
//-------------------------------------------------------------------------
//   Copyright 2002-2019 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file psp102.va with ADMS
//                  interface for Xyce 6.12.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
//                  THIS FILE WAS GENERATED WITH AN EXPERIMENTAL VERSION
//                  OF XYCE/ADMS THAT HAS NOT BEEN RELEASED YET.
//                  Do not regenerate this file using the released version,
//                  or you will lose the optimizations that can be performed
//                  by the experimental code.
//
// Creator        : admsXml-2.3.6
//
// Creation Date  : Tue, 11 Jun 2019 12:24:07
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSPSP102VA.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

#include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

#include <algorithm>

namespace Xyce {
namespace Device {
namespace ADMSPSP102VA {


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_D;
const int Instance::admsNodeID_G;
const int Instance::admsNodeID_S;
const int Instance::admsNodeID_B;
const int Instance::admsNodeID_NOI;
const int Instance::admsNodeID_NOI2;
const int Instance::admsNodeID_GP;
const int Instance::admsNodeID_BP;
const int Instance::admsNodeID_BI;
const int Instance::admsNodeID_BS;
const int Instance::admsNodeID_BD;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSPSP102VA::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSPSP102VA::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("L", static_cast<double>(10e-6), &ADMSPSP102VA::Instance::L)
    .setDescription("Design length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("W", static_cast<double>(10e-6), &ADMSPSP102VA::Instance::W)
    .setDescription("Design width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SA", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SA)
    .setDescription("Distance between OD-edge and poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SB", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SB)
    .setDescription("Distance between OD-edge and poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SD", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SD)
    .setDescription("Distance between neighbouring fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCA", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SCA)
    .setDescription("Integral of the first distribution function for scattered well dopants")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCB", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SCB)
    .setDescription("Integral of the second distribution function for scattered well dopants")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCC", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SCC)
    .setDescription("Integral of the third distribution function for scattered well dopants")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SC", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SC)
    .setDescription("Distance between OD-edge and nearest well edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELVTO", static_cast<double>(0.0), &ADMSPSP102VA::Instance::DELVTO)
    .setDescription("Threshold voltage shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FACTUO", static_cast<double>(1.0), &ADMSPSP102VA::Instance::FACTUO)
    .setDescription("Zero-field mobility pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ABSOURCE", static_cast<double>(1E-12), &ADMSPSP102VA::Instance::ABSOURCE)
    .setDescription("Bottom area of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LSSOURCE", static_cast<double>(1E-6), &ADMSPSP102VA::Instance::LSSOURCE)
    .setDescription("STI-edge length of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LGSOURCE", static_cast<double>(1E-6), &ADMSPSP102VA::Instance::LGSOURCE)
    .setDescription("Gate-edge length of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ABDRAIN", static_cast<double>(1E-12), &ADMSPSP102VA::Instance::ABDRAIN)
    .setDescription("Bottom area of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LSDRAIN", static_cast<double>(1E-6), &ADMSPSP102VA::Instance::LSDRAIN)
    .setDescription("STI-edge length of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LGDRAIN", static_cast<double>(1E-6), &ADMSPSP102VA::Instance::LGDRAIN)
    .setDescription("Gate-edge length of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AS", static_cast<double>(1E-12), &ADMSPSP102VA::Instance::AS)
    .setDescription("Bottom area of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PS", static_cast<double>(1E-6), &ADMSPSP102VA::Instance::PS)
    .setDescription("Perimeter of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AD", static_cast<double>(1E-12), &ADMSPSP102VA::Instance::AD)
    .setDescription("Bottom area of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PD", static_cast<double>(1E-6), &ADMSPSP102VA::Instance::PD)
    .setDescription("Perimeter of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MULT", static_cast<double>(1.0), &ADMSPSP102VA::Instance::MULT)
    .setDescription("Number of devices in parallel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("M", static_cast<double>(1.0), &ADMSPSP102VA::Instance::MULT)
    .setDescription(" Alias for MULT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NF", static_cast<double>(1.0), &ADMSPSP102VA::Instance::NF)
    .setDescription("Number of fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NGCON", static_cast<double>(1.0), &ADMSPSP102VA::Instance::NGCON)
    .setDescription("Number of gate contacts")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XGW", static_cast<double>(1.0E-7), &ADMSPSP102VA::Instance::XGW)
    .setDescription("Distance from the gate contact to the channel edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;


}

void Traits::loadModelParameters(ParametricData<ADMSPSP102VA::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSPSP102VA::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("LEVEL", static_cast<double>(1020), &ADMSPSP102VA::Model::LEVEL)
    .setDescription("Model level")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TYPE", static_cast<double>(1.0), &ADMSPSP102VA::Model::TYPE)
    .setDescription("Channel type parameter, +1=NMOS -1=PMOS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TR", static_cast<double>(21.0), &ADMSPSP102VA::Model::TR)
    .setDescription("nominal (reference) temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SWIGATE", static_cast<double>(0.0), &ADMSPSP102VA::Model::SWIGATE)
    .setDescription("Flag for gate current, 0=turn off IG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SWIMPACT", static_cast<double>(0.0), &ADMSPSP102VA::Model::SWIMPACT)
    .setDescription("Flag for impact ionization current, 0=turn off II")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SWGIDL", static_cast<double>(0.0), &ADMSPSP102VA::Model::SWGIDL)
    .setDescription("Flag for GIDL current, 0=turn off IGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SWJUNCAP", static_cast<double>(0.0), &ADMSPSP102VA::Model::SWJUNCAP)
    .setDescription("Flag for juncap, 0=turn off juncap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SWJUNASYM", static_cast<double>(0.0), &ADMSPSP102VA::Model::SWJUNASYM)
    .setDescription("Flag for asymmetric junctions; 0=symmetric, 1=asymmetric")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QMC", static_cast<double>(1.0), &ADMSPSP102VA::Model::QMC)
    .setDescription("Quantum-mechanical correction factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVARO", static_cast<double>(0.0), &ADMSPSP102VA::Model::LVARO)
    .setDescription("Geom. independent difference between actual and programmed gate length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVARL", static_cast<double>(0.0), &ADMSPSP102VA::Model::LVARL)
    .setDescription("Length dependence of LVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVARW", static_cast<double>(0.0), &ADMSPSP102VA::Model::LVARW)
    .setDescription("Width dependence of LVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAP", static_cast<double>(0.0), &ADMSPSP102VA::Model::LAP)
    .setDescription("Effective channel length reduction per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WVARO", static_cast<double>(0.0), &ADMSPSP102VA::Model::WVARO)
    .setDescription("Geom. independent difference between actual and programmed field-oxide opening")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WVARL", static_cast<double>(0.0), &ADMSPSP102VA::Model::WVARL)
    .setDescription("Length dependence of WVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WVARW", static_cast<double>(0.0), &ADMSPSP102VA::Model::WVARW)
    .setDescription("Width dependence of WVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WOT", static_cast<double>(0.0), &ADMSPSP102VA::Model::WOT)
    .setDescription("Effective channel width reduction per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DLQ", static_cast<double>(0.0), &ADMSPSP102VA::Model::DLQ)
    .setDescription("Effective channel length reduction for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DWQ", static_cast<double>(0.0), &ADMSPSP102VA::Model::DWQ)
    .setDescription("Effective channel width reduction for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBO", static_cast<double>((-1.0)), &ADMSPSP102VA::Model::VFBO)
    .setDescription("Geometry-independent flat-band voltage at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBL", static_cast<double>(0.0), &ADMSPSP102VA::Model::VFBL)
    .setDescription("Length dependence of flat-band voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBW", static_cast<double>(0.0), &ADMSPSP102VA::Model::VFBW)
    .setDescription("Width dependence of flat-band voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::VFBLW)
    .setDescription("Area dependence of flat-band voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFBO", static_cast<double>(5e-4), &ADMSPSP102VA::Model::STVFBO)
    .setDescription("Geometry-independent temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFBL", static_cast<double>(0.0), &ADMSPSP102VA::Model::STVFBL)
    .setDescription("Length dependence of temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFBW", static_cast<double>(0.0), &ADMSPSP102VA::Model::STVFBW)
    .setDescription("Width dependence of temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFBLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::STVFBLW)
    .setDescription("Area dependence of temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXO", static_cast<double>(2e-9), &ADMSPSP102VA::Model::TOXO)
    .setDescription("Gate oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EPSROXO", static_cast<double>(3.9), &ADMSPSP102VA::Model::EPSROXO)
    .setDescription("Relative permittivity of gate dielectric")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSUBO", static_cast<double>(3e23), &ADMSPSP102VA::Model::NSUBO)
    .setDescription("Geometry independent substrate doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSUBW", static_cast<double>(0.0), &ADMSPSP102VA::Model::NSUBW)
    .setDescription("Width dependence of background doping NSUBO due to segregation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WSEG", static_cast<double>(1e-8), &ADMSPSP102VA::Model::WSEG)
    .setDescription("Char. length of segregation of background doping NSUBO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPCK", static_cast<double>(1e24), &ADMSPSP102VA::Model::NPCK)
    .setDescription("Pocket doping level")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPCKW", static_cast<double>(0.0), &ADMSPSP102VA::Model::NPCKW)
    .setDescription("Width dependence of pocket doping NPCK due to segregation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WSEGP", static_cast<double>(1e-8), &ADMSPSP102VA::Model::WSEGP)
    .setDescription("Char. length of segregation of pocket doping NPCK")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPCK", static_cast<double>(1e-8), &ADMSPSP102VA::Model::LPCK)
    .setDescription("Char. length of lateral doping profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPCKW", static_cast<double>(0.0), &ADMSPSP102VA::Model::LPCKW)
    .setDescription("Width dependence of char. length of lateral doping profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FOL1", static_cast<double>(0.0), &ADMSPSP102VA::Model::FOL1)
    .setDescription("First length dependence coefficient for short channel body effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FOL2", static_cast<double>(0.0), &ADMSPSP102VA::Model::FOL2)
    .setDescription("Second length dependence coefficient for short channel body effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VNSUBO", static_cast<double>(0.0), &ADMSPSP102VA::Model::VNSUBO)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSLPO", static_cast<double>(0.05), &ADMSPSP102VA::Model::NSLPO)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DNSUBO", static_cast<double>(0.0), &ADMSPSP102VA::Model::DNSUBO)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBO", static_cast<double>(0.0), &ADMSPSP102VA::Model::DPHIBO)
    .setDescription("Geometry independent offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBL", static_cast<double>(0.0), &ADMSPSP102VA::Model::DPHIBL)
    .setDescription("Length dependence offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBLEXP", static_cast<double>(1.0), &ADMSPSP102VA::Model::DPHIBLEXP)
    .setDescription("Exponent for length dependence of offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBW", static_cast<double>(0.0), &ADMSPSP102VA::Model::DPHIBW)
    .setDescription("Width dependence of offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::DPHIBLW)
    .setDescription("Area dependence of offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPO", static_cast<double>(1e26), &ADMSPSP102VA::Model::NPO)
    .setDescription("Geometry-independent gate poly-silicon doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPL", static_cast<double>(0.0), &ADMSPSP102VA::Model::NPL)
    .setDescription("Length dependence of gate poly-silicon doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTO", static_cast<double>(0.0), &ADMSPSP102VA::Model::CTO)
    .setDescription("Geometry-independent interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTL", static_cast<double>(0.0), &ADMSPSP102VA::Model::CTL)
    .setDescription("Length dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTLEXP", static_cast<double>(1.0), &ADMSPSP102VA::Model::CTLEXP)
    .setDescription("Exponent for length dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CTW)
    .setDescription("Width dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CTLW)
    .setDescription("Area dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXOVO", static_cast<double>(2e-9), &ADMSPSP102VA::Model::TOXOVO)
    .setDescription("Overlap oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXOVDO", static_cast<double>(2e-9), &ADMSPSP102VA::Model::TOXOVDO)
    .setDescription("Overlap oxide thickness for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LOV", static_cast<double>(0), &ADMSPSP102VA::Model::LOV)
    .setDescription("Overlap length for gate/drain and gate/source overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LOVD", static_cast<double>(0), &ADMSPSP102VA::Model::LOVD)
    .setDescription("Overlap length for gate/drain overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NOVO", static_cast<double>(5e25), &ADMSPSP102VA::Model::NOVO)
    .setDescription("Effective doping of overlap region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NOVDO", static_cast<double>(5e25), &ADMSPSP102VA::Model::NOVDO)
    .setDescription("Effective doping of overlap region for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFL", static_cast<double>(0.0), &ADMSPSP102VA::Model::CFL)
    .setDescription("Length dependence of DIBL-parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFLEXP", static_cast<double>(2.0), &ADMSPSP102VA::Model::CFLEXP)
    .setDescription("Exponent for length dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CFW)
    .setDescription("Width dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFBO", static_cast<double>(0.0), &ADMSPSP102VA::Model::CFBO)
    .setDescription("Back-bias dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UO", static_cast<double>(5e-2), &ADMSPSP102VA::Model::UO)
    .setDescription("Zero-field mobility at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBET1", static_cast<double>(0.0), &ADMSPSP102VA::Model::FBET1)
    .setDescription("Relative mobility decrease due to first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBET1W", static_cast<double>(0.0), &ADMSPSP102VA::Model::FBET1W)
    .setDescription("Width dependence of relative mobility decrease due to first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LP1", static_cast<double>(1e-8), &ADMSPSP102VA::Model::LP1)
    .setDescription("Mobility-related characteristic length of first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LP1W", static_cast<double>(0.0), &ADMSPSP102VA::Model::LP1W)
    .setDescription("Width dependence of mobility-related characteristic length of first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBET2", static_cast<double>(0.0), &ADMSPSP102VA::Model::FBET2)
    .setDescription("Relative mobility decrease due to second lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LP2", static_cast<double>(1e-8), &ADMSPSP102VA::Model::LP2)
    .setDescription("Mobility-related characteristic length of second lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETW1", static_cast<double>(0.0), &ADMSPSP102VA::Model::BETW1)
    .setDescription("First higher-order width scaling coefficient of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETW2", static_cast<double>(0.0), &ADMSPSP102VA::Model::BETW2)
    .setDescription("Second higher-order width scaling coefficient of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WBET", static_cast<double>(1e-9), &ADMSPSP102VA::Model::WBET)
    .setDescription("Characteristic width for width scaling of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBETO", static_cast<double>(1.0), &ADMSPSP102VA::Model::STBETO)
    .setDescription("Geometry independent temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBETL", static_cast<double>(0.0), &ADMSPSP102VA::Model::STBETL)
    .setDescription("Length dependence of temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBETW", static_cast<double>(0.0), &ADMSPSP102VA::Model::STBETW)
    .setDescription("Width dependence of temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBETLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::STBETLW)
    .setDescription("Area dependence of temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MUEO", static_cast<double>(0.5), &ADMSPSP102VA::Model::MUEO)
    .setDescription("Geometry independent mobility reduction coefficient at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MUEW", static_cast<double>(0.0), &ADMSPSP102VA::Model::MUEW)
    .setDescription("Width dependence of mobility reduction coefficient at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STMUEO", static_cast<double>(0.0), &ADMSPSP102VA::Model::STMUEO)
    .setDescription("Temperature dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THEMUO", static_cast<double>(1.5), &ADMSPSP102VA::Model::THEMUO)
    .setDescription("Mobility reduction exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STTHEMUO", static_cast<double>(1.5), &ADMSPSP102VA::Model::STTHEMUO)
    .setDescription("Temperature dependence of THEMU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSO", static_cast<double>(0.0), &ADMSPSP102VA::Model::CSO)
    .setDescription("Geometry independent coulomb scattering parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSL", static_cast<double>(0.0), &ADMSPSP102VA::Model::CSL)
    .setDescription("Length dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSLEXP", static_cast<double>(0.0), &ADMSPSP102VA::Model::CSLEXP)
    .setDescription("Exponent for length dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CSW)
    .setDescription("Width dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CSLW)
    .setDescription("Area dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STCSO", static_cast<double>(0.0), &ADMSPSP102VA::Model::STCSO)
    .setDescription("Temperature dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCORO", static_cast<double>(0.0), &ADMSPSP102VA::Model::XCORO)
    .setDescription("Geometry independent non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCORL", static_cast<double>(0.0), &ADMSPSP102VA::Model::XCORL)
    .setDescription("Length dependence of non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCORW", static_cast<double>(0.0), &ADMSPSP102VA::Model::XCORW)
    .setDescription("Width dependence of non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCORLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::XCORLW)
    .setDescription("Area dependence of non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STXCORO", static_cast<double>(0.0), &ADMSPSP102VA::Model::STXCORO)
    .setDescription("Temperature dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FETAO", static_cast<double>(1.0), &ADMSPSP102VA::Model::FETAO)
    .setDescription("Effective field parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSW1", static_cast<double>(2.5e3), &ADMSPSP102VA::Model::RSW1)
    .setDescription("Source/drain series resistance for 1 um wide channel at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSW2", static_cast<double>(0.0), &ADMSPSP102VA::Model::RSW2)
    .setDescription("Higher-order width scaling of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STRSO", static_cast<double>(1.0), &ADMSPSP102VA::Model::STRSO)
    .setDescription("Temperature dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSBO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RSBO)
    .setDescription("Back-bias dependence of series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSGO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RSGO)
    .setDescription("Gate-bias dependence of series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATO", static_cast<double>(0.0), &ADMSPSP102VA::Model::THESATO)
    .setDescription("Geometry independent velocity saturation parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATL", static_cast<double>(0.05), &ADMSPSP102VA::Model::THESATL)
    .setDescription("Length dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATLEXP", static_cast<double>(1.0), &ADMSPSP102VA::Model::THESATLEXP)
    .setDescription("Exponent for length dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATW", static_cast<double>(0.0), &ADMSPSP102VA::Model::THESATW)
    .setDescription("Width dependence of velocity saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::THESATLW)
    .setDescription("Area dependence of velocity saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STTHESATO", static_cast<double>(1.0), &ADMSPSP102VA::Model::STTHESATO)
    .setDescription("Geometry independent temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STTHESATL", static_cast<double>(0.0), &ADMSPSP102VA::Model::STTHESATL)
    .setDescription("Length dependence of temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STTHESATW", static_cast<double>(0.0), &ADMSPSP102VA::Model::STTHESATW)
    .setDescription("Width dependence of temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STTHESATLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::STTHESATLW)
    .setDescription("Area dependence of temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATBO", static_cast<double>(0.0), &ADMSPSP102VA::Model::THESATBO)
    .setDescription("Back-bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATGO", static_cast<double>(0.0), &ADMSPSP102VA::Model::THESATGO)
    .setDescription("Gate-bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AXO", static_cast<double>(18), &ADMSPSP102VA::Model::AXO)
    .setDescription("Geometry independent linear/saturation transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AXL", static_cast<double>(0.4), &ADMSPSP102VA::Model::AXL)
    .setDescription("Length dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPL", static_cast<double>(5e-4), &ADMSPSP102VA::Model::ALPL)
    .setDescription("Length dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPLEXP", static_cast<double>(1.0), &ADMSPSP102VA::Model::ALPLEXP)
    .setDescription("Exponent for length dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPW", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALPW)
    .setDescription("Width dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP1L1", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALP1L1)
    .setDescription("Length dependence of CLM enhancement factor above threshold")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP1LEXP", static_cast<double>(0.5), &ADMSPSP102VA::Model::ALP1LEXP)
    .setDescription("Exponent for length dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP1L2", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALP1L2)
    .setDescription("Second_order length dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP1W", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALP1W)
    .setDescription("Width dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP2L1", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALP2L1)
    .setDescription("Length dependence of CLM enhancement factor below threshold")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP2LEXP", static_cast<double>(0.5), &ADMSPSP102VA::Model::ALP2LEXP)
    .setDescription("Exponent for length dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP2L2", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALP2L2)
    .setDescription("Second_order length dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP2W", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALP2W)
    .setDescription("Width dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VPO", static_cast<double>(0.05), &ADMSPSP102VA::Model::VPO)
    .setDescription("CLM logarithmic dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A1O", static_cast<double>(1.0), &ADMSPSP102VA::Model::A1O)
    .setDescription("Geometry independent impact-ionization pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A1L", static_cast<double>(0.0), &ADMSPSP102VA::Model::A1L)
    .setDescription("Length dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A1W", static_cast<double>(0.0), &ADMSPSP102VA::Model::A1W)
    .setDescription("Width dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A2O", static_cast<double>(10), &ADMSPSP102VA::Model::A2O)
    .setDescription("Impact-ionization exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STA2O", static_cast<double>(0.0), &ADMSPSP102VA::Model::STA2O)
    .setDescription("Temperature dependence of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A3O", static_cast<double>(1.0), &ADMSPSP102VA::Model::A3O)
    .setDescription("Geometry independent saturation-voltage dependence of II")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A3L", static_cast<double>(0.0), &ADMSPSP102VA::Model::A3L)
    .setDescription("Length dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A3W", static_cast<double>(0.0), &ADMSPSP102VA::Model::A3W)
    .setDescription("Width dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A4O", static_cast<double>(0.0), &ADMSPSP102VA::Model::A4O)
    .setDescription("Geometry independent back-bias dependence of II")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A4L", static_cast<double>(0.0), &ADMSPSP102VA::Model::A4L)
    .setDescription("Length dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A4W", static_cast<double>(0.0), &ADMSPSP102VA::Model::A4W)
    .setDescription("Width dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GCOO", static_cast<double>(0.0), &ADMSPSP102VA::Model::GCOO)
    .setDescription("Gate tunnelling energy adjustment")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IGINVLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::IGINVLW)
    .setDescription("Gate channel current pre-factor for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IGOVW", static_cast<double>(0.0), &ADMSPSP102VA::Model::IGOVW)
    .setDescription("Gate overlap current pre-factor for 1 um wide channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IGOVDW", static_cast<double>(0.0), &ADMSPSP102VA::Model::IGOVDW)
    .setDescription("Gate overlap current pre-factor for 1 um wide channel for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STIGO", static_cast<double>(2.0), &ADMSPSP102VA::Model::STIGO)
    .setDescription("Temperature dependence of IGINV and IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GC2O", static_cast<double>(0.375), &ADMSPSP102VA::Model::GC2O)
    .setDescription("Gate current slope factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GC3O", static_cast<double>(0.063), &ADMSPSP102VA::Model::GC3O)
    .setDescription("Gate current curvature factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CHIBO", static_cast<double>(3.1), &ADMSPSP102VA::Model::CHIBO)
    .setDescription("Tunnelling barrier height")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGIDLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::AGIDLW)
    .setDescription("Width dependence of GIDL pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGIDLDW", static_cast<double>(0.0), &ADMSPSP102VA::Model::AGIDLDW)
    .setDescription("Width dependence of GIDL pre-factor for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BGIDLO", static_cast<double>(41), &ADMSPSP102VA::Model::BGIDLO)
    .setDescription("GIDL probability factor at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BGIDLDO", static_cast<double>(41), &ADMSPSP102VA::Model::BGIDLDO)
    .setDescription("GIDL probability factor at TR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBGIDLO", static_cast<double>(0.0), &ADMSPSP102VA::Model::STBGIDLO)
    .setDescription("Temperature dependence of BGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBGIDLDO", static_cast<double>(0.0), &ADMSPSP102VA::Model::STBGIDLDO)
    .setDescription("Temperature dependence of BGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGIDLO", static_cast<double>(0.0), &ADMSPSP102VA::Model::CGIDLO)
    .setDescription("Back-bias dependence of GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGIDLDO", static_cast<double>(0.0), &ADMSPSP102VA::Model::CGIDLDO)
    .setDescription("Back-bias dependence of GIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGBOVL", static_cast<double>(0.0), &ADMSPSP102VA::Model::CGBOVL)
    .setDescription("Oxide capacitance for gate-bulk overlap for 1 um long channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFRW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CFRW)
    .setDescription("Outer fringe capacitance for 1 um wide channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFRDW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CFRDW)
    .setDescription("Outer fringe capacitance for 1 um wide channel for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FNTO", static_cast<double>(1.0), &ADMSPSP102VA::Model::FNTO)
    .setDescription("Thermal noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FNTEXCL", static_cast<double>(0.0), &ADMSPSP102VA::Model::FNTEXCL)
    .setDescription("Length dependence coefficient of excess noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFALW", static_cast<double>(8e22), &ADMSPSP102VA::Model::NFALW)
    .setDescription("First coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFBLW", static_cast<double>(3e7), &ADMSPSP102VA::Model::NFBLW)
    .setDescription("Second coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFCLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::NFCLW)
    .setDescription("Third coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EFO", static_cast<double>(1.0), &ADMSPSP102VA::Model::EFO)
    .setDescription("Flicker noise frequency exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LINTNOI", static_cast<double>(0.0), &ADMSPSP102VA::Model::LINTNOI)
    .setDescription("Length offset for flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPNOI", static_cast<double>(2.0), &ADMSPSP102VA::Model::ALPNOI)
    .setDescription("Exponent for length offset for flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DTA", static_cast<double>(0), &ADMSPSP102VA::Model::DTA)
    .setDescription("Temperature offset w.r.t. ambient circuit temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVTHOWEO", static_cast<double>(0), &ADMSPSP102VA::Model::KVTHOWEO)
    .setDescription("Geometrical independent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVTHOWEL", static_cast<double>(0), &ADMSPSP102VA::Model::KVTHOWEL)
    .setDescription("Length dependent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVTHOWEW", static_cast<double>(0), &ADMSPSP102VA::Model::KVTHOWEW)
    .setDescription("Width dependent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVTHOWELW", static_cast<double>(0), &ADMSPSP102VA::Model::KVTHOWELW)
    .setDescription("Area dependent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KUOWEO", static_cast<double>(0), &ADMSPSP102VA::Model::KUOWEO)
    .setDescription("Geometrical independent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KUOWEL", static_cast<double>(0), &ADMSPSP102VA::Model::KUOWEL)
    .setDescription("Length dependent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KUOWEW", static_cast<double>(0), &ADMSPSP102VA::Model::KUOWEW)
    .setDescription("Width dependent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KUOWELW", static_cast<double>(0), &ADMSPSP102VA::Model::KUOWELW)
    .setDescription("Area dependent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LMIN", static_cast<double>(0), &ADMSPSP102VA::Model::LMIN)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LMAX", static_cast<double>(1.0), &ADMSPSP102VA::Model::LMAX)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WMIN", static_cast<double>(0), &ADMSPSP102VA::Model::WMIN)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WMAX", static_cast<double>(1.0), &ADMSPSP102VA::Model::WMAX)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RGO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RGO)
    .setDescription("Gate resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBULKO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RBULKO)
    .setDescription("Bulk resistance between node BP and BI")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RWELLO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RWELLO)
    .setDescription("Well resistance between node BI and B")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RJUNSO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RJUNSO)
    .setDescription("Source-side bulk resistance between node BI and BS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RJUNDO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RJUNDO)
    .setDescription("Drain-side bulk resistance between node BI and BD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RINT", static_cast<double>(0.0), &ADMSPSP102VA::Model::RINT)
    .setDescription("Contact resistance between silicide and ploy")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RVPOLY", static_cast<double>(0.0), &ADMSPSP102VA::Model::RVPOLY)
    .setDescription("Vertical poly resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSHG", static_cast<double>(0.0), &ADMSPSP102VA::Model::RSHG)
    .setDescription("Gate electrode diffusion sheet resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DLSIL", static_cast<double>(0.0), &ADMSPSP102VA::Model::DLSIL)
    .setDescription("Silicide extension over the physical gate length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SAREF", static_cast<double>(1.0e-6), &ADMSPSP102VA::Model::SAREF)
    .setDescription("Reference distance between OD-edge and poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SBREF", static_cast<double>(1.0e-6), &ADMSPSP102VA::Model::SBREF)
    .setDescription("Reference distance between OD-edge and poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WLOD", static_cast<double>(0), &ADMSPSP102VA::Model::WLOD)
    .setDescription("Width parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KUO", static_cast<double>(0), &ADMSPSP102VA::Model::KUO)
    .setDescription("Mobility degradation/enhancement coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVSAT", static_cast<double>(0), &ADMSPSP102VA::Model::KVSAT)
    .setDescription("Saturation velocity degradation/enhancement coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TKUO", static_cast<double>(0), &ADMSPSP102VA::Model::TKUO)
    .setDescription("Temperature dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LKUO", static_cast<double>(0), &ADMSPSP102VA::Model::LKUO)
    .setDescription("Length dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WKUO", static_cast<double>(0), &ADMSPSP102VA::Model::WKUO)
    .setDescription("Width dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PKUO", static_cast<double>(0), &ADMSPSP102VA::Model::PKUO)
    .setDescription("Cross-term dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LLODKUO", static_cast<double>(0), &ADMSPSP102VA::Model::LLODKUO)
    .setDescription("Length parameter for UO stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WLODKUO", static_cast<double>(0), &ADMSPSP102VA::Model::WLODKUO)
    .setDescription("Width parameter for UO stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVTHO", static_cast<double>(0), &ADMSPSP102VA::Model::KVTHO)
    .setDescription("Threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LKVTHO", static_cast<double>(0), &ADMSPSP102VA::Model::LKVTHO)
    .setDescription("Length dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WKVTHO", static_cast<double>(0), &ADMSPSP102VA::Model::WKVTHO)
    .setDescription("Width dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PKVTHO", static_cast<double>(0), &ADMSPSP102VA::Model::PKVTHO)
    .setDescription("Cross-term dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LLODVTH", static_cast<double>(0), &ADMSPSP102VA::Model::LLODVTH)
    .setDescription("Length parameter for VTH-stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WLODVTH", static_cast<double>(0), &ADMSPSP102VA::Model::WLODVTH)
    .setDescription("Width parameter for VTH-stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STETAO", static_cast<double>(0), &ADMSPSP102VA::Model::STETAO)
    .setDescription("eta0 shift factor related to VTHO change")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LODETAO", static_cast<double>(1.0), &ADMSPSP102VA::Model::LODETAO)
    .setDescription("eta0 shift modification factor for stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCREF", static_cast<double>(1e-6), &ADMSPSP102VA::Model::SCREF)
    .setDescription("Distance between OD-edge and well edge of a reference device")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WEB", static_cast<double>(0), &ADMSPSP102VA::Model::WEB)
    .setDescription("Coefficient for SCB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WEC", static_cast<double>(0), &ADMSPSP102VA::Model::WEC)
    .setDescription("Coefficient for SCC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IMAX", static_cast<double>(1000), &ADMSPSP102VA::Model::IMAX)
    .setDescription("Maximum current up to which forward current behaves exponentially")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TRJ", static_cast<double>(21), &ADMSPSP102VA::Model::TRJ)
    .setDescription("reference temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORBOT", static_cast<double>(1E-3), &ADMSPSP102VA::Model::CJORBOT)
    .setDescription("Zero-bias capacitance per unit-of-area of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORSTI", static_cast<double>(1E-9), &ADMSPSP102VA::Model::CJORSTI)
    .setDescription("Zero-bias capacitance per unit-of-length of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORGAT", static_cast<double>(1E-9), &ADMSPSP102VA::Model::CJORGAT)
    .setDescription("Zero-bias capacitance per unit-of-length of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRBOT", static_cast<double>(1), &ADMSPSP102VA::Model::VBIRBOT)
    .setDescription("Built-in voltage at the reference temperature of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRSTI", static_cast<double>(1), &ADMSPSP102VA::Model::VBIRSTI)
    .setDescription("Built-in voltage at the reference temperature of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRGAT", static_cast<double>(1), &ADMSPSP102VA::Model::VBIRGAT)
    .setDescription("Built-in voltage at the reference temperature of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBOT", static_cast<double>(0.5), &ADMSPSP102VA::Model::PBOT)
    .setDescription("Grading coefficient of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSTI", static_cast<double>(0.5), &ADMSPSP102VA::Model::PSTI)
    .setDescription("Grading coefficient of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PGAT", static_cast<double>(0.5), &ADMSPSP102VA::Model::PGAT)
    .setDescription("Grading coefficient of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGBOT", static_cast<double>(1.16), &ADMSPSP102VA::Model::PHIGBOT)
    .setDescription("Zero-temperature bandgap voltage of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGSTI", static_cast<double>(1.16), &ADMSPSP102VA::Model::PHIGSTI)
    .setDescription("Zero-temperature bandgap voltage of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGGAT", static_cast<double>(1.16), &ADMSPSP102VA::Model::PHIGGAT)
    .setDescription("Zero-temperature bandgap voltage of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRBOT", static_cast<double>(1E-12), &ADMSPSP102VA::Model::IDSATRBOT)
    .setDescription("Saturation current density at the reference temperature of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRSTI", static_cast<double>(1E-18), &ADMSPSP102VA::Model::IDSATRSTI)
    .setDescription("Saturation current density at the reference temperature of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRGAT", static_cast<double>(1E-18), &ADMSPSP102VA::Model::IDSATRGAT)
    .setDescription("Saturation current density at the reference temperature of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHBOT", static_cast<double>(1E2), &ADMSPSP102VA::Model::CSRHBOT)
    .setDescription("Shockley-Read-Hall prefactor of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHSTI", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CSRHSTI)
    .setDescription("Shockley-Read-Hall prefactor of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHGAT", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CSRHGAT)
    .setDescription("Shockley-Read-Hall prefactor of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJUNSTI", static_cast<double>(100E-9), &ADMSPSP102VA::Model::XJUNSTI)
    .setDescription("Junction depth of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJUNGAT", static_cast<double>(100E-9), &ADMSPSP102VA::Model::XJUNGAT)
    .setDescription("Junction depth of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATBOT", static_cast<double>(1E2), &ADMSPSP102VA::Model::CTATBOT)
    .setDescription("Trap-assisted tunneling prefactor of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATSTI", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CTATSTI)
    .setDescription("Trap-assisted tunneling prefactor of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATGAT", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CTATGAT)
    .setDescription("Trap-assisted tunneling prefactor of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATBOT", static_cast<double>(0.25), &ADMSPSP102VA::Model::MEFFTATBOT)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATSTI", static_cast<double>(0.25), &ADMSPSP102VA::Model::MEFFTATSTI)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATGAT", static_cast<double>(0.25), &ADMSPSP102VA::Model::MEFFTATGAT)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTBOT", static_cast<double>(1E-12), &ADMSPSP102VA::Model::CBBTBOT)
    .setDescription("Band-to-band tunneling prefactor of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTSTI", static_cast<double>(1E-18), &ADMSPSP102VA::Model::CBBTSTI)
    .setDescription("Band-to-band tunneling prefactor of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTGAT", static_cast<double>(1E-18), &ADMSPSP102VA::Model::CBBTGAT)
    .setDescription("Band-to-band tunneling prefactor of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRBOT", static_cast<double>(1E9), &ADMSPSP102VA::Model::FBBTRBOT)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRSTI", static_cast<double>(1E9), &ADMSPSP102VA::Model::FBBTRSTI)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRGAT", static_cast<double>(1E9), &ADMSPSP102VA::Model::FBBTRGAT)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTBOT", static_cast<double>((-1E-3)), &ADMSPSP102VA::Model::STFBBTBOT)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTSTI", static_cast<double>((-1E-3)), &ADMSPSP102VA::Model::STFBBTSTI)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTGAT", static_cast<double>((-1E-3)), &ADMSPSP102VA::Model::STFBBTGAT)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRBOT", static_cast<double>(10), &ADMSPSP102VA::Model::VBRBOT)
    .setDescription("Breakdown voltage of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRSTI", static_cast<double>(10), &ADMSPSP102VA::Model::VBRSTI)
    .setDescription("Breakdown voltage of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRGAT", static_cast<double>(10), &ADMSPSP102VA::Model::VBRGAT)
    .setDescription("Breakdown voltage of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRBOT", static_cast<double>(4), &ADMSPSP102VA::Model::PBRBOT)
    .setDescription("Breakdown onset tuning parameter of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRSTI", static_cast<double>(4), &ADMSPSP102VA::Model::PBRSTI)
    .setDescription("Breakdown onset tuning parameter of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRGAT", static_cast<double>(4), &ADMSPSP102VA::Model::PBRGAT)
    .setDescription("Breakdown onset tuning parameter of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORBOTD", static_cast<double>(1E-3), &ADMSPSP102VA::Model::CJORBOTD)
    .setDescription("Zero-bias capacitance per unit-of-area of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORSTID", static_cast<double>(1E-9), &ADMSPSP102VA::Model::CJORSTID)
    .setDescription("Zero-bias capacitance per unit-of-length of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORGATD", static_cast<double>(1E-9), &ADMSPSP102VA::Model::CJORGATD)
    .setDescription("Zero-bias capacitance per unit-of-length of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRBOTD", static_cast<double>(1), &ADMSPSP102VA::Model::VBIRBOTD)
    .setDescription("Built-in voltage at the reference temperature of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRSTID", static_cast<double>(1), &ADMSPSP102VA::Model::VBIRSTID)
    .setDescription("Built-in voltage at the reference temperature of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRGATD", static_cast<double>(1), &ADMSPSP102VA::Model::VBIRGATD)
    .setDescription("Built-in voltage at the reference temperature of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBOTD", static_cast<double>(0.5), &ADMSPSP102VA::Model::PBOTD)
    .setDescription("Grading coefficient of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSTID", static_cast<double>(0.5), &ADMSPSP102VA::Model::PSTID)
    .setDescription("Grading coefficient of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PGATD", static_cast<double>(0.5), &ADMSPSP102VA::Model::PGATD)
    .setDescription("Grading coefficient of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGBOTD", static_cast<double>(1.16), &ADMSPSP102VA::Model::PHIGBOTD)
    .setDescription("Zero-temperature bandgap voltage of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGSTID", static_cast<double>(1.16), &ADMSPSP102VA::Model::PHIGSTID)
    .setDescription("Zero-temperature bandgap voltage of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGGATD", static_cast<double>(1.16), &ADMSPSP102VA::Model::PHIGGATD)
    .setDescription("Zero-temperature bandgap voltage of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRBOTD", static_cast<double>(1E-12), &ADMSPSP102VA::Model::IDSATRBOTD)
    .setDescription("Saturation current density at the reference temperature of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRSTID", static_cast<double>(1E-18), &ADMSPSP102VA::Model::IDSATRSTID)
    .setDescription("Saturation current density at the reference temperature of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRGATD", static_cast<double>(1E-18), &ADMSPSP102VA::Model::IDSATRGATD)
    .setDescription("Saturation current density at the reference temperature of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHBOTD", static_cast<double>(1E2), &ADMSPSP102VA::Model::CSRHBOTD)
    .setDescription("Shockley-Read-Hall prefactor of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHSTID", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CSRHSTID)
    .setDescription("Shockley-Read-Hall prefactor of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHGATD", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CSRHGATD)
    .setDescription("Shockley-Read-Hall prefactor of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJUNSTID", static_cast<double>(100E-9), &ADMSPSP102VA::Model::XJUNSTID)
    .setDescription("Junction depth of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJUNGATD", static_cast<double>(100E-9), &ADMSPSP102VA::Model::XJUNGATD)
    .setDescription("Junction depth of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATBOTD", static_cast<double>(1E2), &ADMSPSP102VA::Model::CTATBOTD)
    .setDescription("Trap-assisted tunneling prefactor of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATSTID", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CTATSTID)
    .setDescription("Trap-assisted tunneling prefactor of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATGATD", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CTATGATD)
    .setDescription("Trap-assisted tunneling prefactor of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATBOTD", static_cast<double>(0.25), &ADMSPSP102VA::Model::MEFFTATBOTD)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATSTID", static_cast<double>(0.25), &ADMSPSP102VA::Model::MEFFTATSTID)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATGATD", static_cast<double>(0.25), &ADMSPSP102VA::Model::MEFFTATGATD)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTBOTD", static_cast<double>(1E-12), &ADMSPSP102VA::Model::CBBTBOTD)
    .setDescription("Band-to-band tunneling prefactor of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTSTID", static_cast<double>(1E-18), &ADMSPSP102VA::Model::CBBTSTID)
    .setDescription("Band-to-band tunneling prefactor of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTGATD", static_cast<double>(1E-18), &ADMSPSP102VA::Model::CBBTGATD)
    .setDescription("Band-to-band tunneling prefactor of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRBOTD", static_cast<double>(1E9), &ADMSPSP102VA::Model::FBBTRBOTD)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRSTID", static_cast<double>(1E9), &ADMSPSP102VA::Model::FBBTRSTID)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRGATD", static_cast<double>(1E9), &ADMSPSP102VA::Model::FBBTRGATD)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTBOTD", static_cast<double>((-1E-3)), &ADMSPSP102VA::Model::STFBBTBOTD)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTSTID", static_cast<double>((-1E-3)), &ADMSPSP102VA::Model::STFBBTSTID)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTGATD", static_cast<double>((-1E-3)), &ADMSPSP102VA::Model::STFBBTGATD)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRBOTD", static_cast<double>(10), &ADMSPSP102VA::Model::VBRBOTD)
    .setDescription("Breakdown voltage of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRSTID", static_cast<double>(10), &ADMSPSP102VA::Model::VBRSTID)
    .setDescription("Breakdown voltage of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRGATD", static_cast<double>(10), &ADMSPSP102VA::Model::VBRGATD)
    .setDescription("Breakdown voltage of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRBOTD", static_cast<double>(4), &ADMSPSP102VA::Model::PBRBOTD)
    .setDescription("Breakdown onset tuning parameter of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRSTID", static_cast<double>(4), &ADMSPSP102VA::Model::PBRSTID)
    .setDescription("Breakdown onset tuning parameter of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRGATD", static_cast<double>(4), &ADMSPSP102VA::Model::PBRGATD)
    .setDescription("Breakdown onset tuning parameter of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SWJUNEXP", static_cast<double>(0.0), &ADMSPSP102VA::Model::SWJUNEXP)
    .setDescription("Flag for JUNCAP-express; 0=full model, 1=express model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VJUNREF", static_cast<double>(2.5), &ADMSPSP102VA::Model::VJUNREF)
    .setDescription("Typical maximum source-bulk junction voltage; usually about 2*VSUP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FJUNQ", static_cast<double>(0.03), &ADMSPSP102VA::Model::FJUNQ)
    .setDescription("Fraction below which source-bulk junction capacitance components are considered negligible")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VJUNREFD", static_cast<double>(2.5), &ADMSPSP102VA::Model::VJUNREFD)
    .setDescription("Typical maximum drain-bulk junction voltage; usually about 2*VSUP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FJUNQD", static_cast<double>(0.03), &ADMSPSP102VA::Model::FJUNQD)
    .setDescription("Fraction below which drain-bulk junction capacitance components are considered negligible")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter L : [ 1e-9,  (+inf) [
  if ( (!((L >=1e-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter L value " << L << " out of range [ 1e-9,  (+inf) [";
  }

  //    Parameter W : [ 1e-9,  (+inf) [
  if ( (!((W >=1e-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter W value " << W << " out of range [ 1e-9,  (+inf) [";
  }

  //    Parameter SCA : [ 0.0,  (+inf) [
  if ( (!((SCA >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SCA value " << SCA << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter SCB : [ 0.0,  (+inf) [
  if ( (!((SCB >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SCB value " << SCB << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter SCC : [ 0.0,  (+inf) [
  if ( (!((SCC >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SCC value " << SCC << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter FACTUO : [ 0.0,  (+inf) [
  if ( (!((FACTUO >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter FACTUO value " << FACTUO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ABSOURCE : [ 0,  (+inf) [
  if ( (!((ABSOURCE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter ABSOURCE value " << ABSOURCE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter LSSOURCE : [ 0,  (+inf) [
  if ( (!((LSSOURCE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LSSOURCE value " << LSSOURCE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter LGSOURCE : [ 0,  (+inf) [
  if ( (!((LGSOURCE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LGSOURCE value " << LGSOURCE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ABDRAIN : [ 0,  (+inf) [
  if ( (!((ABDRAIN >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter ABDRAIN value " << ABDRAIN << " out of range [ 0,  (+inf) [";
  }

  //    Parameter LSDRAIN : [ 0,  (+inf) [
  if ( (!((LSDRAIN >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LSDRAIN value " << LSDRAIN << " out of range [ 0,  (+inf) [";
  }

  //    Parameter LGDRAIN : [ 0,  (+inf) [
  if ( (!((LGDRAIN >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LGDRAIN value " << LGDRAIN << " out of range [ 0,  (+inf) [";
  }

  //    Parameter AS : [ 0,  (+inf) [
  if ( (!((AS >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter AS value " << AS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PS : [ 0,  (+inf) [
  if ( (!((PS >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PS value " << PS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter AD : [ 0,  (+inf) [
  if ( (!((AD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter AD value " << AD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PD : [ 0,  (+inf) [
  if ( (!((PD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PD value " << PD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter MULT : [ 0.0,  (+inf) [
  if ( (!((MULT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MULT value " << MULT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter NF : [ 1.0,  (+inf) [
  if ( (!((NF >=1.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter NF value " << NF << " out of range [ 1.0,  (+inf) [";
  }

  //    Parameter NGCON : [ 1.0, 2.0 ]
  if ( (!((NGCON >=1.0 && NGCON <=2.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter NGCON value " << NGCON << " out of range [ 1.0, 2.0 ]";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double I5;
  double I4;
  double I3;
  double I2;
  double I1;
  double ijungat;
  double ijunsti;
  double ijunbot;
  double V5;
  double V4;
  double V3;
  double V2;
  double V1;
  double FRACI;
  double FRACNB;
  double FRACNA;
  double qjungat;
  double qjunsti;
  double qjunbot;
  double fbreakdown;
  double Fmaxr;
  double ibbt;
  double gammamax;
  double erfctimesexpmtat;
  double xerfc;
  double mtat;
  double ltat;
  double ktat;
  double wtat;
  double wgamma;
  double umaxpoweronepointfive;
  double sqrtumax;
  double umax;
  double umaxbeforelimiting;
  double twoatatoverthreebtat;
  double btat;
  double itat;
  double asrh;
  double wdep;
  double wsrh;
  double dwsrh;
  double wsrhstep;
  double vbi_minus_vjsrh;
  double isrh;
  double id;
  double tmp;
  double vav;
  double vbbt;
  double vjsrh;
  double vjlim;
  double two_psistar;
  double zinv;
  double z;
  double vj;
  double idmult;
  double h5;
  double h4;
  double h3;
  double h2d;
  double h2;
  double h1;
  double erfcpos;
  double terfc;
  double ysq;
  double pmax;
  double vbigat2r;
  double vbisti2r;
  double vbibot2r;
  double pgat2;
  double psti2;
  double pbot2;
  double vbigat2;
  double vbisti2;
  double vbibot2;
  double vmaxgat;
  double vmaxsti;
  double vmaxbot;
  double alphaje;
  double zfrac;
  double tt2;
  double tt1;
  double tt0;
  double I5_cor;
  double I4_cor;
  double I3_cor;
  double I2_cor;
  double I1_cor;
  double mcor_rev;
  double m0_rev;
  double BGIDLD_T;
  double BGIDL_T;
  double tempM;
  double tf_ig;
  double tf_thesat;
  double tf_ther;
  double tf_xcor;
  double tf_cs;
  double tf_mue;
  double tf_bet;
  double CoxovPrime_d;
  double CoxovPrime;
  double phix2;
  double dphibq;
  double qb0;
  double np;
  double arg2max;
  double tox_sq;
  double CoxPrime;
  double EPSOX;
  double DELVTO_i;
  double FACTUO_i;
  double FNT_i;
  double STBGIDLD_i;
  double STBGIDL_i;
  double BGIDLD_i;
  double BGIDL_i;
  double STIG_i;
  double GCO_i;
  double STA2_i;
  double VP_i;
  double STTHESAT_i;
  double STRS_i;
  double RS_i;
  double FETA_i;
  double STXCOR_i;
  double STCS_i;
  double STTHEMU_i;
  double STMUE_i;
  double STBET_i;
  double BETN_i;
  double NOVD_i;
  double NOV_i;
  double CT_i;
  double QMC_i;
  double NP_i;
  double DPHIB_i;
  double NEFF_i;
  double STVFB_i;
  double temp00;
  double Kstressvth0;
  double rhobetaref;
  double rhobeta;
  double Kstressu0;
  double tempw;
  double templ;
  double Wx;
  double Lx;
  double Invsbref;
  double Invsaref;
  double Invsb;
  double Invsa;
  double loop;
  double tmpb;
  double tmpa;
  double RJUND;
  double RJUNS;
  double RBULK;
  double RWELL;
  double RG;
  double KUOWE;
  double KVTHOWE;
  double EF;
  double NFC;
  double NFB;
  double NFA;
  double FNTEXC;
  double FNT;
  double Lred;
  double Lnoi;
  double temp0;
  double CFRD;
  double CFR;
  double CGBOV;
  double CGOVD;
  double CGOV;
  double COX;
  double CGIDLD;
  double CGIDL;
  double STBGIDLD;
  double STBGIDL;
  double BGIDLD;
  double BGIDL;
  double AGIDLD;
  double AGIDL;
  double CHIB;
  double GC3;
  double GC2;
  double STIG;
  double IGOVD;
  double IGOV;
  double IGINV;
  double GCO;
  double A4;
  double A3;
  double STA2;
  double A2;
  double A1;
  double VP;
  double ALP2;
  double ALP1;
  double tmpx;
  double ALP;
  double AX;
  double THESATG;
  double THESATB;
  double STTHESAT;
  double THESAT;
  double RSG;
  double RSB;
  double STRS;
  double RS;
  double FETA;
  double STXCOR;
  double XCOR;
  double STCS;
  double CS;
  double STTHEMU;
  double THEMU;
  double STMUE;
  double MUE;
  double STBET;
  double BETN;
  double GWE;
  double GPE;
  double LP1e;
  double FBET1e;
  double CFB;
  double CF;
  double NOVD;
  double NOV;
  double TOXOVD;
  double TOXOV;
  double CT;
  double NP;
  double DPHIB;
  double DNSUB;
  double NSLP;
  double VNSUB;
  double NEFF;
  double NSUB;
  double BB;
  double AA;
  double LPCKe;
  double NPCKe;
  double NSUB0e;
  double EPSROX;
  double TOX;
  double STVFB;
  double VFB;
  double XGWE;
  double W_f;
  double L_slif;
  double L_f;
  double LGD_i;
  double LSD_i;
  double ABD_i;
  double LGS_i;
  double LSS_i;
  double ABS_i;
  double jwcorr;
  double iWE;
  double iLE;
  double Wcv;
  double Lcv;
  double WEcv;
  double LEcv;
  double WE;
  double LE;
  double delWOD;
  double delLPS;
  double iW;
  double iL;
  double WEN;
  double LEN;
  double NGCON_i;
  double RSHG_i;
  double SCC_i;
  double SCB_i;
  double SCA_i;
  double invNF;
  double NF_i;
  double XGW_i;
  double SC_i;
  double SD_i;
  double SB_i;
  double SA_i;
  double W_i;
  double L_i;
  double PD_i;
  double AD_i;
  double PS_i;
  double AS_i;
  //Begin block initial_instance
  {
    ABSOURCE_i = ABSOURCE;
    LSSOURCE_i = LSSOURCE;
    LGSOURCE_i = LGSOURCE;
    ABDRAIN_i = ABDRAIN;
    LSDRAIN_i = LSDRAIN;
    LGDRAIN_i = LGDRAIN;
    AS_i = AS;
    PS_i = PS;
    AD_i = AD;
    PD_i = PD;
    L_i = L;
    W_i = W;
    SA_i = SA;
    SB_i = SB;
    SD_i = SD;
    SC_i = SC;
    XGW_i = XGW;
    NF_i = ((NF>1.0)?NF:1.0);
    {
      double value_floor_0 = floor((NF_i+0.5));
      NF_i = floor((NF_i+0.5));
    }
    invNF = (1.0/NF_i);
    L_i = ((L_i>1e-9)?L_i:1e-9);
    W_i = (((W_i*invNF)>1e-9)?(W_i*invNF):1e-9);
    SCA_i = ((SCA>0.0)?SCA:0.0);
    SCB_i = ((SCB>0.0)?SCB:0.0);
    SCC_i = ((SCC>0.0)?SCC:0.0);
    RSHG_i = (((model_.RSHG)>0.0)?(model_.RSHG):0.0);
    NGCON_i = ((NGCON<1.5)?1.0:2.0);
    LEN = 1e-6;
    WEN = 1e-6;
    iL = (LEN/L_i);
    iW = (WEN/W_i);
    delLPS = (((model_.LVARO)*(1.0+((model_.LVARL)*iL)))*(1.0+((model_.LVARW)*iW)));
    delWOD = (((model_.WVARO)*(1.0+((model_.WVARL)*iL)))*(1.0+((model_.WVARW)*iW)));
    LE = ((((L_i+delLPS)-(2.0*(model_.LAP)))>1e-9)?((L_i+delLPS)-(2.0*(model_.LAP))):1e-9);
    WE = ((((W_i+delWOD)-(2.0*(model_.WOT)))>1e-9)?((W_i+delWOD)-(2.0*(model_.WOT))):1e-9);
    LEcv = (((((L_i+delLPS)-(2.0*(model_.LAP)))+(model_.DLQ))>1e-9)?(((L_i+delLPS)-(2.0*(model_.LAP)))+(model_.DLQ)):1e-9);
    WEcv = (((((W_i+delWOD)-(2.0*(model_.WOT)))+(model_.DWQ))>1e-9)?(((W_i+delWOD)-(2.0*(model_.WOT)))+(model_.DWQ)):1e-9);
    Lcv = ((((L_i+delLPS)+(model_.DLQ))>1e-9)?((L_i+delLPS)+(model_.DLQ)):1e-9);
    Wcv = ((((W_i+delWOD)+(model_.DWQ))>1e-9)?((W_i+delWOD)+(model_.DWQ)):1e-9);
    iLE = (LEN/LE);
    iWE = (WEN/WE);
    jwcorr = 0.0;
    ABS_i = 0.0;
    LSS_i = 0.0;
    LGS_i = 0.0;
    ABD_i = 0.0;
    LSD_i = 0.0;
    LGD_i = 0.0;
    if (((model_.SWJUNCAP)==3.0))
    {
      jwcorr = WE;
    }
    if ((((model_.SWJUNCAP)==2.0)||((model_.SWJUNCAP)==3.0)))
    {
      ABS_i = (AS_i*invNF);
      LSS_i = ((PS_i*invNF)-jwcorr);
      LGS_i = WE;
      ABD_i = (AD_i*invNF);
      LSD_i = ((PD_i*invNF)-jwcorr);
      LGD_i = WE;
    }
    else
    {
      ABS_i = (ABSOURCE_i*invNF);
      LSS_i = (LSSOURCE_i*invNF);
      LGS_i = (LGSOURCE_i*invNF);
      ABD_i = (ABDRAIN_i*invNF);
      LSD_i = (LSDRAIN_i*invNF);
      LGD_i = (LGDRAIN_i*invNF);
    }
    L_f = (((L_i+delLPS)>1e-9)?(L_i+delLPS):1e-9);
    L_slif = (((L_f+(model_.DLSIL))>1e-9)?(L_f+(model_.DLSIL)):1e-9);
    W_f = (((W_i+delWOD)>1e-9)?(W_i+delWOD):1e-9);
    XGWE = (((XGW_i-(0.5*delWOD))>1e-9)?(XGW_i-(0.5*delWOD)):1e-9);
    VFB = ((((model_.VFBO)*(1.0+((model_.VFBL)*iLE)))*(1.0+((model_.VFBW)*iWE)))*(1.0+(((model_.VFBLW)*iLE)*iWE)));
    STVFB = ((((model_.STVFBO)*(1.0+((model_.STVFBL)*iLE)))*(1.0+((model_.STVFBW)*iWE)))*(1.0+(((model_.STVFBLW)*iLE)*iWE)));
    TOX = (model_.TOXO);
    EPSROX = (model_.EPSROXO);
    {
      double value_log_0 = log((1.0+(WE/(model_.WSEG_i))));
      double value_log_1 = log((1.0+(WE/(model_.WSEG_i))));
      NSUB0e = ((model_.NSUBO_i)*(((1.0+(((model_.NSUBW)*iWE)*value_log_0))>1.0E-03)?(1.0+(((model_.NSUBW)*iWE)*value_log_1)):1.0E-03));
    }
    {
      double value_log_0 = log((1.0+(WE/(model_.WSEGP_i))));
      double value_log_1 = log((1.0+(WE/(model_.WSEGP_i))));
      NPCKe = ((model_.NPCK_i)*(((1.0+(((model_.NPCKW)*iWE)*value_log_0))>1.0E-03)?(1.0+(((model_.NPCKW)*iWE)*value_log_1)):1.0E-03));
    }
    {
      double value_log_0 = log((1.0+(WE/(model_.WSEGP_i))));
      double value_log_1 = log((1.0+(WE/(model_.WSEGP_i))));
      LPCKe = ((model_.LPCK_i)*(((1.0+(((model_.LPCKW)*iWE)*value_log_0))>1.0E-03)?(1.0+(((model_.LPCKW)*iWE)*value_log_1)):1.0E-03));
    }
    if ((LE>(2*LPCKe)))
    {
      AA = 7.5e10;
      {
        double value_sqrt_0 = sqrt((NSUB0e+(0.5*NPCKe)));
        double value_sqrt_1 = sqrt(NSUB0e);
        BB = (value_sqrt_0-value_sqrt_1);
      }
      {
        double value_sqrt_0 = sqrt(NSUB0e);
        double value_exp_1 = exp((BB/AA));
        double value_log_2 = log((1+(((2*LPCKe)/LE)*(value_exp_1-1))));
        NSUB = (value_sqrt_0+(AA*value_log_2));
      }
      NSUB = (NSUB*NSUB);
    }
    else
    {
      if ((LE>=LPCKe))
      {
        NSUB = (NSUB0e+((NPCKe*LPCKe)/LE));
      }
      else
      {
        NSUB = (NSUB0e+(NPCKe*(2-(LE/LPCKe))));
      }
    }
    NEFF = (NSUB*((1-((model_.FOL1)*iLE))-(((model_.FOL2)*iLE)*iLE)));
    VNSUB = (model_.VNSUBO);
    NSLP = (model_.NSLPO);
    DNSUB = (model_.DNSUBO);
    {
      double value_pow_0 = pow(iLE,(model_.DPHIBLEXP));
      DPHIB = ((((model_.DPHIBO)+((model_.DPHIBL)*value_pow_0))*(1.0+((model_.DPHIBW)*iWE)))*(1.0+(((model_.DPHIBLW)*iLE)*iWE)));
    }
    NP = ((model_.NPO)*((1e-6>(1.0+((model_.NPL)*iLE)))?1e-6:(1.0+((model_.NPL)*iLE))));
    {
      double value_pow_0 = pow(iLE,(model_.CTLEXP));
      CT = ((((model_.CTO)+((model_.CTL)*value_pow_0))*(1.0+((model_.CTW)*iWE)))*(1.0+(((model_.CTLW)*iLE)*iWE)));
    }
    TOXOV = (model_.TOXOVO);
    TOXOVD = (model_.TOXOVDO);
    NOV = (model_.NOVO);
    NOVD = (model_.NOVDO);
    {
      double value_pow_0 = pow(iLE,(model_.CFLEXP));
      CF = (((model_.CFL)*value_pow_0)*(1.0+((model_.CFW)*iWE)));
    }
    CFB = (model_.CFBO);
    FBET1e = ((model_.FBET1)*(1.0+((model_.FBET1W)*iWE)));
    LP1e = ((model_.LP1_i)*(((1.0+((model_.LP1W)*iWE))>1.0E-03)?(1.0+((model_.LP1W)*iWE)):1.0E-03));
    {
      double value_exp_0 = exp(((-LE)/LP1e));
      double value_exp_1 = exp(((-LE)/(model_.LP2_i)));
      GPE = ((1.0+(((FBET1e*LP1e)/LE)*(1.0-value_exp_0)))+((((model_.FBET2)*(model_.LP2_i))/LE)*(1.0-value_exp_1)));
    }
    GPE = ((GPE>1e-15)?GPE:1e-15);
    {
      double value_log_0 = log((1.0+(WE/(model_.WBET_i))));
      GWE = ((1.0+((model_.BETW1)*iWE))+(((model_.BETW2)*iWE)*value_log_0));
    }
    BETN = ((((model_.UO)*WE)/(GPE*LE))*GWE);
    STBET = ((((model_.STBETO)*(1.0+((model_.STBETL)*iLE)))*(1.0+((model_.STBETW)*iWE)))*(1.0+(((model_.STBETLW)*iLE)*iWE)));
    MUE = ((model_.MUEO)*(1.0+((model_.MUEW)*iWE)));
    STMUE = (model_.STMUEO);
    THEMU = (model_.THEMUO);
    STTHEMU = (model_.STTHEMUO);
    {
      double value_pow_0 = pow(iLE,(model_.CSLEXP));
      CS = ((((model_.CSO)+((model_.CSL)*value_pow_0))*(1.0+((model_.CSW)*iWE)))*(1.0+(((model_.CSLW)*iLE)*iWE)));
    }
    STCS = (model_.STCSO);
    XCOR = ((((model_.XCORO)*(1.0+((model_.XCORL)*iLE)))*(1.0+((model_.XCORW)*iWE)))*(1.0+(((model_.XCORLW)*iLE)*iWE)));
    STXCOR = (model_.STXCORO);
    FETA = (model_.FETAO);
    RS = (((model_.RSW1)*iWE)*(1.0+((model_.RSW2)*iWE)));
    STRS = (model_.STRSO);
    RSB = (model_.RSBO);
    RSG = (model_.RSGO);
    {
      double value_pow_0 = pow(iLE,(model_.THESATLEXP));
      THESAT = ((((model_.THESATO)+((((model_.THESATL)*GWE)/GPE)*value_pow_0))*(1.0+((model_.THESATW)*iWE)))*(1.0+(((model_.THESATLW)*iLE)*iWE)));
    }
    STTHESAT = ((((model_.STTHESATO)*(1.0+((model_.STTHESATL)*iLE)))*(1.0+((model_.STTHESATW)*iWE)))*(1.0+(((model_.STTHESATLW)*iLE)*iWE)));
    THESATB = (model_.THESATBO);
    THESATG = (model_.THESATGO);
    AX = ((model_.AXO)/(1.0+((model_.AXL_i)*iLE)));
    {
      double value_pow_0 = pow(iLE,(model_.ALPLEXP));
      ALP = (((model_.ALPL)*value_pow_0)*(1.0+((model_.ALPW)*iWE)));
    }
    {
      double value_pow_0 = pow(iLE,(model_.ALP1LEXP));
      tmpx = value_pow_0;
    }
    ALP1 = ((((model_.ALP1L1)*tmpx)*(1.0+((model_.ALP1W)*iWE)))/(1.0+(((model_.ALP1L2_i)*iLE)*tmpx)));
    {
      double value_pow_0 = pow(iLE,(model_.ALP2LEXP));
      tmpx = value_pow_0;
    }
    ALP2 = ((((model_.ALP2L1)*tmpx)*(1.0+((model_.ALP2W)*iWE)))/(1.0+(((model_.ALP2L2_i)*iLE)*tmpx)));
    VP = (model_.VPO);
    A1 = (((model_.A1O)*(1.0+((model_.A1L)*iLE)))*(1.0+((model_.A1W)*iWE)));
    A2 = (model_.A2O);
    STA2 = (model_.STA2O);
    A3 = (((model_.A3O)*(1.0+((model_.A3L)*iLE)))*(1.0+((model_.A3W)*iWE)));
    A4 = (((model_.A4O)*(1.0+((model_.A4L)*iLE)))*(1.0+((model_.A4W)*iWE)));
    GCO = (model_.GCOO);
    IGINV = ((model_.IGINVLW)/(iWE*iLE));
    IGOV = (((model_.IGOVW)*(model_.LOV_i))/(LEN*iWE));
    IGOVD = (((model_.IGOVDW)*(model_.LOVD_i))/(LEN*iWE));
    STIG = (model_.STIGO);
    GC2 = (model_.GC2O);
    GC3 = (model_.GC3O);
    CHIB = (model_.CHIBO);
    AGIDL = (((model_.AGIDLW)*(model_.LOV_i))/(LEN*iWE));
    AGIDLD = (((model_.AGIDLDW)*(model_.LOVD_i))/(LEN*iWE));
    BGIDL = (model_.BGIDLO);
    BGIDLD = (model_.BGIDLDO);
    STBGIDL = (model_.STBGIDLO);
    STBGIDLD = (model_.STBGIDLDO);
    CGIDL = (model_.CGIDLO);
    CGIDLD = (model_.CGIDLDO);
    COX = ((((8.8541878176E-12*(model_.EPSROX_i))*WEcv)*LEcv)/(model_.TOX_i));
    CGOV = ((((8.8541878176E-12*(model_.EPSROX_i))*WEcv)*(model_.LOV_i))/(model_.TOXOV_i));
    CGOVD = ((((8.8541878176E-12*(model_.EPSROX_i))*WEcv)*(model_.LOVD_i))/(model_.TOXOVD_i));
    CGBOV = (((model_.CGBOVL)*Lcv)/LEN);
    CFR = (((model_.CFRW)*Wcv)/WEN);
    CFRD = (((model_.CFRDW)*Wcv)/WEN);
    temp0 = (1.0-(((2.0*(model_.LINTNOI))*iLE)/LEN));
    Lnoi = ((temp0>1.0e-3)?temp0:1.0e-3);
    {
      double value_pow_0 = pow(Lnoi,(model_.ALPNOI));
      Lred = (1.0/value_pow_0);
    }
    FNT = (model_.FNTO);
    FNTEXC = (((((model_.FNTEXCL)*BETN)*BETN)*iWE)*iWE);
    NFA = (((Lred*iWE)*iLE)*(model_.NFALW));
    NFB = (((Lred*iWE)*iLE)*(model_.NFBLW));
    NFC = (((Lred*iWE)*iLE)*(model_.NFCLW));
    EF = (model_.EFO);
    KVTHOWE = ((((model_.KVTHOWEO)+((model_.KVTHOWEL)*iLE))+((model_.KVTHOWEW)*iWE))+(((model_.KVTHOWELW)*iLE)*iWE));
    KUOWE = ((((model_.KUOWEO)+((model_.KUOWEL)*iLE))+((model_.KUOWEW)*iWE))+(((model_.KUOWELW)*iLE)*iWE));
    RG = ((((RSHG_i*(((3.3333333333333333e-01*W_f)/NGCON_i)+XGWE))/(NGCON_i*L_slif))+(((model_.RINT_i)+(model_.RVPOLY_i))/(W_f*L_f)))+(NF_i*(model_.RGO)));
    RWELL = (NF_i*(model_.RWELLO));
    RBULK = (NF_i*(model_.RBULKO));
    RJUNS = (NF_i*(model_.RJUNSO));
    RJUND = (NF_i*(model_.RJUNDO));
    tmpa = 0.0;
    tmpb = 0.0;
    loop = 0.0;
    if ((((SA_i>0.0)&&(SB_i>0.0))&&((NF_i==1.0)||((NF_i>1.0)&&(SD_i>0.0)))))
    {
      while ((loop<(NF_i-0.5)))
      {
        tmpa = (tmpa+(1.0/((SA_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
        tmpb = (tmpb+(1.0/((SB_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
        loop = (loop+1.0);
      }
      Invsa = (tmpa*invNF);
      Invsb = (tmpb*invNF);
      Invsaref = (1.0/((model_.SAREF_i)+(0.5*L_i)));
      Invsbref = (1.0/((model_.SBREF_i)+(0.5*L_i)));
      Lx = (((L_i+delLPS)>1e-9)?(L_i+delLPS):1e-9);
      Wx = ((((W_i+delWOD)+(model_.WLOD))>1e-9)?((W_i+delWOD)+(model_.WLOD)):1e-9);
      {
        double value_pow_0 = pow(Lx,(model_.LLODKUO_i));
        templ = (1.0/value_pow_0);
      }
      {
        double value_pow_0 = pow(Wx,(model_.WLODKUO_i));
        tempw = (1.0/value_pow_0);
      }
      Kstressu0 = ((((1.0+((model_.LKUO)*templ))+((model_.WKUO)*tempw))+(((model_.PKUO)*templ)*tempw))*(1.0+((model_.TKUO)*((model_.rT)-1.0))));
      rhobeta = (((model_.KUO)*(Invsa+Invsb))/Kstressu0);
      rhobetaref = (((model_.KUO)*(Invsaref+Invsbref))/Kstressu0);
      {
        double value_pow_0 = pow(Lx,(model_.LLODVTH_i));
        templ = (1.0/value_pow_0);
      }
      {
        double value_pow_0 = pow(Wx,(model_.WLODVTH_i));
        tempw = (1.0/value_pow_0);
      }
      Kstressvth0 = (((1.0+((model_.LKVTHO)*templ))+((model_.WKVTHO)*tempw))+(((model_.PKVTHO)*templ)*tempw));
      temp0 = (((Invsa+Invsb)-Invsaref)-Invsbref);
      BETN = ((BETN*(1.0+rhobeta))/(1.0+rhobetaref));
      THESAT = (((THESAT*(1.0+rhobeta))*(1.0+((model_.KVSAT_i)*rhobetaref)))/((1.0+rhobetaref)*(1.0+((model_.KVSAT_i)*rhobeta))));
      VFB = (VFB+(((model_.KVTHO)*temp0)/Kstressvth0));
      {
        double value_pow_0 = pow(Kstressvth0,(model_.LODETAO_i));
        CF = (CF+(((model_.STETAO)*temp0)/value_pow_0));
      }
    }
    if (((((SCA_i>0.0)||(SCB_i>0.0))||(SCC_i>0.0))||(SC_i>0.0)))
    {
      if ((((SCA_i==0.0)&&(SCB_i==0.0))&&(SCC_i==0.0)))
      {
        temp0 = (SC_i+W_i);
        temp00 = (1.0/(model_.SCREF_i));
        SCA_i = (((model_.SCREF_i)*(model_.SCREF_i))/(SC_i*temp0));
        {
          double value_exp_0 = exp((((-10.0)*SC_i)*temp00));
          double value_exp_1 = exp((((-10.0)*temp0)*temp00));
          SCB_i = (((((0.1*SC_i)+(0.01*(model_.SCREF_i)))*value_exp_0)-(((0.1*temp0)+(0.01*(model_.SCREF_i)))*value_exp_1))/W_i);
        }
        {
          double value_exp_0 = exp((((-20.0)*SC_i)*temp00));
          double value_exp_1 = exp((((-20.0)*temp0)*temp00));
          SCC_i = (((((0.05*SC_i)+(0.0025*(model_.SCREF_i)))*value_exp_0)-(((0.05*temp0)+(0.0025*(model_.SCREF_i)))*value_exp_1))/W_i);
        }
      }
      temp0 = ((SCA_i+((model_.WEB_i)*SCB_i))+((model_.WEC_i)*SCC_i));
      VFB = (VFB+(KVTHOWE*temp0));
      BETN = (BETN*(1.0+(KUOWE*temp0)));
    }
    VFB_i = VFB;
    STVFB_i = STVFB;
    (model_.TOX_i) = ((TOX>1e-10)?TOX:1e-10);
    (model_.EPSROX_i) = ((EPSROX>1.0)?EPSROX:1.0);
    NEFF_i = ((NEFF>1e20)?((NEFF<1e26)?NEFF:1e26):1e20);
    VNSUB_i = VNSUB;
    NSLP_i = ((NSLP>1e-3)?NSLP:1e-3);
    DNSUB_i = ((DNSUB>0.0)?((DNSUB<1.0)?DNSUB:1.0):0.0);
    DPHIB_i = DPHIB;
    NP_i = ((NP>0.0)?NP:0.0);
    QMC_i = (((model_.QMC)>0.0)?(model_.QMC):0.0);
    CT_i = ((CT>0.0)?CT:0.0);
    (model_.TOXOV_i) = ((TOXOV>1e-10)?TOXOV:1e-10);
    (model_.TOXOVD_i) = ((TOXOVD>1e-10)?TOXOVD:1e-10);
    NOV_i = ((NOV>1e20)?((NOV<1e27)?NOV:1e27):1e20);
    NOVD_i = ((NOVD>1e20)?((NOVD<1e27)?NOVD:1e27):1e20);
    CF_i = ((CF>0.0)?CF:0.0);
    CFB_i = ((CFB>0.0)?((CFB<1.0)?CFB:1.0):0.0);
    BETN_i = ((BETN>0.0)?BETN:0.0);
    STBET_i = STBET;
    MUE_i = ((MUE>0.0)?MUE:0.0);
    STMUE_i = STMUE;
    THEMU_i = ((THEMU>0.0)?THEMU:0.0);
    STTHEMU_i = STTHEMU;
    CS_i = ((CS>0.0)?CS:0.0);
    STCS_i = STCS;
    XCOR_i = ((XCOR>0.0)?XCOR:0.0);
    STXCOR_i = STXCOR;
    FETA_i = ((FETA>0.0)?FETA:0.0);
    RS_i = ((RS>0.0)?RS:0.0);
    STRS_i = STRS;
    RSB_i = ((RSB>(-0.5))?((RSB<1.0)?RSB:1.0):(-0.5));
    RSG_i = ((RSG>(-0.5))?RSG:(-0.5));
    THESAT_i = ((THESAT>0.0)?THESAT:0.0);
    STTHESAT_i = STTHESAT;
    THESATB_i = ((THESATB>(-0.5))?((THESATB<1.0)?THESATB:1.0):(-0.5));
    THESATG_i = ((THESATG>(-0.5))?THESATG:(-0.5));
    AX_i = ((AX>2.0)?AX:2.0);
    ALP_i = ((ALP>0.0)?ALP:0.0);
    ALP1_i = ((ALP1>0.0)?ALP1:0.0);
    ALP2_i = ((ALP2>0.0)?ALP2:0.0);
    VP_i = ((VP>1.0e-10)?VP:1.0e-10);
    A1_i = ((A1>0.0)?A1:0.0);
    A2_i = ((A2>0.0)?A2:0.0);
    STA2_i = STA2;
    A3_i = ((A3>0.0)?A3:0.0);
    A4_i = ((A4>0.0)?A4:0.0);
    GCO_i = ((GCO>(-10.0))?((GCO<10.0)?GCO:10.0):(-10.0));
    IGINV_i = ((IGINV>0.0)?IGINV:0.0);
    IGOV_i = ((IGOV>0.0)?IGOV:0.0);
    IGOVD_i = ((IGOVD>0.0)?IGOVD:0.0);
    STIG_i = STIG;
    GC2_i = ((GC2>0.0)?((GC2<10.0)?GC2:10.0):0.0);
    GC3_i = ((GC3>(-10.0))?((GC3<10.0)?GC3:10.0):(-10.0));
    CHIB_i = ((CHIB>1.0)?CHIB:1.0);
    AGIDL_i = ((AGIDL>0.0)?AGIDL:0.0);
    AGIDLD_i = ((AGIDLD>0.0)?AGIDLD:0.0);
    BGIDL_i = ((BGIDL>0.0)?BGIDL:0.0);
    BGIDLD_i = ((BGIDLD>0.0)?BGIDLD:0.0);
    STBGIDL_i = STBGIDL;
    STBGIDLD_i = STBGIDLD;
    CGIDL_i = CGIDL;
    CGIDLD_i = CGIDLD;
    COX_i = ((COX>0.0)?COX:0.0);
    CGOV_i = ((CGOV>0.0)?CGOV:0.0);
    CGOVD_i = ((CGOVD>0.0)?CGOVD:0.0);
    CGBOV_i = ((CGBOV>0.0)?CGBOV:0.0);
    CFR_i = ((CFR>0.0)?CFR:0.0);
    CFRD_i = ((CFRD>0.0)?CFRD:0.0);
    FNT_i = ((FNT>0.0)?FNT:0.0);
    FNTEXC_i = ((FNTEXC>0.0)?FNTEXC:0.0);
    NFA_i = ((NFA>0.0)?NFA:0.0);
    NFB_i = ((NFB>0.0)?NFB:0.0);
    NFC_i = ((NFC>0.0)?NFC:0.0);
    EF_i = ((EF>0.0)?EF:0.0);
    FACTUO_i = ((FACTUO>0.0)?FACTUO:0.0);
    DELVTO_i = DELVTO;
    RG_i = ((RG>0.0)?RG:0.0);
    RBULK_i = ((RBULK>0.0)?RBULK:0.0);
    RJUNS_i = ((RJUNS>0.0)?RJUNS:0.0);
    RJUND_i = ((RJUND>0.0)?RJUND:0.0);
    RWELL_i = ((RWELL>0.0)?RWELL:0.0);
    MULT_i = (((MULT*NF_i)>0.0)?(MULT*NF_i):0.0);
    if (((model_.SWJUNASYM)==0.0))
    {
      (model_.TOXOVD_i) = (model_.TOXOV_i);
      NOVD_i = NOV_i;
      AGIDLD_i = AGIDL_i;
      BGIDLD_i = BGIDL_i;
      STBGIDLD_i = STBGIDL_i;
      CGIDLD_i = CGIDL_i;
      IGOVD_i = IGOV_i;
      CGOVD_i = CGOV_i;
      CFRD_i = CFR_i;
    }
    if (((((model_.SWJUNCAP)==1.0)||((model_.SWJUNCAP)==2.0))||((model_.SWJUNCAP)==3.0)))
    {
      ABSOURCE_i = ((ABS_i>0)?ABS_i:0);
      LSSOURCE_i = ((LSS_i>0)?LSS_i:0);
      LGSOURCE_i = ((LGS_i>0)?LGS_i:0);
      ABDRAIN_i = ((ABD_i>0)?ABD_i:0);
      LSDRAIN_i = ((LSD_i>0)?LSD_i:0);
      LGDRAIN_i = ((LGD_i>0)?LGD_i:0);
    }
    else
    {
      ABSOURCE_i = 0.0;
      LSSOURCE_i = 0.0;
      LGSOURCE_i = 0.0;
      ABDRAIN_i = 0.0;
      LSDRAIN_i = 0.0;
      LGDRAIN_i = 0.0;
    }
    EPSOX = (8.8541878176E-12*(model_.EPSROX_i));
    phit1 = ((model_.phit)*(1.0+(CT_i*(model_.rTn))));
    inv_phit1 = (1.0/phit1);
    VFB_i = ((VFB_i+(STVFB_i*(model_.dT)))+DELVTO_i);
    {
      double value_pow_0 = pow((model_.phibFac),(-0.75));
      double value_log_1 = log(((NEFF_i*value_pow_0)*4.0e-26));
      phib = (((model_.Eg)+DPHIB_i)+((2.0*(model_.phit))*value_log_1));
    }
    phib = ((phib>5.0E-2)?phib:5.0E-2);
    CoxPrime = (EPSOX/(model_.TOX_i));
    tox_sq = ((model_.TOX_i)*(model_.TOX_i));
    {
      double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NEFF_i)*(model_.EPSSI))*(model_.inv_phit)));
      G_0 = (value_sqrt_0/CoxPrime);
    }
    kp = 0.0;
    if ((NP_i>0.0))
    {
      arg2max = (8.0e7/tox_sq);
      np = ((NP_i>arg2max)?NP_i:arg2max);
      np = ((5.0e24>np)?5.0e24:np);
      kp = ((((2.0*CoxPrime)*CoxPrime)*(model_.phit))/((1.6021918E-19*np)*(model_.EPSSI)));
    }
    qlim2 = ((100.0*(model_.phit))*(model_.phit));
    qq = 0.0;
    if ((QMC_i>0.0))
    {
      {
        double value_pow_0 = pow(CoxPrime,6.6666666666666667e-01);
        qq = (((0.4*5.951993)*QMC_i)*value_pow_0);
      }
      if (((model_.CHNL_TYPE)==(-1)))
      {
        qq = ((7.448711/5.951993)*qq);
      }
      {
        double value_sqrt_0 = sqrt(((((model_.phit)*G_0)*G_0)*phib));
        qb0 = value_sqrt_0;
      }
      {
        double value_pow_0 = pow(qb0,6.6666666666666667e-01);
        dphibq = ((0.75*qq)*value_pow_0);
      }
      phib = (phib+dphibq);
      G_0 = (G_0*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
    }
    {
      double value_sqrt_0 = sqrt(phib);
      sqrt_phib = value_sqrt_0;
    }
    phix = (0.95*phib);
    aphi = ((0.0025*phib)*phib);
    bphi = aphi;
    {
      double value_sqrt_0 = sqrt(bphi);
      phix2 = (0.5*value_sqrt_0);
    }
    {
      double value_sqrt_0 = sqrt(((((phix-phix2))*((phix-phix2)))+aphi));
      phix1 = (0.5*(((phix-phix2))-value_sqrt_0));
    }
    CoxovPrime = (EPSOX/(model_.TOXOV_i));
    CoxovPrime_d = (EPSOX/(model_.TOXOVD_i));
    {
      double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NOV_i)*(model_.EPSSI))*(model_.inv_phit)));
      GOV_s = (value_sqrt_0/CoxovPrime);
    }
    {
      double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NOVD_i)*(model_.EPSSI))*(model_.inv_phit)));
      GOV_d = (value_sqrt_0/CoxovPrime_d);
    }
    GOV2_s = (GOV_s*GOV_s);
    GOV2_d = (GOV_d*GOV_d);
    xi_ov_s = (1.0+(GOV_s*7.0710678118654746e-01));
    xi_ov_d = (1.0+(GOV_d*7.0710678118654746e-01));
    inv_xi_ov_s = (1.0/xi_ov_s);
    inv_xi_ov_d = (1.0/xi_ov_d);
    x_mrg_ov_s = (1.0e-5*xi_ov_s);
    x_mrg_ov_d = (1.0e-5*xi_ov_d);
    {
      double value_pow_0 = pow((model_.rTn),STBET_i);
      tf_bet = value_pow_0;
    }
    BET_i = (((FACTUO_i*BETN_i)*CoxPrime)*tf_bet);
    BETN_i = (BETN_i*tf_bet);
    {
      double value_pow_0 = pow((model_.rTn),STTHEMU_i);
      THEMU_i = (THEMU_i*value_pow_0);
    }
    {
      double value_pow_0 = pow((model_.rTn),STMUE_i);
      tf_mue = value_pow_0;
    }
    MUE_i = (MUE_i*tf_mue);
    {
      double value_pow_0 = pow((model_.rTn),STCS_i);
      tf_cs = value_pow_0;
    }
    CS_i = (CS_i*tf_cs);
    {
      double value_pow_0 = pow((model_.rTn),STXCOR_i);
      tf_xcor = value_pow_0;
    }
    XCOR_i = (XCOR_i*tf_xcor);
    E_eff0 = ((1.0e-8*CoxPrime)/(model_.EPSSI));
    eta_mu = (0.5*FETA_i);
    if (((model_.CHNL_TYPE)==(-1)))
    {
      eta_mu = (3.3333333333333333e-01*FETA_i);
    }
    {
      double value_pow_0 = pow((model_.rTn),STRS_i);
      tf_ther = value_pow_0;
    }
    RS_i = (RS_i*tf_ther);
    THER_i = ((2*BET_i)*RS_i);
    {
      double value_pow_0 = pow((model_.rTn),STTHESAT_i);
      tf_thesat = value_pow_0;
    }
    THESAT_i = (THESAT_i*tf_thesat);
    Vdsat_lim = (3.912023005*phit1);
    inv_AX = (1.0/AX_i);
    inv_VP = (1.0/VP_i);
    {
      double value_pow_0 = pow((model_.rT),STA2_i);
      A2_i = (A2_i*value_pow_0);
    }
    {
      double value_pow_0 = pow((model_.rT),STIG_i);
      tf_ig = value_pow_0;
    }
    IGINV_i = (IGINV_i*tf_ig);
    IGOV_i = (IGOV_i*tf_ig);
    IGOVD_i = (IGOVD_i*tf_ig);
    inv_CHIB = (1.0/CHIB_i);
    {
      double value_sqrt_0 = sqrt((((2*1.6021918E-19)*9.1093826E-31)*CHIB_i));
      tempM = (((4.0*3.3333333333333333e-01)*value_sqrt_0)/1.05457168E-34);
    }
    BCH = (tempM*(model_.TOX_i));
    BOV = (tempM*(model_.TOXOV_i));
    BOV_d = (tempM*(model_.TOXOVD_i));
    GCQ = 0;
    if ((GC3_i<0))
    {
      GCQ = (((-0.495)*GC2_i)/GC3_i);
    }
    alpha_b = (0.5*(phib+(model_.Eg)));
    Dch = (GCO_i*phit1);
    Dov = (GCO_i*(model_.phit));
    AGIDLs = ((AGIDL_i*4e-18)/((model_.TOXOV_i)*(model_.TOXOV_i)));
    AGIDLDs = ((AGIDLD_i*4e-18)/((model_.TOXOVD_i)*(model_.TOXOVD_i)));
    tempM = (((1.0+(STBGIDL_i*(model_.dT)))>0)?(1.0+(STBGIDL_i*(model_.dT))):0);
    BGIDL_T = (BGIDL_i*tempM);
    BGIDLs = ((BGIDL_T*(model_.TOXOV_i))*5e8);
    tempM = (((1.0+(STBGIDLD_i*(model_.dT)))>0)?(1.0+(STBGIDLD_i*(model_.dT))):0);
    BGIDLD_T = (BGIDLD_i*tempM);
    BGIDLDs = ((BGIDLD_T*(model_.TOXOVD_i))*5e8);
    nt = (((FNT_i*4)*1.3806505E-23)*(model_.TKD));
    Cox_over_q = (CoxPrime/1.6021918E-19);
    Sfl_prefac = ((((model_.phit)*(model_.phit))*BET_i)/Cox_over_q);
    fac_exc = ((9.1093826E-31*1e9)*FNTEXC_i);
    x1 = 1.25;
    inv_xg1_s = (1.0/(x1+(GOV_s*7.324648775608221e-1)));
    inv_xg1_d = (1.0/(x1+(GOV_d*7.324648775608221e-1)));
    if ((RG_i>0.0))
    {
      ggate = (1.0/RG_i);
    }
    else
    {
      ggate = 0.0;
    }
    if ((RBULK_i>0.0))
    {
      gbulk = (1.0/RBULK_i);
    }
    else
    {
      gbulk = 0.0;
    }
    if ((RJUNS_i>0.0))
    {
      gjuns = (1.0/RJUNS_i);
    }
    else
    {
      gjuns = 0.0;
    }
    if ((RJUND_i>0.0))
    {
      gjund = (1.0/RJUND_i);
    }
    else
    {
      gjund = 0.0;
    }
    if ((RWELL_i>0.0))
    {
      gwell = (1.0/RWELL_i);
    }
    else
    {
      gwell = 0.0;
    }
    vbimin_s = 0.0;
    vbimin_d = 0.0;
    vfmin_s = 0.0;
    vfmin_d = 0.0;
    vch_s = 0.0;
    vch_d = 0.0;
    vbbtlim_s = 0.0;
    vbbtlim_d = 0.0;
    VMAX_s = 0.0;
    VMAX_d = 0.0;
    exp_VMAX_over_phitd_s = 0.0;
    exp_VMAX_over_phitd_d = 0.0;
    ISATFOR1_s = 0.0;
    ISATFOR1_d = 0.0;
    MFOR1_s = 1.0;
    MFOR1_d = 1.0;
    ISATFOR2_s = 0.0;
    ISATFOR2_d = 0.0;
    MFOR2_s = 1.0;
    MFOR2_d = 1.0;
    ISATREV_s = 0.0;
    ISATREV_d = 0.0;
    MREV_s = 1.0;
    MREV_d = 1.0;
    m0flag_s = 0.0;
    m0flag_d = 0.0;
    xhighf1_s = 0.0;
    xhighf1_d = 0.0;
    expxhf1_s = 0.0;
    expxhf1_d = 0.0;
    xhighf2_s = 0.0;
    xhighf2_d = 0.0;
    expxhf2_s = 0.0;
    expxhf2_d = 0.0;
    xhighr_s = 0.0;
    xhighr_d = 0.0;
    expxhr_s = 0.0;
    expxhr_d = 0.0;
    zflagbot_s = 1.0;
    zflagbot_d = 1.0;
    zflagsti_s = 1.0;
    zflagsti_d = 1.0;
    zflaggat_s = 1.0;
    zflaggat_d = 1.0;
    m0_rev = 0.0;
    mcor_rev = 0.0;
    I1_cor = 0.0;
    I2_cor = 0.0;
    I3_cor = 0.0;
    I4_cor = 0.0;
    I5_cor = 0.0;
    tt0 = 0.0;
    tt1 = 0.0;
    tt2 = 0.0;
    zfrac = 0.0;
    alphaje = 0.0;
    if (((model_.SWJUNCAP)>0))
    {
      if ((((model_.idsatbot)*ABSOURCE_i)>0))
      {
        {
          double value_log_0 = log((((model_.IMAX_i)/((model_.idsatbot)*ABSOURCE_i))+1));
          vmaxbot = ((model_.phitd)*value_log_0);
        }
      }
      else
      {
        vmaxbot = 1E8;
      }
      if ((((model_.idsatsti)*LSSOURCE_i)>0))
      {
        {
          double value_log_0 = log((((model_.IMAX_i)/((model_.idsatsti)*LSSOURCE_i))+1));
          vmaxsti = ((model_.phitd)*value_log_0);
        }
      }
      else
      {
        vmaxsti = 1E8;
      }
      if ((((model_.idsatgat)*LGSOURCE_i)>0))
      {
        {
          double value_log_0 = log((((model_.IMAX_i)/((model_.idsatgat)*LGSOURCE_i))+1));
          vmaxgat = ((model_.phitd)*value_log_0);
        }
      }
      else
      {
        vmaxgat = 1E8;
      }
      {
        double value_min_0 = std::min(vmaxbot,vmaxsti);
        double value_min_1 = std::min(value_min_0,vmaxgat);
        VMAX_s = value_min_1;
      }
      if ((fabs((VMAX_s*(model_.phitdinv)))<2.3025850929940458e+02))
      {
        {
          double value_exp_0 = exp((VMAX_s*(model_.phitdinv)));
          exp_VMAX_over_phitd_s = value_exp_0;
        }
      }
      else
      {
        if (((VMAX_s*(model_.phitdinv))<(-2.3025850929940458e+02)))
        {
          exp_VMAX_over_phitd_s = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(VMAX_s*(model_.phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(VMAX_s*(model_.phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(VMAX_s*(model_.phitdinv)))*3.3333333333333333e-01))))))));
        }
        else
        {
          exp_VMAX_over_phitd_s = (1.0e100*(1.0+(((VMAX_s*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((VMAX_s*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(((VMAX_s*(model_.phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
        }
      }
      vbibot2 = (model_.vbibot);
      vbisti2 = (model_.vbisti);
      vbigat2 = (model_.vbigat);
      pbot2 = (model_.PBOT_i);
      psti2 = (model_.PSTI_i);
      pgat2 = (model_.PGAT_i);
      vbibot2r = (model_.VBIRBOT_i);
      vbisti2r = (model_.VBIRSTI_i);
      vbigat2r = (model_.VBIRGAT_i);
      if ((ABSOURCE_i==0))
      {
        vbibot2 = ((model_.vbisti)+(model_.vbigat));
        {
          double value_min_0 = std::min((model_.PSTI_i),(model_.PGAT_i));
          pbot2 = (0.9*value_min_0);
        }
        vbibot2r = ((model_.VBIRSTI_i)+(model_.VBIRGAT_i));
      }
      if ((LSSOURCE_i==0))
      {
        vbisti2 = ((model_.vbibot)+(model_.vbigat));
        {
          double value_min_0 = std::min((model_.PBOT_i),(model_.PGAT_i));
          psti2 = (0.9*value_min_0);
        }
        vbisti2r = ((model_.VBIRBOT_i)+(model_.VBIRGAT_i));
      }
      if ((LGSOURCE_i==0))
      {
        vbigat2 = ((model_.vbibot)+(model_.vbisti));
        {
          double value_min_0 = std::min((model_.PBOT_i),(model_.PSTI_i));
          pgat2 = (0.9*value_min_0);
        }
        vbigat2r = ((model_.VBIRBOT_i)+(model_.VBIRSTI_i));
      }
      {
        double value_min_0 = std::min(vbibot2,vbisti2);
        double value_min_1 = std::min(value_min_0,vbigat2);
        vbimin_s = value_min_1;
      }
      vch_s = (vbimin_s*0.1);
      {
        double value_max_0 = std::max(pbot2,psti2);
        double value_max_1 = std::max(value_max_0,pgat2);
        pmax = value_max_1;
      }
      {
        double value_pow_0 = pow(2,((-1.0)/pmax));
        vfmin_s = (vbimin_s*(1-value_pow_0));
      }
      {
        double value_min_0 = std::min(vbibot2r,vbisti2r);
        double value_min_1 = std::min(value_min_0,vbigat2r);
        vbbtlim_s = (value_min_1-0.050);
      }
      if ((((model_.idsatbot_d)*ABDRAIN_i)>0))
      {
        {
          double value_log_0 = log((((model_.IMAX_i)/((model_.idsatbot_d)*ABDRAIN_i))+1));
          vmaxbot = ((model_.phitd)*value_log_0);
        }
      }
      else
      {
        vmaxbot = 1E8;
      }
      if ((((model_.idsatsti_d)*LSDRAIN_i)>0))
      {
        {
          double value_log_0 = log((((model_.IMAX_i)/((model_.idsatsti_d)*LSDRAIN_i))+1));
          vmaxsti = ((model_.phitd)*value_log_0);
        }
      }
      else
      {
        vmaxsti = 1E8;
      }
      if ((((model_.idsatgat_d)*LGDRAIN_i)>0))
      {
        {
          double value_log_0 = log((((model_.IMAX_i)/((model_.idsatgat_d)*LGDRAIN_i))+1));
          vmaxgat = ((model_.phitd)*value_log_0);
        }
      }
      else
      {
        vmaxgat = 1E8;
      }
      {
        double value_min_0 = std::min(vmaxbot,vmaxsti);
        double value_min_1 = std::min(value_min_0,vmaxgat);
        VMAX_d = value_min_1;
      }
      if ((fabs((VMAX_d*(model_.phitdinv)))<2.3025850929940458e+02))
      {
        {
          double value_exp_0 = exp((VMAX_d*(model_.phitdinv)));
          exp_VMAX_over_phitd_d = value_exp_0;
        }
      }
      else
      {
        if (((VMAX_d*(model_.phitdinv))<(-2.3025850929940458e+02)))
        {
          exp_VMAX_over_phitd_d = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(VMAX_d*(model_.phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(VMAX_d*(model_.phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(VMAX_d*(model_.phitdinv)))*3.3333333333333333e-01))))))));
        }
        else
        {
          exp_VMAX_over_phitd_d = (1.0e100*(1.0+(((VMAX_d*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((VMAX_d*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(((VMAX_d*(model_.phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
        }
      }
      vbibot2 = (model_.vbibot_d);
      vbisti2 = (model_.vbisti_d);
      vbigat2 = (model_.vbigat_d);
      pbot2 = (model_.PBOTD_i);
      psti2 = (model_.PSTID_i);
      pgat2 = (model_.PGATD_i);
      vbibot2r = (model_.VBIRBOTD_i);
      vbisti2r = (model_.VBIRSTID_i);
      vbigat2r = (model_.VBIRGATD_i);
      if ((ABDRAIN_i==0))
      {
        vbibot2 = ((model_.vbisti_d)+(model_.vbigat_d));
        {
          double value_min_0 = std::min((model_.PSTID_i),(model_.PGATD_i));
          pbot2 = (0.9*value_min_0);
        }
        vbibot2r = ((model_.VBIRSTID_i)+(model_.VBIRGATD_i));
      }
      if ((LSDRAIN_i==0))
      {
        vbisti2 = ((model_.vbibot_d)+(model_.vbigat_d));
        {
          double value_min_0 = std::min((model_.PBOTD_i),(model_.PGATD_i));
          psti2 = (0.9*value_min_0);
        }
        vbisti2r = ((model_.VBIRBOTD_i)+(model_.VBIRGATD_i));
      }
      if ((LGDRAIN_i==0))
      {
        vbigat2 = ((model_.vbibot_d)+(model_.vbisti_d));
        {
          double value_min_0 = std::min((model_.PBOTD_i),(model_.PSTID_i));
          pgat2 = (0.9*value_min_0);
        }
        vbigat2r = ((model_.VBIRBOTD_i)+(model_.VBIRSTID_i));
      }
      {
        double value_min_0 = std::min(vbibot2,vbisti2);
        double value_min_1 = std::min(value_min_0,vbigat2);
        vbimin_d = value_min_1;
      }
      vch_d = (vbimin_d*0.1);
      {
        double value_max_0 = std::max(pbot2,psti2);
        double value_max_1 = std::max(value_max_0,pgat2);
        pmax = value_max_1;
      }
      {
        double value_pow_0 = pow(2,((-1.0)/pmax));
        vfmin_d = (vbimin_d*(1-value_pow_0));
      }
      {
        double value_min_0 = std::min(vbibot2r,vbisti2r);
        double value_min_1 = std::min(value_min_0,vbigat2r);
        vbbtlim_d = (value_min_1-0.050);
      }
      if (((model_.SWJUNEXP_i)==1.0))
        //Begin block JUNCAPexpressInit
      {
        //Block-local variables for block JUNCAPexpressInit
        double ysq;
        double terfc;
        double erfcpos;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double h1;
        double h2;
        double h2d;
        double h3;
        double h4;
        double h5;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double idmult;
        double vj;
        double z;
        double zinv;
        double two_psistar;
        double vjlim;
        double vjsrh;
        double vbbt;
        double vav;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double tmp;
        double id;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double isrh;
        double vbi_minus_vjsrh;
        double wsrhstep;
        double dwsrh;
        double wsrh;
        double wdep;
        double asrh;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double itat;
        double btat;
        double twoatatoverthreebtat;
        double umaxbeforelimiting;
        double umax;
        double sqrtumax;
        double umaxpoweronepointfive;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double wgamma;
        double wtat;
        double ktat;
        double ltat;
        double mtat;
        double xerfc;
        double erfctimesexpmtat;
        double gammamax;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double ibbt;
        double Fmaxr;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double fbreakdown;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double ijunbot;
        double ijunsti;
        double ijungat;
        double qjunbot;
        double qjunsti;
        double qjungat;
        //End of Block-local variables
        ysq = 0.0;
        terfc = 0.0;
        erfcpos = 0.0;
        h1 = 0.0;
        h2 = 0.0;
        h2d = 0.0;
        h3 = 0.0;
        h4 = 0.0;
        h5 = 0.0;
        idmult = 0.0;
        vj = 0.0;
        z = 0.0;
        zinv = 0.0;
        two_psistar = 0.0;
        vjlim = 0.0;
        vjsrh = 0.0;
        vbbt = 0.0;
        vav = 0.0;
        tmp = 0.0;
        id = 0.0;
        isrh = 0.0;
        vbi_minus_vjsrh = 0.0;
        wsrhstep = 0.0;
        dwsrh = 0.0;
        wsrh = 0.0;
        wdep = 0.0;
        asrh = 0.0;
        itat = 0.0;
        btat = 0.0;
        twoatatoverthreebtat = 0.0;
        umaxbeforelimiting = 0.0;
        umax = 0.0;
        sqrtumax = 0.0;
        umaxpoweronepointfive = 0.0;
        wgamma = 0.0;
        wtat = 0.0;
        ktat = 0.0;
        ltat = 0.0;
        mtat = 0.0;
        xerfc = 0.0;
        erfctimesexpmtat = 0.0;
        gammamax = 0.0;
        ibbt = 0.0;
        Fmaxr = 0.0;
        fbreakdown = 0.0;
        qjunbot = 0.0;
        qjunsti = 0.0;
        qjungat = 0.0;
        FRACNA = 0.4;
        FRACNB = 0.65;
        FRACI = 0.8;
        V1 = ((-FRACNA)*(model_.VJUNREF_i));
        V2 = ((-FRACNB)*(model_.VJUNREF_i));
        V3 = ((-FRACI)*(model_.VJUNREF_i));
        V4 = 0.1;
        V5 = 0.2;
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
        {
          h1 = ((4.0*vch_s)*vch_s);
          h2 = (vch_s/vfmin_s);
          h2d = (V1+(vch_s*h2));
          h3 = (vfmin_s+h2d);
          h4 = (vfmin_s-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V1*vfmin_s)/(h3+h5)));
          if ((V1<VMAX_s))
          {
            if ((fabs((0.5*(V1*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V1*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V1*(model_.phitdinv)))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V1-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V1>0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V1)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_s-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V1-vbbtlim_s)*(V1-vbbtlim_s))+((4*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V1+vbbtlim_s)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V1)*(V1))+((4*1E-6)*1E-6)));
            vav = (0.5*((V1)-value_sqrt_0));
          }
        }
        if ((ABSOURCE_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if (((model_.one_minus_PBOT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V1-vj)));
          id = ((model_.idsatbot)*idmult);
          if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PBOT_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot)*tmp);
            asrh = ((model_.ftdbot)*((zinv-1)*wdep));
            isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOT_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOT_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
            if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOT_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOT_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRBOT_i))))
            {
              if (((model_.PBRBOT_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot)+((vav+(0.999*(model_.VBRBOT_i)))*(model_.slopebot)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSSOURCE_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if (((model_.one_minus_PSTI)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V1-vj)));
          id = ((model_.idsatsti)*idmult);
          if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PSTI_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti)*tmp);
            asrh = ((model_.ftdsti)*((zinv-1)*wdep));
            isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTI_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTI_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
            if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTI_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTI_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRSTI_i))))
            {
              if (((model_.PBRSTI_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti)+((vav+(0.999*(model_.VBRSTI_i)))*(model_.slopesti)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGSOURCE_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if (((model_.one_minus_PGAT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V1-vj)));
          id = ((model_.idsatgat)*idmult);
          if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PGAT_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat)*tmp);
            asrh = ((model_.ftdgat)*((zinv-1)*wdep));
            isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
          }
          if (((model_.CTATGAT_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGAT_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
            if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGAT_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGAT_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRGAT_i))))
            {
              if (((model_.PBRGAT_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat)+((vav+(0.999*(model_.VBRGAT_i)))*(model_.slopegat)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I1 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
        {
          h1 = ((4.0*vch_s)*vch_s);
          h2 = (vch_s/vfmin_s);
          h2d = (V2+(vch_s*h2));
          h3 = (vfmin_s+h2d);
          h4 = (vfmin_s-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V2*vfmin_s)/(h3+h5)));
          if ((V2<VMAX_s))
          {
            if ((fabs((0.5*(V2*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V2*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V2*(model_.phitdinv)))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V2-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V2>0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V2)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_s-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V2-vbbtlim_s)*(V2-vbbtlim_s))+((4*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V2+vbbtlim_s)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V2)*(V2))+((4*1E-6)*1E-6)));
            vav = (0.5*((V2)-value_sqrt_0));
          }
        }
        if ((ABSOURCE_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if (((model_.one_minus_PBOT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V2-vj)));
          id = ((model_.idsatbot)*idmult);
          if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PBOT_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot)*tmp);
            asrh = ((model_.ftdbot)*((zinv-1)*wdep));
            isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOT_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOT_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
            if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOT_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOT_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRBOT_i))))
            {
              if (((model_.PBRBOT_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot)+((vav+(0.999*(model_.VBRBOT_i)))*(model_.slopebot)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSSOURCE_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if (((model_.one_minus_PSTI)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V2-vj)));
          id = ((model_.idsatsti)*idmult);
          if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PSTI_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti)*tmp);
            asrh = ((model_.ftdsti)*((zinv-1)*wdep));
            isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTI_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTI_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
            if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTI_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTI_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRSTI_i))))
            {
              if (((model_.PBRSTI_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti)+((vav+(0.999*(model_.VBRSTI_i)))*(model_.slopesti)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGSOURCE_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if (((model_.one_minus_PGAT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V2-vj)));
          id = ((model_.idsatgat)*idmult);
          if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PGAT_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat)*tmp);
            asrh = ((model_.ftdgat)*((zinv-1)*wdep));
            isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
          }
          if (((model_.CTATGAT_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGAT_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
            if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGAT_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGAT_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRGAT_i))))
            {
              if (((model_.PBRGAT_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat)+((vav+(0.999*(model_.VBRGAT_i)))*(model_.slopegat)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I2 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
        {
          h1 = ((4.0*vch_s)*vch_s);
          h2 = (vch_s/vfmin_s);
          h2d = (V3+(vch_s*h2));
          h3 = (vfmin_s+h2d);
          h4 = (vfmin_s-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V3*vfmin_s)/(h3+h5)));
          if ((V3<VMAX_s))
          {
            if ((fabs((0.5*(V3*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V3*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V3*(model_.phitdinv)))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V3-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V3>0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V3)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_s-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V3-vbbtlim_s)*(V3-vbbtlim_s))+((4*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V3+vbbtlim_s)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V3)*(V3))+((4*1E-6)*1E-6)));
            vav = (0.5*((V3)-value_sqrt_0));
          }
        }
        if ((ABSOURCE_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if (((model_.one_minus_PBOT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V3-vj)));
          id = ((model_.idsatbot)*idmult);
          if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PBOT_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot)*tmp);
            asrh = ((model_.ftdbot)*((zinv-1)*wdep));
            isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOT_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOT_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
            if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOT_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOT_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRBOT_i))))
            {
              if (((model_.PBRBOT_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot)+((vav+(0.999*(model_.VBRBOT_i)))*(model_.slopebot)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSSOURCE_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if (((model_.one_minus_PSTI)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V3-vj)));
          id = ((model_.idsatsti)*idmult);
          if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PSTI_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti)*tmp);
            asrh = ((model_.ftdsti)*((zinv-1)*wdep));
            isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTI_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTI_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
            if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTI_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTI_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRSTI_i))))
            {
              if (((model_.PBRSTI_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti)+((vav+(0.999*(model_.VBRSTI_i)))*(model_.slopesti)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGSOURCE_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if (((model_.one_minus_PGAT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V3-vj)));
          id = ((model_.idsatgat)*idmult);
          if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PGAT_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat)*tmp);
            asrh = ((model_.ftdgat)*((zinv-1)*wdep));
            isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
          }
          if (((model_.CTATGAT_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGAT_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
            if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGAT_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGAT_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRGAT_i))))
            {
              if (((model_.PBRGAT_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat)+((vav+(0.999*(model_.VBRGAT_i)))*(model_.slopegat)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I3 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
        {
          h1 = ((4.0*vch_s)*vch_s);
          h2 = (vch_s/vfmin_s);
          h2d = (V4+(vch_s*h2));
          h3 = (vfmin_s+h2d);
          h4 = (vfmin_s-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V4*vfmin_s)/(h3+h5)));
          if ((V4<VMAX_s))
          {
            if ((fabs((0.5*(V4*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V4*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V4*(model_.phitdinv)))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V4-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V4>0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V4)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_s-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V4-vbbtlim_s)*(V4-vbbtlim_s))+((4*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V4+vbbtlim_s)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V4)*(V4))+((4*1E-6)*1E-6)));
            vav = (0.5*((V4)-value_sqrt_0));
          }
        }
        if ((ABSOURCE_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if (((model_.one_minus_PBOT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V4-vj)));
          id = ((model_.idsatbot)*idmult);
          if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PBOT_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot)*tmp);
            asrh = ((model_.ftdbot)*((zinv-1)*wdep));
            isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOT_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOT_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
            if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOT_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOT_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRBOT_i))))
            {
              if (((model_.PBRBOT_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot)+((vav+(0.999*(model_.VBRBOT_i)))*(model_.slopebot)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSSOURCE_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if (((model_.one_minus_PSTI)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V4-vj)));
          id = ((model_.idsatsti)*idmult);
          if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PSTI_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti)*tmp);
            asrh = ((model_.ftdsti)*((zinv-1)*wdep));
            isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTI_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTI_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
            if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTI_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTI_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRSTI_i))))
            {
              if (((model_.PBRSTI_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti)+((vav+(0.999*(model_.VBRSTI_i)))*(model_.slopesti)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGSOURCE_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if (((model_.one_minus_PGAT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V4-vj)));
          id = ((model_.idsatgat)*idmult);
          if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PGAT_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat)*tmp);
            asrh = ((model_.ftdgat)*((zinv-1)*wdep));
            isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
          }
          if (((model_.CTATGAT_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGAT_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
            if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGAT_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGAT_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRGAT_i))))
            {
              if (((model_.PBRGAT_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat)+((vav+(0.999*(model_.VBRGAT_i)))*(model_.slopegat)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I4 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
        {
          h1 = ((4.0*vch_s)*vch_s);
          h2 = (vch_s/vfmin_s);
          h2d = (V5+(vch_s*h2));
          h3 = (vfmin_s+h2d);
          h4 = (vfmin_s-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V5*vfmin_s)/(h3+h5)));
          if ((V5<VMAX_s))
          {
            if ((fabs((0.5*(V5*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V5*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V5*(model_.phitdinv)))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V5-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V5>0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V5)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_s-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V5-vbbtlim_s)*(V5-vbbtlim_s))+((4*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V5+vbbtlim_s)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V5)*(V5))+((4*1E-6)*1E-6)));
            vav = (0.5*((V5)-value_sqrt_0));
          }
        }
        if ((ABSOURCE_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if (((model_.one_minus_PBOT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V5-vj)));
          id = ((model_.idsatbot)*idmult);
          if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PBOT_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot)*tmp);
            asrh = ((model_.ftdbot)*((zinv-1)*wdep));
            isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOT_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOT_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
            if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOT_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOT_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRBOT_i))))
            {
              if (((model_.PBRBOT_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot)+((vav+(0.999*(model_.VBRBOT_i)))*(model_.slopebot)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSSOURCE_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if (((model_.one_minus_PSTI)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V5-vj)));
          id = ((model_.idsatsti)*idmult);
          if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PSTI_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti)*tmp);
            asrh = ((model_.ftdsti)*((zinv-1)*wdep));
            isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTI_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTI_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
            if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTI_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTI_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRSTI_i))))
            {
              if (((model_.PBRSTI_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti)+((vav+(0.999*(model_.VBRSTI_i)))*(model_.slopesti)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGSOURCE_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if (((model_.one_minus_PGAT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V5-vj)));
          id = ((model_.idsatgat)*idmult);
          if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PGAT_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat)*tmp);
            asrh = ((model_.ftdgat)*((zinv-1)*wdep));
            isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
          }
          if (((model_.CTATGAT_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGAT_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
            if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGAT_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGAT_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRGAT_i))))
            {
              if (((model_.PBRGAT_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat)+((vav+(0.999*(model_.VBRGAT_i)))*(model_.slopegat)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I5 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
        ISATFOR1_s = (((ABSOURCE_i*(model_.idsatbot))+(LSSOURCE_i*(model_.idsatsti)))+(LGSOURCE_i*(model_.idsatgat)));
        {
          double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR1_s));
          I4_cor = (I4-(ISATFOR1_s*(value_exp_0-1.0)));
        }
        {
          double value_exp_0 = exp(((V5*(model_.phitdinv))*MFOR1_s));
          I5_cor = (I5-(ISATFOR1_s*(value_exp_0-1.0)));
        }
        if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
        {
          if (((I4>0)&&(I5>0)))
          {
            if ((((((I4_cor/I4)>0.001)||((I5_cor/I5)>0.001))&&(I4_cor>0))&&(I5_cor>0)))
            {
              alphaje = (I4_cor/I5_cor);
              {
                double value_log_0 = log(alphaje);
                MFOR2_s = (((model_.phitd)*value_log_0)/(V4-V5));
              }
              {
                double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR2_s));
                ISATFOR2_s = (I4_cor/(value_exp_0-1));
              }
            }
          }
          {
            double value_exp_0 = exp(((V1*(model_.phitdinv))*MFOR1_s));
            double value_exp_1 = exp(((V1*(model_.phitdinv))*MFOR2_s));
            I1_cor = ((I1-(ISATFOR1_s*(value_exp_0-1.0)))-(ISATFOR2_s*(value_exp_1-1.0)));
          }
          {
            double value_exp_0 = exp(((V2*(model_.phitdinv))*MFOR1_s));
            double value_exp_1 = exp(((V2*(model_.phitdinv))*MFOR2_s));
            I2_cor = ((I2-(ISATFOR1_s*(value_exp_0-1.0)))-(ISATFOR2_s*(value_exp_1-1.0)));
          }
          {
            double value_exp_0 = exp(((V3*(model_.phitdinv))*MFOR1_s));
            double value_exp_1 = exp(((V3*(model_.phitdinv))*MFOR2_s));
            I3_cor = ((I3-(ISATFOR1_s*(value_exp_0-1.0)))-(ISATFOR2_s*(value_exp_1-1.0)));
          }
          if ((((I1<0)&&(I2<0))&&(I3<0)))
          {
            if ((((((((I1_cor/I1)>0.001)||((I2_cor/I2)>0.001))||((I3_cor/I3)>0.001))&&(I1_cor<0))&&(I2_cor<0))&&(I3_cor<0)))
            {
              alphaje = (I1_cor/I2_cor);
              {
                double value_log_0 = log(alphaje);
                m0_rev = (((-(model_.phitd))*value_log_0)/(V1-V2));
              }
              tt0 = (V2/(V2-V1));
              {
                double value_pow_0 = pow(alphaje,tt0);
                tt1 = (((model_.phitd)*(alphaje-1))*(value_pow_0-1));
              }
              tt0 = (V1/(V1-V2));
              {
                double value_pow_0 = pow(alphaje,tt0);
                tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
              }
              mcor_rev = (tt1/tt2);
              MREV_s = (m0_rev+mcor_rev);
              if ((fabs(((V3*(model_.phitdinv))*MREV_s))<1e-6))
              {
                m0flag_s = 1.0;
                ISATREV_s = (I3_cor*((1/V3)+((0.5*(model_.phitdinv))*MREV_s)));
                MREV_s = (((((-0.5)*I3_cor)*MREV_s)*(model_.phitdinv))/V3);
              }
              else
              {
                m0flag_s = 0.0;
                {
                  double value_exp_0 = exp((((-V3)*(model_.phitdinv))*MREV_s));
                  ISATREV_s = ((-I3_cor)/(value_exp_0-1));
                }
              }
            }
          }
        }
        zfrac = ((model_.FJUNQ_i)*(((ABSOURCE_i*(model_.cjobot))+(LSSOURCE_i*(model_.cjosti)))+(LGSOURCE_i*(model_.cjogat))));
        if (((ABSOURCE_i*(model_.cjobot))<=zfrac))
        {
          zflagbot_s = 0.0;
        }
        if (((LSSOURCE_i*(model_.cjosti))<=zfrac))
        {
          zflagsti_s = 0.0;
        }
        if (((LGSOURCE_i*(model_.cjogat))<=zfrac))
        {
          zflaggat_s = 0.0;
        }
        if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
        {
          {
            double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR1_s+1e-21)));
            xhighf1_s = value_log_0;
          }
          {
            double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR2_s+1e-21)));
            xhighf2_s = value_log_0;
          }
          {
            double value_fabs_0 = fabs(ISATREV_s);
            double value_log_1 = log(((0.5*(model_.IMAX_i))/(value_fabs_0+1e-21)));
            xhighr_s = value_log_1;
          }
        }
        {
          double value_min_0 = std::min(xhighf1_s,static_cast<double>(2.3025850929940458e+02));
          xhighf1_s = value_min_0;
        }
        {
          double value_exp_0 = exp(xhighf1_s);
          expxhf1_s = value_exp_0;
        }
        {
          double value_min_0 = std::min(xhighf2_s,static_cast<double>(2.3025850929940458e+02));
          xhighf2_s = value_min_0;
        }
        {
          double value_exp_0 = exp(xhighf2_s);
          expxhf2_s = value_exp_0;
        }
        {
          double value_min_0 = std::min(xhighr_s,static_cast<double>(2.3025850929940458e+02));
          xhighr_s = value_min_0;
        }
        {
          double value_exp_0 = exp(xhighr_s);
          expxhr_s = value_exp_0;
        }
        FRACNA = 0.4;
        FRACNB = 0.65;
        FRACI = 0.8;
        V1 = ((-FRACNA)*(model_.VJUNREFD_i));
        V2 = ((-FRACNB)*(model_.VJUNREFD_i));
        V3 = ((-FRACI)*(model_.VJUNREFD_i));
        V4 = 0.1;
        V5 = 0.2;
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
        {
          h1 = ((4.0*vch_d)*vch_d);
          h2 = (vch_d/vfmin_d);
          h2d = (V1+(vch_d*h2));
          h3 = (vfmin_d+h2d);
          h4 = (vfmin_d-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V1*vfmin_d)/(h3+h5)));
          if ((V1<VMAX_d))
          {
            if ((fabs((0.5*(V1*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V1*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V1*(model_.phitdinv)))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V1-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V1>0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V1)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_d-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V1-vbbtlim_d)*(V1-vbbtlim_d))+((4*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V1+vbbtlim_d)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V1)*(V1))+((4*1E-6)*1E-6)));
            vav = (0.5*((V1)-value_sqrt_0));
          }
        }
        if ((ABDRAIN_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if (((model_.one_minus_PBOT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot_d)*(1-tmp))+((model_.qpref2bot_d)*(V1-vj)));
          id = ((model_.idsatbot_d)*idmult);
          if ((((model_.CSRHBOTD_i)==0)&&((model_.CTATBOTD_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PBOTD_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOTD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot_d)*tmp);
            asrh = ((model_.ftdbot_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOTD_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOTD_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
            if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOTD_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOTD_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRBOTD_i))))
            {
              if (((model_.PBRBOTD_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvbot_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot_d)+((vav+(0.999*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSDRAIN_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if (((model_.one_minus_PSTI_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti_d)*(1-tmp))+((model_.qpref2sti_d)*(V1-vj)));
          id = ((model_.idsatsti_d)*idmult);
          if ((((model_.CSRHSTID_i)==0)&&((model_.CTATSTID_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PSTID_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTID_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti_d)*tmp);
            asrh = ((model_.ftdsti_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTID_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTID_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
            if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTID_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTID_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRSTID_i))))
            {
              if (((model_.PBRSTID_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvsti_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti_d)+((vav+(0.999*(model_.VBRSTID_i)))*(model_.slopesti_d)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGDRAIN_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if (((model_.one_minus_PGAT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat_d)*(1-tmp))+((model_.qpref2gat_d)*(V1-vj)));
          id = ((model_.idsatgat_d)*idmult);
          if ((((model_.CSRHGATD_i)==0)&&((model_.CTATGATD_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PGATD_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGATD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat_d)*tmp);
            asrh = ((model_.ftdgat_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
          }
          if (((model_.CTATGATD_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGATD_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
            if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGATD_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGATD_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRGATD_i))))
            {
              if (((model_.PBRGATD_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvgat_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat_d)+((vav+(0.999*(model_.VBRGATD_i)))*(model_.slopegat_d)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I1 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
        {
          h1 = ((4.0*vch_d)*vch_d);
          h2 = (vch_d/vfmin_d);
          h2d = (V2+(vch_d*h2));
          h3 = (vfmin_d+h2d);
          h4 = (vfmin_d-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V2*vfmin_d)/(h3+h5)));
          if ((V2<VMAX_d))
          {
            if ((fabs((0.5*(V2*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V2*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V2*(model_.phitdinv)))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V2-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V2>0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V2)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_d-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V2-vbbtlim_d)*(V2-vbbtlim_d))+((4*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V2+vbbtlim_d)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V2)*(V2))+((4*1E-6)*1E-6)));
            vav = (0.5*((V2)-value_sqrt_0));
          }
        }
        if ((ABDRAIN_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if (((model_.one_minus_PBOT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot_d)*(1-tmp))+((model_.qpref2bot_d)*(V2-vj)));
          id = ((model_.idsatbot_d)*idmult);
          if ((((model_.CSRHBOTD_i)==0)&&((model_.CTATBOTD_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PBOTD_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOTD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot_d)*tmp);
            asrh = ((model_.ftdbot_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOTD_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOTD_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
            if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOTD_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOTD_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRBOTD_i))))
            {
              if (((model_.PBRBOTD_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvbot_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot_d)+((vav+(0.999*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSDRAIN_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if (((model_.one_minus_PSTI_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti_d)*(1-tmp))+((model_.qpref2sti_d)*(V2-vj)));
          id = ((model_.idsatsti_d)*idmult);
          if ((((model_.CSRHSTID_i)==0)&&((model_.CTATSTID_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PSTID_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTID_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti_d)*tmp);
            asrh = ((model_.ftdsti_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTID_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTID_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
            if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTID_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTID_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRSTID_i))))
            {
              if (((model_.PBRSTID_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvsti_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti_d)+((vav+(0.999*(model_.VBRSTID_i)))*(model_.slopesti_d)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGDRAIN_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if (((model_.one_minus_PGAT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat_d)*(1-tmp))+((model_.qpref2gat_d)*(V2-vj)));
          id = ((model_.idsatgat_d)*idmult);
          if ((((model_.CSRHGATD_i)==0)&&((model_.CTATGATD_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PGATD_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGATD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat_d)*tmp);
            asrh = ((model_.ftdgat_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
          }
          if (((model_.CTATGATD_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGATD_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
            if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGATD_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGATD_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRGATD_i))))
            {
              if (((model_.PBRGATD_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvgat_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat_d)+((vav+(0.999*(model_.VBRGATD_i)))*(model_.slopegat_d)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I2 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
        {
          h1 = ((4.0*vch_d)*vch_d);
          h2 = (vch_d/vfmin_d);
          h2d = (V3+(vch_d*h2));
          h3 = (vfmin_d+h2d);
          h4 = (vfmin_d-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V3*vfmin_d)/(h3+h5)));
          if ((V3<VMAX_d))
          {
            if ((fabs((0.5*(V3*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V3*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V3*(model_.phitdinv)))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V3-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V3>0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V3)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_d-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V3-vbbtlim_d)*(V3-vbbtlim_d))+((4*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V3+vbbtlim_d)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V3)*(V3))+((4*1E-6)*1E-6)));
            vav = (0.5*((V3)-value_sqrt_0));
          }
        }
        if ((ABDRAIN_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if (((model_.one_minus_PBOT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot_d)*(1-tmp))+((model_.qpref2bot_d)*(V3-vj)));
          id = ((model_.idsatbot_d)*idmult);
          if ((((model_.CSRHBOTD_i)==0)&&((model_.CTATBOTD_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PBOTD_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOTD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot_d)*tmp);
            asrh = ((model_.ftdbot_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOTD_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOTD_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
            if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOTD_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOTD_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRBOTD_i))))
            {
              if (((model_.PBRBOTD_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvbot_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot_d)+((vav+(0.999*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSDRAIN_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if (((model_.one_minus_PSTI_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti_d)*(1-tmp))+((model_.qpref2sti_d)*(V3-vj)));
          id = ((model_.idsatsti_d)*idmult);
          if ((((model_.CSRHSTID_i)==0)&&((model_.CTATSTID_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PSTID_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTID_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti_d)*tmp);
            asrh = ((model_.ftdsti_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTID_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTID_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
            if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTID_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTID_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRSTID_i))))
            {
              if (((model_.PBRSTID_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvsti_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti_d)+((vav+(0.999*(model_.VBRSTID_i)))*(model_.slopesti_d)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGDRAIN_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if (((model_.one_minus_PGAT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat_d)*(1-tmp))+((model_.qpref2gat_d)*(V3-vj)));
          id = ((model_.idsatgat_d)*idmult);
          if ((((model_.CSRHGATD_i)==0)&&((model_.CTATGATD_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PGATD_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGATD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat_d)*tmp);
            asrh = ((model_.ftdgat_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
          }
          if (((model_.CTATGATD_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGATD_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
            if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGATD_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGATD_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRGATD_i))))
            {
              if (((model_.PBRGATD_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvgat_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat_d)+((vav+(0.999*(model_.VBRGATD_i)))*(model_.slopegat_d)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I3 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
        {
          h1 = ((4.0*vch_d)*vch_d);
          h2 = (vch_d/vfmin_d);
          h2d = (V4+(vch_d*h2));
          h3 = (vfmin_d+h2d);
          h4 = (vfmin_d-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V4*vfmin_d)/(h3+h5)));
          if ((V4<VMAX_d))
          {
            if ((fabs((0.5*(V4*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V4*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V4*(model_.phitdinv)))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V4-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V4>0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V4)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_d-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V4-vbbtlim_d)*(V4-vbbtlim_d))+((4*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V4+vbbtlim_d)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V4)*(V4))+((4*1E-6)*1E-6)));
            vav = (0.5*((V4)-value_sqrt_0));
          }
        }
        if ((ABDRAIN_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if (((model_.one_minus_PBOT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot_d)*(1-tmp))+((model_.qpref2bot_d)*(V4-vj)));
          id = ((model_.idsatbot_d)*idmult);
          if ((((model_.CSRHBOTD_i)==0)&&((model_.CTATBOTD_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PBOTD_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOTD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot_d)*tmp);
            asrh = ((model_.ftdbot_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOTD_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOTD_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
            if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOTD_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOTD_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRBOTD_i))))
            {
              if (((model_.PBRBOTD_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvbot_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot_d)+((vav+(0.999*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSDRAIN_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if (((model_.one_minus_PSTI_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti_d)*(1-tmp))+((model_.qpref2sti_d)*(V4-vj)));
          id = ((model_.idsatsti_d)*idmult);
          if ((((model_.CSRHSTID_i)==0)&&((model_.CTATSTID_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PSTID_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTID_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti_d)*tmp);
            asrh = ((model_.ftdsti_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTID_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTID_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
            if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTID_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTID_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRSTID_i))))
            {
              if (((model_.PBRSTID_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvsti_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti_d)+((vav+(0.999*(model_.VBRSTID_i)))*(model_.slopesti_d)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGDRAIN_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if (((model_.one_minus_PGAT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat_d)*(1-tmp))+((model_.qpref2gat_d)*(V4-vj)));
          id = ((model_.idsatgat_d)*idmult);
          if ((((model_.CSRHGATD_i)==0)&&((model_.CTATGATD_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PGATD_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGATD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat_d)*tmp);
            asrh = ((model_.ftdgat_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
          }
          if (((model_.CTATGATD_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGATD_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
            if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGATD_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGATD_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRGATD_i))))
            {
              if (((model_.PBRGATD_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvgat_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat_d)+((vav+(0.999*(model_.VBRGATD_i)))*(model_.slopegat_d)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I4 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
        {
          h1 = ((4.0*vch_d)*vch_d);
          h2 = (vch_d/vfmin_d);
          h2d = (V5+(vch_d*h2));
          h3 = (vfmin_d+h2d);
          h4 = (vfmin_d-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V5*vfmin_d)/(h3+h5)));
          if ((V5<VMAX_d))
          {
            if ((fabs((0.5*(V5*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V5*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V5*(model_.phitdinv)))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V5-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V5>0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V5)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_d-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V5-vbbtlim_d)*(V5-vbbtlim_d))+((4*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V5+vbbtlim_d)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V5)*(V5))+((4*1E-6)*1E-6)));
            vav = (0.5*((V5)-value_sqrt_0));
          }
        }
        if ((ABDRAIN_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if (((model_.one_minus_PBOT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot_d)*(1-tmp))+((model_.qpref2bot_d)*(V5-vj)));
          id = ((model_.idsatbot_d)*idmult);
          if ((((model_.CSRHBOTD_i)==0)&&((model_.CTATBOTD_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PBOTD_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOTD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot_d)*tmp);
            asrh = ((model_.ftdbot_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOTD_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOTD_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
            if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOTD_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOTD_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRBOTD_i))))
            {
              if (((model_.PBRBOTD_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvbot_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot_d)+((vav+(0.999*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSDRAIN_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if (((model_.one_minus_PSTI_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti_d)*(1-tmp))+((model_.qpref2sti_d)*(V5-vj)));
          id = ((model_.idsatsti_d)*idmult);
          if ((((model_.CSRHSTID_i)==0)&&((model_.CTATSTID_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PSTID_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTID_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti_d)*tmp);
            asrh = ((model_.ftdsti_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTID_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTID_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
            if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTID_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTID_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRSTID_i))))
            {
              if (((model_.PBRSTID_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvsti_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti_d)+((vav+(0.999*(model_.VBRSTID_i)))*(model_.slopesti_d)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGDRAIN_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if (((model_.one_minus_PGAT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat_d)*(1-tmp))+((model_.qpref2gat_d)*(V5-vj)));
          id = ((model_.idsatgat_d)*idmult);
          if ((((model_.CSRHGATD_i)==0)&&((model_.CTATGATD_i)==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if (((model_.PGATD_i)==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGATD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat_d)*tmp);
            asrh = ((model_.ftdgat_d)*((zinv-1)*wdep));
            isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
          }
          if (((model_.CTATGATD_i)==0))
          {
            itat = 0;
          }
          else
          {
            btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1/(1-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGATD_i)==0))
          {
            ibbt = 0;
          }
          else
          {
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
            if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat_d))/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGATD_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGATD_i)>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*(model_.VBRGATD_i))))
            {
              if (((model_.PBRGATD_i)==4))
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_1 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_2 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_fabs_3 = fabs((vav*(model_.VBRinvgat_d)));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat_d)+((vav+(0.999*(model_.VBRGATD_i)))*(model_.slopegat_d)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I5 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
        ISATFOR1_d = (((ABDRAIN_i*(model_.idsatbot_d))+(LSDRAIN_i*(model_.idsatsti_d)))+(LGDRAIN_i*(model_.idsatgat_d)));
        {
          double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR1_d));
          I4_cor = (I4-(ISATFOR1_d*(value_exp_0-1.0)));
        }
        {
          double value_exp_0 = exp(((V5*(model_.phitdinv))*MFOR1_d));
          I5_cor = (I5-(ISATFOR1_d*(value_exp_0-1.0)));
        }
        if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
        {
          if (((I4>0)&&(I5>0)))
          {
            if ((((((I4_cor/I4)>0.001)||((I5_cor/I5)>0.001))&&(I4_cor>0))&&(I5_cor>0)))
            {
              alphaje = (I4_cor/I5_cor);
              {
                double value_log_0 = log(alphaje);
                MFOR2_d = (((model_.phitd)*value_log_0)/(V4-V5));
              }
              {
                double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR2_d));
                ISATFOR2_d = (I4_cor/(value_exp_0-1));
              }
            }
          }
          {
            double value_exp_0 = exp(((V1*(model_.phitdinv))*MFOR1_d));
            double value_exp_1 = exp(((V1*(model_.phitdinv))*MFOR2_d));
            I1_cor = ((I1-(ISATFOR1_d*(value_exp_0-1.0)))-(ISATFOR2_d*(value_exp_1-1.0)));
          }
          {
            double value_exp_0 = exp(((V2*(model_.phitdinv))*MFOR1_d));
            double value_exp_1 = exp(((V2*(model_.phitdinv))*MFOR2_d));
            I2_cor = ((I2-(ISATFOR1_d*(value_exp_0-1.0)))-(ISATFOR2_d*(value_exp_1-1.0)));
          }
          {
            double value_exp_0 = exp(((V3*(model_.phitdinv))*MFOR1_d));
            double value_exp_1 = exp(((V3*(model_.phitdinv))*MFOR2_d));
            I3_cor = ((I3-(ISATFOR1_d*(value_exp_0-1.0)))-(ISATFOR2_d*(value_exp_1-1.0)));
          }
          if ((((I1<0)&&(I2<0))&&(I3<0)))
          {
            if ((((((((I1_cor/I1)>0.001)||((I2_cor/I2)>0.001))||((I3_cor/I3)>0.001))&&(I1_cor<0))&&(I2_cor<0))&&(I3_cor<0)))
            {
              alphaje = (I1_cor/I2_cor);
              {
                double value_log_0 = log(alphaje);
                m0_rev = (((-(model_.phitd))*value_log_0)/(V1-V2));
              }
              tt0 = (V2/(V2-V1));
              {
                double value_pow_0 = pow(alphaje,tt0);
                tt1 = (((model_.phitd)*(alphaje-1))*(value_pow_0-1));
              }
              tt0 = (V1/(V1-V2));
              {
                double value_pow_0 = pow(alphaje,tt0);
                tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
              }
              mcor_rev = (tt1/tt2);
              MREV_d = (m0_rev+mcor_rev);
              if ((fabs(((V3*(model_.phitdinv))*MREV_d))<1e-6))
              {
                m0flag_d = 1.0;
                ISATREV_d = (I3_cor*((1/V3)+((0.5*(model_.phitdinv))*MREV_d)));
                MREV_d = (((((-0.5)*I3_cor)*MREV_d)*(model_.phitdinv))/V3);
              }
              else
              {
                m0flag_d = 0.0;
                {
                  double value_exp_0 = exp((((-V3)*(model_.phitdinv))*MREV_d));
                  ISATREV_d = ((-I3_cor)/(value_exp_0-1));
                }
              }
            }
          }
        }
        zfrac = ((model_.FJUNQD_i)*(((ABDRAIN_i*(model_.cjobot_d))+(LSDRAIN_i*(model_.cjosti_d)))+(LGDRAIN_i*(model_.cjogat_d))));
        if (((ABDRAIN_i*(model_.cjobot_d))<=zfrac))
        {
          zflagbot_d = 0.0;
        }
        if (((LSDRAIN_i*(model_.cjosti_d))<=zfrac))
        {
          zflagsti_d = 0.0;
        }
        if (((LGDRAIN_i*(model_.cjogat_d))<=zfrac))
        {
          zflaggat_d = 0.0;
        }
        if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
        {
          {
            double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR1_d+1e-21)));
            xhighf1_d = value_log_0;
          }
          {
            double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR2_d+1e-21)));
            xhighf2_d = value_log_0;
          }
          {
            double value_fabs_0 = fabs(ISATREV_d);
            double value_log_1 = log(((0.5*(model_.IMAX_i))/(value_fabs_0+1e-21)));
            xhighr_d = value_log_1;
          }
        }
        {
          double value_min_0 = std::min(xhighf1_d,static_cast<double>(2.3025850929940458e+02));
          xhighf1_d = value_min_0;
        }
        {
          double value_exp_0 = exp(xhighf1_d);
          expxhf1_d = value_exp_0;
        }
        {
          double value_min_0 = std::min(xhighf2_d,static_cast<double>(2.3025850929940458e+02));
          xhighf2_d = value_min_0;
        }
        {
          double value_exp_0 = exp(xhighf2_d);
          expxhf2_d = value_exp_0;
        }
        {
          double value_min_0 = std::min(xhighr_d,static_cast<double>(2.3025850929940458e+02));
          xhighr_d = value_min_0;
        }
        {
          double value_exp_0 = exp(xhighr_d);
          expxhr_d = value_exp_0;
        }
      }
      // End block JUNCAPexpressInit
    }
  }
  // End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    L(10e-6),
    W(10e-6),
    SA(0.0),
    SB(0.0),
    SD(0.0),
    SCA(0.0),
    SCB(0.0),
    SCC(0.0),
    SC(0.0),
    DELVTO(0.0),
    FACTUO(1.0),
    ABSOURCE(1E-12),
    LSSOURCE(1E-6),
    LGSOURCE(1E-6),
    ABDRAIN(1E-12),
    LSDRAIN(1E-6),
    LGDRAIN(1E-6),
    AS(1E-12),
    PS(1E-6),
    AD(1E-12),
    PD(1E-6),
    MULT(1.0),
    NF(1.0),
    NGCON(1.0),
    XGW(1.0E-7),
    VFB_i(0.0),
    VNSUB_i(0.0),
    NSLP_i(0.0),
    DNSUB_i(0.0),
    CF_i(0.0),
    CFB_i(0.0),
    MUE_i(0.0),
    THEMU_i(0.0),
    CS_i(0.0),
    XCOR_i(0.0),
    THER_i(0.0),
    RSB_i(0.0),
    RSG_i(0.0),
    THESAT_i(0.0),
    THESATB_i(0.0),
    THESATG_i(0.0),
    AX_i(0.0),
    ALP_i(0.0),
    ALP1_i(0.0),
    ALP2_i(0.0),
    A1_i(0.0),
    A2_i(0.0),
    A3_i(0.0),
    A4_i(0.0),
    IGINV_i(0.0),
    IGOV_i(0.0),
    IGOVD_i(0.0),
    GC2_i(0.0),
    GC3_i(0.0),
    CHIB_i(0.0),
    AGIDL_i(0.0),
    CGIDL_i(0.0),
    AGIDLD_i(0.0),
    CGIDLD_i(0.0),
    COX_i(0.0),
    CGOV_i(0.0),
    CGOVD_i(0.0),
    CGBOV_i(0.0),
    CFR_i(0.0),
    CFRD_i(0.0),
    NFA_i(0.0),
    NFB_i(0.0),
    NFC_i(0.0),
    EF_i(0.0),
    FNTEXC_i(0.0),
    MULT_i(0.0),
    BET_i(0.0),
    kp(0.0),
    qq(0.0),
    qlim2(0.0),
    E_eff0(0.0),
    eta_mu(0.0),
    BCH(0.0),
    BOV(0.0),
    inv_CHIB(0.0),
    GCQ(0.0),
    Dch(0.0),
    Dov(0.0),
    x1(0.0),
    Vdsat_lim(0.0),
    nt(0.0),
    Cox_over_q(0.0),
    GOV_s(0.0),
    GOV_d(0.0),
    GOV2_s(0.0),
    GOV2_d(0.0),
    BOV_d(0.0),
    xi_ov_s(0.0),
    xi_ov_d(0.0),
    inv_xi_ov_s(0.0),
    inv_xi_ov_d(0.0),
    x_mrg_ov_s(0.0),
    x_mrg_ov_d(0.0),
    inv_xg1_s(0.0),
    inv_xg1_d(0.0),
    AGIDLs(0.0),
    AGIDLDs(0.0),
    BGIDLs(0.0),
    BGIDLDs(0.0),
    phib(0.0),
    sqrt_phib(0.0),
    phix(0.0),
    aphi(0.0),
    bphi(0.0),
    phix1(0.0),
    G_0(0.0),
    phit1(0.0),
    inv_phit1(0.0),
    alpha_b(0.0),
    inv_VP(0.0),
    inv_AX(0.0),
    Sfl_prefac(0.0),
    fac_exc(0.0),
    RG_i(0.0),
    RBULK_i(0.0),
    RWELL_i(0.0),
    RJUNS_i(0.0),
    RJUND_i(0.0),
    ggate(0.0),
    gbulk(0.0),
    gwell(0.0),
    gjund(0.0),
    gjuns(0.0),
    ABSOURCE_i(0.0),
    LSSOURCE_i(0.0),
    LGSOURCE_i(0.0),
    zflagbot_s(0.0),
    zflagsti_s(0.0),
    zflaggat_s(0.0),
    VMAX_s(0.0),
    exp_VMAX_over_phitd_s(0.0),
    vbimin_s(0.0),
    vch_s(0.0),
    vfmin_s(0.0),
    vbbtlim_s(0.0),
    xhighf1_s(0.0),
    expxhf1_s(0.0),
    xhighf2_s(0.0),
    expxhf2_s(0.0),
    xhighr_s(0.0),
    expxhr_s(0.0),
    m0flag_s(0.0),
    ISATFOR1_s(0.0),
    MFOR1_s(0.0),
    ISATFOR2_s(0.0),
    MFOR2_s(0.0),
    ISATREV_s(0.0),
    MREV_s(0.0),
    ABDRAIN_i(0.0),
    LSDRAIN_i(0.0),
    LGDRAIN_i(0.0),
    zflagbot_d(0.0),
    zflagsti_d(0.0),
    zflaggat_d(0.0),
    VMAX_d(0.0),
    exp_VMAX_over_phitd_d(0.0),
    vbimin_d(0.0),
    vch_d(0.0),
    vfmin_d(0.0),
    vbbtlim_d(0.0),
    xhighf1_d(0.0),
    expxhf1_d(0.0),
    xhighf2_d(0.0),
    expxhf2_d(0.0),
    xhighr_d(0.0),
    expxhr_d(0.0),
    m0flag_d(0.0),
    ISATFOR1_d(0.0),
    MFOR1_d(0.0),
    ISATFOR2_d(0.0),
    MFOR2_d(0.0),
    ISATREV_d(0.0),
    MREV_d(0.0),
    li_D(-1),
    li_G(-1),
    li_S(-1),
    li_B(-1),
    li_NOI(-1),
    li_NOI2(-1),
    li_GP(-1),
    li_BP(-1),
    li_BI(-1),
    li_BS(-1),
    li_BD(-1),
    li_branch_iD(-1),
    li_branch_iG(-1),
    li_branch_iS(-1),
    li_branch_iB(-1),
    f_D_Equ_S_Node_Ptr(0),
    f_D_Equ_BP_Node_Ptr(0),
    f_BP_Equ_S_Node_Ptr(0),
    f_BP_Equ_BP_Node_Ptr(0),
    f_D_Equ_D_Node_Ptr(0),
    f_BP_Equ_D_Node_Ptr(0),
    f_D_Equ_GP_Node_Ptr(0),
    f_BP_Equ_GP_Node_Ptr(0),
    f_S_Equ_S_Node_Ptr(0),
    f_S_Equ_BP_Node_Ptr(0),
    f_S_Equ_D_Node_Ptr(0),
    f_S_Equ_GP_Node_Ptr(0),
    f_GP_Equ_S_Node_Ptr(0),
    f_GP_Equ_BP_Node_Ptr(0),
    f_GP_Equ_D_Node_Ptr(0),
    f_GP_Equ_GP_Node_Ptr(0),
    f_BS_Equ_S_Node_Ptr(0),
    f_BS_Equ_BS_Node_Ptr(0),
    f_S_Equ_BS_Node_Ptr(0),
    f_BS_Equ_D_Node_Ptr(0),
    f_BS_Equ_BD_Node_Ptr(0),
    f_S_Equ_BD_Node_Ptr(0),
    f_BD_Equ_S_Node_Ptr(0),
    f_BD_Equ_BS_Node_Ptr(0),
    f_D_Equ_BS_Node_Ptr(0),
    f_BD_Equ_D_Node_Ptr(0),
    f_BD_Equ_BD_Node_Ptr(0),
    f_D_Equ_BD_Node_Ptr(0),
    f_G_Equ_G_Node_Ptr(0),
    f_G_Equ_GP_Node_Ptr(0),
    f_GP_Equ_G_Node_Ptr(0),
    f_BP_Equ_BI_Node_Ptr(0),
    f_BI_Equ_BP_Node_Ptr(0),
    f_BI_Equ_BI_Node_Ptr(0),
    f_BS_Equ_BI_Node_Ptr(0),
    f_BI_Equ_BS_Node_Ptr(0),
    f_BD_Equ_BI_Node_Ptr(0),
    f_BI_Equ_BD_Node_Ptr(0),
    f_B_Equ_B_Node_Ptr(0),
    f_B_Equ_BI_Node_Ptr(0),
    f_BI_Equ_B_Node_Ptr(0),
    f_NOI2_Equ_NOI2_Node_Ptr(0),
    f_NOI2_Equ_S_Node_Ptr(0),
    f_NOI2_Equ_BP_Node_Ptr(0),
    f_NOI2_Equ_GP_Node_Ptr(0),
    f_NOI2_Equ_D_Node_Ptr(0),
    f_NOI_Equ_S_Node_Ptr(0),
    f_NOI_Equ_BP_Node_Ptr(0),
    f_NOI_Equ_GP_Node_Ptr(0),
    f_NOI_Equ_D_Node_Ptr(0),
    f_NOI_Equ_NOI2_Node_Ptr(0),
    f_NOI_Equ_NOI_Node_Ptr(0),
    f_D_Equ_NOI2_Node_Ptr(0),
    f_S_Equ_NOI2_Node_Ptr(0),
    f_GP_Equ_NOI_Node_Ptr(0),
    f_S_Equ_NOI_Node_Ptr(0),
    f_D_Equ_NOI_Node_Ptr(0),
    f_BS_Equ_BP_Node_Ptr(0),
    f_BS_Equ_GP_Node_Ptr(0),
    f_BD_Equ_BP_Node_Ptr(0),
    f_BD_Equ_GP_Node_Ptr(0),
    q_D_Equ_S_Node_Ptr(0),
    q_D_Equ_BP_Node_Ptr(0),
    q_BP_Equ_S_Node_Ptr(0),
    q_BP_Equ_BP_Node_Ptr(0),
    q_D_Equ_D_Node_Ptr(0),
    q_BP_Equ_D_Node_Ptr(0),
    q_D_Equ_GP_Node_Ptr(0),
    q_BP_Equ_GP_Node_Ptr(0),
    q_S_Equ_S_Node_Ptr(0),
    q_S_Equ_BP_Node_Ptr(0),
    q_S_Equ_D_Node_Ptr(0),
    q_S_Equ_GP_Node_Ptr(0),
    q_GP_Equ_S_Node_Ptr(0),
    q_GP_Equ_BP_Node_Ptr(0),
    q_GP_Equ_D_Node_Ptr(0),
    q_GP_Equ_GP_Node_Ptr(0),
    q_BS_Equ_S_Node_Ptr(0),
    q_BS_Equ_BS_Node_Ptr(0),
    q_S_Equ_BS_Node_Ptr(0),
    q_BS_Equ_D_Node_Ptr(0),
    q_BS_Equ_BD_Node_Ptr(0),
    q_S_Equ_BD_Node_Ptr(0),
    q_BD_Equ_S_Node_Ptr(0),
    q_BD_Equ_BS_Node_Ptr(0),
    q_D_Equ_BS_Node_Ptr(0),
    q_BD_Equ_D_Node_Ptr(0),
    q_BD_Equ_BD_Node_Ptr(0),
    q_D_Equ_BD_Node_Ptr(0),
    q_G_Equ_G_Node_Ptr(0),
    q_G_Equ_GP_Node_Ptr(0),
    q_GP_Equ_G_Node_Ptr(0),
    q_BP_Equ_BI_Node_Ptr(0),
    q_BI_Equ_BP_Node_Ptr(0),
    q_BI_Equ_BI_Node_Ptr(0),
    q_BS_Equ_BI_Node_Ptr(0),
    q_BI_Equ_BS_Node_Ptr(0),
    q_BD_Equ_BI_Node_Ptr(0),
    q_BI_Equ_BD_Node_Ptr(0),
    q_B_Equ_B_Node_Ptr(0),
    q_B_Equ_BI_Node_Ptr(0),
    q_BI_Equ_B_Node_Ptr(0),
    q_NOI2_Equ_NOI2_Node_Ptr(0),
    q_NOI2_Equ_S_Node_Ptr(0),
    q_NOI2_Equ_BP_Node_Ptr(0),
    q_NOI2_Equ_GP_Node_Ptr(0),
    q_NOI2_Equ_D_Node_Ptr(0),
    q_NOI_Equ_S_Node_Ptr(0),
    q_NOI_Equ_BP_Node_Ptr(0),
    q_NOI_Equ_GP_Node_Ptr(0),
    q_NOI_Equ_D_Node_Ptr(0),
    q_NOI_Equ_NOI2_Node_Ptr(0),
    q_NOI_Equ_NOI_Node_Ptr(0),
    q_D_Equ_NOI2_Node_Ptr(0),
    q_S_Equ_NOI2_Node_Ptr(0),
    q_GP_Equ_NOI_Node_Ptr(0),
    q_S_Equ_NOI_Node_Ptr(0),
    q_D_Equ_NOI_Node_Ptr(0),
    q_BS_Equ_BP_Node_Ptr(0),
    q_BS_Equ_GP_Node_Ptr(0),
    q_BD_Equ_BP_Node_Ptr(0),
    q_BD_Equ_GP_Node_Ptr(0),
    A_D_Equ_S_NodeOffset(-1),
    A_D_Equ_BP_NodeOffset(-1),
    A_BP_Equ_S_NodeOffset(-1),
    A_BP_Equ_BP_NodeOffset(-1),
    A_D_Equ_D_NodeOffset(-1),
    A_BP_Equ_D_NodeOffset(-1),
    A_D_Equ_GP_NodeOffset(-1),
    A_BP_Equ_GP_NodeOffset(-1),
    A_S_Equ_S_NodeOffset(-1),
    A_S_Equ_BP_NodeOffset(-1),
    A_S_Equ_D_NodeOffset(-1),
    A_S_Equ_GP_NodeOffset(-1),
    A_GP_Equ_S_NodeOffset(-1),
    A_GP_Equ_BP_NodeOffset(-1),
    A_GP_Equ_D_NodeOffset(-1),
    A_GP_Equ_GP_NodeOffset(-1),
    A_BS_Equ_S_NodeOffset(-1),
    A_BS_Equ_BS_NodeOffset(-1),
    A_S_Equ_BS_NodeOffset(-1),
    A_BS_Equ_D_NodeOffset(-1),
    A_BS_Equ_BD_NodeOffset(-1),
    A_S_Equ_BD_NodeOffset(-1),
    A_BD_Equ_S_NodeOffset(-1),
    A_BD_Equ_BS_NodeOffset(-1),
    A_D_Equ_BS_NodeOffset(-1),
    A_BD_Equ_D_NodeOffset(-1),
    A_BD_Equ_BD_NodeOffset(-1),
    A_D_Equ_BD_NodeOffset(-1),
    A_G_Equ_G_NodeOffset(-1),
    A_G_Equ_GP_NodeOffset(-1),
    A_GP_Equ_G_NodeOffset(-1),
    A_BP_Equ_BI_NodeOffset(-1),
    A_BI_Equ_BP_NodeOffset(-1),
    A_BI_Equ_BI_NodeOffset(-1),
    A_BS_Equ_BI_NodeOffset(-1),
    A_BI_Equ_BS_NodeOffset(-1),
    A_BD_Equ_BI_NodeOffset(-1),
    A_BI_Equ_BD_NodeOffset(-1),
    A_B_Equ_B_NodeOffset(-1),
    A_B_Equ_BI_NodeOffset(-1),
    A_BI_Equ_B_NodeOffset(-1),
    A_NOI2_Equ_NOI2_NodeOffset(-1),
    A_NOI2_Equ_S_NodeOffset(-1),
    A_NOI2_Equ_BP_NodeOffset(-1),
    A_NOI2_Equ_GP_NodeOffset(-1),
    A_NOI2_Equ_D_NodeOffset(-1),
    A_NOI_Equ_S_NodeOffset(-1),
    A_NOI_Equ_BP_NodeOffset(-1),
    A_NOI_Equ_GP_NodeOffset(-1),
    A_NOI_Equ_D_NodeOffset(-1),
    A_NOI_Equ_NOI2_NodeOffset(-1),
    A_NOI_Equ_NOI_NodeOffset(-1),
    A_D_Equ_NOI2_NodeOffset(-1),
    A_S_Equ_NOI2_NodeOffset(-1),
    A_GP_Equ_NOI_NodeOffset(-1),
    A_S_Equ_NOI_NodeOffset(-1),
    A_D_Equ_NOI_NodeOffset(-1),
    A_BS_Equ_BP_NodeOffset(-1),
    A_BS_Equ_GP_NodeOffset(-1),
    A_BD_Equ_BP_NodeOffset(-1),
    A_BD_Equ_GP_NodeOffset(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
  numIntVars = 7 + 0;
  numExtVars = 4;


  // Right now, we only have store for limited probes...
  setNumStoreVars(0);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 4;

  leadCurrentF.resize(4);
  leadCurrentQ.resize(4);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_S));
  jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_D));
  jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_BS));
  jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_BD));
  jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_NOI2));
  jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_NOI));
  jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_G));
  jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_S));
  jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_D));
  jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_BS));
  jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_BD));
  jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_NOI2));
  jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_NOI));
  jacobianElements.push_back(IntPair(admsNodeID_B,admsNodeID_B));
  jacobianElements.push_back(IntPair(admsNodeID_B,admsNodeID_BI));
  jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_S));
  jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_D));
  jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_NOI2));
  jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_NOI));
  jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_NOI2));
  jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_S));
  jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_D));
  jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_S));
  jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_D));
  jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_G));
  jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_NOI));
  jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_S));
  jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_D));
  jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_BI));
  jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BI));
  jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BS));
  jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BD));
  jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_B));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_S));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BS));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_D));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BD));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BI));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_S));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BS));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_D));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BD));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BI));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_GP));



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_GP)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_GP,admsNodeID_G));
  }
  if (collapseNode_BP)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_BP,admsNodeID_BI));
  }
  if (collapseNode_BI)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_BI,admsNodeID_B));
  }
  if (collapseNode_BS)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_BS,admsNodeID_BI));
  }
  if (collapseNode_BD)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_BD,admsNodeID_BI));
  }

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 11+0;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
  collapseNode_GP = false;
  collapseNode_BP = false;
  collapseNode_BI = false;
  collapseNode_BS = false;
  collapseNode_BD = false;
  // begin block named evaluateblock

  // begin block named loadStatic

  if (!((RG_i>0.0)))
  {

    collapseNode_GP = true;

  }

  if (!((RBULK_i>0.0)))
  {

    collapseNode_BP = true;

  }

  if (!((RJUNS_i>0.0)))
  {

    collapseNode_BS = true;

  }

  if (!((RJUND_i>0.0)))
  {

    collapseNode_BD = true;

  }

  if (!((RWELL_i>0.0)))
  {

    collapseNode_BI = true;

  }

  // end block  named loadStatic

  // end block  named evaluateblock


  if (collapseNode_GP)
  {
    numIntVars--;
  }
  if (collapseNode_BP)
  {
    numIntVars--;
  }
  if (collapseNode_BI)
  {
    numIntVars--;
  }
  if (collapseNode_BS)
  {
    numIntVars--;
  }
  if (collapseNode_BD)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSPSP102VA::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_D = localLIDVec[nodeMap[admsNodeID_D]];
  li_G = localLIDVec[nodeMap[admsNodeID_G]];
  li_S = localLIDVec[nodeMap[admsNodeID_S]];
  li_B = localLIDVec[nodeMap[admsNodeID_B]];
  li_NOI = localLIDVec[nodeMap[admsNodeID_NOI]];
  li_NOI2 = localLIDVec[nodeMap[admsNodeID_NOI2]];
  li_GP = localLIDVec[nodeMap[admsNodeID_GP]];
  li_BP = localLIDVec[nodeMap[admsNodeID_BP]];
  li_BI = localLIDVec[nodeMap[admsNodeID_BI]];
  li_BS = localLIDVec[nodeMap[admsNodeID_BS]];
  li_BD = localLIDVec[nodeMap[admsNodeID_BD]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_D = " << li_D << std::endl;
    Xyce::dout() << "\nli_G = " << li_G << std::endl;
    Xyce::dout() << "\nli_S = " << li_S << std::endl;
    Xyce::dout() << "\nli_B = " << li_B << std::endl;
    Xyce::dout() << "\nli_NOI = " << li_NOI << std::endl;
    Xyce::dout() << "\nli_NOI2 = " << li_NOI2 << std::endl;
    Xyce::dout() << "\nli_GP = " << li_GP << std::endl;
    Xyce::dout() << "\nli_BP = " << li_BP << std::endl;
    Xyce::dout() << "\nli_BI = " << li_BI << std::endl;
    Xyce::dout() << "\nli_BS = " << li_BS << std::endl;
    Xyce::dout() << "\nli_BD = " << li_BD << std::endl;

    Xyce::dout() << "\nEnd of ADMSPSP102VA::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
  addInternalNode(symbol_table, li_NOI, getName(), "NOI");
  addInternalNode(symbol_table, li_NOI2, getName(), "NOI2");
  if (!collapseNode_GP)
  {
    addInternalNode(symbol_table, li_GP, getName(), "GP");
  }
  if (!collapseNode_BP)
  {
    addInternalNode(symbol_table, li_BP, getName(), "BP");
  }
  if (!collapseNode_BI)
  {
    addInternalNode(symbol_table, li_BI, getName(), "BI");
  }
  if (!collapseNode_BS)
  {
    addInternalNode(symbol_table, li_BS, getName(), "BS");
  }
  if (!collapseNode_BD)
  {
    addInternalNode(symbol_table, li_BD, getName(), "BD");
  }

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_iD, getName(), "BRANCH_DD");
    addBranchDataNode( symbol_table, li_branch_iG, getName(), "BRANCH_DG");
    addBranchDataNode( symbol_table, li_branch_iS, getName(), "BRANCH_DS");
    addBranchDataNode( symbol_table, li_branch_iB, getName(), "BRANCH_D4");
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    int i = 0;
    li_branch_iD = branchLIDVecRef[i++];
    li_branch_iG = branchLIDVecRef[i++];
    li_branch_iS = branchLIDVecRef[i++];
    li_branch_iB = branchLIDVecRef[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_S)];
  A_D_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_BP)];
  A_D_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_D)];
  A_D_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_GP)];
  A_D_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_BS)];
  A_D_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_BD)];
  A_D_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_NOI2)];
  A_D_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_NOI)];
  A_D_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_G)];
  A_G_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_GP)];
  A_G_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_S)];
  A_S_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_BP)];
  A_S_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_D)];
  A_S_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_GP)];
  A_S_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_BS)];
  A_S_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_BD)];
  A_S_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_NOI2)];
  A_S_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_NOI)];
  A_S_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_B,admsNodeID_B)];
  A_B_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_B,admsNodeID_BI)];
  A_B_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_S)];
  A_NOI_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_BP)];
  A_NOI_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_GP)];
  A_NOI_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_D)];
  A_NOI_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_NOI2)];
  A_NOI_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_NOI)];
  A_NOI_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_NOI2)];
  A_NOI2_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_S)];
  A_NOI2_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_BP)];
  A_NOI2_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_GP)];
  A_NOI2_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_D)];
  A_NOI2_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_S)];
  A_GP_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_BP)];
  A_GP_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_D)];
  A_GP_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_GP)];
  A_GP_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_G)];
  A_GP_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_NOI)];
  A_GP_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_S)];
  A_BP_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_BP)];
  A_BP_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_D)];
  A_BP_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_GP)];
  A_BP_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_BI)];
  A_BP_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BP)];
  A_BI_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BI)];
  A_BI_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BS)];
  A_BI_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BD)];
  A_BI_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_B)];
  A_BI_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_S)];
  A_BS_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BS)];
  A_BS_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_D)];
  A_BS_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BD)];
  A_BS_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BI)];
  A_BS_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BP)];
  A_BS_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_GP)];
  A_BS_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_S)];
  A_BD_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BS)];
  A_BD_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_D)];
  A_BD_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BD)];
  A_BD_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BI)];
  A_BD_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BP)];
  A_BD_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_GP)];
  A_BD_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
  f_D_Equ_S_Node_Ptr = &(dFdx[li_D][A_D_Equ_S_NodeOffset]);
  q_D_Equ_S_Node_Ptr = &(dQdx[li_D][A_D_Equ_S_NodeOffset]);
  f_D_Equ_BP_Node_Ptr = &(dFdx[li_D][A_D_Equ_BP_NodeOffset]);
  q_D_Equ_BP_Node_Ptr = &(dQdx[li_D][A_D_Equ_BP_NodeOffset]);
  f_D_Equ_D_Node_Ptr = &(dFdx[li_D][A_D_Equ_D_NodeOffset]);
  q_D_Equ_D_Node_Ptr = &(dQdx[li_D][A_D_Equ_D_NodeOffset]);
  f_D_Equ_GP_Node_Ptr = &(dFdx[li_D][A_D_Equ_GP_NodeOffset]);
  q_D_Equ_GP_Node_Ptr = &(dQdx[li_D][A_D_Equ_GP_NodeOffset]);
  f_D_Equ_BS_Node_Ptr = &(dFdx[li_D][A_D_Equ_BS_NodeOffset]);
  q_D_Equ_BS_Node_Ptr = &(dQdx[li_D][A_D_Equ_BS_NodeOffset]);
  f_D_Equ_BD_Node_Ptr = &(dFdx[li_D][A_D_Equ_BD_NodeOffset]);
  q_D_Equ_BD_Node_Ptr = &(dQdx[li_D][A_D_Equ_BD_NodeOffset]);
  f_D_Equ_NOI2_Node_Ptr = &(dFdx[li_D][A_D_Equ_NOI2_NodeOffset]);
  q_D_Equ_NOI2_Node_Ptr = &(dQdx[li_D][A_D_Equ_NOI2_NodeOffset]);
  f_D_Equ_NOI_Node_Ptr = &(dFdx[li_D][A_D_Equ_NOI_NodeOffset]);
  q_D_Equ_NOI_Node_Ptr = &(dQdx[li_D][A_D_Equ_NOI_NodeOffset]);
  f_G_Equ_G_Node_Ptr = &(dFdx[li_G][A_G_Equ_G_NodeOffset]);
  q_G_Equ_G_Node_Ptr = &(dQdx[li_G][A_G_Equ_G_NodeOffset]);
  f_G_Equ_GP_Node_Ptr = &(dFdx[li_G][A_G_Equ_GP_NodeOffset]);
  q_G_Equ_GP_Node_Ptr = &(dQdx[li_G][A_G_Equ_GP_NodeOffset]);
  f_S_Equ_S_Node_Ptr = &(dFdx[li_S][A_S_Equ_S_NodeOffset]);
  q_S_Equ_S_Node_Ptr = &(dQdx[li_S][A_S_Equ_S_NodeOffset]);
  f_S_Equ_BP_Node_Ptr = &(dFdx[li_S][A_S_Equ_BP_NodeOffset]);
  q_S_Equ_BP_Node_Ptr = &(dQdx[li_S][A_S_Equ_BP_NodeOffset]);
  f_S_Equ_D_Node_Ptr = &(dFdx[li_S][A_S_Equ_D_NodeOffset]);
  q_S_Equ_D_Node_Ptr = &(dQdx[li_S][A_S_Equ_D_NodeOffset]);
  f_S_Equ_GP_Node_Ptr = &(dFdx[li_S][A_S_Equ_GP_NodeOffset]);
  q_S_Equ_GP_Node_Ptr = &(dQdx[li_S][A_S_Equ_GP_NodeOffset]);
  f_S_Equ_BS_Node_Ptr = &(dFdx[li_S][A_S_Equ_BS_NodeOffset]);
  q_S_Equ_BS_Node_Ptr = &(dQdx[li_S][A_S_Equ_BS_NodeOffset]);
  f_S_Equ_BD_Node_Ptr = &(dFdx[li_S][A_S_Equ_BD_NodeOffset]);
  q_S_Equ_BD_Node_Ptr = &(dQdx[li_S][A_S_Equ_BD_NodeOffset]);
  f_S_Equ_NOI2_Node_Ptr = &(dFdx[li_S][A_S_Equ_NOI2_NodeOffset]);
  q_S_Equ_NOI2_Node_Ptr = &(dQdx[li_S][A_S_Equ_NOI2_NodeOffset]);
  f_S_Equ_NOI_Node_Ptr = &(dFdx[li_S][A_S_Equ_NOI_NodeOffset]);
  q_S_Equ_NOI_Node_Ptr = &(dQdx[li_S][A_S_Equ_NOI_NodeOffset]);
  f_B_Equ_B_Node_Ptr = &(dFdx[li_B][A_B_Equ_B_NodeOffset]);
  q_B_Equ_B_Node_Ptr = &(dQdx[li_B][A_B_Equ_B_NodeOffset]);
  f_B_Equ_BI_Node_Ptr = &(dFdx[li_B][A_B_Equ_BI_NodeOffset]);
  q_B_Equ_BI_Node_Ptr = &(dQdx[li_B][A_B_Equ_BI_NodeOffset]);
  f_NOI_Equ_S_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_S_NodeOffset]);
  q_NOI_Equ_S_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_S_NodeOffset]);
  f_NOI_Equ_BP_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_BP_NodeOffset]);
  q_NOI_Equ_BP_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_BP_NodeOffset]);
  f_NOI_Equ_GP_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_GP_NodeOffset]);
  q_NOI_Equ_GP_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_GP_NodeOffset]);
  f_NOI_Equ_D_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_D_NodeOffset]);
  q_NOI_Equ_D_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_D_NodeOffset]);
  f_NOI_Equ_NOI2_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_NOI2_NodeOffset]);
  q_NOI_Equ_NOI2_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_NOI2_NodeOffset]);
  f_NOI_Equ_NOI_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_NOI_NodeOffset]);
  q_NOI_Equ_NOI_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_NOI_NodeOffset]);
  f_NOI2_Equ_NOI2_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_NOI2_NodeOffset]);
  q_NOI2_Equ_NOI2_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_NOI2_NodeOffset]);
  f_NOI2_Equ_S_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_S_NodeOffset]);
  q_NOI2_Equ_S_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_S_NodeOffset]);
  f_NOI2_Equ_BP_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_BP_NodeOffset]);
  q_NOI2_Equ_BP_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_BP_NodeOffset]);
  f_NOI2_Equ_GP_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_GP_NodeOffset]);
  q_NOI2_Equ_GP_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_GP_NodeOffset]);
  f_NOI2_Equ_D_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_D_NodeOffset]);
  q_NOI2_Equ_D_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_D_NodeOffset]);
  f_GP_Equ_S_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_S_NodeOffset]);
  q_GP_Equ_S_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_S_NodeOffset]);
  f_GP_Equ_BP_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_BP_NodeOffset]);
  q_GP_Equ_BP_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_BP_NodeOffset]);
  f_GP_Equ_D_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_D_NodeOffset]);
  q_GP_Equ_D_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_D_NodeOffset]);
  f_GP_Equ_GP_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_GP_NodeOffset]);
  q_GP_Equ_GP_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_GP_NodeOffset]);
  f_GP_Equ_G_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_G_NodeOffset]);
  q_GP_Equ_G_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_G_NodeOffset]);
  f_GP_Equ_NOI_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_NOI_NodeOffset]);
  q_GP_Equ_NOI_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_NOI_NodeOffset]);
  f_BP_Equ_S_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_S_NodeOffset]);
  q_BP_Equ_S_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_S_NodeOffset]);
  f_BP_Equ_BP_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_BP_NodeOffset]);
  q_BP_Equ_BP_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_BP_NodeOffset]);
  f_BP_Equ_D_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_D_NodeOffset]);
  q_BP_Equ_D_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_D_NodeOffset]);
  f_BP_Equ_GP_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_GP_NodeOffset]);
  q_BP_Equ_GP_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_GP_NodeOffset]);
  f_BP_Equ_BI_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_BI_NodeOffset]);
  q_BP_Equ_BI_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_BI_NodeOffset]);
  f_BI_Equ_BP_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BP_NodeOffset]);
  q_BI_Equ_BP_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BP_NodeOffset]);
  f_BI_Equ_BI_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BI_NodeOffset]);
  q_BI_Equ_BI_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BI_NodeOffset]);
  f_BI_Equ_BS_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BS_NodeOffset]);
  q_BI_Equ_BS_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BS_NodeOffset]);
  f_BI_Equ_BD_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BD_NodeOffset]);
  q_BI_Equ_BD_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BD_NodeOffset]);
  f_BI_Equ_B_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_B_NodeOffset]);
  q_BI_Equ_B_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_B_NodeOffset]);
  f_BS_Equ_S_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_S_NodeOffset]);
  q_BS_Equ_S_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_S_NodeOffset]);
  f_BS_Equ_BS_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BS_NodeOffset]);
  q_BS_Equ_BS_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BS_NodeOffset]);
  f_BS_Equ_D_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_D_NodeOffset]);
  q_BS_Equ_D_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_D_NodeOffset]);
  f_BS_Equ_BD_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BD_NodeOffset]);
  q_BS_Equ_BD_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BD_NodeOffset]);
  f_BS_Equ_BI_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BI_NodeOffset]);
  q_BS_Equ_BI_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BI_NodeOffset]);
  f_BS_Equ_BP_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BP_NodeOffset]);
  q_BS_Equ_BP_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BP_NodeOffset]);
  f_BS_Equ_GP_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_GP_NodeOffset]);
  q_BS_Equ_GP_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_GP_NodeOffset]);
  f_BD_Equ_S_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_S_NodeOffset]);
  q_BD_Equ_S_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_S_NodeOffset]);
  f_BD_Equ_BS_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BS_NodeOffset]);
  q_BD_Equ_BS_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BS_NodeOffset]);
  f_BD_Equ_D_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_D_NodeOffset]);
  q_BD_Equ_D_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_D_NodeOffset]);
  f_BD_Equ_BD_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BD_NodeOffset]);
  q_BD_Equ_BD_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BD_NodeOffset]);
  f_BD_Equ_BI_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BI_NodeOffset]);
  q_BD_Equ_BI_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BI_NodeOffset]);
  f_BD_Equ_BP_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BP_NodeOffset]);
  q_BD_Equ_BP_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BP_NodeOffset]);
  f_BD_Equ_GP_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_GP_NodeOffset]);
  q_BD_Equ_GP_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_GP_NodeOffset]);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_D] += staticContributions[admsNodeID_D];
  (*extData.daeFVectorPtr)[li_G] += staticContributions[admsNodeID_G];
  (*extData.daeFVectorPtr)[li_S] += staticContributions[admsNodeID_S];
  (*extData.daeFVectorPtr)[li_B] += staticContributions[admsNodeID_B];
  (*extData.daeFVectorPtr)[li_NOI] += staticContributions[admsNodeID_NOI];
  (*extData.daeFVectorPtr)[li_NOI2] += staticContributions[admsNodeID_NOI2];
  (*extData.daeFVectorPtr)[li_GP] += staticContributions[admsNodeID_GP];
  (*extData.daeFVectorPtr)[li_BP] += staticContributions[admsNodeID_BP];
  (*extData.daeFVectorPtr)[li_BI] += staticContributions[admsNodeID_BI];
  (*extData.daeFVectorPtr)[li_BS] += staticContributions[admsNodeID_BS];
  (*extData.daeFVectorPtr)[li_BD] += staticContributions[admsNodeID_BD];


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;

    leadF[li_branch_iD] = leadCurrentF[admsNodeID_D];
    leadF[li_branch_iG] = leadCurrentF[admsNodeID_G];
    leadF[li_branch_iS] = leadCurrentF[admsNodeID_S];
    leadF[li_branch_iB] = leadCurrentF[admsNodeID_B];

    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

    double * solVec = extData.nextSolVectorRawPtr;
    double * junctionV = extData.nextJunctionVCompRawPtr;
    junctionV[li_branch_iD] = solVec[li_D] - solVec[li_S];
    junctionV[li_branch_iG] = solVec[li_G] - solVec[li_S];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_D] += dynamicContributions[admsNodeID_D];
  (*extData.daeQVectorPtr)[li_G] += dynamicContributions[admsNodeID_G];
  (*extData.daeQVectorPtr)[li_S] += dynamicContributions[admsNodeID_S];
  (*extData.daeQVectorPtr)[li_B] += dynamicContributions[admsNodeID_B];
  (*extData.daeQVectorPtr)[li_NOI] += dynamicContributions[admsNodeID_NOI];
  (*extData.daeQVectorPtr)[li_NOI2] += dynamicContributions[admsNodeID_NOI2];
  (*extData.daeQVectorPtr)[li_GP] += dynamicContributions[admsNodeID_GP];
  (*extData.daeQVectorPtr)[li_BP] += dynamicContributions[admsNodeID_BP];
  (*extData.daeQVectorPtr)[li_BI] += dynamicContributions[admsNodeID_BI];
  (*extData.daeQVectorPtr)[li_BS] += dynamicContributions[admsNodeID_BS];
  (*extData.daeQVectorPtr)[li_BD] += dynamicContributions[admsNodeID_BD];


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;

    leadQ[li_branch_iD] = leadCurrentQ[admsNodeID_D];
    leadQ[li_branch_iG] = leadCurrentQ[admsNodeID_G];
    leadQ[li_branch_iS] = leadCurrentQ[admsNodeID_S];
    leadQ[li_branch_iB] = leadCurrentQ[admsNodeID_B];
  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.


  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one PSP102VA instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSPSP102VA::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double vth_i;
  double d_vth_i_dV_D_S;
  double d_vth_i_dV_GP_S;
  double d_vth_i_dV_S_BP;
  double vts_i;
  double d_vts_i_dV_D_S;
  double d_vts_i_dV_GP_S;
  double d_vts_i_dV_S_BP;
  double facvsb;
  double d_facvsb_dV_D_S;
  double d_facvsb_dV_S_BP;
  double facvsb0;
  double P_D;
  double d_P_D_dV_D_S;
  double d_P_D_dV_GP_S;
  double d_P_D_dV_S_BP;
  double Vtovs;
  double d_Vtovs_dV_GP_S;
  double d_Vtovs_dV_D_S;
  double d_Vtovs_dV_S_BP;
  double Vtovd;
  double d_Vtovd_dV_GP_S;
  double d_Vtovd_dV_D_S;
  double d_Vtovd_dV_S_BP;
  double Igisl;
  double d_Igisl_dV_S_BP;
  double d_Igisl_dV_GP_S;
  double d_Igisl_dV_D_S;
  double Igidl;
  double d_Igidl_dV_D_S;
  double d_Igidl_dV_S_BP;
  double d_Igidl_dV_GP_S;
  double Sg;
  double d_Sg_dV_D_S;
  double d_Sg_dV_GP_S;
  double d_Sg_dV_S_BP;
  double igcd_h;
  double d_igcd_h_dV_D_S;
  double d_igcd_h_dV_GP_S;
  double d_igcd_h_dV_S_BP;
  double igc;
  double d_igc_dV_D_S;
  double d_igc_dV_GP_S;
  double d_igc_dV_S_BP;
  double xsq;
  double d_xsq_dV_D_S;
  double d_xsq_dV_GP_S;
  double d_xsq_dV_S_BP;
  double inv_ex;
  double d_inv_ex_dV_D_S;
  double d_inv_ex_dV_GP_S;
  double d_inv_ex_dV_S_BP;
  double ex;
  double d_ex_dV_D_S;
  double d_ex_dV_GP_S;
  double d_ex_dV_S_BP;
  double inv_x;
  double d_inv_x_dV_D_S;
  double d_inv_x_dV_GP_S;
  double d_inv_x_dV_S_BP;
  double Ag;
  double d_Ag_dV_GP_S;
  double d_Ag_dV_D_S;
  double d_Ag_dV_S_BP;
  double Bg;
  double d_Bg_dV_GP_S;
  double d_Bg_dV_D_S;
  double d_Bg_dV_S_BP;
  double u0_div_H;
  double d_u0_div_H_dV_GP_S;
  double d_u0_div_H_dV_D_S;
  double d_u0_div_H_dV_S_BP;
  double x;
  double d_x_dV_D_S;
  double d_x_dV_GP_S;
  double d_x_dV_S_BP;
  double u0;
  double d_u0_dV_GP_S;
  double d_u0_dV_D_S;
  double d_u0_dV_S_BP;
  double Igc0;
  double d_Igc0_dV_GP_S;
  double d_Igc0_dV_D_S;
  double d_Igc0_dV_S_BP;
  double Vm;
  double d_Vm_dV_D_S;
  double d_Vm_dV_S_BP;
  double d_Vm_dV_GP_S;
  double TP;
  double d_TP_dV_GP_S;
  double d_TP_dV_D_S;
  double d_TP_dV_S_BP;
  double Dgate;
  double d_Dgate_dV_D_S;
  double d_Dgate_dV_S_BP;
  double d_Dgate_dV_GP_S;
  double Dsi;
  double d_Dsi_dV_D_S;
  double d_Dsi_dV_S_BP;
  double d_Dsi_dV_GP_S;
  double arg1;
  double d_arg1_dV_D_S;
  double d_arg1_dV_S_BP;
  double d_arg1_dV_GP_S;
  double zg;
  double d_zg_dV_GP_S;
  double d_zg_dV_D_S;
  double d_zg_dV_S_BP;
  double psi_t;
  double d_psi_t_dV_GP_S;
  double d_psi_t_dV_D_S;
  double d_psi_t_dV_S_BP;
  double arg2mina;
  double d_arg2mina_dV_GP_S;
  double d_arg2mina_dV_D_S;
  double d_arg2mina_dV_S_BP;
  double Igb;
  double d_Igb_dV_GP_S;
  double d_Igb_dV_D_S;
  double d_Igb_dV_S_BP;
  double Igc;
  double d_Igc_dV_GP_S;
  double d_Igc_dV_D_S;
  double d_Igc_dV_S_BP;
  double SP_OV_w;
  double d_SP_OV_w_dV_GP_S;
  double d_SP_OV_w_dV_D_S;
  double d_SP_OV_w_dV_S_BP;
  double SP_OV_xi;
  double d_SP_OV_xi_dV_GP_S;
  double d_SP_OV_xi_dV_D_S;
  double d_SP_OV_xi_dV_S_BP;
  double SP_OV_q;
  double d_SP_OV_q_dV_GP_S;
  double d_SP_OV_q_dV_D_S;
  double d_SP_OV_q_dV_S_BP;
  double SP_OV_p;
  double d_SP_OV_p_dV_GP_S;
  double d_SP_OV_p_dV_D_S;
  double d_SP_OV_p_dV_S_BP;
  double SP_OV_temp;
  double d_SP_OV_temp_dV_GP_S;
  double d_SP_OV_temp_dV_D_S;
  double d_SP_OV_temp_dV_S_BP;
  double SP_OV_D0;
  double d_SP_OV_D0_dV_GP_S;
  double d_SP_OV_D0_dV_D_S;
  double d_SP_OV_D0_dV_S_BP;
  double SP_OV_y0;
  double d_SP_OV_y0_dV_GP_S;
  double d_SP_OV_y0_dV_D_S;
  double d_SP_OV_y0_dV_S_BP;
  double SP_OV_tau;
  double d_SP_OV_tau_dV_D_S;
  double d_SP_OV_tau_dV_GP_S;
  double SP_OV_c;
  double d_SP_OV_c_dV_D_S;
  double d_SP_OV_c_dV_GP_S;
  double SP_OV_a;
  double d_SP_OV_a_dV_D_S;
  double d_SP_OV_a_dV_GP_S;
  double SP_OV_eta;
  double d_SP_OV_eta_dV_D_S;
  double d_SP_OV_eta_dV_GP_S;
  double SP_OV_z;
  double d_SP_OV_z_dV_D_S;
  double d_SP_OV_z_dV_GP_S;
  double SP_OV_yg;
  double d_SP_OV_yg_dV_D_S;
  double d_SP_OV_yg_dV_GP_S;
  double SP_OV_u;
  double d_SP_OV_u_dV_GP_S;
  double d_SP_OV_u_dV_D_S;
  double d_SP_OV_u_dV_S_BP;
  double SP_OV_x0;
  double d_SP_OV_x0_dV_GP_S;
  double d_SP_OV_x0_dV_D_S;
  double d_SP_OV_x0_dV_S_BP;
  double SP_OV_xbar;
  double d_SP_OV_xbar_dV_D_S;
  double d_SP_OV_xbar_dV_GP_S;
  double SP_OV_Afac;
  double inv_xg1;
  double x_mrg_ov;
  double inv_xi_ov;
  double xi_ov;
  double GOV2;
  double GOV;
  double Vdsat;
  double d_Vdsat_dV_D_S;
  double d_Vdsat_dV_GP_S;
  double d_Vdsat_dV_S_BP;
  double qeff;
  double d_qeff_dV_D_S;
  double d_qeff_dV_GP_S;
  double d_qeff_dV_S_BP;
  double Voxm;
  double d_Voxm_dV_D_S;
  double d_Voxm_dV_GP_S;
  double d_Voxm_dV_S_BP;
  double qis;
  double d_qis_dV_D_S;
  double d_qis_dV_GP_S;
  double d_qis_dV_S_BP;
  double delVsat;
  double d_delVsat_dV_D_S;
  double d_delVsat_dV_GP_S;
  double d_delVsat_dV_S_BP;
  double alpha1;
  double d_alpha1_dV_D_S;
  double d_alpha1_dV_GP_S;
  double d_alpha1_dV_S_BP;
  double zsat;
  double d_zsat_dV_GP_S;
  double d_zsat_dV_D_S;
  double d_zsat_dV_S_BP;
  double dL1;
  double d_dL1_dV_GP_S;
  double d_dL1_dV_D_S;
  double d_dL1_dV_S_BP;
  double dL;
  double d_dL_dV_GP_S;
  double d_dL_dV_D_S;
  double d_dL_dV_S_BP;
  double r2;
  double d_r2_dV_D_S;
  double d_r2_dV_GP_S;
  double d_r2_dV_S_BP;
  double r1;
  double d_r1_dV_D_S;
  double d_r1_dV_GP_S;
  double d_r1_dV_S_BP;
  double qbm;
  double d_qbm_dV_D_S;
  double d_qbm_dV_GP_S;
  double d_qbm_dV_S_BP;
  double qim1_1;
  double d_qim1_1_dV_D_S;
  double d_qim1_1_dV_GP_S;
  double d_qim1_1_dV_S_BP;
  double Pm;
  double d_Pm_dV_D_S;
  double d_Pm_dV_GP_S;
  double d_Pm_dV_S_BP;
  double help;
  double d_help_dV_D_S;
  double d_help_dV_GP_S;
  double d_help_dV_S_BP;
  double km;
  double d_km_dV_GP_S;
  double d_km_dV_D_S;
  double d_km_dV_S_BP;
  double u_pd;
  double d_u_pd_dV_GP_S;
  double d_u_pd_dV_D_S;
  double d_u_pd_dV_S_BP;
  double xi_pd;
  double d_xi_pd_dV_D_S;
  double d_xi_pd_dV_GP_S;
  double d_xi_pd_dV_S_BP;
  double q_pd;
  double d_q_pd_dV_GP_S;
  double d_q_pd_dV_D_S;
  double d_q_pd_dV_S_BP;
  double p_pd;
  double d_p_pd_dV_D_S;
  double d_p_pd_dV_GP_S;
  double d_p_pd_dV_S_BP;
  double x_pm;
  double d_x_pm_dV_GP_S;
  double d_x_pm_dV_D_S;
  double d_x_pm_dV_S_BP;
  double d0;
  double d_d0_dV_D_S;
  double d_d0_dV_GP_S;
  double d_d0_dV_S_BP;
  double D_bar;
  double d_D_bar_dV_D_S;
  double d_D_bar_dV_GP_S;
  double d_D_bar_dV_S_BP;
  double xi0d;
  double d_xi0d_dV_D_S;
  double d_xi0d_dV_GP_S;
  double d_xi0d_dV_S_BP;
  double qC;
  double d_qC_dV_D_S;
  double d_qC_dV_GP_S;
  double d_qC_dV_S_BP;
  double pC;
  double d_pC_dV_D_S;
  double d_pC_dV_GP_S;
  double d_pC_dV_S_BP;
  double delta_nd;
  double d_delta_nd_dV_D_S;
  double d_delta_nd_dV_S_BP;
  double d_delta_nd_dV_GP_S;
  double k_ds;
  double d_k_ds_dV_GP_S;
  double d_k_ds_dV_S_BP;
  double d_k_ds_dV_D_S;
  double xn_d;
  double d_xn_d_dV_D_S;
  double d_xn_d_dV_S_BP;
  double d_xn_d_dV_GP_S;
  double Phi_sat;
  double d_Phi_sat_dV_D_S;
  double d_Phi_sat_dV_GP_S;
  double d_Phi_sat_dV_S_BP;
  double Phi0_Phi2;
  double d_Phi0_Phi2_dV_D_S;
  double d_Phi0_Phi2_dV_GP_S;
  double d_Phi0_Phi2_dV_S_BP;
  double Phi_0_2;
  double d_Phi_0_2_dV_D_S;
  double d_Phi_0_2_dV_GP_S;
  double d_Phi_0_2_dV_S_BP;
  double Phi_2;
  double d_Phi_2_dV_D_S;
  double d_Phi_2_dV_GP_S;
  double d_Phi_2_dV_S_BP;
  double asat;
  double d_asat_dV_D_S;
  double d_asat_dV_GP_S;
  double d_asat_dV_S_BP;
  double Phi_0;
  double d_Phi_0_dV_D_S;
  double d_Phi_0_dV_GP_S;
  double d_Phi_0_dV_S_BP;
  double temp1;
  double d_temp1_dV_GP_S;
  double d_temp1_dV_D_S;
  double d_temp1_dV_S_BP;
  double za;
  double d_za_dV_GP_S;
  double d_za_dV_D_S;
  double d_za_dV_S_BP;
  double ysat;
  double d_ysat_dV_GP_S;
  double d_ysat_dV_D_S;
  double d_ysat_dV_S_BP;
  double phi_inf;
  double d_phi_inf_dV_D_S;
  double d_phi_inf_dV_GP_S;
  double d_phi_inf_dV_S_BP;
  double wsat;
  double d_wsat_dV_D_S;
  double d_wsat_dV_GP_S;
  double d_wsat_dV_S_BP;
  double temp2;
  double d_temp2_dV_D_S;
  double d_temp2_dV_GP_S;
  double d_temp2_dV_S_BP;
  double Mutmp;
  double d_Mutmp_dV_D_S;
  double d_Mutmp_dV_GP_S;
  double d_Mutmp_dV_S_BP;
  double Eeffm;
  double d_Eeffm_dV_D_S;
  double d_Eeffm_dV_GP_S;
  double d_Eeffm_dV_S_BP;
  double GR;
  double d_GR_dV_D_S;
  double d_GR_dV_S_BP;
  double d_GR_dV_GP_S;
  double qbs;
  double d_qbs_dV_D_S;
  double d_qbs_dV_GP_S;
  double d_qbs_dV_S_BP;
  double xgs;
  double d_xgs_dV_D_S;
  double d_xgs_dV_GP_S;
  double d_xgs_dV_S_BP;
  double Rxcor;
  double d_Rxcor_dV_D_S;
  double d_Rxcor_dV_S_BP;
  double Dd;
  double d_Dd_dV_D_S;
  double d_Dd_dV_GP_S;
  double d_Dd_dV_S_BP;
  double Dm;
  double d_Dm_dV_D_S;
  double d_Dm_dV_GP_S;
  double d_Dm_dV_S_BP;
  double Ed;
  double d_Ed_dV_D_S;
  double d_Ed_dV_GP_S;
  double d_Ed_dV_S_BP;
  double Em;
  double d_Em_dV_D_S;
  double d_Em_dV_GP_S;
  double d_Em_dV_S_BP;
  double Ps;
  double d_Ps_dV_D_S;
  double d_Ps_dV_GP_S;
  double d_Ps_dV_S_BP;
  double Ds;
  double d_Ds_dV_D_S;
  double d_Ds_dV_GP_S;
  double d_Ds_dV_S_BP;
  double Es;
  double d_Es_dV_D_S;
  double d_Es_dV_GP_S;
  double d_Es_dV_S_BP;
  double xi2s;
  double d_xi2s_dV_GP_S;
  double d_xi2s_dV_D_S;
  double d_xi2s_dV_S_BP;
  double xi1s;
  double d_xi1s_dV_D_S;
  double d_xi1s_dV_GP_S;
  double d_xi1s_dV_S_BP;
  double xi0s;
  double d_xi0s_dV_D_S;
  double d_xi0s_dV_GP_S;
  double d_xi0s_dV_S_BP;
  double delta_1s;
  double d_delta_1s_dV_D_S;
  double d_delta_1s_dV_GP_S;
  double d_delta_1s_dV_S_BP;
  double x_ds;
  double d_x_ds_dV_D_S;
  double d_x_ds_dV_GP_S;
  double d_x_ds_dV_S_BP;
  double x_m;
  double d_x_m_dV_D_S;
  double d_x_m_dV_GP_S;
  double d_x_m_dV_S_BP;
  double x_d;
  double d_x_d_dV_D_S;
  double d_x_d_dV_GP_S;
  double d_x_d_dV_S_BP;
  double SP_S_temp1;
  double d_SP_S_temp1_dV_D_S;
  double d_SP_S_temp1_dV_GP_S;
  double d_SP_S_temp1_dV_S_BP;
  double SP_S_qC;
  double d_SP_S_qC_dV_D_S;
  double d_SP_S_qC_dV_GP_S;
  double d_SP_S_qC_dV_S_BP;
  double SP_S_pC;
  double d_SP_S_pC_dV_D_S;
  double d_SP_S_pC_dV_GP_S;
  double d_SP_S_pC_dV_S_BP;
  double SP_S_xi2;
  double d_SP_S_xi2_dV_D_S;
  double d_SP_S_xi2_dV_GP_S;
  double d_SP_S_xi2_dV_S_BP;
  double SP_S_xi1;
  double d_SP_S_xi1_dV_D_S;
  double d_SP_S_xi1_dV_GP_S;
  double d_SP_S_xi1_dV_S_BP;
  double SP_S_xi0;
  double d_SP_S_xi0_dV_D_S;
  double d_SP_S_xi0_dV_GP_S;
  double d_SP_S_xi0_dV_S_BP;
  double SP_S_delta1;
  double d_SP_S_delta1_dV_D_S;
  double d_SP_S_delta1_dV_GP_S;
  double d_SP_S_delta1_dV_S_BP;
  double SP_S_delta0;
  double d_SP_S_delta0_dV_D_S;
  double d_SP_S_delta0_dV_GP_S;
  double d_SP_S_delta0_dV_S_BP;
  double SP_S_y0;
  double d_SP_S_y0_dV_D_S;
  double d_SP_S_y0_dV_GP_S;
  double d_SP_S_y0_dV_S_BP;
  double mutau;
  double d_mutau_dV_D_S;
  double d_mutau_dV_GP_S;
  double d_mutau_dV_S_BP;
  double nu;
  double d_nu_dV_D_S;
  double d_nu_dV_GP_S;
  double d_nu_dV_S_BP;
  double SP_S_tau;
  double d_SP_S_tau_dV_D_S;
  double d_SP_S_tau_dV_GP_S;
  double d_SP_S_tau_dV_S_BP;
  double SP_S_c;
  double d_SP_S_c_dV_D_S;
  double d_SP_S_c_dV_GP_S;
  double d_SP_S_c_dV_S_BP;
  double SP_S_a;
  double d_SP_S_a_dV_D_S;
  double d_SP_S_a_dV_GP_S;
  double d_SP_S_a_dV_S_BP;
  double SP_S_temp;
  double d_SP_S_temp_dV_D_S;
  double d_SP_S_temp_dV_GP_S;
  double d_SP_S_temp_dV_S_BP;
  double SP_S_eta;
  double d_SP_S_eta_dV_D_S;
  double d_SP_S_eta_dV_GP_S;
  double d_SP_S_eta_dV_S_BP;
  double SP_S_ysub;
  double d_SP_S_ysub_dV_D_S;
  double d_SP_S_ysub_dV_GP_S;
  double d_SP_S_ysub_dV_S_BP;
  double SP_S_yg;
  double d_SP_S_yg_dV_D_S;
  double d_SP_S_yg_dV_GP_S;
  double d_SP_S_yg_dV_S_BP;
  double SP_S_x0;
  double d_SP_S_x0_dV_D_S;
  double d_SP_S_x0_dV_GP_S;
  double d_SP_S_x0_dV_S_BP;
  double SP_S_b;
  double d_SP_S_b_dV_D_S;
  double d_SP_S_b_dV_GP_S;
  double d_SP_S_b_dV_S_BP;
  double SP_S_temp2;
  double d_SP_S_temp2_dV_D_S;
  double d_SP_S_temp2_dV_GP_S;
  double d_SP_S_temp2_dV_S_BP;
  double SP_S_bx;
  double d_SP_S_bx_dV_GP_S;
  double d_SP_S_bx_dV_D_S;
  double d_SP_S_bx_dV_S_BP;
  double SP_S_w;
  double d_SP_S_w_dV_D_S;
  double d_SP_S_w_dV_GP_S;
  double d_SP_S_w_dV_S_BP;
  double SP_S_xbar;
  double d_SP_S_xbar_dV_D_S;
  double d_SP_S_xbar_dV_GP_S;
  double d_SP_S_xbar_dV_S_BP;
  double SP_S_A_fac;
  double d_SP_S_A_fac_dV_D_S;
  double d_SP_S_A_fac_dV_GP_S;
  double d_SP_S_A_fac_dV_S_BP;
  double SP_xg1;
  double d_SP_xg1_dV_D_S;
  double d_SP_xg1_dV_GP_S;
  double d_SP_xg1_dV_S_BP;
  double margin;
  double d_margin_dV_D_S;
  double d_margin_dV_GP_S;
  double d_margin_dV_S_BP;
  double delta_ns;
  double d_delta_ns_dV_D_S;
  double d_delta_ns_dV_S_BP;
  double xn_s;
  double d_xn_s_dV_D_S;
  double d_xn_s_dV_S_BP;
  double Ux;
  double d_Ux_dV_D_S;
  double d_Ux_dV_S_BP;
  double inv_xi;
  double d_inv_xi_dV_D_S;
  double d_inv_xi_dV_GP_S;
  double d_inv_xi_dV_S_BP;
  double xi;
  double d_xi_dV_D_S;
  double d_xi_dV_GP_S;
  double d_xi_dV_S_BP;
  double inv_Gf2;
  double d_inv_Gf2_dV_D_S;
  double d_inv_Gf2_dV_GP_S;
  double d_inv_Gf2_dV_S_BP;
  double Gf2;
  double d_Gf2_dV_D_S;
  double d_Gf2_dV_GP_S;
  double d_Gf2_dV_S_BP;
  double Gf;
  double d_Gf_dV_D_S;
  double d_Gf_dV_GP_S;
  double d_Gf_dV_S_BP;
  double Dnsub;
  double d_Dnsub_dV_D_S;
  double d_Dnsub_dV_GP_S;
  double d_Dnsub_dV_S_BP;
  double delVg;
  double d_delVg_dV_D_S;
  double d_delVg_dV_S_BP;
  double Vsbx;
  double d_Vsbx_dV_D_S;
  double d_Vsbx_dV_S_BP;
  double Vdsx;
  double d_Vdsx_dV_D_S;
  double Vgb1;
  double d_Vgb1_dV_D_S;
  double d_Vgb1_dV_GP_S;
  double d_Vgb1_dV_S_BP;
  double Vgbstar;
  double d_Vgbstar_dV_D_S;
  double d_Vgbstar_dV_GP_S;
  double d_Vgbstar_dV_S_BP;
  double Vdbstar;
  double d_Vdbstar_dV_D_S;
  double d_Vdbstar_dV_S_BP;
  double Vsbstar;
  double d_Vsbstar_dV_D_S;
  double d_Vsbstar_dV_S_BP;
  double temp;
  double d_temp_dV_GP_S;
  double d_temp_dV_D_S;
  double d_temp_dV_S_BP;
  double Vdb;
  double d_Vdb_dV_D_S;
  double d_Vdb_dV_S_BP;
  double Vgd;
  double d_Vgd_dV_D_S;
  double d_Vgd_dV_GP_S;
  double xgd_ov;
  double d_xgd_ov_dV_GP_S;
  double d_xgd_ov_dV_D_S;
  double xgs_ov;
  double d_xgs_ov_dV_GP_S;
  double VgdPrime;
  double d_VgdPrime_dV_GP_S;
  double d_VgdPrime_dV_D_S;
  double VdbPrime;
  double d_VdbPrime_dV_D_S;
  double d_VdbPrime_dV_S_BP;
  double VsbPrime;
  double d_VsbPrime_dV_S_BP;
  double VgsPrime;
  double d_VgsPrime_dV_GP_S;
  double Vjun_d;
  double d_Vjun_d_dV_D_BD;
  double Vjun_s;
  double d_Vjun_s_dV_S_BS;
  double Vsb;
  double d_Vsb_dV_D_S;
  double d_Vsb_dV_S_BP;
  double Vds;
  double d_Vds_dV_D_S;
  double Vgs;
  double d_Vgs_dV_D_S;
  double d_Vgs_dV_GP_S;
  double Vrwell;
  double d_Vrwell_dV_B_BI;
  double Vrbulk;
  double d_Vrbulk_dV_BP_BI;
  double Vrjund;
  double d_Vrjund_dV_BD_BI;
  double Vrjuns;
  double d_Vrjuns_dV_BS_BI;
  double Vrg;
  double d_Vrg_dV_G_GP;
  double Vovd;
  double d_Vovd_dV_GP_S;
  double d_Vovd_dV_D_S;
  double d_Vovd_dV_S_BP;
  double Vovs;
  double d_Vovs_dV_GP_S;
  double d_Vovs_dV_D_S;
  double d_Vovs_dV_S_BP;
  double xd_ov;
  double d_xd_ov_dV_S_BP;
  double d_xd_ov_dV_GP_S;
  double d_xd_ov_dV_D_S;
  double xs_ov;
  double d_xs_ov_dV_D_S;
  double d_xs_ov_dV_S_BP;
  double d_xs_ov_dV_GP_S;
  double xgm;
  double d_xgm_dV_D_S;
  double d_xgm_dV_GP_S;
  double d_xgm_dV_S_BP;
  double thesat1;
  double d_thesat1_dV_GP_S;
  double d_thesat1_dV_D_S;
  double d_thesat1_dV_S_BP;
  double QCLM;
  double d_QCLM_dV_GP_S;
  double d_QCLM_dV_D_S;
  double d_QCLM_dV_S_BP;
  double Udse;
  double d_Udse_dV_GP_S;
  double d_Udse_dV_S_BP;
  double d_Udse_dV_D_S;
  double GdL;
  double d_GdL_dV_GP_S;
  double d_GdL_dV_D_S;
  double d_GdL_dV_S_BP;
  double rhob;
  double d_rhob_dV_D_S;
  double d_rhob_dV_S_BP;
  double sqm;
  double d_sqm_dV_D_S;
  double d_sqm_dV_GP_S;
  double d_sqm_dV_S_BP;
  double x_s;
  double d_x_s_dV_D_S;
  double d_x_s_dV_GP_S;
  double d_x_s_dV_S_BP;
  double SP_S_x1;
  double d_SP_S_x1_dV_D_S;
  double d_SP_S_x1_dV_GP_S;
  double d_SP_S_x1_dV_S_BP;
  double Qfgd;
  double d_Qfgd_dV_S_BP;
  double d_Qfgd_dV_GP_S;
  double d_Qfgd_dV_D_S;
  double Qfgs;
  double d_Qfgs_dV_D_S;
  double d_Qfgs_dV_S_BP;
  double d_Qfgs_dV_GP_S;
  double Qgb_ov;
  double d_Qgb_ov_dV_D_S;
  double d_Qgb_ov_dV_GP_S;
  double d_Qgb_ov_dV_S_BP;
  double Qgd_ov;
  double d_Qgd_ov_dV_GP_S;
  double d_Qgd_ov_dV_D_S;
  double d_Qgd_ov_dV_S_BP;
  double Qgs_ov;
  double d_Qgs_ov_dV_GP_S;
  double d_Qgs_ov_dV_D_S;
  double d_Qgs_ov_dV_S_BP;
  double Qb;
  double d_Qb_dV_D_S;
  double d_Qb_dV_GP_S;
  double d_Qb_dV_S_BP;
  double Qd;
  double d_Qd_dV_GP_S;
  double d_Qd_dV_D_S;
  double d_Qd_dV_S_BP;
  double Qg;
  double d_Qg_dV_D_S;
  double d_Qg_dV_GP_S;
  double d_Qg_dV_S_BP;
  double QB;
  double d_QB_dV_D_S;
  double d_QB_dV_GP_S;
  double d_QB_dV_S_BP;
  double QD;
  double d_QD_dV_GP_S;
  double d_QD_dV_D_S;
  double d_QD_dV_S_BP;
  double QI;
  double d_QI_dV_GP_S;
  double d_QI_dV_D_S;
  double d_QI_dV_S_BP;
  double QG;
  double d_QG_dV_D_S;
  double d_QG_dV_GP_S;
  double d_QG_dV_S_BP;
  double Fj2;
  double d_Fj2_dV_D_S;
  double d_Fj2_dV_GP_S;
  double d_Fj2_dV_S_BP;
  double Fj;
  double d_Fj_dV_D_S;
  double d_Fj_dV_GP_S;
  double d_Fj_dV_S_BP;
  double Vgb;
  double d_Vgb_dV_D_S;
  double d_Vgb_dV_GP_S;
  double d_Vgb_dV_S_BP;
  double rwellnoise;
  double rjundnoise;
  double rjunsnoise;
  double rbulknoise;
  double rgatenoise;
  double h1;
  double h2;
  double h2d;
  double d_h2d_dV_D_BD;
  double d_h2d_dV_S_BS;
  double h3;
  double d_h3_dV_D_BD;
  double d_h3_dV_S_BS;
  double h4;
  double d_h4_dV_D_BD;
  double d_h4_dV_S_BS;
  double h5;
  double d_h5_dV_D_BD;
  double d_h5_dV_S_BS;
  double ijunrev;
  double d_ijunrev_dV_D_BD;
  double d_ijunrev_dV_S_BS;
  double ijunfor2;
  double d_ijunfor2_dV_D_BD;
  double d_ijunfor2_dV_S_BS;
  double ijunfor1;
  double d_ijunfor1_dV_D_BD;
  double d_ijunfor1_dV_S_BS;
  double tm1;
  double d_tm1_dV_D_BD;
  double d_tm1_dV_S_BS;
  double tm0;
  double d_tm0_dV_D_BD;
  double d_tm0_dV_S_BS;
  double fbreakdown;
  double d_fbreakdown_dV_S_BS;
  double d_fbreakdown_dV_D_BD;
  double ibbt;
  double d_ibbt_dV_S_BS;
  double d_ibbt_dV_D_BD;
  double Fmaxr;
  double d_Fmaxr_dV_S_BS;
  double d_Fmaxr_dV_D_BD;
  double itat;
  double d_itat_dV_S_BS;
  double d_itat_dV_D_BD;
  double gammamax;
  double d_gammamax_dV_S_BS;
  double d_gammamax_dV_D_BD;
  double erfctimesexpmtat;
  double d_erfctimesexpmtat_dV_S_BS;
  double d_erfctimesexpmtat_dV_D_BD;
  double erfcpos;
  double d_erfcpos_dV_S_BS;
  double d_erfcpos_dV_D_BD;
  double terfc;
  double d_terfc_dV_S_BS;
  double d_terfc_dV_D_BD;
  double ysq;
  double d_ysq_dV_S_BS;
  double d_ysq_dV_D_BD;
  double xerfc;
  double d_xerfc_dV_S_BS;
  double d_xerfc_dV_D_BD;
  double mtat;
  double d_mtat_dV_S_BS;
  double d_mtat_dV_D_BD;
  double ltat;
  double d_ltat_dV_S_BS;
  double d_ltat_dV_D_BD;
  double ktat;
  double d_ktat_dV_S_BS;
  double d_ktat_dV_D_BD;
  double wtat;
  double d_wtat_dV_S_BS;
  double d_wtat_dV_D_BD;
  double wgamma;
  double d_wgamma_dV_S_BS;
  double d_wgamma_dV_D_BD;
  double umaxpoweronepointfive;
  double d_umaxpoweronepointfive_dV_S_BS;
  double d_umaxpoweronepointfive_dV_D_BD;
  double sqrtumax;
  double d_sqrtumax_dV_S_BS;
  double d_sqrtumax_dV_D_BD;
  double umax;
  double d_umax_dV_S_BS;
  double d_umax_dV_D_BD;
  double umaxbeforelimiting;
  double d_umaxbeforelimiting_dV_S_BS;
  double d_umaxbeforelimiting_dV_D_BD;
  double twoatatoverthreebtat;
  double d_twoatatoverthreebtat_dV_S_BS;
  double d_twoatatoverthreebtat_dV_D_BD;
  double btat;
  double d_btat_dV_S_BS;
  double d_btat_dV_D_BD;
  double isrh;
  double d_isrh_dV_S_BS;
  double d_isrh_dV_D_BD;
  double asrh;
  double d_asrh_dV_S_BS;
  double d_asrh_dV_D_BD;
  double wdep;
  double d_wdep_dV_S_BS;
  double d_wdep_dV_D_BD;
  double wsrh;
  double d_wsrh_dV_D_BD;
  double d_wsrh_dV_S_BS;
  double dwsrh;
  double d_dwsrh_dV_D_BD;
  double d_dwsrh_dV_S_BS;
  double wsrhstep;
  double d_wsrhstep_dV_D_BD;
  double d_wsrhstep_dV_S_BS;
  double vbi_minus_vjsrh;
  double d_vbi_minus_vjsrh_dV_D_BD;
  double d_vbi_minus_vjsrh_dV_S_BS;
  double id;
  double d_id_dV_D_BD;
  double d_id_dV_S_BS;
  double tmp;
  double d_tmp_dV_S_BS;
  double d_tmp_dV_D_BD;
  double vav;
  double d_vav_dV_D_BD;
  double d_vav_dV_S_BS;
  double vjsrh;
  double d_vjsrh_dV_D_BD;
  double d_vjsrh_dV_S_BS;
  double vjlim;
  double d_vjlim_dV_D_BD;
  double d_vjlim_dV_S_BS;
  double z;
  double d_z_dV_D_BD;
  double d_z_dV_S_BS;
  double idmult;
  double d_idmult_dV_D_BD;
  double d_idmult_dV_S_BS;
  double zinv;
  double d_zinv_dV_D_BD;
  double d_zinv_dV_S_BS;
  double vj;
  double d_vj_dV_S_BS;
  double d_vj_dV_D_BD;
  double two_psistar;
  double d_two_psistar_dV_D_BD;
  double d_two_psistar_dV_S_BS;
  double vbbt;
  double d_vbbt_dV_D_BD;
  double d_vbbt_dV_S_BS;
  double Qs;
  double d_Qs_dV_D_S;
  double d_Qs_dV_GP_S;
  double d_Qs_dV_S_BP;
  double shot_igd;
  double d_shot_igd_dV_GP_S;
  double d_shot_igd_dV_D_S;
  double d_shot_igd_dV_S_BP;
  double shot_igs;
  double d_shot_igs_dV_GP_S;
  double d_shot_igs_dV_D_S;
  double d_shot_igs_dV_S_BP;
  double jnoisex_d;
  double d_jnoisex_d_dV_D_BD;
  double d_jnoisex_d_dV_S_BS;
  double jnoisex_s;
  double d_jnoisex_s_dV_D_BD;
  double d_jnoisex_s_dV_S_BS;
  double shot_iavl;
  double d_shot_iavl_dV_D_S;
  double d_shot_iavl_dV_GP_S;
  double d_shot_iavl_dV_S_BP;
  double shot_igdov;
  double d_shot_igdov_dV_GP_S;
  double d_shot_igdov_dV_D_S;
  double d_shot_igdov_dV_S_BP;
  double shot_igsov;
  double d_shot_igsov_dV_GP_S;
  double d_shot_igsov_dV_D_S;
  double d_shot_igsov_dV_S_BP;
  double shot_igcdx;
  double d_shot_igcdx_dV_GP_S;
  double d_shot_igcdx_dV_D_S;
  double d_shot_igcdx_dV_S_BP;
  double shot_igcsx;
  double d_shot_igcsx_dV_GP_S;
  double d_shot_igcsx_dV_D_S;
  double d_shot_igcsx_dV_S_BP;
  double Sidexc;
  double d_Sidexc_dV_GP_S;
  double d_Sidexc_dV_D_S;
  double d_Sidexc_dV_S_BP;
  double gfac;
  double d_gfac_dV_D_S;
  double d_gfac_dV_GP_S;
  double d_gfac_dV_S_BP;
  double Gvsat_exc;
  double d_Gvsat_exc_dV_D_S;
  double d_Gvsat_exc_dV_GP_S;
  double d_Gvsat_exc_dV_S_BP;
  double zsat_exc;
  double d_zsat_exc_dV_D_S;
  double d_zsat_exc_dV_GP_S;
  double d_zsat_exc_dV_S_BP;
  double thesat1_exc;
  double d_thesat1_exc_dV_D_S;
  double d_thesat1_exc_dV_GP_S;
  double d_thesat1_exc_dV_S_BP;
  double temp_exc;
  double d_temp_exc_dV_D_S;
  double d_temp_exc_dV_GP_S;
  double d_temp_exc_dV_S_BP;
  double wsat_exc;
  double d_wsat_exc_dV_D_S;
  double d_wsat_exc_dV_GP_S;
  double d_wsat_exc_dV_S_BP;
  double temp2_exc;
  double d_temp2_exc_dV_D_S;
  double d_temp2_exc_dV_GP_S;
  double d_temp2_exc_dV_S_BP;
  double g_ideal;
  double d_g_ideal_dV_GP_S;
  double d_g_ideal_dV_D_S;
  double d_g_ideal_dV_S_BP;
  double lcinv2;
  double d_lcinv2_dV_D_S;
  double d_lcinv2_dV_GP_S;
  double d_lcinv2_dV_S_BP;
  double lc;
  double d_lc_dV_D_S;
  double d_lc_dV_GP_S;
  double d_lc_dV_S_BP;
  double r;
  double d_r_dV_D_S;
  double d_r_dV_GP_S;
  double d_r_dV_S_BP;
  double t2;
  double d_t2_dV_D_S;
  double d_t2_dV_GP_S;
  double d_t2_dV_S_BP;
  double sqt2;
  double d_sqt2_dV_D_S;
  double d_sqt2_dV_GP_S;
  double d_sqt2_dV_S_BP;
  double t1;
  double d_t1_dV_D_S;
  double d_t1_dV_GP_S;
  double d_t1_dV_S_BP;
  double H0;
  double d_H0_dV_D_S;
  double d_H0_dV_GP_S;
  double d_H0_dV_S_BP;
  double Delta_N1;
  double d_Delta_N1_dV_D_S;
  double d_Delta_N1_dV_GP_S;
  double d_Delta_N1_dV_S_BP;
  double Nm1;
  double d_Nm1_dV_D_S;
  double d_Nm1_dV_GP_S;
  double d_Nm1_dV_S_BP;
  double N1;
  double d_N1_dV_D_S;
  double d_N1_dV_GP_S;
  double d_N1_dV_S_BP;
  double sqig;
  double d_sqig_dV_D_S;
  double d_sqig_dV_GP_S;
  double d_sqig_dV_S_BP;
  double sqid;
  double d_sqid_dV_D_S;
  double d_sqid_dV_GP_S;
  double d_sqid_dV_S_BP;
  double CGeff;
  double d_CGeff_dV_D_S;
  double d_CGeff_dV_GP_S;
  double d_CGeff_dV_S_BP;
  double c_igid;
  double d_c_igid_dV_D_S;
  double d_c_igid_dV_GP_S;
  double d_c_igid_dV_S_BP;
  double migid;
  double d_migid_dV_D_S;
  double d_migid_dV_GP_S;
  double d_migid_dV_S_BP;
  double mig;
  double d_mig_dV_D_S;
  double d_mig_dV_GP_S;
  double d_mig_dV_S_BP;
  double mid;
  double d_mid_dV_D_S;
  double d_mid_dV_GP_S;
  double d_mid_dV_S_BP;
  double Sfl;
  double d_Sfl_dV_D_S;
  double d_Sfl_dV_GP_S;
  double d_Sfl_dV_S_BP;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (12))
  {
    probeVars.resize(12);
    d_probeVars.resize(12);
    for (int i=0;i<12;i++)
    {
      d_probeVars[i].resize(12);
      for (int j=0;j<12;j++)
        d_probeVars[i][j]=0.0;
    }
    staticContributions.resize(11+0);
    d_staticContributions.resize(11+0);
    for (int i=0;i<11+0;i++)
      d_staticContributions[i].resize(12);
    dynamicContributions.resize(11+0);
    d_dynamicContributions.resize(11+0);
    for (int i=0;i<11+0;i++)
      d_dynamicContributions[i].resize(12);
  }

  noiseContribsPower.resize(12);
  noiseContribsExponent.resize(12);

  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 11+0 ; ++i)
  {
    staticContributions[i]=0;
    for (int j=0;j<12;j++)
      d_staticContributions[i][j] = 0.0;
    dynamicContributions[i]=0;
    for (int j=0;j<12;j++)
      d_dynamicContributions[i][j] = 0.0;
  }

  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_NOI_GND] = (*solVectorPtr)[li_NOI];
  d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND] = 1.0;
  probeVars[admsProbeID_V_NOI2_GND] = (*solVectorPtr)[li_NOI2];
  d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND] = 1.0;
  probeVars[admsProbeID_V_D_BD] = (*solVectorPtr)[li_D] - (*solVectorPtr)[li_BD];
  d_probeVars[admsProbeID_V_D_BD][admsProbeID_V_D_BD] = 1.0;
  probeVars[admsProbeID_V_S_BS] = (*solVectorPtr)[li_S] - (*solVectorPtr)[li_BS];
  d_probeVars[admsProbeID_V_S_BS][admsProbeID_V_S_BS] = 1.0;
  probeVars[admsProbeID_V_S_BP] = (*solVectorPtr)[li_S] - (*solVectorPtr)[li_BP];
  d_probeVars[admsProbeID_V_S_BP][admsProbeID_V_S_BP] = 1.0;
  probeVars[admsProbeID_V_D_S] = (*solVectorPtr)[li_D] - (*solVectorPtr)[li_S];
  d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S] = 1.0;
  probeVars[admsProbeID_V_GP_S] = (*solVectorPtr)[li_GP] - (*solVectorPtr)[li_S];
  d_probeVars[admsProbeID_V_GP_S][admsProbeID_V_GP_S] = 1.0;
  probeVars[admsProbeID_V_B_BI] = (*solVectorPtr)[li_B] - (*solVectorPtr)[li_BI];
  d_probeVars[admsProbeID_V_B_BI][admsProbeID_V_B_BI] = 1.0;
  probeVars[admsProbeID_V_BP_BI] = (*solVectorPtr)[li_BP] - (*solVectorPtr)[li_BI];
  d_probeVars[admsProbeID_V_BP_BI][admsProbeID_V_BP_BI] = 1.0;
  probeVars[admsProbeID_V_BD_BI] = (*solVectorPtr)[li_BD] - (*solVectorPtr)[li_BI];
  d_probeVars[admsProbeID_V_BD_BI][admsProbeID_V_BD_BI] = 1.0;
  probeVars[admsProbeID_V_BS_BI] = (*solVectorPtr)[li_BS] - (*solVectorPtr)[li_BI];
  d_probeVars[admsProbeID_V_BS_BI][admsProbeID_V_BS_BI] = 1.0;
  probeVars[admsProbeID_V_G_GP] = (*solVectorPtr)[li_G] - (*solVectorPtr)[li_GP];
  d_probeVars[admsProbeID_V_G_GP][admsProbeID_V_G_GP] = 1.0;
  // -- code converted from analog/code block
  //Begin block evaluateblock
  {
    //Block-local variables for block evaluateblock
    double alpha;
    double d_alpha_dV_D_S;
    double d_alpha_dV_GP_S;
    double d_alpha_dV_S_BP;
    double eta_p;
    double d_eta_p_dV_D_S;
    double d_eta_p_dV_GP_S;
    double d_eta_p_dV_S_BP;
    double xitsb;
    double d_xitsb_dV_D_S;
    double d_xitsb_dV_S_BP;
    double FdL;
    double d_FdL_dV_GP_S;
    double d_FdL_dV_D_S;
    double d_FdL_dV_S_BP;
    double Gmob;
    double d_Gmob_dV_D_S;
    double d_Gmob_dV_GP_S;
    double d_Gmob_dV_S_BP;
    double Gmob_dL;
    double d_Gmob_dL_dV_D_S;
    double d_Gmob_dL_dV_GP_S;
    double d_Gmob_dL_dV_S_BP;
    double Gvsat;
    double d_Gvsat_dV_D_S;
    double d_Gvsat_dV_GP_S;
    double d_Gvsat_dV_S_BP;
    double Gvsatinv;
    double d_Gvsatinv_dV_D_S;
    double d_Gvsatinv_dV_GP_S;
    double d_Gvsatinv_dV_S_BP;
    double dps;
    double d_dps_dV_D_S;
    double d_dps_dV_GP_S;
    double d_dps_dV_S_BP;
    double qim;
    double d_qim_dV_D_S;
    double d_qim_dV_GP_S;
    double d_qim_dV_S_BP;
    double qim1;
    double d_qim1_dV_D_S;
    double d_qim1_dV_GP_S;
    double d_qim1_dV_S_BP;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    double H;
    double d_H_dV_GP_S;
    double d_H_dV_D_S;
    double d_H_dV_S_BP;
    double Iimpact;
    double d_Iimpact_dV_GP_S;
    double d_Iimpact_dV_D_S;
    double d_Iimpact_dV_S_BP;
    double mavl;
    double d_mavl_dV_D_S;
    double d_mavl_dV_GP_S;
    double d_mavl_dV_S_BP;
    double Ids;
    double d_Ids_dV_GP_S;
    double d_Ids_dV_D_S;
    double d_Ids_dV_S_BP;
    double Vdse;
    double d_Vdse_dV_GP_S;
    double d_Vdse_dV_S_BP;
    double d_Vdse_dV_D_S;
    double Igsov;
    double d_Igsov_dV_GP_S;
    double d_Igsov_dV_D_S;
    double d_Igsov_dV_S_BP;
    double Igdov;
    double d_Igdov_dV_GP_S;
    double d_Igdov_dV_D_S;
    double d_Igdov_dV_S_BP;
    double Igcs;
    double d_Igcs_dV_GP_S;
    double d_Igcs_dV_D_S;
    double d_Igcs_dV_S_BP;
    double Igcd;
    double d_Igcd_dV_GP_S;
    double d_Igcd_dV_D_S;
    double d_Igcd_dV_S_BP;
    double xg;
    double d_xg_dV_D_S;
    double d_xg_dV_GP_S;
    double d_xg_dV_S_BP;
    double sigVds;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    double COX_qm;
    double d_COX_qm_dV_D_S;
    double d_COX_qm_dV_GP_S;
    double d_COX_qm_dV_S_BP;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    double ijun_s;
    double d_ijun_s_dV_D_BD;
    double d_ijun_s_dV_S_BS;
    double ijunbot_s;
    double d_ijunbot_s_dV_S_BS;
    double d_ijunbot_s_dV_D_BD;
    double ijunsti_s;
    double d_ijunsti_s_dV_S_BS;
    double d_ijunsti_s_dV_D_BD;
    double ijungat_s;
    double d_ijungat_s_dV_S_BS;
    double d_ijungat_s_dV_D_BD;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    double ijun_d;
    double d_ijun_d_dV_D_BD;
    double d_ijun_d_dV_S_BS;
    double ijunbot_d;
    double d_ijunbot_d_dV_D_BD;
    double d_ijunbot_d_dV_S_BS;
    double ijunsti_d;
    double d_ijunsti_d_dV_D_BD;
    double d_ijunsti_d_dV_S_BS;
    double ijungat_d;
    double d_ijungat_d_dV_D_BD;
    double d_ijungat_d_dV_S_BS;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    double qjun_s;
    double d_qjun_s_dV_D_BD;
    double d_qjun_s_dV_S_BS;
    double qjunbot_s;
    double d_qjunbot_s_dV_D_BD;
    double d_qjunbot_s_dV_S_BS;
    double qjunsti_s;
    double d_qjunsti_s_dV_D_BD;
    double d_qjunsti_s_dV_S_BS;
    double qjungat_s;
    double d_qjungat_s_dV_D_BD;
    double d_qjungat_s_dV_S_BS;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    double qjun_d;
    double d_qjun_d_dV_D_BD;
    double d_qjun_d_dV_S_BS;
    double qjunbot_d;
    double d_qjunbot_d_dV_D_BD;
    double d_qjunbot_d_dV_S_BS;
    double qjunsti_d;
    double d_qjunsti_d_dV_D_BD;
    double d_qjunsti_d_dV_S_BS;
    double qjungat_d;
    double d_qjungat_d_dV_D_BD;
    double d_qjungat_d_dV_S_BS;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    double jnoise_s;
    double d_jnoise_s_dV_D_S;
    double d_jnoise_s_dV_GP_S;
    double d_jnoise_s_dV_S_BP;
    double d_jnoise_s_dV_D_BD;
    double d_jnoise_s_dV_S_BS;
    double jnoise_d;
    double d_jnoise_d_dV_D_BD;
    double d_jnoise_d_dV_S_BS;
    double d_jnoise_d_dV_D_S;
    double d_jnoise_d_dV_GP_S;
    double d_jnoise_d_dV_S_BP;
    //End of Block-local variables
    //Begin block evaluateStatic
    {

      d_SP_S_x1_dV_D_S = d_SP_S_x1_dV_GP_S = d_SP_S_x1_dV_S_BP =  0.0;
      SP_S_x1 = 0.0;

      d_x_s_dV_D_S = d_x_s_dV_GP_S = d_x_s_dV_S_BP =  0.0;
      x_s = 0.0;

      d_sqm_dV_D_S = d_sqm_dV_GP_S = d_sqm_dV_S_BP =  0.0;
      sqm = 0.0;

      d_alpha_dV_D_S = d_alpha_dV_GP_S = d_alpha_dV_S_BP =  0.0;
      alpha = 0.0;

      d_eta_p_dV_D_S = d_eta_p_dV_GP_S = d_eta_p_dV_S_BP =  0.0;
      eta_p = 1.0;

      d_xitsb_dV_D_S = d_xitsb_dV_S_BP =  0.0;
      xitsb = 0.0;

      d_rhob_dV_D_S = d_rhob_dV_S_BP =  0.0;
      rhob = 0.0;

      d_GdL_dV_GP_S = d_GdL_dV_D_S = d_GdL_dV_S_BP =  0.0;
      GdL = 1.0;

      d_FdL_dV_GP_S = d_FdL_dV_D_S = d_FdL_dV_S_BP =  0.0;
      FdL = 1.0;

      d_Gmob_dV_D_S = d_Gmob_dV_GP_S = d_Gmob_dV_S_BP =  0.0;
      Gmob = 1.0;

      d_Gmob_dL_dV_D_S = d_Gmob_dL_dV_GP_S = d_Gmob_dL_dV_S_BP =  0.0;
      Gmob_dL = 1.0;

      d_Udse_dV_GP_S = d_Udse_dV_S_BP = d_Udse_dV_D_S =  0.0;
      Udse = 0.0;

      d_QCLM_dV_GP_S = d_QCLM_dV_D_S = d_QCLM_dV_S_BP =  0.0;
      QCLM = 0.0;

      d_thesat1_dV_GP_S = d_thesat1_dV_D_S = d_thesat1_dV_S_BP =  0.0;
      thesat1 = 0.0;

      d_Gvsat_dV_D_S = d_Gvsat_dV_GP_S = d_Gvsat_dV_S_BP =  0.0;
      Gvsat = 1.0;

      d_Gvsatinv_dV_D_S = d_Gvsatinv_dV_GP_S = d_Gvsatinv_dV_S_BP =  0.0;
      Gvsatinv = 1.0;

      d_xgm_dV_D_S = d_xgm_dV_GP_S = d_xgm_dV_S_BP =  0.0;
      xgm = 0.0;

      d_dps_dV_D_S = d_dps_dV_GP_S = d_dps_dV_S_BP =  0.0;
      dps = 0.0;

      d_qim_dV_D_S = d_qim_dV_GP_S = d_qim_dV_S_BP =  0.0;
      qim = 0.0;

      d_qim1_dV_D_S = d_qim1_dV_GP_S = d_qim1_dV_S_BP =  0.0;
      qim1 = 0.0;

      d_H_dV_GP_S = d_H_dV_D_S = d_H_dV_S_BP =  0.0;
      H = 1.0;

      d_xs_ov_dV_D_S = d_xs_ov_dV_S_BP = d_xs_ov_dV_GP_S =  0.0;
      xs_ov = 0.0;

      d_xd_ov_dV_S_BP = d_xd_ov_dV_GP_S = d_xd_ov_dV_D_S =  0.0;
      xd_ov = 0.0;

      d_Vovs_dV_GP_S = d_Vovs_dV_D_S = d_Vovs_dV_S_BP =  0.0;
      Vovs = 0.0;

      d_Vovd_dV_GP_S = d_Vovd_dV_D_S = d_Vovd_dV_S_BP =  0.0;
      Vovd = 0.0;

      d_Iimpact_dV_GP_S = d_Iimpact_dV_D_S = d_Iimpact_dV_S_BP =  0.0;
      Iimpact = 0.0;

      d_mavl_dV_D_S = d_mavl_dV_GP_S = d_mavl_dV_S_BP =  0.0;
      mavl = 0.0;

      d_Vrg_dV_G_GP = d_probeVars[admsProbeID_V_G_GP][admsProbeID_V_G_GP];
      Vrg = (probeVars[admsProbeID_V_G_GP]);

      d_Vrjuns_dV_BS_BI = d_probeVars[admsProbeID_V_BS_BI][admsProbeID_V_BS_BI];
      Vrjuns = (probeVars[admsProbeID_V_BS_BI]);

      d_Vrjund_dV_BD_BI = d_probeVars[admsProbeID_V_BD_BI][admsProbeID_V_BD_BI];
      Vrjund = (probeVars[admsProbeID_V_BD_BI]);

      d_Vrbulk_dV_BP_BI = d_probeVars[admsProbeID_V_BP_BI][admsProbeID_V_BP_BI];
      Vrbulk = (probeVars[admsProbeID_V_BP_BI]);

      d_Vrwell_dV_B_BI = d_probeVars[admsProbeID_V_B_BI][admsProbeID_V_B_BI];
      Vrwell = (probeVars[admsProbeID_V_B_BI]);
      if (((model_.CHNL_TYPE)==(+1)))
      {

        d_Vgs_dV_D_S =  0.0;
        d_Vgs_dV_GP_S = d_probeVars[admsProbeID_V_GP_S][admsProbeID_V_GP_S];
        Vgs = (probeVars[admsProbeID_V_GP_S]);

        d_Vds_dV_D_S = d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S];
        Vds = (probeVars[admsProbeID_V_D_S]);

        d_Vsb_dV_D_S =  0.0;
        d_Vsb_dV_S_BP = d_probeVars[admsProbeID_V_S_BP][admsProbeID_V_S_BP];
        Vsb = (probeVars[admsProbeID_V_S_BP]);

        d_Vjun_s_dV_S_BS = (-d_probeVars[admsProbeID_V_S_BS][admsProbeID_V_S_BS]);
        Vjun_s = (-(probeVars[admsProbeID_V_S_BS]));

        d_Vjun_d_dV_D_BD = (-d_probeVars[admsProbeID_V_D_BD][admsProbeID_V_D_BD]);
        Vjun_d = (-(probeVars[admsProbeID_V_D_BD]));
      }
      else
      {

        d_Vgs_dV_D_S =  0.0;
        d_Vgs_dV_GP_S = (-d_probeVars[admsProbeID_V_GP_S][admsProbeID_V_GP_S]);
        Vgs = (-(probeVars[admsProbeID_V_GP_S]));

        d_Vds_dV_D_S = (-d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S]);
        Vds = (-(probeVars[admsProbeID_V_D_S]));

        d_Vsb_dV_D_S =  0.0;
        d_Vsb_dV_S_BP = (-d_probeVars[admsProbeID_V_S_BP][admsProbeID_V_S_BP]);
        Vsb = (-(probeVars[admsProbeID_V_S_BP]));

        d_Vjun_s_dV_S_BS = d_probeVars[admsProbeID_V_S_BS][admsProbeID_V_S_BS];
        Vjun_s = (probeVars[admsProbeID_V_S_BS]);

        d_Vjun_d_dV_D_BD = d_probeVars[admsProbeID_V_D_BD][admsProbeID_V_D_BD];
        Vjun_d = (probeVars[admsProbeID_V_D_BD]);
      }

      d_VgsPrime_dV_GP_S = d_Vgs_dV_GP_S;
      VgsPrime = Vgs;

      d_VsbPrime_dV_S_BP = d_Vsb_dV_S_BP;
      VsbPrime = Vsb;

      d_VdbPrime_dV_S_BP = d_Vsb_dV_S_BP;
      d_VdbPrime_dV_D_S = (d_Vds_dV_D_S+d_Vsb_dV_D_S);
      VdbPrime = (Vds+Vsb);

      d_VgdPrime_dV_D_S = (d_Vgs_dV_D_S-d_Vds_dV_D_S);
      d_VgdPrime_dV_GP_S = d_Vgs_dV_GP_S;
      VgdPrime = (Vgs-Vds);

      d_xgs_ov_dV_GP_S = ((-d_VgsPrime_dV_GP_S)*(model_.inv_phit));
      xgs_ov = ((-VgsPrime)*(model_.inv_phit));

      d_xgd_ov_dV_D_S = ((-d_VgdPrime_dV_D_S)*(model_.inv_phit));
      d_xgd_ov_dV_GP_S = ((-d_VgdPrime_dV_GP_S)*(model_.inv_phit));
      xgd_ov = ((-VgdPrime)*(model_.inv_phit));
      sigVds = 1.0;
      if ((Vds<0.0))
      {
        sigVds = (-1.0);

        d_Vgs_dV_D_S = (d_Vgs_dV_D_S-d_Vds_dV_D_S);
        Vgs = (Vgs-Vds);

        d_Vsb_dV_D_S = (d_Vsb_dV_D_S+d_Vds_dV_D_S);
        Vsb = (Vsb+Vds);

        d_Vds_dV_D_S = (-d_Vds_dV_D_S);
        Vds = (-Vds);
      }

      d_Vgd_dV_GP_S = d_Vgs_dV_GP_S;
      d_Vgd_dV_D_S = (d_Vgs_dV_D_S-d_Vds_dV_D_S);
      Vgd = (Vgs-Vds);

      d_Vdb_dV_S_BP = d_Vsb_dV_S_BP;
      d_Vdb_dV_D_S = (d_Vds_dV_D_S+d_Vsb_dV_D_S);
      Vdb = (Vds+Vsb);
      {
        double value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+bphi));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_temp_dV_GP_S =  0.0;
        d_temp_dV_S_BP = (0.5*((d_Vdb_dV_S_BP+d_Vsb_dV_S_BP)-(deriv_sqrt_0_d0*((((Vdb-Vsb)*(d_Vdb_dV_S_BP-d_Vsb_dV_S_BP))+((d_Vdb_dV_S_BP-d_Vsb_dV_S_BP)*(Vdb-Vsb)))))));
        d_temp_dV_D_S = (0.5*((d_Vdb_dV_D_S+d_Vsb_dV_D_S)-(deriv_sqrt_0_d0*((((Vdb-Vsb)*(d_Vdb_dV_D_S-d_Vsb_dV_D_S))+((d_Vdb_dV_D_S-d_Vsb_dV_D_S)*(Vdb-Vsb)))))));
        temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+phix);
      }
      {
        double value_sqrt_0 = sqrt((((temp)*(temp))+aphi));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_Vsbstar_dV_S_BP = (d_Vsb_dV_S_BP-(0.5*((d_temp_dV_S_BP)-(deriv_sqrt_0_d0*((((temp)*(d_temp_dV_S_BP))+((d_temp_dV_S_BP)*(temp))))))));
        d_Vsbstar_dV_D_S = (d_Vsb_dV_D_S-(0.5*((d_temp_dV_D_S)-(deriv_sqrt_0_d0*((((temp)*(d_temp_dV_D_S))+((d_temp_dV_D_S)*(temp))))))));
        Vsbstar = ((Vsb-(0.5*((temp)-value_sqrt_0)))+phix1);
      }

      d_Vdbstar_dV_S_BP = d_Vsbstar_dV_S_BP;
      d_Vdbstar_dV_D_S = (d_Vds_dV_D_S+d_Vsbstar_dV_D_S);
      Vdbstar = (Vds+Vsbstar);

      d_Vgbstar_dV_S_BP = d_Vsbstar_dV_S_BP;
      d_Vgbstar_dV_GP_S = d_Vgs_dV_GP_S;
      d_Vgbstar_dV_D_S = (d_Vgs_dV_D_S+d_Vsbstar_dV_D_S);
      Vgbstar = (Vgs+Vsbstar);

      d_Vgb1_dV_S_BP = d_Vgbstar_dV_S_BP;
      d_Vgb1_dV_GP_S = d_Vgbstar_dV_GP_S;
      d_Vgb1_dV_D_S = d_Vgbstar_dV_D_S;
      Vgb1 = (Vgbstar-VFB_i);
      {
        double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_Vdsx_dV_D_S = (deriv_sqrt_0_d0*(((Vds*d_Vds_dV_D_S)+(d_Vds_dV_D_S*Vds))));
        Vdsx = (value_sqrt_0-0.1);
      }

      d_Vsbx_dV_S_BP = d_Vsbstar_dV_S_BP;
      d_Vsbx_dV_D_S = (d_Vsbstar_dV_D_S+(0.5*(d_Vds_dV_D_S-d_Vdsx_dV_D_S)));
      Vsbx = (Vsbstar+(0.5*(Vds-Vdsx)));

      d_delVg_dV_S_BP = (CF_i*(Vdsx*(CFB_i*d_Vsbx_dV_S_BP)));
      d_delVg_dV_D_S = (CF_i*((Vdsx*(CFB_i*d_Vsbx_dV_D_S))+(d_Vdsx_dV_D_S*(1+(CFB_i*Vsbx)))));
      delVg = (CF_i*(Vdsx*(1+(CFB_i*Vsbx))));

      d_Vgb1_dV_S_BP = (d_Vgb1_dV_S_BP+d_delVg_dV_S_BP);
      d_Vgb1_dV_D_S = (d_Vgb1_dV_D_S+d_delVg_dV_D_S);
      Vgb1 = (Vgb1+delVg);

      d_xg_dV_S_BP = (d_Vgb1_dV_S_BP*inv_phit1);
      d_xg_dV_GP_S = (d_Vgb1_dV_GP_S*inv_phit1);
      d_xg_dV_D_S = (d_Vgb1_dV_D_S*inv_phit1);
      xg = (Vgb1*inv_phit1);
      if ((DNSUB_i>0.0))
      {
        {
          double value_sqrt_0 = sqrt((((-((Vgs+Vsb)-VNSUB_i))*(-((Vgs+Vsb)-VNSUB_i)))+NSLP_i));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_Dnsub_dV_S_BP = ((DNSUB_i*0.5)*((+d_Vsb_dV_S_BP)+(deriv_sqrt_0_d0*((((-((Vgs+Vsb)-VNSUB_i))*(-d_Vsb_dV_S_BP))+((-d_Vsb_dV_S_BP)*(-((Vgs+Vsb)-VNSUB_i))))))));
          d_Dnsub_dV_GP_S = ((DNSUB_i*0.5)*((+d_Vgs_dV_GP_S)+(deriv_sqrt_0_d0*((((-((Vgs+Vsb)-VNSUB_i))*(-d_Vgs_dV_GP_S))+((-d_Vgs_dV_GP_S)*(-((Vgs+Vsb)-VNSUB_i))))))));
          d_Dnsub_dV_D_S = ((DNSUB_i*0.5)*((+(d_Vgs_dV_D_S+d_Vsb_dV_D_S))+(deriv_sqrt_0_d0*((((-((Vgs+Vsb)-VNSUB_i))*(-(d_Vgs_dV_D_S+d_Vsb_dV_D_S)))+((-(d_Vgs_dV_D_S+d_Vsb_dV_D_S))*(-((Vgs+Vsb)-VNSUB_i))))))));
          Dnsub = ((DNSUB_i*0.5)*((+((Vgs+Vsb)-VNSUB_i))+value_sqrt_0));
        }
        {
          double value_sqrt_0 = sqrt((1.0+Dnsub));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_Gf_dV_S_BP = (G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_S_BP)));
          d_Gf_dV_GP_S = (G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_GP_S)));
          d_Gf_dV_D_S = (G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_D_S)));
          Gf = (G_0*value_sqrt_0);
        }
      }
      else
      {

        d_Gf_dV_D_S = d_Gf_dV_GP_S = d_Gf_dV_S_BP =  0.0;
        Gf = G_0;
      }

      d_Gf2_dV_S_BP = ((Gf*d_Gf_dV_S_BP)+(d_Gf_dV_S_BP*Gf));
      d_Gf2_dV_GP_S = ((Gf*d_Gf_dV_GP_S)+(d_Gf_dV_GP_S*Gf));
      d_Gf2_dV_D_S = ((Gf*d_Gf_dV_D_S)+(d_Gf_dV_D_S*Gf));
      Gf2 = (Gf*Gf);

      d_inv_Gf2_dV_S_BP = (-d_Gf2_dV_S_BP/Gf2/Gf2);
      d_inv_Gf2_dV_GP_S = (-d_Gf2_dV_GP_S/Gf2/Gf2);
      d_inv_Gf2_dV_D_S = (-d_Gf2_dV_D_S/Gf2/Gf2);
      inv_Gf2 = (1.0/Gf2);

      d_xi_dV_S_BP = (d_Gf_dV_S_BP*7.0710678118654746e-01);
      d_xi_dV_GP_S = (d_Gf_dV_GP_S*7.0710678118654746e-01);
      d_xi_dV_D_S = (d_Gf_dV_D_S*7.0710678118654746e-01);
      xi = (1.0+(Gf*7.0710678118654746e-01));

      d_inv_xi_dV_S_BP = (-d_xi_dV_S_BP/xi/xi);
      d_inv_xi_dV_GP_S = (-d_xi_dV_GP_S/xi/xi);
      d_inv_xi_dV_D_S = (-d_xi_dV_D_S/xi/xi);
      inv_xi = (1.0/xi);

      d_Ux_dV_S_BP = (d_Vsbstar_dV_S_BP*inv_phit1);
      d_Ux_dV_D_S = (d_Vsbstar_dV_D_S*inv_phit1);
      Ux = (Vsbstar*inv_phit1);

      d_xn_s_dV_S_BP = d_Ux_dV_S_BP;
      d_xn_s_dV_D_S = d_Ux_dV_D_S;
      xn_s = ((phib*inv_phit1)+Ux);
      if ((xn_s<4.6051701859880916e+02))
      {
        {
          double value_exp_0 = exp((-xn_s));
          double  deriv_exp_0_d0 = value_exp_0;

          d_delta_ns_dV_S_BP = (deriv_exp_0_d0*((-d_xn_s_dV_S_BP)));
          d_delta_ns_dV_D_S = (deriv_exp_0_d0*((-d_xn_s_dV_D_S)));
          delta_ns = value_exp_0;
        }
      }
      else
      {

        d_delta_ns_dV_S_BP = (-1.0e-200*(((xn_s-4.6051701859880916e+02)*(0.5*(((xn_s-4.6051701859880916e+02)*(d_xn_s_dV_S_BP*3.3333333333333333e-01))+(d_xn_s_dV_S_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_xn_s_dV_S_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
        d_delta_ns_dV_D_S = (-1.0e-200*(((xn_s-4.6051701859880916e+02)*(0.5*(((xn_s-4.6051701859880916e+02)*(d_xn_s_dV_D_S*3.3333333333333333e-01))+(d_xn_s_dV_D_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_xn_s_dV_D_S*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
        delta_ns = (1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
      }

      d_margin_dV_S_BP = (1e-5*d_xi_dV_S_BP);
      d_margin_dV_GP_S = (1e-5*d_xi_dV_GP_S);
      d_margin_dV_D_S = (1e-5*d_xi_dV_D_S);
      margin = (1e-5*xi);
      if ((fabs(xg)<=margin))
      {

        d_SP_S_temp1_dV_S_BP = ((((inv_xi*d_inv_xi_dV_S_BP)+(d_inv_xi_dV_S_BP*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
        d_SP_S_temp1_dV_GP_S = ((((inv_xi*d_inv_xi_dV_GP_S)+(d_inv_xi_dV_GP_S*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
        d_SP_S_temp1_dV_D_S = ((((inv_xi*d_inv_xi_dV_D_S)+(d_inv_xi_dV_D_S*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
        SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);

        d_x_s_dV_S_BP = (((xg*inv_xi)*((((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_S_BP)+((((xg*(1.0-delta_ns))*d_Gf_dV_S_BP)+(((xg*(-d_delta_ns_dV_S_BP))+(d_xg_dV_S_BP*(1.0-delta_ns)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_S_BP)+(d_xg_dV_S_BP*inv_xi))*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1))));
        d_x_s_dV_GP_S = (((xg*inv_xi)*((((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_GP_S)+((((xg*(1.0-delta_ns))*d_Gf_dV_GP_S)+((d_xg_dV_GP_S*(1.0-delta_ns))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_GP_S)+(d_xg_dV_GP_S*inv_xi))*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1))));
        d_x_s_dV_D_S = (((xg*inv_xi)*((((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_D_S)+((((xg*(1.0-delta_ns))*d_Gf_dV_D_S)+(((xg*(-d_delta_ns_dV_D_S))+(d_xg_dV_D_S*(1.0-delta_ns)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_D_S)+(d_xg_dV_D_S*inv_xi))*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1))));
        x_s = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
      }
      else
      {
        if ((xg<(-margin)))
        {

          d_SP_S_yg_dV_S_BP = (-d_xg_dV_S_BP);
          d_SP_S_yg_dV_GP_S = (-d_xg_dV_GP_S);
          d_SP_S_yg_dV_D_S = (-d_xg_dV_D_S);
          SP_S_yg = (-xg);

          d_SP_S_ysub_dV_S_BP = (1.25*((SP_S_yg*d_inv_xi_dV_S_BP)+(d_SP_S_yg_dV_S_BP*inv_xi)));
          d_SP_S_ysub_dV_GP_S = (1.25*((SP_S_yg*d_inv_xi_dV_GP_S)+(d_SP_S_yg_dV_GP_S*inv_xi)));
          d_SP_S_ysub_dV_D_S = (1.25*((SP_S_yg*d_inv_xi_dV_D_S)+(d_SP_S_yg_dV_D_S*inv_xi)));
          SP_S_ysub = (1.25*(SP_S_yg*inv_xi));
          {
            double value_sqrt_0 = sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_SP_S_eta_dV_S_BP = (0.5*(d_SP_S_ysub_dV_S_BP-(deriv_sqrt_0_d0*((((SP_S_ysub-6.0)*d_SP_S_ysub_dV_S_BP)+(d_SP_S_ysub_dV_S_BP*(SP_S_ysub-6.0)))))));
            d_SP_S_eta_dV_GP_S = (0.5*(d_SP_S_ysub_dV_GP_S-(deriv_sqrt_0_d0*((((SP_S_ysub-6.0)*d_SP_S_ysub_dV_GP_S)+(d_SP_S_ysub_dV_GP_S*(SP_S_ysub-6.0)))))));
            d_SP_S_eta_dV_D_S = (0.5*(d_SP_S_ysub_dV_D_S-(deriv_sqrt_0_d0*((((SP_S_ysub-6.0)*d_SP_S_ysub_dV_D_S)+(d_SP_S_ysub_dV_D_S*(SP_S_ysub-6.0)))))));
            SP_S_eta = (0.5*((SP_S_ysub+10)-value_sqrt_0));
          }

          d_SP_S_temp_dV_S_BP = (d_SP_S_yg_dV_S_BP-d_SP_S_eta_dV_S_BP);
          d_SP_S_temp_dV_GP_S = (d_SP_S_yg_dV_GP_S-d_SP_S_eta_dV_GP_S);
          d_SP_S_temp_dV_D_S = (d_SP_S_yg_dV_D_S-d_SP_S_eta_dV_D_S);
          SP_S_temp = (SP_S_yg-SP_S_eta);

          d_SP_S_a_dV_S_BP = (((SP_S_temp*d_SP_S_temp_dV_S_BP)+(d_SP_S_temp_dV_S_BP*SP_S_temp))+((Gf2*d_SP_S_eta_dV_S_BP)+(d_Gf2_dV_S_BP*(SP_S_eta+1.0))));
          d_SP_S_a_dV_GP_S = (((SP_S_temp*d_SP_S_temp_dV_GP_S)+(d_SP_S_temp_dV_GP_S*SP_S_temp))+((Gf2*d_SP_S_eta_dV_GP_S)+(d_Gf2_dV_GP_S*(SP_S_eta+1.0))));
          d_SP_S_a_dV_D_S = (((SP_S_temp*d_SP_S_temp_dV_D_S)+(d_SP_S_temp_dV_D_S*SP_S_temp))+((Gf2*d_SP_S_eta_dV_D_S)+(d_Gf2_dV_D_S*(SP_S_eta+1.0))));
          SP_S_a = ((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0)));

          d_SP_S_c_dV_S_BP = ((2.0*d_SP_S_temp_dV_S_BP)-d_Gf2_dV_S_BP);
          d_SP_S_c_dV_GP_S = ((2.0*d_SP_S_temp_dV_GP_S)-d_Gf2_dV_GP_S);
          d_SP_S_c_dV_D_S = ((2.0*d_SP_S_temp_dV_D_S)-d_Gf2_dV_D_S);
          SP_S_c = ((2.0*SP_S_temp)-Gf2);
          {
            double value_log_0 = log((SP_S_a*inv_Gf2));
            double  deriv_log_0_d0 = (1.0/(SP_S_a*inv_Gf2));

            d_SP_S_tau_dV_S_BP = ((-d_SP_S_eta_dV_S_BP)+(deriv_log_0_d0*(((SP_S_a*d_inv_Gf2_dV_S_BP)+(d_SP_S_a_dV_S_BP*inv_Gf2)))));
            d_SP_S_tau_dV_GP_S = ((-d_SP_S_eta_dV_GP_S)+(deriv_log_0_d0*(((SP_S_a*d_inv_Gf2_dV_GP_S)+(d_SP_S_a_dV_GP_S*inv_Gf2)))));
            d_SP_S_tau_dV_D_S = ((-d_SP_S_eta_dV_D_S)+(deriv_log_0_d0*(((SP_S_a*d_inv_Gf2_dV_D_S)+(d_SP_S_a_dV_D_S*inv_Gf2)))));
            SP_S_tau = ((-SP_S_eta)+value_log_0);
          }

          d_nu_dV_S_BP = (d_SP_S_a_dV_S_BP+d_SP_S_c_dV_S_BP);
          d_nu_dV_GP_S = (d_SP_S_a_dV_GP_S+d_SP_S_c_dV_GP_S);
          d_nu_dV_D_S = (d_SP_S_a_dV_D_S+d_SP_S_c_dV_D_S);
          nu = (SP_S_a+SP_S_c);

          d_mutau_dV_S_BP = (((nu*d_nu_dV_S_BP)+(d_nu_dV_S_BP*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_S_BP)+(d_SP_S_c_dV_S_BP*SP_S_c)))-d_SP_S_a_dV_S_BP))+(d_SP_S_tau_dV_S_BP*((0.5*(SP_S_c*SP_S_c))-SP_S_a))));
          d_mutau_dV_GP_S = (((nu*d_nu_dV_GP_S)+(d_nu_dV_GP_S*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_GP_S)+(d_SP_S_c_dV_GP_S*SP_S_c)))-d_SP_S_a_dV_GP_S))+(d_SP_S_tau_dV_GP_S*((0.5*(SP_S_c*SP_S_c))-SP_S_a))));
          d_mutau_dV_D_S = (((nu*d_nu_dV_D_S)+(d_nu_dV_D_S*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_D_S)+(d_SP_S_c_dV_D_S*SP_S_c)))-d_SP_S_a_dV_D_S))+(d_SP_S_tau_dV_D_S*((0.5*(SP_S_c*SP_S_c))-SP_S_a))));
          mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));

          d_SP_S_y0_dV_S_BP = (d_SP_S_eta_dV_S_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*(((SP_S_a*nu)*d_SP_S_tau_dV_S_BP)+(((SP_S_a*d_nu_dV_S_BP)+(d_SP_S_a_dV_S_BP*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_S_BP+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_S_BP)+(d_SP_S_c_dV_S_BP*SP_S_c))*3.3333333333333333e-01)-d_SP_S_a_dV_S_BP))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_S_BP)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_S_BP)+((((nu/mutau)*d_SP_S_tau_dV_S_BP)+(((mutau*d_nu_dV_S_BP-nu*d_mutau_dV_S_BP)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
          d_SP_S_y0_dV_GP_S = (d_SP_S_eta_dV_GP_S+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*(((SP_S_a*nu)*d_SP_S_tau_dV_GP_S)+(((SP_S_a*d_nu_dV_GP_S)+(d_SP_S_a_dV_GP_S*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_S+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_GP_S)+(d_SP_S_c_dV_GP_S*SP_S_c))*3.3333333333333333e-01)-d_SP_S_a_dV_GP_S))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_S)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_S)+((((nu/mutau)*d_SP_S_tau_dV_GP_S)+(((mutau*d_nu_dV_GP_S-nu*d_mutau_dV_GP_S)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
          d_SP_S_y0_dV_D_S = (d_SP_S_eta_dV_D_S+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*(((SP_S_a*nu)*d_SP_S_tau_dV_D_S)+(((SP_S_a*d_nu_dV_D_S)+(d_SP_S_a_dV_D_S*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_D_S+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_D_S)+(d_SP_S_c_dV_D_S*SP_S_c))*3.3333333333333333e-01)-d_SP_S_a_dV_D_S))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_D_S)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_D_S)+((((nu/mutau)*d_SP_S_tau_dV_D_S)+(((mutau*d_nu_dV_D_S-nu*d_mutau_dV_D_S)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
          SP_S_y0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
          if ((SP_S_y0<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp(SP_S_y0);
              double  deriv_exp_0_d0 = value_exp_0;

              d_SP_S_delta0_dV_S_BP = (deriv_exp_0_d0*(d_SP_S_y0_dV_S_BP));
              d_SP_S_delta0_dV_GP_S = (deriv_exp_0_d0*(d_SP_S_y0_dV_GP_S));
              d_SP_S_delta0_dV_D_S = (deriv_exp_0_d0*(d_SP_S_y0_dV_D_S));
              SP_S_delta0 = value_exp_0;
            }
          }
          else
          {

            d_SP_S_delta0_dV_S_BP = (1.0e100*(((SP_S_y0-2.3025850929940458e+02)*(0.5*(((SP_S_y0-2.3025850929940458e+02)*(d_SP_S_y0_dV_S_BP*3.3333333333333333e-01))+(d_SP_S_y0_dV_S_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_y0_dV_S_BP*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            d_SP_S_delta0_dV_GP_S = (1.0e100*(((SP_S_y0-2.3025850929940458e+02)*(0.5*(((SP_S_y0-2.3025850929940458e+02)*(d_SP_S_y0_dV_GP_S*3.3333333333333333e-01))+(d_SP_S_y0_dV_GP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_y0_dV_GP_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            d_SP_S_delta0_dV_D_S = (1.0e100*(((SP_S_y0-2.3025850929940458e+02)*(0.5*(((SP_S_y0-2.3025850929940458e+02)*(d_SP_S_y0_dV_D_S*3.3333333333333333e-01))+(d_SP_S_y0_dV_D_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_y0_dV_D_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            SP_S_delta0 = (1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
          }

          d_SP_S_delta1_dV_S_BP = (-d_SP_S_delta0_dV_S_BP/SP_S_delta0/SP_S_delta0);
          d_SP_S_delta1_dV_GP_S = (-d_SP_S_delta0_dV_GP_S/SP_S_delta0/SP_S_delta0);
          d_SP_S_delta1_dV_D_S = (-d_SP_S_delta0_dV_D_S/SP_S_delta0/SP_S_delta0);
          SP_S_delta1 = (1.0/SP_S_delta0);

          d_SP_S_temp_dV_S_BP = (-((SP_S_y0*d_SP_S_y0_dV_S_BP)+(d_SP_S_y0_dV_S_BP*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
          d_SP_S_temp_dV_GP_S = (-((SP_S_y0*d_SP_S_y0_dV_GP_S)+(d_SP_S_y0_dV_GP_S*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
          d_SP_S_temp_dV_D_S = (-((SP_S_y0*d_SP_S_y0_dV_D_S)+(d_SP_S_y0_dV_D_S*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
          SP_S_temp = (1.0/(2.0+(SP_S_y0*SP_S_y0)));

          d_SP_S_xi0_dV_S_BP = (((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_S_BP)+(((SP_S_y0*d_SP_S_y0_dV_S_BP)+(d_SP_S_y0_dV_S_BP*SP_S_y0))*SP_S_temp));
          d_SP_S_xi0_dV_GP_S = (((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_GP_S)+(((SP_S_y0*d_SP_S_y0_dV_GP_S)+(d_SP_S_y0_dV_GP_S*SP_S_y0))*SP_S_temp));
          d_SP_S_xi0_dV_D_S = (((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_D_S)+(((SP_S_y0*d_SP_S_y0_dV_D_S)+(d_SP_S_y0_dV_D_S*SP_S_y0))*SP_S_temp));
          SP_S_xi0 = ((SP_S_y0*SP_S_y0)*SP_S_temp);

          d_SP_S_xi1_dV_S_BP = (4.0*(((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_S_BP)+(((SP_S_y0*d_SP_S_temp_dV_S_BP)+(d_SP_S_y0_dV_S_BP*SP_S_temp))*SP_S_temp)));
          d_SP_S_xi1_dV_GP_S = (4.0*(((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_GP_S)+(((SP_S_y0*d_SP_S_temp_dV_GP_S)+(d_SP_S_y0_dV_GP_S*SP_S_temp))*SP_S_temp)));
          d_SP_S_xi1_dV_D_S = (4.0*(((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_D_S)+(((SP_S_y0*d_SP_S_temp_dV_D_S)+(d_SP_S_y0_dV_D_S*SP_S_temp))*SP_S_temp)));
          SP_S_xi1 = (4.0*((SP_S_y0*SP_S_temp)*SP_S_temp));

          d_SP_S_xi2_dV_S_BP = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_S_BP)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_S_BP)+(((8.0*d_SP_S_temp_dV_S_BP)-(12.0*d_SP_S_xi0_dV_S_BP))*SP_S_temp))*SP_S_temp));
          d_SP_S_xi2_dV_GP_S = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_S)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_S)+(((8.0*d_SP_S_temp_dV_GP_S)-(12.0*d_SP_S_xi0_dV_GP_S))*SP_S_temp))*SP_S_temp));
          d_SP_S_xi2_dV_D_S = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_D_S)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_D_S)+(((8.0*d_SP_S_temp_dV_D_S)-(12.0*d_SP_S_xi0_dV_D_S))*SP_S_temp))*SP_S_temp));
          SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

          d_SP_S_temp_dV_S_BP = (d_SP_S_yg_dV_S_BP-d_SP_S_y0_dV_S_BP);
          d_SP_S_temp_dV_GP_S = (d_SP_S_yg_dV_GP_S-d_SP_S_y0_dV_GP_S);
          d_SP_S_temp_dV_D_S = (d_SP_S_yg_dV_D_S-d_SP_S_y0_dV_D_S);
          SP_S_temp = (SP_S_yg-SP_S_y0);

          d_SP_S_temp1_dV_GP_S = (delta_ns*d_SP_S_delta1_dV_GP_S);
          d_SP_S_temp1_dV_S_BP = ((delta_ns*d_SP_S_delta1_dV_S_BP)+(d_delta_ns_dV_S_BP*SP_S_delta1));
          d_SP_S_temp1_dV_D_S = ((delta_ns*d_SP_S_delta1_dV_D_S)+(d_delta_ns_dV_D_S*SP_S_delta1));
          SP_S_temp1 = (delta_ns*SP_S_delta1);

          d_SP_S_pC_dV_S_BP = ((2.0*d_SP_S_temp_dV_S_BP)+((Gf2*((d_SP_S_delta0_dV_S_BP-d_SP_S_temp1_dV_S_BP)+((delta_ns*(-d_SP_S_xi1_dV_S_BP))+(d_delta_ns_dV_S_BP*(1.0-SP_S_xi1)))))+(d_Gf2_dV_S_BP*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1))))));
          d_SP_S_pC_dV_GP_S = ((2.0*d_SP_S_temp_dV_GP_S)+((Gf2*((d_SP_S_delta0_dV_GP_S-d_SP_S_temp1_dV_GP_S)+(delta_ns*(-d_SP_S_xi1_dV_GP_S))))+(d_Gf2_dV_GP_S*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1))))));
          d_SP_S_pC_dV_D_S = ((2.0*d_SP_S_temp_dV_D_S)+((Gf2*((d_SP_S_delta0_dV_D_S-d_SP_S_temp1_dV_D_S)+((delta_ns*(-d_SP_S_xi1_dV_D_S))+(d_delta_ns_dV_D_S*(1.0-SP_S_xi1)))))+(d_Gf2_dV_D_S*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1))))));
          SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));

          d_SP_S_qC_dV_S_BP = (((SP_S_temp*d_SP_S_temp_dV_S_BP)+(d_SP_S_temp_dV_S_BP*SP_S_temp))-((Gf2*(((d_SP_S_delta0_dV_S_BP-d_SP_S_y0_dV_S_BP)+d_SP_S_temp1_dV_S_BP)+((delta_ns*(d_SP_S_y0_dV_S_BP-d_SP_S_xi0_dV_S_BP))+(d_delta_ns_dV_S_BP*((SP_S_y0-1.0)-SP_S_xi0)))))+(d_Gf2_dV_S_BP*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0))))));
          d_SP_S_qC_dV_GP_S = (((SP_S_temp*d_SP_S_temp_dV_GP_S)+(d_SP_S_temp_dV_GP_S*SP_S_temp))-((Gf2*(((d_SP_S_delta0_dV_GP_S-d_SP_S_y0_dV_GP_S)+d_SP_S_temp1_dV_GP_S)+(delta_ns*(d_SP_S_y0_dV_GP_S-d_SP_S_xi0_dV_GP_S))))+(d_Gf2_dV_GP_S*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0))))));
          d_SP_S_qC_dV_D_S = (((SP_S_temp*d_SP_S_temp_dV_D_S)+(d_SP_S_temp_dV_D_S*SP_S_temp))-((Gf2*(((d_SP_S_delta0_dV_D_S-d_SP_S_y0_dV_D_S)+d_SP_S_temp1_dV_D_S)+((delta_ns*(d_SP_S_y0_dV_D_S-d_SP_S_xi0_dV_D_S))+(d_delta_ns_dV_D_S*((SP_S_y0-1.0)-SP_S_xi0)))))+(d_Gf2_dV_D_S*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0))))));
          SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));

          d_SP_S_temp_dV_S_BP = (-((Gf2*((d_SP_S_delta0_dV_S_BP+d_SP_S_temp1_dV_S_BP)-((delta_ns*d_SP_S_xi2_dV_S_BP)+(d_delta_ns_dV_S_BP*SP_S_xi2))))+(d_Gf2_dV_S_BP*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2)))));
          d_SP_S_temp_dV_GP_S = (-((Gf2*((d_SP_S_delta0_dV_GP_S+d_SP_S_temp1_dV_GP_S)-(delta_ns*d_SP_S_xi2_dV_GP_S)))+(d_Gf2_dV_GP_S*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2)))));
          d_SP_S_temp_dV_D_S = (-((Gf2*((d_SP_S_delta0_dV_D_S+d_SP_S_temp1_dV_D_S)-((delta_ns*d_SP_S_xi2_dV_D_S)+(d_delta_ns_dV_D_S*SP_S_xi2))))+(d_Gf2_dV_D_S*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2)))));
          SP_S_temp = (2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));

          d_SP_S_temp_dV_S_BP = (((SP_S_pC*d_SP_S_pC_dV_S_BP)+(d_SP_S_pC_dV_S_BP*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_S_BP)+(d_SP_S_qC_dV_S_BP*SP_S_temp))));
          d_SP_S_temp_dV_GP_S = (((SP_S_pC*d_SP_S_pC_dV_GP_S)+(d_SP_S_pC_dV_GP_S*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_GP_S)+(d_SP_S_qC_dV_GP_S*SP_S_temp))));
          d_SP_S_temp_dV_D_S = (((SP_S_pC*d_SP_S_pC_dV_D_S)+(d_SP_S_pC_dV_D_S*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_D_S)+(d_SP_S_qC_dV_D_S*SP_S_temp))));
          SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
          {
            double value_sqrt_0 = sqrt(SP_S_temp);
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_x_s_dV_S_BP = ((-d_SP_S_y0_dV_S_BP)-(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_S_BP-SP_S_qC*(d_SP_S_pC_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_S_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
            d_x_s_dV_GP_S = ((-d_SP_S_y0_dV_GP_S)-(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_S-SP_S_qC*(d_SP_S_pC_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_S))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
            d_x_s_dV_D_S = ((-d_SP_S_y0_dV_D_S)-(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_D_S-SP_S_qC*(d_SP_S_pC_dV_D_S+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_D_S))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
            x_s = ((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
          }
        }
        else
        {

          d_SP_xg1_dV_S_BP = (-(d_Gf_dV_S_BP*7.324648775608221e-001)/(x1+(Gf*7.324648775608221e-001))/(x1+(Gf*7.324648775608221e-001)));
          d_SP_xg1_dV_GP_S = (-(d_Gf_dV_GP_S*7.324648775608221e-001)/(x1+(Gf*7.324648775608221e-001))/(x1+(Gf*7.324648775608221e-001)));
          d_SP_xg1_dV_D_S = (-(d_Gf_dV_D_S*7.324648775608221e-001)/(x1+(Gf*7.324648775608221e-001))/(x1+(Gf*7.324648775608221e-001)));
          SP_xg1 = (1.0/(x1+(Gf*7.324648775608221e-001)));

          d_SP_S_A_fac_dV_S_BP = (((((xi*x1)*SP_xg1)-1.0)*d_SP_xg1_dV_S_BP)+((((xi*x1)*d_SP_xg1_dV_S_BP)+((d_xi_dV_S_BP*x1)*SP_xg1))*SP_xg1));
          d_SP_S_A_fac_dV_GP_S = (((((xi*x1)*SP_xg1)-1.0)*d_SP_xg1_dV_GP_S)+((((xi*x1)*d_SP_xg1_dV_GP_S)+((d_xi_dV_GP_S*x1)*SP_xg1))*SP_xg1));
          d_SP_S_A_fac_dV_D_S = (((((xi*x1)*SP_xg1)-1.0)*d_SP_xg1_dV_D_S)+((((xi*x1)*d_SP_xg1_dV_D_S)+((d_xi_dV_D_S*x1)*SP_xg1))*SP_xg1));
          SP_S_A_fac = ((((xi*x1)*SP_xg1)-1.0)*SP_xg1);

          d_SP_S_xbar_dV_S_BP = (((xg*inv_xi)*((SP_S_A_fac*d_xg_dV_S_BP)+(d_SP_S_A_fac_dV_S_BP*xg)))+(((xg*d_inv_xi_dV_S_BP)+(d_xg_dV_S_BP*inv_xi))*(1.0+(SP_S_A_fac*xg))));
          d_SP_S_xbar_dV_GP_S = (((xg*inv_xi)*((SP_S_A_fac*d_xg_dV_GP_S)+(d_SP_S_A_fac_dV_GP_S*xg)))+(((xg*d_inv_xi_dV_GP_S)+(d_xg_dV_GP_S*inv_xi))*(1.0+(SP_S_A_fac*xg))));
          d_SP_S_xbar_dV_D_S = (((xg*inv_xi)*((SP_S_A_fac*d_xg_dV_D_S)+(d_SP_S_A_fac_dV_D_S*xg)))+(((xg*d_inv_xi_dV_D_S)+(d_xg_dV_D_S*inv_xi))*(1.0+(SP_S_A_fac*xg))));
          SP_S_xbar = ((xg*inv_xi)*(1.0+(SP_S_A_fac*xg)));
          if (((-SP_S_xbar)>(-2.3025850929940458e+02)))
          {
            {
              double value_exp_0 = exp((-SP_S_xbar));
              double  deriv_exp_0_d0 = value_exp_0;

              d_SP_S_temp_dV_S_BP = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_S_BP)));
              d_SP_S_temp_dV_GP_S = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_GP_S)));
              d_SP_S_temp_dV_D_S = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_D_S)));
              SP_S_temp = value_exp_0;
            }
          }
          else
          {

            d_SP_S_temp_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*((((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-d_SP_S_xbar_dV_S_BP))*3.3333333333333333e-01))+((-(-d_SP_S_xbar_dV_S_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+((-(-d_SP_S_xbar_dV_S_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
            d_SP_S_temp_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*((((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-d_SP_S_xbar_dV_GP_S))*3.3333333333333333e-01))+((-(-d_SP_S_xbar_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+((-(-d_SP_S_xbar_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
            d_SP_S_temp_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*((((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-d_SP_S_xbar_dV_D_S))*3.3333333333333333e-01))+((-(-d_SP_S_xbar_dV_D_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+((-(-d_SP_S_xbar_dV_D_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
            SP_S_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
          }

          d_SP_S_w_dV_S_BP = (-d_SP_S_temp_dV_S_BP);
          d_SP_S_w_dV_GP_S = (-d_SP_S_temp_dV_GP_S);
          d_SP_S_w_dV_D_S = (-d_SP_S_temp_dV_D_S);
          SP_S_w = (1.0-SP_S_temp);
          {
            double value_sqrt_0 = sqrt(((xg+(Gf2*0.25))-SP_S_w));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_SP_S_x1_dV_S_BP = ((d_xg_dV_S_BP+(d_Gf2_dV_S_BP*0.5))-((Gf*(deriv_sqrt_0_d0*(((d_xg_dV_S_BP+(d_Gf2_dV_S_BP*0.25))-d_SP_S_w_dV_S_BP))))+(d_Gf_dV_S_BP*value_sqrt_0)));
            d_SP_S_x1_dV_GP_S = ((d_xg_dV_GP_S+(d_Gf2_dV_GP_S*0.5))-((Gf*(deriv_sqrt_0_d0*(((d_xg_dV_GP_S+(d_Gf2_dV_GP_S*0.25))-d_SP_S_w_dV_GP_S))))+(d_Gf_dV_GP_S*value_sqrt_0)));
            d_SP_S_x1_dV_D_S = ((d_xg_dV_D_S+(d_Gf2_dV_D_S*0.5))-((Gf*(deriv_sqrt_0_d0*(((d_xg_dV_D_S+(d_Gf2_dV_D_S*0.25))-d_SP_S_w_dV_D_S))))+(d_Gf_dV_D_S*value_sqrt_0)));
            SP_S_x1 = ((xg+(Gf2*0.5))-(Gf*value_sqrt_0));
          }

          d_SP_S_bx_dV_GP_S =  0.0;
          d_SP_S_bx_dV_S_BP = d_xn_s_dV_S_BP;
          d_SP_S_bx_dV_D_S = d_xn_s_dV_D_S;
          SP_S_bx = (xn_s+3.0);
          {
            double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
            double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
            double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

            d_SP_S_eta_dV_S_BP = ((0.5*((d_SP_S_x1_dV_S_BP+d_SP_S_bx_dV_S_BP)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_S_BP-d_SP_S_bx_dV_S_BP))+((d_SP_S_x1_dV_S_BP-d_SP_S_bx_dV_S_BP)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_S_BP-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_S_BP)+(d_SP_S_bx_dV_S_BP*SP_S_bx)))))));
            d_SP_S_eta_dV_GP_S = ((0.5*((d_SP_S_x1_dV_GP_S+d_SP_S_bx_dV_GP_S)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_GP_S-d_SP_S_bx_dV_GP_S))+((d_SP_S_x1_dV_GP_S-d_SP_S_bx_dV_GP_S)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_GP_S-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_GP_S)+(d_SP_S_bx_dV_GP_S*SP_S_bx)))))));
            d_SP_S_eta_dV_D_S = ((0.5*((d_SP_S_x1_dV_D_S+d_SP_S_bx_dV_D_S)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_D_S-d_SP_S_bx_dV_D_S))+((d_SP_S_x1_dV_D_S-d_SP_S_bx_dV_D_S)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_D_S-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_D_S)+(d_SP_S_bx_dV_D_S*SP_S_bx)))))));
            SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
          }

          d_SP_S_temp_dV_S_BP = (d_xg_dV_S_BP-d_SP_S_eta_dV_S_BP);
          d_SP_S_temp_dV_GP_S = (d_xg_dV_GP_S-d_SP_S_eta_dV_GP_S);
          d_SP_S_temp_dV_D_S = (d_xg_dV_D_S-d_SP_S_eta_dV_D_S);
          SP_S_temp = (xg-SP_S_eta);
          {
            double value_exp_0 = exp((-SP_S_eta));
            double  deriv_exp_0_d0 = value_exp_0;

            d_SP_S_temp1_dV_S_BP = (deriv_exp_0_d0*((-d_SP_S_eta_dV_S_BP)));
            d_SP_S_temp1_dV_GP_S = (deriv_exp_0_d0*((-d_SP_S_eta_dV_GP_S)));
            d_SP_S_temp1_dV_D_S = (deriv_exp_0_d0*((-d_SP_S_eta_dV_D_S)));
            SP_S_temp1 = value_exp_0;
          }

          d_SP_S_temp2_dV_S_BP = (-((SP_S_eta*d_SP_S_eta_dV_S_BP)+(d_SP_S_eta_dV_S_BP*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
          d_SP_S_temp2_dV_GP_S = (-((SP_S_eta*d_SP_S_eta_dV_GP_S)+(d_SP_S_eta_dV_GP_S*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
          d_SP_S_temp2_dV_D_S = (-((SP_S_eta*d_SP_S_eta_dV_D_S)+(d_SP_S_eta_dV_D_S*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
          SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));

          d_SP_S_xi0_dV_S_BP = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_S_BP)+(((SP_S_eta*d_SP_S_eta_dV_S_BP)+(d_SP_S_eta_dV_S_BP*SP_S_eta))*SP_S_temp2));
          d_SP_S_xi0_dV_GP_S = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_GP_S)+(((SP_S_eta*d_SP_S_eta_dV_GP_S)+(d_SP_S_eta_dV_GP_S*SP_S_eta))*SP_S_temp2));
          d_SP_S_xi0_dV_D_S = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_D_S)+(((SP_S_eta*d_SP_S_eta_dV_D_S)+(d_SP_S_eta_dV_D_S*SP_S_eta))*SP_S_temp2));
          SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);

          d_SP_S_xi1_dV_S_BP = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_S_BP)+(((SP_S_eta*d_SP_S_temp2_dV_S_BP)+(d_SP_S_eta_dV_S_BP*SP_S_temp2))*SP_S_temp2)));
          d_SP_S_xi1_dV_GP_S = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_GP_S)+(((SP_S_eta*d_SP_S_temp2_dV_GP_S)+(d_SP_S_eta_dV_GP_S*SP_S_temp2))*SP_S_temp2)));
          d_SP_S_xi1_dV_D_S = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_D_S)+(((SP_S_eta*d_SP_S_temp2_dV_D_S)+(d_SP_S_eta_dV_D_S*SP_S_temp2))*SP_S_temp2)));
          SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));

          d_SP_S_xi2_dV_S_BP = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_S_BP)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_S_BP)+(((8.0*d_SP_S_temp2_dV_S_BP)-(12.0*d_SP_S_xi0_dV_S_BP))*SP_S_temp2))*SP_S_temp2));
          d_SP_S_xi2_dV_GP_S = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_GP_S)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_GP_S)+(((8.0*d_SP_S_temp2_dV_GP_S)-(12.0*d_SP_S_xi0_dV_GP_S))*SP_S_temp2))*SP_S_temp2));
          d_SP_S_xi2_dV_D_S = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_D_S)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_D_S)+(((8.0*d_SP_S_temp2_dV_D_S)-(12.0*d_SP_S_xi0_dV_D_S))*SP_S_temp2))*SP_S_temp2));
          SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
          {
            double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))));
            double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);

            d_SP_S_a_dV_S_BP = 0.0;
            d_SP_S_a_dV_GP_S = 0.0;
            d_SP_S_a_dV_D_S = 0.0;
            SP_S_a = value_max_0;
          }

          d_SP_S_b_dV_S_BP = (-(0.5*((Gf2*(d_SP_S_temp1_dV_S_BP-((delta_ns*d_SP_S_xi2_dV_S_BP)+(d_delta_ns_dV_S_BP*SP_S_xi2))))+(d_Gf2_dV_S_BP*(SP_S_temp1-(delta_ns*SP_S_xi2))))));
          d_SP_S_b_dV_GP_S = (-(0.5*((Gf2*(d_SP_S_temp1_dV_GP_S-(delta_ns*d_SP_S_xi2_dV_GP_S)))+(d_Gf2_dV_GP_S*(SP_S_temp1-(delta_ns*SP_S_xi2))))));
          d_SP_S_b_dV_D_S = (-(0.5*((Gf2*(d_SP_S_temp1_dV_D_S-((delta_ns*d_SP_S_xi2_dV_D_S)+(d_delta_ns_dV_D_S*SP_S_xi2))))+(d_Gf2_dV_D_S*(SP_S_temp1-(delta_ns*SP_S_xi2))))));
          SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))));

          d_SP_S_c_dV_S_BP = ((2.0*d_SP_S_temp_dV_S_BP)+((Gf2*((-d_SP_S_temp1_dV_S_BP)-((delta_ns*d_SP_S_xi1_dV_S_BP)+(d_delta_ns_dV_S_BP*(1.0+SP_S_xi1)))))+(d_Gf2_dV_S_BP*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1))))));
          d_SP_S_c_dV_GP_S = ((2.0*d_SP_S_temp_dV_GP_S)+((Gf2*((-d_SP_S_temp1_dV_GP_S)-(delta_ns*d_SP_S_xi1_dV_GP_S)))+(d_Gf2_dV_GP_S*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1))))));
          d_SP_S_c_dV_D_S = ((2.0*d_SP_S_temp_dV_D_S)+((Gf2*((-d_SP_S_temp1_dV_D_S)-((delta_ns*d_SP_S_xi1_dV_D_S)+(d_delta_ns_dV_D_S*(1.0+SP_S_xi1)))))+(d_Gf2_dV_D_S*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1))))));
          SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
          {
            double value_log_0 = log((SP_S_a/Gf2));
            double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));

            d_SP_S_tau_dV_GP_S = ((-d_SP_S_eta_dV_GP_S)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_GP_S-SP_S_a*d_Gf2_dV_GP_S)/Gf2/Gf2))));
            d_SP_S_tau_dV_S_BP = ((d_xn_s_dV_S_BP-d_SP_S_eta_dV_S_BP)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_S_BP-SP_S_a*d_Gf2_dV_S_BP)/Gf2/Gf2))));
            d_SP_S_tau_dV_D_S = ((d_xn_s_dV_D_S-d_SP_S_eta_dV_D_S)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_D_S-SP_S_a*d_Gf2_dV_D_S)/Gf2/Gf2))));
            SP_S_tau = ((xn_s-SP_S_eta)+value_log_0);
          }

          d_nu_dV_S_BP = (d_SP_S_a_dV_S_BP+d_SP_S_c_dV_S_BP);
          d_nu_dV_GP_S = (d_SP_S_a_dV_GP_S+d_SP_S_c_dV_GP_S);
          d_nu_dV_D_S = (d_SP_S_a_dV_D_S+d_SP_S_c_dV_D_S);
          nu = (SP_S_a+SP_S_c);

          d_mutau_dV_S_BP = (((nu*d_nu_dV_S_BP)+(d_nu_dV_S_BP*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_S_BP)+(d_SP_S_c_dV_S_BP*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_S_BP)+(d_SP_S_a_dV_S_BP*SP_S_b))))+(d_SP_S_tau_dV_S_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
          d_mutau_dV_GP_S = (((nu*d_nu_dV_GP_S)+(d_nu_dV_GP_S*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_GP_S)+(d_SP_S_c_dV_GP_S*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_GP_S)+(d_SP_S_a_dV_GP_S*SP_S_b))))+(d_SP_S_tau_dV_GP_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
          d_mutau_dV_D_S = (((nu*d_nu_dV_D_S)+(d_nu_dV_D_S*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_D_S)+(d_SP_S_c_dV_D_S*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_D_S)+(d_SP_S_a_dV_D_S*SP_S_b))))+(d_SP_S_tau_dV_D_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
          mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));

          d_SP_S_x0_dV_S_BP = (d_SP_S_eta_dV_S_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_S_BP)+(((SP_S_a*d_nu_dV_S_BP)+(d_SP_S_a_dV_S_BP*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_S_BP+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_S_BP)+(d_SP_S_c_dV_S_BP*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_S_BP)+(d_SP_S_a_dV_S_BP*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_S_BP)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_S_BP)+((((nu/mutau)*d_SP_S_tau_dV_S_BP)+(((mutau*d_nu_dV_S_BP-nu*d_mutau_dV_S_BP)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
          d_SP_S_x0_dV_GP_S = (d_SP_S_eta_dV_GP_S+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_GP_S)+(((SP_S_a*d_nu_dV_GP_S)+(d_SP_S_a_dV_GP_S*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_S+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_GP_S)+(d_SP_S_c_dV_GP_S*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_GP_S)+(d_SP_S_a_dV_GP_S*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_S)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_S)+((((nu/mutau)*d_SP_S_tau_dV_GP_S)+(((mutau*d_nu_dV_GP_S-nu*d_mutau_dV_GP_S)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
          d_SP_S_x0_dV_D_S = (d_SP_S_eta_dV_D_S+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_D_S)+(((SP_S_a*d_nu_dV_D_S)+(d_SP_S_a_dV_D_S*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_D_S+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_D_S)+(d_SP_S_c_dV_D_S*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_D_S)+(d_SP_S_a_dV_D_S*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_D_S)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_D_S)+((((nu/mutau)*d_SP_S_tau_dV_D_S)+(((mutau*d_nu_dV_D_S-nu*d_mutau_dV_D_S)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
          SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
          if ((SP_S_x0<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp(SP_S_x0);
              double  deriv_exp_0_d0 = value_exp_0;

              d_SP_S_delta0_dV_S_BP = (deriv_exp_0_d0*(d_SP_S_x0_dV_S_BP));
              d_SP_S_delta0_dV_GP_S = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_S));
              d_SP_S_delta0_dV_D_S = (deriv_exp_0_d0*(d_SP_S_x0_dV_D_S));
              SP_S_delta0 = value_exp_0;
            }

            d_SP_S_delta1_dV_S_BP = (-d_SP_S_delta0_dV_S_BP/SP_S_delta0/SP_S_delta0);
            d_SP_S_delta1_dV_GP_S = (-d_SP_S_delta0_dV_GP_S/SP_S_delta0/SP_S_delta0);
            d_SP_S_delta1_dV_D_S = (-d_SP_S_delta0_dV_D_S/SP_S_delta0/SP_S_delta0);
            SP_S_delta1 = (1.0/SP_S_delta0);

            d_SP_S_delta0_dV_GP_S = (delta_ns*d_SP_S_delta0_dV_GP_S);
            d_SP_S_delta0_dV_S_BP = ((delta_ns*d_SP_S_delta0_dV_S_BP)+(d_delta_ns_dV_S_BP*SP_S_delta0));
            d_SP_S_delta0_dV_D_S = ((delta_ns*d_SP_S_delta0_dV_D_S)+(d_delta_ns_dV_D_S*SP_S_delta0));
            SP_S_delta0 = (delta_ns*SP_S_delta0);
          }
          else
          {
            if ((SP_S_x0>(xn_s-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp((SP_S_x0-xn_s));
                double  deriv_exp_0_d0 = value_exp_0;

                d_SP_S_delta0_dV_S_BP = (deriv_exp_0_d0*((d_SP_S_x0_dV_S_BP-d_xn_s_dV_S_BP)));
                d_SP_S_delta0_dV_GP_S = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_S));
                d_SP_S_delta0_dV_D_S = (deriv_exp_0_d0*((d_SP_S_x0_dV_D_S-d_xn_s_dV_D_S)));
                SP_S_delta0 = value_exp_0;
              }

              d_SP_S_delta1_dV_GP_S = (-delta_ns*d_SP_S_delta0_dV_GP_S/SP_S_delta0/SP_S_delta0);
              d_SP_S_delta1_dV_S_BP = ((SP_S_delta0*d_delta_ns_dV_S_BP-delta_ns*d_SP_S_delta0_dV_S_BP)/SP_S_delta0/SP_S_delta0);
              d_SP_S_delta1_dV_D_S = ((SP_S_delta0*d_delta_ns_dV_D_S-delta_ns*d_SP_S_delta0_dV_D_S)/SP_S_delta0/SP_S_delta0);
              SP_S_delta1 = (delta_ns/SP_S_delta0);
            }
            else
            {

              d_SP_S_delta0_dV_GP_S = (-1.0e-100*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-d_SP_S_x0_dV_GP_S)*3.3333333333333333e-01))+((-d_SP_S_x0_dV_GP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-d_SP_S_x0_dV_GP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_SP_S_delta0_dV_S_BP = (-1.0e-100*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*((d_xn_s_dV_S_BP-d_SP_S_x0_dV_S_BP)*3.3333333333333333e-01))+((d_xn_s_dV_S_BP-d_SP_S_x0_dV_S_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_S_BP-d_SP_S_x0_dV_S_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_SP_S_delta0_dV_D_S = (-1.0e-100*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*((d_xn_s_dV_D_S-d_SP_S_x0_dV_D_S)*3.3333333333333333e-01))+((d_xn_s_dV_D_S-d_SP_S_x0_dV_D_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_D_S-d_SP_S_x0_dV_D_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              SP_S_delta0 = (1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

              d_SP_S_delta1_dV_S_BP = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_S_BP*3.3333333333333333e-01))+(d_SP_S_x0_dV_S_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_S_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_SP_S_delta1_dV_GP_S = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_GP_S*3.3333333333333333e-01))+(d_SP_S_x0_dV_GP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_GP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_SP_S_delta1_dV_D_S = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_D_S*3.3333333333333333e-01))+(d_SP_S_x0_dV_D_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_D_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }

          d_SP_S_temp_dV_S_BP = (-((SP_S_x0*d_SP_S_x0_dV_S_BP)+(d_SP_S_x0_dV_S_BP*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
          d_SP_S_temp_dV_GP_S = (-((SP_S_x0*d_SP_S_x0_dV_GP_S)+(d_SP_S_x0_dV_GP_S*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
          d_SP_S_temp_dV_D_S = (-((SP_S_x0*d_SP_S_x0_dV_D_S)+(d_SP_S_x0_dV_D_S*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
          SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));

          d_SP_S_xi0_dV_S_BP = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_S_BP)+(((SP_S_x0*d_SP_S_x0_dV_S_BP)+(d_SP_S_x0_dV_S_BP*SP_S_x0))*SP_S_temp));
          d_SP_S_xi0_dV_GP_S = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_GP_S)+(((SP_S_x0*d_SP_S_x0_dV_GP_S)+(d_SP_S_x0_dV_GP_S*SP_S_x0))*SP_S_temp));
          d_SP_S_xi0_dV_D_S = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_D_S)+(((SP_S_x0*d_SP_S_x0_dV_D_S)+(d_SP_S_x0_dV_D_S*SP_S_x0))*SP_S_temp));
          SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);

          d_SP_S_xi1_dV_S_BP = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_S_BP)+(((SP_S_x0*d_SP_S_temp_dV_S_BP)+(d_SP_S_x0_dV_S_BP*SP_S_temp))*SP_S_temp)));
          d_SP_S_xi1_dV_GP_S = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_GP_S)+(((SP_S_x0*d_SP_S_temp_dV_GP_S)+(d_SP_S_x0_dV_GP_S*SP_S_temp))*SP_S_temp)));
          d_SP_S_xi1_dV_D_S = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_D_S)+(((SP_S_x0*d_SP_S_temp_dV_D_S)+(d_SP_S_x0_dV_D_S*SP_S_temp))*SP_S_temp)));
          SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));

          d_SP_S_xi2_dV_S_BP = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_S_BP)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_S_BP)+(((8.0*d_SP_S_temp_dV_S_BP)-(12.0*d_SP_S_xi0_dV_S_BP))*SP_S_temp))*SP_S_temp));
          d_SP_S_xi2_dV_GP_S = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_S)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_S)+(((8.0*d_SP_S_temp_dV_GP_S)-(12.0*d_SP_S_xi0_dV_GP_S))*SP_S_temp))*SP_S_temp));
          d_SP_S_xi2_dV_D_S = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_D_S)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_D_S)+(((8.0*d_SP_S_temp_dV_D_S)-(12.0*d_SP_S_xi0_dV_D_S))*SP_S_temp))*SP_S_temp));
          SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

          d_SP_S_temp_dV_S_BP = (d_xg_dV_S_BP-d_SP_S_x0_dV_S_BP);
          d_SP_S_temp_dV_GP_S = (d_xg_dV_GP_S-d_SP_S_x0_dV_GP_S);
          d_SP_S_temp_dV_D_S = (d_xg_dV_D_S-d_SP_S_x0_dV_D_S);
          SP_S_temp = (xg-SP_S_x0);

          d_SP_S_pC_dV_S_BP = ((2.0*d_SP_S_temp_dV_S_BP)+((Gf2*(((-d_SP_S_delta1_dV_S_BP)+d_SP_S_delta0_dV_S_BP)-((delta_ns*d_SP_S_xi1_dV_S_BP)+(d_delta_ns_dV_S_BP*(1.0+SP_S_xi1)))))+(d_Gf2_dV_S_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1))))));
          d_SP_S_pC_dV_GP_S = ((2.0*d_SP_S_temp_dV_GP_S)+((Gf2*(((-d_SP_S_delta1_dV_GP_S)+d_SP_S_delta0_dV_GP_S)-(delta_ns*d_SP_S_xi1_dV_GP_S)))+(d_Gf2_dV_GP_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1))))));
          d_SP_S_pC_dV_D_S = ((2.0*d_SP_S_temp_dV_D_S)+((Gf2*(((-d_SP_S_delta1_dV_D_S)+d_SP_S_delta0_dV_D_S)-((delta_ns*d_SP_S_xi1_dV_D_S)+(d_delta_ns_dV_D_S*(1.0+SP_S_xi1)))))+(d_Gf2_dV_D_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1))))));
          SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));

          d_SP_S_qC_dV_S_BP = (((SP_S_temp*d_SP_S_temp_dV_S_BP)+(d_SP_S_temp_dV_S_BP*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_S_BP+d_SP_S_x0_dV_S_BP)+d_SP_S_delta0_dV_S_BP)-((delta_ns*(d_SP_S_x0_dV_S_BP+d_SP_S_xi0_dV_S_BP))+(d_delta_ns_dV_S_BP*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_S_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0))))));
          d_SP_S_qC_dV_GP_S = (((SP_S_temp*d_SP_S_temp_dV_GP_S)+(d_SP_S_temp_dV_GP_S*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_GP_S+d_SP_S_x0_dV_GP_S)+d_SP_S_delta0_dV_GP_S)-(delta_ns*(d_SP_S_x0_dV_GP_S+d_SP_S_xi0_dV_GP_S))))+(d_Gf2_dV_GP_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0))))));
          d_SP_S_qC_dV_D_S = (((SP_S_temp*d_SP_S_temp_dV_D_S)+(d_SP_S_temp_dV_D_S*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_D_S+d_SP_S_x0_dV_D_S)+d_SP_S_delta0_dV_D_S)-((delta_ns*(d_SP_S_x0_dV_D_S+d_SP_S_xi0_dV_D_S))+(d_delta_ns_dV_D_S*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_D_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0))))));
          SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));

          d_SP_S_temp_dV_S_BP = (-((Gf2*((d_SP_S_delta1_dV_S_BP+d_SP_S_delta0_dV_S_BP)-((delta_ns*d_SP_S_xi2_dV_S_BP)+(d_delta_ns_dV_S_BP*SP_S_xi2))))+(d_Gf2_dV_S_BP*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2)))));
          d_SP_S_temp_dV_GP_S = (-((Gf2*((d_SP_S_delta1_dV_GP_S+d_SP_S_delta0_dV_GP_S)-(delta_ns*d_SP_S_xi2_dV_GP_S)))+(d_Gf2_dV_GP_S*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2)))));
          d_SP_S_temp_dV_D_S = (-((Gf2*((d_SP_S_delta1_dV_D_S+d_SP_S_delta0_dV_D_S)-((delta_ns*d_SP_S_xi2_dV_D_S)+(d_delta_ns_dV_D_S*SP_S_xi2))))+(d_Gf2_dV_D_S*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2)))));
          SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));

          d_SP_S_temp_dV_S_BP = (((SP_S_pC*d_SP_S_pC_dV_S_BP)+(d_SP_S_pC_dV_S_BP*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_S_BP)+(d_SP_S_qC_dV_S_BP*SP_S_temp))));
          d_SP_S_temp_dV_GP_S = (((SP_S_pC*d_SP_S_pC_dV_GP_S)+(d_SP_S_pC_dV_GP_S*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_GP_S)+(d_SP_S_qC_dV_GP_S*SP_S_temp))));
          d_SP_S_temp_dV_D_S = (((SP_S_pC*d_SP_S_pC_dV_D_S)+(d_SP_S_pC_dV_D_S*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_D_S)+(d_SP_S_qC_dV_D_S*SP_S_temp))));
          SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
          {
            double value_sqrt_0 = sqrt(SP_S_temp);
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_x_s_dV_S_BP = (d_SP_S_x0_dV_S_BP+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_S_BP-SP_S_qC*(d_SP_S_pC_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_S_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
            d_x_s_dV_GP_S = (d_SP_S_x0_dV_GP_S+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_S-SP_S_qC*(d_SP_S_pC_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_S))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
            d_x_s_dV_D_S = (d_SP_S_x0_dV_D_S+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_D_S-SP_S_qC*(d_SP_S_pC_dV_D_S+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_D_S))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
            x_s = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
          }
        }
      }

      d_x_d_dV_S_BP = d_x_s_dV_S_BP;
      d_x_d_dV_GP_S = d_x_s_dV_GP_S;
      d_x_d_dV_D_S = d_x_s_dV_D_S;
      x_d = x_s;

      d_x_m_dV_S_BP = d_x_s_dV_S_BP;
      d_x_m_dV_GP_S = d_x_s_dV_GP_S;
      d_x_m_dV_D_S = d_x_s_dV_D_S;
      x_m = x_s;

      d_x_ds_dV_D_S = d_x_ds_dV_GP_S = d_x_ds_dV_S_BP =  0.0;
      x_ds = 0.0;
      if ((xg<=0.0))
      {

        d_qis_dV_D_S = d_qis_dV_GP_S = d_qis_dV_S_BP =  0.0;
        qis = 0.0;

        d_Ids_dV_GP_S = d_Ids_dV_D_S = d_Ids_dV_S_BP =  0.0;
        Ids = 0.0;

        d_xgm_dV_S_BP = (d_xg_dV_S_BP-d_x_s_dV_S_BP);
        d_xgm_dV_GP_S = (d_xg_dV_GP_S-d_x_s_dV_GP_S);
        d_xgm_dV_D_S = (d_xg_dV_D_S-d_x_s_dV_D_S);
        xgm = (xg-x_s);

        d_Voxm_dV_S_BP = (d_xgm_dV_S_BP*phit1);
        d_Voxm_dV_GP_S = (d_xgm_dV_GP_S*phit1);
        d_Voxm_dV_D_S = (d_xgm_dV_D_S*phit1);
        Voxm = (xgm*phit1);

        d_qeff_dV_S_BP = d_Voxm_dV_S_BP;
        d_qeff_dV_GP_S = d_Voxm_dV_GP_S;
        d_qeff_dV_D_S = d_Voxm_dV_D_S;
        qeff = Voxm;

        d_Vdsat_dV_D_S = d_Vdsat_dV_GP_S = d_Vdsat_dV_S_BP =  0.0;
        Vdsat = Vdsat_lim;

        d_Vdse_dV_GP_S = d_Vdse_dV_S_BP =  0.0;
        d_Vdse_dV_D_S = d_Vds_dV_D_S;
        Vdse = Vds;
      }
      else
      {

        d_delta_1s_dV_D_S = d_delta_1s_dV_GP_S = d_delta_1s_dV_S_BP =  0.0;
        delta_1s = 0.0;

        d_temp_dV_S_BP = (-((x_s*d_x_s_dV_S_BP)+(d_x_s_dV_S_BP*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
        d_temp_dV_GP_S = (-((x_s*d_x_s_dV_GP_S)+(d_x_s_dV_GP_S*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
        d_temp_dV_D_S = (-((x_s*d_x_s_dV_D_S)+(d_x_s_dV_D_S*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
        temp = (1.0/(2.0+(x_s*x_s)));

        d_xi0s_dV_S_BP = (((x_s*x_s)*d_temp_dV_S_BP)+(((x_s*d_x_s_dV_S_BP)+(d_x_s_dV_S_BP*x_s))*temp));
        d_xi0s_dV_GP_S = (((x_s*x_s)*d_temp_dV_GP_S)+(((x_s*d_x_s_dV_GP_S)+(d_x_s_dV_GP_S*x_s))*temp));
        d_xi0s_dV_D_S = (((x_s*x_s)*d_temp_dV_D_S)+(((x_s*d_x_s_dV_D_S)+(d_x_s_dV_D_S*x_s))*temp));
        xi0s = ((x_s*x_s)*temp);

        d_xi1s_dV_S_BP = (4.0*(((x_s*temp)*d_temp_dV_S_BP)+(((x_s*d_temp_dV_S_BP)+(d_x_s_dV_S_BP*temp))*temp)));
        d_xi1s_dV_GP_S = (4.0*(((x_s*temp)*d_temp_dV_GP_S)+(((x_s*d_temp_dV_GP_S)+(d_x_s_dV_GP_S*temp))*temp)));
        d_xi1s_dV_D_S = (4.0*(((x_s*temp)*d_temp_dV_D_S)+(((x_s*d_temp_dV_D_S)+(d_x_s_dV_D_S*temp))*temp)));
        xi1s = (4.0*((x_s*temp)*temp));

        d_xi2s_dV_S_BP = (((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_S_BP)+(((((8.0*temp)-(12.0*xi0s))*d_temp_dV_S_BP)+(((8.0*d_temp_dV_S_BP)-(12.0*d_xi0s_dV_S_BP))*temp))*temp));
        d_xi2s_dV_D_S = (((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_D_S)+(((((8.0*temp)-(12.0*xi0s))*d_temp_dV_D_S)+(((8.0*d_temp_dV_D_S)-(12.0*d_xi0s_dV_D_S))*temp))*temp));
        d_xi2s_dV_GP_S = (((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_GP_S)+(((((8.0*temp)-(12.0*xi0s))*d_temp_dV_GP_S)+(((8.0*d_temp_dV_GP_S)-(12.0*d_xi0s_dV_GP_S))*temp))*temp));
        xi2s = ((((8.0*temp)-(12.0*xi0s))*temp)*temp);
        if ((x_s<2.3025850929940458e+02))
        {
          {
            double value_exp_0 = exp(x_s);
            double  deriv_exp_0_d0 = value_exp_0;

            d_delta_1s_dV_S_BP = (deriv_exp_0_d0*(d_x_s_dV_S_BP));
            d_delta_1s_dV_GP_S = (deriv_exp_0_d0*(d_x_s_dV_GP_S));
            d_delta_1s_dV_D_S = (deriv_exp_0_d0*(d_x_s_dV_D_S));
            delta_1s = value_exp_0;
          }

          d_Es_dV_S_BP = (-d_delta_1s_dV_S_BP/delta_1s/delta_1s);
          d_Es_dV_GP_S = (-d_delta_1s_dV_GP_S/delta_1s/delta_1s);
          d_Es_dV_D_S = (-d_delta_1s_dV_D_S/delta_1s/delta_1s);
          Es = (1.0/delta_1s);

          d_delta_1s_dV_GP_S = (delta_ns*d_delta_1s_dV_GP_S);
          d_delta_1s_dV_S_BP = ((delta_ns*d_delta_1s_dV_S_BP)+(d_delta_ns_dV_S_BP*delta_1s));
          d_delta_1s_dV_D_S = ((delta_ns*d_delta_1s_dV_D_S)+(d_delta_ns_dV_D_S*delta_1s));
          delta_1s = (delta_ns*delta_1s);
        }
        else
        {
          if ((x_s>(xn_s-2.3025850929940458e+02)))
          {
            {
              double value_exp_0 = exp((x_s-xn_s));
              double  deriv_exp_0_d0 = value_exp_0;

              d_delta_1s_dV_S_BP = (deriv_exp_0_d0*((d_x_s_dV_S_BP-d_xn_s_dV_S_BP)));
              d_delta_1s_dV_GP_S = (deriv_exp_0_d0*(d_x_s_dV_GP_S));
              d_delta_1s_dV_D_S = (deriv_exp_0_d0*((d_x_s_dV_D_S-d_xn_s_dV_D_S)));
              delta_1s = value_exp_0;
            }

            d_Es_dV_GP_S = (-delta_ns*d_delta_1s_dV_GP_S/delta_1s/delta_1s);
            d_Es_dV_S_BP = ((delta_1s*d_delta_ns_dV_S_BP-delta_ns*d_delta_1s_dV_S_BP)/delta_1s/delta_1s);
            d_Es_dV_D_S = ((delta_1s*d_delta_ns_dV_D_S-delta_ns*d_delta_1s_dV_D_S)/delta_1s/delta_1s);
            Es = (delta_ns/delta_1s);
          }
          else
          {

            d_delta_1s_dV_GP_S = (-1.0e-100*((((xn_s-x_s)-2.3025850929940458e+02)*(0.5*((((xn_s-x_s)-2.3025850929940458e+02)*((-d_x_s_dV_GP_S)*3.3333333333333333e-01))+((-d_x_s_dV_GP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-d_x_s_dV_GP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            d_delta_1s_dV_S_BP = (-1.0e-100*((((xn_s-x_s)-2.3025850929940458e+02)*(0.5*((((xn_s-x_s)-2.3025850929940458e+02)*((d_xn_s_dV_S_BP-d_x_s_dV_S_BP)*3.3333333333333333e-01))+((d_xn_s_dV_S_BP-d_x_s_dV_S_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_S_BP-d_x_s_dV_S_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            d_delta_1s_dV_D_S = (-1.0e-100*((((xn_s-x_s)-2.3025850929940458e+02)*(0.5*((((xn_s-x_s)-2.3025850929940458e+02)*((d_xn_s_dV_D_S-d_x_s_dV_D_S)*3.3333333333333333e-01))+((d_xn_s_dV_D_S-d_x_s_dV_D_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_D_S-d_x_s_dV_D_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            delta_1s = (1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

            d_Es_dV_S_BP = (-1.0e-100*(((x_s-2.3025850929940458e+02)*(0.5*(((x_s-2.3025850929940458e+02)*(d_x_s_dV_S_BP*3.3333333333333333e-01))+(d_x_s_dV_S_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_s_dV_S_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            d_Es_dV_GP_S = (-1.0e-100*(((x_s-2.3025850929940458e+02)*(0.5*(((x_s-2.3025850929940458e+02)*(d_x_s_dV_GP_S*3.3333333333333333e-01))+(d_x_s_dV_GP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_s_dV_GP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            d_Es_dV_D_S = (-1.0e-100*(((x_s-2.3025850929940458e+02)*(0.5*(((x_s-2.3025850929940458e+02)*(d_x_s_dV_D_S*3.3333333333333333e-01))+(d_x_s_dV_D_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_s_dV_D_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            Es = (1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
          }
        }

        d_Ds_dV_S_BP = (d_delta_1s_dV_S_BP-((delta_ns*(d_x_s_dV_S_BP+d_xi0s_dV_S_BP))+(d_delta_ns_dV_S_BP*((x_s+1.0)+xi0s))));
        d_Ds_dV_GP_S = (d_delta_1s_dV_GP_S-(delta_ns*(d_x_s_dV_GP_S+d_xi0s_dV_GP_S)));
        d_Ds_dV_D_S = (d_delta_1s_dV_D_S-((delta_ns*(d_x_s_dV_D_S+d_xi0s_dV_D_S))+(d_delta_ns_dV_D_S*((x_s+1.0)+xi0s))));
        Ds = (delta_1s-(delta_ns*((x_s+1.0)+xi0s)));
        if ((x_s<1.0e-5))
        {

          d_Ps_dV_S_BP = (0.5*(((x_s*x_s)*(-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_S_BP)))+(d_x_s_dV_S_BP*(1.0-(0.25*x_s)))))))+(((x_s*d_x_s_dV_S_BP)+(d_x_s_dV_S_BP*x_s))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))));
          d_Ps_dV_GP_S = (0.5*(((x_s*x_s)*(-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_GP_S)))+(d_x_s_dV_GP_S*(1.0-(0.25*x_s)))))))+(((x_s*d_x_s_dV_GP_S)+(d_x_s_dV_GP_S*x_s))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))));
          d_Ps_dV_D_S = (0.5*(((x_s*x_s)*(-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_D_S)))+(d_x_s_dV_D_S*(1.0-(0.25*x_s)))))))+(((x_s*d_x_s_dV_D_S)+(d_x_s_dV_D_S*x_s))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))));
          Ps = (0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))));

          d_Ds_dV_GP_S = (1.6666666666666667e-01*(((((delta_ns*x_s)*x_s)*x_s)*(1.75*d_x_s_dV_GP_S))+(((((delta_ns*x_s)*x_s)*d_x_s_dV_GP_S)+((((delta_ns*x_s)*d_x_s_dV_GP_S)+((delta_ns*d_x_s_dV_GP_S)*x_s))*x_s))*(1.0+(1.75*x_s)))));
          d_Ds_dV_S_BP = (1.6666666666666667e-01*(((((delta_ns*x_s)*x_s)*x_s)*(1.75*d_x_s_dV_S_BP))+(((((delta_ns*x_s)*x_s)*d_x_s_dV_S_BP)+((((delta_ns*x_s)*d_x_s_dV_S_BP)+(((delta_ns*d_x_s_dV_S_BP)+(d_delta_ns_dV_S_BP*x_s))*x_s))*x_s))*(1.0+(1.75*x_s)))));
          d_Ds_dV_D_S = (1.6666666666666667e-01*(((((delta_ns*x_s)*x_s)*x_s)*(1.75*d_x_s_dV_D_S))+(((((delta_ns*x_s)*x_s)*d_x_s_dV_D_S)+((((delta_ns*x_s)*d_x_s_dV_D_S)+(((delta_ns*d_x_s_dV_D_S)+(d_delta_ns_dV_D_S*x_s))*x_s))*x_s))*(1.0+(1.75*x_s)))));
          Ds = (1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s))));
          {
            double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_temp_dV_S_BP = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_S_BP)))+(d_x_s_dV_S_BP*(1.0-(0.25*x_s))))))));
            d_temp_dV_GP_S = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_GP_S)))+(d_x_s_dV_GP_S*(1.0-(0.25*x_s))))))));
            d_temp_dV_D_S = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_D_S)))+(d_x_s_dV_D_S*(1.0-(0.25*x_s))))))));
            temp = value_sqrt_0;
          }

          d_sqm_dV_S_BP = (7.0710678118654746e-01*((x_s*d_temp_dV_S_BP)+(d_x_s_dV_S_BP*temp)));
          d_sqm_dV_GP_S = (7.0710678118654746e-01*((x_s*d_temp_dV_GP_S)+(d_x_s_dV_GP_S*temp)));
          d_sqm_dV_D_S = (7.0710678118654746e-01*((x_s*d_temp_dV_D_S)+(d_x_s_dV_D_S*temp)));
          sqm = (7.0710678118654746e-01*(x_s*temp));

          d_alpha_dV_S_BP = ((temp*(((Gf*7.0710678118654746e-01)*((-(0.5*d_x_s_dV_S_BP))+(1.6666666666666667e-01*((x_s*d_x_s_dV_S_BP)+(d_x_s_dV_S_BP*x_s)))))+((d_Gf_dV_S_BP*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_S_BP)/temp/temp);
          d_alpha_dV_GP_S = ((temp*(((Gf*7.0710678118654746e-01)*((-(0.5*d_x_s_dV_GP_S))+(1.6666666666666667e-01*((x_s*d_x_s_dV_GP_S)+(d_x_s_dV_GP_S*x_s)))))+((d_Gf_dV_GP_S*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_GP_S)/temp/temp);
          d_alpha_dV_D_S = ((temp*(((Gf*7.0710678118654746e-01)*((-(0.5*d_x_s_dV_D_S))+(1.6666666666666667e-01*((x_s*d_x_s_dV_D_S)+(d_x_s_dV_D_S*x_s)))))+((d_Gf_dV_D_S*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_D_S)/temp/temp);
          alpha = (1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp));
        }
        else
        {

          d_Ps_dV_S_BP = (d_x_s_dV_S_BP+d_Es_dV_S_BP);
          d_Ps_dV_GP_S = (d_x_s_dV_GP_S+d_Es_dV_GP_S);
          d_Ps_dV_D_S = (d_x_s_dV_D_S+d_Es_dV_D_S);
          Ps = ((x_s-1.0)+Es);
          {
            double value_sqrt_0 = sqrt(Ps);
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_sqm_dV_S_BP = (deriv_sqrt_0_d0*(d_Ps_dV_S_BP));
            d_sqm_dV_GP_S = (deriv_sqrt_0_d0*(d_Ps_dV_GP_S));
            d_sqm_dV_D_S = (deriv_sqrt_0_d0*(d_Ps_dV_D_S));
            sqm = value_sqrt_0;
          }

          d_alpha_dV_S_BP = (0.5*((sqm*((Gf*(-d_Es_dV_S_BP))+(d_Gf_dV_S_BP*(1.0-Es)))-(Gf*(1.0-Es))*d_sqm_dV_S_BP)/sqm/sqm));
          d_alpha_dV_GP_S = (0.5*((sqm*((Gf*(-d_Es_dV_GP_S))+(d_Gf_dV_GP_S*(1.0-Es)))-(Gf*(1.0-Es))*d_sqm_dV_GP_S)/sqm/sqm));
          d_alpha_dV_D_S = (0.5*((sqm*((Gf*(-d_Es_dV_D_S))+(d_Gf_dV_D_S*(1.0-Es)))-(Gf*(1.0-Es))*d_sqm_dV_D_S)/sqm/sqm));
          alpha = (1.0+(0.5*((Gf*(1.0-Es))/sqm)));
        }

        d_Em_dV_S_BP = d_Es_dV_S_BP;
        d_Em_dV_GP_S = d_Es_dV_GP_S;
        d_Em_dV_D_S = d_Es_dV_D_S;
        Em = Es;

        d_Ed_dV_S_BP = d_Em_dV_S_BP;
        d_Ed_dV_GP_S = d_Em_dV_GP_S;
        d_Ed_dV_D_S = d_Em_dV_D_S;
        Ed = Em;

        d_Dm_dV_S_BP = d_Ds_dV_S_BP;
        d_Dm_dV_GP_S = d_Ds_dV_GP_S;
        d_Dm_dV_D_S = d_Ds_dV_D_S;
        Dm = Ds;

        d_Dd_dV_S_BP = d_Dm_dV_S_BP;
        d_Dd_dV_GP_S = d_Dm_dV_GP_S;
        d_Dd_dV_D_S = d_Dm_dV_D_S;
        Dd = Dm;

        d_Rxcor_dV_S_BP = (((1.0+(XCOR_i*Vsbx))*((0.2*XCOR_i)*d_Vsbx_dV_S_BP)-(1.0+((0.2*XCOR_i)*Vsbx))*(XCOR_i*d_Vsbx_dV_S_BP))/(1.0+(XCOR_i*Vsbx))/(1.0+(XCOR_i*Vsbx)));
        d_Rxcor_dV_D_S = (((1.0+(XCOR_i*Vsbx))*((0.2*XCOR_i)*d_Vsbx_dV_D_S)-(1.0+((0.2*XCOR_i)*Vsbx))*(XCOR_i*d_Vsbx_dV_D_S))/(1.0+(XCOR_i*Vsbx))/(1.0+(XCOR_i*Vsbx)));
        Rxcor = ((1.0+((0.2*XCOR_i)*Vsbx))/(1.0+(XCOR_i*Vsbx)));
        if ((Ds>1.0e-100))
        {
          {
            double value_sqrt_0 = sqrt((Ps+Ds));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_xgs_dV_S_BP = ((Gf*(deriv_sqrt_0_d0*((d_Ps_dV_S_BP+d_Ds_dV_S_BP))))+(d_Gf_dV_S_BP*value_sqrt_0));
            d_xgs_dV_GP_S = ((Gf*(deriv_sqrt_0_d0*((d_Ps_dV_GP_S+d_Ds_dV_GP_S))))+(d_Gf_dV_GP_S*value_sqrt_0));
            d_xgs_dV_D_S = ((Gf*(deriv_sqrt_0_d0*((d_Ps_dV_D_S+d_Ds_dV_D_S))))+(d_Gf_dV_D_S*value_sqrt_0));
            xgs = (Gf*value_sqrt_0);
          }

          d_qis_dV_S_BP = (((xgs+(Gf*sqm))*(((Gf2*d_Ds_dV_S_BP)+(d_Gf2_dV_S_BP*Ds))*phit1)-((Gf2*Ds)*phit1)*(d_xgs_dV_S_BP+((Gf*d_sqm_dV_S_BP)+(d_Gf_dV_S_BP*sqm))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
          d_qis_dV_GP_S = (((xgs+(Gf*sqm))*(((Gf2*d_Ds_dV_GP_S)+(d_Gf2_dV_GP_S*Ds))*phit1)-((Gf2*Ds)*phit1)*(d_xgs_dV_GP_S+((Gf*d_sqm_dV_GP_S)+(d_Gf_dV_GP_S*sqm))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
          d_qis_dV_D_S = (((xgs+(Gf*sqm))*(((Gf2*d_Ds_dV_D_S)+(d_Gf2_dV_D_S*Ds))*phit1)-((Gf2*Ds)*phit1)*(d_xgs_dV_D_S+((Gf*d_sqm_dV_D_S)+(d_Gf_dV_D_S*sqm))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
          qis = (((Gf2*Ds)*phit1)/(xgs+(Gf*sqm)));

          d_qbs_dV_S_BP = (((sqm*d_Gf_dV_S_BP)+(d_sqm_dV_S_BP*Gf))*phit1);
          d_qbs_dV_GP_S = (((sqm*d_Gf_dV_GP_S)+(d_sqm_dV_GP_S*Gf))*phit1);
          d_qbs_dV_D_S = (((sqm*d_Gf_dV_D_S)+(d_sqm_dV_D_S*Gf))*phit1);
          qbs = ((sqm*Gf)*phit1);
          if ((RSB_i<0))
          {

            d_rhob_dV_S_BP = (-(-(RSB_i*d_Vsbx_dV_S_BP))/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
            d_rhob_dV_D_S = (-(-(RSB_i*d_Vsbx_dV_D_S))/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
            rhob = (1.0/(1.0-(RSB_i*Vsbx)));
          }
          else
          {

            d_rhob_dV_S_BP = (RSB_i*d_Vsbx_dV_S_BP);
            d_rhob_dV_D_S = (RSB_i*d_Vsbx_dV_D_S);
            rhob = (1.0+(RSB_i*Vsbx));
          }
          if ((RSG_i<0))
          {

            d_temp_dV_S_BP = (-(RSG_i*d_qis_dV_S_BP));
            d_temp_dV_GP_S = (-(RSG_i*d_qis_dV_GP_S));
            d_temp_dV_D_S = (-(RSG_i*d_qis_dV_D_S));
            temp = (1.0-(RSG_i*qis));
          }
          else
          {

            d_temp_dV_S_BP = (-(RSG_i*d_qis_dV_S_BP)/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
            d_temp_dV_GP_S = (-(RSG_i*d_qis_dV_GP_S)/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
            d_temp_dV_D_S = (-(RSG_i*d_qis_dV_D_S)/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
            temp = (1.0/(1.0+(RSG_i*qis)));
          }

          d_GR_dV_GP_S = (THER_i*(((rhob*temp)*d_qis_dV_GP_S)+((rhob*d_temp_dV_GP_S)*qis)));
          d_GR_dV_S_BP = (THER_i*(((rhob*temp)*d_qis_dV_S_BP)+(((rhob*d_temp_dV_S_BP)+(d_rhob_dV_S_BP*temp))*qis)));
          d_GR_dV_D_S = (THER_i*(((rhob*temp)*d_qis_dV_D_S)+(((rhob*d_temp_dV_D_S)+(d_rhob_dV_D_S*temp))*qis)));
          GR = (THER_i*((rhob*temp)*qis));

          d_Eeffm_dV_S_BP = (E_eff0*(d_qbs_dV_S_BP+(eta_mu*d_qis_dV_S_BP)));
          d_Eeffm_dV_GP_S = (E_eff0*(d_qbs_dV_GP_S+(eta_mu*d_qis_dV_GP_S)));
          d_Eeffm_dV_D_S = (E_eff0*(d_qbs_dV_D_S+(eta_mu*d_qis_dV_D_S)));
          Eeffm = (E_eff0*(qbs+(eta_mu*qis)));
          {
            double value_pow_0 = pow((Eeffm*MUE_i),THEMU_i);
            double  deriv_pow_0_d0 = (((Eeffm*MUE_i) == 0.0)?0.0:(value_pow_0*THEMU_i/(Eeffm*MUE_i)));

            d_Mutmp_dV_S_BP = ((deriv_pow_0_d0*((d_Eeffm_dV_S_BP*MUE_i)))+(CS_i*((((Ps+Ds)+1.0e-14)*d_Ps_dV_S_BP-Ps*(d_Ps_dV_S_BP+d_Ds_dV_S_BP))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
            d_Mutmp_dV_GP_S = ((deriv_pow_0_d0*((d_Eeffm_dV_GP_S*MUE_i)))+(CS_i*((((Ps+Ds)+1.0e-14)*d_Ps_dV_GP_S-Ps*(d_Ps_dV_GP_S+d_Ds_dV_GP_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
            d_Mutmp_dV_D_S = ((deriv_pow_0_d0*((d_Eeffm_dV_D_S*MUE_i)))+(CS_i*((((Ps+Ds)+1.0e-14)*d_Ps_dV_D_S-Ps*(d_Ps_dV_D_S+d_Ds_dV_D_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
            Mutmp = (value_pow_0+(CS_i*(Ps/((Ps+Ds)+1.0e-14))));
          }

          d_Gmob_dV_S_BP = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_S_BP)+((d_Mutmp_dV_S_BP+d_GR_dV_S_BP)*Rxcor));
          d_Gmob_dV_GP_S = ((d_Mutmp_dV_GP_S+d_GR_dV_GP_S)*Rxcor);
          d_Gmob_dV_D_S = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_D_S)+((d_Mutmp_dV_D_S+d_GR_dV_D_S)*Rxcor));
          Gmob = (((1.0+Mutmp)+GR)*Rxcor);
          if ((THESATB_i<0))
          {

            d_xitsb_dV_S_BP = (-(-(THESATB_i*d_Vsbx_dV_S_BP))/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
            d_xitsb_dV_D_S = (-(-(THESATB_i*d_Vsbx_dV_D_S))/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
            xitsb = (1.0/(1.0-(THESATB_i*Vsbx)));
          }
          else
          {

            d_xitsb_dV_S_BP = (THESATB_i*d_Vsbx_dV_S_BP);
            d_xitsb_dV_D_S = (THESATB_i*d_Vsbx_dV_D_S);
            xitsb = (1.0+(THESATB_i*Vsbx));
          }

          d_temp2_dV_S_BP = ((qis*d_xitsb_dV_S_BP)+(d_qis_dV_S_BP*xitsb));
          d_temp2_dV_GP_S = (d_qis_dV_GP_S*xitsb);
          d_temp2_dV_D_S = ((qis*d_xitsb_dV_D_S)+(d_qis_dV_D_S*xitsb));
          temp2 = (qis*xitsb);

          d_wsat_dV_S_BP = (100.0*(((100.0+temp2)*d_temp2_dV_S_BP-temp2*d_temp2_dV_S_BP)/(100.0+temp2)/(100.0+temp2)));
          d_wsat_dV_GP_S = (100.0*(((100.0+temp2)*d_temp2_dV_GP_S-temp2*d_temp2_dV_GP_S)/(100.0+temp2)/(100.0+temp2)));
          d_wsat_dV_D_S = (100.0*(((100.0+temp2)*d_temp2_dV_D_S-temp2*d_temp2_dV_D_S)/(100.0+temp2)/(100.0+temp2)));
          wsat = (100.0*(temp2/(100.0+temp2)));
          if ((THESATG_i<0))
          {

            d_temp_dV_S_BP = (-1*(-(THESATG_i*d_wsat_dV_S_BP))/(1-(THESATG_i*wsat))/(1-(THESATG_i*wsat)));
            d_temp_dV_GP_S = (-1*(-(THESATG_i*d_wsat_dV_GP_S))/(1-(THESATG_i*wsat))/(1-(THESATG_i*wsat)));
            d_temp_dV_D_S = (-1*(-(THESATG_i*d_wsat_dV_D_S))/(1-(THESATG_i*wsat))/(1-(THESATG_i*wsat)));
            temp = (1/(1-(THESATG_i*wsat)));
          }
          else
          {

            d_temp_dV_S_BP = (THESATG_i*d_wsat_dV_S_BP);
            d_temp_dV_GP_S = (THESATG_i*d_wsat_dV_GP_S);
            d_temp_dV_D_S = (THESATG_i*d_wsat_dV_D_S);
            temp = (1+(THESATG_i*wsat));
          }

          d_thesat1_dV_S_BP = (THESAT_i*((Gmob*d_temp_dV_S_BP-temp*d_Gmob_dV_S_BP)/Gmob/Gmob));
          d_thesat1_dV_D_S = (THESAT_i*((Gmob*d_temp_dV_D_S-temp*d_Gmob_dV_D_S)/Gmob/Gmob));
          d_thesat1_dV_GP_S = (THESAT_i*((Gmob*d_temp_dV_GP_S-temp*d_Gmob_dV_GP_S)/Gmob/Gmob));
          thesat1 = (THESAT_i*(temp/Gmob));

          d_phi_inf_dV_S_BP = ((alpha*d_qis_dV_S_BP-qis*d_alpha_dV_S_BP)/alpha/alpha);
          d_phi_inf_dV_GP_S = ((alpha*d_qis_dV_GP_S-qis*d_alpha_dV_GP_S)/alpha/alpha);
          d_phi_inf_dV_D_S = ((alpha*d_qis_dV_D_S-qis*d_alpha_dV_D_S)/alpha/alpha);
          phi_inf = ((qis/alpha)+phit1);

          d_ysat_dV_S_BP = (((thesat1*d_phi_inf_dV_S_BP)+(d_thesat1_dV_S_BP*phi_inf))*7.0710678118654746e-01);
          d_ysat_dV_D_S = (((thesat1*d_phi_inf_dV_D_S)+(d_thesat1_dV_D_S*phi_inf))*7.0710678118654746e-01);
          d_ysat_dV_GP_S = (((thesat1*d_phi_inf_dV_GP_S)+(d_thesat1_dV_GP_S*phi_inf))*7.0710678118654746e-01);
          ysat = ((thesat1*phi_inf)*7.0710678118654746e-01);
          if (((model_.CHNL_TYPE)==(-1)))
          {
            {
              double value_sqrt_0 = sqrt((1.0+ysat));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_ysat_dV_S_BP = ((value_sqrt_0*d_ysat_dV_S_BP-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_S_BP)))/value_sqrt_0/value_sqrt_0);
              d_ysat_dV_D_S = ((value_sqrt_0*d_ysat_dV_D_S-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_D_S)))/value_sqrt_0/value_sqrt_0);
              d_ysat_dV_GP_S = ((value_sqrt_0*d_ysat_dV_GP_S-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_GP_S)))/value_sqrt_0/value_sqrt_0);
              ysat = (ysat/value_sqrt_0);
            }
          }
          {
            double value_sqrt_0 = sqrt((1.0+(4.0*ysat)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_za_dV_S_BP = (-2.0*(deriv_sqrt_0_d0*((4.0*d_ysat_dV_S_BP)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
            d_za_dV_D_S = (-2.0*(deriv_sqrt_0_d0*((4.0*d_ysat_dV_D_S)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
            d_za_dV_GP_S = (-2.0*(deriv_sqrt_0_d0*((4.0*d_ysat_dV_GP_S)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
            za = (2.0/(1.0+value_sqrt_0));
          }

          d_temp1_dV_S_BP = ((za*d_ysat_dV_S_BP)+(d_za_dV_S_BP*ysat));
          d_temp1_dV_D_S = ((za*d_ysat_dV_D_S)+(d_za_dV_D_S*ysat));
          d_temp1_dV_GP_S = ((za*d_ysat_dV_GP_S)+(d_za_dV_GP_S*ysat));
          temp1 = (za*ysat);

          d_Phi_0_dV_S_BP = (((phi_inf*za)*(0.86*(((1.0+(4.0*((temp1*temp1)*za)))*((temp1*(-((temp1*d_za_dV_S_BP)+(d_temp1_dV_S_BP*za))))+(d_temp1_dV_S_BP*(1.0-(temp1*za))))-(temp1*(1.0-(temp1*za)))*(4.0*(((temp1*temp1)*d_za_dV_S_BP)+(((temp1*d_temp1_dV_S_BP)+(d_temp1_dV_S_BP*temp1))*za))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf*d_za_dV_S_BP)+(d_phi_inf_dV_S_BP*za))*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))));
          d_Phi_0_dV_GP_S = (((phi_inf*za)*(0.86*(((1.0+(4.0*((temp1*temp1)*za)))*((temp1*(-((temp1*d_za_dV_GP_S)+(d_temp1_dV_GP_S*za))))+(d_temp1_dV_GP_S*(1.0-(temp1*za))))-(temp1*(1.0-(temp1*za)))*(4.0*(((temp1*temp1)*d_za_dV_GP_S)+(((temp1*d_temp1_dV_GP_S)+(d_temp1_dV_GP_S*temp1))*za))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf*d_za_dV_GP_S)+(d_phi_inf_dV_GP_S*za))*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))));
          d_Phi_0_dV_D_S = (((phi_inf*za)*(0.86*(((1.0+(4.0*((temp1*temp1)*za)))*((temp1*(-((temp1*d_za_dV_D_S)+(d_temp1_dV_D_S*za))))+(d_temp1_dV_D_S*(1.0-(temp1*za))))-(temp1*(1.0-(temp1*za)))*(4.0*(((temp1*temp1)*d_za_dV_D_S)+(((temp1*d_temp1_dV_D_S)+(d_temp1_dV_D_S*temp1))*za))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf*d_za_dV_D_S)+(d_phi_inf_dV_D_S*za))*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))));
          Phi_0 = ((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));

          d_asat_dV_S_BP = (d_xgs_dV_S_BP+(0.5*d_Gf2_dV_S_BP));
          d_asat_dV_GP_S = (d_xgs_dV_GP_S+(0.5*d_Gf2_dV_GP_S));
          d_asat_dV_D_S = (d_xgs_dV_D_S+(0.5*d_Gf2_dV_D_S));
          asat = (xgs+(0.5*Gf2));
          {
            double value_sqrt_0 = sqrt(((asat*asat)-((Gf2*Ds)*0.98)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Phi_2_dV_S_BP = (0.98*(((asat+value_sqrt_0)*(((Gf2*d_Ds_dV_S_BP)+(d_Gf2_dV_S_BP*Ds))*phit1)-((Gf2*Ds)*phit1)*(d_asat_dV_S_BP+(deriv_sqrt_0_d0*((((asat*d_asat_dV_S_BP)+(d_asat_dV_S_BP*asat))-(((Gf2*d_Ds_dV_S_BP)+(d_Gf2_dV_S_BP*Ds))*0.98))))))/(asat+value_sqrt_0)/(asat+value_sqrt_0)));
            d_Phi_2_dV_GP_S = (0.98*(((asat+value_sqrt_0)*(((Gf2*d_Ds_dV_GP_S)+(d_Gf2_dV_GP_S*Ds))*phit1)-((Gf2*Ds)*phit1)*(d_asat_dV_GP_S+(deriv_sqrt_0_d0*((((asat*d_asat_dV_GP_S)+(d_asat_dV_GP_S*asat))-(((Gf2*d_Ds_dV_GP_S)+(d_Gf2_dV_GP_S*Ds))*0.98))))))/(asat+value_sqrt_0)/(asat+value_sqrt_0)));
            d_Phi_2_dV_D_S = (0.98*(((asat+value_sqrt_0)*(((Gf2*d_Ds_dV_D_S)+(d_Gf2_dV_D_S*Ds))*phit1)-((Gf2*Ds)*phit1)*(d_asat_dV_D_S+(deriv_sqrt_0_d0*((((asat*d_asat_dV_D_S)+(d_asat_dV_D_S*asat))-(((Gf2*d_Ds_dV_D_S)+(d_Gf2_dV_D_S*Ds))*0.98))))))/(asat+value_sqrt_0)/(asat+value_sqrt_0)));
            Phi_2 = (0.98*(((Gf2*Ds)*phit1)/(asat+value_sqrt_0)));
          }

          d_Phi_0_2_dV_S_BP = (d_Phi_0_dV_S_BP+d_Phi_2_dV_S_BP);
          d_Phi_0_2_dV_GP_S = (d_Phi_0_dV_GP_S+d_Phi_2_dV_GP_S);
          d_Phi_0_2_dV_D_S = (d_Phi_0_dV_D_S+d_Phi_2_dV_D_S);
          Phi_0_2 = (Phi_0+Phi_2);

          d_Phi0_Phi2_dV_S_BP = (2.0*((Phi_0*d_Phi_2_dV_S_BP)+(d_Phi_0_dV_S_BP*Phi_2)));
          d_Phi0_Phi2_dV_GP_S = (2.0*((Phi_0*d_Phi_2_dV_GP_S)+(d_Phi_0_dV_GP_S*Phi_2)));
          d_Phi0_Phi2_dV_D_S = (2.0*((Phi_0*d_Phi_2_dV_D_S)+(d_Phi_0_dV_D_S*Phi_2)));
          Phi0_Phi2 = (2.0*(Phi_0*Phi_2));
          {
            double value_sqrt_0 = sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Phi_sat_dV_S_BP = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_S_BP-Phi0_Phi2*(d_Phi_0_2_dV_S_BP+(deriv_sqrt_0_d0*((((Phi_0_2*d_Phi_0_2_dV_S_BP)+(d_Phi_0_2_dV_S_BP*Phi_0_2))-(1.98*d_Phi0_Phi2_dV_S_BP))))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
            d_Phi_sat_dV_GP_S = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_GP_S-Phi0_Phi2*(d_Phi_0_2_dV_GP_S+(deriv_sqrt_0_d0*((((Phi_0_2*d_Phi_0_2_dV_GP_S)+(d_Phi_0_2_dV_GP_S*Phi_0_2))-(1.98*d_Phi0_Phi2_dV_GP_S))))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
            d_Phi_sat_dV_D_S = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_D_S-Phi0_Phi2*(d_Phi_0_2_dV_D_S+(deriv_sqrt_0_d0*((((Phi_0_2*d_Phi_0_2_dV_D_S)+(d_Phi_0_2_dV_D_S*Phi_0_2))-(1.98*d_Phi0_Phi2_dV_D_S))))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
            Phi_sat = (Phi0_Phi2/(Phi_0_2+value_sqrt_0));
          }
          {
            double value_log_0 = log((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));
            double  deriv_log_0_d0 = (1.0/(1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));

            d_Vdsat_dV_S_BP = (d_Phi_sat_dV_S_BP-(phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_S_BP)+(((Phi_sat*(d_Phi_sat_dV_S_BP-((2.0*d_asat_dV_S_BP)*phit1)))+(d_Phi_sat_dV_S_BP*(Phi_sat-((2.0*asat)*phit1))))*inv_Gf2))-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*((phit1*phit1)*d_Ds_dV_S_BP))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds))))));
            d_Vdsat_dV_GP_S = (d_Phi_sat_dV_GP_S-(phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_GP_S)+(((Phi_sat*(d_Phi_sat_dV_GP_S-((2.0*d_asat_dV_GP_S)*phit1)))+(d_Phi_sat_dV_GP_S*(Phi_sat-((2.0*asat)*phit1))))*inv_Gf2))-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*((phit1*phit1)*d_Ds_dV_GP_S))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds))))));
            d_Vdsat_dV_D_S = (d_Phi_sat_dV_D_S-(phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_D_S)+(((Phi_sat*(d_Phi_sat_dV_D_S-((2.0*d_asat_dV_D_S)*phit1)))+(d_Phi_sat_dV_D_S*(Phi_sat-((2.0*asat)*phit1))))*inv_Gf2))-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*((phit1*phit1)*d_Ds_dV_D_S))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds))))));
            Vdsat = (Phi_sat-(phit1*value_log_0));
          }
        }
        else
        {

          d_Vdsat_dV_D_S = d_Vdsat_dV_GP_S = d_Vdsat_dV_S_BP =  0.0;
          Vdsat = Vdsat_lim;
        }
        {
          double value_pow_0 = pow((Vds/Vdsat),AX_i);
          double  deriv_pow_0_d0 = (((Vds/Vdsat) == 0.0)?0.0:(value_pow_0*AX_i/(Vds/Vdsat)));

          d_temp_dV_S_BP = (deriv_pow_0_d0*((-Vds*d_Vdsat_dV_S_BP/Vdsat/Vdsat)));
          d_temp_dV_GP_S = (deriv_pow_0_d0*((-Vds*d_Vdsat_dV_GP_S/Vdsat/Vdsat)));
          d_temp_dV_D_S = (deriv_pow_0_d0*(((Vdsat*d_Vds_dV_D_S-Vds*d_Vdsat_dV_D_S)/Vdsat/Vdsat)));
          temp = value_pow_0;
        }
        {
          double value_pow_0 = pow((1.0+temp),(-inv_AX));
          double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-inv_AX)/(1.0+temp)));

          d_Vdse_dV_S_BP = (Vds*(deriv_pow_0_d0*(d_temp_dV_S_BP)));
          d_Vdse_dV_GP_S = (Vds*(deriv_pow_0_d0*(d_temp_dV_GP_S)));
          d_Vdse_dV_D_S = ((Vds*(deriv_pow_0_d0*(d_temp_dV_D_S)))+(d_Vds_dV_D_S*value_pow_0));
          Vdse = (Vds*value_pow_0);
        }

        d_Udse_dV_D_S = (d_Vdse_dV_D_S*inv_phit1);
        d_Udse_dV_S_BP = (d_Vdse_dV_S_BP*inv_phit1);
        d_Udse_dV_GP_S = (d_Vdse_dV_GP_S*inv_phit1);
        Udse = (Vdse*inv_phit1);

        d_xn_d_dV_GP_S = d_Udse_dV_GP_S;
        d_xn_d_dV_S_BP = (d_xn_s_dV_S_BP+d_Udse_dV_S_BP);
        d_xn_d_dV_D_S = (d_xn_s_dV_D_S+d_Udse_dV_D_S);
        xn_d = (xn_s+Udse);
        if ((Udse<4.6051701859880916e+02))
        {
          {
            double value_exp_0 = exp((-Udse));
            double  deriv_exp_0_d0 = value_exp_0;

            d_k_ds_dV_D_S = (deriv_exp_0_d0*((-d_Udse_dV_D_S)));
            d_k_ds_dV_S_BP = (deriv_exp_0_d0*((-d_Udse_dV_S_BP)));
            d_k_ds_dV_GP_S = (deriv_exp_0_d0*((-d_Udse_dV_GP_S)));
            k_ds = value_exp_0;
          }
        }
        else
        {

          d_k_ds_dV_D_S = (-1.0e-200*(((Udse-4.6051701859880916e+02)*(0.5*(((Udse-4.6051701859880916e+02)*(d_Udse_dV_D_S*3.3333333333333333e-01))+(d_Udse_dV_D_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_Udse_dV_D_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
          d_k_ds_dV_S_BP = (-1.0e-200*(((Udse-4.6051701859880916e+02)*(0.5*(((Udse-4.6051701859880916e+02)*(d_Udse_dV_S_BP*3.3333333333333333e-01))+(d_Udse_dV_S_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_Udse_dV_S_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
          d_k_ds_dV_GP_S = (-1.0e-200*(((Udse-4.6051701859880916e+02)*(0.5*(((Udse-4.6051701859880916e+02)*(d_Udse_dV_GP_S*3.3333333333333333e-01))+(d_Udse_dV_GP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_Udse_dV_GP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
          k_ds = (1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
        }

        d_delta_nd_dV_GP_S = (delta_ns*d_k_ds_dV_GP_S);
        d_delta_nd_dV_S_BP = ((delta_ns*d_k_ds_dV_S_BP)+(d_delta_ns_dV_S_BP*k_ds));
        d_delta_nd_dV_D_S = ((delta_ns*d_k_ds_dV_D_S)+(d_delta_ns_dV_D_S*k_ds));
        delta_nd = (delta_ns*k_ds);
        if ((fabs(xg)<=margin))
        {

          d_SP_S_temp1_dV_S_BP = ((((inv_xi*d_inv_xi_dV_S_BP)+(d_inv_xi_dV_S_BP*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
          d_SP_S_temp1_dV_GP_S = ((((inv_xi*d_inv_xi_dV_GP_S)+(d_inv_xi_dV_GP_S*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
          d_SP_S_temp1_dV_D_S = ((((inv_xi*d_inv_xi_dV_D_S)+(d_inv_xi_dV_D_S*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
          SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);

          d_x_d_dV_S_BP = (((xg*inv_xi)*((((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_S_BP)+((((xg*(1.0-delta_nd))*d_Gf_dV_S_BP)+(((xg*(-d_delta_nd_dV_S_BP))+(d_xg_dV_S_BP*(1.0-delta_nd)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_S_BP)+(d_xg_dV_S_BP*inv_xi))*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1))));
          d_x_d_dV_GP_S = (((xg*inv_xi)*((((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_GP_S)+((((xg*(1.0-delta_nd))*d_Gf_dV_GP_S)+(((xg*(-d_delta_nd_dV_GP_S))+(d_xg_dV_GP_S*(1.0-delta_nd)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_GP_S)+(d_xg_dV_GP_S*inv_xi))*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1))));
          d_x_d_dV_D_S = (((xg*inv_xi)*((((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_D_S)+((((xg*(1.0-delta_nd))*d_Gf_dV_D_S)+(((xg*(-d_delta_nd_dV_D_S))+(d_xg_dV_D_S*(1.0-delta_nd)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_D_S)+(d_xg_dV_D_S*inv_xi))*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1))));
          x_d = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
        }
        else
        {

          d_SP_S_bx_dV_GP_S = d_xn_d_dV_GP_S;
          d_SP_S_bx_dV_S_BP = d_xn_d_dV_S_BP;
          d_SP_S_bx_dV_D_S = d_xn_d_dV_D_S;
          SP_S_bx = (xn_d+3);
          {
            double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
            double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
            double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

            d_SP_S_eta_dV_S_BP = ((0.5*((d_SP_S_x1_dV_S_BP+d_SP_S_bx_dV_S_BP)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_S_BP-d_SP_S_bx_dV_S_BP))+((d_SP_S_x1_dV_S_BP-d_SP_S_bx_dV_S_BP)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_S_BP-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_S_BP)+(d_SP_S_bx_dV_S_BP*SP_S_bx)))))));
            d_SP_S_eta_dV_GP_S = ((0.5*((d_SP_S_x1_dV_GP_S+d_SP_S_bx_dV_GP_S)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_GP_S-d_SP_S_bx_dV_GP_S))+((d_SP_S_x1_dV_GP_S-d_SP_S_bx_dV_GP_S)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_GP_S-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_GP_S)+(d_SP_S_bx_dV_GP_S*SP_S_bx)))))));
            d_SP_S_eta_dV_D_S = ((0.5*((d_SP_S_x1_dV_D_S+d_SP_S_bx_dV_D_S)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_D_S-d_SP_S_bx_dV_D_S))+((d_SP_S_x1_dV_D_S-d_SP_S_bx_dV_D_S)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_D_S-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_D_S)+(d_SP_S_bx_dV_D_S*SP_S_bx)))))));
            SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
          }

          d_SP_S_temp_dV_S_BP = (d_xg_dV_S_BP-d_SP_S_eta_dV_S_BP);
          d_SP_S_temp_dV_GP_S = (d_xg_dV_GP_S-d_SP_S_eta_dV_GP_S);
          d_SP_S_temp_dV_D_S = (d_xg_dV_D_S-d_SP_S_eta_dV_D_S);
          SP_S_temp = (xg-SP_S_eta);
          {
            double value_exp_0 = exp((-SP_S_eta));
            double  deriv_exp_0_d0 = value_exp_0;

            d_SP_S_temp1_dV_S_BP = (deriv_exp_0_d0*((-d_SP_S_eta_dV_S_BP)));
            d_SP_S_temp1_dV_GP_S = (deriv_exp_0_d0*((-d_SP_S_eta_dV_GP_S)));
            d_SP_S_temp1_dV_D_S = (deriv_exp_0_d0*((-d_SP_S_eta_dV_D_S)));
            SP_S_temp1 = value_exp_0;
          }

          d_SP_S_temp2_dV_S_BP = (-((SP_S_eta*d_SP_S_eta_dV_S_BP)+(d_SP_S_eta_dV_S_BP*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
          d_SP_S_temp2_dV_GP_S = (-((SP_S_eta*d_SP_S_eta_dV_GP_S)+(d_SP_S_eta_dV_GP_S*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
          d_SP_S_temp2_dV_D_S = (-((SP_S_eta*d_SP_S_eta_dV_D_S)+(d_SP_S_eta_dV_D_S*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
          SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));

          d_SP_S_xi0_dV_S_BP = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_S_BP)+(((SP_S_eta*d_SP_S_eta_dV_S_BP)+(d_SP_S_eta_dV_S_BP*SP_S_eta))*SP_S_temp2));
          d_SP_S_xi0_dV_GP_S = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_GP_S)+(((SP_S_eta*d_SP_S_eta_dV_GP_S)+(d_SP_S_eta_dV_GP_S*SP_S_eta))*SP_S_temp2));
          d_SP_S_xi0_dV_D_S = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_D_S)+(((SP_S_eta*d_SP_S_eta_dV_D_S)+(d_SP_S_eta_dV_D_S*SP_S_eta))*SP_S_temp2));
          SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);

          d_SP_S_xi1_dV_S_BP = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_S_BP)+(((SP_S_eta*d_SP_S_temp2_dV_S_BP)+(d_SP_S_eta_dV_S_BP*SP_S_temp2))*SP_S_temp2)));
          d_SP_S_xi1_dV_GP_S = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_GP_S)+(((SP_S_eta*d_SP_S_temp2_dV_GP_S)+(d_SP_S_eta_dV_GP_S*SP_S_temp2))*SP_S_temp2)));
          d_SP_S_xi1_dV_D_S = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_D_S)+(((SP_S_eta*d_SP_S_temp2_dV_D_S)+(d_SP_S_eta_dV_D_S*SP_S_temp2))*SP_S_temp2)));
          SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));

          d_SP_S_xi2_dV_S_BP = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_S_BP)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_S_BP)+(((8.0*d_SP_S_temp2_dV_S_BP)-(12.0*d_SP_S_xi0_dV_S_BP))*SP_S_temp2))*SP_S_temp2));
          d_SP_S_xi2_dV_GP_S = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_GP_S)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_GP_S)+(((8.0*d_SP_S_temp2_dV_GP_S)-(12.0*d_SP_S_xi0_dV_GP_S))*SP_S_temp2))*SP_S_temp2));
          d_SP_S_xi2_dV_D_S = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_D_S)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_D_S)+(((8.0*d_SP_S_temp2_dV_D_S)-(12.0*d_SP_S_xi0_dV_D_S))*SP_S_temp2))*SP_S_temp2));
          SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
          {
            double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))));
            double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);

            d_SP_S_a_dV_S_BP = 0.0;
            d_SP_S_a_dV_GP_S = 0.0;
            d_SP_S_a_dV_D_S = 0.0;
            SP_S_a = value_max_0;
          }

          d_SP_S_b_dV_S_BP = (-(0.5*((Gf2*(d_SP_S_temp1_dV_S_BP-((delta_nd*d_SP_S_xi2_dV_S_BP)+(d_delta_nd_dV_S_BP*SP_S_xi2))))+(d_Gf2_dV_S_BP*(SP_S_temp1-(delta_nd*SP_S_xi2))))));
          d_SP_S_b_dV_GP_S = (-(0.5*((Gf2*(d_SP_S_temp1_dV_GP_S-((delta_nd*d_SP_S_xi2_dV_GP_S)+(d_delta_nd_dV_GP_S*SP_S_xi2))))+(d_Gf2_dV_GP_S*(SP_S_temp1-(delta_nd*SP_S_xi2))))));
          d_SP_S_b_dV_D_S = (-(0.5*((Gf2*(d_SP_S_temp1_dV_D_S-((delta_nd*d_SP_S_xi2_dV_D_S)+(d_delta_nd_dV_D_S*SP_S_xi2))))+(d_Gf2_dV_D_S*(SP_S_temp1-(delta_nd*SP_S_xi2))))));
          SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))));

          d_SP_S_c_dV_S_BP = ((2.0*d_SP_S_temp_dV_S_BP)+((Gf2*((-d_SP_S_temp1_dV_S_BP)-((delta_nd*d_SP_S_xi1_dV_S_BP)+(d_delta_nd_dV_S_BP*(1.0+SP_S_xi1)))))+(d_Gf2_dV_S_BP*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1))))));
          d_SP_S_c_dV_GP_S = ((2.0*d_SP_S_temp_dV_GP_S)+((Gf2*((-d_SP_S_temp1_dV_GP_S)-((delta_nd*d_SP_S_xi1_dV_GP_S)+(d_delta_nd_dV_GP_S*(1.0+SP_S_xi1)))))+(d_Gf2_dV_GP_S*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1))))));
          d_SP_S_c_dV_D_S = ((2.0*d_SP_S_temp_dV_D_S)+((Gf2*((-d_SP_S_temp1_dV_D_S)-((delta_nd*d_SP_S_xi1_dV_D_S)+(d_delta_nd_dV_D_S*(1.0+SP_S_xi1)))))+(d_Gf2_dV_D_S*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1))))));
          SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
          {
            double value_log_0 = log((SP_S_a/Gf2));
            double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));

            d_SP_S_tau_dV_GP_S = ((d_xn_d_dV_GP_S-d_SP_S_eta_dV_GP_S)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_GP_S-SP_S_a*d_Gf2_dV_GP_S)/Gf2/Gf2))));
            d_SP_S_tau_dV_S_BP = ((d_xn_d_dV_S_BP-d_SP_S_eta_dV_S_BP)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_S_BP-SP_S_a*d_Gf2_dV_S_BP)/Gf2/Gf2))));
            d_SP_S_tau_dV_D_S = ((d_xn_d_dV_D_S-d_SP_S_eta_dV_D_S)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_D_S-SP_S_a*d_Gf2_dV_D_S)/Gf2/Gf2))));
            SP_S_tau = ((xn_d-SP_S_eta)+value_log_0);
          }

          d_nu_dV_S_BP = (d_SP_S_a_dV_S_BP+d_SP_S_c_dV_S_BP);
          d_nu_dV_GP_S = (d_SP_S_a_dV_GP_S+d_SP_S_c_dV_GP_S);
          d_nu_dV_D_S = (d_SP_S_a_dV_D_S+d_SP_S_c_dV_D_S);
          nu = (SP_S_a+SP_S_c);

          d_mutau_dV_S_BP = (((nu*d_nu_dV_S_BP)+(d_nu_dV_S_BP*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_S_BP)+(d_SP_S_c_dV_S_BP*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_S_BP)+(d_SP_S_a_dV_S_BP*SP_S_b))))+(d_SP_S_tau_dV_S_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
          d_mutau_dV_GP_S = (((nu*d_nu_dV_GP_S)+(d_nu_dV_GP_S*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_GP_S)+(d_SP_S_c_dV_GP_S*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_GP_S)+(d_SP_S_a_dV_GP_S*SP_S_b))))+(d_SP_S_tau_dV_GP_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
          d_mutau_dV_D_S = (((nu*d_nu_dV_D_S)+(d_nu_dV_D_S*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_D_S)+(d_SP_S_c_dV_D_S*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_D_S)+(d_SP_S_a_dV_D_S*SP_S_b))))+(d_SP_S_tau_dV_D_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
          mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));

          d_SP_S_x0_dV_S_BP = (d_SP_S_eta_dV_S_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_S_BP)+(((SP_S_a*d_nu_dV_S_BP)+(d_SP_S_a_dV_S_BP*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_S_BP+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_S_BP)+(d_SP_S_c_dV_S_BP*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_S_BP)+(d_SP_S_a_dV_S_BP*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_S_BP)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_S_BP)+((((nu/mutau)*d_SP_S_tau_dV_S_BP)+(((mutau*d_nu_dV_S_BP-nu*d_mutau_dV_S_BP)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
          d_SP_S_x0_dV_GP_S = (d_SP_S_eta_dV_GP_S+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_GP_S)+(((SP_S_a*d_nu_dV_GP_S)+(d_SP_S_a_dV_GP_S*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_S+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_GP_S)+(d_SP_S_c_dV_GP_S*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_GP_S)+(d_SP_S_a_dV_GP_S*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_S)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_S)+((((nu/mutau)*d_SP_S_tau_dV_GP_S)+(((mutau*d_nu_dV_GP_S-nu*d_mutau_dV_GP_S)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
          d_SP_S_x0_dV_D_S = (d_SP_S_eta_dV_D_S+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_D_S)+(((SP_S_a*d_nu_dV_D_S)+(d_SP_S_a_dV_D_S*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_D_S+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_D_S)+(d_SP_S_c_dV_D_S*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_D_S)+(d_SP_S_a_dV_D_S*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_D_S)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_D_S)+((((nu/mutau)*d_SP_S_tau_dV_D_S)+(((mutau*d_nu_dV_D_S-nu*d_mutau_dV_D_S)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
          SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
          if ((SP_S_x0<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp(SP_S_x0);
              double  deriv_exp_0_d0 = value_exp_0;

              d_SP_S_delta0_dV_S_BP = (deriv_exp_0_d0*(d_SP_S_x0_dV_S_BP));
              d_SP_S_delta0_dV_GP_S = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_S));
              d_SP_S_delta0_dV_D_S = (deriv_exp_0_d0*(d_SP_S_x0_dV_D_S));
              SP_S_delta0 = value_exp_0;
            }

            d_SP_S_delta1_dV_S_BP = (-d_SP_S_delta0_dV_S_BP/SP_S_delta0/SP_S_delta0);
            d_SP_S_delta1_dV_GP_S = (-d_SP_S_delta0_dV_GP_S/SP_S_delta0/SP_S_delta0);
            d_SP_S_delta1_dV_D_S = (-d_SP_S_delta0_dV_D_S/SP_S_delta0/SP_S_delta0);
            SP_S_delta1 = (1.0/SP_S_delta0);

            d_SP_S_delta0_dV_GP_S = ((delta_nd*d_SP_S_delta0_dV_GP_S)+(d_delta_nd_dV_GP_S*SP_S_delta0));
            d_SP_S_delta0_dV_S_BP = ((delta_nd*d_SP_S_delta0_dV_S_BP)+(d_delta_nd_dV_S_BP*SP_S_delta0));
            d_SP_S_delta0_dV_D_S = ((delta_nd*d_SP_S_delta0_dV_D_S)+(d_delta_nd_dV_D_S*SP_S_delta0));
            SP_S_delta0 = (delta_nd*SP_S_delta0);
          }
          else
          {
            if ((SP_S_x0>(xn_d-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp((SP_S_x0-xn_d));
                double  deriv_exp_0_d0 = value_exp_0;

                d_SP_S_delta0_dV_S_BP = (deriv_exp_0_d0*((d_SP_S_x0_dV_S_BP-d_xn_d_dV_S_BP)));
                d_SP_S_delta0_dV_GP_S = (deriv_exp_0_d0*((d_SP_S_x0_dV_GP_S-d_xn_d_dV_GP_S)));
                d_SP_S_delta0_dV_D_S = (deriv_exp_0_d0*((d_SP_S_x0_dV_D_S-d_xn_d_dV_D_S)));
                SP_S_delta0 = value_exp_0;
              }

              d_SP_S_delta1_dV_GP_S = ((SP_S_delta0*d_delta_nd_dV_GP_S-delta_nd*d_SP_S_delta0_dV_GP_S)/SP_S_delta0/SP_S_delta0);
              d_SP_S_delta1_dV_S_BP = ((SP_S_delta0*d_delta_nd_dV_S_BP-delta_nd*d_SP_S_delta0_dV_S_BP)/SP_S_delta0/SP_S_delta0);
              d_SP_S_delta1_dV_D_S = ((SP_S_delta0*d_delta_nd_dV_D_S-delta_nd*d_SP_S_delta0_dV_D_S)/SP_S_delta0/SP_S_delta0);
              SP_S_delta1 = (delta_nd/SP_S_delta0);
            }
            else
            {

              d_SP_S_delta0_dV_GP_S = (-1.0e-100*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*((d_xn_d_dV_GP_S-d_SP_S_x0_dV_GP_S)*3.3333333333333333e-01))+((d_xn_d_dV_GP_S-d_SP_S_x0_dV_GP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_GP_S-d_SP_S_x0_dV_GP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_SP_S_delta0_dV_S_BP = (-1.0e-100*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*((d_xn_d_dV_S_BP-d_SP_S_x0_dV_S_BP)*3.3333333333333333e-01))+((d_xn_d_dV_S_BP-d_SP_S_x0_dV_S_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_S_BP-d_SP_S_x0_dV_S_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_SP_S_delta0_dV_D_S = (-1.0e-100*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*((d_xn_d_dV_D_S-d_SP_S_x0_dV_D_S)*3.3333333333333333e-01))+((d_xn_d_dV_D_S-d_SP_S_x0_dV_D_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_D_S-d_SP_S_x0_dV_D_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              SP_S_delta0 = (1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

              d_SP_S_delta1_dV_S_BP = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_S_BP*3.3333333333333333e-01))+(d_SP_S_x0_dV_S_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_S_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_SP_S_delta1_dV_GP_S = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_GP_S*3.3333333333333333e-01))+(d_SP_S_x0_dV_GP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_GP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_SP_S_delta1_dV_D_S = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_D_S*3.3333333333333333e-01))+(d_SP_S_x0_dV_D_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_D_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }

          d_SP_S_temp_dV_S_BP = (-((SP_S_x0*d_SP_S_x0_dV_S_BP)+(d_SP_S_x0_dV_S_BP*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
          d_SP_S_temp_dV_GP_S = (-((SP_S_x0*d_SP_S_x0_dV_GP_S)+(d_SP_S_x0_dV_GP_S*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
          d_SP_S_temp_dV_D_S = (-((SP_S_x0*d_SP_S_x0_dV_D_S)+(d_SP_S_x0_dV_D_S*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
          SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));

          d_SP_S_xi0_dV_S_BP = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_S_BP)+(((SP_S_x0*d_SP_S_x0_dV_S_BP)+(d_SP_S_x0_dV_S_BP*SP_S_x0))*SP_S_temp));
          d_SP_S_xi0_dV_GP_S = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_GP_S)+(((SP_S_x0*d_SP_S_x0_dV_GP_S)+(d_SP_S_x0_dV_GP_S*SP_S_x0))*SP_S_temp));
          d_SP_S_xi0_dV_D_S = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_D_S)+(((SP_S_x0*d_SP_S_x0_dV_D_S)+(d_SP_S_x0_dV_D_S*SP_S_x0))*SP_S_temp));
          SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);

          d_SP_S_xi1_dV_S_BP = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_S_BP)+(((SP_S_x0*d_SP_S_temp_dV_S_BP)+(d_SP_S_x0_dV_S_BP*SP_S_temp))*SP_S_temp)));
          d_SP_S_xi1_dV_GP_S = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_GP_S)+(((SP_S_x0*d_SP_S_temp_dV_GP_S)+(d_SP_S_x0_dV_GP_S*SP_S_temp))*SP_S_temp)));
          d_SP_S_xi1_dV_D_S = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_D_S)+(((SP_S_x0*d_SP_S_temp_dV_D_S)+(d_SP_S_x0_dV_D_S*SP_S_temp))*SP_S_temp)));
          SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));

          d_SP_S_xi2_dV_S_BP = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_S_BP)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_S_BP)+(((8.0*d_SP_S_temp_dV_S_BP)-(12.0*d_SP_S_xi0_dV_S_BP))*SP_S_temp))*SP_S_temp));
          d_SP_S_xi2_dV_GP_S = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_S)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_S)+(((8.0*d_SP_S_temp_dV_GP_S)-(12.0*d_SP_S_xi0_dV_GP_S))*SP_S_temp))*SP_S_temp));
          d_SP_S_xi2_dV_D_S = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_D_S)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_D_S)+(((8.0*d_SP_S_temp_dV_D_S)-(12.0*d_SP_S_xi0_dV_D_S))*SP_S_temp))*SP_S_temp));
          SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

          d_SP_S_temp_dV_S_BP = (d_xg_dV_S_BP-d_SP_S_x0_dV_S_BP);
          d_SP_S_temp_dV_GP_S = (d_xg_dV_GP_S-d_SP_S_x0_dV_GP_S);
          d_SP_S_temp_dV_D_S = (d_xg_dV_D_S-d_SP_S_x0_dV_D_S);
          SP_S_temp = (xg-SP_S_x0);

          d_SP_S_pC_dV_S_BP = ((2.0*d_SP_S_temp_dV_S_BP)+((Gf2*(((-d_SP_S_delta1_dV_S_BP)+d_SP_S_delta0_dV_S_BP)-((delta_nd*d_SP_S_xi1_dV_S_BP)+(d_delta_nd_dV_S_BP*(1.0+SP_S_xi1)))))+(d_Gf2_dV_S_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1))))));
          d_SP_S_pC_dV_GP_S = ((2.0*d_SP_S_temp_dV_GP_S)+((Gf2*(((-d_SP_S_delta1_dV_GP_S)+d_SP_S_delta0_dV_GP_S)-((delta_nd*d_SP_S_xi1_dV_GP_S)+(d_delta_nd_dV_GP_S*(1.0+SP_S_xi1)))))+(d_Gf2_dV_GP_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1))))));
          d_SP_S_pC_dV_D_S = ((2.0*d_SP_S_temp_dV_D_S)+((Gf2*(((-d_SP_S_delta1_dV_D_S)+d_SP_S_delta0_dV_D_S)-((delta_nd*d_SP_S_xi1_dV_D_S)+(d_delta_nd_dV_D_S*(1.0+SP_S_xi1)))))+(d_Gf2_dV_D_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1))))));
          SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));

          d_SP_S_qC_dV_S_BP = (((SP_S_temp*d_SP_S_temp_dV_S_BP)+(d_SP_S_temp_dV_S_BP*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_S_BP+d_SP_S_x0_dV_S_BP)+d_SP_S_delta0_dV_S_BP)-((delta_nd*(d_SP_S_x0_dV_S_BP+d_SP_S_xi0_dV_S_BP))+(d_delta_nd_dV_S_BP*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_S_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0))))));
          d_SP_S_qC_dV_GP_S = (((SP_S_temp*d_SP_S_temp_dV_GP_S)+(d_SP_S_temp_dV_GP_S*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_GP_S+d_SP_S_x0_dV_GP_S)+d_SP_S_delta0_dV_GP_S)-((delta_nd*(d_SP_S_x0_dV_GP_S+d_SP_S_xi0_dV_GP_S))+(d_delta_nd_dV_GP_S*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_GP_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0))))));
          d_SP_S_qC_dV_D_S = (((SP_S_temp*d_SP_S_temp_dV_D_S)+(d_SP_S_temp_dV_D_S*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_D_S+d_SP_S_x0_dV_D_S)+d_SP_S_delta0_dV_D_S)-((delta_nd*(d_SP_S_x0_dV_D_S+d_SP_S_xi0_dV_D_S))+(d_delta_nd_dV_D_S*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_D_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0))))));
          SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));

          d_SP_S_temp_dV_S_BP = (-((Gf2*((d_SP_S_delta1_dV_S_BP+d_SP_S_delta0_dV_S_BP)-((delta_nd*d_SP_S_xi2_dV_S_BP)+(d_delta_nd_dV_S_BP*SP_S_xi2))))+(d_Gf2_dV_S_BP*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2)))));
          d_SP_S_temp_dV_GP_S = (-((Gf2*((d_SP_S_delta1_dV_GP_S+d_SP_S_delta0_dV_GP_S)-((delta_nd*d_SP_S_xi2_dV_GP_S)+(d_delta_nd_dV_GP_S*SP_S_xi2))))+(d_Gf2_dV_GP_S*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2)))));
          d_SP_S_temp_dV_D_S = (-((Gf2*((d_SP_S_delta1_dV_D_S+d_SP_S_delta0_dV_D_S)-((delta_nd*d_SP_S_xi2_dV_D_S)+(d_delta_nd_dV_D_S*SP_S_xi2))))+(d_Gf2_dV_D_S*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2)))));
          SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));

          d_SP_S_temp_dV_S_BP = (((SP_S_pC*d_SP_S_pC_dV_S_BP)+(d_SP_S_pC_dV_S_BP*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_S_BP)+(d_SP_S_qC_dV_S_BP*SP_S_temp))));
          d_SP_S_temp_dV_GP_S = (((SP_S_pC*d_SP_S_pC_dV_GP_S)+(d_SP_S_pC_dV_GP_S*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_GP_S)+(d_SP_S_qC_dV_GP_S*SP_S_temp))));
          d_SP_S_temp_dV_D_S = (((SP_S_pC*d_SP_S_pC_dV_D_S)+(d_SP_S_pC_dV_D_S*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_D_S)+(d_SP_S_qC_dV_D_S*SP_S_temp))));
          SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
          {
            double value_sqrt_0 = sqrt(SP_S_temp);
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_x_d_dV_S_BP = (d_SP_S_x0_dV_S_BP+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_S_BP-SP_S_qC*(d_SP_S_pC_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_S_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
            d_x_d_dV_GP_S = (d_SP_S_x0_dV_GP_S+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_S-SP_S_qC*(d_SP_S_pC_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_S))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
            d_x_d_dV_D_S = (d_SP_S_x0_dV_D_S+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_D_S-SP_S_qC*(d_SP_S_pC_dV_D_S+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_D_S))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
            x_d = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
          }
        }

        d_x_ds_dV_S_BP = (d_x_d_dV_S_BP-d_x_s_dV_S_BP);
        d_x_ds_dV_GP_S = (d_x_d_dV_GP_S-d_x_s_dV_GP_S);
        d_x_ds_dV_D_S = (d_x_d_dV_D_S-d_x_s_dV_D_S);
        x_ds = (x_d-x_s);
        if ((x_ds<1.0E-10))
        {

          d_pC_dV_S_BP = ((2.0*(d_xg_dV_S_BP-d_x_s_dV_S_BP))+((Gf2*(((-d_Es_dV_S_BP)+((delta_1s*d_k_ds_dV_S_BP)+(d_delta_1s_dV_S_BP*k_ds)))-((delta_nd*d_xi1s_dV_S_BP)+(d_delta_nd_dV_S_BP*(1.0+xi1s)))))+(d_Gf2_dV_S_BP*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s))))));
          d_pC_dV_GP_S = ((2.0*(d_xg_dV_GP_S-d_x_s_dV_GP_S))+((Gf2*(((-d_Es_dV_GP_S)+((delta_1s*d_k_ds_dV_GP_S)+(d_delta_1s_dV_GP_S*k_ds)))-((delta_nd*d_xi1s_dV_GP_S)+(d_delta_nd_dV_GP_S*(1.0+xi1s)))))+(d_Gf2_dV_GP_S*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s))))));
          d_pC_dV_D_S = ((2.0*(d_xg_dV_D_S-d_x_s_dV_D_S))+((Gf2*(((-d_Es_dV_D_S)+((delta_1s*d_k_ds_dV_D_S)+(d_delta_1s_dV_D_S*k_ds)))-((delta_nd*d_xi1s_dV_D_S)+(d_delta_nd_dV_D_S*(1.0+xi1s)))))+(d_Gf2_dV_D_S*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s))))));
          pC = ((2.0*(xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));

          d_qC_dV_S_BP = (((Gf2*(1.0-k_ds))*d_Ds_dV_S_BP)+(((Gf2*(-d_k_ds_dV_S_BP))+(d_Gf2_dV_S_BP*(1.0-k_ds)))*Ds));
          d_qC_dV_GP_S = (((Gf2*(1.0-k_ds))*d_Ds_dV_GP_S)+(((Gf2*(-d_k_ds_dV_GP_S))+(d_Gf2_dV_GP_S*(1.0-k_ds)))*Ds));
          d_qC_dV_D_S = (((Gf2*(1.0-k_ds))*d_Ds_dV_D_S)+(((Gf2*(-d_k_ds_dV_D_S))+(d_Gf2_dV_D_S*(1.0-k_ds)))*Ds));
          qC = ((Gf2*(1.0-k_ds))*Ds);

          d_temp_dV_S_BP = (-((Gf2*((d_Es_dV_S_BP+((delta_1s*d_k_ds_dV_S_BP)+(d_delta_1s_dV_S_BP*k_ds)))-((delta_nd*d_xi2s_dV_S_BP)+(d_delta_nd_dV_S_BP*xi2s))))+(d_Gf2_dV_S_BP*((Es+(delta_1s*k_ds))-(delta_nd*xi2s)))));
          d_temp_dV_GP_S = (-((Gf2*((d_Es_dV_GP_S+((delta_1s*d_k_ds_dV_GP_S)+(d_delta_1s_dV_GP_S*k_ds)))-((delta_nd*d_xi2s_dV_GP_S)+(d_delta_nd_dV_GP_S*xi2s))))+(d_Gf2_dV_GP_S*((Es+(delta_1s*k_ds))-(delta_nd*xi2s)))));
          d_temp_dV_D_S = (-((Gf2*((d_Es_dV_D_S+((delta_1s*d_k_ds_dV_D_S)+(d_delta_1s_dV_D_S*k_ds)))-((delta_nd*d_xi2s_dV_D_S)+(d_delta_nd_dV_D_S*xi2s))))+(d_Gf2_dV_D_S*((Es+(delta_1s*k_ds))-(delta_nd*xi2s)))));
          temp = (2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));

          d_temp_dV_S_BP = (((pC*d_pC_dV_S_BP)+(d_pC_dV_S_BP*pC))-(2.0*((temp*d_qC_dV_S_BP)+(d_temp_dV_S_BP*qC))));
          d_temp_dV_GP_S = (((pC*d_pC_dV_GP_S)+(d_pC_dV_GP_S*pC))-(2.0*((temp*d_qC_dV_GP_S)+(d_temp_dV_GP_S*qC))));
          d_temp_dV_D_S = (((pC*d_pC_dV_D_S)+(d_pC_dV_D_S*pC))-(2.0*((temp*d_qC_dV_D_S)+(d_temp_dV_D_S*qC))));
          temp = ((pC*pC)-(2.0*(temp*qC)));
          {
            double value_sqrt_0 = sqrt(temp);
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_x_ds_dV_S_BP = (2.0*(((pC+value_sqrt_0)*d_qC_dV_S_BP-qC*(d_pC_dV_S_BP+(deriv_sqrt_0_d0*(d_temp_dV_S_BP))))/(pC+value_sqrt_0)/(pC+value_sqrt_0)));
            d_x_ds_dV_GP_S = (2.0*(((pC+value_sqrt_0)*d_qC_dV_GP_S-qC*(d_pC_dV_GP_S+(deriv_sqrt_0_d0*(d_temp_dV_GP_S))))/(pC+value_sqrt_0)/(pC+value_sqrt_0)));
            d_x_ds_dV_D_S = (2.0*(((pC+value_sqrt_0)*d_qC_dV_D_S-qC*(d_pC_dV_D_S+(deriv_sqrt_0_d0*(d_temp_dV_D_S))))/(pC+value_sqrt_0)/(pC+value_sqrt_0)));
            x_ds = (2.0*(qC/(pC+value_sqrt_0)));
          }

          d_x_d_dV_S_BP = (d_x_s_dV_S_BP+d_x_ds_dV_S_BP);
          d_x_d_dV_GP_S = (d_x_s_dV_GP_S+d_x_ds_dV_GP_S);
          d_x_d_dV_D_S = (d_x_s_dV_D_S+d_x_ds_dV_D_S);
          x_d = (x_s+x_ds);
        }

        d_dps_dV_S_BP = (d_x_ds_dV_S_BP*phit1);
        d_dps_dV_GP_S = (d_x_ds_dV_GP_S*phit1);
        d_dps_dV_D_S = (d_x_ds_dV_D_S*phit1);
        dps = (x_ds*phit1);

        d_xi0d_dV_S_BP = (((2.0+(x_d*x_d))*((x_d*d_x_d_dV_S_BP)+(d_x_d_dV_S_BP*x_d))-(x_d*x_d)*((x_d*d_x_d_dV_S_BP)+(d_x_d_dV_S_BP*x_d)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
        d_xi0d_dV_GP_S = (((2.0+(x_d*x_d))*((x_d*d_x_d_dV_GP_S)+(d_x_d_dV_GP_S*x_d))-(x_d*x_d)*((x_d*d_x_d_dV_GP_S)+(d_x_d_dV_GP_S*x_d)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
        d_xi0d_dV_D_S = (((2.0+(x_d*x_d))*((x_d*d_x_d_dV_D_S)+(d_x_d_dV_D_S*x_d))-(x_d*x_d)*((x_d*d_x_d_dV_D_S)+(d_x_d_dV_D_S*x_d)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
        xi0d = ((x_d*x_d)/(2.0+(x_d*x_d)));
        if ((x_d<2.3025850929940458e+02))
        {
          {
            double value_exp_0 = exp((-x_d));
            double  deriv_exp_0_d0 = value_exp_0;

            d_Ed_dV_S_BP = (deriv_exp_0_d0*((-d_x_d_dV_S_BP)));
            d_Ed_dV_GP_S = (deriv_exp_0_d0*((-d_x_d_dV_GP_S)));
            d_Ed_dV_D_S = (deriv_exp_0_d0*((-d_x_d_dV_D_S)));
            Ed = value_exp_0;
          }
          if ((x_d<1.0e-5))
          {

            d_Dd_dV_GP_S = ((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.75*d_x_d_dV_GP_S))+((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_GP_S)+(((((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_GP_S)+((((1.6666666666666667e-01*delta_nd)*d_x_d_dV_GP_S)+((1.6666666666666667e-01*d_delta_nd_dV_GP_S)*x_d))*x_d))*x_d))*(1.0+(1.75*x_d))));
            d_Dd_dV_S_BP = ((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.75*d_x_d_dV_S_BP))+((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_S_BP)+(((((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_S_BP)+((((1.6666666666666667e-01*delta_nd)*d_x_d_dV_S_BP)+((1.6666666666666667e-01*d_delta_nd_dV_S_BP)*x_d))*x_d))*x_d))*(1.0+(1.75*x_d))));
            d_Dd_dV_D_S = ((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.75*d_x_d_dV_D_S))+((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_D_S)+(((((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_D_S)+((((1.6666666666666667e-01*delta_nd)*d_x_d_dV_D_S)+((1.6666666666666667e-01*d_delta_nd_dV_D_S)*x_d))*x_d))*x_d))*(1.0+(1.75*x_d))));
            Dd = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
          }
          else
          {

            d_Dd_dV_GP_S = ((delta_nd*(((-d_Ed_dV_GP_S/Ed/Ed)-d_x_d_dV_GP_S)-d_xi0d_dV_GP_S))+(d_delta_nd_dV_GP_S*((((1.0/Ed)-x_d)-1.0)-xi0d)));
            d_Dd_dV_S_BP = ((delta_nd*(((-d_Ed_dV_S_BP/Ed/Ed)-d_x_d_dV_S_BP)-d_xi0d_dV_S_BP))+(d_delta_nd_dV_S_BP*((((1.0/Ed)-x_d)-1.0)-xi0d)));
            d_Dd_dV_D_S = ((delta_nd*(((-d_Ed_dV_D_S/Ed/Ed)-d_x_d_dV_D_S)-d_xi0d_dV_D_S))+(d_delta_nd_dV_D_S*((((1.0/Ed)-x_d)-1.0)-xi0d)));
            Dd = (delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d));
          }
        }
        else
        {
          if ((x_d>(xn_d-2.3025850929940458e+02)))
          {
            {
              double value_exp_0 = exp((x_d-xn_d));
              double  deriv_exp_0_d0 = value_exp_0;

              d_temp_dV_S_BP = (deriv_exp_0_d0*((d_x_d_dV_S_BP-d_xn_d_dV_S_BP)));
              d_temp_dV_GP_S = (deriv_exp_0_d0*((d_x_d_dV_GP_S-d_xn_d_dV_GP_S)));
              d_temp_dV_D_S = (deriv_exp_0_d0*((d_x_d_dV_D_S-d_xn_d_dV_D_S)));
              temp = value_exp_0;
            }

            d_Ed_dV_GP_S = ((temp*d_delta_nd_dV_GP_S-delta_nd*d_temp_dV_GP_S)/temp/temp);
            d_Ed_dV_S_BP = ((temp*d_delta_nd_dV_S_BP-delta_nd*d_temp_dV_S_BP)/temp/temp);
            d_Ed_dV_D_S = ((temp*d_delta_nd_dV_D_S-delta_nd*d_temp_dV_D_S)/temp/temp);
            Ed = (delta_nd/temp);

            d_Dd_dV_S_BP = (d_temp_dV_S_BP-((delta_nd*(d_x_d_dV_S_BP+d_xi0d_dV_S_BP))+(d_delta_nd_dV_S_BP*((x_d+1.0)+xi0d))));
            d_Dd_dV_D_S = (d_temp_dV_D_S-((delta_nd*(d_x_d_dV_D_S+d_xi0d_dV_D_S))+(d_delta_nd_dV_D_S*((x_d+1.0)+xi0d))));
            d_Dd_dV_GP_S = (d_temp_dV_GP_S-((delta_nd*(d_x_d_dV_GP_S+d_xi0d_dV_GP_S))+(d_delta_nd_dV_GP_S*((x_d+1.0)+xi0d))));
            Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
          }
          else
          {

            d_Ed_dV_S_BP = (-1.0e-100*(((x_d-2.3025850929940458e+02)*(0.5*(((x_d-2.3025850929940458e+02)*(d_x_d_dV_S_BP*3.3333333333333333e-01))+(d_x_d_dV_S_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_d_dV_S_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            d_Ed_dV_GP_S = (-1.0e-100*(((x_d-2.3025850929940458e+02)*(0.5*(((x_d-2.3025850929940458e+02)*(d_x_d_dV_GP_S*3.3333333333333333e-01))+(d_x_d_dV_GP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_d_dV_GP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            d_Ed_dV_D_S = (-1.0e-100*(((x_d-2.3025850929940458e+02)*(0.5*(((x_d-2.3025850929940458e+02)*(d_x_d_dV_D_S*3.3333333333333333e-01))+(d_x_d_dV_D_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_d_dV_D_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            Ed = (1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

            d_temp_dV_GP_S = (-1.0e-100*((((xn_d-x_d)-2.3025850929940458e+02)*(0.5*((((xn_d-x_d)-2.3025850929940458e+02)*((d_xn_d_dV_GP_S-d_x_d_dV_GP_S)*3.3333333333333333e-01))+((d_xn_d_dV_GP_S-d_x_d_dV_GP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_GP_S-d_x_d_dV_GP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            d_temp_dV_S_BP = (-1.0e-100*((((xn_d-x_d)-2.3025850929940458e+02)*(0.5*((((xn_d-x_d)-2.3025850929940458e+02)*((d_xn_d_dV_S_BP-d_x_d_dV_S_BP)*3.3333333333333333e-01))+((d_xn_d_dV_S_BP-d_x_d_dV_S_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_S_BP-d_x_d_dV_S_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            d_temp_dV_D_S = (-1.0e-100*((((xn_d-x_d)-2.3025850929940458e+02)*(0.5*((((xn_d-x_d)-2.3025850929940458e+02)*((d_xn_d_dV_D_S-d_x_d_dV_D_S)*3.3333333333333333e-01))+((d_xn_d_dV_D_S-d_x_d_dV_D_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_D_S-d_x_d_dV_D_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            temp = (1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

            d_Dd_dV_S_BP = (d_temp_dV_S_BP-((delta_nd*(d_x_d_dV_S_BP+d_xi0d_dV_S_BP))+(d_delta_nd_dV_S_BP*((x_d+1.0)+xi0d))));
            d_Dd_dV_D_S = (d_temp_dV_D_S-((delta_nd*(d_x_d_dV_D_S+d_xi0d_dV_D_S))+(d_delta_nd_dV_D_S*((x_d+1.0)+xi0d))));
            d_Dd_dV_GP_S = (d_temp_dV_GP_S-((delta_nd*(d_x_d_dV_GP_S+d_xi0d_dV_GP_S))+(d_delta_nd_dV_GP_S*((x_d+1.0)+xi0d))));
            Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
          }
        }

        d_x_m_dV_S_BP = (0.5*(d_x_s_dV_S_BP+d_x_d_dV_S_BP));
        d_x_m_dV_GP_S = (0.5*(d_x_s_dV_GP_S+d_x_d_dV_GP_S));
        d_x_m_dV_D_S = (0.5*(d_x_s_dV_D_S+d_x_d_dV_D_S));
        x_m = (0.5*(x_s+x_d));

        d_Em_dV_D_S = d_Em_dV_GP_S = d_Em_dV_S_BP =  0.0;
        Em = 0.0;

        d_temp_dV_S_BP = ((Ed*d_Es_dV_S_BP)+(d_Ed_dV_S_BP*Es));
        d_temp_dV_GP_S = ((Ed*d_Es_dV_GP_S)+(d_Ed_dV_GP_S*Es));
        d_temp_dV_D_S = ((Ed*d_Es_dV_D_S)+(d_Ed_dV_D_S*Es));
        temp = (Ed*Es);
        if ((temp>0.0))
        {
          {
            double value_sqrt_0 = sqrt(temp);
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Em_dV_S_BP = (deriv_sqrt_0_d0*(d_temp_dV_S_BP));
            d_Em_dV_D_S = (deriv_sqrt_0_d0*(d_temp_dV_D_S));
            d_Em_dV_GP_S = (deriv_sqrt_0_d0*(d_temp_dV_GP_S));
            Em = value_sqrt_0;
          }
        }

        d_D_bar_dV_S_BP = (0.5*(d_Ds_dV_S_BP+d_Dd_dV_S_BP));
        d_D_bar_dV_GP_S = (0.5*(d_Ds_dV_GP_S+d_Dd_dV_GP_S));
        d_D_bar_dV_D_S = (0.5*(d_Ds_dV_D_S+d_Dd_dV_D_S));
        D_bar = (0.5*(Ds+Dd));

        d_Dm_dV_S_BP = (d_D_bar_dV_S_BP+(0.125*(((x_ds*x_ds)*(d_Em_dV_S_BP-(2.0*d_inv_Gf2_dV_S_BP)))+(((x_ds*d_x_ds_dV_S_BP)+(d_x_ds_dV_S_BP*x_ds))*(Em-(2.0*inv_Gf2))))));
        d_Dm_dV_GP_S = (d_D_bar_dV_GP_S+(0.125*(((x_ds*x_ds)*(d_Em_dV_GP_S-(2.0*d_inv_Gf2_dV_GP_S)))+(((x_ds*d_x_ds_dV_GP_S)+(d_x_ds_dV_GP_S*x_ds))*(Em-(2.0*inv_Gf2))))));
        d_Dm_dV_D_S = (d_D_bar_dV_D_S+(0.125*(((x_ds*x_ds)*(d_Em_dV_D_S-(2.0*d_inv_Gf2_dV_D_S)))+(((x_ds*d_x_ds_dV_D_S)+(d_x_ds_dV_D_S*x_ds))*(Em-(2.0*inv_Gf2))))));
        Dm = (D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))));
        if ((x_m<1.0e-5))
        {

          d_Pm_dV_S_BP = (0.5*(((x_m*x_m)*(-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_S_BP)))+(d_x_m_dV_S_BP*(1.0-(0.25*x_m)))))))+(((x_m*d_x_m_dV_S_BP)+(d_x_m_dV_S_BP*x_m))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))));
          d_Pm_dV_GP_S = (0.5*(((x_m*x_m)*(-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_GP_S)))+(d_x_m_dV_GP_S*(1.0-(0.25*x_m)))))))+(((x_m*d_x_m_dV_GP_S)+(d_x_m_dV_GP_S*x_m))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))));
          d_Pm_dV_D_S = (0.5*(((x_m*x_m)*(-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_D_S)))+(d_x_m_dV_D_S*(1.0-(0.25*x_m)))))))+(((x_m*d_x_m_dV_D_S)+(d_x_m_dV_D_S*x_m))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))));
          Pm = (0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))));
          {
            double value_sqrt_0 = sqrt((Dm+Pm));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_xgm_dV_S_BP = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_S_BP+d_Pm_dV_S_BP))))+(d_Gf_dV_S_BP*value_sqrt_0));
            d_xgm_dV_GP_S = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_S+d_Pm_dV_GP_S))))+(d_Gf_dV_GP_S*value_sqrt_0));
            d_xgm_dV_D_S = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_D_S+d_Pm_dV_D_S))))+(d_Gf_dV_D_S*value_sqrt_0));
            xgm = (Gf*value_sqrt_0);
          }
          if ((kp>0.0))
          {
            {
              double value_sqrt_0 = sqrt((1.0+(kp*xgm)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_eta_p_dV_S_BP = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_S_BP)))/value_sqrt_0/value_sqrt_0);
              d_eta_p_dV_GP_S = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_GP_S)))/value_sqrt_0/value_sqrt_0);
              d_eta_p_dV_D_S = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_D_S)))/value_sqrt_0/value_sqrt_0);
              eta_p = (1.0/value_sqrt_0);
            }
          }
          {
            double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_temp_dV_S_BP = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_S_BP)))+(d_x_m_dV_S_BP*(1.0-(0.25*x_m))))))));
            d_temp_dV_GP_S = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_GP_S)))+(d_x_m_dV_GP_S*(1.0-(0.25*x_m))))))));
            d_temp_dV_D_S = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_D_S)))+(d_x_m_dV_D_S*(1.0-(0.25*x_m))))))));
            temp = value_sqrt_0;
          }

          d_sqm_dV_S_BP = (7.0710678118654746e-01*((x_m*d_temp_dV_S_BP)+(d_x_m_dV_S_BP*temp)));
          d_sqm_dV_GP_S = (7.0710678118654746e-01*((x_m*d_temp_dV_GP_S)+(d_x_m_dV_GP_S*temp)));
          d_sqm_dV_D_S = (7.0710678118654746e-01*((x_m*d_temp_dV_D_S)+(d_x_m_dV_D_S*temp)));
          sqm = (7.0710678118654746e-01*(x_m*temp));

          d_alpha_dV_S_BP = (d_eta_p_dV_S_BP+(7.0710678118654746e-01*((temp*((Gf*((-(0.5*d_x_m_dV_S_BP))+(1.6666666666666667e-01*((x_m*d_x_m_dV_S_BP)+(d_x_m_dV_S_BP*x_m)))))+(d_Gf_dV_S_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_S_BP)/temp/temp)));
          d_alpha_dV_GP_S = (d_eta_p_dV_GP_S+(7.0710678118654746e-01*((temp*((Gf*((-(0.5*d_x_m_dV_GP_S))+(1.6666666666666667e-01*((x_m*d_x_m_dV_GP_S)+(d_x_m_dV_GP_S*x_m)))))+(d_Gf_dV_GP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_GP_S)/temp/temp)));
          d_alpha_dV_D_S = (d_eta_p_dV_D_S+(7.0710678118654746e-01*((temp*((Gf*((-(0.5*d_x_m_dV_D_S))+(1.6666666666666667e-01*((x_m*d_x_m_dV_D_S)+(d_x_m_dV_D_S*x_m)))))+(d_Gf_dV_D_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_D_S)/temp/temp)));
          alpha = (eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)));
        }
        else
        {

          d_Pm_dV_S_BP = (d_x_m_dV_S_BP+d_Em_dV_S_BP);
          d_Pm_dV_GP_S = (d_x_m_dV_GP_S+d_Em_dV_GP_S);
          d_Pm_dV_D_S = (d_x_m_dV_D_S+d_Em_dV_D_S);
          Pm = ((x_m-1.0)+Em);
          {
            double value_sqrt_0 = sqrt((Dm+Pm));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_xgm_dV_S_BP = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_S_BP+d_Pm_dV_S_BP))))+(d_Gf_dV_S_BP*value_sqrt_0));
            d_xgm_dV_GP_S = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_S+d_Pm_dV_GP_S))))+(d_Gf_dV_GP_S*value_sqrt_0));
            d_xgm_dV_D_S = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_D_S+d_Pm_dV_D_S))))+(d_Gf_dV_D_S*value_sqrt_0));
            xgm = (Gf*value_sqrt_0);
          }
          if ((kp>0.0))
          {

            d_d0_dV_S_BP = ((-d_Em_dV_S_BP)+(2.0*((xgm*d_inv_Gf2_dV_S_BP)+(d_xgm_dV_S_BP*inv_Gf2))));
            d_d0_dV_GP_S = ((-d_Em_dV_GP_S)+(2.0*((xgm*d_inv_Gf2_dV_GP_S)+(d_xgm_dV_GP_S*inv_Gf2))));
            d_d0_dV_D_S = ((-d_Em_dV_D_S)+(2.0*((xgm*d_inv_Gf2_dV_D_S)+(d_xgm_dV_D_S*inv_Gf2))));
            d0 = ((1.0-Em)+(2.0*(xgm*inv_Gf2)));
            {
              double value_sqrt_0 = sqrt((1.0+(kp*xgm)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_eta_p_dV_S_BP = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_S_BP)))/value_sqrt_0/value_sqrt_0);
              d_eta_p_dV_GP_S = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_GP_S)))/value_sqrt_0/value_sqrt_0);
              d_eta_p_dV_D_S = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_D_S)))/value_sqrt_0/value_sqrt_0);
              eta_p = (1.0/value_sqrt_0);
            }

            d_temp_dV_S_BP = (((eta_p+1.0)*d_eta_p_dV_S_BP-eta_p*d_eta_p_dV_S_BP)/(eta_p+1.0)/(eta_p+1.0));
            d_temp_dV_GP_S = (((eta_p+1.0)*d_eta_p_dV_GP_S-eta_p*d_eta_p_dV_GP_S)/(eta_p+1.0)/(eta_p+1.0));
            d_temp_dV_D_S = (((eta_p+1.0)*d_eta_p_dV_D_S-eta_p*d_eta_p_dV_D_S)/(eta_p+1.0)/(eta_p+1.0));
            temp = (eta_p/(eta_p+1.0));

            d_x_pm_dV_S_BP = (kp*((((temp*temp)*Gf2)*d_Dm_dV_S_BP)+((((temp*temp)*d_Gf2_dV_S_BP)+(((temp*d_temp_dV_S_BP)+(d_temp_dV_S_BP*temp))*Gf2))*Dm)));
            d_x_pm_dV_D_S = (kp*((((temp*temp)*Gf2)*d_Dm_dV_D_S)+((((temp*temp)*d_Gf2_dV_D_S)+(((temp*d_temp_dV_D_S)+(d_temp_dV_D_S*temp))*Gf2))*Dm)));
            d_x_pm_dV_GP_S = (kp*((((temp*temp)*Gf2)*d_Dm_dV_GP_S)+((((temp*temp)*d_Gf2_dV_GP_S)+(((temp*d_temp_dV_GP_S)+(d_temp_dV_GP_S*temp))*Gf2))*Dm)));
            x_pm = (kp*(((temp*temp)*Gf2)*Dm));

            d_p_pd_dV_S_BP = ((2.0*(d_xgm_dV_S_BP-d_x_pm_dV_S_BP))+((Gf2*((-d_Em_dV_S_BP)+d_Dm_dV_S_BP))+(d_Gf2_dV_S_BP*((1.0-Em)+Dm))));
            d_p_pd_dV_GP_S = ((2.0*(d_xgm_dV_GP_S-d_x_pm_dV_GP_S))+((Gf2*((-d_Em_dV_GP_S)+d_Dm_dV_GP_S))+(d_Gf2_dV_GP_S*((1.0-Em)+Dm))));
            d_p_pd_dV_D_S = ((2.0*(d_xgm_dV_D_S-d_x_pm_dV_D_S))+((Gf2*((-d_Em_dV_D_S)+d_Dm_dV_D_S))+(d_Gf2_dV_D_S*((1.0-Em)+Dm))));
            p_pd = ((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm)));

            d_q_pd_dV_S_BP = ((x_pm*(d_x_pm_dV_S_BP-(2.0*d_xgm_dV_S_BP)))+(d_x_pm_dV_S_BP*(x_pm-(2.0*xgm))));
            d_q_pd_dV_D_S = ((x_pm*(d_x_pm_dV_D_S-(2.0*d_xgm_dV_D_S)))+(d_x_pm_dV_D_S*(x_pm-(2.0*xgm))));
            d_q_pd_dV_GP_S = ((x_pm*(d_x_pm_dV_GP_S-(2.0*d_xgm_dV_GP_S)))+(d_x_pm_dV_GP_S*(x_pm-(2.0*xgm))));
            q_pd = (x_pm*(x_pm-(2.0*xgm)));

            d_xi_pd_dV_S_BP = (-(0.5*((Gf2*(d_Em_dV_S_BP+d_Dm_dV_S_BP))+(d_Gf2_dV_S_BP*(Em+Dm)))));
            d_xi_pd_dV_GP_S = (-(0.5*((Gf2*(d_Em_dV_GP_S+d_Dm_dV_GP_S))+(d_Gf2_dV_GP_S*(Em+Dm)))));
            d_xi_pd_dV_D_S = (-(0.5*((Gf2*(d_Em_dV_D_S+d_Dm_dV_D_S))+(d_Gf2_dV_D_S*(Em+Dm)))));
            xi_pd = (1.0-(0.5*(Gf2*(Em+Dm))));

            d_u_pd_dV_S_BP = ((((p_pd*p_pd)-(xi_pd*q_pd))*((q_pd*d_p_pd_dV_S_BP)+(d_q_pd_dV_S_BP*p_pd))-(q_pd*p_pd)*(((p_pd*d_p_pd_dV_S_BP)+(d_p_pd_dV_S_BP*p_pd))-((xi_pd*d_q_pd_dV_S_BP)+(d_xi_pd_dV_S_BP*q_pd))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
            d_u_pd_dV_D_S = ((((p_pd*p_pd)-(xi_pd*q_pd))*((q_pd*d_p_pd_dV_D_S)+(d_q_pd_dV_D_S*p_pd))-(q_pd*p_pd)*(((p_pd*d_p_pd_dV_D_S)+(d_p_pd_dV_D_S*p_pd))-((xi_pd*d_q_pd_dV_D_S)+(d_xi_pd_dV_D_S*q_pd))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
            d_u_pd_dV_GP_S = ((((p_pd*p_pd)-(xi_pd*q_pd))*((q_pd*d_p_pd_dV_GP_S)+(d_q_pd_dV_GP_S*p_pd))-(q_pd*p_pd)*(((p_pd*d_p_pd_dV_GP_S)+(d_p_pd_dV_GP_S*p_pd))-((xi_pd*d_q_pd_dV_GP_S)+(d_xi_pd_dV_GP_S*q_pd))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
            u_pd = ((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd)));

            d_x_m_dV_S_BP = (d_x_m_dV_S_BP+d_u_pd_dV_S_BP);
            d_x_m_dV_GP_S = (d_x_m_dV_GP_S+d_u_pd_dV_GP_S);
            d_x_m_dV_D_S = (d_x_m_dV_D_S+d_u_pd_dV_D_S);
            x_m = (x_m+u_pd);
            {
              double value_exp_0 = exp(u_pd);
              double  deriv_exp_0_d0 = value_exp_0;

              d_km_dV_S_BP = (deriv_exp_0_d0*(d_u_pd_dV_S_BP));
              d_km_dV_D_S = (deriv_exp_0_d0*(d_u_pd_dV_D_S));
              d_km_dV_GP_S = (deriv_exp_0_d0*(d_u_pd_dV_GP_S));
              km = value_exp_0;
            }

            d_Em_dV_S_BP = ((km*d_Em_dV_S_BP-Em*d_km_dV_S_BP)/km/km);
            d_Em_dV_GP_S = ((km*d_Em_dV_GP_S-Em*d_km_dV_GP_S)/km/km);
            d_Em_dV_D_S = ((km*d_Em_dV_D_S-Em*d_km_dV_D_S)/km/km);
            Em = (Em/km);

            d_Dm_dV_S_BP = ((Dm*d_km_dV_S_BP)+(d_Dm_dV_S_BP*km));
            d_Dm_dV_GP_S = ((Dm*d_km_dV_GP_S)+(d_Dm_dV_GP_S*km));
            d_Dm_dV_D_S = ((Dm*d_km_dV_D_S)+(d_Dm_dV_D_S*km));
            Dm = (Dm*km);

            d_Pm_dV_S_BP = (d_x_m_dV_S_BP+d_Em_dV_S_BP);
            d_Pm_dV_GP_S = (d_x_m_dV_GP_S+d_Em_dV_GP_S);
            d_Pm_dV_D_S = (d_x_m_dV_D_S+d_Em_dV_D_S);
            Pm = ((x_m-1.0)+Em);
            {
              double value_sqrt_0 = sqrt((Dm+Pm));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_xgm_dV_S_BP = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_S_BP+d_Pm_dV_S_BP))))+(d_Gf_dV_S_BP*value_sqrt_0));
              d_xgm_dV_GP_S = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_S+d_Pm_dV_GP_S))))+(d_Gf_dV_GP_S*value_sqrt_0));
              d_xgm_dV_D_S = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_D_S+d_Pm_dV_D_S))))+(d_Gf_dV_D_S*value_sqrt_0));
              xgm = (Gf*value_sqrt_0);
            }

            d_help_dV_S_BP = ((-d_Em_dV_S_BP)+(2.0*(((xgm*eta_p)*d_inv_Gf2_dV_S_BP)+(((xgm*d_eta_p_dV_S_BP)+(d_xgm_dV_S_BP*eta_p))*inv_Gf2))));
            d_help_dV_GP_S = ((-d_Em_dV_GP_S)+(2.0*(((xgm*eta_p)*d_inv_Gf2_dV_GP_S)+(((xgm*d_eta_p_dV_GP_S)+(d_xgm_dV_GP_S*eta_p))*inv_Gf2))));
            d_help_dV_D_S = ((-d_Em_dV_D_S)+(2.0*(((xgm*eta_p)*d_inv_Gf2_dV_D_S)+(((xgm*d_eta_p_dV_D_S)+(d_xgm_dV_D_S*eta_p))*inv_Gf2))));
            help = ((1.0-Em)+(2.0*((xgm*eta_p)*inv_Gf2)));

            d_x_ds_dV_S_BP = (((help+(km*D_bar))*(((x_ds*km)*(d_d0_dV_S_BP+d_D_bar_dV_S_BP))+(((x_ds*d_km_dV_S_BP)+(d_x_ds_dV_S_BP*km))*(d0+D_bar)))-((x_ds*km)*(d0+D_bar))*(d_help_dV_S_BP+((km*d_D_bar_dV_S_BP)+(d_km_dV_S_BP*D_bar))))/(help+(km*D_bar))/(help+(km*D_bar)));
            d_x_ds_dV_GP_S = (((help+(km*D_bar))*(((x_ds*km)*(d_d0_dV_GP_S+d_D_bar_dV_GP_S))+(((x_ds*d_km_dV_GP_S)+(d_x_ds_dV_GP_S*km))*(d0+D_bar)))-((x_ds*km)*(d0+D_bar))*(d_help_dV_GP_S+((km*d_D_bar_dV_GP_S)+(d_km_dV_GP_S*D_bar))))/(help+(km*D_bar))/(help+(km*D_bar)));
            d_x_ds_dV_D_S = (((help+(km*D_bar))*(((x_ds*km)*(d_d0_dV_D_S+d_D_bar_dV_D_S))+(((x_ds*d_km_dV_D_S)+(d_x_ds_dV_D_S*km))*(d0+D_bar)))-((x_ds*km)*(d0+D_bar))*(d_help_dV_D_S+((km*d_D_bar_dV_D_S)+(d_km_dV_D_S*D_bar))))/(help+(km*D_bar))/(help+(km*D_bar)));
            x_ds = (((x_ds*km)*(d0+D_bar))/(help+(km*D_bar)));

            d_dps_dV_S_BP = (d_x_ds_dV_S_BP*phit1);
            d_dps_dV_GP_S = (d_x_ds_dV_GP_S*phit1);
            d_dps_dV_D_S = (d_x_ds_dV_D_S*phit1);
            dps = (x_ds*phit1);
          }
          {
            double value_sqrt_0 = sqrt(Pm);
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_sqm_dV_S_BP = (deriv_sqrt_0_d0*(d_Pm_dV_S_BP));
            d_sqm_dV_GP_S = (deriv_sqrt_0_d0*(d_Pm_dV_GP_S));
            d_sqm_dV_D_S = (deriv_sqrt_0_d0*(d_Pm_dV_D_S));
            sqm = value_sqrt_0;
          }

          d_alpha_dV_S_BP = (d_eta_p_dV_S_BP+(0.5*((sqm*((Gf*(-d_Em_dV_S_BP))+(d_Gf_dV_S_BP*(1.0-Em)))-(Gf*(1.0-Em))*d_sqm_dV_S_BP)/sqm/sqm)));
          d_alpha_dV_GP_S = (d_eta_p_dV_GP_S+(0.5*((sqm*((Gf*(-d_Em_dV_GP_S))+(d_Gf_dV_GP_S*(1.0-Em)))-(Gf*(1.0-Em))*d_sqm_dV_GP_S)/sqm/sqm)));
          d_alpha_dV_D_S = (d_eta_p_dV_D_S+(0.5*((sqm*((Gf*(-d_Em_dV_D_S))+(d_Gf_dV_D_S*(1.0-Em)))-(Gf*(1.0-Em))*d_sqm_dV_D_S)/sqm/sqm)));
          alpha = (eta_p+(0.5*((Gf*(1.0-Em))/sqm)));
        }

        d_qim_dV_S_BP = (phit1*(((xgm+(Gf*sqm))*((Gf2*d_Dm_dV_S_BP)+(d_Gf2_dV_S_BP*Dm))-(Gf2*Dm)*(d_xgm_dV_S_BP+((Gf*d_sqm_dV_S_BP)+(d_Gf_dV_S_BP*sqm))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
        d_qim_dV_GP_S = (phit1*(((xgm+(Gf*sqm))*((Gf2*d_Dm_dV_GP_S)+(d_Gf2_dV_GP_S*Dm))-(Gf2*Dm)*(d_xgm_dV_GP_S+((Gf*d_sqm_dV_GP_S)+(d_Gf_dV_GP_S*sqm))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
        d_qim_dV_D_S = (phit1*(((xgm+(Gf*sqm))*((Gf2*d_Dm_dV_D_S)+(d_Gf2_dV_D_S*Dm))-(Gf2*Dm)*(d_xgm_dV_D_S+((Gf*d_sqm_dV_D_S)+(d_Gf_dV_D_S*sqm))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
        qim = (phit1*((Gf2*Dm)/(xgm+(Gf*sqm))));

        d_qim1_dV_S_BP = (d_qim_dV_S_BP+(phit1*d_alpha_dV_S_BP));
        d_qim1_dV_GP_S = (d_qim_dV_GP_S+(phit1*d_alpha_dV_GP_S));
        d_qim1_dV_D_S = (d_qim_dV_D_S+(phit1*d_alpha_dV_D_S));
        qim1 = (qim+(phit1*alpha));

        d_qim1_1_dV_S_BP = (-d_qim1_dV_S_BP/qim1/qim1);
        d_qim1_1_dV_GP_S = (-d_qim1_dV_GP_S/qim1/qim1);
        d_qim1_1_dV_D_S = (-d_qim1_dV_D_S/qim1/qim1);
        qim1_1 = (1.0/qim1);

        d_qbm_dV_S_BP = (((sqm*d_Gf_dV_S_BP)+(d_sqm_dV_S_BP*Gf))*phit1);
        d_qbm_dV_GP_S = (((sqm*d_Gf_dV_GP_S)+(d_sqm_dV_GP_S*Gf))*phit1);
        d_qbm_dV_D_S = (((sqm*d_Gf_dV_D_S)+(d_sqm_dV_D_S*Gf))*phit1);
        qbm = ((sqm*Gf)*phit1);
        if ((RSG_i<0))
        {

          d_temp_dV_S_BP = (-(RSG_i*d_qim_dV_S_BP));
          d_temp_dV_GP_S = (-(RSG_i*d_qim_dV_GP_S));
          d_temp_dV_D_S = (-(RSG_i*d_qim_dV_D_S));
          temp = (1.0-(RSG_i*qim));
        }
        else
        {

          d_temp_dV_S_BP = (-(RSG_i*d_qim_dV_S_BP)/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
          d_temp_dV_GP_S = (-(RSG_i*d_qim_dV_GP_S)/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
          d_temp_dV_D_S = (-(RSG_i*d_qim_dV_D_S)/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
          temp = (1.0/(1.0+(RSG_i*qim)));
        }

        d_GR_dV_GP_S = (THER_i*(((rhob*temp)*d_qim_dV_GP_S)+((rhob*d_temp_dV_GP_S)*qim)));
        d_GR_dV_S_BP = (THER_i*(((rhob*temp)*d_qim_dV_S_BP)+(((rhob*d_temp_dV_S_BP)+(d_rhob_dV_S_BP*temp))*qim)));
        d_GR_dV_D_S = (THER_i*(((rhob*temp)*d_qim_dV_D_S)+(((rhob*d_temp_dV_D_S)+(d_rhob_dV_D_S*temp))*qim)));
        GR = (THER_i*((rhob*temp)*qim));

        d_qeff_dV_S_BP = (d_qbm_dV_S_BP+(eta_mu*d_qim_dV_S_BP));
        d_qeff_dV_GP_S = (d_qbm_dV_GP_S+(eta_mu*d_qim_dV_GP_S));
        d_qeff_dV_D_S = (d_qbm_dV_D_S+(eta_mu*d_qim_dV_D_S));
        qeff = (qbm+(eta_mu*qim));

        d_Eeffm_dV_S_BP = (E_eff0*d_qeff_dV_S_BP);
        d_Eeffm_dV_GP_S = (E_eff0*d_qeff_dV_GP_S);
        d_Eeffm_dV_D_S = (E_eff0*d_qeff_dV_D_S);
        Eeffm = (E_eff0*qeff);
        {
          double value_pow_0 = pow((Eeffm*MUE_i),THEMU_i);
          double  deriv_pow_0_d0 = (((Eeffm*MUE_i) == 0.0)?0.0:(value_pow_0*THEMU_i/(Eeffm*MUE_i)));

          d_Mutmp_dV_S_BP = ((deriv_pow_0_d0*((d_Eeffm_dV_S_BP*MUE_i)))+(CS_i*((((Pm+Dm)+1.0e-14)*d_Pm_dV_S_BP-Pm*(d_Pm_dV_S_BP+d_Dm_dV_S_BP))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
          d_Mutmp_dV_GP_S = ((deriv_pow_0_d0*((d_Eeffm_dV_GP_S*MUE_i)))+(CS_i*((((Pm+Dm)+1.0e-14)*d_Pm_dV_GP_S-Pm*(d_Pm_dV_GP_S+d_Dm_dV_GP_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
          d_Mutmp_dV_D_S = ((deriv_pow_0_d0*((d_Eeffm_dV_D_S*MUE_i)))+(CS_i*((((Pm+Dm)+1.0e-14)*d_Pm_dV_D_S-Pm*(d_Pm_dV_D_S+d_Dm_dV_D_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
          Mutmp = (value_pow_0+(CS_i*(Pm/((Pm+Dm)+1.0e-14))));
        }

        d_Gmob_dV_S_BP = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_S_BP)+((d_Mutmp_dV_S_BP+d_GR_dV_S_BP)*Rxcor));
        d_Gmob_dV_GP_S = ((d_Mutmp_dV_GP_S+d_GR_dV_GP_S)*Rxcor);
        d_Gmob_dV_D_S = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_D_S)+((d_Mutmp_dV_D_S+d_GR_dV_D_S)*Rxcor));
        Gmob = (((1.0+Mutmp)+GR)*Rxcor);

        d_r1_dV_S_BP = ((qim*d_qim1_1_dV_S_BP)+(d_qim_dV_S_BP*qim1_1));
        d_r1_dV_GP_S = ((qim*d_qim1_1_dV_GP_S)+(d_qim_dV_GP_S*qim1_1));
        d_r1_dV_D_S = ((qim*d_qim1_1_dV_D_S)+(d_qim_dV_D_S*qim1_1));
        r1 = (qim*qim1_1);

        d_r2_dV_S_BP = (phit1*((alpha*d_qim1_1_dV_S_BP)+(d_alpha_dV_S_BP*qim1_1)));
        d_r2_dV_GP_S = (phit1*((alpha*d_qim1_1_dV_GP_S)+(d_alpha_dV_GP_S*qim1_1)));
        d_r2_dV_D_S = (phit1*((alpha*d_qim1_1_dV_D_S)+(d_alpha_dV_D_S*qim1_1)));
        r2 = (phit1*(alpha*qim1_1));
        {
          double value_log_0 = log(((1.0+((Vds-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))));
          double  deriv_log_0_d0 = (1.0/((1.0+((Vds-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))));

          d_temp_dV_S_BP = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*((-d_dps_dV_S_BP)*inv_VP)-(1.0+((Vds-dps)*inv_VP))*((d_Vdse_dV_S_BP-d_dps_dV_S_BP)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
          d_temp_dV_GP_S = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*((-d_dps_dV_GP_S)*inv_VP)-(1.0+((Vds-dps)*inv_VP))*((d_Vdse_dV_GP_S-d_dps_dV_GP_S)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
          d_temp_dV_D_S = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*((d_Vds_dV_D_S-d_dps_dV_D_S)*inv_VP)-(1.0+((Vds-dps)*inv_VP))*((d_Vdse_dV_D_S-d_dps_dV_D_S)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
          temp = value_log_0;
        }
        {
          double value_log_0 = log((1.0+(Vdsx*inv_VP)));
          double  deriv_log_0_d0 = (1.0/(1.0+(Vdsx*inv_VP)));

          d_temp1_dV_GP_S = d_temp1_dV_S_BP =  0.0;
          d_temp1_dV_D_S = (deriv_log_0_d0*((d_Vdsx_dV_D_S*inv_VP)));
          temp1 = value_log_0;
        }

        d_dL_dV_S_BP = (ALP_i*d_temp_dV_S_BP);
        d_dL_dV_D_S = (ALP_i*d_temp_dV_D_S);
        d_dL_dV_GP_S = (ALP_i*d_temp_dV_GP_S);
        dL = (ALP_i*temp);

        d_GdL_dV_S_BP = (-(d_dL_dV_S_BP+((dL*d_dL_dV_S_BP)+(d_dL_dV_S_BP*dL)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
        d_GdL_dV_D_S = (-(d_dL_dV_D_S+((dL*d_dL_dV_D_S)+(d_dL_dV_D_S*dL)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
        d_GdL_dV_GP_S = (-(d_dL_dV_GP_S+((dL*d_dL_dV_GP_S)+(d_dL_dV_GP_S*dL)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
        GdL = (1.0/((1.0+dL)+(dL*dL)));

        d_dL1_dV_S_BP = ((d_dL_dV_S_BP+(ALP1_i*(((qim1_1*r1)*d_temp_dV_S_BP)+(((qim1_1*d_r1_dV_S_BP)+(d_qim1_1_dV_S_BP*r1))*temp))))+(ALP2_i*((((qbm*r2)*r2)*d_temp1_dV_S_BP)+((((qbm*r2)*d_r2_dV_S_BP)+(((qbm*d_r2_dV_S_BP)+(d_qbm_dV_S_BP*r2))*r2))*temp1))));
        d_dL1_dV_D_S = ((d_dL_dV_D_S+(ALP1_i*(((qim1_1*r1)*d_temp_dV_D_S)+(((qim1_1*d_r1_dV_D_S)+(d_qim1_1_dV_D_S*r1))*temp))))+(ALP2_i*((((qbm*r2)*r2)*d_temp1_dV_D_S)+((((qbm*r2)*d_r2_dV_D_S)+(((qbm*d_r2_dV_D_S)+(d_qbm_dV_D_S*r2))*r2))*temp1))));
        d_dL1_dV_GP_S = ((d_dL_dV_GP_S+(ALP1_i*(((qim1_1*r1)*d_temp_dV_GP_S)+(((qim1_1*d_r1_dV_GP_S)+(d_qim1_1_dV_GP_S*r1))*temp))))+(ALP2_i*((((qbm*r2)*r2)*d_temp1_dV_GP_S)+((((qbm*r2)*d_r2_dV_GP_S)+(((qbm*d_r2_dV_GP_S)+(d_qbm_dV_GP_S*r2))*r2))*temp1))));
        dL1 = ((dL+(ALP1_i*((qim1_1*r1)*temp)))+(ALP2_i*(((qbm*r2)*r2)*temp1)));

        d_FdL_dV_S_BP = ((((1.0+dL1)+(dL1*dL1))*d_GdL_dV_S_BP)+((d_dL1_dV_S_BP+((dL1*d_dL1_dV_S_BP)+(d_dL1_dV_S_BP*dL1)))*GdL));
        d_FdL_dV_D_S = ((((1.0+dL1)+(dL1*dL1))*d_GdL_dV_D_S)+((d_dL1_dV_D_S+((dL1*d_dL1_dV_D_S)+(d_dL1_dV_D_S*dL1)))*GdL));
        d_FdL_dV_GP_S = ((((1.0+dL1)+(dL1*dL1))*d_GdL_dV_GP_S)+((d_dL1_dV_GP_S+((dL1*d_dL1_dV_GP_S)+(d_dL1_dV_GP_S*dL1)))*GdL));
        FdL = (((1.0+dL1)+(dL1*dL1))*GdL);

        d_temp2_dV_S_BP = ((qim*d_xitsb_dV_S_BP)+(d_qim_dV_S_BP*xitsb));
        d_temp2_dV_GP_S = (d_qim_dV_GP_S*xitsb);
        d_temp2_dV_D_S = ((qim*d_xitsb_dV_D_S)+(d_qim_dV_D_S*xitsb));
        temp2 = (qim*xitsb);

        d_wsat_dV_S_BP = (100.0*(((100.0+temp2)*d_temp2_dV_S_BP-temp2*d_temp2_dV_S_BP)/(100.0+temp2)/(100.0+temp2)));
        d_wsat_dV_GP_S = (100.0*(((100.0+temp2)*d_temp2_dV_GP_S-temp2*d_temp2_dV_GP_S)/(100.0+temp2)/(100.0+temp2)));
        d_wsat_dV_D_S = (100.0*(((100.0+temp2)*d_temp2_dV_D_S-temp2*d_temp2_dV_D_S)/(100.0+temp2)/(100.0+temp2)));
        wsat = (100.0*(temp2/(100.0+temp2)));

        d_Gmob_dL_dV_S_BP = ((Gmob*d_GdL_dV_S_BP)+(d_Gmob_dV_S_BP*GdL));
        d_Gmob_dL_dV_GP_S = ((Gmob*d_GdL_dV_GP_S)+(d_Gmob_dV_GP_S*GdL));
        d_Gmob_dL_dV_D_S = ((Gmob*d_GdL_dV_D_S)+(d_Gmob_dV_D_S*GdL));
        Gmob_dL = (Gmob*GdL);
        if ((THESATG_i<0))
        {

          d_temp_dV_S_BP = (-1*(-(THESATG_i*d_wsat_dV_S_BP))/(1-(THESATG_i*wsat))/(1-(THESATG_i*wsat)));
          d_temp_dV_GP_S = (-1*(-(THESATG_i*d_wsat_dV_GP_S))/(1-(THESATG_i*wsat))/(1-(THESATG_i*wsat)));
          d_temp_dV_D_S = (-1*(-(THESATG_i*d_wsat_dV_D_S))/(1-(THESATG_i*wsat))/(1-(THESATG_i*wsat)));
          temp = (1/(1-(THESATG_i*wsat)));
        }
        else
        {

          d_temp_dV_S_BP = (THESATG_i*d_wsat_dV_S_BP);
          d_temp_dV_GP_S = (THESATG_i*d_wsat_dV_GP_S);
          d_temp_dV_D_S = (THESATG_i*d_wsat_dV_D_S);
          temp = (1+(THESATG_i*wsat));
        }

        d_thesat1_dV_S_BP = (THESAT_i*((Gmob_dL*d_temp_dV_S_BP-temp*d_Gmob_dL_dV_S_BP)/Gmob_dL/Gmob_dL));
        d_thesat1_dV_D_S = (THESAT_i*((Gmob_dL*d_temp_dV_D_S-temp*d_Gmob_dL_dV_D_S)/Gmob_dL/Gmob_dL));
        d_thesat1_dV_GP_S = (THESAT_i*((Gmob_dL*d_temp_dV_GP_S-temp*d_Gmob_dL_dV_GP_S)/Gmob_dL/Gmob_dL));
        thesat1 = (THESAT_i*(temp/Gmob_dL));

        d_zsat_dV_S_BP = ((((thesat1*thesat1)*dps)*d_dps_dV_S_BP)+((((thesat1*thesat1)*d_dps_dV_S_BP)+(((thesat1*d_thesat1_dV_S_BP)+(d_thesat1_dV_S_BP*thesat1))*dps))*dps));
        d_zsat_dV_D_S = ((((thesat1*thesat1)*dps)*d_dps_dV_D_S)+((((thesat1*thesat1)*d_dps_dV_D_S)+(((thesat1*d_thesat1_dV_D_S)+(d_thesat1_dV_D_S*thesat1))*dps))*dps));
        d_zsat_dV_GP_S = ((((thesat1*thesat1)*dps)*d_dps_dV_GP_S)+((((thesat1*thesat1)*d_dps_dV_GP_S)+(((thesat1*d_thesat1_dV_GP_S)+(d_thesat1_dV_GP_S*thesat1))*dps))*dps));
        zsat = (((thesat1*thesat1)*dps)*dps);
        if (((model_.CHNL_TYPE)==(-1)))
        {

          d_zsat_dV_S_BP = (((1.0+(thesat1*dps))*d_zsat_dV_S_BP-zsat*((thesat1*d_dps_dV_S_BP)+(d_thesat1_dV_S_BP*dps)))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
          d_zsat_dV_D_S = (((1.0+(thesat1*dps))*d_zsat_dV_D_S-zsat*((thesat1*d_dps_dV_D_S)+(d_thesat1_dV_D_S*dps)))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
          d_zsat_dV_GP_S = (((1.0+(thesat1*dps))*d_zsat_dV_GP_S-zsat*((thesat1*d_dps_dV_GP_S)+(d_thesat1_dV_GP_S*dps)))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
          zsat = (zsat/(1.0+(thesat1*dps)));
        }
        {
          double value_sqrt_0 = sqrt((1.0+(2.0*zsat)));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_Gvsat_dV_S_BP = (0.5*((Gmob_dL*(deriv_sqrt_0_d0*((2.0*d_zsat_dV_S_BP))))+(d_Gmob_dL_dV_S_BP*(1.0+value_sqrt_0))));
          d_Gvsat_dV_GP_S = (0.5*((Gmob_dL*(deriv_sqrt_0_d0*((2.0*d_zsat_dV_GP_S))))+(d_Gmob_dL_dV_GP_S*(1.0+value_sqrt_0))));
          d_Gvsat_dV_D_S = (0.5*((Gmob_dL*(deriv_sqrt_0_d0*((2.0*d_zsat_dV_D_S))))+(d_Gmob_dL_dV_D_S*(1.0+value_sqrt_0))));
          Gvsat = (0.5*(Gmob_dL*(1.0+value_sqrt_0)));
        }

        d_Gvsatinv_dV_S_BP = (-d_Gvsat_dV_S_BP/Gvsat/Gvsat);
        d_Gvsatinv_dV_GP_S = (-d_Gvsat_dV_GP_S/Gvsat/Gvsat);
        d_Gvsatinv_dV_D_S = (-d_Gvsat_dV_D_S/Gvsat/Gvsat);
        Gvsatinv = (1.0/Gvsat);

        d_Ids_dV_S_BP = (BET_i*((((FdL*qim1)*dps)*d_Gvsatinv_dV_S_BP)+((((FdL*qim1)*d_dps_dV_S_BP)+(((FdL*d_qim1_dV_S_BP)+(d_FdL_dV_S_BP*qim1))*dps))*Gvsatinv)));
        d_Ids_dV_D_S = (BET_i*((((FdL*qim1)*dps)*d_Gvsatinv_dV_D_S)+((((FdL*qim1)*d_dps_dV_D_S)+(((FdL*d_qim1_dV_D_S)+(d_FdL_dV_D_S*qim1))*dps))*Gvsatinv)));
        d_Ids_dV_GP_S = (BET_i*((((FdL*qim1)*dps)*d_Gvsatinv_dV_GP_S)+((((FdL*qim1)*d_dps_dV_GP_S)+(((FdL*d_qim1_dV_GP_S)+(d_FdL_dV_GP_S*qim1))*dps))*Gvsatinv)));
        Ids = (BET_i*(((FdL*qim1)*dps)*Gvsatinv));

        d_Voxm_dV_S_BP = (d_xgm_dV_S_BP*phit1);
        d_Voxm_dV_GP_S = (d_xgm_dV_GP_S*phit1);
        d_Voxm_dV_D_S = (d_xgm_dV_D_S*phit1);
        Voxm = (xgm*phit1);

        d_temp_dV_S_BP = ((Gmob_dL*d_Gvsatinv_dV_S_BP)+(d_Gmob_dL_dV_S_BP*Gvsatinv));
        d_temp_dV_GP_S = ((Gmob_dL*d_Gvsatinv_dV_GP_S)+(d_Gmob_dL_dV_GP_S*Gvsatinv));
        d_temp_dV_D_S = ((Gmob_dL*d_Gvsatinv_dV_D_S)+(d_Gmob_dL_dV_D_S*Gvsatinv));
        temp = (Gmob_dL*Gvsatinv);

        d_alpha1_dV_S_BP = ((alpha*(0.5*(((zsat*temp)*d_temp_dV_S_BP)+(((zsat*d_temp_dV_S_BP)+(d_zsat_dV_S_BP*temp))*temp))))+(d_alpha_dV_S_BP*(1.0+(0.5*((zsat*temp)*temp)))));
        d_alpha1_dV_GP_S = ((alpha*(0.5*(((zsat*temp)*d_temp_dV_GP_S)+(((zsat*d_temp_dV_GP_S)+(d_zsat_dV_GP_S*temp))*temp))))+(d_alpha_dV_GP_S*(1.0+(0.5*((zsat*temp)*temp)))));
        d_alpha1_dV_D_S = ((alpha*(0.5*(((zsat*temp)*d_temp_dV_D_S)+(((zsat*d_temp_dV_D_S)+(d_zsat_dV_D_S*temp))*temp))))+(d_alpha_dV_D_S*(1.0+(0.5*((zsat*temp)*temp)))));
        alpha1 = (alpha*(1.0+(0.5*((zsat*temp)*temp))));

        d_H_dV_S_BP = ((alpha1*((temp*d_qim1_dV_S_BP)+(d_temp_dV_S_BP*qim1))-(temp*qim1)*d_alpha1_dV_S_BP)/alpha1/alpha1);
        d_H_dV_D_S = ((alpha1*((temp*d_qim1_dV_D_S)+(d_temp_dV_D_S*qim1))-(temp*qim1)*d_alpha1_dV_D_S)/alpha1/alpha1);
        d_H_dV_GP_S = ((alpha1*((temp*d_qim1_dV_GP_S)+(d_temp_dV_GP_S*qim1))-(temp*qim1)*d_alpha1_dV_GP_S)/alpha1/alpha1);
        H = ((temp*qim1)/alpha1);
        if (((model_.SWIMPACT)!=0))
        {

          d_delVsat_dV_S_BP = (-(A3_i*d_dps_dV_S_BP));
          d_delVsat_dV_GP_S = (-(A3_i*d_dps_dV_GP_S));
          d_delVsat_dV_D_S = (d_Vds_dV_D_S-(A3_i*d_dps_dV_D_S));
          delVsat = (Vds-(A3_i*dps));
          if ((delVsat>0))
          {
            {
              double value_sqrt_0 = sqrt((phib+Vsbstar));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_temp2_dV_GP_S = (A2_i*(-(1.0+(A4_i*(value_sqrt_0-sqrt_phib)))*d_delVsat_dV_GP_S/(delVsat+1e-30)/(delVsat+1e-30)));
              d_temp2_dV_S_BP = (A2_i*(((delVsat+1e-30)*(A4_i*(deriv_sqrt_0_d0*(d_Vsbstar_dV_S_BP)))-(1.0+(A4_i*(value_sqrt_0-sqrt_phib)))*d_delVsat_dV_S_BP)/(delVsat+1e-30)/(delVsat+1e-30)));
              d_temp2_dV_D_S = (A2_i*(((delVsat+1e-30)*(A4_i*(deriv_sqrt_0_d0*(d_Vsbstar_dV_D_S)))-(1.0+(A4_i*(value_sqrt_0-sqrt_phib)))*d_delVsat_dV_D_S)/(delVsat+1e-30)/(delVsat+1e-30)));
              temp2 = (A2_i*((1.0+(A4_i*(value_sqrt_0-sqrt_phib)))/(delVsat+1e-30)));
            }
            if ((fabs((-temp2))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((-temp2));
                double  deriv_exp_0_d0 = value_exp_0;

                d_temp_dV_S_BP = (deriv_exp_0_d0*((-d_temp2_dV_S_BP)));
                d_temp_dV_GP_S = (deriv_exp_0_d0*((-d_temp2_dV_GP_S)));
                d_temp_dV_D_S = (deriv_exp_0_d0*((-d_temp2_dV_D_S)));
                temp = value_exp_0;
              }
            }
            else
            {
              if (((-temp2)<(-2.3025850929940458e+02)))
              {

                d_temp_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-(-temp2))*(0.5*((((-2.3025850929940458e+02)-(-temp2))*((-(-d_temp2_dV_S_BP))*3.3333333333333333e-01))+((-(-d_temp2_dV_S_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+((-(-d_temp2_dV_S_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
                d_temp_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-(-temp2))*(0.5*((((-2.3025850929940458e+02)-(-temp2))*((-(-d_temp2_dV_GP_S))*3.3333333333333333e-01))+((-(-d_temp2_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+((-(-d_temp2_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
                d_temp_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-(-temp2))*(0.5*((((-2.3025850929940458e+02)-(-temp2))*((-(-d_temp2_dV_D_S))*3.3333333333333333e-01))+((-(-d_temp2_dV_D_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+((-(-d_temp2_dV_D_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
                temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
              }
              else
              {

                d_temp_dV_S_BP = (1.0e100*((((-temp2)-2.3025850929940458e+02)*(0.5*((((-temp2)-2.3025850929940458e+02)*((-d_temp2_dV_S_BP)*3.3333333333333333e-01))+((-d_temp2_dV_S_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-d_temp2_dV_S_BP)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_temp_dV_GP_S = (1.0e100*((((-temp2)-2.3025850929940458e+02)*(0.5*((((-temp2)-2.3025850929940458e+02)*((-d_temp2_dV_GP_S)*3.3333333333333333e-01))+((-d_temp2_dV_GP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-d_temp2_dV_GP_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_temp_dV_D_S = (1.0e100*((((-temp2)-2.3025850929940458e+02)*(0.5*((((-temp2)-2.3025850929940458e+02)*((-d_temp2_dV_D_S)*3.3333333333333333e-01))+((-d_temp2_dV_D_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-d_temp2_dV_D_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                temp = (1.0e100*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }

            d_mavl_dV_S_BP = (A1_i*((delVsat*d_temp_dV_S_BP)+(d_delVsat_dV_S_BP*temp)));
            d_mavl_dV_GP_S = (A1_i*((delVsat*d_temp_dV_GP_S)+(d_delVsat_dV_GP_S*temp)));
            d_mavl_dV_D_S = (A1_i*((delVsat*d_temp_dV_D_S)+(d_delVsat_dV_D_S*temp)));
            mavl = (A1_i*(delVsat*temp));

            d_Iimpact_dV_S_BP = ((Ids*d_mavl_dV_S_BP)+(d_Ids_dV_S_BP*mavl));
            d_Iimpact_dV_D_S = ((Ids*d_mavl_dV_D_S)+(d_Ids_dV_D_S*mavl));
            d_Iimpact_dV_GP_S = ((Ids*d_mavl_dV_GP_S)+(d_Ids_dV_GP_S*mavl));
            Iimpact = (Ids*mavl);
          }
        }
      }
      if (((((((model_.SWIGATE)!=0)&&((IGOV_i>0)||(IGOVD_i>0)))||(((model_.SWGIDL)!=0)&&((AGIDL_i>0)||(AGIDLD_i>0))))||(CGOV_i>0))||(CGOVD_i>0)))
      {
        GOV = GOV_s;
        GOV2 = GOV2_s;
        xi_ov = xi_ov_s;
        inv_xi_ov = inv_xi_ov_s;
        x_mrg_ov = x_mrg_ov_s;
        inv_xg1 = inv_xg1_s;
        if ((fabs(xgs_ov)<=x_mrg_ov))
        {

          d_xs_ov_dV_D_S = d_xs_ov_dV_S_BP =  0.0;
          d_xs_ov_dV_GP_S = ((-d_xgs_ov_dV_GP_S)*inv_xi_ov);
          xs_ov = ((-xgs_ov)*inv_xi_ov);
        }
        else
        {
          if ((xgs_ov<(-x_mrg_ov)))
          {

            d_SP_OV_yg_dV_D_S =  0.0;
            d_SP_OV_yg_dV_GP_S = (-d_xgs_ov_dV_GP_S);
            SP_OV_yg = (-xgs_ov);

            d_SP_OV_z_dV_D_S =  0.0;
            d_SP_OV_z_dV_GP_S = ((x1*d_SP_OV_yg_dV_GP_S)*inv_xi_ov);
            SP_OV_z = ((x1*SP_OV_yg)*inv_xi_ov);
            {
              double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_SP_OV_eta_dV_D_S =  0.0;
              d_SP_OV_eta_dV_GP_S = (0.5*(d_SP_OV_z_dV_GP_S-(deriv_sqrt_0_d0*((((SP_OV_z-6.0)*d_SP_OV_z_dV_GP_S)+(d_SP_OV_z_dV_GP_S*(SP_OV_z-6.0)))))));
              SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
            }

            d_SP_OV_a_dV_D_S =  0.0;
            d_SP_OV_a_dV_GP_S = ((((SP_OV_yg-SP_OV_eta)*(d_SP_OV_yg_dV_GP_S-d_SP_OV_eta_dV_GP_S))+((d_SP_OV_yg_dV_GP_S-d_SP_OV_eta_dV_GP_S)*(SP_OV_yg-SP_OV_eta)))+(GOV2*d_SP_OV_eta_dV_GP_S));
            SP_OV_a = (((SP_OV_yg-SP_OV_eta)*(SP_OV_yg-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));

            d_SP_OV_c_dV_D_S =  0.0;
            d_SP_OV_c_dV_GP_S = (2.0*(d_SP_OV_yg_dV_GP_S-d_SP_OV_eta_dV_GP_S));
            SP_OV_c = ((2.0*(SP_OV_yg-SP_OV_eta))-GOV2);
            {
              double value_log_0 = log((SP_OV_a/GOV2));
              double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));

              d_SP_OV_tau_dV_D_S =  0.0;
              d_SP_OV_tau_dV_GP_S = ((deriv_log_0_d0*((d_SP_OV_a_dV_GP_S/GOV2)))-d_SP_OV_eta_dV_GP_S);
              SP_OV_tau = (value_log_0-SP_OV_eta);
            }

            d_nu_dV_D_S = d_nu_dV_S_BP =  0.0;
            d_nu_dV_GP_S = (d_SP_OV_a_dV_GP_S+d_SP_OV_c_dV_GP_S);
            nu = (SP_OV_a+SP_OV_c);

            d_mutau_dV_S_BP = ((nu*d_nu_dV_S_BP)+(d_nu_dV_S_BP*nu));
            d_mutau_dV_GP_S = (((nu*d_nu_dV_GP_S)+(d_nu_dV_GP_S*nu))+((SP_OV_tau*((0.5*((SP_OV_c*d_SP_OV_c_dV_GP_S)+(d_SP_OV_c_dV_GP_S*SP_OV_c)))-d_SP_OV_a_dV_GP_S))+(d_SP_OV_tau_dV_GP_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a))));
            d_mutau_dV_D_S = (((nu*d_nu_dV_D_S)+(d_nu_dV_D_S*nu))+((SP_OV_tau*((0.5*((SP_OV_c*d_SP_OV_c_dV_D_S)+(d_SP_OV_c_dV_D_S*SP_OV_c)))-d_SP_OV_a_dV_D_S))+(d_SP_OV_tau_dV_D_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a))));
            mutau = ((nu*nu)+(SP_OV_tau*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));

            d_SP_OV_y0_dV_S_BP = (((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*((SP_OV_a*d_nu_dV_S_BP)*SP_OV_tau)-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dV_S_BP+((((((mutau*d_nu_dV_S_BP-nu*d_mutau_dV_S_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))));
            d_SP_OV_y0_dV_D_S = (d_SP_OV_eta_dV_D_S+(((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*(((SP_OV_a*nu)*d_SP_OV_tau_dV_D_S)+(((SP_OV_a*d_nu_dV_D_S)+(d_SP_OV_a_dV_D_S*nu))*SP_OV_tau))-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dV_D_S+((((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((((SP_OV_c*d_SP_OV_c_dV_D_S)+(d_SP_OV_c_dV_D_S*SP_OV_c))*3.3333333333333333e-01)-d_SP_OV_a_dV_D_S))+((((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_D_S)+(((((nu/mutau)*SP_OV_tau)*d_SP_OV_tau_dV_D_S)+((((nu/mutau)*d_SP_OV_tau_dV_D_S)+(((mutau*d_nu_dV_D_S-nu*d_mutau_dV_D_S)/mutau/mutau)*SP_OV_tau))*SP_OV_tau))*SP_OV_c))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
            d_SP_OV_y0_dV_GP_S = (d_SP_OV_eta_dV_GP_S+(((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*(((SP_OV_a*nu)*d_SP_OV_tau_dV_GP_S)+(((SP_OV_a*d_nu_dV_GP_S)+(d_SP_OV_a_dV_GP_S*nu))*SP_OV_tau))-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dV_GP_S+((((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((((SP_OV_c*d_SP_OV_c_dV_GP_S)+(d_SP_OV_c_dV_GP_S*SP_OV_c))*3.3333333333333333e-01)-d_SP_OV_a_dV_GP_S))+((((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_GP_S)+(((((nu/mutau)*SP_OV_tau)*d_SP_OV_tau_dV_GP_S)+((((nu/mutau)*d_SP_OV_tau_dV_GP_S)+(((mutau*d_nu_dV_GP_S-nu*d_mutau_dV_GP_S)/mutau/mutau)*SP_OV_tau))*SP_OV_tau))*SP_OV_c))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
            SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*nu)*SP_OV_tau)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
            {
              double value_exp_0 = exp(SP_OV_y0);
              double  deriv_exp_0_d0 = value_exp_0;

              d_SP_OV_D0_dV_S_BP = (deriv_exp_0_d0*(d_SP_OV_y0_dV_S_BP));
              d_SP_OV_D0_dV_D_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_D_S));
              d_SP_OV_D0_dV_GP_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_GP_S));
              SP_OV_D0 = value_exp_0;
            }

            d_SP_OV_temp_dV_S_BP = (-d_SP_OV_y0_dV_S_BP);
            d_SP_OV_temp_dV_D_S = (d_SP_OV_yg_dV_D_S-d_SP_OV_y0_dV_D_S);
            d_SP_OV_temp_dV_GP_S = (d_SP_OV_yg_dV_GP_S-d_SP_OV_y0_dV_GP_S);
            SP_OV_temp = (SP_OV_yg-SP_OV_y0);

            d_SP_OV_p_dV_S_BP = ((2.0*d_SP_OV_temp_dV_S_BP)+(GOV2*d_SP_OV_D0_dV_S_BP));
            d_SP_OV_p_dV_D_S = ((2.0*d_SP_OV_temp_dV_D_S)+(GOV2*d_SP_OV_D0_dV_D_S));
            d_SP_OV_p_dV_GP_S = ((2.0*d_SP_OV_temp_dV_GP_S)+(GOV2*d_SP_OV_D0_dV_GP_S));
            SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));

            d_SP_OV_q_dV_S_BP = (((SP_OV_temp*d_SP_OV_temp_dV_S_BP)+(d_SP_OV_temp_dV_S_BP*SP_OV_temp))+(GOV2*(d_SP_OV_y0_dV_S_BP-d_SP_OV_D0_dV_S_BP)));
            d_SP_OV_q_dV_D_S = (((SP_OV_temp*d_SP_OV_temp_dV_D_S)+(d_SP_OV_temp_dV_D_S*SP_OV_temp))+(GOV2*(d_SP_OV_y0_dV_D_S-d_SP_OV_D0_dV_D_S)));
            d_SP_OV_q_dV_GP_S = (((SP_OV_temp*d_SP_OV_temp_dV_GP_S)+(d_SP_OV_temp_dV_GP_S*SP_OV_temp))+(GOV2*(d_SP_OV_y0_dV_GP_S-d_SP_OV_D0_dV_GP_S)));
            SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));

            d_SP_OV_xi_dV_S_BP = (-((GOV2*0.5)*d_SP_OV_D0_dV_S_BP));
            d_SP_OV_xi_dV_D_S = (-((GOV2*0.5)*d_SP_OV_D0_dV_D_S));
            d_SP_OV_xi_dV_GP_S = (-((GOV2*0.5)*d_SP_OV_D0_dV_GP_S));
            SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

            d_SP_OV_temp_dV_S_BP = (((SP_OV_p*d_SP_OV_p_dV_S_BP)+(d_SP_OV_p_dV_S_BP*SP_OV_p))-(4.0*((SP_OV_xi*d_SP_OV_q_dV_S_BP)+(d_SP_OV_xi_dV_S_BP*SP_OV_q))));
            d_SP_OV_temp_dV_D_S = (((SP_OV_p*d_SP_OV_p_dV_D_S)+(d_SP_OV_p_dV_D_S*SP_OV_p))-(4.0*((SP_OV_xi*d_SP_OV_q_dV_D_S)+(d_SP_OV_xi_dV_D_S*SP_OV_q))));
            d_SP_OV_temp_dV_GP_S = (((SP_OV_p*d_SP_OV_p_dV_GP_S)+(d_SP_OV_p_dV_GP_S*SP_OV_p))-(4.0*((SP_OV_xi*d_SP_OV_q_dV_GP_S)+(d_SP_OV_xi_dV_GP_S*SP_OV_q))));
            SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
            {
              double value_sqrt_0 = sqrt(SP_OV_temp);
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_SP_OV_w_dV_S_BP = (2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_S_BP-SP_OV_q*(d_SP_OV_p_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_S_BP))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0)));
              d_SP_OV_w_dV_D_S = (2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_D_S-SP_OV_q*(d_SP_OV_p_dV_D_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_D_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0)));
              d_SP_OV_w_dV_GP_S = (2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_GP_S-SP_OV_q*(d_SP_OV_p_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_GP_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0)));
              SP_OV_w = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
            }

            d_xs_ov_dV_S_BP = (-(d_SP_OV_y0_dV_S_BP+d_SP_OV_w_dV_S_BP));
            d_xs_ov_dV_D_S = (-(d_SP_OV_y0_dV_D_S+d_SP_OV_w_dV_D_S));
            d_xs_ov_dV_GP_S = (-(d_SP_OV_y0_dV_GP_S+d_SP_OV_w_dV_GP_S));
            xs_ov = (-(SP_OV_y0+SP_OV_w));
          }
          else
          {
            SP_OV_Afac = ((((xi_ov*x1)*inv_xg1)-1.0)*inv_xg1);

            d_SP_OV_xbar_dV_D_S =  0.0;
            d_SP_OV_xbar_dV_GP_S = (((xgs_ov*inv_xi_ov)*(SP_OV_Afac*d_xgs_ov_dV_GP_S))+((d_xgs_ov_dV_GP_S*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ov))));
            SP_OV_xbar = ((xgs_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ov)));
            if (((-SP_OV_xbar)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp((-SP_OV_xbar));
                double  deriv_exp_0_d0 = value_exp_0;

                d_SP_OV_temp_dV_D_S = d_SP_OV_temp_dV_S_BP =  0.0;
                d_SP_OV_temp_dV_GP_S = (deriv_exp_0_d0*((-d_SP_OV_xbar_dV_GP_S)));
                SP_OV_temp = value_exp_0;
              }
            }
            else
            {

              d_SP_OV_temp_dV_D_S = d_SP_OV_temp_dV_S_BP =  0.0;
              d_SP_OV_temp_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-d_SP_OV_xbar_dV_GP_S))*3.3333333333333333e-01))+((-(-d_SP_OV_xbar_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+((-(-d_SP_OV_xbar_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
              SP_OV_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
            }

            d_SP_OV_w_dV_S_BP = (-d_SP_OV_temp_dV_S_BP);
            d_SP_OV_w_dV_D_S = (-d_SP_OV_temp_dV_D_S);
            d_SP_OV_w_dV_GP_S = (-d_SP_OV_temp_dV_GP_S);
            SP_OV_w = (1.0-SP_OV_temp);
            {
              double value_sqrt_0 = sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_SP_OV_x0_dV_S_BP = (-(GOV*(deriv_sqrt_0_d0*((-d_SP_OV_w_dV_S_BP)))));
              d_SP_OV_x0_dV_D_S = (-(GOV*(deriv_sqrt_0_d0*((-d_SP_OV_w_dV_D_S)))));
              d_SP_OV_x0_dV_GP_S = (d_xgs_ov_dV_GP_S-(GOV*(deriv_sqrt_0_d0*((d_xgs_ov_dV_GP_S-d_SP_OV_w_dV_GP_S)))));
              SP_OV_x0 = ((xgs_ov+(GOV2*0.5))-(GOV*value_sqrt_0));
            }
            if (((-SP_OV_x0)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp((-SP_OV_x0));
                double  deriv_exp_0_d0 = value_exp_0;

                d_SP_OV_D0_dV_S_BP = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_S_BP)));
                d_SP_OV_D0_dV_D_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_D_S)));
                d_SP_OV_D0_dV_GP_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_GP_S)));
                SP_OV_D0 = value_exp_0;
              }
            }
            else
            {

              d_SP_OV_D0_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*((((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-d_SP_OV_x0_dV_S_BP))*3.3333333333333333e-01))+((-(-d_SP_OV_x0_dV_S_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+((-(-d_SP_OV_x0_dV_S_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
              d_SP_OV_D0_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*((((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-d_SP_OV_x0_dV_D_S))*3.3333333333333333e-01))+((-(-d_SP_OV_x0_dV_D_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+((-(-d_SP_OV_x0_dV_D_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
              d_SP_OV_D0_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*((((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-d_SP_OV_x0_dV_GP_S))*3.3333333333333333e-01))+((-(-d_SP_OV_x0_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+((-(-d_SP_OV_x0_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
              SP_OV_D0 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
            }

            d_SP_OV_p_dV_S_BP = ((2.0*(-d_SP_OV_x0_dV_S_BP))+(GOV2*(-d_SP_OV_D0_dV_S_BP)));
            d_SP_OV_p_dV_D_S = ((2.0*(-d_SP_OV_x0_dV_D_S))+(GOV2*(-d_SP_OV_D0_dV_D_S)));
            d_SP_OV_p_dV_GP_S = ((2.0*(d_xgs_ov_dV_GP_S-d_SP_OV_x0_dV_GP_S))+(GOV2*(-d_SP_OV_D0_dV_GP_S)));
            SP_OV_p = ((2.0*(xgs_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));

            d_SP_OV_q_dV_S_BP = ((((xgs_ov-SP_OV_x0)*(-d_SP_OV_x0_dV_S_BP))+((-d_SP_OV_x0_dV_S_BP)*(xgs_ov-SP_OV_x0)))-(GOV2*(d_SP_OV_x0_dV_S_BP+d_SP_OV_D0_dV_S_BP)));
            d_SP_OV_q_dV_D_S = ((((xgs_ov-SP_OV_x0)*(-d_SP_OV_x0_dV_D_S))+((-d_SP_OV_x0_dV_D_S)*(xgs_ov-SP_OV_x0)))-(GOV2*(d_SP_OV_x0_dV_D_S+d_SP_OV_D0_dV_D_S)));
            d_SP_OV_q_dV_GP_S = ((((xgs_ov-SP_OV_x0)*(d_xgs_ov_dV_GP_S-d_SP_OV_x0_dV_GP_S))+((d_xgs_ov_dV_GP_S-d_SP_OV_x0_dV_GP_S)*(xgs_ov-SP_OV_x0)))-(GOV2*(d_SP_OV_x0_dV_GP_S+d_SP_OV_D0_dV_GP_S)));
            SP_OV_q = (((xgs_ov-SP_OV_x0)*(xgs_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));

            d_SP_OV_xi_dV_S_BP = (-((GOV2*0.5)*d_SP_OV_D0_dV_S_BP));
            d_SP_OV_xi_dV_D_S = (-((GOV2*0.5)*d_SP_OV_D0_dV_D_S));
            d_SP_OV_xi_dV_GP_S = (-((GOV2*0.5)*d_SP_OV_D0_dV_GP_S));
            SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

            d_SP_OV_temp_dV_S_BP = (((SP_OV_p*d_SP_OV_p_dV_S_BP)+(d_SP_OV_p_dV_S_BP*SP_OV_p))-(4.0*((SP_OV_xi*d_SP_OV_q_dV_S_BP)+(d_SP_OV_xi_dV_S_BP*SP_OV_q))));
            d_SP_OV_temp_dV_D_S = (((SP_OV_p*d_SP_OV_p_dV_D_S)+(d_SP_OV_p_dV_D_S*SP_OV_p))-(4.0*((SP_OV_xi*d_SP_OV_q_dV_D_S)+(d_SP_OV_xi_dV_D_S*SP_OV_q))));
            d_SP_OV_temp_dV_GP_S = (((SP_OV_p*d_SP_OV_p_dV_GP_S)+(d_SP_OV_p_dV_GP_S*SP_OV_p))-(4.0*((SP_OV_xi*d_SP_OV_q_dV_GP_S)+(d_SP_OV_xi_dV_GP_S*SP_OV_q))));
            SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
            {
              double value_sqrt_0 = sqrt(SP_OV_temp);
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_SP_OV_u_dV_S_BP = (2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_S_BP-SP_OV_q*(d_SP_OV_p_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_S_BP))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0)));
              d_SP_OV_u_dV_D_S = (2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_D_S-SP_OV_q*(d_SP_OV_p_dV_D_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_D_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0)));
              d_SP_OV_u_dV_GP_S = (2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_GP_S-SP_OV_q*(d_SP_OV_p_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_GP_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0)));
              SP_OV_u = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
            }

            d_xs_ov_dV_S_BP = (d_SP_OV_x0_dV_S_BP+d_SP_OV_u_dV_S_BP);
            d_xs_ov_dV_D_S = (d_SP_OV_x0_dV_D_S+d_SP_OV_u_dV_D_S);
            d_xs_ov_dV_GP_S = (d_SP_OV_x0_dV_GP_S+d_SP_OV_u_dV_GP_S);
            xs_ov = (SP_OV_x0+SP_OV_u);
          }

          d_xs_ov_dV_GP_S = (-d_xs_ov_dV_GP_S);
          d_xs_ov_dV_S_BP = (-d_xs_ov_dV_S_BP);
          d_xs_ov_dV_D_S = (-d_xs_ov_dV_D_S);
          xs_ov = (-xs_ov);
        }
        GOV = GOV_d;
        GOV2 = GOV2_d;
        xi_ov = xi_ov_d;
        inv_xi_ov = inv_xi_ov_d;
        x_mrg_ov = x_mrg_ov_d;
        inv_xg1 = inv_xg1_d;
        if ((fabs(xgd_ov)<=x_mrg_ov))
        {

          d_xd_ov_dV_S_BP =  0.0;
          d_xd_ov_dV_D_S = ((-d_xgd_ov_dV_D_S)*inv_xi_ov);
          d_xd_ov_dV_GP_S = ((-d_xgd_ov_dV_GP_S)*inv_xi_ov);
          xd_ov = ((-xgd_ov)*inv_xi_ov);
        }
        else
        {
          if ((xgd_ov<(-x_mrg_ov)))
          {

            d_SP_OV_yg_dV_D_S = (-d_xgd_ov_dV_D_S);
            d_SP_OV_yg_dV_GP_S = (-d_xgd_ov_dV_GP_S);
            SP_OV_yg = (-xgd_ov);

            d_SP_OV_z_dV_GP_S = ((x1*d_SP_OV_yg_dV_GP_S)*inv_xi_ov);
            d_SP_OV_z_dV_D_S = ((x1*d_SP_OV_yg_dV_D_S)*inv_xi_ov);
            SP_OV_z = ((x1*SP_OV_yg)*inv_xi_ov);
            {
              double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_SP_OV_eta_dV_GP_S = (0.5*(d_SP_OV_z_dV_GP_S-(deriv_sqrt_0_d0*((((SP_OV_z-6.0)*d_SP_OV_z_dV_GP_S)+(d_SP_OV_z_dV_GP_S*(SP_OV_z-6.0)))))));
              d_SP_OV_eta_dV_D_S = (0.5*(d_SP_OV_z_dV_D_S-(deriv_sqrt_0_d0*((((SP_OV_z-6.0)*d_SP_OV_z_dV_D_S)+(d_SP_OV_z_dV_D_S*(SP_OV_z-6.0)))))));
              SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
            }

            d_SP_OV_a_dV_GP_S = ((((SP_OV_yg-SP_OV_eta)*(d_SP_OV_yg_dV_GP_S-d_SP_OV_eta_dV_GP_S))+((d_SP_OV_yg_dV_GP_S-d_SP_OV_eta_dV_GP_S)*(SP_OV_yg-SP_OV_eta)))+(GOV2*d_SP_OV_eta_dV_GP_S));
            d_SP_OV_a_dV_D_S = ((((SP_OV_yg-SP_OV_eta)*(d_SP_OV_yg_dV_D_S-d_SP_OV_eta_dV_D_S))+((d_SP_OV_yg_dV_D_S-d_SP_OV_eta_dV_D_S)*(SP_OV_yg-SP_OV_eta)))+(GOV2*d_SP_OV_eta_dV_D_S));
            SP_OV_a = (((SP_OV_yg-SP_OV_eta)*(SP_OV_yg-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));

            d_SP_OV_c_dV_GP_S = (2.0*(d_SP_OV_yg_dV_GP_S-d_SP_OV_eta_dV_GP_S));
            d_SP_OV_c_dV_D_S = (2.0*(d_SP_OV_yg_dV_D_S-d_SP_OV_eta_dV_D_S));
            SP_OV_c = ((2.0*(SP_OV_yg-SP_OV_eta))-GOV2);
            {
              double value_log_0 = log((SP_OV_a/GOV2));
              double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));

              d_SP_OV_tau_dV_GP_S = ((deriv_log_0_d0*((d_SP_OV_a_dV_GP_S/GOV2)))-d_SP_OV_eta_dV_GP_S);
              d_SP_OV_tau_dV_D_S = ((deriv_log_0_d0*((d_SP_OV_a_dV_D_S/GOV2)))-d_SP_OV_eta_dV_D_S);
              SP_OV_tau = (value_log_0-SP_OV_eta);
            }

            d_nu_dV_S_BP =  0.0;
            d_nu_dV_GP_S = (d_SP_OV_a_dV_GP_S+d_SP_OV_c_dV_GP_S);
            d_nu_dV_D_S = (d_SP_OV_a_dV_D_S+d_SP_OV_c_dV_D_S);
            nu = (SP_OV_a+SP_OV_c);

            d_mutau_dV_S_BP = ((nu*d_nu_dV_S_BP)+(d_nu_dV_S_BP*nu));
            d_mutau_dV_GP_S = (((nu*d_nu_dV_GP_S)+(d_nu_dV_GP_S*nu))+((SP_OV_tau*((0.5*((SP_OV_c*d_SP_OV_c_dV_GP_S)+(d_SP_OV_c_dV_GP_S*SP_OV_c)))-d_SP_OV_a_dV_GP_S))+(d_SP_OV_tau_dV_GP_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a))));
            d_mutau_dV_D_S = (((nu*d_nu_dV_D_S)+(d_nu_dV_D_S*nu))+((SP_OV_tau*((0.5*((SP_OV_c*d_SP_OV_c_dV_D_S)+(d_SP_OV_c_dV_D_S*SP_OV_c)))-d_SP_OV_a_dV_D_S))+(d_SP_OV_tau_dV_D_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a))));
            mutau = ((nu*nu)+(SP_OV_tau*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));

            d_SP_OV_y0_dV_S_BP = (((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*((SP_OV_a*d_nu_dV_S_BP)*SP_OV_tau)-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dV_S_BP+((((((mutau*d_nu_dV_S_BP-nu*d_mutau_dV_S_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))));
            d_SP_OV_y0_dV_GP_S = (d_SP_OV_eta_dV_GP_S+(((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*(((SP_OV_a*nu)*d_SP_OV_tau_dV_GP_S)+(((SP_OV_a*d_nu_dV_GP_S)+(d_SP_OV_a_dV_GP_S*nu))*SP_OV_tau))-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dV_GP_S+((((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((((SP_OV_c*d_SP_OV_c_dV_GP_S)+(d_SP_OV_c_dV_GP_S*SP_OV_c))*3.3333333333333333e-01)-d_SP_OV_a_dV_GP_S))+((((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_GP_S)+(((((nu/mutau)*SP_OV_tau)*d_SP_OV_tau_dV_GP_S)+((((nu/mutau)*d_SP_OV_tau_dV_GP_S)+(((mutau*d_nu_dV_GP_S-nu*d_mutau_dV_GP_S)/mutau/mutau)*SP_OV_tau))*SP_OV_tau))*SP_OV_c))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
            d_SP_OV_y0_dV_D_S = (d_SP_OV_eta_dV_D_S+(((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*(((SP_OV_a*nu)*d_SP_OV_tau_dV_D_S)+(((SP_OV_a*d_nu_dV_D_S)+(d_SP_OV_a_dV_D_S*nu))*SP_OV_tau))-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dV_D_S+((((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((((SP_OV_c*d_SP_OV_c_dV_D_S)+(d_SP_OV_c_dV_D_S*SP_OV_c))*3.3333333333333333e-01)-d_SP_OV_a_dV_D_S))+((((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_D_S)+(((((nu/mutau)*SP_OV_tau)*d_SP_OV_tau_dV_D_S)+((((nu/mutau)*d_SP_OV_tau_dV_D_S)+(((mutau*d_nu_dV_D_S-nu*d_mutau_dV_D_S)/mutau/mutau)*SP_OV_tau))*SP_OV_tau))*SP_OV_c))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
            SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*nu)*SP_OV_tau)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
            {
              double value_exp_0 = exp(SP_OV_y0);
              double  deriv_exp_0_d0 = value_exp_0;

              d_SP_OV_D0_dV_S_BP = (deriv_exp_0_d0*(d_SP_OV_y0_dV_S_BP));
              d_SP_OV_D0_dV_D_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_D_S));
              d_SP_OV_D0_dV_GP_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_GP_S));
              SP_OV_D0 = value_exp_0;
            }

            d_SP_OV_temp_dV_S_BP = (-d_SP_OV_y0_dV_S_BP);
            d_SP_OV_temp_dV_GP_S = (d_SP_OV_yg_dV_GP_S-d_SP_OV_y0_dV_GP_S);
            d_SP_OV_temp_dV_D_S = (d_SP_OV_yg_dV_D_S-d_SP_OV_y0_dV_D_S);
            SP_OV_temp = (SP_OV_yg-SP_OV_y0);

            d_SP_OV_p_dV_S_BP = ((2.0*d_SP_OV_temp_dV_S_BP)+(GOV2*d_SP_OV_D0_dV_S_BP));
            d_SP_OV_p_dV_D_S = ((2.0*d_SP_OV_temp_dV_D_S)+(GOV2*d_SP_OV_D0_dV_D_S));
            d_SP_OV_p_dV_GP_S = ((2.0*d_SP_OV_temp_dV_GP_S)+(GOV2*d_SP_OV_D0_dV_GP_S));
            SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));

            d_SP_OV_q_dV_S_BP = (((SP_OV_temp*d_SP_OV_temp_dV_S_BP)+(d_SP_OV_temp_dV_S_BP*SP_OV_temp))+(GOV2*(d_SP_OV_y0_dV_S_BP-d_SP_OV_D0_dV_S_BP)));
            d_SP_OV_q_dV_D_S = (((SP_OV_temp*d_SP_OV_temp_dV_D_S)+(d_SP_OV_temp_dV_D_S*SP_OV_temp))+(GOV2*(d_SP_OV_y0_dV_D_S-d_SP_OV_D0_dV_D_S)));
            d_SP_OV_q_dV_GP_S = (((SP_OV_temp*d_SP_OV_temp_dV_GP_S)+(d_SP_OV_temp_dV_GP_S*SP_OV_temp))+(GOV2*(d_SP_OV_y0_dV_GP_S-d_SP_OV_D0_dV_GP_S)));
            SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));

            d_SP_OV_xi_dV_S_BP = (-((GOV2*0.5)*d_SP_OV_D0_dV_S_BP));
            d_SP_OV_xi_dV_D_S = (-((GOV2*0.5)*d_SP_OV_D0_dV_D_S));
            d_SP_OV_xi_dV_GP_S = (-((GOV2*0.5)*d_SP_OV_D0_dV_GP_S));
            SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

            d_SP_OV_temp_dV_S_BP = (((SP_OV_p*d_SP_OV_p_dV_S_BP)+(d_SP_OV_p_dV_S_BP*SP_OV_p))-(4.0*((SP_OV_xi*d_SP_OV_q_dV_S_BP)+(d_SP_OV_xi_dV_S_BP*SP_OV_q))));
            d_SP_OV_temp_dV_D_S = (((SP_OV_p*d_SP_OV_p_dV_D_S)+(d_SP_OV_p_dV_D_S*SP_OV_p))-(4.0*((SP_OV_xi*d_SP_OV_q_dV_D_S)+(d_SP_OV_xi_dV_D_S*SP_OV_q))));
            d_SP_OV_temp_dV_GP_S = (((SP_OV_p*d_SP_OV_p_dV_GP_S)+(d_SP_OV_p_dV_GP_S*SP_OV_p))-(4.0*((SP_OV_xi*d_SP_OV_q_dV_GP_S)+(d_SP_OV_xi_dV_GP_S*SP_OV_q))));
            SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
            {
              double value_sqrt_0 = sqrt(SP_OV_temp);
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_SP_OV_w_dV_S_BP = (2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_S_BP-SP_OV_q*(d_SP_OV_p_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_S_BP))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0)));
              d_SP_OV_w_dV_D_S = (2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_D_S-SP_OV_q*(d_SP_OV_p_dV_D_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_D_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0)));
              d_SP_OV_w_dV_GP_S = (2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_GP_S-SP_OV_q*(d_SP_OV_p_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_GP_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0)));
              SP_OV_w = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
            }

            d_xd_ov_dV_S_BP = (-(d_SP_OV_y0_dV_S_BP+d_SP_OV_w_dV_S_BP));
            d_xd_ov_dV_D_S = (-(d_SP_OV_y0_dV_D_S+d_SP_OV_w_dV_D_S));
            d_xd_ov_dV_GP_S = (-(d_SP_OV_y0_dV_GP_S+d_SP_OV_w_dV_GP_S));
            xd_ov = (-(SP_OV_y0+SP_OV_w));
          }
          else
          {
            SP_OV_Afac = ((((xi_ov*x1)*inv_xg1)-1.0)*inv_xg1);

            d_SP_OV_xbar_dV_D_S = (((xgd_ov*inv_xi_ov)*(SP_OV_Afac*d_xgd_ov_dV_D_S))+((d_xgd_ov_dV_D_S*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ov))));
            d_SP_OV_xbar_dV_GP_S = (((xgd_ov*inv_xi_ov)*(SP_OV_Afac*d_xgd_ov_dV_GP_S))+((d_xgd_ov_dV_GP_S*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ov))));
            SP_OV_xbar = ((xgd_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ov)));
            if (((-SP_OV_xbar)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp((-SP_OV_xbar));
                double  deriv_exp_0_d0 = value_exp_0;

                d_SP_OV_temp_dV_S_BP =  0.0;
                d_SP_OV_temp_dV_GP_S = (deriv_exp_0_d0*((-d_SP_OV_xbar_dV_GP_S)));
                d_SP_OV_temp_dV_D_S = (deriv_exp_0_d0*((-d_SP_OV_xbar_dV_D_S)));
                SP_OV_temp = value_exp_0;
              }
            }
            else
            {

              d_SP_OV_temp_dV_S_BP =  0.0;
              d_SP_OV_temp_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-d_SP_OV_xbar_dV_GP_S))*3.3333333333333333e-01))+((-(-d_SP_OV_xbar_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+((-(-d_SP_OV_xbar_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
              d_SP_OV_temp_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-d_SP_OV_xbar_dV_D_S))*3.3333333333333333e-01))+((-(-d_SP_OV_xbar_dV_D_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+((-(-d_SP_OV_xbar_dV_D_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
              SP_OV_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
            }

            d_SP_OV_w_dV_S_BP = (-d_SP_OV_temp_dV_S_BP);
            d_SP_OV_w_dV_D_S = (-d_SP_OV_temp_dV_D_S);
            d_SP_OV_w_dV_GP_S = (-d_SP_OV_temp_dV_GP_S);
            SP_OV_w = (1.0-SP_OV_temp);
            {
              double value_sqrt_0 = sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_SP_OV_x0_dV_S_BP = (-(GOV*(deriv_sqrt_0_d0*((-d_SP_OV_w_dV_S_BP)))));
              d_SP_OV_x0_dV_D_S = (d_xgd_ov_dV_D_S-(GOV*(deriv_sqrt_0_d0*((d_xgd_ov_dV_D_S-d_SP_OV_w_dV_D_S)))));
              d_SP_OV_x0_dV_GP_S = (d_xgd_ov_dV_GP_S-(GOV*(deriv_sqrt_0_d0*((d_xgd_ov_dV_GP_S-d_SP_OV_w_dV_GP_S)))));
              SP_OV_x0 = ((xgd_ov+(GOV2*0.5))-(GOV*value_sqrt_0));
            }
            if (((-SP_OV_x0)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp((-SP_OV_x0));
                double  deriv_exp_0_d0 = value_exp_0;

                d_SP_OV_D0_dV_S_BP = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_S_BP)));
                d_SP_OV_D0_dV_D_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_D_S)));
                d_SP_OV_D0_dV_GP_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_GP_S)));
                SP_OV_D0 = value_exp_0;
              }
            }
            else
            {

              d_SP_OV_D0_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*((((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-d_SP_OV_x0_dV_S_BP))*3.3333333333333333e-01))+((-(-d_SP_OV_x0_dV_S_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+((-(-d_SP_OV_x0_dV_S_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
              d_SP_OV_D0_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*((((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-d_SP_OV_x0_dV_D_S))*3.3333333333333333e-01))+((-(-d_SP_OV_x0_dV_D_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+((-(-d_SP_OV_x0_dV_D_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
              d_SP_OV_D0_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*((((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-d_SP_OV_x0_dV_GP_S))*3.3333333333333333e-01))+((-(-d_SP_OV_x0_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+((-(-d_SP_OV_x0_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
              SP_OV_D0 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
            }

            d_SP_OV_p_dV_S_BP = ((2.0*(-d_SP_OV_x0_dV_S_BP))+(GOV2*(-d_SP_OV_D0_dV_S_BP)));
            d_SP_OV_p_dV_D_S = ((2.0*(d_xgd_ov_dV_D_S-d_SP_OV_x0_dV_D_S))+(GOV2*(-d_SP_OV_D0_dV_D_S)));
            d_SP_OV_p_dV_GP_S = ((2.0*(d_xgd_ov_dV_GP_S-d_SP_OV_x0_dV_GP_S))+(GOV2*(-d_SP_OV_D0_dV_GP_S)));
            SP_OV_p = ((2.0*(xgd_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));

            d_SP_OV_q_dV_S_BP = ((((xgd_ov-SP_OV_x0)*(-d_SP_OV_x0_dV_S_BP))+((-d_SP_OV_x0_dV_S_BP)*(xgd_ov-SP_OV_x0)))-(GOV2*(d_SP_OV_x0_dV_S_BP+d_SP_OV_D0_dV_S_BP)));
            d_SP_OV_q_dV_D_S = ((((xgd_ov-SP_OV_x0)*(d_xgd_ov_dV_D_S-d_SP_OV_x0_dV_D_S))+((d_xgd_ov_dV_D_S-d_SP_OV_x0_dV_D_S)*(xgd_ov-SP_OV_x0)))-(GOV2*(d_SP_OV_x0_dV_D_S+d_SP_OV_D0_dV_D_S)));
            d_SP_OV_q_dV_GP_S = ((((xgd_ov-SP_OV_x0)*(d_xgd_ov_dV_GP_S-d_SP_OV_x0_dV_GP_S))+((d_xgd_ov_dV_GP_S-d_SP_OV_x0_dV_GP_S)*(xgd_ov-SP_OV_x0)))-(GOV2*(d_SP_OV_x0_dV_GP_S+d_SP_OV_D0_dV_GP_S)));
            SP_OV_q = (((xgd_ov-SP_OV_x0)*(xgd_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));

            d_SP_OV_xi_dV_S_BP = (-((GOV2*0.5)*d_SP_OV_D0_dV_S_BP));
            d_SP_OV_xi_dV_D_S = (-((GOV2*0.5)*d_SP_OV_D0_dV_D_S));
            d_SP_OV_xi_dV_GP_S = (-((GOV2*0.5)*d_SP_OV_D0_dV_GP_S));
            SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

            d_SP_OV_temp_dV_S_BP = (((SP_OV_p*d_SP_OV_p_dV_S_BP)+(d_SP_OV_p_dV_S_BP*SP_OV_p))-(4.0*((SP_OV_xi*d_SP_OV_q_dV_S_BP)+(d_SP_OV_xi_dV_S_BP*SP_OV_q))));
            d_SP_OV_temp_dV_D_S = (((SP_OV_p*d_SP_OV_p_dV_D_S)+(d_SP_OV_p_dV_D_S*SP_OV_p))-(4.0*((SP_OV_xi*d_SP_OV_q_dV_D_S)+(d_SP_OV_xi_dV_D_S*SP_OV_q))));
            d_SP_OV_temp_dV_GP_S = (((SP_OV_p*d_SP_OV_p_dV_GP_S)+(d_SP_OV_p_dV_GP_S*SP_OV_p))-(4.0*((SP_OV_xi*d_SP_OV_q_dV_GP_S)+(d_SP_OV_xi_dV_GP_S*SP_OV_q))));
            SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
            {
              double value_sqrt_0 = sqrt(SP_OV_temp);
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_SP_OV_u_dV_S_BP = (2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_S_BP-SP_OV_q*(d_SP_OV_p_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_S_BP))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0)));
              d_SP_OV_u_dV_D_S = (2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_D_S-SP_OV_q*(d_SP_OV_p_dV_D_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_D_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0)));
              d_SP_OV_u_dV_GP_S = (2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_GP_S-SP_OV_q*(d_SP_OV_p_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_GP_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0)));
              SP_OV_u = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
            }

            d_xd_ov_dV_S_BP = (d_SP_OV_x0_dV_S_BP+d_SP_OV_u_dV_S_BP);
            d_xd_ov_dV_D_S = (d_SP_OV_x0_dV_D_S+d_SP_OV_u_dV_D_S);
            d_xd_ov_dV_GP_S = (d_SP_OV_x0_dV_GP_S+d_SP_OV_u_dV_GP_S);
            xd_ov = (SP_OV_x0+SP_OV_u);
          }

          d_xd_ov_dV_D_S = (-d_xd_ov_dV_D_S);
          d_xd_ov_dV_GP_S = (-d_xd_ov_dV_GP_S);
          d_xd_ov_dV_S_BP = (-d_xd_ov_dV_S_BP);
          xd_ov = (-xd_ov);
        }

        d_Vovs_dV_S_BP = ((-(model_.phit))*d_xs_ov_dV_S_BP);
        d_Vovs_dV_D_S = ((-(model_.phit))*d_xs_ov_dV_D_S);
        d_Vovs_dV_GP_S = ((-(model_.phit))*(d_xgs_ov_dV_GP_S+d_xs_ov_dV_GP_S));
        Vovs = ((-(model_.phit))*(xgs_ov+xs_ov));

        d_Vovd_dV_S_BP = ((-(model_.phit))*d_xd_ov_dV_S_BP);
        d_Vovd_dV_D_S = ((-(model_.phit))*(d_xgd_ov_dV_D_S+d_xd_ov_dV_D_S));
        d_Vovd_dV_GP_S = ((-(model_.phit))*(d_xgd_ov_dV_GP_S+d_xd_ov_dV_GP_S));
        Vovd = ((-(model_.phit))*(xgd_ov+xd_ov));
      }

      d_Igsov_dV_GP_S = d_Igsov_dV_D_S = d_Igsov_dV_S_BP =  0.0;
      Igsov = 0.0;

      d_Igdov_dV_GP_S = d_Igdov_dV_D_S = d_Igdov_dV_S_BP =  0.0;
      Igdov = 0.0;

      d_Igc_dV_GP_S = d_Igc_dV_D_S = d_Igc_dV_S_BP =  0.0;
      Igc = 0.0;

      d_Igb_dV_GP_S = d_Igb_dV_D_S = d_Igb_dV_S_BP =  0.0;
      Igb = 0.0;

      d_Igcs_dV_GP_S = d_Igcs_dV_D_S = d_Igcs_dV_S_BP =  0.0;
      Igcs = 0.0;

      d_Igcd_dV_GP_S = d_Igcd_dV_D_S = d_Igcd_dV_S_BP =  0.0;
      Igcd = 0.0;
      if (((model_.SWIGATE)!=0))
      {
        if ((IGOV_i>0))
        {

          d_arg2mina_dV_S_BP = d_Vovs_dV_S_BP;
          d_arg2mina_dV_D_S = d_Vovs_dV_D_S;
          d_arg2mina_dV_GP_S = d_Vovs_dV_GP_S;
          arg2mina = (Vovs+Dov);
          {
            double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_psi_t_dV_S_BP = (0.5*((+d_arg2mina_dV_S_BP)-(deriv_sqrt_0_d0*((((-arg2mina)*(-d_arg2mina_dV_S_BP))+((-d_arg2mina_dV_S_BP)*(-arg2mina)))))));
            d_psi_t_dV_D_S = (0.5*((+d_arg2mina_dV_D_S)-(deriv_sqrt_0_d0*((((-arg2mina)*(-d_arg2mina_dV_D_S))+((-d_arg2mina_dV_D_S)*(-arg2mina)))))));
            d_psi_t_dV_GP_S = (0.5*((+d_arg2mina_dV_GP_S)-(deriv_sqrt_0_d0*((((-arg2mina)*(-d_arg2mina_dV_GP_S))+((-d_arg2mina_dV_GP_S)*(-arg2mina)))))));
            psi_t = (0.5*((+arg2mina)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt(((Vovs*Vovs)+1.0e-6));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_zg_dV_S_BP = ((deriv_sqrt_0_d0*(((Vovs*d_Vovs_dV_S_BP)+(d_Vovs_dV_S_BP*Vovs))))*inv_CHIB);
            d_zg_dV_D_S = ((deriv_sqrt_0_d0*(((Vovs*d_Vovs_dV_D_S)+(d_Vovs_dV_D_S*Vovs))))*inv_CHIB);
            d_zg_dV_GP_S = ((deriv_sqrt_0_d0*(((Vovs*d_Vovs_dV_GP_S)+(d_Vovs_dV_GP_S*Vovs))))*inv_CHIB);
            zg = (value_sqrt_0*inv_CHIB);
          }
          if ((GC3_i<0))
          {
            {
              double value_sqrt_0 = sqrt((((zg-GCQ)*(zg-GCQ))+1.0e-6));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_zg_dV_S_BP = (0.5*(d_zg_dV_S_BP-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_S_BP)+(d_zg_dV_S_BP*(zg-GCQ)))))));
              d_zg_dV_D_S = (0.5*(d_zg_dV_D_S-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_D_S)+(d_zg_dV_D_S*(zg-GCQ)))))));
              d_zg_dV_GP_S = (0.5*(d_zg_dV_GP_S-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_GP_S)+(d_zg_dV_GP_S*(zg-GCQ)))))));
              zg = (0.5*((zg+GCQ)-value_sqrt_0));
            }
          }

          d_arg1_dV_GP_S = (d_xs_ov_dV_GP_S+(d_psi_t_dV_GP_S*(model_.inv_phit)));
          d_arg1_dV_S_BP = (d_xs_ov_dV_S_BP+(d_psi_t_dV_S_BP*(model_.inv_phit)));
          d_arg1_dV_D_S = (d_xs_ov_dV_D_S+(d_psi_t_dV_D_S*(model_.inv_phit)));
          arg1 = ((3.0+xs_ov)+(psi_t*(model_.inv_phit)));
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp(arg1);
              double  deriv_exp_0_d0 = value_exp_0;

              d_Dsi_dV_GP_S = (deriv_exp_0_d0*(d_arg1_dV_GP_S));
              d_Dsi_dV_S_BP = (deriv_exp_0_d0*(d_arg1_dV_S_BP));
              d_Dsi_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
              Dsi = value_exp_0;
            }
          }
          else
          {
            if ((arg1<(-2.3025850929940458e+02)))
            {

              d_Dsi_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_GP_S)*3.3333333333333333e-01))+((-d_arg1_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_Dsi_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_S_BP)*3.3333333333333333e-01))+((-d_arg1_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_Dsi_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_D_S)*3.3333333333333333e-01))+((-d_arg1_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {

              d_Dsi_dV_GP_S = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_GP_S*3.3333333333333333e-01))+(d_arg1_dV_GP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_GP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Dsi_dV_S_BP = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_S_BP*3.3333333333333333e-01))+(d_arg1_dV_S_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_S_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Dsi_dV_D_S = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_D_S*3.3333333333333333e-01))+(d_arg1_dV_D_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_D_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }

          d_arg1_dV_D_S = d_arg1_dV_S_BP =  0.0;
          d_arg1_dV_GP_S = ((-d_VgsPrime_dV_GP_S)*(model_.inv_phit));
          arg1 = ((-VgsPrime)*(model_.inv_phit));
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp(arg1);
              double  deriv_exp_0_d0 = value_exp_0;

              d_temp_dV_GP_S = (deriv_exp_0_d0*(d_arg1_dV_GP_S));
              d_temp_dV_S_BP = (deriv_exp_0_d0*(d_arg1_dV_S_BP));
              d_temp_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
              temp = value_exp_0;
            }
          }
          else
          {
            if ((arg1<(-2.3025850929940458e+02)))
            {

              d_temp_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_GP_S)*3.3333333333333333e-01))+((-d_arg1_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_temp_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_S_BP)*3.3333333333333333e-01))+((-d_arg1_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_temp_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_D_S)*3.3333333333333333e-01))+((-d_arg1_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {

              d_temp_dV_GP_S = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_GP_S*3.3333333333333333e-01))+(d_arg1_dV_GP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_GP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_temp_dV_S_BP = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_S_BP*3.3333333333333333e-01))+(d_arg1_dV_S_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_S_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_temp_dV_D_S = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_D_S*3.3333333333333333e-01))+(d_arg1_dV_D_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_D_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }

          d_Dgate_dV_GP_S = ((Dsi*d_temp_dV_GP_S)+(d_Dsi_dV_GP_S*temp));
          d_Dgate_dV_S_BP = ((Dsi*d_temp_dV_S_BP)+(d_Dsi_dV_S_BP*temp));
          d_Dgate_dV_D_S = ((Dsi*d_temp_dV_D_S)+(d_Dsi_dV_D_S*temp));
          Dgate = (Dsi*temp);

          d_temp_dV_S_BP = (BOV*((zg*(GC3_i*d_zg_dV_S_BP))+(d_zg_dV_S_BP*(GC2_i+(GC3_i*zg)))));
          d_temp_dV_D_S = (BOV*((zg*(GC3_i*d_zg_dV_D_S))+(d_zg_dV_D_S*(GC2_i+(GC3_i*zg)))));
          d_temp_dV_GP_S = (BOV*((zg*(GC3_i*d_zg_dV_GP_S))+(d_zg_dV_GP_S*(GC2_i+(GC3_i*zg)))));
          temp = (BOV*((-1.5)+(zg*(GC2_i+(GC3_i*zg)))));
          if ((temp>0))
          {

            d_TP_dV_S_BP = ((temp*(0.5*((temp*(d_temp_dV_S_BP*3.3333333333333333e-01))+(d_temp_dV_S_BP*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_S_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            d_TP_dV_D_S = ((temp*(0.5*((temp*(d_temp_dV_D_S*3.3333333333333333e-01))+(d_temp_dV_D_S*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_D_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            d_TP_dV_GP_S = ((temp*(0.5*((temp*(d_temp_dV_GP_S*3.3333333333333333e-01))+(d_temp_dV_GP_S*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_GP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
          }
          else
          {
            if ((temp>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(temp);
                double  deriv_exp_0_d0 = value_exp_0;

                d_TP_dV_S_BP = (deriv_exp_0_d0*(d_temp_dV_S_BP));
                d_TP_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
                d_TP_dV_GP_S = (deriv_exp_0_d0*(d_temp_dV_GP_S));
                TP = value_exp_0;
              }
            }
            else
            {

              d_TP_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_S_BP)*3.3333333333333333e-01))+((-d_temp_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              d_TP_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_D_S)*3.3333333333333333e-01))+((-d_temp_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              d_TP_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_GP_S)*3.3333333333333333e-01))+((-d_temp_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            }
          }
          {
            double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
            double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));

            d_Igsov_dV_S_BP = (IGOV_i*((TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_S_BP-(1.0+Dsi)*d_Dgate_dV_S_BP)/(1.0+Dgate)/(1.0+Dgate)))))+(d_TP_dV_S_BP*value_log_0)));
            d_Igsov_dV_D_S = (IGOV_i*((TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_D_S-(1.0+Dsi)*d_Dgate_dV_D_S)/(1.0+Dgate)/(1.0+Dgate)))))+(d_TP_dV_D_S*value_log_0)));
            d_Igsov_dV_GP_S = (IGOV_i*((TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_GP_S-(1.0+Dsi)*d_Dgate_dV_GP_S)/(1.0+Dgate)/(1.0+Dgate)))))+(d_TP_dV_GP_S*value_log_0)));
            Igsov = (IGOV_i*(TP*value_log_0));
          }
        }
        if ((IGOVD_i>0))
        {

          d_arg2mina_dV_S_BP = d_Vovd_dV_S_BP;
          d_arg2mina_dV_D_S = d_Vovd_dV_D_S;
          d_arg2mina_dV_GP_S = d_Vovd_dV_GP_S;
          arg2mina = (Vovd+Dov);
          {
            double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_psi_t_dV_S_BP = (0.5*((+d_arg2mina_dV_S_BP)-(deriv_sqrt_0_d0*((((-arg2mina)*(-d_arg2mina_dV_S_BP))+((-d_arg2mina_dV_S_BP)*(-arg2mina)))))));
            d_psi_t_dV_D_S = (0.5*((+d_arg2mina_dV_D_S)-(deriv_sqrt_0_d0*((((-arg2mina)*(-d_arg2mina_dV_D_S))+((-d_arg2mina_dV_D_S)*(-arg2mina)))))));
            d_psi_t_dV_GP_S = (0.5*((+d_arg2mina_dV_GP_S)-(deriv_sqrt_0_d0*((((-arg2mina)*(-d_arg2mina_dV_GP_S))+((-d_arg2mina_dV_GP_S)*(-arg2mina)))))));
            psi_t = (0.5*((+arg2mina)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt(((Vovd*Vovd)+1.0e-6));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_zg_dV_S_BP = ((deriv_sqrt_0_d0*(((Vovd*d_Vovd_dV_S_BP)+(d_Vovd_dV_S_BP*Vovd))))*inv_CHIB);
            d_zg_dV_D_S = ((deriv_sqrt_0_d0*(((Vovd*d_Vovd_dV_D_S)+(d_Vovd_dV_D_S*Vovd))))*inv_CHIB);
            d_zg_dV_GP_S = ((deriv_sqrt_0_d0*(((Vovd*d_Vovd_dV_GP_S)+(d_Vovd_dV_GP_S*Vovd))))*inv_CHIB);
            zg = (value_sqrt_0*inv_CHIB);
          }
          if ((GC3_i<0))
          {
            {
              double value_sqrt_0 = sqrt((((zg-GCQ)*(zg-GCQ))+1.0e-6));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_zg_dV_S_BP = (0.5*(d_zg_dV_S_BP-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_S_BP)+(d_zg_dV_S_BP*(zg-GCQ)))))));
              d_zg_dV_D_S = (0.5*(d_zg_dV_D_S-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_D_S)+(d_zg_dV_D_S*(zg-GCQ)))))));
              d_zg_dV_GP_S = (0.5*(d_zg_dV_GP_S-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_GP_S)+(d_zg_dV_GP_S*(zg-GCQ)))))));
              zg = (0.5*((zg+GCQ)-value_sqrt_0));
            }
          }

          d_arg1_dV_D_S = (d_xd_ov_dV_D_S+(d_psi_t_dV_D_S*(model_.inv_phit)));
          d_arg1_dV_GP_S = (d_xd_ov_dV_GP_S+(d_psi_t_dV_GP_S*(model_.inv_phit)));
          d_arg1_dV_S_BP = (d_xd_ov_dV_S_BP+(d_psi_t_dV_S_BP*(model_.inv_phit)));
          arg1 = ((3.0+xd_ov)+(psi_t*(model_.inv_phit)));
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp(arg1);
              double  deriv_exp_0_d0 = value_exp_0;

              d_Dsi_dV_GP_S = (deriv_exp_0_d0*(d_arg1_dV_GP_S));
              d_Dsi_dV_S_BP = (deriv_exp_0_d0*(d_arg1_dV_S_BP));
              d_Dsi_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
              Dsi = value_exp_0;
            }
          }
          else
          {
            if ((arg1<(-2.3025850929940458e+02)))
            {

              d_Dsi_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_GP_S)*3.3333333333333333e-01))+((-d_arg1_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_Dsi_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_S_BP)*3.3333333333333333e-01))+((-d_arg1_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_Dsi_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_D_S)*3.3333333333333333e-01))+((-d_arg1_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {

              d_Dsi_dV_GP_S = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_GP_S*3.3333333333333333e-01))+(d_arg1_dV_GP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_GP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Dsi_dV_S_BP = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_S_BP*3.3333333333333333e-01))+(d_arg1_dV_S_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_S_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Dsi_dV_D_S = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_D_S*3.3333333333333333e-01))+(d_arg1_dV_D_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_D_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }

          d_arg1_dV_S_BP =  0.0;
          d_arg1_dV_D_S = ((-d_VgdPrime_dV_D_S)*(model_.inv_phit));
          d_arg1_dV_GP_S = ((-d_VgdPrime_dV_GP_S)*(model_.inv_phit));
          arg1 = ((-VgdPrime)*(model_.inv_phit));
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp(arg1);
              double  deriv_exp_0_d0 = value_exp_0;

              d_temp_dV_GP_S = (deriv_exp_0_d0*(d_arg1_dV_GP_S));
              d_temp_dV_S_BP = (deriv_exp_0_d0*(d_arg1_dV_S_BP));
              d_temp_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
              temp = value_exp_0;
            }
          }
          else
          {
            if ((arg1<(-2.3025850929940458e+02)))
            {

              d_temp_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_GP_S)*3.3333333333333333e-01))+((-d_arg1_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_temp_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_S_BP)*3.3333333333333333e-01))+((-d_arg1_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_temp_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_D_S)*3.3333333333333333e-01))+((-d_arg1_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {

              d_temp_dV_GP_S = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_GP_S*3.3333333333333333e-01))+(d_arg1_dV_GP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_GP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_temp_dV_S_BP = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_S_BP*3.3333333333333333e-01))+(d_arg1_dV_S_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_S_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_temp_dV_D_S = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_D_S*3.3333333333333333e-01))+(d_arg1_dV_D_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_D_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }

          d_Dgate_dV_GP_S = ((Dsi*d_temp_dV_GP_S)+(d_Dsi_dV_GP_S*temp));
          d_Dgate_dV_S_BP = ((Dsi*d_temp_dV_S_BP)+(d_Dsi_dV_S_BP*temp));
          d_Dgate_dV_D_S = ((Dsi*d_temp_dV_D_S)+(d_Dsi_dV_D_S*temp));
          Dgate = (Dsi*temp);

          d_temp_dV_S_BP = (BOV_d*((zg*(GC3_i*d_zg_dV_S_BP))+(d_zg_dV_S_BP*(GC2_i+(GC3_i*zg)))));
          d_temp_dV_D_S = (BOV_d*((zg*(GC3_i*d_zg_dV_D_S))+(d_zg_dV_D_S*(GC2_i+(GC3_i*zg)))));
          d_temp_dV_GP_S = (BOV_d*((zg*(GC3_i*d_zg_dV_GP_S))+(d_zg_dV_GP_S*(GC2_i+(GC3_i*zg)))));
          temp = (BOV_d*((-1.5)+(zg*(GC2_i+(GC3_i*zg)))));
          if ((temp>0))
          {

            d_TP_dV_S_BP = ((temp*(0.5*((temp*(d_temp_dV_S_BP*3.3333333333333333e-01))+(d_temp_dV_S_BP*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_S_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            d_TP_dV_D_S = ((temp*(0.5*((temp*(d_temp_dV_D_S*3.3333333333333333e-01))+(d_temp_dV_D_S*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_D_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            d_TP_dV_GP_S = ((temp*(0.5*((temp*(d_temp_dV_GP_S*3.3333333333333333e-01))+(d_temp_dV_GP_S*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_GP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
          }
          else
          {
            if ((temp>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(temp);
                double  deriv_exp_0_d0 = value_exp_0;

                d_TP_dV_S_BP = (deriv_exp_0_d0*(d_temp_dV_S_BP));
                d_TP_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
                d_TP_dV_GP_S = (deriv_exp_0_d0*(d_temp_dV_GP_S));
                TP = value_exp_0;
              }
            }
            else
            {

              d_TP_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_S_BP)*3.3333333333333333e-01))+((-d_temp_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              d_TP_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_D_S)*3.3333333333333333e-01))+((-d_temp_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              d_TP_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_GP_S)*3.3333333333333333e-01))+((-d_temp_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            }
          }
          {
            double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
            double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));

            d_Igdov_dV_S_BP = (IGOVD_i*((TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_S_BP-(1.0+Dsi)*d_Dgate_dV_S_BP)/(1.0+Dgate)/(1.0+Dgate)))))+(d_TP_dV_S_BP*value_log_0)));
            d_Igdov_dV_D_S = (IGOVD_i*((TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_D_S-(1.0+Dsi)*d_Dgate_dV_D_S)/(1.0+Dgate)/(1.0+Dgate)))))+(d_TP_dV_D_S*value_log_0)));
            d_Igdov_dV_GP_S = (IGOVD_i*((TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_GP_S-(1.0+Dsi)*d_Dgate_dV_GP_S)/(1.0+Dgate)/(1.0+Dgate)))))+(d_TP_dV_GP_S*value_log_0)));
            Igdov = (IGOVD_i*(TP*value_log_0));
          }
        }
        if ((IGINV_i>0))
        {
          if ((xg<=0.0))
          {
            {
              double value_pow_0 = pow((Vds/Vdsat_lim),AX_i);
              double  deriv_pow_0_d0 = (((Vds/Vdsat_lim) == 0.0)?0.0:(value_pow_0*AX_i/(Vds/Vdsat_lim)));

              d_temp_dV_GP_S = d_temp_dV_S_BP =  0.0;
              d_temp_dV_D_S = (deriv_pow_0_d0*((d_Vds_dV_D_S/Vdsat_lim)));
              temp = value_pow_0;
            }
            {
              double value_pow_0 = pow((1.0+temp),(-inv_AX));
              double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-inv_AX)/(1.0+temp)));

              d_Udse_dV_S_BP = ((Vds*(deriv_pow_0_d0*(d_temp_dV_S_BP)))*inv_phit1);
              d_Udse_dV_GP_S = ((Vds*(deriv_pow_0_d0*(d_temp_dV_GP_S)))*inv_phit1);
              d_Udse_dV_D_S = (((Vds*(deriv_pow_0_d0*(d_temp_dV_D_S)))+(d_Vds_dV_D_S*value_pow_0))*inv_phit1);
              Udse = ((Vds*value_pow_0)*inv_phit1);
            }
          }
          if (((x_ds-Udse)>(-2.3025850929940458e+02)))
          {
            {
              double value_exp_0 = exp((x_ds-Udse));
              double  deriv_exp_0_d0 = value_exp_0;

              d_temp_dV_S_BP = (deriv_exp_0_d0*((d_x_ds_dV_S_BP-d_Udse_dV_S_BP)));
              d_temp_dV_GP_S = (deriv_exp_0_d0*((d_x_ds_dV_GP_S-d_Udse_dV_GP_S)));
              d_temp_dV_D_S = (deriv_exp_0_d0*((d_x_ds_dV_D_S-d_Udse_dV_D_S)));
              temp = value_exp_0;
            }
          }
          else
          {

            d_temp_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*((-(d_x_ds_dV_S_BP-d_Udse_dV_S_BP))*3.3333333333333333e-01))+((-(d_x_ds_dV_S_BP-d_Udse_dV_S_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+((-(d_x_ds_dV_S_BP-d_Udse_dV_S_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
            d_temp_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*((-(d_x_ds_dV_GP_S-d_Udse_dV_GP_S))*3.3333333333333333e-01))+((-(d_x_ds_dV_GP_S-d_Udse_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+((-(d_x_ds_dV_GP_S-d_Udse_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
            d_temp_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*((-(d_x_ds_dV_D_S-d_Udse_dV_D_S))*3.3333333333333333e-01))+((-(d_x_ds_dV_D_S-d_Udse_dV_D_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+((-(d_x_ds_dV_D_S-d_Udse_dV_D_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
            temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
          }
          {
            double value_log_0 = log((0.5*(1.0+temp)));
            double  deriv_log_0_d0 = (1.0/(0.5*(1.0+temp)));

            d_Vm_dV_GP_S = (phit1*((0.5*d_x_ds_dV_GP_S)-(deriv_log_0_d0*((0.5*d_temp_dV_GP_S)))));
            d_Vm_dV_S_BP = (d_Vsbstar_dV_S_BP+(phit1*((0.5*d_x_ds_dV_S_BP)-(deriv_log_0_d0*((0.5*d_temp_dV_S_BP))))));
            d_Vm_dV_D_S = (d_Vsbstar_dV_D_S+(phit1*((0.5*d_x_ds_dV_D_S)-(deriv_log_0_d0*((0.5*d_temp_dV_D_S))))));
            Vm = (Vsbstar+(phit1*((0.5*x_ds)-value_log_0)));
          }

          d_arg2mina_dV_S_BP = d_Voxm_dV_S_BP;
          d_arg2mina_dV_GP_S = d_Voxm_dV_GP_S;
          d_arg2mina_dV_D_S = d_Voxm_dV_D_S;
          arg2mina = (Voxm+Dch);
          {
            double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_psi_t_dV_S_BP = (0.5*((+d_arg2mina_dV_S_BP)-(deriv_sqrt_0_d0*((((-arg2mina)*(-d_arg2mina_dV_S_BP))+((-d_arg2mina_dV_S_BP)*(-arg2mina)))))));
            d_psi_t_dV_D_S = (0.5*((+d_arg2mina_dV_D_S)-(deriv_sqrt_0_d0*((((-arg2mina)*(-d_arg2mina_dV_D_S))+((-d_arg2mina_dV_D_S)*(-arg2mina)))))));
            d_psi_t_dV_GP_S = (0.5*((+d_arg2mina_dV_GP_S)-(deriv_sqrt_0_d0*((((-arg2mina)*(-d_arg2mina_dV_GP_S))+((-d_arg2mina_dV_GP_S)*(-arg2mina)))))));
            psi_t = (0.5*((+arg2mina)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt(((Voxm*Voxm)+1.0e-6));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_zg_dV_S_BP = ((deriv_sqrt_0_d0*(((Voxm*d_Voxm_dV_S_BP)+(d_Voxm_dV_S_BP*Voxm))))*inv_CHIB);
            d_zg_dV_GP_S = ((deriv_sqrt_0_d0*(((Voxm*d_Voxm_dV_GP_S)+(d_Voxm_dV_GP_S*Voxm))))*inv_CHIB);
            d_zg_dV_D_S = ((deriv_sqrt_0_d0*(((Voxm*d_Voxm_dV_D_S)+(d_Voxm_dV_D_S*Voxm))))*inv_CHIB);
            zg = (value_sqrt_0*inv_CHIB);
          }
          if ((GC3_i<0))
          {
            {
              double value_sqrt_0 = sqrt((((zg-GCQ)*(zg-GCQ))+1.0e-06));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_zg_dV_S_BP = (0.5*(d_zg_dV_S_BP-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_S_BP)+(d_zg_dV_S_BP*(zg-GCQ)))))));
              d_zg_dV_D_S = (0.5*(d_zg_dV_D_S-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_D_S)+(d_zg_dV_D_S*(zg-GCQ)))))));
              d_zg_dV_GP_S = (0.5*(d_zg_dV_GP_S-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_GP_S)+(d_zg_dV_GP_S*(zg-GCQ)))))));
              zg = (0.5*((zg+GCQ)-value_sqrt_0));
            }
          }

          d_arg1_dV_S_BP = (d_x_m_dV_S_BP+((d_psi_t_dV_S_BP-d_Vm_dV_S_BP)*inv_phit1));
          d_arg1_dV_GP_S = (d_x_m_dV_GP_S+((d_psi_t_dV_GP_S-d_Vm_dV_GP_S)*inv_phit1));
          d_arg1_dV_D_S = (d_x_m_dV_D_S+((d_psi_t_dV_D_S-d_Vm_dV_D_S)*inv_phit1));
          arg1 = (x_m+(((psi_t-alpha_b)-Vm)*inv_phit1));
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp(arg1);
              double  deriv_exp_0_d0 = value_exp_0;

              d_Dsi_dV_GP_S = (deriv_exp_0_d0*(d_arg1_dV_GP_S));
              d_Dsi_dV_S_BP = (deriv_exp_0_d0*(d_arg1_dV_S_BP));
              d_Dsi_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
              Dsi = value_exp_0;
            }
          }
          else
          {
            if ((arg1<(-2.3025850929940458e+02)))
            {

              d_Dsi_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_GP_S)*3.3333333333333333e-01))+((-d_arg1_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_Dsi_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_S_BP)*3.3333333333333333e-01))+((-d_arg1_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_Dsi_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_D_S)*3.3333333333333333e-01))+((-d_arg1_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {

              d_Dsi_dV_GP_S = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_GP_S*3.3333333333333333e-01))+(d_arg1_dV_GP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_GP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Dsi_dV_S_BP = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_S_BP*3.3333333333333333e-01))+(d_arg1_dV_S_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_S_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Dsi_dV_D_S = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_D_S*3.3333333333333333e-01))+(d_arg1_dV_D_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_D_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }

          d_arg1_dV_S_BP = ((-(d_Vsbstar_dV_S_BP-d_Vm_dV_S_BP))*inv_phit1);
          d_arg1_dV_GP_S = ((-(d_Vgs_dV_GP_S-d_Vm_dV_GP_S))*inv_phit1);
          d_arg1_dV_D_S = ((-((d_Vgs_dV_D_S+d_Vsbstar_dV_D_S)-d_Vm_dV_D_S))*inv_phit1);
          arg1 = ((-((Vgs+Vsbstar)-Vm))*inv_phit1);
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp(arg1);
              double  deriv_exp_0_d0 = value_exp_0;

              d_temp_dV_GP_S = (deriv_exp_0_d0*(d_arg1_dV_GP_S));
              d_temp_dV_S_BP = (deriv_exp_0_d0*(d_arg1_dV_S_BP));
              d_temp_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
              temp = value_exp_0;
            }
          }
          else
          {
            if ((arg1<(-2.3025850929940458e+02)))
            {

              d_temp_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_GP_S)*3.3333333333333333e-01))+((-d_arg1_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_temp_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_S_BP)*3.3333333333333333e-01))+((-d_arg1_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_temp_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_D_S)*3.3333333333333333e-01))+((-d_arg1_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {

              d_temp_dV_GP_S = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_GP_S*3.3333333333333333e-01))+(d_arg1_dV_GP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_GP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_temp_dV_S_BP = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_S_BP*3.3333333333333333e-01))+(d_arg1_dV_S_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_S_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_temp_dV_D_S = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_D_S*3.3333333333333333e-01))+(d_arg1_dV_D_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_D_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }

          d_Dgate_dV_GP_S = ((Dsi*d_temp_dV_GP_S)+(d_Dsi_dV_GP_S*temp));
          d_Dgate_dV_S_BP = ((Dsi*d_temp_dV_S_BP)+(d_Dsi_dV_S_BP*temp));
          d_Dgate_dV_D_S = ((Dsi*d_temp_dV_D_S)+(d_Dsi_dV_D_S*temp));
          Dgate = (Dsi*temp);

          d_temp_dV_S_BP = (BCH*((zg*(GC3_i*d_zg_dV_S_BP))+(d_zg_dV_S_BP*(GC2_i+(GC3_i*zg)))));
          d_temp_dV_D_S = (BCH*((zg*(GC3_i*d_zg_dV_D_S))+(d_zg_dV_D_S*(GC2_i+(GC3_i*zg)))));
          d_temp_dV_GP_S = (BCH*((zg*(GC3_i*d_zg_dV_GP_S))+(d_zg_dV_GP_S*(GC2_i+(GC3_i*zg)))));
          temp = (BCH*((-1.5)+(zg*(GC2_i+(GC3_i*zg)))));
          if ((temp>0))
          {

            d_TP_dV_S_BP = ((temp*(0.5*((temp*(d_temp_dV_S_BP*3.3333333333333333e-01))+(d_temp_dV_S_BP*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_S_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            d_TP_dV_D_S = ((temp*(0.5*((temp*(d_temp_dV_D_S*3.3333333333333333e-01))+(d_temp_dV_D_S*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_D_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            d_TP_dV_GP_S = ((temp*(0.5*((temp*(d_temp_dV_GP_S*3.3333333333333333e-01))+(d_temp_dV_GP_S*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_GP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
          }
          else
          {
            if ((temp>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(temp);
                double  deriv_exp_0_d0 = value_exp_0;

                d_TP_dV_S_BP = (deriv_exp_0_d0*(d_temp_dV_S_BP));
                d_TP_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
                d_TP_dV_GP_S = (deriv_exp_0_d0*(d_temp_dV_GP_S));
                TP = value_exp_0;
              }
            }
            else
            {

              d_TP_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_S_BP)*3.3333333333333333e-01))+((-d_temp_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              d_TP_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_D_S)*3.3333333333333333e-01))+((-d_temp_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              d_TP_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_GP_S)*3.3333333333333333e-01))+((-d_temp_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            }
          }
          {
            double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
            double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));

            d_Igc0_dV_S_BP = (IGINV_i*((TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_S_BP-(1.0+Dsi)*d_Dgate_dV_S_BP)/(1.0+Dgate)/(1.0+Dgate)))))+(d_TP_dV_S_BP*value_log_0)));
            d_Igc0_dV_D_S = (IGINV_i*((TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_D_S-(1.0+Dsi)*d_Dgate_dV_D_S)/(1.0+Dgate)/(1.0+Dgate)))))+(d_TP_dV_D_S*value_log_0)));
            d_Igc0_dV_GP_S = (IGINV_i*((TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_GP_S-(1.0+Dsi)*d_Dgate_dV_GP_S)/(1.0+Dgate)/(1.0+Dgate)))))+(d_TP_dV_GP_S*value_log_0)));
            Igc0 = (IGINV_i*(TP*value_log_0));
          }
          if (((xg<=0)||((GC2_i==0)&&(GC3_i==0))))
          {

            d_igc_dV_D_S = d_igc_dV_GP_S = d_igc_dV_S_BP =  0.0;
            igc = 1.0;

            d_igcd_h_dV_D_S = d_igcd_h_dV_GP_S = d_igcd_h_dV_S_BP =  0.0;
            igcd_h = 0.5;
          }
          else
          {

            d_temp_dV_S_BP = ((2.0*GC3_i)*d_zg_dV_S_BP);
            d_temp_dV_D_S = ((2.0*GC3_i)*d_zg_dV_D_S);
            d_temp_dV_GP_S = ((2.0*GC3_i)*d_zg_dV_GP_S);
            temp = (GC2_i+((2.0*GC3_i)*zg));

            d_u0_dV_S_BP = (-CHIB_i*(d_temp_dV_S_BP*BCH)/(temp*BCH)/(temp*BCH));
            d_u0_dV_D_S = (-CHIB_i*(d_temp_dV_D_S*BCH)/(temp*BCH)/(temp*BCH));
            d_u0_dV_GP_S = (-CHIB_i*(d_temp_dV_GP_S*BCH)/(temp*BCH)/(temp*BCH));
            u0 = (CHIB_i/(temp*BCH));

            d_x_dV_S_BP = (0.5*((u0*d_dps_dV_S_BP-dps*d_u0_dV_S_BP)/u0/u0));
            d_x_dV_GP_S = (0.5*((u0*d_dps_dV_GP_S-dps*d_u0_dV_GP_S)/u0/u0));
            d_x_dV_D_S = (0.5*((u0*d_dps_dV_D_S-dps*d_u0_dV_D_S)/u0/u0));
            x = (0.5*(dps/u0));

            d_u0_div_H_dV_S_BP = ((H*d_u0_dV_S_BP-u0*d_H_dV_S_BP)/H/H);
            d_u0_div_H_dV_D_S = ((H*d_u0_dV_D_S-u0*d_H_dV_D_S)/H/H);
            d_u0_div_H_dV_GP_S = ((H*d_u0_dV_GP_S-u0*d_H_dV_GP_S)/H/H);
            u0_div_H = (u0/H);

            d_Bg_dV_S_BP = (((u0_div_H*(-d_u0_div_H_dV_S_BP))+(d_u0_div_H_dV_S_BP*(1.0-u0_div_H)))*0.5);
            d_Bg_dV_D_S = (((u0_div_H*(-d_u0_div_H_dV_D_S))+(d_u0_div_H_dV_D_S*(1.0-u0_div_H)))*0.5);
            d_Bg_dV_GP_S = (((u0_div_H*(-d_u0_div_H_dV_GP_S))+(d_u0_div_H_dV_GP_S*(1.0-u0_div_H)))*0.5);
            Bg = ((u0_div_H*(1.0-u0_div_H))*0.5);

            d_Ag_dV_S_BP = (-(3.0*d_Bg_dV_S_BP));
            d_Ag_dV_D_S = (-(3.0*d_Bg_dV_D_S));
            d_Ag_dV_GP_S = (-(3.0*d_Bg_dV_GP_S));
            Ag = (0.5-(3.0*Bg));
            if ((x<1.0e-3))
            {

              d_xsq_dV_S_BP = ((x*d_x_dV_S_BP)+(d_x_dV_S_BP*x));
              d_xsq_dV_GP_S = ((x*d_x_dV_GP_S)+(d_x_dV_GP_S*x));
              d_xsq_dV_D_S = ((x*d_x_dV_D_S)+(d_x_dV_D_S*x));
              xsq = (x*x);

              d_igc_dV_S_BP = ((xsq*((d_u0_div_H_dV_S_BP*3.3333333333333333e-01)+(1.6666666666666667e-01*((xsq*(0.2*d_u0_div_H_dV_S_BP))+(d_xsq_dV_S_BP*(0.05+(0.2*u0_div_H)))))))+(d_xsq_dV_S_BP*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));
              d_igc_dV_GP_S = ((xsq*((d_u0_div_H_dV_GP_S*3.3333333333333333e-01)+(1.6666666666666667e-01*((xsq*(0.2*d_u0_div_H_dV_GP_S))+(d_xsq_dV_GP_S*(0.05+(0.2*u0_div_H)))))))+(d_xsq_dV_GP_S*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));
              d_igc_dV_D_S = ((xsq*((d_u0_div_H_dV_D_S*3.3333333333333333e-01)+(1.6666666666666667e-01*((xsq*(0.2*d_u0_div_H_dV_D_S))+(d_xsq_dV_D_S*(0.05+(0.2*u0_div_H)))))))+(d_xsq_dV_D_S*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));
              igc = (1.0+(xsq*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));

              d_igcd_h_dV_S_BP = ((0.5*d_igc_dV_S_BP)-(1.6666666666666667e-01*((x*((xsq*((0.4*d_Bg_dV_S_BP)+(0.0285714285714*((xsq*d_Bg_dV_S_BP)+(d_xsq_dV_S_BP*(0.125+Bg))))))+(d_xsq_dV_S_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(d_x_dV_S_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))))));
              d_igcd_h_dV_GP_S = ((0.5*d_igc_dV_GP_S)-(1.6666666666666667e-01*((x*((xsq*((0.4*d_Bg_dV_GP_S)+(0.0285714285714*((xsq*d_Bg_dV_GP_S)+(d_xsq_dV_GP_S*(0.125+Bg))))))+(d_xsq_dV_GP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(d_x_dV_GP_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))))));
              d_igcd_h_dV_D_S = ((0.5*d_igc_dV_D_S)-(1.6666666666666667e-01*((x*((xsq*((0.4*d_Bg_dV_D_S)+(0.0285714285714*((xsq*d_Bg_dV_D_S)+(d_xsq_dV_D_S*(0.125+Bg))))))+(d_xsq_dV_D_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(d_x_dV_D_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))))));
              igcd_h = ((0.5*igc)-(1.6666666666666667e-01*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))));
            }
            else
            {

              d_inv_x_dV_S_BP = (-d_x_dV_S_BP/x/x);
              d_inv_x_dV_GP_S = (-d_x_dV_GP_S/x/x);
              d_inv_x_dV_D_S = (-d_x_dV_D_S/x/x);
              inv_x = (1.0/x);
              if ((fabs(x)<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(x);
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_ex_dV_S_BP = (deriv_exp_0_d0*(d_x_dV_S_BP));
                  d_ex_dV_GP_S = (deriv_exp_0_d0*(d_x_dV_GP_S));
                  d_ex_dV_D_S = (deriv_exp_0_d0*(d_x_dV_D_S));
                  ex = value_exp_0;
                }
              }
              else
              {
                if ((x<(-2.3025850929940458e+02)))
                {

                  d_ex_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-x)*(0.5*((((-2.3025850929940458e+02)-x)*((-d_x_dV_S_BP)*3.3333333333333333e-01))+((-d_x_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+((-d_x_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
                  d_ex_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-x)*(0.5*((((-2.3025850929940458e+02)-x)*((-d_x_dV_GP_S)*3.3333333333333333e-01))+((-d_x_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+((-d_x_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
                  d_ex_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-x)*(0.5*((((-2.3025850929940458e+02)-x)*((-d_x_dV_D_S)*3.3333333333333333e-01))+((-d_x_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+((-d_x_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
                  ex = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_ex_dV_S_BP = (1.0e100*(((x-2.3025850929940458e+02)*(0.5*(((x-2.3025850929940458e+02)*(d_x_dV_S_BP*3.3333333333333333e-01))+(d_x_dV_S_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_dV_S_BP*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_ex_dV_GP_S = (1.0e100*(((x-2.3025850929940458e+02)*(0.5*(((x-2.3025850929940458e+02)*(d_x_dV_GP_S*3.3333333333333333e-01))+(d_x_dV_GP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_dV_GP_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_ex_dV_D_S = (1.0e100*(((x-2.3025850929940458e+02)*(0.5*(((x-2.3025850929940458e+02)*(d_x_dV_D_S*3.3333333333333333e-01))+(d_x_dV_D_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_dV_D_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  ex = (1.0e100*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_inv_ex_dV_S_BP = (-d_ex_dV_S_BP/ex/ex);
              d_inv_ex_dV_GP_S = (-d_ex_dV_GP_S/ex/ex);
              d_inv_ex_dV_D_S = (-d_ex_dV_D_S/ex/ex);
              inv_ex = (1.0/ex);

              d_temp_dV_S_BP = (d_ex_dV_S_BP-d_inv_ex_dV_S_BP);
              d_temp_dV_GP_S = (d_ex_dV_GP_S-d_inv_ex_dV_GP_S);
              d_temp_dV_D_S = (d_ex_dV_D_S-d_inv_ex_dV_D_S);
              temp = (ex-inv_ex);

              d_temp2_dV_S_BP = (d_ex_dV_S_BP+d_inv_ex_dV_S_BP);
              d_temp2_dV_GP_S = (d_ex_dV_GP_S+d_inv_ex_dV_GP_S);
              d_temp2_dV_D_S = (d_ex_dV_D_S+d_inv_ex_dV_D_S);
              temp2 = (ex+inv_ex);

              d_igc_dV_S_BP = (0.5*(((((1.0-u0_div_H)*temp)*d_inv_x_dV_S_BP)+((((1.0-u0_div_H)*d_temp_dV_S_BP)+((-d_u0_div_H_dV_S_BP)*temp))*inv_x))+((u0_div_H*d_temp2_dV_S_BP)+(d_u0_div_H_dV_S_BP*temp2))));
              d_igc_dV_D_S = (0.5*(((((1.0-u0_div_H)*temp)*d_inv_x_dV_D_S)+((((1.0-u0_div_H)*d_temp_dV_D_S)+((-d_u0_div_H_dV_D_S)*temp))*inv_x))+((u0_div_H*d_temp2_dV_D_S)+(d_u0_div_H_dV_D_S*temp2))));
              d_igc_dV_GP_S = (0.5*(((((1.0-u0_div_H)*temp)*d_inv_x_dV_GP_S)+((((1.0-u0_div_H)*d_temp_dV_GP_S)+((-d_u0_div_H_dV_GP_S)*temp))*inv_x))+((u0_div_H*d_temp2_dV_GP_S)+(d_u0_div_H_dV_GP_S*temp2))));
              igc = (0.5*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2)));

              d_igcd_h_dV_S_BP = (0.5*((d_igc_dV_S_BP-((temp*(d_Bg_dV_S_BP-(((Ag*inv_x)*d_inv_x_dV_S_BP)+(((Ag*d_inv_x_dV_S_BP)+(d_Ag_dV_S_BP*inv_x))*inv_x))))+(d_temp_dV_S_BP*(Bg-((Ag*inv_x)*inv_x)))))-(((Ag*temp2)*d_inv_x_dV_S_BP)+(((Ag*d_temp2_dV_S_BP)+(d_Ag_dV_S_BP*temp2))*inv_x))));
              d_igcd_h_dV_GP_S = (0.5*((d_igc_dV_GP_S-((temp*(d_Bg_dV_GP_S-(((Ag*inv_x)*d_inv_x_dV_GP_S)+(((Ag*d_inv_x_dV_GP_S)+(d_Ag_dV_GP_S*inv_x))*inv_x))))+(d_temp_dV_GP_S*(Bg-((Ag*inv_x)*inv_x)))))-(((Ag*temp2)*d_inv_x_dV_GP_S)+(((Ag*d_temp2_dV_GP_S)+(d_Ag_dV_GP_S*temp2))*inv_x))));
              d_igcd_h_dV_D_S = (0.5*((d_igc_dV_D_S-((temp*(d_Bg_dV_D_S-(((Ag*inv_x)*d_inv_x_dV_D_S)+(((Ag*d_inv_x_dV_D_S)+(d_Ag_dV_D_S*inv_x))*inv_x))))+(d_temp_dV_D_S*(Bg-((Ag*inv_x)*inv_x)))))-(((Ag*temp2)*d_inv_x_dV_D_S)+(((Ag*d_temp2_dV_D_S)+(d_Ag_dV_D_S*temp2))*inv_x))));
              igcd_h = (0.5*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x)));
            }
          }
          {
            double value_sqrt_0 = sqrt(((xg*xg)+1.0e-6));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Sg_dV_S_BP = (0.5*((value_sqrt_0*d_xg_dV_S_BP-xg*(deriv_sqrt_0_d0*(((xg*d_xg_dV_S_BP)+(d_xg_dV_S_BP*xg)))))/value_sqrt_0/value_sqrt_0));
            d_Sg_dV_GP_S = (0.5*((value_sqrt_0*d_xg_dV_GP_S-xg*(deriv_sqrt_0_d0*(((xg*d_xg_dV_GP_S)+(d_xg_dV_GP_S*xg)))))/value_sqrt_0/value_sqrt_0));
            d_Sg_dV_D_S = (0.5*((value_sqrt_0*d_xg_dV_D_S-xg*(deriv_sqrt_0_d0*(((xg*d_xg_dV_D_S)+(d_xg_dV_D_S*xg)))))/value_sqrt_0/value_sqrt_0));
            Sg = (0.5*(1.0+(xg/value_sqrt_0)));
          }

          d_Igc_dV_S_BP = (((Igc0*igc)*d_Sg_dV_S_BP)+(((Igc0*d_igc_dV_S_BP)+(d_Igc0_dV_S_BP*igc))*Sg));
          d_Igc_dV_D_S = (((Igc0*igc)*d_Sg_dV_D_S)+(((Igc0*d_igc_dV_D_S)+(d_Igc0_dV_D_S*igc))*Sg));
          d_Igc_dV_GP_S = (((Igc0*igc)*d_Sg_dV_GP_S)+(((Igc0*d_igc_dV_GP_S)+(d_Igc0_dV_GP_S*igc))*Sg));
          Igc = ((Igc0*igc)*Sg);

          d_Igcd_dV_S_BP = (((Igc0*igcd_h)*d_Sg_dV_S_BP)+(((Igc0*d_igcd_h_dV_S_BP)+(d_Igc0_dV_S_BP*igcd_h))*Sg));
          d_Igcd_dV_D_S = (((Igc0*igcd_h)*d_Sg_dV_D_S)+(((Igc0*d_igcd_h_dV_D_S)+(d_Igc0_dV_D_S*igcd_h))*Sg));
          d_Igcd_dV_GP_S = (((Igc0*igcd_h)*d_Sg_dV_GP_S)+(((Igc0*d_igcd_h_dV_GP_S)+(d_Igc0_dV_GP_S*igcd_h))*Sg));
          Igcd = ((Igc0*igcd_h)*Sg);

          d_Igcs_dV_S_BP = (d_Igc_dV_S_BP-d_Igcd_dV_S_BP);
          d_Igcs_dV_D_S = (d_Igc_dV_D_S-d_Igcd_dV_D_S);
          d_Igcs_dV_GP_S = (d_Igc_dV_GP_S-d_Igcd_dV_GP_S);
          Igcs = (Igc-Igcd);

          d_Igb_dV_S_BP = (((Igc0*igc)*(-d_Sg_dV_S_BP))+(((Igc0*d_igc_dV_S_BP)+(d_Igc0_dV_S_BP*igc))*(1.0-Sg)));
          d_Igb_dV_D_S = (((Igc0*igc)*(-d_Sg_dV_D_S))+(((Igc0*d_igc_dV_D_S)+(d_Igc0_dV_D_S*igc))*(1.0-Sg)));
          d_Igb_dV_GP_S = (((Igc0*igc)*(-d_Sg_dV_GP_S))+(((Igc0*d_igc_dV_GP_S)+(d_Igc0_dV_GP_S*igc))*(1.0-Sg)));
          Igb = ((Igc0*igc)*(1.0-Sg));
        }
      }

      d_Igidl_dV_D_S = d_Igidl_dV_S_BP = d_Igidl_dV_GP_S =  0.0;
      Igidl = 0.0;

      d_Igisl_dV_S_BP = d_Igisl_dV_GP_S = d_Igisl_dV_D_S =  0.0;
      Igisl = 0.0;
      if (((model_.SWGIDL)!=0))
      {
        if (((AGIDLD_i>0)&&(Vovd<0)))
        {
          {
            double value_sqrt_0 = sqrt((((Vovd*Vovd)+((CGIDLD_i*CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Vtovd_dV_S_BP = (deriv_sqrt_0_d0*((((Vovd*d_Vovd_dV_S_BP)+(d_Vovd_dV_S_BP*Vovd))+((CGIDLD_i*CGIDLD_i)*((VdbPrime*d_VdbPrime_dV_S_BP)+(d_VdbPrime_dV_S_BP*VdbPrime))))));
            d_Vtovd_dV_D_S = (deriv_sqrt_0_d0*((((Vovd*d_Vovd_dV_D_S)+(d_Vovd_dV_D_S*Vovd))+((CGIDLD_i*CGIDLD_i)*((VdbPrime*d_VdbPrime_dV_D_S)+(d_VdbPrime_dV_D_S*VdbPrime))))));
            d_Vtovd_dV_GP_S = (deriv_sqrt_0_d0*(((Vovd*d_Vovd_dV_GP_S)+(d_Vovd_dV_GP_S*Vovd))));
            Vtovd = value_sqrt_0;
          }

          d_temp_dV_S_BP = (-(-BGIDLDs)*d_Vtovd_dV_S_BP/Vtovd/Vtovd);
          d_temp_dV_D_S = (-(-BGIDLDs)*d_Vtovd_dV_D_S/Vtovd/Vtovd);
          d_temp_dV_GP_S = (-(-BGIDLDs)*d_Vtovd_dV_GP_S/Vtovd/Vtovd);
          temp = ((-BGIDLDs)/Vtovd);
          if ((temp>(-2.3025850929940458e+02)))
          {
            {
              double value_exp_0 = exp(temp);
              double  deriv_exp_0_d0 = value_exp_0;

              d_temp2_dV_S_BP = (deriv_exp_0_d0*(d_temp_dV_S_BP));
              d_temp2_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
              d_temp2_dV_GP_S = (deriv_exp_0_d0*(d_temp_dV_GP_S));
              temp2 = value_exp_0;
            }
          }
          else
          {

            d_temp2_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_S_BP)*3.3333333333333333e-01))+((-d_temp_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            d_temp2_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_D_S)*3.3333333333333333e-01))+((-d_temp_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            d_temp2_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_GP_S)*3.3333333333333333e-01))+((-d_temp_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
          }

          d_Igidl_dV_GP_S = ((-AGIDLDs)*((((VdbPrime*Vovd)*Vtovd)*d_temp2_dV_GP_S)+((((VdbPrime*Vovd)*d_Vtovd_dV_GP_S)+((VdbPrime*d_Vovd_dV_GP_S)*Vtovd))*temp2)));
          d_Igidl_dV_S_BP = ((-AGIDLDs)*((((VdbPrime*Vovd)*Vtovd)*d_temp2_dV_S_BP)+((((VdbPrime*Vovd)*d_Vtovd_dV_S_BP)+(((VdbPrime*d_Vovd_dV_S_BP)+(d_VdbPrime_dV_S_BP*Vovd))*Vtovd))*temp2)));
          d_Igidl_dV_D_S = ((-AGIDLDs)*((((VdbPrime*Vovd)*Vtovd)*d_temp2_dV_D_S)+((((VdbPrime*Vovd)*d_Vtovd_dV_D_S)+(((VdbPrime*d_Vovd_dV_D_S)+(d_VdbPrime_dV_D_S*Vovd))*Vtovd))*temp2)));
          Igidl = ((-AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*temp2));
        }
        if (((AGIDL_i>0)&&(Vovs<0)))
        {
          {
            double value_sqrt_0 = sqrt((((Vovs*Vovs)+((CGIDL_i*CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Vtovs_dV_S_BP = (deriv_sqrt_0_d0*((((Vovs*d_Vovs_dV_S_BP)+(d_Vovs_dV_S_BP*Vovs))+((CGIDL_i*CGIDL_i)*((VsbPrime*d_VsbPrime_dV_S_BP)+(d_VsbPrime_dV_S_BP*VsbPrime))))));
            d_Vtovs_dV_D_S = (deriv_sqrt_0_d0*(((Vovs*d_Vovs_dV_D_S)+(d_Vovs_dV_D_S*Vovs))));
            d_Vtovs_dV_GP_S = (deriv_sqrt_0_d0*(((Vovs*d_Vovs_dV_GP_S)+(d_Vovs_dV_GP_S*Vovs))));
            Vtovs = value_sqrt_0;
          }

          d_temp_dV_S_BP = (-(-BGIDLs)*d_Vtovs_dV_S_BP/Vtovs/Vtovs);
          d_temp_dV_D_S = (-(-BGIDLs)*d_Vtovs_dV_D_S/Vtovs/Vtovs);
          d_temp_dV_GP_S = (-(-BGIDLs)*d_Vtovs_dV_GP_S/Vtovs/Vtovs);
          temp = ((-BGIDLs)/Vtovs);
          if ((temp>(-2.3025850929940458e+02)))
          {
            {
              double value_exp_0 = exp(temp);
              double  deriv_exp_0_d0 = value_exp_0;

              d_temp2_dV_S_BP = (deriv_exp_0_d0*(d_temp_dV_S_BP));
              d_temp2_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
              d_temp2_dV_GP_S = (deriv_exp_0_d0*(d_temp_dV_GP_S));
              temp2 = value_exp_0;
            }
          }
          else
          {

            d_temp2_dV_S_BP = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_S_BP)*3.3333333333333333e-01))+((-d_temp_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            d_temp2_dV_D_S = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_D_S)*3.3333333333333333e-01))+((-d_temp_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            d_temp2_dV_GP_S = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_GP_S)*3.3333333333333333e-01))+((-d_temp_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
          }

          d_Igisl_dV_D_S = ((-AGIDLs)*((((VsbPrime*Vovs)*Vtovs)*d_temp2_dV_D_S)+((((VsbPrime*Vovs)*d_Vtovs_dV_D_S)+((VsbPrime*d_Vovs_dV_D_S)*Vtovs))*temp2)));
          d_Igisl_dV_GP_S = ((-AGIDLs)*((((VsbPrime*Vovs)*Vtovs)*d_temp2_dV_GP_S)+((((VsbPrime*Vovs)*d_Vtovs_dV_GP_S)+((VsbPrime*d_Vovs_dV_GP_S)*Vtovs))*temp2)));
          d_Igisl_dV_S_BP = ((-AGIDLs)*((((VsbPrime*Vovs)*Vtovs)*d_temp2_dV_S_BP)+((((VsbPrime*Vovs)*d_Vtovs_dV_S_BP)+(((VsbPrime*d_Vovs_dV_S_BP)+(d_VsbPrime_dV_S_BP*Vovs))*Vtovs))*temp2)));
          Igisl = ((-AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*temp2));
        }
      }

      d_P_D_dV_S_BP = (0.25*(d_Gf_dV_S_BP*kp));
      d_P_D_dV_GP_S = (0.25*(d_Gf_dV_GP_S*kp));
      d_P_D_dV_D_S = (0.25*(d_Gf_dV_D_S*kp));
      P_D = (1+(0.25*(Gf*kp)));
      facvsb0 = (phib+(2*phit1));

      d_facvsb_dV_S_BP = d_Vsbstar_dV_S_BP;
      d_facvsb_dV_D_S = d_Vsbstar_dV_D_S;
      facvsb = (Vsbstar+facvsb0);
      {
        double value_sqrt_0 = sqrt((phit1*facvsb));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_vts_i_dV_S_BP = ((-d_Vsbstar_dV_S_BP)+(d_Gf_dV_S_BP*value_sqrt_0));
        d_vts_i_dV_GP_S = (d_Gf_dV_GP_S*value_sqrt_0);
        d_vts_i_dV_D_S = ((-d_Vsbstar_dV_D_S)+(d_Gf_dV_D_S*value_sqrt_0));
        vts_i = (((VFB_i+(P_D*facvsb))-Vsbstar)+(Gf*value_sqrt_0));
      }

      d_vth_i_dV_S_BP = (-d_delVg_dV_S_BP);
      d_vth_i_dV_GP_S = 0.0;
      d_vth_i_dV_D_S = (-d_delVg_dV_D_S);
      vth_i = (vts_i-delVg);
    }
    // End block evaluateStatic
    //Begin block evaluateDynamic
    {

      d_Vgb_dV_S_BP = d_Vsb_dV_S_BP;
      d_Vgb_dV_GP_S = d_Vgs_dV_GP_S;
      d_Vgb_dV_D_S = (d_Vgs_dV_D_S+d_Vsb_dV_D_S);
      Vgb = (Vgs+Vsb);

      d_COX_qm_dV_D_S = d_COX_qm_dV_GP_S = d_COX_qm_dV_S_BP =  0.0;
      COX_qm = COX_i;
      if ((qq>0.0))
      {
        {
          double value_pow_0 = pow(((qeff*qeff)+qlim2),((-1.0)*1.6666666666666667e-01));
          double  deriv_pow_0_d0 = ((((qeff*qeff)+qlim2) == 0.0)?0.0:(value_pow_0*((-1.0)*1.6666666666666667e-01)/((qeff*qeff)+qlim2)));

          d_COX_qm_dV_S_BP = (-COX_i*(qq*(deriv_pow_0_d0*(((qeff*d_qeff_dV_S_BP)+(d_qeff_dV_S_BP*qeff)))))/(1.0+(qq*value_pow_0))/(1.0+(qq*value_pow_0)));
          d_COX_qm_dV_GP_S = (-COX_i*(qq*(deriv_pow_0_d0*(((qeff*d_qeff_dV_GP_S)+(d_qeff_dV_GP_S*qeff)))))/(1.0+(qq*value_pow_0))/(1.0+(qq*value_pow_0)));
          d_COX_qm_dV_D_S = (-COX_i*(qq*(deriv_pow_0_d0*(((qeff*d_qeff_dV_D_S)+(d_qeff_dV_D_S*qeff)))))/(1.0+(qq*value_pow_0))/(1.0+(qq*value_pow_0)));
          COX_qm = (COX_i/(1.0+(qq*value_pow_0)));
        }
      }
      if ((xg<=0.0))
      {

        d_QG_dV_S_BP = d_Voxm_dV_S_BP;
        d_QG_dV_GP_S = d_Voxm_dV_GP_S;
        d_QG_dV_D_S = d_Voxm_dV_D_S;
        QG = Voxm;

        d_QI_dV_GP_S = d_QI_dV_D_S = d_QI_dV_S_BP =  0.0;
        QI = 0.0;

        d_QD_dV_GP_S = d_QD_dV_D_S = d_QD_dV_S_BP =  0.0;
        QD = 0.0;

        d_QB_dV_S_BP = d_QG_dV_S_BP;
        d_QB_dV_GP_S = d_QG_dV_GP_S;
        d_QB_dV_D_S = d_QG_dV_D_S;
        QB = QG;
      }
      else
      {

        d_Fj_dV_S_BP = (0.5*((H*d_dps_dV_S_BP-dps*d_H_dV_S_BP)/H/H));
        d_Fj_dV_GP_S = (0.5*((H*d_dps_dV_GP_S-dps*d_H_dV_GP_S)/H/H));
        d_Fj_dV_D_S = (0.5*((H*d_dps_dV_D_S-dps*d_H_dV_D_S)/H/H));
        Fj = (0.5*(dps/H));

        d_Fj2_dV_S_BP = ((Fj*d_Fj_dV_S_BP)+(d_Fj_dV_S_BP*Fj));
        d_Fj2_dV_GP_S = ((Fj*d_Fj_dV_GP_S)+(d_Fj_dV_GP_S*Fj));
        d_Fj2_dV_D_S = ((Fj*d_Fj_dV_D_S)+(d_Fj_dV_D_S*Fj));
        Fj2 = (Fj*Fj);

        d_QCLM_dV_S_BP = (((1.0-GdL)*(d_qim_dV_S_BP-(0.5*((alpha*d_dps_dV_S_BP)+(d_alpha_dV_S_BP*dps)))))+((-d_GdL_dV_S_BP)*(qim-(0.5*(alpha*dps)))));
        d_QCLM_dV_D_S = (((1.0-GdL)*(d_qim_dV_D_S-(0.5*((alpha*d_dps_dV_D_S)+(d_alpha_dV_D_S*dps)))))+((-d_GdL_dV_D_S)*(qim-(0.5*(alpha*dps)))));
        d_QCLM_dV_GP_S = (((1.0-GdL)*(d_qim_dV_GP_S-(0.5*((alpha*d_dps_dV_GP_S)+(d_alpha_dV_GP_S*dps)))))+((-d_GdL_dV_GP_S)*(qim-(0.5*(alpha*dps)))));
        QCLM = ((1.0-GdL)*(qim-(0.5*(alpha*dps))));

        d_QG_dV_S_BP = (d_Voxm_dV_S_BP+(0.5*(((eta_p*dps)*((((Fj*d_GdL_dV_S_BP)+(d_Fj_dV_S_BP*GdL))*3.3333333333333333e-01)+d_GdL_dV_S_BP))+(((eta_p*d_dps_dV_S_BP)+(d_eta_p_dV_S_BP*dps))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)))));
        d_QG_dV_GP_S = (d_Voxm_dV_GP_S+(0.5*(((eta_p*dps)*((((Fj*d_GdL_dV_GP_S)+(d_Fj_dV_GP_S*GdL))*3.3333333333333333e-01)+d_GdL_dV_GP_S))+(((eta_p*d_dps_dV_GP_S)+(d_eta_p_dV_GP_S*dps))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)))));
        d_QG_dV_D_S = (d_Voxm_dV_D_S+(0.5*(((eta_p*dps)*((((Fj*d_GdL_dV_D_S)+(d_Fj_dV_D_S*GdL))*3.3333333333333333e-01)+d_GdL_dV_D_S))+(((eta_p*d_dps_dV_D_S)+(d_eta_p_dV_D_S*dps))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)))));
        QG = (Voxm+(0.5*((eta_p*dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))));

        d_temp_dV_S_BP = (((alpha*d_dps_dV_S_BP)+(d_alpha_dV_S_BP*dps))*1.6666666666666667e-01);
        d_temp_dV_GP_S = (((alpha*d_dps_dV_GP_S)+(d_alpha_dV_GP_S*dps))*1.6666666666666667e-01);
        d_temp_dV_D_S = (((alpha*d_dps_dV_D_S)+(d_alpha_dV_D_S*dps))*1.6666666666666667e-01);
        temp = ((alpha*dps)*1.6666666666666667e-01);

        d_QI_dV_S_BP = (((GdL*(d_qim_dV_S_BP+((temp*d_Fj_dV_S_BP)+(d_temp_dV_S_BP*Fj))))+(d_GdL_dV_S_BP*(qim+(temp*Fj))))+d_QCLM_dV_S_BP);
        d_QI_dV_D_S = (((GdL*(d_qim_dV_D_S+((temp*d_Fj_dV_D_S)+(d_temp_dV_D_S*Fj))))+(d_GdL_dV_D_S*(qim+(temp*Fj))))+d_QCLM_dV_D_S);
        d_QI_dV_GP_S = (((GdL*(d_qim_dV_GP_S+((temp*d_Fj_dV_GP_S)+(d_temp_dV_GP_S*Fj))))+(d_GdL_dV_GP_S*(qim+(temp*Fj))))+d_QCLM_dV_GP_S);
        QI = ((GdL*(qim+(temp*Fj)))+QCLM);

        d_QD_dV_S_BP = (0.5*((((GdL*GdL)*(d_qim_dV_S_BP-((temp*((-d_Fj_dV_S_BP)-(0.2*d_Fj2_dV_S_BP)))+(d_temp_dV_S_BP*((1.0-Fj)-(0.2*Fj2))))))+(((GdL*d_GdL_dV_S_BP)+(d_GdL_dV_S_BP*GdL))*(qim-(temp*((1.0-Fj)-(0.2*Fj2))))))+((QCLM*d_GdL_dV_S_BP)+(d_QCLM_dV_S_BP*(1.0+GdL)))));
        d_QD_dV_D_S = (0.5*((((GdL*GdL)*(d_qim_dV_D_S-((temp*((-d_Fj_dV_D_S)-(0.2*d_Fj2_dV_D_S)))+(d_temp_dV_D_S*((1.0-Fj)-(0.2*Fj2))))))+(((GdL*d_GdL_dV_D_S)+(d_GdL_dV_D_S*GdL))*(qim-(temp*((1.0-Fj)-(0.2*Fj2))))))+((QCLM*d_GdL_dV_D_S)+(d_QCLM_dV_D_S*(1.0+GdL)))));
        d_QD_dV_GP_S = (0.5*((((GdL*GdL)*(d_qim_dV_GP_S-((temp*((-d_Fj_dV_GP_S)-(0.2*d_Fj2_dV_GP_S)))+(d_temp_dV_GP_S*((1.0-Fj)-(0.2*Fj2))))))+(((GdL*d_GdL_dV_GP_S)+(d_GdL_dV_GP_S*GdL))*(qim-(temp*((1.0-Fj)-(0.2*Fj2))))))+((QCLM*d_GdL_dV_GP_S)+(d_QCLM_dV_GP_S*(1.0+GdL)))));
        QD = (0.5*(((GdL*GdL)*(qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL))));

        d_QB_dV_S_BP = (d_QG_dV_S_BP-d_QI_dV_S_BP);
        d_QB_dV_GP_S = (d_QG_dV_GP_S-d_QI_dV_GP_S);
        d_QB_dV_D_S = (d_QG_dV_D_S-d_QI_dV_D_S);
        QB = (QG-QI);
      }

      d_Qg_dV_S_BP = ((QG*d_COX_qm_dV_S_BP)+(d_QG_dV_S_BP*COX_qm));
      d_Qg_dV_GP_S = ((QG*d_COX_qm_dV_GP_S)+(d_QG_dV_GP_S*COX_qm));
      d_Qg_dV_D_S = ((QG*d_COX_qm_dV_D_S)+(d_QG_dV_D_S*COX_qm));
      Qg = (QG*COX_qm);

      d_Qd_dV_S_BP = (((-QD)*d_COX_qm_dV_S_BP)+((-d_QD_dV_S_BP)*COX_qm));
      d_Qd_dV_D_S = (((-QD)*d_COX_qm_dV_D_S)+((-d_QD_dV_D_S)*COX_qm));
      d_Qd_dV_GP_S = (((-QD)*d_COX_qm_dV_GP_S)+((-d_QD_dV_GP_S)*COX_qm));
      Qd = ((-QD)*COX_qm);

      d_Qb_dV_S_BP = (((-QB)*d_COX_qm_dV_S_BP)+((-d_QB_dV_S_BP)*COX_qm));
      d_Qb_dV_GP_S = (((-QB)*d_COX_qm_dV_GP_S)+((-d_QB_dV_GP_S)*COX_qm));
      d_Qb_dV_D_S = (((-QB)*d_COX_qm_dV_D_S)+((-d_QB_dV_D_S)*COX_qm));
      Qb = ((-QB)*COX_qm);

      d_Qgs_ov_dV_S_BP = (CGOV_i*d_Vovs_dV_S_BP);
      d_Qgs_ov_dV_D_S = (CGOV_i*d_Vovs_dV_D_S);
      d_Qgs_ov_dV_GP_S = (CGOV_i*d_Vovs_dV_GP_S);
      Qgs_ov = (CGOV_i*Vovs);

      d_Qgd_ov_dV_S_BP = (CGOVD_i*d_Vovd_dV_S_BP);
      d_Qgd_ov_dV_D_S = (CGOVD_i*d_Vovd_dV_D_S);
      d_Qgd_ov_dV_GP_S = (CGOVD_i*d_Vovd_dV_GP_S);
      Qgd_ov = (CGOVD_i*Vovd);

      d_Qgb_ov_dV_S_BP = (CGBOV_i*d_Vgb_dV_S_BP);
      d_Qgb_ov_dV_GP_S = (CGBOV_i*d_Vgb_dV_GP_S);
      d_Qgb_ov_dV_D_S = (CGBOV_i*d_Vgb_dV_D_S);
      Qgb_ov = (CGBOV_i*Vgb);

      d_Qfgs_dV_D_S = d_Qfgs_dV_S_BP =  0.0;
      d_Qfgs_dV_GP_S = (CFR_i*d_VgsPrime_dV_GP_S);
      Qfgs = (CFR_i*VgsPrime);

      d_Qfgd_dV_S_BP =  0.0;
      d_Qfgd_dV_D_S = (CFRD_i*d_VgdPrime_dV_D_S);
      d_Qfgd_dV_GP_S = (CFRD_i*d_VgdPrime_dV_GP_S);
      Qfgd = (CFRD_i*VgdPrime);
    }
    // End block evaluateDynamic

    d_ijun_s_dV_D_BD = d_ijun_s_dV_S_BS =  0.0;
    ijun_s = 0.0;

    d_ijunbot_s_dV_S_BS = d_ijunbot_s_dV_D_BD =  0.0;
    ijunbot_s = 0.0;

    d_ijunsti_s_dV_S_BS = d_ijunsti_s_dV_D_BD =  0.0;
    ijunsti_s = 0.0;

    d_ijungat_s_dV_S_BS = d_ijungat_s_dV_D_BD =  0.0;
    ijungat_s = 0.0;

    d_ijun_d_dV_D_BD = d_ijun_d_dV_S_BS =  0.0;
    ijun_d = 0.0;

    d_ijunbot_d_dV_D_BD = d_ijunbot_d_dV_S_BS =  0.0;
    ijunbot_d = 0.0;

    d_ijunsti_d_dV_D_BD = d_ijunsti_d_dV_S_BS =  0.0;
    ijunsti_d = 0.0;

    d_ijungat_d_dV_D_BD = d_ijungat_d_dV_S_BS =  0.0;
    ijungat_d = 0.0;

    d_qjun_s_dV_D_BD = d_qjun_s_dV_S_BS =  0.0;
    qjun_s = 0.0;

    d_qjunbot_s_dV_D_BD = d_qjunbot_s_dV_S_BS =  0.0;
    qjunbot_s = 0.0;

    d_qjunsti_s_dV_D_BD = d_qjunsti_s_dV_S_BS =  0.0;
    qjunsti_s = 0.0;

    d_qjungat_s_dV_D_BD = d_qjungat_s_dV_S_BS =  0.0;
    qjungat_s = 0.0;

    d_qjun_d_dV_D_BD = d_qjun_d_dV_S_BS =  0.0;
    qjun_d = 0.0;

    d_qjunbot_d_dV_D_BD = d_qjunbot_d_dV_S_BS =  0.0;
    qjunbot_d = 0.0;

    d_qjunsti_d_dV_D_BD = d_qjunsti_d_dV_S_BS =  0.0;
    qjunsti_d = 0.0;

    d_qjungat_d_dV_D_BD = d_qjungat_d_dV_S_BS =  0.0;
    qjungat_d = 0.0;
    //Begin block evaluateStaticDynamic
    {
      if (((model_.SWJUNCAP)>0.0))
      {
        if (((model_.SWJUNEXP_i)==1.0))
        {

          d_tm0_dV_D_BD =  0.0;
          d_tm0_dV_S_BS = ((d_Vjun_s_dV_S_BS*(model_.phitdinv))*MFOR1_s);
          tm0 = ((Vjun_s*(model_.phitdinv))*MFOR1_s);
          {
            double value_exp_0 = exp(tm0);
            double  deriv_exp_0_d0 = value_exp_0;

            d_tm1_dV_D_BD =  0.0;
            d_tm1_dV_S_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_S_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf1_s)?(expxhf1_s*d_tm0_dV_S_BS):(deriv_exp_0_d0*(d_tm0_dV_S_BS))));
            tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf1_s)?(expxhf1_s*((tm0-xhighf1_s)+1)):value_exp_0));
          }

          d_ijunfor1_dV_D_BD =  0.0;
          d_ijunfor1_dV_S_BS = (ISATFOR1_s*d_tm1_dV_S_BS);
          ijunfor1 = (ISATFOR1_s*(tm1-1.0));

          d_tm0_dV_D_BD =  0.0;
          d_tm0_dV_S_BS = ((d_Vjun_s_dV_S_BS*(model_.phitdinv))*MFOR2_s);
          tm0 = ((Vjun_s*(model_.phitdinv))*MFOR2_s);
          {
            double value_exp_0 = exp(tm0);
            double  deriv_exp_0_d0 = value_exp_0;

            d_tm1_dV_D_BD =  0.0;
            d_tm1_dV_S_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_S_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf2_s)?(expxhf2_s*d_tm0_dV_S_BS):(deriv_exp_0_d0*(d_tm0_dV_S_BS))));
            tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf2_s)?(expxhf2_s*((tm0-xhighf2_s)+1)):value_exp_0));
          }

          d_ijunfor2_dV_D_BD =  0.0;
          d_ijunfor2_dV_S_BS = (ISATFOR2_s*d_tm1_dV_S_BS);
          ijunfor2 = (ISATFOR2_s*(tm1-1.0));

          d_ijunrev_dV_D_BD = d_ijunrev_dV_S_BS =  0.0;
          ijunrev = 0.0;
          if ((m0flag_s>0))
          {

            d_ijunrev_dV_D_BD =  0.0;
            d_ijunrev_dV_S_BS = ((Vjun_s*(d_Vjun_s_dV_S_BS*MREV_s))+(d_Vjun_s_dV_S_BS*(ISATREV_s+(Vjun_s*MREV_s))));
            ijunrev = (Vjun_s*(ISATREV_s+(Vjun_s*MREV_s)));
          }
          else
          {

            d_tm0_dV_D_BD =  0.0;
            d_tm0_dV_S_BS = (((-d_Vjun_s_dV_S_BS)*(model_.phitdinv))*MREV_s);
            tm0 = (((-Vjun_s)*(model_.phitdinv))*MREV_s);
            {
              double value_exp_0 = exp(tm0);
              double  deriv_exp_0_d0 = value_exp_0;

              d_tm1_dV_D_BD =  0.0;
              d_tm1_dV_S_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_S_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighr_s)?(expxhr_s*d_tm0_dV_S_BS):(deriv_exp_0_d0*(d_tm0_dV_S_BS))));
              tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighr_s)?(expxhr_s*((tm0-xhighr_s)+1)):value_exp_0));
            }

            d_ijunrev_dV_D_BD =  0.0;
            d_ijunrev_dV_S_BS = ((-ISATREV_s)*d_tm1_dV_S_BS);
            ijunrev = ((-ISATREV_s)*(tm1-1.0));
          }

          d_ijun_s_dV_D_BD =  0.0;
          d_ijun_s_dV_S_BS = ((d_ijunfor1_dV_S_BS+d_ijunfor2_dV_S_BS)+d_ijunrev_dV_S_BS);
          ijun_s = ((ijunfor1+ijunfor2)+ijunrev);

          d_tm0_dV_S_BS =  0.0;
          d_tm0_dV_D_BD = ((d_Vjun_d_dV_D_BD*(model_.phitdinv))*MFOR1_d);
          tm0 = ((Vjun_d*(model_.phitdinv))*MFOR1_d);
          {
            double value_exp_0 = exp(tm0);
            double  deriv_exp_0_d0 = value_exp_0;

            d_tm1_dV_S_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_S_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf1_d)?(expxhf1_d*d_tm0_dV_S_BS):(deriv_exp_0_d0*(d_tm0_dV_S_BS))));
            d_tm1_dV_D_BD = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_D_BD)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf1_d)?(expxhf1_d*d_tm0_dV_D_BD):(deriv_exp_0_d0*(d_tm0_dV_D_BD))));
            tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf1_d)?(expxhf1_d*((tm0-xhighf1_d)+1)):value_exp_0));
          }

          d_ijunfor1_dV_S_BS = (ISATFOR1_d*d_tm1_dV_S_BS);
          d_ijunfor1_dV_D_BD = (ISATFOR1_d*d_tm1_dV_D_BD);
          ijunfor1 = (ISATFOR1_d*(tm1-1.0));

          d_tm0_dV_S_BS =  0.0;
          d_tm0_dV_D_BD = ((d_Vjun_d_dV_D_BD*(model_.phitdinv))*MFOR2_d);
          tm0 = ((Vjun_d*(model_.phitdinv))*MFOR2_d);
          {
            double value_exp_0 = exp(tm0);
            double  deriv_exp_0_d0 = value_exp_0;

            d_tm1_dV_S_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_S_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf2_d)?(expxhf2_d*d_tm0_dV_S_BS):(deriv_exp_0_d0*(d_tm0_dV_S_BS))));
            d_tm1_dV_D_BD = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_D_BD)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf2_d)?(expxhf2_d*d_tm0_dV_D_BD):(deriv_exp_0_d0*(d_tm0_dV_D_BD))));
            tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf2_d)?(expxhf2_d*((tm0-xhighf2_d)+1)):value_exp_0));
          }

          d_ijunfor2_dV_S_BS = (ISATFOR2_d*d_tm1_dV_S_BS);
          d_ijunfor2_dV_D_BD = (ISATFOR2_d*d_tm1_dV_D_BD);
          ijunfor2 = (ISATFOR2_d*(tm1-1.0));

          d_ijunrev_dV_D_BD = d_ijunrev_dV_S_BS =  0.0;
          ijunrev = 0.0;
          if ((m0flag_d>0))
          {

            d_ijunrev_dV_S_BS =  0.0;
            d_ijunrev_dV_D_BD = ((Vjun_d*(d_Vjun_d_dV_D_BD*MREV_d))+(d_Vjun_d_dV_D_BD*(ISATREV_d+(Vjun_d*MREV_d))));
            ijunrev = (Vjun_d*(ISATREV_d+(Vjun_d*MREV_d)));
          }
          else
          {

            d_tm0_dV_S_BS =  0.0;
            d_tm0_dV_D_BD = (((-d_Vjun_d_dV_D_BD)*(model_.phitdinv))*MREV_d);
            tm0 = (((-Vjun_d)*(model_.phitdinv))*MREV_d);
            {
              double value_exp_0 = exp(tm0);
              double  deriv_exp_0_d0 = value_exp_0;

              d_tm1_dV_S_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_S_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighr_d)?(expxhr_d*d_tm0_dV_S_BS):(deriv_exp_0_d0*(d_tm0_dV_S_BS))));
              d_tm1_dV_D_BD = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_D_BD)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighr_d)?(expxhr_d*d_tm0_dV_D_BD):(deriv_exp_0_d0*(d_tm0_dV_D_BD))));
              tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighr_d)?(expxhr_d*((tm0-xhighr_d)+1)):value_exp_0));
            }

            d_ijunrev_dV_S_BS = ((-ISATREV_d)*d_tm1_dV_S_BS);
            d_ijunrev_dV_D_BD = ((-ISATREV_d)*d_tm1_dV_D_BD);
            ijunrev = ((-ISATREV_d)*(tm1-1.0));
          }

          d_ijun_d_dV_S_BS = ((d_ijunfor1_dV_S_BS+d_ijunfor2_dV_S_BS)+d_ijunrev_dV_S_BS);
          d_ijun_d_dV_D_BD = ((d_ijunfor1_dV_D_BD+d_ijunfor2_dV_D_BD)+d_ijunrev_dV_D_BD);
          ijun_d = ((ijunfor1+ijunfor2)+ijunrev);
          //Begin block evaluateDynamic
          {
            //Block-local variables for block evaluateDynamic
            double tmpv;
            double d_tmpv_dV_D_BD;
            double d_tmpv_dV_S_BS;
            double vjv;
            double d_vjv_dV_D_BD;
            double d_vjv_dV_S_BS;
            //End of Block-local variables

            d_tmpv_dV_D_BD = d_tmpv_dV_S_BS =  0.0;
            tmpv = 0.0;

            d_vjv_dV_D_BD = d_vjv_dV_S_BS =  0.0;
            vjv = 0.0;
            h1 = ((4.0*vch_s)*vch_s);
            h2 = (vch_s/vfmin_s);

            d_h2d_dV_D_BD =  0.0;
            d_h2d_dV_S_BS = d_Vjun_s_dV_S_BS;
            h2d = (Vjun_s+(vch_s*h2));

            d_h3_dV_D_BD =  0.0;
            d_h3_dV_S_BS = d_h2d_dV_S_BS;
            h3 = (vfmin_s+h2d);

            d_h4_dV_D_BD =  0.0;
            d_h4_dV_S_BS = (-d_h2d_dV_S_BS);
            h4 = (vfmin_s-h2d);
            {
              double value_sqrt_0 = sqrt(((h4*h4)+h1));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_h5_dV_D_BD =  0.0;
              d_h5_dV_S_BS = (deriv_sqrt_0_d0*(((h4*d_h4_dV_S_BS)+(d_h4_dV_S_BS*h4))));
              h5 = value_sqrt_0;
            }

            d_vjv_dV_D_BD =  0.0;
            d_vjv_dV_S_BS = (2.0*(((h3+h5)*(d_Vjun_s_dV_S_BS*vfmin_s)-(Vjun_s*vfmin_s)*(d_h3_dV_S_BS+d_h5_dV_S_BS))/(h3+h5)/(h3+h5)));
            vjv = (2.0*((Vjun_s*vfmin_s)/(h3+h5)));
            if ((zflagbot_s>0.5))
            {
              if (((model_.one_minus_PBOT)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvbot))));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmpv_dV_D_BD =  0.0;
                  d_tmpv_dV_S_BS = (deriv_sqrt_0_d0*((-(d_vjv_dV_S_BS*(model_.vbiinvbot)))));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((1-(vjv*(model_.vbiinvbot))),(model_.one_minus_PBOT));
                  double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvbot))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT)/(1-(vjv*(model_.vbiinvbot)))));

                  d_tmpv_dV_D_BD =  0.0;
                  d_tmpv_dV_S_BS = (deriv_pow_0_d0*((-(d_vjv_dV_S_BS*(model_.vbiinvbot)))));
                  tmpv = value_pow_0;
                }
              }

              d_qjunbot_s_dV_D_BD =  0.0;
              d_qjunbot_s_dV_S_BS = (((model_.qprefbot)*(-d_tmpv_dV_S_BS))+((model_.qpref2bot)*(d_Vjun_s_dV_S_BS-d_vjv_dV_S_BS)));
              qjunbot_s = (((model_.qprefbot)*(1-tmpv))+((model_.qpref2bot)*(Vjun_s-vjv)));
            }
            if ((zflagsti_s>0.5))
            {
              if (((model_.one_minus_PSTI)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvsti))));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmpv_dV_D_BD =  0.0;
                  d_tmpv_dV_S_BS = (deriv_sqrt_0_d0*((-(d_vjv_dV_S_BS*(model_.vbiinvsti)))));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((1-(vjv*(model_.vbiinvsti))),(model_.one_minus_PSTI));
                  double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvsti))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI)/(1-(vjv*(model_.vbiinvsti)))));

                  d_tmpv_dV_D_BD =  0.0;
                  d_tmpv_dV_S_BS = (deriv_pow_0_d0*((-(d_vjv_dV_S_BS*(model_.vbiinvsti)))));
                  tmpv = value_pow_0;
                }
              }

              d_qjunsti_s_dV_D_BD =  0.0;
              d_qjunsti_s_dV_S_BS = (((model_.qprefsti)*(-d_tmpv_dV_S_BS))+((model_.qpref2sti)*(d_Vjun_s_dV_S_BS-d_vjv_dV_S_BS)));
              qjunsti_s = (((model_.qprefsti)*(1-tmpv))+((model_.qpref2sti)*(Vjun_s-vjv)));
            }
            if ((zflaggat_s>0.5))
            {
              if (((model_.one_minus_PGAT)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvgat))));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmpv_dV_D_BD =  0.0;
                  d_tmpv_dV_S_BS = (deriv_sqrt_0_d0*((-(d_vjv_dV_S_BS*(model_.vbiinvgat)))));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((1-(vjv*(model_.vbiinvgat))),(model_.one_minus_PGAT));
                  double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvgat))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT)/(1-(vjv*(model_.vbiinvgat)))));

                  d_tmpv_dV_D_BD =  0.0;
                  d_tmpv_dV_S_BS = (deriv_pow_0_d0*((-(d_vjv_dV_S_BS*(model_.vbiinvgat)))));
                  tmpv = value_pow_0;
                }
              }

              d_qjungat_s_dV_D_BD =  0.0;
              d_qjungat_s_dV_S_BS = (((model_.qprefgat)*(-d_tmpv_dV_S_BS))+((model_.qpref2gat)*(d_Vjun_s_dV_S_BS-d_vjv_dV_S_BS)));
              qjungat_s = (((model_.qprefgat)*(1-tmpv))+((model_.qpref2gat)*(Vjun_s-vjv)));
            }

            d_tmpv_dV_D_BD = d_tmpv_dV_S_BS =  0.0;
            tmpv = 0.0;

            d_vjv_dV_D_BD = d_vjv_dV_S_BS =  0.0;
            vjv = 0.0;
            h1 = ((4.0*vch_d)*vch_d);
            h2 = (vch_d/vfmin_d);

            d_h2d_dV_S_BS =  0.0;
            d_h2d_dV_D_BD = d_Vjun_d_dV_D_BD;
            h2d = (Vjun_d+(vch_d*h2));

            d_h3_dV_S_BS = d_h2d_dV_S_BS;
            d_h3_dV_D_BD = d_h2d_dV_D_BD;
            h3 = (vfmin_d+h2d);

            d_h4_dV_S_BS = (-d_h2d_dV_S_BS);
            d_h4_dV_D_BD = (-d_h2d_dV_D_BD);
            h4 = (vfmin_d-h2d);
            {
              double value_sqrt_0 = sqrt(((h4*h4)+h1));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_h5_dV_S_BS = (deriv_sqrt_0_d0*(((h4*d_h4_dV_S_BS)+(d_h4_dV_S_BS*h4))));
              d_h5_dV_D_BD = (deriv_sqrt_0_d0*(((h4*d_h4_dV_D_BD)+(d_h4_dV_D_BD*h4))));
              h5 = value_sqrt_0;
            }

            d_vjv_dV_S_BS = (2.0*(-(Vjun_d*vfmin_d)*(d_h3_dV_S_BS+d_h5_dV_S_BS)/(h3+h5)/(h3+h5)));
            d_vjv_dV_D_BD = (2.0*(((h3+h5)*(d_Vjun_d_dV_D_BD*vfmin_d)-(Vjun_d*vfmin_d)*(d_h3_dV_D_BD+d_h5_dV_D_BD))/(h3+h5)/(h3+h5)));
            vjv = (2.0*((Vjun_d*vfmin_d)/(h3+h5)));
            if ((zflagbot_d>0.5))
            {
              if (((model_.one_minus_PBOT_d)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvbot_d))));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmpv_dV_S_BS = (deriv_sqrt_0_d0*((-(d_vjv_dV_S_BS*(model_.vbiinvbot_d)))));
                  d_tmpv_dV_D_BD = (deriv_sqrt_0_d0*((-(d_vjv_dV_D_BD*(model_.vbiinvbot_d)))));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((1-(vjv*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
                  double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvbot_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT_d)/(1-(vjv*(model_.vbiinvbot_d)))));

                  d_tmpv_dV_S_BS = (deriv_pow_0_d0*((-(d_vjv_dV_S_BS*(model_.vbiinvbot_d)))));
                  d_tmpv_dV_D_BD = (deriv_pow_0_d0*((-(d_vjv_dV_D_BD*(model_.vbiinvbot_d)))));
                  tmpv = value_pow_0;
                }
              }

              d_qjunbot_d_dV_S_BS = (((model_.qprefbot_d)*(-d_tmpv_dV_S_BS))+((model_.qpref2bot_d)*(-d_vjv_dV_S_BS)));
              d_qjunbot_d_dV_D_BD = (((model_.qprefbot_d)*(-d_tmpv_dV_D_BD))+((model_.qpref2bot_d)*(d_Vjun_d_dV_D_BD-d_vjv_dV_D_BD)));
              qjunbot_d = (((model_.qprefbot_d)*(1-tmpv))+((model_.qpref2bot_d)*(Vjun_d-vjv)));
            }
            if ((zflagsti_d>0.5))
            {
              if (((model_.one_minus_PSTI_d)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvsti_d))));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmpv_dV_S_BS = (deriv_sqrt_0_d0*((-(d_vjv_dV_S_BS*(model_.vbiinvsti_d)))));
                  d_tmpv_dV_D_BD = (deriv_sqrt_0_d0*((-(d_vjv_dV_D_BD*(model_.vbiinvsti_d)))));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((1-(vjv*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
                  double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvsti_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI_d)/(1-(vjv*(model_.vbiinvsti_d)))));

                  d_tmpv_dV_S_BS = (deriv_pow_0_d0*((-(d_vjv_dV_S_BS*(model_.vbiinvsti_d)))));
                  d_tmpv_dV_D_BD = (deriv_pow_0_d0*((-(d_vjv_dV_D_BD*(model_.vbiinvsti_d)))));
                  tmpv = value_pow_0;
                }
              }

              d_qjunsti_d_dV_S_BS = (((model_.qprefsti_d)*(-d_tmpv_dV_S_BS))+((model_.qpref2sti_d)*(-d_vjv_dV_S_BS)));
              d_qjunsti_d_dV_D_BD = (((model_.qprefsti_d)*(-d_tmpv_dV_D_BD))+((model_.qpref2sti_d)*(d_Vjun_d_dV_D_BD-d_vjv_dV_D_BD)));
              qjunsti_d = (((model_.qprefsti_d)*(1-tmpv))+((model_.qpref2sti_d)*(Vjun_d-vjv)));
            }
            if ((zflaggat_d>0.5))
            {
              if (((model_.one_minus_PGAT_d)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvgat_d))));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmpv_dV_S_BS = (deriv_sqrt_0_d0*((-(d_vjv_dV_S_BS*(model_.vbiinvgat_d)))));
                  d_tmpv_dV_D_BD = (deriv_sqrt_0_d0*((-(d_vjv_dV_D_BD*(model_.vbiinvgat_d)))));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((1-(vjv*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
                  double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvgat_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT_d)/(1-(vjv*(model_.vbiinvgat_d)))));

                  d_tmpv_dV_S_BS = (deriv_pow_0_d0*((-(d_vjv_dV_S_BS*(model_.vbiinvgat_d)))));
                  d_tmpv_dV_D_BD = (deriv_pow_0_d0*((-(d_vjv_dV_D_BD*(model_.vbiinvgat_d)))));
                  tmpv = value_pow_0;
                }
              }

              d_qjungat_d_dV_S_BS = (((model_.qprefgat_d)*(-d_tmpv_dV_S_BS))+((model_.qpref2gat_d)*(-d_vjv_dV_S_BS)));
              d_qjungat_d_dV_D_BD = (((model_.qprefgat_d)*(-d_tmpv_dV_D_BD))+((model_.qpref2gat_d)*(d_Vjun_d_dV_D_BD-d_vjv_dV_D_BD)));
              qjungat_d = (((model_.qprefgat_d)*(1-tmpv))+((model_.qpref2gat_d)*(Vjun_d-vjv)));
            }
          }
          // End block evaluateDynamic
        }
        else
        {

          d_vbbt_dV_D_BD = d_vbbt_dV_S_BS =  0.0;
          vbbt = 0.0;

          d_two_psistar_dV_D_BD = d_two_psistar_dV_S_BS =  0.0;
          two_psistar = 0.0;
          if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
          {
            h1 = ((4.0*vch_s)*vch_s);
            h2 = (vch_s/vfmin_s);

            d_h2d_dV_D_BD =  0.0;
            d_h2d_dV_S_BS = d_Vjun_s_dV_S_BS;
            h2d = (Vjun_s+(vch_s*h2));

            d_h3_dV_S_BS = d_h2d_dV_S_BS;
            d_h3_dV_D_BD = d_h2d_dV_D_BD;
            h3 = (vfmin_s+h2d);

            d_h4_dV_S_BS = (-d_h2d_dV_S_BS);
            d_h4_dV_D_BD = (-d_h2d_dV_D_BD);
            h4 = (vfmin_s-h2d);
            {
              double value_sqrt_0 = sqrt(((h4*h4)+h1));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_h5_dV_S_BS = (deriv_sqrt_0_d0*(((h4*d_h4_dV_S_BS)+(d_h4_dV_S_BS*h4))));
              d_h5_dV_D_BD = (deriv_sqrt_0_d0*(((h4*d_h4_dV_D_BD)+(d_h4_dV_D_BD*h4))));
              h5 = value_sqrt_0;
            }

            d_vj_dV_D_BD = (2.0*(-(Vjun_s*vfmin_s)*(d_h3_dV_D_BD+d_h5_dV_D_BD)/(h3+h5)/(h3+h5)));
            d_vj_dV_S_BS = (2.0*(((h3+h5)*(d_Vjun_s_dV_S_BS*vfmin_s)-(Vjun_s*vfmin_s)*(d_h3_dV_S_BS+d_h5_dV_S_BS))/(h3+h5)/(h3+h5)));
            vj = (2.0*((Vjun_s*vfmin_s)/(h3+h5)));
            if ((Vjun_s<VMAX_s))
            {
              if ((fabs((0.5*(Vjun_s*(model_.phitdinv))))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp((0.5*(Vjun_s*(model_.phitdinv))));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_zinv_dV_D_BD =  0.0;
                  d_zinv_dV_S_BS = (deriv_exp_0_d0*((0.5*(d_Vjun_s_dV_S_BS*(model_.phitdinv)))));
                  zinv = value_exp_0;
                }
              }
              else
              {
                if (((0.5*(Vjun_s*(model_.phitdinv)))<(-2.3025850929940458e+02)))
                {

                  d_zinv_dV_D_BD =  0.0;
                  d_zinv_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(0.5*((((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*((-(0.5*(d_Vjun_s_dV_S_BS*(model_.phitdinv))))*3.3333333333333333e-01))+((-(0.5*(d_Vjun_s_dV_S_BS*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01))))))+((-(0.5*(d_Vjun_s_dV_S_BS*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01))))))));
                  zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_zinv_dV_D_BD =  0.0;
                  d_zinv_dV_S_BS = (1.0e100*((((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(0.5*((((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*((0.5*(d_Vjun_s_dV_S_BS*(model_.phitdinv)))*3.3333333333333333e-01))+((0.5*(d_Vjun_s_dV_S_BS*(model_.phitdinv)))*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((0.5*(d_Vjun_s_dV_S_BS*(model_.phitdinv)))*(1.0+(0.5*(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  zinv = (1.0e100*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_idmult_dV_D_BD =  0.0;
              d_idmult_dV_S_BS = ((zinv*d_zinv_dV_S_BS)+(d_zinv_dV_S_BS*zinv));
              idmult = (zinv*zinv);
            }
            else
            {

              d_idmult_dV_D_BD =  0.0;
              d_idmult_dV_S_BS = ((d_Vjun_s_dV_S_BS*(model_.phitdinv))*exp_VMAX_over_phitd_s);
              idmult = ((1+((Vjun_s-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
              {
                double value_sqrt_0 = sqrt(idmult);
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_zinv_dV_D_BD =  0.0;
                d_zinv_dV_S_BS = (deriv_sqrt_0_d0*(d_idmult_dV_S_BS));
                zinv = value_sqrt_0;
              }
            }

            d_idmult_dV_D_BD =  0.0;
            idmult = (idmult-1.0);

            d_z_dV_D_BD =  0.0;
            d_z_dV_S_BS = (-1*d_zinv_dV_S_BS/zinv/zinv);
            z = (1/zinv);
            if ((Vjun_s>0))
            {
              {
                double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
                double value_log_1 = log(((2.0+z)+value_sqrt_0));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
                double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));

                d_two_psistar_dV_D_BD =  0.0;
                d_two_psistar_dV_S_BS = (2.0*((model_.phitd)*(deriv_log_1_d0*((d_z_dV_S_BS+(deriv_sqrt_0_d0*((((z+1.0)*d_z_dV_S_BS)+(d_z_dV_S_BS*(z+3.0))))))))));
                two_psistar = (2.0*((model_.phitd)*value_log_1));
              }
            }
            else
            {
              {
                double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
                double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
                double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));

                d_two_psistar_dV_D_BD =  0.0;
                d_two_psistar_dV_S_BS = ((-d_Vjun_s_dV_S_BS)+(2.0*((model_.phitd)*(deriv_log_1_d0*(((2*d_zinv_dV_S_BS)+(deriv_sqrt_0_d0*((((1+zinv)*(3*d_zinv_dV_S_BS))+(d_zinv_dV_S_BS*(1+(3*zinv))))))))))));
                two_psistar = ((-Vjun_s)+(2.0*((model_.phitd)*value_log_1)));
              }
            }

            d_vjlim_dV_D_BD =  0.0;
            d_vjlim_dV_S_BS = (-d_two_psistar_dV_S_BS);
            vjlim = (vbimin_s-two_psistar);
            {
              double value_sqrt_0 = sqrt((((Vjun_s-vjlim)*(Vjun_s-vjlim))+((4*(model_.phitd))*(model_.phitd))));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_vjsrh_dV_D_BD =  0.0;
              d_vjsrh_dV_S_BS = (0.5*((d_Vjun_s_dV_S_BS+d_vjlim_dV_S_BS)-(deriv_sqrt_0_d0*((((Vjun_s-vjlim)*(d_Vjun_s_dV_S_BS-d_vjlim_dV_S_BS))+((d_Vjun_s_dV_S_BS-d_vjlim_dV_S_BS)*(Vjun_s-vjlim)))))));
              vjsrh = (0.5*((Vjun_s+vjlim)-value_sqrt_0));
            }
            {
              double value_sqrt_0 = sqrt((((Vjun_s-vbbtlim_s)*(Vjun_s-vbbtlim_s))+((4*(model_.phitr))*(model_.phitr))));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_vbbt_dV_D_BD =  0.0;
              d_vbbt_dV_S_BS = (0.5*(d_Vjun_s_dV_S_BS-(deriv_sqrt_0_d0*((((Vjun_s-vbbtlim_s)*d_Vjun_s_dV_S_BS)+(d_Vjun_s_dV_S_BS*(Vjun_s-vbbtlim_s)))))));
              vbbt = (0.5*((Vjun_s+vbbtlim_s)-value_sqrt_0));
            }
            {
              double value_sqrt_0 = sqrt((((Vjun_s)*(Vjun_s))+((4*1E-6)*1E-6)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_vav_dV_D_BD =  0.0;
              d_vav_dV_S_BS = (0.5*((d_Vjun_s_dV_S_BS)-(deriv_sqrt_0_d0*((((Vjun_s)*(d_Vjun_s_dV_S_BS))+((d_Vjun_s_dV_S_BS)*(Vjun_s)))))));
              vav = (0.5*((Vjun_s)-value_sqrt_0));
            }
          }
          if ((ABSOURCE_i==0))
          {

            d_ijunbot_s_dV_S_BS = d_ijunbot_s_dV_D_BD =  0.0;
            ijunbot_s = 0;

            d_qjunbot_s_dV_D_BD = d_qjunbot_s_dV_S_BS =  0.0;
            qjunbot_s = 0;
          }
          else
          {
            if (((model_.one_minus_PBOT)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-(d_vj_dV_D_BD*(model_.vbiinvbot)))));
                d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-(d_vj_dV_S_BS*(model_.vbiinvbot)))));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
                double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvbot))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT)/(1-(vj*(model_.vbiinvbot)))));

                d_tmp_dV_D_BD = (deriv_pow_0_d0*((-(d_vj_dV_D_BD*(model_.vbiinvbot)))));
                d_tmp_dV_S_BS = (deriv_pow_0_d0*((-(d_vj_dV_S_BS*(model_.vbiinvbot)))));
                tmp = value_pow_0;
              }
            }

            d_qjunbot_s_dV_D_BD = (((model_.qprefbot)*(-d_tmp_dV_D_BD))+((model_.qpref2bot)*(-d_vj_dV_D_BD)));
            d_qjunbot_s_dV_S_BS = (((model_.qprefbot)*(-d_tmp_dV_S_BS))+((model_.qpref2bot)*(d_Vjun_s_dV_S_BS-d_vj_dV_S_BS)));
            qjunbot_s = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(Vjun_s-vj)));

            d_id_dV_D_BD =  0.0;
            d_id_dV_S_BS = ((model_.idsatbot)*d_idmult_dV_S_BS);
            id = ((model_.idsatbot)*idmult);
            if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
            {

              d_isrh_dV_S_BS = d_isrh_dV_D_BD =  0.0;
              isrh = 0;
            }
            else
            {

              d_vbi_minus_vjsrh_dV_D_BD =  0.0;
              d_vbi_minus_vjsrh_dV_S_BS = (-d_vjsrh_dV_S_BS);
              vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
              {
                double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_wsrhstep_dV_D_BD =  0.0;
                d_wsrhstep_dV_S_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_S_BS-two_psistar*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                wsrhstep = (1-value_sqrt_0);
              }
              if (((model_.PBOT_i)==0.5))
              {

                d_dwsrh_dV_D_BD = d_dwsrh_dV_S_BS =  0.0;
                dwsrh = 0;
              }
              else
              {
                {
                  double value_log_0 = log(wsrhstep);
                  double  deriv_log_0_d0 = (1.0/wsrhstep);

                  d_dwsrh_dV_D_BD =  0.0;
                  d_dwsrh_dV_S_BS = (((((1-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_S_BS)))+(((wsrhstep*d_wsrhstep_dV_S_BS)+(d_wsrhstep_dV_S_BS*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_S_BS))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_S_BS)*(1-(2*(model_.PBOT_i))));
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
                }
              }

              d_wsrh_dV_D_BD =  0.0;
              d_wsrh_dV_S_BS = (d_wsrhstep_dV_S_BS+d_dwsrh_dV_S_BS);
              wsrh = (wsrhstep+dwsrh);
              if (((model_.PBOT_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_D_BD =  0.0;
                  d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRBOTinv))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
                  double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRBOTinv)) == 0.0)?0.0:(value_pow_0*(model_.PBOT_i)/(vbi_minus_vjsrh*(model_.VBIRBOTinv))));

                  d_tmp_dV_D_BD =  0.0;
                  d_tmp_dV_S_BS = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRBOTinv))));
                  tmp = value_pow_0;
                }
              }

              d_wdep_dV_D_BD = ((model_.wdepnulrbot)*d_tmp_dV_D_BD);
              d_wdep_dV_S_BS = ((model_.wdepnulrbot)*d_tmp_dV_S_BS);
              wdep = ((model_.wdepnulrbot)*tmp);

              d_asrh_dV_D_BD = ((model_.ftdbot)*(((zinv-1)*d_wdep_dV_D_BD)+(d_zinv_dV_D_BD*wdep)));
              d_asrh_dV_S_BS = ((model_.ftdbot)*(((zinv-1)*d_wdep_dV_S_BS)+(d_zinv_dV_S_BS*wdep)));
              asrh = ((model_.ftdbot)*((zinv-1)*wdep));

              d_isrh_dV_D_BD = ((model_.CSRHBOT_i)*((asrh*d_wsrh_dV_D_BD)+(d_asrh_dV_D_BD*wsrh)));
              d_isrh_dV_S_BS = ((model_.CSRHBOT_i)*((asrh*d_wsrh_dV_S_BS)+(d_asrh_dV_S_BS*wsrh)));
              isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
            }
            if (((model_.CTATBOT_i)==0))
            {

              d_itat_dV_S_BS = d_itat_dV_D_BD =  0.0;
              itat = 0;
            }
            else
            {

              d_btat_dV_D_BD = ((model_.btatpartbot)*((vbi_minus_vjsrh*(d_wdep_dV_D_BD*(model_.one_minus_PBOT))-(wdep*(model_.one_minus_PBOT))*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              d_btat_dV_S_BS = ((model_.btatpartbot)*((vbi_minus_vjsrh*(d_wdep_dV_S_BS*(model_.one_minus_PBOT))-(wdep*(model_.one_minus_PBOT))*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));

              d_twoatatoverthreebtat_dV_D_BD = (-(0.666666666666667*(model_.atatbot))*d_btat_dV_D_BD/btat/btat);
              d_twoatatoverthreebtat_dV_S_BS = (-(0.666666666666667*(model_.atatbot))*d_btat_dV_S_BS/btat/btat);
              twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);

              d_umaxbeforelimiting_dV_D_BD = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_D_BD)+(d_twoatatoverthreebtat_dV_D_BD*twoatatoverthreebtat));
              d_umaxbeforelimiting_dV_S_BS = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_S_BS)+(d_twoatatoverthreebtat_dV_S_BS*twoatatoverthreebtat));
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_umax_dV_D_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD)+(d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD)+(d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
                d_umax_dV_S_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS)+(d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS)+(d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
                umax = value_sqrt_0;
              }
              {
                double value_fabs_0 = fabs(umax);
                double value_sqrt_1 = sqrt(value_fabs_0);
                double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_sqrtumax_dV_D_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_D_BD))));
                d_sqrtumax_dV_S_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_S_BS))));
                sqrtumax = value_sqrt_1;
              }

              d_umaxpoweronepointfive_dV_D_BD = ((umax*d_sqrtumax_dV_D_BD)+(d_umax_dV_D_BD*sqrtumax));
              d_umaxpoweronepointfive_dV_S_BS = ((umax*d_sqrtumax_dV_S_BS)+(d_umax_dV_S_BS*sqrtumax));
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
              {

                d_wgamma_dV_D_BD = (-1*((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
                d_wgamma_dV_S_BS = (-1*((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
                wgamma = (1/(1+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
                  double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))/(1+(btat*umaxpoweronepointfive))));

                  d_wgamma_dV_D_BD = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))));
                  d_wgamma_dV_S_BS = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))));
                  wgamma = value_pow_0;
                }
              }

              d_wtat_dV_D_BD = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_D_BD)+(d_wsrh_dV_D_BD*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_D_BD+d_wgamma_dV_D_BD))/(wsrh+wgamma)/(wsrh+wgamma));
              d_wtat_dV_S_BS = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_S_BS)+(d_wsrh_dV_S_BS*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_S_BS+d_wgamma_dV_S_BS))/(wsrh+wgamma)/(wsrh+wgamma));
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_ktat_dV_D_BD = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_D_BD-btat*d_sqrtumax_dV_D_BD)/sqrtumax/sqrtumax))));
                d_ktat_dV_S_BS = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_S_BS-btat*d_sqrtumax_dV_S_BS)/sqrtumax/sqrtumax))));
                ktat = value_sqrt_0;
              }

              d_ltat_dV_D_BD = ((2*((twoatatoverthreebtat*d_sqrtumax_dV_D_BD)+(d_twoatatoverthreebtat_dV_D_BD*sqrtumax)))-d_umax_dV_D_BD);
              d_ltat_dV_S_BS = ((2*((twoatatoverthreebtat*d_sqrtumax_dV_S_BS)+(d_twoatatoverthreebtat_dV_S_BS*sqrtumax)))-d_umax_dV_S_BS);
              ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

              d_mtat_dV_D_BD = ((((((model_.atatbot)*twoatatoverthreebtat)*d_sqrtumax_dV_D_BD)+(((model_.atatbot)*d_twoatatoverthreebtat_dV_D_BD)*sqrtumax))-((model_.atatbot)*d_umax_dV_D_BD))+(0.5*((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))));
              d_mtat_dV_S_BS = ((((((model_.atatbot)*twoatatoverthreebtat)*d_sqrtumax_dV_S_BS)+(((model_.atatbot)*d_twoatatoverthreebtat_dV_S_BS)*sqrtumax))-((model_.atatbot)*d_umax_dV_S_BS))+(0.5*((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))));
              mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));

              d_xerfc_dV_D_BD = (((ltat-1)*d_ktat_dV_D_BD)+(d_ltat_dV_D_BD*ktat));
              d_xerfc_dV_S_BS = (((ltat-1)*d_ktat_dV_S_BS)+(d_ltat_dV_S_BS*ktat));
              xerfc = ((ltat-1)*ktat);

              d_ysq_dV_D_BD = ((xerfc*d_xerfc_dV_D_BD)+(d_xerfc_dV_D_BD*xerfc));
              d_ysq_dV_S_BS = ((xerfc*d_xerfc_dV_S_BS)+(d_xerfc_dV_S_BS*xerfc));
              ysq = (xerfc*xerfc);
              if ((xerfc>0))
              {

                d_terfc_dV_D_BD = (-1*((model_.perfc)*d_xerfc_dV_D_BD)/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
                d_terfc_dV_S_BS = (-1*((model_.perfc)*d_xerfc_dV_S_BS)/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
                terfc = (1/(1+((model_.perfc)*xerfc)));
              }
              else
              {

                d_terfc_dV_D_BD = (-1*(-((model_.perfc)*d_xerfc_dV_D_BD))/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
                d_terfc_dV_S_BS = (-1*(-((model_.perfc)*d_xerfc_dV_S_BS))/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
                terfc = (1/(1-((model_.perfc)*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(((-ysq)+mtat));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_D_BD = (deriv_exp_0_d0*(((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD)));
                  d_tmp_dV_S_BS = (deriv_exp_0_d0*(((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS)));
                  tmp = value_exp_0;
                }
              }
              else
              {

                d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*3.3333333333333333e-01))+((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*3.3333333333333333e-01))+((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }

              d_erfcpos_dV_D_BD = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_D_BD)+((((0.29214664*d_terfc_dV_D_BD)+((model_.berfc)*((terfc*d_terfc_dV_D_BD)+(d_terfc_dV_D_BD*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_D_BD)+(((terfc*d_terfc_dV_D_BD)+(d_terfc_dV_D_BD*terfc))*terfc))))*tmp));
              d_erfcpos_dV_S_BS = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_S_BS)+((((0.29214664*d_terfc_dV_S_BS)+((model_.berfc)*((terfc*d_terfc_dV_S_BS)+(d_terfc_dV_S_BS*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_S_BS)+(((terfc*d_terfc_dV_S_BS)+(d_terfc_dV_S_BS*terfc))*terfc))))*tmp));
              erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0))
              {

                d_erfctimesexpmtat_dV_D_BD = d_erfcpos_dV_D_BD;
                d_erfctimesexpmtat_dV_S_BS = d_erfcpos_dV_S_BS;
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp(mtat);
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_tmp_dV_D_BD = (deriv_exp_0_d0*(d_mtat_dV_D_BD));
                    d_tmp_dV_S_BS = (deriv_exp_0_d0*(d_mtat_dV_S_BS));
                    tmp = value_exp_0;
                  }
                }
                else
                {

                  d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_D_BD)*3.3333333333333333e-01))+((-d_mtat_dV_D_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_D_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_S_BS)*3.3333333333333333e-01))+((-d_mtat_dV_S_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_S_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }

                d_erfctimesexpmtat_dV_D_BD = ((2*d_tmp_dV_D_BD)-d_erfcpos_dV_D_BD);
                d_erfctimesexpmtat_dV_S_BS = ((2*d_tmp_dV_S_BS)-d_erfcpos_dV_S_BS);
                erfctimesexpmtat = ((2*tmp)-erfcpos);
              }

              d_gammamax_dV_D_BD = ((1.77245385090551603*0.5)*((ktat*((model_.atatbot)*d_erfctimesexpmtat_dV_D_BD)-((model_.atatbot)*erfctimesexpmtat)*d_ktat_dV_D_BD)/ktat/ktat));
              d_gammamax_dV_S_BS = ((1.77245385090551603*0.5)*((ktat*((model_.atatbot)*d_erfctimesexpmtat_dV_S_BS)-((model_.atatbot)*erfctimesexpmtat)*d_ktat_dV_S_BS)/ktat/ktat));
              gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));

              d_itat_dV_D_BD = ((model_.CTATBOT_i)*(((asrh*gammamax)*d_wtat_dV_D_BD)+(((asrh*d_gammamax_dV_D_BD)+(d_asrh_dV_D_BD*gammamax))*wtat)));
              d_itat_dV_S_BS = ((model_.CTATBOT_i)*(((asrh*gammamax)*d_wtat_dV_S_BS)+(((asrh*d_gammamax_dV_S_BS)+(d_asrh_dV_S_BS*gammamax))*wtat)));
              itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
            }
            if (((model_.CBBTBOT_i)==0))
            {

              d_ibbt_dV_S_BS = d_ibbt_dV_D_BD =  0.0;
              ibbt = 0;
            }
            else
            {
              if (((model_.PBOT_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_D_BD =  0.0;
                  d_tmp_dV_S_BS = (deriv_sqrt_0_d0*(((-d_vbbt_dV_S_BS)*(model_.VBIRBOTinv))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
                  double  deriv_pow_0_d0 = (((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)) == 0.0)?0.0:(value_pow_0*(model_.PBOT_i)/(((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv))));

                  d_tmp_dV_D_BD =  0.0;
                  d_tmp_dV_S_BS = (deriv_pow_0_d0*(((-d_vbbt_dV_S_BS)*(model_.VBIRBOTinv))));
                  tmp = value_pow_0;
                }
              }

              d_Fmaxr_dV_D_BD = ((model_.one_over_one_minus_PBOT)*((tmp*((-d_vbbt_dV_D_BD)*(model_.wdepnulrinvbot))-(((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))*d_tmp_dV_D_BD)/tmp/tmp));
              d_Fmaxr_dV_S_BS = ((model_.one_over_one_minus_PBOT)*((tmp*((-d_vbbt_dV_S_BS)*(model_.wdepnulrinvbot))-(((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))*d_tmp_dV_S_BS)/tmp/tmp));
              Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
              if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_D_BD = (deriv_exp_0_d0*((-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)));
                  d_tmp_dV_S_BS = (deriv_exp_0_d0*((-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
                {

                  d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*((-(-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*((-(-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_tmp_dV_D_BD = (1.0e100*(((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (1.0e100*(((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_ibbt_dV_D_BD = ((model_.CBBTBOT_i)*((((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_D_BD)+((((Vjun_s*Fmaxr)*d_Fmaxr_dV_D_BD)+((Vjun_s*d_Fmaxr_dV_D_BD)*Fmaxr))*tmp)));
              d_ibbt_dV_S_BS = ((model_.CBBTBOT_i)*((((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_S_BS)+((((Vjun_s*Fmaxr)*d_Fmaxr_dV_S_BS)+(((Vjun_s*d_Fmaxr_dV_S_BS)+(d_Vjun_s_dV_S_BS*Fmaxr))*Fmaxr))*tmp)));
              ibbt = ((model_.CBBTBOT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
            }
            if (((model_.VBRBOT_i)>1000))
            {

              d_fbreakdown_dV_S_BS = d_fbreakdown_dV_D_BD =  0.0;
              fbreakdown = 1;
            }
            else
            {
              if ((vav>((-0.999)*(model_.VBRBOT_i))))
              {
                if (((model_.PBRBOT_i)==4))
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                    double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
                    double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
                    double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));

                    d_tmp_dV_D_BD =  0.0;
                    d_tmp_dV_S_BS = ((((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*((d_vav_dV_S_BS*(model_.VBRinvbot)))))+((((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*((d_vav_dV_S_BS*(model_.VBRinvbot)))))+(((value_fabs_0*(deriv_fabs_1_d0*((d_vav_dV_S_BS*(model_.VBRinvbot)))))+((deriv_fabs_0_d0*((d_vav_dV_S_BS*(model_.VBRinvbot))))*value_fabs_1))*value_fabs_2))*value_fabs_3));
                    tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                  }
                }
                else
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                    double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
                    double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRBOT_i)/value_fabs_0));

                    d_tmp_dV_D_BD =  0.0;
                    d_tmp_dV_S_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_S_BS*(model_.VBRinvbot))))));
                    tmp = value_pow_1;
                  }
                }

                d_fbreakdown_dV_D_BD = (-1*(-d_tmp_dV_D_BD)/(1-tmp)/(1-tmp));
                d_fbreakdown_dV_S_BS = (-1*(-d_tmp_dV_S_BS)/(1-tmp)/(1-tmp));
                fbreakdown = (1/(1-tmp));
              }
              else
              {

                d_fbreakdown_dV_D_BD =  0.0;
                d_fbreakdown_dV_S_BS = (d_vav_dV_S_BS*(model_.slopebot));
                fbreakdown = ((model_.fstopbot)+((vav+(0.999*(model_.VBRBOT_i)))*(model_.slopebot)));
              }
            }

            d_ijunbot_s_dV_D_BD = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_D_BD)+((((d_id_dV_D_BD+d_isrh_dV_D_BD)+d_itat_dV_D_BD)+d_ibbt_dV_D_BD)*fbreakdown));
            d_ijunbot_s_dV_S_BS = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_S_BS)+((((d_id_dV_S_BS+d_isrh_dV_S_BS)+d_itat_dV_S_BS)+d_ibbt_dV_S_BS)*fbreakdown));
            ijunbot_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((LSSOURCE_i==0))
          {

            d_ijunsti_s_dV_S_BS = d_ijunsti_s_dV_D_BD =  0.0;
            ijunsti_s = 0;

            d_qjunsti_s_dV_D_BD = d_qjunsti_s_dV_S_BS =  0.0;
            qjunsti_s = 0;
          }
          else
          {
            if (((model_.one_minus_PSTI)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-(d_vj_dV_D_BD*(model_.vbiinvsti)))));
                d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-(d_vj_dV_S_BS*(model_.vbiinvsti)))));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
                double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvsti))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI)/(1-(vj*(model_.vbiinvsti)))));

                d_tmp_dV_D_BD = (deriv_pow_0_d0*((-(d_vj_dV_D_BD*(model_.vbiinvsti)))));
                d_tmp_dV_S_BS = (deriv_pow_0_d0*((-(d_vj_dV_S_BS*(model_.vbiinvsti)))));
                tmp = value_pow_0;
              }
            }

            d_qjunsti_s_dV_D_BD = (((model_.qprefsti)*(-d_tmp_dV_D_BD))+((model_.qpref2sti)*(-d_vj_dV_D_BD)));
            d_qjunsti_s_dV_S_BS = (((model_.qprefsti)*(-d_tmp_dV_S_BS))+((model_.qpref2sti)*(d_Vjun_s_dV_S_BS-d_vj_dV_S_BS)));
            qjunsti_s = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(Vjun_s-vj)));

            d_id_dV_D_BD =  0.0;
            d_id_dV_S_BS = ((model_.idsatsti)*d_idmult_dV_S_BS);
            id = ((model_.idsatsti)*idmult);
            if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
            {

              d_isrh_dV_S_BS = d_isrh_dV_D_BD =  0.0;
              isrh = 0;
            }
            else
            {

              d_vbi_minus_vjsrh_dV_D_BD =  0.0;
              d_vbi_minus_vjsrh_dV_S_BS = (-d_vjsrh_dV_S_BS);
              vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
              {
                double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_wsrhstep_dV_D_BD =  0.0;
                d_wsrhstep_dV_S_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_S_BS-two_psistar*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                wsrhstep = (1-value_sqrt_0);
              }
              if (((model_.PSTI_i)==0.5))
              {

                d_dwsrh_dV_D_BD = d_dwsrh_dV_S_BS =  0.0;
                dwsrh = 0;
              }
              else
              {
                {
                  double value_log_0 = log(wsrhstep);
                  double  deriv_log_0_d0 = (1.0/wsrhstep);

                  d_dwsrh_dV_D_BD =  0.0;
                  d_dwsrh_dV_S_BS = (((((1-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_S_BS)))+(((wsrhstep*d_wsrhstep_dV_S_BS)+(d_wsrhstep_dV_S_BS*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_S_BS))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_S_BS)*(1-(2*(model_.PSTI_i))));
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
                }
              }

              d_wsrh_dV_D_BD =  0.0;
              d_wsrh_dV_S_BS = (d_wsrhstep_dV_S_BS+d_dwsrh_dV_S_BS);
              wsrh = (wsrhstep+dwsrh);
              if (((model_.PSTI_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_D_BD =  0.0;
                  d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRSTIinv))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
                  double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRSTIinv)) == 0.0)?0.0:(value_pow_0*(model_.PSTI_i)/(vbi_minus_vjsrh*(model_.VBIRSTIinv))));

                  d_tmp_dV_D_BD =  0.0;
                  d_tmp_dV_S_BS = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRSTIinv))));
                  tmp = value_pow_0;
                }
              }

              d_wdep_dV_D_BD = ((model_.wdepnulrsti)*d_tmp_dV_D_BD);
              d_wdep_dV_S_BS = ((model_.wdepnulrsti)*d_tmp_dV_S_BS);
              wdep = ((model_.wdepnulrsti)*tmp);

              d_asrh_dV_D_BD = ((model_.ftdsti)*(((zinv-1)*d_wdep_dV_D_BD)+(d_zinv_dV_D_BD*wdep)));
              d_asrh_dV_S_BS = ((model_.ftdsti)*(((zinv-1)*d_wdep_dV_S_BS)+(d_zinv_dV_S_BS*wdep)));
              asrh = ((model_.ftdsti)*((zinv-1)*wdep));

              d_isrh_dV_D_BD = ((model_.CSRHSTI_i)*((asrh*d_wsrh_dV_D_BD)+(d_asrh_dV_D_BD*wsrh)));
              d_isrh_dV_S_BS = ((model_.CSRHSTI_i)*((asrh*d_wsrh_dV_S_BS)+(d_asrh_dV_S_BS*wsrh)));
              isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
            }
            if (((model_.CTATSTI_i)==0))
            {

              d_itat_dV_S_BS = d_itat_dV_D_BD =  0.0;
              itat = 0;
            }
            else
            {

              d_btat_dV_D_BD = ((model_.btatpartsti)*((vbi_minus_vjsrh*(d_wdep_dV_D_BD*(model_.one_minus_PSTI))-(wdep*(model_.one_minus_PSTI))*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              d_btat_dV_S_BS = ((model_.btatpartsti)*((vbi_minus_vjsrh*(d_wdep_dV_S_BS*(model_.one_minus_PSTI))-(wdep*(model_.one_minus_PSTI))*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));

              d_twoatatoverthreebtat_dV_D_BD = (-(0.666666666666667*(model_.atatsti))*d_btat_dV_D_BD/btat/btat);
              d_twoatatoverthreebtat_dV_S_BS = (-(0.666666666666667*(model_.atatsti))*d_btat_dV_S_BS/btat/btat);
              twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);

              d_umaxbeforelimiting_dV_D_BD = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_D_BD)+(d_twoatatoverthreebtat_dV_D_BD*twoatatoverthreebtat));
              d_umaxbeforelimiting_dV_S_BS = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_S_BS)+(d_twoatatoverthreebtat_dV_S_BS*twoatatoverthreebtat));
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_umax_dV_D_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD)+(d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD)+(d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
                d_umax_dV_S_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS)+(d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS)+(d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
                umax = value_sqrt_0;
              }
              {
                double value_fabs_0 = fabs(umax);
                double value_sqrt_1 = sqrt(value_fabs_0);
                double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_sqrtumax_dV_D_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_D_BD))));
                d_sqrtumax_dV_S_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_S_BS))));
                sqrtumax = value_sqrt_1;
              }

              d_umaxpoweronepointfive_dV_D_BD = ((umax*d_sqrtumax_dV_D_BD)+(d_umax_dV_D_BD*sqrtumax));
              d_umaxpoweronepointfive_dV_S_BS = ((umax*d_sqrtumax_dV_S_BS)+(d_umax_dV_S_BS*sqrtumax));
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
              {

                d_wgamma_dV_D_BD = (-1*((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
                d_wgamma_dV_S_BS = (-1*((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
                wgamma = (1/(1+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
                  double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))/(1+(btat*umaxpoweronepointfive))));

                  d_wgamma_dV_D_BD = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))));
                  d_wgamma_dV_S_BS = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))));
                  wgamma = value_pow_0;
                }
              }

              d_wtat_dV_D_BD = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_D_BD)+(d_wsrh_dV_D_BD*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_D_BD+d_wgamma_dV_D_BD))/(wsrh+wgamma)/(wsrh+wgamma));
              d_wtat_dV_S_BS = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_S_BS)+(d_wsrh_dV_S_BS*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_S_BS+d_wgamma_dV_S_BS))/(wsrh+wgamma)/(wsrh+wgamma));
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_ktat_dV_D_BD = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_D_BD-btat*d_sqrtumax_dV_D_BD)/sqrtumax/sqrtumax))));
                d_ktat_dV_S_BS = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_S_BS-btat*d_sqrtumax_dV_S_BS)/sqrtumax/sqrtumax))));
                ktat = value_sqrt_0;
              }

              d_ltat_dV_D_BD = ((2*((twoatatoverthreebtat*d_sqrtumax_dV_D_BD)+(d_twoatatoverthreebtat_dV_D_BD*sqrtumax)))-d_umax_dV_D_BD);
              d_ltat_dV_S_BS = ((2*((twoatatoverthreebtat*d_sqrtumax_dV_S_BS)+(d_twoatatoverthreebtat_dV_S_BS*sqrtumax)))-d_umax_dV_S_BS);
              ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

              d_mtat_dV_D_BD = ((((((model_.atatsti)*twoatatoverthreebtat)*d_sqrtumax_dV_D_BD)+(((model_.atatsti)*d_twoatatoverthreebtat_dV_D_BD)*sqrtumax))-((model_.atatsti)*d_umax_dV_D_BD))+(0.5*((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))));
              d_mtat_dV_S_BS = ((((((model_.atatsti)*twoatatoverthreebtat)*d_sqrtumax_dV_S_BS)+(((model_.atatsti)*d_twoatatoverthreebtat_dV_S_BS)*sqrtumax))-((model_.atatsti)*d_umax_dV_S_BS))+(0.5*((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))));
              mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));

              d_xerfc_dV_D_BD = (((ltat-1)*d_ktat_dV_D_BD)+(d_ltat_dV_D_BD*ktat));
              d_xerfc_dV_S_BS = (((ltat-1)*d_ktat_dV_S_BS)+(d_ltat_dV_S_BS*ktat));
              xerfc = ((ltat-1)*ktat);

              d_ysq_dV_D_BD = ((xerfc*d_xerfc_dV_D_BD)+(d_xerfc_dV_D_BD*xerfc));
              d_ysq_dV_S_BS = ((xerfc*d_xerfc_dV_S_BS)+(d_xerfc_dV_S_BS*xerfc));
              ysq = (xerfc*xerfc);
              if ((xerfc>0))
              {

                d_terfc_dV_D_BD = (-1*((model_.perfc)*d_xerfc_dV_D_BD)/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
                d_terfc_dV_S_BS = (-1*((model_.perfc)*d_xerfc_dV_S_BS)/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
                terfc = (1/(1+((model_.perfc)*xerfc)));
              }
              else
              {

                d_terfc_dV_D_BD = (-1*(-((model_.perfc)*d_xerfc_dV_D_BD))/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
                d_terfc_dV_S_BS = (-1*(-((model_.perfc)*d_xerfc_dV_S_BS))/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
                terfc = (1/(1-((model_.perfc)*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(((-ysq)+mtat));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_D_BD = (deriv_exp_0_d0*(((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD)));
                  d_tmp_dV_S_BS = (deriv_exp_0_d0*(((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS)));
                  tmp = value_exp_0;
                }
              }
              else
              {

                d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*3.3333333333333333e-01))+((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*3.3333333333333333e-01))+((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }

              d_erfcpos_dV_D_BD = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_D_BD)+((((0.29214664*d_terfc_dV_D_BD)+((model_.berfc)*((terfc*d_terfc_dV_D_BD)+(d_terfc_dV_D_BD*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_D_BD)+(((terfc*d_terfc_dV_D_BD)+(d_terfc_dV_D_BD*terfc))*terfc))))*tmp));
              d_erfcpos_dV_S_BS = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_S_BS)+((((0.29214664*d_terfc_dV_S_BS)+((model_.berfc)*((terfc*d_terfc_dV_S_BS)+(d_terfc_dV_S_BS*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_S_BS)+(((terfc*d_terfc_dV_S_BS)+(d_terfc_dV_S_BS*terfc))*terfc))))*tmp));
              erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0))
              {

                d_erfctimesexpmtat_dV_D_BD = d_erfcpos_dV_D_BD;
                d_erfctimesexpmtat_dV_S_BS = d_erfcpos_dV_S_BS;
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp(mtat);
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_tmp_dV_D_BD = (deriv_exp_0_d0*(d_mtat_dV_D_BD));
                    d_tmp_dV_S_BS = (deriv_exp_0_d0*(d_mtat_dV_S_BS));
                    tmp = value_exp_0;
                  }
                }
                else
                {

                  d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_D_BD)*3.3333333333333333e-01))+((-d_mtat_dV_D_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_D_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_S_BS)*3.3333333333333333e-01))+((-d_mtat_dV_S_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_S_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }

                d_erfctimesexpmtat_dV_D_BD = ((2*d_tmp_dV_D_BD)-d_erfcpos_dV_D_BD);
                d_erfctimesexpmtat_dV_S_BS = ((2*d_tmp_dV_S_BS)-d_erfcpos_dV_S_BS);
                erfctimesexpmtat = ((2*tmp)-erfcpos);
              }

              d_gammamax_dV_D_BD = ((1.77245385090551603*0.5)*((ktat*((model_.atatsti)*d_erfctimesexpmtat_dV_D_BD)-((model_.atatsti)*erfctimesexpmtat)*d_ktat_dV_D_BD)/ktat/ktat));
              d_gammamax_dV_S_BS = ((1.77245385090551603*0.5)*((ktat*((model_.atatsti)*d_erfctimesexpmtat_dV_S_BS)-((model_.atatsti)*erfctimesexpmtat)*d_ktat_dV_S_BS)/ktat/ktat));
              gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));

              d_itat_dV_D_BD = ((model_.CTATSTI_i)*(((asrh*gammamax)*d_wtat_dV_D_BD)+(((asrh*d_gammamax_dV_D_BD)+(d_asrh_dV_D_BD*gammamax))*wtat)));
              d_itat_dV_S_BS = ((model_.CTATSTI_i)*(((asrh*gammamax)*d_wtat_dV_S_BS)+(((asrh*d_gammamax_dV_S_BS)+(d_asrh_dV_S_BS*gammamax))*wtat)));
              itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
            }
            if (((model_.CBBTSTI_i)==0))
            {

              d_ibbt_dV_S_BS = d_ibbt_dV_D_BD =  0.0;
              ibbt = 0;
            }
            else
            {
              if (((model_.PSTI_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_D_BD =  0.0;
                  d_tmp_dV_S_BS = (deriv_sqrt_0_d0*(((-d_vbbt_dV_S_BS)*(model_.VBIRSTIinv))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
                  double  deriv_pow_0_d0 = (((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)) == 0.0)?0.0:(value_pow_0*(model_.PSTI_i)/(((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv))));

                  d_tmp_dV_D_BD =  0.0;
                  d_tmp_dV_S_BS = (deriv_pow_0_d0*(((-d_vbbt_dV_S_BS)*(model_.VBIRSTIinv))));
                  tmp = value_pow_0;
                }
              }

              d_Fmaxr_dV_D_BD = ((model_.one_over_one_minus_PSTI)*((tmp*((-d_vbbt_dV_D_BD)*(model_.wdepnulrinvsti))-(((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))*d_tmp_dV_D_BD)/tmp/tmp));
              d_Fmaxr_dV_S_BS = ((model_.one_over_one_minus_PSTI)*((tmp*((-d_vbbt_dV_S_BS)*(model_.wdepnulrinvsti))-(((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))*d_tmp_dV_S_BS)/tmp/tmp));
              Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
              if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_D_BD = (deriv_exp_0_d0*((-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)));
                  d_tmp_dV_S_BS = (deriv_exp_0_d0*((-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
                {

                  d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*((-(-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*((-(-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_tmp_dV_D_BD = (1.0e100*(((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (1.0e100*(((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_ibbt_dV_D_BD = ((model_.CBBTSTI_i)*((((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_D_BD)+((((Vjun_s*Fmaxr)*d_Fmaxr_dV_D_BD)+((Vjun_s*d_Fmaxr_dV_D_BD)*Fmaxr))*tmp)));
              d_ibbt_dV_S_BS = ((model_.CBBTSTI_i)*((((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_S_BS)+((((Vjun_s*Fmaxr)*d_Fmaxr_dV_S_BS)+(((Vjun_s*d_Fmaxr_dV_S_BS)+(d_Vjun_s_dV_S_BS*Fmaxr))*Fmaxr))*tmp)));
              ibbt = ((model_.CBBTSTI_i)*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
            }
            if (((model_.VBRSTI_i)>1000))
            {

              d_fbreakdown_dV_S_BS = d_fbreakdown_dV_D_BD =  0.0;
              fbreakdown = 1;
            }
            else
            {
              if ((vav>((-0.999)*(model_.VBRSTI_i))))
              {
                if (((model_.PBRSTI_i)==4))
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                    double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
                    double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
                    double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));

                    d_tmp_dV_D_BD =  0.0;
                    d_tmp_dV_S_BS = ((((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*((d_vav_dV_S_BS*(model_.VBRinvsti)))))+((((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*((d_vav_dV_S_BS*(model_.VBRinvsti)))))+(((value_fabs_0*(deriv_fabs_1_d0*((d_vav_dV_S_BS*(model_.VBRinvsti)))))+((deriv_fabs_0_d0*((d_vav_dV_S_BS*(model_.VBRinvsti))))*value_fabs_1))*value_fabs_2))*value_fabs_3));
                    tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                  }
                }
                else
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                    double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
                    double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRSTI_i)/value_fabs_0));

                    d_tmp_dV_D_BD =  0.0;
                    d_tmp_dV_S_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_S_BS*(model_.VBRinvsti))))));
                    tmp = value_pow_1;
                  }
                }

                d_fbreakdown_dV_D_BD = (-1*(-d_tmp_dV_D_BD)/(1-tmp)/(1-tmp));
                d_fbreakdown_dV_S_BS = (-1*(-d_tmp_dV_S_BS)/(1-tmp)/(1-tmp));
                fbreakdown = (1/(1-tmp));
              }
              else
              {

                d_fbreakdown_dV_D_BD =  0.0;
                d_fbreakdown_dV_S_BS = (d_vav_dV_S_BS*(model_.slopesti));
                fbreakdown = ((model_.fstopsti)+((vav+(0.999*(model_.VBRSTI_i)))*(model_.slopesti)));
              }
            }

            d_ijunsti_s_dV_D_BD = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_D_BD)+((((d_id_dV_D_BD+d_isrh_dV_D_BD)+d_itat_dV_D_BD)+d_ibbt_dV_D_BD)*fbreakdown));
            d_ijunsti_s_dV_S_BS = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_S_BS)+((((d_id_dV_S_BS+d_isrh_dV_S_BS)+d_itat_dV_S_BS)+d_ibbt_dV_S_BS)*fbreakdown));
            ijunsti_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((LGSOURCE_i==0))
          {

            d_ijungat_s_dV_S_BS = d_ijungat_s_dV_D_BD =  0.0;
            ijungat_s = 0;

            d_qjungat_s_dV_D_BD = d_qjungat_s_dV_S_BS =  0.0;
            qjungat_s = 0;
          }
          else
          {
            if (((model_.one_minus_PGAT)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-(d_vj_dV_D_BD*(model_.vbiinvgat)))));
                d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-(d_vj_dV_S_BS*(model_.vbiinvgat)))));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
                double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvgat))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT)/(1-(vj*(model_.vbiinvgat)))));

                d_tmp_dV_D_BD = (deriv_pow_0_d0*((-(d_vj_dV_D_BD*(model_.vbiinvgat)))));
                d_tmp_dV_S_BS = (deriv_pow_0_d0*((-(d_vj_dV_S_BS*(model_.vbiinvgat)))));
                tmp = value_pow_0;
              }
            }

            d_qjungat_s_dV_D_BD = (((model_.qprefgat)*(-d_tmp_dV_D_BD))+((model_.qpref2gat)*(-d_vj_dV_D_BD)));
            d_qjungat_s_dV_S_BS = (((model_.qprefgat)*(-d_tmp_dV_S_BS))+((model_.qpref2gat)*(d_Vjun_s_dV_S_BS-d_vj_dV_S_BS)));
            qjungat_s = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(Vjun_s-vj)));

            d_id_dV_D_BD =  0.0;
            d_id_dV_S_BS = ((model_.idsatgat)*d_idmult_dV_S_BS);
            id = ((model_.idsatgat)*idmult);
            if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
            {

              d_isrh_dV_S_BS = d_isrh_dV_D_BD =  0.0;
              isrh = 0;
            }
            else
            {

              d_vbi_minus_vjsrh_dV_D_BD =  0.0;
              d_vbi_minus_vjsrh_dV_S_BS = (-d_vjsrh_dV_S_BS);
              vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
              {
                double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_wsrhstep_dV_D_BD =  0.0;
                d_wsrhstep_dV_S_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_S_BS-two_psistar*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                wsrhstep = (1-value_sqrt_0);
              }
              if (((model_.PGAT_i)==0.5))
              {

                d_dwsrh_dV_D_BD = d_dwsrh_dV_S_BS =  0.0;
                dwsrh = 0;
              }
              else
              {
                {
                  double value_log_0 = log(wsrhstep);
                  double  deriv_log_0_d0 = (1.0/wsrhstep);

                  d_dwsrh_dV_D_BD =  0.0;
                  d_dwsrh_dV_S_BS = (((((1-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_S_BS)))+(((wsrhstep*d_wsrhstep_dV_S_BS)+(d_wsrhstep_dV_S_BS*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_S_BS))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_S_BS)*(1-(2*(model_.PGAT_i))));
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
                }
              }

              d_wsrh_dV_D_BD =  0.0;
              d_wsrh_dV_S_BS = (d_wsrhstep_dV_S_BS+d_dwsrh_dV_S_BS);
              wsrh = (wsrhstep+dwsrh);
              if (((model_.PGAT_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_D_BD =  0.0;
                  d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRGATinv))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
                  double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRGATinv)) == 0.0)?0.0:(value_pow_0*(model_.PGAT_i)/(vbi_minus_vjsrh*(model_.VBIRGATinv))));

                  d_tmp_dV_D_BD =  0.0;
                  d_tmp_dV_S_BS = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRGATinv))));
                  tmp = value_pow_0;
                }
              }

              d_wdep_dV_D_BD = ((model_.wdepnulrgat)*d_tmp_dV_D_BD);
              d_wdep_dV_S_BS = ((model_.wdepnulrgat)*d_tmp_dV_S_BS);
              wdep = ((model_.wdepnulrgat)*tmp);

              d_asrh_dV_D_BD = ((model_.ftdgat)*(((zinv-1)*d_wdep_dV_D_BD)+(d_zinv_dV_D_BD*wdep)));
              d_asrh_dV_S_BS = ((model_.ftdgat)*(((zinv-1)*d_wdep_dV_S_BS)+(d_zinv_dV_S_BS*wdep)));
              asrh = ((model_.ftdgat)*((zinv-1)*wdep));

              d_isrh_dV_D_BD = ((model_.CSRHGAT_i)*((asrh*d_wsrh_dV_D_BD)+(d_asrh_dV_D_BD*wsrh)));
              d_isrh_dV_S_BS = ((model_.CSRHGAT_i)*((asrh*d_wsrh_dV_S_BS)+(d_asrh_dV_S_BS*wsrh)));
              isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
            }
            if (((model_.CTATGAT_i)==0))
            {

              d_itat_dV_S_BS = d_itat_dV_D_BD =  0.0;
              itat = 0;
            }
            else
            {

              d_btat_dV_D_BD = ((model_.btatpartgat)*((vbi_minus_vjsrh*(d_wdep_dV_D_BD*(model_.one_minus_PGAT))-(wdep*(model_.one_minus_PGAT))*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              d_btat_dV_S_BS = ((model_.btatpartgat)*((vbi_minus_vjsrh*(d_wdep_dV_S_BS*(model_.one_minus_PGAT))-(wdep*(model_.one_minus_PGAT))*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));

              d_twoatatoverthreebtat_dV_D_BD = (-(0.666666666666667*(model_.atatgat))*d_btat_dV_D_BD/btat/btat);
              d_twoatatoverthreebtat_dV_S_BS = (-(0.666666666666667*(model_.atatgat))*d_btat_dV_S_BS/btat/btat);
              twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);

              d_umaxbeforelimiting_dV_D_BD = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_D_BD)+(d_twoatatoverthreebtat_dV_D_BD*twoatatoverthreebtat));
              d_umaxbeforelimiting_dV_S_BS = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_S_BS)+(d_twoatatoverthreebtat_dV_S_BS*twoatatoverthreebtat));
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_umax_dV_D_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD)+(d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD)+(d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
                d_umax_dV_S_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS)+(d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS)+(d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
                umax = value_sqrt_0;
              }
              {
                double value_fabs_0 = fabs(umax);
                double value_sqrt_1 = sqrt(value_fabs_0);
                double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_sqrtumax_dV_D_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_D_BD))));
                d_sqrtumax_dV_S_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_S_BS))));
                sqrtumax = value_sqrt_1;
              }

              d_umaxpoweronepointfive_dV_D_BD = ((umax*d_sqrtumax_dV_D_BD)+(d_umax_dV_D_BD*sqrtumax));
              d_umaxpoweronepointfive_dV_S_BS = ((umax*d_sqrtumax_dV_S_BS)+(d_umax_dV_S_BS*sqrtumax));
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
              {

                d_wgamma_dV_D_BD = (-1*((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
                d_wgamma_dV_S_BS = (-1*((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
                wgamma = (1/(1+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
                  double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))/(1+(btat*umaxpoweronepointfive))));

                  d_wgamma_dV_D_BD = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))));
                  d_wgamma_dV_S_BS = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))));
                  wgamma = value_pow_0;
                }
              }

              d_wtat_dV_D_BD = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_D_BD)+(d_wsrh_dV_D_BD*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_D_BD+d_wgamma_dV_D_BD))/(wsrh+wgamma)/(wsrh+wgamma));
              d_wtat_dV_S_BS = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_S_BS)+(d_wsrh_dV_S_BS*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_S_BS+d_wgamma_dV_S_BS))/(wsrh+wgamma)/(wsrh+wgamma));
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_ktat_dV_D_BD = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_D_BD-btat*d_sqrtumax_dV_D_BD)/sqrtumax/sqrtumax))));
                d_ktat_dV_S_BS = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_S_BS-btat*d_sqrtumax_dV_S_BS)/sqrtumax/sqrtumax))));
                ktat = value_sqrt_0;
              }

              d_ltat_dV_D_BD = ((2*((twoatatoverthreebtat*d_sqrtumax_dV_D_BD)+(d_twoatatoverthreebtat_dV_D_BD*sqrtumax)))-d_umax_dV_D_BD);
              d_ltat_dV_S_BS = ((2*((twoatatoverthreebtat*d_sqrtumax_dV_S_BS)+(d_twoatatoverthreebtat_dV_S_BS*sqrtumax)))-d_umax_dV_S_BS);
              ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

              d_mtat_dV_D_BD = ((((((model_.atatgat)*twoatatoverthreebtat)*d_sqrtumax_dV_D_BD)+(((model_.atatgat)*d_twoatatoverthreebtat_dV_D_BD)*sqrtumax))-((model_.atatgat)*d_umax_dV_D_BD))+(0.5*((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))));
              d_mtat_dV_S_BS = ((((((model_.atatgat)*twoatatoverthreebtat)*d_sqrtumax_dV_S_BS)+(((model_.atatgat)*d_twoatatoverthreebtat_dV_S_BS)*sqrtumax))-((model_.atatgat)*d_umax_dV_S_BS))+(0.5*((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))));
              mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));

              d_xerfc_dV_D_BD = (((ltat-1)*d_ktat_dV_D_BD)+(d_ltat_dV_D_BD*ktat));
              d_xerfc_dV_S_BS = (((ltat-1)*d_ktat_dV_S_BS)+(d_ltat_dV_S_BS*ktat));
              xerfc = ((ltat-1)*ktat);

              d_ysq_dV_D_BD = ((xerfc*d_xerfc_dV_D_BD)+(d_xerfc_dV_D_BD*xerfc));
              d_ysq_dV_S_BS = ((xerfc*d_xerfc_dV_S_BS)+(d_xerfc_dV_S_BS*xerfc));
              ysq = (xerfc*xerfc);
              if ((xerfc>0))
              {

                d_terfc_dV_D_BD = (-1*((model_.perfc)*d_xerfc_dV_D_BD)/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
                d_terfc_dV_S_BS = (-1*((model_.perfc)*d_xerfc_dV_S_BS)/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
                terfc = (1/(1+((model_.perfc)*xerfc)));
              }
              else
              {

                d_terfc_dV_D_BD = (-1*(-((model_.perfc)*d_xerfc_dV_D_BD))/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
                d_terfc_dV_S_BS = (-1*(-((model_.perfc)*d_xerfc_dV_S_BS))/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
                terfc = (1/(1-((model_.perfc)*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(((-ysq)+mtat));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_D_BD = (deriv_exp_0_d0*(((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD)));
                  d_tmp_dV_S_BS = (deriv_exp_0_d0*(((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS)));
                  tmp = value_exp_0;
                }
              }
              else
              {

                d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*3.3333333333333333e-01))+((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*3.3333333333333333e-01))+((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }

              d_erfcpos_dV_D_BD = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_D_BD)+((((0.29214664*d_terfc_dV_D_BD)+((model_.berfc)*((terfc*d_terfc_dV_D_BD)+(d_terfc_dV_D_BD*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_D_BD)+(((terfc*d_terfc_dV_D_BD)+(d_terfc_dV_D_BD*terfc))*terfc))))*tmp));
              d_erfcpos_dV_S_BS = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_S_BS)+((((0.29214664*d_terfc_dV_S_BS)+((model_.berfc)*((terfc*d_terfc_dV_S_BS)+(d_terfc_dV_S_BS*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_S_BS)+(((terfc*d_terfc_dV_S_BS)+(d_terfc_dV_S_BS*terfc))*terfc))))*tmp));
              erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0))
              {

                d_erfctimesexpmtat_dV_D_BD = d_erfcpos_dV_D_BD;
                d_erfctimesexpmtat_dV_S_BS = d_erfcpos_dV_S_BS;
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp(mtat);
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_tmp_dV_D_BD = (deriv_exp_0_d0*(d_mtat_dV_D_BD));
                    d_tmp_dV_S_BS = (deriv_exp_0_d0*(d_mtat_dV_S_BS));
                    tmp = value_exp_0;
                  }
                }
                else
                {

                  d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_D_BD)*3.3333333333333333e-01))+((-d_mtat_dV_D_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_D_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_S_BS)*3.3333333333333333e-01))+((-d_mtat_dV_S_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_S_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }

                d_erfctimesexpmtat_dV_D_BD = ((2*d_tmp_dV_D_BD)-d_erfcpos_dV_D_BD);
                d_erfctimesexpmtat_dV_S_BS = ((2*d_tmp_dV_S_BS)-d_erfcpos_dV_S_BS);
                erfctimesexpmtat = ((2*tmp)-erfcpos);
              }

              d_gammamax_dV_D_BD = ((1.77245385090551603*0.5)*((ktat*((model_.atatgat)*d_erfctimesexpmtat_dV_D_BD)-((model_.atatgat)*erfctimesexpmtat)*d_ktat_dV_D_BD)/ktat/ktat));
              d_gammamax_dV_S_BS = ((1.77245385090551603*0.5)*((ktat*((model_.atatgat)*d_erfctimesexpmtat_dV_S_BS)-((model_.atatgat)*erfctimesexpmtat)*d_ktat_dV_S_BS)/ktat/ktat));
              gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));

              d_itat_dV_D_BD = ((model_.CTATGAT_i)*(((asrh*gammamax)*d_wtat_dV_D_BD)+(((asrh*d_gammamax_dV_D_BD)+(d_asrh_dV_D_BD*gammamax))*wtat)));
              d_itat_dV_S_BS = ((model_.CTATGAT_i)*(((asrh*gammamax)*d_wtat_dV_S_BS)+(((asrh*d_gammamax_dV_S_BS)+(d_asrh_dV_S_BS*gammamax))*wtat)));
              itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
            }
            if (((model_.CBBTGAT_i)==0))
            {

              d_ibbt_dV_S_BS = d_ibbt_dV_D_BD =  0.0;
              ibbt = 0;
            }
            else
            {
              if (((model_.PGAT_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_D_BD =  0.0;
                  d_tmp_dV_S_BS = (deriv_sqrt_0_d0*(((-d_vbbt_dV_S_BS)*(model_.VBIRGATinv))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
                  double  deriv_pow_0_d0 = (((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)) == 0.0)?0.0:(value_pow_0*(model_.PGAT_i)/(((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv))));

                  d_tmp_dV_D_BD =  0.0;
                  d_tmp_dV_S_BS = (deriv_pow_0_d0*(((-d_vbbt_dV_S_BS)*(model_.VBIRGATinv))));
                  tmp = value_pow_0;
                }
              }

              d_Fmaxr_dV_D_BD = ((model_.one_over_one_minus_PGAT)*((tmp*((-d_vbbt_dV_D_BD)*(model_.wdepnulrinvgat))-(((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))*d_tmp_dV_D_BD)/tmp/tmp));
              d_Fmaxr_dV_S_BS = ((model_.one_over_one_minus_PGAT)*((tmp*((-d_vbbt_dV_S_BS)*(model_.wdepnulrinvgat))-(((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))*d_tmp_dV_S_BS)/tmp/tmp));
              Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
              if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_D_BD = (deriv_exp_0_d0*((-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)));
                  d_tmp_dV_S_BS = (deriv_exp_0_d0*((-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
                {

                  d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*((-(-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*((-(-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_tmp_dV_D_BD = (1.0e100*(((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (1.0e100*(((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_ibbt_dV_D_BD = ((model_.CBBTGAT_i)*((((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_D_BD)+((((Vjun_s*Fmaxr)*d_Fmaxr_dV_D_BD)+((Vjun_s*d_Fmaxr_dV_D_BD)*Fmaxr))*tmp)));
              d_ibbt_dV_S_BS = ((model_.CBBTGAT_i)*((((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_S_BS)+((((Vjun_s*Fmaxr)*d_Fmaxr_dV_S_BS)+(((Vjun_s*d_Fmaxr_dV_S_BS)+(d_Vjun_s_dV_S_BS*Fmaxr))*Fmaxr))*tmp)));
              ibbt = ((model_.CBBTGAT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
            }
            if (((model_.VBRGAT_i)>1000))
            {

              d_fbreakdown_dV_S_BS = d_fbreakdown_dV_D_BD =  0.0;
              fbreakdown = 1;
            }
            else
            {
              if ((vav>((-0.999)*(model_.VBRGAT_i))))
              {
                if (((model_.PBRGAT_i)==4))
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                    double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
                    double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
                    double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));

                    d_tmp_dV_D_BD =  0.0;
                    d_tmp_dV_S_BS = ((((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*((d_vav_dV_S_BS*(model_.VBRinvgat)))))+((((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*((d_vav_dV_S_BS*(model_.VBRinvgat)))))+(((value_fabs_0*(deriv_fabs_1_d0*((d_vav_dV_S_BS*(model_.VBRinvgat)))))+((deriv_fabs_0_d0*((d_vav_dV_S_BS*(model_.VBRinvgat))))*value_fabs_1))*value_fabs_2))*value_fabs_3));
                    tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                  }
                }
                else
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                    double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
                    double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRGAT_i)/value_fabs_0));

                    d_tmp_dV_D_BD =  0.0;
                    d_tmp_dV_S_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_S_BS*(model_.VBRinvgat))))));
                    tmp = value_pow_1;
                  }
                }

                d_fbreakdown_dV_D_BD = (-1*(-d_tmp_dV_D_BD)/(1-tmp)/(1-tmp));
                d_fbreakdown_dV_S_BS = (-1*(-d_tmp_dV_S_BS)/(1-tmp)/(1-tmp));
                fbreakdown = (1/(1-tmp));
              }
              else
              {

                d_fbreakdown_dV_D_BD =  0.0;
                d_fbreakdown_dV_S_BS = (d_vav_dV_S_BS*(model_.slopegat));
                fbreakdown = ((model_.fstopgat)+((vav+(0.999*(model_.VBRGAT_i)))*(model_.slopegat)));
              }
            }

            d_ijungat_s_dV_D_BD = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_D_BD)+((((d_id_dV_D_BD+d_isrh_dV_D_BD)+d_itat_dV_D_BD)+d_ibbt_dV_D_BD)*fbreakdown));
            d_ijungat_s_dV_S_BS = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_S_BS)+((((d_id_dV_S_BS+d_isrh_dV_S_BS)+d_itat_dV_S_BS)+d_ibbt_dV_S_BS)*fbreakdown));
            ijungat_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }

          d_ijun_s_dV_D_BD = (((ABSOURCE_i*d_ijunbot_s_dV_D_BD)+(LSSOURCE_i*d_ijunsti_s_dV_D_BD))+(LGSOURCE_i*d_ijungat_s_dV_D_BD));
          d_ijun_s_dV_S_BS = (((ABSOURCE_i*d_ijunbot_s_dV_S_BS)+(LSSOURCE_i*d_ijunsti_s_dV_S_BS))+(LGSOURCE_i*d_ijungat_s_dV_S_BS));
          ijun_s = (((ABSOURCE_i*ijunbot_s)+(LSSOURCE_i*ijunsti_s))+(LGSOURCE_i*ijungat_s));

          d_vbbt_dV_D_BD = d_vbbt_dV_S_BS =  0.0;
          vbbt = 0.0;

          d_two_psistar_dV_D_BD = d_two_psistar_dV_S_BS =  0.0;
          two_psistar = 0.0;
          if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
          {
            h1 = ((4.0*vch_d)*vch_d);
            h2 = (vch_d/vfmin_d);

            d_h2d_dV_S_BS =  0.0;
            d_h2d_dV_D_BD = d_Vjun_d_dV_D_BD;
            h2d = (Vjun_d+(vch_d*h2));

            d_h3_dV_S_BS = d_h2d_dV_S_BS;
            d_h3_dV_D_BD = d_h2d_dV_D_BD;
            h3 = (vfmin_d+h2d);

            d_h4_dV_S_BS = (-d_h2d_dV_S_BS);
            d_h4_dV_D_BD = (-d_h2d_dV_D_BD);
            h4 = (vfmin_d-h2d);
            {
              double value_sqrt_0 = sqrt(((h4*h4)+h1));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_h5_dV_S_BS = (deriv_sqrt_0_d0*(((h4*d_h4_dV_S_BS)+(d_h4_dV_S_BS*h4))));
              d_h5_dV_D_BD = (deriv_sqrt_0_d0*(((h4*d_h4_dV_D_BD)+(d_h4_dV_D_BD*h4))));
              h5 = value_sqrt_0;
            }

            d_vj_dV_S_BS = (2.0*(-(Vjun_d*vfmin_d)*(d_h3_dV_S_BS+d_h5_dV_S_BS)/(h3+h5)/(h3+h5)));
            d_vj_dV_D_BD = (2.0*(((h3+h5)*(d_Vjun_d_dV_D_BD*vfmin_d)-(Vjun_d*vfmin_d)*(d_h3_dV_D_BD+d_h5_dV_D_BD))/(h3+h5)/(h3+h5)));
            vj = (2.0*((Vjun_d*vfmin_d)/(h3+h5)));
            if ((Vjun_d<VMAX_d))
            {
              if ((fabs((0.5*(Vjun_d*(model_.phitdinv))))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp((0.5*(Vjun_d*(model_.phitdinv))));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_zinv_dV_S_BS =  0.0;
                  d_zinv_dV_D_BD = (deriv_exp_0_d0*((0.5*(d_Vjun_d_dV_D_BD*(model_.phitdinv)))));
                  zinv = value_exp_0;
                }
              }
              else
              {
                if (((0.5*(Vjun_d*(model_.phitdinv)))<(-2.3025850929940458e+02)))
                {

                  d_zinv_dV_S_BS =  0.0;
                  d_zinv_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(0.5*((((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*((-(0.5*(d_Vjun_d_dV_D_BD*(model_.phitdinv))))*3.3333333333333333e-01))+((-(0.5*(d_Vjun_d_dV_D_BD*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01))))))+((-(0.5*(d_Vjun_d_dV_D_BD*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01))))))));
                  zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_zinv_dV_S_BS =  0.0;
                  d_zinv_dV_D_BD = (1.0e100*((((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(0.5*((((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*((0.5*(d_Vjun_d_dV_D_BD*(model_.phitdinv)))*3.3333333333333333e-01))+((0.5*(d_Vjun_d_dV_D_BD*(model_.phitdinv)))*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((0.5*(d_Vjun_d_dV_D_BD*(model_.phitdinv)))*(1.0+(0.5*(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  zinv = (1.0e100*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_idmult_dV_S_BS = ((zinv*d_zinv_dV_S_BS)+(d_zinv_dV_S_BS*zinv));
              d_idmult_dV_D_BD = ((zinv*d_zinv_dV_D_BD)+(d_zinv_dV_D_BD*zinv));
              idmult = (zinv*zinv);
            }
            else
            {

              d_idmult_dV_S_BS =  0.0;
              d_idmult_dV_D_BD = ((d_Vjun_d_dV_D_BD*(model_.phitdinv))*exp_VMAX_over_phitd_d);
              idmult = ((1+((Vjun_d-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
              {
                double value_sqrt_0 = sqrt(idmult);
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_zinv_dV_S_BS = (deriv_sqrt_0_d0*(d_idmult_dV_S_BS));
                d_zinv_dV_D_BD = (deriv_sqrt_0_d0*(d_idmult_dV_D_BD));
                zinv = value_sqrt_0;
              }
            }

            idmult = (idmult-1.0);

            d_z_dV_S_BS = (-1*d_zinv_dV_S_BS/zinv/zinv);
            d_z_dV_D_BD = (-1*d_zinv_dV_D_BD/zinv/zinv);
            z = (1/zinv);
            if ((Vjun_d>0))
            {
              {
                double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
                double value_log_1 = log(((2.0+z)+value_sqrt_0));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
                double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));

                d_two_psistar_dV_S_BS = (2.0*((model_.phitd)*(deriv_log_1_d0*((d_z_dV_S_BS+(deriv_sqrt_0_d0*((((z+1.0)*d_z_dV_S_BS)+(d_z_dV_S_BS*(z+3.0))))))))));
                d_two_psistar_dV_D_BD = (2.0*((model_.phitd)*(deriv_log_1_d0*((d_z_dV_D_BD+(deriv_sqrt_0_d0*((((z+1.0)*d_z_dV_D_BD)+(d_z_dV_D_BD*(z+3.0))))))))));
                two_psistar = (2.0*((model_.phitd)*value_log_1));
              }
            }
            else
            {
              {
                double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
                double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
                double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));

                d_two_psistar_dV_S_BS = (2.0*((model_.phitd)*(deriv_log_1_d0*(((2*d_zinv_dV_S_BS)+(deriv_sqrt_0_d0*((((1+zinv)*(3*d_zinv_dV_S_BS))+(d_zinv_dV_S_BS*(1+(3*zinv)))))))))));
                d_two_psistar_dV_D_BD = ((-d_Vjun_d_dV_D_BD)+(2.0*((model_.phitd)*(deriv_log_1_d0*(((2*d_zinv_dV_D_BD)+(deriv_sqrt_0_d0*((((1+zinv)*(3*d_zinv_dV_D_BD))+(d_zinv_dV_D_BD*(1+(3*zinv))))))))))));
                two_psistar = ((-Vjun_d)+(2.0*((model_.phitd)*value_log_1)));
              }
            }

            d_vjlim_dV_S_BS = (-d_two_psistar_dV_S_BS);
            d_vjlim_dV_D_BD = (-d_two_psistar_dV_D_BD);
            vjlim = (vbimin_d-two_psistar);
            {
              double value_sqrt_0 = sqrt((((Vjun_d-vjlim)*(Vjun_d-vjlim))+((4*(model_.phitd))*(model_.phitd))));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_vjsrh_dV_S_BS = (0.5*(d_vjlim_dV_S_BS-(deriv_sqrt_0_d0*((((Vjun_d-vjlim)*(-d_vjlim_dV_S_BS))+((-d_vjlim_dV_S_BS)*(Vjun_d-vjlim)))))));
              d_vjsrh_dV_D_BD = (0.5*((d_Vjun_d_dV_D_BD+d_vjlim_dV_D_BD)-(deriv_sqrt_0_d0*((((Vjun_d-vjlim)*(d_Vjun_d_dV_D_BD-d_vjlim_dV_D_BD))+((d_Vjun_d_dV_D_BD-d_vjlim_dV_D_BD)*(Vjun_d-vjlim)))))));
              vjsrh = (0.5*((Vjun_d+vjlim)-value_sqrt_0));
            }
            {
              double value_sqrt_0 = sqrt((((Vjun_d-vbbtlim_d)*(Vjun_d-vbbtlim_d))+((4*(model_.phitr))*(model_.phitr))));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_vbbt_dV_S_BS =  0.0;
              d_vbbt_dV_D_BD = (0.5*(d_Vjun_d_dV_D_BD-(deriv_sqrt_0_d0*((((Vjun_d-vbbtlim_d)*d_Vjun_d_dV_D_BD)+(d_Vjun_d_dV_D_BD*(Vjun_d-vbbtlim_d)))))));
              vbbt = (0.5*((Vjun_d+vbbtlim_d)-value_sqrt_0));
            }
            {
              double value_sqrt_0 = sqrt((((Vjun_d)*(Vjun_d))+((4*1E-6)*1E-6)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_vav_dV_S_BS =  0.0;
              d_vav_dV_D_BD = (0.5*((d_Vjun_d_dV_D_BD)-(deriv_sqrt_0_d0*((((Vjun_d)*(d_Vjun_d_dV_D_BD))+((d_Vjun_d_dV_D_BD)*(Vjun_d)))))));
              vav = (0.5*((Vjun_d)-value_sqrt_0));
            }
          }
          if ((ABDRAIN_i==0))
          {

            d_ijunbot_d_dV_D_BD = d_ijunbot_d_dV_S_BS =  0.0;
            ijunbot_d = 0;

            d_qjunbot_d_dV_D_BD = d_qjunbot_d_dV_S_BS =  0.0;
            qjunbot_d = 0;
          }
          else
          {
            if (((model_.one_minus_PBOT_d)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot_d))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-(d_vj_dV_D_BD*(model_.vbiinvbot_d)))));
                d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-(d_vj_dV_S_BS*(model_.vbiinvbot_d)))));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((1-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
                double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvbot_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT_d)/(1-(vj*(model_.vbiinvbot_d)))));

                d_tmp_dV_D_BD = (deriv_pow_0_d0*((-(d_vj_dV_D_BD*(model_.vbiinvbot_d)))));
                d_tmp_dV_S_BS = (deriv_pow_0_d0*((-(d_vj_dV_S_BS*(model_.vbiinvbot_d)))));
                tmp = value_pow_0;
              }
            }

            d_qjunbot_d_dV_D_BD = (((model_.qprefbot_d)*(-d_tmp_dV_D_BD))+((model_.qpref2bot_d)*(d_Vjun_d_dV_D_BD-d_vj_dV_D_BD)));
            d_qjunbot_d_dV_S_BS = (((model_.qprefbot_d)*(-d_tmp_dV_S_BS))+((model_.qpref2bot_d)*(-d_vj_dV_S_BS)));
            qjunbot_d = (((model_.qprefbot_d)*(1-tmp))+((model_.qpref2bot_d)*(Vjun_d-vj)));

            d_id_dV_S_BS = ((model_.idsatbot_d)*d_idmult_dV_S_BS);
            d_id_dV_D_BD = ((model_.idsatbot_d)*d_idmult_dV_D_BD);
            id = ((model_.idsatbot_d)*idmult);
            if ((((model_.CSRHBOTD_i)==0)&&((model_.CTATBOTD_i)==0)))
            {

              d_isrh_dV_S_BS = d_isrh_dV_D_BD =  0.0;
              isrh = 0;
            }
            else
            {

              d_vbi_minus_vjsrh_dV_S_BS = (-d_vjsrh_dV_S_BS);
              d_vbi_minus_vjsrh_dV_D_BD = (-d_vjsrh_dV_D_BD);
              vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
              {
                double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_wsrhstep_dV_S_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_S_BS-two_psistar*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                d_wsrhstep_dV_D_BD = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_D_BD-two_psistar*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                wsrhstep = (1-value_sqrt_0);
              }
              if (((model_.PBOTD_i)==0.5))
              {

                d_dwsrh_dV_D_BD = d_dwsrh_dV_S_BS =  0.0;
                dwsrh = 0;
              }
              else
              {
                {
                  double value_log_0 = log(wsrhstep);
                  double  deriv_log_0_d0 = (1.0/wsrhstep);

                  d_dwsrh_dV_S_BS = (((((1-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_S_BS)))+(((wsrhstep*d_wsrhstep_dV_S_BS)+(d_wsrhstep_dV_S_BS*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_S_BS))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_S_BS)*(1-(2*(model_.PBOTD_i))));
                  d_dwsrh_dV_D_BD = (((((1-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_D_BD)))+(((wsrhstep*d_wsrhstep_dV_D_BD)+(d_wsrhstep_dV_D_BD*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_D_BD))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_D_BD)*(1-(2*(model_.PBOTD_i))));
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOTD_i))));
                }
              }

              d_wsrh_dV_S_BS = (d_wsrhstep_dV_S_BS+d_dwsrh_dV_S_BS);
              d_wsrh_dV_D_BD = (d_wsrhstep_dV_D_BD+d_dwsrh_dV_D_BD);
              wsrh = (wsrhstep+dwsrh);
              if (((model_.PBOTD_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRBOTinv_d))));
                  d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_D_BD*(model_.VBIRBOTinv_d))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                  double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PBOTD_i)/(vbi_minus_vjsrh*(model_.VBIRBOTinv_d))));

                  d_tmp_dV_S_BS = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRBOTinv_d))));
                  d_tmp_dV_D_BD = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_D_BD*(model_.VBIRBOTinv_d))));
                  tmp = value_pow_0;
                }
              }

              d_wdep_dV_D_BD = ((model_.wdepnulrbot_d)*d_tmp_dV_D_BD);
              d_wdep_dV_S_BS = ((model_.wdepnulrbot_d)*d_tmp_dV_S_BS);
              wdep = ((model_.wdepnulrbot_d)*tmp);

              d_asrh_dV_S_BS = ((model_.ftdbot_d)*(((zinv-1)*d_wdep_dV_S_BS)+(d_zinv_dV_S_BS*wdep)));
              d_asrh_dV_D_BD = ((model_.ftdbot_d)*(((zinv-1)*d_wdep_dV_D_BD)+(d_zinv_dV_D_BD*wdep)));
              asrh = ((model_.ftdbot_d)*((zinv-1)*wdep));

              d_isrh_dV_D_BD = ((model_.CSRHBOTD_i)*((asrh*d_wsrh_dV_D_BD)+(d_asrh_dV_D_BD*wsrh)));
              d_isrh_dV_S_BS = ((model_.CSRHBOTD_i)*((asrh*d_wsrh_dV_S_BS)+(d_asrh_dV_S_BS*wsrh)));
              isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
            }
            if (((model_.CTATBOTD_i)==0))
            {

              d_itat_dV_S_BS = d_itat_dV_D_BD =  0.0;
              itat = 0;
            }
            else
            {

              d_btat_dV_D_BD = ((model_.btatpartbot_d)*((vbi_minus_vjsrh*(d_wdep_dV_D_BD*(model_.one_minus_PBOT_d))-(wdep*(model_.one_minus_PBOT_d))*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              d_btat_dV_S_BS = ((model_.btatpartbot_d)*((vbi_minus_vjsrh*(d_wdep_dV_S_BS*(model_.one_minus_PBOT_d))-(wdep*(model_.one_minus_PBOT_d))*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));

              d_twoatatoverthreebtat_dV_D_BD = (-(0.666666666666667*(model_.atatbot_d))*d_btat_dV_D_BD/btat/btat);
              d_twoatatoverthreebtat_dV_S_BS = (-(0.666666666666667*(model_.atatbot_d))*d_btat_dV_S_BS/btat/btat);
              twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);

              d_umaxbeforelimiting_dV_D_BD = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_D_BD)+(d_twoatatoverthreebtat_dV_D_BD*twoatatoverthreebtat));
              d_umaxbeforelimiting_dV_S_BS = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_S_BS)+(d_twoatatoverthreebtat_dV_S_BS*twoatatoverthreebtat));
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_umax_dV_D_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD)+(d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD)+(d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
                d_umax_dV_S_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS)+(d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS)+(d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
                umax = value_sqrt_0;
              }
              {
                double value_fabs_0 = fabs(umax);
                double value_sqrt_1 = sqrt(value_fabs_0);
                double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_sqrtumax_dV_D_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_D_BD))));
                d_sqrtumax_dV_S_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_S_BS))));
                sqrtumax = value_sqrt_1;
              }

              d_umaxpoweronepointfive_dV_D_BD = ((umax*d_sqrtumax_dV_D_BD)+(d_umax_dV_D_BD*sqrtumax));
              d_umaxpoweronepointfive_dV_S_BS = ((umax*d_sqrtumax_dV_S_BS)+(d_umax_dV_S_BS*sqrtumax));
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1)))
              {

                d_wgamma_dV_D_BD = (-1*((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
                d_wgamma_dV_S_BS = (-1*((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
                wgamma = (1/(1+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
                  double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))/(1+(btat*umaxpoweronepointfive))));

                  d_wgamma_dV_D_BD = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))));
                  d_wgamma_dV_S_BS = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))));
                  wgamma = value_pow_0;
                }
              }

              d_wtat_dV_S_BS = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_S_BS)+(d_wsrh_dV_S_BS*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_S_BS+d_wgamma_dV_S_BS))/(wsrh+wgamma)/(wsrh+wgamma));
              d_wtat_dV_D_BD = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_D_BD)+(d_wsrh_dV_D_BD*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_D_BD+d_wgamma_dV_D_BD))/(wsrh+wgamma)/(wsrh+wgamma));
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_ktat_dV_D_BD = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_D_BD-btat*d_sqrtumax_dV_D_BD)/sqrtumax/sqrtumax))));
                d_ktat_dV_S_BS = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_S_BS-btat*d_sqrtumax_dV_S_BS)/sqrtumax/sqrtumax))));
                ktat = value_sqrt_0;
              }

              d_ltat_dV_D_BD = ((2*((twoatatoverthreebtat*d_sqrtumax_dV_D_BD)+(d_twoatatoverthreebtat_dV_D_BD*sqrtumax)))-d_umax_dV_D_BD);
              d_ltat_dV_S_BS = ((2*((twoatatoverthreebtat*d_sqrtumax_dV_S_BS)+(d_twoatatoverthreebtat_dV_S_BS*sqrtumax)))-d_umax_dV_S_BS);
              ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

              d_mtat_dV_D_BD = ((((((model_.atatbot_d)*twoatatoverthreebtat)*d_sqrtumax_dV_D_BD)+(((model_.atatbot_d)*d_twoatatoverthreebtat_dV_D_BD)*sqrtumax))-((model_.atatbot_d)*d_umax_dV_D_BD))+(0.5*((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))));
              d_mtat_dV_S_BS = ((((((model_.atatbot_d)*twoatatoverthreebtat)*d_sqrtumax_dV_S_BS)+(((model_.atatbot_d)*d_twoatatoverthreebtat_dV_S_BS)*sqrtumax))-((model_.atatbot_d)*d_umax_dV_S_BS))+(0.5*((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))));
              mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));

              d_xerfc_dV_D_BD = (((ltat-1)*d_ktat_dV_D_BD)+(d_ltat_dV_D_BD*ktat));
              d_xerfc_dV_S_BS = (((ltat-1)*d_ktat_dV_S_BS)+(d_ltat_dV_S_BS*ktat));
              xerfc = ((ltat-1)*ktat);

              d_ysq_dV_D_BD = ((xerfc*d_xerfc_dV_D_BD)+(d_xerfc_dV_D_BD*xerfc));
              d_ysq_dV_S_BS = ((xerfc*d_xerfc_dV_S_BS)+(d_xerfc_dV_S_BS*xerfc));
              ysq = (xerfc*xerfc);
              if ((xerfc>0))
              {

                d_terfc_dV_D_BD = (-1*((model_.perfc)*d_xerfc_dV_D_BD)/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
                d_terfc_dV_S_BS = (-1*((model_.perfc)*d_xerfc_dV_S_BS)/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
                terfc = (1/(1+((model_.perfc)*xerfc)));
              }
              else
              {

                d_terfc_dV_D_BD = (-1*(-((model_.perfc)*d_xerfc_dV_D_BD))/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
                d_terfc_dV_S_BS = (-1*(-((model_.perfc)*d_xerfc_dV_S_BS))/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
                terfc = (1/(1-((model_.perfc)*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(((-ysq)+mtat));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_D_BD = (deriv_exp_0_d0*(((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD)));
                  d_tmp_dV_S_BS = (deriv_exp_0_d0*(((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS)));
                  tmp = value_exp_0;
                }
              }
              else
              {

                d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*3.3333333333333333e-01))+((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*3.3333333333333333e-01))+((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }

              d_erfcpos_dV_D_BD = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_D_BD)+((((0.29214664*d_terfc_dV_D_BD)+((model_.berfc)*((terfc*d_terfc_dV_D_BD)+(d_terfc_dV_D_BD*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_D_BD)+(((terfc*d_terfc_dV_D_BD)+(d_terfc_dV_D_BD*terfc))*terfc))))*tmp));
              d_erfcpos_dV_S_BS = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_S_BS)+((((0.29214664*d_terfc_dV_S_BS)+((model_.berfc)*((terfc*d_terfc_dV_S_BS)+(d_terfc_dV_S_BS*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_S_BS)+(((terfc*d_terfc_dV_S_BS)+(d_terfc_dV_S_BS*terfc))*terfc))))*tmp));
              erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0))
              {

                d_erfctimesexpmtat_dV_D_BD = d_erfcpos_dV_D_BD;
                d_erfctimesexpmtat_dV_S_BS = d_erfcpos_dV_S_BS;
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp(mtat);
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_tmp_dV_D_BD = (deriv_exp_0_d0*(d_mtat_dV_D_BD));
                    d_tmp_dV_S_BS = (deriv_exp_0_d0*(d_mtat_dV_S_BS));
                    tmp = value_exp_0;
                  }
                }
                else
                {

                  d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_D_BD)*3.3333333333333333e-01))+((-d_mtat_dV_D_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_D_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_S_BS)*3.3333333333333333e-01))+((-d_mtat_dV_S_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_S_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }

                d_erfctimesexpmtat_dV_D_BD = ((2*d_tmp_dV_D_BD)-d_erfcpos_dV_D_BD);
                d_erfctimesexpmtat_dV_S_BS = ((2*d_tmp_dV_S_BS)-d_erfcpos_dV_S_BS);
                erfctimesexpmtat = ((2*tmp)-erfcpos);
              }

              d_gammamax_dV_D_BD = ((1.77245385090551603*0.5)*((ktat*((model_.atatbot_d)*d_erfctimesexpmtat_dV_D_BD)-((model_.atatbot_d)*erfctimesexpmtat)*d_ktat_dV_D_BD)/ktat/ktat));
              d_gammamax_dV_S_BS = ((1.77245385090551603*0.5)*((ktat*((model_.atatbot_d)*d_erfctimesexpmtat_dV_S_BS)-((model_.atatbot_d)*erfctimesexpmtat)*d_ktat_dV_S_BS)/ktat/ktat));
              gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));

              d_itat_dV_D_BD = ((model_.CTATBOTD_i)*(((asrh*gammamax)*d_wtat_dV_D_BD)+(((asrh*d_gammamax_dV_D_BD)+(d_asrh_dV_D_BD*gammamax))*wtat)));
              d_itat_dV_S_BS = ((model_.CTATBOTD_i)*(((asrh*gammamax)*d_wtat_dV_S_BS)+(((asrh*d_gammamax_dV_S_BS)+(d_asrh_dV_S_BS*gammamax))*wtat)));
              itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
            }
            if (((model_.CBBTBOTD_i)==0))
            {

              d_ibbt_dV_S_BS = d_ibbt_dV_D_BD =  0.0;
              ibbt = 0;
            }
            else
            {
              if (((model_.PBOTD_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_S_BS = (deriv_sqrt_0_d0*(((-d_vbbt_dV_S_BS)*(model_.VBIRBOTinv_d))));
                  d_tmp_dV_D_BD = (deriv_sqrt_0_d0*(((-d_vbbt_dV_D_BD)*(model_.VBIRBOTinv_d))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                  double  deriv_pow_0_d0 = (((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PBOTD_i)/(((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d))));

                  d_tmp_dV_S_BS = (deriv_pow_0_d0*(((-d_vbbt_dV_S_BS)*(model_.VBIRBOTinv_d))));
                  d_tmp_dV_D_BD = (deriv_pow_0_d0*(((-d_vbbt_dV_D_BD)*(model_.VBIRBOTinv_d))));
                  tmp = value_pow_0;
                }
              }

              d_Fmaxr_dV_S_BS = ((model_.one_over_one_minus_PBOT_d)*((tmp*((-d_vbbt_dV_S_BS)*(model_.wdepnulrinvbot_d))-(((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))*d_tmp_dV_S_BS)/tmp/tmp));
              d_Fmaxr_dV_D_BD = ((model_.one_over_one_minus_PBOT_d)*((tmp*((-d_vbbt_dV_D_BD)*(model_.wdepnulrinvbot_d))-(((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))*d_tmp_dV_D_BD)/tmp/tmp));
              Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
              if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_D_BD = (deriv_exp_0_d0*((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)));
                  d_tmp_dV_S_BS = (deriv_exp_0_d0*((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-(model_.fbbtbot_d))/Fmaxr)<(-2.3025850929940458e+02)))
                {

                  d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*((-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*((-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_tmp_dV_D_BD = (1.0e100*(((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (1.0e100*(((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_ibbt_dV_S_BS = ((model_.CBBTBOTD_i)*((((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_S_BS)+((((Vjun_d*Fmaxr)*d_Fmaxr_dV_S_BS)+((Vjun_d*d_Fmaxr_dV_S_BS)*Fmaxr))*tmp)));
              d_ibbt_dV_D_BD = ((model_.CBBTBOTD_i)*((((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_D_BD)+((((Vjun_d*Fmaxr)*d_Fmaxr_dV_D_BD)+(((Vjun_d*d_Fmaxr_dV_D_BD)+(d_Vjun_d_dV_D_BD*Fmaxr))*Fmaxr))*tmp)));
              ibbt = ((model_.CBBTBOTD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
            }
            if (((model_.VBRBOTD_i)>1000))
            {

              d_fbreakdown_dV_S_BS = d_fbreakdown_dV_D_BD =  0.0;
              fbreakdown = 1;
            }
            else
            {
              if ((vav>((-0.999)*(model_.VBRBOTD_i))))
              {
                if (((model_.PBRBOTD_i)==4))
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                    double value_fabs_1 = fabs((vav*(model_.VBRinvbot_d)));
                    double value_fabs_2 = fabs((vav*(model_.VBRinvbot_d)));
                    double value_fabs_3 = fabs((vav*(model_.VBRinvbot_d)));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvbot_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvbot_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvbot_d)))>=0)?(+1.0):(-1.0));

                    d_tmp_dV_S_BS = ((((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*((d_vav_dV_S_BS*(model_.VBRinvbot_d)))))+((((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*((d_vav_dV_S_BS*(model_.VBRinvbot_d)))))+(((value_fabs_0*(deriv_fabs_1_d0*((d_vav_dV_S_BS*(model_.VBRinvbot_d)))))+((deriv_fabs_0_d0*((d_vav_dV_S_BS*(model_.VBRinvbot_d))))*value_fabs_1))*value_fabs_2))*value_fabs_3));
                    d_tmp_dV_D_BD = ((((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*((d_vav_dV_D_BD*(model_.VBRinvbot_d)))))+((((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*((d_vav_dV_D_BD*(model_.VBRinvbot_d)))))+(((value_fabs_0*(deriv_fabs_1_d0*((d_vav_dV_D_BD*(model_.VBRinvbot_d)))))+((deriv_fabs_0_d0*((d_vav_dV_D_BD*(model_.VBRinvbot_d))))*value_fabs_1))*value_fabs_2))*value_fabs_3));
                    tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                  }
                }
                else
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                    double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRBOTD_i)/value_fabs_0));

                    d_tmp_dV_S_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_S_BS*(model_.VBRinvbot_d))))));
                    d_tmp_dV_D_BD = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_D_BD*(model_.VBRinvbot_d))))));
                    tmp = value_pow_1;
                  }
                }

                d_fbreakdown_dV_D_BD = (-1*(-d_tmp_dV_D_BD)/(1-tmp)/(1-tmp));
                d_fbreakdown_dV_S_BS = (-1*(-d_tmp_dV_S_BS)/(1-tmp)/(1-tmp));
                fbreakdown = (1/(1-tmp));
              }
              else
              {

                d_fbreakdown_dV_S_BS = (d_vav_dV_S_BS*(model_.slopebot_d));
                d_fbreakdown_dV_D_BD = (d_vav_dV_D_BD*(model_.slopebot_d));
                fbreakdown = ((model_.fstopbot_d)+((vav+(0.999*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
              }
            }

            d_ijunbot_d_dV_S_BS = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_S_BS)+((((d_id_dV_S_BS+d_isrh_dV_S_BS)+d_itat_dV_S_BS)+d_ibbt_dV_S_BS)*fbreakdown));
            d_ijunbot_d_dV_D_BD = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_D_BD)+((((d_id_dV_D_BD+d_isrh_dV_D_BD)+d_itat_dV_D_BD)+d_ibbt_dV_D_BD)*fbreakdown));
            ijunbot_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((LSDRAIN_i==0))
          {

            d_ijunsti_d_dV_D_BD = d_ijunsti_d_dV_S_BS =  0.0;
            ijunsti_d = 0;

            d_qjunsti_d_dV_D_BD = d_qjunsti_d_dV_S_BS =  0.0;
            qjunsti_d = 0;
          }
          else
          {
            if (((model_.one_minus_PSTI_d)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti_d))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-(d_vj_dV_D_BD*(model_.vbiinvsti_d)))));
                d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-(d_vj_dV_S_BS*(model_.vbiinvsti_d)))));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((1-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
                double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvsti_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI_d)/(1-(vj*(model_.vbiinvsti_d)))));

                d_tmp_dV_D_BD = (deriv_pow_0_d0*((-(d_vj_dV_D_BD*(model_.vbiinvsti_d)))));
                d_tmp_dV_S_BS = (deriv_pow_0_d0*((-(d_vj_dV_S_BS*(model_.vbiinvsti_d)))));
                tmp = value_pow_0;
              }
            }

            d_qjunsti_d_dV_D_BD = (((model_.qprefsti_d)*(-d_tmp_dV_D_BD))+((model_.qpref2sti_d)*(d_Vjun_d_dV_D_BD-d_vj_dV_D_BD)));
            d_qjunsti_d_dV_S_BS = (((model_.qprefsti_d)*(-d_tmp_dV_S_BS))+((model_.qpref2sti_d)*(-d_vj_dV_S_BS)));
            qjunsti_d = (((model_.qprefsti_d)*(1-tmp))+((model_.qpref2sti_d)*(Vjun_d-vj)));

            d_id_dV_S_BS = ((model_.idsatsti_d)*d_idmult_dV_S_BS);
            d_id_dV_D_BD = ((model_.idsatsti_d)*d_idmult_dV_D_BD);
            id = ((model_.idsatsti_d)*idmult);
            if ((((model_.CSRHSTID_i)==0)&&((model_.CTATSTID_i)==0)))
            {

              d_isrh_dV_S_BS = d_isrh_dV_D_BD =  0.0;
              isrh = 0;
            }
            else
            {

              d_vbi_minus_vjsrh_dV_S_BS = (-d_vjsrh_dV_S_BS);
              d_vbi_minus_vjsrh_dV_D_BD = (-d_vjsrh_dV_D_BD);
              vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
              {
                double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_wsrhstep_dV_S_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_S_BS-two_psistar*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                d_wsrhstep_dV_D_BD = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_D_BD-two_psistar*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                wsrhstep = (1-value_sqrt_0);
              }
              if (((model_.PSTID_i)==0.5))
              {

                d_dwsrh_dV_D_BD = d_dwsrh_dV_S_BS =  0.0;
                dwsrh = 0;
              }
              else
              {
                {
                  double value_log_0 = log(wsrhstep);
                  double  deriv_log_0_d0 = (1.0/wsrhstep);

                  d_dwsrh_dV_S_BS = (((((1-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_S_BS)))+(((wsrhstep*d_wsrhstep_dV_S_BS)+(d_wsrhstep_dV_S_BS*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_S_BS))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_S_BS)*(1-(2*(model_.PSTID_i))));
                  d_dwsrh_dV_D_BD = (((((1-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_D_BD)))+(((wsrhstep*d_wsrhstep_dV_D_BD)+(d_wsrhstep_dV_D_BD*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_D_BD))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_D_BD)*(1-(2*(model_.PSTID_i))));
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTID_i))));
                }
              }

              d_wsrh_dV_S_BS = (d_wsrhstep_dV_S_BS+d_dwsrh_dV_S_BS);
              d_wsrh_dV_D_BD = (d_wsrhstep_dV_D_BD+d_dwsrh_dV_D_BD);
              wsrh = (wsrhstep+dwsrh);
              if (((model_.PSTID_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRSTIinv_d))));
                  d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_D_BD*(model_.VBIRSTIinv_d))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                  double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PSTID_i)/(vbi_minus_vjsrh*(model_.VBIRSTIinv_d))));

                  d_tmp_dV_S_BS = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRSTIinv_d))));
                  d_tmp_dV_D_BD = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_D_BD*(model_.VBIRSTIinv_d))));
                  tmp = value_pow_0;
                }
              }

              d_wdep_dV_D_BD = ((model_.wdepnulrsti_d)*d_tmp_dV_D_BD);
              d_wdep_dV_S_BS = ((model_.wdepnulrsti_d)*d_tmp_dV_S_BS);
              wdep = ((model_.wdepnulrsti_d)*tmp);

              d_asrh_dV_S_BS = ((model_.ftdsti_d)*(((zinv-1)*d_wdep_dV_S_BS)+(d_zinv_dV_S_BS*wdep)));
              d_asrh_dV_D_BD = ((model_.ftdsti_d)*(((zinv-1)*d_wdep_dV_D_BD)+(d_zinv_dV_D_BD*wdep)));
              asrh = ((model_.ftdsti_d)*((zinv-1)*wdep));

              d_isrh_dV_D_BD = ((model_.CSRHSTID_i)*((asrh*d_wsrh_dV_D_BD)+(d_asrh_dV_D_BD*wsrh)));
              d_isrh_dV_S_BS = ((model_.CSRHSTID_i)*((asrh*d_wsrh_dV_S_BS)+(d_asrh_dV_S_BS*wsrh)));
              isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
            }
            if (((model_.CTATSTID_i)==0))
            {

              d_itat_dV_S_BS = d_itat_dV_D_BD =  0.0;
              itat = 0;
            }
            else
            {

              d_btat_dV_D_BD = ((model_.btatpartsti_d)*((vbi_minus_vjsrh*(d_wdep_dV_D_BD*(model_.one_minus_PSTI_d))-(wdep*(model_.one_minus_PSTI_d))*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              d_btat_dV_S_BS = ((model_.btatpartsti_d)*((vbi_minus_vjsrh*(d_wdep_dV_S_BS*(model_.one_minus_PSTI_d))-(wdep*(model_.one_minus_PSTI_d))*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));

              d_twoatatoverthreebtat_dV_D_BD = (-(0.666666666666667*(model_.atatsti_d))*d_btat_dV_D_BD/btat/btat);
              d_twoatatoverthreebtat_dV_S_BS = (-(0.666666666666667*(model_.atatsti_d))*d_btat_dV_S_BS/btat/btat);
              twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);

              d_umaxbeforelimiting_dV_D_BD = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_D_BD)+(d_twoatatoverthreebtat_dV_D_BD*twoatatoverthreebtat));
              d_umaxbeforelimiting_dV_S_BS = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_S_BS)+(d_twoatatoverthreebtat_dV_S_BS*twoatatoverthreebtat));
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_umax_dV_D_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD)+(d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD)+(d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
                d_umax_dV_S_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS)+(d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS)+(d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
                umax = value_sqrt_0;
              }
              {
                double value_fabs_0 = fabs(umax);
                double value_sqrt_1 = sqrt(value_fabs_0);
                double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_sqrtumax_dV_D_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_D_BD))));
                d_sqrtumax_dV_S_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_S_BS))));
                sqrtumax = value_sqrt_1;
              }

              d_umaxpoweronepointfive_dV_D_BD = ((umax*d_sqrtumax_dV_D_BD)+(d_umax_dV_D_BD*sqrtumax));
              d_umaxpoweronepointfive_dV_S_BS = ((umax*d_sqrtumax_dV_S_BS)+(d_umax_dV_S_BS*sqrtumax));
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1)))
              {

                d_wgamma_dV_D_BD = (-1*((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
                d_wgamma_dV_S_BS = (-1*((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
                wgamma = (1/(1+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
                  double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))/(1+(btat*umaxpoweronepointfive))));

                  d_wgamma_dV_D_BD = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))));
                  d_wgamma_dV_S_BS = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))));
                  wgamma = value_pow_0;
                }
              }

              d_wtat_dV_S_BS = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_S_BS)+(d_wsrh_dV_S_BS*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_S_BS+d_wgamma_dV_S_BS))/(wsrh+wgamma)/(wsrh+wgamma));
              d_wtat_dV_D_BD = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_D_BD)+(d_wsrh_dV_D_BD*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_D_BD+d_wgamma_dV_D_BD))/(wsrh+wgamma)/(wsrh+wgamma));
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_ktat_dV_D_BD = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_D_BD-btat*d_sqrtumax_dV_D_BD)/sqrtumax/sqrtumax))));
                d_ktat_dV_S_BS = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_S_BS-btat*d_sqrtumax_dV_S_BS)/sqrtumax/sqrtumax))));
                ktat = value_sqrt_0;
              }

              d_ltat_dV_D_BD = ((2*((twoatatoverthreebtat*d_sqrtumax_dV_D_BD)+(d_twoatatoverthreebtat_dV_D_BD*sqrtumax)))-d_umax_dV_D_BD);
              d_ltat_dV_S_BS = ((2*((twoatatoverthreebtat*d_sqrtumax_dV_S_BS)+(d_twoatatoverthreebtat_dV_S_BS*sqrtumax)))-d_umax_dV_S_BS);
              ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

              d_mtat_dV_D_BD = ((((((model_.atatsti_d)*twoatatoverthreebtat)*d_sqrtumax_dV_D_BD)+(((model_.atatsti_d)*d_twoatatoverthreebtat_dV_D_BD)*sqrtumax))-((model_.atatsti_d)*d_umax_dV_D_BD))+(0.5*((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))));
              d_mtat_dV_S_BS = ((((((model_.atatsti_d)*twoatatoverthreebtat)*d_sqrtumax_dV_S_BS)+(((model_.atatsti_d)*d_twoatatoverthreebtat_dV_S_BS)*sqrtumax))-((model_.atatsti_d)*d_umax_dV_S_BS))+(0.5*((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))));
              mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));

              d_xerfc_dV_D_BD = (((ltat-1)*d_ktat_dV_D_BD)+(d_ltat_dV_D_BD*ktat));
              d_xerfc_dV_S_BS = (((ltat-1)*d_ktat_dV_S_BS)+(d_ltat_dV_S_BS*ktat));
              xerfc = ((ltat-1)*ktat);

              d_ysq_dV_D_BD = ((xerfc*d_xerfc_dV_D_BD)+(d_xerfc_dV_D_BD*xerfc));
              d_ysq_dV_S_BS = ((xerfc*d_xerfc_dV_S_BS)+(d_xerfc_dV_S_BS*xerfc));
              ysq = (xerfc*xerfc);
              if ((xerfc>0))
              {

                d_terfc_dV_D_BD = (-1*((model_.perfc)*d_xerfc_dV_D_BD)/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
                d_terfc_dV_S_BS = (-1*((model_.perfc)*d_xerfc_dV_S_BS)/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
                terfc = (1/(1+((model_.perfc)*xerfc)));
              }
              else
              {

                d_terfc_dV_D_BD = (-1*(-((model_.perfc)*d_xerfc_dV_D_BD))/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
                d_terfc_dV_S_BS = (-1*(-((model_.perfc)*d_xerfc_dV_S_BS))/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
                terfc = (1/(1-((model_.perfc)*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(((-ysq)+mtat));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_D_BD = (deriv_exp_0_d0*(((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD)));
                  d_tmp_dV_S_BS = (deriv_exp_0_d0*(((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS)));
                  tmp = value_exp_0;
                }
              }
              else
              {

                d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*3.3333333333333333e-01))+((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*3.3333333333333333e-01))+((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }

              d_erfcpos_dV_D_BD = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_D_BD)+((((0.29214664*d_terfc_dV_D_BD)+((model_.berfc)*((terfc*d_terfc_dV_D_BD)+(d_terfc_dV_D_BD*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_D_BD)+(((terfc*d_terfc_dV_D_BD)+(d_terfc_dV_D_BD*terfc))*terfc))))*tmp));
              d_erfcpos_dV_S_BS = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_S_BS)+((((0.29214664*d_terfc_dV_S_BS)+((model_.berfc)*((terfc*d_terfc_dV_S_BS)+(d_terfc_dV_S_BS*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_S_BS)+(((terfc*d_terfc_dV_S_BS)+(d_terfc_dV_S_BS*terfc))*terfc))))*tmp));
              erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0))
              {

                d_erfctimesexpmtat_dV_D_BD = d_erfcpos_dV_D_BD;
                d_erfctimesexpmtat_dV_S_BS = d_erfcpos_dV_S_BS;
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp(mtat);
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_tmp_dV_D_BD = (deriv_exp_0_d0*(d_mtat_dV_D_BD));
                    d_tmp_dV_S_BS = (deriv_exp_0_d0*(d_mtat_dV_S_BS));
                    tmp = value_exp_0;
                  }
                }
                else
                {

                  d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_D_BD)*3.3333333333333333e-01))+((-d_mtat_dV_D_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_D_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_S_BS)*3.3333333333333333e-01))+((-d_mtat_dV_S_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_S_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }

                d_erfctimesexpmtat_dV_D_BD = ((2*d_tmp_dV_D_BD)-d_erfcpos_dV_D_BD);
                d_erfctimesexpmtat_dV_S_BS = ((2*d_tmp_dV_S_BS)-d_erfcpos_dV_S_BS);
                erfctimesexpmtat = ((2*tmp)-erfcpos);
              }

              d_gammamax_dV_D_BD = ((1.77245385090551603*0.5)*((ktat*((model_.atatsti_d)*d_erfctimesexpmtat_dV_D_BD)-((model_.atatsti_d)*erfctimesexpmtat)*d_ktat_dV_D_BD)/ktat/ktat));
              d_gammamax_dV_S_BS = ((1.77245385090551603*0.5)*((ktat*((model_.atatsti_d)*d_erfctimesexpmtat_dV_S_BS)-((model_.atatsti_d)*erfctimesexpmtat)*d_ktat_dV_S_BS)/ktat/ktat));
              gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));

              d_itat_dV_D_BD = ((model_.CTATSTID_i)*(((asrh*gammamax)*d_wtat_dV_D_BD)+(((asrh*d_gammamax_dV_D_BD)+(d_asrh_dV_D_BD*gammamax))*wtat)));
              d_itat_dV_S_BS = ((model_.CTATSTID_i)*(((asrh*gammamax)*d_wtat_dV_S_BS)+(((asrh*d_gammamax_dV_S_BS)+(d_asrh_dV_S_BS*gammamax))*wtat)));
              itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
            }
            if (((model_.CBBTSTID_i)==0))
            {

              d_ibbt_dV_S_BS = d_ibbt_dV_D_BD =  0.0;
              ibbt = 0;
            }
            else
            {
              if (((model_.PSTID_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_S_BS = (deriv_sqrt_0_d0*(((-d_vbbt_dV_S_BS)*(model_.VBIRSTIinv_d))));
                  d_tmp_dV_D_BD = (deriv_sqrt_0_d0*(((-d_vbbt_dV_D_BD)*(model_.VBIRSTIinv_d))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                  double  deriv_pow_0_d0 = (((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PSTID_i)/(((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d))));

                  d_tmp_dV_S_BS = (deriv_pow_0_d0*(((-d_vbbt_dV_S_BS)*(model_.VBIRSTIinv_d))));
                  d_tmp_dV_D_BD = (deriv_pow_0_d0*(((-d_vbbt_dV_D_BD)*(model_.VBIRSTIinv_d))));
                  tmp = value_pow_0;
                }
              }

              d_Fmaxr_dV_S_BS = ((model_.one_over_one_minus_PSTI_d)*((tmp*((-d_vbbt_dV_S_BS)*(model_.wdepnulrinvsti_d))-(((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))*d_tmp_dV_S_BS)/tmp/tmp));
              d_Fmaxr_dV_D_BD = ((model_.one_over_one_minus_PSTI_d)*((tmp*((-d_vbbt_dV_D_BD)*(model_.wdepnulrinvsti_d))-(((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))*d_tmp_dV_D_BD)/tmp/tmp));
              Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
              if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_D_BD = (deriv_exp_0_d0*((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)));
                  d_tmp_dV_S_BS = (deriv_exp_0_d0*((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-(model_.fbbtsti_d))/Fmaxr)<(-2.3025850929940458e+02)))
                {

                  d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*((-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*((-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_tmp_dV_D_BD = (1.0e100*(((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (1.0e100*(((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_ibbt_dV_S_BS = ((model_.CBBTSTID_i)*((((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_S_BS)+((((Vjun_d*Fmaxr)*d_Fmaxr_dV_S_BS)+((Vjun_d*d_Fmaxr_dV_S_BS)*Fmaxr))*tmp)));
              d_ibbt_dV_D_BD = ((model_.CBBTSTID_i)*((((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_D_BD)+((((Vjun_d*Fmaxr)*d_Fmaxr_dV_D_BD)+(((Vjun_d*d_Fmaxr_dV_D_BD)+(d_Vjun_d_dV_D_BD*Fmaxr))*Fmaxr))*tmp)));
              ibbt = ((model_.CBBTSTID_i)*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
            }
            if (((model_.VBRSTID_i)>1000))
            {

              d_fbreakdown_dV_S_BS = d_fbreakdown_dV_D_BD =  0.0;
              fbreakdown = 1;
            }
            else
            {
              if ((vav>((-0.999)*(model_.VBRSTID_i))))
              {
                if (((model_.PBRSTID_i)==4))
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                    double value_fabs_1 = fabs((vav*(model_.VBRinvsti_d)));
                    double value_fabs_2 = fabs((vav*(model_.VBRinvsti_d)));
                    double value_fabs_3 = fabs((vav*(model_.VBRinvsti_d)));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvsti_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvsti_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvsti_d)))>=0)?(+1.0):(-1.0));

                    d_tmp_dV_S_BS = ((((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*((d_vav_dV_S_BS*(model_.VBRinvsti_d)))))+((((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*((d_vav_dV_S_BS*(model_.VBRinvsti_d)))))+(((value_fabs_0*(deriv_fabs_1_d0*((d_vav_dV_S_BS*(model_.VBRinvsti_d)))))+((deriv_fabs_0_d0*((d_vav_dV_S_BS*(model_.VBRinvsti_d))))*value_fabs_1))*value_fabs_2))*value_fabs_3));
                    d_tmp_dV_D_BD = ((((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*((d_vav_dV_D_BD*(model_.VBRinvsti_d)))))+((((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*((d_vav_dV_D_BD*(model_.VBRinvsti_d)))))+(((value_fabs_0*(deriv_fabs_1_d0*((d_vav_dV_D_BD*(model_.VBRinvsti_d)))))+((deriv_fabs_0_d0*((d_vav_dV_D_BD*(model_.VBRinvsti_d))))*value_fabs_1))*value_fabs_2))*value_fabs_3));
                    tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                  }
                }
                else
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                    double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRSTID_i)/value_fabs_0));

                    d_tmp_dV_S_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_S_BS*(model_.VBRinvsti_d))))));
                    d_tmp_dV_D_BD = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_D_BD*(model_.VBRinvsti_d))))));
                    tmp = value_pow_1;
                  }
                }

                d_fbreakdown_dV_D_BD = (-1*(-d_tmp_dV_D_BD)/(1-tmp)/(1-tmp));
                d_fbreakdown_dV_S_BS = (-1*(-d_tmp_dV_S_BS)/(1-tmp)/(1-tmp));
                fbreakdown = (1/(1-tmp));
              }
              else
              {

                d_fbreakdown_dV_S_BS = (d_vav_dV_S_BS*(model_.slopesti_d));
                d_fbreakdown_dV_D_BD = (d_vav_dV_D_BD*(model_.slopesti_d));
                fbreakdown = ((model_.fstopsti_d)+((vav+(0.999*(model_.VBRSTID_i)))*(model_.slopesti_d)));
              }
            }

            d_ijunsti_d_dV_S_BS = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_S_BS)+((((d_id_dV_S_BS+d_isrh_dV_S_BS)+d_itat_dV_S_BS)+d_ibbt_dV_S_BS)*fbreakdown));
            d_ijunsti_d_dV_D_BD = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_D_BD)+((((d_id_dV_D_BD+d_isrh_dV_D_BD)+d_itat_dV_D_BD)+d_ibbt_dV_D_BD)*fbreakdown));
            ijunsti_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((LGDRAIN_i==0))
          {

            d_ijungat_d_dV_D_BD = d_ijungat_d_dV_S_BS =  0.0;
            ijungat_d = 0;

            d_qjungat_d_dV_D_BD = d_qjungat_d_dV_S_BS =  0.0;
            qjungat_d = 0;
          }
          else
          {
            if (((model_.one_minus_PGAT_d)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat_d))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-(d_vj_dV_D_BD*(model_.vbiinvgat_d)))));
                d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-(d_vj_dV_S_BS*(model_.vbiinvgat_d)))));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((1-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
                double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvgat_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT_d)/(1-(vj*(model_.vbiinvgat_d)))));

                d_tmp_dV_D_BD = (deriv_pow_0_d0*((-(d_vj_dV_D_BD*(model_.vbiinvgat_d)))));
                d_tmp_dV_S_BS = (deriv_pow_0_d0*((-(d_vj_dV_S_BS*(model_.vbiinvgat_d)))));
                tmp = value_pow_0;
              }
            }

            d_qjungat_d_dV_D_BD = (((model_.qprefgat_d)*(-d_tmp_dV_D_BD))+((model_.qpref2gat_d)*(d_Vjun_d_dV_D_BD-d_vj_dV_D_BD)));
            d_qjungat_d_dV_S_BS = (((model_.qprefgat_d)*(-d_tmp_dV_S_BS))+((model_.qpref2gat_d)*(-d_vj_dV_S_BS)));
            qjungat_d = (((model_.qprefgat_d)*(1-tmp))+((model_.qpref2gat_d)*(Vjun_d-vj)));

            d_id_dV_S_BS = ((model_.idsatgat_d)*d_idmult_dV_S_BS);
            d_id_dV_D_BD = ((model_.idsatgat_d)*d_idmult_dV_D_BD);
            id = ((model_.idsatgat_d)*idmult);
            if ((((model_.CSRHGATD_i)==0)&&((model_.CTATGATD_i)==0)))
            {

              d_isrh_dV_S_BS = d_isrh_dV_D_BD =  0.0;
              isrh = 0;
            }
            else
            {

              d_vbi_minus_vjsrh_dV_S_BS = (-d_vjsrh_dV_S_BS);
              d_vbi_minus_vjsrh_dV_D_BD = (-d_vjsrh_dV_D_BD);
              vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
              {
                double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_wsrhstep_dV_S_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_S_BS-two_psistar*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                d_wsrhstep_dV_D_BD = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_D_BD-two_psistar*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                wsrhstep = (1-value_sqrt_0);
              }
              if (((model_.PGATD_i)==0.5))
              {

                d_dwsrh_dV_D_BD = d_dwsrh_dV_S_BS =  0.0;
                dwsrh = 0;
              }
              else
              {
                {
                  double value_log_0 = log(wsrhstep);
                  double  deriv_log_0_d0 = (1.0/wsrhstep);

                  d_dwsrh_dV_S_BS = (((((1-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_S_BS)))+(((wsrhstep*d_wsrhstep_dV_S_BS)+(d_wsrhstep_dV_S_BS*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_S_BS))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_S_BS)*(1-(2*(model_.PGATD_i))));
                  d_dwsrh_dV_D_BD = (((((1-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_D_BD)))+(((wsrhstep*d_wsrhstep_dV_D_BD)+(d_wsrhstep_dV_D_BD*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_D_BD))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_D_BD)*(1-(2*(model_.PGATD_i))));
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGATD_i))));
                }
              }

              d_wsrh_dV_S_BS = (d_wsrhstep_dV_S_BS+d_dwsrh_dV_S_BS);
              d_wsrh_dV_D_BD = (d_wsrhstep_dV_D_BD+d_dwsrh_dV_D_BD);
              wsrh = (wsrhstep+dwsrh);
              if (((model_.PGATD_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRGATinv_d))));
                  d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_D_BD*(model_.VBIRGATinv_d))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                  double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRGATinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PGATD_i)/(vbi_minus_vjsrh*(model_.VBIRGATinv_d))));

                  d_tmp_dV_S_BS = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRGATinv_d))));
                  d_tmp_dV_D_BD = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_D_BD*(model_.VBIRGATinv_d))));
                  tmp = value_pow_0;
                }
              }

              d_wdep_dV_D_BD = ((model_.wdepnulrgat_d)*d_tmp_dV_D_BD);
              d_wdep_dV_S_BS = ((model_.wdepnulrgat_d)*d_tmp_dV_S_BS);
              wdep = ((model_.wdepnulrgat_d)*tmp);

              d_asrh_dV_S_BS = ((model_.ftdgat_d)*(((zinv-1)*d_wdep_dV_S_BS)+(d_zinv_dV_S_BS*wdep)));
              d_asrh_dV_D_BD = ((model_.ftdgat_d)*(((zinv-1)*d_wdep_dV_D_BD)+(d_zinv_dV_D_BD*wdep)));
              asrh = ((model_.ftdgat_d)*((zinv-1)*wdep));

              d_isrh_dV_D_BD = ((model_.CSRHGATD_i)*((asrh*d_wsrh_dV_D_BD)+(d_asrh_dV_D_BD*wsrh)));
              d_isrh_dV_S_BS = ((model_.CSRHGATD_i)*((asrh*d_wsrh_dV_S_BS)+(d_asrh_dV_S_BS*wsrh)));
              isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
            }
            if (((model_.CTATGATD_i)==0))
            {

              d_itat_dV_S_BS = d_itat_dV_D_BD =  0.0;
              itat = 0;
            }
            else
            {

              d_btat_dV_D_BD = ((model_.btatpartgat_d)*((vbi_minus_vjsrh*(d_wdep_dV_D_BD*(model_.one_minus_PGAT_d))-(wdep*(model_.one_minus_PGAT_d))*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              d_btat_dV_S_BS = ((model_.btatpartgat_d)*((vbi_minus_vjsrh*(d_wdep_dV_S_BS*(model_.one_minus_PGAT_d))-(wdep*(model_.one_minus_PGAT_d))*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));

              d_twoatatoverthreebtat_dV_D_BD = (-(0.666666666666667*(model_.atatgat_d))*d_btat_dV_D_BD/btat/btat);
              d_twoatatoverthreebtat_dV_S_BS = (-(0.666666666666667*(model_.atatgat_d))*d_btat_dV_S_BS/btat/btat);
              twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);

              d_umaxbeforelimiting_dV_D_BD = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_D_BD)+(d_twoatatoverthreebtat_dV_D_BD*twoatatoverthreebtat));
              d_umaxbeforelimiting_dV_S_BS = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_S_BS)+(d_twoatatoverthreebtat_dV_S_BS*twoatatoverthreebtat));
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_umax_dV_D_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD)+(d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD)+(d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
                d_umax_dV_S_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS)+(d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS)+(d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
                umax = value_sqrt_0;
              }
              {
                double value_fabs_0 = fabs(umax);
                double value_sqrt_1 = sqrt(value_fabs_0);
                double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_sqrtumax_dV_D_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_D_BD))));
                d_sqrtumax_dV_S_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_S_BS))));
                sqrtumax = value_sqrt_1;
              }

              d_umaxpoweronepointfive_dV_D_BD = ((umax*d_sqrtumax_dV_D_BD)+(d_umax_dV_D_BD*sqrtumax));
              d_umaxpoweronepointfive_dV_S_BS = ((umax*d_sqrtumax_dV_S_BS)+(d_umax_dV_S_BS*sqrtumax));
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1)))
              {

                d_wgamma_dV_D_BD = (-1*((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
                d_wgamma_dV_S_BS = (-1*((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
                wgamma = (1/(1+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
                  double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))/(1+(btat*umaxpoweronepointfive))));

                  d_wgamma_dV_D_BD = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))));
                  d_wgamma_dV_S_BS = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))));
                  wgamma = value_pow_0;
                }
              }

              d_wtat_dV_S_BS = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_S_BS)+(d_wsrh_dV_S_BS*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_S_BS+d_wgamma_dV_S_BS))/(wsrh+wgamma)/(wsrh+wgamma));
              d_wtat_dV_D_BD = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_D_BD)+(d_wsrh_dV_D_BD*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_D_BD+d_wgamma_dV_D_BD))/(wsrh+wgamma)/(wsrh+wgamma));
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_ktat_dV_D_BD = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_D_BD-btat*d_sqrtumax_dV_D_BD)/sqrtumax/sqrtumax))));
                d_ktat_dV_S_BS = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_S_BS-btat*d_sqrtumax_dV_S_BS)/sqrtumax/sqrtumax))));
                ktat = value_sqrt_0;
              }

              d_ltat_dV_D_BD = ((2*((twoatatoverthreebtat*d_sqrtumax_dV_D_BD)+(d_twoatatoverthreebtat_dV_D_BD*sqrtumax)))-d_umax_dV_D_BD);
              d_ltat_dV_S_BS = ((2*((twoatatoverthreebtat*d_sqrtumax_dV_S_BS)+(d_twoatatoverthreebtat_dV_S_BS*sqrtumax)))-d_umax_dV_S_BS);
              ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

              d_mtat_dV_D_BD = ((((((model_.atatgat_d)*twoatatoverthreebtat)*d_sqrtumax_dV_D_BD)+(((model_.atatgat_d)*d_twoatatoverthreebtat_dV_D_BD)*sqrtumax))-((model_.atatgat_d)*d_umax_dV_D_BD))+(0.5*((btat*d_umaxpoweronepointfive_dV_D_BD)+(d_btat_dV_D_BD*umaxpoweronepointfive))));
              d_mtat_dV_S_BS = ((((((model_.atatgat_d)*twoatatoverthreebtat)*d_sqrtumax_dV_S_BS)+(((model_.atatgat_d)*d_twoatatoverthreebtat_dV_S_BS)*sqrtumax))-((model_.atatgat_d)*d_umax_dV_S_BS))+(0.5*((btat*d_umaxpoweronepointfive_dV_S_BS)+(d_btat_dV_S_BS*umaxpoweronepointfive))));
              mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));

              d_xerfc_dV_D_BD = (((ltat-1)*d_ktat_dV_D_BD)+(d_ltat_dV_D_BD*ktat));
              d_xerfc_dV_S_BS = (((ltat-1)*d_ktat_dV_S_BS)+(d_ltat_dV_S_BS*ktat));
              xerfc = ((ltat-1)*ktat);

              d_ysq_dV_D_BD = ((xerfc*d_xerfc_dV_D_BD)+(d_xerfc_dV_D_BD*xerfc));
              d_ysq_dV_S_BS = ((xerfc*d_xerfc_dV_S_BS)+(d_xerfc_dV_S_BS*xerfc));
              ysq = (xerfc*xerfc);
              if ((xerfc>0))
              {

                d_terfc_dV_D_BD = (-1*((model_.perfc)*d_xerfc_dV_D_BD)/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
                d_terfc_dV_S_BS = (-1*((model_.perfc)*d_xerfc_dV_S_BS)/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
                terfc = (1/(1+((model_.perfc)*xerfc)));
              }
              else
              {

                d_terfc_dV_D_BD = (-1*(-((model_.perfc)*d_xerfc_dV_D_BD))/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
                d_terfc_dV_S_BS = (-1*(-((model_.perfc)*d_xerfc_dV_S_BS))/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
                terfc = (1/(1-((model_.perfc)*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(((-ysq)+mtat));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_D_BD = (deriv_exp_0_d0*(((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD)));
                  d_tmp_dV_S_BS = (deriv_exp_0_d0*(((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS)));
                  tmp = value_exp_0;
                }
              }
              else
              {

                d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*3.3333333333333333e-01))+((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*3.3333333333333333e-01))+((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }

              d_erfcpos_dV_D_BD = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_D_BD)+((((0.29214664*d_terfc_dV_D_BD)+((model_.berfc)*((terfc*d_terfc_dV_D_BD)+(d_terfc_dV_D_BD*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_D_BD)+(((terfc*d_terfc_dV_D_BD)+(d_terfc_dV_D_BD*terfc))*terfc))))*tmp));
              d_erfcpos_dV_S_BS = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_S_BS)+((((0.29214664*d_terfc_dV_S_BS)+((model_.berfc)*((terfc*d_terfc_dV_S_BS)+(d_terfc_dV_S_BS*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_S_BS)+(((terfc*d_terfc_dV_S_BS)+(d_terfc_dV_S_BS*terfc))*terfc))))*tmp));
              erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0))
              {

                d_erfctimesexpmtat_dV_D_BD = d_erfcpos_dV_D_BD;
                d_erfctimesexpmtat_dV_S_BS = d_erfcpos_dV_S_BS;
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp(mtat);
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_tmp_dV_D_BD = (deriv_exp_0_d0*(d_mtat_dV_D_BD));
                    d_tmp_dV_S_BS = (deriv_exp_0_d0*(d_mtat_dV_S_BS));
                    tmp = value_exp_0;
                  }
                }
                else
                {

                  d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_D_BD)*3.3333333333333333e-01))+((-d_mtat_dV_D_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_D_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_S_BS)*3.3333333333333333e-01))+((-d_mtat_dV_S_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_S_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }

                d_erfctimesexpmtat_dV_D_BD = ((2*d_tmp_dV_D_BD)-d_erfcpos_dV_D_BD);
                d_erfctimesexpmtat_dV_S_BS = ((2*d_tmp_dV_S_BS)-d_erfcpos_dV_S_BS);
                erfctimesexpmtat = ((2*tmp)-erfcpos);
              }

              d_gammamax_dV_D_BD = ((1.77245385090551603*0.5)*((ktat*((model_.atatgat_d)*d_erfctimesexpmtat_dV_D_BD)-((model_.atatgat_d)*erfctimesexpmtat)*d_ktat_dV_D_BD)/ktat/ktat));
              d_gammamax_dV_S_BS = ((1.77245385090551603*0.5)*((ktat*((model_.atatgat_d)*d_erfctimesexpmtat_dV_S_BS)-((model_.atatgat_d)*erfctimesexpmtat)*d_ktat_dV_S_BS)/ktat/ktat));
              gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));

              d_itat_dV_D_BD = ((model_.CTATGATD_i)*(((asrh*gammamax)*d_wtat_dV_D_BD)+(((asrh*d_gammamax_dV_D_BD)+(d_asrh_dV_D_BD*gammamax))*wtat)));
              d_itat_dV_S_BS = ((model_.CTATGATD_i)*(((asrh*gammamax)*d_wtat_dV_S_BS)+(((asrh*d_gammamax_dV_S_BS)+(d_asrh_dV_S_BS*gammamax))*wtat)));
              itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
            }
            if (((model_.CBBTGATD_i)==0))
            {

              d_ibbt_dV_S_BS = d_ibbt_dV_D_BD =  0.0;
              ibbt = 0;
            }
            else
            {
              if (((model_.PGATD_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_S_BS = (deriv_sqrt_0_d0*(((-d_vbbt_dV_S_BS)*(model_.VBIRGATinv_d))));
                  d_tmp_dV_D_BD = (deriv_sqrt_0_d0*(((-d_vbbt_dV_D_BD)*(model_.VBIRGATinv_d))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                  double  deriv_pow_0_d0 = (((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PGATD_i)/(((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d))));

                  d_tmp_dV_S_BS = (deriv_pow_0_d0*(((-d_vbbt_dV_S_BS)*(model_.VBIRGATinv_d))));
                  d_tmp_dV_D_BD = (deriv_pow_0_d0*(((-d_vbbt_dV_D_BD)*(model_.VBIRGATinv_d))));
                  tmp = value_pow_0;
                }
              }

              d_Fmaxr_dV_S_BS = ((model_.one_over_one_minus_PGAT_d)*((tmp*((-d_vbbt_dV_S_BS)*(model_.wdepnulrinvgat_d))-(((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))*d_tmp_dV_S_BS)/tmp/tmp));
              d_Fmaxr_dV_D_BD = ((model_.one_over_one_minus_PGAT_d)*((tmp*((-d_vbbt_dV_D_BD)*(model_.wdepnulrinvgat_d))-(((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))*d_tmp_dV_D_BD)/tmp/tmp));
              Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
              if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_D_BD = (deriv_exp_0_d0*((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)));
                  d_tmp_dV_S_BS = (deriv_exp_0_d0*((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-(model_.fbbtgat_d))/Fmaxr)<(-2.3025850929940458e+02)))
                {

                  d_tmp_dV_D_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*((-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*((-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_tmp_dV_D_BD = (1.0e100*(((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_tmp_dV_S_BS = (1.0e100*(((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_ibbt_dV_S_BS = ((model_.CBBTGATD_i)*((((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_S_BS)+((((Vjun_d*Fmaxr)*d_Fmaxr_dV_S_BS)+((Vjun_d*d_Fmaxr_dV_S_BS)*Fmaxr))*tmp)));
              d_ibbt_dV_D_BD = ((model_.CBBTGATD_i)*((((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_D_BD)+((((Vjun_d*Fmaxr)*d_Fmaxr_dV_D_BD)+(((Vjun_d*d_Fmaxr_dV_D_BD)+(d_Vjun_d_dV_D_BD*Fmaxr))*Fmaxr))*tmp)));
              ibbt = ((model_.CBBTGATD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
            }
            if (((model_.VBRGATD_i)>1000))
            {

              d_fbreakdown_dV_S_BS = d_fbreakdown_dV_D_BD =  0.0;
              fbreakdown = 1;
            }
            else
            {
              if ((vav>((-0.999)*(model_.VBRGATD_i))))
              {
                if (((model_.PBRGATD_i)==4))
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                    double value_fabs_1 = fabs((vav*(model_.VBRinvgat_d)));
                    double value_fabs_2 = fabs((vav*(model_.VBRinvgat_d)));
                    double value_fabs_3 = fabs((vav*(model_.VBRinvgat_d)));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvgat_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvgat_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvgat_d)))>=0)?(+1.0):(-1.0));

                    d_tmp_dV_S_BS = ((((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*((d_vav_dV_S_BS*(model_.VBRinvgat_d)))))+((((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*((d_vav_dV_S_BS*(model_.VBRinvgat_d)))))+(((value_fabs_0*(deriv_fabs_1_d0*((d_vav_dV_S_BS*(model_.VBRinvgat_d)))))+((deriv_fabs_0_d0*((d_vav_dV_S_BS*(model_.VBRinvgat_d))))*value_fabs_1))*value_fabs_2))*value_fabs_3));
                    d_tmp_dV_D_BD = ((((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*((d_vav_dV_D_BD*(model_.VBRinvgat_d)))))+((((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*((d_vav_dV_D_BD*(model_.VBRinvgat_d)))))+(((value_fabs_0*(deriv_fabs_1_d0*((d_vav_dV_D_BD*(model_.VBRinvgat_d)))))+((deriv_fabs_0_d0*((d_vav_dV_D_BD*(model_.VBRinvgat_d))))*value_fabs_1))*value_fabs_2))*value_fabs_3));
                    tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                  }
                }
                else
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                    double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRGATD_i)/value_fabs_0));

                    d_tmp_dV_S_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_S_BS*(model_.VBRinvgat_d))))));
                    d_tmp_dV_D_BD = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_D_BD*(model_.VBRinvgat_d))))));
                    tmp = value_pow_1;
                  }
                }

                d_fbreakdown_dV_D_BD = (-1*(-d_tmp_dV_D_BD)/(1-tmp)/(1-tmp));
                d_fbreakdown_dV_S_BS = (-1*(-d_tmp_dV_S_BS)/(1-tmp)/(1-tmp));
                fbreakdown = (1/(1-tmp));
              }
              else
              {

                d_fbreakdown_dV_S_BS = (d_vav_dV_S_BS*(model_.slopegat_d));
                d_fbreakdown_dV_D_BD = (d_vav_dV_D_BD*(model_.slopegat_d));
                fbreakdown = ((model_.fstopgat_d)+((vav+(0.999*(model_.VBRGATD_i)))*(model_.slopegat_d)));
              }
            }

            d_ijungat_d_dV_S_BS = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_S_BS)+((((d_id_dV_S_BS+d_isrh_dV_S_BS)+d_itat_dV_S_BS)+d_ibbt_dV_S_BS)*fbreakdown));
            d_ijungat_d_dV_D_BD = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_D_BD)+((((d_id_dV_D_BD+d_isrh_dV_D_BD)+d_itat_dV_D_BD)+d_ibbt_dV_D_BD)*fbreakdown));
            ijungat_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }

          d_ijun_d_dV_S_BS = (((ABDRAIN_i*d_ijunbot_d_dV_S_BS)+(LSDRAIN_i*d_ijunsti_d_dV_S_BS))+(LGDRAIN_i*d_ijungat_d_dV_S_BS));
          d_ijun_d_dV_D_BD = (((ABDRAIN_i*d_ijunbot_d_dV_D_BD)+(LSDRAIN_i*d_ijunsti_d_dV_D_BD))+(LGDRAIN_i*d_ijungat_d_dV_D_BD));
          ijun_d = (((ABDRAIN_i*ijunbot_d)+(LSDRAIN_i*ijunsti_d))+(LGDRAIN_i*ijungat_d));
        }
      }
      rgatenoise = ((model_.nt0)*ggate);
      rbulknoise = ((model_.nt0)*gbulk);
      rjunsnoise = ((model_.nt0)*gjuns);
      rjundnoise = ((model_.nt0)*gjund);
      rwellnoise = ((model_.nt0)*gwell);
    }
    // End block evaluateStaticDynamic
    //Begin block loadStatic
    {
      if ((sigVds>0))
      {
        // I(D,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
        staticContributions[admsNodeID_D] += (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
        d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_S_BP);
        d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_D_S);
        d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_S);
        staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
        d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_S_BP);
        d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_D_S);
        d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_S);
        // I(D,S) <+ (((CHNL_TYPE*MULT_i)*Ids))
        staticContributions[admsNodeID_D] += (((model_.CHNL_TYPE)*MULT_i)*Ids);
        d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_S_BP);
        d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_D_S);
        d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_GP_S);
        staticContributions[admsNodeID_S] -= (((model_.CHNL_TYPE)*MULT_i)*Ids);
        d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_S_BP);
        d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_D_S);
        d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_GP_S);
        // I(GP,S) <+ (((CHNL_TYPE*MULT_i)*Igcs))
        staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcs);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_S_BP);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_D_S);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_S);
        staticContributions[admsNodeID_S] -= (((model_.CHNL_TYPE)*MULT_i)*Igcs);
        d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_S_BP);
        d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_D_S);
        d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_S);
        // I(GP,D) <+ (((CHNL_TYPE*MULT_i)*Igcd))
        staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcd);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_S_BP);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_D_S);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_S);
        staticContributions[admsNodeID_D] -= (((model_.CHNL_TYPE)*MULT_i)*Igcd);
        d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_S_BP);
        d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_D_S);
        d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_S);
      }
      else
      {
        // I(S,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
        staticContributions[admsNodeID_S] += (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
        d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_S_BP);
        d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_D_S);
        d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_S);
        staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
        d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_S_BP);
        d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_D_S);
        d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_S);
        // I(S,D) <+ (((CHNL_TYPE*MULT_i)*Ids))
        staticContributions[admsNodeID_S] += (((model_.CHNL_TYPE)*MULT_i)*Ids);
        d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_S_BP);
        d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_D_S);
        d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_GP_S);
        staticContributions[admsNodeID_D] -= (((model_.CHNL_TYPE)*MULT_i)*Ids);
        d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_S_BP);
        d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_D_S);
        d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_GP_S);
        // I(GP,D) <+ (((CHNL_TYPE*MULT_i)*Igcs))
        staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcs);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_S_BP);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_D_S);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_S);
        staticContributions[admsNodeID_D] -= (((model_.CHNL_TYPE)*MULT_i)*Igcs);
        d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_S_BP);
        d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_D_S);
        d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_S);
        // I(GP,S) <+ (((CHNL_TYPE*MULT_i)*Igcd))
        staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcd);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_S_BP);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_D_S);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_S);
        staticContributions[admsNodeID_S] -= (((model_.CHNL_TYPE)*MULT_i)*Igcd);
        d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_S_BP);
        d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_D_S);
        d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_S);
      }
      // I(GP,BP) <+ (((CHNL_TYPE*MULT_i)*Igb))
      staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igb);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_S_BP);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_D_S);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_GP_S);
      staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Igb);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_S_BP);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_D_S);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_GP_S);
      // I(GP,S) <+ (((CHNL_TYPE*MULT_i)*Igsov))
      staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igsov);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_S_BP);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_D_S);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_GP_S);
      staticContributions[admsNodeID_S] -= (((model_.CHNL_TYPE)*MULT_i)*Igsov);
      d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_S_BP);
      d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_D_S);
      d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_GP_S);
      // I(GP,D) <+ (((CHNL_TYPE*MULT_i)*Igdov))
      staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igdov);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_S_BP);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_D_S);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_GP_S);
      staticContributions[admsNodeID_D] -= (((model_.CHNL_TYPE)*MULT_i)*Igdov);
      d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_S_BP);
      d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_D_S);
      d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_GP_S);
      // I(S,BP) <+ (((CHNL_TYPE*MULT_i)*Igisl))
      staticContributions[admsNodeID_S] += (((model_.CHNL_TYPE)*MULT_i)*Igisl);
      d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_D_S);
      d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_GP_S);
      d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_S_BP);
      staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Igisl);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_D_S);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_GP_S);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_S_BP);
      // I(D,BP) <+ (((CHNL_TYPE*MULT_i)*Igidl))
      staticContributions[admsNodeID_D] += (((model_.CHNL_TYPE)*MULT_i)*Igidl);
      d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_GP_S);
      d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_S_BP);
      d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_D_S);
      staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Igidl);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_GP_S);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_S_BP);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_D_S);
      // I(BS,S) <+ (((CHNL_TYPE*MULT_i)*ijun_s))
      staticContributions[admsNodeID_BS] += (((model_.CHNL_TYPE)*MULT_i)*ijun_s);
      d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BS] += (((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_S_BS);
      d_staticContributions[admsNodeID_BS][admsProbeID_V_D_BD] += (((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_D_BD);
      staticContributions[admsNodeID_S] -= (((model_.CHNL_TYPE)*MULT_i)*ijun_s);
      d_staticContributions[admsNodeID_S][admsProbeID_V_S_BS] -= (((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_S_BS);
      d_staticContributions[admsNodeID_S][admsProbeID_V_D_BD] -= (((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_D_BD);
      // I(BD,D) <+ (((CHNL_TYPE*MULT_i)*ijun_d))
      staticContributions[admsNodeID_BD] += (((model_.CHNL_TYPE)*MULT_i)*ijun_d);
      d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BS] += (((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_S_BS);
      d_staticContributions[admsNodeID_BD][admsProbeID_V_D_BD] += (((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_D_BD);
      staticContributions[admsNodeID_D] -= (((model_.CHNL_TYPE)*MULT_i)*ijun_d);
      d_staticContributions[admsNodeID_D][admsProbeID_V_S_BS] -= (((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_S_BS);
      d_staticContributions[admsNodeID_D][admsProbeID_V_D_BD] -= (((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_D_BD);
      if ((RG_i>0.0))
      {
        // I(G,GP) <+ (((MULT_i*ggate)*V(G,GP)))
        staticContributions[admsNodeID_G] += ((MULT_i*ggate)*(probeVars[admsProbeID_V_G_GP]));
        d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP] += ((MULT_i*ggate)*d_probeVars[admsProbeID_V_G_GP][admsProbeID_V_G_GP]);
        staticContributions[admsNodeID_GP] -= ((MULT_i*ggate)*(probeVars[admsProbeID_V_G_GP]));
        d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] -= ((MULT_i*ggate)*d_probeVars[admsProbeID_V_G_GP][admsProbeID_V_G_GP]);
        // I(G,GP) <+ (white_noise((MULT_i*rgatenoise)))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[0]= (MULT_i*rgatenoise);
        }
      }
      else
      {
        // V(G,GP) <+ (0.0)
        // do nothing at all
      }
      if ((RBULK_i>0.0))
      {
        // I(BP,BI) <+ (((MULT_i*gbulk)*V(BP,BI)))
        staticContributions[admsNodeID_BP] += ((MULT_i*gbulk)*(probeVars[admsProbeID_V_BP_BI]));
        d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] += ((MULT_i*gbulk)*d_probeVars[admsProbeID_V_BP_BI][admsProbeID_V_BP_BI]);
        staticContributions[admsNodeID_BI] -= ((MULT_i*gbulk)*(probeVars[admsProbeID_V_BP_BI]));
        d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI] -= ((MULT_i*gbulk)*d_probeVars[admsProbeID_V_BP_BI][admsProbeID_V_BP_BI]);
        // I(BP,BI) <+ (white_noise((MULT_i*rbulknoise)))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[1]= (MULT_i*rbulknoise);
        }
      }
      else
      {
        // V(BP,BI) <+ (0.0)
        // do nothing at all
      }
      if ((RJUNS_i>0.0))
      {
        // I(BS,BI) <+ (((MULT_i*gjuns)*V(BS,BI)))
        staticContributions[admsNodeID_BS] += ((MULT_i*gjuns)*(probeVars[admsProbeID_V_BS_BI]));
        d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] += ((MULT_i*gjuns)*d_probeVars[admsProbeID_V_BS_BI][admsProbeID_V_BS_BI]);
        staticContributions[admsNodeID_BI] -= ((MULT_i*gjuns)*(probeVars[admsProbeID_V_BS_BI]));
        d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] -= ((MULT_i*gjuns)*d_probeVars[admsProbeID_V_BS_BI][admsProbeID_V_BS_BI]);
        // I(BS,BI) <+ (white_noise((MULT_i*rjunsnoise)))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[2]= (MULT_i*rjunsnoise);
        }
      }
      else
      {
        // V(BS,BI) <+ (0.0)
        // do nothing at all
      }
      if ((RJUND_i>0.0))
      {
        // I(BD,BI) <+ (((MULT_i*gjund)*V(BD,BI)))
        staticContributions[admsNodeID_BD] += ((MULT_i*gjund)*(probeVars[admsProbeID_V_BD_BI]));
        d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] += ((MULT_i*gjund)*d_probeVars[admsProbeID_V_BD_BI][admsProbeID_V_BD_BI]);
        staticContributions[admsNodeID_BI] -= ((MULT_i*gjund)*(probeVars[admsProbeID_V_BD_BI]));
        d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] -= ((MULT_i*gjund)*d_probeVars[admsProbeID_V_BD_BI][admsProbeID_V_BD_BI]);
        // I(BD,BI) <+ (white_noise((MULT_i*rjundnoise)))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[3]= (MULT_i*rjundnoise);
        }
      }
      else
      {
        // V(BD,BI) <+ (0.0)
        // do nothing at all
      }
      if ((RWELL_i>0.0))
      {
        // I(B,BI) <+ (((MULT_i*gwell)*V(B,BI)))
        staticContributions[admsNodeID_B] += ((MULT_i*gwell)*(probeVars[admsProbeID_V_B_BI]));
        d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI] += ((MULT_i*gwell)*d_probeVars[admsProbeID_V_B_BI][admsProbeID_V_B_BI]);
        staticContributions[admsNodeID_BI] -= ((MULT_i*gwell)*(probeVars[admsProbeID_V_B_BI]));
        d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] -= ((MULT_i*gwell)*d_probeVars[admsProbeID_V_B_BI][admsProbeID_V_B_BI]);
        // I(B,BI) <+ (white_noise((MULT_i*rwellnoise)))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[4]= (MULT_i*rwellnoise);
        }
      }
      else
      {
        // V(B,BI) <+ (0.0)
        // do nothing at all
      }
      // I(D,S) <+ ((1E-15*V(D,S)))
      staticContributions[admsNodeID_D] += (1E-15*(probeVars[admsProbeID_V_D_S]));
      d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += (1E-15*d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S]);
      staticContributions[admsNodeID_S] -= (1E-15*(probeVars[admsProbeID_V_D_S]));
      d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= (1E-15*d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S]);
    }
    // End block loadStatic
    //Begin block loadDynamic
    {

      d_Qs_dV_S_BP = (-((d_Qg_dV_S_BP+d_Qb_dV_S_BP)+d_Qd_dV_S_BP));
      d_Qs_dV_GP_S = (-((d_Qg_dV_GP_S+d_Qb_dV_GP_S)+d_Qd_dV_GP_S));
      d_Qs_dV_D_S = (-((d_Qg_dV_D_S+d_Qb_dV_D_S)+d_Qd_dV_D_S));
      Qs = (-((Qg+Qb)+Qd));

      d_Qfgs_dV_S_BP = (d_Qfgs_dV_S_BP+d_Qgs_ov_dV_S_BP);
      d_Qfgs_dV_D_S = (d_Qfgs_dV_D_S+d_Qgs_ov_dV_D_S);
      d_Qfgs_dV_GP_S = (d_Qfgs_dV_GP_S+d_Qgs_ov_dV_GP_S);
      Qfgs = (Qfgs+Qgs_ov);

      d_Qfgd_dV_S_BP = (d_Qfgd_dV_S_BP+d_Qgd_ov_dV_S_BP);
      d_Qfgd_dV_D_S = (d_Qfgd_dV_D_S+d_Qgd_ov_dV_D_S);
      d_Qfgd_dV_GP_S = (d_Qfgd_dV_GP_S+d_Qgd_ov_dV_GP_S);
      Qfgd = (Qfgd+Qgd_ov);

      d_qjun_s_dV_S_BS = (((ABSOURCE_i*d_qjunbot_s_dV_S_BS)+(LSSOURCE_i*d_qjunsti_s_dV_S_BS))+(LGSOURCE_i*d_qjungat_s_dV_S_BS));
      d_qjun_s_dV_D_BD = (((ABSOURCE_i*d_qjunbot_s_dV_D_BD)+(LSSOURCE_i*d_qjunsti_s_dV_D_BD))+(LGSOURCE_i*d_qjungat_s_dV_D_BD));
      qjun_s = (((ABSOURCE_i*qjunbot_s)+(LSSOURCE_i*qjunsti_s))+(LGSOURCE_i*qjungat_s));

      d_qjun_d_dV_S_BS = (((ABDRAIN_i*d_qjunbot_d_dV_S_BS)+(LSDRAIN_i*d_qjunsti_d_dV_S_BS))+(LGDRAIN_i*d_qjungat_d_dV_S_BS));
      d_qjun_d_dV_D_BD = (((ABDRAIN_i*d_qjunbot_d_dV_D_BD)+(LSDRAIN_i*d_qjunsti_d_dV_D_BD))+(LGDRAIN_i*d_qjungat_d_dV_D_BD));
      qjun_d = (((ABDRAIN_i*qjunbot_d)+(LSDRAIN_i*qjunsti_d))+(LGDRAIN_i*qjungat_d));
      if ((sigVds<0))
      {

        d_temp_dV_S_BP = d_Qd_dV_S_BP;
        d_temp_dV_D_S = d_Qd_dV_D_S;
        d_temp_dV_GP_S = d_Qd_dV_GP_S;
        temp = Qd;

        d_Qd_dV_S_BP = d_Qs_dV_S_BP;
        d_Qd_dV_GP_S = d_Qs_dV_GP_S;
        d_Qd_dV_D_S = d_Qs_dV_D_S;
        Qd = Qs;

        d_Qs_dV_S_BP = d_temp_dV_S_BP;
        d_Qs_dV_D_S = d_temp_dV_D_S;
        d_Qs_dV_GP_S = d_temp_dV_GP_S;
        Qs = temp;
      }
      // I(GP,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qg)))
      dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qg));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_S_BP));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_GP_S));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_D_S));
      dynamicContributions[admsNodeID_S] -= ((((model_.CHNL_TYPE)*MULT_i)*Qg));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_S_BP));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_GP_S));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_D_S));
      // I(BP,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qb)))
      dynamicContributions[admsNodeID_BP] += ((((model_.CHNL_TYPE)*MULT_i)*Qb));
      d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_S_BP));
      d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_GP_S));
      d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_D_S));
      dynamicContributions[admsNodeID_S] -= ((((model_.CHNL_TYPE)*MULT_i)*Qb));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_S_BP));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_GP_S));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_D_S));
      // I(D,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qd)))
      dynamicContributions[admsNodeID_D] += ((((model_.CHNL_TYPE)*MULT_i)*Qd));
      d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_S_BP));
      d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_D_S));
      d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_GP_S));
      dynamicContributions[admsNodeID_S] -= ((((model_.CHNL_TYPE)*MULT_i)*Qd));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_S_BP));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_D_S));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_GP_S));
      // I(GP,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgs)))
      dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qfgs));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_GP_S));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_S_BP));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_D_S));
      dynamicContributions[admsNodeID_S] -= ((((model_.CHNL_TYPE)*MULT_i)*Qfgs));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_GP_S));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_S_BP));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_D_S));
      // I(GP,D) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgd)))
      dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qfgd));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_D_S));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_GP_S));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_S_BP));
      dynamicContributions[admsNodeID_D] -= ((((model_.CHNL_TYPE)*MULT_i)*Qfgd));
      d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_D_S));
      d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_GP_S));
      d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_S_BP));
      // I(GP,BP) <+ (ddt(((CHNL_TYPE*MULT_i)*Qgb_ov)))
      dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qgb_ov));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_S_BP));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_GP_S));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_D_S));
      dynamicContributions[admsNodeID_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*Qgb_ov));
      d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_S_BP));
      d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_GP_S));
      d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_D_S));
      // I(BS,S) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_s)))
      dynamicContributions[admsNodeID_BS] += ((((model_.CHNL_TYPE)*MULT_i)*qjun_s));
      d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BS] += ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_S_BS));
      d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_BD] += ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_D_BD));
      dynamicContributions[admsNodeID_S] -= ((((model_.CHNL_TYPE)*MULT_i)*qjun_s));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BS] -= ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_S_BS));
      d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_BD] -= ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_D_BD));
      // I(BD,D) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_d)))
      dynamicContributions[admsNodeID_BD] += ((((model_.CHNL_TYPE)*MULT_i)*qjun_d));
      d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BS] += ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_S_BS));
      d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_BD] += ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_D_BD));
      dynamicContributions[admsNodeID_D] -= ((((model_.CHNL_TYPE)*MULT_i)*qjun_d));
      d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BS] -= ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_S_BS));
      d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_BD] -= ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_D_BD));
    }
    // End block loadDynamic
    //Begin block noise
    {
      //Block-local variables for block noise
      double sf;
      double d_sf_dV_D_S;
      double d_sf_dV_GP_S;
      double d_sf_dV_S_BP;
      //End of Block-local variables

      d_Sfl_dV_D_S = d_Sfl_dV_GP_S = d_Sfl_dV_S_BP =  0.0;
      Sfl = 0.0;

      d_mid_dV_D_S = d_mid_dV_GP_S = d_mid_dV_S_BP =  0.0;
      mid = 0.0;

      d_mig_dV_D_S = d_mig_dV_GP_S = d_mig_dV_S_BP =  0.0;
      mig = 0.0;

      d_migid_dV_D_S = d_migid_dV_GP_S = d_migid_dV_S_BP =  0.0;
      migid = 0.0;

      d_c_igid_dV_D_S = d_c_igid_dV_GP_S = d_c_igid_dV_S_BP =  0.0;
      c_igid = 0.0;

      d_CGeff_dV_S_BP = ((COX_qm*d_eta_p_dV_S_BP)+(d_COX_qm_dV_S_BP*eta_p));
      d_CGeff_dV_GP_S = ((COX_qm*d_eta_p_dV_GP_S)+(d_COX_qm_dV_GP_S*eta_p));
      d_CGeff_dV_D_S = ((COX_qm*d_eta_p_dV_D_S)+(d_COX_qm_dV_D_S*eta_p));
      CGeff = (COX_qm*eta_p);

      d_sqid_dV_D_S = d_sqid_dV_GP_S = d_sqid_dV_S_BP =  0.0;
      sqid = 0.0;

      d_sqig_dV_D_S = d_sqig_dV_GP_S = d_sqig_dV_S_BP =  0.0;
      sqig = 0.0;
      if ((((xg>0.0)&&(MULT_i>0.0))&&(BET_i>0.0)))
      {

        d_N1_dV_S_BP = ((Cox_over_q*d_alpha_dV_S_BP)*(model_.phit));
        d_N1_dV_GP_S = ((Cox_over_q*d_alpha_dV_GP_S)*(model_.phit));
        d_N1_dV_D_S = ((Cox_over_q*d_alpha_dV_D_S)*(model_.phit));
        N1 = ((Cox_over_q*alpha)*(model_.phit));

        d_Nm1_dV_S_BP = (Cox_over_q*d_qim1_dV_S_BP);
        d_Nm1_dV_GP_S = (Cox_over_q*d_qim1_dV_GP_S);
        d_Nm1_dV_D_S = (Cox_over_q*d_qim1_dV_D_S);
        Nm1 = (Cox_over_q*qim1);

        d_Delta_N1_dV_S_BP = (Cox_over_q*((alpha*d_dps_dV_S_BP)+(d_alpha_dV_S_BP*dps)));
        d_Delta_N1_dV_GP_S = (Cox_over_q*((alpha*d_dps_dV_GP_S)+(d_alpha_dV_GP_S*dps)));
        d_Delta_N1_dV_D_S = (Cox_over_q*((alpha*d_dps_dV_D_S)+(d_alpha_dV_D_S*dps)));
        Delta_N1 = (Cox_over_q*(alpha*dps));
        {
          double value_log_0 = log(((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));
          double  deriv_log_0_d0 = (1.0/((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));

          d_Sfl_dV_S_BP = ((((NFA_i-(NFB_i*N1))+(NFC_i*(N1*N1)))*(deriv_log_0_d0*((((Nm1-(0.5*Delta_N1))*(d_Nm1_dV_S_BP+(0.5*d_Delta_N1_dV_S_BP))-(Nm1+(0.5*Delta_N1))*(d_Nm1_dV_S_BP-(0.5*d_Delta_N1_dV_S_BP)))/(Nm1-(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))))))+(((-(NFB_i*d_N1_dV_S_BP))+(NFC_i*((N1*d_N1_dV_S_BP)+(d_N1_dV_S_BP*N1))))*value_log_0));
          d_Sfl_dV_GP_S = ((((NFA_i-(NFB_i*N1))+(NFC_i*(N1*N1)))*(deriv_log_0_d0*((((Nm1-(0.5*Delta_N1))*(d_Nm1_dV_GP_S+(0.5*d_Delta_N1_dV_GP_S))-(Nm1+(0.5*Delta_N1))*(d_Nm1_dV_GP_S-(0.5*d_Delta_N1_dV_GP_S)))/(Nm1-(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))))))+(((-(NFB_i*d_N1_dV_GP_S))+(NFC_i*((N1*d_N1_dV_GP_S)+(d_N1_dV_GP_S*N1))))*value_log_0));
          d_Sfl_dV_D_S = ((((NFA_i-(NFB_i*N1))+(NFC_i*(N1*N1)))*(deriv_log_0_d0*((((Nm1-(0.5*Delta_N1))*(d_Nm1_dV_D_S+(0.5*d_Delta_N1_dV_D_S))-(Nm1+(0.5*Delta_N1))*(d_Nm1_dV_D_S-(0.5*d_Delta_N1_dV_D_S)))/(Nm1-(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))))))+(((-(NFB_i*d_N1_dV_D_S))+(NFC_i*((N1*d_N1_dV_D_S)+(d_N1_dV_D_S*N1))))*value_log_0));
          Sfl = (((NFA_i-(NFB_i*N1))+(NFC_i*(N1*N1)))*value_log_0);
        }

        d_Sfl_dV_S_BP = (d_Sfl_dV_S_BP+(((NFB_i+(NFC_i*(Nm1-(2.0*N1))))*d_Delta_N1_dV_S_BP)+((NFC_i*(d_Nm1_dV_S_BP-(2.0*d_N1_dV_S_BP)))*Delta_N1)));
        d_Sfl_dV_GP_S = (d_Sfl_dV_GP_S+(((NFB_i+(NFC_i*(Nm1-(2.0*N1))))*d_Delta_N1_dV_GP_S)+((NFC_i*(d_Nm1_dV_GP_S-(2.0*d_N1_dV_GP_S)))*Delta_N1)));
        d_Sfl_dV_D_S = (d_Sfl_dV_D_S+(((NFB_i+(NFC_i*(Nm1-(2.0*N1))))*d_Delta_N1_dV_D_S)+((NFC_i*(d_Nm1_dV_D_S-(2.0*d_N1_dV_D_S)))*Delta_N1)));
        Sfl = (Sfl+((NFB_i+(NFC_i*(Nm1-(2.0*N1))))*Delta_N1));

        d_Sfl_dV_S_BP = ((N1*((((Sfl_prefac*Ids)*Gvsatinv)*d_Sfl_dV_S_BP)+((((Sfl_prefac*Ids)*d_Gvsatinv_dV_S_BP)+((Sfl_prefac*d_Ids_dV_S_BP)*Gvsatinv))*Sfl))-(((Sfl_prefac*Ids)*Gvsatinv)*Sfl)*d_N1_dV_S_BP)/N1/N1);
        d_Sfl_dV_D_S = ((N1*((((Sfl_prefac*Ids)*Gvsatinv)*d_Sfl_dV_D_S)+((((Sfl_prefac*Ids)*d_Gvsatinv_dV_D_S)+((Sfl_prefac*d_Ids_dV_D_S)*Gvsatinv))*Sfl))-(((Sfl_prefac*Ids)*Gvsatinv)*Sfl)*d_N1_dV_D_S)/N1/N1);
        d_Sfl_dV_GP_S = ((N1*((((Sfl_prefac*Ids)*Gvsatinv)*d_Sfl_dV_GP_S)+((((Sfl_prefac*Ids)*d_Gvsatinv_dV_GP_S)+((Sfl_prefac*d_Ids_dV_GP_S)*Gvsatinv))*Sfl))-(((Sfl_prefac*Ids)*Gvsatinv)*Sfl)*d_N1_dV_GP_S)/N1/N1);
        Sfl = ((((Sfl_prefac*Ids)*Gvsatinv)*Sfl)/N1);

        d_Sfl_dV_S_BP = ((Sfl>0.0)?d_Sfl_dV_S_BP:0.0);
        d_Sfl_dV_GP_S = ((Sfl>0.0)?d_Sfl_dV_GP_S:0.0);
        d_Sfl_dV_D_S = ((Sfl>0.0)?d_Sfl_dV_D_S:0.0);
        Sfl = ((Sfl>0.0)?Sfl:0.0);

        d_H0_dV_S_BP = ((alpha*d_qim1_dV_S_BP-qim1*d_alpha_dV_S_BP)/alpha/alpha);
        d_H0_dV_GP_S = ((alpha*d_qim1_dV_GP_S-qim1*d_alpha_dV_GP_S)/alpha/alpha);
        d_H0_dV_D_S = ((alpha*d_qim1_dV_D_S-qim1*d_alpha_dV_D_S)/alpha/alpha);
        H0 = (qim1/alpha);

        d_t1_dV_S_BP = ((qim1*d_qim_dV_S_BP-qim*d_qim1_dV_S_BP)/qim1/qim1);
        d_t1_dV_GP_S = ((qim1*d_qim_dV_GP_S-qim*d_qim1_dV_GP_S)/qim1/qim1);
        d_t1_dV_D_S = ((qim1*d_qim_dV_D_S-qim*d_qim1_dV_D_S)/qim1/qim1);
        t1 = (qim/qim1);

        d_sqt2_dV_S_BP = ((0.5*1.6666666666666667e-01)*((H0*d_dps_dV_S_BP-dps*d_H0_dV_S_BP)/H0/H0));
        d_sqt2_dV_GP_S = ((0.5*1.6666666666666667e-01)*((H0*d_dps_dV_GP_S-dps*d_H0_dV_GP_S)/H0/H0));
        d_sqt2_dV_D_S = ((0.5*1.6666666666666667e-01)*((H0*d_dps_dV_D_S-dps*d_H0_dV_D_S)/H0/H0));
        sqt2 = ((0.5*1.6666666666666667e-01)*(dps/H0));

        d_t2_dV_S_BP = ((sqt2*d_sqt2_dV_S_BP)+(d_sqt2_dV_S_BP*sqt2));
        d_t2_dV_GP_S = ((sqt2*d_sqt2_dV_GP_S)+(d_sqt2_dV_GP_S*sqt2));
        d_t2_dV_D_S = ((sqt2*d_sqt2_dV_D_S)+(d_sqt2_dV_D_S*sqt2));
        t2 = (sqt2*sqt2);

        d_r_dV_S_BP = ((H*d_H0_dV_S_BP-H0*d_H_dV_S_BP)/H/H);
        d_r_dV_GP_S = ((H*d_H0_dV_GP_S-H0*d_H_dV_GP_S)/H/H);
        d_r_dV_D_S = ((H*d_H0_dV_D_S-H0*d_H_dV_D_S)/H/H);
        r = ((H0/H)-1.0);

        d_lc_dV_S_BP = (((1.0-(12*(r*t2)))>1e-20)?(-(12*((r*d_t2_dV_S_BP)+(d_r_dV_S_BP*t2)))):0.0);
        d_lc_dV_GP_S = (((1.0-(12*(r*t2)))>1e-20)?(-(12*((r*d_t2_dV_GP_S)+(d_r_dV_GP_S*t2)))):0.0);
        d_lc_dV_D_S = (((1.0-(12*(r*t2)))>1e-20)?(-(12*((r*d_t2_dV_D_S)+(d_r_dV_D_S*t2)))):0.0);
        lc = (((1.0-(12*(r*t2)))>1e-20)?(1.0-(12*(r*t2))):1e-20);

        d_lcinv2_dV_S_BP = (-1*((lc*d_lc_dV_S_BP)+(d_lc_dV_S_BP*lc))/(lc*lc)/(lc*lc));
        d_lcinv2_dV_GP_S = (-1*((lc*d_lc_dV_GP_S)+(d_lc_dV_GP_S*lc))/(lc*lc)/(lc*lc));
        d_lcinv2_dV_D_S = (-1*((lc*d_lc_dV_D_S)+(d_lc_dV_D_S*lc))/(lc*lc)/(lc*lc));
        lcinv2 = (1/(lc*lc));

        d_g_ideal_dV_S_BP = (BET_i*(((FdL*qim1)*d_Gvsatinv_dV_S_BP)+(((FdL*d_qim1_dV_S_BP)+(d_FdL_dV_S_BP*qim1))*Gvsatinv)));
        d_g_ideal_dV_D_S = (BET_i*(((FdL*qim1)*d_Gvsatinv_dV_D_S)+(((FdL*d_qim1_dV_D_S)+(d_FdL_dV_D_S*qim1))*Gvsatinv)));
        d_g_ideal_dV_GP_S = (BET_i*(((FdL*qim1)*d_Gvsatinv_dV_GP_S)+(((FdL*d_qim1_dV_GP_S)+(d_FdL_dV_GP_S*qim1))*Gvsatinv)));
        g_ideal = (BET_i*((FdL*qim1)*Gvsatinv));

        d_CGeff_dV_S_BP = (((Gmob_dL*Gmob_dL)*((((Gvsat*Gvsat)*COX_qm)*d_eta_p_dV_S_BP)+((((Gvsat*Gvsat)*d_COX_qm_dV_S_BP)+(((Gvsat*d_Gvsat_dV_S_BP)+(d_Gvsat_dV_S_BP*Gvsat))*COX_qm))*eta_p))-(((Gvsat*Gvsat)*COX_qm)*eta_p)*((Gmob_dL*d_Gmob_dL_dV_S_BP)+(d_Gmob_dL_dV_S_BP*Gmob_dL)))/(Gmob_dL*Gmob_dL)/(Gmob_dL*Gmob_dL));
        d_CGeff_dV_GP_S = (((Gmob_dL*Gmob_dL)*((((Gvsat*Gvsat)*COX_qm)*d_eta_p_dV_GP_S)+((((Gvsat*Gvsat)*d_COX_qm_dV_GP_S)+(((Gvsat*d_Gvsat_dV_GP_S)+(d_Gvsat_dV_GP_S*Gvsat))*COX_qm))*eta_p))-(((Gvsat*Gvsat)*COX_qm)*eta_p)*((Gmob_dL*d_Gmob_dL_dV_GP_S)+(d_Gmob_dL_dV_GP_S*Gmob_dL)))/(Gmob_dL*Gmob_dL)/(Gmob_dL*Gmob_dL));
        d_CGeff_dV_D_S = (((Gmob_dL*Gmob_dL)*((((Gvsat*Gvsat)*COX_qm)*d_eta_p_dV_D_S)+((((Gvsat*Gvsat)*d_COX_qm_dV_D_S)+(((Gvsat*d_Gvsat_dV_D_S)+(d_Gvsat_dV_D_S*Gvsat))*COX_qm))*eta_p))-(((Gvsat*Gvsat)*COX_qm)*eta_p)*((Gmob_dL*d_Gmob_dL_dV_D_S)+(d_Gmob_dL_dV_D_S*Gmob_dL)))/(Gmob_dL*Gmob_dL)/(Gmob_dL*Gmob_dL));
        CGeff = ((((Gvsat*Gvsat)*COX_qm)*eta_p)/(Gmob_dL*Gmob_dL));

        d_mid_dV_S_BP = ((d_t1_dV_S_BP+(12*d_t2_dV_S_BP))-(24*((((1.0+t1)*t2)*d_r_dV_S_BP)+((((1.0+t1)*d_t2_dV_S_BP)+(d_t1_dV_S_BP*t2))*r))));
        d_mid_dV_GP_S = ((d_t1_dV_GP_S+(12*d_t2_dV_GP_S))-(24*((((1.0+t1)*t2)*d_r_dV_GP_S)+((((1.0+t1)*d_t2_dV_GP_S)+(d_t1_dV_GP_S*t2))*r))));
        d_mid_dV_D_S = ((d_t1_dV_D_S+(12*d_t2_dV_D_S))-(24*((((1.0+t1)*t2)*d_r_dV_D_S)+((((1.0+t1)*d_t2_dV_D_S)+(d_t1_dV_D_S*t2))*r))));
        mid = ((t1+(12*t2))-(24*(((1.0+t1)*t2)*r)));

        d_mid_dV_S_BP = ((mid>1e-40)?d_mid_dV_S_BP:0.0);
        d_mid_dV_GP_S = ((mid>1e-40)?d_mid_dV_GP_S:0.0);
        d_mid_dV_D_S = ((mid>1e-40)?d_mid_dV_D_S:0.0);
        mid = ((mid>1e-40)?mid:1e-40);

        d_mid_dV_S_BP = (((g_ideal*lcinv2)*d_mid_dV_S_BP)+(((g_ideal*d_lcinv2_dV_S_BP)+(d_g_ideal_dV_S_BP*lcinv2))*mid));
        d_mid_dV_D_S = (((g_ideal*lcinv2)*d_mid_dV_D_S)+(((g_ideal*d_lcinv2_dV_D_S)+(d_g_ideal_dV_D_S*lcinv2))*mid));
        d_mid_dV_GP_S = (((g_ideal*lcinv2)*d_mid_dV_GP_S)+(((g_ideal*d_lcinv2_dV_GP_S)+(d_g_ideal_dV_GP_S*lcinv2))*mid));
        mid = ((g_ideal*lcinv2)*mid);

        d_mig_dV_S_BP = (((d_t1_dV_S_BP/12.0)-((t2*(d_t1_dV_S_BP-(12*d_t2_dV_S_BP)))+(d_t2_dV_S_BP*((t1+0.2)-(12*t2)))))-(1.6*(((t2*((t1+1.0)-(12*t2)))*d_r_dV_S_BP)+(((t2*(d_t1_dV_S_BP-(12*d_t2_dV_S_BP)))+(d_t2_dV_S_BP*((t1+1.0)-(12*t2))))*r))));
        d_mig_dV_GP_S = (((d_t1_dV_GP_S/12.0)-((t2*(d_t1_dV_GP_S-(12*d_t2_dV_GP_S)))+(d_t2_dV_GP_S*((t1+0.2)-(12*t2)))))-(1.6*(((t2*((t1+1.0)-(12*t2)))*d_r_dV_GP_S)+(((t2*(d_t1_dV_GP_S-(12*d_t2_dV_GP_S)))+(d_t2_dV_GP_S*((t1+1.0)-(12*t2))))*r))));
        d_mig_dV_D_S = (((d_t1_dV_D_S/12.0)-((t2*(d_t1_dV_D_S-(12*d_t2_dV_D_S)))+(d_t2_dV_D_S*((t1+0.2)-(12*t2)))))-(1.6*(((t2*((t1+1.0)-(12*t2)))*d_r_dV_D_S)+(((t2*(d_t1_dV_D_S-(12*d_t2_dV_D_S)))+(d_t2_dV_D_S*((t1+1.0)-(12*t2))))*r))));
        mig = (((t1/12.0)-(t2*((t1+0.2)-(12*t2))))-(1.6*((t2*((t1+1.0)-(12*t2)))*r)));

        d_mig_dV_S_BP = ((mig>1e-40)?d_mig_dV_S_BP:0.0);
        d_mig_dV_GP_S = ((mig>1e-40)?d_mig_dV_GP_S:0.0);
        d_mig_dV_D_S = ((mig>1e-40)?d_mig_dV_D_S:0.0);
        mig = ((mig>1e-40)?mig:1e-40);

        d_mig_dV_S_BP = (((lcinv2/g_ideal)*d_mig_dV_S_BP)+(((g_ideal*d_lcinv2_dV_S_BP-lcinv2*d_g_ideal_dV_S_BP)/g_ideal/g_ideal)*mig));
        d_mig_dV_GP_S = (((lcinv2/g_ideal)*d_mig_dV_GP_S)+(((g_ideal*d_lcinv2_dV_GP_S-lcinv2*d_g_ideal_dV_GP_S)/g_ideal/g_ideal)*mig));
        d_mig_dV_D_S = (((lcinv2/g_ideal)*d_mig_dV_D_S)+(((g_ideal*d_lcinv2_dV_D_S-lcinv2*d_g_ideal_dV_D_S)/g_ideal/g_ideal)*mig));
        mig = ((lcinv2/g_ideal)*mig);

        d_migid_dV_S_BP = (((lcinv2*sqt2)*((-(12*d_t2_dV_S_BP))-((((t1+(19.2*t2))-(12*(t1*t2)))*d_r_dV_S_BP)+(((d_t1_dV_S_BP+(19.2*d_t2_dV_S_BP))-(12*((t1*d_t2_dV_S_BP)+(d_t1_dV_S_BP*t2))))*r))))+(((lcinv2*d_sqt2_dV_S_BP)+(d_lcinv2_dV_S_BP*sqt2))*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r))));
        d_migid_dV_GP_S = (((lcinv2*sqt2)*((-(12*d_t2_dV_GP_S))-((((t1+(19.2*t2))-(12*(t1*t2)))*d_r_dV_GP_S)+(((d_t1_dV_GP_S+(19.2*d_t2_dV_GP_S))-(12*((t1*d_t2_dV_GP_S)+(d_t1_dV_GP_S*t2))))*r))))+(((lcinv2*d_sqt2_dV_GP_S)+(d_lcinv2_dV_GP_S*sqt2))*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r))));
        d_migid_dV_D_S = (((lcinv2*sqt2)*((-(12*d_t2_dV_D_S))-((((t1+(19.2*t2))-(12*(t1*t2)))*d_r_dV_D_S)+(((d_t1_dV_D_S+(19.2*d_t2_dV_D_S))-(12*((t1*d_t2_dV_D_S)+(d_t1_dV_D_S*t2))))*r))))+(((lcinv2*d_sqt2_dV_D_S)+(d_lcinv2_dV_D_S*sqt2))*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r))));
        migid = ((lcinv2*sqt2)*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r)));
        if ((FNTEXC_i>0))
        {

          d_temp2_exc_dV_S_BP = ((qim*d_xitsb_dV_S_BP)+(d_qim_dV_S_BP*xitsb));
          d_temp2_exc_dV_GP_S = (d_qim_dV_GP_S*xitsb);
          d_temp2_exc_dV_D_S = ((qim*d_xitsb_dV_D_S)+(d_qim_dV_D_S*xitsb));
          temp2_exc = (qim*xitsb);

          d_wsat_exc_dV_S_BP = (100.0*(((100.0+temp2_exc)*d_temp2_exc_dV_S_BP-temp2_exc*d_temp2_exc_dV_S_BP)/(100.0+temp2_exc)/(100.0+temp2_exc)));
          d_wsat_exc_dV_GP_S = (100.0*(((100.0+temp2_exc)*d_temp2_exc_dV_GP_S-temp2_exc*d_temp2_exc_dV_GP_S)/(100.0+temp2_exc)/(100.0+temp2_exc)));
          d_wsat_exc_dV_D_S = (100.0*(((100.0+temp2_exc)*d_temp2_exc_dV_D_S-temp2_exc*d_temp2_exc_dV_D_S)/(100.0+temp2_exc)/(100.0+temp2_exc)));
          wsat_exc = (100.0*(temp2_exc/(100.0+temp2_exc)));
          if ((THESATG_i<0))
          {

            d_temp_exc_dV_S_BP = (-1*(-(THESATG_i*d_wsat_exc_dV_S_BP))/(1-(THESATG_i*wsat_exc))/(1-(THESATG_i*wsat_exc)));
            d_temp_exc_dV_GP_S = (-1*(-(THESATG_i*d_wsat_exc_dV_GP_S))/(1-(THESATG_i*wsat_exc))/(1-(THESATG_i*wsat_exc)));
            d_temp_exc_dV_D_S = (-1*(-(THESATG_i*d_wsat_exc_dV_D_S))/(1-(THESATG_i*wsat_exc))/(1-(THESATG_i*wsat_exc)));
            temp_exc = (1/(1-(THESATG_i*wsat_exc)));
          }
          else
          {

            d_temp_exc_dV_S_BP = (THESATG_i*d_wsat_exc_dV_S_BP);
            d_temp_exc_dV_GP_S = (THESATG_i*d_wsat_exc_dV_GP_S);
            d_temp_exc_dV_D_S = (THESATG_i*d_wsat_exc_dV_D_S);
            temp_exc = (1+(THESATG_i*wsat_exc));
          }

          d_thesat1_exc_dV_S_BP = (THESAT_i*((Gmob*d_temp_exc_dV_S_BP-temp_exc*d_Gmob_dV_S_BP)/Gmob/Gmob));
          d_thesat1_exc_dV_GP_S = (THESAT_i*((Gmob*d_temp_exc_dV_GP_S-temp_exc*d_Gmob_dV_GP_S)/Gmob/Gmob));
          d_thesat1_exc_dV_D_S = (THESAT_i*((Gmob*d_temp_exc_dV_D_S-temp_exc*d_Gmob_dV_D_S)/Gmob/Gmob));
          thesat1_exc = (THESAT_i*(temp_exc/Gmob));

          d_zsat_exc_dV_S_BP = ((((thesat1_exc*thesat1_exc)*dps)*d_dps_dV_S_BP)+((((thesat1_exc*thesat1_exc)*d_dps_dV_S_BP)+(((thesat1_exc*d_thesat1_exc_dV_S_BP)+(d_thesat1_exc_dV_S_BP*thesat1_exc))*dps))*dps));
          d_zsat_exc_dV_GP_S = ((((thesat1_exc*thesat1_exc)*dps)*d_dps_dV_GP_S)+((((thesat1_exc*thesat1_exc)*d_dps_dV_GP_S)+(((thesat1_exc*d_thesat1_exc_dV_GP_S)+(d_thesat1_exc_dV_GP_S*thesat1_exc))*dps))*dps));
          d_zsat_exc_dV_D_S = ((((thesat1_exc*thesat1_exc)*dps)*d_dps_dV_D_S)+((((thesat1_exc*thesat1_exc)*d_dps_dV_D_S)+(((thesat1_exc*d_thesat1_exc_dV_D_S)+(d_thesat1_exc_dV_D_S*thesat1_exc))*dps))*dps));
          zsat_exc = (((thesat1_exc*thesat1_exc)*dps)*dps);
          if (((model_.CHNL_TYPE)==(-1)))
          {

            d_zsat_exc_dV_S_BP = (((1.0+(thesat1_exc*dps))*d_zsat_exc_dV_S_BP-zsat_exc*((thesat1_exc*d_dps_dV_S_BP)+(d_thesat1_exc_dV_S_BP*dps)))/(1.0+(thesat1_exc*dps))/(1.0+(thesat1_exc*dps)));
            d_zsat_exc_dV_GP_S = (((1.0+(thesat1_exc*dps))*d_zsat_exc_dV_GP_S-zsat_exc*((thesat1_exc*d_dps_dV_GP_S)+(d_thesat1_exc_dV_GP_S*dps)))/(1.0+(thesat1_exc*dps))/(1.0+(thesat1_exc*dps)));
            d_zsat_exc_dV_D_S = (((1.0+(thesat1_exc*dps))*d_zsat_exc_dV_D_S-zsat_exc*((thesat1_exc*d_dps_dV_D_S)+(d_thesat1_exc_dV_D_S*dps)))/(1.0+(thesat1_exc*dps))/(1.0+(thesat1_exc*dps)));
            zsat_exc = (zsat_exc/(1.0+(thesat1_exc*dps)));
          }
          {
            double value_sqrt_0 = sqrt((1.0+(2.0*zsat_exc)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Gvsat_exc_dV_S_BP = (0.5*((Gmob*(deriv_sqrt_0_d0*((2.0*d_zsat_exc_dV_S_BP))))+(d_Gmob_dV_S_BP*(1.0+value_sqrt_0))));
            d_Gvsat_exc_dV_GP_S = (0.5*((Gmob*(deriv_sqrt_0_d0*((2.0*d_zsat_exc_dV_GP_S))))+(d_Gmob_dV_GP_S*(1.0+value_sqrt_0))));
            d_Gvsat_exc_dV_D_S = (0.5*((Gmob*(deriv_sqrt_0_d0*((2.0*d_zsat_exc_dV_D_S))))+(d_Gmob_dV_D_S*(1.0+value_sqrt_0))));
            Gvsat_exc = (0.5*(Gmob*(1.0+value_sqrt_0)));
          }

          d_gfac_dV_S_BP = (((Gvsat_exc*lc)*d_Gmob_dV_S_BP-Gmob*((Gvsat_exc*d_lc_dV_S_BP)+(d_Gvsat_exc_dV_S_BP*lc)))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
          d_gfac_dV_GP_S = (((Gvsat_exc*lc)*d_Gmob_dV_GP_S-Gmob*((Gvsat_exc*d_lc_dV_GP_S)+(d_Gvsat_exc_dV_GP_S*lc)))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
          d_gfac_dV_D_S = (((Gvsat_exc*lc)*d_Gmob_dV_D_S-Gmob*((Gvsat_exc*d_lc_dV_D_S)+(d_Gvsat_exc_dV_D_S*lc)))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
          gfac = (Gmob/(Gvsat_exc*lc));

          d_Sidexc_dV_S_BP = (((((fac_exc*Ids)*Vdse)*gfac)*d_gfac_dV_S_BP)+(((((fac_exc*Ids)*Vdse)*d_gfac_dV_S_BP)+((((fac_exc*Ids)*d_Vdse_dV_S_BP)+((fac_exc*d_Ids_dV_S_BP)*Vdse))*gfac))*gfac));
          d_Sidexc_dV_D_S = (((((fac_exc*Ids)*Vdse)*gfac)*d_gfac_dV_D_S)+(((((fac_exc*Ids)*Vdse)*d_gfac_dV_D_S)+((((fac_exc*Ids)*d_Vdse_dV_D_S)+((fac_exc*d_Ids_dV_D_S)*Vdse))*gfac))*gfac));
          d_Sidexc_dV_GP_S = (((((fac_exc*Ids)*Vdse)*gfac)*d_gfac_dV_GP_S)+(((((fac_exc*Ids)*Vdse)*d_gfac_dV_GP_S)+((((fac_exc*Ids)*d_Vdse_dV_GP_S)+((fac_exc*d_Ids_dV_GP_S)*Vdse))*gfac))*gfac));
          Sidexc = ((((fac_exc*Ids)*Vdse)*gfac)*gfac);

          d_mid_dV_S_BP = (d_mid_dV_S_BP+(d_Sidexc_dV_S_BP/(model_.nt0)));
          d_mid_dV_GP_S = (d_mid_dV_GP_S+(d_Sidexc_dV_GP_S/(model_.nt0)));
          d_mid_dV_D_S = (d_mid_dV_D_S+(d_Sidexc_dV_D_S/(model_.nt0)));
          mid = (mid+(Sidexc/(model_.nt0)));

          d_mig_dV_S_BP = (d_mig_dV_S_BP+(((((12*g_ideal)*g_ideal)*(model_.nt0))*((Sidexc*(12*d_t2_dV_S_BP))+(d_Sidexc_dV_S_BP*(1+(12*t2))))-(Sidexc*(1+(12*t2)))*((((12*g_ideal)*d_g_ideal_dV_S_BP)+((12*d_g_ideal_dV_S_BP)*g_ideal))*(model_.nt0)))/(((12*g_ideal)*g_ideal)*(model_.nt0))/(((12*g_ideal)*g_ideal)*(model_.nt0))));
          d_mig_dV_GP_S = (d_mig_dV_GP_S+(((((12*g_ideal)*g_ideal)*(model_.nt0))*((Sidexc*(12*d_t2_dV_GP_S))+(d_Sidexc_dV_GP_S*(1+(12*t2))))-(Sidexc*(1+(12*t2)))*((((12*g_ideal)*d_g_ideal_dV_GP_S)+((12*d_g_ideal_dV_GP_S)*g_ideal))*(model_.nt0)))/(((12*g_ideal)*g_ideal)*(model_.nt0))/(((12*g_ideal)*g_ideal)*(model_.nt0))));
          d_mig_dV_D_S = (d_mig_dV_D_S+(((((12*g_ideal)*g_ideal)*(model_.nt0))*((Sidexc*(12*d_t2_dV_D_S))+(d_Sidexc_dV_D_S*(1+(12*t2))))-(Sidexc*(1+(12*t2)))*((((12*g_ideal)*d_g_ideal_dV_D_S)+((12*d_g_ideal_dV_D_S)*g_ideal))*(model_.nt0)))/(((12*g_ideal)*g_ideal)*(model_.nt0))/(((12*g_ideal)*g_ideal)*(model_.nt0))));
          mig = (mig+((Sidexc*(1+(12*t2)))/(((12*g_ideal)*g_ideal)*(model_.nt0))));

          d_migid_dV_S_BP = (d_migid_dV_S_BP-(((g_ideal*(model_.nt0))*(((Sidexc*sqt2)*d_r_dV_S_BP)+(((Sidexc*d_sqt2_dV_S_BP)+(d_Sidexc_dV_S_BP*sqt2))*(1+r)))-((Sidexc*sqt2)*(1+r))*(d_g_ideal_dV_S_BP*(model_.nt0)))/(g_ideal*(model_.nt0))/(g_ideal*(model_.nt0))));
          d_migid_dV_GP_S = (d_migid_dV_GP_S-(((g_ideal*(model_.nt0))*(((Sidexc*sqt2)*d_r_dV_GP_S)+(((Sidexc*d_sqt2_dV_GP_S)+(d_Sidexc_dV_GP_S*sqt2))*(1+r)))-((Sidexc*sqt2)*(1+r))*(d_g_ideal_dV_GP_S*(model_.nt0)))/(g_ideal*(model_.nt0))/(g_ideal*(model_.nt0))));
          d_migid_dV_D_S = (d_migid_dV_D_S-(((g_ideal*(model_.nt0))*(((Sidexc*sqt2)*d_r_dV_D_S)+(((Sidexc*d_sqt2_dV_D_S)+(d_Sidexc_dV_D_S*sqt2))*(1+r)))-((Sidexc*sqt2)*(1+r))*(d_g_ideal_dV_D_S*(model_.nt0)))/(g_ideal*(model_.nt0))/(g_ideal*(model_.nt0))));
          migid = (migid-(((Sidexc*sqt2)*(1+r))/(g_ideal*(model_.nt0))));
        }
        {
          double value_sqrt_0 = sqrt((nt*mid));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_sqid_dV_S_BP = (deriv_sqrt_0_d0*((nt*d_mid_dV_S_BP)));
          d_sqid_dV_GP_S = (deriv_sqrt_0_d0*((nt*d_mid_dV_GP_S)));
          d_sqid_dV_D_S = (deriv_sqrt_0_d0*((nt*d_mid_dV_D_S)));
          sqid = value_sqrt_0;
        }
        {
          double value_sqrt_0 = sqrt((nt/mig));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_sqig_dV_S_BP = (deriv_sqrt_0_d0*((-nt*d_mig_dV_S_BP/mig/mig)));
          d_sqig_dV_GP_S = (deriv_sqrt_0_d0*((-nt*d_mig_dV_GP_S/mig/mig)));
          d_sqig_dV_D_S = (deriv_sqrt_0_d0*((-nt*d_mig_dV_D_S/mig/mig)));
          sqig = value_sqrt_0;
        }
        if ((sqid==0))
        {

          d_c_igid_dV_D_S = d_c_igid_dV_GP_S = d_c_igid_dV_S_BP =  0.0;
          c_igid = 0.0;
        }
        else
        {

          d_c_igid_dV_S_BP = ((sqid*((migid*d_sqig_dV_S_BP)+(d_migid_dV_S_BP*sqig))-(migid*sqig)*d_sqid_dV_S_BP)/sqid/sqid);
          d_c_igid_dV_GP_S = ((sqid*((migid*d_sqig_dV_GP_S)+(d_migid_dV_GP_S*sqig))-(migid*sqig)*d_sqid_dV_GP_S)/sqid/sqid);
          d_c_igid_dV_D_S = ((sqid*((migid*d_sqig_dV_D_S)+(d_migid_dV_D_S*sqig))-(migid*sqig)*d_sqid_dV_D_S)/sqid/sqid);
          c_igid = ((migid*sqig)/sqid);
        }

        d_c_igid_dV_S_BP = ((c_igid>0.0)?((c_igid<1.0)?d_c_igid_dV_S_BP:0.0):0.0);
        d_c_igid_dV_GP_S = ((c_igid>0.0)?((c_igid<1.0)?d_c_igid_dV_GP_S:0.0):0.0);
        d_c_igid_dV_D_S = ((c_igid>0.0)?((c_igid<1.0)?d_c_igid_dV_D_S:0.0):0.0);
        c_igid = ((c_igid>0.0)?((c_igid<1.0)?c_igid:1.0):0.0);
      }
      {
        double value_fabs_0 = fabs(Igcs);
        double  deriv_fabs_0_d0 = (((Igcs)>=0)?(+1.0):(-1.0));

        d_shot_igcsx_dV_S_BP = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igcs_dV_S_BP)));
        d_shot_igcsx_dV_D_S = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igcs_dV_D_S)));
        d_shot_igcsx_dV_GP_S = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igcs_dV_GP_S)));
        shot_igcsx = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        double value_fabs_0 = fabs(Igcd);
        double  deriv_fabs_0_d0 = (((Igcd)>=0)?(+1.0):(-1.0));

        d_shot_igcdx_dV_S_BP = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igcd_dV_S_BP)));
        d_shot_igcdx_dV_D_S = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igcd_dV_D_S)));
        d_shot_igcdx_dV_GP_S = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igcd_dV_GP_S)));
        shot_igcdx = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        double value_fabs_0 = fabs(Igsov);
        double  deriv_fabs_0_d0 = (((Igsov)>=0)?(+1.0):(-1.0));

        d_shot_igsov_dV_S_BP = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igsov_dV_S_BP)));
        d_shot_igsov_dV_D_S = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igsov_dV_D_S)));
        d_shot_igsov_dV_GP_S = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igsov_dV_GP_S)));
        shot_igsov = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        double value_fabs_0 = fabs(Igdov);
        double  deriv_fabs_0_d0 = (((Igdov)>=0)?(+1.0):(-1.0));

        d_shot_igdov_dV_S_BP = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igdov_dV_S_BP)));
        d_shot_igdov_dV_D_S = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igdov_dV_D_S)));
        d_shot_igdov_dV_GP_S = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igdov_dV_GP_S)));
        shot_igdov = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        double value_fabs_0 = fabs(Iimpact);
        double  deriv_fabs_0_d0 = (((Iimpact)>=0)?(+1.0):(-1.0));

        d_shot_iavl_dV_S_BP = ((2.0*1.6021918E-19)*(((mavl+1)*(deriv_fabs_0_d0*(d_Iimpact_dV_S_BP)))+(d_mavl_dV_S_BP*value_fabs_0)));
        d_shot_iavl_dV_GP_S = ((2.0*1.6021918E-19)*(((mavl+1)*(deriv_fabs_0_d0*(d_Iimpact_dV_GP_S)))+(d_mavl_dV_GP_S*value_fabs_0)));
        d_shot_iavl_dV_D_S = ((2.0*1.6021918E-19)*(((mavl+1)*(deriv_fabs_0_d0*(d_Iimpact_dV_D_S)))+(d_mavl_dV_D_S*value_fabs_0)));
        shot_iavl = ((2.0*1.6021918E-19)*((mavl+1)*value_fabs_0));
      }
      {
        double value_fabs_0 = fabs(ijun_s);
        double  deriv_fabs_0_d0 = (((ijun_s)>=0)?(+1.0):(-1.0));

        d_jnoisex_s_dV_S_BS = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_ijun_s_dV_S_BS)));
        d_jnoisex_s_dV_D_BD = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_ijun_s_dV_D_BD)));
        jnoisex_s = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        double value_fabs_0 = fabs(ijun_d);
        double  deriv_fabs_0_d0 = (((ijun_d)>=0)?(+1.0):(-1.0));

        d_jnoisex_d_dV_S_BS = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_ijun_d_dV_S_BS)));
        d_jnoisex_d_dV_D_BD = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_ijun_d_dV_D_BD)));
        jnoisex_d = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      if ((sigVds>0))
      {

        d_shot_igs_dV_S_BP = (d_shot_igcsx_dV_S_BP+d_shot_igsov_dV_S_BP);
        d_shot_igs_dV_D_S = (d_shot_igcsx_dV_D_S+d_shot_igsov_dV_D_S);
        d_shot_igs_dV_GP_S = (d_shot_igcsx_dV_GP_S+d_shot_igsov_dV_GP_S);
        shot_igs = (shot_igcsx+shot_igsov);

        d_shot_igd_dV_S_BP = (d_shot_igcdx_dV_S_BP+d_shot_igdov_dV_S_BP);
        d_shot_igd_dV_D_S = (d_shot_igcdx_dV_D_S+d_shot_igdov_dV_D_S);
        d_shot_igd_dV_GP_S = (d_shot_igcdx_dV_GP_S+d_shot_igdov_dV_GP_S);
        shot_igd = (shot_igcdx+shot_igdov);

        d_jnoise_s_dV_D_S = d_jnoise_s_dV_GP_S = d_jnoise_s_dV_S_BP =  0.0;
        d_jnoise_s_dV_S_BS = d_jnoisex_s_dV_S_BS;
        d_jnoise_s_dV_D_BD = d_jnoisex_s_dV_D_BD;
        jnoise_s = jnoisex_s;

        d_jnoise_d_dV_S_BP = d_shot_iavl_dV_S_BP;
        d_jnoise_d_dV_GP_S = d_shot_iavl_dV_GP_S;
        d_jnoise_d_dV_D_S = d_shot_iavl_dV_D_S;
        d_jnoise_d_dV_S_BS = d_jnoisex_d_dV_S_BS;
        d_jnoise_d_dV_D_BD = d_jnoisex_d_dV_D_BD;
        jnoise_d = (jnoisex_d+shot_iavl);
      }
      else
      {

        d_shot_igs_dV_S_BP = (d_shot_igcdx_dV_S_BP+d_shot_igsov_dV_S_BP);
        d_shot_igs_dV_D_S = (d_shot_igcdx_dV_D_S+d_shot_igsov_dV_D_S);
        d_shot_igs_dV_GP_S = (d_shot_igcdx_dV_GP_S+d_shot_igsov_dV_GP_S);
        shot_igs = (shot_igcdx+shot_igsov);

        d_shot_igd_dV_S_BP = (d_shot_igcsx_dV_S_BP+d_shot_igdov_dV_S_BP);
        d_shot_igd_dV_D_S = (d_shot_igcsx_dV_D_S+d_shot_igdov_dV_D_S);
        d_shot_igd_dV_GP_S = (d_shot_igcsx_dV_GP_S+d_shot_igdov_dV_GP_S);
        shot_igd = (shot_igcsx+shot_igdov);

        d_jnoise_s_dV_S_BP = d_shot_iavl_dV_S_BP;
        d_jnoise_s_dV_GP_S = d_shot_iavl_dV_GP_S;
        d_jnoise_s_dV_D_S = d_shot_iavl_dV_D_S;
        d_jnoise_s_dV_S_BS = d_jnoisex_s_dV_S_BS;
        d_jnoise_s_dV_D_BD = d_jnoisex_s_dV_D_BD;
        jnoise_s = (jnoisex_s+shot_iavl);

        d_jnoise_d_dV_D_S = d_jnoise_d_dV_GP_S = d_jnoise_d_dV_S_BP =  0.0;
        d_jnoise_d_dV_S_BS = d_jnoisex_d_dV_S_BS;
        d_jnoise_d_dV_D_BD = d_jnoisex_d_dV_D_BD;
        jnoise_d = jnoisex_d;
      }

      d_sf_dV_S_BP = (((1e6*CGeff)*d_mig_dV_S_BP)+((1e6*d_CGeff_dV_S_BP)*mig));
      d_sf_dV_GP_S = (((1e6*CGeff)*d_mig_dV_GP_S)+((1e6*d_CGeff_dV_GP_S)*mig));
      d_sf_dV_D_S = (((1e6*CGeff)*d_mig_dV_D_S)+((1e6*d_CGeff_dV_D_S)*mig));
      sf = ((1e6*CGeff)*mig);
      // I(NOI2,GND) <+ (V(NOI2,GND))
      staticContributions[admsNodeID_NOI2] += (probeVars[admsProbeID_V_NOI2_GND]);
      d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND] += d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND];
      // I(NOI2,GND) <+ (white_noise((((sqig*sqig)*sf)*sf),"igig"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[5]= (((sqig*sqig)*sf)*sf);
      }
      // I(NOI,GND) <+ (((-V(NOI2,GND))/sf))
      staticContributions[admsNodeID_NOI] += ((-(probeVars[admsProbeID_V_NOI2_GND]))/sf);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP] += (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_S_BP/sf/sf);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S] += (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_GP_S/sf/sf);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S] += (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_D_S/sf/sf);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND] += ((-d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND])/sf);
      // I(NOI,GND) <+ ((V(NOI,GND)/mig))
      staticContributions[admsNodeID_NOI] += ((probeVars[admsProbeID_V_NOI_GND])/mig);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP] += (-(probeVars[admsProbeID_V_NOI_GND])*d_mig_dV_S_BP/mig/mig);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S] += (-(probeVars[admsProbeID_V_NOI_GND])*d_mig_dV_GP_S/mig/mig);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S] += (-(probeVars[admsProbeID_V_NOI_GND])*d_mig_dV_D_S/mig/mig);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] += (d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]/mig);
      // I(NOI,GND) <+ (ddt((CGeff*V(NOI,GND))))
      dynamicContributions[admsNodeID_NOI] += ((CGeff*(probeVars[admsProbeID_V_NOI_GND])));
      d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] += ((CGeff*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]));
      d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BP] += ((d_CGeff_dV_S_BP*(probeVars[admsProbeID_V_NOI_GND])));
      d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_S] += ((d_CGeff_dV_GP_S*(probeVars[admsProbeID_V_NOI_GND])));
      d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_S] += ((d_CGeff_dV_D_S*(probeVars[admsProbeID_V_NOI_GND])));
      // I(D,S) <+ (flicker_noise((MULT_i*Sfl),EF_i,"flicker"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[6]= (MULT_i*Sfl);
        noiseContribsExponent[6]= EF_i;
      }
      // I(D,S) <+ (white_noise((((MULT_i*sqid)*sqid)*(1.0-(c_igid*c_igid))),"idid"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[7]= (((MULT_i*sqid)*sqid)*(1.0-(c_igid*c_igid)));
      }
      // I(D,S) <+ (((((sigVds*sqrt(MULT_i))*migid)*V(NOI2,GND))/sf))
      {
        double value_sqrt_0 = sqrt(MULT_i);
        staticContributions[admsNodeID_D] += ((((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))/sf);
        d_staticContributions[admsNodeID_D][admsProbeID_V_NOI2_GND] += ((((sigVds*value_sqrt_0)*migid)*d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND])/sf);
        d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] += ((sf*(((sigVds*value_sqrt_0)*d_migid_dV_S_BP)*(probeVars[admsProbeID_V_NOI2_GND]))-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_S_BP)/sf/sf);
        d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] += ((sf*(((sigVds*value_sqrt_0)*d_migid_dV_GP_S)*(probeVars[admsProbeID_V_NOI2_GND]))-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_GP_S)/sf/sf);
        d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += ((sf*(((sigVds*value_sqrt_0)*d_migid_dV_D_S)*(probeVars[admsProbeID_V_NOI2_GND]))-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_D_S)/sf/sf);
        staticContributions[admsNodeID_S] -= ((((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))/sf);
        d_staticContributions[admsNodeID_S][admsProbeID_V_NOI2_GND] -= ((((sigVds*value_sqrt_0)*migid)*d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND])/sf);
        d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] -= ((sf*(((sigVds*value_sqrt_0)*d_migid_dV_S_BP)*(probeVars[admsProbeID_V_NOI2_GND]))-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_S_BP)/sf/sf);
        d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -= ((sf*(((sigVds*value_sqrt_0)*d_migid_dV_GP_S)*(probeVars[admsProbeID_V_NOI2_GND]))-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_GP_S)/sf/sf);
        d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= ((sf*(((sigVds*value_sqrt_0)*d_migid_dV_D_S)*(probeVars[admsProbeID_V_NOI2_GND]))-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_D_S)/sf/sf);
      }
      // I(GP,S) <+ (ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND))))
      {
        double value_sqrt_0 = sqrt(MULT_i);
        dynamicContributions[admsNodeID_GP] += ((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] += ((((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((((value_sqrt_0*0.5)*d_CGeff_dV_S_BP)*(probeVars[admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((((value_sqrt_0*0.5)*d_CGeff_dV_GP_S)*(probeVars[admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((((value_sqrt_0*0.5)*d_CGeff_dV_D_S)*(probeVars[admsProbeID_V_NOI_GND])));
        dynamicContributions[admsNodeID_S] -= ((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI_GND] -= ((((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]));
        d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP] -= ((((value_sqrt_0*0.5)*d_CGeff_dV_S_BP)*(probeVars[admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] -= ((((value_sqrt_0*0.5)*d_CGeff_dV_GP_S)*(probeVars[admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= ((((value_sqrt_0*0.5)*d_CGeff_dV_D_S)*(probeVars[admsProbeID_V_NOI_GND])));
      }
      // I(GP,D) <+ (ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND))))
      {
        double value_sqrt_0 = sqrt(MULT_i);
        dynamicContributions[admsNodeID_GP] += ((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] += ((((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((((value_sqrt_0*0.5)*d_CGeff_dV_S_BP)*(probeVars[admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((((value_sqrt_0*0.5)*d_CGeff_dV_GP_S)*(probeVars[admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((((value_sqrt_0*0.5)*d_CGeff_dV_D_S)*(probeVars[admsProbeID_V_NOI_GND])));
        dynamicContributions[admsNodeID_D] -= ((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI_GND] -= ((((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]));
        d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP] -= ((((value_sqrt_0*0.5)*d_CGeff_dV_S_BP)*(probeVars[admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S] -= ((((value_sqrt_0*0.5)*d_CGeff_dV_GP_S)*(probeVars[admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] -= ((((value_sqrt_0*0.5)*d_CGeff_dV_D_S)*(probeVars[admsProbeID_V_NOI_GND])));
      }
      // I(GP,S) <+ (white_noise((MULT_i*shot_igs),"igs"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[8]= (MULT_i*shot_igs);
      }
      // I(GP,D) <+ (white_noise((MULT_i*shot_igd),"igd"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[9]= (MULT_i*shot_igd);
      }
      // I(BS,S) <+ (white_noise((MULT_i*jnoise_s),"ibs"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[10]= (MULT_i*jnoise_s);
      }
      // I(BD,D) <+ (white_noise((MULT_i*jnoise_d),"ibd"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[11]= (MULT_i*jnoise_d);
      }
    }
    // End block noise
  }
  // End block evaluateblock


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_NOI_GND] =  "
                 <<probeVars[admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_NOI2_GND] =  "
                 <<probeVars[admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_D_BD] =  "
                 <<probeVars[admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_S_BS] =  "
                 <<probeVars[admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_S_BP] =  "
                 <<probeVars[admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_D_S] =  "
                 <<probeVars[admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_GP_S] =  "
                 <<probeVars[admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_B_BI] =  "
                 <<probeVars[admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BP_BI] =  "
                 <<probeVars[admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BD_BI] =  "
                 <<probeVars[admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BS_BI] =  "
                 <<probeVars[admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_G_GP] =  "
                 <<probeVars[admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_D] =  "
                 <<staticContributions[admsNodeID_D] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_D] =  "
                 <<dynamicContributions[admsNodeID_D] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_G] =  "
                 <<staticContributions[admsNodeID_G] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_G] =  "
                 <<dynamicContributions[admsNodeID_G] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_S] =  "
                 <<staticContributions[admsNodeID_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_S] =  "
                 <<dynamicContributions[admsNodeID_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_B] =  "
                 <<staticContributions[admsNodeID_B] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_B] =  "
                 <<dynamicContributions[admsNodeID_B] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_NOI] =  "
                 <<staticContributions[admsNodeID_NOI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_NOI] =  "
                 <<dynamicContributions[admsNodeID_NOI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_NOI2] =  "
                 <<staticContributions[admsNodeID_NOI2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_NOI2] =  "
                 <<dynamicContributions[admsNodeID_NOI2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_GP] =  "
                 <<staticContributions[admsNodeID_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_GP] =  "
                 <<dynamicContributions[admsNodeID_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BP] =  "
                 <<staticContributions[admsNodeID_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BP] =  "
                 <<dynamicContributions[admsNodeID_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BI] =  "
                 <<staticContributions[admsNodeID_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BI] =  "
                 <<dynamicContributions[admsNodeID_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BS] =  "
                 <<staticContributions[admsNodeID_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BS] =  "
                 <<dynamicContributions[admsNodeID_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BD] =  "
                 <<staticContributions[admsNodeID_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BD] =  "
                 <<dynamicContributions[admsNodeID_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_G_GP] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 4 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 11; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 4 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode];
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode];
      }
    }
  }
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
  return 12;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
  int numSources=getNumNoiseSources();
  noiseData.numSources = numSources;
  noiseData.resize(numSources);

  noiseData.deviceName = getName().getEncodedName();
  std::string theNoiseName;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_G_GP");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[0]=theNoiseName;
  noiseData.li_Pos[0]=li_G;
  noiseData.li_Neg[0]=li_GP;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BP_BI");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[1]=theNoiseName;
  noiseData.li_Pos[1]=li_BP;
  noiseData.li_Neg[1]=li_BI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BS_BI");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[2]=theNoiseName;
  noiseData.li_Pos[2]=li_BS;
  noiseData.li_Neg[2]=li_BI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BD_BI");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[3]=theNoiseName;
  noiseData.li_Pos[3]=li_BD;
  noiseData.li_Neg[3]=li_BI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_B_BI");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[4]=theNoiseName;
  noiseData.li_Pos[4]=li_B;
  noiseData.li_Neg[4]=li_BI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_NOI2_GND")+std::string("_")+std::string("igig");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[5]=theNoiseName;
  noiseData.li_Pos[5]=li_NOI2;
  noiseData.li_Neg[5]=-1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_D_S")+std::string("_")+std::string("flicker");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[6]=theNoiseName;
  noiseData.li_Pos[6]=li_D;
  noiseData.li_Neg[6]=li_S;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_D_S")+std::string("_")+std::string("idid");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[7]=theNoiseName;
  noiseData.li_Pos[7]=li_D;
  noiseData.li_Neg[7]=li_S;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_GP_S")+std::string("_")+std::string("igs");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[8]=theNoiseName;
  noiseData.li_Pos[8]=li_GP;
  noiseData.li_Neg[8]=li_S;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_GP_D")+std::string("_")+std::string("igd");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[9]=theNoiseName;
  noiseData.li_Pos[9]=li_GP;
  noiseData.li_Neg[9]=li_D;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BS_S")+std::string("_")+std::string("ibs");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[10]=theNoiseName;
  noiseData.li_Pos[10]=li_BS;
  noiseData.li_Neg[10]=li_S;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BD_D")+std::string("_")+std::string("ibd");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[11]=theNoiseName;
  noiseData.li_Pos[11]=li_BD;
  noiseData.li_Neg[11]=li_D;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
  noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
  noiseData.noiseDens[1] = noiseContribsPower[1];
  noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
  noiseData.noiseDens[2] = noiseContribsPower[2];
  noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
  noiseData.noiseDens[3] = noiseContribsPower[3];
  noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
  noiseData.noiseDens[4] = noiseContribsPower[4];
  noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
  noiseData.noiseDens[5] = noiseContribsPower[5];
  noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
  noiseData.noiseDens[6] = noiseContribsPower[6];

  noiseData.noiseDens[6] /= pow(noiseData.freq,noiseContribsExponent[6]);noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
  noiseData.noiseDens[7] = noiseContribsPower[7];
  noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
  noiseData.noiseDens[8] = noiseContribsPower[8];
  noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
  noiseData.noiseDens[9] = noiseContribsPower[9];
  noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
  noiseData.noiseDens[10] = noiseContribsPower[10];
  noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));
  noiseData.noiseDens[11] = noiseContribsPower[11];
  noiseData.lnNoiseDens[11] = std::log(std::max(noiseData.noiseDens[11],N_MINLOG));

}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_D_Equ_S_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_S_BS] -d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP];
  (*f_D_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP];
  (*f_BP_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  (*f_BP_Equ_BP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] -d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  (*f_D_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_D_BD] +d_staticContributions[admsNodeID_D][admsProbeID_V_D_S];
  (*f_BP_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S];
  (*f_D_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S];
  (*f_BP_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S];
  (*f_S_Equ_S_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_S_BS] -d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP];
  (*f_S_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP];
  (*f_S_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_D_BD] +d_staticContributions[admsNodeID_S][admsProbeID_V_D_S];
  (*f_S_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S];
  (*f_GP_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  (*f_GP_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  (*f_GP_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S];
  (*f_GP_Equ_GP_Node_Ptr) +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] +d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S];
  (*f_BS_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BP] +d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  (*f_BS_Equ_BS_Node_Ptr) +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  (*f_S_Equ_BS_Node_Ptr) +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_BS];
  (*f_BS_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  (*f_BS_Equ_BD_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  (*f_S_Equ_BD_Node_Ptr) +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_D_BD];
  (*f_BD_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BP] +d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  (*f_BD_Equ_BS_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  (*f_D_Equ_BS_Node_Ptr) +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_S_BS];
  (*f_BD_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  (*f_BD_Equ_BD_Node_Ptr) +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  (*f_D_Equ_BD_Node_Ptr) +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_D_BD];
  (*f_G_Equ_G_Node_Ptr) +=  +d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  (*f_G_Equ_GP_Node_Ptr) +=  -d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  (*f_GP_Equ_G_Node_Ptr) +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP];
  (*f_BP_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI];
  (*f_BI_Equ_BP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  (*f_BI_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  (*f_BS_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI];
  (*f_BI_Equ_BS_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI];
  (*f_BD_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI];
  (*f_BI_Equ_BD_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI];
  (*f_B_Equ_B_Node_Ptr) +=  +d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  (*f_B_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  (*f_BI_Equ_B_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI];
  (*f_NOI2_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND];
  (*f_NOI2_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_BP];
  (*f_NOI2_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_BP];
  (*f_NOI2_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_S];
  (*f_NOI2_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_S];
  (*f_NOI_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  (*f_NOI_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  (*f_NOI_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S];
  (*f_NOI_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S];
  (*f_NOI_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND];
  (*f_NOI_Equ_NOI_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  (*f_D_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_NOI2_GND];
  (*f_S_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_NOI2_GND];
  (*f_BS_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BP];
  (*f_BS_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_S];
  (*f_BD_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BP];
  (*f_BD_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_S];

#else
  //use the offsets instead of pointers
  dFdx[li_D][A_D_Equ_S_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_S_BS] -d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP];
  dFdx[li_D][A_D_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP];
  dFdx[li_BP][A_BP_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  dFdx[li_BP][A_BP_Equ_BP_NodeOffset] +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] -d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  dFdx[li_D][A_D_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_D_BD] +d_staticContributions[admsNodeID_D][admsProbeID_V_D_S];
  dFdx[li_BP][A_BP_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S];
  dFdx[li_D][A_D_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S];
  dFdx[li_BP][A_BP_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S];
  dFdx[li_S][A_S_Equ_S_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_S_BS] -d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP];
  dFdx[li_S][A_S_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP];
  dFdx[li_S][A_S_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_D_BD] +d_staticContributions[admsNodeID_S][admsProbeID_V_D_S];
  dFdx[li_S][A_S_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S];
  dFdx[li_GP][A_GP_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  dFdx[li_GP][A_GP_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  dFdx[li_GP][A_GP_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S];
  dFdx[li_GP][A_GP_Equ_GP_NodeOffset] +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] +d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S];
  dFdx[li_BS][A_BS_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BP] +d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  dFdx[li_BS][A_BS_Equ_BS_NodeOffset] +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  dFdx[li_S][A_S_Equ_BS_NodeOffset] +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_BS];
  dFdx[li_BS][A_BS_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  dFdx[li_BS][A_BS_Equ_BD_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  dFdx[li_S][A_S_Equ_BD_NodeOffset] +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_D_BD];
  dFdx[li_BD][A_BD_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BP] +d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  dFdx[li_BD][A_BD_Equ_BS_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  dFdx[li_D][A_D_Equ_BS_NodeOffset] +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_S_BS];
  dFdx[li_BD][A_BD_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  dFdx[li_BD][A_BD_Equ_BD_NodeOffset] +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  dFdx[li_D][A_D_Equ_BD_NodeOffset] +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_D_BD];
  dFdx[li_G][A_G_Equ_G_NodeOffset] +=  +d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  dFdx[li_G][A_G_Equ_GP_NodeOffset] +=  -d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  dFdx[li_GP][A_GP_Equ_G_NodeOffset] +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP];
  dFdx[li_BP][A_BP_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI];
  dFdx[li_BI][A_BI_Equ_BP_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  dFdx[li_BI][A_BI_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  dFdx[li_BS][A_BS_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI];
  dFdx[li_BI][A_BI_Equ_BS_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI];
  dFdx[li_BD][A_BD_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI];
  dFdx[li_BI][A_BI_Equ_BD_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI];
  dFdx[li_B][A_B_Equ_B_NodeOffset] +=  +d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  dFdx[li_B][A_B_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  dFdx[li_BI][A_BI_Equ_B_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI];
  dFdx[li_NOI2][A_NOI2_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND];
  dFdx[li_NOI2][A_NOI2_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_BP];
  dFdx[li_NOI2][A_NOI2_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_BP];
  dFdx[li_NOI2][A_NOI2_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_S];
  dFdx[li_NOI2][A_NOI2_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_S];
  dFdx[li_NOI][A_NOI_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  dFdx[li_NOI][A_NOI_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  dFdx[li_NOI][A_NOI_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S];
  dFdx[li_NOI][A_NOI_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S];
  dFdx[li_NOI][A_NOI_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND];
  dFdx[li_NOI][A_NOI_Equ_NOI_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  dFdx[li_D][A_D_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_NOI2_GND];
  dFdx[li_S][A_S_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_NOI2_GND];
  dFdx[li_BS][A_BS_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BP];
  dFdx[li_BS][A_BS_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_S];
  dFdx[li_BD][A_BD_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BP];
  dFdx[li_BD][A_BD_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_S];

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_D_Equ_S_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BS] -d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S] -d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] +d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP];
  (*q_D_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP];
  (*q_BP_Equ_S_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  (*q_BP_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  (*q_D_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_BD] +d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S];
  (*q_BP_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S];
  (*q_D_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S];
  (*q_BP_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S];
  (*q_S_Equ_S_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BS] -d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP];
  (*q_S_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP];
  (*q_S_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_BD] +d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S];
  (*q_S_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S];
  (*q_GP_Equ_S_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  (*q_GP_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  (*q_GP_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S];
  (*q_GP_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S];
  (*q_BS_Equ_S_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  (*q_BS_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  (*q_S_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BS];
  (*q_BS_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  (*q_BS_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  (*q_S_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_BD];
  (*q_BD_Equ_S_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  (*q_BD_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  (*q_D_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BS];
  (*q_BD_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  (*q_BD_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  (*q_D_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_BD];
  (*q_NOI_Equ_S_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  (*q_NOI_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  (*q_NOI_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_S];
  (*q_NOI_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_S];
  (*q_NOI_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  (*q_GP_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND];
  (*q_S_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI_GND];
  (*q_D_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI_GND];

#else
  //use the offsets instead of pointers
  dQdx[li_D][A_D_Equ_S_NodeOffset] +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BS] -d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S] -d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] +d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP];
  dQdx[li_D][A_D_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP];
  dQdx[li_BP][A_BP_Equ_S_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  dQdx[li_BP][A_BP_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  dQdx[li_D][A_D_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_BD] +d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S];
  dQdx[li_BP][A_BP_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S];
  dQdx[li_D][A_D_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S];
  dQdx[li_BP][A_BP_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S];
  dQdx[li_S][A_S_Equ_S_NodeOffset] +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BS] -d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP];
  dQdx[li_S][A_S_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP];
  dQdx[li_S][A_S_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_BD] +d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S];
  dQdx[li_S][A_S_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S];
  dQdx[li_GP][A_GP_Equ_S_NodeOffset] +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  dQdx[li_GP][A_GP_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  dQdx[li_GP][A_GP_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S];
  dQdx[li_GP][A_GP_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S];
  dQdx[li_BS][A_BS_Equ_S_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  dQdx[li_BS][A_BS_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  dQdx[li_S][A_S_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BS];
  dQdx[li_BS][A_BS_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  dQdx[li_BS][A_BS_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  dQdx[li_S][A_S_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_BD];
  dQdx[li_BD][A_BD_Equ_S_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  dQdx[li_BD][A_BD_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  dQdx[li_D][A_D_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BS];
  dQdx[li_BD][A_BD_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  dQdx[li_BD][A_BD_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  dQdx[li_D][A_D_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_BD];
  dQdx[li_NOI][A_NOI_Equ_S_NodeOffset] +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  dQdx[li_NOI][A_NOI_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  dQdx[li_NOI][A_NOI_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_S];
  dQdx[li_NOI][A_NOI_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_S];
  dQdx[li_NOI][A_NOI_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  dQdx[li_GP][A_GP_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND];
  dQdx[li_S][A_S_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI_GND];
  dQdx[li_D][A_D_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI_GND];


#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

  // set internal model type based on model card type
  if (getType() == "pmos" || getType() == "PMOS")
    TYPE = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter TYPE : [ (-1), 1 ]
  if ( (!((TYPE >=(-1) && TYPE <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter TYPE value " << TYPE << " out of range [ (-1), 1 ]";
  }

  //    Parameter TR : [ (-273.0),  (+inf) [
  if ( (!((TR >=(-273.0)))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter TR value " << TR << " out of range [ (-273.0),  (+inf) [";
  }

  //    Parameter SWIGATE : [ 0.0, 1.0 ]
  if ( (!((SWIGATE >=0.0 && SWIGATE <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SWIGATE value " << SWIGATE << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter SWIMPACT : [ 0.0, 1.0 ]
  if ( (!((SWIMPACT >=0.0 && SWIMPACT <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SWIMPACT value " << SWIMPACT << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter SWGIDL : [ 0.0, 1.0 ]
  if ( (!((SWGIDL >=0.0 && SWGIDL <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SWGIDL value " << SWGIDL << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter SWJUNCAP : [ 0.0, 3.0 ]
  if ( (!((SWJUNCAP >=0.0 && SWJUNCAP <=3.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SWJUNCAP value " << SWJUNCAP << " out of range [ 0.0, 3.0 ]";
  }

  //    Parameter QMC : [ 0.0,  (+inf) [
  if ( (!((QMC >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter QMC value " << QMC << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter TOXO : [ 1e-10,  (+inf) [
  if ( (!((TOXO >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter TOXO value " << TOXO << " out of range [ 1e-10,  (+inf) [";
  }

  //    Parameter EPSROXO : [ 1.0,  (+inf) [
  if ( (!((EPSROXO >=1.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter EPSROXO value " << EPSROXO << " out of range [ 1.0,  (+inf) [";
  }

  //    Parameter NSUBO : [ 1e20,  (+inf) [
  if ( (!((NSUBO >=1e20))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter NSUBO value " << NSUBO << " out of range [ 1e20,  (+inf) [";
  }

  //    Parameter WSEG : [ 1e-10,  (+inf) [
  if ( (!((WSEG >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter WSEG value " << WSEG << " out of range [ 1e-10,  (+inf) [";
  }

  //    Parameter NPCK : [ 0.0,  (+inf) [
  if ( (!((NPCK >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter NPCK value " << NPCK << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter WSEGP : [ 1e-10,  (+inf) [
  if ( (!((WSEGP >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter WSEGP value " << WSEGP << " out of range [ 1e-10,  (+inf) [";
  }

  //    Parameter LPCK : [ 1e-10,  (+inf) [
  if ( (!((LPCK >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LPCK value " << LPCK << " out of range [ 1e-10,  (+inf) [";
  }

  //    Parameter TOXOVO : [ 1e-10,  (+inf) [
  if ( (!((TOXOVO >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter TOXOVO value " << TOXOVO << " out of range [ 1e-10,  (+inf) [";
  }

  //    Parameter TOXOVDO : [ 1e-10,  (+inf) [
  if ( (!((TOXOVDO >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter TOXOVDO value " << TOXOVDO << " out of range [ 1e-10,  (+inf) [";
  }

  //    Parameter LOV : [ 0.0,  (+inf) [
  if ( (!((LOV >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LOV value " << LOV << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter LOVD : [ 0.0,  (+inf) [
  if ( (!((LOVD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LOVD value " << LOVD << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter LP1 : [ 1e-10,  (+inf) [
  if ( (!((LP1 >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LP1 value " << LP1 << " out of range [ 1e-10,  (+inf) [";
  }

  //    Parameter LP2 : [ 1e-10,  (+inf) [
  if ( (!((LP2 >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LP2 value " << LP2 << " out of range [ 1e-10,  (+inf) [";
  }

  //    Parameter WBET : [ 1e-10,  (+inf) [
  if ( (!((WBET >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter WBET value " << WBET << " out of range [ 1e-10,  (+inf) [";
  }

  //    Parameter AXL : [ 0.0,  (+inf) [
  if ( (!((AXL >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter AXL value " << AXL << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ALP1L2 : [ 0.0,  (+inf) [
  if ( (!((ALP1L2 >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter ALP1L2 value " << ALP1L2 << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ALP2L2 : [ 0.0,  (+inf) [
  if ( (!((ALP2L2 >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter ALP2L2 value " << ALP2L2 << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter FNTEXCL : [ 0.0,  (+inf) [
  if ( (!((FNTEXCL >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter FNTEXCL value " << FNTEXCL << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RINT : [ 0.0,  (+inf) [
  if ( (!((RINT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter RINT value " << RINT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RVPOLY : [ 0.0,  (+inf) [
  if ( (!((RVPOLY >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter RVPOLY value " << RVPOLY << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter RSHG : [ 0.0,  (+inf) [
  if ( (!((RSHG >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter RSHG value " << RSHG << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter SAREF : [ 1e-9,  (+inf) [
  if ( (!((SAREF >=1e-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SAREF value " << SAREF << " out of range [ 1e-9,  (+inf) [";
  }

  //    Parameter SBREF : [ 1e-9,  (+inf) [
  if ( (!((SBREF >=1e-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SBREF value " << SBREF << " out of range [ 1e-9,  (+inf) [";
  }

  //    Parameter KVSAT : [ (-1.0), 1.0 ]
  if ( (!((KVSAT >=(-1.0) && KVSAT <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter KVSAT value " << KVSAT << " out of range [ (-1.0), 1.0 ]";
  }

  //    Parameter LLODKUO : [ 0.0,  (+inf) [
  if ( (!((LLODKUO >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LLODKUO value " << LLODKUO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter WLODKUO : [ 0.0,  (+inf) [
  if ( (!((WLODKUO >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter WLODKUO value " << WLODKUO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter LLODVTH : [ 0.0,  (+inf) [
  if ( (!((LLODVTH >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LLODVTH value " << LLODVTH << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter WLODVTH : [ 0.0,  (+inf) [
  if ( (!((WLODVTH >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter WLODVTH value " << WLODVTH << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter LODETAO : [ 0.0,  (+inf) [
  if ( (!((LODETAO >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LODETAO value " << LODETAO << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter SCREF : [ 0.0,  (+inf) [
  if ( (!((SCREF >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SCREF value " << SCREF << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IMAX : [ 1E-12,  (+inf) [
  if ( (!((IMAX >=1E-12))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IMAX value " << IMAX << " out of range [ 1E-12,  (+inf) [";
  }

  //    Parameter TRJ : [ (-250),  (+inf) [
  if ( (!((TRJ >=(-250)))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter TRJ value " << TRJ << " out of range [ (-250),  (+inf) [";
  }

  //    Parameter CJORBOT : [ 1E-12,  (+inf) [
  if ( (!((CJORBOT >=1E-12))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CJORBOT value " << CJORBOT << " out of range [ 1E-12,  (+inf) [";
  }

  //    Parameter CJORSTI : [ 1E-18,  (+inf) [
  if ( (!((CJORSTI >=1E-18))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CJORSTI value " << CJORSTI << " out of range [ 1E-18,  (+inf) [";
  }

  //    Parameter CJORGAT : [ 1E-18,  (+inf) [
  if ( (!((CJORGAT >=1E-18))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CJORGAT value " << CJORGAT << " out of range [ 1E-18,  (+inf) [";
  }

  //    Parameter VBIRBOT : [ 0.050,  (+inf) [
  if ( (!((VBIRBOT >=0.050))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBIRBOT value " << VBIRBOT << " out of range [ 0.050,  (+inf) [";
  }

  //    Parameter VBIRSTI : [ 0.050,  (+inf) [
  if ( (!((VBIRSTI >=0.050))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBIRSTI value " << VBIRSTI << " out of range [ 0.050,  (+inf) [";
  }

  //    Parameter VBIRGAT : [ 0.050,  (+inf) [
  if ( (!((VBIRGAT >=0.050))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBIRGAT value " << VBIRGAT << " out of range [ 0.050,  (+inf) [";
  }

  //    Parameter PBOT : [ 0.05, 0.95 ]
  if ( (!((PBOT >=0.05 && PBOT <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBOT value " << PBOT << " out of range [ 0.05, 0.95 ]";
  }

  //    Parameter PSTI : [ 0.05, 0.95 ]
  if ( (!((PSTI >=0.05 && PSTI <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PSTI value " << PSTI << " out of range [ 0.05, 0.95 ]";
  }

  //    Parameter PGAT : [ 0.05, 0.95 ]
  if ( (!((PGAT >=0.05 && PGAT <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PGAT value " << PGAT << " out of range [ 0.05, 0.95 ]";
  }

  //    Parameter IDSATRBOT : [ 0,  (+inf) [
  if ( (!((IDSATRBOT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IDSATRBOT value " << IDSATRBOT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter IDSATRSTI : [ 0,  (+inf) [
  if ( (!((IDSATRSTI >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IDSATRSTI value " << IDSATRSTI << " out of range [ 0,  (+inf) [";
  }

  //    Parameter IDSATRGAT : [ 0,  (+inf) [
  if ( (!((IDSATRGAT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IDSATRGAT value " << IDSATRGAT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CSRHBOT : [ 0,  (+inf) [
  if ( (!((CSRHBOT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CSRHBOT value " << CSRHBOT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CSRHSTI : [ 0,  (+inf) [
  if ( (!((CSRHSTI >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CSRHSTI value " << CSRHSTI << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CSRHGAT : [ 0,  (+inf) [
  if ( (!((CSRHGAT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CSRHGAT value " << CSRHGAT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter XJUNSTI : [ 1E-9,  (+inf) [
  if ( (!((XJUNSTI >=1E-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter XJUNSTI value " << XJUNSTI << " out of range [ 1E-9,  (+inf) [";
  }

  //    Parameter XJUNGAT : [ 1E-9,  (+inf) [
  if ( (!((XJUNGAT >=1E-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter XJUNGAT value " << XJUNGAT << " out of range [ 1E-9,  (+inf) [";
  }

  //    Parameter CTATBOT : [ 0,  (+inf) [
  if ( (!((CTATBOT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CTATBOT value " << CTATBOT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CTATSTI : [ 0,  (+inf) [
  if ( (!((CTATSTI >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CTATSTI value " << CTATSTI << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CTATGAT : [ 0,  (+inf) [
  if ( (!((CTATGAT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CTATGAT value " << CTATGAT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter MEFFTATBOT : [ 0.01,  (+inf) [
  if ( (!((MEFFTATBOT >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MEFFTATBOT value " << MEFFTATBOT << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter MEFFTATSTI : [ 0.01,  (+inf) [
  if ( (!((MEFFTATSTI >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MEFFTATSTI value " << MEFFTATSTI << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter MEFFTATGAT : [ 0.01,  (+inf) [
  if ( (!((MEFFTATGAT >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MEFFTATGAT value " << MEFFTATGAT << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter CBBTBOT : [ 0,  (+inf) [
  if ( (!((CBBTBOT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CBBTBOT value " << CBBTBOT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CBBTSTI : [ 0,  (+inf) [
  if ( (!((CBBTSTI >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CBBTSTI value " << CBBTSTI << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CBBTGAT : [ 0,  (+inf) [
  if ( (!((CBBTGAT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CBBTGAT value " << CBBTGAT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter VBRBOT : [ 0.1,  (+inf) [
  if ( (!((VBRBOT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBRBOT value " << VBRBOT << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VBRSTI : [ 0.1,  (+inf) [
  if ( (!((VBRSTI >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBRSTI value " << VBRSTI << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VBRGAT : [ 0.1,  (+inf) [
  if ( (!((VBRGAT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBRGAT value " << VBRGAT << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRBOT : [ 0.1,  (+inf) [
  if ( (!((PBRBOT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBRBOT value " << PBRBOT << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRSTI : [ 0.1,  (+inf) [
  if ( (!((PBRSTI >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBRSTI value " << PBRSTI << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRGAT : [ 0.1,  (+inf) [
  if ( (!((PBRGAT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBRGAT value " << PBRGAT << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter CJORBOTD : [ 1E-12,  (+inf) [
  if ( (!((CJORBOTD >=1E-12))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CJORBOTD value " << CJORBOTD << " out of range [ 1E-12,  (+inf) [";
  }

  //    Parameter CJORSTID : [ 1E-18,  (+inf) [
  if ( (!((CJORSTID >=1E-18))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CJORSTID value " << CJORSTID << " out of range [ 1E-18,  (+inf) [";
  }

  //    Parameter CJORGATD : [ 1E-18,  (+inf) [
  if ( (!((CJORGATD >=1E-18))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CJORGATD value " << CJORGATD << " out of range [ 1E-18,  (+inf) [";
  }

  //    Parameter VBIRBOTD : [ 0.050,  (+inf) [
  if ( (!((VBIRBOTD >=0.050))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBIRBOTD value " << VBIRBOTD << " out of range [ 0.050,  (+inf) [";
  }

  //    Parameter VBIRSTID : [ 0.050,  (+inf) [
  if ( (!((VBIRSTID >=0.050))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBIRSTID value " << VBIRSTID << " out of range [ 0.050,  (+inf) [";
  }

  //    Parameter VBIRGATD : [ 0.050,  (+inf) [
  if ( (!((VBIRGATD >=0.050))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBIRGATD value " << VBIRGATD << " out of range [ 0.050,  (+inf) [";
  }

  //    Parameter PBOTD : [ 0.05, 0.95 ]
  if ( (!((PBOTD >=0.05 && PBOTD <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBOTD value " << PBOTD << " out of range [ 0.05, 0.95 ]";
  }

  //    Parameter PSTID : [ 0.05, 0.95 ]
  if ( (!((PSTID >=0.05 && PSTID <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PSTID value " << PSTID << " out of range [ 0.05, 0.95 ]";
  }

  //    Parameter PGATD : [ 0.05, 0.95 ]
  if ( (!((PGATD >=0.05 && PGATD <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PGATD value " << PGATD << " out of range [ 0.05, 0.95 ]";
  }

  //    Parameter IDSATRBOTD : [ 0,  (+inf) [
  if ( (!((IDSATRBOTD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IDSATRBOTD value " << IDSATRBOTD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter IDSATRSTID : [ 0,  (+inf) [
  if ( (!((IDSATRSTID >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IDSATRSTID value " << IDSATRSTID << " out of range [ 0,  (+inf) [";
  }

  //    Parameter IDSATRGATD : [ 0,  (+inf) [
  if ( (!((IDSATRGATD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IDSATRGATD value " << IDSATRGATD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CSRHBOTD : [ 0,  (+inf) [
  if ( (!((CSRHBOTD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CSRHBOTD value " << CSRHBOTD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CSRHSTID : [ 0,  (+inf) [
  if ( (!((CSRHSTID >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CSRHSTID value " << CSRHSTID << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CSRHGATD : [ 0,  (+inf) [
  if ( (!((CSRHGATD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CSRHGATD value " << CSRHGATD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter XJUNSTID : [ 1E-9,  (+inf) [
  if ( (!((XJUNSTID >=1E-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter XJUNSTID value " << XJUNSTID << " out of range [ 1E-9,  (+inf) [";
  }

  //    Parameter XJUNGATD : [ 1E-9,  (+inf) [
  if ( (!((XJUNGATD >=1E-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter XJUNGATD value " << XJUNGATD << " out of range [ 1E-9,  (+inf) [";
  }

  //    Parameter CTATBOTD : [ 0,  (+inf) [
  if ( (!((CTATBOTD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CTATBOTD value " << CTATBOTD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CTATSTID : [ 0,  (+inf) [
  if ( (!((CTATSTID >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CTATSTID value " << CTATSTID << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CTATGATD : [ 0,  (+inf) [
  if ( (!((CTATGATD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CTATGATD value " << CTATGATD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter MEFFTATBOTD : [ 0.01,  (+inf) [
  if ( (!((MEFFTATBOTD >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MEFFTATBOTD value " << MEFFTATBOTD << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter MEFFTATSTID : [ 0.01,  (+inf) [
  if ( (!((MEFFTATSTID >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MEFFTATSTID value " << MEFFTATSTID << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter MEFFTATGATD : [ 0.01,  (+inf) [
  if ( (!((MEFFTATGATD >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MEFFTATGATD value " << MEFFTATGATD << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter CBBTBOTD : [ 0,  (+inf) [
  if ( (!((CBBTBOTD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CBBTBOTD value " << CBBTBOTD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CBBTSTID : [ 0,  (+inf) [
  if ( (!((CBBTSTID >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CBBTSTID value " << CBBTSTID << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CBBTGATD : [ 0,  (+inf) [
  if ( (!((CBBTGATD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CBBTGATD value " << CBBTGATD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter VBRBOTD : [ 0.1,  (+inf) [
  if ( (!((VBRBOTD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBRBOTD value " << VBRBOTD << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VBRSTID : [ 0.1,  (+inf) [
  if ( (!((VBRSTID >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBRSTID value " << VBRSTID << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VBRGATD : [ 0.1,  (+inf) [
  if ( (!((VBRGATD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBRGATD value " << VBRGATD << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRBOTD : [ 0.1,  (+inf) [
  if ( (!((PBRBOTD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBRBOTD value " << PBRBOTD << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRSTID : [ 0.1,  (+inf) [
  if ( (!((PBRSTID >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBRSTID value " << PBRSTID << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRGATD : [ 0.1,  (+inf) [
  if ( (!((PBRGATD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBRGATD value " << PBRGATD << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter SWJUNEXP : [ 0.0, 1.0 ]
  if ( (!((SWJUNEXP >=0.0 && SWJUNEXP <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SWJUNEXP value " << SWJUNEXP << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter VJUNREF : [ 0.5,  (+inf) [
  if ( (!((VJUNREF >=0.5))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VJUNREF value " << VJUNREF << " out of range [ 0.5,  (+inf) [";
  }

  //    Parameter FJUNQ : [ 0.0,  (+inf) [
  if ( (!((FJUNQ >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter FJUNQ value " << FJUNQ << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VJUNREFD : [ 0.5,  (+inf) [
  if ( (!((VJUNREFD >=0.5))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VJUNREFD value " << VJUNREFD << " out of range [ 0.5,  (+inf) [";
  }

  //    Parameter FJUNQD : [ 0.0,  (+inf) [
  if ( (!((FJUNQD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter FJUNQD value " << FJUNQD << " out of range [ 0.0,  (+inf) [";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff
  double deltaEgat_d;
  double deltaEsti_d;
  double deltaEbot_d;
  double ubigat_d;
  double ubisti_d;
  double ubibot_d;
  double phigdgat_d;
  double phigdsti_d;
  double phigdbot_d;
  double phigrgat_d;
  double phigrsti_d;
  double phigrbot_d;
  double deltaEgat;
  double deltaEsti;
  double deltaEbot;
  double ubigat;
  double ubisti;
  double ubibot;
  double phigdgat;
  double phigdsti;
  double phigdbot;
  double deltaphigd;
  double phigrgat;
  double phigrsti;
  double phigrbot;
  double deltaphigr;
  double phitrinv;
  double KBOL_over_QELE;
  double auxt;
  double tkd;
  double tkr;
  double STFBBTGATD_i;
  double STFBBTSTID_i;
  double STFBBTBOTD_i;
  double FBBTRGATD_i;
  double FBBTRSTID_i;
  double FBBTRBOTD_i;
  double MEFFTATGATD_i;
  double MEFFTATSTID_i;
  double MEFFTATBOTD_i;
  double XJUNGATD_i;
  double XJUNSTID_i;
  double IDSATRGATD_i;
  double IDSATRSTID_i;
  double IDSATRBOTD_i;
  double PHIGGATD_i;
  double PHIGSTID_i;
  double PHIGBOTD_i;
  double CJORGATD_i;
  double CJORSTID_i;
  double CJORBOTD_i;
  double STFBBTGAT_i;
  double STFBBTSTI_i;
  double STFBBTBOT_i;
  double FBBTRGAT_i;
  double FBBTRSTI_i;
  double FBBTRBOT_i;
  double MEFFTATGAT_i;
  double MEFFTATSTI_i;
  double MEFFTATBOT_i;
  double XJUNGAT_i;
  double XJUNSTI_i;
  double IDSATRGAT_i;
  double IDSATRSTI_i;
  double IDSATRBOT_i;
  double PHIGGAT_i;
  double PHIGSTI_i;
  double PHIGBOT_i;
  double CJORGAT_i;
  double CJORSTI_i;
  double CJORBOT_i;
  double TRJ_i;
  double TKD_sq;
  double TKR;
  double TR_i;
  //Begin block initial_model
  {
    TOX_i = ((TOXO>1e-10)?TOXO:1e-10);
    TOXOVD_i = ((TOXOVDO>1e-10)?TOXOVDO:1e-10);
    EPSROX_i = ((EPSROXO>1.0)?EPSROXO:1.0);
    NSUBO_i = ((NSUBO>1e20)?NSUBO:1e20);
    WSEG_i = ((WSEG>1e-10)?WSEG:1e-10);
    NPCK_i = ((NPCK>0.0)?NPCK:0.0);
    WSEGP_i = ((WSEGP>1e-10)?WSEGP:1e-10);
    LPCK_i = ((LPCK>1e-10)?LPCK:1e-10);
    TOXOV_i = ((TOXOVO>1e-10)?TOXOVO:1e-10);
    LOV_i = ((LOV>0.0)?LOV:0.0);
    LOVD_i = ((LOVD>0.0)?LOVD:0.0);
    LP1_i = ((LP1>1e-10)?LP1:1e-10);
    LP2_i = ((LP2>1e-10)?LP2:1e-10);
    WBET_i = ((WBET>1e-10)?WBET:1e-10);
    AXL_i = ((AXL>0.0)?AXL:0.0);
    ALP1L2_i = ((ALP1L2>0.0)?ALP1L2:0.0);
    ALP2L2_i = ((ALP2L2>0.0)?ALP2L2:0.0);
    SAREF_i = ((SAREF>1e-9)?SAREF:1e-9);
    SBREF_i = ((SBREF>1e-9)?SBREF:1e-9);
    KVSAT_i = ((KVSAT>(-1.0))?((KVSAT<1.0)?KVSAT:1.0):(-1.0));
    LLODKUO_i = ((LLODKUO>0.0)?LLODKUO:0.0);
    WLODKUO_i = ((WLODKUO>0.0)?WLODKUO:0.0);
    LLODVTH_i = ((LLODVTH>0.0)?LLODVTH:0.0);
    WLODVTH_i = ((WLODVTH>0.0)?WLODVTH:0.0);
    LODETAO_i = ((LODETAO>0.0)?LODETAO:0.0);
    SCREF_i = ((SCREF>0.0)?SCREF:0.0);
    WEB_i = WEB;
    WEC_i = WEC;
    RINT_i = ((RINT>0.0)?RINT:0.0);
    RVPOLY_i = ((RVPOLY>0.0)?RVPOLY:0.0);
    if ((TYPE>=0))
    {
      CHNL_TYPE = (+1);
    }
    else
    {
      CHNL_TYPE = (-1);
    }
    TR_i = ((TR>(-273))?TR:(-273));
    TKR = (273.15+TR_i);
    TKD = (admsModTemp+DTA);
    TKD_sq = (TKD*TKD);
    dT = (TKD-TKR);
    rT = (TKD/TKR);
    rTn = (TKR/TKD);
    phit = ((TKD*1.3806505E-23)/1.6021918E-19);
    inv_phit = (1.0/phit);
    Eg = ((1.179-(9.025e-5*TKD))-(3.05e-7*TKD_sq));
    phibFac = ((((1.045+(4.5e-4*TKD))*((0.523+(1.4e-3*TKD))-(1.48e-6*TKD_sq)))*TKD_sq)/9.0E4);
    phibFac = ((phibFac>1.0E-3)?phibFac:1.0E-3);
    EPSSI = (8.8541878176E-12*11.8);
    nt0 = ((4*1.3806505E-23)*TKD);
    TRJ_i = ((TRJ>(-250))?TRJ:(-250));
    IMAX_i = ((IMAX>1E-12)?IMAX:1E-12);
    CJORBOT_i = ((CJORBOT>1E-12)?CJORBOT:1E-12);
    CJORSTI_i = ((CJORSTI>1E-18)?CJORSTI:1E-18);
    CJORGAT_i = ((CJORGAT>1E-18)?CJORGAT:1E-18);
    VBIRBOT_i = ((VBIRBOT>0.050)?VBIRBOT:0.050);
    VBIRSTI_i = ((VBIRSTI>0.050)?VBIRSTI:0.050);
    VBIRGAT_i = ((VBIRGAT>0.050)?VBIRGAT:0.050);
    PBOT_i = ((PBOT>0.05)?((PBOT<0.95)?PBOT:0.95):0.05);
    PSTI_i = ((PSTI>0.05)?((PSTI<0.95)?PSTI:0.95):0.05);
    PGAT_i = ((PGAT>0.05)?((PGAT<0.95)?PGAT:0.95):0.05);
    PHIGBOT_i = PHIGBOT;
    PHIGSTI_i = PHIGSTI;
    PHIGGAT_i = PHIGGAT;
    IDSATRBOT_i = ((IDSATRBOT>0)?IDSATRBOT:0);
    IDSATRSTI_i = ((IDSATRSTI>0)?IDSATRSTI:0);
    IDSATRGAT_i = ((IDSATRGAT>0)?IDSATRGAT:0);
    CSRHBOT_i = ((CSRHBOT>0)?CSRHBOT:0);
    CSRHSTI_i = ((CSRHSTI>0)?CSRHSTI:0);
    CSRHGAT_i = ((CSRHGAT>0)?CSRHGAT:0);
    XJUNSTI_i = ((XJUNSTI>1E-9)?XJUNSTI:1E-9);
    XJUNGAT_i = ((XJUNGAT>1E-9)?XJUNGAT:1E-9);
    CTATBOT_i = ((CTATBOT>0)?CTATBOT:0);
    CTATSTI_i = ((CTATSTI>0)?CTATSTI:0);
    CTATGAT_i = ((CTATGAT>0)?CTATGAT:0);
    MEFFTATBOT_i = ((MEFFTATBOT>0.01)?MEFFTATBOT:0.01);
    MEFFTATSTI_i = ((MEFFTATSTI>0.01)?MEFFTATSTI:0.01);
    MEFFTATGAT_i = ((MEFFTATGAT>0.01)?MEFFTATGAT:0.01);
    CBBTBOT_i = ((CBBTBOT>0)?CBBTBOT:0);
    CBBTSTI_i = ((CBBTSTI>0)?CBBTSTI:0);
    CBBTGAT_i = ((CBBTGAT>0)?CBBTGAT:0);
    FBBTRBOT_i = FBBTRBOT;
    FBBTRSTI_i = FBBTRSTI;
    FBBTRGAT_i = FBBTRGAT;
    STFBBTBOT_i = STFBBTBOT;
    STFBBTSTI_i = STFBBTSTI;
    STFBBTGAT_i = STFBBTGAT;
    VBRBOT_i = ((VBRBOT>0.1)?VBRBOT:0.1);
    VBRSTI_i = ((VBRSTI>0.1)?VBRSTI:0.1);
    VBRGAT_i = ((VBRGAT>0.1)?VBRGAT:0.1);
    PBRBOT_i = ((PBRBOT>0.1)?PBRBOT:0.1);
    PBRSTI_i = ((PBRSTI>0.1)?PBRSTI:0.1);
    PBRGAT_i = ((PBRGAT>0.1)?PBRGAT:0.1);
    SWJUNEXP_i = 0.0;
    if ((SWJUNEXP>0.5))
    {
      SWJUNEXP_i = 1.0;
    }
    else
    {
      SWJUNEXP_i = 0.0;
    }
    VJUNREF_i = ((VJUNREF>0.5)?VJUNREF:0.5);
    FJUNQ_i = ((FJUNQ>0.0)?FJUNQ:0.0);
    if ((SWJUNASYM==0.0))
    {
      CJORBOTD_i = CJORBOT_i;
      CJORSTID_i = CJORSTI_i;
      CJORGATD_i = CJORGAT_i;
      VBIRBOTD_i = VBIRBOT_i;
      VBIRSTID_i = VBIRSTI_i;
      VBIRGATD_i = VBIRGAT_i;
      PBOTD_i = PBOT_i;
      PSTID_i = PSTI_i;
      PGATD_i = PGAT_i;
      PHIGBOTD_i = PHIGBOT_i;
      PHIGSTID_i = PHIGSTI_i;
      PHIGGATD_i = PHIGGAT_i;
      IDSATRBOTD_i = IDSATRBOT_i;
      IDSATRSTID_i = IDSATRSTI_i;
      IDSATRGATD_i = IDSATRGAT_i;
      CSRHBOTD_i = CSRHBOT_i;
      CSRHSTID_i = CSRHSTI_i;
      CSRHGATD_i = CSRHGAT_i;
      XJUNSTID_i = XJUNSTI_i;
      XJUNGATD_i = XJUNGAT_i;
      CTATBOTD_i = CTATBOT_i;
      CTATSTID_i = CTATSTI_i;
      CTATGATD_i = CTATGAT_i;
      MEFFTATBOTD_i = MEFFTATBOT_i;
      MEFFTATSTID_i = MEFFTATSTI_i;
      MEFFTATGATD_i = MEFFTATGAT_i;
      CBBTBOTD_i = CBBTBOT_i;
      CBBTSTID_i = CBBTSTI_i;
      CBBTGATD_i = CBBTGAT_i;
      FBBTRBOTD_i = FBBTRBOT_i;
      FBBTRSTID_i = FBBTRSTI_i;
      FBBTRGATD_i = FBBTRGAT_i;
      STFBBTBOTD_i = STFBBTBOT_i;
      STFBBTSTID_i = STFBBTSTI_i;
      STFBBTGATD_i = STFBBTGAT_i;
      VBRBOTD_i = VBRBOT_i;
      VBRSTID_i = VBRSTI_i;
      VBRGATD_i = VBRGAT_i;
      PBRBOTD_i = PBRBOT_i;
      PBRSTID_i = PBRSTI_i;
      PBRGATD_i = PBRGAT_i;
      VJUNREFD_i = VJUNREF_i;
      FJUNQD_i = FJUNQ_i;
    }
    else
    {
      CJORBOTD_i = ((CJORBOTD>1E-12)?CJORBOTD:1E-12);
      CJORSTID_i = ((CJORSTID>1E-18)?CJORSTID:1E-18);
      CJORGATD_i = ((CJORGATD>1E-18)?CJORGATD:1E-18);
      VBIRBOTD_i = ((VBIRBOTD>0.050)?VBIRBOTD:0.050);
      VBIRSTID_i = ((VBIRSTID>0.050)?VBIRSTID:0.050);
      VBIRGATD_i = ((VBIRGATD>0.050)?VBIRGATD:0.050);
      PBOTD_i = ((PBOTD>0.05)?((PBOTD<0.95)?PBOTD:0.95):0.05);
      PSTID_i = ((PSTID>0.05)?((PSTID<0.95)?PSTID:0.95):0.05);
      PGATD_i = ((PGATD>0.05)?((PGATD<0.95)?PGATD:0.95):0.05);
      PHIGBOTD_i = PHIGBOTD;
      PHIGSTID_i = PHIGSTID;
      PHIGGATD_i = PHIGGATD;
      IDSATRBOTD_i = ((IDSATRBOTD>0)?IDSATRBOTD:0);
      IDSATRSTID_i = ((IDSATRSTID>0)?IDSATRSTID:0);
      IDSATRGATD_i = ((IDSATRGATD>0)?IDSATRGATD:0);
      CSRHBOTD_i = ((CSRHBOTD>0)?CSRHBOTD:0);
      CSRHSTID_i = ((CSRHSTID>0)?CSRHSTID:0);
      CSRHGATD_i = ((CSRHGATD>0)?CSRHGATD:0);
      XJUNSTID_i = ((XJUNSTID>1E-9)?XJUNSTID:1E-9);
      XJUNGATD_i = ((XJUNGATD>1E-9)?XJUNGATD:1E-9);
      CTATBOTD_i = ((CTATBOTD>0)?CTATBOTD:0);
      CTATSTID_i = ((CTATSTID>0)?CTATSTID:0);
      CTATGATD_i = ((CTATGATD>0)?CTATGATD:0);
      MEFFTATBOTD_i = ((MEFFTATBOTD>0.01)?MEFFTATBOTD:0.01);
      MEFFTATSTID_i = ((MEFFTATSTID>0.01)?MEFFTATSTID:0.01);
      MEFFTATGATD_i = ((MEFFTATGATD>0.01)?MEFFTATGATD:0.01);
      CBBTBOTD_i = ((CBBTBOTD>0)?CBBTBOTD:0);
      CBBTSTID_i = ((CBBTSTID>0)?CBBTSTID:0);
      CBBTGATD_i = ((CBBTGATD>0)?CBBTGATD:0);
      FBBTRBOTD_i = FBBTRBOTD;
      FBBTRSTID_i = FBBTRSTID;
      FBBTRGATD_i = FBBTRGATD;
      STFBBTBOTD_i = STFBBTBOTD;
      STFBBTSTID_i = STFBBTSTID;
      STFBBTGATD_i = STFBBTGATD;
      VBRBOTD_i = ((VBRBOTD>0.1)?VBRBOTD:0.1);
      VBRSTID_i = ((VBRSTID>0.1)?VBRSTID:0.1);
      VBRGATD_i = ((VBRGATD>0.1)?VBRGATD:0.1);
      PBRBOTD_i = ((PBRBOTD>0.1)?PBRBOTD:0.1);
      PBRSTID_i = ((PBRSTID>0.1)?PBRSTID:0.1);
      PBRGATD_i = ((PBRGATD>0.1)?PBRGATD:0.1);
      VJUNREFD_i = ((VJUNREFD>0.5)?VJUNREFD:0.5);
      FJUNQD_i = ((FJUNQD>0.0)?FJUNQD:0.0);
    }
    tkr = (273.15+TRJ_i);
    {
      double value_max_0 = std::max((admsModTemp+DTA),(273.15+(-250)));
      tkd = value_max_0;
    }
    auxt = (tkd/tkr);
    KBOL_over_QELE = (1.3806505E-23/1.6021918E-19);
    phitr = (KBOL_over_QELE*tkr);
    phitrinv = (1.0/phitr);
    phitd = (KBOL_over_QELE*tkd);
    phitdinv = (1.0/phitd);
    deltaphigr = ((-((7.02e-4*tkr)*tkr))/(1108.0+tkr));
    phigrbot = (PHIGBOT_i+deltaphigr);
    phigrsti = (PHIGSTI_i+deltaphigr);
    phigrgat = (PHIGGAT_i+deltaphigr);
    deltaphigd = ((-((7.02e-4*tkd)*tkd))/(1108.0+tkd));
    phigdbot = (PHIGBOT_i+deltaphigd);
    phigdsti = (PHIGSTI_i+deltaphigd);
    phigdgat = (PHIGGAT_i+deltaphigd);
    {
      double value_pow_0 = pow(auxt,1.5);
      double value_exp_1 = exp((0.5*((phigrbot*phitrinv)-(phigdbot*phitdinv))));
      ftdbot = (value_pow_0*value_exp_1);
    }
    {
      double value_pow_0 = pow(auxt,1.5);
      double value_exp_1 = exp((0.5*((phigrsti*phitrinv)-(phigdsti*phitdinv))));
      ftdsti = (value_pow_0*value_exp_1);
    }
    {
      double value_pow_0 = pow(auxt,1.5);
      double value_exp_1 = exp((0.5*((phigrgat*phitrinv)-(phigdgat*phitdinv))));
      ftdgat = (value_pow_0*value_exp_1);
    }
    idsatbot = ((IDSATRBOT_i*ftdbot)*ftdbot);
    idsatsti = ((IDSATRSTI_i*ftdsti)*ftdsti);
    idsatgat = ((IDSATRGAT_i*ftdgat)*ftdgat);
    {
      double value_log_0 = log(ftdbot);
      ubibot = ((VBIRBOT_i*auxt)-((2*phitd)*value_log_0));
    }
    {
      double value_log_0 = log(ftdsti);
      ubisti = ((VBIRSTI_i*auxt)-((2*phitd)*value_log_0));
    }
    {
      double value_log_0 = log(ftdgat);
      ubigat = ((VBIRGAT_i*auxt)-((2*phitd)*value_log_0));
    }
    {
      double value_exp_0 = exp(((0.050-ubibot)*phitdinv));
      double value_log_1 = log((1+value_exp_0));
      vbibot = (ubibot+(phitd*value_log_1));
    }
    {
      double value_exp_0 = exp(((0.050-ubisti)*phitdinv));
      double value_log_1 = log((1+value_exp_0));
      vbisti = (ubisti+(phitd*value_log_1));
    }
    {
      double value_exp_0 = exp(((0.050-ubigat)*phitdinv));
      double value_log_1 = log((1+value_exp_0));
      vbigat = (ubigat+(phitd*value_log_1));
    }
    vbiinvbot = (1.0/vbibot);
    vbiinvsti = (1.0/vbisti);
    vbiinvgat = (1.0/vbigat);
    one_minus_PBOT = (1-PBOT_i);
    one_minus_PSTI = (1-PSTI_i);
    one_minus_PGAT = (1-PGAT_i);
    one_over_one_minus_PBOT = (1/one_minus_PBOT);
    one_over_one_minus_PSTI = (1/one_minus_PSTI);
    one_over_one_minus_PGAT = (1/one_minus_PGAT);
    {
      double value_pow_0 = pow((VBIRBOT_i*vbiinvbot),PBOT_i);
      cjobot = (CJORBOT_i*value_pow_0);
    }
    {
      double value_pow_0 = pow((VBIRSTI_i*vbiinvsti),PSTI_i);
      cjosti = (CJORSTI_i*value_pow_0);
    }
    {
      double value_pow_0 = pow((VBIRGAT_i*vbiinvgat),PGAT_i);
      cjogat = (CJORGAT_i*value_pow_0);
    }
    qprefbot = ((cjobot*vbibot)*one_over_one_minus_PBOT);
    qprefsti = ((cjosti*vbisti)*one_over_one_minus_PSTI);
    qprefgat = ((cjogat*vbigat)*one_over_one_minus_PGAT);
    qpref2bot = (2*cjobot);
    qpref2sti = (2*cjosti);
    qpref2gat = (2*cjogat);
    wdepnulrbot = (EPSSI/CJORBOT_i);
    wdepnulrsti = ((XJUNSTI_i*EPSSI)/CJORSTI_i);
    wdepnulrgat = ((XJUNGAT_i*EPSSI)/CJORGAT_i);
    wdepnulrinvbot = (1/wdepnulrbot);
    wdepnulrinvsti = (1/wdepnulrsti);
    wdepnulrinvgat = (1/wdepnulrgat);
    VBIRBOTinv = (1/VBIRBOT_i);
    VBIRSTIinv = (1/VBIRSTI_i);
    VBIRGATinv = (1/VBIRGAT_i);
    perfc = (1.77245385090551603*0.29214664);
    {
      double value_pow_0 = pow(perfc,(-2));
      berfc = (((((-5)*0.29214664)+6)-value_pow_0)/3.0);
    }
    cerfc = ((1.0-0.29214664)-berfc);
    {
      double value_max_0 = std::max((0.5*phigdbot),phitd);
      deltaEbot = value_max_0;
    }
    {
      double value_max_0 = std::max((0.5*phigdsti),phitd);
      deltaEsti = value_max_0;
    }
    {
      double value_max_0 = std::max((0.5*phigdgat),phitd);
      deltaEgat = value_max_0;
    }
    atatbot = (deltaEbot*phitdinv);
    atatsti = (deltaEsti*phitdinv);
    atatgat = (deltaEgat*phitdinv);
    {
      double value_sqrt_0 = sqrt(((((32*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*deltaEbot)));
      btatpartbot = (value_sqrt_0/(3*1.05457168E-34));
    }
    {
      double value_sqrt_0 = sqrt(((((32*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*deltaEsti)));
      btatpartsti = (value_sqrt_0/(3*1.05457168E-34));
    }
    {
      double value_sqrt_0 = sqrt(((((32*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*deltaEgat)));
      btatpartgat = (value_sqrt_0/(3*1.05457168E-34));
    }
    fbbtbot = (FBBTRBOT_i*(1+(STFBBTBOT_i*(tkd-tkr))));
    fbbtsti = (FBBTRSTI_i*(1+(STFBBTSTI_i*(tkd-tkr))));
    fbbtgat = (FBBTRGAT_i*(1+(STFBBTGAT_i*(tkd-tkr))));
    fbbtbot = ((fbbtbot>0)?fbbtbot:0);
    fbbtsti = ((fbbtsti>0)?fbbtsti:0);
    fbbtgat = ((fbbtgat>0)?fbbtgat:0);
    {
      double value_pow_0 = pow(0.999,PBRBOT_i);
      fstopbot = (1/(1-value_pow_0));
    }
    {
      double value_pow_0 = pow(0.999,PBRSTI_i);
      fstopsti = (1/(1-value_pow_0));
    }
    {
      double value_pow_0 = pow(0.999,PBRGAT_i);
      fstopgat = (1/(1-value_pow_0));
    }
    VBRinvbot = (1/VBRBOT_i);
    VBRinvsti = (1/VBRSTI_i);
    VBRinvgat = (1/VBRGAT_i);
    {
      double value_pow_0 = pow(0.999,(PBRBOT_i-1));
      slopebot = (((-((fstopbot*fstopbot)*value_pow_0))*PBRBOT_i)*VBRinvbot);
    }
    {
      double value_pow_0 = pow(0.999,(PBRSTI_i-1));
      slopesti = (((-((fstopsti*fstopsti)*value_pow_0))*PBRSTI_i)*VBRinvsti);
    }
    {
      double value_pow_0 = pow(0.999,(PBRGAT_i-1));
      slopegat = (((-((fstopgat*fstopgat)*value_pow_0))*PBRGAT_i)*VBRinvgat);
    }
    phigrbot_d = (PHIGBOTD_i+deltaphigr);
    phigrsti_d = (PHIGSTID_i+deltaphigr);
    phigrgat_d = (PHIGGATD_i+deltaphigr);
    phigdbot_d = (PHIGBOTD_i+deltaphigd);
    phigdsti_d = (PHIGSTID_i+deltaphigd);
    phigdgat_d = (PHIGGATD_i+deltaphigd);
    {
      double value_pow_0 = pow(auxt,1.5);
      double value_exp_1 = exp((0.5*((phigrbot_d*phitrinv)-(phigdbot_d*phitdinv))));
      ftdbot_d = (value_pow_0*value_exp_1);
    }
    {
      double value_pow_0 = pow(auxt,1.5);
      double value_exp_1 = exp((0.5*((phigrsti_d*phitrinv)-(phigdsti_d*phitdinv))));
      ftdsti_d = (value_pow_0*value_exp_1);
    }
    {
      double value_pow_0 = pow(auxt,1.5);
      double value_exp_1 = exp((0.5*((phigrgat_d*phitrinv)-(phigdgat_d*phitdinv))));
      ftdgat_d = (value_pow_0*value_exp_1);
    }
    idsatbot_d = ((IDSATRBOTD_i*ftdbot_d)*ftdbot_d);
    idsatsti_d = ((IDSATRSTID_i*ftdsti_d)*ftdsti_d);
    idsatgat_d = ((IDSATRGATD_i*ftdgat_d)*ftdgat_d);
    {
      double value_log_0 = log(ftdbot_d);
      ubibot_d = ((VBIRBOTD_i*auxt)-((2*phitd)*value_log_0));
    }
    {
      double value_log_0 = log(ftdsti_d);
      ubisti_d = ((VBIRSTID_i*auxt)-((2*phitd)*value_log_0));
    }
    {
      double value_log_0 = log(ftdgat_d);
      ubigat_d = ((VBIRGATD_i*auxt)-((2*phitd)*value_log_0));
    }
    {
      double value_exp_0 = exp(((0.050-ubibot_d)*phitdinv));
      double value_log_1 = log((1+value_exp_0));
      vbibot_d = (ubibot_d+(phitd*value_log_1));
    }
    {
      double value_exp_0 = exp(((0.050-ubisti_d)*phitdinv));
      double value_log_1 = log((1+value_exp_0));
      vbisti_d = (ubisti_d+(phitd*value_log_1));
    }
    {
      double value_exp_0 = exp(((0.050-ubigat_d)*phitdinv));
      double value_log_1 = log((1+value_exp_0));
      vbigat_d = (ubigat_d+(phitd*value_log_1));
    }
    vbiinvbot_d = (1.0/vbibot_d);
    vbiinvsti_d = (1.0/vbisti_d);
    vbiinvgat_d = (1.0/vbigat_d);
    one_minus_PBOT_d = (1-PBOTD_i);
    one_minus_PSTI_d = (1-PSTID_i);
    one_minus_PGAT_d = (1-PGATD_i);
    one_over_one_minus_PBOT_d = (1/one_minus_PBOT_d);
    one_over_one_minus_PSTI_d = (1/one_minus_PSTI_d);
    one_over_one_minus_PGAT_d = (1/one_minus_PGAT_d);
    {
      double value_pow_0 = pow((VBIRBOTD_i*vbiinvbot_d),PBOTD_i);
      cjobot_d = (CJORBOTD_i*value_pow_0);
    }
    {
      double value_pow_0 = pow((VBIRSTID_i*vbiinvsti_d),PSTID_i);
      cjosti_d = (CJORSTID_i*value_pow_0);
    }
    {
      double value_pow_0 = pow((VBIRGATD_i*vbiinvgat_d),PGATD_i);
      cjogat_d = (CJORGATD_i*value_pow_0);
    }
    qprefbot_d = ((cjobot_d*vbibot_d)*one_over_one_minus_PBOT_d);
    qprefsti_d = ((cjosti_d*vbisti_d)*one_over_one_minus_PSTI_d);
    qprefgat_d = ((cjogat_d*vbigat_d)*one_over_one_minus_PGAT_d);
    qpref2bot_d = (2*cjobot_d);
    qpref2sti_d = (2*cjosti_d);
    qpref2gat_d = (2*cjogat_d);
    wdepnulrbot_d = (EPSSI/CJORBOTD_i);
    wdepnulrsti_d = ((XJUNSTID_i*EPSSI)/CJORSTID_i);
    wdepnulrgat_d = ((XJUNGATD_i*EPSSI)/CJORGATD_i);
    wdepnulrinvbot_d = (1/wdepnulrbot_d);
    wdepnulrinvsti_d = (1/wdepnulrsti_d);
    wdepnulrinvgat_d = (1/wdepnulrgat_d);
    VBIRBOTinv_d = (1/VBIRBOTD_i);
    VBIRSTIinv_d = (1/VBIRSTID_i);
    VBIRGATinv_d = (1/VBIRGATD_i);
    {
      double value_max_0 = std::max((0.5*phigdbot_d),phitd);
      deltaEbot_d = value_max_0;
    }
    {
      double value_max_0 = std::max((0.5*phigdsti_d),phitd);
      deltaEsti_d = value_max_0;
    }
    {
      double value_max_0 = std::max((0.5*phigdgat_d),phitd);
      deltaEgat_d = value_max_0;
    }
    atatbot_d = (deltaEbot_d*phitdinv);
    atatsti_d = (deltaEsti_d*phitdinv);
    atatgat_d = (deltaEgat_d*phitdinv);
    {
      double value_sqrt_0 = sqrt(((((32*MEFFTATBOTD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot_d*deltaEbot_d)*deltaEbot_d)));
      btatpartbot_d = (value_sqrt_0/(3*1.05457168E-34));
    }
    {
      double value_sqrt_0 = sqrt(((((32*MEFFTATSTID_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti_d*deltaEsti_d)*deltaEsti_d)));
      btatpartsti_d = (value_sqrt_0/(3*1.05457168E-34));
    }
    {
      double value_sqrt_0 = sqrt(((((32*MEFFTATGATD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat_d*deltaEgat_d)*deltaEgat_d)));
      btatpartgat_d = (value_sqrt_0/(3*1.05457168E-34));
    }
    fbbtbot_d = (FBBTRBOTD_i*(1+(STFBBTBOTD_i*(tkd-tkr))));
    fbbtsti_d = (FBBTRSTID_i*(1+(STFBBTSTID_i*(tkd-tkr))));
    fbbtgat_d = (FBBTRGATD_i*(1+(STFBBTGATD_i*(tkd-tkr))));
    fbbtbot_d = ((fbbtbot_d>0)?fbbtbot_d:0);
    fbbtsti_d = ((fbbtsti_d>0)?fbbtsti_d:0);
    fbbtgat_d = ((fbbtgat_d>0)?fbbtgat_d:0);
    {
      double value_pow_0 = pow(0.999,PBRBOTD_i);
      fstopbot_d = (1/(1-value_pow_0));
    }
    {
      double value_pow_0 = pow(0.999,PBRSTID_i);
      fstopsti_d = (1/(1-value_pow_0));
    }
    {
      double value_pow_0 = pow(0.999,PBRGATD_i);
      fstopgat_d = (1/(1-value_pow_0));
    }
    VBRinvbot_d = (1/VBRBOTD_i);
    VBRinvsti_d = (1/VBRSTID_i);
    VBRinvgat_d = (1/VBRGATD_i);
    {
      double value_pow_0 = pow(0.999,(PBRBOTD_i-1));
      slopebot_d = (((-((fstopbot_d*fstopbot_d)*value_pow_0))*PBRBOTD_i)*VBRinvbot_d);
    }
    {
      double value_pow_0 = pow(0.999,(PBRSTID_i-1));
      slopesti_d = (((-((fstopsti_d*fstopsti_d)*value_pow_0))*PBRSTID_i)*VBRinvsti_d);
    }
    {
      double value_pow_0 = pow(0.999,(PBRGATD_i-1));
      slopegat_d = (((-((fstopgat_d*fstopgat_d)*value_pow_0))*PBRGATD_i)*VBRinvgat_d);
    }
  }
  // End block initial_model


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    LEVEL(1020),
    TYPE(1.0),
    TR(21.0),
    SWIGATE(0.0),
    SWIMPACT(0.0),
    SWGIDL(0.0),
    SWJUNCAP(0.0),
    SWJUNASYM(0.0),
    QMC(1.0),
    LVARO(0.0),
    LVARL(0.0),
    LVARW(0.0),
    LAP(0.0),
    WVARO(0.0),
    WVARL(0.0),
    WVARW(0.0),
    WOT(0.0),
    DLQ(0.0),
    DWQ(0.0),
    VFBO((-1.0)),
    VFBL(0.0),
    VFBW(0.0),
    VFBLW(0.0),
    STVFBO(5e-4),
    STVFBL(0.0),
    STVFBW(0.0),
    STVFBLW(0.0),
    TOXO(2e-9),
    EPSROXO(3.9),
    NSUBO(3e23),
    NSUBW(0.0),
    WSEG(1e-8),
    NPCK(1e24),
    NPCKW(0.0),
    WSEGP(1e-8),
    LPCK(1e-8),
    LPCKW(0.0),
    FOL1(0.0),
    FOL2(0.0),
    VNSUBO(0.0),
    NSLPO(0.05),
    DNSUBO(0.0),
    DPHIBO(0.0),
    DPHIBL(0.0),
    DPHIBLEXP(1.0),
    DPHIBW(0.0),
    DPHIBLW(0.0),
    NPO(1e26),
    NPL(0.0),
    CTO(0.0),
    CTL(0.0),
    CTLEXP(1.0),
    CTW(0.0),
    CTLW(0.0),
    TOXOVO(2e-9),
    TOXOVDO(2e-9),
    LOV(0),
    LOVD(0),
    NOVO(5e25),
    NOVDO(5e25),
    CFL(0.0),
    CFLEXP(2.0),
    CFW(0.0),
    CFBO(0.0),
    UO(5e-2),
    FBET1(0.0),
    FBET1W(0.0),
    LP1(1e-8),
    LP1W(0.0),
    FBET2(0.0),
    LP2(1e-8),
    BETW1(0.0),
    BETW2(0.0),
    WBET(1e-9),
    STBETO(1.0),
    STBETL(0.0),
    STBETW(0.0),
    STBETLW(0.0),
    MUEO(0.5),
    MUEW(0.0),
    STMUEO(0.0),
    THEMUO(1.5),
    STTHEMUO(1.5),
    CSO(0.0),
    CSL(0.0),
    CSLEXP(0.0),
    CSW(0.0),
    CSLW(0.0),
    STCSO(0.0),
    XCORO(0.0),
    XCORL(0.0),
    XCORW(0.0),
    XCORLW(0.0),
    STXCORO(0.0),
    FETAO(1.0),
    RSW1(2.5e3),
    RSW2(0.0),
    STRSO(1.0),
    RSBO(0.0),
    RSGO(0.0),
    THESATO(0.0),
    THESATL(0.05),
    THESATLEXP(1.0),
    THESATW(0.0),
    THESATLW(0.0),
    STTHESATO(1.0),
    STTHESATL(0.0),
    STTHESATW(0.0),
    STTHESATLW(0.0),
    THESATBO(0.0),
    THESATGO(0.0),
    AXO(18),
    AXL(0.4),
    ALPL(5e-4),
    ALPLEXP(1.0),
    ALPW(0.0),
    ALP1L1(0.0),
    ALP1LEXP(0.5),
    ALP1L2(0.0),
    ALP1W(0.0),
    ALP2L1(0.0),
    ALP2LEXP(0.5),
    ALP2L2(0.0),
    ALP2W(0.0),
    VPO(0.05),
    A1O(1.0),
    A1L(0.0),
    A1W(0.0),
    A2O(10),
    STA2O(0.0),
    A3O(1.0),
    A3L(0.0),
    A3W(0.0),
    A4O(0.0),
    A4L(0.0),
    A4W(0.0),
    GCOO(0.0),
    IGINVLW(0.0),
    IGOVW(0.0),
    IGOVDW(0.0),
    STIGO(2.0),
    GC2O(0.375),
    GC3O(0.063),
    CHIBO(3.1),
    AGIDLW(0.0),
    AGIDLDW(0.0),
    BGIDLO(41),
    BGIDLDO(41),
    STBGIDLO(0.0),
    STBGIDLDO(0.0),
    CGIDLO(0.0),
    CGIDLDO(0.0),
    CGBOVL(0.0),
    CFRW(0.0),
    CFRDW(0.0),
    FNTO(1.0),
    FNTEXCL(0.0),
    NFALW(8e22),
    NFBLW(3e7),
    NFCLW(0.0),
    EFO(1.0),
    LINTNOI(0.0),
    ALPNOI(2.0),
    DTA(0),
    KVTHOWEO(0),
    KVTHOWEL(0),
    KVTHOWEW(0),
    KVTHOWELW(0),
    KUOWEO(0),
    KUOWEL(0),
    KUOWEW(0),
    KUOWELW(0),
    LMIN(0),
    LMAX(1.0),
    WMIN(0),
    WMAX(1.0),
    RGO(0.0),
    RBULKO(0.0),
    RWELLO(0.0),
    RJUNSO(0.0),
    RJUNDO(0.0),
    RINT(0.0),
    RVPOLY(0.0),
    RSHG(0.0),
    DLSIL(0.0),
    SAREF(1.0e-6),
    SBREF(1.0e-6),
    WLOD(0),
    KUO(0),
    KVSAT(0),
    TKUO(0),
    LKUO(0),
    WKUO(0),
    PKUO(0),
    LLODKUO(0),
    WLODKUO(0),
    KVTHO(0),
    LKVTHO(0),
    WKVTHO(0),
    PKVTHO(0),
    LLODVTH(0),
    WLODVTH(0),
    STETAO(0),
    LODETAO(1.0),
    SCREF(1e-6),
    WEB(0),
    WEC(0),
    IMAX(1000),
    TRJ(21),
    CJORBOT(1E-3),
    CJORSTI(1E-9),
    CJORGAT(1E-9),
    VBIRBOT(1),
    VBIRSTI(1),
    VBIRGAT(1),
    PBOT(0.5),
    PSTI(0.5),
    PGAT(0.5),
    PHIGBOT(1.16),
    PHIGSTI(1.16),
    PHIGGAT(1.16),
    IDSATRBOT(1E-12),
    IDSATRSTI(1E-18),
    IDSATRGAT(1E-18),
    CSRHBOT(1E2),
    CSRHSTI(1E-4),
    CSRHGAT(1E-4),
    XJUNSTI(100E-9),
    XJUNGAT(100E-9),
    CTATBOT(1E2),
    CTATSTI(1E-4),
    CTATGAT(1E-4),
    MEFFTATBOT(0.25),
    MEFFTATSTI(0.25),
    MEFFTATGAT(0.25),
    CBBTBOT(1E-12),
    CBBTSTI(1E-18),
    CBBTGAT(1E-18),
    FBBTRBOT(1E9),
    FBBTRSTI(1E9),
    FBBTRGAT(1E9),
    STFBBTBOT((-1E-3)),
    STFBBTSTI((-1E-3)),
    STFBBTGAT((-1E-3)),
    VBRBOT(10),
    VBRSTI(10),
    VBRGAT(10),
    PBRBOT(4),
    PBRSTI(4),
    PBRGAT(4),
    CJORBOTD(1E-3),
    CJORSTID(1E-9),
    CJORGATD(1E-9),
    VBIRBOTD(1),
    VBIRSTID(1),
    VBIRGATD(1),
    PBOTD(0.5),
    PSTID(0.5),
    PGATD(0.5),
    PHIGBOTD(1.16),
    PHIGSTID(1.16),
    PHIGGATD(1.16),
    IDSATRBOTD(1E-12),
    IDSATRSTID(1E-18),
    IDSATRGATD(1E-18),
    CSRHBOTD(1E2),
    CSRHSTID(1E-4),
    CSRHGATD(1E-4),
    XJUNSTID(100E-9),
    XJUNGATD(100E-9),
    CTATBOTD(1E2),
    CTATSTID(1E-4),
    CTATGATD(1E-4),
    MEFFTATBOTD(0.25),
    MEFFTATSTID(0.25),
    MEFFTATGATD(0.25),
    CBBTBOTD(1E-12),
    CBBTSTID(1E-18),
    CBBTGATD(1E-18),
    FBBTRBOTD(1E9),
    FBBTRSTID(1E9),
    FBBTRGATD(1E9),
    STFBBTBOTD((-1E-3)),
    STFBBTSTID((-1E-3)),
    STFBBTGATD((-1E-3)),
    VBRBOTD(10),
    VBRSTID(10),
    VBRGATD(10),
    PBRBOTD(4),
    PBRSTID(4),
    PBRGATD(4),
    SWJUNEXP(0.0),
    VJUNREF(2.5),
    FJUNQ(0.03),
    VJUNREFD(2.5),
    FJUNQD(0.03),
    NSUBO_i(0.0),
    WSEG_i(0.0),
    NPCK_i(0.0),
    WSEGP_i(0.0),
    LPCK_i(0.0),
    LOV_i(0.0),
    LOVD_i(0.0),
    LP1_i(0.0),
    LP2_i(0.0),
    WBET_i(0.0),
    AXL_i(0.0),
    ALP1L2_i(0.0),
    ALP2L2_i(0.0),
    RINT_i(0.0),
    RVPOLY_i(0.0),
    SAREF_i(0.0),
    SBREF_i(0.0),
    KVSAT_i(0.0),
    LLODKUO_i(0.0),
    WLODKUO_i(0.0),
    LLODVTH_i(0.0),
    WLODVTH_i(0.0),
    LODETAO_i(0.0),
    SCREF_i(0.0),
    WEB_i(0.0),
    WEC_i(0.0),
    TOX_i(0.0),
    EPSROX_i(0.0),
    TOXOV_i(0.0),
    TOXOVD_i(0.0),
    TKD(0.0),
    dT(0.0),
    rT(0.0),
    rTn(0.0),
    EPSSI(0.0),
    phit(0.0),
    inv_phit(0.0),
    Eg(0.0),
    phibFac(0.0),
    nt0(0.0),
    CHNL_TYPE(0),
    IMAX_i(0.0),
    VBIRBOT_i(0.0),
    VBIRSTI_i(0.0),
    VBIRGAT_i(0.0),
    PBOT_i(0.0),
    PSTI_i(0.0),
    PGAT_i(0.0),
    CSRHBOT_i(0.0),
    CSRHSTI_i(0.0),
    CSRHGAT_i(0.0),
    CTATBOT_i(0.0),
    CTATSTI_i(0.0),
    CTATGAT_i(0.0),
    CBBTBOT_i(0.0),
    CBBTSTI_i(0.0),
    CBBTGAT_i(0.0),
    VBRBOT_i(0.0),
    VBRSTI_i(0.0),
    VBRGAT_i(0.0),
    PBRBOT_i(0.0),
    PBRSTI_i(0.0),
    PBRGAT_i(0.0),
    SWJUNEXP_i(0.0),
    VJUNREF_i(0.0),
    FJUNQ_i(0.0),
    phitr(0.0),
    phitd(0.0),
    phitdinv(0.0),
    perfc(0.0),
    berfc(0.0),
    cerfc(0.0),
    ftdbot(0.0),
    ftdsti(0.0),
    ftdgat(0.0),
    idsatbot(0.0),
    idsatsti(0.0),
    idsatgat(0.0),
    vbibot(0.0),
    vbisti(0.0),
    vbigat(0.0),
    vbiinvbot(0.0),
    vbiinvsti(0.0),
    vbiinvgat(0.0),
    one_minus_PBOT(0.0),
    one_minus_PSTI(0.0),
    one_minus_PGAT(0.0),
    one_over_one_minus_PBOT(0.0),
    one_over_one_minus_PSTI(0.0),
    one_over_one_minus_PGAT(0.0),
    cjobot(0.0),
    cjosti(0.0),
    cjogat(0.0),
    qprefbot(0.0),
    qprefsti(0.0),
    qprefgat(0.0),
    qpref2bot(0.0),
    qpref2sti(0.0),
    qpref2gat(0.0),
    wdepnulrbot(0.0),
    wdepnulrsti(0.0),
    wdepnulrgat(0.0),
    wdepnulrinvbot(0.0),
    wdepnulrinvsti(0.0),
    wdepnulrinvgat(0.0),
    VBIRBOTinv(0.0),
    VBIRSTIinv(0.0),
    VBIRGATinv(0.0),
    atatbot(0.0),
    atatsti(0.0),
    atatgat(0.0),
    btatpartbot(0.0),
    btatpartsti(0.0),
    btatpartgat(0.0),
    fbbtbot(0.0),
    fbbtsti(0.0),
    fbbtgat(0.0),
    fstopbot(0.0),
    fstopsti(0.0),
    fstopgat(0.0),
    VBRinvbot(0.0),
    VBRinvsti(0.0),
    VBRinvgat(0.0),
    slopebot(0.0),
    slopesti(0.0),
    slopegat(0.0),
    VBIRBOTD_i(0.0),
    VBIRSTID_i(0.0),
    VBIRGATD_i(0.0),
    PBOTD_i(0.0),
    PSTID_i(0.0),
    PGATD_i(0.0),
    CSRHBOTD_i(0.0),
    CSRHSTID_i(0.0),
    CSRHGATD_i(0.0),
    CTATBOTD_i(0.0),
    CTATSTID_i(0.0),
    CTATGATD_i(0.0),
    CBBTBOTD_i(0.0),
    CBBTSTID_i(0.0),
    CBBTGATD_i(0.0),
    VBRBOTD_i(0.0),
    VBRSTID_i(0.0),
    VBRGATD_i(0.0),
    PBRBOTD_i(0.0),
    PBRSTID_i(0.0),
    PBRGATD_i(0.0),
    VJUNREFD_i(0.0),
    FJUNQD_i(0.0),
    ftdbot_d(0.0),
    ftdsti_d(0.0),
    ftdgat_d(0.0),
    idsatbot_d(0.0),
    idsatsti_d(0.0),
    idsatgat_d(0.0),
    vbibot_d(0.0),
    vbisti_d(0.0),
    vbigat_d(0.0),
    vbiinvbot_d(0.0),
    vbiinvsti_d(0.0),
    vbiinvgat_d(0.0),
    one_minus_PBOT_d(0.0),
    one_minus_PSTI_d(0.0),
    one_minus_PGAT_d(0.0),
    one_over_one_minus_PBOT_d(0.0),
    one_over_one_minus_PSTI_d(0.0),
    one_over_one_minus_PGAT_d(0.0),
    cjobot_d(0.0),
    cjosti_d(0.0),
    cjogat_d(0.0),
    qprefbot_d(0.0),
    qprefsti_d(0.0),
    qprefgat_d(0.0),
    qpref2bot_d(0.0),
    qpref2sti_d(0.0),
    qpref2gat_d(0.0),
    wdepnulrbot_d(0.0),
    wdepnulrsti_d(0.0),
    wdepnulrgat_d(0.0),
    wdepnulrinvbot_d(0.0),
    wdepnulrinvsti_d(0.0),
    wdepnulrinvgat_d(0.0),
    VBIRBOTinv_d(0.0),
    VBIRSTIinv_d(0.0),
    VBIRGATinv_d(0.0),
    atatbot_d(0.0),
    atatsti_d(0.0),
    atatgat_d(0.0),
    btatpartbot_d(0.0),
    btatpartsti_d(0.0),
    btatpartgat_d(0.0),
    fbbtbot_d(0.0),
    fbbtsti_d(0.0),
    fbbtgat_d(0.0),
    fstopbot_d(0.0),
    fstopsti_d(0.0),
    fstopgat_d(0.0),
    VBRinvbot_d(0.0),
    VBRinvsti_d(0.0),
    VBRinvgat_d(0.0),
    slopebot_d(0.0),
    slopesti_d(0.0),
    slopegat_d(0.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << "L  =  " << (*iter)->L << std::endl;
    os << "W  =  " << (*iter)->W << std::endl;
    os << "SA  =  " << (*iter)->SA << std::endl;
    os << "SB  =  " << (*iter)->SB << std::endl;
    os << "SD  =  " << (*iter)->SD << std::endl;
    os << "SCA  =  " << (*iter)->SCA << std::endl;
    os << "SCB  =  " << (*iter)->SCB << std::endl;
    os << "SCC  =  " << (*iter)->SCC << std::endl;
    os << "SC  =  " << (*iter)->SC << std::endl;
    os << "DELVTO  =  " << (*iter)->DELVTO << std::endl;
    os << "FACTUO  =  " << (*iter)->FACTUO << std::endl;
    os << "ABSOURCE  =  " << (*iter)->ABSOURCE << std::endl;
    os << "LSSOURCE  =  " << (*iter)->LSSOURCE << std::endl;
    os << "LGSOURCE  =  " << (*iter)->LGSOURCE << std::endl;
    os << "ABDRAIN  =  " << (*iter)->ABDRAIN << std::endl;
    os << "LSDRAIN  =  " << (*iter)->LSDRAIN << std::endl;
    os << "LGDRAIN  =  " << (*iter)->LGDRAIN << std::endl;
    os << "AS  =  " << (*iter)->AS << std::endl;
    os << "PS  =  " << (*iter)->PS << std::endl;
    os << "AD  =  " << (*iter)->AD << std::endl;
    os << "PD  =  " << (*iter)->PD << std::endl;
    os << "MULT  =  " << (*iter)->MULT << std::endl;
    os << "NF  =  " << (*iter)->NF << std::endl;
    os << "NGCON  =  " << (*iter)->NGCON << std::endl;
    os << "XGW  =  " << (*iter)->XGW << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
  if (deviceMap.empty() ||
      ((deviceMap.find("M") != deviceMap.end() && (levelSet.find(102)!=levelSet.end()))))
  {
    MOSFET1::registerDevice();
    Config<Traits>::addConfiguration()
      .registerDevice("m", 102)
      .registerModelType("nmos", 102)
      .registerModelType("pmos", 102);
  }
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_W,
   bool instancePar_given_W,
   AdmsSensFadType & instancePar_SA,
   bool instancePar_given_SA,
   AdmsSensFadType & instancePar_SB,
   bool instancePar_given_SB,
   AdmsSensFadType & instancePar_SD,
   bool instancePar_given_SD,
   AdmsSensFadType & instancePar_SCA,
   bool instancePar_given_SCA,
   AdmsSensFadType & instancePar_SCB,
   bool instancePar_given_SCB,
   AdmsSensFadType & instancePar_SCC,
   bool instancePar_given_SCC,
   AdmsSensFadType & instancePar_SC,
   bool instancePar_given_SC,
   AdmsSensFadType & instancePar_DELVTO,
   bool instancePar_given_DELVTO,
   AdmsSensFadType & instancePar_FACTUO,
   bool instancePar_given_FACTUO,
   AdmsSensFadType & instancePar_ABSOURCE,
   bool instancePar_given_ABSOURCE,
   AdmsSensFadType & instancePar_LSSOURCE,
   bool instancePar_given_LSSOURCE,
   AdmsSensFadType & instancePar_LGSOURCE,
   bool instancePar_given_LGSOURCE,
   AdmsSensFadType & instancePar_ABDRAIN,
   bool instancePar_given_ABDRAIN,
   AdmsSensFadType & instancePar_LSDRAIN,
   bool instancePar_given_LSDRAIN,
   AdmsSensFadType & instancePar_LGDRAIN,
   bool instancePar_given_LGDRAIN,
   AdmsSensFadType & instancePar_AS,
   bool instancePar_given_AS,
   AdmsSensFadType & instancePar_PS,
   bool instancePar_given_PS,
   AdmsSensFadType & instancePar_AD,
   bool instancePar_given_AD,
   AdmsSensFadType & instancePar_PD,
   bool instancePar_given_PD,
   AdmsSensFadType & instancePar_MULT,
   bool instancePar_given_MULT,
   AdmsSensFadType & instancePar_NF,
   bool instancePar_given_NF,
   AdmsSensFadType & instancePar_NGCON,
   bool instancePar_given_NGCON,
   AdmsSensFadType & instancePar_XGW,
   bool instancePar_given_XGW,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_VFB_i,
   AdmsSensFadType & instanceVar_VNSUB_i,
   AdmsSensFadType & instanceVar_NSLP_i,
   AdmsSensFadType & instanceVar_DNSUB_i,
   AdmsSensFadType & instanceVar_CF_i,
   AdmsSensFadType & instanceVar_CFB_i,
   AdmsSensFadType & instanceVar_MUE_i,
   AdmsSensFadType & instanceVar_THEMU_i,
   AdmsSensFadType & instanceVar_CS_i,
   AdmsSensFadType & instanceVar_XCOR_i,
   AdmsSensFadType & instanceVar_THER_i,
   AdmsSensFadType & instanceVar_RSB_i,
   AdmsSensFadType & instanceVar_RSG_i,
   AdmsSensFadType & instanceVar_THESAT_i,
   AdmsSensFadType & instanceVar_THESATB_i,
   AdmsSensFadType & instanceVar_THESATG_i,
   AdmsSensFadType & instanceVar_AX_i,
   AdmsSensFadType & instanceVar_ALP_i,
   AdmsSensFadType & instanceVar_ALP1_i,
   AdmsSensFadType & instanceVar_ALP2_i,
   AdmsSensFadType & instanceVar_A1_i,
   AdmsSensFadType & instanceVar_A2_i,
   AdmsSensFadType & instanceVar_A3_i,
   AdmsSensFadType & instanceVar_A4_i,
   AdmsSensFadType & instanceVar_IGINV_i,
   AdmsSensFadType & instanceVar_IGOV_i,
   AdmsSensFadType & instanceVar_IGOVD_i,
   AdmsSensFadType & instanceVar_GC2_i,
   AdmsSensFadType & instanceVar_GC3_i,
   AdmsSensFadType & instanceVar_CHIB_i,
   AdmsSensFadType & instanceVar_AGIDL_i,
   AdmsSensFadType & instanceVar_CGIDL_i,
   AdmsSensFadType & instanceVar_AGIDLD_i,
   AdmsSensFadType & instanceVar_CGIDLD_i,
   AdmsSensFadType & instanceVar_COX_i,
   AdmsSensFadType & instanceVar_CGOV_i,
   AdmsSensFadType & instanceVar_CGOVD_i,
   AdmsSensFadType & instanceVar_CGBOV_i,
   AdmsSensFadType & instanceVar_CFR_i,
   AdmsSensFadType & instanceVar_CFRD_i,
   AdmsSensFadType & instanceVar_NFA_i,
   AdmsSensFadType & instanceVar_NFB_i,
   AdmsSensFadType & instanceVar_NFC_i,
   AdmsSensFadType & instanceVar_EF_i,
   AdmsSensFadType & instanceVar_FNTEXC_i,
   AdmsSensFadType & instanceVar_MULT_i,
   AdmsSensFadType & instanceVar_BET_i,
   AdmsSensFadType & instanceVar_kp,
   AdmsSensFadType & instanceVar_qq,
   AdmsSensFadType & instanceVar_qlim2,
   AdmsSensFadType & instanceVar_E_eff0,
   AdmsSensFadType & instanceVar_eta_mu,
   AdmsSensFadType & instanceVar_BCH,
   AdmsSensFadType & instanceVar_BOV,
   AdmsSensFadType & instanceVar_inv_CHIB,
   AdmsSensFadType & instanceVar_GCQ,
   AdmsSensFadType & instanceVar_Dch,
   AdmsSensFadType & instanceVar_Dov,
   AdmsSensFadType & instanceVar_x1,
   AdmsSensFadType & instanceVar_Vdsat_lim,
   AdmsSensFadType & instanceVar_nt,
   AdmsSensFadType & instanceVar_Cox_over_q,
   AdmsSensFadType & instanceVar_GOV_s,
   AdmsSensFadType & instanceVar_GOV_d,
   AdmsSensFadType & instanceVar_GOV2_s,
   AdmsSensFadType & instanceVar_GOV2_d,
   AdmsSensFadType & instanceVar_BOV_d,
   AdmsSensFadType & instanceVar_xi_ov_s,
   AdmsSensFadType & instanceVar_xi_ov_d,
   AdmsSensFadType & instanceVar_inv_xi_ov_s,
   AdmsSensFadType & instanceVar_inv_xi_ov_d,
   AdmsSensFadType & instanceVar_x_mrg_ov_s,
   AdmsSensFadType & instanceVar_x_mrg_ov_d,
   AdmsSensFadType & instanceVar_inv_xg1_s,
   AdmsSensFadType & instanceVar_inv_xg1_d,
   AdmsSensFadType & instanceVar_AGIDLs,
   AdmsSensFadType & instanceVar_AGIDLDs,
   AdmsSensFadType & instanceVar_BGIDLs,
   AdmsSensFadType & instanceVar_BGIDLDs,
   AdmsSensFadType & instanceVar_phib,
   AdmsSensFadType & instanceVar_sqrt_phib,
   AdmsSensFadType & instanceVar_phix,
   AdmsSensFadType & instanceVar_aphi,
   AdmsSensFadType & instanceVar_bphi,
   AdmsSensFadType & instanceVar_phix1,
   AdmsSensFadType & instanceVar_G_0,
   AdmsSensFadType & instanceVar_phit1,
   AdmsSensFadType & instanceVar_inv_phit1,
   AdmsSensFadType & instanceVar_alpha_b,
   AdmsSensFadType & instanceVar_inv_VP,
   AdmsSensFadType & instanceVar_inv_AX,
   AdmsSensFadType & instanceVar_Sfl_prefac,
   AdmsSensFadType & instanceVar_fac_exc,
   AdmsSensFadType & instanceVar_RG_i,
   AdmsSensFadType & instanceVar_RBULK_i,
   AdmsSensFadType & instanceVar_RWELL_i,
   AdmsSensFadType & instanceVar_RJUNS_i,
   AdmsSensFadType & instanceVar_RJUND_i,
   AdmsSensFadType & instanceVar_ggate,
   AdmsSensFadType & instanceVar_gbulk,
   AdmsSensFadType & instanceVar_gwell,
   AdmsSensFadType & instanceVar_gjund,
   AdmsSensFadType & instanceVar_gjuns,
   AdmsSensFadType & instanceVar_ABSOURCE_i,
   AdmsSensFadType & instanceVar_LSSOURCE_i,
   AdmsSensFadType & instanceVar_LGSOURCE_i,
   AdmsSensFadType & instanceVar_zflagbot_s,
   AdmsSensFadType & instanceVar_zflagsti_s,
   AdmsSensFadType & instanceVar_zflaggat_s,
   AdmsSensFadType & instanceVar_VMAX_s,
   AdmsSensFadType & instanceVar_exp_VMAX_over_phitd_s,
   AdmsSensFadType & instanceVar_vbimin_s,
   AdmsSensFadType & instanceVar_vch_s,
   AdmsSensFadType & instanceVar_vfmin_s,
   AdmsSensFadType & instanceVar_vbbtlim_s,
   AdmsSensFadType & instanceVar_xhighf1_s,
   AdmsSensFadType & instanceVar_expxhf1_s,
   AdmsSensFadType & instanceVar_xhighf2_s,
   AdmsSensFadType & instanceVar_expxhf2_s,
   AdmsSensFadType & instanceVar_xhighr_s,
   AdmsSensFadType & instanceVar_expxhr_s,
   AdmsSensFadType & instanceVar_m0flag_s,
   AdmsSensFadType & instanceVar_ISATFOR1_s,
   AdmsSensFadType & instanceVar_MFOR1_s,
   AdmsSensFadType & instanceVar_ISATFOR2_s,
   AdmsSensFadType & instanceVar_MFOR2_s,
   AdmsSensFadType & instanceVar_ISATREV_s,
   AdmsSensFadType & instanceVar_MREV_s,
   AdmsSensFadType & instanceVar_ABDRAIN_i,
   AdmsSensFadType & instanceVar_LSDRAIN_i,
   AdmsSensFadType & instanceVar_LGDRAIN_i,
   AdmsSensFadType & instanceVar_zflagbot_d,
   AdmsSensFadType & instanceVar_zflagsti_d,
   AdmsSensFadType & instanceVar_zflaggat_d,
   AdmsSensFadType & instanceVar_VMAX_d,
   AdmsSensFadType & instanceVar_exp_VMAX_over_phitd_d,
   AdmsSensFadType & instanceVar_vbimin_d,
   AdmsSensFadType & instanceVar_vch_d,
   AdmsSensFadType & instanceVar_vfmin_d,
   AdmsSensFadType & instanceVar_vbbtlim_d,
   AdmsSensFadType & instanceVar_xhighf1_d,
   AdmsSensFadType & instanceVar_expxhf1_d,
   AdmsSensFadType & instanceVar_xhighf2_d,
   AdmsSensFadType & instanceVar_expxhf2_d,
   AdmsSensFadType & instanceVar_xhighr_d,
   AdmsSensFadType & instanceVar_expxhr_d,
   AdmsSensFadType & instanceVar_m0flag_d,
   AdmsSensFadType & instanceVar_ISATFOR1_d,
   AdmsSensFadType & instanceVar_MFOR1_d,
   AdmsSensFadType & instanceVar_ISATFOR2_d,
   AdmsSensFadType & instanceVar_MFOR2_d,
   AdmsSensFadType & instanceVar_ISATREV_d,
   AdmsSensFadType & instanceVar_MREV_d,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   AdmsSensFadType & modelPar_TYPE,
   bool modelPar_given_TYPE,
   AdmsSensFadType & modelPar_TR,
   bool modelPar_given_TR,
   AdmsSensFadType & modelPar_SWIGATE,
   bool modelPar_given_SWIGATE,
   AdmsSensFadType & modelPar_SWIMPACT,
   bool modelPar_given_SWIMPACT,
   AdmsSensFadType & modelPar_SWGIDL,
   bool modelPar_given_SWGIDL,
   AdmsSensFadType & modelPar_SWJUNCAP,
   bool modelPar_given_SWJUNCAP,
   AdmsSensFadType & modelPar_SWJUNASYM,
   bool modelPar_given_SWJUNASYM,
   AdmsSensFadType & modelPar_QMC,
   bool modelPar_given_QMC,
   AdmsSensFadType & modelPar_LVARO,
   bool modelPar_given_LVARO,
   AdmsSensFadType & modelPar_LVARL,
   bool modelPar_given_LVARL,
   AdmsSensFadType & modelPar_LVARW,
   bool modelPar_given_LVARW,
   AdmsSensFadType & modelPar_LAP,
   bool modelPar_given_LAP,
   AdmsSensFadType & modelPar_WVARO,
   bool modelPar_given_WVARO,
   AdmsSensFadType & modelPar_WVARL,
   bool modelPar_given_WVARL,
   AdmsSensFadType & modelPar_WVARW,
   bool modelPar_given_WVARW,
   AdmsSensFadType & modelPar_WOT,
   bool modelPar_given_WOT,
   AdmsSensFadType & modelPar_DLQ,
   bool modelPar_given_DLQ,
   AdmsSensFadType & modelPar_DWQ,
   bool modelPar_given_DWQ,
   AdmsSensFadType & modelPar_VFBO,
   bool modelPar_given_VFBO,
   AdmsSensFadType & modelPar_VFBL,
   bool modelPar_given_VFBL,
   AdmsSensFadType & modelPar_VFBW,
   bool modelPar_given_VFBW,
   AdmsSensFadType & modelPar_VFBLW,
   bool modelPar_given_VFBLW,
   AdmsSensFadType & modelPar_STVFBO,
   bool modelPar_given_STVFBO,
   AdmsSensFadType & modelPar_STVFBL,
   bool modelPar_given_STVFBL,
   AdmsSensFadType & modelPar_STVFBW,
   bool modelPar_given_STVFBW,
   AdmsSensFadType & modelPar_STVFBLW,
   bool modelPar_given_STVFBLW,
   AdmsSensFadType & modelPar_TOXO,
   bool modelPar_given_TOXO,
   AdmsSensFadType & modelPar_EPSROXO,
   bool modelPar_given_EPSROXO,
   AdmsSensFadType & modelPar_NSUBO,
   bool modelPar_given_NSUBO,
   AdmsSensFadType & modelPar_NSUBW,
   bool modelPar_given_NSUBW,
   AdmsSensFadType & modelPar_WSEG,
   bool modelPar_given_WSEG,
   AdmsSensFadType & modelPar_NPCK,
   bool modelPar_given_NPCK,
   AdmsSensFadType & modelPar_NPCKW,
   bool modelPar_given_NPCKW,
   AdmsSensFadType & modelPar_WSEGP,
   bool modelPar_given_WSEGP,
   AdmsSensFadType & modelPar_LPCK,
   bool modelPar_given_LPCK,
   AdmsSensFadType & modelPar_LPCKW,
   bool modelPar_given_LPCKW,
   AdmsSensFadType & modelPar_FOL1,
   bool modelPar_given_FOL1,
   AdmsSensFadType & modelPar_FOL2,
   bool modelPar_given_FOL2,
   AdmsSensFadType & modelPar_VNSUBO,
   bool modelPar_given_VNSUBO,
   AdmsSensFadType & modelPar_NSLPO,
   bool modelPar_given_NSLPO,
   AdmsSensFadType & modelPar_DNSUBO,
   bool modelPar_given_DNSUBO,
   AdmsSensFadType & modelPar_DPHIBO,
   bool modelPar_given_DPHIBO,
   AdmsSensFadType & modelPar_DPHIBL,
   bool modelPar_given_DPHIBL,
   AdmsSensFadType & modelPar_DPHIBLEXP,
   bool modelPar_given_DPHIBLEXP,
   AdmsSensFadType & modelPar_DPHIBW,
   bool modelPar_given_DPHIBW,
   AdmsSensFadType & modelPar_DPHIBLW,
   bool modelPar_given_DPHIBLW,
   AdmsSensFadType & modelPar_NPO,
   bool modelPar_given_NPO,
   AdmsSensFadType & modelPar_NPL,
   bool modelPar_given_NPL,
   AdmsSensFadType & modelPar_CTO,
   bool modelPar_given_CTO,
   AdmsSensFadType & modelPar_CTL,
   bool modelPar_given_CTL,
   AdmsSensFadType & modelPar_CTLEXP,
   bool modelPar_given_CTLEXP,
   AdmsSensFadType & modelPar_CTW,
   bool modelPar_given_CTW,
   AdmsSensFadType & modelPar_CTLW,
   bool modelPar_given_CTLW,
   AdmsSensFadType & modelPar_TOXOVO,
   bool modelPar_given_TOXOVO,
   AdmsSensFadType & modelPar_TOXOVDO,
   bool modelPar_given_TOXOVDO,
   AdmsSensFadType & modelPar_LOV,
   bool modelPar_given_LOV,
   AdmsSensFadType & modelPar_LOVD,
   bool modelPar_given_LOVD,
   AdmsSensFadType & modelPar_NOVO,
   bool modelPar_given_NOVO,
   AdmsSensFadType & modelPar_NOVDO,
   bool modelPar_given_NOVDO,
   AdmsSensFadType & modelPar_CFL,
   bool modelPar_given_CFL,
   AdmsSensFadType & modelPar_CFLEXP,
   bool modelPar_given_CFLEXP,
   AdmsSensFadType & modelPar_CFW,
   bool modelPar_given_CFW,
   AdmsSensFadType & modelPar_CFBO,
   bool modelPar_given_CFBO,
   AdmsSensFadType & modelPar_UO,
   bool modelPar_given_UO,
   AdmsSensFadType & modelPar_FBET1,
   bool modelPar_given_FBET1,
   AdmsSensFadType & modelPar_FBET1W,
   bool modelPar_given_FBET1W,
   AdmsSensFadType & modelPar_LP1,
   bool modelPar_given_LP1,
   AdmsSensFadType & modelPar_LP1W,
   bool modelPar_given_LP1W,
   AdmsSensFadType & modelPar_FBET2,
   bool modelPar_given_FBET2,
   AdmsSensFadType & modelPar_LP2,
   bool modelPar_given_LP2,
   AdmsSensFadType & modelPar_BETW1,
   bool modelPar_given_BETW1,
   AdmsSensFadType & modelPar_BETW2,
   bool modelPar_given_BETW2,
   AdmsSensFadType & modelPar_WBET,
   bool modelPar_given_WBET,
   AdmsSensFadType & modelPar_STBETO,
   bool modelPar_given_STBETO,
   AdmsSensFadType & modelPar_STBETL,
   bool modelPar_given_STBETL,
   AdmsSensFadType & modelPar_STBETW,
   bool modelPar_given_STBETW,
   AdmsSensFadType & modelPar_STBETLW,
   bool modelPar_given_STBETLW,
   AdmsSensFadType & modelPar_MUEO,
   bool modelPar_given_MUEO,
   AdmsSensFadType & modelPar_MUEW,
   bool modelPar_given_MUEW,
   AdmsSensFadType & modelPar_STMUEO,
   bool modelPar_given_STMUEO,
   AdmsSensFadType & modelPar_THEMUO,
   bool modelPar_given_THEMUO,
   AdmsSensFadType & modelPar_STTHEMUO,
   bool modelPar_given_STTHEMUO,
   AdmsSensFadType & modelPar_CSO,
   bool modelPar_given_CSO,
   AdmsSensFadType & modelPar_CSL,
   bool modelPar_given_CSL,
   AdmsSensFadType & modelPar_CSLEXP,
   bool modelPar_given_CSLEXP,
   AdmsSensFadType & modelPar_CSW,
   bool modelPar_given_CSW,
   AdmsSensFadType & modelPar_CSLW,
   bool modelPar_given_CSLW,
   AdmsSensFadType & modelPar_STCSO,
   bool modelPar_given_STCSO,
   AdmsSensFadType & modelPar_XCORO,
   bool modelPar_given_XCORO,
   AdmsSensFadType & modelPar_XCORL,
   bool modelPar_given_XCORL,
   AdmsSensFadType & modelPar_XCORW,
   bool modelPar_given_XCORW,
   AdmsSensFadType & modelPar_XCORLW,
   bool modelPar_given_XCORLW,
   AdmsSensFadType & modelPar_STXCORO,
   bool modelPar_given_STXCORO,
   AdmsSensFadType & modelPar_FETAO,
   bool modelPar_given_FETAO,
   AdmsSensFadType & modelPar_RSW1,
   bool modelPar_given_RSW1,
   AdmsSensFadType & modelPar_RSW2,
   bool modelPar_given_RSW2,
   AdmsSensFadType & modelPar_STRSO,
   bool modelPar_given_STRSO,
   AdmsSensFadType & modelPar_RSBO,
   bool modelPar_given_RSBO,
   AdmsSensFadType & modelPar_RSGO,
   bool modelPar_given_RSGO,
   AdmsSensFadType & modelPar_THESATO,
   bool modelPar_given_THESATO,
   AdmsSensFadType & modelPar_THESATL,
   bool modelPar_given_THESATL,
   AdmsSensFadType & modelPar_THESATLEXP,
   bool modelPar_given_THESATLEXP,
   AdmsSensFadType & modelPar_THESATW,
   bool modelPar_given_THESATW,
   AdmsSensFadType & modelPar_THESATLW,
   bool modelPar_given_THESATLW,
   AdmsSensFadType & modelPar_STTHESATO,
   bool modelPar_given_STTHESATO,
   AdmsSensFadType & modelPar_STTHESATL,
   bool modelPar_given_STTHESATL,
   AdmsSensFadType & modelPar_STTHESATW,
   bool modelPar_given_STTHESATW,
   AdmsSensFadType & modelPar_STTHESATLW,
   bool modelPar_given_STTHESATLW,
   AdmsSensFadType & modelPar_THESATBO,
   bool modelPar_given_THESATBO,
   AdmsSensFadType & modelPar_THESATGO,
   bool modelPar_given_THESATGO,
   AdmsSensFadType & modelPar_AXO,
   bool modelPar_given_AXO,
   AdmsSensFadType & modelPar_AXL,
   bool modelPar_given_AXL,
   AdmsSensFadType & modelPar_ALPL,
   bool modelPar_given_ALPL,
   AdmsSensFadType & modelPar_ALPLEXP,
   bool modelPar_given_ALPLEXP,
   AdmsSensFadType & modelPar_ALPW,
   bool modelPar_given_ALPW,
   AdmsSensFadType & modelPar_ALP1L1,
   bool modelPar_given_ALP1L1,
   AdmsSensFadType & modelPar_ALP1LEXP,
   bool modelPar_given_ALP1LEXP,
   AdmsSensFadType & modelPar_ALP1L2,
   bool modelPar_given_ALP1L2,
   AdmsSensFadType & modelPar_ALP1W,
   bool modelPar_given_ALP1W,
   AdmsSensFadType & modelPar_ALP2L1,
   bool modelPar_given_ALP2L1,
   AdmsSensFadType & modelPar_ALP2LEXP,
   bool modelPar_given_ALP2LEXP,
   AdmsSensFadType & modelPar_ALP2L2,
   bool modelPar_given_ALP2L2,
   AdmsSensFadType & modelPar_ALP2W,
   bool modelPar_given_ALP2W,
   AdmsSensFadType & modelPar_VPO,
   bool modelPar_given_VPO,
   AdmsSensFadType & modelPar_A1O,
   bool modelPar_given_A1O,
   AdmsSensFadType & modelPar_A1L,
   bool modelPar_given_A1L,
   AdmsSensFadType & modelPar_A1W,
   bool modelPar_given_A1W,
   AdmsSensFadType & modelPar_A2O,
   bool modelPar_given_A2O,
   AdmsSensFadType & modelPar_STA2O,
   bool modelPar_given_STA2O,
   AdmsSensFadType & modelPar_A3O,
   bool modelPar_given_A3O,
   AdmsSensFadType & modelPar_A3L,
   bool modelPar_given_A3L,
   AdmsSensFadType & modelPar_A3W,
   bool modelPar_given_A3W,
   AdmsSensFadType & modelPar_A4O,
   bool modelPar_given_A4O,
   AdmsSensFadType & modelPar_A4L,
   bool modelPar_given_A4L,
   AdmsSensFadType & modelPar_A4W,
   bool modelPar_given_A4W,
   AdmsSensFadType & modelPar_GCOO,
   bool modelPar_given_GCOO,
   AdmsSensFadType & modelPar_IGINVLW,
   bool modelPar_given_IGINVLW,
   AdmsSensFadType & modelPar_IGOVW,
   bool modelPar_given_IGOVW,
   AdmsSensFadType & modelPar_IGOVDW,
   bool modelPar_given_IGOVDW,
   AdmsSensFadType & modelPar_STIGO,
   bool modelPar_given_STIGO,
   AdmsSensFadType & modelPar_GC2O,
   bool modelPar_given_GC2O,
   AdmsSensFadType & modelPar_GC3O,
   bool modelPar_given_GC3O,
   AdmsSensFadType & modelPar_CHIBO,
   bool modelPar_given_CHIBO,
   AdmsSensFadType & modelPar_AGIDLW,
   bool modelPar_given_AGIDLW,
   AdmsSensFadType & modelPar_AGIDLDW,
   bool modelPar_given_AGIDLDW,
   AdmsSensFadType & modelPar_BGIDLO,
   bool modelPar_given_BGIDLO,
   AdmsSensFadType & modelPar_BGIDLDO,
   bool modelPar_given_BGIDLDO,
   AdmsSensFadType & modelPar_STBGIDLO,
   bool modelPar_given_STBGIDLO,
   AdmsSensFadType & modelPar_STBGIDLDO,
   bool modelPar_given_STBGIDLDO,
   AdmsSensFadType & modelPar_CGIDLO,
   bool modelPar_given_CGIDLO,
   AdmsSensFadType & modelPar_CGIDLDO,
   bool modelPar_given_CGIDLDO,
   AdmsSensFadType & modelPar_CGBOVL,
   bool modelPar_given_CGBOVL,
   AdmsSensFadType & modelPar_CFRW,
   bool modelPar_given_CFRW,
   AdmsSensFadType & modelPar_CFRDW,
   bool modelPar_given_CFRDW,
   AdmsSensFadType & modelPar_FNTO,
   bool modelPar_given_FNTO,
   AdmsSensFadType & modelPar_FNTEXCL,
   bool modelPar_given_FNTEXCL,
   AdmsSensFadType & modelPar_NFALW,
   bool modelPar_given_NFALW,
   AdmsSensFadType & modelPar_NFBLW,
   bool modelPar_given_NFBLW,
   AdmsSensFadType & modelPar_NFCLW,
   bool modelPar_given_NFCLW,
   AdmsSensFadType & modelPar_EFO,
   bool modelPar_given_EFO,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_ALPNOI,
   bool modelPar_given_ALPNOI,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_KVTHOWEO,
   bool modelPar_given_KVTHOWEO,
   AdmsSensFadType & modelPar_KVTHOWEL,
   bool modelPar_given_KVTHOWEL,
   AdmsSensFadType & modelPar_KVTHOWEW,
   bool modelPar_given_KVTHOWEW,
   AdmsSensFadType & modelPar_KVTHOWELW,
   bool modelPar_given_KVTHOWELW,
   AdmsSensFadType & modelPar_KUOWEO,
   bool modelPar_given_KUOWEO,
   AdmsSensFadType & modelPar_KUOWEL,
   bool modelPar_given_KUOWEL,
   AdmsSensFadType & modelPar_KUOWEW,
   bool modelPar_given_KUOWEW,
   AdmsSensFadType & modelPar_KUOWELW,
   bool modelPar_given_KUOWELW,
   AdmsSensFadType & modelPar_LMIN,
   bool modelPar_given_LMIN,
   AdmsSensFadType & modelPar_LMAX,
   bool modelPar_given_LMAX,
   AdmsSensFadType & modelPar_WMIN,
   bool modelPar_given_WMIN,
   AdmsSensFadType & modelPar_WMAX,
   bool modelPar_given_WMAX,
   AdmsSensFadType & modelPar_RGO,
   bool modelPar_given_RGO,
   AdmsSensFadType & modelPar_RBULKO,
   bool modelPar_given_RBULKO,
   AdmsSensFadType & modelPar_RWELLO,
   bool modelPar_given_RWELLO,
   AdmsSensFadType & modelPar_RJUNSO,
   bool modelPar_given_RJUNSO,
   AdmsSensFadType & modelPar_RJUNDO,
   bool modelPar_given_RJUNDO,
   AdmsSensFadType & modelPar_RINT,
   bool modelPar_given_RINT,
   AdmsSensFadType & modelPar_RVPOLY,
   bool modelPar_given_RVPOLY,
   AdmsSensFadType & modelPar_RSHG,
   bool modelPar_given_RSHG,
   AdmsSensFadType & modelPar_DLSIL,
   bool modelPar_given_DLSIL,
   AdmsSensFadType & modelPar_SAREF,
   bool modelPar_given_SAREF,
   AdmsSensFadType & modelPar_SBREF,
   bool modelPar_given_SBREF,
   AdmsSensFadType & modelPar_WLOD,
   bool modelPar_given_WLOD,
   AdmsSensFadType & modelPar_KUO,
   bool modelPar_given_KUO,
   AdmsSensFadType & modelPar_KVSAT,
   bool modelPar_given_KVSAT,
   AdmsSensFadType & modelPar_TKUO,
   bool modelPar_given_TKUO,
   AdmsSensFadType & modelPar_LKUO,
   bool modelPar_given_LKUO,
   AdmsSensFadType & modelPar_WKUO,
   bool modelPar_given_WKUO,
   AdmsSensFadType & modelPar_PKUO,
   bool modelPar_given_PKUO,
   AdmsSensFadType & modelPar_LLODKUO,
   bool modelPar_given_LLODKUO,
   AdmsSensFadType & modelPar_WLODKUO,
   bool modelPar_given_WLODKUO,
   AdmsSensFadType & modelPar_KVTHO,
   bool modelPar_given_KVTHO,
   AdmsSensFadType & modelPar_LKVTHO,
   bool modelPar_given_LKVTHO,
   AdmsSensFadType & modelPar_WKVTHO,
   bool modelPar_given_WKVTHO,
   AdmsSensFadType & modelPar_PKVTHO,
   bool modelPar_given_PKVTHO,
   AdmsSensFadType & modelPar_LLODVTH,
   bool modelPar_given_LLODVTH,
   AdmsSensFadType & modelPar_WLODVTH,
   bool modelPar_given_WLODVTH,
   AdmsSensFadType & modelPar_STETAO,
   bool modelPar_given_STETAO,
   AdmsSensFadType & modelPar_LODETAO,
   bool modelPar_given_LODETAO,
   AdmsSensFadType & modelPar_SCREF,
   bool modelPar_given_SCREF,
   AdmsSensFadType & modelPar_WEB,
   bool modelPar_given_WEB,
   AdmsSensFadType & modelPar_WEC,
   bool modelPar_given_WEC,
   AdmsSensFadType & modelPar_IMAX,
   bool modelPar_given_IMAX,
   AdmsSensFadType & modelPar_TRJ,
   bool modelPar_given_TRJ,
   AdmsSensFadType & modelPar_CJORBOT,
   bool modelPar_given_CJORBOT,
   AdmsSensFadType & modelPar_CJORSTI,
   bool modelPar_given_CJORSTI,
   AdmsSensFadType & modelPar_CJORGAT,
   bool modelPar_given_CJORGAT,
   AdmsSensFadType & modelPar_VBIRBOT,
   bool modelPar_given_VBIRBOT,
   AdmsSensFadType & modelPar_VBIRSTI,
   bool modelPar_given_VBIRSTI,
   AdmsSensFadType & modelPar_VBIRGAT,
   bool modelPar_given_VBIRGAT,
   AdmsSensFadType & modelPar_PBOT,
   bool modelPar_given_PBOT,
   AdmsSensFadType & modelPar_PSTI,
   bool modelPar_given_PSTI,
   AdmsSensFadType & modelPar_PGAT,
   bool modelPar_given_PGAT,
   AdmsSensFadType & modelPar_PHIGBOT,
   bool modelPar_given_PHIGBOT,
   AdmsSensFadType & modelPar_PHIGSTI,
   bool modelPar_given_PHIGSTI,
   AdmsSensFadType & modelPar_PHIGGAT,
   bool modelPar_given_PHIGGAT,
   AdmsSensFadType & modelPar_IDSATRBOT,
   bool modelPar_given_IDSATRBOT,
   AdmsSensFadType & modelPar_IDSATRSTI,
   bool modelPar_given_IDSATRSTI,
   AdmsSensFadType & modelPar_IDSATRGAT,
   bool modelPar_given_IDSATRGAT,
   AdmsSensFadType & modelPar_CSRHBOT,
   bool modelPar_given_CSRHBOT,
   AdmsSensFadType & modelPar_CSRHSTI,
   bool modelPar_given_CSRHSTI,
   AdmsSensFadType & modelPar_CSRHGAT,
   bool modelPar_given_CSRHGAT,
   AdmsSensFadType & modelPar_XJUNSTI,
   bool modelPar_given_XJUNSTI,
   AdmsSensFadType & modelPar_XJUNGAT,
   bool modelPar_given_XJUNGAT,
   AdmsSensFadType & modelPar_CTATBOT,
   bool modelPar_given_CTATBOT,
   AdmsSensFadType & modelPar_CTATSTI,
   bool modelPar_given_CTATSTI,
   AdmsSensFadType & modelPar_CTATGAT,
   bool modelPar_given_CTATGAT,
   AdmsSensFadType & modelPar_MEFFTATBOT,
   bool modelPar_given_MEFFTATBOT,
   AdmsSensFadType & modelPar_MEFFTATSTI,
   bool modelPar_given_MEFFTATSTI,
   AdmsSensFadType & modelPar_MEFFTATGAT,
   bool modelPar_given_MEFFTATGAT,
   AdmsSensFadType & modelPar_CBBTBOT,
   bool modelPar_given_CBBTBOT,
   AdmsSensFadType & modelPar_CBBTSTI,
   bool modelPar_given_CBBTSTI,
   AdmsSensFadType & modelPar_CBBTGAT,
   bool modelPar_given_CBBTGAT,
   AdmsSensFadType & modelPar_FBBTRBOT,
   bool modelPar_given_FBBTRBOT,
   AdmsSensFadType & modelPar_FBBTRSTI,
   bool modelPar_given_FBBTRSTI,
   AdmsSensFadType & modelPar_FBBTRGAT,
   bool modelPar_given_FBBTRGAT,
   AdmsSensFadType & modelPar_STFBBTBOT,
   bool modelPar_given_STFBBTBOT,
   AdmsSensFadType & modelPar_STFBBTSTI,
   bool modelPar_given_STFBBTSTI,
   AdmsSensFadType & modelPar_STFBBTGAT,
   bool modelPar_given_STFBBTGAT,
   AdmsSensFadType & modelPar_VBRBOT,
   bool modelPar_given_VBRBOT,
   AdmsSensFadType & modelPar_VBRSTI,
   bool modelPar_given_VBRSTI,
   AdmsSensFadType & modelPar_VBRGAT,
   bool modelPar_given_VBRGAT,
   AdmsSensFadType & modelPar_PBRBOT,
   bool modelPar_given_PBRBOT,
   AdmsSensFadType & modelPar_PBRSTI,
   bool modelPar_given_PBRSTI,
   AdmsSensFadType & modelPar_PBRGAT,
   bool modelPar_given_PBRGAT,
   AdmsSensFadType & modelPar_CJORBOTD,
   bool modelPar_given_CJORBOTD,
   AdmsSensFadType & modelPar_CJORSTID,
   bool modelPar_given_CJORSTID,
   AdmsSensFadType & modelPar_CJORGATD,
   bool modelPar_given_CJORGATD,
   AdmsSensFadType & modelPar_VBIRBOTD,
   bool modelPar_given_VBIRBOTD,
   AdmsSensFadType & modelPar_VBIRSTID,
   bool modelPar_given_VBIRSTID,
   AdmsSensFadType & modelPar_VBIRGATD,
   bool modelPar_given_VBIRGATD,
   AdmsSensFadType & modelPar_PBOTD,
   bool modelPar_given_PBOTD,
   AdmsSensFadType & modelPar_PSTID,
   bool modelPar_given_PSTID,
   AdmsSensFadType & modelPar_PGATD,
   bool modelPar_given_PGATD,
   AdmsSensFadType & modelPar_PHIGBOTD,
   bool modelPar_given_PHIGBOTD,
   AdmsSensFadType & modelPar_PHIGSTID,
   bool modelPar_given_PHIGSTID,
   AdmsSensFadType & modelPar_PHIGGATD,
   bool modelPar_given_PHIGGATD,
   AdmsSensFadType & modelPar_IDSATRBOTD,
   bool modelPar_given_IDSATRBOTD,
   AdmsSensFadType & modelPar_IDSATRSTID,
   bool modelPar_given_IDSATRSTID,
   AdmsSensFadType & modelPar_IDSATRGATD,
   bool modelPar_given_IDSATRGATD,
   AdmsSensFadType & modelPar_CSRHBOTD,
   bool modelPar_given_CSRHBOTD,
   AdmsSensFadType & modelPar_CSRHSTID,
   bool modelPar_given_CSRHSTID,
   AdmsSensFadType & modelPar_CSRHGATD,
   bool modelPar_given_CSRHGATD,
   AdmsSensFadType & modelPar_XJUNSTID,
   bool modelPar_given_XJUNSTID,
   AdmsSensFadType & modelPar_XJUNGATD,
   bool modelPar_given_XJUNGATD,
   AdmsSensFadType & modelPar_CTATBOTD,
   bool modelPar_given_CTATBOTD,
   AdmsSensFadType & modelPar_CTATSTID,
   bool modelPar_given_CTATSTID,
   AdmsSensFadType & modelPar_CTATGATD,
   bool modelPar_given_CTATGATD,
   AdmsSensFadType & modelPar_MEFFTATBOTD,
   bool modelPar_given_MEFFTATBOTD,
   AdmsSensFadType & modelPar_MEFFTATSTID,
   bool modelPar_given_MEFFTATSTID,
   AdmsSensFadType & modelPar_MEFFTATGATD,
   bool modelPar_given_MEFFTATGATD,
   AdmsSensFadType & modelPar_CBBTBOTD,
   bool modelPar_given_CBBTBOTD,
   AdmsSensFadType & modelPar_CBBTSTID,
   bool modelPar_given_CBBTSTID,
   AdmsSensFadType & modelPar_CBBTGATD,
   bool modelPar_given_CBBTGATD,
   AdmsSensFadType & modelPar_FBBTRBOTD,
   bool modelPar_given_FBBTRBOTD,
   AdmsSensFadType & modelPar_FBBTRSTID,
   bool modelPar_given_FBBTRSTID,
   AdmsSensFadType & modelPar_FBBTRGATD,
   bool modelPar_given_FBBTRGATD,
   AdmsSensFadType & modelPar_STFBBTBOTD,
   bool modelPar_given_STFBBTBOTD,
   AdmsSensFadType & modelPar_STFBBTSTID,
   bool modelPar_given_STFBBTSTID,
   AdmsSensFadType & modelPar_STFBBTGATD,
   bool modelPar_given_STFBBTGATD,
   AdmsSensFadType & modelPar_VBRBOTD,
   bool modelPar_given_VBRBOTD,
   AdmsSensFadType & modelPar_VBRSTID,
   bool modelPar_given_VBRSTID,
   AdmsSensFadType & modelPar_VBRGATD,
   bool modelPar_given_VBRGATD,
   AdmsSensFadType & modelPar_PBRBOTD,
   bool modelPar_given_PBRBOTD,
   AdmsSensFadType & modelPar_PBRSTID,
   bool modelPar_given_PBRSTID,
   AdmsSensFadType & modelPar_PBRGATD,
   bool modelPar_given_PBRGATD,
   AdmsSensFadType & modelPar_SWJUNEXP,
   bool modelPar_given_SWJUNEXP,
   AdmsSensFadType & modelPar_VJUNREF,
   bool modelPar_given_VJUNREF,
   AdmsSensFadType & modelPar_FJUNQ,
   bool modelPar_given_FJUNQ,
   AdmsSensFadType & modelPar_VJUNREFD,
   bool modelPar_given_VJUNREFD,
   AdmsSensFadType & modelPar_FJUNQD,
   bool modelPar_given_FJUNQD// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_NSUBO_i,
   AdmsSensFadType & modelVar_WSEG_i,
   AdmsSensFadType & modelVar_NPCK_i,
   AdmsSensFadType & modelVar_WSEGP_i,
   AdmsSensFadType & modelVar_LPCK_i,
   AdmsSensFadType & modelVar_LOV_i,
   AdmsSensFadType & modelVar_LOVD_i,
   AdmsSensFadType & modelVar_LP1_i,
   AdmsSensFadType & modelVar_LP2_i,
   AdmsSensFadType & modelVar_WBET_i,
   AdmsSensFadType & modelVar_AXL_i,
   AdmsSensFadType & modelVar_ALP1L2_i,
   AdmsSensFadType & modelVar_ALP2L2_i,
   AdmsSensFadType & modelVar_RINT_i,
   AdmsSensFadType & modelVar_RVPOLY_i,
   AdmsSensFadType & modelVar_SAREF_i,
   AdmsSensFadType & modelVar_SBREF_i,
   AdmsSensFadType & modelVar_KVSAT_i,
   AdmsSensFadType & modelVar_LLODKUO_i,
   AdmsSensFadType & modelVar_WLODKUO_i,
   AdmsSensFadType & modelVar_LLODVTH_i,
   AdmsSensFadType & modelVar_WLODVTH_i,
   AdmsSensFadType & modelVar_LODETAO_i,
   AdmsSensFadType & modelVar_SCREF_i,
   AdmsSensFadType & modelVar_WEB_i,
   AdmsSensFadType & modelVar_WEC_i,
   AdmsSensFadType & modelVar_TOX_i,
   AdmsSensFadType & modelVar_EPSROX_i,
   AdmsSensFadType & modelVar_TOXOV_i,
   AdmsSensFadType & modelVar_TOXOVD_i,
   AdmsSensFadType & modelVar_TKD,
   AdmsSensFadType & modelVar_dT,
   AdmsSensFadType & modelVar_rT,
   AdmsSensFadType & modelVar_rTn,
   AdmsSensFadType & modelVar_EPSSI,
   AdmsSensFadType & modelVar_phit,
   AdmsSensFadType & modelVar_inv_phit,
   AdmsSensFadType & modelVar_Eg,
   AdmsSensFadType & modelVar_phibFac,
   AdmsSensFadType & modelVar_nt0,
   AdmsSensFadType & modelVar_IMAX_i,
   AdmsSensFadType & modelVar_VBIRBOT_i,
   AdmsSensFadType & modelVar_VBIRSTI_i,
   AdmsSensFadType & modelVar_VBIRGAT_i,
   AdmsSensFadType & modelVar_PBOT_i,
   AdmsSensFadType & modelVar_PSTI_i,
   AdmsSensFadType & modelVar_PGAT_i,
   AdmsSensFadType & modelVar_CSRHBOT_i,
   AdmsSensFadType & modelVar_CSRHSTI_i,
   AdmsSensFadType & modelVar_CSRHGAT_i,
   AdmsSensFadType & modelVar_CTATBOT_i,
   AdmsSensFadType & modelVar_CTATSTI_i,
   AdmsSensFadType & modelVar_CTATGAT_i,
   AdmsSensFadType & modelVar_CBBTBOT_i,
   AdmsSensFadType & modelVar_CBBTSTI_i,
   AdmsSensFadType & modelVar_CBBTGAT_i,
   AdmsSensFadType & modelVar_VBRBOT_i,
   AdmsSensFadType & modelVar_VBRSTI_i,
   AdmsSensFadType & modelVar_VBRGAT_i,
   AdmsSensFadType & modelVar_PBRBOT_i,
   AdmsSensFadType & modelVar_PBRSTI_i,
   AdmsSensFadType & modelVar_PBRGAT_i,
   AdmsSensFadType & modelVar_SWJUNEXP_i,
   AdmsSensFadType & modelVar_VJUNREF_i,
   AdmsSensFadType & modelVar_FJUNQ_i,
   AdmsSensFadType & modelVar_phitr,
   AdmsSensFadType & modelVar_phitd,
   AdmsSensFadType & modelVar_phitdinv,
   AdmsSensFadType & modelVar_perfc,
   AdmsSensFadType & modelVar_berfc,
   AdmsSensFadType & modelVar_cerfc,
   AdmsSensFadType & modelVar_ftdbot,
   AdmsSensFadType & modelVar_ftdsti,
   AdmsSensFadType & modelVar_ftdgat,
   AdmsSensFadType & modelVar_idsatbot,
   AdmsSensFadType & modelVar_idsatsti,
   AdmsSensFadType & modelVar_idsatgat,
   AdmsSensFadType & modelVar_vbibot,
   AdmsSensFadType & modelVar_vbisti,
   AdmsSensFadType & modelVar_vbigat,
   AdmsSensFadType & modelVar_vbiinvbot,
   AdmsSensFadType & modelVar_vbiinvsti,
   AdmsSensFadType & modelVar_vbiinvgat,
   AdmsSensFadType & modelVar_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_minus_PGAT,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT,
   AdmsSensFadType & modelVar_cjobot,
   AdmsSensFadType & modelVar_cjosti,
   AdmsSensFadType & modelVar_cjogat,
   AdmsSensFadType & modelVar_qprefbot,
   AdmsSensFadType & modelVar_qprefsti,
   AdmsSensFadType & modelVar_qprefgat,
   AdmsSensFadType & modelVar_qpref2bot,
   AdmsSensFadType & modelVar_qpref2sti,
   AdmsSensFadType & modelVar_qpref2gat,
   AdmsSensFadType & modelVar_wdepnulrbot,
   AdmsSensFadType & modelVar_wdepnulrsti,
   AdmsSensFadType & modelVar_wdepnulrgat,
   AdmsSensFadType & modelVar_wdepnulrinvbot,
   AdmsSensFadType & modelVar_wdepnulrinvsti,
   AdmsSensFadType & modelVar_wdepnulrinvgat,
   AdmsSensFadType & modelVar_VBIRBOTinv,
   AdmsSensFadType & modelVar_VBIRSTIinv,
   AdmsSensFadType & modelVar_VBIRGATinv,
   AdmsSensFadType & modelVar_atatbot,
   AdmsSensFadType & modelVar_atatsti,
   AdmsSensFadType & modelVar_atatgat,
   AdmsSensFadType & modelVar_btatpartbot,
   AdmsSensFadType & modelVar_btatpartsti,
   AdmsSensFadType & modelVar_btatpartgat,
   AdmsSensFadType & modelVar_fbbtbot,
   AdmsSensFadType & modelVar_fbbtsti,
   AdmsSensFadType & modelVar_fbbtgat,
   AdmsSensFadType & modelVar_fstopbot,
   AdmsSensFadType & modelVar_fstopsti,
   AdmsSensFadType & modelVar_fstopgat,
   AdmsSensFadType & modelVar_VBRinvbot,
   AdmsSensFadType & modelVar_VBRinvsti,
   AdmsSensFadType & modelVar_VBRinvgat,
   AdmsSensFadType & modelVar_slopebot,
   AdmsSensFadType & modelVar_slopesti,
   AdmsSensFadType & modelVar_slopegat,
   AdmsSensFadType & modelVar_VBIRBOTD_i,
   AdmsSensFadType & modelVar_VBIRSTID_i,
   AdmsSensFadType & modelVar_VBIRGATD_i,
   AdmsSensFadType & modelVar_PBOTD_i,
   AdmsSensFadType & modelVar_PSTID_i,
   AdmsSensFadType & modelVar_PGATD_i,
   AdmsSensFadType & modelVar_CSRHBOTD_i,
   AdmsSensFadType & modelVar_CSRHSTID_i,
   AdmsSensFadType & modelVar_CSRHGATD_i,
   AdmsSensFadType & modelVar_CTATBOTD_i,
   AdmsSensFadType & modelVar_CTATSTID_i,
   AdmsSensFadType & modelVar_CTATGATD_i,
   AdmsSensFadType & modelVar_CBBTBOTD_i,
   AdmsSensFadType & modelVar_CBBTSTID_i,
   AdmsSensFadType & modelVar_CBBTGATD_i,
   AdmsSensFadType & modelVar_VBRBOTD_i,
   AdmsSensFadType & modelVar_VBRSTID_i,
   AdmsSensFadType & modelVar_VBRGATD_i,
   AdmsSensFadType & modelVar_PBRBOTD_i,
   AdmsSensFadType & modelVar_PBRSTID_i,
   AdmsSensFadType & modelVar_PBRGATD_i,
   AdmsSensFadType & modelVar_VJUNREFD_i,
   AdmsSensFadType & modelVar_FJUNQD_i,
   AdmsSensFadType & modelVar_ftdbot_d,
   AdmsSensFadType & modelVar_ftdsti_d,
   AdmsSensFadType & modelVar_ftdgat_d,
   AdmsSensFadType & modelVar_idsatbot_d,
   AdmsSensFadType & modelVar_idsatsti_d,
   AdmsSensFadType & modelVar_idsatgat_d,
   AdmsSensFadType & modelVar_vbibot_d,
   AdmsSensFadType & modelVar_vbisti_d,
   AdmsSensFadType & modelVar_vbigat_d,
   AdmsSensFadType & modelVar_vbiinvbot_d,
   AdmsSensFadType & modelVar_vbiinvsti_d,
   AdmsSensFadType & modelVar_vbiinvgat_d,
   AdmsSensFadType & modelVar_one_minus_PBOT_d,
   AdmsSensFadType & modelVar_one_minus_PSTI_d,
   AdmsSensFadType & modelVar_one_minus_PGAT_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT_d,
   AdmsSensFadType & modelVar_cjobot_d,
   AdmsSensFadType & modelVar_cjosti_d,
   AdmsSensFadType & modelVar_cjogat_d,
   AdmsSensFadType & modelVar_qprefbot_d,
   AdmsSensFadType & modelVar_qprefsti_d,
   AdmsSensFadType & modelVar_qprefgat_d,
   AdmsSensFadType & modelVar_qpref2bot_d,
   AdmsSensFadType & modelVar_qpref2sti_d,
   AdmsSensFadType & modelVar_qpref2gat_d,
   AdmsSensFadType & modelVar_wdepnulrbot_d,
   AdmsSensFadType & modelVar_wdepnulrsti_d,
   AdmsSensFadType & modelVar_wdepnulrgat_d,
   AdmsSensFadType & modelVar_wdepnulrinvbot_d,
   AdmsSensFadType & modelVar_wdepnulrinvsti_d,
   AdmsSensFadType & modelVar_wdepnulrinvgat_d,
   AdmsSensFadType & modelVar_VBIRBOTinv_d,
   AdmsSensFadType & modelVar_VBIRSTIinv_d,
   AdmsSensFadType & modelVar_VBIRGATinv_d,
   AdmsSensFadType & modelVar_atatbot_d,
   AdmsSensFadType & modelVar_atatsti_d,
   AdmsSensFadType & modelVar_atatgat_d,
   AdmsSensFadType & modelVar_btatpartbot_d,
   AdmsSensFadType & modelVar_btatpartsti_d,
   AdmsSensFadType & modelVar_btatpartgat_d,
   AdmsSensFadType & modelVar_fbbtbot_d,
   AdmsSensFadType & modelVar_fbbtsti_d,
   AdmsSensFadType & modelVar_fbbtgat_d,
   AdmsSensFadType & modelVar_fstopbot_d,
   AdmsSensFadType & modelVar_fstopsti_d,
   AdmsSensFadType & modelVar_fstopgat_d,
   AdmsSensFadType & modelVar_VBRinvbot_d,
   AdmsSensFadType & modelVar_VBRinvsti_d,
   AdmsSensFadType & modelVar_VBRinvgat_d,
   AdmsSensFadType & modelVar_slopebot_d,
   AdmsSensFadType & modelVar_slopesti_d,
   AdmsSensFadType & modelVar_slopegat_d,
   // non-reals
   int modelVar_CHNL_TYPE,
   double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
  AdmsSensFadType I5;
  AdmsSensFadType I4;
  AdmsSensFadType I3;
  AdmsSensFadType I2;
  AdmsSensFadType I1;
  AdmsSensFadType ijungat;
  AdmsSensFadType ijunsti;
  AdmsSensFadType ijunbot;
  double V5;
  double V4;
  AdmsSensFadType V3;
  AdmsSensFadType V2;
  AdmsSensFadType V1;
  double FRACI;
  double FRACNB;
  double FRACNA;
  AdmsSensFadType qjungat;
  AdmsSensFadType qjunsti;
  AdmsSensFadType qjunbot;
  AdmsSensFadType fbreakdown;
  AdmsSensFadType Fmaxr;
  AdmsSensFadType ibbt;
  AdmsSensFadType gammamax;
  AdmsSensFadType erfctimesexpmtat;
  AdmsSensFadType xerfc;
  AdmsSensFadType mtat;
  AdmsSensFadType ltat;
  AdmsSensFadType ktat;
  AdmsSensFadType wtat;
  AdmsSensFadType wgamma;
  AdmsSensFadType umaxpoweronepointfive;
  AdmsSensFadType sqrtumax;
  AdmsSensFadType umax;
  AdmsSensFadType umaxbeforelimiting;
  AdmsSensFadType twoatatoverthreebtat;
  AdmsSensFadType btat;
  AdmsSensFadType itat;
  AdmsSensFadType asrh;
  AdmsSensFadType wdep;
  AdmsSensFadType wsrh;
  AdmsSensFadType dwsrh;
  AdmsSensFadType wsrhstep;
  AdmsSensFadType vbi_minus_vjsrh;
  AdmsSensFadType isrh;
  AdmsSensFadType id;
  AdmsSensFadType tmp;
  AdmsSensFadType vav;
  AdmsSensFadType vbbt;
  AdmsSensFadType vjsrh;
  AdmsSensFadType vjlim;
  AdmsSensFadType two_psistar;
  AdmsSensFadType zinv;
  AdmsSensFadType z;
  AdmsSensFadType vj;
  AdmsSensFadType idmult;
  AdmsSensFadType h5;
  AdmsSensFadType h4;
  AdmsSensFadType h3;
  AdmsSensFadType h2d;
  AdmsSensFadType h2;
  AdmsSensFadType h1;
  AdmsSensFadType erfcpos;
  AdmsSensFadType terfc;
  AdmsSensFadType ysq;
  AdmsSensFadType pmax;
  AdmsSensFadType vbigat2r;
  AdmsSensFadType vbisti2r;
  AdmsSensFadType vbibot2r;
  AdmsSensFadType pgat2;
  AdmsSensFadType psti2;
  AdmsSensFadType pbot2;
  AdmsSensFadType vbigat2;
  AdmsSensFadType vbisti2;
  AdmsSensFadType vbibot2;
  AdmsSensFadType vmaxgat;
  AdmsSensFadType vmaxsti;
  AdmsSensFadType vmaxbot;
  AdmsSensFadType alphaje;
  AdmsSensFadType zfrac;
  AdmsSensFadType tt2;
  AdmsSensFadType tt1;
  AdmsSensFadType tt0;
  AdmsSensFadType I5_cor;
  AdmsSensFadType I4_cor;
  AdmsSensFadType I3_cor;
  AdmsSensFadType I2_cor;
  AdmsSensFadType I1_cor;
  AdmsSensFadType mcor_rev;
  AdmsSensFadType m0_rev;
  AdmsSensFadType BGIDLD_T;
  AdmsSensFadType BGIDL_T;
  AdmsSensFadType tempM;
  AdmsSensFadType tf_ig;
  AdmsSensFadType tf_thesat;
  AdmsSensFadType tf_ther;
  AdmsSensFadType tf_xcor;
  AdmsSensFadType tf_cs;
  AdmsSensFadType tf_mue;
  AdmsSensFadType tf_bet;
  AdmsSensFadType CoxovPrime_d;
  AdmsSensFadType CoxovPrime;
  AdmsSensFadType phix2;
  AdmsSensFadType dphibq;
  AdmsSensFadType qb0;
  AdmsSensFadType np;
  AdmsSensFadType arg2max;
  AdmsSensFadType tox_sq;
  AdmsSensFadType CoxPrime;
  AdmsSensFadType EPSOX;
  AdmsSensFadType DELVTO_i;
  AdmsSensFadType FACTUO_i;
  AdmsSensFadType FNT_i;
  AdmsSensFadType STBGIDLD_i;
  AdmsSensFadType STBGIDL_i;
  AdmsSensFadType BGIDLD_i;
  AdmsSensFadType BGIDL_i;
  AdmsSensFadType STIG_i;
  AdmsSensFadType GCO_i;
  AdmsSensFadType STA2_i;
  AdmsSensFadType VP_i;
  AdmsSensFadType STTHESAT_i;
  AdmsSensFadType STRS_i;
  AdmsSensFadType RS_i;
  AdmsSensFadType FETA_i;
  AdmsSensFadType STXCOR_i;
  AdmsSensFadType STCS_i;
  AdmsSensFadType STTHEMU_i;
  AdmsSensFadType STMUE_i;
  AdmsSensFadType STBET_i;
  AdmsSensFadType BETN_i;
  AdmsSensFadType NOVD_i;
  AdmsSensFadType NOV_i;
  AdmsSensFadType CT_i;
  AdmsSensFadType QMC_i;
  AdmsSensFadType NP_i;
  AdmsSensFadType DPHIB_i;
  AdmsSensFadType NEFF_i;
  AdmsSensFadType STVFB_i;
  AdmsSensFadType temp00;
  AdmsSensFadType Kstressvth0;
  AdmsSensFadType rhobetaref;
  AdmsSensFadType rhobeta;
  AdmsSensFadType Kstressu0;
  AdmsSensFadType tempw;
  AdmsSensFadType templ;
  AdmsSensFadType Wx;
  AdmsSensFadType Lx;
  AdmsSensFadType Invsbref;
  AdmsSensFadType Invsaref;
  AdmsSensFadType Invsb;
  AdmsSensFadType Invsa;
  double loop;
  AdmsSensFadType tmpb;
  AdmsSensFadType tmpa;
  AdmsSensFadType RJUND;
  AdmsSensFadType RJUNS;
  AdmsSensFadType RBULK;
  AdmsSensFadType RWELL;
  AdmsSensFadType RG;
  AdmsSensFadType KUOWE;
  AdmsSensFadType KVTHOWE;
  AdmsSensFadType EF;
  AdmsSensFadType NFC;
  AdmsSensFadType NFB;
  AdmsSensFadType NFA;
  AdmsSensFadType FNTEXC;
  AdmsSensFadType FNT;
  AdmsSensFadType Lred;
  AdmsSensFadType Lnoi;
  AdmsSensFadType temp0;
  AdmsSensFadType CFRD;
  AdmsSensFadType CFR;
  AdmsSensFadType CGBOV;
  AdmsSensFadType CGOVD;
  AdmsSensFadType CGOV;
  AdmsSensFadType COX;
  AdmsSensFadType CGIDLD;
  AdmsSensFadType CGIDL;
  AdmsSensFadType STBGIDLD;
  AdmsSensFadType STBGIDL;
  AdmsSensFadType BGIDLD;
  AdmsSensFadType BGIDL;
  AdmsSensFadType AGIDLD;
  AdmsSensFadType AGIDL;
  AdmsSensFadType CHIB;
  AdmsSensFadType GC3;
  AdmsSensFadType GC2;
  AdmsSensFadType STIG;
  AdmsSensFadType IGOVD;
  AdmsSensFadType IGOV;
  AdmsSensFadType IGINV;
  AdmsSensFadType GCO;
  AdmsSensFadType A4;
  AdmsSensFadType A3;
  AdmsSensFadType STA2;
  AdmsSensFadType A2;
  AdmsSensFadType A1;
  AdmsSensFadType VP;
  AdmsSensFadType ALP2;
  AdmsSensFadType ALP1;
  AdmsSensFadType tmpx;
  AdmsSensFadType ALP;
  AdmsSensFadType AX;
  AdmsSensFadType THESATG;
  AdmsSensFadType THESATB;
  AdmsSensFadType STTHESAT;
  AdmsSensFadType THESAT;
  AdmsSensFadType RSG;
  AdmsSensFadType RSB;
  AdmsSensFadType STRS;
  AdmsSensFadType RS;
  AdmsSensFadType FETA;
  AdmsSensFadType STXCOR;
  AdmsSensFadType XCOR;
  AdmsSensFadType STCS;
  AdmsSensFadType CS;
  AdmsSensFadType STTHEMU;
  AdmsSensFadType THEMU;
  AdmsSensFadType STMUE;
  AdmsSensFadType MUE;
  AdmsSensFadType STBET;
  AdmsSensFadType BETN;
  AdmsSensFadType GWE;
  AdmsSensFadType GPE;
  AdmsSensFadType LP1e;
  AdmsSensFadType FBET1e;
  AdmsSensFadType CFB;
  AdmsSensFadType CF;
  AdmsSensFadType NOVD;
  AdmsSensFadType NOV;
  AdmsSensFadType TOXOVD;
  AdmsSensFadType TOXOV;
  AdmsSensFadType CT;
  AdmsSensFadType NP;
  AdmsSensFadType DPHIB;
  AdmsSensFadType DNSUB;
  AdmsSensFadType NSLP;
  AdmsSensFadType VNSUB;
  AdmsSensFadType NEFF;
  AdmsSensFadType NSUB;
  AdmsSensFadType BB;
  double AA;
  AdmsSensFadType LPCKe;
  AdmsSensFadType NPCKe;
  AdmsSensFadType NSUB0e;
  AdmsSensFadType EPSROX;
  AdmsSensFadType TOX;
  AdmsSensFadType STVFB;
  AdmsSensFadType VFB;
  AdmsSensFadType XGWE;
  AdmsSensFadType W_f;
  AdmsSensFadType L_slif;
  AdmsSensFadType L_f;
  AdmsSensFadType LGD_i;
  AdmsSensFadType LSD_i;
  AdmsSensFadType ABD_i;
  AdmsSensFadType LGS_i;
  AdmsSensFadType LSS_i;
  AdmsSensFadType ABS_i;
  AdmsSensFadType jwcorr;
  AdmsSensFadType iWE;
  AdmsSensFadType iLE;
  AdmsSensFadType Wcv;
  AdmsSensFadType Lcv;
  AdmsSensFadType WEcv;
  AdmsSensFadType LEcv;
  AdmsSensFadType WE;
  AdmsSensFadType LE;
  AdmsSensFadType delWOD;
  AdmsSensFadType delLPS;
  AdmsSensFadType iW;
  AdmsSensFadType iL;
  double WEN;
  double LEN;
  AdmsSensFadType NGCON_i;
  AdmsSensFadType RSHG_i;
  AdmsSensFadType SCC_i;
  AdmsSensFadType SCB_i;
  AdmsSensFadType SCA_i;
  AdmsSensFadType invNF;
  AdmsSensFadType NF_i;
  AdmsSensFadType XGW_i;
  AdmsSensFadType SC_i;
  AdmsSensFadType SD_i;
  AdmsSensFadType SB_i;
  AdmsSensFadType SA_i;
  AdmsSensFadType W_i;
  AdmsSensFadType L_i;
  AdmsSensFadType PD_i;
  AdmsSensFadType AD_i;
  AdmsSensFadType PS_i;
  AdmsSensFadType AS_i;
  //Begin block initial_instance
  {
    instanceVar_ABSOURCE_i = instancePar_ABSOURCE;
    instanceVar_LSSOURCE_i = instancePar_LSSOURCE;
    instanceVar_LGSOURCE_i = instancePar_LGSOURCE;
    instanceVar_ABDRAIN_i = instancePar_ABDRAIN;
    instanceVar_LSDRAIN_i = instancePar_LSDRAIN;
    instanceVar_LGDRAIN_i = instancePar_LGDRAIN;
    AS_i = instancePar_AS;
    PS_i = instancePar_PS;
    AD_i = instancePar_AD;
    PD_i = instancePar_PD;
    L_i = instancePar_L;
    W_i = instancePar_W;
    SA_i = instancePar_SA;
    SB_i = instancePar_SB;
    SD_i = instancePar_SD;
    SC_i = instancePar_SC;
    XGW_i = instancePar_XGW;
    NF_i = adms_ternary_op<AdmsSensFadType>((instancePar_NF>1.0),instancePar_NF,1.0);
    {
      AdmsSensFadType value_floor_0 = ADMSfloor((NF_i+0.5));
      NF_i = ADMSfloor((NF_i+0.5));
    }
    invNF = (1.0/NF_i);
    L_i = adms_ternary_op<AdmsSensFadType>((L_i>1e-9),L_i,1e-9);
    W_i = adms_ternary_op<AdmsSensFadType>(((W_i*invNF)>1e-9),(W_i*invNF),1e-9);
    SCA_i = adms_ternary_op<AdmsSensFadType>((instancePar_SCA>0.0),instancePar_SCA,0.0);
    SCB_i = adms_ternary_op<AdmsSensFadType>((instancePar_SCB>0.0),instancePar_SCB,0.0);
    SCC_i = adms_ternary_op<AdmsSensFadType>((instancePar_SCC>0.0),instancePar_SCC,0.0);
    RSHG_i = adms_ternary_op<AdmsSensFadType>((modelPar_RSHG>0.0),modelPar_RSHG,0.0);
    NGCON_i = ((instancePar_NGCON<1.5)?1.0:2.0);
    LEN = 1e-6;
    WEN = 1e-6;
    iL = (LEN/L_i);
    iW = (WEN/W_i);
    delLPS = ((modelPar_LVARO*(1.0+(modelPar_LVARL*iL)))*(1.0+(modelPar_LVARW*iW)));
    delWOD = ((modelPar_WVARO*(1.0+(modelPar_WVARL*iL)))*(1.0+(modelPar_WVARW*iW)));
    LE = adms_ternary_op<AdmsSensFadType>((((L_i+delLPS)-(2.0*modelPar_LAP))>1e-9),((L_i+delLPS)-(2.0*modelPar_LAP)),1e-9);
    WE = adms_ternary_op<AdmsSensFadType>((((W_i+delWOD)-(2.0*modelPar_WOT))>1e-9),((W_i+delWOD)-(2.0*modelPar_WOT)),1e-9);
    LEcv = adms_ternary_op<AdmsSensFadType>(((((L_i+delLPS)-(2.0*modelPar_LAP))+modelPar_DLQ)>1e-9),(((L_i+delLPS)-(2.0*modelPar_LAP))+modelPar_DLQ),1e-9);
    WEcv = adms_ternary_op<AdmsSensFadType>(((((W_i+delWOD)-(2.0*modelPar_WOT))+modelPar_DWQ)>1e-9),(((W_i+delWOD)-(2.0*modelPar_WOT))+modelPar_DWQ),1e-9);
    Lcv = adms_ternary_op<AdmsSensFadType>((((L_i+delLPS)+modelPar_DLQ)>1e-9),((L_i+delLPS)+modelPar_DLQ),1e-9);
    Wcv = adms_ternary_op<AdmsSensFadType>((((W_i+delWOD)+modelPar_DWQ)>1e-9),((W_i+delWOD)+modelPar_DWQ),1e-9);
    iLE = (LEN/LE);
    iWE = (WEN/WE);
    jwcorr = 0.0;
    ABS_i = 0.0;
    LSS_i = 0.0;
    LGS_i = 0.0;
    ABD_i = 0.0;
    LSD_i = 0.0;
    LGD_i = 0.0;
    if ((modelPar_SWJUNCAP==3.0))
    {
      jwcorr = WE;
    }
    if (((modelPar_SWJUNCAP==2.0)||(modelPar_SWJUNCAP==3.0)))
    {
      ABS_i = (AS_i*invNF);
      LSS_i = ((PS_i*invNF)-jwcorr);
      LGS_i = WE;
      ABD_i = (AD_i*invNF);
      LSD_i = ((PD_i*invNF)-jwcorr);
      LGD_i = WE;
    }
    else
    {
      ABS_i = (instanceVar_ABSOURCE_i*invNF);
      LSS_i = (instanceVar_LSSOURCE_i*invNF);
      LGS_i = (instanceVar_LGSOURCE_i*invNF);
      ABD_i = (instanceVar_ABDRAIN_i*invNF);
      LSD_i = (instanceVar_LSDRAIN_i*invNF);
      LGD_i = (instanceVar_LGDRAIN_i*invNF);
    }
    L_f = adms_ternary_op<AdmsSensFadType>(((L_i+delLPS)>1e-9),(L_i+delLPS),1e-9);
    L_slif = adms_ternary_op<AdmsSensFadType>(((L_f+modelPar_DLSIL)>1e-9),(L_f+modelPar_DLSIL),1e-9);
    W_f = adms_ternary_op<AdmsSensFadType>(((W_i+delWOD)>1e-9),(W_i+delWOD),1e-9);
    XGWE = adms_ternary_op<AdmsSensFadType>(((XGW_i-(0.5*delWOD))>1e-9),(XGW_i-(0.5*delWOD)),1e-9);
    VFB = (((modelPar_VFBO*(1.0+(modelPar_VFBL*iLE)))*(1.0+(modelPar_VFBW*iWE)))*(1.0+((modelPar_VFBLW*iLE)*iWE)));
    STVFB = (((modelPar_STVFBO*(1.0+(modelPar_STVFBL*iLE)))*(1.0+(modelPar_STVFBW*iWE)))*(1.0+((modelPar_STVFBLW*iLE)*iWE)));
    TOX = modelPar_TOXO;
    EPSROX = modelPar_EPSROXO;
    {
      AdmsSensFadType value_log_0 = log((1.0+(WE/modelVar_WSEG_i)));
      AdmsSensFadType value_log_1 = log((1.0+(WE/modelVar_WSEG_i)));
      NSUB0e = (modelVar_NSUBO_i*adms_ternary_op<AdmsSensFadType>(((1.0+((modelPar_NSUBW*iWE)*value_log_0))>1.0E-03),(1.0+((modelPar_NSUBW*iWE)*value_log_1)),1.0E-03));
    }
    {
      AdmsSensFadType value_log_0 = log((1.0+(WE/modelVar_WSEGP_i)));
      AdmsSensFadType value_log_1 = log((1.0+(WE/modelVar_WSEGP_i)));
      NPCKe = (modelVar_NPCK_i*adms_ternary_op<AdmsSensFadType>(((1.0+((modelPar_NPCKW*iWE)*value_log_0))>1.0E-03),(1.0+((modelPar_NPCKW*iWE)*value_log_1)),1.0E-03));
    }
    {
      AdmsSensFadType value_log_0 = log((1.0+(WE/modelVar_WSEGP_i)));
      AdmsSensFadType value_log_1 = log((1.0+(WE/modelVar_WSEGP_i)));
      LPCKe = (modelVar_LPCK_i*adms_ternary_op<AdmsSensFadType>(((1.0+((modelPar_LPCKW*iWE)*value_log_0))>1.0E-03),(1.0+((modelPar_LPCKW*iWE)*value_log_1)),1.0E-03));
    }
    if ((LE>(2*LPCKe)))
    {
      AA = 7.5e10;
      {
        AdmsSensFadType value_sqrt_0 = sqrt((NSUB0e+(0.5*NPCKe)));
        AdmsSensFadType value_sqrt_1 = sqrt(NSUB0e);
        BB = (value_sqrt_0-value_sqrt_1);
      }
      {
        AdmsSensFadType value_sqrt_0 = sqrt(NSUB0e);
        AdmsSensFadType value_exp_1 = exp((BB/AA));
        AdmsSensFadType value_log_2 = log((1+(((2*LPCKe)/LE)*(value_exp_1-1))));
        NSUB = (value_sqrt_0+(AA*value_log_2));
      }
      NSUB = (NSUB*NSUB);
    }
    else
    {
      if ((LE>=LPCKe))
      {
        NSUB = (NSUB0e+((NPCKe*LPCKe)/LE));
      }
      else
      {
        NSUB = (NSUB0e+(NPCKe*(2-(LE/LPCKe))));
      }
    }
    NEFF = (NSUB*((1-(modelPar_FOL1*iLE))-((modelPar_FOL2*iLE)*iLE)));
    VNSUB = modelPar_VNSUBO;
    NSLP = modelPar_NSLPO;
    DNSUB = modelPar_DNSUBO;
    {
      AdmsSensFadType value_pow_0 = pow(iLE,modelPar_DPHIBLEXP);
      DPHIB = (((modelPar_DPHIBO+(modelPar_DPHIBL*value_pow_0))*(1.0+(modelPar_DPHIBW*iWE)))*(1.0+((modelPar_DPHIBLW*iLE)*iWE)));
    }
    NP = (modelPar_NPO*adms_ternary_op<AdmsSensFadType>((1e-6>(1.0+(modelPar_NPL*iLE))),1e-6,(1.0+(modelPar_NPL*iLE))));
    {
      AdmsSensFadType value_pow_0 = pow(iLE,modelPar_CTLEXP);
      CT = (((modelPar_CTO+(modelPar_CTL*value_pow_0))*(1.0+(modelPar_CTW*iWE)))*(1.0+((modelPar_CTLW*iLE)*iWE)));
    }
    TOXOV = modelPar_TOXOVO;
    TOXOVD = modelPar_TOXOVDO;
    NOV = modelPar_NOVO;
    NOVD = modelPar_NOVDO;
    {
      AdmsSensFadType value_pow_0 = pow(iLE,modelPar_CFLEXP);
      CF = ((modelPar_CFL*value_pow_0)*(1.0+(modelPar_CFW*iWE)));
    }
    CFB = modelPar_CFBO;
    FBET1e = (modelPar_FBET1*(1.0+(modelPar_FBET1W*iWE)));
    LP1e = (modelVar_LP1_i*adms_ternary_op<AdmsSensFadType>(((1.0+(modelPar_LP1W*iWE))>1.0E-03),(1.0+(modelPar_LP1W*iWE)),1.0E-03));
    {
      AdmsSensFadType value_exp_0 = exp(((-LE)/LP1e));
      AdmsSensFadType value_exp_1 = exp(((-LE)/modelVar_LP2_i));
      GPE = ((1.0+(((FBET1e*LP1e)/LE)*(1.0-value_exp_0)))+(((modelPar_FBET2*modelVar_LP2_i)/LE)*(1.0-value_exp_1)));
    }
    GPE = adms_ternary_op<AdmsSensFadType>((GPE>1e-15),GPE,1e-15);
    {
      AdmsSensFadType value_log_0 = log((1.0+(WE/modelVar_WBET_i)));
      GWE = ((1.0+(modelPar_BETW1*iWE))+((modelPar_BETW2*iWE)*value_log_0));
    }
    BETN = (((modelPar_UO*WE)/(GPE*LE))*GWE);
    STBET = (((modelPar_STBETO*(1.0+(modelPar_STBETL*iLE)))*(1.0+(modelPar_STBETW*iWE)))*(1.0+((modelPar_STBETLW*iLE)*iWE)));
    MUE = (modelPar_MUEO*(1.0+(modelPar_MUEW*iWE)));
    STMUE = modelPar_STMUEO;
    THEMU = modelPar_THEMUO;
    STTHEMU = modelPar_STTHEMUO;
    {
      AdmsSensFadType value_pow_0 = pow(iLE,modelPar_CSLEXP);
      CS = (((modelPar_CSO+(modelPar_CSL*value_pow_0))*(1.0+(modelPar_CSW*iWE)))*(1.0+((modelPar_CSLW*iLE)*iWE)));
    }
    STCS = modelPar_STCSO;
    XCOR = (((modelPar_XCORO*(1.0+(modelPar_XCORL*iLE)))*(1.0+(modelPar_XCORW*iWE)))*(1.0+((modelPar_XCORLW*iLE)*iWE)));
    STXCOR = modelPar_STXCORO;
    FETA = modelPar_FETAO;
    RS = ((modelPar_RSW1*iWE)*(1.0+(modelPar_RSW2*iWE)));
    STRS = modelPar_STRSO;
    RSB = modelPar_RSBO;
    RSG = modelPar_RSGO;
    {
      AdmsSensFadType value_pow_0 = pow(iLE,modelPar_THESATLEXP);
      THESAT = (((modelPar_THESATO+(((modelPar_THESATL*GWE)/GPE)*value_pow_0))*(1.0+(modelPar_THESATW*iWE)))*(1.0+((modelPar_THESATLW*iLE)*iWE)));
    }
    STTHESAT = (((modelPar_STTHESATO*(1.0+(modelPar_STTHESATL*iLE)))*(1.0+(modelPar_STTHESATW*iWE)))*(1.0+((modelPar_STTHESATLW*iLE)*iWE)));
    THESATB = modelPar_THESATBO;
    THESATG = modelPar_THESATGO;
    AX = (modelPar_AXO/(1.0+(modelVar_AXL_i*iLE)));
    {
      AdmsSensFadType value_pow_0 = pow(iLE,modelPar_ALPLEXP);
      ALP = ((modelPar_ALPL*value_pow_0)*(1.0+(modelPar_ALPW*iWE)));
    }
    {
      AdmsSensFadType value_pow_0 = pow(iLE,modelPar_ALP1LEXP);
      tmpx = value_pow_0;
    }
    ALP1 = (((modelPar_ALP1L1*tmpx)*(1.0+(modelPar_ALP1W*iWE)))/(1.0+((modelVar_ALP1L2_i*iLE)*tmpx)));
    {
      AdmsSensFadType value_pow_0 = pow(iLE,modelPar_ALP2LEXP);
      tmpx = value_pow_0;
    }
    ALP2 = (((modelPar_ALP2L1*tmpx)*(1.0+(modelPar_ALP2W*iWE)))/(1.0+((modelVar_ALP2L2_i*iLE)*tmpx)));
    VP = modelPar_VPO;
    A1 = ((modelPar_A1O*(1.0+(modelPar_A1L*iLE)))*(1.0+(modelPar_A1W*iWE)));
    A2 = modelPar_A2O;
    STA2 = modelPar_STA2O;
    A3 = ((modelPar_A3O*(1.0+(modelPar_A3L*iLE)))*(1.0+(modelPar_A3W*iWE)));
    A4 = ((modelPar_A4O*(1.0+(modelPar_A4L*iLE)))*(1.0+(modelPar_A4W*iWE)));
    GCO = modelPar_GCOO;
    IGINV = (modelPar_IGINVLW/(iWE*iLE));
    IGOV = ((modelPar_IGOVW*modelVar_LOV_i)/(LEN*iWE));
    IGOVD = ((modelPar_IGOVDW*modelVar_LOVD_i)/(LEN*iWE));
    STIG = modelPar_STIGO;
    GC2 = modelPar_GC2O;
    GC3 = modelPar_GC3O;
    CHIB = modelPar_CHIBO;
    AGIDL = ((modelPar_AGIDLW*modelVar_LOV_i)/(LEN*iWE));
    AGIDLD = ((modelPar_AGIDLDW*modelVar_LOVD_i)/(LEN*iWE));
    BGIDL = modelPar_BGIDLO;
    BGIDLD = modelPar_BGIDLDO;
    STBGIDL = modelPar_STBGIDLO;
    STBGIDLD = modelPar_STBGIDLDO;
    CGIDL = modelPar_CGIDLO;
    CGIDLD = modelPar_CGIDLDO;
    COX = ((((8.8541878176E-12*modelVar_EPSROX_i)*WEcv)*LEcv)/modelVar_TOX_i);
    CGOV = ((((8.8541878176E-12*modelVar_EPSROX_i)*WEcv)*modelVar_LOV_i)/modelVar_TOXOV_i);
    CGOVD = ((((8.8541878176E-12*modelVar_EPSROX_i)*WEcv)*modelVar_LOVD_i)/modelVar_TOXOVD_i);
    CGBOV = ((modelPar_CGBOVL*Lcv)/LEN);
    CFR = ((modelPar_CFRW*Wcv)/WEN);
    CFRD = ((modelPar_CFRDW*Wcv)/WEN);
    temp0 = (1.0-(((2.0*modelPar_LINTNOI)*iLE)/LEN));
    Lnoi = adms_ternary_op<AdmsSensFadType>((temp0>1.0e-3),temp0,1.0e-3);
    {
      AdmsSensFadType value_pow_0 = pow(Lnoi,modelPar_ALPNOI);
      Lred = (1.0/value_pow_0);
    }
    FNT = modelPar_FNTO;
    FNTEXC = ((((modelPar_FNTEXCL*BETN)*BETN)*iWE)*iWE);
    NFA = (((Lred*iWE)*iLE)*modelPar_NFALW);
    NFB = (((Lred*iWE)*iLE)*modelPar_NFBLW);
    NFC = (((Lred*iWE)*iLE)*modelPar_NFCLW);
    EF = modelPar_EFO;
    KVTHOWE = (((modelPar_KVTHOWEO+(modelPar_KVTHOWEL*iLE))+(modelPar_KVTHOWEW*iWE))+((modelPar_KVTHOWELW*iLE)*iWE));
    KUOWE = (((modelPar_KUOWEO+(modelPar_KUOWEL*iLE))+(modelPar_KUOWEW*iWE))+((modelPar_KUOWELW*iLE)*iWE));
    RG = ((((RSHG_i*(((3.3333333333333333e-01*W_f)/NGCON_i)+XGWE))/(NGCON_i*L_slif))+((modelVar_RINT_i+modelVar_RVPOLY_i)/(W_f*L_f)))+(NF_i*modelPar_RGO));
    RWELL = (NF_i*modelPar_RWELLO);
    RBULK = (NF_i*modelPar_RBULKO);
    RJUNS = (NF_i*modelPar_RJUNSO);
    RJUND = (NF_i*modelPar_RJUNDO);
    tmpa = 0.0;
    tmpb = 0.0;
    loop = 0.0;
    if ((((SA_i>0.0)&&(SB_i>0.0))&&((NF_i==1.0)||((NF_i>1.0)&&(SD_i>0.0)))))
    {
      while ((loop<(NF_i-0.5)))
      {
        tmpa = (tmpa+(1.0/((SA_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
        tmpb = (tmpb+(1.0/((SB_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
        loop = (loop+1.0);
      }
      Invsa = (tmpa*invNF);
      Invsb = (tmpb*invNF);
      Invsaref = (1.0/(modelVar_SAREF_i+(0.5*L_i)));
      Invsbref = (1.0/(modelVar_SBREF_i+(0.5*L_i)));
      Lx = adms_ternary_op<AdmsSensFadType>(((L_i+delLPS)>1e-9),(L_i+delLPS),1e-9);
      Wx = adms_ternary_op<AdmsSensFadType>((((W_i+delWOD)+modelPar_WLOD)>1e-9),((W_i+delWOD)+modelPar_WLOD),1e-9);
      {
        AdmsSensFadType value_pow_0 = pow(Lx,modelVar_LLODKUO_i);
        templ = (1.0/value_pow_0);
      }
      {
        AdmsSensFadType value_pow_0 = pow(Wx,modelVar_WLODKUO_i);
        tempw = (1.0/value_pow_0);
      }
      Kstressu0 = ((((1.0+(modelPar_LKUO*templ))+(modelPar_WKUO*tempw))+((modelPar_PKUO*templ)*tempw))*(1.0+(modelPar_TKUO*(modelVar_rT-1.0))));
      rhobeta = ((modelPar_KUO*(Invsa+Invsb))/Kstressu0);
      rhobetaref = ((modelPar_KUO*(Invsaref+Invsbref))/Kstressu0);
      {
        AdmsSensFadType value_pow_0 = pow(Lx,modelVar_LLODVTH_i);
        templ = (1.0/value_pow_0);
      }
      {
        AdmsSensFadType value_pow_0 = pow(Wx,modelVar_WLODVTH_i);
        tempw = (1.0/value_pow_0);
      }
      Kstressvth0 = (((1.0+(modelPar_LKVTHO*templ))+(modelPar_WKVTHO*tempw))+((modelPar_PKVTHO*templ)*tempw));
      temp0 = (((Invsa+Invsb)-Invsaref)-Invsbref);
      BETN = ((BETN*(1.0+rhobeta))/(1.0+rhobetaref));
      THESAT = (((THESAT*(1.0+rhobeta))*(1.0+(modelVar_KVSAT_i*rhobetaref)))/((1.0+rhobetaref)*(1.0+(modelVar_KVSAT_i*rhobeta))));
      VFB = (VFB+((modelPar_KVTHO*temp0)/Kstressvth0));
      {
        AdmsSensFadType value_pow_0 = pow(Kstressvth0,modelVar_LODETAO_i);
        CF = (CF+((modelPar_STETAO*temp0)/value_pow_0));
      }
    }
    if (((((SCA_i>0.0)||(SCB_i>0.0))||(SCC_i>0.0))||(SC_i>0.0)))
    {
      if ((((SCA_i==0.0)&&(SCB_i==0.0))&&(SCC_i==0.0)))
      {
        temp0 = (SC_i+W_i);
        temp00 = (1.0/modelVar_SCREF_i);
        SCA_i = ((modelVar_SCREF_i*modelVar_SCREF_i)/(SC_i*temp0));
        {
          AdmsSensFadType value_exp_0 = exp((((-10.0)*SC_i)*temp00));
          AdmsSensFadType value_exp_1 = exp((((-10.0)*temp0)*temp00));
          SCB_i = (((((0.1*SC_i)+(0.01*modelVar_SCREF_i))*value_exp_0)-(((0.1*temp0)+(0.01*modelVar_SCREF_i))*value_exp_1))/W_i);
        }
        {
          AdmsSensFadType value_exp_0 = exp((((-20.0)*SC_i)*temp00));
          AdmsSensFadType value_exp_1 = exp((((-20.0)*temp0)*temp00));
          SCC_i = (((((0.05*SC_i)+(0.0025*modelVar_SCREF_i))*value_exp_0)-(((0.05*temp0)+(0.0025*modelVar_SCREF_i))*value_exp_1))/W_i);
        }
      }
      temp0 = ((SCA_i+(modelVar_WEB_i*SCB_i))+(modelVar_WEC_i*SCC_i));
      VFB = (VFB+(KVTHOWE*temp0));
      BETN = (BETN*(1.0+(KUOWE*temp0)));
    }
    instanceVar_VFB_i = VFB;
    STVFB_i = STVFB;
    modelVar_TOX_i = adms_ternary_op<AdmsSensFadType>((TOX>1e-10),TOX,1e-10);
    modelVar_EPSROX_i = adms_ternary_op<AdmsSensFadType>((EPSROX>1.0),EPSROX,1.0);
    NEFF_i = adms_ternary_op<AdmsSensFadType>((NEFF>1e20),adms_ternary_op<AdmsSensFadType>((NEFF<1e26),NEFF,1e26),1e20);
    instanceVar_VNSUB_i = VNSUB;
    instanceVar_NSLP_i = adms_ternary_op<AdmsSensFadType>((NSLP>1e-3),NSLP,1e-3);
    instanceVar_DNSUB_i = adms_ternary_op<AdmsSensFadType>((DNSUB>0.0),adms_ternary_op<AdmsSensFadType>((DNSUB<1.0),DNSUB,1.0),0.0);
    DPHIB_i = DPHIB;
    NP_i = adms_ternary_op<AdmsSensFadType>((NP>0.0),NP,0.0);
    QMC_i = adms_ternary_op<AdmsSensFadType>((modelPar_QMC>0.0),modelPar_QMC,0.0);
    CT_i = adms_ternary_op<AdmsSensFadType>((CT>0.0),CT,0.0);
    modelVar_TOXOV_i = adms_ternary_op<AdmsSensFadType>((TOXOV>1e-10),TOXOV,1e-10);
    modelVar_TOXOVD_i = adms_ternary_op<AdmsSensFadType>((TOXOVD>1e-10),TOXOVD,1e-10);
    NOV_i = adms_ternary_op<AdmsSensFadType>((NOV>1e20),adms_ternary_op<AdmsSensFadType>((NOV<1e27),NOV,1e27),1e20);
    NOVD_i = adms_ternary_op<AdmsSensFadType>((NOVD>1e20),adms_ternary_op<AdmsSensFadType>((NOVD<1e27),NOVD,1e27),1e20);
    instanceVar_CF_i = adms_ternary_op<AdmsSensFadType>((CF>0.0),CF,0.0);
    instanceVar_CFB_i = adms_ternary_op<AdmsSensFadType>((CFB>0.0),adms_ternary_op<AdmsSensFadType>((CFB<1.0),CFB,1.0),0.0);
    BETN_i = adms_ternary_op<AdmsSensFadType>((BETN>0.0),BETN,0.0);
    STBET_i = STBET;
    instanceVar_MUE_i = adms_ternary_op<AdmsSensFadType>((MUE>0.0),MUE,0.0);
    STMUE_i = STMUE;
    instanceVar_THEMU_i = adms_ternary_op<AdmsSensFadType>((THEMU>0.0),THEMU,0.0);
    STTHEMU_i = STTHEMU;
    instanceVar_CS_i = adms_ternary_op<AdmsSensFadType>((CS>0.0),CS,0.0);
    STCS_i = STCS;
    instanceVar_XCOR_i = adms_ternary_op<AdmsSensFadType>((XCOR>0.0),XCOR,0.0);
    STXCOR_i = STXCOR;
    FETA_i = adms_ternary_op<AdmsSensFadType>((FETA>0.0),FETA,0.0);
    RS_i = adms_ternary_op<AdmsSensFadType>((RS>0.0),RS,0.0);
    STRS_i = STRS;
    instanceVar_RSB_i = adms_ternary_op<AdmsSensFadType>((RSB>(-0.5)),adms_ternary_op<AdmsSensFadType>((RSB<1.0),RSB,1.0),(-0.5));
    instanceVar_RSG_i = adms_ternary_op<AdmsSensFadType>((RSG>(-0.5)),RSG,(-0.5));
    instanceVar_THESAT_i = adms_ternary_op<AdmsSensFadType>((THESAT>0.0),THESAT,0.0);
    STTHESAT_i = STTHESAT;
    instanceVar_THESATB_i = adms_ternary_op<AdmsSensFadType>((THESATB>(-0.5)),adms_ternary_op<AdmsSensFadType>((THESATB<1.0),THESATB,1.0),(-0.5));
    instanceVar_THESATG_i = adms_ternary_op<AdmsSensFadType>((THESATG>(-0.5)),THESATG,(-0.5));
    instanceVar_AX_i = adms_ternary_op<AdmsSensFadType>((AX>2.0),AX,2.0);
    instanceVar_ALP_i = adms_ternary_op<AdmsSensFadType>((ALP>0.0),ALP,0.0);
    instanceVar_ALP1_i = adms_ternary_op<AdmsSensFadType>((ALP1>0.0),ALP1,0.0);
    instanceVar_ALP2_i = adms_ternary_op<AdmsSensFadType>((ALP2>0.0),ALP2,0.0);
    VP_i = adms_ternary_op<AdmsSensFadType>((VP>1.0e-10),VP,1.0e-10);
    instanceVar_A1_i = adms_ternary_op<AdmsSensFadType>((A1>0.0),A1,0.0);
    instanceVar_A2_i = adms_ternary_op<AdmsSensFadType>((A2>0.0),A2,0.0);
    STA2_i = STA2;
    instanceVar_A3_i = adms_ternary_op<AdmsSensFadType>((A3>0.0),A3,0.0);
    instanceVar_A4_i = adms_ternary_op<AdmsSensFadType>((A4>0.0),A4,0.0);
    GCO_i = adms_ternary_op<AdmsSensFadType>((GCO>(-10.0)),adms_ternary_op<AdmsSensFadType>((GCO<10.0),GCO,10.0),(-10.0));
    instanceVar_IGINV_i = adms_ternary_op<AdmsSensFadType>((IGINV>0.0),IGINV,0.0);
    instanceVar_IGOV_i = adms_ternary_op<AdmsSensFadType>((IGOV>0.0),IGOV,0.0);
    instanceVar_IGOVD_i = adms_ternary_op<AdmsSensFadType>((IGOVD>0.0),IGOVD,0.0);
    STIG_i = STIG;
    instanceVar_GC2_i = adms_ternary_op<AdmsSensFadType>((GC2>0.0),adms_ternary_op<AdmsSensFadType>((GC2<10.0),GC2,10.0),0.0);
    instanceVar_GC3_i = adms_ternary_op<AdmsSensFadType>((GC3>(-10.0)),adms_ternary_op<AdmsSensFadType>((GC3<10.0),GC3,10.0),(-10.0));
    instanceVar_CHIB_i = adms_ternary_op<AdmsSensFadType>((CHIB>1.0),CHIB,1.0);
    instanceVar_AGIDL_i = adms_ternary_op<AdmsSensFadType>((AGIDL>0.0),AGIDL,0.0);
    instanceVar_AGIDLD_i = adms_ternary_op<AdmsSensFadType>((AGIDLD>0.0),AGIDLD,0.0);
    BGIDL_i = adms_ternary_op<AdmsSensFadType>((BGIDL>0.0),BGIDL,0.0);
    BGIDLD_i = adms_ternary_op<AdmsSensFadType>((BGIDLD>0.0),BGIDLD,0.0);
    STBGIDL_i = STBGIDL;
    STBGIDLD_i = STBGIDLD;
    instanceVar_CGIDL_i = CGIDL;
    instanceVar_CGIDLD_i = CGIDLD;
    instanceVar_COX_i = adms_ternary_op<AdmsSensFadType>((COX>0.0),COX,0.0);
    instanceVar_CGOV_i = adms_ternary_op<AdmsSensFadType>((CGOV>0.0),CGOV,0.0);
    instanceVar_CGOVD_i = adms_ternary_op<AdmsSensFadType>((CGOVD>0.0),CGOVD,0.0);
    instanceVar_CGBOV_i = adms_ternary_op<AdmsSensFadType>((CGBOV>0.0),CGBOV,0.0);
    instanceVar_CFR_i = adms_ternary_op<AdmsSensFadType>((CFR>0.0),CFR,0.0);
    instanceVar_CFRD_i = adms_ternary_op<AdmsSensFadType>((CFRD>0.0),CFRD,0.0);
    FNT_i = adms_ternary_op<AdmsSensFadType>((FNT>0.0),FNT,0.0);
    instanceVar_FNTEXC_i = adms_ternary_op<AdmsSensFadType>((FNTEXC>0.0),FNTEXC,0.0);
    instanceVar_NFA_i = adms_ternary_op<AdmsSensFadType>((NFA>0.0),NFA,0.0);
    instanceVar_NFB_i = adms_ternary_op<AdmsSensFadType>((NFB>0.0),NFB,0.0);
    instanceVar_NFC_i = adms_ternary_op<AdmsSensFadType>((NFC>0.0),NFC,0.0);
    instanceVar_EF_i = adms_ternary_op<AdmsSensFadType>((EF>0.0),EF,0.0);
    FACTUO_i = adms_ternary_op<AdmsSensFadType>((instancePar_FACTUO>0.0),instancePar_FACTUO,0.0);
    DELVTO_i = instancePar_DELVTO;
    instanceVar_RG_i = adms_ternary_op<AdmsSensFadType>((RG>0.0),RG,0.0);
    instanceVar_RBULK_i = adms_ternary_op<AdmsSensFadType>((RBULK>0.0),RBULK,0.0);
    instanceVar_RJUNS_i = adms_ternary_op<AdmsSensFadType>((RJUNS>0.0),RJUNS,0.0);
    instanceVar_RJUND_i = adms_ternary_op<AdmsSensFadType>((RJUND>0.0),RJUND,0.0);
    instanceVar_RWELL_i = adms_ternary_op<AdmsSensFadType>((RWELL>0.0),RWELL,0.0);
    instanceVar_MULT_i = adms_ternary_op<AdmsSensFadType>(((instancePar_MULT*NF_i)>0.0),(instancePar_MULT*NF_i),0.0);
    if ((modelPar_SWJUNASYM==0.0))
    {
      modelVar_TOXOVD_i = modelVar_TOXOV_i;
      NOVD_i = NOV_i;
      instanceVar_AGIDLD_i = instanceVar_AGIDL_i;
      BGIDLD_i = BGIDL_i;
      STBGIDLD_i = STBGIDL_i;
      instanceVar_CGIDLD_i = instanceVar_CGIDL_i;
      instanceVar_IGOVD_i = instanceVar_IGOV_i;
      instanceVar_CGOVD_i = instanceVar_CGOV_i;
      instanceVar_CFRD_i = instanceVar_CFR_i;
    }
    if ((((modelPar_SWJUNCAP==1.0)||(modelPar_SWJUNCAP==2.0))||(modelPar_SWJUNCAP==3.0)))
    {
      instanceVar_ABSOURCE_i = adms_ternary_op<AdmsSensFadType>((ABS_i>0),ABS_i,0);
      instanceVar_LSSOURCE_i = adms_ternary_op<AdmsSensFadType>((LSS_i>0),LSS_i,0);
      instanceVar_LGSOURCE_i = adms_ternary_op<AdmsSensFadType>((LGS_i>0),LGS_i,0);
      instanceVar_ABDRAIN_i = adms_ternary_op<AdmsSensFadType>((ABD_i>0),ABD_i,0);
      instanceVar_LSDRAIN_i = adms_ternary_op<AdmsSensFadType>((LSD_i>0),LSD_i,0);
      instanceVar_LGDRAIN_i = adms_ternary_op<AdmsSensFadType>((LGD_i>0),LGD_i,0);
    }
    else
    {
      instanceVar_ABSOURCE_i = 0.0;
      instanceVar_LSSOURCE_i = 0.0;
      instanceVar_LGSOURCE_i = 0.0;
      instanceVar_ABDRAIN_i = 0.0;
      instanceVar_LSDRAIN_i = 0.0;
      instanceVar_LGDRAIN_i = 0.0;
    }
    EPSOX = (8.8541878176E-12*modelVar_EPSROX_i);
    instanceVar_phit1 = (modelVar_phit*(1.0+(CT_i*modelVar_rTn)));
    instanceVar_inv_phit1 = (1.0/instanceVar_phit1);
    instanceVar_VFB_i = ((instanceVar_VFB_i+(STVFB_i*modelVar_dT))+DELVTO_i);
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_phibFac,(-0.75));
      AdmsSensFadType value_log_1 = log(((NEFF_i*value_pow_0)*4.0e-26));
      instanceVar_phib = ((modelVar_Eg+DPHIB_i)+((2.0*modelVar_phit)*value_log_1));
    }
    instanceVar_phib = adms_ternary_op<AdmsSensFadType>((instanceVar_phib>5.0E-2),instanceVar_phib,5.0E-2);
    CoxPrime = (EPSOX/modelVar_TOX_i);
    tox_sq = (modelVar_TOX_i*modelVar_TOX_i);
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NEFF_i)*modelVar_EPSSI)*modelVar_inv_phit));
      instanceVar_G_0 = (value_sqrt_0/CoxPrime);
    }
    instanceVar_kp = 0.0;
    if ((NP_i>0.0))
    {
      arg2max = (8.0e7/tox_sq);
      np = adms_ternary_op<AdmsSensFadType>((NP_i>arg2max),NP_i,arg2max);
      np = adms_ternary_op<AdmsSensFadType>((5.0e24>np),5.0e24,np);
      instanceVar_kp = ((((2.0*CoxPrime)*CoxPrime)*modelVar_phit)/((1.6021918E-19*np)*modelVar_EPSSI));
    }
    instanceVar_qlim2 = ((100.0*modelVar_phit)*modelVar_phit);
    instanceVar_qq = 0.0;
    if ((QMC_i>0.0))
    {
      {
        AdmsSensFadType value_pow_0 = pow(CoxPrime,6.6666666666666667e-01);
        instanceVar_qq = (((0.4*5.951993)*QMC_i)*value_pow_0);
      }
      if ((modelVar_CHNL_TYPE==(-1)))
      {
        instanceVar_qq = ((7.448711/5.951993)*instanceVar_qq);
      }
      {
        AdmsSensFadType value_sqrt_0 = sqrt((((modelVar_phit*instanceVar_G_0)*instanceVar_G_0)*instanceVar_phib));
        qb0 = value_sqrt_0;
      }
      {
        AdmsSensFadType value_pow_0 = pow(qb0,6.6666666666666667e-01);
        dphibq = ((0.75*instanceVar_qq)*value_pow_0);
      }
      instanceVar_phib = (instanceVar_phib+dphibq);
      instanceVar_G_0 = (instanceVar_G_0*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(instanceVar_phib);
      instanceVar_sqrt_phib = value_sqrt_0;
    }
    instanceVar_phix = (0.95*instanceVar_phib);
    instanceVar_aphi = ((0.0025*instanceVar_phib)*instanceVar_phib);
    instanceVar_bphi = instanceVar_aphi;
    {
      AdmsSensFadType value_sqrt_0 = sqrt(instanceVar_bphi);
      phix2 = (0.5*value_sqrt_0);
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((instanceVar_phix-phix2))*((instanceVar_phix-phix2)))+instanceVar_aphi));
      instanceVar_phix1 = (0.5*(((instanceVar_phix-phix2))-value_sqrt_0));
    }
    CoxovPrime = (EPSOX/modelVar_TOXOV_i);
    CoxovPrime_d = (EPSOX/modelVar_TOXOVD_i);
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NOV_i)*modelVar_EPSSI)*modelVar_inv_phit));
      instanceVar_GOV_s = (value_sqrt_0/CoxovPrime);
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NOVD_i)*modelVar_EPSSI)*modelVar_inv_phit));
      instanceVar_GOV_d = (value_sqrt_0/CoxovPrime_d);
    }
    instanceVar_GOV2_s = (instanceVar_GOV_s*instanceVar_GOV_s);
    instanceVar_GOV2_d = (instanceVar_GOV_d*instanceVar_GOV_d);
    instanceVar_xi_ov_s = (1.0+(instanceVar_GOV_s*7.0710678118654746e-01));
    instanceVar_xi_ov_d = (1.0+(instanceVar_GOV_d*7.0710678118654746e-01));
    instanceVar_inv_xi_ov_s = (1.0/instanceVar_xi_ov_s);
    instanceVar_inv_xi_ov_d = (1.0/instanceVar_xi_ov_d);
    instanceVar_x_mrg_ov_s = (1.0e-5*instanceVar_xi_ov_s);
    instanceVar_x_mrg_ov_d = (1.0e-5*instanceVar_xi_ov_d);
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_rTn,STBET_i);
      tf_bet = value_pow_0;
    }
    instanceVar_BET_i = (((FACTUO_i*BETN_i)*CoxPrime)*tf_bet);
    BETN_i = (BETN_i*tf_bet);
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_rTn,STTHEMU_i);
      instanceVar_THEMU_i = (instanceVar_THEMU_i*value_pow_0);
    }
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_rTn,STMUE_i);
      tf_mue = value_pow_0;
    }
    instanceVar_MUE_i = (instanceVar_MUE_i*tf_mue);
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_rTn,STCS_i);
      tf_cs = value_pow_0;
    }
    instanceVar_CS_i = (instanceVar_CS_i*tf_cs);
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_rTn,STXCOR_i);
      tf_xcor = value_pow_0;
    }
    instanceVar_XCOR_i = (instanceVar_XCOR_i*tf_xcor);
    instanceVar_E_eff0 = ((1.0e-8*CoxPrime)/modelVar_EPSSI);
    instanceVar_eta_mu = (0.5*FETA_i);
    if ((modelVar_CHNL_TYPE==(-1)))
    {
      instanceVar_eta_mu = (3.3333333333333333e-01*FETA_i);
    }
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_rTn,STRS_i);
      tf_ther = value_pow_0;
    }
    RS_i = (RS_i*tf_ther);
    instanceVar_THER_i = ((2*instanceVar_BET_i)*RS_i);
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_rTn,STTHESAT_i);
      tf_thesat = value_pow_0;
    }
    instanceVar_THESAT_i = (instanceVar_THESAT_i*tf_thesat);
    instanceVar_Vdsat_lim = (3.912023005*instanceVar_phit1);
    instanceVar_inv_AX = (1.0/instanceVar_AX_i);
    instanceVar_inv_VP = (1.0/VP_i);
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_rT,STA2_i);
      instanceVar_A2_i = (instanceVar_A2_i*value_pow_0);
    }
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_rT,STIG_i);
      tf_ig = value_pow_0;
    }
    instanceVar_IGINV_i = (instanceVar_IGINV_i*tf_ig);
    instanceVar_IGOV_i = (instanceVar_IGOV_i*tf_ig);
    instanceVar_IGOVD_i = (instanceVar_IGOVD_i*tf_ig);
    instanceVar_inv_CHIB = (1.0/instanceVar_CHIB_i);
    {
      AdmsSensFadType value_sqrt_0 = sqrt((((2*1.6021918E-19)*9.1093826E-31)*instanceVar_CHIB_i));
      tempM = (((4.0*3.3333333333333333e-01)*value_sqrt_0)/1.05457168E-34);
    }
    instanceVar_BCH = (tempM*modelVar_TOX_i);
    instanceVar_BOV = (tempM*modelVar_TOXOV_i);
    instanceVar_BOV_d = (tempM*modelVar_TOXOVD_i);
    instanceVar_GCQ = 0;
    if ((instanceVar_GC3_i<0))
    {
      instanceVar_GCQ = (((-0.495)*instanceVar_GC2_i)/instanceVar_GC3_i);
    }
    instanceVar_alpha_b = (0.5*(instanceVar_phib+modelVar_Eg));
    instanceVar_Dch = (GCO_i*instanceVar_phit1);
    instanceVar_Dov = (GCO_i*modelVar_phit);
    instanceVar_AGIDLs = ((instanceVar_AGIDL_i*4e-18)/(modelVar_TOXOV_i*modelVar_TOXOV_i));
    instanceVar_AGIDLDs = ((instanceVar_AGIDLD_i*4e-18)/(modelVar_TOXOVD_i*modelVar_TOXOVD_i));
    tempM = adms_ternary_op<AdmsSensFadType>(((1.0+(STBGIDL_i*modelVar_dT))>0),(1.0+(STBGIDL_i*modelVar_dT)),0);
    BGIDL_T = (BGIDL_i*tempM);
    instanceVar_BGIDLs = ((BGIDL_T*modelVar_TOXOV_i)*5e8);
    tempM = adms_ternary_op<AdmsSensFadType>(((1.0+(STBGIDLD_i*modelVar_dT))>0),(1.0+(STBGIDLD_i*modelVar_dT)),0);
    BGIDLD_T = (BGIDLD_i*tempM);
    instanceVar_BGIDLDs = ((BGIDLD_T*modelVar_TOXOVD_i)*5e8);
    instanceVar_nt = (((FNT_i*4)*1.3806505E-23)*modelVar_TKD);
    instanceVar_Cox_over_q = (CoxPrime/1.6021918E-19);
    instanceVar_Sfl_prefac = (((modelVar_phit*modelVar_phit)*instanceVar_BET_i)/instanceVar_Cox_over_q);
    instanceVar_fac_exc = ((9.1093826E-31*1e9)*instanceVar_FNTEXC_i);
    instanceVar_x1 = 1.25;
    instanceVar_inv_xg1_s = (1.0/(instanceVar_x1+(instanceVar_GOV_s*7.324648775608221e-1)));
    instanceVar_inv_xg1_d = (1.0/(instanceVar_x1+(instanceVar_GOV_d*7.324648775608221e-1)));
    if ((instanceVar_RG_i>0.0))
    {
      instanceVar_ggate = (1.0/instanceVar_RG_i);
    }
    else
    {
      instanceVar_ggate = 0.0;
    }
    if ((instanceVar_RBULK_i>0.0))
    {
      instanceVar_gbulk = (1.0/instanceVar_RBULK_i);
    }
    else
    {
      instanceVar_gbulk = 0.0;
    }
    if ((instanceVar_RJUNS_i>0.0))
    {
      instanceVar_gjuns = (1.0/instanceVar_RJUNS_i);
    }
    else
    {
      instanceVar_gjuns = 0.0;
    }
    if ((instanceVar_RJUND_i>0.0))
    {
      instanceVar_gjund = (1.0/instanceVar_RJUND_i);
    }
    else
    {
      instanceVar_gjund = 0.0;
    }
    if ((instanceVar_RWELL_i>0.0))
    {
      instanceVar_gwell = (1.0/instanceVar_RWELL_i);
    }
    else
    {
      instanceVar_gwell = 0.0;
    }
    instanceVar_vbimin_s = 0.0;
    instanceVar_vbimin_d = 0.0;
    instanceVar_vfmin_s = 0.0;
    instanceVar_vfmin_d = 0.0;
    instanceVar_vch_s = 0.0;
    instanceVar_vch_d = 0.0;
    instanceVar_vbbtlim_s = 0.0;
    instanceVar_vbbtlim_d = 0.0;
    instanceVar_VMAX_s = 0.0;
    instanceVar_VMAX_d = 0.0;
    instanceVar_exp_VMAX_over_phitd_s = 0.0;
    instanceVar_exp_VMAX_over_phitd_d = 0.0;
    instanceVar_ISATFOR1_s = 0.0;
    instanceVar_ISATFOR1_d = 0.0;
    instanceVar_MFOR1_s = 1.0;
    instanceVar_MFOR1_d = 1.0;
    instanceVar_ISATFOR2_s = 0.0;
    instanceVar_ISATFOR2_d = 0.0;
    instanceVar_MFOR2_s = 1.0;
    instanceVar_MFOR2_d = 1.0;
    instanceVar_ISATREV_s = 0.0;
    instanceVar_ISATREV_d = 0.0;
    instanceVar_MREV_s = 1.0;
    instanceVar_MREV_d = 1.0;
    instanceVar_m0flag_s = 0.0;
    instanceVar_m0flag_d = 0.0;
    instanceVar_xhighf1_s = 0.0;
    instanceVar_xhighf1_d = 0.0;
    instanceVar_expxhf1_s = 0.0;
    instanceVar_expxhf1_d = 0.0;
    instanceVar_xhighf2_s = 0.0;
    instanceVar_xhighf2_d = 0.0;
    instanceVar_expxhf2_s = 0.0;
    instanceVar_expxhf2_d = 0.0;
    instanceVar_xhighr_s = 0.0;
    instanceVar_xhighr_d = 0.0;
    instanceVar_expxhr_s = 0.0;
    instanceVar_expxhr_d = 0.0;
    instanceVar_zflagbot_s = 1.0;
    instanceVar_zflagbot_d = 1.0;
    instanceVar_zflagsti_s = 1.0;
    instanceVar_zflagsti_d = 1.0;
    instanceVar_zflaggat_s = 1.0;
    instanceVar_zflaggat_d = 1.0;
    m0_rev = 0.0;
    mcor_rev = 0.0;
    I1_cor = 0.0;
    I2_cor = 0.0;
    I3_cor = 0.0;
    I4_cor = 0.0;
    I5_cor = 0.0;
    tt0 = 0.0;
    tt1 = 0.0;
    tt2 = 0.0;
    zfrac = 0.0;
    alphaje = 0.0;
    if ((modelPar_SWJUNCAP>0))
    {
      if (((modelVar_idsatbot*instanceVar_ABSOURCE_i)>0))
      {
        {
          AdmsSensFadType value_log_0 = log(((modelVar_IMAX_i/(modelVar_idsatbot*instanceVar_ABSOURCE_i))+1));
          vmaxbot = (modelVar_phitd*value_log_0);
        }
      }
      else
      {
        vmaxbot = 1E8;
      }
      if (((modelVar_idsatsti*instanceVar_LSSOURCE_i)>0))
      {
        {
          AdmsSensFadType value_log_0 = log(((modelVar_IMAX_i/(modelVar_idsatsti*instanceVar_LSSOURCE_i))+1));
          vmaxsti = (modelVar_phitd*value_log_0);
        }
      }
      else
      {
        vmaxsti = 1E8;
      }
      if (((modelVar_idsatgat*instanceVar_LGSOURCE_i)>0))
      {
        {
          AdmsSensFadType value_log_0 = log(((modelVar_IMAX_i/(modelVar_idsatgat*instanceVar_LGSOURCE_i))+1));
          vmaxgat = (modelVar_phitd*value_log_0);
        }
      }
      else
      {
        vmaxgat = 1E8;
      }
      {
        AdmsSensFadType value_min_0 = min(vmaxbot,vmaxsti);
        AdmsSensFadType value_min_1 = min(value_min_0,vmaxgat);
        instanceVar_VMAX_s = value_min_1;
      }
      if ((fabs((instanceVar_VMAX_s*modelVar_phitdinv))<2.3025850929940458e+02))
      {
        {
          AdmsSensFadType value_exp_0 = exp((instanceVar_VMAX_s*modelVar_phitdinv));
          instanceVar_exp_VMAX_over_phitd_s = value_exp_0;
        }
      }
      else
      {
        if (((instanceVar_VMAX_s*modelVar_phitdinv)<(-2.3025850929940458e+02)))
        {
          instanceVar_exp_VMAX_over_phitd_s = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(instanceVar_VMAX_s*modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceVar_VMAX_s*modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceVar_VMAX_s*modelVar_phitdinv))*3.3333333333333333e-01))))))));
        }
        else
        {
          instanceVar_exp_VMAX_over_phitd_s = (1.0e100*(1.0+(((instanceVar_VMAX_s*modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(0.5*(((instanceVar_VMAX_s*modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceVar_VMAX_s*modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
        }
      }
      vbibot2 = modelVar_vbibot;
      vbisti2 = modelVar_vbisti;
      vbigat2 = modelVar_vbigat;
      pbot2 = modelVar_PBOT_i;
      psti2 = modelVar_PSTI_i;
      pgat2 = modelVar_PGAT_i;
      vbibot2r = modelVar_VBIRBOT_i;
      vbisti2r = modelVar_VBIRSTI_i;
      vbigat2r = modelVar_VBIRGAT_i;
      if ((instanceVar_ABSOURCE_i==0))
      {
        vbibot2 = (modelVar_vbisti+modelVar_vbigat);
        {
          AdmsSensFadType value_min_0 = min(modelVar_PSTI_i,modelVar_PGAT_i);
          pbot2 = (0.9*value_min_0);
        }
        vbibot2r = (modelVar_VBIRSTI_i+modelVar_VBIRGAT_i);
      }
      if ((instanceVar_LSSOURCE_i==0))
      {
        vbisti2 = (modelVar_vbibot+modelVar_vbigat);
        {
          AdmsSensFadType value_min_0 = min(modelVar_PBOT_i,modelVar_PGAT_i);
          psti2 = (0.9*value_min_0);
        }
        vbisti2r = (modelVar_VBIRBOT_i+modelVar_VBIRGAT_i);
      }
      if ((instanceVar_LGSOURCE_i==0))
      {
        vbigat2 = (modelVar_vbibot+modelVar_vbisti);
        {
          AdmsSensFadType value_min_0 = min(modelVar_PBOT_i,modelVar_PSTI_i);
          pgat2 = (0.9*value_min_0);
        }
        vbigat2r = (modelVar_VBIRBOT_i+modelVar_VBIRSTI_i);
      }
      {
        AdmsSensFadType value_min_0 = min(vbibot2,vbisti2);
        AdmsSensFadType value_min_1 = min(value_min_0,vbigat2);
        instanceVar_vbimin_s = value_min_1;
      }
      instanceVar_vch_s = (instanceVar_vbimin_s*0.1);
      {
        AdmsSensFadType value_max_0 = max(pbot2,psti2);
        AdmsSensFadType value_max_1 = max(value_max_0,pgat2);
        pmax = value_max_1;
      }
      {
        AdmsSensFadType value_pow_0 = pow(2,((-1.0)/pmax));
        instanceVar_vfmin_s = (instanceVar_vbimin_s*(1-value_pow_0));
      }
      {
        AdmsSensFadType value_min_0 = min(vbibot2r,vbisti2r);
        AdmsSensFadType value_min_1 = min(value_min_0,vbigat2r);
        instanceVar_vbbtlim_s = (value_min_1-0.050);
      }
      if (((modelVar_idsatbot_d*instanceVar_ABDRAIN_i)>0))
      {
        {
          AdmsSensFadType value_log_0 = log(((modelVar_IMAX_i/(modelVar_idsatbot_d*instanceVar_ABDRAIN_i))+1));
          vmaxbot = (modelVar_phitd*value_log_0);
        }
      }
      else
      {
        vmaxbot = 1E8;
      }
      if (((modelVar_idsatsti_d*instanceVar_LSDRAIN_i)>0))
      {
        {
          AdmsSensFadType value_log_0 = log(((modelVar_IMAX_i/(modelVar_idsatsti_d*instanceVar_LSDRAIN_i))+1));
          vmaxsti = (modelVar_phitd*value_log_0);
        }
      }
      else
      {
        vmaxsti = 1E8;
      }
      if (((modelVar_idsatgat_d*instanceVar_LGDRAIN_i)>0))
      {
        {
          AdmsSensFadType value_log_0 = log(((modelVar_IMAX_i/(modelVar_idsatgat_d*instanceVar_LGDRAIN_i))+1));
          vmaxgat = (modelVar_phitd*value_log_0);
        }
      }
      else
      {
        vmaxgat = 1E8;
      }
      {
        AdmsSensFadType value_min_0 = min(vmaxbot,vmaxsti);
        AdmsSensFadType value_min_1 = min(value_min_0,vmaxgat);
        instanceVar_VMAX_d = value_min_1;
      }
      if ((fabs((instanceVar_VMAX_d*modelVar_phitdinv))<2.3025850929940458e+02))
      {
        {
          AdmsSensFadType value_exp_0 = exp((instanceVar_VMAX_d*modelVar_phitdinv));
          instanceVar_exp_VMAX_over_phitd_d = value_exp_0;
        }
      }
      else
      {
        if (((instanceVar_VMAX_d*modelVar_phitdinv)<(-2.3025850929940458e+02)))
        {
          instanceVar_exp_VMAX_over_phitd_d = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(instanceVar_VMAX_d*modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceVar_VMAX_d*modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceVar_VMAX_d*modelVar_phitdinv))*3.3333333333333333e-01))))))));
        }
        else
        {
          instanceVar_exp_VMAX_over_phitd_d = (1.0e100*(1.0+(((instanceVar_VMAX_d*modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(0.5*(((instanceVar_VMAX_d*modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceVar_VMAX_d*modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
        }
      }
      vbibot2 = modelVar_vbibot_d;
      vbisti2 = modelVar_vbisti_d;
      vbigat2 = modelVar_vbigat_d;
      pbot2 = modelVar_PBOTD_i;
      psti2 = modelVar_PSTID_i;
      pgat2 = modelVar_PGATD_i;
      vbibot2r = modelVar_VBIRBOTD_i;
      vbisti2r = modelVar_VBIRSTID_i;
      vbigat2r = modelVar_VBIRGATD_i;
      if ((instanceVar_ABDRAIN_i==0))
      {
        vbibot2 = (modelVar_vbisti_d+modelVar_vbigat_d);
        {
          AdmsSensFadType value_min_0 = min(modelVar_PSTID_i,modelVar_PGATD_i);
          pbot2 = (0.9*value_min_0);
        }
        vbibot2r = (modelVar_VBIRSTID_i+modelVar_VBIRGATD_i);
      }
      if ((instanceVar_LSDRAIN_i==0))
      {
        vbisti2 = (modelVar_vbibot_d+modelVar_vbigat_d);
        {
          AdmsSensFadType value_min_0 = min(modelVar_PBOTD_i,modelVar_PGATD_i);
          psti2 = (0.9*value_min_0);
        }
        vbisti2r = (modelVar_VBIRBOTD_i+modelVar_VBIRGATD_i);
      }
      if ((instanceVar_LGDRAIN_i==0))
      {
        vbigat2 = (modelVar_vbibot_d+modelVar_vbisti_d);
        {
          AdmsSensFadType value_min_0 = min(modelVar_PBOTD_i,modelVar_PSTID_i);
          pgat2 = (0.9*value_min_0);
        }
        vbigat2r = (modelVar_VBIRBOTD_i+modelVar_VBIRSTID_i);
      }
      {
        AdmsSensFadType value_min_0 = min(vbibot2,vbisti2);
        AdmsSensFadType value_min_1 = min(value_min_0,vbigat2);
        instanceVar_vbimin_d = value_min_1;
      }
      instanceVar_vch_d = (instanceVar_vbimin_d*0.1);
      {
        AdmsSensFadType value_max_0 = std::max(pbot2,psti2);
        AdmsSensFadType value_max_1 = std::max(value_max_0,pgat2);
        pmax = value_max_1;
      }
      {
        AdmsSensFadType value_pow_0 = pow(2,((-1.0)/pmax));
        instanceVar_vfmin_d = (instanceVar_vbimin_d*(1-value_pow_0));
      }
      {
        AdmsSensFadType value_min_0 = min(vbibot2r,vbisti2r);
        AdmsSensFadType value_min_1 = min(value_min_0,vbigat2r);
        instanceVar_vbbtlim_d = (value_min_1-0.050);
      }
      if ((modelVar_SWJUNEXP_i==1.0))
        //Begin block JUNCAPexpressInit
      {
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType ysq;
        AdmsSensFadType terfc;
        AdmsSensFadType erfcpos;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType h1;
        AdmsSensFadType h2;
        AdmsSensFadType h2d;
        AdmsSensFadType h3;
        AdmsSensFadType h4;
        AdmsSensFadType h5;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType idmult;
        AdmsSensFadType vj;
        AdmsSensFadType z;
        AdmsSensFadType zinv;
        AdmsSensFadType two_psistar;
        AdmsSensFadType vjlim;
        AdmsSensFadType vjsrh;
        AdmsSensFadType vbbt;
        AdmsSensFadType vav;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType tmp;
        AdmsSensFadType id;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType isrh;
        AdmsSensFadType vbi_minus_vjsrh;
        AdmsSensFadType wsrhstep;
        AdmsSensFadType dwsrh;
        AdmsSensFadType wsrh;
        AdmsSensFadType wdep;
        AdmsSensFadType asrh;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType itat;
        AdmsSensFadType btat;
        AdmsSensFadType twoatatoverthreebtat;
        AdmsSensFadType umaxbeforelimiting;
        AdmsSensFadType umax;
        AdmsSensFadType sqrtumax;
        AdmsSensFadType umaxpoweronepointfive;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType wgamma;
        AdmsSensFadType wtat;
        AdmsSensFadType ktat;
        AdmsSensFadType ltat;
        AdmsSensFadType mtat;
        AdmsSensFadType xerfc;
        AdmsSensFadType erfctimesexpmtat;
        AdmsSensFadType gammamax;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType ibbt;
        AdmsSensFadType Fmaxr;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType fbreakdown;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType ijunbot;
        AdmsSensFadType ijunsti;
        AdmsSensFadType ijungat;
        AdmsSensFadType qjunbot;
        AdmsSensFadType qjunsti;
        AdmsSensFadType qjungat;
        //End of Block-local variables
        ysq = 0.0;
        terfc = 0.0;
        erfcpos = 0.0;
        h1 = 0.0;
        h2 = 0.0;
        h2d = 0.0;
        h3 = 0.0;
        h4 = 0.0;
        h5 = 0.0;
        idmult = 0.0;
        vj = 0.0;
        z = 0.0;
        zinv = 0.0;
        two_psistar = 0.0;
        vjlim = 0.0;
        vjsrh = 0.0;
        vbbt = 0.0;
        vav = 0.0;
        tmp = 0.0;
        id = 0.0;
        isrh = 0.0;
        vbi_minus_vjsrh = 0.0;
        wsrhstep = 0.0;
        dwsrh = 0.0;
        wsrh = 0.0;
        wdep = 0.0;
        asrh = 0.0;
        itat = 0.0;
        btat = 0.0;
        twoatatoverthreebtat = 0.0;
        umaxbeforelimiting = 0.0;
        umax = 0.0;
        sqrtumax = 0.0;
        umaxpoweronepointfive = 0.0;
        wgamma = 0.0;
        wtat = 0.0;
        ktat = 0.0;
        ltat = 0.0;
        mtat = 0.0;
        xerfc = 0.0;
        erfctimesexpmtat = 0.0;
        gammamax = 0.0;
        ibbt = 0.0;
        Fmaxr = 0.0;
        fbreakdown = 0.0;
        qjunbot = 0.0;
        qjunsti = 0.0;
        qjungat = 0.0;
        FRACNA = 0.4;
        FRACNB = 0.65;
        FRACI = 0.8;
        V1 = ((-FRACNA)*modelVar_VJUNREF_i);
        V2 = ((-FRACNB)*modelVar_VJUNREF_i);
        V3 = ((-FRACI)*modelVar_VJUNREF_i);
        V4 = 0.1;
        V5 = 0.2;
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABSOURCE_i==0)&&(instanceVar_LSSOURCE_i==0))&&(instanceVar_LGSOURCE_i==0))))
        {
          h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
          h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
          h2d = (V1+(instanceVar_vch_s*h2));
          h3 = (instanceVar_vfmin_s+h2d);
          h4 = (instanceVar_vfmin_s-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V1*instanceVar_vfmin_s)/(h3+h5)));
          if ((V1<instanceVar_VMAX_s))
          {
            if ((fabs((0.5*(V1*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V1*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V1*modelVar_phitdinv))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V1-instanceVar_VMAX_s)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_s);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V1>0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              AdmsSensFadType value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V1)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_s-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V1-instanceVar_vbbtlim_s)*(V1-instanceVar_vbbtlim_s))+((4*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V1+instanceVar_vbbtlim_s)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V1)*(V1))+((4*1E-6)*1E-6)));
            vav = (0.5*((V1)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABSOURCE_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvbot)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot*(1-tmp))+(modelVar_qpref2bot*(V1-vj)));
          id = (modelVar_idsatbot*idmult);
          if (((modelVar_CSRHBOT_i==0)&&(modelVar_CTATBOT_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PBOT_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PBOT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot*tmp);
            asrh = (modelVar_ftdbot*((zinv-1)*wdep));
            isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOT_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOT_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
            if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOT_i*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOT_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRBOT_i)))
            {
              if ((modelVar_PBRBOT_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvbot));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot+((vav+(0.999*modelVar_VBRBOT_i))*modelVar_slopebot));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSSOURCE_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvsti)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti*(1-tmp))+(modelVar_qpref2sti*(V1-vj)));
          id = (modelVar_idsatsti*idmult);
          if (((modelVar_CSRHSTI_i==0)&&(modelVar_CTATSTI_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PSTI_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PSTI_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti*tmp);
            asrh = (modelVar_ftdsti*((zinv-1)*wdep));
            isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTI_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTI_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
            if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTI_i*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTI_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRSTI_i)))
            {
              if ((modelVar_PBRSTI_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvsti));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTI_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti+((vav+(0.999*modelVar_VBRSTI_i))*modelVar_slopesti));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGSOURCE_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvgat)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat*(1-tmp))+(modelVar_qpref2gat*(V1-vj)));
          id = (modelVar_idsatgat*idmult);
          if (((modelVar_CSRHGAT_i==0)&&(modelVar_CTATGAT_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PGAT_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PGAT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat*tmp);
            asrh = (modelVar_ftdgat*((zinv-1)*wdep));
            isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGAT_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGAT_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
            if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGAT_i*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGAT_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRGAT_i)))
            {
              if ((modelVar_PBRGAT_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvgat));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGAT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat+((vav+(0.999*modelVar_VBRGAT_i))*modelVar_slopegat));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I1 = (((instanceVar_ABSOURCE_i*ijunbot)+(instanceVar_LSSOURCE_i*ijunsti))+(instanceVar_LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABSOURCE_i==0)&&(instanceVar_LSSOURCE_i==0))&&(instanceVar_LGSOURCE_i==0))))
        {
          h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
          h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
          h2d = (V2+(instanceVar_vch_s*h2));
          h3 = (instanceVar_vfmin_s+h2d);
          h4 = (instanceVar_vfmin_s-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V2*instanceVar_vfmin_s)/(h3+h5)));
          if ((V2<instanceVar_VMAX_s))
          {
            if ((fabs((0.5*(V2*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V2*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V2*modelVar_phitdinv))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V2-instanceVar_VMAX_s)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_s);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V2>0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              AdmsSensFadType value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V2)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_s-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V2-instanceVar_vbbtlim_s)*(V2-instanceVar_vbbtlim_s))+((4*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V2+instanceVar_vbbtlim_s)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V2)*(V2))+((4*1E-6)*1E-6)));
            vav = (0.5*((V2)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABSOURCE_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvbot)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot*(1-tmp))+(modelVar_qpref2bot*(V2-vj)));
          id = (modelVar_idsatbot*idmult);
          if (((modelVar_CSRHBOT_i==0)&&(modelVar_CTATBOT_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PBOT_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PBOT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot*tmp);
            asrh = (modelVar_ftdbot*((zinv-1)*wdep));
            isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOT_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOT_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
            if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOT_i*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOT_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRBOT_i)))
            {
              if ((modelVar_PBRBOT_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvbot));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot+((vav+(0.999*modelVar_VBRBOT_i))*modelVar_slopebot));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSSOURCE_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvsti)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti*(1-tmp))+(modelVar_qpref2sti*(V2-vj)));
          id = (modelVar_idsatsti*idmult);
          if (((modelVar_CSRHSTI_i==0)&&(modelVar_CTATSTI_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PSTI_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PSTI_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti*tmp);
            asrh = (modelVar_ftdsti*((zinv-1)*wdep));
            isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTI_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTI_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
            if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTI_i*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTI_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRSTI_i)))
            {
              if ((modelVar_PBRSTI_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvsti));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTI_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti+((vav+(0.999*modelVar_VBRSTI_i))*modelVar_slopesti));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGSOURCE_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvgat)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat*(1-tmp))+(modelVar_qpref2gat*(V2-vj)));
          id = (modelVar_idsatgat*idmult);
          if (((modelVar_CSRHGAT_i==0)&&(modelVar_CTATGAT_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PGAT_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PGAT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat*tmp);
            asrh = (modelVar_ftdgat*((zinv-1)*wdep));
            isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGAT_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGAT_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
            if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGAT_i*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGAT_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRGAT_i)))
            {
              if ((modelVar_PBRGAT_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvgat));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGAT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat+((vav+(0.999*modelVar_VBRGAT_i))*modelVar_slopegat));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I2 = (((instanceVar_ABSOURCE_i*ijunbot)+(instanceVar_LSSOURCE_i*ijunsti))+(instanceVar_LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABSOURCE_i==0)&&(instanceVar_LSSOURCE_i==0))&&(instanceVar_LGSOURCE_i==0))))
        {
          h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
          h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
          h2d = (V3+(instanceVar_vch_s*h2));
          h3 = (instanceVar_vfmin_s+h2d);
          h4 = (instanceVar_vfmin_s-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V3*instanceVar_vfmin_s)/(h3+h5)));
          if ((V3<instanceVar_VMAX_s))
          {
            if ((fabs((0.5*(V3*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V3*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V3*modelVar_phitdinv))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V3-instanceVar_VMAX_s)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_s);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V3>0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              AdmsSensFadType value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V3)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_s-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V3-instanceVar_vbbtlim_s)*(V3-instanceVar_vbbtlim_s))+((4*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V3+instanceVar_vbbtlim_s)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V3)*(V3))+((4*1E-6)*1E-6)));
            vav = (0.5*((V3)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABSOURCE_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvbot)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot*(1-tmp))+(modelVar_qpref2bot*(V3-vj)));
          id = (modelVar_idsatbot*idmult);
          if (((modelVar_CSRHBOT_i==0)&&(modelVar_CTATBOT_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PBOT_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PBOT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot*tmp);
            asrh = (modelVar_ftdbot*((zinv-1)*wdep));
            isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOT_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOT_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
            if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOT_i*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOT_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRBOT_i)))
            {
              if ((modelVar_PBRBOT_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvbot));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot+((vav+(0.999*modelVar_VBRBOT_i))*modelVar_slopebot));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSSOURCE_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvsti)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti*(1-tmp))+(modelVar_qpref2sti*(V3-vj)));
          id = (modelVar_idsatsti*idmult);
          if (((modelVar_CSRHSTI_i==0)&&(modelVar_CTATSTI_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PSTI_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PSTI_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti*tmp);
            asrh = (modelVar_ftdsti*((zinv-1)*wdep));
            isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTI_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTI_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
            if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTI_i*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTI_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRSTI_i)))
            {
              if ((modelVar_PBRSTI_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvsti));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTI_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti+((vav+(0.999*modelVar_VBRSTI_i))*modelVar_slopesti));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGSOURCE_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvgat)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat*(1-tmp))+(modelVar_qpref2gat*(V3-vj)));
          id = (modelVar_idsatgat*idmult);
          if (((modelVar_CSRHGAT_i==0)&&(modelVar_CTATGAT_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PGAT_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PGAT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat*tmp);
            asrh = (modelVar_ftdgat*((zinv-1)*wdep));
            isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGAT_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGAT_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
            if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGAT_i*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGAT_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRGAT_i)))
            {
              if ((modelVar_PBRGAT_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvgat));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGAT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat+((vav+(0.999*modelVar_VBRGAT_i))*modelVar_slopegat));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I3 = (((instanceVar_ABSOURCE_i*ijunbot)+(instanceVar_LSSOURCE_i*ijunsti))+(instanceVar_LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABSOURCE_i==0)&&(instanceVar_LSSOURCE_i==0))&&(instanceVar_LGSOURCE_i==0))))
        {
          h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
          h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
          h2d = (V4+(instanceVar_vch_s*h2));
          h3 = (instanceVar_vfmin_s+h2d);
          h4 = (instanceVar_vfmin_s-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V4*instanceVar_vfmin_s)/(h3+h5)));
          if ((V4<instanceVar_VMAX_s))
          {
            if ((fabs((0.5*(V4*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V4*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V4*modelVar_phitdinv))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V4-instanceVar_VMAX_s)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_s);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V4>0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              AdmsSensFadType value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V4)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_s-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V4-instanceVar_vbbtlim_s)*(V4-instanceVar_vbbtlim_s))+((4*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V4+instanceVar_vbbtlim_s)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V4)*(V4))+((4*1E-6)*1E-6)));
            vav = (0.5*((V4)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABSOURCE_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvbot)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot*(1-tmp))+(modelVar_qpref2bot*(V4-vj)));
          id = (modelVar_idsatbot*idmult);
          if (((modelVar_CSRHBOT_i==0)&&(modelVar_CTATBOT_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PBOT_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PBOT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot*tmp);
            asrh = (modelVar_ftdbot*((zinv-1)*wdep));
            isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOT_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOT_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
            if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOT_i*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOT_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRBOT_i)))
            {
              if ((modelVar_PBRBOT_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvbot));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot+((vav+(0.999*modelVar_VBRBOT_i))*modelVar_slopebot));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSSOURCE_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvsti)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti*(1-tmp))+(modelVar_qpref2sti*(V4-vj)));
          id = (modelVar_idsatsti*idmult);
          if (((modelVar_CSRHSTI_i==0)&&(modelVar_CTATSTI_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PSTI_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PSTI_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti*tmp);
            asrh = (modelVar_ftdsti*((zinv-1)*wdep));
            isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTI_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTI_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
            if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTI_i*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTI_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRSTI_i)))
            {
              if ((modelVar_PBRSTI_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvsti));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTI_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti+((vav+(0.999*modelVar_VBRSTI_i))*modelVar_slopesti));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGSOURCE_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvgat)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat*(1-tmp))+(modelVar_qpref2gat*(V4-vj)));
          id = (modelVar_idsatgat*idmult);
          if (((modelVar_CSRHGAT_i==0)&&(modelVar_CTATGAT_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PGAT_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PGAT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat*tmp);
            asrh = (modelVar_ftdgat*((zinv-1)*wdep));
            isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGAT_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGAT_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
            if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGAT_i*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGAT_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRGAT_i)))
            {
              if ((modelVar_PBRGAT_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvgat));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGAT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat+((vav+(0.999*modelVar_VBRGAT_i))*modelVar_slopegat));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I4 = (((instanceVar_ABSOURCE_i*ijunbot)+(instanceVar_LSSOURCE_i*ijunsti))+(instanceVar_LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABSOURCE_i==0)&&(instanceVar_LSSOURCE_i==0))&&(instanceVar_LGSOURCE_i==0))))
        {
          h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
          h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
          h2d = (V5+(instanceVar_vch_s*h2));
          h3 = (instanceVar_vfmin_s+h2d);
          h4 = (instanceVar_vfmin_s-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V5*instanceVar_vfmin_s)/(h3+h5)));
          if ((V5<instanceVar_VMAX_s))
          {
            if ((fabs((0.5*(V5*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V5*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V5*modelVar_phitdinv))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V5-instanceVar_VMAX_s)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_s);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V5>0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              AdmsSensFadType value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V5)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_s-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V5-instanceVar_vbbtlim_s)*(V5-instanceVar_vbbtlim_s))+((4*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V5+instanceVar_vbbtlim_s)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V5)*(V5))+((4*1E-6)*1E-6)));
            vav = (0.5*((V5)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABSOURCE_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvbot)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot*(1-tmp))+(modelVar_qpref2bot*(V5-vj)));
          id = (modelVar_idsatbot*idmult);
          if (((modelVar_CSRHBOT_i==0)&&(modelVar_CTATBOT_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PBOT_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PBOT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot*tmp);
            asrh = (modelVar_ftdbot*((zinv-1)*wdep));
            isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOT_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOT_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
            if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOT_i*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOT_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRBOT_i)))
            {
              if ((modelVar_PBRBOT_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvbot));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot+((vav+(0.999*modelVar_VBRBOT_i))*modelVar_slopebot));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSSOURCE_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvsti)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti*(1-tmp))+(modelVar_qpref2sti*(V5-vj)));
          id = (modelVar_idsatsti*idmult);
          if (((modelVar_CSRHSTI_i==0)&&(modelVar_CTATSTI_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PSTI_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PSTI_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti*tmp);
            asrh = (modelVar_ftdsti*((zinv-1)*wdep));
            isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTI_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTI_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
            if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTI_i*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTI_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRSTI_i)))
            {
              if ((modelVar_PBRSTI_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvsti));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTI_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti+((vav+(0.999*modelVar_VBRSTI_i))*modelVar_slopesti));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGSOURCE_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvgat)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat*(1-tmp))+(modelVar_qpref2gat*(V5-vj)));
          id = (modelVar_idsatgat*idmult);
          if (((modelVar_CSRHGAT_i==0)&&(modelVar_CTATGAT_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PGAT_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PGAT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat*tmp);
            asrh = (modelVar_ftdgat*((zinv-1)*wdep));
            isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGAT_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGAT_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
            if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGAT_i*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGAT_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRGAT_i)))
            {
              if ((modelVar_PBRGAT_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvgat));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGAT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat+((vav+(0.999*modelVar_VBRGAT_i))*modelVar_slopegat));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I5 = (((instanceVar_ABSOURCE_i*ijunbot)+(instanceVar_LSSOURCE_i*ijunsti))+(instanceVar_LGSOURCE_i*ijungat));
        instanceVar_ISATFOR1_s = (((instanceVar_ABSOURCE_i*modelVar_idsatbot)+(instanceVar_LSSOURCE_i*modelVar_idsatsti))+(instanceVar_LGSOURCE_i*modelVar_idsatgat));
        {
          AdmsSensFadType value_exp_0 = exp(((V4*modelVar_phitdinv)*instanceVar_MFOR1_s));
          I4_cor = (I4-(instanceVar_ISATFOR1_s*(value_exp_0-1.0)));
        }
        {
          AdmsSensFadType value_exp_0 = exp(((V5*modelVar_phitdinv)*instanceVar_MFOR1_s));
          I5_cor = (I5-(instanceVar_ISATFOR1_s*(value_exp_0-1.0)));
        }
        if ((!(((instanceVar_ABSOURCE_i==0)&&(instanceVar_LSSOURCE_i==0))&&(instanceVar_LGSOURCE_i==0))))
        {
          if (((I4>0)&&(I5>0)))
          {
            if ((((((I4_cor/I4)>0.001)||((I5_cor/I5)>0.001))&&(I4_cor>0))&&(I5_cor>0)))
            {
              alphaje = (I4_cor/I5_cor);
              {
                AdmsSensFadType value_log_0 = log(alphaje);
                instanceVar_MFOR2_s = ((modelVar_phitd*value_log_0)/(V4-V5));
              }
              {
                AdmsSensFadType value_exp_0 = exp(((V4*modelVar_phitdinv)*instanceVar_MFOR2_s));
                instanceVar_ISATFOR2_s = (I4_cor/(value_exp_0-1));
              }
            }
          }
          {
            AdmsSensFadType value_exp_0 = exp(((V1*modelVar_phitdinv)*instanceVar_MFOR1_s));
            AdmsSensFadType value_exp_1 = exp(((V1*modelVar_phitdinv)*instanceVar_MFOR2_s));
            I1_cor = ((I1-(instanceVar_ISATFOR1_s*(value_exp_0-1.0)))-(instanceVar_ISATFOR2_s*(value_exp_1-1.0)));
          }
          {
            AdmsSensFadType value_exp_0 = exp(((V2*modelVar_phitdinv)*instanceVar_MFOR1_s));
            AdmsSensFadType value_exp_1 = exp(((V2*modelVar_phitdinv)*instanceVar_MFOR2_s));
            I2_cor = ((I2-(instanceVar_ISATFOR1_s*(value_exp_0-1.0)))-(instanceVar_ISATFOR2_s*(value_exp_1-1.0)));
          }
          {
            AdmsSensFadType value_exp_0 = exp(((V3*modelVar_phitdinv)*instanceVar_MFOR1_s));
            AdmsSensFadType value_exp_1 = exp(((V3*modelVar_phitdinv)*instanceVar_MFOR2_s));
            I3_cor = ((I3-(instanceVar_ISATFOR1_s*(value_exp_0-1.0)))-(instanceVar_ISATFOR2_s*(value_exp_1-1.0)));
          }
          if ((((I1<0)&&(I2<0))&&(I3<0)))
          {
            if ((((((((I1_cor/I1)>0.001)||((I2_cor/I2)>0.001))||((I3_cor/I3)>0.001))&&(I1_cor<0))&&(I2_cor<0))&&(I3_cor<0)))
            {
              alphaje = (I1_cor/I2_cor);
              {
                AdmsSensFadType value_log_0 = log(alphaje);
                m0_rev = (((-modelVar_phitd)*value_log_0)/(V1-V2));
              }
              tt0 = (V2/(V2-V1));
              {
                AdmsSensFadType value_pow_0 = pow(alphaje,tt0);
                tt1 = ((modelVar_phitd*(alphaje-1))*(value_pow_0-1));
              }
              tt0 = (V1/(V1-V2));
              {
                AdmsSensFadType value_pow_0 = pow(alphaje,tt0);
                tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
              }
              mcor_rev = (tt1/tt2);
              instanceVar_MREV_s = (m0_rev+mcor_rev);
              if ((fabs(((V3*modelVar_phitdinv)*instanceVar_MREV_s))<1e-6))
              {
                instanceVar_m0flag_s = 1.0;
                instanceVar_ISATREV_s = (I3_cor*((1/V3)+((0.5*modelVar_phitdinv)*instanceVar_MREV_s)));
                instanceVar_MREV_s = (((((-0.5)*I3_cor)*instanceVar_MREV_s)*modelVar_phitdinv)/V3);
              }
              else
              {
                instanceVar_m0flag_s = 0.0;
                {
                  AdmsSensFadType value_exp_0 = exp((((-V3)*modelVar_phitdinv)*instanceVar_MREV_s));
                  instanceVar_ISATREV_s = ((-I3_cor)/(value_exp_0-1));
                }
              }
            }
          }
        }
        zfrac = (modelVar_FJUNQ_i*(((instanceVar_ABSOURCE_i*modelVar_cjobot)+(instanceVar_LSSOURCE_i*modelVar_cjosti))+(instanceVar_LGSOURCE_i*modelVar_cjogat)));
        if (((instanceVar_ABSOURCE_i*modelVar_cjobot)<=zfrac))
        {
          instanceVar_zflagbot_s = 0.0;
        }
        if (((instanceVar_LSSOURCE_i*modelVar_cjosti)<=zfrac))
        {
          instanceVar_zflagsti_s = 0.0;
        }
        if (((instanceVar_LGSOURCE_i*modelVar_cjogat)<=zfrac))
        {
          instanceVar_zflaggat_s = 0.0;
        }
        if ((!(((instanceVar_ABSOURCE_i==0)&&(instanceVar_LSSOURCE_i==0))&&(instanceVar_LGSOURCE_i==0))))
        {
          {
            AdmsSensFadType value_log_0 = log(((0.5*modelVar_IMAX_i)/(instanceVar_ISATFOR1_s+1e-21)));
            instanceVar_xhighf1_s = value_log_0;
          }
          {
            AdmsSensFadType value_log_0 = log(((0.5*modelVar_IMAX_i)/(instanceVar_ISATFOR2_s+1e-21)));
            instanceVar_xhighf2_s = value_log_0;
          }
          {
            AdmsSensFadType value_fabs_0 = fabs(instanceVar_ISATREV_s);
            AdmsSensFadType value_log_1 = log(((0.5*modelVar_IMAX_i)/(value_fabs_0+1e-21)));
            instanceVar_xhighr_s = value_log_1;
          }
        }
        {
          AdmsSensFadType value_min_0 = std::min(instanceVar_xhighf1_s,static_cast<double>(2.3025850929940458e+02));
          instanceVar_xhighf1_s = value_min_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_xhighf1_s);
          instanceVar_expxhf1_s = value_exp_0;
        }
        {
          AdmsSensFadType value_min_0 = std::min(instanceVar_xhighf2_s,static_cast<double>(2.3025850929940458e+02));
          instanceVar_xhighf2_s = value_min_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_xhighf2_s);
          instanceVar_expxhf2_s = value_exp_0;
        }
        {
          AdmsSensFadType value_min_0 = std::min(instanceVar_xhighr_s,static_cast<double>(2.3025850929940458e+02));
          instanceVar_xhighr_s = value_min_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_xhighr_s);
          instanceVar_expxhr_s = value_exp_0;
        }
        FRACNA = 0.4;
        FRACNB = 0.65;
        FRACI = 0.8;
        V1 = ((-FRACNA)*modelVar_VJUNREFD_i);
        V2 = ((-FRACNB)*modelVar_VJUNREFD_i);
        V3 = ((-FRACI)*modelVar_VJUNREFD_i);
        V4 = 0.1;
        V5 = 0.2;
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABDRAIN_i==0)&&(instanceVar_LSDRAIN_i==0))&&(instanceVar_LGDRAIN_i==0))))
        {
          h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
          h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
          h2d = (V1+(instanceVar_vch_d*h2));
          h3 = (instanceVar_vfmin_d+h2d);
          h4 = (instanceVar_vfmin_d-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V1*instanceVar_vfmin_d)/(h3+h5)));
          if ((V1<instanceVar_VMAX_d))
          {
            if ((fabs((0.5*(V1*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V1*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V1*modelVar_phitdinv))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V1-instanceVar_VMAX_d)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V1>0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              AdmsSensFadType value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V1)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_d-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V1-instanceVar_vbbtlim_d)*(V1-instanceVar_vbbtlim_d))+((4*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V1+instanceVar_vbbtlim_d)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V1)*(V1))+((4*1E-6)*1E-6)));
            vav = (0.5*((V1)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABDRAIN_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvbot_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot_d*(1-tmp))+(modelVar_qpref2bot_d*(V1-vj)));
          id = (modelVar_idsatbot_d*idmult);
          if (((modelVar_CSRHBOTD_i==0)&&(modelVar_CTATBOTD_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PBOTD_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PBOTD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot_d*tmp);
            asrh = (modelVar_ftdbot_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHBOTD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOTD_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartbot_d*((wdep*modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOTD_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT_d*(((modelVar_VBIRBOTD_i-vbbt)*modelVar_wdepnulrinvbot_d)/tmp));
            if ((fabs(((-modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOTD_i*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOTD_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRBOTD_i)))
            {
              if ((modelVar_PBRBOTD_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvbot_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOTD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot_d+((vav+(0.999*modelVar_VBRBOTD_i))*modelVar_slopebot_d));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSDRAIN_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvsti_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti_d*(1-tmp))+(modelVar_qpref2sti_d*(V1-vj)));
          id = (modelVar_idsatsti_d*idmult);
          if (((modelVar_CSRHSTID_i==0)&&(modelVar_CTATSTID_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PSTID_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PSTID_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti_d*tmp);
            asrh = (modelVar_ftdsti_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHSTID_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTID_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartsti_d*((wdep*modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTID_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI_d*(((modelVar_VBIRSTID_i-vbbt)*modelVar_wdepnulrinvsti_d)/tmp));
            if ((fabs(((-modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTID_i*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTID_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRSTID_i)))
            {
              if ((modelVar_PBRSTID_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvsti_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTID_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti_d+((vav+(0.999*modelVar_VBRSTID_i))*modelVar_slopesti_d));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGDRAIN_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvgat_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat_d*(1-tmp))+(modelVar_qpref2gat_d*(V1-vj)));
          id = (modelVar_idsatgat_d*idmult);
          if (((modelVar_CSRHGATD_i==0)&&(modelVar_CTATGATD_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PGATD_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PGATD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat_d*tmp);
            asrh = (modelVar_ftdgat_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHGATD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGATD_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartgat_d*((wdep*modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGATD_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT_d*(((modelVar_VBIRGATD_i-vbbt)*modelVar_wdepnulrinvgat_d)/tmp));
            if ((fabs(((-modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGATD_i*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGATD_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRGATD_i)))
            {
              if ((modelVar_PBRGATD_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvgat_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGATD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat_d+((vav+(0.999*modelVar_VBRGATD_i))*modelVar_slopegat_d));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I1 = (((instanceVar_ABDRAIN_i*ijunbot)+(instanceVar_LSDRAIN_i*ijunsti))+(instanceVar_LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABDRAIN_i==0)&&(instanceVar_LSDRAIN_i==0))&&(instanceVar_LGDRAIN_i==0))))
        {
          h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
          h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
          h2d = (V2+(instanceVar_vch_d*h2));
          h3 = (instanceVar_vfmin_d+h2d);
          h4 = (instanceVar_vfmin_d-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V2*instanceVar_vfmin_d)/(h3+h5)));
          if ((V2<instanceVar_VMAX_d))
          {
            if ((fabs((0.5*(V2*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V2*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V2*modelVar_phitdinv))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V2-instanceVar_VMAX_d)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V2>0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              AdmsSensFadType value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V2)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_d-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V2-instanceVar_vbbtlim_d)*(V2-instanceVar_vbbtlim_d))+((4*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V2+instanceVar_vbbtlim_d)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V2)*(V2))+((4*1E-6)*1E-6)));
            vav = (0.5*((V2)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABDRAIN_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvbot_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot_d*(1-tmp))+(modelVar_qpref2bot_d*(V2-vj)));
          id = (modelVar_idsatbot_d*idmult);
          if (((modelVar_CSRHBOTD_i==0)&&(modelVar_CTATBOTD_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PBOTD_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PBOTD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot_d*tmp);
            asrh = (modelVar_ftdbot_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHBOTD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOTD_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartbot_d*((wdep*modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOTD_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT_d*(((modelVar_VBIRBOTD_i-vbbt)*modelVar_wdepnulrinvbot_d)/tmp));
            if ((fabs(((-modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOTD_i*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOTD_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRBOTD_i)))
            {
              if ((modelVar_PBRBOTD_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvbot_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOTD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot_d+((vav+(0.999*modelVar_VBRBOTD_i))*modelVar_slopebot_d));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSDRAIN_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvsti_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti_d*(1-tmp))+(modelVar_qpref2sti_d*(V2-vj)));
          id = (modelVar_idsatsti_d*idmult);
          if (((modelVar_CSRHSTID_i==0)&&(modelVar_CTATSTID_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PSTID_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PSTID_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti_d*tmp);
            asrh = (modelVar_ftdsti_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHSTID_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTID_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartsti_d*((wdep*modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTID_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI_d*(((modelVar_VBIRSTID_i-vbbt)*modelVar_wdepnulrinvsti_d)/tmp));
            if ((fabs(((-modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTID_i*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTID_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRSTID_i)))
            {
              if ((modelVar_PBRSTID_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvsti_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTID_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti_d+((vav+(0.999*modelVar_VBRSTID_i))*modelVar_slopesti_d));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGDRAIN_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvgat_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat_d*(1-tmp))+(modelVar_qpref2gat_d*(V2-vj)));
          id = (modelVar_idsatgat_d*idmult);
          if (((modelVar_CSRHGATD_i==0)&&(modelVar_CTATGATD_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PGATD_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PGATD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat_d*tmp);
            asrh = (modelVar_ftdgat_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHGATD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGATD_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartgat_d*((wdep*modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGATD_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT_d*(((modelVar_VBIRGATD_i-vbbt)*modelVar_wdepnulrinvgat_d)/tmp));
            if ((fabs(((-modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGATD_i*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGATD_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRGATD_i)))
            {
              if ((modelVar_PBRGATD_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvgat_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGATD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat_d+((vav+(0.999*modelVar_VBRGATD_i))*modelVar_slopegat_d));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I2 = (((instanceVar_ABDRAIN_i*ijunbot)+(instanceVar_LSDRAIN_i*ijunsti))+(instanceVar_LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABDRAIN_i==0)&&(instanceVar_LSDRAIN_i==0))&&(instanceVar_LGDRAIN_i==0))))
        {
          h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
          h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
          h2d = (V3+(instanceVar_vch_d*h2));
          h3 = (instanceVar_vfmin_d+h2d);
          h4 = (instanceVar_vfmin_d-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V3*instanceVar_vfmin_d)/(h3+h5)));
          if ((V3<instanceVar_VMAX_d))
          {
            if ((fabs((0.5*(V3*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V3*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V3*modelVar_phitdinv))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V3-instanceVar_VMAX_d)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V3>0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              AdmsSensFadType value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V3)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_d-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V3-instanceVar_vbbtlim_d)*(V3-instanceVar_vbbtlim_d))+((4*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V3+instanceVar_vbbtlim_d)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V3)*(V3))+((4*1E-6)*1E-6)));
            vav = (0.5*((V3)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABDRAIN_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvbot_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot_d*(1-tmp))+(modelVar_qpref2bot_d*(V3-vj)));
          id = (modelVar_idsatbot_d*idmult);
          if (((modelVar_CSRHBOTD_i==0)&&(modelVar_CTATBOTD_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PBOTD_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PBOTD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot_d*tmp);
            asrh = (modelVar_ftdbot_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHBOTD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOTD_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartbot_d*((wdep*modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOTD_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT_d*(((modelVar_VBIRBOTD_i-vbbt)*modelVar_wdepnulrinvbot_d)/tmp));
            if ((fabs(((-modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOTD_i*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOTD_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRBOTD_i)))
            {
              if ((modelVar_PBRBOTD_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvbot_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOTD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot_d+((vav+(0.999*modelVar_VBRBOTD_i))*modelVar_slopebot_d));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSDRAIN_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvsti_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti_d*(1-tmp))+(modelVar_qpref2sti_d*(V3-vj)));
          id = (modelVar_idsatsti_d*idmult);
          if (((modelVar_CSRHSTID_i==0)&&(modelVar_CTATSTID_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PSTID_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PSTID_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti_d*tmp);
            asrh = (modelVar_ftdsti_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHSTID_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTID_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartsti_d*((wdep*modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTID_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI_d*(((modelVar_VBIRSTID_i-vbbt)*modelVar_wdepnulrinvsti_d)/tmp));
            if ((fabs(((-modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTID_i*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTID_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRSTID_i)))
            {
              if ((modelVar_PBRSTID_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvsti_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTID_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti_d+((vav+(0.999*modelVar_VBRSTID_i))*modelVar_slopesti_d));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGDRAIN_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvgat_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat_d*(1-tmp))+(modelVar_qpref2gat_d*(V3-vj)));
          id = (modelVar_idsatgat_d*idmult);
          if (((modelVar_CSRHGATD_i==0)&&(modelVar_CTATGATD_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PGATD_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PGATD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat_d*tmp);
            asrh = (modelVar_ftdgat_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHGATD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGATD_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartgat_d*((wdep*modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGATD_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT_d*(((modelVar_VBIRGATD_i-vbbt)*modelVar_wdepnulrinvgat_d)/tmp));
            if ((fabs(((-modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGATD_i*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGATD_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRGATD_i)))
            {
              if ((modelVar_PBRGATD_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvgat_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGATD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat_d+((vav+(0.999*modelVar_VBRGATD_i))*modelVar_slopegat_d));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I3 = (((instanceVar_ABDRAIN_i*ijunbot)+(instanceVar_LSDRAIN_i*ijunsti))+(instanceVar_LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABDRAIN_i==0)&&(instanceVar_LSDRAIN_i==0))&&(instanceVar_LGDRAIN_i==0))))
        {
          h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
          h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
          h2d = (V4+(instanceVar_vch_d*h2));
          h3 = (instanceVar_vfmin_d+h2d);
          h4 = (instanceVar_vfmin_d-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V4*instanceVar_vfmin_d)/(h3+h5)));
          if ((V4<instanceVar_VMAX_d))
          {
            if ((fabs((0.5*(V4*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V4*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V4*modelVar_phitdinv))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V4-instanceVar_VMAX_d)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V4>0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              AdmsSensFadType value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V4)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_d-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V4-instanceVar_vbbtlim_d)*(V4-instanceVar_vbbtlim_d))+((4*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V4+instanceVar_vbbtlim_d)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V4)*(V4))+((4*1E-6)*1E-6)));
            vav = (0.5*((V4)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABDRAIN_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvbot_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot_d*(1-tmp))+(modelVar_qpref2bot_d*(V4-vj)));
          id = (modelVar_idsatbot_d*idmult);
          if (((modelVar_CSRHBOTD_i==0)&&(modelVar_CTATBOTD_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PBOTD_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PBOTD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot_d*tmp);
            asrh = (modelVar_ftdbot_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHBOTD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOTD_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartbot_d*((wdep*modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOTD_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT_d*(((modelVar_VBIRBOTD_i-vbbt)*modelVar_wdepnulrinvbot_d)/tmp));
            if ((fabs(((-modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOTD_i*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOTD_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRBOTD_i)))
            {
              if ((modelVar_PBRBOTD_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvbot_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOTD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot_d+((vav+(0.999*modelVar_VBRBOTD_i))*modelVar_slopebot_d));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSDRAIN_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvsti_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti_d*(1-tmp))+(modelVar_qpref2sti_d*(V4-vj)));
          id = (modelVar_idsatsti_d*idmult);
          if (((modelVar_CSRHSTID_i==0)&&(modelVar_CTATSTID_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PSTID_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PSTID_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti_d*tmp);
            asrh = (modelVar_ftdsti_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHSTID_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTID_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartsti_d*((wdep*modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTID_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI_d*(((modelVar_VBIRSTID_i-vbbt)*modelVar_wdepnulrinvsti_d)/tmp));
            if ((fabs(((-modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTID_i*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTID_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRSTID_i)))
            {
              if ((modelVar_PBRSTID_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvsti_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTID_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti_d+((vav+(0.999*modelVar_VBRSTID_i))*modelVar_slopesti_d));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGDRAIN_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvgat_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat_d*(1-tmp))+(modelVar_qpref2gat_d*(V4-vj)));
          id = (modelVar_idsatgat_d*idmult);
          if (((modelVar_CSRHGATD_i==0)&&(modelVar_CTATGATD_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PGATD_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PGATD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat_d*tmp);
            asrh = (modelVar_ftdgat_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHGATD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGATD_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartgat_d*((wdep*modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGATD_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT_d*(((modelVar_VBIRGATD_i-vbbt)*modelVar_wdepnulrinvgat_d)/tmp));
            if ((fabs(((-modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGATD_i*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGATD_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRGATD_i)))
            {
              if ((modelVar_PBRGATD_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvgat_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGATD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat_d+((vav+(0.999*modelVar_VBRGATD_i))*modelVar_slopegat_d));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I4 = (((instanceVar_ABDRAIN_i*ijunbot)+(instanceVar_LSDRAIN_i*ijunsti))+(instanceVar_LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABDRAIN_i==0)&&(instanceVar_LSDRAIN_i==0))&&(instanceVar_LGDRAIN_i==0))))
        {
          h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
          h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
          h2d = (V5+(instanceVar_vch_d*h2));
          h3 = (instanceVar_vfmin_d+h2d);
          h4 = (instanceVar_vfmin_d-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V5*instanceVar_vfmin_d)/(h3+h5)));
          if ((V5<instanceVar_VMAX_d))
          {
            if ((fabs((0.5*(V5*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V5*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V5*modelVar_phitdinv))<(-2.3025850929940458e+02)))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1+((V5-instanceVar_VMAX_d)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1/zinv);
          if ((V5>0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
              AdmsSensFadType value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
              two_psistar = ((-V5)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_d-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V5-instanceVar_vbbtlim_d)*(V5-instanceVar_vbbtlim_d))+((4*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V5+instanceVar_vbbtlim_d)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V5)*(V5))+((4*1E-6)*1E-6)));
            vav = (0.5*((V5)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABDRAIN_i==0))
        {
          ijunbot = 0;
          qjunbot = 0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvbot_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot_d*(1-tmp))+(modelVar_qpref2bot_d*(V5-vj)));
          id = (modelVar_idsatbot_d*idmult);
          if (((modelVar_CSRHBOTD_i==0)&&(modelVar_CTATBOTD_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PBOTD_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PBOTD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot_d*tmp);
            asrh = (modelVar_ftdbot_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHBOTD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOTD_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartbot_d*((wdep*modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOTD_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT_d*(((modelVar_VBIRBOTD_i-vbbt)*modelVar_wdepnulrinvbot_d)/tmp));
            if ((fabs(((-modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOTD_i*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOTD_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRBOTD_i)))
            {
              if ((modelVar_PBRBOTD_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvbot_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOTD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot_d+((vav+(0.999*modelVar_VBRBOTD_i))*modelVar_slopebot_d));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSDRAIN_i==0))
        {
          ijunsti = 0;
          qjunsti = 0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvsti_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti_d*(1-tmp))+(modelVar_qpref2sti_d*(V5-vj)));
          id = (modelVar_idsatsti_d*idmult);
          if (((modelVar_CSRHSTID_i==0)&&(modelVar_CTATSTID_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PSTID_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PSTID_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti_d*tmp);
            asrh = (modelVar_ftdsti_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHSTID_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTID_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartsti_d*((wdep*modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTID_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI_d*(((modelVar_VBIRSTID_i-vbbt)*modelVar_wdepnulrinvsti_d)/tmp));
            if ((fabs(((-modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTID_i*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTID_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRSTID_i)))
            {
              if ((modelVar_PBRSTID_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvsti_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTID_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti_d+((vav+(0.999*modelVar_VBRSTID_i))*modelVar_slopesti_d));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGDRAIN_i==0))
        {
          ijungat = 0;
          qjungat = 0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvgat_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat_d*(1-tmp))+(modelVar_qpref2gat_d*(V5-vj)));
          id = (modelVar_idsatgat_d*idmult);
          if (((modelVar_CSRHGATD_i==0)&&(modelVar_CTATGATD_i==0)))
          {
            isrh = 0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1-value_sqrt_0);
            }
            if ((modelVar_PGATD_i==0.5))
            {
              dwsrh = 0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PGATD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat_d*tmp);
            asrh = (modelVar_ftdgat_d*((zinv-1)*wdep));
            isrh = (modelVar_CSRHGATD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGATD_i==0))
          {
            itat = 0;
          }
          else
          {
            btat = (modelVar_btatpartgat_d*((wdep*modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d)==(-1)))
            {
              wgamma = (1/(1+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0))
            {
              terfc = (1/(1+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1/(1-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGATD_i==0))
          {
            ibbt = 0;
          }
          else
          {
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT_d*(((modelVar_VBIRGATD_i-vbbt)*modelVar_wdepnulrinvgat_d)/tmp));
            if ((fabs(((-modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat_d)/Fmaxr)<(-2.3025850929940458e+02)))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGATD_i*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGATD_i>1000))
          {
            fbreakdown = 1;
          }
          else
          {
            if ((vav>((-0.999)*modelVar_VBRGATD_i)))
            {
              if ((modelVar_PBRGATD_i==4))
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvgat_d));
                  tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                }
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGATD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1/(1-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat_d+((vav+(0.999*modelVar_VBRGATD_i))*modelVar_slopegat_d));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I5 = (((instanceVar_ABDRAIN_i*ijunbot)+(instanceVar_LSDRAIN_i*ijunsti))+(instanceVar_LGDRAIN_i*ijungat));
        instanceVar_ISATFOR1_d = (((instanceVar_ABDRAIN_i*modelVar_idsatbot_d)+(instanceVar_LSDRAIN_i*modelVar_idsatsti_d))+(instanceVar_LGDRAIN_i*modelVar_idsatgat_d));
        {
          AdmsSensFadType value_exp_0 = exp(((V4*modelVar_phitdinv)*instanceVar_MFOR1_d));
          I4_cor = (I4-(instanceVar_ISATFOR1_d*(value_exp_0-1.0)));
        }
        {
          AdmsSensFadType value_exp_0 = exp(((V5*modelVar_phitdinv)*instanceVar_MFOR1_d));
          I5_cor = (I5-(instanceVar_ISATFOR1_d*(value_exp_0-1.0)));
        }
        if ((!(((instanceVar_ABDRAIN_i==0)&&(instanceVar_LSDRAIN_i==0))&&(instanceVar_LGDRAIN_i==0))))
        {
          if (((I4>0)&&(I5>0)))
          {
            if ((((((I4_cor/I4)>0.001)||((I5_cor/I5)>0.001))&&(I4_cor>0))&&(I5_cor>0)))
            {
              alphaje = (I4_cor/I5_cor);
              {
                AdmsSensFadType value_log_0 = log(alphaje);
                instanceVar_MFOR2_d = ((modelVar_phitd*value_log_0)/(V4-V5));
              }
              {
                AdmsSensFadType value_exp_0 = exp(((V4*modelVar_phitdinv)*instanceVar_MFOR2_d));
                instanceVar_ISATFOR2_d = (I4_cor/(value_exp_0-1));
              }
            }
          }
          {
            AdmsSensFadType value_exp_0 = exp(((V1*modelVar_phitdinv)*instanceVar_MFOR1_d));
            AdmsSensFadType value_exp_1 = exp(((V1*modelVar_phitdinv)*instanceVar_MFOR2_d));
            I1_cor = ((I1-(instanceVar_ISATFOR1_d*(value_exp_0-1.0)))-(instanceVar_ISATFOR2_d*(value_exp_1-1.0)));
          }
          {
            AdmsSensFadType value_exp_0 = exp(((V2*modelVar_phitdinv)*instanceVar_MFOR1_d));
            AdmsSensFadType value_exp_1 = exp(((V2*modelVar_phitdinv)*instanceVar_MFOR2_d));
            I2_cor = ((I2-(instanceVar_ISATFOR1_d*(value_exp_0-1.0)))-(instanceVar_ISATFOR2_d*(value_exp_1-1.0)));
          }
          {
            AdmsSensFadType value_exp_0 = exp(((V3*modelVar_phitdinv)*instanceVar_MFOR1_d));
            AdmsSensFadType value_exp_1 = exp(((V3*modelVar_phitdinv)*instanceVar_MFOR2_d));
            I3_cor = ((I3-(instanceVar_ISATFOR1_d*(value_exp_0-1.0)))-(instanceVar_ISATFOR2_d*(value_exp_1-1.0)));
          }
          if ((((I1<0)&&(I2<0))&&(I3<0)))
          {
            if ((((((((I1_cor/I1)>0.001)||((I2_cor/I2)>0.001))||((I3_cor/I3)>0.001))&&(I1_cor<0))&&(I2_cor<0))&&(I3_cor<0)))
            {
              alphaje = (I1_cor/I2_cor);
              {
                AdmsSensFadType value_log_0 = log(alphaje);
                m0_rev = (((-modelVar_phitd)*value_log_0)/(V1-V2));
              }
              tt0 = (V2/(V2-V1));
              {
                AdmsSensFadType value_pow_0 = pow(alphaje,tt0);
                tt1 = ((modelVar_phitd*(alphaje-1))*(value_pow_0-1));
              }
              tt0 = (V1/(V1-V2));
              {
                AdmsSensFadType value_pow_0 = pow(alphaje,tt0);
                tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
              }
              mcor_rev = (tt1/tt2);
              instanceVar_MREV_d = (m0_rev+mcor_rev);
              if ((fabs(((V3*modelVar_phitdinv)*instanceVar_MREV_d))<1e-6))
              {
                instanceVar_m0flag_d = 1.0;
                instanceVar_ISATREV_d = (I3_cor*((1/V3)+((0.5*modelVar_phitdinv)*instanceVar_MREV_d)));
                instanceVar_MREV_d = (((((-0.5)*I3_cor)*instanceVar_MREV_d)*modelVar_phitdinv)/V3);
              }
              else
              {
                instanceVar_m0flag_d = 0.0;
                {
                  AdmsSensFadType value_exp_0 = exp((((-V3)*modelVar_phitdinv)*instanceVar_MREV_d));
                  instanceVar_ISATREV_d = ((-I3_cor)/(value_exp_0-1));
                }
              }
            }
          }
        }
        zfrac = (modelVar_FJUNQD_i*(((instanceVar_ABDRAIN_i*modelVar_cjobot_d)+(instanceVar_LSDRAIN_i*modelVar_cjosti_d))+(instanceVar_LGDRAIN_i*modelVar_cjogat_d)));
        if (((instanceVar_ABDRAIN_i*modelVar_cjobot_d)<=zfrac))
        {
          instanceVar_zflagbot_d = 0.0;
        }
        if (((instanceVar_LSDRAIN_i*modelVar_cjosti_d)<=zfrac))
        {
          instanceVar_zflagsti_d = 0.0;
        }
        if (((instanceVar_LGDRAIN_i*modelVar_cjogat_d)<=zfrac))
        {
          instanceVar_zflaggat_d = 0.0;
        }
        if ((!(((instanceVar_ABDRAIN_i==0)&&(instanceVar_LSDRAIN_i==0))&&(instanceVar_LGDRAIN_i==0))))
        {
          {
            AdmsSensFadType value_log_0 = log(((0.5*modelVar_IMAX_i)/(instanceVar_ISATFOR1_d+1e-21)));
            instanceVar_xhighf1_d = value_log_0;
          }
          {
            AdmsSensFadType value_log_0 = log(((0.5*modelVar_IMAX_i)/(instanceVar_ISATFOR2_d+1e-21)));
            instanceVar_xhighf2_d = value_log_0;
          }
          {
            AdmsSensFadType value_fabs_0 = fabs(instanceVar_ISATREV_d);
            AdmsSensFadType value_log_1 = log(((0.5*modelVar_IMAX_i)/(value_fabs_0+1e-21)));
            instanceVar_xhighr_d = value_log_1;
          }
        }
        {
          AdmsSensFadType value_min_0 = std::min(instanceVar_xhighf1_d,static_cast<double>(2.3025850929940458e+02));
          instanceVar_xhighf1_d = value_min_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_xhighf1_d);
          instanceVar_expxhf1_d = value_exp_0;
        }
        {
          AdmsSensFadType value_min_0 = std::min(instanceVar_xhighf2_d,static_cast<double>(2.3025850929940458e+02));
          instanceVar_xhighf2_d = value_min_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_xhighf2_d);
          instanceVar_expxhf2_d = value_exp_0;
        }
        {
          AdmsSensFadType value_min_0 = std::min(instanceVar_xhighr_d,static_cast<double>(2.3025850929940458e+02));
          instanceVar_xhighr_d = value_min_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_xhighr_d);
          instanceVar_expxhr_d = value_exp_0;
        }
      }
      // End block JUNCAPexpressInit
    }
  }
  // End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   AdmsSensFadType & modelPar_TYPE,
   bool modelPar_given_TYPE,
   AdmsSensFadType & modelPar_TR,
   bool modelPar_given_TR,
   AdmsSensFadType & modelPar_SWIGATE,
   bool modelPar_given_SWIGATE,
   AdmsSensFadType & modelPar_SWIMPACT,
   bool modelPar_given_SWIMPACT,
   AdmsSensFadType & modelPar_SWGIDL,
   bool modelPar_given_SWGIDL,
   AdmsSensFadType & modelPar_SWJUNCAP,
   bool modelPar_given_SWJUNCAP,
   AdmsSensFadType & modelPar_SWJUNASYM,
   bool modelPar_given_SWJUNASYM,
   AdmsSensFadType & modelPar_QMC,
   bool modelPar_given_QMC,
   AdmsSensFadType & modelPar_LVARO,
   bool modelPar_given_LVARO,
   AdmsSensFadType & modelPar_LVARL,
   bool modelPar_given_LVARL,
   AdmsSensFadType & modelPar_LVARW,
   bool modelPar_given_LVARW,
   AdmsSensFadType & modelPar_LAP,
   bool modelPar_given_LAP,
   AdmsSensFadType & modelPar_WVARO,
   bool modelPar_given_WVARO,
   AdmsSensFadType & modelPar_WVARL,
   bool modelPar_given_WVARL,
   AdmsSensFadType & modelPar_WVARW,
   bool modelPar_given_WVARW,
   AdmsSensFadType & modelPar_WOT,
   bool modelPar_given_WOT,
   AdmsSensFadType & modelPar_DLQ,
   bool modelPar_given_DLQ,
   AdmsSensFadType & modelPar_DWQ,
   bool modelPar_given_DWQ,
   AdmsSensFadType & modelPar_VFBO,
   bool modelPar_given_VFBO,
   AdmsSensFadType & modelPar_VFBL,
   bool modelPar_given_VFBL,
   AdmsSensFadType & modelPar_VFBW,
   bool modelPar_given_VFBW,
   AdmsSensFadType & modelPar_VFBLW,
   bool modelPar_given_VFBLW,
   AdmsSensFadType & modelPar_STVFBO,
   bool modelPar_given_STVFBO,
   AdmsSensFadType & modelPar_STVFBL,
   bool modelPar_given_STVFBL,
   AdmsSensFadType & modelPar_STVFBW,
   bool modelPar_given_STVFBW,
   AdmsSensFadType & modelPar_STVFBLW,
   bool modelPar_given_STVFBLW,
   AdmsSensFadType & modelPar_TOXO,
   bool modelPar_given_TOXO,
   AdmsSensFadType & modelPar_EPSROXO,
   bool modelPar_given_EPSROXO,
   AdmsSensFadType & modelPar_NSUBO,
   bool modelPar_given_NSUBO,
   AdmsSensFadType & modelPar_NSUBW,
   bool modelPar_given_NSUBW,
   AdmsSensFadType & modelPar_WSEG,
   bool modelPar_given_WSEG,
   AdmsSensFadType & modelPar_NPCK,
   bool modelPar_given_NPCK,
   AdmsSensFadType & modelPar_NPCKW,
   bool modelPar_given_NPCKW,
   AdmsSensFadType & modelPar_WSEGP,
   bool modelPar_given_WSEGP,
   AdmsSensFadType & modelPar_LPCK,
   bool modelPar_given_LPCK,
   AdmsSensFadType & modelPar_LPCKW,
   bool modelPar_given_LPCKW,
   AdmsSensFadType & modelPar_FOL1,
   bool modelPar_given_FOL1,
   AdmsSensFadType & modelPar_FOL2,
   bool modelPar_given_FOL2,
   AdmsSensFadType & modelPar_VNSUBO,
   bool modelPar_given_VNSUBO,
   AdmsSensFadType & modelPar_NSLPO,
   bool modelPar_given_NSLPO,
   AdmsSensFadType & modelPar_DNSUBO,
   bool modelPar_given_DNSUBO,
   AdmsSensFadType & modelPar_DPHIBO,
   bool modelPar_given_DPHIBO,
   AdmsSensFadType & modelPar_DPHIBL,
   bool modelPar_given_DPHIBL,
   AdmsSensFadType & modelPar_DPHIBLEXP,
   bool modelPar_given_DPHIBLEXP,
   AdmsSensFadType & modelPar_DPHIBW,
   bool modelPar_given_DPHIBW,
   AdmsSensFadType & modelPar_DPHIBLW,
   bool modelPar_given_DPHIBLW,
   AdmsSensFadType & modelPar_NPO,
   bool modelPar_given_NPO,
   AdmsSensFadType & modelPar_NPL,
   bool modelPar_given_NPL,
   AdmsSensFadType & modelPar_CTO,
   bool modelPar_given_CTO,
   AdmsSensFadType & modelPar_CTL,
   bool modelPar_given_CTL,
   AdmsSensFadType & modelPar_CTLEXP,
   bool modelPar_given_CTLEXP,
   AdmsSensFadType & modelPar_CTW,
   bool modelPar_given_CTW,
   AdmsSensFadType & modelPar_CTLW,
   bool modelPar_given_CTLW,
   AdmsSensFadType & modelPar_TOXOVO,
   bool modelPar_given_TOXOVO,
   AdmsSensFadType & modelPar_TOXOVDO,
   bool modelPar_given_TOXOVDO,
   AdmsSensFadType & modelPar_LOV,
   bool modelPar_given_LOV,
   AdmsSensFadType & modelPar_LOVD,
   bool modelPar_given_LOVD,
   AdmsSensFadType & modelPar_NOVO,
   bool modelPar_given_NOVO,
   AdmsSensFadType & modelPar_NOVDO,
   bool modelPar_given_NOVDO,
   AdmsSensFadType & modelPar_CFL,
   bool modelPar_given_CFL,
   AdmsSensFadType & modelPar_CFLEXP,
   bool modelPar_given_CFLEXP,
   AdmsSensFadType & modelPar_CFW,
   bool modelPar_given_CFW,
   AdmsSensFadType & modelPar_CFBO,
   bool modelPar_given_CFBO,
   AdmsSensFadType & modelPar_UO,
   bool modelPar_given_UO,
   AdmsSensFadType & modelPar_FBET1,
   bool modelPar_given_FBET1,
   AdmsSensFadType & modelPar_FBET1W,
   bool modelPar_given_FBET1W,
   AdmsSensFadType & modelPar_LP1,
   bool modelPar_given_LP1,
   AdmsSensFadType & modelPar_LP1W,
   bool modelPar_given_LP1W,
   AdmsSensFadType & modelPar_FBET2,
   bool modelPar_given_FBET2,
   AdmsSensFadType & modelPar_LP2,
   bool modelPar_given_LP2,
   AdmsSensFadType & modelPar_BETW1,
   bool modelPar_given_BETW1,
   AdmsSensFadType & modelPar_BETW2,
   bool modelPar_given_BETW2,
   AdmsSensFadType & modelPar_WBET,
   bool modelPar_given_WBET,
   AdmsSensFadType & modelPar_STBETO,
   bool modelPar_given_STBETO,
   AdmsSensFadType & modelPar_STBETL,
   bool modelPar_given_STBETL,
   AdmsSensFadType & modelPar_STBETW,
   bool modelPar_given_STBETW,
   AdmsSensFadType & modelPar_STBETLW,
   bool modelPar_given_STBETLW,
   AdmsSensFadType & modelPar_MUEO,
   bool modelPar_given_MUEO,
   AdmsSensFadType & modelPar_MUEW,
   bool modelPar_given_MUEW,
   AdmsSensFadType & modelPar_STMUEO,
   bool modelPar_given_STMUEO,
   AdmsSensFadType & modelPar_THEMUO,
   bool modelPar_given_THEMUO,
   AdmsSensFadType & modelPar_STTHEMUO,
   bool modelPar_given_STTHEMUO,
   AdmsSensFadType & modelPar_CSO,
   bool modelPar_given_CSO,
   AdmsSensFadType & modelPar_CSL,
   bool modelPar_given_CSL,
   AdmsSensFadType & modelPar_CSLEXP,
   bool modelPar_given_CSLEXP,
   AdmsSensFadType & modelPar_CSW,
   bool modelPar_given_CSW,
   AdmsSensFadType & modelPar_CSLW,
   bool modelPar_given_CSLW,
   AdmsSensFadType & modelPar_STCSO,
   bool modelPar_given_STCSO,
   AdmsSensFadType & modelPar_XCORO,
   bool modelPar_given_XCORO,
   AdmsSensFadType & modelPar_XCORL,
   bool modelPar_given_XCORL,
   AdmsSensFadType & modelPar_XCORW,
   bool modelPar_given_XCORW,
   AdmsSensFadType & modelPar_XCORLW,
   bool modelPar_given_XCORLW,
   AdmsSensFadType & modelPar_STXCORO,
   bool modelPar_given_STXCORO,
   AdmsSensFadType & modelPar_FETAO,
   bool modelPar_given_FETAO,
   AdmsSensFadType & modelPar_RSW1,
   bool modelPar_given_RSW1,
   AdmsSensFadType & modelPar_RSW2,
   bool modelPar_given_RSW2,
   AdmsSensFadType & modelPar_STRSO,
   bool modelPar_given_STRSO,
   AdmsSensFadType & modelPar_RSBO,
   bool modelPar_given_RSBO,
   AdmsSensFadType & modelPar_RSGO,
   bool modelPar_given_RSGO,
   AdmsSensFadType & modelPar_THESATO,
   bool modelPar_given_THESATO,
   AdmsSensFadType & modelPar_THESATL,
   bool modelPar_given_THESATL,
   AdmsSensFadType & modelPar_THESATLEXP,
   bool modelPar_given_THESATLEXP,
   AdmsSensFadType & modelPar_THESATW,
   bool modelPar_given_THESATW,
   AdmsSensFadType & modelPar_THESATLW,
   bool modelPar_given_THESATLW,
   AdmsSensFadType & modelPar_STTHESATO,
   bool modelPar_given_STTHESATO,
   AdmsSensFadType & modelPar_STTHESATL,
   bool modelPar_given_STTHESATL,
   AdmsSensFadType & modelPar_STTHESATW,
   bool modelPar_given_STTHESATW,
   AdmsSensFadType & modelPar_STTHESATLW,
   bool modelPar_given_STTHESATLW,
   AdmsSensFadType & modelPar_THESATBO,
   bool modelPar_given_THESATBO,
   AdmsSensFadType & modelPar_THESATGO,
   bool modelPar_given_THESATGO,
   AdmsSensFadType & modelPar_AXO,
   bool modelPar_given_AXO,
   AdmsSensFadType & modelPar_AXL,
   bool modelPar_given_AXL,
   AdmsSensFadType & modelPar_ALPL,
   bool modelPar_given_ALPL,
   AdmsSensFadType & modelPar_ALPLEXP,
   bool modelPar_given_ALPLEXP,
   AdmsSensFadType & modelPar_ALPW,
   bool modelPar_given_ALPW,
   AdmsSensFadType & modelPar_ALP1L1,
   bool modelPar_given_ALP1L1,
   AdmsSensFadType & modelPar_ALP1LEXP,
   bool modelPar_given_ALP1LEXP,
   AdmsSensFadType & modelPar_ALP1L2,
   bool modelPar_given_ALP1L2,
   AdmsSensFadType & modelPar_ALP1W,
   bool modelPar_given_ALP1W,
   AdmsSensFadType & modelPar_ALP2L1,
   bool modelPar_given_ALP2L1,
   AdmsSensFadType & modelPar_ALP2LEXP,
   bool modelPar_given_ALP2LEXP,
   AdmsSensFadType & modelPar_ALP2L2,
   bool modelPar_given_ALP2L2,
   AdmsSensFadType & modelPar_ALP2W,
   bool modelPar_given_ALP2W,
   AdmsSensFadType & modelPar_VPO,
   bool modelPar_given_VPO,
   AdmsSensFadType & modelPar_A1O,
   bool modelPar_given_A1O,
   AdmsSensFadType & modelPar_A1L,
   bool modelPar_given_A1L,
   AdmsSensFadType & modelPar_A1W,
   bool modelPar_given_A1W,
   AdmsSensFadType & modelPar_A2O,
   bool modelPar_given_A2O,
   AdmsSensFadType & modelPar_STA2O,
   bool modelPar_given_STA2O,
   AdmsSensFadType & modelPar_A3O,
   bool modelPar_given_A3O,
   AdmsSensFadType & modelPar_A3L,
   bool modelPar_given_A3L,
   AdmsSensFadType & modelPar_A3W,
   bool modelPar_given_A3W,
   AdmsSensFadType & modelPar_A4O,
   bool modelPar_given_A4O,
   AdmsSensFadType & modelPar_A4L,
   bool modelPar_given_A4L,
   AdmsSensFadType & modelPar_A4W,
   bool modelPar_given_A4W,
   AdmsSensFadType & modelPar_GCOO,
   bool modelPar_given_GCOO,
   AdmsSensFadType & modelPar_IGINVLW,
   bool modelPar_given_IGINVLW,
   AdmsSensFadType & modelPar_IGOVW,
   bool modelPar_given_IGOVW,
   AdmsSensFadType & modelPar_IGOVDW,
   bool modelPar_given_IGOVDW,
   AdmsSensFadType & modelPar_STIGO,
   bool modelPar_given_STIGO,
   AdmsSensFadType & modelPar_GC2O,
   bool modelPar_given_GC2O,
   AdmsSensFadType & modelPar_GC3O,
   bool modelPar_given_GC3O,
   AdmsSensFadType & modelPar_CHIBO,
   bool modelPar_given_CHIBO,
   AdmsSensFadType & modelPar_AGIDLW,
   bool modelPar_given_AGIDLW,
   AdmsSensFadType & modelPar_AGIDLDW,
   bool modelPar_given_AGIDLDW,
   AdmsSensFadType & modelPar_BGIDLO,
   bool modelPar_given_BGIDLO,
   AdmsSensFadType & modelPar_BGIDLDO,
   bool modelPar_given_BGIDLDO,
   AdmsSensFadType & modelPar_STBGIDLO,
   bool modelPar_given_STBGIDLO,
   AdmsSensFadType & modelPar_STBGIDLDO,
   bool modelPar_given_STBGIDLDO,
   AdmsSensFadType & modelPar_CGIDLO,
   bool modelPar_given_CGIDLO,
   AdmsSensFadType & modelPar_CGIDLDO,
   bool modelPar_given_CGIDLDO,
   AdmsSensFadType & modelPar_CGBOVL,
   bool modelPar_given_CGBOVL,
   AdmsSensFadType & modelPar_CFRW,
   bool modelPar_given_CFRW,
   AdmsSensFadType & modelPar_CFRDW,
   bool modelPar_given_CFRDW,
   AdmsSensFadType & modelPar_FNTO,
   bool modelPar_given_FNTO,
   AdmsSensFadType & modelPar_FNTEXCL,
   bool modelPar_given_FNTEXCL,
   AdmsSensFadType & modelPar_NFALW,
   bool modelPar_given_NFALW,
   AdmsSensFadType & modelPar_NFBLW,
   bool modelPar_given_NFBLW,
   AdmsSensFadType & modelPar_NFCLW,
   bool modelPar_given_NFCLW,
   AdmsSensFadType & modelPar_EFO,
   bool modelPar_given_EFO,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_ALPNOI,
   bool modelPar_given_ALPNOI,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_KVTHOWEO,
   bool modelPar_given_KVTHOWEO,
   AdmsSensFadType & modelPar_KVTHOWEL,
   bool modelPar_given_KVTHOWEL,
   AdmsSensFadType & modelPar_KVTHOWEW,
   bool modelPar_given_KVTHOWEW,
   AdmsSensFadType & modelPar_KVTHOWELW,
   bool modelPar_given_KVTHOWELW,
   AdmsSensFadType & modelPar_KUOWEO,
   bool modelPar_given_KUOWEO,
   AdmsSensFadType & modelPar_KUOWEL,
   bool modelPar_given_KUOWEL,
   AdmsSensFadType & modelPar_KUOWEW,
   bool modelPar_given_KUOWEW,
   AdmsSensFadType & modelPar_KUOWELW,
   bool modelPar_given_KUOWELW,
   AdmsSensFadType & modelPar_LMIN,
   bool modelPar_given_LMIN,
   AdmsSensFadType & modelPar_LMAX,
   bool modelPar_given_LMAX,
   AdmsSensFadType & modelPar_WMIN,
   bool modelPar_given_WMIN,
   AdmsSensFadType & modelPar_WMAX,
   bool modelPar_given_WMAX,
   AdmsSensFadType & modelPar_RGO,
   bool modelPar_given_RGO,
   AdmsSensFadType & modelPar_RBULKO,
   bool modelPar_given_RBULKO,
   AdmsSensFadType & modelPar_RWELLO,
   bool modelPar_given_RWELLO,
   AdmsSensFadType & modelPar_RJUNSO,
   bool modelPar_given_RJUNSO,
   AdmsSensFadType & modelPar_RJUNDO,
   bool modelPar_given_RJUNDO,
   AdmsSensFadType & modelPar_RINT,
   bool modelPar_given_RINT,
   AdmsSensFadType & modelPar_RVPOLY,
   bool modelPar_given_RVPOLY,
   AdmsSensFadType & modelPar_RSHG,
   bool modelPar_given_RSHG,
   AdmsSensFadType & modelPar_DLSIL,
   bool modelPar_given_DLSIL,
   AdmsSensFadType & modelPar_SAREF,
   bool modelPar_given_SAREF,
   AdmsSensFadType & modelPar_SBREF,
   bool modelPar_given_SBREF,
   AdmsSensFadType & modelPar_WLOD,
   bool modelPar_given_WLOD,
   AdmsSensFadType & modelPar_KUO,
   bool modelPar_given_KUO,
   AdmsSensFadType & modelPar_KVSAT,
   bool modelPar_given_KVSAT,
   AdmsSensFadType & modelPar_TKUO,
   bool modelPar_given_TKUO,
   AdmsSensFadType & modelPar_LKUO,
   bool modelPar_given_LKUO,
   AdmsSensFadType & modelPar_WKUO,
   bool modelPar_given_WKUO,
   AdmsSensFadType & modelPar_PKUO,
   bool modelPar_given_PKUO,
   AdmsSensFadType & modelPar_LLODKUO,
   bool modelPar_given_LLODKUO,
   AdmsSensFadType & modelPar_WLODKUO,
   bool modelPar_given_WLODKUO,
   AdmsSensFadType & modelPar_KVTHO,
   bool modelPar_given_KVTHO,
   AdmsSensFadType & modelPar_LKVTHO,
   bool modelPar_given_LKVTHO,
   AdmsSensFadType & modelPar_WKVTHO,
   bool modelPar_given_WKVTHO,
   AdmsSensFadType & modelPar_PKVTHO,
   bool modelPar_given_PKVTHO,
   AdmsSensFadType & modelPar_LLODVTH,
   bool modelPar_given_LLODVTH,
   AdmsSensFadType & modelPar_WLODVTH,
   bool modelPar_given_WLODVTH,
   AdmsSensFadType & modelPar_STETAO,
   bool modelPar_given_STETAO,
   AdmsSensFadType & modelPar_LODETAO,
   bool modelPar_given_LODETAO,
   AdmsSensFadType & modelPar_SCREF,
   bool modelPar_given_SCREF,
   AdmsSensFadType & modelPar_WEB,
   bool modelPar_given_WEB,
   AdmsSensFadType & modelPar_WEC,
   bool modelPar_given_WEC,
   AdmsSensFadType & modelPar_IMAX,
   bool modelPar_given_IMAX,
   AdmsSensFadType & modelPar_TRJ,
   bool modelPar_given_TRJ,
   AdmsSensFadType & modelPar_CJORBOT,
   bool modelPar_given_CJORBOT,
   AdmsSensFadType & modelPar_CJORSTI,
   bool modelPar_given_CJORSTI,
   AdmsSensFadType & modelPar_CJORGAT,
   bool modelPar_given_CJORGAT,
   AdmsSensFadType & modelPar_VBIRBOT,
   bool modelPar_given_VBIRBOT,
   AdmsSensFadType & modelPar_VBIRSTI,
   bool modelPar_given_VBIRSTI,
   AdmsSensFadType & modelPar_VBIRGAT,
   bool modelPar_given_VBIRGAT,
   AdmsSensFadType & modelPar_PBOT,
   bool modelPar_given_PBOT,
   AdmsSensFadType & modelPar_PSTI,
   bool modelPar_given_PSTI,
   AdmsSensFadType & modelPar_PGAT,
   bool modelPar_given_PGAT,
   AdmsSensFadType & modelPar_PHIGBOT,
   bool modelPar_given_PHIGBOT,
   AdmsSensFadType & modelPar_PHIGSTI,
   bool modelPar_given_PHIGSTI,
   AdmsSensFadType & modelPar_PHIGGAT,
   bool modelPar_given_PHIGGAT,
   AdmsSensFadType & modelPar_IDSATRBOT,
   bool modelPar_given_IDSATRBOT,
   AdmsSensFadType & modelPar_IDSATRSTI,
   bool modelPar_given_IDSATRSTI,
   AdmsSensFadType & modelPar_IDSATRGAT,
   bool modelPar_given_IDSATRGAT,
   AdmsSensFadType & modelPar_CSRHBOT,
   bool modelPar_given_CSRHBOT,
   AdmsSensFadType & modelPar_CSRHSTI,
   bool modelPar_given_CSRHSTI,
   AdmsSensFadType & modelPar_CSRHGAT,
   bool modelPar_given_CSRHGAT,
   AdmsSensFadType & modelPar_XJUNSTI,
   bool modelPar_given_XJUNSTI,
   AdmsSensFadType & modelPar_XJUNGAT,
   bool modelPar_given_XJUNGAT,
   AdmsSensFadType & modelPar_CTATBOT,
   bool modelPar_given_CTATBOT,
   AdmsSensFadType & modelPar_CTATSTI,
   bool modelPar_given_CTATSTI,
   AdmsSensFadType & modelPar_CTATGAT,
   bool modelPar_given_CTATGAT,
   AdmsSensFadType & modelPar_MEFFTATBOT,
   bool modelPar_given_MEFFTATBOT,
   AdmsSensFadType & modelPar_MEFFTATSTI,
   bool modelPar_given_MEFFTATSTI,
   AdmsSensFadType & modelPar_MEFFTATGAT,
   bool modelPar_given_MEFFTATGAT,
   AdmsSensFadType & modelPar_CBBTBOT,
   bool modelPar_given_CBBTBOT,
   AdmsSensFadType & modelPar_CBBTSTI,
   bool modelPar_given_CBBTSTI,
   AdmsSensFadType & modelPar_CBBTGAT,
   bool modelPar_given_CBBTGAT,
   AdmsSensFadType & modelPar_FBBTRBOT,
   bool modelPar_given_FBBTRBOT,
   AdmsSensFadType & modelPar_FBBTRSTI,
   bool modelPar_given_FBBTRSTI,
   AdmsSensFadType & modelPar_FBBTRGAT,
   bool modelPar_given_FBBTRGAT,
   AdmsSensFadType & modelPar_STFBBTBOT,
   bool modelPar_given_STFBBTBOT,
   AdmsSensFadType & modelPar_STFBBTSTI,
   bool modelPar_given_STFBBTSTI,
   AdmsSensFadType & modelPar_STFBBTGAT,
   bool modelPar_given_STFBBTGAT,
   AdmsSensFadType & modelPar_VBRBOT,
   bool modelPar_given_VBRBOT,
   AdmsSensFadType & modelPar_VBRSTI,
   bool modelPar_given_VBRSTI,
   AdmsSensFadType & modelPar_VBRGAT,
   bool modelPar_given_VBRGAT,
   AdmsSensFadType & modelPar_PBRBOT,
   bool modelPar_given_PBRBOT,
   AdmsSensFadType & modelPar_PBRSTI,
   bool modelPar_given_PBRSTI,
   AdmsSensFadType & modelPar_PBRGAT,
   bool modelPar_given_PBRGAT,
   AdmsSensFadType & modelPar_CJORBOTD,
   bool modelPar_given_CJORBOTD,
   AdmsSensFadType & modelPar_CJORSTID,
   bool modelPar_given_CJORSTID,
   AdmsSensFadType & modelPar_CJORGATD,
   bool modelPar_given_CJORGATD,
   AdmsSensFadType & modelPar_VBIRBOTD,
   bool modelPar_given_VBIRBOTD,
   AdmsSensFadType & modelPar_VBIRSTID,
   bool modelPar_given_VBIRSTID,
   AdmsSensFadType & modelPar_VBIRGATD,
   bool modelPar_given_VBIRGATD,
   AdmsSensFadType & modelPar_PBOTD,
   bool modelPar_given_PBOTD,
   AdmsSensFadType & modelPar_PSTID,
   bool modelPar_given_PSTID,
   AdmsSensFadType & modelPar_PGATD,
   bool modelPar_given_PGATD,
   AdmsSensFadType & modelPar_PHIGBOTD,
   bool modelPar_given_PHIGBOTD,
   AdmsSensFadType & modelPar_PHIGSTID,
   bool modelPar_given_PHIGSTID,
   AdmsSensFadType & modelPar_PHIGGATD,
   bool modelPar_given_PHIGGATD,
   AdmsSensFadType & modelPar_IDSATRBOTD,
   bool modelPar_given_IDSATRBOTD,
   AdmsSensFadType & modelPar_IDSATRSTID,
   bool modelPar_given_IDSATRSTID,
   AdmsSensFadType & modelPar_IDSATRGATD,
   bool modelPar_given_IDSATRGATD,
   AdmsSensFadType & modelPar_CSRHBOTD,
   bool modelPar_given_CSRHBOTD,
   AdmsSensFadType & modelPar_CSRHSTID,
   bool modelPar_given_CSRHSTID,
   AdmsSensFadType & modelPar_CSRHGATD,
   bool modelPar_given_CSRHGATD,
   AdmsSensFadType & modelPar_XJUNSTID,
   bool modelPar_given_XJUNSTID,
   AdmsSensFadType & modelPar_XJUNGATD,
   bool modelPar_given_XJUNGATD,
   AdmsSensFadType & modelPar_CTATBOTD,
   bool modelPar_given_CTATBOTD,
   AdmsSensFadType & modelPar_CTATSTID,
   bool modelPar_given_CTATSTID,
   AdmsSensFadType & modelPar_CTATGATD,
   bool modelPar_given_CTATGATD,
   AdmsSensFadType & modelPar_MEFFTATBOTD,
   bool modelPar_given_MEFFTATBOTD,
   AdmsSensFadType & modelPar_MEFFTATSTID,
   bool modelPar_given_MEFFTATSTID,
   AdmsSensFadType & modelPar_MEFFTATGATD,
   bool modelPar_given_MEFFTATGATD,
   AdmsSensFadType & modelPar_CBBTBOTD,
   bool modelPar_given_CBBTBOTD,
   AdmsSensFadType & modelPar_CBBTSTID,
   bool modelPar_given_CBBTSTID,
   AdmsSensFadType & modelPar_CBBTGATD,
   bool modelPar_given_CBBTGATD,
   AdmsSensFadType & modelPar_FBBTRBOTD,
   bool modelPar_given_FBBTRBOTD,
   AdmsSensFadType & modelPar_FBBTRSTID,
   bool modelPar_given_FBBTRSTID,
   AdmsSensFadType & modelPar_FBBTRGATD,
   bool modelPar_given_FBBTRGATD,
   AdmsSensFadType & modelPar_STFBBTBOTD,
   bool modelPar_given_STFBBTBOTD,
   AdmsSensFadType & modelPar_STFBBTSTID,
   bool modelPar_given_STFBBTSTID,
   AdmsSensFadType & modelPar_STFBBTGATD,
   bool modelPar_given_STFBBTGATD,
   AdmsSensFadType & modelPar_VBRBOTD,
   bool modelPar_given_VBRBOTD,
   AdmsSensFadType & modelPar_VBRSTID,
   bool modelPar_given_VBRSTID,
   AdmsSensFadType & modelPar_VBRGATD,
   bool modelPar_given_VBRGATD,
   AdmsSensFadType & modelPar_PBRBOTD,
   bool modelPar_given_PBRBOTD,
   AdmsSensFadType & modelPar_PBRSTID,
   bool modelPar_given_PBRSTID,
   AdmsSensFadType & modelPar_PBRGATD,
   bool modelPar_given_PBRGATD,
   AdmsSensFadType & modelPar_SWJUNEXP,
   bool modelPar_given_SWJUNEXP,
   AdmsSensFadType & modelPar_VJUNREF,
   bool modelPar_given_VJUNREF,
   AdmsSensFadType & modelPar_FJUNQ,
   bool modelPar_given_FJUNQ,
   AdmsSensFadType & modelPar_VJUNREFD,
   bool modelPar_given_VJUNREFD,
   AdmsSensFadType & modelPar_FJUNQD,
   bool modelPar_given_FJUNQD// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_NSUBO_i,
   AdmsSensFadType & modelVar_WSEG_i,
   AdmsSensFadType & modelVar_NPCK_i,
   AdmsSensFadType & modelVar_WSEGP_i,
   AdmsSensFadType & modelVar_LPCK_i,
   AdmsSensFadType & modelVar_LOV_i,
   AdmsSensFadType & modelVar_LOVD_i,
   AdmsSensFadType & modelVar_LP1_i,
   AdmsSensFadType & modelVar_LP2_i,
   AdmsSensFadType & modelVar_WBET_i,
   AdmsSensFadType & modelVar_AXL_i,
   AdmsSensFadType & modelVar_ALP1L2_i,
   AdmsSensFadType & modelVar_ALP2L2_i,
   AdmsSensFadType & modelVar_RINT_i,
   AdmsSensFadType & modelVar_RVPOLY_i,
   AdmsSensFadType & modelVar_SAREF_i,
   AdmsSensFadType & modelVar_SBREF_i,
   AdmsSensFadType & modelVar_KVSAT_i,
   AdmsSensFadType & modelVar_LLODKUO_i,
   AdmsSensFadType & modelVar_WLODKUO_i,
   AdmsSensFadType & modelVar_LLODVTH_i,
   AdmsSensFadType & modelVar_WLODVTH_i,
   AdmsSensFadType & modelVar_LODETAO_i,
   AdmsSensFadType & modelVar_SCREF_i,
   AdmsSensFadType & modelVar_WEB_i,
   AdmsSensFadType & modelVar_WEC_i,
   AdmsSensFadType & modelVar_TOX_i,
   AdmsSensFadType & modelVar_EPSROX_i,
   AdmsSensFadType & modelVar_TOXOV_i,
   AdmsSensFadType & modelVar_TOXOVD_i,
   AdmsSensFadType & modelVar_TKD,
   AdmsSensFadType & modelVar_dT,
   AdmsSensFadType & modelVar_rT,
   AdmsSensFadType & modelVar_rTn,
   AdmsSensFadType & modelVar_EPSSI,
   AdmsSensFadType & modelVar_phit,
   AdmsSensFadType & modelVar_inv_phit,
   AdmsSensFadType & modelVar_Eg,
   AdmsSensFadType & modelVar_phibFac,
   AdmsSensFadType & modelVar_nt0,
   AdmsSensFadType & modelVar_IMAX_i,
   AdmsSensFadType & modelVar_VBIRBOT_i,
   AdmsSensFadType & modelVar_VBIRSTI_i,
   AdmsSensFadType & modelVar_VBIRGAT_i,
   AdmsSensFadType & modelVar_PBOT_i,
   AdmsSensFadType & modelVar_PSTI_i,
   AdmsSensFadType & modelVar_PGAT_i,
   AdmsSensFadType & modelVar_CSRHBOT_i,
   AdmsSensFadType & modelVar_CSRHSTI_i,
   AdmsSensFadType & modelVar_CSRHGAT_i,
   AdmsSensFadType & modelVar_CTATBOT_i,
   AdmsSensFadType & modelVar_CTATSTI_i,
   AdmsSensFadType & modelVar_CTATGAT_i,
   AdmsSensFadType & modelVar_CBBTBOT_i,
   AdmsSensFadType & modelVar_CBBTSTI_i,
   AdmsSensFadType & modelVar_CBBTGAT_i,
   AdmsSensFadType & modelVar_VBRBOT_i,
   AdmsSensFadType & modelVar_VBRSTI_i,
   AdmsSensFadType & modelVar_VBRGAT_i,
   AdmsSensFadType & modelVar_PBRBOT_i,
   AdmsSensFadType & modelVar_PBRSTI_i,
   AdmsSensFadType & modelVar_PBRGAT_i,
   AdmsSensFadType & modelVar_SWJUNEXP_i,
   AdmsSensFadType & modelVar_VJUNREF_i,
   AdmsSensFadType & modelVar_FJUNQ_i,
   AdmsSensFadType & modelVar_phitr,
   AdmsSensFadType & modelVar_phitd,
   AdmsSensFadType & modelVar_phitdinv,
   AdmsSensFadType & modelVar_perfc,
   AdmsSensFadType & modelVar_berfc,
   AdmsSensFadType & modelVar_cerfc,
   AdmsSensFadType & modelVar_ftdbot,
   AdmsSensFadType & modelVar_ftdsti,
   AdmsSensFadType & modelVar_ftdgat,
   AdmsSensFadType & modelVar_idsatbot,
   AdmsSensFadType & modelVar_idsatsti,
   AdmsSensFadType & modelVar_idsatgat,
   AdmsSensFadType & modelVar_vbibot,
   AdmsSensFadType & modelVar_vbisti,
   AdmsSensFadType & modelVar_vbigat,
   AdmsSensFadType & modelVar_vbiinvbot,
   AdmsSensFadType & modelVar_vbiinvsti,
   AdmsSensFadType & modelVar_vbiinvgat,
   AdmsSensFadType & modelVar_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_minus_PGAT,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT,
   AdmsSensFadType & modelVar_cjobot,
   AdmsSensFadType & modelVar_cjosti,
   AdmsSensFadType & modelVar_cjogat,
   AdmsSensFadType & modelVar_qprefbot,
   AdmsSensFadType & modelVar_qprefsti,
   AdmsSensFadType & modelVar_qprefgat,
   AdmsSensFadType & modelVar_qpref2bot,
   AdmsSensFadType & modelVar_qpref2sti,
   AdmsSensFadType & modelVar_qpref2gat,
   AdmsSensFadType & modelVar_wdepnulrbot,
   AdmsSensFadType & modelVar_wdepnulrsti,
   AdmsSensFadType & modelVar_wdepnulrgat,
   AdmsSensFadType & modelVar_wdepnulrinvbot,
   AdmsSensFadType & modelVar_wdepnulrinvsti,
   AdmsSensFadType & modelVar_wdepnulrinvgat,
   AdmsSensFadType & modelVar_VBIRBOTinv,
   AdmsSensFadType & modelVar_VBIRSTIinv,
   AdmsSensFadType & modelVar_VBIRGATinv,
   AdmsSensFadType & modelVar_atatbot,
   AdmsSensFadType & modelVar_atatsti,
   AdmsSensFadType & modelVar_atatgat,
   AdmsSensFadType & modelVar_btatpartbot,
   AdmsSensFadType & modelVar_btatpartsti,
   AdmsSensFadType & modelVar_btatpartgat,
   AdmsSensFadType & modelVar_fbbtbot,
   AdmsSensFadType & modelVar_fbbtsti,
   AdmsSensFadType & modelVar_fbbtgat,
   AdmsSensFadType & modelVar_fstopbot,
   AdmsSensFadType & modelVar_fstopsti,
   AdmsSensFadType & modelVar_fstopgat,
   AdmsSensFadType & modelVar_VBRinvbot,
   AdmsSensFadType & modelVar_VBRinvsti,
   AdmsSensFadType & modelVar_VBRinvgat,
   AdmsSensFadType & modelVar_slopebot,
   AdmsSensFadType & modelVar_slopesti,
   AdmsSensFadType & modelVar_slopegat,
   AdmsSensFadType & modelVar_VBIRBOTD_i,
   AdmsSensFadType & modelVar_VBIRSTID_i,
   AdmsSensFadType & modelVar_VBIRGATD_i,
   AdmsSensFadType & modelVar_PBOTD_i,
   AdmsSensFadType & modelVar_PSTID_i,
   AdmsSensFadType & modelVar_PGATD_i,
   AdmsSensFadType & modelVar_CSRHBOTD_i,
   AdmsSensFadType & modelVar_CSRHSTID_i,
   AdmsSensFadType & modelVar_CSRHGATD_i,
   AdmsSensFadType & modelVar_CTATBOTD_i,
   AdmsSensFadType & modelVar_CTATSTID_i,
   AdmsSensFadType & modelVar_CTATGATD_i,
   AdmsSensFadType & modelVar_CBBTBOTD_i,
   AdmsSensFadType & modelVar_CBBTSTID_i,
   AdmsSensFadType & modelVar_CBBTGATD_i,
   AdmsSensFadType & modelVar_VBRBOTD_i,
   AdmsSensFadType & modelVar_VBRSTID_i,
   AdmsSensFadType & modelVar_VBRGATD_i,
   AdmsSensFadType & modelVar_PBRBOTD_i,
   AdmsSensFadType & modelVar_PBRSTID_i,
   AdmsSensFadType & modelVar_PBRGATD_i,
   AdmsSensFadType & modelVar_VJUNREFD_i,
   AdmsSensFadType & modelVar_FJUNQD_i,
   AdmsSensFadType & modelVar_ftdbot_d,
   AdmsSensFadType & modelVar_ftdsti_d,
   AdmsSensFadType & modelVar_ftdgat_d,
   AdmsSensFadType & modelVar_idsatbot_d,
   AdmsSensFadType & modelVar_idsatsti_d,
   AdmsSensFadType & modelVar_idsatgat_d,
   AdmsSensFadType & modelVar_vbibot_d,
   AdmsSensFadType & modelVar_vbisti_d,
   AdmsSensFadType & modelVar_vbigat_d,
   AdmsSensFadType & modelVar_vbiinvbot_d,
   AdmsSensFadType & modelVar_vbiinvsti_d,
   AdmsSensFadType & modelVar_vbiinvgat_d,
   AdmsSensFadType & modelVar_one_minus_PBOT_d,
   AdmsSensFadType & modelVar_one_minus_PSTI_d,
   AdmsSensFadType & modelVar_one_minus_PGAT_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT_d,
   AdmsSensFadType & modelVar_cjobot_d,
   AdmsSensFadType & modelVar_cjosti_d,
   AdmsSensFadType & modelVar_cjogat_d,
   AdmsSensFadType & modelVar_qprefbot_d,
   AdmsSensFadType & modelVar_qprefsti_d,
   AdmsSensFadType & modelVar_qprefgat_d,
   AdmsSensFadType & modelVar_qpref2bot_d,
   AdmsSensFadType & modelVar_qpref2sti_d,
   AdmsSensFadType & modelVar_qpref2gat_d,
   AdmsSensFadType & modelVar_wdepnulrbot_d,
   AdmsSensFadType & modelVar_wdepnulrsti_d,
   AdmsSensFadType & modelVar_wdepnulrgat_d,
   AdmsSensFadType & modelVar_wdepnulrinvbot_d,
   AdmsSensFadType & modelVar_wdepnulrinvsti_d,
   AdmsSensFadType & modelVar_wdepnulrinvgat_d,
   AdmsSensFadType & modelVar_VBIRBOTinv_d,
   AdmsSensFadType & modelVar_VBIRSTIinv_d,
   AdmsSensFadType & modelVar_VBIRGATinv_d,
   AdmsSensFadType & modelVar_atatbot_d,
   AdmsSensFadType & modelVar_atatsti_d,
   AdmsSensFadType & modelVar_atatgat_d,
   AdmsSensFadType & modelVar_btatpartbot_d,
   AdmsSensFadType & modelVar_btatpartsti_d,
   AdmsSensFadType & modelVar_btatpartgat_d,
   AdmsSensFadType & modelVar_fbbtbot_d,
   AdmsSensFadType & modelVar_fbbtsti_d,
   AdmsSensFadType & modelVar_fbbtgat_d,
   AdmsSensFadType & modelVar_fstopbot_d,
   AdmsSensFadType & modelVar_fstopsti_d,
   AdmsSensFadType & modelVar_fstopgat_d,
   AdmsSensFadType & modelVar_VBRinvbot_d,
   AdmsSensFadType & modelVar_VBRinvsti_d,
   AdmsSensFadType & modelVar_VBRinvgat_d,
   AdmsSensFadType & modelVar_slopebot_d,
   AdmsSensFadType & modelVar_slopesti_d,
   AdmsSensFadType & modelVar_slopegat_d,
   // non-reals
   int modelVar_CHNL_TYPE,
   double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
  AdmsSensFadType deltaEgat_d;
  AdmsSensFadType deltaEsti_d;
  AdmsSensFadType deltaEbot_d;
  AdmsSensFadType ubigat_d;
  AdmsSensFadType ubisti_d;
  AdmsSensFadType ubibot_d;
  AdmsSensFadType phigdgat_d;
  AdmsSensFadType phigdsti_d;
  AdmsSensFadType phigdbot_d;
  AdmsSensFadType phigrgat_d;
  AdmsSensFadType phigrsti_d;
  AdmsSensFadType phigrbot_d;
  AdmsSensFadType deltaEgat;
  AdmsSensFadType deltaEsti;
  AdmsSensFadType deltaEbot;
  AdmsSensFadType ubigat;
  AdmsSensFadType ubisti;
  AdmsSensFadType ubibot;
  AdmsSensFadType phigdgat;
  AdmsSensFadType phigdsti;
  AdmsSensFadType phigdbot;
  AdmsSensFadType deltaphigd;
  AdmsSensFadType phigrgat;
  AdmsSensFadType phigrsti;
  AdmsSensFadType phigrbot;
  AdmsSensFadType deltaphigr;
  AdmsSensFadType phitrinv;
  double KBOL_over_QELE;
  AdmsSensFadType auxt;
  AdmsSensFadType tkd;
  AdmsSensFadType tkr;
  AdmsSensFadType STFBBTGATD_i;
  AdmsSensFadType STFBBTSTID_i;
  AdmsSensFadType STFBBTBOTD_i;
  AdmsSensFadType FBBTRGATD_i;
  AdmsSensFadType FBBTRSTID_i;
  AdmsSensFadType FBBTRBOTD_i;
  AdmsSensFadType MEFFTATGATD_i;
  AdmsSensFadType MEFFTATSTID_i;
  AdmsSensFadType MEFFTATBOTD_i;
  AdmsSensFadType XJUNGATD_i;
  AdmsSensFadType XJUNSTID_i;
  AdmsSensFadType IDSATRGATD_i;
  AdmsSensFadType IDSATRSTID_i;
  AdmsSensFadType IDSATRBOTD_i;
  AdmsSensFadType PHIGGATD_i;
  AdmsSensFadType PHIGSTID_i;
  AdmsSensFadType PHIGBOTD_i;
  AdmsSensFadType CJORGATD_i;
  AdmsSensFadType CJORSTID_i;
  AdmsSensFadType CJORBOTD_i;
  AdmsSensFadType STFBBTGAT_i;
  AdmsSensFadType STFBBTSTI_i;
  AdmsSensFadType STFBBTBOT_i;
  AdmsSensFadType FBBTRGAT_i;
  AdmsSensFadType FBBTRSTI_i;
  AdmsSensFadType FBBTRBOT_i;
  AdmsSensFadType MEFFTATGAT_i;
  AdmsSensFadType MEFFTATSTI_i;
  AdmsSensFadType MEFFTATBOT_i;
  AdmsSensFadType XJUNGAT_i;
  AdmsSensFadType XJUNSTI_i;
  AdmsSensFadType IDSATRGAT_i;
  AdmsSensFadType IDSATRSTI_i;
  AdmsSensFadType IDSATRBOT_i;
  AdmsSensFadType PHIGGAT_i;
  AdmsSensFadType PHIGSTI_i;
  AdmsSensFadType PHIGBOT_i;
  AdmsSensFadType CJORGAT_i;
  AdmsSensFadType CJORSTI_i;
  AdmsSensFadType CJORBOT_i;
  AdmsSensFadType TRJ_i;
  AdmsSensFadType TKD_sq;
  AdmsSensFadType TKR;
  AdmsSensFadType TR_i;
  //Begin block initial_model
  {
    modelVar_TOX_i = adms_ternary_op<AdmsSensFadType>((modelPar_TOXO>1e-10),modelPar_TOXO,1e-10);
    modelVar_TOXOVD_i = adms_ternary_op<AdmsSensFadType>((modelPar_TOXOVDO>1e-10),modelPar_TOXOVDO,1e-10);
    modelVar_EPSROX_i = adms_ternary_op<AdmsSensFadType>((modelPar_EPSROXO>1.0),modelPar_EPSROXO,1.0);
    modelVar_NSUBO_i = adms_ternary_op<AdmsSensFadType>((modelPar_NSUBO>1e20),modelPar_NSUBO,1e20);
    modelVar_WSEG_i = adms_ternary_op<AdmsSensFadType>((modelPar_WSEG>1e-10),modelPar_WSEG,1e-10);
    modelVar_NPCK_i = adms_ternary_op<AdmsSensFadType>((modelPar_NPCK>0.0),modelPar_NPCK,0.0);
    modelVar_WSEGP_i = adms_ternary_op<AdmsSensFadType>((modelPar_WSEGP>1e-10),modelPar_WSEGP,1e-10);
    modelVar_LPCK_i = adms_ternary_op<AdmsSensFadType>((modelPar_LPCK>1e-10),modelPar_LPCK,1e-10);
    modelVar_TOXOV_i = adms_ternary_op<AdmsSensFadType>((modelPar_TOXOVO>1e-10),modelPar_TOXOVO,1e-10);
    modelVar_LOV_i = adms_ternary_op<AdmsSensFadType>((modelPar_LOV>0.0),modelPar_LOV,0.0);
    modelVar_LOVD_i = adms_ternary_op<AdmsSensFadType>((modelPar_LOVD>0.0),modelPar_LOVD,0.0);
    modelVar_LP1_i = adms_ternary_op<AdmsSensFadType>((modelPar_LP1>1e-10),modelPar_LP1,1e-10);
    modelVar_LP2_i = adms_ternary_op<AdmsSensFadType>((modelPar_LP2>1e-10),modelPar_LP2,1e-10);
    modelVar_WBET_i = adms_ternary_op<AdmsSensFadType>((modelPar_WBET>1e-10),modelPar_WBET,1e-10);
    modelVar_AXL_i = adms_ternary_op<AdmsSensFadType>((modelPar_AXL>0.0),modelPar_AXL,0.0);
    modelVar_ALP1L2_i = adms_ternary_op<AdmsSensFadType>((modelPar_ALP1L2>0.0),modelPar_ALP1L2,0.0);
    modelVar_ALP2L2_i = adms_ternary_op<AdmsSensFadType>((modelPar_ALP2L2>0.0),modelPar_ALP2L2,0.0);
    modelVar_SAREF_i = adms_ternary_op<AdmsSensFadType>((modelPar_SAREF>1e-9),modelPar_SAREF,1e-9);
    modelVar_SBREF_i = adms_ternary_op<AdmsSensFadType>((modelPar_SBREF>1e-9),modelPar_SBREF,1e-9);
    modelVar_KVSAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_KVSAT>(-1.0)),adms_ternary_op<AdmsSensFadType>((modelPar_KVSAT<1.0),modelPar_KVSAT,1.0),(-1.0));
    modelVar_LLODKUO_i = adms_ternary_op<AdmsSensFadType>((modelPar_LLODKUO>0.0),modelPar_LLODKUO,0.0);
    modelVar_WLODKUO_i = adms_ternary_op<AdmsSensFadType>((modelPar_WLODKUO>0.0),modelPar_WLODKUO,0.0);
    modelVar_LLODVTH_i = adms_ternary_op<AdmsSensFadType>((modelPar_LLODVTH>0.0),modelPar_LLODVTH,0.0);
    modelVar_WLODVTH_i = adms_ternary_op<AdmsSensFadType>((modelPar_WLODVTH>0.0),modelPar_WLODVTH,0.0);
    modelVar_LODETAO_i = adms_ternary_op<AdmsSensFadType>((modelPar_LODETAO>0.0),modelPar_LODETAO,0.0);
    modelVar_SCREF_i = adms_ternary_op<AdmsSensFadType>((modelPar_SCREF>0.0),modelPar_SCREF,0.0);
    modelVar_WEB_i = modelPar_WEB;
    modelVar_WEC_i = modelPar_WEC;
    modelVar_RINT_i = adms_ternary_op<AdmsSensFadType>((modelPar_RINT>0.0),modelPar_RINT,0.0);
    modelVar_RVPOLY_i = adms_ternary_op<AdmsSensFadType>((modelPar_RVPOLY>0.0),modelPar_RVPOLY,0.0);
    if ((modelPar_TYPE>=0))
    {
      modelVar_CHNL_TYPE = (+1);
    }
    else
    {
      modelVar_CHNL_TYPE = (-1);
    }
    TR_i = adms_ternary_op<AdmsSensFadType>((modelPar_TR>(-273)),modelPar_TR,(-273));
    TKR = (273.15+TR_i);
    modelVar_TKD = (admsTemperature+modelPar_DTA);
    TKD_sq = (modelVar_TKD*modelVar_TKD);
    modelVar_dT = (modelVar_TKD-TKR);
    modelVar_rT = (modelVar_TKD/TKR);
    modelVar_rTn = (TKR/modelVar_TKD);
    modelVar_phit = ((modelVar_TKD*1.3806505E-23)/1.6021918E-19);
    modelVar_inv_phit = (1.0/modelVar_phit);
    modelVar_Eg = ((1.179-(9.025e-5*modelVar_TKD))-(3.05e-7*TKD_sq));
    modelVar_phibFac = ((((1.045+(4.5e-4*modelVar_TKD))*((0.523+(1.4e-3*modelVar_TKD))-(1.48e-6*TKD_sq)))*TKD_sq)/9.0E4);
    modelVar_phibFac = adms_ternary_op<AdmsSensFadType>((modelVar_phibFac>1.0E-3),modelVar_phibFac,1.0E-3);
    modelVar_EPSSI = (8.8541878176E-12*11.8);
    modelVar_nt0 = ((4*1.3806505E-23)*modelVar_TKD);
    TRJ_i = adms_ternary_op<AdmsSensFadType>((modelPar_TRJ>(-250)),modelPar_TRJ,(-250));
    modelVar_IMAX_i = adms_ternary_op<AdmsSensFadType>((modelPar_IMAX>1E-12),modelPar_IMAX,1E-12);
    CJORBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORBOT>1E-12),modelPar_CJORBOT,1E-12);
    CJORSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORSTI>1E-18),modelPar_CJORSTI,1E-18);
    CJORGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORGAT>1E-18),modelPar_CJORGAT,1E-18);
    modelVar_VBIRBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRBOT>0.050),modelPar_VBIRBOT,0.050);
    modelVar_VBIRSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRSTI>0.050),modelPar_VBIRSTI,0.050);
    modelVar_VBIRGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRGAT>0.050),modelPar_VBIRGAT,0.050);
    modelVar_PBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBOT>0.05),adms_ternary_op<AdmsSensFadType>((modelPar_PBOT<0.95),modelPar_PBOT,0.95),0.05);
    modelVar_PSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_PSTI>0.05),adms_ternary_op<AdmsSensFadType>((modelPar_PSTI<0.95),modelPar_PSTI,0.95),0.05);
    modelVar_PGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_PGAT>0.05),adms_ternary_op<AdmsSensFadType>((modelPar_PGAT<0.95),modelPar_PGAT,0.95),0.05);
    PHIGBOT_i = modelPar_PHIGBOT;
    PHIGSTI_i = modelPar_PHIGSTI;
    PHIGGAT_i = modelPar_PHIGGAT;
    IDSATRBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRBOT>0),modelPar_IDSATRBOT,0);
    IDSATRSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRSTI>0),modelPar_IDSATRSTI,0);
    IDSATRGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRGAT>0),modelPar_IDSATRGAT,0);
    modelVar_CSRHBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHBOT>0),modelPar_CSRHBOT,0);
    modelVar_CSRHSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHSTI>0),modelPar_CSRHSTI,0);
    modelVar_CSRHGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHGAT>0),modelPar_CSRHGAT,0);
    XJUNSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_XJUNSTI>1E-9),modelPar_XJUNSTI,1E-9);
    XJUNGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_XJUNGAT>1E-9),modelPar_XJUNGAT,1E-9);
    modelVar_CTATBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATBOT>0),modelPar_CTATBOT,0);
    modelVar_CTATSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATSTI>0),modelPar_CTATSTI,0);
    modelVar_CTATGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATGAT>0),modelPar_CTATGAT,0);
    MEFFTATBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATBOT>0.01),modelPar_MEFFTATBOT,0.01);
    MEFFTATSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATSTI>0.01),modelPar_MEFFTATSTI,0.01);
    MEFFTATGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATGAT>0.01),modelPar_MEFFTATGAT,0.01);
    modelVar_CBBTBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTBOT>0),modelPar_CBBTBOT,0);
    modelVar_CBBTSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTSTI>0),modelPar_CBBTSTI,0);
    modelVar_CBBTGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTGAT>0),modelPar_CBBTGAT,0);
    FBBTRBOT_i = modelPar_FBBTRBOT;
    FBBTRSTI_i = modelPar_FBBTRSTI;
    FBBTRGAT_i = modelPar_FBBTRGAT;
    STFBBTBOT_i = modelPar_STFBBTBOT;
    STFBBTSTI_i = modelPar_STFBBTSTI;
    STFBBTGAT_i = modelPar_STFBBTGAT;
    modelVar_VBRBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRBOT>0.1),modelPar_VBRBOT,0.1);
    modelVar_VBRSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRSTI>0.1),modelPar_VBRSTI,0.1);
    modelVar_VBRGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRGAT>0.1),modelPar_VBRGAT,0.1);
    modelVar_PBRBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRBOT>0.1),modelPar_PBRBOT,0.1);
    modelVar_PBRSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRSTI>0.1),modelPar_PBRSTI,0.1);
    modelVar_PBRGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRGAT>0.1),modelPar_PBRGAT,0.1);
    modelVar_SWJUNEXP_i = 0.0;
    if ((modelPar_SWJUNEXP>0.5))
    {
      modelVar_SWJUNEXP_i = 1.0;
    }
    else
    {
      modelVar_SWJUNEXP_i = 0.0;
    }
    modelVar_VJUNREF_i = adms_ternary_op<AdmsSensFadType>((modelPar_VJUNREF>0.5),modelPar_VJUNREF,0.5);
    modelVar_FJUNQ_i = adms_ternary_op<AdmsSensFadType>((modelPar_FJUNQ>0.0),modelPar_FJUNQ,0.0);
    if ((modelPar_SWJUNASYM==0.0))
    {
      CJORBOTD_i = CJORBOT_i;
      CJORSTID_i = CJORSTI_i;
      CJORGATD_i = CJORGAT_i;
      modelVar_VBIRBOTD_i = modelVar_VBIRBOT_i;
      modelVar_VBIRSTID_i = modelVar_VBIRSTI_i;
      modelVar_VBIRGATD_i = modelVar_VBIRGAT_i;
      modelVar_PBOTD_i = modelVar_PBOT_i;
      modelVar_PSTID_i = modelVar_PSTI_i;
      modelVar_PGATD_i = modelVar_PGAT_i;
      PHIGBOTD_i = PHIGBOT_i;
      PHIGSTID_i = PHIGSTI_i;
      PHIGGATD_i = PHIGGAT_i;
      IDSATRBOTD_i = IDSATRBOT_i;
      IDSATRSTID_i = IDSATRSTI_i;
      IDSATRGATD_i = IDSATRGAT_i;
      modelVar_CSRHBOTD_i = modelVar_CSRHBOT_i;
      modelVar_CSRHSTID_i = modelVar_CSRHSTI_i;
      modelVar_CSRHGATD_i = modelVar_CSRHGAT_i;
      XJUNSTID_i = XJUNSTI_i;
      XJUNGATD_i = XJUNGAT_i;
      modelVar_CTATBOTD_i = modelVar_CTATBOT_i;
      modelVar_CTATSTID_i = modelVar_CTATSTI_i;
      modelVar_CTATGATD_i = modelVar_CTATGAT_i;
      MEFFTATBOTD_i = MEFFTATBOT_i;
      MEFFTATSTID_i = MEFFTATSTI_i;
      MEFFTATGATD_i = MEFFTATGAT_i;
      modelVar_CBBTBOTD_i = modelVar_CBBTBOT_i;
      modelVar_CBBTSTID_i = modelVar_CBBTSTI_i;
      modelVar_CBBTGATD_i = modelVar_CBBTGAT_i;
      FBBTRBOTD_i = FBBTRBOT_i;
      FBBTRSTID_i = FBBTRSTI_i;
      FBBTRGATD_i = FBBTRGAT_i;
      STFBBTBOTD_i = STFBBTBOT_i;
      STFBBTSTID_i = STFBBTSTI_i;
      STFBBTGATD_i = STFBBTGAT_i;
      modelVar_VBRBOTD_i = modelVar_VBRBOT_i;
      modelVar_VBRSTID_i = modelVar_VBRSTI_i;
      modelVar_VBRGATD_i = modelVar_VBRGAT_i;
      modelVar_PBRBOTD_i = modelVar_PBRBOT_i;
      modelVar_PBRSTID_i = modelVar_PBRSTI_i;
      modelVar_PBRGATD_i = modelVar_PBRGAT_i;
      modelVar_VJUNREFD_i = modelVar_VJUNREF_i;
      modelVar_FJUNQD_i = modelVar_FJUNQ_i;
    }
    else
    {
      CJORBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORBOTD>1E-12),modelPar_CJORBOTD,1E-12);
      CJORSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORSTID>1E-18),modelPar_CJORSTID,1E-18);
      CJORGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORGATD>1E-18),modelPar_CJORGATD,1E-18);
      modelVar_VBIRBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRBOTD>0.050),modelPar_VBIRBOTD,0.050);
      modelVar_VBIRSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRSTID>0.050),modelPar_VBIRSTID,0.050);
      modelVar_VBIRGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRGATD>0.050),modelPar_VBIRGATD,0.050);
      modelVar_PBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBOTD>0.05),adms_ternary_op<AdmsSensFadType>((modelPar_PBOTD<0.95),modelPar_PBOTD,0.95),0.05);
      modelVar_PSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_PSTID>0.05),adms_ternary_op<AdmsSensFadType>((modelPar_PSTID<0.95),modelPar_PSTID,0.95),0.05);
      modelVar_PGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_PGATD>0.05),adms_ternary_op<AdmsSensFadType>((modelPar_PGATD<0.95),modelPar_PGATD,0.95),0.05);
      PHIGBOTD_i = modelPar_PHIGBOTD;
      PHIGSTID_i = modelPar_PHIGSTID;
      PHIGGATD_i = modelPar_PHIGGATD;
      IDSATRBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRBOTD>0),modelPar_IDSATRBOTD,0);
      IDSATRSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRSTID>0),modelPar_IDSATRSTID,0);
      IDSATRGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRGATD>0),modelPar_IDSATRGATD,0);
      modelVar_CSRHBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHBOTD>0),modelPar_CSRHBOTD,0);
      modelVar_CSRHSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHSTID>0),modelPar_CSRHSTID,0);
      modelVar_CSRHGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHGATD>0),modelPar_CSRHGATD,0);
      XJUNSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_XJUNSTID>1E-9),modelPar_XJUNSTID,1E-9);
      XJUNGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_XJUNGATD>1E-9),modelPar_XJUNGATD,1E-9);
      modelVar_CTATBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATBOTD>0),modelPar_CTATBOTD,0);
      modelVar_CTATSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATSTID>0),modelPar_CTATSTID,0);
      modelVar_CTATGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATGATD>0),modelPar_CTATGATD,0);
      MEFFTATBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATBOTD>0.01),modelPar_MEFFTATBOTD,0.01);
      MEFFTATSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATSTID>0.01),modelPar_MEFFTATSTID,0.01);
      MEFFTATGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATGATD>0.01),modelPar_MEFFTATGATD,0.01);
      modelVar_CBBTBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTBOTD>0),modelPar_CBBTBOTD,0);
      modelVar_CBBTSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTSTID>0),modelPar_CBBTSTID,0);
      modelVar_CBBTGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTGATD>0),modelPar_CBBTGATD,0);
      FBBTRBOTD_i = modelPar_FBBTRBOTD;
      FBBTRSTID_i = modelPar_FBBTRSTID;
      FBBTRGATD_i = modelPar_FBBTRGATD;
      STFBBTBOTD_i = modelPar_STFBBTBOTD;
      STFBBTSTID_i = modelPar_STFBBTSTID;
      STFBBTGATD_i = modelPar_STFBBTGATD;
      modelVar_VBRBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRBOTD>0.1),modelPar_VBRBOTD,0.1);
      modelVar_VBRSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRSTID>0.1),modelPar_VBRSTID,0.1);
      modelVar_VBRGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRGATD>0.1),modelPar_VBRGATD,0.1);
      modelVar_PBRBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRBOTD>0.1),modelPar_PBRBOTD,0.1);
      modelVar_PBRSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRSTID>0.1),modelPar_PBRSTID,0.1);
      modelVar_PBRGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRGATD>0.1),modelPar_PBRGATD,0.1);
      modelVar_VJUNREFD_i = adms_ternary_op<AdmsSensFadType>((modelPar_VJUNREFD>0.5),modelPar_VJUNREFD,0.5);
      modelVar_FJUNQD_i = adms_ternary_op<AdmsSensFadType>((modelPar_FJUNQD>0.0),modelPar_FJUNQD,0.0);
    }
    tkr = (273.15+TRJ_i);
    {
      AdmsSensFadType value_max_0 = std::max((admsTemperature+modelPar_DTA),(273.15+(-250)));
      tkd = value_max_0;
    }
    auxt = (tkd/tkr);
    KBOL_over_QELE = (1.3806505E-23/1.6021918E-19);
    modelVar_phitr = (KBOL_over_QELE*tkr);
    phitrinv = (1.0/modelVar_phitr);
    modelVar_phitd = (KBOL_over_QELE*tkd);
    modelVar_phitdinv = (1.0/modelVar_phitd);
    deltaphigr = ((-((7.02e-4*tkr)*tkr))/(1108.0+tkr));
    phigrbot = (PHIGBOT_i+deltaphigr);
    phigrsti = (PHIGSTI_i+deltaphigr);
    phigrgat = (PHIGGAT_i+deltaphigr);
    deltaphigd = ((-((7.02e-4*tkd)*tkd))/(1108.0+tkd));
    phigdbot = (PHIGBOT_i+deltaphigd);
    phigdsti = (PHIGSTI_i+deltaphigd);
    phigdgat = (PHIGGAT_i+deltaphigd);
    {
      AdmsSensFadType value_pow_0 = pow(auxt,1.5);
      AdmsSensFadType value_exp_1 = exp((0.5*((phigrbot*phitrinv)-(phigdbot*modelVar_phitdinv))));
      modelVar_ftdbot = (value_pow_0*value_exp_1);
    }
    {
      AdmsSensFadType value_pow_0 = pow(auxt,1.5);
      AdmsSensFadType value_exp_1 = exp((0.5*((phigrsti*phitrinv)-(phigdsti*modelVar_phitdinv))));
      modelVar_ftdsti = (value_pow_0*value_exp_1);
    }
    {
      AdmsSensFadType value_pow_0 = pow(auxt,1.5);
      AdmsSensFadType value_exp_1 = exp((0.5*((phigrgat*phitrinv)-(phigdgat*modelVar_phitdinv))));
      modelVar_ftdgat = (value_pow_0*value_exp_1);
    }
    modelVar_idsatbot = ((IDSATRBOT_i*modelVar_ftdbot)*modelVar_ftdbot);
    modelVar_idsatsti = ((IDSATRSTI_i*modelVar_ftdsti)*modelVar_ftdsti);
    modelVar_idsatgat = ((IDSATRGAT_i*modelVar_ftdgat)*modelVar_ftdgat);
    {
      AdmsSensFadType value_log_0 = log(modelVar_ftdbot);
      ubibot = ((modelVar_VBIRBOT_i*auxt)-((2*modelVar_phitd)*value_log_0));
    }
    {
      AdmsSensFadType value_log_0 = log(modelVar_ftdsti);
      ubisti = ((modelVar_VBIRSTI_i*auxt)-((2*modelVar_phitd)*value_log_0));
    }
    {
      AdmsSensFadType value_log_0 = log(modelVar_ftdgat);
      ubigat = ((modelVar_VBIRGAT_i*auxt)-((2*modelVar_phitd)*value_log_0));
    }
    {
      AdmsSensFadType value_exp_0 = exp(((0.050-ubibot)*modelVar_phitdinv));
      AdmsSensFadType value_log_1 = log((1+value_exp_0));
      modelVar_vbibot = (ubibot+(modelVar_phitd*value_log_1));
    }
    {
      AdmsSensFadType value_exp_0 = exp(((0.050-ubisti)*modelVar_phitdinv));
      AdmsSensFadType value_log_1 = log((1+value_exp_0));
      modelVar_vbisti = (ubisti+(modelVar_phitd*value_log_1));
    }
    {
      AdmsSensFadType value_exp_0 = exp(((0.050-ubigat)*modelVar_phitdinv));
      AdmsSensFadType value_log_1 = log((1+value_exp_0));
      modelVar_vbigat = (ubigat+(modelVar_phitd*value_log_1));
    }
    modelVar_vbiinvbot = (1.0/modelVar_vbibot);
    modelVar_vbiinvsti = (1.0/modelVar_vbisti);
    modelVar_vbiinvgat = (1.0/modelVar_vbigat);
    modelVar_one_minus_PBOT = (1-modelVar_PBOT_i);
    modelVar_one_minus_PSTI = (1-modelVar_PSTI_i);
    modelVar_one_minus_PGAT = (1-modelVar_PGAT_i);
    modelVar_one_over_one_minus_PBOT = (1/modelVar_one_minus_PBOT);
    modelVar_one_over_one_minus_PSTI = (1/modelVar_one_minus_PSTI);
    modelVar_one_over_one_minus_PGAT = (1/modelVar_one_minus_PGAT);
    {
      AdmsSensFadType value_pow_0 = pow((modelVar_VBIRBOT_i*modelVar_vbiinvbot),modelVar_PBOT_i);
      modelVar_cjobot = (CJORBOT_i*value_pow_0);
    }
    {
      AdmsSensFadType value_pow_0 = pow((modelVar_VBIRSTI_i*modelVar_vbiinvsti),modelVar_PSTI_i);
      modelVar_cjosti = (CJORSTI_i*value_pow_0);
    }
    {
      AdmsSensFadType value_pow_0 = pow((modelVar_VBIRGAT_i*modelVar_vbiinvgat),modelVar_PGAT_i);
      modelVar_cjogat = (CJORGAT_i*value_pow_0);
    }
    modelVar_qprefbot = ((modelVar_cjobot*modelVar_vbibot)*modelVar_one_over_one_minus_PBOT);
    modelVar_qprefsti = ((modelVar_cjosti*modelVar_vbisti)*modelVar_one_over_one_minus_PSTI);
    modelVar_qprefgat = ((modelVar_cjogat*modelVar_vbigat)*modelVar_one_over_one_minus_PGAT);
    modelVar_qpref2bot = (2*modelVar_cjobot);
    modelVar_qpref2sti = (2*modelVar_cjosti);
    modelVar_qpref2gat = (2*modelVar_cjogat);
    modelVar_wdepnulrbot = (modelVar_EPSSI/CJORBOT_i);
    modelVar_wdepnulrsti = ((XJUNSTI_i*modelVar_EPSSI)/CJORSTI_i);
    modelVar_wdepnulrgat = ((XJUNGAT_i*modelVar_EPSSI)/CJORGAT_i);
    modelVar_wdepnulrinvbot = (1/modelVar_wdepnulrbot);
    modelVar_wdepnulrinvsti = (1/modelVar_wdepnulrsti);
    modelVar_wdepnulrinvgat = (1/modelVar_wdepnulrgat);
    modelVar_VBIRBOTinv = (1/modelVar_VBIRBOT_i);
    modelVar_VBIRSTIinv = (1/modelVar_VBIRSTI_i);
    modelVar_VBIRGATinv = (1/modelVar_VBIRGAT_i);
    modelVar_perfc = (1.77245385090551603*0.29214664);
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_perfc,(-2));
      modelVar_berfc = (((((-5)*0.29214664)+6)-value_pow_0)/3.0);
    }
    modelVar_cerfc = ((1.0-0.29214664)-modelVar_berfc);
    {
      AdmsSensFadType value_max_0 = max((0.5*phigdbot),modelVar_phitd);
      deltaEbot = value_max_0;
    }
    {
      AdmsSensFadType value_max_0 = max((0.5*phigdsti),modelVar_phitd);
      deltaEsti = value_max_0;
    }
    {
      AdmsSensFadType value_max_0 = max((0.5*phigdgat),modelVar_phitd);
      deltaEgat = value_max_0;
    }
    modelVar_atatbot = (deltaEbot*modelVar_phitdinv);
    modelVar_atatsti = (deltaEsti*modelVar_phitdinv);
    modelVar_atatgat = (deltaEgat*modelVar_phitdinv);
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((32*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*deltaEbot)));
      modelVar_btatpartbot = (value_sqrt_0/(3*1.05457168E-34));
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((32*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*deltaEsti)));
      modelVar_btatpartsti = (value_sqrt_0/(3*1.05457168E-34));
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((32*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*deltaEgat)));
      modelVar_btatpartgat = (value_sqrt_0/(3*1.05457168E-34));
    }
    modelVar_fbbtbot = (FBBTRBOT_i*(1+(STFBBTBOT_i*(tkd-tkr))));
    modelVar_fbbtsti = (FBBTRSTI_i*(1+(STFBBTSTI_i*(tkd-tkr))));
    modelVar_fbbtgat = (FBBTRGAT_i*(1+(STFBBTGAT_i*(tkd-tkr))));
    modelVar_fbbtbot = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtbot>0),modelVar_fbbtbot,0);
    modelVar_fbbtsti = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtsti>0),modelVar_fbbtsti,0);
    modelVar_fbbtgat = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtgat>0),modelVar_fbbtgat,0);
    {
      AdmsSensFadType value_pow_0 = pow(0.999,modelVar_PBRBOT_i);
      modelVar_fstopbot = (1/(1-value_pow_0));
    }
    {
      AdmsSensFadType value_pow_0 = pow(0.999,modelVar_PBRSTI_i);
      modelVar_fstopsti = (1/(1-value_pow_0));
    }
    {
      AdmsSensFadType value_pow_0 = pow(0.999,modelVar_PBRGAT_i);
      modelVar_fstopgat = (1/(1-value_pow_0));
    }
    modelVar_VBRinvbot = (1/modelVar_VBRBOT_i);
    modelVar_VBRinvsti = (1/modelVar_VBRSTI_i);
    modelVar_VBRinvgat = (1/modelVar_VBRGAT_i);
    {
      AdmsSensFadType value_pow_0 = pow(0.999,(modelVar_PBRBOT_i-1));
      modelVar_slopebot = (((-((modelVar_fstopbot*modelVar_fstopbot)*value_pow_0))*modelVar_PBRBOT_i)*modelVar_VBRinvbot);
    }
    {
      AdmsSensFadType value_pow_0 = pow(0.999,(modelVar_PBRSTI_i-1));
      modelVar_slopesti = (((-((modelVar_fstopsti*modelVar_fstopsti)*value_pow_0))*modelVar_PBRSTI_i)*modelVar_VBRinvsti);
    }
    {
      AdmsSensFadType value_pow_0 = pow(0.999,(modelVar_PBRGAT_i-1));
      modelVar_slopegat = (((-((modelVar_fstopgat*modelVar_fstopgat)*value_pow_0))*modelVar_PBRGAT_i)*modelVar_VBRinvgat);
    }
    phigrbot_d = (PHIGBOTD_i+deltaphigr);
    phigrsti_d = (PHIGSTID_i+deltaphigr);
    phigrgat_d = (PHIGGATD_i+deltaphigr);
    phigdbot_d = (PHIGBOTD_i+deltaphigd);
    phigdsti_d = (PHIGSTID_i+deltaphigd);
    phigdgat_d = (PHIGGATD_i+deltaphigd);
    {
      AdmsSensFadType value_pow_0 = pow(auxt,1.5);
      AdmsSensFadType value_exp_1 = exp((0.5*((phigrbot_d*phitrinv)-(phigdbot_d*modelVar_phitdinv))));
      modelVar_ftdbot_d = (value_pow_0*value_exp_1);
    }
    {
      AdmsSensFadType value_pow_0 = pow(auxt,1.5);
      AdmsSensFadType value_exp_1 = exp((0.5*((phigrsti_d*phitrinv)-(phigdsti_d*modelVar_phitdinv))));
      modelVar_ftdsti_d = (value_pow_0*value_exp_1);
    }
    {
      AdmsSensFadType value_pow_0 = pow(auxt,1.5);
      AdmsSensFadType value_exp_1 = exp((0.5*((phigrgat_d*phitrinv)-(phigdgat_d*modelVar_phitdinv))));
      modelVar_ftdgat_d = (value_pow_0*value_exp_1);
    }
    modelVar_idsatbot_d = ((IDSATRBOTD_i*modelVar_ftdbot_d)*modelVar_ftdbot_d);
    modelVar_idsatsti_d = ((IDSATRSTID_i*modelVar_ftdsti_d)*modelVar_ftdsti_d);
    modelVar_idsatgat_d = ((IDSATRGATD_i*modelVar_ftdgat_d)*modelVar_ftdgat_d);
    {
      AdmsSensFadType value_log_0 = log(modelVar_ftdbot_d);
      ubibot_d = ((modelVar_VBIRBOTD_i*auxt)-((2*modelVar_phitd)*value_log_0));
    }
    {
      AdmsSensFadType value_log_0 = log(modelVar_ftdsti_d);
      ubisti_d = ((modelVar_VBIRSTID_i*auxt)-((2*modelVar_phitd)*value_log_0));
    }
    {
      AdmsSensFadType value_log_0 = log(modelVar_ftdgat_d);
      ubigat_d = ((modelVar_VBIRGATD_i*auxt)-((2*modelVar_phitd)*value_log_0));
    }
    {
      AdmsSensFadType value_exp_0 = exp(((0.050-ubibot_d)*modelVar_phitdinv));
      AdmsSensFadType value_log_1 = log((1+value_exp_0));
      modelVar_vbibot_d = (ubibot_d+(modelVar_phitd*value_log_1));
    }
    {
      AdmsSensFadType value_exp_0 = exp(((0.050-ubisti_d)*modelVar_phitdinv));
      AdmsSensFadType value_log_1 = log((1+value_exp_0));
      modelVar_vbisti_d = (ubisti_d+(modelVar_phitd*value_log_1));
    }
    {
      AdmsSensFadType value_exp_0 = exp(((0.050-ubigat_d)*modelVar_phitdinv));
      AdmsSensFadType value_log_1 = log((1+value_exp_0));
      modelVar_vbigat_d = (ubigat_d+(modelVar_phitd*value_log_1));
    }
    modelVar_vbiinvbot_d = (1.0/modelVar_vbibot_d);
    modelVar_vbiinvsti_d = (1.0/modelVar_vbisti_d);
    modelVar_vbiinvgat_d = (1.0/modelVar_vbigat_d);
    modelVar_one_minus_PBOT_d = (1-modelVar_PBOTD_i);
    modelVar_one_minus_PSTI_d = (1-modelVar_PSTID_i);
    modelVar_one_minus_PGAT_d = (1-modelVar_PGATD_i);
    modelVar_one_over_one_minus_PBOT_d = (1/modelVar_one_minus_PBOT_d);
    modelVar_one_over_one_minus_PSTI_d = (1/modelVar_one_minus_PSTI_d);
    modelVar_one_over_one_minus_PGAT_d = (1/modelVar_one_minus_PGAT_d);
    {
      AdmsSensFadType value_pow_0 = pow((modelVar_VBIRBOTD_i*modelVar_vbiinvbot_d),modelVar_PBOTD_i);
      modelVar_cjobot_d = (CJORBOTD_i*value_pow_0);
    }
    {
      AdmsSensFadType value_pow_0 = pow((modelVar_VBIRSTID_i*modelVar_vbiinvsti_d),modelVar_PSTID_i);
      modelVar_cjosti_d = (CJORSTID_i*value_pow_0);
    }
    {
      AdmsSensFadType value_pow_0 = pow((modelVar_VBIRGATD_i*modelVar_vbiinvgat_d),modelVar_PGATD_i);
      modelVar_cjogat_d = (CJORGATD_i*value_pow_0);
    }
    modelVar_qprefbot_d = ((modelVar_cjobot_d*modelVar_vbibot_d)*modelVar_one_over_one_minus_PBOT_d);
    modelVar_qprefsti_d = ((modelVar_cjosti_d*modelVar_vbisti_d)*modelVar_one_over_one_minus_PSTI_d);
    modelVar_qprefgat_d = ((modelVar_cjogat_d*modelVar_vbigat_d)*modelVar_one_over_one_minus_PGAT_d);
    modelVar_qpref2bot_d = (2*modelVar_cjobot_d);
    modelVar_qpref2sti_d = (2*modelVar_cjosti_d);
    modelVar_qpref2gat_d = (2*modelVar_cjogat_d);
    modelVar_wdepnulrbot_d = (modelVar_EPSSI/CJORBOTD_i);
    modelVar_wdepnulrsti_d = ((XJUNSTID_i*modelVar_EPSSI)/CJORSTID_i);
    modelVar_wdepnulrgat_d = ((XJUNGATD_i*modelVar_EPSSI)/CJORGATD_i);
    modelVar_wdepnulrinvbot_d = (1/modelVar_wdepnulrbot_d);
    modelVar_wdepnulrinvsti_d = (1/modelVar_wdepnulrsti_d);
    modelVar_wdepnulrinvgat_d = (1/modelVar_wdepnulrgat_d);
    modelVar_VBIRBOTinv_d = (1/modelVar_VBIRBOTD_i);
    modelVar_VBIRSTIinv_d = (1/modelVar_VBIRSTID_i);
    modelVar_VBIRGATinv_d = (1/modelVar_VBIRGATD_i);
    {
      AdmsSensFadType value_max_0 = max((0.5*phigdbot_d),modelVar_phitd);
      deltaEbot_d = value_max_0;
    }
    {
      AdmsSensFadType value_max_0 = max((0.5*phigdsti_d),modelVar_phitd);
      deltaEsti_d = value_max_0;
    }
    {
      AdmsSensFadType value_max_0 = max((0.5*phigdgat_d),modelVar_phitd);
      deltaEgat_d = value_max_0;
    }
    modelVar_atatbot_d = (deltaEbot_d*modelVar_phitdinv);
    modelVar_atatsti_d = (deltaEsti_d*modelVar_phitdinv);
    modelVar_atatgat_d = (deltaEgat_d*modelVar_phitdinv);
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((32*MEFFTATBOTD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot_d*deltaEbot_d)*deltaEbot_d)));
      modelVar_btatpartbot_d = (value_sqrt_0/(3*1.05457168E-34));
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((32*MEFFTATSTID_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti_d*deltaEsti_d)*deltaEsti_d)));
      modelVar_btatpartsti_d = (value_sqrt_0/(3*1.05457168E-34));
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((32*MEFFTATGATD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat_d*deltaEgat_d)*deltaEgat_d)));
      modelVar_btatpartgat_d = (value_sqrt_0/(3*1.05457168E-34));
    }
    modelVar_fbbtbot_d = (FBBTRBOTD_i*(1+(STFBBTBOTD_i*(tkd-tkr))));
    modelVar_fbbtsti_d = (FBBTRSTID_i*(1+(STFBBTSTID_i*(tkd-tkr))));
    modelVar_fbbtgat_d = (FBBTRGATD_i*(1+(STFBBTGATD_i*(tkd-tkr))));
    modelVar_fbbtbot_d = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtbot_d>0),modelVar_fbbtbot_d,0);
    modelVar_fbbtsti_d = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtsti_d>0),modelVar_fbbtsti_d,0);
    modelVar_fbbtgat_d = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtgat_d>0),modelVar_fbbtgat_d,0);
    {
      AdmsSensFadType value_pow_0 = pow(0.999,modelVar_PBRBOTD_i);
      modelVar_fstopbot_d = (1/(1-value_pow_0));
    }
    {
      AdmsSensFadType value_pow_0 = pow(0.999,modelVar_PBRSTID_i);
      modelVar_fstopsti_d = (1/(1-value_pow_0));
    }
    {
      AdmsSensFadType value_pow_0 = pow(0.999,modelVar_PBRGATD_i);
      modelVar_fstopgat_d = (1/(1-value_pow_0));
    }
    modelVar_VBRinvbot_d = (1/modelVar_VBRBOTD_i);
    modelVar_VBRinvsti_d = (1/modelVar_VBRSTID_i);
    modelVar_VBRinvgat_d = (1/modelVar_VBRGATD_i);
    {
      AdmsSensFadType value_pow_0 = pow(0.999,(modelVar_PBRBOTD_i-1));
      modelVar_slopebot_d = (((-((modelVar_fstopbot_d*modelVar_fstopbot_d)*value_pow_0))*modelVar_PBRBOTD_i)*modelVar_VBRinvbot_d);
    }
    {
      AdmsSensFadType value_pow_0 = pow(0.999,(modelVar_PBRSTID_i-1));
      modelVar_slopesti_d = (((-((modelVar_fstopsti_d*modelVar_fstopsti_d)*value_pow_0))*modelVar_PBRSTID_i)*modelVar_VBRinvsti_d);
    }
    {
      AdmsSensFadType value_pow_0 = pow(0.999,(modelVar_PBRGATD_i-1));
      modelVar_slopegat_d = (((-((modelVar_fstopgat_d*modelVar_fstopgat_d)*value_pow_0))*modelVar_PBRGATD_i)*modelVar_VBRinvgat_d);
    }
  }
  // End block initial_model
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_NOI_GND,
   const int admsProbeID_V_NOI2_GND,
   const int admsProbeID_V_D_BD,
   const int admsProbeID_V_S_BS,
   const int admsProbeID_V_S_BP,
   const int admsProbeID_V_D_S,
   const int admsProbeID_V_GP_S,
   const int admsProbeID_V_B_BI,
   const int admsProbeID_V_BP_BI,
   const int admsProbeID_V_BD_BI,
   const int admsProbeID_V_BS_BI,
   const int admsProbeID_V_G_GP,
   // node constants
   const int admsNodeID_D,
   const int admsNodeID_G,
   const int admsNodeID_S,
   const int admsNodeID_B,
   const int admsNodeID_NOI,
   const int admsNodeID_NOI2,
   const int admsNodeID_GP,
   const int admsNodeID_BP,
   const int admsNodeID_BI,
   const int admsNodeID_BS,
   const int admsNodeID_BD,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_W,
   bool instancePar_given_W,
   AdmsSensFadType & instancePar_SA,
   bool instancePar_given_SA,
   AdmsSensFadType & instancePar_SB,
   bool instancePar_given_SB,
   AdmsSensFadType & instancePar_SD,
   bool instancePar_given_SD,
   AdmsSensFadType & instancePar_SCA,
   bool instancePar_given_SCA,
   AdmsSensFadType & instancePar_SCB,
   bool instancePar_given_SCB,
   AdmsSensFadType & instancePar_SCC,
   bool instancePar_given_SCC,
   AdmsSensFadType & instancePar_SC,
   bool instancePar_given_SC,
   AdmsSensFadType & instancePar_DELVTO,
   bool instancePar_given_DELVTO,
   AdmsSensFadType & instancePar_FACTUO,
   bool instancePar_given_FACTUO,
   AdmsSensFadType & instancePar_ABSOURCE,
   bool instancePar_given_ABSOURCE,
   AdmsSensFadType & instancePar_LSSOURCE,
   bool instancePar_given_LSSOURCE,
   AdmsSensFadType & instancePar_LGSOURCE,
   bool instancePar_given_LGSOURCE,
   AdmsSensFadType & instancePar_ABDRAIN,
   bool instancePar_given_ABDRAIN,
   AdmsSensFadType & instancePar_LSDRAIN,
   bool instancePar_given_LSDRAIN,
   AdmsSensFadType & instancePar_LGDRAIN,
   bool instancePar_given_LGDRAIN,
   AdmsSensFadType & instancePar_AS,
   bool instancePar_given_AS,
   AdmsSensFadType & instancePar_PS,
   bool instancePar_given_PS,
   AdmsSensFadType & instancePar_AD,
   bool instancePar_given_AD,
   AdmsSensFadType & instancePar_PD,
   bool instancePar_given_PD,
   AdmsSensFadType & instancePar_MULT,
   bool instancePar_given_MULT,
   AdmsSensFadType & instancePar_NF,
   bool instancePar_given_NF,
   AdmsSensFadType & instancePar_NGCON,
   bool instancePar_given_NGCON,
   AdmsSensFadType & instancePar_XGW,
   bool instancePar_given_XGW,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_VFB_i,
   AdmsSensFadType & instanceVar_VNSUB_i,
   AdmsSensFadType & instanceVar_NSLP_i,
   AdmsSensFadType & instanceVar_DNSUB_i,
   AdmsSensFadType & instanceVar_CF_i,
   AdmsSensFadType & instanceVar_CFB_i,
   AdmsSensFadType & instanceVar_MUE_i,
   AdmsSensFadType & instanceVar_THEMU_i,
   AdmsSensFadType & instanceVar_CS_i,
   AdmsSensFadType & instanceVar_XCOR_i,
   AdmsSensFadType & instanceVar_THER_i,
   AdmsSensFadType & instanceVar_RSB_i,
   AdmsSensFadType & instanceVar_RSG_i,
   AdmsSensFadType & instanceVar_THESAT_i,
   AdmsSensFadType & instanceVar_THESATB_i,
   AdmsSensFadType & instanceVar_THESATG_i,
   AdmsSensFadType & instanceVar_AX_i,
   AdmsSensFadType & instanceVar_ALP_i,
   AdmsSensFadType & instanceVar_ALP1_i,
   AdmsSensFadType & instanceVar_ALP2_i,
   AdmsSensFadType & instanceVar_A1_i,
   AdmsSensFadType & instanceVar_A2_i,
   AdmsSensFadType & instanceVar_A3_i,
   AdmsSensFadType & instanceVar_A4_i,
   AdmsSensFadType & instanceVar_IGINV_i,
   AdmsSensFadType & instanceVar_IGOV_i,
   AdmsSensFadType & instanceVar_IGOVD_i,
   AdmsSensFadType & instanceVar_GC2_i,
   AdmsSensFadType & instanceVar_GC3_i,
   AdmsSensFadType & instanceVar_CHIB_i,
   AdmsSensFadType & instanceVar_AGIDL_i,
   AdmsSensFadType & instanceVar_CGIDL_i,
   AdmsSensFadType & instanceVar_AGIDLD_i,
   AdmsSensFadType & instanceVar_CGIDLD_i,
   AdmsSensFadType & instanceVar_COX_i,
   AdmsSensFadType & instanceVar_CGOV_i,
   AdmsSensFadType & instanceVar_CGOVD_i,
   AdmsSensFadType & instanceVar_CGBOV_i,
   AdmsSensFadType & instanceVar_CFR_i,
   AdmsSensFadType & instanceVar_CFRD_i,
   AdmsSensFadType & instanceVar_NFA_i,
   AdmsSensFadType & instanceVar_NFB_i,
   AdmsSensFadType & instanceVar_NFC_i,
   AdmsSensFadType & instanceVar_EF_i,
   AdmsSensFadType & instanceVar_FNTEXC_i,
   AdmsSensFadType & instanceVar_MULT_i,
   AdmsSensFadType & instanceVar_BET_i,
   AdmsSensFadType & instanceVar_kp,
   AdmsSensFadType & instanceVar_qq,
   AdmsSensFadType & instanceVar_qlim2,
   AdmsSensFadType & instanceVar_E_eff0,
   AdmsSensFadType & instanceVar_eta_mu,
   AdmsSensFadType & instanceVar_BCH,
   AdmsSensFadType & instanceVar_BOV,
   AdmsSensFadType & instanceVar_inv_CHIB,
   AdmsSensFadType & instanceVar_GCQ,
   AdmsSensFadType & instanceVar_Dch,
   AdmsSensFadType & instanceVar_Dov,
   AdmsSensFadType & instanceVar_x1,
   AdmsSensFadType & instanceVar_Vdsat_lim,
   AdmsSensFadType & instanceVar_nt,
   AdmsSensFadType & instanceVar_Cox_over_q,
   AdmsSensFadType & instanceVar_GOV_s,
   AdmsSensFadType & instanceVar_GOV_d,
   AdmsSensFadType & instanceVar_GOV2_s,
   AdmsSensFadType & instanceVar_GOV2_d,
   AdmsSensFadType & instanceVar_BOV_d,
   AdmsSensFadType & instanceVar_xi_ov_s,
   AdmsSensFadType & instanceVar_xi_ov_d,
   AdmsSensFadType & instanceVar_inv_xi_ov_s,
   AdmsSensFadType & instanceVar_inv_xi_ov_d,
   AdmsSensFadType & instanceVar_x_mrg_ov_s,
   AdmsSensFadType & instanceVar_x_mrg_ov_d,
   AdmsSensFadType & instanceVar_inv_xg1_s,
   AdmsSensFadType & instanceVar_inv_xg1_d,
   AdmsSensFadType & instanceVar_AGIDLs,
   AdmsSensFadType & instanceVar_AGIDLDs,
   AdmsSensFadType & instanceVar_BGIDLs,
   AdmsSensFadType & instanceVar_BGIDLDs,
   AdmsSensFadType & instanceVar_phib,
   AdmsSensFadType & instanceVar_sqrt_phib,
   AdmsSensFadType & instanceVar_phix,
   AdmsSensFadType & instanceVar_aphi,
   AdmsSensFadType & instanceVar_bphi,
   AdmsSensFadType & instanceVar_phix1,
   AdmsSensFadType & instanceVar_G_0,
   AdmsSensFadType & instanceVar_phit1,
   AdmsSensFadType & instanceVar_inv_phit1,
   AdmsSensFadType & instanceVar_alpha_b,
   AdmsSensFadType & instanceVar_inv_VP,
   AdmsSensFadType & instanceVar_inv_AX,
   AdmsSensFadType & instanceVar_Sfl_prefac,
   AdmsSensFadType & instanceVar_fac_exc,
   AdmsSensFadType & instanceVar_RG_i,
   AdmsSensFadType & instanceVar_RBULK_i,
   AdmsSensFadType & instanceVar_RWELL_i,
   AdmsSensFadType & instanceVar_RJUNS_i,
   AdmsSensFadType & instanceVar_RJUND_i,
   AdmsSensFadType & instanceVar_ggate,
   AdmsSensFadType & instanceVar_gbulk,
   AdmsSensFadType & instanceVar_gwell,
   AdmsSensFadType & instanceVar_gjund,
   AdmsSensFadType & instanceVar_gjuns,
   AdmsSensFadType & instanceVar_ABSOURCE_i,
   AdmsSensFadType & instanceVar_LSSOURCE_i,
   AdmsSensFadType & instanceVar_LGSOURCE_i,
   AdmsSensFadType & instanceVar_zflagbot_s,
   AdmsSensFadType & instanceVar_zflagsti_s,
   AdmsSensFadType & instanceVar_zflaggat_s,
   AdmsSensFadType & instanceVar_VMAX_s,
   AdmsSensFadType & instanceVar_exp_VMAX_over_phitd_s,
   AdmsSensFadType & instanceVar_vbimin_s,
   AdmsSensFadType & instanceVar_vch_s,
   AdmsSensFadType & instanceVar_vfmin_s,
   AdmsSensFadType & instanceVar_vbbtlim_s,
   AdmsSensFadType & instanceVar_xhighf1_s,
   AdmsSensFadType & instanceVar_expxhf1_s,
   AdmsSensFadType & instanceVar_xhighf2_s,
   AdmsSensFadType & instanceVar_expxhf2_s,
   AdmsSensFadType & instanceVar_xhighr_s,
   AdmsSensFadType & instanceVar_expxhr_s,
   AdmsSensFadType & instanceVar_m0flag_s,
   AdmsSensFadType & instanceVar_ISATFOR1_s,
   AdmsSensFadType & instanceVar_MFOR1_s,
   AdmsSensFadType & instanceVar_ISATFOR2_s,
   AdmsSensFadType & instanceVar_MFOR2_s,
   AdmsSensFadType & instanceVar_ISATREV_s,
   AdmsSensFadType & instanceVar_MREV_s,
   AdmsSensFadType & instanceVar_ABDRAIN_i,
   AdmsSensFadType & instanceVar_LSDRAIN_i,
   AdmsSensFadType & instanceVar_LGDRAIN_i,
   AdmsSensFadType & instanceVar_zflagbot_d,
   AdmsSensFadType & instanceVar_zflagsti_d,
   AdmsSensFadType & instanceVar_zflaggat_d,
   AdmsSensFadType & instanceVar_VMAX_d,
   AdmsSensFadType & instanceVar_exp_VMAX_over_phitd_d,
   AdmsSensFadType & instanceVar_vbimin_d,
   AdmsSensFadType & instanceVar_vch_d,
   AdmsSensFadType & instanceVar_vfmin_d,
   AdmsSensFadType & instanceVar_vbbtlim_d,
   AdmsSensFadType & instanceVar_xhighf1_d,
   AdmsSensFadType & instanceVar_expxhf1_d,
   AdmsSensFadType & instanceVar_xhighf2_d,
   AdmsSensFadType & instanceVar_expxhf2_d,
   AdmsSensFadType & instanceVar_xhighr_d,
   AdmsSensFadType & instanceVar_expxhr_d,
   AdmsSensFadType & instanceVar_m0flag_d,
   AdmsSensFadType & instanceVar_ISATFOR1_d,
   AdmsSensFadType & instanceVar_MFOR1_d,
   AdmsSensFadType & instanceVar_ISATFOR2_d,
   AdmsSensFadType & instanceVar_MFOR2_d,
   AdmsSensFadType & instanceVar_ISATREV_d,
   AdmsSensFadType & instanceVar_MREV_d,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   AdmsSensFadType & modelPar_TYPE,
   bool modelPar_given_TYPE,
   AdmsSensFadType & modelPar_TR,
   bool modelPar_given_TR,
   AdmsSensFadType & modelPar_SWIGATE,
   bool modelPar_given_SWIGATE,
   AdmsSensFadType & modelPar_SWIMPACT,
   bool modelPar_given_SWIMPACT,
   AdmsSensFadType & modelPar_SWGIDL,
   bool modelPar_given_SWGIDL,
   AdmsSensFadType & modelPar_SWJUNCAP,
   bool modelPar_given_SWJUNCAP,
   AdmsSensFadType & modelPar_SWJUNASYM,
   bool modelPar_given_SWJUNASYM,
   AdmsSensFadType & modelPar_QMC,
   bool modelPar_given_QMC,
   AdmsSensFadType & modelPar_LVARO,
   bool modelPar_given_LVARO,
   AdmsSensFadType & modelPar_LVARL,
   bool modelPar_given_LVARL,
   AdmsSensFadType & modelPar_LVARW,
   bool modelPar_given_LVARW,
   AdmsSensFadType & modelPar_LAP,
   bool modelPar_given_LAP,
   AdmsSensFadType & modelPar_WVARO,
   bool modelPar_given_WVARO,
   AdmsSensFadType & modelPar_WVARL,
   bool modelPar_given_WVARL,
   AdmsSensFadType & modelPar_WVARW,
   bool modelPar_given_WVARW,
   AdmsSensFadType & modelPar_WOT,
   bool modelPar_given_WOT,
   AdmsSensFadType & modelPar_DLQ,
   bool modelPar_given_DLQ,
   AdmsSensFadType & modelPar_DWQ,
   bool modelPar_given_DWQ,
   AdmsSensFadType & modelPar_VFBO,
   bool modelPar_given_VFBO,
   AdmsSensFadType & modelPar_VFBL,
   bool modelPar_given_VFBL,
   AdmsSensFadType & modelPar_VFBW,
   bool modelPar_given_VFBW,
   AdmsSensFadType & modelPar_VFBLW,
   bool modelPar_given_VFBLW,
   AdmsSensFadType & modelPar_STVFBO,
   bool modelPar_given_STVFBO,
   AdmsSensFadType & modelPar_STVFBL,
   bool modelPar_given_STVFBL,
   AdmsSensFadType & modelPar_STVFBW,
   bool modelPar_given_STVFBW,
   AdmsSensFadType & modelPar_STVFBLW,
   bool modelPar_given_STVFBLW,
   AdmsSensFadType & modelPar_TOXO,
   bool modelPar_given_TOXO,
   AdmsSensFadType & modelPar_EPSROXO,
   bool modelPar_given_EPSROXO,
   AdmsSensFadType & modelPar_NSUBO,
   bool modelPar_given_NSUBO,
   AdmsSensFadType & modelPar_NSUBW,
   bool modelPar_given_NSUBW,
   AdmsSensFadType & modelPar_WSEG,
   bool modelPar_given_WSEG,
   AdmsSensFadType & modelPar_NPCK,
   bool modelPar_given_NPCK,
   AdmsSensFadType & modelPar_NPCKW,
   bool modelPar_given_NPCKW,
   AdmsSensFadType & modelPar_WSEGP,
   bool modelPar_given_WSEGP,
   AdmsSensFadType & modelPar_LPCK,
   bool modelPar_given_LPCK,
   AdmsSensFadType & modelPar_LPCKW,
   bool modelPar_given_LPCKW,
   AdmsSensFadType & modelPar_FOL1,
   bool modelPar_given_FOL1,
   AdmsSensFadType & modelPar_FOL2,
   bool modelPar_given_FOL2,
   AdmsSensFadType & modelPar_VNSUBO,
   bool modelPar_given_VNSUBO,
   AdmsSensFadType & modelPar_NSLPO,
   bool modelPar_given_NSLPO,
   AdmsSensFadType & modelPar_DNSUBO,
   bool modelPar_given_DNSUBO,
   AdmsSensFadType & modelPar_DPHIBO,
   bool modelPar_given_DPHIBO,
   AdmsSensFadType & modelPar_DPHIBL,
   bool modelPar_given_DPHIBL,
   AdmsSensFadType & modelPar_DPHIBLEXP,
   bool modelPar_given_DPHIBLEXP,
   AdmsSensFadType & modelPar_DPHIBW,
   bool modelPar_given_DPHIBW,
   AdmsSensFadType & modelPar_DPHIBLW,
   bool modelPar_given_DPHIBLW,
   AdmsSensFadType & modelPar_NPO,
   bool modelPar_given_NPO,
   AdmsSensFadType & modelPar_NPL,
   bool modelPar_given_NPL,
   AdmsSensFadType & modelPar_CTO,
   bool modelPar_given_CTO,
   AdmsSensFadType & modelPar_CTL,
   bool modelPar_given_CTL,
   AdmsSensFadType & modelPar_CTLEXP,
   bool modelPar_given_CTLEXP,
   AdmsSensFadType & modelPar_CTW,
   bool modelPar_given_CTW,
   AdmsSensFadType & modelPar_CTLW,
   bool modelPar_given_CTLW,
   AdmsSensFadType & modelPar_TOXOVO,
   bool modelPar_given_TOXOVO,
   AdmsSensFadType & modelPar_TOXOVDO,
   bool modelPar_given_TOXOVDO,
   AdmsSensFadType & modelPar_LOV,
   bool modelPar_given_LOV,
   AdmsSensFadType & modelPar_LOVD,
   bool modelPar_given_LOVD,
   AdmsSensFadType & modelPar_NOVO,
   bool modelPar_given_NOVO,
   AdmsSensFadType & modelPar_NOVDO,
   bool modelPar_given_NOVDO,
   AdmsSensFadType & modelPar_CFL,
   bool modelPar_given_CFL,
   AdmsSensFadType & modelPar_CFLEXP,
   bool modelPar_given_CFLEXP,
   AdmsSensFadType & modelPar_CFW,
   bool modelPar_given_CFW,
   AdmsSensFadType & modelPar_CFBO,
   bool modelPar_given_CFBO,
   AdmsSensFadType & modelPar_UO,
   bool modelPar_given_UO,
   AdmsSensFadType & modelPar_FBET1,
   bool modelPar_given_FBET1,
   AdmsSensFadType & modelPar_FBET1W,
   bool modelPar_given_FBET1W,
   AdmsSensFadType & modelPar_LP1,
   bool modelPar_given_LP1,
   AdmsSensFadType & modelPar_LP1W,
   bool modelPar_given_LP1W,
   AdmsSensFadType & modelPar_FBET2,
   bool modelPar_given_FBET2,
   AdmsSensFadType & modelPar_LP2,
   bool modelPar_given_LP2,
   AdmsSensFadType & modelPar_BETW1,
   bool modelPar_given_BETW1,
   AdmsSensFadType & modelPar_BETW2,
   bool modelPar_given_BETW2,
   AdmsSensFadType & modelPar_WBET,
   bool modelPar_given_WBET,
   AdmsSensFadType & modelPar_STBETO,
   bool modelPar_given_STBETO,
   AdmsSensFadType & modelPar_STBETL,
   bool modelPar_given_STBETL,
   AdmsSensFadType & modelPar_STBETW,
   bool modelPar_given_STBETW,
   AdmsSensFadType & modelPar_STBETLW,
   bool modelPar_given_STBETLW,
   AdmsSensFadType & modelPar_MUEO,
   bool modelPar_given_MUEO,
   AdmsSensFadType & modelPar_MUEW,
   bool modelPar_given_MUEW,
   AdmsSensFadType & modelPar_STMUEO,
   bool modelPar_given_STMUEO,
   AdmsSensFadType & modelPar_THEMUO,
   bool modelPar_given_THEMUO,
   AdmsSensFadType & modelPar_STTHEMUO,
   bool modelPar_given_STTHEMUO,
   AdmsSensFadType & modelPar_CSO,
   bool modelPar_given_CSO,
   AdmsSensFadType & modelPar_CSL,
   bool modelPar_given_CSL,
   AdmsSensFadType & modelPar_CSLEXP,
   bool modelPar_given_CSLEXP,
   AdmsSensFadType & modelPar_CSW,
   bool modelPar_given_CSW,
   AdmsSensFadType & modelPar_CSLW,
   bool modelPar_given_CSLW,
   AdmsSensFadType & modelPar_STCSO,
   bool modelPar_given_STCSO,
   AdmsSensFadType & modelPar_XCORO,
   bool modelPar_given_XCORO,
   AdmsSensFadType & modelPar_XCORL,
   bool modelPar_given_XCORL,
   AdmsSensFadType & modelPar_XCORW,
   bool modelPar_given_XCORW,
   AdmsSensFadType & modelPar_XCORLW,
   bool modelPar_given_XCORLW,
   AdmsSensFadType & modelPar_STXCORO,
   bool modelPar_given_STXCORO,
   AdmsSensFadType & modelPar_FETAO,
   bool modelPar_given_FETAO,
   AdmsSensFadType & modelPar_RSW1,
   bool modelPar_given_RSW1,
   AdmsSensFadType & modelPar_RSW2,
   bool modelPar_given_RSW2,
   AdmsSensFadType & modelPar_STRSO,
   bool modelPar_given_STRSO,
   AdmsSensFadType & modelPar_RSBO,
   bool modelPar_given_RSBO,
   AdmsSensFadType & modelPar_RSGO,
   bool modelPar_given_RSGO,
   AdmsSensFadType & modelPar_THESATO,
   bool modelPar_given_THESATO,
   AdmsSensFadType & modelPar_THESATL,
   bool modelPar_given_THESATL,
   AdmsSensFadType & modelPar_THESATLEXP,
   bool modelPar_given_THESATLEXP,
   AdmsSensFadType & modelPar_THESATW,
   bool modelPar_given_THESATW,
   AdmsSensFadType & modelPar_THESATLW,
   bool modelPar_given_THESATLW,
   AdmsSensFadType & modelPar_STTHESATO,
   bool modelPar_given_STTHESATO,
   AdmsSensFadType & modelPar_STTHESATL,
   bool modelPar_given_STTHESATL,
   AdmsSensFadType & modelPar_STTHESATW,
   bool modelPar_given_STTHESATW,
   AdmsSensFadType & modelPar_STTHESATLW,
   bool modelPar_given_STTHESATLW,
   AdmsSensFadType & modelPar_THESATBO,
   bool modelPar_given_THESATBO,
   AdmsSensFadType & modelPar_THESATGO,
   bool modelPar_given_THESATGO,
   AdmsSensFadType & modelPar_AXO,
   bool modelPar_given_AXO,
   AdmsSensFadType & modelPar_AXL,
   bool modelPar_given_AXL,
   AdmsSensFadType & modelPar_ALPL,
   bool modelPar_given_ALPL,
   AdmsSensFadType & modelPar_ALPLEXP,
   bool modelPar_given_ALPLEXP,
   AdmsSensFadType & modelPar_ALPW,
   bool modelPar_given_ALPW,
   AdmsSensFadType & modelPar_ALP1L1,
   bool modelPar_given_ALP1L1,
   AdmsSensFadType & modelPar_ALP1LEXP,
   bool modelPar_given_ALP1LEXP,
   AdmsSensFadType & modelPar_ALP1L2,
   bool modelPar_given_ALP1L2,
   AdmsSensFadType & modelPar_ALP1W,
   bool modelPar_given_ALP1W,
   AdmsSensFadType & modelPar_ALP2L1,
   bool modelPar_given_ALP2L1,
   AdmsSensFadType & modelPar_ALP2LEXP,
   bool modelPar_given_ALP2LEXP,
   AdmsSensFadType & modelPar_ALP2L2,
   bool modelPar_given_ALP2L2,
   AdmsSensFadType & modelPar_ALP2W,
   bool modelPar_given_ALP2W,
   AdmsSensFadType & modelPar_VPO,
   bool modelPar_given_VPO,
   AdmsSensFadType & modelPar_A1O,
   bool modelPar_given_A1O,
   AdmsSensFadType & modelPar_A1L,
   bool modelPar_given_A1L,
   AdmsSensFadType & modelPar_A1W,
   bool modelPar_given_A1W,
   AdmsSensFadType & modelPar_A2O,
   bool modelPar_given_A2O,
   AdmsSensFadType & modelPar_STA2O,
   bool modelPar_given_STA2O,
   AdmsSensFadType & modelPar_A3O,
   bool modelPar_given_A3O,
   AdmsSensFadType & modelPar_A3L,
   bool modelPar_given_A3L,
   AdmsSensFadType & modelPar_A3W,
   bool modelPar_given_A3W,
   AdmsSensFadType & modelPar_A4O,
   bool modelPar_given_A4O,
   AdmsSensFadType & modelPar_A4L,
   bool modelPar_given_A4L,
   AdmsSensFadType & modelPar_A4W,
   bool modelPar_given_A4W,
   AdmsSensFadType & modelPar_GCOO,
   bool modelPar_given_GCOO,
   AdmsSensFadType & modelPar_IGINVLW,
   bool modelPar_given_IGINVLW,
   AdmsSensFadType & modelPar_IGOVW,
   bool modelPar_given_IGOVW,
   AdmsSensFadType & modelPar_IGOVDW,
   bool modelPar_given_IGOVDW,
   AdmsSensFadType & modelPar_STIGO,
   bool modelPar_given_STIGO,
   AdmsSensFadType & modelPar_GC2O,
   bool modelPar_given_GC2O,
   AdmsSensFadType & modelPar_GC3O,
   bool modelPar_given_GC3O,
   AdmsSensFadType & modelPar_CHIBO,
   bool modelPar_given_CHIBO,
   AdmsSensFadType & modelPar_AGIDLW,
   bool modelPar_given_AGIDLW,
   AdmsSensFadType & modelPar_AGIDLDW,
   bool modelPar_given_AGIDLDW,
   AdmsSensFadType & modelPar_BGIDLO,
   bool modelPar_given_BGIDLO,
   AdmsSensFadType & modelPar_BGIDLDO,
   bool modelPar_given_BGIDLDO,
   AdmsSensFadType & modelPar_STBGIDLO,
   bool modelPar_given_STBGIDLO,
   AdmsSensFadType & modelPar_STBGIDLDO,
   bool modelPar_given_STBGIDLDO,
   AdmsSensFadType & modelPar_CGIDLO,
   bool modelPar_given_CGIDLO,
   AdmsSensFadType & modelPar_CGIDLDO,
   bool modelPar_given_CGIDLDO,
   AdmsSensFadType & modelPar_CGBOVL,
   bool modelPar_given_CGBOVL,
   AdmsSensFadType & modelPar_CFRW,
   bool modelPar_given_CFRW,
   AdmsSensFadType & modelPar_CFRDW,
   bool modelPar_given_CFRDW,
   AdmsSensFadType & modelPar_FNTO,
   bool modelPar_given_FNTO,
   AdmsSensFadType & modelPar_FNTEXCL,
   bool modelPar_given_FNTEXCL,
   AdmsSensFadType & modelPar_NFALW,
   bool modelPar_given_NFALW,
   AdmsSensFadType & modelPar_NFBLW,
   bool modelPar_given_NFBLW,
   AdmsSensFadType & modelPar_NFCLW,
   bool modelPar_given_NFCLW,
   AdmsSensFadType & modelPar_EFO,
   bool modelPar_given_EFO,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_ALPNOI,
   bool modelPar_given_ALPNOI,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_KVTHOWEO,
   bool modelPar_given_KVTHOWEO,
   AdmsSensFadType & modelPar_KVTHOWEL,
   bool modelPar_given_KVTHOWEL,
   AdmsSensFadType & modelPar_KVTHOWEW,
   bool modelPar_given_KVTHOWEW,
   AdmsSensFadType & modelPar_KVTHOWELW,
   bool modelPar_given_KVTHOWELW,
   AdmsSensFadType & modelPar_KUOWEO,
   bool modelPar_given_KUOWEO,
   AdmsSensFadType & modelPar_KUOWEL,
   bool modelPar_given_KUOWEL,
   AdmsSensFadType & modelPar_KUOWEW,
   bool modelPar_given_KUOWEW,
   AdmsSensFadType & modelPar_KUOWELW,
   bool modelPar_given_KUOWELW,
   AdmsSensFadType & modelPar_LMIN,
   bool modelPar_given_LMIN,
   AdmsSensFadType & modelPar_LMAX,
   bool modelPar_given_LMAX,
   AdmsSensFadType & modelPar_WMIN,
   bool modelPar_given_WMIN,
   AdmsSensFadType & modelPar_WMAX,
   bool modelPar_given_WMAX,
   AdmsSensFadType & modelPar_RGO,
   bool modelPar_given_RGO,
   AdmsSensFadType & modelPar_RBULKO,
   bool modelPar_given_RBULKO,
   AdmsSensFadType & modelPar_RWELLO,
   bool modelPar_given_RWELLO,
   AdmsSensFadType & modelPar_RJUNSO,
   bool modelPar_given_RJUNSO,
   AdmsSensFadType & modelPar_RJUNDO,
   bool modelPar_given_RJUNDO,
   AdmsSensFadType & modelPar_RINT,
   bool modelPar_given_RINT,
   AdmsSensFadType & modelPar_RVPOLY,
   bool modelPar_given_RVPOLY,
   AdmsSensFadType & modelPar_RSHG,
   bool modelPar_given_RSHG,
   AdmsSensFadType & modelPar_DLSIL,
   bool modelPar_given_DLSIL,
   AdmsSensFadType & modelPar_SAREF,
   bool modelPar_given_SAREF,
   AdmsSensFadType & modelPar_SBREF,
   bool modelPar_given_SBREF,
   AdmsSensFadType & modelPar_WLOD,
   bool modelPar_given_WLOD,
   AdmsSensFadType & modelPar_KUO,
   bool modelPar_given_KUO,
   AdmsSensFadType & modelPar_KVSAT,
   bool modelPar_given_KVSAT,
   AdmsSensFadType & modelPar_TKUO,
   bool modelPar_given_TKUO,
   AdmsSensFadType & modelPar_LKUO,
   bool modelPar_given_LKUO,
   AdmsSensFadType & modelPar_WKUO,
   bool modelPar_given_WKUO,
   AdmsSensFadType & modelPar_PKUO,
   bool modelPar_given_PKUO,
   AdmsSensFadType & modelPar_LLODKUO,
   bool modelPar_given_LLODKUO,
   AdmsSensFadType & modelPar_WLODKUO,
   bool modelPar_given_WLODKUO,
   AdmsSensFadType & modelPar_KVTHO,
   bool modelPar_given_KVTHO,
   AdmsSensFadType & modelPar_LKVTHO,
   bool modelPar_given_LKVTHO,
   AdmsSensFadType & modelPar_WKVTHO,
   bool modelPar_given_WKVTHO,
   AdmsSensFadType & modelPar_PKVTHO,
   bool modelPar_given_PKVTHO,
   AdmsSensFadType & modelPar_LLODVTH,
   bool modelPar_given_LLODVTH,
   AdmsSensFadType & modelPar_WLODVTH,
   bool modelPar_given_WLODVTH,
   AdmsSensFadType & modelPar_STETAO,
   bool modelPar_given_STETAO,
   AdmsSensFadType & modelPar_LODETAO,
   bool modelPar_given_LODETAO,
   AdmsSensFadType & modelPar_SCREF,
   bool modelPar_given_SCREF,
   AdmsSensFadType & modelPar_WEB,
   bool modelPar_given_WEB,
   AdmsSensFadType & modelPar_WEC,
   bool modelPar_given_WEC,
   AdmsSensFadType & modelPar_IMAX,
   bool modelPar_given_IMAX,
   AdmsSensFadType & modelPar_TRJ,
   bool modelPar_given_TRJ,
   AdmsSensFadType & modelPar_CJORBOT,
   bool modelPar_given_CJORBOT,
   AdmsSensFadType & modelPar_CJORSTI,
   bool modelPar_given_CJORSTI,
   AdmsSensFadType & modelPar_CJORGAT,
   bool modelPar_given_CJORGAT,
   AdmsSensFadType & modelPar_VBIRBOT,
   bool modelPar_given_VBIRBOT,
   AdmsSensFadType & modelPar_VBIRSTI,
   bool modelPar_given_VBIRSTI,
   AdmsSensFadType & modelPar_VBIRGAT,
   bool modelPar_given_VBIRGAT,
   AdmsSensFadType & modelPar_PBOT,
   bool modelPar_given_PBOT,
   AdmsSensFadType & modelPar_PSTI,
   bool modelPar_given_PSTI,
   AdmsSensFadType & modelPar_PGAT,
   bool modelPar_given_PGAT,
   AdmsSensFadType & modelPar_PHIGBOT,
   bool modelPar_given_PHIGBOT,
   AdmsSensFadType & modelPar_PHIGSTI,
   bool modelPar_given_PHIGSTI,
   AdmsSensFadType & modelPar_PHIGGAT,
   bool modelPar_given_PHIGGAT,
   AdmsSensFadType & modelPar_IDSATRBOT,
   bool modelPar_given_IDSATRBOT,
   AdmsSensFadType & modelPar_IDSATRSTI,
   bool modelPar_given_IDSATRSTI,
   AdmsSensFadType & modelPar_IDSATRGAT,
   bool modelPar_given_IDSATRGAT,
   AdmsSensFadType & modelPar_CSRHBOT,
   bool modelPar_given_CSRHBOT,
   AdmsSensFadType & modelPar_CSRHSTI,
   bool modelPar_given_CSRHSTI,
   AdmsSensFadType & modelPar_CSRHGAT,
   bool modelPar_given_CSRHGAT,
   AdmsSensFadType & modelPar_XJUNSTI,
   bool modelPar_given_XJUNSTI,
   AdmsSensFadType & modelPar_XJUNGAT,
   bool modelPar_given_XJUNGAT,
   AdmsSensFadType & modelPar_CTATBOT,
   bool modelPar_given_CTATBOT,
   AdmsSensFadType & modelPar_CTATSTI,
   bool modelPar_given_CTATSTI,
   AdmsSensFadType & modelPar_CTATGAT,
   bool modelPar_given_CTATGAT,
   AdmsSensFadType & modelPar_MEFFTATBOT,
   bool modelPar_given_MEFFTATBOT,
   AdmsSensFadType & modelPar_MEFFTATSTI,
   bool modelPar_given_MEFFTATSTI,
   AdmsSensFadType & modelPar_MEFFTATGAT,
   bool modelPar_given_MEFFTATGAT,
   AdmsSensFadType & modelPar_CBBTBOT,
   bool modelPar_given_CBBTBOT,
   AdmsSensFadType & modelPar_CBBTSTI,
   bool modelPar_given_CBBTSTI,
   AdmsSensFadType & modelPar_CBBTGAT,
   bool modelPar_given_CBBTGAT,
   AdmsSensFadType & modelPar_FBBTRBOT,
   bool modelPar_given_FBBTRBOT,
   AdmsSensFadType & modelPar_FBBTRSTI,
   bool modelPar_given_FBBTRSTI,
   AdmsSensFadType & modelPar_FBBTRGAT,
   bool modelPar_given_FBBTRGAT,
   AdmsSensFadType & modelPar_STFBBTBOT,
   bool modelPar_given_STFBBTBOT,
   AdmsSensFadType & modelPar_STFBBTSTI,
   bool modelPar_given_STFBBTSTI,
   AdmsSensFadType & modelPar_STFBBTGAT,
   bool modelPar_given_STFBBTGAT,
   AdmsSensFadType & modelPar_VBRBOT,
   bool modelPar_given_VBRBOT,
   AdmsSensFadType & modelPar_VBRSTI,
   bool modelPar_given_VBRSTI,
   AdmsSensFadType & modelPar_VBRGAT,
   bool modelPar_given_VBRGAT,
   AdmsSensFadType & modelPar_PBRBOT,
   bool modelPar_given_PBRBOT,
   AdmsSensFadType & modelPar_PBRSTI,
   bool modelPar_given_PBRSTI,
   AdmsSensFadType & modelPar_PBRGAT,
   bool modelPar_given_PBRGAT,
   AdmsSensFadType & modelPar_CJORBOTD,
   bool modelPar_given_CJORBOTD,
   AdmsSensFadType & modelPar_CJORSTID,
   bool modelPar_given_CJORSTID,
   AdmsSensFadType & modelPar_CJORGATD,
   bool modelPar_given_CJORGATD,
   AdmsSensFadType & modelPar_VBIRBOTD,
   bool modelPar_given_VBIRBOTD,
   AdmsSensFadType & modelPar_VBIRSTID,
   bool modelPar_given_VBIRSTID,
   AdmsSensFadType & modelPar_VBIRGATD,
   bool modelPar_given_VBIRGATD,
   AdmsSensFadType & modelPar_PBOTD,
   bool modelPar_given_PBOTD,
   AdmsSensFadType & modelPar_PSTID,
   bool modelPar_given_PSTID,
   AdmsSensFadType & modelPar_PGATD,
   bool modelPar_given_PGATD,
   AdmsSensFadType & modelPar_PHIGBOTD,
   bool modelPar_given_PHIGBOTD,
   AdmsSensFadType & modelPar_PHIGSTID,
   bool modelPar_given_PHIGSTID,
   AdmsSensFadType & modelPar_PHIGGATD,
   bool modelPar_given_PHIGGATD,
   AdmsSensFadType & modelPar_IDSATRBOTD,
   bool modelPar_given_IDSATRBOTD,
   AdmsSensFadType & modelPar_IDSATRSTID,
   bool modelPar_given_IDSATRSTID,
   AdmsSensFadType & modelPar_IDSATRGATD,
   bool modelPar_given_IDSATRGATD,
   AdmsSensFadType & modelPar_CSRHBOTD,
   bool modelPar_given_CSRHBOTD,
   AdmsSensFadType & modelPar_CSRHSTID,
   bool modelPar_given_CSRHSTID,
   AdmsSensFadType & modelPar_CSRHGATD,
   bool modelPar_given_CSRHGATD,
   AdmsSensFadType & modelPar_XJUNSTID,
   bool modelPar_given_XJUNSTID,
   AdmsSensFadType & modelPar_XJUNGATD,
   bool modelPar_given_XJUNGATD,
   AdmsSensFadType & modelPar_CTATBOTD,
   bool modelPar_given_CTATBOTD,
   AdmsSensFadType & modelPar_CTATSTID,
   bool modelPar_given_CTATSTID,
   AdmsSensFadType & modelPar_CTATGATD,
   bool modelPar_given_CTATGATD,
   AdmsSensFadType & modelPar_MEFFTATBOTD,
   bool modelPar_given_MEFFTATBOTD,
   AdmsSensFadType & modelPar_MEFFTATSTID,
   bool modelPar_given_MEFFTATSTID,
   AdmsSensFadType & modelPar_MEFFTATGATD,
   bool modelPar_given_MEFFTATGATD,
   AdmsSensFadType & modelPar_CBBTBOTD,
   bool modelPar_given_CBBTBOTD,
   AdmsSensFadType & modelPar_CBBTSTID,
   bool modelPar_given_CBBTSTID,
   AdmsSensFadType & modelPar_CBBTGATD,
   bool modelPar_given_CBBTGATD,
   AdmsSensFadType & modelPar_FBBTRBOTD,
   bool modelPar_given_FBBTRBOTD,
   AdmsSensFadType & modelPar_FBBTRSTID,
   bool modelPar_given_FBBTRSTID,
   AdmsSensFadType & modelPar_FBBTRGATD,
   bool modelPar_given_FBBTRGATD,
   AdmsSensFadType & modelPar_STFBBTBOTD,
   bool modelPar_given_STFBBTBOTD,
   AdmsSensFadType & modelPar_STFBBTSTID,
   bool modelPar_given_STFBBTSTID,
   AdmsSensFadType & modelPar_STFBBTGATD,
   bool modelPar_given_STFBBTGATD,
   AdmsSensFadType & modelPar_VBRBOTD,
   bool modelPar_given_VBRBOTD,
   AdmsSensFadType & modelPar_VBRSTID,
   bool modelPar_given_VBRSTID,
   AdmsSensFadType & modelPar_VBRGATD,
   bool modelPar_given_VBRGATD,
   AdmsSensFadType & modelPar_PBRBOTD,
   bool modelPar_given_PBRBOTD,
   AdmsSensFadType & modelPar_PBRSTID,
   bool modelPar_given_PBRSTID,
   AdmsSensFadType & modelPar_PBRGATD,
   bool modelPar_given_PBRGATD,
   AdmsSensFadType & modelPar_SWJUNEXP,
   bool modelPar_given_SWJUNEXP,
   AdmsSensFadType & modelPar_VJUNREF,
   bool modelPar_given_VJUNREF,
   AdmsSensFadType & modelPar_FJUNQ,
   bool modelPar_given_FJUNQ,
   AdmsSensFadType & modelPar_VJUNREFD,
   bool modelPar_given_VJUNREFD,
   AdmsSensFadType & modelPar_FJUNQD,
   bool modelPar_given_FJUNQD// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_NSUBO_i,
   AdmsSensFadType & modelVar_WSEG_i,
   AdmsSensFadType & modelVar_NPCK_i,
   AdmsSensFadType & modelVar_WSEGP_i,
   AdmsSensFadType & modelVar_LPCK_i,
   AdmsSensFadType & modelVar_LOV_i,
   AdmsSensFadType & modelVar_LOVD_i,
   AdmsSensFadType & modelVar_LP1_i,
   AdmsSensFadType & modelVar_LP2_i,
   AdmsSensFadType & modelVar_WBET_i,
   AdmsSensFadType & modelVar_AXL_i,
   AdmsSensFadType & modelVar_ALP1L2_i,
   AdmsSensFadType & modelVar_ALP2L2_i,
   AdmsSensFadType & modelVar_RINT_i,
   AdmsSensFadType & modelVar_RVPOLY_i,
   AdmsSensFadType & modelVar_SAREF_i,
   AdmsSensFadType & modelVar_SBREF_i,
   AdmsSensFadType & modelVar_KVSAT_i,
   AdmsSensFadType & modelVar_LLODKUO_i,
   AdmsSensFadType & modelVar_WLODKUO_i,
   AdmsSensFadType & modelVar_LLODVTH_i,
   AdmsSensFadType & modelVar_WLODVTH_i,
   AdmsSensFadType & modelVar_LODETAO_i,
   AdmsSensFadType & modelVar_SCREF_i,
   AdmsSensFadType & modelVar_WEB_i,
   AdmsSensFadType & modelVar_WEC_i,
   AdmsSensFadType & modelVar_TOX_i,
   AdmsSensFadType & modelVar_EPSROX_i,
   AdmsSensFadType & modelVar_TOXOV_i,
   AdmsSensFadType & modelVar_TOXOVD_i,
   AdmsSensFadType & modelVar_TKD,
   AdmsSensFadType & modelVar_dT,
   AdmsSensFadType & modelVar_rT,
   AdmsSensFadType & modelVar_rTn,
   AdmsSensFadType & modelVar_EPSSI,
   AdmsSensFadType & modelVar_phit,
   AdmsSensFadType & modelVar_inv_phit,
   AdmsSensFadType & modelVar_Eg,
   AdmsSensFadType & modelVar_phibFac,
   AdmsSensFadType & modelVar_nt0,
   AdmsSensFadType & modelVar_IMAX_i,
   AdmsSensFadType & modelVar_VBIRBOT_i,
   AdmsSensFadType & modelVar_VBIRSTI_i,
   AdmsSensFadType & modelVar_VBIRGAT_i,
   AdmsSensFadType & modelVar_PBOT_i,
   AdmsSensFadType & modelVar_PSTI_i,
   AdmsSensFadType & modelVar_PGAT_i,
   AdmsSensFadType & modelVar_CSRHBOT_i,
   AdmsSensFadType & modelVar_CSRHSTI_i,
   AdmsSensFadType & modelVar_CSRHGAT_i,
   AdmsSensFadType & modelVar_CTATBOT_i,
   AdmsSensFadType & modelVar_CTATSTI_i,
   AdmsSensFadType & modelVar_CTATGAT_i,
   AdmsSensFadType & modelVar_CBBTBOT_i,
   AdmsSensFadType & modelVar_CBBTSTI_i,
   AdmsSensFadType & modelVar_CBBTGAT_i,
   AdmsSensFadType & modelVar_VBRBOT_i,
   AdmsSensFadType & modelVar_VBRSTI_i,
   AdmsSensFadType & modelVar_VBRGAT_i,
   AdmsSensFadType & modelVar_PBRBOT_i,
   AdmsSensFadType & modelVar_PBRSTI_i,
   AdmsSensFadType & modelVar_PBRGAT_i,
   AdmsSensFadType & modelVar_SWJUNEXP_i,
   AdmsSensFadType & modelVar_VJUNREF_i,
   AdmsSensFadType & modelVar_FJUNQ_i,
   AdmsSensFadType & modelVar_phitr,
   AdmsSensFadType & modelVar_phitd,
   AdmsSensFadType & modelVar_phitdinv,
   AdmsSensFadType & modelVar_perfc,
   AdmsSensFadType & modelVar_berfc,
   AdmsSensFadType & modelVar_cerfc,
   AdmsSensFadType & modelVar_ftdbot,
   AdmsSensFadType & modelVar_ftdsti,
   AdmsSensFadType & modelVar_ftdgat,
   AdmsSensFadType & modelVar_idsatbot,
   AdmsSensFadType & modelVar_idsatsti,
   AdmsSensFadType & modelVar_idsatgat,
   AdmsSensFadType & modelVar_vbibot,
   AdmsSensFadType & modelVar_vbisti,
   AdmsSensFadType & modelVar_vbigat,
   AdmsSensFadType & modelVar_vbiinvbot,
   AdmsSensFadType & modelVar_vbiinvsti,
   AdmsSensFadType & modelVar_vbiinvgat,
   AdmsSensFadType & modelVar_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_minus_PGAT,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT,
   AdmsSensFadType & modelVar_cjobot,
   AdmsSensFadType & modelVar_cjosti,
   AdmsSensFadType & modelVar_cjogat,
   AdmsSensFadType & modelVar_qprefbot,
   AdmsSensFadType & modelVar_qprefsti,
   AdmsSensFadType & modelVar_qprefgat,
   AdmsSensFadType & modelVar_qpref2bot,
   AdmsSensFadType & modelVar_qpref2sti,
   AdmsSensFadType & modelVar_qpref2gat,
   AdmsSensFadType & modelVar_wdepnulrbot,
   AdmsSensFadType & modelVar_wdepnulrsti,
   AdmsSensFadType & modelVar_wdepnulrgat,
   AdmsSensFadType & modelVar_wdepnulrinvbot,
   AdmsSensFadType & modelVar_wdepnulrinvsti,
   AdmsSensFadType & modelVar_wdepnulrinvgat,
   AdmsSensFadType & modelVar_VBIRBOTinv,
   AdmsSensFadType & modelVar_VBIRSTIinv,
   AdmsSensFadType & modelVar_VBIRGATinv,
   AdmsSensFadType & modelVar_atatbot,
   AdmsSensFadType & modelVar_atatsti,
   AdmsSensFadType & modelVar_atatgat,
   AdmsSensFadType & modelVar_btatpartbot,
   AdmsSensFadType & modelVar_btatpartsti,
   AdmsSensFadType & modelVar_btatpartgat,
   AdmsSensFadType & modelVar_fbbtbot,
   AdmsSensFadType & modelVar_fbbtsti,
   AdmsSensFadType & modelVar_fbbtgat,
   AdmsSensFadType & modelVar_fstopbot,
   AdmsSensFadType & modelVar_fstopsti,
   AdmsSensFadType & modelVar_fstopgat,
   AdmsSensFadType & modelVar_VBRinvbot,
   AdmsSensFadType & modelVar_VBRinvsti,
   AdmsSensFadType & modelVar_VBRinvgat,
   AdmsSensFadType & modelVar_slopebot,
   AdmsSensFadType & modelVar_slopesti,
   AdmsSensFadType & modelVar_slopegat,
   AdmsSensFadType & modelVar_VBIRBOTD_i,
   AdmsSensFadType & modelVar_VBIRSTID_i,
   AdmsSensFadType & modelVar_VBIRGATD_i,
   AdmsSensFadType & modelVar_PBOTD_i,
   AdmsSensFadType & modelVar_PSTID_i,
   AdmsSensFadType & modelVar_PGATD_i,
   AdmsSensFadType & modelVar_CSRHBOTD_i,
   AdmsSensFadType & modelVar_CSRHSTID_i,
   AdmsSensFadType & modelVar_CSRHGATD_i,
   AdmsSensFadType & modelVar_CTATBOTD_i,
   AdmsSensFadType & modelVar_CTATSTID_i,
   AdmsSensFadType & modelVar_CTATGATD_i,
   AdmsSensFadType & modelVar_CBBTBOTD_i,
   AdmsSensFadType & modelVar_CBBTSTID_i,
   AdmsSensFadType & modelVar_CBBTGATD_i,
   AdmsSensFadType & modelVar_VBRBOTD_i,
   AdmsSensFadType & modelVar_VBRSTID_i,
   AdmsSensFadType & modelVar_VBRGATD_i,
   AdmsSensFadType & modelVar_PBRBOTD_i,
   AdmsSensFadType & modelVar_PBRSTID_i,
   AdmsSensFadType & modelVar_PBRGATD_i,
   AdmsSensFadType & modelVar_VJUNREFD_i,
   AdmsSensFadType & modelVar_FJUNQD_i,
   AdmsSensFadType & modelVar_ftdbot_d,
   AdmsSensFadType & modelVar_ftdsti_d,
   AdmsSensFadType & modelVar_ftdgat_d,
   AdmsSensFadType & modelVar_idsatbot_d,
   AdmsSensFadType & modelVar_idsatsti_d,
   AdmsSensFadType & modelVar_idsatgat_d,
   AdmsSensFadType & modelVar_vbibot_d,
   AdmsSensFadType & modelVar_vbisti_d,
   AdmsSensFadType & modelVar_vbigat_d,
   AdmsSensFadType & modelVar_vbiinvbot_d,
   AdmsSensFadType & modelVar_vbiinvsti_d,
   AdmsSensFadType & modelVar_vbiinvgat_d,
   AdmsSensFadType & modelVar_one_minus_PBOT_d,
   AdmsSensFadType & modelVar_one_minus_PSTI_d,
   AdmsSensFadType & modelVar_one_minus_PGAT_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT_d,
   AdmsSensFadType & modelVar_cjobot_d,
   AdmsSensFadType & modelVar_cjosti_d,
   AdmsSensFadType & modelVar_cjogat_d,
   AdmsSensFadType & modelVar_qprefbot_d,
   AdmsSensFadType & modelVar_qprefsti_d,
   AdmsSensFadType & modelVar_qprefgat_d,
   AdmsSensFadType & modelVar_qpref2bot_d,
   AdmsSensFadType & modelVar_qpref2sti_d,
   AdmsSensFadType & modelVar_qpref2gat_d,
   AdmsSensFadType & modelVar_wdepnulrbot_d,
   AdmsSensFadType & modelVar_wdepnulrsti_d,
   AdmsSensFadType & modelVar_wdepnulrgat_d,
   AdmsSensFadType & modelVar_wdepnulrinvbot_d,
   AdmsSensFadType & modelVar_wdepnulrinvsti_d,
   AdmsSensFadType & modelVar_wdepnulrinvgat_d,
   AdmsSensFadType & modelVar_VBIRBOTinv_d,
   AdmsSensFadType & modelVar_VBIRSTIinv_d,
   AdmsSensFadType & modelVar_VBIRGATinv_d,
   AdmsSensFadType & modelVar_atatbot_d,
   AdmsSensFadType & modelVar_atatsti_d,
   AdmsSensFadType & modelVar_atatgat_d,
   AdmsSensFadType & modelVar_btatpartbot_d,
   AdmsSensFadType & modelVar_btatpartsti_d,
   AdmsSensFadType & modelVar_btatpartgat_d,
   AdmsSensFadType & modelVar_fbbtbot_d,
   AdmsSensFadType & modelVar_fbbtsti_d,
   AdmsSensFadType & modelVar_fbbtgat_d,
   AdmsSensFadType & modelVar_fstopbot_d,
   AdmsSensFadType & modelVar_fstopsti_d,
   AdmsSensFadType & modelVar_fstopgat_d,
   AdmsSensFadType & modelVar_VBRinvbot_d,
   AdmsSensFadType & modelVar_VBRinvsti_d,
   AdmsSensFadType & modelVar_VBRinvgat_d,
   AdmsSensFadType & modelVar_slopebot_d,
   AdmsSensFadType & modelVar_slopesti_d,
   AdmsSensFadType & modelVar_slopegat_d,
   // non-reals
   int modelVar_CHNL_TYPE,
   // basic variables
   double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  AdmsSensFadType vth_i;
  AdmsSensFadType vts_i;
  AdmsSensFadType facvsb;
  AdmsSensFadType facvsb0;
  AdmsSensFadType P_D;
  AdmsSensFadType Vtovs;
  AdmsSensFadType Vtovd;
  AdmsSensFadType Igisl;
  AdmsSensFadType Igidl;
  AdmsSensFadType Sg;
  AdmsSensFadType igcd_h;
  AdmsSensFadType igc;
  AdmsSensFadType xsq;
  AdmsSensFadType inv_ex;
  AdmsSensFadType ex;
  AdmsSensFadType inv_x;
  AdmsSensFadType Ag;
  AdmsSensFadType Bg;
  AdmsSensFadType u0_div_H;
  AdmsSensFadType x;
  AdmsSensFadType u0;
  AdmsSensFadType Igc0;
  AdmsSensFadType Vm;
  AdmsSensFadType TP;
  AdmsSensFadType Dgate;
  AdmsSensFadType Dsi;
  AdmsSensFadType arg1;
  AdmsSensFadType zg;
  AdmsSensFadType psi_t;
  AdmsSensFadType arg2mina;
  AdmsSensFadType Igb;
  AdmsSensFadType Igc;
  AdmsSensFadType SP_OV_w;
  AdmsSensFadType SP_OV_xi;
  AdmsSensFadType SP_OV_q;
  AdmsSensFadType SP_OV_p;
  AdmsSensFadType SP_OV_temp;
  AdmsSensFadType SP_OV_D0;
  AdmsSensFadType SP_OV_y0;
  AdmsSensFadType SP_OV_tau;
  AdmsSensFadType SP_OV_c;
  AdmsSensFadType SP_OV_a;
  AdmsSensFadType SP_OV_eta;
  AdmsSensFadType SP_OV_z;
  AdmsSensFadType SP_OV_yg;
  AdmsSensFadType SP_OV_u;
  AdmsSensFadType SP_OV_x0;
  AdmsSensFadType SP_OV_xbar;
  AdmsSensFadType SP_OV_Afac;
  AdmsSensFadType inv_xg1;
  AdmsSensFadType x_mrg_ov;
  AdmsSensFadType inv_xi_ov;
  AdmsSensFadType xi_ov;
  AdmsSensFadType GOV2;
  AdmsSensFadType GOV;
  AdmsSensFadType Vdsat;
  AdmsSensFadType qeff;
  AdmsSensFadType Voxm;
  AdmsSensFadType qis;
  AdmsSensFadType delVsat;
  AdmsSensFadType alpha1;
  AdmsSensFadType zsat;
  AdmsSensFadType dL1;
  AdmsSensFadType dL;
  AdmsSensFadType r2;
  AdmsSensFadType r1;
  AdmsSensFadType qbm;
  AdmsSensFadType qim1_1;
  AdmsSensFadType Pm;
  AdmsSensFadType help;
  AdmsSensFadType km;
  AdmsSensFadType u_pd;
  AdmsSensFadType xi_pd;
  AdmsSensFadType q_pd;
  AdmsSensFadType p_pd;
  AdmsSensFadType x_pm;
  AdmsSensFadType d0;
  AdmsSensFadType D_bar;
  AdmsSensFadType xi0d;
  AdmsSensFadType qC;
  AdmsSensFadType pC;
  AdmsSensFadType delta_nd;
  AdmsSensFadType k_ds;
  AdmsSensFadType xn_d;
  AdmsSensFadType Phi_sat;
  AdmsSensFadType Phi0_Phi2;
  AdmsSensFadType Phi_0_2;
  AdmsSensFadType Phi_2;
  AdmsSensFadType asat;
  AdmsSensFadType Phi_0;
  AdmsSensFadType temp1;
  AdmsSensFadType za;
  AdmsSensFadType ysat;
  AdmsSensFadType phi_inf;
  AdmsSensFadType wsat;
  AdmsSensFadType temp2;
  AdmsSensFadType Mutmp;
  AdmsSensFadType Eeffm;
  AdmsSensFadType GR;
  AdmsSensFadType qbs;
  AdmsSensFadType xgs;
  AdmsSensFadType Rxcor;
  AdmsSensFadType Dd;
  AdmsSensFadType Dm;
  AdmsSensFadType Ed;
  AdmsSensFadType Em;
  AdmsSensFadType Ps;
  AdmsSensFadType Ds;
  AdmsSensFadType Es;
  AdmsSensFadType xi2s;
  AdmsSensFadType xi1s;
  AdmsSensFadType xi0s;
  AdmsSensFadType delta_1s;
  AdmsSensFadType x_ds;
  AdmsSensFadType x_m;
  AdmsSensFadType x_d;
  AdmsSensFadType SP_S_temp1;
  AdmsSensFadType SP_S_qC;
  AdmsSensFadType SP_S_pC;
  AdmsSensFadType SP_S_xi2;
  AdmsSensFadType SP_S_xi1;
  AdmsSensFadType SP_S_xi0;
  AdmsSensFadType SP_S_delta1;
  AdmsSensFadType SP_S_delta0;
  AdmsSensFadType SP_S_y0;
  AdmsSensFadType mutau;
  AdmsSensFadType nu;
  AdmsSensFadType SP_S_tau;
  AdmsSensFadType SP_S_c;
  AdmsSensFadType SP_S_a;
  AdmsSensFadType SP_S_temp;
  AdmsSensFadType SP_S_eta;
  AdmsSensFadType SP_S_ysub;
  AdmsSensFadType SP_S_yg;
  AdmsSensFadType SP_S_x0;
  AdmsSensFadType SP_S_b;
  AdmsSensFadType SP_S_temp2;
  AdmsSensFadType SP_S_bx;
  AdmsSensFadType SP_S_w;
  AdmsSensFadType SP_S_xbar;
  AdmsSensFadType SP_S_A_fac;
  AdmsSensFadType SP_xg1;
  AdmsSensFadType margin;
  AdmsSensFadType delta_ns;
  AdmsSensFadType xn_s;
  AdmsSensFadType Ux;
  AdmsSensFadType inv_xi;
  AdmsSensFadType xi;
  AdmsSensFadType inv_Gf2;
  AdmsSensFadType Gf2;
  AdmsSensFadType Gf;
  AdmsSensFadType Dnsub;
  AdmsSensFadType delVg;
  AdmsSensFadType Vsbx;
  double Vdsx;
  AdmsSensFadType Vgb1;
  AdmsSensFadType Vgbstar;
  AdmsSensFadType Vdbstar;
  AdmsSensFadType Vsbstar;
  AdmsSensFadType temp;
  double Vdb;
  double Vgd;
  AdmsSensFadType xgd_ov;
  AdmsSensFadType xgs_ov;
  double VgdPrime;
  double VdbPrime;
  double VsbPrime;
  double VgsPrime;
  double Vjun_d;
  double Vjun_s;
  double Vsb;
  double Vds;
  double Vgs;
  double Vrwell;
  double Vrbulk;
  double Vrjund;
  double Vrjuns;
  double Vrg;
  AdmsSensFadType Vovd;
  AdmsSensFadType Vovs;
  AdmsSensFadType xd_ov;
  AdmsSensFadType xs_ov;
  AdmsSensFadType xgm;
  AdmsSensFadType thesat1;
  AdmsSensFadType QCLM;
  AdmsSensFadType Udse;
  AdmsSensFadType GdL;
  AdmsSensFadType rhob;
  AdmsSensFadType sqm;
  AdmsSensFadType x_s;
  AdmsSensFadType SP_S_x1;
  AdmsSensFadType Qfgd;
  AdmsSensFadType Qfgs;
  AdmsSensFadType Qgb_ov;
  AdmsSensFadType Qgd_ov;
  AdmsSensFadType Qgs_ov;
  AdmsSensFadType Qb;
  AdmsSensFadType Qd;
  AdmsSensFadType Qg;
  AdmsSensFadType QB;
  AdmsSensFadType QD;
  AdmsSensFadType QI;
  AdmsSensFadType QG;
  AdmsSensFadType Fj2;
  AdmsSensFadType Fj;
  double Vgb;
  AdmsSensFadType rwellnoise;
  AdmsSensFadType rjundnoise;
  AdmsSensFadType rjunsnoise;
  AdmsSensFadType rbulknoise;
  AdmsSensFadType rgatenoise;
  AdmsSensFadType h1;
  AdmsSensFadType h2;
  AdmsSensFadType h2d;
  AdmsSensFadType h3;
  AdmsSensFadType h4;
  AdmsSensFadType h5;
  AdmsSensFadType ijunrev;
  AdmsSensFadType ijunfor2;
  AdmsSensFadType ijunfor1;
  AdmsSensFadType tm1;
  AdmsSensFadType tm0;
  AdmsSensFadType fbreakdown;
  AdmsSensFadType ibbt;
  AdmsSensFadType Fmaxr;
  AdmsSensFadType itat;
  AdmsSensFadType gammamax;
  AdmsSensFadType erfctimesexpmtat;
  AdmsSensFadType erfcpos;
  AdmsSensFadType terfc;
  AdmsSensFadType ysq;
  AdmsSensFadType xerfc;
  AdmsSensFadType mtat;
  AdmsSensFadType ltat;
  AdmsSensFadType ktat;
  AdmsSensFadType wtat;
  AdmsSensFadType wgamma;
  AdmsSensFadType umaxpoweronepointfive;
  AdmsSensFadType sqrtumax;
  AdmsSensFadType umax;
  AdmsSensFadType umaxbeforelimiting;
  AdmsSensFadType twoatatoverthreebtat;
  AdmsSensFadType btat;
  AdmsSensFadType isrh;
  AdmsSensFadType asrh;
  AdmsSensFadType wdep;
  AdmsSensFadType wsrh;
  AdmsSensFadType dwsrh;
  AdmsSensFadType wsrhstep;
  AdmsSensFadType vbi_minus_vjsrh;
  AdmsSensFadType id;
  AdmsSensFadType tmp;
  double vav;
  AdmsSensFadType vjsrh;
  AdmsSensFadType vjlim;
  AdmsSensFadType z;
  AdmsSensFadType idmult;
  AdmsSensFadType zinv;
  AdmsSensFadType vj;
  AdmsSensFadType two_psistar;
  AdmsSensFadType vbbt;
  AdmsSensFadType Qs;
  AdmsSensFadType shot_igd;
  AdmsSensFadType shot_igs;
  AdmsSensFadType jnoisex_d;
  AdmsSensFadType jnoisex_s;
  AdmsSensFadType shot_iavl;
  AdmsSensFadType shot_igdov;
  AdmsSensFadType shot_igsov;
  AdmsSensFadType shot_igcdx;
  AdmsSensFadType shot_igcsx;
  AdmsSensFadType Sidexc;
  AdmsSensFadType gfac;
  AdmsSensFadType Gvsat_exc;
  AdmsSensFadType zsat_exc;
  AdmsSensFadType thesat1_exc;
  AdmsSensFadType temp_exc;
  AdmsSensFadType wsat_exc;
  AdmsSensFadType temp2_exc;
  AdmsSensFadType g_ideal;
  AdmsSensFadType lcinv2;
  AdmsSensFadType lc;
  AdmsSensFadType r;
  AdmsSensFadType t2;
  AdmsSensFadType sqt2;
  AdmsSensFadType t1;
  AdmsSensFadType H0;
  AdmsSensFadType Delta_N1;
  AdmsSensFadType Nm1;
  AdmsSensFadType N1;
  AdmsSensFadType sqig;
  AdmsSensFadType sqid;
  AdmsSensFadType CGeff;
  AdmsSensFadType c_igid;
  AdmsSensFadType migid;
  AdmsSensFadType mig;
  AdmsSensFadType mid;
  AdmsSensFadType Sfl;


  // -- code converted from analog/code block
  //Begin block evaluateblock
  {
    //Block-local variables for block evaluateblock
    AdmsSensFadType alpha;
    AdmsSensFadType eta_p;
    AdmsSensFadType xitsb;
    AdmsSensFadType FdL;
    AdmsSensFadType Gmob;
    AdmsSensFadType Gmob_dL;
    AdmsSensFadType Gvsat;
    AdmsSensFadType Gvsatinv;
    AdmsSensFadType dps;
    AdmsSensFadType qim;
    AdmsSensFadType qim1;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    AdmsSensFadType H;
    AdmsSensFadType Iimpact;
    AdmsSensFadType mavl;
    AdmsSensFadType Ids;
    AdmsSensFadType Vdse;
    AdmsSensFadType Igsov;
    AdmsSensFadType Igdov;
    AdmsSensFadType Igcs;
    AdmsSensFadType Igcd;
    AdmsSensFadType xg;
    double sigVds;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    AdmsSensFadType COX_qm;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    AdmsSensFadType ijun_s;
    AdmsSensFadType ijunbot_s;
    AdmsSensFadType ijunsti_s;
    AdmsSensFadType ijungat_s;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    AdmsSensFadType ijun_d;
    AdmsSensFadType ijunbot_d;
    AdmsSensFadType ijunsti_d;
    AdmsSensFadType ijungat_d;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    AdmsSensFadType qjun_s;
    AdmsSensFadType qjunbot_s;
    AdmsSensFadType qjunsti_s;
    AdmsSensFadType qjungat_s;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    AdmsSensFadType qjun_d;
    AdmsSensFadType qjunbot_d;
    AdmsSensFadType qjunsti_d;
    AdmsSensFadType qjungat_d;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    AdmsSensFadType jnoise_s;
    AdmsSensFadType jnoise_d;
    //End of Block-local variables
    //Begin block evaluateStatic
    {
      SP_S_x1 = 0.0;
      x_s = 0.0;
      sqm = 0.0;
      alpha = 0.0;
      eta_p = 1.0;
      xitsb = 0.0;
      rhob = 0.0;
      GdL = 1.0;
      FdL = 1.0;
      Gmob = 1.0;
      Gmob_dL = 1.0;
      Udse = 0.0;
      QCLM = 0.0;
      thesat1 = 0.0;
      Gvsat = 1.0;
      Gvsatinv = 1.0;
      xgm = 0.0;
      dps = 0.0;
      qim = 0.0;
      qim1 = 0.0;
      H = 1.0;
      xs_ov = 0.0;
      xd_ov = 0.0;
      Vovs = 0.0;
      Vovd = 0.0;
      Iimpact = 0.0;
      mavl = 0.0;
      Vrg = (probeVars[admsProbeID_V_G_GP]);
      Vrjuns = (probeVars[admsProbeID_V_BS_BI]);
      Vrjund = (probeVars[admsProbeID_V_BD_BI]);
      Vrbulk = (probeVars[admsProbeID_V_BP_BI]);
      Vrwell = (probeVars[admsProbeID_V_B_BI]);
      if ((modelVar_CHNL_TYPE==(+1)))
      {
        Vgs = (probeVars[admsProbeID_V_GP_S]);
        Vds = (probeVars[admsProbeID_V_D_S]);
        Vsb = (probeVars[admsProbeID_V_S_BP]);
        Vjun_s = (-(probeVars[admsProbeID_V_S_BS]));
        Vjun_d = (-(probeVars[admsProbeID_V_D_BD]));
      }
      else
      {
        Vgs = (-(probeVars[admsProbeID_V_GP_S]));
        Vds = (-(probeVars[admsProbeID_V_D_S]));
        Vsb = (-(probeVars[admsProbeID_V_S_BP]));
        Vjun_s = (probeVars[admsProbeID_V_S_BS]);
        Vjun_d = (probeVars[admsProbeID_V_D_BD]);
      }
      VgsPrime = Vgs;
      VsbPrime = Vsb;
      VdbPrime = (Vds+Vsb);
      VgdPrime = (Vgs-Vds);
      xgs_ov = ((-VgsPrime)*modelVar_inv_phit);
      xgd_ov = ((-VgdPrime)*modelVar_inv_phit);
      sigVds = 1.0;
      if ((Vds<0.0))
      {
        sigVds = (-1.0);
        Vgs = (Vgs-Vds);
        Vsb = (Vsb+Vds);
        Vds = (-Vds);
      }
      Vgd = (Vgs-Vds);
      Vdb = (Vds+Vsb);
      {
        AdmsSensFadType value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+instanceVar_bphi));
        temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+instanceVar_phix);
      }
      {
        AdmsSensFadType value_sqrt_0 = sqrt((((temp)*(temp))+instanceVar_aphi));
        Vsbstar = ((Vsb-(0.5*((temp)-value_sqrt_0)))+instanceVar_phix1);
      }
      Vdbstar = (Vds+Vsbstar);
      Vgbstar = (Vgs+Vsbstar);
      Vgb1 = (Vgbstar-instanceVar_VFB_i);
      {
        double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
        Vdsx = (value_sqrt_0-0.1);
      }
      Vsbx = (Vsbstar+(0.5*(Vds-Vdsx)));
      delVg = (instanceVar_CF_i*(Vdsx*(1+(instanceVar_CFB_i*Vsbx))));
      Vgb1 = (Vgb1+delVg);
      xg = (Vgb1*instanceVar_inv_phit1);
      if ((instanceVar_DNSUB_i>0.0))
      {
        {
          AdmsSensFadType value_sqrt_0 = sqrt((((-((Vgs+Vsb)-instanceVar_VNSUB_i))*(-((Vgs+Vsb)-instanceVar_VNSUB_i)))+instanceVar_NSLP_i));
          Dnsub = ((instanceVar_DNSUB_i*0.5)*((+((Vgs+Vsb)-instanceVar_VNSUB_i))+value_sqrt_0));
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt((1.0+Dnsub));
          Gf = (instanceVar_G_0*value_sqrt_0);
        }
      }
      else
      {
        Gf = instanceVar_G_0;
      }
      Gf2 = (Gf*Gf);
      inv_Gf2 = (1.0/Gf2);
      xi = (1.0+(Gf*7.0710678118654746e-01));
      inv_xi = (1.0/xi);
      Ux = (Vsbstar*instanceVar_inv_phit1);
      xn_s = ((instanceVar_phib*instanceVar_inv_phit1)+Ux);
      if ((xn_s<4.6051701859880916e+02))
      {
        {
          AdmsSensFadType value_exp_0 = exp((-xn_s));
          delta_ns = value_exp_0;
        }
      }
      else
      {
        delta_ns = (1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
      }
      margin = (1e-5*xi);
      if ((fabs(xg)<=margin))
      {
        SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
        x_s = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
      }
      else
      {
        if ((xg<(-margin)))
        {
          SP_S_yg = (-xg);
          SP_S_ysub = (1.25*(SP_S_yg*inv_xi));
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0));
            SP_S_eta = (0.5*((SP_S_ysub+10)-value_sqrt_0));
          }
          SP_S_temp = (SP_S_yg-SP_S_eta);
          SP_S_a = ((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0)));
          SP_S_c = ((2.0*SP_S_temp)-Gf2);
          {
            AdmsSensFadType value_log_0 = log((SP_S_a*inv_Gf2));
            SP_S_tau = ((-SP_S_eta)+value_log_0);
          }
          nu = (SP_S_a+SP_S_c);
          mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
          SP_S_y0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
          if ((SP_S_y0<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp(SP_S_y0);
              SP_S_delta0 = value_exp_0;
            }
          }
          else
          {
            SP_S_delta0 = (1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
          }
          SP_S_delta1 = (1.0/SP_S_delta0);
          SP_S_temp = (1.0/(2.0+(SP_S_y0*SP_S_y0)));
          SP_S_xi0 = ((SP_S_y0*SP_S_y0)*SP_S_temp);
          SP_S_xi1 = (4.0*((SP_S_y0*SP_S_temp)*SP_S_temp));
          SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
          SP_S_temp = (SP_S_yg-SP_S_y0);
          SP_S_temp1 = (delta_ns*SP_S_delta1);
          SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
          SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
          SP_S_temp = (2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
          SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
          {
            AdmsSensFadType value_sqrt_0 = sqrt(SP_S_temp);
            x_s = ((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
          }
        }
        else
        {
          SP_xg1 = (1.0/(instanceVar_x1+(Gf*7.324648775608221e-001)));
          SP_S_A_fac = ((((xi*instanceVar_x1)*SP_xg1)-1.0)*SP_xg1);
          SP_S_xbar = ((xg*inv_xi)*(1.0+(SP_S_A_fac*xg)));
          if (((-SP_S_xbar)>(-2.3025850929940458e+02)))
          {
            {
              AdmsSensFadType value_exp_0 = exp((-SP_S_xbar));
              SP_S_temp = value_exp_0;
            }
          }
          else
          {
            SP_S_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
          }
          SP_S_w = (1.0-SP_S_temp);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((xg+(Gf2*0.25))-SP_S_w));
            SP_S_x1 = ((xg+(Gf2*0.5))-(Gf*value_sqrt_0));
          }
          SP_S_bx = (xn_s+3.0);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
            AdmsSensFadType value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
            SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
          }
          SP_S_temp = (xg-SP_S_eta);
          {
            AdmsSensFadType value_exp_0 = exp((-SP_S_eta));
            SP_S_temp1 = value_exp_0;
          }
          SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));
          SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);
          SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
          SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
          {
            AdmsSensFadType value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))));
            SP_S_a = value_max_0;
          }
          SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))));
          SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
          {
            AdmsSensFadType value_log_0 = log((SP_S_a/Gf2));
            SP_S_tau = ((xn_s-SP_S_eta)+value_log_0);
          }
          nu = (SP_S_a+SP_S_c);
          mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
          SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
          if ((SP_S_x0<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp(SP_S_x0);
              SP_S_delta0 = value_exp_0;
            }
            SP_S_delta1 = (1.0/SP_S_delta0);
            SP_S_delta0 = (delta_ns*SP_S_delta0);
          }
          else
          {
            if ((SP_S_x0>(xn_s-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp((SP_S_x0-xn_s));
                SP_S_delta0 = value_exp_0;
              }
              SP_S_delta1 = (delta_ns/SP_S_delta0);
            }
            else
            {
              SP_S_delta0 = (1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));
          SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);
          SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
          SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
          SP_S_temp = (xg-SP_S_x0);
          SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
          SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
          SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
          SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
          {
            AdmsSensFadType value_sqrt_0 = sqrt(SP_S_temp);
            x_s = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
          }
        }
      }
      x_d = x_s;
      x_m = x_s;
      x_ds = 0.0;
      if ((xg<=0.0))
      {
        qis = 0.0;
        Ids = 0.0;
        xgm = (xg-x_s);
        Voxm = (xgm*instanceVar_phit1);
        qeff = Voxm;
        Vdsat = instanceVar_Vdsat_lim;
        Vdse = Vds;
      }
      else
      {
        delta_1s = 0.0;
        temp = (1.0/(2.0+(x_s*x_s)));
        xi0s = ((x_s*x_s)*temp);
        xi1s = (4.0*((x_s*temp)*temp));
        xi2s = ((((8.0*temp)-(12.0*xi0s))*temp)*temp);
        if ((x_s<2.3025850929940458e+02))
        {
          {
            AdmsSensFadType value_exp_0 = exp(x_s);
            delta_1s = value_exp_0;
          }
          Es = (1.0/delta_1s);
          delta_1s = (delta_ns*delta_1s);
        }
        else
        {
          if ((x_s>(xn_s-2.3025850929940458e+02)))
          {
            {
              AdmsSensFadType value_exp_0 = exp((x_s-xn_s));
              delta_1s = value_exp_0;
            }
            Es = (delta_ns/delta_1s);
          }
          else
          {
            delta_1s = (1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            Es = (1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
          }
        }
        Ds = (delta_1s-(delta_ns*((x_s+1.0)+xi0s)));
        if ((x_s<1.0e-5))
        {
          Ps = (0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))));
          Ds = (1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s))));
          {
            AdmsSensFadType value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
            temp = value_sqrt_0;
          }
          sqm = (7.0710678118654746e-01*(x_s*temp));
          alpha = (1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp));
        }
        else
        {
          Ps = ((x_s-1.0)+Es);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(Ps);
            sqm = value_sqrt_0;
          }
          alpha = (1.0+(0.5*((Gf*(1.0-Es))/sqm)));
        }
        Em = Es;
        Ed = Em;
        Dm = Ds;
        Dd = Dm;
        Rxcor = ((1.0+((0.2*instanceVar_XCOR_i)*Vsbx))/(1.0+(instanceVar_XCOR_i*Vsbx)));
        if ((Ds>1.0e-100))
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt((Ps+Ds));
            xgs = (Gf*value_sqrt_0);
          }
          qis = (((Gf2*Ds)*instanceVar_phit1)/(xgs+(Gf*sqm)));
          qbs = ((sqm*Gf)*instanceVar_phit1);
          if ((instanceVar_RSB_i<0))
          {
            rhob = (1.0/(1.0-(instanceVar_RSB_i*Vsbx)));
          }
          else
          {
            rhob = (1.0+(instanceVar_RSB_i*Vsbx));
          }
          if ((instanceVar_RSG_i<0))
          {
            temp = (1.0-(instanceVar_RSG_i*qis));
          }
          else
          {
            temp = (1.0/(1.0+(instanceVar_RSG_i*qis)));
          }
          GR = (instanceVar_THER_i*((rhob*temp)*qis));
          Eeffm = (instanceVar_E_eff0*(qbs+(instanceVar_eta_mu*qis)));
          {
            AdmsSensFadType value_pow_0 = pow((Eeffm*instanceVar_MUE_i),instanceVar_THEMU_i);
            Mutmp = (value_pow_0+(instanceVar_CS_i*(Ps/((Ps+Ds)+1.0e-14))));
          }
          Gmob = (((1.0+Mutmp)+GR)*Rxcor);
          if ((instanceVar_THESATB_i<0))
          {
            xitsb = (1.0/(1.0-(instanceVar_THESATB_i*Vsbx)));
          }
          else
          {
            xitsb = (1.0+(instanceVar_THESATB_i*Vsbx));
          }
          temp2 = (qis*xitsb);
          wsat = (100.0*(temp2/(100.0+temp2)));
          if ((instanceVar_THESATG_i<0))
          {
            temp = (1/(1-(instanceVar_THESATG_i*wsat)));
          }
          else
          {
            temp = (1+(instanceVar_THESATG_i*wsat));
          }
          thesat1 = (instanceVar_THESAT_i*(temp/Gmob));
          phi_inf = ((qis/alpha)+instanceVar_phit1);
          ysat = ((thesat1*phi_inf)*7.0710678118654746e-01);
          if ((modelVar_CHNL_TYPE==(-1)))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0+ysat));
              ysat = (ysat/value_sqrt_0);
            }
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((1.0+(4.0*ysat)));
            za = (2.0/(1.0+value_sqrt_0));
          }
          temp1 = (za*ysat);
          Phi_0 = ((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
          asat = (xgs+(0.5*Gf2));
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((asat*asat)-((Gf2*Ds)*0.98)));
            Phi_2 = (0.98*(((Gf2*Ds)*instanceVar_phit1)/(asat+value_sqrt_0)));
          }
          Phi_0_2 = (Phi_0+Phi_2);
          Phi0_Phi2 = (2.0*(Phi_0*Phi_2));
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)));
            Phi_sat = (Phi0_Phi2/(Phi_0_2+value_sqrt_0));
          }
          {
            AdmsSensFadType value_log_0 = log((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*instanceVar_phit1)))*inv_Gf2)/((instanceVar_phit1*instanceVar_phit1)*Ds))));
            Vdsat = (Phi_sat-(instanceVar_phit1*value_log_0));
          }
        }
        else
        {
          Vdsat = instanceVar_Vdsat_lim;
        }
        {
          AdmsSensFadType value_pow_0 = pow((Vds/Vdsat),instanceVar_AX_i);
          temp = value_pow_0;
        }
        {
          AdmsSensFadType value_pow_0 = pow((1.0+temp),(-instanceVar_inv_AX));
          Vdse = (Vds*value_pow_0);
        }
        Udse = (Vdse*instanceVar_inv_phit1);
        xn_d = (xn_s+Udse);
        if ((Udse<4.6051701859880916e+02))
        {
          {
            AdmsSensFadType value_exp_0 = exp((-Udse));
            k_ds = value_exp_0;
          }
        }
        else
        {
          k_ds = (1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
        }
        delta_nd = (delta_ns*k_ds);
        if ((fabs(xg)<=margin))
        {
          SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
          x_d = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
        }
        else
        {
          SP_S_bx = (xn_d+3);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
            AdmsSensFadType value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
            SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
          }
          SP_S_temp = (xg-SP_S_eta);
          {
            AdmsSensFadType value_exp_0 = exp((-SP_S_eta));
            SP_S_temp1 = value_exp_0;
          }
          SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));
          SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);
          SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
          SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
          {
            AdmsSensFadType value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))));
            SP_S_a = value_max_0;
          }
          SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))));
          SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
          {
            AdmsSensFadType value_log_0 = log((SP_S_a/Gf2));
            SP_S_tau = ((xn_d-SP_S_eta)+value_log_0);
          }
          nu = (SP_S_a+SP_S_c);
          mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
          SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
          if ((SP_S_x0<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp(SP_S_x0);
              SP_S_delta0 = value_exp_0;
            }
            SP_S_delta1 = (1.0/SP_S_delta0);
            SP_S_delta0 = (delta_nd*SP_S_delta0);
          }
          else
          {
            if ((SP_S_x0>(xn_d-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp((SP_S_x0-xn_d));
                SP_S_delta0 = value_exp_0;
              }
              SP_S_delta1 = (delta_nd/SP_S_delta0);
            }
            else
            {
              SP_S_delta0 = (1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));
          SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);
          SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
          SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
          SP_S_temp = (xg-SP_S_x0);
          SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
          SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
          SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
          SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
          {
            AdmsSensFadType value_sqrt_0 = sqrt(SP_S_temp);
            x_d = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
          }
        }
        x_ds = (x_d-x_s);
        if ((x_ds<1.0E-10))
        {
          pC = ((2.0*(xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
          qC = ((Gf2*(1.0-k_ds))*Ds);
          temp = (2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
          temp = ((pC*pC)-(2.0*(temp*qC)));
          {
            AdmsSensFadType value_sqrt_0 = sqrt(temp);
            x_ds = (2.0*(qC/(pC+value_sqrt_0)));
          }
          x_d = (x_s+x_ds);
        }
        dps = (x_ds*instanceVar_phit1);
        xi0d = ((x_d*x_d)/(2.0+(x_d*x_d)));
        if ((x_d<2.3025850929940458e+02))
        {
          {
            AdmsSensFadType value_exp_0 = exp((-x_d));
            Ed = value_exp_0;
          }
          if ((x_d<1.0e-5))
          {
            Dd = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
          }
          else
          {
            Dd = (delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d));
          }
        }
        else
        {
          if ((x_d>(xn_d-2.3025850929940458e+02)))
          {
            {
              AdmsSensFadType value_exp_0 = exp((x_d-xn_d));
              temp = value_exp_0;
            }
            Ed = (delta_nd/temp);
            Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
          }
          else
          {
            Ed = (1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            temp = (1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
          }
        }
        x_m = (0.5*(x_s+x_d));
        Em = 0.0;
        temp = (Ed*Es);
        if ((temp>0.0))
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt(temp);
            Em = value_sqrt_0;
          }
        }
        D_bar = (0.5*(Ds+Dd));
        Dm = (D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))));
        if ((x_m<1.0e-5))
        {
          Pm = (0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))));
          {
            AdmsSensFadType value_sqrt_0 = sqrt((Dm+Pm));
            xgm = (Gf*value_sqrt_0);
          }
          if ((instanceVar_kp>0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0+(instanceVar_kp*xgm)));
              eta_p = (1.0/value_sqrt_0);
            }
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
            temp = value_sqrt_0;
          }
          sqm = (7.0710678118654746e-01*(x_m*temp));
          alpha = (eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)));
        }
        else
        {
          Pm = ((x_m-1.0)+Em);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((Dm+Pm));
            xgm = (Gf*value_sqrt_0);
          }
          if ((instanceVar_kp>0.0))
          {
            d0 = ((1.0-Em)+(2.0*(xgm*inv_Gf2)));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0+(instanceVar_kp*xgm)));
              eta_p = (1.0/value_sqrt_0);
            }
            temp = (eta_p/(eta_p+1.0));
            x_pm = (instanceVar_kp*(((temp*temp)*Gf2)*Dm));
            p_pd = ((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm)));
            q_pd = (x_pm*(x_pm-(2.0*xgm)));
            xi_pd = (1.0-(0.5*(Gf2*(Em+Dm))));
            u_pd = ((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd)));
            x_m = (x_m+u_pd);
            {
              AdmsSensFadType value_exp_0 = exp(u_pd);
              km = value_exp_0;
            }
            Em = (Em/km);
            Dm = (Dm*km);
            Pm = ((x_m-1.0)+Em);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((Dm+Pm));
              xgm = (Gf*value_sqrt_0);
            }
            help = ((1.0-Em)+(2.0*((xgm*eta_p)*inv_Gf2)));
            x_ds = (((x_ds*km)*(d0+D_bar))/(help+(km*D_bar)));
            dps = (x_ds*instanceVar_phit1);
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt(Pm);
            sqm = value_sqrt_0;
          }
          alpha = (eta_p+(0.5*((Gf*(1.0-Em))/sqm)));
        }
        qim = (instanceVar_phit1*((Gf2*Dm)/(xgm+(Gf*sqm))));
        qim1 = (qim+(instanceVar_phit1*alpha));
        qim1_1 = (1.0/qim1);
        qbm = ((sqm*Gf)*instanceVar_phit1);
        if ((instanceVar_RSG_i<0))
        {
          temp = (1.0-(instanceVar_RSG_i*qim));
        }
        else
        {
          temp = (1.0/(1.0+(instanceVar_RSG_i*qim)));
        }
        GR = (instanceVar_THER_i*((rhob*temp)*qim));
        qeff = (qbm+(instanceVar_eta_mu*qim));
        Eeffm = (instanceVar_E_eff0*qeff);
        {
          AdmsSensFadType value_pow_0 = pow((Eeffm*instanceVar_MUE_i),instanceVar_THEMU_i);
          Mutmp = (value_pow_0+(instanceVar_CS_i*(Pm/((Pm+Dm)+1.0e-14))));
        }
        Gmob = (((1.0+Mutmp)+GR)*Rxcor);
        r1 = (qim*qim1_1);
        r2 = (instanceVar_phit1*(alpha*qim1_1));
        {
          AdmsSensFadType value_log_0 = log(((1.0+((Vds-dps)*instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceVar_inv_VP))));
          temp = value_log_0;
        }
        {
          AdmsSensFadType value_log_0 = log((1.0+(Vdsx*instanceVar_inv_VP)));
          temp1 = value_log_0;
        }
        dL = (instanceVar_ALP_i*temp);
        GdL = (1.0/((1.0+dL)+(dL*dL)));
        dL1 = ((dL+(instanceVar_ALP1_i*((qim1_1*r1)*temp)))+(instanceVar_ALP2_i*(((qbm*r2)*r2)*temp1)));
        FdL = (((1.0+dL1)+(dL1*dL1))*GdL);
        temp2 = (qim*xitsb);
        wsat = (100.0*(temp2/(100.0+temp2)));
        Gmob_dL = (Gmob*GdL);
        if ((instanceVar_THESATG_i<0))
        {
          temp = (1/(1-(instanceVar_THESATG_i*wsat)));
        }
        else
        {
          temp = (1+(instanceVar_THESATG_i*wsat));
        }
        thesat1 = (instanceVar_THESAT_i*(temp/Gmob_dL));
        zsat = (((thesat1*thesat1)*dps)*dps);
        if ((modelVar_CHNL_TYPE==(-1)))
        {
          zsat = (zsat/(1.0+(thesat1*dps)));
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt((1.0+(2.0*zsat)));
          Gvsat = (0.5*(Gmob_dL*(1.0+value_sqrt_0)));
        }
        Gvsatinv = (1.0/Gvsat);
        Ids = (instanceVar_BET_i*(((FdL*qim1)*dps)*Gvsatinv));
        Voxm = (xgm*instanceVar_phit1);
        temp = (Gmob_dL*Gvsatinv);
        alpha1 = (alpha*(1.0+(0.5*((zsat*temp)*temp))));
        H = ((temp*qim1)/alpha1);
        if ((modelPar_SWIMPACT!=0))
        {
          delVsat = (Vds-(instanceVar_A3_i*dps));
          if ((delVsat>0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((instanceVar_phib+Vsbstar));
              temp2 = (instanceVar_A2_i*((1.0+(instanceVar_A4_i*(value_sqrt_0-instanceVar_sqrt_phib)))/(delVsat+1e-30)));
            }
            if ((fabs((-temp2))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((-temp2));
                temp = value_exp_0;
              }
            }
            else
            {
              if (((-temp2)<(-2.3025850929940458e+02)))
              {
                temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
              }
              else
              {
                temp = (1.0e100*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            mavl = (instanceVar_A1_i*(delVsat*temp));
            Iimpact = (Ids*mavl);
          }
        }
      }
      if ((((((modelPar_SWIGATE!=0)&&((instanceVar_IGOV_i>0)||(instanceVar_IGOVD_i>0)))||((modelPar_SWGIDL!=0)&&((instanceVar_AGIDL_i>0)||(instanceVar_AGIDLD_i>0))))||(instanceVar_CGOV_i>0))||(instanceVar_CGOVD_i>0)))
      {
        GOV = instanceVar_GOV_s;
        GOV2 = instanceVar_GOV2_s;
        xi_ov = instanceVar_xi_ov_s;
        inv_xi_ov = instanceVar_inv_xi_ov_s;
        x_mrg_ov = instanceVar_x_mrg_ov_s;
        inv_xg1 = instanceVar_inv_xg1_s;
        if ((fabs(xgs_ov)<=x_mrg_ov))
        {
          xs_ov = ((-xgs_ov)*inv_xi_ov);
        }
        else
        {
          if ((xgs_ov<(-x_mrg_ov)))
          {
            SP_OV_yg = (-xgs_ov);
            SP_OV_z = ((instanceVar_x1*SP_OV_yg)*inv_xi_ov);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
              SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
            }
            SP_OV_a = (((SP_OV_yg-SP_OV_eta)*(SP_OV_yg-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));
            SP_OV_c = ((2.0*(SP_OV_yg-SP_OV_eta))-GOV2);
            {
              AdmsSensFadType value_log_0 = log((SP_OV_a/GOV2));
              SP_OV_tau = (value_log_0-SP_OV_eta);
            }
            nu = (SP_OV_a+SP_OV_c);
            mutau = ((nu*nu)+(SP_OV_tau*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));
            SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*nu)*SP_OV_tau)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
            {
              AdmsSensFadType value_exp_0 = exp(SP_OV_y0);
              SP_OV_D0 = value_exp_0;
            }
            SP_OV_temp = (SP_OV_yg-SP_OV_y0);
            SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));
            SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));
            SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
            SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
            {
              AdmsSensFadType value_sqrt_0 = sqrt(SP_OV_temp);
              SP_OV_w = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
            }
            xs_ov = (-(SP_OV_y0+SP_OV_w));
          }
          else
          {
            SP_OV_Afac = ((((xi_ov*instanceVar_x1)*inv_xg1)-1.0)*inv_xg1);
            SP_OV_xbar = ((xgs_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ov)));
            if (((-SP_OV_xbar)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp((-SP_OV_xbar));
                SP_OV_temp = value_exp_0;
              }
            }
            else
            {
              SP_OV_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
            }
            SP_OV_w = (1.0-SP_OV_temp);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w));
              SP_OV_x0 = ((xgs_ov+(GOV2*0.5))-(GOV*value_sqrt_0));
            }
            if (((-SP_OV_x0)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp((-SP_OV_x0));
                SP_OV_D0 = value_exp_0;
              }
            }
            else
            {
              SP_OV_D0 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
            }
            SP_OV_p = ((2.0*(xgs_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));
            SP_OV_q = (((xgs_ov-SP_OV_x0)*(xgs_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));
            SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
            SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
            {
              AdmsSensFadType value_sqrt_0 = sqrt(SP_OV_temp);
              SP_OV_u = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
            }
            xs_ov = (SP_OV_x0+SP_OV_u);
          }
          xs_ov = (-xs_ov);
        }
        GOV = instanceVar_GOV_d;
        GOV2 = instanceVar_GOV2_d;
        xi_ov = instanceVar_xi_ov_d;
        inv_xi_ov = instanceVar_inv_xi_ov_d;
        x_mrg_ov = instanceVar_x_mrg_ov_d;
        inv_xg1 = instanceVar_inv_xg1_d;
        if ((fabs(xgd_ov)<=x_mrg_ov))
        {
          xd_ov = ((-xgd_ov)*inv_xi_ov);
        }
        else
        {
          if ((xgd_ov<(-x_mrg_ov)))
          {
            SP_OV_yg = (-xgd_ov);
            SP_OV_z = ((instanceVar_x1*SP_OV_yg)*inv_xi_ov);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
              SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
            }
            SP_OV_a = (((SP_OV_yg-SP_OV_eta)*(SP_OV_yg-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));
            SP_OV_c = ((2.0*(SP_OV_yg-SP_OV_eta))-GOV2);
            {
              AdmsSensFadType value_log_0 = log((SP_OV_a/GOV2));
              SP_OV_tau = (value_log_0-SP_OV_eta);
            }
            nu = (SP_OV_a+SP_OV_c);
            mutau = ((nu*nu)+(SP_OV_tau*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));
            SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*nu)*SP_OV_tau)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
            {
              AdmsSensFadType value_exp_0 = exp(SP_OV_y0);
              SP_OV_D0 = value_exp_0;
            }
            SP_OV_temp = (SP_OV_yg-SP_OV_y0);
            SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));
            SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));
            SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
            SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
            {
              AdmsSensFadType value_sqrt_0 = sqrt(SP_OV_temp);
              SP_OV_w = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
            }
            xd_ov = (-(SP_OV_y0+SP_OV_w));
          }
          else
          {
            SP_OV_Afac = ((((xi_ov*instanceVar_x1)*inv_xg1)-1.0)*inv_xg1);
            SP_OV_xbar = ((xgd_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ov)));
            if (((-SP_OV_xbar)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp((-SP_OV_xbar));
                SP_OV_temp = value_exp_0;
              }
            }
            else
            {
              SP_OV_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
            }
            SP_OV_w = (1.0-SP_OV_temp);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w));
              SP_OV_x0 = ((xgd_ov+(GOV2*0.5))-(GOV*value_sqrt_0));
            }
            if (((-SP_OV_x0)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp((-SP_OV_x0));
                SP_OV_D0 = value_exp_0;
              }
            }
            else
            {
              SP_OV_D0 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
            }
            SP_OV_p = ((2.0*(xgd_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));
            SP_OV_q = (((xgd_ov-SP_OV_x0)*(xgd_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));
            SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
            SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
            {
              AdmsSensFadType value_sqrt_0 = sqrt(SP_OV_temp);
              SP_OV_u = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
            }
            xd_ov = (SP_OV_x0+SP_OV_u);
          }
          xd_ov = (-xd_ov);
        }
        Vovs = ((-modelVar_phit)*(xgs_ov+xs_ov));
        Vovd = ((-modelVar_phit)*(xgd_ov+xd_ov));
      }
      Igsov = 0.0;
      Igdov = 0.0;
      Igc = 0.0;
      Igb = 0.0;
      Igcs = 0.0;
      Igcd = 0.0;
      if ((modelPar_SWIGATE!=0))
      {
        if ((instanceVar_IGOV_i>0))
        {
          arg2mina = (Vovs+instanceVar_Dov);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
            psi_t = (0.5*((+arg2mina)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((Vovs*Vovs)+1.0e-6));
            zg = (value_sqrt_0*instanceVar_inv_CHIB);
          }
          if ((instanceVar_GC3_i<0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((zg-instanceVar_GCQ)*(zg-instanceVar_GCQ))+1.0e-6));
              zg = (0.5*((zg+instanceVar_GCQ)-value_sqrt_0));
            }
          }
          arg1 = ((3.0+xs_ov)+(psi_t*modelVar_inv_phit));
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp(arg1);
              Dsi = value_exp_0;
            }
          }
          else
          {
            if ((arg1<(-2.3025850929940458e+02)))
            {
              Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {
              Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          arg1 = ((-VgsPrime)*modelVar_inv_phit);
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp(arg1);
              temp = value_exp_0;
            }
          }
          else
          {
            if ((arg1<(-2.3025850929940458e+02)))
            {
              temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {
              temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          Dgate = (Dsi*temp);
          temp = (instanceVar_BOV*((-1.5)+(zg*(instanceVar_GC2_i+(instanceVar_GC3_i*zg)))));
          if ((temp>0))
          {
            TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
          }
          else
          {
            if ((temp>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(temp);
                TP = value_exp_0;
              }
            }
            else
            {
              TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            }
          }
          {
            AdmsSensFadType value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
            Igsov = (instanceVar_IGOV_i*(TP*value_log_0));
          }
        }
        if ((instanceVar_IGOVD_i>0))
        {
          arg2mina = (Vovd+instanceVar_Dov);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
            psi_t = (0.5*((+arg2mina)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((Vovd*Vovd)+1.0e-6));
            zg = (value_sqrt_0*instanceVar_inv_CHIB);
          }
          if ((instanceVar_GC3_i<0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((zg-instanceVar_GCQ)*(zg-instanceVar_GCQ))+1.0e-6));
              zg = (0.5*((zg+instanceVar_GCQ)-value_sqrt_0));
            }
          }
          arg1 = ((3.0+xd_ov)+(psi_t*modelVar_inv_phit));
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp(arg1);
              Dsi = value_exp_0;
            }
          }
          else
          {
            if ((arg1<(-2.3025850929940458e+02)))
            {
              Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {
              Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          arg1 = ((-VgdPrime)*modelVar_inv_phit);
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp(arg1);
              temp = value_exp_0;
            }
          }
          else
          {
            if ((arg1<(-2.3025850929940458e+02)))
            {
              temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {
              temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          Dgate = (Dsi*temp);
          temp = (instanceVar_BOV_d*((-1.5)+(zg*(instanceVar_GC2_i+(instanceVar_GC3_i*zg)))));
          if ((temp>0))
          {
            TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
          }
          else
          {
            if ((temp>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(temp);
                TP = value_exp_0;
              }
            }
            else
            {
              TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            }
          }
          {
            AdmsSensFadType value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
            Igdov = (instanceVar_IGOVD_i*(TP*value_log_0));
          }
        }
        if ((instanceVar_IGINV_i>0))
        {
          if ((xg<=0.0))
          {
            {
              AdmsSensFadType value_pow_0 = pow((Vds/instanceVar_Vdsat_lim),instanceVar_AX_i);
              temp = value_pow_0;
            }
            {
              AdmsSensFadType value_pow_0 = pow((1.0+temp),(-instanceVar_inv_AX));
              Udse = ((Vds*value_pow_0)*instanceVar_inv_phit1);
            }
          }
          if (((x_ds-Udse)>(-2.3025850929940458e+02)))
          {
            {
              AdmsSensFadType value_exp_0 = exp((x_ds-Udse));
              temp = value_exp_0;
            }
          }
          else
          {
            temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
          }
          {
            AdmsSensFadType value_log_0 = log((0.5*(1.0+temp)));
            Vm = (Vsbstar+(instanceVar_phit1*((0.5*x_ds)-value_log_0)));
          }
          arg2mina = (Voxm+instanceVar_Dch);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
            psi_t = (0.5*((+arg2mina)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((Voxm*Voxm)+1.0e-6));
            zg = (value_sqrt_0*instanceVar_inv_CHIB);
          }
          if ((instanceVar_GC3_i<0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((zg-instanceVar_GCQ)*(zg-instanceVar_GCQ))+1.0e-06));
              zg = (0.5*((zg+instanceVar_GCQ)-value_sqrt_0));
            }
          }
          arg1 = (x_m+(((psi_t-instanceVar_alpha_b)-Vm)*instanceVar_inv_phit1));
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp(arg1);
              Dsi = value_exp_0;
            }
          }
          else
          {
            if ((arg1<(-2.3025850929940458e+02)))
            {
              Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {
              Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          arg1 = ((-((Vgs+Vsbstar)-Vm))*instanceVar_inv_phit1);
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp(arg1);
              temp = value_exp_0;
            }
          }
          else
          {
            if ((arg1<(-2.3025850929940458e+02)))
            {
              temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {
              temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          Dgate = (Dsi*temp);
          temp = (instanceVar_BCH*((-1.5)+(zg*(instanceVar_GC2_i+(instanceVar_GC3_i*zg)))));
          if ((temp>0))
          {
            TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
          }
          else
          {
            if ((temp>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(temp);
                TP = value_exp_0;
              }
            }
            else
            {
              TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            }
          }
          {
            AdmsSensFadType value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
            Igc0 = (instanceVar_IGINV_i*(TP*value_log_0));
          }
          if (((xg<=0)||((instanceVar_GC2_i==0)&&(instanceVar_GC3_i==0))))
          {
            igc = 1.0;
            igcd_h = 0.5;
          }
          else
          {
            temp = (instanceVar_GC2_i+((2.0*instanceVar_GC3_i)*zg));
            u0 = (instanceVar_CHIB_i/(temp*instanceVar_BCH));
            x = (0.5*(dps/u0));
            u0_div_H = (u0/H);
            Bg = ((u0_div_H*(1.0-u0_div_H))*0.5);
            Ag = (0.5-(3.0*Bg));
            if ((x<1.0e-3))
            {
              xsq = (x*x);
              igc = (1.0+(xsq*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));
              igcd_h = ((0.5*igc)-(1.6666666666666667e-01*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))));
            }
            else
            {
              inv_x = (1.0/x);
              if ((fabs(x)<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(x);
                  ex = value_exp_0;
                }
              }
              else
              {
                if ((x<(-2.3025850929940458e+02)))
                {
                  ex = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
                }
                else
                {
                  ex = (1.0e100*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              inv_ex = (1.0/ex);
              temp = (ex-inv_ex);
              temp2 = (ex+inv_ex);
              igc = (0.5*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2)));
              igcd_h = (0.5*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x)));
            }
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((xg*xg)+1.0e-6));
            Sg = (0.5*(1.0+(xg/value_sqrt_0)));
          }
          Igc = ((Igc0*igc)*Sg);
          Igcd = ((Igc0*igcd_h)*Sg);
          Igcs = (Igc-Igcd);
          Igb = ((Igc0*igc)*(1.0-Sg));
        }
      }
      Igidl = 0.0;
      Igisl = 0.0;
      if ((modelPar_SWGIDL!=0))
      {
        if (((instanceVar_AGIDLD_i>0)&&(Vovd<0)))
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((Vovd*Vovd)+((instanceVar_CGIDLD_i*instanceVar_CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6));
            Vtovd = value_sqrt_0;
          }
          temp = ((-instanceVar_BGIDLDs)/Vtovd);
          if ((temp>(-2.3025850929940458e+02)))
          {
            {
              AdmsSensFadType value_exp_0 = exp(temp);
              temp2 = value_exp_0;
            }
          }
          else
          {
            temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
          }
          Igidl = ((-instanceVar_AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*temp2));
        }
        if (((instanceVar_AGIDL_i>0)&&(Vovs<0)))
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((Vovs*Vovs)+((instanceVar_CGIDL_i*instanceVar_CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6));
            Vtovs = value_sqrt_0;
          }
          temp = ((-instanceVar_BGIDLs)/Vtovs);
          if ((temp>(-2.3025850929940458e+02)))
          {
            {
              AdmsSensFadType value_exp_0 = exp(temp);
              temp2 = value_exp_0;
            }
          }
          else
          {
            temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
          }
          Igisl = ((-instanceVar_AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*temp2));
        }
      }
      P_D = (1+(0.25*(Gf*instanceVar_kp)));
      facvsb0 = (instanceVar_phib+(2*instanceVar_phit1));
      facvsb = (Vsbstar+facvsb0);
      {
        AdmsSensFadType value_sqrt_0 = sqrt((instanceVar_phit1*facvsb));
        vts_i = (((instanceVar_VFB_i+(P_D*facvsb))-Vsbstar)+(Gf*value_sqrt_0));
      }
      vth_i = (vts_i-delVg);
    }
    // End block evaluateStatic
    //Begin block evaluateDynamic
    {
      Vgb = (Vgs+Vsb);
      COX_qm = instanceVar_COX_i;
      if ((instanceVar_qq>0.0))
      {
        {
          AdmsSensFadType value_pow_0 = pow(((qeff*qeff)+instanceVar_qlim2),((-1.0)*1.6666666666666667e-01));
          COX_qm = (instanceVar_COX_i/(1.0+(instanceVar_qq*value_pow_0)));
        }
      }
      if ((xg<=0.0))
      {
        QG = Voxm;
        QI = 0.0;
        QD = 0.0;
        QB = QG;
      }
      else
      {
        Fj = (0.5*(dps/H));
        Fj2 = (Fj*Fj);
        QCLM = ((1.0-GdL)*(qim-(0.5*(alpha*dps))));
        QG = (Voxm+(0.5*((eta_p*dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))));
        temp = ((alpha*dps)*1.6666666666666667e-01);
        QI = ((GdL*(qim+(temp*Fj)))+QCLM);
        QD = (0.5*(((GdL*GdL)*(qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL))));
        QB = (QG-QI);
      }
      Qg = (QG*COX_qm);
      Qd = ((-QD)*COX_qm);
      Qb = ((-QB)*COX_qm);
      Qgs_ov = (instanceVar_CGOV_i*Vovs);
      Qgd_ov = (instanceVar_CGOVD_i*Vovd);
      Qgb_ov = (instanceVar_CGBOV_i*Vgb);
      Qfgs = (instanceVar_CFR_i*VgsPrime);
      Qfgd = (instanceVar_CFRD_i*VgdPrime);
    }
    // End block evaluateDynamic
    ijun_s = 0.0;
    ijunbot_s = 0.0;
    ijunsti_s = 0.0;
    ijungat_s = 0.0;
    ijun_d = 0.0;
    ijunbot_d = 0.0;
    ijunsti_d = 0.0;
    ijungat_d = 0.0;
    qjun_s = 0.0;
    qjunbot_s = 0.0;
    qjunsti_s = 0.0;
    qjungat_s = 0.0;
    qjun_d = 0.0;
    qjunbot_d = 0.0;
    qjunsti_d = 0.0;
    qjungat_d = 0.0;
    //Begin block evaluateStaticDynamic
    {
      if ((modelPar_SWJUNCAP>0.0))
      {
        if ((modelVar_SWJUNEXP_i==1.0))
        {
          tm0 = ((Vjun_s*modelVar_phitdinv)*instanceVar_MFOR1_s);
          {
            AdmsSensFadType value_exp_0 = exp(tm0);
            tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighf1_s),(instanceVar_expxhf1_s*((tm0-instanceVar_xhighf1_s)+1)),value_exp_0));
          }
          ijunfor1 = (instanceVar_ISATFOR1_s*(tm1-1.0));
          tm0 = ((Vjun_s*modelVar_phitdinv)*instanceVar_MFOR2_s);
          {
            AdmsSensFadType value_exp_0 = exp(tm0);
            tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighf2_s),(instanceVar_expxhf2_s*((tm0-instanceVar_xhighf2_s)+1)),value_exp_0));
          }
          ijunfor2 = (instanceVar_ISATFOR2_s*(tm1-1.0));
          ijunrev = 0.0;
          if ((instanceVar_m0flag_s>0))
          {
            ijunrev = (Vjun_s*(instanceVar_ISATREV_s+(Vjun_s*instanceVar_MREV_s)));
          }
          else
          {
            tm0 = (((-Vjun_s)*modelVar_phitdinv)*instanceVar_MREV_s);
            {
              AdmsSensFadType value_exp_0 = exp(tm0);
              tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighr_s),(instanceVar_expxhr_s*((tm0-instanceVar_xhighr_s)+1)),value_exp_0));
            }
            ijunrev = ((-instanceVar_ISATREV_s)*(tm1-1.0));
          }
          ijun_s = ((ijunfor1+ijunfor2)+ijunrev);
          tm0 = ((Vjun_d*modelVar_phitdinv)*instanceVar_MFOR1_d);
          {
            AdmsSensFadType value_exp_0 = exp(tm0);
            tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighf1_d),(instanceVar_expxhf1_d*((tm0-instanceVar_xhighf1_d)+1)),value_exp_0));
          }
          ijunfor1 = (instanceVar_ISATFOR1_d*(tm1-1.0));
          tm0 = ((Vjun_d*modelVar_phitdinv)*instanceVar_MFOR2_d);
          {
            AdmsSensFadType value_exp_0 = exp(tm0);
            tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighf2_d),(instanceVar_expxhf2_d*((tm0-instanceVar_xhighf2_d)+1)),value_exp_0));
          }
          ijunfor2 = (instanceVar_ISATFOR2_d*(tm1-1.0));
          ijunrev = 0.0;
          if ((instanceVar_m0flag_d>0))
          {
            ijunrev = (Vjun_d*(instanceVar_ISATREV_d+(Vjun_d*instanceVar_MREV_d)));
          }
          else
          {
            tm0 = (((-Vjun_d)*modelVar_phitdinv)*instanceVar_MREV_d);
            {
              AdmsSensFadType value_exp_0 = exp(tm0);
              tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighr_d),(instanceVar_expxhr_d*((tm0-instanceVar_xhighr_d)+1)),value_exp_0));
            }
            ijunrev = ((-instanceVar_ISATREV_d)*(tm1-1.0));
          }
          ijun_d = ((ijunfor1+ijunfor2)+ijunrev);
          //Begin block evaluateDynamic
          {
            //Block-local variables for block evaluateDynamic
            AdmsSensFadType tmpv;
            AdmsSensFadType vjv;
            //End of Block-local variables
            tmpv = 0.0;
            vjv = 0.0;
            h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
            h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
            h2d = (Vjun_s+(instanceVar_vch_s*h2));
            h3 = (instanceVar_vfmin_s+h2d);
            h4 = (instanceVar_vfmin_s-h2d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
              h5 = value_sqrt_0;
            }
            vjv = (2.0*((Vjun_s*instanceVar_vfmin_s)/(h3+h5)));
            if ((instanceVar_zflagbot_s>0.5))
            {
              if ((modelVar_one_minus_PBOT==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1-(vjv*modelVar_vbiinvbot)));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1-(vjv*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
                  tmpv = value_pow_0;
                }
              }
              qjunbot_s = ((modelVar_qprefbot*(1-tmpv))+(modelVar_qpref2bot*(Vjun_s-vjv)));
            }
            if ((instanceVar_zflagsti_s>0.5))
            {
              if ((modelVar_one_minus_PSTI==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1-(vjv*modelVar_vbiinvsti)));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1-(vjv*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
                  tmpv = value_pow_0;
                }
              }
              qjunsti_s = ((modelVar_qprefsti*(1-tmpv))+(modelVar_qpref2sti*(Vjun_s-vjv)));
            }
            if ((instanceVar_zflaggat_s>0.5))
            {
              if ((modelVar_one_minus_PGAT==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1-(vjv*modelVar_vbiinvgat)));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1-(vjv*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
                  tmpv = value_pow_0;
                }
              }
              qjungat_s = ((modelVar_qprefgat*(1-tmpv))+(modelVar_qpref2gat*(Vjun_s-vjv)));
            }
            tmpv = 0.0;
            vjv = 0.0;
            h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
            h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
            h2d = (Vjun_d+(instanceVar_vch_d*h2));
            h3 = (instanceVar_vfmin_d+h2d);
            h4 = (instanceVar_vfmin_d-h2d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
              h5 = value_sqrt_0;
            }
            vjv = (2.0*((Vjun_d*instanceVar_vfmin_d)/(h3+h5)));
            if ((instanceVar_zflagbot_d>0.5))
            {
              if ((modelVar_one_minus_PBOT_d==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1-(vjv*modelVar_vbiinvbot_d)));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1-(vjv*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
                  tmpv = value_pow_0;
                }
              }
              qjunbot_d = ((modelVar_qprefbot_d*(1-tmpv))+(modelVar_qpref2bot_d*(Vjun_d-vjv)));
            }
            if ((instanceVar_zflagsti_d>0.5))
            {
              if ((modelVar_one_minus_PSTI_d==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1-(vjv*modelVar_vbiinvsti_d)));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1-(vjv*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
                  tmpv = value_pow_0;
                }
              }
              qjunsti_d = ((modelVar_qprefsti_d*(1-tmpv))+(modelVar_qpref2sti_d*(Vjun_d-vjv)));
            }
            if ((instanceVar_zflaggat_d>0.5))
            {
              if ((modelVar_one_minus_PGAT_d==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1-(vjv*modelVar_vbiinvgat_d)));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1-(vjv*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
                  tmpv = value_pow_0;
                }
              }
              qjungat_d = ((modelVar_qprefgat_d*(1-tmpv))+(modelVar_qpref2gat_d*(Vjun_d-vjv)));
            }
          }
          // End block evaluateDynamic
        }
        else
        {
          vbbt = 0.0;
          two_psistar = 0.0;
          if ((!(((instanceVar_ABSOURCE_i==0)&&(instanceVar_LSSOURCE_i==0))&&(instanceVar_LGSOURCE_i==0))))
          {
            h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
            h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
            h2d = (Vjun_s+(instanceVar_vch_s*h2));
            h3 = (instanceVar_vfmin_s+h2d);
            h4 = (instanceVar_vfmin_s-h2d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
              h5 = value_sqrt_0;
            }
            vj = (2.0*((Vjun_s*instanceVar_vfmin_s)/(h3+h5)));
            if ((Vjun_s<instanceVar_VMAX_s))
            {
              if ((fabs((0.5*(Vjun_s*modelVar_phitdinv)))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp((0.5*(Vjun_s*modelVar_phitdinv)));
                  zinv = value_exp_0;
                }
              }
              else
              {
                if (((0.5*(Vjun_s*modelVar_phitdinv))<(-2.3025850929940458e+02)))
                {
                  zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
                }
                else
                {
                  zinv = (1.0e100*(1.0+(((0.5*(Vjun_s*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_s*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              idmult = (zinv*zinv);
            }
            else
            {
              idmult = ((1+((Vjun_s-instanceVar_VMAX_s)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_s);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(idmult);
                zinv = value_sqrt_0;
              }
            }
            idmult = (idmult-1.0);
            z = (1/zinv);
            if ((Vjun_s>0))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
                AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
                two_psistar = (2.0*(modelVar_phitd*value_log_1));
              }
            }
            else
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
                AdmsSensFadType value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
                two_psistar = ((-Vjun_s)+(2.0*(modelVar_phitd*value_log_1)));
              }
            }
            vjlim = (instanceVar_vbimin_s-two_psistar);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((Vjun_s-vjlim)*(Vjun_s-vjlim))+((4*modelVar_phitd)*modelVar_phitd)));
              vjsrh = (0.5*((Vjun_s+vjlim)-value_sqrt_0));
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((Vjun_s-instanceVar_vbbtlim_s)*(Vjun_s-instanceVar_vbbtlim_s))+((4*modelVar_phitr)*modelVar_phitr)));
              vbbt = (0.5*((Vjun_s+instanceVar_vbbtlim_s)-value_sqrt_0));
            }
            {
              double value_sqrt_0 = sqrt((((Vjun_s)*(Vjun_s))+((4*1E-6)*1E-6)));
              vav = (0.5*((Vjun_s)-value_sqrt_0));
            }
          }
          if ((instanceVar_ABSOURCE_i==0))
          {
            ijunbot_s = 0;
            qjunbot_s = 0;
          }
          else
          {
            if ((modelVar_one_minus_PBOT==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvbot)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
                tmp = value_pow_0;
              }
            }
            qjunbot_s = ((modelVar_qprefbot*(1-tmp))+(modelVar_qpref2bot*(Vjun_s-vj)));
            id = (modelVar_idsatbot*idmult);
            if (((modelVar_CSRHBOT_i==0)&&(modelVar_CTATBOT_i==0)))
            {
              isrh = 0;
            }
            else
            {
              vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
                wsrhstep = (1-value_sqrt_0);
              }
              if ((modelVar_PBOT_i==0.5))
              {
                dwsrh = 0;
              }
              else
              {
                {
                  AdmsSensFadType value_log_0 = log(wsrhstep);
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PBOT_i)));
                }
              }
              wsrh = (wsrhstep+dwsrh);
              if ((modelVar_PBOT_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                  tmp = value_pow_0;
                }
              }
              wdep = (modelVar_wdepnulrbot*tmp);
              asrh = (modelVar_ftdbot*((zinv-1)*wdep));
              isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
            }
            if ((modelVar_CTATBOT_i==0))
            {
              itat = 0;
            }
            else
            {
              btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
              twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
                umax = value_sqrt_0;
              }
              {
                AdmsSensFadType value_fabs_0 = fabs(umax);
                AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
                sqrtumax = value_sqrt_1;
              }
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1)))
              {
                wgamma = (1/(1+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
                  wgamma = value_pow_0;
                }
              }
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                ktat = value_sqrt_0;
              }
              ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
              mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
              xerfc = ((ltat-1)*ktat);
              ysq = (xerfc*xerfc);
              if ((xerfc>0))
              {
                terfc = (1/(1+(modelVar_perfc*xerfc)));
              }
              else
              {
                terfc = (1/(1-(modelVar_perfc*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }
              erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0))
              {
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp(mtat);
                    tmp = value_exp_0;
                  }
                }
                else
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }
                erfctimesexpmtat = ((2*tmp)-erfcpos);
              }
              gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
              itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
            }
            if ((modelVar_CBBTBOT_i==0))
            {
              ibbt = 0;
            }
            else
            {
              if ((modelVar_PBOT_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                  tmp = value_pow_0;
                }
              }
              Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
              if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot)/Fmaxr));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {
                  tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              ibbt = (modelVar_CBBTBOT_i*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
            }
            if ((modelVar_VBRBOT_i>1000))
            {
              fbreakdown = 1;
            }
            else
            {
              if ((vav>((-0.999)*modelVar_VBRBOT_i)))
              {
                if ((modelVar_PBRBOT_i==4))
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                    AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvbot));
                    AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvbot));
                    AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvbot));
                    tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                  }
                }
                else
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                    AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOT_i);
                    tmp = value_pow_1;
                  }
                }
                fbreakdown = (1/(1-tmp));
              }
              else
              {
                fbreakdown = (modelVar_fstopbot+((vav+(0.999*modelVar_VBRBOT_i))*modelVar_slopebot));
              }
            }
            ijunbot_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((instanceVar_LSSOURCE_i==0))
          {
            ijunsti_s = 0;
            qjunsti_s = 0;
          }
          else
          {
            if ((modelVar_one_minus_PSTI==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvsti)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
                tmp = value_pow_0;
              }
            }
            qjunsti_s = ((modelVar_qprefsti*(1-tmp))+(modelVar_qpref2sti*(Vjun_s-vj)));
            id = (modelVar_idsatsti*idmult);
            if (((modelVar_CSRHSTI_i==0)&&(modelVar_CTATSTI_i==0)))
            {
              isrh = 0;
            }
            else
            {
              vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
                wsrhstep = (1-value_sqrt_0);
              }
              if ((modelVar_PSTI_i==0.5))
              {
                dwsrh = 0;
              }
              else
              {
                {
                  AdmsSensFadType value_log_0 = log(wsrhstep);
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PSTI_i)));
                }
              }
              wsrh = (wsrhstep+dwsrh);
              if ((modelVar_PSTI_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                  tmp = value_pow_0;
                }
              }
              wdep = (modelVar_wdepnulrsti*tmp);
              asrh = (modelVar_ftdsti*((zinv-1)*wdep));
              isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
            }
            if ((modelVar_CTATSTI_i==0))
            {
              itat = 0;
            }
            else
            {
              btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
              twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
                umax = value_sqrt_0;
              }
              {
                AdmsSensFadType value_fabs_0 = fabs(umax);
                AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
                sqrtumax = value_sqrt_1;
              }
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1)))
              {
                wgamma = (1/(1+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
                  wgamma = value_pow_0;
                }
              }
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                ktat = value_sqrt_0;
              }
              ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
              mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
              xerfc = ((ltat-1)*ktat);
              ysq = (xerfc*xerfc);
              if ((xerfc>0))
              {
                terfc = (1/(1+(modelVar_perfc*xerfc)));
              }
              else
              {
                terfc = (1/(1-(modelVar_perfc*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }
              erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0))
              {
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp(mtat);
                    tmp = value_exp_0;
                  }
                }
                else
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }
                erfctimesexpmtat = ((2*tmp)-erfcpos);
              }
              gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
              itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
            }
            if ((modelVar_CBBTSTI_i==0))
            {
              ibbt = 0;
            }
            else
            {
              if ((modelVar_PSTI_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                  tmp = value_pow_0;
                }
              }
              Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
              if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti)/Fmaxr));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {
                  tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              ibbt = (modelVar_CBBTSTI_i*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
            }
            if ((modelVar_VBRSTI_i>1000))
            {
              fbreakdown = 1;
            }
            else
            {
              if ((vav>((-0.999)*modelVar_VBRSTI_i)))
              {
                if ((modelVar_PBRSTI_i==4))
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                    AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvsti));
                    AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvsti));
                    AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvsti));
                    tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                  }
                }
                else
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                    AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTI_i);
                    tmp = value_pow_1;
                  }
                }
                fbreakdown = (1/(1-tmp));
              }
              else
              {
                fbreakdown = (modelVar_fstopsti+((vav+(0.999*modelVar_VBRSTI_i))*modelVar_slopesti));
              }
            }
            ijunsti_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((instanceVar_LGSOURCE_i==0))
          {
            ijungat_s = 0;
            qjungat_s = 0;
          }
          else
          {
            if ((modelVar_one_minus_PGAT==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvgat)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
                tmp = value_pow_0;
              }
            }
            qjungat_s = ((modelVar_qprefgat*(1-tmp))+(modelVar_qpref2gat*(Vjun_s-vj)));
            id = (modelVar_idsatgat*idmult);
            if (((modelVar_CSRHGAT_i==0)&&(modelVar_CTATGAT_i==0)))
            {
              isrh = 0;
            }
            else
            {
              vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
                wsrhstep = (1-value_sqrt_0);
              }
              if ((modelVar_PGAT_i==0.5))
              {
                dwsrh = 0;
              }
              else
              {
                {
                  AdmsSensFadType value_log_0 = log(wsrhstep);
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PGAT_i)));
                }
              }
              wsrh = (wsrhstep+dwsrh);
              if ((modelVar_PGAT_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
                  tmp = value_pow_0;
                }
              }
              wdep = (modelVar_wdepnulrgat*tmp);
              asrh = (modelVar_ftdgat*((zinv-1)*wdep));
              isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
            }
            if ((modelVar_CTATGAT_i==0))
            {
              itat = 0;
            }
            else
            {
              btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
              twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
                umax = value_sqrt_0;
              }
              {
                AdmsSensFadType value_fabs_0 = fabs(umax);
                AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
                sqrtumax = value_sqrt_1;
              }
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1)))
              {
                wgamma = (1/(1+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
                  wgamma = value_pow_0;
                }
              }
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                ktat = value_sqrt_0;
              }
              ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
              mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
              xerfc = ((ltat-1)*ktat);
              ysq = (xerfc*xerfc);
              if ((xerfc>0))
              {
                terfc = (1/(1+(modelVar_perfc*xerfc)));
              }
              else
              {
                terfc = (1/(1-(modelVar_perfc*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }
              erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0))
              {
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp(mtat);
                    tmp = value_exp_0;
                  }
                }
                else
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }
                erfctimesexpmtat = ((2*tmp)-erfcpos);
              }
              gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
              itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
            }
            if ((modelVar_CBBTGAT_i==0))
            {
              ibbt = 0;
            }
            else
            {
              if ((modelVar_PGAT_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
                  tmp = value_pow_0;
                }
              }
              Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
              if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat)/Fmaxr));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {
                  tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              ibbt = (modelVar_CBBTGAT_i*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
            }
            if ((modelVar_VBRGAT_i>1000))
            {
              fbreakdown = 1;
            }
            else
            {
              if ((vav>((-0.999)*modelVar_VBRGAT_i)))
              {
                if ((modelVar_PBRGAT_i==4))
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                    AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvgat));
                    AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvgat));
                    AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvgat));
                    tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                  }
                }
                else
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                    AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGAT_i);
                    tmp = value_pow_1;
                  }
                }
                fbreakdown = (1/(1-tmp));
              }
              else
              {
                fbreakdown = (modelVar_fstopgat+((vav+(0.999*modelVar_VBRGAT_i))*modelVar_slopegat));
              }
            }
            ijungat_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          ijun_s = (((instanceVar_ABSOURCE_i*ijunbot_s)+(instanceVar_LSSOURCE_i*ijunsti_s))+(instanceVar_LGSOURCE_i*ijungat_s));
          vbbt = 0.0;
          two_psistar = 0.0;
          if ((!(((instanceVar_ABDRAIN_i==0)&&(instanceVar_LSDRAIN_i==0))&&(instanceVar_LGDRAIN_i==0))))
          {
            h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
            h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
            h2d = (Vjun_d+(instanceVar_vch_d*h2));
            h3 = (instanceVar_vfmin_d+h2d);
            h4 = (instanceVar_vfmin_d-h2d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
              h5 = value_sqrt_0;
            }
            vj = (2.0*((Vjun_d*instanceVar_vfmin_d)/(h3+h5)));
            if ((Vjun_d<instanceVar_VMAX_d))
            {
              if ((fabs((0.5*(Vjun_d*modelVar_phitdinv)))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp((0.5*(Vjun_d*modelVar_phitdinv)));
                  zinv = value_exp_0;
                }
              }
              else
              {
                if (((0.5*(Vjun_d*modelVar_phitdinv))<(-2.3025850929940458e+02)))
                {
                  zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
                }
                else
                {
                  zinv = (1.0e100*(1.0+(((0.5*(Vjun_d*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_d*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              idmult = (zinv*zinv);
            }
            else
            {
              idmult = ((1+((Vjun_d-instanceVar_VMAX_d)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_d);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(idmult);
                zinv = value_sqrt_0;
              }
            }
            idmult = (idmult-1.0);
            z = (1/zinv);
            if ((Vjun_d>0))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
                AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
                two_psistar = (2.0*(modelVar_phitd*value_log_1));
              }
            }
            else
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
                AdmsSensFadType value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
                two_psistar = ((-Vjun_d)+(2.0*(modelVar_phitd*value_log_1)));
              }
            }
            vjlim = (instanceVar_vbimin_d-two_psistar);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((Vjun_d-vjlim)*(Vjun_d-vjlim))+((4*modelVar_phitd)*modelVar_phitd)));
              vjsrh = (0.5*((Vjun_d+vjlim)-value_sqrt_0));
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((Vjun_d-instanceVar_vbbtlim_d)*(Vjun_d-instanceVar_vbbtlim_d))+((4*modelVar_phitr)*modelVar_phitr)));
              vbbt = (0.5*((Vjun_d+instanceVar_vbbtlim_d)-value_sqrt_0));
            }
            {
              double value_sqrt_0 = sqrt((((Vjun_d)*(Vjun_d))+((4*1E-6)*1E-6)));
              vav = (0.5*((Vjun_d)-value_sqrt_0));
            }
          }
          if ((instanceVar_ABDRAIN_i==0))
          {
            ijunbot_d = 0;
            qjunbot_d = 0;
          }
          else
          {
            if ((modelVar_one_minus_PBOT_d==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvbot_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
                tmp = value_pow_0;
              }
            }
            qjunbot_d = ((modelVar_qprefbot_d*(1-tmp))+(modelVar_qpref2bot_d*(Vjun_d-vj)));
            id = (modelVar_idsatbot_d*idmult);
            if (((modelVar_CSRHBOTD_i==0)&&(modelVar_CTATBOTD_i==0)))
            {
              isrh = 0;
            }
            else
            {
              vbi_minus_vjsrh = (modelVar_vbibot_d-vjsrh);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
                wsrhstep = (1-value_sqrt_0);
              }
              if ((modelVar_PBOTD_i==0.5))
              {
                dwsrh = 0;
              }
              else
              {
                {
                  AdmsSensFadType value_log_0 = log(wsrhstep);
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PBOTD_i)));
                }
              }
              wsrh = (wsrhstep+dwsrh);
              if ((modelVar_PBOTD_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                  tmp = value_pow_0;
                }
              }
              wdep = (modelVar_wdepnulrbot_d*tmp);
              asrh = (modelVar_ftdbot_d*((zinv-1)*wdep));
              isrh = (modelVar_CSRHBOTD_i*(asrh*wsrh));
            }
            if ((modelVar_CTATBOTD_i==0))
            {
              itat = 0;
            }
            else
            {
              btat = (modelVar_btatpartbot_d*((wdep*modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
              twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot_d)/btat);
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
                umax = value_sqrt_0;
              }
              {
                AdmsSensFadType value_fabs_0 = fabs(umax);
                AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
                sqrtumax = value_sqrt_1;
              }
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d)==(-1)))
              {
                wgamma = (1/(1+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d));
                  wgamma = value_pow_0;
                }
              }
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                ktat = value_sqrt_0;
              }
              ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
              mtat = ((((modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
              xerfc = ((ltat-1)*ktat);
              ysq = (xerfc*xerfc);
              if ((xerfc>0))
              {
                terfc = (1/(1+(modelVar_perfc*xerfc)));
              }
              else
              {
                terfc = (1/(1-(modelVar_perfc*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }
              erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0))
              {
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp(mtat);
                    tmp = value_exp_0;
                  }
                }
                else
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }
                erfctimesexpmtat = ((2*tmp)-erfcpos);
              }
              gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot_d*erfctimesexpmtat)/ktat));
              itat = (modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
            }
            if ((modelVar_CBBTBOTD_i==0))
            {
              ibbt = 0;
            }
            else
            {
              if ((modelVar_PBOTD_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                  tmp = value_pow_0;
                }
              }
              Fmaxr = (modelVar_one_over_one_minus_PBOT_d*(((modelVar_VBIRBOTD_i-vbbt)*modelVar_wdepnulrinvbot_d)/tmp));
              if ((fabs(((-modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot_d)/Fmaxr));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-modelVar_fbbtbot_d)/Fmaxr)<(-2.3025850929940458e+02)))
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {
                  tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              ibbt = (modelVar_CBBTBOTD_i*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
            }
            if ((modelVar_VBRBOTD_i>1000))
            {
              fbreakdown = 1;
            }
            else
            {
              if ((vav>((-0.999)*modelVar_VBRBOTD_i)))
              {
                if ((modelVar_PBRBOTD_i==4))
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                    AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvbot_d));
                    AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvbot_d));
                    AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvbot_d));
                    tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                  }
                }
                else
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                    AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOTD_i);
                    tmp = value_pow_1;
                  }
                }
                fbreakdown = (1/(1-tmp));
              }
              else
              {
                fbreakdown = (modelVar_fstopbot_d+((vav+(0.999*modelVar_VBRBOTD_i))*modelVar_slopebot_d));
              }
            }
            ijunbot_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((instanceVar_LSDRAIN_i==0))
          {
            ijunsti_d = 0;
            qjunsti_d = 0;
          }
          else
          {
            if ((modelVar_one_minus_PSTI_d==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvsti_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
                tmp = value_pow_0;
              }
            }
            qjunsti_d = ((modelVar_qprefsti_d*(1-tmp))+(modelVar_qpref2sti_d*(Vjun_d-vj)));
            id = (modelVar_idsatsti_d*idmult);
            if (((modelVar_CSRHSTID_i==0)&&(modelVar_CTATSTID_i==0)))
            {
              isrh = 0;
            }
            else
            {
              vbi_minus_vjsrh = (modelVar_vbisti_d-vjsrh);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
                wsrhstep = (1-value_sqrt_0);
              }
              if ((modelVar_PSTID_i==0.5))
              {
                dwsrh = 0;
              }
              else
              {
                {
                  AdmsSensFadType value_log_0 = log(wsrhstep);
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PSTID_i)));
                }
              }
              wsrh = (wsrhstep+dwsrh);
              if ((modelVar_PSTID_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                  tmp = value_pow_0;
                }
              }
              wdep = (modelVar_wdepnulrsti_d*tmp);
              asrh = (modelVar_ftdsti_d*((zinv-1)*wdep));
              isrh = (modelVar_CSRHSTID_i*(asrh*wsrh));
            }
            if ((modelVar_CTATSTID_i==0))
            {
              itat = 0;
            }
            else
            {
              btat = (modelVar_btatpartsti_d*((wdep*modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
              twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti_d)/btat);
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
                umax = value_sqrt_0;
              }
              {
                AdmsSensFadType value_fabs_0 = fabs(umax);
                AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
                sqrtumax = value_sqrt_1;
              }
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d)==(-1)))
              {
                wgamma = (1/(1+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d));
                  wgamma = value_pow_0;
                }
              }
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                ktat = value_sqrt_0;
              }
              ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
              mtat = ((((modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
              xerfc = ((ltat-1)*ktat);
              ysq = (xerfc*xerfc);
              if ((xerfc>0))
              {
                terfc = (1/(1+(modelVar_perfc*xerfc)));
              }
              else
              {
                terfc = (1/(1-(modelVar_perfc*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }
              erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0))
              {
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp(mtat);
                    tmp = value_exp_0;
                  }
                }
                else
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }
                erfctimesexpmtat = ((2*tmp)-erfcpos);
              }
              gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti_d*erfctimesexpmtat)/ktat));
              itat = (modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
            }
            if ((modelVar_CBBTSTID_i==0))
            {
              ibbt = 0;
            }
            else
            {
              if ((modelVar_PSTID_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                  tmp = value_pow_0;
                }
              }
              Fmaxr = (modelVar_one_over_one_minus_PSTI_d*(((modelVar_VBIRSTID_i-vbbt)*modelVar_wdepnulrinvsti_d)/tmp));
              if ((fabs(((-modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti_d)/Fmaxr));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-modelVar_fbbtsti_d)/Fmaxr)<(-2.3025850929940458e+02)))
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {
                  tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              ibbt = (modelVar_CBBTSTID_i*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
            }
            if ((modelVar_VBRSTID_i>1000))
            {
              fbreakdown = 1;
            }
            else
            {
              if ((vav>((-0.999)*modelVar_VBRSTID_i)))
              {
                if ((modelVar_PBRSTID_i==4))
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                    AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvsti_d));
                    AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvsti_d));
                    AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvsti_d));
                    tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                  }
                }
                else
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                    AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTID_i);
                    tmp = value_pow_1;
                  }
                }
                fbreakdown = (1/(1-tmp));
              }
              else
              {
                fbreakdown = (modelVar_fstopsti_d+((vav+(0.999*modelVar_VBRSTID_i))*modelVar_slopesti_d));
              }
            }
            ijunsti_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((instanceVar_LGDRAIN_i==0))
          {
            ijungat_d = 0;
            qjungat_d = 0;
          }
          else
          {
            if ((modelVar_one_minus_PGAT_d==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1-(vj*modelVar_vbiinvgat_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1-(vj*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
                tmp = value_pow_0;
              }
            }
            qjungat_d = ((modelVar_qprefgat_d*(1-tmp))+(modelVar_qpref2gat_d*(Vjun_d-vj)));
            id = (modelVar_idsatgat_d*idmult);
            if (((modelVar_CSRHGATD_i==0)&&(modelVar_CTATGATD_i==0)))
            {
              isrh = 0;
            }
            else
            {
              vbi_minus_vjsrh = (modelVar_vbigat_d-vjsrh);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
                wsrhstep = (1-value_sqrt_0);
              }
              if ((modelVar_PGATD_i==0.5))
              {
                dwsrh = 0;
              }
              else
              {
                {
                  AdmsSensFadType value_log_0 = log(wsrhstep);
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelVar_PGATD_i)));
                }
              }
              wsrh = (wsrhstep+dwsrh);
              if ((modelVar_PGATD_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv_d));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                  tmp = value_pow_0;
                }
              }
              wdep = (modelVar_wdepnulrgat_d*tmp);
              asrh = (modelVar_ftdgat_d*((zinv-1)*wdep));
              isrh = (modelVar_CSRHGATD_i*(asrh*wsrh));
            }
            if ((modelVar_CTATGATD_i==0))
            {
              itat = 0;
            }
            else
            {
              btat = (modelVar_btatpartgat_d*((wdep*modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
              twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat_d)/btat);
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
                umax = value_sqrt_0;
              }
              {
                AdmsSensFadType value_fabs_0 = fabs(umax);
                AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
                sqrtumax = value_sqrt_1;
              }
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d)==(-1)))
              {
                wgamma = (1/(1+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d));
                  wgamma = value_pow_0;
                }
              }
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                ktat = value_sqrt_0;
              }
              ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
              mtat = ((((modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
              xerfc = ((ltat-1)*ktat);
              ysq = (xerfc*xerfc);
              if ((xerfc>0))
              {
                terfc = (1/(1+(modelVar_perfc*xerfc)));
              }
              else
              {
                terfc = (1/(1-(modelVar_perfc*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }
              erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0))
              {
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp(mtat);
                    tmp = value_exp_0;
                  }
                }
                else
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }
                erfctimesexpmtat = ((2*tmp)-erfcpos);
              }
              gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat_d*erfctimesexpmtat)/ktat));
              itat = (modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
            }
            if ((modelVar_CBBTGATD_i==0))
            {
              ibbt = 0;
            }
            else
            {
              if ((modelVar_PGATD_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                  tmp = value_pow_0;
                }
              }
              Fmaxr = (modelVar_one_over_one_minus_PGAT_d*(((modelVar_VBIRGATD_i-vbbt)*modelVar_wdepnulrinvgat_d)/tmp));
              if ((fabs(((-modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat_d)/Fmaxr));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-modelVar_fbbtgat_d)/Fmaxr)<(-2.3025850929940458e+02)))
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {
                  tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              ibbt = (modelVar_CBBTGATD_i*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
            }
            if ((modelVar_VBRGATD_i>1000))
            {
              fbreakdown = 1;
            }
            else
            {
              if ((vav>((-0.999)*modelVar_VBRGATD_i)))
              {
                if ((modelVar_PBRGATD_i==4))
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                    AdmsSensFadType value_fabs_1 = fabs((vav*modelVar_VBRinvgat_d));
                    AdmsSensFadType value_fabs_2 = fabs((vav*modelVar_VBRinvgat_d));
                    AdmsSensFadType value_fabs_3 = fabs((vav*modelVar_VBRinvgat_d));
                    tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
                  }
                }
                else
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                    AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGATD_i);
                    tmp = value_pow_1;
                  }
                }
                fbreakdown = (1/(1-tmp));
              }
              else
              {
                fbreakdown = (modelVar_fstopgat_d+((vav+(0.999*modelVar_VBRGATD_i))*modelVar_slopegat_d));
              }
            }
            ijungat_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          ijun_d = (((instanceVar_ABDRAIN_i*ijunbot_d)+(instanceVar_LSDRAIN_i*ijunsti_d))+(instanceVar_LGDRAIN_i*ijungat_d));
        }
      }
      rgatenoise = (modelVar_nt0*instanceVar_ggate);
      rbulknoise = (modelVar_nt0*instanceVar_gbulk);
      rjunsnoise = (modelVar_nt0*instanceVar_gjuns);
      rjundnoise = (modelVar_nt0*instanceVar_gjund);
      rwellnoise = (modelVar_nt0*instanceVar_gwell);
    }
    // End block evaluateStaticDynamic
    //Begin block loadStatic
    {
      if ((sigVds>0))
      {
        // I(D,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
        staticContributions[admsNodeID_D] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Iimpact);
        staticContributions[admsNodeID_BP] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Iimpact);
        // I(D,S) <+ (((CHNL_TYPE*MULT_i)*Ids))
        staticContributions[admsNodeID_D] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Ids);
        staticContributions[admsNodeID_S] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Ids);
        // I(GP,S) <+ (((CHNL_TYPE*MULT_i)*Igcs))
        staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcs);
        staticContributions[admsNodeID_S] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcs);
        // I(GP,D) <+ (((CHNL_TYPE*MULT_i)*Igcd))
        staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcd);
        staticContributions[admsNodeID_D] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcd);
      }
      else
      {
        // I(S,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
        staticContributions[admsNodeID_S] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Iimpact);
        staticContributions[admsNodeID_BP] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Iimpact);
        // I(S,D) <+ (((CHNL_TYPE*MULT_i)*Ids))
        staticContributions[admsNodeID_S] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Ids);
        staticContributions[admsNodeID_D] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Ids);
        // I(GP,D) <+ (((CHNL_TYPE*MULT_i)*Igcs))
        staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcs);
        staticContributions[admsNodeID_D] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcs);
        // I(GP,S) <+ (((CHNL_TYPE*MULT_i)*Igcd))
        staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcd);
        staticContributions[admsNodeID_S] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcd);
      }
      // I(GP,BP) <+ (((CHNL_TYPE*MULT_i)*Igb))
      staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igb);
      staticContributions[admsNodeID_BP] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igb);
      // I(GP,S) <+ (((CHNL_TYPE*MULT_i)*Igsov))
      staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igsov);
      staticContributions[admsNodeID_S] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igsov);
      // I(GP,D) <+ (((CHNL_TYPE*MULT_i)*Igdov))
      staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igdov);
      staticContributions[admsNodeID_D] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igdov);
      // I(S,BP) <+ (((CHNL_TYPE*MULT_i)*Igisl))
      staticContributions[admsNodeID_S] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igisl);
      staticContributions[admsNodeID_BP] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igisl);
      // I(D,BP) <+ (((CHNL_TYPE*MULT_i)*Igidl))
      staticContributions[admsNodeID_D] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igidl);
      staticContributions[admsNodeID_BP] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igidl);
      // I(BS,S) <+ (((CHNL_TYPE*MULT_i)*ijun_s))
      staticContributions[admsNodeID_BS] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*ijun_s);
      staticContributions[admsNodeID_S] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*ijun_s);
      // I(BD,D) <+ (((CHNL_TYPE*MULT_i)*ijun_d))
      staticContributions[admsNodeID_BD] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*ijun_d);
      staticContributions[admsNodeID_D] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*ijun_d);
      if ((instanceVar_RG_i>0.0))
      {
        // I(G,GP) <+ (((MULT_i*ggate)*V(G,GP)))
        staticContributions[admsNodeID_G] += ((instanceVar_MULT_i*instanceVar_ggate)*(probeVars[admsProbeID_V_G_GP]));
        staticContributions[admsNodeID_GP] -= ((instanceVar_MULT_i*instanceVar_ggate)*(probeVars[admsProbeID_V_G_GP]));
        // I(G,GP) <+ (white_noise((MULT_i*rgatenoise)))
      }
      else
      {
        // V(G,GP) <+ (0.0)
        // do nothing at all
      }
      if ((instanceVar_RBULK_i>0.0))
      {
        // I(BP,BI) <+ (((MULT_i*gbulk)*V(BP,BI)))
        staticContributions[admsNodeID_BP] += ((instanceVar_MULT_i*instanceVar_gbulk)*(probeVars[admsProbeID_V_BP_BI]));
        staticContributions[admsNodeID_BI] -= ((instanceVar_MULT_i*instanceVar_gbulk)*(probeVars[admsProbeID_V_BP_BI]));
        // I(BP,BI) <+ (white_noise((MULT_i*rbulknoise)))
      }
      else
      {
        // V(BP,BI) <+ (0.0)
        // do nothing at all
      }
      if ((instanceVar_RJUNS_i>0.0))
      {
        // I(BS,BI) <+ (((MULT_i*gjuns)*V(BS,BI)))
        staticContributions[admsNodeID_BS] += ((instanceVar_MULT_i*instanceVar_gjuns)*(probeVars[admsProbeID_V_BS_BI]));
        staticContributions[admsNodeID_BI] -= ((instanceVar_MULT_i*instanceVar_gjuns)*(probeVars[admsProbeID_V_BS_BI]));
        // I(BS,BI) <+ (white_noise((MULT_i*rjunsnoise)))
      }
      else
      {
        // V(BS,BI) <+ (0.0)
        // do nothing at all
      }
      if ((instanceVar_RJUND_i>0.0))
      {
        // I(BD,BI) <+ (((MULT_i*gjund)*V(BD,BI)))
        staticContributions[admsNodeID_BD] += ((instanceVar_MULT_i*instanceVar_gjund)*(probeVars[admsProbeID_V_BD_BI]));
        staticContributions[admsNodeID_BI] -= ((instanceVar_MULT_i*instanceVar_gjund)*(probeVars[admsProbeID_V_BD_BI]));
        // I(BD,BI) <+ (white_noise((MULT_i*rjundnoise)))
      }
      else
      {
        // V(BD,BI) <+ (0.0)
        // do nothing at all
      }
      if ((instanceVar_RWELL_i>0.0))
      {
        // I(B,BI) <+ (((MULT_i*gwell)*V(B,BI)))
        staticContributions[admsNodeID_B] += ((instanceVar_MULT_i*instanceVar_gwell)*(probeVars[admsProbeID_V_B_BI]));
        staticContributions[admsNodeID_BI] -= ((instanceVar_MULT_i*instanceVar_gwell)*(probeVars[admsProbeID_V_B_BI]));
        // I(B,BI) <+ (white_noise((MULT_i*rwellnoise)))
      }
      else
      {
        // V(B,BI) <+ (0.0)
        // do nothing at all
      }
      // I(D,S) <+ ((1E-15*V(D,S)))
      staticContributions[admsNodeID_D] += (1E-15*(probeVars[admsProbeID_V_D_S]));
      staticContributions[admsNodeID_S] -= (1E-15*(probeVars[admsProbeID_V_D_S]));
    }
    // End block loadStatic
    //Begin block loadDynamic
    {
      Qs = (-((Qg+Qb)+Qd));
      Qfgs = (Qfgs+Qgs_ov);
      Qfgd = (Qfgd+Qgd_ov);
      qjun_s = (((instanceVar_ABSOURCE_i*qjunbot_s)+(instanceVar_LSSOURCE_i*qjunsti_s))+(instanceVar_LGSOURCE_i*qjungat_s));
      qjun_d = (((instanceVar_ABDRAIN_i*qjunbot_d)+(instanceVar_LSDRAIN_i*qjunsti_d))+(instanceVar_LGDRAIN_i*qjungat_d));
      if ((sigVds<0))
      {
        temp = Qd;
        Qd = Qs;
        Qs = temp;
      }
      // I(GP,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qg)))
      dynamicContributions[admsNodeID_GP] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qg));
      dynamicContributions[admsNodeID_S] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qg));
      // I(BP,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qb)))
      dynamicContributions[admsNodeID_BP] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qb));
      dynamicContributions[admsNodeID_S] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qb));
      // I(D,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qd)))
      dynamicContributions[admsNodeID_D] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qd));
      dynamicContributions[admsNodeID_S] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qd));
      // I(GP,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgs)))
      dynamicContributions[admsNodeID_GP] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qfgs));
      dynamicContributions[admsNodeID_S] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qfgs));
      // I(GP,D) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgd)))
      dynamicContributions[admsNodeID_GP] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qfgd));
      dynamicContributions[admsNodeID_D] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qfgd));
      // I(GP,BP) <+ (ddt(((CHNL_TYPE*MULT_i)*Qgb_ov)))
      dynamicContributions[admsNodeID_GP] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qgb_ov));
      dynamicContributions[admsNodeID_BP] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qgb_ov));
      // I(BS,S) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_s)))
      dynamicContributions[admsNodeID_BS] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*qjun_s));
      dynamicContributions[admsNodeID_S] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*qjun_s));
      // I(BD,D) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_d)))
      dynamicContributions[admsNodeID_BD] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*qjun_d));
      dynamicContributions[admsNodeID_D] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*qjun_d));
    }
    // End block loadDynamic
    //Begin block noise
    {
      //Block-local variables for block noise
      AdmsSensFadType sf;
      //End of Block-local variables
      Sfl = 0.0;
      mid = 0.0;
      mig = 0.0;
      migid = 0.0;
      c_igid = 0.0;
      CGeff = (COX_qm*eta_p);
      sqid = 0.0;
      sqig = 0.0;
      if ((((xg>0.0)&&(instanceVar_MULT_i>0.0))&&(instanceVar_BET_i>0.0)))
      {
        N1 = ((instanceVar_Cox_over_q*alpha)*modelVar_phit);
        Nm1 = (instanceVar_Cox_over_q*qim1);
        Delta_N1 = (instanceVar_Cox_over_q*(alpha*dps));
        {
          AdmsSensFadType value_log_0 = log(((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));
          Sfl = (((instanceVar_NFA_i-(instanceVar_NFB_i*N1))+(instanceVar_NFC_i*(N1*N1)))*value_log_0);
        }
        Sfl = (Sfl+((instanceVar_NFB_i+(instanceVar_NFC_i*(Nm1-(2.0*N1))))*Delta_N1));
        Sfl = ((((instanceVar_Sfl_prefac*Ids)*Gvsatinv)*Sfl)/N1);
        Sfl = adms_ternary_op<AdmsSensFadType>((Sfl>0.0),Sfl,0.0);
        H0 = (qim1/alpha);
        t1 = (qim/qim1);
        sqt2 = ((0.5*1.6666666666666667e-01)*(dps/H0));
        t2 = (sqt2*sqt2);
        r = ((H0/H)-1.0);
        lc = adms_ternary_op<AdmsSensFadType>(((1.0-(12*(r*t2)))>1e-20),(1.0-(12*(r*t2))),1e-20);
        lcinv2 = (1/(lc*lc));
        g_ideal = (instanceVar_BET_i*((FdL*qim1)*Gvsatinv));
        CGeff = ((((Gvsat*Gvsat)*COX_qm)*eta_p)/(Gmob_dL*Gmob_dL));
        mid = ((t1+(12*t2))-(24*(((1.0+t1)*t2)*r)));
        mid = adms_ternary_op<AdmsSensFadType>((mid>1e-40),mid,1e-40);
        mid = ((g_ideal*lcinv2)*mid);
        mig = (((t1/12.0)-(t2*((t1+0.2)-(12*t2))))-(1.6*((t2*((t1+1.0)-(12*t2)))*r)));
        mig = adms_ternary_op<AdmsSensFadType>((mig>1e-40),mig,1e-40);
        mig = ((lcinv2/g_ideal)*mig);
        migid = ((lcinv2*sqt2)*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r)));
        if ((instanceVar_FNTEXC_i>0))
        {
          temp2_exc = (qim*xitsb);
          wsat_exc = (100.0*(temp2_exc/(100.0+temp2_exc)));
          if ((instanceVar_THESATG_i<0))
          {
            temp_exc = (1/(1-(instanceVar_THESATG_i*wsat_exc)));
          }
          else
          {
            temp_exc = (1+(instanceVar_THESATG_i*wsat_exc));
          }
          thesat1_exc = (instanceVar_THESAT_i*(temp_exc/Gmob));
          zsat_exc = (((thesat1_exc*thesat1_exc)*dps)*dps);
          if ((modelVar_CHNL_TYPE==(-1)))
          {
            zsat_exc = (zsat_exc/(1.0+(thesat1_exc*dps)));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((1.0+(2.0*zsat_exc)));
            Gvsat_exc = (0.5*(Gmob*(1.0+value_sqrt_0)));
          }
          gfac = (Gmob/(Gvsat_exc*lc));
          Sidexc = ((((instanceVar_fac_exc*Ids)*Vdse)*gfac)*gfac);
          mid = (mid+(Sidexc/modelVar_nt0));
          mig = (mig+((Sidexc*(1+(12*t2)))/(((12*g_ideal)*g_ideal)*modelVar_nt0)));
          migid = (migid-(((Sidexc*sqt2)*(1+r))/(g_ideal*modelVar_nt0)));
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt((instanceVar_nt*mid));
          sqid = value_sqrt_0;
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt((instanceVar_nt/mig));
          sqig = value_sqrt_0;
        }
        if ((sqid==0))
        {
          c_igid = 0.0;
        }
        else
        {
          c_igid = ((migid*sqig)/sqid);
        }
        c_igid = adms_ternary_op<AdmsSensFadType>((c_igid>0.0),adms_ternary_op<AdmsSensFadType>((c_igid<1.0),c_igid,1.0),0.0);
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(Igcs);
        shot_igcsx = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(Igcd);
        shot_igcdx = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(Igsov);
        shot_igsov = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(Igdov);
        shot_igdov = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(Iimpact);
        shot_iavl = ((2.0*1.6021918E-19)*((mavl+1)*value_fabs_0));
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(ijun_s);
        jnoisex_s = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(ijun_d);
        jnoisex_d = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      if ((sigVds>0))
      {
        shot_igs = (shot_igcsx+shot_igsov);
        shot_igd = (shot_igcdx+shot_igdov);
        jnoise_s = jnoisex_s;
        jnoise_d = (jnoisex_d+shot_iavl);
      }
      else
      {
        shot_igs = (shot_igcdx+shot_igsov);
        shot_igd = (shot_igcsx+shot_igdov);
        jnoise_s = (jnoisex_s+shot_iavl);
        jnoise_d = jnoisex_d;
      }
      sf = ((1e6*CGeff)*mig);
      // I(NOI2,GND) <+ (V(NOI2,GND))
      staticContributions[admsNodeID_NOI2] += (probeVars[admsProbeID_V_NOI2_GND]);
      // I(NOI2,GND) <+ (white_noise((((sqig*sqig)*sf)*sf),"igig"))
      // I(NOI,GND) <+ (((-V(NOI2,GND))/sf))
      staticContributions[admsNodeID_NOI] += ((-(probeVars[admsProbeID_V_NOI2_GND]))/sf);
      // I(NOI,GND) <+ ((V(NOI,GND)/mig))
      staticContributions[admsNodeID_NOI] += ((probeVars[admsProbeID_V_NOI_GND])/mig);
      // I(NOI,GND) <+ (ddt((CGeff*V(NOI,GND))))
      dynamicContributions[admsNodeID_NOI] += ((CGeff*(probeVars[admsProbeID_V_NOI_GND])));
      // I(D,S) <+ (flicker_noise((MULT_i*Sfl),EF_i,"flicker"))
      // I(D,S) <+ (white_noise((((MULT_i*sqid)*sqid)*(1.0-(c_igid*c_igid))),"idid"))
      // I(D,S) <+ (((((sigVds*sqrt(MULT_i))*migid)*V(NOI2,GND))/sf))
      {
        AdmsSensFadType value_sqrt_0 = sqrt(instanceVar_MULT_i);
        staticContributions[admsNodeID_D] += ((((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))/sf);
        staticContributions[admsNodeID_S] -= ((((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))/sf);
      }
      // I(GP,S) <+ (ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND))))
      {
        AdmsSensFadType value_sqrt_0 = sqrt(instanceVar_MULT_i);
        dynamicContributions[admsNodeID_GP] += ((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
        dynamicContributions[admsNodeID_S] -= ((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
      }
      // I(GP,D) <+ (ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND))))
      {
        AdmsSensFadType value_sqrt_0 = sqrt(instanceVar_MULT_i);
        dynamicContributions[admsNodeID_GP] += ((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
        dynamicContributions[admsNodeID_D] -= ((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
      }
      // I(GP,S) <+ (white_noise((MULT_i*shot_igs),"igs"))
      // I(GP,D) <+ (white_noise((MULT_i*shot_igd),"igd"))
      // I(BS,S) <+ (white_noise((MULT_i*jnoise_s),"ibs"))
      // I(BD,D) <+ (white_noise((MULT_i*jnoise_d),"ibd"))
    }
    // End block noise
  }
  // End block evaluateblock
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(11+0);
  dqdp.resize(11+0);
  Findices.resize(11+0);
  Qindices.resize(11+0);

  std::vector <double> probeVars(12);
  std::vector <AdmsSensFadType> staticContributions(11+0);
  std::vector <AdmsSensFadType> dynamicContributions(11+0);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 11+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_LEVEL=mod.LEVEL;
  bool modelPar_given_LEVEL=mod.given("LEVEL");
  AdmsSensFadType modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");
  AdmsSensFadType modelPar_TR=mod.TR;
  bool modelPar_given_TR=mod.given("TR");
  AdmsSensFadType modelPar_SWIGATE=mod.SWIGATE;
  bool modelPar_given_SWIGATE=mod.given("SWIGATE");
  AdmsSensFadType modelPar_SWIMPACT=mod.SWIMPACT;
  bool modelPar_given_SWIMPACT=mod.given("SWIMPACT");
  AdmsSensFadType modelPar_SWGIDL=mod.SWGIDL;
  bool modelPar_given_SWGIDL=mod.given("SWGIDL");
  AdmsSensFadType modelPar_SWJUNCAP=mod.SWJUNCAP;
  bool modelPar_given_SWJUNCAP=mod.given("SWJUNCAP");
  AdmsSensFadType modelPar_SWJUNASYM=mod.SWJUNASYM;
  bool modelPar_given_SWJUNASYM=mod.given("SWJUNASYM");
  AdmsSensFadType modelPar_QMC=mod.QMC;
  bool modelPar_given_QMC=mod.given("QMC");
  AdmsSensFadType modelPar_LVARO=mod.LVARO;
  bool modelPar_given_LVARO=mod.given("LVARO");
  AdmsSensFadType modelPar_LVARL=mod.LVARL;
  bool modelPar_given_LVARL=mod.given("LVARL");
  AdmsSensFadType modelPar_LVARW=mod.LVARW;
  bool modelPar_given_LVARW=mod.given("LVARW");
  AdmsSensFadType modelPar_LAP=mod.LAP;
  bool modelPar_given_LAP=mod.given("LAP");
  AdmsSensFadType modelPar_WVARO=mod.WVARO;
  bool modelPar_given_WVARO=mod.given("WVARO");
  AdmsSensFadType modelPar_WVARL=mod.WVARL;
  bool modelPar_given_WVARL=mod.given("WVARL");
  AdmsSensFadType modelPar_WVARW=mod.WVARW;
  bool modelPar_given_WVARW=mod.given("WVARW");
  AdmsSensFadType modelPar_WOT=mod.WOT;
  bool modelPar_given_WOT=mod.given("WOT");
  AdmsSensFadType modelPar_DLQ=mod.DLQ;
  bool modelPar_given_DLQ=mod.given("DLQ");
  AdmsSensFadType modelPar_DWQ=mod.DWQ;
  bool modelPar_given_DWQ=mod.given("DWQ");
  AdmsSensFadType modelPar_VFBO=mod.VFBO;
  bool modelPar_given_VFBO=mod.given("VFBO");
  AdmsSensFadType modelPar_VFBL=mod.VFBL;
  bool modelPar_given_VFBL=mod.given("VFBL");
  AdmsSensFadType modelPar_VFBW=mod.VFBW;
  bool modelPar_given_VFBW=mod.given("VFBW");
  AdmsSensFadType modelPar_VFBLW=mod.VFBLW;
  bool modelPar_given_VFBLW=mod.given("VFBLW");
  AdmsSensFadType modelPar_STVFBO=mod.STVFBO;
  bool modelPar_given_STVFBO=mod.given("STVFBO");
  AdmsSensFadType modelPar_STVFBL=mod.STVFBL;
  bool modelPar_given_STVFBL=mod.given("STVFBL");
  AdmsSensFadType modelPar_STVFBW=mod.STVFBW;
  bool modelPar_given_STVFBW=mod.given("STVFBW");
  AdmsSensFadType modelPar_STVFBLW=mod.STVFBLW;
  bool modelPar_given_STVFBLW=mod.given("STVFBLW");
  AdmsSensFadType modelPar_TOXO=mod.TOXO;
  bool modelPar_given_TOXO=mod.given("TOXO");
  AdmsSensFadType modelPar_EPSROXO=mod.EPSROXO;
  bool modelPar_given_EPSROXO=mod.given("EPSROXO");
  AdmsSensFadType modelPar_NSUBO=mod.NSUBO;
  bool modelPar_given_NSUBO=mod.given("NSUBO");
  AdmsSensFadType modelPar_NSUBW=mod.NSUBW;
  bool modelPar_given_NSUBW=mod.given("NSUBW");
  AdmsSensFadType modelPar_WSEG=mod.WSEG;
  bool modelPar_given_WSEG=mod.given("WSEG");
  AdmsSensFadType modelPar_NPCK=mod.NPCK;
  bool modelPar_given_NPCK=mod.given("NPCK");
  AdmsSensFadType modelPar_NPCKW=mod.NPCKW;
  bool modelPar_given_NPCKW=mod.given("NPCKW");
  AdmsSensFadType modelPar_WSEGP=mod.WSEGP;
  bool modelPar_given_WSEGP=mod.given("WSEGP");
  AdmsSensFadType modelPar_LPCK=mod.LPCK;
  bool modelPar_given_LPCK=mod.given("LPCK");
  AdmsSensFadType modelPar_LPCKW=mod.LPCKW;
  bool modelPar_given_LPCKW=mod.given("LPCKW");
  AdmsSensFadType modelPar_FOL1=mod.FOL1;
  bool modelPar_given_FOL1=mod.given("FOL1");
  AdmsSensFadType modelPar_FOL2=mod.FOL2;
  bool modelPar_given_FOL2=mod.given("FOL2");
  AdmsSensFadType modelPar_VNSUBO=mod.VNSUBO;
  bool modelPar_given_VNSUBO=mod.given("VNSUBO");
  AdmsSensFadType modelPar_NSLPO=mod.NSLPO;
  bool modelPar_given_NSLPO=mod.given("NSLPO");
  AdmsSensFadType modelPar_DNSUBO=mod.DNSUBO;
  bool modelPar_given_DNSUBO=mod.given("DNSUBO");
  AdmsSensFadType modelPar_DPHIBO=mod.DPHIBO;
  bool modelPar_given_DPHIBO=mod.given("DPHIBO");
  AdmsSensFadType modelPar_DPHIBL=mod.DPHIBL;
  bool modelPar_given_DPHIBL=mod.given("DPHIBL");
  AdmsSensFadType modelPar_DPHIBLEXP=mod.DPHIBLEXP;
  bool modelPar_given_DPHIBLEXP=mod.given("DPHIBLEXP");
  AdmsSensFadType modelPar_DPHIBW=mod.DPHIBW;
  bool modelPar_given_DPHIBW=mod.given("DPHIBW");
  AdmsSensFadType modelPar_DPHIBLW=mod.DPHIBLW;
  bool modelPar_given_DPHIBLW=mod.given("DPHIBLW");
  AdmsSensFadType modelPar_NPO=mod.NPO;
  bool modelPar_given_NPO=mod.given("NPO");
  AdmsSensFadType modelPar_NPL=mod.NPL;
  bool modelPar_given_NPL=mod.given("NPL");
  AdmsSensFadType modelPar_CTO=mod.CTO;
  bool modelPar_given_CTO=mod.given("CTO");
  AdmsSensFadType modelPar_CTL=mod.CTL;
  bool modelPar_given_CTL=mod.given("CTL");
  AdmsSensFadType modelPar_CTLEXP=mod.CTLEXP;
  bool modelPar_given_CTLEXP=mod.given("CTLEXP");
  AdmsSensFadType modelPar_CTW=mod.CTW;
  bool modelPar_given_CTW=mod.given("CTW");
  AdmsSensFadType modelPar_CTLW=mod.CTLW;
  bool modelPar_given_CTLW=mod.given("CTLW");
  AdmsSensFadType modelPar_TOXOVO=mod.TOXOVO;
  bool modelPar_given_TOXOVO=mod.given("TOXOVO");
  AdmsSensFadType modelPar_TOXOVDO=mod.TOXOVDO;
  bool modelPar_given_TOXOVDO=mod.given("TOXOVDO");
  AdmsSensFadType modelPar_LOV=mod.LOV;
  bool modelPar_given_LOV=mod.given("LOV");
  AdmsSensFadType modelPar_LOVD=mod.LOVD;
  bool modelPar_given_LOVD=mod.given("LOVD");
  AdmsSensFadType modelPar_NOVO=mod.NOVO;
  bool modelPar_given_NOVO=mod.given("NOVO");
  AdmsSensFadType modelPar_NOVDO=mod.NOVDO;
  bool modelPar_given_NOVDO=mod.given("NOVDO");
  AdmsSensFadType modelPar_CFL=mod.CFL;
  bool modelPar_given_CFL=mod.given("CFL");
  AdmsSensFadType modelPar_CFLEXP=mod.CFLEXP;
  bool modelPar_given_CFLEXP=mod.given("CFLEXP");
  AdmsSensFadType modelPar_CFW=mod.CFW;
  bool modelPar_given_CFW=mod.given("CFW");
  AdmsSensFadType modelPar_CFBO=mod.CFBO;
  bool modelPar_given_CFBO=mod.given("CFBO");
  AdmsSensFadType modelPar_UO=mod.UO;
  bool modelPar_given_UO=mod.given("UO");
  AdmsSensFadType modelPar_FBET1=mod.FBET1;
  bool modelPar_given_FBET1=mod.given("FBET1");
  AdmsSensFadType modelPar_FBET1W=mod.FBET1W;
  bool modelPar_given_FBET1W=mod.given("FBET1W");
  AdmsSensFadType modelPar_LP1=mod.LP1;
  bool modelPar_given_LP1=mod.given("LP1");
  AdmsSensFadType modelPar_LP1W=mod.LP1W;
  bool modelPar_given_LP1W=mod.given("LP1W");
  AdmsSensFadType modelPar_FBET2=mod.FBET2;
  bool modelPar_given_FBET2=mod.given("FBET2");
  AdmsSensFadType modelPar_LP2=mod.LP2;
  bool modelPar_given_LP2=mod.given("LP2");
  AdmsSensFadType modelPar_BETW1=mod.BETW1;
  bool modelPar_given_BETW1=mod.given("BETW1");
  AdmsSensFadType modelPar_BETW2=mod.BETW2;
  bool modelPar_given_BETW2=mod.given("BETW2");
  AdmsSensFadType modelPar_WBET=mod.WBET;
  bool modelPar_given_WBET=mod.given("WBET");
  AdmsSensFadType modelPar_STBETO=mod.STBETO;
  bool modelPar_given_STBETO=mod.given("STBETO");
  AdmsSensFadType modelPar_STBETL=mod.STBETL;
  bool modelPar_given_STBETL=mod.given("STBETL");
  AdmsSensFadType modelPar_STBETW=mod.STBETW;
  bool modelPar_given_STBETW=mod.given("STBETW");
  AdmsSensFadType modelPar_STBETLW=mod.STBETLW;
  bool modelPar_given_STBETLW=mod.given("STBETLW");
  AdmsSensFadType modelPar_MUEO=mod.MUEO;
  bool modelPar_given_MUEO=mod.given("MUEO");
  AdmsSensFadType modelPar_MUEW=mod.MUEW;
  bool modelPar_given_MUEW=mod.given("MUEW");
  AdmsSensFadType modelPar_STMUEO=mod.STMUEO;
  bool modelPar_given_STMUEO=mod.given("STMUEO");
  AdmsSensFadType modelPar_THEMUO=mod.THEMUO;
  bool modelPar_given_THEMUO=mod.given("THEMUO");
  AdmsSensFadType modelPar_STTHEMUO=mod.STTHEMUO;
  bool modelPar_given_STTHEMUO=mod.given("STTHEMUO");
  AdmsSensFadType modelPar_CSO=mod.CSO;
  bool modelPar_given_CSO=mod.given("CSO");
  AdmsSensFadType modelPar_CSL=mod.CSL;
  bool modelPar_given_CSL=mod.given("CSL");
  AdmsSensFadType modelPar_CSLEXP=mod.CSLEXP;
  bool modelPar_given_CSLEXP=mod.given("CSLEXP");
  AdmsSensFadType modelPar_CSW=mod.CSW;
  bool modelPar_given_CSW=mod.given("CSW");
  AdmsSensFadType modelPar_CSLW=mod.CSLW;
  bool modelPar_given_CSLW=mod.given("CSLW");
  AdmsSensFadType modelPar_STCSO=mod.STCSO;
  bool modelPar_given_STCSO=mod.given("STCSO");
  AdmsSensFadType modelPar_XCORO=mod.XCORO;
  bool modelPar_given_XCORO=mod.given("XCORO");
  AdmsSensFadType modelPar_XCORL=mod.XCORL;
  bool modelPar_given_XCORL=mod.given("XCORL");
  AdmsSensFadType modelPar_XCORW=mod.XCORW;
  bool modelPar_given_XCORW=mod.given("XCORW");
  AdmsSensFadType modelPar_XCORLW=mod.XCORLW;
  bool modelPar_given_XCORLW=mod.given("XCORLW");
  AdmsSensFadType modelPar_STXCORO=mod.STXCORO;
  bool modelPar_given_STXCORO=mod.given("STXCORO");
  AdmsSensFadType modelPar_FETAO=mod.FETAO;
  bool modelPar_given_FETAO=mod.given("FETAO");
  AdmsSensFadType modelPar_RSW1=mod.RSW1;
  bool modelPar_given_RSW1=mod.given("RSW1");
  AdmsSensFadType modelPar_RSW2=mod.RSW2;
  bool modelPar_given_RSW2=mod.given("RSW2");
  AdmsSensFadType modelPar_STRSO=mod.STRSO;
  bool modelPar_given_STRSO=mod.given("STRSO");
  AdmsSensFadType modelPar_RSBO=mod.RSBO;
  bool modelPar_given_RSBO=mod.given("RSBO");
  AdmsSensFadType modelPar_RSGO=mod.RSGO;
  bool modelPar_given_RSGO=mod.given("RSGO");
  AdmsSensFadType modelPar_THESATO=mod.THESATO;
  bool modelPar_given_THESATO=mod.given("THESATO");
  AdmsSensFadType modelPar_THESATL=mod.THESATL;
  bool modelPar_given_THESATL=mod.given("THESATL");
  AdmsSensFadType modelPar_THESATLEXP=mod.THESATLEXP;
  bool modelPar_given_THESATLEXP=mod.given("THESATLEXP");
  AdmsSensFadType modelPar_THESATW=mod.THESATW;
  bool modelPar_given_THESATW=mod.given("THESATW");
  AdmsSensFadType modelPar_THESATLW=mod.THESATLW;
  bool modelPar_given_THESATLW=mod.given("THESATLW");
  AdmsSensFadType modelPar_STTHESATO=mod.STTHESATO;
  bool modelPar_given_STTHESATO=mod.given("STTHESATO");
  AdmsSensFadType modelPar_STTHESATL=mod.STTHESATL;
  bool modelPar_given_STTHESATL=mod.given("STTHESATL");
  AdmsSensFadType modelPar_STTHESATW=mod.STTHESATW;
  bool modelPar_given_STTHESATW=mod.given("STTHESATW");
  AdmsSensFadType modelPar_STTHESATLW=mod.STTHESATLW;
  bool modelPar_given_STTHESATLW=mod.given("STTHESATLW");
  AdmsSensFadType modelPar_THESATBO=mod.THESATBO;
  bool modelPar_given_THESATBO=mod.given("THESATBO");
  AdmsSensFadType modelPar_THESATGO=mod.THESATGO;
  bool modelPar_given_THESATGO=mod.given("THESATGO");
  AdmsSensFadType modelPar_AXO=mod.AXO;
  bool modelPar_given_AXO=mod.given("AXO");
  AdmsSensFadType modelPar_AXL=mod.AXL;
  bool modelPar_given_AXL=mod.given("AXL");
  AdmsSensFadType modelPar_ALPL=mod.ALPL;
  bool modelPar_given_ALPL=mod.given("ALPL");
  AdmsSensFadType modelPar_ALPLEXP=mod.ALPLEXP;
  bool modelPar_given_ALPLEXP=mod.given("ALPLEXP");
  AdmsSensFadType modelPar_ALPW=mod.ALPW;
  bool modelPar_given_ALPW=mod.given("ALPW");
  AdmsSensFadType modelPar_ALP1L1=mod.ALP1L1;
  bool modelPar_given_ALP1L1=mod.given("ALP1L1");
  AdmsSensFadType modelPar_ALP1LEXP=mod.ALP1LEXP;
  bool modelPar_given_ALP1LEXP=mod.given("ALP1LEXP");
  AdmsSensFadType modelPar_ALP1L2=mod.ALP1L2;
  bool modelPar_given_ALP1L2=mod.given("ALP1L2");
  AdmsSensFadType modelPar_ALP1W=mod.ALP1W;
  bool modelPar_given_ALP1W=mod.given("ALP1W");
  AdmsSensFadType modelPar_ALP2L1=mod.ALP2L1;
  bool modelPar_given_ALP2L1=mod.given("ALP2L1");
  AdmsSensFadType modelPar_ALP2LEXP=mod.ALP2LEXP;
  bool modelPar_given_ALP2LEXP=mod.given("ALP2LEXP");
  AdmsSensFadType modelPar_ALP2L2=mod.ALP2L2;
  bool modelPar_given_ALP2L2=mod.given("ALP2L2");
  AdmsSensFadType modelPar_ALP2W=mod.ALP2W;
  bool modelPar_given_ALP2W=mod.given("ALP2W");
  AdmsSensFadType modelPar_VPO=mod.VPO;
  bool modelPar_given_VPO=mod.given("VPO");
  AdmsSensFadType modelPar_A1O=mod.A1O;
  bool modelPar_given_A1O=mod.given("A1O");
  AdmsSensFadType modelPar_A1L=mod.A1L;
  bool modelPar_given_A1L=mod.given("A1L");
  AdmsSensFadType modelPar_A1W=mod.A1W;
  bool modelPar_given_A1W=mod.given("A1W");
  AdmsSensFadType modelPar_A2O=mod.A2O;
  bool modelPar_given_A2O=mod.given("A2O");
  AdmsSensFadType modelPar_STA2O=mod.STA2O;
  bool modelPar_given_STA2O=mod.given("STA2O");
  AdmsSensFadType modelPar_A3O=mod.A3O;
  bool modelPar_given_A3O=mod.given("A3O");
  AdmsSensFadType modelPar_A3L=mod.A3L;
  bool modelPar_given_A3L=mod.given("A3L");
  AdmsSensFadType modelPar_A3W=mod.A3W;
  bool modelPar_given_A3W=mod.given("A3W");
  AdmsSensFadType modelPar_A4O=mod.A4O;
  bool modelPar_given_A4O=mod.given("A4O");
  AdmsSensFadType modelPar_A4L=mod.A4L;
  bool modelPar_given_A4L=mod.given("A4L");
  AdmsSensFadType modelPar_A4W=mod.A4W;
  bool modelPar_given_A4W=mod.given("A4W");
  AdmsSensFadType modelPar_GCOO=mod.GCOO;
  bool modelPar_given_GCOO=mod.given("GCOO");
  AdmsSensFadType modelPar_IGINVLW=mod.IGINVLW;
  bool modelPar_given_IGINVLW=mod.given("IGINVLW");
  AdmsSensFadType modelPar_IGOVW=mod.IGOVW;
  bool modelPar_given_IGOVW=mod.given("IGOVW");
  AdmsSensFadType modelPar_IGOVDW=mod.IGOVDW;
  bool modelPar_given_IGOVDW=mod.given("IGOVDW");
  AdmsSensFadType modelPar_STIGO=mod.STIGO;
  bool modelPar_given_STIGO=mod.given("STIGO");
  AdmsSensFadType modelPar_GC2O=mod.GC2O;
  bool modelPar_given_GC2O=mod.given("GC2O");
  AdmsSensFadType modelPar_GC3O=mod.GC3O;
  bool modelPar_given_GC3O=mod.given("GC3O");
  AdmsSensFadType modelPar_CHIBO=mod.CHIBO;
  bool modelPar_given_CHIBO=mod.given("CHIBO");
  AdmsSensFadType modelPar_AGIDLW=mod.AGIDLW;
  bool modelPar_given_AGIDLW=mod.given("AGIDLW");
  AdmsSensFadType modelPar_AGIDLDW=mod.AGIDLDW;
  bool modelPar_given_AGIDLDW=mod.given("AGIDLDW");
  AdmsSensFadType modelPar_BGIDLO=mod.BGIDLO;
  bool modelPar_given_BGIDLO=mod.given("BGIDLO");
  AdmsSensFadType modelPar_BGIDLDO=mod.BGIDLDO;
  bool modelPar_given_BGIDLDO=mod.given("BGIDLDO");
  AdmsSensFadType modelPar_STBGIDLO=mod.STBGIDLO;
  bool modelPar_given_STBGIDLO=mod.given("STBGIDLO");
  AdmsSensFadType modelPar_STBGIDLDO=mod.STBGIDLDO;
  bool modelPar_given_STBGIDLDO=mod.given("STBGIDLDO");
  AdmsSensFadType modelPar_CGIDLO=mod.CGIDLO;
  bool modelPar_given_CGIDLO=mod.given("CGIDLO");
  AdmsSensFadType modelPar_CGIDLDO=mod.CGIDLDO;
  bool modelPar_given_CGIDLDO=mod.given("CGIDLDO");
  AdmsSensFadType modelPar_CGBOVL=mod.CGBOVL;
  bool modelPar_given_CGBOVL=mod.given("CGBOVL");
  AdmsSensFadType modelPar_CFRW=mod.CFRW;
  bool modelPar_given_CFRW=mod.given("CFRW");
  AdmsSensFadType modelPar_CFRDW=mod.CFRDW;
  bool modelPar_given_CFRDW=mod.given("CFRDW");
  AdmsSensFadType modelPar_FNTO=mod.FNTO;
  bool modelPar_given_FNTO=mod.given("FNTO");
  AdmsSensFadType modelPar_FNTEXCL=mod.FNTEXCL;
  bool modelPar_given_FNTEXCL=mod.given("FNTEXCL");
  AdmsSensFadType modelPar_NFALW=mod.NFALW;
  bool modelPar_given_NFALW=mod.given("NFALW");
  AdmsSensFadType modelPar_NFBLW=mod.NFBLW;
  bool modelPar_given_NFBLW=mod.given("NFBLW");
  AdmsSensFadType modelPar_NFCLW=mod.NFCLW;
  bool modelPar_given_NFCLW=mod.given("NFCLW");
  AdmsSensFadType modelPar_EFO=mod.EFO;
  bool modelPar_given_EFO=mod.given("EFO");
  AdmsSensFadType modelPar_LINTNOI=mod.LINTNOI;
  bool modelPar_given_LINTNOI=mod.given("LINTNOI");
  AdmsSensFadType modelPar_ALPNOI=mod.ALPNOI;
  bool modelPar_given_ALPNOI=mod.given("ALPNOI");
  AdmsSensFadType modelPar_DTA=mod.DTA;
  bool modelPar_given_DTA=mod.given("DTA");
  AdmsSensFadType modelPar_KVTHOWEO=mod.KVTHOWEO;
  bool modelPar_given_KVTHOWEO=mod.given("KVTHOWEO");
  AdmsSensFadType modelPar_KVTHOWEL=mod.KVTHOWEL;
  bool modelPar_given_KVTHOWEL=mod.given("KVTHOWEL");
  AdmsSensFadType modelPar_KVTHOWEW=mod.KVTHOWEW;
  bool modelPar_given_KVTHOWEW=mod.given("KVTHOWEW");
  AdmsSensFadType modelPar_KVTHOWELW=mod.KVTHOWELW;
  bool modelPar_given_KVTHOWELW=mod.given("KVTHOWELW");
  AdmsSensFadType modelPar_KUOWEO=mod.KUOWEO;
  bool modelPar_given_KUOWEO=mod.given("KUOWEO");
  AdmsSensFadType modelPar_KUOWEL=mod.KUOWEL;
  bool modelPar_given_KUOWEL=mod.given("KUOWEL");
  AdmsSensFadType modelPar_KUOWEW=mod.KUOWEW;
  bool modelPar_given_KUOWEW=mod.given("KUOWEW");
  AdmsSensFadType modelPar_KUOWELW=mod.KUOWELW;
  bool modelPar_given_KUOWELW=mod.given("KUOWELW");
  AdmsSensFadType modelPar_LMIN=mod.LMIN;
  bool modelPar_given_LMIN=mod.given("LMIN");
  AdmsSensFadType modelPar_LMAX=mod.LMAX;
  bool modelPar_given_LMAX=mod.given("LMAX");
  AdmsSensFadType modelPar_WMIN=mod.WMIN;
  bool modelPar_given_WMIN=mod.given("WMIN");
  AdmsSensFadType modelPar_WMAX=mod.WMAX;
  bool modelPar_given_WMAX=mod.given("WMAX");
  AdmsSensFadType modelPar_RGO=mod.RGO;
  bool modelPar_given_RGO=mod.given("RGO");
  AdmsSensFadType modelPar_RBULKO=mod.RBULKO;
  bool modelPar_given_RBULKO=mod.given("RBULKO");
  AdmsSensFadType modelPar_RWELLO=mod.RWELLO;
  bool modelPar_given_RWELLO=mod.given("RWELLO");
  AdmsSensFadType modelPar_RJUNSO=mod.RJUNSO;
  bool modelPar_given_RJUNSO=mod.given("RJUNSO");
  AdmsSensFadType modelPar_RJUNDO=mod.RJUNDO;
  bool modelPar_given_RJUNDO=mod.given("RJUNDO");
  AdmsSensFadType modelPar_RINT=mod.RINT;
  bool modelPar_given_RINT=mod.given("RINT");
  AdmsSensFadType modelPar_RVPOLY=mod.RVPOLY;
  bool modelPar_given_RVPOLY=mod.given("RVPOLY");
  AdmsSensFadType modelPar_RSHG=mod.RSHG;
  bool modelPar_given_RSHG=mod.given("RSHG");
  AdmsSensFadType modelPar_DLSIL=mod.DLSIL;
  bool modelPar_given_DLSIL=mod.given("DLSIL");
  AdmsSensFadType modelPar_SAREF=mod.SAREF;
  bool modelPar_given_SAREF=mod.given("SAREF");
  AdmsSensFadType modelPar_SBREF=mod.SBREF;
  bool modelPar_given_SBREF=mod.given("SBREF");
  AdmsSensFadType modelPar_WLOD=mod.WLOD;
  bool modelPar_given_WLOD=mod.given("WLOD");
  AdmsSensFadType modelPar_KUO=mod.KUO;
  bool modelPar_given_KUO=mod.given("KUO");
  AdmsSensFadType modelPar_KVSAT=mod.KVSAT;
  bool modelPar_given_KVSAT=mod.given("KVSAT");
  AdmsSensFadType modelPar_TKUO=mod.TKUO;
  bool modelPar_given_TKUO=mod.given("TKUO");
  AdmsSensFadType modelPar_LKUO=mod.LKUO;
  bool modelPar_given_LKUO=mod.given("LKUO");
  AdmsSensFadType modelPar_WKUO=mod.WKUO;
  bool modelPar_given_WKUO=mod.given("WKUO");
  AdmsSensFadType modelPar_PKUO=mod.PKUO;
  bool modelPar_given_PKUO=mod.given("PKUO");
  AdmsSensFadType modelPar_LLODKUO=mod.LLODKUO;
  bool modelPar_given_LLODKUO=mod.given("LLODKUO");
  AdmsSensFadType modelPar_WLODKUO=mod.WLODKUO;
  bool modelPar_given_WLODKUO=mod.given("WLODKUO");
  AdmsSensFadType modelPar_KVTHO=mod.KVTHO;
  bool modelPar_given_KVTHO=mod.given("KVTHO");
  AdmsSensFadType modelPar_LKVTHO=mod.LKVTHO;
  bool modelPar_given_LKVTHO=mod.given("LKVTHO");
  AdmsSensFadType modelPar_WKVTHO=mod.WKVTHO;
  bool modelPar_given_WKVTHO=mod.given("WKVTHO");
  AdmsSensFadType modelPar_PKVTHO=mod.PKVTHO;
  bool modelPar_given_PKVTHO=mod.given("PKVTHO");
  AdmsSensFadType modelPar_LLODVTH=mod.LLODVTH;
  bool modelPar_given_LLODVTH=mod.given("LLODVTH");
  AdmsSensFadType modelPar_WLODVTH=mod.WLODVTH;
  bool modelPar_given_WLODVTH=mod.given("WLODVTH");
  AdmsSensFadType modelPar_STETAO=mod.STETAO;
  bool modelPar_given_STETAO=mod.given("STETAO");
  AdmsSensFadType modelPar_LODETAO=mod.LODETAO;
  bool modelPar_given_LODETAO=mod.given("LODETAO");
  AdmsSensFadType modelPar_SCREF=mod.SCREF;
  bool modelPar_given_SCREF=mod.given("SCREF");
  AdmsSensFadType modelPar_WEB=mod.WEB;
  bool modelPar_given_WEB=mod.given("WEB");
  AdmsSensFadType modelPar_WEC=mod.WEC;
  bool modelPar_given_WEC=mod.given("WEC");
  AdmsSensFadType modelPar_IMAX=mod.IMAX;
  bool modelPar_given_IMAX=mod.given("IMAX");
  AdmsSensFadType modelPar_TRJ=mod.TRJ;
  bool modelPar_given_TRJ=mod.given("TRJ");
  AdmsSensFadType modelPar_CJORBOT=mod.CJORBOT;
  bool modelPar_given_CJORBOT=mod.given("CJORBOT");
  AdmsSensFadType modelPar_CJORSTI=mod.CJORSTI;
  bool modelPar_given_CJORSTI=mod.given("CJORSTI");
  AdmsSensFadType modelPar_CJORGAT=mod.CJORGAT;
  bool modelPar_given_CJORGAT=mod.given("CJORGAT");
  AdmsSensFadType modelPar_VBIRBOT=mod.VBIRBOT;
  bool modelPar_given_VBIRBOT=mod.given("VBIRBOT");
  AdmsSensFadType modelPar_VBIRSTI=mod.VBIRSTI;
  bool modelPar_given_VBIRSTI=mod.given("VBIRSTI");
  AdmsSensFadType modelPar_VBIRGAT=mod.VBIRGAT;
  bool modelPar_given_VBIRGAT=mod.given("VBIRGAT");
  AdmsSensFadType modelPar_PBOT=mod.PBOT;
  bool modelPar_given_PBOT=mod.given("PBOT");
  AdmsSensFadType modelPar_PSTI=mod.PSTI;
  bool modelPar_given_PSTI=mod.given("PSTI");
  AdmsSensFadType modelPar_PGAT=mod.PGAT;
  bool modelPar_given_PGAT=mod.given("PGAT");
  AdmsSensFadType modelPar_PHIGBOT=mod.PHIGBOT;
  bool modelPar_given_PHIGBOT=mod.given("PHIGBOT");
  AdmsSensFadType modelPar_PHIGSTI=mod.PHIGSTI;
  bool modelPar_given_PHIGSTI=mod.given("PHIGSTI");
  AdmsSensFadType modelPar_PHIGGAT=mod.PHIGGAT;
  bool modelPar_given_PHIGGAT=mod.given("PHIGGAT");
  AdmsSensFadType modelPar_IDSATRBOT=mod.IDSATRBOT;
  bool modelPar_given_IDSATRBOT=mod.given("IDSATRBOT");
  AdmsSensFadType modelPar_IDSATRSTI=mod.IDSATRSTI;
  bool modelPar_given_IDSATRSTI=mod.given("IDSATRSTI");
  AdmsSensFadType modelPar_IDSATRGAT=mod.IDSATRGAT;
  bool modelPar_given_IDSATRGAT=mod.given("IDSATRGAT");
  AdmsSensFadType modelPar_CSRHBOT=mod.CSRHBOT;
  bool modelPar_given_CSRHBOT=mod.given("CSRHBOT");
  AdmsSensFadType modelPar_CSRHSTI=mod.CSRHSTI;
  bool modelPar_given_CSRHSTI=mod.given("CSRHSTI");
  AdmsSensFadType modelPar_CSRHGAT=mod.CSRHGAT;
  bool modelPar_given_CSRHGAT=mod.given("CSRHGAT");
  AdmsSensFadType modelPar_XJUNSTI=mod.XJUNSTI;
  bool modelPar_given_XJUNSTI=mod.given("XJUNSTI");
  AdmsSensFadType modelPar_XJUNGAT=mod.XJUNGAT;
  bool modelPar_given_XJUNGAT=mod.given("XJUNGAT");
  AdmsSensFadType modelPar_CTATBOT=mod.CTATBOT;
  bool modelPar_given_CTATBOT=mod.given("CTATBOT");
  AdmsSensFadType modelPar_CTATSTI=mod.CTATSTI;
  bool modelPar_given_CTATSTI=mod.given("CTATSTI");
  AdmsSensFadType modelPar_CTATGAT=mod.CTATGAT;
  bool modelPar_given_CTATGAT=mod.given("CTATGAT");
  AdmsSensFadType modelPar_MEFFTATBOT=mod.MEFFTATBOT;
  bool modelPar_given_MEFFTATBOT=mod.given("MEFFTATBOT");
  AdmsSensFadType modelPar_MEFFTATSTI=mod.MEFFTATSTI;
  bool modelPar_given_MEFFTATSTI=mod.given("MEFFTATSTI");
  AdmsSensFadType modelPar_MEFFTATGAT=mod.MEFFTATGAT;
  bool modelPar_given_MEFFTATGAT=mod.given("MEFFTATGAT");
  AdmsSensFadType modelPar_CBBTBOT=mod.CBBTBOT;
  bool modelPar_given_CBBTBOT=mod.given("CBBTBOT");
  AdmsSensFadType modelPar_CBBTSTI=mod.CBBTSTI;
  bool modelPar_given_CBBTSTI=mod.given("CBBTSTI");
  AdmsSensFadType modelPar_CBBTGAT=mod.CBBTGAT;
  bool modelPar_given_CBBTGAT=mod.given("CBBTGAT");
  AdmsSensFadType modelPar_FBBTRBOT=mod.FBBTRBOT;
  bool modelPar_given_FBBTRBOT=mod.given("FBBTRBOT");
  AdmsSensFadType modelPar_FBBTRSTI=mod.FBBTRSTI;
  bool modelPar_given_FBBTRSTI=mod.given("FBBTRSTI");
  AdmsSensFadType modelPar_FBBTRGAT=mod.FBBTRGAT;
  bool modelPar_given_FBBTRGAT=mod.given("FBBTRGAT");
  AdmsSensFadType modelPar_STFBBTBOT=mod.STFBBTBOT;
  bool modelPar_given_STFBBTBOT=mod.given("STFBBTBOT");
  AdmsSensFadType modelPar_STFBBTSTI=mod.STFBBTSTI;
  bool modelPar_given_STFBBTSTI=mod.given("STFBBTSTI");
  AdmsSensFadType modelPar_STFBBTGAT=mod.STFBBTGAT;
  bool modelPar_given_STFBBTGAT=mod.given("STFBBTGAT");
  AdmsSensFadType modelPar_VBRBOT=mod.VBRBOT;
  bool modelPar_given_VBRBOT=mod.given("VBRBOT");
  AdmsSensFadType modelPar_VBRSTI=mod.VBRSTI;
  bool modelPar_given_VBRSTI=mod.given("VBRSTI");
  AdmsSensFadType modelPar_VBRGAT=mod.VBRGAT;
  bool modelPar_given_VBRGAT=mod.given("VBRGAT");
  AdmsSensFadType modelPar_PBRBOT=mod.PBRBOT;
  bool modelPar_given_PBRBOT=mod.given("PBRBOT");
  AdmsSensFadType modelPar_PBRSTI=mod.PBRSTI;
  bool modelPar_given_PBRSTI=mod.given("PBRSTI");
  AdmsSensFadType modelPar_PBRGAT=mod.PBRGAT;
  bool modelPar_given_PBRGAT=mod.given("PBRGAT");
  AdmsSensFadType modelPar_CJORBOTD=mod.CJORBOTD;
  bool modelPar_given_CJORBOTD=mod.given("CJORBOTD");
  AdmsSensFadType modelPar_CJORSTID=mod.CJORSTID;
  bool modelPar_given_CJORSTID=mod.given("CJORSTID");
  AdmsSensFadType modelPar_CJORGATD=mod.CJORGATD;
  bool modelPar_given_CJORGATD=mod.given("CJORGATD");
  AdmsSensFadType modelPar_VBIRBOTD=mod.VBIRBOTD;
  bool modelPar_given_VBIRBOTD=mod.given("VBIRBOTD");
  AdmsSensFadType modelPar_VBIRSTID=mod.VBIRSTID;
  bool modelPar_given_VBIRSTID=mod.given("VBIRSTID");
  AdmsSensFadType modelPar_VBIRGATD=mod.VBIRGATD;
  bool modelPar_given_VBIRGATD=mod.given("VBIRGATD");
  AdmsSensFadType modelPar_PBOTD=mod.PBOTD;
  bool modelPar_given_PBOTD=mod.given("PBOTD");
  AdmsSensFadType modelPar_PSTID=mod.PSTID;
  bool modelPar_given_PSTID=mod.given("PSTID");
  AdmsSensFadType modelPar_PGATD=mod.PGATD;
  bool modelPar_given_PGATD=mod.given("PGATD");
  AdmsSensFadType modelPar_PHIGBOTD=mod.PHIGBOTD;
  bool modelPar_given_PHIGBOTD=mod.given("PHIGBOTD");
  AdmsSensFadType modelPar_PHIGSTID=mod.PHIGSTID;
  bool modelPar_given_PHIGSTID=mod.given("PHIGSTID");
  AdmsSensFadType modelPar_PHIGGATD=mod.PHIGGATD;
  bool modelPar_given_PHIGGATD=mod.given("PHIGGATD");
  AdmsSensFadType modelPar_IDSATRBOTD=mod.IDSATRBOTD;
  bool modelPar_given_IDSATRBOTD=mod.given("IDSATRBOTD");
  AdmsSensFadType modelPar_IDSATRSTID=mod.IDSATRSTID;
  bool modelPar_given_IDSATRSTID=mod.given("IDSATRSTID");
  AdmsSensFadType modelPar_IDSATRGATD=mod.IDSATRGATD;
  bool modelPar_given_IDSATRGATD=mod.given("IDSATRGATD");
  AdmsSensFadType modelPar_CSRHBOTD=mod.CSRHBOTD;
  bool modelPar_given_CSRHBOTD=mod.given("CSRHBOTD");
  AdmsSensFadType modelPar_CSRHSTID=mod.CSRHSTID;
  bool modelPar_given_CSRHSTID=mod.given("CSRHSTID");
  AdmsSensFadType modelPar_CSRHGATD=mod.CSRHGATD;
  bool modelPar_given_CSRHGATD=mod.given("CSRHGATD");
  AdmsSensFadType modelPar_XJUNSTID=mod.XJUNSTID;
  bool modelPar_given_XJUNSTID=mod.given("XJUNSTID");
  AdmsSensFadType modelPar_XJUNGATD=mod.XJUNGATD;
  bool modelPar_given_XJUNGATD=mod.given("XJUNGATD");
  AdmsSensFadType modelPar_CTATBOTD=mod.CTATBOTD;
  bool modelPar_given_CTATBOTD=mod.given("CTATBOTD");
  AdmsSensFadType modelPar_CTATSTID=mod.CTATSTID;
  bool modelPar_given_CTATSTID=mod.given("CTATSTID");
  AdmsSensFadType modelPar_CTATGATD=mod.CTATGATD;
  bool modelPar_given_CTATGATD=mod.given("CTATGATD");
  AdmsSensFadType modelPar_MEFFTATBOTD=mod.MEFFTATBOTD;
  bool modelPar_given_MEFFTATBOTD=mod.given("MEFFTATBOTD");
  AdmsSensFadType modelPar_MEFFTATSTID=mod.MEFFTATSTID;
  bool modelPar_given_MEFFTATSTID=mod.given("MEFFTATSTID");
  AdmsSensFadType modelPar_MEFFTATGATD=mod.MEFFTATGATD;
  bool modelPar_given_MEFFTATGATD=mod.given("MEFFTATGATD");
  AdmsSensFadType modelPar_CBBTBOTD=mod.CBBTBOTD;
  bool modelPar_given_CBBTBOTD=mod.given("CBBTBOTD");
  AdmsSensFadType modelPar_CBBTSTID=mod.CBBTSTID;
  bool modelPar_given_CBBTSTID=mod.given("CBBTSTID");
  AdmsSensFadType modelPar_CBBTGATD=mod.CBBTGATD;
  bool modelPar_given_CBBTGATD=mod.given("CBBTGATD");
  AdmsSensFadType modelPar_FBBTRBOTD=mod.FBBTRBOTD;
  bool modelPar_given_FBBTRBOTD=mod.given("FBBTRBOTD");
  AdmsSensFadType modelPar_FBBTRSTID=mod.FBBTRSTID;
  bool modelPar_given_FBBTRSTID=mod.given("FBBTRSTID");
  AdmsSensFadType modelPar_FBBTRGATD=mod.FBBTRGATD;
  bool modelPar_given_FBBTRGATD=mod.given("FBBTRGATD");
  AdmsSensFadType modelPar_STFBBTBOTD=mod.STFBBTBOTD;
  bool modelPar_given_STFBBTBOTD=mod.given("STFBBTBOTD");
  AdmsSensFadType modelPar_STFBBTSTID=mod.STFBBTSTID;
  bool modelPar_given_STFBBTSTID=mod.given("STFBBTSTID");
  AdmsSensFadType modelPar_STFBBTGATD=mod.STFBBTGATD;
  bool modelPar_given_STFBBTGATD=mod.given("STFBBTGATD");
  AdmsSensFadType modelPar_VBRBOTD=mod.VBRBOTD;
  bool modelPar_given_VBRBOTD=mod.given("VBRBOTD");
  AdmsSensFadType modelPar_VBRSTID=mod.VBRSTID;
  bool modelPar_given_VBRSTID=mod.given("VBRSTID");
  AdmsSensFadType modelPar_VBRGATD=mod.VBRGATD;
  bool modelPar_given_VBRGATD=mod.given("VBRGATD");
  AdmsSensFadType modelPar_PBRBOTD=mod.PBRBOTD;
  bool modelPar_given_PBRBOTD=mod.given("PBRBOTD");
  AdmsSensFadType modelPar_PBRSTID=mod.PBRSTID;
  bool modelPar_given_PBRSTID=mod.given("PBRSTID");
  AdmsSensFadType modelPar_PBRGATD=mod.PBRGATD;
  bool modelPar_given_PBRGATD=mod.given("PBRGATD");
  AdmsSensFadType modelPar_SWJUNEXP=mod.SWJUNEXP;
  bool modelPar_given_SWJUNEXP=mod.given("SWJUNEXP");
  AdmsSensFadType modelPar_VJUNREF=mod.VJUNREF;
  bool modelPar_given_VJUNREF=mod.given("VJUNREF");
  AdmsSensFadType modelPar_FJUNQ=mod.FJUNQ;
  bool modelPar_given_FJUNQ=mod.given("FJUNQ");
  AdmsSensFadType modelPar_VJUNREFD=mod.VJUNREFD;
  bool modelPar_given_VJUNREFD=mod.given("VJUNREFD");
  AdmsSensFadType modelPar_FJUNQD=mod.FJUNQD;
  bool modelPar_given_FJUNQD=mod.given("FJUNQD");


  // hidden reals


  // non-reals (including hiddens)



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals
  AdmsSensFadType instancePar_L=in.L;
  bool instancePar_given_L=in.given("L");
  inParamMap["L"] = &instancePar_L;
  AdmsSensFadType instancePar_W=in.W;
  bool instancePar_given_W=in.given("W");
  inParamMap["W"] = &instancePar_W;
  AdmsSensFadType instancePar_SA=in.SA;
  bool instancePar_given_SA=in.given("SA");
  inParamMap["SA"] = &instancePar_SA;
  AdmsSensFadType instancePar_SB=in.SB;
  bool instancePar_given_SB=in.given("SB");
  inParamMap["SB"] = &instancePar_SB;
  AdmsSensFadType instancePar_SD=in.SD;
  bool instancePar_given_SD=in.given("SD");
  inParamMap["SD"] = &instancePar_SD;
  AdmsSensFadType instancePar_SCA=in.SCA;
  bool instancePar_given_SCA=in.given("SCA");
  inParamMap["SCA"] = &instancePar_SCA;
  AdmsSensFadType instancePar_SCB=in.SCB;
  bool instancePar_given_SCB=in.given("SCB");
  inParamMap["SCB"] = &instancePar_SCB;
  AdmsSensFadType instancePar_SCC=in.SCC;
  bool instancePar_given_SCC=in.given("SCC");
  inParamMap["SCC"] = &instancePar_SCC;
  AdmsSensFadType instancePar_SC=in.SC;
  bool instancePar_given_SC=in.given("SC");
  inParamMap["SC"] = &instancePar_SC;
  AdmsSensFadType instancePar_DELVTO=in.DELVTO;
  bool instancePar_given_DELVTO=in.given("DELVTO");
  inParamMap["DELVTO"] = &instancePar_DELVTO;
  AdmsSensFadType instancePar_FACTUO=in.FACTUO;
  bool instancePar_given_FACTUO=in.given("FACTUO");
  inParamMap["FACTUO"] = &instancePar_FACTUO;
  AdmsSensFadType instancePar_ABSOURCE=in.ABSOURCE;
  bool instancePar_given_ABSOURCE=in.given("ABSOURCE");
  inParamMap["ABSOURCE"] = &instancePar_ABSOURCE;
  AdmsSensFadType instancePar_LSSOURCE=in.LSSOURCE;
  bool instancePar_given_LSSOURCE=in.given("LSSOURCE");
  inParamMap["LSSOURCE"] = &instancePar_LSSOURCE;
  AdmsSensFadType instancePar_LGSOURCE=in.LGSOURCE;
  bool instancePar_given_LGSOURCE=in.given("LGSOURCE");
  inParamMap["LGSOURCE"] = &instancePar_LGSOURCE;
  AdmsSensFadType instancePar_ABDRAIN=in.ABDRAIN;
  bool instancePar_given_ABDRAIN=in.given("ABDRAIN");
  inParamMap["ABDRAIN"] = &instancePar_ABDRAIN;
  AdmsSensFadType instancePar_LSDRAIN=in.LSDRAIN;
  bool instancePar_given_LSDRAIN=in.given("LSDRAIN");
  inParamMap["LSDRAIN"] = &instancePar_LSDRAIN;
  AdmsSensFadType instancePar_LGDRAIN=in.LGDRAIN;
  bool instancePar_given_LGDRAIN=in.given("LGDRAIN");
  inParamMap["LGDRAIN"] = &instancePar_LGDRAIN;
  AdmsSensFadType instancePar_AS=in.AS;
  bool instancePar_given_AS=in.given("AS");
  inParamMap["AS"] = &instancePar_AS;
  AdmsSensFadType instancePar_PS=in.PS;
  bool instancePar_given_PS=in.given("PS");
  inParamMap["PS"] = &instancePar_PS;
  AdmsSensFadType instancePar_AD=in.AD;
  bool instancePar_given_AD=in.given("AD");
  inParamMap["AD"] = &instancePar_AD;
  AdmsSensFadType instancePar_PD=in.PD;
  bool instancePar_given_PD=in.given("PD");
  inParamMap["PD"] = &instancePar_PD;
  AdmsSensFadType instancePar_MULT=in.MULT;
  bool instancePar_given_MULT=in.given("MULT");
  inParamMap["MULT"] = &instancePar_MULT;
  AdmsSensFadType instancePar_NF=in.NF;
  bool instancePar_given_NF=in.given("NF");
  inParamMap["NF"] = &instancePar_NF;
  AdmsSensFadType instancePar_NGCON=in.NGCON;
  bool instancePar_given_NGCON=in.given("NGCON");
  inParamMap["NGCON"] = &instancePar_NGCON;
  AdmsSensFadType instancePar_XGW=in.XGW;
  bool instancePar_given_XGW=in.given("XGW");
  inParamMap["XGW"] = &instancePar_XGW;


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals
  AdmsSensFadType instanceVar_VFB_i=in.VFB_i;
  AdmsSensFadType instanceVar_VNSUB_i=in.VNSUB_i;
  AdmsSensFadType instanceVar_NSLP_i=in.NSLP_i;
  AdmsSensFadType instanceVar_DNSUB_i=in.DNSUB_i;
  AdmsSensFadType instanceVar_CF_i=in.CF_i;
  AdmsSensFadType instanceVar_CFB_i=in.CFB_i;
  AdmsSensFadType instanceVar_MUE_i=in.MUE_i;
  AdmsSensFadType instanceVar_THEMU_i=in.THEMU_i;
  AdmsSensFadType instanceVar_CS_i=in.CS_i;
  AdmsSensFadType instanceVar_XCOR_i=in.XCOR_i;
  AdmsSensFadType instanceVar_THER_i=in.THER_i;
  AdmsSensFadType instanceVar_RSB_i=in.RSB_i;
  AdmsSensFadType instanceVar_RSG_i=in.RSG_i;
  AdmsSensFadType instanceVar_THESAT_i=in.THESAT_i;
  AdmsSensFadType instanceVar_THESATB_i=in.THESATB_i;
  AdmsSensFadType instanceVar_THESATG_i=in.THESATG_i;
  AdmsSensFadType instanceVar_AX_i=in.AX_i;
  AdmsSensFadType instanceVar_ALP_i=in.ALP_i;
  AdmsSensFadType instanceVar_ALP1_i=in.ALP1_i;
  AdmsSensFadType instanceVar_ALP2_i=in.ALP2_i;
  AdmsSensFadType instanceVar_A1_i=in.A1_i;
  AdmsSensFadType instanceVar_A2_i=in.A2_i;
  AdmsSensFadType instanceVar_A3_i=in.A3_i;
  AdmsSensFadType instanceVar_A4_i=in.A4_i;
  AdmsSensFadType instanceVar_IGINV_i=in.IGINV_i;
  AdmsSensFadType instanceVar_IGOV_i=in.IGOV_i;
  AdmsSensFadType instanceVar_IGOVD_i=in.IGOVD_i;
  AdmsSensFadType instanceVar_GC2_i=in.GC2_i;
  AdmsSensFadType instanceVar_GC3_i=in.GC3_i;
  AdmsSensFadType instanceVar_CHIB_i=in.CHIB_i;
  AdmsSensFadType instanceVar_AGIDL_i=in.AGIDL_i;
  AdmsSensFadType instanceVar_CGIDL_i=in.CGIDL_i;
  AdmsSensFadType instanceVar_AGIDLD_i=in.AGIDLD_i;
  AdmsSensFadType instanceVar_CGIDLD_i=in.CGIDLD_i;
  AdmsSensFadType instanceVar_COX_i=in.COX_i;
  AdmsSensFadType instanceVar_CGOV_i=in.CGOV_i;
  AdmsSensFadType instanceVar_CGOVD_i=in.CGOVD_i;
  AdmsSensFadType instanceVar_CGBOV_i=in.CGBOV_i;
  AdmsSensFadType instanceVar_CFR_i=in.CFR_i;
  AdmsSensFadType instanceVar_CFRD_i=in.CFRD_i;
  AdmsSensFadType instanceVar_NFA_i=in.NFA_i;
  AdmsSensFadType instanceVar_NFB_i=in.NFB_i;
  AdmsSensFadType instanceVar_NFC_i=in.NFC_i;
  AdmsSensFadType instanceVar_EF_i=in.EF_i;
  AdmsSensFadType instanceVar_FNTEXC_i=in.FNTEXC_i;
  AdmsSensFadType instanceVar_MULT_i=in.MULT_i;
  AdmsSensFadType instanceVar_BET_i=in.BET_i;
  AdmsSensFadType instanceVar_kp=in.kp;
  AdmsSensFadType instanceVar_qq=in.qq;
  AdmsSensFadType instanceVar_qlim2=in.qlim2;
  AdmsSensFadType instanceVar_E_eff0=in.E_eff0;
  AdmsSensFadType instanceVar_eta_mu=in.eta_mu;
  AdmsSensFadType instanceVar_BCH=in.BCH;
  AdmsSensFadType instanceVar_BOV=in.BOV;
  AdmsSensFadType instanceVar_inv_CHIB=in.inv_CHIB;
  AdmsSensFadType instanceVar_GCQ=in.GCQ;
  AdmsSensFadType instanceVar_Dch=in.Dch;
  AdmsSensFadType instanceVar_Dov=in.Dov;
  AdmsSensFadType instanceVar_x1=in.x1;
  AdmsSensFadType instanceVar_Vdsat_lim=in.Vdsat_lim;
  AdmsSensFadType instanceVar_nt=in.nt;
  AdmsSensFadType instanceVar_Cox_over_q=in.Cox_over_q;
  AdmsSensFadType instanceVar_GOV_s=in.GOV_s;
  AdmsSensFadType instanceVar_GOV_d=in.GOV_d;
  AdmsSensFadType instanceVar_GOV2_s=in.GOV2_s;
  AdmsSensFadType instanceVar_GOV2_d=in.GOV2_d;
  AdmsSensFadType instanceVar_BOV_d=in.BOV_d;
  AdmsSensFadType instanceVar_xi_ov_s=in.xi_ov_s;
  AdmsSensFadType instanceVar_xi_ov_d=in.xi_ov_d;
  AdmsSensFadType instanceVar_inv_xi_ov_s=in.inv_xi_ov_s;
  AdmsSensFadType instanceVar_inv_xi_ov_d=in.inv_xi_ov_d;
  AdmsSensFadType instanceVar_x_mrg_ov_s=in.x_mrg_ov_s;
  AdmsSensFadType instanceVar_x_mrg_ov_d=in.x_mrg_ov_d;
  AdmsSensFadType instanceVar_inv_xg1_s=in.inv_xg1_s;
  AdmsSensFadType instanceVar_inv_xg1_d=in.inv_xg1_d;
  AdmsSensFadType instanceVar_AGIDLs=in.AGIDLs;
  AdmsSensFadType instanceVar_AGIDLDs=in.AGIDLDs;
  AdmsSensFadType instanceVar_BGIDLs=in.BGIDLs;
  AdmsSensFadType instanceVar_BGIDLDs=in.BGIDLDs;
  AdmsSensFadType instanceVar_phib=in.phib;
  AdmsSensFadType instanceVar_sqrt_phib=in.sqrt_phib;
  AdmsSensFadType instanceVar_phix=in.phix;
  AdmsSensFadType instanceVar_aphi=in.aphi;
  AdmsSensFadType instanceVar_bphi=in.bphi;
  AdmsSensFadType instanceVar_phix1=in.phix1;
  AdmsSensFadType instanceVar_G_0=in.G_0;
  AdmsSensFadType instanceVar_phit1=in.phit1;
  AdmsSensFadType instanceVar_inv_phit1=in.inv_phit1;
  AdmsSensFadType instanceVar_alpha_b=in.alpha_b;
  AdmsSensFadType instanceVar_inv_VP=in.inv_VP;
  AdmsSensFadType instanceVar_inv_AX=in.inv_AX;
  AdmsSensFadType instanceVar_Sfl_prefac=in.Sfl_prefac;
  AdmsSensFadType instanceVar_fac_exc=in.fac_exc;
  AdmsSensFadType instanceVar_RG_i=in.RG_i;
  AdmsSensFadType instanceVar_RBULK_i=in.RBULK_i;
  AdmsSensFadType instanceVar_RWELL_i=in.RWELL_i;
  AdmsSensFadType instanceVar_RJUNS_i=in.RJUNS_i;
  AdmsSensFadType instanceVar_RJUND_i=in.RJUND_i;
  AdmsSensFadType instanceVar_ggate=in.ggate;
  AdmsSensFadType instanceVar_gbulk=in.gbulk;
  AdmsSensFadType instanceVar_gwell=in.gwell;
  AdmsSensFadType instanceVar_gjund=in.gjund;
  AdmsSensFadType instanceVar_gjuns=in.gjuns;
  AdmsSensFadType instanceVar_ABSOURCE_i=in.ABSOURCE_i;
  AdmsSensFadType instanceVar_LSSOURCE_i=in.LSSOURCE_i;
  AdmsSensFadType instanceVar_LGSOURCE_i=in.LGSOURCE_i;
  AdmsSensFadType instanceVar_zflagbot_s=in.zflagbot_s;
  AdmsSensFadType instanceVar_zflagsti_s=in.zflagsti_s;
  AdmsSensFadType instanceVar_zflaggat_s=in.zflaggat_s;
  AdmsSensFadType instanceVar_VMAX_s=in.VMAX_s;
  AdmsSensFadType instanceVar_exp_VMAX_over_phitd_s=in.exp_VMAX_over_phitd_s;
  AdmsSensFadType instanceVar_vbimin_s=in.vbimin_s;
  AdmsSensFadType instanceVar_vch_s=in.vch_s;
  AdmsSensFadType instanceVar_vfmin_s=in.vfmin_s;
  AdmsSensFadType instanceVar_vbbtlim_s=in.vbbtlim_s;
  AdmsSensFadType instanceVar_xhighf1_s=in.xhighf1_s;
  AdmsSensFadType instanceVar_expxhf1_s=in.expxhf1_s;
  AdmsSensFadType instanceVar_xhighf2_s=in.xhighf2_s;
  AdmsSensFadType instanceVar_expxhf2_s=in.expxhf2_s;
  AdmsSensFadType instanceVar_xhighr_s=in.xhighr_s;
  AdmsSensFadType instanceVar_expxhr_s=in.expxhr_s;
  AdmsSensFadType instanceVar_m0flag_s=in.m0flag_s;
  AdmsSensFadType instanceVar_ISATFOR1_s=in.ISATFOR1_s;
  AdmsSensFadType instanceVar_MFOR1_s=in.MFOR1_s;
  AdmsSensFadType instanceVar_ISATFOR2_s=in.ISATFOR2_s;
  AdmsSensFadType instanceVar_MFOR2_s=in.MFOR2_s;
  AdmsSensFadType instanceVar_ISATREV_s=in.ISATREV_s;
  AdmsSensFadType instanceVar_MREV_s=in.MREV_s;
  AdmsSensFadType instanceVar_ABDRAIN_i=in.ABDRAIN_i;
  AdmsSensFadType instanceVar_LSDRAIN_i=in.LSDRAIN_i;
  AdmsSensFadType instanceVar_LGDRAIN_i=in.LGDRAIN_i;
  AdmsSensFadType instanceVar_zflagbot_d=in.zflagbot_d;
  AdmsSensFadType instanceVar_zflagsti_d=in.zflagsti_d;
  AdmsSensFadType instanceVar_zflaggat_d=in.zflaggat_d;
  AdmsSensFadType instanceVar_VMAX_d=in.VMAX_d;
  AdmsSensFadType instanceVar_exp_VMAX_over_phitd_d=in.exp_VMAX_over_phitd_d;
  AdmsSensFadType instanceVar_vbimin_d=in.vbimin_d;
  AdmsSensFadType instanceVar_vch_d=in.vch_d;
  AdmsSensFadType instanceVar_vfmin_d=in.vfmin_d;
  AdmsSensFadType instanceVar_vbbtlim_d=in.vbbtlim_d;
  AdmsSensFadType instanceVar_xhighf1_d=in.xhighf1_d;
  AdmsSensFadType instanceVar_expxhf1_d=in.expxhf1_d;
  AdmsSensFadType instanceVar_xhighf2_d=in.xhighf2_d;
  AdmsSensFadType instanceVar_expxhf2_d=in.expxhf2_d;
  AdmsSensFadType instanceVar_xhighr_d=in.xhighr_d;
  AdmsSensFadType instanceVar_expxhr_d=in.expxhr_d;
  AdmsSensFadType instanceVar_m0flag_d=in.m0flag_d;
  AdmsSensFadType instanceVar_ISATFOR1_d=in.ISATFOR1_d;
  AdmsSensFadType instanceVar_MFOR1_d=in.MFOR1_d;
  AdmsSensFadType instanceVar_ISATFOR2_d=in.ISATFOR2_d;
  AdmsSensFadType instanceVar_MFOR2_d=in.MFOR2_d;
  AdmsSensFadType instanceVar_ISATREV_d=in.ISATREV_d;
  AdmsSensFadType instanceVar_MREV_d=in.MREV_d;


  //non-reals


  //make local copies of all model vars
  //reals
  AdmsSensFadType modelVar_NSUBO_i=mod.NSUBO_i;
  AdmsSensFadType modelVar_WSEG_i=mod.WSEG_i;
  AdmsSensFadType modelVar_NPCK_i=mod.NPCK_i;
  AdmsSensFadType modelVar_WSEGP_i=mod.WSEGP_i;
  AdmsSensFadType modelVar_LPCK_i=mod.LPCK_i;
  AdmsSensFadType modelVar_LOV_i=mod.LOV_i;
  AdmsSensFadType modelVar_LOVD_i=mod.LOVD_i;
  AdmsSensFadType modelVar_LP1_i=mod.LP1_i;
  AdmsSensFadType modelVar_LP2_i=mod.LP2_i;
  AdmsSensFadType modelVar_WBET_i=mod.WBET_i;
  AdmsSensFadType modelVar_AXL_i=mod.AXL_i;
  AdmsSensFadType modelVar_ALP1L2_i=mod.ALP1L2_i;
  AdmsSensFadType modelVar_ALP2L2_i=mod.ALP2L2_i;
  AdmsSensFadType modelVar_RINT_i=mod.RINT_i;
  AdmsSensFadType modelVar_RVPOLY_i=mod.RVPOLY_i;
  AdmsSensFadType modelVar_SAREF_i=mod.SAREF_i;
  AdmsSensFadType modelVar_SBREF_i=mod.SBREF_i;
  AdmsSensFadType modelVar_KVSAT_i=mod.KVSAT_i;
  AdmsSensFadType modelVar_LLODKUO_i=mod.LLODKUO_i;
  AdmsSensFadType modelVar_WLODKUO_i=mod.WLODKUO_i;
  AdmsSensFadType modelVar_LLODVTH_i=mod.LLODVTH_i;
  AdmsSensFadType modelVar_WLODVTH_i=mod.WLODVTH_i;
  AdmsSensFadType modelVar_LODETAO_i=mod.LODETAO_i;
  AdmsSensFadType modelVar_SCREF_i=mod.SCREF_i;
  AdmsSensFadType modelVar_WEB_i=mod.WEB_i;
  AdmsSensFadType modelVar_WEC_i=mod.WEC_i;
  AdmsSensFadType modelVar_TOX_i=mod.TOX_i;
  AdmsSensFadType modelVar_EPSROX_i=mod.EPSROX_i;
  AdmsSensFadType modelVar_TOXOV_i=mod.TOXOV_i;
  AdmsSensFadType modelVar_TOXOVD_i=mod.TOXOVD_i;
  AdmsSensFadType modelVar_TKD=mod.TKD;
  AdmsSensFadType modelVar_dT=mod.dT;
  AdmsSensFadType modelVar_rT=mod.rT;
  AdmsSensFadType modelVar_rTn=mod.rTn;
  AdmsSensFadType modelVar_EPSSI=mod.EPSSI;
  AdmsSensFadType modelVar_phit=mod.phit;
  AdmsSensFadType modelVar_inv_phit=mod.inv_phit;
  AdmsSensFadType modelVar_Eg=mod.Eg;
  AdmsSensFadType modelVar_phibFac=mod.phibFac;
  AdmsSensFadType modelVar_nt0=mod.nt0;
  AdmsSensFadType modelVar_IMAX_i=mod.IMAX_i;
  AdmsSensFadType modelVar_VBIRBOT_i=mod.VBIRBOT_i;
  AdmsSensFadType modelVar_VBIRSTI_i=mod.VBIRSTI_i;
  AdmsSensFadType modelVar_VBIRGAT_i=mod.VBIRGAT_i;
  AdmsSensFadType modelVar_PBOT_i=mod.PBOT_i;
  AdmsSensFadType modelVar_PSTI_i=mod.PSTI_i;
  AdmsSensFadType modelVar_PGAT_i=mod.PGAT_i;
  AdmsSensFadType modelVar_CSRHBOT_i=mod.CSRHBOT_i;
  AdmsSensFadType modelVar_CSRHSTI_i=mod.CSRHSTI_i;
  AdmsSensFadType modelVar_CSRHGAT_i=mod.CSRHGAT_i;
  AdmsSensFadType modelVar_CTATBOT_i=mod.CTATBOT_i;
  AdmsSensFadType modelVar_CTATSTI_i=mod.CTATSTI_i;
  AdmsSensFadType modelVar_CTATGAT_i=mod.CTATGAT_i;
  AdmsSensFadType modelVar_CBBTBOT_i=mod.CBBTBOT_i;
  AdmsSensFadType modelVar_CBBTSTI_i=mod.CBBTSTI_i;
  AdmsSensFadType modelVar_CBBTGAT_i=mod.CBBTGAT_i;
  AdmsSensFadType modelVar_VBRBOT_i=mod.VBRBOT_i;
  AdmsSensFadType modelVar_VBRSTI_i=mod.VBRSTI_i;
  AdmsSensFadType modelVar_VBRGAT_i=mod.VBRGAT_i;
  AdmsSensFadType modelVar_PBRBOT_i=mod.PBRBOT_i;
  AdmsSensFadType modelVar_PBRSTI_i=mod.PBRSTI_i;
  AdmsSensFadType modelVar_PBRGAT_i=mod.PBRGAT_i;
  AdmsSensFadType modelVar_SWJUNEXP_i=mod.SWJUNEXP_i;
  AdmsSensFadType modelVar_VJUNREF_i=mod.VJUNREF_i;
  AdmsSensFadType modelVar_FJUNQ_i=mod.FJUNQ_i;
  AdmsSensFadType modelVar_phitr=mod.phitr;
  AdmsSensFadType modelVar_phitd=mod.phitd;
  AdmsSensFadType modelVar_phitdinv=mod.phitdinv;
  AdmsSensFadType modelVar_perfc=mod.perfc;
  AdmsSensFadType modelVar_berfc=mod.berfc;
  AdmsSensFadType modelVar_cerfc=mod.cerfc;
  AdmsSensFadType modelVar_ftdbot=mod.ftdbot;
  AdmsSensFadType modelVar_ftdsti=mod.ftdsti;
  AdmsSensFadType modelVar_ftdgat=mod.ftdgat;
  AdmsSensFadType modelVar_idsatbot=mod.idsatbot;
  AdmsSensFadType modelVar_idsatsti=mod.idsatsti;
  AdmsSensFadType modelVar_idsatgat=mod.idsatgat;
  AdmsSensFadType modelVar_vbibot=mod.vbibot;
  AdmsSensFadType modelVar_vbisti=mod.vbisti;
  AdmsSensFadType modelVar_vbigat=mod.vbigat;
  AdmsSensFadType modelVar_vbiinvbot=mod.vbiinvbot;
  AdmsSensFadType modelVar_vbiinvsti=mod.vbiinvsti;
  AdmsSensFadType modelVar_vbiinvgat=mod.vbiinvgat;
  AdmsSensFadType modelVar_one_minus_PBOT=mod.one_minus_PBOT;
  AdmsSensFadType modelVar_one_minus_PSTI=mod.one_minus_PSTI;
  AdmsSensFadType modelVar_one_minus_PGAT=mod.one_minus_PGAT;
  AdmsSensFadType modelVar_one_over_one_minus_PBOT=mod.one_over_one_minus_PBOT;
  AdmsSensFadType modelVar_one_over_one_minus_PSTI=mod.one_over_one_minus_PSTI;
  AdmsSensFadType modelVar_one_over_one_minus_PGAT=mod.one_over_one_minus_PGAT;
  AdmsSensFadType modelVar_cjobot=mod.cjobot;
  AdmsSensFadType modelVar_cjosti=mod.cjosti;
  AdmsSensFadType modelVar_cjogat=mod.cjogat;
  AdmsSensFadType modelVar_qprefbot=mod.qprefbot;
  AdmsSensFadType modelVar_qprefsti=mod.qprefsti;
  AdmsSensFadType modelVar_qprefgat=mod.qprefgat;
  AdmsSensFadType modelVar_qpref2bot=mod.qpref2bot;
  AdmsSensFadType modelVar_qpref2sti=mod.qpref2sti;
  AdmsSensFadType modelVar_qpref2gat=mod.qpref2gat;
  AdmsSensFadType modelVar_wdepnulrbot=mod.wdepnulrbot;
  AdmsSensFadType modelVar_wdepnulrsti=mod.wdepnulrsti;
  AdmsSensFadType modelVar_wdepnulrgat=mod.wdepnulrgat;
  AdmsSensFadType modelVar_wdepnulrinvbot=mod.wdepnulrinvbot;
  AdmsSensFadType modelVar_wdepnulrinvsti=mod.wdepnulrinvsti;
  AdmsSensFadType modelVar_wdepnulrinvgat=mod.wdepnulrinvgat;
  AdmsSensFadType modelVar_VBIRBOTinv=mod.VBIRBOTinv;
  AdmsSensFadType modelVar_VBIRSTIinv=mod.VBIRSTIinv;
  AdmsSensFadType modelVar_VBIRGATinv=mod.VBIRGATinv;
  AdmsSensFadType modelVar_atatbot=mod.atatbot;
  AdmsSensFadType modelVar_atatsti=mod.atatsti;
  AdmsSensFadType modelVar_atatgat=mod.atatgat;
  AdmsSensFadType modelVar_btatpartbot=mod.btatpartbot;
  AdmsSensFadType modelVar_btatpartsti=mod.btatpartsti;
  AdmsSensFadType modelVar_btatpartgat=mod.btatpartgat;
  AdmsSensFadType modelVar_fbbtbot=mod.fbbtbot;
  AdmsSensFadType modelVar_fbbtsti=mod.fbbtsti;
  AdmsSensFadType modelVar_fbbtgat=mod.fbbtgat;
  AdmsSensFadType modelVar_fstopbot=mod.fstopbot;
  AdmsSensFadType modelVar_fstopsti=mod.fstopsti;
  AdmsSensFadType modelVar_fstopgat=mod.fstopgat;
  AdmsSensFadType modelVar_VBRinvbot=mod.VBRinvbot;
  AdmsSensFadType modelVar_VBRinvsti=mod.VBRinvsti;
  AdmsSensFadType modelVar_VBRinvgat=mod.VBRinvgat;
  AdmsSensFadType modelVar_slopebot=mod.slopebot;
  AdmsSensFadType modelVar_slopesti=mod.slopesti;
  AdmsSensFadType modelVar_slopegat=mod.slopegat;
  AdmsSensFadType modelVar_VBIRBOTD_i=mod.VBIRBOTD_i;
  AdmsSensFadType modelVar_VBIRSTID_i=mod.VBIRSTID_i;
  AdmsSensFadType modelVar_VBIRGATD_i=mod.VBIRGATD_i;
  AdmsSensFadType modelVar_PBOTD_i=mod.PBOTD_i;
  AdmsSensFadType modelVar_PSTID_i=mod.PSTID_i;
  AdmsSensFadType modelVar_PGATD_i=mod.PGATD_i;
  AdmsSensFadType modelVar_CSRHBOTD_i=mod.CSRHBOTD_i;
  AdmsSensFadType modelVar_CSRHSTID_i=mod.CSRHSTID_i;
  AdmsSensFadType modelVar_CSRHGATD_i=mod.CSRHGATD_i;
  AdmsSensFadType modelVar_CTATBOTD_i=mod.CTATBOTD_i;
  AdmsSensFadType modelVar_CTATSTID_i=mod.CTATSTID_i;
  AdmsSensFadType modelVar_CTATGATD_i=mod.CTATGATD_i;
  AdmsSensFadType modelVar_CBBTBOTD_i=mod.CBBTBOTD_i;
  AdmsSensFadType modelVar_CBBTSTID_i=mod.CBBTSTID_i;
  AdmsSensFadType modelVar_CBBTGATD_i=mod.CBBTGATD_i;
  AdmsSensFadType modelVar_VBRBOTD_i=mod.VBRBOTD_i;
  AdmsSensFadType modelVar_VBRSTID_i=mod.VBRSTID_i;
  AdmsSensFadType modelVar_VBRGATD_i=mod.VBRGATD_i;
  AdmsSensFadType modelVar_PBRBOTD_i=mod.PBRBOTD_i;
  AdmsSensFadType modelVar_PBRSTID_i=mod.PBRSTID_i;
  AdmsSensFadType modelVar_PBRGATD_i=mod.PBRGATD_i;
  AdmsSensFadType modelVar_VJUNREFD_i=mod.VJUNREFD_i;
  AdmsSensFadType modelVar_FJUNQD_i=mod.FJUNQD_i;
  AdmsSensFadType modelVar_ftdbot_d=mod.ftdbot_d;
  AdmsSensFadType modelVar_ftdsti_d=mod.ftdsti_d;
  AdmsSensFadType modelVar_ftdgat_d=mod.ftdgat_d;
  AdmsSensFadType modelVar_idsatbot_d=mod.idsatbot_d;
  AdmsSensFadType modelVar_idsatsti_d=mod.idsatsti_d;
  AdmsSensFadType modelVar_idsatgat_d=mod.idsatgat_d;
  AdmsSensFadType modelVar_vbibot_d=mod.vbibot_d;
  AdmsSensFadType modelVar_vbisti_d=mod.vbisti_d;
  AdmsSensFadType modelVar_vbigat_d=mod.vbigat_d;
  AdmsSensFadType modelVar_vbiinvbot_d=mod.vbiinvbot_d;
  AdmsSensFadType modelVar_vbiinvsti_d=mod.vbiinvsti_d;
  AdmsSensFadType modelVar_vbiinvgat_d=mod.vbiinvgat_d;
  AdmsSensFadType modelVar_one_minus_PBOT_d=mod.one_minus_PBOT_d;
  AdmsSensFadType modelVar_one_minus_PSTI_d=mod.one_minus_PSTI_d;
  AdmsSensFadType modelVar_one_minus_PGAT_d=mod.one_minus_PGAT_d;
  AdmsSensFadType modelVar_one_over_one_minus_PBOT_d=mod.one_over_one_minus_PBOT_d;
  AdmsSensFadType modelVar_one_over_one_minus_PSTI_d=mod.one_over_one_minus_PSTI_d;
  AdmsSensFadType modelVar_one_over_one_minus_PGAT_d=mod.one_over_one_minus_PGAT_d;
  AdmsSensFadType modelVar_cjobot_d=mod.cjobot_d;
  AdmsSensFadType modelVar_cjosti_d=mod.cjosti_d;
  AdmsSensFadType modelVar_cjogat_d=mod.cjogat_d;
  AdmsSensFadType modelVar_qprefbot_d=mod.qprefbot_d;
  AdmsSensFadType modelVar_qprefsti_d=mod.qprefsti_d;
  AdmsSensFadType modelVar_qprefgat_d=mod.qprefgat_d;
  AdmsSensFadType modelVar_qpref2bot_d=mod.qpref2bot_d;
  AdmsSensFadType modelVar_qpref2sti_d=mod.qpref2sti_d;
  AdmsSensFadType modelVar_qpref2gat_d=mod.qpref2gat_d;
  AdmsSensFadType modelVar_wdepnulrbot_d=mod.wdepnulrbot_d;
  AdmsSensFadType modelVar_wdepnulrsti_d=mod.wdepnulrsti_d;
  AdmsSensFadType modelVar_wdepnulrgat_d=mod.wdepnulrgat_d;
  AdmsSensFadType modelVar_wdepnulrinvbot_d=mod.wdepnulrinvbot_d;
  AdmsSensFadType modelVar_wdepnulrinvsti_d=mod.wdepnulrinvsti_d;
  AdmsSensFadType modelVar_wdepnulrinvgat_d=mod.wdepnulrinvgat_d;
  AdmsSensFadType modelVar_VBIRBOTinv_d=mod.VBIRBOTinv_d;
  AdmsSensFadType modelVar_VBIRSTIinv_d=mod.VBIRSTIinv_d;
  AdmsSensFadType modelVar_VBIRGATinv_d=mod.VBIRGATinv_d;
  AdmsSensFadType modelVar_atatbot_d=mod.atatbot_d;
  AdmsSensFadType modelVar_atatsti_d=mod.atatsti_d;
  AdmsSensFadType modelVar_atatgat_d=mod.atatgat_d;
  AdmsSensFadType modelVar_btatpartbot_d=mod.btatpartbot_d;
  AdmsSensFadType modelVar_btatpartsti_d=mod.btatpartsti_d;
  AdmsSensFadType modelVar_btatpartgat_d=mod.btatpartgat_d;
  AdmsSensFadType modelVar_fbbtbot_d=mod.fbbtbot_d;
  AdmsSensFadType modelVar_fbbtsti_d=mod.fbbtsti_d;
  AdmsSensFadType modelVar_fbbtgat_d=mod.fbbtgat_d;
  AdmsSensFadType modelVar_fstopbot_d=mod.fstopbot_d;
  AdmsSensFadType modelVar_fstopsti_d=mod.fstopsti_d;
  AdmsSensFadType modelVar_fstopgat_d=mod.fstopgat_d;
  AdmsSensFadType modelVar_VBRinvbot_d=mod.VBRinvbot_d;
  AdmsSensFadType modelVar_VBRinvsti_d=mod.VBRinvsti_d;
  AdmsSensFadType modelVar_VBRinvgat_d=mod.VBRinvgat_d;
  AdmsSensFadType modelVar_slopebot_d=mod.slopebot_d;
  AdmsSensFadType modelVar_slopesti_d=mod.slopesti_d;
  AdmsSensFadType modelVar_slopegat_d=mod.slopegat_d;


  // non-reals
  int modelVar_CHNL_TYPE=mod.CHNL_TYPE;



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.
  probeVars[in.admsProbeID_V_NOI_GND] = (*solVectorPtr)[in.li_NOI];
  probeVars[in.admsProbeID_V_NOI2_GND] = (*solVectorPtr)[in.li_NOI2];
  probeVars[in.admsProbeID_V_D_BD] = (*solVectorPtr)[in.li_D]- (*solVectorPtr)[in.li_BD];
  probeVars[in.admsProbeID_V_S_BS] = (*solVectorPtr)[in.li_S]- (*solVectorPtr)[in.li_BS];
  probeVars[in.admsProbeID_V_S_BP] = (*solVectorPtr)[in.li_S]- (*solVectorPtr)[in.li_BP];
  probeVars[in.admsProbeID_V_D_S] = (*solVectorPtr)[in.li_D]- (*solVectorPtr)[in.li_S];
  probeVars[in.admsProbeID_V_GP_S] = (*solVectorPtr)[in.li_GP]- (*solVectorPtr)[in.li_S];
  probeVars[in.admsProbeID_V_B_BI] = (*solVectorPtr)[in.li_B]- (*solVectorPtr)[in.li_BI];
  probeVars[in.admsProbeID_V_BP_BI] = (*solVectorPtr)[in.li_BP]- (*solVectorPtr)[in.li_BI];
  probeVars[in.admsProbeID_V_BD_BI] = (*solVectorPtr)[in.li_BD]- (*solVectorPtr)[in.li_BI];
  probeVars[in.admsProbeID_V_BS_BI] = (*solVectorPtr)[in.li_BS]- (*solVectorPtr)[in.li_BI];
  probeVars[in.admsProbeID_V_G_GP] = (*solVectorPtr)[in.li_G]- (*solVectorPtr)[in.li_GP];



  // Need to use processParams-like function to process the
  // initial_model and initial_instance blocks with the LOCAL copies of
  // instance and model vars, and local copies of instance and model
  // params.
  evaluateInitialModel(
     // model parameters
     // reals
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_TYPE,
     modelPar_given_TYPE,
     modelPar_TR,
     modelPar_given_TR,
     modelPar_SWIGATE,
     modelPar_given_SWIGATE,
     modelPar_SWIMPACT,
     modelPar_given_SWIMPACT,
     modelPar_SWGIDL,
     modelPar_given_SWGIDL,
     modelPar_SWJUNCAP,
     modelPar_given_SWJUNCAP,
     modelPar_SWJUNASYM,
     modelPar_given_SWJUNASYM,
     modelPar_QMC,
     modelPar_given_QMC,
     modelPar_LVARO,
     modelPar_given_LVARO,
     modelPar_LVARL,
     modelPar_given_LVARL,
     modelPar_LVARW,
     modelPar_given_LVARW,
     modelPar_LAP,
     modelPar_given_LAP,
     modelPar_WVARO,
     modelPar_given_WVARO,
     modelPar_WVARL,
     modelPar_given_WVARL,
     modelPar_WVARW,
     modelPar_given_WVARW,
     modelPar_WOT,
     modelPar_given_WOT,
     modelPar_DLQ,
     modelPar_given_DLQ,
     modelPar_DWQ,
     modelPar_given_DWQ,
     modelPar_VFBO,
     modelPar_given_VFBO,
     modelPar_VFBL,
     modelPar_given_VFBL,
     modelPar_VFBW,
     modelPar_given_VFBW,
     modelPar_VFBLW,
     modelPar_given_VFBLW,
     modelPar_STVFBO,
     modelPar_given_STVFBO,
     modelPar_STVFBL,
     modelPar_given_STVFBL,
     modelPar_STVFBW,
     modelPar_given_STVFBW,
     modelPar_STVFBLW,
     modelPar_given_STVFBLW,
     modelPar_TOXO,
     modelPar_given_TOXO,
     modelPar_EPSROXO,
     modelPar_given_EPSROXO,
     modelPar_NSUBO,
     modelPar_given_NSUBO,
     modelPar_NSUBW,
     modelPar_given_NSUBW,
     modelPar_WSEG,
     modelPar_given_WSEG,
     modelPar_NPCK,
     modelPar_given_NPCK,
     modelPar_NPCKW,
     modelPar_given_NPCKW,
     modelPar_WSEGP,
     modelPar_given_WSEGP,
     modelPar_LPCK,
     modelPar_given_LPCK,
     modelPar_LPCKW,
     modelPar_given_LPCKW,
     modelPar_FOL1,
     modelPar_given_FOL1,
     modelPar_FOL2,
     modelPar_given_FOL2,
     modelPar_VNSUBO,
     modelPar_given_VNSUBO,
     modelPar_NSLPO,
     modelPar_given_NSLPO,
     modelPar_DNSUBO,
     modelPar_given_DNSUBO,
     modelPar_DPHIBO,
     modelPar_given_DPHIBO,
     modelPar_DPHIBL,
     modelPar_given_DPHIBL,
     modelPar_DPHIBLEXP,
     modelPar_given_DPHIBLEXP,
     modelPar_DPHIBW,
     modelPar_given_DPHIBW,
     modelPar_DPHIBLW,
     modelPar_given_DPHIBLW,
     modelPar_NPO,
     modelPar_given_NPO,
     modelPar_NPL,
     modelPar_given_NPL,
     modelPar_CTO,
     modelPar_given_CTO,
     modelPar_CTL,
     modelPar_given_CTL,
     modelPar_CTLEXP,
     modelPar_given_CTLEXP,
     modelPar_CTW,
     modelPar_given_CTW,
     modelPar_CTLW,
     modelPar_given_CTLW,
     modelPar_TOXOVO,
     modelPar_given_TOXOVO,
     modelPar_TOXOVDO,
     modelPar_given_TOXOVDO,
     modelPar_LOV,
     modelPar_given_LOV,
     modelPar_LOVD,
     modelPar_given_LOVD,
     modelPar_NOVO,
     modelPar_given_NOVO,
     modelPar_NOVDO,
     modelPar_given_NOVDO,
     modelPar_CFL,
     modelPar_given_CFL,
     modelPar_CFLEXP,
     modelPar_given_CFLEXP,
     modelPar_CFW,
     modelPar_given_CFW,
     modelPar_CFBO,
     modelPar_given_CFBO,
     modelPar_UO,
     modelPar_given_UO,
     modelPar_FBET1,
     modelPar_given_FBET1,
     modelPar_FBET1W,
     modelPar_given_FBET1W,
     modelPar_LP1,
     modelPar_given_LP1,
     modelPar_LP1W,
     modelPar_given_LP1W,
     modelPar_FBET2,
     modelPar_given_FBET2,
     modelPar_LP2,
     modelPar_given_LP2,
     modelPar_BETW1,
     modelPar_given_BETW1,
     modelPar_BETW2,
     modelPar_given_BETW2,
     modelPar_WBET,
     modelPar_given_WBET,
     modelPar_STBETO,
     modelPar_given_STBETO,
     modelPar_STBETL,
     modelPar_given_STBETL,
     modelPar_STBETW,
     modelPar_given_STBETW,
     modelPar_STBETLW,
     modelPar_given_STBETLW,
     modelPar_MUEO,
     modelPar_given_MUEO,
     modelPar_MUEW,
     modelPar_given_MUEW,
     modelPar_STMUEO,
     modelPar_given_STMUEO,
     modelPar_THEMUO,
     modelPar_given_THEMUO,
     modelPar_STTHEMUO,
     modelPar_given_STTHEMUO,
     modelPar_CSO,
     modelPar_given_CSO,
     modelPar_CSL,
     modelPar_given_CSL,
     modelPar_CSLEXP,
     modelPar_given_CSLEXP,
     modelPar_CSW,
     modelPar_given_CSW,
     modelPar_CSLW,
     modelPar_given_CSLW,
     modelPar_STCSO,
     modelPar_given_STCSO,
     modelPar_XCORO,
     modelPar_given_XCORO,
     modelPar_XCORL,
     modelPar_given_XCORL,
     modelPar_XCORW,
     modelPar_given_XCORW,
     modelPar_XCORLW,
     modelPar_given_XCORLW,
     modelPar_STXCORO,
     modelPar_given_STXCORO,
     modelPar_FETAO,
     modelPar_given_FETAO,
     modelPar_RSW1,
     modelPar_given_RSW1,
     modelPar_RSW2,
     modelPar_given_RSW2,
     modelPar_STRSO,
     modelPar_given_STRSO,
     modelPar_RSBO,
     modelPar_given_RSBO,
     modelPar_RSGO,
     modelPar_given_RSGO,
     modelPar_THESATO,
     modelPar_given_THESATO,
     modelPar_THESATL,
     modelPar_given_THESATL,
     modelPar_THESATLEXP,
     modelPar_given_THESATLEXP,
     modelPar_THESATW,
     modelPar_given_THESATW,
     modelPar_THESATLW,
     modelPar_given_THESATLW,
     modelPar_STTHESATO,
     modelPar_given_STTHESATO,
     modelPar_STTHESATL,
     modelPar_given_STTHESATL,
     modelPar_STTHESATW,
     modelPar_given_STTHESATW,
     modelPar_STTHESATLW,
     modelPar_given_STTHESATLW,
     modelPar_THESATBO,
     modelPar_given_THESATBO,
     modelPar_THESATGO,
     modelPar_given_THESATGO,
     modelPar_AXO,
     modelPar_given_AXO,
     modelPar_AXL,
     modelPar_given_AXL,
     modelPar_ALPL,
     modelPar_given_ALPL,
     modelPar_ALPLEXP,
     modelPar_given_ALPLEXP,
     modelPar_ALPW,
     modelPar_given_ALPW,
     modelPar_ALP1L1,
     modelPar_given_ALP1L1,
     modelPar_ALP1LEXP,
     modelPar_given_ALP1LEXP,
     modelPar_ALP1L2,
     modelPar_given_ALP1L2,
     modelPar_ALP1W,
     modelPar_given_ALP1W,
     modelPar_ALP2L1,
     modelPar_given_ALP2L1,
     modelPar_ALP2LEXP,
     modelPar_given_ALP2LEXP,
     modelPar_ALP2L2,
     modelPar_given_ALP2L2,
     modelPar_ALP2W,
     modelPar_given_ALP2W,
     modelPar_VPO,
     modelPar_given_VPO,
     modelPar_A1O,
     modelPar_given_A1O,
     modelPar_A1L,
     modelPar_given_A1L,
     modelPar_A1W,
     modelPar_given_A1W,
     modelPar_A2O,
     modelPar_given_A2O,
     modelPar_STA2O,
     modelPar_given_STA2O,
     modelPar_A3O,
     modelPar_given_A3O,
     modelPar_A3L,
     modelPar_given_A3L,
     modelPar_A3W,
     modelPar_given_A3W,
     modelPar_A4O,
     modelPar_given_A4O,
     modelPar_A4L,
     modelPar_given_A4L,
     modelPar_A4W,
     modelPar_given_A4W,
     modelPar_GCOO,
     modelPar_given_GCOO,
     modelPar_IGINVLW,
     modelPar_given_IGINVLW,
     modelPar_IGOVW,
     modelPar_given_IGOVW,
     modelPar_IGOVDW,
     modelPar_given_IGOVDW,
     modelPar_STIGO,
     modelPar_given_STIGO,
     modelPar_GC2O,
     modelPar_given_GC2O,
     modelPar_GC3O,
     modelPar_given_GC3O,
     modelPar_CHIBO,
     modelPar_given_CHIBO,
     modelPar_AGIDLW,
     modelPar_given_AGIDLW,
     modelPar_AGIDLDW,
     modelPar_given_AGIDLDW,
     modelPar_BGIDLO,
     modelPar_given_BGIDLO,
     modelPar_BGIDLDO,
     modelPar_given_BGIDLDO,
     modelPar_STBGIDLO,
     modelPar_given_STBGIDLO,
     modelPar_STBGIDLDO,
     modelPar_given_STBGIDLDO,
     modelPar_CGIDLO,
     modelPar_given_CGIDLO,
     modelPar_CGIDLDO,
     modelPar_given_CGIDLDO,
     modelPar_CGBOVL,
     modelPar_given_CGBOVL,
     modelPar_CFRW,
     modelPar_given_CFRW,
     modelPar_CFRDW,
     modelPar_given_CFRDW,
     modelPar_FNTO,
     modelPar_given_FNTO,
     modelPar_FNTEXCL,
     modelPar_given_FNTEXCL,
     modelPar_NFALW,
     modelPar_given_NFALW,
     modelPar_NFBLW,
     modelPar_given_NFBLW,
     modelPar_NFCLW,
     modelPar_given_NFCLW,
     modelPar_EFO,
     modelPar_given_EFO,
     modelPar_LINTNOI,
     modelPar_given_LINTNOI,
     modelPar_ALPNOI,
     modelPar_given_ALPNOI,
     modelPar_DTA,
     modelPar_given_DTA,
     modelPar_KVTHOWEO,
     modelPar_given_KVTHOWEO,
     modelPar_KVTHOWEL,
     modelPar_given_KVTHOWEL,
     modelPar_KVTHOWEW,
     modelPar_given_KVTHOWEW,
     modelPar_KVTHOWELW,
     modelPar_given_KVTHOWELW,
     modelPar_KUOWEO,
     modelPar_given_KUOWEO,
     modelPar_KUOWEL,
     modelPar_given_KUOWEL,
     modelPar_KUOWEW,
     modelPar_given_KUOWEW,
     modelPar_KUOWELW,
     modelPar_given_KUOWELW,
     modelPar_LMIN,
     modelPar_given_LMIN,
     modelPar_LMAX,
     modelPar_given_LMAX,
     modelPar_WMIN,
     modelPar_given_WMIN,
     modelPar_WMAX,
     modelPar_given_WMAX,
     modelPar_RGO,
     modelPar_given_RGO,
     modelPar_RBULKO,
     modelPar_given_RBULKO,
     modelPar_RWELLO,
     modelPar_given_RWELLO,
     modelPar_RJUNSO,
     modelPar_given_RJUNSO,
     modelPar_RJUNDO,
     modelPar_given_RJUNDO,
     modelPar_RINT,
     modelPar_given_RINT,
     modelPar_RVPOLY,
     modelPar_given_RVPOLY,
     modelPar_RSHG,
     modelPar_given_RSHG,
     modelPar_DLSIL,
     modelPar_given_DLSIL,
     modelPar_SAREF,
     modelPar_given_SAREF,
     modelPar_SBREF,
     modelPar_given_SBREF,
     modelPar_WLOD,
     modelPar_given_WLOD,
     modelPar_KUO,
     modelPar_given_KUO,
     modelPar_KVSAT,
     modelPar_given_KVSAT,
     modelPar_TKUO,
     modelPar_given_TKUO,
     modelPar_LKUO,
     modelPar_given_LKUO,
     modelPar_WKUO,
     modelPar_given_WKUO,
     modelPar_PKUO,
     modelPar_given_PKUO,
     modelPar_LLODKUO,
     modelPar_given_LLODKUO,
     modelPar_WLODKUO,
     modelPar_given_WLODKUO,
     modelPar_KVTHO,
     modelPar_given_KVTHO,
     modelPar_LKVTHO,
     modelPar_given_LKVTHO,
     modelPar_WKVTHO,
     modelPar_given_WKVTHO,
     modelPar_PKVTHO,
     modelPar_given_PKVTHO,
     modelPar_LLODVTH,
     modelPar_given_LLODVTH,
     modelPar_WLODVTH,
     modelPar_given_WLODVTH,
     modelPar_STETAO,
     modelPar_given_STETAO,
     modelPar_LODETAO,
     modelPar_given_LODETAO,
     modelPar_SCREF,
     modelPar_given_SCREF,
     modelPar_WEB,
     modelPar_given_WEB,
     modelPar_WEC,
     modelPar_given_WEC,
     modelPar_IMAX,
     modelPar_given_IMAX,
     modelPar_TRJ,
     modelPar_given_TRJ,
     modelPar_CJORBOT,
     modelPar_given_CJORBOT,
     modelPar_CJORSTI,
     modelPar_given_CJORSTI,
     modelPar_CJORGAT,
     modelPar_given_CJORGAT,
     modelPar_VBIRBOT,
     modelPar_given_VBIRBOT,
     modelPar_VBIRSTI,
     modelPar_given_VBIRSTI,
     modelPar_VBIRGAT,
     modelPar_given_VBIRGAT,
     modelPar_PBOT,
     modelPar_given_PBOT,
     modelPar_PSTI,
     modelPar_given_PSTI,
     modelPar_PGAT,
     modelPar_given_PGAT,
     modelPar_PHIGBOT,
     modelPar_given_PHIGBOT,
     modelPar_PHIGSTI,
     modelPar_given_PHIGSTI,
     modelPar_PHIGGAT,
     modelPar_given_PHIGGAT,
     modelPar_IDSATRBOT,
     modelPar_given_IDSATRBOT,
     modelPar_IDSATRSTI,
     modelPar_given_IDSATRSTI,
     modelPar_IDSATRGAT,
     modelPar_given_IDSATRGAT,
     modelPar_CSRHBOT,
     modelPar_given_CSRHBOT,
     modelPar_CSRHSTI,
     modelPar_given_CSRHSTI,
     modelPar_CSRHGAT,
     modelPar_given_CSRHGAT,
     modelPar_XJUNSTI,
     modelPar_given_XJUNSTI,
     modelPar_XJUNGAT,
     modelPar_given_XJUNGAT,
     modelPar_CTATBOT,
     modelPar_given_CTATBOT,
     modelPar_CTATSTI,
     modelPar_given_CTATSTI,
     modelPar_CTATGAT,
     modelPar_given_CTATGAT,
     modelPar_MEFFTATBOT,
     modelPar_given_MEFFTATBOT,
     modelPar_MEFFTATSTI,
     modelPar_given_MEFFTATSTI,
     modelPar_MEFFTATGAT,
     modelPar_given_MEFFTATGAT,
     modelPar_CBBTBOT,
     modelPar_given_CBBTBOT,
     modelPar_CBBTSTI,
     modelPar_given_CBBTSTI,
     modelPar_CBBTGAT,
     modelPar_given_CBBTGAT,
     modelPar_FBBTRBOT,
     modelPar_given_FBBTRBOT,
     modelPar_FBBTRSTI,
     modelPar_given_FBBTRSTI,
     modelPar_FBBTRGAT,
     modelPar_given_FBBTRGAT,
     modelPar_STFBBTBOT,
     modelPar_given_STFBBTBOT,
     modelPar_STFBBTSTI,
     modelPar_given_STFBBTSTI,
     modelPar_STFBBTGAT,
     modelPar_given_STFBBTGAT,
     modelPar_VBRBOT,
     modelPar_given_VBRBOT,
     modelPar_VBRSTI,
     modelPar_given_VBRSTI,
     modelPar_VBRGAT,
     modelPar_given_VBRGAT,
     modelPar_PBRBOT,
     modelPar_given_PBRBOT,
     modelPar_PBRSTI,
     modelPar_given_PBRSTI,
     modelPar_PBRGAT,
     modelPar_given_PBRGAT,
     modelPar_CJORBOTD,
     modelPar_given_CJORBOTD,
     modelPar_CJORSTID,
     modelPar_given_CJORSTID,
     modelPar_CJORGATD,
     modelPar_given_CJORGATD,
     modelPar_VBIRBOTD,
     modelPar_given_VBIRBOTD,
     modelPar_VBIRSTID,
     modelPar_given_VBIRSTID,
     modelPar_VBIRGATD,
     modelPar_given_VBIRGATD,
     modelPar_PBOTD,
     modelPar_given_PBOTD,
     modelPar_PSTID,
     modelPar_given_PSTID,
     modelPar_PGATD,
     modelPar_given_PGATD,
     modelPar_PHIGBOTD,
     modelPar_given_PHIGBOTD,
     modelPar_PHIGSTID,
     modelPar_given_PHIGSTID,
     modelPar_PHIGGATD,
     modelPar_given_PHIGGATD,
     modelPar_IDSATRBOTD,
     modelPar_given_IDSATRBOTD,
     modelPar_IDSATRSTID,
     modelPar_given_IDSATRSTID,
     modelPar_IDSATRGATD,
     modelPar_given_IDSATRGATD,
     modelPar_CSRHBOTD,
     modelPar_given_CSRHBOTD,
     modelPar_CSRHSTID,
     modelPar_given_CSRHSTID,
     modelPar_CSRHGATD,
     modelPar_given_CSRHGATD,
     modelPar_XJUNSTID,
     modelPar_given_XJUNSTID,
     modelPar_XJUNGATD,
     modelPar_given_XJUNGATD,
     modelPar_CTATBOTD,
     modelPar_given_CTATBOTD,
     modelPar_CTATSTID,
     modelPar_given_CTATSTID,
     modelPar_CTATGATD,
     modelPar_given_CTATGATD,
     modelPar_MEFFTATBOTD,
     modelPar_given_MEFFTATBOTD,
     modelPar_MEFFTATSTID,
     modelPar_given_MEFFTATSTID,
     modelPar_MEFFTATGATD,
     modelPar_given_MEFFTATGATD,
     modelPar_CBBTBOTD,
     modelPar_given_CBBTBOTD,
     modelPar_CBBTSTID,
     modelPar_given_CBBTSTID,
     modelPar_CBBTGATD,
     modelPar_given_CBBTGATD,
     modelPar_FBBTRBOTD,
     modelPar_given_FBBTRBOTD,
     modelPar_FBBTRSTID,
     modelPar_given_FBBTRSTID,
     modelPar_FBBTRGATD,
     modelPar_given_FBBTRGATD,
     modelPar_STFBBTBOTD,
     modelPar_given_STFBBTBOTD,
     modelPar_STFBBTSTID,
     modelPar_given_STFBBTSTID,
     modelPar_STFBBTGATD,
     modelPar_given_STFBBTGATD,
     modelPar_VBRBOTD,
     modelPar_given_VBRBOTD,
     modelPar_VBRSTID,
     modelPar_given_VBRSTID,
     modelPar_VBRGATD,
     modelPar_given_VBRGATD,
     modelPar_PBRBOTD,
     modelPar_given_PBRBOTD,
     modelPar_PBRSTID,
     modelPar_given_PBRSTID,
     modelPar_PBRGATD,
     modelPar_given_PBRGATD,
     modelPar_SWJUNEXP,
     modelPar_given_SWJUNEXP,
     modelPar_VJUNREF,
     modelPar_given_VJUNREF,
     modelPar_FJUNQ,
     modelPar_given_FJUNQ,
     modelPar_VJUNREFD,
     modelPar_given_VJUNREFD,
     modelPar_FJUNQD,
     modelPar_given_FJUNQD// model variables
     ,
     // reals
     modelVar_NSUBO_i,
     modelVar_WSEG_i,
     modelVar_NPCK_i,
     modelVar_WSEGP_i,
     modelVar_LPCK_i,
     modelVar_LOV_i,
     modelVar_LOVD_i,
     modelVar_LP1_i,
     modelVar_LP2_i,
     modelVar_WBET_i,
     modelVar_AXL_i,
     modelVar_ALP1L2_i,
     modelVar_ALP2L2_i,
     modelVar_RINT_i,
     modelVar_RVPOLY_i,
     modelVar_SAREF_i,
     modelVar_SBREF_i,
     modelVar_KVSAT_i,
     modelVar_LLODKUO_i,
     modelVar_WLODKUO_i,
     modelVar_LLODVTH_i,
     modelVar_WLODVTH_i,
     modelVar_LODETAO_i,
     modelVar_SCREF_i,
     modelVar_WEB_i,
     modelVar_WEC_i,
     modelVar_TOX_i,
     modelVar_EPSROX_i,
     modelVar_TOXOV_i,
     modelVar_TOXOVD_i,
     modelVar_TKD,
     modelVar_dT,
     modelVar_rT,
     modelVar_rTn,
     modelVar_EPSSI,
     modelVar_phit,
     modelVar_inv_phit,
     modelVar_Eg,
     modelVar_phibFac,
     modelVar_nt0,
     modelVar_IMAX_i,
     modelVar_VBIRBOT_i,
     modelVar_VBIRSTI_i,
     modelVar_VBIRGAT_i,
     modelVar_PBOT_i,
     modelVar_PSTI_i,
     modelVar_PGAT_i,
     modelVar_CSRHBOT_i,
     modelVar_CSRHSTI_i,
     modelVar_CSRHGAT_i,
     modelVar_CTATBOT_i,
     modelVar_CTATSTI_i,
     modelVar_CTATGAT_i,
     modelVar_CBBTBOT_i,
     modelVar_CBBTSTI_i,
     modelVar_CBBTGAT_i,
     modelVar_VBRBOT_i,
     modelVar_VBRSTI_i,
     modelVar_VBRGAT_i,
     modelVar_PBRBOT_i,
     modelVar_PBRSTI_i,
     modelVar_PBRGAT_i,
     modelVar_SWJUNEXP_i,
     modelVar_VJUNREF_i,
     modelVar_FJUNQ_i,
     modelVar_phitr,
     modelVar_phitd,
     modelVar_phitdinv,
     modelVar_perfc,
     modelVar_berfc,
     modelVar_cerfc,
     modelVar_ftdbot,
     modelVar_ftdsti,
     modelVar_ftdgat,
     modelVar_idsatbot,
     modelVar_idsatsti,
     modelVar_idsatgat,
     modelVar_vbibot,
     modelVar_vbisti,
     modelVar_vbigat,
     modelVar_vbiinvbot,
     modelVar_vbiinvsti,
     modelVar_vbiinvgat,
     modelVar_one_minus_PBOT,
     modelVar_one_minus_PSTI,
     modelVar_one_minus_PGAT,
     modelVar_one_over_one_minus_PBOT,
     modelVar_one_over_one_minus_PSTI,
     modelVar_one_over_one_minus_PGAT,
     modelVar_cjobot,
     modelVar_cjosti,
     modelVar_cjogat,
     modelVar_qprefbot,
     modelVar_qprefsti,
     modelVar_qprefgat,
     modelVar_qpref2bot,
     modelVar_qpref2sti,
     modelVar_qpref2gat,
     modelVar_wdepnulrbot,
     modelVar_wdepnulrsti,
     modelVar_wdepnulrgat,
     modelVar_wdepnulrinvbot,
     modelVar_wdepnulrinvsti,
     modelVar_wdepnulrinvgat,
     modelVar_VBIRBOTinv,
     modelVar_VBIRSTIinv,
     modelVar_VBIRGATinv,
     modelVar_atatbot,
     modelVar_atatsti,
     modelVar_atatgat,
     modelVar_btatpartbot,
     modelVar_btatpartsti,
     modelVar_btatpartgat,
     modelVar_fbbtbot,
     modelVar_fbbtsti,
     modelVar_fbbtgat,
     modelVar_fstopbot,
     modelVar_fstopsti,
     modelVar_fstopgat,
     modelVar_VBRinvbot,
     modelVar_VBRinvsti,
     modelVar_VBRinvgat,
     modelVar_slopebot,
     modelVar_slopesti,
     modelVar_slopegat,
     modelVar_VBIRBOTD_i,
     modelVar_VBIRSTID_i,
     modelVar_VBIRGATD_i,
     modelVar_PBOTD_i,
     modelVar_PSTID_i,
     modelVar_PGATD_i,
     modelVar_CSRHBOTD_i,
     modelVar_CSRHSTID_i,
     modelVar_CSRHGATD_i,
     modelVar_CTATBOTD_i,
     modelVar_CTATSTID_i,
     modelVar_CTATGATD_i,
     modelVar_CBBTBOTD_i,
     modelVar_CBBTSTID_i,
     modelVar_CBBTGATD_i,
     modelVar_VBRBOTD_i,
     modelVar_VBRSTID_i,
     modelVar_VBRGATD_i,
     modelVar_PBRBOTD_i,
     modelVar_PBRSTID_i,
     modelVar_PBRGATD_i,
     modelVar_VJUNREFD_i,
     modelVar_FJUNQD_i,
     modelVar_ftdbot_d,
     modelVar_ftdsti_d,
     modelVar_ftdgat_d,
     modelVar_idsatbot_d,
     modelVar_idsatsti_d,
     modelVar_idsatgat_d,
     modelVar_vbibot_d,
     modelVar_vbisti_d,
     modelVar_vbigat_d,
     modelVar_vbiinvbot_d,
     modelVar_vbiinvsti_d,
     modelVar_vbiinvgat_d,
     modelVar_one_minus_PBOT_d,
     modelVar_one_minus_PSTI_d,
     modelVar_one_minus_PGAT_d,
     modelVar_one_over_one_minus_PBOT_d,
     modelVar_one_over_one_minus_PSTI_d,
     modelVar_one_over_one_minus_PGAT_d,
     modelVar_cjobot_d,
     modelVar_cjosti_d,
     modelVar_cjogat_d,
     modelVar_qprefbot_d,
     modelVar_qprefsti_d,
     modelVar_qprefgat_d,
     modelVar_qpref2bot_d,
     modelVar_qpref2sti_d,
     modelVar_qpref2gat_d,
     modelVar_wdepnulrbot_d,
     modelVar_wdepnulrsti_d,
     modelVar_wdepnulrgat_d,
     modelVar_wdepnulrinvbot_d,
     modelVar_wdepnulrinvsti_d,
     modelVar_wdepnulrinvgat_d,
     modelVar_VBIRBOTinv_d,
     modelVar_VBIRSTIinv_d,
     modelVar_VBIRGATinv_d,
     modelVar_atatbot_d,
     modelVar_atatsti_d,
     modelVar_atatgat_d,
     modelVar_btatpartbot_d,
     modelVar_btatpartsti_d,
     modelVar_btatpartgat_d,
     modelVar_fbbtbot_d,
     modelVar_fbbtsti_d,
     modelVar_fbbtgat_d,
     modelVar_fstopbot_d,
     modelVar_fstopsti_d,
     modelVar_fstopgat_d,
     modelVar_VBRinvbot_d,
     modelVar_VBRinvsti_d,
     modelVar_VBRinvgat_d,
     modelVar_slopebot_d,
     modelVar_slopesti_d,
     modelVar_slopegat_d,
     // non-reals
     modelVar_CHNL_TYPE,
     mod.admsModTemp,in.getDeviceOptions().gmin,in);
  evaluateInitialInstance(
     // instance parameters
     // reals
     instancePar_L,
     instancePar_given_L,
     instancePar_W,
     instancePar_given_W,
     instancePar_SA,
     instancePar_given_SA,
     instancePar_SB,
     instancePar_given_SB,
     instancePar_SD,
     instancePar_given_SD,
     instancePar_SCA,
     instancePar_given_SCA,
     instancePar_SCB,
     instancePar_given_SCB,
     instancePar_SCC,
     instancePar_given_SCC,
     instancePar_SC,
     instancePar_given_SC,
     instancePar_DELVTO,
     instancePar_given_DELVTO,
     instancePar_FACTUO,
     instancePar_given_FACTUO,
     instancePar_ABSOURCE,
     instancePar_given_ABSOURCE,
     instancePar_LSSOURCE,
     instancePar_given_LSSOURCE,
     instancePar_LGSOURCE,
     instancePar_given_LGSOURCE,
     instancePar_ABDRAIN,
     instancePar_given_ABDRAIN,
     instancePar_LSDRAIN,
     instancePar_given_LSDRAIN,
     instancePar_LGDRAIN,
     instancePar_given_LGDRAIN,
     instancePar_AS,
     instancePar_given_AS,
     instancePar_PS,
     instancePar_given_PS,
     instancePar_AD,
     instancePar_given_AD,
     instancePar_PD,
     instancePar_given_PD,
     instancePar_MULT,
     instancePar_given_MULT,
     instancePar_NF,
     instancePar_given_NF,
     instancePar_NGCON,
     instancePar_given_NGCON,
     instancePar_XGW,
     instancePar_given_XGW,
     // instance variables
     // reals
     instanceVar_VFB_i,
     instanceVar_VNSUB_i,
     instanceVar_NSLP_i,
     instanceVar_DNSUB_i,
     instanceVar_CF_i,
     instanceVar_CFB_i,
     instanceVar_MUE_i,
     instanceVar_THEMU_i,
     instanceVar_CS_i,
     instanceVar_XCOR_i,
     instanceVar_THER_i,
     instanceVar_RSB_i,
     instanceVar_RSG_i,
     instanceVar_THESAT_i,
     instanceVar_THESATB_i,
     instanceVar_THESATG_i,
     instanceVar_AX_i,
     instanceVar_ALP_i,
     instanceVar_ALP1_i,
     instanceVar_ALP2_i,
     instanceVar_A1_i,
     instanceVar_A2_i,
     instanceVar_A3_i,
     instanceVar_A4_i,
     instanceVar_IGINV_i,
     instanceVar_IGOV_i,
     instanceVar_IGOVD_i,
     instanceVar_GC2_i,
     instanceVar_GC3_i,
     instanceVar_CHIB_i,
     instanceVar_AGIDL_i,
     instanceVar_CGIDL_i,
     instanceVar_AGIDLD_i,
     instanceVar_CGIDLD_i,
     instanceVar_COX_i,
     instanceVar_CGOV_i,
     instanceVar_CGOVD_i,
     instanceVar_CGBOV_i,
     instanceVar_CFR_i,
     instanceVar_CFRD_i,
     instanceVar_NFA_i,
     instanceVar_NFB_i,
     instanceVar_NFC_i,
     instanceVar_EF_i,
     instanceVar_FNTEXC_i,
     instanceVar_MULT_i,
     instanceVar_BET_i,
     instanceVar_kp,
     instanceVar_qq,
     instanceVar_qlim2,
     instanceVar_E_eff0,
     instanceVar_eta_mu,
     instanceVar_BCH,
     instanceVar_BOV,
     instanceVar_inv_CHIB,
     instanceVar_GCQ,
     instanceVar_Dch,
     instanceVar_Dov,
     instanceVar_x1,
     instanceVar_Vdsat_lim,
     instanceVar_nt,
     instanceVar_Cox_over_q,
     instanceVar_GOV_s,
     instanceVar_GOV_d,
     instanceVar_GOV2_s,
     instanceVar_GOV2_d,
     instanceVar_BOV_d,
     instanceVar_xi_ov_s,
     instanceVar_xi_ov_d,
     instanceVar_inv_xi_ov_s,
     instanceVar_inv_xi_ov_d,
     instanceVar_x_mrg_ov_s,
     instanceVar_x_mrg_ov_d,
     instanceVar_inv_xg1_s,
     instanceVar_inv_xg1_d,
     instanceVar_AGIDLs,
     instanceVar_AGIDLDs,
     instanceVar_BGIDLs,
     instanceVar_BGIDLDs,
     instanceVar_phib,
     instanceVar_sqrt_phib,
     instanceVar_phix,
     instanceVar_aphi,
     instanceVar_bphi,
     instanceVar_phix1,
     instanceVar_G_0,
     instanceVar_phit1,
     instanceVar_inv_phit1,
     instanceVar_alpha_b,
     instanceVar_inv_VP,
     instanceVar_inv_AX,
     instanceVar_Sfl_prefac,
     instanceVar_fac_exc,
     instanceVar_RG_i,
     instanceVar_RBULK_i,
     instanceVar_RWELL_i,
     instanceVar_RJUNS_i,
     instanceVar_RJUND_i,
     instanceVar_ggate,
     instanceVar_gbulk,
     instanceVar_gwell,
     instanceVar_gjund,
     instanceVar_gjuns,
     instanceVar_ABSOURCE_i,
     instanceVar_LSSOURCE_i,
     instanceVar_LGSOURCE_i,
     instanceVar_zflagbot_s,
     instanceVar_zflagsti_s,
     instanceVar_zflaggat_s,
     instanceVar_VMAX_s,
     instanceVar_exp_VMAX_over_phitd_s,
     instanceVar_vbimin_s,
     instanceVar_vch_s,
     instanceVar_vfmin_s,
     instanceVar_vbbtlim_s,
     instanceVar_xhighf1_s,
     instanceVar_expxhf1_s,
     instanceVar_xhighf2_s,
     instanceVar_expxhf2_s,
     instanceVar_xhighr_s,
     instanceVar_expxhr_s,
     instanceVar_m0flag_s,
     instanceVar_ISATFOR1_s,
     instanceVar_MFOR1_s,
     instanceVar_ISATFOR2_s,
     instanceVar_MFOR2_s,
     instanceVar_ISATREV_s,
     instanceVar_MREV_s,
     instanceVar_ABDRAIN_i,
     instanceVar_LSDRAIN_i,
     instanceVar_LGDRAIN_i,
     instanceVar_zflagbot_d,
     instanceVar_zflagsti_d,
     instanceVar_zflaggat_d,
     instanceVar_VMAX_d,
     instanceVar_exp_VMAX_over_phitd_d,
     instanceVar_vbimin_d,
     instanceVar_vch_d,
     instanceVar_vfmin_d,
     instanceVar_vbbtlim_d,
     instanceVar_xhighf1_d,
     instanceVar_expxhf1_d,
     instanceVar_xhighf2_d,
     instanceVar_expxhf2_d,
     instanceVar_xhighr_d,
     instanceVar_expxhr_d,
     instanceVar_m0flag_d,
     instanceVar_ISATFOR1_d,
     instanceVar_MFOR1_d,
     instanceVar_ISATFOR2_d,
     instanceVar_MFOR2_d,
     instanceVar_ISATREV_d,
     instanceVar_MREV_d,
     // model parameters
     // reals
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_TYPE,
     modelPar_given_TYPE,
     modelPar_TR,
     modelPar_given_TR,
     modelPar_SWIGATE,
     modelPar_given_SWIGATE,
     modelPar_SWIMPACT,
     modelPar_given_SWIMPACT,
     modelPar_SWGIDL,
     modelPar_given_SWGIDL,
     modelPar_SWJUNCAP,
     modelPar_given_SWJUNCAP,
     modelPar_SWJUNASYM,
     modelPar_given_SWJUNASYM,
     modelPar_QMC,
     modelPar_given_QMC,
     modelPar_LVARO,
     modelPar_given_LVARO,
     modelPar_LVARL,
     modelPar_given_LVARL,
     modelPar_LVARW,
     modelPar_given_LVARW,
     modelPar_LAP,
     modelPar_given_LAP,
     modelPar_WVARO,
     modelPar_given_WVARO,
     modelPar_WVARL,
     modelPar_given_WVARL,
     modelPar_WVARW,
     modelPar_given_WVARW,
     modelPar_WOT,
     modelPar_given_WOT,
     modelPar_DLQ,
     modelPar_given_DLQ,
     modelPar_DWQ,
     modelPar_given_DWQ,
     modelPar_VFBO,
     modelPar_given_VFBO,
     modelPar_VFBL,
     modelPar_given_VFBL,
     modelPar_VFBW,
     modelPar_given_VFBW,
     modelPar_VFBLW,
     modelPar_given_VFBLW,
     modelPar_STVFBO,
     modelPar_given_STVFBO,
     modelPar_STVFBL,
     modelPar_given_STVFBL,
     modelPar_STVFBW,
     modelPar_given_STVFBW,
     modelPar_STVFBLW,
     modelPar_given_STVFBLW,
     modelPar_TOXO,
     modelPar_given_TOXO,
     modelPar_EPSROXO,
     modelPar_given_EPSROXO,
     modelPar_NSUBO,
     modelPar_given_NSUBO,
     modelPar_NSUBW,
     modelPar_given_NSUBW,
     modelPar_WSEG,
     modelPar_given_WSEG,
     modelPar_NPCK,
     modelPar_given_NPCK,
     modelPar_NPCKW,
     modelPar_given_NPCKW,
     modelPar_WSEGP,
     modelPar_given_WSEGP,
     modelPar_LPCK,
     modelPar_given_LPCK,
     modelPar_LPCKW,
     modelPar_given_LPCKW,
     modelPar_FOL1,
     modelPar_given_FOL1,
     modelPar_FOL2,
     modelPar_given_FOL2,
     modelPar_VNSUBO,
     modelPar_given_VNSUBO,
     modelPar_NSLPO,
     modelPar_given_NSLPO,
     modelPar_DNSUBO,
     modelPar_given_DNSUBO,
     modelPar_DPHIBO,
     modelPar_given_DPHIBO,
     modelPar_DPHIBL,
     modelPar_given_DPHIBL,
     modelPar_DPHIBLEXP,
     modelPar_given_DPHIBLEXP,
     modelPar_DPHIBW,
     modelPar_given_DPHIBW,
     modelPar_DPHIBLW,
     modelPar_given_DPHIBLW,
     modelPar_NPO,
     modelPar_given_NPO,
     modelPar_NPL,
     modelPar_given_NPL,
     modelPar_CTO,
     modelPar_given_CTO,
     modelPar_CTL,
     modelPar_given_CTL,
     modelPar_CTLEXP,
     modelPar_given_CTLEXP,
     modelPar_CTW,
     modelPar_given_CTW,
     modelPar_CTLW,
     modelPar_given_CTLW,
     modelPar_TOXOVO,
     modelPar_given_TOXOVO,
     modelPar_TOXOVDO,
     modelPar_given_TOXOVDO,
     modelPar_LOV,
     modelPar_given_LOV,
     modelPar_LOVD,
     modelPar_given_LOVD,
     modelPar_NOVO,
     modelPar_given_NOVO,
     modelPar_NOVDO,
     modelPar_given_NOVDO,
     modelPar_CFL,
     modelPar_given_CFL,
     modelPar_CFLEXP,
     modelPar_given_CFLEXP,
     modelPar_CFW,
     modelPar_given_CFW,
     modelPar_CFBO,
     modelPar_given_CFBO,
     modelPar_UO,
     modelPar_given_UO,
     modelPar_FBET1,
     modelPar_given_FBET1,
     modelPar_FBET1W,
     modelPar_given_FBET1W,
     modelPar_LP1,
     modelPar_given_LP1,
     modelPar_LP1W,
     modelPar_given_LP1W,
     modelPar_FBET2,
     modelPar_given_FBET2,
     modelPar_LP2,
     modelPar_given_LP2,
     modelPar_BETW1,
     modelPar_given_BETW1,
     modelPar_BETW2,
     modelPar_given_BETW2,
     modelPar_WBET,
     modelPar_given_WBET,
     modelPar_STBETO,
     modelPar_given_STBETO,
     modelPar_STBETL,
     modelPar_given_STBETL,
     modelPar_STBETW,
     modelPar_given_STBETW,
     modelPar_STBETLW,
     modelPar_given_STBETLW,
     modelPar_MUEO,
     modelPar_given_MUEO,
     modelPar_MUEW,
     modelPar_given_MUEW,
     modelPar_STMUEO,
     modelPar_given_STMUEO,
     modelPar_THEMUO,
     modelPar_given_THEMUO,
     modelPar_STTHEMUO,
     modelPar_given_STTHEMUO,
     modelPar_CSO,
     modelPar_given_CSO,
     modelPar_CSL,
     modelPar_given_CSL,
     modelPar_CSLEXP,
     modelPar_given_CSLEXP,
     modelPar_CSW,
     modelPar_given_CSW,
     modelPar_CSLW,
     modelPar_given_CSLW,
     modelPar_STCSO,
     modelPar_given_STCSO,
     modelPar_XCORO,
     modelPar_given_XCORO,
     modelPar_XCORL,
     modelPar_given_XCORL,
     modelPar_XCORW,
     modelPar_given_XCORW,
     modelPar_XCORLW,
     modelPar_given_XCORLW,
     modelPar_STXCORO,
     modelPar_given_STXCORO,
     modelPar_FETAO,
     modelPar_given_FETAO,
     modelPar_RSW1,
     modelPar_given_RSW1,
     modelPar_RSW2,
     modelPar_given_RSW2,
     modelPar_STRSO,
     modelPar_given_STRSO,
     modelPar_RSBO,
     modelPar_given_RSBO,
     modelPar_RSGO,
     modelPar_given_RSGO,
     modelPar_THESATO,
     modelPar_given_THESATO,
     modelPar_THESATL,
     modelPar_given_THESATL,
     modelPar_THESATLEXP,
     modelPar_given_THESATLEXP,
     modelPar_THESATW,
     modelPar_given_THESATW,
     modelPar_THESATLW,
     modelPar_given_THESATLW,
     modelPar_STTHESATO,
     modelPar_given_STTHESATO,
     modelPar_STTHESATL,
     modelPar_given_STTHESATL,
     modelPar_STTHESATW,
     modelPar_given_STTHESATW,
     modelPar_STTHESATLW,
     modelPar_given_STTHESATLW,
     modelPar_THESATBO,
     modelPar_given_THESATBO,
     modelPar_THESATGO,
     modelPar_given_THESATGO,
     modelPar_AXO,
     modelPar_given_AXO,
     modelPar_AXL,
     modelPar_given_AXL,
     modelPar_ALPL,
     modelPar_given_ALPL,
     modelPar_ALPLEXP,
     modelPar_given_ALPLEXP,
     modelPar_ALPW,
     modelPar_given_ALPW,
     modelPar_ALP1L1,
     modelPar_given_ALP1L1,
     modelPar_ALP1LEXP,
     modelPar_given_ALP1LEXP,
     modelPar_ALP1L2,
     modelPar_given_ALP1L2,
     modelPar_ALP1W,
     modelPar_given_ALP1W,
     modelPar_ALP2L1,
     modelPar_given_ALP2L1,
     modelPar_ALP2LEXP,
     modelPar_given_ALP2LEXP,
     modelPar_ALP2L2,
     modelPar_given_ALP2L2,
     modelPar_ALP2W,
     modelPar_given_ALP2W,
     modelPar_VPO,
     modelPar_given_VPO,
     modelPar_A1O,
     modelPar_given_A1O,
     modelPar_A1L,
     modelPar_given_A1L,
     modelPar_A1W,
     modelPar_given_A1W,
     modelPar_A2O,
     modelPar_given_A2O,
     modelPar_STA2O,
     modelPar_given_STA2O,
     modelPar_A3O,
     modelPar_given_A3O,
     modelPar_A3L,
     modelPar_given_A3L,
     modelPar_A3W,
     modelPar_given_A3W,
     modelPar_A4O,
     modelPar_given_A4O,
     modelPar_A4L,
     modelPar_given_A4L,
     modelPar_A4W,
     modelPar_given_A4W,
     modelPar_GCOO,
     modelPar_given_GCOO,
     modelPar_IGINVLW,
     modelPar_given_IGINVLW,
     modelPar_IGOVW,
     modelPar_given_IGOVW,
     modelPar_IGOVDW,
     modelPar_given_IGOVDW,
     modelPar_STIGO,
     modelPar_given_STIGO,
     modelPar_GC2O,
     modelPar_given_GC2O,
     modelPar_GC3O,
     modelPar_given_GC3O,
     modelPar_CHIBO,
     modelPar_given_CHIBO,
     modelPar_AGIDLW,
     modelPar_given_AGIDLW,
     modelPar_AGIDLDW,
     modelPar_given_AGIDLDW,
     modelPar_BGIDLO,
     modelPar_given_BGIDLO,
     modelPar_BGIDLDO,
     modelPar_given_BGIDLDO,
     modelPar_STBGIDLO,
     modelPar_given_STBGIDLO,
     modelPar_STBGIDLDO,
     modelPar_given_STBGIDLDO,
     modelPar_CGIDLO,
     modelPar_given_CGIDLO,
     modelPar_CGIDLDO,
     modelPar_given_CGIDLDO,
     modelPar_CGBOVL,
     modelPar_given_CGBOVL,
     modelPar_CFRW,
     modelPar_given_CFRW,
     modelPar_CFRDW,
     modelPar_given_CFRDW,
     modelPar_FNTO,
     modelPar_given_FNTO,
     modelPar_FNTEXCL,
     modelPar_given_FNTEXCL,
     modelPar_NFALW,
     modelPar_given_NFALW,
     modelPar_NFBLW,
     modelPar_given_NFBLW,
     modelPar_NFCLW,
     modelPar_given_NFCLW,
     modelPar_EFO,
     modelPar_given_EFO,
     modelPar_LINTNOI,
     modelPar_given_LINTNOI,
     modelPar_ALPNOI,
     modelPar_given_ALPNOI,
     modelPar_DTA,
     modelPar_given_DTA,
     modelPar_KVTHOWEO,
     modelPar_given_KVTHOWEO,
     modelPar_KVTHOWEL,
     modelPar_given_KVTHOWEL,
     modelPar_KVTHOWEW,
     modelPar_given_KVTHOWEW,
     modelPar_KVTHOWELW,
     modelPar_given_KVTHOWELW,
     modelPar_KUOWEO,
     modelPar_given_KUOWEO,
     modelPar_KUOWEL,
     modelPar_given_KUOWEL,
     modelPar_KUOWEW,
     modelPar_given_KUOWEW,
     modelPar_KUOWELW,
     modelPar_given_KUOWELW,
     modelPar_LMIN,
     modelPar_given_LMIN,
     modelPar_LMAX,
     modelPar_given_LMAX,
     modelPar_WMIN,
     modelPar_given_WMIN,
     modelPar_WMAX,
     modelPar_given_WMAX,
     modelPar_RGO,
     modelPar_given_RGO,
     modelPar_RBULKO,
     modelPar_given_RBULKO,
     modelPar_RWELLO,
     modelPar_given_RWELLO,
     modelPar_RJUNSO,
     modelPar_given_RJUNSO,
     modelPar_RJUNDO,
     modelPar_given_RJUNDO,
     modelPar_RINT,
     modelPar_given_RINT,
     modelPar_RVPOLY,
     modelPar_given_RVPOLY,
     modelPar_RSHG,
     modelPar_given_RSHG,
     modelPar_DLSIL,
     modelPar_given_DLSIL,
     modelPar_SAREF,
     modelPar_given_SAREF,
     modelPar_SBREF,
     modelPar_given_SBREF,
     modelPar_WLOD,
     modelPar_given_WLOD,
     modelPar_KUO,
     modelPar_given_KUO,
     modelPar_KVSAT,
     modelPar_given_KVSAT,
     modelPar_TKUO,
     modelPar_given_TKUO,
     modelPar_LKUO,
     modelPar_given_LKUO,
     modelPar_WKUO,
     modelPar_given_WKUO,
     modelPar_PKUO,
     modelPar_given_PKUO,
     modelPar_LLODKUO,
     modelPar_given_LLODKUO,
     modelPar_WLODKUO,
     modelPar_given_WLODKUO,
     modelPar_KVTHO,
     modelPar_given_KVTHO,
     modelPar_LKVTHO,
     modelPar_given_LKVTHO,
     modelPar_WKVTHO,
     modelPar_given_WKVTHO,
     modelPar_PKVTHO,
     modelPar_given_PKVTHO,
     modelPar_LLODVTH,
     modelPar_given_LLODVTH,
     modelPar_WLODVTH,
     modelPar_given_WLODVTH,
     modelPar_STETAO,
     modelPar_given_STETAO,
     modelPar_LODETAO,
     modelPar_given_LODETAO,
     modelPar_SCREF,
     modelPar_given_SCREF,
     modelPar_WEB,
     modelPar_given_WEB,
     modelPar_WEC,
     modelPar_given_WEC,
     modelPar_IMAX,
     modelPar_given_IMAX,
     modelPar_TRJ,
     modelPar_given_TRJ,
     modelPar_CJORBOT,
     modelPar_given_CJORBOT,
     modelPar_CJORSTI,
     modelPar_given_CJORSTI,
     modelPar_CJORGAT,
     modelPar_given_CJORGAT,
     modelPar_VBIRBOT,
     modelPar_given_VBIRBOT,
     modelPar_VBIRSTI,
     modelPar_given_VBIRSTI,
     modelPar_VBIRGAT,
     modelPar_given_VBIRGAT,
     modelPar_PBOT,
     modelPar_given_PBOT,
     modelPar_PSTI,
     modelPar_given_PSTI,
     modelPar_PGAT,
     modelPar_given_PGAT,
     modelPar_PHIGBOT,
     modelPar_given_PHIGBOT,
     modelPar_PHIGSTI,
     modelPar_given_PHIGSTI,
     modelPar_PHIGGAT,
     modelPar_given_PHIGGAT,
     modelPar_IDSATRBOT,
     modelPar_given_IDSATRBOT,
     modelPar_IDSATRSTI,
     modelPar_given_IDSATRSTI,
     modelPar_IDSATRGAT,
     modelPar_given_IDSATRGAT,
     modelPar_CSRHBOT,
     modelPar_given_CSRHBOT,
     modelPar_CSRHSTI,
     modelPar_given_CSRHSTI,
     modelPar_CSRHGAT,
     modelPar_given_CSRHGAT,
     modelPar_XJUNSTI,
     modelPar_given_XJUNSTI,
     modelPar_XJUNGAT,
     modelPar_given_XJUNGAT,
     modelPar_CTATBOT,
     modelPar_given_CTATBOT,
     modelPar_CTATSTI,
     modelPar_given_CTATSTI,
     modelPar_CTATGAT,
     modelPar_given_CTATGAT,
     modelPar_MEFFTATBOT,
     modelPar_given_MEFFTATBOT,
     modelPar_MEFFTATSTI,
     modelPar_given_MEFFTATSTI,
     modelPar_MEFFTATGAT,
     modelPar_given_MEFFTATGAT,
     modelPar_CBBTBOT,
     modelPar_given_CBBTBOT,
     modelPar_CBBTSTI,
     modelPar_given_CBBTSTI,
     modelPar_CBBTGAT,
     modelPar_given_CBBTGAT,
     modelPar_FBBTRBOT,
     modelPar_given_FBBTRBOT,
     modelPar_FBBTRSTI,
     modelPar_given_FBBTRSTI,
     modelPar_FBBTRGAT,
     modelPar_given_FBBTRGAT,
     modelPar_STFBBTBOT,
     modelPar_given_STFBBTBOT,
     modelPar_STFBBTSTI,
     modelPar_given_STFBBTSTI,
     modelPar_STFBBTGAT,
     modelPar_given_STFBBTGAT,
     modelPar_VBRBOT,
     modelPar_given_VBRBOT,
     modelPar_VBRSTI,
     modelPar_given_VBRSTI,
     modelPar_VBRGAT,
     modelPar_given_VBRGAT,
     modelPar_PBRBOT,
     modelPar_given_PBRBOT,
     modelPar_PBRSTI,
     modelPar_given_PBRSTI,
     modelPar_PBRGAT,
     modelPar_given_PBRGAT,
     modelPar_CJORBOTD,
     modelPar_given_CJORBOTD,
     modelPar_CJORSTID,
     modelPar_given_CJORSTID,
     modelPar_CJORGATD,
     modelPar_given_CJORGATD,
     modelPar_VBIRBOTD,
     modelPar_given_VBIRBOTD,
     modelPar_VBIRSTID,
     modelPar_given_VBIRSTID,
     modelPar_VBIRGATD,
     modelPar_given_VBIRGATD,
     modelPar_PBOTD,
     modelPar_given_PBOTD,
     modelPar_PSTID,
     modelPar_given_PSTID,
     modelPar_PGATD,
     modelPar_given_PGATD,
     modelPar_PHIGBOTD,
     modelPar_given_PHIGBOTD,
     modelPar_PHIGSTID,
     modelPar_given_PHIGSTID,
     modelPar_PHIGGATD,
     modelPar_given_PHIGGATD,
     modelPar_IDSATRBOTD,
     modelPar_given_IDSATRBOTD,
     modelPar_IDSATRSTID,
     modelPar_given_IDSATRSTID,
     modelPar_IDSATRGATD,
     modelPar_given_IDSATRGATD,
     modelPar_CSRHBOTD,
     modelPar_given_CSRHBOTD,
     modelPar_CSRHSTID,
     modelPar_given_CSRHSTID,
     modelPar_CSRHGATD,
     modelPar_given_CSRHGATD,
     modelPar_XJUNSTID,
     modelPar_given_XJUNSTID,
     modelPar_XJUNGATD,
     modelPar_given_XJUNGATD,
     modelPar_CTATBOTD,
     modelPar_given_CTATBOTD,
     modelPar_CTATSTID,
     modelPar_given_CTATSTID,
     modelPar_CTATGATD,
     modelPar_given_CTATGATD,
     modelPar_MEFFTATBOTD,
     modelPar_given_MEFFTATBOTD,
     modelPar_MEFFTATSTID,
     modelPar_given_MEFFTATSTID,
     modelPar_MEFFTATGATD,
     modelPar_given_MEFFTATGATD,
     modelPar_CBBTBOTD,
     modelPar_given_CBBTBOTD,
     modelPar_CBBTSTID,
     modelPar_given_CBBTSTID,
     modelPar_CBBTGATD,
     modelPar_given_CBBTGATD,
     modelPar_FBBTRBOTD,
     modelPar_given_FBBTRBOTD,
     modelPar_FBBTRSTID,
     modelPar_given_FBBTRSTID,
     modelPar_FBBTRGATD,
     modelPar_given_FBBTRGATD,
     modelPar_STFBBTBOTD,
     modelPar_given_STFBBTBOTD,
     modelPar_STFBBTSTID,
     modelPar_given_STFBBTSTID,
     modelPar_STFBBTGATD,
     modelPar_given_STFBBTGATD,
     modelPar_VBRBOTD,
     modelPar_given_VBRBOTD,
     modelPar_VBRSTID,
     modelPar_given_VBRSTID,
     modelPar_VBRGATD,
     modelPar_given_VBRGATD,
     modelPar_PBRBOTD,
     modelPar_given_PBRBOTD,
     modelPar_PBRSTID,
     modelPar_given_PBRSTID,
     modelPar_PBRGATD,
     modelPar_given_PBRGATD,
     modelPar_SWJUNEXP,
     modelPar_given_SWJUNEXP,
     modelPar_VJUNREF,
     modelPar_given_VJUNREF,
     modelPar_FJUNQ,
     modelPar_given_FJUNQ,
     modelPar_VJUNREFD,
     modelPar_given_VJUNREFD,
     modelPar_FJUNQD,
     modelPar_given_FJUNQD// model variables
     ,
     // reals
     modelVar_NSUBO_i,
     modelVar_WSEG_i,
     modelVar_NPCK_i,
     modelVar_WSEGP_i,
     modelVar_LPCK_i,
     modelVar_LOV_i,
     modelVar_LOVD_i,
     modelVar_LP1_i,
     modelVar_LP2_i,
     modelVar_WBET_i,
     modelVar_AXL_i,
     modelVar_ALP1L2_i,
     modelVar_ALP2L2_i,
     modelVar_RINT_i,
     modelVar_RVPOLY_i,
     modelVar_SAREF_i,
     modelVar_SBREF_i,
     modelVar_KVSAT_i,
     modelVar_LLODKUO_i,
     modelVar_WLODKUO_i,
     modelVar_LLODVTH_i,
     modelVar_WLODVTH_i,
     modelVar_LODETAO_i,
     modelVar_SCREF_i,
     modelVar_WEB_i,
     modelVar_WEC_i,
     modelVar_TOX_i,
     modelVar_EPSROX_i,
     modelVar_TOXOV_i,
     modelVar_TOXOVD_i,
     modelVar_TKD,
     modelVar_dT,
     modelVar_rT,
     modelVar_rTn,
     modelVar_EPSSI,
     modelVar_phit,
     modelVar_inv_phit,
     modelVar_Eg,
     modelVar_phibFac,
     modelVar_nt0,
     modelVar_IMAX_i,
     modelVar_VBIRBOT_i,
     modelVar_VBIRSTI_i,
     modelVar_VBIRGAT_i,
     modelVar_PBOT_i,
     modelVar_PSTI_i,
     modelVar_PGAT_i,
     modelVar_CSRHBOT_i,
     modelVar_CSRHSTI_i,
     modelVar_CSRHGAT_i,
     modelVar_CTATBOT_i,
     modelVar_CTATSTI_i,
     modelVar_CTATGAT_i,
     modelVar_CBBTBOT_i,
     modelVar_CBBTSTI_i,
     modelVar_CBBTGAT_i,
     modelVar_VBRBOT_i,
     modelVar_VBRSTI_i,
     modelVar_VBRGAT_i,
     modelVar_PBRBOT_i,
     modelVar_PBRSTI_i,
     modelVar_PBRGAT_i,
     modelVar_SWJUNEXP_i,
     modelVar_VJUNREF_i,
     modelVar_FJUNQ_i,
     modelVar_phitr,
     modelVar_phitd,
     modelVar_phitdinv,
     modelVar_perfc,
     modelVar_berfc,
     modelVar_cerfc,
     modelVar_ftdbot,
     modelVar_ftdsti,
     modelVar_ftdgat,
     modelVar_idsatbot,
     modelVar_idsatsti,
     modelVar_idsatgat,
     modelVar_vbibot,
     modelVar_vbisti,
     modelVar_vbigat,
     modelVar_vbiinvbot,
     modelVar_vbiinvsti,
     modelVar_vbiinvgat,
     modelVar_one_minus_PBOT,
     modelVar_one_minus_PSTI,
     modelVar_one_minus_PGAT,
     modelVar_one_over_one_minus_PBOT,
     modelVar_one_over_one_minus_PSTI,
     modelVar_one_over_one_minus_PGAT,
     modelVar_cjobot,
     modelVar_cjosti,
     modelVar_cjogat,
     modelVar_qprefbot,
     modelVar_qprefsti,
     modelVar_qprefgat,
     modelVar_qpref2bot,
     modelVar_qpref2sti,
     modelVar_qpref2gat,
     modelVar_wdepnulrbot,
     modelVar_wdepnulrsti,
     modelVar_wdepnulrgat,
     modelVar_wdepnulrinvbot,
     modelVar_wdepnulrinvsti,
     modelVar_wdepnulrinvgat,
     modelVar_VBIRBOTinv,
     modelVar_VBIRSTIinv,
     modelVar_VBIRGATinv,
     modelVar_atatbot,
     modelVar_atatsti,
     modelVar_atatgat,
     modelVar_btatpartbot,
     modelVar_btatpartsti,
     modelVar_btatpartgat,
     modelVar_fbbtbot,
     modelVar_fbbtsti,
     modelVar_fbbtgat,
     modelVar_fstopbot,
     modelVar_fstopsti,
     modelVar_fstopgat,
     modelVar_VBRinvbot,
     modelVar_VBRinvsti,
     modelVar_VBRinvgat,
     modelVar_slopebot,
     modelVar_slopesti,
     modelVar_slopegat,
     modelVar_VBIRBOTD_i,
     modelVar_VBIRSTID_i,
     modelVar_VBIRGATD_i,
     modelVar_PBOTD_i,
     modelVar_PSTID_i,
     modelVar_PGATD_i,
     modelVar_CSRHBOTD_i,
     modelVar_CSRHSTID_i,
     modelVar_CSRHGATD_i,
     modelVar_CTATBOTD_i,
     modelVar_CTATSTID_i,
     modelVar_CTATGATD_i,
     modelVar_CBBTBOTD_i,
     modelVar_CBBTSTID_i,
     modelVar_CBBTGATD_i,
     modelVar_VBRBOTD_i,
     modelVar_VBRSTID_i,
     modelVar_VBRGATD_i,
     modelVar_PBRBOTD_i,
     modelVar_PBRSTID_i,
     modelVar_PBRGATD_i,
     modelVar_VJUNREFD_i,
     modelVar_FJUNQD_i,
     modelVar_ftdbot_d,
     modelVar_ftdsti_d,
     modelVar_ftdgat_d,
     modelVar_idsatbot_d,
     modelVar_idsatsti_d,
     modelVar_idsatgat_d,
     modelVar_vbibot_d,
     modelVar_vbisti_d,
     modelVar_vbigat_d,
     modelVar_vbiinvbot_d,
     modelVar_vbiinvsti_d,
     modelVar_vbiinvgat_d,
     modelVar_one_minus_PBOT_d,
     modelVar_one_minus_PSTI_d,
     modelVar_one_minus_PGAT_d,
     modelVar_one_over_one_minus_PBOT_d,
     modelVar_one_over_one_minus_PSTI_d,
     modelVar_one_over_one_minus_PGAT_d,
     modelVar_cjobot_d,
     modelVar_cjosti_d,
     modelVar_cjogat_d,
     modelVar_qprefbot_d,
     modelVar_qprefsti_d,
     modelVar_qprefgat_d,
     modelVar_qpref2bot_d,
     modelVar_qpref2sti_d,
     modelVar_qpref2gat_d,
     modelVar_wdepnulrbot_d,
     modelVar_wdepnulrsti_d,
     modelVar_wdepnulrgat_d,
     modelVar_wdepnulrinvbot_d,
     modelVar_wdepnulrinvsti_d,
     modelVar_wdepnulrinvgat_d,
     modelVar_VBIRBOTinv_d,
     modelVar_VBIRSTIinv_d,
     modelVar_VBIRGATinv_d,
     modelVar_atatbot_d,
     modelVar_atatsti_d,
     modelVar_atatgat_d,
     modelVar_btatpartbot_d,
     modelVar_btatpartsti_d,
     modelVar_btatpartgat_d,
     modelVar_fbbtbot_d,
     modelVar_fbbtsti_d,
     modelVar_fbbtgat_d,
     modelVar_fstopbot_d,
     modelVar_fstopsti_d,
     modelVar_fstopgat_d,
     modelVar_VBRinvbot_d,
     modelVar_VBRinvsti_d,
     modelVar_VBRinvgat_d,
     modelVar_slopebot_d,
     modelVar_slopesti_d,
     modelVar_slopegat_d,
     // non-reals
     modelVar_CHNL_TYPE,
     in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_NOI_GND,
     in.admsProbeID_V_NOI2_GND,
     in.admsProbeID_V_D_BD,
     in.admsProbeID_V_S_BS,
     in.admsProbeID_V_S_BP,
     in.admsProbeID_V_D_S,
     in.admsProbeID_V_GP_S,
     in.admsProbeID_V_B_BI,
     in.admsProbeID_V_BP_BI,
     in.admsProbeID_V_BD_BI,
     in.admsProbeID_V_BS_BI,
     in.admsProbeID_V_G_GP,

     // node constants
     in.admsNodeID_D,
     in.admsNodeID_G,
     in.admsNodeID_S,
     in.admsNodeID_B,
     in.admsNodeID_NOI,
     in.admsNodeID_NOI2,
     in.admsNodeID_GP,
     in.admsNodeID_BP,
     in.admsNodeID_BI,
     in.admsNodeID_BS,
     in.admsNodeID_BD,
     // instance parameters
     // reals
     instancePar_L,
     instancePar_given_L,
     instancePar_W,
     instancePar_given_W,
     instancePar_SA,
     instancePar_given_SA,
     instancePar_SB,
     instancePar_given_SB,
     instancePar_SD,
     instancePar_given_SD,
     instancePar_SCA,
     instancePar_given_SCA,
     instancePar_SCB,
     instancePar_given_SCB,
     instancePar_SCC,
     instancePar_given_SCC,
     instancePar_SC,
     instancePar_given_SC,
     instancePar_DELVTO,
     instancePar_given_DELVTO,
     instancePar_FACTUO,
     instancePar_given_FACTUO,
     instancePar_ABSOURCE,
     instancePar_given_ABSOURCE,
     instancePar_LSSOURCE,
     instancePar_given_LSSOURCE,
     instancePar_LGSOURCE,
     instancePar_given_LGSOURCE,
     instancePar_ABDRAIN,
     instancePar_given_ABDRAIN,
     instancePar_LSDRAIN,
     instancePar_given_LSDRAIN,
     instancePar_LGDRAIN,
     instancePar_given_LGDRAIN,
     instancePar_AS,
     instancePar_given_AS,
     instancePar_PS,
     instancePar_given_PS,
     instancePar_AD,
     instancePar_given_AD,
     instancePar_PD,
     instancePar_given_PD,
     instancePar_MULT,
     instancePar_given_MULT,
     instancePar_NF,
     instancePar_given_NF,
     instancePar_NGCON,
     instancePar_given_NGCON,
     instancePar_XGW,
     instancePar_given_XGW,
     // instance variables
     // reals
     instanceVar_VFB_i,
     instanceVar_VNSUB_i,
     instanceVar_NSLP_i,
     instanceVar_DNSUB_i,
     instanceVar_CF_i,
     instanceVar_CFB_i,
     instanceVar_MUE_i,
     instanceVar_THEMU_i,
     instanceVar_CS_i,
     instanceVar_XCOR_i,
     instanceVar_THER_i,
     instanceVar_RSB_i,
     instanceVar_RSG_i,
     instanceVar_THESAT_i,
     instanceVar_THESATB_i,
     instanceVar_THESATG_i,
     instanceVar_AX_i,
     instanceVar_ALP_i,
     instanceVar_ALP1_i,
     instanceVar_ALP2_i,
     instanceVar_A1_i,
     instanceVar_A2_i,
     instanceVar_A3_i,
     instanceVar_A4_i,
     instanceVar_IGINV_i,
     instanceVar_IGOV_i,
     instanceVar_IGOVD_i,
     instanceVar_GC2_i,
     instanceVar_GC3_i,
     instanceVar_CHIB_i,
     instanceVar_AGIDL_i,
     instanceVar_CGIDL_i,
     instanceVar_AGIDLD_i,
     instanceVar_CGIDLD_i,
     instanceVar_COX_i,
     instanceVar_CGOV_i,
     instanceVar_CGOVD_i,
     instanceVar_CGBOV_i,
     instanceVar_CFR_i,
     instanceVar_CFRD_i,
     instanceVar_NFA_i,
     instanceVar_NFB_i,
     instanceVar_NFC_i,
     instanceVar_EF_i,
     instanceVar_FNTEXC_i,
     instanceVar_MULT_i,
     instanceVar_BET_i,
     instanceVar_kp,
     instanceVar_qq,
     instanceVar_qlim2,
     instanceVar_E_eff0,
     instanceVar_eta_mu,
     instanceVar_BCH,
     instanceVar_BOV,
     instanceVar_inv_CHIB,
     instanceVar_GCQ,
     instanceVar_Dch,
     instanceVar_Dov,
     instanceVar_x1,
     instanceVar_Vdsat_lim,
     instanceVar_nt,
     instanceVar_Cox_over_q,
     instanceVar_GOV_s,
     instanceVar_GOV_d,
     instanceVar_GOV2_s,
     instanceVar_GOV2_d,
     instanceVar_BOV_d,
     instanceVar_xi_ov_s,
     instanceVar_xi_ov_d,
     instanceVar_inv_xi_ov_s,
     instanceVar_inv_xi_ov_d,
     instanceVar_x_mrg_ov_s,
     instanceVar_x_mrg_ov_d,
     instanceVar_inv_xg1_s,
     instanceVar_inv_xg1_d,
     instanceVar_AGIDLs,
     instanceVar_AGIDLDs,
     instanceVar_BGIDLs,
     instanceVar_BGIDLDs,
     instanceVar_phib,
     instanceVar_sqrt_phib,
     instanceVar_phix,
     instanceVar_aphi,
     instanceVar_bphi,
     instanceVar_phix1,
     instanceVar_G_0,
     instanceVar_phit1,
     instanceVar_inv_phit1,
     instanceVar_alpha_b,
     instanceVar_inv_VP,
     instanceVar_inv_AX,
     instanceVar_Sfl_prefac,
     instanceVar_fac_exc,
     instanceVar_RG_i,
     instanceVar_RBULK_i,
     instanceVar_RWELL_i,
     instanceVar_RJUNS_i,
     instanceVar_RJUND_i,
     instanceVar_ggate,
     instanceVar_gbulk,
     instanceVar_gwell,
     instanceVar_gjund,
     instanceVar_gjuns,
     instanceVar_ABSOURCE_i,
     instanceVar_LSSOURCE_i,
     instanceVar_LGSOURCE_i,
     instanceVar_zflagbot_s,
     instanceVar_zflagsti_s,
     instanceVar_zflaggat_s,
     instanceVar_VMAX_s,
     instanceVar_exp_VMAX_over_phitd_s,
     instanceVar_vbimin_s,
     instanceVar_vch_s,
     instanceVar_vfmin_s,
     instanceVar_vbbtlim_s,
     instanceVar_xhighf1_s,
     instanceVar_expxhf1_s,
     instanceVar_xhighf2_s,
     instanceVar_expxhf2_s,
     instanceVar_xhighr_s,
     instanceVar_expxhr_s,
     instanceVar_m0flag_s,
     instanceVar_ISATFOR1_s,
     instanceVar_MFOR1_s,
     instanceVar_ISATFOR2_s,
     instanceVar_MFOR2_s,
     instanceVar_ISATREV_s,
     instanceVar_MREV_s,
     instanceVar_ABDRAIN_i,
     instanceVar_LSDRAIN_i,
     instanceVar_LGDRAIN_i,
     instanceVar_zflagbot_d,
     instanceVar_zflagsti_d,
     instanceVar_zflaggat_d,
     instanceVar_VMAX_d,
     instanceVar_exp_VMAX_over_phitd_d,
     instanceVar_vbimin_d,
     instanceVar_vch_d,
     instanceVar_vfmin_d,
     instanceVar_vbbtlim_d,
     instanceVar_xhighf1_d,
     instanceVar_expxhf1_d,
     instanceVar_xhighf2_d,
     instanceVar_expxhf2_d,
     instanceVar_xhighr_d,
     instanceVar_expxhr_d,
     instanceVar_m0flag_d,
     instanceVar_ISATFOR1_d,
     instanceVar_MFOR1_d,
     instanceVar_ISATFOR2_d,
     instanceVar_MFOR2_d,
     instanceVar_ISATREV_d,
     instanceVar_MREV_d,
     // model parameters
     // reals
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_TYPE,
     modelPar_given_TYPE,
     modelPar_TR,
     modelPar_given_TR,
     modelPar_SWIGATE,
     modelPar_given_SWIGATE,
     modelPar_SWIMPACT,
     modelPar_given_SWIMPACT,
     modelPar_SWGIDL,
     modelPar_given_SWGIDL,
     modelPar_SWJUNCAP,
     modelPar_given_SWJUNCAP,
     modelPar_SWJUNASYM,
     modelPar_given_SWJUNASYM,
     modelPar_QMC,
     modelPar_given_QMC,
     modelPar_LVARO,
     modelPar_given_LVARO,
     modelPar_LVARL,
     modelPar_given_LVARL,
     modelPar_LVARW,
     modelPar_given_LVARW,
     modelPar_LAP,
     modelPar_given_LAP,
     modelPar_WVARO,
     modelPar_given_WVARO,
     modelPar_WVARL,
     modelPar_given_WVARL,
     modelPar_WVARW,
     modelPar_given_WVARW,
     modelPar_WOT,
     modelPar_given_WOT,
     modelPar_DLQ,
     modelPar_given_DLQ,
     modelPar_DWQ,
     modelPar_given_DWQ,
     modelPar_VFBO,
     modelPar_given_VFBO,
     modelPar_VFBL,
     modelPar_given_VFBL,
     modelPar_VFBW,
     modelPar_given_VFBW,
     modelPar_VFBLW,
     modelPar_given_VFBLW,
     modelPar_STVFBO,
     modelPar_given_STVFBO,
     modelPar_STVFBL,
     modelPar_given_STVFBL,
     modelPar_STVFBW,
     modelPar_given_STVFBW,
     modelPar_STVFBLW,
     modelPar_given_STVFBLW,
     modelPar_TOXO,
     modelPar_given_TOXO,
     modelPar_EPSROXO,
     modelPar_given_EPSROXO,
     modelPar_NSUBO,
     modelPar_given_NSUBO,
     modelPar_NSUBW,
     modelPar_given_NSUBW,
     modelPar_WSEG,
     modelPar_given_WSEG,
     modelPar_NPCK,
     modelPar_given_NPCK,
     modelPar_NPCKW,
     modelPar_given_NPCKW,
     modelPar_WSEGP,
     modelPar_given_WSEGP,
     modelPar_LPCK,
     modelPar_given_LPCK,
     modelPar_LPCKW,
     modelPar_given_LPCKW,
     modelPar_FOL1,
     modelPar_given_FOL1,
     modelPar_FOL2,
     modelPar_given_FOL2,
     modelPar_VNSUBO,
     modelPar_given_VNSUBO,
     modelPar_NSLPO,
     modelPar_given_NSLPO,
     modelPar_DNSUBO,
     modelPar_given_DNSUBO,
     modelPar_DPHIBO,
     modelPar_given_DPHIBO,
     modelPar_DPHIBL,
     modelPar_given_DPHIBL,
     modelPar_DPHIBLEXP,
     modelPar_given_DPHIBLEXP,
     modelPar_DPHIBW,
     modelPar_given_DPHIBW,
     modelPar_DPHIBLW,
     modelPar_given_DPHIBLW,
     modelPar_NPO,
     modelPar_given_NPO,
     modelPar_NPL,
     modelPar_given_NPL,
     modelPar_CTO,
     modelPar_given_CTO,
     modelPar_CTL,
     modelPar_given_CTL,
     modelPar_CTLEXP,
     modelPar_given_CTLEXP,
     modelPar_CTW,
     modelPar_given_CTW,
     modelPar_CTLW,
     modelPar_given_CTLW,
     modelPar_TOXOVO,
     modelPar_given_TOXOVO,
     modelPar_TOXOVDO,
     modelPar_given_TOXOVDO,
     modelPar_LOV,
     modelPar_given_LOV,
     modelPar_LOVD,
     modelPar_given_LOVD,
     modelPar_NOVO,
     modelPar_given_NOVO,
     modelPar_NOVDO,
     modelPar_given_NOVDO,
     modelPar_CFL,
     modelPar_given_CFL,
     modelPar_CFLEXP,
     modelPar_given_CFLEXP,
     modelPar_CFW,
     modelPar_given_CFW,
     modelPar_CFBO,
     modelPar_given_CFBO,
     modelPar_UO,
     modelPar_given_UO,
     modelPar_FBET1,
     modelPar_given_FBET1,
     modelPar_FBET1W,
     modelPar_given_FBET1W,
     modelPar_LP1,
     modelPar_given_LP1,
     modelPar_LP1W,
     modelPar_given_LP1W,
     modelPar_FBET2,
     modelPar_given_FBET2,
     modelPar_LP2,
     modelPar_given_LP2,
     modelPar_BETW1,
     modelPar_given_BETW1,
     modelPar_BETW2,
     modelPar_given_BETW2,
     modelPar_WBET,
     modelPar_given_WBET,
     modelPar_STBETO,
     modelPar_given_STBETO,
     modelPar_STBETL,
     modelPar_given_STBETL,
     modelPar_STBETW,
     modelPar_given_STBETW,
     modelPar_STBETLW,
     modelPar_given_STBETLW,
     modelPar_MUEO,
     modelPar_given_MUEO,
     modelPar_MUEW,
     modelPar_given_MUEW,
     modelPar_STMUEO,
     modelPar_given_STMUEO,
     modelPar_THEMUO,
     modelPar_given_THEMUO,
     modelPar_STTHEMUO,
     modelPar_given_STTHEMUO,
     modelPar_CSO,
     modelPar_given_CSO,
     modelPar_CSL,
     modelPar_given_CSL,
     modelPar_CSLEXP,
     modelPar_given_CSLEXP,
     modelPar_CSW,
     modelPar_given_CSW,
     modelPar_CSLW,
     modelPar_given_CSLW,
     modelPar_STCSO,
     modelPar_given_STCSO,
     modelPar_XCORO,
     modelPar_given_XCORO,
     modelPar_XCORL,
     modelPar_given_XCORL,
     modelPar_XCORW,
     modelPar_given_XCORW,
     modelPar_XCORLW,
     modelPar_given_XCORLW,
     modelPar_STXCORO,
     modelPar_given_STXCORO,
     modelPar_FETAO,
     modelPar_given_FETAO,
     modelPar_RSW1,
     modelPar_given_RSW1,
     modelPar_RSW2,
     modelPar_given_RSW2,
     modelPar_STRSO,
     modelPar_given_STRSO,
     modelPar_RSBO,
     modelPar_given_RSBO,
     modelPar_RSGO,
     modelPar_given_RSGO,
     modelPar_THESATO,
     modelPar_given_THESATO,
     modelPar_THESATL,
     modelPar_given_THESATL,
     modelPar_THESATLEXP,
     modelPar_given_THESATLEXP,
     modelPar_THESATW,
     modelPar_given_THESATW,
     modelPar_THESATLW,
     modelPar_given_THESATLW,
     modelPar_STTHESATO,
     modelPar_given_STTHESATO,
     modelPar_STTHESATL,
     modelPar_given_STTHESATL,
     modelPar_STTHESATW,
     modelPar_given_STTHESATW,
     modelPar_STTHESATLW,
     modelPar_given_STTHESATLW,
     modelPar_THESATBO,
     modelPar_given_THESATBO,
     modelPar_THESATGO,
     modelPar_given_THESATGO,
     modelPar_AXO,
     modelPar_given_AXO,
     modelPar_AXL,
     modelPar_given_AXL,
     modelPar_ALPL,
     modelPar_given_ALPL,
     modelPar_ALPLEXP,
     modelPar_given_ALPLEXP,
     modelPar_ALPW,
     modelPar_given_ALPW,
     modelPar_ALP1L1,
     modelPar_given_ALP1L1,
     modelPar_ALP1LEXP,
     modelPar_given_ALP1LEXP,
     modelPar_ALP1L2,
     modelPar_given_ALP1L2,
     modelPar_ALP1W,
     modelPar_given_ALP1W,
     modelPar_ALP2L1,
     modelPar_given_ALP2L1,
     modelPar_ALP2LEXP,
     modelPar_given_ALP2LEXP,
     modelPar_ALP2L2,
     modelPar_given_ALP2L2,
     modelPar_ALP2W,
     modelPar_given_ALP2W,
     modelPar_VPO,
     modelPar_given_VPO,
     modelPar_A1O,
     modelPar_given_A1O,
     modelPar_A1L,
     modelPar_given_A1L,
     modelPar_A1W,
     modelPar_given_A1W,
     modelPar_A2O,
     modelPar_given_A2O,
     modelPar_STA2O,
     modelPar_given_STA2O,
     modelPar_A3O,
     modelPar_given_A3O,
     modelPar_A3L,
     modelPar_given_A3L,
     modelPar_A3W,
     modelPar_given_A3W,
     modelPar_A4O,
     modelPar_given_A4O,
     modelPar_A4L,
     modelPar_given_A4L,
     modelPar_A4W,
     modelPar_given_A4W,
     modelPar_GCOO,
     modelPar_given_GCOO,
     modelPar_IGINVLW,
     modelPar_given_IGINVLW,
     modelPar_IGOVW,
     modelPar_given_IGOVW,
     modelPar_IGOVDW,
     modelPar_given_IGOVDW,
     modelPar_STIGO,
     modelPar_given_STIGO,
     modelPar_GC2O,
     modelPar_given_GC2O,
     modelPar_GC3O,
     modelPar_given_GC3O,
     modelPar_CHIBO,
     modelPar_given_CHIBO,
     modelPar_AGIDLW,
     modelPar_given_AGIDLW,
     modelPar_AGIDLDW,
     modelPar_given_AGIDLDW,
     modelPar_BGIDLO,
     modelPar_given_BGIDLO,
     modelPar_BGIDLDO,
     modelPar_given_BGIDLDO,
     modelPar_STBGIDLO,
     modelPar_given_STBGIDLO,
     modelPar_STBGIDLDO,
     modelPar_given_STBGIDLDO,
     modelPar_CGIDLO,
     modelPar_given_CGIDLO,
     modelPar_CGIDLDO,
     modelPar_given_CGIDLDO,
     modelPar_CGBOVL,
     modelPar_given_CGBOVL,
     modelPar_CFRW,
     modelPar_given_CFRW,
     modelPar_CFRDW,
     modelPar_given_CFRDW,
     modelPar_FNTO,
     modelPar_given_FNTO,
     modelPar_FNTEXCL,
     modelPar_given_FNTEXCL,
     modelPar_NFALW,
     modelPar_given_NFALW,
     modelPar_NFBLW,
     modelPar_given_NFBLW,
     modelPar_NFCLW,
     modelPar_given_NFCLW,
     modelPar_EFO,
     modelPar_given_EFO,
     modelPar_LINTNOI,
     modelPar_given_LINTNOI,
     modelPar_ALPNOI,
     modelPar_given_ALPNOI,
     modelPar_DTA,
     modelPar_given_DTA,
     modelPar_KVTHOWEO,
     modelPar_given_KVTHOWEO,
     modelPar_KVTHOWEL,
     modelPar_given_KVTHOWEL,
     modelPar_KVTHOWEW,
     modelPar_given_KVTHOWEW,
     modelPar_KVTHOWELW,
     modelPar_given_KVTHOWELW,
     modelPar_KUOWEO,
     modelPar_given_KUOWEO,
     modelPar_KUOWEL,
     modelPar_given_KUOWEL,
     modelPar_KUOWEW,
     modelPar_given_KUOWEW,
     modelPar_KUOWELW,
     modelPar_given_KUOWELW,
     modelPar_LMIN,
     modelPar_given_LMIN,
     modelPar_LMAX,
     modelPar_given_LMAX,
     modelPar_WMIN,
     modelPar_given_WMIN,
     modelPar_WMAX,
     modelPar_given_WMAX,
     modelPar_RGO,
     modelPar_given_RGO,
     modelPar_RBULKO,
     modelPar_given_RBULKO,
     modelPar_RWELLO,
     modelPar_given_RWELLO,
     modelPar_RJUNSO,
     modelPar_given_RJUNSO,
     modelPar_RJUNDO,
     modelPar_given_RJUNDO,
     modelPar_RINT,
     modelPar_given_RINT,
     modelPar_RVPOLY,
     modelPar_given_RVPOLY,
     modelPar_RSHG,
     modelPar_given_RSHG,
     modelPar_DLSIL,
     modelPar_given_DLSIL,
     modelPar_SAREF,
     modelPar_given_SAREF,
     modelPar_SBREF,
     modelPar_given_SBREF,
     modelPar_WLOD,
     modelPar_given_WLOD,
     modelPar_KUO,
     modelPar_given_KUO,
     modelPar_KVSAT,
     modelPar_given_KVSAT,
     modelPar_TKUO,
     modelPar_given_TKUO,
     modelPar_LKUO,
     modelPar_given_LKUO,
     modelPar_WKUO,
     modelPar_given_WKUO,
     modelPar_PKUO,
     modelPar_given_PKUO,
     modelPar_LLODKUO,
     modelPar_given_LLODKUO,
     modelPar_WLODKUO,
     modelPar_given_WLODKUO,
     modelPar_KVTHO,
     modelPar_given_KVTHO,
     modelPar_LKVTHO,
     modelPar_given_LKVTHO,
     modelPar_WKVTHO,
     modelPar_given_WKVTHO,
     modelPar_PKVTHO,
     modelPar_given_PKVTHO,
     modelPar_LLODVTH,
     modelPar_given_LLODVTH,
     modelPar_WLODVTH,
     modelPar_given_WLODVTH,
     modelPar_STETAO,
     modelPar_given_STETAO,
     modelPar_LODETAO,
     modelPar_given_LODETAO,
     modelPar_SCREF,
     modelPar_given_SCREF,
     modelPar_WEB,
     modelPar_given_WEB,
     modelPar_WEC,
     modelPar_given_WEC,
     modelPar_IMAX,
     modelPar_given_IMAX,
     modelPar_TRJ,
     modelPar_given_TRJ,
     modelPar_CJORBOT,
     modelPar_given_CJORBOT,
     modelPar_CJORSTI,
     modelPar_given_CJORSTI,
     modelPar_CJORGAT,
     modelPar_given_CJORGAT,
     modelPar_VBIRBOT,
     modelPar_given_VBIRBOT,
     modelPar_VBIRSTI,
     modelPar_given_VBIRSTI,
     modelPar_VBIRGAT,
     modelPar_given_VBIRGAT,
     modelPar_PBOT,
     modelPar_given_PBOT,
     modelPar_PSTI,
     modelPar_given_PSTI,
     modelPar_PGAT,
     modelPar_given_PGAT,
     modelPar_PHIGBOT,
     modelPar_given_PHIGBOT,
     modelPar_PHIGSTI,
     modelPar_given_PHIGSTI,
     modelPar_PHIGGAT,
     modelPar_given_PHIGGAT,
     modelPar_IDSATRBOT,
     modelPar_given_IDSATRBOT,
     modelPar_IDSATRSTI,
     modelPar_given_IDSATRSTI,
     modelPar_IDSATRGAT,
     modelPar_given_IDSATRGAT,
     modelPar_CSRHBOT,
     modelPar_given_CSRHBOT,
     modelPar_CSRHSTI,
     modelPar_given_CSRHSTI,
     modelPar_CSRHGAT,
     modelPar_given_CSRHGAT,
     modelPar_XJUNSTI,
     modelPar_given_XJUNSTI,
     modelPar_XJUNGAT,
     modelPar_given_XJUNGAT,
     modelPar_CTATBOT,
     modelPar_given_CTATBOT,
     modelPar_CTATSTI,
     modelPar_given_CTATSTI,
     modelPar_CTATGAT,
     modelPar_given_CTATGAT,
     modelPar_MEFFTATBOT,
     modelPar_given_MEFFTATBOT,
     modelPar_MEFFTATSTI,
     modelPar_given_MEFFTATSTI,
     modelPar_MEFFTATGAT,
     modelPar_given_MEFFTATGAT,
     modelPar_CBBTBOT,
     modelPar_given_CBBTBOT,
     modelPar_CBBTSTI,
     modelPar_given_CBBTSTI,
     modelPar_CBBTGAT,
     modelPar_given_CBBTGAT,
     modelPar_FBBTRBOT,
     modelPar_given_FBBTRBOT,
     modelPar_FBBTRSTI,
     modelPar_given_FBBTRSTI,
     modelPar_FBBTRGAT,
     modelPar_given_FBBTRGAT,
     modelPar_STFBBTBOT,
     modelPar_given_STFBBTBOT,
     modelPar_STFBBTSTI,
     modelPar_given_STFBBTSTI,
     modelPar_STFBBTGAT,
     modelPar_given_STFBBTGAT,
     modelPar_VBRBOT,
     modelPar_given_VBRBOT,
     modelPar_VBRSTI,
     modelPar_given_VBRSTI,
     modelPar_VBRGAT,
     modelPar_given_VBRGAT,
     modelPar_PBRBOT,
     modelPar_given_PBRBOT,
     modelPar_PBRSTI,
     modelPar_given_PBRSTI,
     modelPar_PBRGAT,
     modelPar_given_PBRGAT,
     modelPar_CJORBOTD,
     modelPar_given_CJORBOTD,
     modelPar_CJORSTID,
     modelPar_given_CJORSTID,
     modelPar_CJORGATD,
     modelPar_given_CJORGATD,
     modelPar_VBIRBOTD,
     modelPar_given_VBIRBOTD,
     modelPar_VBIRSTID,
     modelPar_given_VBIRSTID,
     modelPar_VBIRGATD,
     modelPar_given_VBIRGATD,
     modelPar_PBOTD,
     modelPar_given_PBOTD,
     modelPar_PSTID,
     modelPar_given_PSTID,
     modelPar_PGATD,
     modelPar_given_PGATD,
     modelPar_PHIGBOTD,
     modelPar_given_PHIGBOTD,
     modelPar_PHIGSTID,
     modelPar_given_PHIGSTID,
     modelPar_PHIGGATD,
     modelPar_given_PHIGGATD,
     modelPar_IDSATRBOTD,
     modelPar_given_IDSATRBOTD,
     modelPar_IDSATRSTID,
     modelPar_given_IDSATRSTID,
     modelPar_IDSATRGATD,
     modelPar_given_IDSATRGATD,
     modelPar_CSRHBOTD,
     modelPar_given_CSRHBOTD,
     modelPar_CSRHSTID,
     modelPar_given_CSRHSTID,
     modelPar_CSRHGATD,
     modelPar_given_CSRHGATD,
     modelPar_XJUNSTID,
     modelPar_given_XJUNSTID,
     modelPar_XJUNGATD,
     modelPar_given_XJUNGATD,
     modelPar_CTATBOTD,
     modelPar_given_CTATBOTD,
     modelPar_CTATSTID,
     modelPar_given_CTATSTID,
     modelPar_CTATGATD,
     modelPar_given_CTATGATD,
     modelPar_MEFFTATBOTD,
     modelPar_given_MEFFTATBOTD,
     modelPar_MEFFTATSTID,
     modelPar_given_MEFFTATSTID,
     modelPar_MEFFTATGATD,
     modelPar_given_MEFFTATGATD,
     modelPar_CBBTBOTD,
     modelPar_given_CBBTBOTD,
     modelPar_CBBTSTID,
     modelPar_given_CBBTSTID,
     modelPar_CBBTGATD,
     modelPar_given_CBBTGATD,
     modelPar_FBBTRBOTD,
     modelPar_given_FBBTRBOTD,
     modelPar_FBBTRSTID,
     modelPar_given_FBBTRSTID,
     modelPar_FBBTRGATD,
     modelPar_given_FBBTRGATD,
     modelPar_STFBBTBOTD,
     modelPar_given_STFBBTBOTD,
     modelPar_STFBBTSTID,
     modelPar_given_STFBBTSTID,
     modelPar_STFBBTGATD,
     modelPar_given_STFBBTGATD,
     modelPar_VBRBOTD,
     modelPar_given_VBRBOTD,
     modelPar_VBRSTID,
     modelPar_given_VBRSTID,
     modelPar_VBRGATD,
     modelPar_given_VBRGATD,
     modelPar_PBRBOTD,
     modelPar_given_PBRBOTD,
     modelPar_PBRSTID,
     modelPar_given_PBRSTID,
     modelPar_PBRGATD,
     modelPar_given_PBRGATD,
     modelPar_SWJUNEXP,
     modelPar_given_SWJUNEXP,
     modelPar_VJUNREF,
     modelPar_given_VJUNREF,
     modelPar_FJUNQ,
     modelPar_given_FJUNQ,
     modelPar_VJUNREFD,
     modelPar_given_VJUNREFD,
     modelPar_FJUNQD,
     modelPar_given_FJUNQD// model variables
     ,
     // reals
     modelVar_NSUBO_i,
     modelVar_WSEG_i,
     modelVar_NPCK_i,
     modelVar_WSEGP_i,
     modelVar_LPCK_i,
     modelVar_LOV_i,
     modelVar_LOVD_i,
     modelVar_LP1_i,
     modelVar_LP2_i,
     modelVar_WBET_i,
     modelVar_AXL_i,
     modelVar_ALP1L2_i,
     modelVar_ALP2L2_i,
     modelVar_RINT_i,
     modelVar_RVPOLY_i,
     modelVar_SAREF_i,
     modelVar_SBREF_i,
     modelVar_KVSAT_i,
     modelVar_LLODKUO_i,
     modelVar_WLODKUO_i,
     modelVar_LLODVTH_i,
     modelVar_WLODVTH_i,
     modelVar_LODETAO_i,
     modelVar_SCREF_i,
     modelVar_WEB_i,
     modelVar_WEC_i,
     modelVar_TOX_i,
     modelVar_EPSROX_i,
     modelVar_TOXOV_i,
     modelVar_TOXOVD_i,
     modelVar_TKD,
     modelVar_dT,
     modelVar_rT,
     modelVar_rTn,
     modelVar_EPSSI,
     modelVar_phit,
     modelVar_inv_phit,
     modelVar_Eg,
     modelVar_phibFac,
     modelVar_nt0,
     modelVar_IMAX_i,
     modelVar_VBIRBOT_i,
     modelVar_VBIRSTI_i,
     modelVar_VBIRGAT_i,
     modelVar_PBOT_i,
     modelVar_PSTI_i,
     modelVar_PGAT_i,
     modelVar_CSRHBOT_i,
     modelVar_CSRHSTI_i,
     modelVar_CSRHGAT_i,
     modelVar_CTATBOT_i,
     modelVar_CTATSTI_i,
     modelVar_CTATGAT_i,
     modelVar_CBBTBOT_i,
     modelVar_CBBTSTI_i,
     modelVar_CBBTGAT_i,
     modelVar_VBRBOT_i,
     modelVar_VBRSTI_i,
     modelVar_VBRGAT_i,
     modelVar_PBRBOT_i,
     modelVar_PBRSTI_i,
     modelVar_PBRGAT_i,
     modelVar_SWJUNEXP_i,
     modelVar_VJUNREF_i,
     modelVar_FJUNQ_i,
     modelVar_phitr,
     modelVar_phitd,
     modelVar_phitdinv,
     modelVar_perfc,
     modelVar_berfc,
     modelVar_cerfc,
     modelVar_ftdbot,
     modelVar_ftdsti,
     modelVar_ftdgat,
     modelVar_idsatbot,
     modelVar_idsatsti,
     modelVar_idsatgat,
     modelVar_vbibot,
     modelVar_vbisti,
     modelVar_vbigat,
     modelVar_vbiinvbot,
     modelVar_vbiinvsti,
     modelVar_vbiinvgat,
     modelVar_one_minus_PBOT,
     modelVar_one_minus_PSTI,
     modelVar_one_minus_PGAT,
     modelVar_one_over_one_minus_PBOT,
     modelVar_one_over_one_minus_PSTI,
     modelVar_one_over_one_minus_PGAT,
     modelVar_cjobot,
     modelVar_cjosti,
     modelVar_cjogat,
     modelVar_qprefbot,
     modelVar_qprefsti,
     modelVar_qprefgat,
     modelVar_qpref2bot,
     modelVar_qpref2sti,
     modelVar_qpref2gat,
     modelVar_wdepnulrbot,
     modelVar_wdepnulrsti,
     modelVar_wdepnulrgat,
     modelVar_wdepnulrinvbot,
     modelVar_wdepnulrinvsti,
     modelVar_wdepnulrinvgat,
     modelVar_VBIRBOTinv,
     modelVar_VBIRSTIinv,
     modelVar_VBIRGATinv,
     modelVar_atatbot,
     modelVar_atatsti,
     modelVar_atatgat,
     modelVar_btatpartbot,
     modelVar_btatpartsti,
     modelVar_btatpartgat,
     modelVar_fbbtbot,
     modelVar_fbbtsti,
     modelVar_fbbtgat,
     modelVar_fstopbot,
     modelVar_fstopsti,
     modelVar_fstopgat,
     modelVar_VBRinvbot,
     modelVar_VBRinvsti,
     modelVar_VBRinvgat,
     modelVar_slopebot,
     modelVar_slopesti,
     modelVar_slopegat,
     modelVar_VBIRBOTD_i,
     modelVar_VBIRSTID_i,
     modelVar_VBIRGATD_i,
     modelVar_PBOTD_i,
     modelVar_PSTID_i,
     modelVar_PGATD_i,
     modelVar_CSRHBOTD_i,
     modelVar_CSRHSTID_i,
     modelVar_CSRHGATD_i,
     modelVar_CTATBOTD_i,
     modelVar_CTATSTID_i,
     modelVar_CTATGATD_i,
     modelVar_CBBTBOTD_i,
     modelVar_CBBTSTID_i,
     modelVar_CBBTGATD_i,
     modelVar_VBRBOTD_i,
     modelVar_VBRSTID_i,
     modelVar_VBRGATD_i,
     modelVar_PBRBOTD_i,
     modelVar_PBRSTID_i,
     modelVar_PBRGATD_i,
     modelVar_VJUNREFD_i,
     modelVar_FJUNQD_i,
     modelVar_ftdbot_d,
     modelVar_ftdsti_d,
     modelVar_ftdgat_d,
     modelVar_idsatbot_d,
     modelVar_idsatsti_d,
     modelVar_idsatgat_d,
     modelVar_vbibot_d,
     modelVar_vbisti_d,
     modelVar_vbigat_d,
     modelVar_vbiinvbot_d,
     modelVar_vbiinvsti_d,
     modelVar_vbiinvgat_d,
     modelVar_one_minus_PBOT_d,
     modelVar_one_minus_PSTI_d,
     modelVar_one_minus_PGAT_d,
     modelVar_one_over_one_minus_PBOT_d,
     modelVar_one_over_one_minus_PSTI_d,
     modelVar_one_over_one_minus_PGAT_d,
     modelVar_cjobot_d,
     modelVar_cjosti_d,
     modelVar_cjogat_d,
     modelVar_qprefbot_d,
     modelVar_qprefsti_d,
     modelVar_qprefgat_d,
     modelVar_qpref2bot_d,
     modelVar_qpref2sti_d,
     modelVar_qpref2gat_d,
     modelVar_wdepnulrbot_d,
     modelVar_wdepnulrsti_d,
     modelVar_wdepnulrgat_d,
     modelVar_wdepnulrinvbot_d,
     modelVar_wdepnulrinvsti_d,
     modelVar_wdepnulrinvgat_d,
     modelVar_VBIRBOTinv_d,
     modelVar_VBIRSTIinv_d,
     modelVar_VBIRGATinv_d,
     modelVar_atatbot_d,
     modelVar_atatsti_d,
     modelVar_atatgat_d,
     modelVar_btatpartbot_d,
     modelVar_btatpartsti_d,
     modelVar_btatpartgat_d,
     modelVar_fbbtbot_d,
     modelVar_fbbtsti_d,
     modelVar_fbbtgat_d,
     modelVar_fstopbot_d,
     modelVar_fstopsti_d,
     modelVar_fstopgat_d,
     modelVar_VBRinvbot_d,
     modelVar_VBRinvsti_d,
     modelVar_VBRinvgat_d,
     modelVar_slopebot_d,
     modelVar_slopesti_d,
     modelVar_slopegat_d,
     // non-reals
     modelVar_CHNL_TYPE,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_D] += staticContributions[in.admsNodeID_D].dx(0);
  dqdp[in.admsNodeID_D] += dynamicContributions[in.admsNodeID_D].dx(0);
  Findices[in.admsNodeID_D] = in.li_D;
  Qindices[in.admsNodeID_D] = in.li_D;
  dfdp[in.admsNodeID_G] += staticContributions[in.admsNodeID_G].dx(0);
  dqdp[in.admsNodeID_G] += dynamicContributions[in.admsNodeID_G].dx(0);
  Findices[in.admsNodeID_G] = in.li_G;
  Qindices[in.admsNodeID_G] = in.li_G;
  dfdp[in.admsNodeID_S] += staticContributions[in.admsNodeID_S].dx(0);
  dqdp[in.admsNodeID_S] += dynamicContributions[in.admsNodeID_S].dx(0);
  Findices[in.admsNodeID_S] = in.li_S;
  Qindices[in.admsNodeID_S] = in.li_S;
  dfdp[in.admsNodeID_B] += staticContributions[in.admsNodeID_B].dx(0);
  dqdp[in.admsNodeID_B] += dynamicContributions[in.admsNodeID_B].dx(0);
  Findices[in.admsNodeID_B] = in.li_B;
  Qindices[in.admsNodeID_B] = in.li_B;
  dfdp[in.admsNodeID_NOI] += staticContributions[in.admsNodeID_NOI].dx(0);
  dqdp[in.admsNodeID_NOI] += dynamicContributions[in.admsNodeID_NOI].dx(0);
  Findices[in.admsNodeID_NOI] = in.li_NOI;
  Qindices[in.admsNodeID_NOI] = in.li_NOI;
  dfdp[in.admsNodeID_NOI2] += staticContributions[in.admsNodeID_NOI2].dx(0);
  dqdp[in.admsNodeID_NOI2] += dynamicContributions[in.admsNodeID_NOI2].dx(0);
  Findices[in.admsNodeID_NOI2] = in.li_NOI2;
  Qindices[in.admsNodeID_NOI2] = in.li_NOI2;
  dfdp[in.admsNodeID_GP] += staticContributions[in.admsNodeID_GP].dx(0);
  dqdp[in.admsNodeID_GP] += dynamicContributions[in.admsNodeID_GP].dx(0);
  Findices[in.admsNodeID_GP] = in.li_GP;
  Qindices[in.admsNodeID_GP] = in.li_GP;
  dfdp[in.admsNodeID_BP] += staticContributions[in.admsNodeID_BP].dx(0);
  dqdp[in.admsNodeID_BP] += dynamicContributions[in.admsNodeID_BP].dx(0);
  Findices[in.admsNodeID_BP] = in.li_BP;
  Qindices[in.admsNodeID_BP] = in.li_BP;
  dfdp[in.admsNodeID_BI] += staticContributions[in.admsNodeID_BI].dx(0);
  dqdp[in.admsNodeID_BI] += dynamicContributions[in.admsNodeID_BI].dx(0);
  Findices[in.admsNodeID_BI] = in.li_BI;
  Qindices[in.admsNodeID_BI] = in.li_BI;
  dfdp[in.admsNodeID_BS] += staticContributions[in.admsNodeID_BS].dx(0);
  dqdp[in.admsNodeID_BS] += dynamicContributions[in.admsNodeID_BS].dx(0);
  Findices[in.admsNodeID_BS] = in.li_BS;
  Qindices[in.admsNodeID_BS] = in.li_BS;
  dfdp[in.admsNodeID_BD] += staticContributions[in.admsNodeID_BD].dx(0);
  dqdp[in.admsNodeID_BD] += dynamicContributions[in.admsNodeID_BD].dx(0);
  Findices[in.admsNodeID_BD] = in.li_BD;
  Qindices[in.admsNodeID_BD] = in.li_BD;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((11+0)*sizeInstance);
  dqdp.resize((11+0)*sizeInstance);
  Findices.resize((11+0)*sizeInstance);
  Qindices.resize((11+0)*sizeInstance);

  std::vector <double> probeVars(12);
  std::vector <AdmsSensFadType> staticContributions(11+0);
  std::vector <AdmsSensFadType> dynamicContributions(11+0);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_LEVEL=mod.LEVEL;
  bool modelPar_given_LEVEL=mod.given("LEVEL");
  modParamMap["LEVEL"] = &modelPar_LEVEL;
  AdmsSensFadType modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");
  modParamMap["TYPE"] = &modelPar_TYPE;
  AdmsSensFadType modelPar_TR=mod.TR;
  bool modelPar_given_TR=mod.given("TR");
  modParamMap["TR"] = &modelPar_TR;
  AdmsSensFadType modelPar_SWIGATE=mod.SWIGATE;
  bool modelPar_given_SWIGATE=mod.given("SWIGATE");
  modParamMap["SWIGATE"] = &modelPar_SWIGATE;
  AdmsSensFadType modelPar_SWIMPACT=mod.SWIMPACT;
  bool modelPar_given_SWIMPACT=mod.given("SWIMPACT");
  modParamMap["SWIMPACT"] = &modelPar_SWIMPACT;
  AdmsSensFadType modelPar_SWGIDL=mod.SWGIDL;
  bool modelPar_given_SWGIDL=mod.given("SWGIDL");
  modParamMap["SWGIDL"] = &modelPar_SWGIDL;
  AdmsSensFadType modelPar_SWJUNCAP=mod.SWJUNCAP;
  bool modelPar_given_SWJUNCAP=mod.given("SWJUNCAP");
  modParamMap["SWJUNCAP"] = &modelPar_SWJUNCAP;
  AdmsSensFadType modelPar_SWJUNASYM=mod.SWJUNASYM;
  bool modelPar_given_SWJUNASYM=mod.given("SWJUNASYM");
  modParamMap["SWJUNASYM"] = &modelPar_SWJUNASYM;
  AdmsSensFadType modelPar_QMC=mod.QMC;
  bool modelPar_given_QMC=mod.given("QMC");
  modParamMap["QMC"] = &modelPar_QMC;
  AdmsSensFadType modelPar_LVARO=mod.LVARO;
  bool modelPar_given_LVARO=mod.given("LVARO");
  modParamMap["LVARO"] = &modelPar_LVARO;
  AdmsSensFadType modelPar_LVARL=mod.LVARL;
  bool modelPar_given_LVARL=mod.given("LVARL");
  modParamMap["LVARL"] = &modelPar_LVARL;
  AdmsSensFadType modelPar_LVARW=mod.LVARW;
  bool modelPar_given_LVARW=mod.given("LVARW");
  modParamMap["LVARW"] = &modelPar_LVARW;
  AdmsSensFadType modelPar_LAP=mod.LAP;
  bool modelPar_given_LAP=mod.given("LAP");
  modParamMap["LAP"] = &modelPar_LAP;
  AdmsSensFadType modelPar_WVARO=mod.WVARO;
  bool modelPar_given_WVARO=mod.given("WVARO");
  modParamMap["WVARO"] = &modelPar_WVARO;
  AdmsSensFadType modelPar_WVARL=mod.WVARL;
  bool modelPar_given_WVARL=mod.given("WVARL");
  modParamMap["WVARL"] = &modelPar_WVARL;
  AdmsSensFadType modelPar_WVARW=mod.WVARW;
  bool modelPar_given_WVARW=mod.given("WVARW");
  modParamMap["WVARW"] = &modelPar_WVARW;
  AdmsSensFadType modelPar_WOT=mod.WOT;
  bool modelPar_given_WOT=mod.given("WOT");
  modParamMap["WOT"] = &modelPar_WOT;
  AdmsSensFadType modelPar_DLQ=mod.DLQ;
  bool modelPar_given_DLQ=mod.given("DLQ");
  modParamMap["DLQ"] = &modelPar_DLQ;
  AdmsSensFadType modelPar_DWQ=mod.DWQ;
  bool modelPar_given_DWQ=mod.given("DWQ");
  modParamMap["DWQ"] = &modelPar_DWQ;
  AdmsSensFadType modelPar_VFBO=mod.VFBO;
  bool modelPar_given_VFBO=mod.given("VFBO");
  modParamMap["VFBO"] = &modelPar_VFBO;
  AdmsSensFadType modelPar_VFBL=mod.VFBL;
  bool modelPar_given_VFBL=mod.given("VFBL");
  modParamMap["VFBL"] = &modelPar_VFBL;
  AdmsSensFadType modelPar_VFBW=mod.VFBW;
  bool modelPar_given_VFBW=mod.given("VFBW");
  modParamMap["VFBW"] = &modelPar_VFBW;
  AdmsSensFadType modelPar_VFBLW=mod.VFBLW;
  bool modelPar_given_VFBLW=mod.given("VFBLW");
  modParamMap["VFBLW"] = &modelPar_VFBLW;
  AdmsSensFadType modelPar_STVFBO=mod.STVFBO;
  bool modelPar_given_STVFBO=mod.given("STVFBO");
  modParamMap["STVFBO"] = &modelPar_STVFBO;
  AdmsSensFadType modelPar_STVFBL=mod.STVFBL;
  bool modelPar_given_STVFBL=mod.given("STVFBL");
  modParamMap["STVFBL"] = &modelPar_STVFBL;
  AdmsSensFadType modelPar_STVFBW=mod.STVFBW;
  bool modelPar_given_STVFBW=mod.given("STVFBW");
  modParamMap["STVFBW"] = &modelPar_STVFBW;
  AdmsSensFadType modelPar_STVFBLW=mod.STVFBLW;
  bool modelPar_given_STVFBLW=mod.given("STVFBLW");
  modParamMap["STVFBLW"] = &modelPar_STVFBLW;
  AdmsSensFadType modelPar_TOXO=mod.TOXO;
  bool modelPar_given_TOXO=mod.given("TOXO");
  modParamMap["TOXO"] = &modelPar_TOXO;
  AdmsSensFadType modelPar_EPSROXO=mod.EPSROXO;
  bool modelPar_given_EPSROXO=mod.given("EPSROXO");
  modParamMap["EPSROXO"] = &modelPar_EPSROXO;
  AdmsSensFadType modelPar_NSUBO=mod.NSUBO;
  bool modelPar_given_NSUBO=mod.given("NSUBO");
  modParamMap["NSUBO"] = &modelPar_NSUBO;
  AdmsSensFadType modelPar_NSUBW=mod.NSUBW;
  bool modelPar_given_NSUBW=mod.given("NSUBW");
  modParamMap["NSUBW"] = &modelPar_NSUBW;
  AdmsSensFadType modelPar_WSEG=mod.WSEG;
  bool modelPar_given_WSEG=mod.given("WSEG");
  modParamMap["WSEG"] = &modelPar_WSEG;
  AdmsSensFadType modelPar_NPCK=mod.NPCK;
  bool modelPar_given_NPCK=mod.given("NPCK");
  modParamMap["NPCK"] = &modelPar_NPCK;
  AdmsSensFadType modelPar_NPCKW=mod.NPCKW;
  bool modelPar_given_NPCKW=mod.given("NPCKW");
  modParamMap["NPCKW"] = &modelPar_NPCKW;
  AdmsSensFadType modelPar_WSEGP=mod.WSEGP;
  bool modelPar_given_WSEGP=mod.given("WSEGP");
  modParamMap["WSEGP"] = &modelPar_WSEGP;
  AdmsSensFadType modelPar_LPCK=mod.LPCK;
  bool modelPar_given_LPCK=mod.given("LPCK");
  modParamMap["LPCK"] = &modelPar_LPCK;
  AdmsSensFadType modelPar_LPCKW=mod.LPCKW;
  bool modelPar_given_LPCKW=mod.given("LPCKW");
  modParamMap["LPCKW"] = &modelPar_LPCKW;
  AdmsSensFadType modelPar_FOL1=mod.FOL1;
  bool modelPar_given_FOL1=mod.given("FOL1");
  modParamMap["FOL1"] = &modelPar_FOL1;
  AdmsSensFadType modelPar_FOL2=mod.FOL2;
  bool modelPar_given_FOL2=mod.given("FOL2");
  modParamMap["FOL2"] = &modelPar_FOL2;
  AdmsSensFadType modelPar_VNSUBO=mod.VNSUBO;
  bool modelPar_given_VNSUBO=mod.given("VNSUBO");
  modParamMap["VNSUBO"] = &modelPar_VNSUBO;
  AdmsSensFadType modelPar_NSLPO=mod.NSLPO;
  bool modelPar_given_NSLPO=mod.given("NSLPO");
  modParamMap["NSLPO"] = &modelPar_NSLPO;
  AdmsSensFadType modelPar_DNSUBO=mod.DNSUBO;
  bool modelPar_given_DNSUBO=mod.given("DNSUBO");
  modParamMap["DNSUBO"] = &modelPar_DNSUBO;
  AdmsSensFadType modelPar_DPHIBO=mod.DPHIBO;
  bool modelPar_given_DPHIBO=mod.given("DPHIBO");
  modParamMap["DPHIBO"] = &modelPar_DPHIBO;
  AdmsSensFadType modelPar_DPHIBL=mod.DPHIBL;
  bool modelPar_given_DPHIBL=mod.given("DPHIBL");
  modParamMap["DPHIBL"] = &modelPar_DPHIBL;
  AdmsSensFadType modelPar_DPHIBLEXP=mod.DPHIBLEXP;
  bool modelPar_given_DPHIBLEXP=mod.given("DPHIBLEXP");
  modParamMap["DPHIBLEXP"] = &modelPar_DPHIBLEXP;
  AdmsSensFadType modelPar_DPHIBW=mod.DPHIBW;
  bool modelPar_given_DPHIBW=mod.given("DPHIBW");
  modParamMap["DPHIBW"] = &modelPar_DPHIBW;
  AdmsSensFadType modelPar_DPHIBLW=mod.DPHIBLW;
  bool modelPar_given_DPHIBLW=mod.given("DPHIBLW");
  modParamMap["DPHIBLW"] = &modelPar_DPHIBLW;
  AdmsSensFadType modelPar_NPO=mod.NPO;
  bool modelPar_given_NPO=mod.given("NPO");
  modParamMap["NPO"] = &modelPar_NPO;
  AdmsSensFadType modelPar_NPL=mod.NPL;
  bool modelPar_given_NPL=mod.given("NPL");
  modParamMap["NPL"] = &modelPar_NPL;
  AdmsSensFadType modelPar_CTO=mod.CTO;
  bool modelPar_given_CTO=mod.given("CTO");
  modParamMap["CTO"] = &modelPar_CTO;
  AdmsSensFadType modelPar_CTL=mod.CTL;
  bool modelPar_given_CTL=mod.given("CTL");
  modParamMap["CTL"] = &modelPar_CTL;
  AdmsSensFadType modelPar_CTLEXP=mod.CTLEXP;
  bool modelPar_given_CTLEXP=mod.given("CTLEXP");
  modParamMap["CTLEXP"] = &modelPar_CTLEXP;
  AdmsSensFadType modelPar_CTW=mod.CTW;
  bool modelPar_given_CTW=mod.given("CTW");
  modParamMap["CTW"] = &modelPar_CTW;
  AdmsSensFadType modelPar_CTLW=mod.CTLW;
  bool modelPar_given_CTLW=mod.given("CTLW");
  modParamMap["CTLW"] = &modelPar_CTLW;
  AdmsSensFadType modelPar_TOXOVO=mod.TOXOVO;
  bool modelPar_given_TOXOVO=mod.given("TOXOVO");
  modParamMap["TOXOVO"] = &modelPar_TOXOVO;
  AdmsSensFadType modelPar_TOXOVDO=mod.TOXOVDO;
  bool modelPar_given_TOXOVDO=mod.given("TOXOVDO");
  modParamMap["TOXOVDO"] = &modelPar_TOXOVDO;
  AdmsSensFadType modelPar_LOV=mod.LOV;
  bool modelPar_given_LOV=mod.given("LOV");
  modParamMap["LOV"] = &modelPar_LOV;
  AdmsSensFadType modelPar_LOVD=mod.LOVD;
  bool modelPar_given_LOVD=mod.given("LOVD");
  modParamMap["LOVD"] = &modelPar_LOVD;
  AdmsSensFadType modelPar_NOVO=mod.NOVO;
  bool modelPar_given_NOVO=mod.given("NOVO");
  modParamMap["NOVO"] = &modelPar_NOVO;
  AdmsSensFadType modelPar_NOVDO=mod.NOVDO;
  bool modelPar_given_NOVDO=mod.given("NOVDO");
  modParamMap["NOVDO"] = &modelPar_NOVDO;
  AdmsSensFadType modelPar_CFL=mod.CFL;
  bool modelPar_given_CFL=mod.given("CFL");
  modParamMap["CFL"] = &modelPar_CFL;
  AdmsSensFadType modelPar_CFLEXP=mod.CFLEXP;
  bool modelPar_given_CFLEXP=mod.given("CFLEXP");
  modParamMap["CFLEXP"] = &modelPar_CFLEXP;
  AdmsSensFadType modelPar_CFW=mod.CFW;
  bool modelPar_given_CFW=mod.given("CFW");
  modParamMap["CFW"] = &modelPar_CFW;
  AdmsSensFadType modelPar_CFBO=mod.CFBO;
  bool modelPar_given_CFBO=mod.given("CFBO");
  modParamMap["CFBO"] = &modelPar_CFBO;
  AdmsSensFadType modelPar_UO=mod.UO;
  bool modelPar_given_UO=mod.given("UO");
  modParamMap["UO"] = &modelPar_UO;
  AdmsSensFadType modelPar_FBET1=mod.FBET1;
  bool modelPar_given_FBET1=mod.given("FBET1");
  modParamMap["FBET1"] = &modelPar_FBET1;
  AdmsSensFadType modelPar_FBET1W=mod.FBET1W;
  bool modelPar_given_FBET1W=mod.given("FBET1W");
  modParamMap["FBET1W"] = &modelPar_FBET1W;
  AdmsSensFadType modelPar_LP1=mod.LP1;
  bool modelPar_given_LP1=mod.given("LP1");
  modParamMap["LP1"] = &modelPar_LP1;
  AdmsSensFadType modelPar_LP1W=mod.LP1W;
  bool modelPar_given_LP1W=mod.given("LP1W");
  modParamMap["LP1W"] = &modelPar_LP1W;
  AdmsSensFadType modelPar_FBET2=mod.FBET2;
  bool modelPar_given_FBET2=mod.given("FBET2");
  modParamMap["FBET2"] = &modelPar_FBET2;
  AdmsSensFadType modelPar_LP2=mod.LP2;
  bool modelPar_given_LP2=mod.given("LP2");
  modParamMap["LP2"] = &modelPar_LP2;
  AdmsSensFadType modelPar_BETW1=mod.BETW1;
  bool modelPar_given_BETW1=mod.given("BETW1");
  modParamMap["BETW1"] = &modelPar_BETW1;
  AdmsSensFadType modelPar_BETW2=mod.BETW2;
  bool modelPar_given_BETW2=mod.given("BETW2");
  modParamMap["BETW2"] = &modelPar_BETW2;
  AdmsSensFadType modelPar_WBET=mod.WBET;
  bool modelPar_given_WBET=mod.given("WBET");
  modParamMap["WBET"] = &modelPar_WBET;
  AdmsSensFadType modelPar_STBETO=mod.STBETO;
  bool modelPar_given_STBETO=mod.given("STBETO");
  modParamMap["STBETO"] = &modelPar_STBETO;
  AdmsSensFadType modelPar_STBETL=mod.STBETL;
  bool modelPar_given_STBETL=mod.given("STBETL");
  modParamMap["STBETL"] = &modelPar_STBETL;
  AdmsSensFadType modelPar_STBETW=mod.STBETW;
  bool modelPar_given_STBETW=mod.given("STBETW");
  modParamMap["STBETW"] = &modelPar_STBETW;
  AdmsSensFadType modelPar_STBETLW=mod.STBETLW;
  bool modelPar_given_STBETLW=mod.given("STBETLW");
  modParamMap["STBETLW"] = &modelPar_STBETLW;
  AdmsSensFadType modelPar_MUEO=mod.MUEO;
  bool modelPar_given_MUEO=mod.given("MUEO");
  modParamMap["MUEO"] = &modelPar_MUEO;
  AdmsSensFadType modelPar_MUEW=mod.MUEW;
  bool modelPar_given_MUEW=mod.given("MUEW");
  modParamMap["MUEW"] = &modelPar_MUEW;
  AdmsSensFadType modelPar_STMUEO=mod.STMUEO;
  bool modelPar_given_STMUEO=mod.given("STMUEO");
  modParamMap["STMUEO"] = &modelPar_STMUEO;
  AdmsSensFadType modelPar_THEMUO=mod.THEMUO;
  bool modelPar_given_THEMUO=mod.given("THEMUO");
  modParamMap["THEMUO"] = &modelPar_THEMUO;
  AdmsSensFadType modelPar_STTHEMUO=mod.STTHEMUO;
  bool modelPar_given_STTHEMUO=mod.given("STTHEMUO");
  modParamMap["STTHEMUO"] = &modelPar_STTHEMUO;
  AdmsSensFadType modelPar_CSO=mod.CSO;
  bool modelPar_given_CSO=mod.given("CSO");
  modParamMap["CSO"] = &modelPar_CSO;
  AdmsSensFadType modelPar_CSL=mod.CSL;
  bool modelPar_given_CSL=mod.given("CSL");
  modParamMap["CSL"] = &modelPar_CSL;
  AdmsSensFadType modelPar_CSLEXP=mod.CSLEXP;
  bool modelPar_given_CSLEXP=mod.given("CSLEXP");
  modParamMap["CSLEXP"] = &modelPar_CSLEXP;
  AdmsSensFadType modelPar_CSW=mod.CSW;
  bool modelPar_given_CSW=mod.given("CSW");
  modParamMap["CSW"] = &modelPar_CSW;
  AdmsSensFadType modelPar_CSLW=mod.CSLW;
  bool modelPar_given_CSLW=mod.given("CSLW");
  modParamMap["CSLW"] = &modelPar_CSLW;
  AdmsSensFadType modelPar_STCSO=mod.STCSO;
  bool modelPar_given_STCSO=mod.given("STCSO");
  modParamMap["STCSO"] = &modelPar_STCSO;
  AdmsSensFadType modelPar_XCORO=mod.XCORO;
  bool modelPar_given_XCORO=mod.given("XCORO");
  modParamMap["XCORO"] = &modelPar_XCORO;
  AdmsSensFadType modelPar_XCORL=mod.XCORL;
  bool modelPar_given_XCORL=mod.given("XCORL");
  modParamMap["XCORL"] = &modelPar_XCORL;
  AdmsSensFadType modelPar_XCORW=mod.XCORW;
  bool modelPar_given_XCORW=mod.given("XCORW");
  modParamMap["XCORW"] = &modelPar_XCORW;
  AdmsSensFadType modelPar_XCORLW=mod.XCORLW;
  bool modelPar_given_XCORLW=mod.given("XCORLW");
  modParamMap["XCORLW"] = &modelPar_XCORLW;
  AdmsSensFadType modelPar_STXCORO=mod.STXCORO;
  bool modelPar_given_STXCORO=mod.given("STXCORO");
  modParamMap["STXCORO"] = &modelPar_STXCORO;
  AdmsSensFadType modelPar_FETAO=mod.FETAO;
  bool modelPar_given_FETAO=mod.given("FETAO");
  modParamMap["FETAO"] = &modelPar_FETAO;
  AdmsSensFadType modelPar_RSW1=mod.RSW1;
  bool modelPar_given_RSW1=mod.given("RSW1");
  modParamMap["RSW1"] = &modelPar_RSW1;
  AdmsSensFadType modelPar_RSW2=mod.RSW2;
  bool modelPar_given_RSW2=mod.given("RSW2");
  modParamMap["RSW2"] = &modelPar_RSW2;
  AdmsSensFadType modelPar_STRSO=mod.STRSO;
  bool modelPar_given_STRSO=mod.given("STRSO");
  modParamMap["STRSO"] = &modelPar_STRSO;
  AdmsSensFadType modelPar_RSBO=mod.RSBO;
  bool modelPar_given_RSBO=mod.given("RSBO");
  modParamMap["RSBO"] = &modelPar_RSBO;
  AdmsSensFadType modelPar_RSGO=mod.RSGO;
  bool modelPar_given_RSGO=mod.given("RSGO");
  modParamMap["RSGO"] = &modelPar_RSGO;
  AdmsSensFadType modelPar_THESATO=mod.THESATO;
  bool modelPar_given_THESATO=mod.given("THESATO");
  modParamMap["THESATO"] = &modelPar_THESATO;
  AdmsSensFadType modelPar_THESATL=mod.THESATL;
  bool modelPar_given_THESATL=mod.given("THESATL");
  modParamMap["THESATL"] = &modelPar_THESATL;
  AdmsSensFadType modelPar_THESATLEXP=mod.THESATLEXP;
  bool modelPar_given_THESATLEXP=mod.given("THESATLEXP");
  modParamMap["THESATLEXP"] = &modelPar_THESATLEXP;
  AdmsSensFadType modelPar_THESATW=mod.THESATW;
  bool modelPar_given_THESATW=mod.given("THESATW");
  modParamMap["THESATW"] = &modelPar_THESATW;
  AdmsSensFadType modelPar_THESATLW=mod.THESATLW;
  bool modelPar_given_THESATLW=mod.given("THESATLW");
  modParamMap["THESATLW"] = &modelPar_THESATLW;
  AdmsSensFadType modelPar_STTHESATO=mod.STTHESATO;
  bool modelPar_given_STTHESATO=mod.given("STTHESATO");
  modParamMap["STTHESATO"] = &modelPar_STTHESATO;
  AdmsSensFadType modelPar_STTHESATL=mod.STTHESATL;
  bool modelPar_given_STTHESATL=mod.given("STTHESATL");
  modParamMap["STTHESATL"] = &modelPar_STTHESATL;
  AdmsSensFadType modelPar_STTHESATW=mod.STTHESATW;
  bool modelPar_given_STTHESATW=mod.given("STTHESATW");
  modParamMap["STTHESATW"] = &modelPar_STTHESATW;
  AdmsSensFadType modelPar_STTHESATLW=mod.STTHESATLW;
  bool modelPar_given_STTHESATLW=mod.given("STTHESATLW");
  modParamMap["STTHESATLW"] = &modelPar_STTHESATLW;
  AdmsSensFadType modelPar_THESATBO=mod.THESATBO;
  bool modelPar_given_THESATBO=mod.given("THESATBO");
  modParamMap["THESATBO"] = &modelPar_THESATBO;
  AdmsSensFadType modelPar_THESATGO=mod.THESATGO;
  bool modelPar_given_THESATGO=mod.given("THESATGO");
  modParamMap["THESATGO"] = &modelPar_THESATGO;
  AdmsSensFadType modelPar_AXO=mod.AXO;
  bool modelPar_given_AXO=mod.given("AXO");
  modParamMap["AXO"] = &modelPar_AXO;
  AdmsSensFadType modelPar_AXL=mod.AXL;
  bool modelPar_given_AXL=mod.given("AXL");
  modParamMap["AXL"] = &modelPar_AXL;
  AdmsSensFadType modelPar_ALPL=mod.ALPL;
  bool modelPar_given_ALPL=mod.given("ALPL");
  modParamMap["ALPL"] = &modelPar_ALPL;
  AdmsSensFadType modelPar_ALPLEXP=mod.ALPLEXP;
  bool modelPar_given_ALPLEXP=mod.given("ALPLEXP");
  modParamMap["ALPLEXP"] = &modelPar_ALPLEXP;
  AdmsSensFadType modelPar_ALPW=mod.ALPW;
  bool modelPar_given_ALPW=mod.given("ALPW");
  modParamMap["ALPW"] = &modelPar_ALPW;
  AdmsSensFadType modelPar_ALP1L1=mod.ALP1L1;
  bool modelPar_given_ALP1L1=mod.given("ALP1L1");
  modParamMap["ALP1L1"] = &modelPar_ALP1L1;
  AdmsSensFadType modelPar_ALP1LEXP=mod.ALP1LEXP;
  bool modelPar_given_ALP1LEXP=mod.given("ALP1LEXP");
  modParamMap["ALP1LEXP"] = &modelPar_ALP1LEXP;
  AdmsSensFadType modelPar_ALP1L2=mod.ALP1L2;
  bool modelPar_given_ALP1L2=mod.given("ALP1L2");
  modParamMap["ALP1L2"] = &modelPar_ALP1L2;
  AdmsSensFadType modelPar_ALP1W=mod.ALP1W;
  bool modelPar_given_ALP1W=mod.given("ALP1W");
  modParamMap["ALP1W"] = &modelPar_ALP1W;
  AdmsSensFadType modelPar_ALP2L1=mod.ALP2L1;
  bool modelPar_given_ALP2L1=mod.given("ALP2L1");
  modParamMap["ALP2L1"] = &modelPar_ALP2L1;
  AdmsSensFadType modelPar_ALP2LEXP=mod.ALP2LEXP;
  bool modelPar_given_ALP2LEXP=mod.given("ALP2LEXP");
  modParamMap["ALP2LEXP"] = &modelPar_ALP2LEXP;
  AdmsSensFadType modelPar_ALP2L2=mod.ALP2L2;
  bool modelPar_given_ALP2L2=mod.given("ALP2L2");
  modParamMap["ALP2L2"] = &modelPar_ALP2L2;
  AdmsSensFadType modelPar_ALP2W=mod.ALP2W;
  bool modelPar_given_ALP2W=mod.given("ALP2W");
  modParamMap["ALP2W"] = &modelPar_ALP2W;
  AdmsSensFadType modelPar_VPO=mod.VPO;
  bool modelPar_given_VPO=mod.given("VPO");
  modParamMap["VPO"] = &modelPar_VPO;
  AdmsSensFadType modelPar_A1O=mod.A1O;
  bool modelPar_given_A1O=mod.given("A1O");
  modParamMap["A1O"] = &modelPar_A1O;
  AdmsSensFadType modelPar_A1L=mod.A1L;
  bool modelPar_given_A1L=mod.given("A1L");
  modParamMap["A1L"] = &modelPar_A1L;
  AdmsSensFadType modelPar_A1W=mod.A1W;
  bool modelPar_given_A1W=mod.given("A1W");
  modParamMap["A1W"] = &modelPar_A1W;
  AdmsSensFadType modelPar_A2O=mod.A2O;
  bool modelPar_given_A2O=mod.given("A2O");
  modParamMap["A2O"] = &modelPar_A2O;
  AdmsSensFadType modelPar_STA2O=mod.STA2O;
  bool modelPar_given_STA2O=mod.given("STA2O");
  modParamMap["STA2O"] = &modelPar_STA2O;
  AdmsSensFadType modelPar_A3O=mod.A3O;
  bool modelPar_given_A3O=mod.given("A3O");
  modParamMap["A3O"] = &modelPar_A3O;
  AdmsSensFadType modelPar_A3L=mod.A3L;
  bool modelPar_given_A3L=mod.given("A3L");
  modParamMap["A3L"] = &modelPar_A3L;
  AdmsSensFadType modelPar_A3W=mod.A3W;
  bool modelPar_given_A3W=mod.given("A3W");
  modParamMap["A3W"] = &modelPar_A3W;
  AdmsSensFadType modelPar_A4O=mod.A4O;
  bool modelPar_given_A4O=mod.given("A4O");
  modParamMap["A4O"] = &modelPar_A4O;
  AdmsSensFadType modelPar_A4L=mod.A4L;
  bool modelPar_given_A4L=mod.given("A4L");
  modParamMap["A4L"] = &modelPar_A4L;
  AdmsSensFadType modelPar_A4W=mod.A4W;
  bool modelPar_given_A4W=mod.given("A4W");
  modParamMap["A4W"] = &modelPar_A4W;
  AdmsSensFadType modelPar_GCOO=mod.GCOO;
  bool modelPar_given_GCOO=mod.given("GCOO");
  modParamMap["GCOO"] = &modelPar_GCOO;
  AdmsSensFadType modelPar_IGINVLW=mod.IGINVLW;
  bool modelPar_given_IGINVLW=mod.given("IGINVLW");
  modParamMap["IGINVLW"] = &modelPar_IGINVLW;
  AdmsSensFadType modelPar_IGOVW=mod.IGOVW;
  bool modelPar_given_IGOVW=mod.given("IGOVW");
  modParamMap["IGOVW"] = &modelPar_IGOVW;
  AdmsSensFadType modelPar_IGOVDW=mod.IGOVDW;
  bool modelPar_given_IGOVDW=mod.given("IGOVDW");
  modParamMap["IGOVDW"] = &modelPar_IGOVDW;
  AdmsSensFadType modelPar_STIGO=mod.STIGO;
  bool modelPar_given_STIGO=mod.given("STIGO");
  modParamMap["STIGO"] = &modelPar_STIGO;
  AdmsSensFadType modelPar_GC2O=mod.GC2O;
  bool modelPar_given_GC2O=mod.given("GC2O");
  modParamMap["GC2O"] = &modelPar_GC2O;
  AdmsSensFadType modelPar_GC3O=mod.GC3O;
  bool modelPar_given_GC3O=mod.given("GC3O");
  modParamMap["GC3O"] = &modelPar_GC3O;
  AdmsSensFadType modelPar_CHIBO=mod.CHIBO;
  bool modelPar_given_CHIBO=mod.given("CHIBO");
  modParamMap["CHIBO"] = &modelPar_CHIBO;
  AdmsSensFadType modelPar_AGIDLW=mod.AGIDLW;
  bool modelPar_given_AGIDLW=mod.given("AGIDLW");
  modParamMap["AGIDLW"] = &modelPar_AGIDLW;
  AdmsSensFadType modelPar_AGIDLDW=mod.AGIDLDW;
  bool modelPar_given_AGIDLDW=mod.given("AGIDLDW");
  modParamMap["AGIDLDW"] = &modelPar_AGIDLDW;
  AdmsSensFadType modelPar_BGIDLO=mod.BGIDLO;
  bool modelPar_given_BGIDLO=mod.given("BGIDLO");
  modParamMap["BGIDLO"] = &modelPar_BGIDLO;
  AdmsSensFadType modelPar_BGIDLDO=mod.BGIDLDO;
  bool modelPar_given_BGIDLDO=mod.given("BGIDLDO");
  modParamMap["BGIDLDO"] = &modelPar_BGIDLDO;
  AdmsSensFadType modelPar_STBGIDLO=mod.STBGIDLO;
  bool modelPar_given_STBGIDLO=mod.given("STBGIDLO");
  modParamMap["STBGIDLO"] = &modelPar_STBGIDLO;
  AdmsSensFadType modelPar_STBGIDLDO=mod.STBGIDLDO;
  bool modelPar_given_STBGIDLDO=mod.given("STBGIDLDO");
  modParamMap["STBGIDLDO"] = &modelPar_STBGIDLDO;
  AdmsSensFadType modelPar_CGIDLO=mod.CGIDLO;
  bool modelPar_given_CGIDLO=mod.given("CGIDLO");
  modParamMap["CGIDLO"] = &modelPar_CGIDLO;
  AdmsSensFadType modelPar_CGIDLDO=mod.CGIDLDO;
  bool modelPar_given_CGIDLDO=mod.given("CGIDLDO");
  modParamMap["CGIDLDO"] = &modelPar_CGIDLDO;
  AdmsSensFadType modelPar_CGBOVL=mod.CGBOVL;
  bool modelPar_given_CGBOVL=mod.given("CGBOVL");
  modParamMap["CGBOVL"] = &modelPar_CGBOVL;
  AdmsSensFadType modelPar_CFRW=mod.CFRW;
  bool modelPar_given_CFRW=mod.given("CFRW");
  modParamMap["CFRW"] = &modelPar_CFRW;
  AdmsSensFadType modelPar_CFRDW=mod.CFRDW;
  bool modelPar_given_CFRDW=mod.given("CFRDW");
  modParamMap["CFRDW"] = &modelPar_CFRDW;
  AdmsSensFadType modelPar_FNTO=mod.FNTO;
  bool modelPar_given_FNTO=mod.given("FNTO");
  modParamMap["FNTO"] = &modelPar_FNTO;
  AdmsSensFadType modelPar_FNTEXCL=mod.FNTEXCL;
  bool modelPar_given_FNTEXCL=mod.given("FNTEXCL");
  modParamMap["FNTEXCL"] = &modelPar_FNTEXCL;
  AdmsSensFadType modelPar_NFALW=mod.NFALW;
  bool modelPar_given_NFALW=mod.given("NFALW");
  modParamMap["NFALW"] = &modelPar_NFALW;
  AdmsSensFadType modelPar_NFBLW=mod.NFBLW;
  bool modelPar_given_NFBLW=mod.given("NFBLW");
  modParamMap["NFBLW"] = &modelPar_NFBLW;
  AdmsSensFadType modelPar_NFCLW=mod.NFCLW;
  bool modelPar_given_NFCLW=mod.given("NFCLW");
  modParamMap["NFCLW"] = &modelPar_NFCLW;
  AdmsSensFadType modelPar_EFO=mod.EFO;
  bool modelPar_given_EFO=mod.given("EFO");
  modParamMap["EFO"] = &modelPar_EFO;
  AdmsSensFadType modelPar_LINTNOI=mod.LINTNOI;
  bool modelPar_given_LINTNOI=mod.given("LINTNOI");
  modParamMap["LINTNOI"] = &modelPar_LINTNOI;
  AdmsSensFadType modelPar_ALPNOI=mod.ALPNOI;
  bool modelPar_given_ALPNOI=mod.given("ALPNOI");
  modParamMap["ALPNOI"] = &modelPar_ALPNOI;
  AdmsSensFadType modelPar_DTA=mod.DTA;
  bool modelPar_given_DTA=mod.given("DTA");
  modParamMap["DTA"] = &modelPar_DTA;
  AdmsSensFadType modelPar_KVTHOWEO=mod.KVTHOWEO;
  bool modelPar_given_KVTHOWEO=mod.given("KVTHOWEO");
  modParamMap["KVTHOWEO"] = &modelPar_KVTHOWEO;
  AdmsSensFadType modelPar_KVTHOWEL=mod.KVTHOWEL;
  bool modelPar_given_KVTHOWEL=mod.given("KVTHOWEL");
  modParamMap["KVTHOWEL"] = &modelPar_KVTHOWEL;
  AdmsSensFadType modelPar_KVTHOWEW=mod.KVTHOWEW;
  bool modelPar_given_KVTHOWEW=mod.given("KVTHOWEW");
  modParamMap["KVTHOWEW"] = &modelPar_KVTHOWEW;
  AdmsSensFadType modelPar_KVTHOWELW=mod.KVTHOWELW;
  bool modelPar_given_KVTHOWELW=mod.given("KVTHOWELW");
  modParamMap["KVTHOWELW"] = &modelPar_KVTHOWELW;
  AdmsSensFadType modelPar_KUOWEO=mod.KUOWEO;
  bool modelPar_given_KUOWEO=mod.given("KUOWEO");
  modParamMap["KUOWEO"] = &modelPar_KUOWEO;
  AdmsSensFadType modelPar_KUOWEL=mod.KUOWEL;
  bool modelPar_given_KUOWEL=mod.given("KUOWEL");
  modParamMap["KUOWEL"] = &modelPar_KUOWEL;
  AdmsSensFadType modelPar_KUOWEW=mod.KUOWEW;
  bool modelPar_given_KUOWEW=mod.given("KUOWEW");
  modParamMap["KUOWEW"] = &modelPar_KUOWEW;
  AdmsSensFadType modelPar_KUOWELW=mod.KUOWELW;
  bool modelPar_given_KUOWELW=mod.given("KUOWELW");
  modParamMap["KUOWELW"] = &modelPar_KUOWELW;
  AdmsSensFadType modelPar_LMIN=mod.LMIN;
  bool modelPar_given_LMIN=mod.given("LMIN");
  modParamMap["LMIN"] = &modelPar_LMIN;
  AdmsSensFadType modelPar_LMAX=mod.LMAX;
  bool modelPar_given_LMAX=mod.given("LMAX");
  modParamMap["LMAX"] = &modelPar_LMAX;
  AdmsSensFadType modelPar_WMIN=mod.WMIN;
  bool modelPar_given_WMIN=mod.given("WMIN");
  modParamMap["WMIN"] = &modelPar_WMIN;
  AdmsSensFadType modelPar_WMAX=mod.WMAX;
  bool modelPar_given_WMAX=mod.given("WMAX");
  modParamMap["WMAX"] = &modelPar_WMAX;
  AdmsSensFadType modelPar_RGO=mod.RGO;
  bool modelPar_given_RGO=mod.given("RGO");
  modParamMap["RGO"] = &modelPar_RGO;
  AdmsSensFadType modelPar_RBULKO=mod.RBULKO;
  bool modelPar_given_RBULKO=mod.given("RBULKO");
  modParamMap["RBULKO"] = &modelPar_RBULKO;
  AdmsSensFadType modelPar_RWELLO=mod.RWELLO;
  bool modelPar_given_RWELLO=mod.given("RWELLO");
  modParamMap["RWELLO"] = &modelPar_RWELLO;
  AdmsSensFadType modelPar_RJUNSO=mod.RJUNSO;
  bool modelPar_given_RJUNSO=mod.given("RJUNSO");
  modParamMap["RJUNSO"] = &modelPar_RJUNSO;
  AdmsSensFadType modelPar_RJUNDO=mod.RJUNDO;
  bool modelPar_given_RJUNDO=mod.given("RJUNDO");
  modParamMap["RJUNDO"] = &modelPar_RJUNDO;
  AdmsSensFadType modelPar_RINT=mod.RINT;
  bool modelPar_given_RINT=mod.given("RINT");
  modParamMap["RINT"] = &modelPar_RINT;
  AdmsSensFadType modelPar_RVPOLY=mod.RVPOLY;
  bool modelPar_given_RVPOLY=mod.given("RVPOLY");
  modParamMap["RVPOLY"] = &modelPar_RVPOLY;
  AdmsSensFadType modelPar_RSHG=mod.RSHG;
  bool modelPar_given_RSHG=mod.given("RSHG");
  modParamMap["RSHG"] = &modelPar_RSHG;
  AdmsSensFadType modelPar_DLSIL=mod.DLSIL;
  bool modelPar_given_DLSIL=mod.given("DLSIL");
  modParamMap["DLSIL"] = &modelPar_DLSIL;
  AdmsSensFadType modelPar_SAREF=mod.SAREF;
  bool modelPar_given_SAREF=mod.given("SAREF");
  modParamMap["SAREF"] = &modelPar_SAREF;
  AdmsSensFadType modelPar_SBREF=mod.SBREF;
  bool modelPar_given_SBREF=mod.given("SBREF");
  modParamMap["SBREF"] = &modelPar_SBREF;
  AdmsSensFadType modelPar_WLOD=mod.WLOD;
  bool modelPar_given_WLOD=mod.given("WLOD");
  modParamMap["WLOD"] = &modelPar_WLOD;
  AdmsSensFadType modelPar_KUO=mod.KUO;
  bool modelPar_given_KUO=mod.given("KUO");
  modParamMap["KUO"] = &modelPar_KUO;
  AdmsSensFadType modelPar_KVSAT=mod.KVSAT;
  bool modelPar_given_KVSAT=mod.given("KVSAT");
  modParamMap["KVSAT"] = &modelPar_KVSAT;
  AdmsSensFadType modelPar_TKUO=mod.TKUO;
  bool modelPar_given_TKUO=mod.given("TKUO");
  modParamMap["TKUO"] = &modelPar_TKUO;
  AdmsSensFadType modelPar_LKUO=mod.LKUO;
  bool modelPar_given_LKUO=mod.given("LKUO");
  modParamMap["LKUO"] = &modelPar_LKUO;
  AdmsSensFadType modelPar_WKUO=mod.WKUO;
  bool modelPar_given_WKUO=mod.given("WKUO");
  modParamMap["WKUO"] = &modelPar_WKUO;
  AdmsSensFadType modelPar_PKUO=mod.PKUO;
  bool modelPar_given_PKUO=mod.given("PKUO");
  modParamMap["PKUO"] = &modelPar_PKUO;
  AdmsSensFadType modelPar_LLODKUO=mod.LLODKUO;
  bool modelPar_given_LLODKUO=mod.given("LLODKUO");
  modParamMap["LLODKUO"] = &modelPar_LLODKUO;
  AdmsSensFadType modelPar_WLODKUO=mod.WLODKUO;
  bool modelPar_given_WLODKUO=mod.given("WLODKUO");
  modParamMap["WLODKUO"] = &modelPar_WLODKUO;
  AdmsSensFadType modelPar_KVTHO=mod.KVTHO;
  bool modelPar_given_KVTHO=mod.given("KVTHO");
  modParamMap["KVTHO"] = &modelPar_KVTHO;
  AdmsSensFadType modelPar_LKVTHO=mod.LKVTHO;
  bool modelPar_given_LKVTHO=mod.given("LKVTHO");
  modParamMap["LKVTHO"] = &modelPar_LKVTHO;
  AdmsSensFadType modelPar_WKVTHO=mod.WKVTHO;
  bool modelPar_given_WKVTHO=mod.given("WKVTHO");
  modParamMap["WKVTHO"] = &modelPar_WKVTHO;
  AdmsSensFadType modelPar_PKVTHO=mod.PKVTHO;
  bool modelPar_given_PKVTHO=mod.given("PKVTHO");
  modParamMap["PKVTHO"] = &modelPar_PKVTHO;
  AdmsSensFadType modelPar_LLODVTH=mod.LLODVTH;
  bool modelPar_given_LLODVTH=mod.given("LLODVTH");
  modParamMap["LLODVTH"] = &modelPar_LLODVTH;
  AdmsSensFadType modelPar_WLODVTH=mod.WLODVTH;
  bool modelPar_given_WLODVTH=mod.given("WLODVTH");
  modParamMap["WLODVTH"] = &modelPar_WLODVTH;
  AdmsSensFadType modelPar_STETAO=mod.STETAO;
  bool modelPar_given_STETAO=mod.given("STETAO");
  modParamMap["STETAO"] = &modelPar_STETAO;
  AdmsSensFadType modelPar_LODETAO=mod.LODETAO;
  bool modelPar_given_LODETAO=mod.given("LODETAO");
  modParamMap["LODETAO"] = &modelPar_LODETAO;
  AdmsSensFadType modelPar_SCREF=mod.SCREF;
  bool modelPar_given_SCREF=mod.given("SCREF");
  modParamMap["SCREF"] = &modelPar_SCREF;
  AdmsSensFadType modelPar_WEB=mod.WEB;
  bool modelPar_given_WEB=mod.given("WEB");
  modParamMap["WEB"] = &modelPar_WEB;
  AdmsSensFadType modelPar_WEC=mod.WEC;
  bool modelPar_given_WEC=mod.given("WEC");
  modParamMap["WEC"] = &modelPar_WEC;
  AdmsSensFadType modelPar_IMAX=mod.IMAX;
  bool modelPar_given_IMAX=mod.given("IMAX");
  modParamMap["IMAX"] = &modelPar_IMAX;
  AdmsSensFadType modelPar_TRJ=mod.TRJ;
  bool modelPar_given_TRJ=mod.given("TRJ");
  modParamMap["TRJ"] = &modelPar_TRJ;
  AdmsSensFadType modelPar_CJORBOT=mod.CJORBOT;
  bool modelPar_given_CJORBOT=mod.given("CJORBOT");
  modParamMap["CJORBOT"] = &modelPar_CJORBOT;
  AdmsSensFadType modelPar_CJORSTI=mod.CJORSTI;
  bool modelPar_given_CJORSTI=mod.given("CJORSTI");
  modParamMap["CJORSTI"] = &modelPar_CJORSTI;
  AdmsSensFadType modelPar_CJORGAT=mod.CJORGAT;
  bool modelPar_given_CJORGAT=mod.given("CJORGAT");
  modParamMap["CJORGAT"] = &modelPar_CJORGAT;
  AdmsSensFadType modelPar_VBIRBOT=mod.VBIRBOT;
  bool modelPar_given_VBIRBOT=mod.given("VBIRBOT");
  modParamMap["VBIRBOT"] = &modelPar_VBIRBOT;
  AdmsSensFadType modelPar_VBIRSTI=mod.VBIRSTI;
  bool modelPar_given_VBIRSTI=mod.given("VBIRSTI");
  modParamMap["VBIRSTI"] = &modelPar_VBIRSTI;
  AdmsSensFadType modelPar_VBIRGAT=mod.VBIRGAT;
  bool modelPar_given_VBIRGAT=mod.given("VBIRGAT");
  modParamMap["VBIRGAT"] = &modelPar_VBIRGAT;
  AdmsSensFadType modelPar_PBOT=mod.PBOT;
  bool modelPar_given_PBOT=mod.given("PBOT");
  modParamMap["PBOT"] = &modelPar_PBOT;
  AdmsSensFadType modelPar_PSTI=mod.PSTI;
  bool modelPar_given_PSTI=mod.given("PSTI");
  modParamMap["PSTI"] = &modelPar_PSTI;
  AdmsSensFadType modelPar_PGAT=mod.PGAT;
  bool modelPar_given_PGAT=mod.given("PGAT");
  modParamMap["PGAT"] = &modelPar_PGAT;
  AdmsSensFadType modelPar_PHIGBOT=mod.PHIGBOT;
  bool modelPar_given_PHIGBOT=mod.given("PHIGBOT");
  modParamMap["PHIGBOT"] = &modelPar_PHIGBOT;
  AdmsSensFadType modelPar_PHIGSTI=mod.PHIGSTI;
  bool modelPar_given_PHIGSTI=mod.given("PHIGSTI");
  modParamMap["PHIGSTI"] = &modelPar_PHIGSTI;
  AdmsSensFadType modelPar_PHIGGAT=mod.PHIGGAT;
  bool modelPar_given_PHIGGAT=mod.given("PHIGGAT");
  modParamMap["PHIGGAT"] = &modelPar_PHIGGAT;
  AdmsSensFadType modelPar_IDSATRBOT=mod.IDSATRBOT;
  bool modelPar_given_IDSATRBOT=mod.given("IDSATRBOT");
  modParamMap["IDSATRBOT"] = &modelPar_IDSATRBOT;
  AdmsSensFadType modelPar_IDSATRSTI=mod.IDSATRSTI;
  bool modelPar_given_IDSATRSTI=mod.given("IDSATRSTI");
  modParamMap["IDSATRSTI"] = &modelPar_IDSATRSTI;
  AdmsSensFadType modelPar_IDSATRGAT=mod.IDSATRGAT;
  bool modelPar_given_IDSATRGAT=mod.given("IDSATRGAT");
  modParamMap["IDSATRGAT"] = &modelPar_IDSATRGAT;
  AdmsSensFadType modelPar_CSRHBOT=mod.CSRHBOT;
  bool modelPar_given_CSRHBOT=mod.given("CSRHBOT");
  modParamMap["CSRHBOT"] = &modelPar_CSRHBOT;
  AdmsSensFadType modelPar_CSRHSTI=mod.CSRHSTI;
  bool modelPar_given_CSRHSTI=mod.given("CSRHSTI");
  modParamMap["CSRHSTI"] = &modelPar_CSRHSTI;
  AdmsSensFadType modelPar_CSRHGAT=mod.CSRHGAT;
  bool modelPar_given_CSRHGAT=mod.given("CSRHGAT");
  modParamMap["CSRHGAT"] = &modelPar_CSRHGAT;
  AdmsSensFadType modelPar_XJUNSTI=mod.XJUNSTI;
  bool modelPar_given_XJUNSTI=mod.given("XJUNSTI");
  modParamMap["XJUNSTI"] = &modelPar_XJUNSTI;
  AdmsSensFadType modelPar_XJUNGAT=mod.XJUNGAT;
  bool modelPar_given_XJUNGAT=mod.given("XJUNGAT");
  modParamMap["XJUNGAT"] = &modelPar_XJUNGAT;
  AdmsSensFadType modelPar_CTATBOT=mod.CTATBOT;
  bool modelPar_given_CTATBOT=mod.given("CTATBOT");
  modParamMap["CTATBOT"] = &modelPar_CTATBOT;
  AdmsSensFadType modelPar_CTATSTI=mod.CTATSTI;
  bool modelPar_given_CTATSTI=mod.given("CTATSTI");
  modParamMap["CTATSTI"] = &modelPar_CTATSTI;
  AdmsSensFadType modelPar_CTATGAT=mod.CTATGAT;
  bool modelPar_given_CTATGAT=mod.given("CTATGAT");
  modParamMap["CTATGAT"] = &modelPar_CTATGAT;
  AdmsSensFadType modelPar_MEFFTATBOT=mod.MEFFTATBOT;
  bool modelPar_given_MEFFTATBOT=mod.given("MEFFTATBOT");
  modParamMap["MEFFTATBOT"] = &modelPar_MEFFTATBOT;
  AdmsSensFadType modelPar_MEFFTATSTI=mod.MEFFTATSTI;
  bool modelPar_given_MEFFTATSTI=mod.given("MEFFTATSTI");
  modParamMap["MEFFTATSTI"] = &modelPar_MEFFTATSTI;
  AdmsSensFadType modelPar_MEFFTATGAT=mod.MEFFTATGAT;
  bool modelPar_given_MEFFTATGAT=mod.given("MEFFTATGAT");
  modParamMap["MEFFTATGAT"] = &modelPar_MEFFTATGAT;
  AdmsSensFadType modelPar_CBBTBOT=mod.CBBTBOT;
  bool modelPar_given_CBBTBOT=mod.given("CBBTBOT");
  modParamMap["CBBTBOT"] = &modelPar_CBBTBOT;
  AdmsSensFadType modelPar_CBBTSTI=mod.CBBTSTI;
  bool modelPar_given_CBBTSTI=mod.given("CBBTSTI");
  modParamMap["CBBTSTI"] = &modelPar_CBBTSTI;
  AdmsSensFadType modelPar_CBBTGAT=mod.CBBTGAT;
  bool modelPar_given_CBBTGAT=mod.given("CBBTGAT");
  modParamMap["CBBTGAT"] = &modelPar_CBBTGAT;
  AdmsSensFadType modelPar_FBBTRBOT=mod.FBBTRBOT;
  bool modelPar_given_FBBTRBOT=mod.given("FBBTRBOT");
  modParamMap["FBBTRBOT"] = &modelPar_FBBTRBOT;
  AdmsSensFadType modelPar_FBBTRSTI=mod.FBBTRSTI;
  bool modelPar_given_FBBTRSTI=mod.given("FBBTRSTI");
  modParamMap["FBBTRSTI"] = &modelPar_FBBTRSTI;
  AdmsSensFadType modelPar_FBBTRGAT=mod.FBBTRGAT;
  bool modelPar_given_FBBTRGAT=mod.given("FBBTRGAT");
  modParamMap["FBBTRGAT"] = &modelPar_FBBTRGAT;
  AdmsSensFadType modelPar_STFBBTBOT=mod.STFBBTBOT;
  bool modelPar_given_STFBBTBOT=mod.given("STFBBTBOT");
  modParamMap["STFBBTBOT"] = &modelPar_STFBBTBOT;
  AdmsSensFadType modelPar_STFBBTSTI=mod.STFBBTSTI;
  bool modelPar_given_STFBBTSTI=mod.given("STFBBTSTI");
  modParamMap["STFBBTSTI"] = &modelPar_STFBBTSTI;
  AdmsSensFadType modelPar_STFBBTGAT=mod.STFBBTGAT;
  bool modelPar_given_STFBBTGAT=mod.given("STFBBTGAT");
  modParamMap["STFBBTGAT"] = &modelPar_STFBBTGAT;
  AdmsSensFadType modelPar_VBRBOT=mod.VBRBOT;
  bool modelPar_given_VBRBOT=mod.given("VBRBOT");
  modParamMap["VBRBOT"] = &modelPar_VBRBOT;
  AdmsSensFadType modelPar_VBRSTI=mod.VBRSTI;
  bool modelPar_given_VBRSTI=mod.given("VBRSTI");
  modParamMap["VBRSTI"] = &modelPar_VBRSTI;
  AdmsSensFadType modelPar_VBRGAT=mod.VBRGAT;
  bool modelPar_given_VBRGAT=mod.given("VBRGAT");
  modParamMap["VBRGAT"] = &modelPar_VBRGAT;
  AdmsSensFadType modelPar_PBRBOT=mod.PBRBOT;
  bool modelPar_given_PBRBOT=mod.given("PBRBOT");
  modParamMap["PBRBOT"] = &modelPar_PBRBOT;
  AdmsSensFadType modelPar_PBRSTI=mod.PBRSTI;
  bool modelPar_given_PBRSTI=mod.given("PBRSTI");
  modParamMap["PBRSTI"] = &modelPar_PBRSTI;
  AdmsSensFadType modelPar_PBRGAT=mod.PBRGAT;
  bool modelPar_given_PBRGAT=mod.given("PBRGAT");
  modParamMap["PBRGAT"] = &modelPar_PBRGAT;
  AdmsSensFadType modelPar_CJORBOTD=mod.CJORBOTD;
  bool modelPar_given_CJORBOTD=mod.given("CJORBOTD");
  modParamMap["CJORBOTD"] = &modelPar_CJORBOTD;
  AdmsSensFadType modelPar_CJORSTID=mod.CJORSTID;
  bool modelPar_given_CJORSTID=mod.given("CJORSTID");
  modParamMap["CJORSTID"] = &modelPar_CJORSTID;
  AdmsSensFadType modelPar_CJORGATD=mod.CJORGATD;
  bool modelPar_given_CJORGATD=mod.given("CJORGATD");
  modParamMap["CJORGATD"] = &modelPar_CJORGATD;
  AdmsSensFadType modelPar_VBIRBOTD=mod.VBIRBOTD;
  bool modelPar_given_VBIRBOTD=mod.given("VBIRBOTD");
  modParamMap["VBIRBOTD"] = &modelPar_VBIRBOTD;
  AdmsSensFadType modelPar_VBIRSTID=mod.VBIRSTID;
  bool modelPar_given_VBIRSTID=mod.given("VBIRSTID");
  modParamMap["VBIRSTID"] = &modelPar_VBIRSTID;
  AdmsSensFadType modelPar_VBIRGATD=mod.VBIRGATD;
  bool modelPar_given_VBIRGATD=mod.given("VBIRGATD");
  modParamMap["VBIRGATD"] = &modelPar_VBIRGATD;
  AdmsSensFadType modelPar_PBOTD=mod.PBOTD;
  bool modelPar_given_PBOTD=mod.given("PBOTD");
  modParamMap["PBOTD"] = &modelPar_PBOTD;
  AdmsSensFadType modelPar_PSTID=mod.PSTID;
  bool modelPar_given_PSTID=mod.given("PSTID");
  modParamMap["PSTID"] = &modelPar_PSTID;
  AdmsSensFadType modelPar_PGATD=mod.PGATD;
  bool modelPar_given_PGATD=mod.given("PGATD");
  modParamMap["PGATD"] = &modelPar_PGATD;
  AdmsSensFadType modelPar_PHIGBOTD=mod.PHIGBOTD;
  bool modelPar_given_PHIGBOTD=mod.given("PHIGBOTD");
  modParamMap["PHIGBOTD"] = &modelPar_PHIGBOTD;
  AdmsSensFadType modelPar_PHIGSTID=mod.PHIGSTID;
  bool modelPar_given_PHIGSTID=mod.given("PHIGSTID");
  modParamMap["PHIGSTID"] = &modelPar_PHIGSTID;
  AdmsSensFadType modelPar_PHIGGATD=mod.PHIGGATD;
  bool modelPar_given_PHIGGATD=mod.given("PHIGGATD");
  modParamMap["PHIGGATD"] = &modelPar_PHIGGATD;
  AdmsSensFadType modelPar_IDSATRBOTD=mod.IDSATRBOTD;
  bool modelPar_given_IDSATRBOTD=mod.given("IDSATRBOTD");
  modParamMap["IDSATRBOTD"] = &modelPar_IDSATRBOTD;
  AdmsSensFadType modelPar_IDSATRSTID=mod.IDSATRSTID;
  bool modelPar_given_IDSATRSTID=mod.given("IDSATRSTID");
  modParamMap["IDSATRSTID"] = &modelPar_IDSATRSTID;
  AdmsSensFadType modelPar_IDSATRGATD=mod.IDSATRGATD;
  bool modelPar_given_IDSATRGATD=mod.given("IDSATRGATD");
  modParamMap["IDSATRGATD"] = &modelPar_IDSATRGATD;
  AdmsSensFadType modelPar_CSRHBOTD=mod.CSRHBOTD;
  bool modelPar_given_CSRHBOTD=mod.given("CSRHBOTD");
  modParamMap["CSRHBOTD"] = &modelPar_CSRHBOTD;
  AdmsSensFadType modelPar_CSRHSTID=mod.CSRHSTID;
  bool modelPar_given_CSRHSTID=mod.given("CSRHSTID");
  modParamMap["CSRHSTID"] = &modelPar_CSRHSTID;
  AdmsSensFadType modelPar_CSRHGATD=mod.CSRHGATD;
  bool modelPar_given_CSRHGATD=mod.given("CSRHGATD");
  modParamMap["CSRHGATD"] = &modelPar_CSRHGATD;
  AdmsSensFadType modelPar_XJUNSTID=mod.XJUNSTID;
  bool modelPar_given_XJUNSTID=mod.given("XJUNSTID");
  modParamMap["XJUNSTID"] = &modelPar_XJUNSTID;
  AdmsSensFadType modelPar_XJUNGATD=mod.XJUNGATD;
  bool modelPar_given_XJUNGATD=mod.given("XJUNGATD");
  modParamMap["XJUNGATD"] = &modelPar_XJUNGATD;
  AdmsSensFadType modelPar_CTATBOTD=mod.CTATBOTD;
  bool modelPar_given_CTATBOTD=mod.given("CTATBOTD");
  modParamMap["CTATBOTD"] = &modelPar_CTATBOTD;
  AdmsSensFadType modelPar_CTATSTID=mod.CTATSTID;
  bool modelPar_given_CTATSTID=mod.given("CTATSTID");
  modParamMap["CTATSTID"] = &modelPar_CTATSTID;
  AdmsSensFadType modelPar_CTATGATD=mod.CTATGATD;
  bool modelPar_given_CTATGATD=mod.given("CTATGATD");
  modParamMap["CTATGATD"] = &modelPar_CTATGATD;
  AdmsSensFadType modelPar_MEFFTATBOTD=mod.MEFFTATBOTD;
  bool modelPar_given_MEFFTATBOTD=mod.given("MEFFTATBOTD");
  modParamMap["MEFFTATBOTD"] = &modelPar_MEFFTATBOTD;
  AdmsSensFadType modelPar_MEFFTATSTID=mod.MEFFTATSTID;
  bool modelPar_given_MEFFTATSTID=mod.given("MEFFTATSTID");
  modParamMap["MEFFTATSTID"] = &modelPar_MEFFTATSTID;
  AdmsSensFadType modelPar_MEFFTATGATD=mod.MEFFTATGATD;
  bool modelPar_given_MEFFTATGATD=mod.given("MEFFTATGATD");
  modParamMap["MEFFTATGATD"] = &modelPar_MEFFTATGATD;
  AdmsSensFadType modelPar_CBBTBOTD=mod.CBBTBOTD;
  bool modelPar_given_CBBTBOTD=mod.given("CBBTBOTD");
  modParamMap["CBBTBOTD"] = &modelPar_CBBTBOTD;
  AdmsSensFadType modelPar_CBBTSTID=mod.CBBTSTID;
  bool modelPar_given_CBBTSTID=mod.given("CBBTSTID");
  modParamMap["CBBTSTID"] = &modelPar_CBBTSTID;
  AdmsSensFadType modelPar_CBBTGATD=mod.CBBTGATD;
  bool modelPar_given_CBBTGATD=mod.given("CBBTGATD");
  modParamMap["CBBTGATD"] = &modelPar_CBBTGATD;
  AdmsSensFadType modelPar_FBBTRBOTD=mod.FBBTRBOTD;
  bool modelPar_given_FBBTRBOTD=mod.given("FBBTRBOTD");
  modParamMap["FBBTRBOTD"] = &modelPar_FBBTRBOTD;
  AdmsSensFadType modelPar_FBBTRSTID=mod.FBBTRSTID;
  bool modelPar_given_FBBTRSTID=mod.given("FBBTRSTID");
  modParamMap["FBBTRSTID"] = &modelPar_FBBTRSTID;
  AdmsSensFadType modelPar_FBBTRGATD=mod.FBBTRGATD;
  bool modelPar_given_FBBTRGATD=mod.given("FBBTRGATD");
  modParamMap["FBBTRGATD"] = &modelPar_FBBTRGATD;
  AdmsSensFadType modelPar_STFBBTBOTD=mod.STFBBTBOTD;
  bool modelPar_given_STFBBTBOTD=mod.given("STFBBTBOTD");
  modParamMap["STFBBTBOTD"] = &modelPar_STFBBTBOTD;
  AdmsSensFadType modelPar_STFBBTSTID=mod.STFBBTSTID;
  bool modelPar_given_STFBBTSTID=mod.given("STFBBTSTID");
  modParamMap["STFBBTSTID"] = &modelPar_STFBBTSTID;
  AdmsSensFadType modelPar_STFBBTGATD=mod.STFBBTGATD;
  bool modelPar_given_STFBBTGATD=mod.given("STFBBTGATD");
  modParamMap["STFBBTGATD"] = &modelPar_STFBBTGATD;
  AdmsSensFadType modelPar_VBRBOTD=mod.VBRBOTD;
  bool modelPar_given_VBRBOTD=mod.given("VBRBOTD");
  modParamMap["VBRBOTD"] = &modelPar_VBRBOTD;
  AdmsSensFadType modelPar_VBRSTID=mod.VBRSTID;
  bool modelPar_given_VBRSTID=mod.given("VBRSTID");
  modParamMap["VBRSTID"] = &modelPar_VBRSTID;
  AdmsSensFadType modelPar_VBRGATD=mod.VBRGATD;
  bool modelPar_given_VBRGATD=mod.given("VBRGATD");
  modParamMap["VBRGATD"] = &modelPar_VBRGATD;
  AdmsSensFadType modelPar_PBRBOTD=mod.PBRBOTD;
  bool modelPar_given_PBRBOTD=mod.given("PBRBOTD");
  modParamMap["PBRBOTD"] = &modelPar_PBRBOTD;
  AdmsSensFadType modelPar_PBRSTID=mod.PBRSTID;
  bool modelPar_given_PBRSTID=mod.given("PBRSTID");
  modParamMap["PBRSTID"] = &modelPar_PBRSTID;
  AdmsSensFadType modelPar_PBRGATD=mod.PBRGATD;
  bool modelPar_given_PBRGATD=mod.given("PBRGATD");
  modParamMap["PBRGATD"] = &modelPar_PBRGATD;
  AdmsSensFadType modelPar_SWJUNEXP=mod.SWJUNEXP;
  bool modelPar_given_SWJUNEXP=mod.given("SWJUNEXP");
  modParamMap["SWJUNEXP"] = &modelPar_SWJUNEXP;
  AdmsSensFadType modelPar_VJUNREF=mod.VJUNREF;
  bool modelPar_given_VJUNREF=mod.given("VJUNREF");
  modParamMap["VJUNREF"] = &modelPar_VJUNREF;
  AdmsSensFadType modelPar_FJUNQ=mod.FJUNQ;
  bool modelPar_given_FJUNQ=mod.given("FJUNQ");
  modParamMap["FJUNQ"] = &modelPar_FJUNQ;
  AdmsSensFadType modelPar_VJUNREFD=mod.VJUNREFD;
  bool modelPar_given_VJUNREFD=mod.given("VJUNREFD");
  modParamMap["VJUNREFD"] = &modelPar_VJUNREFD;
  AdmsSensFadType modelPar_FJUNQD=mod.FJUNQD;
  bool modelPar_given_FJUNQD=mod.given("FJUNQD");
  modParamMap["FJUNQD"] = &modelPar_FJUNQD;


  // hidden reals


  // non-reals (including hiddens)


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals
  AdmsSensFadType modelVar_NSUBO_i=mod.NSUBO_i;
  AdmsSensFadType modelVar_WSEG_i=mod.WSEG_i;
  AdmsSensFadType modelVar_NPCK_i=mod.NPCK_i;
  AdmsSensFadType modelVar_WSEGP_i=mod.WSEGP_i;
  AdmsSensFadType modelVar_LPCK_i=mod.LPCK_i;
  AdmsSensFadType modelVar_LOV_i=mod.LOV_i;
  AdmsSensFadType modelVar_LOVD_i=mod.LOVD_i;
  AdmsSensFadType modelVar_LP1_i=mod.LP1_i;
  AdmsSensFadType modelVar_LP2_i=mod.LP2_i;
  AdmsSensFadType modelVar_WBET_i=mod.WBET_i;
  AdmsSensFadType modelVar_AXL_i=mod.AXL_i;
  AdmsSensFadType modelVar_ALP1L2_i=mod.ALP1L2_i;
  AdmsSensFadType modelVar_ALP2L2_i=mod.ALP2L2_i;
  AdmsSensFadType modelVar_RINT_i=mod.RINT_i;
  AdmsSensFadType modelVar_RVPOLY_i=mod.RVPOLY_i;
  AdmsSensFadType modelVar_SAREF_i=mod.SAREF_i;
  AdmsSensFadType modelVar_SBREF_i=mod.SBREF_i;
  AdmsSensFadType modelVar_KVSAT_i=mod.KVSAT_i;
  AdmsSensFadType modelVar_LLODKUO_i=mod.LLODKUO_i;
  AdmsSensFadType modelVar_WLODKUO_i=mod.WLODKUO_i;
  AdmsSensFadType modelVar_LLODVTH_i=mod.LLODVTH_i;
  AdmsSensFadType modelVar_WLODVTH_i=mod.WLODVTH_i;
  AdmsSensFadType modelVar_LODETAO_i=mod.LODETAO_i;
  AdmsSensFadType modelVar_SCREF_i=mod.SCREF_i;
  AdmsSensFadType modelVar_WEB_i=mod.WEB_i;
  AdmsSensFadType modelVar_WEC_i=mod.WEC_i;
  AdmsSensFadType modelVar_TOX_i=mod.TOX_i;
  AdmsSensFadType modelVar_EPSROX_i=mod.EPSROX_i;
  AdmsSensFadType modelVar_TOXOV_i=mod.TOXOV_i;
  AdmsSensFadType modelVar_TOXOVD_i=mod.TOXOVD_i;
  AdmsSensFadType modelVar_TKD=mod.TKD;
  AdmsSensFadType modelVar_dT=mod.dT;
  AdmsSensFadType modelVar_rT=mod.rT;
  AdmsSensFadType modelVar_rTn=mod.rTn;
  AdmsSensFadType modelVar_EPSSI=mod.EPSSI;
  AdmsSensFadType modelVar_phit=mod.phit;
  AdmsSensFadType modelVar_inv_phit=mod.inv_phit;
  AdmsSensFadType modelVar_Eg=mod.Eg;
  AdmsSensFadType modelVar_phibFac=mod.phibFac;
  AdmsSensFadType modelVar_nt0=mod.nt0;
  AdmsSensFadType modelVar_IMAX_i=mod.IMAX_i;
  AdmsSensFadType modelVar_VBIRBOT_i=mod.VBIRBOT_i;
  AdmsSensFadType modelVar_VBIRSTI_i=mod.VBIRSTI_i;
  AdmsSensFadType modelVar_VBIRGAT_i=mod.VBIRGAT_i;
  AdmsSensFadType modelVar_PBOT_i=mod.PBOT_i;
  AdmsSensFadType modelVar_PSTI_i=mod.PSTI_i;
  AdmsSensFadType modelVar_PGAT_i=mod.PGAT_i;
  AdmsSensFadType modelVar_CSRHBOT_i=mod.CSRHBOT_i;
  AdmsSensFadType modelVar_CSRHSTI_i=mod.CSRHSTI_i;
  AdmsSensFadType modelVar_CSRHGAT_i=mod.CSRHGAT_i;
  AdmsSensFadType modelVar_CTATBOT_i=mod.CTATBOT_i;
  AdmsSensFadType modelVar_CTATSTI_i=mod.CTATSTI_i;
  AdmsSensFadType modelVar_CTATGAT_i=mod.CTATGAT_i;
  AdmsSensFadType modelVar_CBBTBOT_i=mod.CBBTBOT_i;
  AdmsSensFadType modelVar_CBBTSTI_i=mod.CBBTSTI_i;
  AdmsSensFadType modelVar_CBBTGAT_i=mod.CBBTGAT_i;
  AdmsSensFadType modelVar_VBRBOT_i=mod.VBRBOT_i;
  AdmsSensFadType modelVar_VBRSTI_i=mod.VBRSTI_i;
  AdmsSensFadType modelVar_VBRGAT_i=mod.VBRGAT_i;
  AdmsSensFadType modelVar_PBRBOT_i=mod.PBRBOT_i;
  AdmsSensFadType modelVar_PBRSTI_i=mod.PBRSTI_i;
  AdmsSensFadType modelVar_PBRGAT_i=mod.PBRGAT_i;
  AdmsSensFadType modelVar_SWJUNEXP_i=mod.SWJUNEXP_i;
  AdmsSensFadType modelVar_VJUNREF_i=mod.VJUNREF_i;
  AdmsSensFadType modelVar_FJUNQ_i=mod.FJUNQ_i;
  AdmsSensFadType modelVar_phitr=mod.phitr;
  AdmsSensFadType modelVar_phitd=mod.phitd;
  AdmsSensFadType modelVar_phitdinv=mod.phitdinv;
  AdmsSensFadType modelVar_perfc=mod.perfc;
  AdmsSensFadType modelVar_berfc=mod.berfc;
  AdmsSensFadType modelVar_cerfc=mod.cerfc;
  AdmsSensFadType modelVar_ftdbot=mod.ftdbot;
  AdmsSensFadType modelVar_ftdsti=mod.ftdsti;
  AdmsSensFadType modelVar_ftdgat=mod.ftdgat;
  AdmsSensFadType modelVar_idsatbot=mod.idsatbot;
  AdmsSensFadType modelVar_idsatsti=mod.idsatsti;
  AdmsSensFadType modelVar_idsatgat=mod.idsatgat;
  AdmsSensFadType modelVar_vbibot=mod.vbibot;
  AdmsSensFadType modelVar_vbisti=mod.vbisti;
  AdmsSensFadType modelVar_vbigat=mod.vbigat;
  AdmsSensFadType modelVar_vbiinvbot=mod.vbiinvbot;
  AdmsSensFadType modelVar_vbiinvsti=mod.vbiinvsti;
  AdmsSensFadType modelVar_vbiinvgat=mod.vbiinvgat;
  AdmsSensFadType modelVar_one_minus_PBOT=mod.one_minus_PBOT;
  AdmsSensFadType modelVar_one_minus_PSTI=mod.one_minus_PSTI;
  AdmsSensFadType modelVar_one_minus_PGAT=mod.one_minus_PGAT;
  AdmsSensFadType modelVar_one_over_one_minus_PBOT=mod.one_over_one_minus_PBOT;
  AdmsSensFadType modelVar_one_over_one_minus_PSTI=mod.one_over_one_minus_PSTI;
  AdmsSensFadType modelVar_one_over_one_minus_PGAT=mod.one_over_one_minus_PGAT;
  AdmsSensFadType modelVar_cjobot=mod.cjobot;
  AdmsSensFadType modelVar_cjosti=mod.cjosti;
  AdmsSensFadType modelVar_cjogat=mod.cjogat;
  AdmsSensFadType modelVar_qprefbot=mod.qprefbot;
  AdmsSensFadType modelVar_qprefsti=mod.qprefsti;
  AdmsSensFadType modelVar_qprefgat=mod.qprefgat;
  AdmsSensFadType modelVar_qpref2bot=mod.qpref2bot;
  AdmsSensFadType modelVar_qpref2sti=mod.qpref2sti;
  AdmsSensFadType modelVar_qpref2gat=mod.qpref2gat;
  AdmsSensFadType modelVar_wdepnulrbot=mod.wdepnulrbot;
  AdmsSensFadType modelVar_wdepnulrsti=mod.wdepnulrsti;
  AdmsSensFadType modelVar_wdepnulrgat=mod.wdepnulrgat;
  AdmsSensFadType modelVar_wdepnulrinvbot=mod.wdepnulrinvbot;
  AdmsSensFadType modelVar_wdepnulrinvsti=mod.wdepnulrinvsti;
  AdmsSensFadType modelVar_wdepnulrinvgat=mod.wdepnulrinvgat;
  AdmsSensFadType modelVar_VBIRBOTinv=mod.VBIRBOTinv;
  AdmsSensFadType modelVar_VBIRSTIinv=mod.VBIRSTIinv;
  AdmsSensFadType modelVar_VBIRGATinv=mod.VBIRGATinv;
  AdmsSensFadType modelVar_atatbot=mod.atatbot;
  AdmsSensFadType modelVar_atatsti=mod.atatsti;
  AdmsSensFadType modelVar_atatgat=mod.atatgat;
  AdmsSensFadType modelVar_btatpartbot=mod.btatpartbot;
  AdmsSensFadType modelVar_btatpartsti=mod.btatpartsti;
  AdmsSensFadType modelVar_btatpartgat=mod.btatpartgat;
  AdmsSensFadType modelVar_fbbtbot=mod.fbbtbot;
  AdmsSensFadType modelVar_fbbtsti=mod.fbbtsti;
  AdmsSensFadType modelVar_fbbtgat=mod.fbbtgat;
  AdmsSensFadType modelVar_fstopbot=mod.fstopbot;
  AdmsSensFadType modelVar_fstopsti=mod.fstopsti;
  AdmsSensFadType modelVar_fstopgat=mod.fstopgat;
  AdmsSensFadType modelVar_VBRinvbot=mod.VBRinvbot;
  AdmsSensFadType modelVar_VBRinvsti=mod.VBRinvsti;
  AdmsSensFadType modelVar_VBRinvgat=mod.VBRinvgat;
  AdmsSensFadType modelVar_slopebot=mod.slopebot;
  AdmsSensFadType modelVar_slopesti=mod.slopesti;
  AdmsSensFadType modelVar_slopegat=mod.slopegat;
  AdmsSensFadType modelVar_VBIRBOTD_i=mod.VBIRBOTD_i;
  AdmsSensFadType modelVar_VBIRSTID_i=mod.VBIRSTID_i;
  AdmsSensFadType modelVar_VBIRGATD_i=mod.VBIRGATD_i;
  AdmsSensFadType modelVar_PBOTD_i=mod.PBOTD_i;
  AdmsSensFadType modelVar_PSTID_i=mod.PSTID_i;
  AdmsSensFadType modelVar_PGATD_i=mod.PGATD_i;
  AdmsSensFadType modelVar_CSRHBOTD_i=mod.CSRHBOTD_i;
  AdmsSensFadType modelVar_CSRHSTID_i=mod.CSRHSTID_i;
  AdmsSensFadType modelVar_CSRHGATD_i=mod.CSRHGATD_i;
  AdmsSensFadType modelVar_CTATBOTD_i=mod.CTATBOTD_i;
  AdmsSensFadType modelVar_CTATSTID_i=mod.CTATSTID_i;
  AdmsSensFadType modelVar_CTATGATD_i=mod.CTATGATD_i;
  AdmsSensFadType modelVar_CBBTBOTD_i=mod.CBBTBOTD_i;
  AdmsSensFadType modelVar_CBBTSTID_i=mod.CBBTSTID_i;
  AdmsSensFadType modelVar_CBBTGATD_i=mod.CBBTGATD_i;
  AdmsSensFadType modelVar_VBRBOTD_i=mod.VBRBOTD_i;
  AdmsSensFadType modelVar_VBRSTID_i=mod.VBRSTID_i;
  AdmsSensFadType modelVar_VBRGATD_i=mod.VBRGATD_i;
  AdmsSensFadType modelVar_PBRBOTD_i=mod.PBRBOTD_i;
  AdmsSensFadType modelVar_PBRSTID_i=mod.PBRSTID_i;
  AdmsSensFadType modelVar_PBRGATD_i=mod.PBRGATD_i;
  AdmsSensFadType modelVar_VJUNREFD_i=mod.VJUNREFD_i;
  AdmsSensFadType modelVar_FJUNQD_i=mod.FJUNQD_i;
  AdmsSensFadType modelVar_ftdbot_d=mod.ftdbot_d;
  AdmsSensFadType modelVar_ftdsti_d=mod.ftdsti_d;
  AdmsSensFadType modelVar_ftdgat_d=mod.ftdgat_d;
  AdmsSensFadType modelVar_idsatbot_d=mod.idsatbot_d;
  AdmsSensFadType modelVar_idsatsti_d=mod.idsatsti_d;
  AdmsSensFadType modelVar_idsatgat_d=mod.idsatgat_d;
  AdmsSensFadType modelVar_vbibot_d=mod.vbibot_d;
  AdmsSensFadType modelVar_vbisti_d=mod.vbisti_d;
  AdmsSensFadType modelVar_vbigat_d=mod.vbigat_d;
  AdmsSensFadType modelVar_vbiinvbot_d=mod.vbiinvbot_d;
  AdmsSensFadType modelVar_vbiinvsti_d=mod.vbiinvsti_d;
  AdmsSensFadType modelVar_vbiinvgat_d=mod.vbiinvgat_d;
  AdmsSensFadType modelVar_one_minus_PBOT_d=mod.one_minus_PBOT_d;
  AdmsSensFadType modelVar_one_minus_PSTI_d=mod.one_minus_PSTI_d;
  AdmsSensFadType modelVar_one_minus_PGAT_d=mod.one_minus_PGAT_d;
  AdmsSensFadType modelVar_one_over_one_minus_PBOT_d=mod.one_over_one_minus_PBOT_d;
  AdmsSensFadType modelVar_one_over_one_minus_PSTI_d=mod.one_over_one_minus_PSTI_d;
  AdmsSensFadType modelVar_one_over_one_minus_PGAT_d=mod.one_over_one_minus_PGAT_d;
  AdmsSensFadType modelVar_cjobot_d=mod.cjobot_d;
  AdmsSensFadType modelVar_cjosti_d=mod.cjosti_d;
  AdmsSensFadType modelVar_cjogat_d=mod.cjogat_d;
  AdmsSensFadType modelVar_qprefbot_d=mod.qprefbot_d;
  AdmsSensFadType modelVar_qprefsti_d=mod.qprefsti_d;
  AdmsSensFadType modelVar_qprefgat_d=mod.qprefgat_d;
  AdmsSensFadType modelVar_qpref2bot_d=mod.qpref2bot_d;
  AdmsSensFadType modelVar_qpref2sti_d=mod.qpref2sti_d;
  AdmsSensFadType modelVar_qpref2gat_d=mod.qpref2gat_d;
  AdmsSensFadType modelVar_wdepnulrbot_d=mod.wdepnulrbot_d;
  AdmsSensFadType modelVar_wdepnulrsti_d=mod.wdepnulrsti_d;
  AdmsSensFadType modelVar_wdepnulrgat_d=mod.wdepnulrgat_d;
  AdmsSensFadType modelVar_wdepnulrinvbot_d=mod.wdepnulrinvbot_d;
  AdmsSensFadType modelVar_wdepnulrinvsti_d=mod.wdepnulrinvsti_d;
  AdmsSensFadType modelVar_wdepnulrinvgat_d=mod.wdepnulrinvgat_d;
  AdmsSensFadType modelVar_VBIRBOTinv_d=mod.VBIRBOTinv_d;
  AdmsSensFadType modelVar_VBIRSTIinv_d=mod.VBIRSTIinv_d;
  AdmsSensFadType modelVar_VBIRGATinv_d=mod.VBIRGATinv_d;
  AdmsSensFadType modelVar_atatbot_d=mod.atatbot_d;
  AdmsSensFadType modelVar_atatsti_d=mod.atatsti_d;
  AdmsSensFadType modelVar_atatgat_d=mod.atatgat_d;
  AdmsSensFadType modelVar_btatpartbot_d=mod.btatpartbot_d;
  AdmsSensFadType modelVar_btatpartsti_d=mod.btatpartsti_d;
  AdmsSensFadType modelVar_btatpartgat_d=mod.btatpartgat_d;
  AdmsSensFadType modelVar_fbbtbot_d=mod.fbbtbot_d;
  AdmsSensFadType modelVar_fbbtsti_d=mod.fbbtsti_d;
  AdmsSensFadType modelVar_fbbtgat_d=mod.fbbtgat_d;
  AdmsSensFadType modelVar_fstopbot_d=mod.fstopbot_d;
  AdmsSensFadType modelVar_fstopsti_d=mod.fstopsti_d;
  AdmsSensFadType modelVar_fstopgat_d=mod.fstopgat_d;
  AdmsSensFadType modelVar_VBRinvbot_d=mod.VBRinvbot_d;
  AdmsSensFadType modelVar_VBRinvsti_d=mod.VBRinvsti_d;
  AdmsSensFadType modelVar_VBRinvgat_d=mod.VBRinvgat_d;
  AdmsSensFadType modelVar_slopebot_d=mod.slopebot_d;
  AdmsSensFadType modelVar_slopesti_d=mod.slopesti_d;
  AdmsSensFadType modelVar_slopegat_d=mod.slopegat_d;


  // non-reals
  int modelVar_CHNL_TYPE=mod.CHNL_TYPE;



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 11+0 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals
    AdmsSensFadType instancePar_L=in.L;
    bool instancePar_given_L=in.given("L");
    AdmsSensFadType instancePar_W=in.W;
    bool instancePar_given_W=in.given("W");
    AdmsSensFadType instancePar_SA=in.SA;
    bool instancePar_given_SA=in.given("SA");
    AdmsSensFadType instancePar_SB=in.SB;
    bool instancePar_given_SB=in.given("SB");
    AdmsSensFadType instancePar_SD=in.SD;
    bool instancePar_given_SD=in.given("SD");
    AdmsSensFadType instancePar_SCA=in.SCA;
    bool instancePar_given_SCA=in.given("SCA");
    AdmsSensFadType instancePar_SCB=in.SCB;
    bool instancePar_given_SCB=in.given("SCB");
    AdmsSensFadType instancePar_SCC=in.SCC;
    bool instancePar_given_SCC=in.given("SCC");
    AdmsSensFadType instancePar_SC=in.SC;
    bool instancePar_given_SC=in.given("SC");
    AdmsSensFadType instancePar_DELVTO=in.DELVTO;
    bool instancePar_given_DELVTO=in.given("DELVTO");
    AdmsSensFadType instancePar_FACTUO=in.FACTUO;
    bool instancePar_given_FACTUO=in.given("FACTUO");
    AdmsSensFadType instancePar_ABSOURCE=in.ABSOURCE;
    bool instancePar_given_ABSOURCE=in.given("ABSOURCE");
    AdmsSensFadType instancePar_LSSOURCE=in.LSSOURCE;
    bool instancePar_given_LSSOURCE=in.given("LSSOURCE");
    AdmsSensFadType instancePar_LGSOURCE=in.LGSOURCE;
    bool instancePar_given_LGSOURCE=in.given("LGSOURCE");
    AdmsSensFadType instancePar_ABDRAIN=in.ABDRAIN;
    bool instancePar_given_ABDRAIN=in.given("ABDRAIN");
    AdmsSensFadType instancePar_LSDRAIN=in.LSDRAIN;
    bool instancePar_given_LSDRAIN=in.given("LSDRAIN");
    AdmsSensFadType instancePar_LGDRAIN=in.LGDRAIN;
    bool instancePar_given_LGDRAIN=in.given("LGDRAIN");
    AdmsSensFadType instancePar_AS=in.AS;
    bool instancePar_given_AS=in.given("AS");
    AdmsSensFadType instancePar_PS=in.PS;
    bool instancePar_given_PS=in.given("PS");
    AdmsSensFadType instancePar_AD=in.AD;
    bool instancePar_given_AD=in.given("AD");
    AdmsSensFadType instancePar_PD=in.PD;
    bool instancePar_given_PD=in.given("PD");
    AdmsSensFadType instancePar_MULT=in.MULT;
    bool instancePar_given_MULT=in.given("MULT");
    AdmsSensFadType instancePar_NF=in.NF;
    bool instancePar_given_NF=in.given("NF");
    AdmsSensFadType instancePar_NGCON=in.NGCON;
    bool instancePar_given_NGCON=in.given("NGCON");
    AdmsSensFadType instancePar_XGW=in.XGW;
    bool instancePar_given_XGW=in.given("XGW");


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.


    //make local copies of all instance vars
    //reals
    AdmsSensFadType instanceVar_VFB_i=in.VFB_i;
    AdmsSensFadType instanceVar_VNSUB_i=in.VNSUB_i;
    AdmsSensFadType instanceVar_NSLP_i=in.NSLP_i;
    AdmsSensFadType instanceVar_DNSUB_i=in.DNSUB_i;
    AdmsSensFadType instanceVar_CF_i=in.CF_i;
    AdmsSensFadType instanceVar_CFB_i=in.CFB_i;
    AdmsSensFadType instanceVar_MUE_i=in.MUE_i;
    AdmsSensFadType instanceVar_THEMU_i=in.THEMU_i;
    AdmsSensFadType instanceVar_CS_i=in.CS_i;
    AdmsSensFadType instanceVar_XCOR_i=in.XCOR_i;
    AdmsSensFadType instanceVar_THER_i=in.THER_i;
    AdmsSensFadType instanceVar_RSB_i=in.RSB_i;
    AdmsSensFadType instanceVar_RSG_i=in.RSG_i;
    AdmsSensFadType instanceVar_THESAT_i=in.THESAT_i;
    AdmsSensFadType instanceVar_THESATB_i=in.THESATB_i;
    AdmsSensFadType instanceVar_THESATG_i=in.THESATG_i;
    AdmsSensFadType instanceVar_AX_i=in.AX_i;
    AdmsSensFadType instanceVar_ALP_i=in.ALP_i;
    AdmsSensFadType instanceVar_ALP1_i=in.ALP1_i;
    AdmsSensFadType instanceVar_ALP2_i=in.ALP2_i;
    AdmsSensFadType instanceVar_A1_i=in.A1_i;
    AdmsSensFadType instanceVar_A2_i=in.A2_i;
    AdmsSensFadType instanceVar_A3_i=in.A3_i;
    AdmsSensFadType instanceVar_A4_i=in.A4_i;
    AdmsSensFadType instanceVar_IGINV_i=in.IGINV_i;
    AdmsSensFadType instanceVar_IGOV_i=in.IGOV_i;
    AdmsSensFadType instanceVar_IGOVD_i=in.IGOVD_i;
    AdmsSensFadType instanceVar_GC2_i=in.GC2_i;
    AdmsSensFadType instanceVar_GC3_i=in.GC3_i;
    AdmsSensFadType instanceVar_CHIB_i=in.CHIB_i;
    AdmsSensFadType instanceVar_AGIDL_i=in.AGIDL_i;
    AdmsSensFadType instanceVar_CGIDL_i=in.CGIDL_i;
    AdmsSensFadType instanceVar_AGIDLD_i=in.AGIDLD_i;
    AdmsSensFadType instanceVar_CGIDLD_i=in.CGIDLD_i;
    AdmsSensFadType instanceVar_COX_i=in.COX_i;
    AdmsSensFadType instanceVar_CGOV_i=in.CGOV_i;
    AdmsSensFadType instanceVar_CGOVD_i=in.CGOVD_i;
    AdmsSensFadType instanceVar_CGBOV_i=in.CGBOV_i;
    AdmsSensFadType instanceVar_CFR_i=in.CFR_i;
    AdmsSensFadType instanceVar_CFRD_i=in.CFRD_i;
    AdmsSensFadType instanceVar_NFA_i=in.NFA_i;
    AdmsSensFadType instanceVar_NFB_i=in.NFB_i;
    AdmsSensFadType instanceVar_NFC_i=in.NFC_i;
    AdmsSensFadType instanceVar_EF_i=in.EF_i;
    AdmsSensFadType instanceVar_FNTEXC_i=in.FNTEXC_i;
    AdmsSensFadType instanceVar_MULT_i=in.MULT_i;
    AdmsSensFadType instanceVar_BET_i=in.BET_i;
    AdmsSensFadType instanceVar_kp=in.kp;
    AdmsSensFadType instanceVar_qq=in.qq;
    AdmsSensFadType instanceVar_qlim2=in.qlim2;
    AdmsSensFadType instanceVar_E_eff0=in.E_eff0;
    AdmsSensFadType instanceVar_eta_mu=in.eta_mu;
    AdmsSensFadType instanceVar_BCH=in.BCH;
    AdmsSensFadType instanceVar_BOV=in.BOV;
    AdmsSensFadType instanceVar_inv_CHIB=in.inv_CHIB;
    AdmsSensFadType instanceVar_GCQ=in.GCQ;
    AdmsSensFadType instanceVar_Dch=in.Dch;
    AdmsSensFadType instanceVar_Dov=in.Dov;
    AdmsSensFadType instanceVar_x1=in.x1;
    AdmsSensFadType instanceVar_Vdsat_lim=in.Vdsat_lim;
    AdmsSensFadType instanceVar_nt=in.nt;
    AdmsSensFadType instanceVar_Cox_over_q=in.Cox_over_q;
    AdmsSensFadType instanceVar_GOV_s=in.GOV_s;
    AdmsSensFadType instanceVar_GOV_d=in.GOV_d;
    AdmsSensFadType instanceVar_GOV2_s=in.GOV2_s;
    AdmsSensFadType instanceVar_GOV2_d=in.GOV2_d;
    AdmsSensFadType instanceVar_BOV_d=in.BOV_d;
    AdmsSensFadType instanceVar_xi_ov_s=in.xi_ov_s;
    AdmsSensFadType instanceVar_xi_ov_d=in.xi_ov_d;
    AdmsSensFadType instanceVar_inv_xi_ov_s=in.inv_xi_ov_s;
    AdmsSensFadType instanceVar_inv_xi_ov_d=in.inv_xi_ov_d;
    AdmsSensFadType instanceVar_x_mrg_ov_s=in.x_mrg_ov_s;
    AdmsSensFadType instanceVar_x_mrg_ov_d=in.x_mrg_ov_d;
    AdmsSensFadType instanceVar_inv_xg1_s=in.inv_xg1_s;
    AdmsSensFadType instanceVar_inv_xg1_d=in.inv_xg1_d;
    AdmsSensFadType instanceVar_AGIDLs=in.AGIDLs;
    AdmsSensFadType instanceVar_AGIDLDs=in.AGIDLDs;
    AdmsSensFadType instanceVar_BGIDLs=in.BGIDLs;
    AdmsSensFadType instanceVar_BGIDLDs=in.BGIDLDs;
    AdmsSensFadType instanceVar_phib=in.phib;
    AdmsSensFadType instanceVar_sqrt_phib=in.sqrt_phib;
    AdmsSensFadType instanceVar_phix=in.phix;
    AdmsSensFadType instanceVar_aphi=in.aphi;
    AdmsSensFadType instanceVar_bphi=in.bphi;
    AdmsSensFadType instanceVar_phix1=in.phix1;
    AdmsSensFadType instanceVar_G_0=in.G_0;
    AdmsSensFadType instanceVar_phit1=in.phit1;
    AdmsSensFadType instanceVar_inv_phit1=in.inv_phit1;
    AdmsSensFadType instanceVar_alpha_b=in.alpha_b;
    AdmsSensFadType instanceVar_inv_VP=in.inv_VP;
    AdmsSensFadType instanceVar_inv_AX=in.inv_AX;
    AdmsSensFadType instanceVar_Sfl_prefac=in.Sfl_prefac;
    AdmsSensFadType instanceVar_fac_exc=in.fac_exc;
    AdmsSensFadType instanceVar_RG_i=in.RG_i;
    AdmsSensFadType instanceVar_RBULK_i=in.RBULK_i;
    AdmsSensFadType instanceVar_RWELL_i=in.RWELL_i;
    AdmsSensFadType instanceVar_RJUNS_i=in.RJUNS_i;
    AdmsSensFadType instanceVar_RJUND_i=in.RJUND_i;
    AdmsSensFadType instanceVar_ggate=in.ggate;
    AdmsSensFadType instanceVar_gbulk=in.gbulk;
    AdmsSensFadType instanceVar_gwell=in.gwell;
    AdmsSensFadType instanceVar_gjund=in.gjund;
    AdmsSensFadType instanceVar_gjuns=in.gjuns;
    AdmsSensFadType instanceVar_ABSOURCE_i=in.ABSOURCE_i;
    AdmsSensFadType instanceVar_LSSOURCE_i=in.LSSOURCE_i;
    AdmsSensFadType instanceVar_LGSOURCE_i=in.LGSOURCE_i;
    AdmsSensFadType instanceVar_zflagbot_s=in.zflagbot_s;
    AdmsSensFadType instanceVar_zflagsti_s=in.zflagsti_s;
    AdmsSensFadType instanceVar_zflaggat_s=in.zflaggat_s;
    AdmsSensFadType instanceVar_VMAX_s=in.VMAX_s;
    AdmsSensFadType instanceVar_exp_VMAX_over_phitd_s=in.exp_VMAX_over_phitd_s;
    AdmsSensFadType instanceVar_vbimin_s=in.vbimin_s;
    AdmsSensFadType instanceVar_vch_s=in.vch_s;
    AdmsSensFadType instanceVar_vfmin_s=in.vfmin_s;
    AdmsSensFadType instanceVar_vbbtlim_s=in.vbbtlim_s;
    AdmsSensFadType instanceVar_xhighf1_s=in.xhighf1_s;
    AdmsSensFadType instanceVar_expxhf1_s=in.expxhf1_s;
    AdmsSensFadType instanceVar_xhighf2_s=in.xhighf2_s;
    AdmsSensFadType instanceVar_expxhf2_s=in.expxhf2_s;
    AdmsSensFadType instanceVar_xhighr_s=in.xhighr_s;
    AdmsSensFadType instanceVar_expxhr_s=in.expxhr_s;
    AdmsSensFadType instanceVar_m0flag_s=in.m0flag_s;
    AdmsSensFadType instanceVar_ISATFOR1_s=in.ISATFOR1_s;
    AdmsSensFadType instanceVar_MFOR1_s=in.MFOR1_s;
    AdmsSensFadType instanceVar_ISATFOR2_s=in.ISATFOR2_s;
    AdmsSensFadType instanceVar_MFOR2_s=in.MFOR2_s;
    AdmsSensFadType instanceVar_ISATREV_s=in.ISATREV_s;
    AdmsSensFadType instanceVar_MREV_s=in.MREV_s;
    AdmsSensFadType instanceVar_ABDRAIN_i=in.ABDRAIN_i;
    AdmsSensFadType instanceVar_LSDRAIN_i=in.LSDRAIN_i;
    AdmsSensFadType instanceVar_LGDRAIN_i=in.LGDRAIN_i;
    AdmsSensFadType instanceVar_zflagbot_d=in.zflagbot_d;
    AdmsSensFadType instanceVar_zflagsti_d=in.zflagsti_d;
    AdmsSensFadType instanceVar_zflaggat_d=in.zflaggat_d;
    AdmsSensFadType instanceVar_VMAX_d=in.VMAX_d;
    AdmsSensFadType instanceVar_exp_VMAX_over_phitd_d=in.exp_VMAX_over_phitd_d;
    AdmsSensFadType instanceVar_vbimin_d=in.vbimin_d;
    AdmsSensFadType instanceVar_vch_d=in.vch_d;
    AdmsSensFadType instanceVar_vfmin_d=in.vfmin_d;
    AdmsSensFadType instanceVar_vbbtlim_d=in.vbbtlim_d;
    AdmsSensFadType instanceVar_xhighf1_d=in.xhighf1_d;
    AdmsSensFadType instanceVar_expxhf1_d=in.expxhf1_d;
    AdmsSensFadType instanceVar_xhighf2_d=in.xhighf2_d;
    AdmsSensFadType instanceVar_expxhf2_d=in.expxhf2_d;
    AdmsSensFadType instanceVar_xhighr_d=in.xhighr_d;
    AdmsSensFadType instanceVar_expxhr_d=in.expxhr_d;
    AdmsSensFadType instanceVar_m0flag_d=in.m0flag_d;
    AdmsSensFadType instanceVar_ISATFOR1_d=in.ISATFOR1_d;
    AdmsSensFadType instanceVar_MFOR1_d=in.MFOR1_d;
    AdmsSensFadType instanceVar_ISATFOR2_d=in.ISATFOR2_d;
    AdmsSensFadType instanceVar_MFOR2_d=in.MFOR2_d;
    AdmsSensFadType instanceVar_ISATREV_d=in.ISATREV_d;
    AdmsSensFadType instanceVar_MREV_d=in.MREV_d;


    //non-reals



    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_NOI_GND] = (*solVectorPtr)[in.li_NOI];
    probeVars[in.admsProbeID_V_NOI2_GND] = (*solVectorPtr)[in.li_NOI2];
    probeVars[in.admsProbeID_V_D_BD] = (*solVectorPtr)[in.li_D] - (*solVectorPtr)[in.li_BD];
    probeVars[in.admsProbeID_V_S_BS] = (*solVectorPtr)[in.li_S] - (*solVectorPtr)[in.li_BS];
    probeVars[in.admsProbeID_V_S_BP] = (*solVectorPtr)[in.li_S] - (*solVectorPtr)[in.li_BP];
    probeVars[in.admsProbeID_V_D_S] = (*solVectorPtr)[in.li_D] - (*solVectorPtr)[in.li_S];
    probeVars[in.admsProbeID_V_GP_S] = (*solVectorPtr)[in.li_GP] - (*solVectorPtr)[in.li_S];
    probeVars[in.admsProbeID_V_B_BI] = (*solVectorPtr)[in.li_B] - (*solVectorPtr)[in.li_BI];
    probeVars[in.admsProbeID_V_BP_BI] = (*solVectorPtr)[in.li_BP] - (*solVectorPtr)[in.li_BI];
    probeVars[in.admsProbeID_V_BD_BI] = (*solVectorPtr)[in.li_BD] - (*solVectorPtr)[in.li_BI];
    probeVars[in.admsProbeID_V_BS_BI] = (*solVectorPtr)[in.li_BS] - (*solVectorPtr)[in.li_BI];
    probeVars[in.admsProbeID_V_G_GP] = (*solVectorPtr)[in.li_G] - (*solVectorPtr)[in.li_GP];



    // Need to use processParams-like function to process the
    // initial_model block with the LOCAL copies of
    //  model vars, and local copies of model
    // params.
    evaluateInitialModel(
       // model parameters
       // reals
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_TYPE,
       modelPar_given_TYPE,
       modelPar_TR,
       modelPar_given_TR,
       modelPar_SWIGATE,
       modelPar_given_SWIGATE,
       modelPar_SWIMPACT,
       modelPar_given_SWIMPACT,
       modelPar_SWGIDL,
       modelPar_given_SWGIDL,
       modelPar_SWJUNCAP,
       modelPar_given_SWJUNCAP,
       modelPar_SWJUNASYM,
       modelPar_given_SWJUNASYM,
       modelPar_QMC,
       modelPar_given_QMC,
       modelPar_LVARO,
       modelPar_given_LVARO,
       modelPar_LVARL,
       modelPar_given_LVARL,
       modelPar_LVARW,
       modelPar_given_LVARW,
       modelPar_LAP,
       modelPar_given_LAP,
       modelPar_WVARO,
       modelPar_given_WVARO,
       modelPar_WVARL,
       modelPar_given_WVARL,
       modelPar_WVARW,
       modelPar_given_WVARW,
       modelPar_WOT,
       modelPar_given_WOT,
       modelPar_DLQ,
       modelPar_given_DLQ,
       modelPar_DWQ,
       modelPar_given_DWQ,
       modelPar_VFBO,
       modelPar_given_VFBO,
       modelPar_VFBL,
       modelPar_given_VFBL,
       modelPar_VFBW,
       modelPar_given_VFBW,
       modelPar_VFBLW,
       modelPar_given_VFBLW,
       modelPar_STVFBO,
       modelPar_given_STVFBO,
       modelPar_STVFBL,
       modelPar_given_STVFBL,
       modelPar_STVFBW,
       modelPar_given_STVFBW,
       modelPar_STVFBLW,
       modelPar_given_STVFBLW,
       modelPar_TOXO,
       modelPar_given_TOXO,
       modelPar_EPSROXO,
       modelPar_given_EPSROXO,
       modelPar_NSUBO,
       modelPar_given_NSUBO,
       modelPar_NSUBW,
       modelPar_given_NSUBW,
       modelPar_WSEG,
       modelPar_given_WSEG,
       modelPar_NPCK,
       modelPar_given_NPCK,
       modelPar_NPCKW,
       modelPar_given_NPCKW,
       modelPar_WSEGP,
       modelPar_given_WSEGP,
       modelPar_LPCK,
       modelPar_given_LPCK,
       modelPar_LPCKW,
       modelPar_given_LPCKW,
       modelPar_FOL1,
       modelPar_given_FOL1,
       modelPar_FOL2,
       modelPar_given_FOL2,
       modelPar_VNSUBO,
       modelPar_given_VNSUBO,
       modelPar_NSLPO,
       modelPar_given_NSLPO,
       modelPar_DNSUBO,
       modelPar_given_DNSUBO,
       modelPar_DPHIBO,
       modelPar_given_DPHIBO,
       modelPar_DPHIBL,
       modelPar_given_DPHIBL,
       modelPar_DPHIBLEXP,
       modelPar_given_DPHIBLEXP,
       modelPar_DPHIBW,
       modelPar_given_DPHIBW,
       modelPar_DPHIBLW,
       modelPar_given_DPHIBLW,
       modelPar_NPO,
       modelPar_given_NPO,
       modelPar_NPL,
       modelPar_given_NPL,
       modelPar_CTO,
       modelPar_given_CTO,
       modelPar_CTL,
       modelPar_given_CTL,
       modelPar_CTLEXP,
       modelPar_given_CTLEXP,
       modelPar_CTW,
       modelPar_given_CTW,
       modelPar_CTLW,
       modelPar_given_CTLW,
       modelPar_TOXOVO,
       modelPar_given_TOXOVO,
       modelPar_TOXOVDO,
       modelPar_given_TOXOVDO,
       modelPar_LOV,
       modelPar_given_LOV,
       modelPar_LOVD,
       modelPar_given_LOVD,
       modelPar_NOVO,
       modelPar_given_NOVO,
       modelPar_NOVDO,
       modelPar_given_NOVDO,
       modelPar_CFL,
       modelPar_given_CFL,
       modelPar_CFLEXP,
       modelPar_given_CFLEXP,
       modelPar_CFW,
       modelPar_given_CFW,
       modelPar_CFBO,
       modelPar_given_CFBO,
       modelPar_UO,
       modelPar_given_UO,
       modelPar_FBET1,
       modelPar_given_FBET1,
       modelPar_FBET1W,
       modelPar_given_FBET1W,
       modelPar_LP1,
       modelPar_given_LP1,
       modelPar_LP1W,
       modelPar_given_LP1W,
       modelPar_FBET2,
       modelPar_given_FBET2,
       modelPar_LP2,
       modelPar_given_LP2,
       modelPar_BETW1,
       modelPar_given_BETW1,
       modelPar_BETW2,
       modelPar_given_BETW2,
       modelPar_WBET,
       modelPar_given_WBET,
       modelPar_STBETO,
       modelPar_given_STBETO,
       modelPar_STBETL,
       modelPar_given_STBETL,
       modelPar_STBETW,
       modelPar_given_STBETW,
       modelPar_STBETLW,
       modelPar_given_STBETLW,
       modelPar_MUEO,
       modelPar_given_MUEO,
       modelPar_MUEW,
       modelPar_given_MUEW,
       modelPar_STMUEO,
       modelPar_given_STMUEO,
       modelPar_THEMUO,
       modelPar_given_THEMUO,
       modelPar_STTHEMUO,
       modelPar_given_STTHEMUO,
       modelPar_CSO,
       modelPar_given_CSO,
       modelPar_CSL,
       modelPar_given_CSL,
       modelPar_CSLEXP,
       modelPar_given_CSLEXP,
       modelPar_CSW,
       modelPar_given_CSW,
       modelPar_CSLW,
       modelPar_given_CSLW,
       modelPar_STCSO,
       modelPar_given_STCSO,
       modelPar_XCORO,
       modelPar_given_XCORO,
       modelPar_XCORL,
       modelPar_given_XCORL,
       modelPar_XCORW,
       modelPar_given_XCORW,
       modelPar_XCORLW,
       modelPar_given_XCORLW,
       modelPar_STXCORO,
       modelPar_given_STXCORO,
       modelPar_FETAO,
       modelPar_given_FETAO,
       modelPar_RSW1,
       modelPar_given_RSW1,
       modelPar_RSW2,
       modelPar_given_RSW2,
       modelPar_STRSO,
       modelPar_given_STRSO,
       modelPar_RSBO,
       modelPar_given_RSBO,
       modelPar_RSGO,
       modelPar_given_RSGO,
       modelPar_THESATO,
       modelPar_given_THESATO,
       modelPar_THESATL,
       modelPar_given_THESATL,
       modelPar_THESATLEXP,
       modelPar_given_THESATLEXP,
       modelPar_THESATW,
       modelPar_given_THESATW,
       modelPar_THESATLW,
       modelPar_given_THESATLW,
       modelPar_STTHESATO,
       modelPar_given_STTHESATO,
       modelPar_STTHESATL,
       modelPar_given_STTHESATL,
       modelPar_STTHESATW,
       modelPar_given_STTHESATW,
       modelPar_STTHESATLW,
       modelPar_given_STTHESATLW,
       modelPar_THESATBO,
       modelPar_given_THESATBO,
       modelPar_THESATGO,
       modelPar_given_THESATGO,
       modelPar_AXO,
       modelPar_given_AXO,
       modelPar_AXL,
       modelPar_given_AXL,
       modelPar_ALPL,
       modelPar_given_ALPL,
       modelPar_ALPLEXP,
       modelPar_given_ALPLEXP,
       modelPar_ALPW,
       modelPar_given_ALPW,
       modelPar_ALP1L1,
       modelPar_given_ALP1L1,
       modelPar_ALP1LEXP,
       modelPar_given_ALP1LEXP,
       modelPar_ALP1L2,
       modelPar_given_ALP1L2,
       modelPar_ALP1W,
       modelPar_given_ALP1W,
       modelPar_ALP2L1,
       modelPar_given_ALP2L1,
       modelPar_ALP2LEXP,
       modelPar_given_ALP2LEXP,
       modelPar_ALP2L2,
       modelPar_given_ALP2L2,
       modelPar_ALP2W,
       modelPar_given_ALP2W,
       modelPar_VPO,
       modelPar_given_VPO,
       modelPar_A1O,
       modelPar_given_A1O,
       modelPar_A1L,
       modelPar_given_A1L,
       modelPar_A1W,
       modelPar_given_A1W,
       modelPar_A2O,
       modelPar_given_A2O,
       modelPar_STA2O,
       modelPar_given_STA2O,
       modelPar_A3O,
       modelPar_given_A3O,
       modelPar_A3L,
       modelPar_given_A3L,
       modelPar_A3W,
       modelPar_given_A3W,
       modelPar_A4O,
       modelPar_given_A4O,
       modelPar_A4L,
       modelPar_given_A4L,
       modelPar_A4W,
       modelPar_given_A4W,
       modelPar_GCOO,
       modelPar_given_GCOO,
       modelPar_IGINVLW,
       modelPar_given_IGINVLW,
       modelPar_IGOVW,
       modelPar_given_IGOVW,
       modelPar_IGOVDW,
       modelPar_given_IGOVDW,
       modelPar_STIGO,
       modelPar_given_STIGO,
       modelPar_GC2O,
       modelPar_given_GC2O,
       modelPar_GC3O,
       modelPar_given_GC3O,
       modelPar_CHIBO,
       modelPar_given_CHIBO,
       modelPar_AGIDLW,
       modelPar_given_AGIDLW,
       modelPar_AGIDLDW,
       modelPar_given_AGIDLDW,
       modelPar_BGIDLO,
       modelPar_given_BGIDLO,
       modelPar_BGIDLDO,
       modelPar_given_BGIDLDO,
       modelPar_STBGIDLO,
       modelPar_given_STBGIDLO,
       modelPar_STBGIDLDO,
       modelPar_given_STBGIDLDO,
       modelPar_CGIDLO,
       modelPar_given_CGIDLO,
       modelPar_CGIDLDO,
       modelPar_given_CGIDLDO,
       modelPar_CGBOVL,
       modelPar_given_CGBOVL,
       modelPar_CFRW,
       modelPar_given_CFRW,
       modelPar_CFRDW,
       modelPar_given_CFRDW,
       modelPar_FNTO,
       modelPar_given_FNTO,
       modelPar_FNTEXCL,
       modelPar_given_FNTEXCL,
       modelPar_NFALW,
       modelPar_given_NFALW,
       modelPar_NFBLW,
       modelPar_given_NFBLW,
       modelPar_NFCLW,
       modelPar_given_NFCLW,
       modelPar_EFO,
       modelPar_given_EFO,
       modelPar_LINTNOI,
       modelPar_given_LINTNOI,
       modelPar_ALPNOI,
       modelPar_given_ALPNOI,
       modelPar_DTA,
       modelPar_given_DTA,
       modelPar_KVTHOWEO,
       modelPar_given_KVTHOWEO,
       modelPar_KVTHOWEL,
       modelPar_given_KVTHOWEL,
       modelPar_KVTHOWEW,
       modelPar_given_KVTHOWEW,
       modelPar_KVTHOWELW,
       modelPar_given_KVTHOWELW,
       modelPar_KUOWEO,
       modelPar_given_KUOWEO,
       modelPar_KUOWEL,
       modelPar_given_KUOWEL,
       modelPar_KUOWEW,
       modelPar_given_KUOWEW,
       modelPar_KUOWELW,
       modelPar_given_KUOWELW,
       modelPar_LMIN,
       modelPar_given_LMIN,
       modelPar_LMAX,
       modelPar_given_LMAX,
       modelPar_WMIN,
       modelPar_given_WMIN,
       modelPar_WMAX,
       modelPar_given_WMAX,
       modelPar_RGO,
       modelPar_given_RGO,
       modelPar_RBULKO,
       modelPar_given_RBULKO,
       modelPar_RWELLO,
       modelPar_given_RWELLO,
       modelPar_RJUNSO,
       modelPar_given_RJUNSO,
       modelPar_RJUNDO,
       modelPar_given_RJUNDO,
       modelPar_RINT,
       modelPar_given_RINT,
       modelPar_RVPOLY,
       modelPar_given_RVPOLY,
       modelPar_RSHG,
       modelPar_given_RSHG,
       modelPar_DLSIL,
       modelPar_given_DLSIL,
       modelPar_SAREF,
       modelPar_given_SAREF,
       modelPar_SBREF,
       modelPar_given_SBREF,
       modelPar_WLOD,
       modelPar_given_WLOD,
       modelPar_KUO,
       modelPar_given_KUO,
       modelPar_KVSAT,
       modelPar_given_KVSAT,
       modelPar_TKUO,
       modelPar_given_TKUO,
       modelPar_LKUO,
       modelPar_given_LKUO,
       modelPar_WKUO,
       modelPar_given_WKUO,
       modelPar_PKUO,
       modelPar_given_PKUO,
       modelPar_LLODKUO,
       modelPar_given_LLODKUO,
       modelPar_WLODKUO,
       modelPar_given_WLODKUO,
       modelPar_KVTHO,
       modelPar_given_KVTHO,
       modelPar_LKVTHO,
       modelPar_given_LKVTHO,
       modelPar_WKVTHO,
       modelPar_given_WKVTHO,
       modelPar_PKVTHO,
       modelPar_given_PKVTHO,
       modelPar_LLODVTH,
       modelPar_given_LLODVTH,
       modelPar_WLODVTH,
       modelPar_given_WLODVTH,
       modelPar_STETAO,
       modelPar_given_STETAO,
       modelPar_LODETAO,
       modelPar_given_LODETAO,
       modelPar_SCREF,
       modelPar_given_SCREF,
       modelPar_WEB,
       modelPar_given_WEB,
       modelPar_WEC,
       modelPar_given_WEC,
       modelPar_IMAX,
       modelPar_given_IMAX,
       modelPar_TRJ,
       modelPar_given_TRJ,
       modelPar_CJORBOT,
       modelPar_given_CJORBOT,
       modelPar_CJORSTI,
       modelPar_given_CJORSTI,
       modelPar_CJORGAT,
       modelPar_given_CJORGAT,
       modelPar_VBIRBOT,
       modelPar_given_VBIRBOT,
       modelPar_VBIRSTI,
       modelPar_given_VBIRSTI,
       modelPar_VBIRGAT,
       modelPar_given_VBIRGAT,
       modelPar_PBOT,
       modelPar_given_PBOT,
       modelPar_PSTI,
       modelPar_given_PSTI,
       modelPar_PGAT,
       modelPar_given_PGAT,
       modelPar_PHIGBOT,
       modelPar_given_PHIGBOT,
       modelPar_PHIGSTI,
       modelPar_given_PHIGSTI,
       modelPar_PHIGGAT,
       modelPar_given_PHIGGAT,
       modelPar_IDSATRBOT,
       modelPar_given_IDSATRBOT,
       modelPar_IDSATRSTI,
       modelPar_given_IDSATRSTI,
       modelPar_IDSATRGAT,
       modelPar_given_IDSATRGAT,
       modelPar_CSRHBOT,
       modelPar_given_CSRHBOT,
       modelPar_CSRHSTI,
       modelPar_given_CSRHSTI,
       modelPar_CSRHGAT,
       modelPar_given_CSRHGAT,
       modelPar_XJUNSTI,
       modelPar_given_XJUNSTI,
       modelPar_XJUNGAT,
       modelPar_given_XJUNGAT,
       modelPar_CTATBOT,
       modelPar_given_CTATBOT,
       modelPar_CTATSTI,
       modelPar_given_CTATSTI,
       modelPar_CTATGAT,
       modelPar_given_CTATGAT,
       modelPar_MEFFTATBOT,
       modelPar_given_MEFFTATBOT,
       modelPar_MEFFTATSTI,
       modelPar_given_MEFFTATSTI,
       modelPar_MEFFTATGAT,
       modelPar_given_MEFFTATGAT,
       modelPar_CBBTBOT,
       modelPar_given_CBBTBOT,
       modelPar_CBBTSTI,
       modelPar_given_CBBTSTI,
       modelPar_CBBTGAT,
       modelPar_given_CBBTGAT,
       modelPar_FBBTRBOT,
       modelPar_given_FBBTRBOT,
       modelPar_FBBTRSTI,
       modelPar_given_FBBTRSTI,
       modelPar_FBBTRGAT,
       modelPar_given_FBBTRGAT,
       modelPar_STFBBTBOT,
       modelPar_given_STFBBTBOT,
       modelPar_STFBBTSTI,
       modelPar_given_STFBBTSTI,
       modelPar_STFBBTGAT,
       modelPar_given_STFBBTGAT,
       modelPar_VBRBOT,
       modelPar_given_VBRBOT,
       modelPar_VBRSTI,
       modelPar_given_VBRSTI,
       modelPar_VBRGAT,
       modelPar_given_VBRGAT,
       modelPar_PBRBOT,
       modelPar_given_PBRBOT,
       modelPar_PBRSTI,
       modelPar_given_PBRSTI,
       modelPar_PBRGAT,
       modelPar_given_PBRGAT,
       modelPar_CJORBOTD,
       modelPar_given_CJORBOTD,
       modelPar_CJORSTID,
       modelPar_given_CJORSTID,
       modelPar_CJORGATD,
       modelPar_given_CJORGATD,
       modelPar_VBIRBOTD,
       modelPar_given_VBIRBOTD,
       modelPar_VBIRSTID,
       modelPar_given_VBIRSTID,
       modelPar_VBIRGATD,
       modelPar_given_VBIRGATD,
       modelPar_PBOTD,
       modelPar_given_PBOTD,
       modelPar_PSTID,
       modelPar_given_PSTID,
       modelPar_PGATD,
       modelPar_given_PGATD,
       modelPar_PHIGBOTD,
       modelPar_given_PHIGBOTD,
       modelPar_PHIGSTID,
       modelPar_given_PHIGSTID,
       modelPar_PHIGGATD,
       modelPar_given_PHIGGATD,
       modelPar_IDSATRBOTD,
       modelPar_given_IDSATRBOTD,
       modelPar_IDSATRSTID,
       modelPar_given_IDSATRSTID,
       modelPar_IDSATRGATD,
       modelPar_given_IDSATRGATD,
       modelPar_CSRHBOTD,
       modelPar_given_CSRHBOTD,
       modelPar_CSRHSTID,
       modelPar_given_CSRHSTID,
       modelPar_CSRHGATD,
       modelPar_given_CSRHGATD,
       modelPar_XJUNSTID,
       modelPar_given_XJUNSTID,
       modelPar_XJUNGATD,
       modelPar_given_XJUNGATD,
       modelPar_CTATBOTD,
       modelPar_given_CTATBOTD,
       modelPar_CTATSTID,
       modelPar_given_CTATSTID,
       modelPar_CTATGATD,
       modelPar_given_CTATGATD,
       modelPar_MEFFTATBOTD,
       modelPar_given_MEFFTATBOTD,
       modelPar_MEFFTATSTID,
       modelPar_given_MEFFTATSTID,
       modelPar_MEFFTATGATD,
       modelPar_given_MEFFTATGATD,
       modelPar_CBBTBOTD,
       modelPar_given_CBBTBOTD,
       modelPar_CBBTSTID,
       modelPar_given_CBBTSTID,
       modelPar_CBBTGATD,
       modelPar_given_CBBTGATD,
       modelPar_FBBTRBOTD,
       modelPar_given_FBBTRBOTD,
       modelPar_FBBTRSTID,
       modelPar_given_FBBTRSTID,
       modelPar_FBBTRGATD,
       modelPar_given_FBBTRGATD,
       modelPar_STFBBTBOTD,
       modelPar_given_STFBBTBOTD,
       modelPar_STFBBTSTID,
       modelPar_given_STFBBTSTID,
       modelPar_STFBBTGATD,
       modelPar_given_STFBBTGATD,
       modelPar_VBRBOTD,
       modelPar_given_VBRBOTD,
       modelPar_VBRSTID,
       modelPar_given_VBRSTID,
       modelPar_VBRGATD,
       modelPar_given_VBRGATD,
       modelPar_PBRBOTD,
       modelPar_given_PBRBOTD,
       modelPar_PBRSTID,
       modelPar_given_PBRSTID,
       modelPar_PBRGATD,
       modelPar_given_PBRGATD,
       modelPar_SWJUNEXP,
       modelPar_given_SWJUNEXP,
       modelPar_VJUNREF,
       modelPar_given_VJUNREF,
       modelPar_FJUNQ,
       modelPar_given_FJUNQ,
       modelPar_VJUNREFD,
       modelPar_given_VJUNREFD,
       modelPar_FJUNQD,
       modelPar_given_FJUNQD// model variables
       ,
       // reals
       modelVar_NSUBO_i,
       modelVar_WSEG_i,
       modelVar_NPCK_i,
       modelVar_WSEGP_i,
       modelVar_LPCK_i,
       modelVar_LOV_i,
       modelVar_LOVD_i,
       modelVar_LP1_i,
       modelVar_LP2_i,
       modelVar_WBET_i,
       modelVar_AXL_i,
       modelVar_ALP1L2_i,
       modelVar_ALP2L2_i,
       modelVar_RINT_i,
       modelVar_RVPOLY_i,
       modelVar_SAREF_i,
       modelVar_SBREF_i,
       modelVar_KVSAT_i,
       modelVar_LLODKUO_i,
       modelVar_WLODKUO_i,
       modelVar_LLODVTH_i,
       modelVar_WLODVTH_i,
       modelVar_LODETAO_i,
       modelVar_SCREF_i,
       modelVar_WEB_i,
       modelVar_WEC_i,
       modelVar_TOX_i,
       modelVar_EPSROX_i,
       modelVar_TOXOV_i,
       modelVar_TOXOVD_i,
       modelVar_TKD,
       modelVar_dT,
       modelVar_rT,
       modelVar_rTn,
       modelVar_EPSSI,
       modelVar_phit,
       modelVar_inv_phit,
       modelVar_Eg,
       modelVar_phibFac,
       modelVar_nt0,
       modelVar_IMAX_i,
       modelVar_VBIRBOT_i,
       modelVar_VBIRSTI_i,
       modelVar_VBIRGAT_i,
       modelVar_PBOT_i,
       modelVar_PSTI_i,
       modelVar_PGAT_i,
       modelVar_CSRHBOT_i,
       modelVar_CSRHSTI_i,
       modelVar_CSRHGAT_i,
       modelVar_CTATBOT_i,
       modelVar_CTATSTI_i,
       modelVar_CTATGAT_i,
       modelVar_CBBTBOT_i,
       modelVar_CBBTSTI_i,
       modelVar_CBBTGAT_i,
       modelVar_VBRBOT_i,
       modelVar_VBRSTI_i,
       modelVar_VBRGAT_i,
       modelVar_PBRBOT_i,
       modelVar_PBRSTI_i,
       modelVar_PBRGAT_i,
       modelVar_SWJUNEXP_i,
       modelVar_VJUNREF_i,
       modelVar_FJUNQ_i,
       modelVar_phitr,
       modelVar_phitd,
       modelVar_phitdinv,
       modelVar_perfc,
       modelVar_berfc,
       modelVar_cerfc,
       modelVar_ftdbot,
       modelVar_ftdsti,
       modelVar_ftdgat,
       modelVar_idsatbot,
       modelVar_idsatsti,
       modelVar_idsatgat,
       modelVar_vbibot,
       modelVar_vbisti,
       modelVar_vbigat,
       modelVar_vbiinvbot,
       modelVar_vbiinvsti,
       modelVar_vbiinvgat,
       modelVar_one_minus_PBOT,
       modelVar_one_minus_PSTI,
       modelVar_one_minus_PGAT,
       modelVar_one_over_one_minus_PBOT,
       modelVar_one_over_one_minus_PSTI,
       modelVar_one_over_one_minus_PGAT,
       modelVar_cjobot,
       modelVar_cjosti,
       modelVar_cjogat,
       modelVar_qprefbot,
       modelVar_qprefsti,
       modelVar_qprefgat,
       modelVar_qpref2bot,
       modelVar_qpref2sti,
       modelVar_qpref2gat,
       modelVar_wdepnulrbot,
       modelVar_wdepnulrsti,
       modelVar_wdepnulrgat,
       modelVar_wdepnulrinvbot,
       modelVar_wdepnulrinvsti,
       modelVar_wdepnulrinvgat,
       modelVar_VBIRBOTinv,
       modelVar_VBIRSTIinv,
       modelVar_VBIRGATinv,
       modelVar_atatbot,
       modelVar_atatsti,
       modelVar_atatgat,
       modelVar_btatpartbot,
       modelVar_btatpartsti,
       modelVar_btatpartgat,
       modelVar_fbbtbot,
       modelVar_fbbtsti,
       modelVar_fbbtgat,
       modelVar_fstopbot,
       modelVar_fstopsti,
       modelVar_fstopgat,
       modelVar_VBRinvbot,
       modelVar_VBRinvsti,
       modelVar_VBRinvgat,
       modelVar_slopebot,
       modelVar_slopesti,
       modelVar_slopegat,
       modelVar_VBIRBOTD_i,
       modelVar_VBIRSTID_i,
       modelVar_VBIRGATD_i,
       modelVar_PBOTD_i,
       modelVar_PSTID_i,
       modelVar_PGATD_i,
       modelVar_CSRHBOTD_i,
       modelVar_CSRHSTID_i,
       modelVar_CSRHGATD_i,
       modelVar_CTATBOTD_i,
       modelVar_CTATSTID_i,
       modelVar_CTATGATD_i,
       modelVar_CBBTBOTD_i,
       modelVar_CBBTSTID_i,
       modelVar_CBBTGATD_i,
       modelVar_VBRBOTD_i,
       modelVar_VBRSTID_i,
       modelVar_VBRGATD_i,
       modelVar_PBRBOTD_i,
       modelVar_PBRSTID_i,
       modelVar_PBRGATD_i,
       modelVar_VJUNREFD_i,
       modelVar_FJUNQD_i,
       modelVar_ftdbot_d,
       modelVar_ftdsti_d,
       modelVar_ftdgat_d,
       modelVar_idsatbot_d,
       modelVar_idsatsti_d,
       modelVar_idsatgat_d,
       modelVar_vbibot_d,
       modelVar_vbisti_d,
       modelVar_vbigat_d,
       modelVar_vbiinvbot_d,
       modelVar_vbiinvsti_d,
       modelVar_vbiinvgat_d,
       modelVar_one_minus_PBOT_d,
       modelVar_one_minus_PSTI_d,
       modelVar_one_minus_PGAT_d,
       modelVar_one_over_one_minus_PBOT_d,
       modelVar_one_over_one_minus_PSTI_d,
       modelVar_one_over_one_minus_PGAT_d,
       modelVar_cjobot_d,
       modelVar_cjosti_d,
       modelVar_cjogat_d,
       modelVar_qprefbot_d,
       modelVar_qprefsti_d,
       modelVar_qprefgat_d,
       modelVar_qpref2bot_d,
       modelVar_qpref2sti_d,
       modelVar_qpref2gat_d,
       modelVar_wdepnulrbot_d,
       modelVar_wdepnulrsti_d,
       modelVar_wdepnulrgat_d,
       modelVar_wdepnulrinvbot_d,
       modelVar_wdepnulrinvsti_d,
       modelVar_wdepnulrinvgat_d,
       modelVar_VBIRBOTinv_d,
       modelVar_VBIRSTIinv_d,
       modelVar_VBIRGATinv_d,
       modelVar_atatbot_d,
       modelVar_atatsti_d,
       modelVar_atatgat_d,
       modelVar_btatpartbot_d,
       modelVar_btatpartsti_d,
       modelVar_btatpartgat_d,
       modelVar_fbbtbot_d,
       modelVar_fbbtsti_d,
       modelVar_fbbtgat_d,
       modelVar_fstopbot_d,
       modelVar_fstopsti_d,
       modelVar_fstopgat_d,
       modelVar_VBRinvbot_d,
       modelVar_VBRinvsti_d,
       modelVar_VBRinvgat_d,
       modelVar_slopebot_d,
       modelVar_slopesti_d,
       modelVar_slopegat_d,
       // non-reals
       modelVar_CHNL_TYPE,
       mod.admsModTemp,in.getDeviceOptions().gmin,in);
    evaluateInitialInstance(
       // instance parameters
       // reals
       instancePar_L,
       instancePar_given_L,
       instancePar_W,
       instancePar_given_W,
       instancePar_SA,
       instancePar_given_SA,
       instancePar_SB,
       instancePar_given_SB,
       instancePar_SD,
       instancePar_given_SD,
       instancePar_SCA,
       instancePar_given_SCA,
       instancePar_SCB,
       instancePar_given_SCB,
       instancePar_SCC,
       instancePar_given_SCC,
       instancePar_SC,
       instancePar_given_SC,
       instancePar_DELVTO,
       instancePar_given_DELVTO,
       instancePar_FACTUO,
       instancePar_given_FACTUO,
       instancePar_ABSOURCE,
       instancePar_given_ABSOURCE,
       instancePar_LSSOURCE,
       instancePar_given_LSSOURCE,
       instancePar_LGSOURCE,
       instancePar_given_LGSOURCE,
       instancePar_ABDRAIN,
       instancePar_given_ABDRAIN,
       instancePar_LSDRAIN,
       instancePar_given_LSDRAIN,
       instancePar_LGDRAIN,
       instancePar_given_LGDRAIN,
       instancePar_AS,
       instancePar_given_AS,
       instancePar_PS,
       instancePar_given_PS,
       instancePar_AD,
       instancePar_given_AD,
       instancePar_PD,
       instancePar_given_PD,
       instancePar_MULT,
       instancePar_given_MULT,
       instancePar_NF,
       instancePar_given_NF,
       instancePar_NGCON,
       instancePar_given_NGCON,
       instancePar_XGW,
       instancePar_given_XGW,
       // instance variables
       // reals
       instanceVar_VFB_i,
       instanceVar_VNSUB_i,
       instanceVar_NSLP_i,
       instanceVar_DNSUB_i,
       instanceVar_CF_i,
       instanceVar_CFB_i,
       instanceVar_MUE_i,
       instanceVar_THEMU_i,
       instanceVar_CS_i,
       instanceVar_XCOR_i,
       instanceVar_THER_i,
       instanceVar_RSB_i,
       instanceVar_RSG_i,
       instanceVar_THESAT_i,
       instanceVar_THESATB_i,
       instanceVar_THESATG_i,
       instanceVar_AX_i,
       instanceVar_ALP_i,
       instanceVar_ALP1_i,
       instanceVar_ALP2_i,
       instanceVar_A1_i,
       instanceVar_A2_i,
       instanceVar_A3_i,
       instanceVar_A4_i,
       instanceVar_IGINV_i,
       instanceVar_IGOV_i,
       instanceVar_IGOVD_i,
       instanceVar_GC2_i,
       instanceVar_GC3_i,
       instanceVar_CHIB_i,
       instanceVar_AGIDL_i,
       instanceVar_CGIDL_i,
       instanceVar_AGIDLD_i,
       instanceVar_CGIDLD_i,
       instanceVar_COX_i,
       instanceVar_CGOV_i,
       instanceVar_CGOVD_i,
       instanceVar_CGBOV_i,
       instanceVar_CFR_i,
       instanceVar_CFRD_i,
       instanceVar_NFA_i,
       instanceVar_NFB_i,
       instanceVar_NFC_i,
       instanceVar_EF_i,
       instanceVar_FNTEXC_i,
       instanceVar_MULT_i,
       instanceVar_BET_i,
       instanceVar_kp,
       instanceVar_qq,
       instanceVar_qlim2,
       instanceVar_E_eff0,
       instanceVar_eta_mu,
       instanceVar_BCH,
       instanceVar_BOV,
       instanceVar_inv_CHIB,
       instanceVar_GCQ,
       instanceVar_Dch,
       instanceVar_Dov,
       instanceVar_x1,
       instanceVar_Vdsat_lim,
       instanceVar_nt,
       instanceVar_Cox_over_q,
       instanceVar_GOV_s,
       instanceVar_GOV_d,
       instanceVar_GOV2_s,
       instanceVar_GOV2_d,
       instanceVar_BOV_d,
       instanceVar_xi_ov_s,
       instanceVar_xi_ov_d,
       instanceVar_inv_xi_ov_s,
       instanceVar_inv_xi_ov_d,
       instanceVar_x_mrg_ov_s,
       instanceVar_x_mrg_ov_d,
       instanceVar_inv_xg1_s,
       instanceVar_inv_xg1_d,
       instanceVar_AGIDLs,
       instanceVar_AGIDLDs,
       instanceVar_BGIDLs,
       instanceVar_BGIDLDs,
       instanceVar_phib,
       instanceVar_sqrt_phib,
       instanceVar_phix,
       instanceVar_aphi,
       instanceVar_bphi,
       instanceVar_phix1,
       instanceVar_G_0,
       instanceVar_phit1,
       instanceVar_inv_phit1,
       instanceVar_alpha_b,
       instanceVar_inv_VP,
       instanceVar_inv_AX,
       instanceVar_Sfl_prefac,
       instanceVar_fac_exc,
       instanceVar_RG_i,
       instanceVar_RBULK_i,
       instanceVar_RWELL_i,
       instanceVar_RJUNS_i,
       instanceVar_RJUND_i,
       instanceVar_ggate,
       instanceVar_gbulk,
       instanceVar_gwell,
       instanceVar_gjund,
       instanceVar_gjuns,
       instanceVar_ABSOURCE_i,
       instanceVar_LSSOURCE_i,
       instanceVar_LGSOURCE_i,
       instanceVar_zflagbot_s,
       instanceVar_zflagsti_s,
       instanceVar_zflaggat_s,
       instanceVar_VMAX_s,
       instanceVar_exp_VMAX_over_phitd_s,
       instanceVar_vbimin_s,
       instanceVar_vch_s,
       instanceVar_vfmin_s,
       instanceVar_vbbtlim_s,
       instanceVar_xhighf1_s,
       instanceVar_expxhf1_s,
       instanceVar_xhighf2_s,
       instanceVar_expxhf2_s,
       instanceVar_xhighr_s,
       instanceVar_expxhr_s,
       instanceVar_m0flag_s,
       instanceVar_ISATFOR1_s,
       instanceVar_MFOR1_s,
       instanceVar_ISATFOR2_s,
       instanceVar_MFOR2_s,
       instanceVar_ISATREV_s,
       instanceVar_MREV_s,
       instanceVar_ABDRAIN_i,
       instanceVar_LSDRAIN_i,
       instanceVar_LGDRAIN_i,
       instanceVar_zflagbot_d,
       instanceVar_zflagsti_d,
       instanceVar_zflaggat_d,
       instanceVar_VMAX_d,
       instanceVar_exp_VMAX_over_phitd_d,
       instanceVar_vbimin_d,
       instanceVar_vch_d,
       instanceVar_vfmin_d,
       instanceVar_vbbtlim_d,
       instanceVar_xhighf1_d,
       instanceVar_expxhf1_d,
       instanceVar_xhighf2_d,
       instanceVar_expxhf2_d,
       instanceVar_xhighr_d,
       instanceVar_expxhr_d,
       instanceVar_m0flag_d,
       instanceVar_ISATFOR1_d,
       instanceVar_MFOR1_d,
       instanceVar_ISATFOR2_d,
       instanceVar_MFOR2_d,
       instanceVar_ISATREV_d,
       instanceVar_MREV_d,
       // model parameters
       // reals
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_TYPE,
       modelPar_given_TYPE,
       modelPar_TR,
       modelPar_given_TR,
       modelPar_SWIGATE,
       modelPar_given_SWIGATE,
       modelPar_SWIMPACT,
       modelPar_given_SWIMPACT,
       modelPar_SWGIDL,
       modelPar_given_SWGIDL,
       modelPar_SWJUNCAP,
       modelPar_given_SWJUNCAP,
       modelPar_SWJUNASYM,
       modelPar_given_SWJUNASYM,
       modelPar_QMC,
       modelPar_given_QMC,
       modelPar_LVARO,
       modelPar_given_LVARO,
       modelPar_LVARL,
       modelPar_given_LVARL,
       modelPar_LVARW,
       modelPar_given_LVARW,
       modelPar_LAP,
       modelPar_given_LAP,
       modelPar_WVARO,
       modelPar_given_WVARO,
       modelPar_WVARL,
       modelPar_given_WVARL,
       modelPar_WVARW,
       modelPar_given_WVARW,
       modelPar_WOT,
       modelPar_given_WOT,
       modelPar_DLQ,
       modelPar_given_DLQ,
       modelPar_DWQ,
       modelPar_given_DWQ,
       modelPar_VFBO,
       modelPar_given_VFBO,
       modelPar_VFBL,
       modelPar_given_VFBL,
       modelPar_VFBW,
       modelPar_given_VFBW,
       modelPar_VFBLW,
       modelPar_given_VFBLW,
       modelPar_STVFBO,
       modelPar_given_STVFBO,
       modelPar_STVFBL,
       modelPar_given_STVFBL,
       modelPar_STVFBW,
       modelPar_given_STVFBW,
       modelPar_STVFBLW,
       modelPar_given_STVFBLW,
       modelPar_TOXO,
       modelPar_given_TOXO,
       modelPar_EPSROXO,
       modelPar_given_EPSROXO,
       modelPar_NSUBO,
       modelPar_given_NSUBO,
       modelPar_NSUBW,
       modelPar_given_NSUBW,
       modelPar_WSEG,
       modelPar_given_WSEG,
       modelPar_NPCK,
       modelPar_given_NPCK,
       modelPar_NPCKW,
       modelPar_given_NPCKW,
       modelPar_WSEGP,
       modelPar_given_WSEGP,
       modelPar_LPCK,
       modelPar_given_LPCK,
       modelPar_LPCKW,
       modelPar_given_LPCKW,
       modelPar_FOL1,
       modelPar_given_FOL1,
       modelPar_FOL2,
       modelPar_given_FOL2,
       modelPar_VNSUBO,
       modelPar_given_VNSUBO,
       modelPar_NSLPO,
       modelPar_given_NSLPO,
       modelPar_DNSUBO,
       modelPar_given_DNSUBO,
       modelPar_DPHIBO,
       modelPar_given_DPHIBO,
       modelPar_DPHIBL,
       modelPar_given_DPHIBL,
       modelPar_DPHIBLEXP,
       modelPar_given_DPHIBLEXP,
       modelPar_DPHIBW,
       modelPar_given_DPHIBW,
       modelPar_DPHIBLW,
       modelPar_given_DPHIBLW,
       modelPar_NPO,
       modelPar_given_NPO,
       modelPar_NPL,
       modelPar_given_NPL,
       modelPar_CTO,
       modelPar_given_CTO,
       modelPar_CTL,
       modelPar_given_CTL,
       modelPar_CTLEXP,
       modelPar_given_CTLEXP,
       modelPar_CTW,
       modelPar_given_CTW,
       modelPar_CTLW,
       modelPar_given_CTLW,
       modelPar_TOXOVO,
       modelPar_given_TOXOVO,
       modelPar_TOXOVDO,
       modelPar_given_TOXOVDO,
       modelPar_LOV,
       modelPar_given_LOV,
       modelPar_LOVD,
       modelPar_given_LOVD,
       modelPar_NOVO,
       modelPar_given_NOVO,
       modelPar_NOVDO,
       modelPar_given_NOVDO,
       modelPar_CFL,
       modelPar_given_CFL,
       modelPar_CFLEXP,
       modelPar_given_CFLEXP,
       modelPar_CFW,
       modelPar_given_CFW,
       modelPar_CFBO,
       modelPar_given_CFBO,
       modelPar_UO,
       modelPar_given_UO,
       modelPar_FBET1,
       modelPar_given_FBET1,
       modelPar_FBET1W,
       modelPar_given_FBET1W,
       modelPar_LP1,
       modelPar_given_LP1,
       modelPar_LP1W,
       modelPar_given_LP1W,
       modelPar_FBET2,
       modelPar_given_FBET2,
       modelPar_LP2,
       modelPar_given_LP2,
       modelPar_BETW1,
       modelPar_given_BETW1,
       modelPar_BETW2,
       modelPar_given_BETW2,
       modelPar_WBET,
       modelPar_given_WBET,
       modelPar_STBETO,
       modelPar_given_STBETO,
       modelPar_STBETL,
       modelPar_given_STBETL,
       modelPar_STBETW,
       modelPar_given_STBETW,
       modelPar_STBETLW,
       modelPar_given_STBETLW,
       modelPar_MUEO,
       modelPar_given_MUEO,
       modelPar_MUEW,
       modelPar_given_MUEW,
       modelPar_STMUEO,
       modelPar_given_STMUEO,
       modelPar_THEMUO,
       modelPar_given_THEMUO,
       modelPar_STTHEMUO,
       modelPar_given_STTHEMUO,
       modelPar_CSO,
       modelPar_given_CSO,
       modelPar_CSL,
       modelPar_given_CSL,
       modelPar_CSLEXP,
       modelPar_given_CSLEXP,
       modelPar_CSW,
       modelPar_given_CSW,
       modelPar_CSLW,
       modelPar_given_CSLW,
       modelPar_STCSO,
       modelPar_given_STCSO,
       modelPar_XCORO,
       modelPar_given_XCORO,
       modelPar_XCORL,
       modelPar_given_XCORL,
       modelPar_XCORW,
       modelPar_given_XCORW,
       modelPar_XCORLW,
       modelPar_given_XCORLW,
       modelPar_STXCORO,
       modelPar_given_STXCORO,
       modelPar_FETAO,
       modelPar_given_FETAO,
       modelPar_RSW1,
       modelPar_given_RSW1,
       modelPar_RSW2,
       modelPar_given_RSW2,
       modelPar_STRSO,
       modelPar_given_STRSO,
       modelPar_RSBO,
       modelPar_given_RSBO,
       modelPar_RSGO,
       modelPar_given_RSGO,
       modelPar_THESATO,
       modelPar_given_THESATO,
       modelPar_THESATL,
       modelPar_given_THESATL,
       modelPar_THESATLEXP,
       modelPar_given_THESATLEXP,
       modelPar_THESATW,
       modelPar_given_THESATW,
       modelPar_THESATLW,
       modelPar_given_THESATLW,
       modelPar_STTHESATO,
       modelPar_given_STTHESATO,
       modelPar_STTHESATL,
       modelPar_given_STTHESATL,
       modelPar_STTHESATW,
       modelPar_given_STTHESATW,
       modelPar_STTHESATLW,
       modelPar_given_STTHESATLW,
       modelPar_THESATBO,
       modelPar_given_THESATBO,
       modelPar_THESATGO,
       modelPar_given_THESATGO,
       modelPar_AXO,
       modelPar_given_AXO,
       modelPar_AXL,
       modelPar_given_AXL,
       modelPar_ALPL,
       modelPar_given_ALPL,
       modelPar_ALPLEXP,
       modelPar_given_ALPLEXP,
       modelPar_ALPW,
       modelPar_given_ALPW,
       modelPar_ALP1L1,
       modelPar_given_ALP1L1,
       modelPar_ALP1LEXP,
       modelPar_given_ALP1LEXP,
       modelPar_ALP1L2,
       modelPar_given_ALP1L2,
       modelPar_ALP1W,
       modelPar_given_ALP1W,
       modelPar_ALP2L1,
       modelPar_given_ALP2L1,
       modelPar_ALP2LEXP,
       modelPar_given_ALP2LEXP,
       modelPar_ALP2L2,
       modelPar_given_ALP2L2,
       modelPar_ALP2W,
       modelPar_given_ALP2W,
       modelPar_VPO,
       modelPar_given_VPO,
       modelPar_A1O,
       modelPar_given_A1O,
       modelPar_A1L,
       modelPar_given_A1L,
       modelPar_A1W,
       modelPar_given_A1W,
       modelPar_A2O,
       modelPar_given_A2O,
       modelPar_STA2O,
       modelPar_given_STA2O,
       modelPar_A3O,
       modelPar_given_A3O,
       modelPar_A3L,
       modelPar_given_A3L,
       modelPar_A3W,
       modelPar_given_A3W,
       modelPar_A4O,
       modelPar_given_A4O,
       modelPar_A4L,
       modelPar_given_A4L,
       modelPar_A4W,
       modelPar_given_A4W,
       modelPar_GCOO,
       modelPar_given_GCOO,
       modelPar_IGINVLW,
       modelPar_given_IGINVLW,
       modelPar_IGOVW,
       modelPar_given_IGOVW,
       modelPar_IGOVDW,
       modelPar_given_IGOVDW,
       modelPar_STIGO,
       modelPar_given_STIGO,
       modelPar_GC2O,
       modelPar_given_GC2O,
       modelPar_GC3O,
       modelPar_given_GC3O,
       modelPar_CHIBO,
       modelPar_given_CHIBO,
       modelPar_AGIDLW,
       modelPar_given_AGIDLW,
       modelPar_AGIDLDW,
       modelPar_given_AGIDLDW,
       modelPar_BGIDLO,
       modelPar_given_BGIDLO,
       modelPar_BGIDLDO,
       modelPar_given_BGIDLDO,
       modelPar_STBGIDLO,
       modelPar_given_STBGIDLO,
       modelPar_STBGIDLDO,
       modelPar_given_STBGIDLDO,
       modelPar_CGIDLO,
       modelPar_given_CGIDLO,
       modelPar_CGIDLDO,
       modelPar_given_CGIDLDO,
       modelPar_CGBOVL,
       modelPar_given_CGBOVL,
       modelPar_CFRW,
       modelPar_given_CFRW,
       modelPar_CFRDW,
       modelPar_given_CFRDW,
       modelPar_FNTO,
       modelPar_given_FNTO,
       modelPar_FNTEXCL,
       modelPar_given_FNTEXCL,
       modelPar_NFALW,
       modelPar_given_NFALW,
       modelPar_NFBLW,
       modelPar_given_NFBLW,
       modelPar_NFCLW,
       modelPar_given_NFCLW,
       modelPar_EFO,
       modelPar_given_EFO,
       modelPar_LINTNOI,
       modelPar_given_LINTNOI,
       modelPar_ALPNOI,
       modelPar_given_ALPNOI,
       modelPar_DTA,
       modelPar_given_DTA,
       modelPar_KVTHOWEO,
       modelPar_given_KVTHOWEO,
       modelPar_KVTHOWEL,
       modelPar_given_KVTHOWEL,
       modelPar_KVTHOWEW,
       modelPar_given_KVTHOWEW,
       modelPar_KVTHOWELW,
       modelPar_given_KVTHOWELW,
       modelPar_KUOWEO,
       modelPar_given_KUOWEO,
       modelPar_KUOWEL,
       modelPar_given_KUOWEL,
       modelPar_KUOWEW,
       modelPar_given_KUOWEW,
       modelPar_KUOWELW,
       modelPar_given_KUOWELW,
       modelPar_LMIN,
       modelPar_given_LMIN,
       modelPar_LMAX,
       modelPar_given_LMAX,
       modelPar_WMIN,
       modelPar_given_WMIN,
       modelPar_WMAX,
       modelPar_given_WMAX,
       modelPar_RGO,
       modelPar_given_RGO,
       modelPar_RBULKO,
       modelPar_given_RBULKO,
       modelPar_RWELLO,
       modelPar_given_RWELLO,
       modelPar_RJUNSO,
       modelPar_given_RJUNSO,
       modelPar_RJUNDO,
       modelPar_given_RJUNDO,
       modelPar_RINT,
       modelPar_given_RINT,
       modelPar_RVPOLY,
       modelPar_given_RVPOLY,
       modelPar_RSHG,
       modelPar_given_RSHG,
       modelPar_DLSIL,
       modelPar_given_DLSIL,
       modelPar_SAREF,
       modelPar_given_SAREF,
       modelPar_SBREF,
       modelPar_given_SBREF,
       modelPar_WLOD,
       modelPar_given_WLOD,
       modelPar_KUO,
       modelPar_given_KUO,
       modelPar_KVSAT,
       modelPar_given_KVSAT,
       modelPar_TKUO,
       modelPar_given_TKUO,
       modelPar_LKUO,
       modelPar_given_LKUO,
       modelPar_WKUO,
       modelPar_given_WKUO,
       modelPar_PKUO,
       modelPar_given_PKUO,
       modelPar_LLODKUO,
       modelPar_given_LLODKUO,
       modelPar_WLODKUO,
       modelPar_given_WLODKUO,
       modelPar_KVTHO,
       modelPar_given_KVTHO,
       modelPar_LKVTHO,
       modelPar_given_LKVTHO,
       modelPar_WKVTHO,
       modelPar_given_WKVTHO,
       modelPar_PKVTHO,
       modelPar_given_PKVTHO,
       modelPar_LLODVTH,
       modelPar_given_LLODVTH,
       modelPar_WLODVTH,
       modelPar_given_WLODVTH,
       modelPar_STETAO,
       modelPar_given_STETAO,
       modelPar_LODETAO,
       modelPar_given_LODETAO,
       modelPar_SCREF,
       modelPar_given_SCREF,
       modelPar_WEB,
       modelPar_given_WEB,
       modelPar_WEC,
       modelPar_given_WEC,
       modelPar_IMAX,
       modelPar_given_IMAX,
       modelPar_TRJ,
       modelPar_given_TRJ,
       modelPar_CJORBOT,
       modelPar_given_CJORBOT,
       modelPar_CJORSTI,
       modelPar_given_CJORSTI,
       modelPar_CJORGAT,
       modelPar_given_CJORGAT,
       modelPar_VBIRBOT,
       modelPar_given_VBIRBOT,
       modelPar_VBIRSTI,
       modelPar_given_VBIRSTI,
       modelPar_VBIRGAT,
       modelPar_given_VBIRGAT,
       modelPar_PBOT,
       modelPar_given_PBOT,
       modelPar_PSTI,
       modelPar_given_PSTI,
       modelPar_PGAT,
       modelPar_given_PGAT,
       modelPar_PHIGBOT,
       modelPar_given_PHIGBOT,
       modelPar_PHIGSTI,
       modelPar_given_PHIGSTI,
       modelPar_PHIGGAT,
       modelPar_given_PHIGGAT,
       modelPar_IDSATRBOT,
       modelPar_given_IDSATRBOT,
       modelPar_IDSATRSTI,
       modelPar_given_IDSATRSTI,
       modelPar_IDSATRGAT,
       modelPar_given_IDSATRGAT,
       modelPar_CSRHBOT,
       modelPar_given_CSRHBOT,
       modelPar_CSRHSTI,
       modelPar_given_CSRHSTI,
       modelPar_CSRHGAT,
       modelPar_given_CSRHGAT,
       modelPar_XJUNSTI,
       modelPar_given_XJUNSTI,
       modelPar_XJUNGAT,
       modelPar_given_XJUNGAT,
       modelPar_CTATBOT,
       modelPar_given_CTATBOT,
       modelPar_CTATSTI,
       modelPar_given_CTATSTI,
       modelPar_CTATGAT,
       modelPar_given_CTATGAT,
       modelPar_MEFFTATBOT,
       modelPar_given_MEFFTATBOT,
       modelPar_MEFFTATSTI,
       modelPar_given_MEFFTATSTI,
       modelPar_MEFFTATGAT,
       modelPar_given_MEFFTATGAT,
       modelPar_CBBTBOT,
       modelPar_given_CBBTBOT,
       modelPar_CBBTSTI,
       modelPar_given_CBBTSTI,
       modelPar_CBBTGAT,
       modelPar_given_CBBTGAT,
       modelPar_FBBTRBOT,
       modelPar_given_FBBTRBOT,
       modelPar_FBBTRSTI,
       modelPar_given_FBBTRSTI,
       modelPar_FBBTRGAT,
       modelPar_given_FBBTRGAT,
       modelPar_STFBBTBOT,
       modelPar_given_STFBBTBOT,
       modelPar_STFBBTSTI,
       modelPar_given_STFBBTSTI,
       modelPar_STFBBTGAT,
       modelPar_given_STFBBTGAT,
       modelPar_VBRBOT,
       modelPar_given_VBRBOT,
       modelPar_VBRSTI,
       modelPar_given_VBRSTI,
       modelPar_VBRGAT,
       modelPar_given_VBRGAT,
       modelPar_PBRBOT,
       modelPar_given_PBRBOT,
       modelPar_PBRSTI,
       modelPar_given_PBRSTI,
       modelPar_PBRGAT,
       modelPar_given_PBRGAT,
       modelPar_CJORBOTD,
       modelPar_given_CJORBOTD,
       modelPar_CJORSTID,
       modelPar_given_CJORSTID,
       modelPar_CJORGATD,
       modelPar_given_CJORGATD,
       modelPar_VBIRBOTD,
       modelPar_given_VBIRBOTD,
       modelPar_VBIRSTID,
       modelPar_given_VBIRSTID,
       modelPar_VBIRGATD,
       modelPar_given_VBIRGATD,
       modelPar_PBOTD,
       modelPar_given_PBOTD,
       modelPar_PSTID,
       modelPar_given_PSTID,
       modelPar_PGATD,
       modelPar_given_PGATD,
       modelPar_PHIGBOTD,
       modelPar_given_PHIGBOTD,
       modelPar_PHIGSTID,
       modelPar_given_PHIGSTID,
       modelPar_PHIGGATD,
       modelPar_given_PHIGGATD,
       modelPar_IDSATRBOTD,
       modelPar_given_IDSATRBOTD,
       modelPar_IDSATRSTID,
       modelPar_given_IDSATRSTID,
       modelPar_IDSATRGATD,
       modelPar_given_IDSATRGATD,
       modelPar_CSRHBOTD,
       modelPar_given_CSRHBOTD,
       modelPar_CSRHSTID,
       modelPar_given_CSRHSTID,
       modelPar_CSRHGATD,
       modelPar_given_CSRHGATD,
       modelPar_XJUNSTID,
       modelPar_given_XJUNSTID,
       modelPar_XJUNGATD,
       modelPar_given_XJUNGATD,
       modelPar_CTATBOTD,
       modelPar_given_CTATBOTD,
       modelPar_CTATSTID,
       modelPar_given_CTATSTID,
       modelPar_CTATGATD,
       modelPar_given_CTATGATD,
       modelPar_MEFFTATBOTD,
       modelPar_given_MEFFTATBOTD,
       modelPar_MEFFTATSTID,
       modelPar_given_MEFFTATSTID,
       modelPar_MEFFTATGATD,
       modelPar_given_MEFFTATGATD,
       modelPar_CBBTBOTD,
       modelPar_given_CBBTBOTD,
       modelPar_CBBTSTID,
       modelPar_given_CBBTSTID,
       modelPar_CBBTGATD,
       modelPar_given_CBBTGATD,
       modelPar_FBBTRBOTD,
       modelPar_given_FBBTRBOTD,
       modelPar_FBBTRSTID,
       modelPar_given_FBBTRSTID,
       modelPar_FBBTRGATD,
       modelPar_given_FBBTRGATD,
       modelPar_STFBBTBOTD,
       modelPar_given_STFBBTBOTD,
       modelPar_STFBBTSTID,
       modelPar_given_STFBBTSTID,
       modelPar_STFBBTGATD,
       modelPar_given_STFBBTGATD,
       modelPar_VBRBOTD,
       modelPar_given_VBRBOTD,
       modelPar_VBRSTID,
       modelPar_given_VBRSTID,
       modelPar_VBRGATD,
       modelPar_given_VBRGATD,
       modelPar_PBRBOTD,
       modelPar_given_PBRBOTD,
       modelPar_PBRSTID,
       modelPar_given_PBRSTID,
       modelPar_PBRGATD,
       modelPar_given_PBRGATD,
       modelPar_SWJUNEXP,
       modelPar_given_SWJUNEXP,
       modelPar_VJUNREF,
       modelPar_given_VJUNREF,
       modelPar_FJUNQ,
       modelPar_given_FJUNQ,
       modelPar_VJUNREFD,
       modelPar_given_VJUNREFD,
       modelPar_FJUNQD,
       modelPar_given_FJUNQD// model variables
       ,
       // reals
       modelVar_NSUBO_i,
       modelVar_WSEG_i,
       modelVar_NPCK_i,
       modelVar_WSEGP_i,
       modelVar_LPCK_i,
       modelVar_LOV_i,
       modelVar_LOVD_i,
       modelVar_LP1_i,
       modelVar_LP2_i,
       modelVar_WBET_i,
       modelVar_AXL_i,
       modelVar_ALP1L2_i,
       modelVar_ALP2L2_i,
       modelVar_RINT_i,
       modelVar_RVPOLY_i,
       modelVar_SAREF_i,
       modelVar_SBREF_i,
       modelVar_KVSAT_i,
       modelVar_LLODKUO_i,
       modelVar_WLODKUO_i,
       modelVar_LLODVTH_i,
       modelVar_WLODVTH_i,
       modelVar_LODETAO_i,
       modelVar_SCREF_i,
       modelVar_WEB_i,
       modelVar_WEC_i,
       modelVar_TOX_i,
       modelVar_EPSROX_i,
       modelVar_TOXOV_i,
       modelVar_TOXOVD_i,
       modelVar_TKD,
       modelVar_dT,
       modelVar_rT,
       modelVar_rTn,
       modelVar_EPSSI,
       modelVar_phit,
       modelVar_inv_phit,
       modelVar_Eg,
       modelVar_phibFac,
       modelVar_nt0,
       modelVar_IMAX_i,
       modelVar_VBIRBOT_i,
       modelVar_VBIRSTI_i,
       modelVar_VBIRGAT_i,
       modelVar_PBOT_i,
       modelVar_PSTI_i,
       modelVar_PGAT_i,
       modelVar_CSRHBOT_i,
       modelVar_CSRHSTI_i,
       modelVar_CSRHGAT_i,
       modelVar_CTATBOT_i,
       modelVar_CTATSTI_i,
       modelVar_CTATGAT_i,
       modelVar_CBBTBOT_i,
       modelVar_CBBTSTI_i,
       modelVar_CBBTGAT_i,
       modelVar_VBRBOT_i,
       modelVar_VBRSTI_i,
       modelVar_VBRGAT_i,
       modelVar_PBRBOT_i,
       modelVar_PBRSTI_i,
       modelVar_PBRGAT_i,
       modelVar_SWJUNEXP_i,
       modelVar_VJUNREF_i,
       modelVar_FJUNQ_i,
       modelVar_phitr,
       modelVar_phitd,
       modelVar_phitdinv,
       modelVar_perfc,
       modelVar_berfc,
       modelVar_cerfc,
       modelVar_ftdbot,
       modelVar_ftdsti,
       modelVar_ftdgat,
       modelVar_idsatbot,
       modelVar_idsatsti,
       modelVar_idsatgat,
       modelVar_vbibot,
       modelVar_vbisti,
       modelVar_vbigat,
       modelVar_vbiinvbot,
       modelVar_vbiinvsti,
       modelVar_vbiinvgat,
       modelVar_one_minus_PBOT,
       modelVar_one_minus_PSTI,
       modelVar_one_minus_PGAT,
       modelVar_one_over_one_minus_PBOT,
       modelVar_one_over_one_minus_PSTI,
       modelVar_one_over_one_minus_PGAT,
       modelVar_cjobot,
       modelVar_cjosti,
       modelVar_cjogat,
       modelVar_qprefbot,
       modelVar_qprefsti,
       modelVar_qprefgat,
       modelVar_qpref2bot,
       modelVar_qpref2sti,
       modelVar_qpref2gat,
       modelVar_wdepnulrbot,
       modelVar_wdepnulrsti,
       modelVar_wdepnulrgat,
       modelVar_wdepnulrinvbot,
       modelVar_wdepnulrinvsti,
       modelVar_wdepnulrinvgat,
       modelVar_VBIRBOTinv,
       modelVar_VBIRSTIinv,
       modelVar_VBIRGATinv,
       modelVar_atatbot,
       modelVar_atatsti,
       modelVar_atatgat,
       modelVar_btatpartbot,
       modelVar_btatpartsti,
       modelVar_btatpartgat,
       modelVar_fbbtbot,
       modelVar_fbbtsti,
       modelVar_fbbtgat,
       modelVar_fstopbot,
       modelVar_fstopsti,
       modelVar_fstopgat,
       modelVar_VBRinvbot,
       modelVar_VBRinvsti,
       modelVar_VBRinvgat,
       modelVar_slopebot,
       modelVar_slopesti,
       modelVar_slopegat,
       modelVar_VBIRBOTD_i,
       modelVar_VBIRSTID_i,
       modelVar_VBIRGATD_i,
       modelVar_PBOTD_i,
       modelVar_PSTID_i,
       modelVar_PGATD_i,
       modelVar_CSRHBOTD_i,
       modelVar_CSRHSTID_i,
       modelVar_CSRHGATD_i,
       modelVar_CTATBOTD_i,
       modelVar_CTATSTID_i,
       modelVar_CTATGATD_i,
       modelVar_CBBTBOTD_i,
       modelVar_CBBTSTID_i,
       modelVar_CBBTGATD_i,
       modelVar_VBRBOTD_i,
       modelVar_VBRSTID_i,
       modelVar_VBRGATD_i,
       modelVar_PBRBOTD_i,
       modelVar_PBRSTID_i,
       modelVar_PBRGATD_i,
       modelVar_VJUNREFD_i,
       modelVar_FJUNQD_i,
       modelVar_ftdbot_d,
       modelVar_ftdsti_d,
       modelVar_ftdgat_d,
       modelVar_idsatbot_d,
       modelVar_idsatsti_d,
       modelVar_idsatgat_d,
       modelVar_vbibot_d,
       modelVar_vbisti_d,
       modelVar_vbigat_d,
       modelVar_vbiinvbot_d,
       modelVar_vbiinvsti_d,
       modelVar_vbiinvgat_d,
       modelVar_one_minus_PBOT_d,
       modelVar_one_minus_PSTI_d,
       modelVar_one_minus_PGAT_d,
       modelVar_one_over_one_minus_PBOT_d,
       modelVar_one_over_one_minus_PSTI_d,
       modelVar_one_over_one_minus_PGAT_d,
       modelVar_cjobot_d,
       modelVar_cjosti_d,
       modelVar_cjogat_d,
       modelVar_qprefbot_d,
       modelVar_qprefsti_d,
       modelVar_qprefgat_d,
       modelVar_qpref2bot_d,
       modelVar_qpref2sti_d,
       modelVar_qpref2gat_d,
       modelVar_wdepnulrbot_d,
       modelVar_wdepnulrsti_d,
       modelVar_wdepnulrgat_d,
       modelVar_wdepnulrinvbot_d,
       modelVar_wdepnulrinvsti_d,
       modelVar_wdepnulrinvgat_d,
       modelVar_VBIRBOTinv_d,
       modelVar_VBIRSTIinv_d,
       modelVar_VBIRGATinv_d,
       modelVar_atatbot_d,
       modelVar_atatsti_d,
       modelVar_atatgat_d,
       modelVar_btatpartbot_d,
       modelVar_btatpartsti_d,
       modelVar_btatpartgat_d,
       modelVar_fbbtbot_d,
       modelVar_fbbtsti_d,
       modelVar_fbbtgat_d,
       modelVar_fstopbot_d,
       modelVar_fstopsti_d,
       modelVar_fstopgat_d,
       modelVar_VBRinvbot_d,
       modelVar_VBRinvsti_d,
       modelVar_VBRinvgat_d,
       modelVar_slopebot_d,
       modelVar_slopesti_d,
       modelVar_slopegat_d,
       // non-reals
       modelVar_CHNL_TYPE,
       in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_NOI_GND,
       in.admsProbeID_V_NOI2_GND,
       in.admsProbeID_V_D_BD,
       in.admsProbeID_V_S_BS,
       in.admsProbeID_V_S_BP,
       in.admsProbeID_V_D_S,
       in.admsProbeID_V_GP_S,
       in.admsProbeID_V_B_BI,
       in.admsProbeID_V_BP_BI,
       in.admsProbeID_V_BD_BI,
       in.admsProbeID_V_BS_BI,
       in.admsProbeID_V_G_GP,

       // node constants
       in.admsNodeID_D,
       in.admsNodeID_G,
       in.admsNodeID_S,
       in.admsNodeID_B,
       in.admsNodeID_NOI,
       in.admsNodeID_NOI2,
       in.admsNodeID_GP,
       in.admsNodeID_BP,
       in.admsNodeID_BI,
       in.admsNodeID_BS,
       in.admsNodeID_BD,
       // instance parameters
       // reals
       instancePar_L,
       instancePar_given_L,
       instancePar_W,
       instancePar_given_W,
       instancePar_SA,
       instancePar_given_SA,
       instancePar_SB,
       instancePar_given_SB,
       instancePar_SD,
       instancePar_given_SD,
       instancePar_SCA,
       instancePar_given_SCA,
       instancePar_SCB,
       instancePar_given_SCB,
       instancePar_SCC,
       instancePar_given_SCC,
       instancePar_SC,
       instancePar_given_SC,
       instancePar_DELVTO,
       instancePar_given_DELVTO,
       instancePar_FACTUO,
       instancePar_given_FACTUO,
       instancePar_ABSOURCE,
       instancePar_given_ABSOURCE,
       instancePar_LSSOURCE,
       instancePar_given_LSSOURCE,
       instancePar_LGSOURCE,
       instancePar_given_LGSOURCE,
       instancePar_ABDRAIN,
       instancePar_given_ABDRAIN,
       instancePar_LSDRAIN,
       instancePar_given_LSDRAIN,
       instancePar_LGDRAIN,
       instancePar_given_LGDRAIN,
       instancePar_AS,
       instancePar_given_AS,
       instancePar_PS,
       instancePar_given_PS,
       instancePar_AD,
       instancePar_given_AD,
       instancePar_PD,
       instancePar_given_PD,
       instancePar_MULT,
       instancePar_given_MULT,
       instancePar_NF,
       instancePar_given_NF,
       instancePar_NGCON,
       instancePar_given_NGCON,
       instancePar_XGW,
       instancePar_given_XGW,
       // instance variables
       // reals
       instanceVar_VFB_i,
       instanceVar_VNSUB_i,
       instanceVar_NSLP_i,
       instanceVar_DNSUB_i,
       instanceVar_CF_i,
       instanceVar_CFB_i,
       instanceVar_MUE_i,
       instanceVar_THEMU_i,
       instanceVar_CS_i,
       instanceVar_XCOR_i,
       instanceVar_THER_i,
       instanceVar_RSB_i,
       instanceVar_RSG_i,
       instanceVar_THESAT_i,
       instanceVar_THESATB_i,
       instanceVar_THESATG_i,
       instanceVar_AX_i,
       instanceVar_ALP_i,
       instanceVar_ALP1_i,
       instanceVar_ALP2_i,
       instanceVar_A1_i,
       instanceVar_A2_i,
       instanceVar_A3_i,
       instanceVar_A4_i,
       instanceVar_IGINV_i,
       instanceVar_IGOV_i,
       instanceVar_IGOVD_i,
       instanceVar_GC2_i,
       instanceVar_GC3_i,
       instanceVar_CHIB_i,
       instanceVar_AGIDL_i,
       instanceVar_CGIDL_i,
       instanceVar_AGIDLD_i,
       instanceVar_CGIDLD_i,
       instanceVar_COX_i,
       instanceVar_CGOV_i,
       instanceVar_CGOVD_i,
       instanceVar_CGBOV_i,
       instanceVar_CFR_i,
       instanceVar_CFRD_i,
       instanceVar_NFA_i,
       instanceVar_NFB_i,
       instanceVar_NFC_i,
       instanceVar_EF_i,
       instanceVar_FNTEXC_i,
       instanceVar_MULT_i,
       instanceVar_BET_i,
       instanceVar_kp,
       instanceVar_qq,
       instanceVar_qlim2,
       instanceVar_E_eff0,
       instanceVar_eta_mu,
       instanceVar_BCH,
       instanceVar_BOV,
       instanceVar_inv_CHIB,
       instanceVar_GCQ,
       instanceVar_Dch,
       instanceVar_Dov,
       instanceVar_x1,
       instanceVar_Vdsat_lim,
       instanceVar_nt,
       instanceVar_Cox_over_q,
       instanceVar_GOV_s,
       instanceVar_GOV_d,
       instanceVar_GOV2_s,
       instanceVar_GOV2_d,
       instanceVar_BOV_d,
       instanceVar_xi_ov_s,
       instanceVar_xi_ov_d,
       instanceVar_inv_xi_ov_s,
       instanceVar_inv_xi_ov_d,
       instanceVar_x_mrg_ov_s,
       instanceVar_x_mrg_ov_d,
       instanceVar_inv_xg1_s,
       instanceVar_inv_xg1_d,
       instanceVar_AGIDLs,
       instanceVar_AGIDLDs,
       instanceVar_BGIDLs,
       instanceVar_BGIDLDs,
       instanceVar_phib,
       instanceVar_sqrt_phib,
       instanceVar_phix,
       instanceVar_aphi,
       instanceVar_bphi,
       instanceVar_phix1,
       instanceVar_G_0,
       instanceVar_phit1,
       instanceVar_inv_phit1,
       instanceVar_alpha_b,
       instanceVar_inv_VP,
       instanceVar_inv_AX,
       instanceVar_Sfl_prefac,
       instanceVar_fac_exc,
       instanceVar_RG_i,
       instanceVar_RBULK_i,
       instanceVar_RWELL_i,
       instanceVar_RJUNS_i,
       instanceVar_RJUND_i,
       instanceVar_ggate,
       instanceVar_gbulk,
       instanceVar_gwell,
       instanceVar_gjund,
       instanceVar_gjuns,
       instanceVar_ABSOURCE_i,
       instanceVar_LSSOURCE_i,
       instanceVar_LGSOURCE_i,
       instanceVar_zflagbot_s,
       instanceVar_zflagsti_s,
       instanceVar_zflaggat_s,
       instanceVar_VMAX_s,
       instanceVar_exp_VMAX_over_phitd_s,
       instanceVar_vbimin_s,
       instanceVar_vch_s,
       instanceVar_vfmin_s,
       instanceVar_vbbtlim_s,
       instanceVar_xhighf1_s,
       instanceVar_expxhf1_s,
       instanceVar_xhighf2_s,
       instanceVar_expxhf2_s,
       instanceVar_xhighr_s,
       instanceVar_expxhr_s,
       instanceVar_m0flag_s,
       instanceVar_ISATFOR1_s,
       instanceVar_MFOR1_s,
       instanceVar_ISATFOR2_s,
       instanceVar_MFOR2_s,
       instanceVar_ISATREV_s,
       instanceVar_MREV_s,
       instanceVar_ABDRAIN_i,
       instanceVar_LSDRAIN_i,
       instanceVar_LGDRAIN_i,
       instanceVar_zflagbot_d,
       instanceVar_zflagsti_d,
       instanceVar_zflaggat_d,
       instanceVar_VMAX_d,
       instanceVar_exp_VMAX_over_phitd_d,
       instanceVar_vbimin_d,
       instanceVar_vch_d,
       instanceVar_vfmin_d,
       instanceVar_vbbtlim_d,
       instanceVar_xhighf1_d,
       instanceVar_expxhf1_d,
       instanceVar_xhighf2_d,
       instanceVar_expxhf2_d,
       instanceVar_xhighr_d,
       instanceVar_expxhr_d,
       instanceVar_m0flag_d,
       instanceVar_ISATFOR1_d,
       instanceVar_MFOR1_d,
       instanceVar_ISATFOR2_d,
       instanceVar_MFOR2_d,
       instanceVar_ISATREV_d,
       instanceVar_MREV_d,
       // model parameters
       // reals
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_TYPE,
       modelPar_given_TYPE,
       modelPar_TR,
       modelPar_given_TR,
       modelPar_SWIGATE,
       modelPar_given_SWIGATE,
       modelPar_SWIMPACT,
       modelPar_given_SWIMPACT,
       modelPar_SWGIDL,
       modelPar_given_SWGIDL,
       modelPar_SWJUNCAP,
       modelPar_given_SWJUNCAP,
       modelPar_SWJUNASYM,
       modelPar_given_SWJUNASYM,
       modelPar_QMC,
       modelPar_given_QMC,
       modelPar_LVARO,
       modelPar_given_LVARO,
       modelPar_LVARL,
       modelPar_given_LVARL,
       modelPar_LVARW,
       modelPar_given_LVARW,
       modelPar_LAP,
       modelPar_given_LAP,
       modelPar_WVARO,
       modelPar_given_WVARO,
       modelPar_WVARL,
       modelPar_given_WVARL,
       modelPar_WVARW,
       modelPar_given_WVARW,
       modelPar_WOT,
       modelPar_given_WOT,
       modelPar_DLQ,
       modelPar_given_DLQ,
       modelPar_DWQ,
       modelPar_given_DWQ,
       modelPar_VFBO,
       modelPar_given_VFBO,
       modelPar_VFBL,
       modelPar_given_VFBL,
       modelPar_VFBW,
       modelPar_given_VFBW,
       modelPar_VFBLW,
       modelPar_given_VFBLW,
       modelPar_STVFBO,
       modelPar_given_STVFBO,
       modelPar_STVFBL,
       modelPar_given_STVFBL,
       modelPar_STVFBW,
       modelPar_given_STVFBW,
       modelPar_STVFBLW,
       modelPar_given_STVFBLW,
       modelPar_TOXO,
       modelPar_given_TOXO,
       modelPar_EPSROXO,
       modelPar_given_EPSROXO,
       modelPar_NSUBO,
       modelPar_given_NSUBO,
       modelPar_NSUBW,
       modelPar_given_NSUBW,
       modelPar_WSEG,
       modelPar_given_WSEG,
       modelPar_NPCK,
       modelPar_given_NPCK,
       modelPar_NPCKW,
       modelPar_given_NPCKW,
       modelPar_WSEGP,
       modelPar_given_WSEGP,
       modelPar_LPCK,
       modelPar_given_LPCK,
       modelPar_LPCKW,
       modelPar_given_LPCKW,
       modelPar_FOL1,
       modelPar_given_FOL1,
       modelPar_FOL2,
       modelPar_given_FOL2,
       modelPar_VNSUBO,
       modelPar_given_VNSUBO,
       modelPar_NSLPO,
       modelPar_given_NSLPO,
       modelPar_DNSUBO,
       modelPar_given_DNSUBO,
       modelPar_DPHIBO,
       modelPar_given_DPHIBO,
       modelPar_DPHIBL,
       modelPar_given_DPHIBL,
       modelPar_DPHIBLEXP,
       modelPar_given_DPHIBLEXP,
       modelPar_DPHIBW,
       modelPar_given_DPHIBW,
       modelPar_DPHIBLW,
       modelPar_given_DPHIBLW,
       modelPar_NPO,
       modelPar_given_NPO,
       modelPar_NPL,
       modelPar_given_NPL,
       modelPar_CTO,
       modelPar_given_CTO,
       modelPar_CTL,
       modelPar_given_CTL,
       modelPar_CTLEXP,
       modelPar_given_CTLEXP,
       modelPar_CTW,
       modelPar_given_CTW,
       modelPar_CTLW,
       modelPar_given_CTLW,
       modelPar_TOXOVO,
       modelPar_given_TOXOVO,
       modelPar_TOXOVDO,
       modelPar_given_TOXOVDO,
       modelPar_LOV,
       modelPar_given_LOV,
       modelPar_LOVD,
       modelPar_given_LOVD,
       modelPar_NOVO,
       modelPar_given_NOVO,
       modelPar_NOVDO,
       modelPar_given_NOVDO,
       modelPar_CFL,
       modelPar_given_CFL,
       modelPar_CFLEXP,
       modelPar_given_CFLEXP,
       modelPar_CFW,
       modelPar_given_CFW,
       modelPar_CFBO,
       modelPar_given_CFBO,
       modelPar_UO,
       modelPar_given_UO,
       modelPar_FBET1,
       modelPar_given_FBET1,
       modelPar_FBET1W,
       modelPar_given_FBET1W,
       modelPar_LP1,
       modelPar_given_LP1,
       modelPar_LP1W,
       modelPar_given_LP1W,
       modelPar_FBET2,
       modelPar_given_FBET2,
       modelPar_LP2,
       modelPar_given_LP2,
       modelPar_BETW1,
       modelPar_given_BETW1,
       modelPar_BETW2,
       modelPar_given_BETW2,
       modelPar_WBET,
       modelPar_given_WBET,
       modelPar_STBETO,
       modelPar_given_STBETO,
       modelPar_STBETL,
       modelPar_given_STBETL,
       modelPar_STBETW,
       modelPar_given_STBETW,
       modelPar_STBETLW,
       modelPar_given_STBETLW,
       modelPar_MUEO,
       modelPar_given_MUEO,
       modelPar_MUEW,
       modelPar_given_MUEW,
       modelPar_STMUEO,
       modelPar_given_STMUEO,
       modelPar_THEMUO,
       modelPar_given_THEMUO,
       modelPar_STTHEMUO,
       modelPar_given_STTHEMUO,
       modelPar_CSO,
       modelPar_given_CSO,
       modelPar_CSL,
       modelPar_given_CSL,
       modelPar_CSLEXP,
       modelPar_given_CSLEXP,
       modelPar_CSW,
       modelPar_given_CSW,
       modelPar_CSLW,
       modelPar_given_CSLW,
       modelPar_STCSO,
       modelPar_given_STCSO,
       modelPar_XCORO,
       modelPar_given_XCORO,
       modelPar_XCORL,
       modelPar_given_XCORL,
       modelPar_XCORW,
       modelPar_given_XCORW,
       modelPar_XCORLW,
       modelPar_given_XCORLW,
       modelPar_STXCORO,
       modelPar_given_STXCORO,
       modelPar_FETAO,
       modelPar_given_FETAO,
       modelPar_RSW1,
       modelPar_given_RSW1,
       modelPar_RSW2,
       modelPar_given_RSW2,
       modelPar_STRSO,
       modelPar_given_STRSO,
       modelPar_RSBO,
       modelPar_given_RSBO,
       modelPar_RSGO,
       modelPar_given_RSGO,
       modelPar_THESATO,
       modelPar_given_THESATO,
       modelPar_THESATL,
       modelPar_given_THESATL,
       modelPar_THESATLEXP,
       modelPar_given_THESATLEXP,
       modelPar_THESATW,
       modelPar_given_THESATW,
       modelPar_THESATLW,
       modelPar_given_THESATLW,
       modelPar_STTHESATO,
       modelPar_given_STTHESATO,
       modelPar_STTHESATL,
       modelPar_given_STTHESATL,
       modelPar_STTHESATW,
       modelPar_given_STTHESATW,
       modelPar_STTHESATLW,
       modelPar_given_STTHESATLW,
       modelPar_THESATBO,
       modelPar_given_THESATBO,
       modelPar_THESATGO,
       modelPar_given_THESATGO,
       modelPar_AXO,
       modelPar_given_AXO,
       modelPar_AXL,
       modelPar_given_AXL,
       modelPar_ALPL,
       modelPar_given_ALPL,
       modelPar_ALPLEXP,
       modelPar_given_ALPLEXP,
       modelPar_ALPW,
       modelPar_given_ALPW,
       modelPar_ALP1L1,
       modelPar_given_ALP1L1,
       modelPar_ALP1LEXP,
       modelPar_given_ALP1LEXP,
       modelPar_ALP1L2,
       modelPar_given_ALP1L2,
       modelPar_ALP1W,
       modelPar_given_ALP1W,
       modelPar_ALP2L1,
       modelPar_given_ALP2L1,
       modelPar_ALP2LEXP,
       modelPar_given_ALP2LEXP,
       modelPar_ALP2L2,
       modelPar_given_ALP2L2,
       modelPar_ALP2W,
       modelPar_given_ALP2W,
       modelPar_VPO,
       modelPar_given_VPO,
       modelPar_A1O,
       modelPar_given_A1O,
       modelPar_A1L,
       modelPar_given_A1L,
       modelPar_A1W,
       modelPar_given_A1W,
       modelPar_A2O,
       modelPar_given_A2O,
       modelPar_STA2O,
       modelPar_given_STA2O,
       modelPar_A3O,
       modelPar_given_A3O,
       modelPar_A3L,
       modelPar_given_A3L,
       modelPar_A3W,
       modelPar_given_A3W,
       modelPar_A4O,
       modelPar_given_A4O,
       modelPar_A4L,
       modelPar_given_A4L,
       modelPar_A4W,
       modelPar_given_A4W,
       modelPar_GCOO,
       modelPar_given_GCOO,
       modelPar_IGINVLW,
       modelPar_given_IGINVLW,
       modelPar_IGOVW,
       modelPar_given_IGOVW,
       modelPar_IGOVDW,
       modelPar_given_IGOVDW,
       modelPar_STIGO,
       modelPar_given_STIGO,
       modelPar_GC2O,
       modelPar_given_GC2O,
       modelPar_GC3O,
       modelPar_given_GC3O,
       modelPar_CHIBO,
       modelPar_given_CHIBO,
       modelPar_AGIDLW,
       modelPar_given_AGIDLW,
       modelPar_AGIDLDW,
       modelPar_given_AGIDLDW,
       modelPar_BGIDLO,
       modelPar_given_BGIDLO,
       modelPar_BGIDLDO,
       modelPar_given_BGIDLDO,
       modelPar_STBGIDLO,
       modelPar_given_STBGIDLO,
       modelPar_STBGIDLDO,
       modelPar_given_STBGIDLDO,
       modelPar_CGIDLO,
       modelPar_given_CGIDLO,
       modelPar_CGIDLDO,
       modelPar_given_CGIDLDO,
       modelPar_CGBOVL,
       modelPar_given_CGBOVL,
       modelPar_CFRW,
       modelPar_given_CFRW,
       modelPar_CFRDW,
       modelPar_given_CFRDW,
       modelPar_FNTO,
       modelPar_given_FNTO,
       modelPar_FNTEXCL,
       modelPar_given_FNTEXCL,
       modelPar_NFALW,
       modelPar_given_NFALW,
       modelPar_NFBLW,
       modelPar_given_NFBLW,
       modelPar_NFCLW,
       modelPar_given_NFCLW,
       modelPar_EFO,
       modelPar_given_EFO,
       modelPar_LINTNOI,
       modelPar_given_LINTNOI,
       modelPar_ALPNOI,
       modelPar_given_ALPNOI,
       modelPar_DTA,
       modelPar_given_DTA,
       modelPar_KVTHOWEO,
       modelPar_given_KVTHOWEO,
       modelPar_KVTHOWEL,
       modelPar_given_KVTHOWEL,
       modelPar_KVTHOWEW,
       modelPar_given_KVTHOWEW,
       modelPar_KVTHOWELW,
       modelPar_given_KVTHOWELW,
       modelPar_KUOWEO,
       modelPar_given_KUOWEO,
       modelPar_KUOWEL,
       modelPar_given_KUOWEL,
       modelPar_KUOWEW,
       modelPar_given_KUOWEW,
       modelPar_KUOWELW,
       modelPar_given_KUOWELW,
       modelPar_LMIN,
       modelPar_given_LMIN,
       modelPar_LMAX,
       modelPar_given_LMAX,
       modelPar_WMIN,
       modelPar_given_WMIN,
       modelPar_WMAX,
       modelPar_given_WMAX,
       modelPar_RGO,
       modelPar_given_RGO,
       modelPar_RBULKO,
       modelPar_given_RBULKO,
       modelPar_RWELLO,
       modelPar_given_RWELLO,
       modelPar_RJUNSO,
       modelPar_given_RJUNSO,
       modelPar_RJUNDO,
       modelPar_given_RJUNDO,
       modelPar_RINT,
       modelPar_given_RINT,
       modelPar_RVPOLY,
       modelPar_given_RVPOLY,
       modelPar_RSHG,
       modelPar_given_RSHG,
       modelPar_DLSIL,
       modelPar_given_DLSIL,
       modelPar_SAREF,
       modelPar_given_SAREF,
       modelPar_SBREF,
       modelPar_given_SBREF,
       modelPar_WLOD,
       modelPar_given_WLOD,
       modelPar_KUO,
       modelPar_given_KUO,
       modelPar_KVSAT,
       modelPar_given_KVSAT,
       modelPar_TKUO,
       modelPar_given_TKUO,
       modelPar_LKUO,
       modelPar_given_LKUO,
       modelPar_WKUO,
       modelPar_given_WKUO,
       modelPar_PKUO,
       modelPar_given_PKUO,
       modelPar_LLODKUO,
       modelPar_given_LLODKUO,
       modelPar_WLODKUO,
       modelPar_given_WLODKUO,
       modelPar_KVTHO,
       modelPar_given_KVTHO,
       modelPar_LKVTHO,
       modelPar_given_LKVTHO,
       modelPar_WKVTHO,
       modelPar_given_WKVTHO,
       modelPar_PKVTHO,
       modelPar_given_PKVTHO,
       modelPar_LLODVTH,
       modelPar_given_LLODVTH,
       modelPar_WLODVTH,
       modelPar_given_WLODVTH,
       modelPar_STETAO,
       modelPar_given_STETAO,
       modelPar_LODETAO,
       modelPar_given_LODETAO,
       modelPar_SCREF,
       modelPar_given_SCREF,
       modelPar_WEB,
       modelPar_given_WEB,
       modelPar_WEC,
       modelPar_given_WEC,
       modelPar_IMAX,
       modelPar_given_IMAX,
       modelPar_TRJ,
       modelPar_given_TRJ,
       modelPar_CJORBOT,
       modelPar_given_CJORBOT,
       modelPar_CJORSTI,
       modelPar_given_CJORSTI,
       modelPar_CJORGAT,
       modelPar_given_CJORGAT,
       modelPar_VBIRBOT,
       modelPar_given_VBIRBOT,
       modelPar_VBIRSTI,
       modelPar_given_VBIRSTI,
       modelPar_VBIRGAT,
       modelPar_given_VBIRGAT,
       modelPar_PBOT,
       modelPar_given_PBOT,
       modelPar_PSTI,
       modelPar_given_PSTI,
       modelPar_PGAT,
       modelPar_given_PGAT,
       modelPar_PHIGBOT,
       modelPar_given_PHIGBOT,
       modelPar_PHIGSTI,
       modelPar_given_PHIGSTI,
       modelPar_PHIGGAT,
       modelPar_given_PHIGGAT,
       modelPar_IDSATRBOT,
       modelPar_given_IDSATRBOT,
       modelPar_IDSATRSTI,
       modelPar_given_IDSATRSTI,
       modelPar_IDSATRGAT,
       modelPar_given_IDSATRGAT,
       modelPar_CSRHBOT,
       modelPar_given_CSRHBOT,
       modelPar_CSRHSTI,
       modelPar_given_CSRHSTI,
       modelPar_CSRHGAT,
       modelPar_given_CSRHGAT,
       modelPar_XJUNSTI,
       modelPar_given_XJUNSTI,
       modelPar_XJUNGAT,
       modelPar_given_XJUNGAT,
       modelPar_CTATBOT,
       modelPar_given_CTATBOT,
       modelPar_CTATSTI,
       modelPar_given_CTATSTI,
       modelPar_CTATGAT,
       modelPar_given_CTATGAT,
       modelPar_MEFFTATBOT,
       modelPar_given_MEFFTATBOT,
       modelPar_MEFFTATSTI,
       modelPar_given_MEFFTATSTI,
       modelPar_MEFFTATGAT,
       modelPar_given_MEFFTATGAT,
       modelPar_CBBTBOT,
       modelPar_given_CBBTBOT,
       modelPar_CBBTSTI,
       modelPar_given_CBBTSTI,
       modelPar_CBBTGAT,
       modelPar_given_CBBTGAT,
       modelPar_FBBTRBOT,
       modelPar_given_FBBTRBOT,
       modelPar_FBBTRSTI,
       modelPar_given_FBBTRSTI,
       modelPar_FBBTRGAT,
       modelPar_given_FBBTRGAT,
       modelPar_STFBBTBOT,
       modelPar_given_STFBBTBOT,
       modelPar_STFBBTSTI,
       modelPar_given_STFBBTSTI,
       modelPar_STFBBTGAT,
       modelPar_given_STFBBTGAT,
       modelPar_VBRBOT,
       modelPar_given_VBRBOT,
       modelPar_VBRSTI,
       modelPar_given_VBRSTI,
       modelPar_VBRGAT,
       modelPar_given_VBRGAT,
       modelPar_PBRBOT,
       modelPar_given_PBRBOT,
       modelPar_PBRSTI,
       modelPar_given_PBRSTI,
       modelPar_PBRGAT,
       modelPar_given_PBRGAT,
       modelPar_CJORBOTD,
       modelPar_given_CJORBOTD,
       modelPar_CJORSTID,
       modelPar_given_CJORSTID,
       modelPar_CJORGATD,
       modelPar_given_CJORGATD,
       modelPar_VBIRBOTD,
       modelPar_given_VBIRBOTD,
       modelPar_VBIRSTID,
       modelPar_given_VBIRSTID,
       modelPar_VBIRGATD,
       modelPar_given_VBIRGATD,
       modelPar_PBOTD,
       modelPar_given_PBOTD,
       modelPar_PSTID,
       modelPar_given_PSTID,
       modelPar_PGATD,
       modelPar_given_PGATD,
       modelPar_PHIGBOTD,
       modelPar_given_PHIGBOTD,
       modelPar_PHIGSTID,
       modelPar_given_PHIGSTID,
       modelPar_PHIGGATD,
       modelPar_given_PHIGGATD,
       modelPar_IDSATRBOTD,
       modelPar_given_IDSATRBOTD,
       modelPar_IDSATRSTID,
       modelPar_given_IDSATRSTID,
       modelPar_IDSATRGATD,
       modelPar_given_IDSATRGATD,
       modelPar_CSRHBOTD,
       modelPar_given_CSRHBOTD,
       modelPar_CSRHSTID,
       modelPar_given_CSRHSTID,
       modelPar_CSRHGATD,
       modelPar_given_CSRHGATD,
       modelPar_XJUNSTID,
       modelPar_given_XJUNSTID,
       modelPar_XJUNGATD,
       modelPar_given_XJUNGATD,
       modelPar_CTATBOTD,
       modelPar_given_CTATBOTD,
       modelPar_CTATSTID,
       modelPar_given_CTATSTID,
       modelPar_CTATGATD,
       modelPar_given_CTATGATD,
       modelPar_MEFFTATBOTD,
       modelPar_given_MEFFTATBOTD,
       modelPar_MEFFTATSTID,
       modelPar_given_MEFFTATSTID,
       modelPar_MEFFTATGATD,
       modelPar_given_MEFFTATGATD,
       modelPar_CBBTBOTD,
       modelPar_given_CBBTBOTD,
       modelPar_CBBTSTID,
       modelPar_given_CBBTSTID,
       modelPar_CBBTGATD,
       modelPar_given_CBBTGATD,
       modelPar_FBBTRBOTD,
       modelPar_given_FBBTRBOTD,
       modelPar_FBBTRSTID,
       modelPar_given_FBBTRSTID,
       modelPar_FBBTRGATD,
       modelPar_given_FBBTRGATD,
       modelPar_STFBBTBOTD,
       modelPar_given_STFBBTBOTD,
       modelPar_STFBBTSTID,
       modelPar_given_STFBBTSTID,
       modelPar_STFBBTGATD,
       modelPar_given_STFBBTGATD,
       modelPar_VBRBOTD,
       modelPar_given_VBRBOTD,
       modelPar_VBRSTID,
       modelPar_given_VBRSTID,
       modelPar_VBRGATD,
       modelPar_given_VBRGATD,
       modelPar_PBRBOTD,
       modelPar_given_PBRBOTD,
       modelPar_PBRSTID,
       modelPar_given_PBRSTID,
       modelPar_PBRGATD,
       modelPar_given_PBRGATD,
       modelPar_SWJUNEXP,
       modelPar_given_SWJUNEXP,
       modelPar_VJUNREF,
       modelPar_given_VJUNREF,
       modelPar_FJUNQ,
       modelPar_given_FJUNQ,
       modelPar_VJUNREFD,
       modelPar_given_VJUNREFD,
       modelPar_FJUNQD,
       modelPar_given_FJUNQD// model variables
       ,
       // reals
       modelVar_NSUBO_i,
       modelVar_WSEG_i,
       modelVar_NPCK_i,
       modelVar_WSEGP_i,
       modelVar_LPCK_i,
       modelVar_LOV_i,
       modelVar_LOVD_i,
       modelVar_LP1_i,
       modelVar_LP2_i,
       modelVar_WBET_i,
       modelVar_AXL_i,
       modelVar_ALP1L2_i,
       modelVar_ALP2L2_i,
       modelVar_RINT_i,
       modelVar_RVPOLY_i,
       modelVar_SAREF_i,
       modelVar_SBREF_i,
       modelVar_KVSAT_i,
       modelVar_LLODKUO_i,
       modelVar_WLODKUO_i,
       modelVar_LLODVTH_i,
       modelVar_WLODVTH_i,
       modelVar_LODETAO_i,
       modelVar_SCREF_i,
       modelVar_WEB_i,
       modelVar_WEC_i,
       modelVar_TOX_i,
       modelVar_EPSROX_i,
       modelVar_TOXOV_i,
       modelVar_TOXOVD_i,
       modelVar_TKD,
       modelVar_dT,
       modelVar_rT,
       modelVar_rTn,
       modelVar_EPSSI,
       modelVar_phit,
       modelVar_inv_phit,
       modelVar_Eg,
       modelVar_phibFac,
       modelVar_nt0,
       modelVar_IMAX_i,
       modelVar_VBIRBOT_i,
       modelVar_VBIRSTI_i,
       modelVar_VBIRGAT_i,
       modelVar_PBOT_i,
       modelVar_PSTI_i,
       modelVar_PGAT_i,
       modelVar_CSRHBOT_i,
       modelVar_CSRHSTI_i,
       modelVar_CSRHGAT_i,
       modelVar_CTATBOT_i,
       modelVar_CTATSTI_i,
       modelVar_CTATGAT_i,
       modelVar_CBBTBOT_i,
       modelVar_CBBTSTI_i,
       modelVar_CBBTGAT_i,
       modelVar_VBRBOT_i,
       modelVar_VBRSTI_i,
       modelVar_VBRGAT_i,
       modelVar_PBRBOT_i,
       modelVar_PBRSTI_i,
       modelVar_PBRGAT_i,
       modelVar_SWJUNEXP_i,
       modelVar_VJUNREF_i,
       modelVar_FJUNQ_i,
       modelVar_phitr,
       modelVar_phitd,
       modelVar_phitdinv,
       modelVar_perfc,
       modelVar_berfc,
       modelVar_cerfc,
       modelVar_ftdbot,
       modelVar_ftdsti,
       modelVar_ftdgat,
       modelVar_idsatbot,
       modelVar_idsatsti,
       modelVar_idsatgat,
       modelVar_vbibot,
       modelVar_vbisti,
       modelVar_vbigat,
       modelVar_vbiinvbot,
       modelVar_vbiinvsti,
       modelVar_vbiinvgat,
       modelVar_one_minus_PBOT,
       modelVar_one_minus_PSTI,
       modelVar_one_minus_PGAT,
       modelVar_one_over_one_minus_PBOT,
       modelVar_one_over_one_minus_PSTI,
       modelVar_one_over_one_minus_PGAT,
       modelVar_cjobot,
       modelVar_cjosti,
       modelVar_cjogat,
       modelVar_qprefbot,
       modelVar_qprefsti,
       modelVar_qprefgat,
       modelVar_qpref2bot,
       modelVar_qpref2sti,
       modelVar_qpref2gat,
       modelVar_wdepnulrbot,
       modelVar_wdepnulrsti,
       modelVar_wdepnulrgat,
       modelVar_wdepnulrinvbot,
       modelVar_wdepnulrinvsti,
       modelVar_wdepnulrinvgat,
       modelVar_VBIRBOTinv,
       modelVar_VBIRSTIinv,
       modelVar_VBIRGATinv,
       modelVar_atatbot,
       modelVar_atatsti,
       modelVar_atatgat,
       modelVar_btatpartbot,
       modelVar_btatpartsti,
       modelVar_btatpartgat,
       modelVar_fbbtbot,
       modelVar_fbbtsti,
       modelVar_fbbtgat,
       modelVar_fstopbot,
       modelVar_fstopsti,
       modelVar_fstopgat,
       modelVar_VBRinvbot,
       modelVar_VBRinvsti,
       modelVar_VBRinvgat,
       modelVar_slopebot,
       modelVar_slopesti,
       modelVar_slopegat,
       modelVar_VBIRBOTD_i,
       modelVar_VBIRSTID_i,
       modelVar_VBIRGATD_i,
       modelVar_PBOTD_i,
       modelVar_PSTID_i,
       modelVar_PGATD_i,
       modelVar_CSRHBOTD_i,
       modelVar_CSRHSTID_i,
       modelVar_CSRHGATD_i,
       modelVar_CTATBOTD_i,
       modelVar_CTATSTID_i,
       modelVar_CTATGATD_i,
       modelVar_CBBTBOTD_i,
       modelVar_CBBTSTID_i,
       modelVar_CBBTGATD_i,
       modelVar_VBRBOTD_i,
       modelVar_VBRSTID_i,
       modelVar_VBRGATD_i,
       modelVar_PBRBOTD_i,
       modelVar_PBRSTID_i,
       modelVar_PBRGATD_i,
       modelVar_VJUNREFD_i,
       modelVar_FJUNQD_i,
       modelVar_ftdbot_d,
       modelVar_ftdsti_d,
       modelVar_ftdgat_d,
       modelVar_idsatbot_d,
       modelVar_idsatsti_d,
       modelVar_idsatgat_d,
       modelVar_vbibot_d,
       modelVar_vbisti_d,
       modelVar_vbigat_d,
       modelVar_vbiinvbot_d,
       modelVar_vbiinvsti_d,
       modelVar_vbiinvgat_d,
       modelVar_one_minus_PBOT_d,
       modelVar_one_minus_PSTI_d,
       modelVar_one_minus_PGAT_d,
       modelVar_one_over_one_minus_PBOT_d,
       modelVar_one_over_one_minus_PSTI_d,
       modelVar_one_over_one_minus_PGAT_d,
       modelVar_cjobot_d,
       modelVar_cjosti_d,
       modelVar_cjogat_d,
       modelVar_qprefbot_d,
       modelVar_qprefsti_d,
       modelVar_qprefgat_d,
       modelVar_qpref2bot_d,
       modelVar_qpref2sti_d,
       modelVar_qpref2gat_d,
       modelVar_wdepnulrbot_d,
       modelVar_wdepnulrsti_d,
       modelVar_wdepnulrgat_d,
       modelVar_wdepnulrinvbot_d,
       modelVar_wdepnulrinvsti_d,
       modelVar_wdepnulrinvgat_d,
       modelVar_VBIRBOTinv_d,
       modelVar_VBIRSTIinv_d,
       modelVar_VBIRGATinv_d,
       modelVar_atatbot_d,
       modelVar_atatsti_d,
       modelVar_atatgat_d,
       modelVar_btatpartbot_d,
       modelVar_btatpartsti_d,
       modelVar_btatpartgat_d,
       modelVar_fbbtbot_d,
       modelVar_fbbtsti_d,
       modelVar_fbbtgat_d,
       modelVar_fstopbot_d,
       modelVar_fstopsti_d,
       modelVar_fstopgat_d,
       modelVar_VBRinvbot_d,
       modelVar_VBRinvsti_d,
       modelVar_VBRinvgat_d,
       modelVar_slopebot_d,
       modelVar_slopesti_d,
       modelVar_slopegat_d,
       // non-reals
       modelVar_CHNL_TYPE,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);


    // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_D+inst*(11+0)] += staticContributions[in.admsNodeID_D].dx(0);
    dqdp[in.admsNodeID_D+inst*(11+0)] += dynamicContributions[in.admsNodeID_D].dx(0);
    Findices[in.admsNodeID_D+inst*(11+0)] = in.li_D;
    Qindices[in.admsNodeID_D+inst*(11+0)] = in.li_D;
    dfdp[in.admsNodeID_G+inst*(11+0)] += staticContributions[in.admsNodeID_G].dx(0);
    dqdp[in.admsNodeID_G+inst*(11+0)] += dynamicContributions[in.admsNodeID_G].dx(0);
    Findices[in.admsNodeID_G+inst*(11+0)] = in.li_G;
    Qindices[in.admsNodeID_G+inst*(11+0)] = in.li_G;
    dfdp[in.admsNodeID_S+inst*(11+0)] += staticContributions[in.admsNodeID_S].dx(0);
    dqdp[in.admsNodeID_S+inst*(11+0)] += dynamicContributions[in.admsNodeID_S].dx(0);
    Findices[in.admsNodeID_S+inst*(11+0)] = in.li_S;
    Qindices[in.admsNodeID_S+inst*(11+0)] = in.li_S;
    dfdp[in.admsNodeID_B+inst*(11+0)] += staticContributions[in.admsNodeID_B].dx(0);
    dqdp[in.admsNodeID_B+inst*(11+0)] += dynamicContributions[in.admsNodeID_B].dx(0);
    Findices[in.admsNodeID_B+inst*(11+0)] = in.li_B;
    Qindices[in.admsNodeID_B+inst*(11+0)] = in.li_B;
    dfdp[in.admsNodeID_NOI+inst*(11+0)] += staticContributions[in.admsNodeID_NOI].dx(0);
    dqdp[in.admsNodeID_NOI+inst*(11+0)] += dynamicContributions[in.admsNodeID_NOI].dx(0);
    Findices[in.admsNodeID_NOI+inst*(11+0)] = in.li_NOI;
    Qindices[in.admsNodeID_NOI+inst*(11+0)] = in.li_NOI;
    dfdp[in.admsNodeID_NOI2+inst*(11+0)] += staticContributions[in.admsNodeID_NOI2].dx(0);
    dqdp[in.admsNodeID_NOI2+inst*(11+0)] += dynamicContributions[in.admsNodeID_NOI2].dx(0);
    Findices[in.admsNodeID_NOI2+inst*(11+0)] = in.li_NOI2;
    Qindices[in.admsNodeID_NOI2+inst*(11+0)] = in.li_NOI2;
    dfdp[in.admsNodeID_GP+inst*(11+0)] += staticContributions[in.admsNodeID_GP].dx(0);
    dqdp[in.admsNodeID_GP+inst*(11+0)] += dynamicContributions[in.admsNodeID_GP].dx(0);
    Findices[in.admsNodeID_GP+inst*(11+0)] = in.li_GP;
    Qindices[in.admsNodeID_GP+inst*(11+0)] = in.li_GP;
    dfdp[in.admsNodeID_BP+inst*(11+0)] += staticContributions[in.admsNodeID_BP].dx(0);
    dqdp[in.admsNodeID_BP+inst*(11+0)] += dynamicContributions[in.admsNodeID_BP].dx(0);
    Findices[in.admsNodeID_BP+inst*(11+0)] = in.li_BP;
    Qindices[in.admsNodeID_BP+inst*(11+0)] = in.li_BP;
    dfdp[in.admsNodeID_BI+inst*(11+0)] += staticContributions[in.admsNodeID_BI].dx(0);
    dqdp[in.admsNodeID_BI+inst*(11+0)] += dynamicContributions[in.admsNodeID_BI].dx(0);
    Findices[in.admsNodeID_BI+inst*(11+0)] = in.li_BI;
    Qindices[in.admsNodeID_BI+inst*(11+0)] = in.li_BI;
    dfdp[in.admsNodeID_BS+inst*(11+0)] += staticContributions[in.admsNodeID_BS].dx(0);
    dqdp[in.admsNodeID_BS+inst*(11+0)] += dynamicContributions[in.admsNodeID_BS].dx(0);
    Findices[in.admsNodeID_BS+inst*(11+0)] = in.li_BS;
    Qindices[in.admsNodeID_BS+inst*(11+0)] = in.li_BS;
    dfdp[in.admsNodeID_BD+inst*(11+0)] += staticContributions[in.admsNodeID_BD].dx(0);
    dqdp[in.admsNodeID_BD+inst*(11+0)] += dynamicContributions[in.admsNodeID_BD].dx(0);
    Findices[in.admsNodeID_BD+inst*(11+0)] = in.li_BD;
    Qindices[in.admsNodeID_BD+inst*(11+0)] = in.li_BD;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSPSP102VA
} // namespace Device
} // namespace Xyce
