
//-------------------------------------------------------------------------
//   Copyright 2002-2019 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file psp103.va with ADMS
//                  interface for Xyce 6.12.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
//                  THIS FILE WAS GENERATED WITH AN EXPERIMENTAL VERSION
//                  OF XYCE/ADMS THAT HAS NOT BEEN RELEASED YET.
//                  Do not regenerate this file using the released version,
//                  or you will lose the optimizations that can be performed
//                  by the experimental code.
//
// Creator        : admsXml-2.3.6
//
// Creation Date  : Mon, 08 Apr 2019 14:02:46
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSPSP103VA.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

#include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

#include <algorithm>

namespace Xyce {
namespace Device {
namespace ADMSPSP103VA {


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_D;
const int Instance::admsNodeID_G;
const int Instance::admsNodeID_S;
const int Instance::admsNodeID_B;
const int Instance::admsNodeID_NOI;
const int Instance::admsNodeID_NOI2;
const int Instance::admsNodeID_GP;
const int Instance::admsNodeID_SI;
const int Instance::admsNodeID_DI;
const int Instance::admsNodeID_BP;
const int Instance::admsNodeID_BI;
const int Instance::admsNodeID_BS;
const int Instance::admsNodeID_BD;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSPSP103VA::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSPSP103VA::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("L", static_cast<double>(1.0e-5), &ADMSPSP103VA::Instance::L)
    .setUnit(U_METER)
    .setDescription("Design length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("W", static_cast<double>(1.0e-5), &ADMSPSP103VA::Instance::W)
    .setUnit(U_METER)
    .setDescription("Design width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SA", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SA)
    .setUnit(U_METER)
    .setDescription("Distance between OD-edge and poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SB", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SB)
    .setUnit(U_METER)
    .setDescription("Distance between OD-edge and poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SD", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SD)
    .setUnit(U_METER)
    .setDescription("Distance between neighbouring fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCA", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SCA)
    .setUnit(U_UNKNOWN)
    .setDescription("Integral of the first distribution function for scattered well dopants")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCB", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SCB)
    .setUnit(U_UNKNOWN)
    .setDescription("Integral of the second distribution function for scattered well dopants")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCC", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SCC)
    .setUnit(U_UNKNOWN)
    .setDescription("Integral of the third distribution function for scattered well dopants")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SC", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SC)
    .setUnit(U_METER)
    .setDescription("Distance between OD-edge and nearest well edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NF", static_cast<double>(1.0), &ADMSPSP103VA::Instance::NF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NGCON", static_cast<double>(1.0), &ADMSPSP103VA::Instance::NGCON)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of gate contacts")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XGW", static_cast<double>(1.0e-7), &ADMSPSP103VA::Instance::XGW)
    .setUnit(U_METER)
    .setDescription("Distance from the gate contact to the channel edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NRS", static_cast<double>(0.0), &ADMSPSP103VA::Instance::NRS)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of squares of source diffusion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NRD", static_cast<double>(0.0), &ADMSPSP103VA::Instance::NRD)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of squares of drain diffusion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("JW", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::JW)
    .setUnit(U_METER)
    .setDescription("Gate-edge length of source/drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELVTO", static_cast<double>(0.0), &ADMSPSP103VA::Instance::DELVTO)
    .setUnit(U_VOLT)
    .setDescription("Threshold voltage shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FACTUO", static_cast<double>(1.0), &ADMSPSP103VA::Instance::FACTUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Zero-field mobility pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELVTOEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Instance::DELVTOEDGE)
    .setUnit(U_VOLT)
    .setDescription("Threshold voltage shift parameter of edge transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FACTUOEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Instance::FACTUOEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Zero-field mobility pre-factor of edge transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ABSOURCE", static_cast<double>(1.0e-12), &ADMSPSP103VA::Instance::ABSOURCE)
    .setUnit(U_METER2)
    .setDescription("Bottom area of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LSSOURCE", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::LSSOURCE)
    .setUnit(U_METER)
    .setDescription("STI-edge length of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LGSOURCE", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::LGSOURCE)
    .setUnit(U_METER)
    .setDescription("Gate-edge length of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ABDRAIN", static_cast<double>(1.0e-12), &ADMSPSP103VA::Instance::ABDRAIN)
    .setUnit(U_METER2)
    .setDescription("Bottom area of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LSDRAIN", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::LSDRAIN)
    .setUnit(U_METER)
    .setDescription("STI-edge length of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LGDRAIN", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::LGDRAIN)
    .setUnit(U_METER)
    .setDescription("Gate-edge length of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AS", static_cast<double>(1.0e-12), &ADMSPSP103VA::Instance::AS)
    .setUnit(U_METER2)
    .setDescription("Bottom area of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PS", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::PS)
    .setUnit(U_METER)
    .setDescription("Perimeter of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AD", static_cast<double>(1.0e-12), &ADMSPSP103VA::Instance::AD)
    .setUnit(U_METER2)
    .setDescription("Bottom area of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PD", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::PD)
    .setUnit(U_METER)
    .setDescription("Perimeter of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MULT", static_cast<double>(1.0), &ADMSPSP103VA::Instance::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of devices in parallel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("M", static_cast<double>(1.0), &ADMSPSP103VA::Instance::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription(" Alias for MULT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;


}

void Traits::loadModelParameters(ParametricData<ADMSPSP103VA::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSPSP103VA::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("LEVEL", static_cast<int>(103), &ADMSPSP103VA::Model::LEVEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Model level");
  p.addPar("TYPE", static_cast<int>(1), &ADMSPSP103VA::Model::TYPE)
    .setUnit(U_UNKNOWN)
    .setDescription("Channel type parameter, +1=NMOS -1=PMOS");
  p.addPar("TR", static_cast<double>(21.0), &ADMSPSP103VA::Model::TR)
    .setUnit(U_DEGC)
    .setDescription("nominal (reference) temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SWGEO", static_cast<int>(1), &ADMSPSP103VA::Model::SWGEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for geometrical model, 0=local, 1=global, 2=binning");
  p.addPar("SWIGATE", static_cast<int>(0), &ADMSPSP103VA::Model::SWIGATE)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for gate current, 0=turn off IG");
  p.addPar("SWIMPACT", static_cast<int>(0), &ADMSPSP103VA::Model::SWIMPACT)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for impact ionization current, 0=turn off II");
  p.addPar("SWGIDL", static_cast<int>(0), &ADMSPSP103VA::Model::SWGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for GIDL current, 0=turn off IGIDL");
  p.addPar("SWJUNCAP", static_cast<int>(0), &ADMSPSP103VA::Model::SWJUNCAP)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for juncap, 0=turn off juncap");
  p.addPar("SWJUNASYM", static_cast<int>(0), &ADMSPSP103VA::Model::SWJUNASYM)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for asymmetric junctions; 0=symmetric, 1=asymmetric");
  p.addPar("SWNUD", static_cast<int>(0), &ADMSPSP103VA::Model::SWNUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for NUD-effect; 0=off, 1=on, 2=on+CV-correction");
  p.addPar("SWEDGE", static_cast<int>(0), &ADMSPSP103VA::Model::SWEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for drain current of edge transistors; 0=off, 1=on");
  p.addPar("SWDELVTAC", static_cast<int>(0), &ADMSPSP103VA::Model::SWDELVTAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for separate capacitance calculation; 0=off, 1=on");
  p.addPar("SWIGN", static_cast<int>(1), &ADMSPSP103VA::Model::SWIGN)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for induced gate noise; 0=off, 1=on");
  p.addPar("QMC", static_cast<double>(1.0), &ADMSPSP103VA::Model::QMC)
    .setUnit(U_UNKNOWN)
    .setDescription("Quantum-mechanical correction factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFB", static_cast<double>((-1.0)), &ADMSPSP103VA::Model::VFB)
    .setUnit(U_VOLT)
    .setDescription("Flat band voltage at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFB", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::STVFB)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOX", static_cast<double>(2.0e-09), &ADMSPSP103VA::Model::TOX)
    .setUnit(U_METER)
    .setDescription("Gate oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EPSROX", static_cast<double>(3.9), &ADMSPSP103VA::Model::EPSROX)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative permittivity of gate dielectric")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NEFF", static_cast<double>(5.0e23), &ADMSPSP103VA::Model::NEFF)
    .setUnit(U_METERM3)
    .setDescription("Effective substrate doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FACNEFFAC", static_cast<double>(1.0), &ADMSPSP103VA::Model::FACNEFFAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-factor for effective substrate doping in separate charge calculation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GFACNUD", static_cast<double>(1.0), &ADMSPSP103VA::Model::GFACNUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Body-factor change due to NUD-effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSBNUD", static_cast<double>(0.0), &ADMSPSP103VA::Model::VSBNUD)
    .setUnit(U_VOLT)
    .setDescription("Lower Vsb value for NUD-effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVSBNUD", static_cast<double>(1.0), &ADMSPSP103VA::Model::DVSBNUD)
    .setUnit(U_VOLT)
    .setDescription("Vsb-range for NUD-effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VNSUB", static_cast<double>(0.0), &ADMSPSP103VA::Model::VNSUB)
    .setUnit(U_VOLT)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSLP", static_cast<double>(0.05), &ADMSPSP103VA::Model::NSLP)
    .setUnit(U_VOLT)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DNSUB", static_cast<double>(0.0), &ADMSPSP103VA::Model::DNSUB)
    .setUnit(U_VOLTM1)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIB", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIB)
    .setUnit(U_VOLT)
    .setDescription("Offset parameter for PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELVTAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::DELVTAC)
    .setUnit(U_VOLT)
    .setDescription("Offset parameter for PHIB in separate charge calculation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NP", static_cast<double>(1.0e26), &ADMSPSP103VA::Model::NP)
    .setUnit(U_METERM3)
    .setDescription("Gate poly-silicon doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CT", static_cast<double>(0.0), &ADMSPSP103VA::Model::CT)
    .setUnit(U_UNKNOWN)
    .setDescription("Interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXOV", static_cast<double>(2.0e-09), &ADMSPSP103VA::Model::TOXOV)
    .setUnit(U_METER)
    .setDescription("Overlap oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXOVD", static_cast<double>(2.0e-09), &ADMSPSP103VA::Model::TOXOVD)
    .setUnit(U_METER)
    .setDescription("Overlap oxide thickness for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NOV", static_cast<double>(5.0e25), &ADMSPSP103VA::Model::NOV)
    .setUnit(U_METERM3)
    .setDescription("Effective doping of overlap region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NOVD", static_cast<double>(5.0e25), &ADMSPSP103VA::Model::NOVD)
    .setUnit(U_METERM3)
    .setDescription("Effective doping of overlap region for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CF", static_cast<double>(0.0), &ADMSPSP103VA::Model::CF)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL-parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFD", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFD)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFB)
    .setUnit(U_VOLTM1)
    .setDescription("Back bias dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("Subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCEB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEB)
    .setUnit(U_VOLTM1)
    .setDescription("Bulk voltage dependence parameter of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCED", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCED)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence parameter of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETN", static_cast<double>(7.0e-2), &ADMSPSP103VA::Model::BETN)
    .setUnit(U_M2VM1SM1)
    .setDescription("Channel aspect ratio times zero-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBET", static_cast<double>(1.0), &ADMSPSP103VA::Model::STBET)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MUE", static_cast<double>(0.5), &ADMSPSP103VA::Model::MUE)
    .setUnit(U_MVM1)
    .setDescription("Mobility reduction coefficient at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STMUE", static_cast<double>(0.0), &ADMSPSP103VA::Model::STMUE)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THEMU", static_cast<double>(1.5), &ADMSPSP103VA::Model::THEMU)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STTHEMU", static_cast<double>(1.5), &ADMSPSP103VA::Model::STTHEMU)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of THEMU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CS", static_cast<double>(0.0), &ADMSPSP103VA::Model::CS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coulomb scattering parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STCS", static_cast<double>(0.0), &ADMSPSP103VA::Model::STCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::XCOR)
    .setUnit(U_VOLTM1)
    .setDescription("Non-universality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STXCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::STXCOR)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FETA", static_cast<double>(1.0), &ADMSPSP103VA::Model::FETA)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective field parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RS", static_cast<double>(30.0), &ADMSPSP103VA::Model::RS)
    .setUnit(U_OHM)
    .setDescription("Series resistance at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STRS", static_cast<double>(1.0), &ADMSPSP103VA::Model::STRS)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSB", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSB)
    .setUnit(U_VOLTM1)
    .setDescription("Back-bias dependence of series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSG", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSG)
    .setUnit(U_VOLTM1)
    .setDescription("Gate-bias dependence of series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESAT", static_cast<double>(1.0), &ADMSPSP103VA::Model::THESAT)
    .setUnit(U_VOLTM1)
    .setDescription("Velocity saturation parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STTHESAT", static_cast<double>(1.0), &ADMSPSP103VA::Model::STTHESAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATB", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATB)
    .setUnit(U_VOLTM1)
    .setDescription("Back-bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATG", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATG)
    .setUnit(U_VOLTM1)
    .setDescription("Gate-bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AX", static_cast<double>(3.0), &ADMSPSP103VA::Model::AX)
    .setUnit(U_UNKNOWN)
    .setDescription("Linear/saturation transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP", static_cast<double>(0.01), &ADMSPSP103VA::Model::ALP)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP1", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP1)
    .setUnit(U_VOLT)
    .setDescription("CLM enhancement factor above threshold")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP2", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP2)
    .setUnit(U_VOLTM1)
    .setDescription("CLM enhancement factor below threshold")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VP", static_cast<double>(0.05), &ADMSPSP103VA::Model::VP)
    .setUnit(U_VOLT)
    .setDescription("CLM logarithm dependence factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A1", static_cast<double>(1.0), &ADMSPSP103VA::Model::A1)
    .setUnit(U_UNKNOWN)
    .setDescription("Impact-ionization pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A2", static_cast<double>(10.0), &ADMSPSP103VA::Model::A2)
    .setUnit(U_VOLT)
    .setDescription("Impact-ionization exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STA2", static_cast<double>(0.0), &ADMSPSP103VA::Model::STA2)
    .setUnit(U_VOLT)
    .setDescription("Temperature dependence of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A3", static_cast<double>(1.0), &ADMSPSP103VA::Model::A3)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation-voltage dependence of impact-ionization")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A4", static_cast<double>(0.0), &ADMSPSP103VA::Model::A4)
    .setUnit(U_VOLTMH)
    .setDescription("Back-bias dependence of impact-ionization")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GCO", static_cast<double>(0.0), &ADMSPSP103VA::Model::GCO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate tunnelling energy adjustment")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IGINV", static_cast<double>(0.0), &ADMSPSP103VA::Model::IGINV)
    .setUnit(U_AMP)
    .setDescription("Gate channel current pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::IGOV)
    .setUnit(U_AMP)
    .setDescription("Gate overlap current pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::IGOVD)
    .setUnit(U_AMP)
    .setDescription("Gate overlap current pre-factor for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STIG", static_cast<double>(2.0), &ADMSPSP103VA::Model::STIG)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of IGINV and IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GC2", static_cast<double>(0.375), &ADMSPSP103VA::Model::GC2)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current slope factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GC3", static_cast<double>(0.063), &ADMSPSP103VA::Model::GC3)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current curvature factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CHIB", static_cast<double>(3.1), &ADMSPSP103VA::Model::CHIB)
    .setUnit(U_VOLT)
    .setDescription("Tunnelling barrier height")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::AGIDL)
    .setUnit(U_AMPVM3)
    .setDescription("GIDL pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::AGIDLD)
    .setUnit(U_AMPVM3)
    .setDescription("GIDL pre-factor for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BGIDL", static_cast<double>(41.0), &ADMSPSP103VA::Model::BGIDL)
    .setUnit(U_VOLT)
    .setDescription("GIDL probability factor at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BGIDLD", static_cast<double>(41.0), &ADMSPSP103VA::Model::BGIDLD)
    .setUnit(U_VOLT)
    .setDescription("GIDL probability factor at TR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBGIDL)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of BGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBGIDLD)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of BGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Back-bias dependence of GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::CGIDLD)
    .setUnit(U_UNKNOWN)
    .setDescription("Back-bias dependence of GIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("COX", static_cast<double>(1.0e-14), &ADMSPSP103VA::Model::COX)
    .setUnit(U_FARAD)
    .setDescription("Oxide capacitance for intrinsic channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGOV", static_cast<double>(1.0e-15), &ADMSPSP103VA::Model::CGOV)
    .setUnit(U_FARAD)
    .setDescription("Oxide capacitance for gate-drain/source overlap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGOVD", static_cast<double>(1.0e-15), &ADMSPSP103VA::Model::CGOVD)
    .setUnit(U_FARAD)
    .setDescription("Oxide capacitance for gate-drain overlap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGBOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::CGBOV)
    .setUnit(U_FARAD)
    .setDescription("Oxide capacitance for gate-bulk overlap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFR", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFR)
    .setUnit(U_FARAD)
    .setDescription("Outer fringe capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFRD", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFRD)
    .setUnit(U_FARAD)
    .setDescription("Outer fringe capacitance for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FNT", static_cast<double>(1.0), &ADMSPSP103VA::Model::FNT)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FNTEXC", static_cast<double>(0.0), &ADMSPSP103VA::Model::FNTEXC)
    .setUnit(U_UNKNOWN)
    .setDescription("Excess noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFA", static_cast<double>(8.0e22), &ADMSPSP103VA::Model::NFA)
    .setUnit(U_UNKNOWN)
    .setDescription("First coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFB", static_cast<double>(3.0e07), &ADMSPSP103VA::Model::NFB)
    .setUnit(U_UNKNOWN)
    .setDescription("Second coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFC", static_cast<double>(0.0), &ADMSPSP103VA::Model::NFC)
    .setUnit(U_VOLTM1)
    .setDescription("Third coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EF", static_cast<double>(1.0), &ADMSPSP103VA::Model::EF)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise frequency exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBEDGE", static_cast<double>((-1.0)), &ADMSPSP103VA::Model::VFBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Flat band voltage of edge transistors at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFBEDGE", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::STVFBEDGE)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of VFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Offset parameter for PHIB of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NEFFEDGE", static_cast<double>(5.0e23), &ADMSPSP103VA::Model::NEFFEDGE)
    .setUnit(U_METERM3)
    .setDescription("Effective substrate doping of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Interface states factor of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETNEDGE", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::BETNEDGE)
    .setUnit(U_M2VM1SM1)
    .setDescription("Channel aspect ratio times zero-field mobility of edge transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBETEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Model::STBETEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCEEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCEBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEBEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Bulk voltage dependence parameter of subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCEDEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEDEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence parameter of subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFDEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFDEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence parameter of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFBEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Bulk voltage dependence parameter of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FNTEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Model::FNTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise coefficient of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFAEDGE", static_cast<double>(8.0e22), &ADMSPSP103VA::Model::NFAEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("First coefficient of flicker noise of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFBEDGE", static_cast<double>(3.0e07), &ADMSPSP103VA::Model::NFBEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Second coefficient of flicker noise of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFCEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::NFCEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Third coefficient of flicker noise of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EFEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Model::EFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise frequency exponent of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RG", static_cast<double>(0.0), &ADMSPSP103VA::Model::RG)
    .setUnit(U_OHM)
    .setDescription("Gate resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSE", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSE)
    .setUnit(U_OHM)
    .setDescription("External source resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RDE", static_cast<double>(0.0), &ADMSPSP103VA::Model::RDE)
    .setUnit(U_OHM)
    .setDescription("External drain resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBULK", static_cast<double>(0.0), &ADMSPSP103VA::Model::RBULK)
    .setUnit(U_OHM)
    .setDescription("Bulk resistance between node BP and BI")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RWELL", static_cast<double>(0.0), &ADMSPSP103VA::Model::RWELL)
    .setUnit(U_OHM)
    .setDescription("Well resistance between node BI and B")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RJUNS", static_cast<double>(0.0), &ADMSPSP103VA::Model::RJUNS)
    .setUnit(U_OHM)
    .setDescription("Source-side bulk resistance between node BI and BS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RJUND", static_cast<double>(0.0), &ADMSPSP103VA::Model::RJUND)
    .setUnit(U_OHM)
    .setDescription("Drain-side bulk resistance between node BI and BD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POVFB", static_cast<double>((-1.0)), &ADMSPSP103VA::Model::POVFB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLVFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLVFB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWVFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWVFB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the width dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWVFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWVFB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length times width dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTVFB", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::POSTVFB)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the geometry independent part of STVFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLSTVFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLSTVFB)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the length dependence of STVFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWSTVFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWSTVFB)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the width dependence of STVFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWSTVFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWSTVFB)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the length times width dependence of STVFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POTOX", static_cast<double>(2.0e-9), &ADMSPSP103VA::Model::POTOX)
    .setUnit(U_METER)
    .setDescription("Coefficient for the geometry independent part of TOX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POEPSROX", static_cast<double>(3.9), &ADMSPSP103VA::Model::POEPSROX)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of EPSOX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PONEFF", static_cast<double>(5.0e23), &ADMSPSP103VA::Model::PONEFF)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the geometry independent part of NEFF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLNEFF", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNEFF)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length dependence of NEFF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWNEFF", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNEFF)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the width dependence of NEFF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWNEFF", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNEFF)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length times width dependence of NEFF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POFACNEFFAC", static_cast<double>(1.0), &ADMSPSP103VA::Model::POFACNEFFAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLFACNEFFAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLFACNEFFAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWFACNEFFAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWFACNEFFAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWFACNEFFAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWFACNEFFAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POGFACNUD", static_cast<double>(1.0), &ADMSPSP103VA::Model::POGFACNUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLGFACNUD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLGFACNUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWGFACNUD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWGFACNUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWGFACNUD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWGFACNUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POVSBNUD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POVSBNUD)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of VSBNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PODVSBNUD", static_cast<double>(1.0), &ADMSPSP103VA::Model::PODVSBNUD)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of DVSBNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POVNSUB", static_cast<double>(0.0), &ADMSPSP103VA::Model::POVNSUB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of VNSUB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PONSLP", static_cast<double>(0.05), &ADMSPSP103VA::Model::PONSLP)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of NSLP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PODNSUB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PODNSUB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of DNSUB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PODPHIB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PODPHIB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of DPHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLDPHIB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLDPHIB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length dependence of DPHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWDPHIB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWDPHIB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the width dependence of DPHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWDPHIB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWDPHIB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length times width dependence of DPHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PODELVTAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PODELVTAC)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLDELVTAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLDELVTAC)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length dependence of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWDELVTAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWDELVTAC)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the width dependence of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWDELVTAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWDELVTAC)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length times width dependence of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PONP", static_cast<double>(1.0e26), &ADMSPSP103VA::Model::PONP)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the geometry independent part of NP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLNP", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNP)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length dependence of NP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWNP", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNP)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the width dependence of NP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWNP", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNP)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length times width dependence of NP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCT", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLCT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of CT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWCT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of CT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWCT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of CT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POTOXOV", static_cast<double>(2.0e-09), &ADMSPSP103VA::Model::POTOXOV)
    .setUnit(U_METER)
    .setDescription("Coefficient for the geometry independent part of TOXOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POTOXOVD", static_cast<double>(2.0e-09), &ADMSPSP103VA::Model::POTOXOVD)
    .setUnit(U_METER)
    .setDescription("Coefficient for the geometry independent part of TOXOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PONOV", static_cast<double>(5.0e25), &ADMSPSP103VA::Model::PONOV)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the geometry independent part of NOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLNOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNOV)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length dependence of NOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWNOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNOV)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the width dependence of NOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWNOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNOV)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length times width dependence of NOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PONOVD", static_cast<double>(5.0e25), &ADMSPSP103VA::Model::PONOVD)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the geometry independent part of NOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLNOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNOVD)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length dependence of NOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWNOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNOVD)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the width dependence of NOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWNOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNOVD)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length times width dependence of NOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCF", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCF)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLCF", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCF)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWCF", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCF)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWCF", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCF)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCFD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFD)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of CFD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of CFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POPSCE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POPSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of PSCE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLPSCE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLPSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of PSCE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWPSCE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWPSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of PSCE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWPSCE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWPSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of PSCE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POPSCEB", static_cast<double>(0.0), &ADMSPSP103VA::Model::POPSCEB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of PSCEB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POPSCED", static_cast<double>(0.0), &ADMSPSP103VA::Model::POPSCED)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of PSCED")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POBETN", static_cast<double>(7.0e-2), &ADMSPSP103VA::Model::POBETN)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the geometry independent part of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLBETN", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLBETN)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the length dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWBETN", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWBETN)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the width dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWBETN", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWBETN)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the length times width dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTBET", static_cast<double>(1.0), &ADMSPSP103VA::Model::POSTBET)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STBET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLSTBET", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLSTBET)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of STBET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWSTBET", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWSTBET)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of STBET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWSTBET", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWSTBET)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of STBET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POMUE", static_cast<double>(0.5), &ADMSPSP103VA::Model::POMUE)
    .setUnit(U_MVM1)
    .setDescription("Coefficient for the geometry independent part of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLMUE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLMUE)
    .setUnit(U_MVM1)
    .setDescription("Coefficient for the length dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWMUE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWMUE)
    .setUnit(U_MVM1)
    .setDescription("Coefficient for the width dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWMUE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWMUE)
    .setUnit(U_MVM1)
    .setDescription("Coefficient for the length times width dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTMUE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTMUE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STMUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POTHEMU", static_cast<double>(1.5), &ADMSPSP103VA::Model::POTHEMU)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of THEMU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTTHEMU", static_cast<double>(1.5), &ADMSPSP103VA::Model::POSTTHEMU)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STTHEMU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCS", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLCS", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWCS", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWCS", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTCS", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STCS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POXCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::POXCOR)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLXCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLXCOR)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWXCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWXCOR)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWXCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWXCOR)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTXCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTXCOR)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STXCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POFETA", static_cast<double>(1.0), &ADMSPSP103VA::Model::POFETA)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of FETA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PORS", static_cast<double>(30.0), &ADMSPSP103VA::Model::PORS)
    .setUnit(U_OHM)
    .setDescription("Coefficient for the geometry independent part of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLRS", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLRS)
    .setUnit(U_OHM)
    .setDescription("Coefficient for the length dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWRS", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWRS)
    .setUnit(U_OHM)
    .setDescription("Coefficient for the width dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWRS", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWRS)
    .setUnit(U_OHM)
    .setDescription("Coefficient for the length times width dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTRS", static_cast<double>(1.0), &ADMSPSP103VA::Model::POSTRS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STRS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PORSB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PORSB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of RSB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PORSG", static_cast<double>(0.0), &ADMSPSP103VA::Model::PORSG)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of RSG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POTHESAT", static_cast<double>(1.0), &ADMSPSP103VA::Model::POTHESAT)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLTHESAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLTHESAT)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWTHESAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWTHESAT)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWTHESAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWTHESAT)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTTHESAT", static_cast<double>(1.0), &ADMSPSP103VA::Model::POSTTHESAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STTHESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLSTTHESAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLSTTHESAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of STTHESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWSTTHESAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWSTTHESAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of STTHESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWSTTHESAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWSTTHESAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of STTHESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POTHESATB", static_cast<double>(0.0), &ADMSPSP103VA::Model::POTHESATB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of THESATB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLTHESATB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLTHESATB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of THESATB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWTHESATB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWTHESATB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of THESATB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWTHESATB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWTHESATB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of THESATB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POTHESATG", static_cast<double>(0.0), &ADMSPSP103VA::Model::POTHESATG)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of THESATG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLTHESATG", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLTHESATG)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of THESATG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWTHESATG", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWTHESATG)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of THESATG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWTHESATG", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWTHESATG)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of THESATG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POAX", static_cast<double>(3.0), &ADMSPSP103VA::Model::POAX)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLAX", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLAX)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWAX", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWAX)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWAX", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWAX)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POALP", static_cast<double>(1.0e-2), &ADMSPSP103VA::Model::POALP)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLALP", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLALP)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWALP", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWALP)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWALP", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWALP)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POALP1", static_cast<double>(0.0), &ADMSPSP103VA::Model::POALP1)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLALP1", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLALP1)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWALP1", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWALP1)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the width dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWALP1", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWALP1)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length times width dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POALP2", static_cast<double>(0.0), &ADMSPSP103VA::Model::POALP2)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLALP2", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLALP2)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWALP2", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWALP2)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWALP2", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWALP2)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POVP", static_cast<double>(0.05), &ADMSPSP103VA::Model::POVP)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of VP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POA1", static_cast<double>(1.0), &ADMSPSP103VA::Model::POA1)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLA1", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLA1)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWA1", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWA1)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWA1", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWA1)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POA2", static_cast<double>(10.0), &ADMSPSP103VA::Model::POA2)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTA2", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTA2)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of STA2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POA3", static_cast<double>(1.0), &ADMSPSP103VA::Model::POA3)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLA3", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLA3)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWA3", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWA3)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWA3", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWA3)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POA4", static_cast<double>(0.0), &ADMSPSP103VA::Model::POA4)
    .setUnit(U_VOLTMH)
    .setDescription("Coefficient for the geometry independent part of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLA4", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLA4)
    .setUnit(U_VOLTMH)
    .setDescription("Coefficient for the length dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWA4", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWA4)
    .setUnit(U_VOLTMH)
    .setDescription("Coefficient for the width dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWA4", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWA4)
    .setUnit(U_VOLTMH)
    .setDescription("Coefficient for the length times width dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POGCO", static_cast<double>(0.0), &ADMSPSP103VA::Model::POGCO)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of GCO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POIGINV", static_cast<double>(0.0), &ADMSPSP103VA::Model::POIGINV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the geometry independent part of IGINV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLIGINV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLIGINV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the length dependence of IGINV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWIGINV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWIGINV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the width dependence of IGINV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWIGINV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWIGINV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the length times width dependence of IGINV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POIGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::POIGOV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the geometry independent part of IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLIGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLIGOV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the length dependence of IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWIGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWIGOV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the width dependence of IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWIGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWIGOV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the length times width dependence of IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POIGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POIGOVD)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the geometry independent part of IGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLIGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLIGOVD)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the length dependence of IGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWIGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWIGOVD)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the width dependence of IGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWIGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWIGOVD)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the length times width dependence of IGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTIG", static_cast<double>(2.0), &ADMSPSP103VA::Model::POSTIG)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STIG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POGC2", static_cast<double>(0.375), &ADMSPSP103VA::Model::POGC2)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of GC2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POGC3", static_cast<double>(0.063), &ADMSPSP103VA::Model::POGC3)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of GC3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCHIB", static_cast<double>(3.1), &ADMSPSP103VA::Model::POCHIB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of CHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POAGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::POAGIDL)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the geometry independent part of AGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLAGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLAGIDL)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the length dependence of AGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWAGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWAGIDL)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the width dependence of AGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWAGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWAGIDL)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the length times width dependence of AGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POAGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POAGIDLD)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the geometry independent part of AGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLAGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLAGIDLD)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the length dependence of AGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWAGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWAGIDLD)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the width dependence of AGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWAGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWAGIDLD)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the length times width dependence of AGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POBGIDL", static_cast<double>(41.0), &ADMSPSP103VA::Model::POBGIDL)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of BGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POBGIDLD", static_cast<double>(41.0), &ADMSPSP103VA::Model::POBGIDLD)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of BGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTBGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTBGIDL)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the geometry independent part of STBGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTBGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTBGIDLD)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the geometry independent part of STBGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCGIDLD)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCOX", static_cast<double>(1.0e-14), &ADMSPSP103VA::Model::POCOX)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the geometry independent part of COX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLCOX", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCOX)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length dependence of COX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWCOX", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCOX)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the width dependence of COX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWCOX", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCOX)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length times width dependence of COX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCGOV", static_cast<double>(1.0e-15), &ADMSPSP103VA::Model::POCGOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the geometry independent part of CGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLCGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCGOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length dependence of CGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWCGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCGOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the width dependence of CGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWCGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCGOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length times width dependence of CGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCGOVD", static_cast<double>(1.0e-15), &ADMSPSP103VA::Model::POCGOVD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the geometry independent part of CGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLCGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCGOVD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length dependence of CGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWCGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCGOVD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the width dependence of CGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWCGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCGOVD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length times width dependence of CGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCGBOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCGBOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the geometry independent part of CGBOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLCGBOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCGBOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length dependence of CGBOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWCGBOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCGBOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the width dependence of CGBOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWCGBOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCGBOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length times width dependence of CGBOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCFR", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFR)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the geometry independent part of CFR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLCFR", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCFR)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length dependence of CFR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWCFR", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCFR)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the width dependence of CFR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWCFR", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCFR)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length times width dependence of CFR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCFRD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFRD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the geometry independent part of CFR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLCFRD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCFRD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length dependence of CFR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWCFRD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCFRD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the width dependence of CFR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWCFRD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCFRD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length times width dependence of CFR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POFNT", static_cast<double>(1.0), &ADMSPSP103VA::Model::POFNT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of FNT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POFNTEXC", static_cast<double>(0.0), &ADMSPSP103VA::Model::POFNTEXC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of FNTEXC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLFNTEXC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLFNTEXC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of FNTEXC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWFNTEXC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWFNTEXC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of FNTEXC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWFNTEXC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWFNTEXC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of FNTEXC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PONFA", static_cast<double>(8.0e22), &ADMSPSP103VA::Model::PONFA)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of NFA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLNFA", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNFA)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of NFA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWNFA", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNFA)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of NFA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWNFA", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNFA)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of NFA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PONFB", static_cast<double>(3.0e7), &ADMSPSP103VA::Model::PONFB)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of NFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLNFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNFB)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of NFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWNFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNFB)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of NFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWNFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNFB)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of NFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PONFC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PONFC)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of NFC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLNFC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNFC)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of NFC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWNFC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNFC)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of NFC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWNFC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNFC)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of NFC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POEF", static_cast<double>(1.0), &ADMSPSP103VA::Model::POEF)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the flicker noise frequency exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POVFBEDGE", static_cast<double>((-1.0)), &ADMSPSP103VA::Model::POVFBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of VFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTVFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTVFBEDGE)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the geometry independent part of STVFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLSTVFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLSTVFBEDGE)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the length dependence of STVFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWSTVFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWSTVFBEDGE)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the width dependence of STVFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWSTVFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWSTVFBEDGE)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the length times width dependence of STVFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PODPHIBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PODPHIBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of DPHIBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLDPHIBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLDPHIBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length dependence of DPHIBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWDPHIBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWDPHIBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the width dependence of DPHIBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWDPHIBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWDPHIBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length times width dependence of DPHIBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PONEFFEDGE", static_cast<double>(5.0e23), &ADMSPSP103VA::Model::PONEFFEDGE)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the geometry independent part of NEFFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLNEFFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNEFFEDGE)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length dependence of NEFFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWNEFFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNEFFEDGE)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the width dependence of NEFFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWNEFFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNEFFEDGE)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length times width dependence of NEFFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCTEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CTEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLCTEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of CTEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWCTEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of CTEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWCTEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of CTEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POBETNEDGE", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::POBETNEDGE)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the geometry independent part of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLBETNEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLBETNEDGE)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the length dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWBETNEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWBETNEDGE)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the width dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWBETNEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWBETNEDGE)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the length times width dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POSTBETEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Model::POSTBETEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STBETEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLSTBETEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLSTBETEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of STBETEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWSTBETEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWSTBETEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of STBETEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWSTBETEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWSTBETEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of STBETEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POPSCEEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POPSCEEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of PSCEEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLPSCEEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLPSCEEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of PSCEEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWPSCEEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWPSCEEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of PSCEEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWPSCEEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWPSCEEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of PSCEEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POPSCEBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POPSCEBEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of PSCEBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POPSCEDEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POPSCEDEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of PSCEDEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLCFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of CFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWCFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of CFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWCFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of CFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCFDEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFDEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of CFDEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POCFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFBEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of CFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POFNTEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Model::POFNTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of FNTEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PONFAEDGE", static_cast<double>(8.0e22), &ADMSPSP103VA::Model::PONFAEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of NFAEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLNFAEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNFAEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of NFAEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWNFAEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNFAEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of NFAEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWNFAEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNFAEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of NFAEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PONFBEDGE", static_cast<double>(3.0e7), &ADMSPSP103VA::Model::PONFBEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of NFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLNFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNFBEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of NFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWNFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNFBEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of NFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWNFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNFBEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of NFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PONFCEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PONFCEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of NFCEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLNFCEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNFCEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of NFCEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWNFCEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNFCEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of NFCEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWNFCEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNFCEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of NFCEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POEFEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Model::POEFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of EFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POKVTHOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POKVTHOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of KVTHOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLKVTHOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLKVTHOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence part of KVTHOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWKVTHOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWKVTHOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence part of KVTHOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWKVTHOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWKVTHOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence part of KVTHOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("POKUOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POKUOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of KUOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLKUOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLKUOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence part of KUOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PWKUOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWKUOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence part of KUOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PLWKUOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWKUOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence part of KUOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LMIN", static_cast<double>(0), &ADMSPSP103VA::Model::LMIN)
    .setUnit(U_METER)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LMAX", static_cast<double>(1.0), &ADMSPSP103VA::Model::LMAX)
    .setUnit(U_METER)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WMIN", static_cast<double>(0.0), &ADMSPSP103VA::Model::WMIN)
    .setUnit(U_METER)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WMAX", static_cast<double>(1.0), &ADMSPSP103VA::Model::WMAX)
    .setUnit(U_METER)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVARO", static_cast<double>(0.0), &ADMSPSP103VA::Model::LVARO)
    .setUnit(U_METER)
    .setDescription("Geom. independent difference between actual and programmed gate length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVARL", static_cast<double>(0.0), &ADMSPSP103VA::Model::LVARL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of LVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LVARW", static_cast<double>(0.0), &ADMSPSP103VA::Model::LVARW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of LVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LAP", static_cast<double>(0.0), &ADMSPSP103VA::Model::LAP)
    .setUnit(U_METER)
    .setDescription("Effective channel length reduction per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WVARO", static_cast<double>(0.0), &ADMSPSP103VA::Model::WVARO)
    .setUnit(U_METER)
    .setDescription("Geom. independent difference between actual and programmed field-oxide opening")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WVARL", static_cast<double>(0.0), &ADMSPSP103VA::Model::WVARL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of WVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WVARW", static_cast<double>(0.0), &ADMSPSP103VA::Model::WVARW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of WVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WOT", static_cast<double>(0.0), &ADMSPSP103VA::Model::WOT)
    .setUnit(U_METER)
    .setDescription("Effective channel width reduction per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DLQ", static_cast<double>(0.0), &ADMSPSP103VA::Model::DLQ)
    .setUnit(U_METER)
    .setDescription("Effective channel length reduction for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DWQ", static_cast<double>(0.0), &ADMSPSP103VA::Model::DWQ)
    .setUnit(U_METER)
    .setDescription("Effective channel width reduction for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBO", static_cast<double>((-1.0)), &ADMSPSP103VA::Model::VFBO)
    .setUnit(U_VOLT)
    .setDescription("Geometry-independent flat-band voltage at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBL", static_cast<double>(0.0), &ADMSPSP103VA::Model::VFBL)
    .setUnit(U_VOLT)
    .setDescription("Length dependence of flat-band voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBW", static_cast<double>(0.0), &ADMSPSP103VA::Model::VFBW)
    .setUnit(U_VOLT)
    .setDescription("Width dependence of flat-band voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::VFBLW)
    .setUnit(U_VOLT)
    .setDescription("Area dependence of flat-band voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFBO", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::STVFBO)
    .setUnit(U_VKM1)
    .setDescription("Geometry-independent temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFBL", static_cast<double>(0.0), &ADMSPSP103VA::Model::STVFBL)
    .setUnit(U_VKM1)
    .setDescription("Length dependence of temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFBW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STVFBW)
    .setUnit(U_VKM1)
    .setDescription("Width dependence of temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFBLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STVFBLW)
    .setUnit(U_VKM1)
    .setDescription("Area dependence of temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXO", static_cast<double>(2.0e-9), &ADMSPSP103VA::Model::TOXO)
    .setUnit(U_METER)
    .setDescription("Gate oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EPSROXO", static_cast<double>(3.9), &ADMSPSP103VA::Model::EPSROXO)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative permittivity of gate dielectric")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSUBO", static_cast<double>(3.0e23), &ADMSPSP103VA::Model::NSUBO)
    .setUnit(U_METERM3)
    .setDescription("Geometry independent substrate doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSUBW", static_cast<double>(0.0), &ADMSPSP103VA::Model::NSUBW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of background doping NSUBO due to segregation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WSEG", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::WSEG)
    .setUnit(U_METER)
    .setDescription("Char. length of segregation of background doping NSUBO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPCK", static_cast<double>(1.0e24), &ADMSPSP103VA::Model::NPCK)
    .setUnit(U_METERM3)
    .setDescription("Pocket doping level")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPCKW", static_cast<double>(0.0), &ADMSPSP103VA::Model::NPCKW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of pocket doping NPCK due to segregation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WSEGP", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::WSEGP)
    .setUnit(U_METER)
    .setDescription("Char. length of segregation of pocket doping NPCK")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPCK", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::LPCK)
    .setUnit(U_METER)
    .setDescription("Char. length of lateral doping profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPCKW", static_cast<double>(0.0), &ADMSPSP103VA::Model::LPCKW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of char. length of lateral doping profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FOL1", static_cast<double>(0.0), &ADMSPSP103VA::Model::FOL1)
    .setUnit(U_UNKNOWN)
    .setDescription("First length dependence coefficient for short channel body effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FOL2", static_cast<double>(0.0), &ADMSPSP103VA::Model::FOL2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second length dependence coefficient for short channel body effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FACNEFFACO", static_cast<double>(1.0), &ADMSPSP103VA::Model::FACNEFFACO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geom. independent pre-factor for effective substrate doping in separate charge calculation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FACNEFFACL", static_cast<double>(0.0), &ADMSPSP103VA::Model::FACNEFFACL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FACNEFFACW", static_cast<double>(0.0), &ADMSPSP103VA::Model::FACNEFFACW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FACNEFFACLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::FACNEFFACLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GFACNUDO", static_cast<double>(1.0), &ADMSPSP103VA::Model::GFACNUDO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geom. independent body-factor change due to NUD-effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GFACNUDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::GFACNUDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GFACNUDLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::GFACNUDLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GFACNUDW", static_cast<double>(0.0), &ADMSPSP103VA::Model::GFACNUDW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GFACNUDLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::GFACNUDLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VSBNUDO", static_cast<double>(0.0), &ADMSPSP103VA::Model::VSBNUDO)
    .setUnit(U_VOLT)
    .setDescription("Lower Vsb value for NUD-effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVSBNUDO", static_cast<double>(1.0), &ADMSPSP103VA::Model::DVSBNUDO)
    .setUnit(U_VOLT)
    .setDescription("Vsb range for NUD-effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VNSUBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::VNSUBO)
    .setUnit(U_VOLT)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSLPO", static_cast<double>(0.05), &ADMSPSP103VA::Model::NSLPO)
    .setUnit(U_VOLT)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DNSUBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::DNSUBO)
    .setUnit(U_VOLTM1)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBO)
    .setUnit(U_VOLT)
    .setDescription("Geometry independent offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBL", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBL)
    .setUnit(U_VOLT)
    .setDescription("Length dependence offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::DPHIBLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBW", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBW)
    .setUnit(U_VOLT)
    .setDescription("Width dependence of offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBLW)
    .setUnit(U_VOLT)
    .setDescription("Area dependence of offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELVTACO", static_cast<double>(0.0), &ADMSPSP103VA::Model::DELVTACO)
    .setUnit(U_VOLT)
    .setDescription("Geom. independent offset parameter for PHIB in separate charge calculation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELVTACL", static_cast<double>(0.0), &ADMSPSP103VA::Model::DELVTACL)
    .setUnit(U_VOLT)
    .setDescription("Length dependence of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELVTACLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::DELVTACLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of offset of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELVTACW", static_cast<double>(0.0), &ADMSPSP103VA::Model::DELVTACW)
    .setUnit(U_VOLT)
    .setDescription("Width dependence of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELVTACLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::DELVTACLW)
    .setUnit(U_VOLT)
    .setDescription("Area dependence of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPO", static_cast<double>(1.0e26), &ADMSPSP103VA::Model::NPO)
    .setUnit(U_METERM3)
    .setDescription("Geometry-independent gate poly-silicon doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NPL", static_cast<double>(0.0), &ADMSPSP103VA::Model::NPL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of gate poly-silicon doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry-independent interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::CTLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXOVO", static_cast<double>(2.0e-9), &ADMSPSP103VA::Model::TOXOVO)
    .setUnit(U_METER)
    .setDescription("Overlap oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TOXOVDO", static_cast<double>(2.0e-9), &ADMSPSP103VA::Model::TOXOVDO)
    .setUnit(U_METER)
    .setDescription("Overlap oxide thickness for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::LOV)
    .setUnit(U_METER)
    .setDescription("Overlap length for gate/drain and gate/source overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::LOVD)
    .setUnit(U_METER)
    .setDescription("Overlap length for gate/drain overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NOVO", static_cast<double>(5e25), &ADMSPSP103VA::Model::NOVO)
    .setUnit(U_METERM3)
    .setDescription("Effective doping of overlap region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NOVDO", static_cast<double>(5e25), &ADMSPSP103VA::Model::NOVDO)
    .setUnit(U_METERM3)
    .setDescription("Effective doping of overlap region for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of DIBL-parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFLEXP", static_cast<double>(2.0), &ADMSPSP103VA::Model::CFLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFDO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFDO)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFBO)
    .setUnit(U_VOLTM1)
    .setDescription("Back-bias dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCELEXP", static_cast<double>(2.0), &ADMSPSP103VA::Model::PSCELEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCEBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEBO)
    .setUnit(U_VOLTM1)
    .setDescription("Bulk voltage dependence parameter of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCEDO", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEDO)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence parameter of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("UO", static_cast<double>(5.0e-2), &ADMSPSP103VA::Model::UO)
    .setUnit(U_M2VM1SM1)
    .setDescription("Zero-field mobility at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBET1", static_cast<double>(0.0), &ADMSPSP103VA::Model::FBET1)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative mobility decrease due to first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBET1W", static_cast<double>(0.0), &ADMSPSP103VA::Model::FBET1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of relative mobility decrease due to first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LP1", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::LP1)
    .setUnit(U_METER)
    .setDescription("Mobility-related characteristic length of first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LP1W", static_cast<double>(0.0), &ADMSPSP103VA::Model::LP1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of mobility-related characteristic length of first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBET2", static_cast<double>(0.0), &ADMSPSP103VA::Model::FBET2)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative mobility decrease due to second lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LP2", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::LP2)
    .setUnit(U_METER)
    .setDescription("Mobility-related characteristic length of second lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETW1", static_cast<double>(0.0), &ADMSPSP103VA::Model::BETW1)
    .setUnit(U_UNKNOWN)
    .setDescription("First higher-order width scaling coefficient of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETW2", static_cast<double>(0.0), &ADMSPSP103VA::Model::BETW2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second higher-order width scaling coefficient of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WBET", static_cast<double>(1.0e-9), &ADMSPSP103VA::Model::WBET)
    .setUnit(U_METER)
    .setDescription("Characteristic width for width scaling of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBETO", static_cast<double>(1.0), &ADMSPSP103VA::Model::STBETO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBETL", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBETL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBETW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBETW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBETLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBETLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MUEO", static_cast<double>(0.5), &ADMSPSP103VA::Model::MUEO)
    .setUnit(U_MVM1)
    .setDescription("Geometry independent mobility reduction coefficient at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MUEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::MUEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of mobility reduction coefficient at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STMUEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::STMUEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THEMUO", static_cast<double>(1.5), &ADMSPSP103VA::Model::THEMUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STTHEMUO", static_cast<double>(1.5), &ADMSPSP103VA::Model::STTHEMUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of THEMU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent coulomb scattering parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CSL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::CSLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CSLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STCSO", static_cast<double>(0.0), &ADMSPSP103VA::Model::STCSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCORO", static_cast<double>(0.0), &ADMSPSP103VA::Model::XCORO)
    .setUnit(U_VOLTM1)
    .setDescription("Geometry independent non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCORL", static_cast<double>(0.0), &ADMSPSP103VA::Model::XCORL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCORW", static_cast<double>(0.0), &ADMSPSP103VA::Model::XCORW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XCORLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::XCORLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STXCORO", static_cast<double>(0.0), &ADMSPSP103VA::Model::STXCORO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FETAO", static_cast<double>(1.0), &ADMSPSP103VA::Model::FETAO)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective field parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSW1", static_cast<double>(50.0), &ADMSPSP103VA::Model::RSW1)
    .setUnit(U_OHM)
    .setDescription("Source/drain series resistance for 1 um wide channel at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSW2", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSW2)
    .setUnit(U_UNKNOWN)
    .setDescription("Higher-order width scaling of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STRSO", static_cast<double>(1.0), &ADMSPSP103VA::Model::STRSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSBO)
    .setUnit(U_VOLTM1)
    .setDescription("Back-bias dependence of series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSGO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSGO)
    .setUnit(U_VOLTM1)
    .setDescription("Gate-bias dependence of series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATO", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATO)
    .setUnit(U_VOLTM1)
    .setDescription("Geometry independent velocity saturation parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATL", static_cast<double>(0.05), &ADMSPSP103VA::Model::THESATL)
    .setUnit(U_VOLTM1)
    .setDescription("Length dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::THESATLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATW", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of velocity saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of velocity saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STTHESATO", static_cast<double>(1.0), &ADMSPSP103VA::Model::STTHESATO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STTHESATL", static_cast<double>(0.0), &ADMSPSP103VA::Model::STTHESATL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STTHESATW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STTHESATW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STTHESATLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STTHESATLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATBO)
    .setUnit(U_VOLTM1)
    .setDescription("Back-bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THESATGO", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATGO)
    .setUnit(U_VOLTM1)
    .setDescription("Gate-bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AXO", static_cast<double>(18.0), &ADMSPSP103VA::Model::AXO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent linear/saturation transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AXL", static_cast<double>(0.4), &ADMSPSP103VA::Model::AXL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPL", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::ALPL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::ALPLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPW", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALPW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP1L1", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP1L1)
    .setUnit(U_VOLT)
    .setDescription("Length dependence of CLM enhancement factor above threshold")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP1LEXP", static_cast<double>(0.5), &ADMSPSP103VA::Model::ALP1LEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP1L2", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP1L2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second_order length dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP1W", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP2L1", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP2L1)
    .setUnit(U_VOLTM1)
    .setDescription("Length dependence of CLM enhancement factor below threshold")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP2LEXP", static_cast<double>(0.5), &ADMSPSP103VA::Model::ALP2LEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP2L2", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP2L2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second_order length dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALP2W", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP2W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VPO", static_cast<double>(0.05), &ADMSPSP103VA::Model::VPO)
    .setUnit(U_VOLT)
    .setDescription("CLM logarithmic dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A1O", static_cast<double>(1.0), &ADMSPSP103VA::Model::A1O)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent impact-ionization pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A1L", static_cast<double>(0.0), &ADMSPSP103VA::Model::A1L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A1W", static_cast<double>(0.0), &ADMSPSP103VA::Model::A1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A2O", static_cast<double>(10.0), &ADMSPSP103VA::Model::A2O)
    .setUnit(U_VOLT)
    .setDescription("Impact-ionization exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STA2O", static_cast<double>(0.0), &ADMSPSP103VA::Model::STA2O)
    .setUnit(U_VOLT)
    .setDescription("Temperature dependence of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A3O", static_cast<double>(1.0), &ADMSPSP103VA::Model::A3O)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent saturation-voltage dependence of II")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A3L", static_cast<double>(0.0), &ADMSPSP103VA::Model::A3L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A3W", static_cast<double>(0.0), &ADMSPSP103VA::Model::A3W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A4O", static_cast<double>(0.0), &ADMSPSP103VA::Model::A4O)
    .setUnit(U_VOLTMH)
    .setDescription("Geometry independent back-bias dependence of II")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A4L", static_cast<double>(0.0), &ADMSPSP103VA::Model::A4L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("A4W", static_cast<double>(0.0), &ADMSPSP103VA::Model::A4W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GCOO", static_cast<double>(0.0), &ADMSPSP103VA::Model::GCOO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate tunnelling energy adjustment")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IGINVLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::IGINVLW)
    .setUnit(U_AMP)
    .setDescription("Gate channel current pre-factor for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IGOVW", static_cast<double>(0.0), &ADMSPSP103VA::Model::IGOVW)
    .setUnit(U_AMP)
    .setDescription("Gate overlap current pre-factor for 1 um wide channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IGOVDW", static_cast<double>(0.0), &ADMSPSP103VA::Model::IGOVDW)
    .setUnit(U_AMP)
    .setDescription("Gate overlap current pre-factor for 1 um wide channel for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STIGO", static_cast<double>(2.0), &ADMSPSP103VA::Model::STIGO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of IGINV and IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GC2O", static_cast<double>(0.375), &ADMSPSP103VA::Model::GC2O)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current slope factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GC3O", static_cast<double>(0.063), &ADMSPSP103VA::Model::GC3O)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current curvature factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CHIBO", static_cast<double>(3.1), &ADMSPSP103VA::Model::CHIBO)
    .setUnit(U_VOLT)
    .setDescription("Tunnelling barrier height")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGIDLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::AGIDLW)
    .setUnit(U_AMPVM3)
    .setDescription("Width dependence of GIDL pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AGIDLDW", static_cast<double>(0.0), &ADMSPSP103VA::Model::AGIDLDW)
    .setUnit(U_AMPVM3)
    .setDescription("Width dependence of GIDL pre-factor for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BGIDLO", static_cast<double>(41.0), &ADMSPSP103VA::Model::BGIDLO)
    .setUnit(U_VOLT)
    .setDescription("GIDL probability factor at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BGIDLDO", static_cast<double>(41.0), &ADMSPSP103VA::Model::BGIDLDO)
    .setUnit(U_VOLT)
    .setDescription("GIDL probability factor at TR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBGIDLO", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBGIDLO)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of BGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBGIDLDO", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBGIDLDO)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of BGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGIDLO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CGIDLO)
    .setUnit(U_UNKNOWN)
    .setDescription("Back-bias dependence of GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGIDLDO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CGIDLDO)
    .setUnit(U_UNKNOWN)
    .setDescription("Back-bias dependence of GIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CGBOVL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CGBOVL)
    .setUnit(U_FARAD)
    .setDescription("Oxide capacitance for gate-bulk overlap for 1 um long channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFRW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFRW)
    .setUnit(U_FARAD)
    .setDescription("Outer fringe capacitance for 1 um wide channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFRDW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFRDW)
    .setUnit(U_FARAD)
    .setDescription("Outer fringe capacitance for 1 um wide channel for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FNTO", static_cast<double>(1.0), &ADMSPSP103VA::Model::FNTO)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FNTEXCL", static_cast<double>(0.0), &ADMSPSP103VA::Model::FNTEXCL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of excess noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFALW", static_cast<double>(8.0e22), &ADMSPSP103VA::Model::NFALW)
    .setUnit(U_UNKNOWN)
    .setDescription("First coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFBLW", static_cast<double>(3.0e7), &ADMSPSP103VA::Model::NFBLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Second coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFCLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::NFCLW)
    .setUnit(U_VOLTM1)
    .setDescription("Third coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EFO", static_cast<double>(1.0), &ADMSPSP103VA::Model::EFO)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise frequency exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LINTNOI", static_cast<double>(0.0), &ADMSPSP103VA::Model::LINTNOI)
    .setUnit(U_METER)
    .setDescription("Length offset for flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALPNOI", static_cast<double>(2.0), &ADMSPSP103VA::Model::ALPNOI)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length offset for flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WEDGE", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::WEDGE)
    .setUnit(U_METER)
    .setDescription("Electrical width of edge transistor per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::WEDGEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of edge WEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VFBEDGEO", static_cast<double>((-1.0)), &ADMSPSP103VA::Model::VFBEDGEO)
    .setUnit(U_VOLT)
    .setDescription("Geometry-independent flat-band voltage of edge transistors at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFBEDGEO", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::STVFBEDGEO)
    .setUnit(U_VKM1)
    .setDescription("Geometry-independent temperature dependence of VFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFBEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::STVFBEDGEL)
    .setUnit(U_VKM1)
    .setDescription("Length dependence of temperature dependence of VFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFBEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STVFBEDGEW)
    .setUnit(U_VKM1)
    .setDescription("Width dependence of temperature dependence of VFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STVFBEDGELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STVFBEDGELW)
    .setUnit(U_VKM1)
    .setDescription("Area dependence of temperature dependence of VFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBEDGEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBEDGEO)
    .setUnit(U_VOLT)
    .setDescription("Geometry independent of edge transistor PHIB offset")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBEDGEL)
    .setUnit(U_VOLT)
    .setDescription("Length dependence of edge transistor PHIB offset")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBEDGELEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::DPHIBEDGELEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of edge transistor PHIB offset")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBEDGEW)
    .setUnit(U_VOLT)
    .setDescription("Width dependence of edge transistor PHIB offset")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DPHIBEDGELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBEDGELW)
    .setUnit(U_VOLT)
    .setDescription("Area dependence of edge transistor PHIB offset")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSUBEDGEO", static_cast<double>(5.0e23), &ADMSPSP103VA::Model::NSUBEDGEO)
    .setUnit(U_METERM3)
    .setDescription("Geometry independent substrate doping of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSUBEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::NSUBEDGEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of edge transistor substrate doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSUBEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::NSUBEDGEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of edge transistor substrate doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NSUBEDGELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::NSUBEDGELW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of edge transistor substrate doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTEDGEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTEDGEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry-independent interface states factor of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTEDGEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of interface states factor of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTEDGELEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::CTEDGELEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of interface states factor of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBETEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::FBETEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of edge transistor mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LPEDGE", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::LPEDGE)
    .setUnit(U_METER)
    .setDescription("Exponent for length dependence of edge transistor mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("BETEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::BETEDGEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width scaling coefficient of edge transistor mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBETEDGEO", static_cast<double>(1.0), &ADMSPSP103VA::Model::STBETEDGEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent temperature dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBETEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBETEDGEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of temperature dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBETEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBETEDGEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of temperature dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STBETEDGELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBETEDGELW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of temperature dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCEEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEEDGEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCEEDGELEXP", static_cast<double>(2.0), &ADMSPSP103VA::Model::PSCEEDGELEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCEEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEEDGEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of subthreshold slope coefficient for short channel edge transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCEBEDGEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEBEDGEO)
    .setUnit(U_VOLTM1)
    .setDescription("Bulk voltage dependence parameter of subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSCEDEDGEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEDEDGEO)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence parameter of subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFEDGEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFEDGELEXP", static_cast<double>(2.0), &ADMSPSP103VA::Model::CFEDGELEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFEDGEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFDEDGEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFDEDGEO)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence parameter of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFBEDGEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFBEDGEO)
    .setUnit(U_VOLTM1)
    .setDescription("Bulk voltage dependence parameter of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FNTEDGEO", static_cast<double>(1.0), &ADMSPSP103VA::Model::FNTEDGEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFAEDGELW", static_cast<double>(8.0e22), &ADMSPSP103VA::Model::NFAEDGELW)
    .setUnit(U_UNKNOWN)
    .setDescription("First coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFBEDGELW", static_cast<double>(3.0e7), &ADMSPSP103VA::Model::NFBEDGELW)
    .setUnit(U_UNKNOWN)
    .setDescription("Second coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("NFCEDGELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::NFCEDGELW)
    .setUnit(U_VOLTM1)
    .setDescription("Third coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("EFEDGEO", static_cast<double>(1.0), &ADMSPSP103VA::Model::EFEDGEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise frequency exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVTHOWEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::KVTHOWEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical independent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVTHOWEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::KVTHOWEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVTHOWEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::KVTHOWEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVTHOWELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::KVTHOWELW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KUOWEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::KUOWEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical independent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KUOWEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::KUOWEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KUOWEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::KUOWEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KUOWELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::KUOWELW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RGO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RGO)
    .setUnit(U_OHM)
    .setDescription("Gate resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RINT", static_cast<double>(0.0), &ADMSPSP103VA::Model::RINT)
    .setUnit(U_OHMM2)
    .setDescription("Contact resistance between silicide and ploy")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RVPOLY", static_cast<double>(0.0), &ADMSPSP103VA::Model::RVPOLY)
    .setUnit(U_OHMM2)
    .setDescription("Vertical poly resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSHG", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSHG)
    .setUnit(U_OSQM1)
    .setDescription("Gate electrode diffusion sheet resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DLSIL", static_cast<double>(0.0), &ADMSPSP103VA::Model::DLSIL)
    .setUnit(U_METER)
    .setDescription("Silicide extension over the physical gate length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSH", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSH)
    .setUnit(U_OSQM1)
    .setDescription("Sheet resistance of source diffusion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSHD", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSHD)
    .setUnit(U_OSQM1)
    .setDescription("Sheet resistance of drain diffusion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBULKO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RBULKO)
    .setUnit(U_OHM)
    .setDescription("Bulk resistance between node BP and BI")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RWELLO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RWELLO)
    .setUnit(U_OHM)
    .setDescription("Well resistance between node BI and B")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RJUNSO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RJUNSO)
    .setUnit(U_OHM)
    .setDescription("Source-side bulk resistance between node BI and BS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RJUNDO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RJUNDO)
    .setUnit(U_OHM)
    .setDescription("Drain-side bulk resistance between node BI and BD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SAREF", static_cast<double>(1.0e-6), &ADMSPSP103VA::Model::SAREF)
    .setUnit(U_METER)
    .setDescription("Reference distance between OD-edge and poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SBREF", static_cast<double>(1.0e-6), &ADMSPSP103VA::Model::SBREF)
    .setUnit(U_METER)
    .setDescription("Reference distance between OD-edge and poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WLOD", static_cast<double>(0.0), &ADMSPSP103VA::Model::WLOD)
    .setUnit(U_METER)
    .setDescription("Width parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::KUO)
    .setUnit(U_METER)
    .setDescription("Mobility degradation/enhancement coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVSAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::KVSAT)
    .setUnit(U_METER)
    .setDescription("Saturation velocity degradation/enhancement coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TKUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::TKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LKUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::LKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WKUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::WKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PKUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::PKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Cross-term dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LLODKUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::LLODKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Length parameter for UO stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WLODKUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::WLODKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Width parameter for UO stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KVTHO", static_cast<double>(0.0), &ADMSPSP103VA::Model::KVTHO)
    .setUnit(U_VM)
    .setDescription("Threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LKVTHO", static_cast<double>(0.0), &ADMSPSP103VA::Model::LKVTHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WKVTHO", static_cast<double>(0.0), &ADMSPSP103VA::Model::WKVTHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PKVTHO", static_cast<double>(0.0), &ADMSPSP103VA::Model::PKVTHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Cross-term dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LLODVTH", static_cast<double>(0.0), &ADMSPSP103VA::Model::LLODVTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Length parameter for VTH-stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WLODVTH", static_cast<double>(0.0), &ADMSPSP103VA::Model::WLODVTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Width parameter for VTH-stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STETAO", static_cast<double>(0.0), &ADMSPSP103VA::Model::STETAO)
    .setUnit(U_METER)
    .setDescription("Eta0 shift factor related to VTHO change")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LODETAO", static_cast<double>(1.0), &ADMSPSP103VA::Model::LODETAO)
    .setUnit(U_UNKNOWN)
    .setDescription("Eta0 shift modification factor for stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SCREF", static_cast<double>(1.0e-6), &ADMSPSP103VA::Model::SCREF)
    .setUnit(U_METER)
    .setDescription("Distance between OD-edge and well edge of a reference device")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WEB", static_cast<double>(0.0), &ADMSPSP103VA::Model::WEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for SCB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("WEC", static_cast<double>(0.0), &ADMSPSP103VA::Model::WEC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for SCC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IMAX", static_cast<double>(1000.0), &ADMSPSP103VA::Model::IMAX)
    .setUnit(U_AMP)
    .setDescription("Maximum current up to which forward current behaves exponentially")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TRJ", static_cast<double>(21.0), &ADMSPSP103VA::Model::TRJ)
    .setUnit(U_DEGC)
    .setDescription("Reference temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FREV", static_cast<double>(1.0e3), &ADMSPSP103VA::Model::FREV)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for reverse breakdown current limitation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORBOT", static_cast<double>(1.0e-3), &ADMSPSP103VA::Model::CJORBOT)
    .setUnit(U_FARADMM2)
    .setDescription("Zero-bias capacitance per unit-of-area of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORSTI", static_cast<double>(1.0e-9), &ADMSPSP103VA::Model::CJORSTI)
    .setUnit(U_FARADMM1)
    .setDescription("Zero-bias capacitance per unit-of-length of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORGAT", static_cast<double>(1.0e-9), &ADMSPSP103VA::Model::CJORGAT)
    .setUnit(U_FARADMM1)
    .setDescription("Zero-bias capacitance per unit-of-length of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRBOT", static_cast<double>(1.0), &ADMSPSP103VA::Model::VBIRBOT)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRSTI", static_cast<double>(1.0), &ADMSPSP103VA::Model::VBIRSTI)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRGAT", static_cast<double>(1.0), &ADMSPSP103VA::Model::VBIRGAT)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBOT", static_cast<double>(0.5), &ADMSPSP103VA::Model::PBOT)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSTI", static_cast<double>(0.5), &ADMSPSP103VA::Model::PSTI)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PGAT", static_cast<double>(0.5), &ADMSPSP103VA::Model::PGAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGBOT", static_cast<double>(1.16), &ADMSPSP103VA::Model::PHIGBOT)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGSTI", static_cast<double>(1.16), &ADMSPSP103VA::Model::PHIGSTI)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGGAT", static_cast<double>(1.16), &ADMSPSP103VA::Model::PHIGGAT)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRBOT", static_cast<double>(1.0e-12), &ADMSPSP103VA::Model::IDSATRBOT)
    .setUnit(U_AMPMM2)
    .setDescription("Saturation current density at the reference temperature of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRSTI", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::IDSATRSTI)
    .setUnit(U_AMPMM1)
    .setDescription("Saturation current density at the reference temperature of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRGAT", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::IDSATRGAT)
    .setUnit(U_AMPMM1)
    .setDescription("Saturation current density at the reference temperature of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHBOT", static_cast<double>(1.0e2), &ADMSPSP103VA::Model::CSRHBOT)
    .setUnit(U_AMPMM3)
    .setDescription("Shockley-Read-Hall prefactor of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHSTI", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CSRHSTI)
    .setUnit(U_AMPMM2)
    .setDescription("Shockley-Read-Hall prefactor of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHGAT", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CSRHGAT)
    .setUnit(U_AMPMM2)
    .setDescription("Shockley-Read-Hall prefactor of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJUNSTI", static_cast<double>(1.0e-7), &ADMSPSP103VA::Model::XJUNSTI)
    .setUnit(U_METER)
    .setDescription("Junction depth of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJUNGAT", static_cast<double>(1.0e-7), &ADMSPSP103VA::Model::XJUNGAT)
    .setUnit(U_METER)
    .setDescription("Junction depth of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATBOT", static_cast<double>(1.0e2), &ADMSPSP103VA::Model::CTATBOT)
    .setUnit(U_AMPMM3)
    .setDescription("Trap-assisted tunneling prefactor of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATSTI", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CTATSTI)
    .setUnit(U_AMPMM2)
    .setDescription("Trap-assisted tunneling prefactor of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATGAT", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CTATGAT)
    .setUnit(U_AMPMM2)
    .setDescription("Trap-assisted tunneling prefactor of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATBOT", static_cast<double>(0.25), &ADMSPSP103VA::Model::MEFFTATBOT)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATSTI", static_cast<double>(0.25), &ADMSPSP103VA::Model::MEFFTATSTI)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATGAT", static_cast<double>(0.25), &ADMSPSP103VA::Model::MEFFTATGAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTBOT", static_cast<double>(1.0e-12), &ADMSPSP103VA::Model::CBBTBOT)
    .setUnit(U_AMPVM3)
    .setDescription("Band-to-band tunneling prefactor of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTSTI", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::CBBTSTI)
    .setUnit(U_AMPVM3M)
    .setDescription("Band-to-band tunneling prefactor of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTGAT", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::CBBTGAT)
    .setUnit(U_AMPVM3M)
    .setDescription("Band-to-band tunneling prefactor of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRBOT", static_cast<double>(1.0e9), &ADMSPSP103VA::Model::FBBTRBOT)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRSTI", static_cast<double>(1.0e9), &ADMSPSP103VA::Model::FBBTRSTI)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRGAT", static_cast<double>(1.0e9), &ADMSPSP103VA::Model::FBBTRGAT)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTBOT", static_cast<double>((-1.0e-3)), &ADMSPSP103VA::Model::STFBBTBOT)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTSTI", static_cast<double>((-1.0e-3)), &ADMSPSP103VA::Model::STFBBTSTI)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTGAT", static_cast<double>((-1.0e-3)), &ADMSPSP103VA::Model::STFBBTGAT)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRBOT", static_cast<double>(10.0), &ADMSPSP103VA::Model::VBRBOT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRSTI", static_cast<double>(10.0), &ADMSPSP103VA::Model::VBRSTI)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRGAT", static_cast<double>(10.0), &ADMSPSP103VA::Model::VBRGAT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRBOT", static_cast<double>(4.0), &ADMSPSP103VA::Model::PBRBOT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRSTI", static_cast<double>(4.0), &ADMSPSP103VA::Model::PBRSTI)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRGAT", static_cast<double>(4.0), &ADMSPSP103VA::Model::PBRGAT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORBOTD", static_cast<double>(1.0e-3), &ADMSPSP103VA::Model::CJORBOTD)
    .setUnit(U_FARADMM2)
    .setDescription("Zero-bias capacitance per unit-of-area of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORSTID", static_cast<double>(1.0e-9), &ADMSPSP103VA::Model::CJORSTID)
    .setUnit(U_FARADMM1)
    .setDescription("Zero-bias capacitance per unit-of-length of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORGATD", static_cast<double>(1.0e-9), &ADMSPSP103VA::Model::CJORGATD)
    .setUnit(U_FARADMM1)
    .setDescription("Zero-bias capacitance per unit-of-length of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRBOTD", static_cast<double>(1.0), &ADMSPSP103VA::Model::VBIRBOTD)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRSTID", static_cast<double>(1.0), &ADMSPSP103VA::Model::VBIRSTID)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRGATD", static_cast<double>(1.0), &ADMSPSP103VA::Model::VBIRGATD)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBOTD", static_cast<double>(0.5), &ADMSPSP103VA::Model::PBOTD)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSTID", static_cast<double>(0.5), &ADMSPSP103VA::Model::PSTID)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PGATD", static_cast<double>(0.5), &ADMSPSP103VA::Model::PGATD)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGBOTD", static_cast<double>(1.16), &ADMSPSP103VA::Model::PHIGBOTD)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGSTID", static_cast<double>(1.16), &ADMSPSP103VA::Model::PHIGSTID)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGGATD", static_cast<double>(1.16), &ADMSPSP103VA::Model::PHIGGATD)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRBOTD", static_cast<double>(1.0e-12), &ADMSPSP103VA::Model::IDSATRBOTD)
    .setUnit(U_AMPMM2)
    .setDescription("Saturation current density at the reference temperature of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRSTID", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::IDSATRSTID)
    .setUnit(U_AMPMM1)
    .setDescription("Saturation current density at the reference temperature of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRGATD", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::IDSATRGATD)
    .setUnit(U_AMPMM1)
    .setDescription("Saturation current density at the reference temperature of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHBOTD", static_cast<double>(1.0e2), &ADMSPSP103VA::Model::CSRHBOTD)
    .setUnit(U_AMPMM3)
    .setDescription("Shockley-Read-Hall prefactor of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHSTID", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CSRHSTID)
    .setUnit(U_AMPMM2)
    .setDescription("Shockley-Read-Hall prefactor of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHGATD", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CSRHGATD)
    .setUnit(U_AMPMM2)
    .setDescription("Shockley-Read-Hall prefactor of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJUNSTID", static_cast<double>(1.0e-7), &ADMSPSP103VA::Model::XJUNSTID)
    .setUnit(U_METER)
    .setDescription("Junction depth of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJUNGATD", static_cast<double>(1.0e-7), &ADMSPSP103VA::Model::XJUNGATD)
    .setUnit(U_METER)
    .setDescription("Junction depth of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATBOTD", static_cast<double>(1.0e2), &ADMSPSP103VA::Model::CTATBOTD)
    .setUnit(U_AMPMM3)
    .setDescription("Trap-assisted tunneling prefactor of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATSTID", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CTATSTID)
    .setUnit(U_AMPMM2)
    .setDescription("Trap-assisted tunneling prefactor of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATGATD", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CTATGATD)
    .setUnit(U_AMPMM2)
    .setDescription("Trap-assisted tunneling prefactor of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATBOTD", static_cast<double>(0.25), &ADMSPSP103VA::Model::MEFFTATBOTD)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATSTID", static_cast<double>(0.25), &ADMSPSP103VA::Model::MEFFTATSTID)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATGATD", static_cast<double>(0.25), &ADMSPSP103VA::Model::MEFFTATGATD)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTBOTD", static_cast<double>(1.0e-12), &ADMSPSP103VA::Model::CBBTBOTD)
    .setUnit(U_AMPVM3)
    .setDescription("Band-to-band tunneling prefactor of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTSTID", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::CBBTSTID)
    .setUnit(U_AMPVM3M)
    .setDescription("Band-to-band tunneling prefactor of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTGATD", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::CBBTGATD)
    .setUnit(U_AMPVM3M)
    .setDescription("Band-to-band tunneling prefactor of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRBOTD", static_cast<double>(1.0e9), &ADMSPSP103VA::Model::FBBTRBOTD)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRSTID", static_cast<double>(1.0e9), &ADMSPSP103VA::Model::FBBTRSTID)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRGATD", static_cast<double>(1.0e9), &ADMSPSP103VA::Model::FBBTRGATD)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTBOTD", static_cast<double>((-1.0e-3)), &ADMSPSP103VA::Model::STFBBTBOTD)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTSTID", static_cast<double>((-1.0e-3)), &ADMSPSP103VA::Model::STFBBTSTID)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTGATD", static_cast<double>((-1.0e-3)), &ADMSPSP103VA::Model::STFBBTGATD)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRBOTD", static_cast<double>(10.0), &ADMSPSP103VA::Model::VBRBOTD)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRSTID", static_cast<double>(10.0), &ADMSPSP103VA::Model::VBRSTID)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRGATD", static_cast<double>(10.0), &ADMSPSP103VA::Model::VBRGATD)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRBOTD", static_cast<double>(4.0), &ADMSPSP103VA::Model::PBRBOTD)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRSTID", static_cast<double>(4.0), &ADMSPSP103VA::Model::PBRSTID)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRGATD", static_cast<double>(4.0), &ADMSPSP103VA::Model::PBRGATD)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SWJUNEXP", static_cast<double>(0.0), &ADMSPSP103VA::Model::SWJUNEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for JUNCAP-express; 0=full model, 1=express model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VJUNREF", static_cast<double>(2.5), &ADMSPSP103VA::Model::VJUNREF)
    .setUnit(U_VOLT)
    .setDescription("Typical maximum source-bulk junction voltage; usually about 2*VSUP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FJUNQ", static_cast<double>(0.03), &ADMSPSP103VA::Model::FJUNQ)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction below which source-bulk junction capacitance components are considered negligible")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VJUNREFD", static_cast<double>(2.5), &ADMSPSP103VA::Model::VJUNREFD)
    .setUnit(U_VOLT)
    .setDescription("Typical maximum drain-bulk junction voltage; usually about 2*VSUP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FJUNQD", static_cast<double>(0.03), &ADMSPSP103VA::Model::FJUNQD)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction below which drain-bulk junction capacitance components are considered negligible")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DTA", static_cast<double>(0.0), &ADMSPSP103VA::Model::DTA)
    .setUnit(U_DEGK)
    .setDescription("Temperature offset w.r.t. ambient temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter L : [ 1.0e-9,  (+inf) [
  if ( (!((L >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter L value " << L << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter W : [ 1.0e-9,  (+inf) [
  if ( (!((W >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter W value " << W << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter SCA : [ 0,  (+inf) [
  if ( (!((SCA >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SCA value " << SCA << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SCB : [ 0,  (+inf) [
  if ( (!((SCB >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SCB value " << SCB << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SCC : [ 0,  (+inf) [
  if ( (!((SCC >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SCC value " << SCC << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NF : [ 1.0,  (+inf) [
  if ( (!((NF >=1.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NF value " << NF << " out of range [ 1.0,  (+inf) [";
  }

  //    Parameter NGCON : [ 1.0, 2.0 ]
  if ( (!((NGCON >=1.0 && NGCON <=2.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NGCON value " << NGCON << " out of range [ 1.0, 2.0 ]";
  }

  //    Parameter JW : [ 0.0,  (+inf) [
  if ( (!((JW >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter JW value " << JW << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter FACTUO : [ 0,  (+inf) [
  if ( (!((FACTUO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FACTUO value " << FACTUO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter FACTUOEDGE : [ 0,  (+inf) [
  if ( (!((FACTUOEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FACTUOEDGE value " << FACTUOEDGE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ABSOURCE : [ 0.0,  (+inf) [
  if ( (!((ABSOURCE >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ABSOURCE value " << ABSOURCE << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter LSSOURCE : [ 0.0,  (+inf) [
  if ( (!((LSSOURCE >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LSSOURCE value " << LSSOURCE << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter LGSOURCE : [ 0.0,  (+inf) [
  if ( (!((LGSOURCE >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LGSOURCE value " << LGSOURCE << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter ABDRAIN : [ 0.0,  (+inf) [
  if ( (!((ABDRAIN >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ABDRAIN value " << ABDRAIN << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter LSDRAIN : [ 0.0,  (+inf) [
  if ( (!((LSDRAIN >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LSDRAIN value " << LSDRAIN << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter LGDRAIN : [ 0.0,  (+inf) [
  if ( (!((LGDRAIN >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LGDRAIN value " << LGDRAIN << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter AS : [ 0.0,  (+inf) [
  if ( (!((AS >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter AS value " << AS << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter PS : [ 0.0,  (+inf) [
  if ( (!((PS >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PS value " << PS << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter AD : [ 0.0,  (+inf) [
  if ( (!((AD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter AD value " << AD << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter PD : [ 0.0,  (+inf) [
  if ( (!((PD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PD value " << PD << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter MULT : [ 0.0,  (+inf) [
  if ( (!((MULT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MULT value " << MULT << " out of range [ 0.0,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double I5;
  double I4;
  double I3;
  double I2;
  double I1;
  double ijungat;
  double ijunsti;
  double ijunbot;
  double V5;
  double V4;
  double V3;
  double V2;
  double V1;
  double FRACI;
  double FRACNB;
  double FRACNA;
  double qjungat;
  double qjunsti;
  double qjunbot;
  double fbreakdown;
  double Fmaxr;
  double ibbt;
  double gammamax;
  double erfctimesexpmtat;
  double xerfc;
  double mtat;
  double ltat;
  double ktat;
  double wtat;
  double wgamma;
  double umaxpoweronepointfive;
  double sqrtumax;
  double umax;
  double umaxbeforelimiting;
  double twoatatoverthreebtat;
  double btat;
  double itat;
  double asrh;
  double wdep;
  double wsrh;
  double dwsrh;
  double wsrhstep;
  double vbi_minus_vjsrh;
  double isrh;
  double id;
  double tmp;
  double vav;
  double vbbt;
  double vjsrh;
  double vjlim;
  double two_psistar;
  double zinv;
  double z;
  double vj;
  double idmult;
  double h5;
  double h4;
  double h3;
  double h2d;
  double h2;
  double h1;
  double erfcpos;
  double terfc;
  double ysq;
  double pmax;
  double vbigat2r;
  double vbisti2r;
  double vbibot2r;
  double pgat2;
  double psti2;
  double pbot2;
  double vbigat2;
  double vbisti2;
  double vbibot2;
  double vmaxgat;
  double vmaxsti;
  double vmaxbot;
  double alphaje;
  double zfrac;
  double tt2;
  double tt1;
  double tt0;
  double I5_cor;
  double I4_cor;
  double I3_cor;
  double I2_cor;
  double I1_cor;
  double mcor_rev;
  double m0_rev;
  double jww;
  double jwcorr;
  double LGD_i;
  double LSD_i;
  double ABD_i;
  double LGS_i;
  double LSS_i;
  double ABS_i;
  double BGIDLD_T;
  double BGIDL_T;
  double tf_ig;
  double B_fact;
  double phix2edge;
  double BETNEDGE_T;
  double tf_betedge;
  double tf_thesat;
  double RS_T;
  double tf_ther;
  double tf_xcor;
  double tf_cs;
  double tf_mue;
  double BETN_T;
  double tf_bet;
  double phix2;
  double dphibq;
  double qb0;
  double arg2max;
  double np;
  double SP_OV_delta;
  double SP_OV_eps;
  double inv_GOV;
  double CoxovPrime_d;
  double CoxovPrime;
  double NEFFAC_i;
  double tox_sq;
  double CoxPrime;
  double EPSOX;
  double DELVTOEDGE_i;
  double FACTUOEDGE_i;
  double DELVTO_i;
  double FACTUO_i;
  double FNTEDGE_i;
  double STBETEDGE_i;
  double CTEDGE_i;
  double NEFFEDGE_i;
  double DPHIBEDGE_i;
  double STVFBEDGE_i;
  double VFBEDGE_i;
  double FNT_i;
  double STBGIDLD_i;
  double STBGIDL_i;
  double BGIDLD_i;
  double BGIDL_i;
  double STIG_i;
  double STA2_i;
  double A2_i;
  double VP_i;
  double STTHESAT_i;
  double THESAT_i;
  double STRS_i;
  double RS_i;
  double FETA_i;
  double STXCOR_i;
  double XCOR_i;
  double STCS_i;
  double CS_i;
  double STTHEMU_i;
  double THEMU_i;
  double STMUE_i;
  double MUE_i;
  double STBET_i;
  double BETN_i;
  double NOVD_i;
  double NOV_i;
  double TOXOVD_i;
  double TOXOV_i;
  double CT_i;
  double NP_i;
  double DELVTAC_i;
  double DPHIB_i;
  double DVSBNUD_i;
  double VSBNUD_i;
  double FACNEFFAC_i;
  double NEFF_i;
  double EPSROX_i;
  double TOX_i;
  double STVFB_i;
  double VFB_i;
  double temp00;
  double Kstressvth0;
  double rhobetaref;
  double rhobeta;
  double Kstressu0;
  double tempw;
  double templ;
  double Wx;
  double Lx;
  double Invsbref;
  double Invsaref;
  double Invsb;
  double Invsa;
  double loop;
  double tmpb;
  double tmpa;
  double iiiLWcv;
  double iLcv;
  double iiLWcv;
  double iiWcv;
  double iiLcv;
  double iiiLEWEcv;
  double iLEcv;
  double iiLEWEcv;
  double iiWEcv;
  double iiLEcv;
  double iiiLEWE;
  double iiLEWE;
  double iiWE;
  double iiLE;
  double iLEWE;
  double KUOWE;
  double KVTHOWE;
  double GPE_edge;
  double iWE_edge;
  double WE_edge;
  double Lred;
  double Lnoi;
  double temp0;
  double tmpx;
  double GWE;
  double GPE;
  double LP1e;
  double FBET1e;
  double NSUB;
  double BB;
  double AA;
  double LPCKe;
  double NPCKe;
  double NSUB0e;
  double RJUND_p;
  double RJUNS_p;
  double RBULK_p;
  double RWELL_p;
  double RDE_p;
  double RSE_p;
  double RG_p;
  double EFEDGE_p;
  double NFCEDGE_p;
  double NFBEDGE_p;
  double NFAEDGE_p;
  double FNTEDGE_p;
  double CFBEDGE_p;
  double CFDEDGE_p;
  double CFEDGE_p;
  double PSCEDEDGE_p;
  double PSCEBEDGE_p;
  double PSCEEDGE_p;
  double STBETEDGE_p;
  double BETNEDGE_p;
  double CTEDGE_p;
  double NEFFEDGE_p;
  double DPHIBEDGE_p;
  double STVFBEDGE_p;
  double VFBEDGE_p;
  double EF_p;
  double NFC_p;
  double NFB_p;
  double NFA_p;
  double FNTEXC_p;
  double FNT_p;
  double CFRD_p;
  double CFR_p;
  double CGBOV_p;
  double CGOVD_p;
  double CGOV_p;
  double COX_p;
  double CGIDLD_p;
  double CGIDL_p;
  double STBGIDLD_p;
  double STBGIDL_p;
  double BGIDLD_p;
  double BGIDL_p;
  double AGIDLD_p;
  double AGIDL_p;
  double CHIB_p;
  double GC3_p;
  double GC2_p;
  double STIG_p;
  double IGOVD_p;
  double IGOV_p;
  double IGINV_p;
  double GCO_p;
  double A4_p;
  double A3_p;
  double STA2_p;
  double A2_p;
  double A1_p;
  double VP_p;
  double ALP2_p;
  double ALP1_p;
  double ALP_p;
  double AX_p;
  double THESATG_p;
  double THESATB_p;
  double STTHESAT_p;
  double THESAT_p;
  double RSG_p;
  double RSB_p;
  double STRS_p;
  double RS_p;
  double FETA_p;
  double STXCOR_p;
  double XCOR_p;
  double STCS_p;
  double CS_p;
  double STTHEMU_p;
  double THEMU_p;
  double STMUE_p;
  double MUE_p;
  double STBET_p;
  double BETN_p;
  double CFB_p;
  double CFD_p;
  double CF_p;
  double PSCEB_p;
  double PSCED_p;
  double PSCE_p;
  double NOVD_p;
  double NOV_p;
  double TOXOVD_p;
  double TOXOV_p;
  double CT_p;
  double NP_p;
  double DELVTAC_p;
  double DPHIB_p;
  double DNSUB_p;
  double NSLP_p;
  double VNSUB_p;
  double DVSBNUD_p;
  double VSBNUD_p;
  double GFACNUD_p;
  double FACNEFFAC_p;
  double NEFF_p;
  double EPSROX_p;
  double TOX_p;
  double STVFB_p;
  double VFB_p;
  double XGWE;
  double W_f;
  double L_slif;
  double L_f;
  double iWE;
  double iLE;
  double Wcv;
  double Lcv;
  double WEcv;
  double LEcv;
  double delWOD;
  double delLPS;
  double iW;
  double iL;
  double NGCON_i;
  double SCC_i;
  double SCB_i;
  double SCA_i;
  double JW_i;
  double PD_i;
  double AD_i;
  double PS_i;
  double AS_i;
  double XGW_i;
  double SC_i;
  double SD_i;
  double SB_i;
  double SA_i;
  double W_i;
  double L_i;
  double WE;
  double LE;
  double invNF;
  double NF_i;
  //Begin block initial_instance
  {
    //Block-local variables for block initial_instance
    double Invsa;
    double Invsb;
    double Invsaref;
    double Invsbref;
    double Kstressu0;
    double rhobeta;
    double rhobetaref;
    double Kstressvth0;
    //End of Block-local variables
    //Block-local variables for block initial_instance
    double temp0;
    double temp00;
    double templ;
    double tempw;
    double Lx;
    double Wx;
    double loop;
    double tmpa;
    double tmpb;
    //End of Block-local variables
    NF_i = 1.0;
    invNF = 1.0;
    LE = 0.0;
    WE = 0.0;
    L_i = L;
    W_i = W;
    SA_i = SA;
    SB_i = SB;
    SD_i = SD;
    SC_i = SC;
    XGW_i = XGW;
    ABSOURCE_i = ABSOURCE;
    LSSOURCE_i = LSSOURCE;
    LGSOURCE_i = LGSOURCE;
    ABDRAIN_i = ABDRAIN;
    LSDRAIN_i = LSDRAIN;
    LGDRAIN_i = LGDRAIN;
    AS_i = AS;
    PS_i = PS;
    AD_i = AD;
    PD_i = PD;
    JW_i = JW;
    if ((((model_.SWGEO_i)==1)||((model_.SWGEO_i)==2)))
    {
      NF_i = ((NF>1.0)?NF:1.0);
      {
        double value_floor_0 = floor((NF_i+0.5));
        NF_i = floor((NF_i+0.5));
      }
      invNF = (1.0/NF_i);
    }
    L_i = ((L_i>1.0e-9)?L_i:1.0e-9);
    W_i = (((W_i*invNF)>1.0e-9)?(W_i*invNF):1.0e-9);
    SCA_i = ((SCA>0.0)?SCA:0.0);
    SCB_i = ((SCB>0.0)?SCB:0.0);
    SCC_i = ((SCC>0.0)?SCC:0.0);
    NGCON_i = ((NGCON<1.5)?1.0:2.0);
    iL = (1.0e-6/L_i);
    iW = (1.0e-6/W_i);
    delLPS = (((model_.LVARO)*(1.0+((model_.LVARL)*iL)))*(1.0+((model_.LVARW)*iW)));
    delWOD = (((model_.WVARO)*(1.0+((model_.WVARL)*iL)))*(1.0+((model_.WVARW)*iW)));
    if (((model_.SWGEO_i)==2))
    {
      delLPS = ((model_.LVARO)*(1.0+((model_.LVARL)*iL)));
      delWOD = ((model_.WVARO)*(1.0+((model_.WVARW)*iW)));
    }
    LE = ((((L_i+delLPS)-(2.0*(model_.LAP)))>1.0e-9)?((L_i+delLPS)-(2.0*(model_.LAP))):1.0e-9);
    WE = ((((W_i+delWOD)-(2.0*(model_.WOT)))>1.0e-9)?((W_i+delWOD)-(2.0*(model_.WOT))):1.0e-9);
    LEcv = (((((L_i+delLPS)-(2.0*(model_.LAP)))+(model_.DLQ))>1.0e-9)?(((L_i+delLPS)-(2.0*(model_.LAP)))+(model_.DLQ)):1.0e-9);
    WEcv = (((((W_i+delWOD)-(2.0*(model_.WOT)))+(model_.DWQ))>1.0e-9)?(((W_i+delWOD)-(2.0*(model_.WOT)))+(model_.DWQ)):1.0e-9);
    Lcv = ((((L_i+delLPS)+(model_.DLQ))>1.0e-9)?((L_i+delLPS)+(model_.DLQ)):1.0e-9);
    Wcv = ((((W_i+delWOD)+(model_.DWQ))>1.0e-9)?((W_i+delWOD)+(model_.DWQ)):1.0e-9);
    iLE = (1.0e-6/LE);
    iWE = (1.0e-6/WE);
    L_f = (((L_i+delLPS)>1.0e-9)?(L_i+delLPS):1.0e-9);
    L_slif = (((L_f+(model_.DLSIL))>1.0e-9)?(L_f+(model_.DLSIL)):1.0e-9);
    W_f = (((W_i+delWOD)>1.0e-9)?(W_i+delWOD):1.0e-9);
    XGWE = (((XGW_i-(0.5*delWOD))>1.0e-9)?(XGW_i-(0.5*delWOD)):1.0e-9);
    VFB_p = (model_.VFB);
    STVFB_p = (model_.STVFB);
    TOX_p = (model_.TOX);
    EPSROX_p = (model_.EPSROX);
    NEFF_p = (model_.NEFF);
    FACNEFFAC_p = (model_.FACNEFFAC);
    GFACNUD_p = (model_.GFACNUD);
    VSBNUD_p = (model_.VSBNUD);
    DVSBNUD_p = (model_.DVSBNUD);
    VNSUB_p = (model_.VNSUB);
    NSLP_p = (model_.NSLP);
    DNSUB_p = (model_.DNSUB);
    DPHIB_p = (model_.DPHIB);
    DELVTAC_p = (model_.DELVTAC);
    NP_p = (model_.NP);
    CT_p = (model_.CT);
    TOXOV_p = (model_.TOXOV);
    TOXOVD_p = (model_.TOXOVD);
    NOV_p = (model_.NOV);
    NOVD_p = (model_.NOVD);
    PSCE_p = (model_.PSCE);
    PSCED_p = (model_.PSCED);
    PSCEB_p = (model_.PSCEB);
    CF_p = (model_.CF);
    CFD_p = (model_.CFD);
    CFB_p = (model_.CFB);
    BETN_p = (model_.BETN);
    STBET_p = (model_.STBET);
    MUE_p = (model_.MUE);
    STMUE_p = (model_.STMUE);
    THEMU_p = (model_.THEMU);
    STTHEMU_p = (model_.STTHEMU);
    CS_p = (model_.CS);
    STCS_p = (model_.STCS);
    XCOR_p = (model_.XCOR);
    STXCOR_p = (model_.STXCOR);
    FETA_p = (model_.FETA);
    RS_p = (model_.RS);
    STRS_p = (model_.STRS);
    RSB_p = (model_.RSB);
    RSG_p = (model_.RSG);
    THESAT_p = (model_.THESAT);
    STTHESAT_p = (model_.STTHESAT);
    THESATB_p = (model_.THESATB);
    THESATG_p = (model_.THESATG);
    AX_p = (model_.AX);
    ALP_p = (model_.ALP);
    ALP1_p = (model_.ALP1);
    ALP2_p = (model_.ALP2);
    VP_p = (model_.VP);
    A1_p = (model_.A1);
    A2_p = (model_.A2);
    STA2_p = (model_.STA2);
    A3_p = (model_.A3);
    A4_p = (model_.A4);
    GCO_p = (model_.GCO);
    IGINV_p = (model_.IGINV);
    IGOV_p = (model_.IGOV);
    IGOVD_p = (model_.IGOVD);
    STIG_p = (model_.STIG);
    GC2_p = (model_.GC2);
    GC3_p = (model_.GC3);
    CHIB_p = (model_.CHIB);
    AGIDL_p = (model_.AGIDL);
    AGIDLD_p = (model_.AGIDLD);
    BGIDL_p = (model_.BGIDL);
    BGIDLD_p = (model_.BGIDLD);
    STBGIDL_p = (model_.STBGIDL);
    STBGIDLD_p = (model_.STBGIDLD);
    CGIDL_p = (model_.CGIDL);
    CGIDLD_p = (model_.CGIDLD);
    COX_p = (model_.COX);
    CGOV_p = (model_.CGOV);
    CGOVD_p = (model_.CGOVD);
    CGBOV_p = (model_.CGBOV);
    CFR_p = (model_.CFR);
    CFRD_p = (model_.CFRD);
    FNT_p = (model_.FNT);
    FNTEXC_p = (model_.FNTEXC);
    NFA_p = (model_.NFA);
    NFB_p = (model_.NFB);
    NFC_p = (model_.NFC);
    EF_p = (model_.EF);
    VFBEDGE_p = (model_.VFBEDGE);
    STVFBEDGE_p = (model_.STVFBEDGE);
    DPHIBEDGE_p = (model_.DPHIBEDGE);
    NEFFEDGE_p = (model_.NEFFEDGE);
    CTEDGE_p = (model_.CTEDGE);
    BETNEDGE_p = (model_.BETNEDGE);
    STBETEDGE_p = (model_.STBETEDGE);
    PSCEEDGE_p = (model_.PSCEEDGE);
    PSCEBEDGE_p = (model_.PSCEBEDGE);
    PSCEDEDGE_p = (model_.PSCEDEDGE);
    CFEDGE_p = (model_.CFEDGE);
    CFDEDGE_p = (model_.CFDEDGE);
    CFBEDGE_p = (model_.CFBEDGE);
    FNTEDGE_p = (model_.FNTEDGE);
    NFAEDGE_p = (model_.NFAEDGE);
    NFBEDGE_p = (model_.NFBEDGE);
    NFCEDGE_p = (model_.NFCEDGE);
    EFEDGE_p = (model_.EFEDGE);
    RG_p = (model_.RG);
    RSE_p = (model_.RSE);
    RDE_p = (model_.RDE);
    RWELL_p = (model_.RWELL);
    RBULK_p = (model_.RBULK);
    RJUNS_p = (model_.RJUNS);
    RJUND_p = (model_.RJUND);
    if (((model_.SWGEO_i)==1))
    {
      VFB_p = ((((model_.VFBO)+((model_.VFBL)*iLE))+((model_.VFBW)*iWE))+(((model_.VFBLW)*iLE)*iWE));
      STVFB_p = ((((model_.STVFBO)+((model_.STVFBL)*iLE))+((model_.STVFBW)*iWE))+(((model_.STVFBLW)*iLE)*iWE));
      TOX_p = (model_.TOXO);
      EPSROX_p = (model_.EPSROXO);
      {
        double value_log_0 = log((1.0+(WE/(model_.WSEG_i))));
        double value_log_1 = log((1.0+(WE/(model_.WSEG_i))));
        NSUB0e = ((model_.NSUBO_i)*(((1.0+(((model_.NSUBW)*iWE)*value_log_0))>1.0e-03)?(1.0+(((model_.NSUBW)*iWE)*value_log_1)):1.0e-03));
      }
      {
        double value_log_0 = log((1.0+(WE/(model_.WSEGP_i))));
        double value_log_1 = log((1.0+(WE/(model_.WSEGP_i))));
        NPCKe = ((model_.NPCK_i)*(((1.0+(((model_.NPCKW)*iWE)*value_log_0))>1.0e-03)?(1.0+(((model_.NPCKW)*iWE)*value_log_1)):1.0e-03));
      }
      {
        double value_log_0 = log((1.0+(WE/(model_.WSEGP_i))));
        double value_log_1 = log((1.0+(WE/(model_.WSEGP_i))));
        LPCKe = ((model_.LPCK_i)*(((1.0+(((model_.LPCKW)*iWE)*value_log_0))>1.0e-03)?(1.0+(((model_.LPCKW)*iWE)*value_log_1)):1.0e-03));
      }
      if ((LE>(2.0*LPCKe)))
      {
        AA = 7.5e10;
        {
          double value_sqrt_0 = sqrt((NSUB0e+(0.5*NPCKe)));
          double value_sqrt_1 = sqrt(NSUB0e);
          BB = (value_sqrt_0-value_sqrt_1);
        }
        {
          double value_sqrt_0 = sqrt(NSUB0e);
          double value_exp_1 = exp((BB/AA));
          double value_log_2 = log((1.0+(((2.0*LPCKe)/LE)*(value_exp_1-1.0))));
          NSUB = (value_sqrt_0+(AA*value_log_2));
        }
        NSUB = (NSUB*NSUB);
      }
      else
      {
        if ((LE>=LPCKe))
        {
          NSUB = (NSUB0e+((NPCKe*LPCKe)/LE));
        }
        else
        {
          NSUB = (NSUB0e+(NPCKe*(2.0-(LE/LPCKe))));
        }
      }
      NEFF_p = (NSUB*((1.0-((model_.FOL1)*iLE))-(((model_.FOL2)*iLE)*iLE)));
      FACNEFFAC_p = ((((model_.FACNEFFACO)+((model_.FACNEFFACL)*iLE))+((model_.FACNEFFACW)*iWE))+(((model_.FACNEFFACLW)*iLE)*iWE));
      {
        double value_pow_0 = pow(iLE,(model_.GFACNUDLEXP));
        GFACNUD_p = ((((model_.GFACNUDO)+((model_.GFACNUDL)*value_pow_0))+((model_.GFACNUDW)*iWE))+(((model_.GFACNUDLW)*iLE)*iWE));
      }
      VSBNUD_p = (model_.VSBNUDO);
      DVSBNUD_p = (model_.DVSBNUDO);
      VNSUB_p = (model_.VNSUBO);
      NSLP_p = (model_.NSLPO);
      DNSUB_p = (model_.DNSUBO);
      {
        double value_pow_0 = pow(iLE,(model_.DPHIBLEXP));
        DPHIB_p = ((((model_.DPHIBO)+((model_.DPHIBL)*value_pow_0))+((model_.DPHIBW)*iWE))+(((model_.DPHIBLW)*iLE)*iWE));
      }
      {
        double value_pow_0 = pow(iLE,(model_.DELVTACLEXP));
        DELVTAC_p = ((((model_.DELVTACO)+((model_.DELVTACL)*value_pow_0))+((model_.DELVTACW)*iWE))+(((model_.DELVTACLW)*iLE)*iWE));
      }
      NP_p = ((model_.NPO)*((1.0e-6>(1.0+((model_.NPL)*iLE)))?1.0e-6:(1.0+((model_.NPL)*iLE))));
      {
        double value_pow_0 = pow(iLE,(model_.CTLEXP));
        CT_p = ((((model_.CTO)+((model_.CTL)*value_pow_0))*(1.0+((model_.CTW)*iWE)))*(1.0+(((model_.CTLW)*iLE)*iWE)));
      }
      TOXOV_p = (model_.TOXOVO);
      TOXOVD_p = (model_.TOXOVDO);
      NOV_p = (model_.NOVO);
      NOVD_p = (model_.NOVDO);
      {
        double value_pow_0 = pow(iLE,(model_.CFLEXP));
        CF_p = (((model_.CFL)*value_pow_0)*(1.0+((model_.CFW)*iWE)));
      }
      CFD_p = (model_.CFDO);
      CFB_p = (model_.CFBO);
      {
        double value_pow_0 = pow(iLE,(model_.PSCELEXP));
        PSCE_p = (((model_.PSCEL)*value_pow_0)*(1.0+((model_.PSCEW)*iWE)));
      }
      PSCED_p = (model_.PSCEDO);
      PSCEB_p = (model_.PSCEBO);
      FBET1e = ((model_.FBET1)*(1.0+((model_.FBET1W)*iWE)));
      LP1e = ((model_.LP1_i)*(((1.0+((model_.LP1W)*iWE))>1.0e-03)?(1.0+((model_.LP1W)*iWE)):1.0e-03));
      {
        double value_exp_0 = exp(((-LE)/LP1e));
        double value_exp_1 = exp(((-LE)/(model_.LP2_i)));
        GPE = ((1.0+(((FBET1e*LP1e)/LE)*(1.0-value_exp_0)))+((((model_.FBET2)*(model_.LP2_i))/LE)*(1.0-value_exp_1)));
      }
      GPE = ((GPE>1.0e-15)?GPE:1.0e-15);
      {
        double value_log_0 = log((1.0+(WE/(model_.WBET_i))));
        GWE = ((1.0+((model_.BETW1)*iWE))+(((model_.BETW2)*iWE)*value_log_0));
      }
      BETN_p = ((((model_.UO)*WE)/(GPE*LE))*GWE);
      STBET_p = ((((model_.STBETO)+((model_.STBETL)*iLE))+((model_.STBETW)*iWE))+(((model_.STBETLW)*iLE)*iWE));
      MUE_p = ((model_.MUEO)*(1.0+((model_.MUEW)*iWE)));
      STMUE_p = (model_.STMUEO);
      THEMU_p = (model_.THEMUO);
      STTHEMU_p = (model_.STTHEMUO);
      {
        double value_pow_0 = pow(iLE,(model_.CSLEXP));
        CS_p = ((((model_.CSO)+((model_.CSL)*value_pow_0))*(1.0+((model_.CSW)*iWE)))*(1.0+(((model_.CSLW)*iLE)*iWE)));
      }
      STCS_p = (model_.STCSO);
      XCOR_p = ((((model_.XCORO)*(1.0+((model_.XCORL)*iLE)))*(1.0+((model_.XCORW)*iWE)))*(1.0+(((model_.XCORLW)*iLE)*iWE)));
      STXCOR_p = (model_.STXCORO);
      FETA_p = (model_.FETAO);
      RS_p = (((model_.RSW1)*iWE)*(1.0+((model_.RSW2)*iWE)));
      STRS_p = (model_.STRSO);
      RSB_p = (model_.RSBO);
      RSG_p = (model_.RSGO);
      {
        double value_pow_0 = pow(iLE,(model_.THESATLEXP));
        THESAT_p = ((((model_.THESATO)+((((model_.THESATL)*GWE)/GPE)*value_pow_0))*(1.0+((model_.THESATW)*iWE)))*(1.0+(((model_.THESATLW)*iLE)*iWE)));
      }
      STTHESAT_p = ((((model_.STTHESATO)+((model_.STTHESATL)*iLE))+((model_.STTHESATW)*iWE))+(((model_.STTHESATLW)*iLE)*iWE));
      THESATB_p = (model_.THESATBO);
      THESATG_p = (model_.THESATGO);
      AX_p = ((model_.AXO)/(1.0+((model_.AXL_i)*iLE)));
      {
        double value_pow_0 = pow(iLE,(model_.ALPLEXP));
        ALP_p = (((model_.ALPL)*value_pow_0)*(1.0+((model_.ALPW)*iWE)));
      }
      {
        double value_pow_0 = pow(iLE,(model_.ALP1LEXP));
        tmpx = value_pow_0;
      }
      ALP1_p = ((((model_.ALP1L1)*tmpx)*(1.0+((model_.ALP1W)*iWE)))/(1.0+(((model_.ALP1L2_i)*iLE)*tmpx)));
      {
        double value_pow_0 = pow(iLE,(model_.ALP2LEXP));
        tmpx = value_pow_0;
      }
      ALP2_p = ((((model_.ALP2L1)*tmpx)*(1.0+((model_.ALP2W)*iWE)))/(1.0+(((model_.ALP2L2_i)*iLE)*tmpx)));
      VP_p = (model_.VPO);
      A1_p = (((model_.A1O)*(1.0+((model_.A1L)*iLE)))*(1.0+((model_.A1W)*iWE)));
      A2_p = (model_.A2O);
      STA2_p = (model_.STA2O);
      A3_p = (((model_.A3O)*(1.0+((model_.A3L)*iLE)))*(1.0+((model_.A3W)*iWE)));
      A4_p = (((model_.A4O)*(1.0+((model_.A4L)*iLE)))*(1.0+((model_.A4W)*iWE)));
      GCO_p = (model_.GCOO);
      IGINV_p = ((model_.IGINVLW)/(iWE*iLE));
      IGOV_p = (((model_.IGOVW)*(model_.LOV_i))/(1.0e-6*iWE));
      IGOVD_p = (((model_.IGOVDW)*(model_.LOVD_i))/(1.0e-6*iWE));
      STIG_p = (model_.STIGO);
      GC2_p = (model_.GC2O);
      GC3_p = (model_.GC3O);
      CHIB_p = (model_.CHIBO);
      AGIDL_p = (((model_.AGIDLW)*(model_.LOV_i))/(1.0e-6*iWE));
      AGIDLD_p = (((model_.AGIDLDW)*(model_.LOVD_i))/(1.0e-6*iWE));
      BGIDL_p = (model_.BGIDLO);
      BGIDLD_p = (model_.BGIDLDO);
      STBGIDL_p = (model_.STBGIDLO);
      STBGIDLD_p = (model_.STBGIDLDO);
      CGIDL_p = (model_.CGIDLO);
      CGIDLD_p = (model_.CGIDLDO);
      COX_p = ((((8.8541878176E-12*(model_.EPSROXO_i))*WEcv)*LEcv)/(model_.TOXO_i));
      CGOV_p = ((((8.8541878176E-12*(model_.EPSROXO_i))*WEcv)*(model_.LOV_i))/(model_.TOXOVO_i));
      CGOVD_p = ((((8.8541878176E-12*(model_.EPSROXO_i))*WEcv)*(model_.LOVD_i))/(model_.TOXOVDO_i));
      CGBOV_p = (((model_.CGBOVL)*Lcv)/1.0e-6);
      CFR_p = (((model_.CFRW)*Wcv)/1.0e-6);
      CFRD_p = (((model_.CFRDW)*Wcv)/1.0e-6);
      temp0 = (1.0-(((2.0*(model_.LINTNOI))*iLE)/1.0e-6));
      Lnoi = ((temp0>1.0e-3)?temp0:1.0e-3);
      {
        double value_pow_0 = pow(Lnoi,(model_.ALPNOI));
        Lred = (1.0/value_pow_0);
      }
      FNT_p = (model_.FNTO);
      FNTEXC_p = (((((model_.FNTEXCL)*BETN_p)*BETN_p)*iWE)*iWE);
      NFA_p = (((Lred*iWE)*iLE)*(model_.NFALW));
      NFB_p = (((Lred*iWE)*iLE)*(model_.NFBLW));
      NFC_p = (((Lred*iWE)*iLE)*(model_.NFCLW));
      EF_p = (model_.EFO);
      WE_edge = ((2.0*(model_.WEDGE))+((model_.WEDGEW)*WE));
      iWE_edge = (1.0e-6/WE_edge);
      VFBEDGE_p = (model_.VFBEDGEO);
      STVFBEDGE_p = ((((model_.STVFBEDGEO)+((model_.STVFBEDGEL)*iLE))+((model_.STVFBEDGEW)*iWE))+(((model_.STVFBEDGELW)*iLE)*iWE));
      {
        double value_pow_0 = pow(iLE,(model_.DPHIBEDGELEXP));
        DPHIBEDGE_p = ((((model_.DPHIBEDGEO)+((model_.DPHIBEDGEL)*value_pow_0))+((model_.DPHIBEDGEW)*iWE))+(((model_.DPHIBEDGELW)*iLE)*iWE));
      }
      NEFFEDGE_p = ((((model_.NSUBEDGEO_i)*(1.0+((model_.NSUBEDGEL)*iLE)))*(1.0+((model_.NSUBEDGEW)*iWE)))*(1.0+(((model_.NSUBEDGELW)*iLE)*iWE)));
      {
        double value_pow_0 = pow(iLE,(model_.CTEDGELEXP));
        CTEDGE_p = ((model_.CTEDGEO)+((model_.CTEDGEL)*value_pow_0));
      }
      {
        double value_exp_0 = exp(((-LE)/(model_.LPEDGE_i)));
        GPE_edge = (1.0+((((model_.FBETEDGE)*(model_.LPEDGE_i))/LE)*(1.0-value_exp_0)));
      }
      GPE_edge = ((GPE_edge>1.0e-15)?GPE_edge:1.0e-15);
      BETNEDGE_p = ((((model_.UO)*WE_edge)/(GPE_edge*LE))*(1.0+((model_.BETEDGEW)*iWE)));
      STBETEDGE_p = ((((model_.STBETEDGEO)+((model_.STBETEDGEL)*iLE))+((model_.STBETEDGEW)*iWE))+(((model_.STBETEDGELW)*iLE)*iWE));
      {
        double value_pow_0 = pow(iLE,(model_.PSCEEDGELEXP));
        PSCEEDGE_p = (((model_.PSCEEDGEL)*value_pow_0)*(1.0+((model_.PSCEEDGEW)*iWE)));
      }
      PSCEBEDGE_p = (model_.PSCEBEDGEO);
      PSCEDEDGE_p = (model_.PSCEDEDGEO);
      {
        double value_pow_0 = pow(iLE,(model_.CFEDGELEXP));
        CFEDGE_p = (((model_.CFEDGEL)*value_pow_0)*(1.0+((model_.CFEDGEW)*iWE)));
      }
      CFDEDGE_p = (model_.CFDEDGEO);
      CFBEDGE_p = (model_.CFBEDGEO);
      FNTEDGE_p = (model_.FNTEDGEO);
      NFAEDGE_p = ((iWE_edge*iLE)*(model_.NFAEDGELW));
      NFBEDGE_p = ((iWE_edge*iLE)*(model_.NFBEDGELW));
      NFCEDGE_p = ((iWE_edge*iLE)*(model_.NFCEDGELW));
      EFEDGE_p = (model_.EFEDGEO);
    }
    KVTHOWE = ((((model_.KVTHOWEO)+((model_.KVTHOWEL)*iLE))+((model_.KVTHOWEW)*iWE))+(((model_.KVTHOWELW)*iLE)*iWE));
    KUOWE = ((((model_.KUOWEO)+((model_.KUOWEL)*iLE))+((model_.KUOWEW)*iWE))+(((model_.KUOWELW)*iLE)*iWE));
    if (((model_.SWGEO_i)==2))
    {
      iLEWE = (iLE*iWE);
      iiLE = (LE/1.0e-6);
      iiWE = (WE/1.0e-6);
      iiLEWE = (iiLE*iiWE);
      iiiLEWE = (iiWE/iiLE);
      iiLEcv = (LEcv/1.0e-6);
      iiWEcv = (WEcv/1.0e-6);
      iiLEWEcv = (iiLEcv*iiWEcv);
      iLEcv = (1.0e-6/LEcv);
      iiiLEWEcv = (iiWEcv/iiLEcv);
      iiLcv = (Lcv/1.0e-6);
      iiWcv = (Wcv/1.0e-6);
      iiLWcv = (iiLcv*iiWcv);
      iLcv = (1.0e-6/Lcv);
      iiiLWcv = (iiWcv/iiLcv);
      VFB_p = ((((model_.POVFB)+(iLE*(model_.PLVFB)))+(iWE*(model_.PWVFB)))+(iLEWE*(model_.PLWVFB)));
      STVFB_p = ((((model_.POSTVFB)+(iLE*(model_.PLSTVFB)))+(iWE*(model_.PWSTVFB)))+(iLEWE*(model_.PLWSTVFB)));
      TOX_p = (model_.POTOX);
      EPSROX_p = (model_.POEPSROX);
      NEFF_p = ((((model_.PONEFF)+(iLE*(model_.PLNEFF)))+(iWE*(model_.PWNEFF)))+(iLEWE*(model_.PLWNEFF)));
      FACNEFFAC_p = ((((model_.POFACNEFFAC)+(iLE*(model_.PLFACNEFFAC)))+(iWE*(model_.PWFACNEFFAC)))+(iLEWE*(model_.PLWFACNEFFAC)));
      GFACNUD_p = ((((model_.POGFACNUD)+((model_.PLGFACNUD)*iLE))+((model_.PWGFACNUD)*iWE))+(((model_.PLWGFACNUD)*iLE)*iWE));
      VSBNUD_p = (model_.POVSBNUD);
      DVSBNUD_p = (model_.PODVSBNUD);
      VNSUB_p = (model_.POVNSUB);
      NSLP_p = (model_.PONSLP);
      DNSUB_p = (model_.PODNSUB);
      DPHIB_p = ((((model_.PODPHIB)+(iLE*(model_.PLDPHIB)))+(iWE*(model_.PWDPHIB)))+(iLEWE*(model_.PLWDPHIB)));
      DELVTAC_p = ((((model_.PODELVTAC)+(iLE*(model_.PLDELVTAC)))+(iWE*(model_.PWDELVTAC)))+(iLEWE*(model_.PLWDELVTAC)));
      NP_p = ((((model_.PONP)+(iLE*(model_.PLNP)))+(iWE*(model_.PWNP)))+(iLEWE*(model_.PLWNP)));
      CT_p = ((((model_.POCT)+(iLE*(model_.PLCT)))+(iWE*(model_.PWCT)))+(iLEWE*(model_.PLWCT)));
      TOXOV_p = (model_.POTOXOV);
      TOXOVD_p = (model_.POTOXOVD);
      NOV_p = ((((model_.PONOV)+(iLE*(model_.PLNOV)))+(iWE*(model_.PWNOV)))+(iLEWE*(model_.PLWNOV)));
      NOVD_p = ((((model_.PONOVD)+(iLE*(model_.PLNOVD)))+(iWE*(model_.PWNOVD)))+(iLEWE*(model_.PLWNOVD)));
      CF_p = ((((model_.POCF)+(iLE*(model_.PLCF)))+(iWE*(model_.PWCF)))+(iLEWE*(model_.PLWCF)));
      CFD_p = (model_.POCFD);
      CFB_p = (model_.POCFB);
      PSCE_p = ((((model_.POPSCE)+(iLE*(model_.PLPSCE)))+(iWE*(model_.PWPSCE)))+(iLEWE*(model_.PLWPSCE)));
      PSCEB_p = (model_.POPSCEB);
      PSCED_p = (model_.POPSCED);
      BETN_p = ((iiWE*iLE)*((((model_.POBETN)+(iLE*(model_.PLBETN)))+(iWE*(model_.PWBETN)))+(iLEWE*(model_.PLWBETN))));
      STBET_p = ((((model_.POSTBET)+(iLE*(model_.PLSTBET)))+(iWE*(model_.PWSTBET)))+(iLEWE*(model_.PLWSTBET)));
      MUE_p = ((((model_.POMUE)+(iLE*(model_.PLMUE)))+(iWE*(model_.PWMUE)))+(iLEWE*(model_.PLWMUE)));
      STMUE_p = (model_.POSTMUE);
      THEMU_p = (model_.POTHEMU);
      STTHEMU_p = (model_.POSTTHEMU);
      CS_p = ((((model_.POCS)+(iLE*(model_.PLCS)))+(iWE*(model_.PWCS)))+(iLEWE*(model_.PLWCS)));
      STCS_p = (model_.POSTCS);
      XCOR_p = ((((model_.POXCOR)+(iLE*(model_.PLXCOR)))+(iWE*(model_.PWXCOR)))+(iLEWE*(model_.PLWXCOR)));
      STXCOR_p = (model_.POSTXCOR);
      FETA_p = (model_.POFETA);
      RS_p = ((((model_.PORS)+(iLE*(model_.PLRS)))+(iWE*(model_.PWRS)))+(iLEWE*(model_.PLWRS)));
      STRS_p = (model_.POSTRS);
      RSB_p = (model_.PORSB);
      RSG_p = (model_.PORSG);
      THESAT_p = ((((model_.POTHESAT)+(iLE*(model_.PLTHESAT)))+(iWE*(model_.PWTHESAT)))+(iLEWE*(model_.PLWTHESAT)));
      STTHESAT_p = ((((model_.POSTTHESAT)+(iLE*(model_.PLSTTHESAT)))+(iWE*(model_.PWSTTHESAT)))+(iLEWE*(model_.PLWSTTHESAT)));
      THESATB_p = ((((model_.POTHESATB)+(iLE*(model_.PLTHESATB)))+(iWE*(model_.PWTHESATB)))+(iLEWE*(model_.PLWTHESATB)));
      THESATG_p = ((((model_.POTHESATG)+(iLE*(model_.PLTHESATG)))+(iWE*(model_.PWTHESATG)))+(iLEWE*(model_.PLWTHESATG)));
      AX_p = ((((model_.POAX)+(iLE*(model_.PLAX)))+(iWE*(model_.PWAX)))+(iLEWE*(model_.PLWAX)));
      ALP_p = ((((model_.POALP)+(iLE*(model_.PLALP)))+(iWE*(model_.PWALP)))+(iLEWE*(model_.PLWALP)));
      ALP1_p = ((((model_.POALP1)+(iLE*(model_.PLALP1)))+(iWE*(model_.PWALP1)))+(iLEWE*(model_.PLWALP1)));
      ALP2_p = ((((model_.POALP2)+(iLE*(model_.PLALP2)))+(iWE*(model_.PWALP2)))+(iLEWE*(model_.PLWALP2)));
      VP_p = (model_.POVP);
      A1_p = ((((model_.POA1)+(iLE*(model_.PLA1)))+(iWE*(model_.PWA1)))+(iLEWE*(model_.PLWA1)));
      A2_p = (model_.POA2);
      STA2_p = (model_.POSTA2);
      A3_p = ((((model_.POA3)+(iLE*(model_.PLA3)))+(iWE*(model_.PWA3)))+(iLEWE*(model_.PLWA3)));
      A4_p = ((((model_.POA4)+(iLE*(model_.PLA4)))+(iWE*(model_.PWA4)))+(iLEWE*(model_.PLWA4)));
      GCO_p = (model_.POGCO);
      IGINV_p = ((((model_.POIGINV)+(iiLE*(model_.PLIGINV)))+(iiWE*(model_.PWIGINV)))+(iiLEWE*(model_.PLWIGINV)));
      IGOV_p = ((((model_.POIGOV)+(iLE*(model_.PLIGOV)))+(iiWE*(model_.PWIGOV)))+(iiiLEWE*(model_.PLWIGOV)));
      IGOVD_p = ((((model_.POIGOVD)+(iLE*(model_.PLIGOVD)))+(iiWE*(model_.PWIGOVD)))+(iiiLEWE*(model_.PLWIGOVD)));
      STIG_p = (model_.POSTIG);
      GC2_p = (model_.POGC2);
      GC3_p = (model_.POGC3);
      CHIB_p = (model_.POCHIB);
      AGIDL_p = ((((model_.POAGIDL)+(iLE*(model_.PLAGIDL)))+(iiWE*(model_.PWAGIDL)))+(iiiLEWE*(model_.PLWAGIDL)));
      AGIDLD_p = ((((model_.POAGIDLD)+(iLE*(model_.PLAGIDLD)))+(iiWE*(model_.PWAGIDLD)))+(iiiLEWE*(model_.PLWAGIDLD)));
      BGIDL_p = (model_.POBGIDL);
      BGIDLD_p = (model_.POBGIDLD);
      STBGIDL_p = (model_.POSTBGIDL);
      STBGIDLD_p = (model_.POSTBGIDLD);
      CGIDL_p = (model_.POCGIDL);
      CGIDLD_p = (model_.POCGIDLD);
      COX_p = ((((model_.POCOX)+(iiLEcv*(model_.PLCOX)))+(iiWEcv*(model_.PWCOX)))+(iiLEWEcv*(model_.PLWCOX)));
      CGOV_p = ((((model_.POCGOV)+(iLEcv*(model_.PLCGOV)))+(iiWEcv*(model_.PWCGOV)))+(iiiLEWEcv*(model_.PLWCGOV)));
      CGOVD_p = ((((model_.POCGOVD)+(iLEcv*(model_.PLCGOVD)))+(iiWEcv*(model_.PWCGOVD)))+(iiiLEWEcv*(model_.PLWCGOVD)));
      CGBOV_p = ((((model_.POCGBOV)+(iiLcv*(model_.PLCGBOV)))+(iiWcv*(model_.PWCGBOV)))+(iiLWcv*(model_.PLWCGBOV)));
      CFR_p = ((((model_.POCFR)+(iLcv*(model_.PLCFR)))+(iiWcv*(model_.PWCFR)))+(iiiLWcv*(model_.PLWCFR)));
      CFRD_p = ((((model_.POCFRD)+(iLcv*(model_.PLCFRD)))+(iiWcv*(model_.PWCFRD)))+(iiiLWcv*(model_.PLWCFRD)));
      FNT_p = (model_.POFNT);
      FNTEXC_p = ((iLE*iLE)*((((model_.POFNTEXC)+(iLE*(model_.PLFNTEXC)))+(iWE*(model_.PWFNTEXC)))+(iLEWE*(model_.PLWFNTEXC))));
      NFA_p = ((((model_.PONFA)+(iLE*(model_.PLNFA)))+(iWE*(model_.PWNFA)))+(iLEWE*(model_.PLWNFA)));
      NFB_p = ((((model_.PONFB)+(iLE*(model_.PLNFB)))+(iWE*(model_.PWNFB)))+(iLEWE*(model_.PLWNFB)));
      NFC_p = ((((model_.PONFC)+(iLE*(model_.PLNFC)))+(iWE*(model_.PWNFC)))+(iLEWE*(model_.PLWNFC)));
      EF_p = (model_.POEF);
      VFBEDGE_p = (model_.POVFBEDGE);
      STVFBEDGE_p = ((((model_.POSTVFBEDGE)+(iLE*(model_.PLSTVFBEDGE)))+(iWE*(model_.PWSTVFBEDGE)))+(iLEWE*(model_.PLWSTVFBEDGE)));
      DPHIBEDGE_p = ((((model_.PODPHIBEDGE)+(iLE*(model_.PLDPHIBEDGE)))+(iWE*(model_.PWDPHIBEDGE)))+(iLEWE*(model_.PLWDPHIBEDGE)));
      NEFFEDGE_p = ((((model_.PONEFFEDGE)+(iLE*(model_.PLNEFFEDGE)))+(iWE*(model_.PWNEFFEDGE)))+(iLEWE*(model_.PLWNEFFEDGE)));
      CTEDGE_p = ((((model_.POCTEDGE)+(iLE*(model_.PLCTEDGE)))+(iWE*(model_.PWCTEDGE)))+(iLEWE*(model_.PLWCTEDGE)));
      BETNEDGE_p = (iLE*((((model_.POBETNEDGE)+(iLE*(model_.PLBETNEDGE)))+(iWE*(model_.PWBETNEDGE)))+(iLEWE*(model_.PLWBETNEDGE))));
      STBETEDGE_p = ((((model_.POSTBETEDGE)+(iLE*(model_.PLSTBETEDGE)))+(iWE*(model_.PWSTBETEDGE)))+(iLEWE*(model_.PLWSTBETEDGE)));
      PSCEEDGE_p = ((((model_.POPSCEEDGE)+(iLE*(model_.PLPSCEEDGE)))+(iWE*(model_.PWPSCEEDGE)))+(iLEWE*(model_.PLWPSCEEDGE)));
      PSCEBEDGE_p = (model_.POPSCEBEDGE);
      PSCEDEDGE_p = (model_.POPSCEDEDGE);
      CFEDGE_p = ((((model_.POCFEDGE)+(iLE*(model_.PLCFEDGE)))+(iWE*(model_.PWCFEDGE)))+(iLEWE*(model_.PLWCFEDGE)));
      CFDEDGE_p = (model_.POCFDEDGE);
      CFBEDGE_p = (model_.POCFBEDGE);
      FNTEDGE_p = (model_.POFNTEDGE);
      NFAEDGE_p = ((((model_.PONFAEDGE)+(iLE*(model_.PLNFAEDGE)))+(iWE*(model_.PWNFAEDGE)))+(iLEWE*(model_.PLWNFAEDGE)));
      NFBEDGE_p = ((((model_.PONFBEDGE)+(iLE*(model_.PLNFBEDGE)))+(iWE*(model_.PWNFBEDGE)))+(iLEWE*(model_.PLWNFBEDGE)));
      NFCEDGE_p = ((((model_.PONFCEDGE)+(iLE*(model_.PLNFCEDGE)))+(iWE*(model_.PWNFCEDGE)))+(iLEWE*(model_.PLWNFCEDGE)));
      EFEDGE_p = (model_.POEFEDGE);
      KVTHOWE = ((((model_.POKVTHOWE)+(iLE*(model_.PLKVTHOWE)))+(iWE*(model_.PWKVTHOWE)))+(iLEWE*(model_.PLWKVTHOWE)));
      KUOWE = ((((model_.POKUOWE)+(iLE*(model_.PLKUOWE)))+(iWE*(model_.PWKUOWE)))+(iLEWE*(model_.PLWKUOWE)));
    }
    if ((((model_.SWGEO_i)==1)||((model_.SWGEO_i)==2)))
    {
      RG_p = (((((model_.RSHG_i)*(((3.3333333333333333e-01*W_f)/NGCON_i)+XGWE))/(NGCON_i*L_slif))+(((model_.RINT_i)+(model_.RVPOLY_i))/(W_f*L_f)))+(NF_i*(model_.RGO)));
      if (((model_.SWJUNASYM)==0))
      {
        (model_.RSHD_i) = (model_.RSH_i);
      }
      RSE_p = (NRS*(model_.RSH_i));
      RDE_p = (NRD*(model_.RSHD_i));
      RWELL_p = (NF_i*(model_.RWELLO));
      RBULK_p = (NF_i*(model_.RBULKO));
      RJUNS_p = (NF_i*(model_.RJUNSO));
      RJUND_p = (NF_i*(model_.RJUNDO));
      tmpa = 0.0;
      tmpb = 0.0;
      loop = 0.0;
      if ((((SA_i>0.0)&&(SB_i>0.0))&&((NF_i==1.0)||((NF_i>1.0)&&(SD_i>0.0)))))
      {
        while ((loop<(NF_i-0.5)))
        {
          tmpa = (tmpa+(1.0/((SA_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
          tmpb = (tmpb+(1.0/((SB_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
          loop = (loop+1.0);
        }
        Invsa = (tmpa*invNF);
        Invsb = (tmpb*invNF);
        Invsaref = (1.0/((model_.SAREF_i)+(0.5*L_i)));
        Invsbref = (1.0/((model_.SBREF_i)+(0.5*L_i)));
        Lx = (((L_i+delLPS)>1.0e-9)?(L_i+delLPS):1.0e-9);
        Wx = ((((W_i+delWOD)+(model_.WLOD))>1.0e-9)?((W_i+delWOD)+(model_.WLOD)):1.0e-9);
        {
          double value_pow_0 = pow(Lx,(model_.LLODKUO_i));
          templ = (1.0/value_pow_0);
        }
        {
          double value_pow_0 = pow(Wx,(model_.WLODKUO_i));
          tempw = (1.0/value_pow_0);
        }
        Kstressu0 = ((((1.0+((model_.LKUO)*templ))+((model_.WKUO)*tempw))+(((model_.PKUO)*templ)*tempw))*(1.0+((model_.TKUO)*((model_.rTa)-1.0))));
        rhobeta = (((model_.KUO)*(Invsa+Invsb))/Kstressu0);
        rhobetaref = (((model_.KUO)*(Invsaref+Invsbref))/Kstressu0);
        {
          double value_pow_0 = pow(Lx,(model_.LLODVTH_i));
          templ = (1.0/value_pow_0);
        }
        {
          double value_pow_0 = pow(Wx,(model_.WLODVTH_i));
          tempw = (1.0/value_pow_0);
        }
        Kstressvth0 = (((1.0+((model_.LKVTHO)*templ))+((model_.WKVTHO)*tempw))+(((model_.PKVTHO)*templ)*tempw));
        temp0 = (((Invsa+Invsb)-Invsaref)-Invsbref);
        BETN_p = ((BETN_p*(1.0+rhobeta))/(1.0+rhobetaref));
        THESAT_p = (((THESAT_p*(1.0+rhobeta))*(1.0+((model_.KVSAT_i)*rhobetaref)))/((1.0+rhobetaref)*(1.0+((model_.KVSAT_i)*rhobeta))));
        VFB_p = (VFB_p+(((model_.KVTHO)*temp0)/Kstressvth0));
        {
          double value_pow_0 = pow(Kstressvth0,(model_.LODETAO_i));
          CF_p = (CF_p+(((model_.STETAO)*temp0)/value_pow_0));
        }
        BETNEDGE_p = ((BETNEDGE_p*(1.0+rhobeta))/(1.0+rhobetaref));
        VFBEDGE_p = (VFBEDGE_p+(((model_.KVTHO)*temp0)/Kstressvth0));
        {
          double value_pow_0 = pow(Kstressvth0,(model_.LODETAO_i));
          CFEDGE_p = (CFEDGE_p+(((model_.STETAO)*temp0)/value_pow_0));
        }
      }
      if (((((SCA_i>0.0)||(SCB_i>0.0))||(SCC_i>0.0))||(SC_i>0.0)))
      {
        if ((((SCA_i==0.0)&&(SCB_i==0.0))&&(SCC_i==0.0)))
        {
          temp0 = (SC_i+W_i);
          temp00 = (1.0/(model_.SCREF_i));
          SCA_i = (((model_.SCREF_i)*(model_.SCREF_i))/(SC_i*temp0));
          {
            double value_exp_0 = exp((((-10.0)*SC_i)*temp00));
            double value_exp_1 = exp((((-10.0)*temp0)*temp00));
            SCB_i = (((((0.1*SC_i)+(0.01*(model_.SCREF_i)))*value_exp_0)-(((0.1*temp0)+(0.01*(model_.SCREF_i)))*value_exp_1))/W_i);
          }
          {
            double value_exp_0 = exp((((-20.0)*SC_i)*temp00));
            double value_exp_1 = exp((((-20.0)*temp0)*temp00));
            SCC_i = (((((0.05*SC_i)+(0.0025*(model_.SCREF_i)))*value_exp_0)-(((0.05*temp0)+(0.0025*(model_.SCREF_i)))*value_exp_1))/W_i);
          }
        }
        temp0 = ((SCA_i+((model_.WEB_i)*SCB_i))+((model_.WEC_i)*SCC_i));
        VFB_p = (VFB_p+(KVTHOWE*temp0));
        BETN_p = (BETN_p*(1.0+(KUOWE*temp0)));
        VFBEDGE_p = (VFBEDGE_p+(KVTHOWE*temp0));
        BETNEDGE_p = (BETNEDGE_p*(1.0+(KUOWE*temp0)));
      }
    }
    VFB_i = VFB_p;
    STVFB_i = STVFB_p;
    TOX_i = ((TOX_p>1.0e-10)?TOX_p:1.0e-10);
    EPSROX_i = ((EPSROX_p>1.0)?EPSROX_p:1.0);
    NEFF_i = ((NEFF_p>1.0e20)?((NEFF_p<1.0e26)?NEFF_p:1.0e26):1.0e20);
    FACNEFFAC_i = ((FACNEFFAC_p>0.0)?FACNEFFAC_p:0.0);
    GFACNUD_i = ((GFACNUD_p>0.01)?GFACNUD_p:0.01);
    VSBNUD_i = ((VSBNUD_p>0.0)?VSBNUD_p:0.0);
    DVSBNUD_i = ((DVSBNUD_p>0.1)?DVSBNUD_p:0.1);
    VNSUB_i = VNSUB_p;
    NSLP_i = ((NSLP_p>1.0e-3)?NSLP_p:1.0e-3);
    DNSUB_i = ((DNSUB_p>0.0)?((DNSUB_p<1.0)?DNSUB_p:1.0):0.0);
    DPHIB_i = DPHIB_p;
    DELVTAC_i = DELVTAC_p;
    NP_i = ((NP_p>0.0)?NP_p:0.0);
    CT_i = ((CT_p>0.0)?CT_p:0.0);
    TOXOV_i = ((TOXOV_p>1.0e-10)?TOXOV_p:1.0e-10);
    TOXOVD_i = ((TOXOVD_p>1.0e-10)?TOXOVD_p:1.0e-10);
    NOV_i = ((NOV_p>1.0e20)?((NOV_p<1.0e27)?NOV_p:1.0e27):1.0e20);
    NOVD_i = ((NOVD_p>1.0e20)?((NOVD_p<1.0e27)?NOVD_p:1.0e27):1.0e20);
    CF_i = ((CF_p>0.0)?CF_p:0.0);
    CFD_i = ((CFD_p>0.0)?CFD_p:0.0);
    CFB_i = ((CFB_p>0.0)?((CFB_p<1.0)?CFB_p:1.0):0.0);
    PSCE_i = ((PSCE_p>0.0)?PSCE_p:0.0);
    PSCEB_i = ((PSCEB_p>0.0)?((PSCEB_p<1.0)?PSCEB_p:1.0):0.0);
    PSCED_i = ((PSCED_p>0.0)?PSCED_p:0.0);
    BETN_i = ((BETN_p>0.0)?BETN_p:0.0);
    STBET_i = STBET_p;
    MUE_i = ((MUE_p>0.0)?MUE_p:0.0);
    STMUE_i = STMUE_p;
    THEMU_i = ((THEMU_p>0.0)?THEMU_p:0.0);
    STTHEMU_i = STTHEMU_p;
    CS_i = ((CS_p>0.0)?CS_p:0.0);
    STCS_i = STCS_p;
    XCOR_i = ((XCOR_p>0.0)?XCOR_p:0.0);
    STXCOR_i = STXCOR_p;
    FETA_i = ((FETA_p>0.0)?FETA_p:0.0);
    RS_i = ((RS_p>0.0)?RS_p:0.0);
    STRS_i = STRS_p;
    RSB_i = ((RSB_p>(-0.5))?((RSB_p<1.0)?RSB_p:1.0):(-0.5));
    RSG_i = ((RSG_p>(-0.5))?RSG_p:(-0.5));
    THESAT_i = ((THESAT_p>0.0)?THESAT_p:0.0);
    STTHESAT_i = STTHESAT_p;
    THESATB_i = ((THESATB_p>(-0.5))?((THESATB_p<1.0)?THESATB_p:1.0):(-0.5));
    THESATG_i = ((THESATG_p>(-0.5))?THESATG_p:(-0.5));
    AX_i = ((AX_p>2.0)?AX_p:2.0);
    ALP_i = ((ALP_p>0.0)?ALP_p:0.0);
    ALP1_i = ((ALP1_p>0.0)?ALP1_p:0.0);
    ALP2_i = ((ALP2_p>0.0)?ALP2_p:0.0);
    VP_i = ((VP_p>1.0e-10)?VP_p:1.0e-10);
    A1_i = ((A1_p>0.0)?A1_p:0.0);
    A2_i = ((A2_p>0.0)?A2_p:0.0);
    STA2_i = STA2_p;
    A3_i = ((A3_p>0.0)?A3_p:0.0);
    A4_i = ((A4_p>0.0)?A4_p:0.0);
    GCO_i = ((GCO_p>(-10.0))?((GCO_p<10.0)?GCO_p:10.0):(-10.0));
    IGINV_i = ((IGINV_p>0.0)?IGINV_p:0.0);
    IGOV_i = ((IGOV_p>0.0)?IGOV_p:0.0);
    IGOVD_i = ((IGOVD_p>0.0)?IGOVD_p:0.0);
    STIG_i = STIG_p;
    GC2_i = ((GC2_p>0.0)?((GC2_p<10.0)?GC2_p:10.0):0.0);
    GC3_i = ((GC3_p>(-10.0))?((GC3_p<10.0)?GC3_p:10.0):(-10.0));
    CHIB_i = ((CHIB_p>1.0)?CHIB_p:1.0);
    AGIDL_i = ((AGIDL_p>0.0)?AGIDL_p:0.0);
    AGIDLD_i = ((AGIDLD_p>0.0)?AGIDLD_p:0.0);
    BGIDL_i = ((BGIDL_p>0.0)?BGIDL_p:0.0);
    BGIDLD_i = ((BGIDLD_p>0.0)?BGIDLD_p:0.0);
    STBGIDL_i = STBGIDL_p;
    STBGIDLD_i = STBGIDLD_p;
    CGIDL_i = CGIDL_p;
    CGIDLD_i = CGIDLD_p;
    COX_i = ((COX_p>0.0)?COX_p:0.0);
    CGOV_i = ((CGOV_p>0.0)?CGOV_p:0.0);
    CGOVD_i = ((CGOVD_p>0.0)?CGOVD_p:0.0);
    CGBOV_i = ((CGBOV_p>0.0)?CGBOV_p:0.0);
    CFR_i = ((CFR_p>0.0)?CFR_p:0.0);
    CFRD_i = ((CFRD_p>0.0)?CFRD_p:0.0);
    FNT_i = ((FNT_p>0.0)?FNT_p:0.0);
    FNTEXC_i = ((FNTEXC_p>0.0)?FNTEXC_p:0.0);
    NFA_i = ((NFA_p>0.0)?NFA_p:0.0);
    NFB_i = ((NFB_p>0.0)?NFB_p:0.0);
    NFC_i = ((NFC_p>0.0)?NFC_p:0.0);
    EF_i = ((EF_p>0.0)?EF_p:0.0);
    VFBEDGE_i = VFBEDGE_p;
    STVFBEDGE_i = STVFBEDGE_p;
    DPHIBEDGE_i = DPHIBEDGE_p;
    NEFFEDGE_i = ((NEFFEDGE_p>1.0e20)?((NEFFEDGE_p<1.0e26)?NEFFEDGE_p:1.0e26):1.0e20);
    CTEDGE_i = ((CTEDGE_p>0.0)?CTEDGE_p:0.0);
    BETNEDGE_i = ((BETNEDGE_p>0.0)?BETNEDGE_p:0.0);
    STBETEDGE_i = STBETEDGE_p;
    PSCEEDGE_i = ((PSCEEDGE_p>0.0)?PSCEEDGE_p:0.0);
    PSCEBEDGE_i = ((PSCEBEDGE_p>0.0)?((PSCEBEDGE_p<1.0)?PSCEBEDGE_p:1.0):0.0);
    PSCEDEDGE_i = ((PSCEDEDGE_p>0.0)?PSCEDEDGE_p:0.0);
    CFEDGE_i = ((CFEDGE_p>0.0)?CFEDGE_p:0.0);
    CFDEDGE_i = ((CFDEDGE_p>0.0)?CFDEDGE_p:0.0);
    CFBEDGE_i = ((CFBEDGE_p>0.0)?((CFBEDGE_p<1.0)?CFBEDGE_p:1.0):0.0);
    FNTEDGE_i = ((FNTEDGE_p>0.0)?FNTEDGE_p:0.0);
    NFAEDGE_i = ((NFAEDGE_p>0.0)?NFAEDGE_p:0.0);
    NFBEDGE_i = ((NFBEDGE_p>0.0)?NFBEDGE_p:0.0);
    NFCEDGE_i = ((NFCEDGE_p>0.0)?NFCEDGE_p:0.0);
    EFEDGE_i = ((EFEDGE_p>0.0)?EFEDGE_p:0.0);
    RG_i = ((RG_p>0.0)?RG_p:0.0);
    RSE_i = ((RSE_p>0.0)?RSE_p:0.0);
    RDE_i = ((RDE_p>0.0)?RDE_p:0.0);
    RBULK_i = ((RBULK_p>0.0)?RBULK_p:0.0);
    RJUNS_i = ((RJUNS_p>0.0)?RJUNS_p:0.0);
    RJUND_i = ((RJUND_p>0.0)?RJUND_p:0.0);
    RWELL_i = ((RWELL_p>0.0)?RWELL_p:0.0);
    MULT_i = (((MULT*NF_i)>0.0)?(MULT*NF_i):0.0);
    FACTUO_i = ((FACTUO>0.0)?FACTUO:0.0);
    DELVTO_i = DELVTO;
    FACTUOEDGE_i = ((FACTUOEDGE>0.0)?FACTUOEDGE:0.0);
    DELVTOEDGE_i = DELVTOEDGE;
    if (((model_.SWJUNASYM_i)==0))
    {
      TOXOVD_i = TOXOV_i;
      NOVD_i = NOV_i;
      AGIDLD_i = AGIDL_i;
      BGIDLD_i = BGIDL_i;
      STBGIDLD_i = STBGIDL_i;
      CGIDLD_i = CGIDL_i;
      IGOVD_i = IGOV_i;
      CGOVD_i = CGOV_i;
      CFRD_i = CFR_i;
    }
    EPSOX = (8.8541878176E-12*EPSROX_i);
    CoxPrime = (EPSOX/TOX_i);
    tox_sq = (TOX_i*TOX_i);
    Cox_over_q = (CoxPrime/1.6021918E-19);
    NEFFAC_i = (FACNEFFAC_i*NEFF_i);
    NEFFAC_i = ((NEFFAC_i>1.0e20)?((NEFFAC_i<1.0e26)?NEFFAC_i:1.0e26):1.0e20);
    qq = 0.0;
    if (((model_.QMC_i)>0.0))
    {
      {
        double value_pow_0 = pow(CoxPrime,6.6666666666666667e-01);
        qq = (((0.4*5.951993)*(model_.QMC_i))*value_pow_0);
      }
      if (((model_.CHNL_TYPE)==(-1)))
      {
        qq = ((7.448711/5.951993)*qq);
      }
    }
    E_eff0 = ((1.0e-8*CoxPrime)/(model_.EPSSI));
    eta_mu = (0.5*FETA_i);
    eta_mu1 = 0.5;
    if (((model_.CHNL_TYPE)==(-1)))
    {
      eta_mu = (3.3333333333333333e-01*FETA_i);
      eta_mu1 = 3.3333333333333333e-01;
    }
    inv_AX = (1.0/AX_i);
    inv_VP = (1.0/VP_i);
    CoxovPrime = (EPSOX/TOXOV_i);
    CoxovPrime_d = (EPSOX/TOXOVD_i);
    {
      double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NOV_i)*(model_.EPSSI))*(model_.inv_phita)));
      GOV_s = (value_sqrt_0/CoxovPrime);
    }
    {
      double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NOVD_i)*(model_.EPSSI))*(model_.inv_phita)));
      GOV_d = (value_sqrt_0/CoxovPrime_d);
    }
    GOV2_s = (GOV_s*GOV_s);
    GOV2_d = (GOV_d*GOV_d);
    inv_GOV = (1.0/GOV_s);
    SP_OV_eps = ((3.1*GOV_s)+8.5);
    SP_OV_eps2_s = (SP_OV_eps*SP_OV_eps);
    SP_OV_delta = (0.5*SP_OV_eps);
    if ((inv_GOV<0.06))
    {
      SP_OV_a_s = (64.0*inv_GOV);
    }
    else
    {
      if ((inv_GOV<=0.45))
      {
        SP_OV_a_s = ((22.0*inv_GOV)+3.0);
      }
      else
      {
        if ((inv_GOV<=1.6))
        {
          SP_OV_a_s = (((-7.2)*inv_GOV)+15.5);
        }
        else
        {
          SP_OV_a_s = GOV_s;
        }
      }
    }
    {
      double value_sqrt_0 = sqrt(((SP_OV_delta+(GOV2_s*0.25))+SP_OV_a_s));
      SP_OV_delta1_s = ((SP_OV_delta+(GOV2_s*0.5))-(GOV_s*value_sqrt_0));
    }
    inv_GOV = (1.0/GOV_d);
    SP_OV_eps = ((3.1*GOV_d)+8.5);
    SP_OV_eps2_d = (SP_OV_eps*SP_OV_eps);
    SP_OV_delta = (0.5*SP_OV_eps);
    if ((inv_GOV<0.06))
    {
      SP_OV_a_d = (64.0*inv_GOV);
    }
    else
    {
      if ((inv_GOV<=0.45))
      {
        SP_OV_a_d = ((22.0*inv_GOV)+3.0);
      }
      else
      {
        if ((inv_GOV<=1.6))
        {
          SP_OV_a_d = (((-7.2)*inv_GOV)+15.5);
        }
        else
        {
          SP_OV_a_d = GOV_d;
        }
      }
    }
    {
      double value_sqrt_0 = sqrt(((SP_OV_delta+(GOV2_d*0.25))+SP_OV_a_d));
      SP_OV_delta1_d = ((SP_OV_delta+(GOV2_d*0.5))-(GOV_d*value_sqrt_0));
    }
    phit0 = ((model_.phit)*(1.0+(CT_i*(model_.rTn))));
    {
      double value_pow_0 = pow((model_.phibFac),(-0.75));
      double value_log_1 = log(((NEFF_i*value_pow_0)*4.0e-26));
      phib_dc = (((model_.Eg)+DPHIB_i)+((2.0*(model_.phit))*value_log_1));
    }
    phib_dc = ((phib_dc>5.0E-2)?phib_dc:5.0E-2);
    {
      double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NEFF_i)*(model_.EPSSI))*(model_.inv_phit)));
      G_0_dc = (value_sqrt_0/CoxPrime);
    }
    kp = 0.0;
    np = 0.0;
    if ((NP_i>0.0))
    {
      arg2max = (8.0e7/tox_sq);
      np = ((NP_i>arg2max)?NP_i:arg2max);
      np = ((5.0e24>np)?5.0e24:np);
      kp = ((((2.0*CoxPrime)*CoxPrime)*(model_.phit))/((1.6021918E-19*np)*(model_.EPSSI)));
    }
    qlim2 = ((100.0*(model_.phit))*(model_.phit));
    if (((model_.QMC_i)>0.0))
    {
      {
        double value_sqrt_0 = sqrt(((((model_.phit)*G_0_dc)*G_0_dc)*phib_dc));
        qb0 = value_sqrt_0;
      }
      {
        double value_pow_0 = pow(qb0,6.6666666666666667e-01);
        dphibq = ((0.75*qq)*value_pow_0);
      }
      phib_dc = (phib_dc+dphibq);
      G_0_dc = (G_0_dc*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
    }
    {
      double value_sqrt_0 = sqrt(phib_dc);
      sqrt_phib_dc = value_sqrt_0;
    }
    phix_dc = (0.95*phib_dc);
    aphi_dc = ((0.0025*phib_dc)*phib_dc);
    bphi_dc = aphi_dc;
    {
      double value_sqrt_0 = sqrt(bphi_dc);
      phix2 = (0.5*value_sqrt_0);
    }
    {
      double value_sqrt_0 = sqrt(((((phix_dc-phix2))*((phix_dc-phix2)))+aphi_dc));
      phix1_dc = (0.5*(((phix_dc-phix2))-value_sqrt_0));
    }
    alpha_b = (0.5*(phib_dc+(model_.Eg)));
    {
      double value_sqrt_0 = sqrt((VSBNUD_i+phib_dc));
      us1 = (value_sqrt_0-sqrt_phib_dc);
    }
    {
      double value_sqrt_0 = sqrt(((VSBNUD_i+DVSBNUD_i)+phib_dc));
      us21 = ((value_sqrt_0-sqrt_phib_dc)-us1);
    }
    {
      double value_pow_0 = pow((model_.phibFac),(-0.75));
      double value_log_1 = log(((NEFFAC_i*value_pow_0)*4.0e-26));
      phib_ac = ((((model_.Eg)+DPHIB_i)+DELVTAC_i)+((2.0*(model_.phit))*value_log_1));
    }
    phib_ac = ((phib_ac>5.0E-2)?phib_ac:5.0E-2);
    {
      double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NEFFAC_i)*(model_.EPSSI))*(model_.inv_phit)));
      G_0_ac = (value_sqrt_0/CoxPrime);
    }
    if (((model_.QMC_i)>0.0))
    {
      {
        double value_sqrt_0 = sqrt(((((model_.phit)*G_0_ac)*G_0_ac)*phib_ac));
        qb0 = value_sqrt_0;
      }
      {
        double value_pow_0 = pow(qb0,6.6666666666666667e-01);
        dphibq = ((0.75*qq)*value_pow_0);
      }
      phib_ac = (phib_ac+dphibq);
      G_0_ac = (G_0_ac*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
    }
    phix_ac = (0.95*phib_ac);
    aphi_ac = ((0.0025*phib_ac)*phib_ac);
    bphi_ac = aphi_ac;
    {
      double value_sqrt_0 = sqrt(bphi_ac);
      phix2 = (0.5*value_sqrt_0);
    }
    {
      double value_sqrt_0 = sqrt(((((phix_ac-phix2))*((phix_ac-phix2)))+aphi_ac));
      phix1_ac = (0.5*(((phix_ac-phix2))-value_sqrt_0));
    }
    VFB_T = ((VFB_i+(STVFB_i*(model_.delT)))+DELVTO_i);
    {
      double value_exp_0 = exp((STBET_i*(model_.ln_rTn)));
      tf_bet = value_exp_0;
    }
    BETN_T = (BETN_i*tf_bet);
    BET_i = ((FACTUO_i*BETN_T)*CoxPrime);
    {
      double value_exp_0 = exp((STTHEMU_i*(model_.ln_rTn)));
      THEMU_T = (THEMU_i*value_exp_0);
    }
    {
      double value_exp_0 = exp((STMUE_i*(model_.ln_rTn)));
      tf_mue = value_exp_0;
    }
    MUE_T = (MUE_i*tf_mue);
    {
      double value_exp_0 = exp((STCS_i*(model_.ln_rTn)));
      tf_cs = value_exp_0;
    }
    CS_T = (CS_i*tf_cs);
    {
      double value_exp_0 = exp((STXCOR_i*(model_.ln_rTn)));
      tf_xcor = value_exp_0;
    }
    XCOR_T = (XCOR_i*tf_xcor);
    {
      double value_exp_0 = exp((STRS_i*(model_.ln_rTn)));
      tf_ther = value_exp_0;
    }
    RS_T = (RS_i*tf_ther);
    THER_i = ((2.0*BET_i)*RS_T);
    {
      double value_exp_0 = exp((STTHESAT_i*(model_.ln_rTn)));
      tf_thesat = value_exp_0;
    }
    THESAT_T = (THESAT_i*tf_thesat);
    {
      double value_exp_0 = exp(((-STA2_i)*(model_.ln_rTn)));
      A2_T = (A2_i*value_exp_0);
    }
    nt = (((FNT_i*4.0)*1.3806505E-23)*(model_.TKD));
    Sfl_prefac = ((((model_.phit)*(model_.phit))*BET_i)/Cox_over_q);
    if ((((model_.SWEDGE_i)!=0.0)&&(BETNEDGE_i>0.0)))
    {
      VFBEDGE_T = ((VFBEDGE_i+(STVFBEDGE_i*(model_.delT)))+DELVTOEDGE_i);
      {
        double value_exp_0 = exp((STBETEDGE_i*(model_.ln_rTn)));
        tf_betedge = value_exp_0;
      }
      BETNEDGE_T = (BETNEDGE_i*tf_betedge);
      BETEDGE_i = ((FACTUOEDGE_i*BETNEDGE_T)*CoxPrime);
      phit0edge = ((model_.phit)*(1.0+(CTEDGE_i*(model_.rTn))));
      {
        double value_pow_0 = pow((model_.phibFac),(-0.75));
        double value_log_1 = log(((NEFFEDGE_i*value_pow_0)*4.0e-26));
        phibedge = (((model_.Eg)+DPHIBEDGE_i)+((2.0*phit0edge)*value_log_1));
      }
      phibedge = ((phibedge>5.0E-2)?phibedge:5.0E-2);
      {
        double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NEFFEDGE_i)*(model_.EPSSI))*(model_.inv_phit)));
        Gfedge = (value_sqrt_0/CoxPrime);
      }
      Gfedge2 = (Gfedge*Gfedge);
      {
        double value_log_0 = log(Gfedge2);
        lnGfedge2 = value_log_0;
      }
      phixedge = (0.95*phibedge);
      aphiedge = ((0.0025*phibedge)*phibedge);
      bphiedge = aphiedge;
      {
        double value_sqrt_0 = sqrt(bphiedge);
        phix2edge = (0.5*value_sqrt_0);
      }
      {
        double value_sqrt_0 = sqrt(((((phixedge-phix2edge))*((phixedge-phix2edge)))+aphiedge));
        phix1edge = (0.5*(((phixedge-phix2edge))-value_sqrt_0));
      }
      Sfl_prefac_edge = ((((model_.phit)*(model_.phit))*BETEDGE_i)/Cox_over_q);
      ntedge = (((FNTEDGE_i*4.0)*1.3806505E-23)*(model_.TKD));
    }
    else
    {
      VFBEDGE_T = 0.0;
      tf_betedge = 1.0;
      BETNEDGE_T = 0.0;
      BETEDGE_i = 0.0;
      phit0edge = (model_.phit);
      phibedge = 0.0;
      Gfedge = 1.0;
      Gfedge2 = 1.0;
      lnGfedge2 = 0.0;
      phixedge = 0.0;
      aphiedge = 0.0;
      bphiedge = 0.0;
      phix2edge = 0.0;
      phix1edge = 0.0;
      Sfl_prefac_edge = 0.0;
      ntedge = 1.0;
    }
    inv_CHIB = (1.0/CHIB_i);
    {
      double value_sqrt_0 = sqrt((((2.0*1.6021918E-19)*9.1093826E-31)*CHIB_i));
      B_fact = (((4.0*3.3333333333333333e-01)*value_sqrt_0)/1.05457168E-34);
    }
    BCH = (B_fact*TOX_i);
    BOV = (B_fact*TOXOV_i);
    BOV_d = (B_fact*TOXOVD_i);
    GCQ = 0.0;
    if ((GC3_i<0))
    {
      GCQ = (((-0.495)*GC2_i)/GC3_i);
    }
    {
      double value_pow_0 = pow((model_.rTa),STIG_i);
      tf_ig = value_pow_0;
    }
    IGINV_i = (IGINV_i*tf_ig);
    IGOV_i = (IGOV_i*tf_ig);
    IGOVD_i = (IGOVD_i*tf_ig);
    AGIDLs = ((AGIDL_i*4.0e-18)/(TOXOV_i*TOXOV_i));
    AGIDLDs = ((AGIDLD_i*4.0e-18)/(TOXOVD_i*TOXOVD_i));
    B_fact = (((1.0+(STBGIDL_i*(model_.delTa)))>0.0)?(1.0+(STBGIDL_i*(model_.delTa))):0.0);
    BGIDL_T = (BGIDL_i*B_fact);
    BGIDLs = ((BGIDL_T*TOXOV_i)*5.0e8);
    B_fact = (((1.0+(STBGIDLD_i*(model_.delTa)))>0.0)?(1.0+(STBGIDLD_i*(model_.delTa))):0.0);
    BGIDLD_T = (BGIDLD_i*B_fact);
    BGIDLDs = ((BGIDLD_T*TOXOVD_i)*5.0e8);
    fac_exc = ((9.1093826E-31*1.0e9)*FNTEXC_i);
    if ((RG_i>0.0))
    {
      ggate = (1.0/RG_i);
    }
    else
    {
      ggate = 0.0;
    }
    if ((RSE_i>0.0))
    {
      gsource = (1.0/RSE_i);
    }
    else
    {
      gsource = 0.0;
    }
    if ((RDE_i>0.0))
    {
      gdrain = (1.0/RDE_i);
    }
    else
    {
      gdrain = 0.0;
    }
    if ((RBULK_i>0.0))
    {
      gbulk = (1.0/RBULK_i);
    }
    else
    {
      gbulk = 0.0;
    }
    if ((RJUNS_i>0.0))
    {
      gjuns = (1.0/RJUNS_i);
    }
    else
    {
      gjuns = 0.0;
    }
    if ((RJUND_i>0.0))
    {
      gjund = (1.0/RJUND_i);
    }
    else
    {
      gjund = 0.0;
    }
    if ((RWELL_i>0.0))
    {
      gwell = (1.0/RWELL_i);
    }
    else
    {
      gwell = 0.0;
    }
    ABS_i = 0.0;
    LSS_i = 0.0;
    LGS_i = 0.0;
    ABD_i = 0.0;
    LSD_i = 0.0;
    LGD_i = 0.0;
    jwcorr = 0.0;
    jww = WE;
    if (((model_.SWGEO_i)==0))
    {
      jww = ((JW_i>0.0)?JW_i:0.0);
    }
    if (((model_.SWJUNCAP_i)==3))
    {
      jwcorr = 1.0;
    }
    ABS_i = (ABSOURCE_i*invNF);
    LSS_i = (LSSOURCE_i*invNF);
    LGS_i = (LGSOURCE_i*invNF);
    ABD_i = (ABDRAIN_i*invNF);
    LSD_i = (LSDRAIN_i*invNF);
    LGD_i = (LGDRAIN_i*invNF);
    if ((((model_.SWJUNCAP_i)==2)||((model_.SWJUNCAP_i)==3)))
    {
      ABS_i = (AS_i*invNF);
      LSS_i = ((PS_i*invNF)-(jwcorr*jww));
      LGS_i = jww;
      ABD_i = (AD_i*invNF);
      LSD_i = ((PD_i*invNF)-(jwcorr*jww));
      LGD_i = jww;
    }
    if (((((model_.SWJUNCAP_i)==1)||((model_.SWJUNCAP_i)==2))||((model_.SWJUNCAP_i)==3)))
    {
      ABSOURCE_i = ((ABS_i>0.0)?ABS_i:0.0);
      LSSOURCE_i = ((LSS_i>0.0)?LSS_i:0.0);
      LGSOURCE_i = ((LGS_i>0.0)?LGS_i:0.0);
      ABDRAIN_i = ((ABD_i>0.0)?ABD_i:0.0);
      LSDRAIN_i = ((LSD_i>0.0)?LSD_i:0.0);
      LGDRAIN_i = ((LGD_i>0.0)?LGD_i:0.0);
    }
    else
    {
      ABSOURCE_i = 0.0;
      LSSOURCE_i = 0.0;
      LGSOURCE_i = 0.0;
      ABDRAIN_i = 0.0;
      LSDRAIN_i = 0.0;
      LGDRAIN_i = 0.0;
    }
    vbimin_s = 0.0;
    vbimin_d = 0.0;
    vfmin_s = 0.0;
    vfmin_d = 0.0;
    vch_s = 0.0;
    vch_d = 0.0;
    vbbtlim_s = 0.0;
    vbbtlim_d = 0.0;
    VMAX_s = 0.0;
    VMAX_d = 0.0;
    exp_VMAX_over_phitd_s = 0.0;
    exp_VMAX_over_phitd_d = 0.0;
    ISATFOR1_s = 0.0;
    ISATFOR1_d = 0.0;
    MFOR1_s = 1.0;
    MFOR1_d = 1.0;
    ISATFOR2_s = 0.0;
    ISATFOR2_d = 0.0;
    MFOR2_s = 1.0;
    MFOR2_d = 1.0;
    ISATREV_s = 0.0;
    ISATREV_d = 0.0;
    MREV_s = 1.0;
    MREV_d = 1.0;
    m0flag_s = 0.0;
    m0flag_d = 0.0;
    xhighf1_s = 0.0;
    xhighf1_d = 0.0;
    expxhf1_s = 0.0;
    expxhf1_d = 0.0;
    xhighf2_s = 0.0;
    xhighf2_d = 0.0;
    expxhf2_s = 0.0;
    expxhf2_d = 0.0;
    xhighr_s = 0.0;
    xhighr_d = 0.0;
    expxhr_s = 0.0;
    expxhr_d = 0.0;
    zflagbot_s = 1.0;
    zflagbot_d = 1.0;
    zflagsti_s = 1.0;
    zflagsti_d = 1.0;
    zflaggat_s = 1.0;
    zflaggat_d = 1.0;
    m0_rev = 0.0;
    mcor_rev = 0.0;
    I1_cor = 0.0;
    I2_cor = 0.0;
    I3_cor = 0.0;
    I4_cor = 0.0;
    I5_cor = 0.0;
    tt0 = 0.0;
    tt1 = 0.0;
    tt2 = 0.0;
    zfrac = 0.0;
    alphaje = 0.0;
    if (((model_.SWJUNCAP_i)>0))
    {
      if ((((model_.idsatbot)*ABSOURCE_i)>0.0))
      {
        {
          double value_log_0 = log((((model_.IMAX_i)/((model_.idsatbot)*ABSOURCE_i))+1.0));
          vmaxbot = ((model_.phitd)*value_log_0);
        }
      }
      else
      {
        vmaxbot = 1.0e8;
      }
      if ((((model_.idsatsti)*LSSOURCE_i)>0.0))
      {
        {
          double value_log_0 = log((((model_.IMAX_i)/((model_.idsatsti)*LSSOURCE_i))+1.0));
          vmaxsti = ((model_.phitd)*value_log_0);
        }
      }
      else
      {
        vmaxsti = 1.0e8;
      }
      if ((((model_.idsatgat)*LGSOURCE_i)>0.0))
      {
        {
          double value_log_0 = log((((model_.IMAX_i)/((model_.idsatgat)*LGSOURCE_i))+1.0));
          vmaxgat = ((model_.phitd)*value_log_0);
        }
      }
      else
      {
        vmaxgat = 1.0e8;
      }
      {
        double value_min_0 = std::min(vmaxbot,vmaxsti);
        double value_min_1 = std::min(value_min_0,vmaxgat);
        VMAX_s = value_min_1;
      }
      if ((fabs((VMAX_s*(model_.phitdinv)))<2.3025850929940458e+02))
      {
        {
          double value_exp_0 = exp((VMAX_s*(model_.phitdinv)));
          exp_VMAX_over_phitd_s = value_exp_0;
        }
      }
      else
      {
        if (((VMAX_s*(model_.phitdinv))<0.0))
        {
          exp_VMAX_over_phitd_s = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(VMAX_s*(model_.phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(VMAX_s*(model_.phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(VMAX_s*(model_.phitdinv)))*3.3333333333333333e-01))))))));
        }
        else
        {
          exp_VMAX_over_phitd_s = (1.0e100*(1.0+(((VMAX_s*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((VMAX_s*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(((VMAX_s*(model_.phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
        }
      }
      vbibot2 = (model_.vbibot);
      vbisti2 = (model_.vbisti);
      vbigat2 = (model_.vbigat);
      pbot2 = (model_.PBOT_i);
      psti2 = (model_.PSTI_i);
      pgat2 = (model_.PGAT_i);
      vbibot2r = (model_.VBIRBOT_i);
      vbisti2r = (model_.VBIRSTI_i);
      vbigat2r = (model_.VBIRGAT_i);
      if ((ABSOURCE_i==0.0))
      {
        vbibot2 = ((model_.vbisti)+(model_.vbigat));
        {
          double value_min_0 = std::min((model_.PSTI_i),(model_.PGAT_i));
          pbot2 = (0.9*value_min_0);
        }
        vbibot2r = ((model_.VBIRSTI_i)+(model_.VBIRGAT_i));
      }
      if ((LSSOURCE_i==0.0))
      {
        vbisti2 = ((model_.vbibot)+(model_.vbigat));
        {
          double value_min_0 = std::min((model_.PBOT_i),(model_.PGAT_i));
          psti2 = (0.9*value_min_0);
        }
        vbisti2r = ((model_.VBIRBOT_i)+(model_.VBIRGAT_i));
      }
      if ((LGSOURCE_i==0.0))
      {
        vbigat2 = ((model_.vbibot)+(model_.vbisti));
        {
          double value_min_0 = std::min((model_.PBOT_i),(model_.PSTI_i));
          pgat2 = (0.9*value_min_0);
        }
        vbigat2r = ((model_.VBIRBOT_i)+(model_.VBIRSTI_i));
      }
      {
        double value_min_0 = std::min(vbibot2,vbisti2);
        double value_min_1 = std::min(value_min_0,vbigat2);
        vbimin_s = value_min_1;
      }
      vch_s = (vbimin_s*0.1);
      {
        double value_max_0 = std::max(pbot2,psti2);
        double value_max_1 = std::max(value_max_0,pgat2);
        pmax = value_max_1;
      }
      {
        double value_pow_0 = pow(2.0,((-1.0)/pmax));
        vfmin_s = (vbimin_s*(1.0-value_pow_0));
      }
      {
        double value_min_0 = std::min(vbibot2r,vbisti2r);
        double value_min_1 = std::min(value_min_0,vbigat2r);
        vbbtlim_s = (value_min_1-5.0e-2);
      }
      if ((((model_.idsatbot_d)*ABDRAIN_i)>0.0))
      {
        {
          double value_log_0 = log((((model_.IMAX_i)/((model_.idsatbot_d)*ABDRAIN_i))+1.0));
          vmaxbot = ((model_.phitd)*value_log_0);
        }
      }
      else
      {
        vmaxbot = 1.0e8;
      }
      if ((((model_.idsatsti_d)*LSDRAIN_i)>0.0))
      {
        {
          double value_log_0 = log((((model_.IMAX_i)/((model_.idsatsti_d)*LSDRAIN_i))+1.0));
          vmaxsti = ((model_.phitd)*value_log_0);
        }
      }
      else
      {
        vmaxsti = 1.0e8;
      }
      if ((((model_.idsatgat_d)*LGDRAIN_i)>0.0))
      {
        {
          double value_log_0 = log((((model_.IMAX_i)/((model_.idsatgat_d)*LGDRAIN_i))+1.0));
          vmaxgat = ((model_.phitd)*value_log_0);
        }
      }
      else
      {
        vmaxgat = 1.0e8;
      }
      {
        double value_min_0 = std::min(vmaxbot,vmaxsti);
        double value_min_1 = std::min(value_min_0,vmaxgat);
        VMAX_d = value_min_1;
      }
      if ((fabs((VMAX_d*(model_.phitdinv)))<2.3025850929940458e+02))
      {
        {
          double value_exp_0 = exp((VMAX_d*(model_.phitdinv)));
          exp_VMAX_over_phitd_d = value_exp_0;
        }
      }
      else
      {
        if (((VMAX_d*(model_.phitdinv))<0.0))
        {
          exp_VMAX_over_phitd_d = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(VMAX_d*(model_.phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(VMAX_d*(model_.phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(VMAX_d*(model_.phitdinv)))*3.3333333333333333e-01))))))));
        }
        else
        {
          exp_VMAX_over_phitd_d = (1.0e100*(1.0+(((VMAX_d*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((VMAX_d*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(((VMAX_d*(model_.phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
        }
      }
      vbibot2 = (model_.vbibot_d);
      vbisti2 = (model_.vbisti_d);
      vbigat2 = (model_.vbigat_d);
      pbot2 = (model_.PBOTD_i);
      psti2 = (model_.PSTID_i);
      pgat2 = (model_.PGATD_i);
      vbibot2r = (model_.VBIRBOTD_i);
      vbisti2r = (model_.VBIRSTID_i);
      vbigat2r = (model_.VBIRGATD_i);
      if ((ABDRAIN_i==0.0))
      {
        vbibot2 = ((model_.vbisti_d)+(model_.vbigat_d));
        {
          double value_min_0 = std::min((model_.PSTID_i),(model_.PGATD_i));
          pbot2 = (0.9*value_min_0);
        }
        vbibot2r = ((model_.VBIRSTID_i)+(model_.VBIRGATD_i));
      }
      if ((LSDRAIN_i==0.0))
      {
        vbisti2 = ((model_.vbibot_d)+(model_.vbigat_d));
        {
          double value_min_0 = std::min((model_.PBOTD_i),(model_.PGATD_i));
          psti2 = (0.9*value_min_0);
        }
        vbisti2r = ((model_.VBIRBOTD_i)+(model_.VBIRGATD_i));
      }
      if ((LGDRAIN_i==0.0))
      {
        vbigat2 = ((model_.vbibot_d)+(model_.vbisti_d));
        {
          double value_min_0 = std::min((model_.PBOTD_i),(model_.PSTID_i));
          pgat2 = (0.9*value_min_0);
        }
        vbigat2r = ((model_.VBIRBOTD_i)+(model_.VBIRSTID_i));
      }
      {
        double value_min_0 = std::min(vbibot2,vbisti2);
        double value_min_1 = std::min(value_min_0,vbigat2);
        vbimin_d = value_min_1;
      }
      vch_d = (vbimin_d*0.1);
      {
        double value_max_0 = std::max(pbot2,psti2);
        double value_max_1 = std::max(value_max_0,pgat2);
        pmax = value_max_1;
      }
      {
        double value_pow_0 = pow(2.0,((-1.0)/pmax));
        vfmin_d = (vbimin_d*(1.0-value_pow_0));
      }
      {
        double value_min_0 = std::min(vbibot2r,vbisti2r);
        double value_min_1 = std::min(value_min_0,vbigat2r);
        vbbtlim_d = (value_min_1-5.0e-2);
      }
      if (((model_.SWJUNEXP_i)==1))
        //Begin block JUNCAPexpressInit
      {
        //Block-local variables for block JUNCAPexpressInit
        double ysq;
        double terfc;
        double erfcpos;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double h1;
        double h2;
        double h2d;
        double h3;
        double h4;
        double h5;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double idmult;
        double vj;
        double z;
        double zinv;
        double two_psistar;
        double vjlim;
        double vjsrh;
        double vbbt;
        double vav;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double tmp;
        double id;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double isrh;
        double vbi_minus_vjsrh;
        double wsrhstep;
        double dwsrh;
        double wsrh;
        double wdep;
        double asrh;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double itat;
        double btat;
        double twoatatoverthreebtat;
        double umaxbeforelimiting;
        double umax;
        double sqrtumax;
        double umaxpoweronepointfive;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double wgamma;
        double wtat;
        double ktat;
        double ltat;
        double mtat;
        double xerfc;
        double erfctimesexpmtat;
        double gammamax;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double ibbt;
        double Fmaxr;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double fbreakdown;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        double ijunbot;
        double ijunsti;
        double ijungat;
        double qjunbot;
        double qjunsti;
        double qjungat;
        //End of Block-local variables
        ysq = 0.0;
        terfc = 0.0;
        erfcpos = 0.0;
        h1 = 0.0;
        h2 = 0.0;
        h2d = 0.0;
        h3 = 0.0;
        h4 = 0.0;
        h5 = 0.0;
        idmult = 0.0;
        vj = 0.0;
        z = 0.0;
        zinv = 0.0;
        two_psistar = 0.0;
        vjlim = 0.0;
        vjsrh = 0.0;
        vbbt = 0.0;
        vav = 0.0;
        tmp = 0.0;
        id = 0.0;
        isrh = 0.0;
        vbi_minus_vjsrh = 0.0;
        wsrhstep = 0.0;
        dwsrh = 0.0;
        wsrh = 0.0;
        wdep = 0.0;
        asrh = 0.0;
        itat = 0.0;
        btat = 0.0;
        twoatatoverthreebtat = 0.0;
        umaxbeforelimiting = 0.0;
        umax = 0.0;
        sqrtumax = 0.0;
        umaxpoweronepointfive = 0.0;
        wgamma = 0.0;
        wtat = 0.0;
        ktat = 0.0;
        ltat = 0.0;
        mtat = 0.0;
        xerfc = 0.0;
        erfctimesexpmtat = 0.0;
        gammamax = 0.0;
        ibbt = 0.0;
        Fmaxr = 0.0;
        fbreakdown = 0.0;
        qjunbot = 0.0;
        qjunsti = 0.0;
        qjungat = 0.0;
        FRACNA = 0.4;
        FRACNB = 0.65;
        FRACI = 0.8;
        V1 = ((-FRACNA)*(model_.VJUNREF_i));
        V2 = ((-FRACNB)*(model_.VJUNREF_i));
        V3 = ((-FRACI)*(model_.VJUNREF_i));
        V4 = 0.1;
        V5 = 0.2;
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
        {
          h1 = ((4.0*vch_s)*vch_s);
          h2 = (vch_s/vfmin_s);
          h2d = (V1+(vch_s*h2));
          h3 = (vfmin_s+h2d);
          h4 = (vfmin_s-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V1*vfmin_s)/(h3+h5)));
          if ((V1<VMAX_s))
          {
            if ((fabs((0.5*(V1*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V1*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V1*(model_.phitdinv)))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V1-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V1>0.0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V1)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_s-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V1-vbbtlim_s)*(V1-vbbtlim_s))+((4.0*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V1+vbbtlim_s)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V1)*(V1))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V1)-value_sqrt_0));
          }
        }
        if ((ABSOURCE_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if (((model_.one_minus_PBOT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V1-vj)));
          id = ((model_.idsatbot)*idmult);
          if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PBOT_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot)*tmp);
            asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOT_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOT_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
            if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOT_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOT_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
            {
              if (((model_.PBRBOT_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSSOURCE_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if (((model_.one_minus_PSTI)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V1-vj)));
          id = ((model_.idsatsti)*idmult);
          if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PSTI_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti)*tmp);
            asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTI_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTI_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
            if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTI_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTI_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
            {
              if (((model_.PBRSTI_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGSOURCE_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if (((model_.one_minus_PGAT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V1-vj)));
          id = ((model_.idsatgat)*idmult);
          if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PGAT_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat)*tmp);
            asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
          }
          if (((model_.CTATGAT_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGAT_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
            if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGAT_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGAT_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
            {
              if (((model_.PBRGAT_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I1 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
        {
          h1 = ((4.0*vch_s)*vch_s);
          h2 = (vch_s/vfmin_s);
          h2d = (V2+(vch_s*h2));
          h3 = (vfmin_s+h2d);
          h4 = (vfmin_s-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V2*vfmin_s)/(h3+h5)));
          if ((V2<VMAX_s))
          {
            if ((fabs((0.5*(V2*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V2*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V2*(model_.phitdinv)))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V2-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V2>0.0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V2)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_s-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V2-vbbtlim_s)*(V2-vbbtlim_s))+((4.0*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V2+vbbtlim_s)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V2)*(V2))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V2)-value_sqrt_0));
          }
        }
        if ((ABSOURCE_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if (((model_.one_minus_PBOT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V2-vj)));
          id = ((model_.idsatbot)*idmult);
          if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PBOT_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot)*tmp);
            asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOT_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOT_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
            if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOT_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOT_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
            {
              if (((model_.PBRBOT_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSSOURCE_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if (((model_.one_minus_PSTI)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V2-vj)));
          id = ((model_.idsatsti)*idmult);
          if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PSTI_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti)*tmp);
            asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTI_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTI_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
            if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTI_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTI_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
            {
              if (((model_.PBRSTI_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGSOURCE_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if (((model_.one_minus_PGAT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V2-vj)));
          id = ((model_.idsatgat)*idmult);
          if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PGAT_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat)*tmp);
            asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
          }
          if (((model_.CTATGAT_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGAT_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
            if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGAT_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGAT_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
            {
              if (((model_.PBRGAT_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I2 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
        {
          h1 = ((4.0*vch_s)*vch_s);
          h2 = (vch_s/vfmin_s);
          h2d = (V3+(vch_s*h2));
          h3 = (vfmin_s+h2d);
          h4 = (vfmin_s-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V3*vfmin_s)/(h3+h5)));
          if ((V3<VMAX_s))
          {
            if ((fabs((0.5*(V3*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V3*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V3*(model_.phitdinv)))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V3-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V3>0.0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V3)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_s-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V3-vbbtlim_s)*(V3-vbbtlim_s))+((4.0*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V3+vbbtlim_s)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V3)*(V3))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V3)-value_sqrt_0));
          }
        }
        if ((ABSOURCE_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if (((model_.one_minus_PBOT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V3-vj)));
          id = ((model_.idsatbot)*idmult);
          if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PBOT_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot)*tmp);
            asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOT_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOT_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
            if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOT_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOT_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
            {
              if (((model_.PBRBOT_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSSOURCE_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if (((model_.one_minus_PSTI)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V3-vj)));
          id = ((model_.idsatsti)*idmult);
          if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PSTI_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti)*tmp);
            asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTI_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTI_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
            if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTI_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTI_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
            {
              if (((model_.PBRSTI_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGSOURCE_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if (((model_.one_minus_PGAT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V3-vj)));
          id = ((model_.idsatgat)*idmult);
          if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PGAT_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat)*tmp);
            asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
          }
          if (((model_.CTATGAT_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGAT_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
            if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGAT_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGAT_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
            {
              if (((model_.PBRGAT_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I3 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
        {
          h1 = ((4.0*vch_s)*vch_s);
          h2 = (vch_s/vfmin_s);
          h2d = (V4+(vch_s*h2));
          h3 = (vfmin_s+h2d);
          h4 = (vfmin_s-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V4*vfmin_s)/(h3+h5)));
          if ((V4<VMAX_s))
          {
            if ((fabs((0.5*(V4*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V4*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V4*(model_.phitdinv)))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V4-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V4>0.0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V4)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_s-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V4-vbbtlim_s)*(V4-vbbtlim_s))+((4.0*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V4+vbbtlim_s)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V4)*(V4))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V4)-value_sqrt_0));
          }
        }
        if ((ABSOURCE_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if (((model_.one_minus_PBOT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V4-vj)));
          id = ((model_.idsatbot)*idmult);
          if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PBOT_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot)*tmp);
            asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOT_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOT_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
            if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOT_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOT_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
            {
              if (((model_.PBRBOT_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSSOURCE_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if (((model_.one_minus_PSTI)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V4-vj)));
          id = ((model_.idsatsti)*idmult);
          if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PSTI_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti)*tmp);
            asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTI_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTI_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
            if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTI_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTI_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
            {
              if (((model_.PBRSTI_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGSOURCE_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if (((model_.one_minus_PGAT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V4-vj)));
          id = ((model_.idsatgat)*idmult);
          if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PGAT_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat)*tmp);
            asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
          }
          if (((model_.CTATGAT_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGAT_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
            if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGAT_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGAT_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
            {
              if (((model_.PBRGAT_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I4 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
        {
          h1 = ((4.0*vch_s)*vch_s);
          h2 = (vch_s/vfmin_s);
          h2d = (V5+(vch_s*h2));
          h3 = (vfmin_s+h2d);
          h4 = (vfmin_s-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V5*vfmin_s)/(h3+h5)));
          if ((V5<VMAX_s))
          {
            if ((fabs((0.5*(V5*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V5*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V5*(model_.phitdinv)))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V5-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V5>0.0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V5)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_s-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V5-vbbtlim_s)*(V5-vbbtlim_s))+((4.0*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V5+vbbtlim_s)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V5)*(V5))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V5)-value_sqrt_0));
          }
        }
        if ((ABSOURCE_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if (((model_.one_minus_PBOT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V5-vj)));
          id = ((model_.idsatbot)*idmult);
          if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PBOT_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot)*tmp);
            asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOT_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOT_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PBOT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
            if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOT_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOT_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
            {
              if (((model_.PBRBOT_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSSOURCE_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if (((model_.one_minus_PSTI)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V5-vj)));
          id = ((model_.idsatsti)*idmult);
          if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PSTI_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti)*tmp);
            asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTI_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTI_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PSTI_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
            if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTI_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTI_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
            {
              if (((model_.PBRSTI_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGSOURCE_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if (((model_.one_minus_PGAT)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V5-vj)));
          id = ((model_.idsatgat)*idmult);
          if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PGAT_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat)*tmp);
            asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
          }
          if (((model_.CTATGAT_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGAT_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PGAT_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
            if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGAT_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGAT_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
            {
              if (((model_.PBRGAT_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I5 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
        ISATFOR1_s = (((ABSOURCE_i*(model_.idsatbot))+(LSSOURCE_i*(model_.idsatsti)))+(LGSOURCE_i*(model_.idsatgat)));
        {
          double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR1_s));
          I4_cor = (I4-(ISATFOR1_s*(value_exp_0-1.0)));
        }
        {
          double value_exp_0 = exp(((V5*(model_.phitdinv))*MFOR1_s));
          I5_cor = (I5-(ISATFOR1_s*(value_exp_0-1.0)));
        }
        if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
        {
          if (((I4>0.0)&&(I5>0.0)))
          {
            if ((((((I4_cor/I4)>1.0e-3)||((I5_cor/I5)>1.0e-3))&&(I4_cor>0.0))&&(I5_cor>0.0)))
            {
              alphaje = (I4_cor/I5_cor);
              {
                double value_log_0 = log(alphaje);
                MFOR2_s = (((model_.phitd)*value_log_0)/(V4-V5));
              }
              {
                double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR2_s));
                ISATFOR2_s = (I4_cor/(value_exp_0-1.0));
              }
            }
          }
          {
            double value_exp_0 = exp(((V1*(model_.phitdinv))*MFOR1_s));
            double value_exp_1 = exp(((V1*(model_.phitdinv))*MFOR2_s));
            I1_cor = ((I1-(ISATFOR1_s*(value_exp_0-1.0)))-(ISATFOR2_s*(value_exp_1-1.0)));
          }
          {
            double value_exp_0 = exp(((V2*(model_.phitdinv))*MFOR1_s));
            double value_exp_1 = exp(((V2*(model_.phitdinv))*MFOR2_s));
            I2_cor = ((I2-(ISATFOR1_s*(value_exp_0-1.0)))-(ISATFOR2_s*(value_exp_1-1.0)));
          }
          {
            double value_exp_0 = exp(((V3*(model_.phitdinv))*MFOR1_s));
            double value_exp_1 = exp(((V3*(model_.phitdinv))*MFOR2_s));
            I3_cor = ((I3-(ISATFOR1_s*(value_exp_0-1.0)))-(ISATFOR2_s*(value_exp_1-1.0)));
          }
          if ((((I1<0.0)&&(I2<0.0))&&(I3<0.0)))
          {
            if ((((((((I1_cor/I1)>1.0e-3)||((I2_cor/I2)>1.0e-3))||((I3_cor/I3)>1.0e-3))&&(I1_cor<0.0))&&(I2_cor<0.0))&&(I3_cor<0.0)))
            {
              alphaje = (I1_cor/I2_cor);
              {
                double value_log_0 = log(alphaje);
                m0_rev = (((-(model_.phitd))*value_log_0)/(V1-V2));
              }
              tt0 = (V2/(V2-V1));
              {
                double value_pow_0 = pow(alphaje,tt0);
                tt1 = (((model_.phitd)*(alphaje-1.0))*(value_pow_0-1.0));
              }
              tt0 = (V1/(V1-V2));
              {
                double value_pow_0 = pow(alphaje,tt0);
                tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
              }
              mcor_rev = (tt1/tt2);
              MREV_s = (m0_rev+mcor_rev);
              if ((fabs(((V3*(model_.phitdinv))*MREV_s))<1.0e-6))
              {
                m0flag_s = 1.0;
                ISATREV_s = (I3_cor*((1.0/V3)+((0.5*(model_.phitdinv))*MREV_s)));
                MREV_s = (((((-0.5)*I3_cor)*MREV_s)*(model_.phitdinv))/V3);
              }
              else
              {
                m0flag_s = 0.0;
                {
                  double value_exp_0 = exp((((-V3)*(model_.phitdinv))*MREV_s));
                  ISATREV_s = ((-I3_cor)/(value_exp_0-1.0));
                }
              }
            }
          }
        }
        zfrac = ((model_.FJUNQ_i)*(((ABSOURCE_i*(model_.cjobot))+(LSSOURCE_i*(model_.cjosti)))+(LGSOURCE_i*(model_.cjogat))));
        if (((ABSOURCE_i*(model_.cjobot))<=zfrac))
        {
          zflagbot_s = 0.0;
        }
        if (((LSSOURCE_i*(model_.cjosti))<=zfrac))
        {
          zflagsti_s = 0.0;
        }
        if (((LGSOURCE_i*(model_.cjogat))<=zfrac))
        {
          zflaggat_s = 0.0;
        }
        if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
        {
          {
            double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR1_s+1.0e-21)));
            xhighf1_s = value_log_0;
          }
          {
            double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR2_s+1.0e-21)));
            xhighf2_s = value_log_0;
          }
          {
            double value_fabs_0 = fabs(ISATREV_s);
            double value_log_1 = log(((0.5*(model_.IMAX_i))/(value_fabs_0+1.0e-21)));
            xhighr_s = value_log_1;
          }
        }
        {
          double value_min_0 = std::min(xhighf1_s,static_cast<double>(2.3025850929940458e+02));
          xhighf1_s = value_min_0;
        }
        {
          double value_exp_0 = exp(xhighf1_s);
          expxhf1_s = value_exp_0;
        }
        {
          double value_min_0 = std::min(xhighf2_s,static_cast<double>(2.3025850929940458e+02));
          xhighf2_s = value_min_0;
        }
        {
          double value_exp_0 = exp(xhighf2_s);
          expxhf2_s = value_exp_0;
        }
        {
          double value_min_0 = std::min(xhighr_s,static_cast<double>(2.3025850929940458e+02));
          xhighr_s = value_min_0;
        }
        {
          double value_exp_0 = exp(xhighr_s);
          expxhr_s = value_exp_0;
        }
        FRACNA = 0.4;
        FRACNB = 0.65;
        FRACI = 0.8;
        V1 = ((-FRACNA)*(model_.VJUNREFD_i));
        V2 = ((-FRACNB)*(model_.VJUNREFD_i));
        V3 = ((-FRACI)*(model_.VJUNREFD_i));
        V4 = 0.1;
        V5 = 0.2;
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
        {
          h1 = ((4.0*vch_d)*vch_d);
          h2 = (vch_d/vfmin_d);
          h2d = (V1+(vch_d*h2));
          h3 = (vfmin_d+h2d);
          h4 = (vfmin_d-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V1*vfmin_d)/(h3+h5)));
          if ((V1<VMAX_d))
          {
            if ((fabs((0.5*(V1*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V1*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V1*(model_.phitdinv)))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V1-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V1>0.0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V1)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_d-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V1-vbbtlim_d)*(V1-vbbtlim_d))+((4.0*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V1+vbbtlim_d)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V1)*(V1))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V1)-value_sqrt_0));
          }
        }
        if ((ABDRAIN_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if (((model_.one_minus_PBOT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot_d)*(1.0-tmp))+((model_.qpref2bot_d)*(V1-vj)));
          id = ((model_.idsatbot_d)*idmult);
          if ((((model_.CSRHBOTD_i)==0.0)&&((model_.CTATBOTD_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PBOTD_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOTD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot_d)*tmp);
            asrh = ((model_.ftdbot_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOTD_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOTD_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
            if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOTD_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOTD_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRBOTD_i))))
            {
              if (((model_.PBRBOTD_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot_d)+((vav+((model_.alphaav)*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSDRAIN_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if (((model_.one_minus_PSTI_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti_d)*(1.0-tmp))+((model_.qpref2sti_d)*(V1-vj)));
          id = ((model_.idsatsti_d)*idmult);
          if ((((model_.CSRHSTID_i)==0.0)&&((model_.CTATSTID_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PSTID_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTID_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti_d)*tmp);
            asrh = ((model_.ftdsti_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTID_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTID_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
            if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTID_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTID_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRSTID_i))))
            {
              if (((model_.PBRSTID_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti_d)+((vav+((model_.alphaav)*(model_.VBRSTID_i)))*(model_.slopesti_d)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGDRAIN_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if (((model_.one_minus_PGAT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat_d)*(1.0-tmp))+((model_.qpref2gat_d)*(V1-vj)));
          id = ((model_.idsatgat_d)*idmult);
          if ((((model_.CSRHGATD_i)==0.0)&&((model_.CTATGATD_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PGATD_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGATD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat_d)*tmp);
            asrh = ((model_.ftdgat_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
          }
          if (((model_.CTATGATD_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGATD_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
            if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGATD_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGATD_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRGATD_i))))
            {
              if (((model_.PBRGATD_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat_d)+((vav+((model_.alphaav)*(model_.VBRGATD_i)))*(model_.slopegat_d)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I1 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
        {
          h1 = ((4.0*vch_d)*vch_d);
          h2 = (vch_d/vfmin_d);
          h2d = (V2+(vch_d*h2));
          h3 = (vfmin_d+h2d);
          h4 = (vfmin_d-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V2*vfmin_d)/(h3+h5)));
          if ((V2<VMAX_d))
          {
            if ((fabs((0.5*(V2*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V2*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V2*(model_.phitdinv)))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V2-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V2>0.0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V2)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_d-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V2-vbbtlim_d)*(V2-vbbtlim_d))+((4.0*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V2+vbbtlim_d)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V2)*(V2))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V2)-value_sqrt_0));
          }
        }
        if ((ABDRAIN_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if (((model_.one_minus_PBOT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot_d)*(1.0-tmp))+((model_.qpref2bot_d)*(V2-vj)));
          id = ((model_.idsatbot_d)*idmult);
          if ((((model_.CSRHBOTD_i)==0.0)&&((model_.CTATBOTD_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PBOTD_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOTD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot_d)*tmp);
            asrh = ((model_.ftdbot_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOTD_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOTD_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
            if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOTD_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOTD_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRBOTD_i))))
            {
              if (((model_.PBRBOTD_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot_d)+((vav+((model_.alphaav)*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSDRAIN_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if (((model_.one_minus_PSTI_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti_d)*(1.0-tmp))+((model_.qpref2sti_d)*(V2-vj)));
          id = ((model_.idsatsti_d)*idmult);
          if ((((model_.CSRHSTID_i)==0.0)&&((model_.CTATSTID_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PSTID_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTID_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti_d)*tmp);
            asrh = ((model_.ftdsti_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTID_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTID_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
            if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTID_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTID_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRSTID_i))))
            {
              if (((model_.PBRSTID_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti_d)+((vav+((model_.alphaav)*(model_.VBRSTID_i)))*(model_.slopesti_d)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGDRAIN_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if (((model_.one_minus_PGAT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat_d)*(1.0-tmp))+((model_.qpref2gat_d)*(V2-vj)));
          id = ((model_.idsatgat_d)*idmult);
          if ((((model_.CSRHGATD_i)==0.0)&&((model_.CTATGATD_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PGATD_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGATD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat_d)*tmp);
            asrh = ((model_.ftdgat_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
          }
          if (((model_.CTATGATD_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGATD_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
            if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGATD_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGATD_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRGATD_i))))
            {
              if (((model_.PBRGATD_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat_d)+((vav+((model_.alphaav)*(model_.VBRGATD_i)))*(model_.slopegat_d)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I2 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
        {
          h1 = ((4.0*vch_d)*vch_d);
          h2 = (vch_d/vfmin_d);
          h2d = (V3+(vch_d*h2));
          h3 = (vfmin_d+h2d);
          h4 = (vfmin_d-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V3*vfmin_d)/(h3+h5)));
          if ((V3<VMAX_d))
          {
            if ((fabs((0.5*(V3*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V3*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V3*(model_.phitdinv)))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V3-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V3>0.0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V3)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_d-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V3-vbbtlim_d)*(V3-vbbtlim_d))+((4.0*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V3+vbbtlim_d)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V3)*(V3))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V3)-value_sqrt_0));
          }
        }
        if ((ABDRAIN_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if (((model_.one_minus_PBOT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot_d)*(1.0-tmp))+((model_.qpref2bot_d)*(V3-vj)));
          id = ((model_.idsatbot_d)*idmult);
          if ((((model_.CSRHBOTD_i)==0.0)&&((model_.CTATBOTD_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PBOTD_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOTD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot_d)*tmp);
            asrh = ((model_.ftdbot_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOTD_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOTD_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
            if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOTD_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOTD_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRBOTD_i))))
            {
              if (((model_.PBRBOTD_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot_d)+((vav+((model_.alphaav)*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSDRAIN_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if (((model_.one_minus_PSTI_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti_d)*(1.0-tmp))+((model_.qpref2sti_d)*(V3-vj)));
          id = ((model_.idsatsti_d)*idmult);
          if ((((model_.CSRHSTID_i)==0.0)&&((model_.CTATSTID_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PSTID_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTID_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti_d)*tmp);
            asrh = ((model_.ftdsti_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTID_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTID_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
            if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTID_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTID_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRSTID_i))))
            {
              if (((model_.PBRSTID_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti_d)+((vav+((model_.alphaav)*(model_.VBRSTID_i)))*(model_.slopesti_d)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGDRAIN_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if (((model_.one_minus_PGAT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat_d)*(1.0-tmp))+((model_.qpref2gat_d)*(V3-vj)));
          id = ((model_.idsatgat_d)*idmult);
          if ((((model_.CSRHGATD_i)==0.0)&&((model_.CTATGATD_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PGATD_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGATD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat_d)*tmp);
            asrh = ((model_.ftdgat_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
          }
          if (((model_.CTATGATD_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGATD_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
            if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGATD_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGATD_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRGATD_i))))
            {
              if (((model_.PBRGATD_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat_d)+((vav+((model_.alphaav)*(model_.VBRGATD_i)))*(model_.slopegat_d)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I3 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
        {
          h1 = ((4.0*vch_d)*vch_d);
          h2 = (vch_d/vfmin_d);
          h2d = (V4+(vch_d*h2));
          h3 = (vfmin_d+h2d);
          h4 = (vfmin_d-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V4*vfmin_d)/(h3+h5)));
          if ((V4<VMAX_d))
          {
            if ((fabs((0.5*(V4*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V4*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V4*(model_.phitdinv)))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V4-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V4>0.0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V4)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_d-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V4-vbbtlim_d)*(V4-vbbtlim_d))+((4.0*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V4+vbbtlim_d)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V4)*(V4))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V4)-value_sqrt_0));
          }
        }
        if ((ABDRAIN_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if (((model_.one_minus_PBOT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot_d)*(1.0-tmp))+((model_.qpref2bot_d)*(V4-vj)));
          id = ((model_.idsatbot_d)*idmult);
          if ((((model_.CSRHBOTD_i)==0.0)&&((model_.CTATBOTD_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PBOTD_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOTD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot_d)*tmp);
            asrh = ((model_.ftdbot_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOTD_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOTD_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
            if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOTD_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOTD_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRBOTD_i))))
            {
              if (((model_.PBRBOTD_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot_d)+((vav+((model_.alphaav)*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSDRAIN_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if (((model_.one_minus_PSTI_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti_d)*(1.0-tmp))+((model_.qpref2sti_d)*(V4-vj)));
          id = ((model_.idsatsti_d)*idmult);
          if ((((model_.CSRHSTID_i)==0.0)&&((model_.CTATSTID_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PSTID_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTID_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti_d)*tmp);
            asrh = ((model_.ftdsti_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTID_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTID_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
            if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTID_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTID_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRSTID_i))))
            {
              if (((model_.PBRSTID_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti_d)+((vav+((model_.alphaav)*(model_.VBRSTID_i)))*(model_.slopesti_d)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGDRAIN_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if (((model_.one_minus_PGAT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat_d)*(1.0-tmp))+((model_.qpref2gat_d)*(V4-vj)));
          id = ((model_.idsatgat_d)*idmult);
          if ((((model_.CSRHGATD_i)==0.0)&&((model_.CTATGATD_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PGATD_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGATD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat_d)*tmp);
            asrh = ((model_.ftdgat_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
          }
          if (((model_.CTATGATD_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGATD_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
            if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGATD_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGATD_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRGATD_i))))
            {
              if (((model_.PBRGATD_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat_d)+((vav+((model_.alphaav)*(model_.VBRGATD_i)))*(model_.slopegat_d)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I4 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
        {
          h1 = ((4.0*vch_d)*vch_d);
          h2 = (vch_d/vfmin_d);
          h2d = (V5+(vch_d*h2));
          h3 = (vfmin_d+h2d);
          h4 = (vfmin_d-h2d);
          {
            double value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V5*vfmin_d)/(h3+h5)));
          if ((V5<VMAX_d))
          {
            if ((fabs((0.5*(V5*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((0.5*(V5*(model_.phitdinv))));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V5*(model_.phitdinv)))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V5-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
            {
              double value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V5>0.0))
          {
            {
              double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              double value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*((model_.phitd)*value_log_1));
            }
          }
          else
          {
            {
              double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V5)+(2.0*((model_.phitd)*value_log_1)));
            }
          }
          vjlim = (vbimin_d-two_psistar);
          {
            double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
            vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V5-vbbtlim_d)*(V5-vbbtlim_d))+((4.0*(model_.phitr))*(model_.phitr))));
            vbbt = (0.5*((V5+vbbtlim_d)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((((V5)*(V5))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V5)-value_sqrt_0));
          }
        }
        if ((ABDRAIN_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if (((model_.one_minus_PBOT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
              tmp = value_pow_0;
            }
          }
          qjunbot = (((model_.qprefbot_d)*(1.0-tmp))+((model_.qpref2bot_d)*(V5-vj)));
          id = ((model_.idsatbot_d)*idmult);
          if ((((model_.CSRHBOTD_i)==0.0)&&((model_.CTATBOTD_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PBOTD_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOTD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrbot_d)*tmp);
            asrh = ((model_.ftdbot_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOTD_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOTD_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PBOTD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
            if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtbot_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOTD_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOTD_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRBOTD_i))))
            {
              if (((model_.PBRBOTD_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot_d)+((vav+((model_.alphaav)*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LSDRAIN_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if (((model_.one_minus_PSTI_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
              tmp = value_pow_0;
            }
          }
          qjunsti = (((model_.qprefsti_d)*(1.0-tmp))+((model_.qpref2sti_d)*(V5-vj)));
          id = ((model_.idsatsti_d)*idmult);
          if ((((model_.CSRHSTID_i)==0.0)&&((model_.CTATSTID_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PSTID_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTID_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrsti_d)*tmp);
            asrh = ((model_.ftdsti_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTID_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTID_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PSTID_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
            if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtsti_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTID_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTID_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRSTID_i))))
            {
              if (((model_.PBRSTID_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti_d)+((vav+((model_.alphaav)*(model_.VBRSTID_i)))*(model_.slopesti_d)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LGDRAIN_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if (((model_.one_minus_PGAT_d)==0.5))
          {
            {
              double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat_d))));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
              tmp = value_pow_0;
            }
          }
          qjungat = (((model_.qprefgat_d)*(1.0-tmp))+((model_.qpref2gat_d)*(V5-vj)));
          id = ((model_.idsatgat_d)*idmult);
          if ((((model_.CSRHGATD_i)==0.0)&&((model_.CTATGATD_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
            {
              double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if (((model_.PGATD_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                double value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGATD_i))));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            wdep = ((model_.wdepnulrgat_d)*tmp);
            asrh = ((model_.ftdgat_d)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
          }
          if (((model_.CTATGATD_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              double value_fabs_0 = fabs(umax);
              double value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGATD_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PGATD_i)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                tmp = value_pow_0;
              }
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
            if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-(model_.fbbtgat_d))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGATD_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGATD_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRGATD_i))))
            {
              if (((model_.PBRGATD_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
              }
              else
              {
                {
                  double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                  double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat_d)+((vav+((model_.alphaav)*(model_.VBRGATD_i)))*(model_.slopegat_d)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I5 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
        ISATFOR1_d = (((ABDRAIN_i*(model_.idsatbot_d))+(LSDRAIN_i*(model_.idsatsti_d)))+(LGDRAIN_i*(model_.idsatgat_d)));
        {
          double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR1_d));
          I4_cor = (I4-(ISATFOR1_d*(value_exp_0-1.0)));
        }
        {
          double value_exp_0 = exp(((V5*(model_.phitdinv))*MFOR1_d));
          I5_cor = (I5-(ISATFOR1_d*(value_exp_0-1.0)));
        }
        if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
        {
          if (((I4>0.0)&&(I5>0.0)))
          {
            if ((((((I4_cor/I4)>1.0e-3)||((I5_cor/I5)>1.0e-3))&&(I4_cor>0.0))&&(I5_cor>0.0)))
            {
              alphaje = (I4_cor/I5_cor);
              {
                double value_log_0 = log(alphaje);
                MFOR2_d = (((model_.phitd)*value_log_0)/(V4-V5));
              }
              {
                double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR2_d));
                ISATFOR2_d = (I4_cor/(value_exp_0-1.0));
              }
            }
          }
          {
            double value_exp_0 = exp(((V1*(model_.phitdinv))*MFOR1_d));
            double value_exp_1 = exp(((V1*(model_.phitdinv))*MFOR2_d));
            I1_cor = ((I1-(ISATFOR1_d*(value_exp_0-1.0)))-(ISATFOR2_d*(value_exp_1-1.0)));
          }
          {
            double value_exp_0 = exp(((V2*(model_.phitdinv))*MFOR1_d));
            double value_exp_1 = exp(((V2*(model_.phitdinv))*MFOR2_d));
            I2_cor = ((I2-(ISATFOR1_d*(value_exp_0-1.0)))-(ISATFOR2_d*(value_exp_1-1.0)));
          }
          {
            double value_exp_0 = exp(((V3*(model_.phitdinv))*MFOR1_d));
            double value_exp_1 = exp(((V3*(model_.phitdinv))*MFOR2_d));
            I3_cor = ((I3-(ISATFOR1_d*(value_exp_0-1.0)))-(ISATFOR2_d*(value_exp_1-1.0)));
          }
          if ((((I1<0.0)&&(I2<0.0))&&(I3<0.0)))
          {
            if ((((((((I1_cor/I1)>1.0e-3)||((I2_cor/I2)>1.0e-3))||((I3_cor/I3)>1.0e-3))&&(I1_cor<0.0))&&(I2_cor<0.0))&&(I3_cor<0.0)))
            {
              alphaje = (I1_cor/I2_cor);
              {
                double value_log_0 = log(alphaje);
                m0_rev = (((-(model_.phitd))*value_log_0)/(V1-V2));
              }
              tt0 = (V2/(V2-V1));
              {
                double value_pow_0 = pow(alphaje,tt0);
                tt1 = (((model_.phitd)*(alphaje-1.0))*(value_pow_0-1.0));
              }
              tt0 = (V1/(V1-V2));
              {
                double value_pow_0 = pow(alphaje,tt0);
                tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
              }
              mcor_rev = (tt1/tt2);
              MREV_d = (m0_rev+mcor_rev);
              if ((fabs(((V3*(model_.phitdinv))*MREV_d))<1.0e-6))
              {
                m0flag_d = 1.0;
                ISATREV_d = (I3_cor*((1.0/V3)+((0.5*(model_.phitdinv))*MREV_d)));
                MREV_d = (((((-0.5)*I3_cor)*MREV_d)*(model_.phitdinv))/V3);
              }
              else
              {
                m0flag_d = 0.0;
                {
                  double value_exp_0 = exp((((-V3)*(model_.phitdinv))*MREV_d));
                  ISATREV_d = ((-I3_cor)/(value_exp_0-1.0));
                }
              }
            }
          }
        }
        zfrac = ((model_.FJUNQD_i)*(((ABDRAIN_i*(model_.cjobot_d))+(LSDRAIN_i*(model_.cjosti_d)))+(LGDRAIN_i*(model_.cjogat_d))));
        if (((ABDRAIN_i*(model_.cjobot_d))<=zfrac))
        {
          zflagbot_d = 0.0;
        }
        if (((LSDRAIN_i*(model_.cjosti_d))<=zfrac))
        {
          zflagsti_d = 0.0;
        }
        if (((LGDRAIN_i*(model_.cjogat_d))<=zfrac))
        {
          zflaggat_d = 0.0;
        }
        if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
        {
          {
            double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR1_d+1.0e-21)));
            xhighf1_d = value_log_0;
          }
          {
            double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR2_d+1.0e-21)));
            xhighf2_d = value_log_0;
          }
          {
            double value_fabs_0 = fabs(ISATREV_d);
            double value_log_1 = log(((0.5*(model_.IMAX_i))/(value_fabs_0+1.0e-21)));
            xhighr_d = value_log_1;
          }
        }
        {
          double value_min_0 = std::min(xhighf1_d,static_cast<double>(2.3025850929940458e+02));
          xhighf1_d = value_min_0;
        }
        {
          double value_exp_0 = exp(xhighf1_d);
          expxhf1_d = value_exp_0;
        }
        {
          double value_min_0 = std::min(xhighf2_d,static_cast<double>(2.3025850929940458e+02));
          xhighf2_d = value_min_0;
        }
        {
          double value_exp_0 = exp(xhighf2_d);
          expxhf2_d = value_exp_0;
        }
        {
          double value_min_0 = std::min(xhighr_d,static_cast<double>(2.3025850929940458e+02));
          xhighr_d = value_min_0;
        }
        {
          double value_exp_0 = exp(xhighr_d);
          expxhr_d = value_exp_0;
        }
      }
      // End block JUNCAPexpressInit
    }
  }
  // End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    L(1.0e-5),
    W(1.0e-5),
    SA(0.0),
    SB(0.0),
    SD(0.0),
    SCA(0.0),
    SCB(0.0),
    SCC(0.0),
    SC(0.0),
    NF(1.0),
    NGCON(1.0),
    XGW(1.0e-7),
    NRS(0.0),
    NRD(0.0),
    JW(1.0e-6),
    DELVTO(0.0),
    FACTUO(1.0),
    DELVTOEDGE(0.0),
    FACTUOEDGE(1.0),
    ABSOURCE(1.0e-12),
    LSSOURCE(1.0e-6),
    LGSOURCE(1.0e-6),
    ABDRAIN(1.0e-12),
    LSDRAIN(1.0e-6),
    LGDRAIN(1.0e-6),
    AS(1.0e-12),
    PS(1.0e-6),
    AD(1.0e-12),
    PD(1.0e-6),
    MULT(1.0),
    MULT_i(0.0),
    GFACNUD_i(0.0),
    VNSUB_i(0.0),
    NSLP_i(0.0),
    DNSUB_i(0.0),
    CF_i(0.0),
    CFD_i(0.0),
    CFB_i(0.0),
    PSCE_i(0.0),
    PSCEB_i(0.0),
    PSCED_i(0.0),
    RSB_i(0.0),
    RSG_i(0.0),
    THESATB_i(0.0),
    THESATG_i(0.0),
    AX_i(0.0),
    ALP_i(0.0),
    ALP1_i(0.0),
    ALP2_i(0.0),
    A1_i(0.0),
    A3_i(0.0),
    A4_i(0.0),
    GCO_i(0.0),
    IGINV_i(0.0),
    IGOV_i(0.0),
    IGOVD_i(0.0),
    GC2_i(0.0),
    GC3_i(0.0),
    CHIB_i(0.0),
    AGIDL_i(0.0),
    AGIDLD_i(0.0),
    CGIDL_i(0.0),
    CGIDLD_i(0.0),
    COX_i(0.0),
    CGOV_i(0.0),
    CGOVD_i(0.0),
    CGBOV_i(0.0),
    CFR_i(0.0),
    CFRD_i(0.0),
    FNTEXC_i(0.0),
    NFA_i(0.0),
    NFB_i(0.0),
    NFC_i(0.0),
    EF_i(0.0),
    BETNEDGE_i(0.0),
    PSCEEDGE_i(0.0),
    PSCEBEDGE_i(0.0),
    PSCEDEDGE_i(0.0),
    CFEDGE_i(0.0),
    CFDEDGE_i(0.0),
    CFBEDGE_i(0.0),
    NFAEDGE_i(0.0),
    NFBEDGE_i(0.0),
    NFCEDGE_i(0.0),
    EFEDGE_i(0.0),
    RG_i(0.0),
    RSE_i(0.0),
    RDE_i(0.0),
    RBULK_i(0.0),
    RJUNS_i(0.0),
    RJUND_i(0.0),
    RWELL_i(0.0),
    ABSOURCE_i(0.0),
    LSSOURCE_i(0.0),
    LGSOURCE_i(0.0),
    zflagbot_s(0.0),
    zflagsti_s(0.0),
    zflaggat_s(0.0),
    VMAX_s(0.0),
    exp_VMAX_over_phitd_s(0.0),
    vbimin_s(0.0),
    vch_s(0.0),
    vfmin_s(0.0),
    vbbtlim_s(0.0),
    xhighf1_s(0.0),
    expxhf1_s(0.0),
    xhighf2_s(0.0),
    expxhf2_s(0.0),
    xhighr_s(0.0),
    expxhr_s(0.0),
    m0flag_s(0.0),
    ISATFOR1_s(0.0),
    MFOR1_s(0.0),
    ISATFOR2_s(0.0),
    MFOR2_s(0.0),
    ISATREV_s(0.0),
    MREV_s(0.0),
    ABDRAIN_i(0.0),
    LSDRAIN_i(0.0),
    LGDRAIN_i(0.0),
    zflagbot_d(0.0),
    zflagsti_d(0.0),
    zflaggat_d(0.0),
    VMAX_d(0.0),
    exp_VMAX_over_phitd_d(0.0),
    vbimin_d(0.0),
    vch_d(0.0),
    vfmin_d(0.0),
    vbbtlim_d(0.0),
    xhighf1_d(0.0),
    expxhf1_d(0.0),
    xhighf2_d(0.0),
    expxhf2_d(0.0),
    xhighr_d(0.0),
    expxhr_d(0.0),
    m0flag_d(0.0),
    ISATFOR1_d(0.0),
    MFOR1_d(0.0),
    ISATFOR2_d(0.0),
    MFOR2_d(0.0),
    ISATREV_d(0.0),
    MREV_d(0.0),
    VFB_T(0.0),
    MUE_T(0.0),
    THEMU_T(0.0),
    CS_T(0.0),
    XCOR_T(0.0),
    A2_T(0.0),
    VFBEDGE_T(0.0),
    phit0(0.0),
    BET_i(0.0),
    BETEDGE_i(0.0),
    nt(0.0),
    THESAT_T(0.0),
    Sfl_prefac(0.0),
    phit0edge(0.0),
    Gfedge2(0.0),
    lnGfedge2(0.0),
    Sfl_prefac_edge(0.0),
    ntedge(0.0),
    phib_dc(0.0),
    G_0_dc(0.0),
    kp(0.0),
    qlim2(0.0),
    sqrt_phib_dc(0.0),
    phix_dc(0.0),
    aphi_dc(0.0),
    bphi_dc(0.0),
    phix1_dc(0.0),
    alpha_b(0.0),
    us1(0.0),
    us21(0.0),
    phib_ac(0.0),
    G_0_ac(0.0),
    phix_ac(0.0),
    aphi_ac(0.0),
    bphi_ac(0.0),
    phix1_ac(0.0),
    THER_i(0.0),
    phibedge(0.0),
    Gfedge(0.0),
    phixedge(0.0),
    aphiedge(0.0),
    bphiedge(0.0),
    phix1edge(0.0),
    Cox_over_q(0.0),
    qq(0.0),
    E_eff0(0.0),
    eta_mu(0.0),
    eta_mu1(0.0),
    inv_AX(0.0),
    inv_VP(0.0),
    GOV_s(0.0),
    GOV_d(0.0),
    GOV2_s(0.0),
    GOV2_d(0.0),
    SP_OV_eps2_s(0.0),
    SP_OV_a_s(0.0),
    SP_OV_delta1_s(0.0),
    SP_OV_eps2_d(0.0),
    SP_OV_a_d(0.0),
    SP_OV_delta1_d(0.0),
    inv_CHIB(0.0),
    BCH(0.0),
    BOV(0.0),
    BOV_d(0.0),
    GCQ(0.0),
    AGIDLs(0.0),
    AGIDLDs(0.0),
    BGIDLs(0.0),
    BGIDLDs(0.0),
    fac_exc(0.0),
    ggate(0.0),
    gsource(0.0),
    gdrain(0.0),
    gbulk(0.0),
    gjuns(0.0),
    gjund(0.0),
    gwell(0.0),
    li_D(-1),
    li_G(-1),
    li_S(-1),
    li_B(-1),
    li_NOI(-1),
    li_NOI2(-1),
    li_GP(-1),
    li_SI(-1),
    li_DI(-1),
    li_BP(-1),
    li_BI(-1),
    li_BS(-1),
    li_BD(-1),
    li_branch_iD(-1),
    li_branch_iG(-1),
    li_branch_iS(-1),
    li_branch_iB(-1),
    f_DI_Equ_SI_Node_Ptr(0),
    f_DI_Equ_BP_Node_Ptr(0),
    f_BP_Equ_SI_Node_Ptr(0),
    f_BP_Equ_BP_Node_Ptr(0),
    f_DI_Equ_GP_Node_Ptr(0),
    f_BP_Equ_GP_Node_Ptr(0),
    f_DI_Equ_DI_Node_Ptr(0),
    f_BP_Equ_DI_Node_Ptr(0),
    f_SI_Equ_SI_Node_Ptr(0),
    f_SI_Equ_BP_Node_Ptr(0),
    f_SI_Equ_GP_Node_Ptr(0),
    f_SI_Equ_DI_Node_Ptr(0),
    f_GP_Equ_SI_Node_Ptr(0),
    f_GP_Equ_BP_Node_Ptr(0),
    f_GP_Equ_DI_Node_Ptr(0),
    f_GP_Equ_GP_Node_Ptr(0),
    f_BS_Equ_SI_Node_Ptr(0),
    f_BS_Equ_BS_Node_Ptr(0),
    f_SI_Equ_BS_Node_Ptr(0),
    f_BS_Equ_DI_Node_Ptr(0),
    f_BS_Equ_BD_Node_Ptr(0),
    f_SI_Equ_BD_Node_Ptr(0),
    f_BD_Equ_SI_Node_Ptr(0),
    f_BD_Equ_BS_Node_Ptr(0),
    f_DI_Equ_BS_Node_Ptr(0),
    f_BD_Equ_DI_Node_Ptr(0),
    f_BD_Equ_BD_Node_Ptr(0),
    f_DI_Equ_BD_Node_Ptr(0),
    f_G_Equ_G_Node_Ptr(0),
    f_G_Equ_GP_Node_Ptr(0),
    f_GP_Equ_G_Node_Ptr(0),
    f_S_Equ_S_Node_Ptr(0),
    f_S_Equ_SI_Node_Ptr(0),
    f_SI_Equ_S_Node_Ptr(0),
    f_D_Equ_D_Node_Ptr(0),
    f_D_Equ_DI_Node_Ptr(0),
    f_DI_Equ_D_Node_Ptr(0),
    f_BP_Equ_BI_Node_Ptr(0),
    f_BI_Equ_BP_Node_Ptr(0),
    f_BI_Equ_BI_Node_Ptr(0),
    f_BS_Equ_BI_Node_Ptr(0),
    f_BI_Equ_BS_Node_Ptr(0),
    f_BD_Equ_BI_Node_Ptr(0),
    f_BI_Equ_BD_Node_Ptr(0),
    f_B_Equ_B_Node_Ptr(0),
    f_B_Equ_BI_Node_Ptr(0),
    f_BI_Equ_B_Node_Ptr(0),
    f_NOI2_Equ_NOI2_Node_Ptr(0),
    f_NOI2_Equ_GP_Node_Ptr(0),
    f_NOI2_Equ_SI_Node_Ptr(0),
    f_NOI2_Equ_BP_Node_Ptr(0),
    f_NOI2_Equ_DI_Node_Ptr(0),
    f_NOI_Equ_SI_Node_Ptr(0),
    f_NOI_Equ_BP_Node_Ptr(0),
    f_NOI_Equ_GP_Node_Ptr(0),
    f_NOI_Equ_DI_Node_Ptr(0),
    f_NOI_Equ_NOI2_Node_Ptr(0),
    f_NOI_Equ_NOI_Node_Ptr(0),
    f_GP_Equ_NOI_Node_Ptr(0),
    f_SI_Equ_NOI_Node_Ptr(0),
    f_DI_Equ_NOI_Node_Ptr(0),
    f_DI_Equ_NOI2_Node_Ptr(0),
    f_SI_Equ_NOI2_Node_Ptr(0),
    f_BS_Equ_BP_Node_Ptr(0),
    f_BS_Equ_GP_Node_Ptr(0),
    f_BD_Equ_BP_Node_Ptr(0),
    f_BD_Equ_GP_Node_Ptr(0),
    q_DI_Equ_SI_Node_Ptr(0),
    q_DI_Equ_BP_Node_Ptr(0),
    q_BP_Equ_SI_Node_Ptr(0),
    q_BP_Equ_BP_Node_Ptr(0),
    q_DI_Equ_GP_Node_Ptr(0),
    q_BP_Equ_GP_Node_Ptr(0),
    q_DI_Equ_DI_Node_Ptr(0),
    q_BP_Equ_DI_Node_Ptr(0),
    q_SI_Equ_SI_Node_Ptr(0),
    q_SI_Equ_BP_Node_Ptr(0),
    q_SI_Equ_GP_Node_Ptr(0),
    q_SI_Equ_DI_Node_Ptr(0),
    q_GP_Equ_SI_Node_Ptr(0),
    q_GP_Equ_BP_Node_Ptr(0),
    q_GP_Equ_DI_Node_Ptr(0),
    q_GP_Equ_GP_Node_Ptr(0),
    q_BS_Equ_SI_Node_Ptr(0),
    q_BS_Equ_BS_Node_Ptr(0),
    q_SI_Equ_BS_Node_Ptr(0),
    q_BS_Equ_DI_Node_Ptr(0),
    q_BS_Equ_BD_Node_Ptr(0),
    q_SI_Equ_BD_Node_Ptr(0),
    q_BD_Equ_SI_Node_Ptr(0),
    q_BD_Equ_BS_Node_Ptr(0),
    q_DI_Equ_BS_Node_Ptr(0),
    q_BD_Equ_DI_Node_Ptr(0),
    q_BD_Equ_BD_Node_Ptr(0),
    q_DI_Equ_BD_Node_Ptr(0),
    q_G_Equ_G_Node_Ptr(0),
    q_G_Equ_GP_Node_Ptr(0),
    q_GP_Equ_G_Node_Ptr(0),
    q_S_Equ_S_Node_Ptr(0),
    q_S_Equ_SI_Node_Ptr(0),
    q_SI_Equ_S_Node_Ptr(0),
    q_D_Equ_D_Node_Ptr(0),
    q_D_Equ_DI_Node_Ptr(0),
    q_DI_Equ_D_Node_Ptr(0),
    q_BP_Equ_BI_Node_Ptr(0),
    q_BI_Equ_BP_Node_Ptr(0),
    q_BI_Equ_BI_Node_Ptr(0),
    q_BS_Equ_BI_Node_Ptr(0),
    q_BI_Equ_BS_Node_Ptr(0),
    q_BD_Equ_BI_Node_Ptr(0),
    q_BI_Equ_BD_Node_Ptr(0),
    q_B_Equ_B_Node_Ptr(0),
    q_B_Equ_BI_Node_Ptr(0),
    q_BI_Equ_B_Node_Ptr(0),
    q_NOI2_Equ_NOI2_Node_Ptr(0),
    q_NOI2_Equ_GP_Node_Ptr(0),
    q_NOI2_Equ_SI_Node_Ptr(0),
    q_NOI2_Equ_BP_Node_Ptr(0),
    q_NOI2_Equ_DI_Node_Ptr(0),
    q_NOI_Equ_SI_Node_Ptr(0),
    q_NOI_Equ_BP_Node_Ptr(0),
    q_NOI_Equ_GP_Node_Ptr(0),
    q_NOI_Equ_DI_Node_Ptr(0),
    q_NOI_Equ_NOI2_Node_Ptr(0),
    q_NOI_Equ_NOI_Node_Ptr(0),
    q_GP_Equ_NOI_Node_Ptr(0),
    q_SI_Equ_NOI_Node_Ptr(0),
    q_DI_Equ_NOI_Node_Ptr(0),
    q_DI_Equ_NOI2_Node_Ptr(0),
    q_SI_Equ_NOI2_Node_Ptr(0),
    q_BS_Equ_BP_Node_Ptr(0),
    q_BS_Equ_GP_Node_Ptr(0),
    q_BD_Equ_BP_Node_Ptr(0),
    q_BD_Equ_GP_Node_Ptr(0),
    A_DI_Equ_SI_NodeOffset(-1),
    A_DI_Equ_BP_NodeOffset(-1),
    A_BP_Equ_SI_NodeOffset(-1),
    A_BP_Equ_BP_NodeOffset(-1),
    A_DI_Equ_GP_NodeOffset(-1),
    A_BP_Equ_GP_NodeOffset(-1),
    A_DI_Equ_DI_NodeOffset(-1),
    A_BP_Equ_DI_NodeOffset(-1),
    A_SI_Equ_SI_NodeOffset(-1),
    A_SI_Equ_BP_NodeOffset(-1),
    A_SI_Equ_GP_NodeOffset(-1),
    A_SI_Equ_DI_NodeOffset(-1),
    A_GP_Equ_SI_NodeOffset(-1),
    A_GP_Equ_BP_NodeOffset(-1),
    A_GP_Equ_DI_NodeOffset(-1),
    A_GP_Equ_GP_NodeOffset(-1),
    A_BS_Equ_SI_NodeOffset(-1),
    A_BS_Equ_BS_NodeOffset(-1),
    A_SI_Equ_BS_NodeOffset(-1),
    A_BS_Equ_DI_NodeOffset(-1),
    A_BS_Equ_BD_NodeOffset(-1),
    A_SI_Equ_BD_NodeOffset(-1),
    A_BD_Equ_SI_NodeOffset(-1),
    A_BD_Equ_BS_NodeOffset(-1),
    A_DI_Equ_BS_NodeOffset(-1),
    A_BD_Equ_DI_NodeOffset(-1),
    A_BD_Equ_BD_NodeOffset(-1),
    A_DI_Equ_BD_NodeOffset(-1),
    A_G_Equ_G_NodeOffset(-1),
    A_G_Equ_GP_NodeOffset(-1),
    A_GP_Equ_G_NodeOffset(-1),
    A_S_Equ_S_NodeOffset(-1),
    A_S_Equ_SI_NodeOffset(-1),
    A_SI_Equ_S_NodeOffset(-1),
    A_D_Equ_D_NodeOffset(-1),
    A_D_Equ_DI_NodeOffset(-1),
    A_DI_Equ_D_NodeOffset(-1),
    A_BP_Equ_BI_NodeOffset(-1),
    A_BI_Equ_BP_NodeOffset(-1),
    A_BI_Equ_BI_NodeOffset(-1),
    A_BS_Equ_BI_NodeOffset(-1),
    A_BI_Equ_BS_NodeOffset(-1),
    A_BD_Equ_BI_NodeOffset(-1),
    A_BI_Equ_BD_NodeOffset(-1),
    A_B_Equ_B_NodeOffset(-1),
    A_B_Equ_BI_NodeOffset(-1),
    A_BI_Equ_B_NodeOffset(-1),
    A_NOI2_Equ_NOI2_NodeOffset(-1),
    A_NOI2_Equ_GP_NodeOffset(-1),
    A_NOI2_Equ_SI_NodeOffset(-1),
    A_NOI2_Equ_BP_NodeOffset(-1),
    A_NOI2_Equ_DI_NodeOffset(-1),
    A_NOI_Equ_SI_NodeOffset(-1),
    A_NOI_Equ_BP_NodeOffset(-1),
    A_NOI_Equ_GP_NodeOffset(-1),
    A_NOI_Equ_DI_NodeOffset(-1),
    A_NOI_Equ_NOI2_NodeOffset(-1),
    A_NOI_Equ_NOI_NodeOffset(-1),
    A_GP_Equ_NOI_NodeOffset(-1),
    A_SI_Equ_NOI_NodeOffset(-1),
    A_DI_Equ_NOI_NodeOffset(-1),
    A_DI_Equ_NOI2_NodeOffset(-1),
    A_SI_Equ_NOI2_NodeOffset(-1),
    A_BS_Equ_BP_NodeOffset(-1),
    A_BS_Equ_GP_NodeOffset(-1),
    A_BD_Equ_BP_NodeOffset(-1),
    A_BD_Equ_GP_NodeOffset(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
  numIntVars = 9 + 0;
  numExtVars = 4;


  // Right now, we only have store for limited probes...
  setNumStoreVars(0);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 4;

  leadCurrentF.resize(4);
  leadCurrentQ.resize(4);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_D));
  jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_DI));
  jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_G));
  jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_S));
  jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_SI));
  jacobianElements.push_back(IntPair(admsNodeID_B,admsNodeID_B));
  jacobianElements.push_back(IntPair(admsNodeID_B,admsNodeID_BI));
  jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_SI));
  jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_DI));
  jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_NOI2));
  jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_NOI));
  jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_NOI2));
  jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_SI));
  jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_DI));
  jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_SI));
  jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_DI));
  jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_G));
  jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_NOI));
  jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_SI));
  jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_DI));
  jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_BS));
  jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_BD));
  jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_S));
  jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_NOI));
  jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_NOI2));
  jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_SI));
  jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_DI));
  jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_BS));
  jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_BD));
  jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_D));
  jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_NOI));
  jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_NOI2));
  jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_SI));
  jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_DI));
  jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_BI));
  jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BI));
  jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BS));
  jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BD));
  jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_B));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_SI));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BS));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_DI));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BD));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BI));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_GP));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_SI));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BS));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_DI));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BD));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BI));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BP));
  jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_GP));



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_GP)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_GP,admsNodeID_G));
  }
  if (collapseNode_SI)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_SI,admsNodeID_S));
  }
  if (collapseNode_DI)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_DI,admsNodeID_D));
  }
  if (collapseNode_BP)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_BP,admsNodeID_BI));
  }
  if (collapseNode_BI)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_BI,admsNodeID_B));
  }
  if (collapseNode_BS)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_BS,admsNodeID_BI));
  }
  if (collapseNode_BD)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_BD,admsNodeID_BI));
  }

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 13+0;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
  collapseNode_GP = false;
  collapseNode_SI = false;
  collapseNode_DI = false;
  collapseNode_BP = false;
  collapseNode_BI = false;
  collapseNode_BS = false;
  collapseNode_BD = false;
  // begin block named evaluateblock

  // begin block named loadStatic

  if (!((RG_i>0.0)))
  {

    collapseNode_GP = true;

  }

  if (!((RSE_i>0.0)))
  {

    collapseNode_SI = true;

  }

  if (!((RDE_i>0.0)))
  {

    collapseNode_DI = true;

  }

  if (!((RBULK_i>0.0)))
  {

    collapseNode_BP = true;

  }

  if (!((RJUNS_i>0.0)))
  {

    collapseNode_BS = true;

  }

  if (!((RJUND_i>0.0)))
  {

    collapseNode_BD = true;

  }

  if (!((RWELL_i>0.0)))
  {

    collapseNode_BI = true;

  }

  // end block  named loadStatic

  // end block  named evaluateblock


  if (collapseNode_GP)
  {
    numIntVars--;
  }
  if (collapseNode_SI)
  {
    numIntVars--;
  }
  if (collapseNode_DI)
  {
    numIntVars--;
  }
  if (collapseNode_BP)
  {
    numIntVars--;
  }
  if (collapseNode_BI)
  {
    numIntVars--;
  }
  if (collapseNode_BS)
  {
    numIntVars--;
  }
  if (collapseNode_BD)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSPSP103VA::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_D = localLIDVec[nodeMap[admsNodeID_D]];
  li_G = localLIDVec[nodeMap[admsNodeID_G]];
  li_S = localLIDVec[nodeMap[admsNodeID_S]];
  li_B = localLIDVec[nodeMap[admsNodeID_B]];
  li_NOI = localLIDVec[nodeMap[admsNodeID_NOI]];
  li_NOI2 = localLIDVec[nodeMap[admsNodeID_NOI2]];
  li_GP = localLIDVec[nodeMap[admsNodeID_GP]];
  li_SI = localLIDVec[nodeMap[admsNodeID_SI]];
  li_DI = localLIDVec[nodeMap[admsNodeID_DI]];
  li_BP = localLIDVec[nodeMap[admsNodeID_BP]];
  li_BI = localLIDVec[nodeMap[admsNodeID_BI]];
  li_BS = localLIDVec[nodeMap[admsNodeID_BS]];
  li_BD = localLIDVec[nodeMap[admsNodeID_BD]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_D = " << li_D << std::endl;
    Xyce::dout() << "\nli_G = " << li_G << std::endl;
    Xyce::dout() << "\nli_S = " << li_S << std::endl;
    Xyce::dout() << "\nli_B = " << li_B << std::endl;
    Xyce::dout() << "\nli_NOI = " << li_NOI << std::endl;
    Xyce::dout() << "\nli_NOI2 = " << li_NOI2 << std::endl;
    Xyce::dout() << "\nli_GP = " << li_GP << std::endl;
    Xyce::dout() << "\nli_SI = " << li_SI << std::endl;
    Xyce::dout() << "\nli_DI = " << li_DI << std::endl;
    Xyce::dout() << "\nli_BP = " << li_BP << std::endl;
    Xyce::dout() << "\nli_BI = " << li_BI << std::endl;
    Xyce::dout() << "\nli_BS = " << li_BS << std::endl;
    Xyce::dout() << "\nli_BD = " << li_BD << std::endl;

    Xyce::dout() << "\nEnd of ADMSPSP103VA::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
  addInternalNode(symbol_table, li_NOI, getName(), "NOI");
  addInternalNode(symbol_table, li_NOI2, getName(), "NOI2");
  if (!collapseNode_GP)
  {
    addInternalNode(symbol_table, li_GP, getName(), "GP");
  }
  if (!collapseNode_SI)
  {
    addInternalNode(symbol_table, li_SI, getName(), "SI");
  }
  if (!collapseNode_DI)
  {
    addInternalNode(symbol_table, li_DI, getName(), "DI");
  }
  if (!collapseNode_BP)
  {
    addInternalNode(symbol_table, li_BP, getName(), "BP");
  }
  if (!collapseNode_BI)
  {
    addInternalNode(symbol_table, li_BI, getName(), "BI");
  }
  if (!collapseNode_BS)
  {
    addInternalNode(symbol_table, li_BS, getName(), "BS");
  }
  if (!collapseNode_BD)
  {
    addInternalNode(symbol_table, li_BD, getName(), "BD");
  }

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_iD, getName(), "BRANCH_DD");
    addBranchDataNode( symbol_table, li_branch_iG, getName(), "BRANCH_DG");
    addBranchDataNode( symbol_table, li_branch_iS, getName(), "BRANCH_DS");
    addBranchDataNode( symbol_table, li_branch_iB, getName(), "BRANCH_D4");
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    int i = 0;
    li_branch_iD = branchLIDVecRef[i++];
    li_branch_iG = branchLIDVecRef[i++];
    li_branch_iS = branchLIDVecRef[i++];
    li_branch_iB = branchLIDVecRef[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_D)];
  A_D_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_DI)];
  A_D_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_G)];
  A_G_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_GP)];
  A_G_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_S)];
  A_S_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_SI)];
  A_S_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_B,admsNodeID_B)];
  A_B_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_B,admsNodeID_BI)];
  A_B_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_SI)];
  A_NOI_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_BP)];
  A_NOI_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_GP)];
  A_NOI_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_DI)];
  A_NOI_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_NOI2)];
  A_NOI_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_NOI)];
  A_NOI_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_NOI2)];
  A_NOI2_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_GP)];
  A_NOI2_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_SI)];
  A_NOI2_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_BP)];
  A_NOI2_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_DI)];
  A_NOI2_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_SI)];
  A_GP_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_BP)];
  A_GP_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_DI)];
  A_GP_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_GP)];
  A_GP_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_G)];
  A_GP_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_NOI)];
  A_GP_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_SI)];
  A_SI_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_BP)];
  A_SI_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_GP)];
  A_SI_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_DI)];
  A_SI_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_BS)];
  A_SI_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_BD)];
  A_SI_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_S)];
  A_SI_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_NOI)];
  A_SI_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_NOI2)];
  A_SI_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_SI)];
  A_DI_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_BP)];
  A_DI_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_GP)];
  A_DI_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_DI)];
  A_DI_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_BS)];
  A_DI_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_BD)];
  A_DI_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_D)];
  A_DI_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_NOI)];
  A_DI_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_NOI2)];
  A_DI_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_SI)];
  A_BP_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_BP)];
  A_BP_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_GP)];
  A_BP_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_DI)];
  A_BP_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_BI)];
  A_BP_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BP)];
  A_BI_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BI)];
  A_BI_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BS)];
  A_BI_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BD)];
  A_BI_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_B)];
  A_BI_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_SI)];
  A_BS_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BS)];
  A_BS_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_DI)];
  A_BS_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BD)];
  A_BS_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BI)];
  A_BS_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BP)];
  A_BS_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_GP)];
  A_BS_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_SI)];
  A_BD_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BS)];
  A_BD_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_DI)];
  A_BD_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BD)];
  A_BD_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BI)];
  A_BD_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BP)];
  A_BD_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_GP)];
  A_BD_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
  f_D_Equ_D_Node_Ptr = &(dFdx[li_D][A_D_Equ_D_NodeOffset]);
  q_D_Equ_D_Node_Ptr = &(dQdx[li_D][A_D_Equ_D_NodeOffset]);
  f_D_Equ_DI_Node_Ptr = &(dFdx[li_D][A_D_Equ_DI_NodeOffset]);
  q_D_Equ_DI_Node_Ptr = &(dQdx[li_D][A_D_Equ_DI_NodeOffset]);
  f_G_Equ_G_Node_Ptr = &(dFdx[li_G][A_G_Equ_G_NodeOffset]);
  q_G_Equ_G_Node_Ptr = &(dQdx[li_G][A_G_Equ_G_NodeOffset]);
  f_G_Equ_GP_Node_Ptr = &(dFdx[li_G][A_G_Equ_GP_NodeOffset]);
  q_G_Equ_GP_Node_Ptr = &(dQdx[li_G][A_G_Equ_GP_NodeOffset]);
  f_S_Equ_S_Node_Ptr = &(dFdx[li_S][A_S_Equ_S_NodeOffset]);
  q_S_Equ_S_Node_Ptr = &(dQdx[li_S][A_S_Equ_S_NodeOffset]);
  f_S_Equ_SI_Node_Ptr = &(dFdx[li_S][A_S_Equ_SI_NodeOffset]);
  q_S_Equ_SI_Node_Ptr = &(dQdx[li_S][A_S_Equ_SI_NodeOffset]);
  f_B_Equ_B_Node_Ptr = &(dFdx[li_B][A_B_Equ_B_NodeOffset]);
  q_B_Equ_B_Node_Ptr = &(dQdx[li_B][A_B_Equ_B_NodeOffset]);
  f_B_Equ_BI_Node_Ptr = &(dFdx[li_B][A_B_Equ_BI_NodeOffset]);
  q_B_Equ_BI_Node_Ptr = &(dQdx[li_B][A_B_Equ_BI_NodeOffset]);
  f_NOI_Equ_SI_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_SI_NodeOffset]);
  q_NOI_Equ_SI_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_SI_NodeOffset]);
  f_NOI_Equ_BP_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_BP_NodeOffset]);
  q_NOI_Equ_BP_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_BP_NodeOffset]);
  f_NOI_Equ_GP_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_GP_NodeOffset]);
  q_NOI_Equ_GP_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_GP_NodeOffset]);
  f_NOI_Equ_DI_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_DI_NodeOffset]);
  q_NOI_Equ_DI_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_DI_NodeOffset]);
  f_NOI_Equ_NOI2_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_NOI2_NodeOffset]);
  q_NOI_Equ_NOI2_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_NOI2_NodeOffset]);
  f_NOI_Equ_NOI_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_NOI_NodeOffset]);
  q_NOI_Equ_NOI_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_NOI_NodeOffset]);
  f_NOI2_Equ_NOI2_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_NOI2_NodeOffset]);
  q_NOI2_Equ_NOI2_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_NOI2_NodeOffset]);
  f_NOI2_Equ_GP_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_GP_NodeOffset]);
  q_NOI2_Equ_GP_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_GP_NodeOffset]);
  f_NOI2_Equ_SI_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_SI_NodeOffset]);
  q_NOI2_Equ_SI_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_SI_NodeOffset]);
  f_NOI2_Equ_BP_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_BP_NodeOffset]);
  q_NOI2_Equ_BP_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_BP_NodeOffset]);
  f_NOI2_Equ_DI_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_DI_NodeOffset]);
  q_NOI2_Equ_DI_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_DI_NodeOffset]);
  f_GP_Equ_SI_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_SI_NodeOffset]);
  q_GP_Equ_SI_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_SI_NodeOffset]);
  f_GP_Equ_BP_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_BP_NodeOffset]);
  q_GP_Equ_BP_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_BP_NodeOffset]);
  f_GP_Equ_DI_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_DI_NodeOffset]);
  q_GP_Equ_DI_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_DI_NodeOffset]);
  f_GP_Equ_GP_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_GP_NodeOffset]);
  q_GP_Equ_GP_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_GP_NodeOffset]);
  f_GP_Equ_G_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_G_NodeOffset]);
  q_GP_Equ_G_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_G_NodeOffset]);
  f_GP_Equ_NOI_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_NOI_NodeOffset]);
  q_GP_Equ_NOI_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_NOI_NodeOffset]);
  f_SI_Equ_SI_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_SI_NodeOffset]);
  q_SI_Equ_SI_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_SI_NodeOffset]);
  f_SI_Equ_BP_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_BP_NodeOffset]);
  q_SI_Equ_BP_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_BP_NodeOffset]);
  f_SI_Equ_GP_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_GP_NodeOffset]);
  q_SI_Equ_GP_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_GP_NodeOffset]);
  f_SI_Equ_DI_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_DI_NodeOffset]);
  q_SI_Equ_DI_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_DI_NodeOffset]);
  f_SI_Equ_BS_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_BS_NodeOffset]);
  q_SI_Equ_BS_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_BS_NodeOffset]);
  f_SI_Equ_BD_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_BD_NodeOffset]);
  q_SI_Equ_BD_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_BD_NodeOffset]);
  f_SI_Equ_S_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_S_NodeOffset]);
  q_SI_Equ_S_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_S_NodeOffset]);
  f_SI_Equ_NOI_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_NOI_NodeOffset]);
  q_SI_Equ_NOI_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_NOI_NodeOffset]);
  f_SI_Equ_NOI2_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_NOI2_NodeOffset]);
  q_SI_Equ_NOI2_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_NOI2_NodeOffset]);
  f_DI_Equ_SI_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_SI_NodeOffset]);
  q_DI_Equ_SI_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_SI_NodeOffset]);
  f_DI_Equ_BP_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_BP_NodeOffset]);
  q_DI_Equ_BP_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_BP_NodeOffset]);
  f_DI_Equ_GP_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_GP_NodeOffset]);
  q_DI_Equ_GP_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_GP_NodeOffset]);
  f_DI_Equ_DI_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_DI_NodeOffset]);
  q_DI_Equ_DI_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_DI_NodeOffset]);
  f_DI_Equ_BS_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_BS_NodeOffset]);
  q_DI_Equ_BS_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_BS_NodeOffset]);
  f_DI_Equ_BD_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_BD_NodeOffset]);
  q_DI_Equ_BD_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_BD_NodeOffset]);
  f_DI_Equ_D_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_D_NodeOffset]);
  q_DI_Equ_D_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_D_NodeOffset]);
  f_DI_Equ_NOI_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_NOI_NodeOffset]);
  q_DI_Equ_NOI_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_NOI_NodeOffset]);
  f_DI_Equ_NOI2_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_NOI2_NodeOffset]);
  q_DI_Equ_NOI2_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_NOI2_NodeOffset]);
  f_BP_Equ_SI_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_SI_NodeOffset]);
  q_BP_Equ_SI_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_SI_NodeOffset]);
  f_BP_Equ_BP_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_BP_NodeOffset]);
  q_BP_Equ_BP_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_BP_NodeOffset]);
  f_BP_Equ_GP_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_GP_NodeOffset]);
  q_BP_Equ_GP_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_GP_NodeOffset]);
  f_BP_Equ_DI_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_DI_NodeOffset]);
  q_BP_Equ_DI_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_DI_NodeOffset]);
  f_BP_Equ_BI_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_BI_NodeOffset]);
  q_BP_Equ_BI_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_BI_NodeOffset]);
  f_BI_Equ_BP_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BP_NodeOffset]);
  q_BI_Equ_BP_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BP_NodeOffset]);
  f_BI_Equ_BI_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BI_NodeOffset]);
  q_BI_Equ_BI_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BI_NodeOffset]);
  f_BI_Equ_BS_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BS_NodeOffset]);
  q_BI_Equ_BS_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BS_NodeOffset]);
  f_BI_Equ_BD_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BD_NodeOffset]);
  q_BI_Equ_BD_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BD_NodeOffset]);
  f_BI_Equ_B_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_B_NodeOffset]);
  q_BI_Equ_B_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_B_NodeOffset]);
  f_BS_Equ_SI_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_SI_NodeOffset]);
  q_BS_Equ_SI_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_SI_NodeOffset]);
  f_BS_Equ_BS_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BS_NodeOffset]);
  q_BS_Equ_BS_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BS_NodeOffset]);
  f_BS_Equ_DI_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_DI_NodeOffset]);
  q_BS_Equ_DI_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_DI_NodeOffset]);
  f_BS_Equ_BD_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BD_NodeOffset]);
  q_BS_Equ_BD_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BD_NodeOffset]);
  f_BS_Equ_BI_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BI_NodeOffset]);
  q_BS_Equ_BI_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BI_NodeOffset]);
  f_BS_Equ_BP_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BP_NodeOffset]);
  q_BS_Equ_BP_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BP_NodeOffset]);
  f_BS_Equ_GP_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_GP_NodeOffset]);
  q_BS_Equ_GP_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_GP_NodeOffset]);
  f_BD_Equ_SI_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_SI_NodeOffset]);
  q_BD_Equ_SI_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_SI_NodeOffset]);
  f_BD_Equ_BS_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BS_NodeOffset]);
  q_BD_Equ_BS_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BS_NodeOffset]);
  f_BD_Equ_DI_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_DI_NodeOffset]);
  q_BD_Equ_DI_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_DI_NodeOffset]);
  f_BD_Equ_BD_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BD_NodeOffset]);
  q_BD_Equ_BD_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BD_NodeOffset]);
  f_BD_Equ_BI_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BI_NodeOffset]);
  q_BD_Equ_BI_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BI_NodeOffset]);
  f_BD_Equ_BP_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BP_NodeOffset]);
  q_BD_Equ_BP_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BP_NodeOffset]);
  f_BD_Equ_GP_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_GP_NodeOffset]);
  q_BD_Equ_GP_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_GP_NodeOffset]);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_D] += staticContributions[admsNodeID_D];
  (*extData.daeFVectorPtr)[li_G] += staticContributions[admsNodeID_G];
  (*extData.daeFVectorPtr)[li_S] += staticContributions[admsNodeID_S];
  (*extData.daeFVectorPtr)[li_B] += staticContributions[admsNodeID_B];
  (*extData.daeFVectorPtr)[li_NOI] += staticContributions[admsNodeID_NOI];
  (*extData.daeFVectorPtr)[li_NOI2] += staticContributions[admsNodeID_NOI2];
  (*extData.daeFVectorPtr)[li_GP] += staticContributions[admsNodeID_GP];
  (*extData.daeFVectorPtr)[li_SI] += staticContributions[admsNodeID_SI];
  (*extData.daeFVectorPtr)[li_DI] += staticContributions[admsNodeID_DI];
  (*extData.daeFVectorPtr)[li_BP] += staticContributions[admsNodeID_BP];
  (*extData.daeFVectorPtr)[li_BI] += staticContributions[admsNodeID_BI];
  (*extData.daeFVectorPtr)[li_BS] += staticContributions[admsNodeID_BS];
  (*extData.daeFVectorPtr)[li_BD] += staticContributions[admsNodeID_BD];


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;

    leadF[li_branch_iD] = leadCurrentF[admsNodeID_D];
    leadF[li_branch_iG] = leadCurrentF[admsNodeID_G];
    leadF[li_branch_iS] = leadCurrentF[admsNodeID_S];
    leadF[li_branch_iB] = leadCurrentF[admsNodeID_B];

    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

    double * solVec = extData.nextSolVectorRawPtr;
    double * junctionV = extData.nextJunctionVCompRawPtr;
    junctionV[li_branch_iD] = solVec[li_D] - solVec[li_S];
    junctionV[li_branch_iG] = solVec[li_G] - solVec[li_S];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_D] += dynamicContributions[admsNodeID_D];
  (*extData.daeQVectorPtr)[li_G] += dynamicContributions[admsNodeID_G];
  (*extData.daeQVectorPtr)[li_S] += dynamicContributions[admsNodeID_S];
  (*extData.daeQVectorPtr)[li_B] += dynamicContributions[admsNodeID_B];
  (*extData.daeQVectorPtr)[li_NOI] += dynamicContributions[admsNodeID_NOI];
  (*extData.daeQVectorPtr)[li_NOI2] += dynamicContributions[admsNodeID_NOI2];
  (*extData.daeQVectorPtr)[li_GP] += dynamicContributions[admsNodeID_GP];
  (*extData.daeQVectorPtr)[li_SI] += dynamicContributions[admsNodeID_SI];
  (*extData.daeQVectorPtr)[li_DI] += dynamicContributions[admsNodeID_DI];
  (*extData.daeQVectorPtr)[li_BP] += dynamicContributions[admsNodeID_BP];
  (*extData.daeQVectorPtr)[li_BI] += dynamicContributions[admsNodeID_BI];
  (*extData.daeQVectorPtr)[li_BS] += dynamicContributions[admsNodeID_BS];
  (*extData.daeQVectorPtr)[li_BD] += dynamicContributions[admsNodeID_BD];


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;

    leadQ[li_branch_iD] = leadCurrentQ[admsNodeID_D];
    leadQ[li_branch_iG] = leadCurrentQ[admsNodeID_G];
    leadQ[li_branch_iS] = leadCurrentQ[admsNodeID_S];
    leadQ[li_branch_iB] = leadCurrentQ[admsNodeID_B];
  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.


  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one PSP103VA instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSPSP103VA::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double vth_i;
  double d_vth_i_dV_DI_SI;
  double d_vth_i_dV_GP_SI;
  double d_vth_i_dV_SI_BP;
  double vts_i;
  double d_vts_i_dV_DI_SI;
  double d_vts_i_dV_GP_SI;
  double d_vts_i_dV_SI_BP;
  double facvsb;
  double d_facvsb_dV_DI_SI;
  double d_facvsb_dV_SI_BP;
  double facvsb0;
  double d_facvsb0_dV_DI_SI;
  double d_facvsb0_dV_SI_BP;
  double P_D;
  double d_P_D_dV_DI_SI;
  double d_P_D_dV_GP_SI;
  double d_P_D_dV_SI_BP;
  double delVsat;
  double d_delVsat_dV_DI_SI;
  double d_delVsat_dV_GP_SI;
  double d_delVsat_dV_SI_BP;
  double Q_EDGE_errq;
  double d_Q_EDGE_errq_dV_DI_SI;
  double d_Q_EDGE_errq_dV_SI_BP;
  double d_Q_EDGE_errq_dV_GP_SI;
  double Q_EDGE_sqerr;
  double d_Q_EDGE_sqerr_dV_DI_SI;
  double d_Q_EDGE_sqerr_dV_SI_BP;
  double d_Q_EDGE_sqerr_dV_GP_SI;
  double Q_EDGE_d0p;
  double d_Q_EDGE_d0p_dV_DI_SI;
  double d_Q_EDGE_d0p_dV_SI_BP;
  double d_Q_EDGE_d0p_dV_GP_SI;
  double Q_EDGE_d0;
  double d_Q_EDGE_d0_dV_DI_SI;
  double d_Q_EDGE_d0_dV_SI_BP;
  double d_Q_EDGE_d0_dV_GP_SI;
  double Q_EDGE_exp_x;
  double d_Q_EDGE_exp_x_dV_DI_SI;
  double d_Q_EDGE_exp_x_dV_SI_BP;
  double d_Q_EDGE_exp_x_dV_GP_SI;
  double Q_EDGE_qi0;
  double d_Q_EDGE_qi0_dV_DI_SI;
  double d_Q_EDGE_qi0_dV_SI_BP;
  double d_Q_EDGE_qi0_dV_GP_SI;
  double Q_EDGE_qi0si;
  double d_Q_EDGE_qi0si_dV_DI_SI;
  double d_Q_EDGE_qi0si_dV_SI_BP;
  double d_Q_EDGE_qi0si_dV_GP_SI;
  double Q_EDGE_xgt0e;
  double d_Q_EDGE_xgt0e_dV_DI_SI;
  double d_Q_EDGE_xgt0e_dV_SI_BP;
  double d_Q_EDGE_xgt0e_dV_GP_SI;
  double Q_EDGE_xgt0;
  double d_Q_EDGE_xgt0_dV_DI_SI;
  double d_Q_EDGE_xgt0_dV_SI_BP;
  double d_Q_EDGE_xgt0_dV_GP_SI;
  double Q_EDGE_xgt;
  double d_Q_EDGE_xgt_dV_DI_SI;
  double d_Q_EDGE_xgt_dV_SI_BP;
  double d_Q_EDGE_xgt_dV_GP_SI;
  double Q_EDGE_n_inv;
  double d_Q_EDGE_n_inv_dV_DI_SI;
  double d_Q_EDGE_n_inv_dV_SI_BP;
  double d_Q_EDGE_n_inv_dV_GP_SI;
  double Q_EDGE_n;
  double d_Q_EDGE_n_dV_DI_SI;
  double d_Q_EDGE_n_dV_SI_BP;
  double d_Q_EDGE_n_dV_GP_SI;
  double Q_EDGE_xth;
  double d_Q_EDGE_xth_dV_DI_SI;
  double d_Q_EDGE_xth_dV_SI_BP;
  double d_Q_EDGE_xth_dV_GP_SI;
  double Q_EDGE_xth0;
  double d_Q_EDGE_xth0_dV_DI_SI;
  double d_Q_EDGE_xth0_dV_SI_BP;
  double d_Q_EDGE_xth0_dV_GP_SI;
  double Q_EDGE_xsth;
  double d_Q_EDGE_xsth_dV_DI_SI;
  double d_Q_EDGE_xsth_dV_SI_BP;
  double d_Q_EDGE_xsth_dV_GP_SI;
  double Vtovs;
  double d_Vtovs_dV_GP_SI;
  double d_Vtovs_dV_SI_BP;
  double Vtovd;
  double d_Vtovd_dV_GP_SI;
  double d_Vtovd_dV_DI_SI;
  double d_Vtovd_dV_SI_BP;
  double Igisl;
  double d_Igisl_dV_SI_BP;
  double d_Igisl_dV_GP_SI;
  double d_Igisl_dV_DI_SI;
  double Igidl;
  double d_Igidl_dV_DI_SI;
  double d_Igidl_dV_SI_BP;
  double d_Igidl_dV_GP_SI;
  double Sg;
  double d_Sg_dV_DI_SI;
  double d_Sg_dV_GP_SI;
  double d_Sg_dV_SI_BP;
  double igcd_h;
  double d_igcd_h_dV_DI_SI;
  double d_igcd_h_dV_GP_SI;
  double d_igcd_h_dV_SI_BP;
  double igc;
  double d_igc_dV_DI_SI;
  double d_igc_dV_GP_SI;
  double d_igc_dV_SI_BP;
  double xsq;
  double d_xsq_dV_DI_SI;
  double d_xsq_dV_GP_SI;
  double d_xsq_dV_SI_BP;
  double inv_ex;
  double d_inv_ex_dV_DI_SI;
  double d_inv_ex_dV_GP_SI;
  double d_inv_ex_dV_SI_BP;
  double ex;
  double d_ex_dV_DI_SI;
  double d_ex_dV_GP_SI;
  double d_ex_dV_SI_BP;
  double inv_x;
  double d_inv_x_dV_DI_SI;
  double d_inv_x_dV_GP_SI;
  double d_inv_x_dV_SI_BP;
  double Ag;
  double d_Ag_dV_GP_SI;
  double d_Ag_dV_DI_SI;
  double d_Ag_dV_SI_BP;
  double Bg;
  double d_Bg_dV_GP_SI;
  double d_Bg_dV_DI_SI;
  double d_Bg_dV_SI_BP;
  double u0_div_H;
  double d_u0_div_H_dV_GP_SI;
  double d_u0_div_H_dV_DI_SI;
  double d_u0_div_H_dV_SI_BP;
  double x;
  double d_x_dV_DI_SI;
  double d_x_dV_GP_SI;
  double d_x_dV_SI_BP;
  double u0;
  double d_u0_dV_GP_SI;
  double d_u0_dV_DI_SI;
  double d_u0_dV_SI_BP;
  double Igc0;
  double d_Igc0_dV_GP_SI;
  double d_Igc0_dV_DI_SI;
  double d_Igc0_dV_SI_BP;
  double Dgate;
  double d_Dgate_dV_DI_SI;
  double d_Dgate_dV_GP_SI;
  double d_Dgate_dV_SI_BP;
  double Dsi;
  double d_Dsi_dV_DI_SI;
  double d_Dsi_dV_GP_SI;
  double d_Dsi_dV_SI_BP;
  double arg1;
  double d_arg1_dV_DI_SI;
  double d_arg1_dV_GP_SI;
  double d_arg1_dV_SI_BP;
  double psi_t;
  double d_psi_t_dV_DI_SI;
  double d_psi_t_dV_GP_SI;
  double d_psi_t_dV_SI_BP;
  double arg2mina;
  double d_arg2mina_dV_DI_SI;
  double d_arg2mina_dV_GP_SI;
  double d_arg2mina_dV_SI_BP;
  double Dch;
  double d_Dch_dV_DI_SI;
  double d_Dch_dV_SI_BP;
  double Vm;
  double d_Vm_dV_DI_SI;
  double d_Vm_dV_SI_BP;
  double d_Vm_dV_GP_SI;
  double Fs;
  double d_Fs_dV_DI_SI;
  double d_Fs_dV_SI_BP;
  double d_Fs_dV_GP_SI;
  double tme2;
  double d_tme2_dV_DI_SI;
  double d_tme2_dV_SI_BP;
  double d_tme2_dV_GP_SI;
  double tme1;
  double Fs3;
  double d_Fs3_dV_DI_SI;
  double d_Fs3_dV_GP_SI;
  double Fs2;
  double Fs1;
  double d_Fs1_dV_DI_SI;
  double d_Fs1_dV_GP_SI;
  double TP;
  double d_TP_dV_GP_SI;
  double d_TP_dV_DI_SI;
  double d_TP_dV_SI_BP;
  double zg;
  double d_zg_dV_SI_BP;
  double d_zg_dV_DI_SI;
  double d_zg_dV_GP_SI;
  double Igb;
  double d_Igb_dV_GP_SI;
  double d_Igb_dV_DI_SI;
  double d_Igb_dV_SI_BP;
  double Igc;
  double d_Igc_dV_GP_SI;
  double d_Igc_dV_DI_SI;
  double d_Igc_dV_SI_BP;
  double SP_OV_xg;
  double d_SP_OV_xg_dV_DI_SI;
  double d_SP_OV_xg_dV_GP_SI;
  double Vsbstar_dc;
  double d_Vsbstar_dc_dV_DI_SI;
  double d_Vsbstar_dc_dV_SI_BP;
  double Vsbstar_dc_tmp;
  double d_Vsbstar_dc_tmp_dV_DI_SI;
  double d_Vsbstar_dc_tmp_dV_SI_BP;
  double Vmb;
  double d_Vmb_dV_DI_SI;
  double d_Vmb_dV_SI_BP;
  double us;
  double d_us_dV_DI_SI;
  double d_us_dV_SI_BP;
  double usnew;
  double d_usnew_dV_DI_SI;
  double d_usnew_dV_SI_BP;
  double Vmbnew;
  double d_Vmbnew_dV_DI_SI;
  double d_Vmbnew_dV_SI_BP;
  double Vgbstar;
  double d_Vgbstar_dV_DI_SI;
  double d_Vgbstar_dV_GP_SI;
  double d_Vgbstar_dV_SI_BP;
  double Vgb1;
  double d_Vgb1_dV_DI_SI;
  double d_Vgb1_dV_GP_SI;
  double d_Vgb1_dV_SI_BP;
  double Vdsp;
  double d_Vdsp_dV_DI_SI;
  double delVg;
  double d_delVg_dV_GP_SI;
  double d_delVg_dV_DI_SI;
  double d_delVg_dV_SI_BP;
  double nu;
  double d_nu_dV_DI_SI;
  double d_nu_dV_GP_SI;
  double d_nu_dV_SI_BP;
  double mutau;
  double d_mutau_dV_DI_SI;
  double d_mutau_dV_GP_SI;
  double d_mutau_dV_SI_BP;
  double Vdsat_lim;
  double d_Vdsat_lim_dV_GP_SI;
  double d_Vdsat_lim_dV_DI_SI;
  double d_Vdsat_lim_dV_SI_BP;
  double Vdsat;
  double d_Vdsat_dV_GP_SI;
  double d_Vdsat_dV_DI_SI;
  double d_Vdsat_dV_SI_BP;
  double qeff1_dc;
  double d_qeff1_dc_dV_DI_SI;
  double d_qeff1_dc_dV_GP_SI;
  double d_qeff1_dc_dV_SI_BP;
  double Voxm_dc;
  double d_Voxm_dc_dV_DI_SI;
  double d_Voxm_dc_dV_GP_SI;
  double d_Voxm_dc_dV_SI_BP;
  double GdL_dc;
  double d_GdL_dc_dV_DI_SI;
  double d_GdL_dc_dV_GP_SI;
  double d_GdL_dc_dV_SI_BP;
  double eta_p_dc;
  double d_eta_p_dc_dV_DI_SI;
  double d_eta_p_dc_dV_GP_SI;
  double d_eta_p_dc_dV_SI_BP;
  double Gvsat_dc;
  double d_Gvsat_dc_dV_DI_SI;
  double d_Gvsat_dc_dV_GP_SI;
  double d_Gvsat_dc_dV_SI_BP;
  double Gmob_dL_dc;
  double d_Gmob_dL_dc_dV_DI_SI;
  double d_Gmob_dL_dc_dV_GP_SI;
  double d_Gmob_dL_dc_dV_SI_BP;
  double x_ds_dc;
  double d_x_ds_dc_dV_DI_SI;
  double d_x_ds_dc_dV_GP_SI;
  double d_x_ds_dc_dV_SI_BP;
  double x_m_dc;
  double d_x_m_dc_dV_DI_SI;
  double d_x_m_dc_dV_GP_SI;
  double d_x_m_dc_dV_SI_BP;
  double Gf_dc;
  double d_Gf_dc_dV_DI_SI;
  double d_Gf_dc_dV_GP_SI;
  double d_Gf_dc_dV_SI_BP;
  double Vdsat_dc;
  double d_Vdsat_dc_dV_GP_SI;
  double d_Vdsat_dc_dV_DI_SI;
  double d_Vdsat_dc_dV_SI_BP;
  double Udse_dc;
  double d_Udse_dc_dV_GP_SI;
  double d_Udse_dc_dV_SI_BP;
  double d_Udse_dc_dV_DI_SI;
  double Vdsx;
  double d_Vdsx_dV_DI_SI;
  double Vdb;
  double d_Vdb_dV_DI_SI;
  double d_Vdb_dV_SI_BP;
  double xgd_ov;
  double d_xgd_ov_dV_GP_SI;
  double d_xgd_ov_dV_DI_SI;
  double xgs_ov;
  double d_xgs_ov_dV_GP_SI;
  double VgdPrime;
  double d_VgdPrime_dV_GP_SI;
  double d_VgdPrime_dV_DI_SI;
  double VdbPrime;
  double d_VdbPrime_dV_DI_SI;
  double d_VdbPrime_dV_SI_BP;
  double VsbPrime;
  double d_VsbPrime_dV_SI_BP;
  double VgsPrime;
  double d_VgsPrime_dV_GP_SI;
  double Vjun_d;
  double d_Vjun_d_dV_DI_BD;
  double Vjun_s;
  double d_Vjun_s_dV_SI_BS;
  double Vsb;
  double d_Vsb_dV_DI_SI;
  double d_Vsb_dV_SI_BP;
  double Vds;
  double d_Vds_dV_DI_SI;
  double Vgs;
  double d_Vgs_dV_DI_SI;
  double d_Vgs_dV_GP_SI;
  double Vovd;
  double d_Vovd_dV_GP_SI;
  double d_Vovd_dV_DI_SI;
  double Vovs;
  double d_Vovs_dV_GP_SI;
  double xd_ov;
  double d_xd_ov_dV_DI_SI;
  double d_xd_ov_dV_GP_SI;
  double xs_ov;
  double d_xs_ov_dV_GP_SI;
  double QCLM;
  double d_QCLM_dV_DI_SI;
  double d_QCLM_dV_GP_SI;
  double d_QCLM_dV_SI_BP;
  double Qfgd;
  double d_Qfgd_dV_GP_SI;
  double d_Qfgd_dV_DI_SI;
  double Qfgs;
  double d_Qfgs_dV_GP_SI;
  double Qgb_ov;
  double d_Qgb_ov_dV_DI_SI;
  double d_Qgb_ov_dV_GP_SI;
  double d_Qgb_ov_dV_SI_BP;
  double Qgd_ov;
  double d_Qgd_ov_dV_GP_SI;
  double d_Qgd_ov_dV_DI_SI;
  double Qgs_ov;
  double d_Qgs_ov_dV_GP_SI;
  double Qb;
  double d_Qb_dV_DI_SI;
  double d_Qb_dV_GP_SI;
  double d_Qb_dV_SI_BP;
  double Qd;
  double d_Qd_dV_DI_SI;
  double d_Qd_dV_GP_SI;
  double d_Qd_dV_SI_BP;
  double Qg;
  double d_Qg_dV_DI_SI;
  double d_Qg_dV_GP_SI;
  double d_Qg_dV_SI_BP;
  double QB;
  double d_QB_dV_DI_SI;
  double d_QB_dV_GP_SI;
  double d_QB_dV_SI_BP;
  double QD;
  double d_QD_dV_DI_SI;
  double d_QD_dV_GP_SI;
  double d_QD_dV_SI_BP;
  double QI;
  double d_QI_dV_DI_SI;
  double d_QI_dV_GP_SI;
  double d_QI_dV_SI_BP;
  double QG;
  double d_QG_dV_DI_SI;
  double d_QG_dV_GP_SI;
  double d_QG_dV_SI_BP;
  double Fj2;
  double d_Fj2_dV_DI_SI;
  double d_Fj2_dV_GP_SI;
  double d_Fj2_dV_SI_BP;
  double Fj;
  double d_Fj_dV_DI_SI;
  double d_Fj_dV_GP_SI;
  double d_Fj_dV_SI_BP;
  double Vgb;
  double d_Vgb_dV_DI_SI;
  double d_Vgb_dV_GP_SI;
  double d_Vgb_dV_SI_BP;
  double Vsbstar_ac;
  double d_Vsbstar_ac_dV_DI_SI;
  double d_Vsbstar_ac_dV_SI_BP;
  double d_Vsbstar_ac_dV_GP_SI;
  double xg_ac;
  double d_xg_ac_dV_DI_SI;
  double d_xg_ac_dV_GP_SI;
  double d_xg_ac_dV_SI_BP;
  double qeff1_ac;
  double d_qeff1_ac_dV_DI_SI;
  double d_qeff1_ac_dV_GP_SI;
  double d_qeff1_ac_dV_SI_BP;
  double Voxm_ac;
  double d_Voxm_ac_dV_DI_SI;
  double d_Voxm_ac_dV_GP_SI;
  double d_Voxm_ac_dV_SI_BP;
  double alpha_ac;
  double d_alpha_ac_dV_DI_SI;
  double d_alpha_ac_dV_GP_SI;
  double d_alpha_ac_dV_SI_BP;
  double dps_ac;
  double d_dps_ac_dV_DI_SI;
  double d_dps_ac_dV_GP_SI;
  double d_dps_ac_dV_SI_BP;
  double qim_ac;
  double d_qim_ac_dV_GP_SI;
  double d_qim_ac_dV_DI_SI;
  double d_qim_ac_dV_SI_BP;
  double GdL_ac;
  double d_GdL_ac_dV_DI_SI;
  double d_GdL_ac_dV_GP_SI;
  double d_GdL_ac_dV_SI_BP;
  double H_ac;
  double d_H_ac_dV_GP_SI;
  double d_H_ac_dV_DI_SI;
  double d_H_ac_dV_SI_BP;
  double rwellnoise;
  double rjundnoise;
  double rjunsnoise;
  double rbulknoise;
  double rdrainnoise;
  double rsourcenoise;
  double rgatenoise;
  double h1;
  double h2;
  double h2d;
  double d_h2d_dV_DI_BD;
  double d_h2d_dV_SI_BS;
  double h3;
  double d_h3_dV_DI_BD;
  double d_h3_dV_SI_BS;
  double h4;
  double d_h4_dV_DI_BD;
  double d_h4_dV_SI_BS;
  double h5;
  double d_h5_dV_DI_BD;
  double d_h5_dV_SI_BS;
  double ijunrev;
  double d_ijunrev_dV_DI_BD;
  double d_ijunrev_dV_SI_BS;
  double ijunfor2;
  double d_ijunfor2_dV_DI_BD;
  double d_ijunfor2_dV_SI_BS;
  double ijunfor1;
  double d_ijunfor1_dV_DI_BD;
  double d_ijunfor1_dV_SI_BS;
  double tm1;
  double d_tm1_dV_DI_BD;
  double d_tm1_dV_SI_BS;
  double tm0;
  double d_tm0_dV_DI_BD;
  double d_tm0_dV_SI_BS;
  double fbreakdown;
  double d_fbreakdown_dV_SI_BS;
  double d_fbreakdown_dV_DI_BD;
  double ibbt;
  double d_ibbt_dV_SI_BS;
  double d_ibbt_dV_DI_BD;
  double Fmaxr;
  double d_Fmaxr_dV_SI_BS;
  double d_Fmaxr_dV_DI_BD;
  double itat;
  double d_itat_dV_SI_BS;
  double d_itat_dV_DI_BD;
  double gammamax;
  double d_gammamax_dV_SI_BS;
  double d_gammamax_dV_DI_BD;
  double erfctimesexpmtat;
  double d_erfctimesexpmtat_dV_SI_BS;
  double d_erfctimesexpmtat_dV_DI_BD;
  double erfcpos;
  double d_erfcpos_dV_SI_BS;
  double d_erfcpos_dV_DI_BD;
  double terfc;
  double d_terfc_dV_SI_BS;
  double d_terfc_dV_DI_BD;
  double ysq;
  double d_ysq_dV_SI_BS;
  double d_ysq_dV_DI_BD;
  double xerfc;
  double d_xerfc_dV_SI_BS;
  double d_xerfc_dV_DI_BD;
  double mtat;
  double d_mtat_dV_SI_BS;
  double d_mtat_dV_DI_BD;
  double ltat;
  double d_ltat_dV_SI_BS;
  double d_ltat_dV_DI_BD;
  double ktat;
  double d_ktat_dV_SI_BS;
  double d_ktat_dV_DI_BD;
  double wtat;
  double d_wtat_dV_SI_BS;
  double d_wtat_dV_DI_BD;
  double wgamma;
  double d_wgamma_dV_SI_BS;
  double d_wgamma_dV_DI_BD;
  double umaxpoweronepointfive;
  double d_umaxpoweronepointfive_dV_SI_BS;
  double d_umaxpoweronepointfive_dV_DI_BD;
  double sqrtumax;
  double d_sqrtumax_dV_SI_BS;
  double d_sqrtumax_dV_DI_BD;
  double umax;
  double d_umax_dV_SI_BS;
  double d_umax_dV_DI_BD;
  double umaxbeforelimiting;
  double d_umaxbeforelimiting_dV_SI_BS;
  double d_umaxbeforelimiting_dV_DI_BD;
  double twoatatoverthreebtat;
  double d_twoatatoverthreebtat_dV_SI_BS;
  double d_twoatatoverthreebtat_dV_DI_BD;
  double btat;
  double d_btat_dV_SI_BS;
  double d_btat_dV_DI_BD;
  double isrh;
  double d_isrh_dV_SI_BS;
  double d_isrh_dV_DI_BD;
  double asrh;
  double d_asrh_dV_SI_BS;
  double d_asrh_dV_DI_BD;
  double wdep;
  double d_wdep_dV_SI_BS;
  double d_wdep_dV_DI_BD;
  double wsrh;
  double d_wsrh_dV_DI_BD;
  double d_wsrh_dV_SI_BS;
  double dwsrh;
  double d_dwsrh_dV_DI_BD;
  double d_dwsrh_dV_SI_BS;
  double wsrhstep;
  double d_wsrhstep_dV_DI_BD;
  double d_wsrhstep_dV_SI_BS;
  double vbi_minus_vjsrh;
  double d_vbi_minus_vjsrh_dV_DI_BD;
  double d_vbi_minus_vjsrh_dV_SI_BS;
  double id;
  double d_id_dV_DI_BD;
  double d_id_dV_SI_BS;
  double tmp;
  double d_tmp_dV_SI_BS;
  double d_tmp_dV_DI_BD;
  double vav;
  double d_vav_dV_DI_BD;
  double d_vav_dV_SI_BS;
  double vjsrh;
  double d_vjsrh_dV_DI_BD;
  double d_vjsrh_dV_SI_BS;
  double vjlim;
  double d_vjlim_dV_DI_BD;
  double d_vjlim_dV_SI_BS;
  double z;
  double d_z_dV_DI_BD;
  double d_z_dV_SI_BS;
  double idmult;
  double d_idmult_dV_DI_BD;
  double d_idmult_dV_SI_BS;
  double zinv;
  double d_zinv_dV_DI_BD;
  double d_zinv_dV_SI_BS;
  double vj;
  double d_vj_dV_SI_BS;
  double d_vj_dV_DI_BD;
  double two_psistar;
  double d_two_psistar_dV_DI_BD;
  double d_two_psistar_dV_SI_BS;
  double vbbt;
  double d_vbbt_dV_DI_BD;
  double d_vbbt_dV_SI_BS;
  double Qs;
  double d_Qs_dV_DI_SI;
  double d_Qs_dV_GP_SI;
  double d_Qs_dV_SI_BP;
  double g_idealedge;
  double d_g_idealedge_dV_DI_SI;
  double d_g_idealedge_dV_SI_BP;
  double d_g_idealedge_dV_GP_SI;
  double lcinv2edge;
  double d_lcinv2edge_dV_GP_SI;
  double d_lcinv2edge_dV_DI_SI;
  double d_lcinv2edge_dV_SI_BP;
  double lcedge;
  double d_lcedge_dV_GP_SI;
  double d_lcedge_dV_DI_SI;
  double d_lcedge_dV_SI_BP;
  double redge;
  double d_redge_dV_GP_SI;
  double d_redge_dV_DI_SI;
  double d_redge_dV_SI_BP;
  double t2edge;
  double d_t2edge_dV_DI_SI;
  double d_t2edge_dV_SI_BP;
  double d_t2edge_dV_GP_SI;
  double sqt2edge;
  double d_sqt2edge_dV_DI_SI;
  double d_sqt2edge_dV_SI_BP;
  double d_sqt2edge_dV_GP_SI;
  double t1edge;
  double d_t1edge_dV_GP_SI;
  double d_t1edge_dV_DI_SI;
  double d_t1edge_dV_SI_BP;
  double H0edge;
  double d_H0edge_dV_DI_SI;
  double d_H0edge_dV_SI_BP;
  double d_H0edge_dV_GP_SI;
  double Delta_N1edge;
  double d_Delta_N1edge_dV_GP_SI;
  double d_Delta_N1edge_dV_DI_SI;
  double d_Delta_N1edge_dV_SI_BP;
  double Nm1edge;
  double d_Nm1edge_dV_GP_SI;
  double d_Nm1edge_dV_DI_SI;
  double d_Nm1edge_dV_SI_BP;
  double N1edge;
  double d_N1edge_dV_GP_SI;
  double d_N1edge_dV_DI_SI;
  double d_N1edge_dV_SI_BP;
  double anoisedge;
  double d_anoisedge_dV_GP_SI;
  double d_anoisedge_dV_DI_SI;
  double d_anoisedge_dV_SI_BP;
  double shot_igd;
  double d_shot_igd_dV_GP_SI;
  double d_shot_igd_dV_DI_SI;
  double d_shot_igd_dV_SI_BP;
  double shot_igs;
  double d_shot_igs_dV_GP_SI;
  double d_shot_igs_dV_DI_SI;
  double d_shot_igs_dV_SI_BP;
  double jnoisex_d;
  double d_jnoisex_d_dV_DI_BD;
  double d_jnoisex_d_dV_SI_BS;
  double jnoisex_s;
  double d_jnoisex_s_dV_DI_BD;
  double d_jnoisex_s_dV_SI_BS;
  double shot_iavl;
  double d_shot_iavl_dV_DI_SI;
  double d_shot_iavl_dV_GP_SI;
  double d_shot_iavl_dV_SI_BP;
  double shot_igdov;
  double d_shot_igdov_dV_GP_SI;
  double d_shot_igdov_dV_DI_SI;
  double d_shot_igdov_dV_SI_BP;
  double shot_igsov;
  double d_shot_igsov_dV_GP_SI;
  double d_shot_igsov_dV_DI_SI;
  double d_shot_igsov_dV_SI_BP;
  double shot_igcdx;
  double d_shot_igcdx_dV_GP_SI;
  double d_shot_igcdx_dV_DI_SI;
  double d_shot_igcdx_dV_SI_BP;
  double shot_igcsx;
  double d_shot_igcsx_dV_GP_SI;
  double d_shot_igcsx_dV_DI_SI;
  double d_shot_igcsx_dV_SI_BP;
  double gfac;
  double d_gfac_dV_DI_SI;
  double d_gfac_dV_GP_SI;
  double d_gfac_dV_SI_BP;
  double Gvsat_exc;
  double d_Gvsat_exc_dV_DI_SI;
  double d_Gvsat_exc_dV_GP_SI;
  double d_Gvsat_exc_dV_SI_BP;
  double zsat_exc;
  double d_zsat_exc_dV_DI_SI;
  double d_zsat_exc_dV_SI_BP;
  double d_zsat_exc_dV_GP_SI;
  double thesat1_exc;
  double d_thesat1_exc_dV_DI_SI;
  double d_thesat1_exc_dV_SI_BP;
  double d_thesat1_exc_dV_GP_SI;
  double temp_exc;
  double d_temp_exc_dV_DI_SI;
  double d_temp_exc_dV_SI_BP;
  double d_temp_exc_dV_GP_SI;
  double wsat_exc;
  double d_wsat_exc_dV_DI_SI;
  double d_wsat_exc_dV_SI_BP;
  double d_wsat_exc_dV_GP_SI;
  double temp2_exc;
  double d_temp2_exc_dV_DI_SI;
  double d_temp2_exc_dV_SI_BP;
  double d_temp2_exc_dV_GP_SI;
  double g_ideal;
  double d_g_ideal_dV_DI_SI;
  double d_g_ideal_dV_GP_SI;
  double d_g_ideal_dV_SI_BP;
  double lcinv2;
  double d_lcinv2_dV_DI_SI;
  double d_lcinv2_dV_SI_BP;
  double d_lcinv2_dV_GP_SI;
  double lc;
  double d_lc_dV_DI_SI;
  double d_lc_dV_SI_BP;
  double d_lc_dV_GP_SI;
  double r;
  double d_r_dV_DI_SI;
  double d_r_dV_SI_BP;
  double d_r_dV_GP_SI;
  double t2;
  double d_t2_dV_DI_SI;
  double d_t2_dV_GP_SI;
  double d_t2_dV_SI_BP;
  double sqt2;
  double d_sqt2_dV_DI_SI;
  double d_sqt2_dV_GP_SI;
  double d_sqt2_dV_SI_BP;
  double t1;
  double d_t1_dV_DI_SI;
  double d_t1_dV_SI_BP;
  double d_t1_dV_GP_SI;
  double Delta_N1;
  double d_Delta_N1_dV_DI_SI;
  double d_Delta_N1_dV_GP_SI;
  double d_Delta_N1_dV_SI_BP;
  double Nm1;
  double d_Nm1_dV_DI_SI;
  double d_Nm1_dV_SI_BP;
  double d_Nm1_dV_GP_SI;
  double N1;
  double d_N1_dV_DI_SI;
  double d_N1_dV_GP_SI;
  double d_N1_dV_SI_BP;
  double sqig;
  double d_sqig_dV_DI_SI;
  double d_sqig_dV_SI_BP;
  double d_sqig_dV_GP_SI;
  double sqid;
  double d_sqid_dV_DI_SI;
  double d_sqid_dV_SI_BP;
  double d_sqid_dV_GP_SI;
  double CGeff;
  double d_CGeff_dV_DI_SI;
  double d_CGeff_dV_GP_SI;
  double d_CGeff_dV_SI_BP;
  double c_igid;
  double d_c_igid_dV_DI_SI;
  double d_c_igid_dV_SI_BP;
  double d_c_igid_dV_GP_SI;
  double migid;
  double d_migid_dV_DI_SI;
  double d_migid_dV_SI_BP;
  double d_migid_dV_GP_SI;
  double mig;
  double d_mig_dV_DI_SI;
  double d_mig_dV_SI_BP;
  double d_mig_dV_GP_SI;
  double mid;
  double d_mid_dV_DI_SI;
  double d_mid_dV_SI_BP;
  double d_mid_dV_GP_SI;
  double Sidexc;
  double d_Sidexc_dV_DI_SI;
  double d_Sidexc_dV_GP_SI;
  double d_Sidexc_dV_SI_BP;
  double Sfl;
  double d_Sfl_dV_DI_SI;
  double d_Sfl_dV_GP_SI;
  double d_Sfl_dV_SI_BP;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (14))
  {
    probeVars.resize(14);
    d_probeVars.resize(14);
    for (int i=0;i<14;i++)
    {
      d_probeVars[i].resize(14);
      for (int j=0;j<14;j++)
        d_probeVars[i][j]=0.0;
    }
    staticContributions.resize(13+0);
    d_staticContributions.resize(13+0);
    for (int i=0;i<13+0;i++)
      d_staticContributions[i].resize(14);
    dynamicContributions.resize(13+0);
    d_dynamicContributions.resize(13+0);
    for (int i=0;i<13+0;i++)
      d_dynamicContributions[i].resize(14);
  }

  noiseContribsPower.resize(16);
  noiseContribsExponent.resize(16);

  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 13+0 ; ++i)
  {
    staticContributions[i]=0;
    for (int j=0;j<14;j++)
      d_staticContributions[i][j] = 0.0;
    dynamicContributions[i]=0;
    for (int j=0;j<14;j++)
      d_dynamicContributions[i][j] = 0.0;
  }

  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_NOI_GND] = (*solVectorPtr)[li_NOI];
  d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND] = 1.0;
  probeVars[admsProbeID_V_NOI2_GND] = (*solVectorPtr)[li_NOI2];
  d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND] = 1.0;
  probeVars[admsProbeID_V_B_BI] = (*solVectorPtr)[li_B] - (*solVectorPtr)[li_BI];
  d_probeVars[admsProbeID_V_B_BI][admsProbeID_V_B_BI] = 1.0;
  probeVars[admsProbeID_V_BD_BI] = (*solVectorPtr)[li_BD] - (*solVectorPtr)[li_BI];
  d_probeVars[admsProbeID_V_BD_BI][admsProbeID_V_BD_BI] = 1.0;
  probeVars[admsProbeID_V_BS_BI] = (*solVectorPtr)[li_BS] - (*solVectorPtr)[li_BI];
  d_probeVars[admsProbeID_V_BS_BI][admsProbeID_V_BS_BI] = 1.0;
  probeVars[admsProbeID_V_BP_BI] = (*solVectorPtr)[li_BP] - (*solVectorPtr)[li_BI];
  d_probeVars[admsProbeID_V_BP_BI][admsProbeID_V_BP_BI] = 1.0;
  probeVars[admsProbeID_V_D_DI] = (*solVectorPtr)[li_D] - (*solVectorPtr)[li_DI];
  d_probeVars[admsProbeID_V_D_DI][admsProbeID_V_D_DI] = 1.0;
  probeVars[admsProbeID_V_S_SI] = (*solVectorPtr)[li_S] - (*solVectorPtr)[li_SI];
  d_probeVars[admsProbeID_V_S_SI][admsProbeID_V_S_SI] = 1.0;
  probeVars[admsProbeID_V_G_GP] = (*solVectorPtr)[li_G] - (*solVectorPtr)[li_GP];
  d_probeVars[admsProbeID_V_G_GP][admsProbeID_V_G_GP] = 1.0;
  probeVars[admsProbeID_V_DI_BD] = (*solVectorPtr)[li_DI] - (*solVectorPtr)[li_BD];
  d_probeVars[admsProbeID_V_DI_BD][admsProbeID_V_DI_BD] = 1.0;
  probeVars[admsProbeID_V_SI_BS] = (*solVectorPtr)[li_SI] - (*solVectorPtr)[li_BS];
  d_probeVars[admsProbeID_V_SI_BS][admsProbeID_V_SI_BS] = 1.0;
  probeVars[admsProbeID_V_SI_BP] = (*solVectorPtr)[li_SI] - (*solVectorPtr)[li_BP];
  d_probeVars[admsProbeID_V_SI_BP][admsProbeID_V_SI_BP] = 1.0;
  probeVars[admsProbeID_V_DI_SI] = (*solVectorPtr)[li_DI] - (*solVectorPtr)[li_SI];
  d_probeVars[admsProbeID_V_DI_SI][admsProbeID_V_DI_SI] = 1.0;
  probeVars[admsProbeID_V_GP_SI] = (*solVectorPtr)[li_GP] - (*solVectorPtr)[li_SI];
  d_probeVars[admsProbeID_V_GP_SI][admsProbeID_V_GP_SI] = 1.0;
  // -- code converted from analog/code block
  //Begin block evaluateblock
  {
    //Block-local variables for block evaluateblock
    double sigVds;
    double dphit1;
    double d_dphit1_dV_GP_SI;
    double d_dphit1_dV_DI_SI;
    double d_dphit1_dV_SI_BP;
    double phit1;
    double d_phit1_dV_GP_SI;
    double d_phit1_dV_DI_SI;
    double d_phit1_dV_SI_BP;
    double inv_phit1;
    double d_inv_phit1_dV_GP_SI;
    double d_inv_phit1_dV_DI_SI;
    double d_inv_phit1_dV_SI_BP;
    double xg_dc;
    double d_xg_dc_dV_DI_SI;
    double d_xg_dc_dV_GP_SI;
    double d_xg_dc_dV_SI_BP;
    double alpha_dc;
    double d_alpha_dc_dV_DI_SI;
    double d_alpha_dc_dV_GP_SI;
    double d_alpha_dc_dV_SI_BP;
    double dps_dc;
    double d_dps_dc_dV_DI_SI;
    double d_dps_dc_dV_GP_SI;
    double d_dps_dc_dV_SI_BP;
    double qim_dc;
    double d_qim_dc_dV_DI_SI;
    double d_qim_dc_dV_SI_BP;
    double d_qim_dc_dV_GP_SI;
    double qim1_dc;
    double d_qim1_dc_dV_DI_SI;
    double d_qim1_dc_dV_SI_BP;
    double d_qim1_dc_dV_GP_SI;
    double H_dc;
    double d_H_dc_dV_GP_SI;
    double d_H_dc_dV_DI_SI;
    double d_H_dc_dV_SI_BP;
    double FdL_dc;
    double d_FdL_dc_dV_DI_SI;
    double d_FdL_dc_dV_GP_SI;
    double d_FdL_dc_dV_SI_BP;
    double Gvsatinv_dc;
    double d_Gvsatinv_dc_dV_DI_SI;
    double d_Gvsatinv_dc_dV_GP_SI;
    double d_Gvsatinv_dc_dV_SI_BP;
    double Ids;
    double d_Ids_dV_DI_SI;
    double d_Ids_dV_GP_SI;
    double d_Ids_dV_SI_BP;
    double Iimpact;
    double d_Iimpact_dV_DI_SI;
    double d_Iimpact_dV_GP_SI;
    double d_Iimpact_dV_SI_BP;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    double mavl;
    double d_mavl_dV_DI_SI;
    double d_mavl_dV_GP_SI;
    double d_mavl_dV_SI_BP;
    double Igdov;
    double d_Igdov_dV_GP_SI;
    double d_Igdov_dV_DI_SI;
    double d_Igdov_dV_SI_BP;
    double Igsov;
    double d_Igsov_dV_GP_SI;
    double d_Igsov_dV_DI_SI;
    double d_Igsov_dV_SI_BP;
    double Igcd;
    double d_Igcd_dV_GP_SI;
    double d_Igcd_dV_DI_SI;
    double d_Igcd_dV_SI_BP;
    double Igcs;
    double d_Igcs_dV_GP_SI;
    double d_Igcs_dV_DI_SI;
    double d_Igcs_dV_SI_BP;
    double eta_p_ac;
    double d_eta_p_ac_dV_DI_SI;
    double d_eta_p_ac_dV_GP_SI;
    double d_eta_p_ac_dV_SI_BP;
    double Gvsat_ac;
    double d_Gvsat_ac_dV_DI_SI;
    double d_Gvsat_ac_dV_GP_SI;
    double d_Gvsat_ac_dV_SI_BP;
    double Gmob_dL_ac;
    double d_Gmob_dL_ac_dV_DI_SI;
    double d_Gmob_dL_ac_dV_GP_SI;
    double d_Gmob_dL_ac_dV_SI_BP;
    double H0;
    double d_H0_dV_DI_SI;
    double d_H0_dV_SI_BP;
    double d_H0_dV_GP_SI;
    double COX_qm;
    double d_COX_qm_dV_DI_SI;
    double d_COX_qm_dV_GP_SI;
    double d_COX_qm_dV_SI_BP;
    double ijun_s;
    double d_ijun_s_dV_DI_BD;
    double d_ijun_s_dV_SI_BS;
    double ijunbot_s;
    double d_ijunbot_s_dV_SI_BS;
    double d_ijunbot_s_dV_DI_BD;
    double ijunsti_s;
    double d_ijunsti_s_dV_SI_BS;
    double d_ijunsti_s_dV_DI_BD;
    double ijungat_s;
    double d_ijungat_s_dV_SI_BS;
    double d_ijungat_s_dV_DI_BD;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    double ijun_d;
    double d_ijun_d_dV_DI_BD;
    double d_ijun_d_dV_SI_BS;
    double ijunbot_d;
    double d_ijunbot_d_dV_DI_BD;
    double d_ijunbot_d_dV_SI_BS;
    double ijunsti_d;
    double d_ijunsti_d_dV_DI_BD;
    double d_ijunsti_d_dV_SI_BS;
    double ijungat_d;
    double d_ijungat_d_dV_DI_BD;
    double d_ijungat_d_dV_SI_BS;
    double qjun_s;
    double d_qjun_s_dV_DI_BD;
    double d_qjun_s_dV_SI_BS;
    double qjunbot_s;
    double d_qjunbot_s_dV_DI_BD;
    double d_qjunbot_s_dV_SI_BS;
    double qjunsti_s;
    double d_qjunsti_s_dV_DI_BD;
    double d_qjunsti_s_dV_SI_BS;
    double qjungat_s;
    double d_qjungat_s_dV_DI_BD;
    double d_qjungat_s_dV_SI_BS;
    double qjun_d;
    double d_qjun_d_dV_DI_BD;
    double d_qjun_d_dV_SI_BS;
    double qjunbot_d;
    double d_qjunbot_d_dV_DI_BD;
    double d_qjunbot_d_dV_SI_BS;
    double qjunsti_d;
    double d_qjunsti_d_dV_DI_BD;
    double d_qjunsti_d_dV_SI_BS;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    double qjungat_d;
    double d_qjungat_d_dV_DI_BD;
    double d_qjungat_d_dV_SI_BS;
    double jnoise_s;
    double d_jnoise_s_dV_DI_SI;
    double d_jnoise_s_dV_GP_SI;
    double d_jnoise_s_dV_SI_BP;
    double d_jnoise_s_dV_DI_BD;
    double d_jnoise_s_dV_SI_BS;
    double jnoise_d;
    double d_jnoise_d_dV_DI_BD;
    double d_jnoise_d_dV_SI_BS;
    double d_jnoise_d_dV_DI_SI;
    double d_jnoise_d_dV_GP_SI;
    double d_jnoise_d_dV_SI_BP;
    double Gmob_dc;
    double d_Gmob_dc_dV_DI_SI;
    double d_Gmob_dc_dV_GP_SI;
    double d_Gmob_dc_dV_SI_BP;
    double xitsb_dc;
    double d_xitsb_dc_dV_DI_SI;
    double d_xitsb_dc_dV_SI_BP;
    double Vdse_dc;
    double d_Vdse_dc_dV_GP_SI;
    double d_Vdse_dc_dV_SI_BP;
    double d_Vdse_dc_dV_DI_SI;
    double Vsbstaredge;
    double d_Vsbstaredge_dV_DI_SI;
    double d_Vsbstaredge_dV_SI_BP;
    double d_Vsbstaredge_dV_GP_SI;
    double Vsbxedge;
    double d_Vsbxedge_dV_DI_SI;
    double d_Vsbxedge_dV_SI_BP;
    double d_Vsbxedge_dV_GP_SI;
    double dphit1edge;
    double d_dphit1edge_dV_DI_SI;
    double d_dphit1edge_dV_SI_BP;
    double d_dphit1edge_dV_GP_SI;
    double phit1edge;
    double d_phit1edge_dV_DI_SI;
    double d_phit1edge_dV_SI_BP;
    double d_phit1edge_dV_GP_SI;
    double inv_phit1edge;
    double d_inv_phit1edge_dV_DI_SI;
    double d_inv_phit1edge_dV_SI_BP;
    double d_inv_phit1edge_dV_GP_SI;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    double Vdspedge;
    double d_Vdspedge_dV_DI_SI;
    double delVgedge;
    double d_delVgedge_dV_DI_SI;
    double d_delVgedge_dV_SI_BP;
    double d_delVgedge_dV_GP_SI;
    double xgedge;
    double d_xgedge_dV_DI_SI;
    double d_xgedge_dV_SI_BP;
    double d_xgedge_dV_GP_SI;
    double xbedge;
    double d_xbedge_dV_DI_SI;
    double d_xbedge_dV_SI_BP;
    double d_xbedge_dV_GP_SI;
    double dxthedge;
    double d_dxthedge_dV_DI_SI;
    double d_dxthedge_dV_SI_BP;
    double d_dxthedge_dV_GP_SI;
    double xnedge_s;
    double d_xnedge_s_dV_DI_SI;
    double d_xnedge_s_dV_SI_BP;
    double d_xnedge_s_dV_GP_SI;
    double qseffedge;
    double d_qseffedge_dV_DI_SI;
    double d_qseffedge_dV_SI_BP;
    double d_qseffedge_dV_GP_SI;
    double xnedge_d;
    double d_xnedge_d_dV_DI_SI;
    double d_xnedge_d_dV_SI_BP;
    double d_xnedge_d_dV_GP_SI;
    double qdseffedge;
    double d_qdseffedge_dV_DI_SI;
    double d_qdseffedge_dV_SI_BP;
    double d_qdseffedge_dV_GP_SI;
    double qdeffedge;
    double d_qdeffedge_dV_DI_SI;
    double d_qdeffedge_dV_SI_BP;
    double d_qdeffedge_dV_GP_SI;
    double qmeffedge;
    double d_qmeffedge_dV_DI_SI;
    double d_qmeffedge_dV_SI_BP;
    double d_qmeffedge_dV_GP_SI;
    double dsqredge;
    double d_dsqredge_dV_DI_SI;
    double d_dsqredge_dV_SI_BP;
    double d_dsqredge_dV_GP_SI;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    double alphabmedge;
    double d_alphabmedge_dV_DI_SI;
    double d_alphabmedge_dV_SI_BP;
    double d_alphabmedge_dV_GP_SI;
    double Idsedge;
    double d_Idsedge_dV_DI_SI;
    double d_Idsedge_dV_SI_BP;
    double d_Idsedge_dV_GP_SI;
    double Sfledge;
    double d_Sfledge_dV_GP_SI;
    double d_Sfledge_dV_DI_SI;
    double d_Sfledge_dV_SI_BP;
    double midedge;
    double d_midedge_dV_GP_SI;
    double d_midedge_dV_DI_SI;
    double d_midedge_dV_SI_BP;
    double sqidedge;
    double d_sqidedge_dV_GP_SI;
    double d_sqidedge_dV_DI_SI;
    double d_sqidedge_dV_SI_BP;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    double temp;
    double d_temp_dV_GP_SI;
    double d_temp_dV_DI_SI;
    double d_temp_dV_SI_BP;
    double temp1;
    double d_temp1_dV_GP_SI;
    double d_temp1_dV_DI_SI;
    double d_temp1_dV_SI_BP;
    double temp2;
    double d_temp2_dV_DI_SI;
    double d_temp2_dV_GP_SI;
    double d_temp2_dV_SI_BP;
    //End of Block-local variables
    //Begin block evaluateStatic
    {

      d_temp_dV_GP_SI = d_temp_dV_DI_SI = d_temp_dV_SI_BP =  0.0;
      temp = 0.0;

      d_temp1_dV_GP_SI = d_temp1_dV_DI_SI = d_temp1_dV_SI_BP =  0.0;
      temp1 = 0.0;

      d_temp2_dV_DI_SI = d_temp2_dV_GP_SI = d_temp2_dV_SI_BP =  0.0;
      temp2 = 0.0;

      d_QCLM_dV_DI_SI = d_QCLM_dV_GP_SI = d_QCLM_dV_SI_BP =  0.0;
      QCLM = 0.0;

      d_xs_ov_dV_GP_SI =  0.0;
      xs_ov = 0.0;

      d_xd_ov_dV_DI_SI = d_xd_ov_dV_GP_SI =  0.0;
      xd_ov = 0.0;

      d_Vovs_dV_GP_SI =  0.0;
      Vovs = 0.0;

      d_Vovd_dV_GP_SI = d_Vovd_dV_DI_SI =  0.0;
      Vovd = 0.0;

      d_Iimpact_dV_DI_SI = d_Iimpact_dV_GP_SI = d_Iimpact_dV_SI_BP =  0.0;
      Iimpact = 0.0;

      d_mavl_dV_DI_SI = d_mavl_dV_GP_SI = d_mavl_dV_SI_BP =  0.0;
      mavl = 0.0;
      if (((model_.CHNL_TYPE)==(+1)))
      {

        d_Vgs_dV_DI_SI =  0.0;
        d_Vgs_dV_GP_SI = d_probeVars[admsProbeID_V_GP_SI][admsProbeID_V_GP_SI];
        Vgs = (probeVars[admsProbeID_V_GP_SI]);

        d_Vds_dV_DI_SI = d_probeVars[admsProbeID_V_DI_SI][admsProbeID_V_DI_SI];
        Vds = (probeVars[admsProbeID_V_DI_SI]);

        d_Vsb_dV_DI_SI =  0.0;
        d_Vsb_dV_SI_BP = d_probeVars[admsProbeID_V_SI_BP][admsProbeID_V_SI_BP];
        Vsb = (probeVars[admsProbeID_V_SI_BP]);

        d_Vjun_s_dV_SI_BS = (-d_probeVars[admsProbeID_V_SI_BS][admsProbeID_V_SI_BS]);
        Vjun_s = (-(probeVars[admsProbeID_V_SI_BS]));

        d_Vjun_d_dV_DI_BD = (-d_probeVars[admsProbeID_V_DI_BD][admsProbeID_V_DI_BD]);
        Vjun_d = (-(probeVars[admsProbeID_V_DI_BD]));
      }
      else
      {

        d_Vgs_dV_DI_SI =  0.0;
        d_Vgs_dV_GP_SI = (-d_probeVars[admsProbeID_V_GP_SI][admsProbeID_V_GP_SI]);
        Vgs = (-(probeVars[admsProbeID_V_GP_SI]));

        d_Vds_dV_DI_SI = (-d_probeVars[admsProbeID_V_DI_SI][admsProbeID_V_DI_SI]);
        Vds = (-(probeVars[admsProbeID_V_DI_SI]));

        d_Vsb_dV_DI_SI =  0.0;
        d_Vsb_dV_SI_BP = (-d_probeVars[admsProbeID_V_SI_BP][admsProbeID_V_SI_BP]);
        Vsb = (-(probeVars[admsProbeID_V_SI_BP]));

        d_Vjun_s_dV_SI_BS = d_probeVars[admsProbeID_V_SI_BS][admsProbeID_V_SI_BS];
        Vjun_s = (probeVars[admsProbeID_V_SI_BS]);

        d_Vjun_d_dV_DI_BD = d_probeVars[admsProbeID_V_DI_BD][admsProbeID_V_DI_BD];
        Vjun_d = (probeVars[admsProbeID_V_DI_BD]);
      }

      d_VgsPrime_dV_GP_SI = d_Vgs_dV_GP_SI;
      VgsPrime = Vgs;

      d_VsbPrime_dV_SI_BP = d_Vsb_dV_SI_BP;
      VsbPrime = Vsb;

      d_VdbPrime_dV_SI_BP = d_Vsb_dV_SI_BP;
      d_VdbPrime_dV_DI_SI = (d_Vds_dV_DI_SI+d_Vsb_dV_DI_SI);
      VdbPrime = (Vds+Vsb);

      d_VgdPrime_dV_DI_SI = (d_Vgs_dV_DI_SI-d_Vds_dV_DI_SI);
      d_VgdPrime_dV_GP_SI = d_Vgs_dV_GP_SI;
      VgdPrime = (Vgs-Vds);

      d_xgs_ov_dV_GP_SI = ((-d_VgsPrime_dV_GP_SI)*(model_.inv_phita));
      xgs_ov = ((-VgsPrime)*(model_.inv_phita));

      d_xgd_ov_dV_DI_SI = ((-d_VgdPrime_dV_DI_SI)*(model_.inv_phita));
      d_xgd_ov_dV_GP_SI = ((-d_VgdPrime_dV_GP_SI)*(model_.inv_phita));
      xgd_ov = ((-VgdPrime)*(model_.inv_phita));
      sigVds = 1.0;
      if ((Vds<0.0))
      {
        sigVds = (-1.0);

        d_Vgs_dV_DI_SI = (d_Vgs_dV_DI_SI-d_Vds_dV_DI_SI);
        Vgs = (Vgs-Vds);

        d_Vsb_dV_DI_SI = (d_Vsb_dV_DI_SI+d_Vds_dV_DI_SI);
        Vsb = (Vsb+Vds);

        d_Vds_dV_DI_SI = (-d_Vds_dV_DI_SI);
        Vds = (-Vds);
      }

      d_Vdb_dV_SI_BP = d_Vsb_dV_SI_BP;
      d_Vdb_dV_DI_SI = (d_Vds_dV_DI_SI+d_Vsb_dV_DI_SI);
      Vdb = (Vds+Vsb);
      {
        double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_Vdsx_dV_DI_SI = (((value_sqrt_0+0.1)*((Vds*d_Vds_dV_DI_SI)+(d_Vds_dV_DI_SI*Vds))-(Vds*Vds)*(deriv_sqrt_0_d0*(((Vds*d_Vds_dV_DI_SI)+(d_Vds_dV_DI_SI*Vds)))))/(value_sqrt_0+0.1)/(value_sqrt_0+0.1));
        Vdsx = ((Vds*Vds)/(value_sqrt_0+0.1));
      }
      //Begin block SPcalc_dc
      {
        //Block-local variables for block SPcalc_dc
        double phib;
        double G_0;
        double Vsbstar;
        double d_Vsbstar_dV_DI_SI;
        double d_Vsbstar_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        double Vsbx;
        double d_Vsbx_dV_DI_SI;
        double d_Vsbx_dV_SI_BP;
        double xg;
        double d_xg_dV_DI_SI;
        double d_xg_dV_GP_SI;
        double d_xg_dV_SI_BP;
        double Dnsub;
        double d_Dnsub_dV_DI_SI;
        double d_Dnsub_dV_GP_SI;
        double d_Dnsub_dV_SI_BP;
        double Gf;
        double d_Gf_dV_DI_SI;
        double d_Gf_dV_GP_SI;
        double d_Gf_dV_SI_BP;
        double Gf2;
        double d_Gf2_dV_DI_SI;
        double d_Gf2_dV_GP_SI;
        double d_Gf2_dV_SI_BP;
        double inv_Gf2;
        double d_inv_Gf2_dV_DI_SI;
        double d_inv_Gf2_dV_GP_SI;
        double d_inv_Gf2_dV_SI_BP;
        double xi;
        double d_xi_dV_DI_SI;
        double d_xi_dV_GP_SI;
        double d_xi_dV_SI_BP;
        double inv_xi;
        double d_inv_xi_dV_DI_SI;
        double d_inv_xi_dV_GP_SI;
        double d_inv_xi_dV_SI_BP;
        double Ux;
        double d_Ux_dV_DI_SI;
        double d_Ux_dV_SI_BP;
        double xn_s;
        double d_xn_s_dV_DI_SI;
        double d_xn_s_dV_SI_BP;
        double delta_ns;
        double d_delta_ns_dV_DI_SI;
        double d_delta_ns_dV_SI_BP;
        double margin;
        double d_margin_dV_DI_SI;
        double d_margin_dV_GP_SI;
        double d_margin_dV_SI_BP;
        double x_s;
        double d_x_s_dV_DI_SI;
        double d_x_s_dV_GP_SI;
        double d_x_s_dV_SI_BP;
        double delta_1s;
        double d_delta_1s_dV_DI_SI;
        double d_delta_1s_dV_GP_SI;
        double d_delta_1s_dV_SI_BP;
        double xi0s;
        double d_xi0s_dV_DI_SI;
        double d_xi0s_dV_GP_SI;
        double d_xi0s_dV_SI_BP;
        double xi1s;
        double d_xi1s_dV_DI_SI;
        double d_xi1s_dV_GP_SI;
        double d_xi1s_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        double xi2s;
        double d_xi2s_dV_GP_SI;
        double d_xi2s_dV_DI_SI;
        double d_xi2s_dV_SI_BP;
        double Es;
        double d_Es_dV_DI_SI;
        double d_Es_dV_GP_SI;
        double d_Es_dV_SI_BP;
        double Ds;
        double d_Ds_dV_DI_SI;
        double d_Ds_dV_GP_SI;
        double d_Ds_dV_SI_BP;
        double Ps;
        double d_Ps_dV_DI_SI;
        double d_Ps_dV_GP_SI;
        double d_Ps_dV_SI_BP;
        double Rxcor;
        double d_Rxcor_dV_DI_SI;
        double d_Rxcor_dV_SI_BP;
        double xgs;
        double d_xgs_dV_DI_SI;
        double d_xgs_dV_GP_SI;
        double d_xgs_dV_SI_BP;
        double qis;
        double d_qis_dV_DI_SI;
        double d_qis_dV_GP_SI;
        double d_qis_dV_SI_BP;
        double qbs;
        double d_qbs_dV_DI_SI;
        double d_qbs_dV_GP_SI;
        double d_qbs_dV_SI_BP;
        double rhob;
        double d_rhob_dV_DI_SI;
        double d_rhob_dV_SI_BP;
        double GR;
        double d_GR_dV_DI_SI;
        double d_GR_dV_SI_BP;
        double d_GR_dV_GP_SI;
        double Eeffm;
        double d_Eeffm_dV_DI_SI;
        double d_Eeffm_dV_GP_SI;
        double d_Eeffm_dV_SI_BP;
        double Mutmp;
        double d_Mutmp_dV_DI_SI;
        double d_Mutmp_dV_GP_SI;
        double d_Mutmp_dV_SI_BP;
        double Gmob;
        double d_Gmob_dV_DI_SI;
        double d_Gmob_dV_GP_SI;
        double d_Gmob_dV_SI_BP;
        double xitsb;
        double d_xitsb_dV_DI_SI;
        double d_xitsb_dV_SI_BP;
        double wsat;
        double d_wsat_dV_DI_SI;
        double d_wsat_dV_GP_SI;
        double d_wsat_dV_SI_BP;
        double thesat1;
        double d_thesat1_dV_GP_SI;
        double d_thesat1_dV_DI_SI;
        double d_thesat1_dV_SI_BP;
        double phi_inf;
        double d_phi_inf_dV_DI_SI;
        double d_phi_inf_dV_GP_SI;
        double d_phi_inf_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        double ysat;
        double d_ysat_dV_GP_SI;
        double d_ysat_dV_DI_SI;
        double d_ysat_dV_SI_BP;
        double za;
        double d_za_dV_GP_SI;
        double d_za_dV_DI_SI;
        double d_za_dV_SI_BP;
        double Phi_0;
        double d_Phi_0_dV_DI_SI;
        double d_Phi_0_dV_GP_SI;
        double d_Phi_0_dV_SI_BP;
        double asat;
        double d_asat_dV_DI_SI;
        double d_asat_dV_GP_SI;
        double d_asat_dV_SI_BP;
        double Phi_2;
        double d_Phi_2_dV_DI_SI;
        double d_Phi_2_dV_GP_SI;
        double d_Phi_2_dV_SI_BP;
        double Phi_0_2;
        double d_Phi_0_2_dV_DI_SI;
        double d_Phi_0_2_dV_GP_SI;
        double d_Phi_0_2_dV_SI_BP;
        double Phi0_Phi2;
        double d_Phi0_Phi2_dV_DI_SI;
        double d_Phi0_Phi2_dV_GP_SI;
        double d_Phi0_Phi2_dV_SI_BP;
        double Phi_sat;
        double d_Phi_sat_dV_DI_SI;
        double d_Phi_sat_dV_GP_SI;
        double d_Phi_sat_dV_SI_BP;
        double Vdse;
        double d_Vdse_dV_GP_SI;
        double d_Vdse_dV_SI_BP;
        double d_Vdse_dV_DI_SI;
        double Udse;
        double d_Udse_dV_GP_SI;
        double d_Udse_dV_SI_BP;
        double d_Udse_dV_DI_SI;
        double xn_d;
        double d_xn_d_dV_DI_SI;
        double d_xn_d_dV_SI_BP;
        double d_xn_d_dV_GP_SI;
        double k_ds;
        double d_k_ds_dV_GP_SI;
        double d_k_ds_dV_SI_BP;
        double d_k_ds_dV_DI_SI;
        double delta_nd;
        double d_delta_nd_dV_DI_SI;
        double d_delta_nd_dV_SI_BP;
        double d_delta_nd_dV_GP_SI;
        double x_d;
        double d_x_d_dV_DI_SI;
        double d_x_d_dV_GP_SI;
        double d_x_d_dV_SI_BP;
        double x_ds;
        double d_x_ds_dV_DI_SI;
        double d_x_ds_dV_GP_SI;
        double d_x_ds_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        double pC;
        double d_pC_dV_DI_SI;
        double d_pC_dV_GP_SI;
        double d_pC_dV_SI_BP;
        double qC;
        double d_qC_dV_DI_SI;
        double d_qC_dV_GP_SI;
        double d_qC_dV_SI_BP;
        double dps;
        double d_dps_dV_DI_SI;
        double d_dps_dV_GP_SI;
        double d_dps_dV_SI_BP;
        double xi0d;
        double d_xi0d_dV_DI_SI;
        double d_xi0d_dV_GP_SI;
        double d_xi0d_dV_SI_BP;
        double Ed;
        double d_Ed_dV_DI_SI;
        double d_Ed_dV_GP_SI;
        double d_Ed_dV_SI_BP;
        double Dd;
        double d_Dd_dV_DI_SI;
        double d_Dd_dV_GP_SI;
        double d_Dd_dV_SI_BP;
        double x_m;
        double d_x_m_dV_DI_SI;
        double d_x_m_dV_GP_SI;
        double d_x_m_dV_SI_BP;
        double Em;
        double d_Em_dV_DI_SI;
        double d_Em_dV_GP_SI;
        double d_Em_dV_SI_BP;
        double D_bar;
        double d_D_bar_dV_DI_SI;
        double d_D_bar_dV_GP_SI;
        double d_D_bar_dV_SI_BP;
        double Dm;
        double d_Dm_dV_DI_SI;
        double d_Dm_dV_GP_SI;
        double d_Dm_dV_SI_BP;
        double Pm;
        double d_Pm_dV_DI_SI;
        double d_Pm_dV_GP_SI;
        double d_Pm_dV_SI_BP;
        double xgm;
        double d_xgm_dV_DI_SI;
        double d_xgm_dV_GP_SI;
        double d_xgm_dV_SI_BP;
        double eta_p;
        double d_eta_p_dV_DI_SI;
        double d_eta_p_dV_GP_SI;
        double d_eta_p_dV_SI_BP;
        double sqm;
        double d_sqm_dV_DI_SI;
        double d_sqm_dV_GP_SI;
        double d_sqm_dV_SI_BP;
        double alpha;
        double d_alpha_dV_DI_SI;
        double d_alpha_dV_GP_SI;
        double d_alpha_dV_SI_BP;
        double d0;
        double d_d0_dV_DI_SI;
        double d_d0_dV_GP_SI;
        double d_d0_dV_SI_BP;
        double x_pm;
        double d_x_pm_dV_GP_SI;
        double d_x_pm_dV_DI_SI;
        double d_x_pm_dV_SI_BP;
        double p_pd;
        double d_p_pd_dV_DI_SI;
        double d_p_pd_dV_GP_SI;
        double d_p_pd_dV_SI_BP;
        double q_pd;
        double d_q_pd_dV_GP_SI;
        double d_q_pd_dV_DI_SI;
        double d_q_pd_dV_SI_BP;
        double xi_pd;
        double d_xi_pd_dV_DI_SI;
        double d_xi_pd_dV_GP_SI;
        double d_xi_pd_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        double u_pd;
        double d_u_pd_dV_GP_SI;
        double d_u_pd_dV_DI_SI;
        double d_u_pd_dV_SI_BP;
        double km;
        double d_km_dV_GP_SI;
        double d_km_dV_DI_SI;
        double d_km_dV_SI_BP;
        double km0;
        double d_km0_dV_DI_SI;
        double d_km0_dV_GP_SI;
        double d_km0_dV_SI_BP;
        double qim;
        double d_qim_dV_DI_SI;
        double d_qim_dV_SI_BP;
        double d_qim_dV_GP_SI;
        double qim1;
        double d_qim1_dV_DI_SI;
        double d_qim1_dV_SI_BP;
        double d_qim1_dV_GP_SI;
        double qbm;
        double d_qbm_dV_DI_SI;
        double d_qbm_dV_GP_SI;
        double d_qbm_dV_SI_BP;
        double qeff;
        double d_qeff_dV_DI_SI;
        double d_qeff_dV_GP_SI;
        double d_qeff_dV_SI_BP;
        double qeff1;
        double d_qeff1_dV_DI_SI;
        double d_qeff1_dV_GP_SI;
        double d_qeff1_dV_SI_BP;
        double s1;
        double d_s1_dV_DI_SI;
        double d_s1_dV_GP_SI;
        double d_s1_dV_SI_BP;
        double dL;
        double d_dL_dV_DI_SI;
        double d_dL_dV_GP_SI;
        double d_dL_dV_SI_BP;
        double GdL;
        double d_GdL_dV_DI_SI;
        double d_GdL_dV_GP_SI;
        double d_GdL_dV_SI_BP;
        double Gmob_dL;
        double d_Gmob_dL_dV_DI_SI;
        double d_Gmob_dL_dV_GP_SI;
        double d_Gmob_dL_dV_SI_BP;
        double zsat;
        double d_zsat_dV_GP_SI;
        double d_zsat_dV_DI_SI;
        double d_zsat_dV_SI_BP;
        double Gvsat;
        double d_Gvsat_dV_DI_SI;
        double d_Gvsat_dV_GP_SI;
        double d_Gvsat_dV_SI_BP;
        double Gvsatinv;
        double d_Gvsatinv_dV_DI_SI;
        double d_Gvsatinv_dV_GP_SI;
        double d_Gvsatinv_dV_SI_BP;
        double Voxm;
        double d_Voxm_dV_DI_SI;
        double d_Voxm_dV_GP_SI;
        double d_Voxm_dV_SI_BP;
        double alpha1;
        double d_alpha1_dV_DI_SI;
        double d_alpha1_dV_GP_SI;
        double d_alpha1_dV_SI_BP;
        double H;
        double d_H_dV_GP_SI;
        double d_H_dV_DI_SI;
        double d_H_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        double SP_S_temp;
        double d_SP_S_temp_dV_DI_SI;
        double d_SP_S_temp_dV_GP_SI;
        double d_SP_S_temp_dV_SI_BP;
        double SP_S_temp1;
        double d_SP_S_temp1_dV_DI_SI;
        double d_SP_S_temp1_dV_GP_SI;
        double d_SP_S_temp1_dV_SI_BP;
        double SP_S_temp2;
        double d_SP_S_temp2_dV_DI_SI;
        double d_SP_S_temp2_dV_GP_SI;
        double d_SP_S_temp2_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        double SP_S_yg;
        double d_SP_S_yg_dV_DI_SI;
        double d_SP_S_yg_dV_GP_SI;
        double d_SP_S_yg_dV_SI_BP;
        double SP_S_ysub;
        double d_SP_S_ysub_dV_DI_SI;
        double d_SP_S_ysub_dV_GP_SI;
        double d_SP_S_ysub_dV_SI_BP;
        double SP_S_eta;
        double d_SP_S_eta_dV_DI_SI;
        double d_SP_S_eta_dV_GP_SI;
        double d_SP_S_eta_dV_SI_BP;
        double SP_S_a;
        double d_SP_S_a_dV_DI_SI;
        double d_SP_S_a_dV_GP_SI;
        double d_SP_S_a_dV_SI_BP;
        double SP_S_c;
        double d_SP_S_c_dV_DI_SI;
        double d_SP_S_c_dV_GP_SI;
        double d_SP_S_c_dV_SI_BP;
        double SP_S_tau;
        double d_SP_S_tau_dV_DI_SI;
        double d_SP_S_tau_dV_GP_SI;
        double d_SP_S_tau_dV_SI_BP;
        double SP_S_y0;
        double d_SP_S_y0_dV_DI_SI;
        double d_SP_S_y0_dV_GP_SI;
        double d_SP_S_y0_dV_SI_BP;
        double SP_S_delta0;
        double d_SP_S_delta0_dV_DI_SI;
        double d_SP_S_delta0_dV_GP_SI;
        double d_SP_S_delta0_dV_SI_BP;
        double SP_S_delta1;
        double d_SP_S_delta1_dV_DI_SI;
        double d_SP_S_delta1_dV_GP_SI;
        double d_SP_S_delta1_dV_SI_BP;
        double SP_S_xi0;
        double d_SP_S_xi0_dV_DI_SI;
        double d_SP_S_xi0_dV_GP_SI;
        double d_SP_S_xi0_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        double SP_S_xi1;
        double d_SP_S_xi1_dV_DI_SI;
        double d_SP_S_xi1_dV_GP_SI;
        double d_SP_S_xi1_dV_SI_BP;
        double SP_S_xi2;
        double d_SP_S_xi2_dV_DI_SI;
        double d_SP_S_xi2_dV_GP_SI;
        double d_SP_S_xi2_dV_SI_BP;
        double SP_S_pC;
        double d_SP_S_pC_dV_DI_SI;
        double d_SP_S_pC_dV_GP_SI;
        double d_SP_S_pC_dV_SI_BP;
        double SP_S_qC;
        double d_SP_S_qC_dV_DI_SI;
        double d_SP_S_qC_dV_GP_SI;
        double d_SP_S_qC_dV_SI_BP;
        double SP_xg1;
        double d_SP_xg1_dV_DI_SI;
        double d_SP_xg1_dV_GP_SI;
        double d_SP_xg1_dV_SI_BP;
        double SP_S_A_fac;
        double d_SP_S_A_fac_dV_DI_SI;
        double d_SP_S_A_fac_dV_GP_SI;
        double d_SP_S_A_fac_dV_SI_BP;
        double SP_S_xbar;
        double d_SP_S_xbar_dV_DI_SI;
        double d_SP_S_xbar_dV_GP_SI;
        double d_SP_S_xbar_dV_SI_BP;
        double SP_S_w;
        double d_SP_S_w_dV_DI_SI;
        double d_SP_S_w_dV_GP_SI;
        double d_SP_S_w_dV_SI_BP;
        double SP_S_x1;
        double d_SP_S_x1_dV_DI_SI;
        double d_SP_S_x1_dV_GP_SI;
        double d_SP_S_x1_dV_SI_BP;
        double SP_S_bx;
        double d_SP_S_bx_dV_GP_SI;
        double d_SP_S_bx_dV_DI_SI;
        double d_SP_S_bx_dV_SI_BP;
        double SP_S_b;
        double d_SP_S_b_dV_DI_SI;
        double d_SP_S_b_dV_GP_SI;
        double d_SP_S_b_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        double SP_S_x0;
        double d_SP_S_x0_dV_DI_SI;
        double d_SP_S_x0_dV_GP_SI;
        double d_SP_S_x0_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        double FdL;
        double d_FdL_dV_DI_SI;
        double d_FdL_dV_GP_SI;
        double d_FdL_dV_SI_BP;
        double qim1_1;
        double d_qim1_1_dV_DI_SI;
        double d_qim1_1_dV_SI_BP;
        double d_qim1_1_dV_GP_SI;
        double r1;
        double d_r1_dV_DI_SI;
        double d_r1_dV_SI_BP;
        double d_r1_dV_GP_SI;
        double r2;
        double d_r2_dV_DI_SI;
        double d_r2_dV_SI_BP;
        double d_r2_dV_GP_SI;
        double s2;
        double d_s2_dV_DI_SI;
        double dL1;
        double d_dL1_dV_DI_SI;
        double d_dL1_dV_GP_SI;
        double d_dL1_dV_SI_BP;
        //End of Block-local variables
        {
          double value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+bphi_dc));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_temp_dV_GP_SI =  0.0;
          d_temp_dV_SI_BP = (0.5*((d_Vdb_dV_SI_BP+d_Vsb_dV_SI_BP)-(deriv_sqrt_0_d0*((((Vdb-Vsb)*(d_Vdb_dV_SI_BP-d_Vsb_dV_SI_BP))+((d_Vdb_dV_SI_BP-d_Vsb_dV_SI_BP)*(Vdb-Vsb)))))));
          d_temp_dV_DI_SI = (0.5*((d_Vdb_dV_DI_SI+d_Vsb_dV_DI_SI)-(deriv_sqrt_0_d0*((((Vdb-Vsb)*(d_Vdb_dV_DI_SI-d_Vsb_dV_DI_SI))+((d_Vdb_dV_DI_SI-d_Vsb_dV_DI_SI)*(Vdb-Vsb)))))));
          temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+phix_dc);
        }
        {
          double value_sqrt_0 = sqrt((((temp)*(temp))+aphi_dc));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_Vsbstar_dc_dV_SI_BP = (d_Vsb_dV_SI_BP-(0.5*((d_temp_dV_SI_BP)-(deriv_sqrt_0_d0*((((temp)*(d_temp_dV_SI_BP))+((d_temp_dV_SI_BP)*(temp))))))));
          d_Vsbstar_dc_dV_DI_SI = (d_Vsb_dV_DI_SI-(0.5*((d_temp_dV_DI_SI)-(deriv_sqrt_0_d0*((((temp)*(d_temp_dV_DI_SI))+((d_temp_dV_DI_SI)*(temp))))))));
          Vsbstar_dc = ((Vsb-(0.5*((temp)-value_sqrt_0)))+phix1_dc);
        }

        d_Vsbstar_dc_tmp_dV_SI_BP = d_Vsbstar_dc_dV_SI_BP;
        d_Vsbstar_dc_tmp_dV_DI_SI = d_Vsbstar_dc_dV_DI_SI;
        Vsbstar_dc_tmp = Vsbstar_dc;
        if ((((model_.SWNUD_i)!=0)&&(GFACNUD_i!=1.0)))
        {

          d_Vmb_dV_SI_BP = d_Vsbstar_dc_dV_SI_BP;
          d_Vmb_dV_DI_SI = (d_Vsbstar_dc_dV_DI_SI+(0.5*(d_Vds_dV_DI_SI-d_Vdsx_dV_DI_SI)));
          Vmb = (Vsbstar_dc+(0.5*(Vds-Vdsx)));
          {
            double value_sqrt_0 = sqrt((Vmb+phib_dc));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_us_dV_SI_BP = (deriv_sqrt_0_d0*(d_Vmb_dV_SI_BP));
            d_us_dV_DI_SI = (deriv_sqrt_0_d0*(d_Vmb_dV_DI_SI));
            us = (value_sqrt_0-sqrt_phib_dc);
          }

          d_temp_dV_GP_SI =  0.0;
          d_temp_dV_SI_BP = ((2.0*d_us_dV_SI_BP)/us21);
          d_temp_dV_DI_SI = ((2.0*d_us_dV_DI_SI)/us21);
          temp = (((2.0*(us-us1))/us21)-1.0);
          {
            double value_sqrt_0 = sqrt(((temp*temp)+0.4804530139182));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_usnew_dV_SI_BP = (d_us_dV_SI_BP-(((0.25*(1.0-GFACNUD_i))*us21)*(d_temp_dV_SI_BP+(deriv_sqrt_0_d0*(((temp*d_temp_dV_SI_BP)+(d_temp_dV_SI_BP*temp)))))));
            d_usnew_dV_DI_SI = (d_us_dV_DI_SI-(((0.25*(1.0-GFACNUD_i))*us21)*(d_temp_dV_DI_SI+(deriv_sqrt_0_d0*(((temp*d_temp_dV_DI_SI)+(d_temp_dV_DI_SI*temp)))))));
            usnew = (us-(((0.25*(1.0-GFACNUD_i))*us21)*(temp+value_sqrt_0)));
          }

          d_Vmbnew_dV_SI_BP = (((usnew*d_usnew_dV_SI_BP)+(d_usnew_dV_SI_BP*usnew))+((2.0*sqrt_phib_dc)*d_usnew_dV_SI_BP));
          d_Vmbnew_dV_DI_SI = (((usnew*d_usnew_dV_DI_SI)+(d_usnew_dV_DI_SI*usnew))+((2.0*sqrt_phib_dc)*d_usnew_dV_DI_SI));
          Vmbnew = ((usnew*usnew)+((2.0*sqrt_phib_dc)*usnew));

          d_Vsbstar_dc_dV_SI_BP = d_Vmbnew_dV_SI_BP;
          d_Vsbstar_dc_dV_DI_SI = (d_Vmbnew_dV_DI_SI-(0.5*(d_Vds_dV_DI_SI-d_Vdsx_dV_DI_SI)));
          Vsbstar_dc = (Vmbnew-(0.5*(Vds-Vdsx)));
        }
        phib = phib_dc;
        G_0 = G_0_dc;

        d_Vsbstar_dV_SI_BP = d_Vsbstar_dc_dV_SI_BP;
        d_Vsbstar_dV_DI_SI = d_Vsbstar_dc_dV_DI_SI;
        Vsbstar = Vsbstar_dc;

        d_FdL_dV_DI_SI = d_FdL_dV_GP_SI = d_FdL_dV_SI_BP =  0.0;
        FdL = 1.0;

        d_alpha_dV_DI_SI = d_alpha_dV_GP_SI = d_alpha_dV_SI_BP =  0.0;
        alpha = 0.0;

        d_GdL_dV_DI_SI = d_GdL_dV_GP_SI = d_GdL_dV_SI_BP =  0.0;
        GdL = 1.0;

        d_dL_dV_DI_SI = d_dL_dV_GP_SI = d_dL_dV_SI_BP =  0.0;
        dL = 0.0;

        d_qbm_dV_DI_SI = d_qbm_dV_GP_SI = d_qbm_dV_SI_BP =  0.0;
        qbm = 0.0;

        d_dps_dV_DI_SI = d_dps_dV_GP_SI = d_dps_dV_SI_BP =  0.0;
        dps = 0.0;

        d_qim_dV_DI_SI = d_qim_dV_SI_BP = d_qim_dV_GP_SI =  0.0;
        qim = 0.0;

        d_qim1_dV_DI_SI = d_qim1_dV_SI_BP = d_qim1_dV_GP_SI =  0.0;
        qim1 = 0.0;

        d_H_dV_GP_SI = d_H_dV_DI_SI = d_H_dV_SI_BP =  0.0;
        H = 1.0;

        d_s1_dV_DI_SI = d_s1_dV_GP_SI = d_s1_dV_SI_BP =  0.0;
        s1 = 0.0;

        d_eta_p_dV_DI_SI = d_eta_p_dV_GP_SI = d_eta_p_dV_SI_BP =  0.0;
        eta_p = 1.0;

        d_Gvsat_dV_DI_SI = d_Gvsat_dV_GP_SI = d_Gvsat_dV_SI_BP =  0.0;
        Gvsat = 1.0;

        d_Gvsatinv_dV_DI_SI = d_Gvsatinv_dV_GP_SI = d_Gvsatinv_dV_SI_BP =  0.0;
        Gvsatinv = 1.0;

        d_SP_S_x1_dV_DI_SI = d_SP_S_x1_dV_GP_SI = d_SP_S_x1_dV_SI_BP =  0.0;
        SP_S_x1 = 0.0;

        d_x_s_dV_DI_SI = d_x_s_dV_GP_SI = d_x_s_dV_SI_BP =  0.0;
        x_s = 0.0;

        d_sqm_dV_DI_SI = d_sqm_dV_GP_SI = d_sqm_dV_SI_BP =  0.0;
        sqm = 0.0;

        d_xitsb_dV_DI_SI = d_xitsb_dV_SI_BP =  0.0;
        xitsb = 0.0;

        d_rhob_dV_DI_SI = d_rhob_dV_SI_BP =  0.0;
        rhob = 0.0;

        d_Gmob_dV_DI_SI = d_Gmob_dV_GP_SI = d_Gmob_dV_SI_BP =  0.0;
        Gmob = 1.0;

        d_Gmob_dL_dV_DI_SI = d_Gmob_dL_dV_GP_SI = d_Gmob_dL_dV_SI_BP =  0.0;
        Gmob_dL = 1.0;

        d_Udse_dV_GP_SI = d_Udse_dV_SI_BP = d_Udse_dV_DI_SI =  0.0;
        Udse = 0.0;

        d_thesat1_dV_GP_SI = d_thesat1_dV_DI_SI = d_thesat1_dV_SI_BP =  0.0;
        thesat1 = 0.0;

        d_xgm_dV_DI_SI = d_xgm_dV_GP_SI = d_xgm_dV_SI_BP =  0.0;
        xgm = 0.0;

        d_Vgbstar_dV_SI_BP = d_Vsbstar_dV_SI_BP;
        d_Vgbstar_dV_GP_SI = d_Vgs_dV_GP_SI;
        d_Vgbstar_dV_DI_SI = (d_Vgs_dV_DI_SI+d_Vsbstar_dV_DI_SI);
        Vgbstar = (Vgs+Vsbstar);

        d_Vgb1_dV_SI_BP = d_Vgbstar_dV_SI_BP;
        d_Vgb1_dV_GP_SI = d_Vgbstar_dV_GP_SI;
        d_Vgb1_dV_DI_SI = d_Vgbstar_dV_DI_SI;
        Vgb1 = (Vgbstar-VFB_T);

        d_Vsbx_dV_SI_BP = d_Vsbstar_dV_SI_BP;
        d_Vsbx_dV_DI_SI = (d_Vsbstar_dV_DI_SI+(0.5*(d_Vds_dV_DI_SI-d_Vdsx_dV_DI_SI)));
        Vsbx = (Vsbstar+(0.5*(Vds-Vdsx)));
        if ((CFD_i<1.0e-10))
        {

          d_Vdsp_dV_DI_SI = d_Vdsx_dV_DI_SI;
          Vdsp = Vdsx;
        }
        else
        {
          {
            double value_sqrt_0 = sqrt((1.0+(CFD_i*Vdsx)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Vdsp_dV_DI_SI = ((2.0*(deriv_sqrt_0_d0*((CFD_i*d_Vdsx_dV_DI_SI))))/CFD_i);
            Vdsp = ((2.0*(value_sqrt_0-1.0))/CFD_i);
          }
        }

        d_delVg_dV_GP_SI =  0.0;
        d_delVg_dV_SI_BP = ((CF_i*Vdsp)*(CFB_i*d_Vsbx_dV_SI_BP));
        d_delVg_dV_DI_SI = (((CF_i*Vdsp)*(CFB_i*d_Vsbx_dV_DI_SI))+((CF_i*d_Vdsp_dV_DI_SI)*(1.0+(CFB_i*Vsbx))));
        delVg = ((CF_i*Vdsp)*(1.0+(CFB_i*Vsbx)));

        d_dphit1_dV_GP_SI =  0.0;
        d_dphit1_dV_SI_BP = ((PSCE_i*(1.0+(PSCED_i*Vdsx)))*(PSCEB_i*d_Vsbx_dV_SI_BP));
        d_dphit1_dV_DI_SI = (((PSCE_i*(1.0+(PSCED_i*Vdsx)))*(PSCEB_i*d_Vsbx_dV_DI_SI))+((PSCE_i*(PSCED_i*d_Vdsx_dV_DI_SI))*(1.0+(PSCEB_i*Vsbx))));
        dphit1 = ((PSCE_i*(1.0+(PSCED_i*Vdsx)))*(1.0+(PSCEB_i*Vsbx)));

        d_phit1_dV_GP_SI =  0.0;
        d_phit1_dV_SI_BP = (phit0*d_dphit1_dV_SI_BP);
        d_phit1_dV_DI_SI = (phit0*d_dphit1_dV_DI_SI);
        phit1 = (phit0*(1.0+dphit1));

        d_inv_phit1_dV_GP_SI =  0.0;
        d_inv_phit1_dV_SI_BP = (-d_phit1_dV_SI_BP/phit1/phit1);
        d_inv_phit1_dV_DI_SI = (-d_phit1_dV_DI_SI/phit1/phit1);
        inv_phit1 = (1.0/phit1);

        d_Vgb1_dV_SI_BP = (d_Vgb1_dV_SI_BP+d_delVg_dV_SI_BP);
        d_Vgb1_dV_GP_SI = (d_Vgb1_dV_GP_SI+d_delVg_dV_GP_SI);
        d_Vgb1_dV_DI_SI = (d_Vgb1_dV_DI_SI+d_delVg_dV_DI_SI);
        Vgb1 = (Vgb1+delVg);

        d_xg_dV_SI_BP = ((Vgb1*d_inv_phit1_dV_SI_BP)+(d_Vgb1_dV_SI_BP*inv_phit1));
        d_xg_dV_GP_SI = ((Vgb1*d_inv_phit1_dV_GP_SI)+(d_Vgb1_dV_GP_SI*inv_phit1));
        d_xg_dV_DI_SI = ((Vgb1*d_inv_phit1_dV_DI_SI)+(d_Vgb1_dV_DI_SI*inv_phit1));
        xg = (Vgb1*inv_phit1);
        if ((DNSUB_i>0.0))
        {
          {
            double value_sqrt_0 = sqrt((((-((Vgs+Vsb)-VNSUB_i))*(-((Vgs+Vsb)-VNSUB_i)))+NSLP_i));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Dnsub_dV_SI_BP = ((DNSUB_i*0.5)*((+d_Vsb_dV_SI_BP)+(deriv_sqrt_0_d0*((((-((Vgs+Vsb)-VNSUB_i))*(-d_Vsb_dV_SI_BP))+((-d_Vsb_dV_SI_BP)*(-((Vgs+Vsb)-VNSUB_i))))))));
            d_Dnsub_dV_GP_SI = ((DNSUB_i*0.5)*((+d_Vgs_dV_GP_SI)+(deriv_sqrt_0_d0*((((-((Vgs+Vsb)-VNSUB_i))*(-d_Vgs_dV_GP_SI))+((-d_Vgs_dV_GP_SI)*(-((Vgs+Vsb)-VNSUB_i))))))));
            d_Dnsub_dV_DI_SI = ((DNSUB_i*0.5)*((+(d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI))+(deriv_sqrt_0_d0*((((-((Vgs+Vsb)-VNSUB_i))*(-(d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI)))+((-(d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI))*(-((Vgs+Vsb)-VNSUB_i))))))));
            Dnsub = ((DNSUB_i*0.5)*((+((Vgs+Vsb)-VNSUB_i))+value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt((1.0+Dnsub));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Gf_dV_SI_BP = (G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_SI_BP)));
            d_Gf_dV_GP_SI = (G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_GP_SI)));
            d_Gf_dV_DI_SI = (G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_DI_SI)));
            Gf = (G_0*value_sqrt_0);
          }
        }
        else
        {

          d_Gf_dV_DI_SI = d_Gf_dV_GP_SI = d_Gf_dV_SI_BP =  0.0;
          Gf = G_0;
        }

        d_Gf2_dV_SI_BP = ((Gf*d_Gf_dV_SI_BP)+(d_Gf_dV_SI_BP*Gf));
        d_Gf2_dV_GP_SI = ((Gf*d_Gf_dV_GP_SI)+(d_Gf_dV_GP_SI*Gf));
        d_Gf2_dV_DI_SI = ((Gf*d_Gf_dV_DI_SI)+(d_Gf_dV_DI_SI*Gf));
        Gf2 = (Gf*Gf);

        d_inv_Gf2_dV_SI_BP = (-d_Gf2_dV_SI_BP/Gf2/Gf2);
        d_inv_Gf2_dV_GP_SI = (-d_Gf2_dV_GP_SI/Gf2/Gf2);
        d_inv_Gf2_dV_DI_SI = (-d_Gf2_dV_DI_SI/Gf2/Gf2);
        inv_Gf2 = (1.0/Gf2);

        d_xi_dV_SI_BP = (d_Gf_dV_SI_BP*7.0710678118654746e-01);
        d_xi_dV_GP_SI = (d_Gf_dV_GP_SI*7.0710678118654746e-01);
        d_xi_dV_DI_SI = (d_Gf_dV_DI_SI*7.0710678118654746e-01);
        xi = (1.0+(Gf*7.0710678118654746e-01));

        d_inv_xi_dV_SI_BP = (-d_xi_dV_SI_BP/xi/xi);
        d_inv_xi_dV_GP_SI = (-d_xi_dV_GP_SI/xi/xi);
        d_inv_xi_dV_DI_SI = (-d_xi_dV_DI_SI/xi/xi);
        inv_xi = (1.0/xi);

        d_Ux_dV_SI_BP = ((Vsbstar*d_inv_phit1_dV_SI_BP)+(d_Vsbstar_dV_SI_BP*inv_phit1));
        d_Ux_dV_DI_SI = ((Vsbstar*d_inv_phit1_dV_DI_SI)+(d_Vsbstar_dV_DI_SI*inv_phit1));
        Ux = (Vsbstar*inv_phit1);

        d_xn_s_dV_SI_BP = ((phib*d_inv_phit1_dV_SI_BP)+d_Ux_dV_SI_BP);
        d_xn_s_dV_DI_SI = ((phib*d_inv_phit1_dV_DI_SI)+d_Ux_dV_DI_SI);
        xn_s = ((phib*inv_phit1)+Ux);
        if ((xn_s<4.6051701859880916e+02))
        {
          {
            double value_exp_0 = exp((-xn_s));
            double  deriv_exp_0_d0 = value_exp_0;

            d_delta_ns_dV_SI_BP = (deriv_exp_0_d0*((-d_xn_s_dV_SI_BP)));
            d_delta_ns_dV_DI_SI = (deriv_exp_0_d0*((-d_xn_s_dV_DI_SI)));
            delta_ns = value_exp_0;
          }
        }
        else
        {

          d_delta_ns_dV_SI_BP = (-1.0e-200*(((xn_s-4.6051701859880916e+02)*(0.5*(((xn_s-4.6051701859880916e+02)*(d_xn_s_dV_SI_BP*3.3333333333333333e-01))+(d_xn_s_dV_SI_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_xn_s_dV_SI_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
          d_delta_ns_dV_DI_SI = (-1.0e-200*(((xn_s-4.6051701859880916e+02)*(0.5*(((xn_s-4.6051701859880916e+02)*(d_xn_s_dV_DI_SI*3.3333333333333333e-01))+(d_xn_s_dV_DI_SI*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_xn_s_dV_DI_SI*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
          delta_ns = (1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
        }

        d_margin_dV_SI_BP = (1.0e-5*d_xi_dV_SI_BP);
        d_margin_dV_GP_SI = (1.0e-5*d_xi_dV_GP_SI);
        d_margin_dV_DI_SI = (1.0e-5*d_xi_dV_DI_SI);
        margin = (1.0e-5*xi);
        if ((fabs(xg)<=margin))
        {

          d_SP_S_temp1_dV_SI_BP = ((((inv_xi*d_inv_xi_dV_SI_BP)+(d_inv_xi_dV_SI_BP*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
          d_SP_S_temp1_dV_GP_SI = ((((inv_xi*d_inv_xi_dV_GP_SI)+(d_inv_xi_dV_GP_SI*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
          d_SP_S_temp1_dV_DI_SI = ((((inv_xi*d_inv_xi_dV_DI_SI)+(d_inv_xi_dV_DI_SI*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
          SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);

          d_x_s_dV_SI_BP = (((xg*inv_xi)*((((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_SI_BP)+((((xg*(1.0-delta_ns))*d_Gf_dV_SI_BP)+(((xg*(-d_delta_ns_dV_SI_BP))+(d_xg_dV_SI_BP*(1.0-delta_ns)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_SI_BP)+(d_xg_dV_SI_BP*inv_xi))*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1))));
          d_x_s_dV_GP_SI = (((xg*inv_xi)*((((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_GP_SI)+((((xg*(1.0-delta_ns))*d_Gf_dV_GP_SI)+((d_xg_dV_GP_SI*(1.0-delta_ns))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_GP_SI)+(d_xg_dV_GP_SI*inv_xi))*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1))));
          d_x_s_dV_DI_SI = (((xg*inv_xi)*((((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_DI_SI)+((((xg*(1.0-delta_ns))*d_Gf_dV_DI_SI)+(((xg*(-d_delta_ns_dV_DI_SI))+(d_xg_dV_DI_SI*(1.0-delta_ns)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_DI_SI)+(d_xg_dV_DI_SI*inv_xi))*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1))));
          x_s = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
        }
        else
        {
          if ((xg<(-margin)))
          {

            d_SP_S_yg_dV_SI_BP = (-d_xg_dV_SI_BP);
            d_SP_S_yg_dV_GP_SI = (-d_xg_dV_GP_SI);
            d_SP_S_yg_dV_DI_SI = (-d_xg_dV_DI_SI);
            SP_S_yg = (-xg);

            d_SP_S_ysub_dV_SI_BP = (1.25*((SP_S_yg*d_inv_xi_dV_SI_BP)+(d_SP_S_yg_dV_SI_BP*inv_xi)));
            d_SP_S_ysub_dV_GP_SI = (1.25*((SP_S_yg*d_inv_xi_dV_GP_SI)+(d_SP_S_yg_dV_GP_SI*inv_xi)));
            d_SP_S_ysub_dV_DI_SI = (1.25*((SP_S_yg*d_inv_xi_dV_DI_SI)+(d_SP_S_yg_dV_DI_SI*inv_xi)));
            SP_S_ysub = (1.25*(SP_S_yg*inv_xi));
            {
              double value_sqrt_0 = sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_SP_S_eta_dV_SI_BP = (0.5*(d_SP_S_ysub_dV_SI_BP-(deriv_sqrt_0_d0*((((SP_S_ysub-6.0)*d_SP_S_ysub_dV_SI_BP)+(d_SP_S_ysub_dV_SI_BP*(SP_S_ysub-6.0)))))));
              d_SP_S_eta_dV_GP_SI = (0.5*(d_SP_S_ysub_dV_GP_SI-(deriv_sqrt_0_d0*((((SP_S_ysub-6.0)*d_SP_S_ysub_dV_GP_SI)+(d_SP_S_ysub_dV_GP_SI*(SP_S_ysub-6.0)))))));
              d_SP_S_eta_dV_DI_SI = (0.5*(d_SP_S_ysub_dV_DI_SI-(deriv_sqrt_0_d0*((((SP_S_ysub-6.0)*d_SP_S_ysub_dV_DI_SI)+(d_SP_S_ysub_dV_DI_SI*(SP_S_ysub-6.0)))))));
              SP_S_eta = (0.5*((SP_S_ysub+10)-value_sqrt_0));
            }

            d_SP_S_temp_dV_SI_BP = (d_SP_S_yg_dV_SI_BP-d_SP_S_eta_dV_SI_BP);
            d_SP_S_temp_dV_GP_SI = (d_SP_S_yg_dV_GP_SI-d_SP_S_eta_dV_GP_SI);
            d_SP_S_temp_dV_DI_SI = (d_SP_S_yg_dV_DI_SI-d_SP_S_eta_dV_DI_SI);
            SP_S_temp = (SP_S_yg-SP_S_eta);

            d_SP_S_a_dV_SI_BP = (((SP_S_temp*d_SP_S_temp_dV_SI_BP)+(d_SP_S_temp_dV_SI_BP*SP_S_temp))+((Gf2*d_SP_S_eta_dV_SI_BP)+(d_Gf2_dV_SI_BP*(SP_S_eta+1.0))));
            d_SP_S_a_dV_GP_SI = (((SP_S_temp*d_SP_S_temp_dV_GP_SI)+(d_SP_S_temp_dV_GP_SI*SP_S_temp))+((Gf2*d_SP_S_eta_dV_GP_SI)+(d_Gf2_dV_GP_SI*(SP_S_eta+1.0))));
            d_SP_S_a_dV_DI_SI = (((SP_S_temp*d_SP_S_temp_dV_DI_SI)+(d_SP_S_temp_dV_DI_SI*SP_S_temp))+((Gf2*d_SP_S_eta_dV_DI_SI)+(d_Gf2_dV_DI_SI*(SP_S_eta+1.0))));
            SP_S_a = ((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0)));

            d_SP_S_c_dV_SI_BP = ((2.0*d_SP_S_temp_dV_SI_BP)-d_Gf2_dV_SI_BP);
            d_SP_S_c_dV_GP_SI = ((2.0*d_SP_S_temp_dV_GP_SI)-d_Gf2_dV_GP_SI);
            d_SP_S_c_dV_DI_SI = ((2.0*d_SP_S_temp_dV_DI_SI)-d_Gf2_dV_DI_SI);
            SP_S_c = ((2.0*SP_S_temp)-Gf2);
            {
              double value_log_0 = log((SP_S_a*inv_Gf2));
              double  deriv_log_0_d0 = (1.0/(SP_S_a*inv_Gf2));

              d_SP_S_tau_dV_SI_BP = ((-d_SP_S_eta_dV_SI_BP)+(deriv_log_0_d0*(((SP_S_a*d_inv_Gf2_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*inv_Gf2)))));
              d_SP_S_tau_dV_GP_SI = ((-d_SP_S_eta_dV_GP_SI)+(deriv_log_0_d0*(((SP_S_a*d_inv_Gf2_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*inv_Gf2)))));
              d_SP_S_tau_dV_DI_SI = ((-d_SP_S_eta_dV_DI_SI)+(deriv_log_0_d0*(((SP_S_a*d_inv_Gf2_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*inv_Gf2)))));
              SP_S_tau = ((-SP_S_eta)+value_log_0);
            }

            d_nu_dV_SI_BP = (d_SP_S_a_dV_SI_BP+d_SP_S_c_dV_SI_BP);
            d_nu_dV_GP_SI = (d_SP_S_a_dV_GP_SI+d_SP_S_c_dV_GP_SI);
            d_nu_dV_DI_SI = (d_SP_S_a_dV_DI_SI+d_SP_S_c_dV_DI_SI);
            nu = (SP_S_a+SP_S_c);

            d_mutau_dV_SI_BP = (((nu*d_nu_dV_SI_BP)+(d_nu_dV_SI_BP*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_SI_BP)+(d_SP_S_c_dV_SI_BP*SP_S_c)))-d_SP_S_a_dV_SI_BP))+(d_SP_S_tau_dV_SI_BP*((0.5*(SP_S_c*SP_S_c))-SP_S_a))));
            d_mutau_dV_GP_SI = (((nu*d_nu_dV_GP_SI)+(d_nu_dV_GP_SI*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_GP_SI)+(d_SP_S_c_dV_GP_SI*SP_S_c)))-d_SP_S_a_dV_GP_SI))+(d_SP_S_tau_dV_GP_SI*((0.5*(SP_S_c*SP_S_c))-SP_S_a))));
            d_mutau_dV_DI_SI = (((nu*d_nu_dV_DI_SI)+(d_nu_dV_DI_SI*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_DI_SI)+(d_SP_S_c_dV_DI_SI*SP_S_c)))-d_SP_S_a_dV_DI_SI))+(d_SP_S_tau_dV_DI_SI*((0.5*(SP_S_c*SP_S_c))-SP_S_a))));
            mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));

            d_SP_S_y0_dV_SI_BP = (d_SP_S_eta_dV_SI_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*(((SP_S_a*nu)*d_SP_S_tau_dV_SI_BP)+(((SP_S_a*d_nu_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_SI_BP+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_SI_BP)+(d_SP_S_c_dV_SI_BP*SP_S_c))*3.3333333333333333e-01)-d_SP_S_a_dV_SI_BP))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_SI_BP)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_SI_BP)+((((nu/mutau)*d_SP_S_tau_dV_SI_BP)+(((mutau*d_nu_dV_SI_BP-nu*d_mutau_dV_SI_BP)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
            d_SP_S_y0_dV_GP_SI = (d_SP_S_eta_dV_GP_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*(((SP_S_a*nu)*d_SP_S_tau_dV_GP_SI)+(((SP_S_a*d_nu_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_SI+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_GP_SI)+(d_SP_S_c_dV_GP_SI*SP_S_c))*3.3333333333333333e-01)-d_SP_S_a_dV_GP_SI))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_SI)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_SI)+((((nu/mutau)*d_SP_S_tau_dV_GP_SI)+(((mutau*d_nu_dV_GP_SI-nu*d_mutau_dV_GP_SI)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
            d_SP_S_y0_dV_DI_SI = (d_SP_S_eta_dV_DI_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*(((SP_S_a*nu)*d_SP_S_tau_dV_DI_SI)+(((SP_S_a*d_nu_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_DI_SI+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_DI_SI)+(d_SP_S_c_dV_DI_SI*SP_S_c))*3.3333333333333333e-01)-d_SP_S_a_dV_DI_SI))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_DI_SI)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_DI_SI)+((((nu/mutau)*d_SP_S_tau_dV_DI_SI)+(((mutau*d_nu_dV_DI_SI-nu*d_mutau_dV_DI_SI)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
            SP_S_y0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
            if ((SP_S_y0<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(SP_S_y0);
                double  deriv_exp_0_d0 = value_exp_0;

                d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*(d_SP_S_y0_dV_SI_BP));
                d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_y0_dV_GP_SI));
                d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*(d_SP_S_y0_dV_DI_SI));
                SP_S_delta0 = value_exp_0;
              }
            }
            else
            {

              d_SP_S_delta0_dV_SI_BP = (1.0e100*(((SP_S_y0-2.3025850929940458e+02)*(0.5*(((SP_S_y0-2.3025850929940458e+02)*(d_SP_S_y0_dV_SI_BP*3.3333333333333333e-01))+(d_SP_S_y0_dV_SI_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_y0_dV_SI_BP*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_SP_S_delta0_dV_GP_SI = (1.0e100*(((SP_S_y0-2.3025850929940458e+02)*(0.5*(((SP_S_y0-2.3025850929940458e+02)*(d_SP_S_y0_dV_GP_SI*3.3333333333333333e-01))+(d_SP_S_y0_dV_GP_SI*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_y0_dV_GP_SI*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_SP_S_delta0_dV_DI_SI = (1.0e100*(((SP_S_y0-2.3025850929940458e+02)*(0.5*(((SP_S_y0-2.3025850929940458e+02)*(d_SP_S_y0_dV_DI_SI*3.3333333333333333e-01))+(d_SP_S_y0_dV_DI_SI*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_y0_dV_DI_SI*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              SP_S_delta0 = (1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }

            d_SP_S_delta1_dV_SI_BP = (-d_SP_S_delta0_dV_SI_BP/SP_S_delta0/SP_S_delta0);
            d_SP_S_delta1_dV_GP_SI = (-d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
            d_SP_S_delta1_dV_DI_SI = (-d_SP_S_delta0_dV_DI_SI/SP_S_delta0/SP_S_delta0);
            SP_S_delta1 = (1.0/SP_S_delta0);

            d_SP_S_temp_dV_SI_BP = (-((SP_S_y0*d_SP_S_y0_dV_SI_BP)+(d_SP_S_y0_dV_SI_BP*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
            d_SP_S_temp_dV_GP_SI = (-((SP_S_y0*d_SP_S_y0_dV_GP_SI)+(d_SP_S_y0_dV_GP_SI*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
            d_SP_S_temp_dV_DI_SI = (-((SP_S_y0*d_SP_S_y0_dV_DI_SI)+(d_SP_S_y0_dV_DI_SI*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
            SP_S_temp = (1.0/(2.0+(SP_S_y0*SP_S_y0)));

            d_SP_S_xi0_dV_SI_BP = (((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_SI_BP)+(((SP_S_y0*d_SP_S_y0_dV_SI_BP)+(d_SP_S_y0_dV_SI_BP*SP_S_y0))*SP_S_temp));
            d_SP_S_xi0_dV_GP_SI = (((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_GP_SI)+(((SP_S_y0*d_SP_S_y0_dV_GP_SI)+(d_SP_S_y0_dV_GP_SI*SP_S_y0))*SP_S_temp));
            d_SP_S_xi0_dV_DI_SI = (((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_DI_SI)+(((SP_S_y0*d_SP_S_y0_dV_DI_SI)+(d_SP_S_y0_dV_DI_SI*SP_S_y0))*SP_S_temp));
            SP_S_xi0 = ((SP_S_y0*SP_S_y0)*SP_S_temp);

            d_SP_S_xi1_dV_SI_BP = (4.0*(((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_SI_BP)+(((SP_S_y0*d_SP_S_temp_dV_SI_BP)+(d_SP_S_y0_dV_SI_BP*SP_S_temp))*SP_S_temp)));
            d_SP_S_xi1_dV_GP_SI = (4.0*(((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_GP_SI)+(((SP_S_y0*d_SP_S_temp_dV_GP_SI)+(d_SP_S_y0_dV_GP_SI*SP_S_temp))*SP_S_temp)));
            d_SP_S_xi1_dV_DI_SI = (4.0*(((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_DI_SI)+(((SP_S_y0*d_SP_S_temp_dV_DI_SI)+(d_SP_S_y0_dV_DI_SI*SP_S_temp))*SP_S_temp)));
            SP_S_xi1 = (4.0*((SP_S_y0*SP_S_temp)*SP_S_temp));

            d_SP_S_xi2_dV_SI_BP = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_SI_BP)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_SI_BP)+(((8.0*d_SP_S_temp_dV_SI_BP)-(12.0*d_SP_S_xi0_dV_SI_BP))*SP_S_temp))*SP_S_temp));
            d_SP_S_xi2_dV_GP_SI = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_SI)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_SI)+(((8.0*d_SP_S_temp_dV_GP_SI)-(12.0*d_SP_S_xi0_dV_GP_SI))*SP_S_temp))*SP_S_temp));
            d_SP_S_xi2_dV_DI_SI = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_DI_SI)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_DI_SI)+(((8.0*d_SP_S_temp_dV_DI_SI)-(12.0*d_SP_S_xi0_dV_DI_SI))*SP_S_temp))*SP_S_temp));
            SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

            d_SP_S_temp_dV_SI_BP = (d_SP_S_yg_dV_SI_BP-d_SP_S_y0_dV_SI_BP);
            d_SP_S_temp_dV_GP_SI = (d_SP_S_yg_dV_GP_SI-d_SP_S_y0_dV_GP_SI);
            d_SP_S_temp_dV_DI_SI = (d_SP_S_yg_dV_DI_SI-d_SP_S_y0_dV_DI_SI);
            SP_S_temp = (SP_S_yg-SP_S_y0);

            d_SP_S_temp1_dV_GP_SI = (delta_ns*d_SP_S_delta1_dV_GP_SI);
            d_SP_S_temp1_dV_SI_BP = ((delta_ns*d_SP_S_delta1_dV_SI_BP)+(d_delta_ns_dV_SI_BP*SP_S_delta1));
            d_SP_S_temp1_dV_DI_SI = ((delta_ns*d_SP_S_delta1_dV_DI_SI)+(d_delta_ns_dV_DI_SI*SP_S_delta1));
            SP_S_temp1 = (delta_ns*SP_S_delta1);

            d_SP_S_pC_dV_SI_BP = ((2.0*d_SP_S_temp_dV_SI_BP)+((Gf2*((d_SP_S_delta0_dV_SI_BP-d_SP_S_temp1_dV_SI_BP)+((delta_ns*(-d_SP_S_xi1_dV_SI_BP))+(d_delta_ns_dV_SI_BP*(1.0-SP_S_xi1)))))+(d_Gf2_dV_SI_BP*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1))))));
            d_SP_S_pC_dV_GP_SI = ((2.0*d_SP_S_temp_dV_GP_SI)+((Gf2*((d_SP_S_delta0_dV_GP_SI-d_SP_S_temp1_dV_GP_SI)+(delta_ns*(-d_SP_S_xi1_dV_GP_SI))))+(d_Gf2_dV_GP_SI*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1))))));
            d_SP_S_pC_dV_DI_SI = ((2.0*d_SP_S_temp_dV_DI_SI)+((Gf2*((d_SP_S_delta0_dV_DI_SI-d_SP_S_temp1_dV_DI_SI)+((delta_ns*(-d_SP_S_xi1_dV_DI_SI))+(d_delta_ns_dV_DI_SI*(1.0-SP_S_xi1)))))+(d_Gf2_dV_DI_SI*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1))))));
            SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));

            d_SP_S_qC_dV_SI_BP = (((SP_S_temp*d_SP_S_temp_dV_SI_BP)+(d_SP_S_temp_dV_SI_BP*SP_S_temp))-((Gf2*(((d_SP_S_delta0_dV_SI_BP-d_SP_S_y0_dV_SI_BP)+d_SP_S_temp1_dV_SI_BP)+((delta_ns*(d_SP_S_y0_dV_SI_BP-d_SP_S_xi0_dV_SI_BP))+(d_delta_ns_dV_SI_BP*((SP_S_y0-1.0)-SP_S_xi0)))))+(d_Gf2_dV_SI_BP*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0))))));
            d_SP_S_qC_dV_GP_SI = (((SP_S_temp*d_SP_S_temp_dV_GP_SI)+(d_SP_S_temp_dV_GP_SI*SP_S_temp))-((Gf2*(((d_SP_S_delta0_dV_GP_SI-d_SP_S_y0_dV_GP_SI)+d_SP_S_temp1_dV_GP_SI)+(delta_ns*(d_SP_S_y0_dV_GP_SI-d_SP_S_xi0_dV_GP_SI))))+(d_Gf2_dV_GP_SI*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0))))));
            d_SP_S_qC_dV_DI_SI = (((SP_S_temp*d_SP_S_temp_dV_DI_SI)+(d_SP_S_temp_dV_DI_SI*SP_S_temp))-((Gf2*(((d_SP_S_delta0_dV_DI_SI-d_SP_S_y0_dV_DI_SI)+d_SP_S_temp1_dV_DI_SI)+((delta_ns*(d_SP_S_y0_dV_DI_SI-d_SP_S_xi0_dV_DI_SI))+(d_delta_ns_dV_DI_SI*((SP_S_y0-1.0)-SP_S_xi0)))))+(d_Gf2_dV_DI_SI*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0))))));
            SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));

            d_SP_S_temp_dV_SI_BP = (-((Gf2*((d_SP_S_delta0_dV_SI_BP+d_SP_S_temp1_dV_SI_BP)-((delta_ns*d_SP_S_xi2_dV_SI_BP)+(d_delta_ns_dV_SI_BP*SP_S_xi2))))+(d_Gf2_dV_SI_BP*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2)))));
            d_SP_S_temp_dV_GP_SI = (-((Gf2*((d_SP_S_delta0_dV_GP_SI+d_SP_S_temp1_dV_GP_SI)-(delta_ns*d_SP_S_xi2_dV_GP_SI)))+(d_Gf2_dV_GP_SI*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2)))));
            d_SP_S_temp_dV_DI_SI = (-((Gf2*((d_SP_S_delta0_dV_DI_SI+d_SP_S_temp1_dV_DI_SI)-((delta_ns*d_SP_S_xi2_dV_DI_SI)+(d_delta_ns_dV_DI_SI*SP_S_xi2))))+(d_Gf2_dV_DI_SI*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2)))));
            SP_S_temp = (2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));

            d_SP_S_temp_dV_SI_BP = (((SP_S_pC*d_SP_S_pC_dV_SI_BP)+(d_SP_S_pC_dV_SI_BP*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_SI_BP)+(d_SP_S_qC_dV_SI_BP*SP_S_temp))));
            d_SP_S_temp_dV_GP_SI = (((SP_S_pC*d_SP_S_pC_dV_GP_SI)+(d_SP_S_pC_dV_GP_SI*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_GP_SI)+(d_SP_S_qC_dV_GP_SI*SP_S_temp))));
            d_SP_S_temp_dV_DI_SI = (((SP_S_pC*d_SP_S_pC_dV_DI_SI)+(d_SP_S_pC_dV_DI_SI*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_DI_SI)+(d_SP_S_qC_dV_DI_SI*SP_S_temp))));
            SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
            {
              double value_sqrt_0 = sqrt(SP_S_temp);
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_x_s_dV_SI_BP = ((-d_SP_S_y0_dV_SI_BP)-(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_SI_BP-SP_S_qC*(d_SP_S_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_SI_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
              d_x_s_dV_GP_SI = ((-d_SP_S_y0_dV_GP_SI)-(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_SI-SP_S_qC*(d_SP_S_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
              d_x_s_dV_DI_SI = ((-d_SP_S_y0_dV_DI_SI)-(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_DI_SI-SP_S_qC*(d_SP_S_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_DI_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
              x_s = ((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
            }
          }
          else
          {

            d_SP_xg1_dV_SI_BP = (-(d_Gf_dV_SI_BP*7.324648775608221e-001)/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
            d_SP_xg1_dV_GP_SI = (-(d_Gf_dV_GP_SI*7.324648775608221e-001)/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
            d_SP_xg1_dV_DI_SI = (-(d_Gf_dV_DI_SI*7.324648775608221e-001)/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
            SP_xg1 = (1.0/(1.25+(Gf*7.324648775608221e-001)));

            d_SP_S_A_fac_dV_SI_BP = (((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dV_SI_BP)+((((xi*1.25)*d_SP_xg1_dV_SI_BP)+((d_xi_dV_SI_BP*1.25)*SP_xg1))*SP_xg1));
            d_SP_S_A_fac_dV_GP_SI = (((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dV_GP_SI)+((((xi*1.25)*d_SP_xg1_dV_GP_SI)+((d_xi_dV_GP_SI*1.25)*SP_xg1))*SP_xg1));
            d_SP_S_A_fac_dV_DI_SI = (((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dV_DI_SI)+((((xi*1.25)*d_SP_xg1_dV_DI_SI)+((d_xi_dV_DI_SI*1.25)*SP_xg1))*SP_xg1));
            SP_S_A_fac = ((((xi*1.25)*SP_xg1)-1.0)*SP_xg1);

            d_SP_S_xbar_dV_SI_BP = (((xg*inv_xi)*((SP_S_A_fac*d_xg_dV_SI_BP)+(d_SP_S_A_fac_dV_SI_BP*xg)))+(((xg*d_inv_xi_dV_SI_BP)+(d_xg_dV_SI_BP*inv_xi))*(1.0+(SP_S_A_fac*xg))));
            d_SP_S_xbar_dV_GP_SI = (((xg*inv_xi)*((SP_S_A_fac*d_xg_dV_GP_SI)+(d_SP_S_A_fac_dV_GP_SI*xg)))+(((xg*d_inv_xi_dV_GP_SI)+(d_xg_dV_GP_SI*inv_xi))*(1.0+(SP_S_A_fac*xg))));
            d_SP_S_xbar_dV_DI_SI = (((xg*inv_xi)*((SP_S_A_fac*d_xg_dV_DI_SI)+(d_SP_S_A_fac_dV_DI_SI*xg)))+(((xg*d_inv_xi_dV_DI_SI)+(d_xg_dV_DI_SI*inv_xi))*(1.0+(SP_S_A_fac*xg))));
            SP_S_xbar = ((xg*inv_xi)*(1.0+(SP_S_A_fac*xg)));
            if (((-SP_S_xbar)>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp((-SP_S_xbar));
                double  deriv_exp_0_d0 = value_exp_0;

                d_SP_S_temp_dV_SI_BP = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_SI_BP)));
                d_SP_S_temp_dV_GP_SI = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_GP_SI)));
                d_SP_S_temp_dV_DI_SI = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_DI_SI)));
                SP_S_temp = value_exp_0;
              }
            }
            else
            {

              d_SP_S_temp_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*((((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-d_SP_S_xbar_dV_SI_BP))*3.3333333333333333e-01))+((-(-d_SP_S_xbar_dV_SI_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+((-(-d_SP_S_xbar_dV_SI_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
              d_SP_S_temp_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*((((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-d_SP_S_xbar_dV_GP_SI))*3.3333333333333333e-01))+((-(-d_SP_S_xbar_dV_GP_SI))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+((-(-d_SP_S_xbar_dV_GP_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
              d_SP_S_temp_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*((((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-d_SP_S_xbar_dV_DI_SI))*3.3333333333333333e-01))+((-(-d_SP_S_xbar_dV_DI_SI))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+((-(-d_SP_S_xbar_dV_DI_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
              SP_S_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
            }

            d_SP_S_w_dV_SI_BP = (-d_SP_S_temp_dV_SI_BP);
            d_SP_S_w_dV_GP_SI = (-d_SP_S_temp_dV_GP_SI);
            d_SP_S_w_dV_DI_SI = (-d_SP_S_temp_dV_DI_SI);
            SP_S_w = (1.0-SP_S_temp);
            {
              double value_sqrt_0 = sqrt(((xg+(Gf2*0.25))-SP_S_w));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_SP_S_x1_dV_SI_BP = ((d_xg_dV_SI_BP+(d_Gf2_dV_SI_BP*0.5))-((Gf*(deriv_sqrt_0_d0*(((d_xg_dV_SI_BP+(d_Gf2_dV_SI_BP*0.25))-d_SP_S_w_dV_SI_BP))))+(d_Gf_dV_SI_BP*value_sqrt_0)));
              d_SP_S_x1_dV_GP_SI = ((d_xg_dV_GP_SI+(d_Gf2_dV_GP_SI*0.5))-((Gf*(deriv_sqrt_0_d0*(((d_xg_dV_GP_SI+(d_Gf2_dV_GP_SI*0.25))-d_SP_S_w_dV_GP_SI))))+(d_Gf_dV_GP_SI*value_sqrt_0)));
              d_SP_S_x1_dV_DI_SI = ((d_xg_dV_DI_SI+(d_Gf2_dV_DI_SI*0.5))-((Gf*(deriv_sqrt_0_d0*(((d_xg_dV_DI_SI+(d_Gf2_dV_DI_SI*0.25))-d_SP_S_w_dV_DI_SI))))+(d_Gf_dV_DI_SI*value_sqrt_0)));
              SP_S_x1 = ((xg+(Gf2*0.5))-(Gf*value_sqrt_0));
            }

            d_SP_S_bx_dV_GP_SI =  0.0;
            d_SP_S_bx_dV_SI_BP = d_xn_s_dV_SI_BP;
            d_SP_S_bx_dV_DI_SI = d_xn_s_dV_DI_SI;
            SP_S_bx = (xn_s+3.0);
            {
              double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
              double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
              double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

              d_SP_S_eta_dV_SI_BP = ((0.5*((d_SP_S_x1_dV_SI_BP+d_SP_S_bx_dV_SI_BP)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP))+((d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_SI_BP-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_SI_BP)+(d_SP_S_bx_dV_SI_BP*SP_S_bx)))))));
              d_SP_S_eta_dV_GP_SI = ((0.5*((d_SP_S_x1_dV_GP_SI+d_SP_S_bx_dV_GP_SI)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI))+((d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_GP_SI-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_GP_SI)+(d_SP_S_bx_dV_GP_SI*SP_S_bx)))))));
              d_SP_S_eta_dV_DI_SI = ((0.5*((d_SP_S_x1_dV_DI_SI+d_SP_S_bx_dV_DI_SI)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI))+((d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_DI_SI-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_DI_SI)+(d_SP_S_bx_dV_DI_SI*SP_S_bx)))))));
              SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
            }

            d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_eta_dV_SI_BP);
            d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_eta_dV_GP_SI);
            d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_eta_dV_DI_SI);
            SP_S_temp = (xg-SP_S_eta);
            {
              double value_exp_0 = exp((-SP_S_eta));
              double  deriv_exp_0_d0 = value_exp_0;

              d_SP_S_temp1_dV_SI_BP = (deriv_exp_0_d0*((-d_SP_S_eta_dV_SI_BP)));
              d_SP_S_temp1_dV_GP_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_GP_SI)));
              d_SP_S_temp1_dV_DI_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_DI_SI)));
              SP_S_temp1 = value_exp_0;
            }

            d_SP_S_temp2_dV_SI_BP = (-((SP_S_eta*d_SP_S_eta_dV_SI_BP)+(d_SP_S_eta_dV_SI_BP*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
            d_SP_S_temp2_dV_GP_SI = (-((SP_S_eta*d_SP_S_eta_dV_GP_SI)+(d_SP_S_eta_dV_GP_SI*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
            d_SP_S_temp2_dV_DI_SI = (-((SP_S_eta*d_SP_S_eta_dV_DI_SI)+(d_SP_S_eta_dV_DI_SI*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
            SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));

            d_SP_S_xi0_dV_SI_BP = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_SI_BP)+(((SP_S_eta*d_SP_S_eta_dV_SI_BP)+(d_SP_S_eta_dV_SI_BP*SP_S_eta))*SP_S_temp2));
            d_SP_S_xi0_dV_GP_SI = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_GP_SI)+(((SP_S_eta*d_SP_S_eta_dV_GP_SI)+(d_SP_S_eta_dV_GP_SI*SP_S_eta))*SP_S_temp2));
            d_SP_S_xi0_dV_DI_SI = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_DI_SI)+(((SP_S_eta*d_SP_S_eta_dV_DI_SI)+(d_SP_S_eta_dV_DI_SI*SP_S_eta))*SP_S_temp2));
            SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);

            d_SP_S_xi1_dV_SI_BP = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP)+(((SP_S_eta*d_SP_S_temp2_dV_SI_BP)+(d_SP_S_eta_dV_SI_BP*SP_S_temp2))*SP_S_temp2)));
            d_SP_S_xi1_dV_GP_SI = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI)+(((SP_S_eta*d_SP_S_temp2_dV_GP_SI)+(d_SP_S_eta_dV_GP_SI*SP_S_temp2))*SP_S_temp2)));
            d_SP_S_xi1_dV_DI_SI = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI)+(((SP_S_eta*d_SP_S_temp2_dV_DI_SI)+(d_SP_S_eta_dV_DI_SI*SP_S_temp2))*SP_S_temp2)));
            SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));

            d_SP_S_xi2_dV_SI_BP = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_SI_BP)+(((8.0*d_SP_S_temp2_dV_SI_BP)-(12.0*d_SP_S_xi0_dV_SI_BP))*SP_S_temp2))*SP_S_temp2));
            d_SP_S_xi2_dV_GP_SI = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_GP_SI)+(((8.0*d_SP_S_temp2_dV_GP_SI)-(12.0*d_SP_S_xi0_dV_GP_SI))*SP_S_temp2))*SP_S_temp2));
            d_SP_S_xi2_dV_DI_SI = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_DI_SI)+(((8.0*d_SP_S_temp2_dV_DI_SI)-(12.0*d_SP_S_xi0_dV_DI_SI))*SP_S_temp2))*SP_S_temp2));
            SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
            {
              double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))));
              double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);

              d_SP_S_a_dV_SI_BP = 0.0;
              d_SP_S_a_dV_GP_SI = 0.0;
              d_SP_S_a_dV_DI_SI = 0.0;
              SP_S_a = value_max_0;
            }

            d_SP_S_b_dV_SI_BP = (-(0.5*((Gf2*(d_SP_S_temp1_dV_SI_BP-((delta_ns*d_SP_S_xi2_dV_SI_BP)+(d_delta_ns_dV_SI_BP*SP_S_xi2))))+(d_Gf2_dV_SI_BP*(SP_S_temp1-(delta_ns*SP_S_xi2))))));
            d_SP_S_b_dV_GP_SI = (-(0.5*((Gf2*(d_SP_S_temp1_dV_GP_SI-(delta_ns*d_SP_S_xi2_dV_GP_SI)))+(d_Gf2_dV_GP_SI*(SP_S_temp1-(delta_ns*SP_S_xi2))))));
            d_SP_S_b_dV_DI_SI = (-(0.5*((Gf2*(d_SP_S_temp1_dV_DI_SI-((delta_ns*d_SP_S_xi2_dV_DI_SI)+(d_delta_ns_dV_DI_SI*SP_S_xi2))))+(d_Gf2_dV_DI_SI*(SP_S_temp1-(delta_ns*SP_S_xi2))))));
            SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))));

            d_SP_S_c_dV_SI_BP = ((2.0*d_SP_S_temp_dV_SI_BP)+((Gf2*((-d_SP_S_temp1_dV_SI_BP)-((delta_ns*d_SP_S_xi1_dV_SI_BP)+(d_delta_ns_dV_SI_BP*(1.0+SP_S_xi1)))))+(d_Gf2_dV_SI_BP*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1))))));
            d_SP_S_c_dV_GP_SI = ((2.0*d_SP_S_temp_dV_GP_SI)+((Gf2*((-d_SP_S_temp1_dV_GP_SI)-(delta_ns*d_SP_S_xi1_dV_GP_SI)))+(d_Gf2_dV_GP_SI*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1))))));
            d_SP_S_c_dV_DI_SI = ((2.0*d_SP_S_temp_dV_DI_SI)+((Gf2*((-d_SP_S_temp1_dV_DI_SI)-((delta_ns*d_SP_S_xi1_dV_DI_SI)+(d_delta_ns_dV_DI_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_DI_SI*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1))))));
            SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
            {
              double value_log_0 = log((SP_S_a/Gf2));
              double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));

              d_SP_S_tau_dV_GP_SI = ((-d_SP_S_eta_dV_GP_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_GP_SI-SP_S_a*d_Gf2_dV_GP_SI)/Gf2/Gf2))));
              d_SP_S_tau_dV_SI_BP = ((d_xn_s_dV_SI_BP-d_SP_S_eta_dV_SI_BP)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_SI_BP-SP_S_a*d_Gf2_dV_SI_BP)/Gf2/Gf2))));
              d_SP_S_tau_dV_DI_SI = ((d_xn_s_dV_DI_SI-d_SP_S_eta_dV_DI_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_DI_SI-SP_S_a*d_Gf2_dV_DI_SI)/Gf2/Gf2))));
              SP_S_tau = ((xn_s-SP_S_eta)+value_log_0);
            }

            d_nu_dV_SI_BP = (d_SP_S_a_dV_SI_BP+d_SP_S_c_dV_SI_BP);
            d_nu_dV_GP_SI = (d_SP_S_a_dV_GP_SI+d_SP_S_c_dV_GP_SI);
            d_nu_dV_DI_SI = (d_SP_S_a_dV_DI_SI+d_SP_S_c_dV_DI_SI);
            nu = (SP_S_a+SP_S_c);

            d_mutau_dV_SI_BP = (((nu*d_nu_dV_SI_BP)+(d_nu_dV_SI_BP*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_SI_BP)+(d_SP_S_c_dV_SI_BP*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*SP_S_b))))+(d_SP_S_tau_dV_SI_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
            d_mutau_dV_GP_SI = (((nu*d_nu_dV_GP_SI)+(d_nu_dV_GP_SI*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_GP_SI)+(d_SP_S_c_dV_GP_SI*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*SP_S_b))))+(d_SP_S_tau_dV_GP_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
            d_mutau_dV_DI_SI = (((nu*d_nu_dV_DI_SI)+(d_nu_dV_DI_SI*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_DI_SI)+(d_SP_S_c_dV_DI_SI*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*SP_S_b))))+(d_SP_S_tau_dV_DI_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
            mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));

            d_SP_S_x0_dV_SI_BP = (d_SP_S_eta_dV_SI_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_SI_BP)+(((SP_S_a*d_nu_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_SI_BP+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_SI_BP)+(d_SP_S_c_dV_SI_BP*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_SI_BP)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_SI_BP)+((((nu/mutau)*d_SP_S_tau_dV_SI_BP)+(((mutau*d_nu_dV_SI_BP-nu*d_mutau_dV_SI_BP)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
            d_SP_S_x0_dV_GP_SI = (d_SP_S_eta_dV_GP_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_GP_SI)+(((SP_S_a*d_nu_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_SI+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_GP_SI)+(d_SP_S_c_dV_GP_SI*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_SI)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_SI)+((((nu/mutau)*d_SP_S_tau_dV_GP_SI)+(((mutau*d_nu_dV_GP_SI-nu*d_mutau_dV_GP_SI)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
            d_SP_S_x0_dV_DI_SI = (d_SP_S_eta_dV_DI_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_DI_SI)+(((SP_S_a*d_nu_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_DI_SI+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_DI_SI)+(d_SP_S_c_dV_DI_SI*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_DI_SI)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_DI_SI)+((((nu/mutau)*d_SP_S_tau_dV_DI_SI)+(((mutau*d_nu_dV_DI_SI-nu*d_mutau_dV_DI_SI)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
            SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
            if ((SP_S_x0<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(SP_S_x0);
                double  deriv_exp_0_d0 = value_exp_0;

                d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*(d_SP_S_x0_dV_SI_BP));
                d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_SI));
                d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_DI_SI));
                SP_S_delta0 = value_exp_0;
              }

              d_SP_S_delta1_dV_SI_BP = (-d_SP_S_delta0_dV_SI_BP/SP_S_delta0/SP_S_delta0);
              d_SP_S_delta1_dV_GP_SI = (-d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
              d_SP_S_delta1_dV_DI_SI = (-d_SP_S_delta0_dV_DI_SI/SP_S_delta0/SP_S_delta0);
              SP_S_delta1 = (1.0/SP_S_delta0);

              d_SP_S_delta0_dV_GP_SI = (delta_ns*d_SP_S_delta0_dV_GP_SI);
              d_SP_S_delta0_dV_SI_BP = ((delta_ns*d_SP_S_delta0_dV_SI_BP)+(d_delta_ns_dV_SI_BP*SP_S_delta0));
              d_SP_S_delta0_dV_DI_SI = ((delta_ns*d_SP_S_delta0_dV_DI_SI)+(d_delta_ns_dV_DI_SI*SP_S_delta0));
              SP_S_delta0 = (delta_ns*SP_S_delta0);
            }
            else
            {
              if ((SP_S_x0>(xn_s-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp((SP_S_x0-xn_s));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*((d_SP_S_x0_dV_SI_BP-d_xn_s_dV_SI_BP)));
                  d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_SI));
                  d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_DI_SI-d_xn_s_dV_DI_SI)));
                  SP_S_delta0 = value_exp_0;
                }

                d_SP_S_delta1_dV_GP_SI = (-delta_ns*d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
                d_SP_S_delta1_dV_SI_BP = ((SP_S_delta0*d_delta_ns_dV_SI_BP-delta_ns*d_SP_S_delta0_dV_SI_BP)/SP_S_delta0/SP_S_delta0);
                d_SP_S_delta1_dV_DI_SI = ((SP_S_delta0*d_delta_ns_dV_DI_SI-delta_ns*d_SP_S_delta0_dV_DI_SI)/SP_S_delta0/SP_S_delta0);
                SP_S_delta1 = (delta_ns/SP_S_delta0);
              }
              else
              {

                d_SP_S_delta0_dV_GP_SI = (-1.0e-100*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-d_SP_S_x0_dV_GP_SI)*3.3333333333333333e-01))+((-d_SP_S_x0_dV_GP_SI)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-d_SP_S_x0_dV_GP_SI)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_SP_S_delta0_dV_SI_BP = (-1.0e-100*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*((d_xn_s_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*3.3333333333333333e-01))+((d_xn_s_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_SP_S_delta0_dV_DI_SI = (-1.0e-100*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*((d_xn_s_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*3.3333333333333333e-01))+((d_xn_s_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                SP_S_delta0 = (1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

                d_SP_S_delta1_dV_SI_BP = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_SI_BP*3.3333333333333333e-01))+(d_SP_S_x0_dV_SI_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_SI_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_SP_S_delta1_dV_GP_SI = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_GP_SI*3.3333333333333333e-01))+(d_SP_S_x0_dV_GP_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_GP_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_SP_S_delta1_dV_DI_SI = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_DI_SI*3.3333333333333333e-01))+(d_SP_S_x0_dV_DI_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_DI_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }

            d_SP_S_temp_dV_SI_BP = (-((SP_S_x0*d_SP_S_x0_dV_SI_BP)+(d_SP_S_x0_dV_SI_BP*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
            d_SP_S_temp_dV_GP_SI = (-((SP_S_x0*d_SP_S_x0_dV_GP_SI)+(d_SP_S_x0_dV_GP_SI*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
            d_SP_S_temp_dV_DI_SI = (-((SP_S_x0*d_SP_S_x0_dV_DI_SI)+(d_SP_S_x0_dV_DI_SI*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
            SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));

            d_SP_S_xi0_dV_SI_BP = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_SI_BP)+(((SP_S_x0*d_SP_S_x0_dV_SI_BP)+(d_SP_S_x0_dV_SI_BP*SP_S_x0))*SP_S_temp));
            d_SP_S_xi0_dV_GP_SI = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_GP_SI)+(((SP_S_x0*d_SP_S_x0_dV_GP_SI)+(d_SP_S_x0_dV_GP_SI*SP_S_x0))*SP_S_temp));
            d_SP_S_xi0_dV_DI_SI = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_DI_SI)+(((SP_S_x0*d_SP_S_x0_dV_DI_SI)+(d_SP_S_x0_dV_DI_SI*SP_S_x0))*SP_S_temp));
            SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);

            d_SP_S_xi1_dV_SI_BP = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_SI_BP)+(((SP_S_x0*d_SP_S_temp_dV_SI_BP)+(d_SP_S_x0_dV_SI_BP*SP_S_temp))*SP_S_temp)));
            d_SP_S_xi1_dV_GP_SI = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_GP_SI)+(((SP_S_x0*d_SP_S_temp_dV_GP_SI)+(d_SP_S_x0_dV_GP_SI*SP_S_temp))*SP_S_temp)));
            d_SP_S_xi1_dV_DI_SI = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_DI_SI)+(((SP_S_x0*d_SP_S_temp_dV_DI_SI)+(d_SP_S_x0_dV_DI_SI*SP_S_temp))*SP_S_temp)));
            SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));

            d_SP_S_xi2_dV_SI_BP = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_SI_BP)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_SI_BP)+(((8.0*d_SP_S_temp_dV_SI_BP)-(12.0*d_SP_S_xi0_dV_SI_BP))*SP_S_temp))*SP_S_temp));
            d_SP_S_xi2_dV_GP_SI = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_SI)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_SI)+(((8.0*d_SP_S_temp_dV_GP_SI)-(12.0*d_SP_S_xi0_dV_GP_SI))*SP_S_temp))*SP_S_temp));
            d_SP_S_xi2_dV_DI_SI = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_DI_SI)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_DI_SI)+(((8.0*d_SP_S_temp_dV_DI_SI)-(12.0*d_SP_S_xi0_dV_DI_SI))*SP_S_temp))*SP_S_temp));
            SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

            d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_x0_dV_SI_BP);
            d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_x0_dV_GP_SI);
            d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_x0_dV_DI_SI);
            SP_S_temp = (xg-SP_S_x0);

            d_SP_S_pC_dV_SI_BP = ((2.0*d_SP_S_temp_dV_SI_BP)+((Gf2*(((-d_SP_S_delta1_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-((delta_ns*d_SP_S_xi1_dV_SI_BP)+(d_delta_ns_dV_SI_BP*(1.0+SP_S_xi1)))))+(d_Gf2_dV_SI_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1))))));
            d_SP_S_pC_dV_GP_SI = ((2.0*d_SP_S_temp_dV_GP_SI)+((Gf2*(((-d_SP_S_delta1_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-(delta_ns*d_SP_S_xi1_dV_GP_SI)))+(d_Gf2_dV_GP_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1))))));
            d_SP_S_pC_dV_DI_SI = ((2.0*d_SP_S_temp_dV_DI_SI)+((Gf2*(((-d_SP_S_delta1_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-((delta_ns*d_SP_S_xi1_dV_DI_SI)+(d_delta_ns_dV_DI_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_DI_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1))))));
            SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));

            d_SP_S_qC_dV_SI_BP = (((SP_S_temp*d_SP_S_temp_dV_SI_BP)+(d_SP_S_temp_dV_SI_BP*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_SI_BP+d_SP_S_x0_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-((delta_ns*(d_SP_S_x0_dV_SI_BP+d_SP_S_xi0_dV_SI_BP))+(d_delta_ns_dV_SI_BP*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_SI_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0))))));
            d_SP_S_qC_dV_GP_SI = (((SP_S_temp*d_SP_S_temp_dV_GP_SI)+(d_SP_S_temp_dV_GP_SI*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_GP_SI+d_SP_S_x0_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-(delta_ns*(d_SP_S_x0_dV_GP_SI+d_SP_S_xi0_dV_GP_SI))))+(d_Gf2_dV_GP_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0))))));
            d_SP_S_qC_dV_DI_SI = (((SP_S_temp*d_SP_S_temp_dV_DI_SI)+(d_SP_S_temp_dV_DI_SI*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_DI_SI+d_SP_S_x0_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-((delta_ns*(d_SP_S_x0_dV_DI_SI+d_SP_S_xi0_dV_DI_SI))+(d_delta_ns_dV_DI_SI*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_DI_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0))))));
            SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));

            d_SP_S_temp_dV_SI_BP = (-((Gf2*((d_SP_S_delta1_dV_SI_BP+d_SP_S_delta0_dV_SI_BP)-((delta_ns*d_SP_S_xi2_dV_SI_BP)+(d_delta_ns_dV_SI_BP*SP_S_xi2))))+(d_Gf2_dV_SI_BP*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2)))));
            d_SP_S_temp_dV_GP_SI = (-((Gf2*((d_SP_S_delta1_dV_GP_SI+d_SP_S_delta0_dV_GP_SI)-(delta_ns*d_SP_S_xi2_dV_GP_SI)))+(d_Gf2_dV_GP_SI*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2)))));
            d_SP_S_temp_dV_DI_SI = (-((Gf2*((d_SP_S_delta1_dV_DI_SI+d_SP_S_delta0_dV_DI_SI)-((delta_ns*d_SP_S_xi2_dV_DI_SI)+(d_delta_ns_dV_DI_SI*SP_S_xi2))))+(d_Gf2_dV_DI_SI*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2)))));
            SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));

            d_SP_S_temp_dV_SI_BP = (((SP_S_pC*d_SP_S_pC_dV_SI_BP)+(d_SP_S_pC_dV_SI_BP*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_SI_BP)+(d_SP_S_qC_dV_SI_BP*SP_S_temp))));
            d_SP_S_temp_dV_GP_SI = (((SP_S_pC*d_SP_S_pC_dV_GP_SI)+(d_SP_S_pC_dV_GP_SI*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_GP_SI)+(d_SP_S_qC_dV_GP_SI*SP_S_temp))));
            d_SP_S_temp_dV_DI_SI = (((SP_S_pC*d_SP_S_pC_dV_DI_SI)+(d_SP_S_pC_dV_DI_SI*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_DI_SI)+(d_SP_S_qC_dV_DI_SI*SP_S_temp))));
            SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
            {
              double value_sqrt_0 = sqrt(SP_S_temp);
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_x_s_dV_SI_BP = (d_SP_S_x0_dV_SI_BP+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_SI_BP-SP_S_qC*(d_SP_S_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_SI_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
              d_x_s_dV_GP_SI = (d_SP_S_x0_dV_GP_SI+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_SI-SP_S_qC*(d_SP_S_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
              d_x_s_dV_DI_SI = (d_SP_S_x0_dV_DI_SI+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_DI_SI-SP_S_qC*(d_SP_S_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_DI_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
              x_s = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
            }
          }
        }

        d_x_d_dV_SI_BP = d_x_s_dV_SI_BP;
        d_x_d_dV_GP_SI = d_x_s_dV_GP_SI;
        d_x_d_dV_DI_SI = d_x_s_dV_DI_SI;
        x_d = x_s;

        d_x_m_dV_SI_BP = d_x_s_dV_SI_BP;
        d_x_m_dV_GP_SI = d_x_s_dV_GP_SI;
        d_x_m_dV_DI_SI = d_x_s_dV_DI_SI;
        x_m = x_s;

        d_x_ds_dV_DI_SI = d_x_ds_dV_GP_SI = d_x_ds_dV_SI_BP =  0.0;
        x_ds = 0.0;

        d_Vdsat_lim_dV_GP_SI =  0.0;
        d_Vdsat_lim_dV_SI_BP = (3.912023005*d_phit1_dV_SI_BP);
        d_Vdsat_lim_dV_DI_SI = (3.912023005*d_phit1_dV_DI_SI);
        Vdsat_lim = (3.912023005*phit1);
        if ((xg<=0.0))
        {

          d_qis_dV_DI_SI = d_qis_dV_GP_SI = d_qis_dV_SI_BP =  0.0;
          qis = 0.0;

          d_xgm_dV_SI_BP = (d_xg_dV_SI_BP-d_x_s_dV_SI_BP);
          d_xgm_dV_GP_SI = (d_xg_dV_GP_SI-d_x_s_dV_GP_SI);
          d_xgm_dV_DI_SI = (d_xg_dV_DI_SI-d_x_s_dV_DI_SI);
          xgm = (xg-x_s);

          d_Voxm_dV_SI_BP = ((xgm*d_phit1_dV_SI_BP)+(d_xgm_dV_SI_BP*phit1));
          d_Voxm_dV_GP_SI = ((xgm*d_phit1_dV_GP_SI)+(d_xgm_dV_GP_SI*phit1));
          d_Voxm_dV_DI_SI = ((xgm*d_phit1_dV_DI_SI)+(d_xgm_dV_DI_SI*phit1));
          Voxm = (xgm*phit1);

          d_qeff1_dV_SI_BP = d_Voxm_dV_SI_BP;
          d_qeff1_dV_GP_SI = d_Voxm_dV_GP_SI;
          d_qeff1_dV_DI_SI = d_Voxm_dV_DI_SI;
          qeff1 = Voxm;

          d_Vdsat_dV_GP_SI =  0.0;
          d_Vdsat_dV_SI_BP = d_Vdsat_lim_dV_SI_BP;
          d_Vdsat_dV_DI_SI = d_Vdsat_lim_dV_DI_SI;
          Vdsat = Vdsat_lim;

          d_Vdse_dV_GP_SI = d_Vdse_dV_SI_BP =  0.0;
          d_Vdse_dV_DI_SI = d_Vds_dV_DI_SI;
          Vdse = Vds;
        }
        else
        {

          d_delta_1s_dV_DI_SI = d_delta_1s_dV_GP_SI = d_delta_1s_dV_SI_BP =  0.0;
          delta_1s = 0.0;

          d_temp_dV_SI_BP = (-((x_s*d_x_s_dV_SI_BP)+(d_x_s_dV_SI_BP*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
          d_temp_dV_GP_SI = (-((x_s*d_x_s_dV_GP_SI)+(d_x_s_dV_GP_SI*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
          d_temp_dV_DI_SI = (-((x_s*d_x_s_dV_DI_SI)+(d_x_s_dV_DI_SI*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
          temp = (1.0/(2.0+(x_s*x_s)));

          d_xi0s_dV_SI_BP = (((x_s*x_s)*d_temp_dV_SI_BP)+(((x_s*d_x_s_dV_SI_BP)+(d_x_s_dV_SI_BP*x_s))*temp));
          d_xi0s_dV_GP_SI = (((x_s*x_s)*d_temp_dV_GP_SI)+(((x_s*d_x_s_dV_GP_SI)+(d_x_s_dV_GP_SI*x_s))*temp));
          d_xi0s_dV_DI_SI = (((x_s*x_s)*d_temp_dV_DI_SI)+(((x_s*d_x_s_dV_DI_SI)+(d_x_s_dV_DI_SI*x_s))*temp));
          xi0s = ((x_s*x_s)*temp);

          d_xi1s_dV_SI_BP = (4.0*(((x_s*temp)*d_temp_dV_SI_BP)+(((x_s*d_temp_dV_SI_BP)+(d_x_s_dV_SI_BP*temp))*temp)));
          d_xi1s_dV_GP_SI = (4.0*(((x_s*temp)*d_temp_dV_GP_SI)+(((x_s*d_temp_dV_GP_SI)+(d_x_s_dV_GP_SI*temp))*temp)));
          d_xi1s_dV_DI_SI = (4.0*(((x_s*temp)*d_temp_dV_DI_SI)+(((x_s*d_temp_dV_DI_SI)+(d_x_s_dV_DI_SI*temp))*temp)));
          xi1s = (4.0*((x_s*temp)*temp));

          d_xi2s_dV_SI_BP = (((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_SI_BP)+(((((8.0*temp)-(12.0*xi0s))*d_temp_dV_SI_BP)+(((8.0*d_temp_dV_SI_BP)-(12.0*d_xi0s_dV_SI_BP))*temp))*temp));
          d_xi2s_dV_DI_SI = (((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_DI_SI)+(((((8.0*temp)-(12.0*xi0s))*d_temp_dV_DI_SI)+(((8.0*d_temp_dV_DI_SI)-(12.0*d_xi0s_dV_DI_SI))*temp))*temp));
          d_xi2s_dV_GP_SI = (((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_GP_SI)+(((((8.0*temp)-(12.0*xi0s))*d_temp_dV_GP_SI)+(((8.0*d_temp_dV_GP_SI)-(12.0*d_xi0s_dV_GP_SI))*temp))*temp));
          xi2s = ((((8.0*temp)-(12.0*xi0s))*temp)*temp);
          if ((x_s<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp(x_s);
              double  deriv_exp_0_d0 = value_exp_0;

              d_delta_1s_dV_SI_BP = (deriv_exp_0_d0*(d_x_s_dV_SI_BP));
              d_delta_1s_dV_GP_SI = (deriv_exp_0_d0*(d_x_s_dV_GP_SI));
              d_delta_1s_dV_DI_SI = (deriv_exp_0_d0*(d_x_s_dV_DI_SI));
              delta_1s = value_exp_0;
            }

            d_Es_dV_SI_BP = (-d_delta_1s_dV_SI_BP/delta_1s/delta_1s);
            d_Es_dV_GP_SI = (-d_delta_1s_dV_GP_SI/delta_1s/delta_1s);
            d_Es_dV_DI_SI = (-d_delta_1s_dV_DI_SI/delta_1s/delta_1s);
            Es = (1.0/delta_1s);

            d_delta_1s_dV_GP_SI = (delta_ns*d_delta_1s_dV_GP_SI);
            d_delta_1s_dV_SI_BP = ((delta_ns*d_delta_1s_dV_SI_BP)+(d_delta_ns_dV_SI_BP*delta_1s));
            d_delta_1s_dV_DI_SI = ((delta_ns*d_delta_1s_dV_DI_SI)+(d_delta_ns_dV_DI_SI*delta_1s));
            delta_1s = (delta_ns*delta_1s);
          }
          else
          {
            if ((x_s>(xn_s-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp((x_s-xn_s));
                double  deriv_exp_0_d0 = value_exp_0;

                d_delta_1s_dV_SI_BP = (deriv_exp_0_d0*((d_x_s_dV_SI_BP-d_xn_s_dV_SI_BP)));
                d_delta_1s_dV_GP_SI = (deriv_exp_0_d0*(d_x_s_dV_GP_SI));
                d_delta_1s_dV_DI_SI = (deriv_exp_0_d0*((d_x_s_dV_DI_SI-d_xn_s_dV_DI_SI)));
                delta_1s = value_exp_0;
              }

              d_Es_dV_GP_SI = (-delta_ns*d_delta_1s_dV_GP_SI/delta_1s/delta_1s);
              d_Es_dV_SI_BP = ((delta_1s*d_delta_ns_dV_SI_BP-delta_ns*d_delta_1s_dV_SI_BP)/delta_1s/delta_1s);
              d_Es_dV_DI_SI = ((delta_1s*d_delta_ns_dV_DI_SI-delta_ns*d_delta_1s_dV_DI_SI)/delta_1s/delta_1s);
              Es = (delta_ns/delta_1s);
            }
            else
            {

              d_delta_1s_dV_GP_SI = (-1.0e-100*((((xn_s-x_s)-2.3025850929940458e+02)*(0.5*((((xn_s-x_s)-2.3025850929940458e+02)*((-d_x_s_dV_GP_SI)*3.3333333333333333e-01))+((-d_x_s_dV_GP_SI)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-d_x_s_dV_GP_SI)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_delta_1s_dV_SI_BP = (-1.0e-100*((((xn_s-x_s)-2.3025850929940458e+02)*(0.5*((((xn_s-x_s)-2.3025850929940458e+02)*((d_xn_s_dV_SI_BP-d_x_s_dV_SI_BP)*3.3333333333333333e-01))+((d_xn_s_dV_SI_BP-d_x_s_dV_SI_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_SI_BP-d_x_s_dV_SI_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_delta_1s_dV_DI_SI = (-1.0e-100*((((xn_s-x_s)-2.3025850929940458e+02)*(0.5*((((xn_s-x_s)-2.3025850929940458e+02)*((d_xn_s_dV_DI_SI-d_x_s_dV_DI_SI)*3.3333333333333333e-01))+((d_xn_s_dV_DI_SI-d_x_s_dV_DI_SI)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_DI_SI-d_x_s_dV_DI_SI)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              delta_1s = (1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

              d_Es_dV_SI_BP = (-1.0e-100*(((x_s-2.3025850929940458e+02)*(0.5*(((x_s-2.3025850929940458e+02)*(d_x_s_dV_SI_BP*3.3333333333333333e-01))+(d_x_s_dV_SI_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_s_dV_SI_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Es_dV_GP_SI = (-1.0e-100*(((x_s-2.3025850929940458e+02)*(0.5*(((x_s-2.3025850929940458e+02)*(d_x_s_dV_GP_SI*3.3333333333333333e-01))+(d_x_s_dV_GP_SI*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_s_dV_GP_SI*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Es_dV_DI_SI = (-1.0e-100*(((x_s-2.3025850929940458e+02)*(0.5*(((x_s-2.3025850929940458e+02)*(d_x_s_dV_DI_SI*3.3333333333333333e-01))+(d_x_s_dV_DI_SI*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_s_dV_DI_SI*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              Es = (1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }

          d_Ds_dV_SI_BP = (d_delta_1s_dV_SI_BP-((delta_ns*(d_x_s_dV_SI_BP+d_xi0s_dV_SI_BP))+(d_delta_ns_dV_SI_BP*((x_s+1.0)+xi0s))));
          d_Ds_dV_GP_SI = (d_delta_1s_dV_GP_SI-(delta_ns*(d_x_s_dV_GP_SI+d_xi0s_dV_GP_SI)));
          d_Ds_dV_DI_SI = (d_delta_1s_dV_DI_SI-((delta_ns*(d_x_s_dV_DI_SI+d_xi0s_dV_DI_SI))+(d_delta_ns_dV_DI_SI*((x_s+1.0)+xi0s))));
          Ds = (delta_1s-(delta_ns*((x_s+1.0)+xi0s)));
          if ((x_s<1.0e-5))
          {

            d_Ps_dV_SI_BP = (0.5*(((x_s*x_s)*(-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_SI_BP)))+(d_x_s_dV_SI_BP*(1.0-(0.25*x_s)))))))+(((x_s*d_x_s_dV_SI_BP)+(d_x_s_dV_SI_BP*x_s))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))));
            d_Ps_dV_GP_SI = (0.5*(((x_s*x_s)*(-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_GP_SI)))+(d_x_s_dV_GP_SI*(1.0-(0.25*x_s)))))))+(((x_s*d_x_s_dV_GP_SI)+(d_x_s_dV_GP_SI*x_s))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))));
            d_Ps_dV_DI_SI = (0.5*(((x_s*x_s)*(-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_DI_SI)))+(d_x_s_dV_DI_SI*(1.0-(0.25*x_s)))))))+(((x_s*d_x_s_dV_DI_SI)+(d_x_s_dV_DI_SI*x_s))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))));
            Ps = (0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))));

            d_Ds_dV_GP_SI = (1.6666666666666667e-01*(((((delta_ns*x_s)*x_s)*x_s)*(1.75*d_x_s_dV_GP_SI))+(((((delta_ns*x_s)*x_s)*d_x_s_dV_GP_SI)+((((delta_ns*x_s)*d_x_s_dV_GP_SI)+((delta_ns*d_x_s_dV_GP_SI)*x_s))*x_s))*(1.0+(1.75*x_s)))));
            d_Ds_dV_SI_BP = (1.6666666666666667e-01*(((((delta_ns*x_s)*x_s)*x_s)*(1.75*d_x_s_dV_SI_BP))+(((((delta_ns*x_s)*x_s)*d_x_s_dV_SI_BP)+((((delta_ns*x_s)*d_x_s_dV_SI_BP)+(((delta_ns*d_x_s_dV_SI_BP)+(d_delta_ns_dV_SI_BP*x_s))*x_s))*x_s))*(1.0+(1.75*x_s)))));
            d_Ds_dV_DI_SI = (1.6666666666666667e-01*(((((delta_ns*x_s)*x_s)*x_s)*(1.75*d_x_s_dV_DI_SI))+(((((delta_ns*x_s)*x_s)*d_x_s_dV_DI_SI)+((((delta_ns*x_s)*d_x_s_dV_DI_SI)+(((delta_ns*d_x_s_dV_DI_SI)+(d_delta_ns_dV_DI_SI*x_s))*x_s))*x_s))*(1.0+(1.75*x_s)))));
            Ds = (1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s))));
            {
              double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_temp_dV_SI_BP = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_SI_BP)))+(d_x_s_dV_SI_BP*(1.0-(0.25*x_s))))))));
              d_temp_dV_GP_SI = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_GP_SI)))+(d_x_s_dV_GP_SI*(1.0-(0.25*x_s))))))));
              d_temp_dV_DI_SI = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_DI_SI)))+(d_x_s_dV_DI_SI*(1.0-(0.25*x_s))))))));
              temp = value_sqrt_0;
            }

            d_sqm_dV_SI_BP = (7.0710678118654746e-01*((x_s*d_temp_dV_SI_BP)+(d_x_s_dV_SI_BP*temp)));
            d_sqm_dV_GP_SI = (7.0710678118654746e-01*((x_s*d_temp_dV_GP_SI)+(d_x_s_dV_GP_SI*temp)));
            d_sqm_dV_DI_SI = (7.0710678118654746e-01*((x_s*d_temp_dV_DI_SI)+(d_x_s_dV_DI_SI*temp)));
            sqm = (7.0710678118654746e-01*(x_s*temp));

            d_alpha_dV_SI_BP = ((temp*(((Gf*7.0710678118654746e-01)*((-(0.5*d_x_s_dV_SI_BP))+(1.6666666666666667e-01*((x_s*d_x_s_dV_SI_BP)+(d_x_s_dV_SI_BP*x_s)))))+((d_Gf_dV_SI_BP*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_SI_BP)/temp/temp);
            d_alpha_dV_GP_SI = ((temp*(((Gf*7.0710678118654746e-01)*((-(0.5*d_x_s_dV_GP_SI))+(1.6666666666666667e-01*((x_s*d_x_s_dV_GP_SI)+(d_x_s_dV_GP_SI*x_s)))))+((d_Gf_dV_GP_SI*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_GP_SI)/temp/temp);
            d_alpha_dV_DI_SI = ((temp*(((Gf*7.0710678118654746e-01)*((-(0.5*d_x_s_dV_DI_SI))+(1.6666666666666667e-01*((x_s*d_x_s_dV_DI_SI)+(d_x_s_dV_DI_SI*x_s)))))+((d_Gf_dV_DI_SI*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_DI_SI)/temp/temp);
            alpha = (1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp));
          }
          else
          {

            d_Ps_dV_SI_BP = (d_x_s_dV_SI_BP+d_Es_dV_SI_BP);
            d_Ps_dV_GP_SI = (d_x_s_dV_GP_SI+d_Es_dV_GP_SI);
            d_Ps_dV_DI_SI = (d_x_s_dV_DI_SI+d_Es_dV_DI_SI);
            Ps = ((x_s-1.0)+Es);
            {
              double value_sqrt_0 = sqrt(Ps);
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_sqm_dV_SI_BP = (deriv_sqrt_0_d0*(d_Ps_dV_SI_BP));
              d_sqm_dV_GP_SI = (deriv_sqrt_0_d0*(d_Ps_dV_GP_SI));
              d_sqm_dV_DI_SI = (deriv_sqrt_0_d0*(d_Ps_dV_DI_SI));
              sqm = value_sqrt_0;
            }

            d_alpha_dV_SI_BP = (0.5*((sqm*((Gf*(-d_Es_dV_SI_BP))+(d_Gf_dV_SI_BP*(1.0-Es)))-(Gf*(1.0-Es))*d_sqm_dV_SI_BP)/sqm/sqm));
            d_alpha_dV_GP_SI = (0.5*((sqm*((Gf*(-d_Es_dV_GP_SI))+(d_Gf_dV_GP_SI*(1.0-Es)))-(Gf*(1.0-Es))*d_sqm_dV_GP_SI)/sqm/sqm));
            d_alpha_dV_DI_SI = (0.5*((sqm*((Gf*(-d_Es_dV_DI_SI))+(d_Gf_dV_DI_SI*(1.0-Es)))-(Gf*(1.0-Es))*d_sqm_dV_DI_SI)/sqm/sqm));
            alpha = (1.0+(0.5*((Gf*(1.0-Es))/sqm)));
          }

          d_Em_dV_SI_BP = d_Es_dV_SI_BP;
          d_Em_dV_GP_SI = d_Es_dV_GP_SI;
          d_Em_dV_DI_SI = d_Es_dV_DI_SI;
          Em = Es;

          d_Ed_dV_SI_BP = d_Em_dV_SI_BP;
          d_Ed_dV_GP_SI = d_Em_dV_GP_SI;
          d_Ed_dV_DI_SI = d_Em_dV_DI_SI;
          Ed = Em;

          d_Dm_dV_SI_BP = d_Ds_dV_SI_BP;
          d_Dm_dV_GP_SI = d_Ds_dV_GP_SI;
          d_Dm_dV_DI_SI = d_Ds_dV_DI_SI;
          Dm = Ds;

          d_Dd_dV_SI_BP = d_Dm_dV_SI_BP;
          d_Dd_dV_GP_SI = d_Dm_dV_GP_SI;
          d_Dd_dV_DI_SI = d_Dm_dV_DI_SI;
          Dd = Dm;

          d_Rxcor_dV_SI_BP = (((1.0+(XCOR_T*Vsbx))*((0.2*XCOR_T)*d_Vsbx_dV_SI_BP)-(1.0+((0.2*XCOR_T)*Vsbx))*(XCOR_T*d_Vsbx_dV_SI_BP))/(1.0+(XCOR_T*Vsbx))/(1.0+(XCOR_T*Vsbx)));
          d_Rxcor_dV_DI_SI = (((1.0+(XCOR_T*Vsbx))*((0.2*XCOR_T)*d_Vsbx_dV_DI_SI)-(1.0+((0.2*XCOR_T)*Vsbx))*(XCOR_T*d_Vsbx_dV_DI_SI))/(1.0+(XCOR_T*Vsbx))/(1.0+(XCOR_T*Vsbx)));
          Rxcor = ((1.0+((0.2*XCOR_T)*Vsbx))/(1.0+(XCOR_T*Vsbx)));
          if ((Ds>1.0e-100))
          {
            {
              double value_sqrt_0 = sqrt((Ps+Ds));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_xgs_dV_SI_BP = ((Gf*(deriv_sqrt_0_d0*((d_Ps_dV_SI_BP+d_Ds_dV_SI_BP))))+(d_Gf_dV_SI_BP*value_sqrt_0));
              d_xgs_dV_GP_SI = ((Gf*(deriv_sqrt_0_d0*((d_Ps_dV_GP_SI+d_Ds_dV_GP_SI))))+(d_Gf_dV_GP_SI*value_sqrt_0));
              d_xgs_dV_DI_SI = ((Gf*(deriv_sqrt_0_d0*((d_Ps_dV_DI_SI+d_Ds_dV_DI_SI))))+(d_Gf_dV_DI_SI*value_sqrt_0));
              xgs = (Gf*value_sqrt_0);
            }

            d_qis_dV_SI_BP = (((xgs+(Gf*sqm))*(((Gf2*Ds)*d_phit1_dV_SI_BP)+(((Gf2*d_Ds_dV_SI_BP)+(d_Gf2_dV_SI_BP*Ds))*phit1))-((Gf2*Ds)*phit1)*(d_xgs_dV_SI_BP+((Gf*d_sqm_dV_SI_BP)+(d_Gf_dV_SI_BP*sqm))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
            d_qis_dV_GP_SI = (((xgs+(Gf*sqm))*(((Gf2*Ds)*d_phit1_dV_GP_SI)+(((Gf2*d_Ds_dV_GP_SI)+(d_Gf2_dV_GP_SI*Ds))*phit1))-((Gf2*Ds)*phit1)*(d_xgs_dV_GP_SI+((Gf*d_sqm_dV_GP_SI)+(d_Gf_dV_GP_SI*sqm))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
            d_qis_dV_DI_SI = (((xgs+(Gf*sqm))*(((Gf2*Ds)*d_phit1_dV_DI_SI)+(((Gf2*d_Ds_dV_DI_SI)+(d_Gf2_dV_DI_SI*Ds))*phit1))-((Gf2*Ds)*phit1)*(d_xgs_dV_DI_SI+((Gf*d_sqm_dV_DI_SI)+(d_Gf_dV_DI_SI*sqm))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
            qis = (((Gf2*Ds)*phit1)/(xgs+(Gf*sqm)));

            d_qbs_dV_SI_BP = (((sqm*Gf)*d_phit1_dV_SI_BP)+(((sqm*d_Gf_dV_SI_BP)+(d_sqm_dV_SI_BP*Gf))*phit1));
            d_qbs_dV_GP_SI = (((sqm*Gf)*d_phit1_dV_GP_SI)+(((sqm*d_Gf_dV_GP_SI)+(d_sqm_dV_GP_SI*Gf))*phit1));
            d_qbs_dV_DI_SI = (((sqm*Gf)*d_phit1_dV_DI_SI)+(((sqm*d_Gf_dV_DI_SI)+(d_sqm_dV_DI_SI*Gf))*phit1));
            qbs = ((sqm*Gf)*phit1);
            if ((RSB_i<0.0))
            {

              d_rhob_dV_SI_BP = (-(-(RSB_i*d_Vsbx_dV_SI_BP))/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
              d_rhob_dV_DI_SI = (-(-(RSB_i*d_Vsbx_dV_DI_SI))/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
              rhob = (1.0/(1.0-(RSB_i*Vsbx)));
            }
            else
            {

              d_rhob_dV_SI_BP = (RSB_i*d_Vsbx_dV_SI_BP);
              d_rhob_dV_DI_SI = (RSB_i*d_Vsbx_dV_DI_SI);
              rhob = (1.0+(RSB_i*Vsbx));
            }
            if ((RSG_i<0.0))
            {

              d_temp_dV_SI_BP = (-(RSG_i*d_qis_dV_SI_BP));
              d_temp_dV_GP_SI = (-(RSG_i*d_qis_dV_GP_SI));
              d_temp_dV_DI_SI = (-(RSG_i*d_qis_dV_DI_SI));
              temp = (1.0-(RSG_i*qis));
            }
            else
            {

              d_temp_dV_SI_BP = (-(RSG_i*d_qis_dV_SI_BP)/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
              d_temp_dV_GP_SI = (-(RSG_i*d_qis_dV_GP_SI)/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
              d_temp_dV_DI_SI = (-(RSG_i*d_qis_dV_DI_SI)/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
              temp = (1.0/(1.0+(RSG_i*qis)));
            }

            d_GR_dV_GP_SI = (THER_i*(((rhob*temp)*d_qis_dV_GP_SI)+((rhob*d_temp_dV_GP_SI)*qis)));
            d_GR_dV_SI_BP = (THER_i*(((rhob*temp)*d_qis_dV_SI_BP)+(((rhob*d_temp_dV_SI_BP)+(d_rhob_dV_SI_BP*temp))*qis)));
            d_GR_dV_DI_SI = (THER_i*(((rhob*temp)*d_qis_dV_DI_SI)+(((rhob*d_temp_dV_DI_SI)+(d_rhob_dV_DI_SI*temp))*qis)));
            GR = (THER_i*((rhob*temp)*qis));

            d_Eeffm_dV_SI_BP = (E_eff0*(d_qbs_dV_SI_BP+(eta_mu*d_qis_dV_SI_BP)));
            d_Eeffm_dV_GP_SI = (E_eff0*(d_qbs_dV_GP_SI+(eta_mu*d_qis_dV_GP_SI)));
            d_Eeffm_dV_DI_SI = (E_eff0*(d_qbs_dV_DI_SI+(eta_mu*d_qis_dV_DI_SI)));
            Eeffm = (E_eff0*(qbs+(eta_mu*qis)));
            {
              double value_pow_0 = pow((Eeffm*MUE_T),THEMU_T);
              double  deriv_pow_0_d0 = (((Eeffm*MUE_T) == 0.0)?0.0:(value_pow_0*THEMU_T/(Eeffm*MUE_T)));

              d_Mutmp_dV_SI_BP = ((deriv_pow_0_d0*((d_Eeffm_dV_SI_BP*MUE_T)))+(CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dV_SI_BP-Ps*(d_Ps_dV_SI_BP+d_Ds_dV_SI_BP))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
              d_Mutmp_dV_GP_SI = ((deriv_pow_0_d0*((d_Eeffm_dV_GP_SI*MUE_T)))+(CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dV_GP_SI-Ps*(d_Ps_dV_GP_SI+d_Ds_dV_GP_SI))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
              d_Mutmp_dV_DI_SI = ((deriv_pow_0_d0*((d_Eeffm_dV_DI_SI*MUE_T)))+(CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dV_DI_SI-Ps*(d_Ps_dV_DI_SI+d_Ds_dV_DI_SI))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
              Mutmp = (value_pow_0+(CS_T*(Ps/((Ps+Ds)+1.0e-14))));
            }

            d_Gmob_dV_SI_BP = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_SI_BP)+((d_Mutmp_dV_SI_BP+d_GR_dV_SI_BP)*Rxcor));
            d_Gmob_dV_GP_SI = ((d_Mutmp_dV_GP_SI+d_GR_dV_GP_SI)*Rxcor);
            d_Gmob_dV_DI_SI = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_DI_SI)+((d_Mutmp_dV_DI_SI+d_GR_dV_DI_SI)*Rxcor));
            Gmob = (((1.0+Mutmp)+GR)*Rxcor);
            if ((THESATB_i<0.0))
            {

              d_xitsb_dV_SI_BP = (-(-(THESATB_i*d_Vsbx_dV_SI_BP))/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
              d_xitsb_dV_DI_SI = (-(-(THESATB_i*d_Vsbx_dV_DI_SI))/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
              xitsb = (1.0/(1.0-(THESATB_i*Vsbx)));
            }
            else
            {

              d_xitsb_dV_SI_BP = (THESATB_i*d_Vsbx_dV_SI_BP);
              d_xitsb_dV_DI_SI = (THESATB_i*d_Vsbx_dV_DI_SI);
              xitsb = (1.0+(THESATB_i*Vsbx));
            }

            d_temp2_dV_SI_BP = ((qis*d_xitsb_dV_SI_BP)+(d_qis_dV_SI_BP*xitsb));
            d_temp2_dV_GP_SI = (d_qis_dV_GP_SI*xitsb);
            d_temp2_dV_DI_SI = ((qis*d_xitsb_dV_DI_SI)+(d_qis_dV_DI_SI*xitsb));
            temp2 = (qis*xitsb);

            d_wsat_dV_SI_BP = (100.0*(((100.0+temp2)*d_temp2_dV_SI_BP-temp2*d_temp2_dV_SI_BP)/(100.0+temp2)/(100.0+temp2)));
            d_wsat_dV_GP_SI = (100.0*(((100.0+temp2)*d_temp2_dV_GP_SI-temp2*d_temp2_dV_GP_SI)/(100.0+temp2)/(100.0+temp2)));
            d_wsat_dV_DI_SI = (100.0*(((100.0+temp2)*d_temp2_dV_DI_SI-temp2*d_temp2_dV_DI_SI)/(100.0+temp2)/(100.0+temp2)));
            wsat = (100.0*(temp2/(100.0+temp2)));
            if ((THESATG_i<0.0))
            {

              d_temp_dV_SI_BP = (-(-(THESATG_i*d_wsat_dV_SI_BP))/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
              d_temp_dV_GP_SI = (-(-(THESATG_i*d_wsat_dV_GP_SI))/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
              d_temp_dV_DI_SI = (-(-(THESATG_i*d_wsat_dV_DI_SI))/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
              temp = (1.0/(1.0-(THESATG_i*wsat)));
            }
            else
            {

              d_temp_dV_SI_BP = (THESATG_i*d_wsat_dV_SI_BP);
              d_temp_dV_GP_SI = (THESATG_i*d_wsat_dV_GP_SI);
              d_temp_dV_DI_SI = (THESATG_i*d_wsat_dV_DI_SI);
              temp = (1.0+(THESATG_i*wsat));
            }

            d_thesat1_dV_SI_BP = (THESAT_T*((Gmob*d_temp_dV_SI_BP-temp*d_Gmob_dV_SI_BP)/Gmob/Gmob));
            d_thesat1_dV_DI_SI = (THESAT_T*((Gmob*d_temp_dV_DI_SI-temp*d_Gmob_dV_DI_SI)/Gmob/Gmob));
            d_thesat1_dV_GP_SI = (THESAT_T*((Gmob*d_temp_dV_GP_SI-temp*d_Gmob_dV_GP_SI)/Gmob/Gmob));
            thesat1 = (THESAT_T*(temp/Gmob));

            d_phi_inf_dV_SI_BP = (((alpha*d_qis_dV_SI_BP-qis*d_alpha_dV_SI_BP)/alpha/alpha)+d_phit1_dV_SI_BP);
            d_phi_inf_dV_GP_SI = (((alpha*d_qis_dV_GP_SI-qis*d_alpha_dV_GP_SI)/alpha/alpha)+d_phit1_dV_GP_SI);
            d_phi_inf_dV_DI_SI = (((alpha*d_qis_dV_DI_SI-qis*d_alpha_dV_DI_SI)/alpha/alpha)+d_phit1_dV_DI_SI);
            phi_inf = ((qis/alpha)+phit1);

            d_ysat_dV_SI_BP = (((thesat1*d_phi_inf_dV_SI_BP)+(d_thesat1_dV_SI_BP*phi_inf))*7.0710678118654746e-01);
            d_ysat_dV_DI_SI = (((thesat1*d_phi_inf_dV_DI_SI)+(d_thesat1_dV_DI_SI*phi_inf))*7.0710678118654746e-01);
            d_ysat_dV_GP_SI = (((thesat1*d_phi_inf_dV_GP_SI)+(d_thesat1_dV_GP_SI*phi_inf))*7.0710678118654746e-01);
            ysat = ((thesat1*phi_inf)*7.0710678118654746e-01);
            if (((model_.CHNL_TYPE)==(-1)))
            {
              {
                double value_sqrt_0 = sqrt((1.0+ysat));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_ysat_dV_SI_BP = ((value_sqrt_0*d_ysat_dV_SI_BP-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_SI_BP)))/value_sqrt_0/value_sqrt_0);
                d_ysat_dV_DI_SI = ((value_sqrt_0*d_ysat_dV_DI_SI-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_DI_SI)))/value_sqrt_0/value_sqrt_0);
                d_ysat_dV_GP_SI = ((value_sqrt_0*d_ysat_dV_GP_SI-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_GP_SI)))/value_sqrt_0/value_sqrt_0);
                ysat = (ysat/value_sqrt_0);
              }
            }
            {
              double value_sqrt_0 = sqrt((1.0+(4.0*ysat)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_za_dV_SI_BP = (-2.0*(deriv_sqrt_0_d0*((4.0*d_ysat_dV_SI_BP)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
              d_za_dV_DI_SI = (-2.0*(deriv_sqrt_0_d0*((4.0*d_ysat_dV_DI_SI)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
              d_za_dV_GP_SI = (-2.0*(deriv_sqrt_0_d0*((4.0*d_ysat_dV_GP_SI)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
              za = (2.0/(1.0+value_sqrt_0));
            }

            d_temp1_dV_SI_BP = ((za*d_ysat_dV_SI_BP)+(d_za_dV_SI_BP*ysat));
            d_temp1_dV_DI_SI = ((za*d_ysat_dV_DI_SI)+(d_za_dV_DI_SI*ysat));
            d_temp1_dV_GP_SI = ((za*d_ysat_dV_GP_SI)+(d_za_dV_GP_SI*ysat));
            temp1 = (za*ysat);

            d_Phi_0_dV_SI_BP = (((phi_inf*za)*(0.86*(((1.0+(4.0*((temp1*temp1)*za)))*((temp1*(-((temp1*d_za_dV_SI_BP)+(d_temp1_dV_SI_BP*za))))+(d_temp1_dV_SI_BP*(1.0-(temp1*za))))-(temp1*(1.0-(temp1*za)))*(4.0*(((temp1*temp1)*d_za_dV_SI_BP)+(((temp1*d_temp1_dV_SI_BP)+(d_temp1_dV_SI_BP*temp1))*za))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf*d_za_dV_SI_BP)+(d_phi_inf_dV_SI_BP*za))*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))));
            d_Phi_0_dV_GP_SI = (((phi_inf*za)*(0.86*(((1.0+(4.0*((temp1*temp1)*za)))*((temp1*(-((temp1*d_za_dV_GP_SI)+(d_temp1_dV_GP_SI*za))))+(d_temp1_dV_GP_SI*(1.0-(temp1*za))))-(temp1*(1.0-(temp1*za)))*(4.0*(((temp1*temp1)*d_za_dV_GP_SI)+(((temp1*d_temp1_dV_GP_SI)+(d_temp1_dV_GP_SI*temp1))*za))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf*d_za_dV_GP_SI)+(d_phi_inf_dV_GP_SI*za))*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))));
            d_Phi_0_dV_DI_SI = (((phi_inf*za)*(0.86*(((1.0+(4.0*((temp1*temp1)*za)))*((temp1*(-((temp1*d_za_dV_DI_SI)+(d_temp1_dV_DI_SI*za))))+(d_temp1_dV_DI_SI*(1.0-(temp1*za))))-(temp1*(1.0-(temp1*za)))*(4.0*(((temp1*temp1)*d_za_dV_DI_SI)+(((temp1*d_temp1_dV_DI_SI)+(d_temp1_dV_DI_SI*temp1))*za))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf*d_za_dV_DI_SI)+(d_phi_inf_dV_DI_SI*za))*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))));
            Phi_0 = ((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));

            d_asat_dV_SI_BP = (d_xgs_dV_SI_BP+(0.5*d_Gf2_dV_SI_BP));
            d_asat_dV_GP_SI = (d_xgs_dV_GP_SI+(0.5*d_Gf2_dV_GP_SI));
            d_asat_dV_DI_SI = (d_xgs_dV_DI_SI+(0.5*d_Gf2_dV_DI_SI));
            asat = (xgs+(0.5*Gf2));
            {
              double value_sqrt_0 = sqrt(((asat*asat)-((Gf2*Ds)*0.98)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_Phi_2_dV_SI_BP = (0.98*(((asat+value_sqrt_0)*(((Gf2*Ds)*d_phit1_dV_SI_BP)+(((Gf2*d_Ds_dV_SI_BP)+(d_Gf2_dV_SI_BP*Ds))*phit1))-((Gf2*Ds)*phit1)*(d_asat_dV_SI_BP+(deriv_sqrt_0_d0*((((asat*d_asat_dV_SI_BP)+(d_asat_dV_SI_BP*asat))-(((Gf2*d_Ds_dV_SI_BP)+(d_Gf2_dV_SI_BP*Ds))*0.98))))))/(asat+value_sqrt_0)/(asat+value_sqrt_0)));
              d_Phi_2_dV_GP_SI = (0.98*(((asat+value_sqrt_0)*(((Gf2*Ds)*d_phit1_dV_GP_SI)+(((Gf2*d_Ds_dV_GP_SI)+(d_Gf2_dV_GP_SI*Ds))*phit1))-((Gf2*Ds)*phit1)*(d_asat_dV_GP_SI+(deriv_sqrt_0_d0*((((asat*d_asat_dV_GP_SI)+(d_asat_dV_GP_SI*asat))-(((Gf2*d_Ds_dV_GP_SI)+(d_Gf2_dV_GP_SI*Ds))*0.98))))))/(asat+value_sqrt_0)/(asat+value_sqrt_0)));
              d_Phi_2_dV_DI_SI = (0.98*(((asat+value_sqrt_0)*(((Gf2*Ds)*d_phit1_dV_DI_SI)+(((Gf2*d_Ds_dV_DI_SI)+(d_Gf2_dV_DI_SI*Ds))*phit1))-((Gf2*Ds)*phit1)*(d_asat_dV_DI_SI+(deriv_sqrt_0_d0*((((asat*d_asat_dV_DI_SI)+(d_asat_dV_DI_SI*asat))-(((Gf2*d_Ds_dV_DI_SI)+(d_Gf2_dV_DI_SI*Ds))*0.98))))))/(asat+value_sqrt_0)/(asat+value_sqrt_0)));
              Phi_2 = (0.98*(((Gf2*Ds)*phit1)/(asat+value_sqrt_0)));
            }

            d_Phi_0_2_dV_SI_BP = (d_Phi_0_dV_SI_BP+d_Phi_2_dV_SI_BP);
            d_Phi_0_2_dV_GP_SI = (d_Phi_0_dV_GP_SI+d_Phi_2_dV_GP_SI);
            d_Phi_0_2_dV_DI_SI = (d_Phi_0_dV_DI_SI+d_Phi_2_dV_DI_SI);
            Phi_0_2 = (Phi_0+Phi_2);

            d_Phi0_Phi2_dV_SI_BP = (2.0*((Phi_0*d_Phi_2_dV_SI_BP)+(d_Phi_0_dV_SI_BP*Phi_2)));
            d_Phi0_Phi2_dV_GP_SI = (2.0*((Phi_0*d_Phi_2_dV_GP_SI)+(d_Phi_0_dV_GP_SI*Phi_2)));
            d_Phi0_Phi2_dV_DI_SI = (2.0*((Phi_0*d_Phi_2_dV_DI_SI)+(d_Phi_0_dV_DI_SI*Phi_2)));
            Phi0_Phi2 = (2.0*(Phi_0*Phi_2));
            {
              double value_sqrt_0 = sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_Phi_sat_dV_SI_BP = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_SI_BP-Phi0_Phi2*(d_Phi_0_2_dV_SI_BP+(deriv_sqrt_0_d0*((((Phi_0_2*d_Phi_0_2_dV_SI_BP)+(d_Phi_0_2_dV_SI_BP*Phi_0_2))-(1.98*d_Phi0_Phi2_dV_SI_BP))))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
              d_Phi_sat_dV_GP_SI = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_GP_SI-Phi0_Phi2*(d_Phi_0_2_dV_GP_SI+(deriv_sqrt_0_d0*((((Phi_0_2*d_Phi_0_2_dV_GP_SI)+(d_Phi_0_2_dV_GP_SI*Phi_0_2))-(1.98*d_Phi0_Phi2_dV_GP_SI))))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
              d_Phi_sat_dV_DI_SI = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_DI_SI-Phi0_Phi2*(d_Phi_0_2_dV_DI_SI+(deriv_sqrt_0_d0*((((Phi_0_2*d_Phi_0_2_dV_DI_SI)+(d_Phi_0_2_dV_DI_SI*Phi_0_2))-(1.98*d_Phi0_Phi2_dV_DI_SI))))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
              Phi_sat = (Phi0_Phi2/(Phi_0_2+value_sqrt_0));
            }
            {
              double value_log_0 = log((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));
              double  deriv_log_0_d0 = (1.0/(1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));

              d_Vdsat_dV_SI_BP = (d_Phi_sat_dV_SI_BP-((phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_SI_BP)+(((Phi_sat*(d_Phi_sat_dV_SI_BP-(((2.0*asat)*d_phit1_dV_SI_BP)+((2.0*d_asat_dV_SI_BP)*phit1))))+(d_Phi_sat_dV_SI_BP*(Phi_sat-((2.0*asat)*phit1))))*inv_Gf2))-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*(((phit1*phit1)*d_Ds_dV_SI_BP)+(((phit1*d_phit1_dV_SI_BP)+(d_phit1_dV_SI_BP*phit1))*Ds)))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds)))))+(d_phit1_dV_SI_BP*value_log_0)));
              d_Vdsat_dV_GP_SI = (d_Phi_sat_dV_GP_SI-((phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_GP_SI)+(((Phi_sat*(d_Phi_sat_dV_GP_SI-(((2.0*asat)*d_phit1_dV_GP_SI)+((2.0*d_asat_dV_GP_SI)*phit1))))+(d_Phi_sat_dV_GP_SI*(Phi_sat-((2.0*asat)*phit1))))*inv_Gf2))-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*(((phit1*phit1)*d_Ds_dV_GP_SI)+(((phit1*d_phit1_dV_GP_SI)+(d_phit1_dV_GP_SI*phit1))*Ds)))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds)))))+(d_phit1_dV_GP_SI*value_log_0)));
              d_Vdsat_dV_DI_SI = (d_Phi_sat_dV_DI_SI-((phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_DI_SI)+(((Phi_sat*(d_Phi_sat_dV_DI_SI-(((2.0*asat)*d_phit1_dV_DI_SI)+((2.0*d_asat_dV_DI_SI)*phit1))))+(d_Phi_sat_dV_DI_SI*(Phi_sat-((2.0*asat)*phit1))))*inv_Gf2))-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*(((phit1*phit1)*d_Ds_dV_DI_SI)+(((phit1*d_phit1_dV_DI_SI)+(d_phit1_dV_DI_SI*phit1))*Ds)))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds)))))+(d_phit1_dV_DI_SI*value_log_0)));
              Vdsat = (Phi_sat-(phit1*value_log_0));
            }
          }
          else
          {

            d_Vdsat_dV_GP_SI =  0.0;
            d_Vdsat_dV_SI_BP = d_Vdsat_lim_dV_SI_BP;
            d_Vdsat_dV_DI_SI = d_Vdsat_lim_dV_DI_SI;
            Vdsat = Vdsat_lim;
          }
          {
            double value_pow_0 = pow((Vds/Vdsat),AX_i);
            double  deriv_pow_0_d0 = (((Vds/Vdsat) == 0.0)?0.0:(value_pow_0*AX_i/(Vds/Vdsat)));

            d_temp_dV_SI_BP = (deriv_pow_0_d0*((-Vds*d_Vdsat_dV_SI_BP/Vdsat/Vdsat)));
            d_temp_dV_GP_SI = (deriv_pow_0_d0*((-Vds*d_Vdsat_dV_GP_SI/Vdsat/Vdsat)));
            d_temp_dV_DI_SI = (deriv_pow_0_d0*(((Vdsat*d_Vds_dV_DI_SI-Vds*d_Vdsat_dV_DI_SI)/Vdsat/Vdsat)));
            temp = value_pow_0;
          }
          {
            double value_pow_0 = pow((1.0+temp),(-inv_AX));
            double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-inv_AX)/(1.0+temp)));

            d_Vdse_dV_SI_BP = (Vds*(deriv_pow_0_d0*(d_temp_dV_SI_BP)));
            d_Vdse_dV_GP_SI = (Vds*(deriv_pow_0_d0*(d_temp_dV_GP_SI)));
            d_Vdse_dV_DI_SI = ((Vds*(deriv_pow_0_d0*(d_temp_dV_DI_SI)))+(d_Vds_dV_DI_SI*value_pow_0));
            Vdse = (Vds*value_pow_0);
          }

          d_Udse_dV_DI_SI = ((Vdse*d_inv_phit1_dV_DI_SI)+(d_Vdse_dV_DI_SI*inv_phit1));
          d_Udse_dV_SI_BP = ((Vdse*d_inv_phit1_dV_SI_BP)+(d_Vdse_dV_SI_BP*inv_phit1));
          d_Udse_dV_GP_SI = ((Vdse*d_inv_phit1_dV_GP_SI)+(d_Vdse_dV_GP_SI*inv_phit1));
          Udse = (Vdse*inv_phit1);

          d_xn_d_dV_GP_SI = d_Udse_dV_GP_SI;
          d_xn_d_dV_SI_BP = (d_xn_s_dV_SI_BP+d_Udse_dV_SI_BP);
          d_xn_d_dV_DI_SI = (d_xn_s_dV_DI_SI+d_Udse_dV_DI_SI);
          xn_d = (xn_s+Udse);
          if ((Udse<4.6051701859880916e+02))
          {
            {
              double value_exp_0 = exp((-Udse));
              double  deriv_exp_0_d0 = value_exp_0;

              d_k_ds_dV_DI_SI = (deriv_exp_0_d0*((-d_Udse_dV_DI_SI)));
              d_k_ds_dV_SI_BP = (deriv_exp_0_d0*((-d_Udse_dV_SI_BP)));
              d_k_ds_dV_GP_SI = (deriv_exp_0_d0*((-d_Udse_dV_GP_SI)));
              k_ds = value_exp_0;
            }
          }
          else
          {

            d_k_ds_dV_DI_SI = (-1.0e-200*(((Udse-4.6051701859880916e+02)*(0.5*(((Udse-4.6051701859880916e+02)*(d_Udse_dV_DI_SI*3.3333333333333333e-01))+(d_Udse_dV_DI_SI*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_Udse_dV_DI_SI*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
            d_k_ds_dV_SI_BP = (-1.0e-200*(((Udse-4.6051701859880916e+02)*(0.5*(((Udse-4.6051701859880916e+02)*(d_Udse_dV_SI_BP*3.3333333333333333e-01))+(d_Udse_dV_SI_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_Udse_dV_SI_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
            d_k_ds_dV_GP_SI = (-1.0e-200*(((Udse-4.6051701859880916e+02)*(0.5*(((Udse-4.6051701859880916e+02)*(d_Udse_dV_GP_SI*3.3333333333333333e-01))+(d_Udse_dV_GP_SI*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_Udse_dV_GP_SI*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
            k_ds = (1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
          }

          d_delta_nd_dV_GP_SI = (delta_ns*d_k_ds_dV_GP_SI);
          d_delta_nd_dV_SI_BP = ((delta_ns*d_k_ds_dV_SI_BP)+(d_delta_ns_dV_SI_BP*k_ds));
          d_delta_nd_dV_DI_SI = ((delta_ns*d_k_ds_dV_DI_SI)+(d_delta_ns_dV_DI_SI*k_ds));
          delta_nd = (delta_ns*k_ds);
          if ((fabs(xg)<=margin))
          {

            d_SP_S_temp1_dV_SI_BP = ((((inv_xi*d_inv_xi_dV_SI_BP)+(d_inv_xi_dV_SI_BP*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
            d_SP_S_temp1_dV_GP_SI = ((((inv_xi*d_inv_xi_dV_GP_SI)+(d_inv_xi_dV_GP_SI*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
            d_SP_S_temp1_dV_DI_SI = ((((inv_xi*d_inv_xi_dV_DI_SI)+(d_inv_xi_dV_DI_SI*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
            SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);

            d_x_d_dV_SI_BP = (((xg*inv_xi)*((((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_SI_BP)+((((xg*(1.0-delta_nd))*d_Gf_dV_SI_BP)+(((xg*(-d_delta_nd_dV_SI_BP))+(d_xg_dV_SI_BP*(1.0-delta_nd)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_SI_BP)+(d_xg_dV_SI_BP*inv_xi))*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1))));
            d_x_d_dV_GP_SI = (((xg*inv_xi)*((((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_GP_SI)+((((xg*(1.0-delta_nd))*d_Gf_dV_GP_SI)+(((xg*(-d_delta_nd_dV_GP_SI))+(d_xg_dV_GP_SI*(1.0-delta_nd)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_GP_SI)+(d_xg_dV_GP_SI*inv_xi))*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1))));
            d_x_d_dV_DI_SI = (((xg*inv_xi)*((((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_DI_SI)+((((xg*(1.0-delta_nd))*d_Gf_dV_DI_SI)+(((xg*(-d_delta_nd_dV_DI_SI))+(d_xg_dV_DI_SI*(1.0-delta_nd)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_DI_SI)+(d_xg_dV_DI_SI*inv_xi))*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1))));
            x_d = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
          }
          else
          {

            d_SP_S_bx_dV_GP_SI = d_xn_d_dV_GP_SI;
            d_SP_S_bx_dV_SI_BP = d_xn_d_dV_SI_BP;
            d_SP_S_bx_dV_DI_SI = d_xn_d_dV_DI_SI;
            SP_S_bx = (xn_d+3);
            {
              double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
              double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
              double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

              d_SP_S_eta_dV_SI_BP = ((0.5*((d_SP_S_x1_dV_SI_BP+d_SP_S_bx_dV_SI_BP)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP))+((d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_SI_BP-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_SI_BP)+(d_SP_S_bx_dV_SI_BP*SP_S_bx)))))));
              d_SP_S_eta_dV_GP_SI = ((0.5*((d_SP_S_x1_dV_GP_SI+d_SP_S_bx_dV_GP_SI)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI))+((d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_GP_SI-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_GP_SI)+(d_SP_S_bx_dV_GP_SI*SP_S_bx)))))));
              d_SP_S_eta_dV_DI_SI = ((0.5*((d_SP_S_x1_dV_DI_SI+d_SP_S_bx_dV_DI_SI)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI))+((d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_DI_SI-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_DI_SI)+(d_SP_S_bx_dV_DI_SI*SP_S_bx)))))));
              SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
            }

            d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_eta_dV_SI_BP);
            d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_eta_dV_GP_SI);
            d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_eta_dV_DI_SI);
            SP_S_temp = (xg-SP_S_eta);
            {
              double value_exp_0 = exp((-SP_S_eta));
              double  deriv_exp_0_d0 = value_exp_0;

              d_SP_S_temp1_dV_SI_BP = (deriv_exp_0_d0*((-d_SP_S_eta_dV_SI_BP)));
              d_SP_S_temp1_dV_GP_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_GP_SI)));
              d_SP_S_temp1_dV_DI_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_DI_SI)));
              SP_S_temp1 = value_exp_0;
            }

            d_SP_S_temp2_dV_SI_BP = (-((SP_S_eta*d_SP_S_eta_dV_SI_BP)+(d_SP_S_eta_dV_SI_BP*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
            d_SP_S_temp2_dV_GP_SI = (-((SP_S_eta*d_SP_S_eta_dV_GP_SI)+(d_SP_S_eta_dV_GP_SI*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
            d_SP_S_temp2_dV_DI_SI = (-((SP_S_eta*d_SP_S_eta_dV_DI_SI)+(d_SP_S_eta_dV_DI_SI*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
            SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));

            d_SP_S_xi0_dV_SI_BP = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_SI_BP)+(((SP_S_eta*d_SP_S_eta_dV_SI_BP)+(d_SP_S_eta_dV_SI_BP*SP_S_eta))*SP_S_temp2));
            d_SP_S_xi0_dV_GP_SI = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_GP_SI)+(((SP_S_eta*d_SP_S_eta_dV_GP_SI)+(d_SP_S_eta_dV_GP_SI*SP_S_eta))*SP_S_temp2));
            d_SP_S_xi0_dV_DI_SI = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_DI_SI)+(((SP_S_eta*d_SP_S_eta_dV_DI_SI)+(d_SP_S_eta_dV_DI_SI*SP_S_eta))*SP_S_temp2));
            SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);

            d_SP_S_xi1_dV_SI_BP = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP)+(((SP_S_eta*d_SP_S_temp2_dV_SI_BP)+(d_SP_S_eta_dV_SI_BP*SP_S_temp2))*SP_S_temp2)));
            d_SP_S_xi1_dV_GP_SI = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI)+(((SP_S_eta*d_SP_S_temp2_dV_GP_SI)+(d_SP_S_eta_dV_GP_SI*SP_S_temp2))*SP_S_temp2)));
            d_SP_S_xi1_dV_DI_SI = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI)+(((SP_S_eta*d_SP_S_temp2_dV_DI_SI)+(d_SP_S_eta_dV_DI_SI*SP_S_temp2))*SP_S_temp2)));
            SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));

            d_SP_S_xi2_dV_SI_BP = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_SI_BP)+(((8.0*d_SP_S_temp2_dV_SI_BP)-(12.0*d_SP_S_xi0_dV_SI_BP))*SP_S_temp2))*SP_S_temp2));
            d_SP_S_xi2_dV_GP_SI = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_GP_SI)+(((8.0*d_SP_S_temp2_dV_GP_SI)-(12.0*d_SP_S_xi0_dV_GP_SI))*SP_S_temp2))*SP_S_temp2));
            d_SP_S_xi2_dV_DI_SI = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_DI_SI)+(((8.0*d_SP_S_temp2_dV_DI_SI)-(12.0*d_SP_S_xi0_dV_DI_SI))*SP_S_temp2))*SP_S_temp2));
            SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
            {
              double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))));
              double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);

              d_SP_S_a_dV_SI_BP = 0.0;
              d_SP_S_a_dV_GP_SI = 0.0;
              d_SP_S_a_dV_DI_SI = 0.0;
              SP_S_a = value_max_0;
            }

            d_SP_S_b_dV_SI_BP = (-(0.5*((Gf2*(d_SP_S_temp1_dV_SI_BP-((delta_nd*d_SP_S_xi2_dV_SI_BP)+(d_delta_nd_dV_SI_BP*SP_S_xi2))))+(d_Gf2_dV_SI_BP*(SP_S_temp1-(delta_nd*SP_S_xi2))))));
            d_SP_S_b_dV_GP_SI = (-(0.5*((Gf2*(d_SP_S_temp1_dV_GP_SI-((delta_nd*d_SP_S_xi2_dV_GP_SI)+(d_delta_nd_dV_GP_SI*SP_S_xi2))))+(d_Gf2_dV_GP_SI*(SP_S_temp1-(delta_nd*SP_S_xi2))))));
            d_SP_S_b_dV_DI_SI = (-(0.5*((Gf2*(d_SP_S_temp1_dV_DI_SI-((delta_nd*d_SP_S_xi2_dV_DI_SI)+(d_delta_nd_dV_DI_SI*SP_S_xi2))))+(d_Gf2_dV_DI_SI*(SP_S_temp1-(delta_nd*SP_S_xi2))))));
            SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))));

            d_SP_S_c_dV_SI_BP = ((2.0*d_SP_S_temp_dV_SI_BP)+((Gf2*((-d_SP_S_temp1_dV_SI_BP)-((delta_nd*d_SP_S_xi1_dV_SI_BP)+(d_delta_nd_dV_SI_BP*(1.0+SP_S_xi1)))))+(d_Gf2_dV_SI_BP*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1))))));
            d_SP_S_c_dV_GP_SI = ((2.0*d_SP_S_temp_dV_GP_SI)+((Gf2*((-d_SP_S_temp1_dV_GP_SI)-((delta_nd*d_SP_S_xi1_dV_GP_SI)+(d_delta_nd_dV_GP_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_GP_SI*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1))))));
            d_SP_S_c_dV_DI_SI = ((2.0*d_SP_S_temp_dV_DI_SI)+((Gf2*((-d_SP_S_temp1_dV_DI_SI)-((delta_nd*d_SP_S_xi1_dV_DI_SI)+(d_delta_nd_dV_DI_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_DI_SI*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1))))));
            SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
            {
              double value_log_0 = log((SP_S_a/Gf2));
              double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));

              d_SP_S_tau_dV_GP_SI = ((d_xn_d_dV_GP_SI-d_SP_S_eta_dV_GP_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_GP_SI-SP_S_a*d_Gf2_dV_GP_SI)/Gf2/Gf2))));
              d_SP_S_tau_dV_SI_BP = ((d_xn_d_dV_SI_BP-d_SP_S_eta_dV_SI_BP)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_SI_BP-SP_S_a*d_Gf2_dV_SI_BP)/Gf2/Gf2))));
              d_SP_S_tau_dV_DI_SI = ((d_xn_d_dV_DI_SI-d_SP_S_eta_dV_DI_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_DI_SI-SP_S_a*d_Gf2_dV_DI_SI)/Gf2/Gf2))));
              SP_S_tau = ((xn_d-SP_S_eta)+value_log_0);
            }

            d_nu_dV_SI_BP = (d_SP_S_a_dV_SI_BP+d_SP_S_c_dV_SI_BP);
            d_nu_dV_GP_SI = (d_SP_S_a_dV_GP_SI+d_SP_S_c_dV_GP_SI);
            d_nu_dV_DI_SI = (d_SP_S_a_dV_DI_SI+d_SP_S_c_dV_DI_SI);
            nu = (SP_S_a+SP_S_c);

            d_mutau_dV_SI_BP = (((nu*d_nu_dV_SI_BP)+(d_nu_dV_SI_BP*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_SI_BP)+(d_SP_S_c_dV_SI_BP*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*SP_S_b))))+(d_SP_S_tau_dV_SI_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
            d_mutau_dV_GP_SI = (((nu*d_nu_dV_GP_SI)+(d_nu_dV_GP_SI*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_GP_SI)+(d_SP_S_c_dV_GP_SI*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*SP_S_b))))+(d_SP_S_tau_dV_GP_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
            d_mutau_dV_DI_SI = (((nu*d_nu_dV_DI_SI)+(d_nu_dV_DI_SI*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_DI_SI)+(d_SP_S_c_dV_DI_SI*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*SP_S_b))))+(d_SP_S_tau_dV_DI_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
            mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));

            d_SP_S_x0_dV_SI_BP = (d_SP_S_eta_dV_SI_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_SI_BP)+(((SP_S_a*d_nu_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_SI_BP+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_SI_BP)+(d_SP_S_c_dV_SI_BP*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_SI_BP)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_SI_BP)+((((nu/mutau)*d_SP_S_tau_dV_SI_BP)+(((mutau*d_nu_dV_SI_BP-nu*d_mutau_dV_SI_BP)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
            d_SP_S_x0_dV_GP_SI = (d_SP_S_eta_dV_GP_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_GP_SI)+(((SP_S_a*d_nu_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_SI+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_GP_SI)+(d_SP_S_c_dV_GP_SI*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_SI)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_SI)+((((nu/mutau)*d_SP_S_tau_dV_GP_SI)+(((mutau*d_nu_dV_GP_SI-nu*d_mutau_dV_GP_SI)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
            d_SP_S_x0_dV_DI_SI = (d_SP_S_eta_dV_DI_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_DI_SI)+(((SP_S_a*d_nu_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_DI_SI+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_DI_SI)+(d_SP_S_c_dV_DI_SI*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_DI_SI)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_DI_SI)+((((nu/mutau)*d_SP_S_tau_dV_DI_SI)+(((mutau*d_nu_dV_DI_SI-nu*d_mutau_dV_DI_SI)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
            SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
            if ((SP_S_x0<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(SP_S_x0);
                double  deriv_exp_0_d0 = value_exp_0;

                d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*(d_SP_S_x0_dV_SI_BP));
                d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_SI));
                d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_DI_SI));
                SP_S_delta0 = value_exp_0;
              }

              d_SP_S_delta1_dV_SI_BP = (-d_SP_S_delta0_dV_SI_BP/SP_S_delta0/SP_S_delta0);
              d_SP_S_delta1_dV_GP_SI = (-d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
              d_SP_S_delta1_dV_DI_SI = (-d_SP_S_delta0_dV_DI_SI/SP_S_delta0/SP_S_delta0);
              SP_S_delta1 = (1.0/SP_S_delta0);

              d_SP_S_delta0_dV_GP_SI = ((delta_nd*d_SP_S_delta0_dV_GP_SI)+(d_delta_nd_dV_GP_SI*SP_S_delta0));
              d_SP_S_delta0_dV_SI_BP = ((delta_nd*d_SP_S_delta0_dV_SI_BP)+(d_delta_nd_dV_SI_BP*SP_S_delta0));
              d_SP_S_delta0_dV_DI_SI = ((delta_nd*d_SP_S_delta0_dV_DI_SI)+(d_delta_nd_dV_DI_SI*SP_S_delta0));
              SP_S_delta0 = (delta_nd*SP_S_delta0);
            }
            else
            {
              if ((SP_S_x0>(xn_d-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp((SP_S_x0-xn_d));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*((d_SP_S_x0_dV_SI_BP-d_xn_d_dV_SI_BP)));
                  d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_GP_SI-d_xn_d_dV_GP_SI)));
                  d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_DI_SI-d_xn_d_dV_DI_SI)));
                  SP_S_delta0 = value_exp_0;
                }

                d_SP_S_delta1_dV_GP_SI = ((SP_S_delta0*d_delta_nd_dV_GP_SI-delta_nd*d_SP_S_delta0_dV_GP_SI)/SP_S_delta0/SP_S_delta0);
                d_SP_S_delta1_dV_SI_BP = ((SP_S_delta0*d_delta_nd_dV_SI_BP-delta_nd*d_SP_S_delta0_dV_SI_BP)/SP_S_delta0/SP_S_delta0);
                d_SP_S_delta1_dV_DI_SI = ((SP_S_delta0*d_delta_nd_dV_DI_SI-delta_nd*d_SP_S_delta0_dV_DI_SI)/SP_S_delta0/SP_S_delta0);
                SP_S_delta1 = (delta_nd/SP_S_delta0);
              }
              else
              {

                d_SP_S_delta0_dV_GP_SI = (-1.0e-100*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*((d_xn_d_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*3.3333333333333333e-01))+((d_xn_d_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_SP_S_delta0_dV_SI_BP = (-1.0e-100*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*((d_xn_d_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*3.3333333333333333e-01))+((d_xn_d_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_SP_S_delta0_dV_DI_SI = (-1.0e-100*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*((d_xn_d_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*3.3333333333333333e-01))+((d_xn_d_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                SP_S_delta0 = (1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

                d_SP_S_delta1_dV_SI_BP = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_SI_BP*3.3333333333333333e-01))+(d_SP_S_x0_dV_SI_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_SI_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_SP_S_delta1_dV_GP_SI = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_GP_SI*3.3333333333333333e-01))+(d_SP_S_x0_dV_GP_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_GP_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_SP_S_delta1_dV_DI_SI = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_DI_SI*3.3333333333333333e-01))+(d_SP_S_x0_dV_DI_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_DI_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }

            d_SP_S_temp_dV_SI_BP = (-((SP_S_x0*d_SP_S_x0_dV_SI_BP)+(d_SP_S_x0_dV_SI_BP*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
            d_SP_S_temp_dV_GP_SI = (-((SP_S_x0*d_SP_S_x0_dV_GP_SI)+(d_SP_S_x0_dV_GP_SI*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
            d_SP_S_temp_dV_DI_SI = (-((SP_S_x0*d_SP_S_x0_dV_DI_SI)+(d_SP_S_x0_dV_DI_SI*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
            SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));

            d_SP_S_xi0_dV_SI_BP = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_SI_BP)+(((SP_S_x0*d_SP_S_x0_dV_SI_BP)+(d_SP_S_x0_dV_SI_BP*SP_S_x0))*SP_S_temp));
            d_SP_S_xi0_dV_GP_SI = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_GP_SI)+(((SP_S_x0*d_SP_S_x0_dV_GP_SI)+(d_SP_S_x0_dV_GP_SI*SP_S_x0))*SP_S_temp));
            d_SP_S_xi0_dV_DI_SI = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_DI_SI)+(((SP_S_x0*d_SP_S_x0_dV_DI_SI)+(d_SP_S_x0_dV_DI_SI*SP_S_x0))*SP_S_temp));
            SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);

            d_SP_S_xi1_dV_SI_BP = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_SI_BP)+(((SP_S_x0*d_SP_S_temp_dV_SI_BP)+(d_SP_S_x0_dV_SI_BP*SP_S_temp))*SP_S_temp)));
            d_SP_S_xi1_dV_GP_SI = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_GP_SI)+(((SP_S_x0*d_SP_S_temp_dV_GP_SI)+(d_SP_S_x0_dV_GP_SI*SP_S_temp))*SP_S_temp)));
            d_SP_S_xi1_dV_DI_SI = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_DI_SI)+(((SP_S_x0*d_SP_S_temp_dV_DI_SI)+(d_SP_S_x0_dV_DI_SI*SP_S_temp))*SP_S_temp)));
            SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));

            d_SP_S_xi2_dV_SI_BP = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_SI_BP)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_SI_BP)+(((8.0*d_SP_S_temp_dV_SI_BP)-(12.0*d_SP_S_xi0_dV_SI_BP))*SP_S_temp))*SP_S_temp));
            d_SP_S_xi2_dV_GP_SI = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_SI)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_SI)+(((8.0*d_SP_S_temp_dV_GP_SI)-(12.0*d_SP_S_xi0_dV_GP_SI))*SP_S_temp))*SP_S_temp));
            d_SP_S_xi2_dV_DI_SI = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_DI_SI)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_DI_SI)+(((8.0*d_SP_S_temp_dV_DI_SI)-(12.0*d_SP_S_xi0_dV_DI_SI))*SP_S_temp))*SP_S_temp));
            SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

            d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_x0_dV_SI_BP);
            d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_x0_dV_GP_SI);
            d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_x0_dV_DI_SI);
            SP_S_temp = (xg-SP_S_x0);

            d_SP_S_pC_dV_SI_BP = ((2.0*d_SP_S_temp_dV_SI_BP)+((Gf2*(((-d_SP_S_delta1_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-((delta_nd*d_SP_S_xi1_dV_SI_BP)+(d_delta_nd_dV_SI_BP*(1.0+SP_S_xi1)))))+(d_Gf2_dV_SI_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1))))));
            d_SP_S_pC_dV_GP_SI = ((2.0*d_SP_S_temp_dV_GP_SI)+((Gf2*(((-d_SP_S_delta1_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-((delta_nd*d_SP_S_xi1_dV_GP_SI)+(d_delta_nd_dV_GP_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_GP_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1))))));
            d_SP_S_pC_dV_DI_SI = ((2.0*d_SP_S_temp_dV_DI_SI)+((Gf2*(((-d_SP_S_delta1_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-((delta_nd*d_SP_S_xi1_dV_DI_SI)+(d_delta_nd_dV_DI_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_DI_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1))))));
            SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));

            d_SP_S_qC_dV_SI_BP = (((SP_S_temp*d_SP_S_temp_dV_SI_BP)+(d_SP_S_temp_dV_SI_BP*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_SI_BP+d_SP_S_x0_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-((delta_nd*(d_SP_S_x0_dV_SI_BP+d_SP_S_xi0_dV_SI_BP))+(d_delta_nd_dV_SI_BP*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_SI_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0))))));
            d_SP_S_qC_dV_GP_SI = (((SP_S_temp*d_SP_S_temp_dV_GP_SI)+(d_SP_S_temp_dV_GP_SI*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_GP_SI+d_SP_S_x0_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-((delta_nd*(d_SP_S_x0_dV_GP_SI+d_SP_S_xi0_dV_GP_SI))+(d_delta_nd_dV_GP_SI*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_GP_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0))))));
            d_SP_S_qC_dV_DI_SI = (((SP_S_temp*d_SP_S_temp_dV_DI_SI)+(d_SP_S_temp_dV_DI_SI*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_DI_SI+d_SP_S_x0_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-((delta_nd*(d_SP_S_x0_dV_DI_SI+d_SP_S_xi0_dV_DI_SI))+(d_delta_nd_dV_DI_SI*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_DI_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0))))));
            SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));

            d_SP_S_temp_dV_SI_BP = (-((Gf2*((d_SP_S_delta1_dV_SI_BP+d_SP_S_delta0_dV_SI_BP)-((delta_nd*d_SP_S_xi2_dV_SI_BP)+(d_delta_nd_dV_SI_BP*SP_S_xi2))))+(d_Gf2_dV_SI_BP*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2)))));
            d_SP_S_temp_dV_GP_SI = (-((Gf2*((d_SP_S_delta1_dV_GP_SI+d_SP_S_delta0_dV_GP_SI)-((delta_nd*d_SP_S_xi2_dV_GP_SI)+(d_delta_nd_dV_GP_SI*SP_S_xi2))))+(d_Gf2_dV_GP_SI*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2)))));
            d_SP_S_temp_dV_DI_SI = (-((Gf2*((d_SP_S_delta1_dV_DI_SI+d_SP_S_delta0_dV_DI_SI)-((delta_nd*d_SP_S_xi2_dV_DI_SI)+(d_delta_nd_dV_DI_SI*SP_S_xi2))))+(d_Gf2_dV_DI_SI*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2)))));
            SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));

            d_SP_S_temp_dV_SI_BP = (((SP_S_pC*d_SP_S_pC_dV_SI_BP)+(d_SP_S_pC_dV_SI_BP*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_SI_BP)+(d_SP_S_qC_dV_SI_BP*SP_S_temp))));
            d_SP_S_temp_dV_GP_SI = (((SP_S_pC*d_SP_S_pC_dV_GP_SI)+(d_SP_S_pC_dV_GP_SI*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_GP_SI)+(d_SP_S_qC_dV_GP_SI*SP_S_temp))));
            d_SP_S_temp_dV_DI_SI = (((SP_S_pC*d_SP_S_pC_dV_DI_SI)+(d_SP_S_pC_dV_DI_SI*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_DI_SI)+(d_SP_S_qC_dV_DI_SI*SP_S_temp))));
            SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
            {
              double value_sqrt_0 = sqrt(SP_S_temp);
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_x_d_dV_SI_BP = (d_SP_S_x0_dV_SI_BP+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_SI_BP-SP_S_qC*(d_SP_S_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_SI_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
              d_x_d_dV_GP_SI = (d_SP_S_x0_dV_GP_SI+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_SI-SP_S_qC*(d_SP_S_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
              d_x_d_dV_DI_SI = (d_SP_S_x0_dV_DI_SI+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_DI_SI-SP_S_qC*(d_SP_S_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_DI_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
              x_d = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
            }
          }

          d_x_ds_dV_SI_BP = (d_x_d_dV_SI_BP-d_x_s_dV_SI_BP);
          d_x_ds_dV_GP_SI = (d_x_d_dV_GP_SI-d_x_s_dV_GP_SI);
          d_x_ds_dV_DI_SI = (d_x_d_dV_DI_SI-d_x_s_dV_DI_SI);
          x_ds = (x_d-x_s);
          if ((x_ds<1.0e-10))
          {

            d_pC_dV_SI_BP = ((2.0*(d_xg_dV_SI_BP-d_x_s_dV_SI_BP))+((Gf2*(((-d_Es_dV_SI_BP)+((delta_1s*d_k_ds_dV_SI_BP)+(d_delta_1s_dV_SI_BP*k_ds)))-((delta_nd*d_xi1s_dV_SI_BP)+(d_delta_nd_dV_SI_BP*(1.0+xi1s)))))+(d_Gf2_dV_SI_BP*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s))))));
            d_pC_dV_GP_SI = ((2.0*(d_xg_dV_GP_SI-d_x_s_dV_GP_SI))+((Gf2*(((-d_Es_dV_GP_SI)+((delta_1s*d_k_ds_dV_GP_SI)+(d_delta_1s_dV_GP_SI*k_ds)))-((delta_nd*d_xi1s_dV_GP_SI)+(d_delta_nd_dV_GP_SI*(1.0+xi1s)))))+(d_Gf2_dV_GP_SI*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s))))));
            d_pC_dV_DI_SI = ((2.0*(d_xg_dV_DI_SI-d_x_s_dV_DI_SI))+((Gf2*(((-d_Es_dV_DI_SI)+((delta_1s*d_k_ds_dV_DI_SI)+(d_delta_1s_dV_DI_SI*k_ds)))-((delta_nd*d_xi1s_dV_DI_SI)+(d_delta_nd_dV_DI_SI*(1.0+xi1s)))))+(d_Gf2_dV_DI_SI*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s))))));
            pC = ((2.0*(xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));

            d_qC_dV_SI_BP = (((Gf2*(1.0-k_ds))*d_Ds_dV_SI_BP)+(((Gf2*(-d_k_ds_dV_SI_BP))+(d_Gf2_dV_SI_BP*(1.0-k_ds)))*Ds));
            d_qC_dV_GP_SI = (((Gf2*(1.0-k_ds))*d_Ds_dV_GP_SI)+(((Gf2*(-d_k_ds_dV_GP_SI))+(d_Gf2_dV_GP_SI*(1.0-k_ds)))*Ds));
            d_qC_dV_DI_SI = (((Gf2*(1.0-k_ds))*d_Ds_dV_DI_SI)+(((Gf2*(-d_k_ds_dV_DI_SI))+(d_Gf2_dV_DI_SI*(1.0-k_ds)))*Ds));
            qC = ((Gf2*(1.0-k_ds))*Ds);

            d_temp_dV_SI_BP = (-((Gf2*((d_Es_dV_SI_BP+((delta_1s*d_k_ds_dV_SI_BP)+(d_delta_1s_dV_SI_BP*k_ds)))-((delta_nd*d_xi2s_dV_SI_BP)+(d_delta_nd_dV_SI_BP*xi2s))))+(d_Gf2_dV_SI_BP*((Es+(delta_1s*k_ds))-(delta_nd*xi2s)))));
            d_temp_dV_GP_SI = (-((Gf2*((d_Es_dV_GP_SI+((delta_1s*d_k_ds_dV_GP_SI)+(d_delta_1s_dV_GP_SI*k_ds)))-((delta_nd*d_xi2s_dV_GP_SI)+(d_delta_nd_dV_GP_SI*xi2s))))+(d_Gf2_dV_GP_SI*((Es+(delta_1s*k_ds))-(delta_nd*xi2s)))));
            d_temp_dV_DI_SI = (-((Gf2*((d_Es_dV_DI_SI+((delta_1s*d_k_ds_dV_DI_SI)+(d_delta_1s_dV_DI_SI*k_ds)))-((delta_nd*d_xi2s_dV_DI_SI)+(d_delta_nd_dV_DI_SI*xi2s))))+(d_Gf2_dV_DI_SI*((Es+(delta_1s*k_ds))-(delta_nd*xi2s)))));
            temp = (2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));

            d_temp_dV_SI_BP = (((pC*d_pC_dV_SI_BP)+(d_pC_dV_SI_BP*pC))-(2.0*((temp*d_qC_dV_SI_BP)+(d_temp_dV_SI_BP*qC))));
            d_temp_dV_GP_SI = (((pC*d_pC_dV_GP_SI)+(d_pC_dV_GP_SI*pC))-(2.0*((temp*d_qC_dV_GP_SI)+(d_temp_dV_GP_SI*qC))));
            d_temp_dV_DI_SI = (((pC*d_pC_dV_DI_SI)+(d_pC_dV_DI_SI*pC))-(2.0*((temp*d_qC_dV_DI_SI)+(d_temp_dV_DI_SI*qC))));
            temp = ((pC*pC)-(2.0*(temp*qC)));
            {
              double value_sqrt_0 = sqrt(temp);
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_x_ds_dV_SI_BP = (2.0*(((pC+value_sqrt_0)*d_qC_dV_SI_BP-qC*(d_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_temp_dV_SI_BP))))/(pC+value_sqrt_0)/(pC+value_sqrt_0)));
              d_x_ds_dV_GP_SI = (2.0*(((pC+value_sqrt_0)*d_qC_dV_GP_SI-qC*(d_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_temp_dV_GP_SI))))/(pC+value_sqrt_0)/(pC+value_sqrt_0)));
              d_x_ds_dV_DI_SI = (2.0*(((pC+value_sqrt_0)*d_qC_dV_DI_SI-qC*(d_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_temp_dV_DI_SI))))/(pC+value_sqrt_0)/(pC+value_sqrt_0)));
              x_ds = (2.0*(qC/(pC+value_sqrt_0)));
            }

            d_x_d_dV_SI_BP = (d_x_s_dV_SI_BP+d_x_ds_dV_SI_BP);
            d_x_d_dV_GP_SI = (d_x_s_dV_GP_SI+d_x_ds_dV_GP_SI);
            d_x_d_dV_DI_SI = (d_x_s_dV_DI_SI+d_x_ds_dV_DI_SI);
            x_d = (x_s+x_ds);
          }

          d_dps_dV_SI_BP = ((x_ds*d_phit1_dV_SI_BP)+(d_x_ds_dV_SI_BP*phit1));
          d_dps_dV_GP_SI = ((x_ds*d_phit1_dV_GP_SI)+(d_x_ds_dV_GP_SI*phit1));
          d_dps_dV_DI_SI = ((x_ds*d_phit1_dV_DI_SI)+(d_x_ds_dV_DI_SI*phit1));
          dps = (x_ds*phit1);

          d_xi0d_dV_SI_BP = (((2.0+(x_d*x_d))*((x_d*d_x_d_dV_SI_BP)+(d_x_d_dV_SI_BP*x_d))-(x_d*x_d)*((x_d*d_x_d_dV_SI_BP)+(d_x_d_dV_SI_BP*x_d)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
          d_xi0d_dV_GP_SI = (((2.0+(x_d*x_d))*((x_d*d_x_d_dV_GP_SI)+(d_x_d_dV_GP_SI*x_d))-(x_d*x_d)*((x_d*d_x_d_dV_GP_SI)+(d_x_d_dV_GP_SI*x_d)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
          d_xi0d_dV_DI_SI = (((2.0+(x_d*x_d))*((x_d*d_x_d_dV_DI_SI)+(d_x_d_dV_DI_SI*x_d))-(x_d*x_d)*((x_d*d_x_d_dV_DI_SI)+(d_x_d_dV_DI_SI*x_d)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
          xi0d = ((x_d*x_d)/(2.0+(x_d*x_d)));
          if ((x_d<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp((-x_d));
              double  deriv_exp_0_d0 = value_exp_0;

              d_Ed_dV_SI_BP = (deriv_exp_0_d0*((-d_x_d_dV_SI_BP)));
              d_Ed_dV_GP_SI = (deriv_exp_0_d0*((-d_x_d_dV_GP_SI)));
              d_Ed_dV_DI_SI = (deriv_exp_0_d0*((-d_x_d_dV_DI_SI)));
              Ed = value_exp_0;
            }
            if ((x_d<1.0e-5))
            {

              d_Dd_dV_GP_SI = ((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.75*d_x_d_dV_GP_SI))+((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_GP_SI)+(((((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_GP_SI)+((((1.6666666666666667e-01*delta_nd)*d_x_d_dV_GP_SI)+((1.6666666666666667e-01*d_delta_nd_dV_GP_SI)*x_d))*x_d))*x_d))*(1.0+(1.75*x_d))));
              d_Dd_dV_SI_BP = ((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.75*d_x_d_dV_SI_BP))+((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_SI_BP)+(((((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_SI_BP)+((((1.6666666666666667e-01*delta_nd)*d_x_d_dV_SI_BP)+((1.6666666666666667e-01*d_delta_nd_dV_SI_BP)*x_d))*x_d))*x_d))*(1.0+(1.75*x_d))));
              d_Dd_dV_DI_SI = ((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.75*d_x_d_dV_DI_SI))+((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_DI_SI)+(((((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_DI_SI)+((((1.6666666666666667e-01*delta_nd)*d_x_d_dV_DI_SI)+((1.6666666666666667e-01*d_delta_nd_dV_DI_SI)*x_d))*x_d))*x_d))*(1.0+(1.75*x_d))));
              Dd = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
            }
            else
            {

              d_Dd_dV_GP_SI = ((delta_nd*(((-d_Ed_dV_GP_SI/Ed/Ed)-d_x_d_dV_GP_SI)-d_xi0d_dV_GP_SI))+(d_delta_nd_dV_GP_SI*((((1.0/Ed)-x_d)-1.0)-xi0d)));
              d_Dd_dV_SI_BP = ((delta_nd*(((-d_Ed_dV_SI_BP/Ed/Ed)-d_x_d_dV_SI_BP)-d_xi0d_dV_SI_BP))+(d_delta_nd_dV_SI_BP*((((1.0/Ed)-x_d)-1.0)-xi0d)));
              d_Dd_dV_DI_SI = ((delta_nd*(((-d_Ed_dV_DI_SI/Ed/Ed)-d_x_d_dV_DI_SI)-d_xi0d_dV_DI_SI))+(d_delta_nd_dV_DI_SI*((((1.0/Ed)-x_d)-1.0)-xi0d)));
              Dd = (delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d));
            }
          }
          else
          {
            if ((x_d>(xn_d-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp((x_d-xn_d));
                double  deriv_exp_0_d0 = value_exp_0;

                d_temp_dV_SI_BP = (deriv_exp_0_d0*((d_x_d_dV_SI_BP-d_xn_d_dV_SI_BP)));
                d_temp_dV_GP_SI = (deriv_exp_0_d0*((d_x_d_dV_GP_SI-d_xn_d_dV_GP_SI)));
                d_temp_dV_DI_SI = (deriv_exp_0_d0*((d_x_d_dV_DI_SI-d_xn_d_dV_DI_SI)));
                temp = value_exp_0;
              }

              d_Ed_dV_GP_SI = ((temp*d_delta_nd_dV_GP_SI-delta_nd*d_temp_dV_GP_SI)/temp/temp);
              d_Ed_dV_SI_BP = ((temp*d_delta_nd_dV_SI_BP-delta_nd*d_temp_dV_SI_BP)/temp/temp);
              d_Ed_dV_DI_SI = ((temp*d_delta_nd_dV_DI_SI-delta_nd*d_temp_dV_DI_SI)/temp/temp);
              Ed = (delta_nd/temp);

              d_Dd_dV_SI_BP = (d_temp_dV_SI_BP-((delta_nd*(d_x_d_dV_SI_BP+d_xi0d_dV_SI_BP))+(d_delta_nd_dV_SI_BP*((x_d+1.0)+xi0d))));
              d_Dd_dV_DI_SI = (d_temp_dV_DI_SI-((delta_nd*(d_x_d_dV_DI_SI+d_xi0d_dV_DI_SI))+(d_delta_nd_dV_DI_SI*((x_d+1.0)+xi0d))));
              d_Dd_dV_GP_SI = (d_temp_dV_GP_SI-((delta_nd*(d_x_d_dV_GP_SI+d_xi0d_dV_GP_SI))+(d_delta_nd_dV_GP_SI*((x_d+1.0)+xi0d))));
              Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
            }
            else
            {

              d_Ed_dV_SI_BP = (-1.0e-100*(((x_d-2.3025850929940458e+02)*(0.5*(((x_d-2.3025850929940458e+02)*(d_x_d_dV_SI_BP*3.3333333333333333e-01))+(d_x_d_dV_SI_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_d_dV_SI_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Ed_dV_GP_SI = (-1.0e-100*(((x_d-2.3025850929940458e+02)*(0.5*(((x_d-2.3025850929940458e+02)*(d_x_d_dV_GP_SI*3.3333333333333333e-01))+(d_x_d_dV_GP_SI*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_d_dV_GP_SI*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Ed_dV_DI_SI = (-1.0e-100*(((x_d-2.3025850929940458e+02)*(0.5*(((x_d-2.3025850929940458e+02)*(d_x_d_dV_DI_SI*3.3333333333333333e-01))+(d_x_d_dV_DI_SI*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_d_dV_DI_SI*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              Ed = (1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

              d_temp_dV_GP_SI = (-1.0e-100*((((xn_d-x_d)-2.3025850929940458e+02)*(0.5*((((xn_d-x_d)-2.3025850929940458e+02)*((d_xn_d_dV_GP_SI-d_x_d_dV_GP_SI)*3.3333333333333333e-01))+((d_xn_d_dV_GP_SI-d_x_d_dV_GP_SI)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_GP_SI-d_x_d_dV_GP_SI)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_temp_dV_SI_BP = (-1.0e-100*((((xn_d-x_d)-2.3025850929940458e+02)*(0.5*((((xn_d-x_d)-2.3025850929940458e+02)*((d_xn_d_dV_SI_BP-d_x_d_dV_SI_BP)*3.3333333333333333e-01))+((d_xn_d_dV_SI_BP-d_x_d_dV_SI_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_SI_BP-d_x_d_dV_SI_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_temp_dV_DI_SI = (-1.0e-100*((((xn_d-x_d)-2.3025850929940458e+02)*(0.5*((((xn_d-x_d)-2.3025850929940458e+02)*((d_xn_d_dV_DI_SI-d_x_d_dV_DI_SI)*3.3333333333333333e-01))+((d_xn_d_dV_DI_SI-d_x_d_dV_DI_SI)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_DI_SI-d_x_d_dV_DI_SI)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              temp = (1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

              d_Dd_dV_SI_BP = (d_temp_dV_SI_BP-((delta_nd*(d_x_d_dV_SI_BP+d_xi0d_dV_SI_BP))+(d_delta_nd_dV_SI_BP*((x_d+1.0)+xi0d))));
              d_Dd_dV_DI_SI = (d_temp_dV_DI_SI-((delta_nd*(d_x_d_dV_DI_SI+d_xi0d_dV_DI_SI))+(d_delta_nd_dV_DI_SI*((x_d+1.0)+xi0d))));
              d_Dd_dV_GP_SI = (d_temp_dV_GP_SI-((delta_nd*(d_x_d_dV_GP_SI+d_xi0d_dV_GP_SI))+(d_delta_nd_dV_GP_SI*((x_d+1.0)+xi0d))));
              Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
            }
          }

          d_x_m_dV_SI_BP = (0.5*(d_x_s_dV_SI_BP+d_x_d_dV_SI_BP));
          d_x_m_dV_GP_SI = (0.5*(d_x_s_dV_GP_SI+d_x_d_dV_GP_SI));
          d_x_m_dV_DI_SI = (0.5*(d_x_s_dV_DI_SI+d_x_d_dV_DI_SI));
          x_m = (0.5*(x_s+x_d));

          d_Em_dV_DI_SI = d_Em_dV_GP_SI = d_Em_dV_SI_BP =  0.0;
          Em = 0.0;

          d_temp_dV_SI_BP = ((Ed*d_Es_dV_SI_BP)+(d_Ed_dV_SI_BP*Es));
          d_temp_dV_GP_SI = ((Ed*d_Es_dV_GP_SI)+(d_Ed_dV_GP_SI*Es));
          d_temp_dV_DI_SI = ((Ed*d_Es_dV_DI_SI)+(d_Ed_dV_DI_SI*Es));
          temp = (Ed*Es);
          if ((temp>0.0))
          {
            {
              double value_sqrt_0 = sqrt(temp);
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_Em_dV_SI_BP = (deriv_sqrt_0_d0*(d_temp_dV_SI_BP));
              d_Em_dV_DI_SI = (deriv_sqrt_0_d0*(d_temp_dV_DI_SI));
              d_Em_dV_GP_SI = (deriv_sqrt_0_d0*(d_temp_dV_GP_SI));
              Em = value_sqrt_0;
            }
          }

          d_D_bar_dV_SI_BP = (0.5*(d_Ds_dV_SI_BP+d_Dd_dV_SI_BP));
          d_D_bar_dV_GP_SI = (0.5*(d_Ds_dV_GP_SI+d_Dd_dV_GP_SI));
          d_D_bar_dV_DI_SI = (0.5*(d_Ds_dV_DI_SI+d_Dd_dV_DI_SI));
          D_bar = (0.5*(Ds+Dd));

          d_Dm_dV_SI_BP = (d_D_bar_dV_SI_BP+(0.125*(((x_ds*x_ds)*(d_Em_dV_SI_BP-(2.0*d_inv_Gf2_dV_SI_BP)))+(((x_ds*d_x_ds_dV_SI_BP)+(d_x_ds_dV_SI_BP*x_ds))*(Em-(2.0*inv_Gf2))))));
          d_Dm_dV_GP_SI = (d_D_bar_dV_GP_SI+(0.125*(((x_ds*x_ds)*(d_Em_dV_GP_SI-(2.0*d_inv_Gf2_dV_GP_SI)))+(((x_ds*d_x_ds_dV_GP_SI)+(d_x_ds_dV_GP_SI*x_ds))*(Em-(2.0*inv_Gf2))))));
          d_Dm_dV_DI_SI = (d_D_bar_dV_DI_SI+(0.125*(((x_ds*x_ds)*(d_Em_dV_DI_SI-(2.0*d_inv_Gf2_dV_DI_SI)))+(((x_ds*d_x_ds_dV_DI_SI)+(d_x_ds_dV_DI_SI*x_ds))*(Em-(2.0*inv_Gf2))))));
          Dm = (D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))));
          if ((x_m<1.0e-5))
          {

            d_Pm_dV_SI_BP = (0.5*(((x_m*x_m)*(-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_SI_BP)))+(d_x_m_dV_SI_BP*(1.0-(0.25*x_m)))))))+(((x_m*d_x_m_dV_SI_BP)+(d_x_m_dV_SI_BP*x_m))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))));
            d_Pm_dV_GP_SI = (0.5*(((x_m*x_m)*(-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_GP_SI)))+(d_x_m_dV_GP_SI*(1.0-(0.25*x_m)))))))+(((x_m*d_x_m_dV_GP_SI)+(d_x_m_dV_GP_SI*x_m))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))));
            d_Pm_dV_DI_SI = (0.5*(((x_m*x_m)*(-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_DI_SI)))+(d_x_m_dV_DI_SI*(1.0-(0.25*x_m)))))))+(((x_m*d_x_m_dV_DI_SI)+(d_x_m_dV_DI_SI*x_m))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))));
            Pm = (0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))));
            {
              double value_sqrt_0 = sqrt((Dm+Pm));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_xgm_dV_SI_BP = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_SI_BP+d_Pm_dV_SI_BP))))+(d_Gf_dV_SI_BP*value_sqrt_0));
              d_xgm_dV_GP_SI = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_SI+d_Pm_dV_GP_SI))))+(d_Gf_dV_GP_SI*value_sqrt_0));
              d_xgm_dV_DI_SI = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_DI_SI+d_Pm_dV_DI_SI))))+(d_Gf_dV_DI_SI*value_sqrt_0));
              xgm = (Gf*value_sqrt_0);
            }
            if ((kp>0.0))
            {
              {
                double value_sqrt_0 = sqrt((1.0+(kp*xgm)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_eta_p_dV_SI_BP = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_SI_BP)))/value_sqrt_0/value_sqrt_0);
                d_eta_p_dV_GP_SI = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_GP_SI)))/value_sqrt_0/value_sqrt_0);
                d_eta_p_dV_DI_SI = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_DI_SI)))/value_sqrt_0/value_sqrt_0);
                eta_p = (1.0/value_sqrt_0);
              }
            }
            {
              double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_temp_dV_SI_BP = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_SI_BP)))+(d_x_m_dV_SI_BP*(1.0-(0.25*x_m))))))));
              d_temp_dV_GP_SI = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_GP_SI)))+(d_x_m_dV_GP_SI*(1.0-(0.25*x_m))))))));
              d_temp_dV_DI_SI = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_DI_SI)))+(d_x_m_dV_DI_SI*(1.0-(0.25*x_m))))))));
              temp = value_sqrt_0;
            }

            d_sqm_dV_SI_BP = (7.0710678118654746e-01*((x_m*d_temp_dV_SI_BP)+(d_x_m_dV_SI_BP*temp)));
            d_sqm_dV_GP_SI = (7.0710678118654746e-01*((x_m*d_temp_dV_GP_SI)+(d_x_m_dV_GP_SI*temp)));
            d_sqm_dV_DI_SI = (7.0710678118654746e-01*((x_m*d_temp_dV_DI_SI)+(d_x_m_dV_DI_SI*temp)));
            sqm = (7.0710678118654746e-01*(x_m*temp));

            d_alpha_dV_SI_BP = (d_eta_p_dV_SI_BP+(7.0710678118654746e-01*((temp*((Gf*((-(0.5*d_x_m_dV_SI_BP))+(1.6666666666666667e-01*((x_m*d_x_m_dV_SI_BP)+(d_x_m_dV_SI_BP*x_m)))))+(d_Gf_dV_SI_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_SI_BP)/temp/temp)));
            d_alpha_dV_GP_SI = (d_eta_p_dV_GP_SI+(7.0710678118654746e-01*((temp*((Gf*((-(0.5*d_x_m_dV_GP_SI))+(1.6666666666666667e-01*((x_m*d_x_m_dV_GP_SI)+(d_x_m_dV_GP_SI*x_m)))))+(d_Gf_dV_GP_SI*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_GP_SI)/temp/temp)));
            d_alpha_dV_DI_SI = (d_eta_p_dV_DI_SI+(7.0710678118654746e-01*((temp*((Gf*((-(0.5*d_x_m_dV_DI_SI))+(1.6666666666666667e-01*((x_m*d_x_m_dV_DI_SI)+(d_x_m_dV_DI_SI*x_m)))))+(d_Gf_dV_DI_SI*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_DI_SI)/temp/temp)));
            alpha = (eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)));
          }
          else
          {

            d_Pm_dV_SI_BP = (d_x_m_dV_SI_BP+d_Em_dV_SI_BP);
            d_Pm_dV_GP_SI = (d_x_m_dV_GP_SI+d_Em_dV_GP_SI);
            d_Pm_dV_DI_SI = (d_x_m_dV_DI_SI+d_Em_dV_DI_SI);
            Pm = ((x_m-1.0)+Em);
            {
              double value_sqrt_0 = sqrt((Dm+Pm));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_xgm_dV_SI_BP = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_SI_BP+d_Pm_dV_SI_BP))))+(d_Gf_dV_SI_BP*value_sqrt_0));
              d_xgm_dV_GP_SI = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_SI+d_Pm_dV_GP_SI))))+(d_Gf_dV_GP_SI*value_sqrt_0));
              d_xgm_dV_DI_SI = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_DI_SI+d_Pm_dV_DI_SI))))+(d_Gf_dV_DI_SI*value_sqrt_0));
              xgm = (Gf*value_sqrt_0);
            }
            if ((kp>0.0))
            {

              d_d0_dV_SI_BP = ((-d_Em_dV_SI_BP)+(2.0*((xgm*d_inv_Gf2_dV_SI_BP)+(d_xgm_dV_SI_BP*inv_Gf2))));
              d_d0_dV_GP_SI = ((-d_Em_dV_GP_SI)+(2.0*((xgm*d_inv_Gf2_dV_GP_SI)+(d_xgm_dV_GP_SI*inv_Gf2))));
              d_d0_dV_DI_SI = ((-d_Em_dV_DI_SI)+(2.0*((xgm*d_inv_Gf2_dV_DI_SI)+(d_xgm_dV_DI_SI*inv_Gf2))));
              d0 = ((1.0-Em)+(2.0*(xgm*inv_Gf2)));
              {
                double value_sqrt_0 = sqrt((1.0+(kp*xgm)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_eta_p_dV_SI_BP = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_SI_BP)))/value_sqrt_0/value_sqrt_0);
                d_eta_p_dV_GP_SI = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_GP_SI)))/value_sqrt_0/value_sqrt_0);
                d_eta_p_dV_DI_SI = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_DI_SI)))/value_sqrt_0/value_sqrt_0);
                eta_p = (1.0/value_sqrt_0);
              }

              d_temp_dV_SI_BP = (((eta_p+1.0)*d_eta_p_dV_SI_BP-eta_p*d_eta_p_dV_SI_BP)/(eta_p+1.0)/(eta_p+1.0));
              d_temp_dV_GP_SI = (((eta_p+1.0)*d_eta_p_dV_GP_SI-eta_p*d_eta_p_dV_GP_SI)/(eta_p+1.0)/(eta_p+1.0));
              d_temp_dV_DI_SI = (((eta_p+1.0)*d_eta_p_dV_DI_SI-eta_p*d_eta_p_dV_DI_SI)/(eta_p+1.0)/(eta_p+1.0));
              temp = (eta_p/(eta_p+1.0));

              d_x_pm_dV_SI_BP = (kp*((((temp*temp)*Gf2)*d_Dm_dV_SI_BP)+((((temp*temp)*d_Gf2_dV_SI_BP)+(((temp*d_temp_dV_SI_BP)+(d_temp_dV_SI_BP*temp))*Gf2))*Dm)));
              d_x_pm_dV_DI_SI = (kp*((((temp*temp)*Gf2)*d_Dm_dV_DI_SI)+((((temp*temp)*d_Gf2_dV_DI_SI)+(((temp*d_temp_dV_DI_SI)+(d_temp_dV_DI_SI*temp))*Gf2))*Dm)));
              d_x_pm_dV_GP_SI = (kp*((((temp*temp)*Gf2)*d_Dm_dV_GP_SI)+((((temp*temp)*d_Gf2_dV_GP_SI)+(((temp*d_temp_dV_GP_SI)+(d_temp_dV_GP_SI*temp))*Gf2))*Dm)));
              x_pm = (kp*(((temp*temp)*Gf2)*Dm));

              d_p_pd_dV_SI_BP = ((2.0*(d_xgm_dV_SI_BP-d_x_pm_dV_SI_BP))+((Gf2*((-d_Em_dV_SI_BP)+d_Dm_dV_SI_BP))+(d_Gf2_dV_SI_BP*((1.0-Em)+Dm))));
              d_p_pd_dV_GP_SI = ((2.0*(d_xgm_dV_GP_SI-d_x_pm_dV_GP_SI))+((Gf2*((-d_Em_dV_GP_SI)+d_Dm_dV_GP_SI))+(d_Gf2_dV_GP_SI*((1.0-Em)+Dm))));
              d_p_pd_dV_DI_SI = ((2.0*(d_xgm_dV_DI_SI-d_x_pm_dV_DI_SI))+((Gf2*((-d_Em_dV_DI_SI)+d_Dm_dV_DI_SI))+(d_Gf2_dV_DI_SI*((1.0-Em)+Dm))));
              p_pd = ((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm)));

              d_q_pd_dV_SI_BP = ((x_pm*(d_x_pm_dV_SI_BP-(2.0*d_xgm_dV_SI_BP)))+(d_x_pm_dV_SI_BP*(x_pm-(2.0*xgm))));
              d_q_pd_dV_DI_SI = ((x_pm*(d_x_pm_dV_DI_SI-(2.0*d_xgm_dV_DI_SI)))+(d_x_pm_dV_DI_SI*(x_pm-(2.0*xgm))));
              d_q_pd_dV_GP_SI = ((x_pm*(d_x_pm_dV_GP_SI-(2.0*d_xgm_dV_GP_SI)))+(d_x_pm_dV_GP_SI*(x_pm-(2.0*xgm))));
              q_pd = (x_pm*(x_pm-(2.0*xgm)));

              d_xi_pd_dV_SI_BP = (-(0.5*((Gf2*(d_Em_dV_SI_BP+d_Dm_dV_SI_BP))+(d_Gf2_dV_SI_BP*(Em+Dm)))));
              d_xi_pd_dV_GP_SI = (-(0.5*((Gf2*(d_Em_dV_GP_SI+d_Dm_dV_GP_SI))+(d_Gf2_dV_GP_SI*(Em+Dm)))));
              d_xi_pd_dV_DI_SI = (-(0.5*((Gf2*(d_Em_dV_DI_SI+d_Dm_dV_DI_SI))+(d_Gf2_dV_DI_SI*(Em+Dm)))));
              xi_pd = (1.0-(0.5*(Gf2*(Em+Dm))));

              d_u_pd_dV_SI_BP = ((((p_pd*p_pd)-(xi_pd*q_pd))*((q_pd*d_p_pd_dV_SI_BP)+(d_q_pd_dV_SI_BP*p_pd))-(q_pd*p_pd)*(((p_pd*d_p_pd_dV_SI_BP)+(d_p_pd_dV_SI_BP*p_pd))-((xi_pd*d_q_pd_dV_SI_BP)+(d_xi_pd_dV_SI_BP*q_pd))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
              d_u_pd_dV_DI_SI = ((((p_pd*p_pd)-(xi_pd*q_pd))*((q_pd*d_p_pd_dV_DI_SI)+(d_q_pd_dV_DI_SI*p_pd))-(q_pd*p_pd)*(((p_pd*d_p_pd_dV_DI_SI)+(d_p_pd_dV_DI_SI*p_pd))-((xi_pd*d_q_pd_dV_DI_SI)+(d_xi_pd_dV_DI_SI*q_pd))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
              d_u_pd_dV_GP_SI = ((((p_pd*p_pd)-(xi_pd*q_pd))*((q_pd*d_p_pd_dV_GP_SI)+(d_q_pd_dV_GP_SI*p_pd))-(q_pd*p_pd)*(((p_pd*d_p_pd_dV_GP_SI)+(d_p_pd_dV_GP_SI*p_pd))-((xi_pd*d_q_pd_dV_GP_SI)+(d_xi_pd_dV_GP_SI*q_pd))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
              u_pd = ((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd)));

              d_x_m_dV_SI_BP = (d_x_m_dV_SI_BP+d_u_pd_dV_SI_BP);
              d_x_m_dV_GP_SI = (d_x_m_dV_GP_SI+d_u_pd_dV_GP_SI);
              d_x_m_dV_DI_SI = (d_x_m_dV_DI_SI+d_u_pd_dV_DI_SI);
              x_m = (x_m+u_pd);
              {
                double value_exp_0 = exp(u_pd);
                double  deriv_exp_0_d0 = value_exp_0;

                d_km_dV_SI_BP = (deriv_exp_0_d0*(d_u_pd_dV_SI_BP));
                d_km_dV_DI_SI = (deriv_exp_0_d0*(d_u_pd_dV_DI_SI));
                d_km_dV_GP_SI = (deriv_exp_0_d0*(d_u_pd_dV_GP_SI));
                km = value_exp_0;
              }

              d_Em_dV_SI_BP = ((km*d_Em_dV_SI_BP-Em*d_km_dV_SI_BP)/km/km);
              d_Em_dV_GP_SI = ((km*d_Em_dV_GP_SI-Em*d_km_dV_GP_SI)/km/km);
              d_Em_dV_DI_SI = ((km*d_Em_dV_DI_SI-Em*d_km_dV_DI_SI)/km/km);
              Em = (Em/km);

              d_Dm_dV_SI_BP = ((Dm*d_km_dV_SI_BP)+(d_Dm_dV_SI_BP*km));
              d_Dm_dV_GP_SI = ((Dm*d_km_dV_GP_SI)+(d_Dm_dV_GP_SI*km));
              d_Dm_dV_DI_SI = ((Dm*d_km_dV_DI_SI)+(d_Dm_dV_DI_SI*km));
              Dm = (Dm*km);

              d_Pm_dV_SI_BP = (d_x_m_dV_SI_BP+d_Em_dV_SI_BP);
              d_Pm_dV_GP_SI = (d_x_m_dV_GP_SI+d_Em_dV_GP_SI);
              d_Pm_dV_DI_SI = (d_x_m_dV_DI_SI+d_Em_dV_DI_SI);
              Pm = ((x_m-1.0)+Em);
              {
                double value_sqrt_0 = sqrt((Dm+Pm));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_xgm_dV_SI_BP = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_SI_BP+d_Pm_dV_SI_BP))))+(d_Gf_dV_SI_BP*value_sqrt_0));
                d_xgm_dV_GP_SI = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_SI+d_Pm_dV_GP_SI))))+(d_Gf_dV_GP_SI*value_sqrt_0));
                d_xgm_dV_DI_SI = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_DI_SI+d_Pm_dV_DI_SI))))+(d_Gf_dV_DI_SI*value_sqrt_0));
                xgm = (Gf*value_sqrt_0);
              }

              d_km0_dV_SI_BP = ((-d_Em_dV_SI_BP)+(2.0*(((xgm*eta_p)*d_inv_Gf2_dV_SI_BP)+(((xgm*d_eta_p_dV_SI_BP)+(d_xgm_dV_SI_BP*eta_p))*inv_Gf2))));
              d_km0_dV_GP_SI = ((-d_Em_dV_GP_SI)+(2.0*(((xgm*eta_p)*d_inv_Gf2_dV_GP_SI)+(((xgm*d_eta_p_dV_GP_SI)+(d_xgm_dV_GP_SI*eta_p))*inv_Gf2))));
              d_km0_dV_DI_SI = ((-d_Em_dV_DI_SI)+(2.0*(((xgm*eta_p)*d_inv_Gf2_dV_DI_SI)+(((xgm*d_eta_p_dV_DI_SI)+(d_xgm_dV_DI_SI*eta_p))*inv_Gf2))));
              km0 = ((1.0-Em)+(2.0*((xgm*eta_p)*inv_Gf2)));

              d_x_ds_dV_SI_BP = (((km0+(km*D_bar))*(((x_ds*km)*(d_d0_dV_SI_BP+d_D_bar_dV_SI_BP))+(((x_ds*d_km_dV_SI_BP)+(d_x_ds_dV_SI_BP*km))*(d0+D_bar)))-((x_ds*km)*(d0+D_bar))*(d_km0_dV_SI_BP+((km*d_D_bar_dV_SI_BP)+(d_km_dV_SI_BP*D_bar))))/(km0+(km*D_bar))/(km0+(km*D_bar)));
              d_x_ds_dV_GP_SI = (((km0+(km*D_bar))*(((x_ds*km)*(d_d0_dV_GP_SI+d_D_bar_dV_GP_SI))+(((x_ds*d_km_dV_GP_SI)+(d_x_ds_dV_GP_SI*km))*(d0+D_bar)))-((x_ds*km)*(d0+D_bar))*(d_km0_dV_GP_SI+((km*d_D_bar_dV_GP_SI)+(d_km_dV_GP_SI*D_bar))))/(km0+(km*D_bar))/(km0+(km*D_bar)));
              d_x_ds_dV_DI_SI = (((km0+(km*D_bar))*(((x_ds*km)*(d_d0_dV_DI_SI+d_D_bar_dV_DI_SI))+(((x_ds*d_km_dV_DI_SI)+(d_x_ds_dV_DI_SI*km))*(d0+D_bar)))-((x_ds*km)*(d0+D_bar))*(d_km0_dV_DI_SI+((km*d_D_bar_dV_DI_SI)+(d_km_dV_DI_SI*D_bar))))/(km0+(km*D_bar))/(km0+(km*D_bar)));
              x_ds = (((x_ds*km)*(d0+D_bar))/(km0+(km*D_bar)));

              d_dps_dV_SI_BP = ((x_ds*d_phit1_dV_SI_BP)+(d_x_ds_dV_SI_BP*phit1));
              d_dps_dV_GP_SI = ((x_ds*d_phit1_dV_GP_SI)+(d_x_ds_dV_GP_SI*phit1));
              d_dps_dV_DI_SI = ((x_ds*d_phit1_dV_DI_SI)+(d_x_ds_dV_DI_SI*phit1));
              dps = (x_ds*phit1);
            }
            {
              double value_sqrt_0 = sqrt(Pm);
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_sqm_dV_SI_BP = (deriv_sqrt_0_d0*(d_Pm_dV_SI_BP));
              d_sqm_dV_GP_SI = (deriv_sqrt_0_d0*(d_Pm_dV_GP_SI));
              d_sqm_dV_DI_SI = (deriv_sqrt_0_d0*(d_Pm_dV_DI_SI));
              sqm = value_sqrt_0;
            }

            d_alpha_dV_SI_BP = (d_eta_p_dV_SI_BP+(0.5*((sqm*((Gf*(-d_Em_dV_SI_BP))+(d_Gf_dV_SI_BP*(1.0-Em)))-(Gf*(1.0-Em))*d_sqm_dV_SI_BP)/sqm/sqm)));
            d_alpha_dV_GP_SI = (d_eta_p_dV_GP_SI+(0.5*((sqm*((Gf*(-d_Em_dV_GP_SI))+(d_Gf_dV_GP_SI*(1.0-Em)))-(Gf*(1.0-Em))*d_sqm_dV_GP_SI)/sqm/sqm)));
            d_alpha_dV_DI_SI = (d_eta_p_dV_DI_SI+(0.5*((sqm*((Gf*(-d_Em_dV_DI_SI))+(d_Gf_dV_DI_SI*(1.0-Em)))-(Gf*(1.0-Em))*d_sqm_dV_DI_SI)/sqm/sqm)));
            alpha = (eta_p+(0.5*((Gf*(1.0-Em))/sqm)));
          }

          d_qim_dV_GP_SI = ((phit1*(((xgm+(Gf*sqm))*((Gf2*d_Dm_dV_GP_SI)+(d_Gf2_dV_GP_SI*Dm))-(Gf2*Dm)*(d_xgm_dV_GP_SI+((Gf*d_sqm_dV_GP_SI)+(d_Gf_dV_GP_SI*sqm))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))))+(d_phit1_dV_GP_SI*((Gf2*Dm)/(xgm+(Gf*sqm)))));
          d_qim_dV_SI_BP = ((phit1*(((xgm+(Gf*sqm))*((Gf2*d_Dm_dV_SI_BP)+(d_Gf2_dV_SI_BP*Dm))-(Gf2*Dm)*(d_xgm_dV_SI_BP+((Gf*d_sqm_dV_SI_BP)+(d_Gf_dV_SI_BP*sqm))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))))+(d_phit1_dV_SI_BP*((Gf2*Dm)/(xgm+(Gf*sqm)))));
          d_qim_dV_DI_SI = ((phit1*(((xgm+(Gf*sqm))*((Gf2*d_Dm_dV_DI_SI)+(d_Gf2_dV_DI_SI*Dm))-(Gf2*Dm)*(d_xgm_dV_DI_SI+((Gf*d_sqm_dV_DI_SI)+(d_Gf_dV_DI_SI*sqm))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))))+(d_phit1_dV_DI_SI*((Gf2*Dm)/(xgm+(Gf*sqm)))));
          qim = (phit1*((Gf2*Dm)/(xgm+(Gf*sqm))));

          d_qim1_dV_GP_SI = (d_qim_dV_GP_SI+((phit1*d_alpha_dV_GP_SI)+(d_phit1_dV_GP_SI*alpha)));
          d_qim1_dV_SI_BP = (d_qim_dV_SI_BP+((phit1*d_alpha_dV_SI_BP)+(d_phit1_dV_SI_BP*alpha)));
          d_qim1_dV_DI_SI = (d_qim_dV_DI_SI+((phit1*d_alpha_dV_DI_SI)+(d_phit1_dV_DI_SI*alpha)));
          qim1 = (qim+(phit1*alpha));

          d_qbm_dV_SI_BP = (((sqm*Gf)*d_phit1_dV_SI_BP)+(((sqm*d_Gf_dV_SI_BP)+(d_sqm_dV_SI_BP*Gf))*phit1));
          d_qbm_dV_GP_SI = (((sqm*Gf)*d_phit1_dV_GP_SI)+(((sqm*d_Gf_dV_GP_SI)+(d_sqm_dV_GP_SI*Gf))*phit1));
          d_qbm_dV_DI_SI = (((sqm*Gf)*d_phit1_dV_DI_SI)+(((sqm*d_Gf_dV_DI_SI)+(d_sqm_dV_DI_SI*Gf))*phit1));
          qbm = ((sqm*Gf)*phit1);
          if ((RSG_i<0.0))
          {

            d_temp_dV_GP_SI = (-(RSG_i*d_qim_dV_GP_SI));
            d_temp_dV_SI_BP = (-(RSG_i*d_qim_dV_SI_BP));
            d_temp_dV_DI_SI = (-(RSG_i*d_qim_dV_DI_SI));
            temp = (1.0-(RSG_i*qim));
          }
          else
          {

            d_temp_dV_GP_SI = (-(RSG_i*d_qim_dV_GP_SI)/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
            d_temp_dV_SI_BP = (-(RSG_i*d_qim_dV_SI_BP)/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
            d_temp_dV_DI_SI = (-(RSG_i*d_qim_dV_DI_SI)/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
            temp = (1.0/(1.0+(RSG_i*qim)));
          }

          d_GR_dV_GP_SI = (THER_i*(((rhob*temp)*d_qim_dV_GP_SI)+((rhob*d_temp_dV_GP_SI)*qim)));
          d_GR_dV_SI_BP = (THER_i*(((rhob*temp)*d_qim_dV_SI_BP)+(((rhob*d_temp_dV_SI_BP)+(d_rhob_dV_SI_BP*temp))*qim)));
          d_GR_dV_DI_SI = (THER_i*(((rhob*temp)*d_qim_dV_DI_SI)+(((rhob*d_temp_dV_DI_SI)+(d_rhob_dV_DI_SI*temp))*qim)));
          GR = (THER_i*((rhob*temp)*qim));

          d_qeff_dV_SI_BP = (d_qbm_dV_SI_BP+(eta_mu*d_qim_dV_SI_BP));
          d_qeff_dV_GP_SI = (d_qbm_dV_GP_SI+(eta_mu*d_qim_dV_GP_SI));
          d_qeff_dV_DI_SI = (d_qbm_dV_DI_SI+(eta_mu*d_qim_dV_DI_SI));
          qeff = (qbm+(eta_mu*qim));

          d_qeff1_dV_SI_BP = (d_qbm_dV_SI_BP+(eta_mu1*d_qim_dV_SI_BP));
          d_qeff1_dV_GP_SI = (d_qbm_dV_GP_SI+(eta_mu1*d_qim_dV_GP_SI));
          d_qeff1_dV_DI_SI = (d_qbm_dV_DI_SI+(eta_mu1*d_qim_dV_DI_SI));
          qeff1 = (qbm+(eta_mu1*qim));

          d_Eeffm_dV_SI_BP = (E_eff0*d_qeff_dV_SI_BP);
          d_Eeffm_dV_GP_SI = (E_eff0*d_qeff_dV_GP_SI);
          d_Eeffm_dV_DI_SI = (E_eff0*d_qeff_dV_DI_SI);
          Eeffm = (E_eff0*qeff);
          {
            double value_pow_0 = pow((Eeffm*MUE_T),THEMU_T);
            double  deriv_pow_0_d0 = (((Eeffm*MUE_T) == 0.0)?0.0:(value_pow_0*THEMU_T/(Eeffm*MUE_T)));

            d_Mutmp_dV_SI_BP = ((deriv_pow_0_d0*((d_Eeffm_dV_SI_BP*MUE_T)))+(CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dV_SI_BP-Pm*(d_Pm_dV_SI_BP+d_Dm_dV_SI_BP))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
            d_Mutmp_dV_GP_SI = ((deriv_pow_0_d0*((d_Eeffm_dV_GP_SI*MUE_T)))+(CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dV_GP_SI-Pm*(d_Pm_dV_GP_SI+d_Dm_dV_GP_SI))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
            d_Mutmp_dV_DI_SI = ((deriv_pow_0_d0*((d_Eeffm_dV_DI_SI*MUE_T)))+(CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dV_DI_SI-Pm*(d_Pm_dV_DI_SI+d_Dm_dV_DI_SI))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
            Mutmp = (value_pow_0+(CS_T*(Pm/((Pm+Dm)+1.0e-14))));
          }

          d_Gmob_dV_SI_BP = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_SI_BP)+((d_Mutmp_dV_SI_BP+d_GR_dV_SI_BP)*Rxcor));
          d_Gmob_dV_GP_SI = ((d_Mutmp_dV_GP_SI+d_GR_dV_GP_SI)*Rxcor);
          d_Gmob_dV_DI_SI = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_DI_SI)+((d_Mutmp_dV_DI_SI+d_GR_dV_DI_SI)*Rxcor));
          Gmob = (((1.0+Mutmp)+GR)*Rxcor);
          {
            double value_log_0 = log(((1.0+((Vds-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))));
            double  deriv_log_0_d0 = (1.0/((1.0+((Vds-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))));

            d_s1_dV_SI_BP = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*((-d_dps_dV_SI_BP)*inv_VP)-(1.0+((Vds-dps)*inv_VP))*((d_Vdse_dV_SI_BP-d_dps_dV_SI_BP)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
            d_s1_dV_GP_SI = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*((-d_dps_dV_GP_SI)*inv_VP)-(1.0+((Vds-dps)*inv_VP))*((d_Vdse_dV_GP_SI-d_dps_dV_GP_SI)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
            d_s1_dV_DI_SI = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*((d_Vds_dV_DI_SI-d_dps_dV_DI_SI)*inv_VP)-(1.0+((Vds-dps)*inv_VP))*((d_Vdse_dV_DI_SI-d_dps_dV_DI_SI)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
            s1 = value_log_0;
          }

          d_dL_dV_SI_BP = (ALP_i*d_s1_dV_SI_BP);
          d_dL_dV_GP_SI = (ALP_i*d_s1_dV_GP_SI);
          d_dL_dV_DI_SI = (ALP_i*d_s1_dV_DI_SI);
          dL = (ALP_i*s1);

          d_GdL_dV_SI_BP = (-(d_dL_dV_SI_BP+((dL*d_dL_dV_SI_BP)+(d_dL_dV_SI_BP*dL)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
          d_GdL_dV_GP_SI = (-(d_dL_dV_GP_SI+((dL*d_dL_dV_GP_SI)+(d_dL_dV_GP_SI*dL)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
          d_GdL_dV_DI_SI = (-(d_dL_dV_DI_SI+((dL*d_dL_dV_DI_SI)+(d_dL_dV_DI_SI*dL)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
          GdL = (1.0/((1.0+dL)+(dL*dL)));

          d_temp2_dV_GP_SI = (d_qim_dV_GP_SI*xitsb);
          d_temp2_dV_SI_BP = ((qim*d_xitsb_dV_SI_BP)+(d_qim_dV_SI_BP*xitsb));
          d_temp2_dV_DI_SI = ((qim*d_xitsb_dV_DI_SI)+(d_qim_dV_DI_SI*xitsb));
          temp2 = (qim*xitsb);

          d_wsat_dV_SI_BP = (100.0*(((100.0+temp2)*d_temp2_dV_SI_BP-temp2*d_temp2_dV_SI_BP)/(100.0+temp2)/(100.0+temp2)));
          d_wsat_dV_GP_SI = (100.0*(((100.0+temp2)*d_temp2_dV_GP_SI-temp2*d_temp2_dV_GP_SI)/(100.0+temp2)/(100.0+temp2)));
          d_wsat_dV_DI_SI = (100.0*(((100.0+temp2)*d_temp2_dV_DI_SI-temp2*d_temp2_dV_DI_SI)/(100.0+temp2)/(100.0+temp2)));
          wsat = (100.0*(temp2/(100.0+temp2)));

          d_Gmob_dL_dV_SI_BP = ((Gmob*d_GdL_dV_SI_BP)+(d_Gmob_dV_SI_BP*GdL));
          d_Gmob_dL_dV_GP_SI = ((Gmob*d_GdL_dV_GP_SI)+(d_Gmob_dV_GP_SI*GdL));
          d_Gmob_dL_dV_DI_SI = ((Gmob*d_GdL_dV_DI_SI)+(d_Gmob_dV_DI_SI*GdL));
          Gmob_dL = (Gmob*GdL);
          if ((THESATG_i<0.0))
          {

            d_temp_dV_SI_BP = (-(-(THESATG_i*d_wsat_dV_SI_BP))/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
            d_temp_dV_GP_SI = (-(-(THESATG_i*d_wsat_dV_GP_SI))/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
            d_temp_dV_DI_SI = (-(-(THESATG_i*d_wsat_dV_DI_SI))/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
            temp = (1.0/(1.0-(THESATG_i*wsat)));
          }
          else
          {

            d_temp_dV_SI_BP = (THESATG_i*d_wsat_dV_SI_BP);
            d_temp_dV_GP_SI = (THESATG_i*d_wsat_dV_GP_SI);
            d_temp_dV_DI_SI = (THESATG_i*d_wsat_dV_DI_SI);
            temp = (1.0+(THESATG_i*wsat));
          }

          d_thesat1_dV_SI_BP = (THESAT_T*((Gmob_dL*d_temp_dV_SI_BP-temp*d_Gmob_dL_dV_SI_BP)/Gmob_dL/Gmob_dL));
          d_thesat1_dV_DI_SI = (THESAT_T*((Gmob_dL*d_temp_dV_DI_SI-temp*d_Gmob_dL_dV_DI_SI)/Gmob_dL/Gmob_dL));
          d_thesat1_dV_GP_SI = (THESAT_T*((Gmob_dL*d_temp_dV_GP_SI-temp*d_Gmob_dL_dV_GP_SI)/Gmob_dL/Gmob_dL));
          thesat1 = (THESAT_T*(temp/Gmob_dL));

          d_zsat_dV_SI_BP = ((((thesat1*thesat1)*dps)*d_dps_dV_SI_BP)+((((thesat1*thesat1)*d_dps_dV_SI_BP)+(((thesat1*d_thesat1_dV_SI_BP)+(d_thesat1_dV_SI_BP*thesat1))*dps))*dps));
          d_zsat_dV_DI_SI = ((((thesat1*thesat1)*dps)*d_dps_dV_DI_SI)+((((thesat1*thesat1)*d_dps_dV_DI_SI)+(((thesat1*d_thesat1_dV_DI_SI)+(d_thesat1_dV_DI_SI*thesat1))*dps))*dps));
          d_zsat_dV_GP_SI = ((((thesat1*thesat1)*dps)*d_dps_dV_GP_SI)+((((thesat1*thesat1)*d_dps_dV_GP_SI)+(((thesat1*d_thesat1_dV_GP_SI)+(d_thesat1_dV_GP_SI*thesat1))*dps))*dps));
          zsat = (((thesat1*thesat1)*dps)*dps);
          if (((model_.CHNL_TYPE)==(-1)))
          {

            d_zsat_dV_SI_BP = (((1.0+(thesat1*dps))*d_zsat_dV_SI_BP-zsat*((thesat1*d_dps_dV_SI_BP)+(d_thesat1_dV_SI_BP*dps)))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
            d_zsat_dV_DI_SI = (((1.0+(thesat1*dps))*d_zsat_dV_DI_SI-zsat*((thesat1*d_dps_dV_DI_SI)+(d_thesat1_dV_DI_SI*dps)))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
            d_zsat_dV_GP_SI = (((1.0+(thesat1*dps))*d_zsat_dV_GP_SI-zsat*((thesat1*d_dps_dV_GP_SI)+(d_thesat1_dV_GP_SI*dps)))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
            zsat = (zsat/(1.0+(thesat1*dps)));
          }
          {
            double value_sqrt_0 = sqrt((1.0+(2.0*zsat)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Gvsat_dV_SI_BP = (0.5*((Gmob_dL*(deriv_sqrt_0_d0*((2.0*d_zsat_dV_SI_BP))))+(d_Gmob_dL_dV_SI_BP*(1.0+value_sqrt_0))));
            d_Gvsat_dV_GP_SI = (0.5*((Gmob_dL*(deriv_sqrt_0_d0*((2.0*d_zsat_dV_GP_SI))))+(d_Gmob_dL_dV_GP_SI*(1.0+value_sqrt_0))));
            d_Gvsat_dV_DI_SI = (0.5*((Gmob_dL*(deriv_sqrt_0_d0*((2.0*d_zsat_dV_DI_SI))))+(d_Gmob_dL_dV_DI_SI*(1.0+value_sqrt_0))));
            Gvsat = (0.5*(Gmob_dL*(1.0+value_sqrt_0)));
          }

          d_Gvsatinv_dV_SI_BP = (-d_Gvsat_dV_SI_BP/Gvsat/Gvsat);
          d_Gvsatinv_dV_GP_SI = (-d_Gvsat_dV_GP_SI/Gvsat/Gvsat);
          d_Gvsatinv_dV_DI_SI = (-d_Gvsat_dV_DI_SI/Gvsat/Gvsat);
          Gvsatinv = (1.0/Gvsat);

          d_Voxm_dV_SI_BP = ((xgm*d_phit1_dV_SI_BP)+(d_xgm_dV_SI_BP*phit1));
          d_Voxm_dV_GP_SI = ((xgm*d_phit1_dV_GP_SI)+(d_xgm_dV_GP_SI*phit1));
          d_Voxm_dV_DI_SI = ((xgm*d_phit1_dV_DI_SI)+(d_xgm_dV_DI_SI*phit1));
          Voxm = (xgm*phit1);

          d_temp_dV_SI_BP = ((Gmob_dL*d_Gvsatinv_dV_SI_BP)+(d_Gmob_dL_dV_SI_BP*Gvsatinv));
          d_temp_dV_GP_SI = ((Gmob_dL*d_Gvsatinv_dV_GP_SI)+(d_Gmob_dL_dV_GP_SI*Gvsatinv));
          d_temp_dV_DI_SI = ((Gmob_dL*d_Gvsatinv_dV_DI_SI)+(d_Gmob_dL_dV_DI_SI*Gvsatinv));
          temp = (Gmob_dL*Gvsatinv);

          d_alpha1_dV_SI_BP = ((alpha*(0.5*(((zsat*temp)*d_temp_dV_SI_BP)+(((zsat*d_temp_dV_SI_BP)+(d_zsat_dV_SI_BP*temp))*temp))))+(d_alpha_dV_SI_BP*(1.0+(0.5*((zsat*temp)*temp)))));
          d_alpha1_dV_GP_SI = ((alpha*(0.5*(((zsat*temp)*d_temp_dV_GP_SI)+(((zsat*d_temp_dV_GP_SI)+(d_zsat_dV_GP_SI*temp))*temp))))+(d_alpha_dV_GP_SI*(1.0+(0.5*((zsat*temp)*temp)))));
          d_alpha1_dV_DI_SI = ((alpha*(0.5*(((zsat*temp)*d_temp_dV_DI_SI)+(((zsat*d_temp_dV_DI_SI)+(d_zsat_dV_DI_SI*temp))*temp))))+(d_alpha_dV_DI_SI*(1.0+(0.5*((zsat*temp)*temp)))));
          alpha1 = (alpha*(1.0+(0.5*((zsat*temp)*temp))));

          d_H_dV_SI_BP = ((alpha1*((temp*d_qim1_dV_SI_BP)+(d_temp_dV_SI_BP*qim1))-(temp*qim1)*d_alpha1_dV_SI_BP)/alpha1/alpha1);
          d_H_dV_DI_SI = ((alpha1*((temp*d_qim1_dV_DI_SI)+(d_temp_dV_DI_SI*qim1))-(temp*qim1)*d_alpha1_dV_DI_SI)/alpha1/alpha1);
          d_H_dV_GP_SI = ((alpha1*((temp*d_qim1_dV_GP_SI)+(d_temp_dV_GP_SI*qim1))-(temp*qim1)*d_alpha1_dV_GP_SI)/alpha1/alpha1);
          H = ((temp*qim1)/alpha1);
        }
        if ((xg>0.0))
        {

          d_qim1_1_dV_GP_SI = (-d_qim1_dV_GP_SI/qim1/qim1);
          d_qim1_1_dV_SI_BP = (-d_qim1_dV_SI_BP/qim1/qim1);
          d_qim1_1_dV_DI_SI = (-d_qim1_dV_DI_SI/qim1/qim1);
          qim1_1 = (1.0/qim1);

          d_r1_dV_GP_SI = ((qim*d_qim1_1_dV_GP_SI)+(d_qim_dV_GP_SI*qim1_1));
          d_r1_dV_SI_BP = ((qim*d_qim1_1_dV_SI_BP)+(d_qim_dV_SI_BP*qim1_1));
          d_r1_dV_DI_SI = ((qim*d_qim1_1_dV_DI_SI)+(d_qim_dV_DI_SI*qim1_1));
          r1 = (qim*qim1_1);

          d_r2_dV_GP_SI = ((phit1*((alpha*d_qim1_1_dV_GP_SI)+(d_alpha_dV_GP_SI*qim1_1)))+(d_phit1_dV_GP_SI*(alpha*qim1_1)));
          d_r2_dV_SI_BP = ((phit1*((alpha*d_qim1_1_dV_SI_BP)+(d_alpha_dV_SI_BP*qim1_1)))+(d_phit1_dV_SI_BP*(alpha*qim1_1)));
          d_r2_dV_DI_SI = ((phit1*((alpha*d_qim1_1_dV_DI_SI)+(d_alpha_dV_DI_SI*qim1_1)))+(d_phit1_dV_DI_SI*(alpha*qim1_1)));
          r2 = (phit1*(alpha*qim1_1));
          {
            double value_log_0 = log((1.0+(Vdsx*inv_VP)));
            double  deriv_log_0_d0 = (1.0/(1.0+(Vdsx*inv_VP)));

            d_s2_dV_DI_SI = (deriv_log_0_d0*((d_Vdsx_dV_DI_SI*inv_VP)));
            s2 = value_log_0;
          }

          d_dL1_dV_SI_BP = ((d_dL_dV_SI_BP+(ALP1_i*(((qim1_1*r1)*d_s1_dV_SI_BP)+(((qim1_1*d_r1_dV_SI_BP)+(d_qim1_1_dV_SI_BP*r1))*s1))))+(ALP2_i*((((qbm*r2)*d_r2_dV_SI_BP)+(((qbm*d_r2_dV_SI_BP)+(d_qbm_dV_SI_BP*r2))*r2))*s2)));
          d_dL1_dV_GP_SI = ((d_dL_dV_GP_SI+(ALP1_i*(((qim1_1*r1)*d_s1_dV_GP_SI)+(((qim1_1*d_r1_dV_GP_SI)+(d_qim1_1_dV_GP_SI*r1))*s1))))+(ALP2_i*((((qbm*r2)*d_r2_dV_GP_SI)+(((qbm*d_r2_dV_GP_SI)+(d_qbm_dV_GP_SI*r2))*r2))*s2)));
          d_dL1_dV_DI_SI = ((d_dL_dV_DI_SI+(ALP1_i*(((qim1_1*r1)*d_s1_dV_DI_SI)+(((qim1_1*d_r1_dV_DI_SI)+(d_qim1_1_dV_DI_SI*r1))*s1))))+(ALP2_i*((((qbm*r2)*r2)*d_s2_dV_DI_SI)+((((qbm*r2)*d_r2_dV_DI_SI)+(((qbm*d_r2_dV_DI_SI)+(d_qbm_dV_DI_SI*r2))*r2))*s2))));
          dL1 = ((dL+(ALP1_i*((qim1_1*r1)*s1)))+(ALP2_i*(((qbm*r2)*r2)*s2)));

          d_FdL_dV_SI_BP = ((((1.0+dL1)+(dL1*dL1))*d_GdL_dV_SI_BP)+((d_dL1_dV_SI_BP+((dL1*d_dL1_dV_SI_BP)+(d_dL1_dV_SI_BP*dL1)))*GdL));
          d_FdL_dV_GP_SI = ((((1.0+dL1)+(dL1*dL1))*d_GdL_dV_GP_SI)+((d_dL1_dV_GP_SI+((dL1*d_dL1_dV_GP_SI)+(d_dL1_dV_GP_SI*dL1)))*GdL));
          d_FdL_dV_DI_SI = ((((1.0+dL1)+(dL1*dL1))*d_GdL_dV_DI_SI)+((d_dL1_dV_DI_SI+((dL1*d_dL1_dV_DI_SI)+(d_dL1_dV_DI_SI*dL1)))*GdL));
          FdL = (((1.0+dL1)+(dL1*dL1))*GdL);
        }

        d_xg_dc_dV_SI_BP = d_xg_dV_SI_BP;
        d_xg_dc_dV_GP_SI = d_xg_dV_GP_SI;
        d_xg_dc_dV_DI_SI = d_xg_dV_DI_SI;
        xg_dc = xg;

        d_qeff1_dc_dV_SI_BP = d_qeff1_dV_SI_BP;
        d_qeff1_dc_dV_GP_SI = d_qeff1_dV_GP_SI;
        d_qeff1_dc_dV_DI_SI = d_qeff1_dV_DI_SI;
        qeff1_dc = qeff1;

        d_Voxm_dc_dV_SI_BP = d_Voxm_dV_SI_BP;
        d_Voxm_dc_dV_GP_SI = d_Voxm_dV_GP_SI;
        d_Voxm_dc_dV_DI_SI = d_Voxm_dV_DI_SI;
        Voxm_dc = Voxm;

        d_alpha_dc_dV_SI_BP = d_alpha_dV_SI_BP;
        d_alpha_dc_dV_GP_SI = d_alpha_dV_GP_SI;
        d_alpha_dc_dV_DI_SI = d_alpha_dV_DI_SI;
        alpha_dc = alpha;

        d_dps_dc_dV_SI_BP = d_dps_dV_SI_BP;
        d_dps_dc_dV_GP_SI = d_dps_dV_GP_SI;
        d_dps_dc_dV_DI_SI = d_dps_dV_DI_SI;
        dps_dc = dps;

        d_qim_dc_dV_GP_SI = d_qim_dV_GP_SI;
        d_qim_dc_dV_SI_BP = d_qim_dV_SI_BP;
        d_qim_dc_dV_DI_SI = d_qim_dV_DI_SI;
        qim_dc = qim;

        d_qim1_dc_dV_GP_SI = d_qim1_dV_GP_SI;
        d_qim1_dc_dV_SI_BP = d_qim1_dV_SI_BP;
        d_qim1_dc_dV_DI_SI = d_qim1_dV_DI_SI;
        qim1_dc = qim1;

        d_GdL_dc_dV_SI_BP = d_GdL_dV_SI_BP;
        d_GdL_dc_dV_GP_SI = d_GdL_dV_GP_SI;
        d_GdL_dc_dV_DI_SI = d_GdL_dV_DI_SI;
        GdL_dc = GdL;

        d_FdL_dc_dV_SI_BP = d_FdL_dV_SI_BP;
        d_FdL_dc_dV_GP_SI = d_FdL_dV_GP_SI;
        d_FdL_dc_dV_DI_SI = d_FdL_dV_DI_SI;
        FdL_dc = FdL;

        d_H_dc_dV_SI_BP = d_H_dV_SI_BP;
        d_H_dc_dV_DI_SI = d_H_dV_DI_SI;
        d_H_dc_dV_GP_SI = d_H_dV_GP_SI;
        H_dc = H;

        d_eta_p_dc_dV_SI_BP = d_eta_p_dV_SI_BP;
        d_eta_p_dc_dV_GP_SI = d_eta_p_dV_GP_SI;
        d_eta_p_dc_dV_DI_SI = d_eta_p_dV_DI_SI;
        eta_p_dc = eta_p;

        d_Gvsat_dc_dV_SI_BP = d_Gvsat_dV_SI_BP;
        d_Gvsat_dc_dV_GP_SI = d_Gvsat_dV_GP_SI;
        d_Gvsat_dc_dV_DI_SI = d_Gvsat_dV_DI_SI;
        Gvsat_dc = Gvsat;

        d_Gvsatinv_dc_dV_SI_BP = d_Gvsatinv_dV_SI_BP;
        d_Gvsatinv_dc_dV_GP_SI = d_Gvsatinv_dV_GP_SI;
        d_Gvsatinv_dc_dV_DI_SI = d_Gvsatinv_dV_DI_SI;
        Gvsatinv_dc = Gvsatinv;

        d_Gmob_dL_dc_dV_SI_BP = d_Gmob_dL_dV_SI_BP;
        d_Gmob_dL_dc_dV_GP_SI = d_Gmob_dL_dV_GP_SI;
        d_Gmob_dL_dc_dV_DI_SI = d_Gmob_dL_dV_DI_SI;
        Gmob_dL_dc = Gmob_dL;

        d_x_ds_dc_dV_SI_BP = d_x_ds_dV_SI_BP;
        d_x_ds_dc_dV_GP_SI = d_x_ds_dV_GP_SI;
        d_x_ds_dc_dV_DI_SI = d_x_ds_dV_DI_SI;
        x_ds_dc = x_ds;

        d_x_m_dc_dV_SI_BP = d_x_m_dV_SI_BP;
        d_x_m_dc_dV_GP_SI = d_x_m_dV_GP_SI;
        d_x_m_dc_dV_DI_SI = d_x_m_dV_DI_SI;
        x_m_dc = x_m;

        d_Gf_dc_dV_SI_BP = d_Gf_dV_SI_BP;
        d_Gf_dc_dV_GP_SI = d_Gf_dV_GP_SI;
        d_Gf_dc_dV_DI_SI = d_Gf_dV_DI_SI;
        Gf_dc = Gf;

        d_Vdsat_dc_dV_SI_BP = d_Vdsat_dV_SI_BP;
        d_Vdsat_dc_dV_DI_SI = d_Vdsat_dV_DI_SI;
        d_Vdsat_dc_dV_GP_SI = d_Vdsat_dV_GP_SI;
        Vdsat_dc = Vdsat;

        d_Udse_dc_dV_DI_SI = d_Udse_dV_DI_SI;
        d_Udse_dc_dV_SI_BP = d_Udse_dV_SI_BP;
        d_Udse_dc_dV_GP_SI = d_Udse_dV_GP_SI;
        Udse_dc = Udse;

        d_Gmob_dc_dV_SI_BP = d_Gmob_dV_SI_BP;
        d_Gmob_dc_dV_GP_SI = d_Gmob_dV_GP_SI;
        d_Gmob_dc_dV_DI_SI = d_Gmob_dV_DI_SI;
        Gmob_dc = Gmob;

        d_xitsb_dc_dV_SI_BP = d_xitsb_dV_SI_BP;
        d_xitsb_dc_dV_DI_SI = d_xitsb_dV_DI_SI;
        xitsb_dc = xitsb;

        d_Vdse_dc_dV_DI_SI = d_Vdse_dV_DI_SI;
        d_Vdse_dc_dV_SI_BP = d_Vdse_dV_SI_BP;
        d_Vdse_dc_dV_GP_SI = d_Vdse_dV_GP_SI;
        Vdse_dc = Vdse;
      }
      // End block SPcalc_dc
      if ((xg_dc<=0))
      {

        d_Ids_dV_DI_SI = d_Ids_dV_GP_SI = d_Ids_dV_SI_BP =  0.0;
        Ids = 0.0;
      }
      else
      {

        d_Ids_dV_SI_BP = (BET_i*((((FdL_dc*qim1_dc)*dps_dc)*d_Gvsatinv_dc_dV_SI_BP)+((((FdL_dc*qim1_dc)*d_dps_dc_dV_SI_BP)+(((FdL_dc*d_qim1_dc_dV_SI_BP)+(d_FdL_dc_dV_SI_BP*qim1_dc))*dps_dc))*Gvsatinv_dc)));
        d_Ids_dV_GP_SI = (BET_i*((((FdL_dc*qim1_dc)*dps_dc)*d_Gvsatinv_dc_dV_GP_SI)+((((FdL_dc*qim1_dc)*d_dps_dc_dV_GP_SI)+(((FdL_dc*d_qim1_dc_dV_GP_SI)+(d_FdL_dc_dV_GP_SI*qim1_dc))*dps_dc))*Gvsatinv_dc)));
        d_Ids_dV_DI_SI = (BET_i*((((FdL_dc*qim1_dc)*dps_dc)*d_Gvsatinv_dc_dV_DI_SI)+((((FdL_dc*qim1_dc)*d_dps_dc_dV_DI_SI)+(((FdL_dc*d_qim1_dc_dV_DI_SI)+(d_FdL_dc_dV_DI_SI*qim1_dc))*dps_dc))*Gvsatinv_dc)));
        Ids = (BET_i*(((FdL_dc*qim1_dc)*dps_dc)*Gvsatinv_dc));
      }
      if (((((((model_.SWIGATE_i)!=0)&&((IGOV_i>0.0)||(IGOVD_i>0.0)))||(((model_.SWGIDL_i)!=0)&&((AGIDL_i>0.0)||(AGIDLD_i>0.0))))||(CGOV_i>0.0))||(CGOVD_i>0.0)))
      {
        {
          double value_sqrt_0 = sqrt(((xgs_ov*xgs_ov)+SP_OV_eps2_s));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_SP_OV_xg_dV_DI_SI =  0.0;
          d_SP_OV_xg_dV_GP_SI = (0.5*(d_xgs_ov_dV_GP_SI+(deriv_sqrt_0_d0*(((xgs_ov*d_xgs_ov_dV_GP_SI)+(d_xgs_ov_dV_GP_SI*xgs_ov))))));
          SP_OV_xg = (0.5*(xgs_ov+value_sqrt_0));
        }
        {
          double value_sqrt_0 = sqrt(((SP_OV_xg+(GOV2_s*0.25))+SP_OV_a_s));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_xs_ov_dV_GP_SI = ((-d_SP_OV_xg_dV_GP_SI)+(GOV_s*(deriv_sqrt_0_d0*(d_SP_OV_xg_dV_GP_SI))));
          xs_ov = ((((-SP_OV_xg)-(GOV2_s*0.5))+(GOV_s*value_sqrt_0))+SP_OV_delta1_s);
        }
        {
          double value_sqrt_0 = sqrt(((xgd_ov*xgd_ov)+SP_OV_eps2_d));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_SP_OV_xg_dV_DI_SI = (0.5*(d_xgd_ov_dV_DI_SI+(deriv_sqrt_0_d0*(((xgd_ov*d_xgd_ov_dV_DI_SI)+(d_xgd_ov_dV_DI_SI*xgd_ov))))));
          d_SP_OV_xg_dV_GP_SI = (0.5*(d_xgd_ov_dV_GP_SI+(deriv_sqrt_0_d0*(((xgd_ov*d_xgd_ov_dV_GP_SI)+(d_xgd_ov_dV_GP_SI*xgd_ov))))));
          SP_OV_xg = (0.5*(xgd_ov+value_sqrt_0));
        }
        {
          double value_sqrt_0 = sqrt(((SP_OV_xg+(GOV2_d*0.25))+SP_OV_a_d));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_xd_ov_dV_GP_SI = ((-d_SP_OV_xg_dV_GP_SI)+(GOV_d*(deriv_sqrt_0_d0*(d_SP_OV_xg_dV_GP_SI))));
          d_xd_ov_dV_DI_SI = ((-d_SP_OV_xg_dV_DI_SI)+(GOV_d*(deriv_sqrt_0_d0*(d_SP_OV_xg_dV_DI_SI))));
          xd_ov = ((((-SP_OV_xg)-(GOV2_d*0.5))+(GOV_d*value_sqrt_0))+SP_OV_delta1_d);
        }

        d_Vovs_dV_GP_SI = ((-(model_.phita))*(d_xgs_ov_dV_GP_SI+d_xs_ov_dV_GP_SI));
        Vovs = ((-(model_.phita))*(xgs_ov+xs_ov));

        d_Vovd_dV_DI_SI = ((-(model_.phita))*(d_xgd_ov_dV_DI_SI+d_xd_ov_dV_DI_SI));
        d_Vovd_dV_GP_SI = ((-(model_.phita))*(d_xgd_ov_dV_GP_SI+d_xd_ov_dV_GP_SI));
        Vovd = ((-(model_.phita))*(xgd_ov+xd_ov));
      }

      d_Igsov_dV_GP_SI = d_Igsov_dV_DI_SI = d_Igsov_dV_SI_BP =  0.0;
      Igsov = 0.0;

      d_Igdov_dV_GP_SI = d_Igdov_dV_DI_SI = d_Igdov_dV_SI_BP =  0.0;
      Igdov = 0.0;

      d_Igc_dV_GP_SI = d_Igc_dV_DI_SI = d_Igc_dV_SI_BP =  0.0;
      Igc = 0.0;

      d_Igb_dV_GP_SI = d_Igb_dV_DI_SI = d_Igb_dV_SI_BP =  0.0;
      Igb = 0.0;

      d_Igcs_dV_GP_SI = d_Igcs_dV_DI_SI = d_Igcs_dV_SI_BP =  0.0;
      Igcs = 0.0;

      d_Igcd_dV_GP_SI = d_Igcd_dV_DI_SI = d_Igcd_dV_SI_BP =  0.0;
      Igcd = 0.0;
      if (((model_.SWIGATE_i)!=0))
      {
        if ((IGOV_i>0.0))
        {
          {
            double value_sqrt_0 = sqrt(((Vovs*Vovs)+1.0e-6));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_zg_dV_SI_BP = d_zg_dV_DI_SI =  0.0;
            d_zg_dV_GP_SI = ((deriv_sqrt_0_d0*(((Vovs*d_Vovs_dV_GP_SI)+(d_Vovs_dV_GP_SI*Vovs))))*inv_CHIB);
            zg = (value_sqrt_0*inv_CHIB);
          }
          if ((GC3_i<0.0))
          {
            {
              double value_sqrt_0 = sqrt((((zg-GCQ)*(zg-GCQ))+1.0e-6));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_zg_dV_SI_BP = d_zg_dV_DI_SI =  0.0;
              d_zg_dV_GP_SI = (0.5*(d_zg_dV_GP_SI-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_GP_SI)+(d_zg_dV_GP_SI*(zg-GCQ)))))));
              zg = (0.5*((zg+GCQ)-value_sqrt_0));
            }
          }

          d_temp_dV_DI_SI = d_temp_dV_SI_BP =  0.0;
          d_temp_dV_GP_SI = (BOV*((zg*(GC3_i*d_zg_dV_GP_SI))+(d_zg_dV_GP_SI*(GC2_i+(GC3_i*zg)))));
          temp = (BOV*((-1.5)+(zg*(GC2_i+(GC3_i*zg)))));
          if ((temp>0.0))
          {

            d_TP_dV_SI_BP = ((temp*(0.5*((temp*(d_temp_dV_SI_BP*3.3333333333333333e-01))+(d_temp_dV_SI_BP*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_SI_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            d_TP_dV_DI_SI = ((temp*(0.5*((temp*(d_temp_dV_DI_SI*3.3333333333333333e-01))+(d_temp_dV_DI_SI*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_DI_SI*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            d_TP_dV_GP_SI = ((temp*(0.5*((temp*(d_temp_dV_GP_SI*3.3333333333333333e-01))+(d_temp_dV_GP_SI*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_GP_SI*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
          }
          else
          {
            if ((temp>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(temp);
                double  deriv_exp_0_d0 = value_exp_0;

                d_TP_dV_SI_BP = (deriv_exp_0_d0*(d_temp_dV_SI_BP));
                d_TP_dV_DI_SI = (deriv_exp_0_d0*(d_temp_dV_DI_SI));
                d_TP_dV_GP_SI = (deriv_exp_0_d0*(d_temp_dV_GP_SI));
                TP = value_exp_0;
              }
            }
            else
            {

              d_TP_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_SI_BP)*3.3333333333333333e-01))+((-d_temp_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              d_TP_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_DI_SI)*3.3333333333333333e-01))+((-d_temp_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              d_TP_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_GP_SI)*3.3333333333333333e-01))+((-d_temp_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            }
          }

          d_Fs1_dV_DI_SI =  0.0;
          d_Fs1_dV_GP_SI = d_xs_ov_dV_GP_SI;
          Fs1 = (3.0+xs_ov);
          Fs2 = ((-3.0)-GCO_i);

          d_Fs3_dV_DI_SI =  0.0;
          d_Fs3_dV_GP_SI = (30.0*d_VgsPrime_dV_GP_SI);
          Fs3 = (30.0*VgsPrime);
          tme1 = (4.0-0.9);

          d_tme2_dV_DI_SI = d_tme2_dV_SI_BP =  0.0;
          d_tme2_dV_GP_SI = (d_Fs1_dV_GP_SI+d_Fs3_dV_GP_SI);
          tme2 = (Fs1+Fs3);
          {
            double value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs1)*Fs3)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_temp_dV_DI_SI = d_temp_dV_SI_BP =  0.0;
            d_temp_dV_GP_SI = ((2.0/tme1)*(d_tme2_dV_GP_SI-(deriv_sqrt_0_d0*((((tme2*d_tme2_dV_GP_SI)+(d_tme2_dV_GP_SI*tme2))-(((tme1*Fs1)*d_Fs3_dV_GP_SI)+((tme1*d_Fs1_dV_GP_SI)*Fs3)))))));
            temp = ((2.0/tme1)*(tme2-value_sqrt_0));
          }
          tme1 = (4.0-0.3);

          d_tme2_dV_SI_BP = d_temp_dV_SI_BP;
          d_tme2_dV_DI_SI = d_temp_dV_DI_SI;
          d_tme2_dV_GP_SI = d_temp_dV_GP_SI;
          tme2 = (Fs2+temp);
          {
            double value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs2)*temp)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Fs_dV_GP_SI = ((2.0/tme1)*(d_tme2_dV_GP_SI+(deriv_sqrt_0_d0*((((tme2*d_tme2_dV_GP_SI)+(d_tme2_dV_GP_SI*tme2))-((tme1*Fs2)*d_temp_dV_GP_SI))))));
            d_Fs_dV_SI_BP = ((2.0/tme1)*(d_tme2_dV_SI_BP+(deriv_sqrt_0_d0*((((tme2*d_tme2_dV_SI_BP)+(d_tme2_dV_SI_BP*tme2))-((tme1*Fs2)*d_temp_dV_SI_BP))))));
            d_Fs_dV_DI_SI = ((2.0/tme1)*(d_tme2_dV_DI_SI+(deriv_sqrt_0_d0*((((tme2*d_tme2_dV_DI_SI)+(d_tme2_dV_DI_SI*tme2))-((tme1*Fs2)*d_temp_dV_DI_SI))))));
            Fs = ((2.0/tme1)*(tme2+value_sqrt_0));
          }

          d_Igsov_dV_SI_BP = (IGOV_i*((TP*d_Fs_dV_SI_BP)+(d_TP_dV_SI_BP*Fs)));
          d_Igsov_dV_DI_SI = (IGOV_i*((TP*d_Fs_dV_DI_SI)+(d_TP_dV_DI_SI*Fs)));
          d_Igsov_dV_GP_SI = (IGOV_i*((TP*d_Fs_dV_GP_SI)+(d_TP_dV_GP_SI*Fs)));
          Igsov = (IGOV_i*(TP*Fs));
        }
        if ((IGOVD_i>0.0))
        {
          {
            double value_sqrt_0 = sqrt(((Vovd*Vovd)+1.0e-6));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_zg_dV_SI_BP =  0.0;
            d_zg_dV_DI_SI = ((deriv_sqrt_0_d0*(((Vovd*d_Vovd_dV_DI_SI)+(d_Vovd_dV_DI_SI*Vovd))))*inv_CHIB);
            d_zg_dV_GP_SI = ((deriv_sqrt_0_d0*(((Vovd*d_Vovd_dV_GP_SI)+(d_Vovd_dV_GP_SI*Vovd))))*inv_CHIB);
            zg = (value_sqrt_0*inv_CHIB);
          }
          if ((GC3_i<0.0))
          {
            {
              double value_sqrt_0 = sqrt((((zg-GCQ)*(zg-GCQ))+1.0e-6));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_zg_dV_SI_BP =  0.0;
              d_zg_dV_GP_SI = (0.5*(d_zg_dV_GP_SI-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_GP_SI)+(d_zg_dV_GP_SI*(zg-GCQ)))))));
              d_zg_dV_DI_SI = (0.5*(d_zg_dV_DI_SI-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_DI_SI)+(d_zg_dV_DI_SI*(zg-GCQ)))))));
              zg = (0.5*((zg+GCQ)-value_sqrt_0));
            }
          }

          d_temp_dV_SI_BP =  0.0;
          d_temp_dV_GP_SI = (BOV_d*((zg*(GC3_i*d_zg_dV_GP_SI))+(d_zg_dV_GP_SI*(GC2_i+(GC3_i*zg)))));
          d_temp_dV_DI_SI = (BOV_d*((zg*(GC3_i*d_zg_dV_DI_SI))+(d_zg_dV_DI_SI*(GC2_i+(GC3_i*zg)))));
          temp = (BOV_d*((-1.5)+(zg*(GC2_i+(GC3_i*zg)))));
          if ((temp>0.0))
          {

            d_TP_dV_SI_BP = ((temp*(0.5*((temp*(d_temp_dV_SI_BP*3.3333333333333333e-01))+(d_temp_dV_SI_BP*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_SI_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            d_TP_dV_DI_SI = ((temp*(0.5*((temp*(d_temp_dV_DI_SI*3.3333333333333333e-01))+(d_temp_dV_DI_SI*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_DI_SI*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            d_TP_dV_GP_SI = ((temp*(0.5*((temp*(d_temp_dV_GP_SI*3.3333333333333333e-01))+(d_temp_dV_GP_SI*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_GP_SI*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
          }
          else
          {
            if ((temp>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(temp);
                double  deriv_exp_0_d0 = value_exp_0;

                d_TP_dV_SI_BP = (deriv_exp_0_d0*(d_temp_dV_SI_BP));
                d_TP_dV_DI_SI = (deriv_exp_0_d0*(d_temp_dV_DI_SI));
                d_TP_dV_GP_SI = (deriv_exp_0_d0*(d_temp_dV_GP_SI));
                TP = value_exp_0;
              }
            }
            else
            {

              d_TP_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_SI_BP)*3.3333333333333333e-01))+((-d_temp_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              d_TP_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_DI_SI)*3.3333333333333333e-01))+((-d_temp_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              d_TP_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_GP_SI)*3.3333333333333333e-01))+((-d_temp_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            }
          }

          d_Fs1_dV_GP_SI = d_xd_ov_dV_GP_SI;
          d_Fs1_dV_DI_SI = d_xd_ov_dV_DI_SI;
          Fs1 = (3.0+xd_ov);
          Fs2 = ((-3.0)-GCO_i);

          d_Fs3_dV_DI_SI = (30.0*d_VgdPrime_dV_DI_SI);
          d_Fs3_dV_GP_SI = (30.0*d_VgdPrime_dV_GP_SI);
          Fs3 = (30.0*VgdPrime);
          tme1 = (4.0-0.9);

          d_tme2_dV_SI_BP =  0.0;
          d_tme2_dV_GP_SI = (d_Fs1_dV_GP_SI+d_Fs3_dV_GP_SI);
          d_tme2_dV_DI_SI = (d_Fs1_dV_DI_SI+d_Fs3_dV_DI_SI);
          tme2 = (Fs1+Fs3);
          {
            double value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs1)*Fs3)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_temp_dV_GP_SI = ((2.0/tme1)*(d_tme2_dV_GP_SI-(deriv_sqrt_0_d0*((((tme2*d_tme2_dV_GP_SI)+(d_tme2_dV_GP_SI*tme2))-(((tme1*Fs1)*d_Fs3_dV_GP_SI)+((tme1*d_Fs1_dV_GP_SI)*Fs3)))))));
            d_temp_dV_SI_BP = ((2.0/tme1)*(d_tme2_dV_SI_BP-(deriv_sqrt_0_d0*(((tme2*d_tme2_dV_SI_BP)+(d_tme2_dV_SI_BP*tme2))))));
            d_temp_dV_DI_SI = ((2.0/tme1)*(d_tme2_dV_DI_SI-(deriv_sqrt_0_d0*((((tme2*d_tme2_dV_DI_SI)+(d_tme2_dV_DI_SI*tme2))-(((tme1*Fs1)*d_Fs3_dV_DI_SI)+((tme1*d_Fs1_dV_DI_SI)*Fs3)))))));
            temp = ((2.0/tme1)*(tme2-value_sqrt_0));
          }
          tme1 = (4.0-0.3);

          d_tme2_dV_SI_BP = d_temp_dV_SI_BP;
          d_tme2_dV_DI_SI = d_temp_dV_DI_SI;
          d_tme2_dV_GP_SI = d_temp_dV_GP_SI;
          tme2 = (Fs2+temp);
          {
            double value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs2)*temp)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Fs_dV_GP_SI = ((2.0/tme1)*(d_tme2_dV_GP_SI+(deriv_sqrt_0_d0*((((tme2*d_tme2_dV_GP_SI)+(d_tme2_dV_GP_SI*tme2))-((tme1*Fs2)*d_temp_dV_GP_SI))))));
            d_Fs_dV_SI_BP = ((2.0/tme1)*(d_tme2_dV_SI_BP+(deriv_sqrt_0_d0*((((tme2*d_tme2_dV_SI_BP)+(d_tme2_dV_SI_BP*tme2))-((tme1*Fs2)*d_temp_dV_SI_BP))))));
            d_Fs_dV_DI_SI = ((2.0/tme1)*(d_tme2_dV_DI_SI+(deriv_sqrt_0_d0*((((tme2*d_tme2_dV_DI_SI)+(d_tme2_dV_DI_SI*tme2))-((tme1*Fs2)*d_temp_dV_DI_SI))))));
            Fs = ((2.0/tme1)*(tme2+value_sqrt_0));
          }

          d_Igdov_dV_SI_BP = (IGOVD_i*((TP*d_Fs_dV_SI_BP)+(d_TP_dV_SI_BP*Fs)));
          d_Igdov_dV_DI_SI = (IGOVD_i*((TP*d_Fs_dV_DI_SI)+(d_TP_dV_DI_SI*Fs)));
          d_Igdov_dV_GP_SI = (IGOVD_i*((TP*d_Fs_dV_GP_SI)+(d_TP_dV_GP_SI*Fs)));
          Igdov = (IGOVD_i*(TP*Fs));
        }
        if ((IGINV_i>0.0))
        {
          if ((xg_dc<=0.0))
          {
            {
              double value_pow_0 = pow((Vds/Vdsat_lim),AX_i);
              double  deriv_pow_0_d0 = (((Vds/Vdsat_lim) == 0.0)?0.0:(value_pow_0*AX_i/(Vds/Vdsat_lim)));

              d_temp_dV_GP_SI =  0.0;
              d_temp_dV_SI_BP = (deriv_pow_0_d0*((-Vds*d_Vdsat_lim_dV_SI_BP/Vdsat_lim/Vdsat_lim)));
              d_temp_dV_DI_SI = (deriv_pow_0_d0*(((Vdsat_lim*d_Vds_dV_DI_SI-Vds*d_Vdsat_lim_dV_DI_SI)/Vdsat_lim/Vdsat_lim)));
              temp = value_pow_0;
            }
            {
              double value_pow_0 = pow((1.0+temp),(-inv_AX));
              double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-inv_AX)/(1.0+temp)));

              d_Udse_dc_dV_SI_BP = (((Vds*value_pow_0)*d_inv_phit1_dV_SI_BP)+((Vds*(deriv_pow_0_d0*(d_temp_dV_SI_BP)))*inv_phit1));
              d_Udse_dc_dV_GP_SI = (((Vds*value_pow_0)*d_inv_phit1_dV_GP_SI)+((Vds*(deriv_pow_0_d0*(d_temp_dV_GP_SI)))*inv_phit1));
              d_Udse_dc_dV_DI_SI = (((Vds*value_pow_0)*d_inv_phit1_dV_DI_SI)+(((Vds*(deriv_pow_0_d0*(d_temp_dV_DI_SI)))+(d_Vds_dV_DI_SI*value_pow_0))*inv_phit1));
              Udse_dc = ((Vds*value_pow_0)*inv_phit1);
            }
          }
          if (((x_ds_dc-Udse_dc)>(-2.3025850929940458e+02)))
          {
            {
              double value_exp_0 = exp((x_ds_dc-Udse_dc));
              double  deriv_exp_0_d0 = value_exp_0;

              d_temp_dV_SI_BP = (deriv_exp_0_d0*((d_x_ds_dc_dV_SI_BP-d_Udse_dc_dV_SI_BP)));
              d_temp_dV_GP_SI = (deriv_exp_0_d0*((d_x_ds_dc_dV_GP_SI-d_Udse_dc_dV_GP_SI)));
              d_temp_dV_DI_SI = (deriv_exp_0_d0*((d_x_ds_dc_dV_DI_SI-d_Udse_dc_dV_DI_SI)));
              temp = value_exp_0;
            }
          }
          else
          {

            d_temp_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(0.5*((((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*((-(d_x_ds_dc_dV_SI_BP-d_Udse_dc_dV_SI_BP))*3.3333333333333333e-01))+((-(d_x_ds_dc_dV_SI_BP-d_Udse_dc_dV_SI_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))+((-(d_x_ds_dc_dV_SI_BP-d_Udse_dc_dV_SI_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))));
            d_temp_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(0.5*((((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*((-(d_x_ds_dc_dV_GP_SI-d_Udse_dc_dV_GP_SI))*3.3333333333333333e-01))+((-(d_x_ds_dc_dV_GP_SI-d_Udse_dc_dV_GP_SI))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))+((-(d_x_ds_dc_dV_GP_SI-d_Udse_dc_dV_GP_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))));
            d_temp_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(0.5*((((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*((-(d_x_ds_dc_dV_DI_SI-d_Udse_dc_dV_DI_SI))*3.3333333333333333e-01))+((-(d_x_ds_dc_dV_DI_SI-d_Udse_dc_dV_DI_SI))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))+((-(d_x_ds_dc_dV_DI_SI-d_Udse_dc_dV_DI_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))));
            temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))));
          }
          {
            double value_log_0 = log((0.5*(1.0+temp)));
            double  deriv_log_0_d0 = (1.0/(0.5*(1.0+temp)));

            d_Vm_dV_GP_SI = ((phit1*((0.5*d_x_ds_dc_dV_GP_SI)-(deriv_log_0_d0*((0.5*d_temp_dV_GP_SI)))))+(d_phit1_dV_GP_SI*((0.5*x_ds_dc)-value_log_0)));
            d_Vm_dV_SI_BP = (d_Vsbstar_dc_dV_SI_BP+((phit1*((0.5*d_x_ds_dc_dV_SI_BP)-(deriv_log_0_d0*((0.5*d_temp_dV_SI_BP)))))+(d_phit1_dV_SI_BP*((0.5*x_ds_dc)-value_log_0))));
            d_Vm_dV_DI_SI = (d_Vsbstar_dc_dV_DI_SI+((phit1*((0.5*d_x_ds_dc_dV_DI_SI)-(deriv_log_0_d0*((0.5*d_temp_dV_DI_SI)))))+(d_phit1_dV_DI_SI*((0.5*x_ds_dc)-value_log_0))));
            Vm = (Vsbstar_dc+(phit1*((0.5*x_ds_dc)-value_log_0)));
          }

          d_Dch_dV_SI_BP = (GCO_i*d_phit1_dV_SI_BP);
          d_Dch_dV_DI_SI = (GCO_i*d_phit1_dV_DI_SI);
          Dch = (GCO_i*phit1);

          d_arg2mina_dV_SI_BP = (d_Voxm_dc_dV_SI_BP+d_Dch_dV_SI_BP);
          d_arg2mina_dV_GP_SI = d_Voxm_dc_dV_GP_SI;
          d_arg2mina_dV_DI_SI = (d_Voxm_dc_dV_DI_SI+d_Dch_dV_DI_SI);
          arg2mina = (Voxm_dc+Dch);
          {
            double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_psi_t_dV_SI_BP = (0.5*((+d_arg2mina_dV_SI_BP)-(deriv_sqrt_0_d0*((((-arg2mina)*(-d_arg2mina_dV_SI_BP))+((-d_arg2mina_dV_SI_BP)*(-arg2mina)))))));
            d_psi_t_dV_GP_SI = (0.5*((+d_arg2mina_dV_GP_SI)-(deriv_sqrt_0_d0*((((-arg2mina)*(-d_arg2mina_dV_GP_SI))+((-d_arg2mina_dV_GP_SI)*(-arg2mina)))))));
            d_psi_t_dV_DI_SI = (0.5*((+d_arg2mina_dV_DI_SI)-(deriv_sqrt_0_d0*((((-arg2mina)*(-d_arg2mina_dV_DI_SI))+((-d_arg2mina_dV_DI_SI)*(-arg2mina)))))));
            psi_t = (0.5*((+arg2mina)-value_sqrt_0));
          }
          {
            double value_sqrt_0 = sqrt(((Voxm_dc*Voxm_dc)+1.0e-6));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_zg_dV_SI_BP = ((deriv_sqrt_0_d0*(((Voxm_dc*d_Voxm_dc_dV_SI_BP)+(d_Voxm_dc_dV_SI_BP*Voxm_dc))))*inv_CHIB);
            d_zg_dV_GP_SI = ((deriv_sqrt_0_d0*(((Voxm_dc*d_Voxm_dc_dV_GP_SI)+(d_Voxm_dc_dV_GP_SI*Voxm_dc))))*inv_CHIB);
            d_zg_dV_DI_SI = ((deriv_sqrt_0_d0*(((Voxm_dc*d_Voxm_dc_dV_DI_SI)+(d_Voxm_dc_dV_DI_SI*Voxm_dc))))*inv_CHIB);
            zg = (value_sqrt_0*inv_CHIB);
          }
          if ((GC3_i<0.0))
          {
            {
              double value_sqrt_0 = sqrt((((zg-GCQ)*(zg-GCQ))+1.0e-06));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_zg_dV_GP_SI = (0.5*(d_zg_dV_GP_SI-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_GP_SI)+(d_zg_dV_GP_SI*(zg-GCQ)))))));
              d_zg_dV_DI_SI = (0.5*(d_zg_dV_DI_SI-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_DI_SI)+(d_zg_dV_DI_SI*(zg-GCQ)))))));
              d_zg_dV_SI_BP = (0.5*(d_zg_dV_SI_BP-(deriv_sqrt_0_d0*((((zg-GCQ)*d_zg_dV_SI_BP)+(d_zg_dV_SI_BP*(zg-GCQ)))))));
              zg = (0.5*((zg+GCQ)-value_sqrt_0));
            }
          }

          d_arg1_dV_SI_BP = (d_x_m_dc_dV_SI_BP+((((psi_t-alpha_b)-Vm)*d_inv_phit1_dV_SI_BP)+((d_psi_t_dV_SI_BP-d_Vm_dV_SI_BP)*inv_phit1)));
          d_arg1_dV_GP_SI = (d_x_m_dc_dV_GP_SI+((((psi_t-alpha_b)-Vm)*d_inv_phit1_dV_GP_SI)+((d_psi_t_dV_GP_SI-d_Vm_dV_GP_SI)*inv_phit1)));
          d_arg1_dV_DI_SI = (d_x_m_dc_dV_DI_SI+((((psi_t-alpha_b)-Vm)*d_inv_phit1_dV_DI_SI)+((d_psi_t_dV_DI_SI-d_Vm_dV_DI_SI)*inv_phit1)));
          arg1 = (x_m_dc+(((psi_t-alpha_b)-Vm)*inv_phit1));
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp(arg1);
              double  deriv_exp_0_d0 = value_exp_0;

              d_Dsi_dV_SI_BP = (deriv_exp_0_d0*(d_arg1_dV_SI_BP));
              d_Dsi_dV_GP_SI = (deriv_exp_0_d0*(d_arg1_dV_GP_SI));
              d_Dsi_dV_DI_SI = (deriv_exp_0_d0*(d_arg1_dV_DI_SI));
              Dsi = value_exp_0;
            }
          }
          else
          {
            if ((arg1<0.0))
            {

              d_Dsi_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_SI_BP)*3.3333333333333333e-01))+((-d_arg1_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_Dsi_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_GP_SI)*3.3333333333333333e-01))+((-d_arg1_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_Dsi_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_DI_SI)*3.3333333333333333e-01))+((-d_arg1_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {

              d_Dsi_dV_SI_BP = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_SI_BP*3.3333333333333333e-01))+(d_arg1_dV_SI_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_SI_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Dsi_dV_GP_SI = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_GP_SI*3.3333333333333333e-01))+(d_arg1_dV_GP_SI*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_GP_SI*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Dsi_dV_DI_SI = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_DI_SI*3.3333333333333333e-01))+(d_arg1_dV_DI_SI*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_DI_SI*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }

          d_arg1_dV_SI_BP = (((-((Vgs+Vsbstar_dc)-Vm))*d_inv_phit1_dV_SI_BP)+((-(d_Vsbstar_dc_dV_SI_BP-d_Vm_dV_SI_BP))*inv_phit1));
          d_arg1_dV_GP_SI = (((-((Vgs+Vsbstar_dc)-Vm))*d_inv_phit1_dV_GP_SI)+((-(d_Vgs_dV_GP_SI-d_Vm_dV_GP_SI))*inv_phit1));
          d_arg1_dV_DI_SI = (((-((Vgs+Vsbstar_dc)-Vm))*d_inv_phit1_dV_DI_SI)+((-((d_Vgs_dV_DI_SI+d_Vsbstar_dc_dV_DI_SI)-d_Vm_dV_DI_SI))*inv_phit1));
          arg1 = ((-((Vgs+Vsbstar_dc)-Vm))*inv_phit1);
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp(arg1);
              double  deriv_exp_0_d0 = value_exp_0;

              d_temp_dV_SI_BP = (deriv_exp_0_d0*(d_arg1_dV_SI_BP));
              d_temp_dV_GP_SI = (deriv_exp_0_d0*(d_arg1_dV_GP_SI));
              d_temp_dV_DI_SI = (deriv_exp_0_d0*(d_arg1_dV_DI_SI));
              temp = value_exp_0;
            }
          }
          else
          {
            if ((arg1<0.0))
            {

              d_temp_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_SI_BP)*3.3333333333333333e-01))+((-d_arg1_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_temp_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_GP_SI)*3.3333333333333333e-01))+((-d_arg1_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              d_temp_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-arg1)*(0.5*((((-2.3025850929940458e+02)-arg1)*((-d_arg1_dV_DI_SI)*3.3333333333333333e-01))+((-d_arg1_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+((-d_arg1_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
              temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {

              d_temp_dV_SI_BP = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_SI_BP*3.3333333333333333e-01))+(d_arg1_dV_SI_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_SI_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_temp_dV_GP_SI = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_GP_SI*3.3333333333333333e-01))+(d_arg1_dV_GP_SI*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_GP_SI*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_temp_dV_DI_SI = (1.0e100*(((arg1-2.3025850929940458e+02)*(0.5*(((arg1-2.3025850929940458e+02)*(d_arg1_dV_DI_SI*3.3333333333333333e-01))+(d_arg1_dV_DI_SI*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_arg1_dV_DI_SI*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }

          d_Dgate_dV_SI_BP = ((Dsi*d_temp_dV_SI_BP)+(d_Dsi_dV_SI_BP*temp));
          d_Dgate_dV_GP_SI = ((Dsi*d_temp_dV_GP_SI)+(d_Dsi_dV_GP_SI*temp));
          d_Dgate_dV_DI_SI = ((Dsi*d_temp_dV_DI_SI)+(d_Dsi_dV_DI_SI*temp));
          Dgate = (Dsi*temp);

          d_temp_dV_GP_SI = (BCH*((zg*(GC3_i*d_zg_dV_GP_SI))+(d_zg_dV_GP_SI*(GC2_i+(GC3_i*zg)))));
          d_temp_dV_DI_SI = (BCH*((zg*(GC3_i*d_zg_dV_DI_SI))+(d_zg_dV_DI_SI*(GC2_i+(GC3_i*zg)))));
          d_temp_dV_SI_BP = (BCH*((zg*(GC3_i*d_zg_dV_SI_BP))+(d_zg_dV_SI_BP*(GC2_i+(GC3_i*zg)))));
          temp = (BCH*((-1.5)+(zg*(GC2_i+(GC3_i*zg)))));
          if ((temp>0))
          {

            d_TP_dV_SI_BP = ((temp*(0.5*((temp*(d_temp_dV_SI_BP*3.3333333333333333e-01))+(d_temp_dV_SI_BP*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_SI_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            d_TP_dV_DI_SI = ((temp*(0.5*((temp*(d_temp_dV_DI_SI*3.3333333333333333e-01))+(d_temp_dV_DI_SI*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_DI_SI*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            d_TP_dV_GP_SI = ((temp*(0.5*((temp*(d_temp_dV_GP_SI*3.3333333333333333e-01))+(d_temp_dV_GP_SI*(1.0+(temp*3.3333333333333333e-01))))))+(d_temp_dV_GP_SI*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
            TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
          }
          else
          {
            if ((temp>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp(temp);
                double  deriv_exp_0_d0 = value_exp_0;

                d_TP_dV_SI_BP = (deriv_exp_0_d0*(d_temp_dV_SI_BP));
                d_TP_dV_DI_SI = (deriv_exp_0_d0*(d_temp_dV_DI_SI));
                d_TP_dV_GP_SI = (deriv_exp_0_d0*(d_temp_dV_GP_SI));
                TP = value_exp_0;
              }
            }
            else
            {

              d_TP_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_SI_BP)*3.3333333333333333e-01))+((-d_temp_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              d_TP_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_DI_SI)*3.3333333333333333e-01))+((-d_temp_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              d_TP_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_GP_SI)*3.3333333333333333e-01))+((-d_temp_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
              TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            }
          }
          {
            double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
            double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));

            d_Igc0_dV_SI_BP = (IGINV_i*((TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_SI_BP-(1.0+Dsi)*d_Dgate_dV_SI_BP)/(1.0+Dgate)/(1.0+Dgate)))))+(d_TP_dV_SI_BP*value_log_0)));
            d_Igc0_dV_DI_SI = (IGINV_i*((TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_DI_SI-(1.0+Dsi)*d_Dgate_dV_DI_SI)/(1.0+Dgate)/(1.0+Dgate)))))+(d_TP_dV_DI_SI*value_log_0)));
            d_Igc0_dV_GP_SI = (IGINV_i*((TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_GP_SI-(1.0+Dsi)*d_Dgate_dV_GP_SI)/(1.0+Dgate)/(1.0+Dgate)))))+(d_TP_dV_GP_SI*value_log_0)));
            Igc0 = (IGINV_i*(TP*value_log_0));
          }
          if (((xg_dc<=0.0)||((GC2_i==0.0)&&(GC3_i==0.0))))
          {

            d_igc_dV_DI_SI = d_igc_dV_GP_SI = d_igc_dV_SI_BP =  0.0;
            igc = 1.0;

            d_igcd_h_dV_DI_SI = d_igcd_h_dV_GP_SI = d_igcd_h_dV_SI_BP =  0.0;
            igcd_h = 0.5;
          }
          else
          {

            d_temp_dV_GP_SI = ((2.0*GC3_i)*d_zg_dV_GP_SI);
            d_temp_dV_DI_SI = ((2.0*GC3_i)*d_zg_dV_DI_SI);
            d_temp_dV_SI_BP = ((2.0*GC3_i)*d_zg_dV_SI_BP);
            temp = (GC2_i+((2.0*GC3_i)*zg));

            d_u0_dV_SI_BP = (-CHIB_i*(d_temp_dV_SI_BP*BCH)/(temp*BCH)/(temp*BCH));
            d_u0_dV_DI_SI = (-CHIB_i*(d_temp_dV_DI_SI*BCH)/(temp*BCH)/(temp*BCH));
            d_u0_dV_GP_SI = (-CHIB_i*(d_temp_dV_GP_SI*BCH)/(temp*BCH)/(temp*BCH));
            u0 = (CHIB_i/(temp*BCH));

            d_x_dV_SI_BP = (0.5*((u0*d_dps_dc_dV_SI_BP-dps_dc*d_u0_dV_SI_BP)/u0/u0));
            d_x_dV_GP_SI = (0.5*((u0*d_dps_dc_dV_GP_SI-dps_dc*d_u0_dV_GP_SI)/u0/u0));
            d_x_dV_DI_SI = (0.5*((u0*d_dps_dc_dV_DI_SI-dps_dc*d_u0_dV_DI_SI)/u0/u0));
            x = (0.5*(dps_dc/u0));

            d_u0_div_H_dV_SI_BP = ((H_dc*d_u0_dV_SI_BP-u0*d_H_dc_dV_SI_BP)/H_dc/H_dc);
            d_u0_div_H_dV_DI_SI = ((H_dc*d_u0_dV_DI_SI-u0*d_H_dc_dV_DI_SI)/H_dc/H_dc);
            d_u0_div_H_dV_GP_SI = ((H_dc*d_u0_dV_GP_SI-u0*d_H_dc_dV_GP_SI)/H_dc/H_dc);
            u0_div_H = (u0/H_dc);

            d_Bg_dV_SI_BP = (((u0_div_H*(-d_u0_div_H_dV_SI_BP))+(d_u0_div_H_dV_SI_BP*(1.0-u0_div_H)))*0.5);
            d_Bg_dV_DI_SI = (((u0_div_H*(-d_u0_div_H_dV_DI_SI))+(d_u0_div_H_dV_DI_SI*(1.0-u0_div_H)))*0.5);
            d_Bg_dV_GP_SI = (((u0_div_H*(-d_u0_div_H_dV_GP_SI))+(d_u0_div_H_dV_GP_SI*(1.0-u0_div_H)))*0.5);
            Bg = ((u0_div_H*(1.0-u0_div_H))*0.5);

            d_Ag_dV_SI_BP = (-(3.0*d_Bg_dV_SI_BP));
            d_Ag_dV_DI_SI = (-(3.0*d_Bg_dV_DI_SI));
            d_Ag_dV_GP_SI = (-(3.0*d_Bg_dV_GP_SI));
            Ag = (0.5-(3.0*Bg));
            if ((x<1.0e-3))
            {

              d_xsq_dV_SI_BP = ((x*d_x_dV_SI_BP)+(d_x_dV_SI_BP*x));
              d_xsq_dV_GP_SI = ((x*d_x_dV_GP_SI)+(d_x_dV_GP_SI*x));
              d_xsq_dV_DI_SI = ((x*d_x_dV_DI_SI)+(d_x_dV_DI_SI*x));
              xsq = (x*x);

              d_igc_dV_SI_BP = ((xsq*((d_u0_div_H_dV_SI_BP*3.3333333333333333e-01)+(1.6666666666666667e-01*((xsq*(0.2*d_u0_div_H_dV_SI_BP))+(d_xsq_dV_SI_BP*(0.05+(0.2*u0_div_H)))))))+(d_xsq_dV_SI_BP*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));
              d_igc_dV_GP_SI = ((xsq*((d_u0_div_H_dV_GP_SI*3.3333333333333333e-01)+(1.6666666666666667e-01*((xsq*(0.2*d_u0_div_H_dV_GP_SI))+(d_xsq_dV_GP_SI*(0.05+(0.2*u0_div_H)))))))+(d_xsq_dV_GP_SI*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));
              d_igc_dV_DI_SI = ((xsq*((d_u0_div_H_dV_DI_SI*3.3333333333333333e-01)+(1.6666666666666667e-01*((xsq*(0.2*d_u0_div_H_dV_DI_SI))+(d_xsq_dV_DI_SI*(0.05+(0.2*u0_div_H)))))))+(d_xsq_dV_DI_SI*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));
              igc = (1.0+(xsq*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));

              d_igcd_h_dV_SI_BP = ((0.5*d_igc_dV_SI_BP)-(1.6666666666666667e-01*((x*((xsq*((0.4*d_Bg_dV_SI_BP)+(0.0285714285714*((xsq*d_Bg_dV_SI_BP)+(d_xsq_dV_SI_BP*(0.125+Bg))))))+(d_xsq_dV_SI_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(d_x_dV_SI_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))))));
              d_igcd_h_dV_GP_SI = ((0.5*d_igc_dV_GP_SI)-(1.6666666666666667e-01*((x*((xsq*((0.4*d_Bg_dV_GP_SI)+(0.0285714285714*((xsq*d_Bg_dV_GP_SI)+(d_xsq_dV_GP_SI*(0.125+Bg))))))+(d_xsq_dV_GP_SI*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(d_x_dV_GP_SI*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))))));
              d_igcd_h_dV_DI_SI = ((0.5*d_igc_dV_DI_SI)-(1.6666666666666667e-01*((x*((xsq*((0.4*d_Bg_dV_DI_SI)+(0.0285714285714*((xsq*d_Bg_dV_DI_SI)+(d_xsq_dV_DI_SI*(0.125+Bg))))))+(d_xsq_dV_DI_SI*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(d_x_dV_DI_SI*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))))));
              igcd_h = ((0.5*igc)-(1.6666666666666667e-01*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))));
            }
            else
            {

              d_inv_x_dV_SI_BP = (-d_x_dV_SI_BP/x/x);
              d_inv_x_dV_GP_SI = (-d_x_dV_GP_SI/x/x);
              d_inv_x_dV_DI_SI = (-d_x_dV_DI_SI/x/x);
              inv_x = (1.0/x);
              if ((fabs(x)<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(x);
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_ex_dV_SI_BP = (deriv_exp_0_d0*(d_x_dV_SI_BP));
                  d_ex_dV_GP_SI = (deriv_exp_0_d0*(d_x_dV_GP_SI));
                  d_ex_dV_DI_SI = (deriv_exp_0_d0*(d_x_dV_DI_SI));
                  ex = value_exp_0;
                }
              }
              else
              {
                if ((x<0.0))
                {

                  d_ex_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-x)*(0.5*((((-2.3025850929940458e+02)-x)*((-d_x_dV_SI_BP)*3.3333333333333333e-01))+((-d_x_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+((-d_x_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
                  d_ex_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-x)*(0.5*((((-2.3025850929940458e+02)-x)*((-d_x_dV_GP_SI)*3.3333333333333333e-01))+((-d_x_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+((-d_x_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
                  d_ex_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-x)*(0.5*((((-2.3025850929940458e+02)-x)*((-d_x_dV_DI_SI)*3.3333333333333333e-01))+((-d_x_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+((-d_x_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
                  ex = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_ex_dV_SI_BP = (1.0e100*(((x-2.3025850929940458e+02)*(0.5*(((x-2.3025850929940458e+02)*(d_x_dV_SI_BP*3.3333333333333333e-01))+(d_x_dV_SI_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_dV_SI_BP*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_ex_dV_GP_SI = (1.0e100*(((x-2.3025850929940458e+02)*(0.5*(((x-2.3025850929940458e+02)*(d_x_dV_GP_SI*3.3333333333333333e-01))+(d_x_dV_GP_SI*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_dV_GP_SI*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_ex_dV_DI_SI = (1.0e100*(((x-2.3025850929940458e+02)*(0.5*(((x-2.3025850929940458e+02)*(d_x_dV_DI_SI*3.3333333333333333e-01))+(d_x_dV_DI_SI*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_dV_DI_SI*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  ex = (1.0e100*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_inv_ex_dV_SI_BP = (-d_ex_dV_SI_BP/ex/ex);
              d_inv_ex_dV_GP_SI = (-d_ex_dV_GP_SI/ex/ex);
              d_inv_ex_dV_DI_SI = (-d_ex_dV_DI_SI/ex/ex);
              inv_ex = (1.0/ex);

              d_temp_dV_SI_BP = (d_ex_dV_SI_BP-d_inv_ex_dV_SI_BP);
              d_temp_dV_GP_SI = (d_ex_dV_GP_SI-d_inv_ex_dV_GP_SI);
              d_temp_dV_DI_SI = (d_ex_dV_DI_SI-d_inv_ex_dV_DI_SI);
              temp = (ex-inv_ex);

              d_temp2_dV_SI_BP = (d_ex_dV_SI_BP+d_inv_ex_dV_SI_BP);
              d_temp2_dV_GP_SI = (d_ex_dV_GP_SI+d_inv_ex_dV_GP_SI);
              d_temp2_dV_DI_SI = (d_ex_dV_DI_SI+d_inv_ex_dV_DI_SI);
              temp2 = (ex+inv_ex);

              d_igc_dV_SI_BP = (0.5*(((((1.0-u0_div_H)*temp)*d_inv_x_dV_SI_BP)+((((1.0-u0_div_H)*d_temp_dV_SI_BP)+((-d_u0_div_H_dV_SI_BP)*temp))*inv_x))+((u0_div_H*d_temp2_dV_SI_BP)+(d_u0_div_H_dV_SI_BP*temp2))));
              d_igc_dV_DI_SI = (0.5*(((((1.0-u0_div_H)*temp)*d_inv_x_dV_DI_SI)+((((1.0-u0_div_H)*d_temp_dV_DI_SI)+((-d_u0_div_H_dV_DI_SI)*temp))*inv_x))+((u0_div_H*d_temp2_dV_DI_SI)+(d_u0_div_H_dV_DI_SI*temp2))));
              d_igc_dV_GP_SI = (0.5*(((((1.0-u0_div_H)*temp)*d_inv_x_dV_GP_SI)+((((1.0-u0_div_H)*d_temp_dV_GP_SI)+((-d_u0_div_H_dV_GP_SI)*temp))*inv_x))+((u0_div_H*d_temp2_dV_GP_SI)+(d_u0_div_H_dV_GP_SI*temp2))));
              igc = (0.5*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2)));

              d_igcd_h_dV_SI_BP = (0.5*((d_igc_dV_SI_BP-((temp*(d_Bg_dV_SI_BP-(((Ag*inv_x)*d_inv_x_dV_SI_BP)+(((Ag*d_inv_x_dV_SI_BP)+(d_Ag_dV_SI_BP*inv_x))*inv_x))))+(d_temp_dV_SI_BP*(Bg-((Ag*inv_x)*inv_x)))))-(((Ag*temp2)*d_inv_x_dV_SI_BP)+(((Ag*d_temp2_dV_SI_BP)+(d_Ag_dV_SI_BP*temp2))*inv_x))));
              d_igcd_h_dV_GP_SI = (0.5*((d_igc_dV_GP_SI-((temp*(d_Bg_dV_GP_SI-(((Ag*inv_x)*d_inv_x_dV_GP_SI)+(((Ag*d_inv_x_dV_GP_SI)+(d_Ag_dV_GP_SI*inv_x))*inv_x))))+(d_temp_dV_GP_SI*(Bg-((Ag*inv_x)*inv_x)))))-(((Ag*temp2)*d_inv_x_dV_GP_SI)+(((Ag*d_temp2_dV_GP_SI)+(d_Ag_dV_GP_SI*temp2))*inv_x))));
              d_igcd_h_dV_DI_SI = (0.5*((d_igc_dV_DI_SI-((temp*(d_Bg_dV_DI_SI-(((Ag*inv_x)*d_inv_x_dV_DI_SI)+(((Ag*d_inv_x_dV_DI_SI)+(d_Ag_dV_DI_SI*inv_x))*inv_x))))+(d_temp_dV_DI_SI*(Bg-((Ag*inv_x)*inv_x)))))-(((Ag*temp2)*d_inv_x_dV_DI_SI)+(((Ag*d_temp2_dV_DI_SI)+(d_Ag_dV_DI_SI*temp2))*inv_x))));
              igcd_h = (0.5*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x)));
            }
          }
          {
            double value_sqrt_0 = sqrt(((xg_dc*xg_dc)+1.0e-6));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Sg_dV_SI_BP = (0.5*((value_sqrt_0*d_xg_dc_dV_SI_BP-xg_dc*(deriv_sqrt_0_d0*(((xg_dc*d_xg_dc_dV_SI_BP)+(d_xg_dc_dV_SI_BP*xg_dc)))))/value_sqrt_0/value_sqrt_0));
            d_Sg_dV_GP_SI = (0.5*((value_sqrt_0*d_xg_dc_dV_GP_SI-xg_dc*(deriv_sqrt_0_d0*(((xg_dc*d_xg_dc_dV_GP_SI)+(d_xg_dc_dV_GP_SI*xg_dc)))))/value_sqrt_0/value_sqrt_0));
            d_Sg_dV_DI_SI = (0.5*((value_sqrt_0*d_xg_dc_dV_DI_SI-xg_dc*(deriv_sqrt_0_d0*(((xg_dc*d_xg_dc_dV_DI_SI)+(d_xg_dc_dV_DI_SI*xg_dc)))))/value_sqrt_0/value_sqrt_0));
            Sg = (0.5*(1.0+(xg_dc/value_sqrt_0)));
          }

          d_Igc_dV_SI_BP = (((Igc0*igc)*d_Sg_dV_SI_BP)+(((Igc0*d_igc_dV_SI_BP)+(d_Igc0_dV_SI_BP*igc))*Sg));
          d_Igc_dV_DI_SI = (((Igc0*igc)*d_Sg_dV_DI_SI)+(((Igc0*d_igc_dV_DI_SI)+(d_Igc0_dV_DI_SI*igc))*Sg));
          d_Igc_dV_GP_SI = (((Igc0*igc)*d_Sg_dV_GP_SI)+(((Igc0*d_igc_dV_GP_SI)+(d_Igc0_dV_GP_SI*igc))*Sg));
          Igc = ((Igc0*igc)*Sg);

          d_Igcd_dV_SI_BP = (((Igc0*igcd_h)*d_Sg_dV_SI_BP)+(((Igc0*d_igcd_h_dV_SI_BP)+(d_Igc0_dV_SI_BP*igcd_h))*Sg));
          d_Igcd_dV_DI_SI = (((Igc0*igcd_h)*d_Sg_dV_DI_SI)+(((Igc0*d_igcd_h_dV_DI_SI)+(d_Igc0_dV_DI_SI*igcd_h))*Sg));
          d_Igcd_dV_GP_SI = (((Igc0*igcd_h)*d_Sg_dV_GP_SI)+(((Igc0*d_igcd_h_dV_GP_SI)+(d_Igc0_dV_GP_SI*igcd_h))*Sg));
          Igcd = ((Igc0*igcd_h)*Sg);

          d_Igcs_dV_SI_BP = (d_Igc_dV_SI_BP-d_Igcd_dV_SI_BP);
          d_Igcs_dV_DI_SI = (d_Igc_dV_DI_SI-d_Igcd_dV_DI_SI);
          d_Igcs_dV_GP_SI = (d_Igc_dV_GP_SI-d_Igcd_dV_GP_SI);
          Igcs = (Igc-Igcd);

          d_Igb_dV_SI_BP = (((Igc0*igc)*(-d_Sg_dV_SI_BP))+(((Igc0*d_igc_dV_SI_BP)+(d_Igc0_dV_SI_BP*igc))*(1.0-Sg)));
          d_Igb_dV_DI_SI = (((Igc0*igc)*(-d_Sg_dV_DI_SI))+(((Igc0*d_igc_dV_DI_SI)+(d_Igc0_dV_DI_SI*igc))*(1.0-Sg)));
          d_Igb_dV_GP_SI = (((Igc0*igc)*(-d_Sg_dV_GP_SI))+(((Igc0*d_igc_dV_GP_SI)+(d_Igc0_dV_GP_SI*igc))*(1.0-Sg)));
          Igb = ((Igc0*igc)*(1.0-Sg));
        }
      }

      d_Igidl_dV_DI_SI = d_Igidl_dV_SI_BP = d_Igidl_dV_GP_SI =  0.0;
      Igidl = 0.0;

      d_Igisl_dV_SI_BP = d_Igisl_dV_GP_SI = d_Igisl_dV_DI_SI =  0.0;
      Igisl = 0.0;
      if (((model_.SWGIDL_i)!=0))
      {
        if (((AGIDLD_i>0)&&(Vovd<0)))
        {
          {
            double value_sqrt_0 = sqrt((((Vovd*Vovd)+((CGIDLD_i*CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Vtovd_dV_SI_BP = (deriv_sqrt_0_d0*(((CGIDLD_i*CGIDLD_i)*((VdbPrime*d_VdbPrime_dV_SI_BP)+(d_VdbPrime_dV_SI_BP*VdbPrime)))));
            d_Vtovd_dV_DI_SI = (deriv_sqrt_0_d0*((((Vovd*d_Vovd_dV_DI_SI)+(d_Vovd_dV_DI_SI*Vovd))+((CGIDLD_i*CGIDLD_i)*((VdbPrime*d_VdbPrime_dV_DI_SI)+(d_VdbPrime_dV_DI_SI*VdbPrime))))));
            d_Vtovd_dV_GP_SI = (deriv_sqrt_0_d0*(((Vovd*d_Vovd_dV_GP_SI)+(d_Vovd_dV_GP_SI*Vovd))));
            Vtovd = value_sqrt_0;
          }

          d_temp_dV_SI_BP = (-(-BGIDLDs)*d_Vtovd_dV_SI_BP/Vtovd/Vtovd);
          d_temp_dV_DI_SI = (-(-BGIDLDs)*d_Vtovd_dV_DI_SI/Vtovd/Vtovd);
          d_temp_dV_GP_SI = (-(-BGIDLDs)*d_Vtovd_dV_GP_SI/Vtovd/Vtovd);
          temp = ((-BGIDLDs)/Vtovd);
          if ((temp>(-2.3025850929940458e+02)))
          {
            {
              double value_exp_0 = exp(temp);
              double  deriv_exp_0_d0 = value_exp_0;

              d_temp2_dV_SI_BP = (deriv_exp_0_d0*(d_temp_dV_SI_BP));
              d_temp2_dV_DI_SI = (deriv_exp_0_d0*(d_temp_dV_DI_SI));
              d_temp2_dV_GP_SI = (deriv_exp_0_d0*(d_temp_dV_GP_SI));
              temp2 = value_exp_0;
            }
          }
          else
          {

            d_temp2_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_SI_BP)*3.3333333333333333e-01))+((-d_temp_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            d_temp2_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_DI_SI)*3.3333333333333333e-01))+((-d_temp_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            d_temp2_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_GP_SI)*3.3333333333333333e-01))+((-d_temp_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
          }

          d_Igidl_dV_GP_SI = ((-AGIDLDs)*((((VdbPrime*Vovd)*Vtovd)*d_temp2_dV_GP_SI)+((((VdbPrime*Vovd)*d_Vtovd_dV_GP_SI)+((VdbPrime*d_Vovd_dV_GP_SI)*Vtovd))*temp2)));
          d_Igidl_dV_SI_BP = ((-AGIDLDs)*((((VdbPrime*Vovd)*Vtovd)*d_temp2_dV_SI_BP)+((((VdbPrime*Vovd)*d_Vtovd_dV_SI_BP)+((d_VdbPrime_dV_SI_BP*Vovd)*Vtovd))*temp2)));
          d_Igidl_dV_DI_SI = ((-AGIDLDs)*((((VdbPrime*Vovd)*Vtovd)*d_temp2_dV_DI_SI)+((((VdbPrime*Vovd)*d_Vtovd_dV_DI_SI)+(((VdbPrime*d_Vovd_dV_DI_SI)+(d_VdbPrime_dV_DI_SI*Vovd))*Vtovd))*temp2)));
          Igidl = ((-AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*temp2));
        }
        if (((AGIDL_i>0)&&(Vovs<0)))
        {
          {
            double value_sqrt_0 = sqrt((((Vovs*Vovs)+((CGIDL_i*CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Vtovs_dV_SI_BP = (deriv_sqrt_0_d0*(((CGIDL_i*CGIDL_i)*((VsbPrime*d_VsbPrime_dV_SI_BP)+(d_VsbPrime_dV_SI_BP*VsbPrime)))));
            d_Vtovs_dV_GP_SI = (deriv_sqrt_0_d0*(((Vovs*d_Vovs_dV_GP_SI)+(d_Vovs_dV_GP_SI*Vovs))));
            Vtovs = value_sqrt_0;
          }

          d_temp_dV_DI_SI =  0.0;
          d_temp_dV_SI_BP = (-(-BGIDLs)*d_Vtovs_dV_SI_BP/Vtovs/Vtovs);
          d_temp_dV_GP_SI = (-(-BGIDLs)*d_Vtovs_dV_GP_SI/Vtovs/Vtovs);
          temp = ((-BGIDLs)/Vtovs);
          if ((temp>(-2.3025850929940458e+02)))
          {
            {
              double value_exp_0 = exp(temp);
              double  deriv_exp_0_d0 = value_exp_0;

              d_temp2_dV_SI_BP = (deriv_exp_0_d0*(d_temp_dV_SI_BP));
              d_temp2_dV_DI_SI = (deriv_exp_0_d0*(d_temp_dV_DI_SI));
              d_temp2_dV_GP_SI = (deriv_exp_0_d0*(d_temp_dV_GP_SI));
              temp2 = value_exp_0;
            }
          }
          else
          {

            d_temp2_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_SI_BP)*3.3333333333333333e-01))+((-d_temp_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            d_temp2_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_DI_SI)*3.3333333333333333e-01))+((-d_temp_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            d_temp2_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-temp)*(0.5*((((-2.3025850929940458e+02)-temp)*((-d_temp_dV_GP_SI)*3.3333333333333333e-01))+((-d_temp_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+((-d_temp_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
          }

          d_Igisl_dV_DI_SI = ((-AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*d_temp2_dV_DI_SI));
          d_Igisl_dV_GP_SI = ((-AGIDLs)*((((VsbPrime*Vovs)*Vtovs)*d_temp2_dV_GP_SI)+((((VsbPrime*Vovs)*d_Vtovs_dV_GP_SI)+((VsbPrime*d_Vovs_dV_GP_SI)*Vtovs))*temp2)));
          d_Igisl_dV_SI_BP = ((-AGIDLs)*((((VsbPrime*Vovs)*Vtovs)*d_temp2_dV_SI_BP)+((((VsbPrime*Vovs)*d_Vtovs_dV_SI_BP)+((d_VsbPrime_dV_SI_BP*Vovs)*Vtovs))*temp2)));
          Igisl = ((-AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*temp2));
        }
      }

      d_xgedge_dV_DI_SI = d_xgedge_dV_SI_BP = d_xgedge_dV_GP_SI =  0.0;
      xgedge = 0.0;

      d_qdseffedge_dV_DI_SI = d_qdseffedge_dV_SI_BP = d_qdseffedge_dV_GP_SI =  0.0;
      qdseffedge = 0.0;

      d_qmeffedge_dV_DI_SI = d_qmeffedge_dV_SI_BP = d_qmeffedge_dV_GP_SI =  0.0;
      qmeffedge = 0.0;

      d_dsqredge_dV_DI_SI = d_dsqredge_dV_SI_BP = d_dsqredge_dV_GP_SI =  0.0;
      dsqredge = 1.0e-40;

      d_alphabmedge_dV_DI_SI = d_alphabmedge_dV_SI_BP = d_alphabmedge_dV_GP_SI =  0.0;
      alphabmedge = 1.0;

      d_Idsedge_dV_DI_SI = d_Idsedge_dV_SI_BP = d_Idsedge_dV_GP_SI =  0.0;
      Idsedge = 0.0;
      if ((((model_.SWEDGE_i)!=0.0)&&(BETNEDGE_i>0)))
      {
        {
          double value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+bphiedge));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_temp_dV_GP_SI =  0.0;
          d_temp_dV_SI_BP = (0.5*((d_Vdb_dV_SI_BP+d_Vsb_dV_SI_BP)-(deriv_sqrt_0_d0*((((Vdb-Vsb)*(d_Vdb_dV_SI_BP-d_Vsb_dV_SI_BP))+((d_Vdb_dV_SI_BP-d_Vsb_dV_SI_BP)*(Vdb-Vsb)))))));
          d_temp_dV_DI_SI = (0.5*((d_Vdb_dV_DI_SI+d_Vsb_dV_DI_SI)-(deriv_sqrt_0_d0*((((Vdb-Vsb)*(d_Vdb_dV_DI_SI-d_Vsb_dV_DI_SI))+((d_Vdb_dV_DI_SI-d_Vsb_dV_DI_SI)*(Vdb-Vsb)))))));
          temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+phixedge);
        }
        {
          double value_sqrt_0 = sqrt((((temp)*(temp))+aphiedge));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_Vsbstaredge_dV_GP_SI = (-(0.5*((d_temp_dV_GP_SI)-(deriv_sqrt_0_d0*((((temp)*(d_temp_dV_GP_SI))+((d_temp_dV_GP_SI)*(temp))))))));
          d_Vsbstaredge_dV_SI_BP = (d_Vsb_dV_SI_BP-(0.5*((d_temp_dV_SI_BP)-(deriv_sqrt_0_d0*((((temp)*(d_temp_dV_SI_BP))+((d_temp_dV_SI_BP)*(temp))))))));
          d_Vsbstaredge_dV_DI_SI = (d_Vsb_dV_DI_SI-(0.5*((d_temp_dV_DI_SI)-(deriv_sqrt_0_d0*((((temp)*(d_temp_dV_DI_SI))+((d_temp_dV_DI_SI)*(temp))))))));
          Vsbstaredge = ((Vsb-(0.5*((temp)-value_sqrt_0)))+phix1edge);
        }

        d_Vsbxedge_dV_GP_SI = d_Vsbstaredge_dV_GP_SI;
        d_Vsbxedge_dV_SI_BP = d_Vsbstaredge_dV_SI_BP;
        d_Vsbxedge_dV_DI_SI = (d_Vsbstaredge_dV_DI_SI+(0.5*(d_Vds_dV_DI_SI-d_Vdsx_dV_DI_SI)));
        Vsbxedge = (Vsbstaredge+(0.5*(Vds-Vdsx)));

        d_dphit1edge_dV_GP_SI = ((PSCEEDGE_i*(1+(PSCEDEDGE_i*Vdsx)))*(PSCEBEDGE_i*d_Vsbxedge_dV_GP_SI));
        d_dphit1edge_dV_SI_BP = ((PSCEEDGE_i*(1+(PSCEDEDGE_i*Vdsx)))*(PSCEBEDGE_i*d_Vsbxedge_dV_SI_BP));
        d_dphit1edge_dV_DI_SI = (((PSCEEDGE_i*(1+(PSCEDEDGE_i*Vdsx)))*(PSCEBEDGE_i*d_Vsbxedge_dV_DI_SI))+((PSCEEDGE_i*(PSCEDEDGE_i*d_Vdsx_dV_DI_SI))*(1.0+(PSCEBEDGE_i*Vsbxedge))));
        dphit1edge = ((PSCEEDGE_i*(1+(PSCEDEDGE_i*Vdsx)))*(1.0+(PSCEBEDGE_i*Vsbxedge)));

        d_phit1edge_dV_GP_SI = (phit0edge*d_dphit1edge_dV_GP_SI);
        d_phit1edge_dV_SI_BP = (phit0edge*d_dphit1edge_dV_SI_BP);
        d_phit1edge_dV_DI_SI = (phit0edge*d_dphit1edge_dV_DI_SI);
        phit1edge = (phit0edge*(1.0+dphit1edge));

        d_inv_phit1edge_dV_GP_SI = (-d_phit1edge_dV_GP_SI/phit1edge/phit1edge);
        d_inv_phit1edge_dV_SI_BP = (-d_phit1edge_dV_SI_BP/phit1edge/phit1edge);
        d_inv_phit1edge_dV_DI_SI = (-d_phit1edge_dV_DI_SI/phit1edge/phit1edge);
        inv_phit1edge = (1.0/phit1edge);
        if ((CFDEDGE_i<0.05))
        {

          d_Vdspedge_dV_DI_SI = d_Vdsx_dV_DI_SI;
          Vdspedge = Vdsx;
        }
        else
        {
          {
            double value_sqrt_0 = sqrt((1.0+(CFDEDGE_i*Vdsx)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Vdspedge_dV_DI_SI = ((2.0*(deriv_sqrt_0_d0*((CFDEDGE_i*d_Vdsx_dV_DI_SI))))/CFDEDGE_i);
            Vdspedge = ((2.0*(value_sqrt_0-1.0))/CFDEDGE_i);
          }
        }

        d_delVgedge_dV_GP_SI = ((CFEDGE_i*Vdspedge)*(CFBEDGE_i*d_Vsbxedge_dV_GP_SI));
        d_delVgedge_dV_SI_BP = ((CFEDGE_i*Vdspedge)*(CFBEDGE_i*d_Vsbxedge_dV_SI_BP));
        d_delVgedge_dV_DI_SI = (((CFEDGE_i*Vdspedge)*(CFBEDGE_i*d_Vsbxedge_dV_DI_SI))+((CFEDGE_i*d_Vdspedge_dV_DI_SI)*(1+(CFBEDGE_i*Vsbxedge))));
        delVgedge = ((CFEDGE_i*Vdspedge)*(1+(CFBEDGE_i*Vsbxedge)));

        d_xgedge_dV_GP_SI = ((inv_phit1edge*((d_Vgs_dV_GP_SI+d_Vsbstaredge_dV_GP_SI)+d_delVgedge_dV_GP_SI))+(d_inv_phit1edge_dV_GP_SI*(((Vgs+Vsbstaredge)+delVgedge)-VFBEDGE_T)));
        d_xgedge_dV_SI_BP = ((inv_phit1edge*(d_Vsbstaredge_dV_SI_BP+d_delVgedge_dV_SI_BP))+(d_inv_phit1edge_dV_SI_BP*(((Vgs+Vsbstaredge)+delVgedge)-VFBEDGE_T)));
        d_xgedge_dV_DI_SI = ((inv_phit1edge*((d_Vgs_dV_DI_SI+d_Vsbstaredge_dV_DI_SI)+d_delVgedge_dV_DI_SI))+(d_inv_phit1edge_dV_DI_SI*(((Vgs+Vsbstaredge)+delVgedge)-VFBEDGE_T)));
        xgedge = (inv_phit1edge*(((Vgs+Vsbstaredge)+delVgedge)-VFBEDGE_T));

        d_xbedge_dV_GP_SI = (d_inv_phit1edge_dV_GP_SI*phibedge);
        d_xbedge_dV_SI_BP = (d_inv_phit1edge_dV_SI_BP*phibedge);
        d_xbedge_dV_DI_SI = (d_inv_phit1edge_dV_DI_SI*phibedge);
        xbedge = (inv_phit1edge*phibedge);
        {
          double value_sqrt_0 = sqrt(xbedge);
          double value_log_1 = log(((xbedge/Gfedge)+value_sqrt_0));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
          double  deriv_log_1_d0 = (1.0/((xbedge/Gfedge)+value_sqrt_0));

          d_dxthedge_dV_GP_SI = (2.0*(deriv_log_1_d0*(((d_xbedge_dV_GP_SI/Gfedge)+(deriv_sqrt_0_d0*(d_xbedge_dV_GP_SI))))));
          d_dxthedge_dV_SI_BP = (2.0*(deriv_log_1_d0*(((d_xbedge_dV_SI_BP/Gfedge)+(deriv_sqrt_0_d0*(d_xbedge_dV_SI_BP))))));
          d_dxthedge_dV_DI_SI = (2.0*(deriv_log_1_d0*(((d_xbedge_dV_DI_SI/Gfedge)+(deriv_sqrt_0_d0*(d_xbedge_dV_DI_SI))))));
          dxthedge = (2.0*value_log_1);
        }

        d_xnedge_s_dV_GP_SI = ((inv_phit1edge*d_Vsbstaredge_dV_GP_SI)+(d_inv_phit1edge_dV_GP_SI*Vsbstaredge));
        d_xnedge_s_dV_SI_BP = ((inv_phit1edge*d_Vsbstaredge_dV_SI_BP)+(d_inv_phit1edge_dV_SI_BP*Vsbstaredge));
        d_xnedge_s_dV_DI_SI = ((inv_phit1edge*d_Vsbstaredge_dV_DI_SI)+(d_inv_phit1edge_dV_DI_SI*Vsbstaredge));
        xnedge_s = (inv_phit1edge*Vsbstaredge);

        d_Q_EDGE_xsth_dV_GP_SI = (d_xbedge_dV_GP_SI+d_xnedge_s_dV_GP_SI);
        d_Q_EDGE_xsth_dV_SI_BP = (d_xbedge_dV_SI_BP+d_xnedge_s_dV_SI_BP);
        d_Q_EDGE_xsth_dV_DI_SI = (d_xbedge_dV_DI_SI+d_xnedge_s_dV_DI_SI);
        Q_EDGE_xsth = (xbedge+xnedge_s);
        {
          double value_sqrt_0 = sqrt(Q_EDGE_xsth);
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_Q_EDGE_xth0_dV_GP_SI = (d_Q_EDGE_xsth_dV_GP_SI+(Gfedge*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_GP_SI))));
          d_Q_EDGE_xth0_dV_SI_BP = (d_Q_EDGE_xsth_dV_SI_BP+(Gfedge*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_SI_BP))));
          d_Q_EDGE_xth0_dV_DI_SI = (d_Q_EDGE_xsth_dV_DI_SI+(Gfedge*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_DI_SI))));
          Q_EDGE_xth0 = (Q_EDGE_xsth+(Gfedge*value_sqrt_0));
        }

        d_Q_EDGE_xth_dV_GP_SI = (d_Q_EDGE_xth0_dV_GP_SI+d_dxthedge_dV_GP_SI);
        d_Q_EDGE_xth_dV_SI_BP = (d_Q_EDGE_xth0_dV_SI_BP+d_dxthedge_dV_SI_BP);
        d_Q_EDGE_xth_dV_DI_SI = (d_Q_EDGE_xth0_dV_DI_SI+d_dxthedge_dV_DI_SI);
        Q_EDGE_xth = (Q_EDGE_xth0+dxthedge);
        {
          double value_sqrt_0 = sqrt(Q_EDGE_xsth);
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_Q_EDGE_n_dV_GP_SI = (-Gfedge*(2.0*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_GP_SI)))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
          d_Q_EDGE_n_dV_SI_BP = (-Gfedge*(2.0*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_SI_BP)))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
          d_Q_EDGE_n_dV_DI_SI = (-Gfedge*(2.0*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_DI_SI)))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
          Q_EDGE_n = (1.0+(Gfedge/(2.0*value_sqrt_0)));
        }

        d_Q_EDGE_n_inv_dV_GP_SI = (-d_Q_EDGE_n_dV_GP_SI/Q_EDGE_n/Q_EDGE_n);
        d_Q_EDGE_n_inv_dV_SI_BP = (-d_Q_EDGE_n_dV_SI_BP/Q_EDGE_n/Q_EDGE_n);
        d_Q_EDGE_n_inv_dV_DI_SI = (-d_Q_EDGE_n_dV_DI_SI/Q_EDGE_n/Q_EDGE_n);
        Q_EDGE_n_inv = (1.0/Q_EDGE_n);

        d_Q_EDGE_xgt_dV_GP_SI = (d_xgedge_dV_GP_SI-d_Q_EDGE_xth_dV_GP_SI);
        d_Q_EDGE_xgt_dV_SI_BP = (d_xgedge_dV_SI_BP-d_Q_EDGE_xth_dV_SI_BP);
        d_Q_EDGE_xgt_dV_DI_SI = (d_xgedge_dV_DI_SI-d_Q_EDGE_xth_dV_DI_SI);
        Q_EDGE_xgt = (xgedge-Q_EDGE_xth);
        if ((Q_EDGE_xgt>(-12.0)))
        {

          d_Q_EDGE_xgt0_dV_GP_SI = d_Q_EDGE_xgt_dV_GP_SI;
          d_Q_EDGE_xgt0_dV_SI_BP = d_Q_EDGE_xgt_dV_SI_BP;
          d_Q_EDGE_xgt0_dV_DI_SI = d_Q_EDGE_xgt_dV_DI_SI;
          Q_EDGE_xgt0 = ((Q_EDGE_xgt+lnGfedge2)-1.0);
          {
            double value_sqrt_0 = sqrt(((Q_EDGE_xgt0*Q_EDGE_xgt0)+10.0));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Q_EDGE_xgt0e_dV_GP_SI = (0.5*(d_Q_EDGE_xgt0_dV_GP_SI+(deriv_sqrt_0_d0*(((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dV_GP_SI)+(d_Q_EDGE_xgt0_dV_GP_SI*Q_EDGE_xgt0))))));
            d_Q_EDGE_xgt0e_dV_SI_BP = (0.5*(d_Q_EDGE_xgt0_dV_SI_BP+(deriv_sqrt_0_d0*(((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dV_SI_BP)+(d_Q_EDGE_xgt0_dV_SI_BP*Q_EDGE_xgt0))))));
            d_Q_EDGE_xgt0e_dV_DI_SI = (0.5*(d_Q_EDGE_xgt0_dV_DI_SI+(deriv_sqrt_0_d0*(((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dV_DI_SI)+(d_Q_EDGE_xgt0_dV_DI_SI*Q_EDGE_xgt0))))));
            Q_EDGE_xgt0e = (0.5*(Q_EDGE_xgt0+value_sqrt_0));
          }
          {
            double value_log_0 = log(Q_EDGE_xgt0e);
            double  deriv_log_0_d0 = (1.0/Q_EDGE_xgt0e);

            d_Q_EDGE_qi0si_dV_GP_SI = (d_Q_EDGE_xgt_dV_GP_SI-((Q_EDGE_n*(deriv_log_0_d0*(d_Q_EDGE_xgt0e_dV_GP_SI)))+(d_Q_EDGE_n_dV_GP_SI*value_log_0)));
            d_Q_EDGE_qi0si_dV_SI_BP = (d_Q_EDGE_xgt_dV_SI_BP-((Q_EDGE_n*(deriv_log_0_d0*(d_Q_EDGE_xgt0e_dV_SI_BP)))+(d_Q_EDGE_n_dV_SI_BP*value_log_0)));
            d_Q_EDGE_qi0si_dV_DI_SI = (d_Q_EDGE_xgt_dV_DI_SI-((Q_EDGE_n*(deriv_log_0_d0*(d_Q_EDGE_xgt0e_dV_DI_SI)))+(d_Q_EDGE_n_dV_DI_SI*value_log_0)));
            Q_EDGE_qi0si = ((Q_EDGE_xgt-(Q_EDGE_n*value_log_0))+lnGfedge2);
          }
          {
            double value_sqrt_0 = sqrt(((Q_EDGE_qi0si*Q_EDGE_qi0si)+2.0));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Q_EDGE_qi0_dV_GP_SI = (0.5*(d_Q_EDGE_qi0si_dV_GP_SI+(deriv_sqrt_0_d0*(((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dV_GP_SI)+(d_Q_EDGE_qi0si_dV_GP_SI*Q_EDGE_qi0si))))));
            d_Q_EDGE_qi0_dV_SI_BP = (0.5*(d_Q_EDGE_qi0si_dV_SI_BP+(deriv_sqrt_0_d0*(((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dV_SI_BP)+(d_Q_EDGE_qi0si_dV_SI_BP*Q_EDGE_qi0si))))));
            d_Q_EDGE_qi0_dV_DI_SI = (0.5*(d_Q_EDGE_qi0si_dV_DI_SI+(deriv_sqrt_0_d0*(((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dV_DI_SI)+(d_Q_EDGE_qi0si_dV_DI_SI*Q_EDGE_qi0si))))));
            Q_EDGE_qi0 = (0.5*(Q_EDGE_qi0si+value_sqrt_0));
          }
          if (((Q_EDGE_xgt-Q_EDGE_qi0)<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp((Q_EDGE_xgt-Q_EDGE_qi0));
              double  deriv_exp_0_d0 = value_exp_0;

              d_Q_EDGE_exp_x_dV_GP_SI = (deriv_exp_0_d0*((d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)));
              d_Q_EDGE_exp_x_dV_SI_BP = (deriv_exp_0_d0*((d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)));
              d_Q_EDGE_exp_x_dV_DI_SI = (deriv_exp_0_d0*((d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)));
              Q_EDGE_exp_x = value_exp_0;
            }
          }
          else
          {

            d_Q_EDGE_exp_x_dV_GP_SI = (1.0e100*((((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(0.5*((((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*((d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)*3.3333333333333333e-01))+((d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            d_Q_EDGE_exp_x_dV_SI_BP = (1.0e100*((((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(0.5*((((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*((d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)*3.3333333333333333e-01))+((d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            d_Q_EDGE_exp_x_dV_DI_SI = (1.0e100*((((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(0.5*((((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*((d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)*3.3333333333333333e-01))+((d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            Q_EDGE_exp_x = (1.0e100*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
          }

          d_Q_EDGE_d0_dV_GP_SI = (Gfedge2*d_Q_EDGE_exp_x_dV_GP_SI);
          d_Q_EDGE_d0_dV_SI_BP = (Gfedge2*d_Q_EDGE_exp_x_dV_SI_BP);
          d_Q_EDGE_d0_dV_DI_SI = (Gfedge2*d_Q_EDGE_exp_x_dV_DI_SI);
          Q_EDGE_d0 = (Gfedge2*Q_EDGE_exp_x);
          {
            double value_pow_0 = pow(Q_EDGE_d0,Q_EDGE_n_inv);
            double  deriv_pow_0_d0 = ((Q_EDGE_d0 == 0.0)?0.0:(value_pow_0*Q_EDGE_n_inv/Q_EDGE_d0));
            double  deriv_pow_0_d1 = (Q_EDGE_d0 == 0.0)?0.0:(log(Q_EDGE_d0)*value_pow_0);

            d_Q_EDGE_d0p_dV_GP_SI = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dV_GP_SI))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dV_GP_SI)));
            d_Q_EDGE_d0p_dV_SI_BP = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dV_SI_BP))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dV_SI_BP)));
            d_Q_EDGE_d0p_dV_DI_SI = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dV_DI_SI))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dV_DI_SI)));
            Q_EDGE_d0p = value_pow_0;
          }

          d_Q_EDGE_sqerr_dV_GP_SI = (((Q_EDGE_n*d_Q_EDGE_n_dV_GP_SI)+(d_Q_EDGE_n_dV_GP_SI*Q_EDGE_n))+((((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dV_GP_SI)+(((2.0*(d_Q_EDGE_qi0_dV_GP_SI+d_Q_EDGE_n_dV_GP_SI))-d_Q_EDGE_d0p_dV_GP_SI)*Q_EDGE_d0p)));
          d_Q_EDGE_sqerr_dV_SI_BP = (((Q_EDGE_n*d_Q_EDGE_n_dV_SI_BP)+(d_Q_EDGE_n_dV_SI_BP*Q_EDGE_n))+((((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dV_SI_BP)+(((2.0*(d_Q_EDGE_qi0_dV_SI_BP+d_Q_EDGE_n_dV_SI_BP))-d_Q_EDGE_d0p_dV_SI_BP)*Q_EDGE_d0p)));
          d_Q_EDGE_sqerr_dV_DI_SI = (((Q_EDGE_n*d_Q_EDGE_n_dV_DI_SI)+(d_Q_EDGE_n_dV_DI_SI*Q_EDGE_n))+((((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dV_DI_SI)+(((2.0*(d_Q_EDGE_qi0_dV_DI_SI+d_Q_EDGE_n_dV_DI_SI))-d_Q_EDGE_d0p_dV_DI_SI)*Q_EDGE_d0p)));
          Q_EDGE_sqerr = ((Q_EDGE_n*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*Q_EDGE_d0p));
          {
            double value_sqrt_0 = sqrt(Q_EDGE_sqerr);
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Q_EDGE_errq_dV_GP_SI = ((Q_EDGE_n*((Q_EDGE_d0p*((deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dV_GP_SI))-d_Q_EDGE_n_dV_GP_SI)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dV_GP_SI)/Q_EDGE_d0p/Q_EDGE_d0p))+(d_Q_EDGE_n_dV_GP_SI*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0)));
            d_Q_EDGE_errq_dV_SI_BP = ((Q_EDGE_n*((Q_EDGE_d0p*((deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dV_SI_BP))-d_Q_EDGE_n_dV_SI_BP)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dV_SI_BP)/Q_EDGE_d0p/Q_EDGE_d0p))+(d_Q_EDGE_n_dV_SI_BP*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0)));
            d_Q_EDGE_errq_dV_DI_SI = ((Q_EDGE_n*((Q_EDGE_d0p*((deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dV_DI_SI))-d_Q_EDGE_n_dV_DI_SI)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dV_DI_SI)/Q_EDGE_d0p/Q_EDGE_d0p))+(d_Q_EDGE_n_dV_DI_SI*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0)));
            Q_EDGE_errq = (Q_EDGE_n*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
          }

          d_qseffedge_dV_GP_SI = (d_Q_EDGE_qi0_dV_GP_SI-d_Q_EDGE_errq_dV_GP_SI);
          d_qseffedge_dV_SI_BP = (d_Q_EDGE_qi0_dV_SI_BP-d_Q_EDGE_errq_dV_SI_BP);
          d_qseffedge_dV_DI_SI = (d_Q_EDGE_qi0_dV_DI_SI-d_Q_EDGE_errq_dV_DI_SI);
          qseffedge = (Q_EDGE_qi0-Q_EDGE_errq);
        }
        else
        {
          if (((Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2))>(-2.3025850929940458e+02)))
          {
            {
              double value_exp_0 = exp((Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)));
              double  deriv_exp_0_d0 = value_exp_0;

              d_qseffedge_dV_GP_SI = (deriv_exp_0_d0*(((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI)+(d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2)))));
              d_qseffedge_dV_SI_BP = (deriv_exp_0_d0*(((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP)+(d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2)))));
              d_qseffedge_dV_DI_SI = (deriv_exp_0_d0*(((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI)+(d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2)))));
              qseffedge = value_exp_0;
            }
          }
          else
          {

            d_qseffedge_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(0.5*((((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI)+(d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2))))*3.3333333333333333e-01))+((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI)+(d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2))))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))+((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI)+(d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
            d_qseffedge_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(0.5*((((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP)+(d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2))))*3.3333333333333333e-01))+((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP)+(d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2))))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))+((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP)+(d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
            d_qseffedge_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(0.5*((((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI)+(d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2))))*3.3333333333333333e-01))+((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI)+(d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2))))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))+((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI)+(d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
            qseffedge = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
          }
        }

        d_xnedge_d_dV_GP_SI = ((inv_phit1edge*(d_Vdse_dc_dV_GP_SI+d_Vsbstaredge_dV_GP_SI))+(d_inv_phit1edge_dV_GP_SI*(Vdse_dc+Vsbstaredge)));
        d_xnedge_d_dV_SI_BP = ((inv_phit1edge*(d_Vdse_dc_dV_SI_BP+d_Vsbstaredge_dV_SI_BP))+(d_inv_phit1edge_dV_SI_BP*(Vdse_dc+Vsbstaredge)));
        d_xnedge_d_dV_DI_SI = ((inv_phit1edge*(d_Vdse_dc_dV_DI_SI+d_Vsbstaredge_dV_DI_SI))+(d_inv_phit1edge_dV_DI_SI*(Vdse_dc+Vsbstaredge)));
        xnedge_d = (inv_phit1edge*(Vdse_dc+Vsbstaredge));
        if (((qseffedge<1.0e-3)&(Vdse_dc<1.0e-6)))
        {
          if ((((-xnedge_d)+xnedge_s)>(-2.3025850929940458e+02)))
          {
            {
              double value_exp_0 = exp(((-xnedge_d)+xnedge_s));
              double  deriv_exp_0_d0 = value_exp_0;

              d_temp_dV_GP_SI = (deriv_exp_0_d0*(((-d_xnedge_d_dV_GP_SI)+d_xnedge_s_dV_GP_SI)));
              d_temp_dV_SI_BP = (deriv_exp_0_d0*(((-d_xnedge_d_dV_SI_BP)+d_xnedge_s_dV_SI_BP)));
              d_temp_dV_DI_SI = (deriv_exp_0_d0*(((-d_xnedge_d_dV_DI_SI)+d_xnedge_s_dV_DI_SI)));
              temp = value_exp_0;
            }
          }
          else
          {

            d_temp_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(0.5*((((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*((-((-d_xnedge_d_dV_GP_SI)+d_xnedge_s_dV_GP_SI))*3.3333333333333333e-01))+((-((-d_xnedge_d_dV_GP_SI)+d_xnedge_s_dV_GP_SI))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))+((-((-d_xnedge_d_dV_GP_SI)+d_xnedge_s_dV_GP_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))));
            d_temp_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(0.5*((((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*((-((-d_xnedge_d_dV_SI_BP)+d_xnedge_s_dV_SI_BP))*3.3333333333333333e-01))+((-((-d_xnedge_d_dV_SI_BP)+d_xnedge_s_dV_SI_BP))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))+((-((-d_xnedge_d_dV_SI_BP)+d_xnedge_s_dV_SI_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))));
            d_temp_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(0.5*((((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*((-((-d_xnedge_d_dV_DI_SI)+d_xnedge_s_dV_DI_SI))*3.3333333333333333e-01))+((-((-d_xnedge_d_dV_DI_SI)+d_xnedge_s_dV_DI_SI))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))+((-((-d_xnedge_d_dV_DI_SI)+d_xnedge_s_dV_DI_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))));
            temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))));
          }

          d_qdseffedge_dV_GP_SI = ((qseffedge*d_temp_dV_GP_SI)+(d_qseffedge_dV_GP_SI*(temp-1.0)));
          d_qdseffedge_dV_SI_BP = ((qseffedge*d_temp_dV_SI_BP)+(d_qseffedge_dV_SI_BP*(temp-1.0)));
          d_qdseffedge_dV_DI_SI = ((qseffedge*d_temp_dV_DI_SI)+(d_qseffedge_dV_DI_SI*(temp-1.0)));
          qdseffedge = (qseffedge*(temp-1.0));

          d_qdeffedge_dV_GP_SI = (d_qdseffedge_dV_GP_SI+d_qseffedge_dV_GP_SI);
          d_qdeffedge_dV_SI_BP = (d_qdseffedge_dV_SI_BP+d_qseffedge_dV_SI_BP);
          d_qdeffedge_dV_DI_SI = (d_qdseffedge_dV_DI_SI+d_qseffedge_dV_DI_SI);
          qdeffedge = (qdseffedge+qseffedge);
        }
        else
        {

          d_Q_EDGE_xsth_dV_GP_SI = (d_xbedge_dV_GP_SI+d_xnedge_d_dV_GP_SI);
          d_Q_EDGE_xsth_dV_SI_BP = (d_xbedge_dV_SI_BP+d_xnedge_d_dV_SI_BP);
          d_Q_EDGE_xsth_dV_DI_SI = (d_xbedge_dV_DI_SI+d_xnedge_d_dV_DI_SI);
          Q_EDGE_xsth = (xbedge+xnedge_d);
          {
            double value_sqrt_0 = sqrt(Q_EDGE_xsth);
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Q_EDGE_xth0_dV_GP_SI = (d_Q_EDGE_xsth_dV_GP_SI+(Gfedge*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_GP_SI))));
            d_Q_EDGE_xth0_dV_SI_BP = (d_Q_EDGE_xsth_dV_SI_BP+(Gfedge*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_SI_BP))));
            d_Q_EDGE_xth0_dV_DI_SI = (d_Q_EDGE_xsth_dV_DI_SI+(Gfedge*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_DI_SI))));
            Q_EDGE_xth0 = (Q_EDGE_xsth+(Gfedge*value_sqrt_0));
          }

          d_Q_EDGE_xth_dV_GP_SI = (d_Q_EDGE_xth0_dV_GP_SI+d_dxthedge_dV_GP_SI);
          d_Q_EDGE_xth_dV_SI_BP = (d_Q_EDGE_xth0_dV_SI_BP+d_dxthedge_dV_SI_BP);
          d_Q_EDGE_xth_dV_DI_SI = (d_Q_EDGE_xth0_dV_DI_SI+d_dxthedge_dV_DI_SI);
          Q_EDGE_xth = (Q_EDGE_xth0+dxthedge);
          {
            double value_sqrt_0 = sqrt(Q_EDGE_xsth);
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Q_EDGE_n_dV_GP_SI = (-Gfedge*(2.0*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_GP_SI)))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
            d_Q_EDGE_n_dV_SI_BP = (-Gfedge*(2.0*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_SI_BP)))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
            d_Q_EDGE_n_dV_DI_SI = (-Gfedge*(2.0*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_DI_SI)))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
            Q_EDGE_n = (1.0+(Gfedge/(2.0*value_sqrt_0)));
          }

          d_Q_EDGE_n_inv_dV_GP_SI = (-d_Q_EDGE_n_dV_GP_SI/Q_EDGE_n/Q_EDGE_n);
          d_Q_EDGE_n_inv_dV_SI_BP = (-d_Q_EDGE_n_dV_SI_BP/Q_EDGE_n/Q_EDGE_n);
          d_Q_EDGE_n_inv_dV_DI_SI = (-d_Q_EDGE_n_dV_DI_SI/Q_EDGE_n/Q_EDGE_n);
          Q_EDGE_n_inv = (1.0/Q_EDGE_n);

          d_Q_EDGE_xgt_dV_GP_SI = (d_xgedge_dV_GP_SI-d_Q_EDGE_xth_dV_GP_SI);
          d_Q_EDGE_xgt_dV_SI_BP = (d_xgedge_dV_SI_BP-d_Q_EDGE_xth_dV_SI_BP);
          d_Q_EDGE_xgt_dV_DI_SI = (d_xgedge_dV_DI_SI-d_Q_EDGE_xth_dV_DI_SI);
          Q_EDGE_xgt = (xgedge-Q_EDGE_xth);
          if ((Q_EDGE_xgt>(-12.0)))
          {

            d_Q_EDGE_xgt0_dV_GP_SI = d_Q_EDGE_xgt_dV_GP_SI;
            d_Q_EDGE_xgt0_dV_SI_BP = d_Q_EDGE_xgt_dV_SI_BP;
            d_Q_EDGE_xgt0_dV_DI_SI = d_Q_EDGE_xgt_dV_DI_SI;
            Q_EDGE_xgt0 = ((Q_EDGE_xgt+lnGfedge2)-1.0);
            {
              double value_sqrt_0 = sqrt(((Q_EDGE_xgt0*Q_EDGE_xgt0)+10.0));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_Q_EDGE_xgt0e_dV_GP_SI = (0.5*(d_Q_EDGE_xgt0_dV_GP_SI+(deriv_sqrt_0_d0*(((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dV_GP_SI)+(d_Q_EDGE_xgt0_dV_GP_SI*Q_EDGE_xgt0))))));
              d_Q_EDGE_xgt0e_dV_SI_BP = (0.5*(d_Q_EDGE_xgt0_dV_SI_BP+(deriv_sqrt_0_d0*(((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dV_SI_BP)+(d_Q_EDGE_xgt0_dV_SI_BP*Q_EDGE_xgt0))))));
              d_Q_EDGE_xgt0e_dV_DI_SI = (0.5*(d_Q_EDGE_xgt0_dV_DI_SI+(deriv_sqrt_0_d0*(((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dV_DI_SI)+(d_Q_EDGE_xgt0_dV_DI_SI*Q_EDGE_xgt0))))));
              Q_EDGE_xgt0e = (0.5*(Q_EDGE_xgt0+value_sqrt_0));
            }
            {
              double value_log_0 = log(Q_EDGE_xgt0e);
              double  deriv_log_0_d0 = (1.0/Q_EDGE_xgt0e);

              d_Q_EDGE_qi0si_dV_GP_SI = (d_Q_EDGE_xgt_dV_GP_SI-((Q_EDGE_n*(deriv_log_0_d0*(d_Q_EDGE_xgt0e_dV_GP_SI)))+(d_Q_EDGE_n_dV_GP_SI*value_log_0)));
              d_Q_EDGE_qi0si_dV_SI_BP = (d_Q_EDGE_xgt_dV_SI_BP-((Q_EDGE_n*(deriv_log_0_d0*(d_Q_EDGE_xgt0e_dV_SI_BP)))+(d_Q_EDGE_n_dV_SI_BP*value_log_0)));
              d_Q_EDGE_qi0si_dV_DI_SI = (d_Q_EDGE_xgt_dV_DI_SI-((Q_EDGE_n*(deriv_log_0_d0*(d_Q_EDGE_xgt0e_dV_DI_SI)))+(d_Q_EDGE_n_dV_DI_SI*value_log_0)));
              Q_EDGE_qi0si = ((Q_EDGE_xgt-(Q_EDGE_n*value_log_0))+lnGfedge2);
            }
            {
              double value_sqrt_0 = sqrt(((Q_EDGE_qi0si*Q_EDGE_qi0si)+2.0));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_Q_EDGE_qi0_dV_GP_SI = (0.5*(d_Q_EDGE_qi0si_dV_GP_SI+(deriv_sqrt_0_d0*(((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dV_GP_SI)+(d_Q_EDGE_qi0si_dV_GP_SI*Q_EDGE_qi0si))))));
              d_Q_EDGE_qi0_dV_SI_BP = (0.5*(d_Q_EDGE_qi0si_dV_SI_BP+(deriv_sqrt_0_d0*(((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dV_SI_BP)+(d_Q_EDGE_qi0si_dV_SI_BP*Q_EDGE_qi0si))))));
              d_Q_EDGE_qi0_dV_DI_SI = (0.5*(d_Q_EDGE_qi0si_dV_DI_SI+(deriv_sqrt_0_d0*(((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dV_DI_SI)+(d_Q_EDGE_qi0si_dV_DI_SI*Q_EDGE_qi0si))))));
              Q_EDGE_qi0 = (0.5*(Q_EDGE_qi0si+value_sqrt_0));
            }
            if (((Q_EDGE_xgt-Q_EDGE_qi0)<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((Q_EDGE_xgt-Q_EDGE_qi0));
                double  deriv_exp_0_d0 = value_exp_0;

                d_Q_EDGE_exp_x_dV_GP_SI = (deriv_exp_0_d0*((d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)));
                d_Q_EDGE_exp_x_dV_SI_BP = (deriv_exp_0_d0*((d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)));
                d_Q_EDGE_exp_x_dV_DI_SI = (deriv_exp_0_d0*((d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)));
                Q_EDGE_exp_x = value_exp_0;
              }
            }
            else
            {

              d_Q_EDGE_exp_x_dV_GP_SI = (1.0e100*((((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(0.5*((((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*((d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)*3.3333333333333333e-01))+((d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Q_EDGE_exp_x_dV_SI_BP = (1.0e100*((((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(0.5*((((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*((d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)*3.3333333333333333e-01))+((d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_Q_EDGE_exp_x_dV_DI_SI = (1.0e100*((((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(0.5*((((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*((d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)*3.3333333333333333e-01))+((d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              Q_EDGE_exp_x = (1.0e100*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }

            d_Q_EDGE_d0_dV_GP_SI = (Gfedge2*d_Q_EDGE_exp_x_dV_GP_SI);
            d_Q_EDGE_d0_dV_SI_BP = (Gfedge2*d_Q_EDGE_exp_x_dV_SI_BP);
            d_Q_EDGE_d0_dV_DI_SI = (Gfedge2*d_Q_EDGE_exp_x_dV_DI_SI);
            Q_EDGE_d0 = (Gfedge2*Q_EDGE_exp_x);
            {
              double value_pow_0 = pow(Q_EDGE_d0,Q_EDGE_n_inv);
              double  deriv_pow_0_d0 = ((Q_EDGE_d0 == 0.0)?0.0:(value_pow_0*Q_EDGE_n_inv/Q_EDGE_d0));
              double  deriv_pow_0_d1 = (Q_EDGE_d0 == 0.0)?0.0:(log(Q_EDGE_d0)*value_pow_0);

              d_Q_EDGE_d0p_dV_GP_SI = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dV_GP_SI))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dV_GP_SI)));
              d_Q_EDGE_d0p_dV_SI_BP = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dV_SI_BP))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dV_SI_BP)));
              d_Q_EDGE_d0p_dV_DI_SI = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dV_DI_SI))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dV_DI_SI)));
              Q_EDGE_d0p = value_pow_0;
            }

            d_Q_EDGE_sqerr_dV_GP_SI = (((Q_EDGE_n*d_Q_EDGE_n_dV_GP_SI)+(d_Q_EDGE_n_dV_GP_SI*Q_EDGE_n))+((((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dV_GP_SI)+(((2.0*(d_Q_EDGE_qi0_dV_GP_SI+d_Q_EDGE_n_dV_GP_SI))-d_Q_EDGE_d0p_dV_GP_SI)*Q_EDGE_d0p)));
            d_Q_EDGE_sqerr_dV_SI_BP = (((Q_EDGE_n*d_Q_EDGE_n_dV_SI_BP)+(d_Q_EDGE_n_dV_SI_BP*Q_EDGE_n))+((((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dV_SI_BP)+(((2.0*(d_Q_EDGE_qi0_dV_SI_BP+d_Q_EDGE_n_dV_SI_BP))-d_Q_EDGE_d0p_dV_SI_BP)*Q_EDGE_d0p)));
            d_Q_EDGE_sqerr_dV_DI_SI = (((Q_EDGE_n*d_Q_EDGE_n_dV_DI_SI)+(d_Q_EDGE_n_dV_DI_SI*Q_EDGE_n))+((((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dV_DI_SI)+(((2.0*(d_Q_EDGE_qi0_dV_DI_SI+d_Q_EDGE_n_dV_DI_SI))-d_Q_EDGE_d0p_dV_DI_SI)*Q_EDGE_d0p)));
            Q_EDGE_sqerr = ((Q_EDGE_n*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*Q_EDGE_d0p));
            {
              double value_sqrt_0 = sqrt(Q_EDGE_sqerr);
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_Q_EDGE_errq_dV_GP_SI = ((Q_EDGE_n*((Q_EDGE_d0p*((deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dV_GP_SI))-d_Q_EDGE_n_dV_GP_SI)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dV_GP_SI)/Q_EDGE_d0p/Q_EDGE_d0p))+(d_Q_EDGE_n_dV_GP_SI*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0)));
              d_Q_EDGE_errq_dV_SI_BP = ((Q_EDGE_n*((Q_EDGE_d0p*((deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dV_SI_BP))-d_Q_EDGE_n_dV_SI_BP)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dV_SI_BP)/Q_EDGE_d0p/Q_EDGE_d0p))+(d_Q_EDGE_n_dV_SI_BP*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0)));
              d_Q_EDGE_errq_dV_DI_SI = ((Q_EDGE_n*((Q_EDGE_d0p*((deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dV_DI_SI))-d_Q_EDGE_n_dV_DI_SI)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dV_DI_SI)/Q_EDGE_d0p/Q_EDGE_d0p))+(d_Q_EDGE_n_dV_DI_SI*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0)));
              Q_EDGE_errq = (Q_EDGE_n*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
            }

            d_qdeffedge_dV_GP_SI = (d_Q_EDGE_qi0_dV_GP_SI-d_Q_EDGE_errq_dV_GP_SI);
            d_qdeffedge_dV_SI_BP = (d_Q_EDGE_qi0_dV_SI_BP-d_Q_EDGE_errq_dV_SI_BP);
            d_qdeffedge_dV_DI_SI = (d_Q_EDGE_qi0_dV_DI_SI-d_Q_EDGE_errq_dV_DI_SI);
            qdeffedge = (Q_EDGE_qi0-Q_EDGE_errq);
          }
          else
          {
            if (((Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2))>(-2.3025850929940458e+02)))
            {
              {
                double value_exp_0 = exp((Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)));
                double  deriv_exp_0_d0 = value_exp_0;

                d_qdeffedge_dV_GP_SI = (deriv_exp_0_d0*(((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI)+(d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2)))));
                d_qdeffedge_dV_SI_BP = (deriv_exp_0_d0*(((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP)+(d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2)))));
                d_qdeffedge_dV_DI_SI = (deriv_exp_0_d0*(((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI)+(d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2)))));
                qdeffedge = value_exp_0;
              }
            }
            else
            {

              d_qdeffedge_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(0.5*((((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI)+(d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2))))*3.3333333333333333e-01))+((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI)+(d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2))))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))+((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI)+(d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
              d_qdeffedge_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(0.5*((((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP)+(d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2))))*3.3333333333333333e-01))+((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP)+(d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2))))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))+((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP)+(d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
              d_qdeffedge_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(0.5*((((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI)+(d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2))))*3.3333333333333333e-01))+((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI)+(d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2))))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))+((-((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI)+(d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
              qdeffedge = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
            }
          }

          d_qdseffedge_dV_GP_SI = (d_qdeffedge_dV_GP_SI-d_qseffedge_dV_GP_SI);
          d_qdseffedge_dV_SI_BP = (d_qdeffedge_dV_SI_BP-d_qseffedge_dV_SI_BP);
          d_qdseffedge_dV_DI_SI = (d_qdeffedge_dV_DI_SI-d_qseffedge_dV_DI_SI);
          qdseffedge = (qdeffedge-qseffedge);
        }

        d_qmeffedge_dV_GP_SI = (0.5*(d_qdeffedge_dV_GP_SI+d_qseffedge_dV_GP_SI));
        d_qmeffedge_dV_SI_BP = (0.5*(d_qdeffedge_dV_SI_BP+d_qseffedge_dV_SI_BP));
        d_qmeffedge_dV_DI_SI = (0.5*(d_qdeffedge_dV_DI_SI+d_qseffedge_dV_DI_SI));
        qmeffedge = (0.5*(qdeffedge+qseffedge));
        {
          double value_max_0 = std::max((xgedge-qmeffedge),static_cast<double>(1.0e-40));
          double  deriv_max_0_d0 = (((xgedge-qmeffedge)>=1.0e-40)?1.0:0.0);

          d_dsqredge_dV_GP_SI = 0.0;
          d_dsqredge_dV_SI_BP = 0.0;
          d_dsqredge_dV_DI_SI = 0.0;
          dsqredge = value_max_0;
        }
        {
          double value_sqrt_0 = sqrt((dsqredge+(0.25*Gfedge2)));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_alphabmedge_dV_GP_SI = (-(-(0.5*Gfedge)*(deriv_sqrt_0_d0*(d_dsqredge_dV_GP_SI))/value_sqrt_0/value_sqrt_0));
          d_alphabmedge_dV_SI_BP = (-(-(0.5*Gfedge)*(deriv_sqrt_0_d0*(d_dsqredge_dV_SI_BP))/value_sqrt_0/value_sqrt_0));
          d_alphabmedge_dV_DI_SI = (-(-(0.5*Gfedge)*(deriv_sqrt_0_d0*(d_dsqredge_dV_DI_SI))/value_sqrt_0/value_sqrt_0));
          alphabmedge = (1.0-((0.5*Gfedge)/value_sqrt_0));
        }

        d_Idsedge_dV_GP_SI = ((Gmob_dc*((((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*d_qdseffedge_dV_GP_SI)+((((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*d_qmeffedge_dV_GP_SI)+(d_alphabmedge_dV_GP_SI*qmeffedge)))+(((((-BETEDGE_i)*phit1edge)*d_phit1edge_dV_GP_SI)+(((-BETEDGE_i)*d_phit1edge_dV_GP_SI)*phit1edge))*((alphabmedge*qmeffedge)+1.0)))*qdseffedge))-(((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)*d_Gmob_dc_dV_GP_SI)/Gmob_dc/Gmob_dc);
        d_Idsedge_dV_SI_BP = ((Gmob_dc*((((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*d_qdseffedge_dV_SI_BP)+((((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*d_qmeffedge_dV_SI_BP)+(d_alphabmedge_dV_SI_BP*qmeffedge)))+(((((-BETEDGE_i)*phit1edge)*d_phit1edge_dV_SI_BP)+(((-BETEDGE_i)*d_phit1edge_dV_SI_BP)*phit1edge))*((alphabmedge*qmeffedge)+1.0)))*qdseffedge))-(((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)*d_Gmob_dc_dV_SI_BP)/Gmob_dc/Gmob_dc);
        d_Idsedge_dV_DI_SI = ((Gmob_dc*((((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*d_qdseffedge_dV_DI_SI)+((((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*d_qmeffedge_dV_DI_SI)+(d_alphabmedge_dV_DI_SI*qmeffedge)))+(((((-BETEDGE_i)*phit1edge)*d_phit1edge_dV_DI_SI)+(((-BETEDGE_i)*d_phit1edge_dV_DI_SI)*phit1edge))*((alphabmedge*qmeffedge)+1.0)))*qdseffedge))-(((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)*d_Gmob_dc_dV_DI_SI)/Gmob_dc/Gmob_dc);
        Idsedge = ((((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)/Gmob_dc);
      }
      if (((xg_dc>0)&&((model_.SWIMPACT_i)!=0)))
      {

        d_delVsat_dV_SI_BP = (-(A3_i*d_dps_dc_dV_SI_BP));
        d_delVsat_dV_GP_SI = (-(A3_i*d_dps_dc_dV_GP_SI));
        d_delVsat_dV_DI_SI = (d_Vds_dV_DI_SI-(A3_i*d_dps_dc_dV_DI_SI));
        delVsat = (Vds-(A3_i*dps_dc));
        if ((delVsat>0))
        {
          {
            double value_sqrt_0 = sqrt((phib_dc+Vsbstar_dc));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_temp2_dV_GP_SI = (A2_T*(-(1.0+(A4_i*(value_sqrt_0-sqrt_phib_dc)))*d_delVsat_dV_GP_SI/(delVsat+1.0e-30)/(delVsat+1.0e-30)));
            d_temp2_dV_SI_BP = (A2_T*(((delVsat+1.0e-30)*(A4_i*(deriv_sqrt_0_d0*(d_Vsbstar_dc_dV_SI_BP)))-(1.0+(A4_i*(value_sqrt_0-sqrt_phib_dc)))*d_delVsat_dV_SI_BP)/(delVsat+1.0e-30)/(delVsat+1.0e-30)));
            d_temp2_dV_DI_SI = (A2_T*(((delVsat+1.0e-30)*(A4_i*(deriv_sqrt_0_d0*(d_Vsbstar_dc_dV_DI_SI)))-(1.0+(A4_i*(value_sqrt_0-sqrt_phib_dc)))*d_delVsat_dV_DI_SI)/(delVsat+1.0e-30)/(delVsat+1.0e-30)));
            temp2 = (A2_T*((1.0+(A4_i*(value_sqrt_0-sqrt_phib_dc)))/(delVsat+1.0e-30)));
          }
          if ((fabs((-temp2))<2.3025850929940458e+02))
          {
            {
              double value_exp_0 = exp((-temp2));
              double  deriv_exp_0_d0 = value_exp_0;

              d_temp_dV_SI_BP = (deriv_exp_0_d0*((-d_temp2_dV_SI_BP)));
              d_temp_dV_GP_SI = (deriv_exp_0_d0*((-d_temp2_dV_GP_SI)));
              d_temp_dV_DI_SI = (deriv_exp_0_d0*((-d_temp2_dV_DI_SI)));
              temp = value_exp_0;
            }
          }
          else
          {
            if (((-temp2)<0.0))
            {

              d_temp_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-(-temp2))*(0.5*((((-2.3025850929940458e+02)-(-temp2))*((-(-d_temp2_dV_SI_BP))*3.3333333333333333e-01))+((-(-d_temp2_dV_SI_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+((-(-d_temp2_dV_SI_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
              d_temp_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-(-temp2))*(0.5*((((-2.3025850929940458e+02)-(-temp2))*((-(-d_temp2_dV_GP_SI))*3.3333333333333333e-01))+((-(-d_temp2_dV_GP_SI))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+((-(-d_temp2_dV_GP_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
              d_temp_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-(-temp2))*(0.5*((((-2.3025850929940458e+02)-(-temp2))*((-(-d_temp2_dV_DI_SI))*3.3333333333333333e-01))+((-(-d_temp2_dV_DI_SI))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+((-(-d_temp2_dV_DI_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
              temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
            }
            else
            {

              d_temp_dV_SI_BP = (1.0e100*((((-temp2)-2.3025850929940458e+02)*(0.5*((((-temp2)-2.3025850929940458e+02)*((-d_temp2_dV_SI_BP)*3.3333333333333333e-01))+((-d_temp2_dV_SI_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-d_temp2_dV_SI_BP)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_temp_dV_GP_SI = (1.0e100*((((-temp2)-2.3025850929940458e+02)*(0.5*((((-temp2)-2.3025850929940458e+02)*((-d_temp2_dV_GP_SI)*3.3333333333333333e-01))+((-d_temp2_dV_GP_SI)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-d_temp2_dV_GP_SI)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              d_temp_dV_DI_SI = (1.0e100*((((-temp2)-2.3025850929940458e+02)*(0.5*((((-temp2)-2.3025850929940458e+02)*((-d_temp2_dV_DI_SI)*3.3333333333333333e-01))+((-d_temp2_dV_DI_SI)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-d_temp2_dV_DI_SI)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              temp = (1.0e100*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }

          d_mavl_dV_SI_BP = (A1_i*((delVsat*d_temp_dV_SI_BP)+(d_delVsat_dV_SI_BP*temp)));
          d_mavl_dV_GP_SI = (A1_i*((delVsat*d_temp_dV_GP_SI)+(d_delVsat_dV_GP_SI*temp)));
          d_mavl_dV_DI_SI = (A1_i*((delVsat*d_temp_dV_DI_SI)+(d_delVsat_dV_DI_SI*temp)));
          mavl = (A1_i*(delVsat*temp));

          d_Iimpact_dV_SI_BP = ((mavl*(d_Ids_dV_SI_BP+d_Idsedge_dV_SI_BP))+(d_mavl_dV_SI_BP*(Ids+Idsedge)));
          d_Iimpact_dV_GP_SI = ((mavl*(d_Ids_dV_GP_SI+d_Idsedge_dV_GP_SI))+(d_mavl_dV_GP_SI*(Ids+Idsedge)));
          d_Iimpact_dV_DI_SI = ((mavl*(d_Ids_dV_DI_SI+d_Idsedge_dV_DI_SI))+(d_mavl_dV_DI_SI*(Ids+Idsedge)));
          Iimpact = (mavl*(Ids+Idsedge));
        }
      }

      d_P_D_dV_SI_BP = 0.0;
      d_P_D_dV_GP_SI = 0.0;
      d_P_D_dV_DI_SI = 0.0;
      P_D = (1.0+(0.25*(Gf_dc*kp)));

      d_facvsb0_dV_SI_BP = (2.0*d_phit1_dV_SI_BP);
      d_facvsb0_dV_DI_SI = (2.0*d_phit1_dV_DI_SI);
      facvsb0 = (phib_dc+(2.0*phit1));

      d_facvsb_dV_SI_BP = d_Vsbstar_dc_dV_SI_BP;
      d_facvsb_dV_DI_SI = d_Vsbstar_dc_dV_DI_SI;
      facvsb = (Vsbstar_dc+facvsb0);
      {
        double value_sqrt_0 = sqrt((phit1*facvsb));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_vts_i_dV_SI_BP = ((-d_Vsbstar_dc_dV_SI_BP)+(Gf_dc*(deriv_sqrt_0_d0*((d_phit1_dV_SI_BP*facvsb)))));
        d_vts_i_dV_GP_SI = (Gf_dc*(deriv_sqrt_0_d0*((d_phit1_dV_GP_SI*facvsb))));
        d_vts_i_dV_DI_SI = ((-d_Vsbstar_dc_dV_DI_SI)+(Gf_dc*(deriv_sqrt_0_d0*((d_phit1_dV_DI_SI*facvsb)))));
        vts_i = (((VFB_T+(P_D*facvsb))-Vsbstar_dc)+(Gf_dc*value_sqrt_0));
      }

      d_vth_i_dV_SI_BP = (-d_delVg_dV_SI_BP);
      d_vth_i_dV_GP_SI = (-d_delVg_dV_GP_SI);
      d_vth_i_dV_DI_SI = (-d_delVg_dV_DI_SI);
      vth_i = (vts_i-delVg);
    }
    // End block evaluateStatic
    //Begin block evaluateDynamic
    {
      //Begin block SPcalc_ac
      {
        //Block-local variables for block SPcalc_ac
        double phib;
        double G_0;
        double Vsbstar;
        double d_Vsbstar_dV_DI_SI;
        double d_Vsbstar_dV_SI_BP;
        double d_Vsbstar_dV_GP_SI;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        double Vsbx;
        double d_Vsbx_dV_DI_SI;
        double d_Vsbx_dV_SI_BP;
        double d_Vsbx_dV_GP_SI;
        double xg;
        double d_xg_dV_DI_SI;
        double d_xg_dV_GP_SI;
        double d_xg_dV_SI_BP;
        double Dnsub;
        double d_Dnsub_dV_DI_SI;
        double d_Dnsub_dV_GP_SI;
        double d_Dnsub_dV_SI_BP;
        double Gf;
        double d_Gf_dV_DI_SI;
        double d_Gf_dV_GP_SI;
        double d_Gf_dV_SI_BP;
        double Gf2;
        double d_Gf2_dV_DI_SI;
        double d_Gf2_dV_GP_SI;
        double d_Gf2_dV_SI_BP;
        double inv_Gf2;
        double d_inv_Gf2_dV_DI_SI;
        double d_inv_Gf2_dV_GP_SI;
        double d_inv_Gf2_dV_SI_BP;
        double xi;
        double d_xi_dV_DI_SI;
        double d_xi_dV_GP_SI;
        double d_xi_dV_SI_BP;
        double inv_xi;
        double d_inv_xi_dV_DI_SI;
        double d_inv_xi_dV_GP_SI;
        double d_inv_xi_dV_SI_BP;
        double Ux;
        double d_Ux_dV_DI_SI;
        double d_Ux_dV_SI_BP;
        double d_Ux_dV_GP_SI;
        double xn_s;
        double d_xn_s_dV_GP_SI;
        double d_xn_s_dV_DI_SI;
        double d_xn_s_dV_SI_BP;
        double delta_ns;
        double d_delta_ns_dV_GP_SI;
        double d_delta_ns_dV_DI_SI;
        double d_delta_ns_dV_SI_BP;
        double margin;
        double d_margin_dV_DI_SI;
        double d_margin_dV_GP_SI;
        double d_margin_dV_SI_BP;
        double x_s;
        double d_x_s_dV_DI_SI;
        double d_x_s_dV_GP_SI;
        double d_x_s_dV_SI_BP;
        double delta_1s;
        double d_delta_1s_dV_DI_SI;
        double d_delta_1s_dV_GP_SI;
        double d_delta_1s_dV_SI_BP;
        double xi0s;
        double d_xi0s_dV_DI_SI;
        double d_xi0s_dV_GP_SI;
        double d_xi0s_dV_SI_BP;
        double xi1s;
        double d_xi1s_dV_DI_SI;
        double d_xi1s_dV_GP_SI;
        double d_xi1s_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        double xi2s;
        double d_xi2s_dV_GP_SI;
        double d_xi2s_dV_DI_SI;
        double d_xi2s_dV_SI_BP;
        double Es;
        double d_Es_dV_DI_SI;
        double d_Es_dV_GP_SI;
        double d_Es_dV_SI_BP;
        double Ds;
        double d_Ds_dV_DI_SI;
        double d_Ds_dV_GP_SI;
        double d_Ds_dV_SI_BP;
        double Ps;
        double d_Ps_dV_DI_SI;
        double d_Ps_dV_GP_SI;
        double d_Ps_dV_SI_BP;
        double Rxcor;
        double d_Rxcor_dV_DI_SI;
        double d_Rxcor_dV_SI_BP;
        double d_Rxcor_dV_GP_SI;
        double xgs;
        double d_xgs_dV_DI_SI;
        double d_xgs_dV_GP_SI;
        double d_xgs_dV_SI_BP;
        double qis;
        double d_qis_dV_DI_SI;
        double d_qis_dV_GP_SI;
        double d_qis_dV_SI_BP;
        double qbs;
        double d_qbs_dV_DI_SI;
        double d_qbs_dV_GP_SI;
        double d_qbs_dV_SI_BP;
        double rhob;
        double d_rhob_dV_DI_SI;
        double d_rhob_dV_SI_BP;
        double d_rhob_dV_GP_SI;
        double GR;
        double d_GR_dV_DI_SI;
        double d_GR_dV_SI_BP;
        double d_GR_dV_GP_SI;
        double Eeffm;
        double d_Eeffm_dV_DI_SI;
        double d_Eeffm_dV_GP_SI;
        double d_Eeffm_dV_SI_BP;
        double Mutmp;
        double d_Mutmp_dV_DI_SI;
        double d_Mutmp_dV_GP_SI;
        double d_Mutmp_dV_SI_BP;
        double Gmob;
        double d_Gmob_dV_DI_SI;
        double d_Gmob_dV_GP_SI;
        double d_Gmob_dV_SI_BP;
        double xitsb;
        double d_xitsb_dV_DI_SI;
        double d_xitsb_dV_SI_BP;
        double d_xitsb_dV_GP_SI;
        double wsat;
        double d_wsat_dV_DI_SI;
        double d_wsat_dV_GP_SI;
        double d_wsat_dV_SI_BP;
        double thesat1;
        double d_thesat1_dV_GP_SI;
        double d_thesat1_dV_DI_SI;
        double d_thesat1_dV_SI_BP;
        double phi_inf;
        double d_phi_inf_dV_DI_SI;
        double d_phi_inf_dV_GP_SI;
        double d_phi_inf_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        double ysat;
        double d_ysat_dV_GP_SI;
        double d_ysat_dV_DI_SI;
        double d_ysat_dV_SI_BP;
        double za;
        double d_za_dV_GP_SI;
        double d_za_dV_DI_SI;
        double d_za_dV_SI_BP;
        double Phi_0;
        double d_Phi_0_dV_DI_SI;
        double d_Phi_0_dV_GP_SI;
        double d_Phi_0_dV_SI_BP;
        double asat;
        double d_asat_dV_DI_SI;
        double d_asat_dV_GP_SI;
        double d_asat_dV_SI_BP;
        double Phi_2;
        double d_Phi_2_dV_DI_SI;
        double d_Phi_2_dV_GP_SI;
        double d_Phi_2_dV_SI_BP;
        double Phi_0_2;
        double d_Phi_0_2_dV_DI_SI;
        double d_Phi_0_2_dV_GP_SI;
        double d_Phi_0_2_dV_SI_BP;
        double Phi0_Phi2;
        double d_Phi0_Phi2_dV_DI_SI;
        double d_Phi0_Phi2_dV_GP_SI;
        double d_Phi0_Phi2_dV_SI_BP;
        double Phi_sat;
        double d_Phi_sat_dV_DI_SI;
        double d_Phi_sat_dV_GP_SI;
        double d_Phi_sat_dV_SI_BP;
        double Vdse;
        double d_Vdse_dV_GP_SI;
        double d_Vdse_dV_SI_BP;
        double d_Vdse_dV_DI_SI;
        double Udse;
        double d_Udse_dV_GP_SI;
        double d_Udse_dV_SI_BP;
        double d_Udse_dV_DI_SI;
        double xn_d;
        double d_xn_d_dV_GP_SI;
        double d_xn_d_dV_DI_SI;
        double d_xn_d_dV_SI_BP;
        double k_ds;
        double d_k_ds_dV_GP_SI;
        double d_k_ds_dV_SI_BP;
        double d_k_ds_dV_DI_SI;
        double delta_nd;
        double d_delta_nd_dV_GP_SI;
        double d_delta_nd_dV_DI_SI;
        double d_delta_nd_dV_SI_BP;
        double x_d;
        double d_x_d_dV_DI_SI;
        double d_x_d_dV_GP_SI;
        double d_x_d_dV_SI_BP;
        double x_ds;
        double d_x_ds_dV_DI_SI;
        double d_x_ds_dV_GP_SI;
        double d_x_ds_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        double pC;
        double d_pC_dV_DI_SI;
        double d_pC_dV_GP_SI;
        double d_pC_dV_SI_BP;
        double qC;
        double d_qC_dV_DI_SI;
        double d_qC_dV_GP_SI;
        double d_qC_dV_SI_BP;
        double dps;
        double d_dps_dV_DI_SI;
        double d_dps_dV_GP_SI;
        double d_dps_dV_SI_BP;
        double xi0d;
        double d_xi0d_dV_DI_SI;
        double d_xi0d_dV_GP_SI;
        double d_xi0d_dV_SI_BP;
        double Ed;
        double d_Ed_dV_DI_SI;
        double d_Ed_dV_GP_SI;
        double d_Ed_dV_SI_BP;
        double Dd;
        double d_Dd_dV_DI_SI;
        double d_Dd_dV_GP_SI;
        double d_Dd_dV_SI_BP;
        double x_m;
        double d_x_m_dV_DI_SI;
        double d_x_m_dV_GP_SI;
        double d_x_m_dV_SI_BP;
        double Em;
        double d_Em_dV_DI_SI;
        double d_Em_dV_GP_SI;
        double d_Em_dV_SI_BP;
        double D_bar;
        double d_D_bar_dV_DI_SI;
        double d_D_bar_dV_GP_SI;
        double d_D_bar_dV_SI_BP;
        double Dm;
        double d_Dm_dV_DI_SI;
        double d_Dm_dV_GP_SI;
        double d_Dm_dV_SI_BP;
        double Pm;
        double d_Pm_dV_DI_SI;
        double d_Pm_dV_GP_SI;
        double d_Pm_dV_SI_BP;
        double xgm;
        double d_xgm_dV_DI_SI;
        double d_xgm_dV_GP_SI;
        double d_xgm_dV_SI_BP;
        double eta_p;
        double d_eta_p_dV_DI_SI;
        double d_eta_p_dV_GP_SI;
        double d_eta_p_dV_SI_BP;
        double sqm;
        double d_sqm_dV_DI_SI;
        double d_sqm_dV_GP_SI;
        double d_sqm_dV_SI_BP;
        double alpha;
        double d_alpha_dV_DI_SI;
        double d_alpha_dV_GP_SI;
        double d_alpha_dV_SI_BP;
        double d0;
        double d_d0_dV_DI_SI;
        double d_d0_dV_GP_SI;
        double d_d0_dV_SI_BP;
        double x_pm;
        double d_x_pm_dV_GP_SI;
        double d_x_pm_dV_DI_SI;
        double d_x_pm_dV_SI_BP;
        double p_pd;
        double d_p_pd_dV_DI_SI;
        double d_p_pd_dV_GP_SI;
        double d_p_pd_dV_SI_BP;
        double q_pd;
        double d_q_pd_dV_GP_SI;
        double d_q_pd_dV_DI_SI;
        double d_q_pd_dV_SI_BP;
        double xi_pd;
        double d_xi_pd_dV_DI_SI;
        double d_xi_pd_dV_GP_SI;
        double d_xi_pd_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        double u_pd;
        double d_u_pd_dV_GP_SI;
        double d_u_pd_dV_DI_SI;
        double d_u_pd_dV_SI_BP;
        double km;
        double d_km_dV_GP_SI;
        double d_km_dV_DI_SI;
        double d_km_dV_SI_BP;
        double km0;
        double d_km0_dV_DI_SI;
        double d_km0_dV_GP_SI;
        double d_km0_dV_SI_BP;
        double qim;
        double d_qim_dV_GP_SI;
        double d_qim_dV_DI_SI;
        double d_qim_dV_SI_BP;
        double qim1;
        double d_qim1_dV_GP_SI;
        double d_qim1_dV_DI_SI;
        double d_qim1_dV_SI_BP;
        double qbm;
        double d_qbm_dV_DI_SI;
        double d_qbm_dV_GP_SI;
        double d_qbm_dV_SI_BP;
        double qeff;
        double d_qeff_dV_DI_SI;
        double d_qeff_dV_GP_SI;
        double d_qeff_dV_SI_BP;
        double qeff1;
        double d_qeff1_dV_DI_SI;
        double d_qeff1_dV_GP_SI;
        double d_qeff1_dV_SI_BP;
        double s1;
        double d_s1_dV_DI_SI;
        double d_s1_dV_GP_SI;
        double d_s1_dV_SI_BP;
        double dL;
        double d_dL_dV_DI_SI;
        double d_dL_dV_GP_SI;
        double d_dL_dV_SI_BP;
        double GdL;
        double d_GdL_dV_DI_SI;
        double d_GdL_dV_GP_SI;
        double d_GdL_dV_SI_BP;
        double Gmob_dL;
        double d_Gmob_dL_dV_DI_SI;
        double d_Gmob_dL_dV_GP_SI;
        double d_Gmob_dL_dV_SI_BP;
        double zsat;
        double d_zsat_dV_GP_SI;
        double d_zsat_dV_DI_SI;
        double d_zsat_dV_SI_BP;
        double Gvsat;
        double d_Gvsat_dV_DI_SI;
        double d_Gvsat_dV_GP_SI;
        double d_Gvsat_dV_SI_BP;
        double Gvsatinv;
        double d_Gvsatinv_dV_DI_SI;
        double d_Gvsatinv_dV_GP_SI;
        double d_Gvsatinv_dV_SI_BP;
        double Voxm;
        double d_Voxm_dV_DI_SI;
        double d_Voxm_dV_GP_SI;
        double d_Voxm_dV_SI_BP;
        double alpha1;
        double d_alpha1_dV_DI_SI;
        double d_alpha1_dV_GP_SI;
        double d_alpha1_dV_SI_BP;
        double H;
        double d_H_dV_GP_SI;
        double d_H_dV_DI_SI;
        double d_H_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        double SP_S_temp;
        double d_SP_S_temp_dV_DI_SI;
        double d_SP_S_temp_dV_GP_SI;
        double d_SP_S_temp_dV_SI_BP;
        double SP_S_temp1;
        double d_SP_S_temp1_dV_DI_SI;
        double d_SP_S_temp1_dV_GP_SI;
        double d_SP_S_temp1_dV_SI_BP;
        double SP_S_temp2;
        double d_SP_S_temp2_dV_DI_SI;
        double d_SP_S_temp2_dV_GP_SI;
        double d_SP_S_temp2_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        double SP_S_yg;
        double d_SP_S_yg_dV_DI_SI;
        double d_SP_S_yg_dV_GP_SI;
        double d_SP_S_yg_dV_SI_BP;
        double SP_S_ysub;
        double d_SP_S_ysub_dV_DI_SI;
        double d_SP_S_ysub_dV_GP_SI;
        double d_SP_S_ysub_dV_SI_BP;
        double SP_S_eta;
        double d_SP_S_eta_dV_DI_SI;
        double d_SP_S_eta_dV_GP_SI;
        double d_SP_S_eta_dV_SI_BP;
        double SP_S_a;
        double d_SP_S_a_dV_DI_SI;
        double d_SP_S_a_dV_GP_SI;
        double d_SP_S_a_dV_SI_BP;
        double SP_S_c;
        double d_SP_S_c_dV_DI_SI;
        double d_SP_S_c_dV_GP_SI;
        double d_SP_S_c_dV_SI_BP;
        double SP_S_tau;
        double d_SP_S_tau_dV_DI_SI;
        double d_SP_S_tau_dV_GP_SI;
        double d_SP_S_tau_dV_SI_BP;
        double SP_S_y0;
        double d_SP_S_y0_dV_DI_SI;
        double d_SP_S_y0_dV_GP_SI;
        double d_SP_S_y0_dV_SI_BP;
        double SP_S_delta0;
        double d_SP_S_delta0_dV_DI_SI;
        double d_SP_S_delta0_dV_GP_SI;
        double d_SP_S_delta0_dV_SI_BP;
        double SP_S_delta1;
        double d_SP_S_delta1_dV_DI_SI;
        double d_SP_S_delta1_dV_GP_SI;
        double d_SP_S_delta1_dV_SI_BP;
        double SP_S_xi0;
        double d_SP_S_xi0_dV_DI_SI;
        double d_SP_S_xi0_dV_GP_SI;
        double d_SP_S_xi0_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        double SP_S_xi1;
        double d_SP_S_xi1_dV_DI_SI;
        double d_SP_S_xi1_dV_GP_SI;
        double d_SP_S_xi1_dV_SI_BP;
        double SP_S_xi2;
        double d_SP_S_xi2_dV_DI_SI;
        double d_SP_S_xi2_dV_GP_SI;
        double d_SP_S_xi2_dV_SI_BP;
        double SP_S_pC;
        double d_SP_S_pC_dV_DI_SI;
        double d_SP_S_pC_dV_GP_SI;
        double d_SP_S_pC_dV_SI_BP;
        double SP_S_qC;
        double d_SP_S_qC_dV_DI_SI;
        double d_SP_S_qC_dV_GP_SI;
        double d_SP_S_qC_dV_SI_BP;
        double SP_xg1;
        double d_SP_xg1_dV_DI_SI;
        double d_SP_xg1_dV_GP_SI;
        double d_SP_xg1_dV_SI_BP;
        double SP_S_A_fac;
        double d_SP_S_A_fac_dV_DI_SI;
        double d_SP_S_A_fac_dV_GP_SI;
        double d_SP_S_A_fac_dV_SI_BP;
        double SP_S_xbar;
        double d_SP_S_xbar_dV_DI_SI;
        double d_SP_S_xbar_dV_GP_SI;
        double d_SP_S_xbar_dV_SI_BP;
        double SP_S_w;
        double d_SP_S_w_dV_DI_SI;
        double d_SP_S_w_dV_GP_SI;
        double d_SP_S_w_dV_SI_BP;
        double SP_S_x1;
        double d_SP_S_x1_dV_DI_SI;
        double d_SP_S_x1_dV_GP_SI;
        double d_SP_S_x1_dV_SI_BP;
        double SP_S_bx;
        double d_SP_S_bx_dV_GP_SI;
        double d_SP_S_bx_dV_DI_SI;
        double d_SP_S_bx_dV_SI_BP;
        double SP_S_b;
        double d_SP_S_b_dV_DI_SI;
        double d_SP_S_b_dV_GP_SI;
        double d_SP_S_b_dV_SI_BP;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        double SP_S_x0;
        double d_SP_S_x0_dV_DI_SI;
        double d_SP_S_x0_dV_GP_SI;
        double d_SP_S_x0_dV_SI_BP;
        //End of Block-local variables
        if ((((model_.SWNUD_i)==1)||((model_.SWDELVTAC_i)!=0)))
        {
          if (((model_.SWDELVTAC_i)!=0))
          {
            {
              double value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+bphi_ac));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_temp_dV_GP_SI =  0.0;
              d_temp_dV_SI_BP = (0.5*((d_Vdb_dV_SI_BP+d_Vsb_dV_SI_BP)-(deriv_sqrt_0_d0*((((Vdb-Vsb)*(d_Vdb_dV_SI_BP-d_Vsb_dV_SI_BP))+((d_Vdb_dV_SI_BP-d_Vsb_dV_SI_BP)*(Vdb-Vsb)))))));
              d_temp_dV_DI_SI = (0.5*((d_Vdb_dV_DI_SI+d_Vsb_dV_DI_SI)-(deriv_sqrt_0_d0*((((Vdb-Vsb)*(d_Vdb_dV_DI_SI-d_Vsb_dV_DI_SI))+((d_Vdb_dV_DI_SI-d_Vsb_dV_DI_SI)*(Vdb-Vsb)))))));
              temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+phix_ac);
            }
            {
              double value_sqrt_0 = sqrt((((temp)*(temp))+aphi_ac));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_Vsbstar_ac_dV_GP_SI = (-(0.5*((d_temp_dV_GP_SI)-(deriv_sqrt_0_d0*((((temp)*(d_temp_dV_GP_SI))+((d_temp_dV_GP_SI)*(temp))))))));
              d_Vsbstar_ac_dV_SI_BP = (d_Vsb_dV_SI_BP-(0.5*((d_temp_dV_SI_BP)-(deriv_sqrt_0_d0*((((temp)*(d_temp_dV_SI_BP))+((d_temp_dV_SI_BP)*(temp))))))));
              d_Vsbstar_ac_dV_DI_SI = (d_Vsb_dV_DI_SI-(0.5*((d_temp_dV_DI_SI)-(deriv_sqrt_0_d0*((((temp)*(d_temp_dV_DI_SI))+((d_temp_dV_DI_SI)*(temp))))))));
              Vsbstar_ac = ((Vsb-(0.5*((temp)-value_sqrt_0)))+phix1_ac);
            }

            d_Vsbstar_dV_GP_SI = d_Vsbstar_ac_dV_GP_SI;
            d_Vsbstar_dV_SI_BP = d_Vsbstar_ac_dV_SI_BP;
            d_Vsbstar_dV_DI_SI = d_Vsbstar_ac_dV_DI_SI;
            Vsbstar = Vsbstar_ac;
            phib = phib_ac;
            G_0 = G_0_ac;
          }
          else
          {

            d_Vsbstar_dV_GP_SI =  0.0;
            d_Vsbstar_dV_SI_BP = d_Vsbstar_dc_tmp_dV_SI_BP;
            d_Vsbstar_dV_DI_SI = d_Vsbstar_dc_tmp_dV_DI_SI;
            Vsbstar = Vsbstar_dc_tmp;
            phib = phib_dc;
            G_0 = G_0_dc;
          }

          d_alpha_dV_DI_SI = d_alpha_dV_GP_SI = d_alpha_dV_SI_BP =  0.0;
          alpha = 0.0;

          d_GdL_dV_DI_SI = d_GdL_dV_GP_SI = d_GdL_dV_SI_BP =  0.0;
          GdL = 1.0;

          d_dL_dV_DI_SI = d_dL_dV_GP_SI = d_dL_dV_SI_BP =  0.0;
          dL = 0.0;

          d_qbm_dV_DI_SI = d_qbm_dV_GP_SI = d_qbm_dV_SI_BP =  0.0;
          qbm = 0.0;

          d_dps_dV_DI_SI = d_dps_dV_GP_SI = d_dps_dV_SI_BP =  0.0;
          dps = 0.0;

          d_qim_dV_GP_SI = d_qim_dV_DI_SI = d_qim_dV_SI_BP =  0.0;
          qim = 0.0;

          d_qim1_dV_GP_SI = d_qim1_dV_DI_SI = d_qim1_dV_SI_BP =  0.0;
          qim1 = 0.0;

          d_H_dV_GP_SI = d_H_dV_DI_SI = d_H_dV_SI_BP =  0.0;
          H = 1.0;

          d_s1_dV_DI_SI = d_s1_dV_GP_SI = d_s1_dV_SI_BP =  0.0;
          s1 = 0.0;

          d_eta_p_dV_DI_SI = d_eta_p_dV_GP_SI = d_eta_p_dV_SI_BP =  0.0;
          eta_p = 1.0;

          d_Gvsat_dV_DI_SI = d_Gvsat_dV_GP_SI = d_Gvsat_dV_SI_BP =  0.0;
          Gvsat = 1.0;

          d_Gvsatinv_dV_DI_SI = d_Gvsatinv_dV_GP_SI = d_Gvsatinv_dV_SI_BP =  0.0;
          Gvsatinv = 1.0;

          d_SP_S_x1_dV_DI_SI = d_SP_S_x1_dV_GP_SI = d_SP_S_x1_dV_SI_BP =  0.0;
          SP_S_x1 = 0.0;

          d_x_s_dV_DI_SI = d_x_s_dV_GP_SI = d_x_s_dV_SI_BP =  0.0;
          x_s = 0.0;

          d_sqm_dV_DI_SI = d_sqm_dV_GP_SI = d_sqm_dV_SI_BP =  0.0;
          sqm = 0.0;

          d_xitsb_dV_DI_SI = d_xitsb_dV_SI_BP = d_xitsb_dV_GP_SI =  0.0;
          xitsb = 0.0;

          d_rhob_dV_DI_SI = d_rhob_dV_SI_BP = d_rhob_dV_GP_SI =  0.0;
          rhob = 0.0;

          d_Gmob_dV_DI_SI = d_Gmob_dV_GP_SI = d_Gmob_dV_SI_BP =  0.0;
          Gmob = 1.0;

          d_Gmob_dL_dV_DI_SI = d_Gmob_dL_dV_GP_SI = d_Gmob_dL_dV_SI_BP =  0.0;
          Gmob_dL = 1.0;

          d_Udse_dV_GP_SI = d_Udse_dV_SI_BP = d_Udse_dV_DI_SI =  0.0;
          Udse = 0.0;

          d_thesat1_dV_GP_SI = d_thesat1_dV_DI_SI = d_thesat1_dV_SI_BP =  0.0;
          thesat1 = 0.0;

          d_xgm_dV_DI_SI = d_xgm_dV_GP_SI = d_xgm_dV_SI_BP =  0.0;
          xgm = 0.0;

          d_Vgbstar_dV_SI_BP = d_Vsbstar_dV_SI_BP;
          d_Vgbstar_dV_GP_SI = (d_Vgs_dV_GP_SI+d_Vsbstar_dV_GP_SI);
          d_Vgbstar_dV_DI_SI = (d_Vgs_dV_DI_SI+d_Vsbstar_dV_DI_SI);
          Vgbstar = (Vgs+Vsbstar);

          d_Vgb1_dV_SI_BP = d_Vgbstar_dV_SI_BP;
          d_Vgb1_dV_GP_SI = d_Vgbstar_dV_GP_SI;
          d_Vgb1_dV_DI_SI = d_Vgbstar_dV_DI_SI;
          Vgb1 = (Vgbstar-VFB_T);

          d_Vsbx_dV_GP_SI = d_Vsbstar_dV_GP_SI;
          d_Vsbx_dV_SI_BP = d_Vsbstar_dV_SI_BP;
          d_Vsbx_dV_DI_SI = (d_Vsbstar_dV_DI_SI+(0.5*(d_Vds_dV_DI_SI-d_Vdsx_dV_DI_SI)));
          Vsbx = (Vsbstar+(0.5*(Vds-Vdsx)));
          if ((CFD_i<1.0e-10))
          {

            d_Vdsp_dV_DI_SI = d_Vdsx_dV_DI_SI;
            Vdsp = Vdsx;
          }
          else
          {
            {
              double value_sqrt_0 = sqrt((1.0+(CFD_i*Vdsx)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_Vdsp_dV_DI_SI = ((2.0*(deriv_sqrt_0_d0*((CFD_i*d_Vdsx_dV_DI_SI))))/CFD_i);
              Vdsp = ((2.0*(value_sqrt_0-1.0))/CFD_i);
            }
          }

          d_delVg_dV_GP_SI = ((CF_i*Vdsp)*(CFB_i*d_Vsbx_dV_GP_SI));
          d_delVg_dV_SI_BP = ((CF_i*Vdsp)*(CFB_i*d_Vsbx_dV_SI_BP));
          d_delVg_dV_DI_SI = (((CF_i*Vdsp)*(CFB_i*d_Vsbx_dV_DI_SI))+((CF_i*d_Vdsp_dV_DI_SI)*(1.0+(CFB_i*Vsbx))));
          delVg = ((CF_i*Vdsp)*(1.0+(CFB_i*Vsbx)));

          d_dphit1_dV_GP_SI = ((PSCE_i*(1.0+(PSCED_i*Vdsx)))*(PSCEB_i*d_Vsbx_dV_GP_SI));
          d_dphit1_dV_SI_BP = ((PSCE_i*(1.0+(PSCED_i*Vdsx)))*(PSCEB_i*d_Vsbx_dV_SI_BP));
          d_dphit1_dV_DI_SI = (((PSCE_i*(1.0+(PSCED_i*Vdsx)))*(PSCEB_i*d_Vsbx_dV_DI_SI))+((PSCE_i*(PSCED_i*d_Vdsx_dV_DI_SI))*(1.0+(PSCEB_i*Vsbx))));
          dphit1 = ((PSCE_i*(1.0+(PSCED_i*Vdsx)))*(1.0+(PSCEB_i*Vsbx)));

          d_phit1_dV_SI_BP = (phit0*d_dphit1_dV_SI_BP);
          d_phit1_dV_DI_SI = (phit0*d_dphit1_dV_DI_SI);
          d_phit1_dV_GP_SI = (phit0*d_dphit1_dV_GP_SI);
          phit1 = (phit0*(1.0+dphit1));

          d_inv_phit1_dV_SI_BP = (-d_phit1_dV_SI_BP/phit1/phit1);
          d_inv_phit1_dV_DI_SI = (-d_phit1_dV_DI_SI/phit1/phit1);
          d_inv_phit1_dV_GP_SI = (-d_phit1_dV_GP_SI/phit1/phit1);
          inv_phit1 = (1.0/phit1);

          d_Vgb1_dV_SI_BP = (d_Vgb1_dV_SI_BP+d_delVg_dV_SI_BP);
          d_Vgb1_dV_GP_SI = (d_Vgb1_dV_GP_SI+d_delVg_dV_GP_SI);
          d_Vgb1_dV_DI_SI = (d_Vgb1_dV_DI_SI+d_delVg_dV_DI_SI);
          Vgb1 = (Vgb1+delVg);

          d_xg_dV_SI_BP = ((Vgb1*d_inv_phit1_dV_SI_BP)+(d_Vgb1_dV_SI_BP*inv_phit1));
          d_xg_dV_GP_SI = ((Vgb1*d_inv_phit1_dV_GP_SI)+(d_Vgb1_dV_GP_SI*inv_phit1));
          d_xg_dV_DI_SI = ((Vgb1*d_inv_phit1_dV_DI_SI)+(d_Vgb1_dV_DI_SI*inv_phit1));
          xg = (Vgb1*inv_phit1);
          if ((DNSUB_i>0.0))
          {
            {
              double value_sqrt_0 = sqrt((((-((Vgs+Vsb)-VNSUB_i))*(-((Vgs+Vsb)-VNSUB_i)))+NSLP_i));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_Dnsub_dV_SI_BP = ((DNSUB_i*0.5)*((+d_Vsb_dV_SI_BP)+(deriv_sqrt_0_d0*((((-((Vgs+Vsb)-VNSUB_i))*(-d_Vsb_dV_SI_BP))+((-d_Vsb_dV_SI_BP)*(-((Vgs+Vsb)-VNSUB_i))))))));
              d_Dnsub_dV_GP_SI = ((DNSUB_i*0.5)*((+d_Vgs_dV_GP_SI)+(deriv_sqrt_0_d0*((((-((Vgs+Vsb)-VNSUB_i))*(-d_Vgs_dV_GP_SI))+((-d_Vgs_dV_GP_SI)*(-((Vgs+Vsb)-VNSUB_i))))))));
              d_Dnsub_dV_DI_SI = ((DNSUB_i*0.5)*((+(d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI))+(deriv_sqrt_0_d0*((((-((Vgs+Vsb)-VNSUB_i))*(-(d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI)))+((-(d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI))*(-((Vgs+Vsb)-VNSUB_i))))))));
              Dnsub = ((DNSUB_i*0.5)*((+((Vgs+Vsb)-VNSUB_i))+value_sqrt_0));
            }
            {
              double value_sqrt_0 = sqrt((1.0+Dnsub));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_Gf_dV_SI_BP = (G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_SI_BP)));
              d_Gf_dV_GP_SI = (G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_GP_SI)));
              d_Gf_dV_DI_SI = (G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_DI_SI)));
              Gf = (G_0*value_sqrt_0);
            }
          }
          else
          {

            d_Gf_dV_DI_SI = d_Gf_dV_GP_SI = d_Gf_dV_SI_BP =  0.0;
            Gf = G_0;
          }

          d_Gf2_dV_SI_BP = ((Gf*d_Gf_dV_SI_BP)+(d_Gf_dV_SI_BP*Gf));
          d_Gf2_dV_GP_SI = ((Gf*d_Gf_dV_GP_SI)+(d_Gf_dV_GP_SI*Gf));
          d_Gf2_dV_DI_SI = ((Gf*d_Gf_dV_DI_SI)+(d_Gf_dV_DI_SI*Gf));
          Gf2 = (Gf*Gf);

          d_inv_Gf2_dV_SI_BP = (-d_Gf2_dV_SI_BP/Gf2/Gf2);
          d_inv_Gf2_dV_GP_SI = (-d_Gf2_dV_GP_SI/Gf2/Gf2);
          d_inv_Gf2_dV_DI_SI = (-d_Gf2_dV_DI_SI/Gf2/Gf2);
          inv_Gf2 = (1.0/Gf2);

          d_xi_dV_SI_BP = (d_Gf_dV_SI_BP*7.0710678118654746e-01);
          d_xi_dV_GP_SI = (d_Gf_dV_GP_SI*7.0710678118654746e-01);
          d_xi_dV_DI_SI = (d_Gf_dV_DI_SI*7.0710678118654746e-01);
          xi = (1.0+(Gf*7.0710678118654746e-01));

          d_inv_xi_dV_SI_BP = (-d_xi_dV_SI_BP/xi/xi);
          d_inv_xi_dV_GP_SI = (-d_xi_dV_GP_SI/xi/xi);
          d_inv_xi_dV_DI_SI = (-d_xi_dV_DI_SI/xi/xi);
          inv_xi = (1.0/xi);

          d_Ux_dV_GP_SI = ((Vsbstar*d_inv_phit1_dV_GP_SI)+(d_Vsbstar_dV_GP_SI*inv_phit1));
          d_Ux_dV_SI_BP = ((Vsbstar*d_inv_phit1_dV_SI_BP)+(d_Vsbstar_dV_SI_BP*inv_phit1));
          d_Ux_dV_DI_SI = ((Vsbstar*d_inv_phit1_dV_DI_SI)+(d_Vsbstar_dV_DI_SI*inv_phit1));
          Ux = (Vsbstar*inv_phit1);

          d_xn_s_dV_SI_BP = ((phib*d_inv_phit1_dV_SI_BP)+d_Ux_dV_SI_BP);
          d_xn_s_dV_DI_SI = ((phib*d_inv_phit1_dV_DI_SI)+d_Ux_dV_DI_SI);
          d_xn_s_dV_GP_SI = ((phib*d_inv_phit1_dV_GP_SI)+d_Ux_dV_GP_SI);
          xn_s = ((phib*inv_phit1)+Ux);
          if ((xn_s<4.6051701859880916e+02))
          {
            {
              double value_exp_0 = exp((-xn_s));
              double  deriv_exp_0_d0 = value_exp_0;

              d_delta_ns_dV_SI_BP = (deriv_exp_0_d0*((-d_xn_s_dV_SI_BP)));
              d_delta_ns_dV_DI_SI = (deriv_exp_0_d0*((-d_xn_s_dV_DI_SI)));
              d_delta_ns_dV_GP_SI = (deriv_exp_0_d0*((-d_xn_s_dV_GP_SI)));
              delta_ns = value_exp_0;
            }
          }
          else
          {

            d_delta_ns_dV_SI_BP = (-1.0e-200*(((xn_s-4.6051701859880916e+02)*(0.5*(((xn_s-4.6051701859880916e+02)*(d_xn_s_dV_SI_BP*3.3333333333333333e-01))+(d_xn_s_dV_SI_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_xn_s_dV_SI_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
            d_delta_ns_dV_DI_SI = (-1.0e-200*(((xn_s-4.6051701859880916e+02)*(0.5*(((xn_s-4.6051701859880916e+02)*(d_xn_s_dV_DI_SI*3.3333333333333333e-01))+(d_xn_s_dV_DI_SI*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_xn_s_dV_DI_SI*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
            d_delta_ns_dV_GP_SI = (-1.0e-200*(((xn_s-4.6051701859880916e+02)*(0.5*(((xn_s-4.6051701859880916e+02)*(d_xn_s_dV_GP_SI*3.3333333333333333e-01))+(d_xn_s_dV_GP_SI*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_xn_s_dV_GP_SI*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
            delta_ns = (1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
          }

          d_margin_dV_SI_BP = (1.0e-5*d_xi_dV_SI_BP);
          d_margin_dV_GP_SI = (1.0e-5*d_xi_dV_GP_SI);
          d_margin_dV_DI_SI = (1.0e-5*d_xi_dV_DI_SI);
          margin = (1.0e-5*xi);
          if ((fabs(xg)<=margin))
          {

            d_SP_S_temp1_dV_SI_BP = ((((inv_xi*d_inv_xi_dV_SI_BP)+(d_inv_xi_dV_SI_BP*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
            d_SP_S_temp1_dV_GP_SI = ((((inv_xi*d_inv_xi_dV_GP_SI)+(d_inv_xi_dV_GP_SI*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
            d_SP_S_temp1_dV_DI_SI = ((((inv_xi*d_inv_xi_dV_DI_SI)+(d_inv_xi_dV_DI_SI*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
            SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);

            d_x_s_dV_SI_BP = (((xg*inv_xi)*((((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_SI_BP)+((((xg*(1.0-delta_ns))*d_Gf_dV_SI_BP)+(((xg*(-d_delta_ns_dV_SI_BP))+(d_xg_dV_SI_BP*(1.0-delta_ns)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_SI_BP)+(d_xg_dV_SI_BP*inv_xi))*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1))));
            d_x_s_dV_GP_SI = (((xg*inv_xi)*((((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_GP_SI)+((((xg*(1.0-delta_ns))*d_Gf_dV_GP_SI)+(((xg*(-d_delta_ns_dV_GP_SI))+(d_xg_dV_GP_SI*(1.0-delta_ns)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_GP_SI)+(d_xg_dV_GP_SI*inv_xi))*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1))));
            d_x_s_dV_DI_SI = (((xg*inv_xi)*((((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_DI_SI)+((((xg*(1.0-delta_ns))*d_Gf_dV_DI_SI)+(((xg*(-d_delta_ns_dV_DI_SI))+(d_xg_dV_DI_SI*(1.0-delta_ns)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_DI_SI)+(d_xg_dV_DI_SI*inv_xi))*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1))));
            x_s = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
          }
          else
          {
            if ((xg<(-margin)))
            {

              d_SP_S_yg_dV_SI_BP = (-d_xg_dV_SI_BP);
              d_SP_S_yg_dV_GP_SI = (-d_xg_dV_GP_SI);
              d_SP_S_yg_dV_DI_SI = (-d_xg_dV_DI_SI);
              SP_S_yg = (-xg);

              d_SP_S_ysub_dV_SI_BP = (1.25*((SP_S_yg*d_inv_xi_dV_SI_BP)+(d_SP_S_yg_dV_SI_BP*inv_xi)));
              d_SP_S_ysub_dV_GP_SI = (1.25*((SP_S_yg*d_inv_xi_dV_GP_SI)+(d_SP_S_yg_dV_GP_SI*inv_xi)));
              d_SP_S_ysub_dV_DI_SI = (1.25*((SP_S_yg*d_inv_xi_dV_DI_SI)+(d_SP_S_yg_dV_DI_SI*inv_xi)));
              SP_S_ysub = (1.25*(SP_S_yg*inv_xi));
              {
                double value_sqrt_0 = sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_SP_S_eta_dV_SI_BP = (0.5*(d_SP_S_ysub_dV_SI_BP-(deriv_sqrt_0_d0*((((SP_S_ysub-6.0)*d_SP_S_ysub_dV_SI_BP)+(d_SP_S_ysub_dV_SI_BP*(SP_S_ysub-6.0)))))));
                d_SP_S_eta_dV_GP_SI = (0.5*(d_SP_S_ysub_dV_GP_SI-(deriv_sqrt_0_d0*((((SP_S_ysub-6.0)*d_SP_S_ysub_dV_GP_SI)+(d_SP_S_ysub_dV_GP_SI*(SP_S_ysub-6.0)))))));
                d_SP_S_eta_dV_DI_SI = (0.5*(d_SP_S_ysub_dV_DI_SI-(deriv_sqrt_0_d0*((((SP_S_ysub-6.0)*d_SP_S_ysub_dV_DI_SI)+(d_SP_S_ysub_dV_DI_SI*(SP_S_ysub-6.0)))))));
                SP_S_eta = (0.5*((SP_S_ysub+10)-value_sqrt_0));
              }

              d_SP_S_temp_dV_SI_BP = (d_SP_S_yg_dV_SI_BP-d_SP_S_eta_dV_SI_BP);
              d_SP_S_temp_dV_GP_SI = (d_SP_S_yg_dV_GP_SI-d_SP_S_eta_dV_GP_SI);
              d_SP_S_temp_dV_DI_SI = (d_SP_S_yg_dV_DI_SI-d_SP_S_eta_dV_DI_SI);
              SP_S_temp = (SP_S_yg-SP_S_eta);

              d_SP_S_a_dV_SI_BP = (((SP_S_temp*d_SP_S_temp_dV_SI_BP)+(d_SP_S_temp_dV_SI_BP*SP_S_temp))+((Gf2*d_SP_S_eta_dV_SI_BP)+(d_Gf2_dV_SI_BP*(SP_S_eta+1.0))));
              d_SP_S_a_dV_GP_SI = (((SP_S_temp*d_SP_S_temp_dV_GP_SI)+(d_SP_S_temp_dV_GP_SI*SP_S_temp))+((Gf2*d_SP_S_eta_dV_GP_SI)+(d_Gf2_dV_GP_SI*(SP_S_eta+1.0))));
              d_SP_S_a_dV_DI_SI = (((SP_S_temp*d_SP_S_temp_dV_DI_SI)+(d_SP_S_temp_dV_DI_SI*SP_S_temp))+((Gf2*d_SP_S_eta_dV_DI_SI)+(d_Gf2_dV_DI_SI*(SP_S_eta+1.0))));
              SP_S_a = ((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0)));

              d_SP_S_c_dV_SI_BP = ((2.0*d_SP_S_temp_dV_SI_BP)-d_Gf2_dV_SI_BP);
              d_SP_S_c_dV_GP_SI = ((2.0*d_SP_S_temp_dV_GP_SI)-d_Gf2_dV_GP_SI);
              d_SP_S_c_dV_DI_SI = ((2.0*d_SP_S_temp_dV_DI_SI)-d_Gf2_dV_DI_SI);
              SP_S_c = ((2.0*SP_S_temp)-Gf2);
              {
                double value_log_0 = log((SP_S_a*inv_Gf2));
                double  deriv_log_0_d0 = (1.0/(SP_S_a*inv_Gf2));

                d_SP_S_tau_dV_SI_BP = ((-d_SP_S_eta_dV_SI_BP)+(deriv_log_0_d0*(((SP_S_a*d_inv_Gf2_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*inv_Gf2)))));
                d_SP_S_tau_dV_GP_SI = ((-d_SP_S_eta_dV_GP_SI)+(deriv_log_0_d0*(((SP_S_a*d_inv_Gf2_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*inv_Gf2)))));
                d_SP_S_tau_dV_DI_SI = ((-d_SP_S_eta_dV_DI_SI)+(deriv_log_0_d0*(((SP_S_a*d_inv_Gf2_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*inv_Gf2)))));
                SP_S_tau = ((-SP_S_eta)+value_log_0);
              }

              d_nu_dV_SI_BP = (d_SP_S_a_dV_SI_BP+d_SP_S_c_dV_SI_BP);
              d_nu_dV_GP_SI = (d_SP_S_a_dV_GP_SI+d_SP_S_c_dV_GP_SI);
              d_nu_dV_DI_SI = (d_SP_S_a_dV_DI_SI+d_SP_S_c_dV_DI_SI);
              nu = (SP_S_a+SP_S_c);

              d_mutau_dV_SI_BP = (((nu*d_nu_dV_SI_BP)+(d_nu_dV_SI_BP*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_SI_BP)+(d_SP_S_c_dV_SI_BP*SP_S_c)))-d_SP_S_a_dV_SI_BP))+(d_SP_S_tau_dV_SI_BP*((0.5*(SP_S_c*SP_S_c))-SP_S_a))));
              d_mutau_dV_GP_SI = (((nu*d_nu_dV_GP_SI)+(d_nu_dV_GP_SI*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_GP_SI)+(d_SP_S_c_dV_GP_SI*SP_S_c)))-d_SP_S_a_dV_GP_SI))+(d_SP_S_tau_dV_GP_SI*((0.5*(SP_S_c*SP_S_c))-SP_S_a))));
              d_mutau_dV_DI_SI = (((nu*d_nu_dV_DI_SI)+(d_nu_dV_DI_SI*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_DI_SI)+(d_SP_S_c_dV_DI_SI*SP_S_c)))-d_SP_S_a_dV_DI_SI))+(d_SP_S_tau_dV_DI_SI*((0.5*(SP_S_c*SP_S_c))-SP_S_a))));
              mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));

              d_SP_S_y0_dV_SI_BP = (d_SP_S_eta_dV_SI_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*(((SP_S_a*nu)*d_SP_S_tau_dV_SI_BP)+(((SP_S_a*d_nu_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_SI_BP+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_SI_BP)+(d_SP_S_c_dV_SI_BP*SP_S_c))*3.3333333333333333e-01)-d_SP_S_a_dV_SI_BP))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_SI_BP)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_SI_BP)+((((nu/mutau)*d_SP_S_tau_dV_SI_BP)+(((mutau*d_nu_dV_SI_BP-nu*d_mutau_dV_SI_BP)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
              d_SP_S_y0_dV_GP_SI = (d_SP_S_eta_dV_GP_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*(((SP_S_a*nu)*d_SP_S_tau_dV_GP_SI)+(((SP_S_a*d_nu_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_SI+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_GP_SI)+(d_SP_S_c_dV_GP_SI*SP_S_c))*3.3333333333333333e-01)-d_SP_S_a_dV_GP_SI))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_SI)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_SI)+((((nu/mutau)*d_SP_S_tau_dV_GP_SI)+(((mutau*d_nu_dV_GP_SI-nu*d_mutau_dV_GP_SI)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
              d_SP_S_y0_dV_DI_SI = (d_SP_S_eta_dV_DI_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*(((SP_S_a*nu)*d_SP_S_tau_dV_DI_SI)+(((SP_S_a*d_nu_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_DI_SI+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_DI_SI)+(d_SP_S_c_dV_DI_SI*SP_S_c))*3.3333333333333333e-01)-d_SP_S_a_dV_DI_SI))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_DI_SI)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_DI_SI)+((((nu/mutau)*d_SP_S_tau_dV_DI_SI)+(((mutau*d_nu_dV_DI_SI-nu*d_mutau_dV_DI_SI)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
              SP_S_y0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
              if ((SP_S_y0<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(SP_S_y0);
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*(d_SP_S_y0_dV_SI_BP));
                  d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_y0_dV_GP_SI));
                  d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*(d_SP_S_y0_dV_DI_SI));
                  SP_S_delta0 = value_exp_0;
                }
              }
              else
              {

                d_SP_S_delta0_dV_SI_BP = (1.0e100*(((SP_S_y0-2.3025850929940458e+02)*(0.5*(((SP_S_y0-2.3025850929940458e+02)*(d_SP_S_y0_dV_SI_BP*3.3333333333333333e-01))+(d_SP_S_y0_dV_SI_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_y0_dV_SI_BP*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_SP_S_delta0_dV_GP_SI = (1.0e100*(((SP_S_y0-2.3025850929940458e+02)*(0.5*(((SP_S_y0-2.3025850929940458e+02)*(d_SP_S_y0_dV_GP_SI*3.3333333333333333e-01))+(d_SP_S_y0_dV_GP_SI*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_y0_dV_GP_SI*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_SP_S_delta0_dV_DI_SI = (1.0e100*(((SP_S_y0-2.3025850929940458e+02)*(0.5*(((SP_S_y0-2.3025850929940458e+02)*(d_SP_S_y0_dV_DI_SI*3.3333333333333333e-01))+(d_SP_S_y0_dV_DI_SI*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_y0_dV_DI_SI*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                SP_S_delta0 = (1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }

              d_SP_S_delta1_dV_SI_BP = (-d_SP_S_delta0_dV_SI_BP/SP_S_delta0/SP_S_delta0);
              d_SP_S_delta1_dV_GP_SI = (-d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
              d_SP_S_delta1_dV_DI_SI = (-d_SP_S_delta0_dV_DI_SI/SP_S_delta0/SP_S_delta0);
              SP_S_delta1 = (1.0/SP_S_delta0);

              d_SP_S_temp_dV_SI_BP = (-((SP_S_y0*d_SP_S_y0_dV_SI_BP)+(d_SP_S_y0_dV_SI_BP*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
              d_SP_S_temp_dV_GP_SI = (-((SP_S_y0*d_SP_S_y0_dV_GP_SI)+(d_SP_S_y0_dV_GP_SI*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
              d_SP_S_temp_dV_DI_SI = (-((SP_S_y0*d_SP_S_y0_dV_DI_SI)+(d_SP_S_y0_dV_DI_SI*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
              SP_S_temp = (1.0/(2.0+(SP_S_y0*SP_S_y0)));

              d_SP_S_xi0_dV_SI_BP = (((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_SI_BP)+(((SP_S_y0*d_SP_S_y0_dV_SI_BP)+(d_SP_S_y0_dV_SI_BP*SP_S_y0))*SP_S_temp));
              d_SP_S_xi0_dV_GP_SI = (((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_GP_SI)+(((SP_S_y0*d_SP_S_y0_dV_GP_SI)+(d_SP_S_y0_dV_GP_SI*SP_S_y0))*SP_S_temp));
              d_SP_S_xi0_dV_DI_SI = (((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_DI_SI)+(((SP_S_y0*d_SP_S_y0_dV_DI_SI)+(d_SP_S_y0_dV_DI_SI*SP_S_y0))*SP_S_temp));
              SP_S_xi0 = ((SP_S_y0*SP_S_y0)*SP_S_temp);

              d_SP_S_xi1_dV_SI_BP = (4.0*(((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_SI_BP)+(((SP_S_y0*d_SP_S_temp_dV_SI_BP)+(d_SP_S_y0_dV_SI_BP*SP_S_temp))*SP_S_temp)));
              d_SP_S_xi1_dV_GP_SI = (4.0*(((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_GP_SI)+(((SP_S_y0*d_SP_S_temp_dV_GP_SI)+(d_SP_S_y0_dV_GP_SI*SP_S_temp))*SP_S_temp)));
              d_SP_S_xi1_dV_DI_SI = (4.0*(((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_DI_SI)+(((SP_S_y0*d_SP_S_temp_dV_DI_SI)+(d_SP_S_y0_dV_DI_SI*SP_S_temp))*SP_S_temp)));
              SP_S_xi1 = (4.0*((SP_S_y0*SP_S_temp)*SP_S_temp));

              d_SP_S_xi2_dV_SI_BP = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_SI_BP)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_SI_BP)+(((8.0*d_SP_S_temp_dV_SI_BP)-(12.0*d_SP_S_xi0_dV_SI_BP))*SP_S_temp))*SP_S_temp));
              d_SP_S_xi2_dV_GP_SI = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_SI)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_SI)+(((8.0*d_SP_S_temp_dV_GP_SI)-(12.0*d_SP_S_xi0_dV_GP_SI))*SP_S_temp))*SP_S_temp));
              d_SP_S_xi2_dV_DI_SI = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_DI_SI)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_DI_SI)+(((8.0*d_SP_S_temp_dV_DI_SI)-(12.0*d_SP_S_xi0_dV_DI_SI))*SP_S_temp))*SP_S_temp));
              SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

              d_SP_S_temp_dV_SI_BP = (d_SP_S_yg_dV_SI_BP-d_SP_S_y0_dV_SI_BP);
              d_SP_S_temp_dV_GP_SI = (d_SP_S_yg_dV_GP_SI-d_SP_S_y0_dV_GP_SI);
              d_SP_S_temp_dV_DI_SI = (d_SP_S_yg_dV_DI_SI-d_SP_S_y0_dV_DI_SI);
              SP_S_temp = (SP_S_yg-SP_S_y0);

              d_SP_S_temp1_dV_SI_BP = ((delta_ns*d_SP_S_delta1_dV_SI_BP)+(d_delta_ns_dV_SI_BP*SP_S_delta1));
              d_SP_S_temp1_dV_DI_SI = ((delta_ns*d_SP_S_delta1_dV_DI_SI)+(d_delta_ns_dV_DI_SI*SP_S_delta1));
              d_SP_S_temp1_dV_GP_SI = ((delta_ns*d_SP_S_delta1_dV_GP_SI)+(d_delta_ns_dV_GP_SI*SP_S_delta1));
              SP_S_temp1 = (delta_ns*SP_S_delta1);

              d_SP_S_pC_dV_SI_BP = ((2.0*d_SP_S_temp_dV_SI_BP)+((Gf2*((d_SP_S_delta0_dV_SI_BP-d_SP_S_temp1_dV_SI_BP)+((delta_ns*(-d_SP_S_xi1_dV_SI_BP))+(d_delta_ns_dV_SI_BP*(1.0-SP_S_xi1)))))+(d_Gf2_dV_SI_BP*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1))))));
              d_SP_S_pC_dV_GP_SI = ((2.0*d_SP_S_temp_dV_GP_SI)+((Gf2*((d_SP_S_delta0_dV_GP_SI-d_SP_S_temp1_dV_GP_SI)+((delta_ns*(-d_SP_S_xi1_dV_GP_SI))+(d_delta_ns_dV_GP_SI*(1.0-SP_S_xi1)))))+(d_Gf2_dV_GP_SI*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1))))));
              d_SP_S_pC_dV_DI_SI = ((2.0*d_SP_S_temp_dV_DI_SI)+((Gf2*((d_SP_S_delta0_dV_DI_SI-d_SP_S_temp1_dV_DI_SI)+((delta_ns*(-d_SP_S_xi1_dV_DI_SI))+(d_delta_ns_dV_DI_SI*(1.0-SP_S_xi1)))))+(d_Gf2_dV_DI_SI*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1))))));
              SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));

              d_SP_S_qC_dV_SI_BP = (((SP_S_temp*d_SP_S_temp_dV_SI_BP)+(d_SP_S_temp_dV_SI_BP*SP_S_temp))-((Gf2*(((d_SP_S_delta0_dV_SI_BP-d_SP_S_y0_dV_SI_BP)+d_SP_S_temp1_dV_SI_BP)+((delta_ns*(d_SP_S_y0_dV_SI_BP-d_SP_S_xi0_dV_SI_BP))+(d_delta_ns_dV_SI_BP*((SP_S_y0-1.0)-SP_S_xi0)))))+(d_Gf2_dV_SI_BP*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0))))));
              d_SP_S_qC_dV_GP_SI = (((SP_S_temp*d_SP_S_temp_dV_GP_SI)+(d_SP_S_temp_dV_GP_SI*SP_S_temp))-((Gf2*(((d_SP_S_delta0_dV_GP_SI-d_SP_S_y0_dV_GP_SI)+d_SP_S_temp1_dV_GP_SI)+((delta_ns*(d_SP_S_y0_dV_GP_SI-d_SP_S_xi0_dV_GP_SI))+(d_delta_ns_dV_GP_SI*((SP_S_y0-1.0)-SP_S_xi0)))))+(d_Gf2_dV_GP_SI*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0))))));
              d_SP_S_qC_dV_DI_SI = (((SP_S_temp*d_SP_S_temp_dV_DI_SI)+(d_SP_S_temp_dV_DI_SI*SP_S_temp))-((Gf2*(((d_SP_S_delta0_dV_DI_SI-d_SP_S_y0_dV_DI_SI)+d_SP_S_temp1_dV_DI_SI)+((delta_ns*(d_SP_S_y0_dV_DI_SI-d_SP_S_xi0_dV_DI_SI))+(d_delta_ns_dV_DI_SI*((SP_S_y0-1.0)-SP_S_xi0)))))+(d_Gf2_dV_DI_SI*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0))))));
              SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));

              d_SP_S_temp_dV_SI_BP = (-((Gf2*((d_SP_S_delta0_dV_SI_BP+d_SP_S_temp1_dV_SI_BP)-((delta_ns*d_SP_S_xi2_dV_SI_BP)+(d_delta_ns_dV_SI_BP*SP_S_xi2))))+(d_Gf2_dV_SI_BP*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2)))));
              d_SP_S_temp_dV_GP_SI = (-((Gf2*((d_SP_S_delta0_dV_GP_SI+d_SP_S_temp1_dV_GP_SI)-((delta_ns*d_SP_S_xi2_dV_GP_SI)+(d_delta_ns_dV_GP_SI*SP_S_xi2))))+(d_Gf2_dV_GP_SI*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2)))));
              d_SP_S_temp_dV_DI_SI = (-((Gf2*((d_SP_S_delta0_dV_DI_SI+d_SP_S_temp1_dV_DI_SI)-((delta_ns*d_SP_S_xi2_dV_DI_SI)+(d_delta_ns_dV_DI_SI*SP_S_xi2))))+(d_Gf2_dV_DI_SI*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2)))));
              SP_S_temp = (2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));

              d_SP_S_temp_dV_SI_BP = (((SP_S_pC*d_SP_S_pC_dV_SI_BP)+(d_SP_S_pC_dV_SI_BP*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_SI_BP)+(d_SP_S_qC_dV_SI_BP*SP_S_temp))));
              d_SP_S_temp_dV_GP_SI = (((SP_S_pC*d_SP_S_pC_dV_GP_SI)+(d_SP_S_pC_dV_GP_SI*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_GP_SI)+(d_SP_S_qC_dV_GP_SI*SP_S_temp))));
              d_SP_S_temp_dV_DI_SI = (((SP_S_pC*d_SP_S_pC_dV_DI_SI)+(d_SP_S_pC_dV_DI_SI*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_DI_SI)+(d_SP_S_qC_dV_DI_SI*SP_S_temp))));
              SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
              {
                double value_sqrt_0 = sqrt(SP_S_temp);
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_x_s_dV_SI_BP = ((-d_SP_S_y0_dV_SI_BP)-(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_SI_BP-SP_S_qC*(d_SP_S_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_SI_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
                d_x_s_dV_GP_SI = ((-d_SP_S_y0_dV_GP_SI)-(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_SI-SP_S_qC*(d_SP_S_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
                d_x_s_dV_DI_SI = ((-d_SP_S_y0_dV_DI_SI)-(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_DI_SI-SP_S_qC*(d_SP_S_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_DI_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
                x_s = ((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
              }
            }
            else
            {

              d_SP_xg1_dV_SI_BP = (-(d_Gf_dV_SI_BP*7.324648775608221e-001)/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
              d_SP_xg1_dV_GP_SI = (-(d_Gf_dV_GP_SI*7.324648775608221e-001)/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
              d_SP_xg1_dV_DI_SI = (-(d_Gf_dV_DI_SI*7.324648775608221e-001)/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
              SP_xg1 = (1.0/(1.25+(Gf*7.324648775608221e-001)));

              d_SP_S_A_fac_dV_SI_BP = (((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dV_SI_BP)+((((xi*1.25)*d_SP_xg1_dV_SI_BP)+((d_xi_dV_SI_BP*1.25)*SP_xg1))*SP_xg1));
              d_SP_S_A_fac_dV_GP_SI = (((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dV_GP_SI)+((((xi*1.25)*d_SP_xg1_dV_GP_SI)+((d_xi_dV_GP_SI*1.25)*SP_xg1))*SP_xg1));
              d_SP_S_A_fac_dV_DI_SI = (((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dV_DI_SI)+((((xi*1.25)*d_SP_xg1_dV_DI_SI)+((d_xi_dV_DI_SI*1.25)*SP_xg1))*SP_xg1));
              SP_S_A_fac = ((((xi*1.25)*SP_xg1)-1.0)*SP_xg1);

              d_SP_S_xbar_dV_SI_BP = (((xg*inv_xi)*((SP_S_A_fac*d_xg_dV_SI_BP)+(d_SP_S_A_fac_dV_SI_BP*xg)))+(((xg*d_inv_xi_dV_SI_BP)+(d_xg_dV_SI_BP*inv_xi))*(1.0+(SP_S_A_fac*xg))));
              d_SP_S_xbar_dV_GP_SI = (((xg*inv_xi)*((SP_S_A_fac*d_xg_dV_GP_SI)+(d_SP_S_A_fac_dV_GP_SI*xg)))+(((xg*d_inv_xi_dV_GP_SI)+(d_xg_dV_GP_SI*inv_xi))*(1.0+(SP_S_A_fac*xg))));
              d_SP_S_xbar_dV_DI_SI = (((xg*inv_xi)*((SP_S_A_fac*d_xg_dV_DI_SI)+(d_SP_S_A_fac_dV_DI_SI*xg)))+(((xg*d_inv_xi_dV_DI_SI)+(d_xg_dV_DI_SI*inv_xi))*(1.0+(SP_S_A_fac*xg))));
              SP_S_xbar = ((xg*inv_xi)*(1.0+(SP_S_A_fac*xg)));
              if (((-SP_S_xbar)>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp((-SP_S_xbar));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_SP_S_temp_dV_SI_BP = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_SI_BP)));
                  d_SP_S_temp_dV_GP_SI = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_GP_SI)));
                  d_SP_S_temp_dV_DI_SI = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_DI_SI)));
                  SP_S_temp = value_exp_0;
                }
              }
              else
              {

                d_SP_S_temp_dV_SI_BP = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*((((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-d_SP_S_xbar_dV_SI_BP))*3.3333333333333333e-01))+((-(-d_SP_S_xbar_dV_SI_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+((-(-d_SP_S_xbar_dV_SI_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
                d_SP_S_temp_dV_GP_SI = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*((((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-d_SP_S_xbar_dV_GP_SI))*3.3333333333333333e-01))+((-(-d_SP_S_xbar_dV_GP_SI))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+((-(-d_SP_S_xbar_dV_GP_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
                d_SP_S_temp_dV_DI_SI = (-1.0e-100*((((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*((((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-d_SP_S_xbar_dV_DI_SI))*3.3333333333333333e-01))+((-(-d_SP_S_xbar_dV_DI_SI))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+((-(-d_SP_S_xbar_dV_DI_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
                SP_S_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
              }

              d_SP_S_w_dV_SI_BP = (-d_SP_S_temp_dV_SI_BP);
              d_SP_S_w_dV_GP_SI = (-d_SP_S_temp_dV_GP_SI);
              d_SP_S_w_dV_DI_SI = (-d_SP_S_temp_dV_DI_SI);
              SP_S_w = (1.0-SP_S_temp);
              {
                double value_sqrt_0 = sqrt(((xg+(Gf2*0.25))-SP_S_w));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_SP_S_x1_dV_SI_BP = ((d_xg_dV_SI_BP+(d_Gf2_dV_SI_BP*0.5))-((Gf*(deriv_sqrt_0_d0*(((d_xg_dV_SI_BP+(d_Gf2_dV_SI_BP*0.25))-d_SP_S_w_dV_SI_BP))))+(d_Gf_dV_SI_BP*value_sqrt_0)));
                d_SP_S_x1_dV_GP_SI = ((d_xg_dV_GP_SI+(d_Gf2_dV_GP_SI*0.5))-((Gf*(deriv_sqrt_0_d0*(((d_xg_dV_GP_SI+(d_Gf2_dV_GP_SI*0.25))-d_SP_S_w_dV_GP_SI))))+(d_Gf_dV_GP_SI*value_sqrt_0)));
                d_SP_S_x1_dV_DI_SI = ((d_xg_dV_DI_SI+(d_Gf2_dV_DI_SI*0.5))-((Gf*(deriv_sqrt_0_d0*(((d_xg_dV_DI_SI+(d_Gf2_dV_DI_SI*0.25))-d_SP_S_w_dV_DI_SI))))+(d_Gf_dV_DI_SI*value_sqrt_0)));
                SP_S_x1 = ((xg+(Gf2*0.5))-(Gf*value_sqrt_0));
              }

              d_SP_S_bx_dV_SI_BP = d_xn_s_dV_SI_BP;
              d_SP_S_bx_dV_DI_SI = d_xn_s_dV_DI_SI;
              d_SP_S_bx_dV_GP_SI = d_xn_s_dV_GP_SI;
              SP_S_bx = (xn_s+3.0);
              {
                double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
                double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_SP_S_eta_dV_SI_BP = ((0.5*((d_SP_S_x1_dV_SI_BP+d_SP_S_bx_dV_SI_BP)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP))+((d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_SI_BP-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_SI_BP)+(d_SP_S_bx_dV_SI_BP*SP_S_bx)))))));
                d_SP_S_eta_dV_GP_SI = ((0.5*((d_SP_S_x1_dV_GP_SI+d_SP_S_bx_dV_GP_SI)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI))+((d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_GP_SI-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_GP_SI)+(d_SP_S_bx_dV_GP_SI*SP_S_bx)))))));
                d_SP_S_eta_dV_DI_SI = ((0.5*((d_SP_S_x1_dV_DI_SI+d_SP_S_bx_dV_DI_SI)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI))+((d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_DI_SI-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_DI_SI)+(d_SP_S_bx_dV_DI_SI*SP_S_bx)))))));
                SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
              }

              d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_eta_dV_SI_BP);
              d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_eta_dV_GP_SI);
              d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_eta_dV_DI_SI);
              SP_S_temp = (xg-SP_S_eta);
              {
                double value_exp_0 = exp((-SP_S_eta));
                double  deriv_exp_0_d0 = value_exp_0;

                d_SP_S_temp1_dV_SI_BP = (deriv_exp_0_d0*((-d_SP_S_eta_dV_SI_BP)));
                d_SP_S_temp1_dV_GP_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_GP_SI)));
                d_SP_S_temp1_dV_DI_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_DI_SI)));
                SP_S_temp1 = value_exp_0;
              }

              d_SP_S_temp2_dV_SI_BP = (-((SP_S_eta*d_SP_S_eta_dV_SI_BP)+(d_SP_S_eta_dV_SI_BP*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
              d_SP_S_temp2_dV_GP_SI = (-((SP_S_eta*d_SP_S_eta_dV_GP_SI)+(d_SP_S_eta_dV_GP_SI*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
              d_SP_S_temp2_dV_DI_SI = (-((SP_S_eta*d_SP_S_eta_dV_DI_SI)+(d_SP_S_eta_dV_DI_SI*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
              SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));

              d_SP_S_xi0_dV_SI_BP = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_SI_BP)+(((SP_S_eta*d_SP_S_eta_dV_SI_BP)+(d_SP_S_eta_dV_SI_BP*SP_S_eta))*SP_S_temp2));
              d_SP_S_xi0_dV_GP_SI = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_GP_SI)+(((SP_S_eta*d_SP_S_eta_dV_GP_SI)+(d_SP_S_eta_dV_GP_SI*SP_S_eta))*SP_S_temp2));
              d_SP_S_xi0_dV_DI_SI = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_DI_SI)+(((SP_S_eta*d_SP_S_eta_dV_DI_SI)+(d_SP_S_eta_dV_DI_SI*SP_S_eta))*SP_S_temp2));
              SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);

              d_SP_S_xi1_dV_SI_BP = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP)+(((SP_S_eta*d_SP_S_temp2_dV_SI_BP)+(d_SP_S_eta_dV_SI_BP*SP_S_temp2))*SP_S_temp2)));
              d_SP_S_xi1_dV_GP_SI = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI)+(((SP_S_eta*d_SP_S_temp2_dV_GP_SI)+(d_SP_S_eta_dV_GP_SI*SP_S_temp2))*SP_S_temp2)));
              d_SP_S_xi1_dV_DI_SI = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI)+(((SP_S_eta*d_SP_S_temp2_dV_DI_SI)+(d_SP_S_eta_dV_DI_SI*SP_S_temp2))*SP_S_temp2)));
              SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));

              d_SP_S_xi2_dV_SI_BP = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_SI_BP)+(((8.0*d_SP_S_temp2_dV_SI_BP)-(12.0*d_SP_S_xi0_dV_SI_BP))*SP_S_temp2))*SP_S_temp2));
              d_SP_S_xi2_dV_GP_SI = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_GP_SI)+(((8.0*d_SP_S_temp2_dV_GP_SI)-(12.0*d_SP_S_xi0_dV_GP_SI))*SP_S_temp2))*SP_S_temp2));
              d_SP_S_xi2_dV_DI_SI = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_DI_SI)+(((8.0*d_SP_S_temp2_dV_DI_SI)-(12.0*d_SP_S_xi0_dV_DI_SI))*SP_S_temp2))*SP_S_temp2));
              SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
              {
                double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))));
                double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);

                d_SP_S_a_dV_SI_BP = 0.0;
                d_SP_S_a_dV_GP_SI = 0.0;
                d_SP_S_a_dV_DI_SI = 0.0;
                SP_S_a = value_max_0;
              }

              d_SP_S_b_dV_SI_BP = (-(0.5*((Gf2*(d_SP_S_temp1_dV_SI_BP-((delta_ns*d_SP_S_xi2_dV_SI_BP)+(d_delta_ns_dV_SI_BP*SP_S_xi2))))+(d_Gf2_dV_SI_BP*(SP_S_temp1-(delta_ns*SP_S_xi2))))));
              d_SP_S_b_dV_GP_SI = (-(0.5*((Gf2*(d_SP_S_temp1_dV_GP_SI-((delta_ns*d_SP_S_xi2_dV_GP_SI)+(d_delta_ns_dV_GP_SI*SP_S_xi2))))+(d_Gf2_dV_GP_SI*(SP_S_temp1-(delta_ns*SP_S_xi2))))));
              d_SP_S_b_dV_DI_SI = (-(0.5*((Gf2*(d_SP_S_temp1_dV_DI_SI-((delta_ns*d_SP_S_xi2_dV_DI_SI)+(d_delta_ns_dV_DI_SI*SP_S_xi2))))+(d_Gf2_dV_DI_SI*(SP_S_temp1-(delta_ns*SP_S_xi2))))));
              SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))));

              d_SP_S_c_dV_SI_BP = ((2.0*d_SP_S_temp_dV_SI_BP)+((Gf2*((-d_SP_S_temp1_dV_SI_BP)-((delta_ns*d_SP_S_xi1_dV_SI_BP)+(d_delta_ns_dV_SI_BP*(1.0+SP_S_xi1)))))+(d_Gf2_dV_SI_BP*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1))))));
              d_SP_S_c_dV_GP_SI = ((2.0*d_SP_S_temp_dV_GP_SI)+((Gf2*((-d_SP_S_temp1_dV_GP_SI)-((delta_ns*d_SP_S_xi1_dV_GP_SI)+(d_delta_ns_dV_GP_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_GP_SI*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1))))));
              d_SP_S_c_dV_DI_SI = ((2.0*d_SP_S_temp_dV_DI_SI)+((Gf2*((-d_SP_S_temp1_dV_DI_SI)-((delta_ns*d_SP_S_xi1_dV_DI_SI)+(d_delta_ns_dV_DI_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_DI_SI*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1))))));
              SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
              {
                double value_log_0 = log((SP_S_a/Gf2));
                double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));

                d_SP_S_tau_dV_SI_BP = ((d_xn_s_dV_SI_BP-d_SP_S_eta_dV_SI_BP)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_SI_BP-SP_S_a*d_Gf2_dV_SI_BP)/Gf2/Gf2))));
                d_SP_S_tau_dV_DI_SI = ((d_xn_s_dV_DI_SI-d_SP_S_eta_dV_DI_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_DI_SI-SP_S_a*d_Gf2_dV_DI_SI)/Gf2/Gf2))));
                d_SP_S_tau_dV_GP_SI = ((d_xn_s_dV_GP_SI-d_SP_S_eta_dV_GP_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_GP_SI-SP_S_a*d_Gf2_dV_GP_SI)/Gf2/Gf2))));
                SP_S_tau = ((xn_s-SP_S_eta)+value_log_0);
              }

              d_nu_dV_SI_BP = (d_SP_S_a_dV_SI_BP+d_SP_S_c_dV_SI_BP);
              d_nu_dV_GP_SI = (d_SP_S_a_dV_GP_SI+d_SP_S_c_dV_GP_SI);
              d_nu_dV_DI_SI = (d_SP_S_a_dV_DI_SI+d_SP_S_c_dV_DI_SI);
              nu = (SP_S_a+SP_S_c);

              d_mutau_dV_SI_BP = (((nu*d_nu_dV_SI_BP)+(d_nu_dV_SI_BP*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_SI_BP)+(d_SP_S_c_dV_SI_BP*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*SP_S_b))))+(d_SP_S_tau_dV_SI_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
              d_mutau_dV_GP_SI = (((nu*d_nu_dV_GP_SI)+(d_nu_dV_GP_SI*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_GP_SI)+(d_SP_S_c_dV_GP_SI*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*SP_S_b))))+(d_SP_S_tau_dV_GP_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
              d_mutau_dV_DI_SI = (((nu*d_nu_dV_DI_SI)+(d_nu_dV_DI_SI*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_DI_SI)+(d_SP_S_c_dV_DI_SI*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*SP_S_b))))+(d_SP_S_tau_dV_DI_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
              mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));

              d_SP_S_x0_dV_SI_BP = (d_SP_S_eta_dV_SI_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_SI_BP)+(((SP_S_a*d_nu_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_SI_BP+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_SI_BP)+(d_SP_S_c_dV_SI_BP*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_SI_BP)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_SI_BP)+((((nu/mutau)*d_SP_S_tau_dV_SI_BP)+(((mutau*d_nu_dV_SI_BP-nu*d_mutau_dV_SI_BP)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
              d_SP_S_x0_dV_GP_SI = (d_SP_S_eta_dV_GP_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_GP_SI)+(((SP_S_a*d_nu_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_SI+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_GP_SI)+(d_SP_S_c_dV_GP_SI*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_SI)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_SI)+((((nu/mutau)*d_SP_S_tau_dV_GP_SI)+(((mutau*d_nu_dV_GP_SI-nu*d_mutau_dV_GP_SI)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
              d_SP_S_x0_dV_DI_SI = (d_SP_S_eta_dV_DI_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_DI_SI)+(((SP_S_a*d_nu_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_DI_SI+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_DI_SI)+(d_SP_S_c_dV_DI_SI*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_DI_SI)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_DI_SI)+((((nu/mutau)*d_SP_S_tau_dV_DI_SI)+(((mutau*d_nu_dV_DI_SI-nu*d_mutau_dV_DI_SI)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
              SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
              if ((SP_S_x0<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(SP_S_x0);
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*(d_SP_S_x0_dV_SI_BP));
                  d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_SI));
                  d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_DI_SI));
                  SP_S_delta0 = value_exp_0;
                }

                d_SP_S_delta1_dV_SI_BP = (-d_SP_S_delta0_dV_SI_BP/SP_S_delta0/SP_S_delta0);
                d_SP_S_delta1_dV_GP_SI = (-d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
                d_SP_S_delta1_dV_DI_SI = (-d_SP_S_delta0_dV_DI_SI/SP_S_delta0/SP_S_delta0);
                SP_S_delta1 = (1.0/SP_S_delta0);

                d_SP_S_delta0_dV_SI_BP = ((delta_ns*d_SP_S_delta0_dV_SI_BP)+(d_delta_ns_dV_SI_BP*SP_S_delta0));
                d_SP_S_delta0_dV_DI_SI = ((delta_ns*d_SP_S_delta0_dV_DI_SI)+(d_delta_ns_dV_DI_SI*SP_S_delta0));
                d_SP_S_delta0_dV_GP_SI = ((delta_ns*d_SP_S_delta0_dV_GP_SI)+(d_delta_ns_dV_GP_SI*SP_S_delta0));
                SP_S_delta0 = (delta_ns*SP_S_delta0);
              }
              else
              {
                if ((SP_S_x0>(xn_s-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp((SP_S_x0-xn_s));
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*((d_SP_S_x0_dV_SI_BP-d_xn_s_dV_SI_BP)));
                    d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_GP_SI-d_xn_s_dV_GP_SI)));
                    d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_DI_SI-d_xn_s_dV_DI_SI)));
                    SP_S_delta0 = value_exp_0;
                  }

                  d_SP_S_delta1_dV_SI_BP = ((SP_S_delta0*d_delta_ns_dV_SI_BP-delta_ns*d_SP_S_delta0_dV_SI_BP)/SP_S_delta0/SP_S_delta0);
                  d_SP_S_delta1_dV_DI_SI = ((SP_S_delta0*d_delta_ns_dV_DI_SI-delta_ns*d_SP_S_delta0_dV_DI_SI)/SP_S_delta0/SP_S_delta0);
                  d_SP_S_delta1_dV_GP_SI = ((SP_S_delta0*d_delta_ns_dV_GP_SI-delta_ns*d_SP_S_delta0_dV_GP_SI)/SP_S_delta0/SP_S_delta0);
                  SP_S_delta1 = (delta_ns/SP_S_delta0);
                }
                else
                {

                  d_SP_S_delta0_dV_SI_BP = (-1.0e-100*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*((d_xn_s_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*3.3333333333333333e-01))+((d_xn_s_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_SP_S_delta0_dV_DI_SI = (-1.0e-100*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*((d_xn_s_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*3.3333333333333333e-01))+((d_xn_s_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_SP_S_delta0_dV_GP_SI = (-1.0e-100*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_s-SP_S_x0)-2.3025850929940458e+02)*((d_xn_s_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*3.3333333333333333e-01))+((d_xn_s_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  SP_S_delta0 = (1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

                  d_SP_S_delta1_dV_SI_BP = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_SI_BP*3.3333333333333333e-01))+(d_SP_S_x0_dV_SI_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_SI_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_SP_S_delta1_dV_GP_SI = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_GP_SI*3.3333333333333333e-01))+(d_SP_S_x0_dV_GP_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_GP_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_SP_S_delta1_dV_DI_SI = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_DI_SI*3.3333333333333333e-01))+(d_SP_S_x0_dV_DI_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_DI_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_SP_S_temp_dV_SI_BP = (-((SP_S_x0*d_SP_S_x0_dV_SI_BP)+(d_SP_S_x0_dV_SI_BP*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
              d_SP_S_temp_dV_GP_SI = (-((SP_S_x0*d_SP_S_x0_dV_GP_SI)+(d_SP_S_x0_dV_GP_SI*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
              d_SP_S_temp_dV_DI_SI = (-((SP_S_x0*d_SP_S_x0_dV_DI_SI)+(d_SP_S_x0_dV_DI_SI*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
              SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));

              d_SP_S_xi0_dV_SI_BP = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_SI_BP)+(((SP_S_x0*d_SP_S_x0_dV_SI_BP)+(d_SP_S_x0_dV_SI_BP*SP_S_x0))*SP_S_temp));
              d_SP_S_xi0_dV_GP_SI = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_GP_SI)+(((SP_S_x0*d_SP_S_x0_dV_GP_SI)+(d_SP_S_x0_dV_GP_SI*SP_S_x0))*SP_S_temp));
              d_SP_S_xi0_dV_DI_SI = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_DI_SI)+(((SP_S_x0*d_SP_S_x0_dV_DI_SI)+(d_SP_S_x0_dV_DI_SI*SP_S_x0))*SP_S_temp));
              SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);

              d_SP_S_xi1_dV_SI_BP = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_SI_BP)+(((SP_S_x0*d_SP_S_temp_dV_SI_BP)+(d_SP_S_x0_dV_SI_BP*SP_S_temp))*SP_S_temp)));
              d_SP_S_xi1_dV_GP_SI = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_GP_SI)+(((SP_S_x0*d_SP_S_temp_dV_GP_SI)+(d_SP_S_x0_dV_GP_SI*SP_S_temp))*SP_S_temp)));
              d_SP_S_xi1_dV_DI_SI = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_DI_SI)+(((SP_S_x0*d_SP_S_temp_dV_DI_SI)+(d_SP_S_x0_dV_DI_SI*SP_S_temp))*SP_S_temp)));
              SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));

              d_SP_S_xi2_dV_SI_BP = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_SI_BP)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_SI_BP)+(((8.0*d_SP_S_temp_dV_SI_BP)-(12.0*d_SP_S_xi0_dV_SI_BP))*SP_S_temp))*SP_S_temp));
              d_SP_S_xi2_dV_GP_SI = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_SI)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_SI)+(((8.0*d_SP_S_temp_dV_GP_SI)-(12.0*d_SP_S_xi0_dV_GP_SI))*SP_S_temp))*SP_S_temp));
              d_SP_S_xi2_dV_DI_SI = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_DI_SI)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_DI_SI)+(((8.0*d_SP_S_temp_dV_DI_SI)-(12.0*d_SP_S_xi0_dV_DI_SI))*SP_S_temp))*SP_S_temp));
              SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

              d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_x0_dV_SI_BP);
              d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_x0_dV_GP_SI);
              d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_x0_dV_DI_SI);
              SP_S_temp = (xg-SP_S_x0);

              d_SP_S_pC_dV_SI_BP = ((2.0*d_SP_S_temp_dV_SI_BP)+((Gf2*(((-d_SP_S_delta1_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-((delta_ns*d_SP_S_xi1_dV_SI_BP)+(d_delta_ns_dV_SI_BP*(1.0+SP_S_xi1)))))+(d_Gf2_dV_SI_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1))))));
              d_SP_S_pC_dV_GP_SI = ((2.0*d_SP_S_temp_dV_GP_SI)+((Gf2*(((-d_SP_S_delta1_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-((delta_ns*d_SP_S_xi1_dV_GP_SI)+(d_delta_ns_dV_GP_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_GP_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1))))));
              d_SP_S_pC_dV_DI_SI = ((2.0*d_SP_S_temp_dV_DI_SI)+((Gf2*(((-d_SP_S_delta1_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-((delta_ns*d_SP_S_xi1_dV_DI_SI)+(d_delta_ns_dV_DI_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_DI_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1))))));
              SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));

              d_SP_S_qC_dV_SI_BP = (((SP_S_temp*d_SP_S_temp_dV_SI_BP)+(d_SP_S_temp_dV_SI_BP*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_SI_BP+d_SP_S_x0_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-((delta_ns*(d_SP_S_x0_dV_SI_BP+d_SP_S_xi0_dV_SI_BP))+(d_delta_ns_dV_SI_BP*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_SI_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0))))));
              d_SP_S_qC_dV_GP_SI = (((SP_S_temp*d_SP_S_temp_dV_GP_SI)+(d_SP_S_temp_dV_GP_SI*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_GP_SI+d_SP_S_x0_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-((delta_ns*(d_SP_S_x0_dV_GP_SI+d_SP_S_xi0_dV_GP_SI))+(d_delta_ns_dV_GP_SI*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_GP_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0))))));
              d_SP_S_qC_dV_DI_SI = (((SP_S_temp*d_SP_S_temp_dV_DI_SI)+(d_SP_S_temp_dV_DI_SI*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_DI_SI+d_SP_S_x0_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-((delta_ns*(d_SP_S_x0_dV_DI_SI+d_SP_S_xi0_dV_DI_SI))+(d_delta_ns_dV_DI_SI*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_DI_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0))))));
              SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));

              d_SP_S_temp_dV_SI_BP = (-((Gf2*((d_SP_S_delta1_dV_SI_BP+d_SP_S_delta0_dV_SI_BP)-((delta_ns*d_SP_S_xi2_dV_SI_BP)+(d_delta_ns_dV_SI_BP*SP_S_xi2))))+(d_Gf2_dV_SI_BP*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2)))));
              d_SP_S_temp_dV_GP_SI = (-((Gf2*((d_SP_S_delta1_dV_GP_SI+d_SP_S_delta0_dV_GP_SI)-((delta_ns*d_SP_S_xi2_dV_GP_SI)+(d_delta_ns_dV_GP_SI*SP_S_xi2))))+(d_Gf2_dV_GP_SI*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2)))));
              d_SP_S_temp_dV_DI_SI = (-((Gf2*((d_SP_S_delta1_dV_DI_SI+d_SP_S_delta0_dV_DI_SI)-((delta_ns*d_SP_S_xi2_dV_DI_SI)+(d_delta_ns_dV_DI_SI*SP_S_xi2))))+(d_Gf2_dV_DI_SI*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2)))));
              SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));

              d_SP_S_temp_dV_SI_BP = (((SP_S_pC*d_SP_S_pC_dV_SI_BP)+(d_SP_S_pC_dV_SI_BP*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_SI_BP)+(d_SP_S_qC_dV_SI_BP*SP_S_temp))));
              d_SP_S_temp_dV_GP_SI = (((SP_S_pC*d_SP_S_pC_dV_GP_SI)+(d_SP_S_pC_dV_GP_SI*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_GP_SI)+(d_SP_S_qC_dV_GP_SI*SP_S_temp))));
              d_SP_S_temp_dV_DI_SI = (((SP_S_pC*d_SP_S_pC_dV_DI_SI)+(d_SP_S_pC_dV_DI_SI*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_DI_SI)+(d_SP_S_qC_dV_DI_SI*SP_S_temp))));
              SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
              {
                double value_sqrt_0 = sqrt(SP_S_temp);
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_x_s_dV_SI_BP = (d_SP_S_x0_dV_SI_BP+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_SI_BP-SP_S_qC*(d_SP_S_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_SI_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
                d_x_s_dV_GP_SI = (d_SP_S_x0_dV_GP_SI+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_SI-SP_S_qC*(d_SP_S_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
                d_x_s_dV_DI_SI = (d_SP_S_x0_dV_DI_SI+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_DI_SI-SP_S_qC*(d_SP_S_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_DI_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
                x_s = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
              }
            }
          }

          d_x_d_dV_SI_BP = d_x_s_dV_SI_BP;
          d_x_d_dV_GP_SI = d_x_s_dV_GP_SI;
          d_x_d_dV_DI_SI = d_x_s_dV_DI_SI;
          x_d = x_s;

          d_x_m_dV_SI_BP = d_x_s_dV_SI_BP;
          d_x_m_dV_GP_SI = d_x_s_dV_GP_SI;
          d_x_m_dV_DI_SI = d_x_s_dV_DI_SI;
          x_m = x_s;

          d_x_ds_dV_DI_SI = d_x_ds_dV_GP_SI = d_x_ds_dV_SI_BP =  0.0;
          x_ds = 0.0;

          d_Vdsat_lim_dV_SI_BP = (3.912023005*d_phit1_dV_SI_BP);
          d_Vdsat_lim_dV_DI_SI = (3.912023005*d_phit1_dV_DI_SI);
          d_Vdsat_lim_dV_GP_SI = (3.912023005*d_phit1_dV_GP_SI);
          Vdsat_lim = (3.912023005*phit1);
          if ((xg<=0.0))
          {

            d_qis_dV_DI_SI = d_qis_dV_GP_SI = d_qis_dV_SI_BP =  0.0;
            qis = 0.0;

            d_xgm_dV_SI_BP = (d_xg_dV_SI_BP-d_x_s_dV_SI_BP);
            d_xgm_dV_GP_SI = (d_xg_dV_GP_SI-d_x_s_dV_GP_SI);
            d_xgm_dV_DI_SI = (d_xg_dV_DI_SI-d_x_s_dV_DI_SI);
            xgm = (xg-x_s);

            d_Voxm_dV_SI_BP = ((xgm*d_phit1_dV_SI_BP)+(d_xgm_dV_SI_BP*phit1));
            d_Voxm_dV_GP_SI = ((xgm*d_phit1_dV_GP_SI)+(d_xgm_dV_GP_SI*phit1));
            d_Voxm_dV_DI_SI = ((xgm*d_phit1_dV_DI_SI)+(d_xgm_dV_DI_SI*phit1));
            Voxm = (xgm*phit1);

            d_qeff1_dV_SI_BP = d_Voxm_dV_SI_BP;
            d_qeff1_dV_GP_SI = d_Voxm_dV_GP_SI;
            d_qeff1_dV_DI_SI = d_Voxm_dV_DI_SI;
            qeff1 = Voxm;

            d_Vdsat_dV_SI_BP = d_Vdsat_lim_dV_SI_BP;
            d_Vdsat_dV_DI_SI = d_Vdsat_lim_dV_DI_SI;
            d_Vdsat_dV_GP_SI = d_Vdsat_lim_dV_GP_SI;
            Vdsat = Vdsat_lim;

            d_Vdse_dV_GP_SI = d_Vdse_dV_SI_BP =  0.0;
            d_Vdse_dV_DI_SI = d_Vds_dV_DI_SI;
            Vdse = Vds;
          }
          else
          {

            d_delta_1s_dV_DI_SI = d_delta_1s_dV_GP_SI = d_delta_1s_dV_SI_BP =  0.0;
            delta_1s = 0.0;

            d_temp_dV_SI_BP = (-((x_s*d_x_s_dV_SI_BP)+(d_x_s_dV_SI_BP*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
            d_temp_dV_GP_SI = (-((x_s*d_x_s_dV_GP_SI)+(d_x_s_dV_GP_SI*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
            d_temp_dV_DI_SI = (-((x_s*d_x_s_dV_DI_SI)+(d_x_s_dV_DI_SI*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
            temp = (1.0/(2.0+(x_s*x_s)));

            d_xi0s_dV_SI_BP = (((x_s*x_s)*d_temp_dV_SI_BP)+(((x_s*d_x_s_dV_SI_BP)+(d_x_s_dV_SI_BP*x_s))*temp));
            d_xi0s_dV_GP_SI = (((x_s*x_s)*d_temp_dV_GP_SI)+(((x_s*d_x_s_dV_GP_SI)+(d_x_s_dV_GP_SI*x_s))*temp));
            d_xi0s_dV_DI_SI = (((x_s*x_s)*d_temp_dV_DI_SI)+(((x_s*d_x_s_dV_DI_SI)+(d_x_s_dV_DI_SI*x_s))*temp));
            xi0s = ((x_s*x_s)*temp);

            d_xi1s_dV_SI_BP = (4.0*(((x_s*temp)*d_temp_dV_SI_BP)+(((x_s*d_temp_dV_SI_BP)+(d_x_s_dV_SI_BP*temp))*temp)));
            d_xi1s_dV_GP_SI = (4.0*(((x_s*temp)*d_temp_dV_GP_SI)+(((x_s*d_temp_dV_GP_SI)+(d_x_s_dV_GP_SI*temp))*temp)));
            d_xi1s_dV_DI_SI = (4.0*(((x_s*temp)*d_temp_dV_DI_SI)+(((x_s*d_temp_dV_DI_SI)+(d_x_s_dV_DI_SI*temp))*temp)));
            xi1s = (4.0*((x_s*temp)*temp));

            d_xi2s_dV_SI_BP = (((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_SI_BP)+(((((8.0*temp)-(12.0*xi0s))*d_temp_dV_SI_BP)+(((8.0*d_temp_dV_SI_BP)-(12.0*d_xi0s_dV_SI_BP))*temp))*temp));
            d_xi2s_dV_DI_SI = (((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_DI_SI)+(((((8.0*temp)-(12.0*xi0s))*d_temp_dV_DI_SI)+(((8.0*d_temp_dV_DI_SI)-(12.0*d_xi0s_dV_DI_SI))*temp))*temp));
            d_xi2s_dV_GP_SI = (((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_GP_SI)+(((((8.0*temp)-(12.0*xi0s))*d_temp_dV_GP_SI)+(((8.0*d_temp_dV_GP_SI)-(12.0*d_xi0s_dV_GP_SI))*temp))*temp));
            xi2s = ((((8.0*temp)-(12.0*xi0s))*temp)*temp);
            if ((x_s<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp(x_s);
                double  deriv_exp_0_d0 = value_exp_0;

                d_delta_1s_dV_SI_BP = (deriv_exp_0_d0*(d_x_s_dV_SI_BP));
                d_delta_1s_dV_GP_SI = (deriv_exp_0_d0*(d_x_s_dV_GP_SI));
                d_delta_1s_dV_DI_SI = (deriv_exp_0_d0*(d_x_s_dV_DI_SI));
                delta_1s = value_exp_0;
              }

              d_Es_dV_SI_BP = (-d_delta_1s_dV_SI_BP/delta_1s/delta_1s);
              d_Es_dV_GP_SI = (-d_delta_1s_dV_GP_SI/delta_1s/delta_1s);
              d_Es_dV_DI_SI = (-d_delta_1s_dV_DI_SI/delta_1s/delta_1s);
              Es = (1.0/delta_1s);

              d_delta_1s_dV_SI_BP = ((delta_ns*d_delta_1s_dV_SI_BP)+(d_delta_ns_dV_SI_BP*delta_1s));
              d_delta_1s_dV_DI_SI = ((delta_ns*d_delta_1s_dV_DI_SI)+(d_delta_ns_dV_DI_SI*delta_1s));
              d_delta_1s_dV_GP_SI = ((delta_ns*d_delta_1s_dV_GP_SI)+(d_delta_ns_dV_GP_SI*delta_1s));
              delta_1s = (delta_ns*delta_1s);
            }
            else
            {
              if ((x_s>(xn_s-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp((x_s-xn_s));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_delta_1s_dV_SI_BP = (deriv_exp_0_d0*((d_x_s_dV_SI_BP-d_xn_s_dV_SI_BP)));
                  d_delta_1s_dV_GP_SI = (deriv_exp_0_d0*((d_x_s_dV_GP_SI-d_xn_s_dV_GP_SI)));
                  d_delta_1s_dV_DI_SI = (deriv_exp_0_d0*((d_x_s_dV_DI_SI-d_xn_s_dV_DI_SI)));
                  delta_1s = value_exp_0;
                }

                d_Es_dV_SI_BP = ((delta_1s*d_delta_ns_dV_SI_BP-delta_ns*d_delta_1s_dV_SI_BP)/delta_1s/delta_1s);
                d_Es_dV_DI_SI = ((delta_1s*d_delta_ns_dV_DI_SI-delta_ns*d_delta_1s_dV_DI_SI)/delta_1s/delta_1s);
                d_Es_dV_GP_SI = ((delta_1s*d_delta_ns_dV_GP_SI-delta_ns*d_delta_1s_dV_GP_SI)/delta_1s/delta_1s);
                Es = (delta_ns/delta_1s);
              }
              else
              {

                d_delta_1s_dV_SI_BP = (-1.0e-100*((((xn_s-x_s)-2.3025850929940458e+02)*(0.5*((((xn_s-x_s)-2.3025850929940458e+02)*((d_xn_s_dV_SI_BP-d_x_s_dV_SI_BP)*3.3333333333333333e-01))+((d_xn_s_dV_SI_BP-d_x_s_dV_SI_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_SI_BP-d_x_s_dV_SI_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_delta_1s_dV_DI_SI = (-1.0e-100*((((xn_s-x_s)-2.3025850929940458e+02)*(0.5*((((xn_s-x_s)-2.3025850929940458e+02)*((d_xn_s_dV_DI_SI-d_x_s_dV_DI_SI)*3.3333333333333333e-01))+((d_xn_s_dV_DI_SI-d_x_s_dV_DI_SI)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_DI_SI-d_x_s_dV_DI_SI)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_delta_1s_dV_GP_SI = (-1.0e-100*((((xn_s-x_s)-2.3025850929940458e+02)*(0.5*((((xn_s-x_s)-2.3025850929940458e+02)*((d_xn_s_dV_GP_SI-d_x_s_dV_GP_SI)*3.3333333333333333e-01))+((d_xn_s_dV_GP_SI-d_x_s_dV_GP_SI)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_s_dV_GP_SI-d_x_s_dV_GP_SI)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                delta_1s = (1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

                d_Es_dV_SI_BP = (-1.0e-100*(((x_s-2.3025850929940458e+02)*(0.5*(((x_s-2.3025850929940458e+02)*(d_x_s_dV_SI_BP*3.3333333333333333e-01))+(d_x_s_dV_SI_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_s_dV_SI_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_Es_dV_GP_SI = (-1.0e-100*(((x_s-2.3025850929940458e+02)*(0.5*(((x_s-2.3025850929940458e+02)*(d_x_s_dV_GP_SI*3.3333333333333333e-01))+(d_x_s_dV_GP_SI*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_s_dV_GP_SI*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_Es_dV_DI_SI = (-1.0e-100*(((x_s-2.3025850929940458e+02)*(0.5*(((x_s-2.3025850929940458e+02)*(d_x_s_dV_DI_SI*3.3333333333333333e-01))+(d_x_s_dV_DI_SI*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_s_dV_DI_SI*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                Es = (1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }

            d_Ds_dV_SI_BP = (d_delta_1s_dV_SI_BP-((delta_ns*(d_x_s_dV_SI_BP+d_xi0s_dV_SI_BP))+(d_delta_ns_dV_SI_BP*((x_s+1.0)+xi0s))));
            d_Ds_dV_GP_SI = (d_delta_1s_dV_GP_SI-((delta_ns*(d_x_s_dV_GP_SI+d_xi0s_dV_GP_SI))+(d_delta_ns_dV_GP_SI*((x_s+1.0)+xi0s))));
            d_Ds_dV_DI_SI = (d_delta_1s_dV_DI_SI-((delta_ns*(d_x_s_dV_DI_SI+d_xi0s_dV_DI_SI))+(d_delta_ns_dV_DI_SI*((x_s+1.0)+xi0s))));
            Ds = (delta_1s-(delta_ns*((x_s+1.0)+xi0s)));
            if ((x_s<1.0e-5))
            {

              d_Ps_dV_SI_BP = (0.5*(((x_s*x_s)*(-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_SI_BP)))+(d_x_s_dV_SI_BP*(1.0-(0.25*x_s)))))))+(((x_s*d_x_s_dV_SI_BP)+(d_x_s_dV_SI_BP*x_s))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))));
              d_Ps_dV_GP_SI = (0.5*(((x_s*x_s)*(-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_GP_SI)))+(d_x_s_dV_GP_SI*(1.0-(0.25*x_s)))))))+(((x_s*d_x_s_dV_GP_SI)+(d_x_s_dV_GP_SI*x_s))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))));
              d_Ps_dV_DI_SI = (0.5*(((x_s*x_s)*(-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_DI_SI)))+(d_x_s_dV_DI_SI*(1.0-(0.25*x_s)))))))+(((x_s*d_x_s_dV_DI_SI)+(d_x_s_dV_DI_SI*x_s))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))));
              Ps = (0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))));

              d_Ds_dV_SI_BP = (1.6666666666666667e-01*(((((delta_ns*x_s)*x_s)*x_s)*(1.75*d_x_s_dV_SI_BP))+(((((delta_ns*x_s)*x_s)*d_x_s_dV_SI_BP)+((((delta_ns*x_s)*d_x_s_dV_SI_BP)+(((delta_ns*d_x_s_dV_SI_BP)+(d_delta_ns_dV_SI_BP*x_s))*x_s))*x_s))*(1.0+(1.75*x_s)))));
              d_Ds_dV_DI_SI = (1.6666666666666667e-01*(((((delta_ns*x_s)*x_s)*x_s)*(1.75*d_x_s_dV_DI_SI))+(((((delta_ns*x_s)*x_s)*d_x_s_dV_DI_SI)+((((delta_ns*x_s)*d_x_s_dV_DI_SI)+(((delta_ns*d_x_s_dV_DI_SI)+(d_delta_ns_dV_DI_SI*x_s))*x_s))*x_s))*(1.0+(1.75*x_s)))));
              d_Ds_dV_GP_SI = (1.6666666666666667e-01*(((((delta_ns*x_s)*x_s)*x_s)*(1.75*d_x_s_dV_GP_SI))+(((((delta_ns*x_s)*x_s)*d_x_s_dV_GP_SI)+((((delta_ns*x_s)*d_x_s_dV_GP_SI)+(((delta_ns*d_x_s_dV_GP_SI)+(d_delta_ns_dV_GP_SI*x_s))*x_s))*x_s))*(1.0+(1.75*x_s)))));
              Ds = (1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s))));
              {
                double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_temp_dV_SI_BP = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_SI_BP)))+(d_x_s_dV_SI_BP*(1.0-(0.25*x_s))))))));
                d_temp_dV_GP_SI = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_GP_SI)))+(d_x_s_dV_GP_SI*(1.0-(0.25*x_s))))))));
                d_temp_dV_DI_SI = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_s*(-(0.25*d_x_s_dV_DI_SI)))+(d_x_s_dV_DI_SI*(1.0-(0.25*x_s))))))));
                temp = value_sqrt_0;
              }

              d_sqm_dV_SI_BP = (7.0710678118654746e-01*((x_s*d_temp_dV_SI_BP)+(d_x_s_dV_SI_BP*temp)));
              d_sqm_dV_GP_SI = (7.0710678118654746e-01*((x_s*d_temp_dV_GP_SI)+(d_x_s_dV_GP_SI*temp)));
              d_sqm_dV_DI_SI = (7.0710678118654746e-01*((x_s*d_temp_dV_DI_SI)+(d_x_s_dV_DI_SI*temp)));
              sqm = (7.0710678118654746e-01*(x_s*temp));

              d_alpha_dV_SI_BP = ((temp*(((Gf*7.0710678118654746e-01)*((-(0.5*d_x_s_dV_SI_BP))+(1.6666666666666667e-01*((x_s*d_x_s_dV_SI_BP)+(d_x_s_dV_SI_BP*x_s)))))+((d_Gf_dV_SI_BP*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_SI_BP)/temp/temp);
              d_alpha_dV_GP_SI = ((temp*(((Gf*7.0710678118654746e-01)*((-(0.5*d_x_s_dV_GP_SI))+(1.6666666666666667e-01*((x_s*d_x_s_dV_GP_SI)+(d_x_s_dV_GP_SI*x_s)))))+((d_Gf_dV_GP_SI*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_GP_SI)/temp/temp);
              d_alpha_dV_DI_SI = ((temp*(((Gf*7.0710678118654746e-01)*((-(0.5*d_x_s_dV_DI_SI))+(1.6666666666666667e-01*((x_s*d_x_s_dV_DI_SI)+(d_x_s_dV_DI_SI*x_s)))))+((d_Gf_dV_DI_SI*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_DI_SI)/temp/temp);
              alpha = (1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp));
            }
            else
            {

              d_Ps_dV_SI_BP = (d_x_s_dV_SI_BP+d_Es_dV_SI_BP);
              d_Ps_dV_GP_SI = (d_x_s_dV_GP_SI+d_Es_dV_GP_SI);
              d_Ps_dV_DI_SI = (d_x_s_dV_DI_SI+d_Es_dV_DI_SI);
              Ps = ((x_s-1.0)+Es);
              {
                double value_sqrt_0 = sqrt(Ps);
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_sqm_dV_SI_BP = (deriv_sqrt_0_d0*(d_Ps_dV_SI_BP));
                d_sqm_dV_GP_SI = (deriv_sqrt_0_d0*(d_Ps_dV_GP_SI));
                d_sqm_dV_DI_SI = (deriv_sqrt_0_d0*(d_Ps_dV_DI_SI));
                sqm = value_sqrt_0;
              }

              d_alpha_dV_SI_BP = (0.5*((sqm*((Gf*(-d_Es_dV_SI_BP))+(d_Gf_dV_SI_BP*(1.0-Es)))-(Gf*(1.0-Es))*d_sqm_dV_SI_BP)/sqm/sqm));
              d_alpha_dV_GP_SI = (0.5*((sqm*((Gf*(-d_Es_dV_GP_SI))+(d_Gf_dV_GP_SI*(1.0-Es)))-(Gf*(1.0-Es))*d_sqm_dV_GP_SI)/sqm/sqm));
              d_alpha_dV_DI_SI = (0.5*((sqm*((Gf*(-d_Es_dV_DI_SI))+(d_Gf_dV_DI_SI*(1.0-Es)))-(Gf*(1.0-Es))*d_sqm_dV_DI_SI)/sqm/sqm));
              alpha = (1.0+(0.5*((Gf*(1.0-Es))/sqm)));
            }

            d_Em_dV_SI_BP = d_Es_dV_SI_BP;
            d_Em_dV_GP_SI = d_Es_dV_GP_SI;
            d_Em_dV_DI_SI = d_Es_dV_DI_SI;
            Em = Es;

            d_Ed_dV_SI_BP = d_Em_dV_SI_BP;
            d_Ed_dV_GP_SI = d_Em_dV_GP_SI;
            d_Ed_dV_DI_SI = d_Em_dV_DI_SI;
            Ed = Em;

            d_Dm_dV_SI_BP = d_Ds_dV_SI_BP;
            d_Dm_dV_GP_SI = d_Ds_dV_GP_SI;
            d_Dm_dV_DI_SI = d_Ds_dV_DI_SI;
            Dm = Ds;

            d_Dd_dV_SI_BP = d_Dm_dV_SI_BP;
            d_Dd_dV_GP_SI = d_Dm_dV_GP_SI;
            d_Dd_dV_DI_SI = d_Dm_dV_DI_SI;
            Dd = Dm;

            d_Rxcor_dV_GP_SI = (((1.0+(XCOR_T*Vsbx))*((0.2*XCOR_T)*d_Vsbx_dV_GP_SI)-(1.0+((0.2*XCOR_T)*Vsbx))*(XCOR_T*d_Vsbx_dV_GP_SI))/(1.0+(XCOR_T*Vsbx))/(1.0+(XCOR_T*Vsbx)));
            d_Rxcor_dV_SI_BP = (((1.0+(XCOR_T*Vsbx))*((0.2*XCOR_T)*d_Vsbx_dV_SI_BP)-(1.0+((0.2*XCOR_T)*Vsbx))*(XCOR_T*d_Vsbx_dV_SI_BP))/(1.0+(XCOR_T*Vsbx))/(1.0+(XCOR_T*Vsbx)));
            d_Rxcor_dV_DI_SI = (((1.0+(XCOR_T*Vsbx))*((0.2*XCOR_T)*d_Vsbx_dV_DI_SI)-(1.0+((0.2*XCOR_T)*Vsbx))*(XCOR_T*d_Vsbx_dV_DI_SI))/(1.0+(XCOR_T*Vsbx))/(1.0+(XCOR_T*Vsbx)));
            Rxcor = ((1.0+((0.2*XCOR_T)*Vsbx))/(1.0+(XCOR_T*Vsbx)));
            if ((Ds>1.0e-100))
            {
              {
                double value_sqrt_0 = sqrt((Ps+Ds));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_xgs_dV_SI_BP = ((Gf*(deriv_sqrt_0_d0*((d_Ps_dV_SI_BP+d_Ds_dV_SI_BP))))+(d_Gf_dV_SI_BP*value_sqrt_0));
                d_xgs_dV_GP_SI = ((Gf*(deriv_sqrt_0_d0*((d_Ps_dV_GP_SI+d_Ds_dV_GP_SI))))+(d_Gf_dV_GP_SI*value_sqrt_0));
                d_xgs_dV_DI_SI = ((Gf*(deriv_sqrt_0_d0*((d_Ps_dV_DI_SI+d_Ds_dV_DI_SI))))+(d_Gf_dV_DI_SI*value_sqrt_0));
                xgs = (Gf*value_sqrt_0);
              }

              d_qis_dV_SI_BP = (((xgs+(Gf*sqm))*(((Gf2*Ds)*d_phit1_dV_SI_BP)+(((Gf2*d_Ds_dV_SI_BP)+(d_Gf2_dV_SI_BP*Ds))*phit1))-((Gf2*Ds)*phit1)*(d_xgs_dV_SI_BP+((Gf*d_sqm_dV_SI_BP)+(d_Gf_dV_SI_BP*sqm))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
              d_qis_dV_GP_SI = (((xgs+(Gf*sqm))*(((Gf2*Ds)*d_phit1_dV_GP_SI)+(((Gf2*d_Ds_dV_GP_SI)+(d_Gf2_dV_GP_SI*Ds))*phit1))-((Gf2*Ds)*phit1)*(d_xgs_dV_GP_SI+((Gf*d_sqm_dV_GP_SI)+(d_Gf_dV_GP_SI*sqm))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
              d_qis_dV_DI_SI = (((xgs+(Gf*sqm))*(((Gf2*Ds)*d_phit1_dV_DI_SI)+(((Gf2*d_Ds_dV_DI_SI)+(d_Gf2_dV_DI_SI*Ds))*phit1))-((Gf2*Ds)*phit1)*(d_xgs_dV_DI_SI+((Gf*d_sqm_dV_DI_SI)+(d_Gf_dV_DI_SI*sqm))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
              qis = (((Gf2*Ds)*phit1)/(xgs+(Gf*sqm)));

              d_qbs_dV_SI_BP = (((sqm*Gf)*d_phit1_dV_SI_BP)+(((sqm*d_Gf_dV_SI_BP)+(d_sqm_dV_SI_BP*Gf))*phit1));
              d_qbs_dV_GP_SI = (((sqm*Gf)*d_phit1_dV_GP_SI)+(((sqm*d_Gf_dV_GP_SI)+(d_sqm_dV_GP_SI*Gf))*phit1));
              d_qbs_dV_DI_SI = (((sqm*Gf)*d_phit1_dV_DI_SI)+(((sqm*d_Gf_dV_DI_SI)+(d_sqm_dV_DI_SI*Gf))*phit1));
              qbs = ((sqm*Gf)*phit1);
              if ((RSB_i<0.0))
              {

                d_rhob_dV_GP_SI = (-(-(RSB_i*d_Vsbx_dV_GP_SI))/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
                d_rhob_dV_SI_BP = (-(-(RSB_i*d_Vsbx_dV_SI_BP))/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
                d_rhob_dV_DI_SI = (-(-(RSB_i*d_Vsbx_dV_DI_SI))/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
                rhob = (1.0/(1.0-(RSB_i*Vsbx)));
              }
              else
              {

                d_rhob_dV_GP_SI = (RSB_i*d_Vsbx_dV_GP_SI);
                d_rhob_dV_SI_BP = (RSB_i*d_Vsbx_dV_SI_BP);
                d_rhob_dV_DI_SI = (RSB_i*d_Vsbx_dV_DI_SI);
                rhob = (1.0+(RSB_i*Vsbx));
              }
              if ((RSG_i<0.0))
              {

                d_temp_dV_SI_BP = (-(RSG_i*d_qis_dV_SI_BP));
                d_temp_dV_GP_SI = (-(RSG_i*d_qis_dV_GP_SI));
                d_temp_dV_DI_SI = (-(RSG_i*d_qis_dV_DI_SI));
                temp = (1.0-(RSG_i*qis));
              }
              else
              {

                d_temp_dV_SI_BP = (-(RSG_i*d_qis_dV_SI_BP)/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
                d_temp_dV_GP_SI = (-(RSG_i*d_qis_dV_GP_SI)/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
                d_temp_dV_DI_SI = (-(RSG_i*d_qis_dV_DI_SI)/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
                temp = (1.0/(1.0+(RSG_i*qis)));
              }

              d_GR_dV_GP_SI = (THER_i*(((rhob*temp)*d_qis_dV_GP_SI)+(((rhob*d_temp_dV_GP_SI)+(d_rhob_dV_GP_SI*temp))*qis)));
              d_GR_dV_SI_BP = (THER_i*(((rhob*temp)*d_qis_dV_SI_BP)+(((rhob*d_temp_dV_SI_BP)+(d_rhob_dV_SI_BP*temp))*qis)));
              d_GR_dV_DI_SI = (THER_i*(((rhob*temp)*d_qis_dV_DI_SI)+(((rhob*d_temp_dV_DI_SI)+(d_rhob_dV_DI_SI*temp))*qis)));
              GR = (THER_i*((rhob*temp)*qis));

              d_Eeffm_dV_SI_BP = (E_eff0*(d_qbs_dV_SI_BP+(eta_mu*d_qis_dV_SI_BP)));
              d_Eeffm_dV_GP_SI = (E_eff0*(d_qbs_dV_GP_SI+(eta_mu*d_qis_dV_GP_SI)));
              d_Eeffm_dV_DI_SI = (E_eff0*(d_qbs_dV_DI_SI+(eta_mu*d_qis_dV_DI_SI)));
              Eeffm = (E_eff0*(qbs+(eta_mu*qis)));
              {
                double value_pow_0 = pow((Eeffm*MUE_T),THEMU_T);
                double  deriv_pow_0_d0 = (((Eeffm*MUE_T) == 0.0)?0.0:(value_pow_0*THEMU_T/(Eeffm*MUE_T)));

                d_Mutmp_dV_SI_BP = ((deriv_pow_0_d0*((d_Eeffm_dV_SI_BP*MUE_T)))+(CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dV_SI_BP-Ps*(d_Ps_dV_SI_BP+d_Ds_dV_SI_BP))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
                d_Mutmp_dV_GP_SI = ((deriv_pow_0_d0*((d_Eeffm_dV_GP_SI*MUE_T)))+(CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dV_GP_SI-Ps*(d_Ps_dV_GP_SI+d_Ds_dV_GP_SI))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
                d_Mutmp_dV_DI_SI = ((deriv_pow_0_d0*((d_Eeffm_dV_DI_SI*MUE_T)))+(CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dV_DI_SI-Ps*(d_Ps_dV_DI_SI+d_Ds_dV_DI_SI))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
                Mutmp = (value_pow_0+(CS_T*(Ps/((Ps+Ds)+1.0e-14))));
              }

              d_Gmob_dV_SI_BP = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_SI_BP)+((d_Mutmp_dV_SI_BP+d_GR_dV_SI_BP)*Rxcor));
              d_Gmob_dV_GP_SI = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_GP_SI)+((d_Mutmp_dV_GP_SI+d_GR_dV_GP_SI)*Rxcor));
              d_Gmob_dV_DI_SI = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_DI_SI)+((d_Mutmp_dV_DI_SI+d_GR_dV_DI_SI)*Rxcor));
              Gmob = (((1.0+Mutmp)+GR)*Rxcor);
              if ((THESATB_i<0.0))
              {

                d_xitsb_dV_GP_SI = (-(-(THESATB_i*d_Vsbx_dV_GP_SI))/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
                d_xitsb_dV_SI_BP = (-(-(THESATB_i*d_Vsbx_dV_SI_BP))/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
                d_xitsb_dV_DI_SI = (-(-(THESATB_i*d_Vsbx_dV_DI_SI))/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
                xitsb = (1.0/(1.0-(THESATB_i*Vsbx)));
              }
              else
              {

                d_xitsb_dV_GP_SI = (THESATB_i*d_Vsbx_dV_GP_SI);
                d_xitsb_dV_SI_BP = (THESATB_i*d_Vsbx_dV_SI_BP);
                d_xitsb_dV_DI_SI = (THESATB_i*d_Vsbx_dV_DI_SI);
                xitsb = (1.0+(THESATB_i*Vsbx));
              }

              d_temp2_dV_SI_BP = ((qis*d_xitsb_dV_SI_BP)+(d_qis_dV_SI_BP*xitsb));
              d_temp2_dV_GP_SI = ((qis*d_xitsb_dV_GP_SI)+(d_qis_dV_GP_SI*xitsb));
              d_temp2_dV_DI_SI = ((qis*d_xitsb_dV_DI_SI)+(d_qis_dV_DI_SI*xitsb));
              temp2 = (qis*xitsb);

              d_wsat_dV_SI_BP = (100.0*(((100.0+temp2)*d_temp2_dV_SI_BP-temp2*d_temp2_dV_SI_BP)/(100.0+temp2)/(100.0+temp2)));
              d_wsat_dV_GP_SI = (100.0*(((100.0+temp2)*d_temp2_dV_GP_SI-temp2*d_temp2_dV_GP_SI)/(100.0+temp2)/(100.0+temp2)));
              d_wsat_dV_DI_SI = (100.0*(((100.0+temp2)*d_temp2_dV_DI_SI-temp2*d_temp2_dV_DI_SI)/(100.0+temp2)/(100.0+temp2)));
              wsat = (100.0*(temp2/(100.0+temp2)));
              if ((THESATG_i<0.0))
              {

                d_temp_dV_SI_BP = (-(-(THESATG_i*d_wsat_dV_SI_BP))/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
                d_temp_dV_GP_SI = (-(-(THESATG_i*d_wsat_dV_GP_SI))/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
                d_temp_dV_DI_SI = (-(-(THESATG_i*d_wsat_dV_DI_SI))/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
                temp = (1.0/(1.0-(THESATG_i*wsat)));
              }
              else
              {

                d_temp_dV_SI_BP = (THESATG_i*d_wsat_dV_SI_BP);
                d_temp_dV_GP_SI = (THESATG_i*d_wsat_dV_GP_SI);
                d_temp_dV_DI_SI = (THESATG_i*d_wsat_dV_DI_SI);
                temp = (1.0+(THESATG_i*wsat));
              }

              d_thesat1_dV_SI_BP = (THESAT_T*((Gmob*d_temp_dV_SI_BP-temp*d_Gmob_dV_SI_BP)/Gmob/Gmob));
              d_thesat1_dV_DI_SI = (THESAT_T*((Gmob*d_temp_dV_DI_SI-temp*d_Gmob_dV_DI_SI)/Gmob/Gmob));
              d_thesat1_dV_GP_SI = (THESAT_T*((Gmob*d_temp_dV_GP_SI-temp*d_Gmob_dV_GP_SI)/Gmob/Gmob));
              thesat1 = (THESAT_T*(temp/Gmob));

              d_phi_inf_dV_SI_BP = (((alpha*d_qis_dV_SI_BP-qis*d_alpha_dV_SI_BP)/alpha/alpha)+d_phit1_dV_SI_BP);
              d_phi_inf_dV_GP_SI = (((alpha*d_qis_dV_GP_SI-qis*d_alpha_dV_GP_SI)/alpha/alpha)+d_phit1_dV_GP_SI);
              d_phi_inf_dV_DI_SI = (((alpha*d_qis_dV_DI_SI-qis*d_alpha_dV_DI_SI)/alpha/alpha)+d_phit1_dV_DI_SI);
              phi_inf = ((qis/alpha)+phit1);

              d_ysat_dV_SI_BP = (((thesat1*d_phi_inf_dV_SI_BP)+(d_thesat1_dV_SI_BP*phi_inf))*7.0710678118654746e-01);
              d_ysat_dV_DI_SI = (((thesat1*d_phi_inf_dV_DI_SI)+(d_thesat1_dV_DI_SI*phi_inf))*7.0710678118654746e-01);
              d_ysat_dV_GP_SI = (((thesat1*d_phi_inf_dV_GP_SI)+(d_thesat1_dV_GP_SI*phi_inf))*7.0710678118654746e-01);
              ysat = ((thesat1*phi_inf)*7.0710678118654746e-01);
              if (((model_.CHNL_TYPE)==(-1)))
              {
                {
                  double value_sqrt_0 = sqrt((1.0+ysat));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_ysat_dV_SI_BP = ((value_sqrt_0*d_ysat_dV_SI_BP-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_SI_BP)))/value_sqrt_0/value_sqrt_0);
                  d_ysat_dV_DI_SI = ((value_sqrt_0*d_ysat_dV_DI_SI-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_DI_SI)))/value_sqrt_0/value_sqrt_0);
                  d_ysat_dV_GP_SI = ((value_sqrt_0*d_ysat_dV_GP_SI-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_GP_SI)))/value_sqrt_0/value_sqrt_0);
                  ysat = (ysat/value_sqrt_0);
                }
              }
              {
                double value_sqrt_0 = sqrt((1.0+(4.0*ysat)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_za_dV_SI_BP = (-2.0*(deriv_sqrt_0_d0*((4.0*d_ysat_dV_SI_BP)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
                d_za_dV_DI_SI = (-2.0*(deriv_sqrt_0_d0*((4.0*d_ysat_dV_DI_SI)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
                d_za_dV_GP_SI = (-2.0*(deriv_sqrt_0_d0*((4.0*d_ysat_dV_GP_SI)))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
                za = (2.0/(1.0+value_sqrt_0));
              }

              d_temp1_dV_SI_BP = ((za*d_ysat_dV_SI_BP)+(d_za_dV_SI_BP*ysat));
              d_temp1_dV_DI_SI = ((za*d_ysat_dV_DI_SI)+(d_za_dV_DI_SI*ysat));
              d_temp1_dV_GP_SI = ((za*d_ysat_dV_GP_SI)+(d_za_dV_GP_SI*ysat));
              temp1 = (za*ysat);

              d_Phi_0_dV_SI_BP = (((phi_inf*za)*(0.86*(((1.0+(4.0*((temp1*temp1)*za)))*((temp1*(-((temp1*d_za_dV_SI_BP)+(d_temp1_dV_SI_BP*za))))+(d_temp1_dV_SI_BP*(1.0-(temp1*za))))-(temp1*(1.0-(temp1*za)))*(4.0*(((temp1*temp1)*d_za_dV_SI_BP)+(((temp1*d_temp1_dV_SI_BP)+(d_temp1_dV_SI_BP*temp1))*za))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf*d_za_dV_SI_BP)+(d_phi_inf_dV_SI_BP*za))*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))));
              d_Phi_0_dV_GP_SI = (((phi_inf*za)*(0.86*(((1.0+(4.0*((temp1*temp1)*za)))*((temp1*(-((temp1*d_za_dV_GP_SI)+(d_temp1_dV_GP_SI*za))))+(d_temp1_dV_GP_SI*(1.0-(temp1*za))))-(temp1*(1.0-(temp1*za)))*(4.0*(((temp1*temp1)*d_za_dV_GP_SI)+(((temp1*d_temp1_dV_GP_SI)+(d_temp1_dV_GP_SI*temp1))*za))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf*d_za_dV_GP_SI)+(d_phi_inf_dV_GP_SI*za))*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))));
              d_Phi_0_dV_DI_SI = (((phi_inf*za)*(0.86*(((1.0+(4.0*((temp1*temp1)*za)))*((temp1*(-((temp1*d_za_dV_DI_SI)+(d_temp1_dV_DI_SI*za))))+(d_temp1_dV_DI_SI*(1.0-(temp1*za))))-(temp1*(1.0-(temp1*za)))*(4.0*(((temp1*temp1)*d_za_dV_DI_SI)+(((temp1*d_temp1_dV_DI_SI)+(d_temp1_dV_DI_SI*temp1))*za))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf*d_za_dV_DI_SI)+(d_phi_inf_dV_DI_SI*za))*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))));
              Phi_0 = ((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));

              d_asat_dV_SI_BP = (d_xgs_dV_SI_BP+(0.5*d_Gf2_dV_SI_BP));
              d_asat_dV_GP_SI = (d_xgs_dV_GP_SI+(0.5*d_Gf2_dV_GP_SI));
              d_asat_dV_DI_SI = (d_xgs_dV_DI_SI+(0.5*d_Gf2_dV_DI_SI));
              asat = (xgs+(0.5*Gf2));
              {
                double value_sqrt_0 = sqrt(((asat*asat)-((Gf2*Ds)*0.98)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_Phi_2_dV_SI_BP = (0.98*(((asat+value_sqrt_0)*(((Gf2*Ds)*d_phit1_dV_SI_BP)+(((Gf2*d_Ds_dV_SI_BP)+(d_Gf2_dV_SI_BP*Ds))*phit1))-((Gf2*Ds)*phit1)*(d_asat_dV_SI_BP+(deriv_sqrt_0_d0*((((asat*d_asat_dV_SI_BP)+(d_asat_dV_SI_BP*asat))-(((Gf2*d_Ds_dV_SI_BP)+(d_Gf2_dV_SI_BP*Ds))*0.98))))))/(asat+value_sqrt_0)/(asat+value_sqrt_0)));
                d_Phi_2_dV_GP_SI = (0.98*(((asat+value_sqrt_0)*(((Gf2*Ds)*d_phit1_dV_GP_SI)+(((Gf2*d_Ds_dV_GP_SI)+(d_Gf2_dV_GP_SI*Ds))*phit1))-((Gf2*Ds)*phit1)*(d_asat_dV_GP_SI+(deriv_sqrt_0_d0*((((asat*d_asat_dV_GP_SI)+(d_asat_dV_GP_SI*asat))-(((Gf2*d_Ds_dV_GP_SI)+(d_Gf2_dV_GP_SI*Ds))*0.98))))))/(asat+value_sqrt_0)/(asat+value_sqrt_0)));
                d_Phi_2_dV_DI_SI = (0.98*(((asat+value_sqrt_0)*(((Gf2*Ds)*d_phit1_dV_DI_SI)+(((Gf2*d_Ds_dV_DI_SI)+(d_Gf2_dV_DI_SI*Ds))*phit1))-((Gf2*Ds)*phit1)*(d_asat_dV_DI_SI+(deriv_sqrt_0_d0*((((asat*d_asat_dV_DI_SI)+(d_asat_dV_DI_SI*asat))-(((Gf2*d_Ds_dV_DI_SI)+(d_Gf2_dV_DI_SI*Ds))*0.98))))))/(asat+value_sqrt_0)/(asat+value_sqrt_0)));
                Phi_2 = (0.98*(((Gf2*Ds)*phit1)/(asat+value_sqrt_0)));
              }

              d_Phi_0_2_dV_SI_BP = (d_Phi_0_dV_SI_BP+d_Phi_2_dV_SI_BP);
              d_Phi_0_2_dV_GP_SI = (d_Phi_0_dV_GP_SI+d_Phi_2_dV_GP_SI);
              d_Phi_0_2_dV_DI_SI = (d_Phi_0_dV_DI_SI+d_Phi_2_dV_DI_SI);
              Phi_0_2 = (Phi_0+Phi_2);

              d_Phi0_Phi2_dV_SI_BP = (2.0*((Phi_0*d_Phi_2_dV_SI_BP)+(d_Phi_0_dV_SI_BP*Phi_2)));
              d_Phi0_Phi2_dV_GP_SI = (2.0*((Phi_0*d_Phi_2_dV_GP_SI)+(d_Phi_0_dV_GP_SI*Phi_2)));
              d_Phi0_Phi2_dV_DI_SI = (2.0*((Phi_0*d_Phi_2_dV_DI_SI)+(d_Phi_0_dV_DI_SI*Phi_2)));
              Phi0_Phi2 = (2.0*(Phi_0*Phi_2));
              {
                double value_sqrt_0 = sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_Phi_sat_dV_SI_BP = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_SI_BP-Phi0_Phi2*(d_Phi_0_2_dV_SI_BP+(deriv_sqrt_0_d0*((((Phi_0_2*d_Phi_0_2_dV_SI_BP)+(d_Phi_0_2_dV_SI_BP*Phi_0_2))-(1.98*d_Phi0_Phi2_dV_SI_BP))))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
                d_Phi_sat_dV_GP_SI = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_GP_SI-Phi0_Phi2*(d_Phi_0_2_dV_GP_SI+(deriv_sqrt_0_d0*((((Phi_0_2*d_Phi_0_2_dV_GP_SI)+(d_Phi_0_2_dV_GP_SI*Phi_0_2))-(1.98*d_Phi0_Phi2_dV_GP_SI))))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
                d_Phi_sat_dV_DI_SI = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_DI_SI-Phi0_Phi2*(d_Phi_0_2_dV_DI_SI+(deriv_sqrt_0_d0*((((Phi_0_2*d_Phi_0_2_dV_DI_SI)+(d_Phi_0_2_dV_DI_SI*Phi_0_2))-(1.98*d_Phi0_Phi2_dV_DI_SI))))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
                Phi_sat = (Phi0_Phi2/(Phi_0_2+value_sqrt_0));
              }
              {
                double value_log_0 = log((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));
                double  deriv_log_0_d0 = (1.0/(1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));

                d_Vdsat_dV_SI_BP = (d_Phi_sat_dV_SI_BP-((phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_SI_BP)+(((Phi_sat*(d_Phi_sat_dV_SI_BP-(((2.0*asat)*d_phit1_dV_SI_BP)+((2.0*d_asat_dV_SI_BP)*phit1))))+(d_Phi_sat_dV_SI_BP*(Phi_sat-((2.0*asat)*phit1))))*inv_Gf2))-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*(((phit1*phit1)*d_Ds_dV_SI_BP)+(((phit1*d_phit1_dV_SI_BP)+(d_phit1_dV_SI_BP*phit1))*Ds)))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds)))))+(d_phit1_dV_SI_BP*value_log_0)));
                d_Vdsat_dV_GP_SI = (d_Phi_sat_dV_GP_SI-((phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_GP_SI)+(((Phi_sat*(d_Phi_sat_dV_GP_SI-(((2.0*asat)*d_phit1_dV_GP_SI)+((2.0*d_asat_dV_GP_SI)*phit1))))+(d_Phi_sat_dV_GP_SI*(Phi_sat-((2.0*asat)*phit1))))*inv_Gf2))-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*(((phit1*phit1)*d_Ds_dV_GP_SI)+(((phit1*d_phit1_dV_GP_SI)+(d_phit1_dV_GP_SI*phit1))*Ds)))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds)))))+(d_phit1_dV_GP_SI*value_log_0)));
                d_Vdsat_dV_DI_SI = (d_Phi_sat_dV_DI_SI-((phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_DI_SI)+(((Phi_sat*(d_Phi_sat_dV_DI_SI-(((2.0*asat)*d_phit1_dV_DI_SI)+((2.0*d_asat_dV_DI_SI)*phit1))))+(d_Phi_sat_dV_DI_SI*(Phi_sat-((2.0*asat)*phit1))))*inv_Gf2))-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*(((phit1*phit1)*d_Ds_dV_DI_SI)+(((phit1*d_phit1_dV_DI_SI)+(d_phit1_dV_DI_SI*phit1))*Ds)))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds)))))+(d_phit1_dV_DI_SI*value_log_0)));
                Vdsat = (Phi_sat-(phit1*value_log_0));
              }
            }
            else
            {

              d_Vdsat_dV_SI_BP = d_Vdsat_lim_dV_SI_BP;
              d_Vdsat_dV_DI_SI = d_Vdsat_lim_dV_DI_SI;
              d_Vdsat_dV_GP_SI = d_Vdsat_lim_dV_GP_SI;
              Vdsat = Vdsat_lim;
            }
            {
              double value_pow_0 = pow((Vds/Vdsat),AX_i);
              double  deriv_pow_0_d0 = (((Vds/Vdsat) == 0.0)?0.0:(value_pow_0*AX_i/(Vds/Vdsat)));

              d_temp_dV_SI_BP = (deriv_pow_0_d0*((-Vds*d_Vdsat_dV_SI_BP/Vdsat/Vdsat)));
              d_temp_dV_GP_SI = (deriv_pow_0_d0*((-Vds*d_Vdsat_dV_GP_SI/Vdsat/Vdsat)));
              d_temp_dV_DI_SI = (deriv_pow_0_d0*(((Vdsat*d_Vds_dV_DI_SI-Vds*d_Vdsat_dV_DI_SI)/Vdsat/Vdsat)));
              temp = value_pow_0;
            }
            {
              double value_pow_0 = pow((1.0+temp),(-inv_AX));
              double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-inv_AX)/(1.0+temp)));

              d_Vdse_dV_SI_BP = (Vds*(deriv_pow_0_d0*(d_temp_dV_SI_BP)));
              d_Vdse_dV_GP_SI = (Vds*(deriv_pow_0_d0*(d_temp_dV_GP_SI)));
              d_Vdse_dV_DI_SI = ((Vds*(deriv_pow_0_d0*(d_temp_dV_DI_SI)))+(d_Vds_dV_DI_SI*value_pow_0));
              Vdse = (Vds*value_pow_0);
            }

            d_Udse_dV_DI_SI = ((Vdse*d_inv_phit1_dV_DI_SI)+(d_Vdse_dV_DI_SI*inv_phit1));
            d_Udse_dV_SI_BP = ((Vdse*d_inv_phit1_dV_SI_BP)+(d_Vdse_dV_SI_BP*inv_phit1));
            d_Udse_dV_GP_SI = ((Vdse*d_inv_phit1_dV_GP_SI)+(d_Vdse_dV_GP_SI*inv_phit1));
            Udse = (Vdse*inv_phit1);

            d_xn_d_dV_SI_BP = (d_xn_s_dV_SI_BP+d_Udse_dV_SI_BP);
            d_xn_d_dV_DI_SI = (d_xn_s_dV_DI_SI+d_Udse_dV_DI_SI);
            d_xn_d_dV_GP_SI = (d_xn_s_dV_GP_SI+d_Udse_dV_GP_SI);
            xn_d = (xn_s+Udse);
            if ((Udse<4.6051701859880916e+02))
            {
              {
                double value_exp_0 = exp((-Udse));
                double  deriv_exp_0_d0 = value_exp_0;

                d_k_ds_dV_DI_SI = (deriv_exp_0_d0*((-d_Udse_dV_DI_SI)));
                d_k_ds_dV_SI_BP = (deriv_exp_0_d0*((-d_Udse_dV_SI_BP)));
                d_k_ds_dV_GP_SI = (deriv_exp_0_d0*((-d_Udse_dV_GP_SI)));
                k_ds = value_exp_0;
              }
            }
            else
            {

              d_k_ds_dV_DI_SI = (-1.0e-200*(((Udse-4.6051701859880916e+02)*(0.5*(((Udse-4.6051701859880916e+02)*(d_Udse_dV_DI_SI*3.3333333333333333e-01))+(d_Udse_dV_DI_SI*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_Udse_dV_DI_SI*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
              d_k_ds_dV_SI_BP = (-1.0e-200*(((Udse-4.6051701859880916e+02)*(0.5*(((Udse-4.6051701859880916e+02)*(d_Udse_dV_SI_BP*3.3333333333333333e-01))+(d_Udse_dV_SI_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_Udse_dV_SI_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
              d_k_ds_dV_GP_SI = (-1.0e-200*(((Udse-4.6051701859880916e+02)*(0.5*(((Udse-4.6051701859880916e+02)*(d_Udse_dV_GP_SI*3.3333333333333333e-01))+(d_Udse_dV_GP_SI*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+(d_Udse_dV_GP_SI*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
              k_ds = (1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
            }

            d_delta_nd_dV_SI_BP = ((delta_ns*d_k_ds_dV_SI_BP)+(d_delta_ns_dV_SI_BP*k_ds));
            d_delta_nd_dV_DI_SI = ((delta_ns*d_k_ds_dV_DI_SI)+(d_delta_ns_dV_DI_SI*k_ds));
            d_delta_nd_dV_GP_SI = ((delta_ns*d_k_ds_dV_GP_SI)+(d_delta_ns_dV_GP_SI*k_ds));
            delta_nd = (delta_ns*k_ds);
            if ((fabs(xg)<=margin))
            {

              d_SP_S_temp1_dV_SI_BP = ((((inv_xi*d_inv_xi_dV_SI_BP)+(d_inv_xi_dV_SI_BP*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
              d_SP_S_temp1_dV_GP_SI = ((((inv_xi*d_inv_xi_dV_GP_SI)+(d_inv_xi_dV_GP_SI*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
              d_SP_S_temp1_dV_DI_SI = ((((inv_xi*d_inv_xi_dV_DI_SI)+(d_inv_xi_dV_DI_SI*inv_xi))*1.6666666666666667e-01)*7.0710678118654746e-01);
              SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);

              d_x_d_dV_SI_BP = (((xg*inv_xi)*((((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_SI_BP)+((((xg*(1.0-delta_nd))*d_Gf_dV_SI_BP)+(((xg*(-d_delta_nd_dV_SI_BP))+(d_xg_dV_SI_BP*(1.0-delta_nd)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_SI_BP)+(d_xg_dV_SI_BP*inv_xi))*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1))));
              d_x_d_dV_GP_SI = (((xg*inv_xi)*((((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_GP_SI)+((((xg*(1.0-delta_nd))*d_Gf_dV_GP_SI)+(((xg*(-d_delta_nd_dV_GP_SI))+(d_xg_dV_GP_SI*(1.0-delta_nd)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_GP_SI)+(d_xg_dV_GP_SI*inv_xi))*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1))));
              d_x_d_dV_DI_SI = (((xg*inv_xi)*((((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_DI_SI)+((((xg*(1.0-delta_nd))*d_Gf_dV_DI_SI)+(((xg*(-d_delta_nd_dV_DI_SI))+(d_xg_dV_DI_SI*(1.0-delta_nd)))*Gf))*SP_S_temp1)))+(((xg*d_inv_xi_dV_DI_SI)+(d_xg_dV_DI_SI*inv_xi))*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1))));
              x_d = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
            }
            else
            {

              d_SP_S_bx_dV_SI_BP = d_xn_d_dV_SI_BP;
              d_SP_S_bx_dV_DI_SI = d_xn_d_dV_DI_SI;
              d_SP_S_bx_dV_GP_SI = d_xn_d_dV_GP_SI;
              SP_S_bx = (xn_d+3);
              {
                double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
                double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_SP_S_eta_dV_SI_BP = ((0.5*((d_SP_S_x1_dV_SI_BP+d_SP_S_bx_dV_SI_BP)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP))+((d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_SI_BP-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_SI_BP)+(d_SP_S_bx_dV_SI_BP*SP_S_bx)))))));
                d_SP_S_eta_dV_GP_SI = ((0.5*((d_SP_S_x1_dV_GP_SI+d_SP_S_bx_dV_GP_SI)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI))+((d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_GP_SI-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_GP_SI)+(d_SP_S_bx_dV_GP_SI*SP_S_bx)))))));
                d_SP_S_eta_dV_DI_SI = ((0.5*((d_SP_S_x1_dV_DI_SI+d_SP_S_bx_dV_DI_SI)-(deriv_sqrt_0_d0*((((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI))+((d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI)*(SP_S_x1-SP_S_bx)))))))-(0.5*(d_SP_S_bx_dV_DI_SI-(deriv_sqrt_1_d0*(((SP_S_bx*d_SP_S_bx_dV_DI_SI)+(d_SP_S_bx_dV_DI_SI*SP_S_bx)))))));
                SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
              }

              d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_eta_dV_SI_BP);
              d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_eta_dV_GP_SI);
              d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_eta_dV_DI_SI);
              SP_S_temp = (xg-SP_S_eta);
              {
                double value_exp_0 = exp((-SP_S_eta));
                double  deriv_exp_0_d0 = value_exp_0;

                d_SP_S_temp1_dV_SI_BP = (deriv_exp_0_d0*((-d_SP_S_eta_dV_SI_BP)));
                d_SP_S_temp1_dV_GP_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_GP_SI)));
                d_SP_S_temp1_dV_DI_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_DI_SI)));
                SP_S_temp1 = value_exp_0;
              }

              d_SP_S_temp2_dV_SI_BP = (-((SP_S_eta*d_SP_S_eta_dV_SI_BP)+(d_SP_S_eta_dV_SI_BP*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
              d_SP_S_temp2_dV_GP_SI = (-((SP_S_eta*d_SP_S_eta_dV_GP_SI)+(d_SP_S_eta_dV_GP_SI*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
              d_SP_S_temp2_dV_DI_SI = (-((SP_S_eta*d_SP_S_eta_dV_DI_SI)+(d_SP_S_eta_dV_DI_SI*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
              SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));

              d_SP_S_xi0_dV_SI_BP = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_SI_BP)+(((SP_S_eta*d_SP_S_eta_dV_SI_BP)+(d_SP_S_eta_dV_SI_BP*SP_S_eta))*SP_S_temp2));
              d_SP_S_xi0_dV_GP_SI = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_GP_SI)+(((SP_S_eta*d_SP_S_eta_dV_GP_SI)+(d_SP_S_eta_dV_GP_SI*SP_S_eta))*SP_S_temp2));
              d_SP_S_xi0_dV_DI_SI = (((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_DI_SI)+(((SP_S_eta*d_SP_S_eta_dV_DI_SI)+(d_SP_S_eta_dV_DI_SI*SP_S_eta))*SP_S_temp2));
              SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);

              d_SP_S_xi1_dV_SI_BP = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP)+(((SP_S_eta*d_SP_S_temp2_dV_SI_BP)+(d_SP_S_eta_dV_SI_BP*SP_S_temp2))*SP_S_temp2)));
              d_SP_S_xi1_dV_GP_SI = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI)+(((SP_S_eta*d_SP_S_temp2_dV_GP_SI)+(d_SP_S_eta_dV_GP_SI*SP_S_temp2))*SP_S_temp2)));
              d_SP_S_xi1_dV_DI_SI = (4.0*(((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI)+(((SP_S_eta*d_SP_S_temp2_dV_DI_SI)+(d_SP_S_eta_dV_DI_SI*SP_S_temp2))*SP_S_temp2)));
              SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));

              d_SP_S_xi2_dV_SI_BP = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_SI_BP)+(((8.0*d_SP_S_temp2_dV_SI_BP)-(12.0*d_SP_S_xi0_dV_SI_BP))*SP_S_temp2))*SP_S_temp2));
              d_SP_S_xi2_dV_GP_SI = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_GP_SI)+(((8.0*d_SP_S_temp2_dV_GP_SI)-(12.0*d_SP_S_xi0_dV_GP_SI))*SP_S_temp2))*SP_S_temp2));
              d_SP_S_xi2_dV_DI_SI = (((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI)+(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_DI_SI)+(((8.0*d_SP_S_temp2_dV_DI_SI)-(12.0*d_SP_S_xi0_dV_DI_SI))*SP_S_temp2))*SP_S_temp2));
              SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
              {
                double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))));
                double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);

                d_SP_S_a_dV_SI_BP = 0.0;
                d_SP_S_a_dV_GP_SI = 0.0;
                d_SP_S_a_dV_DI_SI = 0.0;
                SP_S_a = value_max_0;
              }

              d_SP_S_b_dV_SI_BP = (-(0.5*((Gf2*(d_SP_S_temp1_dV_SI_BP-((delta_nd*d_SP_S_xi2_dV_SI_BP)+(d_delta_nd_dV_SI_BP*SP_S_xi2))))+(d_Gf2_dV_SI_BP*(SP_S_temp1-(delta_nd*SP_S_xi2))))));
              d_SP_S_b_dV_GP_SI = (-(0.5*((Gf2*(d_SP_S_temp1_dV_GP_SI-((delta_nd*d_SP_S_xi2_dV_GP_SI)+(d_delta_nd_dV_GP_SI*SP_S_xi2))))+(d_Gf2_dV_GP_SI*(SP_S_temp1-(delta_nd*SP_S_xi2))))));
              d_SP_S_b_dV_DI_SI = (-(0.5*((Gf2*(d_SP_S_temp1_dV_DI_SI-((delta_nd*d_SP_S_xi2_dV_DI_SI)+(d_delta_nd_dV_DI_SI*SP_S_xi2))))+(d_Gf2_dV_DI_SI*(SP_S_temp1-(delta_nd*SP_S_xi2))))));
              SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))));

              d_SP_S_c_dV_SI_BP = ((2.0*d_SP_S_temp_dV_SI_BP)+((Gf2*((-d_SP_S_temp1_dV_SI_BP)-((delta_nd*d_SP_S_xi1_dV_SI_BP)+(d_delta_nd_dV_SI_BP*(1.0+SP_S_xi1)))))+(d_Gf2_dV_SI_BP*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1))))));
              d_SP_S_c_dV_GP_SI = ((2.0*d_SP_S_temp_dV_GP_SI)+((Gf2*((-d_SP_S_temp1_dV_GP_SI)-((delta_nd*d_SP_S_xi1_dV_GP_SI)+(d_delta_nd_dV_GP_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_GP_SI*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1))))));
              d_SP_S_c_dV_DI_SI = ((2.0*d_SP_S_temp_dV_DI_SI)+((Gf2*((-d_SP_S_temp1_dV_DI_SI)-((delta_nd*d_SP_S_xi1_dV_DI_SI)+(d_delta_nd_dV_DI_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_DI_SI*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1))))));
              SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
              {
                double value_log_0 = log((SP_S_a/Gf2));
                double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));

                d_SP_S_tau_dV_SI_BP = ((d_xn_d_dV_SI_BP-d_SP_S_eta_dV_SI_BP)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_SI_BP-SP_S_a*d_Gf2_dV_SI_BP)/Gf2/Gf2))));
                d_SP_S_tau_dV_DI_SI = ((d_xn_d_dV_DI_SI-d_SP_S_eta_dV_DI_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_DI_SI-SP_S_a*d_Gf2_dV_DI_SI)/Gf2/Gf2))));
                d_SP_S_tau_dV_GP_SI = ((d_xn_d_dV_GP_SI-d_SP_S_eta_dV_GP_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_GP_SI-SP_S_a*d_Gf2_dV_GP_SI)/Gf2/Gf2))));
                SP_S_tau = ((xn_d-SP_S_eta)+value_log_0);
              }

              d_nu_dV_SI_BP = (d_SP_S_a_dV_SI_BP+d_SP_S_c_dV_SI_BP);
              d_nu_dV_GP_SI = (d_SP_S_a_dV_GP_SI+d_SP_S_c_dV_GP_SI);
              d_nu_dV_DI_SI = (d_SP_S_a_dV_DI_SI+d_SP_S_c_dV_DI_SI);
              nu = (SP_S_a+SP_S_c);

              d_mutau_dV_SI_BP = (((nu*d_nu_dV_SI_BP)+(d_nu_dV_SI_BP*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_SI_BP)+(d_SP_S_c_dV_SI_BP*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*SP_S_b))))+(d_SP_S_tau_dV_SI_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
              d_mutau_dV_GP_SI = (((nu*d_nu_dV_GP_SI)+(d_nu_dV_GP_SI*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_GP_SI)+(d_SP_S_c_dV_GP_SI*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*SP_S_b))))+(d_SP_S_tau_dV_GP_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
              d_mutau_dV_DI_SI = (((nu*d_nu_dV_DI_SI)+(d_nu_dV_DI_SI*nu))+((SP_S_tau*((0.5*((SP_S_c*d_SP_S_c_dV_DI_SI)+(d_SP_S_c_dV_DI_SI*SP_S_c)))-((SP_S_a*d_SP_S_b_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*SP_S_b))))+(d_SP_S_tau_dV_DI_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))));
              mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));

              d_SP_S_x0_dV_SI_BP = (d_SP_S_eta_dV_SI_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_SI_BP)+(((SP_S_a*d_nu_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_SI_BP+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_SI_BP)+(d_SP_S_c_dV_SI_BP*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_SI_BP)+(d_SP_S_a_dV_SI_BP*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_SI_BP)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_SI_BP)+((((nu/mutau)*d_SP_S_tau_dV_SI_BP)+(((mutau*d_nu_dV_SI_BP-nu*d_mutau_dV_SI_BP)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
              d_SP_S_x0_dV_GP_SI = (d_SP_S_eta_dV_GP_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_GP_SI)+(((SP_S_a*d_nu_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_SI+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_GP_SI)+(d_SP_S_c_dV_GP_SI*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_GP_SI)+(d_SP_S_a_dV_GP_SI*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_SI)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_SI)+((((nu/mutau)*d_SP_S_tau_dV_GP_SI)+(((mutau*d_nu_dV_GP_SI-nu*d_mutau_dV_GP_SI)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
              d_SP_S_x0_dV_DI_SI = (d_SP_S_eta_dV_DI_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*(((SP_S_a*nu)*d_SP_S_tau_dV_DI_SI)+(((SP_S_a*d_nu_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*nu))*SP_S_tau))-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_DI_SI+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((((SP_S_c*d_SP_S_c_dV_DI_SI)+(d_SP_S_c_dV_DI_SI*SP_S_c))*3.3333333333333333e-01)-((SP_S_a*d_SP_S_b_dV_DI_SI)+(d_SP_S_a_dV_DI_SI*SP_S_b))))+((((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_DI_SI)+(((((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_DI_SI)+((((nu/mutau)*d_SP_S_tau_dV_DI_SI)+(((mutau*d_nu_dV_DI_SI-nu*d_mutau_dV_DI_SI)/mutau/mutau)*SP_S_tau))*SP_S_tau))*SP_S_c))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
              SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
              if ((SP_S_x0<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(SP_S_x0);
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*(d_SP_S_x0_dV_SI_BP));
                  d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_SI));
                  d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_DI_SI));
                  SP_S_delta0 = value_exp_0;
                }

                d_SP_S_delta1_dV_SI_BP = (-d_SP_S_delta0_dV_SI_BP/SP_S_delta0/SP_S_delta0);
                d_SP_S_delta1_dV_GP_SI = (-d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
                d_SP_S_delta1_dV_DI_SI = (-d_SP_S_delta0_dV_DI_SI/SP_S_delta0/SP_S_delta0);
                SP_S_delta1 = (1.0/SP_S_delta0);

                d_SP_S_delta0_dV_SI_BP = ((delta_nd*d_SP_S_delta0_dV_SI_BP)+(d_delta_nd_dV_SI_BP*SP_S_delta0));
                d_SP_S_delta0_dV_DI_SI = ((delta_nd*d_SP_S_delta0_dV_DI_SI)+(d_delta_nd_dV_DI_SI*SP_S_delta0));
                d_SP_S_delta0_dV_GP_SI = ((delta_nd*d_SP_S_delta0_dV_GP_SI)+(d_delta_nd_dV_GP_SI*SP_S_delta0));
                SP_S_delta0 = (delta_nd*SP_S_delta0);
              }
              else
              {
                if ((SP_S_x0>(xn_d-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp((SP_S_x0-xn_d));
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*((d_SP_S_x0_dV_SI_BP-d_xn_d_dV_SI_BP)));
                    d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_GP_SI-d_xn_d_dV_GP_SI)));
                    d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_DI_SI-d_xn_d_dV_DI_SI)));
                    SP_S_delta0 = value_exp_0;
                  }

                  d_SP_S_delta1_dV_SI_BP = ((SP_S_delta0*d_delta_nd_dV_SI_BP-delta_nd*d_SP_S_delta0_dV_SI_BP)/SP_S_delta0/SP_S_delta0);
                  d_SP_S_delta1_dV_DI_SI = ((SP_S_delta0*d_delta_nd_dV_DI_SI-delta_nd*d_SP_S_delta0_dV_DI_SI)/SP_S_delta0/SP_S_delta0);
                  d_SP_S_delta1_dV_GP_SI = ((SP_S_delta0*d_delta_nd_dV_GP_SI-delta_nd*d_SP_S_delta0_dV_GP_SI)/SP_S_delta0/SP_S_delta0);
                  SP_S_delta1 = (delta_nd/SP_S_delta0);
                }
                else
                {

                  d_SP_S_delta0_dV_SI_BP = (-1.0e-100*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*((d_xn_d_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*3.3333333333333333e-01))+((d_xn_d_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_SP_S_delta0_dV_DI_SI = (-1.0e-100*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*((d_xn_d_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*3.3333333333333333e-01))+((d_xn_d_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_SP_S_delta0_dV_GP_SI = (-1.0e-100*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*((((xn_d-SP_S_x0)-2.3025850929940458e+02)*((d_xn_d_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*3.3333333333333333e-01))+((d_xn_d_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  SP_S_delta0 = (1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

                  d_SP_S_delta1_dV_SI_BP = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_SI_BP*3.3333333333333333e-01))+(d_SP_S_x0_dV_SI_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_SI_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_SP_S_delta1_dV_GP_SI = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_GP_SI*3.3333333333333333e-01))+(d_SP_S_x0_dV_GP_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_GP_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_SP_S_delta1_dV_DI_SI = (-1.0e-100*(((SP_S_x0-2.3025850929940458e+02)*(0.5*(((SP_S_x0-2.3025850929940458e+02)*(d_SP_S_x0_dV_DI_SI*3.3333333333333333e-01))+(d_SP_S_x0_dV_DI_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_SP_S_x0_dV_DI_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_SP_S_temp_dV_SI_BP = (-((SP_S_x0*d_SP_S_x0_dV_SI_BP)+(d_SP_S_x0_dV_SI_BP*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
              d_SP_S_temp_dV_GP_SI = (-((SP_S_x0*d_SP_S_x0_dV_GP_SI)+(d_SP_S_x0_dV_GP_SI*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
              d_SP_S_temp_dV_DI_SI = (-((SP_S_x0*d_SP_S_x0_dV_DI_SI)+(d_SP_S_x0_dV_DI_SI*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
              SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));

              d_SP_S_xi0_dV_SI_BP = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_SI_BP)+(((SP_S_x0*d_SP_S_x0_dV_SI_BP)+(d_SP_S_x0_dV_SI_BP*SP_S_x0))*SP_S_temp));
              d_SP_S_xi0_dV_GP_SI = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_GP_SI)+(((SP_S_x0*d_SP_S_x0_dV_GP_SI)+(d_SP_S_x0_dV_GP_SI*SP_S_x0))*SP_S_temp));
              d_SP_S_xi0_dV_DI_SI = (((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_DI_SI)+(((SP_S_x0*d_SP_S_x0_dV_DI_SI)+(d_SP_S_x0_dV_DI_SI*SP_S_x0))*SP_S_temp));
              SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);

              d_SP_S_xi1_dV_SI_BP = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_SI_BP)+(((SP_S_x0*d_SP_S_temp_dV_SI_BP)+(d_SP_S_x0_dV_SI_BP*SP_S_temp))*SP_S_temp)));
              d_SP_S_xi1_dV_GP_SI = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_GP_SI)+(((SP_S_x0*d_SP_S_temp_dV_GP_SI)+(d_SP_S_x0_dV_GP_SI*SP_S_temp))*SP_S_temp)));
              d_SP_S_xi1_dV_DI_SI = (4.0*(((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_DI_SI)+(((SP_S_x0*d_SP_S_temp_dV_DI_SI)+(d_SP_S_x0_dV_DI_SI*SP_S_temp))*SP_S_temp)));
              SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));

              d_SP_S_xi2_dV_SI_BP = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_SI_BP)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_SI_BP)+(((8.0*d_SP_S_temp_dV_SI_BP)-(12.0*d_SP_S_xi0_dV_SI_BP))*SP_S_temp))*SP_S_temp));
              d_SP_S_xi2_dV_GP_SI = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_SI)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_SI)+(((8.0*d_SP_S_temp_dV_GP_SI)-(12.0*d_SP_S_xi0_dV_GP_SI))*SP_S_temp))*SP_S_temp));
              d_SP_S_xi2_dV_DI_SI = (((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_DI_SI)+(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_DI_SI)+(((8.0*d_SP_S_temp_dV_DI_SI)-(12.0*d_SP_S_xi0_dV_DI_SI))*SP_S_temp))*SP_S_temp));
              SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

              d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_x0_dV_SI_BP);
              d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_x0_dV_GP_SI);
              d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_x0_dV_DI_SI);
              SP_S_temp = (xg-SP_S_x0);

              d_SP_S_pC_dV_SI_BP = ((2.0*d_SP_S_temp_dV_SI_BP)+((Gf2*(((-d_SP_S_delta1_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-((delta_nd*d_SP_S_xi1_dV_SI_BP)+(d_delta_nd_dV_SI_BP*(1.0+SP_S_xi1)))))+(d_Gf2_dV_SI_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1))))));
              d_SP_S_pC_dV_GP_SI = ((2.0*d_SP_S_temp_dV_GP_SI)+((Gf2*(((-d_SP_S_delta1_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-((delta_nd*d_SP_S_xi1_dV_GP_SI)+(d_delta_nd_dV_GP_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_GP_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1))))));
              d_SP_S_pC_dV_DI_SI = ((2.0*d_SP_S_temp_dV_DI_SI)+((Gf2*(((-d_SP_S_delta1_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-((delta_nd*d_SP_S_xi1_dV_DI_SI)+(d_delta_nd_dV_DI_SI*(1.0+SP_S_xi1)))))+(d_Gf2_dV_DI_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1))))));
              SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));

              d_SP_S_qC_dV_SI_BP = (((SP_S_temp*d_SP_S_temp_dV_SI_BP)+(d_SP_S_temp_dV_SI_BP*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_SI_BP+d_SP_S_x0_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-((delta_nd*(d_SP_S_x0_dV_SI_BP+d_SP_S_xi0_dV_SI_BP))+(d_delta_nd_dV_SI_BP*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_SI_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0))))));
              d_SP_S_qC_dV_GP_SI = (((SP_S_temp*d_SP_S_temp_dV_GP_SI)+(d_SP_S_temp_dV_GP_SI*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_GP_SI+d_SP_S_x0_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-((delta_nd*(d_SP_S_x0_dV_GP_SI+d_SP_S_xi0_dV_GP_SI))+(d_delta_nd_dV_GP_SI*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_GP_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0))))));
              d_SP_S_qC_dV_DI_SI = (((SP_S_temp*d_SP_S_temp_dV_DI_SI)+(d_SP_S_temp_dV_DI_SI*SP_S_temp))-((Gf2*(((d_SP_S_delta1_dV_DI_SI+d_SP_S_x0_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-((delta_nd*(d_SP_S_x0_dV_DI_SI+d_SP_S_xi0_dV_DI_SI))+(d_delta_nd_dV_DI_SI*((SP_S_x0+1.0)+SP_S_xi0)))))+(d_Gf2_dV_DI_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0))))));
              SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));

              d_SP_S_temp_dV_SI_BP = (-((Gf2*((d_SP_S_delta1_dV_SI_BP+d_SP_S_delta0_dV_SI_BP)-((delta_nd*d_SP_S_xi2_dV_SI_BP)+(d_delta_nd_dV_SI_BP*SP_S_xi2))))+(d_Gf2_dV_SI_BP*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2)))));
              d_SP_S_temp_dV_GP_SI = (-((Gf2*((d_SP_S_delta1_dV_GP_SI+d_SP_S_delta0_dV_GP_SI)-((delta_nd*d_SP_S_xi2_dV_GP_SI)+(d_delta_nd_dV_GP_SI*SP_S_xi2))))+(d_Gf2_dV_GP_SI*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2)))));
              d_SP_S_temp_dV_DI_SI = (-((Gf2*((d_SP_S_delta1_dV_DI_SI+d_SP_S_delta0_dV_DI_SI)-((delta_nd*d_SP_S_xi2_dV_DI_SI)+(d_delta_nd_dV_DI_SI*SP_S_xi2))))+(d_Gf2_dV_DI_SI*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2)))));
              SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));

              d_SP_S_temp_dV_SI_BP = (((SP_S_pC*d_SP_S_pC_dV_SI_BP)+(d_SP_S_pC_dV_SI_BP*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_SI_BP)+(d_SP_S_qC_dV_SI_BP*SP_S_temp))));
              d_SP_S_temp_dV_GP_SI = (((SP_S_pC*d_SP_S_pC_dV_GP_SI)+(d_SP_S_pC_dV_GP_SI*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_GP_SI)+(d_SP_S_qC_dV_GP_SI*SP_S_temp))));
              d_SP_S_temp_dV_DI_SI = (((SP_S_pC*d_SP_S_pC_dV_DI_SI)+(d_SP_S_pC_dV_DI_SI*SP_S_pC))-(2.0*((SP_S_qC*d_SP_S_temp_dV_DI_SI)+(d_SP_S_qC_dV_DI_SI*SP_S_temp))));
              SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
              {
                double value_sqrt_0 = sqrt(SP_S_temp);
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_x_d_dV_SI_BP = (d_SP_S_x0_dV_SI_BP+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_SI_BP-SP_S_qC*(d_SP_S_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_SI_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
                d_x_d_dV_GP_SI = (d_SP_S_x0_dV_GP_SI+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_SI-SP_S_qC*(d_SP_S_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
                d_x_d_dV_DI_SI = (d_SP_S_x0_dV_DI_SI+(2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_DI_SI-SP_S_qC*(d_SP_S_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_DI_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0))));
                x_d = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
              }
            }

            d_x_ds_dV_SI_BP = (d_x_d_dV_SI_BP-d_x_s_dV_SI_BP);
            d_x_ds_dV_GP_SI = (d_x_d_dV_GP_SI-d_x_s_dV_GP_SI);
            d_x_ds_dV_DI_SI = (d_x_d_dV_DI_SI-d_x_s_dV_DI_SI);
            x_ds = (x_d-x_s);
            if ((x_ds<1.0e-10))
            {

              d_pC_dV_SI_BP = ((2.0*(d_xg_dV_SI_BP-d_x_s_dV_SI_BP))+((Gf2*(((-d_Es_dV_SI_BP)+((delta_1s*d_k_ds_dV_SI_BP)+(d_delta_1s_dV_SI_BP*k_ds)))-((delta_nd*d_xi1s_dV_SI_BP)+(d_delta_nd_dV_SI_BP*(1.0+xi1s)))))+(d_Gf2_dV_SI_BP*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s))))));
              d_pC_dV_GP_SI = ((2.0*(d_xg_dV_GP_SI-d_x_s_dV_GP_SI))+((Gf2*(((-d_Es_dV_GP_SI)+((delta_1s*d_k_ds_dV_GP_SI)+(d_delta_1s_dV_GP_SI*k_ds)))-((delta_nd*d_xi1s_dV_GP_SI)+(d_delta_nd_dV_GP_SI*(1.0+xi1s)))))+(d_Gf2_dV_GP_SI*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s))))));
              d_pC_dV_DI_SI = ((2.0*(d_xg_dV_DI_SI-d_x_s_dV_DI_SI))+((Gf2*(((-d_Es_dV_DI_SI)+((delta_1s*d_k_ds_dV_DI_SI)+(d_delta_1s_dV_DI_SI*k_ds)))-((delta_nd*d_xi1s_dV_DI_SI)+(d_delta_nd_dV_DI_SI*(1.0+xi1s)))))+(d_Gf2_dV_DI_SI*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s))))));
              pC = ((2.0*(xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));

              d_qC_dV_SI_BP = (((Gf2*(1.0-k_ds))*d_Ds_dV_SI_BP)+(((Gf2*(-d_k_ds_dV_SI_BP))+(d_Gf2_dV_SI_BP*(1.0-k_ds)))*Ds));
              d_qC_dV_GP_SI = (((Gf2*(1.0-k_ds))*d_Ds_dV_GP_SI)+(((Gf2*(-d_k_ds_dV_GP_SI))+(d_Gf2_dV_GP_SI*(1.0-k_ds)))*Ds));
              d_qC_dV_DI_SI = (((Gf2*(1.0-k_ds))*d_Ds_dV_DI_SI)+(((Gf2*(-d_k_ds_dV_DI_SI))+(d_Gf2_dV_DI_SI*(1.0-k_ds)))*Ds));
              qC = ((Gf2*(1.0-k_ds))*Ds);

              d_temp_dV_SI_BP = (-((Gf2*((d_Es_dV_SI_BP+((delta_1s*d_k_ds_dV_SI_BP)+(d_delta_1s_dV_SI_BP*k_ds)))-((delta_nd*d_xi2s_dV_SI_BP)+(d_delta_nd_dV_SI_BP*xi2s))))+(d_Gf2_dV_SI_BP*((Es+(delta_1s*k_ds))-(delta_nd*xi2s)))));
              d_temp_dV_GP_SI = (-((Gf2*((d_Es_dV_GP_SI+((delta_1s*d_k_ds_dV_GP_SI)+(d_delta_1s_dV_GP_SI*k_ds)))-((delta_nd*d_xi2s_dV_GP_SI)+(d_delta_nd_dV_GP_SI*xi2s))))+(d_Gf2_dV_GP_SI*((Es+(delta_1s*k_ds))-(delta_nd*xi2s)))));
              d_temp_dV_DI_SI = (-((Gf2*((d_Es_dV_DI_SI+((delta_1s*d_k_ds_dV_DI_SI)+(d_delta_1s_dV_DI_SI*k_ds)))-((delta_nd*d_xi2s_dV_DI_SI)+(d_delta_nd_dV_DI_SI*xi2s))))+(d_Gf2_dV_DI_SI*((Es+(delta_1s*k_ds))-(delta_nd*xi2s)))));
              temp = (2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));

              d_temp_dV_SI_BP = (((pC*d_pC_dV_SI_BP)+(d_pC_dV_SI_BP*pC))-(2.0*((temp*d_qC_dV_SI_BP)+(d_temp_dV_SI_BP*qC))));
              d_temp_dV_GP_SI = (((pC*d_pC_dV_GP_SI)+(d_pC_dV_GP_SI*pC))-(2.0*((temp*d_qC_dV_GP_SI)+(d_temp_dV_GP_SI*qC))));
              d_temp_dV_DI_SI = (((pC*d_pC_dV_DI_SI)+(d_pC_dV_DI_SI*pC))-(2.0*((temp*d_qC_dV_DI_SI)+(d_temp_dV_DI_SI*qC))));
              temp = ((pC*pC)-(2.0*(temp*qC)));
              {
                double value_sqrt_0 = sqrt(temp);
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_x_ds_dV_SI_BP = (2.0*(((pC+value_sqrt_0)*d_qC_dV_SI_BP-qC*(d_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_temp_dV_SI_BP))))/(pC+value_sqrt_0)/(pC+value_sqrt_0)));
                d_x_ds_dV_GP_SI = (2.0*(((pC+value_sqrt_0)*d_qC_dV_GP_SI-qC*(d_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_temp_dV_GP_SI))))/(pC+value_sqrt_0)/(pC+value_sqrt_0)));
                d_x_ds_dV_DI_SI = (2.0*(((pC+value_sqrt_0)*d_qC_dV_DI_SI-qC*(d_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_temp_dV_DI_SI))))/(pC+value_sqrt_0)/(pC+value_sqrt_0)));
                x_ds = (2.0*(qC/(pC+value_sqrt_0)));
              }

              d_x_d_dV_SI_BP = (d_x_s_dV_SI_BP+d_x_ds_dV_SI_BP);
              d_x_d_dV_GP_SI = (d_x_s_dV_GP_SI+d_x_ds_dV_GP_SI);
              d_x_d_dV_DI_SI = (d_x_s_dV_DI_SI+d_x_ds_dV_DI_SI);
              x_d = (x_s+x_ds);
            }

            d_dps_dV_SI_BP = ((x_ds*d_phit1_dV_SI_BP)+(d_x_ds_dV_SI_BP*phit1));
            d_dps_dV_GP_SI = ((x_ds*d_phit1_dV_GP_SI)+(d_x_ds_dV_GP_SI*phit1));
            d_dps_dV_DI_SI = ((x_ds*d_phit1_dV_DI_SI)+(d_x_ds_dV_DI_SI*phit1));
            dps = (x_ds*phit1);

            d_xi0d_dV_SI_BP = (((2.0+(x_d*x_d))*((x_d*d_x_d_dV_SI_BP)+(d_x_d_dV_SI_BP*x_d))-(x_d*x_d)*((x_d*d_x_d_dV_SI_BP)+(d_x_d_dV_SI_BP*x_d)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
            d_xi0d_dV_GP_SI = (((2.0+(x_d*x_d))*((x_d*d_x_d_dV_GP_SI)+(d_x_d_dV_GP_SI*x_d))-(x_d*x_d)*((x_d*d_x_d_dV_GP_SI)+(d_x_d_dV_GP_SI*x_d)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
            d_xi0d_dV_DI_SI = (((2.0+(x_d*x_d))*((x_d*d_x_d_dV_DI_SI)+(d_x_d_dV_DI_SI*x_d))-(x_d*x_d)*((x_d*d_x_d_dV_DI_SI)+(d_x_d_dV_DI_SI*x_d)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
            xi0d = ((x_d*x_d)/(2.0+(x_d*x_d)));
            if ((x_d<2.3025850929940458e+02))
            {
              {
                double value_exp_0 = exp((-x_d));
                double  deriv_exp_0_d0 = value_exp_0;

                d_Ed_dV_SI_BP = (deriv_exp_0_d0*((-d_x_d_dV_SI_BP)));
                d_Ed_dV_GP_SI = (deriv_exp_0_d0*((-d_x_d_dV_GP_SI)));
                d_Ed_dV_DI_SI = (deriv_exp_0_d0*((-d_x_d_dV_DI_SI)));
                Ed = value_exp_0;
              }
              if ((x_d<1.0e-5))
              {

                d_Dd_dV_SI_BP = ((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.75*d_x_d_dV_SI_BP))+((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_SI_BP)+(((((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_SI_BP)+((((1.6666666666666667e-01*delta_nd)*d_x_d_dV_SI_BP)+((1.6666666666666667e-01*d_delta_nd_dV_SI_BP)*x_d))*x_d))*x_d))*(1.0+(1.75*x_d))));
                d_Dd_dV_DI_SI = ((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.75*d_x_d_dV_DI_SI))+((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_DI_SI)+(((((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_DI_SI)+((((1.6666666666666667e-01*delta_nd)*d_x_d_dV_DI_SI)+((1.6666666666666667e-01*d_delta_nd_dV_DI_SI)*x_d))*x_d))*x_d))*(1.0+(1.75*x_d))));
                d_Dd_dV_GP_SI = ((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.75*d_x_d_dV_GP_SI))+((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_GP_SI)+(((((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_GP_SI)+((((1.6666666666666667e-01*delta_nd)*d_x_d_dV_GP_SI)+((1.6666666666666667e-01*d_delta_nd_dV_GP_SI)*x_d))*x_d))*x_d))*(1.0+(1.75*x_d))));
                Dd = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
              }
              else
              {

                d_Dd_dV_SI_BP = ((delta_nd*(((-d_Ed_dV_SI_BP/Ed/Ed)-d_x_d_dV_SI_BP)-d_xi0d_dV_SI_BP))+(d_delta_nd_dV_SI_BP*((((1.0/Ed)-x_d)-1.0)-xi0d)));
                d_Dd_dV_DI_SI = ((delta_nd*(((-d_Ed_dV_DI_SI/Ed/Ed)-d_x_d_dV_DI_SI)-d_xi0d_dV_DI_SI))+(d_delta_nd_dV_DI_SI*((((1.0/Ed)-x_d)-1.0)-xi0d)));
                d_Dd_dV_GP_SI = ((delta_nd*(((-d_Ed_dV_GP_SI/Ed/Ed)-d_x_d_dV_GP_SI)-d_xi0d_dV_GP_SI))+(d_delta_nd_dV_GP_SI*((((1.0/Ed)-x_d)-1.0)-xi0d)));
                Dd = (delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d));
              }
            }
            else
            {
              if ((x_d>(xn_d-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp((x_d-xn_d));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_temp_dV_SI_BP = (deriv_exp_0_d0*((d_x_d_dV_SI_BP-d_xn_d_dV_SI_BP)));
                  d_temp_dV_GP_SI = (deriv_exp_0_d0*((d_x_d_dV_GP_SI-d_xn_d_dV_GP_SI)));
                  d_temp_dV_DI_SI = (deriv_exp_0_d0*((d_x_d_dV_DI_SI-d_xn_d_dV_DI_SI)));
                  temp = value_exp_0;
                }

                d_Ed_dV_SI_BP = ((temp*d_delta_nd_dV_SI_BP-delta_nd*d_temp_dV_SI_BP)/temp/temp);
                d_Ed_dV_DI_SI = ((temp*d_delta_nd_dV_DI_SI-delta_nd*d_temp_dV_DI_SI)/temp/temp);
                d_Ed_dV_GP_SI = ((temp*d_delta_nd_dV_GP_SI-delta_nd*d_temp_dV_GP_SI)/temp/temp);
                Ed = (delta_nd/temp);

                d_Dd_dV_SI_BP = (d_temp_dV_SI_BP-((delta_nd*(d_x_d_dV_SI_BP+d_xi0d_dV_SI_BP))+(d_delta_nd_dV_SI_BP*((x_d+1.0)+xi0d))));
                d_Dd_dV_DI_SI = (d_temp_dV_DI_SI-((delta_nd*(d_x_d_dV_DI_SI+d_xi0d_dV_DI_SI))+(d_delta_nd_dV_DI_SI*((x_d+1.0)+xi0d))));
                d_Dd_dV_GP_SI = (d_temp_dV_GP_SI-((delta_nd*(d_x_d_dV_GP_SI+d_xi0d_dV_GP_SI))+(d_delta_nd_dV_GP_SI*((x_d+1.0)+xi0d))));
                Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
              }
              else
              {

                d_Ed_dV_SI_BP = (-1.0e-100*(((x_d-2.3025850929940458e+02)*(0.5*(((x_d-2.3025850929940458e+02)*(d_x_d_dV_SI_BP*3.3333333333333333e-01))+(d_x_d_dV_SI_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_d_dV_SI_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_Ed_dV_GP_SI = (-1.0e-100*(((x_d-2.3025850929940458e+02)*(0.5*(((x_d-2.3025850929940458e+02)*(d_x_d_dV_GP_SI*3.3333333333333333e-01))+(d_x_d_dV_GP_SI*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_d_dV_GP_SI*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_Ed_dV_DI_SI = (-1.0e-100*(((x_d-2.3025850929940458e+02)*(0.5*(((x_d-2.3025850929940458e+02)*(d_x_d_dV_DI_SI*3.3333333333333333e-01))+(d_x_d_dV_DI_SI*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(d_x_d_dV_DI_SI*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                Ed = (1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

                d_temp_dV_SI_BP = (-1.0e-100*((((xn_d-x_d)-2.3025850929940458e+02)*(0.5*((((xn_d-x_d)-2.3025850929940458e+02)*((d_xn_d_dV_SI_BP-d_x_d_dV_SI_BP)*3.3333333333333333e-01))+((d_xn_d_dV_SI_BP-d_x_d_dV_SI_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_SI_BP-d_x_d_dV_SI_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_temp_dV_DI_SI = (-1.0e-100*((((xn_d-x_d)-2.3025850929940458e+02)*(0.5*((((xn_d-x_d)-2.3025850929940458e+02)*((d_xn_d_dV_DI_SI-d_x_d_dV_DI_SI)*3.3333333333333333e-01))+((d_xn_d_dV_DI_SI-d_x_d_dV_DI_SI)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_DI_SI-d_x_d_dV_DI_SI)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                d_temp_dV_GP_SI = (-1.0e-100*((((xn_d-x_d)-2.3025850929940458e+02)*(0.5*((((xn_d-x_d)-2.3025850929940458e+02)*((d_xn_d_dV_GP_SI-d_x_d_dV_GP_SI)*3.3333333333333333e-01))+((d_xn_d_dV_GP_SI-d_x_d_dV_GP_SI)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((d_xn_d_dV_GP_SI-d_x_d_dV_GP_SI)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                temp = (1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

                d_Dd_dV_SI_BP = (d_temp_dV_SI_BP-((delta_nd*(d_x_d_dV_SI_BP+d_xi0d_dV_SI_BP))+(d_delta_nd_dV_SI_BP*((x_d+1.0)+xi0d))));
                d_Dd_dV_DI_SI = (d_temp_dV_DI_SI-((delta_nd*(d_x_d_dV_DI_SI+d_xi0d_dV_DI_SI))+(d_delta_nd_dV_DI_SI*((x_d+1.0)+xi0d))));
                d_Dd_dV_GP_SI = (d_temp_dV_GP_SI-((delta_nd*(d_x_d_dV_GP_SI+d_xi0d_dV_GP_SI))+(d_delta_nd_dV_GP_SI*((x_d+1.0)+xi0d))));
                Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
              }
            }

            d_x_m_dV_SI_BP = (0.5*(d_x_s_dV_SI_BP+d_x_d_dV_SI_BP));
            d_x_m_dV_GP_SI = (0.5*(d_x_s_dV_GP_SI+d_x_d_dV_GP_SI));
            d_x_m_dV_DI_SI = (0.5*(d_x_s_dV_DI_SI+d_x_d_dV_DI_SI));
            x_m = (0.5*(x_s+x_d));

            d_Em_dV_DI_SI = d_Em_dV_GP_SI = d_Em_dV_SI_BP =  0.0;
            Em = 0.0;

            d_temp_dV_SI_BP = ((Ed*d_Es_dV_SI_BP)+(d_Ed_dV_SI_BP*Es));
            d_temp_dV_GP_SI = ((Ed*d_Es_dV_GP_SI)+(d_Ed_dV_GP_SI*Es));
            d_temp_dV_DI_SI = ((Ed*d_Es_dV_DI_SI)+(d_Ed_dV_DI_SI*Es));
            temp = (Ed*Es);
            if ((temp>0.0))
            {
              {
                double value_sqrt_0 = sqrt(temp);
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_Em_dV_SI_BP = (deriv_sqrt_0_d0*(d_temp_dV_SI_BP));
                d_Em_dV_DI_SI = (deriv_sqrt_0_d0*(d_temp_dV_DI_SI));
                d_Em_dV_GP_SI = (deriv_sqrt_0_d0*(d_temp_dV_GP_SI));
                Em = value_sqrt_0;
              }
            }

            d_D_bar_dV_SI_BP = (0.5*(d_Ds_dV_SI_BP+d_Dd_dV_SI_BP));
            d_D_bar_dV_GP_SI = (0.5*(d_Ds_dV_GP_SI+d_Dd_dV_GP_SI));
            d_D_bar_dV_DI_SI = (0.5*(d_Ds_dV_DI_SI+d_Dd_dV_DI_SI));
            D_bar = (0.5*(Ds+Dd));

            d_Dm_dV_SI_BP = (d_D_bar_dV_SI_BP+(0.125*(((x_ds*x_ds)*(d_Em_dV_SI_BP-(2.0*d_inv_Gf2_dV_SI_BP)))+(((x_ds*d_x_ds_dV_SI_BP)+(d_x_ds_dV_SI_BP*x_ds))*(Em-(2.0*inv_Gf2))))));
            d_Dm_dV_GP_SI = (d_D_bar_dV_GP_SI+(0.125*(((x_ds*x_ds)*(d_Em_dV_GP_SI-(2.0*d_inv_Gf2_dV_GP_SI)))+(((x_ds*d_x_ds_dV_GP_SI)+(d_x_ds_dV_GP_SI*x_ds))*(Em-(2.0*inv_Gf2))))));
            d_Dm_dV_DI_SI = (d_D_bar_dV_DI_SI+(0.125*(((x_ds*x_ds)*(d_Em_dV_DI_SI-(2.0*d_inv_Gf2_dV_DI_SI)))+(((x_ds*d_x_ds_dV_DI_SI)+(d_x_ds_dV_DI_SI*x_ds))*(Em-(2.0*inv_Gf2))))));
            Dm = (D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))));
            if ((x_m<1.0e-5))
            {

              d_Pm_dV_SI_BP = (0.5*(((x_m*x_m)*(-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_SI_BP)))+(d_x_m_dV_SI_BP*(1.0-(0.25*x_m)))))))+(((x_m*d_x_m_dV_SI_BP)+(d_x_m_dV_SI_BP*x_m))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))));
              d_Pm_dV_GP_SI = (0.5*(((x_m*x_m)*(-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_GP_SI)))+(d_x_m_dV_GP_SI*(1.0-(0.25*x_m)))))))+(((x_m*d_x_m_dV_GP_SI)+(d_x_m_dV_GP_SI*x_m))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))));
              d_Pm_dV_DI_SI = (0.5*(((x_m*x_m)*(-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_DI_SI)))+(d_x_m_dV_DI_SI*(1.0-(0.25*x_m)))))))+(((x_m*d_x_m_dV_DI_SI)+(d_x_m_dV_DI_SI*x_m))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))));
              Pm = (0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))));
              {
                double value_sqrt_0 = sqrt((Dm+Pm));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_xgm_dV_SI_BP = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_SI_BP+d_Pm_dV_SI_BP))))+(d_Gf_dV_SI_BP*value_sqrt_0));
                d_xgm_dV_GP_SI = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_SI+d_Pm_dV_GP_SI))))+(d_Gf_dV_GP_SI*value_sqrt_0));
                d_xgm_dV_DI_SI = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_DI_SI+d_Pm_dV_DI_SI))))+(d_Gf_dV_DI_SI*value_sqrt_0));
                xgm = (Gf*value_sqrt_0);
              }
              if ((kp>0.0))
              {
                {
                  double value_sqrt_0 = sqrt((1.0+(kp*xgm)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_eta_p_dV_SI_BP = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_SI_BP)))/value_sqrt_0/value_sqrt_0);
                  d_eta_p_dV_GP_SI = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_GP_SI)))/value_sqrt_0/value_sqrt_0);
                  d_eta_p_dV_DI_SI = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_DI_SI)))/value_sqrt_0/value_sqrt_0);
                  eta_p = (1.0/value_sqrt_0);
                }
              }
              {
                double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_temp_dV_SI_BP = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_SI_BP)))+(d_x_m_dV_SI_BP*(1.0-(0.25*x_m))))))));
                d_temp_dV_GP_SI = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_GP_SI)))+(d_x_m_dV_GP_SI*(1.0-(0.25*x_m))))))));
                d_temp_dV_DI_SI = (deriv_sqrt_0_d0*((-(3.3333333333333333e-01*((x_m*(-(0.25*d_x_m_dV_DI_SI)))+(d_x_m_dV_DI_SI*(1.0-(0.25*x_m))))))));
                temp = value_sqrt_0;
              }

              d_sqm_dV_SI_BP = (7.0710678118654746e-01*((x_m*d_temp_dV_SI_BP)+(d_x_m_dV_SI_BP*temp)));
              d_sqm_dV_GP_SI = (7.0710678118654746e-01*((x_m*d_temp_dV_GP_SI)+(d_x_m_dV_GP_SI*temp)));
              d_sqm_dV_DI_SI = (7.0710678118654746e-01*((x_m*d_temp_dV_DI_SI)+(d_x_m_dV_DI_SI*temp)));
              sqm = (7.0710678118654746e-01*(x_m*temp));

              d_alpha_dV_SI_BP = (d_eta_p_dV_SI_BP+(7.0710678118654746e-01*((temp*((Gf*((-(0.5*d_x_m_dV_SI_BP))+(1.6666666666666667e-01*((x_m*d_x_m_dV_SI_BP)+(d_x_m_dV_SI_BP*x_m)))))+(d_Gf_dV_SI_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_SI_BP)/temp/temp)));
              d_alpha_dV_GP_SI = (d_eta_p_dV_GP_SI+(7.0710678118654746e-01*((temp*((Gf*((-(0.5*d_x_m_dV_GP_SI))+(1.6666666666666667e-01*((x_m*d_x_m_dV_GP_SI)+(d_x_m_dV_GP_SI*x_m)))))+(d_Gf_dV_GP_SI*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_GP_SI)/temp/temp)));
              d_alpha_dV_DI_SI = (d_eta_p_dV_DI_SI+(7.0710678118654746e-01*((temp*((Gf*((-(0.5*d_x_m_dV_DI_SI))+(1.6666666666666667e-01*((x_m*d_x_m_dV_DI_SI)+(d_x_m_dV_DI_SI*x_m)))))+(d_Gf_dV_DI_SI*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_DI_SI)/temp/temp)));
              alpha = (eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)));
            }
            else
            {

              d_Pm_dV_SI_BP = (d_x_m_dV_SI_BP+d_Em_dV_SI_BP);
              d_Pm_dV_GP_SI = (d_x_m_dV_GP_SI+d_Em_dV_GP_SI);
              d_Pm_dV_DI_SI = (d_x_m_dV_DI_SI+d_Em_dV_DI_SI);
              Pm = ((x_m-1.0)+Em);
              {
                double value_sqrt_0 = sqrt((Dm+Pm));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_xgm_dV_SI_BP = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_SI_BP+d_Pm_dV_SI_BP))))+(d_Gf_dV_SI_BP*value_sqrt_0));
                d_xgm_dV_GP_SI = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_SI+d_Pm_dV_GP_SI))))+(d_Gf_dV_GP_SI*value_sqrt_0));
                d_xgm_dV_DI_SI = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_DI_SI+d_Pm_dV_DI_SI))))+(d_Gf_dV_DI_SI*value_sqrt_0));
                xgm = (Gf*value_sqrt_0);
              }
              if ((kp>0.0))
              {

                d_d0_dV_SI_BP = ((-d_Em_dV_SI_BP)+(2.0*((xgm*d_inv_Gf2_dV_SI_BP)+(d_xgm_dV_SI_BP*inv_Gf2))));
                d_d0_dV_GP_SI = ((-d_Em_dV_GP_SI)+(2.0*((xgm*d_inv_Gf2_dV_GP_SI)+(d_xgm_dV_GP_SI*inv_Gf2))));
                d_d0_dV_DI_SI = ((-d_Em_dV_DI_SI)+(2.0*((xgm*d_inv_Gf2_dV_DI_SI)+(d_xgm_dV_DI_SI*inv_Gf2))));
                d0 = ((1.0-Em)+(2.0*(xgm*inv_Gf2)));
                {
                  double value_sqrt_0 = sqrt((1.0+(kp*xgm)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_eta_p_dV_SI_BP = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_SI_BP)))/value_sqrt_0/value_sqrt_0);
                  d_eta_p_dV_GP_SI = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_GP_SI)))/value_sqrt_0/value_sqrt_0);
                  d_eta_p_dV_DI_SI = (-(deriv_sqrt_0_d0*((kp*d_xgm_dV_DI_SI)))/value_sqrt_0/value_sqrt_0);
                  eta_p = (1.0/value_sqrt_0);
                }

                d_temp_dV_SI_BP = (((eta_p+1.0)*d_eta_p_dV_SI_BP-eta_p*d_eta_p_dV_SI_BP)/(eta_p+1.0)/(eta_p+1.0));
                d_temp_dV_GP_SI = (((eta_p+1.0)*d_eta_p_dV_GP_SI-eta_p*d_eta_p_dV_GP_SI)/(eta_p+1.0)/(eta_p+1.0));
                d_temp_dV_DI_SI = (((eta_p+1.0)*d_eta_p_dV_DI_SI-eta_p*d_eta_p_dV_DI_SI)/(eta_p+1.0)/(eta_p+1.0));
                temp = (eta_p/(eta_p+1.0));

                d_x_pm_dV_SI_BP = (kp*((((temp*temp)*Gf2)*d_Dm_dV_SI_BP)+((((temp*temp)*d_Gf2_dV_SI_BP)+(((temp*d_temp_dV_SI_BP)+(d_temp_dV_SI_BP*temp))*Gf2))*Dm)));
                d_x_pm_dV_DI_SI = (kp*((((temp*temp)*Gf2)*d_Dm_dV_DI_SI)+((((temp*temp)*d_Gf2_dV_DI_SI)+(((temp*d_temp_dV_DI_SI)+(d_temp_dV_DI_SI*temp))*Gf2))*Dm)));
                d_x_pm_dV_GP_SI = (kp*((((temp*temp)*Gf2)*d_Dm_dV_GP_SI)+((((temp*temp)*d_Gf2_dV_GP_SI)+(((temp*d_temp_dV_GP_SI)+(d_temp_dV_GP_SI*temp))*Gf2))*Dm)));
                x_pm = (kp*(((temp*temp)*Gf2)*Dm));

                d_p_pd_dV_SI_BP = ((2.0*(d_xgm_dV_SI_BP-d_x_pm_dV_SI_BP))+((Gf2*((-d_Em_dV_SI_BP)+d_Dm_dV_SI_BP))+(d_Gf2_dV_SI_BP*((1.0-Em)+Dm))));
                d_p_pd_dV_GP_SI = ((2.0*(d_xgm_dV_GP_SI-d_x_pm_dV_GP_SI))+((Gf2*((-d_Em_dV_GP_SI)+d_Dm_dV_GP_SI))+(d_Gf2_dV_GP_SI*((1.0-Em)+Dm))));
                d_p_pd_dV_DI_SI = ((2.0*(d_xgm_dV_DI_SI-d_x_pm_dV_DI_SI))+((Gf2*((-d_Em_dV_DI_SI)+d_Dm_dV_DI_SI))+(d_Gf2_dV_DI_SI*((1.0-Em)+Dm))));
                p_pd = ((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm)));

                d_q_pd_dV_SI_BP = ((x_pm*(d_x_pm_dV_SI_BP-(2.0*d_xgm_dV_SI_BP)))+(d_x_pm_dV_SI_BP*(x_pm-(2.0*xgm))));
                d_q_pd_dV_DI_SI = ((x_pm*(d_x_pm_dV_DI_SI-(2.0*d_xgm_dV_DI_SI)))+(d_x_pm_dV_DI_SI*(x_pm-(2.0*xgm))));
                d_q_pd_dV_GP_SI = ((x_pm*(d_x_pm_dV_GP_SI-(2.0*d_xgm_dV_GP_SI)))+(d_x_pm_dV_GP_SI*(x_pm-(2.0*xgm))));
                q_pd = (x_pm*(x_pm-(2.0*xgm)));

                d_xi_pd_dV_SI_BP = (-(0.5*((Gf2*(d_Em_dV_SI_BP+d_Dm_dV_SI_BP))+(d_Gf2_dV_SI_BP*(Em+Dm)))));
                d_xi_pd_dV_GP_SI = (-(0.5*((Gf2*(d_Em_dV_GP_SI+d_Dm_dV_GP_SI))+(d_Gf2_dV_GP_SI*(Em+Dm)))));
                d_xi_pd_dV_DI_SI = (-(0.5*((Gf2*(d_Em_dV_DI_SI+d_Dm_dV_DI_SI))+(d_Gf2_dV_DI_SI*(Em+Dm)))));
                xi_pd = (1.0-(0.5*(Gf2*(Em+Dm))));

                d_u_pd_dV_SI_BP = ((((p_pd*p_pd)-(xi_pd*q_pd))*((q_pd*d_p_pd_dV_SI_BP)+(d_q_pd_dV_SI_BP*p_pd))-(q_pd*p_pd)*(((p_pd*d_p_pd_dV_SI_BP)+(d_p_pd_dV_SI_BP*p_pd))-((xi_pd*d_q_pd_dV_SI_BP)+(d_xi_pd_dV_SI_BP*q_pd))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
                d_u_pd_dV_DI_SI = ((((p_pd*p_pd)-(xi_pd*q_pd))*((q_pd*d_p_pd_dV_DI_SI)+(d_q_pd_dV_DI_SI*p_pd))-(q_pd*p_pd)*(((p_pd*d_p_pd_dV_DI_SI)+(d_p_pd_dV_DI_SI*p_pd))-((xi_pd*d_q_pd_dV_DI_SI)+(d_xi_pd_dV_DI_SI*q_pd))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
                d_u_pd_dV_GP_SI = ((((p_pd*p_pd)-(xi_pd*q_pd))*((q_pd*d_p_pd_dV_GP_SI)+(d_q_pd_dV_GP_SI*p_pd))-(q_pd*p_pd)*(((p_pd*d_p_pd_dV_GP_SI)+(d_p_pd_dV_GP_SI*p_pd))-((xi_pd*d_q_pd_dV_GP_SI)+(d_xi_pd_dV_GP_SI*q_pd))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
                u_pd = ((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd)));

                d_x_m_dV_SI_BP = (d_x_m_dV_SI_BP+d_u_pd_dV_SI_BP);
                d_x_m_dV_GP_SI = (d_x_m_dV_GP_SI+d_u_pd_dV_GP_SI);
                d_x_m_dV_DI_SI = (d_x_m_dV_DI_SI+d_u_pd_dV_DI_SI);
                x_m = (x_m+u_pd);
                {
                  double value_exp_0 = exp(u_pd);
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_km_dV_SI_BP = (deriv_exp_0_d0*(d_u_pd_dV_SI_BP));
                  d_km_dV_DI_SI = (deriv_exp_0_d0*(d_u_pd_dV_DI_SI));
                  d_km_dV_GP_SI = (deriv_exp_0_d0*(d_u_pd_dV_GP_SI));
                  km = value_exp_0;
                }

                d_Em_dV_SI_BP = ((km*d_Em_dV_SI_BP-Em*d_km_dV_SI_BP)/km/km);
                d_Em_dV_GP_SI = ((km*d_Em_dV_GP_SI-Em*d_km_dV_GP_SI)/km/km);
                d_Em_dV_DI_SI = ((km*d_Em_dV_DI_SI-Em*d_km_dV_DI_SI)/km/km);
                Em = (Em/km);

                d_Dm_dV_SI_BP = ((Dm*d_km_dV_SI_BP)+(d_Dm_dV_SI_BP*km));
                d_Dm_dV_GP_SI = ((Dm*d_km_dV_GP_SI)+(d_Dm_dV_GP_SI*km));
                d_Dm_dV_DI_SI = ((Dm*d_km_dV_DI_SI)+(d_Dm_dV_DI_SI*km));
                Dm = (Dm*km);

                d_Pm_dV_SI_BP = (d_x_m_dV_SI_BP+d_Em_dV_SI_BP);
                d_Pm_dV_GP_SI = (d_x_m_dV_GP_SI+d_Em_dV_GP_SI);
                d_Pm_dV_DI_SI = (d_x_m_dV_DI_SI+d_Em_dV_DI_SI);
                Pm = ((x_m-1.0)+Em);
                {
                  double value_sqrt_0 = sqrt((Dm+Pm));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_xgm_dV_SI_BP = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_SI_BP+d_Pm_dV_SI_BP))))+(d_Gf_dV_SI_BP*value_sqrt_0));
                  d_xgm_dV_GP_SI = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_SI+d_Pm_dV_GP_SI))))+(d_Gf_dV_GP_SI*value_sqrt_0));
                  d_xgm_dV_DI_SI = ((Gf*(deriv_sqrt_0_d0*((d_Dm_dV_DI_SI+d_Pm_dV_DI_SI))))+(d_Gf_dV_DI_SI*value_sqrt_0));
                  xgm = (Gf*value_sqrt_0);
                }

                d_km0_dV_SI_BP = ((-d_Em_dV_SI_BP)+(2.0*(((xgm*eta_p)*d_inv_Gf2_dV_SI_BP)+(((xgm*d_eta_p_dV_SI_BP)+(d_xgm_dV_SI_BP*eta_p))*inv_Gf2))));
                d_km0_dV_GP_SI = ((-d_Em_dV_GP_SI)+(2.0*(((xgm*eta_p)*d_inv_Gf2_dV_GP_SI)+(((xgm*d_eta_p_dV_GP_SI)+(d_xgm_dV_GP_SI*eta_p))*inv_Gf2))));
                d_km0_dV_DI_SI = ((-d_Em_dV_DI_SI)+(2.0*(((xgm*eta_p)*d_inv_Gf2_dV_DI_SI)+(((xgm*d_eta_p_dV_DI_SI)+(d_xgm_dV_DI_SI*eta_p))*inv_Gf2))));
                km0 = ((1.0-Em)+(2.0*((xgm*eta_p)*inv_Gf2)));

                d_x_ds_dV_SI_BP = (((km0+(km*D_bar))*(((x_ds*km)*(d_d0_dV_SI_BP+d_D_bar_dV_SI_BP))+(((x_ds*d_km_dV_SI_BP)+(d_x_ds_dV_SI_BP*km))*(d0+D_bar)))-((x_ds*km)*(d0+D_bar))*(d_km0_dV_SI_BP+((km*d_D_bar_dV_SI_BP)+(d_km_dV_SI_BP*D_bar))))/(km0+(km*D_bar))/(km0+(km*D_bar)));
                d_x_ds_dV_GP_SI = (((km0+(km*D_bar))*(((x_ds*km)*(d_d0_dV_GP_SI+d_D_bar_dV_GP_SI))+(((x_ds*d_km_dV_GP_SI)+(d_x_ds_dV_GP_SI*km))*(d0+D_bar)))-((x_ds*km)*(d0+D_bar))*(d_km0_dV_GP_SI+((km*d_D_bar_dV_GP_SI)+(d_km_dV_GP_SI*D_bar))))/(km0+(km*D_bar))/(km0+(km*D_bar)));
                d_x_ds_dV_DI_SI = (((km0+(km*D_bar))*(((x_ds*km)*(d_d0_dV_DI_SI+d_D_bar_dV_DI_SI))+(((x_ds*d_km_dV_DI_SI)+(d_x_ds_dV_DI_SI*km))*(d0+D_bar)))-((x_ds*km)*(d0+D_bar))*(d_km0_dV_DI_SI+((km*d_D_bar_dV_DI_SI)+(d_km_dV_DI_SI*D_bar))))/(km0+(km*D_bar))/(km0+(km*D_bar)));
                x_ds = (((x_ds*km)*(d0+D_bar))/(km0+(km*D_bar)));

                d_dps_dV_SI_BP = ((x_ds*d_phit1_dV_SI_BP)+(d_x_ds_dV_SI_BP*phit1));
                d_dps_dV_GP_SI = ((x_ds*d_phit1_dV_GP_SI)+(d_x_ds_dV_GP_SI*phit1));
                d_dps_dV_DI_SI = ((x_ds*d_phit1_dV_DI_SI)+(d_x_ds_dV_DI_SI*phit1));
                dps = (x_ds*phit1);
              }
              {
                double value_sqrt_0 = sqrt(Pm);
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_sqm_dV_SI_BP = (deriv_sqrt_0_d0*(d_Pm_dV_SI_BP));
                d_sqm_dV_GP_SI = (deriv_sqrt_0_d0*(d_Pm_dV_GP_SI));
                d_sqm_dV_DI_SI = (deriv_sqrt_0_d0*(d_Pm_dV_DI_SI));
                sqm = value_sqrt_0;
              }

              d_alpha_dV_SI_BP = (d_eta_p_dV_SI_BP+(0.5*((sqm*((Gf*(-d_Em_dV_SI_BP))+(d_Gf_dV_SI_BP*(1.0-Em)))-(Gf*(1.0-Em))*d_sqm_dV_SI_BP)/sqm/sqm)));
              d_alpha_dV_GP_SI = (d_eta_p_dV_GP_SI+(0.5*((sqm*((Gf*(-d_Em_dV_GP_SI))+(d_Gf_dV_GP_SI*(1.0-Em)))-(Gf*(1.0-Em))*d_sqm_dV_GP_SI)/sqm/sqm)));
              d_alpha_dV_DI_SI = (d_eta_p_dV_DI_SI+(0.5*((sqm*((Gf*(-d_Em_dV_DI_SI))+(d_Gf_dV_DI_SI*(1.0-Em)))-(Gf*(1.0-Em))*d_sqm_dV_DI_SI)/sqm/sqm)));
              alpha = (eta_p+(0.5*((Gf*(1.0-Em))/sqm)));
            }

            d_qim_dV_SI_BP = ((phit1*(((xgm+(Gf*sqm))*((Gf2*d_Dm_dV_SI_BP)+(d_Gf2_dV_SI_BP*Dm))-(Gf2*Dm)*(d_xgm_dV_SI_BP+((Gf*d_sqm_dV_SI_BP)+(d_Gf_dV_SI_BP*sqm))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))))+(d_phit1_dV_SI_BP*((Gf2*Dm)/(xgm+(Gf*sqm)))));
            d_qim_dV_DI_SI = ((phit1*(((xgm+(Gf*sqm))*((Gf2*d_Dm_dV_DI_SI)+(d_Gf2_dV_DI_SI*Dm))-(Gf2*Dm)*(d_xgm_dV_DI_SI+((Gf*d_sqm_dV_DI_SI)+(d_Gf_dV_DI_SI*sqm))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))))+(d_phit1_dV_DI_SI*((Gf2*Dm)/(xgm+(Gf*sqm)))));
            d_qim_dV_GP_SI = ((phit1*(((xgm+(Gf*sqm))*((Gf2*d_Dm_dV_GP_SI)+(d_Gf2_dV_GP_SI*Dm))-(Gf2*Dm)*(d_xgm_dV_GP_SI+((Gf*d_sqm_dV_GP_SI)+(d_Gf_dV_GP_SI*sqm))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))))+(d_phit1_dV_GP_SI*((Gf2*Dm)/(xgm+(Gf*sqm)))));
            qim = (phit1*((Gf2*Dm)/(xgm+(Gf*sqm))));

            d_qim1_dV_SI_BP = (d_qim_dV_SI_BP+((phit1*d_alpha_dV_SI_BP)+(d_phit1_dV_SI_BP*alpha)));
            d_qim1_dV_DI_SI = (d_qim_dV_DI_SI+((phit1*d_alpha_dV_DI_SI)+(d_phit1_dV_DI_SI*alpha)));
            d_qim1_dV_GP_SI = (d_qim_dV_GP_SI+((phit1*d_alpha_dV_GP_SI)+(d_phit1_dV_GP_SI*alpha)));
            qim1 = (qim+(phit1*alpha));

            d_qbm_dV_SI_BP = (((sqm*Gf)*d_phit1_dV_SI_BP)+(((sqm*d_Gf_dV_SI_BP)+(d_sqm_dV_SI_BP*Gf))*phit1));
            d_qbm_dV_GP_SI = (((sqm*Gf)*d_phit1_dV_GP_SI)+(((sqm*d_Gf_dV_GP_SI)+(d_sqm_dV_GP_SI*Gf))*phit1));
            d_qbm_dV_DI_SI = (((sqm*Gf)*d_phit1_dV_DI_SI)+(((sqm*d_Gf_dV_DI_SI)+(d_sqm_dV_DI_SI*Gf))*phit1));
            qbm = ((sqm*Gf)*phit1);
            if ((RSG_i<0.0))
            {

              d_temp_dV_SI_BP = (-(RSG_i*d_qim_dV_SI_BP));
              d_temp_dV_DI_SI = (-(RSG_i*d_qim_dV_DI_SI));
              d_temp_dV_GP_SI = (-(RSG_i*d_qim_dV_GP_SI));
              temp = (1.0-(RSG_i*qim));
            }
            else
            {

              d_temp_dV_SI_BP = (-(RSG_i*d_qim_dV_SI_BP)/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
              d_temp_dV_DI_SI = (-(RSG_i*d_qim_dV_DI_SI)/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
              d_temp_dV_GP_SI = (-(RSG_i*d_qim_dV_GP_SI)/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
              temp = (1.0/(1.0+(RSG_i*qim)));
            }

            d_GR_dV_GP_SI = (THER_i*(((rhob*temp)*d_qim_dV_GP_SI)+(((rhob*d_temp_dV_GP_SI)+(d_rhob_dV_GP_SI*temp))*qim)));
            d_GR_dV_SI_BP = (THER_i*(((rhob*temp)*d_qim_dV_SI_BP)+(((rhob*d_temp_dV_SI_BP)+(d_rhob_dV_SI_BP*temp))*qim)));
            d_GR_dV_DI_SI = (THER_i*(((rhob*temp)*d_qim_dV_DI_SI)+(((rhob*d_temp_dV_DI_SI)+(d_rhob_dV_DI_SI*temp))*qim)));
            GR = (THER_i*((rhob*temp)*qim));

            d_qeff_dV_SI_BP = (d_qbm_dV_SI_BP+(eta_mu*d_qim_dV_SI_BP));
            d_qeff_dV_GP_SI = (d_qbm_dV_GP_SI+(eta_mu*d_qim_dV_GP_SI));
            d_qeff_dV_DI_SI = (d_qbm_dV_DI_SI+(eta_mu*d_qim_dV_DI_SI));
            qeff = (qbm+(eta_mu*qim));

            d_qeff1_dV_SI_BP = (d_qbm_dV_SI_BP+(eta_mu1*d_qim_dV_SI_BP));
            d_qeff1_dV_GP_SI = (d_qbm_dV_GP_SI+(eta_mu1*d_qim_dV_GP_SI));
            d_qeff1_dV_DI_SI = (d_qbm_dV_DI_SI+(eta_mu1*d_qim_dV_DI_SI));
            qeff1 = (qbm+(eta_mu1*qim));

            d_Eeffm_dV_SI_BP = (E_eff0*d_qeff_dV_SI_BP);
            d_Eeffm_dV_GP_SI = (E_eff0*d_qeff_dV_GP_SI);
            d_Eeffm_dV_DI_SI = (E_eff0*d_qeff_dV_DI_SI);
            Eeffm = (E_eff0*qeff);
            {
              double value_pow_0 = pow((Eeffm*MUE_T),THEMU_T);
              double  deriv_pow_0_d0 = (((Eeffm*MUE_T) == 0.0)?0.0:(value_pow_0*THEMU_T/(Eeffm*MUE_T)));

              d_Mutmp_dV_SI_BP = ((deriv_pow_0_d0*((d_Eeffm_dV_SI_BP*MUE_T)))+(CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dV_SI_BP-Pm*(d_Pm_dV_SI_BP+d_Dm_dV_SI_BP))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
              d_Mutmp_dV_GP_SI = ((deriv_pow_0_d0*((d_Eeffm_dV_GP_SI*MUE_T)))+(CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dV_GP_SI-Pm*(d_Pm_dV_GP_SI+d_Dm_dV_GP_SI))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
              d_Mutmp_dV_DI_SI = ((deriv_pow_0_d0*((d_Eeffm_dV_DI_SI*MUE_T)))+(CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dV_DI_SI-Pm*(d_Pm_dV_DI_SI+d_Dm_dV_DI_SI))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
              Mutmp = (value_pow_0+(CS_T*(Pm/((Pm+Dm)+1.0e-14))));
            }

            d_Gmob_dV_SI_BP = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_SI_BP)+((d_Mutmp_dV_SI_BP+d_GR_dV_SI_BP)*Rxcor));
            d_Gmob_dV_GP_SI = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_GP_SI)+((d_Mutmp_dV_GP_SI+d_GR_dV_GP_SI)*Rxcor));
            d_Gmob_dV_DI_SI = ((((1.0+Mutmp)+GR)*d_Rxcor_dV_DI_SI)+((d_Mutmp_dV_DI_SI+d_GR_dV_DI_SI)*Rxcor));
            Gmob = (((1.0+Mutmp)+GR)*Rxcor);
            {
              double value_log_0 = log(((1.0+((Vds-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))));
              double  deriv_log_0_d0 = (1.0/((1.0+((Vds-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))));

              d_s1_dV_SI_BP = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*((-d_dps_dV_SI_BP)*inv_VP)-(1.0+((Vds-dps)*inv_VP))*((d_Vdse_dV_SI_BP-d_dps_dV_SI_BP)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
              d_s1_dV_GP_SI = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*((-d_dps_dV_GP_SI)*inv_VP)-(1.0+((Vds-dps)*inv_VP))*((d_Vdse_dV_GP_SI-d_dps_dV_GP_SI)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
              d_s1_dV_DI_SI = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*((d_Vds_dV_DI_SI-d_dps_dV_DI_SI)*inv_VP)-(1.0+((Vds-dps)*inv_VP))*((d_Vdse_dV_DI_SI-d_dps_dV_DI_SI)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
              s1 = value_log_0;
            }

            d_dL_dV_SI_BP = (ALP_i*d_s1_dV_SI_BP);
            d_dL_dV_GP_SI = (ALP_i*d_s1_dV_GP_SI);
            d_dL_dV_DI_SI = (ALP_i*d_s1_dV_DI_SI);
            dL = (ALP_i*s1);

            d_GdL_dV_SI_BP = (-(d_dL_dV_SI_BP+((dL*d_dL_dV_SI_BP)+(d_dL_dV_SI_BP*dL)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
            d_GdL_dV_GP_SI = (-(d_dL_dV_GP_SI+((dL*d_dL_dV_GP_SI)+(d_dL_dV_GP_SI*dL)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
            d_GdL_dV_DI_SI = (-(d_dL_dV_DI_SI+((dL*d_dL_dV_DI_SI)+(d_dL_dV_DI_SI*dL)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
            GdL = (1.0/((1.0+dL)+(dL*dL)));

            d_temp2_dV_SI_BP = ((qim*d_xitsb_dV_SI_BP)+(d_qim_dV_SI_BP*xitsb));
            d_temp2_dV_DI_SI = ((qim*d_xitsb_dV_DI_SI)+(d_qim_dV_DI_SI*xitsb));
            d_temp2_dV_GP_SI = ((qim*d_xitsb_dV_GP_SI)+(d_qim_dV_GP_SI*xitsb));
            temp2 = (qim*xitsb);

            d_wsat_dV_SI_BP = (100.0*(((100.0+temp2)*d_temp2_dV_SI_BP-temp2*d_temp2_dV_SI_BP)/(100.0+temp2)/(100.0+temp2)));
            d_wsat_dV_GP_SI = (100.0*(((100.0+temp2)*d_temp2_dV_GP_SI-temp2*d_temp2_dV_GP_SI)/(100.0+temp2)/(100.0+temp2)));
            d_wsat_dV_DI_SI = (100.0*(((100.0+temp2)*d_temp2_dV_DI_SI-temp2*d_temp2_dV_DI_SI)/(100.0+temp2)/(100.0+temp2)));
            wsat = (100.0*(temp2/(100.0+temp2)));

            d_Gmob_dL_dV_SI_BP = ((Gmob*d_GdL_dV_SI_BP)+(d_Gmob_dV_SI_BP*GdL));
            d_Gmob_dL_dV_GP_SI = ((Gmob*d_GdL_dV_GP_SI)+(d_Gmob_dV_GP_SI*GdL));
            d_Gmob_dL_dV_DI_SI = ((Gmob*d_GdL_dV_DI_SI)+(d_Gmob_dV_DI_SI*GdL));
            Gmob_dL = (Gmob*GdL);
            if ((THESATG_i<0.0))
            {

              d_temp_dV_SI_BP = (-(-(THESATG_i*d_wsat_dV_SI_BP))/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
              d_temp_dV_GP_SI = (-(-(THESATG_i*d_wsat_dV_GP_SI))/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
              d_temp_dV_DI_SI = (-(-(THESATG_i*d_wsat_dV_DI_SI))/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
              temp = (1.0/(1.0-(THESATG_i*wsat)));
            }
            else
            {

              d_temp_dV_SI_BP = (THESATG_i*d_wsat_dV_SI_BP);
              d_temp_dV_GP_SI = (THESATG_i*d_wsat_dV_GP_SI);
              d_temp_dV_DI_SI = (THESATG_i*d_wsat_dV_DI_SI);
              temp = (1.0+(THESATG_i*wsat));
            }

            d_thesat1_dV_SI_BP = (THESAT_T*((Gmob_dL*d_temp_dV_SI_BP-temp*d_Gmob_dL_dV_SI_BP)/Gmob_dL/Gmob_dL));
            d_thesat1_dV_DI_SI = (THESAT_T*((Gmob_dL*d_temp_dV_DI_SI-temp*d_Gmob_dL_dV_DI_SI)/Gmob_dL/Gmob_dL));
            d_thesat1_dV_GP_SI = (THESAT_T*((Gmob_dL*d_temp_dV_GP_SI-temp*d_Gmob_dL_dV_GP_SI)/Gmob_dL/Gmob_dL));
            thesat1 = (THESAT_T*(temp/Gmob_dL));

            d_zsat_dV_SI_BP = ((((thesat1*thesat1)*dps)*d_dps_dV_SI_BP)+((((thesat1*thesat1)*d_dps_dV_SI_BP)+(((thesat1*d_thesat1_dV_SI_BP)+(d_thesat1_dV_SI_BP*thesat1))*dps))*dps));
            d_zsat_dV_DI_SI = ((((thesat1*thesat1)*dps)*d_dps_dV_DI_SI)+((((thesat1*thesat1)*d_dps_dV_DI_SI)+(((thesat1*d_thesat1_dV_DI_SI)+(d_thesat1_dV_DI_SI*thesat1))*dps))*dps));
            d_zsat_dV_GP_SI = ((((thesat1*thesat1)*dps)*d_dps_dV_GP_SI)+((((thesat1*thesat1)*d_dps_dV_GP_SI)+(((thesat1*d_thesat1_dV_GP_SI)+(d_thesat1_dV_GP_SI*thesat1))*dps))*dps));
            zsat = (((thesat1*thesat1)*dps)*dps);
            if (((model_.CHNL_TYPE)==(-1)))
            {

              d_zsat_dV_SI_BP = (((1.0+(thesat1*dps))*d_zsat_dV_SI_BP-zsat*((thesat1*d_dps_dV_SI_BP)+(d_thesat1_dV_SI_BP*dps)))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
              d_zsat_dV_DI_SI = (((1.0+(thesat1*dps))*d_zsat_dV_DI_SI-zsat*((thesat1*d_dps_dV_DI_SI)+(d_thesat1_dV_DI_SI*dps)))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
              d_zsat_dV_GP_SI = (((1.0+(thesat1*dps))*d_zsat_dV_GP_SI-zsat*((thesat1*d_dps_dV_GP_SI)+(d_thesat1_dV_GP_SI*dps)))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
              zsat = (zsat/(1.0+(thesat1*dps)));
            }
            {
              double value_sqrt_0 = sqrt((1.0+(2.0*zsat)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_Gvsat_dV_SI_BP = (0.5*((Gmob_dL*(deriv_sqrt_0_d0*((2.0*d_zsat_dV_SI_BP))))+(d_Gmob_dL_dV_SI_BP*(1.0+value_sqrt_0))));
              d_Gvsat_dV_GP_SI = (0.5*((Gmob_dL*(deriv_sqrt_0_d0*((2.0*d_zsat_dV_GP_SI))))+(d_Gmob_dL_dV_GP_SI*(1.0+value_sqrt_0))));
              d_Gvsat_dV_DI_SI = (0.5*((Gmob_dL*(deriv_sqrt_0_d0*((2.0*d_zsat_dV_DI_SI))))+(d_Gmob_dL_dV_DI_SI*(1.0+value_sqrt_0))));
              Gvsat = (0.5*(Gmob_dL*(1.0+value_sqrt_0)));
            }

            d_Gvsatinv_dV_SI_BP = (-d_Gvsat_dV_SI_BP/Gvsat/Gvsat);
            d_Gvsatinv_dV_GP_SI = (-d_Gvsat_dV_GP_SI/Gvsat/Gvsat);
            d_Gvsatinv_dV_DI_SI = (-d_Gvsat_dV_DI_SI/Gvsat/Gvsat);
            Gvsatinv = (1.0/Gvsat);

            d_Voxm_dV_SI_BP = ((xgm*d_phit1_dV_SI_BP)+(d_xgm_dV_SI_BP*phit1));
            d_Voxm_dV_GP_SI = ((xgm*d_phit1_dV_GP_SI)+(d_xgm_dV_GP_SI*phit1));
            d_Voxm_dV_DI_SI = ((xgm*d_phit1_dV_DI_SI)+(d_xgm_dV_DI_SI*phit1));
            Voxm = (xgm*phit1);

            d_temp_dV_SI_BP = ((Gmob_dL*d_Gvsatinv_dV_SI_BP)+(d_Gmob_dL_dV_SI_BP*Gvsatinv));
            d_temp_dV_GP_SI = ((Gmob_dL*d_Gvsatinv_dV_GP_SI)+(d_Gmob_dL_dV_GP_SI*Gvsatinv));
            d_temp_dV_DI_SI = ((Gmob_dL*d_Gvsatinv_dV_DI_SI)+(d_Gmob_dL_dV_DI_SI*Gvsatinv));
            temp = (Gmob_dL*Gvsatinv);

            d_alpha1_dV_SI_BP = ((alpha*(0.5*(((zsat*temp)*d_temp_dV_SI_BP)+(((zsat*d_temp_dV_SI_BP)+(d_zsat_dV_SI_BP*temp))*temp))))+(d_alpha_dV_SI_BP*(1.0+(0.5*((zsat*temp)*temp)))));
            d_alpha1_dV_GP_SI = ((alpha*(0.5*(((zsat*temp)*d_temp_dV_GP_SI)+(((zsat*d_temp_dV_GP_SI)+(d_zsat_dV_GP_SI*temp))*temp))))+(d_alpha_dV_GP_SI*(1.0+(0.5*((zsat*temp)*temp)))));
            d_alpha1_dV_DI_SI = ((alpha*(0.5*(((zsat*temp)*d_temp_dV_DI_SI)+(((zsat*d_temp_dV_DI_SI)+(d_zsat_dV_DI_SI*temp))*temp))))+(d_alpha_dV_DI_SI*(1.0+(0.5*((zsat*temp)*temp)))));
            alpha1 = (alpha*(1.0+(0.5*((zsat*temp)*temp))));

            d_H_dV_SI_BP = ((alpha1*((temp*d_qim1_dV_SI_BP)+(d_temp_dV_SI_BP*qim1))-(temp*qim1)*d_alpha1_dV_SI_BP)/alpha1/alpha1);
            d_H_dV_DI_SI = ((alpha1*((temp*d_qim1_dV_DI_SI)+(d_temp_dV_DI_SI*qim1))-(temp*qim1)*d_alpha1_dV_DI_SI)/alpha1/alpha1);
            d_H_dV_GP_SI = ((alpha1*((temp*d_qim1_dV_GP_SI)+(d_temp_dV_GP_SI*qim1))-(temp*qim1)*d_alpha1_dV_GP_SI)/alpha1/alpha1);
            H = ((temp*qim1)/alpha1);
          }

          d_xg_ac_dV_SI_BP = d_xg_dV_SI_BP;
          d_xg_ac_dV_GP_SI = d_xg_dV_GP_SI;
          d_xg_ac_dV_DI_SI = d_xg_dV_DI_SI;
          xg_ac = xg;

          d_qeff1_ac_dV_SI_BP = d_qeff1_dV_SI_BP;
          d_qeff1_ac_dV_GP_SI = d_qeff1_dV_GP_SI;
          d_qeff1_ac_dV_DI_SI = d_qeff1_dV_DI_SI;
          qeff1_ac = qeff1;

          d_Voxm_ac_dV_SI_BP = d_Voxm_dV_SI_BP;
          d_Voxm_ac_dV_GP_SI = d_Voxm_dV_GP_SI;
          d_Voxm_ac_dV_DI_SI = d_Voxm_dV_DI_SI;
          Voxm_ac = Voxm;

          d_alpha_ac_dV_SI_BP = d_alpha_dV_SI_BP;
          d_alpha_ac_dV_GP_SI = d_alpha_dV_GP_SI;
          d_alpha_ac_dV_DI_SI = d_alpha_dV_DI_SI;
          alpha_ac = alpha;

          d_dps_ac_dV_SI_BP = d_dps_dV_SI_BP;
          d_dps_ac_dV_GP_SI = d_dps_dV_GP_SI;
          d_dps_ac_dV_DI_SI = d_dps_dV_DI_SI;
          dps_ac = dps;

          d_qim_ac_dV_SI_BP = d_qim_dV_SI_BP;
          d_qim_ac_dV_DI_SI = d_qim_dV_DI_SI;
          d_qim_ac_dV_GP_SI = d_qim_dV_GP_SI;
          qim_ac = qim;

          d_GdL_ac_dV_SI_BP = d_GdL_dV_SI_BP;
          d_GdL_ac_dV_GP_SI = d_GdL_dV_GP_SI;
          d_GdL_ac_dV_DI_SI = d_GdL_dV_DI_SI;
          GdL_ac = GdL;

          d_H_ac_dV_SI_BP = d_H_dV_SI_BP;
          d_H_ac_dV_DI_SI = d_H_dV_DI_SI;
          d_H_ac_dV_GP_SI = d_H_dV_GP_SI;
          H_ac = H;

          d_eta_p_ac_dV_SI_BP = d_eta_p_dV_SI_BP;
          d_eta_p_ac_dV_GP_SI = d_eta_p_dV_GP_SI;
          d_eta_p_ac_dV_DI_SI = d_eta_p_dV_DI_SI;
          eta_p_ac = eta_p;

          d_Gvsat_ac_dV_SI_BP = d_Gvsat_dV_SI_BP;
          d_Gvsat_ac_dV_GP_SI = d_Gvsat_dV_GP_SI;
          d_Gvsat_ac_dV_DI_SI = d_Gvsat_dV_DI_SI;
          Gvsat_ac = Gvsat;

          d_Gmob_dL_ac_dV_SI_BP = d_Gmob_dL_dV_SI_BP;
          d_Gmob_dL_ac_dV_GP_SI = d_Gmob_dL_dV_GP_SI;
          d_Gmob_dL_ac_dV_DI_SI = d_Gmob_dL_dV_DI_SI;
          Gmob_dL_ac = Gmob_dL;
        }
        else
        {

          d_xg_ac_dV_SI_BP = d_xg_dc_dV_SI_BP;
          d_xg_ac_dV_GP_SI = d_xg_dc_dV_GP_SI;
          d_xg_ac_dV_DI_SI = d_xg_dc_dV_DI_SI;
          xg_ac = xg_dc;

          d_qeff1_ac_dV_SI_BP = d_qeff1_dc_dV_SI_BP;
          d_qeff1_ac_dV_GP_SI = d_qeff1_dc_dV_GP_SI;
          d_qeff1_ac_dV_DI_SI = d_qeff1_dc_dV_DI_SI;
          qeff1_ac = qeff1_dc;

          d_Voxm_ac_dV_SI_BP = d_Voxm_dc_dV_SI_BP;
          d_Voxm_ac_dV_GP_SI = d_Voxm_dc_dV_GP_SI;
          d_Voxm_ac_dV_DI_SI = d_Voxm_dc_dV_DI_SI;
          Voxm_ac = Voxm_dc;

          d_alpha_ac_dV_SI_BP = d_alpha_dc_dV_SI_BP;
          d_alpha_ac_dV_GP_SI = d_alpha_dc_dV_GP_SI;
          d_alpha_ac_dV_DI_SI = d_alpha_dc_dV_DI_SI;
          alpha_ac = alpha_dc;

          d_dps_ac_dV_SI_BP = d_dps_dc_dV_SI_BP;
          d_dps_ac_dV_GP_SI = d_dps_dc_dV_GP_SI;
          d_dps_ac_dV_DI_SI = d_dps_dc_dV_DI_SI;
          dps_ac = dps_dc;

          d_qim_ac_dV_GP_SI = d_qim_dc_dV_GP_SI;
          d_qim_ac_dV_SI_BP = d_qim_dc_dV_SI_BP;
          d_qim_ac_dV_DI_SI = d_qim_dc_dV_DI_SI;
          qim_ac = qim_dc;

          d_GdL_ac_dV_SI_BP = d_GdL_dc_dV_SI_BP;
          d_GdL_ac_dV_GP_SI = d_GdL_dc_dV_GP_SI;
          d_GdL_ac_dV_DI_SI = d_GdL_dc_dV_DI_SI;
          GdL_ac = GdL_dc;

          d_H_ac_dV_SI_BP = d_H_dc_dV_SI_BP;
          d_H_ac_dV_DI_SI = d_H_dc_dV_DI_SI;
          d_H_ac_dV_GP_SI = d_H_dc_dV_GP_SI;
          H_ac = H_dc;

          d_eta_p_ac_dV_SI_BP = d_eta_p_dc_dV_SI_BP;
          d_eta_p_ac_dV_GP_SI = d_eta_p_dc_dV_GP_SI;
          d_eta_p_ac_dV_DI_SI = d_eta_p_dc_dV_DI_SI;
          eta_p_ac = eta_p_dc;

          d_Gvsat_ac_dV_SI_BP = d_Gvsat_dc_dV_SI_BP;
          d_Gvsat_ac_dV_GP_SI = d_Gvsat_dc_dV_GP_SI;
          d_Gvsat_ac_dV_DI_SI = d_Gvsat_dc_dV_DI_SI;
          Gvsat_ac = Gvsat_dc;

          d_Gmob_dL_ac_dV_SI_BP = d_Gmob_dL_dc_dV_SI_BP;
          d_Gmob_dL_ac_dV_GP_SI = d_Gmob_dL_dc_dV_GP_SI;
          d_Gmob_dL_ac_dV_DI_SI = d_Gmob_dL_dc_dV_DI_SI;
          Gmob_dL_ac = Gmob_dL_dc;
        }
      }
      // End block SPcalc_ac

      d_Vgb_dV_SI_BP = d_Vsb_dV_SI_BP;
      d_Vgb_dV_GP_SI = d_Vgs_dV_GP_SI;
      d_Vgb_dV_DI_SI = (d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI);
      Vgb = (Vgs+Vsb);

      d_COX_qm_dV_DI_SI = d_COX_qm_dV_GP_SI = d_COX_qm_dV_SI_BP =  0.0;
      COX_qm = COX_i;
      if ((qq>0.0))
      {
        {
          double value_pow_0 = pow(((qeff1_ac*qeff1_ac)+qlim2),((-1.0)*1.6666666666666667e-01));
          double  deriv_pow_0_d0 = ((((qeff1_ac*qeff1_ac)+qlim2) == 0.0)?0.0:(value_pow_0*((-1.0)*1.6666666666666667e-01)/((qeff1_ac*qeff1_ac)+qlim2)));

          d_COX_qm_dV_SI_BP = (-COX_i*(qq*(deriv_pow_0_d0*(((qeff1_ac*d_qeff1_ac_dV_SI_BP)+(d_qeff1_ac_dV_SI_BP*qeff1_ac)))))/(1.0+(qq*value_pow_0))/(1.0+(qq*value_pow_0)));
          d_COX_qm_dV_GP_SI = (-COX_i*(qq*(deriv_pow_0_d0*(((qeff1_ac*d_qeff1_ac_dV_GP_SI)+(d_qeff1_ac_dV_GP_SI*qeff1_ac)))))/(1.0+(qq*value_pow_0))/(1.0+(qq*value_pow_0)));
          d_COX_qm_dV_DI_SI = (-COX_i*(qq*(deriv_pow_0_d0*(((qeff1_ac*d_qeff1_ac_dV_DI_SI)+(d_qeff1_ac_dV_DI_SI*qeff1_ac)))))/(1.0+(qq*value_pow_0))/(1.0+(qq*value_pow_0)));
          COX_qm = (COX_i/(1.0+(qq*value_pow_0)));
        }
      }
      if ((xg_ac<=0.0))
      {

        d_QG_dV_SI_BP = d_Voxm_ac_dV_SI_BP;
        d_QG_dV_GP_SI = d_Voxm_ac_dV_GP_SI;
        d_QG_dV_DI_SI = d_Voxm_ac_dV_DI_SI;
        QG = Voxm_ac;

        d_QI_dV_DI_SI = d_QI_dV_GP_SI = d_QI_dV_SI_BP =  0.0;
        QI = 0.0;

        d_QD_dV_DI_SI = d_QD_dV_GP_SI = d_QD_dV_SI_BP =  0.0;
        QD = 0.0;

        d_QB_dV_SI_BP = d_QG_dV_SI_BP;
        d_QB_dV_GP_SI = d_QG_dV_GP_SI;
        d_QB_dV_DI_SI = d_QG_dV_DI_SI;
        QB = QG;
      }
      else
      {

        d_Fj_dV_SI_BP = (0.5*((H_ac*d_dps_ac_dV_SI_BP-dps_ac*d_H_ac_dV_SI_BP)/H_ac/H_ac));
        d_Fj_dV_GP_SI = (0.5*((H_ac*d_dps_ac_dV_GP_SI-dps_ac*d_H_ac_dV_GP_SI)/H_ac/H_ac));
        d_Fj_dV_DI_SI = (0.5*((H_ac*d_dps_ac_dV_DI_SI-dps_ac*d_H_ac_dV_DI_SI)/H_ac/H_ac));
        Fj = (0.5*(dps_ac/H_ac));

        d_Fj2_dV_SI_BP = ((Fj*d_Fj_dV_SI_BP)+(d_Fj_dV_SI_BP*Fj));
        d_Fj2_dV_GP_SI = ((Fj*d_Fj_dV_GP_SI)+(d_Fj_dV_GP_SI*Fj));
        d_Fj2_dV_DI_SI = ((Fj*d_Fj_dV_DI_SI)+(d_Fj_dV_DI_SI*Fj));
        Fj2 = (Fj*Fj);

        d_QCLM_dV_SI_BP = (((1.0-GdL_ac)*(d_qim_ac_dV_SI_BP-(0.5*((alpha_ac*d_dps_ac_dV_SI_BP)+(d_alpha_ac_dV_SI_BP*dps_ac)))))+((-d_GdL_ac_dV_SI_BP)*(qim_ac-(0.5*(alpha_ac*dps_ac)))));
        d_QCLM_dV_GP_SI = (((1.0-GdL_ac)*(d_qim_ac_dV_GP_SI-(0.5*((alpha_ac*d_dps_ac_dV_GP_SI)+(d_alpha_ac_dV_GP_SI*dps_ac)))))+((-d_GdL_ac_dV_GP_SI)*(qim_ac-(0.5*(alpha_ac*dps_ac)))));
        d_QCLM_dV_DI_SI = (((1.0-GdL_ac)*(d_qim_ac_dV_DI_SI-(0.5*((alpha_ac*d_dps_ac_dV_DI_SI)+(d_alpha_ac_dV_DI_SI*dps_ac)))))+((-d_GdL_ac_dV_DI_SI)*(qim_ac-(0.5*(alpha_ac*dps_ac)))));
        QCLM = ((1.0-GdL_ac)*(qim_ac-(0.5*(alpha_ac*dps_ac))));

        d_QG_dV_SI_BP = (d_Voxm_ac_dV_SI_BP+(0.5*(((eta_p_ac*dps_ac)*((((Fj*d_GdL_ac_dV_SI_BP)+(d_Fj_dV_SI_BP*GdL_ac))*3.3333333333333333e-01)+d_GdL_ac_dV_SI_BP))+(((eta_p_ac*d_dps_ac_dV_SI_BP)+(d_eta_p_ac_dV_SI_BP*dps_ac))*((((Fj*GdL_ac)*3.3333333333333333e-01)-1.0)+GdL_ac)))));
        d_QG_dV_GP_SI = (d_Voxm_ac_dV_GP_SI+(0.5*(((eta_p_ac*dps_ac)*((((Fj*d_GdL_ac_dV_GP_SI)+(d_Fj_dV_GP_SI*GdL_ac))*3.3333333333333333e-01)+d_GdL_ac_dV_GP_SI))+(((eta_p_ac*d_dps_ac_dV_GP_SI)+(d_eta_p_ac_dV_GP_SI*dps_ac))*((((Fj*GdL_ac)*3.3333333333333333e-01)-1.0)+GdL_ac)))));
        d_QG_dV_DI_SI = (d_Voxm_ac_dV_DI_SI+(0.5*(((eta_p_ac*dps_ac)*((((Fj*d_GdL_ac_dV_DI_SI)+(d_Fj_dV_DI_SI*GdL_ac))*3.3333333333333333e-01)+d_GdL_ac_dV_DI_SI))+(((eta_p_ac*d_dps_ac_dV_DI_SI)+(d_eta_p_ac_dV_DI_SI*dps_ac))*((((Fj*GdL_ac)*3.3333333333333333e-01)-1.0)+GdL_ac)))));
        QG = (Voxm_ac+(0.5*((eta_p_ac*dps_ac)*((((Fj*GdL_ac)*3.3333333333333333e-01)-1.0)+GdL_ac))));

        d_temp_dV_SI_BP = (((alpha_ac*d_dps_ac_dV_SI_BP)+(d_alpha_ac_dV_SI_BP*dps_ac))*1.6666666666666667e-01);
        d_temp_dV_GP_SI = (((alpha_ac*d_dps_ac_dV_GP_SI)+(d_alpha_ac_dV_GP_SI*dps_ac))*1.6666666666666667e-01);
        d_temp_dV_DI_SI = (((alpha_ac*d_dps_ac_dV_DI_SI)+(d_alpha_ac_dV_DI_SI*dps_ac))*1.6666666666666667e-01);
        temp = ((alpha_ac*dps_ac)*1.6666666666666667e-01);

        d_QI_dV_SI_BP = (((GdL_ac*(d_qim_ac_dV_SI_BP+((temp*d_Fj_dV_SI_BP)+(d_temp_dV_SI_BP*Fj))))+(d_GdL_ac_dV_SI_BP*(qim_ac+(temp*Fj))))+d_QCLM_dV_SI_BP);
        d_QI_dV_GP_SI = (((GdL_ac*(d_qim_ac_dV_GP_SI+((temp*d_Fj_dV_GP_SI)+(d_temp_dV_GP_SI*Fj))))+(d_GdL_ac_dV_GP_SI*(qim_ac+(temp*Fj))))+d_QCLM_dV_GP_SI);
        d_QI_dV_DI_SI = (((GdL_ac*(d_qim_ac_dV_DI_SI+((temp*d_Fj_dV_DI_SI)+(d_temp_dV_DI_SI*Fj))))+(d_GdL_ac_dV_DI_SI*(qim_ac+(temp*Fj))))+d_QCLM_dV_DI_SI);
        QI = ((GdL_ac*(qim_ac+(temp*Fj)))+QCLM);

        d_QD_dV_SI_BP = (0.5*((((GdL_ac*GdL_ac)*(d_qim_ac_dV_SI_BP-((temp*((-d_Fj_dV_SI_BP)-(0.2*d_Fj2_dV_SI_BP)))+(d_temp_dV_SI_BP*((1.0-Fj)-(0.2*Fj2))))))+(((GdL_ac*d_GdL_ac_dV_SI_BP)+(d_GdL_ac_dV_SI_BP*GdL_ac))*(qim_ac-(temp*((1.0-Fj)-(0.2*Fj2))))))+((QCLM*d_GdL_ac_dV_SI_BP)+(d_QCLM_dV_SI_BP*(1.0+GdL_ac)))));
        d_QD_dV_GP_SI = (0.5*((((GdL_ac*GdL_ac)*(d_qim_ac_dV_GP_SI-((temp*((-d_Fj_dV_GP_SI)-(0.2*d_Fj2_dV_GP_SI)))+(d_temp_dV_GP_SI*((1.0-Fj)-(0.2*Fj2))))))+(((GdL_ac*d_GdL_ac_dV_GP_SI)+(d_GdL_ac_dV_GP_SI*GdL_ac))*(qim_ac-(temp*((1.0-Fj)-(0.2*Fj2))))))+((QCLM*d_GdL_ac_dV_GP_SI)+(d_QCLM_dV_GP_SI*(1.0+GdL_ac)))));
        d_QD_dV_DI_SI = (0.5*((((GdL_ac*GdL_ac)*(d_qim_ac_dV_DI_SI-((temp*((-d_Fj_dV_DI_SI)-(0.2*d_Fj2_dV_DI_SI)))+(d_temp_dV_DI_SI*((1.0-Fj)-(0.2*Fj2))))))+(((GdL_ac*d_GdL_ac_dV_DI_SI)+(d_GdL_ac_dV_DI_SI*GdL_ac))*(qim_ac-(temp*((1.0-Fj)-(0.2*Fj2))))))+((QCLM*d_GdL_ac_dV_DI_SI)+(d_QCLM_dV_DI_SI*(1.0+GdL_ac)))));
        QD = (0.5*(((GdL_ac*GdL_ac)*(qim_ac-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL_ac))));

        d_QB_dV_SI_BP = (d_QG_dV_SI_BP-d_QI_dV_SI_BP);
        d_QB_dV_GP_SI = (d_QG_dV_GP_SI-d_QI_dV_GP_SI);
        d_QB_dV_DI_SI = (d_QG_dV_DI_SI-d_QI_dV_DI_SI);
        QB = (QG-QI);
      }

      d_Qg_dV_SI_BP = ((QG*d_COX_qm_dV_SI_BP)+(d_QG_dV_SI_BP*COX_qm));
      d_Qg_dV_GP_SI = ((QG*d_COX_qm_dV_GP_SI)+(d_QG_dV_GP_SI*COX_qm));
      d_Qg_dV_DI_SI = ((QG*d_COX_qm_dV_DI_SI)+(d_QG_dV_DI_SI*COX_qm));
      Qg = (QG*COX_qm);

      d_Qd_dV_SI_BP = (((-QD)*d_COX_qm_dV_SI_BP)+((-d_QD_dV_SI_BP)*COX_qm));
      d_Qd_dV_GP_SI = (((-QD)*d_COX_qm_dV_GP_SI)+((-d_QD_dV_GP_SI)*COX_qm));
      d_Qd_dV_DI_SI = (((-QD)*d_COX_qm_dV_DI_SI)+((-d_QD_dV_DI_SI)*COX_qm));
      Qd = ((-QD)*COX_qm);

      d_Qb_dV_SI_BP = (((-QB)*d_COX_qm_dV_SI_BP)+((-d_QB_dV_SI_BP)*COX_qm));
      d_Qb_dV_GP_SI = (((-QB)*d_COX_qm_dV_GP_SI)+((-d_QB_dV_GP_SI)*COX_qm));
      d_Qb_dV_DI_SI = (((-QB)*d_COX_qm_dV_DI_SI)+((-d_QB_dV_DI_SI)*COX_qm));
      Qb = ((-QB)*COX_qm);

      d_Qgs_ov_dV_GP_SI = (CGOV_i*d_Vovs_dV_GP_SI);
      Qgs_ov = (CGOV_i*Vovs);

      d_Qgd_ov_dV_DI_SI = (CGOVD_i*d_Vovd_dV_DI_SI);
      d_Qgd_ov_dV_GP_SI = (CGOVD_i*d_Vovd_dV_GP_SI);
      Qgd_ov = (CGOVD_i*Vovd);

      d_Qgb_ov_dV_SI_BP = (CGBOV_i*d_Vgb_dV_SI_BP);
      d_Qgb_ov_dV_GP_SI = (CGBOV_i*d_Vgb_dV_GP_SI);
      d_Qgb_ov_dV_DI_SI = (CGBOV_i*d_Vgb_dV_DI_SI);
      Qgb_ov = (CGBOV_i*Vgb);

      d_Qfgs_dV_GP_SI = (CFR_i*d_VgsPrime_dV_GP_SI);
      Qfgs = (CFR_i*VgsPrime);

      d_Qfgd_dV_DI_SI = (CFRD_i*d_VgdPrime_dV_DI_SI);
      d_Qfgd_dV_GP_SI = (CFRD_i*d_VgdPrime_dV_GP_SI);
      Qfgd = (CFRD_i*VgdPrime);
    }
    // End block evaluateDynamic
    //Begin block evaluateStaticDynamic
    {

      d_ijun_s_dV_DI_BD = d_ijun_s_dV_SI_BS =  0.0;
      ijun_s = 0.0;

      d_ijunbot_s_dV_SI_BS = d_ijunbot_s_dV_DI_BD =  0.0;
      ijunbot_s = 0.0;

      d_ijunsti_s_dV_SI_BS = d_ijunsti_s_dV_DI_BD =  0.0;
      ijunsti_s = 0.0;

      d_ijungat_s_dV_SI_BS = d_ijungat_s_dV_DI_BD =  0.0;
      ijungat_s = 0.0;

      d_ijun_d_dV_DI_BD = d_ijun_d_dV_SI_BS =  0.0;
      ijun_d = 0.0;

      d_ijunbot_d_dV_DI_BD = d_ijunbot_d_dV_SI_BS =  0.0;
      ijunbot_d = 0.0;

      d_ijunsti_d_dV_DI_BD = d_ijunsti_d_dV_SI_BS =  0.0;
      ijunsti_d = 0.0;

      d_ijungat_d_dV_DI_BD = d_ijungat_d_dV_SI_BS =  0.0;
      ijungat_d = 0.0;

      d_qjun_s_dV_DI_BD = d_qjun_s_dV_SI_BS =  0.0;
      qjun_s = 0.0;

      d_qjunbot_s_dV_DI_BD = d_qjunbot_s_dV_SI_BS =  0.0;
      qjunbot_s = 0.0;

      d_qjunsti_s_dV_DI_BD = d_qjunsti_s_dV_SI_BS =  0.0;
      qjunsti_s = 0.0;

      d_qjungat_s_dV_DI_BD = d_qjungat_s_dV_SI_BS =  0.0;
      qjungat_s = 0.0;

      d_qjun_d_dV_DI_BD = d_qjun_d_dV_SI_BS =  0.0;
      qjun_d = 0.0;

      d_qjunbot_d_dV_DI_BD = d_qjunbot_d_dV_SI_BS =  0.0;
      qjunbot_d = 0.0;

      d_qjunsti_d_dV_DI_BD = d_qjunsti_d_dV_SI_BS =  0.0;
      qjunsti_d = 0.0;

      d_qjungat_d_dV_DI_BD = d_qjungat_d_dV_SI_BS =  0.0;
      qjungat_d = 0.0;
      if (((model_.SWJUNCAP_i)>0))
      {
        if (((model_.SWJUNEXP_i)==1))
        {

          d_tm0_dV_DI_BD =  0.0;
          d_tm0_dV_SI_BS = ((d_Vjun_s_dV_SI_BS*(model_.phitdinv))*MFOR1_s);
          tm0 = ((Vjun_s*(model_.phitdinv))*MFOR1_s);
          {
            double value_exp_0 = exp(tm0);
            double  deriv_exp_0_d0 = value_exp_0;

            d_tm1_dV_DI_BD =  0.0;
            d_tm1_dV_SI_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_SI_BS)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf1_s)?(expxhf1_s*d_tm0_dV_SI_BS):(deriv_exp_0_d0*(d_tm0_dV_SI_BS))));
            tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf1_s)?(expxhf1_s*((tm0-xhighf1_s)+1.0)):value_exp_0));
          }

          d_ijunfor1_dV_DI_BD =  0.0;
          d_ijunfor1_dV_SI_BS = (ISATFOR1_s*d_tm1_dV_SI_BS);
          ijunfor1 = (ISATFOR1_s*(tm1-1.0));

          d_tm0_dV_DI_BD =  0.0;
          d_tm0_dV_SI_BS = ((d_Vjun_s_dV_SI_BS*(model_.phitdinv))*MFOR2_s);
          tm0 = ((Vjun_s*(model_.phitdinv))*MFOR2_s);
          {
            double value_exp_0 = exp(tm0);
            double  deriv_exp_0_d0 = value_exp_0;

            d_tm1_dV_DI_BD =  0.0;
            d_tm1_dV_SI_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_SI_BS)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf2_s)?(expxhf2_s*d_tm0_dV_SI_BS):(deriv_exp_0_d0*(d_tm0_dV_SI_BS))));
            tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf2_s)?(expxhf2_s*((tm0-xhighf2_s)+1.0)):value_exp_0));
          }

          d_ijunfor2_dV_DI_BD =  0.0;
          d_ijunfor2_dV_SI_BS = (ISATFOR2_s*d_tm1_dV_SI_BS);
          ijunfor2 = (ISATFOR2_s*(tm1-1.0));

          d_ijunrev_dV_DI_BD = d_ijunrev_dV_SI_BS =  0.0;
          ijunrev = 0.0;
          if ((m0flag_s>0.0))
          {

            d_ijunrev_dV_DI_BD =  0.0;
            d_ijunrev_dV_SI_BS = ((Vjun_s*(d_Vjun_s_dV_SI_BS*MREV_s))+(d_Vjun_s_dV_SI_BS*(ISATREV_s+(Vjun_s*MREV_s))));
            ijunrev = (Vjun_s*(ISATREV_s+(Vjun_s*MREV_s)));
          }
          else
          {

            d_tm0_dV_DI_BD =  0.0;
            d_tm0_dV_SI_BS = (((-d_Vjun_s_dV_SI_BS)*(model_.phitdinv))*MREV_s);
            tm0 = (((-Vjun_s)*(model_.phitdinv))*MREV_s);
            {
              double value_exp_0 = exp(tm0);
              double  deriv_exp_0_d0 = value_exp_0;

              d_tm1_dV_DI_BD =  0.0;
              d_tm1_dV_SI_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_SI_BS)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighr_s)?(expxhr_s*d_tm0_dV_SI_BS):(deriv_exp_0_d0*(d_tm0_dV_SI_BS))));
              tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighr_s)?(expxhr_s*((tm0-xhighr_s)+1.0)):value_exp_0));
            }

            d_ijunrev_dV_DI_BD =  0.0;
            d_ijunrev_dV_SI_BS = ((-ISATREV_s)*d_tm1_dV_SI_BS);
            ijunrev = ((-ISATREV_s)*(tm1-1.0));
          }

          d_ijun_s_dV_DI_BD =  0.0;
          d_ijun_s_dV_SI_BS = ((d_ijunfor1_dV_SI_BS+d_ijunfor2_dV_SI_BS)+d_ijunrev_dV_SI_BS);
          ijun_s = ((ijunfor1+ijunfor2)+ijunrev);

          d_tm0_dV_SI_BS =  0.0;
          d_tm0_dV_DI_BD = ((d_Vjun_d_dV_DI_BD*(model_.phitdinv))*MFOR1_d);
          tm0 = ((Vjun_d*(model_.phitdinv))*MFOR1_d);
          {
            double value_exp_0 = exp(tm0);
            double  deriv_exp_0_d0 = value_exp_0;

            d_tm1_dV_SI_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_SI_BS)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf1_d)?(expxhf1_d*d_tm0_dV_SI_BS):(deriv_exp_0_d0*(d_tm0_dV_SI_BS))));
            d_tm1_dV_DI_BD = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_DI_BD)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf1_d)?(expxhf1_d*d_tm0_dV_DI_BD):(deriv_exp_0_d0*(d_tm0_dV_DI_BD))));
            tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf1_d)?(expxhf1_d*((tm0-xhighf1_d)+1.0)):value_exp_0));
          }

          d_ijunfor1_dV_SI_BS = (ISATFOR1_d*d_tm1_dV_SI_BS);
          d_ijunfor1_dV_DI_BD = (ISATFOR1_d*d_tm1_dV_DI_BD);
          ijunfor1 = (ISATFOR1_d*(tm1-1.0));

          d_tm0_dV_SI_BS =  0.0;
          d_tm0_dV_DI_BD = ((d_Vjun_d_dV_DI_BD*(model_.phitdinv))*MFOR2_d);
          tm0 = ((Vjun_d*(model_.phitdinv))*MFOR2_d);
          {
            double value_exp_0 = exp(tm0);
            double  deriv_exp_0_d0 = value_exp_0;

            d_tm1_dV_SI_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_SI_BS)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf2_d)?(expxhf2_d*d_tm0_dV_SI_BS):(deriv_exp_0_d0*(d_tm0_dV_SI_BS))));
            d_tm1_dV_DI_BD = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_DI_BD)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf2_d)?(expxhf2_d*d_tm0_dV_DI_BD):(deriv_exp_0_d0*(d_tm0_dV_DI_BD))));
            tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf2_d)?(expxhf2_d*((tm0-xhighf2_d)+1.0)):value_exp_0));
          }

          d_ijunfor2_dV_SI_BS = (ISATFOR2_d*d_tm1_dV_SI_BS);
          d_ijunfor2_dV_DI_BD = (ISATFOR2_d*d_tm1_dV_DI_BD);
          ijunfor2 = (ISATFOR2_d*(tm1-1.0));

          d_ijunrev_dV_DI_BD = d_ijunrev_dV_SI_BS =  0.0;
          ijunrev = 0.0;
          if ((m0flag_d>0.0))
          {

            d_ijunrev_dV_SI_BS =  0.0;
            d_ijunrev_dV_DI_BD = ((Vjun_d*(d_Vjun_d_dV_DI_BD*MREV_d))+(d_Vjun_d_dV_DI_BD*(ISATREV_d+(Vjun_d*MREV_d))));
            ijunrev = (Vjun_d*(ISATREV_d+(Vjun_d*MREV_d)));
          }
          else
          {

            d_tm0_dV_SI_BS =  0.0;
            d_tm0_dV_DI_BD = (((-d_Vjun_d_dV_DI_BD)*(model_.phitdinv))*MREV_d);
            tm0 = (((-Vjun_d)*(model_.phitdinv))*MREV_d);
            {
              double value_exp_0 = exp(tm0);
              double  deriv_exp_0_d0 = value_exp_0;

              d_tm1_dV_SI_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_SI_BS)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighr_d)?(expxhr_d*d_tm0_dV_SI_BS):(deriv_exp_0_d0*(d_tm0_dV_SI_BS))));
              d_tm1_dV_DI_BD = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_DI_BD)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighr_d)?(expxhr_d*d_tm0_dV_DI_BD):(deriv_exp_0_d0*(d_tm0_dV_DI_BD))));
              tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighr_d)?(expxhr_d*((tm0-xhighr_d)+1.0)):value_exp_0));
            }

            d_ijunrev_dV_SI_BS = ((-ISATREV_d)*d_tm1_dV_SI_BS);
            d_ijunrev_dV_DI_BD = ((-ISATREV_d)*d_tm1_dV_DI_BD);
            ijunrev = ((-ISATREV_d)*(tm1-1.0));
          }

          d_ijun_d_dV_SI_BS = ((d_ijunfor1_dV_SI_BS+d_ijunfor2_dV_SI_BS)+d_ijunrev_dV_SI_BS);
          d_ijun_d_dV_DI_BD = ((d_ijunfor1_dV_DI_BD+d_ijunfor2_dV_DI_BD)+d_ijunrev_dV_DI_BD);
          ijun_d = ((ijunfor1+ijunfor2)+ijunrev);
          //Begin block evaluateDynamic
          {
            //Block-local variables for block evaluateDynamic
            double tmpv;
            double d_tmpv_dV_DI_BD;
            double d_tmpv_dV_SI_BS;
            double vjv;
            double d_vjv_dV_DI_BD;
            double d_vjv_dV_SI_BS;
            //End of Block-local variables

            d_tmpv_dV_DI_BD = d_tmpv_dV_SI_BS =  0.0;
            tmpv = 0.0;

            d_vjv_dV_DI_BD = d_vjv_dV_SI_BS =  0.0;
            vjv = 0.0;
            h1 = ((4.0*vch_s)*vch_s);
            h2 = (vch_s/vfmin_s);

            d_h2d_dV_DI_BD =  0.0;
            d_h2d_dV_SI_BS = d_Vjun_s_dV_SI_BS;
            h2d = (Vjun_s+(vch_s*h2));

            d_h3_dV_DI_BD =  0.0;
            d_h3_dV_SI_BS = d_h2d_dV_SI_BS;
            h3 = (vfmin_s+h2d);

            d_h4_dV_DI_BD =  0.0;
            d_h4_dV_SI_BS = (-d_h2d_dV_SI_BS);
            h4 = (vfmin_s-h2d);
            {
              double value_sqrt_0 = sqrt(((h4*h4)+h1));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_h5_dV_DI_BD =  0.0;
              d_h5_dV_SI_BS = (deriv_sqrt_0_d0*(((h4*d_h4_dV_SI_BS)+(d_h4_dV_SI_BS*h4))));
              h5 = value_sqrt_0;
            }

            d_vjv_dV_DI_BD =  0.0;
            d_vjv_dV_SI_BS = (2.0*(((h3+h5)*(d_Vjun_s_dV_SI_BS*vfmin_s)-(Vjun_s*vfmin_s)*(d_h3_dV_SI_BS+d_h5_dV_SI_BS))/(h3+h5)/(h3+h5)));
            vjv = (2.0*((Vjun_s*vfmin_s)/(h3+h5)));
            if ((zflagbot_s>0.5))
            {
              if (((model_.one_minus_PBOT)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((1.0-(vjv*(model_.vbiinvbot))));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmpv_dV_DI_BD =  0.0;
                  d_tmpv_dV_SI_BS = (deriv_sqrt_0_d0*((-(d_vjv_dV_SI_BS*(model_.vbiinvbot)))));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((1.0-(vjv*(model_.vbiinvbot))),(model_.one_minus_PBOT));
                  double  deriv_pow_0_d0 = (((1.0-(vjv*(model_.vbiinvbot))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT)/(1.0-(vjv*(model_.vbiinvbot)))));

                  d_tmpv_dV_DI_BD =  0.0;
                  d_tmpv_dV_SI_BS = (deriv_pow_0_d0*((-(d_vjv_dV_SI_BS*(model_.vbiinvbot)))));
                  tmpv = value_pow_0;
                }
              }

              d_qjunbot_s_dV_DI_BD =  0.0;
              d_qjunbot_s_dV_SI_BS = (((model_.qprefbot)*(-d_tmpv_dV_SI_BS))+((model_.qpref2bot)*(d_Vjun_s_dV_SI_BS-d_vjv_dV_SI_BS)));
              qjunbot_s = (((model_.qprefbot)*(1.0-tmpv))+((model_.qpref2bot)*(Vjun_s-vjv)));
            }
            if ((zflagsti_s>0.5))
            {
              if (((model_.one_minus_PSTI)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((1.0-(vjv*(model_.vbiinvsti))));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmpv_dV_DI_BD =  0.0;
                  d_tmpv_dV_SI_BS = (deriv_sqrt_0_d0*((-(d_vjv_dV_SI_BS*(model_.vbiinvsti)))));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((1.0-(vjv*(model_.vbiinvsti))),(model_.one_minus_PSTI));
                  double  deriv_pow_0_d0 = (((1.0-(vjv*(model_.vbiinvsti))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI)/(1.0-(vjv*(model_.vbiinvsti)))));

                  d_tmpv_dV_DI_BD =  0.0;
                  d_tmpv_dV_SI_BS = (deriv_pow_0_d0*((-(d_vjv_dV_SI_BS*(model_.vbiinvsti)))));
                  tmpv = value_pow_0;
                }
              }

              d_qjunsti_s_dV_DI_BD =  0.0;
              d_qjunsti_s_dV_SI_BS = (((model_.qprefsti)*(-d_tmpv_dV_SI_BS))+((model_.qpref2sti)*(d_Vjun_s_dV_SI_BS-d_vjv_dV_SI_BS)));
              qjunsti_s = (((model_.qprefsti)*(1.0-tmpv))+((model_.qpref2sti)*(Vjun_s-vjv)));
            }
            if ((zflaggat_s>0.5))
            {
              if (((model_.one_minus_PGAT)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((1.0-(vjv*(model_.vbiinvgat))));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmpv_dV_DI_BD =  0.0;
                  d_tmpv_dV_SI_BS = (deriv_sqrt_0_d0*((-(d_vjv_dV_SI_BS*(model_.vbiinvgat)))));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((1.0-(vjv*(model_.vbiinvgat))),(model_.one_minus_PGAT));
                  double  deriv_pow_0_d0 = (((1.0-(vjv*(model_.vbiinvgat))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT)/(1.0-(vjv*(model_.vbiinvgat)))));

                  d_tmpv_dV_DI_BD =  0.0;
                  d_tmpv_dV_SI_BS = (deriv_pow_0_d0*((-(d_vjv_dV_SI_BS*(model_.vbiinvgat)))));
                  tmpv = value_pow_0;
                }
              }

              d_qjungat_s_dV_DI_BD =  0.0;
              d_qjungat_s_dV_SI_BS = (((model_.qprefgat)*(-d_tmpv_dV_SI_BS))+((model_.qpref2gat)*(d_Vjun_s_dV_SI_BS-d_vjv_dV_SI_BS)));
              qjungat_s = (((model_.qprefgat)*(1.0-tmpv))+((model_.qpref2gat)*(Vjun_s-vjv)));
            }

            d_tmpv_dV_DI_BD = d_tmpv_dV_SI_BS =  0.0;
            tmpv = 0.0;

            d_vjv_dV_DI_BD = d_vjv_dV_SI_BS =  0.0;
            vjv = 0.0;
            h1 = ((4.0*vch_d)*vch_d);
            h2 = (vch_d/vfmin_d);

            d_h2d_dV_SI_BS =  0.0;
            d_h2d_dV_DI_BD = d_Vjun_d_dV_DI_BD;
            h2d = (Vjun_d+(vch_d*h2));

            d_h3_dV_SI_BS = d_h2d_dV_SI_BS;
            d_h3_dV_DI_BD = d_h2d_dV_DI_BD;
            h3 = (vfmin_d+h2d);

            d_h4_dV_SI_BS = (-d_h2d_dV_SI_BS);
            d_h4_dV_DI_BD = (-d_h2d_dV_DI_BD);
            h4 = (vfmin_d-h2d);
            {
              double value_sqrt_0 = sqrt(((h4*h4)+h1));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_h5_dV_SI_BS = (deriv_sqrt_0_d0*(((h4*d_h4_dV_SI_BS)+(d_h4_dV_SI_BS*h4))));
              d_h5_dV_DI_BD = (deriv_sqrt_0_d0*(((h4*d_h4_dV_DI_BD)+(d_h4_dV_DI_BD*h4))));
              h5 = value_sqrt_0;
            }

            d_vjv_dV_SI_BS = (2.0*(-(Vjun_d*vfmin_d)*(d_h3_dV_SI_BS+d_h5_dV_SI_BS)/(h3+h5)/(h3+h5)));
            d_vjv_dV_DI_BD = (2.0*(((h3+h5)*(d_Vjun_d_dV_DI_BD*vfmin_d)-(Vjun_d*vfmin_d)*(d_h3_dV_DI_BD+d_h5_dV_DI_BD))/(h3+h5)/(h3+h5)));
            vjv = (2.0*((Vjun_d*vfmin_d)/(h3+h5)));
            if ((zflagbot_d>0.5))
            {
              if (((model_.one_minus_PBOT_d)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((1.0-(vjv*(model_.vbiinvbot_d))));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmpv_dV_SI_BS = (deriv_sqrt_0_d0*((-(d_vjv_dV_SI_BS*(model_.vbiinvbot_d)))));
                  d_tmpv_dV_DI_BD = (deriv_sqrt_0_d0*((-(d_vjv_dV_DI_BD*(model_.vbiinvbot_d)))));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((1.0-(vjv*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
                  double  deriv_pow_0_d0 = (((1.0-(vjv*(model_.vbiinvbot_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT_d)/(1.0-(vjv*(model_.vbiinvbot_d)))));

                  d_tmpv_dV_SI_BS = (deriv_pow_0_d0*((-(d_vjv_dV_SI_BS*(model_.vbiinvbot_d)))));
                  d_tmpv_dV_DI_BD = (deriv_pow_0_d0*((-(d_vjv_dV_DI_BD*(model_.vbiinvbot_d)))));
                  tmpv = value_pow_0;
                }
              }

              d_qjunbot_d_dV_SI_BS = (((model_.qprefbot_d)*(-d_tmpv_dV_SI_BS))+((model_.qpref2bot_d)*(-d_vjv_dV_SI_BS)));
              d_qjunbot_d_dV_DI_BD = (((model_.qprefbot_d)*(-d_tmpv_dV_DI_BD))+((model_.qpref2bot_d)*(d_Vjun_d_dV_DI_BD-d_vjv_dV_DI_BD)));
              qjunbot_d = (((model_.qprefbot_d)*(1.0-tmpv))+((model_.qpref2bot_d)*(Vjun_d-vjv)));
            }
            if ((zflagsti_d>0.5))
            {
              if (((model_.one_minus_PSTI_d)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((1.0-(vjv*(model_.vbiinvsti_d))));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmpv_dV_SI_BS = (deriv_sqrt_0_d0*((-(d_vjv_dV_SI_BS*(model_.vbiinvsti_d)))));
                  d_tmpv_dV_DI_BD = (deriv_sqrt_0_d0*((-(d_vjv_dV_DI_BD*(model_.vbiinvsti_d)))));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((1.0-(vjv*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
                  double  deriv_pow_0_d0 = (((1.0-(vjv*(model_.vbiinvsti_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI_d)/(1.0-(vjv*(model_.vbiinvsti_d)))));

                  d_tmpv_dV_SI_BS = (deriv_pow_0_d0*((-(d_vjv_dV_SI_BS*(model_.vbiinvsti_d)))));
                  d_tmpv_dV_DI_BD = (deriv_pow_0_d0*((-(d_vjv_dV_DI_BD*(model_.vbiinvsti_d)))));
                  tmpv = value_pow_0;
                }
              }

              d_qjunsti_d_dV_SI_BS = (((model_.qprefsti_d)*(-d_tmpv_dV_SI_BS))+((model_.qpref2sti_d)*(-d_vjv_dV_SI_BS)));
              d_qjunsti_d_dV_DI_BD = (((model_.qprefsti_d)*(-d_tmpv_dV_DI_BD))+((model_.qpref2sti_d)*(d_Vjun_d_dV_DI_BD-d_vjv_dV_DI_BD)));
              qjunsti_d = (((model_.qprefsti_d)*(1.0-tmpv))+((model_.qpref2sti_d)*(Vjun_d-vjv)));
            }
            if ((zflaggat_d>0.5))
            {
              if (((model_.one_minus_PGAT_d)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((1.0-(vjv*(model_.vbiinvgat_d))));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmpv_dV_SI_BS = (deriv_sqrt_0_d0*((-(d_vjv_dV_SI_BS*(model_.vbiinvgat_d)))));
                  d_tmpv_dV_DI_BD = (deriv_sqrt_0_d0*((-(d_vjv_dV_DI_BD*(model_.vbiinvgat_d)))));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((1.0-(vjv*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
                  double  deriv_pow_0_d0 = (((1.0-(vjv*(model_.vbiinvgat_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT_d)/(1.0-(vjv*(model_.vbiinvgat_d)))));

                  d_tmpv_dV_SI_BS = (deriv_pow_0_d0*((-(d_vjv_dV_SI_BS*(model_.vbiinvgat_d)))));
                  d_tmpv_dV_DI_BD = (deriv_pow_0_d0*((-(d_vjv_dV_DI_BD*(model_.vbiinvgat_d)))));
                  tmpv = value_pow_0;
                }
              }

              d_qjungat_d_dV_SI_BS = (((model_.qprefgat_d)*(-d_tmpv_dV_SI_BS))+((model_.qpref2gat_d)*(-d_vjv_dV_SI_BS)));
              d_qjungat_d_dV_DI_BD = (((model_.qprefgat_d)*(-d_tmpv_dV_DI_BD))+((model_.qpref2gat_d)*(d_Vjun_d_dV_DI_BD-d_vjv_dV_DI_BD)));
              qjungat_d = (((model_.qprefgat_d)*(1.0-tmpv))+((model_.qpref2gat_d)*(Vjun_d-vjv)));
            }
          }
          // End block evaluateDynamic
        }
        else
        {

          d_vbbt_dV_DI_BD = d_vbbt_dV_SI_BS =  0.0;
          vbbt = 0.0;

          d_two_psistar_dV_DI_BD = d_two_psistar_dV_SI_BS =  0.0;
          two_psistar = 0.0;
          if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
          {
            h1 = ((4.0*vch_s)*vch_s);
            h2 = (vch_s/vfmin_s);

            d_h2d_dV_DI_BD =  0.0;
            d_h2d_dV_SI_BS = d_Vjun_s_dV_SI_BS;
            h2d = (Vjun_s+(vch_s*h2));

            d_h3_dV_SI_BS = d_h2d_dV_SI_BS;
            d_h3_dV_DI_BD = d_h2d_dV_DI_BD;
            h3 = (vfmin_s+h2d);

            d_h4_dV_SI_BS = (-d_h2d_dV_SI_BS);
            d_h4_dV_DI_BD = (-d_h2d_dV_DI_BD);
            h4 = (vfmin_s-h2d);
            {
              double value_sqrt_0 = sqrt(((h4*h4)+h1));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_h5_dV_SI_BS = (deriv_sqrt_0_d0*(((h4*d_h4_dV_SI_BS)+(d_h4_dV_SI_BS*h4))));
              d_h5_dV_DI_BD = (deriv_sqrt_0_d0*(((h4*d_h4_dV_DI_BD)+(d_h4_dV_DI_BD*h4))));
              h5 = value_sqrt_0;
            }

            d_vj_dV_DI_BD = (2.0*(-(Vjun_s*vfmin_s)*(d_h3_dV_DI_BD+d_h5_dV_DI_BD)/(h3+h5)/(h3+h5)));
            d_vj_dV_SI_BS = (2.0*(((h3+h5)*(d_Vjun_s_dV_SI_BS*vfmin_s)-(Vjun_s*vfmin_s)*(d_h3_dV_SI_BS+d_h5_dV_SI_BS))/(h3+h5)/(h3+h5)));
            vj = (2.0*((Vjun_s*vfmin_s)/(h3+h5)));
            if ((Vjun_s<VMAX_s))
            {
              if ((fabs((0.5*(Vjun_s*(model_.phitdinv))))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp((0.5*(Vjun_s*(model_.phitdinv))));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_zinv_dV_DI_BD =  0.0;
                  d_zinv_dV_SI_BS = (deriv_exp_0_d0*((0.5*(d_Vjun_s_dV_SI_BS*(model_.phitdinv)))));
                  zinv = value_exp_0;
                }
              }
              else
              {
                if (((0.5*(Vjun_s*(model_.phitdinv)))<0.0))
                {

                  d_zinv_dV_DI_BD =  0.0;
                  d_zinv_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(0.5*((((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*((-(0.5*(d_Vjun_s_dV_SI_BS*(model_.phitdinv))))*3.3333333333333333e-01))+((-(0.5*(d_Vjun_s_dV_SI_BS*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01))))))+((-(0.5*(d_Vjun_s_dV_SI_BS*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01))))))));
                  zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_zinv_dV_DI_BD =  0.0;
                  d_zinv_dV_SI_BS = (1.0e100*((((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(0.5*((((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*((0.5*(d_Vjun_s_dV_SI_BS*(model_.phitdinv)))*3.3333333333333333e-01))+((0.5*(d_Vjun_s_dV_SI_BS*(model_.phitdinv)))*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((0.5*(d_Vjun_s_dV_SI_BS*(model_.phitdinv)))*(1.0+(0.5*(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  zinv = (1.0e100*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_idmult_dV_DI_BD =  0.0;
              d_idmult_dV_SI_BS = ((zinv*d_zinv_dV_SI_BS)+(d_zinv_dV_SI_BS*zinv));
              idmult = (zinv*zinv);
            }
            else
            {

              d_idmult_dV_DI_BD =  0.0;
              d_idmult_dV_SI_BS = ((d_Vjun_s_dV_SI_BS*(model_.phitdinv))*exp_VMAX_over_phitd_s);
              idmult = ((1.0+((Vjun_s-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
              {
                double value_sqrt_0 = sqrt(idmult);
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_zinv_dV_DI_BD =  0.0;
                d_zinv_dV_SI_BS = (deriv_sqrt_0_d0*(d_idmult_dV_SI_BS));
                zinv = value_sqrt_0;
              }
            }

            d_idmult_dV_DI_BD =  0.0;
            idmult = (idmult-1.0);

            d_z_dV_DI_BD =  0.0;
            d_z_dV_SI_BS = (-d_zinv_dV_SI_BS/zinv/zinv);
            z = (1.0/zinv);
            if ((Vjun_s>0.0))
            {
              {
                double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
                double value_log_1 = log(((2.0+z)+value_sqrt_0));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
                double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));

                d_two_psistar_dV_DI_BD =  0.0;
                d_two_psistar_dV_SI_BS = (2.0*((model_.phitd)*(deriv_log_1_d0*((d_z_dV_SI_BS+(deriv_sqrt_0_d0*((((z+1.0)*d_z_dV_SI_BS)+(d_z_dV_SI_BS*(z+3.0))))))))));
                two_psistar = (2.0*((model_.phitd)*value_log_1));
              }
            }
            else
            {
              {
                double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
                double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
                double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));

                d_two_psistar_dV_DI_BD =  0.0;
                d_two_psistar_dV_SI_BS = ((-d_Vjun_s_dV_SI_BS)+(2.0*((model_.phitd)*(deriv_log_1_d0*(((2.0*d_zinv_dV_SI_BS)+(deriv_sqrt_0_d0*((((1.0+zinv)*(3.0*d_zinv_dV_SI_BS))+(d_zinv_dV_SI_BS*(1.0+(3.0*zinv))))))))))));
                two_psistar = ((-Vjun_s)+(2.0*((model_.phitd)*value_log_1)));
              }
            }

            d_vjlim_dV_DI_BD =  0.0;
            d_vjlim_dV_SI_BS = (-d_two_psistar_dV_SI_BS);
            vjlim = (vbimin_s-two_psistar);
            {
              double value_sqrt_0 = sqrt((((Vjun_s-vjlim)*(Vjun_s-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_vjsrh_dV_DI_BD =  0.0;
              d_vjsrh_dV_SI_BS = (0.5*((d_Vjun_s_dV_SI_BS+d_vjlim_dV_SI_BS)-(deriv_sqrt_0_d0*((((Vjun_s-vjlim)*(d_Vjun_s_dV_SI_BS-d_vjlim_dV_SI_BS))+((d_Vjun_s_dV_SI_BS-d_vjlim_dV_SI_BS)*(Vjun_s-vjlim)))))));
              vjsrh = (0.5*((Vjun_s+vjlim)-value_sqrt_0));
            }
            {
              double value_sqrt_0 = sqrt((((Vjun_s-vbbtlim_s)*(Vjun_s-vbbtlim_s))+((4.0*(model_.phitr))*(model_.phitr))));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_vbbt_dV_DI_BD =  0.0;
              d_vbbt_dV_SI_BS = (0.5*(d_Vjun_s_dV_SI_BS-(deriv_sqrt_0_d0*((((Vjun_s-vbbtlim_s)*d_Vjun_s_dV_SI_BS)+(d_Vjun_s_dV_SI_BS*(Vjun_s-vbbtlim_s)))))));
              vbbt = (0.5*((Vjun_s+vbbtlim_s)-value_sqrt_0));
            }
            {
              double value_sqrt_0 = sqrt((((Vjun_s)*(Vjun_s))+((4.0*1.0e-6)*1.0e-6)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_vav_dV_DI_BD =  0.0;
              d_vav_dV_SI_BS = (0.5*((d_Vjun_s_dV_SI_BS)-(deriv_sqrt_0_d0*((((Vjun_s)*(d_Vjun_s_dV_SI_BS))+((d_Vjun_s_dV_SI_BS)*(Vjun_s)))))));
              vav = (0.5*((Vjun_s)-value_sqrt_0));
            }
          }
          if ((ABSOURCE_i==0.0))
          {

            d_ijunbot_s_dV_SI_BS = d_ijunbot_s_dV_DI_BD =  0.0;
            ijunbot_s = 0.0;

            d_qjunbot_s_dV_DI_BD = d_qjunbot_s_dV_SI_BS =  0.0;
            qjunbot_s = 0.0;
          }
          else
          {
            if (((model_.one_minus_PBOT)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-(d_vj_dV_DI_BD*(model_.vbiinvbot)))));
                d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-(d_vj_dV_SI_BS*(model_.vbiinvbot)))));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
                double  deriv_pow_0_d0 = (((1.0-(vj*(model_.vbiinvbot))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT)/(1.0-(vj*(model_.vbiinvbot)))));

                d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-(d_vj_dV_DI_BD*(model_.vbiinvbot)))));
                d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-(d_vj_dV_SI_BS*(model_.vbiinvbot)))));
                tmp = value_pow_0;
              }
            }

            d_qjunbot_s_dV_DI_BD = (((model_.qprefbot)*(-d_tmp_dV_DI_BD))+((model_.qpref2bot)*(-d_vj_dV_DI_BD)));
            d_qjunbot_s_dV_SI_BS = (((model_.qprefbot)*(-d_tmp_dV_SI_BS))+((model_.qpref2bot)*(d_Vjun_s_dV_SI_BS-d_vj_dV_SI_BS)));
            qjunbot_s = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(Vjun_s-vj)));

            d_id_dV_DI_BD =  0.0;
            d_id_dV_SI_BS = ((model_.idsatbot)*d_idmult_dV_SI_BS);
            id = ((model_.idsatbot)*idmult);
            if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
            {

              d_isrh_dV_SI_BS = d_isrh_dV_DI_BD =  0.0;
              isrh = 0.0;
            }
            else
            {

              d_vbi_minus_vjsrh_dV_DI_BD =  0.0;
              d_vbi_minus_vjsrh_dV_SI_BS = (-d_vjsrh_dV_SI_BS);
              vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
              {
                double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_wsrhstep_dV_DI_BD =  0.0;
                d_wsrhstep_dV_SI_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_SI_BS-two_psistar*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                wsrhstep = (1.0-value_sqrt_0);
              }
              if (((model_.PBOT_i)==0.5))
              {

                d_dwsrh_dV_DI_BD = d_dwsrh_dV_SI_BS =  0.0;
                dwsrh = 0.0;
              }
              else
              {
                {
                  double value_log_0 = log(wsrhstep);
                  double  deriv_log_0_d0 = (1.0/wsrhstep);

                  d_dwsrh_dV_DI_BD =  0.0;
                  d_dwsrh_dV_SI_BS = (((((1.0-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_SI_BS)))+(((wsrhstep*d_wsrhstep_dV_SI_BS)+(d_wsrhstep_dV_SI_BS*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_SI_BS))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_SI_BS)*(1.0-(2.0*(model_.PBOT_i))));
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
                }
              }

              d_wsrh_dV_DI_BD =  0.0;
              d_wsrh_dV_SI_BS = (d_wsrhstep_dV_SI_BS+d_dwsrh_dV_SI_BS);
              wsrh = (wsrhstep+dwsrh);
              if (((model_.PBOT_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRBOTinv))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
                  double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRBOTinv)) == 0.0)?0.0:(value_pow_0*(model_.PBOT_i)/(vbi_minus_vjsrh*(model_.VBIRBOTinv))));

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRBOTinv))));
                  tmp = value_pow_0;
                }
              }

              d_wdep_dV_DI_BD = ((model_.wdepnulrbot)*d_tmp_dV_DI_BD);
              d_wdep_dV_SI_BS = ((model_.wdepnulrbot)*d_tmp_dV_SI_BS);
              wdep = ((model_.wdepnulrbot)*tmp);

              d_asrh_dV_DI_BD = ((model_.ftdbot)*(((zinv-1.0)*d_wdep_dV_DI_BD)+(d_zinv_dV_DI_BD*wdep)));
              d_asrh_dV_SI_BS = ((model_.ftdbot)*(((zinv-1.0)*d_wdep_dV_SI_BS)+(d_zinv_dV_SI_BS*wdep)));
              asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));

              d_isrh_dV_DI_BD = ((model_.CSRHBOT_i)*((asrh*d_wsrh_dV_DI_BD)+(d_asrh_dV_DI_BD*wsrh)));
              d_isrh_dV_SI_BS = ((model_.CSRHBOT_i)*((asrh*d_wsrh_dV_SI_BS)+(d_asrh_dV_SI_BS*wsrh)));
              isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
            }
            if (((model_.CTATBOT_i)==0.0))
            {

              d_itat_dV_SI_BS = d_itat_dV_DI_BD =  0.0;
              itat = 0.0;
            }
            else
            {

              d_btat_dV_DI_BD = ((model_.btatpartbot)*((vbi_minus_vjsrh*(d_wdep_dV_DI_BD*(model_.one_minus_PBOT))-(wdep*(model_.one_minus_PBOT))*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              d_btat_dV_SI_BS = ((model_.btatpartbot)*((vbi_minus_vjsrh*(d_wdep_dV_SI_BS*(model_.one_minus_PBOT))-(wdep*(model_.one_minus_PBOT))*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));

              d_twoatatoverthreebtat_dV_DI_BD = (-(0.666666666666667*(model_.atatbot))*d_btat_dV_DI_BD/btat/btat);
              d_twoatatoverthreebtat_dV_SI_BS = (-(0.666666666666667*(model_.atatbot))*d_btat_dV_SI_BS/btat/btat);
              twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);

              d_umaxbeforelimiting_dV_DI_BD = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_DI_BD)+(d_twoatatoverthreebtat_dV_DI_BD*twoatatoverthreebtat));
              d_umaxbeforelimiting_dV_SI_BS = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_SI_BS)+(d_twoatatoverthreebtat_dV_SI_BS*twoatatoverthreebtat));
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_umax_dV_DI_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD)+(d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD)+(d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
                d_umax_dV_SI_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS)+(d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS)+(d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
                umax = value_sqrt_0;
              }
              {
                double value_fabs_0 = fabs(umax);
                double value_sqrt_1 = sqrt(value_fabs_0);
                double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_sqrtumax_dV_DI_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_DI_BD))));
                d_sqrtumax_dV_SI_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_SI_BS))));
                sqrtumax = value_sqrt_1;
              }

              d_umaxpoweronepointfive_dV_DI_BD = ((umax*d_sqrtumax_dV_DI_BD)+(d_umax_dV_DI_BD*sqrtumax));
              d_umaxpoweronepointfive_dV_SI_BS = ((umax*d_sqrtumax_dV_SI_BS)+(d_umax_dV_SI_BS*sqrtumax));
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
              {

                d_wgamma_dV_DI_BD = (-((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
                d_wgamma_dV_SI_BS = (-((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
                wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
                  double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))/(1.0+(btat*umaxpoweronepointfive))));

                  d_wgamma_dV_DI_BD = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))));
                  d_wgamma_dV_SI_BS = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))));
                  wgamma = value_pow_0;
                }
              }

              d_wtat_dV_DI_BD = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_DI_BD)+(d_wsrh_dV_DI_BD*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_DI_BD+d_wgamma_dV_DI_BD))/(wsrh+wgamma)/(wsrh+wgamma));
              d_wtat_dV_SI_BS = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_SI_BS)+(d_wsrh_dV_SI_BS*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_SI_BS+d_wgamma_dV_SI_BS))/(wsrh+wgamma)/(wsrh+wgamma));
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_ktat_dV_DI_BD = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_DI_BD-btat*d_sqrtumax_dV_DI_BD)/sqrtumax/sqrtumax))));
                d_ktat_dV_SI_BS = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_SI_BS-btat*d_sqrtumax_dV_SI_BS)/sqrtumax/sqrtumax))));
                ktat = value_sqrt_0;
              }

              d_ltat_dV_DI_BD = ((2.0*((twoatatoverthreebtat*d_sqrtumax_dV_DI_BD)+(d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)))-d_umax_dV_DI_BD);
              d_ltat_dV_SI_BS = ((2.0*((twoatatoverthreebtat*d_sqrtumax_dV_SI_BS)+(d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)))-d_umax_dV_SI_BS);
              ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);

              d_mtat_dV_DI_BD = ((((((model_.atatbot)*twoatatoverthreebtat)*d_sqrtumax_dV_DI_BD)+(((model_.atatbot)*d_twoatatoverthreebtat_dV_DI_BD)*sqrtumax))-((model_.atatbot)*d_umax_dV_DI_BD))+(0.5*((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))));
              d_mtat_dV_SI_BS = ((((((model_.atatbot)*twoatatoverthreebtat)*d_sqrtumax_dV_SI_BS)+(((model_.atatbot)*d_twoatatoverthreebtat_dV_SI_BS)*sqrtumax))-((model_.atatbot)*d_umax_dV_SI_BS))+(0.5*((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))));
              mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));

              d_xerfc_dV_DI_BD = (((ltat-1.0)*d_ktat_dV_DI_BD)+(d_ltat_dV_DI_BD*ktat));
              d_xerfc_dV_SI_BS = (((ltat-1.0)*d_ktat_dV_SI_BS)+(d_ltat_dV_SI_BS*ktat));
              xerfc = ((ltat-1.0)*ktat);

              d_ysq_dV_DI_BD = ((xerfc*d_xerfc_dV_DI_BD)+(d_xerfc_dV_DI_BD*xerfc));
              d_ysq_dV_SI_BS = ((xerfc*d_xerfc_dV_SI_BS)+(d_xerfc_dV_SI_BS*xerfc));
              ysq = (xerfc*xerfc);
              if ((xerfc>0.0))
              {

                d_terfc_dV_DI_BD = (-((model_.perfc)*d_xerfc_dV_DI_BD)/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
                d_terfc_dV_SI_BS = (-((model_.perfc)*d_xerfc_dV_SI_BS)/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
                terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
              }
              else
              {

                d_terfc_dV_DI_BD = (-(-((model_.perfc)*d_xerfc_dV_DI_BD))/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
                d_terfc_dV_SI_BS = (-(-((model_.perfc)*d_xerfc_dV_SI_BS))/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
                terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(((-ysq)+mtat));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_DI_BD = (deriv_exp_0_d0*(((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD)));
                  d_tmp_dV_SI_BS = (deriv_exp_0_d0*(((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS)));
                  tmp = value_exp_0;
                }
              }
              else
              {

                d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*3.3333333333333333e-01))+((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*3.3333333333333333e-01))+((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }

              d_erfcpos_dV_DI_BD = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_DI_BD)+((((0.29214664*d_terfc_dV_DI_BD)+((model_.berfc)*((terfc*d_terfc_dV_DI_BD)+(d_terfc_dV_DI_BD*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_DI_BD)+(((terfc*d_terfc_dV_DI_BD)+(d_terfc_dV_DI_BD*terfc))*terfc))))*tmp));
              d_erfcpos_dV_SI_BS = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_SI_BS)+((((0.29214664*d_terfc_dV_SI_BS)+((model_.berfc)*((terfc*d_terfc_dV_SI_BS)+(d_terfc_dV_SI_BS*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_SI_BS)+(((terfc*d_terfc_dV_SI_BS)+(d_terfc_dV_SI_BS*terfc))*terfc))))*tmp));
              erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0.0))
              {

                d_erfctimesexpmtat_dV_DI_BD = d_erfcpos_dV_DI_BD;
                d_erfctimesexpmtat_dV_SI_BS = d_erfcpos_dV_SI_BS;
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp(mtat);
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_tmp_dV_DI_BD = (deriv_exp_0_d0*(d_mtat_dV_DI_BD));
                    d_tmp_dV_SI_BS = (deriv_exp_0_d0*(d_mtat_dV_SI_BS));
                    tmp = value_exp_0;
                  }
                }
                else
                {

                  d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_DI_BD)*3.3333333333333333e-01))+((-d_mtat_dV_DI_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_DI_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_SI_BS)*3.3333333333333333e-01))+((-d_mtat_dV_SI_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_SI_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }

                d_erfctimesexpmtat_dV_DI_BD = ((2.0*d_tmp_dV_DI_BD)-d_erfcpos_dV_DI_BD);
                d_erfctimesexpmtat_dV_SI_BS = ((2.0*d_tmp_dV_SI_BS)-d_erfcpos_dV_SI_BS);
                erfctimesexpmtat = ((2.0*tmp)-erfcpos);
              }

              d_gammamax_dV_DI_BD = ((1.77245385090551603*0.5)*((ktat*((model_.atatbot)*d_erfctimesexpmtat_dV_DI_BD)-((model_.atatbot)*erfctimesexpmtat)*d_ktat_dV_DI_BD)/ktat/ktat));
              d_gammamax_dV_SI_BS = ((1.77245385090551603*0.5)*((ktat*((model_.atatbot)*d_erfctimesexpmtat_dV_SI_BS)-((model_.atatbot)*erfctimesexpmtat)*d_ktat_dV_SI_BS)/ktat/ktat));
              gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));

              d_itat_dV_DI_BD = ((model_.CTATBOT_i)*(((asrh*gammamax)*d_wtat_dV_DI_BD)+(((asrh*d_gammamax_dV_DI_BD)+(d_asrh_dV_DI_BD*gammamax))*wtat)));
              d_itat_dV_SI_BS = ((model_.CTATBOT_i)*(((asrh*gammamax)*d_wtat_dV_SI_BS)+(((asrh*d_gammamax_dV_SI_BS)+(d_asrh_dV_SI_BS*gammamax))*wtat)));
              itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
            }
            if (((model_.CBBTBOT_i)==0.0))
            {

              d_ibbt_dV_SI_BS = d_ibbt_dV_DI_BD =  0.0;
              ibbt = 0.0;
            }
            else
            {
              if (((model_.PBOT_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*(((-d_vbbt_dV_SI_BS)*(model_.VBIRBOTinv))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
                  double  deriv_pow_0_d0 = (((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)) == 0.0)?0.0:(value_pow_0*(model_.PBOT_i)/(((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv))));

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (deriv_pow_0_d0*(((-d_vbbt_dV_SI_BS)*(model_.VBIRBOTinv))));
                  tmp = value_pow_0;
                }
              }

              d_Fmaxr_dV_DI_BD = ((model_.one_over_one_minus_PBOT)*((tmp*((-d_vbbt_dV_DI_BD)*(model_.wdepnulrinvbot))-(((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))*d_tmp_dV_DI_BD)/tmp/tmp));
              d_Fmaxr_dV_SI_BS = ((model_.one_over_one_minus_PBOT)*((tmp*((-d_vbbt_dV_SI_BS)*(model_.wdepnulrinvbot))-(((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))*d_tmp_dV_SI_BS)/tmp/tmp));
              Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
              if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_DI_BD = (deriv_exp_0_d0*((-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)));
                  d_tmp_dV_SI_BS = (deriv_exp_0_d0*((-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
                {

                  d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*((-(-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*((-(-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_tmp_dV_DI_BD = (1.0e100*(((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (1.0e100*(((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_ibbt_dV_DI_BD = ((model_.CBBTBOT_i)*((((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_DI_BD)+((((Vjun_s*Fmaxr)*d_Fmaxr_dV_DI_BD)+((Vjun_s*d_Fmaxr_dV_DI_BD)*Fmaxr))*tmp)));
              d_ibbt_dV_SI_BS = ((model_.CBBTBOT_i)*((((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_SI_BS)+((((Vjun_s*Fmaxr)*d_Fmaxr_dV_SI_BS)+(((Vjun_s*d_Fmaxr_dV_SI_BS)+(d_Vjun_s_dV_SI_BS*Fmaxr))*Fmaxr))*tmp)));
              ibbt = ((model_.CBBTBOT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
            }
            if (((model_.VBRBOT_i)>1.0e3))
            {

              d_fbreakdown_dV_SI_BS = d_fbreakdown_dV_DI_BD =  0.0;
              fbreakdown = 1.0;
            }
            else
            {
              if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
              {
                if (((model_.PBRBOT_i)==4.0))
                {

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(d_vav_dV_SI_BS*(model_.VBRinvbot)))+(((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(d_vav_dV_SI_BS*(model_.VBRinvbot)))+((((vav*(model_.VBRinvbot))*(d_vav_dV_SI_BS*(model_.VBRinvbot)))+((d_vav_dV_SI_BS*(model_.VBRinvbot))*(vav*(model_.VBRinvbot))))*(vav*(model_.VBRinvbot))))*(vav*(model_.VBRinvbot))));
                  tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
                }
                else
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
                    double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
                    double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRBOT_i)/value_fabs_0));

                    d_tmp_dV_DI_BD =  0.0;
                    d_tmp_dV_SI_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_SI_BS*(model_.VBRinvbot))))));
                    tmp = value_pow_1;
                  }
                }

                d_fbreakdown_dV_DI_BD = (-(-d_tmp_dV_DI_BD)/(1.0-tmp)/(1.0-tmp));
                d_fbreakdown_dV_SI_BS = (-(-d_tmp_dV_SI_BS)/(1.0-tmp)/(1.0-tmp));
                fbreakdown = (1.0/(1.0-tmp));
              }
              else
              {

                d_fbreakdown_dV_DI_BD =  0.0;
                d_fbreakdown_dV_SI_BS = (d_vav_dV_SI_BS*(model_.slopebot));
                fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
              }
            }

            d_ijunbot_s_dV_DI_BD = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_DI_BD)+((((d_id_dV_DI_BD+d_isrh_dV_DI_BD)+d_itat_dV_DI_BD)+d_ibbt_dV_DI_BD)*fbreakdown));
            d_ijunbot_s_dV_SI_BS = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_SI_BS)+((((d_id_dV_SI_BS+d_isrh_dV_SI_BS)+d_itat_dV_SI_BS)+d_ibbt_dV_SI_BS)*fbreakdown));
            ijunbot_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((LSSOURCE_i==0.0))
          {

            d_ijunsti_s_dV_SI_BS = d_ijunsti_s_dV_DI_BD =  0.0;
            ijunsti_s = 0.0;

            d_qjunsti_s_dV_DI_BD = d_qjunsti_s_dV_SI_BS =  0.0;
            qjunsti_s = 0.0;
          }
          else
          {
            if (((model_.one_minus_PSTI)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-(d_vj_dV_DI_BD*(model_.vbiinvsti)))));
                d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-(d_vj_dV_SI_BS*(model_.vbiinvsti)))));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
                double  deriv_pow_0_d0 = (((1.0-(vj*(model_.vbiinvsti))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI)/(1.0-(vj*(model_.vbiinvsti)))));

                d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-(d_vj_dV_DI_BD*(model_.vbiinvsti)))));
                d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-(d_vj_dV_SI_BS*(model_.vbiinvsti)))));
                tmp = value_pow_0;
              }
            }

            d_qjunsti_s_dV_DI_BD = (((model_.qprefsti)*(-d_tmp_dV_DI_BD))+((model_.qpref2sti)*(-d_vj_dV_DI_BD)));
            d_qjunsti_s_dV_SI_BS = (((model_.qprefsti)*(-d_tmp_dV_SI_BS))+((model_.qpref2sti)*(d_Vjun_s_dV_SI_BS-d_vj_dV_SI_BS)));
            qjunsti_s = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(Vjun_s-vj)));

            d_id_dV_DI_BD =  0.0;
            d_id_dV_SI_BS = ((model_.idsatsti)*d_idmult_dV_SI_BS);
            id = ((model_.idsatsti)*idmult);
            if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
            {

              d_isrh_dV_SI_BS = d_isrh_dV_DI_BD =  0.0;
              isrh = 0.0;
            }
            else
            {

              d_vbi_minus_vjsrh_dV_DI_BD =  0.0;
              d_vbi_minus_vjsrh_dV_SI_BS = (-d_vjsrh_dV_SI_BS);
              vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
              {
                double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_wsrhstep_dV_DI_BD =  0.0;
                d_wsrhstep_dV_SI_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_SI_BS-two_psistar*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                wsrhstep = (1.0-value_sqrt_0);
              }
              if (((model_.PSTI_i)==0.5))
              {

                d_dwsrh_dV_DI_BD = d_dwsrh_dV_SI_BS =  0.0;
                dwsrh = 0.0;
              }
              else
              {
                {
                  double value_log_0 = log(wsrhstep);
                  double  deriv_log_0_d0 = (1.0/wsrhstep);

                  d_dwsrh_dV_DI_BD =  0.0;
                  d_dwsrh_dV_SI_BS = (((((1.0-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_SI_BS)))+(((wsrhstep*d_wsrhstep_dV_SI_BS)+(d_wsrhstep_dV_SI_BS*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_SI_BS))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_SI_BS)*(1.0-(2.0*(model_.PSTI_i))));
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
                }
              }

              d_wsrh_dV_DI_BD =  0.0;
              d_wsrh_dV_SI_BS = (d_wsrhstep_dV_SI_BS+d_dwsrh_dV_SI_BS);
              wsrh = (wsrhstep+dwsrh);
              if (((model_.PSTI_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRSTIinv))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
                  double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRSTIinv)) == 0.0)?0.0:(value_pow_0*(model_.PSTI_i)/(vbi_minus_vjsrh*(model_.VBIRSTIinv))));

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRSTIinv))));
                  tmp = value_pow_0;
                }
              }

              d_wdep_dV_DI_BD = ((model_.wdepnulrsti)*d_tmp_dV_DI_BD);
              d_wdep_dV_SI_BS = ((model_.wdepnulrsti)*d_tmp_dV_SI_BS);
              wdep = ((model_.wdepnulrsti)*tmp);

              d_asrh_dV_DI_BD = ((model_.ftdsti)*(((zinv-1.0)*d_wdep_dV_DI_BD)+(d_zinv_dV_DI_BD*wdep)));
              d_asrh_dV_SI_BS = ((model_.ftdsti)*(((zinv-1.0)*d_wdep_dV_SI_BS)+(d_zinv_dV_SI_BS*wdep)));
              asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));

              d_isrh_dV_DI_BD = ((model_.CSRHSTI_i)*((asrh*d_wsrh_dV_DI_BD)+(d_asrh_dV_DI_BD*wsrh)));
              d_isrh_dV_SI_BS = ((model_.CSRHSTI_i)*((asrh*d_wsrh_dV_SI_BS)+(d_asrh_dV_SI_BS*wsrh)));
              isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
            }
            if (((model_.CTATSTI_i)==0.0))
            {

              d_itat_dV_SI_BS = d_itat_dV_DI_BD =  0.0;
              itat = 0.0;
            }
            else
            {

              d_btat_dV_DI_BD = ((model_.btatpartsti)*((vbi_minus_vjsrh*(d_wdep_dV_DI_BD*(model_.one_minus_PSTI))-(wdep*(model_.one_minus_PSTI))*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              d_btat_dV_SI_BS = ((model_.btatpartsti)*((vbi_minus_vjsrh*(d_wdep_dV_SI_BS*(model_.one_minus_PSTI))-(wdep*(model_.one_minus_PSTI))*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));

              d_twoatatoverthreebtat_dV_DI_BD = (-(0.666666666666667*(model_.atatsti))*d_btat_dV_DI_BD/btat/btat);
              d_twoatatoverthreebtat_dV_SI_BS = (-(0.666666666666667*(model_.atatsti))*d_btat_dV_SI_BS/btat/btat);
              twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);

              d_umaxbeforelimiting_dV_DI_BD = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_DI_BD)+(d_twoatatoverthreebtat_dV_DI_BD*twoatatoverthreebtat));
              d_umaxbeforelimiting_dV_SI_BS = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_SI_BS)+(d_twoatatoverthreebtat_dV_SI_BS*twoatatoverthreebtat));
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_umax_dV_DI_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD)+(d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD)+(d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
                d_umax_dV_SI_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS)+(d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS)+(d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
                umax = value_sqrt_0;
              }
              {
                double value_fabs_0 = fabs(umax);
                double value_sqrt_1 = sqrt(value_fabs_0);
                double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_sqrtumax_dV_DI_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_DI_BD))));
                d_sqrtumax_dV_SI_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_SI_BS))));
                sqrtumax = value_sqrt_1;
              }

              d_umaxpoweronepointfive_dV_DI_BD = ((umax*d_sqrtumax_dV_DI_BD)+(d_umax_dV_DI_BD*sqrtumax));
              d_umaxpoweronepointfive_dV_SI_BS = ((umax*d_sqrtumax_dV_SI_BS)+(d_umax_dV_SI_BS*sqrtumax));
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
              {

                d_wgamma_dV_DI_BD = (-((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
                d_wgamma_dV_SI_BS = (-((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
                wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
                  double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))/(1.0+(btat*umaxpoweronepointfive))));

                  d_wgamma_dV_DI_BD = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))));
                  d_wgamma_dV_SI_BS = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))));
                  wgamma = value_pow_0;
                }
              }

              d_wtat_dV_DI_BD = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_DI_BD)+(d_wsrh_dV_DI_BD*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_DI_BD+d_wgamma_dV_DI_BD))/(wsrh+wgamma)/(wsrh+wgamma));
              d_wtat_dV_SI_BS = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_SI_BS)+(d_wsrh_dV_SI_BS*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_SI_BS+d_wgamma_dV_SI_BS))/(wsrh+wgamma)/(wsrh+wgamma));
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_ktat_dV_DI_BD = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_DI_BD-btat*d_sqrtumax_dV_DI_BD)/sqrtumax/sqrtumax))));
                d_ktat_dV_SI_BS = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_SI_BS-btat*d_sqrtumax_dV_SI_BS)/sqrtumax/sqrtumax))));
                ktat = value_sqrt_0;
              }

              d_ltat_dV_DI_BD = ((2.0*((twoatatoverthreebtat*d_sqrtumax_dV_DI_BD)+(d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)))-d_umax_dV_DI_BD);
              d_ltat_dV_SI_BS = ((2.0*((twoatatoverthreebtat*d_sqrtumax_dV_SI_BS)+(d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)))-d_umax_dV_SI_BS);
              ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);

              d_mtat_dV_DI_BD = ((((((model_.atatsti)*twoatatoverthreebtat)*d_sqrtumax_dV_DI_BD)+(((model_.atatsti)*d_twoatatoverthreebtat_dV_DI_BD)*sqrtumax))-((model_.atatsti)*d_umax_dV_DI_BD))+(0.5*((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))));
              d_mtat_dV_SI_BS = ((((((model_.atatsti)*twoatatoverthreebtat)*d_sqrtumax_dV_SI_BS)+(((model_.atatsti)*d_twoatatoverthreebtat_dV_SI_BS)*sqrtumax))-((model_.atatsti)*d_umax_dV_SI_BS))+(0.5*((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))));
              mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));

              d_xerfc_dV_DI_BD = (((ltat-1.0)*d_ktat_dV_DI_BD)+(d_ltat_dV_DI_BD*ktat));
              d_xerfc_dV_SI_BS = (((ltat-1.0)*d_ktat_dV_SI_BS)+(d_ltat_dV_SI_BS*ktat));
              xerfc = ((ltat-1.0)*ktat);

              d_ysq_dV_DI_BD = ((xerfc*d_xerfc_dV_DI_BD)+(d_xerfc_dV_DI_BD*xerfc));
              d_ysq_dV_SI_BS = ((xerfc*d_xerfc_dV_SI_BS)+(d_xerfc_dV_SI_BS*xerfc));
              ysq = (xerfc*xerfc);
              if ((xerfc>0.0))
              {

                d_terfc_dV_DI_BD = (-((model_.perfc)*d_xerfc_dV_DI_BD)/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
                d_terfc_dV_SI_BS = (-((model_.perfc)*d_xerfc_dV_SI_BS)/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
                terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
              }
              else
              {

                d_terfc_dV_DI_BD = (-(-((model_.perfc)*d_xerfc_dV_DI_BD))/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
                d_terfc_dV_SI_BS = (-(-((model_.perfc)*d_xerfc_dV_SI_BS))/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
                terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(((-ysq)+mtat));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_DI_BD = (deriv_exp_0_d0*(((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD)));
                  d_tmp_dV_SI_BS = (deriv_exp_0_d0*(((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS)));
                  tmp = value_exp_0;
                }
              }
              else
              {

                d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*3.3333333333333333e-01))+((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*3.3333333333333333e-01))+((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }

              d_erfcpos_dV_DI_BD = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_DI_BD)+((((0.29214664*d_terfc_dV_DI_BD)+((model_.berfc)*((terfc*d_terfc_dV_DI_BD)+(d_terfc_dV_DI_BD*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_DI_BD)+(((terfc*d_terfc_dV_DI_BD)+(d_terfc_dV_DI_BD*terfc))*terfc))))*tmp));
              d_erfcpos_dV_SI_BS = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_SI_BS)+((((0.29214664*d_terfc_dV_SI_BS)+((model_.berfc)*((terfc*d_terfc_dV_SI_BS)+(d_terfc_dV_SI_BS*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_SI_BS)+(((terfc*d_terfc_dV_SI_BS)+(d_terfc_dV_SI_BS*terfc))*terfc))))*tmp));
              erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0.0))
              {

                d_erfctimesexpmtat_dV_DI_BD = d_erfcpos_dV_DI_BD;
                d_erfctimesexpmtat_dV_SI_BS = d_erfcpos_dV_SI_BS;
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp(mtat);
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_tmp_dV_DI_BD = (deriv_exp_0_d0*(d_mtat_dV_DI_BD));
                    d_tmp_dV_SI_BS = (deriv_exp_0_d0*(d_mtat_dV_SI_BS));
                    tmp = value_exp_0;
                  }
                }
                else
                {

                  d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_DI_BD)*3.3333333333333333e-01))+((-d_mtat_dV_DI_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_DI_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_SI_BS)*3.3333333333333333e-01))+((-d_mtat_dV_SI_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_SI_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }

                d_erfctimesexpmtat_dV_DI_BD = ((2.0*d_tmp_dV_DI_BD)-d_erfcpos_dV_DI_BD);
                d_erfctimesexpmtat_dV_SI_BS = ((2.0*d_tmp_dV_SI_BS)-d_erfcpos_dV_SI_BS);
                erfctimesexpmtat = ((2.0*tmp)-erfcpos);
              }

              d_gammamax_dV_DI_BD = ((1.77245385090551603*0.5)*((ktat*((model_.atatsti)*d_erfctimesexpmtat_dV_DI_BD)-((model_.atatsti)*erfctimesexpmtat)*d_ktat_dV_DI_BD)/ktat/ktat));
              d_gammamax_dV_SI_BS = ((1.77245385090551603*0.5)*((ktat*((model_.atatsti)*d_erfctimesexpmtat_dV_SI_BS)-((model_.atatsti)*erfctimesexpmtat)*d_ktat_dV_SI_BS)/ktat/ktat));
              gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));

              d_itat_dV_DI_BD = ((model_.CTATSTI_i)*(((asrh*gammamax)*d_wtat_dV_DI_BD)+(((asrh*d_gammamax_dV_DI_BD)+(d_asrh_dV_DI_BD*gammamax))*wtat)));
              d_itat_dV_SI_BS = ((model_.CTATSTI_i)*(((asrh*gammamax)*d_wtat_dV_SI_BS)+(((asrh*d_gammamax_dV_SI_BS)+(d_asrh_dV_SI_BS*gammamax))*wtat)));
              itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
            }
            if (((model_.CBBTSTI_i)==0.0))
            {

              d_ibbt_dV_SI_BS = d_ibbt_dV_DI_BD =  0.0;
              ibbt = 0.0;
            }
            else
            {
              if (((model_.PSTI_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*(((-d_vbbt_dV_SI_BS)*(model_.VBIRSTIinv))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
                  double  deriv_pow_0_d0 = (((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)) == 0.0)?0.0:(value_pow_0*(model_.PSTI_i)/(((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv))));

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (deriv_pow_0_d0*(((-d_vbbt_dV_SI_BS)*(model_.VBIRSTIinv))));
                  tmp = value_pow_0;
                }
              }

              d_Fmaxr_dV_DI_BD = ((model_.one_over_one_minus_PSTI)*((tmp*((-d_vbbt_dV_DI_BD)*(model_.wdepnulrinvsti))-(((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))*d_tmp_dV_DI_BD)/tmp/tmp));
              d_Fmaxr_dV_SI_BS = ((model_.one_over_one_minus_PSTI)*((tmp*((-d_vbbt_dV_SI_BS)*(model_.wdepnulrinvsti))-(((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))*d_tmp_dV_SI_BS)/tmp/tmp));
              Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
              if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_DI_BD = (deriv_exp_0_d0*((-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)));
                  d_tmp_dV_SI_BS = (deriv_exp_0_d0*((-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
                {

                  d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*((-(-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*((-(-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_tmp_dV_DI_BD = (1.0e100*(((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (1.0e100*(((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_ibbt_dV_DI_BD = ((model_.CBBTSTI_i)*((((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_DI_BD)+((((Vjun_s*Fmaxr)*d_Fmaxr_dV_DI_BD)+((Vjun_s*d_Fmaxr_dV_DI_BD)*Fmaxr))*tmp)));
              d_ibbt_dV_SI_BS = ((model_.CBBTSTI_i)*((((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_SI_BS)+((((Vjun_s*Fmaxr)*d_Fmaxr_dV_SI_BS)+(((Vjun_s*d_Fmaxr_dV_SI_BS)+(d_Vjun_s_dV_SI_BS*Fmaxr))*Fmaxr))*tmp)));
              ibbt = ((model_.CBBTSTI_i)*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
            }
            if (((model_.VBRSTI_i)>1.0e3))
            {

              d_fbreakdown_dV_SI_BS = d_fbreakdown_dV_DI_BD =  0.0;
              fbreakdown = 1.0;
            }
            else
            {
              if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
              {
                if (((model_.PBRSTI_i)==4.0))
                {

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(d_vav_dV_SI_BS*(model_.VBRinvsti)))+(((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(d_vav_dV_SI_BS*(model_.VBRinvsti)))+((((vav*(model_.VBRinvsti))*(d_vav_dV_SI_BS*(model_.VBRinvsti)))+((d_vav_dV_SI_BS*(model_.VBRinvsti))*(vav*(model_.VBRinvsti))))*(vav*(model_.VBRinvsti))))*(vav*(model_.VBRinvsti))));
                  tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
                }
                else
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
                    double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
                    double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRSTI_i)/value_fabs_0));

                    d_tmp_dV_DI_BD =  0.0;
                    d_tmp_dV_SI_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_SI_BS*(model_.VBRinvsti))))));
                    tmp = value_pow_1;
                  }
                }

                d_fbreakdown_dV_DI_BD = (-(-d_tmp_dV_DI_BD)/(1.0-tmp)/(1.0-tmp));
                d_fbreakdown_dV_SI_BS = (-(-d_tmp_dV_SI_BS)/(1.0-tmp)/(1.0-tmp));
                fbreakdown = (1.0/(1.0-tmp));
              }
              else
              {

                d_fbreakdown_dV_DI_BD =  0.0;
                d_fbreakdown_dV_SI_BS = (d_vav_dV_SI_BS*(model_.slopesti));
                fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
              }
            }

            d_ijunsti_s_dV_DI_BD = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_DI_BD)+((((d_id_dV_DI_BD+d_isrh_dV_DI_BD)+d_itat_dV_DI_BD)+d_ibbt_dV_DI_BD)*fbreakdown));
            d_ijunsti_s_dV_SI_BS = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_SI_BS)+((((d_id_dV_SI_BS+d_isrh_dV_SI_BS)+d_itat_dV_SI_BS)+d_ibbt_dV_SI_BS)*fbreakdown));
            ijunsti_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((LGSOURCE_i==0.0))
          {

            d_ijungat_s_dV_SI_BS = d_ijungat_s_dV_DI_BD =  0.0;
            ijungat_s = 0.0;

            d_qjungat_s_dV_DI_BD = d_qjungat_s_dV_SI_BS =  0.0;
            qjungat_s = 0.0;
          }
          else
          {
            if (((model_.one_minus_PGAT)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-(d_vj_dV_DI_BD*(model_.vbiinvgat)))));
                d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-(d_vj_dV_SI_BS*(model_.vbiinvgat)))));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
                double  deriv_pow_0_d0 = (((1.0-(vj*(model_.vbiinvgat))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT)/(1.0-(vj*(model_.vbiinvgat)))));

                d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-(d_vj_dV_DI_BD*(model_.vbiinvgat)))));
                d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-(d_vj_dV_SI_BS*(model_.vbiinvgat)))));
                tmp = value_pow_0;
              }
            }

            d_qjungat_s_dV_DI_BD = (((model_.qprefgat)*(-d_tmp_dV_DI_BD))+((model_.qpref2gat)*(-d_vj_dV_DI_BD)));
            d_qjungat_s_dV_SI_BS = (((model_.qprefgat)*(-d_tmp_dV_SI_BS))+((model_.qpref2gat)*(d_Vjun_s_dV_SI_BS-d_vj_dV_SI_BS)));
            qjungat_s = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(Vjun_s-vj)));

            d_id_dV_DI_BD =  0.0;
            d_id_dV_SI_BS = ((model_.idsatgat)*d_idmult_dV_SI_BS);
            id = ((model_.idsatgat)*idmult);
            if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
            {

              d_isrh_dV_SI_BS = d_isrh_dV_DI_BD =  0.0;
              isrh = 0.0;
            }
            else
            {

              d_vbi_minus_vjsrh_dV_DI_BD =  0.0;
              d_vbi_minus_vjsrh_dV_SI_BS = (-d_vjsrh_dV_SI_BS);
              vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
              {
                double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_wsrhstep_dV_DI_BD =  0.0;
                d_wsrhstep_dV_SI_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_SI_BS-two_psistar*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                wsrhstep = (1.0-value_sqrt_0);
              }
              if (((model_.PGAT_i)==0.5))
              {

                d_dwsrh_dV_DI_BD = d_dwsrh_dV_SI_BS =  0.0;
                dwsrh = 0.0;
              }
              else
              {
                {
                  double value_log_0 = log(wsrhstep);
                  double  deriv_log_0_d0 = (1.0/wsrhstep);

                  d_dwsrh_dV_DI_BD =  0.0;
                  d_dwsrh_dV_SI_BS = (((((1.0-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_SI_BS)))+(((wsrhstep*d_wsrhstep_dV_SI_BS)+(d_wsrhstep_dV_SI_BS*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_SI_BS))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_SI_BS)*(1.0-(2.0*(model_.PGAT_i))));
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
                }
              }

              d_wsrh_dV_DI_BD =  0.0;
              d_wsrh_dV_SI_BS = (d_wsrhstep_dV_SI_BS+d_dwsrh_dV_SI_BS);
              wsrh = (wsrhstep+dwsrh);
              if (((model_.PGAT_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRGATinv))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
                  double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRGATinv)) == 0.0)?0.0:(value_pow_0*(model_.PGAT_i)/(vbi_minus_vjsrh*(model_.VBIRGATinv))));

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRGATinv))));
                  tmp = value_pow_0;
                }
              }

              d_wdep_dV_DI_BD = ((model_.wdepnulrgat)*d_tmp_dV_DI_BD);
              d_wdep_dV_SI_BS = ((model_.wdepnulrgat)*d_tmp_dV_SI_BS);
              wdep = ((model_.wdepnulrgat)*tmp);

              d_asrh_dV_DI_BD = ((model_.ftdgat)*(((zinv-1.0)*d_wdep_dV_DI_BD)+(d_zinv_dV_DI_BD*wdep)));
              d_asrh_dV_SI_BS = ((model_.ftdgat)*(((zinv-1.0)*d_wdep_dV_SI_BS)+(d_zinv_dV_SI_BS*wdep)));
              asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));

              d_isrh_dV_DI_BD = ((model_.CSRHGAT_i)*((asrh*d_wsrh_dV_DI_BD)+(d_asrh_dV_DI_BD*wsrh)));
              d_isrh_dV_SI_BS = ((model_.CSRHGAT_i)*((asrh*d_wsrh_dV_SI_BS)+(d_asrh_dV_SI_BS*wsrh)));
              isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
            }
            if (((model_.CTATGAT_i)==0.0))
            {

              d_itat_dV_SI_BS = d_itat_dV_DI_BD =  0.0;
              itat = 0.0;
            }
            else
            {

              d_btat_dV_DI_BD = ((model_.btatpartgat)*((vbi_minus_vjsrh*(d_wdep_dV_DI_BD*(model_.one_minus_PGAT))-(wdep*(model_.one_minus_PGAT))*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              d_btat_dV_SI_BS = ((model_.btatpartgat)*((vbi_minus_vjsrh*(d_wdep_dV_SI_BS*(model_.one_minus_PGAT))-(wdep*(model_.one_minus_PGAT))*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));

              d_twoatatoverthreebtat_dV_DI_BD = (-(0.666666666666667*(model_.atatgat))*d_btat_dV_DI_BD/btat/btat);
              d_twoatatoverthreebtat_dV_SI_BS = (-(0.666666666666667*(model_.atatgat))*d_btat_dV_SI_BS/btat/btat);
              twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);

              d_umaxbeforelimiting_dV_DI_BD = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_DI_BD)+(d_twoatatoverthreebtat_dV_DI_BD*twoatatoverthreebtat));
              d_umaxbeforelimiting_dV_SI_BS = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_SI_BS)+(d_twoatatoverthreebtat_dV_SI_BS*twoatatoverthreebtat));
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_umax_dV_DI_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD)+(d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD)+(d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
                d_umax_dV_SI_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS)+(d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS)+(d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
                umax = value_sqrt_0;
              }
              {
                double value_fabs_0 = fabs(umax);
                double value_sqrt_1 = sqrt(value_fabs_0);
                double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_sqrtumax_dV_DI_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_DI_BD))));
                d_sqrtumax_dV_SI_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_SI_BS))));
                sqrtumax = value_sqrt_1;
              }

              d_umaxpoweronepointfive_dV_DI_BD = ((umax*d_sqrtumax_dV_DI_BD)+(d_umax_dV_DI_BD*sqrtumax));
              d_umaxpoweronepointfive_dV_SI_BS = ((umax*d_sqrtumax_dV_SI_BS)+(d_umax_dV_SI_BS*sqrtumax));
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
              {

                d_wgamma_dV_DI_BD = (-((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
                d_wgamma_dV_SI_BS = (-((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
                wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
                  double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))/(1.0+(btat*umaxpoweronepointfive))));

                  d_wgamma_dV_DI_BD = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))));
                  d_wgamma_dV_SI_BS = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))));
                  wgamma = value_pow_0;
                }
              }

              d_wtat_dV_DI_BD = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_DI_BD)+(d_wsrh_dV_DI_BD*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_DI_BD+d_wgamma_dV_DI_BD))/(wsrh+wgamma)/(wsrh+wgamma));
              d_wtat_dV_SI_BS = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_SI_BS)+(d_wsrh_dV_SI_BS*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_SI_BS+d_wgamma_dV_SI_BS))/(wsrh+wgamma)/(wsrh+wgamma));
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_ktat_dV_DI_BD = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_DI_BD-btat*d_sqrtumax_dV_DI_BD)/sqrtumax/sqrtumax))));
                d_ktat_dV_SI_BS = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_SI_BS-btat*d_sqrtumax_dV_SI_BS)/sqrtumax/sqrtumax))));
                ktat = value_sqrt_0;
              }

              d_ltat_dV_DI_BD = ((2.0*((twoatatoverthreebtat*d_sqrtumax_dV_DI_BD)+(d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)))-d_umax_dV_DI_BD);
              d_ltat_dV_SI_BS = ((2.0*((twoatatoverthreebtat*d_sqrtumax_dV_SI_BS)+(d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)))-d_umax_dV_SI_BS);
              ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);

              d_mtat_dV_DI_BD = ((((((model_.atatgat)*twoatatoverthreebtat)*d_sqrtumax_dV_DI_BD)+(((model_.atatgat)*d_twoatatoverthreebtat_dV_DI_BD)*sqrtumax))-((model_.atatgat)*d_umax_dV_DI_BD))+(0.5*((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))));
              d_mtat_dV_SI_BS = ((((((model_.atatgat)*twoatatoverthreebtat)*d_sqrtumax_dV_SI_BS)+(((model_.atatgat)*d_twoatatoverthreebtat_dV_SI_BS)*sqrtumax))-((model_.atatgat)*d_umax_dV_SI_BS))+(0.5*((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))));
              mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));

              d_xerfc_dV_DI_BD = (((ltat-1.0)*d_ktat_dV_DI_BD)+(d_ltat_dV_DI_BD*ktat));
              d_xerfc_dV_SI_BS = (((ltat-1.0)*d_ktat_dV_SI_BS)+(d_ltat_dV_SI_BS*ktat));
              xerfc = ((ltat-1.0)*ktat);

              d_ysq_dV_DI_BD = ((xerfc*d_xerfc_dV_DI_BD)+(d_xerfc_dV_DI_BD*xerfc));
              d_ysq_dV_SI_BS = ((xerfc*d_xerfc_dV_SI_BS)+(d_xerfc_dV_SI_BS*xerfc));
              ysq = (xerfc*xerfc);
              if ((xerfc>0.0))
              {

                d_terfc_dV_DI_BD = (-((model_.perfc)*d_xerfc_dV_DI_BD)/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
                d_terfc_dV_SI_BS = (-((model_.perfc)*d_xerfc_dV_SI_BS)/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
                terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
              }
              else
              {

                d_terfc_dV_DI_BD = (-(-((model_.perfc)*d_xerfc_dV_DI_BD))/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
                d_terfc_dV_SI_BS = (-(-((model_.perfc)*d_xerfc_dV_SI_BS))/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
                terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(((-ysq)+mtat));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_DI_BD = (deriv_exp_0_d0*(((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD)));
                  d_tmp_dV_SI_BS = (deriv_exp_0_d0*(((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS)));
                  tmp = value_exp_0;
                }
              }
              else
              {

                d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*3.3333333333333333e-01))+((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*3.3333333333333333e-01))+((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }

              d_erfcpos_dV_DI_BD = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_DI_BD)+((((0.29214664*d_terfc_dV_DI_BD)+((model_.berfc)*((terfc*d_terfc_dV_DI_BD)+(d_terfc_dV_DI_BD*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_DI_BD)+(((terfc*d_terfc_dV_DI_BD)+(d_terfc_dV_DI_BD*terfc))*terfc))))*tmp));
              d_erfcpos_dV_SI_BS = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_SI_BS)+((((0.29214664*d_terfc_dV_SI_BS)+((model_.berfc)*((terfc*d_terfc_dV_SI_BS)+(d_terfc_dV_SI_BS*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_SI_BS)+(((terfc*d_terfc_dV_SI_BS)+(d_terfc_dV_SI_BS*terfc))*terfc))))*tmp));
              erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0.0))
              {

                d_erfctimesexpmtat_dV_DI_BD = d_erfcpos_dV_DI_BD;
                d_erfctimesexpmtat_dV_SI_BS = d_erfcpos_dV_SI_BS;
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp(mtat);
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_tmp_dV_DI_BD = (deriv_exp_0_d0*(d_mtat_dV_DI_BD));
                    d_tmp_dV_SI_BS = (deriv_exp_0_d0*(d_mtat_dV_SI_BS));
                    tmp = value_exp_0;
                  }
                }
                else
                {

                  d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_DI_BD)*3.3333333333333333e-01))+((-d_mtat_dV_DI_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_DI_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_SI_BS)*3.3333333333333333e-01))+((-d_mtat_dV_SI_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_SI_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }

                d_erfctimesexpmtat_dV_DI_BD = ((2.0*d_tmp_dV_DI_BD)-d_erfcpos_dV_DI_BD);
                d_erfctimesexpmtat_dV_SI_BS = ((2.0*d_tmp_dV_SI_BS)-d_erfcpos_dV_SI_BS);
                erfctimesexpmtat = ((2.0*tmp)-erfcpos);
              }

              d_gammamax_dV_DI_BD = ((1.77245385090551603*0.5)*((ktat*((model_.atatgat)*d_erfctimesexpmtat_dV_DI_BD)-((model_.atatgat)*erfctimesexpmtat)*d_ktat_dV_DI_BD)/ktat/ktat));
              d_gammamax_dV_SI_BS = ((1.77245385090551603*0.5)*((ktat*((model_.atatgat)*d_erfctimesexpmtat_dV_SI_BS)-((model_.atatgat)*erfctimesexpmtat)*d_ktat_dV_SI_BS)/ktat/ktat));
              gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));

              d_itat_dV_DI_BD = ((model_.CTATGAT_i)*(((asrh*gammamax)*d_wtat_dV_DI_BD)+(((asrh*d_gammamax_dV_DI_BD)+(d_asrh_dV_DI_BD*gammamax))*wtat)));
              d_itat_dV_SI_BS = ((model_.CTATGAT_i)*(((asrh*gammamax)*d_wtat_dV_SI_BS)+(((asrh*d_gammamax_dV_SI_BS)+(d_asrh_dV_SI_BS*gammamax))*wtat)));
              itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
            }
            if (((model_.CBBTGAT_i)==0.0))
            {

              d_ibbt_dV_SI_BS = d_ibbt_dV_DI_BD =  0.0;
              ibbt = 0.0;
            }
            else
            {
              if (((model_.PGAT_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*(((-d_vbbt_dV_SI_BS)*(model_.VBIRGATinv))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
                  double  deriv_pow_0_d0 = (((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)) == 0.0)?0.0:(value_pow_0*(model_.PGAT_i)/(((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv))));

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (deriv_pow_0_d0*(((-d_vbbt_dV_SI_BS)*(model_.VBIRGATinv))));
                  tmp = value_pow_0;
                }
              }

              d_Fmaxr_dV_DI_BD = ((model_.one_over_one_minus_PGAT)*((tmp*((-d_vbbt_dV_DI_BD)*(model_.wdepnulrinvgat))-(((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))*d_tmp_dV_DI_BD)/tmp/tmp));
              d_Fmaxr_dV_SI_BS = ((model_.one_over_one_minus_PGAT)*((tmp*((-d_vbbt_dV_SI_BS)*(model_.wdepnulrinvgat))-(((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))*d_tmp_dV_SI_BS)/tmp/tmp));
              Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
              if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_DI_BD = (deriv_exp_0_d0*((-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)));
                  d_tmp_dV_SI_BS = (deriv_exp_0_d0*((-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
                {

                  d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*((-(-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*((-(-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_tmp_dV_DI_BD = (1.0e100*(((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (1.0e100*(((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_ibbt_dV_DI_BD = ((model_.CBBTGAT_i)*((((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_DI_BD)+((((Vjun_s*Fmaxr)*d_Fmaxr_dV_DI_BD)+((Vjun_s*d_Fmaxr_dV_DI_BD)*Fmaxr))*tmp)));
              d_ibbt_dV_SI_BS = ((model_.CBBTGAT_i)*((((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_SI_BS)+((((Vjun_s*Fmaxr)*d_Fmaxr_dV_SI_BS)+(((Vjun_s*d_Fmaxr_dV_SI_BS)+(d_Vjun_s_dV_SI_BS*Fmaxr))*Fmaxr))*tmp)));
              ibbt = ((model_.CBBTGAT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
            }
            if (((model_.VBRGAT_i)>1.0e3))
            {

              d_fbreakdown_dV_SI_BS = d_fbreakdown_dV_DI_BD =  0.0;
              fbreakdown = 1.0;
            }
            else
            {
              if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
              {
                if (((model_.PBRGAT_i)==4.0))
                {

                  d_tmp_dV_DI_BD =  0.0;
                  d_tmp_dV_SI_BS = (((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(d_vav_dV_SI_BS*(model_.VBRinvgat)))+(((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(d_vav_dV_SI_BS*(model_.VBRinvgat)))+((((vav*(model_.VBRinvgat))*(d_vav_dV_SI_BS*(model_.VBRinvgat)))+((d_vav_dV_SI_BS*(model_.VBRinvgat))*(vav*(model_.VBRinvgat))))*(vav*(model_.VBRinvgat))))*(vav*(model_.VBRinvgat))));
                  tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
                }
                else
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
                    double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
                    double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRGAT_i)/value_fabs_0));

                    d_tmp_dV_DI_BD =  0.0;
                    d_tmp_dV_SI_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_SI_BS*(model_.VBRinvgat))))));
                    tmp = value_pow_1;
                  }
                }

                d_fbreakdown_dV_DI_BD = (-(-d_tmp_dV_DI_BD)/(1.0-tmp)/(1.0-tmp));
                d_fbreakdown_dV_SI_BS = (-(-d_tmp_dV_SI_BS)/(1.0-tmp)/(1.0-tmp));
                fbreakdown = (1.0/(1.0-tmp));
              }
              else
              {

                d_fbreakdown_dV_DI_BD =  0.0;
                d_fbreakdown_dV_SI_BS = (d_vav_dV_SI_BS*(model_.slopegat));
                fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
              }
            }

            d_ijungat_s_dV_DI_BD = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_DI_BD)+((((d_id_dV_DI_BD+d_isrh_dV_DI_BD)+d_itat_dV_DI_BD)+d_ibbt_dV_DI_BD)*fbreakdown));
            d_ijungat_s_dV_SI_BS = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_SI_BS)+((((d_id_dV_SI_BS+d_isrh_dV_SI_BS)+d_itat_dV_SI_BS)+d_ibbt_dV_SI_BS)*fbreakdown));
            ijungat_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }

          d_ijun_s_dV_DI_BD = (((ABSOURCE_i*d_ijunbot_s_dV_DI_BD)+(LSSOURCE_i*d_ijunsti_s_dV_DI_BD))+(LGSOURCE_i*d_ijungat_s_dV_DI_BD));
          d_ijun_s_dV_SI_BS = (((ABSOURCE_i*d_ijunbot_s_dV_SI_BS)+(LSSOURCE_i*d_ijunsti_s_dV_SI_BS))+(LGSOURCE_i*d_ijungat_s_dV_SI_BS));
          ijun_s = (((ABSOURCE_i*ijunbot_s)+(LSSOURCE_i*ijunsti_s))+(LGSOURCE_i*ijungat_s));

          d_vbbt_dV_DI_BD = d_vbbt_dV_SI_BS =  0.0;
          vbbt = 0.0;

          d_two_psistar_dV_DI_BD = d_two_psistar_dV_SI_BS =  0.0;
          two_psistar = 0.0;
          if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
          {
            h1 = ((4.0*vch_d)*vch_d);
            h2 = (vch_d/vfmin_d);

            d_h2d_dV_SI_BS =  0.0;
            d_h2d_dV_DI_BD = d_Vjun_d_dV_DI_BD;
            h2d = (Vjun_d+(vch_d*h2));

            d_h3_dV_SI_BS = d_h2d_dV_SI_BS;
            d_h3_dV_DI_BD = d_h2d_dV_DI_BD;
            h3 = (vfmin_d+h2d);

            d_h4_dV_SI_BS = (-d_h2d_dV_SI_BS);
            d_h4_dV_DI_BD = (-d_h2d_dV_DI_BD);
            h4 = (vfmin_d-h2d);
            {
              double value_sqrt_0 = sqrt(((h4*h4)+h1));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_h5_dV_SI_BS = (deriv_sqrt_0_d0*(((h4*d_h4_dV_SI_BS)+(d_h4_dV_SI_BS*h4))));
              d_h5_dV_DI_BD = (deriv_sqrt_0_d0*(((h4*d_h4_dV_DI_BD)+(d_h4_dV_DI_BD*h4))));
              h5 = value_sqrt_0;
            }

            d_vj_dV_SI_BS = (2.0*(-(Vjun_d*vfmin_d)*(d_h3_dV_SI_BS+d_h5_dV_SI_BS)/(h3+h5)/(h3+h5)));
            d_vj_dV_DI_BD = (2.0*(((h3+h5)*(d_Vjun_d_dV_DI_BD*vfmin_d)-(Vjun_d*vfmin_d)*(d_h3_dV_DI_BD+d_h5_dV_DI_BD))/(h3+h5)/(h3+h5)));
            vj = (2.0*((Vjun_d*vfmin_d)/(h3+h5)));
            if ((Vjun_d<VMAX_d))
            {
              if ((fabs((0.5*(Vjun_d*(model_.phitdinv))))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp((0.5*(Vjun_d*(model_.phitdinv))));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_zinv_dV_SI_BS =  0.0;
                  d_zinv_dV_DI_BD = (deriv_exp_0_d0*((0.5*(d_Vjun_d_dV_DI_BD*(model_.phitdinv)))));
                  zinv = value_exp_0;
                }
              }
              else
              {
                if (((0.5*(Vjun_d*(model_.phitdinv)))<0.0))
                {

                  d_zinv_dV_SI_BS =  0.0;
                  d_zinv_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(0.5*((((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*((-(0.5*(d_Vjun_d_dV_DI_BD*(model_.phitdinv))))*3.3333333333333333e-01))+((-(0.5*(d_Vjun_d_dV_DI_BD*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01))))))+((-(0.5*(d_Vjun_d_dV_DI_BD*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01))))))));
                  zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_zinv_dV_SI_BS =  0.0;
                  d_zinv_dV_DI_BD = (1.0e100*((((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(0.5*((((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*((0.5*(d_Vjun_d_dV_DI_BD*(model_.phitdinv)))*3.3333333333333333e-01))+((0.5*(d_Vjun_d_dV_DI_BD*(model_.phitdinv)))*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((0.5*(d_Vjun_d_dV_DI_BD*(model_.phitdinv)))*(1.0+(0.5*(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  zinv = (1.0e100*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_idmult_dV_SI_BS = ((zinv*d_zinv_dV_SI_BS)+(d_zinv_dV_SI_BS*zinv));
              d_idmult_dV_DI_BD = ((zinv*d_zinv_dV_DI_BD)+(d_zinv_dV_DI_BD*zinv));
              idmult = (zinv*zinv);
            }
            else
            {

              d_idmult_dV_SI_BS =  0.0;
              d_idmult_dV_DI_BD = ((d_Vjun_d_dV_DI_BD*(model_.phitdinv))*exp_VMAX_over_phitd_d);
              idmult = ((1.0+((Vjun_d-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
              {
                double value_sqrt_0 = sqrt(idmult);
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_zinv_dV_SI_BS = (deriv_sqrt_0_d0*(d_idmult_dV_SI_BS));
                d_zinv_dV_DI_BD = (deriv_sqrt_0_d0*(d_idmult_dV_DI_BD));
                zinv = value_sqrt_0;
              }
            }

            idmult = (idmult-1.0);

            d_z_dV_SI_BS = (-d_zinv_dV_SI_BS/zinv/zinv);
            d_z_dV_DI_BD = (-d_zinv_dV_DI_BD/zinv/zinv);
            z = (1.0/zinv);
            if ((Vjun_d>0.0))
            {
              {
                double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
                double value_log_1 = log(((2.0+z)+value_sqrt_0));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
                double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));

                d_two_psistar_dV_SI_BS = (2.0*((model_.phitd)*(deriv_log_1_d0*((d_z_dV_SI_BS+(deriv_sqrt_0_d0*((((z+1.0)*d_z_dV_SI_BS)+(d_z_dV_SI_BS*(z+3.0))))))))));
                d_two_psistar_dV_DI_BD = (2.0*((model_.phitd)*(deriv_log_1_d0*((d_z_dV_DI_BD+(deriv_sqrt_0_d0*((((z+1.0)*d_z_dV_DI_BD)+(d_z_dV_DI_BD*(z+3.0))))))))));
                two_psistar = (2.0*((model_.phitd)*value_log_1));
              }
            }
            else
            {
              {
                double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
                double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
                double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));

                d_two_psistar_dV_SI_BS = (2.0*((model_.phitd)*(deriv_log_1_d0*(((2.0*d_zinv_dV_SI_BS)+(deriv_sqrt_0_d0*((((1.0+zinv)*(3.0*d_zinv_dV_SI_BS))+(d_zinv_dV_SI_BS*(1.0+(3.0*zinv)))))))))));
                d_two_psistar_dV_DI_BD = ((-d_Vjun_d_dV_DI_BD)+(2.0*((model_.phitd)*(deriv_log_1_d0*(((2.0*d_zinv_dV_DI_BD)+(deriv_sqrt_0_d0*((((1.0+zinv)*(3.0*d_zinv_dV_DI_BD))+(d_zinv_dV_DI_BD*(1.0+(3.0*zinv))))))))))));
                two_psistar = ((-Vjun_d)+(2.0*((model_.phitd)*value_log_1)));
              }
            }

            d_vjlim_dV_SI_BS = (-d_two_psistar_dV_SI_BS);
            d_vjlim_dV_DI_BD = (-d_two_psistar_dV_DI_BD);
            vjlim = (vbimin_d-two_psistar);
            {
              double value_sqrt_0 = sqrt((((Vjun_d-vjlim)*(Vjun_d-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_vjsrh_dV_SI_BS = (0.5*(d_vjlim_dV_SI_BS-(deriv_sqrt_0_d0*((((Vjun_d-vjlim)*(-d_vjlim_dV_SI_BS))+((-d_vjlim_dV_SI_BS)*(Vjun_d-vjlim)))))));
              d_vjsrh_dV_DI_BD = (0.5*((d_Vjun_d_dV_DI_BD+d_vjlim_dV_DI_BD)-(deriv_sqrt_0_d0*((((Vjun_d-vjlim)*(d_Vjun_d_dV_DI_BD-d_vjlim_dV_DI_BD))+((d_Vjun_d_dV_DI_BD-d_vjlim_dV_DI_BD)*(Vjun_d-vjlim)))))));
              vjsrh = (0.5*((Vjun_d+vjlim)-value_sqrt_0));
            }
            {
              double value_sqrt_0 = sqrt((((Vjun_d-vbbtlim_d)*(Vjun_d-vbbtlim_d))+((4.0*(model_.phitr))*(model_.phitr))));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_vbbt_dV_SI_BS =  0.0;
              d_vbbt_dV_DI_BD = (0.5*(d_Vjun_d_dV_DI_BD-(deriv_sqrt_0_d0*((((Vjun_d-vbbtlim_d)*d_Vjun_d_dV_DI_BD)+(d_Vjun_d_dV_DI_BD*(Vjun_d-vbbtlim_d)))))));
              vbbt = (0.5*((Vjun_d+vbbtlim_d)-value_sqrt_0));
            }
            {
              double value_sqrt_0 = sqrt((((Vjun_d)*(Vjun_d))+((4.0*1.0e-6)*1.0e-6)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_vav_dV_SI_BS =  0.0;
              d_vav_dV_DI_BD = (0.5*((d_Vjun_d_dV_DI_BD)-(deriv_sqrt_0_d0*((((Vjun_d)*(d_Vjun_d_dV_DI_BD))+((d_Vjun_d_dV_DI_BD)*(Vjun_d)))))));
              vav = (0.5*((Vjun_d)-value_sqrt_0));
            }
          }
          if ((ABDRAIN_i==0.0))
          {

            d_ijunbot_d_dV_DI_BD = d_ijunbot_d_dV_SI_BS =  0.0;
            ijunbot_d = 0.0;

            d_qjunbot_d_dV_DI_BD = d_qjunbot_d_dV_SI_BS =  0.0;
            qjunbot_d = 0.0;
          }
          else
          {
            if (((model_.one_minus_PBOT_d)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot_d))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-(d_vj_dV_DI_BD*(model_.vbiinvbot_d)))));
                d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-(d_vj_dV_SI_BS*(model_.vbiinvbot_d)))));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
                double  deriv_pow_0_d0 = (((1.0-(vj*(model_.vbiinvbot_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT_d)/(1.0-(vj*(model_.vbiinvbot_d)))));

                d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-(d_vj_dV_DI_BD*(model_.vbiinvbot_d)))));
                d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-(d_vj_dV_SI_BS*(model_.vbiinvbot_d)))));
                tmp = value_pow_0;
              }
            }

            d_qjunbot_d_dV_DI_BD = (((model_.qprefbot_d)*(-d_tmp_dV_DI_BD))+((model_.qpref2bot_d)*(d_Vjun_d_dV_DI_BD-d_vj_dV_DI_BD)));
            d_qjunbot_d_dV_SI_BS = (((model_.qprefbot_d)*(-d_tmp_dV_SI_BS))+((model_.qpref2bot_d)*(-d_vj_dV_SI_BS)));
            qjunbot_d = (((model_.qprefbot_d)*(1.0-tmp))+((model_.qpref2bot_d)*(Vjun_d-vj)));

            d_id_dV_SI_BS = ((model_.idsatbot_d)*d_idmult_dV_SI_BS);
            d_id_dV_DI_BD = ((model_.idsatbot_d)*d_idmult_dV_DI_BD);
            id = ((model_.idsatbot_d)*idmult);
            if ((((model_.CSRHBOTD_i)==0.0)&&((model_.CTATBOTD_i)==0.0)))
            {

              d_isrh_dV_SI_BS = d_isrh_dV_DI_BD =  0.0;
              isrh = 0.0;
            }
            else
            {

              d_vbi_minus_vjsrh_dV_SI_BS = (-d_vjsrh_dV_SI_BS);
              d_vbi_minus_vjsrh_dV_DI_BD = (-d_vjsrh_dV_DI_BD);
              vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
              {
                double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_wsrhstep_dV_SI_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_SI_BS-two_psistar*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                d_wsrhstep_dV_DI_BD = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_DI_BD-two_psistar*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                wsrhstep = (1.0-value_sqrt_0);
              }
              if (((model_.PBOTD_i)==0.5))
              {

                d_dwsrh_dV_DI_BD = d_dwsrh_dV_SI_BS =  0.0;
                dwsrh = 0.0;
              }
              else
              {
                {
                  double value_log_0 = log(wsrhstep);
                  double  deriv_log_0_d0 = (1.0/wsrhstep);

                  d_dwsrh_dV_SI_BS = (((((1.0-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_SI_BS)))+(((wsrhstep*d_wsrhstep_dV_SI_BS)+(d_wsrhstep_dV_SI_BS*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_SI_BS))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_SI_BS)*(1.0-(2.0*(model_.PBOTD_i))));
                  d_dwsrh_dV_DI_BD = (((((1.0-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_DI_BD)))+(((wsrhstep*d_wsrhstep_dV_DI_BD)+(d_wsrhstep_dV_DI_BD*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_DI_BD))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_DI_BD)*(1.0-(2.0*(model_.PBOTD_i))));
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOTD_i))));
                }
              }

              d_wsrh_dV_SI_BS = (d_wsrhstep_dV_SI_BS+d_dwsrh_dV_SI_BS);
              d_wsrh_dV_DI_BD = (d_wsrhstep_dV_DI_BD+d_dwsrh_dV_DI_BD);
              wsrh = (wsrhstep+dwsrh);
              if (((model_.PBOTD_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRBOTinv_d))));
                  d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_DI_BD*(model_.VBIRBOTinv_d))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                  double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PBOTD_i)/(vbi_minus_vjsrh*(model_.VBIRBOTinv_d))));

                  d_tmp_dV_SI_BS = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRBOTinv_d))));
                  d_tmp_dV_DI_BD = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_DI_BD*(model_.VBIRBOTinv_d))));
                  tmp = value_pow_0;
                }
              }

              d_wdep_dV_DI_BD = ((model_.wdepnulrbot_d)*d_tmp_dV_DI_BD);
              d_wdep_dV_SI_BS = ((model_.wdepnulrbot_d)*d_tmp_dV_SI_BS);
              wdep = ((model_.wdepnulrbot_d)*tmp);

              d_asrh_dV_SI_BS = ((model_.ftdbot_d)*(((zinv-1.0)*d_wdep_dV_SI_BS)+(d_zinv_dV_SI_BS*wdep)));
              d_asrh_dV_DI_BD = ((model_.ftdbot_d)*(((zinv-1.0)*d_wdep_dV_DI_BD)+(d_zinv_dV_DI_BD*wdep)));
              asrh = ((model_.ftdbot_d)*((zinv-1.0)*wdep));

              d_isrh_dV_DI_BD = ((model_.CSRHBOTD_i)*((asrh*d_wsrh_dV_DI_BD)+(d_asrh_dV_DI_BD*wsrh)));
              d_isrh_dV_SI_BS = ((model_.CSRHBOTD_i)*((asrh*d_wsrh_dV_SI_BS)+(d_asrh_dV_SI_BS*wsrh)));
              isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
            }
            if (((model_.CTATBOTD_i)==0.0))
            {

              d_itat_dV_SI_BS = d_itat_dV_DI_BD =  0.0;
              itat = 0.0;
            }
            else
            {

              d_btat_dV_DI_BD = ((model_.btatpartbot_d)*((vbi_minus_vjsrh*(d_wdep_dV_DI_BD*(model_.one_minus_PBOT_d))-(wdep*(model_.one_minus_PBOT_d))*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              d_btat_dV_SI_BS = ((model_.btatpartbot_d)*((vbi_minus_vjsrh*(d_wdep_dV_SI_BS*(model_.one_minus_PBOT_d))-(wdep*(model_.one_minus_PBOT_d))*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));

              d_twoatatoverthreebtat_dV_DI_BD = (-(0.666666666666667*(model_.atatbot_d))*d_btat_dV_DI_BD/btat/btat);
              d_twoatatoverthreebtat_dV_SI_BS = (-(0.666666666666667*(model_.atatbot_d))*d_btat_dV_SI_BS/btat/btat);
              twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);

              d_umaxbeforelimiting_dV_DI_BD = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_DI_BD)+(d_twoatatoverthreebtat_dV_DI_BD*twoatatoverthreebtat));
              d_umaxbeforelimiting_dV_SI_BS = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_SI_BS)+(d_twoatatoverthreebtat_dV_SI_BS*twoatatoverthreebtat));
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_umax_dV_DI_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD)+(d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD)+(d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
                d_umax_dV_SI_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS)+(d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS)+(d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
                umax = value_sqrt_0;
              }
              {
                double value_fabs_0 = fabs(umax);
                double value_sqrt_1 = sqrt(value_fabs_0);
                double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_sqrtumax_dV_DI_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_DI_BD))));
                d_sqrtumax_dV_SI_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_SI_BS))));
                sqrtumax = value_sqrt_1;
              }

              d_umaxpoweronepointfive_dV_DI_BD = ((umax*d_sqrtumax_dV_DI_BD)+(d_umax_dV_DI_BD*sqrtumax));
              d_umaxpoweronepointfive_dV_SI_BS = ((umax*d_sqrtumax_dV_SI_BS)+(d_umax_dV_SI_BS*sqrtumax));
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1.0)))
              {

                d_wgamma_dV_DI_BD = (-((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
                d_wgamma_dV_SI_BS = (-((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
                wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
                  double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))/(1.0+(btat*umaxpoweronepointfive))));

                  d_wgamma_dV_DI_BD = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))));
                  d_wgamma_dV_SI_BS = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))));
                  wgamma = value_pow_0;
                }
              }

              d_wtat_dV_SI_BS = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_SI_BS)+(d_wsrh_dV_SI_BS*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_SI_BS+d_wgamma_dV_SI_BS))/(wsrh+wgamma)/(wsrh+wgamma));
              d_wtat_dV_DI_BD = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_DI_BD)+(d_wsrh_dV_DI_BD*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_DI_BD+d_wgamma_dV_DI_BD))/(wsrh+wgamma)/(wsrh+wgamma));
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_ktat_dV_DI_BD = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_DI_BD-btat*d_sqrtumax_dV_DI_BD)/sqrtumax/sqrtumax))));
                d_ktat_dV_SI_BS = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_SI_BS-btat*d_sqrtumax_dV_SI_BS)/sqrtumax/sqrtumax))));
                ktat = value_sqrt_0;
              }

              d_ltat_dV_DI_BD = ((2.0*((twoatatoverthreebtat*d_sqrtumax_dV_DI_BD)+(d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)))-d_umax_dV_DI_BD);
              d_ltat_dV_SI_BS = ((2.0*((twoatatoverthreebtat*d_sqrtumax_dV_SI_BS)+(d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)))-d_umax_dV_SI_BS);
              ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);

              d_mtat_dV_DI_BD = ((((((model_.atatbot_d)*twoatatoverthreebtat)*d_sqrtumax_dV_DI_BD)+(((model_.atatbot_d)*d_twoatatoverthreebtat_dV_DI_BD)*sqrtumax))-((model_.atatbot_d)*d_umax_dV_DI_BD))+(0.5*((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))));
              d_mtat_dV_SI_BS = ((((((model_.atatbot_d)*twoatatoverthreebtat)*d_sqrtumax_dV_SI_BS)+(((model_.atatbot_d)*d_twoatatoverthreebtat_dV_SI_BS)*sqrtumax))-((model_.atatbot_d)*d_umax_dV_SI_BS))+(0.5*((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))));
              mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));

              d_xerfc_dV_DI_BD = (((ltat-1.0)*d_ktat_dV_DI_BD)+(d_ltat_dV_DI_BD*ktat));
              d_xerfc_dV_SI_BS = (((ltat-1.0)*d_ktat_dV_SI_BS)+(d_ltat_dV_SI_BS*ktat));
              xerfc = ((ltat-1.0)*ktat);

              d_ysq_dV_DI_BD = ((xerfc*d_xerfc_dV_DI_BD)+(d_xerfc_dV_DI_BD*xerfc));
              d_ysq_dV_SI_BS = ((xerfc*d_xerfc_dV_SI_BS)+(d_xerfc_dV_SI_BS*xerfc));
              ysq = (xerfc*xerfc);
              if ((xerfc>0.0))
              {

                d_terfc_dV_DI_BD = (-((model_.perfc)*d_xerfc_dV_DI_BD)/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
                d_terfc_dV_SI_BS = (-((model_.perfc)*d_xerfc_dV_SI_BS)/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
                terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
              }
              else
              {

                d_terfc_dV_DI_BD = (-(-((model_.perfc)*d_xerfc_dV_DI_BD))/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
                d_terfc_dV_SI_BS = (-(-((model_.perfc)*d_xerfc_dV_SI_BS))/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
                terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(((-ysq)+mtat));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_DI_BD = (deriv_exp_0_d0*(((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD)));
                  d_tmp_dV_SI_BS = (deriv_exp_0_d0*(((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS)));
                  tmp = value_exp_0;
                }
              }
              else
              {

                d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*3.3333333333333333e-01))+((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*3.3333333333333333e-01))+((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }

              d_erfcpos_dV_DI_BD = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_DI_BD)+((((0.29214664*d_terfc_dV_DI_BD)+((model_.berfc)*((terfc*d_terfc_dV_DI_BD)+(d_terfc_dV_DI_BD*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_DI_BD)+(((terfc*d_terfc_dV_DI_BD)+(d_terfc_dV_DI_BD*terfc))*terfc))))*tmp));
              d_erfcpos_dV_SI_BS = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_SI_BS)+((((0.29214664*d_terfc_dV_SI_BS)+((model_.berfc)*((terfc*d_terfc_dV_SI_BS)+(d_terfc_dV_SI_BS*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_SI_BS)+(((terfc*d_terfc_dV_SI_BS)+(d_terfc_dV_SI_BS*terfc))*terfc))))*tmp));
              erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0.0))
              {

                d_erfctimesexpmtat_dV_DI_BD = d_erfcpos_dV_DI_BD;
                d_erfctimesexpmtat_dV_SI_BS = d_erfcpos_dV_SI_BS;
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp(mtat);
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_tmp_dV_DI_BD = (deriv_exp_0_d0*(d_mtat_dV_DI_BD));
                    d_tmp_dV_SI_BS = (deriv_exp_0_d0*(d_mtat_dV_SI_BS));
                    tmp = value_exp_0;
                  }
                }
                else
                {

                  d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_DI_BD)*3.3333333333333333e-01))+((-d_mtat_dV_DI_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_DI_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_SI_BS)*3.3333333333333333e-01))+((-d_mtat_dV_SI_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_SI_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }

                d_erfctimesexpmtat_dV_DI_BD = ((2.0*d_tmp_dV_DI_BD)-d_erfcpos_dV_DI_BD);
                d_erfctimesexpmtat_dV_SI_BS = ((2.0*d_tmp_dV_SI_BS)-d_erfcpos_dV_SI_BS);
                erfctimesexpmtat = ((2.0*tmp)-erfcpos);
              }

              d_gammamax_dV_DI_BD = ((1.77245385090551603*0.5)*((ktat*((model_.atatbot_d)*d_erfctimesexpmtat_dV_DI_BD)-((model_.atatbot_d)*erfctimesexpmtat)*d_ktat_dV_DI_BD)/ktat/ktat));
              d_gammamax_dV_SI_BS = ((1.77245385090551603*0.5)*((ktat*((model_.atatbot_d)*d_erfctimesexpmtat_dV_SI_BS)-((model_.atatbot_d)*erfctimesexpmtat)*d_ktat_dV_SI_BS)/ktat/ktat));
              gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));

              d_itat_dV_DI_BD = ((model_.CTATBOTD_i)*(((asrh*gammamax)*d_wtat_dV_DI_BD)+(((asrh*d_gammamax_dV_DI_BD)+(d_asrh_dV_DI_BD*gammamax))*wtat)));
              d_itat_dV_SI_BS = ((model_.CTATBOTD_i)*(((asrh*gammamax)*d_wtat_dV_SI_BS)+(((asrh*d_gammamax_dV_SI_BS)+(d_asrh_dV_SI_BS*gammamax))*wtat)));
              itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
            }
            if (((model_.CBBTBOTD_i)==0.0))
            {

              d_ibbt_dV_SI_BS = d_ibbt_dV_DI_BD =  0.0;
              ibbt = 0.0;
            }
            else
            {
              if (((model_.PBOTD_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*(((-d_vbbt_dV_SI_BS)*(model_.VBIRBOTinv_d))));
                  d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*(((-d_vbbt_dV_DI_BD)*(model_.VBIRBOTinv_d))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
                  double  deriv_pow_0_d0 = (((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PBOTD_i)/(((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d))));

                  d_tmp_dV_SI_BS = (deriv_pow_0_d0*(((-d_vbbt_dV_SI_BS)*(model_.VBIRBOTinv_d))));
                  d_tmp_dV_DI_BD = (deriv_pow_0_d0*(((-d_vbbt_dV_DI_BD)*(model_.VBIRBOTinv_d))));
                  tmp = value_pow_0;
                }
              }

              d_Fmaxr_dV_SI_BS = ((model_.one_over_one_minus_PBOT_d)*((tmp*((-d_vbbt_dV_SI_BS)*(model_.wdepnulrinvbot_d))-(((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))*d_tmp_dV_SI_BS)/tmp/tmp));
              d_Fmaxr_dV_DI_BD = ((model_.one_over_one_minus_PBOT_d)*((tmp*((-d_vbbt_dV_DI_BD)*(model_.wdepnulrinvbot_d))-(((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))*d_tmp_dV_DI_BD)/tmp/tmp));
              Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
              if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_DI_BD = (deriv_exp_0_d0*((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)));
                  d_tmp_dV_SI_BS = (deriv_exp_0_d0*((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-(model_.fbbtbot_d))/Fmaxr)<0.0))
                {

                  d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*((-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*((-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_tmp_dV_DI_BD = (1.0e100*(((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (1.0e100*(((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_ibbt_dV_SI_BS = ((model_.CBBTBOTD_i)*((((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_SI_BS)+((((Vjun_d*Fmaxr)*d_Fmaxr_dV_SI_BS)+((Vjun_d*d_Fmaxr_dV_SI_BS)*Fmaxr))*tmp)));
              d_ibbt_dV_DI_BD = ((model_.CBBTBOTD_i)*((((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_DI_BD)+((((Vjun_d*Fmaxr)*d_Fmaxr_dV_DI_BD)+(((Vjun_d*d_Fmaxr_dV_DI_BD)+(d_Vjun_d_dV_DI_BD*Fmaxr))*Fmaxr))*tmp)));
              ibbt = ((model_.CBBTBOTD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
            }
            if (((model_.VBRBOTD_i)>1.0e3))
            {

              d_fbreakdown_dV_SI_BS = d_fbreakdown_dV_DI_BD =  0.0;
              fbreakdown = 1.0;
            }
            else
            {
              if ((vav>((-(model_.alphaav))*(model_.VBRBOTD_i))))
              {
                if (((model_.PBRBOTD_i)==4.0))
                {

                  d_tmp_dV_SI_BS = (((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(d_vav_dV_SI_BS*(model_.VBRinvbot_d)))+(((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(d_vav_dV_SI_BS*(model_.VBRinvbot_d)))+((((vav*(model_.VBRinvbot_d))*(d_vav_dV_SI_BS*(model_.VBRinvbot_d)))+((d_vav_dV_SI_BS*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d))))*(vav*(model_.VBRinvbot_d))))*(vav*(model_.VBRinvbot_d))));
                  d_tmp_dV_DI_BD = (((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(d_vav_dV_DI_BD*(model_.VBRinvbot_d)))+(((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(d_vav_dV_DI_BD*(model_.VBRinvbot_d)))+((((vav*(model_.VBRinvbot_d))*(d_vav_dV_DI_BD*(model_.VBRinvbot_d)))+((d_vav_dV_DI_BD*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d))))*(vav*(model_.VBRinvbot_d))))*(vav*(model_.VBRinvbot_d))));
                  tmp = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
                }
                else
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
                    double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRBOTD_i)/value_fabs_0));

                    d_tmp_dV_SI_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_SI_BS*(model_.VBRinvbot_d))))));
                    d_tmp_dV_DI_BD = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_DI_BD*(model_.VBRinvbot_d))))));
                    tmp = value_pow_1;
                  }
                }

                d_fbreakdown_dV_DI_BD = (-(-d_tmp_dV_DI_BD)/(1.0-tmp)/(1.0-tmp));
                d_fbreakdown_dV_SI_BS = (-(-d_tmp_dV_SI_BS)/(1.0-tmp)/(1.0-tmp));
                fbreakdown = (1.0/(1.0-tmp));
              }
              else
              {

                d_fbreakdown_dV_SI_BS = (d_vav_dV_SI_BS*(model_.slopebot_d));
                d_fbreakdown_dV_DI_BD = (d_vav_dV_DI_BD*(model_.slopebot_d));
                fbreakdown = ((model_.fstopbot_d)+((vav+((model_.alphaav)*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
              }
            }

            d_ijunbot_d_dV_SI_BS = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_SI_BS)+((((d_id_dV_SI_BS+d_isrh_dV_SI_BS)+d_itat_dV_SI_BS)+d_ibbt_dV_SI_BS)*fbreakdown));
            d_ijunbot_d_dV_DI_BD = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_DI_BD)+((((d_id_dV_DI_BD+d_isrh_dV_DI_BD)+d_itat_dV_DI_BD)+d_ibbt_dV_DI_BD)*fbreakdown));
            ijunbot_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((LSDRAIN_i==0.0))
          {

            d_ijunsti_d_dV_DI_BD = d_ijunsti_d_dV_SI_BS =  0.0;
            ijunsti_d = 0.0;

            d_qjunsti_d_dV_DI_BD = d_qjunsti_d_dV_SI_BS =  0.0;
            qjunsti_d = 0.0;
          }
          else
          {
            if (((model_.one_minus_PSTI_d)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti_d))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-(d_vj_dV_DI_BD*(model_.vbiinvsti_d)))));
                d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-(d_vj_dV_SI_BS*(model_.vbiinvsti_d)))));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
                double  deriv_pow_0_d0 = (((1.0-(vj*(model_.vbiinvsti_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI_d)/(1.0-(vj*(model_.vbiinvsti_d)))));

                d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-(d_vj_dV_DI_BD*(model_.vbiinvsti_d)))));
                d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-(d_vj_dV_SI_BS*(model_.vbiinvsti_d)))));
                tmp = value_pow_0;
              }
            }

            d_qjunsti_d_dV_DI_BD = (((model_.qprefsti_d)*(-d_tmp_dV_DI_BD))+((model_.qpref2sti_d)*(d_Vjun_d_dV_DI_BD-d_vj_dV_DI_BD)));
            d_qjunsti_d_dV_SI_BS = (((model_.qprefsti_d)*(-d_tmp_dV_SI_BS))+((model_.qpref2sti_d)*(-d_vj_dV_SI_BS)));
            qjunsti_d = (((model_.qprefsti_d)*(1.0-tmp))+((model_.qpref2sti_d)*(Vjun_d-vj)));

            d_id_dV_SI_BS = ((model_.idsatsti_d)*d_idmult_dV_SI_BS);
            d_id_dV_DI_BD = ((model_.idsatsti_d)*d_idmult_dV_DI_BD);
            id = ((model_.idsatsti_d)*idmult);
            if ((((model_.CSRHSTID_i)==0.0)&&((model_.CTATSTID_i)==0.0)))
            {

              d_isrh_dV_SI_BS = d_isrh_dV_DI_BD =  0.0;
              isrh = 0.0;
            }
            else
            {

              d_vbi_minus_vjsrh_dV_SI_BS = (-d_vjsrh_dV_SI_BS);
              d_vbi_minus_vjsrh_dV_DI_BD = (-d_vjsrh_dV_DI_BD);
              vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
              {
                double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_wsrhstep_dV_SI_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_SI_BS-two_psistar*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                d_wsrhstep_dV_DI_BD = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_DI_BD-two_psistar*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                wsrhstep = (1.0-value_sqrt_0);
              }
              if (((model_.PSTID_i)==0.5))
              {

                d_dwsrh_dV_DI_BD = d_dwsrh_dV_SI_BS =  0.0;
                dwsrh = 0.0;
              }
              else
              {
                {
                  double value_log_0 = log(wsrhstep);
                  double  deriv_log_0_d0 = (1.0/wsrhstep);

                  d_dwsrh_dV_SI_BS = (((((1.0-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_SI_BS)))+(((wsrhstep*d_wsrhstep_dV_SI_BS)+(d_wsrhstep_dV_SI_BS*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_SI_BS))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_SI_BS)*(1.0-(2.0*(model_.PSTID_i))));
                  d_dwsrh_dV_DI_BD = (((((1.0-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_DI_BD)))+(((wsrhstep*d_wsrhstep_dV_DI_BD)+(d_wsrhstep_dV_DI_BD*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_DI_BD))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_DI_BD)*(1.0-(2.0*(model_.PSTID_i))));
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTID_i))));
                }
              }

              d_wsrh_dV_SI_BS = (d_wsrhstep_dV_SI_BS+d_dwsrh_dV_SI_BS);
              d_wsrh_dV_DI_BD = (d_wsrhstep_dV_DI_BD+d_dwsrh_dV_DI_BD);
              wsrh = (wsrhstep+dwsrh);
              if (((model_.PSTID_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRSTIinv_d))));
                  d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_DI_BD*(model_.VBIRSTIinv_d))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                  double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PSTID_i)/(vbi_minus_vjsrh*(model_.VBIRSTIinv_d))));

                  d_tmp_dV_SI_BS = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRSTIinv_d))));
                  d_tmp_dV_DI_BD = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_DI_BD*(model_.VBIRSTIinv_d))));
                  tmp = value_pow_0;
                }
              }

              d_wdep_dV_DI_BD = ((model_.wdepnulrsti_d)*d_tmp_dV_DI_BD);
              d_wdep_dV_SI_BS = ((model_.wdepnulrsti_d)*d_tmp_dV_SI_BS);
              wdep = ((model_.wdepnulrsti_d)*tmp);

              d_asrh_dV_SI_BS = ((model_.ftdsti_d)*(((zinv-1.0)*d_wdep_dV_SI_BS)+(d_zinv_dV_SI_BS*wdep)));
              d_asrh_dV_DI_BD = ((model_.ftdsti_d)*(((zinv-1.0)*d_wdep_dV_DI_BD)+(d_zinv_dV_DI_BD*wdep)));
              asrh = ((model_.ftdsti_d)*((zinv-1.0)*wdep));

              d_isrh_dV_DI_BD = ((model_.CSRHSTID_i)*((asrh*d_wsrh_dV_DI_BD)+(d_asrh_dV_DI_BD*wsrh)));
              d_isrh_dV_SI_BS = ((model_.CSRHSTID_i)*((asrh*d_wsrh_dV_SI_BS)+(d_asrh_dV_SI_BS*wsrh)));
              isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
            }
            if (((model_.CTATSTID_i)==0.0))
            {

              d_itat_dV_SI_BS = d_itat_dV_DI_BD =  0.0;
              itat = 0.0;
            }
            else
            {

              d_btat_dV_DI_BD = ((model_.btatpartsti_d)*((vbi_minus_vjsrh*(d_wdep_dV_DI_BD*(model_.one_minus_PSTI_d))-(wdep*(model_.one_minus_PSTI_d))*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              d_btat_dV_SI_BS = ((model_.btatpartsti_d)*((vbi_minus_vjsrh*(d_wdep_dV_SI_BS*(model_.one_minus_PSTI_d))-(wdep*(model_.one_minus_PSTI_d))*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));

              d_twoatatoverthreebtat_dV_DI_BD = (-(0.666666666666667*(model_.atatsti_d))*d_btat_dV_DI_BD/btat/btat);
              d_twoatatoverthreebtat_dV_SI_BS = (-(0.666666666666667*(model_.atatsti_d))*d_btat_dV_SI_BS/btat/btat);
              twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);

              d_umaxbeforelimiting_dV_DI_BD = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_DI_BD)+(d_twoatatoverthreebtat_dV_DI_BD*twoatatoverthreebtat));
              d_umaxbeforelimiting_dV_SI_BS = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_SI_BS)+(d_twoatatoverthreebtat_dV_SI_BS*twoatatoverthreebtat));
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_umax_dV_DI_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD)+(d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD)+(d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
                d_umax_dV_SI_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS)+(d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS)+(d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
                umax = value_sqrt_0;
              }
              {
                double value_fabs_0 = fabs(umax);
                double value_sqrt_1 = sqrt(value_fabs_0);
                double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_sqrtumax_dV_DI_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_DI_BD))));
                d_sqrtumax_dV_SI_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_SI_BS))));
                sqrtumax = value_sqrt_1;
              }

              d_umaxpoweronepointfive_dV_DI_BD = ((umax*d_sqrtumax_dV_DI_BD)+(d_umax_dV_DI_BD*sqrtumax));
              d_umaxpoweronepointfive_dV_SI_BS = ((umax*d_sqrtumax_dV_SI_BS)+(d_umax_dV_SI_BS*sqrtumax));
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1.0)))
              {

                d_wgamma_dV_DI_BD = (-((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
                d_wgamma_dV_SI_BS = (-((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
                wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
                  double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))/(1.0+(btat*umaxpoweronepointfive))));

                  d_wgamma_dV_DI_BD = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))));
                  d_wgamma_dV_SI_BS = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))));
                  wgamma = value_pow_0;
                }
              }

              d_wtat_dV_SI_BS = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_SI_BS)+(d_wsrh_dV_SI_BS*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_SI_BS+d_wgamma_dV_SI_BS))/(wsrh+wgamma)/(wsrh+wgamma));
              d_wtat_dV_DI_BD = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_DI_BD)+(d_wsrh_dV_DI_BD*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_DI_BD+d_wgamma_dV_DI_BD))/(wsrh+wgamma)/(wsrh+wgamma));
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_ktat_dV_DI_BD = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_DI_BD-btat*d_sqrtumax_dV_DI_BD)/sqrtumax/sqrtumax))));
                d_ktat_dV_SI_BS = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_SI_BS-btat*d_sqrtumax_dV_SI_BS)/sqrtumax/sqrtumax))));
                ktat = value_sqrt_0;
              }

              d_ltat_dV_DI_BD = ((2.0*((twoatatoverthreebtat*d_sqrtumax_dV_DI_BD)+(d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)))-d_umax_dV_DI_BD);
              d_ltat_dV_SI_BS = ((2.0*((twoatatoverthreebtat*d_sqrtumax_dV_SI_BS)+(d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)))-d_umax_dV_SI_BS);
              ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);

              d_mtat_dV_DI_BD = ((((((model_.atatsti_d)*twoatatoverthreebtat)*d_sqrtumax_dV_DI_BD)+(((model_.atatsti_d)*d_twoatatoverthreebtat_dV_DI_BD)*sqrtumax))-((model_.atatsti_d)*d_umax_dV_DI_BD))+(0.5*((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))));
              d_mtat_dV_SI_BS = ((((((model_.atatsti_d)*twoatatoverthreebtat)*d_sqrtumax_dV_SI_BS)+(((model_.atatsti_d)*d_twoatatoverthreebtat_dV_SI_BS)*sqrtumax))-((model_.atatsti_d)*d_umax_dV_SI_BS))+(0.5*((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))));
              mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));

              d_xerfc_dV_DI_BD = (((ltat-1.0)*d_ktat_dV_DI_BD)+(d_ltat_dV_DI_BD*ktat));
              d_xerfc_dV_SI_BS = (((ltat-1.0)*d_ktat_dV_SI_BS)+(d_ltat_dV_SI_BS*ktat));
              xerfc = ((ltat-1.0)*ktat);

              d_ysq_dV_DI_BD = ((xerfc*d_xerfc_dV_DI_BD)+(d_xerfc_dV_DI_BD*xerfc));
              d_ysq_dV_SI_BS = ((xerfc*d_xerfc_dV_SI_BS)+(d_xerfc_dV_SI_BS*xerfc));
              ysq = (xerfc*xerfc);
              if ((xerfc>0.0))
              {

                d_terfc_dV_DI_BD = (-((model_.perfc)*d_xerfc_dV_DI_BD)/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
                d_terfc_dV_SI_BS = (-((model_.perfc)*d_xerfc_dV_SI_BS)/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
                terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
              }
              else
              {

                d_terfc_dV_DI_BD = (-(-((model_.perfc)*d_xerfc_dV_DI_BD))/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
                d_terfc_dV_SI_BS = (-(-((model_.perfc)*d_xerfc_dV_SI_BS))/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
                terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(((-ysq)+mtat));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_DI_BD = (deriv_exp_0_d0*(((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD)));
                  d_tmp_dV_SI_BS = (deriv_exp_0_d0*(((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS)));
                  tmp = value_exp_0;
                }
              }
              else
              {

                d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*3.3333333333333333e-01))+((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*3.3333333333333333e-01))+((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }

              d_erfcpos_dV_DI_BD = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_DI_BD)+((((0.29214664*d_terfc_dV_DI_BD)+((model_.berfc)*((terfc*d_terfc_dV_DI_BD)+(d_terfc_dV_DI_BD*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_DI_BD)+(((terfc*d_terfc_dV_DI_BD)+(d_terfc_dV_DI_BD*terfc))*terfc))))*tmp));
              d_erfcpos_dV_SI_BS = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_SI_BS)+((((0.29214664*d_terfc_dV_SI_BS)+((model_.berfc)*((terfc*d_terfc_dV_SI_BS)+(d_terfc_dV_SI_BS*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_SI_BS)+(((terfc*d_terfc_dV_SI_BS)+(d_terfc_dV_SI_BS*terfc))*terfc))))*tmp));
              erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0.0))
              {

                d_erfctimesexpmtat_dV_DI_BD = d_erfcpos_dV_DI_BD;
                d_erfctimesexpmtat_dV_SI_BS = d_erfcpos_dV_SI_BS;
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp(mtat);
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_tmp_dV_DI_BD = (deriv_exp_0_d0*(d_mtat_dV_DI_BD));
                    d_tmp_dV_SI_BS = (deriv_exp_0_d0*(d_mtat_dV_SI_BS));
                    tmp = value_exp_0;
                  }
                }
                else
                {

                  d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_DI_BD)*3.3333333333333333e-01))+((-d_mtat_dV_DI_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_DI_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_SI_BS)*3.3333333333333333e-01))+((-d_mtat_dV_SI_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_SI_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }

                d_erfctimesexpmtat_dV_DI_BD = ((2.0*d_tmp_dV_DI_BD)-d_erfcpos_dV_DI_BD);
                d_erfctimesexpmtat_dV_SI_BS = ((2.0*d_tmp_dV_SI_BS)-d_erfcpos_dV_SI_BS);
                erfctimesexpmtat = ((2.0*tmp)-erfcpos);
              }

              d_gammamax_dV_DI_BD = ((1.77245385090551603*0.5)*((ktat*((model_.atatsti_d)*d_erfctimesexpmtat_dV_DI_BD)-((model_.atatsti_d)*erfctimesexpmtat)*d_ktat_dV_DI_BD)/ktat/ktat));
              d_gammamax_dV_SI_BS = ((1.77245385090551603*0.5)*((ktat*((model_.atatsti_d)*d_erfctimesexpmtat_dV_SI_BS)-((model_.atatsti_d)*erfctimesexpmtat)*d_ktat_dV_SI_BS)/ktat/ktat));
              gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));

              d_itat_dV_DI_BD = ((model_.CTATSTID_i)*(((asrh*gammamax)*d_wtat_dV_DI_BD)+(((asrh*d_gammamax_dV_DI_BD)+(d_asrh_dV_DI_BD*gammamax))*wtat)));
              d_itat_dV_SI_BS = ((model_.CTATSTID_i)*(((asrh*gammamax)*d_wtat_dV_SI_BS)+(((asrh*d_gammamax_dV_SI_BS)+(d_asrh_dV_SI_BS*gammamax))*wtat)));
              itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
            }
            if (((model_.CBBTSTID_i)==0.0))
            {

              d_ibbt_dV_SI_BS = d_ibbt_dV_DI_BD =  0.0;
              ibbt = 0.0;
            }
            else
            {
              if (((model_.PSTID_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*(((-d_vbbt_dV_SI_BS)*(model_.VBIRSTIinv_d))));
                  d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*(((-d_vbbt_dV_DI_BD)*(model_.VBIRSTIinv_d))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
                  double  deriv_pow_0_d0 = (((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PSTID_i)/(((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d))));

                  d_tmp_dV_SI_BS = (deriv_pow_0_d0*(((-d_vbbt_dV_SI_BS)*(model_.VBIRSTIinv_d))));
                  d_tmp_dV_DI_BD = (deriv_pow_0_d0*(((-d_vbbt_dV_DI_BD)*(model_.VBIRSTIinv_d))));
                  tmp = value_pow_0;
                }
              }

              d_Fmaxr_dV_SI_BS = ((model_.one_over_one_minus_PSTI_d)*((tmp*((-d_vbbt_dV_SI_BS)*(model_.wdepnulrinvsti_d))-(((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))*d_tmp_dV_SI_BS)/tmp/tmp));
              d_Fmaxr_dV_DI_BD = ((model_.one_over_one_minus_PSTI_d)*((tmp*((-d_vbbt_dV_DI_BD)*(model_.wdepnulrinvsti_d))-(((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))*d_tmp_dV_DI_BD)/tmp/tmp));
              Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
              if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_DI_BD = (deriv_exp_0_d0*((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)));
                  d_tmp_dV_SI_BS = (deriv_exp_0_d0*((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-(model_.fbbtsti_d))/Fmaxr)<0.0))
                {

                  d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*((-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*((-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_tmp_dV_DI_BD = (1.0e100*(((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (1.0e100*(((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_ibbt_dV_SI_BS = ((model_.CBBTSTID_i)*((((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_SI_BS)+((((Vjun_d*Fmaxr)*d_Fmaxr_dV_SI_BS)+((Vjun_d*d_Fmaxr_dV_SI_BS)*Fmaxr))*tmp)));
              d_ibbt_dV_DI_BD = ((model_.CBBTSTID_i)*((((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_DI_BD)+((((Vjun_d*Fmaxr)*d_Fmaxr_dV_DI_BD)+(((Vjun_d*d_Fmaxr_dV_DI_BD)+(d_Vjun_d_dV_DI_BD*Fmaxr))*Fmaxr))*tmp)));
              ibbt = ((model_.CBBTSTID_i)*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
            }
            if (((model_.VBRSTID_i)>1.0e3))
            {

              d_fbreakdown_dV_SI_BS = d_fbreakdown_dV_DI_BD =  0.0;
              fbreakdown = 1.0;
            }
            else
            {
              if ((vav>((-(model_.alphaav))*(model_.VBRSTID_i))))
              {
                if (((model_.PBRSTID_i)==4.0))
                {

                  d_tmp_dV_SI_BS = (((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(d_vav_dV_SI_BS*(model_.VBRinvsti_d)))+(((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(d_vav_dV_SI_BS*(model_.VBRinvsti_d)))+((((vav*(model_.VBRinvsti_d))*(d_vav_dV_SI_BS*(model_.VBRinvsti_d)))+((d_vav_dV_SI_BS*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d))))*(vav*(model_.VBRinvsti_d))))*(vav*(model_.VBRinvsti_d))));
                  d_tmp_dV_DI_BD = (((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(d_vav_dV_DI_BD*(model_.VBRinvsti_d)))+(((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(d_vav_dV_DI_BD*(model_.VBRinvsti_d)))+((((vav*(model_.VBRinvsti_d))*(d_vav_dV_DI_BD*(model_.VBRinvsti_d)))+((d_vav_dV_DI_BD*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d))))*(vav*(model_.VBRinvsti_d))))*(vav*(model_.VBRinvsti_d))));
                  tmp = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
                }
                else
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
                    double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRSTID_i)/value_fabs_0));

                    d_tmp_dV_SI_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_SI_BS*(model_.VBRinvsti_d))))));
                    d_tmp_dV_DI_BD = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_DI_BD*(model_.VBRinvsti_d))))));
                    tmp = value_pow_1;
                  }
                }

                d_fbreakdown_dV_DI_BD = (-(-d_tmp_dV_DI_BD)/(1.0-tmp)/(1.0-tmp));
                d_fbreakdown_dV_SI_BS = (-(-d_tmp_dV_SI_BS)/(1.0-tmp)/(1.0-tmp));
                fbreakdown = (1.0/(1.0-tmp));
              }
              else
              {

                d_fbreakdown_dV_SI_BS = (d_vav_dV_SI_BS*(model_.slopesti_d));
                d_fbreakdown_dV_DI_BD = (d_vav_dV_DI_BD*(model_.slopesti_d));
                fbreakdown = ((model_.fstopsti_d)+((vav+((model_.alphaav)*(model_.VBRSTID_i)))*(model_.slopesti_d)));
              }
            }

            d_ijunsti_d_dV_SI_BS = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_SI_BS)+((((d_id_dV_SI_BS+d_isrh_dV_SI_BS)+d_itat_dV_SI_BS)+d_ibbt_dV_SI_BS)*fbreakdown));
            d_ijunsti_d_dV_DI_BD = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_DI_BD)+((((d_id_dV_DI_BD+d_isrh_dV_DI_BD)+d_itat_dV_DI_BD)+d_ibbt_dV_DI_BD)*fbreakdown));
            ijunsti_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((LGDRAIN_i==0.0))
          {

            d_ijungat_d_dV_DI_BD = d_ijungat_d_dV_SI_BS =  0.0;
            ijungat_d = 0.0;

            d_qjungat_d_dV_DI_BD = d_qjungat_d_dV_SI_BS =  0.0;
            qjungat_d = 0.0;
          }
          else
          {
            if (((model_.one_minus_PGAT_d)==0.5))
            {
              {
                double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat_d))));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-(d_vj_dV_DI_BD*(model_.vbiinvgat_d)))));
                d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-(d_vj_dV_SI_BS*(model_.vbiinvgat_d)))));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
                double  deriv_pow_0_d0 = (((1.0-(vj*(model_.vbiinvgat_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT_d)/(1.0-(vj*(model_.vbiinvgat_d)))));

                d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-(d_vj_dV_DI_BD*(model_.vbiinvgat_d)))));
                d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-(d_vj_dV_SI_BS*(model_.vbiinvgat_d)))));
                tmp = value_pow_0;
              }
            }

            d_qjungat_d_dV_DI_BD = (((model_.qprefgat_d)*(-d_tmp_dV_DI_BD))+((model_.qpref2gat_d)*(d_Vjun_d_dV_DI_BD-d_vj_dV_DI_BD)));
            d_qjungat_d_dV_SI_BS = (((model_.qprefgat_d)*(-d_tmp_dV_SI_BS))+((model_.qpref2gat_d)*(-d_vj_dV_SI_BS)));
            qjungat_d = (((model_.qprefgat_d)*(1.0-tmp))+((model_.qpref2gat_d)*(Vjun_d-vj)));

            d_id_dV_SI_BS = ((model_.idsatgat_d)*d_idmult_dV_SI_BS);
            d_id_dV_DI_BD = ((model_.idsatgat_d)*d_idmult_dV_DI_BD);
            id = ((model_.idsatgat_d)*idmult);
            if ((((model_.CSRHGATD_i)==0.0)&&((model_.CTATGATD_i)==0.0)))
            {

              d_isrh_dV_SI_BS = d_isrh_dV_DI_BD =  0.0;
              isrh = 0.0;
            }
            else
            {

              d_vbi_minus_vjsrh_dV_SI_BS = (-d_vjsrh_dV_SI_BS);
              d_vbi_minus_vjsrh_dV_DI_BD = (-d_vjsrh_dV_DI_BD);
              vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
              {
                double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_wsrhstep_dV_SI_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_SI_BS-two_psistar*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                d_wsrhstep_dV_DI_BD = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_DI_BD-two_psistar*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
                wsrhstep = (1.0-value_sqrt_0);
              }
              if (((model_.PGATD_i)==0.5))
              {

                d_dwsrh_dV_DI_BD = d_dwsrh_dV_SI_BS =  0.0;
                dwsrh = 0.0;
              }
              else
              {
                {
                  double value_log_0 = log(wsrhstep);
                  double  deriv_log_0_d0 = (1.0/wsrhstep);

                  d_dwsrh_dV_SI_BS = (((((1.0-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_SI_BS)))+(((wsrhstep*d_wsrhstep_dV_SI_BS)+(d_wsrhstep_dV_SI_BS*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_SI_BS))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_SI_BS)*(1.0-(2.0*(model_.PGATD_i))));
                  d_dwsrh_dV_DI_BD = (((((1.0-wsrhstep)*(((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_DI_BD)))+(((wsrhstep*d_wsrhstep_dV_DI_BD)+(d_wsrhstep_dV_DI_BD*wsrhstep))*value_log_0))-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_DI_BD))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_DI_BD)*(1.0-(2.0*(model_.PGATD_i))));
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGATD_i))));
                }
              }

              d_wsrh_dV_SI_BS = (d_wsrhstep_dV_SI_BS+d_dwsrh_dV_SI_BS);
              d_wsrh_dV_DI_BD = (d_wsrhstep_dV_DI_BD+d_dwsrh_dV_DI_BD);
              wsrh = (wsrhstep+dwsrh);
              if (((model_.PGATD_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRGATinv_d))));
                  d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((d_vbi_minus_vjsrh_dV_DI_BD*(model_.VBIRGATinv_d))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                  double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRGATinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PGATD_i)/(vbi_minus_vjsrh*(model_.VBIRGATinv_d))));

                  d_tmp_dV_SI_BS = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRGATinv_d))));
                  d_tmp_dV_DI_BD = (deriv_pow_0_d0*((d_vbi_minus_vjsrh_dV_DI_BD*(model_.VBIRGATinv_d))));
                  tmp = value_pow_0;
                }
              }

              d_wdep_dV_DI_BD = ((model_.wdepnulrgat_d)*d_tmp_dV_DI_BD);
              d_wdep_dV_SI_BS = ((model_.wdepnulrgat_d)*d_tmp_dV_SI_BS);
              wdep = ((model_.wdepnulrgat_d)*tmp);

              d_asrh_dV_SI_BS = ((model_.ftdgat_d)*(((zinv-1.0)*d_wdep_dV_SI_BS)+(d_zinv_dV_SI_BS*wdep)));
              d_asrh_dV_DI_BD = ((model_.ftdgat_d)*(((zinv-1.0)*d_wdep_dV_DI_BD)+(d_zinv_dV_DI_BD*wdep)));
              asrh = ((model_.ftdgat_d)*((zinv-1.0)*wdep));

              d_isrh_dV_DI_BD = ((model_.CSRHGATD_i)*((asrh*d_wsrh_dV_DI_BD)+(d_asrh_dV_DI_BD*wsrh)));
              d_isrh_dV_SI_BS = ((model_.CSRHGATD_i)*((asrh*d_wsrh_dV_SI_BS)+(d_asrh_dV_SI_BS*wsrh)));
              isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
            }
            if (((model_.CTATGATD_i)==0.0))
            {

              d_itat_dV_SI_BS = d_itat_dV_DI_BD =  0.0;
              itat = 0.0;
            }
            else
            {

              d_btat_dV_DI_BD = ((model_.btatpartgat_d)*((vbi_minus_vjsrh*(d_wdep_dV_DI_BD*(model_.one_minus_PGAT_d))-(wdep*(model_.one_minus_PGAT_d))*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              d_btat_dV_SI_BS = ((model_.btatpartgat_d)*((vbi_minus_vjsrh*(d_wdep_dV_SI_BS*(model_.one_minus_PGAT_d))-(wdep*(model_.one_minus_PGAT_d))*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh));
              btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));

              d_twoatatoverthreebtat_dV_DI_BD = (-(0.666666666666667*(model_.atatgat_d))*d_btat_dV_DI_BD/btat/btat);
              d_twoatatoverthreebtat_dV_SI_BS = (-(0.666666666666667*(model_.atatgat_d))*d_btat_dV_SI_BS/btat/btat);
              twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);

              d_umaxbeforelimiting_dV_DI_BD = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_DI_BD)+(d_twoatatoverthreebtat_dV_DI_BD*twoatatoverthreebtat));
              d_umaxbeforelimiting_dV_SI_BS = ((twoatatoverthreebtat*d_twoatatoverthreebtat_dV_SI_BS)+(d_twoatatoverthreebtat_dV_SI_BS*twoatatoverthreebtat));
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_umax_dV_DI_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD)+(d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD)+(d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
                d_umax_dV_SI_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS)+(d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting))-(umaxbeforelimiting*umaxbeforelimiting)*((umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS)+(d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting)))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
                umax = value_sqrt_0;
              }
              {
                double value_fabs_0 = fabs(umax);
                double value_sqrt_1 = sqrt(value_fabs_0);
                double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
                double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

                d_sqrtumax_dV_DI_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_DI_BD))));
                d_sqrtumax_dV_SI_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_SI_BS))));
                sqrtumax = value_sqrt_1;
              }

              d_umaxpoweronepointfive_dV_DI_BD = ((umax*d_sqrtumax_dV_DI_BD)+(d_umax_dV_DI_BD*sqrtumax));
              d_umaxpoweronepointfive_dV_SI_BS = ((umax*d_sqrtumax_dV_SI_BS)+(d_umax_dV_SI_BS*sqrtumax));
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1.0)))
              {

                d_wgamma_dV_DI_BD = (-((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
                d_wgamma_dV_SI_BS = (-((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
                wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
                  double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))/(1.0+(btat*umaxpoweronepointfive))));

                  d_wgamma_dV_DI_BD = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))));
                  d_wgamma_dV_SI_BS = (deriv_pow_0_d0*(((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))));
                  wgamma = value_pow_0;
                }
              }

              d_wtat_dV_SI_BS = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_SI_BS)+(d_wsrh_dV_SI_BS*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_SI_BS+d_wgamma_dV_SI_BS))/(wsrh+wgamma)/(wsrh+wgamma));
              d_wtat_dV_DI_BD = (((wsrh+wgamma)*((wsrh*d_wgamma_dV_DI_BD)+(d_wsrh_dV_DI_BD*wgamma))-(wsrh*wgamma)*(d_wsrh_dV_DI_BD+d_wgamma_dV_DI_BD))/(wsrh+wgamma)/(wsrh+wgamma));
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                d_ktat_dV_DI_BD = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_DI_BD-btat*d_sqrtumax_dV_DI_BD)/sqrtumax/sqrtumax))));
                d_ktat_dV_SI_BS = (deriv_sqrt_0_d0*((0.375*((sqrtumax*d_btat_dV_SI_BS-btat*d_sqrtumax_dV_SI_BS)/sqrtumax/sqrtumax))));
                ktat = value_sqrt_0;
              }

              d_ltat_dV_DI_BD = ((2.0*((twoatatoverthreebtat*d_sqrtumax_dV_DI_BD)+(d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)))-d_umax_dV_DI_BD);
              d_ltat_dV_SI_BS = ((2.0*((twoatatoverthreebtat*d_sqrtumax_dV_SI_BS)+(d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)))-d_umax_dV_SI_BS);
              ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);

              d_mtat_dV_DI_BD = ((((((model_.atatgat_d)*twoatatoverthreebtat)*d_sqrtumax_dV_DI_BD)+(((model_.atatgat_d)*d_twoatatoverthreebtat_dV_DI_BD)*sqrtumax))-((model_.atatgat_d)*d_umax_dV_DI_BD))+(0.5*((btat*d_umaxpoweronepointfive_dV_DI_BD)+(d_btat_dV_DI_BD*umaxpoweronepointfive))));
              d_mtat_dV_SI_BS = ((((((model_.atatgat_d)*twoatatoverthreebtat)*d_sqrtumax_dV_SI_BS)+(((model_.atatgat_d)*d_twoatatoverthreebtat_dV_SI_BS)*sqrtumax))-((model_.atatgat_d)*d_umax_dV_SI_BS))+(0.5*((btat*d_umaxpoweronepointfive_dV_SI_BS)+(d_btat_dV_SI_BS*umaxpoweronepointfive))));
              mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));

              d_xerfc_dV_DI_BD = (((ltat-1.0)*d_ktat_dV_DI_BD)+(d_ltat_dV_DI_BD*ktat));
              d_xerfc_dV_SI_BS = (((ltat-1.0)*d_ktat_dV_SI_BS)+(d_ltat_dV_SI_BS*ktat));
              xerfc = ((ltat-1.0)*ktat);

              d_ysq_dV_DI_BD = ((xerfc*d_xerfc_dV_DI_BD)+(d_xerfc_dV_DI_BD*xerfc));
              d_ysq_dV_SI_BS = ((xerfc*d_xerfc_dV_SI_BS)+(d_xerfc_dV_SI_BS*xerfc));
              ysq = (xerfc*xerfc);
              if ((xerfc>0.0))
              {

                d_terfc_dV_DI_BD = (-((model_.perfc)*d_xerfc_dV_DI_BD)/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
                d_terfc_dV_SI_BS = (-((model_.perfc)*d_xerfc_dV_SI_BS)/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
                terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
              }
              else
              {

                d_terfc_dV_DI_BD = (-(-((model_.perfc)*d_xerfc_dV_DI_BD))/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
                d_terfc_dV_SI_BS = (-(-((model_.perfc)*d_xerfc_dV_SI_BS))/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
                terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  double value_exp_0 = exp(((-ysq)+mtat));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_DI_BD = (deriv_exp_0_d0*(((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD)));
                  d_tmp_dV_SI_BS = (deriv_exp_0_d0*(((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS)));
                  tmp = value_exp_0;
                }
              }
              else
              {

                d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*3.3333333333333333e-01))+((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-ysq)+mtat))*(0.5*((((-2.3025850929940458e+02)-((-ysq)+mtat))*((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*3.3333333333333333e-01))+((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))+((-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }

              d_erfcpos_dV_DI_BD = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_DI_BD)+((((0.29214664*d_terfc_dV_DI_BD)+((model_.berfc)*((terfc*d_terfc_dV_DI_BD)+(d_terfc_dV_DI_BD*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_DI_BD)+(((terfc*d_terfc_dV_DI_BD)+(d_terfc_dV_DI_BD*terfc))*terfc))))*tmp));
              d_erfcpos_dV_SI_BS = (((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_SI_BS)+((((0.29214664*d_terfc_dV_SI_BS)+((model_.berfc)*((terfc*d_terfc_dV_SI_BS)+(d_terfc_dV_SI_BS*terfc))))+((model_.cerfc)*(((terfc*terfc)*d_terfc_dV_SI_BS)+(((terfc*d_terfc_dV_SI_BS)+(d_terfc_dV_SI_BS*terfc))*terfc))))*tmp));
              erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0.0))
              {

                d_erfctimesexpmtat_dV_DI_BD = d_erfcpos_dV_DI_BD;
                d_erfctimesexpmtat_dV_SI_BS = d_erfcpos_dV_SI_BS;
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    double value_exp_0 = exp(mtat);
                    double  deriv_exp_0_d0 = value_exp_0;

                    d_tmp_dV_DI_BD = (deriv_exp_0_d0*(d_mtat_dV_DI_BD));
                    d_tmp_dV_SI_BS = (deriv_exp_0_d0*(d_mtat_dV_SI_BS));
                    tmp = value_exp_0;
                  }
                }
                else
                {

                  d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_DI_BD)*3.3333333333333333e-01))+((-d_mtat_dV_DI_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_DI_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-mtat)*(0.5*((((-2.3025850929940458e+02)-mtat)*((-d_mtat_dV_SI_BS)*3.3333333333333333e-01))+((-d_mtat_dV_SI_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))+((-d_mtat_dV_SI_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }

                d_erfctimesexpmtat_dV_DI_BD = ((2.0*d_tmp_dV_DI_BD)-d_erfcpos_dV_DI_BD);
                d_erfctimesexpmtat_dV_SI_BS = ((2.0*d_tmp_dV_SI_BS)-d_erfcpos_dV_SI_BS);
                erfctimesexpmtat = ((2.0*tmp)-erfcpos);
              }

              d_gammamax_dV_DI_BD = ((1.77245385090551603*0.5)*((ktat*((model_.atatgat_d)*d_erfctimesexpmtat_dV_DI_BD)-((model_.atatgat_d)*erfctimesexpmtat)*d_ktat_dV_DI_BD)/ktat/ktat));
              d_gammamax_dV_SI_BS = ((1.77245385090551603*0.5)*((ktat*((model_.atatgat_d)*d_erfctimesexpmtat_dV_SI_BS)-((model_.atatgat_d)*erfctimesexpmtat)*d_ktat_dV_SI_BS)/ktat/ktat));
              gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));

              d_itat_dV_DI_BD = ((model_.CTATGATD_i)*(((asrh*gammamax)*d_wtat_dV_DI_BD)+(((asrh*d_gammamax_dV_DI_BD)+(d_asrh_dV_DI_BD*gammamax))*wtat)));
              d_itat_dV_SI_BS = ((model_.CTATGATD_i)*(((asrh*gammamax)*d_wtat_dV_SI_BS)+(((asrh*d_gammamax_dV_SI_BS)+(d_asrh_dV_SI_BS*gammamax))*wtat)));
              itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
            }
            if (((model_.CBBTGATD_i)==0.0))
            {

              d_ibbt_dV_SI_BS = d_ibbt_dV_DI_BD =  0.0;
              ibbt = 0.0;
            }
            else
            {
              if (((model_.PGATD_i)==0.5))
              {
                {
                  double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
                  double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

                  d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*(((-d_vbbt_dV_SI_BS)*(model_.VBIRGATinv_d))));
                  d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*(((-d_vbbt_dV_DI_BD)*(model_.VBIRGATinv_d))));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
                  double  deriv_pow_0_d0 = (((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PGATD_i)/(((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d))));

                  d_tmp_dV_SI_BS = (deriv_pow_0_d0*(((-d_vbbt_dV_SI_BS)*(model_.VBIRGATinv_d))));
                  d_tmp_dV_DI_BD = (deriv_pow_0_d0*(((-d_vbbt_dV_DI_BD)*(model_.VBIRGATinv_d))));
                  tmp = value_pow_0;
                }
              }

              d_Fmaxr_dV_SI_BS = ((model_.one_over_one_minus_PGAT_d)*((tmp*((-d_vbbt_dV_SI_BS)*(model_.wdepnulrinvgat_d))-(((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))*d_tmp_dV_SI_BS)/tmp/tmp));
              d_Fmaxr_dV_DI_BD = ((model_.one_over_one_minus_PGAT_d)*((tmp*((-d_vbbt_dV_DI_BD)*(model_.wdepnulrinvgat_d))-(((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))*d_tmp_dV_DI_BD)/tmp/tmp));
              Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
              if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_tmp_dV_DI_BD = (deriv_exp_0_d0*((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)));
                  d_tmp_dV_SI_BS = (deriv_exp_0_d0*((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-(model_.fbbtgat_d))/Fmaxr)<0.0))
                {

                  d_tmp_dV_DI_BD = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*((-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (-1.0e-100*((((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(0.5*((((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*((-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01))+((-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))+((-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {

                  d_tmp_dV_DI_BD = (1.0e100*(((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  d_tmp_dV_SI_BS = (1.0e100*(((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(0.5*(((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01))+((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }

              d_ibbt_dV_SI_BS = ((model_.CBBTGATD_i)*((((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_SI_BS)+((((Vjun_d*Fmaxr)*d_Fmaxr_dV_SI_BS)+((Vjun_d*d_Fmaxr_dV_SI_BS)*Fmaxr))*tmp)));
              d_ibbt_dV_DI_BD = ((model_.CBBTGATD_i)*((((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_DI_BD)+((((Vjun_d*Fmaxr)*d_Fmaxr_dV_DI_BD)+(((Vjun_d*d_Fmaxr_dV_DI_BD)+(d_Vjun_d_dV_DI_BD*Fmaxr))*Fmaxr))*tmp)));
              ibbt = ((model_.CBBTGATD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
            }
            if (((model_.VBRGATD_i)>1.0e3))
            {

              d_fbreakdown_dV_SI_BS = d_fbreakdown_dV_DI_BD =  0.0;
              fbreakdown = 1.0;
            }
            else
            {
              if ((vav>((-(model_.alphaav))*(model_.VBRGATD_i))))
              {
                if (((model_.PBRGATD_i)==4.0))
                {

                  d_tmp_dV_SI_BS = (((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(d_vav_dV_SI_BS*(model_.VBRinvgat_d)))+(((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(d_vav_dV_SI_BS*(model_.VBRinvgat_d)))+((((vav*(model_.VBRinvgat_d))*(d_vav_dV_SI_BS*(model_.VBRinvgat_d)))+((d_vav_dV_SI_BS*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d))))*(vav*(model_.VBRinvgat_d))))*(vav*(model_.VBRinvgat_d))));
                  d_tmp_dV_DI_BD = (((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(d_vav_dV_DI_BD*(model_.VBRinvgat_d)))+(((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(d_vav_dV_DI_BD*(model_.VBRinvgat_d)))+((((vav*(model_.VBRinvgat_d))*(d_vav_dV_DI_BD*(model_.VBRinvgat_d)))+((d_vav_dV_DI_BD*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d))))*(vav*(model_.VBRinvgat_d))))*(vav*(model_.VBRinvgat_d))));
                  tmp = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
                }
                else
                {
                  {
                    double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
                    double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
                    double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat_d)))>=0)?(+1.0):(-1.0));
                    double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRGATD_i)/value_fabs_0));

                    d_tmp_dV_SI_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_SI_BS*(model_.VBRinvgat_d))))));
                    d_tmp_dV_DI_BD = (deriv_pow_1_d0*((deriv_fabs_0_d0*((d_vav_dV_DI_BD*(model_.VBRinvgat_d))))));
                    tmp = value_pow_1;
                  }
                }

                d_fbreakdown_dV_DI_BD = (-(-d_tmp_dV_DI_BD)/(1.0-tmp)/(1.0-tmp));
                d_fbreakdown_dV_SI_BS = (-(-d_tmp_dV_SI_BS)/(1.0-tmp)/(1.0-tmp));
                fbreakdown = (1.0/(1.0-tmp));
              }
              else
              {

                d_fbreakdown_dV_SI_BS = (d_vav_dV_SI_BS*(model_.slopegat_d));
                d_fbreakdown_dV_DI_BD = (d_vav_dV_DI_BD*(model_.slopegat_d));
                fbreakdown = ((model_.fstopgat_d)+((vav+((model_.alphaav)*(model_.VBRGATD_i)))*(model_.slopegat_d)));
              }
            }

            d_ijungat_d_dV_SI_BS = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_SI_BS)+((((d_id_dV_SI_BS+d_isrh_dV_SI_BS)+d_itat_dV_SI_BS)+d_ibbt_dV_SI_BS)*fbreakdown));
            d_ijungat_d_dV_DI_BD = (((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_DI_BD)+((((d_id_dV_DI_BD+d_isrh_dV_DI_BD)+d_itat_dV_DI_BD)+d_ibbt_dV_DI_BD)*fbreakdown));
            ijungat_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }

          d_ijun_d_dV_SI_BS = (((ABDRAIN_i*d_ijunbot_d_dV_SI_BS)+(LSDRAIN_i*d_ijunsti_d_dV_SI_BS))+(LGDRAIN_i*d_ijungat_d_dV_SI_BS));
          d_ijun_d_dV_DI_BD = (((ABDRAIN_i*d_ijunbot_d_dV_DI_BD)+(LSDRAIN_i*d_ijunsti_d_dV_DI_BD))+(LGDRAIN_i*d_ijungat_d_dV_DI_BD));
          ijun_d = (((ABDRAIN_i*ijunbot_d)+(LSDRAIN_i*ijunsti_d))+(LGDRAIN_i*ijungat_d));
        }
      }
      rgatenoise = ((model_.nt0)*ggate);
      rsourcenoise = ((model_.nt0)*gsource);
      rdrainnoise = ((model_.nt0)*gdrain);
      rbulknoise = ((model_.nt0)*gbulk);
      rjunsnoise = ((model_.nt0)*gjuns);
      rjundnoise = ((model_.nt0)*gjund);
      rwellnoise = ((model_.nt0)*gwell);
    }
    // End block evaluateStaticDynamic
    //Begin block loadStatic
    {
      if ((sigVds>0.0))
      {
        // I(DI,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
        staticContributions[admsNodeID_DI] += (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
        d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_SI_BP);
        d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_SI);
        d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_DI_SI);
        staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
        d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_SI_BP);
        d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_SI);
        d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_DI_SI);
        // I(DI,SI) <+ (((CHNL_TYPE*MULT_i)*(Ids+Idsedge)))
        staticContributions[admsNodeID_DI] += (((model_.CHNL_TYPE)*MULT_i)*(Ids+Idsedge));
        d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_SI_BP+d_Idsedge_dV_SI_BP));
        d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_GP_SI+d_Idsedge_dV_GP_SI));
        d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_DI_SI+d_Idsedge_dV_DI_SI));
        staticContributions[admsNodeID_SI] -= (((model_.CHNL_TYPE)*MULT_i)*(Ids+Idsedge));
        d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_SI_BP+d_Idsedge_dV_SI_BP));
        d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_GP_SI+d_Idsedge_dV_GP_SI));
        d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_DI_SI+d_Idsedge_dV_DI_SI));
        // I(GP,SI) <+ (((CHNL_TYPE*MULT_i)*Igcs))
        staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcs);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_SI_BP);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_DI_SI);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_SI);
        staticContributions[admsNodeID_SI] -= (((model_.CHNL_TYPE)*MULT_i)*Igcs);
        d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_SI_BP);
        d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_DI_SI);
        d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_SI);
        // I(GP,DI) <+ (((CHNL_TYPE*MULT_i)*Igcd))
        staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcd);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_SI_BP);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_DI_SI);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_SI);
        staticContributions[admsNodeID_DI] -= (((model_.CHNL_TYPE)*MULT_i)*Igcd);
        d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_SI_BP);
        d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_DI_SI);
        d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_SI);
      }
      else
      {
        // I(SI,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
        staticContributions[admsNodeID_SI] += (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
        d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_SI_BP);
        d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_SI);
        d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_DI_SI);
        staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
        d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_SI_BP);
        d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_SI);
        d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_DI_SI);
        // I(SI,DI) <+ (((CHNL_TYPE*MULT_i)*(Ids+Idsedge)))
        staticContributions[admsNodeID_SI] += (((model_.CHNL_TYPE)*MULT_i)*(Ids+Idsedge));
        d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_SI_BP+d_Idsedge_dV_SI_BP));
        d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_GP_SI+d_Idsedge_dV_GP_SI));
        d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_DI_SI+d_Idsedge_dV_DI_SI));
        staticContributions[admsNodeID_DI] -= (((model_.CHNL_TYPE)*MULT_i)*(Ids+Idsedge));
        d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_SI_BP+d_Idsedge_dV_SI_BP));
        d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_GP_SI+d_Idsedge_dV_GP_SI));
        d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_DI_SI+d_Idsedge_dV_DI_SI));
        // I(GP,DI) <+ (((CHNL_TYPE*MULT_i)*Igcs))
        staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcs);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_SI_BP);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_DI_SI);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_SI);
        staticContributions[admsNodeID_DI] -= (((model_.CHNL_TYPE)*MULT_i)*Igcs);
        d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_SI_BP);
        d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_DI_SI);
        d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_SI);
        // I(GP,SI) <+ (((CHNL_TYPE*MULT_i)*Igcd))
        staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcd);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_SI_BP);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_DI_SI);
        d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_SI);
        staticContributions[admsNodeID_SI] -= (((model_.CHNL_TYPE)*MULT_i)*Igcd);
        d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_SI_BP);
        d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_DI_SI);
        d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_SI);
      }
      // I(GP,BP) <+ (((CHNL_TYPE*MULT_i)*Igb))
      staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igb);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_SI_BP);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_DI_SI);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_GP_SI);
      staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Igb);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_SI_BP);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_DI_SI);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_GP_SI);
      // I(GP,SI) <+ (((CHNL_TYPE*MULT_i)*Igsov))
      staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igsov);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_SI_BP);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_DI_SI);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_GP_SI);
      staticContributions[admsNodeID_SI] -= (((model_.CHNL_TYPE)*MULT_i)*Igsov);
      d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_SI_BP);
      d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_DI_SI);
      d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_GP_SI);
      // I(GP,DI) <+ (((CHNL_TYPE*MULT_i)*Igdov))
      staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igdov);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_SI_BP);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_DI_SI);
      d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_GP_SI);
      staticContributions[admsNodeID_DI] -= (((model_.CHNL_TYPE)*MULT_i)*Igdov);
      d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_SI_BP);
      d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_DI_SI);
      d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_GP_SI);
      // I(SI,BP) <+ (((CHNL_TYPE*MULT_i)*Igisl))
      staticContributions[admsNodeID_SI] += (((model_.CHNL_TYPE)*MULT_i)*Igisl);
      d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_DI_SI);
      d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_GP_SI);
      d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_SI_BP);
      staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Igisl);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_DI_SI);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_GP_SI);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_SI_BP);
      // I(DI,BP) <+ (((CHNL_TYPE*MULT_i)*Igidl))
      staticContributions[admsNodeID_DI] += (((model_.CHNL_TYPE)*MULT_i)*Igidl);
      d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_GP_SI);
      d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_SI_BP);
      d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_DI_SI);
      staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Igidl);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_GP_SI);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_SI_BP);
      d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_DI_SI);
      // I(BS,SI) <+ (((CHNL_TYPE*MULT_i)*ijun_s))
      staticContributions[admsNodeID_BS] += (((model_.CHNL_TYPE)*MULT_i)*ijun_s);
      d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BS] += (((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_SI_BS);
      d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_BD] += (((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_DI_BD);
      staticContributions[admsNodeID_SI] -= (((model_.CHNL_TYPE)*MULT_i)*ijun_s);
      d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BS] -= (((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_SI_BS);
      d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_BD] -= (((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_DI_BD);
      // I(BD,DI) <+ (((CHNL_TYPE*MULT_i)*ijun_d))
      staticContributions[admsNodeID_BD] += (((model_.CHNL_TYPE)*MULT_i)*ijun_d);
      d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BS] += (((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_SI_BS);
      d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_BD] += (((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_DI_BD);
      staticContributions[admsNodeID_DI] -= (((model_.CHNL_TYPE)*MULT_i)*ijun_d);
      d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BS] -= (((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_SI_BS);
      d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_BD] -= (((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_DI_BD);
      if ((RG_i>0.0))
      {
        // I(G,GP) <+ (((MULT_i*ggate)*V(G,GP)))
        staticContributions[admsNodeID_G] += ((MULT_i*ggate)*(probeVars[admsProbeID_V_G_GP]));
        d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP] += ((MULT_i*ggate)*d_probeVars[admsProbeID_V_G_GP][admsProbeID_V_G_GP]);
        staticContributions[admsNodeID_GP] -= ((MULT_i*ggate)*(probeVars[admsProbeID_V_G_GP]));
        d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] -= ((MULT_i*ggate)*d_probeVars[admsProbeID_V_G_GP][admsProbeID_V_G_GP]);
        // I(G,GP) <+ (white_noise((MULT_i*rgatenoise),"rgate"))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[0]= (MULT_i*rgatenoise);
        }
      }
      else
      {
        // V(G,GP) <+ (0.0)
        // do nothing at all
      }
      if ((RSE_i>0.0))
      {
        // I(S,SI) <+ (((MULT_i*gsource)*V(S,SI)))
        staticContributions[admsNodeID_S] += ((MULT_i*gsource)*(probeVars[admsProbeID_V_S_SI]));
        d_staticContributions[admsNodeID_S][admsProbeID_V_S_SI] += ((MULT_i*gsource)*d_probeVars[admsProbeID_V_S_SI][admsProbeID_V_S_SI]);
        staticContributions[admsNodeID_SI] -= ((MULT_i*gsource)*(probeVars[admsProbeID_V_S_SI]));
        d_staticContributions[admsNodeID_SI][admsProbeID_V_S_SI] -= ((MULT_i*gsource)*d_probeVars[admsProbeID_V_S_SI][admsProbeID_V_S_SI]);
        // I(S,SI) <+ (white_noise((MULT_i*rsourcenoise),"rsource"))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[1]= (MULT_i*rsourcenoise);
        }
      }
      else
      {
        // V(S,SI) <+ (0.0)
        // do nothing at all
      }
      if ((RDE_i>0.0))
      {
        // I(D,DI) <+ (((MULT_i*gdrain)*V(D,DI)))
        staticContributions[admsNodeID_D] += ((MULT_i*gdrain)*(probeVars[admsProbeID_V_D_DI]));
        d_staticContributions[admsNodeID_D][admsProbeID_V_D_DI] += ((MULT_i*gdrain)*d_probeVars[admsProbeID_V_D_DI][admsProbeID_V_D_DI]);
        staticContributions[admsNodeID_DI] -= ((MULT_i*gdrain)*(probeVars[admsProbeID_V_D_DI]));
        d_staticContributions[admsNodeID_DI][admsProbeID_V_D_DI] -= ((MULT_i*gdrain)*d_probeVars[admsProbeID_V_D_DI][admsProbeID_V_D_DI]);
        // I(D,DI) <+ (white_noise((MULT_i*rdrainnoise),"rdrain"))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[2]= (MULT_i*rdrainnoise);
        }
      }
      else
      {
        // V(D,DI) <+ (0.0)
        // do nothing at all
      }
      if ((RBULK_i>0.0))
      {
        // I(BP,BI) <+ (((MULT_i*gbulk)*V(BP,BI)))
        staticContributions[admsNodeID_BP] += ((MULT_i*gbulk)*(probeVars[admsProbeID_V_BP_BI]));
        d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] += ((MULT_i*gbulk)*d_probeVars[admsProbeID_V_BP_BI][admsProbeID_V_BP_BI]);
        staticContributions[admsNodeID_BI] -= ((MULT_i*gbulk)*(probeVars[admsProbeID_V_BP_BI]));
        d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI] -= ((MULT_i*gbulk)*d_probeVars[admsProbeID_V_BP_BI][admsProbeID_V_BP_BI]);
        // I(BP,BI) <+ (white_noise((MULT_i*rbulknoise),"rbulk"))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[3]= (MULT_i*rbulknoise);
        }
      }
      else
      {
        // V(BP,BI) <+ (0.0)
        // do nothing at all
      }
      if ((RJUNS_i>0.0))
      {
        // I(BS,BI) <+ (((MULT_i*gjuns)*V(BS,BI)))
        staticContributions[admsNodeID_BS] += ((MULT_i*gjuns)*(probeVars[admsProbeID_V_BS_BI]));
        d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] += ((MULT_i*gjuns)*d_probeVars[admsProbeID_V_BS_BI][admsProbeID_V_BS_BI]);
        staticContributions[admsNodeID_BI] -= ((MULT_i*gjuns)*(probeVars[admsProbeID_V_BS_BI]));
        d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] -= ((MULT_i*gjuns)*d_probeVars[admsProbeID_V_BS_BI][admsProbeID_V_BS_BI]);
        // I(BS,BI) <+ (white_noise((MULT_i*rjunsnoise),"rjuns"))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[4]= (MULT_i*rjunsnoise);
        }
      }
      else
      {
        // V(BS,BI) <+ (0.0)
        // do nothing at all
      }
      if ((RJUND_i>0.0))
      {
        // I(BD,BI) <+ (((MULT_i*gjund)*V(BD,BI)))
        staticContributions[admsNodeID_BD] += ((MULT_i*gjund)*(probeVars[admsProbeID_V_BD_BI]));
        d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] += ((MULT_i*gjund)*d_probeVars[admsProbeID_V_BD_BI][admsProbeID_V_BD_BI]);
        staticContributions[admsNodeID_BI] -= ((MULT_i*gjund)*(probeVars[admsProbeID_V_BD_BI]));
        d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] -= ((MULT_i*gjund)*d_probeVars[admsProbeID_V_BD_BI][admsProbeID_V_BD_BI]);
        // I(BD,BI) <+ (white_noise((MULT_i*rjundnoise),"rjund"))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[5]= (MULT_i*rjundnoise);
        }
      }
      else
      {
        // V(BD,BI) <+ (0.0)
        // do nothing at all
      }
      if ((RWELL_i>0.0))
      {
        // I(B,BI) <+ (((MULT_i*gwell)*V(B,BI)))
        staticContributions[admsNodeID_B] += ((MULT_i*gwell)*(probeVars[admsProbeID_V_B_BI]));
        d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI] += ((MULT_i*gwell)*d_probeVars[admsProbeID_V_B_BI][admsProbeID_V_B_BI]);
        staticContributions[admsNodeID_BI] -= ((MULT_i*gwell)*(probeVars[admsProbeID_V_B_BI]));
        d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] -= ((MULT_i*gwell)*d_probeVars[admsProbeID_V_B_BI][admsProbeID_V_B_BI]);
        // I(B,BI) <+ (white_noise((MULT_i*rwellnoise),"rwell"))
        if (getSolverState().noiseFlag)
        {
          noiseContribsPower[6]= (MULT_i*rwellnoise);
        }
      }
      else
      {
        // V(B,BI) <+ (0.0)
        // do nothing at all
      }
      // I(DI,SI) <+ ((1E-15*V(DI,SI)))
      staticContributions[admsNodeID_DI] += (1E-15*(probeVars[admsProbeID_V_DI_SI]));
      d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] += (1E-15*d_probeVars[admsProbeID_V_DI_SI][admsProbeID_V_DI_SI]);
      staticContributions[admsNodeID_SI] -= (1E-15*(probeVars[admsProbeID_V_DI_SI]));
      d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= (1E-15*d_probeVars[admsProbeID_V_DI_SI][admsProbeID_V_DI_SI]);
    }
    // End block loadStatic
    //Begin block loadStaticDynamic
    {
    }
    // End block loadStaticDynamic
    //Begin block loadDynamic
    {
      //Block-local variables for block loadDynamic
      double temp;
      double d_temp_dV_DI_SI;
      double d_temp_dV_GP_SI;
      double d_temp_dV_SI_BP;
      //End of Block-local variables

      d_Qs_dV_SI_BP = (-((d_Qg_dV_SI_BP+d_Qb_dV_SI_BP)+d_Qd_dV_SI_BP));
      d_Qs_dV_GP_SI = (-((d_Qg_dV_GP_SI+d_Qb_dV_GP_SI)+d_Qd_dV_GP_SI));
      d_Qs_dV_DI_SI = (-((d_Qg_dV_DI_SI+d_Qb_dV_DI_SI)+d_Qd_dV_DI_SI));
      Qs = (-((Qg+Qb)+Qd));

      d_Qfgs_dV_GP_SI = (d_Qfgs_dV_GP_SI+d_Qgs_ov_dV_GP_SI);
      Qfgs = (Qfgs+Qgs_ov);

      d_Qfgd_dV_DI_SI = (d_Qfgd_dV_DI_SI+d_Qgd_ov_dV_DI_SI);
      d_Qfgd_dV_GP_SI = (d_Qfgd_dV_GP_SI+d_Qgd_ov_dV_GP_SI);
      Qfgd = (Qfgd+Qgd_ov);

      d_qjun_s_dV_SI_BS = (((ABSOURCE_i*d_qjunbot_s_dV_SI_BS)+(LSSOURCE_i*d_qjunsti_s_dV_SI_BS))+(LGSOURCE_i*d_qjungat_s_dV_SI_BS));
      d_qjun_s_dV_DI_BD = (((ABSOURCE_i*d_qjunbot_s_dV_DI_BD)+(LSSOURCE_i*d_qjunsti_s_dV_DI_BD))+(LGSOURCE_i*d_qjungat_s_dV_DI_BD));
      qjun_s = (((ABSOURCE_i*qjunbot_s)+(LSSOURCE_i*qjunsti_s))+(LGSOURCE_i*qjungat_s));

      d_qjun_d_dV_SI_BS = (((ABDRAIN_i*d_qjunbot_d_dV_SI_BS)+(LSDRAIN_i*d_qjunsti_d_dV_SI_BS))+(LGDRAIN_i*d_qjungat_d_dV_SI_BS));
      d_qjun_d_dV_DI_BD = (((ABDRAIN_i*d_qjunbot_d_dV_DI_BD)+(LSDRAIN_i*d_qjunsti_d_dV_DI_BD))+(LGDRAIN_i*d_qjungat_d_dV_DI_BD));
      qjun_d = (((ABDRAIN_i*qjunbot_d)+(LSDRAIN_i*qjunsti_d))+(LGDRAIN_i*qjungat_d));
      if ((sigVds<0.0))
      {

        d_temp_dV_SI_BP = d_Qd_dV_SI_BP;
        d_temp_dV_GP_SI = d_Qd_dV_GP_SI;
        d_temp_dV_DI_SI = d_Qd_dV_DI_SI;
        temp = Qd;

        d_Qd_dV_SI_BP = d_Qs_dV_SI_BP;
        d_Qd_dV_GP_SI = d_Qs_dV_GP_SI;
        d_Qd_dV_DI_SI = d_Qs_dV_DI_SI;
        Qd = Qs;

        d_Qs_dV_SI_BP = 0.0;
        d_Qs_dV_GP_SI = 0.0;
        d_Qs_dV_DI_SI = 0.0;
        Qs = temp;
      }
      // I(GP,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qg)))
      dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qg));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_SI_BP));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_GP_SI));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_DI_SI));
      dynamicContributions[admsNodeID_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*Qg));
      d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_SI_BP));
      d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_GP_SI));
      d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_DI_SI));
      // I(BP,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qb)))
      dynamicContributions[admsNodeID_BP] += ((((model_.CHNL_TYPE)*MULT_i)*Qb));
      d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_SI_BP));
      d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_GP_SI));
      d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_DI_SI));
      dynamicContributions[admsNodeID_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*Qb));
      d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_SI_BP));
      d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_GP_SI));
      d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_DI_SI));
      // I(DI,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qd)))
      dynamicContributions[admsNodeID_DI] += ((((model_.CHNL_TYPE)*MULT_i)*Qd));
      d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_SI_BP));
      d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_GP_SI));
      d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_DI_SI));
      dynamicContributions[admsNodeID_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*Qd));
      d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_SI_BP));
      d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_GP_SI));
      d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_DI_SI));
      // I(GP,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgs)))
      dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qfgs));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_GP_SI));
      dynamicContributions[admsNodeID_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*Qfgs));
      d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_GP_SI));
      // I(GP,DI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgd)))
      dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qfgd));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_DI_SI));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_GP_SI));
      dynamicContributions[admsNodeID_DI] -= ((((model_.CHNL_TYPE)*MULT_i)*Qfgd));
      d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_DI_SI));
      d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_GP_SI));
      // I(GP,BP) <+ (ddt(((CHNL_TYPE*MULT_i)*Qgb_ov)))
      dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qgb_ov));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_SI_BP));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_GP_SI));
      d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += ((((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_DI_SI));
      dynamicContributions[admsNodeID_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*Qgb_ov));
      d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_SI_BP));
      d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_GP_SI));
      d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_DI_SI));
      // I(BS,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_s)))
      dynamicContributions[admsNodeID_BS] += ((((model_.CHNL_TYPE)*MULT_i)*qjun_s));
      d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BS] += ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_SI_BS));
      d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_BD] += ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_DI_BD));
      dynamicContributions[admsNodeID_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*qjun_s));
      d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BS] -= ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_SI_BS));
      d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_BD] -= ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_DI_BD));
      // I(BD,DI) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_d)))
      dynamicContributions[admsNodeID_BD] += ((((model_.CHNL_TYPE)*MULT_i)*qjun_d));
      d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BS] += ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_SI_BS));
      d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_BD] += ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_DI_BD));
      dynamicContributions[admsNodeID_DI] -= ((((model_.CHNL_TYPE)*MULT_i)*qjun_d));
      d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BS] -= ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_SI_BS));
      d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_BD] -= ((((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_DI_BD));
    }
    // End block loadDynamic
    //Begin block noise
    {
      //Block-local variables for block noise
      double sf;
      double d_sf_dV_DI_SI;
      double d_sf_dV_GP_SI;
      double d_sf_dV_SI_BP;
      //End of Block-local variables

      d_Sfl_dV_DI_SI = d_Sfl_dV_GP_SI = d_Sfl_dV_SI_BP =  0.0;
      Sfl = 0.0;

      d_Sidexc_dV_DI_SI = d_Sidexc_dV_GP_SI = d_Sidexc_dV_SI_BP =  0.0;
      Sidexc = 0.0;

      d_mid_dV_DI_SI = d_mid_dV_SI_BP = d_mid_dV_GP_SI =  0.0;
      mid = 0.0;

      d_mig_dV_DI_SI = d_mig_dV_SI_BP = d_mig_dV_GP_SI =  0.0;
      mig = 1.0e-40;

      d_migid_dV_DI_SI = d_migid_dV_SI_BP = d_migid_dV_GP_SI =  0.0;
      migid = 0.0;

      d_c_igid_dV_DI_SI = d_c_igid_dV_SI_BP = d_c_igid_dV_GP_SI =  0.0;
      c_igid = 0.0;

      d_CGeff_dV_SI_BP = ((COX_qm*d_eta_p_ac_dV_SI_BP)+(d_COX_qm_dV_SI_BP*eta_p_ac));
      d_CGeff_dV_GP_SI = ((COX_qm*d_eta_p_ac_dV_GP_SI)+(d_COX_qm_dV_GP_SI*eta_p_ac));
      d_CGeff_dV_DI_SI = ((COX_qm*d_eta_p_ac_dV_DI_SI)+(d_COX_qm_dV_DI_SI*eta_p_ac));
      CGeff = (COX_qm*eta_p_ac);

      d_sqid_dV_DI_SI = d_sqid_dV_SI_BP = d_sqid_dV_GP_SI =  0.0;
      sqid = 0.0;

      d_sqig_dV_DI_SI = d_sqig_dV_SI_BP = d_sqig_dV_GP_SI =  0.0;
      sqig = 0.0;

      d_Sfledge_dV_GP_SI = d_Sfledge_dV_DI_SI = d_Sfledge_dV_SI_BP =  0.0;
      Sfledge = 0.0;

      d_midedge_dV_GP_SI = d_midedge_dV_DI_SI = d_midedge_dV_SI_BP =  0.0;
      midedge = 0.0;

      d_sqidedge_dV_GP_SI = d_sqidedge_dV_DI_SI = d_sqidedge_dV_SI_BP =  0.0;
      sqidedge = 0.0;
      if ((((xg_dc>0.0)&&(MULT_i>0.0))&&(BET_i>0.0)))
      {

        d_N1_dV_SI_BP = ((Cox_over_q*d_alpha_dc_dV_SI_BP)*(model_.phit));
        d_N1_dV_GP_SI = ((Cox_over_q*d_alpha_dc_dV_GP_SI)*(model_.phit));
        d_N1_dV_DI_SI = ((Cox_over_q*d_alpha_dc_dV_DI_SI)*(model_.phit));
        N1 = ((Cox_over_q*alpha_dc)*(model_.phit));

        d_Nm1_dV_GP_SI = (Cox_over_q*d_qim1_dc_dV_GP_SI);
        d_Nm1_dV_SI_BP = (Cox_over_q*d_qim1_dc_dV_SI_BP);
        d_Nm1_dV_DI_SI = (Cox_over_q*d_qim1_dc_dV_DI_SI);
        Nm1 = (Cox_over_q*qim1_dc);

        d_Delta_N1_dV_SI_BP = (((Cox_over_q*alpha_dc)*d_dps_dc_dV_SI_BP)+((Cox_over_q*d_alpha_dc_dV_SI_BP)*dps_dc));
        d_Delta_N1_dV_GP_SI = (((Cox_over_q*alpha_dc)*d_dps_dc_dV_GP_SI)+((Cox_over_q*d_alpha_dc_dV_GP_SI)*dps_dc));
        d_Delta_N1_dV_DI_SI = (((Cox_over_q*alpha_dc)*d_dps_dc_dV_DI_SI)+((Cox_over_q*d_alpha_dc_dV_DI_SI)*dps_dc));
        Delta_N1 = ((Cox_over_q*alpha_dc)*dps_dc);
        {
          double value_log_0 = log(((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));
          double  deriv_log_0_d0 = (1.0/((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));

          d_Sfl_dV_SI_BP = ((((NFA_i-(NFB_i*N1))+(NFC_i*(N1*N1)))*(deriv_log_0_d0*((((Nm1-(0.5*Delta_N1))*(d_Nm1_dV_SI_BP+(0.5*d_Delta_N1_dV_SI_BP))-(Nm1+(0.5*Delta_N1))*(d_Nm1_dV_SI_BP-(0.5*d_Delta_N1_dV_SI_BP)))/(Nm1-(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))))))+(((-(NFB_i*d_N1_dV_SI_BP))+(NFC_i*((N1*d_N1_dV_SI_BP)+(d_N1_dV_SI_BP*N1))))*value_log_0));
          d_Sfl_dV_GP_SI = ((((NFA_i-(NFB_i*N1))+(NFC_i*(N1*N1)))*(deriv_log_0_d0*((((Nm1-(0.5*Delta_N1))*(d_Nm1_dV_GP_SI+(0.5*d_Delta_N1_dV_GP_SI))-(Nm1+(0.5*Delta_N1))*(d_Nm1_dV_GP_SI-(0.5*d_Delta_N1_dV_GP_SI)))/(Nm1-(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))))))+(((-(NFB_i*d_N1_dV_GP_SI))+(NFC_i*((N1*d_N1_dV_GP_SI)+(d_N1_dV_GP_SI*N1))))*value_log_0));
          d_Sfl_dV_DI_SI = ((((NFA_i-(NFB_i*N1))+(NFC_i*(N1*N1)))*(deriv_log_0_d0*((((Nm1-(0.5*Delta_N1))*(d_Nm1_dV_DI_SI+(0.5*d_Delta_N1_dV_DI_SI))-(Nm1+(0.5*Delta_N1))*(d_Nm1_dV_DI_SI-(0.5*d_Delta_N1_dV_DI_SI)))/(Nm1-(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))))))+(((-(NFB_i*d_N1_dV_DI_SI))+(NFC_i*((N1*d_N1_dV_DI_SI)+(d_N1_dV_DI_SI*N1))))*value_log_0));
          Sfl = (((NFA_i-(NFB_i*N1))+(NFC_i*(N1*N1)))*value_log_0);
        }

        d_Sfl_dV_SI_BP = (d_Sfl_dV_SI_BP+(((NFB_i+(NFC_i*(Nm1-(2.0*N1))))*d_Delta_N1_dV_SI_BP)+((NFC_i*(d_Nm1_dV_SI_BP-(2.0*d_N1_dV_SI_BP)))*Delta_N1)));
        d_Sfl_dV_GP_SI = (d_Sfl_dV_GP_SI+(((NFB_i+(NFC_i*(Nm1-(2.0*N1))))*d_Delta_N1_dV_GP_SI)+((NFC_i*(d_Nm1_dV_GP_SI-(2.0*d_N1_dV_GP_SI)))*Delta_N1)));
        d_Sfl_dV_DI_SI = (d_Sfl_dV_DI_SI+(((NFB_i+(NFC_i*(Nm1-(2.0*N1))))*d_Delta_N1_dV_DI_SI)+((NFC_i*(d_Nm1_dV_DI_SI-(2.0*d_N1_dV_DI_SI)))*Delta_N1)));
        Sfl = (Sfl+((NFB_i+(NFC_i*(Nm1-(2.0*N1))))*Delta_N1));

        d_Sfl_dV_SI_BP = ((N1*((((Sfl_prefac*Ids)*Gvsatinv_dc)*d_Sfl_dV_SI_BP)+((((Sfl_prefac*Ids)*d_Gvsatinv_dc_dV_SI_BP)+((Sfl_prefac*d_Ids_dV_SI_BP)*Gvsatinv_dc))*Sfl))-(((Sfl_prefac*Ids)*Gvsatinv_dc)*Sfl)*d_N1_dV_SI_BP)/N1/N1);
        d_Sfl_dV_GP_SI = ((N1*((((Sfl_prefac*Ids)*Gvsatinv_dc)*d_Sfl_dV_GP_SI)+((((Sfl_prefac*Ids)*d_Gvsatinv_dc_dV_GP_SI)+((Sfl_prefac*d_Ids_dV_GP_SI)*Gvsatinv_dc))*Sfl))-(((Sfl_prefac*Ids)*Gvsatinv_dc)*Sfl)*d_N1_dV_GP_SI)/N1/N1);
        d_Sfl_dV_DI_SI = ((N1*((((Sfl_prefac*Ids)*Gvsatinv_dc)*d_Sfl_dV_DI_SI)+((((Sfl_prefac*Ids)*d_Gvsatinv_dc_dV_DI_SI)+((Sfl_prefac*d_Ids_dV_DI_SI)*Gvsatinv_dc))*Sfl))-(((Sfl_prefac*Ids)*Gvsatinv_dc)*Sfl)*d_N1_dV_DI_SI)/N1/N1);
        Sfl = ((((Sfl_prefac*Ids)*Gvsatinv_dc)*Sfl)/N1);

        d_Sfl_dV_SI_BP = ((Sfl>0.0)?d_Sfl_dV_SI_BP:0.0);
        d_Sfl_dV_GP_SI = ((Sfl>0.0)?d_Sfl_dV_GP_SI:0.0);
        d_Sfl_dV_DI_SI = ((Sfl>0.0)?d_Sfl_dV_DI_SI:0.0);
        Sfl = ((Sfl>0.0)?Sfl:0.0);

        d_H0_dV_GP_SI = ((alpha_dc*d_qim1_dc_dV_GP_SI-qim1_dc*d_alpha_dc_dV_GP_SI)/alpha_dc/alpha_dc);
        d_H0_dV_SI_BP = ((alpha_dc*d_qim1_dc_dV_SI_BP-qim1_dc*d_alpha_dc_dV_SI_BP)/alpha_dc/alpha_dc);
        d_H0_dV_DI_SI = ((alpha_dc*d_qim1_dc_dV_DI_SI-qim1_dc*d_alpha_dc_dV_DI_SI)/alpha_dc/alpha_dc);
        H0 = (qim1_dc/alpha_dc);

        d_t1_dV_GP_SI = ((qim1_dc*d_qim_dc_dV_GP_SI-qim_dc*d_qim1_dc_dV_GP_SI)/qim1_dc/qim1_dc);
        d_t1_dV_SI_BP = ((qim1_dc*d_qim_dc_dV_SI_BP-qim_dc*d_qim1_dc_dV_SI_BP)/qim1_dc/qim1_dc);
        d_t1_dV_DI_SI = ((qim1_dc*d_qim_dc_dV_DI_SI-qim_dc*d_qim1_dc_dV_DI_SI)/qim1_dc/qim1_dc);
        t1 = (qim_dc/qim1_dc);

        d_sqt2_dV_SI_BP = ((0.5*1.6666666666666667e-01)*((H0*d_dps_dc_dV_SI_BP-dps_dc*d_H0_dV_SI_BP)/H0/H0));
        d_sqt2_dV_GP_SI = ((0.5*1.6666666666666667e-01)*((H0*d_dps_dc_dV_GP_SI-dps_dc*d_H0_dV_GP_SI)/H0/H0));
        d_sqt2_dV_DI_SI = ((0.5*1.6666666666666667e-01)*((H0*d_dps_dc_dV_DI_SI-dps_dc*d_H0_dV_DI_SI)/H0/H0));
        sqt2 = ((0.5*1.6666666666666667e-01)*(dps_dc/H0));

        d_t2_dV_SI_BP = ((sqt2*d_sqt2_dV_SI_BP)+(d_sqt2_dV_SI_BP*sqt2));
        d_t2_dV_GP_SI = ((sqt2*d_sqt2_dV_GP_SI)+(d_sqt2_dV_GP_SI*sqt2));
        d_t2_dV_DI_SI = ((sqt2*d_sqt2_dV_DI_SI)+(d_sqt2_dV_DI_SI*sqt2));
        t2 = (sqt2*sqt2);

        d_r_dV_GP_SI = ((H_dc*d_H0_dV_GP_SI-H0*d_H_dc_dV_GP_SI)/H_dc/H_dc);
        d_r_dV_SI_BP = ((H_dc*d_H0_dV_SI_BP-H0*d_H_dc_dV_SI_BP)/H_dc/H_dc);
        d_r_dV_DI_SI = ((H_dc*d_H0_dV_DI_SI-H0*d_H_dc_dV_DI_SI)/H_dc/H_dc);
        r = ((H0/H_dc)-1.0);

        d_lc_dV_GP_SI = (((1.0-(12.0*(r*t2)))>1.0e-20)?(-(12.0*((r*d_t2_dV_GP_SI)+(d_r_dV_GP_SI*t2)))):0.0);
        d_lc_dV_SI_BP = (((1.0-(12.0*(r*t2)))>1.0e-20)?(-(12.0*((r*d_t2_dV_SI_BP)+(d_r_dV_SI_BP*t2)))):0.0);
        d_lc_dV_DI_SI = (((1.0-(12.0*(r*t2)))>1.0e-20)?(-(12.0*((r*d_t2_dV_DI_SI)+(d_r_dV_DI_SI*t2)))):0.0);
        lc = (((1.0-(12.0*(r*t2)))>1.0e-20)?(1.0-(12.0*(r*t2))):1.0e-20);

        d_lcinv2_dV_GP_SI = (-((lc*d_lc_dV_GP_SI)+(d_lc_dV_GP_SI*lc))/(lc*lc)/(lc*lc));
        d_lcinv2_dV_SI_BP = (-((lc*d_lc_dV_SI_BP)+(d_lc_dV_SI_BP*lc))/(lc*lc)/(lc*lc));
        d_lcinv2_dV_DI_SI = (-((lc*d_lc_dV_DI_SI)+(d_lc_dV_DI_SI*lc))/(lc*lc)/(lc*lc));
        lcinv2 = (1.0/(lc*lc));

        d_g_ideal_dV_SI_BP = (BET_i*(((FdL_dc*qim1_dc)*d_Gvsatinv_dc_dV_SI_BP)+(((FdL_dc*d_qim1_dc_dV_SI_BP)+(d_FdL_dc_dV_SI_BP*qim1_dc))*Gvsatinv_dc)));
        d_g_ideal_dV_GP_SI = (BET_i*(((FdL_dc*qim1_dc)*d_Gvsatinv_dc_dV_GP_SI)+(((FdL_dc*d_qim1_dc_dV_GP_SI)+(d_FdL_dc_dV_GP_SI*qim1_dc))*Gvsatinv_dc)));
        d_g_ideal_dV_DI_SI = (BET_i*(((FdL_dc*qim1_dc)*d_Gvsatinv_dc_dV_DI_SI)+(((FdL_dc*d_qim1_dc_dV_DI_SI)+(d_FdL_dc_dV_DI_SI*qim1_dc))*Gvsatinv_dc)));
        g_ideal = (BET_i*((FdL_dc*qim1_dc)*Gvsatinv_dc));

        d_mid_dV_GP_SI = ((d_t1_dV_GP_SI+(12.0*d_t2_dV_GP_SI))-(24.0*((((1.0+t1)*t2)*d_r_dV_GP_SI)+((((1.0+t1)*d_t2_dV_GP_SI)+(d_t1_dV_GP_SI*t2))*r))));
        d_mid_dV_SI_BP = ((d_t1_dV_SI_BP+(12.0*d_t2_dV_SI_BP))-(24.0*((((1.0+t1)*t2)*d_r_dV_SI_BP)+((((1.0+t1)*d_t2_dV_SI_BP)+(d_t1_dV_SI_BP*t2))*r))));
        d_mid_dV_DI_SI = ((d_t1_dV_DI_SI+(12.0*d_t2_dV_DI_SI))-(24.0*((((1.0+t1)*t2)*d_r_dV_DI_SI)+((((1.0+t1)*d_t2_dV_DI_SI)+(d_t1_dV_DI_SI*t2))*r))));
        mid = ((t1+(12.0*t2))-(24.0*(((1.0+t1)*t2)*r)));

        d_mid_dV_GP_SI = ((mid>1.0e-40)?d_mid_dV_GP_SI:0.0);
        d_mid_dV_SI_BP = ((mid>1.0e-40)?d_mid_dV_SI_BP:0.0);
        d_mid_dV_DI_SI = ((mid>1.0e-40)?d_mid_dV_DI_SI:0.0);
        mid = ((mid>1.0e-40)?mid:1.0e-40);

        d_mid_dV_SI_BP = (((g_ideal*lcinv2)*d_mid_dV_SI_BP)+(((g_ideal*d_lcinv2_dV_SI_BP)+(d_g_ideal_dV_SI_BP*lcinv2))*mid));
        d_mid_dV_GP_SI = (((g_ideal*lcinv2)*d_mid_dV_GP_SI)+(((g_ideal*d_lcinv2_dV_GP_SI)+(d_g_ideal_dV_GP_SI*lcinv2))*mid));
        d_mid_dV_DI_SI = (((g_ideal*lcinv2)*d_mid_dV_DI_SI)+(((g_ideal*d_lcinv2_dV_DI_SI)+(d_g_ideal_dV_DI_SI*lcinv2))*mid));
        mid = ((g_ideal*lcinv2)*mid);
        if ((FNTEXC_i>0.0))
        {

          d_temp2_exc_dV_GP_SI = (d_qim_dc_dV_GP_SI*xitsb_dc);
          d_temp2_exc_dV_SI_BP = ((qim_dc*d_xitsb_dc_dV_SI_BP)+(d_qim_dc_dV_SI_BP*xitsb_dc));
          d_temp2_exc_dV_DI_SI = ((qim_dc*d_xitsb_dc_dV_DI_SI)+(d_qim_dc_dV_DI_SI*xitsb_dc));
          temp2_exc = (qim_dc*xitsb_dc);

          d_wsat_exc_dV_GP_SI = (100.0*(((100.0+temp2_exc)*d_temp2_exc_dV_GP_SI-temp2_exc*d_temp2_exc_dV_GP_SI)/(100.0+temp2_exc)/(100.0+temp2_exc)));
          d_wsat_exc_dV_SI_BP = (100.0*(((100.0+temp2_exc)*d_temp2_exc_dV_SI_BP-temp2_exc*d_temp2_exc_dV_SI_BP)/(100.0+temp2_exc)/(100.0+temp2_exc)));
          d_wsat_exc_dV_DI_SI = (100.0*(((100.0+temp2_exc)*d_temp2_exc_dV_DI_SI-temp2_exc*d_temp2_exc_dV_DI_SI)/(100.0+temp2_exc)/(100.0+temp2_exc)));
          wsat_exc = (100.0*(temp2_exc/(100.0+temp2_exc)));
          if ((THESATG_i<0))
          {

            d_temp_exc_dV_GP_SI = (-(-(THESATG_i*d_wsat_exc_dV_GP_SI))/(1.0-(THESATG_i*wsat_exc))/(1.0-(THESATG_i*wsat_exc)));
            d_temp_exc_dV_SI_BP = (-(-(THESATG_i*d_wsat_exc_dV_SI_BP))/(1.0-(THESATG_i*wsat_exc))/(1.0-(THESATG_i*wsat_exc)));
            d_temp_exc_dV_DI_SI = (-(-(THESATG_i*d_wsat_exc_dV_DI_SI))/(1.0-(THESATG_i*wsat_exc))/(1.0-(THESATG_i*wsat_exc)));
            temp_exc = (1.0/(1.0-(THESATG_i*wsat_exc)));
          }
          else
          {

            d_temp_exc_dV_GP_SI = (THESATG_i*d_wsat_exc_dV_GP_SI);
            d_temp_exc_dV_SI_BP = (THESATG_i*d_wsat_exc_dV_SI_BP);
            d_temp_exc_dV_DI_SI = (THESATG_i*d_wsat_exc_dV_DI_SI);
            temp_exc = (1.0+(THESATG_i*wsat_exc));
          }

          d_thesat1_exc_dV_GP_SI = (THESAT_T*((Gmob_dc*d_temp_exc_dV_GP_SI-temp_exc*d_Gmob_dc_dV_GP_SI)/Gmob_dc/Gmob_dc));
          d_thesat1_exc_dV_SI_BP = (THESAT_T*((Gmob_dc*d_temp_exc_dV_SI_BP-temp_exc*d_Gmob_dc_dV_SI_BP)/Gmob_dc/Gmob_dc));
          d_thesat1_exc_dV_DI_SI = (THESAT_T*((Gmob_dc*d_temp_exc_dV_DI_SI-temp_exc*d_Gmob_dc_dV_DI_SI)/Gmob_dc/Gmob_dc));
          thesat1_exc = (THESAT_T*(temp_exc/Gmob_dc));

          d_zsat_exc_dV_GP_SI = ((((thesat1_exc*thesat1_exc)*dps_dc)*d_dps_dc_dV_GP_SI)+((((thesat1_exc*thesat1_exc)*d_dps_dc_dV_GP_SI)+(((thesat1_exc*d_thesat1_exc_dV_GP_SI)+(d_thesat1_exc_dV_GP_SI*thesat1_exc))*dps_dc))*dps_dc));
          d_zsat_exc_dV_SI_BP = ((((thesat1_exc*thesat1_exc)*dps_dc)*d_dps_dc_dV_SI_BP)+((((thesat1_exc*thesat1_exc)*d_dps_dc_dV_SI_BP)+(((thesat1_exc*d_thesat1_exc_dV_SI_BP)+(d_thesat1_exc_dV_SI_BP*thesat1_exc))*dps_dc))*dps_dc));
          d_zsat_exc_dV_DI_SI = ((((thesat1_exc*thesat1_exc)*dps_dc)*d_dps_dc_dV_DI_SI)+((((thesat1_exc*thesat1_exc)*d_dps_dc_dV_DI_SI)+(((thesat1_exc*d_thesat1_exc_dV_DI_SI)+(d_thesat1_exc_dV_DI_SI*thesat1_exc))*dps_dc))*dps_dc));
          zsat_exc = (((thesat1_exc*thesat1_exc)*dps_dc)*dps_dc);
          if (((model_.CHNL_TYPE)==(-1)))
          {

            d_zsat_exc_dV_GP_SI = (((1.0+(thesat1_exc*dps_dc))*d_zsat_exc_dV_GP_SI-zsat_exc*((thesat1_exc*d_dps_dc_dV_GP_SI)+(d_thesat1_exc_dV_GP_SI*dps_dc)))/(1.0+(thesat1_exc*dps_dc))/(1.0+(thesat1_exc*dps_dc)));
            d_zsat_exc_dV_SI_BP = (((1.0+(thesat1_exc*dps_dc))*d_zsat_exc_dV_SI_BP-zsat_exc*((thesat1_exc*d_dps_dc_dV_SI_BP)+(d_thesat1_exc_dV_SI_BP*dps_dc)))/(1.0+(thesat1_exc*dps_dc))/(1.0+(thesat1_exc*dps_dc)));
            d_zsat_exc_dV_DI_SI = (((1.0+(thesat1_exc*dps_dc))*d_zsat_exc_dV_DI_SI-zsat_exc*((thesat1_exc*d_dps_dc_dV_DI_SI)+(d_thesat1_exc_dV_DI_SI*dps_dc)))/(1.0+(thesat1_exc*dps_dc))/(1.0+(thesat1_exc*dps_dc)));
            zsat_exc = (zsat_exc/(1.0+(thesat1_exc*dps_dc)));
          }
          {
            double value_sqrt_0 = sqrt((1.0+(2.0*zsat_exc)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_Gvsat_exc_dV_SI_BP = (0.5*((Gmob_dc*(deriv_sqrt_0_d0*((2.0*d_zsat_exc_dV_SI_BP))))+(d_Gmob_dc_dV_SI_BP*(1.0+value_sqrt_0))));
            d_Gvsat_exc_dV_GP_SI = (0.5*((Gmob_dc*(deriv_sqrt_0_d0*((2.0*d_zsat_exc_dV_GP_SI))))+(d_Gmob_dc_dV_GP_SI*(1.0+value_sqrt_0))));
            d_Gvsat_exc_dV_DI_SI = (0.5*((Gmob_dc*(deriv_sqrt_0_d0*((2.0*d_zsat_exc_dV_DI_SI))))+(d_Gmob_dc_dV_DI_SI*(1.0+value_sqrt_0))));
            Gvsat_exc = (0.5*(Gmob_dc*(1.0+value_sqrt_0)));
          }

          d_gfac_dV_SI_BP = (((Gvsat_exc*lc)*d_Gmob_dc_dV_SI_BP-Gmob_dc*((Gvsat_exc*d_lc_dV_SI_BP)+(d_Gvsat_exc_dV_SI_BP*lc)))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
          d_gfac_dV_GP_SI = (((Gvsat_exc*lc)*d_Gmob_dc_dV_GP_SI-Gmob_dc*((Gvsat_exc*d_lc_dV_GP_SI)+(d_Gvsat_exc_dV_GP_SI*lc)))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
          d_gfac_dV_DI_SI = (((Gvsat_exc*lc)*d_Gmob_dc_dV_DI_SI-Gmob_dc*((Gvsat_exc*d_lc_dV_DI_SI)+(d_Gvsat_exc_dV_DI_SI*lc)))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
          gfac = (Gmob_dc/(Gvsat_exc*lc));

          d_Sidexc_dV_SI_BP = (((((fac_exc*Ids)*Vdse_dc)*gfac)*d_gfac_dV_SI_BP)+(((((fac_exc*Ids)*Vdse_dc)*d_gfac_dV_SI_BP)+((((fac_exc*Ids)*d_Vdse_dc_dV_SI_BP)+((fac_exc*d_Ids_dV_SI_BP)*Vdse_dc))*gfac))*gfac));
          d_Sidexc_dV_GP_SI = (((((fac_exc*Ids)*Vdse_dc)*gfac)*d_gfac_dV_GP_SI)+(((((fac_exc*Ids)*Vdse_dc)*d_gfac_dV_GP_SI)+((((fac_exc*Ids)*d_Vdse_dc_dV_GP_SI)+((fac_exc*d_Ids_dV_GP_SI)*Vdse_dc))*gfac))*gfac));
          d_Sidexc_dV_DI_SI = (((((fac_exc*Ids)*Vdse_dc)*gfac)*d_gfac_dV_DI_SI)+(((((fac_exc*Ids)*Vdse_dc)*d_gfac_dV_DI_SI)+((((fac_exc*Ids)*d_Vdse_dc_dV_DI_SI)+((fac_exc*d_Ids_dV_DI_SI)*Vdse_dc))*gfac))*gfac));
          Sidexc = ((((fac_exc*Ids)*Vdse_dc)*gfac)*gfac);

          d_mid_dV_GP_SI = (d_mid_dV_GP_SI+(d_Sidexc_dV_GP_SI/(model_.nt0)));
          d_mid_dV_SI_BP = (d_mid_dV_SI_BP+(d_Sidexc_dV_SI_BP/(model_.nt0)));
          d_mid_dV_DI_SI = (d_mid_dV_DI_SI+(d_Sidexc_dV_DI_SI/(model_.nt0)));
          mid = (mid+(Sidexc/(model_.nt0)));
        }
        {
          double value_sqrt_0 = sqrt((nt*mid));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_sqid_dV_GP_SI = (deriv_sqrt_0_d0*((nt*d_mid_dV_GP_SI)));
          d_sqid_dV_SI_BP = (deriv_sqrt_0_d0*((nt*d_mid_dV_SI_BP)));
          d_sqid_dV_DI_SI = (deriv_sqrt_0_d0*((nt*d_mid_dV_DI_SI)));
          sqid = value_sqrt_0;
        }
        if (((model_.SWIGN_i)==1))
        {

          d_mig_dV_GP_SI = (((d_t1_dV_GP_SI/12.0)-((t2*(d_t1_dV_GP_SI-(12.0*d_t2_dV_GP_SI)))+(d_t2_dV_GP_SI*((t1+0.2)-(12.0*t2)))))-(1.6*(((t2*((t1+1.0)-(12.0*t2)))*d_r_dV_GP_SI)+(((t2*(d_t1_dV_GP_SI-(12.0*d_t2_dV_GP_SI)))+(d_t2_dV_GP_SI*((t1+1.0)-(12.0*t2))))*r))));
          d_mig_dV_SI_BP = (((d_t1_dV_SI_BP/12.0)-((t2*(d_t1_dV_SI_BP-(12.0*d_t2_dV_SI_BP)))+(d_t2_dV_SI_BP*((t1+0.2)-(12.0*t2)))))-(1.6*(((t2*((t1+1.0)-(12.0*t2)))*d_r_dV_SI_BP)+(((t2*(d_t1_dV_SI_BP-(12.0*d_t2_dV_SI_BP)))+(d_t2_dV_SI_BP*((t1+1.0)-(12.0*t2))))*r))));
          d_mig_dV_DI_SI = (((d_t1_dV_DI_SI/12.0)-((t2*(d_t1_dV_DI_SI-(12.0*d_t2_dV_DI_SI)))+(d_t2_dV_DI_SI*((t1+0.2)-(12.0*t2)))))-(1.6*(((t2*((t1+1.0)-(12.0*t2)))*d_r_dV_DI_SI)+(((t2*(d_t1_dV_DI_SI-(12.0*d_t2_dV_DI_SI)))+(d_t2_dV_DI_SI*((t1+1.0)-(12.0*t2))))*r))));
          mig = (((t1/12.0)-(t2*((t1+0.2)-(12.0*t2))))-(1.6*((t2*((t1+1.0)-(12.0*t2)))*r)));

          d_mig_dV_GP_SI = ((mig>1.0e-40)?d_mig_dV_GP_SI:0.0);
          d_mig_dV_SI_BP = ((mig>1.0e-40)?d_mig_dV_SI_BP:0.0);
          d_mig_dV_DI_SI = ((mig>1.0e-40)?d_mig_dV_DI_SI:0.0);
          mig = ((mig>1.0e-40)?mig:1.0e-40);

          d_mig_dV_GP_SI = (((lcinv2/g_ideal)*d_mig_dV_GP_SI)+(((g_ideal*d_lcinv2_dV_GP_SI-lcinv2*d_g_ideal_dV_GP_SI)/g_ideal/g_ideal)*mig));
          d_mig_dV_SI_BP = (((lcinv2/g_ideal)*d_mig_dV_SI_BP)+(((g_ideal*d_lcinv2_dV_SI_BP-lcinv2*d_g_ideal_dV_SI_BP)/g_ideal/g_ideal)*mig));
          d_mig_dV_DI_SI = (((lcinv2/g_ideal)*d_mig_dV_DI_SI)+(((g_ideal*d_lcinv2_dV_DI_SI-lcinv2*d_g_ideal_dV_DI_SI)/g_ideal/g_ideal)*mig));
          mig = ((lcinv2/g_ideal)*mig);

          d_migid_dV_GP_SI = (((lcinv2*sqt2)*((-(12.0*d_t2_dV_GP_SI))-((((t1+(19.2*t2))-(12.0*(t1*t2)))*d_r_dV_GP_SI)+(((d_t1_dV_GP_SI+(19.2*d_t2_dV_GP_SI))-(12.0*((t1*d_t2_dV_GP_SI)+(d_t1_dV_GP_SI*t2))))*r))))+(((lcinv2*d_sqt2_dV_GP_SI)+(d_lcinv2_dV_GP_SI*sqt2))*((1.0-(12.0*t2))-(((t1+(19.2*t2))-(12.0*(t1*t2)))*r))));
          d_migid_dV_SI_BP = (((lcinv2*sqt2)*((-(12.0*d_t2_dV_SI_BP))-((((t1+(19.2*t2))-(12.0*(t1*t2)))*d_r_dV_SI_BP)+(((d_t1_dV_SI_BP+(19.2*d_t2_dV_SI_BP))-(12.0*((t1*d_t2_dV_SI_BP)+(d_t1_dV_SI_BP*t2))))*r))))+(((lcinv2*d_sqt2_dV_SI_BP)+(d_lcinv2_dV_SI_BP*sqt2))*((1.0-(12.0*t2))-(((t1+(19.2*t2))-(12.0*(t1*t2)))*r))));
          d_migid_dV_DI_SI = (((lcinv2*sqt2)*((-(12.0*d_t2_dV_DI_SI))-((((t1+(19.2*t2))-(12.0*(t1*t2)))*d_r_dV_DI_SI)+(((d_t1_dV_DI_SI+(19.2*d_t2_dV_DI_SI))-(12.0*((t1*d_t2_dV_DI_SI)+(d_t1_dV_DI_SI*t2))))*r))))+(((lcinv2*d_sqt2_dV_DI_SI)+(d_lcinv2_dV_DI_SI*sqt2))*((1.0-(12.0*t2))-(((t1+(19.2*t2))-(12.0*(t1*t2)))*r))));
          migid = ((lcinv2*sqt2)*((1.0-(12.0*t2))-(((t1+(19.2*t2))-(12.0*(t1*t2)))*r)));

          d_CGeff_dV_SI_BP = (((Gmob_dL_ac*Gmob_dL_ac)*((((Gvsat_ac*Gvsat_ac)*COX_qm)*d_eta_p_ac_dV_SI_BP)+((((Gvsat_ac*Gvsat_ac)*d_COX_qm_dV_SI_BP)+(((Gvsat_ac*d_Gvsat_ac_dV_SI_BP)+(d_Gvsat_ac_dV_SI_BP*Gvsat_ac))*COX_qm))*eta_p_ac))-(((Gvsat_ac*Gvsat_ac)*COX_qm)*eta_p_ac)*((Gmob_dL_ac*d_Gmob_dL_ac_dV_SI_BP)+(d_Gmob_dL_ac_dV_SI_BP*Gmob_dL_ac)))/(Gmob_dL_ac*Gmob_dL_ac)/(Gmob_dL_ac*Gmob_dL_ac));
          d_CGeff_dV_GP_SI = (((Gmob_dL_ac*Gmob_dL_ac)*((((Gvsat_ac*Gvsat_ac)*COX_qm)*d_eta_p_ac_dV_GP_SI)+((((Gvsat_ac*Gvsat_ac)*d_COX_qm_dV_GP_SI)+(((Gvsat_ac*d_Gvsat_ac_dV_GP_SI)+(d_Gvsat_ac_dV_GP_SI*Gvsat_ac))*COX_qm))*eta_p_ac))-(((Gvsat_ac*Gvsat_ac)*COX_qm)*eta_p_ac)*((Gmob_dL_ac*d_Gmob_dL_ac_dV_GP_SI)+(d_Gmob_dL_ac_dV_GP_SI*Gmob_dL_ac)))/(Gmob_dL_ac*Gmob_dL_ac)/(Gmob_dL_ac*Gmob_dL_ac));
          d_CGeff_dV_DI_SI = (((Gmob_dL_ac*Gmob_dL_ac)*((((Gvsat_ac*Gvsat_ac)*COX_qm)*d_eta_p_ac_dV_DI_SI)+((((Gvsat_ac*Gvsat_ac)*d_COX_qm_dV_DI_SI)+(((Gvsat_ac*d_Gvsat_ac_dV_DI_SI)+(d_Gvsat_ac_dV_DI_SI*Gvsat_ac))*COX_qm))*eta_p_ac))-(((Gvsat_ac*Gvsat_ac)*COX_qm)*eta_p_ac)*((Gmob_dL_ac*d_Gmob_dL_ac_dV_DI_SI)+(d_Gmob_dL_ac_dV_DI_SI*Gmob_dL_ac)))/(Gmob_dL_ac*Gmob_dL_ac)/(Gmob_dL_ac*Gmob_dL_ac));
          CGeff = ((((Gvsat_ac*Gvsat_ac)*COX_qm)*eta_p_ac)/(Gmob_dL_ac*Gmob_dL_ac));
          if ((FNTEXC_i>0.0))
          {

            d_mig_dV_GP_SI = (d_mig_dV_GP_SI+(((((12.0*g_ideal)*g_ideal)*(model_.nt0))*((Sidexc*(12.0*d_t2_dV_GP_SI))+(d_Sidexc_dV_GP_SI*(1.0+(12.0*t2))))-(Sidexc*(1.0+(12.0*t2)))*((((12.0*g_ideal)*d_g_ideal_dV_GP_SI)+((12.0*d_g_ideal_dV_GP_SI)*g_ideal))*(model_.nt0)))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))));
            d_mig_dV_SI_BP = (d_mig_dV_SI_BP+(((((12.0*g_ideal)*g_ideal)*(model_.nt0))*((Sidexc*(12.0*d_t2_dV_SI_BP))+(d_Sidexc_dV_SI_BP*(1.0+(12.0*t2))))-(Sidexc*(1.0+(12.0*t2)))*((((12.0*g_ideal)*d_g_ideal_dV_SI_BP)+((12.0*d_g_ideal_dV_SI_BP)*g_ideal))*(model_.nt0)))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))));
            d_mig_dV_DI_SI = (d_mig_dV_DI_SI+(((((12.0*g_ideal)*g_ideal)*(model_.nt0))*((Sidexc*(12.0*d_t2_dV_DI_SI))+(d_Sidexc_dV_DI_SI*(1.0+(12.0*t2))))-(Sidexc*(1.0+(12.0*t2)))*((((12.0*g_ideal)*d_g_ideal_dV_DI_SI)+((12.0*d_g_ideal_dV_DI_SI)*g_ideal))*(model_.nt0)))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))));
            mig = (mig+((Sidexc*(1.0+(12.0*t2)))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))));

            d_migid_dV_GP_SI = (d_migid_dV_GP_SI-(((g_ideal*(model_.nt0))*(((Sidexc*sqt2)*d_r_dV_GP_SI)+(((Sidexc*d_sqt2_dV_GP_SI)+(d_Sidexc_dV_GP_SI*sqt2))*(1.0+r)))-((Sidexc*sqt2)*(1.0+r))*(d_g_ideal_dV_GP_SI*(model_.nt0)))/(g_ideal*(model_.nt0))/(g_ideal*(model_.nt0))));
            d_migid_dV_SI_BP = (d_migid_dV_SI_BP-(((g_ideal*(model_.nt0))*(((Sidexc*sqt2)*d_r_dV_SI_BP)+(((Sidexc*d_sqt2_dV_SI_BP)+(d_Sidexc_dV_SI_BP*sqt2))*(1.0+r)))-((Sidexc*sqt2)*(1.0+r))*(d_g_ideal_dV_SI_BP*(model_.nt0)))/(g_ideal*(model_.nt0))/(g_ideal*(model_.nt0))));
            d_migid_dV_DI_SI = (d_migid_dV_DI_SI-(((g_ideal*(model_.nt0))*(((Sidexc*sqt2)*d_r_dV_DI_SI)+(((Sidexc*d_sqt2_dV_DI_SI)+(d_Sidexc_dV_DI_SI*sqt2))*(1.0+r)))-((Sidexc*sqt2)*(1.0+r))*(d_g_ideal_dV_DI_SI*(model_.nt0)))/(g_ideal*(model_.nt0))/(g_ideal*(model_.nt0))));
            migid = (migid-(((Sidexc*sqt2)*(1.0+r))/(g_ideal*(model_.nt0))));
          }
          {
            double value_sqrt_0 = sqrt((nt/mig));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_sqig_dV_GP_SI = (deriv_sqrt_0_d0*((-nt*d_mig_dV_GP_SI/mig/mig)));
            d_sqig_dV_SI_BP = (deriv_sqrt_0_d0*((-nt*d_mig_dV_SI_BP/mig/mig)));
            d_sqig_dV_DI_SI = (deriv_sqrt_0_d0*((-nt*d_mig_dV_DI_SI/mig/mig)));
            sqig = value_sqrt_0;
          }
          if ((sqid==0))
          {

            d_c_igid_dV_DI_SI = d_c_igid_dV_SI_BP = d_c_igid_dV_GP_SI =  0.0;
            c_igid = 0.0;
          }
          else
          {

            d_c_igid_dV_GP_SI = ((sqid*((migid*d_sqig_dV_GP_SI)+(d_migid_dV_GP_SI*sqig))-(migid*sqig)*d_sqid_dV_GP_SI)/sqid/sqid);
            d_c_igid_dV_SI_BP = ((sqid*((migid*d_sqig_dV_SI_BP)+(d_migid_dV_SI_BP*sqig))-(migid*sqig)*d_sqid_dV_SI_BP)/sqid/sqid);
            d_c_igid_dV_DI_SI = ((sqid*((migid*d_sqig_dV_DI_SI)+(d_migid_dV_DI_SI*sqig))-(migid*sqig)*d_sqid_dV_DI_SI)/sqid/sqid);
            c_igid = ((migid*sqig)/sqid);
          }

          d_c_igid_dV_GP_SI = ((c_igid>0.0)?((c_igid<1.0)?d_c_igid_dV_GP_SI:0.0):0.0);
          d_c_igid_dV_SI_BP = ((c_igid>0.0)?((c_igid<1.0)?d_c_igid_dV_SI_BP:0.0):0.0);
          d_c_igid_dV_DI_SI = ((c_igid>0.0)?((c_igid<1.0)?d_c_igid_dV_DI_SI:0.0):0.0);
          c_igid = ((c_igid>0.0)?((c_igid<1.0)?c_igid:1.0):0.0);
        }
      }
      {
        double value_fabs_0 = fabs(Igcs);
        double  deriv_fabs_0_d0 = (((Igcs)>=0)?(+1.0):(-1.0));

        d_shot_igcsx_dV_SI_BP = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igcs_dV_SI_BP)));
        d_shot_igcsx_dV_DI_SI = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igcs_dV_DI_SI)));
        d_shot_igcsx_dV_GP_SI = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igcs_dV_GP_SI)));
        shot_igcsx = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        double value_fabs_0 = fabs(Igcd);
        double  deriv_fabs_0_d0 = (((Igcd)>=0)?(+1.0):(-1.0));

        d_shot_igcdx_dV_SI_BP = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igcd_dV_SI_BP)));
        d_shot_igcdx_dV_DI_SI = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igcd_dV_DI_SI)));
        d_shot_igcdx_dV_GP_SI = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igcd_dV_GP_SI)));
        shot_igcdx = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        double value_fabs_0 = fabs(Igsov);
        double  deriv_fabs_0_d0 = (((Igsov)>=0)?(+1.0):(-1.0));

        d_shot_igsov_dV_SI_BP = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igsov_dV_SI_BP)));
        d_shot_igsov_dV_DI_SI = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igsov_dV_DI_SI)));
        d_shot_igsov_dV_GP_SI = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igsov_dV_GP_SI)));
        shot_igsov = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        double value_fabs_0 = fabs(Igdov);
        double  deriv_fabs_0_d0 = (((Igdov)>=0)?(+1.0):(-1.0));

        d_shot_igdov_dV_SI_BP = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igdov_dV_SI_BP)));
        d_shot_igdov_dV_DI_SI = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igdov_dV_DI_SI)));
        d_shot_igdov_dV_GP_SI = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_Igdov_dV_GP_SI)));
        shot_igdov = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        double value_fabs_0 = fabs(Iimpact);
        double  deriv_fabs_0_d0 = (((Iimpact)>=0)?(+1.0):(-1.0));

        d_shot_iavl_dV_SI_BP = ((2.0*1.6021918E-19)*(((mavl+1)*(deriv_fabs_0_d0*(d_Iimpact_dV_SI_BP)))+(d_mavl_dV_SI_BP*value_fabs_0)));
        d_shot_iavl_dV_GP_SI = ((2.0*1.6021918E-19)*(((mavl+1)*(deriv_fabs_0_d0*(d_Iimpact_dV_GP_SI)))+(d_mavl_dV_GP_SI*value_fabs_0)));
        d_shot_iavl_dV_DI_SI = ((2.0*1.6021918E-19)*(((mavl+1)*(deriv_fabs_0_d0*(d_Iimpact_dV_DI_SI)))+(d_mavl_dV_DI_SI*value_fabs_0)));
        shot_iavl = ((2.0*1.6021918E-19)*((mavl+1)*value_fabs_0));
      }
      {
        double value_fabs_0 = fabs(ijun_s);
        double  deriv_fabs_0_d0 = (((ijun_s)>=0)?(+1.0):(-1.0));

        d_jnoisex_s_dV_SI_BS = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_ijun_s_dV_SI_BS)));
        d_jnoisex_s_dV_DI_BD = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_ijun_s_dV_DI_BD)));
        jnoisex_s = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        double value_fabs_0 = fabs(ijun_d);
        double  deriv_fabs_0_d0 = (((ijun_d)>=0)?(+1.0):(-1.0));

        d_jnoisex_d_dV_SI_BS = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_ijun_d_dV_SI_BS)));
        d_jnoisex_d_dV_DI_BD = ((2.0*1.6021918E-19)*(deriv_fabs_0_d0*(d_ijun_d_dV_DI_BD)));
        jnoisex_d = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      if ((sigVds>0.0))
      {

        d_shot_igs_dV_SI_BP = (d_shot_igcsx_dV_SI_BP+d_shot_igsov_dV_SI_BP);
        d_shot_igs_dV_DI_SI = (d_shot_igcsx_dV_DI_SI+d_shot_igsov_dV_DI_SI);
        d_shot_igs_dV_GP_SI = (d_shot_igcsx_dV_GP_SI+d_shot_igsov_dV_GP_SI);
        shot_igs = (shot_igcsx+shot_igsov);

        d_shot_igd_dV_SI_BP = (d_shot_igcdx_dV_SI_BP+d_shot_igdov_dV_SI_BP);
        d_shot_igd_dV_DI_SI = (d_shot_igcdx_dV_DI_SI+d_shot_igdov_dV_DI_SI);
        d_shot_igd_dV_GP_SI = (d_shot_igcdx_dV_GP_SI+d_shot_igdov_dV_GP_SI);
        shot_igd = (shot_igcdx+shot_igdov);

        d_jnoise_s_dV_DI_SI = d_jnoise_s_dV_GP_SI = d_jnoise_s_dV_SI_BP =  0.0;
        d_jnoise_s_dV_SI_BS = d_jnoisex_s_dV_SI_BS;
        d_jnoise_s_dV_DI_BD = d_jnoisex_s_dV_DI_BD;
        jnoise_s = jnoisex_s;

        d_jnoise_d_dV_SI_BP = d_shot_iavl_dV_SI_BP;
        d_jnoise_d_dV_GP_SI = d_shot_iavl_dV_GP_SI;
        d_jnoise_d_dV_DI_SI = d_shot_iavl_dV_DI_SI;
        d_jnoise_d_dV_SI_BS = d_jnoisex_d_dV_SI_BS;
        d_jnoise_d_dV_DI_BD = d_jnoisex_d_dV_DI_BD;
        jnoise_d = (jnoisex_d+shot_iavl);
      }
      else
      {

        d_shot_igs_dV_SI_BP = (d_shot_igcdx_dV_SI_BP+d_shot_igsov_dV_SI_BP);
        d_shot_igs_dV_DI_SI = (d_shot_igcdx_dV_DI_SI+d_shot_igsov_dV_DI_SI);
        d_shot_igs_dV_GP_SI = (d_shot_igcdx_dV_GP_SI+d_shot_igsov_dV_GP_SI);
        shot_igs = (shot_igcdx+shot_igsov);

        d_shot_igd_dV_SI_BP = (d_shot_igcsx_dV_SI_BP+d_shot_igdov_dV_SI_BP);
        d_shot_igd_dV_DI_SI = (d_shot_igcsx_dV_DI_SI+d_shot_igdov_dV_DI_SI);
        d_shot_igd_dV_GP_SI = (d_shot_igcsx_dV_GP_SI+d_shot_igdov_dV_GP_SI);
        shot_igd = (shot_igcsx+shot_igdov);

        d_jnoise_s_dV_SI_BP = d_shot_iavl_dV_SI_BP;
        d_jnoise_s_dV_GP_SI = d_shot_iavl_dV_GP_SI;
        d_jnoise_s_dV_DI_SI = d_shot_iavl_dV_DI_SI;
        d_jnoise_s_dV_SI_BS = d_jnoisex_s_dV_SI_BS;
        d_jnoise_s_dV_DI_BD = d_jnoisex_s_dV_DI_BD;
        jnoise_s = (jnoisex_s+shot_iavl);

        d_jnoise_d_dV_DI_SI = d_jnoise_d_dV_GP_SI = d_jnoise_d_dV_SI_BP =  0.0;
        d_jnoise_d_dV_SI_BS = d_jnoisex_d_dV_SI_BS;
        d_jnoise_d_dV_DI_BD = d_jnoisex_d_dV_DI_BD;
        jnoise_d = jnoisex_d;
      }
      if (((((model_.SWEDGE_i)!=0.0)&&(BETNEDGE_i>0))&&(xgedge>0)))
      {

        d_temp1_dV_GP_SI = ((4.0*d_dsqredge_dV_GP_SI)/Gfedge2);
        d_temp1_dV_SI_BP = ((4.0*d_dsqredge_dV_SI_BP)/Gfedge2);
        d_temp1_dV_DI_SI = ((4.0*d_dsqredge_dV_DI_SI)/Gfedge2);
        temp1 = ((4.0*dsqredge)/Gfedge2);
        {
          double value_sqrt_0 = sqrt((temp1+1.0));
          double value_sqrt_1 = sqrt((temp1+1.1));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
          double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

          d_anoisedge_dV_SI_BP = (((value_sqrt_1-1.0)*(deriv_sqrt_0_d0*(d_temp1_dV_SI_BP))-value_sqrt_0*(deriv_sqrt_1_d0*(d_temp1_dV_SI_BP)))/(value_sqrt_1-1.0)/(value_sqrt_1-1.0));
          d_anoisedge_dV_DI_SI = (((value_sqrt_1-1.0)*(deriv_sqrt_0_d0*(d_temp1_dV_DI_SI))-value_sqrt_0*(deriv_sqrt_1_d0*(d_temp1_dV_DI_SI)))/(value_sqrt_1-1.0)/(value_sqrt_1-1.0));
          d_anoisedge_dV_GP_SI = (((value_sqrt_1-1.0)*(deriv_sqrt_0_d0*(d_temp1_dV_GP_SI))-value_sqrt_0*(deriv_sqrt_1_d0*(d_temp1_dV_GP_SI)))/(value_sqrt_1-1.0)/(value_sqrt_1-1.0));
          anoisedge = (value_sqrt_0/(value_sqrt_1-1.0));
        }

        d_temp1_dV_GP_SI = d_temp1_dV_DI_SI = d_temp1_dV_SI_BP =  0.0;
        temp1 = (Cox_over_q*(model_.phit));

        d_N1edge_dV_SI_BP = ((temp1*d_anoisedge_dV_SI_BP)+(d_temp1_dV_SI_BP*anoisedge));
        d_N1edge_dV_DI_SI = ((temp1*d_anoisedge_dV_DI_SI)+(d_temp1_dV_DI_SI*anoisedge));
        d_N1edge_dV_GP_SI = ((temp1*d_anoisedge_dV_GP_SI)+(d_temp1_dV_GP_SI*anoisedge));
        N1edge = (temp1*anoisedge);

        d_Nm1edge_dV_SI_BP = ((temp1*(d_qmeffedge_dV_SI_BP+d_anoisedge_dV_SI_BP))+(d_temp1_dV_SI_BP*(qmeffedge+anoisedge)));
        d_Nm1edge_dV_DI_SI = ((temp1*(d_qmeffedge_dV_DI_SI+d_anoisedge_dV_DI_SI))+(d_temp1_dV_DI_SI*(qmeffedge+anoisedge)));
        d_Nm1edge_dV_GP_SI = ((temp1*(d_qmeffedge_dV_GP_SI+d_anoisedge_dV_GP_SI))+(d_temp1_dV_GP_SI*(qmeffedge+anoisedge)));
        Nm1edge = (temp1*(qmeffedge+anoisedge));

        d_Delta_N1edge_dV_SI_BP = (((((-temp1)*anoisedge)*alphabmedge)*d_qdseffedge_dV_SI_BP)+(((((-temp1)*anoisedge)*d_alphabmedge_dV_SI_BP)+((((-temp1)*d_anoisedge_dV_SI_BP)+((-d_temp1_dV_SI_BP)*anoisedge))*alphabmedge))*qdseffedge));
        d_Delta_N1edge_dV_DI_SI = (((((-temp1)*anoisedge)*alphabmedge)*d_qdseffedge_dV_DI_SI)+(((((-temp1)*anoisedge)*d_alphabmedge_dV_DI_SI)+((((-temp1)*d_anoisedge_dV_DI_SI)+((-d_temp1_dV_DI_SI)*anoisedge))*alphabmedge))*qdseffedge));
        d_Delta_N1edge_dV_GP_SI = (((((-temp1)*anoisedge)*alphabmedge)*d_qdseffedge_dV_GP_SI)+(((((-temp1)*anoisedge)*d_alphabmedge_dV_GP_SI)+((((-temp1)*d_anoisedge_dV_GP_SI)+((-d_temp1_dV_GP_SI)*anoisedge))*alphabmedge))*qdseffedge));
        Delta_N1edge = ((((-temp1)*anoisedge)*alphabmedge)*qdseffedge);
        {
          double value_log_0 = log(((Nm1edge+(0.5*Delta_N1edge))/(Nm1edge-(0.5*Delta_N1edge))));
          double  deriv_log_0_d0 = (1.0/((Nm1edge+(0.5*Delta_N1edge))/(Nm1edge-(0.5*Delta_N1edge))));

          d_Sfledge_dV_SI_BP = (((NFAEDGE_i-((NFBEDGE_i-(NFCEDGE_i*N1edge))*N1edge))*(deriv_log_0_d0*((((Nm1edge-(0.5*Delta_N1edge))*(d_Nm1edge_dV_SI_BP+(0.5*d_Delta_N1edge_dV_SI_BP))-(Nm1edge+(0.5*Delta_N1edge))*(d_Nm1edge_dV_SI_BP-(0.5*d_Delta_N1edge_dV_SI_BP)))/(Nm1edge-(0.5*Delta_N1edge))/(Nm1edge-(0.5*Delta_N1edge))))))+((-(((NFBEDGE_i-(NFCEDGE_i*N1edge))*d_N1edge_dV_SI_BP)+((-(NFCEDGE_i*d_N1edge_dV_SI_BP))*N1edge)))*value_log_0));
          d_Sfledge_dV_DI_SI = (((NFAEDGE_i-((NFBEDGE_i-(NFCEDGE_i*N1edge))*N1edge))*(deriv_log_0_d0*((((Nm1edge-(0.5*Delta_N1edge))*(d_Nm1edge_dV_DI_SI+(0.5*d_Delta_N1edge_dV_DI_SI))-(Nm1edge+(0.5*Delta_N1edge))*(d_Nm1edge_dV_DI_SI-(0.5*d_Delta_N1edge_dV_DI_SI)))/(Nm1edge-(0.5*Delta_N1edge))/(Nm1edge-(0.5*Delta_N1edge))))))+((-(((NFBEDGE_i-(NFCEDGE_i*N1edge))*d_N1edge_dV_DI_SI)+((-(NFCEDGE_i*d_N1edge_dV_DI_SI))*N1edge)))*value_log_0));
          d_Sfledge_dV_GP_SI = (((NFAEDGE_i-((NFBEDGE_i-(NFCEDGE_i*N1edge))*N1edge))*(deriv_log_0_d0*((((Nm1edge-(0.5*Delta_N1edge))*(d_Nm1edge_dV_GP_SI+(0.5*d_Delta_N1edge_dV_GP_SI))-(Nm1edge+(0.5*Delta_N1edge))*(d_Nm1edge_dV_GP_SI-(0.5*d_Delta_N1edge_dV_GP_SI)))/(Nm1edge-(0.5*Delta_N1edge))/(Nm1edge-(0.5*Delta_N1edge))))))+((-(((NFBEDGE_i-(NFCEDGE_i*N1edge))*d_N1edge_dV_GP_SI)+((-(NFCEDGE_i*d_N1edge_dV_GP_SI))*N1edge)))*value_log_0));
          Sfledge = ((NFAEDGE_i-((NFBEDGE_i-(NFCEDGE_i*N1edge))*N1edge))*value_log_0);
        }

        d_Sfledge_dV_SI_BP = (d_Sfledge_dV_SI_BP+(((NFBEDGE_i+(NFCEDGE_i*(Nm1edge-(2.0*N1edge))))*d_Delta_N1edge_dV_SI_BP)+((NFCEDGE_i*(d_Nm1edge_dV_SI_BP-(2.0*d_N1edge_dV_SI_BP)))*Delta_N1edge)));
        d_Sfledge_dV_DI_SI = (d_Sfledge_dV_DI_SI+(((NFBEDGE_i+(NFCEDGE_i*(Nm1edge-(2.0*N1edge))))*d_Delta_N1edge_dV_DI_SI)+((NFCEDGE_i*(d_Nm1edge_dV_DI_SI-(2.0*d_N1edge_dV_DI_SI)))*Delta_N1edge)));
        d_Sfledge_dV_GP_SI = (d_Sfledge_dV_GP_SI+(((NFBEDGE_i+(NFCEDGE_i*(Nm1edge-(2.0*N1edge))))*d_Delta_N1edge_dV_GP_SI)+((NFCEDGE_i*(d_Nm1edge_dV_GP_SI-(2.0*d_N1edge_dV_GP_SI)))*Delta_N1edge)));
        Sfledge = (Sfledge+((NFBEDGE_i+(NFCEDGE_i*(Nm1edge-(2.0*N1edge))))*Delta_N1edge));

        d_Sfledge_dV_GP_SI = ((N1edge*((((Sfl_prefac_edge*Idsedge)*Gvsatinv_dc)*d_Sfledge_dV_GP_SI)+((((Sfl_prefac_edge*Idsedge)*d_Gvsatinv_dc_dV_GP_SI)+((Sfl_prefac_edge*d_Idsedge_dV_GP_SI)*Gvsatinv_dc))*Sfledge))-(((Sfl_prefac_edge*Idsedge)*Gvsatinv_dc)*Sfledge)*d_N1edge_dV_GP_SI)/N1edge/N1edge);
        d_Sfledge_dV_SI_BP = ((N1edge*((((Sfl_prefac_edge*Idsedge)*Gvsatinv_dc)*d_Sfledge_dV_SI_BP)+((((Sfl_prefac_edge*Idsedge)*d_Gvsatinv_dc_dV_SI_BP)+((Sfl_prefac_edge*d_Idsedge_dV_SI_BP)*Gvsatinv_dc))*Sfledge))-(((Sfl_prefac_edge*Idsedge)*Gvsatinv_dc)*Sfledge)*d_N1edge_dV_SI_BP)/N1edge/N1edge);
        d_Sfledge_dV_DI_SI = ((N1edge*((((Sfl_prefac_edge*Idsedge)*Gvsatinv_dc)*d_Sfledge_dV_DI_SI)+((((Sfl_prefac_edge*Idsedge)*d_Gvsatinv_dc_dV_DI_SI)+((Sfl_prefac_edge*d_Idsedge_dV_DI_SI)*Gvsatinv_dc))*Sfledge))-(((Sfl_prefac_edge*Idsedge)*Gvsatinv_dc)*Sfledge)*d_N1edge_dV_DI_SI)/N1edge/N1edge);
        Sfledge = ((((Sfl_prefac_edge*Idsedge)*Gvsatinv_dc)*Sfledge)/N1edge);

        d_Sfledge_dV_SI_BP = ((Sfledge>0.0)?d_Sfledge_dV_SI_BP:0.0);
        d_Sfledge_dV_DI_SI = ((Sfledge>0.0)?d_Sfledge_dV_DI_SI:0.0);
        d_Sfledge_dV_GP_SI = ((Sfledge>0.0)?d_Sfledge_dV_GP_SI:0.0);
        Sfledge = ((Sfledge>0.0)?Sfledge:0.0);

        d_H0edge_dV_GP_SI = ((anoisedge*((model_.phit)*(d_qmeffedge_dV_GP_SI+d_anoisedge_dV_GP_SI))-((model_.phit)*(qmeffedge+anoisedge))*d_anoisedge_dV_GP_SI)/anoisedge/anoisedge);
        d_H0edge_dV_SI_BP = ((anoisedge*((model_.phit)*(d_qmeffedge_dV_SI_BP+d_anoisedge_dV_SI_BP))-((model_.phit)*(qmeffedge+anoisedge))*d_anoisedge_dV_SI_BP)/anoisedge/anoisedge);
        d_H0edge_dV_DI_SI = ((anoisedge*((model_.phit)*(d_qmeffedge_dV_DI_SI+d_anoisedge_dV_DI_SI))-((model_.phit)*(qmeffedge+anoisedge))*d_anoisedge_dV_DI_SI)/anoisedge/anoisedge);
        H0edge = (((model_.phit)*(qmeffedge+anoisedge))/anoisedge);

        d_t1edge_dV_SI_BP = (((qmeffedge+anoisedge)*(((phit1/(model_.phit))*d_qmeffedge_dV_SI_BP)+((d_phit1_dV_SI_BP/(model_.phit))*qmeffedge))-((phit1/(model_.phit))*qmeffedge)*(d_qmeffedge_dV_SI_BP+d_anoisedge_dV_SI_BP))/(qmeffedge+anoisedge)/(qmeffedge+anoisedge));
        d_t1edge_dV_DI_SI = (((qmeffedge+anoisedge)*(((phit1/(model_.phit))*d_qmeffedge_dV_DI_SI)+((d_phit1_dV_DI_SI/(model_.phit))*qmeffedge))-((phit1/(model_.phit))*qmeffedge)*(d_qmeffedge_dV_DI_SI+d_anoisedge_dV_DI_SI))/(qmeffedge+anoisedge)/(qmeffedge+anoisedge));
        d_t1edge_dV_GP_SI = (((qmeffedge+anoisedge)*(((phit1/(model_.phit))*d_qmeffedge_dV_GP_SI)+((d_phit1_dV_GP_SI/(model_.phit))*qmeffedge))-((phit1/(model_.phit))*qmeffedge)*(d_qmeffedge_dV_GP_SI+d_anoisedge_dV_GP_SI))/(qmeffedge+anoisedge)/(qmeffedge+anoisedge));
        t1edge = (((phit1/(model_.phit))*qmeffedge)/(qmeffedge+anoisedge));

        d_sqt2edge_dV_GP_SI = ((H0edge*((((((-0.5)*1.6666666666666667e-01)*(model_.phit))*alphabmedge)*d_qdseffedge_dV_GP_SI)+(((((-0.5)*1.6666666666666667e-01)*(model_.phit))*d_alphabmedge_dV_GP_SI)*qdseffedge))-(((((-0.5)*1.6666666666666667e-01)*(model_.phit))*alphabmedge)*qdseffedge)*d_H0edge_dV_GP_SI)/H0edge/H0edge);
        d_sqt2edge_dV_SI_BP = ((H0edge*((((((-0.5)*1.6666666666666667e-01)*(model_.phit))*alphabmedge)*d_qdseffedge_dV_SI_BP)+(((((-0.5)*1.6666666666666667e-01)*(model_.phit))*d_alphabmedge_dV_SI_BP)*qdseffedge))-(((((-0.5)*1.6666666666666667e-01)*(model_.phit))*alphabmedge)*qdseffedge)*d_H0edge_dV_SI_BP)/H0edge/H0edge);
        d_sqt2edge_dV_DI_SI = ((H0edge*((((((-0.5)*1.6666666666666667e-01)*(model_.phit))*alphabmedge)*d_qdseffedge_dV_DI_SI)+(((((-0.5)*1.6666666666666667e-01)*(model_.phit))*d_alphabmedge_dV_DI_SI)*qdseffedge))-(((((-0.5)*1.6666666666666667e-01)*(model_.phit))*alphabmedge)*qdseffedge)*d_H0edge_dV_DI_SI)/H0edge/H0edge);
        sqt2edge = ((((((-0.5)*1.6666666666666667e-01)*(model_.phit))*alphabmedge)*qdseffedge)/H0edge);

        d_t2edge_dV_GP_SI = ((sqt2edge*d_sqt2edge_dV_GP_SI)+(d_sqt2edge_dV_GP_SI*sqt2edge));
        d_t2edge_dV_SI_BP = ((sqt2edge*d_sqt2edge_dV_SI_BP)+(d_sqt2edge_dV_SI_BP*sqt2edge));
        d_t2edge_dV_DI_SI = ((sqt2edge*d_sqt2edge_dV_DI_SI)+(d_sqt2edge_dV_DI_SI*sqt2edge));
        t2edge = (sqt2edge*sqt2edge);

        d_redge_dV_SI_BP = ((H_dc*(((anoisedge/alpha_dc)*d_H0edge_dV_SI_BP)+(((alpha_dc*d_anoisedge_dV_SI_BP-anoisedge*d_alpha_dc_dV_SI_BP)/alpha_dc/alpha_dc)*H0edge))-((anoisedge/alpha_dc)*H0edge)*d_H_dc_dV_SI_BP)/H_dc/H_dc);
        d_redge_dV_DI_SI = ((H_dc*(((anoisedge/alpha_dc)*d_H0edge_dV_DI_SI)+(((alpha_dc*d_anoisedge_dV_DI_SI-anoisedge*d_alpha_dc_dV_DI_SI)/alpha_dc/alpha_dc)*H0edge))-((anoisedge/alpha_dc)*H0edge)*d_H_dc_dV_DI_SI)/H_dc/H_dc);
        d_redge_dV_GP_SI = ((H_dc*(((anoisedge/alpha_dc)*d_H0edge_dV_GP_SI)+(((alpha_dc*d_anoisedge_dV_GP_SI-anoisedge*d_alpha_dc_dV_GP_SI)/alpha_dc/alpha_dc)*H0edge))-((anoisedge/alpha_dc)*H0edge)*d_H_dc_dV_GP_SI)/H_dc/H_dc);
        redge = ((((anoisedge/alpha_dc)*H0edge)/H_dc)-1.0);

        d_lcedge_dV_SI_BP = (((1.0-(12.0*(redge*t2edge)))>1.0e-20)?(-(12.0*((redge*d_t2edge_dV_SI_BP)+(d_redge_dV_SI_BP*t2edge)))):0.0);
        d_lcedge_dV_DI_SI = (((1.0-(12.0*(redge*t2edge)))>1.0e-20)?(-(12.0*((redge*d_t2edge_dV_DI_SI)+(d_redge_dV_DI_SI*t2edge)))):0.0);
        d_lcedge_dV_GP_SI = (((1.0-(12.0*(redge*t2edge)))>1.0e-20)?(-(12.0*((redge*d_t2edge_dV_GP_SI)+(d_redge_dV_GP_SI*t2edge)))):0.0);
        lcedge = (((1.0-(12.0*(redge*t2edge)))>1.0e-20)?(1.0-(12.0*(redge*t2edge))):1.0e-20);

        d_lcinv2edge_dV_SI_BP = (-((lcedge*d_lcedge_dV_SI_BP)+(d_lcedge_dV_SI_BP*lcedge))/(lcedge*lcedge)/(lcedge*lcedge));
        d_lcinv2edge_dV_DI_SI = (-((lcedge*d_lcedge_dV_DI_SI)+(d_lcedge_dV_DI_SI*lcedge))/(lcedge*lcedge)/(lcedge*lcedge));
        d_lcinv2edge_dV_GP_SI = (-((lcedge*d_lcedge_dV_GP_SI)+(d_lcedge_dV_GP_SI*lcedge))/(lcedge*lcedge)/(lcedge*lcedge));
        lcinv2edge = (1.0/(lcedge*lcedge));

        d_g_idealedge_dV_GP_SI = (((((BETEDGE_i*(model_.phit))*(qmeffedge+anoisedge))*FdL_dc)*d_Gvsatinv_dc_dV_GP_SI)+(((((BETEDGE_i*(model_.phit))*(qmeffedge+anoisedge))*d_FdL_dc_dV_GP_SI)+(((BETEDGE_i*(model_.phit))*(d_qmeffedge_dV_GP_SI+d_anoisedge_dV_GP_SI))*FdL_dc))*Gvsatinv_dc));
        d_g_idealedge_dV_SI_BP = (((((BETEDGE_i*(model_.phit))*(qmeffedge+anoisedge))*FdL_dc)*d_Gvsatinv_dc_dV_SI_BP)+(((((BETEDGE_i*(model_.phit))*(qmeffedge+anoisedge))*d_FdL_dc_dV_SI_BP)+(((BETEDGE_i*(model_.phit))*(d_qmeffedge_dV_SI_BP+d_anoisedge_dV_SI_BP))*FdL_dc))*Gvsatinv_dc));
        d_g_idealedge_dV_DI_SI = (((((BETEDGE_i*(model_.phit))*(qmeffedge+anoisedge))*FdL_dc)*d_Gvsatinv_dc_dV_DI_SI)+(((((BETEDGE_i*(model_.phit))*(qmeffedge+anoisedge))*d_FdL_dc_dV_DI_SI)+(((BETEDGE_i*(model_.phit))*(d_qmeffedge_dV_DI_SI+d_anoisedge_dV_DI_SI))*FdL_dc))*Gvsatinv_dc));
        g_idealedge = ((((BETEDGE_i*(model_.phit))*(qmeffedge+anoisedge))*FdL_dc)*Gvsatinv_dc);

        d_midedge_dV_SI_BP = ((d_t1edge_dV_SI_BP+(12.0*d_t2edge_dV_SI_BP))-(24.0*((((1.0+t1edge)*t2edge)*d_redge_dV_SI_BP)+((((1.0+t1edge)*d_t2edge_dV_SI_BP)+(d_t1edge_dV_SI_BP*t2edge))*redge))));
        d_midedge_dV_DI_SI = ((d_t1edge_dV_DI_SI+(12.0*d_t2edge_dV_DI_SI))-(24.0*((((1.0+t1edge)*t2edge)*d_redge_dV_DI_SI)+((((1.0+t1edge)*d_t2edge_dV_DI_SI)+(d_t1edge_dV_DI_SI*t2edge))*redge))));
        d_midedge_dV_GP_SI = ((d_t1edge_dV_GP_SI+(12.0*d_t2edge_dV_GP_SI))-(24.0*((((1.0+t1edge)*t2edge)*d_redge_dV_GP_SI)+((((1.0+t1edge)*d_t2edge_dV_GP_SI)+(d_t1edge_dV_GP_SI*t2edge))*redge))));
        midedge = ((t1edge+(12.0*t2edge))-(24.0*(((1.0+t1edge)*t2edge)*redge)));

        d_midedge_dV_SI_BP = ((midedge>1.0e-40)?d_midedge_dV_SI_BP:0.0);
        d_midedge_dV_DI_SI = ((midedge>1.0e-40)?d_midedge_dV_DI_SI:0.0);
        d_midedge_dV_GP_SI = ((midedge>1.0e-40)?d_midedge_dV_GP_SI:0.0);
        midedge = ((midedge>1.0e-40)?midedge:1.0e-40);

        d_midedge_dV_GP_SI = (((g_idealedge*lcinv2edge)*d_midedge_dV_GP_SI)+(((g_idealedge*d_lcinv2edge_dV_GP_SI)+(d_g_idealedge_dV_GP_SI*lcinv2edge))*midedge));
        d_midedge_dV_SI_BP = (((g_idealedge*lcinv2edge)*d_midedge_dV_SI_BP)+(((g_idealedge*d_lcinv2edge_dV_SI_BP)+(d_g_idealedge_dV_SI_BP*lcinv2edge))*midedge));
        d_midedge_dV_DI_SI = (((g_idealedge*lcinv2edge)*d_midedge_dV_DI_SI)+(((g_idealedge*d_lcinv2edge_dV_DI_SI)+(d_g_idealedge_dV_DI_SI*lcinv2edge))*midedge));
        midedge = ((g_idealedge*lcinv2edge)*midedge);
        {
          double value_sqrt_0 = sqrt((ntedge*midedge));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_sqidedge_dV_SI_BP = (deriv_sqrt_0_d0*((ntedge*d_midedge_dV_SI_BP)));
          d_sqidedge_dV_DI_SI = (deriv_sqrt_0_d0*((ntedge*d_midedge_dV_DI_SI)));
          d_sqidedge_dV_GP_SI = (deriv_sqrt_0_d0*((ntedge*d_midedge_dV_GP_SI)));
          sqidedge = value_sqrt_0;
        }
      }

      d_sf_dV_SI_BP = (((1.0e+6*CGeff)*d_mig_dV_SI_BP)+((1.0e+6*d_CGeff_dV_SI_BP)*mig));
      d_sf_dV_GP_SI = (((1.0e+6*CGeff)*d_mig_dV_GP_SI)+((1.0e+6*d_CGeff_dV_GP_SI)*mig));
      d_sf_dV_DI_SI = (((1.0e+6*CGeff)*d_mig_dV_DI_SI)+((1.0e+6*d_CGeff_dV_DI_SI)*mig));
      sf = ((1.0e+6*CGeff)*mig);
      // I(NOI2,GND) <+ (V(NOI2,GND))
      staticContributions[admsNodeID_NOI2] += (probeVars[admsProbeID_V_NOI2_GND]);
      d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND] += d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND];
      // I(NOI2,GND) <+ (white_noise((((nt/mig)*sf)*sf),"igig"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[7]= (((nt/mig)*sf)*sf);
      }
      // I(NOI,GND) <+ (((-V(NOI2,GND))/sf))
      staticContributions[admsNodeID_NOI] += ((-(probeVars[admsProbeID_V_NOI2_GND]))/sf);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP] += (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_SI_BP/sf/sf);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] += (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_GP_SI/sf/sf);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] += (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_DI_SI/sf/sf);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND] += ((-d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND])/sf);
      // I(NOI,GND) <+ ((V(NOI,GND)/mig))
      staticContributions[admsNodeID_NOI] += ((probeVars[admsProbeID_V_NOI_GND])/mig);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] += (-(probeVars[admsProbeID_V_NOI_GND])*d_mig_dV_GP_SI/mig/mig);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP] += (-(probeVars[admsProbeID_V_NOI_GND])*d_mig_dV_SI_BP/mig/mig);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] += (-(probeVars[admsProbeID_V_NOI_GND])*d_mig_dV_DI_SI/mig/mig);
      d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] += (d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]/mig);
      // I(NOI,GND) <+ (ddt((CGeff*V(NOI,GND))))
      dynamicContributions[admsNodeID_NOI] += ((CGeff*(probeVars[admsProbeID_V_NOI_GND])));
      d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] += ((CGeff*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]));
      d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BP] += ((d_CGeff_dV_SI_BP*(probeVars[admsProbeID_V_NOI_GND])));
      d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] += ((d_CGeff_dV_GP_SI*(probeVars[admsProbeID_V_NOI_GND])));
      d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] += ((d_CGeff_dV_DI_SI*(probeVars[admsProbeID_V_NOI_GND])));
      // I(GP,SI) <+ ((-ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND)))))
      {
        double value_sqrt_0 = sqrt(MULT_i);
        dynamicContributions[admsNodeID_GP] += (-((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND]))));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] += (-((((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += (-((((value_sqrt_0*0.5)*d_CGeff_dV_SI_BP)*(probeVars[admsProbeID_V_NOI_GND]))));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (-((((value_sqrt_0*0.5)*d_CGeff_dV_GP_SI)*(probeVars[admsProbeID_V_NOI_GND]))));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (-((((value_sqrt_0*0.5)*d_CGeff_dV_DI_SI)*(probeVars[admsProbeID_V_NOI_GND]))));
        dynamicContributions[admsNodeID_SI] -= (-((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND]))));
        d_dynamicContributions[admsNodeID_SI][admsProbeID_V_NOI_GND] -= (-((((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= (-((((value_sqrt_0*0.5)*d_CGeff_dV_SI_BP)*(probeVars[admsProbeID_V_NOI_GND]))));
        d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= (-((((value_sqrt_0*0.5)*d_CGeff_dV_GP_SI)*(probeVars[admsProbeID_V_NOI_GND]))));
        d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= (-((((value_sqrt_0*0.5)*d_CGeff_dV_DI_SI)*(probeVars[admsProbeID_V_NOI_GND]))));
      }
      // I(GP,DI) <+ ((-ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND)))))
      {
        double value_sqrt_0 = sqrt(MULT_i);
        dynamicContributions[admsNodeID_GP] += (-((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND]))));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] += (-((((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += (-((((value_sqrt_0*0.5)*d_CGeff_dV_SI_BP)*(probeVars[admsProbeID_V_NOI_GND]))));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (-((((value_sqrt_0*0.5)*d_CGeff_dV_GP_SI)*(probeVars[admsProbeID_V_NOI_GND]))));
        d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (-((((value_sqrt_0*0.5)*d_CGeff_dV_DI_SI)*(probeVars[admsProbeID_V_NOI_GND]))));
        dynamicContributions[admsNodeID_DI] -= (-((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND]))));
        d_dynamicContributions[admsNodeID_DI][admsProbeID_V_NOI_GND] -= (-((((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND])));
        d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP] -= (-((((value_sqrt_0*0.5)*d_CGeff_dV_SI_BP)*(probeVars[admsProbeID_V_NOI_GND]))));
        d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI] -= (-((((value_sqrt_0*0.5)*d_CGeff_dV_GP_SI)*(probeVars[admsProbeID_V_NOI_GND]))));
        d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -= (-((((value_sqrt_0*0.5)*d_CGeff_dV_DI_SI)*(probeVars[admsProbeID_V_NOI_GND]))));
      }
      // I(DI,SI) <+ (((((sigVds*sqrt(MULT_i))*migid)*V(NOI2,GND))/sf))
      {
        double value_sqrt_0 = sqrt(MULT_i);
        staticContributions[admsNodeID_DI] += ((((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))/sf);
        d_staticContributions[admsNodeID_DI][admsProbeID_V_NOI2_GND] += ((((sigVds*value_sqrt_0)*migid)*d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND])/sf);
        d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] += ((sf*(((sigVds*value_sqrt_0)*d_migid_dV_GP_SI)*(probeVars[admsProbeID_V_NOI2_GND]))-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_GP_SI)/sf/sf);
        d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] += ((sf*(((sigVds*value_sqrt_0)*d_migid_dV_SI_BP)*(probeVars[admsProbeID_V_NOI2_GND]))-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_SI_BP)/sf/sf);
        d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] += ((sf*(((sigVds*value_sqrt_0)*d_migid_dV_DI_SI)*(probeVars[admsProbeID_V_NOI2_GND]))-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_DI_SI)/sf/sf);
        staticContributions[admsNodeID_SI] -= ((((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))/sf);
        d_staticContributions[admsNodeID_SI][admsProbeID_V_NOI2_GND] -= ((((sigVds*value_sqrt_0)*migid)*d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND])/sf);
        d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= ((sf*(((sigVds*value_sqrt_0)*d_migid_dV_GP_SI)*(probeVars[admsProbeID_V_NOI2_GND]))-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_GP_SI)/sf/sf);
        d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= ((sf*(((sigVds*value_sqrt_0)*d_migid_dV_SI_BP)*(probeVars[admsProbeID_V_NOI2_GND]))-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_SI_BP)/sf/sf);
        d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= ((sf*(((sigVds*value_sqrt_0)*d_migid_dV_DI_SI)*(probeVars[admsProbeID_V_NOI2_GND]))-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_DI_SI)/sf/sf);
      }
      // I(DI,SI) <+ (white_noise((((MULT_i*sqid)*sqid)*(1.0-(c_igid*c_igid))),"idid"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[8]= (((MULT_i*sqid)*sqid)*(1.0-(c_igid*c_igid)));
      }
      // I(DI,SI) <+ (flicker_noise((MULT_i*Sfl),EF_i,"flicker"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[9]= (MULT_i*Sfl);
        noiseContribsExponent[9]= EF_i;
      }
      // I(GP,SI) <+ (white_noise((MULT_i*shot_igs),"igs"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[10]= (MULT_i*shot_igs);
      }
      // I(GP,DI) <+ (white_noise((MULT_i*shot_igd),"igd"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[11]= (MULT_i*shot_igd);
      }
      // I(BS,SI) <+ (white_noise((MULT_i*jnoise_s),"ibs"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[12]= (MULT_i*jnoise_s);
      }
      // I(BD,DI) <+ (white_noise((MULT_i*jnoise_d),"ibd"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[13]= (MULT_i*jnoise_d);
      }
      // I(DI,SI) <+ (flicker_noise((MULT_i*Sfledge),EFEDGE_i,"flicker"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[14]= (MULT_i*Sfledge);
        noiseContribsExponent[14]= EFEDGE_i;
      }
      // I(DI,SI) <+ (white_noise(((MULT_i*sqidedge)*sqidedge),"ididedge"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[15]= ((MULT_i*sqidedge)*sqidedge);
      }
    }
    // End block noise
  }
  // End block evaluateblock


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_NOI_GND] =  "
                 <<probeVars[admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_NOI2_GND] =  "
                 <<probeVars[admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_B_BI] =  "
                 <<probeVars[admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BD_BI] =  "
                 <<probeVars[admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BS_BI] =  "
                 <<probeVars[admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BP_BI] =  "
                 <<probeVars[admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_D_DI] =  "
                 <<probeVars[admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_S_SI] =  "
                 <<probeVars[admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_G_GP] =  "
                 <<probeVars[admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_DI_BD] =  "
                 <<probeVars[admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_SI_BS] =  "
                 <<probeVars[admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_SI_BP] =  "
                 <<probeVars[admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_DI_SI] =  "
                 <<probeVars[admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_GP_SI] =  "
                 <<probeVars[admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_D] =  "
                 <<staticContributions[admsNodeID_D] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_D] =  "
                 <<dynamicContributions[admsNodeID_D] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_G] =  "
                 <<staticContributions[admsNodeID_G] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_G] =  "
                 <<dynamicContributions[admsNodeID_G] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_S] =  "
                 <<staticContributions[admsNodeID_S] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_S] =  "
                 <<dynamicContributions[admsNodeID_S] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_B] =  "
                 <<staticContributions[admsNodeID_B] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_B] =  "
                 <<dynamicContributions[admsNodeID_B] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_NOI] =  "
                 <<staticContributions[admsNodeID_NOI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_NOI] =  "
                 <<dynamicContributions[admsNodeID_NOI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_NOI2] =  "
                 <<staticContributions[admsNodeID_NOI2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_NOI2] =  "
                 <<dynamicContributions[admsNodeID_NOI2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_GP] =  "
                 <<staticContributions[admsNodeID_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_GP] =  "
                 <<dynamicContributions[admsNodeID_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_SI] =  "
                 <<staticContributions[admsNodeID_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_SI] =  "
                 <<dynamicContributions[admsNodeID_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_DI] =  "
                 <<staticContributions[admsNodeID_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_DI] =  "
                 <<dynamicContributions[admsNodeID_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BP] =  "
                 <<staticContributions[admsNodeID_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BP] =  "
                 <<dynamicContributions[admsNodeID_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BI] =  "
                 <<staticContributions[admsNodeID_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BI] =  "
                 <<dynamicContributions[admsNodeID_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BS] =  "
                 <<staticContributions[admsNodeID_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BS] =  "
                 <<dynamicContributions[admsNodeID_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BD] =  "
                 <<staticContributions[admsNodeID_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BD] =  "
                 <<dynamicContributions[admsNodeID_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_GP_SI] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 4 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 13; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 4 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode];
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode];
      }
    }
  }
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
  return 16;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
  int numSources=getNumNoiseSources();
  noiseData.numSources = numSources;
  noiseData.resize(numSources);

  noiseData.deviceName = getName().getEncodedName();
  std::string theNoiseName;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_G_GP")+std::string("_")+std::string("rgate");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[0]=theNoiseName;
  noiseData.li_Pos[0]=li_G;
  noiseData.li_Neg[0]=li_GP;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_S_SI")+std::string("_")+std::string("rsource");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[1]=theNoiseName;
  noiseData.li_Pos[1]=li_S;
  noiseData.li_Neg[1]=li_SI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_D_DI")+std::string("_")+std::string("rdrain");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[2]=theNoiseName;
  noiseData.li_Pos[2]=li_D;
  noiseData.li_Neg[2]=li_DI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BP_BI")+std::string("_")+std::string("rbulk");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[3]=theNoiseName;
  noiseData.li_Pos[3]=li_BP;
  noiseData.li_Neg[3]=li_BI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BS_BI")+std::string("_")+std::string("rjuns");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[4]=theNoiseName;
  noiseData.li_Pos[4]=li_BS;
  noiseData.li_Neg[4]=li_BI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BD_BI")+std::string("_")+std::string("rjund");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[5]=theNoiseName;
  noiseData.li_Pos[5]=li_BD;
  noiseData.li_Neg[5]=li_BI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_B_BI")+std::string("_")+std::string("rwell");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[6]=theNoiseName;
  noiseData.li_Pos[6]=li_B;
  noiseData.li_Neg[6]=li_BI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_NOI2_GND")+std::string("_")+std::string("igig");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[7]=theNoiseName;
  noiseData.li_Pos[7]=li_NOI2;
  noiseData.li_Neg[7]=-1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_DI_SI")+std::string("_")+std::string("idid");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[8]=theNoiseName;
  noiseData.li_Pos[8]=li_DI;
  noiseData.li_Neg[8]=li_SI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_DI_SI")+std::string("_")+std::string("flicker");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[9]=theNoiseName;
  noiseData.li_Pos[9]=li_DI;
  noiseData.li_Neg[9]=li_SI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_GP_SI")+std::string("_")+std::string("igs");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[10]=theNoiseName;
  noiseData.li_Pos[10]=li_GP;
  noiseData.li_Neg[10]=li_SI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_GP_DI")+std::string("_")+std::string("igd");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[11]=theNoiseName;
  noiseData.li_Pos[11]=li_GP;
  noiseData.li_Neg[11]=li_DI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BS_SI")+std::string("_")+std::string("ibs");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[12]=theNoiseName;
  noiseData.li_Pos[12]=li_BS;
  noiseData.li_Neg[12]=li_SI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BD_DI")+std::string("_")+std::string("ibd");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[13]=theNoiseName;
  noiseData.li_Pos[13]=li_BD;
  noiseData.li_Neg[13]=li_DI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_DI_SI")+std::string("_")+std::string("flicker");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[14]=theNoiseName;
  noiseData.li_Pos[14]=li_DI;
  noiseData.li_Neg[14]=li_SI;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_DI_SI")+std::string("_")+std::string("ididedge");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[15]=theNoiseName;
  noiseData.li_Pos[15]=li_DI;
  noiseData.li_Neg[15]=li_SI;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
  noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
  noiseData.noiseDens[1] = noiseContribsPower[1];
  noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
  noiseData.noiseDens[2] = noiseContribsPower[2];
  noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
  noiseData.noiseDens[3] = noiseContribsPower[3];
  noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
  noiseData.noiseDens[4] = noiseContribsPower[4];
  noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
  noiseData.noiseDens[5] = noiseContribsPower[5];
  noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
  noiseData.noiseDens[6] = noiseContribsPower[6];
  noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
  noiseData.noiseDens[7] = noiseContribsPower[7];
  noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
  noiseData.noiseDens[8] = noiseContribsPower[8];
  noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
  noiseData.noiseDens[9] = noiseContribsPower[9];

  noiseData.noiseDens[9] /= pow(noiseData.freq,noiseContribsExponent[9]);noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
  noiseData.noiseDens[10] = noiseContribsPower[10];
  noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));
  noiseData.noiseDens[11] = noiseContribsPower[11];
  noiseData.lnNoiseDens[11] = std::log(std::max(noiseData.noiseDens[11],N_MINLOG));
  noiseData.noiseDens[12] = noiseContribsPower[12];
  noiseData.lnNoiseDens[12] = std::log(std::max(noiseData.noiseDens[12],N_MINLOG));
  noiseData.noiseDens[13] = noiseContribsPower[13];
  noiseData.lnNoiseDens[13] = std::log(std::max(noiseData.noiseDens[13],N_MINLOG));
  noiseData.noiseDens[14] = noiseContribsPower[14];

  noiseData.noiseDens[14] /= pow(noiseData.freq,noiseContribsExponent[14]);noiseData.lnNoiseDens[14] = std::log(std::max(noiseData.noiseDens[14],N_MINLOG));
  noiseData.noiseDens[15] = noiseContribsPower[15];
  noiseData.lnNoiseDens[15] = std::log(std::max(noiseData.noiseDens[15],N_MINLOG));

}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_DI_Equ_SI_Node_Ptr) +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BS] -d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  (*f_DI_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  (*f_BP_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  (*f_BP_Equ_BP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] -d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  (*f_DI_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI];
  (*f_BP_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI];
  (*f_DI_Equ_DI_Node_Ptr) +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_D_DI] +d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_BD] +d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI];
  (*f_BP_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI];
  (*f_SI_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_S_SI] +d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BS] -d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  (*f_SI_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  (*f_SI_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI];
  (*f_SI_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_BD] +d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI];
  (*f_GP_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] -d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  (*f_GP_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  (*f_GP_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI];
  (*f_GP_Equ_GP_Node_Ptr) +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] +d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI];
  (*f_BS_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BP] +d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  (*f_BS_Equ_BS_Node_Ptr) +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  (*f_SI_Equ_BS_Node_Ptr) +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BS];
  (*f_BS_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  (*f_BS_Equ_BD_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  (*f_SI_Equ_BD_Node_Ptr) +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_BD];
  (*f_BD_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BP] +d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  (*f_BD_Equ_BS_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  (*f_DI_Equ_BS_Node_Ptr) +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BS];
  (*f_BD_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  (*f_BD_Equ_BD_Node_Ptr) +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  (*f_DI_Equ_BD_Node_Ptr) +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_BD];
  (*f_G_Equ_G_Node_Ptr) +=  +d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  (*f_G_Equ_GP_Node_Ptr) +=  -d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  (*f_GP_Equ_G_Node_Ptr) +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP];
  (*f_S_Equ_S_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_S_SI];
  (*f_S_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_SI];
  (*f_SI_Equ_S_Node_Ptr) +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_S_SI];
  (*f_D_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_D_DI];
  (*f_D_Equ_DI_Node_Ptr) +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_D_DI];
  (*f_DI_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_D_DI];
  (*f_BP_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI];
  (*f_BI_Equ_BP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  (*f_BI_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  (*f_BS_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI];
  (*f_BI_Equ_BS_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI];
  (*f_BD_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI];
  (*f_BI_Equ_BD_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI];
  (*f_B_Equ_B_Node_Ptr) +=  +d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  (*f_B_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  (*f_BI_Equ_B_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI];
  (*f_NOI2_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND];
  (*f_NOI2_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_SI];
  (*f_NOI2_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_SI_BP] -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_SI];
  (*f_NOI2_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_SI_BP];
  (*f_NOI2_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_DI_SI];
  (*f_NOI_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  (*f_NOI_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  (*f_NOI_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI];
  (*f_NOI_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI];
  (*f_NOI_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND];
  (*f_NOI_Equ_NOI_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  (*f_DI_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_NOI2_GND];
  (*f_SI_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_NOI2_GND];
  (*f_BS_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BP];
  (*f_BS_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_SI];
  (*f_BD_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BP];
  (*f_BD_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_SI];

#else
  //use the offsets instead of pointers
  dFdx[li_DI][A_DI_Equ_SI_NodeOffset] +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BS] -d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  dFdx[li_DI][A_DI_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  dFdx[li_BP][A_BP_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  dFdx[li_BP][A_BP_Equ_BP_NodeOffset] +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] -d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  dFdx[li_DI][A_DI_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI];
  dFdx[li_BP][A_BP_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI];
  dFdx[li_DI][A_DI_Equ_DI_NodeOffset] +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_D_DI] +d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_BD] +d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI];
  dFdx[li_BP][A_BP_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI];
  dFdx[li_SI][A_SI_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_S_SI] +d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BS] -d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  dFdx[li_SI][A_SI_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  dFdx[li_SI][A_SI_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI];
  dFdx[li_SI][A_SI_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_BD] +d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI];
  dFdx[li_GP][A_GP_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] -d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  dFdx[li_GP][A_GP_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  dFdx[li_GP][A_GP_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI];
  dFdx[li_GP][A_GP_Equ_GP_NodeOffset] +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] +d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI];
  dFdx[li_BS][A_BS_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BP] +d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  dFdx[li_BS][A_BS_Equ_BS_NodeOffset] +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  dFdx[li_SI][A_SI_Equ_BS_NodeOffset] +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BS];
  dFdx[li_BS][A_BS_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  dFdx[li_BS][A_BS_Equ_BD_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  dFdx[li_SI][A_SI_Equ_BD_NodeOffset] +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_BD];
  dFdx[li_BD][A_BD_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BP] +d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  dFdx[li_BD][A_BD_Equ_BS_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  dFdx[li_DI][A_DI_Equ_BS_NodeOffset] +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BS];
  dFdx[li_BD][A_BD_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  dFdx[li_BD][A_BD_Equ_BD_NodeOffset] +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  dFdx[li_DI][A_DI_Equ_BD_NodeOffset] +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_BD];
  dFdx[li_G][A_G_Equ_G_NodeOffset] +=  +d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  dFdx[li_G][A_G_Equ_GP_NodeOffset] +=  -d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  dFdx[li_GP][A_GP_Equ_G_NodeOffset] +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP];
  dFdx[li_S][A_S_Equ_S_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_S_SI];
  dFdx[li_S][A_S_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_SI];
  dFdx[li_SI][A_SI_Equ_S_NodeOffset] +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_S_SI];
  dFdx[li_D][A_D_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_D_DI];
  dFdx[li_D][A_D_Equ_DI_NodeOffset] +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_D_DI];
  dFdx[li_DI][A_DI_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_D_DI];
  dFdx[li_BP][A_BP_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI];
  dFdx[li_BI][A_BI_Equ_BP_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  dFdx[li_BI][A_BI_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  dFdx[li_BS][A_BS_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI];
  dFdx[li_BI][A_BI_Equ_BS_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI];
  dFdx[li_BD][A_BD_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI];
  dFdx[li_BI][A_BI_Equ_BD_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI];
  dFdx[li_B][A_B_Equ_B_NodeOffset] +=  +d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  dFdx[li_B][A_B_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  dFdx[li_BI][A_BI_Equ_B_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI];
  dFdx[li_NOI2][A_NOI2_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND];
  dFdx[li_NOI2][A_NOI2_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_SI];
  dFdx[li_NOI2][A_NOI2_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_SI_BP] -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_SI];
  dFdx[li_NOI2][A_NOI2_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_SI_BP];
  dFdx[li_NOI2][A_NOI2_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_DI_SI];
  dFdx[li_NOI][A_NOI_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  dFdx[li_NOI][A_NOI_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  dFdx[li_NOI][A_NOI_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI];
  dFdx[li_NOI][A_NOI_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI];
  dFdx[li_NOI][A_NOI_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND];
  dFdx[li_NOI][A_NOI_Equ_NOI_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  dFdx[li_DI][A_DI_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_NOI2_GND];
  dFdx[li_SI][A_SI_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_NOI2_GND];
  dFdx[li_BS][A_BS_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BP];
  dFdx[li_BS][A_BS_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_SI];
  dFdx[li_BD][A_BD_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BP];
  dFdx[li_BD][A_BD_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_SI];

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_DI_Equ_SI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BS] -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  (*q_DI_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  (*q_BP_Equ_SI_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  (*q_BP_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  (*q_DI_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI];
  (*q_BP_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI];
  (*q_DI_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_BD] +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI];
  (*q_BP_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI];
  (*q_SI_Equ_SI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BS] -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  (*q_SI_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  (*q_SI_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI];
  (*q_SI_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_BD] +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI];
  (*q_GP_Equ_SI_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  (*q_GP_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  (*q_GP_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI];
  (*q_GP_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI];
  (*q_BS_Equ_SI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  (*q_BS_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  (*q_SI_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BS];
  (*q_BS_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  (*q_BS_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  (*q_SI_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_BD];
  (*q_BD_Equ_SI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  (*q_BD_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  (*q_DI_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BS];
  (*q_BD_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  (*q_BD_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  (*q_DI_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_BD];
  (*q_NOI_Equ_SI_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  (*q_NOI_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  (*q_NOI_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_SI];
  (*q_NOI_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_SI];
  (*q_NOI_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  (*q_GP_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND];
  (*q_SI_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_NOI_GND];
  (*q_DI_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_NOI_GND];

#else
  //use the offsets instead of pointers
  dQdx[li_DI][A_DI_Equ_SI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BS] -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  dQdx[li_DI][A_DI_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  dQdx[li_BP][A_BP_Equ_SI_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  dQdx[li_BP][A_BP_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  dQdx[li_DI][A_DI_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI];
  dQdx[li_BP][A_BP_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI];
  dQdx[li_DI][A_DI_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_BD] +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI];
  dQdx[li_BP][A_BP_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI];
  dQdx[li_SI][A_SI_Equ_SI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BS] -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  dQdx[li_SI][A_SI_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  dQdx[li_SI][A_SI_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI];
  dQdx[li_SI][A_SI_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_BD] +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI];
  dQdx[li_GP][A_GP_Equ_SI_NodeOffset] +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  dQdx[li_GP][A_GP_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  dQdx[li_GP][A_GP_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI];
  dQdx[li_GP][A_GP_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI];
  dQdx[li_BS][A_BS_Equ_SI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  dQdx[li_BS][A_BS_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  dQdx[li_SI][A_SI_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BS];
  dQdx[li_BS][A_BS_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  dQdx[li_BS][A_BS_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  dQdx[li_SI][A_SI_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_BD];
  dQdx[li_BD][A_BD_Equ_SI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  dQdx[li_BD][A_BD_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  dQdx[li_DI][A_DI_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BS];
  dQdx[li_BD][A_BD_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  dQdx[li_BD][A_BD_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  dQdx[li_DI][A_DI_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_BD];
  dQdx[li_NOI][A_NOI_Equ_SI_NodeOffset] +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  dQdx[li_NOI][A_NOI_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  dQdx[li_NOI][A_NOI_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_SI];
  dQdx[li_NOI][A_NOI_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_SI];
  dQdx[li_NOI][A_NOI_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  dQdx[li_GP][A_GP_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND];
  dQdx[li_SI][A_SI_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_NOI_GND];
  dQdx[li_DI][A_DI_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_NOI_GND];


#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

  // set internal model type based on model card type
  if (getType() == "pmos" || getType() == "PMOS")
    TYPE = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter TYPE : [ (-1), 1 ]] 0, 0 [
  if ( (!((TYPE >=(-1) && TYPE <=1 )) || (TYPE >0 && TYPE <0 )) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TYPE value " << TYPE << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

  //    Parameter TR : [ (-273.0),  (+inf) [
  if ( (!((TR >=(-273.0)))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TR value " << TR << " out of range [ (-273.0),  (+inf) [";
  }

  //    Parameter SWGEO : [ 0, 2 ]
  if ( (!((SWGEO >=0 && SWGEO <=2 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWGEO value " << SWGEO << " out of range [ 0, 2 ]";
  }

  //    Parameter SWIGATE : [ 0, 1 ]
  if ( (!((SWIGATE >=0 && SWIGATE <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWIGATE value " << SWIGATE << " out of range [ 0, 1 ]";
  }

  //    Parameter SWIMPACT : [ 0, 1 ]
  if ( (!((SWIMPACT >=0 && SWIMPACT <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWIMPACT value " << SWIMPACT << " out of range [ 0, 1 ]";
  }

  //    Parameter SWGIDL : [ 0, 1 ]
  if ( (!((SWGIDL >=0 && SWGIDL <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWGIDL value " << SWGIDL << " out of range [ 0, 1 ]";
  }

  //    Parameter SWJUNCAP : [ 0, 3 ]
  if ( (!((SWJUNCAP >=0 && SWJUNCAP <=3 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWJUNCAP value " << SWJUNCAP << " out of range [ 0, 3 ]";
  }

  //    Parameter SWJUNASYM : [ 0, 1 ]
  if ( (!((SWJUNASYM >=0 && SWJUNASYM <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWJUNASYM value " << SWJUNASYM << " out of range [ 0, 1 ]";
  }

  //    Parameter SWNUD : [ 0, 2 ]
  if ( (!((SWNUD >=0 && SWNUD <=2 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWNUD value " << SWNUD << " out of range [ 0, 2 ]";
  }

  //    Parameter SWEDGE : [ 0, 1 ]
  if ( (!((SWEDGE >=0 && SWEDGE <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWEDGE value " << SWEDGE << " out of range [ 0, 1 ]";
  }

  //    Parameter SWDELVTAC : [ 0, 1 ]
  if ( (!((SWDELVTAC >=0 && SWDELVTAC <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWDELVTAC value " << SWDELVTAC << " out of range [ 0, 1 ]";
  }

  //    Parameter SWIGN : [ 0, 1 ]
  if ( (!((SWIGN >=0 && SWIGN <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWIGN value " << SWIGN << " out of range [ 0, 1 ]";
  }

  //    Parameter QMC : [ 0,  (+inf) [
  if ( (!((QMC >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter QMC value " << QMC << " out of range [ 0,  (+inf) [";
  }

  //    Parameter TOX : [ 1.0e-10,  (+inf) [
  if ( (!((TOX >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TOX value " << TOX << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter EPSROX : [ 1.0,  (+inf) [
  if ( (!((EPSROX >=1.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter EPSROX value " << EPSROX << " out of range [ 1.0,  (+inf) [";
  }

  //    Parameter NEFF : [ 1.0e20, 1.0e26 ]
  if ( (!((NEFF >=1.0e20 && NEFF <=1.0e26 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NEFF value " << NEFF << " out of range [ 1.0e20, 1.0e26 ]";
  }

  //    Parameter FACNEFFAC : [ 0,  (+inf) [
  if ( (!((FACNEFFAC >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FACNEFFAC value " << FACNEFFAC << " out of range [ 0,  (+inf) [";
  }

  //    Parameter GFACNUD : [ 0.01,  (+inf) [
  if ( (!((GFACNUD >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter GFACNUD value " << GFACNUD << " out of range [ 0.01,  (+inf) [";
  }

  //    Parameter VSBNUD : [ 0,  (+inf) [
  if ( (!((VSBNUD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VSBNUD value " << VSBNUD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter DVSBNUD : [ 0.1,  (+inf) [
  if ( (!((DVSBNUD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter DVSBNUD value " << DVSBNUD << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter NSLP : [ 1.0e-3,  (+inf) [
  if ( (!((NSLP >=1.0e-3))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NSLP value " << NSLP << " out of range [ 1.0e-3,  (+inf) [";
  }

  //    Parameter DNSUB : [ 0.0, 1.0 ]
  if ( (!((DNSUB >=0.0 && DNSUB <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter DNSUB value " << DNSUB << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter NP : [ 0,  (+inf) [
  if ( (!((NP >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NP value " << NP << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CT : [ 0,  (+inf) [
  if ( (!((CT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CT value " << CT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter TOXOV : [ 1.0e-10,  (+inf) [
  if ( (!((TOXOV >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TOXOV value " << TOXOV << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter TOXOVD : [ 1.0e-10,  (+inf) [
  if ( (!((TOXOVD >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TOXOVD value " << TOXOVD << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter NOV : [ 1.0e23, 1.0e27 ]
  if ( (!((NOV >=1.0e23 && NOV <=1.0e27 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NOV value " << NOV << " out of range [ 1.0e23, 1.0e27 ]";
  }

  //    Parameter NOVD : [ 1.0e23, 1.0e27 ]
  if ( (!((NOVD >=1.0e23 && NOVD <=1.0e27 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NOVD value " << NOVD << " out of range [ 1.0e23, 1.0e27 ]";
  }

  //    Parameter CF : [ 0,  (+inf) [
  if ( (!((CF >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CF value " << CF << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CFD : [ 0,  (+inf) [
  if ( (!((CFD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFD value " << CFD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CFB : [ 0.0, 1.0 ]
  if ( (!((CFB >=0.0 && CFB <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFB value " << CFB << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter PSCE : [ 0,  (+inf) [
  if ( (!((PSCE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCE value " << PSCE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PSCEB : [ 0.0, 1.0 ]
  if ( (!((PSCEB >=0.0 && PSCEB <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEB value " << PSCEB << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter PSCED : [ 0,  (+inf) [
  if ( (!((PSCED >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCED value " << PSCED << " out of range [ 0,  (+inf) [";
  }

  //    Parameter BETN : [ 0,  (+inf) [
  if ( (!((BETN >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter BETN value " << BETN << " out of range [ 0,  (+inf) [";
  }

  //    Parameter MUE : [ 0,  (+inf) [
  if ( (!((MUE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MUE value " << MUE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter THEMU : [ 0,  (+inf) [
  if ( (!((THEMU >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter THEMU value " << THEMU << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CS : [ 0,  (+inf) [
  if ( (!((CS >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CS value " << CS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter XCOR : [ 0,  (+inf) [
  if ( (!((XCOR >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter XCOR value " << XCOR << " out of range [ 0,  (+inf) [";
  }

  //    Parameter FETA : [ 0,  (+inf) [
  if ( (!((FETA >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FETA value " << FETA << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RS : [ 0,  (+inf) [
  if ( (!((RS >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RS value " << RS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RSB : [ (-0.5), 1.0 ]
  if ( (!((RSB >=(-0.5) && RSB <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RSB value " << RSB << " out of range [ (-0.5), 1.0 ]";
  }

  //    Parameter RSG : [ (-0.5),  (+inf) [
  if ( (!((RSG >=(-0.5)))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RSG value " << RSG << " out of range [ (-0.5),  (+inf) [";
  }

  //    Parameter THESAT : [ 0,  (+inf) [
  if ( (!((THESAT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter THESAT value " << THESAT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter THESATB : [ (-0.5), 1.0 ]
  if ( (!((THESATB >=(-0.5) && THESATB <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter THESATB value " << THESATB << " out of range [ (-0.5), 1.0 ]";
  }

  //    Parameter THESATG : [ (-0.5),  (+inf) [
  if ( (!((THESATG >=(-0.5)))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter THESATG value " << THESATG << " out of range [ (-0.5),  (+inf) [";
  }

  //    Parameter AX : [ 2.0,  (+inf) [
  if ( (!((AX >=2.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter AX value " << AX << " out of range [ 2.0,  (+inf) [";
  }

  //    Parameter ALP : [ 0,  (+inf) [
  if ( (!((ALP >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ALP value " << ALP << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ALP1 : [ 0,  (+inf) [
  if ( (!((ALP1 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ALP1 value " << ALP1 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ALP2 : [ 0,  (+inf) [
  if ( (!((ALP2 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ALP2 value " << ALP2 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter VP : [ 1.0e-10,  (+inf) [
  if ( (!((VP >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VP value " << VP << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter A1 : [ 0,  (+inf) [
  if ( (!((A1 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter A1 value " << A1 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter A2 : [ 0,  (+inf) [
  if ( (!((A2 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter A2 value " << A2 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter A3 : [ 0,  (+inf) [
  if ( (!((A3 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter A3 value " << A3 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter A4 : [ 0,  (+inf) [
  if ( (!((A4 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter A4 value " << A4 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter GCO : [ (-10.0), 10.0 ]
  if ( (!((GCO >=(-10.0) && GCO <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter GCO value " << GCO << " out of range [ (-10.0), 10.0 ]";
  }

  //    Parameter IGINV : [ 0,  (+inf) [
  if ( (!((IGINV >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IGINV value " << IGINV << " out of range [ 0,  (+inf) [";
  }

  //    Parameter IGOV : [ 0,  (+inf) [
  if ( (!((IGOV >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IGOV value " << IGOV << " out of range [ 0,  (+inf) [";
  }

  //    Parameter IGOVD : [ 0,  (+inf) [
  if ( (!((IGOVD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IGOVD value " << IGOVD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter GC2 : [ 0.0, 10.0 ]
  if ( (!((GC2 >=0.0 && GC2 <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter GC2 value " << GC2 << " out of range [ 0.0, 10.0 ]";
  }

  //    Parameter GC3 : [ (-2.0), 2.0 ]
  if ( (!((GC3 >=(-2.0) && GC3 <=2.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter GC3 value " << GC3 << " out of range [ (-2.0), 2.0 ]";
  }

  //    Parameter CHIB : [ 1.0,  (+inf) [
  if ( (!((CHIB >=1.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CHIB value " << CHIB << " out of range [ 1.0,  (+inf) [";
  }

  //    Parameter AGIDL : [ 0,  (+inf) [
  if ( (!((AGIDL >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter AGIDL value " << AGIDL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter AGIDLD : [ 0,  (+inf) [
  if ( (!((AGIDLD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter AGIDLD value " << AGIDLD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter BGIDL : [ 0,  (+inf) [
  if ( (!((BGIDL >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter BGIDL value " << BGIDL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter BGIDLD : [ 0,  (+inf) [
  if ( (!((BGIDLD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter BGIDLD value " << BGIDLD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter COX : [ 0,  (+inf) [
  if ( (!((COX >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter COX value " << COX << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CGOV : [ 0,  (+inf) [
  if ( (!((CGOV >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CGOV value " << CGOV << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CGOVD : [ 0,  (+inf) [
  if ( (!((CGOVD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CGOVD value " << CGOVD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CGBOV : [ 0,  (+inf) [
  if ( (!((CGBOV >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CGBOV value " << CGBOV << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CFR : [ 0,  (+inf) [
  if ( (!((CFR >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFR value " << CFR << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CFRD : [ 0,  (+inf) [
  if ( (!((CFRD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFRD value " << CFRD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter FNT : [ 0,  (+inf) [
  if ( (!((FNT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FNT value " << FNT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter FNTEXC : [ 0,  (+inf) [
  if ( (!((FNTEXC >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FNTEXC value " << FNTEXC << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NFA : [ 0,  (+inf) [
  if ( (!((NFA >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NFA value " << NFA << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NFB : [ 0,  (+inf) [
  if ( (!((NFB >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NFB value " << NFB << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NFC : [ 0,  (+inf) [
  if ( (!((NFC >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NFC value " << NFC << " out of range [ 0,  (+inf) [";
  }

  //    Parameter EF : [ 0,  (+inf) [
  if ( (!((EF >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter EF value " << EF << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NEFFEDGE : [ 1.0e20, 1.0e26 ]
  if ( (!((NEFFEDGE >=1.0e20 && NEFFEDGE <=1.0e26 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NEFFEDGE value " << NEFFEDGE << " out of range [ 1.0e20, 1.0e26 ]";
  }

  //    Parameter CTEDGE : [ 0,  (+inf) [
  if ( (!((CTEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTEDGE value " << CTEDGE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter BETNEDGE : [ 0,  (+inf) [
  if ( (!((BETNEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter BETNEDGE value " << BETNEDGE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PSCEEDGE : [ 0,  (+inf) [
  if ( (!((PSCEEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEEDGE value " << PSCEEDGE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PSCEBEDGE : [ 0.0, 1.0 ]
  if ( (!((PSCEBEDGE >=0.0 && PSCEBEDGE <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEBEDGE value " << PSCEBEDGE << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter PSCEDEDGE : [ 0,  (+inf) [
  if ( (!((PSCEDEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEDEDGE value " << PSCEDEDGE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CFEDGE : [ 0,  (+inf) [
  if ( (!((CFEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFEDGE value " << CFEDGE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CFDEDGE : [ 0,  (+inf) [
  if ( (!((CFDEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFDEDGE value " << CFDEDGE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CFBEDGE : [ 0.0, 1.0 ]
  if ( (!((CFBEDGE >=0.0 && CFBEDGE <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFBEDGE value " << CFBEDGE << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter FNTEDGE : [ 0,  (+inf) [
  if ( (!((FNTEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FNTEDGE value " << FNTEDGE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NFAEDGE : [ 0,  (+inf) [
  if ( (!((NFAEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NFAEDGE value " << NFAEDGE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NFBEDGE : [ 0,  (+inf) [
  if ( (!((NFBEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NFBEDGE value " << NFBEDGE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NFCEDGE : [ 0,  (+inf) [
  if ( (!((NFCEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NFCEDGE value " << NFCEDGE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter EFEDGE : [ 0,  (+inf) [
  if ( (!((EFEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter EFEDGE value " << EFEDGE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RG : [ 0,  (+inf) [
  if ( (!((RG >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RG value " << RG << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RSE : [ 0,  (+inf) [
  if ( (!((RSE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RSE value " << RSE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RDE : [ 0,  (+inf) [
  if ( (!((RDE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RDE value " << RDE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RBULK : [ 0,  (+inf) [
  if ( (!((RBULK >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RBULK value " << RBULK << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RWELL : [ 0,  (+inf) [
  if ( (!((RWELL >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RWELL value " << RWELL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RJUNS : [ 0,  (+inf) [
  if ( (!((RJUNS >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RJUNS value " << RJUNS << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RJUND : [ 0,  (+inf) [
  if ( (!((RJUND >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RJUND value " << RJUND << " out of range [ 0,  (+inf) [";
  }

  //    Parameter TOXO : [ 1.0e-10,  (+inf) [
  if ( (!((TOXO >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TOXO value " << TOXO << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter EPSROXO : [ 1.0,  (+inf) [
  if ( (!((EPSROXO >=1.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter EPSROXO value " << EPSROXO << " out of range [ 1.0,  (+inf) [";
  }

  //    Parameter NSUBO : [ 1.0e20,  (+inf) [
  if ( (!((NSUBO >=1.0e20))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NSUBO value " << NSUBO << " out of range [ 1.0e20,  (+inf) [";
  }

  //    Parameter WSEG : [ 1.0e-10,  (+inf) [
  if ( (!((WSEG >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WSEG value " << WSEG << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter NPCK : [ 0,  (+inf) [
  if ( (!((NPCK >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NPCK value " << NPCK << " out of range [ 0,  (+inf) [";
  }

  //    Parameter WSEGP : [ 1.0e-10,  (+inf) [
  if ( (!((WSEGP >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WSEGP value " << WSEGP << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter LPCK : [ 1.0e-10,  (+inf) [
  if ( (!((LPCK >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LPCK value " << LPCK << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter TOXOVO : [ 1.0e-10,  (+inf) [
  if ( (!((TOXOVO >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TOXOVO value " << TOXOVO << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter TOXOVDO : [ 1.0e-10,  (+inf) [
  if ( (!((TOXOVDO >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TOXOVDO value " << TOXOVDO << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter LOV : [ 0,  (+inf) [
  if ( (!((LOV >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LOV value " << LOV << " out of range [ 0,  (+inf) [";
  }

  //    Parameter LOVD : [ 0,  (+inf) [
  if ( (!((LOVD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LOVD value " << LOVD << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CFDO : [ 0,  (+inf) [
  if ( (!((CFDO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFDO value " << CFDO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter PSCEBO : [ 0.0, 1.0 ]
  if ( (!((PSCEBO >=0.0 && PSCEBO <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEBO value " << PSCEBO << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter PSCEDO : [ 0,  (+inf) [
  if ( (!((PSCEDO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEDO value " << PSCEDO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter UO : [ 0,  (+inf) [
  if ( (!((UO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter UO value " << UO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter LP1 : [ 1.0e-10,  (+inf) [
  if ( (!((LP1 >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LP1 value " << LP1 << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter LP2 : [ 1.0e-10,  (+inf) [
  if ( (!((LP2 >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LP2 value " << LP2 << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter WBET : [ 1.0e-10,  (+inf) [
  if ( (!((WBET >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WBET value " << WBET << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter AXL : [ 0,  (+inf) [
  if ( (!((AXL >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter AXL value " << AXL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ALP1L2 : [ 0,  (+inf) [
  if ( (!((ALP1L2 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ALP1L2 value " << ALP1L2 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ALP2L2 : [ 0,  (+inf) [
  if ( (!((ALP2L2 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ALP2L2 value " << ALP2L2 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter FNTEXCL : [ 0,  (+inf) [
  if ( (!((FNTEXCL >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FNTEXCL value " << FNTEXCL << " out of range [ 0,  (+inf) [";
  }

  //    Parameter WEDGE : [ 0,  (+inf) [
  if ( (!((WEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WEDGE value " << WEDGE << " out of range [ 0,  (+inf) [";
  }

  //    Parameter WEDGEW : [ 0,  (+inf) [
  if ( (!((WEDGEW >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WEDGEW value " << WEDGEW << " out of range [ 0,  (+inf) [";
  }

  //    Parameter NSUBEDGEO : [ 1.0e20,  (+inf) [
  if ( (!((NSUBEDGEO >=1.0e20))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NSUBEDGEO value " << NSUBEDGEO << " out of range [ 1.0e20,  (+inf) [";
  }

  //    Parameter LPEDGE : [ 1.0e-10,  (+inf) [
  if ( (!((LPEDGE >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LPEDGE value " << LPEDGE << " out of range [ 1.0e-10,  (+inf) [";
  }

  //    Parameter PSCEBEDGEO : [ 0.0, 1.0 ]
  if ( (!((PSCEBEDGEO >=0.0 && PSCEBEDGEO <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEBEDGEO value " << PSCEBEDGEO << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter PSCEDEDGEO : [ 0,  (+inf) [
  if ( (!((PSCEDEDGEO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEDEDGEO value " << PSCEDEDGEO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CFDEDGEO : [ 0,  (+inf) [
  if ( (!((CFDEDGEO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFDEDGEO value " << CFDEDGEO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter CFBEDGEO : [ 0.0, 1.0 ]
  if ( (!((CFBEDGEO >=0.0 && CFBEDGEO <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFBEDGEO value " << CFBEDGEO << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter RINT : [ 0,  (+inf) [
  if ( (!((RINT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RINT value " << RINT << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RVPOLY : [ 0,  (+inf) [
  if ( (!((RVPOLY >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RVPOLY value " << RVPOLY << " out of range [ 0,  (+inf) [";
  }

  //    Parameter RSHG : [ 0,  (+inf) [
  if ( (!((RSHG >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RSHG value " << RSHG << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SAREF : [ 1.0e-9,  (+inf) [
  if ( (!((SAREF >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SAREF value " << SAREF << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter SBREF : [ 1.0e-9,  (+inf) [
  if ( (!((SBREF >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SBREF value " << SBREF << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter KVSAT : [ (-1.0), 1.0 ]
  if ( (!((KVSAT >=(-1.0) && KVSAT <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter KVSAT value " << KVSAT << " out of range [ (-1.0), 1.0 ]";
  }

  //    Parameter LLODKUO : [ 0,  (+inf) [
  if ( (!((LLODKUO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LLODKUO value " << LLODKUO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter WLODKUO : [ 0,  (+inf) [
  if ( (!((WLODKUO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WLODKUO value " << WLODKUO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter LLODVTH : [ 0,  (+inf) [
  if ( (!((LLODVTH >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LLODVTH value " << LLODVTH << " out of range [ 0,  (+inf) [";
  }

  //    Parameter WLODVTH : [ 0,  (+inf) [
  if ( (!((WLODVTH >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WLODVTH value " << WLODVTH << " out of range [ 0,  (+inf) [";
  }

  //    Parameter LODETAO : [ 0,  (+inf) [
  if ( (!((LODETAO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LODETAO value " << LODETAO << " out of range [ 0,  (+inf) [";
  }

  //    Parameter SCREF : [ 0,  (+inf) [
  if ( (!((SCREF >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SCREF value " << SCREF << " out of range [ 0,  (+inf) [";
  }

  //    Parameter IMAX : [ 1.0e-12,  (+inf) [
  if ( (!((IMAX >=1.0e-12))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IMAX value " << IMAX << " out of range [ 1.0e-12,  (+inf) [";
  }

  //    Parameter TRJ : [ (-2.5e2),  (+inf) [
  if ( (!((TRJ >=(-2.5e2)))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TRJ value " << TRJ << " out of range [ (-2.5e2),  (+inf) [";
  }

  //    Parameter FREV : [ 1.0e1, 1.0e10 ]
  if ( (!((FREV >=1.0e1 && FREV <=1.0e10 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FREV value " << FREV << " out of range [ 1.0e1, 1.0e10 ]";
  }

  //    Parameter CJORBOT : [ 1.0e-12,  (+inf) [
  if ( (!((CJORBOT >=1.0e-12))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CJORBOT value " << CJORBOT << " out of range [ 1.0e-12,  (+inf) [";
  }

  //    Parameter CJORSTI : [ 1.0e-18,  (+inf) [
  if ( (!((CJORSTI >=1.0e-18))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CJORSTI value " << CJORSTI << " out of range [ 1.0e-18,  (+inf) [";
  }

  //    Parameter CJORGAT : [ 1.0e-18,  (+inf) [
  if ( (!((CJORGAT >=1.0e-18))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CJORGAT value " << CJORGAT << " out of range [ 1.0e-18,  (+inf) [";
  }

  //    Parameter VBIRBOT : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRBOT >=5.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBIRBOT value " << VBIRBOT << " out of range [ 5.0e-2,  (+inf) [";
  }

  //    Parameter VBIRSTI : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRSTI >=5.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBIRSTI value " << VBIRSTI << " out of range [ 5.0e-2,  (+inf) [";
  }

  //    Parameter VBIRGAT : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRGAT >=5.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBIRGAT value " << VBIRGAT << " out of range [ 5.0e-2,  (+inf) [";
  }

  //    Parameter PBOT : [ 5.0e-2, 0.95 ]
  if ( (!((PBOT >=5.0e-2 && PBOT <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBOT value " << PBOT << " out of range [ 5.0e-2, 0.95 ]";
  }

  //    Parameter PSTI : [ 5.0e-2, 0.95 ]
  if ( (!((PSTI >=5.0e-2 && PSTI <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSTI value " << PSTI << " out of range [ 5.0e-2, 0.95 ]";
  }

  //    Parameter PGAT : [ 5.0e-2, 0.95 ]
  if ( (!((PGAT >=5.0e-2 && PGAT <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PGAT value " << PGAT << " out of range [ 5.0e-2, 0.95 ]";
  }

  //    Parameter IDSATRBOT : [ 0.0,  (+inf) [
  if ( (!((IDSATRBOT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IDSATRBOT value " << IDSATRBOT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IDSATRSTI : [ 0.0,  (+inf) [
  if ( (!((IDSATRSTI >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IDSATRSTI value " << IDSATRSTI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IDSATRGAT : [ 0.0,  (+inf) [
  if ( (!((IDSATRGAT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IDSATRGAT value " << IDSATRGAT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CSRHBOT : [ 0.0,  (+inf) [
  if ( (!((CSRHBOT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CSRHBOT value " << CSRHBOT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CSRHSTI : [ 0.0,  (+inf) [
  if ( (!((CSRHSTI >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CSRHSTI value " << CSRHSTI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CSRHGAT : [ 0.0,  (+inf) [
  if ( (!((CSRHGAT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CSRHGAT value " << CSRHGAT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XJUNSTI : [ 1.0e-9,  (+inf) [
  if ( (!((XJUNSTI >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter XJUNSTI value " << XJUNSTI << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter XJUNGAT : [ 1.0e-9,  (+inf) [
  if ( (!((XJUNGAT >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter XJUNGAT value " << XJUNGAT << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter CTATBOT : [ 0.0,  (+inf) [
  if ( (!((CTATBOT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTATBOT value " << CTATBOT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CTATSTI : [ 0.0,  (+inf) [
  if ( (!((CTATSTI >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTATSTI value " << CTATSTI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CTATGAT : [ 0.0,  (+inf) [
  if ( (!((CTATGAT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTATGAT value " << CTATGAT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter MEFFTATBOT : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATBOT >=1.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MEFFTATBOT value " << MEFFTATBOT << " out of range [ 1.0e-2,  (+inf) [";
  }

  //    Parameter MEFFTATSTI : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATSTI >=1.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MEFFTATSTI value " << MEFFTATSTI << " out of range [ 1.0e-2,  (+inf) [";
  }

  //    Parameter MEFFTATGAT : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATGAT >=1.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MEFFTATGAT value " << MEFFTATGAT << " out of range [ 1.0e-2,  (+inf) [";
  }

  //    Parameter CBBTBOT : [ 0.0,  (+inf) [
  if ( (!((CBBTBOT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CBBTBOT value " << CBBTBOT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CBBTSTI : [ 0.0,  (+inf) [
  if ( (!((CBBTSTI >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CBBTSTI value " << CBBTSTI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CBBTGAT : [ 0.0,  (+inf) [
  if ( (!((CBBTGAT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CBBTGAT value " << CBBTGAT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VBRBOT : [ 0.1,  (+inf) [
  if ( (!((VBRBOT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBRBOT value " << VBRBOT << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VBRSTI : [ 0.1,  (+inf) [
  if ( (!((VBRSTI >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBRSTI value " << VBRSTI << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VBRGAT : [ 0.1,  (+inf) [
  if ( (!((VBRGAT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBRGAT value " << VBRGAT << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRBOT : [ 0.1,  (+inf) [
  if ( (!((PBRBOT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBRBOT value " << PBRBOT << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRSTI : [ 0.1,  (+inf) [
  if ( (!((PBRSTI >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBRSTI value " << PBRSTI << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRGAT : [ 0.1,  (+inf) [
  if ( (!((PBRGAT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBRGAT value " << PBRGAT << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter CJORBOTD : [ 1.0e-12,  (+inf) [
  if ( (!((CJORBOTD >=1.0e-12))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CJORBOTD value " << CJORBOTD << " out of range [ 1.0e-12,  (+inf) [";
  }

  //    Parameter CJORSTID : [ 1.0e-18,  (+inf) [
  if ( (!((CJORSTID >=1.0e-18))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CJORSTID value " << CJORSTID << " out of range [ 1.0e-18,  (+inf) [";
  }

  //    Parameter CJORGATD : [ 1.0e-18,  (+inf) [
  if ( (!((CJORGATD >=1.0e-18))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CJORGATD value " << CJORGATD << " out of range [ 1.0e-18,  (+inf) [";
  }

  //    Parameter VBIRBOTD : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRBOTD >=5.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBIRBOTD value " << VBIRBOTD << " out of range [ 5.0e-2,  (+inf) [";
  }

  //    Parameter VBIRSTID : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRSTID >=5.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBIRSTID value " << VBIRSTID << " out of range [ 5.0e-2,  (+inf) [";
  }

  //    Parameter VBIRGATD : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRGATD >=5.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBIRGATD value " << VBIRGATD << " out of range [ 5.0e-2,  (+inf) [";
  }

  //    Parameter PBOTD : [ 5.0e-2, 0.95 ]
  if ( (!((PBOTD >=5.0e-2 && PBOTD <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBOTD value " << PBOTD << " out of range [ 5.0e-2, 0.95 ]";
  }

  //    Parameter PSTID : [ 5.0e-2, 0.95 ]
  if ( (!((PSTID >=5.0e-2 && PSTID <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSTID value " << PSTID << " out of range [ 5.0e-2, 0.95 ]";
  }

  //    Parameter PGATD : [ 5.0e-2, 0.95 ]
  if ( (!((PGATD >=5.0e-2 && PGATD <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PGATD value " << PGATD << " out of range [ 5.0e-2, 0.95 ]";
  }

  //    Parameter IDSATRBOTD : [ 0.0,  (+inf) [
  if ( (!((IDSATRBOTD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IDSATRBOTD value " << IDSATRBOTD << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IDSATRSTID : [ 0.0,  (+inf) [
  if ( (!((IDSATRSTID >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IDSATRSTID value " << IDSATRSTID << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IDSATRGATD : [ 0.0,  (+inf) [
  if ( (!((IDSATRGATD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IDSATRGATD value " << IDSATRGATD << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CSRHBOTD : [ 0.0,  (+inf) [
  if ( (!((CSRHBOTD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CSRHBOTD value " << CSRHBOTD << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CSRHSTID : [ 0.0,  (+inf) [
  if ( (!((CSRHSTID >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CSRHSTID value " << CSRHSTID << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CSRHGATD : [ 0.0,  (+inf) [
  if ( (!((CSRHGATD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CSRHGATD value " << CSRHGATD << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XJUNSTID : [ 1.0e-9,  (+inf) [
  if ( (!((XJUNSTID >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter XJUNSTID value " << XJUNSTID << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter XJUNGATD : [ 1.0e-9,  (+inf) [
  if ( (!((XJUNGATD >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter XJUNGATD value " << XJUNGATD << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter CTATBOTD : [ 0.0,  (+inf) [
  if ( (!((CTATBOTD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTATBOTD value " << CTATBOTD << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CTATSTID : [ 0.0,  (+inf) [
  if ( (!((CTATSTID >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTATSTID value " << CTATSTID << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CTATGATD : [ 0.0,  (+inf) [
  if ( (!((CTATGATD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTATGATD value " << CTATGATD << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter MEFFTATBOTD : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATBOTD >=1.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MEFFTATBOTD value " << MEFFTATBOTD << " out of range [ 1.0e-2,  (+inf) [";
  }

  //    Parameter MEFFTATSTID : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATSTID >=1.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MEFFTATSTID value " << MEFFTATSTID << " out of range [ 1.0e-2,  (+inf) [";
  }

  //    Parameter MEFFTATGATD : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATGATD >=1.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MEFFTATGATD value " << MEFFTATGATD << " out of range [ 1.0e-2,  (+inf) [";
  }

  //    Parameter CBBTBOTD : [ 0.0,  (+inf) [
  if ( (!((CBBTBOTD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CBBTBOTD value " << CBBTBOTD << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CBBTSTID : [ 0.0,  (+inf) [
  if ( (!((CBBTSTID >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CBBTSTID value " << CBBTSTID << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CBBTGATD : [ 0.0,  (+inf) [
  if ( (!((CBBTGATD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CBBTGATD value " << CBBTGATD << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VBRBOTD : [ 0.1,  (+inf) [
  if ( (!((VBRBOTD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBRBOTD value " << VBRBOTD << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VBRSTID : [ 0.1,  (+inf) [
  if ( (!((VBRSTID >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBRSTID value " << VBRSTID << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VBRGATD : [ 0.1,  (+inf) [
  if ( (!((VBRGATD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBRGATD value " << VBRGATD << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRBOTD : [ 0.1,  (+inf) [
  if ( (!((PBRBOTD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBRBOTD value " << PBRBOTD << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRSTID : [ 0.1,  (+inf) [
  if ( (!((PBRSTID >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBRSTID value " << PBRSTID << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRGATD : [ 0.1,  (+inf) [
  if ( (!((PBRGATD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBRGATD value " << PBRGATD << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter SWJUNEXP : [ 0.0, 1.0 ]
  if ( (!((SWJUNEXP >=0.0 && SWJUNEXP <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWJUNEXP value " << SWJUNEXP << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter VJUNREF : [ 0.5,  (+inf) [
  if ( (!((VJUNREF >=0.5))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VJUNREF value " << VJUNREF << " out of range [ 0.5,  (+inf) [";
  }

  //    Parameter FJUNQ : [ 0.0,  (+inf) [
  if ( (!((FJUNQ >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FJUNQ value " << FJUNQ << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VJUNREFD : [ 0.5,  (+inf) [
  if ( (!((VJUNREFD >=0.5))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VJUNREFD value " << VJUNREFD << " out of range [ 0.5,  (+inf) [";
  }

  //    Parameter FJUNQD : [ 0.0,  (+inf) [
  if ( (!((FJUNQD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FJUNQD value " << FJUNQD << " out of range [ 0.0,  (+inf) [";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff
  double deltaEgat_d;
  double deltaEsti_d;
  double deltaEbot_d;
  double ubigat_d;
  double ubisti_d;
  double ubibot_d;
  double phigdgat_d;
  double phigdsti_d;
  double phigdbot_d;
  double phigrgat_d;
  double phigrsti_d;
  double phigrbot_d;
  double deltaEgat;
  double deltaEsti;
  double deltaEbot;
  double ubigat;
  double ubisti;
  double ubibot;
  double phigdgat;
  double phigdsti;
  double phigdbot;
  double deltaphigd;
  double phigrgat;
  double phigrsti;
  double phigrbot;
  double deltaphigr;
  double phitrinv;
  double KBOL_over_QELE;
  double auxt;
  double tkd;
  double tkr;
  double STFBBTGATD_i;
  double STFBBTSTID_i;
  double STFBBTBOTD_i;
  double FBBTRGATD_i;
  double FBBTRSTID_i;
  double FBBTRBOTD_i;
  double MEFFTATGATD_i;
  double MEFFTATSTID_i;
  double MEFFTATBOTD_i;
  double XJUNGATD_i;
  double XJUNSTID_i;
  double IDSATRGATD_i;
  double IDSATRSTID_i;
  double IDSATRBOTD_i;
  double PHIGGATD_i;
  double PHIGSTID_i;
  double PHIGBOTD_i;
  double CJORGATD_i;
  double CJORSTID_i;
  double CJORBOTD_i;
  double STFBBTGAT_i;
  double STFBBTSTI_i;
  double STFBBTBOT_i;
  double FBBTRGAT_i;
  double FBBTRSTI_i;
  double FBBTRBOT_i;
  double MEFFTATGAT_i;
  double MEFFTATSTI_i;
  double MEFFTATBOT_i;
  double XJUNGAT_i;
  double XJUNSTI_i;
  double IDSATRGAT_i;
  double IDSATRSTI_i;
  double IDSATRBOT_i;
  double PHIGGAT_i;
  double PHIGSTI_i;
  double PHIGBOT_i;
  double CJORGAT_i;
  double CJORSTI_i;
  double CJORBOT_i;
  double FREV_i;
  double TRJ_i;
  double TKD_sq;
  double TKA;
  double TKR;
  double TR_i;
  //Begin block initial_model
  {
    if ((TYPE>=0))
    {
      CHNL_TYPE = (+1);
    }
    else
    {
      CHNL_TYPE = (-1);
    }
    EPSSI = (8.8541878176E-12*11.8);
    {
      double value_floor_0 = floor((((SWGEO>0.0)?((SWGEO<2.0)?SWGEO:2.0):0.0)+0.5));
      SWGEO_i = floor((((SWGEO>0.0)?((SWGEO<2.0)?SWGEO:2.0):0.0)+0.5));
    }
    {
      double value_floor_0 = floor((((SWIGATE>0.0)?((SWIGATE<1.0)?SWIGATE:1.0):0.0)+0.5));
      SWIGATE_i = floor((((SWIGATE>0.0)?((SWIGATE<1.0)?SWIGATE:1.0):0.0)+0.5));
    }
    {
      double value_floor_0 = floor((((SWIMPACT>0.0)?((SWIMPACT<1.0)?SWIMPACT:1.0):0.0)+0.5));
      SWIMPACT_i = floor((((SWIMPACT>0.0)?((SWIMPACT<1.0)?SWIMPACT:1.0):0.0)+0.5));
    }
    {
      double value_floor_0 = floor((((SWGIDL>0.0)?((SWGIDL<1.0)?SWGIDL:1.0):0.0)+0.5));
      SWGIDL_i = floor((((SWGIDL>0.0)?((SWGIDL<1.0)?SWGIDL:1.0):0.0)+0.5));
    }
    {
      double value_floor_0 = floor((((SWJUNCAP>0.0)?((SWJUNCAP<3.0)?SWJUNCAP:3.0):0.0)+0.5));
      SWJUNCAP_i = floor((((SWJUNCAP>0.0)?((SWJUNCAP<3.0)?SWJUNCAP:3.0):0.0)+0.5));
    }
    {
      double value_floor_0 = floor((((SWJUNASYM>0.0)?((SWJUNASYM<1.0)?SWJUNASYM:1.0):0.0)+0.5));
      SWJUNASYM_i = floor((((SWJUNASYM>0.0)?((SWJUNASYM<1.0)?SWJUNASYM:1.0):0.0)+0.5));
    }
    {
      double value_floor_0 = floor((((SWNUD>0.0)?((SWNUD<2.0)?SWNUD:2.0):0.0)+0.5));
      SWNUD_i = floor((((SWNUD>0.0)?((SWNUD<2.0)?SWNUD:2.0):0.0)+0.5));
    }
    {
      double value_floor_0 = floor((((SWEDGE>0.0)?((SWEDGE<1.0)?SWEDGE:1.0):0.0)+0.5));
      SWEDGE_i = floor((((SWEDGE>0.0)?((SWEDGE<1.0)?SWEDGE:1.0):0.0)+0.5));
    }
    {
      double value_floor_0 = floor((((SWDELVTAC>0.0)?((SWDELVTAC<1.0)?SWDELVTAC:1.0):0.0)+0.5));
      SWDELVTAC_i = floor((((SWDELVTAC>0.0)?((SWDELVTAC<1.0)?SWDELVTAC:1.0):0.0)+0.5));
    }
    {
      double value_floor_0 = floor((((SWIGN>0.0)?((SWIGN<1.0)?SWIGN:1.0):0.0)+0.5));
      SWIGN_i = floor((((SWIGN>0.0)?((SWIGN<1.0)?SWIGN:1.0):0.0)+0.5));
    }
    QMC_i = ((QMC>0.0)?QMC:0.0);
    TOXO_i = ((TOXO>1.0e-10)?TOXO:1.0e-10);
    EPSROXO_i = ((EPSROXO>1.0)?EPSROXO:1.0);
    NSUBO_i = ((NSUBO>1.0e20)?NSUBO:1.0e20);
    WSEG_i = ((WSEG>1.0e-10)?WSEG:1.0e-10);
    NPCK_i = ((NPCK>0.0)?NPCK:0.0);
    WSEGP_i = ((WSEGP>1.0e-10)?WSEGP:1.0e-10);
    LPCK_i = ((LPCK>1.0e-10)?LPCK:1.0e-10);
    TOXOVO_i = ((TOXOVO>1.0e-10)?TOXOVO:1.0e-10);
    TOXOVDO_i = ((TOXOVDO>1.0e-10)?TOXOVDO:1.0e-10);
    LOV_i = ((LOV>0.0)?LOV:0.0);
    LOVD_i = ((LOVD>0.0)?LOVD:0.0);
    LP1_i = ((LP1>1.0e-10)?LP1:1.0e-10);
    LP2_i = ((LP2>1.0e-10)?LP2:1.0e-10);
    WBET_i = ((WBET>1.0e-10)?WBET:1.0e-10);
    AXL_i = ((AXL>0.0)?AXL:0.0);
    ALP1L2_i = ((ALP1L2>0.0)?ALP1L2:0.0);
    ALP2L2_i = ((ALP2L2>0.0)?ALP2L2:0.0);
    SAREF_i = ((SAREF>1.0e-9)?SAREF:1.0e-9);
    SBREF_i = ((SBREF>1.0e-9)?SBREF:1.0e-9);
    KVSAT_i = ((KVSAT>(-1.0))?((KVSAT<1.0)?KVSAT:1.0):(-1.0));
    LLODKUO_i = ((LLODKUO>0.0)?LLODKUO:0.0);
    WLODKUO_i = ((WLODKUO>0.0)?WLODKUO:0.0);
    LLODVTH_i = ((LLODVTH>0.0)?LLODVTH:0.0);
    WLODVTH_i = ((WLODVTH>0.0)?WLODVTH:0.0);
    LODETAO_i = ((LODETAO>0.0)?LODETAO:0.0);
    SCREF_i = ((SCREF>0.0)?SCREF:0.0);
    WEB_i = WEB;
    WEC_i = WEC;
    RSHG_i = ((RSHG>0.0)?RSHG:0.0);
    RSH_i = ((RSH>0.0)?RSH:0.0);
    RSHD_i = ((RSHD>0.0)?RSHD:0.0);
    RINT_i = ((RINT>0.0)?RINT:0.0);
    RVPOLY_i = ((RVPOLY>0.0)?RVPOLY:0.0);
    NSUBEDGEO_i = ((NSUBEDGEO>1.0e20)?NSUBEDGEO:1.0e20);
    LPEDGE_i = ((LPEDGE>1.0e-10)?LPEDGE:1.0e-10);
    TR_i = ((TR>(-273.0))?TR:(-273.0));
    TKR = (273.15+TR_i);
    TKA = (admsModTemp+DTA);
    rTa = (TKA/TKR);
    delTa = (TKA-TKR);
    phita = ((TKA*1.3806505E-23)/1.6021918E-19);
    inv_phita = (1.0/phita);
    TKD = TKA;
    TKD_sq = (TKD*TKD);
    delT = (TKD-TKR);
    rTn = (TKR/TKD);
    {
      double value_log_0 = log(rTn);
      ln_rTn = value_log_0;
    }
    phit = ((TKD*1.3806505E-23)/1.6021918E-19);
    inv_phit = (1.0/phit);
    Eg = ((1.179-(9.025e-5*TKD))-(3.05e-7*TKD_sq));
    phibFac = ((((1.045+(4.5e-4*TKD))*((0.523+(1.4e-3*TKD))-(1.48e-6*TKD_sq)))*TKD_sq)/9.0E4);
    phibFac = ((phibFac>1.0E-3)?phibFac:1.0E-3);
    nt0 = ((4.0*1.3806505E-23)*TKD);
    TRJ_i = ((TRJ>(-2.5e2))?TRJ:(-2.5e2));
    IMAX_i = ((IMAX>1.0e-12)?IMAX:1.0e-12);
    FREV_i = ((FREV>1.0e1)?((FREV<1.0e10)?FREV:1.0e10):1.0e1);
    CJORBOT_i = ((CJORBOT>1.0e-12)?CJORBOT:1.0e-12);
    CJORSTI_i = ((CJORSTI>1.0e-18)?CJORSTI:1.0e-18);
    CJORGAT_i = ((CJORGAT>1.0e-18)?CJORGAT:1.0e-18);
    VBIRBOT_i = ((VBIRBOT>5.0e-2)?VBIRBOT:5.0e-2);
    VBIRSTI_i = ((VBIRSTI>5.0e-2)?VBIRSTI:5.0e-2);
    VBIRGAT_i = ((VBIRGAT>5.0e-2)?VBIRGAT:5.0e-2);
    PBOT_i = ((PBOT>5.0e-2)?((PBOT<0.95)?PBOT:0.95):5.0e-2);
    PSTI_i = ((PSTI>5.0e-2)?((PSTI<0.95)?PSTI:0.95):5.0e-2);
    PGAT_i = ((PGAT>5.0e-2)?((PGAT<0.95)?PGAT:0.95):5.0e-2);
    PHIGBOT_i = PHIGBOT;
    PHIGSTI_i = PHIGSTI;
    PHIGGAT_i = PHIGGAT;
    IDSATRBOT_i = ((IDSATRBOT>0.0)?IDSATRBOT:0.0);
    IDSATRSTI_i = ((IDSATRSTI>0.0)?IDSATRSTI:0.0);
    IDSATRGAT_i = ((IDSATRGAT>0.0)?IDSATRGAT:0.0);
    CSRHBOT_i = ((CSRHBOT>0.0)?CSRHBOT:0.0);
    CSRHSTI_i = ((CSRHSTI>0.0)?CSRHSTI:0.0);
    CSRHGAT_i = ((CSRHGAT>0.0)?CSRHGAT:0.0);
    XJUNSTI_i = ((XJUNSTI>1.0e-9)?XJUNSTI:1.0e-9);
    XJUNGAT_i = ((XJUNGAT>1.0e-9)?XJUNGAT:1.0e-9);
    CTATBOT_i = ((CTATBOT>0.0)?CTATBOT:0.0);
    CTATSTI_i = ((CTATSTI>0.0)?CTATSTI:0.0);
    CTATGAT_i = ((CTATGAT>0.0)?CTATGAT:0.0);
    MEFFTATBOT_i = ((MEFFTATBOT>1.0e-2)?MEFFTATBOT:1.0e-2);
    MEFFTATSTI_i = ((MEFFTATSTI>1.0e-2)?MEFFTATSTI:1.0e-2);
    MEFFTATGAT_i = ((MEFFTATGAT>1.0e-2)?MEFFTATGAT:1.0e-2);
    CBBTBOT_i = ((CBBTBOT>0.0)?CBBTBOT:0.0);
    CBBTSTI_i = ((CBBTSTI>0.0)?CBBTSTI:0.0);
    CBBTGAT_i = ((CBBTGAT>0.0)?CBBTGAT:0.0);
    FBBTRBOT_i = FBBTRBOT;
    FBBTRSTI_i = FBBTRSTI;
    FBBTRGAT_i = FBBTRGAT;
    STFBBTBOT_i = STFBBTBOT;
    STFBBTSTI_i = STFBBTSTI;
    STFBBTGAT_i = STFBBTGAT;
    VBRBOT_i = ((VBRBOT>0.1)?VBRBOT:0.1);
    VBRSTI_i = ((VBRSTI>0.1)?VBRSTI:0.1);
    VBRGAT_i = ((VBRGAT>0.1)?VBRGAT:0.1);
    PBRBOT_i = ((PBRBOT>0.1)?PBRBOT:0.1);
    PBRSTI_i = ((PBRSTI>0.1)?PBRSTI:0.1);
    PBRGAT_i = ((PBRGAT>0.1)?PBRGAT:0.1);
    SWJUNEXP_i = 0.0;
    if ((SWJUNEXP>0.5))
    {
      SWJUNEXP_i = 1.0;
    }
    else
    {
      SWJUNEXP_i = 0.0;
    }
    VJUNREF_i = ((VJUNREF>0.5)?VJUNREF:0.5);
    FJUNQ_i = ((FJUNQ>0.0)?FJUNQ:0.0);
    if ((SWJUNASYM==0.0))
    {
      CJORBOTD_i = CJORBOT_i;
      CJORSTID_i = CJORSTI_i;
      CJORGATD_i = CJORGAT_i;
      VBIRBOTD_i = VBIRBOT_i;
      VBIRSTID_i = VBIRSTI_i;
      VBIRGATD_i = VBIRGAT_i;
      PBOTD_i = PBOT_i;
      PSTID_i = PSTI_i;
      PGATD_i = PGAT_i;
      PHIGBOTD_i = PHIGBOT_i;
      PHIGSTID_i = PHIGSTI_i;
      PHIGGATD_i = PHIGGAT_i;
      IDSATRBOTD_i = IDSATRBOT_i;
      IDSATRSTID_i = IDSATRSTI_i;
      IDSATRGATD_i = IDSATRGAT_i;
      CSRHBOTD_i = CSRHBOT_i;
      CSRHSTID_i = CSRHSTI_i;
      CSRHGATD_i = CSRHGAT_i;
      XJUNSTID_i = XJUNSTI_i;
      XJUNGATD_i = XJUNGAT_i;
      CTATBOTD_i = CTATBOT_i;
      CTATSTID_i = CTATSTI_i;
      CTATGATD_i = CTATGAT_i;
      MEFFTATBOTD_i = MEFFTATBOT_i;
      MEFFTATSTID_i = MEFFTATSTI_i;
      MEFFTATGATD_i = MEFFTATGAT_i;
      CBBTBOTD_i = CBBTBOT_i;
      CBBTSTID_i = CBBTSTI_i;
      CBBTGATD_i = CBBTGAT_i;
      FBBTRBOTD_i = FBBTRBOT_i;
      FBBTRSTID_i = FBBTRSTI_i;
      FBBTRGATD_i = FBBTRGAT_i;
      STFBBTBOTD_i = STFBBTBOT_i;
      STFBBTSTID_i = STFBBTSTI_i;
      STFBBTGATD_i = STFBBTGAT_i;
      VBRBOTD_i = VBRBOT_i;
      VBRSTID_i = VBRSTI_i;
      VBRGATD_i = VBRGAT_i;
      PBRBOTD_i = PBRBOT_i;
      PBRSTID_i = PBRSTI_i;
      PBRGATD_i = PBRGAT_i;
      VJUNREFD_i = VJUNREF_i;
      FJUNQD_i = FJUNQ_i;
    }
    else
    {
      CJORBOTD_i = ((CJORBOTD>1.0e-12)?CJORBOTD:1.0e-12);
      CJORSTID_i = ((CJORSTID>1.0e-18)?CJORSTID:1.0e-18);
      CJORGATD_i = ((CJORGATD>1.0e-18)?CJORGATD:1.0e-18);
      VBIRBOTD_i = ((VBIRBOTD>5.0e-2)?VBIRBOTD:5.0e-2);
      VBIRSTID_i = ((VBIRSTID>5.0e-2)?VBIRSTID:5.0e-2);
      VBIRGATD_i = ((VBIRGATD>5.0e-2)?VBIRGATD:5.0e-2);
      PBOTD_i = ((PBOTD>5.0e-2)?((PBOTD<0.95)?PBOTD:0.95):5.0e-2);
      PSTID_i = ((PSTID>5.0e-2)?((PSTID<0.95)?PSTID:0.95):5.0e-2);
      PGATD_i = ((PGATD>5.0e-2)?((PGATD<0.95)?PGATD:0.95):5.0e-2);
      PHIGBOTD_i = PHIGBOTD;
      PHIGSTID_i = PHIGSTID;
      PHIGGATD_i = PHIGGATD;
      IDSATRBOTD_i = ((IDSATRBOTD>0.0)?IDSATRBOTD:0.0);
      IDSATRSTID_i = ((IDSATRSTID>0.0)?IDSATRSTID:0.0);
      IDSATRGATD_i = ((IDSATRGATD>0.0)?IDSATRGATD:0.0);
      CSRHBOTD_i = ((CSRHBOTD>0.0)?CSRHBOTD:0.0);
      CSRHSTID_i = ((CSRHSTID>0.0)?CSRHSTID:0.0);
      CSRHGATD_i = ((CSRHGATD>0.0)?CSRHGATD:0.0);
      XJUNSTID_i = ((XJUNSTID>1.0e-9)?XJUNSTID:1.0e-9);
      XJUNGATD_i = ((XJUNGATD>1.0e-9)?XJUNGATD:1.0e-9);
      CTATBOTD_i = ((CTATBOTD>0.0)?CTATBOTD:0.0);
      CTATSTID_i = ((CTATSTID>0.0)?CTATSTID:0.0);
      CTATGATD_i = ((CTATGATD>0.0)?CTATGATD:0.0);
      MEFFTATBOTD_i = ((MEFFTATBOTD>1.0e-2)?MEFFTATBOTD:1.0e-2);
      MEFFTATSTID_i = ((MEFFTATSTID>1.0e-2)?MEFFTATSTID:1.0e-2);
      MEFFTATGATD_i = ((MEFFTATGATD>1.0e-2)?MEFFTATGATD:1.0e-2);
      CBBTBOTD_i = ((CBBTBOTD>0.0)?CBBTBOTD:0.0);
      CBBTSTID_i = ((CBBTSTID>0.0)?CBBTSTID:0.0);
      CBBTGATD_i = ((CBBTGATD>0.0)?CBBTGATD:0.0);
      FBBTRBOTD_i = FBBTRBOTD;
      FBBTRSTID_i = FBBTRSTID;
      FBBTRGATD_i = FBBTRGATD;
      STFBBTBOTD_i = STFBBTBOTD;
      STFBBTSTID_i = STFBBTSTID;
      STFBBTGATD_i = STFBBTGATD;
      VBRBOTD_i = ((VBRBOTD>0.1)?VBRBOTD:0.1);
      VBRSTID_i = ((VBRSTID>0.1)?VBRSTID:0.1);
      VBRGATD_i = ((VBRGATD>0.1)?VBRGATD:0.1);
      PBRBOTD_i = ((PBRBOTD>0.1)?PBRBOTD:0.1);
      PBRSTID_i = ((PBRSTID>0.1)?PBRSTID:0.1);
      PBRGATD_i = ((PBRGATD>0.1)?PBRGATD:0.1);
      VJUNREFD_i = ((VJUNREFD>0.5)?VJUNREFD:0.5);
      FJUNQD_i = ((FJUNQD>0.0)?FJUNQD:0.0);
    }
    tkr = (273.15+TRJ_i);
    {
      double value_max_0 = std::max((admsModTemp+DTA),(273.15+(-2.5e2)));
      tkd = value_max_0;
    }
    auxt = (tkd/tkr);
    KBOL_over_QELE = (1.3806505E-23/1.6021918E-19);
    phitr = (KBOL_over_QELE*tkr);
    phitrinv = (1.0/phitr);
    phitd = (KBOL_over_QELE*tkd);
    phitdinv = (1.0/phitd);
    deltaphigr = ((-((7.02e-4*tkr)*tkr))/(1108.0+tkr));
    phigrbot = (PHIGBOT_i+deltaphigr);
    phigrsti = (PHIGSTI_i+deltaphigr);
    phigrgat = (PHIGGAT_i+deltaphigr);
    deltaphigd = ((-((7.02e-4*tkd)*tkd))/(1108.0+tkd));
    phigdbot = (PHIGBOT_i+deltaphigd);
    phigdsti = (PHIGSTI_i+deltaphigd);
    phigdgat = (PHIGGAT_i+deltaphigd);
    {
      double value_pow_0 = pow(auxt,1.5);
      double value_exp_1 = exp((0.5*((phigrbot*phitrinv)-(phigdbot*phitdinv))));
      ftdbot = (value_pow_0*value_exp_1);
    }
    {
      double value_pow_0 = pow(auxt,1.5);
      double value_exp_1 = exp((0.5*((phigrsti*phitrinv)-(phigdsti*phitdinv))));
      ftdsti = (value_pow_0*value_exp_1);
    }
    {
      double value_pow_0 = pow(auxt,1.5);
      double value_exp_1 = exp((0.5*((phigrgat*phitrinv)-(phigdgat*phitdinv))));
      ftdgat = (value_pow_0*value_exp_1);
    }
    idsatbot = ((IDSATRBOT_i*ftdbot)*ftdbot);
    idsatsti = ((IDSATRSTI_i*ftdsti)*ftdsti);
    idsatgat = ((IDSATRGAT_i*ftdgat)*ftdgat);
    {
      double value_log_0 = log(ftdbot);
      ubibot = ((VBIRBOT_i*auxt)-((2.0*phitd)*value_log_0));
    }
    {
      double value_log_0 = log(ftdsti);
      ubisti = ((VBIRSTI_i*auxt)-((2.0*phitd)*value_log_0));
    }
    {
      double value_log_0 = log(ftdgat);
      ubigat = ((VBIRGAT_i*auxt)-((2.0*phitd)*value_log_0));
    }
    {
      double value_exp_0 = exp(((5.0e-2-ubibot)*phitdinv));
      double value_log_1 = log((1+value_exp_0));
      vbibot = (ubibot+(phitd*value_log_1));
    }
    {
      double value_exp_0 = exp(((5.0e-2-ubisti)*phitdinv));
      double value_log_1 = log((1+value_exp_0));
      vbisti = (ubisti+(phitd*value_log_1));
    }
    {
      double value_exp_0 = exp(((5.0e-2-ubigat)*phitdinv));
      double value_log_1 = log((1+value_exp_0));
      vbigat = (ubigat+(phitd*value_log_1));
    }
    vbiinvbot = (1.0/vbibot);
    vbiinvsti = (1.0/vbisti);
    vbiinvgat = (1.0/vbigat);
    one_minus_PBOT = (1.0-PBOT_i);
    one_minus_PSTI = (1.0-PSTI_i);
    one_minus_PGAT = (1.0-PGAT_i);
    one_over_one_minus_PBOT = (1.0/one_minus_PBOT);
    one_over_one_minus_PSTI = (1.0/one_minus_PSTI);
    one_over_one_minus_PGAT = (1.0/one_minus_PGAT);
    {
      double value_pow_0 = pow((VBIRBOT_i*vbiinvbot),PBOT_i);
      cjobot = (CJORBOT_i*value_pow_0);
    }
    {
      double value_pow_0 = pow((VBIRSTI_i*vbiinvsti),PSTI_i);
      cjosti = (CJORSTI_i*value_pow_0);
    }
    {
      double value_pow_0 = pow((VBIRGAT_i*vbiinvgat),PGAT_i);
      cjogat = (CJORGAT_i*value_pow_0);
    }
    qprefbot = ((cjobot*vbibot)*one_over_one_minus_PBOT);
    qprefsti = ((cjosti*vbisti)*one_over_one_minus_PSTI);
    qprefgat = ((cjogat*vbigat)*one_over_one_minus_PGAT);
    qpref2bot = (2.0*cjobot);
    qpref2sti = (2.0*cjosti);
    qpref2gat = (2.0*cjogat);
    wdepnulrbot = (EPSSI/CJORBOT_i);
    wdepnulrsti = ((XJUNSTI_i*EPSSI)/CJORSTI_i);
    wdepnulrgat = ((XJUNGAT_i*EPSSI)/CJORGAT_i);
    wdepnulrinvbot = (1.0/wdepnulrbot);
    wdepnulrinvsti = (1.0/wdepnulrsti);
    wdepnulrinvgat = (1.0/wdepnulrgat);
    VBIRBOTinv = (1.0/VBIRBOT_i);
    VBIRSTIinv = (1.0/VBIRSTI_i);
    VBIRGATinv = (1.0/VBIRGAT_i);
    perfc = (1.77245385090551603*0.29214664);
    {
      double value_pow_0 = pow(perfc,(-2.0));
      berfc = (((((-5.0)*0.29214664)+6.0)-value_pow_0)/3.0);
    }
    cerfc = ((1.0-0.29214664)-berfc);
    {
      double value_max_0 = std::max((0.5*phigdbot),phitd);
      deltaEbot = value_max_0;
    }
    {
      double value_max_0 = std::max((0.5*phigdsti),phitd);
      deltaEsti = value_max_0;
    }
    {
      double value_max_0 = std::max((0.5*phigdgat),phitd);
      deltaEgat = value_max_0;
    }
    atatbot = (deltaEbot*phitdinv);
    atatsti = (deltaEsti*phitdinv);
    atatgat = (deltaEgat*phitdinv);
    {
      double value_sqrt_0 = sqrt(((((32.0*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*deltaEbot)));
      btatpartbot = (value_sqrt_0/(3.0*1.05457168E-34));
    }
    {
      double value_sqrt_0 = sqrt(((((32.0*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*deltaEsti)));
      btatpartsti = (value_sqrt_0/(3.0*1.05457168E-34));
    }
    {
      double value_sqrt_0 = sqrt(((((32.0*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*deltaEgat)));
      btatpartgat = (value_sqrt_0/(3.0*1.05457168E-34));
    }
    fbbtbot = (FBBTRBOT_i*(1.0+(STFBBTBOT_i*(tkd-tkr))));
    fbbtsti = (FBBTRSTI_i*(1.0+(STFBBTSTI_i*(tkd-tkr))));
    fbbtgat = (FBBTRGAT_i*(1.0+(STFBBTGAT_i*(tkd-tkr))));
    fbbtbot = ((fbbtbot>0.0)?fbbtbot:0.0);
    fbbtsti = ((fbbtsti>0.0)?fbbtsti:0.0);
    fbbtgat = ((fbbtgat>0.0)?fbbtgat:0.0);
    alphaav = (1.0-(1.0/FREV_i));
    {
      double value_pow_0 = pow(alphaav,PBRBOT_i);
      fstopbot = (1.0/(1.0-value_pow_0));
    }
    {
      double value_pow_0 = pow(alphaav,PBRSTI_i);
      fstopsti = (1.0/(1.0-value_pow_0));
    }
    {
      double value_pow_0 = pow(alphaav,PBRGAT_i);
      fstopgat = (1.0/(1.0-value_pow_0));
    }
    VBRinvbot = (1.0/VBRBOT_i);
    VBRinvsti = (1.0/VBRSTI_i);
    VBRinvgat = (1.0/VBRGAT_i);
    {
      double value_pow_0 = pow(alphaav,(PBRBOT_i-1.0));
      slopebot = (((-((fstopbot*fstopbot)*value_pow_0))*PBRBOT_i)*VBRinvbot);
    }
    {
      double value_pow_0 = pow(alphaav,(PBRSTI_i-1.0));
      slopesti = (((-((fstopsti*fstopsti)*value_pow_0))*PBRSTI_i)*VBRinvsti);
    }
    {
      double value_pow_0 = pow(alphaav,(PBRGAT_i-1.0));
      slopegat = (((-((fstopgat*fstopgat)*value_pow_0))*PBRGAT_i)*VBRinvgat);
    }
    phigrbot_d = (PHIGBOTD_i+deltaphigr);
    phigrsti_d = (PHIGSTID_i+deltaphigr);
    phigrgat_d = (PHIGGATD_i+deltaphigr);
    phigdbot_d = (PHIGBOTD_i+deltaphigd);
    phigdsti_d = (PHIGSTID_i+deltaphigd);
    phigdgat_d = (PHIGGATD_i+deltaphigd);
    {
      double value_pow_0 = pow(auxt,1.5);
      double value_exp_1 = exp((0.5*((phigrbot_d*phitrinv)-(phigdbot_d*phitdinv))));
      ftdbot_d = (value_pow_0*value_exp_1);
    }
    {
      double value_pow_0 = pow(auxt,1.5);
      double value_exp_1 = exp((0.5*((phigrsti_d*phitrinv)-(phigdsti_d*phitdinv))));
      ftdsti_d = (value_pow_0*value_exp_1);
    }
    {
      double value_pow_0 = pow(auxt,1.5);
      double value_exp_1 = exp((0.5*((phigrgat_d*phitrinv)-(phigdgat_d*phitdinv))));
      ftdgat_d = (value_pow_0*value_exp_1);
    }
    idsatbot_d = ((IDSATRBOTD_i*ftdbot_d)*ftdbot_d);
    idsatsti_d = ((IDSATRSTID_i*ftdsti_d)*ftdsti_d);
    idsatgat_d = ((IDSATRGATD_i*ftdgat_d)*ftdgat_d);
    {
      double value_log_0 = log(ftdbot_d);
      ubibot_d = ((VBIRBOTD_i*auxt)-((2.0*phitd)*value_log_0));
    }
    {
      double value_log_0 = log(ftdsti_d);
      ubisti_d = ((VBIRSTID_i*auxt)-((2.0*phitd)*value_log_0));
    }
    {
      double value_log_0 = log(ftdgat_d);
      ubigat_d = ((VBIRGATD_i*auxt)-((2.0*phitd)*value_log_0));
    }
    {
      double value_exp_0 = exp(((5.0e-2-ubibot_d)*phitdinv));
      double value_log_1 = log((1.0+value_exp_0));
      vbibot_d = (ubibot_d+(phitd*value_log_1));
    }
    {
      double value_exp_0 = exp(((5.0e-2-ubisti_d)*phitdinv));
      double value_log_1 = log((1.0+value_exp_0));
      vbisti_d = (ubisti_d+(phitd*value_log_1));
    }
    {
      double value_exp_0 = exp(((5.0e-2-ubigat_d)*phitdinv));
      double value_log_1 = log((1.0+value_exp_0));
      vbigat_d = (ubigat_d+(phitd*value_log_1));
    }
    vbiinvbot_d = (1.0/vbibot_d);
    vbiinvsti_d = (1.0/vbisti_d);
    vbiinvgat_d = (1.0/vbigat_d);
    one_minus_PBOT_d = (1.0-PBOTD_i);
    one_minus_PSTI_d = (1.0-PSTID_i);
    one_minus_PGAT_d = (1.0-PGATD_i);
    one_over_one_minus_PBOT_d = (1.0/one_minus_PBOT_d);
    one_over_one_minus_PSTI_d = (1.0/one_minus_PSTI_d);
    one_over_one_minus_PGAT_d = (1.0/one_minus_PGAT_d);
    {
      double value_pow_0 = pow((VBIRBOTD_i*vbiinvbot_d),PBOTD_i);
      cjobot_d = (CJORBOTD_i*value_pow_0);
    }
    {
      double value_pow_0 = pow((VBIRSTID_i*vbiinvsti_d),PSTID_i);
      cjosti_d = (CJORSTID_i*value_pow_0);
    }
    {
      double value_pow_0 = pow((VBIRGATD_i*vbiinvgat_d),PGATD_i);
      cjogat_d = (CJORGATD_i*value_pow_0);
    }
    qprefbot_d = ((cjobot_d*vbibot_d)*one_over_one_minus_PBOT_d);
    qprefsti_d = ((cjosti_d*vbisti_d)*one_over_one_minus_PSTI_d);
    qprefgat_d = ((cjogat_d*vbigat_d)*one_over_one_minus_PGAT_d);
    qpref2bot_d = (2.0*cjobot_d);
    qpref2sti_d = (2.0*cjosti_d);
    qpref2gat_d = (2.0*cjogat_d);
    wdepnulrbot_d = (EPSSI/CJORBOTD_i);
    wdepnulrsti_d = ((XJUNSTID_i*EPSSI)/CJORSTID_i);
    wdepnulrgat_d = ((XJUNGATD_i*EPSSI)/CJORGATD_i);
    wdepnulrinvbot_d = (1.0/wdepnulrbot_d);
    wdepnulrinvsti_d = (1.0/wdepnulrsti_d);
    wdepnulrinvgat_d = (1.0/wdepnulrgat_d);
    VBIRBOTinv_d = (1.0/VBIRBOTD_i);
    VBIRSTIinv_d = (1.0/VBIRSTID_i);
    VBIRGATinv_d = (1.0/VBIRGATD_i);
    {
      double value_max_0 = std::max((0.5*phigdbot_d),phitd);
      deltaEbot_d = value_max_0;
    }
    {
      double value_max_0 = std::max((0.5*phigdsti_d),phitd);
      deltaEsti_d = value_max_0;
    }
    {
      double value_max_0 = std::max((0.5*phigdgat_d),phitd);
      deltaEgat_d = value_max_0;
    }
    atatbot_d = (deltaEbot_d*phitdinv);
    atatsti_d = (deltaEsti_d*phitdinv);
    atatgat_d = (deltaEgat_d*phitdinv);
    {
      double value_sqrt_0 = sqrt(((((32.0*MEFFTATBOTD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot_d*deltaEbot_d)*deltaEbot_d)));
      btatpartbot_d = (value_sqrt_0/(3.0*1.05457168E-34));
    }
    {
      double value_sqrt_0 = sqrt(((((32.0*MEFFTATSTID_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti_d*deltaEsti_d)*deltaEsti_d)));
      btatpartsti_d = (value_sqrt_0/(3.0*1.05457168E-34));
    }
    {
      double value_sqrt_0 = sqrt(((((32.0*MEFFTATGATD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat_d*deltaEgat_d)*deltaEgat_d)));
      btatpartgat_d = (value_sqrt_0/(3.0*1.05457168E-34));
    }
    fbbtbot_d = (FBBTRBOTD_i*(1.0+(STFBBTBOTD_i*(tkd-tkr))));
    fbbtsti_d = (FBBTRSTID_i*(1.0+(STFBBTSTID_i*(tkd-tkr))));
    fbbtgat_d = (FBBTRGATD_i*(1.0+(STFBBTGATD_i*(tkd-tkr))));
    fbbtbot_d = ((fbbtbot_d>0.0)?fbbtbot_d:0.0);
    fbbtsti_d = ((fbbtsti_d>0.0)?fbbtsti_d:0.0);
    fbbtgat_d = ((fbbtgat_d>0.0)?fbbtgat_d:0.0);
    {
      double value_pow_0 = pow(alphaav,PBRBOTD_i);
      fstopbot_d = (1.0/(1.0-value_pow_0));
    }
    {
      double value_pow_0 = pow(alphaav,PBRSTID_i);
      fstopsti_d = (1.0/(1.0-value_pow_0));
    }
    {
      double value_pow_0 = pow(alphaav,PBRGATD_i);
      fstopgat_d = (1.0/(1.0-value_pow_0));
    }
    VBRinvbot_d = (1.0/VBRBOTD_i);
    VBRinvsti_d = (1.0/VBRSTID_i);
    VBRinvgat_d = (1.0/VBRGATD_i);
    {
      double value_pow_0 = pow(alphaav,(PBRBOTD_i-1.0));
      slopebot_d = (((-((fstopbot_d*fstopbot_d)*value_pow_0))*PBRBOTD_i)*VBRinvbot_d);
    }
    {
      double value_pow_0 = pow(alphaav,(PBRSTID_i-1.0));
      slopesti_d = (((-((fstopsti_d*fstopsti_d)*value_pow_0))*PBRSTID_i)*VBRinvsti_d);
    }
    {
      double value_pow_0 = pow(alphaav,(PBRGATD_i-1.0));
      slopegat_d = (((-((fstopgat_d*fstopgat_d)*value_pow_0))*PBRGATD_i)*VBRinvgat_d);
    }
  }
  // End block initial_model


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    LEVEL(103),
    TYPE(1),
    TR(21.0),
    SWGEO(1),
    SWIGATE(0),
    SWIMPACT(0),
    SWGIDL(0),
    SWJUNCAP(0),
    SWJUNASYM(0),
    SWNUD(0),
    SWEDGE(0),
    SWDELVTAC(0),
    SWIGN(1),
    QMC(1.0),
    VFB((-1.0)),
    STVFB(5.0e-4),
    TOX(2.0e-09),
    EPSROX(3.9),
    NEFF(5.0e23),
    FACNEFFAC(1.0),
    GFACNUD(1.0),
    VSBNUD(0.0),
    DVSBNUD(1.0),
    VNSUB(0.0),
    NSLP(0.05),
    DNSUB(0.0),
    DPHIB(0.0),
    DELVTAC(0.0),
    NP(1.0e26),
    CT(0.0),
    TOXOV(2.0e-09),
    TOXOVD(2.0e-09),
    NOV(5.0e25),
    NOVD(5.0e25),
    CF(0.0),
    CFD(0.0),
    CFB(0.0),
    PSCE(0.0),
    PSCEB(0.0),
    PSCED(0.0),
    BETN(7.0e-2),
    STBET(1.0),
    MUE(0.5),
    STMUE(0.0),
    THEMU(1.5),
    STTHEMU(1.5),
    CS(0.0),
    STCS(0.0),
    XCOR(0.0),
    STXCOR(0.0),
    FETA(1.0),
    RS(30.0),
    STRS(1.0),
    RSB(0.0),
    RSG(0.0),
    THESAT(1.0),
    STTHESAT(1.0),
    THESATB(0.0),
    THESATG(0.0),
    AX(3.0),
    ALP(0.01),
    ALP1(0.0),
    ALP2(0.0),
    VP(0.05),
    A1(1.0),
    A2(10.0),
    STA2(0.0),
    A3(1.0),
    A4(0.0),
    GCO(0.0),
    IGINV(0.0),
    IGOV(0.0),
    IGOVD(0.0),
    STIG(2.0),
    GC2(0.375),
    GC3(0.063),
    CHIB(3.1),
    AGIDL(0.0),
    AGIDLD(0.0),
    BGIDL(41.0),
    BGIDLD(41.0),
    STBGIDL(0.0),
    STBGIDLD(0.0),
    CGIDL(0.0),
    CGIDLD(0.0),
    COX(1.0e-14),
    CGOV(1.0e-15),
    CGOVD(1.0e-15),
    CGBOV(0.0),
    CFR(0.0),
    CFRD(0.0),
    FNT(1.0),
    FNTEXC(0.0),
    NFA(8.0e22),
    NFB(3.0e07),
    NFC(0.0),
    EF(1.0),
    VFBEDGE((-1.0)),
    STVFBEDGE(5.0e-4),
    DPHIBEDGE(0.0),
    NEFFEDGE(5.0e23),
    CTEDGE(0.0),
    BETNEDGE(5.0e-4),
    STBETEDGE(1.0),
    PSCEEDGE(0.0),
    PSCEBEDGE(0.0),
    PSCEDEDGE(0.0),
    CFEDGE(0.0),
    CFDEDGE(0.0),
    CFBEDGE(0.0),
    FNTEDGE(1.0),
    NFAEDGE(8.0e22),
    NFBEDGE(3.0e07),
    NFCEDGE(0.0),
    EFEDGE(1.0),
    RG(0.0),
    RSE(0.0),
    RDE(0.0),
    RBULK(0.0),
    RWELL(0.0),
    RJUNS(0.0),
    RJUND(0.0),
    POVFB((-1.0)),
    PLVFB(0.0),
    PWVFB(0.0),
    PLWVFB(0.0),
    POSTVFB(5.0e-4),
    PLSTVFB(0.0),
    PWSTVFB(0.0),
    PLWSTVFB(0.0),
    POTOX(2.0e-9),
    POEPSROX(3.9),
    PONEFF(5.0e23),
    PLNEFF(0.0),
    PWNEFF(0.0),
    PLWNEFF(0.0),
    POFACNEFFAC(1.0),
    PLFACNEFFAC(0.0),
    PWFACNEFFAC(0.0),
    PLWFACNEFFAC(0.0),
    POGFACNUD(1.0),
    PLGFACNUD(0.0),
    PWGFACNUD(0.0),
    PLWGFACNUD(0.0),
    POVSBNUD(0.0),
    PODVSBNUD(1.0),
    POVNSUB(0.0),
    PONSLP(0.05),
    PODNSUB(0.0),
    PODPHIB(0.0),
    PLDPHIB(0.0),
    PWDPHIB(0.0),
    PLWDPHIB(0.0),
    PODELVTAC(0.0),
    PLDELVTAC(0.0),
    PWDELVTAC(0.0),
    PLWDELVTAC(0.0),
    PONP(1.0e26),
    PLNP(0.0),
    PWNP(0.0),
    PLWNP(0.0),
    POCT(0.0),
    PLCT(0.0),
    PWCT(0.0),
    PLWCT(0.0),
    POTOXOV(2.0e-09),
    POTOXOVD(2.0e-09),
    PONOV(5.0e25),
    PLNOV(0.0),
    PWNOV(0.0),
    PLWNOV(0.0),
    PONOVD(5.0e25),
    PLNOVD(0.0),
    PWNOVD(0.0),
    PLWNOVD(0.0),
    POCF(0.0),
    PLCF(0.0),
    PWCF(0.0),
    PLWCF(0.0),
    POCFD(0.0),
    POCFB(0.0),
    POPSCE(0.0),
    PLPSCE(0.0),
    PWPSCE(0.0),
    PLWPSCE(0.0),
    POPSCEB(0.0),
    POPSCED(0.0),
    POBETN(7.0e-2),
    PLBETN(0.0),
    PWBETN(0.0),
    PLWBETN(0.0),
    POSTBET(1.0),
    PLSTBET(0.0),
    PWSTBET(0.0),
    PLWSTBET(0.0),
    POMUE(0.5),
    PLMUE(0.0),
    PWMUE(0.0),
    PLWMUE(0.0),
    POSTMUE(0.0),
    POTHEMU(1.5),
    POSTTHEMU(1.5),
    POCS(0.0),
    PLCS(0.0),
    PWCS(0.0),
    PLWCS(0.0),
    POSTCS(0.0),
    POXCOR(0.0),
    PLXCOR(0.0),
    PWXCOR(0.0),
    PLWXCOR(0.0),
    POSTXCOR(0.0),
    POFETA(1.0),
    PORS(30.0),
    PLRS(0.0),
    PWRS(0.0),
    PLWRS(0.0),
    POSTRS(1.0),
    PORSB(0.0),
    PORSG(0.0),
    POTHESAT(1.0),
    PLTHESAT(0.0),
    PWTHESAT(0.0),
    PLWTHESAT(0.0),
    POSTTHESAT(1.0),
    PLSTTHESAT(0.0),
    PWSTTHESAT(0.0),
    PLWSTTHESAT(0.0),
    POTHESATB(0.0),
    PLTHESATB(0.0),
    PWTHESATB(0.0),
    PLWTHESATB(0.0),
    POTHESATG(0.0),
    PLTHESATG(0.0),
    PWTHESATG(0.0),
    PLWTHESATG(0.0),
    POAX(3.0),
    PLAX(0.0),
    PWAX(0.0),
    PLWAX(0.0),
    POALP(1.0e-2),
    PLALP(0.0),
    PWALP(0.0),
    PLWALP(0.0),
    POALP1(0.0),
    PLALP1(0.0),
    PWALP1(0.0),
    PLWALP1(0.0),
    POALP2(0.0),
    PLALP2(0.0),
    PWALP2(0.0),
    PLWALP2(0.0),
    POVP(0.05),
    POA1(1.0),
    PLA1(0.0),
    PWA1(0.0),
    PLWA1(0.0),
    POA2(10.0),
    POSTA2(0.0),
    POA3(1.0),
    PLA3(0.0),
    PWA3(0.0),
    PLWA3(0.0),
    POA4(0.0),
    PLA4(0.0),
    PWA4(0.0),
    PLWA4(0.0),
    POGCO(0.0),
    POIGINV(0.0),
    PLIGINV(0.0),
    PWIGINV(0.0),
    PLWIGINV(0.0),
    POIGOV(0.0),
    PLIGOV(0.0),
    PWIGOV(0.0),
    PLWIGOV(0.0),
    POIGOVD(0.0),
    PLIGOVD(0.0),
    PWIGOVD(0.0),
    PLWIGOVD(0.0),
    POSTIG(2.0),
    POGC2(0.375),
    POGC3(0.063),
    POCHIB(3.1),
    POAGIDL(0.0),
    PLAGIDL(0.0),
    PWAGIDL(0.0),
    PLWAGIDL(0.0),
    POAGIDLD(0.0),
    PLAGIDLD(0.0),
    PWAGIDLD(0.0),
    PLWAGIDLD(0.0),
    POBGIDL(41.0),
    POBGIDLD(41.0),
    POSTBGIDL(0.0),
    POSTBGIDLD(0.0),
    POCGIDL(0.0),
    POCGIDLD(0.0),
    POCOX(1.0e-14),
    PLCOX(0.0),
    PWCOX(0.0),
    PLWCOX(0.0),
    POCGOV(1.0e-15),
    PLCGOV(0.0),
    PWCGOV(0.0),
    PLWCGOV(0.0),
    POCGOVD(1.0e-15),
    PLCGOVD(0.0),
    PWCGOVD(0.0),
    PLWCGOVD(0.0),
    POCGBOV(0.0),
    PLCGBOV(0.0),
    PWCGBOV(0.0),
    PLWCGBOV(0.0),
    POCFR(0.0),
    PLCFR(0.0),
    PWCFR(0.0),
    PLWCFR(0.0),
    POCFRD(0.0),
    PLCFRD(0.0),
    PWCFRD(0.0),
    PLWCFRD(0.0),
    POFNT(1.0),
    POFNTEXC(0.0),
    PLFNTEXC(0.0),
    PWFNTEXC(0.0),
    PLWFNTEXC(0.0),
    PONFA(8.0e22),
    PLNFA(0.0),
    PWNFA(0.0),
    PLWNFA(0.0),
    PONFB(3.0e7),
    PLNFB(0.0),
    PWNFB(0.0),
    PLWNFB(0.0),
    PONFC(0.0),
    PLNFC(0.0),
    PWNFC(0.0),
    PLWNFC(0.0),
    POEF(1.0),
    POVFBEDGE((-1.0)),
    POSTVFBEDGE(0.0),
    PLSTVFBEDGE(0.0),
    PWSTVFBEDGE(0.0),
    PLWSTVFBEDGE(0.0),
    PODPHIBEDGE(0.0),
    PLDPHIBEDGE(0.0),
    PWDPHIBEDGE(0.0),
    PLWDPHIBEDGE(0.0),
    PONEFFEDGE(5.0e23),
    PLNEFFEDGE(0.0),
    PWNEFFEDGE(0.0),
    PLWNEFFEDGE(0.0),
    POCTEDGE(0.0),
    PLCTEDGE(0.0),
    PWCTEDGE(0.0),
    PLWCTEDGE(0.0),
    POBETNEDGE(5.0e-4),
    PLBETNEDGE(0.0),
    PWBETNEDGE(0.0),
    PLWBETNEDGE(0.0),
    POSTBETEDGE(1.0),
    PLSTBETEDGE(0.0),
    PWSTBETEDGE(0.0),
    PLWSTBETEDGE(0.0),
    POPSCEEDGE(0.0),
    PLPSCEEDGE(0.0),
    PWPSCEEDGE(0.0),
    PLWPSCEEDGE(0.0),
    POPSCEBEDGE(0.0),
    POPSCEDEDGE(0.0),
    POCFEDGE(0.0),
    PLCFEDGE(0.0),
    PWCFEDGE(0.0),
    PLWCFEDGE(0.0),
    POCFDEDGE(0.0),
    POCFBEDGE(0.0),
    POFNTEDGE(1.0),
    PONFAEDGE(8.0e22),
    PLNFAEDGE(0.0),
    PWNFAEDGE(0.0),
    PLWNFAEDGE(0.0),
    PONFBEDGE(3.0e7),
    PLNFBEDGE(0.0),
    PWNFBEDGE(0.0),
    PLWNFBEDGE(0.0),
    PONFCEDGE(0.0),
    PLNFCEDGE(0.0),
    PWNFCEDGE(0.0),
    PLWNFCEDGE(0.0),
    POEFEDGE(1.0),
    POKVTHOWE(0.0),
    PLKVTHOWE(0.0),
    PWKVTHOWE(0.0),
    PLWKVTHOWE(0.0),
    POKUOWE(0.0),
    PLKUOWE(0.0),
    PWKUOWE(0.0),
    PLWKUOWE(0.0),
    LMIN(0),
    LMAX(1.0),
    WMIN(0.0),
    WMAX(1.0),
    LVARO(0.0),
    LVARL(0.0),
    LVARW(0.0),
    LAP(0.0),
    WVARO(0.0),
    WVARL(0.0),
    WVARW(0.0),
    WOT(0.0),
    DLQ(0.0),
    DWQ(0.0),
    VFBO((-1.0)),
    VFBL(0.0),
    VFBW(0.0),
    VFBLW(0.0),
    STVFBO(5.0e-4),
    STVFBL(0.0),
    STVFBW(0.0),
    STVFBLW(0.0),
    TOXO(2.0e-9),
    EPSROXO(3.9),
    NSUBO(3.0e23),
    NSUBW(0.0),
    WSEG(1.0e-8),
    NPCK(1.0e24),
    NPCKW(0.0),
    WSEGP(1.0e-8),
    LPCK(1.0e-8),
    LPCKW(0.0),
    FOL1(0.0),
    FOL2(0.0),
    FACNEFFACO(1.0),
    FACNEFFACL(0.0),
    FACNEFFACW(0.0),
    FACNEFFACLW(0.0),
    GFACNUDO(1.0),
    GFACNUDL(0.0),
    GFACNUDLEXP(1.0),
    GFACNUDW(0.0),
    GFACNUDLW(0.0),
    VSBNUDO(0.0),
    DVSBNUDO(1.0),
    VNSUBO(0.0),
    NSLPO(0.05),
    DNSUBO(0.0),
    DPHIBO(0.0),
    DPHIBL(0.0),
    DPHIBLEXP(1.0),
    DPHIBW(0.0),
    DPHIBLW(0.0),
    DELVTACO(0.0),
    DELVTACL(0.0),
    DELVTACLEXP(1.0),
    DELVTACW(0.0),
    DELVTACLW(0.0),
    NPO(1.0e26),
    NPL(0.0),
    CTO(0.0),
    CTL(0.0),
    CTLEXP(1.0),
    CTW(0.0),
    CTLW(0.0),
    TOXOVO(2.0e-9),
    TOXOVDO(2.0e-9),
    LOV(0.0),
    LOVD(0.0),
    NOVO(5e25),
    NOVDO(5e25),
    CFL(0.0),
    CFLEXP(2.0),
    CFW(0.0),
    CFDO(0.0),
    CFBO(0.0),
    PSCEL(0.0),
    PSCELEXP(2.0),
    PSCEW(0.0),
    PSCEBO(0.0),
    PSCEDO(0.0),
    UO(5.0e-2),
    FBET1(0.0),
    FBET1W(0.0),
    LP1(1.0e-8),
    LP1W(0.0),
    FBET2(0.0),
    LP2(1.0e-8),
    BETW1(0.0),
    BETW2(0.0),
    WBET(1.0e-9),
    STBETO(1.0),
    STBETL(0.0),
    STBETW(0.0),
    STBETLW(0.0),
    MUEO(0.5),
    MUEW(0.0),
    STMUEO(0.0),
    THEMUO(1.5),
    STTHEMUO(1.5),
    CSO(0.0),
    CSL(0.0),
    CSLEXP(1.0),
    CSW(0.0),
    CSLW(0.0),
    STCSO(0.0),
    XCORO(0.0),
    XCORL(0.0),
    XCORW(0.0),
    XCORLW(0.0),
    STXCORO(0.0),
    FETAO(1.0),
    RSW1(50.0),
    RSW2(0.0),
    STRSO(1.0),
    RSBO(0.0),
    RSGO(0.0),
    THESATO(0.0),
    THESATL(0.05),
    THESATLEXP(1.0),
    THESATW(0.0),
    THESATLW(0.0),
    STTHESATO(1.0),
    STTHESATL(0.0),
    STTHESATW(0.0),
    STTHESATLW(0.0),
    THESATBO(0.0),
    THESATGO(0.0),
    AXO(18.0),
    AXL(0.4),
    ALPL(5.0e-4),
    ALPLEXP(1.0),
    ALPW(0.0),
    ALP1L1(0.0),
    ALP1LEXP(0.5),
    ALP1L2(0.0),
    ALP1W(0.0),
    ALP2L1(0.0),
    ALP2LEXP(0.5),
    ALP2L2(0.0),
    ALP2W(0.0),
    VPO(0.05),
    A1O(1.0),
    A1L(0.0),
    A1W(0.0),
    A2O(10.0),
    STA2O(0.0),
    A3O(1.0),
    A3L(0.0),
    A3W(0.0),
    A4O(0.0),
    A4L(0.0),
    A4W(0.0),
    GCOO(0.0),
    IGINVLW(0.0),
    IGOVW(0.0),
    IGOVDW(0.0),
    STIGO(2.0),
    GC2O(0.375),
    GC3O(0.063),
    CHIBO(3.1),
    AGIDLW(0.0),
    AGIDLDW(0.0),
    BGIDLO(41.0),
    BGIDLDO(41.0),
    STBGIDLO(0.0),
    STBGIDLDO(0.0),
    CGIDLO(0.0),
    CGIDLDO(0.0),
    CGBOVL(0.0),
    CFRW(0.0),
    CFRDW(0.0),
    FNTO(1.0),
    FNTEXCL(0.0),
    NFALW(8.0e22),
    NFBLW(3.0e7),
    NFCLW(0.0),
    EFO(1.0),
    LINTNOI(0.0),
    ALPNOI(2.0),
    WEDGE(1.0e-8),
    WEDGEW(0.0),
    VFBEDGEO((-1.0)),
    STVFBEDGEO(5.0e-4),
    STVFBEDGEL(0.0),
    STVFBEDGEW(0.0),
    STVFBEDGELW(0.0),
    DPHIBEDGEO(0.0),
    DPHIBEDGEL(0.0),
    DPHIBEDGELEXP(1.0),
    DPHIBEDGEW(0.0),
    DPHIBEDGELW(0.0),
    NSUBEDGEO(5.0e23),
    NSUBEDGEL(0.0),
    NSUBEDGEW(0.0),
    NSUBEDGELW(0.0),
    CTEDGEO(0.0),
    CTEDGEL(0.0),
    CTEDGELEXP(1.0),
    FBETEDGE(0.0),
    LPEDGE(1.0e-8),
    BETEDGEW(0.0),
    STBETEDGEO(1.0),
    STBETEDGEL(0.0),
    STBETEDGEW(0.0),
    STBETEDGELW(0.0),
    PSCEEDGEL(0.0),
    PSCEEDGELEXP(2.0),
    PSCEEDGEW(0.0),
    PSCEBEDGEO(0.0),
    PSCEDEDGEO(0.0),
    CFEDGEL(0.0),
    CFEDGELEXP(2.0),
    CFEDGEW(0.0),
    CFDEDGEO(0.0),
    CFBEDGEO(0.0),
    FNTEDGEO(1.0),
    NFAEDGELW(8.0e22),
    NFBEDGELW(3.0e7),
    NFCEDGELW(0.0),
    EFEDGEO(1.0),
    KVTHOWEO(0.0),
    KVTHOWEL(0.0),
    KVTHOWEW(0.0),
    KVTHOWELW(0.0),
    KUOWEO(0.0),
    KUOWEL(0.0),
    KUOWEW(0.0),
    KUOWELW(0.0),
    RGO(0.0),
    RINT(0.0),
    RVPOLY(0.0),
    RSHG(0.0),
    DLSIL(0.0),
    RSH(0.0),
    RSHD(0.0),
    RBULKO(0.0),
    RWELLO(0.0),
    RJUNSO(0.0),
    RJUNDO(0.0),
    SAREF(1.0e-6),
    SBREF(1.0e-6),
    WLOD(0.0),
    KUO(0.0),
    KVSAT(0.0),
    TKUO(0.0),
    LKUO(0.0),
    WKUO(0.0),
    PKUO(0.0),
    LLODKUO(0.0),
    WLODKUO(0.0),
    KVTHO(0.0),
    LKVTHO(0.0),
    WKVTHO(0.0),
    PKVTHO(0.0),
    LLODVTH(0.0),
    WLODVTH(0.0),
    STETAO(0.0),
    LODETAO(1.0),
    SCREF(1.0e-6),
    WEB(0.0),
    WEC(0.0),
    IMAX(1000.0),
    TRJ(21.0),
    FREV(1.0e3),
    CJORBOT(1.0e-3),
    CJORSTI(1.0e-9),
    CJORGAT(1.0e-9),
    VBIRBOT(1.0),
    VBIRSTI(1.0),
    VBIRGAT(1.0),
    PBOT(0.5),
    PSTI(0.5),
    PGAT(0.5),
    PHIGBOT(1.16),
    PHIGSTI(1.16),
    PHIGGAT(1.16),
    IDSATRBOT(1.0e-12),
    IDSATRSTI(1.0e-18),
    IDSATRGAT(1.0e-18),
    CSRHBOT(1.0e2),
    CSRHSTI(1.0e-4),
    CSRHGAT(1.0e-4),
    XJUNSTI(1.0e-7),
    XJUNGAT(1.0e-7),
    CTATBOT(1.0e2),
    CTATSTI(1.0e-4),
    CTATGAT(1.0e-4),
    MEFFTATBOT(0.25),
    MEFFTATSTI(0.25),
    MEFFTATGAT(0.25),
    CBBTBOT(1.0e-12),
    CBBTSTI(1.0e-18),
    CBBTGAT(1.0e-18),
    FBBTRBOT(1.0e9),
    FBBTRSTI(1.0e9),
    FBBTRGAT(1.0e9),
    STFBBTBOT((-1.0e-3)),
    STFBBTSTI((-1.0e-3)),
    STFBBTGAT((-1.0e-3)),
    VBRBOT(10.0),
    VBRSTI(10.0),
    VBRGAT(10.0),
    PBRBOT(4.0),
    PBRSTI(4.0),
    PBRGAT(4.0),
    CJORBOTD(1.0e-3),
    CJORSTID(1.0e-9),
    CJORGATD(1.0e-9),
    VBIRBOTD(1.0),
    VBIRSTID(1.0),
    VBIRGATD(1.0),
    PBOTD(0.5),
    PSTID(0.5),
    PGATD(0.5),
    PHIGBOTD(1.16),
    PHIGSTID(1.16),
    PHIGGATD(1.16),
    IDSATRBOTD(1.0e-12),
    IDSATRSTID(1.0e-18),
    IDSATRGATD(1.0e-18),
    CSRHBOTD(1.0e2),
    CSRHSTID(1.0e-4),
    CSRHGATD(1.0e-4),
    XJUNSTID(1.0e-7),
    XJUNGATD(1.0e-7),
    CTATBOTD(1.0e2),
    CTATSTID(1.0e-4),
    CTATGATD(1.0e-4),
    MEFFTATBOTD(0.25),
    MEFFTATSTID(0.25),
    MEFFTATGATD(0.25),
    CBBTBOTD(1.0e-12),
    CBBTSTID(1.0e-18),
    CBBTGATD(1.0e-18),
    FBBTRBOTD(1.0e9),
    FBBTRSTID(1.0e9),
    FBBTRGATD(1.0e9),
    STFBBTBOTD((-1.0e-3)),
    STFBBTSTID((-1.0e-3)),
    STFBBTGATD((-1.0e-3)),
    VBRBOTD(10.0),
    VBRSTID(10.0),
    VBRGATD(10.0),
    PBRBOTD(4.0),
    PBRSTID(4.0),
    PBRGATD(4.0),
    SWJUNEXP(0.0),
    VJUNREF(2.5),
    FJUNQ(0.03),
    VJUNREFD(2.5),
    FJUNQD(0.03),
    DTA(0.0),
    CHNL_TYPE(0),
    SWGEO_i(0),
    SWIGATE_i(0),
    SWIMPACT_i(0),
    SWGIDL_i(0),
    SWJUNCAP_i(0),
    SWJUNASYM_i(0),
    SWNUD_i(0),
    SWEDGE_i(0),
    SWDELVTAC_i(0),
    SWIGN_i(0),
    TOXO_i(0.0),
    EPSROXO_i(0.0),
    NSUBO_i(0.0),
    WSEG_i(0.0),
    NPCK_i(0.0),
    WSEGP_i(0.0),
    LPCK_i(0.0),
    TOXOVO_i(0.0),
    TOXOVDO_i(0.0),
    LOV_i(0.0),
    LOVD_i(0.0),
    LP1_i(0.0),
    LP2_i(0.0),
    WBET_i(0.0),
    AXL_i(0.0),
    ALP1L2_i(0.0),
    ALP2L2_i(0.0),
    SAREF_i(0.0),
    SBREF_i(0.0),
    KVSAT_i(0.0),
    LLODKUO_i(0.0),
    WLODKUO_i(0.0),
    LLODVTH_i(0.0),
    WLODVTH_i(0.0),
    LODETAO_i(0.0),
    SCREF_i(0.0),
    WEB_i(0.0),
    WEC_i(0.0),
    RSHG_i(0.0),
    RSH_i(0.0),
    RSHD_i(0.0),
    RINT_i(0.0),
    RVPOLY_i(0.0),
    NSUBEDGEO_i(0.0),
    LPEDGE_i(0.0),
    QMC_i(0.0),
    rTa(0.0),
    delTa(0.0),
    phita(0.0),
    inv_phita(0.0),
    TKD(0.0),
    delT(0.0),
    rTn(0.0),
    ln_rTn(0.0),
    inv_phit(0.0),
    Eg(0.0),
    phibFac(0.0),
    IMAX_i(0.0),
    VBIRBOT_i(0.0),
    VBIRSTI_i(0.0),
    VBIRGAT_i(0.0),
    PBOT_i(0.0),
    PSTI_i(0.0),
    PGAT_i(0.0),
    CSRHBOT_i(0.0),
    CSRHSTI_i(0.0),
    CSRHGAT_i(0.0),
    CTATBOT_i(0.0),
    CTATSTI_i(0.0),
    CTATGAT_i(0.0),
    CBBTBOT_i(0.0),
    CBBTSTI_i(0.0),
    CBBTGAT_i(0.0),
    VBRBOT_i(0.0),
    VBRSTI_i(0.0),
    VBRGAT_i(0.0),
    PBRBOT_i(0.0),
    PBRSTI_i(0.0),
    PBRGAT_i(0.0),
    SWJUNEXP_i(0.0),
    VJUNREF_i(0.0),
    FJUNQ_i(0.0),
    phitr(0.0),
    phitd(0.0),
    phitdinv(0.0),
    perfc(0.0),
    berfc(0.0),
    cerfc(0.0),
    ftdbot(0.0),
    ftdsti(0.0),
    ftdgat(0.0),
    idsatbot(0.0),
    idsatsti(0.0),
    idsatgat(0.0),
    vbibot(0.0),
    vbisti(0.0),
    vbigat(0.0),
    vbiinvbot(0.0),
    vbiinvsti(0.0),
    vbiinvgat(0.0),
    one_minus_PBOT(0.0),
    one_minus_PSTI(0.0),
    one_minus_PGAT(0.0),
    one_over_one_minus_PBOT(0.0),
    one_over_one_minus_PSTI(0.0),
    one_over_one_minus_PGAT(0.0),
    cjobot(0.0),
    cjosti(0.0),
    cjogat(0.0),
    qprefbot(0.0),
    qprefsti(0.0),
    qprefgat(0.0),
    qpref2bot(0.0),
    qpref2sti(0.0),
    qpref2gat(0.0),
    wdepnulrbot(0.0),
    wdepnulrsti(0.0),
    wdepnulrgat(0.0),
    wdepnulrinvbot(0.0),
    wdepnulrinvsti(0.0),
    wdepnulrinvgat(0.0),
    VBIRBOTinv(0.0),
    VBIRSTIinv(0.0),
    VBIRGATinv(0.0),
    atatbot(0.0),
    atatsti(0.0),
    atatgat(0.0),
    btatpartbot(0.0),
    btatpartsti(0.0),
    btatpartgat(0.0),
    fbbtbot(0.0),
    fbbtsti(0.0),
    fbbtgat(0.0),
    alphaav(0.0),
    fstopbot(0.0),
    fstopsti(0.0),
    fstopgat(0.0),
    VBRinvbot(0.0),
    VBRinvsti(0.0),
    VBRinvgat(0.0),
    slopebot(0.0),
    slopesti(0.0),
    slopegat(0.0),
    VBIRBOTD_i(0.0),
    VBIRSTID_i(0.0),
    VBIRGATD_i(0.0),
    PBOTD_i(0.0),
    PSTID_i(0.0),
    PGATD_i(0.0),
    CSRHBOTD_i(0.0),
    CSRHSTID_i(0.0),
    CSRHGATD_i(0.0),
    CTATBOTD_i(0.0),
    CTATSTID_i(0.0),
    CTATGATD_i(0.0),
    CBBTBOTD_i(0.0),
    CBBTSTID_i(0.0),
    CBBTGATD_i(0.0),
    VBRBOTD_i(0.0),
    VBRSTID_i(0.0),
    VBRGATD_i(0.0),
    PBRBOTD_i(0.0),
    PBRSTID_i(0.0),
    PBRGATD_i(0.0),
    VJUNREFD_i(0.0),
    FJUNQD_i(0.0),
    ftdbot_d(0.0),
    ftdsti_d(0.0),
    ftdgat_d(0.0),
    idsatbot_d(0.0),
    idsatsti_d(0.0),
    idsatgat_d(0.0),
    vbibot_d(0.0),
    vbisti_d(0.0),
    vbigat_d(0.0),
    vbiinvbot_d(0.0),
    vbiinvsti_d(0.0),
    vbiinvgat_d(0.0),
    one_minus_PBOT_d(0.0),
    one_minus_PSTI_d(0.0),
    one_minus_PGAT_d(0.0),
    one_over_one_minus_PBOT_d(0.0),
    one_over_one_minus_PSTI_d(0.0),
    one_over_one_minus_PGAT_d(0.0),
    cjobot_d(0.0),
    cjosti_d(0.0),
    cjogat_d(0.0),
    qprefbot_d(0.0),
    qprefsti_d(0.0),
    qprefgat_d(0.0),
    qpref2bot_d(0.0),
    qpref2sti_d(0.0),
    qpref2gat_d(0.0),
    wdepnulrbot_d(0.0),
    wdepnulrsti_d(0.0),
    wdepnulrgat_d(0.0),
    wdepnulrinvbot_d(0.0),
    wdepnulrinvsti_d(0.0),
    wdepnulrinvgat_d(0.0),
    VBIRBOTinv_d(0.0),
    VBIRSTIinv_d(0.0),
    VBIRGATinv_d(0.0),
    atatbot_d(0.0),
    atatsti_d(0.0),
    atatgat_d(0.0),
    btatpartbot_d(0.0),
    btatpartsti_d(0.0),
    btatpartgat_d(0.0),
    fbbtbot_d(0.0),
    fbbtsti_d(0.0),
    fbbtgat_d(0.0),
    fstopbot_d(0.0),
    fstopsti_d(0.0),
    fstopgat_d(0.0),
    VBRinvbot_d(0.0),
    VBRinvsti_d(0.0),
    VBRinvgat_d(0.0),
    slopebot_d(0.0),
    slopesti_d(0.0),
    slopegat_d(0.0),
    phit(0.0),
    nt0(0.0),
    EPSSI(0.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << "L  =  " << (*iter)->L << std::endl;
    os << "W  =  " << (*iter)->W << std::endl;
    os << "SA  =  " << (*iter)->SA << std::endl;
    os << "SB  =  " << (*iter)->SB << std::endl;
    os << "SD  =  " << (*iter)->SD << std::endl;
    os << "SCA  =  " << (*iter)->SCA << std::endl;
    os << "SCB  =  " << (*iter)->SCB << std::endl;
    os << "SCC  =  " << (*iter)->SCC << std::endl;
    os << "SC  =  " << (*iter)->SC << std::endl;
    os << "NF  =  " << (*iter)->NF << std::endl;
    os << "NGCON  =  " << (*iter)->NGCON << std::endl;
    os << "XGW  =  " << (*iter)->XGW << std::endl;
    os << "NRS  =  " << (*iter)->NRS << std::endl;
    os << "NRD  =  " << (*iter)->NRD << std::endl;
    os << "JW  =  " << (*iter)->JW << std::endl;
    os << "DELVTO  =  " << (*iter)->DELVTO << std::endl;
    os << "FACTUO  =  " << (*iter)->FACTUO << std::endl;
    os << "DELVTOEDGE  =  " << (*iter)->DELVTOEDGE << std::endl;
    os << "FACTUOEDGE  =  " << (*iter)->FACTUOEDGE << std::endl;
    os << "ABSOURCE  =  " << (*iter)->ABSOURCE << std::endl;
    os << "LSSOURCE  =  " << (*iter)->LSSOURCE << std::endl;
    os << "LGSOURCE  =  " << (*iter)->LGSOURCE << std::endl;
    os << "ABDRAIN  =  " << (*iter)->ABDRAIN << std::endl;
    os << "LSDRAIN  =  " << (*iter)->LSDRAIN << std::endl;
    os << "LGDRAIN  =  " << (*iter)->LGDRAIN << std::endl;
    os << "AS  =  " << (*iter)->AS << std::endl;
    os << "PS  =  " << (*iter)->PS << std::endl;
    os << "AD  =  " << (*iter)->AD << std::endl;
    os << "PD  =  " << (*iter)->PD << std::endl;
    os << "MULT  =  " << (*iter)->MULT << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
  if (deviceMap.empty() ||
      ((deviceMap.find("M") != deviceMap.end() && (levelSet.find(103)!=levelSet.end()))))
  {
    MOSFET1::registerDevice();
    Config<Traits>::addConfiguration()
      .registerDevice("m", 103)
      .registerModelType("nmos", 103)
      .registerModelType("pmos", 103);
  }
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_W,
   bool instancePar_given_W,
   AdmsSensFadType & instancePar_SA,
   bool instancePar_given_SA,
   AdmsSensFadType & instancePar_SB,
   bool instancePar_given_SB,
   AdmsSensFadType & instancePar_SD,
   bool instancePar_given_SD,
   AdmsSensFadType & instancePar_SCA,
   bool instancePar_given_SCA,
   AdmsSensFadType & instancePar_SCB,
   bool instancePar_given_SCB,
   AdmsSensFadType & instancePar_SCC,
   bool instancePar_given_SCC,
   AdmsSensFadType & instancePar_SC,
   bool instancePar_given_SC,
   AdmsSensFadType & instancePar_NF,
   bool instancePar_given_NF,
   AdmsSensFadType & instancePar_NGCON,
   bool instancePar_given_NGCON,
   AdmsSensFadType & instancePar_XGW,
   bool instancePar_given_XGW,
   AdmsSensFadType & instancePar_NRS,
   bool instancePar_given_NRS,
   AdmsSensFadType & instancePar_NRD,
   bool instancePar_given_NRD,
   AdmsSensFadType & instancePar_JW,
   bool instancePar_given_JW,
   AdmsSensFadType & instancePar_DELVTO,
   bool instancePar_given_DELVTO,
   AdmsSensFadType & instancePar_FACTUO,
   bool instancePar_given_FACTUO,
   AdmsSensFadType & instancePar_DELVTOEDGE,
   bool instancePar_given_DELVTOEDGE,
   AdmsSensFadType & instancePar_FACTUOEDGE,
   bool instancePar_given_FACTUOEDGE,
   AdmsSensFadType & instancePar_ABSOURCE,
   bool instancePar_given_ABSOURCE,
   AdmsSensFadType & instancePar_LSSOURCE,
   bool instancePar_given_LSSOURCE,
   AdmsSensFadType & instancePar_LGSOURCE,
   bool instancePar_given_LGSOURCE,
   AdmsSensFadType & instancePar_ABDRAIN,
   bool instancePar_given_ABDRAIN,
   AdmsSensFadType & instancePar_LSDRAIN,
   bool instancePar_given_LSDRAIN,
   AdmsSensFadType & instancePar_LGDRAIN,
   bool instancePar_given_LGDRAIN,
   AdmsSensFadType & instancePar_AS,
   bool instancePar_given_AS,
   AdmsSensFadType & instancePar_PS,
   bool instancePar_given_PS,
   AdmsSensFadType & instancePar_AD,
   bool instancePar_given_AD,
   AdmsSensFadType & instancePar_PD,
   bool instancePar_given_PD,
   AdmsSensFadType & instancePar_MULT,
   bool instancePar_given_MULT,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_MULT_i,
   AdmsSensFadType & instanceVar_GFACNUD_i,
   AdmsSensFadType & instanceVar_VNSUB_i,
   AdmsSensFadType & instanceVar_NSLP_i,
   AdmsSensFadType & instanceVar_DNSUB_i,
   AdmsSensFadType & instanceVar_CF_i,
   AdmsSensFadType & instanceVar_CFD_i,
   AdmsSensFadType & instanceVar_CFB_i,
   AdmsSensFadType & instanceVar_PSCE_i,
   AdmsSensFadType & instanceVar_PSCEB_i,
   AdmsSensFadType & instanceVar_PSCED_i,
   AdmsSensFadType & instanceVar_RSB_i,
   AdmsSensFadType & instanceVar_RSG_i,
   AdmsSensFadType & instanceVar_THESATB_i,
   AdmsSensFadType & instanceVar_THESATG_i,
   AdmsSensFadType & instanceVar_AX_i,
   AdmsSensFadType & instanceVar_ALP_i,
   AdmsSensFadType & instanceVar_ALP1_i,
   AdmsSensFadType & instanceVar_ALP2_i,
   AdmsSensFadType & instanceVar_A1_i,
   AdmsSensFadType & instanceVar_A3_i,
   AdmsSensFadType & instanceVar_A4_i,
   AdmsSensFadType & instanceVar_GCO_i,
   AdmsSensFadType & instanceVar_IGINV_i,
   AdmsSensFadType & instanceVar_IGOV_i,
   AdmsSensFadType & instanceVar_IGOVD_i,
   AdmsSensFadType & instanceVar_GC2_i,
   AdmsSensFadType & instanceVar_GC3_i,
   AdmsSensFadType & instanceVar_CHIB_i,
   AdmsSensFadType & instanceVar_AGIDL_i,
   AdmsSensFadType & instanceVar_AGIDLD_i,
   AdmsSensFadType & instanceVar_CGIDL_i,
   AdmsSensFadType & instanceVar_CGIDLD_i,
   AdmsSensFadType & instanceVar_COX_i,
   AdmsSensFadType & instanceVar_CGOV_i,
   AdmsSensFadType & instanceVar_CGOVD_i,
   AdmsSensFadType & instanceVar_CGBOV_i,
   AdmsSensFadType & instanceVar_CFR_i,
   AdmsSensFadType & instanceVar_CFRD_i,
   AdmsSensFadType & instanceVar_FNTEXC_i,
   AdmsSensFadType & instanceVar_NFA_i,
   AdmsSensFadType & instanceVar_NFB_i,
   AdmsSensFadType & instanceVar_NFC_i,
   AdmsSensFadType & instanceVar_EF_i,
   AdmsSensFadType & instanceVar_BETNEDGE_i,
   AdmsSensFadType & instanceVar_PSCEEDGE_i,
   AdmsSensFadType & instanceVar_PSCEBEDGE_i,
   AdmsSensFadType & instanceVar_PSCEDEDGE_i,
   AdmsSensFadType & instanceVar_CFEDGE_i,
   AdmsSensFadType & instanceVar_CFDEDGE_i,
   AdmsSensFadType & instanceVar_CFBEDGE_i,
   AdmsSensFadType & instanceVar_NFAEDGE_i,
   AdmsSensFadType & instanceVar_NFBEDGE_i,
   AdmsSensFadType & instanceVar_NFCEDGE_i,
   AdmsSensFadType & instanceVar_EFEDGE_i,
   AdmsSensFadType & instanceVar_RG_i,
   AdmsSensFadType & instanceVar_RSE_i,
   AdmsSensFadType & instanceVar_RDE_i,
   AdmsSensFadType & instanceVar_RBULK_i,
   AdmsSensFadType & instanceVar_RJUNS_i,
   AdmsSensFadType & instanceVar_RJUND_i,
   AdmsSensFadType & instanceVar_RWELL_i,
   AdmsSensFadType & instanceVar_ABSOURCE_i,
   AdmsSensFadType & instanceVar_LSSOURCE_i,
   AdmsSensFadType & instanceVar_LGSOURCE_i,
   AdmsSensFadType & instanceVar_zflagbot_s,
   AdmsSensFadType & instanceVar_zflagsti_s,
   AdmsSensFadType & instanceVar_zflaggat_s,
   AdmsSensFadType & instanceVar_VMAX_s,
   AdmsSensFadType & instanceVar_exp_VMAX_over_phitd_s,
   AdmsSensFadType & instanceVar_vbimin_s,
   AdmsSensFadType & instanceVar_vch_s,
   AdmsSensFadType & instanceVar_vfmin_s,
   AdmsSensFadType & instanceVar_vbbtlim_s,
   AdmsSensFadType & instanceVar_xhighf1_s,
   AdmsSensFadType & instanceVar_expxhf1_s,
   AdmsSensFadType & instanceVar_xhighf2_s,
   AdmsSensFadType & instanceVar_expxhf2_s,
   AdmsSensFadType & instanceVar_xhighr_s,
   AdmsSensFadType & instanceVar_expxhr_s,
   AdmsSensFadType & instanceVar_m0flag_s,
   AdmsSensFadType & instanceVar_ISATFOR1_s,
   AdmsSensFadType & instanceVar_MFOR1_s,
   AdmsSensFadType & instanceVar_ISATFOR2_s,
   AdmsSensFadType & instanceVar_MFOR2_s,
   AdmsSensFadType & instanceVar_ISATREV_s,
   AdmsSensFadType & instanceVar_MREV_s,
   AdmsSensFadType & instanceVar_ABDRAIN_i,
   AdmsSensFadType & instanceVar_LSDRAIN_i,
   AdmsSensFadType & instanceVar_LGDRAIN_i,
   AdmsSensFadType & instanceVar_zflagbot_d,
   AdmsSensFadType & instanceVar_zflagsti_d,
   AdmsSensFadType & instanceVar_zflaggat_d,
   AdmsSensFadType & instanceVar_VMAX_d,
   AdmsSensFadType & instanceVar_exp_VMAX_over_phitd_d,
   AdmsSensFadType & instanceVar_vbimin_d,
   AdmsSensFadType & instanceVar_vch_d,
   AdmsSensFadType & instanceVar_vfmin_d,
   AdmsSensFadType & instanceVar_vbbtlim_d,
   AdmsSensFadType & instanceVar_xhighf1_d,
   AdmsSensFadType & instanceVar_expxhf1_d,
   AdmsSensFadType & instanceVar_xhighf2_d,
   AdmsSensFadType & instanceVar_expxhf2_d,
   AdmsSensFadType & instanceVar_xhighr_d,
   AdmsSensFadType & instanceVar_expxhr_d,
   AdmsSensFadType & instanceVar_m0flag_d,
   AdmsSensFadType & instanceVar_ISATFOR1_d,
   AdmsSensFadType & instanceVar_MFOR1_d,
   AdmsSensFadType & instanceVar_ISATFOR2_d,
   AdmsSensFadType & instanceVar_MFOR2_d,
   AdmsSensFadType & instanceVar_ISATREV_d,
   AdmsSensFadType & instanceVar_MREV_d,
   AdmsSensFadType & instanceVar_VFB_T,
   AdmsSensFadType & instanceVar_MUE_T,
   AdmsSensFadType & instanceVar_THEMU_T,
   AdmsSensFadType & instanceVar_CS_T,
   AdmsSensFadType & instanceVar_XCOR_T,
   AdmsSensFadType & instanceVar_A2_T,
   AdmsSensFadType & instanceVar_VFBEDGE_T,
   AdmsSensFadType & instanceVar_phit0,
   AdmsSensFadType & instanceVar_BET_i,
   AdmsSensFadType & instanceVar_BETEDGE_i,
   AdmsSensFadType & instanceVar_nt,
   AdmsSensFadType & instanceVar_THESAT_T,
   AdmsSensFadType & instanceVar_Sfl_prefac,
   AdmsSensFadType & instanceVar_phit0edge,
   AdmsSensFadType & instanceVar_Gfedge2,
   AdmsSensFadType & instanceVar_lnGfedge2,
   AdmsSensFadType & instanceVar_Sfl_prefac_edge,
   AdmsSensFadType & instanceVar_ntedge,
   AdmsSensFadType & instanceVar_phib_dc,
   AdmsSensFadType & instanceVar_G_0_dc,
   AdmsSensFadType & instanceVar_kp,
   AdmsSensFadType & instanceVar_qlim2,
   AdmsSensFadType & instanceVar_sqrt_phib_dc,
   AdmsSensFadType & instanceVar_phix_dc,
   AdmsSensFadType & instanceVar_aphi_dc,
   AdmsSensFadType & instanceVar_bphi_dc,
   AdmsSensFadType & instanceVar_phix1_dc,
   AdmsSensFadType & instanceVar_alpha_b,
   AdmsSensFadType & instanceVar_us1,
   AdmsSensFadType & instanceVar_us21,
   AdmsSensFadType & instanceVar_phib_ac,
   AdmsSensFadType & instanceVar_G_0_ac,
   AdmsSensFadType & instanceVar_phix_ac,
   AdmsSensFadType & instanceVar_aphi_ac,
   AdmsSensFadType & instanceVar_bphi_ac,
   AdmsSensFadType & instanceVar_phix1_ac,
   AdmsSensFadType & instanceVar_THER_i,
   AdmsSensFadType & instanceVar_phibedge,
   AdmsSensFadType & instanceVar_Gfedge,
   AdmsSensFadType & instanceVar_phixedge,
   AdmsSensFadType & instanceVar_aphiedge,
   AdmsSensFadType & instanceVar_bphiedge,
   AdmsSensFadType & instanceVar_phix1edge,
   AdmsSensFadType & instanceVar_Cox_over_q,
   AdmsSensFadType & instanceVar_qq,
   AdmsSensFadType & instanceVar_E_eff0,
   AdmsSensFadType & instanceVar_eta_mu,
   AdmsSensFadType & instanceVar_eta_mu1,
   AdmsSensFadType & instanceVar_inv_AX,
   AdmsSensFadType & instanceVar_inv_VP,
   AdmsSensFadType & instanceVar_GOV_s,
   AdmsSensFadType & instanceVar_GOV_d,
   AdmsSensFadType & instanceVar_GOV2_s,
   AdmsSensFadType & instanceVar_GOV2_d,
   AdmsSensFadType & instanceVar_SP_OV_eps2_s,
   AdmsSensFadType & instanceVar_SP_OV_a_s,
   AdmsSensFadType & instanceVar_SP_OV_delta1_s,
   AdmsSensFadType & instanceVar_SP_OV_eps2_d,
   AdmsSensFadType & instanceVar_SP_OV_a_d,
   AdmsSensFadType & instanceVar_SP_OV_delta1_d,
   AdmsSensFadType & instanceVar_inv_CHIB,
   AdmsSensFadType & instanceVar_BCH,
   AdmsSensFadType & instanceVar_BOV,
   AdmsSensFadType & instanceVar_BOV_d,
   AdmsSensFadType & instanceVar_GCQ,
   AdmsSensFadType & instanceVar_AGIDLs,
   AdmsSensFadType & instanceVar_AGIDLDs,
   AdmsSensFadType & instanceVar_BGIDLs,
   AdmsSensFadType & instanceVar_BGIDLDs,
   AdmsSensFadType & instanceVar_fac_exc,
   AdmsSensFadType & instanceVar_ggate,
   AdmsSensFadType & instanceVar_gsource,
   AdmsSensFadType & instanceVar_gdrain,
   AdmsSensFadType & instanceVar_gbulk,
   AdmsSensFadType & instanceVar_gjuns,
   AdmsSensFadType & instanceVar_gjund,
   AdmsSensFadType & instanceVar_gwell,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TR,
   bool modelPar_given_TR,
   AdmsSensFadType & modelPar_QMC,
   bool modelPar_given_QMC,
   AdmsSensFadType & modelPar_VFB,
   bool modelPar_given_VFB,
   AdmsSensFadType & modelPar_STVFB,
   bool modelPar_given_STVFB,
   AdmsSensFadType & modelPar_TOX,
   bool modelPar_given_TOX,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_NEFF,
   bool modelPar_given_NEFF,
   AdmsSensFadType & modelPar_FACNEFFAC,
   bool modelPar_given_FACNEFFAC,
   AdmsSensFadType & modelPar_GFACNUD,
   bool modelPar_given_GFACNUD,
   AdmsSensFadType & modelPar_VSBNUD,
   bool modelPar_given_VSBNUD,
   AdmsSensFadType & modelPar_DVSBNUD,
   bool modelPar_given_DVSBNUD,
   AdmsSensFadType & modelPar_VNSUB,
   bool modelPar_given_VNSUB,
   AdmsSensFadType & modelPar_NSLP,
   bool modelPar_given_NSLP,
   AdmsSensFadType & modelPar_DNSUB,
   bool modelPar_given_DNSUB,
   AdmsSensFadType & modelPar_DPHIB,
   bool modelPar_given_DPHIB,
   AdmsSensFadType & modelPar_DELVTAC,
   bool modelPar_given_DELVTAC,
   AdmsSensFadType & modelPar_NP,
   bool modelPar_given_NP,
   AdmsSensFadType & modelPar_CT,
   bool modelPar_given_CT,
   AdmsSensFadType & modelPar_TOXOV,
   bool modelPar_given_TOXOV,
   AdmsSensFadType & modelPar_TOXOVD,
   bool modelPar_given_TOXOVD,
   AdmsSensFadType & modelPar_NOV,
   bool modelPar_given_NOV,
   AdmsSensFadType & modelPar_NOVD,
   bool modelPar_given_NOVD,
   AdmsSensFadType & modelPar_CF,
   bool modelPar_given_CF,
   AdmsSensFadType & modelPar_CFD,
   bool modelPar_given_CFD,
   AdmsSensFadType & modelPar_CFB,
   bool modelPar_given_CFB,
   AdmsSensFadType & modelPar_PSCE,
   bool modelPar_given_PSCE,
   AdmsSensFadType & modelPar_PSCEB,
   bool modelPar_given_PSCEB,
   AdmsSensFadType & modelPar_PSCED,
   bool modelPar_given_PSCED,
   AdmsSensFadType & modelPar_BETN,
   bool modelPar_given_BETN,
   AdmsSensFadType & modelPar_STBET,
   bool modelPar_given_STBET,
   AdmsSensFadType & modelPar_MUE,
   bool modelPar_given_MUE,
   AdmsSensFadType & modelPar_STMUE,
   bool modelPar_given_STMUE,
   AdmsSensFadType & modelPar_THEMU,
   bool modelPar_given_THEMU,
   AdmsSensFadType & modelPar_STTHEMU,
   bool modelPar_given_STTHEMU,
   AdmsSensFadType & modelPar_CS,
   bool modelPar_given_CS,
   AdmsSensFadType & modelPar_STCS,
   bool modelPar_given_STCS,
   AdmsSensFadType & modelPar_XCOR,
   bool modelPar_given_XCOR,
   AdmsSensFadType & modelPar_STXCOR,
   bool modelPar_given_STXCOR,
   AdmsSensFadType & modelPar_FETA,
   bool modelPar_given_FETA,
   AdmsSensFadType & modelPar_RS,
   bool modelPar_given_RS,
   AdmsSensFadType & modelPar_STRS,
   bool modelPar_given_STRS,
   AdmsSensFadType & modelPar_RSB,
   bool modelPar_given_RSB,
   AdmsSensFadType & modelPar_RSG,
   bool modelPar_given_RSG,
   AdmsSensFadType & modelPar_THESAT,
   bool modelPar_given_THESAT,
   AdmsSensFadType & modelPar_STTHESAT,
   bool modelPar_given_STTHESAT,
   AdmsSensFadType & modelPar_THESATB,
   bool modelPar_given_THESATB,
   AdmsSensFadType & modelPar_THESATG,
   bool modelPar_given_THESATG,
   AdmsSensFadType & modelPar_AX,
   bool modelPar_given_AX,
   AdmsSensFadType & modelPar_ALP,
   bool modelPar_given_ALP,
   AdmsSensFadType & modelPar_ALP1,
   bool modelPar_given_ALP1,
   AdmsSensFadType & modelPar_ALP2,
   bool modelPar_given_ALP2,
   AdmsSensFadType & modelPar_VP,
   bool modelPar_given_VP,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_STA2,
   bool modelPar_given_STA2,
   AdmsSensFadType & modelPar_A3,
   bool modelPar_given_A3,
   AdmsSensFadType & modelPar_A4,
   bool modelPar_given_A4,
   AdmsSensFadType & modelPar_GCO,
   bool modelPar_given_GCO,
   AdmsSensFadType & modelPar_IGINV,
   bool modelPar_given_IGINV,
   AdmsSensFadType & modelPar_IGOV,
   bool modelPar_given_IGOV,
   AdmsSensFadType & modelPar_IGOVD,
   bool modelPar_given_IGOVD,
   AdmsSensFadType & modelPar_STIG,
   bool modelPar_given_STIG,
   AdmsSensFadType & modelPar_GC2,
   bool modelPar_given_GC2,
   AdmsSensFadType & modelPar_GC3,
   bool modelPar_given_GC3,
   AdmsSensFadType & modelPar_CHIB,
   bool modelPar_given_CHIB,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_AGIDLD,
   bool modelPar_given_AGIDLD,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_BGIDLD,
   bool modelPar_given_BGIDLD,
   AdmsSensFadType & modelPar_STBGIDL,
   bool modelPar_given_STBGIDL,
   AdmsSensFadType & modelPar_STBGIDLD,
   bool modelPar_given_STBGIDLD,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_CGIDLD,
   bool modelPar_given_CGIDLD,
   AdmsSensFadType & modelPar_COX,
   bool modelPar_given_COX,
   AdmsSensFadType & modelPar_CGOV,
   bool modelPar_given_CGOV,
   AdmsSensFadType & modelPar_CGOVD,
   bool modelPar_given_CGOVD,
   AdmsSensFadType & modelPar_CGBOV,
   bool modelPar_given_CGBOV,
   AdmsSensFadType & modelPar_CFR,
   bool modelPar_given_CFR,
   AdmsSensFadType & modelPar_CFRD,
   bool modelPar_given_CFRD,
   AdmsSensFadType & modelPar_FNT,
   bool modelPar_given_FNT,
   AdmsSensFadType & modelPar_FNTEXC,
   bool modelPar_given_FNTEXC,
   AdmsSensFadType & modelPar_NFA,
   bool modelPar_given_NFA,
   AdmsSensFadType & modelPar_NFB,
   bool modelPar_given_NFB,
   AdmsSensFadType & modelPar_NFC,
   bool modelPar_given_NFC,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_VFBEDGE,
   bool modelPar_given_VFBEDGE,
   AdmsSensFadType & modelPar_STVFBEDGE,
   bool modelPar_given_STVFBEDGE,
   AdmsSensFadType & modelPar_DPHIBEDGE,
   bool modelPar_given_DPHIBEDGE,
   AdmsSensFadType & modelPar_NEFFEDGE,
   bool modelPar_given_NEFFEDGE,
   AdmsSensFadType & modelPar_CTEDGE,
   bool modelPar_given_CTEDGE,
   AdmsSensFadType & modelPar_BETNEDGE,
   bool modelPar_given_BETNEDGE,
   AdmsSensFadType & modelPar_STBETEDGE,
   bool modelPar_given_STBETEDGE,
   AdmsSensFadType & modelPar_PSCEEDGE,
   bool modelPar_given_PSCEEDGE,
   AdmsSensFadType & modelPar_PSCEBEDGE,
   bool modelPar_given_PSCEBEDGE,
   AdmsSensFadType & modelPar_PSCEDEDGE,
   bool modelPar_given_PSCEDEDGE,
   AdmsSensFadType & modelPar_CFEDGE,
   bool modelPar_given_CFEDGE,
   AdmsSensFadType & modelPar_CFDEDGE,
   bool modelPar_given_CFDEDGE,
   AdmsSensFadType & modelPar_CFBEDGE,
   bool modelPar_given_CFBEDGE,
   AdmsSensFadType & modelPar_FNTEDGE,
   bool modelPar_given_FNTEDGE,
   AdmsSensFadType & modelPar_NFAEDGE,
   bool modelPar_given_NFAEDGE,
   AdmsSensFadType & modelPar_NFBEDGE,
   bool modelPar_given_NFBEDGE,
   AdmsSensFadType & modelPar_NFCEDGE,
   bool modelPar_given_NFCEDGE,
   AdmsSensFadType & modelPar_EFEDGE,
   bool modelPar_given_EFEDGE,
   AdmsSensFadType & modelPar_RG,
   bool modelPar_given_RG,
   AdmsSensFadType & modelPar_RSE,
   bool modelPar_given_RSE,
   AdmsSensFadType & modelPar_RDE,
   bool modelPar_given_RDE,
   AdmsSensFadType & modelPar_RBULK,
   bool modelPar_given_RBULK,
   AdmsSensFadType & modelPar_RWELL,
   bool modelPar_given_RWELL,
   AdmsSensFadType & modelPar_RJUNS,
   bool modelPar_given_RJUNS,
   AdmsSensFadType & modelPar_RJUND,
   bool modelPar_given_RJUND,
   AdmsSensFadType & modelPar_POVFB,
   bool modelPar_given_POVFB,
   AdmsSensFadType & modelPar_PLVFB,
   bool modelPar_given_PLVFB,
   AdmsSensFadType & modelPar_PWVFB,
   bool modelPar_given_PWVFB,
   AdmsSensFadType & modelPar_PLWVFB,
   bool modelPar_given_PLWVFB,
   AdmsSensFadType & modelPar_POSTVFB,
   bool modelPar_given_POSTVFB,
   AdmsSensFadType & modelPar_PLSTVFB,
   bool modelPar_given_PLSTVFB,
   AdmsSensFadType & modelPar_PWSTVFB,
   bool modelPar_given_PWSTVFB,
   AdmsSensFadType & modelPar_PLWSTVFB,
   bool modelPar_given_PLWSTVFB,
   AdmsSensFadType & modelPar_POTOX,
   bool modelPar_given_POTOX,
   AdmsSensFadType & modelPar_POEPSROX,
   bool modelPar_given_POEPSROX,
   AdmsSensFadType & modelPar_PONEFF,
   bool modelPar_given_PONEFF,
   AdmsSensFadType & modelPar_PLNEFF,
   bool modelPar_given_PLNEFF,
   AdmsSensFadType & modelPar_PWNEFF,
   bool modelPar_given_PWNEFF,
   AdmsSensFadType & modelPar_PLWNEFF,
   bool modelPar_given_PLWNEFF,
   AdmsSensFadType & modelPar_POFACNEFFAC,
   bool modelPar_given_POFACNEFFAC,
   AdmsSensFadType & modelPar_PLFACNEFFAC,
   bool modelPar_given_PLFACNEFFAC,
   AdmsSensFadType & modelPar_PWFACNEFFAC,
   bool modelPar_given_PWFACNEFFAC,
   AdmsSensFadType & modelPar_PLWFACNEFFAC,
   bool modelPar_given_PLWFACNEFFAC,
   AdmsSensFadType & modelPar_POGFACNUD,
   bool modelPar_given_POGFACNUD,
   AdmsSensFadType & modelPar_PLGFACNUD,
   bool modelPar_given_PLGFACNUD,
   AdmsSensFadType & modelPar_PWGFACNUD,
   bool modelPar_given_PWGFACNUD,
   AdmsSensFadType & modelPar_PLWGFACNUD,
   bool modelPar_given_PLWGFACNUD,
   AdmsSensFadType & modelPar_POVSBNUD,
   bool modelPar_given_POVSBNUD,
   AdmsSensFadType & modelPar_PODVSBNUD,
   bool modelPar_given_PODVSBNUD,
   AdmsSensFadType & modelPar_POVNSUB,
   bool modelPar_given_POVNSUB,
   AdmsSensFadType & modelPar_PONSLP,
   bool modelPar_given_PONSLP,
   AdmsSensFadType & modelPar_PODNSUB,
   bool modelPar_given_PODNSUB,
   AdmsSensFadType & modelPar_PODPHIB,
   bool modelPar_given_PODPHIB,
   AdmsSensFadType & modelPar_PLDPHIB,
   bool modelPar_given_PLDPHIB,
   AdmsSensFadType & modelPar_PWDPHIB,
   bool modelPar_given_PWDPHIB,
   AdmsSensFadType & modelPar_PLWDPHIB,
   bool modelPar_given_PLWDPHIB,
   AdmsSensFadType & modelPar_PODELVTAC,
   bool modelPar_given_PODELVTAC,
   AdmsSensFadType & modelPar_PLDELVTAC,
   bool modelPar_given_PLDELVTAC,
   AdmsSensFadType & modelPar_PWDELVTAC,
   bool modelPar_given_PWDELVTAC,
   AdmsSensFadType & modelPar_PLWDELVTAC,
   bool modelPar_given_PLWDELVTAC,
   AdmsSensFadType & modelPar_PONP,
   bool modelPar_given_PONP,
   AdmsSensFadType & modelPar_PLNP,
   bool modelPar_given_PLNP,
   AdmsSensFadType & modelPar_PWNP,
   bool modelPar_given_PWNP,
   AdmsSensFadType & modelPar_PLWNP,
   bool modelPar_given_PLWNP,
   AdmsSensFadType & modelPar_POCT,
   bool modelPar_given_POCT,
   AdmsSensFadType & modelPar_PLCT,
   bool modelPar_given_PLCT,
   AdmsSensFadType & modelPar_PWCT,
   bool modelPar_given_PWCT,
   AdmsSensFadType & modelPar_PLWCT,
   bool modelPar_given_PLWCT,
   AdmsSensFadType & modelPar_POTOXOV,
   bool modelPar_given_POTOXOV,
   AdmsSensFadType & modelPar_POTOXOVD,
   bool modelPar_given_POTOXOVD,
   AdmsSensFadType & modelPar_PONOV,
   bool modelPar_given_PONOV,
   AdmsSensFadType & modelPar_PLNOV,
   bool modelPar_given_PLNOV,
   AdmsSensFadType & modelPar_PWNOV,
   bool modelPar_given_PWNOV,
   AdmsSensFadType & modelPar_PLWNOV,
   bool modelPar_given_PLWNOV,
   AdmsSensFadType & modelPar_PONOVD,
   bool modelPar_given_PONOVD,
   AdmsSensFadType & modelPar_PLNOVD,
   bool modelPar_given_PLNOVD,
   AdmsSensFadType & modelPar_PWNOVD,
   bool modelPar_given_PWNOVD,
   AdmsSensFadType & modelPar_PLWNOVD,
   bool modelPar_given_PLWNOVD,
   AdmsSensFadType & modelPar_POCF,
   bool modelPar_given_POCF,
   AdmsSensFadType & modelPar_PLCF,
   bool modelPar_given_PLCF,
   AdmsSensFadType & modelPar_PWCF,
   bool modelPar_given_PWCF,
   AdmsSensFadType & modelPar_PLWCF,
   bool modelPar_given_PLWCF,
   AdmsSensFadType & modelPar_POCFD,
   bool modelPar_given_POCFD,
   AdmsSensFadType & modelPar_POCFB,
   bool modelPar_given_POCFB,
   AdmsSensFadType & modelPar_POPSCE,
   bool modelPar_given_POPSCE,
   AdmsSensFadType & modelPar_PLPSCE,
   bool modelPar_given_PLPSCE,
   AdmsSensFadType & modelPar_PWPSCE,
   bool modelPar_given_PWPSCE,
   AdmsSensFadType & modelPar_PLWPSCE,
   bool modelPar_given_PLWPSCE,
   AdmsSensFadType & modelPar_POPSCEB,
   bool modelPar_given_POPSCEB,
   AdmsSensFadType & modelPar_POPSCED,
   bool modelPar_given_POPSCED,
   AdmsSensFadType & modelPar_POBETN,
   bool modelPar_given_POBETN,
   AdmsSensFadType & modelPar_PLBETN,
   bool modelPar_given_PLBETN,
   AdmsSensFadType & modelPar_PWBETN,
   bool modelPar_given_PWBETN,
   AdmsSensFadType & modelPar_PLWBETN,
   bool modelPar_given_PLWBETN,
   AdmsSensFadType & modelPar_POSTBET,
   bool modelPar_given_POSTBET,
   AdmsSensFadType & modelPar_PLSTBET,
   bool modelPar_given_PLSTBET,
   AdmsSensFadType & modelPar_PWSTBET,
   bool modelPar_given_PWSTBET,
   AdmsSensFadType & modelPar_PLWSTBET,
   bool modelPar_given_PLWSTBET,
   AdmsSensFadType & modelPar_POMUE,
   bool modelPar_given_POMUE,
   AdmsSensFadType & modelPar_PLMUE,
   bool modelPar_given_PLMUE,
   AdmsSensFadType & modelPar_PWMUE,
   bool modelPar_given_PWMUE,
   AdmsSensFadType & modelPar_PLWMUE,
   bool modelPar_given_PLWMUE,
   AdmsSensFadType & modelPar_POSTMUE,
   bool modelPar_given_POSTMUE,
   AdmsSensFadType & modelPar_POTHEMU,
   bool modelPar_given_POTHEMU,
   AdmsSensFadType & modelPar_POSTTHEMU,
   bool modelPar_given_POSTTHEMU,
   AdmsSensFadType & modelPar_POCS,
   bool modelPar_given_POCS,
   AdmsSensFadType & modelPar_PLCS,
   bool modelPar_given_PLCS,
   AdmsSensFadType & modelPar_PWCS,
   bool modelPar_given_PWCS,
   AdmsSensFadType & modelPar_PLWCS,
   bool modelPar_given_PLWCS,
   AdmsSensFadType & modelPar_POSTCS,
   bool modelPar_given_POSTCS,
   AdmsSensFadType & modelPar_POXCOR,
   bool modelPar_given_POXCOR,
   AdmsSensFadType & modelPar_PLXCOR,
   bool modelPar_given_PLXCOR,
   AdmsSensFadType & modelPar_PWXCOR,
   bool modelPar_given_PWXCOR,
   AdmsSensFadType & modelPar_PLWXCOR,
   bool modelPar_given_PLWXCOR,
   AdmsSensFadType & modelPar_POSTXCOR,
   bool modelPar_given_POSTXCOR,
   AdmsSensFadType & modelPar_POFETA,
   bool modelPar_given_POFETA,
   AdmsSensFadType & modelPar_PORS,
   bool modelPar_given_PORS,
   AdmsSensFadType & modelPar_PLRS,
   bool modelPar_given_PLRS,
   AdmsSensFadType & modelPar_PWRS,
   bool modelPar_given_PWRS,
   AdmsSensFadType & modelPar_PLWRS,
   bool modelPar_given_PLWRS,
   AdmsSensFadType & modelPar_POSTRS,
   bool modelPar_given_POSTRS,
   AdmsSensFadType & modelPar_PORSB,
   bool modelPar_given_PORSB,
   AdmsSensFadType & modelPar_PORSG,
   bool modelPar_given_PORSG,
   AdmsSensFadType & modelPar_POTHESAT,
   bool modelPar_given_POTHESAT,
   AdmsSensFadType & modelPar_PLTHESAT,
   bool modelPar_given_PLTHESAT,
   AdmsSensFadType & modelPar_PWTHESAT,
   bool modelPar_given_PWTHESAT,
   AdmsSensFadType & modelPar_PLWTHESAT,
   bool modelPar_given_PLWTHESAT,
   AdmsSensFadType & modelPar_POSTTHESAT,
   bool modelPar_given_POSTTHESAT,
   AdmsSensFadType & modelPar_PLSTTHESAT,
   bool modelPar_given_PLSTTHESAT,
   AdmsSensFadType & modelPar_PWSTTHESAT,
   bool modelPar_given_PWSTTHESAT,
   AdmsSensFadType & modelPar_PLWSTTHESAT,
   bool modelPar_given_PLWSTTHESAT,
   AdmsSensFadType & modelPar_POTHESATB,
   bool modelPar_given_POTHESATB,
   AdmsSensFadType & modelPar_PLTHESATB,
   bool modelPar_given_PLTHESATB,
   AdmsSensFadType & modelPar_PWTHESATB,
   bool modelPar_given_PWTHESATB,
   AdmsSensFadType & modelPar_PLWTHESATB,
   bool modelPar_given_PLWTHESATB,
   AdmsSensFadType & modelPar_POTHESATG,
   bool modelPar_given_POTHESATG,
   AdmsSensFadType & modelPar_PLTHESATG,
   bool modelPar_given_PLTHESATG,
   AdmsSensFadType & modelPar_PWTHESATG,
   bool modelPar_given_PWTHESATG,
   AdmsSensFadType & modelPar_PLWTHESATG,
   bool modelPar_given_PLWTHESATG,
   AdmsSensFadType & modelPar_POAX,
   bool modelPar_given_POAX,
   AdmsSensFadType & modelPar_PLAX,
   bool modelPar_given_PLAX,
   AdmsSensFadType & modelPar_PWAX,
   bool modelPar_given_PWAX,
   AdmsSensFadType & modelPar_PLWAX,
   bool modelPar_given_PLWAX,
   AdmsSensFadType & modelPar_POALP,
   bool modelPar_given_POALP,
   AdmsSensFadType & modelPar_PLALP,
   bool modelPar_given_PLALP,
   AdmsSensFadType & modelPar_PWALP,
   bool modelPar_given_PWALP,
   AdmsSensFadType & modelPar_PLWALP,
   bool modelPar_given_PLWALP,
   AdmsSensFadType & modelPar_POALP1,
   bool modelPar_given_POALP1,
   AdmsSensFadType & modelPar_PLALP1,
   bool modelPar_given_PLALP1,
   AdmsSensFadType & modelPar_PWALP1,
   bool modelPar_given_PWALP1,
   AdmsSensFadType & modelPar_PLWALP1,
   bool modelPar_given_PLWALP1,
   AdmsSensFadType & modelPar_POALP2,
   bool modelPar_given_POALP2,
   AdmsSensFadType & modelPar_PLALP2,
   bool modelPar_given_PLALP2,
   AdmsSensFadType & modelPar_PWALP2,
   bool modelPar_given_PWALP2,
   AdmsSensFadType & modelPar_PLWALP2,
   bool modelPar_given_PLWALP2,
   AdmsSensFadType & modelPar_POVP,
   bool modelPar_given_POVP,
   AdmsSensFadType & modelPar_POA1,
   bool modelPar_given_POA1,
   AdmsSensFadType & modelPar_PLA1,
   bool modelPar_given_PLA1,
   AdmsSensFadType & modelPar_PWA1,
   bool modelPar_given_PWA1,
   AdmsSensFadType & modelPar_PLWA1,
   bool modelPar_given_PLWA1,
   AdmsSensFadType & modelPar_POA2,
   bool modelPar_given_POA2,
   AdmsSensFadType & modelPar_POSTA2,
   bool modelPar_given_POSTA2,
   AdmsSensFadType & modelPar_POA3,
   bool modelPar_given_POA3,
   AdmsSensFadType & modelPar_PLA3,
   bool modelPar_given_PLA3,
   AdmsSensFadType & modelPar_PWA3,
   bool modelPar_given_PWA3,
   AdmsSensFadType & modelPar_PLWA3,
   bool modelPar_given_PLWA3,
   AdmsSensFadType & modelPar_POA4,
   bool modelPar_given_POA4,
   AdmsSensFadType & modelPar_PLA4,
   bool modelPar_given_PLA4,
   AdmsSensFadType & modelPar_PWA4,
   bool modelPar_given_PWA4,
   AdmsSensFadType & modelPar_PLWA4,
   bool modelPar_given_PLWA4,
   AdmsSensFadType & modelPar_POGCO,
   bool modelPar_given_POGCO,
   AdmsSensFadType & modelPar_POIGINV,
   bool modelPar_given_POIGINV,
   AdmsSensFadType & modelPar_PLIGINV,
   bool modelPar_given_PLIGINV,
   AdmsSensFadType & modelPar_PWIGINV,
   bool modelPar_given_PWIGINV,
   AdmsSensFadType & modelPar_PLWIGINV,
   bool modelPar_given_PLWIGINV,
   AdmsSensFadType & modelPar_POIGOV,
   bool modelPar_given_POIGOV,
   AdmsSensFadType & modelPar_PLIGOV,
   bool modelPar_given_PLIGOV,
   AdmsSensFadType & modelPar_PWIGOV,
   bool modelPar_given_PWIGOV,
   AdmsSensFadType & modelPar_PLWIGOV,
   bool modelPar_given_PLWIGOV,
   AdmsSensFadType & modelPar_POIGOVD,
   bool modelPar_given_POIGOVD,
   AdmsSensFadType & modelPar_PLIGOVD,
   bool modelPar_given_PLIGOVD,
   AdmsSensFadType & modelPar_PWIGOVD,
   bool modelPar_given_PWIGOVD,
   AdmsSensFadType & modelPar_PLWIGOVD,
   bool modelPar_given_PLWIGOVD,
   AdmsSensFadType & modelPar_POSTIG,
   bool modelPar_given_POSTIG,
   AdmsSensFadType & modelPar_POGC2,
   bool modelPar_given_POGC2,
   AdmsSensFadType & modelPar_POGC3,
   bool modelPar_given_POGC3,
   AdmsSensFadType & modelPar_POCHIB,
   bool modelPar_given_POCHIB,
   AdmsSensFadType & modelPar_POAGIDL,
   bool modelPar_given_POAGIDL,
   AdmsSensFadType & modelPar_PLAGIDL,
   bool modelPar_given_PLAGIDL,
   AdmsSensFadType & modelPar_PWAGIDL,
   bool modelPar_given_PWAGIDL,
   AdmsSensFadType & modelPar_PLWAGIDL,
   bool modelPar_given_PLWAGIDL,
   AdmsSensFadType & modelPar_POAGIDLD,
   bool modelPar_given_POAGIDLD,
   AdmsSensFadType & modelPar_PLAGIDLD,
   bool modelPar_given_PLAGIDLD,
   AdmsSensFadType & modelPar_PWAGIDLD,
   bool modelPar_given_PWAGIDLD,
   AdmsSensFadType & modelPar_PLWAGIDLD,
   bool modelPar_given_PLWAGIDLD,
   AdmsSensFadType & modelPar_POBGIDL,
   bool modelPar_given_POBGIDL,
   AdmsSensFadType & modelPar_POBGIDLD,
   bool modelPar_given_POBGIDLD,
   AdmsSensFadType & modelPar_POSTBGIDL,
   bool modelPar_given_POSTBGIDL,
   AdmsSensFadType & modelPar_POSTBGIDLD,
   bool modelPar_given_POSTBGIDLD,
   AdmsSensFadType & modelPar_POCGIDL,
   bool modelPar_given_POCGIDL,
   AdmsSensFadType & modelPar_POCGIDLD,
   bool modelPar_given_POCGIDLD,
   AdmsSensFadType & modelPar_POCOX,
   bool modelPar_given_POCOX,
   AdmsSensFadType & modelPar_PLCOX,
   bool modelPar_given_PLCOX,
   AdmsSensFadType & modelPar_PWCOX,
   bool modelPar_given_PWCOX,
   AdmsSensFadType & modelPar_PLWCOX,
   bool modelPar_given_PLWCOX,
   AdmsSensFadType & modelPar_POCGOV,
   bool modelPar_given_POCGOV,
   AdmsSensFadType & modelPar_PLCGOV,
   bool modelPar_given_PLCGOV,
   AdmsSensFadType & modelPar_PWCGOV,
   bool modelPar_given_PWCGOV,
   AdmsSensFadType & modelPar_PLWCGOV,
   bool modelPar_given_PLWCGOV,
   AdmsSensFadType & modelPar_POCGOVD,
   bool modelPar_given_POCGOVD,
   AdmsSensFadType & modelPar_PLCGOVD,
   bool modelPar_given_PLCGOVD,
   AdmsSensFadType & modelPar_PWCGOVD,
   bool modelPar_given_PWCGOVD,
   AdmsSensFadType & modelPar_PLWCGOVD,
   bool modelPar_given_PLWCGOVD,
   AdmsSensFadType & modelPar_POCGBOV,
   bool modelPar_given_POCGBOV,
   AdmsSensFadType & modelPar_PLCGBOV,
   bool modelPar_given_PLCGBOV,
   AdmsSensFadType & modelPar_PWCGBOV,
   bool modelPar_given_PWCGBOV,
   AdmsSensFadType & modelPar_PLWCGBOV,
   bool modelPar_given_PLWCGBOV,
   AdmsSensFadType & modelPar_POCFR,
   bool modelPar_given_POCFR,
   AdmsSensFadType & modelPar_PLCFR,
   bool modelPar_given_PLCFR,
   AdmsSensFadType & modelPar_PWCFR,
   bool modelPar_given_PWCFR,
   AdmsSensFadType & modelPar_PLWCFR,
   bool modelPar_given_PLWCFR,
   AdmsSensFadType & modelPar_POCFRD,
   bool modelPar_given_POCFRD,
   AdmsSensFadType & modelPar_PLCFRD,
   bool modelPar_given_PLCFRD,
   AdmsSensFadType & modelPar_PWCFRD,
   bool modelPar_given_PWCFRD,
   AdmsSensFadType & modelPar_PLWCFRD,
   bool modelPar_given_PLWCFRD,
   AdmsSensFadType & modelPar_POFNT,
   bool modelPar_given_POFNT,
   AdmsSensFadType & modelPar_POFNTEXC,
   bool modelPar_given_POFNTEXC,
   AdmsSensFadType & modelPar_PLFNTEXC,
   bool modelPar_given_PLFNTEXC,
   AdmsSensFadType & modelPar_PWFNTEXC,
   bool modelPar_given_PWFNTEXC,
   AdmsSensFadType & modelPar_PLWFNTEXC,
   bool modelPar_given_PLWFNTEXC,
   AdmsSensFadType & modelPar_PONFA,
   bool modelPar_given_PONFA,
   AdmsSensFadType & modelPar_PLNFA,
   bool modelPar_given_PLNFA,
   AdmsSensFadType & modelPar_PWNFA,
   bool modelPar_given_PWNFA,
   AdmsSensFadType & modelPar_PLWNFA,
   bool modelPar_given_PLWNFA,
   AdmsSensFadType & modelPar_PONFB,
   bool modelPar_given_PONFB,
   AdmsSensFadType & modelPar_PLNFB,
   bool modelPar_given_PLNFB,
   AdmsSensFadType & modelPar_PWNFB,
   bool modelPar_given_PWNFB,
   AdmsSensFadType & modelPar_PLWNFB,
   bool modelPar_given_PLWNFB,
   AdmsSensFadType & modelPar_PONFC,
   bool modelPar_given_PONFC,
   AdmsSensFadType & modelPar_PLNFC,
   bool modelPar_given_PLNFC,
   AdmsSensFadType & modelPar_PWNFC,
   bool modelPar_given_PWNFC,
   AdmsSensFadType & modelPar_PLWNFC,
   bool modelPar_given_PLWNFC,
   AdmsSensFadType & modelPar_POEF,
   bool modelPar_given_POEF,
   AdmsSensFadType & modelPar_POVFBEDGE,
   bool modelPar_given_POVFBEDGE,
   AdmsSensFadType & modelPar_POSTVFBEDGE,
   bool modelPar_given_POSTVFBEDGE,
   AdmsSensFadType & modelPar_PLSTVFBEDGE,
   bool modelPar_given_PLSTVFBEDGE,
   AdmsSensFadType & modelPar_PWSTVFBEDGE,
   bool modelPar_given_PWSTVFBEDGE,
   AdmsSensFadType & modelPar_PLWSTVFBEDGE,
   bool modelPar_given_PLWSTVFBEDGE,
   AdmsSensFadType & modelPar_PODPHIBEDGE,
   bool modelPar_given_PODPHIBEDGE,
   AdmsSensFadType & modelPar_PLDPHIBEDGE,
   bool modelPar_given_PLDPHIBEDGE,
   AdmsSensFadType & modelPar_PWDPHIBEDGE,
   bool modelPar_given_PWDPHIBEDGE,
   AdmsSensFadType & modelPar_PLWDPHIBEDGE,
   bool modelPar_given_PLWDPHIBEDGE,
   AdmsSensFadType & modelPar_PONEFFEDGE,
   bool modelPar_given_PONEFFEDGE,
   AdmsSensFadType & modelPar_PLNEFFEDGE,
   bool modelPar_given_PLNEFFEDGE,
   AdmsSensFadType & modelPar_PWNEFFEDGE,
   bool modelPar_given_PWNEFFEDGE,
   AdmsSensFadType & modelPar_PLWNEFFEDGE,
   bool modelPar_given_PLWNEFFEDGE,
   AdmsSensFadType & modelPar_POCTEDGE,
   bool modelPar_given_POCTEDGE,
   AdmsSensFadType & modelPar_PLCTEDGE,
   bool modelPar_given_PLCTEDGE,
   AdmsSensFadType & modelPar_PWCTEDGE,
   bool modelPar_given_PWCTEDGE,
   AdmsSensFadType & modelPar_PLWCTEDGE,
   bool modelPar_given_PLWCTEDGE,
   AdmsSensFadType & modelPar_POBETNEDGE,
   bool modelPar_given_POBETNEDGE,
   AdmsSensFadType & modelPar_PLBETNEDGE,
   bool modelPar_given_PLBETNEDGE,
   AdmsSensFadType & modelPar_PWBETNEDGE,
   bool modelPar_given_PWBETNEDGE,
   AdmsSensFadType & modelPar_PLWBETNEDGE,
   bool modelPar_given_PLWBETNEDGE,
   AdmsSensFadType & modelPar_POSTBETEDGE,
   bool modelPar_given_POSTBETEDGE,
   AdmsSensFadType & modelPar_PLSTBETEDGE,
   bool modelPar_given_PLSTBETEDGE,
   AdmsSensFadType & modelPar_PWSTBETEDGE,
   bool modelPar_given_PWSTBETEDGE,
   AdmsSensFadType & modelPar_PLWSTBETEDGE,
   bool modelPar_given_PLWSTBETEDGE,
   AdmsSensFadType & modelPar_POPSCEEDGE,
   bool modelPar_given_POPSCEEDGE,
   AdmsSensFadType & modelPar_PLPSCEEDGE,
   bool modelPar_given_PLPSCEEDGE,
   AdmsSensFadType & modelPar_PWPSCEEDGE,
   bool modelPar_given_PWPSCEEDGE,
   AdmsSensFadType & modelPar_PLWPSCEEDGE,
   bool modelPar_given_PLWPSCEEDGE,
   AdmsSensFadType & modelPar_POPSCEBEDGE,
   bool modelPar_given_POPSCEBEDGE,
   AdmsSensFadType & modelPar_POPSCEDEDGE,
   bool modelPar_given_POPSCEDEDGE,
   AdmsSensFadType & modelPar_POCFEDGE,
   bool modelPar_given_POCFEDGE,
   AdmsSensFadType & modelPar_PLCFEDGE,
   bool modelPar_given_PLCFEDGE,
   AdmsSensFadType & modelPar_PWCFEDGE,
   bool modelPar_given_PWCFEDGE,
   AdmsSensFadType & modelPar_PLWCFEDGE,
   bool modelPar_given_PLWCFEDGE,
   AdmsSensFadType & modelPar_POCFDEDGE,
   bool modelPar_given_POCFDEDGE,
   AdmsSensFadType & modelPar_POCFBEDGE,
   bool modelPar_given_POCFBEDGE,
   AdmsSensFadType & modelPar_POFNTEDGE,
   bool modelPar_given_POFNTEDGE,
   AdmsSensFadType & modelPar_PONFAEDGE,
   bool modelPar_given_PONFAEDGE,
   AdmsSensFadType & modelPar_PLNFAEDGE,
   bool modelPar_given_PLNFAEDGE,
   AdmsSensFadType & modelPar_PWNFAEDGE,
   bool modelPar_given_PWNFAEDGE,
   AdmsSensFadType & modelPar_PLWNFAEDGE,
   bool modelPar_given_PLWNFAEDGE,
   AdmsSensFadType & modelPar_PONFBEDGE,
   bool modelPar_given_PONFBEDGE,
   AdmsSensFadType & modelPar_PLNFBEDGE,
   bool modelPar_given_PLNFBEDGE,
   AdmsSensFadType & modelPar_PWNFBEDGE,
   bool modelPar_given_PWNFBEDGE,
   AdmsSensFadType & modelPar_PLWNFBEDGE,
   bool modelPar_given_PLWNFBEDGE,
   AdmsSensFadType & modelPar_PONFCEDGE,
   bool modelPar_given_PONFCEDGE,
   AdmsSensFadType & modelPar_PLNFCEDGE,
   bool modelPar_given_PLNFCEDGE,
   AdmsSensFadType & modelPar_PWNFCEDGE,
   bool modelPar_given_PWNFCEDGE,
   AdmsSensFadType & modelPar_PLWNFCEDGE,
   bool modelPar_given_PLWNFCEDGE,
   AdmsSensFadType & modelPar_POEFEDGE,
   bool modelPar_given_POEFEDGE,
   AdmsSensFadType & modelPar_POKVTHOWE,
   bool modelPar_given_POKVTHOWE,
   AdmsSensFadType & modelPar_PLKVTHOWE,
   bool modelPar_given_PLKVTHOWE,
   AdmsSensFadType & modelPar_PWKVTHOWE,
   bool modelPar_given_PWKVTHOWE,
   AdmsSensFadType & modelPar_PLWKVTHOWE,
   bool modelPar_given_PLWKVTHOWE,
   AdmsSensFadType & modelPar_POKUOWE,
   bool modelPar_given_POKUOWE,
   AdmsSensFadType & modelPar_PLKUOWE,
   bool modelPar_given_PLKUOWE,
   AdmsSensFadType & modelPar_PWKUOWE,
   bool modelPar_given_PWKUOWE,
   AdmsSensFadType & modelPar_PLWKUOWE,
   bool modelPar_given_PLWKUOWE,
   AdmsSensFadType & modelPar_LMIN,
   bool modelPar_given_LMIN,
   AdmsSensFadType & modelPar_LMAX,
   bool modelPar_given_LMAX,
   AdmsSensFadType & modelPar_WMIN,
   bool modelPar_given_WMIN,
   AdmsSensFadType & modelPar_WMAX,
   bool modelPar_given_WMAX,
   AdmsSensFadType & modelPar_LVARO,
   bool modelPar_given_LVARO,
   AdmsSensFadType & modelPar_LVARL,
   bool modelPar_given_LVARL,
   AdmsSensFadType & modelPar_LVARW,
   bool modelPar_given_LVARW,
   AdmsSensFadType & modelPar_LAP,
   bool modelPar_given_LAP,
   AdmsSensFadType & modelPar_WVARO,
   bool modelPar_given_WVARO,
   AdmsSensFadType & modelPar_WVARL,
   bool modelPar_given_WVARL,
   AdmsSensFadType & modelPar_WVARW,
   bool modelPar_given_WVARW,
   AdmsSensFadType & modelPar_WOT,
   bool modelPar_given_WOT,
   AdmsSensFadType & modelPar_DLQ,
   bool modelPar_given_DLQ,
   AdmsSensFadType & modelPar_DWQ,
   bool modelPar_given_DWQ,
   AdmsSensFadType & modelPar_VFBO,
   bool modelPar_given_VFBO,
   AdmsSensFadType & modelPar_VFBL,
   bool modelPar_given_VFBL,
   AdmsSensFadType & modelPar_VFBW,
   bool modelPar_given_VFBW,
   AdmsSensFadType & modelPar_VFBLW,
   bool modelPar_given_VFBLW,
   AdmsSensFadType & modelPar_STVFBO,
   bool modelPar_given_STVFBO,
   AdmsSensFadType & modelPar_STVFBL,
   bool modelPar_given_STVFBL,
   AdmsSensFadType & modelPar_STVFBW,
   bool modelPar_given_STVFBW,
   AdmsSensFadType & modelPar_STVFBLW,
   bool modelPar_given_STVFBLW,
   AdmsSensFadType & modelPar_TOXO,
   bool modelPar_given_TOXO,
   AdmsSensFadType & modelPar_EPSROXO,
   bool modelPar_given_EPSROXO,
   AdmsSensFadType & modelPar_NSUBO,
   bool modelPar_given_NSUBO,
   AdmsSensFadType & modelPar_NSUBW,
   bool modelPar_given_NSUBW,
   AdmsSensFadType & modelPar_WSEG,
   bool modelPar_given_WSEG,
   AdmsSensFadType & modelPar_NPCK,
   bool modelPar_given_NPCK,
   AdmsSensFadType & modelPar_NPCKW,
   bool modelPar_given_NPCKW,
   AdmsSensFadType & modelPar_WSEGP,
   bool modelPar_given_WSEGP,
   AdmsSensFadType & modelPar_LPCK,
   bool modelPar_given_LPCK,
   AdmsSensFadType & modelPar_LPCKW,
   bool modelPar_given_LPCKW,
   AdmsSensFadType & modelPar_FOL1,
   bool modelPar_given_FOL1,
   AdmsSensFadType & modelPar_FOL2,
   bool modelPar_given_FOL2,
   AdmsSensFadType & modelPar_FACNEFFACO,
   bool modelPar_given_FACNEFFACO,
   AdmsSensFadType & modelPar_FACNEFFACL,
   bool modelPar_given_FACNEFFACL,
   AdmsSensFadType & modelPar_FACNEFFACW,
   bool modelPar_given_FACNEFFACW,
   AdmsSensFadType & modelPar_FACNEFFACLW,
   bool modelPar_given_FACNEFFACLW,
   AdmsSensFadType & modelPar_GFACNUDO,
   bool modelPar_given_GFACNUDO,
   AdmsSensFadType & modelPar_GFACNUDL,
   bool modelPar_given_GFACNUDL,
   AdmsSensFadType & modelPar_GFACNUDLEXP,
   bool modelPar_given_GFACNUDLEXP,
   AdmsSensFadType & modelPar_GFACNUDW,
   bool modelPar_given_GFACNUDW,
   AdmsSensFadType & modelPar_GFACNUDLW,
   bool modelPar_given_GFACNUDLW,
   AdmsSensFadType & modelPar_VSBNUDO,
   bool modelPar_given_VSBNUDO,
   AdmsSensFadType & modelPar_DVSBNUDO,
   bool modelPar_given_DVSBNUDO,
   AdmsSensFadType & modelPar_VNSUBO,
   bool modelPar_given_VNSUBO,
   AdmsSensFadType & modelPar_NSLPO,
   bool modelPar_given_NSLPO,
   AdmsSensFadType & modelPar_DNSUBO,
   bool modelPar_given_DNSUBO,
   AdmsSensFadType & modelPar_DPHIBO,
   bool modelPar_given_DPHIBO,
   AdmsSensFadType & modelPar_DPHIBL,
   bool modelPar_given_DPHIBL,
   AdmsSensFadType & modelPar_DPHIBLEXP,
   bool modelPar_given_DPHIBLEXP,
   AdmsSensFadType & modelPar_DPHIBW,
   bool modelPar_given_DPHIBW,
   AdmsSensFadType & modelPar_DPHIBLW,
   bool modelPar_given_DPHIBLW,
   AdmsSensFadType & modelPar_DELVTACO,
   bool modelPar_given_DELVTACO,
   AdmsSensFadType & modelPar_DELVTACL,
   bool modelPar_given_DELVTACL,
   AdmsSensFadType & modelPar_DELVTACLEXP,
   bool modelPar_given_DELVTACLEXP,
   AdmsSensFadType & modelPar_DELVTACW,
   bool modelPar_given_DELVTACW,
   AdmsSensFadType & modelPar_DELVTACLW,
   bool modelPar_given_DELVTACLW,
   AdmsSensFadType & modelPar_NPO,
   bool modelPar_given_NPO,
   AdmsSensFadType & modelPar_NPL,
   bool modelPar_given_NPL,
   AdmsSensFadType & modelPar_CTO,
   bool modelPar_given_CTO,
   AdmsSensFadType & modelPar_CTL,
   bool modelPar_given_CTL,
   AdmsSensFadType & modelPar_CTLEXP,
   bool modelPar_given_CTLEXP,
   AdmsSensFadType & modelPar_CTW,
   bool modelPar_given_CTW,
   AdmsSensFadType & modelPar_CTLW,
   bool modelPar_given_CTLW,
   AdmsSensFadType & modelPar_TOXOVO,
   bool modelPar_given_TOXOVO,
   AdmsSensFadType & modelPar_TOXOVDO,
   bool modelPar_given_TOXOVDO,
   AdmsSensFadType & modelPar_LOV,
   bool modelPar_given_LOV,
   AdmsSensFadType & modelPar_LOVD,
   bool modelPar_given_LOVD,
   AdmsSensFadType & modelPar_NOVO,
   bool modelPar_given_NOVO,
   AdmsSensFadType & modelPar_NOVDO,
   bool modelPar_given_NOVDO,
   AdmsSensFadType & modelPar_CFL,
   bool modelPar_given_CFL,
   AdmsSensFadType & modelPar_CFLEXP,
   bool modelPar_given_CFLEXP,
   AdmsSensFadType & modelPar_CFW,
   bool modelPar_given_CFW,
   AdmsSensFadType & modelPar_CFDO,
   bool modelPar_given_CFDO,
   AdmsSensFadType & modelPar_CFBO,
   bool modelPar_given_CFBO,
   AdmsSensFadType & modelPar_PSCEL,
   bool modelPar_given_PSCEL,
   AdmsSensFadType & modelPar_PSCELEXP,
   bool modelPar_given_PSCELEXP,
   AdmsSensFadType & modelPar_PSCEW,
   bool modelPar_given_PSCEW,
   AdmsSensFadType & modelPar_PSCEBO,
   bool modelPar_given_PSCEBO,
   AdmsSensFadType & modelPar_PSCEDO,
   bool modelPar_given_PSCEDO,
   AdmsSensFadType & modelPar_UO,
   bool modelPar_given_UO,
   AdmsSensFadType & modelPar_FBET1,
   bool modelPar_given_FBET1,
   AdmsSensFadType & modelPar_FBET1W,
   bool modelPar_given_FBET1W,
   AdmsSensFadType & modelPar_LP1,
   bool modelPar_given_LP1,
   AdmsSensFadType & modelPar_LP1W,
   bool modelPar_given_LP1W,
   AdmsSensFadType & modelPar_FBET2,
   bool modelPar_given_FBET2,
   AdmsSensFadType & modelPar_LP2,
   bool modelPar_given_LP2,
   AdmsSensFadType & modelPar_BETW1,
   bool modelPar_given_BETW1,
   AdmsSensFadType & modelPar_BETW2,
   bool modelPar_given_BETW2,
   AdmsSensFadType & modelPar_WBET,
   bool modelPar_given_WBET,
   AdmsSensFadType & modelPar_STBETO,
   bool modelPar_given_STBETO,
   AdmsSensFadType & modelPar_STBETL,
   bool modelPar_given_STBETL,
   AdmsSensFadType & modelPar_STBETW,
   bool modelPar_given_STBETW,
   AdmsSensFadType & modelPar_STBETLW,
   bool modelPar_given_STBETLW,
   AdmsSensFadType & modelPar_MUEO,
   bool modelPar_given_MUEO,
   AdmsSensFadType & modelPar_MUEW,
   bool modelPar_given_MUEW,
   AdmsSensFadType & modelPar_STMUEO,
   bool modelPar_given_STMUEO,
   AdmsSensFadType & modelPar_THEMUO,
   bool modelPar_given_THEMUO,
   AdmsSensFadType & modelPar_STTHEMUO,
   bool modelPar_given_STTHEMUO,
   AdmsSensFadType & modelPar_CSO,
   bool modelPar_given_CSO,
   AdmsSensFadType & modelPar_CSL,
   bool modelPar_given_CSL,
   AdmsSensFadType & modelPar_CSLEXP,
   bool modelPar_given_CSLEXP,
   AdmsSensFadType & modelPar_CSW,
   bool modelPar_given_CSW,
   AdmsSensFadType & modelPar_CSLW,
   bool modelPar_given_CSLW,
   AdmsSensFadType & modelPar_STCSO,
   bool modelPar_given_STCSO,
   AdmsSensFadType & modelPar_XCORO,
   bool modelPar_given_XCORO,
   AdmsSensFadType & modelPar_XCORL,
   bool modelPar_given_XCORL,
   AdmsSensFadType & modelPar_XCORW,
   bool modelPar_given_XCORW,
   AdmsSensFadType & modelPar_XCORLW,
   bool modelPar_given_XCORLW,
   AdmsSensFadType & modelPar_STXCORO,
   bool modelPar_given_STXCORO,
   AdmsSensFadType & modelPar_FETAO,
   bool modelPar_given_FETAO,
   AdmsSensFadType & modelPar_RSW1,
   bool modelPar_given_RSW1,
   AdmsSensFadType & modelPar_RSW2,
   bool modelPar_given_RSW2,
   AdmsSensFadType & modelPar_STRSO,
   bool modelPar_given_STRSO,
   AdmsSensFadType & modelPar_RSBO,
   bool modelPar_given_RSBO,
   AdmsSensFadType & modelPar_RSGO,
   bool modelPar_given_RSGO,
   AdmsSensFadType & modelPar_THESATO,
   bool modelPar_given_THESATO,
   AdmsSensFadType & modelPar_THESATL,
   bool modelPar_given_THESATL,
   AdmsSensFadType & modelPar_THESATLEXP,
   bool modelPar_given_THESATLEXP,
   AdmsSensFadType & modelPar_THESATW,
   bool modelPar_given_THESATW,
   AdmsSensFadType & modelPar_THESATLW,
   bool modelPar_given_THESATLW,
   AdmsSensFadType & modelPar_STTHESATO,
   bool modelPar_given_STTHESATO,
   AdmsSensFadType & modelPar_STTHESATL,
   bool modelPar_given_STTHESATL,
   AdmsSensFadType & modelPar_STTHESATW,
   bool modelPar_given_STTHESATW,
   AdmsSensFadType & modelPar_STTHESATLW,
   bool modelPar_given_STTHESATLW,
   AdmsSensFadType & modelPar_THESATBO,
   bool modelPar_given_THESATBO,
   AdmsSensFadType & modelPar_THESATGO,
   bool modelPar_given_THESATGO,
   AdmsSensFadType & modelPar_AXO,
   bool modelPar_given_AXO,
   AdmsSensFadType & modelPar_AXL,
   bool modelPar_given_AXL,
   AdmsSensFadType & modelPar_ALPL,
   bool modelPar_given_ALPL,
   AdmsSensFadType & modelPar_ALPLEXP,
   bool modelPar_given_ALPLEXP,
   AdmsSensFadType & modelPar_ALPW,
   bool modelPar_given_ALPW,
   AdmsSensFadType & modelPar_ALP1L1,
   bool modelPar_given_ALP1L1,
   AdmsSensFadType & modelPar_ALP1LEXP,
   bool modelPar_given_ALP1LEXP,
   AdmsSensFadType & modelPar_ALP1L2,
   bool modelPar_given_ALP1L2,
   AdmsSensFadType & modelPar_ALP1W,
   bool modelPar_given_ALP1W,
   AdmsSensFadType & modelPar_ALP2L1,
   bool modelPar_given_ALP2L1,
   AdmsSensFadType & modelPar_ALP2LEXP,
   bool modelPar_given_ALP2LEXP,
   AdmsSensFadType & modelPar_ALP2L2,
   bool modelPar_given_ALP2L2,
   AdmsSensFadType & modelPar_ALP2W,
   bool modelPar_given_ALP2W,
   AdmsSensFadType & modelPar_VPO,
   bool modelPar_given_VPO,
   AdmsSensFadType & modelPar_A1O,
   bool modelPar_given_A1O,
   AdmsSensFadType & modelPar_A1L,
   bool modelPar_given_A1L,
   AdmsSensFadType & modelPar_A1W,
   bool modelPar_given_A1W,
   AdmsSensFadType & modelPar_A2O,
   bool modelPar_given_A2O,
   AdmsSensFadType & modelPar_STA2O,
   bool modelPar_given_STA2O,
   AdmsSensFadType & modelPar_A3O,
   bool modelPar_given_A3O,
   AdmsSensFadType & modelPar_A3L,
   bool modelPar_given_A3L,
   AdmsSensFadType & modelPar_A3W,
   bool modelPar_given_A3W,
   AdmsSensFadType & modelPar_A4O,
   bool modelPar_given_A4O,
   AdmsSensFadType & modelPar_A4L,
   bool modelPar_given_A4L,
   AdmsSensFadType & modelPar_A4W,
   bool modelPar_given_A4W,
   AdmsSensFadType & modelPar_GCOO,
   bool modelPar_given_GCOO,
   AdmsSensFadType & modelPar_IGINVLW,
   bool modelPar_given_IGINVLW,
   AdmsSensFadType & modelPar_IGOVW,
   bool modelPar_given_IGOVW,
   AdmsSensFadType & modelPar_IGOVDW,
   bool modelPar_given_IGOVDW,
   AdmsSensFadType & modelPar_STIGO,
   bool modelPar_given_STIGO,
   AdmsSensFadType & modelPar_GC2O,
   bool modelPar_given_GC2O,
   AdmsSensFadType & modelPar_GC3O,
   bool modelPar_given_GC3O,
   AdmsSensFadType & modelPar_CHIBO,
   bool modelPar_given_CHIBO,
   AdmsSensFadType & modelPar_AGIDLW,
   bool modelPar_given_AGIDLW,
   AdmsSensFadType & modelPar_AGIDLDW,
   bool modelPar_given_AGIDLDW,
   AdmsSensFadType & modelPar_BGIDLO,
   bool modelPar_given_BGIDLO,
   AdmsSensFadType & modelPar_BGIDLDO,
   bool modelPar_given_BGIDLDO,
   AdmsSensFadType & modelPar_STBGIDLO,
   bool modelPar_given_STBGIDLO,
   AdmsSensFadType & modelPar_STBGIDLDO,
   bool modelPar_given_STBGIDLDO,
   AdmsSensFadType & modelPar_CGIDLO,
   bool modelPar_given_CGIDLO,
   AdmsSensFadType & modelPar_CGIDLDO,
   bool modelPar_given_CGIDLDO,
   AdmsSensFadType & modelPar_CGBOVL,
   bool modelPar_given_CGBOVL,
   AdmsSensFadType & modelPar_CFRW,
   bool modelPar_given_CFRW,
   AdmsSensFadType & modelPar_CFRDW,
   bool modelPar_given_CFRDW,
   AdmsSensFadType & modelPar_FNTO,
   bool modelPar_given_FNTO,
   AdmsSensFadType & modelPar_FNTEXCL,
   bool modelPar_given_FNTEXCL,
   AdmsSensFadType & modelPar_NFALW,
   bool modelPar_given_NFALW,
   AdmsSensFadType & modelPar_NFBLW,
   bool modelPar_given_NFBLW,
   AdmsSensFadType & modelPar_NFCLW,
   bool modelPar_given_NFCLW,
   AdmsSensFadType & modelPar_EFO,
   bool modelPar_given_EFO,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_ALPNOI,
   bool modelPar_given_ALPNOI,
   AdmsSensFadType & modelPar_WEDGE,
   bool modelPar_given_WEDGE,
   AdmsSensFadType & modelPar_WEDGEW,
   bool modelPar_given_WEDGEW,
   AdmsSensFadType & modelPar_VFBEDGEO,
   bool modelPar_given_VFBEDGEO,
   AdmsSensFadType & modelPar_STVFBEDGEO,
   bool modelPar_given_STVFBEDGEO,
   AdmsSensFadType & modelPar_STVFBEDGEL,
   bool modelPar_given_STVFBEDGEL,
   AdmsSensFadType & modelPar_STVFBEDGEW,
   bool modelPar_given_STVFBEDGEW,
   AdmsSensFadType & modelPar_STVFBEDGELW,
   bool modelPar_given_STVFBEDGELW,
   AdmsSensFadType & modelPar_DPHIBEDGEO,
   bool modelPar_given_DPHIBEDGEO,
   AdmsSensFadType & modelPar_DPHIBEDGEL,
   bool modelPar_given_DPHIBEDGEL,
   AdmsSensFadType & modelPar_DPHIBEDGELEXP,
   bool modelPar_given_DPHIBEDGELEXP,
   AdmsSensFadType & modelPar_DPHIBEDGEW,
   bool modelPar_given_DPHIBEDGEW,
   AdmsSensFadType & modelPar_DPHIBEDGELW,
   bool modelPar_given_DPHIBEDGELW,
   AdmsSensFadType & modelPar_NSUBEDGEO,
   bool modelPar_given_NSUBEDGEO,
   AdmsSensFadType & modelPar_NSUBEDGEL,
   bool modelPar_given_NSUBEDGEL,
   AdmsSensFadType & modelPar_NSUBEDGEW,
   bool modelPar_given_NSUBEDGEW,
   AdmsSensFadType & modelPar_NSUBEDGELW,
   bool modelPar_given_NSUBEDGELW,
   AdmsSensFadType & modelPar_CTEDGEO,
   bool modelPar_given_CTEDGEO,
   AdmsSensFadType & modelPar_CTEDGEL,
   bool modelPar_given_CTEDGEL,
   AdmsSensFadType & modelPar_CTEDGELEXP,
   bool modelPar_given_CTEDGELEXP,
   AdmsSensFadType & modelPar_FBETEDGE,
   bool modelPar_given_FBETEDGE,
   AdmsSensFadType & modelPar_LPEDGE,
   bool modelPar_given_LPEDGE,
   AdmsSensFadType & modelPar_BETEDGEW,
   bool modelPar_given_BETEDGEW,
   AdmsSensFadType & modelPar_STBETEDGEO,
   bool modelPar_given_STBETEDGEO,
   AdmsSensFadType & modelPar_STBETEDGEL,
   bool modelPar_given_STBETEDGEL,
   AdmsSensFadType & modelPar_STBETEDGEW,
   bool modelPar_given_STBETEDGEW,
   AdmsSensFadType & modelPar_STBETEDGELW,
   bool modelPar_given_STBETEDGELW,
   AdmsSensFadType & modelPar_PSCEEDGEL,
   bool modelPar_given_PSCEEDGEL,
   AdmsSensFadType & modelPar_PSCEEDGELEXP,
   bool modelPar_given_PSCEEDGELEXP,
   AdmsSensFadType & modelPar_PSCEEDGEW,
   bool modelPar_given_PSCEEDGEW,
   AdmsSensFadType & modelPar_PSCEBEDGEO,
   bool modelPar_given_PSCEBEDGEO,
   AdmsSensFadType & modelPar_PSCEDEDGEO,
   bool modelPar_given_PSCEDEDGEO,
   AdmsSensFadType & modelPar_CFEDGEL,
   bool modelPar_given_CFEDGEL,
   AdmsSensFadType & modelPar_CFEDGELEXP,
   bool modelPar_given_CFEDGELEXP,
   AdmsSensFadType & modelPar_CFEDGEW,
   bool modelPar_given_CFEDGEW,
   AdmsSensFadType & modelPar_CFDEDGEO,
   bool modelPar_given_CFDEDGEO,
   AdmsSensFadType & modelPar_CFBEDGEO,
   bool modelPar_given_CFBEDGEO,
   AdmsSensFadType & modelPar_FNTEDGEO,
   bool modelPar_given_FNTEDGEO,
   AdmsSensFadType & modelPar_NFAEDGELW,
   bool modelPar_given_NFAEDGELW,
   AdmsSensFadType & modelPar_NFBEDGELW,
   bool modelPar_given_NFBEDGELW,
   AdmsSensFadType & modelPar_NFCEDGELW,
   bool modelPar_given_NFCEDGELW,
   AdmsSensFadType & modelPar_EFEDGEO,
   bool modelPar_given_EFEDGEO,
   AdmsSensFadType & modelPar_KVTHOWEO,
   bool modelPar_given_KVTHOWEO,
   AdmsSensFadType & modelPar_KVTHOWEL,
   bool modelPar_given_KVTHOWEL,
   AdmsSensFadType & modelPar_KVTHOWEW,
   bool modelPar_given_KVTHOWEW,
   AdmsSensFadType & modelPar_KVTHOWELW,
   bool modelPar_given_KVTHOWELW,
   AdmsSensFadType & modelPar_KUOWEO,
   bool modelPar_given_KUOWEO,
   AdmsSensFadType & modelPar_KUOWEL,
   bool modelPar_given_KUOWEL,
   AdmsSensFadType & modelPar_KUOWEW,
   bool modelPar_given_KUOWEW,
   AdmsSensFadType & modelPar_KUOWELW,
   bool modelPar_given_KUOWELW,
   AdmsSensFadType & modelPar_RGO,
   bool modelPar_given_RGO,
   AdmsSensFadType & modelPar_RINT,
   bool modelPar_given_RINT,
   AdmsSensFadType & modelPar_RVPOLY,
   bool modelPar_given_RVPOLY,
   AdmsSensFadType & modelPar_RSHG,
   bool modelPar_given_RSHG,
   AdmsSensFadType & modelPar_DLSIL,
   bool modelPar_given_DLSIL,
   AdmsSensFadType & modelPar_RSH,
   bool modelPar_given_RSH,
   AdmsSensFadType & modelPar_RSHD,
   bool modelPar_given_RSHD,
   AdmsSensFadType & modelPar_RBULKO,
   bool modelPar_given_RBULKO,
   AdmsSensFadType & modelPar_RWELLO,
   bool modelPar_given_RWELLO,
   AdmsSensFadType & modelPar_RJUNSO,
   bool modelPar_given_RJUNSO,
   AdmsSensFadType & modelPar_RJUNDO,
   bool modelPar_given_RJUNDO,
   AdmsSensFadType & modelPar_SAREF,
   bool modelPar_given_SAREF,
   AdmsSensFadType & modelPar_SBREF,
   bool modelPar_given_SBREF,
   AdmsSensFadType & modelPar_WLOD,
   bool modelPar_given_WLOD,
   AdmsSensFadType & modelPar_KUO,
   bool modelPar_given_KUO,
   AdmsSensFadType & modelPar_KVSAT,
   bool modelPar_given_KVSAT,
   AdmsSensFadType & modelPar_TKUO,
   bool modelPar_given_TKUO,
   AdmsSensFadType & modelPar_LKUO,
   bool modelPar_given_LKUO,
   AdmsSensFadType & modelPar_WKUO,
   bool modelPar_given_WKUO,
   AdmsSensFadType & modelPar_PKUO,
   bool modelPar_given_PKUO,
   AdmsSensFadType & modelPar_LLODKUO,
   bool modelPar_given_LLODKUO,
   AdmsSensFadType & modelPar_WLODKUO,
   bool modelPar_given_WLODKUO,
   AdmsSensFadType & modelPar_KVTHO,
   bool modelPar_given_KVTHO,
   AdmsSensFadType & modelPar_LKVTHO,
   bool modelPar_given_LKVTHO,
   AdmsSensFadType & modelPar_WKVTHO,
   bool modelPar_given_WKVTHO,
   AdmsSensFadType & modelPar_PKVTHO,
   bool modelPar_given_PKVTHO,
   AdmsSensFadType & modelPar_LLODVTH,
   bool modelPar_given_LLODVTH,
   AdmsSensFadType & modelPar_WLODVTH,
   bool modelPar_given_WLODVTH,
   AdmsSensFadType & modelPar_STETAO,
   bool modelPar_given_STETAO,
   AdmsSensFadType & modelPar_LODETAO,
   bool modelPar_given_LODETAO,
   AdmsSensFadType & modelPar_SCREF,
   bool modelPar_given_SCREF,
   AdmsSensFadType & modelPar_WEB,
   bool modelPar_given_WEB,
   AdmsSensFadType & modelPar_WEC,
   bool modelPar_given_WEC,
   AdmsSensFadType & modelPar_IMAX,
   bool modelPar_given_IMAX,
   AdmsSensFadType & modelPar_TRJ,
   bool modelPar_given_TRJ,
   AdmsSensFadType & modelPar_FREV,
   bool modelPar_given_FREV,
   AdmsSensFadType & modelPar_CJORBOT,
   bool modelPar_given_CJORBOT,
   AdmsSensFadType & modelPar_CJORSTI,
   bool modelPar_given_CJORSTI,
   AdmsSensFadType & modelPar_CJORGAT,
   bool modelPar_given_CJORGAT,
   AdmsSensFadType & modelPar_VBIRBOT,
   bool modelPar_given_VBIRBOT,
   AdmsSensFadType & modelPar_VBIRSTI,
   bool modelPar_given_VBIRSTI,
   AdmsSensFadType & modelPar_VBIRGAT,
   bool modelPar_given_VBIRGAT,
   AdmsSensFadType & modelPar_PBOT,
   bool modelPar_given_PBOT,
   AdmsSensFadType & modelPar_PSTI,
   bool modelPar_given_PSTI,
   AdmsSensFadType & modelPar_PGAT,
   bool modelPar_given_PGAT,
   AdmsSensFadType & modelPar_PHIGBOT,
   bool modelPar_given_PHIGBOT,
   AdmsSensFadType & modelPar_PHIGSTI,
   bool modelPar_given_PHIGSTI,
   AdmsSensFadType & modelPar_PHIGGAT,
   bool modelPar_given_PHIGGAT,
   AdmsSensFadType & modelPar_IDSATRBOT,
   bool modelPar_given_IDSATRBOT,
   AdmsSensFadType & modelPar_IDSATRSTI,
   bool modelPar_given_IDSATRSTI,
   AdmsSensFadType & modelPar_IDSATRGAT,
   bool modelPar_given_IDSATRGAT,
   AdmsSensFadType & modelPar_CSRHBOT,
   bool modelPar_given_CSRHBOT,
   AdmsSensFadType & modelPar_CSRHSTI,
   bool modelPar_given_CSRHSTI,
   AdmsSensFadType & modelPar_CSRHGAT,
   bool modelPar_given_CSRHGAT,
   AdmsSensFadType & modelPar_XJUNSTI,
   bool modelPar_given_XJUNSTI,
   AdmsSensFadType & modelPar_XJUNGAT,
   bool modelPar_given_XJUNGAT,
   AdmsSensFadType & modelPar_CTATBOT,
   bool modelPar_given_CTATBOT,
   AdmsSensFadType & modelPar_CTATSTI,
   bool modelPar_given_CTATSTI,
   AdmsSensFadType & modelPar_CTATGAT,
   bool modelPar_given_CTATGAT,
   AdmsSensFadType & modelPar_MEFFTATBOT,
   bool modelPar_given_MEFFTATBOT,
   AdmsSensFadType & modelPar_MEFFTATSTI,
   bool modelPar_given_MEFFTATSTI,
   AdmsSensFadType & modelPar_MEFFTATGAT,
   bool modelPar_given_MEFFTATGAT,
   AdmsSensFadType & modelPar_CBBTBOT,
   bool modelPar_given_CBBTBOT,
   AdmsSensFadType & modelPar_CBBTSTI,
   bool modelPar_given_CBBTSTI,
   AdmsSensFadType & modelPar_CBBTGAT,
   bool modelPar_given_CBBTGAT,
   AdmsSensFadType & modelPar_FBBTRBOT,
   bool modelPar_given_FBBTRBOT,
   AdmsSensFadType & modelPar_FBBTRSTI,
   bool modelPar_given_FBBTRSTI,
   AdmsSensFadType & modelPar_FBBTRGAT,
   bool modelPar_given_FBBTRGAT,
   AdmsSensFadType & modelPar_STFBBTBOT,
   bool modelPar_given_STFBBTBOT,
   AdmsSensFadType & modelPar_STFBBTSTI,
   bool modelPar_given_STFBBTSTI,
   AdmsSensFadType & modelPar_STFBBTGAT,
   bool modelPar_given_STFBBTGAT,
   AdmsSensFadType & modelPar_VBRBOT,
   bool modelPar_given_VBRBOT,
   AdmsSensFadType & modelPar_VBRSTI,
   bool modelPar_given_VBRSTI,
   AdmsSensFadType & modelPar_VBRGAT,
   bool modelPar_given_VBRGAT,
   AdmsSensFadType & modelPar_PBRBOT,
   bool modelPar_given_PBRBOT,
   AdmsSensFadType & modelPar_PBRSTI,
   bool modelPar_given_PBRSTI,
   AdmsSensFadType & modelPar_PBRGAT,
   bool modelPar_given_PBRGAT,
   AdmsSensFadType & modelPar_CJORBOTD,
   bool modelPar_given_CJORBOTD,
   AdmsSensFadType & modelPar_CJORSTID,
   bool modelPar_given_CJORSTID,
   AdmsSensFadType & modelPar_CJORGATD,
   bool modelPar_given_CJORGATD,
   AdmsSensFadType & modelPar_VBIRBOTD,
   bool modelPar_given_VBIRBOTD,
   AdmsSensFadType & modelPar_VBIRSTID,
   bool modelPar_given_VBIRSTID,
   AdmsSensFadType & modelPar_VBIRGATD,
   bool modelPar_given_VBIRGATD,
   AdmsSensFadType & modelPar_PBOTD,
   bool modelPar_given_PBOTD,
   AdmsSensFadType & modelPar_PSTID,
   bool modelPar_given_PSTID,
   AdmsSensFadType & modelPar_PGATD,
   bool modelPar_given_PGATD,
   AdmsSensFadType & modelPar_PHIGBOTD,
   bool modelPar_given_PHIGBOTD,
   AdmsSensFadType & modelPar_PHIGSTID,
   bool modelPar_given_PHIGSTID,
   AdmsSensFadType & modelPar_PHIGGATD,
   bool modelPar_given_PHIGGATD,
   AdmsSensFadType & modelPar_IDSATRBOTD,
   bool modelPar_given_IDSATRBOTD,
   AdmsSensFadType & modelPar_IDSATRSTID,
   bool modelPar_given_IDSATRSTID,
   AdmsSensFadType & modelPar_IDSATRGATD,
   bool modelPar_given_IDSATRGATD,
   AdmsSensFadType & modelPar_CSRHBOTD,
   bool modelPar_given_CSRHBOTD,
   AdmsSensFadType & modelPar_CSRHSTID,
   bool modelPar_given_CSRHSTID,
   AdmsSensFadType & modelPar_CSRHGATD,
   bool modelPar_given_CSRHGATD,
   AdmsSensFadType & modelPar_XJUNSTID,
   bool modelPar_given_XJUNSTID,
   AdmsSensFadType & modelPar_XJUNGATD,
   bool modelPar_given_XJUNGATD,
   AdmsSensFadType & modelPar_CTATBOTD,
   bool modelPar_given_CTATBOTD,
   AdmsSensFadType & modelPar_CTATSTID,
   bool modelPar_given_CTATSTID,
   AdmsSensFadType & modelPar_CTATGATD,
   bool modelPar_given_CTATGATD,
   AdmsSensFadType & modelPar_MEFFTATBOTD,
   bool modelPar_given_MEFFTATBOTD,
   AdmsSensFadType & modelPar_MEFFTATSTID,
   bool modelPar_given_MEFFTATSTID,
   AdmsSensFadType & modelPar_MEFFTATGATD,
   bool modelPar_given_MEFFTATGATD,
   AdmsSensFadType & modelPar_CBBTBOTD,
   bool modelPar_given_CBBTBOTD,
   AdmsSensFadType & modelPar_CBBTSTID,
   bool modelPar_given_CBBTSTID,
   AdmsSensFadType & modelPar_CBBTGATD,
   bool modelPar_given_CBBTGATD,
   AdmsSensFadType & modelPar_FBBTRBOTD,
   bool modelPar_given_FBBTRBOTD,
   AdmsSensFadType & modelPar_FBBTRSTID,
   bool modelPar_given_FBBTRSTID,
   AdmsSensFadType & modelPar_FBBTRGATD,
   bool modelPar_given_FBBTRGATD,
   AdmsSensFadType & modelPar_STFBBTBOTD,
   bool modelPar_given_STFBBTBOTD,
   AdmsSensFadType & modelPar_STFBBTSTID,
   bool modelPar_given_STFBBTSTID,
   AdmsSensFadType & modelPar_STFBBTGATD,
   bool modelPar_given_STFBBTGATD,
   AdmsSensFadType & modelPar_VBRBOTD,
   bool modelPar_given_VBRBOTD,
   AdmsSensFadType & modelPar_VBRSTID,
   bool modelPar_given_VBRSTID,
   AdmsSensFadType & modelPar_VBRGATD,
   bool modelPar_given_VBRGATD,
   AdmsSensFadType & modelPar_PBRBOTD,
   bool modelPar_given_PBRBOTD,
   AdmsSensFadType & modelPar_PBRSTID,
   bool modelPar_given_PBRSTID,
   AdmsSensFadType & modelPar_PBRGATD,
   bool modelPar_given_PBRGATD,
   AdmsSensFadType & modelPar_SWJUNEXP,
   bool modelPar_given_SWJUNEXP,
   AdmsSensFadType & modelPar_VJUNREF,
   bool modelPar_given_VJUNREF,
   AdmsSensFadType & modelPar_FJUNQ,
   bool modelPar_given_FJUNQ,
   AdmsSensFadType & modelPar_VJUNREFD,
   bool modelPar_given_VJUNREFD,
   AdmsSensFadType & modelPar_FJUNQD,
   bool modelPar_given_FJUNQD,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   int modelPar_SWGEO,
   bool modelPar_given_SWGEO,
   int modelPar_SWIGATE,
   bool modelPar_given_SWIGATE,
   int modelPar_SWIMPACT,
   bool modelPar_given_SWIMPACT,
   int modelPar_SWGIDL,
   bool modelPar_given_SWGIDL,
   int modelPar_SWJUNCAP,
   bool modelPar_given_SWJUNCAP,
   int modelPar_SWJUNASYM,
   bool modelPar_given_SWJUNASYM,
   int modelPar_SWNUD,
   bool modelPar_given_SWNUD,
   int modelPar_SWEDGE,
   bool modelPar_given_SWEDGE,
   int modelPar_SWDELVTAC,
   bool modelPar_given_SWDELVTAC,
   int modelPar_SWIGN,
   bool modelPar_given_SWIGN// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_TOXO_i,
   AdmsSensFadType & modelVar_EPSROXO_i,
   AdmsSensFadType & modelVar_NSUBO_i,
   AdmsSensFadType & modelVar_WSEG_i,
   AdmsSensFadType & modelVar_NPCK_i,
   AdmsSensFadType & modelVar_WSEGP_i,
   AdmsSensFadType & modelVar_LPCK_i,
   AdmsSensFadType & modelVar_TOXOVO_i,
   AdmsSensFadType & modelVar_TOXOVDO_i,
   AdmsSensFadType & modelVar_LOV_i,
   AdmsSensFadType & modelVar_LOVD_i,
   AdmsSensFadType & modelVar_LP1_i,
   AdmsSensFadType & modelVar_LP2_i,
   AdmsSensFadType & modelVar_WBET_i,
   AdmsSensFadType & modelVar_AXL_i,
   AdmsSensFadType & modelVar_ALP1L2_i,
   AdmsSensFadType & modelVar_ALP2L2_i,
   AdmsSensFadType & modelVar_SAREF_i,
   AdmsSensFadType & modelVar_SBREF_i,
   AdmsSensFadType & modelVar_KVSAT_i,
   AdmsSensFadType & modelVar_LLODKUO_i,
   AdmsSensFadType & modelVar_WLODKUO_i,
   AdmsSensFadType & modelVar_LLODVTH_i,
   AdmsSensFadType & modelVar_WLODVTH_i,
   AdmsSensFadType & modelVar_LODETAO_i,
   AdmsSensFadType & modelVar_SCREF_i,
   AdmsSensFadType & modelVar_WEB_i,
   AdmsSensFadType & modelVar_WEC_i,
   AdmsSensFadType & modelVar_RSHG_i,
   AdmsSensFadType & modelVar_RSH_i,
   AdmsSensFadType & modelVar_RSHD_i,
   AdmsSensFadType & modelVar_RINT_i,
   AdmsSensFadType & modelVar_RVPOLY_i,
   AdmsSensFadType & modelVar_NSUBEDGEO_i,
   AdmsSensFadType & modelVar_LPEDGE_i,
   AdmsSensFadType & modelVar_QMC_i,
   AdmsSensFadType & modelVar_rTa,
   AdmsSensFadType & modelVar_delTa,
   AdmsSensFadType & modelVar_phita,
   AdmsSensFadType & modelVar_inv_phita,
   AdmsSensFadType & modelVar_TKD,
   AdmsSensFadType & modelVar_delT,
   AdmsSensFadType & modelVar_rTn,
   AdmsSensFadType & modelVar_ln_rTn,
   AdmsSensFadType & modelVar_inv_phit,
   AdmsSensFadType & modelVar_Eg,
   AdmsSensFadType & modelVar_phibFac,
   AdmsSensFadType & modelVar_IMAX_i,
   AdmsSensFadType & modelVar_VBIRBOT_i,
   AdmsSensFadType & modelVar_VBIRSTI_i,
   AdmsSensFadType & modelVar_VBIRGAT_i,
   AdmsSensFadType & modelVar_PBOT_i,
   AdmsSensFadType & modelVar_PSTI_i,
   AdmsSensFadType & modelVar_PGAT_i,
   AdmsSensFadType & modelVar_CSRHBOT_i,
   AdmsSensFadType & modelVar_CSRHSTI_i,
   AdmsSensFadType & modelVar_CSRHGAT_i,
   AdmsSensFadType & modelVar_CTATBOT_i,
   AdmsSensFadType & modelVar_CTATSTI_i,
   AdmsSensFadType & modelVar_CTATGAT_i,
   AdmsSensFadType & modelVar_CBBTBOT_i,
   AdmsSensFadType & modelVar_CBBTSTI_i,
   AdmsSensFadType & modelVar_CBBTGAT_i,
   AdmsSensFadType & modelVar_VBRBOT_i,
   AdmsSensFadType & modelVar_VBRSTI_i,
   AdmsSensFadType & modelVar_VBRGAT_i,
   AdmsSensFadType & modelVar_PBRBOT_i,
   AdmsSensFadType & modelVar_PBRSTI_i,
   AdmsSensFadType & modelVar_PBRGAT_i,
   AdmsSensFadType & modelVar_SWJUNEXP_i,
   AdmsSensFadType & modelVar_VJUNREF_i,
   AdmsSensFadType & modelVar_FJUNQ_i,
   AdmsSensFadType & modelVar_phitr,
   AdmsSensFadType & modelVar_phitd,
   AdmsSensFadType & modelVar_phitdinv,
   AdmsSensFadType & modelVar_perfc,
   AdmsSensFadType & modelVar_berfc,
   AdmsSensFadType & modelVar_cerfc,
   AdmsSensFadType & modelVar_ftdbot,
   AdmsSensFadType & modelVar_ftdsti,
   AdmsSensFadType & modelVar_ftdgat,
   AdmsSensFadType & modelVar_idsatbot,
   AdmsSensFadType & modelVar_idsatsti,
   AdmsSensFadType & modelVar_idsatgat,
   AdmsSensFadType & modelVar_vbibot,
   AdmsSensFadType & modelVar_vbisti,
   AdmsSensFadType & modelVar_vbigat,
   AdmsSensFadType & modelVar_vbiinvbot,
   AdmsSensFadType & modelVar_vbiinvsti,
   AdmsSensFadType & modelVar_vbiinvgat,
   AdmsSensFadType & modelVar_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_minus_PGAT,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT,
   AdmsSensFadType & modelVar_cjobot,
   AdmsSensFadType & modelVar_cjosti,
   AdmsSensFadType & modelVar_cjogat,
   AdmsSensFadType & modelVar_qprefbot,
   AdmsSensFadType & modelVar_qprefsti,
   AdmsSensFadType & modelVar_qprefgat,
   AdmsSensFadType & modelVar_qpref2bot,
   AdmsSensFadType & modelVar_qpref2sti,
   AdmsSensFadType & modelVar_qpref2gat,
   AdmsSensFadType & modelVar_wdepnulrbot,
   AdmsSensFadType & modelVar_wdepnulrsti,
   AdmsSensFadType & modelVar_wdepnulrgat,
   AdmsSensFadType & modelVar_wdepnulrinvbot,
   AdmsSensFadType & modelVar_wdepnulrinvsti,
   AdmsSensFadType & modelVar_wdepnulrinvgat,
   AdmsSensFadType & modelVar_VBIRBOTinv,
   AdmsSensFadType & modelVar_VBIRSTIinv,
   AdmsSensFadType & modelVar_VBIRGATinv,
   AdmsSensFadType & modelVar_atatbot,
   AdmsSensFadType & modelVar_atatsti,
   AdmsSensFadType & modelVar_atatgat,
   AdmsSensFadType & modelVar_btatpartbot,
   AdmsSensFadType & modelVar_btatpartsti,
   AdmsSensFadType & modelVar_btatpartgat,
   AdmsSensFadType & modelVar_fbbtbot,
   AdmsSensFadType & modelVar_fbbtsti,
   AdmsSensFadType & modelVar_fbbtgat,
   AdmsSensFadType & modelVar_alphaav,
   AdmsSensFadType & modelVar_fstopbot,
   AdmsSensFadType & modelVar_fstopsti,
   AdmsSensFadType & modelVar_fstopgat,
   AdmsSensFadType & modelVar_VBRinvbot,
   AdmsSensFadType & modelVar_VBRinvsti,
   AdmsSensFadType & modelVar_VBRinvgat,
   AdmsSensFadType & modelVar_slopebot,
   AdmsSensFadType & modelVar_slopesti,
   AdmsSensFadType & modelVar_slopegat,
   AdmsSensFadType & modelVar_VBIRBOTD_i,
   AdmsSensFadType & modelVar_VBIRSTID_i,
   AdmsSensFadType & modelVar_VBIRGATD_i,
   AdmsSensFadType & modelVar_PBOTD_i,
   AdmsSensFadType & modelVar_PSTID_i,
   AdmsSensFadType & modelVar_PGATD_i,
   AdmsSensFadType & modelVar_CSRHBOTD_i,
   AdmsSensFadType & modelVar_CSRHSTID_i,
   AdmsSensFadType & modelVar_CSRHGATD_i,
   AdmsSensFadType & modelVar_CTATBOTD_i,
   AdmsSensFadType & modelVar_CTATSTID_i,
   AdmsSensFadType & modelVar_CTATGATD_i,
   AdmsSensFadType & modelVar_CBBTBOTD_i,
   AdmsSensFadType & modelVar_CBBTSTID_i,
   AdmsSensFadType & modelVar_CBBTGATD_i,
   AdmsSensFadType & modelVar_VBRBOTD_i,
   AdmsSensFadType & modelVar_VBRSTID_i,
   AdmsSensFadType & modelVar_VBRGATD_i,
   AdmsSensFadType & modelVar_PBRBOTD_i,
   AdmsSensFadType & modelVar_PBRSTID_i,
   AdmsSensFadType & modelVar_PBRGATD_i,
   AdmsSensFadType & modelVar_VJUNREFD_i,
   AdmsSensFadType & modelVar_FJUNQD_i,
   AdmsSensFadType & modelVar_ftdbot_d,
   AdmsSensFadType & modelVar_ftdsti_d,
   AdmsSensFadType & modelVar_ftdgat_d,
   AdmsSensFadType & modelVar_idsatbot_d,
   AdmsSensFadType & modelVar_idsatsti_d,
   AdmsSensFadType & modelVar_idsatgat_d,
   AdmsSensFadType & modelVar_vbibot_d,
   AdmsSensFadType & modelVar_vbisti_d,
   AdmsSensFadType & modelVar_vbigat_d,
   AdmsSensFadType & modelVar_vbiinvbot_d,
   AdmsSensFadType & modelVar_vbiinvsti_d,
   AdmsSensFadType & modelVar_vbiinvgat_d,
   AdmsSensFadType & modelVar_one_minus_PBOT_d,
   AdmsSensFadType & modelVar_one_minus_PSTI_d,
   AdmsSensFadType & modelVar_one_minus_PGAT_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT_d,
   AdmsSensFadType & modelVar_cjobot_d,
   AdmsSensFadType & modelVar_cjosti_d,
   AdmsSensFadType & modelVar_cjogat_d,
   AdmsSensFadType & modelVar_qprefbot_d,
   AdmsSensFadType & modelVar_qprefsti_d,
   AdmsSensFadType & modelVar_qprefgat_d,
   AdmsSensFadType & modelVar_qpref2bot_d,
   AdmsSensFadType & modelVar_qpref2sti_d,
   AdmsSensFadType & modelVar_qpref2gat_d,
   AdmsSensFadType & modelVar_wdepnulrbot_d,
   AdmsSensFadType & modelVar_wdepnulrsti_d,
   AdmsSensFadType & modelVar_wdepnulrgat_d,
   AdmsSensFadType & modelVar_wdepnulrinvbot_d,
   AdmsSensFadType & modelVar_wdepnulrinvsti_d,
   AdmsSensFadType & modelVar_wdepnulrinvgat_d,
   AdmsSensFadType & modelVar_VBIRBOTinv_d,
   AdmsSensFadType & modelVar_VBIRSTIinv_d,
   AdmsSensFadType & modelVar_VBIRGATinv_d,
   AdmsSensFadType & modelVar_atatbot_d,
   AdmsSensFadType & modelVar_atatsti_d,
   AdmsSensFadType & modelVar_atatgat_d,
   AdmsSensFadType & modelVar_btatpartbot_d,
   AdmsSensFadType & modelVar_btatpartsti_d,
   AdmsSensFadType & modelVar_btatpartgat_d,
   AdmsSensFadType & modelVar_fbbtbot_d,
   AdmsSensFadType & modelVar_fbbtsti_d,
   AdmsSensFadType & modelVar_fbbtgat_d,
   AdmsSensFadType & modelVar_fstopbot_d,
   AdmsSensFadType & modelVar_fstopsti_d,
   AdmsSensFadType & modelVar_fstopgat_d,
   AdmsSensFadType & modelVar_VBRinvbot_d,
   AdmsSensFadType & modelVar_VBRinvsti_d,
   AdmsSensFadType & modelVar_VBRinvgat_d,
   AdmsSensFadType & modelVar_slopebot_d,
   AdmsSensFadType & modelVar_slopesti_d,
   AdmsSensFadType & modelVar_slopegat_d,
   AdmsSensFadType & modelVar_phit,
   AdmsSensFadType & modelVar_nt0,
   AdmsSensFadType & modelVar_EPSSI,
   // non-reals
   int modelVar_CHNL_TYPE,
   int modelVar_SWGEO_i,
   int modelVar_SWIGATE_i,
   int modelVar_SWIMPACT_i,
   int modelVar_SWGIDL_i,
   int modelVar_SWJUNCAP_i,
   int modelVar_SWJUNASYM_i,
   int modelVar_SWNUD_i,
   int modelVar_SWEDGE_i,
   int modelVar_SWDELVTAC_i,
   int modelVar_SWIGN_i,
   double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
  AdmsSensFadType I5;
  AdmsSensFadType I4;
  AdmsSensFadType I3;
  AdmsSensFadType I2;
  AdmsSensFadType I1;
  AdmsSensFadType ijungat;
  AdmsSensFadType ijunsti;
  AdmsSensFadType ijunbot;
  double V5;
  double V4;
  AdmsSensFadType V3;
  AdmsSensFadType V2;
  AdmsSensFadType V1;
  double FRACI;
  double FRACNB;
  double FRACNA;
  AdmsSensFadType qjungat;
  AdmsSensFadType qjunsti;
  AdmsSensFadType qjunbot;
  AdmsSensFadType fbreakdown;
  AdmsSensFadType Fmaxr;
  AdmsSensFadType ibbt;
  AdmsSensFadType gammamax;
  AdmsSensFadType erfctimesexpmtat;
  AdmsSensFadType xerfc;
  AdmsSensFadType mtat;
  AdmsSensFadType ltat;
  AdmsSensFadType ktat;
  AdmsSensFadType wtat;
  AdmsSensFadType wgamma;
  AdmsSensFadType umaxpoweronepointfive;
  AdmsSensFadType sqrtumax;
  AdmsSensFadType umax;
  AdmsSensFadType umaxbeforelimiting;
  AdmsSensFadType twoatatoverthreebtat;
  AdmsSensFadType btat;
  AdmsSensFadType itat;
  AdmsSensFadType asrh;
  AdmsSensFadType wdep;
  AdmsSensFadType wsrh;
  AdmsSensFadType dwsrh;
  AdmsSensFadType wsrhstep;
  AdmsSensFadType vbi_minus_vjsrh;
  AdmsSensFadType isrh;
  AdmsSensFadType id;
  AdmsSensFadType tmp;
  AdmsSensFadType vav;
  AdmsSensFadType vbbt;
  AdmsSensFadType vjsrh;
  AdmsSensFadType vjlim;
  AdmsSensFadType two_psistar;
  AdmsSensFadType zinv;
  AdmsSensFadType z;
  AdmsSensFadType vj;
  AdmsSensFadType idmult;
  AdmsSensFadType h5;
  AdmsSensFadType h4;
  AdmsSensFadType h3;
  AdmsSensFadType h2d;
  AdmsSensFadType h2;
  AdmsSensFadType h1;
  AdmsSensFadType erfcpos;
  AdmsSensFadType terfc;
  AdmsSensFadType ysq;
  AdmsSensFadType pmax;
  AdmsSensFadType vbigat2r;
  AdmsSensFadType vbisti2r;
  AdmsSensFadType vbibot2r;
  AdmsSensFadType pgat2;
  AdmsSensFadType psti2;
  AdmsSensFadType pbot2;
  AdmsSensFadType vbigat2;
  AdmsSensFadType vbisti2;
  AdmsSensFadType vbibot2;
  AdmsSensFadType vmaxgat;
  AdmsSensFadType vmaxsti;
  AdmsSensFadType vmaxbot;
  AdmsSensFadType alphaje;
  AdmsSensFadType zfrac;
  AdmsSensFadType tt2;
  AdmsSensFadType tt1;
  AdmsSensFadType tt0;
  AdmsSensFadType I5_cor;
  AdmsSensFadType I4_cor;
  AdmsSensFadType I3_cor;
  AdmsSensFadType I2_cor;
  AdmsSensFadType I1_cor;
  AdmsSensFadType mcor_rev;
  AdmsSensFadType m0_rev;
  AdmsSensFadType jww;
  double jwcorr;
  AdmsSensFadType LGD_i;
  AdmsSensFadType LSD_i;
  AdmsSensFadType ABD_i;
  AdmsSensFadType LGS_i;
  AdmsSensFadType LSS_i;
  AdmsSensFadType ABS_i;
  AdmsSensFadType BGIDLD_T;
  AdmsSensFadType BGIDL_T;
  AdmsSensFadType tf_ig;
  AdmsSensFadType B_fact;
  AdmsSensFadType phix2edge;
  AdmsSensFadType BETNEDGE_T;
  AdmsSensFadType tf_betedge;
  AdmsSensFadType tf_thesat;
  AdmsSensFadType RS_T;
  AdmsSensFadType tf_ther;
  AdmsSensFadType tf_xcor;
  AdmsSensFadType tf_cs;
  AdmsSensFadType tf_mue;
  AdmsSensFadType BETN_T;
  AdmsSensFadType tf_bet;
  AdmsSensFadType phix2;
  AdmsSensFadType dphibq;
  AdmsSensFadType qb0;
  AdmsSensFadType arg2max;
  AdmsSensFadType np;
  AdmsSensFadType SP_OV_delta;
  AdmsSensFadType SP_OV_eps;
  AdmsSensFadType inv_GOV;
  AdmsSensFadType CoxovPrime_d;
  AdmsSensFadType CoxovPrime;
  AdmsSensFadType NEFFAC_i;
  AdmsSensFadType tox_sq;
  AdmsSensFadType CoxPrime;
  AdmsSensFadType EPSOX;
  AdmsSensFadType DELVTOEDGE_i;
  AdmsSensFadType FACTUOEDGE_i;
  AdmsSensFadType DELVTO_i;
  AdmsSensFadType FACTUO_i;
  AdmsSensFadType FNTEDGE_i;
  AdmsSensFadType STBETEDGE_i;
  AdmsSensFadType CTEDGE_i;
  AdmsSensFadType NEFFEDGE_i;
  AdmsSensFadType DPHIBEDGE_i;
  AdmsSensFadType STVFBEDGE_i;
  AdmsSensFadType VFBEDGE_i;
  AdmsSensFadType FNT_i;
  AdmsSensFadType STBGIDLD_i;
  AdmsSensFadType STBGIDL_i;
  AdmsSensFadType BGIDLD_i;
  AdmsSensFadType BGIDL_i;
  AdmsSensFadType STIG_i;
  AdmsSensFadType STA2_i;
  AdmsSensFadType A2_i;
  AdmsSensFadType VP_i;
  AdmsSensFadType STTHESAT_i;
  AdmsSensFadType THESAT_i;
  AdmsSensFadType STRS_i;
  AdmsSensFadType RS_i;
  AdmsSensFadType FETA_i;
  AdmsSensFadType STXCOR_i;
  AdmsSensFadType XCOR_i;
  AdmsSensFadType STCS_i;
  AdmsSensFadType CS_i;
  AdmsSensFadType STTHEMU_i;
  AdmsSensFadType THEMU_i;
  AdmsSensFadType STMUE_i;
  AdmsSensFadType MUE_i;
  AdmsSensFadType STBET_i;
  AdmsSensFadType BETN_i;
  AdmsSensFadType NOVD_i;
  AdmsSensFadType NOV_i;
  AdmsSensFadType TOXOVD_i;
  AdmsSensFadType TOXOV_i;
  AdmsSensFadType CT_i;
  AdmsSensFadType NP_i;
  AdmsSensFadType DELVTAC_i;
  AdmsSensFadType DPHIB_i;
  AdmsSensFadType DVSBNUD_i;
  AdmsSensFadType VSBNUD_i;
  AdmsSensFadType FACNEFFAC_i;
  AdmsSensFadType NEFF_i;
  AdmsSensFadType EPSROX_i;
  AdmsSensFadType TOX_i;
  AdmsSensFadType STVFB_i;
  AdmsSensFadType VFB_i;
  AdmsSensFadType temp00;
  AdmsSensFadType Kstressvth0;
  AdmsSensFadType rhobetaref;
  AdmsSensFadType rhobeta;
  AdmsSensFadType Kstressu0;
  AdmsSensFadType tempw;
  AdmsSensFadType templ;
  AdmsSensFadType Wx;
  AdmsSensFadType Lx;
  AdmsSensFadType Invsbref;
  AdmsSensFadType Invsaref;
  AdmsSensFadType Invsb;
  AdmsSensFadType Invsa;
  double loop;
  AdmsSensFadType tmpb;
  AdmsSensFadType tmpa;
  AdmsSensFadType iiiLWcv;
  AdmsSensFadType iLcv;
  AdmsSensFadType iiLWcv;
  AdmsSensFadType iiWcv;
  AdmsSensFadType iiLcv;
  AdmsSensFadType iiiLEWEcv;
  AdmsSensFadType iLEcv;
  AdmsSensFadType iiLEWEcv;
  AdmsSensFadType iiWEcv;
  AdmsSensFadType iiLEcv;
  AdmsSensFadType iiiLEWE;
  AdmsSensFadType iiLEWE;
  AdmsSensFadType iiWE;
  AdmsSensFadType iiLE;
  AdmsSensFadType iLEWE;
  AdmsSensFadType KUOWE;
  AdmsSensFadType KVTHOWE;
  AdmsSensFadType GPE_edge;
  AdmsSensFadType iWE_edge;
  AdmsSensFadType WE_edge;
  AdmsSensFadType Lred;
  AdmsSensFadType Lnoi;
  AdmsSensFadType temp0;
  AdmsSensFadType tmpx;
  AdmsSensFadType GWE;
  AdmsSensFadType GPE;
  AdmsSensFadType LP1e;
  AdmsSensFadType FBET1e;
  AdmsSensFadType NSUB;
  AdmsSensFadType BB;
  double AA;
  AdmsSensFadType LPCKe;
  AdmsSensFadType NPCKe;
  AdmsSensFadType NSUB0e;
  AdmsSensFadType RJUND_p;
  AdmsSensFadType RJUNS_p;
  AdmsSensFadType RBULK_p;
  AdmsSensFadType RWELL_p;
  AdmsSensFadType RDE_p;
  AdmsSensFadType RSE_p;
  AdmsSensFadType RG_p;
  AdmsSensFadType EFEDGE_p;
  AdmsSensFadType NFCEDGE_p;
  AdmsSensFadType NFBEDGE_p;
  AdmsSensFadType NFAEDGE_p;
  AdmsSensFadType FNTEDGE_p;
  AdmsSensFadType CFBEDGE_p;
  AdmsSensFadType CFDEDGE_p;
  AdmsSensFadType CFEDGE_p;
  AdmsSensFadType PSCEDEDGE_p;
  AdmsSensFadType PSCEBEDGE_p;
  AdmsSensFadType PSCEEDGE_p;
  AdmsSensFadType STBETEDGE_p;
  AdmsSensFadType BETNEDGE_p;
  AdmsSensFadType CTEDGE_p;
  AdmsSensFadType NEFFEDGE_p;
  AdmsSensFadType DPHIBEDGE_p;
  AdmsSensFadType STVFBEDGE_p;
  AdmsSensFadType VFBEDGE_p;
  AdmsSensFadType EF_p;
  AdmsSensFadType NFC_p;
  AdmsSensFadType NFB_p;
  AdmsSensFadType NFA_p;
  AdmsSensFadType FNTEXC_p;
  AdmsSensFadType FNT_p;
  AdmsSensFadType CFRD_p;
  AdmsSensFadType CFR_p;
  AdmsSensFadType CGBOV_p;
  AdmsSensFadType CGOVD_p;
  AdmsSensFadType CGOV_p;
  AdmsSensFadType COX_p;
  AdmsSensFadType CGIDLD_p;
  AdmsSensFadType CGIDL_p;
  AdmsSensFadType STBGIDLD_p;
  AdmsSensFadType STBGIDL_p;
  AdmsSensFadType BGIDLD_p;
  AdmsSensFadType BGIDL_p;
  AdmsSensFadType AGIDLD_p;
  AdmsSensFadType AGIDL_p;
  AdmsSensFadType CHIB_p;
  AdmsSensFadType GC3_p;
  AdmsSensFadType GC2_p;
  AdmsSensFadType STIG_p;
  AdmsSensFadType IGOVD_p;
  AdmsSensFadType IGOV_p;
  AdmsSensFadType IGINV_p;
  AdmsSensFadType GCO_p;
  AdmsSensFadType A4_p;
  AdmsSensFadType A3_p;
  AdmsSensFadType STA2_p;
  AdmsSensFadType A2_p;
  AdmsSensFadType A1_p;
  AdmsSensFadType VP_p;
  AdmsSensFadType ALP2_p;
  AdmsSensFadType ALP1_p;
  AdmsSensFadType ALP_p;
  AdmsSensFadType AX_p;
  AdmsSensFadType THESATG_p;
  AdmsSensFadType THESATB_p;
  AdmsSensFadType STTHESAT_p;
  AdmsSensFadType THESAT_p;
  AdmsSensFadType RSG_p;
  AdmsSensFadType RSB_p;
  AdmsSensFadType STRS_p;
  AdmsSensFadType RS_p;
  AdmsSensFadType FETA_p;
  AdmsSensFadType STXCOR_p;
  AdmsSensFadType XCOR_p;
  AdmsSensFadType STCS_p;
  AdmsSensFadType CS_p;
  AdmsSensFadType STTHEMU_p;
  AdmsSensFadType THEMU_p;
  AdmsSensFadType STMUE_p;
  AdmsSensFadType MUE_p;
  AdmsSensFadType STBET_p;
  AdmsSensFadType BETN_p;
  AdmsSensFadType CFB_p;
  AdmsSensFadType CFD_p;
  AdmsSensFadType CF_p;
  AdmsSensFadType PSCEB_p;
  AdmsSensFadType PSCED_p;
  AdmsSensFadType PSCE_p;
  AdmsSensFadType NOVD_p;
  AdmsSensFadType NOV_p;
  AdmsSensFadType TOXOVD_p;
  AdmsSensFadType TOXOV_p;
  AdmsSensFadType CT_p;
  AdmsSensFadType NP_p;
  AdmsSensFadType DELVTAC_p;
  AdmsSensFadType DPHIB_p;
  AdmsSensFadType DNSUB_p;
  AdmsSensFadType NSLP_p;
  AdmsSensFadType VNSUB_p;
  AdmsSensFadType DVSBNUD_p;
  AdmsSensFadType VSBNUD_p;
  AdmsSensFadType GFACNUD_p;
  AdmsSensFadType FACNEFFAC_p;
  AdmsSensFadType NEFF_p;
  AdmsSensFadType EPSROX_p;
  AdmsSensFadType TOX_p;
  AdmsSensFadType STVFB_p;
  AdmsSensFadType VFB_p;
  AdmsSensFadType XGWE;
  AdmsSensFadType W_f;
  AdmsSensFadType L_slif;
  AdmsSensFadType L_f;
  AdmsSensFadType iWE;
  AdmsSensFadType iLE;
  AdmsSensFadType Wcv;
  AdmsSensFadType Lcv;
  AdmsSensFadType WEcv;
  AdmsSensFadType LEcv;
  AdmsSensFadType delWOD;
  AdmsSensFadType delLPS;
  AdmsSensFadType iW;
  AdmsSensFadType iL;
  AdmsSensFadType NGCON_i;
  AdmsSensFadType SCC_i;
  AdmsSensFadType SCB_i;
  AdmsSensFadType SCA_i;
  AdmsSensFadType JW_i;
  AdmsSensFadType PD_i;
  AdmsSensFadType AD_i;
  AdmsSensFadType PS_i;
  AdmsSensFadType AS_i;
  AdmsSensFadType XGW_i;
  AdmsSensFadType SC_i;
  AdmsSensFadType SD_i;
  AdmsSensFadType SB_i;
  AdmsSensFadType SA_i;
  AdmsSensFadType W_i;
  AdmsSensFadType L_i;
  AdmsSensFadType WE;
  AdmsSensFadType LE;
  AdmsSensFadType invNF;
  AdmsSensFadType NF_i;
  //Begin block initial_instance
  {
    //Block-local variables for block initial_instance
    AdmsSensFadType Invsa;
    AdmsSensFadType Invsb;
    AdmsSensFadType Invsaref;
    AdmsSensFadType Invsbref;
    AdmsSensFadType Kstressu0;
    AdmsSensFadType rhobeta;
    AdmsSensFadType rhobetaref;
    AdmsSensFadType Kstressvth0;
    //End of Block-local variables
    //Block-local variables for block initial_instance
    AdmsSensFadType temp0;
    AdmsSensFadType temp00;
    AdmsSensFadType templ;
    AdmsSensFadType tempw;
    AdmsSensFadType Lx;
    AdmsSensFadType Wx;
    double loop;
    AdmsSensFadType tmpa;
    AdmsSensFadType tmpb;
    //End of Block-local variables
    NF_i = 1.0;
    invNF = 1.0;
    LE = 0.0;
    WE = 0.0;
    L_i = instancePar_L;
    W_i = instancePar_W;
    SA_i = instancePar_SA;
    SB_i = instancePar_SB;
    SD_i = instancePar_SD;
    SC_i = instancePar_SC;
    XGW_i = instancePar_XGW;
    instanceVar_ABSOURCE_i = instancePar_ABSOURCE;
    instanceVar_LSSOURCE_i = instancePar_LSSOURCE;
    instanceVar_LGSOURCE_i = instancePar_LGSOURCE;
    instanceVar_ABDRAIN_i = instancePar_ABDRAIN;
    instanceVar_LSDRAIN_i = instancePar_LSDRAIN;
    instanceVar_LGDRAIN_i = instancePar_LGDRAIN;
    AS_i = instancePar_AS;
    PS_i = instancePar_PS;
    AD_i = instancePar_AD;
    PD_i = instancePar_PD;
    JW_i = instancePar_JW;
    if (((modelVar_SWGEO_i==1)||(modelVar_SWGEO_i==2)))
    {
      NF_i = adms_ternary_op<AdmsSensFadType>((instancePar_NF>1.0),instancePar_NF,1.0);
      {
        AdmsSensFadType value_floor_0 = ADMSfloor((NF_i+0.5));
        NF_i = ADMSfloor((NF_i+0.5));
      }
      invNF = (1.0/NF_i);
    }
    L_i = adms_ternary_op<AdmsSensFadType>((L_i>1.0e-9),L_i,1.0e-9);
    W_i = adms_ternary_op<AdmsSensFadType>(((W_i*invNF)>1.0e-9),(W_i*invNF),1.0e-9);
    SCA_i = adms_ternary_op<AdmsSensFadType>((instancePar_SCA>0.0),instancePar_SCA,0.0);
    SCB_i = adms_ternary_op<AdmsSensFadType>((instancePar_SCB>0.0),instancePar_SCB,0.0);
    SCC_i = adms_ternary_op<AdmsSensFadType>((instancePar_SCC>0.0),instancePar_SCC,0.0);
    NGCON_i = ((instancePar_NGCON<1.5)?1.0:2.0);
    iL = (1.0e-6/L_i);
    iW = (1.0e-6/W_i);
    delLPS = ((modelPar_LVARO*(1.0+(modelPar_LVARL*iL)))*(1.0+(modelPar_LVARW*iW)));
    delWOD = ((modelPar_WVARO*(1.0+(modelPar_WVARL*iL)))*(1.0+(modelPar_WVARW*iW)));
    if ((modelVar_SWGEO_i==2))
    {
      delLPS = (modelPar_LVARO*(1.0+(modelPar_LVARL*iL)));
      delWOD = (modelPar_WVARO*(1.0+(modelPar_WVARW*iW)));
    }
    LE = adms_ternary_op<AdmsSensFadType>((((L_i+delLPS)-(2.0*modelPar_LAP))>1.0e-9),((L_i+delLPS)-(2.0*modelPar_LAP)),1.0e-9);
    WE = adms_ternary_op<AdmsSensFadType>((((W_i+delWOD)-(2.0*modelPar_WOT))>1.0e-9),((W_i+delWOD)-(2.0*modelPar_WOT)),1.0e-9);
    LEcv = adms_ternary_op<AdmsSensFadType>(((((L_i+delLPS)-(2.0*modelPar_LAP))+modelPar_DLQ)>1.0e-9),(((L_i+delLPS)-(2.0*modelPar_LAP))+modelPar_DLQ),1.0e-9);
    WEcv = adms_ternary_op<AdmsSensFadType>(((((W_i+delWOD)-(2.0*modelPar_WOT))+modelPar_DWQ)>1.0e-9),(((W_i+delWOD)-(2.0*modelPar_WOT))+modelPar_DWQ),1.0e-9);
    Lcv = adms_ternary_op<AdmsSensFadType>((((L_i+delLPS)+modelPar_DLQ)>1.0e-9),((L_i+delLPS)+modelPar_DLQ),1.0e-9);
    Wcv = adms_ternary_op<AdmsSensFadType>((((W_i+delWOD)+modelPar_DWQ)>1.0e-9),((W_i+delWOD)+modelPar_DWQ),1.0e-9);
    iLE = (1.0e-6/LE);
    iWE = (1.0e-6/WE);
    L_f = adms_ternary_op<AdmsSensFadType>(((L_i+delLPS)>1.0e-9),(L_i+delLPS),1.0e-9);
    L_slif = adms_ternary_op<AdmsSensFadType>(((L_f+modelPar_DLSIL)>1.0e-9),(L_f+modelPar_DLSIL),1.0e-9);
    W_f = adms_ternary_op<AdmsSensFadType>(((W_i+delWOD)>1.0e-9),(W_i+delWOD),1.0e-9);
    XGWE = adms_ternary_op<AdmsSensFadType>(((XGW_i-(0.5*delWOD))>1.0e-9),(XGW_i-(0.5*delWOD)),1.0e-9);
    VFB_p = modelPar_VFB;
    STVFB_p = modelPar_STVFB;
    TOX_p = modelPar_TOX;
    EPSROX_p = modelPar_EPSROX;
    NEFF_p = modelPar_NEFF;
    FACNEFFAC_p = modelPar_FACNEFFAC;
    GFACNUD_p = modelPar_GFACNUD;
    VSBNUD_p = modelPar_VSBNUD;
    DVSBNUD_p = modelPar_DVSBNUD;
    VNSUB_p = modelPar_VNSUB;
    NSLP_p = modelPar_NSLP;
    DNSUB_p = modelPar_DNSUB;
    DPHIB_p = modelPar_DPHIB;
    DELVTAC_p = modelPar_DELVTAC;
    NP_p = modelPar_NP;
    CT_p = modelPar_CT;
    TOXOV_p = modelPar_TOXOV;
    TOXOVD_p = modelPar_TOXOVD;
    NOV_p = modelPar_NOV;
    NOVD_p = modelPar_NOVD;
    PSCE_p = modelPar_PSCE;
    PSCED_p = modelPar_PSCED;
    PSCEB_p = modelPar_PSCEB;
    CF_p = modelPar_CF;
    CFD_p = modelPar_CFD;
    CFB_p = modelPar_CFB;
    BETN_p = modelPar_BETN;
    STBET_p = modelPar_STBET;
    MUE_p = modelPar_MUE;
    STMUE_p = modelPar_STMUE;
    THEMU_p = modelPar_THEMU;
    STTHEMU_p = modelPar_STTHEMU;
    CS_p = modelPar_CS;
    STCS_p = modelPar_STCS;
    XCOR_p = modelPar_XCOR;
    STXCOR_p = modelPar_STXCOR;
    FETA_p = modelPar_FETA;
    RS_p = modelPar_RS;
    STRS_p = modelPar_STRS;
    RSB_p = modelPar_RSB;
    RSG_p = modelPar_RSG;
    THESAT_p = modelPar_THESAT;
    STTHESAT_p = modelPar_STTHESAT;
    THESATB_p = modelPar_THESATB;
    THESATG_p = modelPar_THESATG;
    AX_p = modelPar_AX;
    ALP_p = modelPar_ALP;
    ALP1_p = modelPar_ALP1;
    ALP2_p = modelPar_ALP2;
    VP_p = modelPar_VP;
    A1_p = modelPar_A1;
    A2_p = modelPar_A2;
    STA2_p = modelPar_STA2;
    A3_p = modelPar_A3;
    A4_p = modelPar_A4;
    GCO_p = modelPar_GCO;
    IGINV_p = modelPar_IGINV;
    IGOV_p = modelPar_IGOV;
    IGOVD_p = modelPar_IGOVD;
    STIG_p = modelPar_STIG;
    GC2_p = modelPar_GC2;
    GC3_p = modelPar_GC3;
    CHIB_p = modelPar_CHIB;
    AGIDL_p = modelPar_AGIDL;
    AGIDLD_p = modelPar_AGIDLD;
    BGIDL_p = modelPar_BGIDL;
    BGIDLD_p = modelPar_BGIDLD;
    STBGIDL_p = modelPar_STBGIDL;
    STBGIDLD_p = modelPar_STBGIDLD;
    CGIDL_p = modelPar_CGIDL;
    CGIDLD_p = modelPar_CGIDLD;
    COX_p = modelPar_COX;
    CGOV_p = modelPar_CGOV;
    CGOVD_p = modelPar_CGOVD;
    CGBOV_p = modelPar_CGBOV;
    CFR_p = modelPar_CFR;
    CFRD_p = modelPar_CFRD;
    FNT_p = modelPar_FNT;
    FNTEXC_p = modelPar_FNTEXC;
    NFA_p = modelPar_NFA;
    NFB_p = modelPar_NFB;
    NFC_p = modelPar_NFC;
    EF_p = modelPar_EF;
    VFBEDGE_p = modelPar_VFBEDGE;
    STVFBEDGE_p = modelPar_STVFBEDGE;
    DPHIBEDGE_p = modelPar_DPHIBEDGE;
    NEFFEDGE_p = modelPar_NEFFEDGE;
    CTEDGE_p = modelPar_CTEDGE;
    BETNEDGE_p = modelPar_BETNEDGE;
    STBETEDGE_p = modelPar_STBETEDGE;
    PSCEEDGE_p = modelPar_PSCEEDGE;
    PSCEBEDGE_p = modelPar_PSCEBEDGE;
    PSCEDEDGE_p = modelPar_PSCEDEDGE;
    CFEDGE_p = modelPar_CFEDGE;
    CFDEDGE_p = modelPar_CFDEDGE;
    CFBEDGE_p = modelPar_CFBEDGE;
    FNTEDGE_p = modelPar_FNTEDGE;
    NFAEDGE_p = modelPar_NFAEDGE;
    NFBEDGE_p = modelPar_NFBEDGE;
    NFCEDGE_p = modelPar_NFCEDGE;
    EFEDGE_p = modelPar_EFEDGE;
    RG_p = modelPar_RG;
    RSE_p = modelPar_RSE;
    RDE_p = modelPar_RDE;
    RWELL_p = modelPar_RWELL;
    RBULK_p = modelPar_RBULK;
    RJUNS_p = modelPar_RJUNS;
    RJUND_p = modelPar_RJUND;
    if ((modelVar_SWGEO_i==1))
    {
      VFB_p = (((modelPar_VFBO+(modelPar_VFBL*iLE))+(modelPar_VFBW*iWE))+((modelPar_VFBLW*iLE)*iWE));
      STVFB_p = (((modelPar_STVFBO+(modelPar_STVFBL*iLE))+(modelPar_STVFBW*iWE))+((modelPar_STVFBLW*iLE)*iWE));
      TOX_p = modelPar_TOXO;
      EPSROX_p = modelPar_EPSROXO;
      {
        AdmsSensFadType value_log_0 = log((1.0+(WE/modelVar_WSEG_i)));
        AdmsSensFadType value_log_1 = log((1.0+(WE/modelVar_WSEG_i)));
        NSUB0e = (modelVar_NSUBO_i*adms_ternary_op<AdmsSensFadType>(((1.0+((modelPar_NSUBW*iWE)*value_log_0))>1.0e-03),(1.0+((modelPar_NSUBW*iWE)*value_log_1)),1.0e-03));
      }
      {
        AdmsSensFadType value_log_0 = log((1.0+(WE/modelVar_WSEGP_i)));
        AdmsSensFadType value_log_1 = log((1.0+(WE/modelVar_WSEGP_i)));
        NPCKe = (modelVar_NPCK_i*adms_ternary_op<AdmsSensFadType>(((1.0+((modelPar_NPCKW*iWE)*value_log_0))>1.0e-03),(1.0+((modelPar_NPCKW*iWE)*value_log_1)),1.0e-03));
      }
      {
        AdmsSensFadType value_log_0 = log((1.0+(WE/modelVar_WSEGP_i)));
        AdmsSensFadType value_log_1 = log((1.0+(WE/modelVar_WSEGP_i)));
        LPCKe = (modelVar_LPCK_i*adms_ternary_op<AdmsSensFadType>(((1.0+((modelPar_LPCKW*iWE)*value_log_0))>1.0e-03),(1.0+((modelPar_LPCKW*iWE)*value_log_1)),1.0e-03));
      }
      if ((LE>(2.0*LPCKe)))
      {
        AA = 7.5e10;
        {
          AdmsSensFadType value_sqrt_0 = sqrt((NSUB0e+(0.5*NPCKe)));
          AdmsSensFadType value_sqrt_1 = sqrt(NSUB0e);
          BB = (value_sqrt_0-value_sqrt_1);
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt(NSUB0e);
          AdmsSensFadType value_exp_1 = exp((BB/AA));
          AdmsSensFadType value_log_2 = log((1.0+(((2.0*LPCKe)/LE)*(value_exp_1-1.0))));
          NSUB = (value_sqrt_0+(AA*value_log_2));
        }
        NSUB = (NSUB*NSUB);
      }
      else
      {
        if ((LE>=LPCKe))
        {
          NSUB = (NSUB0e+((NPCKe*LPCKe)/LE));
        }
        else
        {
          NSUB = (NSUB0e+(NPCKe*(2.0-(LE/LPCKe))));
        }
      }
      NEFF_p = (NSUB*((1.0-(modelPar_FOL1*iLE))-((modelPar_FOL2*iLE)*iLE)));
      FACNEFFAC_p = (((modelPar_FACNEFFACO+(modelPar_FACNEFFACL*iLE))+(modelPar_FACNEFFACW*iWE))+((modelPar_FACNEFFACLW*iLE)*iWE));
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_GFACNUDLEXP);
        GFACNUD_p = (((modelPar_GFACNUDO+(modelPar_GFACNUDL*value_pow_0))+(modelPar_GFACNUDW*iWE))+((modelPar_GFACNUDLW*iLE)*iWE));
      }
      VSBNUD_p = modelPar_VSBNUDO;
      DVSBNUD_p = modelPar_DVSBNUDO;
      VNSUB_p = modelPar_VNSUBO;
      NSLP_p = modelPar_NSLPO;
      DNSUB_p = modelPar_DNSUBO;
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_DPHIBLEXP);
        DPHIB_p = (((modelPar_DPHIBO+(modelPar_DPHIBL*value_pow_0))+(modelPar_DPHIBW*iWE))+((modelPar_DPHIBLW*iLE)*iWE));
      }
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_DELVTACLEXP);
        DELVTAC_p = (((modelPar_DELVTACO+(modelPar_DELVTACL*value_pow_0))+(modelPar_DELVTACW*iWE))+((modelPar_DELVTACLW*iLE)*iWE));
      }
      NP_p = (modelPar_NPO*adms_ternary_op<AdmsSensFadType>((1.0e-6>(1.0+(modelPar_NPL*iLE))),1.0e-6,(1.0+(modelPar_NPL*iLE))));
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_CTLEXP);
        CT_p = (((modelPar_CTO+(modelPar_CTL*value_pow_0))*(1.0+(modelPar_CTW*iWE)))*(1.0+((modelPar_CTLW*iLE)*iWE)));
      }
      TOXOV_p = modelPar_TOXOVO;
      TOXOVD_p = modelPar_TOXOVDO;
      NOV_p = modelPar_NOVO;
      NOVD_p = modelPar_NOVDO;
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_CFLEXP);
        CF_p = ((modelPar_CFL*value_pow_0)*(1.0+(modelPar_CFW*iWE)));
      }
      CFD_p = modelPar_CFDO;
      CFB_p = modelPar_CFBO;
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_PSCELEXP);
        PSCE_p = ((modelPar_PSCEL*value_pow_0)*(1.0+(modelPar_PSCEW*iWE)));
      }
      PSCED_p = modelPar_PSCEDO;
      PSCEB_p = modelPar_PSCEBO;
      FBET1e = (modelPar_FBET1*(1.0+(modelPar_FBET1W*iWE)));
      LP1e = (modelVar_LP1_i*adms_ternary_op<AdmsSensFadType>(((1.0+(modelPar_LP1W*iWE))>1.0e-03),(1.0+(modelPar_LP1W*iWE)),1.0e-03));
      {
        AdmsSensFadType value_exp_0 = exp(((-LE)/LP1e));
        AdmsSensFadType value_exp_1 = exp(((-LE)/modelVar_LP2_i));
        GPE = ((1.0+(((FBET1e*LP1e)/LE)*(1.0-value_exp_0)))+(((modelPar_FBET2*modelVar_LP2_i)/LE)*(1.0-value_exp_1)));
      }
      GPE = adms_ternary_op<AdmsSensFadType>((GPE>1.0e-15),GPE,1.0e-15);
      {
        AdmsSensFadType value_log_0 = log((1.0+(WE/modelVar_WBET_i)));
        GWE = ((1.0+(modelPar_BETW1*iWE))+((modelPar_BETW2*iWE)*value_log_0));
      }
      BETN_p = (((modelPar_UO*WE)/(GPE*LE))*GWE);
      STBET_p = (((modelPar_STBETO+(modelPar_STBETL*iLE))+(modelPar_STBETW*iWE))+((modelPar_STBETLW*iLE)*iWE));
      MUE_p = (modelPar_MUEO*(1.0+(modelPar_MUEW*iWE)));
      STMUE_p = modelPar_STMUEO;
      THEMU_p = modelPar_THEMUO;
      STTHEMU_p = modelPar_STTHEMUO;
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_CSLEXP);
        CS_p = (((modelPar_CSO+(modelPar_CSL*value_pow_0))*(1.0+(modelPar_CSW*iWE)))*(1.0+((modelPar_CSLW*iLE)*iWE)));
      }
      STCS_p = modelPar_STCSO;
      XCOR_p = (((modelPar_XCORO*(1.0+(modelPar_XCORL*iLE)))*(1.0+(modelPar_XCORW*iWE)))*(1.0+((modelPar_XCORLW*iLE)*iWE)));
      STXCOR_p = modelPar_STXCORO;
      FETA_p = modelPar_FETAO;
      RS_p = ((modelPar_RSW1*iWE)*(1.0+(modelPar_RSW2*iWE)));
      STRS_p = modelPar_STRSO;
      RSB_p = modelPar_RSBO;
      RSG_p = modelPar_RSGO;
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_THESATLEXP);
        THESAT_p = (((modelPar_THESATO+(((modelPar_THESATL*GWE)/GPE)*value_pow_0))*(1.0+(modelPar_THESATW*iWE)))*(1.0+((modelPar_THESATLW*iLE)*iWE)));
      }
      STTHESAT_p = (((modelPar_STTHESATO+(modelPar_STTHESATL*iLE))+(modelPar_STTHESATW*iWE))+((modelPar_STTHESATLW*iLE)*iWE));
      THESATB_p = modelPar_THESATBO;
      THESATG_p = modelPar_THESATGO;
      AX_p = (modelPar_AXO/(1.0+(modelVar_AXL_i*iLE)));
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_ALPLEXP);
        ALP_p = ((modelPar_ALPL*value_pow_0)*(1.0+(modelPar_ALPW*iWE)));
      }
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_ALP1LEXP);
        tmpx = value_pow_0;
      }
      ALP1_p = (((modelPar_ALP1L1*tmpx)*(1.0+(modelPar_ALP1W*iWE)))/(1.0+((modelVar_ALP1L2_i*iLE)*tmpx)));
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_ALP2LEXP);
        tmpx = value_pow_0;
      }
      ALP2_p = (((modelPar_ALP2L1*tmpx)*(1.0+(modelPar_ALP2W*iWE)))/(1.0+((modelVar_ALP2L2_i*iLE)*tmpx)));
      VP_p = modelPar_VPO;
      A1_p = ((modelPar_A1O*(1.0+(modelPar_A1L*iLE)))*(1.0+(modelPar_A1W*iWE)));
      A2_p = modelPar_A2O;
      STA2_p = modelPar_STA2O;
      A3_p = ((modelPar_A3O*(1.0+(modelPar_A3L*iLE)))*(1.0+(modelPar_A3W*iWE)));
      A4_p = ((modelPar_A4O*(1.0+(modelPar_A4L*iLE)))*(1.0+(modelPar_A4W*iWE)));
      GCO_p = modelPar_GCOO;
      IGINV_p = (modelPar_IGINVLW/(iWE*iLE));
      IGOV_p = ((modelPar_IGOVW*modelVar_LOV_i)/(1.0e-6*iWE));
      IGOVD_p = ((modelPar_IGOVDW*modelVar_LOVD_i)/(1.0e-6*iWE));
      STIG_p = modelPar_STIGO;
      GC2_p = modelPar_GC2O;
      GC3_p = modelPar_GC3O;
      CHIB_p = modelPar_CHIBO;
      AGIDL_p = ((modelPar_AGIDLW*modelVar_LOV_i)/(1.0e-6*iWE));
      AGIDLD_p = ((modelPar_AGIDLDW*modelVar_LOVD_i)/(1.0e-6*iWE));
      BGIDL_p = modelPar_BGIDLO;
      BGIDLD_p = modelPar_BGIDLDO;
      STBGIDL_p = modelPar_STBGIDLO;
      STBGIDLD_p = modelPar_STBGIDLDO;
      CGIDL_p = modelPar_CGIDLO;
      CGIDLD_p = modelPar_CGIDLDO;
      COX_p = ((((8.8541878176E-12*modelVar_EPSROXO_i)*WEcv)*LEcv)/modelVar_TOXO_i);
      CGOV_p = ((((8.8541878176E-12*modelVar_EPSROXO_i)*WEcv)*modelVar_LOV_i)/modelVar_TOXOVO_i);
      CGOVD_p = ((((8.8541878176E-12*modelVar_EPSROXO_i)*WEcv)*modelVar_LOVD_i)/modelVar_TOXOVDO_i);
      CGBOV_p = ((modelPar_CGBOVL*Lcv)/1.0e-6);
      CFR_p = ((modelPar_CFRW*Wcv)/1.0e-6);
      CFRD_p = ((modelPar_CFRDW*Wcv)/1.0e-6);
      temp0 = (1.0-(((2.0*modelPar_LINTNOI)*iLE)/1.0e-6));
      Lnoi = adms_ternary_op<AdmsSensFadType>((temp0>1.0e-3),temp0,1.0e-3);
      {
        AdmsSensFadType value_pow_0 = pow(Lnoi,modelPar_ALPNOI);
        Lred = (1.0/value_pow_0);
      }
      FNT_p = modelPar_FNTO;
      FNTEXC_p = ((((modelPar_FNTEXCL*BETN_p)*BETN_p)*iWE)*iWE);
      NFA_p = (((Lred*iWE)*iLE)*modelPar_NFALW);
      NFB_p = (((Lred*iWE)*iLE)*modelPar_NFBLW);
      NFC_p = (((Lred*iWE)*iLE)*modelPar_NFCLW);
      EF_p = modelPar_EFO;
      WE_edge = ((2.0*modelPar_WEDGE)+(modelPar_WEDGEW*WE));
      iWE_edge = (1.0e-6/WE_edge);
      VFBEDGE_p = modelPar_VFBEDGEO;
      STVFBEDGE_p = (((modelPar_STVFBEDGEO+(modelPar_STVFBEDGEL*iLE))+(modelPar_STVFBEDGEW*iWE))+((modelPar_STVFBEDGELW*iLE)*iWE));
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_DPHIBEDGELEXP);
        DPHIBEDGE_p = (((modelPar_DPHIBEDGEO+(modelPar_DPHIBEDGEL*value_pow_0))+(modelPar_DPHIBEDGEW*iWE))+((modelPar_DPHIBEDGELW*iLE)*iWE));
      }
      NEFFEDGE_p = (((modelVar_NSUBEDGEO_i*(1.0+(modelPar_NSUBEDGEL*iLE)))*(1.0+(modelPar_NSUBEDGEW*iWE)))*(1.0+((modelPar_NSUBEDGELW*iLE)*iWE)));
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_CTEDGELEXP);
        CTEDGE_p = (modelPar_CTEDGEO+(modelPar_CTEDGEL*value_pow_0));
      }
      {
        AdmsSensFadType value_exp_0 = exp(((-LE)/modelVar_LPEDGE_i));
        GPE_edge = (1.0+(((modelPar_FBETEDGE*modelVar_LPEDGE_i)/LE)*(1.0-value_exp_0)));
      }
      GPE_edge = adms_ternary_op<AdmsSensFadType>((GPE_edge>1.0e-15),GPE_edge,1.0e-15);
      BETNEDGE_p = (((modelPar_UO*WE_edge)/(GPE_edge*LE))*(1.0+(modelPar_BETEDGEW*iWE)));
      STBETEDGE_p = (((modelPar_STBETEDGEO+(modelPar_STBETEDGEL*iLE))+(modelPar_STBETEDGEW*iWE))+((modelPar_STBETEDGELW*iLE)*iWE));
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_PSCEEDGELEXP);
        PSCEEDGE_p = ((modelPar_PSCEEDGEL*value_pow_0)*(1.0+(modelPar_PSCEEDGEW*iWE)));
      }
      PSCEBEDGE_p = modelPar_PSCEBEDGEO;
      PSCEDEDGE_p = modelPar_PSCEDEDGEO;
      {
        AdmsSensFadType value_pow_0 = pow(iLE,modelPar_CFEDGELEXP);
        CFEDGE_p = ((modelPar_CFEDGEL*value_pow_0)*(1.0+(modelPar_CFEDGEW*iWE)));
      }
      CFDEDGE_p = modelPar_CFDEDGEO;
      CFBEDGE_p = modelPar_CFBEDGEO;
      FNTEDGE_p = modelPar_FNTEDGEO;
      NFAEDGE_p = ((iWE_edge*iLE)*modelPar_NFAEDGELW);
      NFBEDGE_p = ((iWE_edge*iLE)*modelPar_NFBEDGELW);
      NFCEDGE_p = ((iWE_edge*iLE)*modelPar_NFCEDGELW);
      EFEDGE_p = modelPar_EFEDGEO;
    }
    KVTHOWE = (((modelPar_KVTHOWEO+(modelPar_KVTHOWEL*iLE))+(modelPar_KVTHOWEW*iWE))+((modelPar_KVTHOWELW*iLE)*iWE));
    KUOWE = (((modelPar_KUOWEO+(modelPar_KUOWEL*iLE))+(modelPar_KUOWEW*iWE))+((modelPar_KUOWELW*iLE)*iWE));
    if ((modelVar_SWGEO_i==2))
    {
      iLEWE = (iLE*iWE);
      iiLE = (LE/1.0e-6);
      iiWE = (WE/1.0e-6);
      iiLEWE = (iiLE*iiWE);
      iiiLEWE = (iiWE/iiLE);
      iiLEcv = (LEcv/1.0e-6);
      iiWEcv = (WEcv/1.0e-6);
      iiLEWEcv = (iiLEcv*iiWEcv);
      iLEcv = (1.0e-6/LEcv);
      iiiLEWEcv = (iiWEcv/iiLEcv);
      iiLcv = (Lcv/1.0e-6);
      iiWcv = (Wcv/1.0e-6);
      iiLWcv = (iiLcv*iiWcv);
      iLcv = (1.0e-6/Lcv);
      iiiLWcv = (iiWcv/iiLcv);
      VFB_p = (((modelPar_POVFB+(iLE*modelPar_PLVFB))+(iWE*modelPar_PWVFB))+(iLEWE*modelPar_PLWVFB));
      STVFB_p = (((modelPar_POSTVFB+(iLE*modelPar_PLSTVFB))+(iWE*modelPar_PWSTVFB))+(iLEWE*modelPar_PLWSTVFB));
      TOX_p = modelPar_POTOX;
      EPSROX_p = modelPar_POEPSROX;
      NEFF_p = (((modelPar_PONEFF+(iLE*modelPar_PLNEFF))+(iWE*modelPar_PWNEFF))+(iLEWE*modelPar_PLWNEFF));
      FACNEFFAC_p = (((modelPar_POFACNEFFAC+(iLE*modelPar_PLFACNEFFAC))+(iWE*modelPar_PWFACNEFFAC))+(iLEWE*modelPar_PLWFACNEFFAC));
      GFACNUD_p = (((modelPar_POGFACNUD+(modelPar_PLGFACNUD*iLE))+(modelPar_PWGFACNUD*iWE))+((modelPar_PLWGFACNUD*iLE)*iWE));
      VSBNUD_p = modelPar_POVSBNUD;
      DVSBNUD_p = modelPar_PODVSBNUD;
      VNSUB_p = modelPar_POVNSUB;
      NSLP_p = modelPar_PONSLP;
      DNSUB_p = modelPar_PODNSUB;
      DPHIB_p = (((modelPar_PODPHIB+(iLE*modelPar_PLDPHIB))+(iWE*modelPar_PWDPHIB))+(iLEWE*modelPar_PLWDPHIB));
      DELVTAC_p = (((modelPar_PODELVTAC+(iLE*modelPar_PLDELVTAC))+(iWE*modelPar_PWDELVTAC))+(iLEWE*modelPar_PLWDELVTAC));
      NP_p = (((modelPar_PONP+(iLE*modelPar_PLNP))+(iWE*modelPar_PWNP))+(iLEWE*modelPar_PLWNP));
      CT_p = (((modelPar_POCT+(iLE*modelPar_PLCT))+(iWE*modelPar_PWCT))+(iLEWE*modelPar_PLWCT));
      TOXOV_p = modelPar_POTOXOV;
      TOXOVD_p = modelPar_POTOXOVD;
      NOV_p = (((modelPar_PONOV+(iLE*modelPar_PLNOV))+(iWE*modelPar_PWNOV))+(iLEWE*modelPar_PLWNOV));
      NOVD_p = (((modelPar_PONOVD+(iLE*modelPar_PLNOVD))+(iWE*modelPar_PWNOVD))+(iLEWE*modelPar_PLWNOVD));
      CF_p = (((modelPar_POCF+(iLE*modelPar_PLCF))+(iWE*modelPar_PWCF))+(iLEWE*modelPar_PLWCF));
      CFD_p = modelPar_POCFD;
      CFB_p = modelPar_POCFB;
      PSCE_p = (((modelPar_POPSCE+(iLE*modelPar_PLPSCE))+(iWE*modelPar_PWPSCE))+(iLEWE*modelPar_PLWPSCE));
      PSCEB_p = modelPar_POPSCEB;
      PSCED_p = modelPar_POPSCED;
      BETN_p = ((iiWE*iLE)*(((modelPar_POBETN+(iLE*modelPar_PLBETN))+(iWE*modelPar_PWBETN))+(iLEWE*modelPar_PLWBETN)));
      STBET_p = (((modelPar_POSTBET+(iLE*modelPar_PLSTBET))+(iWE*modelPar_PWSTBET))+(iLEWE*modelPar_PLWSTBET));
      MUE_p = (((modelPar_POMUE+(iLE*modelPar_PLMUE))+(iWE*modelPar_PWMUE))+(iLEWE*modelPar_PLWMUE));
      STMUE_p = modelPar_POSTMUE;
      THEMU_p = modelPar_POTHEMU;
      STTHEMU_p = modelPar_POSTTHEMU;
      CS_p = (((modelPar_POCS+(iLE*modelPar_PLCS))+(iWE*modelPar_PWCS))+(iLEWE*modelPar_PLWCS));
      STCS_p = modelPar_POSTCS;
      XCOR_p = (((modelPar_POXCOR+(iLE*modelPar_PLXCOR))+(iWE*modelPar_PWXCOR))+(iLEWE*modelPar_PLWXCOR));
      STXCOR_p = modelPar_POSTXCOR;
      FETA_p = modelPar_POFETA;
      RS_p = (((modelPar_PORS+(iLE*modelPar_PLRS))+(iWE*modelPar_PWRS))+(iLEWE*modelPar_PLWRS));
      STRS_p = modelPar_POSTRS;
      RSB_p = modelPar_PORSB;
      RSG_p = modelPar_PORSG;
      THESAT_p = (((modelPar_POTHESAT+(iLE*modelPar_PLTHESAT))+(iWE*modelPar_PWTHESAT))+(iLEWE*modelPar_PLWTHESAT));
      STTHESAT_p = (((modelPar_POSTTHESAT+(iLE*modelPar_PLSTTHESAT))+(iWE*modelPar_PWSTTHESAT))+(iLEWE*modelPar_PLWSTTHESAT));
      THESATB_p = (((modelPar_POTHESATB+(iLE*modelPar_PLTHESATB))+(iWE*modelPar_PWTHESATB))+(iLEWE*modelPar_PLWTHESATB));
      THESATG_p = (((modelPar_POTHESATG+(iLE*modelPar_PLTHESATG))+(iWE*modelPar_PWTHESATG))+(iLEWE*modelPar_PLWTHESATG));
      AX_p = (((modelPar_POAX+(iLE*modelPar_PLAX))+(iWE*modelPar_PWAX))+(iLEWE*modelPar_PLWAX));
      ALP_p = (((modelPar_POALP+(iLE*modelPar_PLALP))+(iWE*modelPar_PWALP))+(iLEWE*modelPar_PLWALP));
      ALP1_p = (((modelPar_POALP1+(iLE*modelPar_PLALP1))+(iWE*modelPar_PWALP1))+(iLEWE*modelPar_PLWALP1));
      ALP2_p = (((modelPar_POALP2+(iLE*modelPar_PLALP2))+(iWE*modelPar_PWALP2))+(iLEWE*modelPar_PLWALP2));
      VP_p = modelPar_POVP;
      A1_p = (((modelPar_POA1+(iLE*modelPar_PLA1))+(iWE*modelPar_PWA1))+(iLEWE*modelPar_PLWA1));
      A2_p = modelPar_POA2;
      STA2_p = modelPar_POSTA2;
      A3_p = (((modelPar_POA3+(iLE*modelPar_PLA3))+(iWE*modelPar_PWA3))+(iLEWE*modelPar_PLWA3));
      A4_p = (((modelPar_POA4+(iLE*modelPar_PLA4))+(iWE*modelPar_PWA4))+(iLEWE*modelPar_PLWA4));
      GCO_p = modelPar_POGCO;
      IGINV_p = (((modelPar_POIGINV+(iiLE*modelPar_PLIGINV))+(iiWE*modelPar_PWIGINV))+(iiLEWE*modelPar_PLWIGINV));
      IGOV_p = (((modelPar_POIGOV+(iLE*modelPar_PLIGOV))+(iiWE*modelPar_PWIGOV))+(iiiLEWE*modelPar_PLWIGOV));
      IGOVD_p = (((modelPar_POIGOVD+(iLE*modelPar_PLIGOVD))+(iiWE*modelPar_PWIGOVD))+(iiiLEWE*modelPar_PLWIGOVD));
      STIG_p = modelPar_POSTIG;
      GC2_p = modelPar_POGC2;
      GC3_p = modelPar_POGC3;
      CHIB_p = modelPar_POCHIB;
      AGIDL_p = (((modelPar_POAGIDL+(iLE*modelPar_PLAGIDL))+(iiWE*modelPar_PWAGIDL))+(iiiLEWE*modelPar_PLWAGIDL));
      AGIDLD_p = (((modelPar_POAGIDLD+(iLE*modelPar_PLAGIDLD))+(iiWE*modelPar_PWAGIDLD))+(iiiLEWE*modelPar_PLWAGIDLD));
      BGIDL_p = modelPar_POBGIDL;
      BGIDLD_p = modelPar_POBGIDLD;
      STBGIDL_p = modelPar_POSTBGIDL;
      STBGIDLD_p = modelPar_POSTBGIDLD;
      CGIDL_p = modelPar_POCGIDL;
      CGIDLD_p = modelPar_POCGIDLD;
      COX_p = (((modelPar_POCOX+(iiLEcv*modelPar_PLCOX))+(iiWEcv*modelPar_PWCOX))+(iiLEWEcv*modelPar_PLWCOX));
      CGOV_p = (((modelPar_POCGOV+(iLEcv*modelPar_PLCGOV))+(iiWEcv*modelPar_PWCGOV))+(iiiLEWEcv*modelPar_PLWCGOV));
      CGOVD_p = (((modelPar_POCGOVD+(iLEcv*modelPar_PLCGOVD))+(iiWEcv*modelPar_PWCGOVD))+(iiiLEWEcv*modelPar_PLWCGOVD));
      CGBOV_p = (((modelPar_POCGBOV+(iiLcv*modelPar_PLCGBOV))+(iiWcv*modelPar_PWCGBOV))+(iiLWcv*modelPar_PLWCGBOV));
      CFR_p = (((modelPar_POCFR+(iLcv*modelPar_PLCFR))+(iiWcv*modelPar_PWCFR))+(iiiLWcv*modelPar_PLWCFR));
      CFRD_p = (((modelPar_POCFRD+(iLcv*modelPar_PLCFRD))+(iiWcv*modelPar_PWCFRD))+(iiiLWcv*modelPar_PLWCFRD));
      FNT_p = modelPar_POFNT;
      FNTEXC_p = ((iLE*iLE)*(((modelPar_POFNTEXC+(iLE*modelPar_PLFNTEXC))+(iWE*modelPar_PWFNTEXC))+(iLEWE*modelPar_PLWFNTEXC)));
      NFA_p = (((modelPar_PONFA+(iLE*modelPar_PLNFA))+(iWE*modelPar_PWNFA))+(iLEWE*modelPar_PLWNFA));
      NFB_p = (((modelPar_PONFB+(iLE*modelPar_PLNFB))+(iWE*modelPar_PWNFB))+(iLEWE*modelPar_PLWNFB));
      NFC_p = (((modelPar_PONFC+(iLE*modelPar_PLNFC))+(iWE*modelPar_PWNFC))+(iLEWE*modelPar_PLWNFC));
      EF_p = modelPar_POEF;
      VFBEDGE_p = modelPar_POVFBEDGE;
      STVFBEDGE_p = (((modelPar_POSTVFBEDGE+(iLE*modelPar_PLSTVFBEDGE))+(iWE*modelPar_PWSTVFBEDGE))+(iLEWE*modelPar_PLWSTVFBEDGE));
      DPHIBEDGE_p = (((modelPar_PODPHIBEDGE+(iLE*modelPar_PLDPHIBEDGE))+(iWE*modelPar_PWDPHIBEDGE))+(iLEWE*modelPar_PLWDPHIBEDGE));
      NEFFEDGE_p = (((modelPar_PONEFFEDGE+(iLE*modelPar_PLNEFFEDGE))+(iWE*modelPar_PWNEFFEDGE))+(iLEWE*modelPar_PLWNEFFEDGE));
      CTEDGE_p = (((modelPar_POCTEDGE+(iLE*modelPar_PLCTEDGE))+(iWE*modelPar_PWCTEDGE))+(iLEWE*modelPar_PLWCTEDGE));
      BETNEDGE_p = (iLE*(((modelPar_POBETNEDGE+(iLE*modelPar_PLBETNEDGE))+(iWE*modelPar_PWBETNEDGE))+(iLEWE*modelPar_PLWBETNEDGE)));
      STBETEDGE_p = (((modelPar_POSTBETEDGE+(iLE*modelPar_PLSTBETEDGE))+(iWE*modelPar_PWSTBETEDGE))+(iLEWE*modelPar_PLWSTBETEDGE));
      PSCEEDGE_p = (((modelPar_POPSCEEDGE+(iLE*modelPar_PLPSCEEDGE))+(iWE*modelPar_PWPSCEEDGE))+(iLEWE*modelPar_PLWPSCEEDGE));
      PSCEBEDGE_p = modelPar_POPSCEBEDGE;
      PSCEDEDGE_p = modelPar_POPSCEDEDGE;
      CFEDGE_p = (((modelPar_POCFEDGE+(iLE*modelPar_PLCFEDGE))+(iWE*modelPar_PWCFEDGE))+(iLEWE*modelPar_PLWCFEDGE));
      CFDEDGE_p = modelPar_POCFDEDGE;
      CFBEDGE_p = modelPar_POCFBEDGE;
      FNTEDGE_p = modelPar_POFNTEDGE;
      NFAEDGE_p = (((modelPar_PONFAEDGE+(iLE*modelPar_PLNFAEDGE))+(iWE*modelPar_PWNFAEDGE))+(iLEWE*modelPar_PLWNFAEDGE));
      NFBEDGE_p = (((modelPar_PONFBEDGE+(iLE*modelPar_PLNFBEDGE))+(iWE*modelPar_PWNFBEDGE))+(iLEWE*modelPar_PLWNFBEDGE));
      NFCEDGE_p = (((modelPar_PONFCEDGE+(iLE*modelPar_PLNFCEDGE))+(iWE*modelPar_PWNFCEDGE))+(iLEWE*modelPar_PLWNFCEDGE));
      EFEDGE_p = modelPar_POEFEDGE;
      KVTHOWE = (((modelPar_POKVTHOWE+(iLE*modelPar_PLKVTHOWE))+(iWE*modelPar_PWKVTHOWE))+(iLEWE*modelPar_PLWKVTHOWE));
      KUOWE = (((modelPar_POKUOWE+(iLE*modelPar_PLKUOWE))+(iWE*modelPar_PWKUOWE))+(iLEWE*modelPar_PLWKUOWE));
    }
    if (((modelVar_SWGEO_i==1)||(modelVar_SWGEO_i==2)))
    {
      RG_p = ((((modelVar_RSHG_i*(((3.3333333333333333e-01*W_f)/NGCON_i)+XGWE))/(NGCON_i*L_slif))+((modelVar_RINT_i+modelVar_RVPOLY_i)/(W_f*L_f)))+(NF_i*modelPar_RGO));
      if ((modelPar_SWJUNASYM==0))
      {
        modelVar_RSHD_i = modelVar_RSH_i;
      }
      RSE_p = (instancePar_NRS*modelVar_RSH_i);
      RDE_p = (instancePar_NRD*modelVar_RSHD_i);
      RWELL_p = (NF_i*modelPar_RWELLO);
      RBULK_p = (NF_i*modelPar_RBULKO);
      RJUNS_p = (NF_i*modelPar_RJUNSO);
      RJUND_p = (NF_i*modelPar_RJUNDO);
      tmpa = 0.0;
      tmpb = 0.0;
      loop = 0.0;
      if ((((SA_i>0.0)&&(SB_i>0.0))&&((NF_i==1.0)||((NF_i>1.0)&&(SD_i>0.0)))))
      {
        while ((loop<(NF_i-0.5)))
        {
          tmpa = (tmpa+(1.0/((SA_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
          tmpb = (tmpb+(1.0/((SB_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
          loop = (loop+1.0);
        }
        Invsa = (tmpa*invNF);
        Invsb = (tmpb*invNF);
        Invsaref = (1.0/(modelVar_SAREF_i+(0.5*L_i)));
        Invsbref = (1.0/(modelVar_SBREF_i+(0.5*L_i)));
        Lx = adms_ternary_op<AdmsSensFadType>(((L_i+delLPS)>1.0e-9),(L_i+delLPS),1.0e-9);
        Wx = adms_ternary_op<AdmsSensFadType>((((W_i+delWOD)+modelPar_WLOD)>1.0e-9),((W_i+delWOD)+modelPar_WLOD),1.0e-9);
        {
          AdmsSensFadType value_pow_0 = pow(Lx,modelVar_LLODKUO_i);
          templ = (1.0/value_pow_0);
        }
        {
          AdmsSensFadType value_pow_0 = pow(Wx,modelVar_WLODKUO_i);
          tempw = (1.0/value_pow_0);
        }
        Kstressu0 = ((((1.0+(modelPar_LKUO*templ))+(modelPar_WKUO*tempw))+((modelPar_PKUO*templ)*tempw))*(1.0+(modelPar_TKUO*(modelVar_rTa-1.0))));
        rhobeta = ((modelPar_KUO*(Invsa+Invsb))/Kstressu0);
        rhobetaref = ((modelPar_KUO*(Invsaref+Invsbref))/Kstressu0);
        {
          AdmsSensFadType value_pow_0 = pow(Lx,modelVar_LLODVTH_i);
          templ = (1.0/value_pow_0);
        }
        {
          AdmsSensFadType value_pow_0 = pow(Wx,modelVar_WLODVTH_i);
          tempw = (1.0/value_pow_0);
        }
        Kstressvth0 = (((1.0+(modelPar_LKVTHO*templ))+(modelPar_WKVTHO*tempw))+((modelPar_PKVTHO*templ)*tempw));
        temp0 = (((Invsa+Invsb)-Invsaref)-Invsbref);
        BETN_p = ((BETN_p*(1.0+rhobeta))/(1.0+rhobetaref));
        THESAT_p = (((THESAT_p*(1.0+rhobeta))*(1.0+(modelVar_KVSAT_i*rhobetaref)))/((1.0+rhobetaref)*(1.0+(modelVar_KVSAT_i*rhobeta))));
        VFB_p = (VFB_p+((modelPar_KVTHO*temp0)/Kstressvth0));
        {
          AdmsSensFadType value_pow_0 = pow(Kstressvth0,modelVar_LODETAO_i);
          CF_p = (CF_p+((modelPar_STETAO*temp0)/value_pow_0));
        }
        BETNEDGE_p = ((BETNEDGE_p*(1.0+rhobeta))/(1.0+rhobetaref));
        VFBEDGE_p = (VFBEDGE_p+((modelPar_KVTHO*temp0)/Kstressvth0));
        {
          AdmsSensFadType value_pow_0 = pow(Kstressvth0,modelVar_LODETAO_i);
          CFEDGE_p = (CFEDGE_p+((modelPar_STETAO*temp0)/value_pow_0));
        }
      }
      if (((((SCA_i>0.0)||(SCB_i>0.0))||(SCC_i>0.0))||(SC_i>0.0)))
      {
        if ((((SCA_i==0.0)&&(SCB_i==0.0))&&(SCC_i==0.0)))
        {
          temp0 = (SC_i+W_i);
          temp00 = (1.0/modelVar_SCREF_i);
          SCA_i = ((modelVar_SCREF_i*modelVar_SCREF_i)/(SC_i*temp0));
          {
            AdmsSensFadType value_exp_0 = exp((((-10.0)*SC_i)*temp00));
            AdmsSensFadType value_exp_1 = exp((((-10.0)*temp0)*temp00));
            SCB_i = (((((0.1*SC_i)+(0.01*modelVar_SCREF_i))*value_exp_0)-(((0.1*temp0)+(0.01*modelVar_SCREF_i))*value_exp_1))/W_i);
          }
          {
            AdmsSensFadType value_exp_0 = exp((((-20.0)*SC_i)*temp00));
            AdmsSensFadType value_exp_1 = exp((((-20.0)*temp0)*temp00));
            SCC_i = (((((0.05*SC_i)+(0.0025*modelVar_SCREF_i))*value_exp_0)-(((0.05*temp0)+(0.0025*modelVar_SCREF_i))*value_exp_1))/W_i);
          }
        }
        temp0 = ((SCA_i+(modelVar_WEB_i*SCB_i))+(modelVar_WEC_i*SCC_i));
        VFB_p = (VFB_p+(KVTHOWE*temp0));
        BETN_p = (BETN_p*(1.0+(KUOWE*temp0)));
        VFBEDGE_p = (VFBEDGE_p+(KVTHOWE*temp0));
        BETNEDGE_p = (BETNEDGE_p*(1.0+(KUOWE*temp0)));
      }
    }
    VFB_i = VFB_p;
    STVFB_i = STVFB_p;
    TOX_i = adms_ternary_op<AdmsSensFadType>((TOX_p>1.0e-10),TOX_p,1.0e-10);
    EPSROX_i = adms_ternary_op<AdmsSensFadType>((EPSROX_p>1.0),EPSROX_p,1.0);
    NEFF_i = adms_ternary_op<AdmsSensFadType>((NEFF_p>1.0e20),adms_ternary_op<AdmsSensFadType>((NEFF_p<1.0e26),NEFF_p,1.0e26),1.0e20);
    FACNEFFAC_i = adms_ternary_op<AdmsSensFadType>((FACNEFFAC_p>0.0),FACNEFFAC_p,0.0);
    instanceVar_GFACNUD_i = adms_ternary_op<AdmsSensFadType>((GFACNUD_p>0.01),GFACNUD_p,0.01);
    VSBNUD_i = adms_ternary_op<AdmsSensFadType>((VSBNUD_p>0.0),VSBNUD_p,0.0);
    DVSBNUD_i = adms_ternary_op<AdmsSensFadType>((DVSBNUD_p>0.1),DVSBNUD_p,0.1);
    instanceVar_VNSUB_i = VNSUB_p;
    instanceVar_NSLP_i = adms_ternary_op<AdmsSensFadType>((NSLP_p>1.0e-3),NSLP_p,1.0e-3);
    instanceVar_DNSUB_i = adms_ternary_op<AdmsSensFadType>((DNSUB_p>0.0),adms_ternary_op<AdmsSensFadType>((DNSUB_p<1.0),DNSUB_p,1.0),0.0);
    DPHIB_i = DPHIB_p;
    DELVTAC_i = DELVTAC_p;
    NP_i = adms_ternary_op<AdmsSensFadType>((NP_p>0.0),NP_p,0.0);
    CT_i = adms_ternary_op<AdmsSensFadType>((CT_p>0.0),CT_p,0.0);
    TOXOV_i = adms_ternary_op<AdmsSensFadType>((TOXOV_p>1.0e-10),TOXOV_p,1.0e-10);
    TOXOVD_i = adms_ternary_op<AdmsSensFadType>((TOXOVD_p>1.0e-10),TOXOVD_p,1.0e-10);
    NOV_i = adms_ternary_op<AdmsSensFadType>((NOV_p>1.0e20),adms_ternary_op<AdmsSensFadType>((NOV_p<1.0e27),NOV_p,1.0e27),1.0e20);
    NOVD_i = adms_ternary_op<AdmsSensFadType>((NOVD_p>1.0e20),adms_ternary_op<AdmsSensFadType>((NOVD_p<1.0e27),NOVD_p,1.0e27),1.0e20);
    instanceVar_CF_i = adms_ternary_op<AdmsSensFadType>((CF_p>0.0),CF_p,0.0);
    instanceVar_CFD_i = adms_ternary_op<AdmsSensFadType>((CFD_p>0.0),CFD_p,0.0);
    instanceVar_CFB_i = adms_ternary_op<AdmsSensFadType>((CFB_p>0.0),adms_ternary_op<AdmsSensFadType>((CFB_p<1.0),CFB_p,1.0),0.0);
    instanceVar_PSCE_i = adms_ternary_op<AdmsSensFadType>((PSCE_p>0.0),PSCE_p,0.0);
    instanceVar_PSCEB_i = adms_ternary_op<AdmsSensFadType>((PSCEB_p>0.0),adms_ternary_op<AdmsSensFadType>((PSCEB_p<1.0),PSCEB_p,1.0),0.0);
    instanceVar_PSCED_i = adms_ternary_op<AdmsSensFadType>((PSCED_p>0.0),PSCED_p,0.0);
    BETN_i = adms_ternary_op<AdmsSensFadType>((BETN_p>0.0),BETN_p,0.0);
    STBET_i = STBET_p;
    MUE_i = adms_ternary_op<AdmsSensFadType>((MUE_p>0.0),MUE_p,0.0);
    STMUE_i = STMUE_p;
    THEMU_i = adms_ternary_op<AdmsSensFadType>((THEMU_p>0.0),THEMU_p,0.0);
    STTHEMU_i = STTHEMU_p;
    CS_i = adms_ternary_op<AdmsSensFadType>((CS_p>0.0),CS_p,0.0);
    STCS_i = STCS_p;
    XCOR_i = adms_ternary_op<AdmsSensFadType>((XCOR_p>0.0),XCOR_p,0.0);
    STXCOR_i = STXCOR_p;
    FETA_i = adms_ternary_op<AdmsSensFadType>((FETA_p>0.0),FETA_p,0.0);
    RS_i = adms_ternary_op<AdmsSensFadType>((RS_p>0.0),RS_p,0.0);
    STRS_i = STRS_p;
    instanceVar_RSB_i = adms_ternary_op<AdmsSensFadType>((RSB_p>(-0.5)),adms_ternary_op<AdmsSensFadType>((RSB_p<1.0),RSB_p,1.0),(-0.5));
    instanceVar_RSG_i = adms_ternary_op<AdmsSensFadType>((RSG_p>(-0.5)),RSG_p,(-0.5));
    THESAT_i = adms_ternary_op<AdmsSensFadType>((THESAT_p>0.0),THESAT_p,0.0);
    STTHESAT_i = STTHESAT_p;
    instanceVar_THESATB_i = adms_ternary_op<AdmsSensFadType>((THESATB_p>(-0.5)),adms_ternary_op<AdmsSensFadType>((THESATB_p<1.0),THESATB_p,1.0),(-0.5));
    instanceVar_THESATG_i = adms_ternary_op<AdmsSensFadType>((THESATG_p>(-0.5)),THESATG_p,(-0.5));
    instanceVar_AX_i = adms_ternary_op<AdmsSensFadType>((AX_p>2.0),AX_p,2.0);
    instanceVar_ALP_i = adms_ternary_op<AdmsSensFadType>((ALP_p>0.0),ALP_p,0.0);
    instanceVar_ALP1_i = adms_ternary_op<AdmsSensFadType>((ALP1_p>0.0),ALP1_p,0.0);
    instanceVar_ALP2_i = adms_ternary_op<AdmsSensFadType>((ALP2_p>0.0),ALP2_p,0.0);
    VP_i = adms_ternary_op<AdmsSensFadType>((VP_p>1.0e-10),VP_p,1.0e-10);
    instanceVar_A1_i = adms_ternary_op<AdmsSensFadType>((A1_p>0.0),A1_p,0.0);
    A2_i = adms_ternary_op<AdmsSensFadType>((A2_p>0.0),A2_p,0.0);
    STA2_i = STA2_p;
    instanceVar_A3_i = adms_ternary_op<AdmsSensFadType>((A3_p>0.0),A3_p,0.0);
    instanceVar_A4_i = adms_ternary_op<AdmsSensFadType>((A4_p>0.0),A4_p,0.0);
    instanceVar_GCO_i = adms_ternary_op<AdmsSensFadType>((GCO_p>(-10.0)),adms_ternary_op<AdmsSensFadType>((GCO_p<10.0),GCO_p,10.0),(-10.0));
    instanceVar_IGINV_i = adms_ternary_op<AdmsSensFadType>((IGINV_p>0.0),IGINV_p,0.0);
    instanceVar_IGOV_i = adms_ternary_op<AdmsSensFadType>((IGOV_p>0.0),IGOV_p,0.0);
    instanceVar_IGOVD_i = adms_ternary_op<AdmsSensFadType>((IGOVD_p>0.0),IGOVD_p,0.0);
    STIG_i = STIG_p;
    instanceVar_GC2_i = adms_ternary_op<AdmsSensFadType>((GC2_p>0.0),adms_ternary_op<AdmsSensFadType>((GC2_p<10.0),GC2_p,10.0),0.0);
    instanceVar_GC3_i = adms_ternary_op<AdmsSensFadType>((GC3_p>(-10.0)),adms_ternary_op<AdmsSensFadType>((GC3_p<10.0),GC3_p,10.0),(-10.0));
    instanceVar_CHIB_i = adms_ternary_op<AdmsSensFadType>((CHIB_p>1.0),CHIB_p,1.0);
    instanceVar_AGIDL_i = adms_ternary_op<AdmsSensFadType>((AGIDL_p>0.0),AGIDL_p,0.0);
    instanceVar_AGIDLD_i = adms_ternary_op<AdmsSensFadType>((AGIDLD_p>0.0),AGIDLD_p,0.0);
    BGIDL_i = adms_ternary_op<AdmsSensFadType>((BGIDL_p>0.0),BGIDL_p,0.0);
    BGIDLD_i = adms_ternary_op<AdmsSensFadType>((BGIDLD_p>0.0),BGIDLD_p,0.0);
    STBGIDL_i = STBGIDL_p;
    STBGIDLD_i = STBGIDLD_p;
    instanceVar_CGIDL_i = CGIDL_p;
    instanceVar_CGIDLD_i = CGIDLD_p;
    instanceVar_COX_i = adms_ternary_op<AdmsSensFadType>((COX_p>0.0),COX_p,0.0);
    instanceVar_CGOV_i = adms_ternary_op<AdmsSensFadType>((CGOV_p>0.0),CGOV_p,0.0);
    instanceVar_CGOVD_i = adms_ternary_op<AdmsSensFadType>((CGOVD_p>0.0),CGOVD_p,0.0);
    instanceVar_CGBOV_i = adms_ternary_op<AdmsSensFadType>((CGBOV_p>0.0),CGBOV_p,0.0);
    instanceVar_CFR_i = adms_ternary_op<AdmsSensFadType>((CFR_p>0.0),CFR_p,0.0);
    instanceVar_CFRD_i = adms_ternary_op<AdmsSensFadType>((CFRD_p>0.0),CFRD_p,0.0);
    FNT_i = adms_ternary_op<AdmsSensFadType>((FNT_p>0.0),FNT_p,0.0);
    instanceVar_FNTEXC_i = adms_ternary_op<AdmsSensFadType>((FNTEXC_p>0.0),FNTEXC_p,0.0);
    instanceVar_NFA_i = adms_ternary_op<AdmsSensFadType>((NFA_p>0.0),NFA_p,0.0);
    instanceVar_NFB_i = adms_ternary_op<AdmsSensFadType>((NFB_p>0.0),NFB_p,0.0);
    instanceVar_NFC_i = adms_ternary_op<AdmsSensFadType>((NFC_p>0.0),NFC_p,0.0);
    instanceVar_EF_i = adms_ternary_op<AdmsSensFadType>((EF_p>0.0),EF_p,0.0);
    VFBEDGE_i = VFBEDGE_p;
    STVFBEDGE_i = STVFBEDGE_p;
    DPHIBEDGE_i = DPHIBEDGE_p;
    NEFFEDGE_i = adms_ternary_op<AdmsSensFadType>((NEFFEDGE_p>1.0e20),adms_ternary_op<AdmsSensFadType>((NEFFEDGE_p<1.0e26),NEFFEDGE_p,1.0e26),1.0e20);
    CTEDGE_i = adms_ternary_op<AdmsSensFadType>((CTEDGE_p>0.0),CTEDGE_p,0.0);
    instanceVar_BETNEDGE_i = adms_ternary_op<AdmsSensFadType>((BETNEDGE_p>0.0),BETNEDGE_p,0.0);
    STBETEDGE_i = STBETEDGE_p;
    instanceVar_PSCEEDGE_i = adms_ternary_op<AdmsSensFadType>((PSCEEDGE_p>0.0),PSCEEDGE_p,0.0);
    instanceVar_PSCEBEDGE_i = adms_ternary_op<AdmsSensFadType>((PSCEBEDGE_p>0.0),adms_ternary_op<AdmsSensFadType>((PSCEBEDGE_p<1.0),PSCEBEDGE_p,1.0),0.0);
    instanceVar_PSCEDEDGE_i = adms_ternary_op<AdmsSensFadType>((PSCEDEDGE_p>0.0),PSCEDEDGE_p,0.0);
    instanceVar_CFEDGE_i = adms_ternary_op<AdmsSensFadType>((CFEDGE_p>0.0),CFEDGE_p,0.0);
    instanceVar_CFDEDGE_i = adms_ternary_op<AdmsSensFadType>((CFDEDGE_p>0.0),CFDEDGE_p,0.0);
    instanceVar_CFBEDGE_i = adms_ternary_op<AdmsSensFadType>((CFBEDGE_p>0.0),adms_ternary_op<AdmsSensFadType>((CFBEDGE_p<1.0),CFBEDGE_p,1.0),0.0);
    FNTEDGE_i = adms_ternary_op<AdmsSensFadType>((FNTEDGE_p>0.0),FNTEDGE_p,0.0);
    instanceVar_NFAEDGE_i = adms_ternary_op<AdmsSensFadType>((NFAEDGE_p>0.0),NFAEDGE_p,0.0);
    instanceVar_NFBEDGE_i = adms_ternary_op<AdmsSensFadType>((NFBEDGE_p>0.0),NFBEDGE_p,0.0);
    instanceVar_NFCEDGE_i = adms_ternary_op<AdmsSensFadType>((NFCEDGE_p>0.0),NFCEDGE_p,0.0);
    instanceVar_EFEDGE_i = adms_ternary_op<AdmsSensFadType>((EFEDGE_p>0.0),EFEDGE_p,0.0);
    instanceVar_RG_i = adms_ternary_op<AdmsSensFadType>((RG_p>0.0),RG_p,0.0);
    instanceVar_RSE_i = adms_ternary_op<AdmsSensFadType>((RSE_p>0.0),RSE_p,0.0);
    instanceVar_RDE_i = adms_ternary_op<AdmsSensFadType>((RDE_p>0.0),RDE_p,0.0);
    instanceVar_RBULK_i = adms_ternary_op<AdmsSensFadType>((RBULK_p>0.0),RBULK_p,0.0);
    instanceVar_RJUNS_i = adms_ternary_op<AdmsSensFadType>((RJUNS_p>0.0),RJUNS_p,0.0);
    instanceVar_RJUND_i = adms_ternary_op<AdmsSensFadType>((RJUND_p>0.0),RJUND_p,0.0);
    instanceVar_RWELL_i = adms_ternary_op<AdmsSensFadType>((RWELL_p>0.0),RWELL_p,0.0);
    instanceVar_MULT_i = adms_ternary_op<AdmsSensFadType>(((instancePar_MULT*NF_i)>0.0),(instancePar_MULT*NF_i),0.0);
    FACTUO_i = adms_ternary_op<AdmsSensFadType>((instancePar_FACTUO>0.0),instancePar_FACTUO,0.0);
    DELVTO_i = instancePar_DELVTO;
    FACTUOEDGE_i = adms_ternary_op<AdmsSensFadType>((instancePar_FACTUOEDGE>0.0),instancePar_FACTUOEDGE,0.0);
    DELVTOEDGE_i = instancePar_DELVTOEDGE;
    if ((modelVar_SWJUNASYM_i==0))
    {
      TOXOVD_i = TOXOV_i;
      NOVD_i = NOV_i;
      instanceVar_AGIDLD_i = instanceVar_AGIDL_i;
      BGIDLD_i = BGIDL_i;
      STBGIDLD_i = STBGIDL_i;
      instanceVar_CGIDLD_i = instanceVar_CGIDL_i;
      instanceVar_IGOVD_i = instanceVar_IGOV_i;
      instanceVar_CGOVD_i = instanceVar_CGOV_i;
      instanceVar_CFRD_i = instanceVar_CFR_i;
    }
    EPSOX = (8.8541878176E-12*EPSROX_i);
    CoxPrime = (EPSOX/TOX_i);
    tox_sq = (TOX_i*TOX_i);
    instanceVar_Cox_over_q = (CoxPrime/1.6021918E-19);
    NEFFAC_i = (FACNEFFAC_i*NEFF_i);
    NEFFAC_i = adms_ternary_op<AdmsSensFadType>((NEFFAC_i>1.0e20),adms_ternary_op<AdmsSensFadType>((NEFFAC_i<1.0e26),NEFFAC_i,1.0e26),1.0e20);
    instanceVar_qq = 0.0;
    if ((modelVar_QMC_i>0.0))
    {
      {
        AdmsSensFadType value_pow_0 = pow(CoxPrime,6.6666666666666667e-01);
        instanceVar_qq = (((0.4*5.951993)*modelVar_QMC_i)*value_pow_0);
      }
      if ((modelVar_CHNL_TYPE==(-1)))
      {
        instanceVar_qq = ((7.448711/5.951993)*instanceVar_qq);
      }
    }
    instanceVar_E_eff0 = ((1.0e-8*CoxPrime)/modelVar_EPSSI);
    instanceVar_eta_mu = (0.5*FETA_i);
    instanceVar_eta_mu1 = 0.5;
    if ((modelVar_CHNL_TYPE==(-1)))
    {
      instanceVar_eta_mu = (3.3333333333333333e-01*FETA_i);
      instanceVar_eta_mu1 = 3.3333333333333333e-01;
    }
    instanceVar_inv_AX = (1.0/instanceVar_AX_i);
    instanceVar_inv_VP = (1.0/VP_i);
    CoxovPrime = (EPSOX/TOXOV_i);
    CoxovPrime_d = (EPSOX/TOXOVD_i);
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NOV_i)*modelVar_EPSSI)*modelVar_inv_phita));
      instanceVar_GOV_s = (value_sqrt_0/CoxovPrime);
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NOVD_i)*modelVar_EPSSI)*modelVar_inv_phita));
      instanceVar_GOV_d = (value_sqrt_0/CoxovPrime_d);
    }
    instanceVar_GOV2_s = (instanceVar_GOV_s*instanceVar_GOV_s);
    instanceVar_GOV2_d = (instanceVar_GOV_d*instanceVar_GOV_d);
    inv_GOV = (1.0/instanceVar_GOV_s);
    SP_OV_eps = ((3.1*instanceVar_GOV_s)+8.5);
    instanceVar_SP_OV_eps2_s = (SP_OV_eps*SP_OV_eps);
    SP_OV_delta = (0.5*SP_OV_eps);
    if ((inv_GOV<0.06))
    {
      instanceVar_SP_OV_a_s = (64.0*inv_GOV);
    }
    else
    {
      if ((inv_GOV<=0.45))
      {
        instanceVar_SP_OV_a_s = ((22.0*inv_GOV)+3.0);
      }
      else
      {
        if ((inv_GOV<=1.6))
        {
          instanceVar_SP_OV_a_s = (((-7.2)*inv_GOV)+15.5);
        }
        else
        {
          instanceVar_SP_OV_a_s = instanceVar_GOV_s;
        }
      }
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((SP_OV_delta+(instanceVar_GOV2_s*0.25))+instanceVar_SP_OV_a_s));
      instanceVar_SP_OV_delta1_s = ((SP_OV_delta+(instanceVar_GOV2_s*0.5))-(instanceVar_GOV_s*value_sqrt_0));
    }
    inv_GOV = (1.0/instanceVar_GOV_d);
    SP_OV_eps = ((3.1*instanceVar_GOV_d)+8.5);
    instanceVar_SP_OV_eps2_d = (SP_OV_eps*SP_OV_eps);
    SP_OV_delta = (0.5*SP_OV_eps);
    if ((inv_GOV<0.06))
    {
      instanceVar_SP_OV_a_d = (64.0*inv_GOV);
    }
    else
    {
      if ((inv_GOV<=0.45))
      {
        instanceVar_SP_OV_a_d = ((22.0*inv_GOV)+3.0);
      }
      else
      {
        if ((inv_GOV<=1.6))
        {
          instanceVar_SP_OV_a_d = (((-7.2)*inv_GOV)+15.5);
        }
        else
        {
          instanceVar_SP_OV_a_d = instanceVar_GOV_d;
        }
      }
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((SP_OV_delta+(instanceVar_GOV2_d*0.25))+instanceVar_SP_OV_a_d));
      instanceVar_SP_OV_delta1_d = ((SP_OV_delta+(instanceVar_GOV2_d*0.5))-(instanceVar_GOV_d*value_sqrt_0));
    }
    instanceVar_phit0 = (modelVar_phit*(1.0+(CT_i*modelVar_rTn)));
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_phibFac,(-0.75));
      AdmsSensFadType value_log_1 = log(((NEFF_i*value_pow_0)*4.0e-26));
      instanceVar_phib_dc = ((modelVar_Eg+DPHIB_i)+((2.0*modelVar_phit)*value_log_1));
    }
    instanceVar_phib_dc = adms_ternary_op<AdmsSensFadType>((instanceVar_phib_dc>5.0E-2),instanceVar_phib_dc,5.0E-2);
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NEFF_i)*modelVar_EPSSI)*modelVar_inv_phit));
      instanceVar_G_0_dc = (value_sqrt_0/CoxPrime);
    }
    instanceVar_kp = 0.0;
    np = 0.0;
    if ((NP_i>0.0))
    {
      arg2max = (8.0e7/tox_sq);
      np = adms_ternary_op<AdmsSensFadType>((NP_i>arg2max),NP_i,arg2max);
      np = adms_ternary_op<AdmsSensFadType>((5.0e24>np),5.0e24,np);
      instanceVar_kp = ((((2.0*CoxPrime)*CoxPrime)*modelVar_phit)/((1.6021918E-19*np)*modelVar_EPSSI));
    }
    instanceVar_qlim2 = ((100.0*modelVar_phit)*modelVar_phit);
    if ((modelVar_QMC_i>0.0))
    {
      {
        AdmsSensFadType value_sqrt_0 = sqrt((((modelVar_phit*instanceVar_G_0_dc)*instanceVar_G_0_dc)*instanceVar_phib_dc));
        qb0 = value_sqrt_0;
      }
      {
        AdmsSensFadType value_pow_0 = pow(qb0,6.6666666666666667e-01);
        dphibq = ((0.75*instanceVar_qq)*value_pow_0);
      }
      instanceVar_phib_dc = (instanceVar_phib_dc+dphibq);
      instanceVar_G_0_dc = (instanceVar_G_0_dc*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(instanceVar_phib_dc);
      instanceVar_sqrt_phib_dc = value_sqrt_0;
    }
    instanceVar_phix_dc = (0.95*instanceVar_phib_dc);
    instanceVar_aphi_dc = ((0.0025*instanceVar_phib_dc)*instanceVar_phib_dc);
    instanceVar_bphi_dc = instanceVar_aphi_dc;
    {
      AdmsSensFadType value_sqrt_0 = sqrt(instanceVar_bphi_dc);
      phix2 = (0.5*value_sqrt_0);
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((instanceVar_phix_dc-phix2))*((instanceVar_phix_dc-phix2)))+instanceVar_aphi_dc));
      instanceVar_phix1_dc = (0.5*(((instanceVar_phix_dc-phix2))-value_sqrt_0));
    }
    instanceVar_alpha_b = (0.5*(instanceVar_phib_dc+modelVar_Eg));
    {
      AdmsSensFadType value_sqrt_0 = sqrt((VSBNUD_i+instanceVar_phib_dc));
      instanceVar_us1 = (value_sqrt_0-instanceVar_sqrt_phib_dc);
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((VSBNUD_i+DVSBNUD_i)+instanceVar_phib_dc));
      instanceVar_us21 = ((value_sqrt_0-instanceVar_sqrt_phib_dc)-instanceVar_us1);
    }
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_phibFac,(-0.75));
      AdmsSensFadType value_log_1 = log(((NEFFAC_i*value_pow_0)*4.0e-26));
      instanceVar_phib_ac = (((modelVar_Eg+DPHIB_i)+DELVTAC_i)+((2.0*modelVar_phit)*value_log_1));
    }
    instanceVar_phib_ac = adms_ternary_op<AdmsSensFadType>((instanceVar_phib_ac>5.0E-2),instanceVar_phib_ac,5.0E-2);
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NEFFAC_i)*modelVar_EPSSI)*modelVar_inv_phit));
      instanceVar_G_0_ac = (value_sqrt_0/CoxPrime);
    }
    if ((modelVar_QMC_i>0.0))
    {
      {
        AdmsSensFadType value_sqrt_0 = sqrt((((modelVar_phit*instanceVar_G_0_ac)*instanceVar_G_0_ac)*instanceVar_phib_ac));
        qb0 = value_sqrt_0;
      }
      {
        AdmsSensFadType value_pow_0 = pow(qb0,6.6666666666666667e-01);
        dphibq = ((0.75*instanceVar_qq)*value_pow_0);
      }
      instanceVar_phib_ac = (instanceVar_phib_ac+dphibq);
      instanceVar_G_0_ac = (instanceVar_G_0_ac*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
    }
    instanceVar_phix_ac = (0.95*instanceVar_phib_ac);
    instanceVar_aphi_ac = ((0.0025*instanceVar_phib_ac)*instanceVar_phib_ac);
    instanceVar_bphi_ac = instanceVar_aphi_ac;
    {
      AdmsSensFadType value_sqrt_0 = sqrt(instanceVar_bphi_ac);
      phix2 = (0.5*value_sqrt_0);
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((instanceVar_phix_ac-phix2))*((instanceVar_phix_ac-phix2)))+instanceVar_aphi_ac));
      instanceVar_phix1_ac = (0.5*(((instanceVar_phix_ac-phix2))-value_sqrt_0));
    }
    instanceVar_VFB_T = ((VFB_i+(STVFB_i*modelVar_delT))+DELVTO_i);
    {
      AdmsSensFadType value_exp_0 = exp((STBET_i*modelVar_ln_rTn));
      tf_bet = value_exp_0;
    }
    BETN_T = (BETN_i*tf_bet);
    instanceVar_BET_i = ((FACTUO_i*BETN_T)*CoxPrime);
    {
      AdmsSensFadType value_exp_0 = exp((STTHEMU_i*modelVar_ln_rTn));
      instanceVar_THEMU_T = (THEMU_i*value_exp_0);
    }
    {
      AdmsSensFadType value_exp_0 = exp((STMUE_i*modelVar_ln_rTn));
      tf_mue = value_exp_0;
    }
    instanceVar_MUE_T = (MUE_i*tf_mue);
    {
      AdmsSensFadType value_exp_0 = exp((STCS_i*modelVar_ln_rTn));
      tf_cs = value_exp_0;
    }
    instanceVar_CS_T = (CS_i*tf_cs);
    {
      AdmsSensFadType value_exp_0 = exp((STXCOR_i*modelVar_ln_rTn));
      tf_xcor = value_exp_0;
    }
    instanceVar_XCOR_T = (XCOR_i*tf_xcor);
    {
      AdmsSensFadType value_exp_0 = exp((STRS_i*modelVar_ln_rTn));
      tf_ther = value_exp_0;
    }
    RS_T = (RS_i*tf_ther);
    instanceVar_THER_i = ((2.0*instanceVar_BET_i)*RS_T);
    {
      AdmsSensFadType value_exp_0 = exp((STTHESAT_i*modelVar_ln_rTn));
      tf_thesat = value_exp_0;
    }
    instanceVar_THESAT_T = (THESAT_i*tf_thesat);
    {
      AdmsSensFadType value_exp_0 = exp(((-STA2_i)*modelVar_ln_rTn));
      instanceVar_A2_T = (A2_i*value_exp_0);
    }
    instanceVar_nt = (((FNT_i*4.0)*1.3806505E-23)*modelVar_TKD);
    instanceVar_Sfl_prefac = (((modelVar_phit*modelVar_phit)*instanceVar_BET_i)/instanceVar_Cox_over_q);
    if (((modelVar_SWEDGE_i!=0.0)&&(instanceVar_BETNEDGE_i>0.0)))
    {
      instanceVar_VFBEDGE_T = ((VFBEDGE_i+(STVFBEDGE_i*modelVar_delT))+DELVTOEDGE_i);
      {
        AdmsSensFadType value_exp_0 = exp((STBETEDGE_i*modelVar_ln_rTn));
        tf_betedge = value_exp_0;
      }
      BETNEDGE_T = (instanceVar_BETNEDGE_i*tf_betedge);
      instanceVar_BETEDGE_i = ((FACTUOEDGE_i*BETNEDGE_T)*CoxPrime);
      instanceVar_phit0edge = (modelVar_phit*(1.0+(CTEDGE_i*modelVar_rTn)));
      {
        AdmsSensFadType value_pow_0 = pow(modelVar_phibFac,(-0.75));
        AdmsSensFadType value_log_1 = log(((NEFFEDGE_i*value_pow_0)*4.0e-26));
        instanceVar_phibedge = ((modelVar_Eg+DPHIBEDGE_i)+((2.0*instanceVar_phit0edge)*value_log_1));
      }
      instanceVar_phibedge = adms_ternary_op<AdmsSensFadType>((instanceVar_phibedge>5.0E-2),instanceVar_phibedge,5.0E-2);
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NEFFEDGE_i)*modelVar_EPSSI)*modelVar_inv_phit));
        instanceVar_Gfedge = (value_sqrt_0/CoxPrime);
      }
      instanceVar_Gfedge2 = (instanceVar_Gfedge*instanceVar_Gfedge);
      {
        AdmsSensFadType value_log_0 = log(instanceVar_Gfedge2);
        instanceVar_lnGfedge2 = value_log_0;
      }
      instanceVar_phixedge = (0.95*instanceVar_phibedge);
      instanceVar_aphiedge = ((0.0025*instanceVar_phibedge)*instanceVar_phibedge);
      instanceVar_bphiedge = instanceVar_aphiedge;
      {
        AdmsSensFadType value_sqrt_0 = sqrt(instanceVar_bphiedge);
        phix2edge = (0.5*value_sqrt_0);
      }
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((((instanceVar_phixedge-phix2edge))*((instanceVar_phixedge-phix2edge)))+instanceVar_aphiedge));
        instanceVar_phix1edge = (0.5*(((instanceVar_phixedge-phix2edge))-value_sqrt_0));
      }
      instanceVar_Sfl_prefac_edge = (((modelVar_phit*modelVar_phit)*instanceVar_BETEDGE_i)/instanceVar_Cox_over_q);
      instanceVar_ntedge = (((FNTEDGE_i*4.0)*1.3806505E-23)*modelVar_TKD);
    }
    else
    {
      instanceVar_VFBEDGE_T = 0.0;
      tf_betedge = 1.0;
      BETNEDGE_T = 0.0;
      instanceVar_BETEDGE_i = 0.0;
      instanceVar_phit0edge = modelVar_phit;
      instanceVar_phibedge = 0.0;
      instanceVar_Gfedge = 1.0;
      instanceVar_Gfedge2 = 1.0;
      instanceVar_lnGfedge2 = 0.0;
      instanceVar_phixedge = 0.0;
      instanceVar_aphiedge = 0.0;
      instanceVar_bphiedge = 0.0;
      phix2edge = 0.0;
      instanceVar_phix1edge = 0.0;
      instanceVar_Sfl_prefac_edge = 0.0;
      instanceVar_ntedge = 1.0;
    }
    instanceVar_inv_CHIB = (1.0/instanceVar_CHIB_i);
    {
      AdmsSensFadType value_sqrt_0 = sqrt((((2.0*1.6021918E-19)*9.1093826E-31)*instanceVar_CHIB_i));
      B_fact = (((4.0*3.3333333333333333e-01)*value_sqrt_0)/1.05457168E-34);
    }
    instanceVar_BCH = (B_fact*TOX_i);
    instanceVar_BOV = (B_fact*TOXOV_i);
    instanceVar_BOV_d = (B_fact*TOXOVD_i);
    instanceVar_GCQ = 0.0;
    if ((instanceVar_GC3_i<0))
    {
      instanceVar_GCQ = (((-0.495)*instanceVar_GC2_i)/instanceVar_GC3_i);
    }
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_rTa,STIG_i);
      tf_ig = value_pow_0;
    }
    instanceVar_IGINV_i = (instanceVar_IGINV_i*tf_ig);
    instanceVar_IGOV_i = (instanceVar_IGOV_i*tf_ig);
    instanceVar_IGOVD_i = (instanceVar_IGOVD_i*tf_ig);
    instanceVar_AGIDLs = ((instanceVar_AGIDL_i*4.0e-18)/(TOXOV_i*TOXOV_i));
    instanceVar_AGIDLDs = ((instanceVar_AGIDLD_i*4.0e-18)/(TOXOVD_i*TOXOVD_i));
    B_fact = adms_ternary_op<AdmsSensFadType>(((1.0+(STBGIDL_i*modelVar_delTa))>0.0),(1.0+(STBGIDL_i*modelVar_delTa)),0.0);
    BGIDL_T = (BGIDL_i*B_fact);
    instanceVar_BGIDLs = ((BGIDL_T*TOXOV_i)*5.0e8);
    B_fact = adms_ternary_op<AdmsSensFadType>(((1.0+(STBGIDLD_i*modelVar_delTa))>0.0),(1.0+(STBGIDLD_i*modelVar_delTa)),0.0);
    BGIDLD_T = (BGIDLD_i*B_fact);
    instanceVar_BGIDLDs = ((BGIDLD_T*TOXOVD_i)*5.0e8);
    instanceVar_fac_exc = ((9.1093826E-31*1.0e9)*instanceVar_FNTEXC_i);
    if ((instanceVar_RG_i>0.0))
    {
      instanceVar_ggate = (1.0/instanceVar_RG_i);
    }
    else
    {
      instanceVar_ggate = 0.0;
    }
    if ((instanceVar_RSE_i>0.0))
    {
      instanceVar_gsource = (1.0/instanceVar_RSE_i);
    }
    else
    {
      instanceVar_gsource = 0.0;
    }
    if ((instanceVar_RDE_i>0.0))
    {
      instanceVar_gdrain = (1.0/instanceVar_RDE_i);
    }
    else
    {
      instanceVar_gdrain = 0.0;
    }
    if ((instanceVar_RBULK_i>0.0))
    {
      instanceVar_gbulk = (1.0/instanceVar_RBULK_i);
    }
    else
    {
      instanceVar_gbulk = 0.0;
    }
    if ((instanceVar_RJUNS_i>0.0))
    {
      instanceVar_gjuns = (1.0/instanceVar_RJUNS_i);
    }
    else
    {
      instanceVar_gjuns = 0.0;
    }
    if ((instanceVar_RJUND_i>0.0))
    {
      instanceVar_gjund = (1.0/instanceVar_RJUND_i);
    }
    else
    {
      instanceVar_gjund = 0.0;
    }
    if ((instanceVar_RWELL_i>0.0))
    {
      instanceVar_gwell = (1.0/instanceVar_RWELL_i);
    }
    else
    {
      instanceVar_gwell = 0.0;
    }
    ABS_i = 0.0;
    LSS_i = 0.0;
    LGS_i = 0.0;
    ABD_i = 0.0;
    LSD_i = 0.0;
    LGD_i = 0.0;
    jwcorr = 0.0;
    jww = WE;
    if ((modelVar_SWGEO_i==0))
    {
      jww = adms_ternary_op<AdmsSensFadType>((JW_i>0.0),JW_i,0.0);
    }
    if ((modelVar_SWJUNCAP_i==3))
    {
      jwcorr = 1.0;
    }
    ABS_i = (instanceVar_ABSOURCE_i*invNF);
    LSS_i = (instanceVar_LSSOURCE_i*invNF);
    LGS_i = (instanceVar_LGSOURCE_i*invNF);
    ABD_i = (instanceVar_ABDRAIN_i*invNF);
    LSD_i = (instanceVar_LSDRAIN_i*invNF);
    LGD_i = (instanceVar_LGDRAIN_i*invNF);
    if (((modelVar_SWJUNCAP_i==2)||(modelVar_SWJUNCAP_i==3)))
    {
      ABS_i = (AS_i*invNF);
      LSS_i = ((PS_i*invNF)-(jwcorr*jww));
      LGS_i = jww;
      ABD_i = (AD_i*invNF);
      LSD_i = ((PD_i*invNF)-(jwcorr*jww));
      LGD_i = jww;
    }
    if ((((modelVar_SWJUNCAP_i==1)||(modelVar_SWJUNCAP_i==2))||(modelVar_SWJUNCAP_i==3)))
    {
      instanceVar_ABSOURCE_i = adms_ternary_op<AdmsSensFadType>((ABS_i>0.0),ABS_i,0.0);
      instanceVar_LSSOURCE_i = adms_ternary_op<AdmsSensFadType>((LSS_i>0.0),LSS_i,0.0);
      instanceVar_LGSOURCE_i = adms_ternary_op<AdmsSensFadType>((LGS_i>0.0),LGS_i,0.0);
      instanceVar_ABDRAIN_i = adms_ternary_op<AdmsSensFadType>((ABD_i>0.0),ABD_i,0.0);
      instanceVar_LSDRAIN_i = adms_ternary_op<AdmsSensFadType>((LSD_i>0.0),LSD_i,0.0);
      instanceVar_LGDRAIN_i = adms_ternary_op<AdmsSensFadType>((LGD_i>0.0),LGD_i,0.0);
    }
    else
    {
      instanceVar_ABSOURCE_i = 0.0;
      instanceVar_LSSOURCE_i = 0.0;
      instanceVar_LGSOURCE_i = 0.0;
      instanceVar_ABDRAIN_i = 0.0;
      instanceVar_LSDRAIN_i = 0.0;
      instanceVar_LGDRAIN_i = 0.0;
    }
    instanceVar_vbimin_s = 0.0;
    instanceVar_vbimin_d = 0.0;
    instanceVar_vfmin_s = 0.0;
    instanceVar_vfmin_d = 0.0;
    instanceVar_vch_s = 0.0;
    instanceVar_vch_d = 0.0;
    instanceVar_vbbtlim_s = 0.0;
    instanceVar_vbbtlim_d = 0.0;
    instanceVar_VMAX_s = 0.0;
    instanceVar_VMAX_d = 0.0;
    instanceVar_exp_VMAX_over_phitd_s = 0.0;
    instanceVar_exp_VMAX_over_phitd_d = 0.0;
    instanceVar_ISATFOR1_s = 0.0;
    instanceVar_ISATFOR1_d = 0.0;
    instanceVar_MFOR1_s = 1.0;
    instanceVar_MFOR1_d = 1.0;
    instanceVar_ISATFOR2_s = 0.0;
    instanceVar_ISATFOR2_d = 0.0;
    instanceVar_MFOR2_s = 1.0;
    instanceVar_MFOR2_d = 1.0;
    instanceVar_ISATREV_s = 0.0;
    instanceVar_ISATREV_d = 0.0;
    instanceVar_MREV_s = 1.0;
    instanceVar_MREV_d = 1.0;
    instanceVar_m0flag_s = 0.0;
    instanceVar_m0flag_d = 0.0;
    instanceVar_xhighf1_s = 0.0;
    instanceVar_xhighf1_d = 0.0;
    instanceVar_expxhf1_s = 0.0;
    instanceVar_expxhf1_d = 0.0;
    instanceVar_xhighf2_s = 0.0;
    instanceVar_xhighf2_d = 0.0;
    instanceVar_expxhf2_s = 0.0;
    instanceVar_expxhf2_d = 0.0;
    instanceVar_xhighr_s = 0.0;
    instanceVar_xhighr_d = 0.0;
    instanceVar_expxhr_s = 0.0;
    instanceVar_expxhr_d = 0.0;
    instanceVar_zflagbot_s = 1.0;
    instanceVar_zflagbot_d = 1.0;
    instanceVar_zflagsti_s = 1.0;
    instanceVar_zflagsti_d = 1.0;
    instanceVar_zflaggat_s = 1.0;
    instanceVar_zflaggat_d = 1.0;
    m0_rev = 0.0;
    mcor_rev = 0.0;
    I1_cor = 0.0;
    I2_cor = 0.0;
    I3_cor = 0.0;
    I4_cor = 0.0;
    I5_cor = 0.0;
    tt0 = 0.0;
    tt1 = 0.0;
    tt2 = 0.0;
    zfrac = 0.0;
    alphaje = 0.0;
    if ((modelVar_SWJUNCAP_i>0))
    {
      if (((modelVar_idsatbot*instanceVar_ABSOURCE_i)>0.0))
      {
        {
          AdmsSensFadType value_log_0 = log(((modelVar_IMAX_i/(modelVar_idsatbot*instanceVar_ABSOURCE_i))+1.0));
          vmaxbot = (modelVar_phitd*value_log_0);
        }
      }
      else
      {
        vmaxbot = 1.0e8;
      }
      if (((modelVar_idsatsti*instanceVar_LSSOURCE_i)>0.0))
      {
        {
          AdmsSensFadType value_log_0 = log(((modelVar_IMAX_i/(modelVar_idsatsti*instanceVar_LSSOURCE_i))+1.0));
          vmaxsti = (modelVar_phitd*value_log_0);
        }
      }
      else
      {
        vmaxsti = 1.0e8;
      }
      if (((modelVar_idsatgat*instanceVar_LGSOURCE_i)>0.0))
      {
        {
          AdmsSensFadType value_log_0 = log(((modelVar_IMAX_i/(modelVar_idsatgat*instanceVar_LGSOURCE_i))+1.0));
          vmaxgat = (modelVar_phitd*value_log_0);
        }
      }
      else
      {
        vmaxgat = 1.0e8;
      }
      {
        AdmsSensFadType value_min_0 = min(vmaxbot,vmaxsti);
        AdmsSensFadType value_min_1 = min(value_min_0,vmaxgat);
        instanceVar_VMAX_s = value_min_1;
      }
      if ((fabs((instanceVar_VMAX_s*modelVar_phitdinv))<2.3025850929940458e+02))
      {
        {
          AdmsSensFadType value_exp_0 = exp((instanceVar_VMAX_s*modelVar_phitdinv));
          instanceVar_exp_VMAX_over_phitd_s = value_exp_0;
        }
      }
      else
      {
        if (((instanceVar_VMAX_s*modelVar_phitdinv)<0.0))
        {
          instanceVar_exp_VMAX_over_phitd_s = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(instanceVar_VMAX_s*modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceVar_VMAX_s*modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceVar_VMAX_s*modelVar_phitdinv))*3.3333333333333333e-01))))))));
        }
        else
        {
          instanceVar_exp_VMAX_over_phitd_s = (1.0e100*(1.0+(((instanceVar_VMAX_s*modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(0.5*(((instanceVar_VMAX_s*modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceVar_VMAX_s*modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
        }
      }
      vbibot2 = modelVar_vbibot;
      vbisti2 = modelVar_vbisti;
      vbigat2 = modelVar_vbigat;
      pbot2 = modelVar_PBOT_i;
      psti2 = modelVar_PSTI_i;
      pgat2 = modelVar_PGAT_i;
      vbibot2r = modelVar_VBIRBOT_i;
      vbisti2r = modelVar_VBIRSTI_i;
      vbigat2r = modelVar_VBIRGAT_i;
      if ((instanceVar_ABSOURCE_i==0.0))
      {
        vbibot2 = (modelVar_vbisti+modelVar_vbigat);
        {
          AdmsSensFadType value_min_0 = min(modelVar_PSTI_i,modelVar_PGAT_i);
          pbot2 = (0.9*value_min_0);
        }
        vbibot2r = (modelVar_VBIRSTI_i+modelVar_VBIRGAT_i);
      }
      if ((instanceVar_LSSOURCE_i==0.0))
      {
        vbisti2 = (modelVar_vbibot+modelVar_vbigat);
        {
          AdmsSensFadType value_min_0 = min(modelVar_PBOT_i,modelVar_PGAT_i);
          psti2 = (0.9*value_min_0);
        }
        vbisti2r = (modelVar_VBIRBOT_i+modelVar_VBIRGAT_i);
      }
      if ((instanceVar_LGSOURCE_i==0.0))
      {
        vbigat2 = (modelVar_vbibot+modelVar_vbisti);
        {
          AdmsSensFadType value_min_0 = min(modelVar_PBOT_i,modelVar_PSTI_i);
          pgat2 = (0.9*value_min_0);
        }
        vbigat2r = (modelVar_VBIRBOT_i+modelVar_VBIRSTI_i);
      }
      {
        AdmsSensFadType value_min_0 = min(vbibot2,vbisti2);
        AdmsSensFadType value_min_1 = min(value_min_0,vbigat2);
        instanceVar_vbimin_s = value_min_1;
      }
      instanceVar_vch_s = (instanceVar_vbimin_s*0.1);
      {
        AdmsSensFadType value_max_0 = max(pbot2,psti2);
        AdmsSensFadType value_max_1 = max(value_max_0,pgat2);
        pmax = value_max_1;
      }
      {
        AdmsSensFadType value_pow_0 = pow(2.0,((-1.0)/pmax));
        instanceVar_vfmin_s = (instanceVar_vbimin_s*(1.0-value_pow_0));
      }
      {
        AdmsSensFadType value_min_0 = min(vbibot2r,vbisti2r);
        AdmsSensFadType value_min_1 = min(value_min_0,vbigat2r);
        instanceVar_vbbtlim_s = (value_min_1-5.0e-2);
      }
      if (((modelVar_idsatbot_d*instanceVar_ABDRAIN_i)>0.0))
      {
        {
          AdmsSensFadType value_log_0 = log(((modelVar_IMAX_i/(modelVar_idsatbot_d*instanceVar_ABDRAIN_i))+1.0));
          vmaxbot = (modelVar_phitd*value_log_0);
        }
      }
      else
      {
        vmaxbot = 1.0e8;
      }
      if (((modelVar_idsatsti_d*instanceVar_LSDRAIN_i)>0.0))
      {
        {
          AdmsSensFadType value_log_0 = log(((modelVar_IMAX_i/(modelVar_idsatsti_d*instanceVar_LSDRAIN_i))+1.0));
          vmaxsti = (modelVar_phitd*value_log_0);
        }
      }
      else
      {
        vmaxsti = 1.0e8;
      }
      if (((modelVar_idsatgat_d*instanceVar_LGDRAIN_i)>0.0))
      {
        {
          AdmsSensFadType value_log_0 = log(((modelVar_IMAX_i/(modelVar_idsatgat_d*instanceVar_LGDRAIN_i))+1.0));
          vmaxgat = (modelVar_phitd*value_log_0);
        }
      }
      else
      {
        vmaxgat = 1.0e8;
      }
      {
        AdmsSensFadType value_min_0 = min(vmaxbot,vmaxsti);
        AdmsSensFadType value_min_1 = min(value_min_0,vmaxgat);
        instanceVar_VMAX_d = value_min_1;
      }
      if ((fabs((instanceVar_VMAX_d*modelVar_phitdinv))<2.3025850929940458e+02))
      {
        {
          AdmsSensFadType value_exp_0 = exp((instanceVar_VMAX_d*modelVar_phitdinv));
          instanceVar_exp_VMAX_over_phitd_d = value_exp_0;
        }
      }
      else
      {
        if (((instanceVar_VMAX_d*modelVar_phitdinv)<0.0))
        {
          instanceVar_exp_VMAX_over_phitd_d = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(instanceVar_VMAX_d*modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceVar_VMAX_d*modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceVar_VMAX_d*modelVar_phitdinv))*3.3333333333333333e-01))))))));
        }
        else
        {
          instanceVar_exp_VMAX_over_phitd_d = (1.0e100*(1.0+(((instanceVar_VMAX_d*modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(0.5*(((instanceVar_VMAX_d*modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceVar_VMAX_d*modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
        }
      }
      vbibot2 = modelVar_vbibot_d;
      vbisti2 = modelVar_vbisti_d;
      vbigat2 = modelVar_vbigat_d;
      pbot2 = modelVar_PBOTD_i;
      psti2 = modelVar_PSTID_i;
      pgat2 = modelVar_PGATD_i;
      vbibot2r = modelVar_VBIRBOTD_i;
      vbisti2r = modelVar_VBIRSTID_i;
      vbigat2r = modelVar_VBIRGATD_i;
      if ((instanceVar_ABDRAIN_i==0.0))
      {
        vbibot2 = (modelVar_vbisti_d+modelVar_vbigat_d);
        {
          AdmsSensFadType value_min_0 = min(modelVar_PSTID_i,modelVar_PGATD_i);
          pbot2 = (0.9*value_min_0);
        }
        vbibot2r = (modelVar_VBIRSTID_i+modelVar_VBIRGATD_i);
      }
      if ((instanceVar_LSDRAIN_i==0.0))
      {
        vbisti2 = (modelVar_vbibot_d+modelVar_vbigat_d);
        {
          AdmsSensFadType value_min_0 = min(modelVar_PBOTD_i,modelVar_PGATD_i);
          psti2 = (0.9*value_min_0);
        }
        vbisti2r = (modelVar_VBIRBOTD_i+modelVar_VBIRGATD_i);
      }
      if ((instanceVar_LGDRAIN_i==0.0))
      {
        vbigat2 = (modelVar_vbibot_d+modelVar_vbisti_d);
        {
          AdmsSensFadType value_min_0 = min(modelVar_PBOTD_i,modelVar_PSTID_i);
          pgat2 = (0.9*value_min_0);
        }
        vbigat2r = (modelVar_VBIRBOTD_i+modelVar_VBIRSTID_i);
      }
      {
        AdmsSensFadType value_min_0 = min(vbibot2,vbisti2);
        AdmsSensFadType value_min_1 = min(value_min_0,vbigat2);
        instanceVar_vbimin_d = value_min_1;
      }
      instanceVar_vch_d = (instanceVar_vbimin_d*0.1);
      {
        AdmsSensFadType value_max_0 = std::max(pbot2,psti2);
        AdmsSensFadType value_max_1 = std::max(value_max_0,pgat2);
        pmax = value_max_1;
      }
      {
        AdmsSensFadType value_pow_0 = pow(2.0,((-1.0)/pmax));
        instanceVar_vfmin_d = (instanceVar_vbimin_d*(1.0-value_pow_0));
      }
      {
        AdmsSensFadType value_min_0 = min(vbibot2r,vbisti2r);
        AdmsSensFadType value_min_1 = min(value_min_0,vbigat2r);
        instanceVar_vbbtlim_d = (value_min_1-5.0e-2);
      }
      if ((modelVar_SWJUNEXP_i==1))
        //Begin block JUNCAPexpressInit
      {
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType ysq;
        AdmsSensFadType terfc;
        AdmsSensFadType erfcpos;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType h1;
        AdmsSensFadType h2;
        AdmsSensFadType h2d;
        AdmsSensFadType h3;
        AdmsSensFadType h4;
        AdmsSensFadType h5;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType idmult;
        AdmsSensFadType vj;
        AdmsSensFadType z;
        AdmsSensFadType zinv;
        AdmsSensFadType two_psistar;
        AdmsSensFadType vjlim;
        AdmsSensFadType vjsrh;
        AdmsSensFadType vbbt;
        AdmsSensFadType vav;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType tmp;
        AdmsSensFadType id;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType isrh;
        AdmsSensFadType vbi_minus_vjsrh;
        AdmsSensFadType wsrhstep;
        AdmsSensFadType dwsrh;
        AdmsSensFadType wsrh;
        AdmsSensFadType wdep;
        AdmsSensFadType asrh;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType itat;
        AdmsSensFadType btat;
        AdmsSensFadType twoatatoverthreebtat;
        AdmsSensFadType umaxbeforelimiting;
        AdmsSensFadType umax;
        AdmsSensFadType sqrtumax;
        AdmsSensFadType umaxpoweronepointfive;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType wgamma;
        AdmsSensFadType wtat;
        AdmsSensFadType ktat;
        AdmsSensFadType ltat;
        AdmsSensFadType mtat;
        AdmsSensFadType xerfc;
        AdmsSensFadType erfctimesexpmtat;
        AdmsSensFadType gammamax;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType ibbt;
        AdmsSensFadType Fmaxr;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType fbreakdown;
        //End of Block-local variables
        //Block-local variables for block JUNCAPexpressInit
        AdmsSensFadType ijunbot;
        AdmsSensFadType ijunsti;
        AdmsSensFadType ijungat;
        AdmsSensFadType qjunbot;
        AdmsSensFadType qjunsti;
        AdmsSensFadType qjungat;
        //End of Block-local variables
        ysq = 0.0;
        terfc = 0.0;
        erfcpos = 0.0;
        h1 = 0.0;
        h2 = 0.0;
        h2d = 0.0;
        h3 = 0.0;
        h4 = 0.0;
        h5 = 0.0;
        idmult = 0.0;
        vj = 0.0;
        z = 0.0;
        zinv = 0.0;
        two_psistar = 0.0;
        vjlim = 0.0;
        vjsrh = 0.0;
        vbbt = 0.0;
        vav = 0.0;
        tmp = 0.0;
        id = 0.0;
        isrh = 0.0;
        vbi_minus_vjsrh = 0.0;
        wsrhstep = 0.0;
        dwsrh = 0.0;
        wsrh = 0.0;
        wdep = 0.0;
        asrh = 0.0;
        itat = 0.0;
        btat = 0.0;
        twoatatoverthreebtat = 0.0;
        umaxbeforelimiting = 0.0;
        umax = 0.0;
        sqrtumax = 0.0;
        umaxpoweronepointfive = 0.0;
        wgamma = 0.0;
        wtat = 0.0;
        ktat = 0.0;
        ltat = 0.0;
        mtat = 0.0;
        xerfc = 0.0;
        erfctimesexpmtat = 0.0;
        gammamax = 0.0;
        ibbt = 0.0;
        Fmaxr = 0.0;
        fbreakdown = 0.0;
        qjunbot = 0.0;
        qjunsti = 0.0;
        qjungat = 0.0;
        FRACNA = 0.4;
        FRACNB = 0.65;
        FRACI = 0.8;
        V1 = ((-FRACNA)*modelVar_VJUNREF_i);
        V2 = ((-FRACNB)*modelVar_VJUNREF_i);
        V3 = ((-FRACI)*modelVar_VJUNREF_i);
        V4 = 0.1;
        V5 = 0.2;
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABSOURCE_i==0.0)&&(instanceVar_LSSOURCE_i==0.0))&&(instanceVar_LGSOURCE_i==0.0))))
        {
          h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
          h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
          h2d = (V1+(instanceVar_vch_s*h2));
          h3 = (instanceVar_vfmin_s+h2d);
          h4 = (instanceVar_vfmin_s-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V1*instanceVar_vfmin_s)/(h3+h5)));
          if ((V1<instanceVar_VMAX_s))
          {
            if ((fabs((0.5*(V1*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V1*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V1*modelVar_phitdinv))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V1-instanceVar_VMAX_s)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_s);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V1>0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              AdmsSensFadType value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V1)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_s-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V1-instanceVar_vbbtlim_s)*(V1-instanceVar_vbbtlim_s))+((4.0*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V1+instanceVar_vbbtlim_s)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V1)*(V1))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V1)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABSOURCE_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvbot)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot*(1.0-tmp))+(modelVar_qpref2bot*(V1-vj)));
          id = (modelVar_idsatbot*idmult);
          if (((modelVar_CSRHBOT_i==0.0)&&(modelVar_CTATBOT_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PBOT_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot*tmp);
            asrh = (modelVar_ftdbot*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOT_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOT_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
            if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOT_i*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOT_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRBOT_i)))
            {
              if ((modelVar_PBRBOT_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvbot)*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot+((vav+(modelVar_alphaav*modelVar_VBRBOT_i))*modelVar_slopebot));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSSOURCE_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvsti)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti*(1.0-tmp))+(modelVar_qpref2sti*(V1-vj)));
          id = (modelVar_idsatsti*idmult);
          if (((modelVar_CSRHSTI_i==0.0)&&(modelVar_CTATSTI_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PSTI_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTI_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti*tmp);
            asrh = (modelVar_ftdsti*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTI_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTI_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
            if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTI_i*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTI_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRSTI_i)))
            {
              if ((modelVar_PBRSTI_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvsti)*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTI_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti+((vav+(modelVar_alphaav*modelVar_VBRSTI_i))*modelVar_slopesti));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGSOURCE_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvgat)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat*(1.0-tmp))+(modelVar_qpref2gat*(V1-vj)));
          id = (modelVar_idsatgat*idmult);
          if (((modelVar_CSRHGAT_i==0.0)&&(modelVar_CTATGAT_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PGAT_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGAT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat*tmp);
            asrh = (modelVar_ftdgat*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGAT_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGAT_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
            if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGAT_i*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGAT_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRGAT_i)))
            {
              if ((modelVar_PBRGAT_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvgat)*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGAT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat+((vav+(modelVar_alphaav*modelVar_VBRGAT_i))*modelVar_slopegat));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I1 = (((instanceVar_ABSOURCE_i*ijunbot)+(instanceVar_LSSOURCE_i*ijunsti))+(instanceVar_LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABSOURCE_i==0.0)&&(instanceVar_LSSOURCE_i==0.0))&&(instanceVar_LGSOURCE_i==0.0))))
        {
          h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
          h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
          h2d = (V2+(instanceVar_vch_s*h2));
          h3 = (instanceVar_vfmin_s+h2d);
          h4 = (instanceVar_vfmin_s-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V2*instanceVar_vfmin_s)/(h3+h5)));
          if ((V2<instanceVar_VMAX_s))
          {
            if ((fabs((0.5*(V2*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V2*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V2*modelVar_phitdinv))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V2-instanceVar_VMAX_s)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_s);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V2>0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              AdmsSensFadType value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V2)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_s-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V2-instanceVar_vbbtlim_s)*(V2-instanceVar_vbbtlim_s))+((4.0*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V2+instanceVar_vbbtlim_s)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V2)*(V2))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V2)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABSOURCE_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvbot)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot*(1.0-tmp))+(modelVar_qpref2bot*(V2-vj)));
          id = (modelVar_idsatbot*idmult);
          if (((modelVar_CSRHBOT_i==0.0)&&(modelVar_CTATBOT_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PBOT_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot*tmp);
            asrh = (modelVar_ftdbot*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOT_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOT_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
            if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOT_i*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOT_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRBOT_i)))
            {
              if ((modelVar_PBRBOT_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvbot)*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot+((vav+(modelVar_alphaav*modelVar_VBRBOT_i))*modelVar_slopebot));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSSOURCE_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvsti)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti*(1.0-tmp))+(modelVar_qpref2sti*(V2-vj)));
          id = (modelVar_idsatsti*idmult);
          if (((modelVar_CSRHSTI_i==0.0)&&(modelVar_CTATSTI_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PSTI_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTI_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti*tmp);
            asrh = (modelVar_ftdsti*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTI_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTI_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
            if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTI_i*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTI_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRSTI_i)))
            {
              if ((modelVar_PBRSTI_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvsti)*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTI_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti+((vav+(modelVar_alphaav*modelVar_VBRSTI_i))*modelVar_slopesti));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGSOURCE_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvgat)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat*(1.0-tmp))+(modelVar_qpref2gat*(V2-vj)));
          id = (modelVar_idsatgat*idmult);
          if (((modelVar_CSRHGAT_i==0.0)&&(modelVar_CTATGAT_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PGAT_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGAT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat*tmp);
            asrh = (modelVar_ftdgat*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGAT_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGAT_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
            if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGAT_i*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGAT_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRGAT_i)))
            {
              if ((modelVar_PBRGAT_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvgat)*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGAT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat+((vav+(modelVar_alphaav*modelVar_VBRGAT_i))*modelVar_slopegat));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I2 = (((instanceVar_ABSOURCE_i*ijunbot)+(instanceVar_LSSOURCE_i*ijunsti))+(instanceVar_LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABSOURCE_i==0.0)&&(instanceVar_LSSOURCE_i==0.0))&&(instanceVar_LGSOURCE_i==0.0))))
        {
          h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
          h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
          h2d = (V3+(instanceVar_vch_s*h2));
          h3 = (instanceVar_vfmin_s+h2d);
          h4 = (instanceVar_vfmin_s-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V3*instanceVar_vfmin_s)/(h3+h5)));
          if ((V3<instanceVar_VMAX_s))
          {
            if ((fabs((0.5*(V3*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V3*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V3*modelVar_phitdinv))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V3-instanceVar_VMAX_s)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_s);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V3>0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              AdmsSensFadType value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V3)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_s-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V3-instanceVar_vbbtlim_s)*(V3-instanceVar_vbbtlim_s))+((4.0*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V3+instanceVar_vbbtlim_s)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V3)*(V3))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V3)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABSOURCE_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvbot)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot*(1.0-tmp))+(modelVar_qpref2bot*(V3-vj)));
          id = (modelVar_idsatbot*idmult);
          if (((modelVar_CSRHBOT_i==0.0)&&(modelVar_CTATBOT_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PBOT_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot*tmp);
            asrh = (modelVar_ftdbot*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOT_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOT_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
            if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOT_i*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOT_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRBOT_i)))
            {
              if ((modelVar_PBRBOT_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvbot)*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot+((vav+(modelVar_alphaav*modelVar_VBRBOT_i))*modelVar_slopebot));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSSOURCE_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvsti)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti*(1.0-tmp))+(modelVar_qpref2sti*(V3-vj)));
          id = (modelVar_idsatsti*idmult);
          if (((modelVar_CSRHSTI_i==0.0)&&(modelVar_CTATSTI_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PSTI_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTI_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti*tmp);
            asrh = (modelVar_ftdsti*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTI_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTI_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
            if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTI_i*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTI_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRSTI_i)))
            {
              if ((modelVar_PBRSTI_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvsti)*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTI_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti+((vav+(modelVar_alphaav*modelVar_VBRSTI_i))*modelVar_slopesti));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGSOURCE_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvgat)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat*(1.0-tmp))+(modelVar_qpref2gat*(V3-vj)));
          id = (modelVar_idsatgat*idmult);
          if (((modelVar_CSRHGAT_i==0.0)&&(modelVar_CTATGAT_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PGAT_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGAT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat*tmp);
            asrh = (modelVar_ftdgat*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGAT_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGAT_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
            if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGAT_i*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGAT_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRGAT_i)))
            {
              if ((modelVar_PBRGAT_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvgat)*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGAT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat+((vav+(modelVar_alphaav*modelVar_VBRGAT_i))*modelVar_slopegat));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I3 = (((instanceVar_ABSOURCE_i*ijunbot)+(instanceVar_LSSOURCE_i*ijunsti))+(instanceVar_LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABSOURCE_i==0.0)&&(instanceVar_LSSOURCE_i==0.0))&&(instanceVar_LGSOURCE_i==0.0))))
        {
          h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
          h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
          h2d = (V4+(instanceVar_vch_s*h2));
          h3 = (instanceVar_vfmin_s+h2d);
          h4 = (instanceVar_vfmin_s-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V4*instanceVar_vfmin_s)/(h3+h5)));
          if ((V4<instanceVar_VMAX_s))
          {
            if ((fabs((0.5*(V4*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V4*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V4*modelVar_phitdinv))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V4-instanceVar_VMAX_s)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_s);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V4>0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              AdmsSensFadType value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V4)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_s-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V4-instanceVar_vbbtlim_s)*(V4-instanceVar_vbbtlim_s))+((4.0*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V4+instanceVar_vbbtlim_s)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V4)*(V4))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V4)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABSOURCE_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvbot)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot*(1.0-tmp))+(modelVar_qpref2bot*(V4-vj)));
          id = (modelVar_idsatbot*idmult);
          if (((modelVar_CSRHBOT_i==0.0)&&(modelVar_CTATBOT_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PBOT_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot*tmp);
            asrh = (modelVar_ftdbot*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOT_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOT_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
            if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOT_i*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOT_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRBOT_i)))
            {
              if ((modelVar_PBRBOT_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvbot)*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot+((vav+(modelVar_alphaav*modelVar_VBRBOT_i))*modelVar_slopebot));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSSOURCE_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvsti)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti*(1.0-tmp))+(modelVar_qpref2sti*(V4-vj)));
          id = (modelVar_idsatsti*idmult);
          if (((modelVar_CSRHSTI_i==0.0)&&(modelVar_CTATSTI_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PSTI_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTI_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti*tmp);
            asrh = (modelVar_ftdsti*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTI_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTI_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
            if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTI_i*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTI_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRSTI_i)))
            {
              if ((modelVar_PBRSTI_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvsti)*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTI_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti+((vav+(modelVar_alphaav*modelVar_VBRSTI_i))*modelVar_slopesti));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGSOURCE_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvgat)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat*(1.0-tmp))+(modelVar_qpref2gat*(V4-vj)));
          id = (modelVar_idsatgat*idmult);
          if (((modelVar_CSRHGAT_i==0.0)&&(modelVar_CTATGAT_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PGAT_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGAT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat*tmp);
            asrh = (modelVar_ftdgat*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGAT_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGAT_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
            if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGAT_i*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGAT_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRGAT_i)))
            {
              if ((modelVar_PBRGAT_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvgat)*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGAT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat+((vav+(modelVar_alphaav*modelVar_VBRGAT_i))*modelVar_slopegat));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I4 = (((instanceVar_ABSOURCE_i*ijunbot)+(instanceVar_LSSOURCE_i*ijunsti))+(instanceVar_LGSOURCE_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABSOURCE_i==0.0)&&(instanceVar_LSSOURCE_i==0.0))&&(instanceVar_LGSOURCE_i==0.0))))
        {
          h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
          h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
          h2d = (V5+(instanceVar_vch_s*h2));
          h3 = (instanceVar_vfmin_s+h2d);
          h4 = (instanceVar_vfmin_s-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V5*instanceVar_vfmin_s)/(h3+h5)));
          if ((V5<instanceVar_VMAX_s))
          {
            if ((fabs((0.5*(V5*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V5*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V5*modelVar_phitdinv))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V5-instanceVar_VMAX_s)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_s);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V5>0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              AdmsSensFadType value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V5)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_s-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V5-instanceVar_vbbtlim_s)*(V5-instanceVar_vbbtlim_s))+((4.0*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V5+instanceVar_vbbtlim_s)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V5)*(V5))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V5)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABSOURCE_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvbot)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot*(1.0-tmp))+(modelVar_qpref2bot*(V5-vj)));
          id = (modelVar_idsatbot*idmult);
          if (((modelVar_CSRHBOT_i==0.0)&&(modelVar_CTATBOT_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PBOT_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot*tmp);
            asrh = (modelVar_ftdbot*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOT_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOT_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PBOT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
            if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOT_i*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOT_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRBOT_i)))
            {
              if ((modelVar_PBRBOT_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvbot)*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot+((vav+(modelVar_alphaav*modelVar_VBRBOT_i))*modelVar_slopebot));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSSOURCE_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvsti)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti*(1.0-tmp))+(modelVar_qpref2sti*(V5-vj)));
          id = (modelVar_idsatsti*idmult);
          if (((modelVar_CSRHSTI_i==0.0)&&(modelVar_CTATSTI_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PSTI_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTI_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti*tmp);
            asrh = (modelVar_ftdsti*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTI_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTI_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PSTI_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
            if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTI_i*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTI_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRSTI_i)))
            {
              if ((modelVar_PBRSTI_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvsti)*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTI_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti+((vav+(modelVar_alphaav*modelVar_VBRSTI_i))*modelVar_slopesti));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGSOURCE_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvgat)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat*(1.0-tmp))+(modelVar_qpref2gat*(V5-vj)));
          id = (modelVar_idsatgat*idmult);
          if (((modelVar_CSRHGAT_i==0.0)&&(modelVar_CTATGAT_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PGAT_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGAT_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat*tmp);
            asrh = (modelVar_ftdgat*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGAT_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGAT_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PGAT_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
            if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGAT_i*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGAT_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRGAT_i)))
            {
              if ((modelVar_PBRGAT_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvgat)*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGAT_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat+((vav+(modelVar_alphaav*modelVar_VBRGAT_i))*modelVar_slopegat));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I5 = (((instanceVar_ABSOURCE_i*ijunbot)+(instanceVar_LSSOURCE_i*ijunsti))+(instanceVar_LGSOURCE_i*ijungat));
        instanceVar_ISATFOR1_s = (((instanceVar_ABSOURCE_i*modelVar_idsatbot)+(instanceVar_LSSOURCE_i*modelVar_idsatsti))+(instanceVar_LGSOURCE_i*modelVar_idsatgat));
        {
          AdmsSensFadType value_exp_0 = exp(((V4*modelVar_phitdinv)*instanceVar_MFOR1_s));
          I4_cor = (I4-(instanceVar_ISATFOR1_s*(value_exp_0-1.0)));
        }
        {
          AdmsSensFadType value_exp_0 = exp(((V5*modelVar_phitdinv)*instanceVar_MFOR1_s));
          I5_cor = (I5-(instanceVar_ISATFOR1_s*(value_exp_0-1.0)));
        }
        if ((!(((instanceVar_ABSOURCE_i==0.0)&&(instanceVar_LSSOURCE_i==0.0))&&(instanceVar_LGSOURCE_i==0.0))))
        {
          if (((I4>0.0)&&(I5>0.0)))
          {
            if ((((((I4_cor/I4)>1.0e-3)||((I5_cor/I5)>1.0e-3))&&(I4_cor>0.0))&&(I5_cor>0.0)))
            {
              alphaje = (I4_cor/I5_cor);
              {
                AdmsSensFadType value_log_0 = log(alphaje);
                instanceVar_MFOR2_s = ((modelVar_phitd*value_log_0)/(V4-V5));
              }
              {
                AdmsSensFadType value_exp_0 = exp(((V4*modelVar_phitdinv)*instanceVar_MFOR2_s));
                instanceVar_ISATFOR2_s = (I4_cor/(value_exp_0-1.0));
              }
            }
          }
          {
            AdmsSensFadType value_exp_0 = exp(((V1*modelVar_phitdinv)*instanceVar_MFOR1_s));
            AdmsSensFadType value_exp_1 = exp(((V1*modelVar_phitdinv)*instanceVar_MFOR2_s));
            I1_cor = ((I1-(instanceVar_ISATFOR1_s*(value_exp_0-1.0)))-(instanceVar_ISATFOR2_s*(value_exp_1-1.0)));
          }
          {
            AdmsSensFadType value_exp_0 = exp(((V2*modelVar_phitdinv)*instanceVar_MFOR1_s));
            AdmsSensFadType value_exp_1 = exp(((V2*modelVar_phitdinv)*instanceVar_MFOR2_s));
            I2_cor = ((I2-(instanceVar_ISATFOR1_s*(value_exp_0-1.0)))-(instanceVar_ISATFOR2_s*(value_exp_1-1.0)));
          }
          {
            AdmsSensFadType value_exp_0 = exp(((V3*modelVar_phitdinv)*instanceVar_MFOR1_s));
            AdmsSensFadType value_exp_1 = exp(((V3*modelVar_phitdinv)*instanceVar_MFOR2_s));
            I3_cor = ((I3-(instanceVar_ISATFOR1_s*(value_exp_0-1.0)))-(instanceVar_ISATFOR2_s*(value_exp_1-1.0)));
          }
          if ((((I1<0.0)&&(I2<0.0))&&(I3<0.0)))
          {
            if ((((((((I1_cor/I1)>1.0e-3)||((I2_cor/I2)>1.0e-3))||((I3_cor/I3)>1.0e-3))&&(I1_cor<0.0))&&(I2_cor<0.0))&&(I3_cor<0.0)))
            {
              alphaje = (I1_cor/I2_cor);
              {
                AdmsSensFadType value_log_0 = log(alphaje);
                m0_rev = (((-modelVar_phitd)*value_log_0)/(V1-V2));
              }
              tt0 = (V2/(V2-V1));
              {
                AdmsSensFadType value_pow_0 = pow(alphaje,tt0);
                tt1 = ((modelVar_phitd*(alphaje-1.0))*(value_pow_0-1.0));
              }
              tt0 = (V1/(V1-V2));
              {
                AdmsSensFadType value_pow_0 = pow(alphaje,tt0);
                tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
              }
              mcor_rev = (tt1/tt2);
              instanceVar_MREV_s = (m0_rev+mcor_rev);
              if ((fabs(((V3*modelVar_phitdinv)*instanceVar_MREV_s))<1.0e-6))
              {
                instanceVar_m0flag_s = 1.0;
                instanceVar_ISATREV_s = (I3_cor*((1.0/V3)+((0.5*modelVar_phitdinv)*instanceVar_MREV_s)));
                instanceVar_MREV_s = (((((-0.5)*I3_cor)*instanceVar_MREV_s)*modelVar_phitdinv)/V3);
              }
              else
              {
                instanceVar_m0flag_s = 0.0;
                {
                  AdmsSensFadType value_exp_0 = exp((((-V3)*modelVar_phitdinv)*instanceVar_MREV_s));
                  instanceVar_ISATREV_s = ((-I3_cor)/(value_exp_0-1.0));
                }
              }
            }
          }
        }
        zfrac = (modelVar_FJUNQ_i*(((instanceVar_ABSOURCE_i*modelVar_cjobot)+(instanceVar_LSSOURCE_i*modelVar_cjosti))+(instanceVar_LGSOURCE_i*modelVar_cjogat)));
        if (((instanceVar_ABSOURCE_i*modelVar_cjobot)<=zfrac))
        {
          instanceVar_zflagbot_s = 0.0;
        }
        if (((instanceVar_LSSOURCE_i*modelVar_cjosti)<=zfrac))
        {
          instanceVar_zflagsti_s = 0.0;
        }
        if (((instanceVar_LGSOURCE_i*modelVar_cjogat)<=zfrac))
        {
          instanceVar_zflaggat_s = 0.0;
        }
        if ((!(((instanceVar_ABSOURCE_i==0.0)&&(instanceVar_LSSOURCE_i==0.0))&&(instanceVar_LGSOURCE_i==0.0))))
        {
          {
            AdmsSensFadType value_log_0 = log(((0.5*modelVar_IMAX_i)/(instanceVar_ISATFOR1_s+1.0e-21)));
            instanceVar_xhighf1_s = value_log_0;
          }
          {
            AdmsSensFadType value_log_0 = log(((0.5*modelVar_IMAX_i)/(instanceVar_ISATFOR2_s+1.0e-21)));
            instanceVar_xhighf2_s = value_log_0;
          }
          {
            AdmsSensFadType value_fabs_0 = fabs(instanceVar_ISATREV_s);
            AdmsSensFadType value_log_1 = log(((0.5*modelVar_IMAX_i)/(value_fabs_0+1.0e-21)));
            instanceVar_xhighr_s = value_log_1;
          }
        }
        {
          AdmsSensFadType value_min_0 = std::min(instanceVar_xhighf1_s,static_cast<double>(2.3025850929940458e+02));
          instanceVar_xhighf1_s = value_min_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_xhighf1_s);
          instanceVar_expxhf1_s = value_exp_0;
        }
        {
          AdmsSensFadType value_min_0 = std::min(instanceVar_xhighf2_s,static_cast<double>(2.3025850929940458e+02));
          instanceVar_xhighf2_s = value_min_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_xhighf2_s);
          instanceVar_expxhf2_s = value_exp_0;
        }
        {
          AdmsSensFadType value_min_0 = std::min(instanceVar_xhighr_s,static_cast<double>(2.3025850929940458e+02));
          instanceVar_xhighr_s = value_min_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_xhighr_s);
          instanceVar_expxhr_s = value_exp_0;
        }
        FRACNA = 0.4;
        FRACNB = 0.65;
        FRACI = 0.8;
        V1 = ((-FRACNA)*modelVar_VJUNREFD_i);
        V2 = ((-FRACNB)*modelVar_VJUNREFD_i);
        V3 = ((-FRACI)*modelVar_VJUNREFD_i);
        V4 = 0.1;
        V5 = 0.2;
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABDRAIN_i==0.0)&&(instanceVar_LSDRAIN_i==0.0))&&(instanceVar_LGDRAIN_i==0.0))))
        {
          h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
          h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
          h2d = (V1+(instanceVar_vch_d*h2));
          h3 = (instanceVar_vfmin_d+h2d);
          h4 = (instanceVar_vfmin_d-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V1*instanceVar_vfmin_d)/(h3+h5)));
          if ((V1<instanceVar_VMAX_d))
          {
            if ((fabs((0.5*(V1*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V1*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V1*modelVar_phitdinv))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V1-instanceVar_VMAX_d)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V1>0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              AdmsSensFadType value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V1)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_d-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V1-instanceVar_vbbtlim_d)*(V1-instanceVar_vbbtlim_d))+((4.0*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V1+instanceVar_vbbtlim_d)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V1)*(V1))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V1)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABDRAIN_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvbot_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot_d*(1.0-tmp))+(modelVar_qpref2bot_d*(V1-vj)));
          id = (modelVar_idsatbot_d*idmult);
          if (((modelVar_CSRHBOTD_i==0.0)&&(modelVar_CTATBOTD_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PBOTD_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOTD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot_d*tmp);
            asrh = (modelVar_ftdbot_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHBOTD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOTD_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartbot_d*((wdep*modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOTD_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT_d*(((modelVar_VBIRBOTD_i-vbbt)*modelVar_wdepnulrinvbot_d)/tmp));
            if ((fabs(((-modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOTD_i*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOTD_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRBOTD_i)))
            {
              if ((modelVar_PBRBOTD_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvbot_d)*(vav*modelVar_VBRinvbot_d))*(vav*modelVar_VBRinvbot_d))*(vav*modelVar_VBRinvbot_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOTD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot_d+((vav+(modelVar_alphaav*modelVar_VBRBOTD_i))*modelVar_slopebot_d));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSDRAIN_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvsti_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti_d*(1.0-tmp))+(modelVar_qpref2sti_d*(V1-vj)));
          id = (modelVar_idsatsti_d*idmult);
          if (((modelVar_CSRHSTID_i==0.0)&&(modelVar_CTATSTID_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PSTID_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTID_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti_d*tmp);
            asrh = (modelVar_ftdsti_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHSTID_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTID_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartsti_d*((wdep*modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTID_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI_d*(((modelVar_VBIRSTID_i-vbbt)*modelVar_wdepnulrinvsti_d)/tmp));
            if ((fabs(((-modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTID_i*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTID_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRSTID_i)))
            {
              if ((modelVar_PBRSTID_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvsti_d)*(vav*modelVar_VBRinvsti_d))*(vav*modelVar_VBRinvsti_d))*(vav*modelVar_VBRinvsti_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTID_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti_d+((vav+(modelVar_alphaav*modelVar_VBRSTID_i))*modelVar_slopesti_d));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGDRAIN_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvgat_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat_d*(1.0-tmp))+(modelVar_qpref2gat_d*(V1-vj)));
          id = (modelVar_idsatgat_d*idmult);
          if (((modelVar_CSRHGATD_i==0.0)&&(modelVar_CTATGATD_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PGATD_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGATD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat_d*tmp);
            asrh = (modelVar_ftdgat_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHGATD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGATD_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartgat_d*((wdep*modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGATD_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT_d*(((modelVar_VBIRGATD_i-vbbt)*modelVar_wdepnulrinvgat_d)/tmp));
            if ((fabs(((-modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGATD_i*(((V1*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGATD_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRGATD_i)))
            {
              if ((modelVar_PBRGATD_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvgat_d)*(vav*modelVar_VBRinvgat_d))*(vav*modelVar_VBRinvgat_d))*(vav*modelVar_VBRinvgat_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGATD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat_d+((vav+(modelVar_alphaav*modelVar_VBRGATD_i))*modelVar_slopegat_d));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I1 = (((instanceVar_ABDRAIN_i*ijunbot)+(instanceVar_LSDRAIN_i*ijunsti))+(instanceVar_LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABDRAIN_i==0.0)&&(instanceVar_LSDRAIN_i==0.0))&&(instanceVar_LGDRAIN_i==0.0))))
        {
          h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
          h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
          h2d = (V2+(instanceVar_vch_d*h2));
          h3 = (instanceVar_vfmin_d+h2d);
          h4 = (instanceVar_vfmin_d-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V2*instanceVar_vfmin_d)/(h3+h5)));
          if ((V2<instanceVar_VMAX_d))
          {
            if ((fabs((0.5*(V2*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V2*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V2*modelVar_phitdinv))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V2-instanceVar_VMAX_d)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V2>0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              AdmsSensFadType value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V2)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_d-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V2-instanceVar_vbbtlim_d)*(V2-instanceVar_vbbtlim_d))+((4.0*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V2+instanceVar_vbbtlim_d)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V2)*(V2))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V2)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABDRAIN_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvbot_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot_d*(1.0-tmp))+(modelVar_qpref2bot_d*(V2-vj)));
          id = (modelVar_idsatbot_d*idmult);
          if (((modelVar_CSRHBOTD_i==0.0)&&(modelVar_CTATBOTD_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PBOTD_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOTD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot_d*tmp);
            asrh = (modelVar_ftdbot_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHBOTD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOTD_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartbot_d*((wdep*modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOTD_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT_d*(((modelVar_VBIRBOTD_i-vbbt)*modelVar_wdepnulrinvbot_d)/tmp));
            if ((fabs(((-modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOTD_i*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOTD_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRBOTD_i)))
            {
              if ((modelVar_PBRBOTD_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvbot_d)*(vav*modelVar_VBRinvbot_d))*(vav*modelVar_VBRinvbot_d))*(vav*modelVar_VBRinvbot_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOTD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot_d+((vav+(modelVar_alphaav*modelVar_VBRBOTD_i))*modelVar_slopebot_d));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSDRAIN_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvsti_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti_d*(1.0-tmp))+(modelVar_qpref2sti_d*(V2-vj)));
          id = (modelVar_idsatsti_d*idmult);
          if (((modelVar_CSRHSTID_i==0.0)&&(modelVar_CTATSTID_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PSTID_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTID_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti_d*tmp);
            asrh = (modelVar_ftdsti_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHSTID_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTID_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartsti_d*((wdep*modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTID_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI_d*(((modelVar_VBIRSTID_i-vbbt)*modelVar_wdepnulrinvsti_d)/tmp));
            if ((fabs(((-modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTID_i*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTID_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRSTID_i)))
            {
              if ((modelVar_PBRSTID_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvsti_d)*(vav*modelVar_VBRinvsti_d))*(vav*modelVar_VBRinvsti_d))*(vav*modelVar_VBRinvsti_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTID_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti_d+((vav+(modelVar_alphaav*modelVar_VBRSTID_i))*modelVar_slopesti_d));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGDRAIN_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvgat_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat_d*(1.0-tmp))+(modelVar_qpref2gat_d*(V2-vj)));
          id = (modelVar_idsatgat_d*idmult);
          if (((modelVar_CSRHGATD_i==0.0)&&(modelVar_CTATGATD_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PGATD_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGATD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat_d*tmp);
            asrh = (modelVar_ftdgat_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHGATD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGATD_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartgat_d*((wdep*modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGATD_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT_d*(((modelVar_VBIRGATD_i-vbbt)*modelVar_wdepnulrinvgat_d)/tmp));
            if ((fabs(((-modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGATD_i*(((V2*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGATD_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRGATD_i)))
            {
              if ((modelVar_PBRGATD_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvgat_d)*(vav*modelVar_VBRinvgat_d))*(vav*modelVar_VBRinvgat_d))*(vav*modelVar_VBRinvgat_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGATD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat_d+((vav+(modelVar_alphaav*modelVar_VBRGATD_i))*modelVar_slopegat_d));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I2 = (((instanceVar_ABDRAIN_i*ijunbot)+(instanceVar_LSDRAIN_i*ijunsti))+(instanceVar_LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABDRAIN_i==0.0)&&(instanceVar_LSDRAIN_i==0.0))&&(instanceVar_LGDRAIN_i==0.0))))
        {
          h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
          h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
          h2d = (V3+(instanceVar_vch_d*h2));
          h3 = (instanceVar_vfmin_d+h2d);
          h4 = (instanceVar_vfmin_d-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V3*instanceVar_vfmin_d)/(h3+h5)));
          if ((V3<instanceVar_VMAX_d))
          {
            if ((fabs((0.5*(V3*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V3*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V3*modelVar_phitdinv))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V3-instanceVar_VMAX_d)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V3>0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              AdmsSensFadType value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V3)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_d-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V3-instanceVar_vbbtlim_d)*(V3-instanceVar_vbbtlim_d))+((4.0*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V3+instanceVar_vbbtlim_d)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V3)*(V3))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V3)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABDRAIN_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvbot_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot_d*(1.0-tmp))+(modelVar_qpref2bot_d*(V3-vj)));
          id = (modelVar_idsatbot_d*idmult);
          if (((modelVar_CSRHBOTD_i==0.0)&&(modelVar_CTATBOTD_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PBOTD_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOTD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot_d*tmp);
            asrh = (modelVar_ftdbot_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHBOTD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOTD_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartbot_d*((wdep*modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOTD_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT_d*(((modelVar_VBIRBOTD_i-vbbt)*modelVar_wdepnulrinvbot_d)/tmp));
            if ((fabs(((-modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOTD_i*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOTD_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRBOTD_i)))
            {
              if ((modelVar_PBRBOTD_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvbot_d)*(vav*modelVar_VBRinvbot_d))*(vav*modelVar_VBRinvbot_d))*(vav*modelVar_VBRinvbot_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOTD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot_d+((vav+(modelVar_alphaav*modelVar_VBRBOTD_i))*modelVar_slopebot_d));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSDRAIN_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvsti_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti_d*(1.0-tmp))+(modelVar_qpref2sti_d*(V3-vj)));
          id = (modelVar_idsatsti_d*idmult);
          if (((modelVar_CSRHSTID_i==0.0)&&(modelVar_CTATSTID_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PSTID_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTID_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti_d*tmp);
            asrh = (modelVar_ftdsti_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHSTID_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTID_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartsti_d*((wdep*modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTID_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI_d*(((modelVar_VBIRSTID_i-vbbt)*modelVar_wdepnulrinvsti_d)/tmp));
            if ((fabs(((-modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTID_i*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTID_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRSTID_i)))
            {
              if ((modelVar_PBRSTID_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvsti_d)*(vav*modelVar_VBRinvsti_d))*(vav*modelVar_VBRinvsti_d))*(vav*modelVar_VBRinvsti_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTID_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti_d+((vav+(modelVar_alphaav*modelVar_VBRSTID_i))*modelVar_slopesti_d));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGDRAIN_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvgat_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat_d*(1.0-tmp))+(modelVar_qpref2gat_d*(V3-vj)));
          id = (modelVar_idsatgat_d*idmult);
          if (((modelVar_CSRHGATD_i==0.0)&&(modelVar_CTATGATD_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PGATD_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGATD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat_d*tmp);
            asrh = (modelVar_ftdgat_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHGATD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGATD_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartgat_d*((wdep*modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGATD_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT_d*(((modelVar_VBIRGATD_i-vbbt)*modelVar_wdepnulrinvgat_d)/tmp));
            if ((fabs(((-modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGATD_i*(((V3*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGATD_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRGATD_i)))
            {
              if ((modelVar_PBRGATD_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvgat_d)*(vav*modelVar_VBRinvgat_d))*(vav*modelVar_VBRinvgat_d))*(vav*modelVar_VBRinvgat_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGATD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat_d+((vav+(modelVar_alphaav*modelVar_VBRGATD_i))*modelVar_slopegat_d));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I3 = (((instanceVar_ABDRAIN_i*ijunbot)+(instanceVar_LSDRAIN_i*ijunsti))+(instanceVar_LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABDRAIN_i==0.0)&&(instanceVar_LSDRAIN_i==0.0))&&(instanceVar_LGDRAIN_i==0.0))))
        {
          h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
          h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
          h2d = (V4+(instanceVar_vch_d*h2));
          h3 = (instanceVar_vfmin_d+h2d);
          h4 = (instanceVar_vfmin_d-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V4*instanceVar_vfmin_d)/(h3+h5)));
          if ((V4<instanceVar_VMAX_d))
          {
            if ((fabs((0.5*(V4*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V4*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V4*modelVar_phitdinv))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V4-instanceVar_VMAX_d)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V4>0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              AdmsSensFadType value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V4)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_d-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V4-instanceVar_vbbtlim_d)*(V4-instanceVar_vbbtlim_d))+((4.0*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V4+instanceVar_vbbtlim_d)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V4)*(V4))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V4)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABDRAIN_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvbot_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot_d*(1.0-tmp))+(modelVar_qpref2bot_d*(V4-vj)));
          id = (modelVar_idsatbot_d*idmult);
          if (((modelVar_CSRHBOTD_i==0.0)&&(modelVar_CTATBOTD_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PBOTD_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOTD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot_d*tmp);
            asrh = (modelVar_ftdbot_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHBOTD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOTD_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartbot_d*((wdep*modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOTD_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT_d*(((modelVar_VBIRBOTD_i-vbbt)*modelVar_wdepnulrinvbot_d)/tmp));
            if ((fabs(((-modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOTD_i*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOTD_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRBOTD_i)))
            {
              if ((modelVar_PBRBOTD_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvbot_d)*(vav*modelVar_VBRinvbot_d))*(vav*modelVar_VBRinvbot_d))*(vav*modelVar_VBRinvbot_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOTD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot_d+((vav+(modelVar_alphaav*modelVar_VBRBOTD_i))*modelVar_slopebot_d));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSDRAIN_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvsti_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti_d*(1.0-tmp))+(modelVar_qpref2sti_d*(V4-vj)));
          id = (modelVar_idsatsti_d*idmult);
          if (((modelVar_CSRHSTID_i==0.0)&&(modelVar_CTATSTID_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PSTID_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTID_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti_d*tmp);
            asrh = (modelVar_ftdsti_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHSTID_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTID_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartsti_d*((wdep*modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTID_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI_d*(((modelVar_VBIRSTID_i-vbbt)*modelVar_wdepnulrinvsti_d)/tmp));
            if ((fabs(((-modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTID_i*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTID_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRSTID_i)))
            {
              if ((modelVar_PBRSTID_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvsti_d)*(vav*modelVar_VBRinvsti_d))*(vav*modelVar_VBRinvsti_d))*(vav*modelVar_VBRinvsti_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTID_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti_d+((vav+(modelVar_alphaav*modelVar_VBRSTID_i))*modelVar_slopesti_d));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGDRAIN_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvgat_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat_d*(1.0-tmp))+(modelVar_qpref2gat_d*(V4-vj)));
          id = (modelVar_idsatgat_d*idmult);
          if (((modelVar_CSRHGATD_i==0.0)&&(modelVar_CTATGATD_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PGATD_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGATD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat_d*tmp);
            asrh = (modelVar_ftdgat_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHGATD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGATD_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartgat_d*((wdep*modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGATD_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT_d*(((modelVar_VBIRGATD_i-vbbt)*modelVar_wdepnulrinvgat_d)/tmp));
            if ((fabs(((-modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGATD_i*(((V4*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGATD_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRGATD_i)))
            {
              if ((modelVar_PBRGATD_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvgat_d)*(vav*modelVar_VBRinvgat_d))*(vav*modelVar_VBRinvgat_d))*(vav*modelVar_VBRinvgat_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGATD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat_d+((vav+(modelVar_alphaav*modelVar_VBRGATD_i))*modelVar_slopegat_d));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I4 = (((instanceVar_ABDRAIN_i*ijunbot)+(instanceVar_LSDRAIN_i*ijunsti))+(instanceVar_LGDRAIN_i*ijungat));
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_ABDRAIN_i==0.0)&&(instanceVar_LSDRAIN_i==0.0))&&(instanceVar_LGDRAIN_i==0.0))))
        {
          h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
          h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
          h2d = (V5+(instanceVar_vch_d*h2));
          h3 = (instanceVar_vfmin_d+h2d);
          h4 = (instanceVar_vfmin_d-h2d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
            h5 = value_sqrt_0;
          }
          vj = (2.0*((V5*instanceVar_vfmin_d)/(h3+h5)));
          if ((V5<instanceVar_VMAX_d))
          {
            if ((fabs((0.5*(V5*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((0.5*(V5*modelVar_phitdinv)));
                zinv = value_exp_0;
              }
            }
            else
            {
              if (((0.5*(V5*modelVar_phitdinv))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((V5-instanceVar_VMAX_d)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(idmult);
              zinv = value_sqrt_0;
            }
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((V5>0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
              AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
              two_psistar = (2.0*(modelVar_phitd*value_log_1));
            }
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
              AdmsSensFadType value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
              two_psistar = ((-V5)+(2.0*(modelVar_phitd*value_log_1)));
            }
          }
          vjlim = (instanceVar_vbimin_d-two_psistar);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)));
            vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V5-instanceVar_vbbtlim_d)*(V5-instanceVar_vbbtlim_d))+((4.0*modelVar_phitr)*modelVar_phitr)));
            vbbt = (0.5*((V5+instanceVar_vbbtlim_d)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((V5)*(V5))+((4.0*1.0e-6)*1.0e-6)));
            vav = (0.5*((V5)-value_sqrt_0));
          }
        }
        if ((instanceVar_ABDRAIN_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvbot_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
              tmp = value_pow_0;
            }
          }
          qjunbot = ((modelVar_qprefbot_d*(1.0-tmp))+(modelVar_qpref2bot_d*(V5-vj)));
          id = (modelVar_idsatbot_d*idmult);
          if (((modelVar_CSRHBOTD_i==0.0)&&(modelVar_CTATBOTD_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PBOTD_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOTD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrbot_d*tmp);
            asrh = (modelVar_ftdbot_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHBOTD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOTD_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartbot_d*((wdep*modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOTD_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PBOTD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT_d*(((modelVar_VBIRBOTD_i-vbbt)*modelVar_wdepnulrinvbot_d)/tmp));
            if ((fabs(((-modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtbot_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOTD_i*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOTD_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRBOTD_i)))
            {
              if ((modelVar_PBRBOTD_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvbot_d)*(vav*modelVar_VBRinvbot_d))*(vav*modelVar_VBRinvbot_d))*(vav*modelVar_VBRinvbot_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOTD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot_d+((vav+(modelVar_alphaav*modelVar_VBRBOTD_i))*modelVar_slopebot_d));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LSDRAIN_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvsti_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
              tmp = value_pow_0;
            }
          }
          qjunsti = ((modelVar_qprefsti_d*(1.0-tmp))+(modelVar_qpref2sti_d*(V5-vj)));
          id = (modelVar_idsatsti_d*idmult);
          if (((modelVar_CSRHSTID_i==0.0)&&(modelVar_CTATSTID_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PSTID_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTID_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrsti_d*tmp);
            asrh = (modelVar_ftdsti_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHSTID_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTID_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartsti_d*((wdep*modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTID_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PSTID_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI_d*(((modelVar_VBIRSTID_i-vbbt)*modelVar_wdepnulrinvsti_d)/tmp));
            if ((fabs(((-modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtsti_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTID_i*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTID_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRSTID_i)))
            {
              if ((modelVar_PBRSTID_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvsti_d)*(vav*modelVar_VBRinvsti_d))*(vav*modelVar_VBRinvsti_d))*(vav*modelVar_VBRinvsti_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTID_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti_d+((vav+(modelVar_alphaav*modelVar_VBRSTID_i))*modelVar_slopesti_d));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LGDRAIN_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT_d==0.5))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvgat_d)));
              tmp = value_sqrt_0;
            }
          }
          else
          {
            {
              AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
              tmp = value_pow_0;
            }
          }
          qjungat = ((modelVar_qprefgat_d*(1.0-tmp))+(modelVar_qpref2gat_d*(V5-vj)));
          id = (modelVar_idsatgat_d*idmult);
          if (((modelVar_CSRHGATD_i==0.0)&&(modelVar_CTATGATD_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat_d-vjsrh);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
              wsrhstep = (1.0-value_sqrt_0);
            }
            if ((modelVar_PGATD_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              {
                AdmsSensFadType value_log_0 = log(wsrhstep);
                dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGATD_i)));
              }
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            wdep = (modelVar_wdepnulrgat_d*tmp);
            asrh = (modelVar_ftdgat_d*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHGATD_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGATD_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartgat_d*((wdep*modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat_d)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
              umax = value_sqrt_0;
            }
            {
              AdmsSensFadType value_fabs_0 = fabs(umax);
              AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
              sqrtumax = value_sqrt_1;
            }
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d));
                wgamma = value_pow_0;
              }
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
              ktat = value_sqrt_0;
            }
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                tmp = value_exp_0;
              }
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(mtat);
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat_d*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGATD_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PGATD_i==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                tmp = value_pow_0;
              }
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT_d*(((modelVar_VBIRGATD_i-vbbt)*modelVar_wdepnulrinvgat_d)/tmp));
            if ((fabs(((-modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat_d)/Fmaxr));
                tmp = value_exp_0;
              }
            }
            else
            {
              if ((((-modelVar_fbbtgat_d)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGATD_i*(((V5*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGATD_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRGATD_i)))
            {
              if ((modelVar_PBRGATD_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvgat_d)*(vav*modelVar_VBRinvgat_d))*(vav*modelVar_VBRinvgat_d))*(vav*modelVar_VBRinvgat_d));
              }
              else
              {
                {
                  AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                  AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGATD_i);
                  tmp = value_pow_1;
                }
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat_d+((vav+(modelVar_alphaav*modelVar_VBRGATD_i))*modelVar_slopegat_d));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        I5 = (((instanceVar_ABDRAIN_i*ijunbot)+(instanceVar_LSDRAIN_i*ijunsti))+(instanceVar_LGDRAIN_i*ijungat));
        instanceVar_ISATFOR1_d = (((instanceVar_ABDRAIN_i*modelVar_idsatbot_d)+(instanceVar_LSDRAIN_i*modelVar_idsatsti_d))+(instanceVar_LGDRAIN_i*modelVar_idsatgat_d));
        {
          AdmsSensFadType value_exp_0 = exp(((V4*modelVar_phitdinv)*instanceVar_MFOR1_d));
          I4_cor = (I4-(instanceVar_ISATFOR1_d*(value_exp_0-1.0)));
        }
        {
          AdmsSensFadType value_exp_0 = exp(((V5*modelVar_phitdinv)*instanceVar_MFOR1_d));
          I5_cor = (I5-(instanceVar_ISATFOR1_d*(value_exp_0-1.0)));
        }
        if ((!(((instanceVar_ABDRAIN_i==0.0)&&(instanceVar_LSDRAIN_i==0.0))&&(instanceVar_LGDRAIN_i==0.0))))
        {
          if (((I4>0.0)&&(I5>0.0)))
          {
            if ((((((I4_cor/I4)>1.0e-3)||((I5_cor/I5)>1.0e-3))&&(I4_cor>0.0))&&(I5_cor>0.0)))
            {
              alphaje = (I4_cor/I5_cor);
              {
                AdmsSensFadType value_log_0 = log(alphaje);
                instanceVar_MFOR2_d = ((modelVar_phitd*value_log_0)/(V4-V5));
              }
              {
                AdmsSensFadType value_exp_0 = exp(((V4*modelVar_phitdinv)*instanceVar_MFOR2_d));
                instanceVar_ISATFOR2_d = (I4_cor/(value_exp_0-1.0));
              }
            }
          }
          {
            AdmsSensFadType value_exp_0 = exp(((V1*modelVar_phitdinv)*instanceVar_MFOR1_d));
            AdmsSensFadType value_exp_1 = exp(((V1*modelVar_phitdinv)*instanceVar_MFOR2_d));
            I1_cor = ((I1-(instanceVar_ISATFOR1_d*(value_exp_0-1.0)))-(instanceVar_ISATFOR2_d*(value_exp_1-1.0)));
          }
          {
            AdmsSensFadType value_exp_0 = exp(((V2*modelVar_phitdinv)*instanceVar_MFOR1_d));
            AdmsSensFadType value_exp_1 = exp(((V2*modelVar_phitdinv)*instanceVar_MFOR2_d));
            I2_cor = ((I2-(instanceVar_ISATFOR1_d*(value_exp_0-1.0)))-(instanceVar_ISATFOR2_d*(value_exp_1-1.0)));
          }
          {
            AdmsSensFadType value_exp_0 = exp(((V3*modelVar_phitdinv)*instanceVar_MFOR1_d));
            AdmsSensFadType value_exp_1 = exp(((V3*modelVar_phitdinv)*instanceVar_MFOR2_d));
            I3_cor = ((I3-(instanceVar_ISATFOR1_d*(value_exp_0-1.0)))-(instanceVar_ISATFOR2_d*(value_exp_1-1.0)));
          }
          if ((((I1<0.0)&&(I2<0.0))&&(I3<0.0)))
          {
            if ((((((((I1_cor/I1)>1.0e-3)||((I2_cor/I2)>1.0e-3))||((I3_cor/I3)>1.0e-3))&&(I1_cor<0.0))&&(I2_cor<0.0))&&(I3_cor<0.0)))
            {
              alphaje = (I1_cor/I2_cor);
              {
                AdmsSensFadType value_log_0 = log(alphaje);
                m0_rev = (((-modelVar_phitd)*value_log_0)/(V1-V2));
              }
              tt0 = (V2/(V2-V1));
              {
                AdmsSensFadType value_pow_0 = pow(alphaje,tt0);
                tt1 = ((modelVar_phitd*(alphaje-1.0))*(value_pow_0-1.0));
              }
              tt0 = (V1/(V1-V2));
              {
                AdmsSensFadType value_pow_0 = pow(alphaje,tt0);
                tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
              }
              mcor_rev = (tt1/tt2);
              instanceVar_MREV_d = (m0_rev+mcor_rev);
              if ((fabs(((V3*modelVar_phitdinv)*instanceVar_MREV_d))<1.0e-6))
              {
                instanceVar_m0flag_d = 1.0;
                instanceVar_ISATREV_d = (I3_cor*((1.0/V3)+((0.5*modelVar_phitdinv)*instanceVar_MREV_d)));
                instanceVar_MREV_d = (((((-0.5)*I3_cor)*instanceVar_MREV_d)*modelVar_phitdinv)/V3);
              }
              else
              {
                instanceVar_m0flag_d = 0.0;
                {
                  AdmsSensFadType value_exp_0 = exp((((-V3)*modelVar_phitdinv)*instanceVar_MREV_d));
                  instanceVar_ISATREV_d = ((-I3_cor)/(value_exp_0-1.0));
                }
              }
            }
          }
        }
        zfrac = (modelVar_FJUNQD_i*(((instanceVar_ABDRAIN_i*modelVar_cjobot_d)+(instanceVar_LSDRAIN_i*modelVar_cjosti_d))+(instanceVar_LGDRAIN_i*modelVar_cjogat_d)));
        if (((instanceVar_ABDRAIN_i*modelVar_cjobot_d)<=zfrac))
        {
          instanceVar_zflagbot_d = 0.0;
        }
        if (((instanceVar_LSDRAIN_i*modelVar_cjosti_d)<=zfrac))
        {
          instanceVar_zflagsti_d = 0.0;
        }
        if (((instanceVar_LGDRAIN_i*modelVar_cjogat_d)<=zfrac))
        {
          instanceVar_zflaggat_d = 0.0;
        }
        if ((!(((instanceVar_ABDRAIN_i==0.0)&&(instanceVar_LSDRAIN_i==0.0))&&(instanceVar_LGDRAIN_i==0.0))))
        {
          {
            AdmsSensFadType value_log_0 = log(((0.5*modelVar_IMAX_i)/(instanceVar_ISATFOR1_d+1.0e-21)));
            instanceVar_xhighf1_d = value_log_0;
          }
          {
            AdmsSensFadType value_log_0 = log(((0.5*modelVar_IMAX_i)/(instanceVar_ISATFOR2_d+1.0e-21)));
            instanceVar_xhighf2_d = value_log_0;
          }
          {
            AdmsSensFadType value_fabs_0 = fabs(instanceVar_ISATREV_d);
            AdmsSensFadType value_log_1 = log(((0.5*modelVar_IMAX_i)/(value_fabs_0+1.0e-21)));
            instanceVar_xhighr_d = value_log_1;
          }
        }
        {
          AdmsSensFadType value_min_0 = std::min(instanceVar_xhighf1_d,static_cast<double>(2.3025850929940458e+02));
          instanceVar_xhighf1_d = value_min_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_xhighf1_d);
          instanceVar_expxhf1_d = value_exp_0;
        }
        {
          AdmsSensFadType value_min_0 = std::min(instanceVar_xhighf2_d,static_cast<double>(2.3025850929940458e+02));
          instanceVar_xhighf2_d = value_min_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_xhighf2_d);
          instanceVar_expxhf2_d = value_exp_0;
        }
        {
          AdmsSensFadType value_min_0 = std::min(instanceVar_xhighr_d,static_cast<double>(2.3025850929940458e+02));
          instanceVar_xhighr_d = value_min_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_xhighr_d);
          instanceVar_expxhr_d = value_exp_0;
        }
      }
      // End block JUNCAPexpressInit
    }
  }
  // End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TR,
   bool modelPar_given_TR,
   AdmsSensFadType & modelPar_QMC,
   bool modelPar_given_QMC,
   AdmsSensFadType & modelPar_VFB,
   bool modelPar_given_VFB,
   AdmsSensFadType & modelPar_STVFB,
   bool modelPar_given_STVFB,
   AdmsSensFadType & modelPar_TOX,
   bool modelPar_given_TOX,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_NEFF,
   bool modelPar_given_NEFF,
   AdmsSensFadType & modelPar_FACNEFFAC,
   bool modelPar_given_FACNEFFAC,
   AdmsSensFadType & modelPar_GFACNUD,
   bool modelPar_given_GFACNUD,
   AdmsSensFadType & modelPar_VSBNUD,
   bool modelPar_given_VSBNUD,
   AdmsSensFadType & modelPar_DVSBNUD,
   bool modelPar_given_DVSBNUD,
   AdmsSensFadType & modelPar_VNSUB,
   bool modelPar_given_VNSUB,
   AdmsSensFadType & modelPar_NSLP,
   bool modelPar_given_NSLP,
   AdmsSensFadType & modelPar_DNSUB,
   bool modelPar_given_DNSUB,
   AdmsSensFadType & modelPar_DPHIB,
   bool modelPar_given_DPHIB,
   AdmsSensFadType & modelPar_DELVTAC,
   bool modelPar_given_DELVTAC,
   AdmsSensFadType & modelPar_NP,
   bool modelPar_given_NP,
   AdmsSensFadType & modelPar_CT,
   bool modelPar_given_CT,
   AdmsSensFadType & modelPar_TOXOV,
   bool modelPar_given_TOXOV,
   AdmsSensFadType & modelPar_TOXOVD,
   bool modelPar_given_TOXOVD,
   AdmsSensFadType & modelPar_NOV,
   bool modelPar_given_NOV,
   AdmsSensFadType & modelPar_NOVD,
   bool modelPar_given_NOVD,
   AdmsSensFadType & modelPar_CF,
   bool modelPar_given_CF,
   AdmsSensFadType & modelPar_CFD,
   bool modelPar_given_CFD,
   AdmsSensFadType & modelPar_CFB,
   bool modelPar_given_CFB,
   AdmsSensFadType & modelPar_PSCE,
   bool modelPar_given_PSCE,
   AdmsSensFadType & modelPar_PSCEB,
   bool modelPar_given_PSCEB,
   AdmsSensFadType & modelPar_PSCED,
   bool modelPar_given_PSCED,
   AdmsSensFadType & modelPar_BETN,
   bool modelPar_given_BETN,
   AdmsSensFadType & modelPar_STBET,
   bool modelPar_given_STBET,
   AdmsSensFadType & modelPar_MUE,
   bool modelPar_given_MUE,
   AdmsSensFadType & modelPar_STMUE,
   bool modelPar_given_STMUE,
   AdmsSensFadType & modelPar_THEMU,
   bool modelPar_given_THEMU,
   AdmsSensFadType & modelPar_STTHEMU,
   bool modelPar_given_STTHEMU,
   AdmsSensFadType & modelPar_CS,
   bool modelPar_given_CS,
   AdmsSensFadType & modelPar_STCS,
   bool modelPar_given_STCS,
   AdmsSensFadType & modelPar_XCOR,
   bool modelPar_given_XCOR,
   AdmsSensFadType & modelPar_STXCOR,
   bool modelPar_given_STXCOR,
   AdmsSensFadType & modelPar_FETA,
   bool modelPar_given_FETA,
   AdmsSensFadType & modelPar_RS,
   bool modelPar_given_RS,
   AdmsSensFadType & modelPar_STRS,
   bool modelPar_given_STRS,
   AdmsSensFadType & modelPar_RSB,
   bool modelPar_given_RSB,
   AdmsSensFadType & modelPar_RSG,
   bool modelPar_given_RSG,
   AdmsSensFadType & modelPar_THESAT,
   bool modelPar_given_THESAT,
   AdmsSensFadType & modelPar_STTHESAT,
   bool modelPar_given_STTHESAT,
   AdmsSensFadType & modelPar_THESATB,
   bool modelPar_given_THESATB,
   AdmsSensFadType & modelPar_THESATG,
   bool modelPar_given_THESATG,
   AdmsSensFadType & modelPar_AX,
   bool modelPar_given_AX,
   AdmsSensFadType & modelPar_ALP,
   bool modelPar_given_ALP,
   AdmsSensFadType & modelPar_ALP1,
   bool modelPar_given_ALP1,
   AdmsSensFadType & modelPar_ALP2,
   bool modelPar_given_ALP2,
   AdmsSensFadType & modelPar_VP,
   bool modelPar_given_VP,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_STA2,
   bool modelPar_given_STA2,
   AdmsSensFadType & modelPar_A3,
   bool modelPar_given_A3,
   AdmsSensFadType & modelPar_A4,
   bool modelPar_given_A4,
   AdmsSensFadType & modelPar_GCO,
   bool modelPar_given_GCO,
   AdmsSensFadType & modelPar_IGINV,
   bool modelPar_given_IGINV,
   AdmsSensFadType & modelPar_IGOV,
   bool modelPar_given_IGOV,
   AdmsSensFadType & modelPar_IGOVD,
   bool modelPar_given_IGOVD,
   AdmsSensFadType & modelPar_STIG,
   bool modelPar_given_STIG,
   AdmsSensFadType & modelPar_GC2,
   bool modelPar_given_GC2,
   AdmsSensFadType & modelPar_GC3,
   bool modelPar_given_GC3,
   AdmsSensFadType & modelPar_CHIB,
   bool modelPar_given_CHIB,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_AGIDLD,
   bool modelPar_given_AGIDLD,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_BGIDLD,
   bool modelPar_given_BGIDLD,
   AdmsSensFadType & modelPar_STBGIDL,
   bool modelPar_given_STBGIDL,
   AdmsSensFadType & modelPar_STBGIDLD,
   bool modelPar_given_STBGIDLD,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_CGIDLD,
   bool modelPar_given_CGIDLD,
   AdmsSensFadType & modelPar_COX,
   bool modelPar_given_COX,
   AdmsSensFadType & modelPar_CGOV,
   bool modelPar_given_CGOV,
   AdmsSensFadType & modelPar_CGOVD,
   bool modelPar_given_CGOVD,
   AdmsSensFadType & modelPar_CGBOV,
   bool modelPar_given_CGBOV,
   AdmsSensFadType & modelPar_CFR,
   bool modelPar_given_CFR,
   AdmsSensFadType & modelPar_CFRD,
   bool modelPar_given_CFRD,
   AdmsSensFadType & modelPar_FNT,
   bool modelPar_given_FNT,
   AdmsSensFadType & modelPar_FNTEXC,
   bool modelPar_given_FNTEXC,
   AdmsSensFadType & modelPar_NFA,
   bool modelPar_given_NFA,
   AdmsSensFadType & modelPar_NFB,
   bool modelPar_given_NFB,
   AdmsSensFadType & modelPar_NFC,
   bool modelPar_given_NFC,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_VFBEDGE,
   bool modelPar_given_VFBEDGE,
   AdmsSensFadType & modelPar_STVFBEDGE,
   bool modelPar_given_STVFBEDGE,
   AdmsSensFadType & modelPar_DPHIBEDGE,
   bool modelPar_given_DPHIBEDGE,
   AdmsSensFadType & modelPar_NEFFEDGE,
   bool modelPar_given_NEFFEDGE,
   AdmsSensFadType & modelPar_CTEDGE,
   bool modelPar_given_CTEDGE,
   AdmsSensFadType & modelPar_BETNEDGE,
   bool modelPar_given_BETNEDGE,
   AdmsSensFadType & modelPar_STBETEDGE,
   bool modelPar_given_STBETEDGE,
   AdmsSensFadType & modelPar_PSCEEDGE,
   bool modelPar_given_PSCEEDGE,
   AdmsSensFadType & modelPar_PSCEBEDGE,
   bool modelPar_given_PSCEBEDGE,
   AdmsSensFadType & modelPar_PSCEDEDGE,
   bool modelPar_given_PSCEDEDGE,
   AdmsSensFadType & modelPar_CFEDGE,
   bool modelPar_given_CFEDGE,
   AdmsSensFadType & modelPar_CFDEDGE,
   bool modelPar_given_CFDEDGE,
   AdmsSensFadType & modelPar_CFBEDGE,
   bool modelPar_given_CFBEDGE,
   AdmsSensFadType & modelPar_FNTEDGE,
   bool modelPar_given_FNTEDGE,
   AdmsSensFadType & modelPar_NFAEDGE,
   bool modelPar_given_NFAEDGE,
   AdmsSensFadType & modelPar_NFBEDGE,
   bool modelPar_given_NFBEDGE,
   AdmsSensFadType & modelPar_NFCEDGE,
   bool modelPar_given_NFCEDGE,
   AdmsSensFadType & modelPar_EFEDGE,
   bool modelPar_given_EFEDGE,
   AdmsSensFadType & modelPar_RG,
   bool modelPar_given_RG,
   AdmsSensFadType & modelPar_RSE,
   bool modelPar_given_RSE,
   AdmsSensFadType & modelPar_RDE,
   bool modelPar_given_RDE,
   AdmsSensFadType & modelPar_RBULK,
   bool modelPar_given_RBULK,
   AdmsSensFadType & modelPar_RWELL,
   bool modelPar_given_RWELL,
   AdmsSensFadType & modelPar_RJUNS,
   bool modelPar_given_RJUNS,
   AdmsSensFadType & modelPar_RJUND,
   bool modelPar_given_RJUND,
   AdmsSensFadType & modelPar_POVFB,
   bool modelPar_given_POVFB,
   AdmsSensFadType & modelPar_PLVFB,
   bool modelPar_given_PLVFB,
   AdmsSensFadType & modelPar_PWVFB,
   bool modelPar_given_PWVFB,
   AdmsSensFadType & modelPar_PLWVFB,
   bool modelPar_given_PLWVFB,
   AdmsSensFadType & modelPar_POSTVFB,
   bool modelPar_given_POSTVFB,
   AdmsSensFadType & modelPar_PLSTVFB,
   bool modelPar_given_PLSTVFB,
   AdmsSensFadType & modelPar_PWSTVFB,
   bool modelPar_given_PWSTVFB,
   AdmsSensFadType & modelPar_PLWSTVFB,
   bool modelPar_given_PLWSTVFB,
   AdmsSensFadType & modelPar_POTOX,
   bool modelPar_given_POTOX,
   AdmsSensFadType & modelPar_POEPSROX,
   bool modelPar_given_POEPSROX,
   AdmsSensFadType & modelPar_PONEFF,
   bool modelPar_given_PONEFF,
   AdmsSensFadType & modelPar_PLNEFF,
   bool modelPar_given_PLNEFF,
   AdmsSensFadType & modelPar_PWNEFF,
   bool modelPar_given_PWNEFF,
   AdmsSensFadType & modelPar_PLWNEFF,
   bool modelPar_given_PLWNEFF,
   AdmsSensFadType & modelPar_POFACNEFFAC,
   bool modelPar_given_POFACNEFFAC,
   AdmsSensFadType & modelPar_PLFACNEFFAC,
   bool modelPar_given_PLFACNEFFAC,
   AdmsSensFadType & modelPar_PWFACNEFFAC,
   bool modelPar_given_PWFACNEFFAC,
   AdmsSensFadType & modelPar_PLWFACNEFFAC,
   bool modelPar_given_PLWFACNEFFAC,
   AdmsSensFadType & modelPar_POGFACNUD,
   bool modelPar_given_POGFACNUD,
   AdmsSensFadType & modelPar_PLGFACNUD,
   bool modelPar_given_PLGFACNUD,
   AdmsSensFadType & modelPar_PWGFACNUD,
   bool modelPar_given_PWGFACNUD,
   AdmsSensFadType & modelPar_PLWGFACNUD,
   bool modelPar_given_PLWGFACNUD,
   AdmsSensFadType & modelPar_POVSBNUD,
   bool modelPar_given_POVSBNUD,
   AdmsSensFadType & modelPar_PODVSBNUD,
   bool modelPar_given_PODVSBNUD,
   AdmsSensFadType & modelPar_POVNSUB,
   bool modelPar_given_POVNSUB,
   AdmsSensFadType & modelPar_PONSLP,
   bool modelPar_given_PONSLP,
   AdmsSensFadType & modelPar_PODNSUB,
   bool modelPar_given_PODNSUB,
   AdmsSensFadType & modelPar_PODPHIB,
   bool modelPar_given_PODPHIB,
   AdmsSensFadType & modelPar_PLDPHIB,
   bool modelPar_given_PLDPHIB,
   AdmsSensFadType & modelPar_PWDPHIB,
   bool modelPar_given_PWDPHIB,
   AdmsSensFadType & modelPar_PLWDPHIB,
   bool modelPar_given_PLWDPHIB,
   AdmsSensFadType & modelPar_PODELVTAC,
   bool modelPar_given_PODELVTAC,
   AdmsSensFadType & modelPar_PLDELVTAC,
   bool modelPar_given_PLDELVTAC,
   AdmsSensFadType & modelPar_PWDELVTAC,
   bool modelPar_given_PWDELVTAC,
   AdmsSensFadType & modelPar_PLWDELVTAC,
   bool modelPar_given_PLWDELVTAC,
   AdmsSensFadType & modelPar_PONP,
   bool modelPar_given_PONP,
   AdmsSensFadType & modelPar_PLNP,
   bool modelPar_given_PLNP,
   AdmsSensFadType & modelPar_PWNP,
   bool modelPar_given_PWNP,
   AdmsSensFadType & modelPar_PLWNP,
   bool modelPar_given_PLWNP,
   AdmsSensFadType & modelPar_POCT,
   bool modelPar_given_POCT,
   AdmsSensFadType & modelPar_PLCT,
   bool modelPar_given_PLCT,
   AdmsSensFadType & modelPar_PWCT,
   bool modelPar_given_PWCT,
   AdmsSensFadType & modelPar_PLWCT,
   bool modelPar_given_PLWCT,
   AdmsSensFadType & modelPar_POTOXOV,
   bool modelPar_given_POTOXOV,
   AdmsSensFadType & modelPar_POTOXOVD,
   bool modelPar_given_POTOXOVD,
   AdmsSensFadType & modelPar_PONOV,
   bool modelPar_given_PONOV,
   AdmsSensFadType & modelPar_PLNOV,
   bool modelPar_given_PLNOV,
   AdmsSensFadType & modelPar_PWNOV,
   bool modelPar_given_PWNOV,
   AdmsSensFadType & modelPar_PLWNOV,
   bool modelPar_given_PLWNOV,
   AdmsSensFadType & modelPar_PONOVD,
   bool modelPar_given_PONOVD,
   AdmsSensFadType & modelPar_PLNOVD,
   bool modelPar_given_PLNOVD,
   AdmsSensFadType & modelPar_PWNOVD,
   bool modelPar_given_PWNOVD,
   AdmsSensFadType & modelPar_PLWNOVD,
   bool modelPar_given_PLWNOVD,
   AdmsSensFadType & modelPar_POCF,
   bool modelPar_given_POCF,
   AdmsSensFadType & modelPar_PLCF,
   bool modelPar_given_PLCF,
   AdmsSensFadType & modelPar_PWCF,
   bool modelPar_given_PWCF,
   AdmsSensFadType & modelPar_PLWCF,
   bool modelPar_given_PLWCF,
   AdmsSensFadType & modelPar_POCFD,
   bool modelPar_given_POCFD,
   AdmsSensFadType & modelPar_POCFB,
   bool modelPar_given_POCFB,
   AdmsSensFadType & modelPar_POPSCE,
   bool modelPar_given_POPSCE,
   AdmsSensFadType & modelPar_PLPSCE,
   bool modelPar_given_PLPSCE,
   AdmsSensFadType & modelPar_PWPSCE,
   bool modelPar_given_PWPSCE,
   AdmsSensFadType & modelPar_PLWPSCE,
   bool modelPar_given_PLWPSCE,
   AdmsSensFadType & modelPar_POPSCEB,
   bool modelPar_given_POPSCEB,
   AdmsSensFadType & modelPar_POPSCED,
   bool modelPar_given_POPSCED,
   AdmsSensFadType & modelPar_POBETN,
   bool modelPar_given_POBETN,
   AdmsSensFadType & modelPar_PLBETN,
   bool modelPar_given_PLBETN,
   AdmsSensFadType & modelPar_PWBETN,
   bool modelPar_given_PWBETN,
   AdmsSensFadType & modelPar_PLWBETN,
   bool modelPar_given_PLWBETN,
   AdmsSensFadType & modelPar_POSTBET,
   bool modelPar_given_POSTBET,
   AdmsSensFadType & modelPar_PLSTBET,
   bool modelPar_given_PLSTBET,
   AdmsSensFadType & modelPar_PWSTBET,
   bool modelPar_given_PWSTBET,
   AdmsSensFadType & modelPar_PLWSTBET,
   bool modelPar_given_PLWSTBET,
   AdmsSensFadType & modelPar_POMUE,
   bool modelPar_given_POMUE,
   AdmsSensFadType & modelPar_PLMUE,
   bool modelPar_given_PLMUE,
   AdmsSensFadType & modelPar_PWMUE,
   bool modelPar_given_PWMUE,
   AdmsSensFadType & modelPar_PLWMUE,
   bool modelPar_given_PLWMUE,
   AdmsSensFadType & modelPar_POSTMUE,
   bool modelPar_given_POSTMUE,
   AdmsSensFadType & modelPar_POTHEMU,
   bool modelPar_given_POTHEMU,
   AdmsSensFadType & modelPar_POSTTHEMU,
   bool modelPar_given_POSTTHEMU,
   AdmsSensFadType & modelPar_POCS,
   bool modelPar_given_POCS,
   AdmsSensFadType & modelPar_PLCS,
   bool modelPar_given_PLCS,
   AdmsSensFadType & modelPar_PWCS,
   bool modelPar_given_PWCS,
   AdmsSensFadType & modelPar_PLWCS,
   bool modelPar_given_PLWCS,
   AdmsSensFadType & modelPar_POSTCS,
   bool modelPar_given_POSTCS,
   AdmsSensFadType & modelPar_POXCOR,
   bool modelPar_given_POXCOR,
   AdmsSensFadType & modelPar_PLXCOR,
   bool modelPar_given_PLXCOR,
   AdmsSensFadType & modelPar_PWXCOR,
   bool modelPar_given_PWXCOR,
   AdmsSensFadType & modelPar_PLWXCOR,
   bool modelPar_given_PLWXCOR,
   AdmsSensFadType & modelPar_POSTXCOR,
   bool modelPar_given_POSTXCOR,
   AdmsSensFadType & modelPar_POFETA,
   bool modelPar_given_POFETA,
   AdmsSensFadType & modelPar_PORS,
   bool modelPar_given_PORS,
   AdmsSensFadType & modelPar_PLRS,
   bool modelPar_given_PLRS,
   AdmsSensFadType & modelPar_PWRS,
   bool modelPar_given_PWRS,
   AdmsSensFadType & modelPar_PLWRS,
   bool modelPar_given_PLWRS,
   AdmsSensFadType & modelPar_POSTRS,
   bool modelPar_given_POSTRS,
   AdmsSensFadType & modelPar_PORSB,
   bool modelPar_given_PORSB,
   AdmsSensFadType & modelPar_PORSG,
   bool modelPar_given_PORSG,
   AdmsSensFadType & modelPar_POTHESAT,
   bool modelPar_given_POTHESAT,
   AdmsSensFadType & modelPar_PLTHESAT,
   bool modelPar_given_PLTHESAT,
   AdmsSensFadType & modelPar_PWTHESAT,
   bool modelPar_given_PWTHESAT,
   AdmsSensFadType & modelPar_PLWTHESAT,
   bool modelPar_given_PLWTHESAT,
   AdmsSensFadType & modelPar_POSTTHESAT,
   bool modelPar_given_POSTTHESAT,
   AdmsSensFadType & modelPar_PLSTTHESAT,
   bool modelPar_given_PLSTTHESAT,
   AdmsSensFadType & modelPar_PWSTTHESAT,
   bool modelPar_given_PWSTTHESAT,
   AdmsSensFadType & modelPar_PLWSTTHESAT,
   bool modelPar_given_PLWSTTHESAT,
   AdmsSensFadType & modelPar_POTHESATB,
   bool modelPar_given_POTHESATB,
   AdmsSensFadType & modelPar_PLTHESATB,
   bool modelPar_given_PLTHESATB,
   AdmsSensFadType & modelPar_PWTHESATB,
   bool modelPar_given_PWTHESATB,
   AdmsSensFadType & modelPar_PLWTHESATB,
   bool modelPar_given_PLWTHESATB,
   AdmsSensFadType & modelPar_POTHESATG,
   bool modelPar_given_POTHESATG,
   AdmsSensFadType & modelPar_PLTHESATG,
   bool modelPar_given_PLTHESATG,
   AdmsSensFadType & modelPar_PWTHESATG,
   bool modelPar_given_PWTHESATG,
   AdmsSensFadType & modelPar_PLWTHESATG,
   bool modelPar_given_PLWTHESATG,
   AdmsSensFadType & modelPar_POAX,
   bool modelPar_given_POAX,
   AdmsSensFadType & modelPar_PLAX,
   bool modelPar_given_PLAX,
   AdmsSensFadType & modelPar_PWAX,
   bool modelPar_given_PWAX,
   AdmsSensFadType & modelPar_PLWAX,
   bool modelPar_given_PLWAX,
   AdmsSensFadType & modelPar_POALP,
   bool modelPar_given_POALP,
   AdmsSensFadType & modelPar_PLALP,
   bool modelPar_given_PLALP,
   AdmsSensFadType & modelPar_PWALP,
   bool modelPar_given_PWALP,
   AdmsSensFadType & modelPar_PLWALP,
   bool modelPar_given_PLWALP,
   AdmsSensFadType & modelPar_POALP1,
   bool modelPar_given_POALP1,
   AdmsSensFadType & modelPar_PLALP1,
   bool modelPar_given_PLALP1,
   AdmsSensFadType & modelPar_PWALP1,
   bool modelPar_given_PWALP1,
   AdmsSensFadType & modelPar_PLWALP1,
   bool modelPar_given_PLWALP1,
   AdmsSensFadType & modelPar_POALP2,
   bool modelPar_given_POALP2,
   AdmsSensFadType & modelPar_PLALP2,
   bool modelPar_given_PLALP2,
   AdmsSensFadType & modelPar_PWALP2,
   bool modelPar_given_PWALP2,
   AdmsSensFadType & modelPar_PLWALP2,
   bool modelPar_given_PLWALP2,
   AdmsSensFadType & modelPar_POVP,
   bool modelPar_given_POVP,
   AdmsSensFadType & modelPar_POA1,
   bool modelPar_given_POA1,
   AdmsSensFadType & modelPar_PLA1,
   bool modelPar_given_PLA1,
   AdmsSensFadType & modelPar_PWA1,
   bool modelPar_given_PWA1,
   AdmsSensFadType & modelPar_PLWA1,
   bool modelPar_given_PLWA1,
   AdmsSensFadType & modelPar_POA2,
   bool modelPar_given_POA2,
   AdmsSensFadType & modelPar_POSTA2,
   bool modelPar_given_POSTA2,
   AdmsSensFadType & modelPar_POA3,
   bool modelPar_given_POA3,
   AdmsSensFadType & modelPar_PLA3,
   bool modelPar_given_PLA3,
   AdmsSensFadType & modelPar_PWA3,
   bool modelPar_given_PWA3,
   AdmsSensFadType & modelPar_PLWA3,
   bool modelPar_given_PLWA3,
   AdmsSensFadType & modelPar_POA4,
   bool modelPar_given_POA4,
   AdmsSensFadType & modelPar_PLA4,
   bool modelPar_given_PLA4,
   AdmsSensFadType & modelPar_PWA4,
   bool modelPar_given_PWA4,
   AdmsSensFadType & modelPar_PLWA4,
   bool modelPar_given_PLWA4,
   AdmsSensFadType & modelPar_POGCO,
   bool modelPar_given_POGCO,
   AdmsSensFadType & modelPar_POIGINV,
   bool modelPar_given_POIGINV,
   AdmsSensFadType & modelPar_PLIGINV,
   bool modelPar_given_PLIGINV,
   AdmsSensFadType & modelPar_PWIGINV,
   bool modelPar_given_PWIGINV,
   AdmsSensFadType & modelPar_PLWIGINV,
   bool modelPar_given_PLWIGINV,
   AdmsSensFadType & modelPar_POIGOV,
   bool modelPar_given_POIGOV,
   AdmsSensFadType & modelPar_PLIGOV,
   bool modelPar_given_PLIGOV,
   AdmsSensFadType & modelPar_PWIGOV,
   bool modelPar_given_PWIGOV,
   AdmsSensFadType & modelPar_PLWIGOV,
   bool modelPar_given_PLWIGOV,
   AdmsSensFadType & modelPar_POIGOVD,
   bool modelPar_given_POIGOVD,
   AdmsSensFadType & modelPar_PLIGOVD,
   bool modelPar_given_PLIGOVD,
   AdmsSensFadType & modelPar_PWIGOVD,
   bool modelPar_given_PWIGOVD,
   AdmsSensFadType & modelPar_PLWIGOVD,
   bool modelPar_given_PLWIGOVD,
   AdmsSensFadType & modelPar_POSTIG,
   bool modelPar_given_POSTIG,
   AdmsSensFadType & modelPar_POGC2,
   bool modelPar_given_POGC2,
   AdmsSensFadType & modelPar_POGC3,
   bool modelPar_given_POGC3,
   AdmsSensFadType & modelPar_POCHIB,
   bool modelPar_given_POCHIB,
   AdmsSensFadType & modelPar_POAGIDL,
   bool modelPar_given_POAGIDL,
   AdmsSensFadType & modelPar_PLAGIDL,
   bool modelPar_given_PLAGIDL,
   AdmsSensFadType & modelPar_PWAGIDL,
   bool modelPar_given_PWAGIDL,
   AdmsSensFadType & modelPar_PLWAGIDL,
   bool modelPar_given_PLWAGIDL,
   AdmsSensFadType & modelPar_POAGIDLD,
   bool modelPar_given_POAGIDLD,
   AdmsSensFadType & modelPar_PLAGIDLD,
   bool modelPar_given_PLAGIDLD,
   AdmsSensFadType & modelPar_PWAGIDLD,
   bool modelPar_given_PWAGIDLD,
   AdmsSensFadType & modelPar_PLWAGIDLD,
   bool modelPar_given_PLWAGIDLD,
   AdmsSensFadType & modelPar_POBGIDL,
   bool modelPar_given_POBGIDL,
   AdmsSensFadType & modelPar_POBGIDLD,
   bool modelPar_given_POBGIDLD,
   AdmsSensFadType & modelPar_POSTBGIDL,
   bool modelPar_given_POSTBGIDL,
   AdmsSensFadType & modelPar_POSTBGIDLD,
   bool modelPar_given_POSTBGIDLD,
   AdmsSensFadType & modelPar_POCGIDL,
   bool modelPar_given_POCGIDL,
   AdmsSensFadType & modelPar_POCGIDLD,
   bool modelPar_given_POCGIDLD,
   AdmsSensFadType & modelPar_POCOX,
   bool modelPar_given_POCOX,
   AdmsSensFadType & modelPar_PLCOX,
   bool modelPar_given_PLCOX,
   AdmsSensFadType & modelPar_PWCOX,
   bool modelPar_given_PWCOX,
   AdmsSensFadType & modelPar_PLWCOX,
   bool modelPar_given_PLWCOX,
   AdmsSensFadType & modelPar_POCGOV,
   bool modelPar_given_POCGOV,
   AdmsSensFadType & modelPar_PLCGOV,
   bool modelPar_given_PLCGOV,
   AdmsSensFadType & modelPar_PWCGOV,
   bool modelPar_given_PWCGOV,
   AdmsSensFadType & modelPar_PLWCGOV,
   bool modelPar_given_PLWCGOV,
   AdmsSensFadType & modelPar_POCGOVD,
   bool modelPar_given_POCGOVD,
   AdmsSensFadType & modelPar_PLCGOVD,
   bool modelPar_given_PLCGOVD,
   AdmsSensFadType & modelPar_PWCGOVD,
   bool modelPar_given_PWCGOVD,
   AdmsSensFadType & modelPar_PLWCGOVD,
   bool modelPar_given_PLWCGOVD,
   AdmsSensFadType & modelPar_POCGBOV,
   bool modelPar_given_POCGBOV,
   AdmsSensFadType & modelPar_PLCGBOV,
   bool modelPar_given_PLCGBOV,
   AdmsSensFadType & modelPar_PWCGBOV,
   bool modelPar_given_PWCGBOV,
   AdmsSensFadType & modelPar_PLWCGBOV,
   bool modelPar_given_PLWCGBOV,
   AdmsSensFadType & modelPar_POCFR,
   bool modelPar_given_POCFR,
   AdmsSensFadType & modelPar_PLCFR,
   bool modelPar_given_PLCFR,
   AdmsSensFadType & modelPar_PWCFR,
   bool modelPar_given_PWCFR,
   AdmsSensFadType & modelPar_PLWCFR,
   bool modelPar_given_PLWCFR,
   AdmsSensFadType & modelPar_POCFRD,
   bool modelPar_given_POCFRD,
   AdmsSensFadType & modelPar_PLCFRD,
   bool modelPar_given_PLCFRD,
   AdmsSensFadType & modelPar_PWCFRD,
   bool modelPar_given_PWCFRD,
   AdmsSensFadType & modelPar_PLWCFRD,
   bool modelPar_given_PLWCFRD,
   AdmsSensFadType & modelPar_POFNT,
   bool modelPar_given_POFNT,
   AdmsSensFadType & modelPar_POFNTEXC,
   bool modelPar_given_POFNTEXC,
   AdmsSensFadType & modelPar_PLFNTEXC,
   bool modelPar_given_PLFNTEXC,
   AdmsSensFadType & modelPar_PWFNTEXC,
   bool modelPar_given_PWFNTEXC,
   AdmsSensFadType & modelPar_PLWFNTEXC,
   bool modelPar_given_PLWFNTEXC,
   AdmsSensFadType & modelPar_PONFA,
   bool modelPar_given_PONFA,
   AdmsSensFadType & modelPar_PLNFA,
   bool modelPar_given_PLNFA,
   AdmsSensFadType & modelPar_PWNFA,
   bool modelPar_given_PWNFA,
   AdmsSensFadType & modelPar_PLWNFA,
   bool modelPar_given_PLWNFA,
   AdmsSensFadType & modelPar_PONFB,
   bool modelPar_given_PONFB,
   AdmsSensFadType & modelPar_PLNFB,
   bool modelPar_given_PLNFB,
   AdmsSensFadType & modelPar_PWNFB,
   bool modelPar_given_PWNFB,
   AdmsSensFadType & modelPar_PLWNFB,
   bool modelPar_given_PLWNFB,
   AdmsSensFadType & modelPar_PONFC,
   bool modelPar_given_PONFC,
   AdmsSensFadType & modelPar_PLNFC,
   bool modelPar_given_PLNFC,
   AdmsSensFadType & modelPar_PWNFC,
   bool modelPar_given_PWNFC,
   AdmsSensFadType & modelPar_PLWNFC,
   bool modelPar_given_PLWNFC,
   AdmsSensFadType & modelPar_POEF,
   bool modelPar_given_POEF,
   AdmsSensFadType & modelPar_POVFBEDGE,
   bool modelPar_given_POVFBEDGE,
   AdmsSensFadType & modelPar_POSTVFBEDGE,
   bool modelPar_given_POSTVFBEDGE,
   AdmsSensFadType & modelPar_PLSTVFBEDGE,
   bool modelPar_given_PLSTVFBEDGE,
   AdmsSensFadType & modelPar_PWSTVFBEDGE,
   bool modelPar_given_PWSTVFBEDGE,
   AdmsSensFadType & modelPar_PLWSTVFBEDGE,
   bool modelPar_given_PLWSTVFBEDGE,
   AdmsSensFadType & modelPar_PODPHIBEDGE,
   bool modelPar_given_PODPHIBEDGE,
   AdmsSensFadType & modelPar_PLDPHIBEDGE,
   bool modelPar_given_PLDPHIBEDGE,
   AdmsSensFadType & modelPar_PWDPHIBEDGE,
   bool modelPar_given_PWDPHIBEDGE,
   AdmsSensFadType & modelPar_PLWDPHIBEDGE,
   bool modelPar_given_PLWDPHIBEDGE,
   AdmsSensFadType & modelPar_PONEFFEDGE,
   bool modelPar_given_PONEFFEDGE,
   AdmsSensFadType & modelPar_PLNEFFEDGE,
   bool modelPar_given_PLNEFFEDGE,
   AdmsSensFadType & modelPar_PWNEFFEDGE,
   bool modelPar_given_PWNEFFEDGE,
   AdmsSensFadType & modelPar_PLWNEFFEDGE,
   bool modelPar_given_PLWNEFFEDGE,
   AdmsSensFadType & modelPar_POCTEDGE,
   bool modelPar_given_POCTEDGE,
   AdmsSensFadType & modelPar_PLCTEDGE,
   bool modelPar_given_PLCTEDGE,
   AdmsSensFadType & modelPar_PWCTEDGE,
   bool modelPar_given_PWCTEDGE,
   AdmsSensFadType & modelPar_PLWCTEDGE,
   bool modelPar_given_PLWCTEDGE,
   AdmsSensFadType & modelPar_POBETNEDGE,
   bool modelPar_given_POBETNEDGE,
   AdmsSensFadType & modelPar_PLBETNEDGE,
   bool modelPar_given_PLBETNEDGE,
   AdmsSensFadType & modelPar_PWBETNEDGE,
   bool modelPar_given_PWBETNEDGE,
   AdmsSensFadType & modelPar_PLWBETNEDGE,
   bool modelPar_given_PLWBETNEDGE,
   AdmsSensFadType & modelPar_POSTBETEDGE,
   bool modelPar_given_POSTBETEDGE,
   AdmsSensFadType & modelPar_PLSTBETEDGE,
   bool modelPar_given_PLSTBETEDGE,
   AdmsSensFadType & modelPar_PWSTBETEDGE,
   bool modelPar_given_PWSTBETEDGE,
   AdmsSensFadType & modelPar_PLWSTBETEDGE,
   bool modelPar_given_PLWSTBETEDGE,
   AdmsSensFadType & modelPar_POPSCEEDGE,
   bool modelPar_given_POPSCEEDGE,
   AdmsSensFadType & modelPar_PLPSCEEDGE,
   bool modelPar_given_PLPSCEEDGE,
   AdmsSensFadType & modelPar_PWPSCEEDGE,
   bool modelPar_given_PWPSCEEDGE,
   AdmsSensFadType & modelPar_PLWPSCEEDGE,
   bool modelPar_given_PLWPSCEEDGE,
   AdmsSensFadType & modelPar_POPSCEBEDGE,
   bool modelPar_given_POPSCEBEDGE,
   AdmsSensFadType & modelPar_POPSCEDEDGE,
   bool modelPar_given_POPSCEDEDGE,
   AdmsSensFadType & modelPar_POCFEDGE,
   bool modelPar_given_POCFEDGE,
   AdmsSensFadType & modelPar_PLCFEDGE,
   bool modelPar_given_PLCFEDGE,
   AdmsSensFadType & modelPar_PWCFEDGE,
   bool modelPar_given_PWCFEDGE,
   AdmsSensFadType & modelPar_PLWCFEDGE,
   bool modelPar_given_PLWCFEDGE,
   AdmsSensFadType & modelPar_POCFDEDGE,
   bool modelPar_given_POCFDEDGE,
   AdmsSensFadType & modelPar_POCFBEDGE,
   bool modelPar_given_POCFBEDGE,
   AdmsSensFadType & modelPar_POFNTEDGE,
   bool modelPar_given_POFNTEDGE,
   AdmsSensFadType & modelPar_PONFAEDGE,
   bool modelPar_given_PONFAEDGE,
   AdmsSensFadType & modelPar_PLNFAEDGE,
   bool modelPar_given_PLNFAEDGE,
   AdmsSensFadType & modelPar_PWNFAEDGE,
   bool modelPar_given_PWNFAEDGE,
   AdmsSensFadType & modelPar_PLWNFAEDGE,
   bool modelPar_given_PLWNFAEDGE,
   AdmsSensFadType & modelPar_PONFBEDGE,
   bool modelPar_given_PONFBEDGE,
   AdmsSensFadType & modelPar_PLNFBEDGE,
   bool modelPar_given_PLNFBEDGE,
   AdmsSensFadType & modelPar_PWNFBEDGE,
   bool modelPar_given_PWNFBEDGE,
   AdmsSensFadType & modelPar_PLWNFBEDGE,
   bool modelPar_given_PLWNFBEDGE,
   AdmsSensFadType & modelPar_PONFCEDGE,
   bool modelPar_given_PONFCEDGE,
   AdmsSensFadType & modelPar_PLNFCEDGE,
   bool modelPar_given_PLNFCEDGE,
   AdmsSensFadType & modelPar_PWNFCEDGE,
   bool modelPar_given_PWNFCEDGE,
   AdmsSensFadType & modelPar_PLWNFCEDGE,
   bool modelPar_given_PLWNFCEDGE,
   AdmsSensFadType & modelPar_POEFEDGE,
   bool modelPar_given_POEFEDGE,
   AdmsSensFadType & modelPar_POKVTHOWE,
   bool modelPar_given_POKVTHOWE,
   AdmsSensFadType & modelPar_PLKVTHOWE,
   bool modelPar_given_PLKVTHOWE,
   AdmsSensFadType & modelPar_PWKVTHOWE,
   bool modelPar_given_PWKVTHOWE,
   AdmsSensFadType & modelPar_PLWKVTHOWE,
   bool modelPar_given_PLWKVTHOWE,
   AdmsSensFadType & modelPar_POKUOWE,
   bool modelPar_given_POKUOWE,
   AdmsSensFadType & modelPar_PLKUOWE,
   bool modelPar_given_PLKUOWE,
   AdmsSensFadType & modelPar_PWKUOWE,
   bool modelPar_given_PWKUOWE,
   AdmsSensFadType & modelPar_PLWKUOWE,
   bool modelPar_given_PLWKUOWE,
   AdmsSensFadType & modelPar_LMIN,
   bool modelPar_given_LMIN,
   AdmsSensFadType & modelPar_LMAX,
   bool modelPar_given_LMAX,
   AdmsSensFadType & modelPar_WMIN,
   bool modelPar_given_WMIN,
   AdmsSensFadType & modelPar_WMAX,
   bool modelPar_given_WMAX,
   AdmsSensFadType & modelPar_LVARO,
   bool modelPar_given_LVARO,
   AdmsSensFadType & modelPar_LVARL,
   bool modelPar_given_LVARL,
   AdmsSensFadType & modelPar_LVARW,
   bool modelPar_given_LVARW,
   AdmsSensFadType & modelPar_LAP,
   bool modelPar_given_LAP,
   AdmsSensFadType & modelPar_WVARO,
   bool modelPar_given_WVARO,
   AdmsSensFadType & modelPar_WVARL,
   bool modelPar_given_WVARL,
   AdmsSensFadType & modelPar_WVARW,
   bool modelPar_given_WVARW,
   AdmsSensFadType & modelPar_WOT,
   bool modelPar_given_WOT,
   AdmsSensFadType & modelPar_DLQ,
   bool modelPar_given_DLQ,
   AdmsSensFadType & modelPar_DWQ,
   bool modelPar_given_DWQ,
   AdmsSensFadType & modelPar_VFBO,
   bool modelPar_given_VFBO,
   AdmsSensFadType & modelPar_VFBL,
   bool modelPar_given_VFBL,
   AdmsSensFadType & modelPar_VFBW,
   bool modelPar_given_VFBW,
   AdmsSensFadType & modelPar_VFBLW,
   bool modelPar_given_VFBLW,
   AdmsSensFadType & modelPar_STVFBO,
   bool modelPar_given_STVFBO,
   AdmsSensFadType & modelPar_STVFBL,
   bool modelPar_given_STVFBL,
   AdmsSensFadType & modelPar_STVFBW,
   bool modelPar_given_STVFBW,
   AdmsSensFadType & modelPar_STVFBLW,
   bool modelPar_given_STVFBLW,
   AdmsSensFadType & modelPar_TOXO,
   bool modelPar_given_TOXO,
   AdmsSensFadType & modelPar_EPSROXO,
   bool modelPar_given_EPSROXO,
   AdmsSensFadType & modelPar_NSUBO,
   bool modelPar_given_NSUBO,
   AdmsSensFadType & modelPar_NSUBW,
   bool modelPar_given_NSUBW,
   AdmsSensFadType & modelPar_WSEG,
   bool modelPar_given_WSEG,
   AdmsSensFadType & modelPar_NPCK,
   bool modelPar_given_NPCK,
   AdmsSensFadType & modelPar_NPCKW,
   bool modelPar_given_NPCKW,
   AdmsSensFadType & modelPar_WSEGP,
   bool modelPar_given_WSEGP,
   AdmsSensFadType & modelPar_LPCK,
   bool modelPar_given_LPCK,
   AdmsSensFadType & modelPar_LPCKW,
   bool modelPar_given_LPCKW,
   AdmsSensFadType & modelPar_FOL1,
   bool modelPar_given_FOL1,
   AdmsSensFadType & modelPar_FOL2,
   bool modelPar_given_FOL2,
   AdmsSensFadType & modelPar_FACNEFFACO,
   bool modelPar_given_FACNEFFACO,
   AdmsSensFadType & modelPar_FACNEFFACL,
   bool modelPar_given_FACNEFFACL,
   AdmsSensFadType & modelPar_FACNEFFACW,
   bool modelPar_given_FACNEFFACW,
   AdmsSensFadType & modelPar_FACNEFFACLW,
   bool modelPar_given_FACNEFFACLW,
   AdmsSensFadType & modelPar_GFACNUDO,
   bool modelPar_given_GFACNUDO,
   AdmsSensFadType & modelPar_GFACNUDL,
   bool modelPar_given_GFACNUDL,
   AdmsSensFadType & modelPar_GFACNUDLEXP,
   bool modelPar_given_GFACNUDLEXP,
   AdmsSensFadType & modelPar_GFACNUDW,
   bool modelPar_given_GFACNUDW,
   AdmsSensFadType & modelPar_GFACNUDLW,
   bool modelPar_given_GFACNUDLW,
   AdmsSensFadType & modelPar_VSBNUDO,
   bool modelPar_given_VSBNUDO,
   AdmsSensFadType & modelPar_DVSBNUDO,
   bool modelPar_given_DVSBNUDO,
   AdmsSensFadType & modelPar_VNSUBO,
   bool modelPar_given_VNSUBO,
   AdmsSensFadType & modelPar_NSLPO,
   bool modelPar_given_NSLPO,
   AdmsSensFadType & modelPar_DNSUBO,
   bool modelPar_given_DNSUBO,
   AdmsSensFadType & modelPar_DPHIBO,
   bool modelPar_given_DPHIBO,
   AdmsSensFadType & modelPar_DPHIBL,
   bool modelPar_given_DPHIBL,
   AdmsSensFadType & modelPar_DPHIBLEXP,
   bool modelPar_given_DPHIBLEXP,
   AdmsSensFadType & modelPar_DPHIBW,
   bool modelPar_given_DPHIBW,
   AdmsSensFadType & modelPar_DPHIBLW,
   bool modelPar_given_DPHIBLW,
   AdmsSensFadType & modelPar_DELVTACO,
   bool modelPar_given_DELVTACO,
   AdmsSensFadType & modelPar_DELVTACL,
   bool modelPar_given_DELVTACL,
   AdmsSensFadType & modelPar_DELVTACLEXP,
   bool modelPar_given_DELVTACLEXP,
   AdmsSensFadType & modelPar_DELVTACW,
   bool modelPar_given_DELVTACW,
   AdmsSensFadType & modelPar_DELVTACLW,
   bool modelPar_given_DELVTACLW,
   AdmsSensFadType & modelPar_NPO,
   bool modelPar_given_NPO,
   AdmsSensFadType & modelPar_NPL,
   bool modelPar_given_NPL,
   AdmsSensFadType & modelPar_CTO,
   bool modelPar_given_CTO,
   AdmsSensFadType & modelPar_CTL,
   bool modelPar_given_CTL,
   AdmsSensFadType & modelPar_CTLEXP,
   bool modelPar_given_CTLEXP,
   AdmsSensFadType & modelPar_CTW,
   bool modelPar_given_CTW,
   AdmsSensFadType & modelPar_CTLW,
   bool modelPar_given_CTLW,
   AdmsSensFadType & modelPar_TOXOVO,
   bool modelPar_given_TOXOVO,
   AdmsSensFadType & modelPar_TOXOVDO,
   bool modelPar_given_TOXOVDO,
   AdmsSensFadType & modelPar_LOV,
   bool modelPar_given_LOV,
   AdmsSensFadType & modelPar_LOVD,
   bool modelPar_given_LOVD,
   AdmsSensFadType & modelPar_NOVO,
   bool modelPar_given_NOVO,
   AdmsSensFadType & modelPar_NOVDO,
   bool modelPar_given_NOVDO,
   AdmsSensFadType & modelPar_CFL,
   bool modelPar_given_CFL,
   AdmsSensFadType & modelPar_CFLEXP,
   bool modelPar_given_CFLEXP,
   AdmsSensFadType & modelPar_CFW,
   bool modelPar_given_CFW,
   AdmsSensFadType & modelPar_CFDO,
   bool modelPar_given_CFDO,
   AdmsSensFadType & modelPar_CFBO,
   bool modelPar_given_CFBO,
   AdmsSensFadType & modelPar_PSCEL,
   bool modelPar_given_PSCEL,
   AdmsSensFadType & modelPar_PSCELEXP,
   bool modelPar_given_PSCELEXP,
   AdmsSensFadType & modelPar_PSCEW,
   bool modelPar_given_PSCEW,
   AdmsSensFadType & modelPar_PSCEBO,
   bool modelPar_given_PSCEBO,
   AdmsSensFadType & modelPar_PSCEDO,
   bool modelPar_given_PSCEDO,
   AdmsSensFadType & modelPar_UO,
   bool modelPar_given_UO,
   AdmsSensFadType & modelPar_FBET1,
   bool modelPar_given_FBET1,
   AdmsSensFadType & modelPar_FBET1W,
   bool modelPar_given_FBET1W,
   AdmsSensFadType & modelPar_LP1,
   bool modelPar_given_LP1,
   AdmsSensFadType & modelPar_LP1W,
   bool modelPar_given_LP1W,
   AdmsSensFadType & modelPar_FBET2,
   bool modelPar_given_FBET2,
   AdmsSensFadType & modelPar_LP2,
   bool modelPar_given_LP2,
   AdmsSensFadType & modelPar_BETW1,
   bool modelPar_given_BETW1,
   AdmsSensFadType & modelPar_BETW2,
   bool modelPar_given_BETW2,
   AdmsSensFadType & modelPar_WBET,
   bool modelPar_given_WBET,
   AdmsSensFadType & modelPar_STBETO,
   bool modelPar_given_STBETO,
   AdmsSensFadType & modelPar_STBETL,
   bool modelPar_given_STBETL,
   AdmsSensFadType & modelPar_STBETW,
   bool modelPar_given_STBETW,
   AdmsSensFadType & modelPar_STBETLW,
   bool modelPar_given_STBETLW,
   AdmsSensFadType & modelPar_MUEO,
   bool modelPar_given_MUEO,
   AdmsSensFadType & modelPar_MUEW,
   bool modelPar_given_MUEW,
   AdmsSensFadType & modelPar_STMUEO,
   bool modelPar_given_STMUEO,
   AdmsSensFadType & modelPar_THEMUO,
   bool modelPar_given_THEMUO,
   AdmsSensFadType & modelPar_STTHEMUO,
   bool modelPar_given_STTHEMUO,
   AdmsSensFadType & modelPar_CSO,
   bool modelPar_given_CSO,
   AdmsSensFadType & modelPar_CSL,
   bool modelPar_given_CSL,
   AdmsSensFadType & modelPar_CSLEXP,
   bool modelPar_given_CSLEXP,
   AdmsSensFadType & modelPar_CSW,
   bool modelPar_given_CSW,
   AdmsSensFadType & modelPar_CSLW,
   bool modelPar_given_CSLW,
   AdmsSensFadType & modelPar_STCSO,
   bool modelPar_given_STCSO,
   AdmsSensFadType & modelPar_XCORO,
   bool modelPar_given_XCORO,
   AdmsSensFadType & modelPar_XCORL,
   bool modelPar_given_XCORL,
   AdmsSensFadType & modelPar_XCORW,
   bool modelPar_given_XCORW,
   AdmsSensFadType & modelPar_XCORLW,
   bool modelPar_given_XCORLW,
   AdmsSensFadType & modelPar_STXCORO,
   bool modelPar_given_STXCORO,
   AdmsSensFadType & modelPar_FETAO,
   bool modelPar_given_FETAO,
   AdmsSensFadType & modelPar_RSW1,
   bool modelPar_given_RSW1,
   AdmsSensFadType & modelPar_RSW2,
   bool modelPar_given_RSW2,
   AdmsSensFadType & modelPar_STRSO,
   bool modelPar_given_STRSO,
   AdmsSensFadType & modelPar_RSBO,
   bool modelPar_given_RSBO,
   AdmsSensFadType & modelPar_RSGO,
   bool modelPar_given_RSGO,
   AdmsSensFadType & modelPar_THESATO,
   bool modelPar_given_THESATO,
   AdmsSensFadType & modelPar_THESATL,
   bool modelPar_given_THESATL,
   AdmsSensFadType & modelPar_THESATLEXP,
   bool modelPar_given_THESATLEXP,
   AdmsSensFadType & modelPar_THESATW,
   bool modelPar_given_THESATW,
   AdmsSensFadType & modelPar_THESATLW,
   bool modelPar_given_THESATLW,
   AdmsSensFadType & modelPar_STTHESATO,
   bool modelPar_given_STTHESATO,
   AdmsSensFadType & modelPar_STTHESATL,
   bool modelPar_given_STTHESATL,
   AdmsSensFadType & modelPar_STTHESATW,
   bool modelPar_given_STTHESATW,
   AdmsSensFadType & modelPar_STTHESATLW,
   bool modelPar_given_STTHESATLW,
   AdmsSensFadType & modelPar_THESATBO,
   bool modelPar_given_THESATBO,
   AdmsSensFadType & modelPar_THESATGO,
   bool modelPar_given_THESATGO,
   AdmsSensFadType & modelPar_AXO,
   bool modelPar_given_AXO,
   AdmsSensFadType & modelPar_AXL,
   bool modelPar_given_AXL,
   AdmsSensFadType & modelPar_ALPL,
   bool modelPar_given_ALPL,
   AdmsSensFadType & modelPar_ALPLEXP,
   bool modelPar_given_ALPLEXP,
   AdmsSensFadType & modelPar_ALPW,
   bool modelPar_given_ALPW,
   AdmsSensFadType & modelPar_ALP1L1,
   bool modelPar_given_ALP1L1,
   AdmsSensFadType & modelPar_ALP1LEXP,
   bool modelPar_given_ALP1LEXP,
   AdmsSensFadType & modelPar_ALP1L2,
   bool modelPar_given_ALP1L2,
   AdmsSensFadType & modelPar_ALP1W,
   bool modelPar_given_ALP1W,
   AdmsSensFadType & modelPar_ALP2L1,
   bool modelPar_given_ALP2L1,
   AdmsSensFadType & modelPar_ALP2LEXP,
   bool modelPar_given_ALP2LEXP,
   AdmsSensFadType & modelPar_ALP2L2,
   bool modelPar_given_ALP2L2,
   AdmsSensFadType & modelPar_ALP2W,
   bool modelPar_given_ALP2W,
   AdmsSensFadType & modelPar_VPO,
   bool modelPar_given_VPO,
   AdmsSensFadType & modelPar_A1O,
   bool modelPar_given_A1O,
   AdmsSensFadType & modelPar_A1L,
   bool modelPar_given_A1L,
   AdmsSensFadType & modelPar_A1W,
   bool modelPar_given_A1W,
   AdmsSensFadType & modelPar_A2O,
   bool modelPar_given_A2O,
   AdmsSensFadType & modelPar_STA2O,
   bool modelPar_given_STA2O,
   AdmsSensFadType & modelPar_A3O,
   bool modelPar_given_A3O,
   AdmsSensFadType & modelPar_A3L,
   bool modelPar_given_A3L,
   AdmsSensFadType & modelPar_A3W,
   bool modelPar_given_A3W,
   AdmsSensFadType & modelPar_A4O,
   bool modelPar_given_A4O,
   AdmsSensFadType & modelPar_A4L,
   bool modelPar_given_A4L,
   AdmsSensFadType & modelPar_A4W,
   bool modelPar_given_A4W,
   AdmsSensFadType & modelPar_GCOO,
   bool modelPar_given_GCOO,
   AdmsSensFadType & modelPar_IGINVLW,
   bool modelPar_given_IGINVLW,
   AdmsSensFadType & modelPar_IGOVW,
   bool modelPar_given_IGOVW,
   AdmsSensFadType & modelPar_IGOVDW,
   bool modelPar_given_IGOVDW,
   AdmsSensFadType & modelPar_STIGO,
   bool modelPar_given_STIGO,
   AdmsSensFadType & modelPar_GC2O,
   bool modelPar_given_GC2O,
   AdmsSensFadType & modelPar_GC3O,
   bool modelPar_given_GC3O,
   AdmsSensFadType & modelPar_CHIBO,
   bool modelPar_given_CHIBO,
   AdmsSensFadType & modelPar_AGIDLW,
   bool modelPar_given_AGIDLW,
   AdmsSensFadType & modelPar_AGIDLDW,
   bool modelPar_given_AGIDLDW,
   AdmsSensFadType & modelPar_BGIDLO,
   bool modelPar_given_BGIDLO,
   AdmsSensFadType & modelPar_BGIDLDO,
   bool modelPar_given_BGIDLDO,
   AdmsSensFadType & modelPar_STBGIDLO,
   bool modelPar_given_STBGIDLO,
   AdmsSensFadType & modelPar_STBGIDLDO,
   bool modelPar_given_STBGIDLDO,
   AdmsSensFadType & modelPar_CGIDLO,
   bool modelPar_given_CGIDLO,
   AdmsSensFadType & modelPar_CGIDLDO,
   bool modelPar_given_CGIDLDO,
   AdmsSensFadType & modelPar_CGBOVL,
   bool modelPar_given_CGBOVL,
   AdmsSensFadType & modelPar_CFRW,
   bool modelPar_given_CFRW,
   AdmsSensFadType & modelPar_CFRDW,
   bool modelPar_given_CFRDW,
   AdmsSensFadType & modelPar_FNTO,
   bool modelPar_given_FNTO,
   AdmsSensFadType & modelPar_FNTEXCL,
   bool modelPar_given_FNTEXCL,
   AdmsSensFadType & modelPar_NFALW,
   bool modelPar_given_NFALW,
   AdmsSensFadType & modelPar_NFBLW,
   bool modelPar_given_NFBLW,
   AdmsSensFadType & modelPar_NFCLW,
   bool modelPar_given_NFCLW,
   AdmsSensFadType & modelPar_EFO,
   bool modelPar_given_EFO,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_ALPNOI,
   bool modelPar_given_ALPNOI,
   AdmsSensFadType & modelPar_WEDGE,
   bool modelPar_given_WEDGE,
   AdmsSensFadType & modelPar_WEDGEW,
   bool modelPar_given_WEDGEW,
   AdmsSensFadType & modelPar_VFBEDGEO,
   bool modelPar_given_VFBEDGEO,
   AdmsSensFadType & modelPar_STVFBEDGEO,
   bool modelPar_given_STVFBEDGEO,
   AdmsSensFadType & modelPar_STVFBEDGEL,
   bool modelPar_given_STVFBEDGEL,
   AdmsSensFadType & modelPar_STVFBEDGEW,
   bool modelPar_given_STVFBEDGEW,
   AdmsSensFadType & modelPar_STVFBEDGELW,
   bool modelPar_given_STVFBEDGELW,
   AdmsSensFadType & modelPar_DPHIBEDGEO,
   bool modelPar_given_DPHIBEDGEO,
   AdmsSensFadType & modelPar_DPHIBEDGEL,
   bool modelPar_given_DPHIBEDGEL,
   AdmsSensFadType & modelPar_DPHIBEDGELEXP,
   bool modelPar_given_DPHIBEDGELEXP,
   AdmsSensFadType & modelPar_DPHIBEDGEW,
   bool modelPar_given_DPHIBEDGEW,
   AdmsSensFadType & modelPar_DPHIBEDGELW,
   bool modelPar_given_DPHIBEDGELW,
   AdmsSensFadType & modelPar_NSUBEDGEO,
   bool modelPar_given_NSUBEDGEO,
   AdmsSensFadType & modelPar_NSUBEDGEL,
   bool modelPar_given_NSUBEDGEL,
   AdmsSensFadType & modelPar_NSUBEDGEW,
   bool modelPar_given_NSUBEDGEW,
   AdmsSensFadType & modelPar_NSUBEDGELW,
   bool modelPar_given_NSUBEDGELW,
   AdmsSensFadType & modelPar_CTEDGEO,
   bool modelPar_given_CTEDGEO,
   AdmsSensFadType & modelPar_CTEDGEL,
   bool modelPar_given_CTEDGEL,
   AdmsSensFadType & modelPar_CTEDGELEXP,
   bool modelPar_given_CTEDGELEXP,
   AdmsSensFadType & modelPar_FBETEDGE,
   bool modelPar_given_FBETEDGE,
   AdmsSensFadType & modelPar_LPEDGE,
   bool modelPar_given_LPEDGE,
   AdmsSensFadType & modelPar_BETEDGEW,
   bool modelPar_given_BETEDGEW,
   AdmsSensFadType & modelPar_STBETEDGEO,
   bool modelPar_given_STBETEDGEO,
   AdmsSensFadType & modelPar_STBETEDGEL,
   bool modelPar_given_STBETEDGEL,
   AdmsSensFadType & modelPar_STBETEDGEW,
   bool modelPar_given_STBETEDGEW,
   AdmsSensFadType & modelPar_STBETEDGELW,
   bool modelPar_given_STBETEDGELW,
   AdmsSensFadType & modelPar_PSCEEDGEL,
   bool modelPar_given_PSCEEDGEL,
   AdmsSensFadType & modelPar_PSCEEDGELEXP,
   bool modelPar_given_PSCEEDGELEXP,
   AdmsSensFadType & modelPar_PSCEEDGEW,
   bool modelPar_given_PSCEEDGEW,
   AdmsSensFadType & modelPar_PSCEBEDGEO,
   bool modelPar_given_PSCEBEDGEO,
   AdmsSensFadType & modelPar_PSCEDEDGEO,
   bool modelPar_given_PSCEDEDGEO,
   AdmsSensFadType & modelPar_CFEDGEL,
   bool modelPar_given_CFEDGEL,
   AdmsSensFadType & modelPar_CFEDGELEXP,
   bool modelPar_given_CFEDGELEXP,
   AdmsSensFadType & modelPar_CFEDGEW,
   bool modelPar_given_CFEDGEW,
   AdmsSensFadType & modelPar_CFDEDGEO,
   bool modelPar_given_CFDEDGEO,
   AdmsSensFadType & modelPar_CFBEDGEO,
   bool modelPar_given_CFBEDGEO,
   AdmsSensFadType & modelPar_FNTEDGEO,
   bool modelPar_given_FNTEDGEO,
   AdmsSensFadType & modelPar_NFAEDGELW,
   bool modelPar_given_NFAEDGELW,
   AdmsSensFadType & modelPar_NFBEDGELW,
   bool modelPar_given_NFBEDGELW,
   AdmsSensFadType & modelPar_NFCEDGELW,
   bool modelPar_given_NFCEDGELW,
   AdmsSensFadType & modelPar_EFEDGEO,
   bool modelPar_given_EFEDGEO,
   AdmsSensFadType & modelPar_KVTHOWEO,
   bool modelPar_given_KVTHOWEO,
   AdmsSensFadType & modelPar_KVTHOWEL,
   bool modelPar_given_KVTHOWEL,
   AdmsSensFadType & modelPar_KVTHOWEW,
   bool modelPar_given_KVTHOWEW,
   AdmsSensFadType & modelPar_KVTHOWELW,
   bool modelPar_given_KVTHOWELW,
   AdmsSensFadType & modelPar_KUOWEO,
   bool modelPar_given_KUOWEO,
   AdmsSensFadType & modelPar_KUOWEL,
   bool modelPar_given_KUOWEL,
   AdmsSensFadType & modelPar_KUOWEW,
   bool modelPar_given_KUOWEW,
   AdmsSensFadType & modelPar_KUOWELW,
   bool modelPar_given_KUOWELW,
   AdmsSensFadType & modelPar_RGO,
   bool modelPar_given_RGO,
   AdmsSensFadType & modelPar_RINT,
   bool modelPar_given_RINT,
   AdmsSensFadType & modelPar_RVPOLY,
   bool modelPar_given_RVPOLY,
   AdmsSensFadType & modelPar_RSHG,
   bool modelPar_given_RSHG,
   AdmsSensFadType & modelPar_DLSIL,
   bool modelPar_given_DLSIL,
   AdmsSensFadType & modelPar_RSH,
   bool modelPar_given_RSH,
   AdmsSensFadType & modelPar_RSHD,
   bool modelPar_given_RSHD,
   AdmsSensFadType & modelPar_RBULKO,
   bool modelPar_given_RBULKO,
   AdmsSensFadType & modelPar_RWELLO,
   bool modelPar_given_RWELLO,
   AdmsSensFadType & modelPar_RJUNSO,
   bool modelPar_given_RJUNSO,
   AdmsSensFadType & modelPar_RJUNDO,
   bool modelPar_given_RJUNDO,
   AdmsSensFadType & modelPar_SAREF,
   bool modelPar_given_SAREF,
   AdmsSensFadType & modelPar_SBREF,
   bool modelPar_given_SBREF,
   AdmsSensFadType & modelPar_WLOD,
   bool modelPar_given_WLOD,
   AdmsSensFadType & modelPar_KUO,
   bool modelPar_given_KUO,
   AdmsSensFadType & modelPar_KVSAT,
   bool modelPar_given_KVSAT,
   AdmsSensFadType & modelPar_TKUO,
   bool modelPar_given_TKUO,
   AdmsSensFadType & modelPar_LKUO,
   bool modelPar_given_LKUO,
   AdmsSensFadType & modelPar_WKUO,
   bool modelPar_given_WKUO,
   AdmsSensFadType & modelPar_PKUO,
   bool modelPar_given_PKUO,
   AdmsSensFadType & modelPar_LLODKUO,
   bool modelPar_given_LLODKUO,
   AdmsSensFadType & modelPar_WLODKUO,
   bool modelPar_given_WLODKUO,
   AdmsSensFadType & modelPar_KVTHO,
   bool modelPar_given_KVTHO,
   AdmsSensFadType & modelPar_LKVTHO,
   bool modelPar_given_LKVTHO,
   AdmsSensFadType & modelPar_WKVTHO,
   bool modelPar_given_WKVTHO,
   AdmsSensFadType & modelPar_PKVTHO,
   bool modelPar_given_PKVTHO,
   AdmsSensFadType & modelPar_LLODVTH,
   bool modelPar_given_LLODVTH,
   AdmsSensFadType & modelPar_WLODVTH,
   bool modelPar_given_WLODVTH,
   AdmsSensFadType & modelPar_STETAO,
   bool modelPar_given_STETAO,
   AdmsSensFadType & modelPar_LODETAO,
   bool modelPar_given_LODETAO,
   AdmsSensFadType & modelPar_SCREF,
   bool modelPar_given_SCREF,
   AdmsSensFadType & modelPar_WEB,
   bool modelPar_given_WEB,
   AdmsSensFadType & modelPar_WEC,
   bool modelPar_given_WEC,
   AdmsSensFadType & modelPar_IMAX,
   bool modelPar_given_IMAX,
   AdmsSensFadType & modelPar_TRJ,
   bool modelPar_given_TRJ,
   AdmsSensFadType & modelPar_FREV,
   bool modelPar_given_FREV,
   AdmsSensFadType & modelPar_CJORBOT,
   bool modelPar_given_CJORBOT,
   AdmsSensFadType & modelPar_CJORSTI,
   bool modelPar_given_CJORSTI,
   AdmsSensFadType & modelPar_CJORGAT,
   bool modelPar_given_CJORGAT,
   AdmsSensFadType & modelPar_VBIRBOT,
   bool modelPar_given_VBIRBOT,
   AdmsSensFadType & modelPar_VBIRSTI,
   bool modelPar_given_VBIRSTI,
   AdmsSensFadType & modelPar_VBIRGAT,
   bool modelPar_given_VBIRGAT,
   AdmsSensFadType & modelPar_PBOT,
   bool modelPar_given_PBOT,
   AdmsSensFadType & modelPar_PSTI,
   bool modelPar_given_PSTI,
   AdmsSensFadType & modelPar_PGAT,
   bool modelPar_given_PGAT,
   AdmsSensFadType & modelPar_PHIGBOT,
   bool modelPar_given_PHIGBOT,
   AdmsSensFadType & modelPar_PHIGSTI,
   bool modelPar_given_PHIGSTI,
   AdmsSensFadType & modelPar_PHIGGAT,
   bool modelPar_given_PHIGGAT,
   AdmsSensFadType & modelPar_IDSATRBOT,
   bool modelPar_given_IDSATRBOT,
   AdmsSensFadType & modelPar_IDSATRSTI,
   bool modelPar_given_IDSATRSTI,
   AdmsSensFadType & modelPar_IDSATRGAT,
   bool modelPar_given_IDSATRGAT,
   AdmsSensFadType & modelPar_CSRHBOT,
   bool modelPar_given_CSRHBOT,
   AdmsSensFadType & modelPar_CSRHSTI,
   bool modelPar_given_CSRHSTI,
   AdmsSensFadType & modelPar_CSRHGAT,
   bool modelPar_given_CSRHGAT,
   AdmsSensFadType & modelPar_XJUNSTI,
   bool modelPar_given_XJUNSTI,
   AdmsSensFadType & modelPar_XJUNGAT,
   bool modelPar_given_XJUNGAT,
   AdmsSensFadType & modelPar_CTATBOT,
   bool modelPar_given_CTATBOT,
   AdmsSensFadType & modelPar_CTATSTI,
   bool modelPar_given_CTATSTI,
   AdmsSensFadType & modelPar_CTATGAT,
   bool modelPar_given_CTATGAT,
   AdmsSensFadType & modelPar_MEFFTATBOT,
   bool modelPar_given_MEFFTATBOT,
   AdmsSensFadType & modelPar_MEFFTATSTI,
   bool modelPar_given_MEFFTATSTI,
   AdmsSensFadType & modelPar_MEFFTATGAT,
   bool modelPar_given_MEFFTATGAT,
   AdmsSensFadType & modelPar_CBBTBOT,
   bool modelPar_given_CBBTBOT,
   AdmsSensFadType & modelPar_CBBTSTI,
   bool modelPar_given_CBBTSTI,
   AdmsSensFadType & modelPar_CBBTGAT,
   bool modelPar_given_CBBTGAT,
   AdmsSensFadType & modelPar_FBBTRBOT,
   bool modelPar_given_FBBTRBOT,
   AdmsSensFadType & modelPar_FBBTRSTI,
   bool modelPar_given_FBBTRSTI,
   AdmsSensFadType & modelPar_FBBTRGAT,
   bool modelPar_given_FBBTRGAT,
   AdmsSensFadType & modelPar_STFBBTBOT,
   bool modelPar_given_STFBBTBOT,
   AdmsSensFadType & modelPar_STFBBTSTI,
   bool modelPar_given_STFBBTSTI,
   AdmsSensFadType & modelPar_STFBBTGAT,
   bool modelPar_given_STFBBTGAT,
   AdmsSensFadType & modelPar_VBRBOT,
   bool modelPar_given_VBRBOT,
   AdmsSensFadType & modelPar_VBRSTI,
   bool modelPar_given_VBRSTI,
   AdmsSensFadType & modelPar_VBRGAT,
   bool modelPar_given_VBRGAT,
   AdmsSensFadType & modelPar_PBRBOT,
   bool modelPar_given_PBRBOT,
   AdmsSensFadType & modelPar_PBRSTI,
   bool modelPar_given_PBRSTI,
   AdmsSensFadType & modelPar_PBRGAT,
   bool modelPar_given_PBRGAT,
   AdmsSensFadType & modelPar_CJORBOTD,
   bool modelPar_given_CJORBOTD,
   AdmsSensFadType & modelPar_CJORSTID,
   bool modelPar_given_CJORSTID,
   AdmsSensFadType & modelPar_CJORGATD,
   bool modelPar_given_CJORGATD,
   AdmsSensFadType & modelPar_VBIRBOTD,
   bool modelPar_given_VBIRBOTD,
   AdmsSensFadType & modelPar_VBIRSTID,
   bool modelPar_given_VBIRSTID,
   AdmsSensFadType & modelPar_VBIRGATD,
   bool modelPar_given_VBIRGATD,
   AdmsSensFadType & modelPar_PBOTD,
   bool modelPar_given_PBOTD,
   AdmsSensFadType & modelPar_PSTID,
   bool modelPar_given_PSTID,
   AdmsSensFadType & modelPar_PGATD,
   bool modelPar_given_PGATD,
   AdmsSensFadType & modelPar_PHIGBOTD,
   bool modelPar_given_PHIGBOTD,
   AdmsSensFadType & modelPar_PHIGSTID,
   bool modelPar_given_PHIGSTID,
   AdmsSensFadType & modelPar_PHIGGATD,
   bool modelPar_given_PHIGGATD,
   AdmsSensFadType & modelPar_IDSATRBOTD,
   bool modelPar_given_IDSATRBOTD,
   AdmsSensFadType & modelPar_IDSATRSTID,
   bool modelPar_given_IDSATRSTID,
   AdmsSensFadType & modelPar_IDSATRGATD,
   bool modelPar_given_IDSATRGATD,
   AdmsSensFadType & modelPar_CSRHBOTD,
   bool modelPar_given_CSRHBOTD,
   AdmsSensFadType & modelPar_CSRHSTID,
   bool modelPar_given_CSRHSTID,
   AdmsSensFadType & modelPar_CSRHGATD,
   bool modelPar_given_CSRHGATD,
   AdmsSensFadType & modelPar_XJUNSTID,
   bool modelPar_given_XJUNSTID,
   AdmsSensFadType & modelPar_XJUNGATD,
   bool modelPar_given_XJUNGATD,
   AdmsSensFadType & modelPar_CTATBOTD,
   bool modelPar_given_CTATBOTD,
   AdmsSensFadType & modelPar_CTATSTID,
   bool modelPar_given_CTATSTID,
   AdmsSensFadType & modelPar_CTATGATD,
   bool modelPar_given_CTATGATD,
   AdmsSensFadType & modelPar_MEFFTATBOTD,
   bool modelPar_given_MEFFTATBOTD,
   AdmsSensFadType & modelPar_MEFFTATSTID,
   bool modelPar_given_MEFFTATSTID,
   AdmsSensFadType & modelPar_MEFFTATGATD,
   bool modelPar_given_MEFFTATGATD,
   AdmsSensFadType & modelPar_CBBTBOTD,
   bool modelPar_given_CBBTBOTD,
   AdmsSensFadType & modelPar_CBBTSTID,
   bool modelPar_given_CBBTSTID,
   AdmsSensFadType & modelPar_CBBTGATD,
   bool modelPar_given_CBBTGATD,
   AdmsSensFadType & modelPar_FBBTRBOTD,
   bool modelPar_given_FBBTRBOTD,
   AdmsSensFadType & modelPar_FBBTRSTID,
   bool modelPar_given_FBBTRSTID,
   AdmsSensFadType & modelPar_FBBTRGATD,
   bool modelPar_given_FBBTRGATD,
   AdmsSensFadType & modelPar_STFBBTBOTD,
   bool modelPar_given_STFBBTBOTD,
   AdmsSensFadType & modelPar_STFBBTSTID,
   bool modelPar_given_STFBBTSTID,
   AdmsSensFadType & modelPar_STFBBTGATD,
   bool modelPar_given_STFBBTGATD,
   AdmsSensFadType & modelPar_VBRBOTD,
   bool modelPar_given_VBRBOTD,
   AdmsSensFadType & modelPar_VBRSTID,
   bool modelPar_given_VBRSTID,
   AdmsSensFadType & modelPar_VBRGATD,
   bool modelPar_given_VBRGATD,
   AdmsSensFadType & modelPar_PBRBOTD,
   bool modelPar_given_PBRBOTD,
   AdmsSensFadType & modelPar_PBRSTID,
   bool modelPar_given_PBRSTID,
   AdmsSensFadType & modelPar_PBRGATD,
   bool modelPar_given_PBRGATD,
   AdmsSensFadType & modelPar_SWJUNEXP,
   bool modelPar_given_SWJUNEXP,
   AdmsSensFadType & modelPar_VJUNREF,
   bool modelPar_given_VJUNREF,
   AdmsSensFadType & modelPar_FJUNQ,
   bool modelPar_given_FJUNQ,
   AdmsSensFadType & modelPar_VJUNREFD,
   bool modelPar_given_VJUNREFD,
   AdmsSensFadType & modelPar_FJUNQD,
   bool modelPar_given_FJUNQD,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   int modelPar_SWGEO,
   bool modelPar_given_SWGEO,
   int modelPar_SWIGATE,
   bool modelPar_given_SWIGATE,
   int modelPar_SWIMPACT,
   bool modelPar_given_SWIMPACT,
   int modelPar_SWGIDL,
   bool modelPar_given_SWGIDL,
   int modelPar_SWJUNCAP,
   bool modelPar_given_SWJUNCAP,
   int modelPar_SWJUNASYM,
   bool modelPar_given_SWJUNASYM,
   int modelPar_SWNUD,
   bool modelPar_given_SWNUD,
   int modelPar_SWEDGE,
   bool modelPar_given_SWEDGE,
   int modelPar_SWDELVTAC,
   bool modelPar_given_SWDELVTAC,
   int modelPar_SWIGN,
   bool modelPar_given_SWIGN// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_TOXO_i,
   AdmsSensFadType & modelVar_EPSROXO_i,
   AdmsSensFadType & modelVar_NSUBO_i,
   AdmsSensFadType & modelVar_WSEG_i,
   AdmsSensFadType & modelVar_NPCK_i,
   AdmsSensFadType & modelVar_WSEGP_i,
   AdmsSensFadType & modelVar_LPCK_i,
   AdmsSensFadType & modelVar_TOXOVO_i,
   AdmsSensFadType & modelVar_TOXOVDO_i,
   AdmsSensFadType & modelVar_LOV_i,
   AdmsSensFadType & modelVar_LOVD_i,
   AdmsSensFadType & modelVar_LP1_i,
   AdmsSensFadType & modelVar_LP2_i,
   AdmsSensFadType & modelVar_WBET_i,
   AdmsSensFadType & modelVar_AXL_i,
   AdmsSensFadType & modelVar_ALP1L2_i,
   AdmsSensFadType & modelVar_ALP2L2_i,
   AdmsSensFadType & modelVar_SAREF_i,
   AdmsSensFadType & modelVar_SBREF_i,
   AdmsSensFadType & modelVar_KVSAT_i,
   AdmsSensFadType & modelVar_LLODKUO_i,
   AdmsSensFadType & modelVar_WLODKUO_i,
   AdmsSensFadType & modelVar_LLODVTH_i,
   AdmsSensFadType & modelVar_WLODVTH_i,
   AdmsSensFadType & modelVar_LODETAO_i,
   AdmsSensFadType & modelVar_SCREF_i,
   AdmsSensFadType & modelVar_WEB_i,
   AdmsSensFadType & modelVar_WEC_i,
   AdmsSensFadType & modelVar_RSHG_i,
   AdmsSensFadType & modelVar_RSH_i,
   AdmsSensFadType & modelVar_RSHD_i,
   AdmsSensFadType & modelVar_RINT_i,
   AdmsSensFadType & modelVar_RVPOLY_i,
   AdmsSensFadType & modelVar_NSUBEDGEO_i,
   AdmsSensFadType & modelVar_LPEDGE_i,
   AdmsSensFadType & modelVar_QMC_i,
   AdmsSensFadType & modelVar_rTa,
   AdmsSensFadType & modelVar_delTa,
   AdmsSensFadType & modelVar_phita,
   AdmsSensFadType & modelVar_inv_phita,
   AdmsSensFadType & modelVar_TKD,
   AdmsSensFadType & modelVar_delT,
   AdmsSensFadType & modelVar_rTn,
   AdmsSensFadType & modelVar_ln_rTn,
   AdmsSensFadType & modelVar_inv_phit,
   AdmsSensFadType & modelVar_Eg,
   AdmsSensFadType & modelVar_phibFac,
   AdmsSensFadType & modelVar_IMAX_i,
   AdmsSensFadType & modelVar_VBIRBOT_i,
   AdmsSensFadType & modelVar_VBIRSTI_i,
   AdmsSensFadType & modelVar_VBIRGAT_i,
   AdmsSensFadType & modelVar_PBOT_i,
   AdmsSensFadType & modelVar_PSTI_i,
   AdmsSensFadType & modelVar_PGAT_i,
   AdmsSensFadType & modelVar_CSRHBOT_i,
   AdmsSensFadType & modelVar_CSRHSTI_i,
   AdmsSensFadType & modelVar_CSRHGAT_i,
   AdmsSensFadType & modelVar_CTATBOT_i,
   AdmsSensFadType & modelVar_CTATSTI_i,
   AdmsSensFadType & modelVar_CTATGAT_i,
   AdmsSensFadType & modelVar_CBBTBOT_i,
   AdmsSensFadType & modelVar_CBBTSTI_i,
   AdmsSensFadType & modelVar_CBBTGAT_i,
   AdmsSensFadType & modelVar_VBRBOT_i,
   AdmsSensFadType & modelVar_VBRSTI_i,
   AdmsSensFadType & modelVar_VBRGAT_i,
   AdmsSensFadType & modelVar_PBRBOT_i,
   AdmsSensFadType & modelVar_PBRSTI_i,
   AdmsSensFadType & modelVar_PBRGAT_i,
   AdmsSensFadType & modelVar_SWJUNEXP_i,
   AdmsSensFadType & modelVar_VJUNREF_i,
   AdmsSensFadType & modelVar_FJUNQ_i,
   AdmsSensFadType & modelVar_phitr,
   AdmsSensFadType & modelVar_phitd,
   AdmsSensFadType & modelVar_phitdinv,
   AdmsSensFadType & modelVar_perfc,
   AdmsSensFadType & modelVar_berfc,
   AdmsSensFadType & modelVar_cerfc,
   AdmsSensFadType & modelVar_ftdbot,
   AdmsSensFadType & modelVar_ftdsti,
   AdmsSensFadType & modelVar_ftdgat,
   AdmsSensFadType & modelVar_idsatbot,
   AdmsSensFadType & modelVar_idsatsti,
   AdmsSensFadType & modelVar_idsatgat,
   AdmsSensFadType & modelVar_vbibot,
   AdmsSensFadType & modelVar_vbisti,
   AdmsSensFadType & modelVar_vbigat,
   AdmsSensFadType & modelVar_vbiinvbot,
   AdmsSensFadType & modelVar_vbiinvsti,
   AdmsSensFadType & modelVar_vbiinvgat,
   AdmsSensFadType & modelVar_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_minus_PGAT,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT,
   AdmsSensFadType & modelVar_cjobot,
   AdmsSensFadType & modelVar_cjosti,
   AdmsSensFadType & modelVar_cjogat,
   AdmsSensFadType & modelVar_qprefbot,
   AdmsSensFadType & modelVar_qprefsti,
   AdmsSensFadType & modelVar_qprefgat,
   AdmsSensFadType & modelVar_qpref2bot,
   AdmsSensFadType & modelVar_qpref2sti,
   AdmsSensFadType & modelVar_qpref2gat,
   AdmsSensFadType & modelVar_wdepnulrbot,
   AdmsSensFadType & modelVar_wdepnulrsti,
   AdmsSensFadType & modelVar_wdepnulrgat,
   AdmsSensFadType & modelVar_wdepnulrinvbot,
   AdmsSensFadType & modelVar_wdepnulrinvsti,
   AdmsSensFadType & modelVar_wdepnulrinvgat,
   AdmsSensFadType & modelVar_VBIRBOTinv,
   AdmsSensFadType & modelVar_VBIRSTIinv,
   AdmsSensFadType & modelVar_VBIRGATinv,
   AdmsSensFadType & modelVar_atatbot,
   AdmsSensFadType & modelVar_atatsti,
   AdmsSensFadType & modelVar_atatgat,
   AdmsSensFadType & modelVar_btatpartbot,
   AdmsSensFadType & modelVar_btatpartsti,
   AdmsSensFadType & modelVar_btatpartgat,
   AdmsSensFadType & modelVar_fbbtbot,
   AdmsSensFadType & modelVar_fbbtsti,
   AdmsSensFadType & modelVar_fbbtgat,
   AdmsSensFadType & modelVar_alphaav,
   AdmsSensFadType & modelVar_fstopbot,
   AdmsSensFadType & modelVar_fstopsti,
   AdmsSensFadType & modelVar_fstopgat,
   AdmsSensFadType & modelVar_VBRinvbot,
   AdmsSensFadType & modelVar_VBRinvsti,
   AdmsSensFadType & modelVar_VBRinvgat,
   AdmsSensFadType & modelVar_slopebot,
   AdmsSensFadType & modelVar_slopesti,
   AdmsSensFadType & modelVar_slopegat,
   AdmsSensFadType & modelVar_VBIRBOTD_i,
   AdmsSensFadType & modelVar_VBIRSTID_i,
   AdmsSensFadType & modelVar_VBIRGATD_i,
   AdmsSensFadType & modelVar_PBOTD_i,
   AdmsSensFadType & modelVar_PSTID_i,
   AdmsSensFadType & modelVar_PGATD_i,
   AdmsSensFadType & modelVar_CSRHBOTD_i,
   AdmsSensFadType & modelVar_CSRHSTID_i,
   AdmsSensFadType & modelVar_CSRHGATD_i,
   AdmsSensFadType & modelVar_CTATBOTD_i,
   AdmsSensFadType & modelVar_CTATSTID_i,
   AdmsSensFadType & modelVar_CTATGATD_i,
   AdmsSensFadType & modelVar_CBBTBOTD_i,
   AdmsSensFadType & modelVar_CBBTSTID_i,
   AdmsSensFadType & modelVar_CBBTGATD_i,
   AdmsSensFadType & modelVar_VBRBOTD_i,
   AdmsSensFadType & modelVar_VBRSTID_i,
   AdmsSensFadType & modelVar_VBRGATD_i,
   AdmsSensFadType & modelVar_PBRBOTD_i,
   AdmsSensFadType & modelVar_PBRSTID_i,
   AdmsSensFadType & modelVar_PBRGATD_i,
   AdmsSensFadType & modelVar_VJUNREFD_i,
   AdmsSensFadType & modelVar_FJUNQD_i,
   AdmsSensFadType & modelVar_ftdbot_d,
   AdmsSensFadType & modelVar_ftdsti_d,
   AdmsSensFadType & modelVar_ftdgat_d,
   AdmsSensFadType & modelVar_idsatbot_d,
   AdmsSensFadType & modelVar_idsatsti_d,
   AdmsSensFadType & modelVar_idsatgat_d,
   AdmsSensFadType & modelVar_vbibot_d,
   AdmsSensFadType & modelVar_vbisti_d,
   AdmsSensFadType & modelVar_vbigat_d,
   AdmsSensFadType & modelVar_vbiinvbot_d,
   AdmsSensFadType & modelVar_vbiinvsti_d,
   AdmsSensFadType & modelVar_vbiinvgat_d,
   AdmsSensFadType & modelVar_one_minus_PBOT_d,
   AdmsSensFadType & modelVar_one_minus_PSTI_d,
   AdmsSensFadType & modelVar_one_minus_PGAT_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT_d,
   AdmsSensFadType & modelVar_cjobot_d,
   AdmsSensFadType & modelVar_cjosti_d,
   AdmsSensFadType & modelVar_cjogat_d,
   AdmsSensFadType & modelVar_qprefbot_d,
   AdmsSensFadType & modelVar_qprefsti_d,
   AdmsSensFadType & modelVar_qprefgat_d,
   AdmsSensFadType & modelVar_qpref2bot_d,
   AdmsSensFadType & modelVar_qpref2sti_d,
   AdmsSensFadType & modelVar_qpref2gat_d,
   AdmsSensFadType & modelVar_wdepnulrbot_d,
   AdmsSensFadType & modelVar_wdepnulrsti_d,
   AdmsSensFadType & modelVar_wdepnulrgat_d,
   AdmsSensFadType & modelVar_wdepnulrinvbot_d,
   AdmsSensFadType & modelVar_wdepnulrinvsti_d,
   AdmsSensFadType & modelVar_wdepnulrinvgat_d,
   AdmsSensFadType & modelVar_VBIRBOTinv_d,
   AdmsSensFadType & modelVar_VBIRSTIinv_d,
   AdmsSensFadType & modelVar_VBIRGATinv_d,
   AdmsSensFadType & modelVar_atatbot_d,
   AdmsSensFadType & modelVar_atatsti_d,
   AdmsSensFadType & modelVar_atatgat_d,
   AdmsSensFadType & modelVar_btatpartbot_d,
   AdmsSensFadType & modelVar_btatpartsti_d,
   AdmsSensFadType & modelVar_btatpartgat_d,
   AdmsSensFadType & modelVar_fbbtbot_d,
   AdmsSensFadType & modelVar_fbbtsti_d,
   AdmsSensFadType & modelVar_fbbtgat_d,
   AdmsSensFadType & modelVar_fstopbot_d,
   AdmsSensFadType & modelVar_fstopsti_d,
   AdmsSensFadType & modelVar_fstopgat_d,
   AdmsSensFadType & modelVar_VBRinvbot_d,
   AdmsSensFadType & modelVar_VBRinvsti_d,
   AdmsSensFadType & modelVar_VBRinvgat_d,
   AdmsSensFadType & modelVar_slopebot_d,
   AdmsSensFadType & modelVar_slopesti_d,
   AdmsSensFadType & modelVar_slopegat_d,
   AdmsSensFadType & modelVar_phit,
   AdmsSensFadType & modelVar_nt0,
   AdmsSensFadType & modelVar_EPSSI,
   // non-reals
   int modelVar_CHNL_TYPE,
   int modelVar_SWGEO_i,
   int modelVar_SWIGATE_i,
   int modelVar_SWIMPACT_i,
   int modelVar_SWGIDL_i,
   int modelVar_SWJUNCAP_i,
   int modelVar_SWJUNASYM_i,
   int modelVar_SWNUD_i,
   int modelVar_SWEDGE_i,
   int modelVar_SWDELVTAC_i,
   int modelVar_SWIGN_i,
   double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
  AdmsSensFadType deltaEgat_d;
  AdmsSensFadType deltaEsti_d;
  AdmsSensFadType deltaEbot_d;
  AdmsSensFadType ubigat_d;
  AdmsSensFadType ubisti_d;
  AdmsSensFadType ubibot_d;
  AdmsSensFadType phigdgat_d;
  AdmsSensFadType phigdsti_d;
  AdmsSensFadType phigdbot_d;
  AdmsSensFadType phigrgat_d;
  AdmsSensFadType phigrsti_d;
  AdmsSensFadType phigrbot_d;
  AdmsSensFadType deltaEgat;
  AdmsSensFadType deltaEsti;
  AdmsSensFadType deltaEbot;
  AdmsSensFadType ubigat;
  AdmsSensFadType ubisti;
  AdmsSensFadType ubibot;
  AdmsSensFadType phigdgat;
  AdmsSensFadType phigdsti;
  AdmsSensFadType phigdbot;
  AdmsSensFadType deltaphigd;
  AdmsSensFadType phigrgat;
  AdmsSensFadType phigrsti;
  AdmsSensFadType phigrbot;
  AdmsSensFadType deltaphigr;
  AdmsSensFadType phitrinv;
  double KBOL_over_QELE;
  AdmsSensFadType auxt;
  AdmsSensFadType tkd;
  AdmsSensFadType tkr;
  AdmsSensFadType STFBBTGATD_i;
  AdmsSensFadType STFBBTSTID_i;
  AdmsSensFadType STFBBTBOTD_i;
  AdmsSensFadType FBBTRGATD_i;
  AdmsSensFadType FBBTRSTID_i;
  AdmsSensFadType FBBTRBOTD_i;
  AdmsSensFadType MEFFTATGATD_i;
  AdmsSensFadType MEFFTATSTID_i;
  AdmsSensFadType MEFFTATBOTD_i;
  AdmsSensFadType XJUNGATD_i;
  AdmsSensFadType XJUNSTID_i;
  AdmsSensFadType IDSATRGATD_i;
  AdmsSensFadType IDSATRSTID_i;
  AdmsSensFadType IDSATRBOTD_i;
  AdmsSensFadType PHIGGATD_i;
  AdmsSensFadType PHIGSTID_i;
  AdmsSensFadType PHIGBOTD_i;
  AdmsSensFadType CJORGATD_i;
  AdmsSensFadType CJORSTID_i;
  AdmsSensFadType CJORBOTD_i;
  AdmsSensFadType STFBBTGAT_i;
  AdmsSensFadType STFBBTSTI_i;
  AdmsSensFadType STFBBTBOT_i;
  AdmsSensFadType FBBTRGAT_i;
  AdmsSensFadType FBBTRSTI_i;
  AdmsSensFadType FBBTRBOT_i;
  AdmsSensFadType MEFFTATGAT_i;
  AdmsSensFadType MEFFTATSTI_i;
  AdmsSensFadType MEFFTATBOT_i;
  AdmsSensFadType XJUNGAT_i;
  AdmsSensFadType XJUNSTI_i;
  AdmsSensFadType IDSATRGAT_i;
  AdmsSensFadType IDSATRSTI_i;
  AdmsSensFadType IDSATRBOT_i;
  AdmsSensFadType PHIGGAT_i;
  AdmsSensFadType PHIGSTI_i;
  AdmsSensFadType PHIGBOT_i;
  AdmsSensFadType CJORGAT_i;
  AdmsSensFadType CJORSTI_i;
  AdmsSensFadType CJORBOT_i;
  AdmsSensFadType FREV_i;
  AdmsSensFadType TRJ_i;
  AdmsSensFadType TKD_sq;
  AdmsSensFadType TKA;
  AdmsSensFadType TKR;
  AdmsSensFadType TR_i;
  //Begin block initial_model
  {
    if ((modelPar_TYPE>=0))
    {
      modelVar_CHNL_TYPE = (+1);
    }
    else
    {
      modelVar_CHNL_TYPE = (-1);
    }
    modelVar_EPSSI = (8.8541878176E-12*11.8);
    {
      AdmsSensFadType value_floor_0 = floor((((modelPar_SWGEO>0.0)?((modelPar_SWGEO<2.0)?modelPar_SWGEO:2.0):0.0)+0.5));
      modelVar_SWGEO_i = floor((((modelPar_SWGEO>0.0)?((modelPar_SWGEO<2.0)?modelPar_SWGEO:2.0):0.0)+0.5));
    }
    {
      AdmsSensFadType value_floor_0 = floor((((modelPar_SWIGATE>0.0)?((modelPar_SWIGATE<1.0)?modelPar_SWIGATE:1.0):0.0)+0.5));
      modelVar_SWIGATE_i = floor((((modelPar_SWIGATE>0.0)?((modelPar_SWIGATE<1.0)?modelPar_SWIGATE:1.0):0.0)+0.5));
    }
    {
      AdmsSensFadType value_floor_0 = floor((((modelPar_SWIMPACT>0.0)?((modelPar_SWIMPACT<1.0)?modelPar_SWIMPACT:1.0):0.0)+0.5));
      modelVar_SWIMPACT_i = floor((((modelPar_SWIMPACT>0.0)?((modelPar_SWIMPACT<1.0)?modelPar_SWIMPACT:1.0):0.0)+0.5));
    }
    {
      AdmsSensFadType value_floor_0 = floor((((modelPar_SWGIDL>0.0)?((modelPar_SWGIDL<1.0)?modelPar_SWGIDL:1.0):0.0)+0.5));
      modelVar_SWGIDL_i = floor((((modelPar_SWGIDL>0.0)?((modelPar_SWGIDL<1.0)?modelPar_SWGIDL:1.0):0.0)+0.5));
    }
    {
      AdmsSensFadType value_floor_0 = floor((((modelPar_SWJUNCAP>0.0)?((modelPar_SWJUNCAP<3.0)?modelPar_SWJUNCAP:3.0):0.0)+0.5));
      modelVar_SWJUNCAP_i = floor((((modelPar_SWJUNCAP>0.0)?((modelPar_SWJUNCAP<3.0)?modelPar_SWJUNCAP:3.0):0.0)+0.5));
    }
    {
      AdmsSensFadType value_floor_0 = floor((((modelPar_SWJUNASYM>0.0)?((modelPar_SWJUNASYM<1.0)?modelPar_SWJUNASYM:1.0):0.0)+0.5));
      modelVar_SWJUNASYM_i = floor((((modelPar_SWJUNASYM>0.0)?((modelPar_SWJUNASYM<1.0)?modelPar_SWJUNASYM:1.0):0.0)+0.5));
    }
    {
      AdmsSensFadType value_floor_0 = floor((((modelPar_SWNUD>0.0)?((modelPar_SWNUD<2.0)?modelPar_SWNUD:2.0):0.0)+0.5));
      modelVar_SWNUD_i = floor((((modelPar_SWNUD>0.0)?((modelPar_SWNUD<2.0)?modelPar_SWNUD:2.0):0.0)+0.5));
    }
    {
      AdmsSensFadType value_floor_0 = floor((((modelPar_SWEDGE>0.0)?((modelPar_SWEDGE<1.0)?modelPar_SWEDGE:1.0):0.0)+0.5));
      modelVar_SWEDGE_i = floor((((modelPar_SWEDGE>0.0)?((modelPar_SWEDGE<1.0)?modelPar_SWEDGE:1.0):0.0)+0.5));
    }
    {
      AdmsSensFadType value_floor_0 = floor((((modelPar_SWDELVTAC>0.0)?((modelPar_SWDELVTAC<1.0)?modelPar_SWDELVTAC:1.0):0.0)+0.5));
      modelVar_SWDELVTAC_i = floor((((modelPar_SWDELVTAC>0.0)?((modelPar_SWDELVTAC<1.0)?modelPar_SWDELVTAC:1.0):0.0)+0.5));
    }
    {
      AdmsSensFadType value_floor_0 = floor((((modelPar_SWIGN>0.0)?((modelPar_SWIGN<1.0)?modelPar_SWIGN:1.0):0.0)+0.5));
      modelVar_SWIGN_i = floor((((modelPar_SWIGN>0.0)?((modelPar_SWIGN<1.0)?modelPar_SWIGN:1.0):0.0)+0.5));
    }
    modelVar_QMC_i = adms_ternary_op<AdmsSensFadType>((modelPar_QMC>0.0),modelPar_QMC,0.0);
    modelVar_TOXO_i = adms_ternary_op<AdmsSensFadType>((modelPar_TOXO>1.0e-10),modelPar_TOXO,1.0e-10);
    modelVar_EPSROXO_i = adms_ternary_op<AdmsSensFadType>((modelPar_EPSROXO>1.0),modelPar_EPSROXO,1.0);
    modelVar_NSUBO_i = adms_ternary_op<AdmsSensFadType>((modelPar_NSUBO>1.0e20),modelPar_NSUBO,1.0e20);
    modelVar_WSEG_i = adms_ternary_op<AdmsSensFadType>((modelPar_WSEG>1.0e-10),modelPar_WSEG,1.0e-10);
    modelVar_NPCK_i = adms_ternary_op<AdmsSensFadType>((modelPar_NPCK>0.0),modelPar_NPCK,0.0);
    modelVar_WSEGP_i = adms_ternary_op<AdmsSensFadType>((modelPar_WSEGP>1.0e-10),modelPar_WSEGP,1.0e-10);
    modelVar_LPCK_i = adms_ternary_op<AdmsSensFadType>((modelPar_LPCK>1.0e-10),modelPar_LPCK,1.0e-10);
    modelVar_TOXOVO_i = adms_ternary_op<AdmsSensFadType>((modelPar_TOXOVO>1.0e-10),modelPar_TOXOVO,1.0e-10);
    modelVar_TOXOVDO_i = adms_ternary_op<AdmsSensFadType>((modelPar_TOXOVDO>1.0e-10),modelPar_TOXOVDO,1.0e-10);
    modelVar_LOV_i = adms_ternary_op<AdmsSensFadType>((modelPar_LOV>0.0),modelPar_LOV,0.0);
    modelVar_LOVD_i = adms_ternary_op<AdmsSensFadType>((modelPar_LOVD>0.0),modelPar_LOVD,0.0);
    modelVar_LP1_i = adms_ternary_op<AdmsSensFadType>((modelPar_LP1>1.0e-10),modelPar_LP1,1.0e-10);
    modelVar_LP2_i = adms_ternary_op<AdmsSensFadType>((modelPar_LP2>1.0e-10),modelPar_LP2,1.0e-10);
    modelVar_WBET_i = adms_ternary_op<AdmsSensFadType>((modelPar_WBET>1.0e-10),modelPar_WBET,1.0e-10);
    modelVar_AXL_i = adms_ternary_op<AdmsSensFadType>((modelPar_AXL>0.0),modelPar_AXL,0.0);
    modelVar_ALP1L2_i = adms_ternary_op<AdmsSensFadType>((modelPar_ALP1L2>0.0),modelPar_ALP1L2,0.0);
    modelVar_ALP2L2_i = adms_ternary_op<AdmsSensFadType>((modelPar_ALP2L2>0.0),modelPar_ALP2L2,0.0);
    modelVar_SAREF_i = adms_ternary_op<AdmsSensFadType>((modelPar_SAREF>1.0e-9),modelPar_SAREF,1.0e-9);
    modelVar_SBREF_i = adms_ternary_op<AdmsSensFadType>((modelPar_SBREF>1.0e-9),modelPar_SBREF,1.0e-9);
    modelVar_KVSAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_KVSAT>(-1.0)),adms_ternary_op<AdmsSensFadType>((modelPar_KVSAT<1.0),modelPar_KVSAT,1.0),(-1.0));
    modelVar_LLODKUO_i = adms_ternary_op<AdmsSensFadType>((modelPar_LLODKUO>0.0),modelPar_LLODKUO,0.0);
    modelVar_WLODKUO_i = adms_ternary_op<AdmsSensFadType>((modelPar_WLODKUO>0.0),modelPar_WLODKUO,0.0);
    modelVar_LLODVTH_i = adms_ternary_op<AdmsSensFadType>((modelPar_LLODVTH>0.0),modelPar_LLODVTH,0.0);
    modelVar_WLODVTH_i = adms_ternary_op<AdmsSensFadType>((modelPar_WLODVTH>0.0),modelPar_WLODVTH,0.0);
    modelVar_LODETAO_i = adms_ternary_op<AdmsSensFadType>((modelPar_LODETAO>0.0),modelPar_LODETAO,0.0);
    modelVar_SCREF_i = adms_ternary_op<AdmsSensFadType>((modelPar_SCREF>0.0),modelPar_SCREF,0.0);
    modelVar_WEB_i = modelPar_WEB;
    modelVar_WEC_i = modelPar_WEC;
    modelVar_RSHG_i = adms_ternary_op<AdmsSensFadType>((modelPar_RSHG>0.0),modelPar_RSHG,0.0);
    modelVar_RSH_i = adms_ternary_op<AdmsSensFadType>((modelPar_RSH>0.0),modelPar_RSH,0.0);
    modelVar_RSHD_i = adms_ternary_op<AdmsSensFadType>((modelPar_RSHD>0.0),modelPar_RSHD,0.0);
    modelVar_RINT_i = adms_ternary_op<AdmsSensFadType>((modelPar_RINT>0.0),modelPar_RINT,0.0);
    modelVar_RVPOLY_i = adms_ternary_op<AdmsSensFadType>((modelPar_RVPOLY>0.0),modelPar_RVPOLY,0.0);
    modelVar_NSUBEDGEO_i = adms_ternary_op<AdmsSensFadType>((modelPar_NSUBEDGEO>1.0e20),modelPar_NSUBEDGEO,1.0e20);
    modelVar_LPEDGE_i = adms_ternary_op<AdmsSensFadType>((modelPar_LPEDGE>1.0e-10),modelPar_LPEDGE,1.0e-10);
    TR_i = adms_ternary_op<AdmsSensFadType>((modelPar_TR>(-273.0)),modelPar_TR,(-273.0));
    TKR = (273.15+TR_i);
    TKA = (admsTemperature+modelPar_DTA);
    modelVar_rTa = (TKA/TKR);
    modelVar_delTa = (TKA-TKR);
    modelVar_phita = ((TKA*1.3806505E-23)/1.6021918E-19);
    modelVar_inv_phita = (1.0/modelVar_phita);
    modelVar_TKD = TKA;
    TKD_sq = (modelVar_TKD*modelVar_TKD);
    modelVar_delT = (modelVar_TKD-TKR);
    modelVar_rTn = (TKR/modelVar_TKD);
    {
      AdmsSensFadType value_log_0 = log(modelVar_rTn);
      modelVar_ln_rTn = value_log_0;
    }
    modelVar_phit = ((modelVar_TKD*1.3806505E-23)/1.6021918E-19);
    modelVar_inv_phit = (1.0/modelVar_phit);
    modelVar_Eg = ((1.179-(9.025e-5*modelVar_TKD))-(3.05e-7*TKD_sq));
    modelVar_phibFac = ((((1.045+(4.5e-4*modelVar_TKD))*((0.523+(1.4e-3*modelVar_TKD))-(1.48e-6*TKD_sq)))*TKD_sq)/9.0E4);
    modelVar_phibFac = adms_ternary_op<AdmsSensFadType>((modelVar_phibFac>1.0E-3),modelVar_phibFac,1.0E-3);
    modelVar_nt0 = ((4.0*1.3806505E-23)*modelVar_TKD);
    TRJ_i = adms_ternary_op<AdmsSensFadType>((modelPar_TRJ>(-2.5e2)),modelPar_TRJ,(-2.5e2));
    modelVar_IMAX_i = adms_ternary_op<AdmsSensFadType>((modelPar_IMAX>1.0e-12),modelPar_IMAX,1.0e-12);
    FREV_i = adms_ternary_op<AdmsSensFadType>((modelPar_FREV>1.0e1),adms_ternary_op<AdmsSensFadType>((modelPar_FREV<1.0e10),modelPar_FREV,1.0e10),1.0e1);
    CJORBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORBOT>1.0e-12),modelPar_CJORBOT,1.0e-12);
    CJORSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORSTI>1.0e-18),modelPar_CJORSTI,1.0e-18);
    CJORGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORGAT>1.0e-18),modelPar_CJORGAT,1.0e-18);
    modelVar_VBIRBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRBOT>5.0e-2),modelPar_VBIRBOT,5.0e-2);
    modelVar_VBIRSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRSTI>5.0e-2),modelPar_VBIRSTI,5.0e-2);
    modelVar_VBIRGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRGAT>5.0e-2),modelPar_VBIRGAT,5.0e-2);
    modelVar_PBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBOT>5.0e-2),adms_ternary_op<AdmsSensFadType>((modelPar_PBOT<0.95),modelPar_PBOT,0.95),5.0e-2);
    modelVar_PSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_PSTI>5.0e-2),adms_ternary_op<AdmsSensFadType>((modelPar_PSTI<0.95),modelPar_PSTI,0.95),5.0e-2);
    modelVar_PGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_PGAT>5.0e-2),adms_ternary_op<AdmsSensFadType>((modelPar_PGAT<0.95),modelPar_PGAT,0.95),5.0e-2);
    PHIGBOT_i = modelPar_PHIGBOT;
    PHIGSTI_i = modelPar_PHIGSTI;
    PHIGGAT_i = modelPar_PHIGGAT;
    IDSATRBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRBOT>0.0),modelPar_IDSATRBOT,0.0);
    IDSATRSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRSTI>0.0),modelPar_IDSATRSTI,0.0);
    IDSATRGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRGAT>0.0),modelPar_IDSATRGAT,0.0);
    modelVar_CSRHBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHBOT>0.0),modelPar_CSRHBOT,0.0);
    modelVar_CSRHSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHSTI>0.0),modelPar_CSRHSTI,0.0);
    modelVar_CSRHGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHGAT>0.0),modelPar_CSRHGAT,0.0);
    XJUNSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_XJUNSTI>1.0e-9),modelPar_XJUNSTI,1.0e-9);
    XJUNGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_XJUNGAT>1.0e-9),modelPar_XJUNGAT,1.0e-9);
    modelVar_CTATBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATBOT>0.0),modelPar_CTATBOT,0.0);
    modelVar_CTATSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATSTI>0.0),modelPar_CTATSTI,0.0);
    modelVar_CTATGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATGAT>0.0),modelPar_CTATGAT,0.0);
    MEFFTATBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATBOT>1.0e-2),modelPar_MEFFTATBOT,1.0e-2);
    MEFFTATSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATSTI>1.0e-2),modelPar_MEFFTATSTI,1.0e-2);
    MEFFTATGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATGAT>1.0e-2),modelPar_MEFFTATGAT,1.0e-2);
    modelVar_CBBTBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTBOT>0.0),modelPar_CBBTBOT,0.0);
    modelVar_CBBTSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTSTI>0.0),modelPar_CBBTSTI,0.0);
    modelVar_CBBTGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTGAT>0.0),modelPar_CBBTGAT,0.0);
    FBBTRBOT_i = modelPar_FBBTRBOT;
    FBBTRSTI_i = modelPar_FBBTRSTI;
    FBBTRGAT_i = modelPar_FBBTRGAT;
    STFBBTBOT_i = modelPar_STFBBTBOT;
    STFBBTSTI_i = modelPar_STFBBTSTI;
    STFBBTGAT_i = modelPar_STFBBTGAT;
    modelVar_VBRBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRBOT>0.1),modelPar_VBRBOT,0.1);
    modelVar_VBRSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRSTI>0.1),modelPar_VBRSTI,0.1);
    modelVar_VBRGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRGAT>0.1),modelPar_VBRGAT,0.1);
    modelVar_PBRBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRBOT>0.1),modelPar_PBRBOT,0.1);
    modelVar_PBRSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRSTI>0.1),modelPar_PBRSTI,0.1);
    modelVar_PBRGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRGAT>0.1),modelPar_PBRGAT,0.1);
    modelVar_SWJUNEXP_i = 0.0;
    if ((modelPar_SWJUNEXP>0.5))
    {
      modelVar_SWJUNEXP_i = 1.0;
    }
    else
    {
      modelVar_SWJUNEXP_i = 0.0;
    }
    modelVar_VJUNREF_i = adms_ternary_op<AdmsSensFadType>((modelPar_VJUNREF>0.5),modelPar_VJUNREF,0.5);
    modelVar_FJUNQ_i = adms_ternary_op<AdmsSensFadType>((modelPar_FJUNQ>0.0),modelPar_FJUNQ,0.0);
    if ((modelPar_SWJUNASYM==0.0))
    {
      CJORBOTD_i = CJORBOT_i;
      CJORSTID_i = CJORSTI_i;
      CJORGATD_i = CJORGAT_i;
      modelVar_VBIRBOTD_i = modelVar_VBIRBOT_i;
      modelVar_VBIRSTID_i = modelVar_VBIRSTI_i;
      modelVar_VBIRGATD_i = modelVar_VBIRGAT_i;
      modelVar_PBOTD_i = modelVar_PBOT_i;
      modelVar_PSTID_i = modelVar_PSTI_i;
      modelVar_PGATD_i = modelVar_PGAT_i;
      PHIGBOTD_i = PHIGBOT_i;
      PHIGSTID_i = PHIGSTI_i;
      PHIGGATD_i = PHIGGAT_i;
      IDSATRBOTD_i = IDSATRBOT_i;
      IDSATRSTID_i = IDSATRSTI_i;
      IDSATRGATD_i = IDSATRGAT_i;
      modelVar_CSRHBOTD_i = modelVar_CSRHBOT_i;
      modelVar_CSRHSTID_i = modelVar_CSRHSTI_i;
      modelVar_CSRHGATD_i = modelVar_CSRHGAT_i;
      XJUNSTID_i = XJUNSTI_i;
      XJUNGATD_i = XJUNGAT_i;
      modelVar_CTATBOTD_i = modelVar_CTATBOT_i;
      modelVar_CTATSTID_i = modelVar_CTATSTI_i;
      modelVar_CTATGATD_i = modelVar_CTATGAT_i;
      MEFFTATBOTD_i = MEFFTATBOT_i;
      MEFFTATSTID_i = MEFFTATSTI_i;
      MEFFTATGATD_i = MEFFTATGAT_i;
      modelVar_CBBTBOTD_i = modelVar_CBBTBOT_i;
      modelVar_CBBTSTID_i = modelVar_CBBTSTI_i;
      modelVar_CBBTGATD_i = modelVar_CBBTGAT_i;
      FBBTRBOTD_i = FBBTRBOT_i;
      FBBTRSTID_i = FBBTRSTI_i;
      FBBTRGATD_i = FBBTRGAT_i;
      STFBBTBOTD_i = STFBBTBOT_i;
      STFBBTSTID_i = STFBBTSTI_i;
      STFBBTGATD_i = STFBBTGAT_i;
      modelVar_VBRBOTD_i = modelVar_VBRBOT_i;
      modelVar_VBRSTID_i = modelVar_VBRSTI_i;
      modelVar_VBRGATD_i = modelVar_VBRGAT_i;
      modelVar_PBRBOTD_i = modelVar_PBRBOT_i;
      modelVar_PBRSTID_i = modelVar_PBRSTI_i;
      modelVar_PBRGATD_i = modelVar_PBRGAT_i;
      modelVar_VJUNREFD_i = modelVar_VJUNREF_i;
      modelVar_FJUNQD_i = modelVar_FJUNQ_i;
    }
    else
    {
      CJORBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORBOTD>1.0e-12),modelPar_CJORBOTD,1.0e-12);
      CJORSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORSTID>1.0e-18),modelPar_CJORSTID,1.0e-18);
      CJORGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORGATD>1.0e-18),modelPar_CJORGATD,1.0e-18);
      modelVar_VBIRBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRBOTD>5.0e-2),modelPar_VBIRBOTD,5.0e-2);
      modelVar_VBIRSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRSTID>5.0e-2),modelPar_VBIRSTID,5.0e-2);
      modelVar_VBIRGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRGATD>5.0e-2),modelPar_VBIRGATD,5.0e-2);
      modelVar_PBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBOTD>5.0e-2),adms_ternary_op<AdmsSensFadType>((modelPar_PBOTD<0.95),modelPar_PBOTD,0.95),5.0e-2);
      modelVar_PSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_PSTID>5.0e-2),adms_ternary_op<AdmsSensFadType>((modelPar_PSTID<0.95),modelPar_PSTID,0.95),5.0e-2);
      modelVar_PGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_PGATD>5.0e-2),adms_ternary_op<AdmsSensFadType>((modelPar_PGATD<0.95),modelPar_PGATD,0.95),5.0e-2);
      PHIGBOTD_i = modelPar_PHIGBOTD;
      PHIGSTID_i = modelPar_PHIGSTID;
      PHIGGATD_i = modelPar_PHIGGATD;
      IDSATRBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRBOTD>0.0),modelPar_IDSATRBOTD,0.0);
      IDSATRSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRSTID>0.0),modelPar_IDSATRSTID,0.0);
      IDSATRGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRGATD>0.0),modelPar_IDSATRGATD,0.0);
      modelVar_CSRHBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHBOTD>0.0),modelPar_CSRHBOTD,0.0);
      modelVar_CSRHSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHSTID>0.0),modelPar_CSRHSTID,0.0);
      modelVar_CSRHGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHGATD>0.0),modelPar_CSRHGATD,0.0);
      XJUNSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_XJUNSTID>1.0e-9),modelPar_XJUNSTID,1.0e-9);
      XJUNGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_XJUNGATD>1.0e-9),modelPar_XJUNGATD,1.0e-9);
      modelVar_CTATBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATBOTD>0.0),modelPar_CTATBOTD,0.0);
      modelVar_CTATSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATSTID>0.0),modelPar_CTATSTID,0.0);
      modelVar_CTATGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATGATD>0.0),modelPar_CTATGATD,0.0);
      MEFFTATBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATBOTD>1.0e-2),modelPar_MEFFTATBOTD,1.0e-2);
      MEFFTATSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATSTID>1.0e-2),modelPar_MEFFTATSTID,1.0e-2);
      MEFFTATGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATGATD>1.0e-2),modelPar_MEFFTATGATD,1.0e-2);
      modelVar_CBBTBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTBOTD>0.0),modelPar_CBBTBOTD,0.0);
      modelVar_CBBTSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTSTID>0.0),modelPar_CBBTSTID,0.0);
      modelVar_CBBTGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTGATD>0.0),modelPar_CBBTGATD,0.0);
      FBBTRBOTD_i = modelPar_FBBTRBOTD;
      FBBTRSTID_i = modelPar_FBBTRSTID;
      FBBTRGATD_i = modelPar_FBBTRGATD;
      STFBBTBOTD_i = modelPar_STFBBTBOTD;
      STFBBTSTID_i = modelPar_STFBBTSTID;
      STFBBTGATD_i = modelPar_STFBBTGATD;
      modelVar_VBRBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRBOTD>0.1),modelPar_VBRBOTD,0.1);
      modelVar_VBRSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRSTID>0.1),modelPar_VBRSTID,0.1);
      modelVar_VBRGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRGATD>0.1),modelPar_VBRGATD,0.1);
      modelVar_PBRBOTD_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRBOTD>0.1),modelPar_PBRBOTD,0.1);
      modelVar_PBRSTID_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRSTID>0.1),modelPar_PBRSTID,0.1);
      modelVar_PBRGATD_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRGATD>0.1),modelPar_PBRGATD,0.1);
      modelVar_VJUNREFD_i = adms_ternary_op<AdmsSensFadType>((modelPar_VJUNREFD>0.5),modelPar_VJUNREFD,0.5);
      modelVar_FJUNQD_i = adms_ternary_op<AdmsSensFadType>((modelPar_FJUNQD>0.0),modelPar_FJUNQD,0.0);
    }
    tkr = (273.15+TRJ_i);
    {
      AdmsSensFadType value_max_0 = std::max((admsTemperature+modelPar_DTA),(273.15+(-2.5e2)));
      tkd = value_max_0;
    }
    auxt = (tkd/tkr);
    KBOL_over_QELE = (1.3806505E-23/1.6021918E-19);
    modelVar_phitr = (KBOL_over_QELE*tkr);
    phitrinv = (1.0/modelVar_phitr);
    modelVar_phitd = (KBOL_over_QELE*tkd);
    modelVar_phitdinv = (1.0/modelVar_phitd);
    deltaphigr = ((-((7.02e-4*tkr)*tkr))/(1108.0+tkr));
    phigrbot = (PHIGBOT_i+deltaphigr);
    phigrsti = (PHIGSTI_i+deltaphigr);
    phigrgat = (PHIGGAT_i+deltaphigr);
    deltaphigd = ((-((7.02e-4*tkd)*tkd))/(1108.0+tkd));
    phigdbot = (PHIGBOT_i+deltaphigd);
    phigdsti = (PHIGSTI_i+deltaphigd);
    phigdgat = (PHIGGAT_i+deltaphigd);
    {
      AdmsSensFadType value_pow_0 = pow(auxt,1.5);
      AdmsSensFadType value_exp_1 = exp((0.5*((phigrbot*phitrinv)-(phigdbot*modelVar_phitdinv))));
      modelVar_ftdbot = (value_pow_0*value_exp_1);
    }
    {
      AdmsSensFadType value_pow_0 = pow(auxt,1.5);
      AdmsSensFadType value_exp_1 = exp((0.5*((phigrsti*phitrinv)-(phigdsti*modelVar_phitdinv))));
      modelVar_ftdsti = (value_pow_0*value_exp_1);
    }
    {
      AdmsSensFadType value_pow_0 = pow(auxt,1.5);
      AdmsSensFadType value_exp_1 = exp((0.5*((phigrgat*phitrinv)-(phigdgat*modelVar_phitdinv))));
      modelVar_ftdgat = (value_pow_0*value_exp_1);
    }
    modelVar_idsatbot = ((IDSATRBOT_i*modelVar_ftdbot)*modelVar_ftdbot);
    modelVar_idsatsti = ((IDSATRSTI_i*modelVar_ftdsti)*modelVar_ftdsti);
    modelVar_idsatgat = ((IDSATRGAT_i*modelVar_ftdgat)*modelVar_ftdgat);
    {
      AdmsSensFadType value_log_0 = log(modelVar_ftdbot);
      ubibot = ((modelVar_VBIRBOT_i*auxt)-((2.0*modelVar_phitd)*value_log_0));
    }
    {
      AdmsSensFadType value_log_0 = log(modelVar_ftdsti);
      ubisti = ((modelVar_VBIRSTI_i*auxt)-((2.0*modelVar_phitd)*value_log_0));
    }
    {
      AdmsSensFadType value_log_0 = log(modelVar_ftdgat);
      ubigat = ((modelVar_VBIRGAT_i*auxt)-((2.0*modelVar_phitd)*value_log_0));
    }
    {
      AdmsSensFadType value_exp_0 = exp(((5.0e-2-ubibot)*modelVar_phitdinv));
      AdmsSensFadType value_log_1 = log((1+value_exp_0));
      modelVar_vbibot = (ubibot+(modelVar_phitd*value_log_1));
    }
    {
      AdmsSensFadType value_exp_0 = exp(((5.0e-2-ubisti)*modelVar_phitdinv));
      AdmsSensFadType value_log_1 = log((1+value_exp_0));
      modelVar_vbisti = (ubisti+(modelVar_phitd*value_log_1));
    }
    {
      AdmsSensFadType value_exp_0 = exp(((5.0e-2-ubigat)*modelVar_phitdinv));
      AdmsSensFadType value_log_1 = log((1+value_exp_0));
      modelVar_vbigat = (ubigat+(modelVar_phitd*value_log_1));
    }
    modelVar_vbiinvbot = (1.0/modelVar_vbibot);
    modelVar_vbiinvsti = (1.0/modelVar_vbisti);
    modelVar_vbiinvgat = (1.0/modelVar_vbigat);
    modelVar_one_minus_PBOT = (1.0-modelVar_PBOT_i);
    modelVar_one_minus_PSTI = (1.0-modelVar_PSTI_i);
    modelVar_one_minus_PGAT = (1.0-modelVar_PGAT_i);
    modelVar_one_over_one_minus_PBOT = (1.0/modelVar_one_minus_PBOT);
    modelVar_one_over_one_minus_PSTI = (1.0/modelVar_one_minus_PSTI);
    modelVar_one_over_one_minus_PGAT = (1.0/modelVar_one_minus_PGAT);
    {
      AdmsSensFadType value_pow_0 = pow((modelVar_VBIRBOT_i*modelVar_vbiinvbot),modelVar_PBOT_i);
      modelVar_cjobot = (CJORBOT_i*value_pow_0);
    }
    {
      AdmsSensFadType value_pow_0 = pow((modelVar_VBIRSTI_i*modelVar_vbiinvsti),modelVar_PSTI_i);
      modelVar_cjosti = (CJORSTI_i*value_pow_0);
    }
    {
      AdmsSensFadType value_pow_0 = pow((modelVar_VBIRGAT_i*modelVar_vbiinvgat),modelVar_PGAT_i);
      modelVar_cjogat = (CJORGAT_i*value_pow_0);
    }
    modelVar_qprefbot = ((modelVar_cjobot*modelVar_vbibot)*modelVar_one_over_one_minus_PBOT);
    modelVar_qprefsti = ((modelVar_cjosti*modelVar_vbisti)*modelVar_one_over_one_minus_PSTI);
    modelVar_qprefgat = ((modelVar_cjogat*modelVar_vbigat)*modelVar_one_over_one_minus_PGAT);
    modelVar_qpref2bot = (2.0*modelVar_cjobot);
    modelVar_qpref2sti = (2.0*modelVar_cjosti);
    modelVar_qpref2gat = (2.0*modelVar_cjogat);
    modelVar_wdepnulrbot = (modelVar_EPSSI/CJORBOT_i);
    modelVar_wdepnulrsti = ((XJUNSTI_i*modelVar_EPSSI)/CJORSTI_i);
    modelVar_wdepnulrgat = ((XJUNGAT_i*modelVar_EPSSI)/CJORGAT_i);
    modelVar_wdepnulrinvbot = (1.0/modelVar_wdepnulrbot);
    modelVar_wdepnulrinvsti = (1.0/modelVar_wdepnulrsti);
    modelVar_wdepnulrinvgat = (1.0/modelVar_wdepnulrgat);
    modelVar_VBIRBOTinv = (1.0/modelVar_VBIRBOT_i);
    modelVar_VBIRSTIinv = (1.0/modelVar_VBIRSTI_i);
    modelVar_VBIRGATinv = (1.0/modelVar_VBIRGAT_i);
    modelVar_perfc = (1.77245385090551603*0.29214664);
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_perfc,(-2.0));
      modelVar_berfc = (((((-5.0)*0.29214664)+6.0)-value_pow_0)/3.0);
    }
    modelVar_cerfc = ((1.0-0.29214664)-modelVar_berfc);
    {
      AdmsSensFadType value_max_0 = max((0.5*phigdbot),modelVar_phitd);
      deltaEbot = value_max_0;
    }
    {
      AdmsSensFadType value_max_0 = max((0.5*phigdsti),modelVar_phitd);
      deltaEsti = value_max_0;
    }
    {
      AdmsSensFadType value_max_0 = max((0.5*phigdgat),modelVar_phitd);
      deltaEgat = value_max_0;
    }
    modelVar_atatbot = (deltaEbot*modelVar_phitdinv);
    modelVar_atatsti = (deltaEsti*modelVar_phitdinv);
    modelVar_atatgat = (deltaEgat*modelVar_phitdinv);
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((32.0*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*deltaEbot)));
      modelVar_btatpartbot = (value_sqrt_0/(3.0*1.05457168E-34));
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((32.0*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*deltaEsti)));
      modelVar_btatpartsti = (value_sqrt_0/(3.0*1.05457168E-34));
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((32.0*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*deltaEgat)));
      modelVar_btatpartgat = (value_sqrt_0/(3.0*1.05457168E-34));
    }
    modelVar_fbbtbot = (FBBTRBOT_i*(1.0+(STFBBTBOT_i*(tkd-tkr))));
    modelVar_fbbtsti = (FBBTRSTI_i*(1.0+(STFBBTSTI_i*(tkd-tkr))));
    modelVar_fbbtgat = (FBBTRGAT_i*(1.0+(STFBBTGAT_i*(tkd-tkr))));
    modelVar_fbbtbot = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtbot>0.0),modelVar_fbbtbot,0.0);
    modelVar_fbbtsti = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtsti>0.0),modelVar_fbbtsti,0.0);
    modelVar_fbbtgat = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtgat>0.0),modelVar_fbbtgat,0.0);
    modelVar_alphaav = (1.0-(1.0/FREV_i));
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_alphaav,modelVar_PBRBOT_i);
      modelVar_fstopbot = (1.0/(1.0-value_pow_0));
    }
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_alphaav,modelVar_PBRSTI_i);
      modelVar_fstopsti = (1.0/(1.0-value_pow_0));
    }
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_alphaav,modelVar_PBRGAT_i);
      modelVar_fstopgat = (1.0/(1.0-value_pow_0));
    }
    modelVar_VBRinvbot = (1.0/modelVar_VBRBOT_i);
    modelVar_VBRinvsti = (1.0/modelVar_VBRSTI_i);
    modelVar_VBRinvgat = (1.0/modelVar_VBRGAT_i);
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_alphaav,(modelVar_PBRBOT_i-1.0));
      modelVar_slopebot = (((-((modelVar_fstopbot*modelVar_fstopbot)*value_pow_0))*modelVar_PBRBOT_i)*modelVar_VBRinvbot);
    }
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_alphaav,(modelVar_PBRSTI_i-1.0));
      modelVar_slopesti = (((-((modelVar_fstopsti*modelVar_fstopsti)*value_pow_0))*modelVar_PBRSTI_i)*modelVar_VBRinvsti);
    }
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_alphaav,(modelVar_PBRGAT_i-1.0));
      modelVar_slopegat = (((-((modelVar_fstopgat*modelVar_fstopgat)*value_pow_0))*modelVar_PBRGAT_i)*modelVar_VBRinvgat);
    }
    phigrbot_d = (PHIGBOTD_i+deltaphigr);
    phigrsti_d = (PHIGSTID_i+deltaphigr);
    phigrgat_d = (PHIGGATD_i+deltaphigr);
    phigdbot_d = (PHIGBOTD_i+deltaphigd);
    phigdsti_d = (PHIGSTID_i+deltaphigd);
    phigdgat_d = (PHIGGATD_i+deltaphigd);
    {
      AdmsSensFadType value_pow_0 = pow(auxt,1.5);
      AdmsSensFadType value_exp_1 = exp((0.5*((phigrbot_d*phitrinv)-(phigdbot_d*modelVar_phitdinv))));
      modelVar_ftdbot_d = (value_pow_0*value_exp_1);
    }
    {
      AdmsSensFadType value_pow_0 = pow(auxt,1.5);
      AdmsSensFadType value_exp_1 = exp((0.5*((phigrsti_d*phitrinv)-(phigdsti_d*modelVar_phitdinv))));
      modelVar_ftdsti_d = (value_pow_0*value_exp_1);
    }
    {
      AdmsSensFadType value_pow_0 = pow(auxt,1.5);
      AdmsSensFadType value_exp_1 = exp((0.5*((phigrgat_d*phitrinv)-(phigdgat_d*modelVar_phitdinv))));
      modelVar_ftdgat_d = (value_pow_0*value_exp_1);
    }
    modelVar_idsatbot_d = ((IDSATRBOTD_i*modelVar_ftdbot_d)*modelVar_ftdbot_d);
    modelVar_idsatsti_d = ((IDSATRSTID_i*modelVar_ftdsti_d)*modelVar_ftdsti_d);
    modelVar_idsatgat_d = ((IDSATRGATD_i*modelVar_ftdgat_d)*modelVar_ftdgat_d);
    {
      AdmsSensFadType value_log_0 = log(modelVar_ftdbot_d);
      ubibot_d = ((modelVar_VBIRBOTD_i*auxt)-((2.0*modelVar_phitd)*value_log_0));
    }
    {
      AdmsSensFadType value_log_0 = log(modelVar_ftdsti_d);
      ubisti_d = ((modelVar_VBIRSTID_i*auxt)-((2.0*modelVar_phitd)*value_log_0));
    }
    {
      AdmsSensFadType value_log_0 = log(modelVar_ftdgat_d);
      ubigat_d = ((modelVar_VBIRGATD_i*auxt)-((2.0*modelVar_phitd)*value_log_0));
    }
    {
      AdmsSensFadType value_exp_0 = exp(((5.0e-2-ubibot_d)*modelVar_phitdinv));
      AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
      modelVar_vbibot_d = (ubibot_d+(modelVar_phitd*value_log_1));
    }
    {
      AdmsSensFadType value_exp_0 = exp(((5.0e-2-ubisti_d)*modelVar_phitdinv));
      AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
      modelVar_vbisti_d = (ubisti_d+(modelVar_phitd*value_log_1));
    }
    {
      AdmsSensFadType value_exp_0 = exp(((5.0e-2-ubigat_d)*modelVar_phitdinv));
      AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
      modelVar_vbigat_d = (ubigat_d+(modelVar_phitd*value_log_1));
    }
    modelVar_vbiinvbot_d = (1.0/modelVar_vbibot_d);
    modelVar_vbiinvsti_d = (1.0/modelVar_vbisti_d);
    modelVar_vbiinvgat_d = (1.0/modelVar_vbigat_d);
    modelVar_one_minus_PBOT_d = (1.0-modelVar_PBOTD_i);
    modelVar_one_minus_PSTI_d = (1.0-modelVar_PSTID_i);
    modelVar_one_minus_PGAT_d = (1.0-modelVar_PGATD_i);
    modelVar_one_over_one_minus_PBOT_d = (1.0/modelVar_one_minus_PBOT_d);
    modelVar_one_over_one_minus_PSTI_d = (1.0/modelVar_one_minus_PSTI_d);
    modelVar_one_over_one_minus_PGAT_d = (1.0/modelVar_one_minus_PGAT_d);
    {
      AdmsSensFadType value_pow_0 = pow((modelVar_VBIRBOTD_i*modelVar_vbiinvbot_d),modelVar_PBOTD_i);
      modelVar_cjobot_d = (CJORBOTD_i*value_pow_0);
    }
    {
      AdmsSensFadType value_pow_0 = pow((modelVar_VBIRSTID_i*modelVar_vbiinvsti_d),modelVar_PSTID_i);
      modelVar_cjosti_d = (CJORSTID_i*value_pow_0);
    }
    {
      AdmsSensFadType value_pow_0 = pow((modelVar_VBIRGATD_i*modelVar_vbiinvgat_d),modelVar_PGATD_i);
      modelVar_cjogat_d = (CJORGATD_i*value_pow_0);
    }
    modelVar_qprefbot_d = ((modelVar_cjobot_d*modelVar_vbibot_d)*modelVar_one_over_one_minus_PBOT_d);
    modelVar_qprefsti_d = ((modelVar_cjosti_d*modelVar_vbisti_d)*modelVar_one_over_one_minus_PSTI_d);
    modelVar_qprefgat_d = ((modelVar_cjogat_d*modelVar_vbigat_d)*modelVar_one_over_one_minus_PGAT_d);
    modelVar_qpref2bot_d = (2.0*modelVar_cjobot_d);
    modelVar_qpref2sti_d = (2.0*modelVar_cjosti_d);
    modelVar_qpref2gat_d = (2.0*modelVar_cjogat_d);
    modelVar_wdepnulrbot_d = (modelVar_EPSSI/CJORBOTD_i);
    modelVar_wdepnulrsti_d = ((XJUNSTID_i*modelVar_EPSSI)/CJORSTID_i);
    modelVar_wdepnulrgat_d = ((XJUNGATD_i*modelVar_EPSSI)/CJORGATD_i);
    modelVar_wdepnulrinvbot_d = (1.0/modelVar_wdepnulrbot_d);
    modelVar_wdepnulrinvsti_d = (1.0/modelVar_wdepnulrsti_d);
    modelVar_wdepnulrinvgat_d = (1.0/modelVar_wdepnulrgat_d);
    modelVar_VBIRBOTinv_d = (1.0/modelVar_VBIRBOTD_i);
    modelVar_VBIRSTIinv_d = (1.0/modelVar_VBIRSTID_i);
    modelVar_VBIRGATinv_d = (1.0/modelVar_VBIRGATD_i);
    {
      AdmsSensFadType value_max_0 = max((0.5*phigdbot_d),modelVar_phitd);
      deltaEbot_d = value_max_0;
    }
    {
      AdmsSensFadType value_max_0 = max((0.5*phigdsti_d),modelVar_phitd);
      deltaEsti_d = value_max_0;
    }
    {
      AdmsSensFadType value_max_0 = max((0.5*phigdgat_d),modelVar_phitd);
      deltaEgat_d = value_max_0;
    }
    modelVar_atatbot_d = (deltaEbot_d*modelVar_phitdinv);
    modelVar_atatsti_d = (deltaEsti_d*modelVar_phitdinv);
    modelVar_atatgat_d = (deltaEgat_d*modelVar_phitdinv);
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((32.0*MEFFTATBOTD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot_d*deltaEbot_d)*deltaEbot_d)));
      modelVar_btatpartbot_d = (value_sqrt_0/(3.0*1.05457168E-34));
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((32.0*MEFFTATSTID_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti_d*deltaEsti_d)*deltaEsti_d)));
      modelVar_btatpartsti_d = (value_sqrt_0/(3.0*1.05457168E-34));
    }
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((((32.0*MEFFTATGATD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat_d*deltaEgat_d)*deltaEgat_d)));
      modelVar_btatpartgat_d = (value_sqrt_0/(3.0*1.05457168E-34));
    }
    modelVar_fbbtbot_d = (FBBTRBOTD_i*(1.0+(STFBBTBOTD_i*(tkd-tkr))));
    modelVar_fbbtsti_d = (FBBTRSTID_i*(1.0+(STFBBTSTID_i*(tkd-tkr))));
    modelVar_fbbtgat_d = (FBBTRGATD_i*(1.0+(STFBBTGATD_i*(tkd-tkr))));
    modelVar_fbbtbot_d = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtbot_d>0.0),modelVar_fbbtbot_d,0.0);
    modelVar_fbbtsti_d = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtsti_d>0.0),modelVar_fbbtsti_d,0.0);
    modelVar_fbbtgat_d = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtgat_d>0.0),modelVar_fbbtgat_d,0.0);
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_alphaav,modelVar_PBRBOTD_i);
      modelVar_fstopbot_d = (1.0/(1.0-value_pow_0));
    }
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_alphaav,modelVar_PBRSTID_i);
      modelVar_fstopsti_d = (1.0/(1.0-value_pow_0));
    }
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_alphaav,modelVar_PBRGATD_i);
      modelVar_fstopgat_d = (1.0/(1.0-value_pow_0));
    }
    modelVar_VBRinvbot_d = (1.0/modelVar_VBRBOTD_i);
    modelVar_VBRinvsti_d = (1.0/modelVar_VBRSTID_i);
    modelVar_VBRinvgat_d = (1.0/modelVar_VBRGATD_i);
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_alphaav,(modelVar_PBRBOTD_i-1.0));
      modelVar_slopebot_d = (((-((modelVar_fstopbot_d*modelVar_fstopbot_d)*value_pow_0))*modelVar_PBRBOTD_i)*modelVar_VBRinvbot_d);
    }
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_alphaav,(modelVar_PBRSTID_i-1.0));
      modelVar_slopesti_d = (((-((modelVar_fstopsti_d*modelVar_fstopsti_d)*value_pow_0))*modelVar_PBRSTID_i)*modelVar_VBRinvsti_d);
    }
    {
      AdmsSensFadType value_pow_0 = pow(modelVar_alphaav,(modelVar_PBRGATD_i-1.0));
      modelVar_slopegat_d = (((-((modelVar_fstopgat_d*modelVar_fstopgat_d)*value_pow_0))*modelVar_PBRGATD_i)*modelVar_VBRinvgat_d);
    }
  }
  // End block initial_model
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_NOI_GND,
   const int admsProbeID_V_NOI2_GND,
   const int admsProbeID_V_B_BI,
   const int admsProbeID_V_BD_BI,
   const int admsProbeID_V_BS_BI,
   const int admsProbeID_V_BP_BI,
   const int admsProbeID_V_D_DI,
   const int admsProbeID_V_S_SI,
   const int admsProbeID_V_G_GP,
   const int admsProbeID_V_DI_BD,
   const int admsProbeID_V_SI_BS,
   const int admsProbeID_V_SI_BP,
   const int admsProbeID_V_DI_SI,
   const int admsProbeID_V_GP_SI,
   // node constants
   const int admsNodeID_D,
   const int admsNodeID_G,
   const int admsNodeID_S,
   const int admsNodeID_B,
   const int admsNodeID_NOI,
   const int admsNodeID_NOI2,
   const int admsNodeID_GP,
   const int admsNodeID_SI,
   const int admsNodeID_DI,
   const int admsNodeID_BP,
   const int admsNodeID_BI,
   const int admsNodeID_BS,
   const int admsNodeID_BD,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_W,
   bool instancePar_given_W,
   AdmsSensFadType & instancePar_SA,
   bool instancePar_given_SA,
   AdmsSensFadType & instancePar_SB,
   bool instancePar_given_SB,
   AdmsSensFadType & instancePar_SD,
   bool instancePar_given_SD,
   AdmsSensFadType & instancePar_SCA,
   bool instancePar_given_SCA,
   AdmsSensFadType & instancePar_SCB,
   bool instancePar_given_SCB,
   AdmsSensFadType & instancePar_SCC,
   bool instancePar_given_SCC,
   AdmsSensFadType & instancePar_SC,
   bool instancePar_given_SC,
   AdmsSensFadType & instancePar_NF,
   bool instancePar_given_NF,
   AdmsSensFadType & instancePar_NGCON,
   bool instancePar_given_NGCON,
   AdmsSensFadType & instancePar_XGW,
   bool instancePar_given_XGW,
   AdmsSensFadType & instancePar_NRS,
   bool instancePar_given_NRS,
   AdmsSensFadType & instancePar_NRD,
   bool instancePar_given_NRD,
   AdmsSensFadType & instancePar_JW,
   bool instancePar_given_JW,
   AdmsSensFadType & instancePar_DELVTO,
   bool instancePar_given_DELVTO,
   AdmsSensFadType & instancePar_FACTUO,
   bool instancePar_given_FACTUO,
   AdmsSensFadType & instancePar_DELVTOEDGE,
   bool instancePar_given_DELVTOEDGE,
   AdmsSensFadType & instancePar_FACTUOEDGE,
   bool instancePar_given_FACTUOEDGE,
   AdmsSensFadType & instancePar_ABSOURCE,
   bool instancePar_given_ABSOURCE,
   AdmsSensFadType & instancePar_LSSOURCE,
   bool instancePar_given_LSSOURCE,
   AdmsSensFadType & instancePar_LGSOURCE,
   bool instancePar_given_LGSOURCE,
   AdmsSensFadType & instancePar_ABDRAIN,
   bool instancePar_given_ABDRAIN,
   AdmsSensFadType & instancePar_LSDRAIN,
   bool instancePar_given_LSDRAIN,
   AdmsSensFadType & instancePar_LGDRAIN,
   bool instancePar_given_LGDRAIN,
   AdmsSensFadType & instancePar_AS,
   bool instancePar_given_AS,
   AdmsSensFadType & instancePar_PS,
   bool instancePar_given_PS,
   AdmsSensFadType & instancePar_AD,
   bool instancePar_given_AD,
   AdmsSensFadType & instancePar_PD,
   bool instancePar_given_PD,
   AdmsSensFadType & instancePar_MULT,
   bool instancePar_given_MULT,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_MULT_i,
   AdmsSensFadType & instanceVar_GFACNUD_i,
   AdmsSensFadType & instanceVar_VNSUB_i,
   AdmsSensFadType & instanceVar_NSLP_i,
   AdmsSensFadType & instanceVar_DNSUB_i,
   AdmsSensFadType & instanceVar_CF_i,
   AdmsSensFadType & instanceVar_CFD_i,
   AdmsSensFadType & instanceVar_CFB_i,
   AdmsSensFadType & instanceVar_PSCE_i,
   AdmsSensFadType & instanceVar_PSCEB_i,
   AdmsSensFadType & instanceVar_PSCED_i,
   AdmsSensFadType & instanceVar_RSB_i,
   AdmsSensFadType & instanceVar_RSG_i,
   AdmsSensFadType & instanceVar_THESATB_i,
   AdmsSensFadType & instanceVar_THESATG_i,
   AdmsSensFadType & instanceVar_AX_i,
   AdmsSensFadType & instanceVar_ALP_i,
   AdmsSensFadType & instanceVar_ALP1_i,
   AdmsSensFadType & instanceVar_ALP2_i,
   AdmsSensFadType & instanceVar_A1_i,
   AdmsSensFadType & instanceVar_A3_i,
   AdmsSensFadType & instanceVar_A4_i,
   AdmsSensFadType & instanceVar_GCO_i,
   AdmsSensFadType & instanceVar_IGINV_i,
   AdmsSensFadType & instanceVar_IGOV_i,
   AdmsSensFadType & instanceVar_IGOVD_i,
   AdmsSensFadType & instanceVar_GC2_i,
   AdmsSensFadType & instanceVar_GC3_i,
   AdmsSensFadType & instanceVar_CHIB_i,
   AdmsSensFadType & instanceVar_AGIDL_i,
   AdmsSensFadType & instanceVar_AGIDLD_i,
   AdmsSensFadType & instanceVar_CGIDL_i,
   AdmsSensFadType & instanceVar_CGIDLD_i,
   AdmsSensFadType & instanceVar_COX_i,
   AdmsSensFadType & instanceVar_CGOV_i,
   AdmsSensFadType & instanceVar_CGOVD_i,
   AdmsSensFadType & instanceVar_CGBOV_i,
   AdmsSensFadType & instanceVar_CFR_i,
   AdmsSensFadType & instanceVar_CFRD_i,
   AdmsSensFadType & instanceVar_FNTEXC_i,
   AdmsSensFadType & instanceVar_NFA_i,
   AdmsSensFadType & instanceVar_NFB_i,
   AdmsSensFadType & instanceVar_NFC_i,
   AdmsSensFadType & instanceVar_EF_i,
   AdmsSensFadType & instanceVar_BETNEDGE_i,
   AdmsSensFadType & instanceVar_PSCEEDGE_i,
   AdmsSensFadType & instanceVar_PSCEBEDGE_i,
   AdmsSensFadType & instanceVar_PSCEDEDGE_i,
   AdmsSensFadType & instanceVar_CFEDGE_i,
   AdmsSensFadType & instanceVar_CFDEDGE_i,
   AdmsSensFadType & instanceVar_CFBEDGE_i,
   AdmsSensFadType & instanceVar_NFAEDGE_i,
   AdmsSensFadType & instanceVar_NFBEDGE_i,
   AdmsSensFadType & instanceVar_NFCEDGE_i,
   AdmsSensFadType & instanceVar_EFEDGE_i,
   AdmsSensFadType & instanceVar_RG_i,
   AdmsSensFadType & instanceVar_RSE_i,
   AdmsSensFadType & instanceVar_RDE_i,
   AdmsSensFadType & instanceVar_RBULK_i,
   AdmsSensFadType & instanceVar_RJUNS_i,
   AdmsSensFadType & instanceVar_RJUND_i,
   AdmsSensFadType & instanceVar_RWELL_i,
   AdmsSensFadType & instanceVar_ABSOURCE_i,
   AdmsSensFadType & instanceVar_LSSOURCE_i,
   AdmsSensFadType & instanceVar_LGSOURCE_i,
   AdmsSensFadType & instanceVar_zflagbot_s,
   AdmsSensFadType & instanceVar_zflagsti_s,
   AdmsSensFadType & instanceVar_zflaggat_s,
   AdmsSensFadType & instanceVar_VMAX_s,
   AdmsSensFadType & instanceVar_exp_VMAX_over_phitd_s,
   AdmsSensFadType & instanceVar_vbimin_s,
   AdmsSensFadType & instanceVar_vch_s,
   AdmsSensFadType & instanceVar_vfmin_s,
   AdmsSensFadType & instanceVar_vbbtlim_s,
   AdmsSensFadType & instanceVar_xhighf1_s,
   AdmsSensFadType & instanceVar_expxhf1_s,
   AdmsSensFadType & instanceVar_xhighf2_s,
   AdmsSensFadType & instanceVar_expxhf2_s,
   AdmsSensFadType & instanceVar_xhighr_s,
   AdmsSensFadType & instanceVar_expxhr_s,
   AdmsSensFadType & instanceVar_m0flag_s,
   AdmsSensFadType & instanceVar_ISATFOR1_s,
   AdmsSensFadType & instanceVar_MFOR1_s,
   AdmsSensFadType & instanceVar_ISATFOR2_s,
   AdmsSensFadType & instanceVar_MFOR2_s,
   AdmsSensFadType & instanceVar_ISATREV_s,
   AdmsSensFadType & instanceVar_MREV_s,
   AdmsSensFadType & instanceVar_ABDRAIN_i,
   AdmsSensFadType & instanceVar_LSDRAIN_i,
   AdmsSensFadType & instanceVar_LGDRAIN_i,
   AdmsSensFadType & instanceVar_zflagbot_d,
   AdmsSensFadType & instanceVar_zflagsti_d,
   AdmsSensFadType & instanceVar_zflaggat_d,
   AdmsSensFadType & instanceVar_VMAX_d,
   AdmsSensFadType & instanceVar_exp_VMAX_over_phitd_d,
   AdmsSensFadType & instanceVar_vbimin_d,
   AdmsSensFadType & instanceVar_vch_d,
   AdmsSensFadType & instanceVar_vfmin_d,
   AdmsSensFadType & instanceVar_vbbtlim_d,
   AdmsSensFadType & instanceVar_xhighf1_d,
   AdmsSensFadType & instanceVar_expxhf1_d,
   AdmsSensFadType & instanceVar_xhighf2_d,
   AdmsSensFadType & instanceVar_expxhf2_d,
   AdmsSensFadType & instanceVar_xhighr_d,
   AdmsSensFadType & instanceVar_expxhr_d,
   AdmsSensFadType & instanceVar_m0flag_d,
   AdmsSensFadType & instanceVar_ISATFOR1_d,
   AdmsSensFadType & instanceVar_MFOR1_d,
   AdmsSensFadType & instanceVar_ISATFOR2_d,
   AdmsSensFadType & instanceVar_MFOR2_d,
   AdmsSensFadType & instanceVar_ISATREV_d,
   AdmsSensFadType & instanceVar_MREV_d,
   AdmsSensFadType & instanceVar_VFB_T,
   AdmsSensFadType & instanceVar_MUE_T,
   AdmsSensFadType & instanceVar_THEMU_T,
   AdmsSensFadType & instanceVar_CS_T,
   AdmsSensFadType & instanceVar_XCOR_T,
   AdmsSensFadType & instanceVar_A2_T,
   AdmsSensFadType & instanceVar_VFBEDGE_T,
   AdmsSensFadType & instanceVar_phit0,
   AdmsSensFadType & instanceVar_BET_i,
   AdmsSensFadType & instanceVar_BETEDGE_i,
   AdmsSensFadType & instanceVar_nt,
   AdmsSensFadType & instanceVar_THESAT_T,
   AdmsSensFadType & instanceVar_Sfl_prefac,
   AdmsSensFadType & instanceVar_phit0edge,
   AdmsSensFadType & instanceVar_Gfedge2,
   AdmsSensFadType & instanceVar_lnGfedge2,
   AdmsSensFadType & instanceVar_Sfl_prefac_edge,
   AdmsSensFadType & instanceVar_ntedge,
   AdmsSensFadType & instanceVar_phib_dc,
   AdmsSensFadType & instanceVar_G_0_dc,
   AdmsSensFadType & instanceVar_kp,
   AdmsSensFadType & instanceVar_qlim2,
   AdmsSensFadType & instanceVar_sqrt_phib_dc,
   AdmsSensFadType & instanceVar_phix_dc,
   AdmsSensFadType & instanceVar_aphi_dc,
   AdmsSensFadType & instanceVar_bphi_dc,
   AdmsSensFadType & instanceVar_phix1_dc,
   AdmsSensFadType & instanceVar_alpha_b,
   AdmsSensFadType & instanceVar_us1,
   AdmsSensFadType & instanceVar_us21,
   AdmsSensFadType & instanceVar_phib_ac,
   AdmsSensFadType & instanceVar_G_0_ac,
   AdmsSensFadType & instanceVar_phix_ac,
   AdmsSensFadType & instanceVar_aphi_ac,
   AdmsSensFadType & instanceVar_bphi_ac,
   AdmsSensFadType & instanceVar_phix1_ac,
   AdmsSensFadType & instanceVar_THER_i,
   AdmsSensFadType & instanceVar_phibedge,
   AdmsSensFadType & instanceVar_Gfedge,
   AdmsSensFadType & instanceVar_phixedge,
   AdmsSensFadType & instanceVar_aphiedge,
   AdmsSensFadType & instanceVar_bphiedge,
   AdmsSensFadType & instanceVar_phix1edge,
   AdmsSensFadType & instanceVar_Cox_over_q,
   AdmsSensFadType & instanceVar_qq,
   AdmsSensFadType & instanceVar_E_eff0,
   AdmsSensFadType & instanceVar_eta_mu,
   AdmsSensFadType & instanceVar_eta_mu1,
   AdmsSensFadType & instanceVar_inv_AX,
   AdmsSensFadType & instanceVar_inv_VP,
   AdmsSensFadType & instanceVar_GOV_s,
   AdmsSensFadType & instanceVar_GOV_d,
   AdmsSensFadType & instanceVar_GOV2_s,
   AdmsSensFadType & instanceVar_GOV2_d,
   AdmsSensFadType & instanceVar_SP_OV_eps2_s,
   AdmsSensFadType & instanceVar_SP_OV_a_s,
   AdmsSensFadType & instanceVar_SP_OV_delta1_s,
   AdmsSensFadType & instanceVar_SP_OV_eps2_d,
   AdmsSensFadType & instanceVar_SP_OV_a_d,
   AdmsSensFadType & instanceVar_SP_OV_delta1_d,
   AdmsSensFadType & instanceVar_inv_CHIB,
   AdmsSensFadType & instanceVar_BCH,
   AdmsSensFadType & instanceVar_BOV,
   AdmsSensFadType & instanceVar_BOV_d,
   AdmsSensFadType & instanceVar_GCQ,
   AdmsSensFadType & instanceVar_AGIDLs,
   AdmsSensFadType & instanceVar_AGIDLDs,
   AdmsSensFadType & instanceVar_BGIDLs,
   AdmsSensFadType & instanceVar_BGIDLDs,
   AdmsSensFadType & instanceVar_fac_exc,
   AdmsSensFadType & instanceVar_ggate,
   AdmsSensFadType & instanceVar_gsource,
   AdmsSensFadType & instanceVar_gdrain,
   AdmsSensFadType & instanceVar_gbulk,
   AdmsSensFadType & instanceVar_gjuns,
   AdmsSensFadType & instanceVar_gjund,
   AdmsSensFadType & instanceVar_gwell,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TR,
   bool modelPar_given_TR,
   AdmsSensFadType & modelPar_QMC,
   bool modelPar_given_QMC,
   AdmsSensFadType & modelPar_VFB,
   bool modelPar_given_VFB,
   AdmsSensFadType & modelPar_STVFB,
   bool modelPar_given_STVFB,
   AdmsSensFadType & modelPar_TOX,
   bool modelPar_given_TOX,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_NEFF,
   bool modelPar_given_NEFF,
   AdmsSensFadType & modelPar_FACNEFFAC,
   bool modelPar_given_FACNEFFAC,
   AdmsSensFadType & modelPar_GFACNUD,
   bool modelPar_given_GFACNUD,
   AdmsSensFadType & modelPar_VSBNUD,
   bool modelPar_given_VSBNUD,
   AdmsSensFadType & modelPar_DVSBNUD,
   bool modelPar_given_DVSBNUD,
   AdmsSensFadType & modelPar_VNSUB,
   bool modelPar_given_VNSUB,
   AdmsSensFadType & modelPar_NSLP,
   bool modelPar_given_NSLP,
   AdmsSensFadType & modelPar_DNSUB,
   bool modelPar_given_DNSUB,
   AdmsSensFadType & modelPar_DPHIB,
   bool modelPar_given_DPHIB,
   AdmsSensFadType & modelPar_DELVTAC,
   bool modelPar_given_DELVTAC,
   AdmsSensFadType & modelPar_NP,
   bool modelPar_given_NP,
   AdmsSensFadType & modelPar_CT,
   bool modelPar_given_CT,
   AdmsSensFadType & modelPar_TOXOV,
   bool modelPar_given_TOXOV,
   AdmsSensFadType & modelPar_TOXOVD,
   bool modelPar_given_TOXOVD,
   AdmsSensFadType & modelPar_NOV,
   bool modelPar_given_NOV,
   AdmsSensFadType & modelPar_NOVD,
   bool modelPar_given_NOVD,
   AdmsSensFadType & modelPar_CF,
   bool modelPar_given_CF,
   AdmsSensFadType & modelPar_CFD,
   bool modelPar_given_CFD,
   AdmsSensFadType & modelPar_CFB,
   bool modelPar_given_CFB,
   AdmsSensFadType & modelPar_PSCE,
   bool modelPar_given_PSCE,
   AdmsSensFadType & modelPar_PSCEB,
   bool modelPar_given_PSCEB,
   AdmsSensFadType & modelPar_PSCED,
   bool modelPar_given_PSCED,
   AdmsSensFadType & modelPar_BETN,
   bool modelPar_given_BETN,
   AdmsSensFadType & modelPar_STBET,
   bool modelPar_given_STBET,
   AdmsSensFadType & modelPar_MUE,
   bool modelPar_given_MUE,
   AdmsSensFadType & modelPar_STMUE,
   bool modelPar_given_STMUE,
   AdmsSensFadType & modelPar_THEMU,
   bool modelPar_given_THEMU,
   AdmsSensFadType & modelPar_STTHEMU,
   bool modelPar_given_STTHEMU,
   AdmsSensFadType & modelPar_CS,
   bool modelPar_given_CS,
   AdmsSensFadType & modelPar_STCS,
   bool modelPar_given_STCS,
   AdmsSensFadType & modelPar_XCOR,
   bool modelPar_given_XCOR,
   AdmsSensFadType & modelPar_STXCOR,
   bool modelPar_given_STXCOR,
   AdmsSensFadType & modelPar_FETA,
   bool modelPar_given_FETA,
   AdmsSensFadType & modelPar_RS,
   bool modelPar_given_RS,
   AdmsSensFadType & modelPar_STRS,
   bool modelPar_given_STRS,
   AdmsSensFadType & modelPar_RSB,
   bool modelPar_given_RSB,
   AdmsSensFadType & modelPar_RSG,
   bool modelPar_given_RSG,
   AdmsSensFadType & modelPar_THESAT,
   bool modelPar_given_THESAT,
   AdmsSensFadType & modelPar_STTHESAT,
   bool modelPar_given_STTHESAT,
   AdmsSensFadType & modelPar_THESATB,
   bool modelPar_given_THESATB,
   AdmsSensFadType & modelPar_THESATG,
   bool modelPar_given_THESATG,
   AdmsSensFadType & modelPar_AX,
   bool modelPar_given_AX,
   AdmsSensFadType & modelPar_ALP,
   bool modelPar_given_ALP,
   AdmsSensFadType & modelPar_ALP1,
   bool modelPar_given_ALP1,
   AdmsSensFadType & modelPar_ALP2,
   bool modelPar_given_ALP2,
   AdmsSensFadType & modelPar_VP,
   bool modelPar_given_VP,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_STA2,
   bool modelPar_given_STA2,
   AdmsSensFadType & modelPar_A3,
   bool modelPar_given_A3,
   AdmsSensFadType & modelPar_A4,
   bool modelPar_given_A4,
   AdmsSensFadType & modelPar_GCO,
   bool modelPar_given_GCO,
   AdmsSensFadType & modelPar_IGINV,
   bool modelPar_given_IGINV,
   AdmsSensFadType & modelPar_IGOV,
   bool modelPar_given_IGOV,
   AdmsSensFadType & modelPar_IGOVD,
   bool modelPar_given_IGOVD,
   AdmsSensFadType & modelPar_STIG,
   bool modelPar_given_STIG,
   AdmsSensFadType & modelPar_GC2,
   bool modelPar_given_GC2,
   AdmsSensFadType & modelPar_GC3,
   bool modelPar_given_GC3,
   AdmsSensFadType & modelPar_CHIB,
   bool modelPar_given_CHIB,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_AGIDLD,
   bool modelPar_given_AGIDLD,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_BGIDLD,
   bool modelPar_given_BGIDLD,
   AdmsSensFadType & modelPar_STBGIDL,
   bool modelPar_given_STBGIDL,
   AdmsSensFadType & modelPar_STBGIDLD,
   bool modelPar_given_STBGIDLD,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_CGIDLD,
   bool modelPar_given_CGIDLD,
   AdmsSensFadType & modelPar_COX,
   bool modelPar_given_COX,
   AdmsSensFadType & modelPar_CGOV,
   bool modelPar_given_CGOV,
   AdmsSensFadType & modelPar_CGOVD,
   bool modelPar_given_CGOVD,
   AdmsSensFadType & modelPar_CGBOV,
   bool modelPar_given_CGBOV,
   AdmsSensFadType & modelPar_CFR,
   bool modelPar_given_CFR,
   AdmsSensFadType & modelPar_CFRD,
   bool modelPar_given_CFRD,
   AdmsSensFadType & modelPar_FNT,
   bool modelPar_given_FNT,
   AdmsSensFadType & modelPar_FNTEXC,
   bool modelPar_given_FNTEXC,
   AdmsSensFadType & modelPar_NFA,
   bool modelPar_given_NFA,
   AdmsSensFadType & modelPar_NFB,
   bool modelPar_given_NFB,
   AdmsSensFadType & modelPar_NFC,
   bool modelPar_given_NFC,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_VFBEDGE,
   bool modelPar_given_VFBEDGE,
   AdmsSensFadType & modelPar_STVFBEDGE,
   bool modelPar_given_STVFBEDGE,
   AdmsSensFadType & modelPar_DPHIBEDGE,
   bool modelPar_given_DPHIBEDGE,
   AdmsSensFadType & modelPar_NEFFEDGE,
   bool modelPar_given_NEFFEDGE,
   AdmsSensFadType & modelPar_CTEDGE,
   bool modelPar_given_CTEDGE,
   AdmsSensFadType & modelPar_BETNEDGE,
   bool modelPar_given_BETNEDGE,
   AdmsSensFadType & modelPar_STBETEDGE,
   bool modelPar_given_STBETEDGE,
   AdmsSensFadType & modelPar_PSCEEDGE,
   bool modelPar_given_PSCEEDGE,
   AdmsSensFadType & modelPar_PSCEBEDGE,
   bool modelPar_given_PSCEBEDGE,
   AdmsSensFadType & modelPar_PSCEDEDGE,
   bool modelPar_given_PSCEDEDGE,
   AdmsSensFadType & modelPar_CFEDGE,
   bool modelPar_given_CFEDGE,
   AdmsSensFadType & modelPar_CFDEDGE,
   bool modelPar_given_CFDEDGE,
   AdmsSensFadType & modelPar_CFBEDGE,
   bool modelPar_given_CFBEDGE,
   AdmsSensFadType & modelPar_FNTEDGE,
   bool modelPar_given_FNTEDGE,
   AdmsSensFadType & modelPar_NFAEDGE,
   bool modelPar_given_NFAEDGE,
   AdmsSensFadType & modelPar_NFBEDGE,
   bool modelPar_given_NFBEDGE,
   AdmsSensFadType & modelPar_NFCEDGE,
   bool modelPar_given_NFCEDGE,
   AdmsSensFadType & modelPar_EFEDGE,
   bool modelPar_given_EFEDGE,
   AdmsSensFadType & modelPar_RG,
   bool modelPar_given_RG,
   AdmsSensFadType & modelPar_RSE,
   bool modelPar_given_RSE,
   AdmsSensFadType & modelPar_RDE,
   bool modelPar_given_RDE,
   AdmsSensFadType & modelPar_RBULK,
   bool modelPar_given_RBULK,
   AdmsSensFadType & modelPar_RWELL,
   bool modelPar_given_RWELL,
   AdmsSensFadType & modelPar_RJUNS,
   bool modelPar_given_RJUNS,
   AdmsSensFadType & modelPar_RJUND,
   bool modelPar_given_RJUND,
   AdmsSensFadType & modelPar_POVFB,
   bool modelPar_given_POVFB,
   AdmsSensFadType & modelPar_PLVFB,
   bool modelPar_given_PLVFB,
   AdmsSensFadType & modelPar_PWVFB,
   bool modelPar_given_PWVFB,
   AdmsSensFadType & modelPar_PLWVFB,
   bool modelPar_given_PLWVFB,
   AdmsSensFadType & modelPar_POSTVFB,
   bool modelPar_given_POSTVFB,
   AdmsSensFadType & modelPar_PLSTVFB,
   bool modelPar_given_PLSTVFB,
   AdmsSensFadType & modelPar_PWSTVFB,
   bool modelPar_given_PWSTVFB,
   AdmsSensFadType & modelPar_PLWSTVFB,
   bool modelPar_given_PLWSTVFB,
   AdmsSensFadType & modelPar_POTOX,
   bool modelPar_given_POTOX,
   AdmsSensFadType & modelPar_POEPSROX,
   bool modelPar_given_POEPSROX,
   AdmsSensFadType & modelPar_PONEFF,
   bool modelPar_given_PONEFF,
   AdmsSensFadType & modelPar_PLNEFF,
   bool modelPar_given_PLNEFF,
   AdmsSensFadType & modelPar_PWNEFF,
   bool modelPar_given_PWNEFF,
   AdmsSensFadType & modelPar_PLWNEFF,
   bool modelPar_given_PLWNEFF,
   AdmsSensFadType & modelPar_POFACNEFFAC,
   bool modelPar_given_POFACNEFFAC,
   AdmsSensFadType & modelPar_PLFACNEFFAC,
   bool modelPar_given_PLFACNEFFAC,
   AdmsSensFadType & modelPar_PWFACNEFFAC,
   bool modelPar_given_PWFACNEFFAC,
   AdmsSensFadType & modelPar_PLWFACNEFFAC,
   bool modelPar_given_PLWFACNEFFAC,
   AdmsSensFadType & modelPar_POGFACNUD,
   bool modelPar_given_POGFACNUD,
   AdmsSensFadType & modelPar_PLGFACNUD,
   bool modelPar_given_PLGFACNUD,
   AdmsSensFadType & modelPar_PWGFACNUD,
   bool modelPar_given_PWGFACNUD,
   AdmsSensFadType & modelPar_PLWGFACNUD,
   bool modelPar_given_PLWGFACNUD,
   AdmsSensFadType & modelPar_POVSBNUD,
   bool modelPar_given_POVSBNUD,
   AdmsSensFadType & modelPar_PODVSBNUD,
   bool modelPar_given_PODVSBNUD,
   AdmsSensFadType & modelPar_POVNSUB,
   bool modelPar_given_POVNSUB,
   AdmsSensFadType & modelPar_PONSLP,
   bool modelPar_given_PONSLP,
   AdmsSensFadType & modelPar_PODNSUB,
   bool modelPar_given_PODNSUB,
   AdmsSensFadType & modelPar_PODPHIB,
   bool modelPar_given_PODPHIB,
   AdmsSensFadType & modelPar_PLDPHIB,
   bool modelPar_given_PLDPHIB,
   AdmsSensFadType & modelPar_PWDPHIB,
   bool modelPar_given_PWDPHIB,
   AdmsSensFadType & modelPar_PLWDPHIB,
   bool modelPar_given_PLWDPHIB,
   AdmsSensFadType & modelPar_PODELVTAC,
   bool modelPar_given_PODELVTAC,
   AdmsSensFadType & modelPar_PLDELVTAC,
   bool modelPar_given_PLDELVTAC,
   AdmsSensFadType & modelPar_PWDELVTAC,
   bool modelPar_given_PWDELVTAC,
   AdmsSensFadType & modelPar_PLWDELVTAC,
   bool modelPar_given_PLWDELVTAC,
   AdmsSensFadType & modelPar_PONP,
   bool modelPar_given_PONP,
   AdmsSensFadType & modelPar_PLNP,
   bool modelPar_given_PLNP,
   AdmsSensFadType & modelPar_PWNP,
   bool modelPar_given_PWNP,
   AdmsSensFadType & modelPar_PLWNP,
   bool modelPar_given_PLWNP,
   AdmsSensFadType & modelPar_POCT,
   bool modelPar_given_POCT,
   AdmsSensFadType & modelPar_PLCT,
   bool modelPar_given_PLCT,
   AdmsSensFadType & modelPar_PWCT,
   bool modelPar_given_PWCT,
   AdmsSensFadType & modelPar_PLWCT,
   bool modelPar_given_PLWCT,
   AdmsSensFadType & modelPar_POTOXOV,
   bool modelPar_given_POTOXOV,
   AdmsSensFadType & modelPar_POTOXOVD,
   bool modelPar_given_POTOXOVD,
   AdmsSensFadType & modelPar_PONOV,
   bool modelPar_given_PONOV,
   AdmsSensFadType & modelPar_PLNOV,
   bool modelPar_given_PLNOV,
   AdmsSensFadType & modelPar_PWNOV,
   bool modelPar_given_PWNOV,
   AdmsSensFadType & modelPar_PLWNOV,
   bool modelPar_given_PLWNOV,
   AdmsSensFadType & modelPar_PONOVD,
   bool modelPar_given_PONOVD,
   AdmsSensFadType & modelPar_PLNOVD,
   bool modelPar_given_PLNOVD,
   AdmsSensFadType & modelPar_PWNOVD,
   bool modelPar_given_PWNOVD,
   AdmsSensFadType & modelPar_PLWNOVD,
   bool modelPar_given_PLWNOVD,
   AdmsSensFadType & modelPar_POCF,
   bool modelPar_given_POCF,
   AdmsSensFadType & modelPar_PLCF,
   bool modelPar_given_PLCF,
   AdmsSensFadType & modelPar_PWCF,
   bool modelPar_given_PWCF,
   AdmsSensFadType & modelPar_PLWCF,
   bool modelPar_given_PLWCF,
   AdmsSensFadType & modelPar_POCFD,
   bool modelPar_given_POCFD,
   AdmsSensFadType & modelPar_POCFB,
   bool modelPar_given_POCFB,
   AdmsSensFadType & modelPar_POPSCE,
   bool modelPar_given_POPSCE,
   AdmsSensFadType & modelPar_PLPSCE,
   bool modelPar_given_PLPSCE,
   AdmsSensFadType & modelPar_PWPSCE,
   bool modelPar_given_PWPSCE,
   AdmsSensFadType & modelPar_PLWPSCE,
   bool modelPar_given_PLWPSCE,
   AdmsSensFadType & modelPar_POPSCEB,
   bool modelPar_given_POPSCEB,
   AdmsSensFadType & modelPar_POPSCED,
   bool modelPar_given_POPSCED,
   AdmsSensFadType & modelPar_POBETN,
   bool modelPar_given_POBETN,
   AdmsSensFadType & modelPar_PLBETN,
   bool modelPar_given_PLBETN,
   AdmsSensFadType & modelPar_PWBETN,
   bool modelPar_given_PWBETN,
   AdmsSensFadType & modelPar_PLWBETN,
   bool modelPar_given_PLWBETN,
   AdmsSensFadType & modelPar_POSTBET,
   bool modelPar_given_POSTBET,
   AdmsSensFadType & modelPar_PLSTBET,
   bool modelPar_given_PLSTBET,
   AdmsSensFadType & modelPar_PWSTBET,
   bool modelPar_given_PWSTBET,
   AdmsSensFadType & modelPar_PLWSTBET,
   bool modelPar_given_PLWSTBET,
   AdmsSensFadType & modelPar_POMUE,
   bool modelPar_given_POMUE,
   AdmsSensFadType & modelPar_PLMUE,
   bool modelPar_given_PLMUE,
   AdmsSensFadType & modelPar_PWMUE,
   bool modelPar_given_PWMUE,
   AdmsSensFadType & modelPar_PLWMUE,
   bool modelPar_given_PLWMUE,
   AdmsSensFadType & modelPar_POSTMUE,
   bool modelPar_given_POSTMUE,
   AdmsSensFadType & modelPar_POTHEMU,
   bool modelPar_given_POTHEMU,
   AdmsSensFadType & modelPar_POSTTHEMU,
   bool modelPar_given_POSTTHEMU,
   AdmsSensFadType & modelPar_POCS,
   bool modelPar_given_POCS,
   AdmsSensFadType & modelPar_PLCS,
   bool modelPar_given_PLCS,
   AdmsSensFadType & modelPar_PWCS,
   bool modelPar_given_PWCS,
   AdmsSensFadType & modelPar_PLWCS,
   bool modelPar_given_PLWCS,
   AdmsSensFadType & modelPar_POSTCS,
   bool modelPar_given_POSTCS,
   AdmsSensFadType & modelPar_POXCOR,
   bool modelPar_given_POXCOR,
   AdmsSensFadType & modelPar_PLXCOR,
   bool modelPar_given_PLXCOR,
   AdmsSensFadType & modelPar_PWXCOR,
   bool modelPar_given_PWXCOR,
   AdmsSensFadType & modelPar_PLWXCOR,
   bool modelPar_given_PLWXCOR,
   AdmsSensFadType & modelPar_POSTXCOR,
   bool modelPar_given_POSTXCOR,
   AdmsSensFadType & modelPar_POFETA,
   bool modelPar_given_POFETA,
   AdmsSensFadType & modelPar_PORS,
   bool modelPar_given_PORS,
   AdmsSensFadType & modelPar_PLRS,
   bool modelPar_given_PLRS,
   AdmsSensFadType & modelPar_PWRS,
   bool modelPar_given_PWRS,
   AdmsSensFadType & modelPar_PLWRS,
   bool modelPar_given_PLWRS,
   AdmsSensFadType & modelPar_POSTRS,
   bool modelPar_given_POSTRS,
   AdmsSensFadType & modelPar_PORSB,
   bool modelPar_given_PORSB,
   AdmsSensFadType & modelPar_PORSG,
   bool modelPar_given_PORSG,
   AdmsSensFadType & modelPar_POTHESAT,
   bool modelPar_given_POTHESAT,
   AdmsSensFadType & modelPar_PLTHESAT,
   bool modelPar_given_PLTHESAT,
   AdmsSensFadType & modelPar_PWTHESAT,
   bool modelPar_given_PWTHESAT,
   AdmsSensFadType & modelPar_PLWTHESAT,
   bool modelPar_given_PLWTHESAT,
   AdmsSensFadType & modelPar_POSTTHESAT,
   bool modelPar_given_POSTTHESAT,
   AdmsSensFadType & modelPar_PLSTTHESAT,
   bool modelPar_given_PLSTTHESAT,
   AdmsSensFadType & modelPar_PWSTTHESAT,
   bool modelPar_given_PWSTTHESAT,
   AdmsSensFadType & modelPar_PLWSTTHESAT,
   bool modelPar_given_PLWSTTHESAT,
   AdmsSensFadType & modelPar_POTHESATB,
   bool modelPar_given_POTHESATB,
   AdmsSensFadType & modelPar_PLTHESATB,
   bool modelPar_given_PLTHESATB,
   AdmsSensFadType & modelPar_PWTHESATB,
   bool modelPar_given_PWTHESATB,
   AdmsSensFadType & modelPar_PLWTHESATB,
   bool modelPar_given_PLWTHESATB,
   AdmsSensFadType & modelPar_POTHESATG,
   bool modelPar_given_POTHESATG,
   AdmsSensFadType & modelPar_PLTHESATG,
   bool modelPar_given_PLTHESATG,
   AdmsSensFadType & modelPar_PWTHESATG,
   bool modelPar_given_PWTHESATG,
   AdmsSensFadType & modelPar_PLWTHESATG,
   bool modelPar_given_PLWTHESATG,
   AdmsSensFadType & modelPar_POAX,
   bool modelPar_given_POAX,
   AdmsSensFadType & modelPar_PLAX,
   bool modelPar_given_PLAX,
   AdmsSensFadType & modelPar_PWAX,
   bool modelPar_given_PWAX,
   AdmsSensFadType & modelPar_PLWAX,
   bool modelPar_given_PLWAX,
   AdmsSensFadType & modelPar_POALP,
   bool modelPar_given_POALP,
   AdmsSensFadType & modelPar_PLALP,
   bool modelPar_given_PLALP,
   AdmsSensFadType & modelPar_PWALP,
   bool modelPar_given_PWALP,
   AdmsSensFadType & modelPar_PLWALP,
   bool modelPar_given_PLWALP,
   AdmsSensFadType & modelPar_POALP1,
   bool modelPar_given_POALP1,
   AdmsSensFadType & modelPar_PLALP1,
   bool modelPar_given_PLALP1,
   AdmsSensFadType & modelPar_PWALP1,
   bool modelPar_given_PWALP1,
   AdmsSensFadType & modelPar_PLWALP1,
   bool modelPar_given_PLWALP1,
   AdmsSensFadType & modelPar_POALP2,
   bool modelPar_given_POALP2,
   AdmsSensFadType & modelPar_PLALP2,
   bool modelPar_given_PLALP2,
   AdmsSensFadType & modelPar_PWALP2,
   bool modelPar_given_PWALP2,
   AdmsSensFadType & modelPar_PLWALP2,
   bool modelPar_given_PLWALP2,
   AdmsSensFadType & modelPar_POVP,
   bool modelPar_given_POVP,
   AdmsSensFadType & modelPar_POA1,
   bool modelPar_given_POA1,
   AdmsSensFadType & modelPar_PLA1,
   bool modelPar_given_PLA1,
   AdmsSensFadType & modelPar_PWA1,
   bool modelPar_given_PWA1,
   AdmsSensFadType & modelPar_PLWA1,
   bool modelPar_given_PLWA1,
   AdmsSensFadType & modelPar_POA2,
   bool modelPar_given_POA2,
   AdmsSensFadType & modelPar_POSTA2,
   bool modelPar_given_POSTA2,
   AdmsSensFadType & modelPar_POA3,
   bool modelPar_given_POA3,
   AdmsSensFadType & modelPar_PLA3,
   bool modelPar_given_PLA3,
   AdmsSensFadType & modelPar_PWA3,
   bool modelPar_given_PWA3,
   AdmsSensFadType & modelPar_PLWA3,
   bool modelPar_given_PLWA3,
   AdmsSensFadType & modelPar_POA4,
   bool modelPar_given_POA4,
   AdmsSensFadType & modelPar_PLA4,
   bool modelPar_given_PLA4,
   AdmsSensFadType & modelPar_PWA4,
   bool modelPar_given_PWA4,
   AdmsSensFadType & modelPar_PLWA4,
   bool modelPar_given_PLWA4,
   AdmsSensFadType & modelPar_POGCO,
   bool modelPar_given_POGCO,
   AdmsSensFadType & modelPar_POIGINV,
   bool modelPar_given_POIGINV,
   AdmsSensFadType & modelPar_PLIGINV,
   bool modelPar_given_PLIGINV,
   AdmsSensFadType & modelPar_PWIGINV,
   bool modelPar_given_PWIGINV,
   AdmsSensFadType & modelPar_PLWIGINV,
   bool modelPar_given_PLWIGINV,
   AdmsSensFadType & modelPar_POIGOV,
   bool modelPar_given_POIGOV,
   AdmsSensFadType & modelPar_PLIGOV,
   bool modelPar_given_PLIGOV,
   AdmsSensFadType & modelPar_PWIGOV,
   bool modelPar_given_PWIGOV,
   AdmsSensFadType & modelPar_PLWIGOV,
   bool modelPar_given_PLWIGOV,
   AdmsSensFadType & modelPar_POIGOVD,
   bool modelPar_given_POIGOVD,
   AdmsSensFadType & modelPar_PLIGOVD,
   bool modelPar_given_PLIGOVD,
   AdmsSensFadType & modelPar_PWIGOVD,
   bool modelPar_given_PWIGOVD,
   AdmsSensFadType & modelPar_PLWIGOVD,
   bool modelPar_given_PLWIGOVD,
   AdmsSensFadType & modelPar_POSTIG,
   bool modelPar_given_POSTIG,
   AdmsSensFadType & modelPar_POGC2,
   bool modelPar_given_POGC2,
   AdmsSensFadType & modelPar_POGC3,
   bool modelPar_given_POGC3,
   AdmsSensFadType & modelPar_POCHIB,
   bool modelPar_given_POCHIB,
   AdmsSensFadType & modelPar_POAGIDL,
   bool modelPar_given_POAGIDL,
   AdmsSensFadType & modelPar_PLAGIDL,
   bool modelPar_given_PLAGIDL,
   AdmsSensFadType & modelPar_PWAGIDL,
   bool modelPar_given_PWAGIDL,
   AdmsSensFadType & modelPar_PLWAGIDL,
   bool modelPar_given_PLWAGIDL,
   AdmsSensFadType & modelPar_POAGIDLD,
   bool modelPar_given_POAGIDLD,
   AdmsSensFadType & modelPar_PLAGIDLD,
   bool modelPar_given_PLAGIDLD,
   AdmsSensFadType & modelPar_PWAGIDLD,
   bool modelPar_given_PWAGIDLD,
   AdmsSensFadType & modelPar_PLWAGIDLD,
   bool modelPar_given_PLWAGIDLD,
   AdmsSensFadType & modelPar_POBGIDL,
   bool modelPar_given_POBGIDL,
   AdmsSensFadType & modelPar_POBGIDLD,
   bool modelPar_given_POBGIDLD,
   AdmsSensFadType & modelPar_POSTBGIDL,
   bool modelPar_given_POSTBGIDL,
   AdmsSensFadType & modelPar_POSTBGIDLD,
   bool modelPar_given_POSTBGIDLD,
   AdmsSensFadType & modelPar_POCGIDL,
   bool modelPar_given_POCGIDL,
   AdmsSensFadType & modelPar_POCGIDLD,
   bool modelPar_given_POCGIDLD,
   AdmsSensFadType & modelPar_POCOX,
   bool modelPar_given_POCOX,
   AdmsSensFadType & modelPar_PLCOX,
   bool modelPar_given_PLCOX,
   AdmsSensFadType & modelPar_PWCOX,
   bool modelPar_given_PWCOX,
   AdmsSensFadType & modelPar_PLWCOX,
   bool modelPar_given_PLWCOX,
   AdmsSensFadType & modelPar_POCGOV,
   bool modelPar_given_POCGOV,
   AdmsSensFadType & modelPar_PLCGOV,
   bool modelPar_given_PLCGOV,
   AdmsSensFadType & modelPar_PWCGOV,
   bool modelPar_given_PWCGOV,
   AdmsSensFadType & modelPar_PLWCGOV,
   bool modelPar_given_PLWCGOV,
   AdmsSensFadType & modelPar_POCGOVD,
   bool modelPar_given_POCGOVD,
   AdmsSensFadType & modelPar_PLCGOVD,
   bool modelPar_given_PLCGOVD,
   AdmsSensFadType & modelPar_PWCGOVD,
   bool modelPar_given_PWCGOVD,
   AdmsSensFadType & modelPar_PLWCGOVD,
   bool modelPar_given_PLWCGOVD,
   AdmsSensFadType & modelPar_POCGBOV,
   bool modelPar_given_POCGBOV,
   AdmsSensFadType & modelPar_PLCGBOV,
   bool modelPar_given_PLCGBOV,
   AdmsSensFadType & modelPar_PWCGBOV,
   bool modelPar_given_PWCGBOV,
   AdmsSensFadType & modelPar_PLWCGBOV,
   bool modelPar_given_PLWCGBOV,
   AdmsSensFadType & modelPar_POCFR,
   bool modelPar_given_POCFR,
   AdmsSensFadType & modelPar_PLCFR,
   bool modelPar_given_PLCFR,
   AdmsSensFadType & modelPar_PWCFR,
   bool modelPar_given_PWCFR,
   AdmsSensFadType & modelPar_PLWCFR,
   bool modelPar_given_PLWCFR,
   AdmsSensFadType & modelPar_POCFRD,
   bool modelPar_given_POCFRD,
   AdmsSensFadType & modelPar_PLCFRD,
   bool modelPar_given_PLCFRD,
   AdmsSensFadType & modelPar_PWCFRD,
   bool modelPar_given_PWCFRD,
   AdmsSensFadType & modelPar_PLWCFRD,
   bool modelPar_given_PLWCFRD,
   AdmsSensFadType & modelPar_POFNT,
   bool modelPar_given_POFNT,
   AdmsSensFadType & modelPar_POFNTEXC,
   bool modelPar_given_POFNTEXC,
   AdmsSensFadType & modelPar_PLFNTEXC,
   bool modelPar_given_PLFNTEXC,
   AdmsSensFadType & modelPar_PWFNTEXC,
   bool modelPar_given_PWFNTEXC,
   AdmsSensFadType & modelPar_PLWFNTEXC,
   bool modelPar_given_PLWFNTEXC,
   AdmsSensFadType & modelPar_PONFA,
   bool modelPar_given_PONFA,
   AdmsSensFadType & modelPar_PLNFA,
   bool modelPar_given_PLNFA,
   AdmsSensFadType & modelPar_PWNFA,
   bool modelPar_given_PWNFA,
   AdmsSensFadType & modelPar_PLWNFA,
   bool modelPar_given_PLWNFA,
   AdmsSensFadType & modelPar_PONFB,
   bool modelPar_given_PONFB,
   AdmsSensFadType & modelPar_PLNFB,
   bool modelPar_given_PLNFB,
   AdmsSensFadType & modelPar_PWNFB,
   bool modelPar_given_PWNFB,
   AdmsSensFadType & modelPar_PLWNFB,
   bool modelPar_given_PLWNFB,
   AdmsSensFadType & modelPar_PONFC,
   bool modelPar_given_PONFC,
   AdmsSensFadType & modelPar_PLNFC,
   bool modelPar_given_PLNFC,
   AdmsSensFadType & modelPar_PWNFC,
   bool modelPar_given_PWNFC,
   AdmsSensFadType & modelPar_PLWNFC,
   bool modelPar_given_PLWNFC,
   AdmsSensFadType & modelPar_POEF,
   bool modelPar_given_POEF,
   AdmsSensFadType & modelPar_POVFBEDGE,
   bool modelPar_given_POVFBEDGE,
   AdmsSensFadType & modelPar_POSTVFBEDGE,
   bool modelPar_given_POSTVFBEDGE,
   AdmsSensFadType & modelPar_PLSTVFBEDGE,
   bool modelPar_given_PLSTVFBEDGE,
   AdmsSensFadType & modelPar_PWSTVFBEDGE,
   bool modelPar_given_PWSTVFBEDGE,
   AdmsSensFadType & modelPar_PLWSTVFBEDGE,
   bool modelPar_given_PLWSTVFBEDGE,
   AdmsSensFadType & modelPar_PODPHIBEDGE,
   bool modelPar_given_PODPHIBEDGE,
   AdmsSensFadType & modelPar_PLDPHIBEDGE,
   bool modelPar_given_PLDPHIBEDGE,
   AdmsSensFadType & modelPar_PWDPHIBEDGE,
   bool modelPar_given_PWDPHIBEDGE,
   AdmsSensFadType & modelPar_PLWDPHIBEDGE,
   bool modelPar_given_PLWDPHIBEDGE,
   AdmsSensFadType & modelPar_PONEFFEDGE,
   bool modelPar_given_PONEFFEDGE,
   AdmsSensFadType & modelPar_PLNEFFEDGE,
   bool modelPar_given_PLNEFFEDGE,
   AdmsSensFadType & modelPar_PWNEFFEDGE,
   bool modelPar_given_PWNEFFEDGE,
   AdmsSensFadType & modelPar_PLWNEFFEDGE,
   bool modelPar_given_PLWNEFFEDGE,
   AdmsSensFadType & modelPar_POCTEDGE,
   bool modelPar_given_POCTEDGE,
   AdmsSensFadType & modelPar_PLCTEDGE,
   bool modelPar_given_PLCTEDGE,
   AdmsSensFadType & modelPar_PWCTEDGE,
   bool modelPar_given_PWCTEDGE,
   AdmsSensFadType & modelPar_PLWCTEDGE,
   bool modelPar_given_PLWCTEDGE,
   AdmsSensFadType & modelPar_POBETNEDGE,
   bool modelPar_given_POBETNEDGE,
   AdmsSensFadType & modelPar_PLBETNEDGE,
   bool modelPar_given_PLBETNEDGE,
   AdmsSensFadType & modelPar_PWBETNEDGE,
   bool modelPar_given_PWBETNEDGE,
   AdmsSensFadType & modelPar_PLWBETNEDGE,
   bool modelPar_given_PLWBETNEDGE,
   AdmsSensFadType & modelPar_POSTBETEDGE,
   bool modelPar_given_POSTBETEDGE,
   AdmsSensFadType & modelPar_PLSTBETEDGE,
   bool modelPar_given_PLSTBETEDGE,
   AdmsSensFadType & modelPar_PWSTBETEDGE,
   bool modelPar_given_PWSTBETEDGE,
   AdmsSensFadType & modelPar_PLWSTBETEDGE,
   bool modelPar_given_PLWSTBETEDGE,
   AdmsSensFadType & modelPar_POPSCEEDGE,
   bool modelPar_given_POPSCEEDGE,
   AdmsSensFadType & modelPar_PLPSCEEDGE,
   bool modelPar_given_PLPSCEEDGE,
   AdmsSensFadType & modelPar_PWPSCEEDGE,
   bool modelPar_given_PWPSCEEDGE,
   AdmsSensFadType & modelPar_PLWPSCEEDGE,
   bool modelPar_given_PLWPSCEEDGE,
   AdmsSensFadType & modelPar_POPSCEBEDGE,
   bool modelPar_given_POPSCEBEDGE,
   AdmsSensFadType & modelPar_POPSCEDEDGE,
   bool modelPar_given_POPSCEDEDGE,
   AdmsSensFadType & modelPar_POCFEDGE,
   bool modelPar_given_POCFEDGE,
   AdmsSensFadType & modelPar_PLCFEDGE,
   bool modelPar_given_PLCFEDGE,
   AdmsSensFadType & modelPar_PWCFEDGE,
   bool modelPar_given_PWCFEDGE,
   AdmsSensFadType & modelPar_PLWCFEDGE,
   bool modelPar_given_PLWCFEDGE,
   AdmsSensFadType & modelPar_POCFDEDGE,
   bool modelPar_given_POCFDEDGE,
   AdmsSensFadType & modelPar_POCFBEDGE,
   bool modelPar_given_POCFBEDGE,
   AdmsSensFadType & modelPar_POFNTEDGE,
   bool modelPar_given_POFNTEDGE,
   AdmsSensFadType & modelPar_PONFAEDGE,
   bool modelPar_given_PONFAEDGE,
   AdmsSensFadType & modelPar_PLNFAEDGE,
   bool modelPar_given_PLNFAEDGE,
   AdmsSensFadType & modelPar_PWNFAEDGE,
   bool modelPar_given_PWNFAEDGE,
   AdmsSensFadType & modelPar_PLWNFAEDGE,
   bool modelPar_given_PLWNFAEDGE,
   AdmsSensFadType & modelPar_PONFBEDGE,
   bool modelPar_given_PONFBEDGE,
   AdmsSensFadType & modelPar_PLNFBEDGE,
   bool modelPar_given_PLNFBEDGE,
   AdmsSensFadType & modelPar_PWNFBEDGE,
   bool modelPar_given_PWNFBEDGE,
   AdmsSensFadType & modelPar_PLWNFBEDGE,
   bool modelPar_given_PLWNFBEDGE,
   AdmsSensFadType & modelPar_PONFCEDGE,
   bool modelPar_given_PONFCEDGE,
   AdmsSensFadType & modelPar_PLNFCEDGE,
   bool modelPar_given_PLNFCEDGE,
   AdmsSensFadType & modelPar_PWNFCEDGE,
   bool modelPar_given_PWNFCEDGE,
   AdmsSensFadType & modelPar_PLWNFCEDGE,
   bool modelPar_given_PLWNFCEDGE,
   AdmsSensFadType & modelPar_POEFEDGE,
   bool modelPar_given_POEFEDGE,
   AdmsSensFadType & modelPar_POKVTHOWE,
   bool modelPar_given_POKVTHOWE,
   AdmsSensFadType & modelPar_PLKVTHOWE,
   bool modelPar_given_PLKVTHOWE,
   AdmsSensFadType & modelPar_PWKVTHOWE,
   bool modelPar_given_PWKVTHOWE,
   AdmsSensFadType & modelPar_PLWKVTHOWE,
   bool modelPar_given_PLWKVTHOWE,
   AdmsSensFadType & modelPar_POKUOWE,
   bool modelPar_given_POKUOWE,
   AdmsSensFadType & modelPar_PLKUOWE,
   bool modelPar_given_PLKUOWE,
   AdmsSensFadType & modelPar_PWKUOWE,
   bool modelPar_given_PWKUOWE,
   AdmsSensFadType & modelPar_PLWKUOWE,
   bool modelPar_given_PLWKUOWE,
   AdmsSensFadType & modelPar_LMIN,
   bool modelPar_given_LMIN,
   AdmsSensFadType & modelPar_LMAX,
   bool modelPar_given_LMAX,
   AdmsSensFadType & modelPar_WMIN,
   bool modelPar_given_WMIN,
   AdmsSensFadType & modelPar_WMAX,
   bool modelPar_given_WMAX,
   AdmsSensFadType & modelPar_LVARO,
   bool modelPar_given_LVARO,
   AdmsSensFadType & modelPar_LVARL,
   bool modelPar_given_LVARL,
   AdmsSensFadType & modelPar_LVARW,
   bool modelPar_given_LVARW,
   AdmsSensFadType & modelPar_LAP,
   bool modelPar_given_LAP,
   AdmsSensFadType & modelPar_WVARO,
   bool modelPar_given_WVARO,
   AdmsSensFadType & modelPar_WVARL,
   bool modelPar_given_WVARL,
   AdmsSensFadType & modelPar_WVARW,
   bool modelPar_given_WVARW,
   AdmsSensFadType & modelPar_WOT,
   bool modelPar_given_WOT,
   AdmsSensFadType & modelPar_DLQ,
   bool modelPar_given_DLQ,
   AdmsSensFadType & modelPar_DWQ,
   bool modelPar_given_DWQ,
   AdmsSensFadType & modelPar_VFBO,
   bool modelPar_given_VFBO,
   AdmsSensFadType & modelPar_VFBL,
   bool modelPar_given_VFBL,
   AdmsSensFadType & modelPar_VFBW,
   bool modelPar_given_VFBW,
   AdmsSensFadType & modelPar_VFBLW,
   bool modelPar_given_VFBLW,
   AdmsSensFadType & modelPar_STVFBO,
   bool modelPar_given_STVFBO,
   AdmsSensFadType & modelPar_STVFBL,
   bool modelPar_given_STVFBL,
   AdmsSensFadType & modelPar_STVFBW,
   bool modelPar_given_STVFBW,
   AdmsSensFadType & modelPar_STVFBLW,
   bool modelPar_given_STVFBLW,
   AdmsSensFadType & modelPar_TOXO,
   bool modelPar_given_TOXO,
   AdmsSensFadType & modelPar_EPSROXO,
   bool modelPar_given_EPSROXO,
   AdmsSensFadType & modelPar_NSUBO,
   bool modelPar_given_NSUBO,
   AdmsSensFadType & modelPar_NSUBW,
   bool modelPar_given_NSUBW,
   AdmsSensFadType & modelPar_WSEG,
   bool modelPar_given_WSEG,
   AdmsSensFadType & modelPar_NPCK,
   bool modelPar_given_NPCK,
   AdmsSensFadType & modelPar_NPCKW,
   bool modelPar_given_NPCKW,
   AdmsSensFadType & modelPar_WSEGP,
   bool modelPar_given_WSEGP,
   AdmsSensFadType & modelPar_LPCK,
   bool modelPar_given_LPCK,
   AdmsSensFadType & modelPar_LPCKW,
   bool modelPar_given_LPCKW,
   AdmsSensFadType & modelPar_FOL1,
   bool modelPar_given_FOL1,
   AdmsSensFadType & modelPar_FOL2,
   bool modelPar_given_FOL2,
   AdmsSensFadType & modelPar_FACNEFFACO,
   bool modelPar_given_FACNEFFACO,
   AdmsSensFadType & modelPar_FACNEFFACL,
   bool modelPar_given_FACNEFFACL,
   AdmsSensFadType & modelPar_FACNEFFACW,
   bool modelPar_given_FACNEFFACW,
   AdmsSensFadType & modelPar_FACNEFFACLW,
   bool modelPar_given_FACNEFFACLW,
   AdmsSensFadType & modelPar_GFACNUDO,
   bool modelPar_given_GFACNUDO,
   AdmsSensFadType & modelPar_GFACNUDL,
   bool modelPar_given_GFACNUDL,
   AdmsSensFadType & modelPar_GFACNUDLEXP,
   bool modelPar_given_GFACNUDLEXP,
   AdmsSensFadType & modelPar_GFACNUDW,
   bool modelPar_given_GFACNUDW,
   AdmsSensFadType & modelPar_GFACNUDLW,
   bool modelPar_given_GFACNUDLW,
   AdmsSensFadType & modelPar_VSBNUDO,
   bool modelPar_given_VSBNUDO,
   AdmsSensFadType & modelPar_DVSBNUDO,
   bool modelPar_given_DVSBNUDO,
   AdmsSensFadType & modelPar_VNSUBO,
   bool modelPar_given_VNSUBO,
   AdmsSensFadType & modelPar_NSLPO,
   bool modelPar_given_NSLPO,
   AdmsSensFadType & modelPar_DNSUBO,
   bool modelPar_given_DNSUBO,
   AdmsSensFadType & modelPar_DPHIBO,
   bool modelPar_given_DPHIBO,
   AdmsSensFadType & modelPar_DPHIBL,
   bool modelPar_given_DPHIBL,
   AdmsSensFadType & modelPar_DPHIBLEXP,
   bool modelPar_given_DPHIBLEXP,
   AdmsSensFadType & modelPar_DPHIBW,
   bool modelPar_given_DPHIBW,
   AdmsSensFadType & modelPar_DPHIBLW,
   bool modelPar_given_DPHIBLW,
   AdmsSensFadType & modelPar_DELVTACO,
   bool modelPar_given_DELVTACO,
   AdmsSensFadType & modelPar_DELVTACL,
   bool modelPar_given_DELVTACL,
   AdmsSensFadType & modelPar_DELVTACLEXP,
   bool modelPar_given_DELVTACLEXP,
   AdmsSensFadType & modelPar_DELVTACW,
   bool modelPar_given_DELVTACW,
   AdmsSensFadType & modelPar_DELVTACLW,
   bool modelPar_given_DELVTACLW,
   AdmsSensFadType & modelPar_NPO,
   bool modelPar_given_NPO,
   AdmsSensFadType & modelPar_NPL,
   bool modelPar_given_NPL,
   AdmsSensFadType & modelPar_CTO,
   bool modelPar_given_CTO,
   AdmsSensFadType & modelPar_CTL,
   bool modelPar_given_CTL,
   AdmsSensFadType & modelPar_CTLEXP,
   bool modelPar_given_CTLEXP,
   AdmsSensFadType & modelPar_CTW,
   bool modelPar_given_CTW,
   AdmsSensFadType & modelPar_CTLW,
   bool modelPar_given_CTLW,
   AdmsSensFadType & modelPar_TOXOVO,
   bool modelPar_given_TOXOVO,
   AdmsSensFadType & modelPar_TOXOVDO,
   bool modelPar_given_TOXOVDO,
   AdmsSensFadType & modelPar_LOV,
   bool modelPar_given_LOV,
   AdmsSensFadType & modelPar_LOVD,
   bool modelPar_given_LOVD,
   AdmsSensFadType & modelPar_NOVO,
   bool modelPar_given_NOVO,
   AdmsSensFadType & modelPar_NOVDO,
   bool modelPar_given_NOVDO,
   AdmsSensFadType & modelPar_CFL,
   bool modelPar_given_CFL,
   AdmsSensFadType & modelPar_CFLEXP,
   bool modelPar_given_CFLEXP,
   AdmsSensFadType & modelPar_CFW,
   bool modelPar_given_CFW,
   AdmsSensFadType & modelPar_CFDO,
   bool modelPar_given_CFDO,
   AdmsSensFadType & modelPar_CFBO,
   bool modelPar_given_CFBO,
   AdmsSensFadType & modelPar_PSCEL,
   bool modelPar_given_PSCEL,
   AdmsSensFadType & modelPar_PSCELEXP,
   bool modelPar_given_PSCELEXP,
   AdmsSensFadType & modelPar_PSCEW,
   bool modelPar_given_PSCEW,
   AdmsSensFadType & modelPar_PSCEBO,
   bool modelPar_given_PSCEBO,
   AdmsSensFadType & modelPar_PSCEDO,
   bool modelPar_given_PSCEDO,
   AdmsSensFadType & modelPar_UO,
   bool modelPar_given_UO,
   AdmsSensFadType & modelPar_FBET1,
   bool modelPar_given_FBET1,
   AdmsSensFadType & modelPar_FBET1W,
   bool modelPar_given_FBET1W,
   AdmsSensFadType & modelPar_LP1,
   bool modelPar_given_LP1,
   AdmsSensFadType & modelPar_LP1W,
   bool modelPar_given_LP1W,
   AdmsSensFadType & modelPar_FBET2,
   bool modelPar_given_FBET2,
   AdmsSensFadType & modelPar_LP2,
   bool modelPar_given_LP2,
   AdmsSensFadType & modelPar_BETW1,
   bool modelPar_given_BETW1,
   AdmsSensFadType & modelPar_BETW2,
   bool modelPar_given_BETW2,
   AdmsSensFadType & modelPar_WBET,
   bool modelPar_given_WBET,
   AdmsSensFadType & modelPar_STBETO,
   bool modelPar_given_STBETO,
   AdmsSensFadType & modelPar_STBETL,
   bool modelPar_given_STBETL,
   AdmsSensFadType & modelPar_STBETW,
   bool modelPar_given_STBETW,
   AdmsSensFadType & modelPar_STBETLW,
   bool modelPar_given_STBETLW,
   AdmsSensFadType & modelPar_MUEO,
   bool modelPar_given_MUEO,
   AdmsSensFadType & modelPar_MUEW,
   bool modelPar_given_MUEW,
   AdmsSensFadType & modelPar_STMUEO,
   bool modelPar_given_STMUEO,
   AdmsSensFadType & modelPar_THEMUO,
   bool modelPar_given_THEMUO,
   AdmsSensFadType & modelPar_STTHEMUO,
   bool modelPar_given_STTHEMUO,
   AdmsSensFadType & modelPar_CSO,
   bool modelPar_given_CSO,
   AdmsSensFadType & modelPar_CSL,
   bool modelPar_given_CSL,
   AdmsSensFadType & modelPar_CSLEXP,
   bool modelPar_given_CSLEXP,
   AdmsSensFadType & modelPar_CSW,
   bool modelPar_given_CSW,
   AdmsSensFadType & modelPar_CSLW,
   bool modelPar_given_CSLW,
   AdmsSensFadType & modelPar_STCSO,
   bool modelPar_given_STCSO,
   AdmsSensFadType & modelPar_XCORO,
   bool modelPar_given_XCORO,
   AdmsSensFadType & modelPar_XCORL,
   bool modelPar_given_XCORL,
   AdmsSensFadType & modelPar_XCORW,
   bool modelPar_given_XCORW,
   AdmsSensFadType & modelPar_XCORLW,
   bool modelPar_given_XCORLW,
   AdmsSensFadType & modelPar_STXCORO,
   bool modelPar_given_STXCORO,
   AdmsSensFadType & modelPar_FETAO,
   bool modelPar_given_FETAO,
   AdmsSensFadType & modelPar_RSW1,
   bool modelPar_given_RSW1,
   AdmsSensFadType & modelPar_RSW2,
   bool modelPar_given_RSW2,
   AdmsSensFadType & modelPar_STRSO,
   bool modelPar_given_STRSO,
   AdmsSensFadType & modelPar_RSBO,
   bool modelPar_given_RSBO,
   AdmsSensFadType & modelPar_RSGO,
   bool modelPar_given_RSGO,
   AdmsSensFadType & modelPar_THESATO,
   bool modelPar_given_THESATO,
   AdmsSensFadType & modelPar_THESATL,
   bool modelPar_given_THESATL,
   AdmsSensFadType & modelPar_THESATLEXP,
   bool modelPar_given_THESATLEXP,
   AdmsSensFadType & modelPar_THESATW,
   bool modelPar_given_THESATW,
   AdmsSensFadType & modelPar_THESATLW,
   bool modelPar_given_THESATLW,
   AdmsSensFadType & modelPar_STTHESATO,
   bool modelPar_given_STTHESATO,
   AdmsSensFadType & modelPar_STTHESATL,
   bool modelPar_given_STTHESATL,
   AdmsSensFadType & modelPar_STTHESATW,
   bool modelPar_given_STTHESATW,
   AdmsSensFadType & modelPar_STTHESATLW,
   bool modelPar_given_STTHESATLW,
   AdmsSensFadType & modelPar_THESATBO,
   bool modelPar_given_THESATBO,
   AdmsSensFadType & modelPar_THESATGO,
   bool modelPar_given_THESATGO,
   AdmsSensFadType & modelPar_AXO,
   bool modelPar_given_AXO,
   AdmsSensFadType & modelPar_AXL,
   bool modelPar_given_AXL,
   AdmsSensFadType & modelPar_ALPL,
   bool modelPar_given_ALPL,
   AdmsSensFadType & modelPar_ALPLEXP,
   bool modelPar_given_ALPLEXP,
   AdmsSensFadType & modelPar_ALPW,
   bool modelPar_given_ALPW,
   AdmsSensFadType & modelPar_ALP1L1,
   bool modelPar_given_ALP1L1,
   AdmsSensFadType & modelPar_ALP1LEXP,
   bool modelPar_given_ALP1LEXP,
   AdmsSensFadType & modelPar_ALP1L2,
   bool modelPar_given_ALP1L2,
   AdmsSensFadType & modelPar_ALP1W,
   bool modelPar_given_ALP1W,
   AdmsSensFadType & modelPar_ALP2L1,
   bool modelPar_given_ALP2L1,
   AdmsSensFadType & modelPar_ALP2LEXP,
   bool modelPar_given_ALP2LEXP,
   AdmsSensFadType & modelPar_ALP2L2,
   bool modelPar_given_ALP2L2,
   AdmsSensFadType & modelPar_ALP2W,
   bool modelPar_given_ALP2W,
   AdmsSensFadType & modelPar_VPO,
   bool modelPar_given_VPO,
   AdmsSensFadType & modelPar_A1O,
   bool modelPar_given_A1O,
   AdmsSensFadType & modelPar_A1L,
   bool modelPar_given_A1L,
   AdmsSensFadType & modelPar_A1W,
   bool modelPar_given_A1W,
   AdmsSensFadType & modelPar_A2O,
   bool modelPar_given_A2O,
   AdmsSensFadType & modelPar_STA2O,
   bool modelPar_given_STA2O,
   AdmsSensFadType & modelPar_A3O,
   bool modelPar_given_A3O,
   AdmsSensFadType & modelPar_A3L,
   bool modelPar_given_A3L,
   AdmsSensFadType & modelPar_A3W,
   bool modelPar_given_A3W,
   AdmsSensFadType & modelPar_A4O,
   bool modelPar_given_A4O,
   AdmsSensFadType & modelPar_A4L,
   bool modelPar_given_A4L,
   AdmsSensFadType & modelPar_A4W,
   bool modelPar_given_A4W,
   AdmsSensFadType & modelPar_GCOO,
   bool modelPar_given_GCOO,
   AdmsSensFadType & modelPar_IGINVLW,
   bool modelPar_given_IGINVLW,
   AdmsSensFadType & modelPar_IGOVW,
   bool modelPar_given_IGOVW,
   AdmsSensFadType & modelPar_IGOVDW,
   bool modelPar_given_IGOVDW,
   AdmsSensFadType & modelPar_STIGO,
   bool modelPar_given_STIGO,
   AdmsSensFadType & modelPar_GC2O,
   bool modelPar_given_GC2O,
   AdmsSensFadType & modelPar_GC3O,
   bool modelPar_given_GC3O,
   AdmsSensFadType & modelPar_CHIBO,
   bool modelPar_given_CHIBO,
   AdmsSensFadType & modelPar_AGIDLW,
   bool modelPar_given_AGIDLW,
   AdmsSensFadType & modelPar_AGIDLDW,
   bool modelPar_given_AGIDLDW,
   AdmsSensFadType & modelPar_BGIDLO,
   bool modelPar_given_BGIDLO,
   AdmsSensFadType & modelPar_BGIDLDO,
   bool modelPar_given_BGIDLDO,
   AdmsSensFadType & modelPar_STBGIDLO,
   bool modelPar_given_STBGIDLO,
   AdmsSensFadType & modelPar_STBGIDLDO,
   bool modelPar_given_STBGIDLDO,
   AdmsSensFadType & modelPar_CGIDLO,
   bool modelPar_given_CGIDLO,
   AdmsSensFadType & modelPar_CGIDLDO,
   bool modelPar_given_CGIDLDO,
   AdmsSensFadType & modelPar_CGBOVL,
   bool modelPar_given_CGBOVL,
   AdmsSensFadType & modelPar_CFRW,
   bool modelPar_given_CFRW,
   AdmsSensFadType & modelPar_CFRDW,
   bool modelPar_given_CFRDW,
   AdmsSensFadType & modelPar_FNTO,
   bool modelPar_given_FNTO,
   AdmsSensFadType & modelPar_FNTEXCL,
   bool modelPar_given_FNTEXCL,
   AdmsSensFadType & modelPar_NFALW,
   bool modelPar_given_NFALW,
   AdmsSensFadType & modelPar_NFBLW,
   bool modelPar_given_NFBLW,
   AdmsSensFadType & modelPar_NFCLW,
   bool modelPar_given_NFCLW,
   AdmsSensFadType & modelPar_EFO,
   bool modelPar_given_EFO,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_ALPNOI,
   bool modelPar_given_ALPNOI,
   AdmsSensFadType & modelPar_WEDGE,
   bool modelPar_given_WEDGE,
   AdmsSensFadType & modelPar_WEDGEW,
   bool modelPar_given_WEDGEW,
   AdmsSensFadType & modelPar_VFBEDGEO,
   bool modelPar_given_VFBEDGEO,
   AdmsSensFadType & modelPar_STVFBEDGEO,
   bool modelPar_given_STVFBEDGEO,
   AdmsSensFadType & modelPar_STVFBEDGEL,
   bool modelPar_given_STVFBEDGEL,
   AdmsSensFadType & modelPar_STVFBEDGEW,
   bool modelPar_given_STVFBEDGEW,
   AdmsSensFadType & modelPar_STVFBEDGELW,
   bool modelPar_given_STVFBEDGELW,
   AdmsSensFadType & modelPar_DPHIBEDGEO,
   bool modelPar_given_DPHIBEDGEO,
   AdmsSensFadType & modelPar_DPHIBEDGEL,
   bool modelPar_given_DPHIBEDGEL,
   AdmsSensFadType & modelPar_DPHIBEDGELEXP,
   bool modelPar_given_DPHIBEDGELEXP,
   AdmsSensFadType & modelPar_DPHIBEDGEW,
   bool modelPar_given_DPHIBEDGEW,
   AdmsSensFadType & modelPar_DPHIBEDGELW,
   bool modelPar_given_DPHIBEDGELW,
   AdmsSensFadType & modelPar_NSUBEDGEO,
   bool modelPar_given_NSUBEDGEO,
   AdmsSensFadType & modelPar_NSUBEDGEL,
   bool modelPar_given_NSUBEDGEL,
   AdmsSensFadType & modelPar_NSUBEDGEW,
   bool modelPar_given_NSUBEDGEW,
   AdmsSensFadType & modelPar_NSUBEDGELW,
   bool modelPar_given_NSUBEDGELW,
   AdmsSensFadType & modelPar_CTEDGEO,
   bool modelPar_given_CTEDGEO,
   AdmsSensFadType & modelPar_CTEDGEL,
   bool modelPar_given_CTEDGEL,
   AdmsSensFadType & modelPar_CTEDGELEXP,
   bool modelPar_given_CTEDGELEXP,
   AdmsSensFadType & modelPar_FBETEDGE,
   bool modelPar_given_FBETEDGE,
   AdmsSensFadType & modelPar_LPEDGE,
   bool modelPar_given_LPEDGE,
   AdmsSensFadType & modelPar_BETEDGEW,
   bool modelPar_given_BETEDGEW,
   AdmsSensFadType & modelPar_STBETEDGEO,
   bool modelPar_given_STBETEDGEO,
   AdmsSensFadType & modelPar_STBETEDGEL,
   bool modelPar_given_STBETEDGEL,
   AdmsSensFadType & modelPar_STBETEDGEW,
   bool modelPar_given_STBETEDGEW,
   AdmsSensFadType & modelPar_STBETEDGELW,
   bool modelPar_given_STBETEDGELW,
   AdmsSensFadType & modelPar_PSCEEDGEL,
   bool modelPar_given_PSCEEDGEL,
   AdmsSensFadType & modelPar_PSCEEDGELEXP,
   bool modelPar_given_PSCEEDGELEXP,
   AdmsSensFadType & modelPar_PSCEEDGEW,
   bool modelPar_given_PSCEEDGEW,
   AdmsSensFadType & modelPar_PSCEBEDGEO,
   bool modelPar_given_PSCEBEDGEO,
   AdmsSensFadType & modelPar_PSCEDEDGEO,
   bool modelPar_given_PSCEDEDGEO,
   AdmsSensFadType & modelPar_CFEDGEL,
   bool modelPar_given_CFEDGEL,
   AdmsSensFadType & modelPar_CFEDGELEXP,
   bool modelPar_given_CFEDGELEXP,
   AdmsSensFadType & modelPar_CFEDGEW,
   bool modelPar_given_CFEDGEW,
   AdmsSensFadType & modelPar_CFDEDGEO,
   bool modelPar_given_CFDEDGEO,
   AdmsSensFadType & modelPar_CFBEDGEO,
   bool modelPar_given_CFBEDGEO,
   AdmsSensFadType & modelPar_FNTEDGEO,
   bool modelPar_given_FNTEDGEO,
   AdmsSensFadType & modelPar_NFAEDGELW,
   bool modelPar_given_NFAEDGELW,
   AdmsSensFadType & modelPar_NFBEDGELW,
   bool modelPar_given_NFBEDGELW,
   AdmsSensFadType & modelPar_NFCEDGELW,
   bool modelPar_given_NFCEDGELW,
   AdmsSensFadType & modelPar_EFEDGEO,
   bool modelPar_given_EFEDGEO,
   AdmsSensFadType & modelPar_KVTHOWEO,
   bool modelPar_given_KVTHOWEO,
   AdmsSensFadType & modelPar_KVTHOWEL,
   bool modelPar_given_KVTHOWEL,
   AdmsSensFadType & modelPar_KVTHOWEW,
   bool modelPar_given_KVTHOWEW,
   AdmsSensFadType & modelPar_KVTHOWELW,
   bool modelPar_given_KVTHOWELW,
   AdmsSensFadType & modelPar_KUOWEO,
   bool modelPar_given_KUOWEO,
   AdmsSensFadType & modelPar_KUOWEL,
   bool modelPar_given_KUOWEL,
   AdmsSensFadType & modelPar_KUOWEW,
   bool modelPar_given_KUOWEW,
   AdmsSensFadType & modelPar_KUOWELW,
   bool modelPar_given_KUOWELW,
   AdmsSensFadType & modelPar_RGO,
   bool modelPar_given_RGO,
   AdmsSensFadType & modelPar_RINT,
   bool modelPar_given_RINT,
   AdmsSensFadType & modelPar_RVPOLY,
   bool modelPar_given_RVPOLY,
   AdmsSensFadType & modelPar_RSHG,
   bool modelPar_given_RSHG,
   AdmsSensFadType & modelPar_DLSIL,
   bool modelPar_given_DLSIL,
   AdmsSensFadType & modelPar_RSH,
   bool modelPar_given_RSH,
   AdmsSensFadType & modelPar_RSHD,
   bool modelPar_given_RSHD,
   AdmsSensFadType & modelPar_RBULKO,
   bool modelPar_given_RBULKO,
   AdmsSensFadType & modelPar_RWELLO,
   bool modelPar_given_RWELLO,
   AdmsSensFadType & modelPar_RJUNSO,
   bool modelPar_given_RJUNSO,
   AdmsSensFadType & modelPar_RJUNDO,
   bool modelPar_given_RJUNDO,
   AdmsSensFadType & modelPar_SAREF,
   bool modelPar_given_SAREF,
   AdmsSensFadType & modelPar_SBREF,
   bool modelPar_given_SBREF,
   AdmsSensFadType & modelPar_WLOD,
   bool modelPar_given_WLOD,
   AdmsSensFadType & modelPar_KUO,
   bool modelPar_given_KUO,
   AdmsSensFadType & modelPar_KVSAT,
   bool modelPar_given_KVSAT,
   AdmsSensFadType & modelPar_TKUO,
   bool modelPar_given_TKUO,
   AdmsSensFadType & modelPar_LKUO,
   bool modelPar_given_LKUO,
   AdmsSensFadType & modelPar_WKUO,
   bool modelPar_given_WKUO,
   AdmsSensFadType & modelPar_PKUO,
   bool modelPar_given_PKUO,
   AdmsSensFadType & modelPar_LLODKUO,
   bool modelPar_given_LLODKUO,
   AdmsSensFadType & modelPar_WLODKUO,
   bool modelPar_given_WLODKUO,
   AdmsSensFadType & modelPar_KVTHO,
   bool modelPar_given_KVTHO,
   AdmsSensFadType & modelPar_LKVTHO,
   bool modelPar_given_LKVTHO,
   AdmsSensFadType & modelPar_WKVTHO,
   bool modelPar_given_WKVTHO,
   AdmsSensFadType & modelPar_PKVTHO,
   bool modelPar_given_PKVTHO,
   AdmsSensFadType & modelPar_LLODVTH,
   bool modelPar_given_LLODVTH,
   AdmsSensFadType & modelPar_WLODVTH,
   bool modelPar_given_WLODVTH,
   AdmsSensFadType & modelPar_STETAO,
   bool modelPar_given_STETAO,
   AdmsSensFadType & modelPar_LODETAO,
   bool modelPar_given_LODETAO,
   AdmsSensFadType & modelPar_SCREF,
   bool modelPar_given_SCREF,
   AdmsSensFadType & modelPar_WEB,
   bool modelPar_given_WEB,
   AdmsSensFadType & modelPar_WEC,
   bool modelPar_given_WEC,
   AdmsSensFadType & modelPar_IMAX,
   bool modelPar_given_IMAX,
   AdmsSensFadType & modelPar_TRJ,
   bool modelPar_given_TRJ,
   AdmsSensFadType & modelPar_FREV,
   bool modelPar_given_FREV,
   AdmsSensFadType & modelPar_CJORBOT,
   bool modelPar_given_CJORBOT,
   AdmsSensFadType & modelPar_CJORSTI,
   bool modelPar_given_CJORSTI,
   AdmsSensFadType & modelPar_CJORGAT,
   bool modelPar_given_CJORGAT,
   AdmsSensFadType & modelPar_VBIRBOT,
   bool modelPar_given_VBIRBOT,
   AdmsSensFadType & modelPar_VBIRSTI,
   bool modelPar_given_VBIRSTI,
   AdmsSensFadType & modelPar_VBIRGAT,
   bool modelPar_given_VBIRGAT,
   AdmsSensFadType & modelPar_PBOT,
   bool modelPar_given_PBOT,
   AdmsSensFadType & modelPar_PSTI,
   bool modelPar_given_PSTI,
   AdmsSensFadType & modelPar_PGAT,
   bool modelPar_given_PGAT,
   AdmsSensFadType & modelPar_PHIGBOT,
   bool modelPar_given_PHIGBOT,
   AdmsSensFadType & modelPar_PHIGSTI,
   bool modelPar_given_PHIGSTI,
   AdmsSensFadType & modelPar_PHIGGAT,
   bool modelPar_given_PHIGGAT,
   AdmsSensFadType & modelPar_IDSATRBOT,
   bool modelPar_given_IDSATRBOT,
   AdmsSensFadType & modelPar_IDSATRSTI,
   bool modelPar_given_IDSATRSTI,
   AdmsSensFadType & modelPar_IDSATRGAT,
   bool modelPar_given_IDSATRGAT,
   AdmsSensFadType & modelPar_CSRHBOT,
   bool modelPar_given_CSRHBOT,
   AdmsSensFadType & modelPar_CSRHSTI,
   bool modelPar_given_CSRHSTI,
   AdmsSensFadType & modelPar_CSRHGAT,
   bool modelPar_given_CSRHGAT,
   AdmsSensFadType & modelPar_XJUNSTI,
   bool modelPar_given_XJUNSTI,
   AdmsSensFadType & modelPar_XJUNGAT,
   bool modelPar_given_XJUNGAT,
   AdmsSensFadType & modelPar_CTATBOT,
   bool modelPar_given_CTATBOT,
   AdmsSensFadType & modelPar_CTATSTI,
   bool modelPar_given_CTATSTI,
   AdmsSensFadType & modelPar_CTATGAT,
   bool modelPar_given_CTATGAT,
   AdmsSensFadType & modelPar_MEFFTATBOT,
   bool modelPar_given_MEFFTATBOT,
   AdmsSensFadType & modelPar_MEFFTATSTI,
   bool modelPar_given_MEFFTATSTI,
   AdmsSensFadType & modelPar_MEFFTATGAT,
   bool modelPar_given_MEFFTATGAT,
   AdmsSensFadType & modelPar_CBBTBOT,
   bool modelPar_given_CBBTBOT,
   AdmsSensFadType & modelPar_CBBTSTI,
   bool modelPar_given_CBBTSTI,
   AdmsSensFadType & modelPar_CBBTGAT,
   bool modelPar_given_CBBTGAT,
   AdmsSensFadType & modelPar_FBBTRBOT,
   bool modelPar_given_FBBTRBOT,
   AdmsSensFadType & modelPar_FBBTRSTI,
   bool modelPar_given_FBBTRSTI,
   AdmsSensFadType & modelPar_FBBTRGAT,
   bool modelPar_given_FBBTRGAT,
   AdmsSensFadType & modelPar_STFBBTBOT,
   bool modelPar_given_STFBBTBOT,
   AdmsSensFadType & modelPar_STFBBTSTI,
   bool modelPar_given_STFBBTSTI,
   AdmsSensFadType & modelPar_STFBBTGAT,
   bool modelPar_given_STFBBTGAT,
   AdmsSensFadType & modelPar_VBRBOT,
   bool modelPar_given_VBRBOT,
   AdmsSensFadType & modelPar_VBRSTI,
   bool modelPar_given_VBRSTI,
   AdmsSensFadType & modelPar_VBRGAT,
   bool modelPar_given_VBRGAT,
   AdmsSensFadType & modelPar_PBRBOT,
   bool modelPar_given_PBRBOT,
   AdmsSensFadType & modelPar_PBRSTI,
   bool modelPar_given_PBRSTI,
   AdmsSensFadType & modelPar_PBRGAT,
   bool modelPar_given_PBRGAT,
   AdmsSensFadType & modelPar_CJORBOTD,
   bool modelPar_given_CJORBOTD,
   AdmsSensFadType & modelPar_CJORSTID,
   bool modelPar_given_CJORSTID,
   AdmsSensFadType & modelPar_CJORGATD,
   bool modelPar_given_CJORGATD,
   AdmsSensFadType & modelPar_VBIRBOTD,
   bool modelPar_given_VBIRBOTD,
   AdmsSensFadType & modelPar_VBIRSTID,
   bool modelPar_given_VBIRSTID,
   AdmsSensFadType & modelPar_VBIRGATD,
   bool modelPar_given_VBIRGATD,
   AdmsSensFadType & modelPar_PBOTD,
   bool modelPar_given_PBOTD,
   AdmsSensFadType & modelPar_PSTID,
   bool modelPar_given_PSTID,
   AdmsSensFadType & modelPar_PGATD,
   bool modelPar_given_PGATD,
   AdmsSensFadType & modelPar_PHIGBOTD,
   bool modelPar_given_PHIGBOTD,
   AdmsSensFadType & modelPar_PHIGSTID,
   bool modelPar_given_PHIGSTID,
   AdmsSensFadType & modelPar_PHIGGATD,
   bool modelPar_given_PHIGGATD,
   AdmsSensFadType & modelPar_IDSATRBOTD,
   bool modelPar_given_IDSATRBOTD,
   AdmsSensFadType & modelPar_IDSATRSTID,
   bool modelPar_given_IDSATRSTID,
   AdmsSensFadType & modelPar_IDSATRGATD,
   bool modelPar_given_IDSATRGATD,
   AdmsSensFadType & modelPar_CSRHBOTD,
   bool modelPar_given_CSRHBOTD,
   AdmsSensFadType & modelPar_CSRHSTID,
   bool modelPar_given_CSRHSTID,
   AdmsSensFadType & modelPar_CSRHGATD,
   bool modelPar_given_CSRHGATD,
   AdmsSensFadType & modelPar_XJUNSTID,
   bool modelPar_given_XJUNSTID,
   AdmsSensFadType & modelPar_XJUNGATD,
   bool modelPar_given_XJUNGATD,
   AdmsSensFadType & modelPar_CTATBOTD,
   bool modelPar_given_CTATBOTD,
   AdmsSensFadType & modelPar_CTATSTID,
   bool modelPar_given_CTATSTID,
   AdmsSensFadType & modelPar_CTATGATD,
   bool modelPar_given_CTATGATD,
   AdmsSensFadType & modelPar_MEFFTATBOTD,
   bool modelPar_given_MEFFTATBOTD,
   AdmsSensFadType & modelPar_MEFFTATSTID,
   bool modelPar_given_MEFFTATSTID,
   AdmsSensFadType & modelPar_MEFFTATGATD,
   bool modelPar_given_MEFFTATGATD,
   AdmsSensFadType & modelPar_CBBTBOTD,
   bool modelPar_given_CBBTBOTD,
   AdmsSensFadType & modelPar_CBBTSTID,
   bool modelPar_given_CBBTSTID,
   AdmsSensFadType & modelPar_CBBTGATD,
   bool modelPar_given_CBBTGATD,
   AdmsSensFadType & modelPar_FBBTRBOTD,
   bool modelPar_given_FBBTRBOTD,
   AdmsSensFadType & modelPar_FBBTRSTID,
   bool modelPar_given_FBBTRSTID,
   AdmsSensFadType & modelPar_FBBTRGATD,
   bool modelPar_given_FBBTRGATD,
   AdmsSensFadType & modelPar_STFBBTBOTD,
   bool modelPar_given_STFBBTBOTD,
   AdmsSensFadType & modelPar_STFBBTSTID,
   bool modelPar_given_STFBBTSTID,
   AdmsSensFadType & modelPar_STFBBTGATD,
   bool modelPar_given_STFBBTGATD,
   AdmsSensFadType & modelPar_VBRBOTD,
   bool modelPar_given_VBRBOTD,
   AdmsSensFadType & modelPar_VBRSTID,
   bool modelPar_given_VBRSTID,
   AdmsSensFadType & modelPar_VBRGATD,
   bool modelPar_given_VBRGATD,
   AdmsSensFadType & modelPar_PBRBOTD,
   bool modelPar_given_PBRBOTD,
   AdmsSensFadType & modelPar_PBRSTID,
   bool modelPar_given_PBRSTID,
   AdmsSensFadType & modelPar_PBRGATD,
   bool modelPar_given_PBRGATD,
   AdmsSensFadType & modelPar_SWJUNEXP,
   bool modelPar_given_SWJUNEXP,
   AdmsSensFadType & modelPar_VJUNREF,
   bool modelPar_given_VJUNREF,
   AdmsSensFadType & modelPar_FJUNQ,
   bool modelPar_given_FJUNQ,
   AdmsSensFadType & modelPar_VJUNREFD,
   bool modelPar_given_VJUNREFD,
   AdmsSensFadType & modelPar_FJUNQD,
   bool modelPar_given_FJUNQD,
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   int modelPar_SWGEO,
   bool modelPar_given_SWGEO,
   int modelPar_SWIGATE,
   bool modelPar_given_SWIGATE,
   int modelPar_SWIMPACT,
   bool modelPar_given_SWIMPACT,
   int modelPar_SWGIDL,
   bool modelPar_given_SWGIDL,
   int modelPar_SWJUNCAP,
   bool modelPar_given_SWJUNCAP,
   int modelPar_SWJUNASYM,
   bool modelPar_given_SWJUNASYM,
   int modelPar_SWNUD,
   bool modelPar_given_SWNUD,
   int modelPar_SWEDGE,
   bool modelPar_given_SWEDGE,
   int modelPar_SWDELVTAC,
   bool modelPar_given_SWDELVTAC,
   int modelPar_SWIGN,
   bool modelPar_given_SWIGN// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_TOXO_i,
   AdmsSensFadType & modelVar_EPSROXO_i,
   AdmsSensFadType & modelVar_NSUBO_i,
   AdmsSensFadType & modelVar_WSEG_i,
   AdmsSensFadType & modelVar_NPCK_i,
   AdmsSensFadType & modelVar_WSEGP_i,
   AdmsSensFadType & modelVar_LPCK_i,
   AdmsSensFadType & modelVar_TOXOVO_i,
   AdmsSensFadType & modelVar_TOXOVDO_i,
   AdmsSensFadType & modelVar_LOV_i,
   AdmsSensFadType & modelVar_LOVD_i,
   AdmsSensFadType & modelVar_LP1_i,
   AdmsSensFadType & modelVar_LP2_i,
   AdmsSensFadType & modelVar_WBET_i,
   AdmsSensFadType & modelVar_AXL_i,
   AdmsSensFadType & modelVar_ALP1L2_i,
   AdmsSensFadType & modelVar_ALP2L2_i,
   AdmsSensFadType & modelVar_SAREF_i,
   AdmsSensFadType & modelVar_SBREF_i,
   AdmsSensFadType & modelVar_KVSAT_i,
   AdmsSensFadType & modelVar_LLODKUO_i,
   AdmsSensFadType & modelVar_WLODKUO_i,
   AdmsSensFadType & modelVar_LLODVTH_i,
   AdmsSensFadType & modelVar_WLODVTH_i,
   AdmsSensFadType & modelVar_LODETAO_i,
   AdmsSensFadType & modelVar_SCREF_i,
   AdmsSensFadType & modelVar_WEB_i,
   AdmsSensFadType & modelVar_WEC_i,
   AdmsSensFadType & modelVar_RSHG_i,
   AdmsSensFadType & modelVar_RSH_i,
   AdmsSensFadType & modelVar_RSHD_i,
   AdmsSensFadType & modelVar_RINT_i,
   AdmsSensFadType & modelVar_RVPOLY_i,
   AdmsSensFadType & modelVar_NSUBEDGEO_i,
   AdmsSensFadType & modelVar_LPEDGE_i,
   AdmsSensFadType & modelVar_QMC_i,
   AdmsSensFadType & modelVar_rTa,
   AdmsSensFadType & modelVar_delTa,
   AdmsSensFadType & modelVar_phita,
   AdmsSensFadType & modelVar_inv_phita,
   AdmsSensFadType & modelVar_TKD,
   AdmsSensFadType & modelVar_delT,
   AdmsSensFadType & modelVar_rTn,
   AdmsSensFadType & modelVar_ln_rTn,
   AdmsSensFadType & modelVar_inv_phit,
   AdmsSensFadType & modelVar_Eg,
   AdmsSensFadType & modelVar_phibFac,
   AdmsSensFadType & modelVar_IMAX_i,
   AdmsSensFadType & modelVar_VBIRBOT_i,
   AdmsSensFadType & modelVar_VBIRSTI_i,
   AdmsSensFadType & modelVar_VBIRGAT_i,
   AdmsSensFadType & modelVar_PBOT_i,
   AdmsSensFadType & modelVar_PSTI_i,
   AdmsSensFadType & modelVar_PGAT_i,
   AdmsSensFadType & modelVar_CSRHBOT_i,
   AdmsSensFadType & modelVar_CSRHSTI_i,
   AdmsSensFadType & modelVar_CSRHGAT_i,
   AdmsSensFadType & modelVar_CTATBOT_i,
   AdmsSensFadType & modelVar_CTATSTI_i,
   AdmsSensFadType & modelVar_CTATGAT_i,
   AdmsSensFadType & modelVar_CBBTBOT_i,
   AdmsSensFadType & modelVar_CBBTSTI_i,
   AdmsSensFadType & modelVar_CBBTGAT_i,
   AdmsSensFadType & modelVar_VBRBOT_i,
   AdmsSensFadType & modelVar_VBRSTI_i,
   AdmsSensFadType & modelVar_VBRGAT_i,
   AdmsSensFadType & modelVar_PBRBOT_i,
   AdmsSensFadType & modelVar_PBRSTI_i,
   AdmsSensFadType & modelVar_PBRGAT_i,
   AdmsSensFadType & modelVar_SWJUNEXP_i,
   AdmsSensFadType & modelVar_VJUNREF_i,
   AdmsSensFadType & modelVar_FJUNQ_i,
   AdmsSensFadType & modelVar_phitr,
   AdmsSensFadType & modelVar_phitd,
   AdmsSensFadType & modelVar_phitdinv,
   AdmsSensFadType & modelVar_perfc,
   AdmsSensFadType & modelVar_berfc,
   AdmsSensFadType & modelVar_cerfc,
   AdmsSensFadType & modelVar_ftdbot,
   AdmsSensFadType & modelVar_ftdsti,
   AdmsSensFadType & modelVar_ftdgat,
   AdmsSensFadType & modelVar_idsatbot,
   AdmsSensFadType & modelVar_idsatsti,
   AdmsSensFadType & modelVar_idsatgat,
   AdmsSensFadType & modelVar_vbibot,
   AdmsSensFadType & modelVar_vbisti,
   AdmsSensFadType & modelVar_vbigat,
   AdmsSensFadType & modelVar_vbiinvbot,
   AdmsSensFadType & modelVar_vbiinvsti,
   AdmsSensFadType & modelVar_vbiinvgat,
   AdmsSensFadType & modelVar_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_minus_PGAT,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT,
   AdmsSensFadType & modelVar_cjobot,
   AdmsSensFadType & modelVar_cjosti,
   AdmsSensFadType & modelVar_cjogat,
   AdmsSensFadType & modelVar_qprefbot,
   AdmsSensFadType & modelVar_qprefsti,
   AdmsSensFadType & modelVar_qprefgat,
   AdmsSensFadType & modelVar_qpref2bot,
   AdmsSensFadType & modelVar_qpref2sti,
   AdmsSensFadType & modelVar_qpref2gat,
   AdmsSensFadType & modelVar_wdepnulrbot,
   AdmsSensFadType & modelVar_wdepnulrsti,
   AdmsSensFadType & modelVar_wdepnulrgat,
   AdmsSensFadType & modelVar_wdepnulrinvbot,
   AdmsSensFadType & modelVar_wdepnulrinvsti,
   AdmsSensFadType & modelVar_wdepnulrinvgat,
   AdmsSensFadType & modelVar_VBIRBOTinv,
   AdmsSensFadType & modelVar_VBIRSTIinv,
   AdmsSensFadType & modelVar_VBIRGATinv,
   AdmsSensFadType & modelVar_atatbot,
   AdmsSensFadType & modelVar_atatsti,
   AdmsSensFadType & modelVar_atatgat,
   AdmsSensFadType & modelVar_btatpartbot,
   AdmsSensFadType & modelVar_btatpartsti,
   AdmsSensFadType & modelVar_btatpartgat,
   AdmsSensFadType & modelVar_fbbtbot,
   AdmsSensFadType & modelVar_fbbtsti,
   AdmsSensFadType & modelVar_fbbtgat,
   AdmsSensFadType & modelVar_alphaav,
   AdmsSensFadType & modelVar_fstopbot,
   AdmsSensFadType & modelVar_fstopsti,
   AdmsSensFadType & modelVar_fstopgat,
   AdmsSensFadType & modelVar_VBRinvbot,
   AdmsSensFadType & modelVar_VBRinvsti,
   AdmsSensFadType & modelVar_VBRinvgat,
   AdmsSensFadType & modelVar_slopebot,
   AdmsSensFadType & modelVar_slopesti,
   AdmsSensFadType & modelVar_slopegat,
   AdmsSensFadType & modelVar_VBIRBOTD_i,
   AdmsSensFadType & modelVar_VBIRSTID_i,
   AdmsSensFadType & modelVar_VBIRGATD_i,
   AdmsSensFadType & modelVar_PBOTD_i,
   AdmsSensFadType & modelVar_PSTID_i,
   AdmsSensFadType & modelVar_PGATD_i,
   AdmsSensFadType & modelVar_CSRHBOTD_i,
   AdmsSensFadType & modelVar_CSRHSTID_i,
   AdmsSensFadType & modelVar_CSRHGATD_i,
   AdmsSensFadType & modelVar_CTATBOTD_i,
   AdmsSensFadType & modelVar_CTATSTID_i,
   AdmsSensFadType & modelVar_CTATGATD_i,
   AdmsSensFadType & modelVar_CBBTBOTD_i,
   AdmsSensFadType & modelVar_CBBTSTID_i,
   AdmsSensFadType & modelVar_CBBTGATD_i,
   AdmsSensFadType & modelVar_VBRBOTD_i,
   AdmsSensFadType & modelVar_VBRSTID_i,
   AdmsSensFadType & modelVar_VBRGATD_i,
   AdmsSensFadType & modelVar_PBRBOTD_i,
   AdmsSensFadType & modelVar_PBRSTID_i,
   AdmsSensFadType & modelVar_PBRGATD_i,
   AdmsSensFadType & modelVar_VJUNREFD_i,
   AdmsSensFadType & modelVar_FJUNQD_i,
   AdmsSensFadType & modelVar_ftdbot_d,
   AdmsSensFadType & modelVar_ftdsti_d,
   AdmsSensFadType & modelVar_ftdgat_d,
   AdmsSensFadType & modelVar_idsatbot_d,
   AdmsSensFadType & modelVar_idsatsti_d,
   AdmsSensFadType & modelVar_idsatgat_d,
   AdmsSensFadType & modelVar_vbibot_d,
   AdmsSensFadType & modelVar_vbisti_d,
   AdmsSensFadType & modelVar_vbigat_d,
   AdmsSensFadType & modelVar_vbiinvbot_d,
   AdmsSensFadType & modelVar_vbiinvsti_d,
   AdmsSensFadType & modelVar_vbiinvgat_d,
   AdmsSensFadType & modelVar_one_minus_PBOT_d,
   AdmsSensFadType & modelVar_one_minus_PSTI_d,
   AdmsSensFadType & modelVar_one_minus_PGAT_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI_d,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT_d,
   AdmsSensFadType & modelVar_cjobot_d,
   AdmsSensFadType & modelVar_cjosti_d,
   AdmsSensFadType & modelVar_cjogat_d,
   AdmsSensFadType & modelVar_qprefbot_d,
   AdmsSensFadType & modelVar_qprefsti_d,
   AdmsSensFadType & modelVar_qprefgat_d,
   AdmsSensFadType & modelVar_qpref2bot_d,
   AdmsSensFadType & modelVar_qpref2sti_d,
   AdmsSensFadType & modelVar_qpref2gat_d,
   AdmsSensFadType & modelVar_wdepnulrbot_d,
   AdmsSensFadType & modelVar_wdepnulrsti_d,
   AdmsSensFadType & modelVar_wdepnulrgat_d,
   AdmsSensFadType & modelVar_wdepnulrinvbot_d,
   AdmsSensFadType & modelVar_wdepnulrinvsti_d,
   AdmsSensFadType & modelVar_wdepnulrinvgat_d,
   AdmsSensFadType & modelVar_VBIRBOTinv_d,
   AdmsSensFadType & modelVar_VBIRSTIinv_d,
   AdmsSensFadType & modelVar_VBIRGATinv_d,
   AdmsSensFadType & modelVar_atatbot_d,
   AdmsSensFadType & modelVar_atatsti_d,
   AdmsSensFadType & modelVar_atatgat_d,
   AdmsSensFadType & modelVar_btatpartbot_d,
   AdmsSensFadType & modelVar_btatpartsti_d,
   AdmsSensFadType & modelVar_btatpartgat_d,
   AdmsSensFadType & modelVar_fbbtbot_d,
   AdmsSensFadType & modelVar_fbbtsti_d,
   AdmsSensFadType & modelVar_fbbtgat_d,
   AdmsSensFadType & modelVar_fstopbot_d,
   AdmsSensFadType & modelVar_fstopsti_d,
   AdmsSensFadType & modelVar_fstopgat_d,
   AdmsSensFadType & modelVar_VBRinvbot_d,
   AdmsSensFadType & modelVar_VBRinvsti_d,
   AdmsSensFadType & modelVar_VBRinvgat_d,
   AdmsSensFadType & modelVar_slopebot_d,
   AdmsSensFadType & modelVar_slopesti_d,
   AdmsSensFadType & modelVar_slopegat_d,
   AdmsSensFadType & modelVar_phit,
   AdmsSensFadType & modelVar_nt0,
   AdmsSensFadType & modelVar_EPSSI,
   // non-reals
   int modelVar_CHNL_TYPE,
   int modelVar_SWGEO_i,
   int modelVar_SWIGATE_i,
   int modelVar_SWIMPACT_i,
   int modelVar_SWGIDL_i,
   int modelVar_SWJUNCAP_i,
   int modelVar_SWJUNASYM_i,
   int modelVar_SWNUD_i,
   int modelVar_SWEDGE_i,
   int modelVar_SWDELVTAC_i,
   int modelVar_SWIGN_i,
   // basic variables
   double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  AdmsSensFadType vth_i;
  AdmsSensFadType vts_i;
  AdmsSensFadType facvsb;
  AdmsSensFadType facvsb0;
  AdmsSensFadType P_D;
  AdmsSensFadType delVsat;
  AdmsSensFadType Q_EDGE_errq;
  AdmsSensFadType Q_EDGE_sqerr;
  AdmsSensFadType Q_EDGE_d0p;
  AdmsSensFadType Q_EDGE_d0;
  AdmsSensFadType Q_EDGE_exp_x;
  AdmsSensFadType Q_EDGE_qi0;
  AdmsSensFadType Q_EDGE_qi0si;
  AdmsSensFadType Q_EDGE_xgt0e;
  AdmsSensFadType Q_EDGE_xgt0;
  AdmsSensFadType Q_EDGE_xgt;
  AdmsSensFadType Q_EDGE_n_inv;
  AdmsSensFadType Q_EDGE_n;
  AdmsSensFadType Q_EDGE_xth;
  AdmsSensFadType Q_EDGE_xth0;
  AdmsSensFadType Q_EDGE_xsth;
  AdmsSensFadType Vtovs;
  AdmsSensFadType Vtovd;
  AdmsSensFadType Igisl;
  AdmsSensFadType Igidl;
  AdmsSensFadType Sg;
  AdmsSensFadType igcd_h;
  AdmsSensFadType igc;
  AdmsSensFadType xsq;
  AdmsSensFadType inv_ex;
  AdmsSensFadType ex;
  AdmsSensFadType inv_x;
  AdmsSensFadType Ag;
  AdmsSensFadType Bg;
  AdmsSensFadType u0_div_H;
  AdmsSensFadType x;
  AdmsSensFadType u0;
  AdmsSensFadType Igc0;
  AdmsSensFadType Dgate;
  AdmsSensFadType Dsi;
  AdmsSensFadType arg1;
  AdmsSensFadType psi_t;
  AdmsSensFadType arg2mina;
  AdmsSensFadType Dch;
  AdmsSensFadType Vm;
  AdmsSensFadType Fs;
  AdmsSensFadType tme2;
  double tme1;
  double Fs3;
  AdmsSensFadType Fs2;
  AdmsSensFadType Fs1;
  AdmsSensFadType TP;
  AdmsSensFadType zg;
  AdmsSensFadType Igb;
  AdmsSensFadType Igc;
  AdmsSensFadType SP_OV_xg;
  AdmsSensFadType Vsbstar_dc;
  AdmsSensFadType Vsbstar_dc_tmp;
  AdmsSensFadType Vmb;
  AdmsSensFadType us;
  AdmsSensFadType usnew;
  AdmsSensFadType Vmbnew;
  AdmsSensFadType Vgbstar;
  AdmsSensFadType Vgb1;
  AdmsSensFadType Vdsp;
  AdmsSensFadType delVg;
  AdmsSensFadType nu;
  AdmsSensFadType mutau;
  AdmsSensFadType Vdsat_lim;
  AdmsSensFadType Vdsat;
  AdmsSensFadType qeff1_dc;
  AdmsSensFadType Voxm_dc;
  AdmsSensFadType GdL_dc;
  AdmsSensFadType eta_p_dc;
  AdmsSensFadType Gvsat_dc;
  AdmsSensFadType Gmob_dL_dc;
  AdmsSensFadType x_ds_dc;
  AdmsSensFadType x_m_dc;
  AdmsSensFadType Gf_dc;
  AdmsSensFadType Vdsat_dc;
  AdmsSensFadType Udse_dc;
  double Vdsx;
  double Vdb;
  AdmsSensFadType xgd_ov;
  AdmsSensFadType xgs_ov;
  double VgdPrime;
  double VdbPrime;
  double VsbPrime;
  double VgsPrime;
  double Vjun_d;
  double Vjun_s;
  double Vsb;
  double Vds;
  double Vgs;
  AdmsSensFadType Vovd;
  AdmsSensFadType Vovs;
  AdmsSensFadType xd_ov;
  AdmsSensFadType xs_ov;
  AdmsSensFadType QCLM;
  AdmsSensFadType Qfgd;
  AdmsSensFadType Qfgs;
  AdmsSensFadType Qgb_ov;
  AdmsSensFadType Qgd_ov;
  AdmsSensFadType Qgs_ov;
  AdmsSensFadType Qb;
  AdmsSensFadType Qd;
  AdmsSensFadType Qg;
  AdmsSensFadType QB;
  AdmsSensFadType QD;
  AdmsSensFadType QI;
  AdmsSensFadType QG;
  AdmsSensFadType Fj2;
  AdmsSensFadType Fj;
  double Vgb;
  AdmsSensFadType Vsbstar_ac;
  AdmsSensFadType xg_ac;
  AdmsSensFadType qeff1_ac;
  AdmsSensFadType Voxm_ac;
  AdmsSensFadType alpha_ac;
  AdmsSensFadType dps_ac;
  AdmsSensFadType qim_ac;
  AdmsSensFadType GdL_ac;
  AdmsSensFadType H_ac;
  AdmsSensFadType rwellnoise;
  AdmsSensFadType rjundnoise;
  AdmsSensFadType rjunsnoise;
  AdmsSensFadType rbulknoise;
  AdmsSensFadType rdrainnoise;
  AdmsSensFadType rsourcenoise;
  AdmsSensFadType rgatenoise;
  AdmsSensFadType h1;
  AdmsSensFadType h2;
  AdmsSensFadType h2d;
  AdmsSensFadType h3;
  AdmsSensFadType h4;
  AdmsSensFadType h5;
  AdmsSensFadType ijunrev;
  AdmsSensFadType ijunfor2;
  AdmsSensFadType ijunfor1;
  AdmsSensFadType tm1;
  AdmsSensFadType tm0;
  AdmsSensFadType fbreakdown;
  AdmsSensFadType ibbt;
  AdmsSensFadType Fmaxr;
  AdmsSensFadType itat;
  AdmsSensFadType gammamax;
  AdmsSensFadType erfctimesexpmtat;
  AdmsSensFadType erfcpos;
  AdmsSensFadType terfc;
  AdmsSensFadType ysq;
  AdmsSensFadType xerfc;
  AdmsSensFadType mtat;
  AdmsSensFadType ltat;
  AdmsSensFadType ktat;
  AdmsSensFadType wtat;
  AdmsSensFadType wgamma;
  AdmsSensFadType umaxpoweronepointfive;
  AdmsSensFadType sqrtumax;
  AdmsSensFadType umax;
  AdmsSensFadType umaxbeforelimiting;
  AdmsSensFadType twoatatoverthreebtat;
  AdmsSensFadType btat;
  AdmsSensFadType isrh;
  AdmsSensFadType asrh;
  AdmsSensFadType wdep;
  AdmsSensFadType wsrh;
  AdmsSensFadType dwsrh;
  AdmsSensFadType wsrhstep;
  AdmsSensFadType vbi_minus_vjsrh;
  AdmsSensFadType id;
  AdmsSensFadType tmp;
  double vav;
  AdmsSensFadType vjsrh;
  AdmsSensFadType vjlim;
  AdmsSensFadType z;
  AdmsSensFadType idmult;
  AdmsSensFadType zinv;
  AdmsSensFadType vj;
  AdmsSensFadType two_psistar;
  AdmsSensFadType vbbt;
  AdmsSensFadType Qs;
  AdmsSensFadType g_idealedge;
  AdmsSensFadType lcinv2edge;
  AdmsSensFadType lcedge;
  AdmsSensFadType redge;
  AdmsSensFadType t2edge;
  AdmsSensFadType sqt2edge;
  AdmsSensFadType t1edge;
  AdmsSensFadType H0edge;
  AdmsSensFadType Delta_N1edge;
  AdmsSensFadType Nm1edge;
  AdmsSensFadType N1edge;
  AdmsSensFadType anoisedge;
  AdmsSensFadType shot_igd;
  AdmsSensFadType shot_igs;
  AdmsSensFadType jnoisex_d;
  AdmsSensFadType jnoisex_s;
  AdmsSensFadType shot_iavl;
  AdmsSensFadType shot_igdov;
  AdmsSensFadType shot_igsov;
  AdmsSensFadType shot_igcdx;
  AdmsSensFadType shot_igcsx;
  AdmsSensFadType gfac;
  AdmsSensFadType Gvsat_exc;
  AdmsSensFadType zsat_exc;
  AdmsSensFadType thesat1_exc;
  AdmsSensFadType temp_exc;
  AdmsSensFadType wsat_exc;
  AdmsSensFadType temp2_exc;
  AdmsSensFadType g_ideal;
  AdmsSensFadType lcinv2;
  AdmsSensFadType lc;
  AdmsSensFadType r;
  AdmsSensFadType t2;
  AdmsSensFadType sqt2;
  AdmsSensFadType t1;
  AdmsSensFadType Delta_N1;
  AdmsSensFadType Nm1;
  AdmsSensFadType N1;
  AdmsSensFadType sqig;
  AdmsSensFadType sqid;
  AdmsSensFadType CGeff;
  AdmsSensFadType c_igid;
  AdmsSensFadType migid;
  AdmsSensFadType mig;
  AdmsSensFadType mid;
  AdmsSensFadType Sidexc;
  AdmsSensFadType Sfl;


  // -- code converted from analog/code block
  //Begin block evaluateblock
  {
    //Block-local variables for block evaluateblock
    double sigVds;
    AdmsSensFadType dphit1;
    AdmsSensFadType phit1;
    AdmsSensFadType inv_phit1;
    AdmsSensFadType xg_dc;
    AdmsSensFadType alpha_dc;
    AdmsSensFadType dps_dc;
    AdmsSensFadType qim_dc;
    AdmsSensFadType qim1_dc;
    AdmsSensFadType H_dc;
    AdmsSensFadType FdL_dc;
    AdmsSensFadType Gvsatinv_dc;
    AdmsSensFadType Ids;
    AdmsSensFadType Iimpact;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    AdmsSensFadType mavl;
    AdmsSensFadType Igdov;
    AdmsSensFadType Igsov;
    AdmsSensFadType Igcd;
    AdmsSensFadType Igcs;
    AdmsSensFadType eta_p_ac;
    AdmsSensFadType Gvsat_ac;
    AdmsSensFadType Gmob_dL_ac;
    AdmsSensFadType H0;
    AdmsSensFadType COX_qm;
    AdmsSensFadType ijun_s;
    AdmsSensFadType ijunbot_s;
    AdmsSensFadType ijunsti_s;
    AdmsSensFadType ijungat_s;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    AdmsSensFadType ijun_d;
    AdmsSensFadType ijunbot_d;
    AdmsSensFadType ijunsti_d;
    AdmsSensFadType ijungat_d;
    AdmsSensFadType qjun_s;
    AdmsSensFadType qjunbot_s;
    AdmsSensFadType qjunsti_s;
    AdmsSensFadType qjungat_s;
    AdmsSensFadType qjun_d;
    AdmsSensFadType qjunbot_d;
    AdmsSensFadType qjunsti_d;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    AdmsSensFadType qjungat_d;
    AdmsSensFadType jnoise_s;
    AdmsSensFadType jnoise_d;
    AdmsSensFadType Gmob_dc;
    AdmsSensFadType xitsb_dc;
    AdmsSensFadType Vdse_dc;
    AdmsSensFadType Vsbstaredge;
    AdmsSensFadType Vsbxedge;
    AdmsSensFadType dphit1edge;
    AdmsSensFadType phit1edge;
    AdmsSensFadType inv_phit1edge;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    AdmsSensFadType Vdspedge;
    AdmsSensFadType delVgedge;
    AdmsSensFadType xgedge;
    AdmsSensFadType xbedge;
    AdmsSensFadType dxthedge;
    AdmsSensFadType xnedge_s;
    AdmsSensFadType qseffedge;
    AdmsSensFadType xnedge_d;
    AdmsSensFadType qdseffedge;
    AdmsSensFadType qdeffedge;
    AdmsSensFadType qmeffedge;
    AdmsSensFadType dsqredge;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    AdmsSensFadType alphabmedge;
    AdmsSensFadType Idsedge;
    AdmsSensFadType Sfledge;
    AdmsSensFadType midedge;
    AdmsSensFadType sqidedge;
    //End of Block-local variables
    //Block-local variables for block evaluateblock
    AdmsSensFadType temp;
    AdmsSensFadType temp1;
    AdmsSensFadType temp2;
    //End of Block-local variables
    //Begin block evaluateStatic
    {
      temp = 0.0;
      temp1 = 0.0;
      temp2 = 0.0;
      QCLM = 0.0;
      xs_ov = 0.0;
      xd_ov = 0.0;
      Vovs = 0.0;
      Vovd = 0.0;
      Iimpact = 0.0;
      mavl = 0.0;
      if ((modelVar_CHNL_TYPE==(+1)))
      {
        Vgs = (probeVars[admsProbeID_V_GP_SI]);
        Vds = (probeVars[admsProbeID_V_DI_SI]);
        Vsb = (probeVars[admsProbeID_V_SI_BP]);
        Vjun_s = (-(probeVars[admsProbeID_V_SI_BS]));
        Vjun_d = (-(probeVars[admsProbeID_V_DI_BD]));
      }
      else
      {
        Vgs = (-(probeVars[admsProbeID_V_GP_SI]));
        Vds = (-(probeVars[admsProbeID_V_DI_SI]));
        Vsb = (-(probeVars[admsProbeID_V_SI_BP]));
        Vjun_s = (probeVars[admsProbeID_V_SI_BS]);
        Vjun_d = (probeVars[admsProbeID_V_DI_BD]);
      }
      VgsPrime = Vgs;
      VsbPrime = Vsb;
      VdbPrime = (Vds+Vsb);
      VgdPrime = (Vgs-Vds);
      xgs_ov = ((-VgsPrime)*modelVar_inv_phita);
      xgd_ov = ((-VgdPrime)*modelVar_inv_phita);
      sigVds = 1.0;
      if ((Vds<0.0))
      {
        sigVds = (-1.0);
        Vgs = (Vgs-Vds);
        Vsb = (Vsb+Vds);
        Vds = (-Vds);
      }
      Vdb = (Vds+Vsb);
      {
        double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
        Vdsx = ((Vds*Vds)/(value_sqrt_0+0.1));
      }
      //Begin block SPcalc_dc
      {
        //Block-local variables for block SPcalc_dc
        AdmsSensFadType phib;
        AdmsSensFadType G_0;
        AdmsSensFadType Vsbstar;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        AdmsSensFadType Vsbx;
        AdmsSensFadType xg;
        AdmsSensFadType Dnsub;
        AdmsSensFadType Gf;
        AdmsSensFadType Gf2;
        AdmsSensFadType inv_Gf2;
        AdmsSensFadType xi;
        AdmsSensFadType inv_xi;
        AdmsSensFadType Ux;
        AdmsSensFadType xn_s;
        AdmsSensFadType delta_ns;
        AdmsSensFadType margin;
        AdmsSensFadType x_s;
        AdmsSensFadType delta_1s;
        AdmsSensFadType xi0s;
        AdmsSensFadType xi1s;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        AdmsSensFadType xi2s;
        AdmsSensFadType Es;
        AdmsSensFadType Ds;
        AdmsSensFadType Ps;
        AdmsSensFadType Rxcor;
        AdmsSensFadType xgs;
        AdmsSensFadType qis;
        AdmsSensFadType qbs;
        AdmsSensFadType rhob;
        AdmsSensFadType GR;
        AdmsSensFadType Eeffm;
        AdmsSensFadType Mutmp;
        AdmsSensFadType Gmob;
        AdmsSensFadType xitsb;
        AdmsSensFadType wsat;
        AdmsSensFadType thesat1;
        AdmsSensFadType phi_inf;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        AdmsSensFadType ysat;
        AdmsSensFadType za;
        AdmsSensFadType Phi_0;
        AdmsSensFadType asat;
        AdmsSensFadType Phi_2;
        AdmsSensFadType Phi_0_2;
        AdmsSensFadType Phi0_Phi2;
        AdmsSensFadType Phi_sat;
        AdmsSensFadType Vdse;
        AdmsSensFadType Udse;
        AdmsSensFadType xn_d;
        AdmsSensFadType k_ds;
        AdmsSensFadType delta_nd;
        AdmsSensFadType x_d;
        AdmsSensFadType x_ds;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        AdmsSensFadType pC;
        AdmsSensFadType qC;
        AdmsSensFadType dps;
        AdmsSensFadType xi0d;
        AdmsSensFadType Ed;
        AdmsSensFadType Dd;
        AdmsSensFadType x_m;
        AdmsSensFadType Em;
        AdmsSensFadType D_bar;
        AdmsSensFadType Dm;
        AdmsSensFadType Pm;
        AdmsSensFadType xgm;
        AdmsSensFadType eta_p;
        AdmsSensFadType sqm;
        AdmsSensFadType alpha;
        AdmsSensFadType d0;
        AdmsSensFadType x_pm;
        AdmsSensFadType p_pd;
        AdmsSensFadType q_pd;
        AdmsSensFadType xi_pd;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        AdmsSensFadType u_pd;
        AdmsSensFadType km;
        AdmsSensFadType km0;
        AdmsSensFadType qim;
        AdmsSensFadType qim1;
        AdmsSensFadType qbm;
        AdmsSensFadType qeff;
        AdmsSensFadType qeff1;
        AdmsSensFadType s1;
        AdmsSensFadType dL;
        AdmsSensFadType GdL;
        AdmsSensFadType Gmob_dL;
        AdmsSensFadType zsat;
        AdmsSensFadType Gvsat;
        AdmsSensFadType Gvsatinv;
        AdmsSensFadType Voxm;
        AdmsSensFadType alpha1;
        AdmsSensFadType H;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        AdmsSensFadType SP_S_temp;
        AdmsSensFadType SP_S_temp1;
        AdmsSensFadType SP_S_temp2;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        AdmsSensFadType SP_S_yg;
        AdmsSensFadType SP_S_ysub;
        AdmsSensFadType SP_S_eta;
        AdmsSensFadType SP_S_a;
        AdmsSensFadType SP_S_c;
        AdmsSensFadType SP_S_tau;
        AdmsSensFadType SP_S_y0;
        AdmsSensFadType SP_S_delta0;
        AdmsSensFadType SP_S_delta1;
        AdmsSensFadType SP_S_xi0;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        AdmsSensFadType SP_S_xi1;
        AdmsSensFadType SP_S_xi2;
        AdmsSensFadType SP_S_pC;
        AdmsSensFadType SP_S_qC;
        AdmsSensFadType SP_xg1;
        AdmsSensFadType SP_S_A_fac;
        AdmsSensFadType SP_S_xbar;
        AdmsSensFadType SP_S_w;
        AdmsSensFadType SP_S_x1;
        AdmsSensFadType SP_S_bx;
        AdmsSensFadType SP_S_b;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        AdmsSensFadType SP_S_x0;
        //End of Block-local variables
        //Block-local variables for block SPcalc_dc
        AdmsSensFadType FdL;
        AdmsSensFadType qim1_1;
        AdmsSensFadType r1;
        AdmsSensFadType r2;
        AdmsSensFadType s2;
        AdmsSensFadType dL1;
        //End of Block-local variables
        {
          AdmsSensFadType value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+instanceVar_bphi_dc));
          temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+instanceVar_phix_dc);
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt((((temp)*(temp))+instanceVar_aphi_dc));
          Vsbstar_dc = ((Vsb-(0.5*((temp)-value_sqrt_0)))+instanceVar_phix1_dc);
        }
        Vsbstar_dc_tmp = Vsbstar_dc;
        if (((modelVar_SWNUD_i!=0)&&(instanceVar_GFACNUD_i!=1.0)))
        {
          Vmb = (Vsbstar_dc+(0.5*(Vds-Vdsx)));
          {
            AdmsSensFadType value_sqrt_0 = sqrt((Vmb+instanceVar_phib_dc));
            us = (value_sqrt_0-instanceVar_sqrt_phib_dc);
          }
          temp = (((2.0*(us-instanceVar_us1))/instanceVar_us21)-1.0);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((temp*temp)+0.4804530139182));
            usnew = (us-(((0.25*(1.0-instanceVar_GFACNUD_i))*instanceVar_us21)*(temp+value_sqrt_0)));
          }
          Vmbnew = ((usnew*usnew)+((2.0*instanceVar_sqrt_phib_dc)*usnew));
          Vsbstar_dc = (Vmbnew-(0.5*(Vds-Vdsx)));
        }
        phib = instanceVar_phib_dc;
        G_0 = instanceVar_G_0_dc;
        Vsbstar = Vsbstar_dc;
        FdL = 1.0;
        alpha = 0.0;
        GdL = 1.0;
        dL = 0.0;
        qbm = 0.0;
        dps = 0.0;
        qim = 0.0;
        qim1 = 0.0;
        H = 1.0;
        s1 = 0.0;
        eta_p = 1.0;
        Gvsat = 1.0;
        Gvsatinv = 1.0;
        SP_S_x1 = 0.0;
        x_s = 0.0;
        sqm = 0.0;
        xitsb = 0.0;
        rhob = 0.0;
        Gmob = 1.0;
        Gmob_dL = 1.0;
        Udse = 0.0;
        thesat1 = 0.0;
        xgm = 0.0;
        Vgbstar = (Vgs+Vsbstar);
        Vgb1 = (Vgbstar-instanceVar_VFB_T);
        Vsbx = (Vsbstar+(0.5*(Vds-Vdsx)));
        if ((instanceVar_CFD_i<1.0e-10))
        {
          Vdsp = Vdsx;
        }
        else
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt((1.0+(instanceVar_CFD_i*Vdsx)));
            Vdsp = ((2.0*(value_sqrt_0-1.0))/instanceVar_CFD_i);
          }
        }
        delVg = ((instanceVar_CF_i*Vdsp)*(1.0+(instanceVar_CFB_i*Vsbx)));
        dphit1 = ((instanceVar_PSCE_i*(1.0+(instanceVar_PSCED_i*Vdsx)))*(1.0+(instanceVar_PSCEB_i*Vsbx)));
        phit1 = (instanceVar_phit0*(1.0+dphit1));
        inv_phit1 = (1.0/phit1);
        Vgb1 = (Vgb1+delVg);
        xg = (Vgb1*inv_phit1);
        if ((instanceVar_DNSUB_i>0.0))
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((-((Vgs+Vsb)-instanceVar_VNSUB_i))*(-((Vgs+Vsb)-instanceVar_VNSUB_i)))+instanceVar_NSLP_i));
            Dnsub = ((instanceVar_DNSUB_i*0.5)*((+((Vgs+Vsb)-instanceVar_VNSUB_i))+value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((1.0+Dnsub));
            Gf = (G_0*value_sqrt_0);
          }
        }
        else
        {
          Gf = G_0;
        }
        Gf2 = (Gf*Gf);
        inv_Gf2 = (1.0/Gf2);
        xi = (1.0+(Gf*7.0710678118654746e-01));
        inv_xi = (1.0/xi);
        Ux = (Vsbstar*inv_phit1);
        xn_s = ((phib*inv_phit1)+Ux);
        if ((xn_s<4.6051701859880916e+02))
        {
          {
            AdmsSensFadType value_exp_0 = exp((-xn_s));
            delta_ns = value_exp_0;
          }
        }
        else
        {
          delta_ns = (1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
        }
        margin = (1.0e-5*xi);
        if ((fabs(xg)<=margin))
        {
          SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
          x_s = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
        }
        else
        {
          if ((xg<(-margin)))
          {
            SP_S_yg = (-xg);
            SP_S_ysub = (1.25*(SP_S_yg*inv_xi));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0));
              SP_S_eta = (0.5*((SP_S_ysub+10)-value_sqrt_0));
            }
            SP_S_temp = (SP_S_yg-SP_S_eta);
            SP_S_a = ((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0)));
            SP_S_c = ((2.0*SP_S_temp)-Gf2);
            {
              AdmsSensFadType value_log_0 = log((SP_S_a*inv_Gf2));
              SP_S_tau = ((-SP_S_eta)+value_log_0);
            }
            nu = (SP_S_a+SP_S_c);
            mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
            SP_S_y0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
            if ((SP_S_y0<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(SP_S_y0);
                SP_S_delta0 = value_exp_0;
              }
            }
            else
            {
              SP_S_delta0 = (1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
            SP_S_delta1 = (1.0/SP_S_delta0);
            SP_S_temp = (1.0/(2.0+(SP_S_y0*SP_S_y0)));
            SP_S_xi0 = ((SP_S_y0*SP_S_y0)*SP_S_temp);
            SP_S_xi1 = (4.0*((SP_S_y0*SP_S_temp)*SP_S_temp));
            SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
            SP_S_temp = (SP_S_yg-SP_S_y0);
            SP_S_temp1 = (delta_ns*SP_S_delta1);
            SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
            SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
            SP_S_temp = (2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
            SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
            {
              AdmsSensFadType value_sqrt_0 = sqrt(SP_S_temp);
              x_s = ((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
            }
          }
          else
          {
            SP_xg1 = (1.0/(1.25+(Gf*7.324648775608221e-001)));
            SP_S_A_fac = ((((xi*1.25)*SP_xg1)-1.0)*SP_xg1);
            SP_S_xbar = ((xg*inv_xi)*(1.0+(SP_S_A_fac*xg)));
            if (((-SP_S_xbar)>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp((-SP_S_xbar));
                SP_S_temp = value_exp_0;
              }
            }
            else
            {
              SP_S_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
            }
            SP_S_w = (1.0-SP_S_temp);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((xg+(Gf2*0.25))-SP_S_w));
              SP_S_x1 = ((xg+(Gf2*0.5))-(Gf*value_sqrt_0));
            }
            SP_S_bx = (xn_s+3.0);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
              AdmsSensFadType value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
              SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
            }
            SP_S_temp = (xg-SP_S_eta);
            {
              AdmsSensFadType value_exp_0 = exp((-SP_S_eta));
              SP_S_temp1 = value_exp_0;
            }
            SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));
            SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);
            SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
            SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
            {
              AdmsSensFadType value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))));
              SP_S_a = value_max_0;
            }
            SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))));
            SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
            {
              AdmsSensFadType value_log_0 = log((SP_S_a/Gf2));
              SP_S_tau = ((xn_s-SP_S_eta)+value_log_0);
            }
            nu = (SP_S_a+SP_S_c);
            mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
            SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
            if ((SP_S_x0<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(SP_S_x0);
                SP_S_delta0 = value_exp_0;
              }
              SP_S_delta1 = (1.0/SP_S_delta0);
              SP_S_delta0 = (delta_ns*SP_S_delta0);
            }
            else
            {
              if ((SP_S_x0>(xn_s-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp((SP_S_x0-xn_s));
                  SP_S_delta0 = value_exp_0;
                }
                SP_S_delta1 = (delta_ns/SP_S_delta0);
              }
              else
              {
                SP_S_delta0 = (1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));
            SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);
            SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
            SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
            SP_S_temp = (xg-SP_S_x0);
            SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
            SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
            SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
            SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
            {
              AdmsSensFadType value_sqrt_0 = sqrt(SP_S_temp);
              x_s = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
            }
          }
        }
        x_d = x_s;
        x_m = x_s;
        x_ds = 0.0;
        Vdsat_lim = (3.912023005*phit1);
        if ((xg<=0.0))
        {
          qis = 0.0;
          xgm = (xg-x_s);
          Voxm = (xgm*phit1);
          qeff1 = Voxm;
          Vdsat = Vdsat_lim;
          Vdse = Vds;
        }
        else
        {
          delta_1s = 0.0;
          temp = (1.0/(2.0+(x_s*x_s)));
          xi0s = ((x_s*x_s)*temp);
          xi1s = (4.0*((x_s*temp)*temp));
          xi2s = ((((8.0*temp)-(12.0*xi0s))*temp)*temp);
          if ((x_s<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp(x_s);
              delta_1s = value_exp_0;
            }
            Es = (1.0/delta_1s);
            delta_1s = (delta_ns*delta_1s);
          }
          else
          {
            if ((x_s>(xn_s-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp((x_s-xn_s));
                delta_1s = value_exp_0;
              }
              Es = (delta_ns/delta_1s);
            }
            else
            {
              delta_1s = (1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              Es = (1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          Ds = (delta_1s-(delta_ns*((x_s+1.0)+xi0s)));
          if ((x_s<1.0e-5))
          {
            Ps = (0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))));
            Ds = (1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s))));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
              temp = value_sqrt_0;
            }
            sqm = (7.0710678118654746e-01*(x_s*temp));
            alpha = (1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp));
          }
          else
          {
            Ps = ((x_s-1.0)+Es);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(Ps);
              sqm = value_sqrt_0;
            }
            alpha = (1.0+(0.5*((Gf*(1.0-Es))/sqm)));
          }
          Em = Es;
          Ed = Em;
          Dm = Ds;
          Dd = Dm;
          Rxcor = ((1.0+((0.2*instanceVar_XCOR_T)*Vsbx))/(1.0+(instanceVar_XCOR_T*Vsbx)));
          if ((Ds>1.0e-100))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((Ps+Ds));
              xgs = (Gf*value_sqrt_0);
            }
            qis = (((Gf2*Ds)*phit1)/(xgs+(Gf*sqm)));
            qbs = ((sqm*Gf)*phit1);
            if ((instanceVar_RSB_i<0.0))
            {
              rhob = (1.0/(1.0-(instanceVar_RSB_i*Vsbx)));
            }
            else
            {
              rhob = (1.0+(instanceVar_RSB_i*Vsbx));
            }
            if ((instanceVar_RSG_i<0.0))
            {
              temp = (1.0-(instanceVar_RSG_i*qis));
            }
            else
            {
              temp = (1.0/(1.0+(instanceVar_RSG_i*qis)));
            }
            GR = (instanceVar_THER_i*((rhob*temp)*qis));
            Eeffm = (instanceVar_E_eff0*(qbs+(instanceVar_eta_mu*qis)));
            {
              AdmsSensFadType value_pow_0 = pow((Eeffm*instanceVar_MUE_T),instanceVar_THEMU_T);
              Mutmp = (value_pow_0+(instanceVar_CS_T*(Ps/((Ps+Ds)+1.0e-14))));
            }
            Gmob = (((1.0+Mutmp)+GR)*Rxcor);
            if ((instanceVar_THESATB_i<0.0))
            {
              xitsb = (1.0/(1.0-(instanceVar_THESATB_i*Vsbx)));
            }
            else
            {
              xitsb = (1.0+(instanceVar_THESATB_i*Vsbx));
            }
            temp2 = (qis*xitsb);
            wsat = (100.0*(temp2/(100.0+temp2)));
            if ((instanceVar_THESATG_i<0.0))
            {
              temp = (1.0/(1.0-(instanceVar_THESATG_i*wsat)));
            }
            else
            {
              temp = (1.0+(instanceVar_THESATG_i*wsat));
            }
            thesat1 = (instanceVar_THESAT_T*(temp/Gmob));
            phi_inf = ((qis/alpha)+phit1);
            ysat = ((thesat1*phi_inf)*7.0710678118654746e-01);
            if ((modelVar_CHNL_TYPE==(-1)))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0+ysat));
                ysat = (ysat/value_sqrt_0);
              }
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0+(4.0*ysat)));
              za = (2.0/(1.0+value_sqrt_0));
            }
            temp1 = (za*ysat);
            Phi_0 = ((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
            asat = (xgs+(0.5*Gf2));
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((asat*asat)-((Gf2*Ds)*0.98)));
              Phi_2 = (0.98*(((Gf2*Ds)*phit1)/(asat+value_sqrt_0)));
            }
            Phi_0_2 = (Phi_0+Phi_2);
            Phi0_Phi2 = (2.0*(Phi_0*Phi_2));
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)));
              Phi_sat = (Phi0_Phi2/(Phi_0_2+value_sqrt_0));
            }
            {
              AdmsSensFadType value_log_0 = log((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));
              Vdsat = (Phi_sat-(phit1*value_log_0));
            }
          }
          else
          {
            Vdsat = Vdsat_lim;
          }
          {
            AdmsSensFadType value_pow_0 = pow((Vds/Vdsat),instanceVar_AX_i);
            temp = value_pow_0;
          }
          {
            AdmsSensFadType value_pow_0 = pow((1.0+temp),(-instanceVar_inv_AX));
            Vdse = (Vds*value_pow_0);
          }
          Udse = (Vdse*inv_phit1);
          xn_d = (xn_s+Udse);
          if ((Udse<4.6051701859880916e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp((-Udse));
              k_ds = value_exp_0;
            }
          }
          else
          {
            k_ds = (1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
          }
          delta_nd = (delta_ns*k_ds);
          if ((fabs(xg)<=margin))
          {
            SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
            x_d = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
          }
          else
          {
            SP_S_bx = (xn_d+3);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
              AdmsSensFadType value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
              SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
            }
            SP_S_temp = (xg-SP_S_eta);
            {
              AdmsSensFadType value_exp_0 = exp((-SP_S_eta));
              SP_S_temp1 = value_exp_0;
            }
            SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));
            SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);
            SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
            SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
            {
              AdmsSensFadType value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))));
              SP_S_a = value_max_0;
            }
            SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))));
            SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
            {
              AdmsSensFadType value_log_0 = log((SP_S_a/Gf2));
              SP_S_tau = ((xn_d-SP_S_eta)+value_log_0);
            }
            nu = (SP_S_a+SP_S_c);
            mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
            SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
            if ((SP_S_x0<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(SP_S_x0);
                SP_S_delta0 = value_exp_0;
              }
              SP_S_delta1 = (1.0/SP_S_delta0);
              SP_S_delta0 = (delta_nd*SP_S_delta0);
            }
            else
            {
              if ((SP_S_x0>(xn_d-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp((SP_S_x0-xn_d));
                  SP_S_delta0 = value_exp_0;
                }
                SP_S_delta1 = (delta_nd/SP_S_delta0);
              }
              else
              {
                SP_S_delta0 = (1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));
            SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);
            SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
            SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
            SP_S_temp = (xg-SP_S_x0);
            SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
            SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
            SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
            SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
            {
              AdmsSensFadType value_sqrt_0 = sqrt(SP_S_temp);
              x_d = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
            }
          }
          x_ds = (x_d-x_s);
          if ((x_ds<1.0e-10))
          {
            pC = ((2.0*(xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
            qC = ((Gf2*(1.0-k_ds))*Ds);
            temp = (2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
            temp = ((pC*pC)-(2.0*(temp*qC)));
            {
              AdmsSensFadType value_sqrt_0 = sqrt(temp);
              x_ds = (2.0*(qC/(pC+value_sqrt_0)));
            }
            x_d = (x_s+x_ds);
          }
          dps = (x_ds*phit1);
          xi0d = ((x_d*x_d)/(2.0+(x_d*x_d)));
          if ((x_d<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp((-x_d));
              Ed = value_exp_0;
            }
            if ((x_d<1.0e-5))
            {
              Dd = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
            }
            else
            {
              Dd = (delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d));
            }
          }
          else
          {
            if ((x_d>(xn_d-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp((x_d-xn_d));
                temp = value_exp_0;
              }
              Ed = (delta_nd/temp);
              Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
            }
            else
            {
              Ed = (1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              temp = (1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
            }
          }
          x_m = (0.5*(x_s+x_d));
          Em = 0.0;
          temp = (Ed*Es);
          if ((temp>0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(temp);
              Em = value_sqrt_0;
            }
          }
          D_bar = (0.5*(Ds+Dd));
          Dm = (D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))));
          if ((x_m<1.0e-5))
          {
            Pm = (0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))));
            {
              AdmsSensFadType value_sqrt_0 = sqrt((Dm+Pm));
              xgm = (Gf*value_sqrt_0);
            }
            if ((instanceVar_kp>0.0))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0+(instanceVar_kp*xgm)));
                eta_p = (1.0/value_sqrt_0);
              }
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
              temp = value_sqrt_0;
            }
            sqm = (7.0710678118654746e-01*(x_m*temp));
            alpha = (eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)));
          }
          else
          {
            Pm = ((x_m-1.0)+Em);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((Dm+Pm));
              xgm = (Gf*value_sqrt_0);
            }
            if ((instanceVar_kp>0.0))
            {
              d0 = ((1.0-Em)+(2.0*(xgm*inv_Gf2)));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0+(instanceVar_kp*xgm)));
                eta_p = (1.0/value_sqrt_0);
              }
              temp = (eta_p/(eta_p+1.0));
              x_pm = (instanceVar_kp*(((temp*temp)*Gf2)*Dm));
              p_pd = ((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm)));
              q_pd = (x_pm*(x_pm-(2.0*xgm)));
              xi_pd = (1.0-(0.5*(Gf2*(Em+Dm))));
              u_pd = ((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd)));
              x_m = (x_m+u_pd);
              {
                AdmsSensFadType value_exp_0 = exp(u_pd);
                km = value_exp_0;
              }
              Em = (Em/km);
              Dm = (Dm*km);
              Pm = ((x_m-1.0)+Em);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((Dm+Pm));
                xgm = (Gf*value_sqrt_0);
              }
              km0 = ((1.0-Em)+(2.0*((xgm*eta_p)*inv_Gf2)));
              x_ds = (((x_ds*km)*(d0+D_bar))/(km0+(km*D_bar)));
              dps = (x_ds*phit1);
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt(Pm);
              sqm = value_sqrt_0;
            }
            alpha = (eta_p+(0.5*((Gf*(1.0-Em))/sqm)));
          }
          qim = (phit1*((Gf2*Dm)/(xgm+(Gf*sqm))));
          qim1 = (qim+(phit1*alpha));
          qbm = ((sqm*Gf)*phit1);
          if ((instanceVar_RSG_i<0.0))
          {
            temp = (1.0-(instanceVar_RSG_i*qim));
          }
          else
          {
            temp = (1.0/(1.0+(instanceVar_RSG_i*qim)));
          }
          GR = (instanceVar_THER_i*((rhob*temp)*qim));
          qeff = (qbm+(instanceVar_eta_mu*qim));
          qeff1 = (qbm+(instanceVar_eta_mu1*qim));
          Eeffm = (instanceVar_E_eff0*qeff);
          {
            AdmsSensFadType value_pow_0 = pow((Eeffm*instanceVar_MUE_T),instanceVar_THEMU_T);
            Mutmp = (value_pow_0+(instanceVar_CS_T*(Pm/((Pm+Dm)+1.0e-14))));
          }
          Gmob = (((1.0+Mutmp)+GR)*Rxcor);
          {
            AdmsSensFadType value_log_0 = log(((1.0+((Vds-dps)*instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceVar_inv_VP))));
            s1 = value_log_0;
          }
          dL = (instanceVar_ALP_i*s1);
          GdL = (1.0/((1.0+dL)+(dL*dL)));
          temp2 = (qim*xitsb);
          wsat = (100.0*(temp2/(100.0+temp2)));
          Gmob_dL = (Gmob*GdL);
          if ((instanceVar_THESATG_i<0.0))
          {
            temp = (1.0/(1.0-(instanceVar_THESATG_i*wsat)));
          }
          else
          {
            temp = (1.0+(instanceVar_THESATG_i*wsat));
          }
          thesat1 = (instanceVar_THESAT_T*(temp/Gmob_dL));
          zsat = (((thesat1*thesat1)*dps)*dps);
          if ((modelVar_CHNL_TYPE==(-1)))
          {
            zsat = (zsat/(1.0+(thesat1*dps)));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((1.0+(2.0*zsat)));
            Gvsat = (0.5*(Gmob_dL*(1.0+value_sqrt_0)));
          }
          Gvsatinv = (1.0/Gvsat);
          Voxm = (xgm*phit1);
          temp = (Gmob_dL*Gvsatinv);
          alpha1 = (alpha*(1.0+(0.5*((zsat*temp)*temp))));
          H = ((temp*qim1)/alpha1);
        }
        if ((xg>0.0))
        {
          qim1_1 = (1.0/qim1);
          r1 = (qim*qim1_1);
          r2 = (phit1*(alpha*qim1_1));
          {
            AdmsSensFadType value_log_0 = log((1.0+(Vdsx*instanceVar_inv_VP)));
            s2 = value_log_0;
          }
          dL1 = ((dL+(instanceVar_ALP1_i*((qim1_1*r1)*s1)))+(instanceVar_ALP2_i*(((qbm*r2)*r2)*s2)));
          FdL = (((1.0+dL1)+(dL1*dL1))*GdL);
        }
        xg_dc = xg;
        qeff1_dc = qeff1;
        Voxm_dc = Voxm;
        alpha_dc = alpha;
        dps_dc = dps;
        qim_dc = qim;
        qim1_dc = qim1;
        GdL_dc = GdL;
        FdL_dc = FdL;
        H_dc = H;
        eta_p_dc = eta_p;
        Gvsat_dc = Gvsat;
        Gvsatinv_dc = Gvsatinv;
        Gmob_dL_dc = Gmob_dL;
        x_ds_dc = x_ds;
        x_m_dc = x_m;
        Gf_dc = Gf;
        Vdsat_dc = Vdsat;
        Udse_dc = Udse;
        Gmob_dc = Gmob;
        xitsb_dc = xitsb;
        Vdse_dc = Vdse;
      }
      // End block SPcalc_dc
      if ((xg_dc<=0))
      {
        Ids = 0.0;
      }
      else
      {
        Ids = (instanceVar_BET_i*(((FdL_dc*qim1_dc)*dps_dc)*Gvsatinv_dc));
      }
      if ((((((modelVar_SWIGATE_i!=0)&&((instanceVar_IGOV_i>0.0)||(instanceVar_IGOVD_i>0.0)))||((modelVar_SWGIDL_i!=0)&&((instanceVar_AGIDL_i>0.0)||(instanceVar_AGIDLD_i>0.0))))||(instanceVar_CGOV_i>0.0))||(instanceVar_CGOVD_i>0.0)))
      {
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((xgs_ov*xgs_ov)+instanceVar_SP_OV_eps2_s));
          SP_OV_xg = (0.5*(xgs_ov+value_sqrt_0));
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((SP_OV_xg+(instanceVar_GOV2_s*0.25))+instanceVar_SP_OV_a_s));
          xs_ov = ((((-SP_OV_xg)-(instanceVar_GOV2_s*0.5))+(instanceVar_GOV_s*value_sqrt_0))+instanceVar_SP_OV_delta1_s);
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((xgd_ov*xgd_ov)+instanceVar_SP_OV_eps2_d));
          SP_OV_xg = (0.5*(xgd_ov+value_sqrt_0));
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((SP_OV_xg+(instanceVar_GOV2_d*0.25))+instanceVar_SP_OV_a_d));
          xd_ov = ((((-SP_OV_xg)-(instanceVar_GOV2_d*0.5))+(instanceVar_GOV_d*value_sqrt_0))+instanceVar_SP_OV_delta1_d);
        }
        Vovs = ((-modelVar_phita)*(xgs_ov+xs_ov));
        Vovd = ((-modelVar_phita)*(xgd_ov+xd_ov));
      }
      Igsov = 0.0;
      Igdov = 0.0;
      Igc = 0.0;
      Igb = 0.0;
      Igcs = 0.0;
      Igcd = 0.0;
      if ((modelVar_SWIGATE_i!=0))
      {
        if ((instanceVar_IGOV_i>0.0))
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((Vovs*Vovs)+1.0e-6));
            zg = (value_sqrt_0*instanceVar_inv_CHIB);
          }
          if ((instanceVar_GC3_i<0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((zg-instanceVar_GCQ)*(zg-instanceVar_GCQ))+1.0e-6));
              zg = (0.5*((zg+instanceVar_GCQ)-value_sqrt_0));
            }
          }
          temp = (instanceVar_BOV*((-1.5)+(zg*(instanceVar_GC2_i+(instanceVar_GC3_i*zg)))));
          if ((temp>0.0))
          {
            TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
          }
          else
          {
            if ((temp>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(temp);
                TP = value_exp_0;
              }
            }
            else
            {
              TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            }
          }
          Fs1 = (3.0+xs_ov);
          Fs2 = ((-3.0)-instanceVar_GCO_i);
          Fs3 = (30.0*VgsPrime);
          tme1 = (4.0-0.9);
          tme2 = (Fs1+Fs3);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs1)*Fs3)));
            temp = ((2.0/tme1)*(tme2-value_sqrt_0));
          }
          tme1 = (4.0-0.3);
          tme2 = (Fs2+temp);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs2)*temp)));
            Fs = ((2.0/tme1)*(tme2+value_sqrt_0));
          }
          Igsov = (instanceVar_IGOV_i*(TP*Fs));
        }
        if ((instanceVar_IGOVD_i>0.0))
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((Vovd*Vovd)+1.0e-6));
            zg = (value_sqrt_0*instanceVar_inv_CHIB);
          }
          if ((instanceVar_GC3_i<0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((zg-instanceVar_GCQ)*(zg-instanceVar_GCQ))+1.0e-6));
              zg = (0.5*((zg+instanceVar_GCQ)-value_sqrt_0));
            }
          }
          temp = (instanceVar_BOV_d*((-1.5)+(zg*(instanceVar_GC2_i+(instanceVar_GC3_i*zg)))));
          if ((temp>0.0))
          {
            TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
          }
          else
          {
            if ((temp>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(temp);
                TP = value_exp_0;
              }
            }
            else
            {
              TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            }
          }
          Fs1 = (3.0+xd_ov);
          Fs2 = ((-3.0)-instanceVar_GCO_i);
          Fs3 = (30.0*VgdPrime);
          tme1 = (4.0-0.9);
          tme2 = (Fs1+Fs3);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs1)*Fs3)));
            temp = ((2.0/tme1)*(tme2-value_sqrt_0));
          }
          tme1 = (4.0-0.3);
          tme2 = (Fs2+temp);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs2)*temp)));
            Fs = ((2.0/tme1)*(tme2+value_sqrt_0));
          }
          Igdov = (instanceVar_IGOVD_i*(TP*Fs));
        }
        if ((instanceVar_IGINV_i>0.0))
        {
          if ((xg_dc<=0.0))
          {
            {
              AdmsSensFadType value_pow_0 = pow((Vds/Vdsat_lim),instanceVar_AX_i);
              temp = value_pow_0;
            }
            {
              AdmsSensFadType value_pow_0 = pow((1.0+temp),(-instanceVar_inv_AX));
              Udse_dc = ((Vds*value_pow_0)*inv_phit1);
            }
          }
          if (((x_ds_dc-Udse_dc)>(-2.3025850929940458e+02)))
          {
            {
              AdmsSensFadType value_exp_0 = exp((x_ds_dc-Udse_dc));
              temp = value_exp_0;
            }
          }
          else
          {
            temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))));
          }
          {
            AdmsSensFadType value_log_0 = log((0.5*(1.0+temp)));
            Vm = (Vsbstar_dc+(phit1*((0.5*x_ds_dc)-value_log_0)));
          }
          Dch = (instanceVar_GCO_i*phit1);
          arg2mina = (Voxm_dc+Dch);
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
            psi_t = (0.5*((+arg2mina)-value_sqrt_0));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((Voxm_dc*Voxm_dc)+1.0e-6));
            zg = (value_sqrt_0*instanceVar_inv_CHIB);
          }
          if ((instanceVar_GC3_i<0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((zg-instanceVar_GCQ)*(zg-instanceVar_GCQ))+1.0e-06));
              zg = (0.5*((zg+instanceVar_GCQ)-value_sqrt_0));
            }
          }
          arg1 = (x_m_dc+(((psi_t-instanceVar_alpha_b)-Vm)*inv_phit1));
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp(arg1);
              Dsi = value_exp_0;
            }
          }
          else
          {
            if ((arg1<0.0))
            {
              Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {
              Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          arg1 = ((-((Vgs+Vsbstar_dc)-Vm))*inv_phit1);
          if ((fabs(arg1)<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp(arg1);
              temp = value_exp_0;
            }
          }
          else
          {
            if ((arg1<0.0))
            {
              temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
            }
            else
            {
              temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          Dgate = (Dsi*temp);
          temp = (instanceVar_BCH*((-1.5)+(zg*(instanceVar_GC2_i+(instanceVar_GC3_i*zg)))));
          if ((temp>0))
          {
            TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
          }
          else
          {
            if ((temp>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp(temp);
                TP = value_exp_0;
              }
            }
            else
            {
              TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
            }
          }
          {
            AdmsSensFadType value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
            Igc0 = (instanceVar_IGINV_i*(TP*value_log_0));
          }
          if (((xg_dc<=0.0)||((instanceVar_GC2_i==0.0)&&(instanceVar_GC3_i==0.0))))
          {
            igc = 1.0;
            igcd_h = 0.5;
          }
          else
          {
            temp = (instanceVar_GC2_i+((2.0*instanceVar_GC3_i)*zg));
            u0 = (instanceVar_CHIB_i/(temp*instanceVar_BCH));
            x = (0.5*(dps_dc/u0));
            u0_div_H = (u0/H_dc);
            Bg = ((u0_div_H*(1.0-u0_div_H))*0.5);
            Ag = (0.5-(3.0*Bg));
            if ((x<1.0e-3))
            {
              xsq = (x*x);
              igc = (1.0+(xsq*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));
              igcd_h = ((0.5*igc)-(1.6666666666666667e-01*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))));
            }
            else
            {
              inv_x = (1.0/x);
              if ((fabs(x)<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(x);
                  ex = value_exp_0;
                }
              }
              else
              {
                if ((x<0.0))
                {
                  ex = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
                }
                else
                {
                  ex = (1.0e100*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              inv_ex = (1.0/ex);
              temp = (ex-inv_ex);
              temp2 = (ex+inv_ex);
              igc = (0.5*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2)));
              igcd_h = (0.5*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x)));
            }
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((xg_dc*xg_dc)+1.0e-6));
            Sg = (0.5*(1.0+(xg_dc/value_sqrt_0)));
          }
          Igc = ((Igc0*igc)*Sg);
          Igcd = ((Igc0*igcd_h)*Sg);
          Igcs = (Igc-Igcd);
          Igb = ((Igc0*igc)*(1.0-Sg));
        }
      }
      Igidl = 0.0;
      Igisl = 0.0;
      if ((modelVar_SWGIDL_i!=0))
      {
        if (((instanceVar_AGIDLD_i>0)&&(Vovd<0)))
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((Vovd*Vovd)+((instanceVar_CGIDLD_i*instanceVar_CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6));
            Vtovd = value_sqrt_0;
          }
          temp = ((-instanceVar_BGIDLDs)/Vtovd);
          if ((temp>(-2.3025850929940458e+02)))
          {
            {
              AdmsSensFadType value_exp_0 = exp(temp);
              temp2 = value_exp_0;
            }
          }
          else
          {
            temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
          }
          Igidl = ((-instanceVar_AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*temp2));
        }
        if (((instanceVar_AGIDL_i>0)&&(Vovs<0)))
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt((((Vovs*Vovs)+((instanceVar_CGIDL_i*instanceVar_CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6));
            Vtovs = value_sqrt_0;
          }
          temp = ((-instanceVar_BGIDLs)/Vtovs);
          if ((temp>(-2.3025850929940458e+02)))
          {
            {
              AdmsSensFadType value_exp_0 = exp(temp);
              temp2 = value_exp_0;
            }
          }
          else
          {
            temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
          }
          Igisl = ((-instanceVar_AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*temp2));
        }
      }
      xgedge = 0.0;
      qdseffedge = 0.0;
      qmeffedge = 0.0;
      dsqredge = 1.0e-40;
      alphabmedge = 1.0;
      Idsedge = 0.0;
      if (((modelVar_SWEDGE_i!=0.0)&&(instanceVar_BETNEDGE_i>0)))
      {
        {
          AdmsSensFadType value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+instanceVar_bphiedge));
          temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+instanceVar_phixedge);
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt((((temp)*(temp))+instanceVar_aphiedge));
          Vsbstaredge = ((Vsb-(0.5*((temp)-value_sqrt_0)))+instanceVar_phix1edge);
        }
        Vsbxedge = (Vsbstaredge+(0.5*(Vds-Vdsx)));
        dphit1edge = ((instanceVar_PSCEEDGE_i*(1+(instanceVar_PSCEDEDGE_i*Vdsx)))*(1.0+(instanceVar_PSCEBEDGE_i*Vsbxedge)));
        phit1edge = (instanceVar_phit0edge*(1.0+dphit1edge));
        inv_phit1edge = (1.0/phit1edge);
        if ((instanceVar_CFDEDGE_i<0.05))
        {
          Vdspedge = Vdsx;
        }
        else
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt((1.0+(instanceVar_CFDEDGE_i*Vdsx)));
            Vdspedge = ((2.0*(value_sqrt_0-1.0))/instanceVar_CFDEDGE_i);
          }
        }
        delVgedge = ((instanceVar_CFEDGE_i*Vdspedge)*(1+(instanceVar_CFBEDGE_i*Vsbxedge)));
        xgedge = (inv_phit1edge*(((Vgs+Vsbstaredge)+delVgedge)-instanceVar_VFBEDGE_T));
        xbedge = (inv_phit1edge*instanceVar_phibedge);
        {
          AdmsSensFadType value_sqrt_0 = sqrt(xbedge);
          AdmsSensFadType value_log_1 = log(((xbedge/instanceVar_Gfedge)+value_sqrt_0));
          dxthedge = (2.0*value_log_1);
        }
        xnedge_s = (inv_phit1edge*Vsbstaredge);
        Q_EDGE_xsth = (xbedge+xnedge_s);
        {
          AdmsSensFadType value_sqrt_0 = sqrt(Q_EDGE_xsth);
          Q_EDGE_xth0 = (Q_EDGE_xsth+(instanceVar_Gfedge*value_sqrt_0));
        }
        Q_EDGE_xth = (Q_EDGE_xth0+dxthedge);
        {
          AdmsSensFadType value_sqrt_0 = sqrt(Q_EDGE_xsth);
          Q_EDGE_n = (1.0+(instanceVar_Gfedge/(2.0*value_sqrt_0)));
        }
        Q_EDGE_n_inv = (1.0/Q_EDGE_n);
        Q_EDGE_xgt = (xgedge-Q_EDGE_xth);
        if ((Q_EDGE_xgt>(-12.0)))
        {
          Q_EDGE_xgt0 = ((Q_EDGE_xgt+instanceVar_lnGfedge2)-1.0);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((Q_EDGE_xgt0*Q_EDGE_xgt0)+10.0));
            Q_EDGE_xgt0e = (0.5*(Q_EDGE_xgt0+value_sqrt_0));
          }
          {
            AdmsSensFadType value_log_0 = log(Q_EDGE_xgt0e);
            Q_EDGE_qi0si = ((Q_EDGE_xgt-(Q_EDGE_n*value_log_0))+instanceVar_lnGfedge2);
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((Q_EDGE_qi0si*Q_EDGE_qi0si)+2.0));
            Q_EDGE_qi0 = (0.5*(Q_EDGE_qi0si+value_sqrt_0));
          }
          if (((Q_EDGE_xgt-Q_EDGE_qi0)<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp((Q_EDGE_xgt-Q_EDGE_qi0));
              Q_EDGE_exp_x = value_exp_0;
            }
          }
          else
          {
            Q_EDGE_exp_x = (1.0e100*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
          }
          Q_EDGE_d0 = (instanceVar_Gfedge2*Q_EDGE_exp_x);
          {
            AdmsSensFadType value_pow_0 = pow(Q_EDGE_d0,Q_EDGE_n_inv);
            Q_EDGE_d0p = value_pow_0;
          }
          Q_EDGE_sqerr = ((Q_EDGE_n*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*Q_EDGE_d0p));
          {
            AdmsSensFadType value_sqrt_0 = sqrt(Q_EDGE_sqerr);
            Q_EDGE_errq = (Q_EDGE_n*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
          }
          qseffedge = (Q_EDGE_qi0-Q_EDGE_errq);
        }
        else
        {
          if (((Q_EDGE_n_inv*(Q_EDGE_xgt+instanceVar_lnGfedge2))>(-2.3025850929940458e+02)))
          {
            {
              AdmsSensFadType value_exp_0 = exp((Q_EDGE_n_inv*(Q_EDGE_xgt+instanceVar_lnGfedge2)));
              qseffedge = value_exp_0;
            }
          }
          else
          {
            qseffedge = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceVar_lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceVar_lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceVar_lnGfedge2)))*3.3333333333333333e-01))))))));
          }
        }
        xnedge_d = (inv_phit1edge*(Vdse_dc+Vsbstaredge));
        if (((qseffedge<1.0e-3)&(Vdse_dc<1.0e-6)))
        {
          if ((((-xnedge_d)+xnedge_s)>(-2.3025850929940458e+02)))
          {
            {
              AdmsSensFadType value_exp_0 = exp(((-xnedge_d)+xnedge_s));
              temp = value_exp_0;
            }
          }
          else
          {
            temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))));
          }
          qdseffedge = (qseffedge*(temp-1.0));
          qdeffedge = (qdseffedge+qseffedge);
        }
        else
        {
          Q_EDGE_xsth = (xbedge+xnedge_d);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(Q_EDGE_xsth);
            Q_EDGE_xth0 = (Q_EDGE_xsth+(instanceVar_Gfedge*value_sqrt_0));
          }
          Q_EDGE_xth = (Q_EDGE_xth0+dxthedge);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(Q_EDGE_xsth);
            Q_EDGE_n = (1.0+(instanceVar_Gfedge/(2.0*value_sqrt_0)));
          }
          Q_EDGE_n_inv = (1.0/Q_EDGE_n);
          Q_EDGE_xgt = (xgedge-Q_EDGE_xth);
          if ((Q_EDGE_xgt>(-12.0)))
          {
            Q_EDGE_xgt0 = ((Q_EDGE_xgt+instanceVar_lnGfedge2)-1.0);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((Q_EDGE_xgt0*Q_EDGE_xgt0)+10.0));
              Q_EDGE_xgt0e = (0.5*(Q_EDGE_xgt0+value_sqrt_0));
            }
            {
              AdmsSensFadType value_log_0 = log(Q_EDGE_xgt0e);
              Q_EDGE_qi0si = ((Q_EDGE_xgt-(Q_EDGE_n*value_log_0))+instanceVar_lnGfedge2);
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((Q_EDGE_qi0si*Q_EDGE_qi0si)+2.0));
              Q_EDGE_qi0 = (0.5*(Q_EDGE_qi0si+value_sqrt_0));
            }
            if (((Q_EDGE_xgt-Q_EDGE_qi0)<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((Q_EDGE_xgt-Q_EDGE_qi0));
                Q_EDGE_exp_x = value_exp_0;
              }
            }
            else
            {
              Q_EDGE_exp_x = (1.0e100*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
            Q_EDGE_d0 = (instanceVar_Gfedge2*Q_EDGE_exp_x);
            {
              AdmsSensFadType value_pow_0 = pow(Q_EDGE_d0,Q_EDGE_n_inv);
              Q_EDGE_d0p = value_pow_0;
            }
            Q_EDGE_sqerr = ((Q_EDGE_n*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*Q_EDGE_d0p));
            {
              AdmsSensFadType value_sqrt_0 = sqrt(Q_EDGE_sqerr);
              Q_EDGE_errq = (Q_EDGE_n*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
            }
            qdeffedge = (Q_EDGE_qi0-Q_EDGE_errq);
          }
          else
          {
            if (((Q_EDGE_n_inv*(Q_EDGE_xgt+instanceVar_lnGfedge2))>(-2.3025850929940458e+02)))
            {
              {
                AdmsSensFadType value_exp_0 = exp((Q_EDGE_n_inv*(Q_EDGE_xgt+instanceVar_lnGfedge2)));
                qdeffedge = value_exp_0;
              }
            }
            else
            {
              qdeffedge = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceVar_lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceVar_lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceVar_lnGfedge2)))*3.3333333333333333e-01))))))));
            }
          }
          qdseffedge = (qdeffedge-qseffedge);
        }
        qmeffedge = (0.5*(qdeffedge+qseffedge));
        {
          AdmsSensFadType value_max_0 = std::max((xgedge-qmeffedge),static_cast<double>(1.0e-40));
          dsqredge = value_max_0;
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt((dsqredge+(0.25*instanceVar_Gfedge2)));
          alphabmedge = (1.0-((0.5*instanceVar_Gfedge)/value_sqrt_0));
        }
        Idsedge = ((((((-instanceVar_BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)/Gmob_dc);
      }
      if (((xg_dc>0)&&(modelVar_SWIMPACT_i!=0)))
      {
        delVsat = (Vds-(instanceVar_A3_i*dps_dc));
        if ((delVsat>0))
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt((instanceVar_phib_dc+Vsbstar_dc));
            temp2 = (instanceVar_A2_T*((1.0+(instanceVar_A4_i*(value_sqrt_0-instanceVar_sqrt_phib_dc)))/(delVsat+1.0e-30)));
          }
          if ((fabs((-temp2))<2.3025850929940458e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp((-temp2));
              temp = value_exp_0;
            }
          }
          else
          {
            if (((-temp2)<0.0))
            {
              temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
            }
            else
            {
              temp = (1.0e100*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          mavl = (instanceVar_A1_i*(delVsat*temp));
          Iimpact = (mavl*(Ids+Idsedge));
        }
      }
      P_D = (1.0+(0.25*(Gf_dc*instanceVar_kp)));
      facvsb0 = (instanceVar_phib_dc+(2.0*phit1));
      facvsb = (Vsbstar_dc+facvsb0);
      {
        AdmsSensFadType value_sqrt_0 = sqrt((phit1*facvsb));
        vts_i = (((instanceVar_VFB_T+(P_D*facvsb))-Vsbstar_dc)+(Gf_dc*value_sqrt_0));
      }
      vth_i = (vts_i-delVg);
    }
    // End block evaluateStatic
    //Begin block evaluateDynamic
    {
      //Begin block SPcalc_ac
      {
        //Block-local variables for block SPcalc_ac
        AdmsSensFadType phib;
        AdmsSensFadType G_0;
        AdmsSensFadType Vsbstar;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        AdmsSensFadType Vsbx;
        AdmsSensFadType xg;
        AdmsSensFadType Dnsub;
        AdmsSensFadType Gf;
        AdmsSensFadType Gf2;
        AdmsSensFadType inv_Gf2;
        AdmsSensFadType xi;
        AdmsSensFadType inv_xi;
        AdmsSensFadType Ux;
        AdmsSensFadType xn_s;
        AdmsSensFadType delta_ns;
        AdmsSensFadType margin;
        AdmsSensFadType x_s;
        AdmsSensFadType delta_1s;
        AdmsSensFadType xi0s;
        AdmsSensFadType xi1s;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        AdmsSensFadType xi2s;
        AdmsSensFadType Es;
        AdmsSensFadType Ds;
        AdmsSensFadType Ps;
        AdmsSensFadType Rxcor;
        AdmsSensFadType xgs;
        AdmsSensFadType qis;
        AdmsSensFadType qbs;
        AdmsSensFadType rhob;
        AdmsSensFadType GR;
        AdmsSensFadType Eeffm;
        AdmsSensFadType Mutmp;
        AdmsSensFadType Gmob;
        AdmsSensFadType xitsb;
        AdmsSensFadType wsat;
        AdmsSensFadType thesat1;
        AdmsSensFadType phi_inf;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        AdmsSensFadType ysat;
        AdmsSensFadType za;
        AdmsSensFadType Phi_0;
        AdmsSensFadType asat;
        AdmsSensFadType Phi_2;
        AdmsSensFadType Phi_0_2;
        AdmsSensFadType Phi0_Phi2;
        AdmsSensFadType Phi_sat;
        AdmsSensFadType Vdse;
        AdmsSensFadType Udse;
        AdmsSensFadType xn_d;
        AdmsSensFadType k_ds;
        AdmsSensFadType delta_nd;
        AdmsSensFadType x_d;
        AdmsSensFadType x_ds;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        AdmsSensFadType pC;
        AdmsSensFadType qC;
        AdmsSensFadType dps;
        AdmsSensFadType xi0d;
        AdmsSensFadType Ed;
        AdmsSensFadType Dd;
        AdmsSensFadType x_m;
        AdmsSensFadType Em;
        AdmsSensFadType D_bar;
        AdmsSensFadType Dm;
        AdmsSensFadType Pm;
        AdmsSensFadType xgm;
        AdmsSensFadType eta_p;
        AdmsSensFadType sqm;
        AdmsSensFadType alpha;
        AdmsSensFadType d0;
        AdmsSensFadType x_pm;
        AdmsSensFadType p_pd;
        AdmsSensFadType q_pd;
        AdmsSensFadType xi_pd;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        AdmsSensFadType u_pd;
        AdmsSensFadType km;
        AdmsSensFadType km0;
        AdmsSensFadType qim;
        AdmsSensFadType qim1;
        AdmsSensFadType qbm;
        AdmsSensFadType qeff;
        AdmsSensFadType qeff1;
        AdmsSensFadType s1;
        AdmsSensFadType dL;
        AdmsSensFadType GdL;
        AdmsSensFadType Gmob_dL;
        AdmsSensFadType zsat;
        AdmsSensFadType Gvsat;
        AdmsSensFadType Gvsatinv;
        AdmsSensFadType Voxm;
        AdmsSensFadType alpha1;
        AdmsSensFadType H;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        AdmsSensFadType SP_S_temp;
        AdmsSensFadType SP_S_temp1;
        AdmsSensFadType SP_S_temp2;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        AdmsSensFadType SP_S_yg;
        AdmsSensFadType SP_S_ysub;
        AdmsSensFadType SP_S_eta;
        AdmsSensFadType SP_S_a;
        AdmsSensFadType SP_S_c;
        AdmsSensFadType SP_S_tau;
        AdmsSensFadType SP_S_y0;
        AdmsSensFadType SP_S_delta0;
        AdmsSensFadType SP_S_delta1;
        AdmsSensFadType SP_S_xi0;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        AdmsSensFadType SP_S_xi1;
        AdmsSensFadType SP_S_xi2;
        AdmsSensFadType SP_S_pC;
        AdmsSensFadType SP_S_qC;
        AdmsSensFadType SP_xg1;
        AdmsSensFadType SP_S_A_fac;
        AdmsSensFadType SP_S_xbar;
        AdmsSensFadType SP_S_w;
        AdmsSensFadType SP_S_x1;
        AdmsSensFadType SP_S_bx;
        AdmsSensFadType SP_S_b;
        //End of Block-local variables
        //Block-local variables for block SPcalc_ac
        AdmsSensFadType SP_S_x0;
        //End of Block-local variables
        if (((modelVar_SWNUD_i==1)||(modelVar_SWDELVTAC_i!=0)))
        {
          if ((modelVar_SWDELVTAC_i!=0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+instanceVar_bphi_ac));
              temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+instanceVar_phix_ac);
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((temp)*(temp))+instanceVar_aphi_ac));
              Vsbstar_ac = ((Vsb-(0.5*((temp)-value_sqrt_0)))+instanceVar_phix1_ac);
            }
            Vsbstar = Vsbstar_ac;
            phib = instanceVar_phib_ac;
            G_0 = instanceVar_G_0_ac;
          }
          else
          {
            Vsbstar = Vsbstar_dc_tmp;
            phib = instanceVar_phib_dc;
            G_0 = instanceVar_G_0_dc;
          }
          alpha = 0.0;
          GdL = 1.0;
          dL = 0.0;
          qbm = 0.0;
          dps = 0.0;
          qim = 0.0;
          qim1 = 0.0;
          H = 1.0;
          s1 = 0.0;
          eta_p = 1.0;
          Gvsat = 1.0;
          Gvsatinv = 1.0;
          SP_S_x1 = 0.0;
          x_s = 0.0;
          sqm = 0.0;
          xitsb = 0.0;
          rhob = 0.0;
          Gmob = 1.0;
          Gmob_dL = 1.0;
          Udse = 0.0;
          thesat1 = 0.0;
          xgm = 0.0;
          Vgbstar = (Vgs+Vsbstar);
          Vgb1 = (Vgbstar-instanceVar_VFB_T);
          Vsbx = (Vsbstar+(0.5*(Vds-Vdsx)));
          if ((instanceVar_CFD_i<1.0e-10))
          {
            Vdsp = Vdsx;
          }
          else
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0+(instanceVar_CFD_i*Vdsx)));
              Vdsp = ((2.0*(value_sqrt_0-1.0))/instanceVar_CFD_i);
            }
          }
          delVg = ((instanceVar_CF_i*Vdsp)*(1.0+(instanceVar_CFB_i*Vsbx)));
          dphit1 = ((instanceVar_PSCE_i*(1.0+(instanceVar_PSCED_i*Vdsx)))*(1.0+(instanceVar_PSCEB_i*Vsbx)));
          phit1 = (instanceVar_phit0*(1.0+dphit1));
          inv_phit1 = (1.0/phit1);
          Vgb1 = (Vgb1+delVg);
          xg = (Vgb1*inv_phit1);
          if ((instanceVar_DNSUB_i>0.0))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((-((Vgs+Vsb)-instanceVar_VNSUB_i))*(-((Vgs+Vsb)-instanceVar_VNSUB_i)))+instanceVar_NSLP_i));
              Dnsub = ((instanceVar_DNSUB_i*0.5)*((+((Vgs+Vsb)-instanceVar_VNSUB_i))+value_sqrt_0));
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0+Dnsub));
              Gf = (G_0*value_sqrt_0);
            }
          }
          else
          {
            Gf = G_0;
          }
          Gf2 = (Gf*Gf);
          inv_Gf2 = (1.0/Gf2);
          xi = (1.0+(Gf*7.0710678118654746e-01));
          inv_xi = (1.0/xi);
          Ux = (Vsbstar*inv_phit1);
          xn_s = ((phib*inv_phit1)+Ux);
          if ((xn_s<4.6051701859880916e+02))
          {
            {
              AdmsSensFadType value_exp_0 = exp((-xn_s));
              delta_ns = value_exp_0;
            }
          }
          else
          {
            delta_ns = (1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
          }
          margin = (1.0e-5*xi);
          if ((fabs(xg)<=margin))
          {
            SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
            x_s = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
          }
          else
          {
            if ((xg<(-margin)))
            {
              SP_S_yg = (-xg);
              SP_S_ysub = (1.25*(SP_S_yg*inv_xi));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0));
                SP_S_eta = (0.5*((SP_S_ysub+10)-value_sqrt_0));
              }
              SP_S_temp = (SP_S_yg-SP_S_eta);
              SP_S_a = ((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0)));
              SP_S_c = ((2.0*SP_S_temp)-Gf2);
              {
                AdmsSensFadType value_log_0 = log((SP_S_a*inv_Gf2));
                SP_S_tau = ((-SP_S_eta)+value_log_0);
              }
              nu = (SP_S_a+SP_S_c);
              mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
              SP_S_y0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
              if ((SP_S_y0<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(SP_S_y0);
                  SP_S_delta0 = value_exp_0;
                }
              }
              else
              {
                SP_S_delta0 = (1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
              SP_S_delta1 = (1.0/SP_S_delta0);
              SP_S_temp = (1.0/(2.0+(SP_S_y0*SP_S_y0)));
              SP_S_xi0 = ((SP_S_y0*SP_S_y0)*SP_S_temp);
              SP_S_xi1 = (4.0*((SP_S_y0*SP_S_temp)*SP_S_temp));
              SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
              SP_S_temp = (SP_S_yg-SP_S_y0);
              SP_S_temp1 = (delta_ns*SP_S_delta1);
              SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
              SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
              SP_S_temp = (2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
              SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
              {
                AdmsSensFadType value_sqrt_0 = sqrt(SP_S_temp);
                x_s = ((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
              }
            }
            else
            {
              SP_xg1 = (1.0/(1.25+(Gf*7.324648775608221e-001)));
              SP_S_A_fac = ((((xi*1.25)*SP_xg1)-1.0)*SP_xg1);
              SP_S_xbar = ((xg*inv_xi)*(1.0+(SP_S_A_fac*xg)));
              if (((-SP_S_xbar)>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp((-SP_S_xbar));
                  SP_S_temp = value_exp_0;
                }
              }
              else
              {
                SP_S_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
              }
              SP_S_w = (1.0-SP_S_temp);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((xg+(Gf2*0.25))-SP_S_w));
                SP_S_x1 = ((xg+(Gf2*0.5))-(Gf*value_sqrt_0));
              }
              SP_S_bx = (xn_s+3.0);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
                AdmsSensFadType value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
                SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
              }
              SP_S_temp = (xg-SP_S_eta);
              {
                AdmsSensFadType value_exp_0 = exp((-SP_S_eta));
                SP_S_temp1 = value_exp_0;
              }
              SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));
              SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);
              SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
              SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
              {
                AdmsSensFadType value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))));
                SP_S_a = value_max_0;
              }
              SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))));
              SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
              {
                AdmsSensFadType value_log_0 = log((SP_S_a/Gf2));
                SP_S_tau = ((xn_s-SP_S_eta)+value_log_0);
              }
              nu = (SP_S_a+SP_S_c);
              mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
              SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
              if ((SP_S_x0<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(SP_S_x0);
                  SP_S_delta0 = value_exp_0;
                }
                SP_S_delta1 = (1.0/SP_S_delta0);
                SP_S_delta0 = (delta_ns*SP_S_delta0);
              }
              else
              {
                if ((SP_S_x0>(xn_s-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp((SP_S_x0-xn_s));
                    SP_S_delta0 = value_exp_0;
                  }
                  SP_S_delta1 = (delta_ns/SP_S_delta0);
                }
                else
                {
                  SP_S_delta0 = (1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));
              SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);
              SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
              SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
              SP_S_temp = (xg-SP_S_x0);
              SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
              SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
              SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
              SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
              {
                AdmsSensFadType value_sqrt_0 = sqrt(SP_S_temp);
                x_s = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
              }
            }
          }
          x_d = x_s;
          x_m = x_s;
          x_ds = 0.0;
          Vdsat_lim = (3.912023005*phit1);
          if ((xg<=0.0))
          {
            qis = 0.0;
            xgm = (xg-x_s);
            Voxm = (xgm*phit1);
            qeff1 = Voxm;
            Vdsat = Vdsat_lim;
            Vdse = Vds;
          }
          else
          {
            delta_1s = 0.0;
            temp = (1.0/(2.0+(x_s*x_s)));
            xi0s = ((x_s*x_s)*temp);
            xi1s = (4.0*((x_s*temp)*temp));
            xi2s = ((((8.0*temp)-(12.0*xi0s))*temp)*temp);
            if ((x_s<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp(x_s);
                delta_1s = value_exp_0;
              }
              Es = (1.0/delta_1s);
              delta_1s = (delta_ns*delta_1s);
            }
            else
            {
              if ((x_s>(xn_s-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp((x_s-xn_s));
                  delta_1s = value_exp_0;
                }
                Es = (delta_ns/delta_1s);
              }
              else
              {
                delta_1s = (1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                Es = (1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            Ds = (delta_1s-(delta_ns*((x_s+1.0)+xi0s)));
            if ((x_s<1.0e-5))
            {
              Ps = (0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))));
              Ds = (1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s))));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
                temp = value_sqrt_0;
              }
              sqm = (7.0710678118654746e-01*(x_s*temp));
              alpha = (1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp));
            }
            else
            {
              Ps = ((x_s-1.0)+Es);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(Ps);
                sqm = value_sqrt_0;
              }
              alpha = (1.0+(0.5*((Gf*(1.0-Es))/sqm)));
            }
            Em = Es;
            Ed = Em;
            Dm = Ds;
            Dd = Dm;
            Rxcor = ((1.0+((0.2*instanceVar_XCOR_T)*Vsbx))/(1.0+(instanceVar_XCOR_T*Vsbx)));
            if ((Ds>1.0e-100))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((Ps+Ds));
                xgs = (Gf*value_sqrt_0);
              }
              qis = (((Gf2*Ds)*phit1)/(xgs+(Gf*sqm)));
              qbs = ((sqm*Gf)*phit1);
              if ((instanceVar_RSB_i<0.0))
              {
                rhob = (1.0/(1.0-(instanceVar_RSB_i*Vsbx)));
              }
              else
              {
                rhob = (1.0+(instanceVar_RSB_i*Vsbx));
              }
              if ((instanceVar_RSG_i<0.0))
              {
                temp = (1.0-(instanceVar_RSG_i*qis));
              }
              else
              {
                temp = (1.0/(1.0+(instanceVar_RSG_i*qis)));
              }
              GR = (instanceVar_THER_i*((rhob*temp)*qis));
              Eeffm = (instanceVar_E_eff0*(qbs+(instanceVar_eta_mu*qis)));
              {
                AdmsSensFadType value_pow_0 = pow((Eeffm*instanceVar_MUE_T),instanceVar_THEMU_T);
                Mutmp = (value_pow_0+(instanceVar_CS_T*(Ps/((Ps+Ds)+1.0e-14))));
              }
              Gmob = (((1.0+Mutmp)+GR)*Rxcor);
              if ((instanceVar_THESATB_i<0.0))
              {
                xitsb = (1.0/(1.0-(instanceVar_THESATB_i*Vsbx)));
              }
              else
              {
                xitsb = (1.0+(instanceVar_THESATB_i*Vsbx));
              }
              temp2 = (qis*xitsb);
              wsat = (100.0*(temp2/(100.0+temp2)));
              if ((instanceVar_THESATG_i<0.0))
              {
                temp = (1.0/(1.0-(instanceVar_THESATG_i*wsat)));
              }
              else
              {
                temp = (1.0+(instanceVar_THESATG_i*wsat));
              }
              thesat1 = (instanceVar_THESAT_T*(temp/Gmob));
              phi_inf = ((qis/alpha)+phit1);
              ysat = ((thesat1*phi_inf)*7.0710678118654746e-01);
              if ((modelVar_CHNL_TYPE==(-1)))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1.0+ysat));
                  ysat = (ysat/value_sqrt_0);
                }
              }
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0+(4.0*ysat)));
                za = (2.0/(1.0+value_sqrt_0));
              }
              temp1 = (za*ysat);
              Phi_0 = ((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
              asat = (xgs+(0.5*Gf2));
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((asat*asat)-((Gf2*Ds)*0.98)));
                Phi_2 = (0.98*(((Gf2*Ds)*phit1)/(asat+value_sqrt_0)));
              }
              Phi_0_2 = (Phi_0+Phi_2);
              Phi0_Phi2 = (2.0*(Phi_0*Phi_2));
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)));
                Phi_sat = (Phi0_Phi2/(Phi_0_2+value_sqrt_0));
              }
              {
                AdmsSensFadType value_log_0 = log((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));
                Vdsat = (Phi_sat-(phit1*value_log_0));
              }
            }
            else
            {
              Vdsat = Vdsat_lim;
            }
            {
              AdmsSensFadType value_pow_0 = pow((Vds/Vdsat),instanceVar_AX_i);
              temp = value_pow_0;
            }
            {
              AdmsSensFadType value_pow_0 = pow((1.0+temp),(-instanceVar_inv_AX));
              Vdse = (Vds*value_pow_0);
            }
            Udse = (Vdse*inv_phit1);
            xn_d = (xn_s+Udse);
            if ((Udse<4.6051701859880916e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((-Udse));
                k_ds = value_exp_0;
              }
            }
            else
            {
              k_ds = (1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
            }
            delta_nd = (delta_ns*k_ds);
            if ((fabs(xg)<=margin))
            {
              SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
              x_d = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
            }
            else
            {
              SP_S_bx = (xn_d+3);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
                AdmsSensFadType value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
                SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
              }
              SP_S_temp = (xg-SP_S_eta);
              {
                AdmsSensFadType value_exp_0 = exp((-SP_S_eta));
                SP_S_temp1 = value_exp_0;
              }
              SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));
              SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);
              SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
              SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
              {
                AdmsSensFadType value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))));
                SP_S_a = value_max_0;
              }
              SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))));
              SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
              {
                AdmsSensFadType value_log_0 = log((SP_S_a/Gf2));
                SP_S_tau = ((xn_d-SP_S_eta)+value_log_0);
              }
              nu = (SP_S_a+SP_S_c);
              mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
              SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
              if ((SP_S_x0<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(SP_S_x0);
                  SP_S_delta0 = value_exp_0;
                }
                SP_S_delta1 = (1.0/SP_S_delta0);
                SP_S_delta0 = (delta_nd*SP_S_delta0);
              }
              else
              {
                if ((SP_S_x0>(xn_d-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp((SP_S_x0-xn_d));
                    SP_S_delta0 = value_exp_0;
                  }
                  SP_S_delta1 = (delta_nd/SP_S_delta0);
                }
                else
                {
                  SP_S_delta0 = (1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                  SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));
              SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);
              SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
              SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
              SP_S_temp = (xg-SP_S_x0);
              SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
              SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
              SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
              SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
              {
                AdmsSensFadType value_sqrt_0 = sqrt(SP_S_temp);
                x_d = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
              }
            }
            x_ds = (x_d-x_s);
            if ((x_ds<1.0e-10))
            {
              pC = ((2.0*(xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
              qC = ((Gf2*(1.0-k_ds))*Ds);
              temp = (2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
              temp = ((pC*pC)-(2.0*(temp*qC)));
              {
                AdmsSensFadType value_sqrt_0 = sqrt(temp);
                x_ds = (2.0*(qC/(pC+value_sqrt_0)));
              }
              x_d = (x_s+x_ds);
            }
            dps = (x_ds*phit1);
            xi0d = ((x_d*x_d)/(2.0+(x_d*x_d)));
            if ((x_d<2.3025850929940458e+02))
            {
              {
                AdmsSensFadType value_exp_0 = exp((-x_d));
                Ed = value_exp_0;
              }
              if ((x_d<1.0e-5))
              {
                Dd = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
              }
              else
              {
                Dd = (delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d));
              }
            }
            else
            {
              if ((x_d>(xn_d-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp((x_d-xn_d));
                  temp = value_exp_0;
                }
                Ed = (delta_nd/temp);
                Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
              }
              else
              {
                Ed = (1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                temp = (1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
              }
            }
            x_m = (0.5*(x_s+x_d));
            Em = 0.0;
            temp = (Ed*Es);
            if ((temp>0.0))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(temp);
                Em = value_sqrt_0;
              }
            }
            D_bar = (0.5*(Ds+Dd));
            Dm = (D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))));
            if ((x_m<1.0e-5))
            {
              Pm = (0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((Dm+Pm));
                xgm = (Gf*value_sqrt_0);
              }
              if ((instanceVar_kp>0.0))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1.0+(instanceVar_kp*xgm)));
                  eta_p = (1.0/value_sqrt_0);
                }
              }
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
                temp = value_sqrt_0;
              }
              sqm = (7.0710678118654746e-01*(x_m*temp));
              alpha = (eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)));
            }
            else
            {
              Pm = ((x_m-1.0)+Em);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((Dm+Pm));
                xgm = (Gf*value_sqrt_0);
              }
              if ((instanceVar_kp>0.0))
              {
                d0 = ((1.0-Em)+(2.0*(xgm*inv_Gf2)));
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1.0+(instanceVar_kp*xgm)));
                  eta_p = (1.0/value_sqrt_0);
                }
                temp = (eta_p/(eta_p+1.0));
                x_pm = (instanceVar_kp*(((temp*temp)*Gf2)*Dm));
                p_pd = ((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm)));
                q_pd = (x_pm*(x_pm-(2.0*xgm)));
                xi_pd = (1.0-(0.5*(Gf2*(Em+Dm))));
                u_pd = ((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd)));
                x_m = (x_m+u_pd);
                {
                  AdmsSensFadType value_exp_0 = exp(u_pd);
                  km = value_exp_0;
                }
                Em = (Em/km);
                Dm = (Dm*km);
                Pm = ((x_m-1.0)+Em);
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((Dm+Pm));
                  xgm = (Gf*value_sqrt_0);
                }
                km0 = ((1.0-Em)+(2.0*((xgm*eta_p)*inv_Gf2)));
                x_ds = (((x_ds*km)*(d0+D_bar))/(km0+(km*D_bar)));
                dps = (x_ds*phit1);
              }
              {
                AdmsSensFadType value_sqrt_0 = sqrt(Pm);
                sqm = value_sqrt_0;
              }
              alpha = (eta_p+(0.5*((Gf*(1.0-Em))/sqm)));
            }
            qim = (phit1*((Gf2*Dm)/(xgm+(Gf*sqm))));
            qim1 = (qim+(phit1*alpha));
            qbm = ((sqm*Gf)*phit1);
            if ((instanceVar_RSG_i<0.0))
            {
              temp = (1.0-(instanceVar_RSG_i*qim));
            }
            else
            {
              temp = (1.0/(1.0+(instanceVar_RSG_i*qim)));
            }
            GR = (instanceVar_THER_i*((rhob*temp)*qim));
            qeff = (qbm+(instanceVar_eta_mu*qim));
            qeff1 = (qbm+(instanceVar_eta_mu1*qim));
            Eeffm = (instanceVar_E_eff0*qeff);
            {
              AdmsSensFadType value_pow_0 = pow((Eeffm*instanceVar_MUE_T),instanceVar_THEMU_T);
              Mutmp = (value_pow_0+(instanceVar_CS_T*(Pm/((Pm+Dm)+1.0e-14))));
            }
            Gmob = (((1.0+Mutmp)+GR)*Rxcor);
            {
              AdmsSensFadType value_log_0 = log(((1.0+((Vds-dps)*instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceVar_inv_VP))));
              s1 = value_log_0;
            }
            dL = (instanceVar_ALP_i*s1);
            GdL = (1.0/((1.0+dL)+(dL*dL)));
            temp2 = (qim*xitsb);
            wsat = (100.0*(temp2/(100.0+temp2)));
            Gmob_dL = (Gmob*GdL);
            if ((instanceVar_THESATG_i<0.0))
            {
              temp = (1.0/(1.0-(instanceVar_THESATG_i*wsat)));
            }
            else
            {
              temp = (1.0+(instanceVar_THESATG_i*wsat));
            }
            thesat1 = (instanceVar_THESAT_T*(temp/Gmob_dL));
            zsat = (((thesat1*thesat1)*dps)*dps);
            if ((modelVar_CHNL_TYPE==(-1)))
            {
              zsat = (zsat/(1.0+(thesat1*dps)));
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0+(2.0*zsat)));
              Gvsat = (0.5*(Gmob_dL*(1.0+value_sqrt_0)));
            }
            Gvsatinv = (1.0/Gvsat);
            Voxm = (xgm*phit1);
            temp = (Gmob_dL*Gvsatinv);
            alpha1 = (alpha*(1.0+(0.5*((zsat*temp)*temp))));
            H = ((temp*qim1)/alpha1);
          }
          xg_ac = xg;
          qeff1_ac = qeff1;
          Voxm_ac = Voxm;
          alpha_ac = alpha;
          dps_ac = dps;
          qim_ac = qim;
          GdL_ac = GdL;
          H_ac = H;
          eta_p_ac = eta_p;
          Gvsat_ac = Gvsat;
          Gmob_dL_ac = Gmob_dL;
        }
        else
        {
          xg_ac = xg_dc;
          qeff1_ac = qeff1_dc;
          Voxm_ac = Voxm_dc;
          alpha_ac = alpha_dc;
          dps_ac = dps_dc;
          qim_ac = qim_dc;
          GdL_ac = GdL_dc;
          H_ac = H_dc;
          eta_p_ac = eta_p_dc;
          Gvsat_ac = Gvsat_dc;
          Gmob_dL_ac = Gmob_dL_dc;
        }
      }
      // End block SPcalc_ac
      Vgb = (Vgs+Vsb);
      COX_qm = instanceVar_COX_i;
      if ((instanceVar_qq>0.0))
      {
        {
          AdmsSensFadType value_pow_0 = pow(((qeff1_ac*qeff1_ac)+instanceVar_qlim2),((-1.0)*1.6666666666666667e-01));
          COX_qm = (instanceVar_COX_i/(1.0+(instanceVar_qq*value_pow_0)));
        }
      }
      if ((xg_ac<=0.0))
      {
        QG = Voxm_ac;
        QI = 0.0;
        QD = 0.0;
        QB = QG;
      }
      else
      {
        Fj = (0.5*(dps_ac/H_ac));
        Fj2 = (Fj*Fj);
        QCLM = ((1.0-GdL_ac)*(qim_ac-(0.5*(alpha_ac*dps_ac))));
        QG = (Voxm_ac+(0.5*((eta_p_ac*dps_ac)*((((Fj*GdL_ac)*3.3333333333333333e-01)-1.0)+GdL_ac))));
        temp = ((alpha_ac*dps_ac)*1.6666666666666667e-01);
        QI = ((GdL_ac*(qim_ac+(temp*Fj)))+QCLM);
        QD = (0.5*(((GdL_ac*GdL_ac)*(qim_ac-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL_ac))));
        QB = (QG-QI);
      }
      Qg = (QG*COX_qm);
      Qd = ((-QD)*COX_qm);
      Qb = ((-QB)*COX_qm);
      Qgs_ov = (instanceVar_CGOV_i*Vovs);
      Qgd_ov = (instanceVar_CGOVD_i*Vovd);
      Qgb_ov = (instanceVar_CGBOV_i*Vgb);
      Qfgs = (instanceVar_CFR_i*VgsPrime);
      Qfgd = (instanceVar_CFRD_i*VgdPrime);
    }
    // End block evaluateDynamic
    //Begin block evaluateStaticDynamic
    {
      ijun_s = 0.0;
      ijunbot_s = 0.0;
      ijunsti_s = 0.0;
      ijungat_s = 0.0;
      ijun_d = 0.0;
      ijunbot_d = 0.0;
      ijunsti_d = 0.0;
      ijungat_d = 0.0;
      qjun_s = 0.0;
      qjunbot_s = 0.0;
      qjunsti_s = 0.0;
      qjungat_s = 0.0;
      qjun_d = 0.0;
      qjunbot_d = 0.0;
      qjunsti_d = 0.0;
      qjungat_d = 0.0;
      if ((modelVar_SWJUNCAP_i>0))
      {
        if ((modelVar_SWJUNEXP_i==1))
        {
          tm0 = ((Vjun_s*modelVar_phitdinv)*instanceVar_MFOR1_s);
          {
            AdmsSensFadType value_exp_0 = exp(tm0);
            tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighf1_s),(instanceVar_expxhf1_s*((tm0-instanceVar_xhighf1_s)+1.0)),value_exp_0));
          }
          ijunfor1 = (instanceVar_ISATFOR1_s*(tm1-1.0));
          tm0 = ((Vjun_s*modelVar_phitdinv)*instanceVar_MFOR2_s);
          {
            AdmsSensFadType value_exp_0 = exp(tm0);
            tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighf2_s),(instanceVar_expxhf2_s*((tm0-instanceVar_xhighf2_s)+1.0)),value_exp_0));
          }
          ijunfor2 = (instanceVar_ISATFOR2_s*(tm1-1.0));
          ijunrev = 0.0;
          if ((instanceVar_m0flag_s>0.0))
          {
            ijunrev = (Vjun_s*(instanceVar_ISATREV_s+(Vjun_s*instanceVar_MREV_s)));
          }
          else
          {
            tm0 = (((-Vjun_s)*modelVar_phitdinv)*instanceVar_MREV_s);
            {
              AdmsSensFadType value_exp_0 = exp(tm0);
              tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighr_s),(instanceVar_expxhr_s*((tm0-instanceVar_xhighr_s)+1.0)),value_exp_0));
            }
            ijunrev = ((-instanceVar_ISATREV_s)*(tm1-1.0));
          }
          ijun_s = ((ijunfor1+ijunfor2)+ijunrev);
          tm0 = ((Vjun_d*modelVar_phitdinv)*instanceVar_MFOR1_d);
          {
            AdmsSensFadType value_exp_0 = exp(tm0);
            tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighf1_d),(instanceVar_expxhf1_d*((tm0-instanceVar_xhighf1_d)+1.0)),value_exp_0));
          }
          ijunfor1 = (instanceVar_ISATFOR1_d*(tm1-1.0));
          tm0 = ((Vjun_d*modelVar_phitdinv)*instanceVar_MFOR2_d);
          {
            AdmsSensFadType value_exp_0 = exp(tm0);
            tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighf2_d),(instanceVar_expxhf2_d*((tm0-instanceVar_xhighf2_d)+1.0)),value_exp_0));
          }
          ijunfor2 = (instanceVar_ISATFOR2_d*(tm1-1.0));
          ijunrev = 0.0;
          if ((instanceVar_m0flag_d>0.0))
          {
            ijunrev = (Vjun_d*(instanceVar_ISATREV_d+(Vjun_d*instanceVar_MREV_d)));
          }
          else
          {
            tm0 = (((-Vjun_d)*modelVar_phitdinv)*instanceVar_MREV_d);
            {
              AdmsSensFadType value_exp_0 = exp(tm0);
              tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighr_d),(instanceVar_expxhr_d*((tm0-instanceVar_xhighr_d)+1.0)),value_exp_0));
            }
            ijunrev = ((-instanceVar_ISATREV_d)*(tm1-1.0));
          }
          ijun_d = ((ijunfor1+ijunfor2)+ijunrev);
          //Begin block evaluateDynamic
          {
            //Block-local variables for block evaluateDynamic
            AdmsSensFadType tmpv;
            AdmsSensFadType vjv;
            //End of Block-local variables
            tmpv = 0.0;
            vjv = 0.0;
            h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
            h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
            h2d = (Vjun_s+(instanceVar_vch_s*h2));
            h3 = (instanceVar_vfmin_s+h2d);
            h4 = (instanceVar_vfmin_s-h2d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
              h5 = value_sqrt_0;
            }
            vjv = (2.0*((Vjun_s*instanceVar_vfmin_s)/(h3+h5)));
            if ((instanceVar_zflagbot_s>0.5))
            {
              if ((modelVar_one_minus_PBOT==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vjv*modelVar_vbiinvbot)));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1.0-(vjv*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
                  tmpv = value_pow_0;
                }
              }
              qjunbot_s = ((modelVar_qprefbot*(1.0-tmpv))+(modelVar_qpref2bot*(Vjun_s-vjv)));
            }
            if ((instanceVar_zflagsti_s>0.5))
            {
              if ((modelVar_one_minus_PSTI==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vjv*modelVar_vbiinvsti)));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1.0-(vjv*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
                  tmpv = value_pow_0;
                }
              }
              qjunsti_s = ((modelVar_qprefsti*(1.0-tmpv))+(modelVar_qpref2sti*(Vjun_s-vjv)));
            }
            if ((instanceVar_zflaggat_s>0.5))
            {
              if ((modelVar_one_minus_PGAT==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vjv*modelVar_vbiinvgat)));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1.0-(vjv*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
                  tmpv = value_pow_0;
                }
              }
              qjungat_s = ((modelVar_qprefgat*(1.0-tmpv))+(modelVar_qpref2gat*(Vjun_s-vjv)));
            }
            tmpv = 0.0;
            vjv = 0.0;
            h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
            h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
            h2d = (Vjun_d+(instanceVar_vch_d*h2));
            h3 = (instanceVar_vfmin_d+h2d);
            h4 = (instanceVar_vfmin_d-h2d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
              h5 = value_sqrt_0;
            }
            vjv = (2.0*((Vjun_d*instanceVar_vfmin_d)/(h3+h5)));
            if ((instanceVar_zflagbot_d>0.5))
            {
              if ((modelVar_one_minus_PBOT_d==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vjv*modelVar_vbiinvbot_d)));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1.0-(vjv*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
                  tmpv = value_pow_0;
                }
              }
              qjunbot_d = ((modelVar_qprefbot_d*(1.0-tmpv))+(modelVar_qpref2bot_d*(Vjun_d-vjv)));
            }
            if ((instanceVar_zflagsti_d>0.5))
            {
              if ((modelVar_one_minus_PSTI_d==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vjv*modelVar_vbiinvsti_d)));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1.0-(vjv*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
                  tmpv = value_pow_0;
                }
              }
              qjunsti_d = ((modelVar_qprefsti_d*(1.0-tmpv))+(modelVar_qpref2sti_d*(Vjun_d-vjv)));
            }
            if ((instanceVar_zflaggat_d>0.5))
            {
              if ((modelVar_one_minus_PGAT_d==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vjv*modelVar_vbiinvgat_d)));
                  tmpv = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1.0-(vjv*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
                  tmpv = value_pow_0;
                }
              }
              qjungat_d = ((modelVar_qprefgat_d*(1.0-tmpv))+(modelVar_qpref2gat_d*(Vjun_d-vjv)));
            }
          }
          // End block evaluateDynamic
        }
        else
        {
          vbbt = 0.0;
          two_psistar = 0.0;
          if ((!(((instanceVar_ABSOURCE_i==0.0)&&(instanceVar_LSSOURCE_i==0.0))&&(instanceVar_LGSOURCE_i==0.0))))
          {
            h1 = ((4.0*instanceVar_vch_s)*instanceVar_vch_s);
            h2 = (instanceVar_vch_s/instanceVar_vfmin_s);
            h2d = (Vjun_s+(instanceVar_vch_s*h2));
            h3 = (instanceVar_vfmin_s+h2d);
            h4 = (instanceVar_vfmin_s-h2d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
              h5 = value_sqrt_0;
            }
            vj = (2.0*((Vjun_s*instanceVar_vfmin_s)/(h3+h5)));
            if ((Vjun_s<instanceVar_VMAX_s))
            {
              if ((fabs((0.5*(Vjun_s*modelVar_phitdinv)))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp((0.5*(Vjun_s*modelVar_phitdinv)));
                  zinv = value_exp_0;
                }
              }
              else
              {
                if (((0.5*(Vjun_s*modelVar_phitdinv))<0.0))
                {
                  zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
                }
                else
                {
                  zinv = (1.0e100*(1.0+(((0.5*(Vjun_s*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_s*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              idmult = (zinv*zinv);
            }
            else
            {
              idmult = ((1.0+((Vjun_s-instanceVar_VMAX_s)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_s);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(idmult);
                zinv = value_sqrt_0;
              }
            }
            idmult = (idmult-1.0);
            z = (1.0/zinv);
            if ((Vjun_s>0.0))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
                AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
                two_psistar = (2.0*(modelVar_phitd*value_log_1));
              }
            }
            else
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
                AdmsSensFadType value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
                two_psistar = ((-Vjun_s)+(2.0*(modelVar_phitd*value_log_1)));
              }
            }
            vjlim = (instanceVar_vbimin_s-two_psistar);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((Vjun_s-vjlim)*(Vjun_s-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)));
              vjsrh = (0.5*((Vjun_s+vjlim)-value_sqrt_0));
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((Vjun_s-instanceVar_vbbtlim_s)*(Vjun_s-instanceVar_vbbtlim_s))+((4.0*modelVar_phitr)*modelVar_phitr)));
              vbbt = (0.5*((Vjun_s+instanceVar_vbbtlim_s)-value_sqrt_0));
            }
            {
              double value_sqrt_0 = sqrt((((Vjun_s)*(Vjun_s))+((4.0*1.0e-6)*1.0e-6)));
              vav = (0.5*((Vjun_s)-value_sqrt_0));
            }
          }
          if ((instanceVar_ABSOURCE_i==0.0))
          {
            ijunbot_s = 0.0;
            qjunbot_s = 0.0;
          }
          else
          {
            if ((modelVar_one_minus_PBOT==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvbot)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
                tmp = value_pow_0;
              }
            }
            qjunbot_s = ((modelVar_qprefbot*(1.0-tmp))+(modelVar_qpref2bot*(Vjun_s-vj)));
            id = (modelVar_idsatbot*idmult);
            if (((modelVar_CSRHBOT_i==0.0)&&(modelVar_CTATBOT_i==0.0)))
            {
              isrh = 0.0;
            }
            else
            {
              vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
                wsrhstep = (1.0-value_sqrt_0);
              }
              if ((modelVar_PBOT_i==0.5))
              {
                dwsrh = 0.0;
              }
              else
              {
                {
                  AdmsSensFadType value_log_0 = log(wsrhstep);
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOT_i)));
                }
              }
              wsrh = (wsrhstep+dwsrh);
              if ((modelVar_PBOT_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                  tmp = value_pow_0;
                }
              }
              wdep = (modelVar_wdepnulrbot*tmp);
              asrh = (modelVar_ftdbot*((zinv-1.0)*wdep));
              isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
            }
            if ((modelVar_CTATBOT_i==0.0))
            {
              itat = 0.0;
            }
            else
            {
              btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
              twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
                umax = value_sqrt_0;
              }
              {
                AdmsSensFadType value_fabs_0 = fabs(umax);
                AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
                sqrtumax = value_sqrt_1;
              }
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1.0)))
              {
                wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
                  wgamma = value_pow_0;
                }
              }
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                ktat = value_sqrt_0;
              }
              ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
              mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
              xerfc = ((ltat-1.0)*ktat);
              ysq = (xerfc*xerfc);
              if ((xerfc>0.0))
              {
                terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
              }
              else
              {
                terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }
              erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0.0))
              {
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp(mtat);
                    tmp = value_exp_0;
                  }
                }
                else
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }
                erfctimesexpmtat = ((2.0*tmp)-erfcpos);
              }
              gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
              itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
            }
            if ((modelVar_CBBTBOT_i==0.0))
            {
              ibbt = 0.0;
            }
            else
            {
              if ((modelVar_PBOT_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
                  tmp = value_pow_0;
                }
              }
              Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
              if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot)/Fmaxr));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-modelVar_fbbtbot)/Fmaxr)<0.0))
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {
                  tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              ibbt = (modelVar_CBBTBOT_i*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
            }
            if ((modelVar_VBRBOT_i>1.0e3))
            {
              fbreakdown = 1.0;
            }
            else
            {
              if ((vav>((-modelVar_alphaav)*modelVar_VBRBOT_i)))
              {
                if ((modelVar_PBRBOT_i==4.0))
                {
                  tmp = ((((vav*modelVar_VBRinvbot)*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot));
                }
                else
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot));
                    AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOT_i);
                    tmp = value_pow_1;
                  }
                }
                fbreakdown = (1.0/(1.0-tmp));
              }
              else
              {
                fbreakdown = (modelVar_fstopbot+((vav+(modelVar_alphaav*modelVar_VBRBOT_i))*modelVar_slopebot));
              }
            }
            ijunbot_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((instanceVar_LSSOURCE_i==0.0))
          {
            ijunsti_s = 0.0;
            qjunsti_s = 0.0;
          }
          else
          {
            if ((modelVar_one_minus_PSTI==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvsti)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
                tmp = value_pow_0;
              }
            }
            qjunsti_s = ((modelVar_qprefsti*(1.0-tmp))+(modelVar_qpref2sti*(Vjun_s-vj)));
            id = (modelVar_idsatsti*idmult);
            if (((modelVar_CSRHSTI_i==0.0)&&(modelVar_CTATSTI_i==0.0)))
            {
              isrh = 0.0;
            }
            else
            {
              vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
                wsrhstep = (1.0-value_sqrt_0);
              }
              if ((modelVar_PSTI_i==0.5))
              {
                dwsrh = 0.0;
              }
              else
              {
                {
                  AdmsSensFadType value_log_0 = log(wsrhstep);
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTI_i)));
                }
              }
              wsrh = (wsrhstep+dwsrh);
              if ((modelVar_PSTI_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                  tmp = value_pow_0;
                }
              }
              wdep = (modelVar_wdepnulrsti*tmp);
              asrh = (modelVar_ftdsti*((zinv-1.0)*wdep));
              isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
            }
            if ((modelVar_CTATSTI_i==0.0))
            {
              itat = 0.0;
            }
            else
            {
              btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
              twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
                umax = value_sqrt_0;
              }
              {
                AdmsSensFadType value_fabs_0 = fabs(umax);
                AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
                sqrtumax = value_sqrt_1;
              }
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1.0)))
              {
                wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
                  wgamma = value_pow_0;
                }
              }
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                ktat = value_sqrt_0;
              }
              ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
              mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
              xerfc = ((ltat-1.0)*ktat);
              ysq = (xerfc*xerfc);
              if ((xerfc>0.0))
              {
                terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
              }
              else
              {
                terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }
              erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0.0))
              {
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp(mtat);
                    tmp = value_exp_0;
                  }
                }
                else
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }
                erfctimesexpmtat = ((2.0*tmp)-erfcpos);
              }
              gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
              itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
            }
            if ((modelVar_CBBTSTI_i==0.0))
            {
              ibbt = 0.0;
            }
            else
            {
              if ((modelVar_PSTI_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
                  tmp = value_pow_0;
                }
              }
              Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
              if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti)/Fmaxr));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-modelVar_fbbtsti)/Fmaxr)<0.0))
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {
                  tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              ibbt = (modelVar_CBBTSTI_i*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
            }
            if ((modelVar_VBRSTI_i>1.0e3))
            {
              fbreakdown = 1.0;
            }
            else
            {
              if ((vav>((-modelVar_alphaav)*modelVar_VBRSTI_i)))
              {
                if ((modelVar_PBRSTI_i==4.0))
                {
                  tmp = ((((vav*modelVar_VBRinvsti)*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti));
                }
                else
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti));
                    AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTI_i);
                    tmp = value_pow_1;
                  }
                }
                fbreakdown = (1.0/(1.0-tmp));
              }
              else
              {
                fbreakdown = (modelVar_fstopsti+((vav+(modelVar_alphaav*modelVar_VBRSTI_i))*modelVar_slopesti));
              }
            }
            ijunsti_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((instanceVar_LGSOURCE_i==0.0))
          {
            ijungat_s = 0.0;
            qjungat_s = 0.0;
          }
          else
          {
            if ((modelVar_one_minus_PGAT==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvgat)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
                tmp = value_pow_0;
              }
            }
            qjungat_s = ((modelVar_qprefgat*(1.0-tmp))+(modelVar_qpref2gat*(Vjun_s-vj)));
            id = (modelVar_idsatgat*idmult);
            if (((modelVar_CSRHGAT_i==0.0)&&(modelVar_CTATGAT_i==0.0)))
            {
              isrh = 0.0;
            }
            else
            {
              vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
                wsrhstep = (1.0-value_sqrt_0);
              }
              if ((modelVar_PGAT_i==0.5))
              {
                dwsrh = 0.0;
              }
              else
              {
                {
                  AdmsSensFadType value_log_0 = log(wsrhstep);
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGAT_i)));
                }
              }
              wsrh = (wsrhstep+dwsrh);
              if ((modelVar_PGAT_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
                  tmp = value_pow_0;
                }
              }
              wdep = (modelVar_wdepnulrgat*tmp);
              asrh = (modelVar_ftdgat*((zinv-1.0)*wdep));
              isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
            }
            if ((modelVar_CTATGAT_i==0.0))
            {
              itat = 0.0;
            }
            else
            {
              btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
              twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
                umax = value_sqrt_0;
              }
              {
                AdmsSensFadType value_fabs_0 = fabs(umax);
                AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
                sqrtumax = value_sqrt_1;
              }
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1.0)))
              {
                wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
                  wgamma = value_pow_0;
                }
              }
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                ktat = value_sqrt_0;
              }
              ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
              mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
              xerfc = ((ltat-1.0)*ktat);
              ysq = (xerfc*xerfc);
              if ((xerfc>0.0))
              {
                terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
              }
              else
              {
                terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }
              erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0.0))
              {
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp(mtat);
                    tmp = value_exp_0;
                  }
                }
                else
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }
                erfctimesexpmtat = ((2.0*tmp)-erfcpos);
              }
              gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
              itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
            }
            if ((modelVar_CBBTGAT_i==0.0))
            {
              ibbt = 0.0;
            }
            else
            {
              if ((modelVar_PGAT_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
                  tmp = value_pow_0;
                }
              }
              Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
              if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat)/Fmaxr));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-modelVar_fbbtgat)/Fmaxr)<0.0))
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {
                  tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              ibbt = (modelVar_CBBTGAT_i*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
            }
            if ((modelVar_VBRGAT_i>1.0e3))
            {
              fbreakdown = 1.0;
            }
            else
            {
              if ((vav>((-modelVar_alphaav)*modelVar_VBRGAT_i)))
              {
                if ((modelVar_PBRGAT_i==4.0))
                {
                  tmp = ((((vav*modelVar_VBRinvgat)*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat));
                }
                else
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat));
                    AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGAT_i);
                    tmp = value_pow_1;
                  }
                }
                fbreakdown = (1.0/(1.0-tmp));
              }
              else
              {
                fbreakdown = (modelVar_fstopgat+((vav+(modelVar_alphaav*modelVar_VBRGAT_i))*modelVar_slopegat));
              }
            }
            ijungat_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          ijun_s = (((instanceVar_ABSOURCE_i*ijunbot_s)+(instanceVar_LSSOURCE_i*ijunsti_s))+(instanceVar_LGSOURCE_i*ijungat_s));
          vbbt = 0.0;
          two_psistar = 0.0;
          if ((!(((instanceVar_ABDRAIN_i==0.0)&&(instanceVar_LSDRAIN_i==0.0))&&(instanceVar_LGDRAIN_i==0.0))))
          {
            h1 = ((4.0*instanceVar_vch_d)*instanceVar_vch_d);
            h2 = (instanceVar_vch_d/instanceVar_vfmin_d);
            h2d = (Vjun_d+(instanceVar_vch_d*h2));
            h3 = (instanceVar_vfmin_d+h2d);
            h4 = (instanceVar_vfmin_d-h2d);
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((h4*h4)+h1));
              h5 = value_sqrt_0;
            }
            vj = (2.0*((Vjun_d*instanceVar_vfmin_d)/(h3+h5)));
            if ((Vjun_d<instanceVar_VMAX_d))
            {
              if ((fabs((0.5*(Vjun_d*modelVar_phitdinv)))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp((0.5*(Vjun_d*modelVar_phitdinv)));
                  zinv = value_exp_0;
                }
              }
              else
              {
                if (((0.5*(Vjun_d*modelVar_phitdinv))<0.0))
                {
                  zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
                }
                else
                {
                  zinv = (1.0e100*(1.0+(((0.5*(Vjun_d*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_d*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              idmult = (zinv*zinv);
            }
            else
            {
              idmult = ((1.0+((Vjun_d-instanceVar_VMAX_d)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd_d);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(idmult);
                zinv = value_sqrt_0;
              }
            }
            idmult = (idmult-1.0);
            z = (1.0/zinv);
            if ((Vjun_d>0.0))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
                AdmsSensFadType value_log_1 = log(((2.0+z)+value_sqrt_0));
                two_psistar = (2.0*(modelVar_phitd*value_log_1));
              }
            }
            else
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
                AdmsSensFadType value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
                two_psistar = ((-Vjun_d)+(2.0*(modelVar_phitd*value_log_1)));
              }
            }
            vjlim = (instanceVar_vbimin_d-two_psistar);
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((Vjun_d-vjlim)*(Vjun_d-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)));
              vjsrh = (0.5*((Vjun_d+vjlim)-value_sqrt_0));
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt((((Vjun_d-instanceVar_vbbtlim_d)*(Vjun_d-instanceVar_vbbtlim_d))+((4.0*modelVar_phitr)*modelVar_phitr)));
              vbbt = (0.5*((Vjun_d+instanceVar_vbbtlim_d)-value_sqrt_0));
            }
            {
              double value_sqrt_0 = sqrt((((Vjun_d)*(Vjun_d))+((4.0*1.0e-6)*1.0e-6)));
              vav = (0.5*((Vjun_d)-value_sqrt_0));
            }
          }
          if ((instanceVar_ABDRAIN_i==0.0))
          {
            ijunbot_d = 0.0;
            qjunbot_d = 0.0;
          }
          else
          {
            if ((modelVar_one_minus_PBOT_d==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvbot_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvbot_d)),modelVar_one_minus_PBOT_d);
                tmp = value_pow_0;
              }
            }
            qjunbot_d = ((modelVar_qprefbot_d*(1.0-tmp))+(modelVar_qpref2bot_d*(Vjun_d-vj)));
            id = (modelVar_idsatbot_d*idmult);
            if (((modelVar_CSRHBOTD_i==0.0)&&(modelVar_CTATBOTD_i==0.0)))
            {
              isrh = 0.0;
            }
            else
            {
              vbi_minus_vjsrh = (modelVar_vbibot_d-vjsrh);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
                wsrhstep = (1.0-value_sqrt_0);
              }
              if ((modelVar_PBOTD_i==0.5))
              {
                dwsrh = 0.0;
              }
              else
              {
                {
                  AdmsSensFadType value_log_0 = log(wsrhstep);
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOTD_i)));
                }
              }
              wsrh = (wsrhstep+dwsrh);
              if ((modelVar_PBOTD_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                  tmp = value_pow_0;
                }
              }
              wdep = (modelVar_wdepnulrbot_d*tmp);
              asrh = (modelVar_ftdbot_d*((zinv-1.0)*wdep));
              isrh = (modelVar_CSRHBOTD_i*(asrh*wsrh));
            }
            if ((modelVar_CTATBOTD_i==0.0))
            {
              itat = 0.0;
            }
            else
            {
              btat = (modelVar_btatpartbot_d*((wdep*modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
              twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot_d)/btat);
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
                umax = value_sqrt_0;
              }
              {
                AdmsSensFadType value_fabs_0 = fabs(umax);
                AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
                sqrtumax = value_sqrt_1;
              }
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d)==(-1.0)))
              {
                wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOTD_i)*modelVar_one_over_one_minus_PBOT_d));
                  wgamma = value_pow_0;
                }
              }
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                ktat = value_sqrt_0;
              }
              ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
              mtat = ((((modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
              xerfc = ((ltat-1.0)*ktat);
              ysq = (xerfc*xerfc);
              if ((xerfc>0.0))
              {
                terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
              }
              else
              {
                terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }
              erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0.0))
              {
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp(mtat);
                    tmp = value_exp_0;
                  }
                }
                else
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }
                erfctimesexpmtat = ((2.0*tmp)-erfcpos);
              }
              gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot_d*erfctimesexpmtat)/ktat));
              itat = (modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
            }
            if ((modelVar_CBBTBOTD_i==0.0))
            {
              ibbt = 0.0;
            }
            else
            {
              if ((modelVar_PBOTD_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRBOTD_i-vbbt)*modelVar_VBIRBOTinv_d),modelVar_PBOTD_i);
                  tmp = value_pow_0;
                }
              }
              Fmaxr = (modelVar_one_over_one_minus_PBOT_d*(((modelVar_VBIRBOTD_i-vbbt)*modelVar_wdepnulrinvbot_d)/tmp));
              if ((fabs(((-modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtbot_d)/Fmaxr));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-modelVar_fbbtbot_d)/Fmaxr)<0.0))
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {
                  tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              ibbt = (modelVar_CBBTBOTD_i*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
            }
            if ((modelVar_VBRBOTD_i>1.0e3))
            {
              fbreakdown = 1.0;
            }
            else
            {
              if ((vav>((-modelVar_alphaav)*modelVar_VBRBOTD_i)))
              {
                if ((modelVar_PBRBOTD_i==4.0))
                {
                  tmp = ((((vav*modelVar_VBRinvbot_d)*(vav*modelVar_VBRinvbot_d))*(vav*modelVar_VBRinvbot_d))*(vav*modelVar_VBRinvbot_d));
                }
                else
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvbot_d));
                    AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRBOTD_i);
                    tmp = value_pow_1;
                  }
                }
                fbreakdown = (1.0/(1.0-tmp));
              }
              else
              {
                fbreakdown = (modelVar_fstopbot_d+((vav+(modelVar_alphaav*modelVar_VBRBOTD_i))*modelVar_slopebot_d));
              }
            }
            ijunbot_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((instanceVar_LSDRAIN_i==0.0))
          {
            ijunsti_d = 0.0;
            qjunsti_d = 0.0;
          }
          else
          {
            if ((modelVar_one_minus_PSTI_d==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvsti_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvsti_d)),modelVar_one_minus_PSTI_d);
                tmp = value_pow_0;
              }
            }
            qjunsti_d = ((modelVar_qprefsti_d*(1.0-tmp))+(modelVar_qpref2sti_d*(Vjun_d-vj)));
            id = (modelVar_idsatsti_d*idmult);
            if (((modelVar_CSRHSTID_i==0.0)&&(modelVar_CTATSTID_i==0.0)))
            {
              isrh = 0.0;
            }
            else
            {
              vbi_minus_vjsrh = (modelVar_vbisti_d-vjsrh);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
                wsrhstep = (1.0-value_sqrt_0);
              }
              if ((modelVar_PSTID_i==0.5))
              {
                dwsrh = 0.0;
              }
              else
              {
                {
                  AdmsSensFadType value_log_0 = log(wsrhstep);
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTID_i)));
                }
              }
              wsrh = (wsrhstep+dwsrh);
              if ((modelVar_PSTID_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                  tmp = value_pow_0;
                }
              }
              wdep = (modelVar_wdepnulrsti_d*tmp);
              asrh = (modelVar_ftdsti_d*((zinv-1.0)*wdep));
              isrh = (modelVar_CSRHSTID_i*(asrh*wsrh));
            }
            if ((modelVar_CTATSTID_i==0.0))
            {
              itat = 0.0;
            }
            else
            {
              btat = (modelVar_btatpartsti_d*((wdep*modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
              twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti_d)/btat);
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
                umax = value_sqrt_0;
              }
              {
                AdmsSensFadType value_fabs_0 = fabs(umax);
                AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
                sqrtumax = value_sqrt_1;
              }
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d)==(-1.0)))
              {
                wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTID_i)*modelVar_one_over_one_minus_PSTI_d));
                  wgamma = value_pow_0;
                }
              }
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                ktat = value_sqrt_0;
              }
              ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
              mtat = ((((modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
              xerfc = ((ltat-1.0)*ktat);
              ysq = (xerfc*xerfc);
              if ((xerfc>0.0))
              {
                terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
              }
              else
              {
                terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }
              erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0.0))
              {
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp(mtat);
                    tmp = value_exp_0;
                  }
                }
                else
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }
                erfctimesexpmtat = ((2.0*tmp)-erfcpos);
              }
              gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti_d*erfctimesexpmtat)/ktat));
              itat = (modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
            }
            if ((modelVar_CBBTSTID_i==0.0))
            {
              ibbt = 0.0;
            }
            else
            {
              if ((modelVar_PSTID_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRSTID_i-vbbt)*modelVar_VBIRSTIinv_d),modelVar_PSTID_i);
                  tmp = value_pow_0;
                }
              }
              Fmaxr = (modelVar_one_over_one_minus_PSTI_d*(((modelVar_VBIRSTID_i-vbbt)*modelVar_wdepnulrinvsti_d)/tmp));
              if ((fabs(((-modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtsti_d)/Fmaxr));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-modelVar_fbbtsti_d)/Fmaxr)<0.0))
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {
                  tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              ibbt = (modelVar_CBBTSTID_i*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
            }
            if ((modelVar_VBRSTID_i>1.0e3))
            {
              fbreakdown = 1.0;
            }
            else
            {
              if ((vav>((-modelVar_alphaav)*modelVar_VBRSTID_i)))
              {
                if ((modelVar_PBRSTID_i==4.0))
                {
                  tmp = ((((vav*modelVar_VBRinvsti_d)*(vav*modelVar_VBRinvsti_d))*(vav*modelVar_VBRinvsti_d))*(vav*modelVar_VBRinvsti_d));
                }
                else
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvsti_d));
                    AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRSTID_i);
                    tmp = value_pow_1;
                  }
                }
                fbreakdown = (1.0/(1.0-tmp));
              }
              else
              {
                fbreakdown = (modelVar_fstopsti_d+((vav+(modelVar_alphaav*modelVar_VBRSTID_i))*modelVar_slopesti_d));
              }
            }
            ijunsti_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          if ((instanceVar_LGDRAIN_i==0.0))
          {
            ijungat_d = 0.0;
            qjungat_d = 0.0;
          }
          else
          {
            if ((modelVar_one_minus_PGAT_d==0.5))
            {
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(vj*modelVar_vbiinvgat_d)));
                tmp = value_sqrt_0;
              }
            }
            else
            {
              {
                AdmsSensFadType value_pow_0 = pow((1.0-(vj*modelVar_vbiinvgat_d)),modelVar_one_minus_PGAT_d);
                tmp = value_pow_0;
              }
            }
            qjungat_d = ((modelVar_qprefgat_d*(1.0-tmp))+(modelVar_qpref2gat_d*(Vjun_d-vj)));
            id = (modelVar_idsatgat_d*idmult);
            if (((modelVar_CSRHGATD_i==0.0)&&(modelVar_CTATGATD_i==0.0)))
            {
              isrh = 0.0;
            }
            else
            {
              vbi_minus_vjsrh = (modelVar_vbigat_d-vjsrh);
              {
                AdmsSensFadType value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
                wsrhstep = (1.0-value_sqrt_0);
              }
              if ((modelVar_PGATD_i==0.5))
              {
                dwsrh = 0.0;
              }
              else
              {
                {
                  AdmsSensFadType value_log_0 = log(wsrhstep);
                  dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGATD_i)));
                }
              }
              wsrh = (wsrhstep+dwsrh);
              if ((modelVar_PGATD_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv_d));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                  tmp = value_pow_0;
                }
              }
              wdep = (modelVar_wdepnulrgat_d*tmp);
              asrh = (modelVar_ftdgat_d*((zinv-1.0)*wdep));
              isrh = (modelVar_CSRHGATD_i*(asrh*wsrh));
            }
            if ((modelVar_CTATGATD_i==0.0))
            {
              itat = 0.0;
            }
            else
            {
              btat = (modelVar_btatpartgat_d*((wdep*modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
              twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat_d)/btat);
              umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
              {
                AdmsSensFadType value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
                umax = value_sqrt_0;
              }
              {
                AdmsSensFadType value_fabs_0 = fabs(umax);
                AdmsSensFadType value_sqrt_1 = sqrt(value_fabs_0);
                sqrtumax = value_sqrt_1;
              }
              umaxpoweronepointfive = (umax*sqrtumax);
              if ((((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d)==(-1.0)))
              {
                wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGATD_i)*modelVar_one_over_one_minus_PGAT_d));
                  wgamma = value_pow_0;
                }
              }
              wtat = ((wsrh*wgamma)/(wsrh+wgamma));
              {
                AdmsSensFadType value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
                ktat = value_sqrt_0;
              }
              ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
              mtat = ((((modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
              xerfc = ((ltat-1.0)*ktat);
              ysq = (xerfc*xerfc);
              if ((xerfc>0.0))
              {
                terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
              }
              else
              {
                terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
              }
              if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-ysq)+mtat));
                  tmp = value_exp_0;
                }
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
              }
              erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
              if ((xerfc>0.0))
              {
                erfctimesexpmtat = erfcpos;
              }
              else
              {
                if ((mtat>(-2.3025850929940458e+02)))
                {
                  {
                    AdmsSensFadType value_exp_0 = exp(mtat);
                    tmp = value_exp_0;
                  }
                }
                else
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
                }
                erfctimesexpmtat = ((2.0*tmp)-erfcpos);
              }
              gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat_d*erfctimesexpmtat)/ktat));
              itat = (modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
            }
            if ((modelVar_CBBTGATD_i==0.0))
            {
              ibbt = 0.0;
            }
            else
            {
              if ((modelVar_PGATD_i==0.5))
              {
                {
                  AdmsSensFadType value_sqrt_0 = sqrt(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d));
                  tmp = value_sqrt_0;
                }
              }
              else
              {
                {
                  AdmsSensFadType value_pow_0 = pow(((modelVar_VBIRGATD_i-vbbt)*modelVar_VBIRGATinv_d),modelVar_PGATD_i);
                  tmp = value_pow_0;
                }
              }
              Fmaxr = (modelVar_one_over_one_minus_PGAT_d*(((modelVar_VBIRGATD_i-vbbt)*modelVar_wdepnulrinvgat_d)/tmp));
              if ((fabs(((-modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
              {
                {
                  AdmsSensFadType value_exp_0 = exp(((-modelVar_fbbtgat_d)/Fmaxr));
                  tmp = value_exp_0;
                }
              }
              else
              {
                if ((((-modelVar_fbbtgat_d)/Fmaxr)<0.0))
                {
                  tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
                }
                else
                {
                  tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
                }
              }
              ibbt = (modelVar_CBBTGATD_i*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
            }
            if ((modelVar_VBRGATD_i>1.0e3))
            {
              fbreakdown = 1.0;
            }
            else
            {
              if ((vav>((-modelVar_alphaav)*modelVar_VBRGATD_i)))
              {
                if ((modelVar_PBRGATD_i==4.0))
                {
                  tmp = ((((vav*modelVar_VBRinvgat_d)*(vav*modelVar_VBRinvgat_d))*(vav*modelVar_VBRinvgat_d))*(vav*modelVar_VBRinvgat_d));
                }
                else
                {
                  {
                    AdmsSensFadType value_fabs_0 = fabs((vav*modelVar_VBRinvgat_d));
                    AdmsSensFadType value_pow_1 = pow(value_fabs_0,modelVar_PBRGATD_i);
                    tmp = value_pow_1;
                  }
                }
                fbreakdown = (1.0/(1.0-tmp));
              }
              else
              {
                fbreakdown = (modelVar_fstopgat_d+((vav+(modelVar_alphaav*modelVar_VBRGATD_i))*modelVar_slopegat_d));
              }
            }
            ijungat_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
          }
          ijun_d = (((instanceVar_ABDRAIN_i*ijunbot_d)+(instanceVar_LSDRAIN_i*ijunsti_d))+(instanceVar_LGDRAIN_i*ijungat_d));
        }
      }
      rgatenoise = (modelVar_nt0*instanceVar_ggate);
      rsourcenoise = (modelVar_nt0*instanceVar_gsource);
      rdrainnoise = (modelVar_nt0*instanceVar_gdrain);
      rbulknoise = (modelVar_nt0*instanceVar_gbulk);
      rjunsnoise = (modelVar_nt0*instanceVar_gjuns);
      rjundnoise = (modelVar_nt0*instanceVar_gjund);
      rwellnoise = (modelVar_nt0*instanceVar_gwell);
    }
    // End block evaluateStaticDynamic
    //Begin block loadStatic
    {
      if ((sigVds>0.0))
      {
        // I(DI,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
        staticContributions[admsNodeID_DI] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Iimpact);
        staticContributions[admsNodeID_BP] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Iimpact);
        // I(DI,SI) <+ (((CHNL_TYPE*MULT_i)*(Ids+Idsedge)))
        staticContributions[admsNodeID_DI] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*(Ids+Idsedge));
        staticContributions[admsNodeID_SI] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*(Ids+Idsedge));
        // I(GP,SI) <+ (((CHNL_TYPE*MULT_i)*Igcs))
        staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcs);
        staticContributions[admsNodeID_SI] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcs);
        // I(GP,DI) <+ (((CHNL_TYPE*MULT_i)*Igcd))
        staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcd);
        staticContributions[admsNodeID_DI] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcd);
      }
      else
      {
        // I(SI,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
        staticContributions[admsNodeID_SI] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Iimpact);
        staticContributions[admsNodeID_BP] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Iimpact);
        // I(SI,DI) <+ (((CHNL_TYPE*MULT_i)*(Ids+Idsedge)))
        staticContributions[admsNodeID_SI] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*(Ids+Idsedge));
        staticContributions[admsNodeID_DI] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*(Ids+Idsedge));
        // I(GP,DI) <+ (((CHNL_TYPE*MULT_i)*Igcs))
        staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcs);
        staticContributions[admsNodeID_DI] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcs);
        // I(GP,SI) <+ (((CHNL_TYPE*MULT_i)*Igcd))
        staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcd);
        staticContributions[admsNodeID_SI] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igcd);
      }
      // I(GP,BP) <+ (((CHNL_TYPE*MULT_i)*Igb))
      staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igb);
      staticContributions[admsNodeID_BP] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igb);
      // I(GP,SI) <+ (((CHNL_TYPE*MULT_i)*Igsov))
      staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igsov);
      staticContributions[admsNodeID_SI] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igsov);
      // I(GP,DI) <+ (((CHNL_TYPE*MULT_i)*Igdov))
      staticContributions[admsNodeID_GP] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igdov);
      staticContributions[admsNodeID_DI] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igdov);
      // I(SI,BP) <+ (((CHNL_TYPE*MULT_i)*Igisl))
      staticContributions[admsNodeID_SI] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igisl);
      staticContributions[admsNodeID_BP] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igisl);
      // I(DI,BP) <+ (((CHNL_TYPE*MULT_i)*Igidl))
      staticContributions[admsNodeID_DI] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igidl);
      staticContributions[admsNodeID_BP] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Igidl);
      // I(BS,SI) <+ (((CHNL_TYPE*MULT_i)*ijun_s))
      staticContributions[admsNodeID_BS] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*ijun_s);
      staticContributions[admsNodeID_SI] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*ijun_s);
      // I(BD,DI) <+ (((CHNL_TYPE*MULT_i)*ijun_d))
      staticContributions[admsNodeID_BD] += ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*ijun_d);
      staticContributions[admsNodeID_DI] -= ((modelVar_CHNL_TYPE*instanceVar_MULT_i)*ijun_d);
      if ((instanceVar_RG_i>0.0))
      {
        // I(G,GP) <+ (((MULT_i*ggate)*V(G,GP)))
        staticContributions[admsNodeID_G] += ((instanceVar_MULT_i*instanceVar_ggate)*(probeVars[admsProbeID_V_G_GP]));
        staticContributions[admsNodeID_GP] -= ((instanceVar_MULT_i*instanceVar_ggate)*(probeVars[admsProbeID_V_G_GP]));
        // I(G,GP) <+ (white_noise((MULT_i*rgatenoise),"rgate"))
      }
      else
      {
        // V(G,GP) <+ (0.0)
        // do nothing at all
      }
      if ((instanceVar_RSE_i>0.0))
      {
        // I(S,SI) <+ (((MULT_i*gsource)*V(S,SI)))
        staticContributions[admsNodeID_S] += ((instanceVar_MULT_i*instanceVar_gsource)*(probeVars[admsProbeID_V_S_SI]));
        staticContributions[admsNodeID_SI] -= ((instanceVar_MULT_i*instanceVar_gsource)*(probeVars[admsProbeID_V_S_SI]));
        // I(S,SI) <+ (white_noise((MULT_i*rsourcenoise),"rsource"))
      }
      else
      {
        // V(S,SI) <+ (0.0)
        // do nothing at all
      }
      if ((instanceVar_RDE_i>0.0))
      {
        // I(D,DI) <+ (((MULT_i*gdrain)*V(D,DI)))
        staticContributions[admsNodeID_D] += ((instanceVar_MULT_i*instanceVar_gdrain)*(probeVars[admsProbeID_V_D_DI]));
        staticContributions[admsNodeID_DI] -= ((instanceVar_MULT_i*instanceVar_gdrain)*(probeVars[admsProbeID_V_D_DI]));
        // I(D,DI) <+ (white_noise((MULT_i*rdrainnoise),"rdrain"))
      }
      else
      {
        // V(D,DI) <+ (0.0)
        // do nothing at all
      }
      if ((instanceVar_RBULK_i>0.0))
      {
        // I(BP,BI) <+ (((MULT_i*gbulk)*V(BP,BI)))
        staticContributions[admsNodeID_BP] += ((instanceVar_MULT_i*instanceVar_gbulk)*(probeVars[admsProbeID_V_BP_BI]));
        staticContributions[admsNodeID_BI] -= ((instanceVar_MULT_i*instanceVar_gbulk)*(probeVars[admsProbeID_V_BP_BI]));
        // I(BP,BI) <+ (white_noise((MULT_i*rbulknoise),"rbulk"))
      }
      else
      {
        // V(BP,BI) <+ (0.0)
        // do nothing at all
      }
      if ((instanceVar_RJUNS_i>0.0))
      {
        // I(BS,BI) <+ (((MULT_i*gjuns)*V(BS,BI)))
        staticContributions[admsNodeID_BS] += ((instanceVar_MULT_i*instanceVar_gjuns)*(probeVars[admsProbeID_V_BS_BI]));
        staticContributions[admsNodeID_BI] -= ((instanceVar_MULT_i*instanceVar_gjuns)*(probeVars[admsProbeID_V_BS_BI]));
        // I(BS,BI) <+ (white_noise((MULT_i*rjunsnoise),"rjuns"))
      }
      else
      {
        // V(BS,BI) <+ (0.0)
        // do nothing at all
      }
      if ((instanceVar_RJUND_i>0.0))
      {
        // I(BD,BI) <+ (((MULT_i*gjund)*V(BD,BI)))
        staticContributions[admsNodeID_BD] += ((instanceVar_MULT_i*instanceVar_gjund)*(probeVars[admsProbeID_V_BD_BI]));
        staticContributions[admsNodeID_BI] -= ((instanceVar_MULT_i*instanceVar_gjund)*(probeVars[admsProbeID_V_BD_BI]));
        // I(BD,BI) <+ (white_noise((MULT_i*rjundnoise),"rjund"))
      }
      else
      {
        // V(BD,BI) <+ (0.0)
        // do nothing at all
      }
      if ((instanceVar_RWELL_i>0.0))
      {
        // I(B,BI) <+ (((MULT_i*gwell)*V(B,BI)))
        staticContributions[admsNodeID_B] += ((instanceVar_MULT_i*instanceVar_gwell)*(probeVars[admsProbeID_V_B_BI]));
        staticContributions[admsNodeID_BI] -= ((instanceVar_MULT_i*instanceVar_gwell)*(probeVars[admsProbeID_V_B_BI]));
        // I(B,BI) <+ (white_noise((MULT_i*rwellnoise),"rwell"))
      }
      else
      {
        // V(B,BI) <+ (0.0)
        // do nothing at all
      }
      // I(DI,SI) <+ ((1E-15*V(DI,SI)))
      staticContributions[admsNodeID_DI] += (1E-15*(probeVars[admsProbeID_V_DI_SI]));
      staticContributions[admsNodeID_SI] -= (1E-15*(probeVars[admsProbeID_V_DI_SI]));
    }
    // End block loadStatic
    //Begin block loadStaticDynamic
    {
    }
    // End block loadStaticDynamic
    //Begin block loadDynamic
    {
      //Block-local variables for block loadDynamic
      AdmsSensFadType temp;
      //End of Block-local variables
      Qs = (-((Qg+Qb)+Qd));
      Qfgs = (Qfgs+Qgs_ov);
      Qfgd = (Qfgd+Qgd_ov);
      qjun_s = (((instanceVar_ABSOURCE_i*qjunbot_s)+(instanceVar_LSSOURCE_i*qjunsti_s))+(instanceVar_LGSOURCE_i*qjungat_s));
      qjun_d = (((instanceVar_ABDRAIN_i*qjunbot_d)+(instanceVar_LSDRAIN_i*qjunsti_d))+(instanceVar_LGDRAIN_i*qjungat_d));
      if ((sigVds<0.0))
      {
        temp = Qd;
        Qd = Qs;
        Qs = temp;
      }
      // I(GP,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qg)))
      dynamicContributions[admsNodeID_GP] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qg));
      dynamicContributions[admsNodeID_SI] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qg));
      // I(BP,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qb)))
      dynamicContributions[admsNodeID_BP] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qb));
      dynamicContributions[admsNodeID_SI] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qb));
      // I(DI,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qd)))
      dynamicContributions[admsNodeID_DI] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qd));
      dynamicContributions[admsNodeID_SI] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qd));
      // I(GP,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgs)))
      dynamicContributions[admsNodeID_GP] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qfgs));
      dynamicContributions[admsNodeID_SI] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qfgs));
      // I(GP,DI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgd)))
      dynamicContributions[admsNodeID_GP] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qfgd));
      dynamicContributions[admsNodeID_DI] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qfgd));
      // I(GP,BP) <+ (ddt(((CHNL_TYPE*MULT_i)*Qgb_ov)))
      dynamicContributions[admsNodeID_GP] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qgb_ov));
      dynamicContributions[admsNodeID_BP] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*Qgb_ov));
      // I(BS,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_s)))
      dynamicContributions[admsNodeID_BS] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*qjun_s));
      dynamicContributions[admsNodeID_SI] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*qjun_s));
      // I(BD,DI) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_d)))
      dynamicContributions[admsNodeID_BD] += (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*qjun_d));
      dynamicContributions[admsNodeID_DI] -= (((modelVar_CHNL_TYPE*instanceVar_MULT_i)*qjun_d));
    }
    // End block loadDynamic
    //Begin block noise
    {
      //Block-local variables for block noise
      AdmsSensFadType sf;
      //End of Block-local variables
      Sfl = 0.0;
      Sidexc = 0.0;
      mid = 0.0;
      mig = 1.0e-40;
      migid = 0.0;
      c_igid = 0.0;
      CGeff = (COX_qm*eta_p_ac);
      sqid = 0.0;
      sqig = 0.0;
      Sfledge = 0.0;
      midedge = 0.0;
      sqidedge = 0.0;
      if ((((xg_dc>0.0)&&(instanceVar_MULT_i>0.0))&&(instanceVar_BET_i>0.0)))
      {
        N1 = ((instanceVar_Cox_over_q*alpha_dc)*modelVar_phit);
        Nm1 = (instanceVar_Cox_over_q*qim1_dc);
        Delta_N1 = ((instanceVar_Cox_over_q*alpha_dc)*dps_dc);
        {
          AdmsSensFadType value_log_0 = log(((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));
          Sfl = (((instanceVar_NFA_i-(instanceVar_NFB_i*N1))+(instanceVar_NFC_i*(N1*N1)))*value_log_0);
        }
        Sfl = (Sfl+((instanceVar_NFB_i+(instanceVar_NFC_i*(Nm1-(2.0*N1))))*Delta_N1));
        Sfl = ((((instanceVar_Sfl_prefac*Ids)*Gvsatinv_dc)*Sfl)/N1);
        Sfl = adms_ternary_op<AdmsSensFadType>((Sfl>0.0),Sfl,0.0);
        H0 = (qim1_dc/alpha_dc);
        t1 = (qim_dc/qim1_dc);
        sqt2 = ((0.5*1.6666666666666667e-01)*(dps_dc/H0));
        t2 = (sqt2*sqt2);
        r = ((H0/H_dc)-1.0);
        lc = adms_ternary_op<AdmsSensFadType>(((1.0-(12.0*(r*t2)))>1.0e-20),(1.0-(12.0*(r*t2))),1.0e-20);
        lcinv2 = (1.0/(lc*lc));
        g_ideal = (instanceVar_BET_i*((FdL_dc*qim1_dc)*Gvsatinv_dc));
        mid = ((t1+(12.0*t2))-(24.0*(((1.0+t1)*t2)*r)));
        mid = adms_ternary_op<AdmsSensFadType>((mid>1.0e-40),mid,1.0e-40);
        mid = ((g_ideal*lcinv2)*mid);
        if ((instanceVar_FNTEXC_i>0.0))
        {
          temp2_exc = (qim_dc*xitsb_dc);
          wsat_exc = (100.0*(temp2_exc/(100.0+temp2_exc)));
          if ((instanceVar_THESATG_i<0))
          {
            temp_exc = (1.0/(1.0-(instanceVar_THESATG_i*wsat_exc)));
          }
          else
          {
            temp_exc = (1.0+(instanceVar_THESATG_i*wsat_exc));
          }
          thesat1_exc = (instanceVar_THESAT_T*(temp_exc/Gmob_dc));
          zsat_exc = (((thesat1_exc*thesat1_exc)*dps_dc)*dps_dc);
          if ((modelVar_CHNL_TYPE==(-1)))
          {
            zsat_exc = (zsat_exc/(1.0+(thesat1_exc*dps_dc)));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((1.0+(2.0*zsat_exc)));
            Gvsat_exc = (0.5*(Gmob_dc*(1.0+value_sqrt_0)));
          }
          gfac = (Gmob_dc/(Gvsat_exc*lc));
          Sidexc = ((((instanceVar_fac_exc*Ids)*Vdse_dc)*gfac)*gfac);
          mid = (mid+(Sidexc/modelVar_nt0));
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt((instanceVar_nt*mid));
          sqid = value_sqrt_0;
        }
        if ((modelVar_SWIGN_i==1))
        {
          mig = (((t1/12.0)-(t2*((t1+0.2)-(12.0*t2))))-(1.6*((t2*((t1+1.0)-(12.0*t2)))*r)));
          mig = adms_ternary_op<AdmsSensFadType>((mig>1.0e-40),mig,1.0e-40);
          mig = ((lcinv2/g_ideal)*mig);
          migid = ((lcinv2*sqt2)*((1.0-(12.0*t2))-(((t1+(19.2*t2))-(12.0*(t1*t2)))*r)));
          CGeff = ((((Gvsat_ac*Gvsat_ac)*COX_qm)*eta_p_ac)/(Gmob_dL_ac*Gmob_dL_ac));
          if ((instanceVar_FNTEXC_i>0.0))
          {
            mig = (mig+((Sidexc*(1.0+(12.0*t2)))/(((12.0*g_ideal)*g_ideal)*modelVar_nt0)));
            migid = (migid-(((Sidexc*sqt2)*(1.0+r))/(g_ideal*modelVar_nt0)));
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((instanceVar_nt/mig));
            sqig = value_sqrt_0;
          }
          if ((sqid==0))
          {
            c_igid = 0.0;
          }
          else
          {
            c_igid = ((migid*sqig)/sqid);
          }
          c_igid = adms_ternary_op<AdmsSensFadType>((c_igid>0.0),adms_ternary_op<AdmsSensFadType>((c_igid<1.0),c_igid,1.0),0.0);
        }
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(Igcs);
        shot_igcsx = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(Igcd);
        shot_igcdx = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(Igsov);
        shot_igsov = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(Igdov);
        shot_igdov = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(Iimpact);
        shot_iavl = ((2.0*1.6021918E-19)*((mavl+1)*value_fabs_0));
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(ijun_s);
        jnoisex_s = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      {
        AdmsSensFadType value_fabs_0 = fabs(ijun_d);
        jnoisex_d = ((2.0*1.6021918E-19)*value_fabs_0);
      }
      if ((sigVds>0.0))
      {
        shot_igs = (shot_igcsx+shot_igsov);
        shot_igd = (shot_igcdx+shot_igdov);
        jnoise_s = jnoisex_s;
        jnoise_d = (jnoisex_d+shot_iavl);
      }
      else
      {
        shot_igs = (shot_igcdx+shot_igsov);
        shot_igd = (shot_igcsx+shot_igdov);
        jnoise_s = (jnoisex_s+shot_iavl);
        jnoise_d = jnoisex_d;
      }
      if ((((modelVar_SWEDGE_i!=0.0)&&(instanceVar_BETNEDGE_i>0))&&(xgedge>0)))
      {
        temp1 = ((4.0*dsqredge)/instanceVar_Gfedge2);
        {
          AdmsSensFadType value_sqrt_0 = sqrt((temp1+1.0));
          AdmsSensFadType value_sqrt_1 = sqrt((temp1+1.1));
          anoisedge = (value_sqrt_0/(value_sqrt_1-1.0));
        }
        temp1 = (instanceVar_Cox_over_q*modelVar_phit);
        N1edge = (temp1*anoisedge);
        Nm1edge = (temp1*(qmeffedge+anoisedge));
        Delta_N1edge = ((((-temp1)*anoisedge)*alphabmedge)*qdseffedge);
        {
          AdmsSensFadType value_log_0 = log(((Nm1edge+(0.5*Delta_N1edge))/(Nm1edge-(0.5*Delta_N1edge))));
          Sfledge = ((instanceVar_NFAEDGE_i-((instanceVar_NFBEDGE_i-(instanceVar_NFCEDGE_i*N1edge))*N1edge))*value_log_0);
        }
        Sfledge = (Sfledge+((instanceVar_NFBEDGE_i+(instanceVar_NFCEDGE_i*(Nm1edge-(2.0*N1edge))))*Delta_N1edge));
        Sfledge = ((((instanceVar_Sfl_prefac_edge*Idsedge)*Gvsatinv_dc)*Sfledge)/N1edge);
        Sfledge = adms_ternary_op<AdmsSensFadType>((Sfledge>0.0),Sfledge,0.0);
        H0edge = ((modelVar_phit*(qmeffedge+anoisedge))/anoisedge);
        t1edge = (((phit1/modelVar_phit)*qmeffedge)/(qmeffedge+anoisedge));
        sqt2edge = ((((((-0.5)*1.6666666666666667e-01)*modelVar_phit)*alphabmedge)*qdseffedge)/H0edge);
        t2edge = (sqt2edge*sqt2edge);
        redge = ((((anoisedge/alpha_dc)*H0edge)/H_dc)-1.0);
        lcedge = adms_ternary_op<AdmsSensFadType>(((1.0-(12.0*(redge*t2edge)))>1.0e-20),(1.0-(12.0*(redge*t2edge))),1.0e-20);
        lcinv2edge = (1.0/(lcedge*lcedge));
        g_idealedge = ((((instanceVar_BETEDGE_i*modelVar_phit)*(qmeffedge+anoisedge))*FdL_dc)*Gvsatinv_dc);
        midedge = ((t1edge+(12.0*t2edge))-(24.0*(((1.0+t1edge)*t2edge)*redge)));
        midedge = adms_ternary_op<AdmsSensFadType>((midedge>1.0e-40),midedge,1.0e-40);
        midedge = ((g_idealedge*lcinv2edge)*midedge);
        {
          AdmsSensFadType value_sqrt_0 = sqrt((instanceVar_ntedge*midedge));
          sqidedge = value_sqrt_0;
        }
      }
      sf = ((1.0e+6*CGeff)*mig);
      // I(NOI2,GND) <+ (V(NOI2,GND))
      staticContributions[admsNodeID_NOI2] += (probeVars[admsProbeID_V_NOI2_GND]);
      // I(NOI2,GND) <+ (white_noise((((nt/mig)*sf)*sf),"igig"))
      // I(NOI,GND) <+ (((-V(NOI2,GND))/sf))
      staticContributions[admsNodeID_NOI] += ((-(probeVars[admsProbeID_V_NOI2_GND]))/sf);
      // I(NOI,GND) <+ ((V(NOI,GND)/mig))
      staticContributions[admsNodeID_NOI] += ((probeVars[admsProbeID_V_NOI_GND])/mig);
      // I(NOI,GND) <+ (ddt((CGeff*V(NOI,GND))))
      dynamicContributions[admsNodeID_NOI] += ((CGeff*(probeVars[admsProbeID_V_NOI_GND])));
      // I(GP,SI) <+ ((-ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND)))))
      {
        AdmsSensFadType value_sqrt_0 = sqrt(instanceVar_MULT_i);
        dynamicContributions[admsNodeID_GP] += (-((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND]))));
        dynamicContributions[admsNodeID_SI] -= (-((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND]))));
      }
      // I(GP,DI) <+ ((-ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND)))))
      {
        AdmsSensFadType value_sqrt_0 = sqrt(instanceVar_MULT_i);
        dynamicContributions[admsNodeID_GP] += (-((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND]))));
        dynamicContributions[admsNodeID_DI] -= (-((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND]))));
      }
      // I(DI,SI) <+ (((((sigVds*sqrt(MULT_i))*migid)*V(NOI2,GND))/sf))
      {
        AdmsSensFadType value_sqrt_0 = sqrt(instanceVar_MULT_i);
        staticContributions[admsNodeID_DI] += ((((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))/sf);
        staticContributions[admsNodeID_SI] -= ((((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))/sf);
      }
      // I(DI,SI) <+ (white_noise((((MULT_i*sqid)*sqid)*(1.0-(c_igid*c_igid))),"idid"))
      // I(DI,SI) <+ (flicker_noise((MULT_i*Sfl),EF_i,"flicker"))
      // I(GP,SI) <+ (white_noise((MULT_i*shot_igs),"igs"))
      // I(GP,DI) <+ (white_noise((MULT_i*shot_igd),"igd"))
      // I(BS,SI) <+ (white_noise((MULT_i*jnoise_s),"ibs"))
      // I(BD,DI) <+ (white_noise((MULT_i*jnoise_d),"ibd"))
      // I(DI,SI) <+ (flicker_noise((MULT_i*Sfledge),EFEDGE_i,"flicker"))
      // I(DI,SI) <+ (white_noise(((MULT_i*sqidedge)*sqidedge),"ididedge"))
    }
    // End block noise
  }
  // End block evaluateblock
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(13+0);
  dqdp.resize(13+0);
  Findices.resize(13+0);
  Qindices.resize(13+0);

  std::vector <double> probeVars(14);
  std::vector <AdmsSensFadType> staticContributions(13+0);
  std::vector <AdmsSensFadType> dynamicContributions(13+0);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 13+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_TR=mod.TR;
  bool modelPar_given_TR=mod.given("TR");
  AdmsSensFadType modelPar_QMC=mod.QMC;
  bool modelPar_given_QMC=mod.given("QMC");
  AdmsSensFadType modelPar_VFB=mod.VFB;
  bool modelPar_given_VFB=mod.given("VFB");
  AdmsSensFadType modelPar_STVFB=mod.STVFB;
  bool modelPar_given_STVFB=mod.given("STVFB");
  AdmsSensFadType modelPar_TOX=mod.TOX;
  bool modelPar_given_TOX=mod.given("TOX");
  AdmsSensFadType modelPar_EPSROX=mod.EPSROX;
  bool modelPar_given_EPSROX=mod.given("EPSROX");
  AdmsSensFadType modelPar_NEFF=mod.NEFF;
  bool modelPar_given_NEFF=mod.given("NEFF");
  AdmsSensFadType modelPar_FACNEFFAC=mod.FACNEFFAC;
  bool modelPar_given_FACNEFFAC=mod.given("FACNEFFAC");
  AdmsSensFadType modelPar_GFACNUD=mod.GFACNUD;
  bool modelPar_given_GFACNUD=mod.given("GFACNUD");
  AdmsSensFadType modelPar_VSBNUD=mod.VSBNUD;
  bool modelPar_given_VSBNUD=mod.given("VSBNUD");
  AdmsSensFadType modelPar_DVSBNUD=mod.DVSBNUD;
  bool modelPar_given_DVSBNUD=mod.given("DVSBNUD");
  AdmsSensFadType modelPar_VNSUB=mod.VNSUB;
  bool modelPar_given_VNSUB=mod.given("VNSUB");
  AdmsSensFadType modelPar_NSLP=mod.NSLP;
  bool modelPar_given_NSLP=mod.given("NSLP");
  AdmsSensFadType modelPar_DNSUB=mod.DNSUB;
  bool modelPar_given_DNSUB=mod.given("DNSUB");
  AdmsSensFadType modelPar_DPHIB=mod.DPHIB;
  bool modelPar_given_DPHIB=mod.given("DPHIB");
  AdmsSensFadType modelPar_DELVTAC=mod.DELVTAC;
  bool modelPar_given_DELVTAC=mod.given("DELVTAC");
  AdmsSensFadType modelPar_NP=mod.NP;
  bool modelPar_given_NP=mod.given("NP");
  AdmsSensFadType modelPar_CT=mod.CT;
  bool modelPar_given_CT=mod.given("CT");
  AdmsSensFadType modelPar_TOXOV=mod.TOXOV;
  bool modelPar_given_TOXOV=mod.given("TOXOV");
  AdmsSensFadType modelPar_TOXOVD=mod.TOXOVD;
  bool modelPar_given_TOXOVD=mod.given("TOXOVD");
  AdmsSensFadType modelPar_NOV=mod.NOV;
  bool modelPar_given_NOV=mod.given("NOV");
  AdmsSensFadType modelPar_NOVD=mod.NOVD;
  bool modelPar_given_NOVD=mod.given("NOVD");
  AdmsSensFadType modelPar_CF=mod.CF;
  bool modelPar_given_CF=mod.given("CF");
  AdmsSensFadType modelPar_CFD=mod.CFD;
  bool modelPar_given_CFD=mod.given("CFD");
  AdmsSensFadType modelPar_CFB=mod.CFB;
  bool modelPar_given_CFB=mod.given("CFB");
  AdmsSensFadType modelPar_PSCE=mod.PSCE;
  bool modelPar_given_PSCE=mod.given("PSCE");
  AdmsSensFadType modelPar_PSCEB=mod.PSCEB;
  bool modelPar_given_PSCEB=mod.given("PSCEB");
  AdmsSensFadType modelPar_PSCED=mod.PSCED;
  bool modelPar_given_PSCED=mod.given("PSCED");
  AdmsSensFadType modelPar_BETN=mod.BETN;
  bool modelPar_given_BETN=mod.given("BETN");
  AdmsSensFadType modelPar_STBET=mod.STBET;
  bool modelPar_given_STBET=mod.given("STBET");
  AdmsSensFadType modelPar_MUE=mod.MUE;
  bool modelPar_given_MUE=mod.given("MUE");
  AdmsSensFadType modelPar_STMUE=mod.STMUE;
  bool modelPar_given_STMUE=mod.given("STMUE");
  AdmsSensFadType modelPar_THEMU=mod.THEMU;
  bool modelPar_given_THEMU=mod.given("THEMU");
  AdmsSensFadType modelPar_STTHEMU=mod.STTHEMU;
  bool modelPar_given_STTHEMU=mod.given("STTHEMU");
  AdmsSensFadType modelPar_CS=mod.CS;
  bool modelPar_given_CS=mod.given("CS");
  AdmsSensFadType modelPar_STCS=mod.STCS;
  bool modelPar_given_STCS=mod.given("STCS");
  AdmsSensFadType modelPar_XCOR=mod.XCOR;
  bool modelPar_given_XCOR=mod.given("XCOR");
  AdmsSensFadType modelPar_STXCOR=mod.STXCOR;
  bool modelPar_given_STXCOR=mod.given("STXCOR");
  AdmsSensFadType modelPar_FETA=mod.FETA;
  bool modelPar_given_FETA=mod.given("FETA");
  AdmsSensFadType modelPar_RS=mod.RS;
  bool modelPar_given_RS=mod.given("RS");
  AdmsSensFadType modelPar_STRS=mod.STRS;
  bool modelPar_given_STRS=mod.given("STRS");
  AdmsSensFadType modelPar_RSB=mod.RSB;
  bool modelPar_given_RSB=mod.given("RSB");
  AdmsSensFadType modelPar_RSG=mod.RSG;
  bool modelPar_given_RSG=mod.given("RSG");
  AdmsSensFadType modelPar_THESAT=mod.THESAT;
  bool modelPar_given_THESAT=mod.given("THESAT");
  AdmsSensFadType modelPar_STTHESAT=mod.STTHESAT;
  bool modelPar_given_STTHESAT=mod.given("STTHESAT");
  AdmsSensFadType modelPar_THESATB=mod.THESATB;
  bool modelPar_given_THESATB=mod.given("THESATB");
  AdmsSensFadType modelPar_THESATG=mod.THESATG;
  bool modelPar_given_THESATG=mod.given("THESATG");
  AdmsSensFadType modelPar_AX=mod.AX;
  bool modelPar_given_AX=mod.given("AX");
  AdmsSensFadType modelPar_ALP=mod.ALP;
  bool modelPar_given_ALP=mod.given("ALP");
  AdmsSensFadType modelPar_ALP1=mod.ALP1;
  bool modelPar_given_ALP1=mod.given("ALP1");
  AdmsSensFadType modelPar_ALP2=mod.ALP2;
  bool modelPar_given_ALP2=mod.given("ALP2");
  AdmsSensFadType modelPar_VP=mod.VP;
  bool modelPar_given_VP=mod.given("VP");
  AdmsSensFadType modelPar_A1=mod.A1;
  bool modelPar_given_A1=mod.given("A1");
  AdmsSensFadType modelPar_A2=mod.A2;
  bool modelPar_given_A2=mod.given("A2");
  AdmsSensFadType modelPar_STA2=mod.STA2;
  bool modelPar_given_STA2=mod.given("STA2");
  AdmsSensFadType modelPar_A3=mod.A3;
  bool modelPar_given_A3=mod.given("A3");
  AdmsSensFadType modelPar_A4=mod.A4;
  bool modelPar_given_A4=mod.given("A4");
  AdmsSensFadType modelPar_GCO=mod.GCO;
  bool modelPar_given_GCO=mod.given("GCO");
  AdmsSensFadType modelPar_IGINV=mod.IGINV;
  bool modelPar_given_IGINV=mod.given("IGINV");
  AdmsSensFadType modelPar_IGOV=mod.IGOV;
  bool modelPar_given_IGOV=mod.given("IGOV");
  AdmsSensFadType modelPar_IGOVD=mod.IGOVD;
  bool modelPar_given_IGOVD=mod.given("IGOVD");
  AdmsSensFadType modelPar_STIG=mod.STIG;
  bool modelPar_given_STIG=mod.given("STIG");
  AdmsSensFadType modelPar_GC2=mod.GC2;
  bool modelPar_given_GC2=mod.given("GC2");
  AdmsSensFadType modelPar_GC3=mod.GC3;
  bool modelPar_given_GC3=mod.given("GC3");
  AdmsSensFadType modelPar_CHIB=mod.CHIB;
  bool modelPar_given_CHIB=mod.given("CHIB");
  AdmsSensFadType modelPar_AGIDL=mod.AGIDL;
  bool modelPar_given_AGIDL=mod.given("AGIDL");
  AdmsSensFadType modelPar_AGIDLD=mod.AGIDLD;
  bool modelPar_given_AGIDLD=mod.given("AGIDLD");
  AdmsSensFadType modelPar_BGIDL=mod.BGIDL;
  bool modelPar_given_BGIDL=mod.given("BGIDL");
  AdmsSensFadType modelPar_BGIDLD=mod.BGIDLD;
  bool modelPar_given_BGIDLD=mod.given("BGIDLD");
  AdmsSensFadType modelPar_STBGIDL=mod.STBGIDL;
  bool modelPar_given_STBGIDL=mod.given("STBGIDL");
  AdmsSensFadType modelPar_STBGIDLD=mod.STBGIDLD;
  bool modelPar_given_STBGIDLD=mod.given("STBGIDLD");
  AdmsSensFadType modelPar_CGIDL=mod.CGIDL;
  bool modelPar_given_CGIDL=mod.given("CGIDL");
  AdmsSensFadType modelPar_CGIDLD=mod.CGIDLD;
  bool modelPar_given_CGIDLD=mod.given("CGIDLD");
  AdmsSensFadType modelPar_COX=mod.COX;
  bool modelPar_given_COX=mod.given("COX");
  AdmsSensFadType modelPar_CGOV=mod.CGOV;
  bool modelPar_given_CGOV=mod.given("CGOV");
  AdmsSensFadType modelPar_CGOVD=mod.CGOVD;
  bool modelPar_given_CGOVD=mod.given("CGOVD");
  AdmsSensFadType modelPar_CGBOV=mod.CGBOV;
  bool modelPar_given_CGBOV=mod.given("CGBOV");
  AdmsSensFadType modelPar_CFR=mod.CFR;
  bool modelPar_given_CFR=mod.given("CFR");
  AdmsSensFadType modelPar_CFRD=mod.CFRD;
  bool modelPar_given_CFRD=mod.given("CFRD");
  AdmsSensFadType modelPar_FNT=mod.FNT;
  bool modelPar_given_FNT=mod.given("FNT");
  AdmsSensFadType modelPar_FNTEXC=mod.FNTEXC;
  bool modelPar_given_FNTEXC=mod.given("FNTEXC");
  AdmsSensFadType modelPar_NFA=mod.NFA;
  bool modelPar_given_NFA=mod.given("NFA");
  AdmsSensFadType modelPar_NFB=mod.NFB;
  bool modelPar_given_NFB=mod.given("NFB");
  AdmsSensFadType modelPar_NFC=mod.NFC;
  bool modelPar_given_NFC=mod.given("NFC");
  AdmsSensFadType modelPar_EF=mod.EF;
  bool modelPar_given_EF=mod.given("EF");
  AdmsSensFadType modelPar_VFBEDGE=mod.VFBEDGE;
  bool modelPar_given_VFBEDGE=mod.given("VFBEDGE");
  AdmsSensFadType modelPar_STVFBEDGE=mod.STVFBEDGE;
  bool modelPar_given_STVFBEDGE=mod.given("STVFBEDGE");
  AdmsSensFadType modelPar_DPHIBEDGE=mod.DPHIBEDGE;
  bool modelPar_given_DPHIBEDGE=mod.given("DPHIBEDGE");
  AdmsSensFadType modelPar_NEFFEDGE=mod.NEFFEDGE;
  bool modelPar_given_NEFFEDGE=mod.given("NEFFEDGE");
  AdmsSensFadType modelPar_CTEDGE=mod.CTEDGE;
  bool modelPar_given_CTEDGE=mod.given("CTEDGE");
  AdmsSensFadType modelPar_BETNEDGE=mod.BETNEDGE;
  bool modelPar_given_BETNEDGE=mod.given("BETNEDGE");
  AdmsSensFadType modelPar_STBETEDGE=mod.STBETEDGE;
  bool modelPar_given_STBETEDGE=mod.given("STBETEDGE");
  AdmsSensFadType modelPar_PSCEEDGE=mod.PSCEEDGE;
  bool modelPar_given_PSCEEDGE=mod.given("PSCEEDGE");
  AdmsSensFadType modelPar_PSCEBEDGE=mod.PSCEBEDGE;
  bool modelPar_given_PSCEBEDGE=mod.given("PSCEBEDGE");
  AdmsSensFadType modelPar_PSCEDEDGE=mod.PSCEDEDGE;
  bool modelPar_given_PSCEDEDGE=mod.given("PSCEDEDGE");
  AdmsSensFadType modelPar_CFEDGE=mod.CFEDGE;
  bool modelPar_given_CFEDGE=mod.given("CFEDGE");
  AdmsSensFadType modelPar_CFDEDGE=mod.CFDEDGE;
  bool modelPar_given_CFDEDGE=mod.given("CFDEDGE");
  AdmsSensFadType modelPar_CFBEDGE=mod.CFBEDGE;
  bool modelPar_given_CFBEDGE=mod.given("CFBEDGE");
  AdmsSensFadType modelPar_FNTEDGE=mod.FNTEDGE;
  bool modelPar_given_FNTEDGE=mod.given("FNTEDGE");
  AdmsSensFadType modelPar_NFAEDGE=mod.NFAEDGE;
  bool modelPar_given_NFAEDGE=mod.given("NFAEDGE");
  AdmsSensFadType modelPar_NFBEDGE=mod.NFBEDGE;
  bool modelPar_given_NFBEDGE=mod.given("NFBEDGE");
  AdmsSensFadType modelPar_NFCEDGE=mod.NFCEDGE;
  bool modelPar_given_NFCEDGE=mod.given("NFCEDGE");
  AdmsSensFadType modelPar_EFEDGE=mod.EFEDGE;
  bool modelPar_given_EFEDGE=mod.given("EFEDGE");
  AdmsSensFadType modelPar_RG=mod.RG;
  bool modelPar_given_RG=mod.given("RG");
  AdmsSensFadType modelPar_RSE=mod.RSE;
  bool modelPar_given_RSE=mod.given("RSE");
  AdmsSensFadType modelPar_RDE=mod.RDE;
  bool modelPar_given_RDE=mod.given("RDE");
  AdmsSensFadType modelPar_RBULK=mod.RBULK;
  bool modelPar_given_RBULK=mod.given("RBULK");
  AdmsSensFadType modelPar_RWELL=mod.RWELL;
  bool modelPar_given_RWELL=mod.given("RWELL");
  AdmsSensFadType modelPar_RJUNS=mod.RJUNS;
  bool modelPar_given_RJUNS=mod.given("RJUNS");
  AdmsSensFadType modelPar_RJUND=mod.RJUND;
  bool modelPar_given_RJUND=mod.given("RJUND");
  AdmsSensFadType modelPar_POVFB=mod.POVFB;
  bool modelPar_given_POVFB=mod.given("POVFB");
  AdmsSensFadType modelPar_PLVFB=mod.PLVFB;
  bool modelPar_given_PLVFB=mod.given("PLVFB");
  AdmsSensFadType modelPar_PWVFB=mod.PWVFB;
  bool modelPar_given_PWVFB=mod.given("PWVFB");
  AdmsSensFadType modelPar_PLWVFB=mod.PLWVFB;
  bool modelPar_given_PLWVFB=mod.given("PLWVFB");
  AdmsSensFadType modelPar_POSTVFB=mod.POSTVFB;
  bool modelPar_given_POSTVFB=mod.given("POSTVFB");
  AdmsSensFadType modelPar_PLSTVFB=mod.PLSTVFB;
  bool modelPar_given_PLSTVFB=mod.given("PLSTVFB");
  AdmsSensFadType modelPar_PWSTVFB=mod.PWSTVFB;
  bool modelPar_given_PWSTVFB=mod.given("PWSTVFB");
  AdmsSensFadType modelPar_PLWSTVFB=mod.PLWSTVFB;
  bool modelPar_given_PLWSTVFB=mod.given("PLWSTVFB");
  AdmsSensFadType modelPar_POTOX=mod.POTOX;
  bool modelPar_given_POTOX=mod.given("POTOX");
  AdmsSensFadType modelPar_POEPSROX=mod.POEPSROX;
  bool modelPar_given_POEPSROX=mod.given("POEPSROX");
  AdmsSensFadType modelPar_PONEFF=mod.PONEFF;
  bool modelPar_given_PONEFF=mod.given("PONEFF");
  AdmsSensFadType modelPar_PLNEFF=mod.PLNEFF;
  bool modelPar_given_PLNEFF=mod.given("PLNEFF");
  AdmsSensFadType modelPar_PWNEFF=mod.PWNEFF;
  bool modelPar_given_PWNEFF=mod.given("PWNEFF");
  AdmsSensFadType modelPar_PLWNEFF=mod.PLWNEFF;
  bool modelPar_given_PLWNEFF=mod.given("PLWNEFF");
  AdmsSensFadType modelPar_POFACNEFFAC=mod.POFACNEFFAC;
  bool modelPar_given_POFACNEFFAC=mod.given("POFACNEFFAC");
  AdmsSensFadType modelPar_PLFACNEFFAC=mod.PLFACNEFFAC;
  bool modelPar_given_PLFACNEFFAC=mod.given("PLFACNEFFAC");
  AdmsSensFadType modelPar_PWFACNEFFAC=mod.PWFACNEFFAC;
  bool modelPar_given_PWFACNEFFAC=mod.given("PWFACNEFFAC");
  AdmsSensFadType modelPar_PLWFACNEFFAC=mod.PLWFACNEFFAC;
  bool modelPar_given_PLWFACNEFFAC=mod.given("PLWFACNEFFAC");
  AdmsSensFadType modelPar_POGFACNUD=mod.POGFACNUD;
  bool modelPar_given_POGFACNUD=mod.given("POGFACNUD");
  AdmsSensFadType modelPar_PLGFACNUD=mod.PLGFACNUD;
  bool modelPar_given_PLGFACNUD=mod.given("PLGFACNUD");
  AdmsSensFadType modelPar_PWGFACNUD=mod.PWGFACNUD;
  bool modelPar_given_PWGFACNUD=mod.given("PWGFACNUD");
  AdmsSensFadType modelPar_PLWGFACNUD=mod.PLWGFACNUD;
  bool modelPar_given_PLWGFACNUD=mod.given("PLWGFACNUD");
  AdmsSensFadType modelPar_POVSBNUD=mod.POVSBNUD;
  bool modelPar_given_POVSBNUD=mod.given("POVSBNUD");
  AdmsSensFadType modelPar_PODVSBNUD=mod.PODVSBNUD;
  bool modelPar_given_PODVSBNUD=mod.given("PODVSBNUD");
  AdmsSensFadType modelPar_POVNSUB=mod.POVNSUB;
  bool modelPar_given_POVNSUB=mod.given("POVNSUB");
  AdmsSensFadType modelPar_PONSLP=mod.PONSLP;
  bool modelPar_given_PONSLP=mod.given("PONSLP");
  AdmsSensFadType modelPar_PODNSUB=mod.PODNSUB;
  bool modelPar_given_PODNSUB=mod.given("PODNSUB");
  AdmsSensFadType modelPar_PODPHIB=mod.PODPHIB;
  bool modelPar_given_PODPHIB=mod.given("PODPHIB");
  AdmsSensFadType modelPar_PLDPHIB=mod.PLDPHIB;
  bool modelPar_given_PLDPHIB=mod.given("PLDPHIB");
  AdmsSensFadType modelPar_PWDPHIB=mod.PWDPHIB;
  bool modelPar_given_PWDPHIB=mod.given("PWDPHIB");
  AdmsSensFadType modelPar_PLWDPHIB=mod.PLWDPHIB;
  bool modelPar_given_PLWDPHIB=mod.given("PLWDPHIB");
  AdmsSensFadType modelPar_PODELVTAC=mod.PODELVTAC;
  bool modelPar_given_PODELVTAC=mod.given("PODELVTAC");
  AdmsSensFadType modelPar_PLDELVTAC=mod.PLDELVTAC;
  bool modelPar_given_PLDELVTAC=mod.given("PLDELVTAC");
  AdmsSensFadType modelPar_PWDELVTAC=mod.PWDELVTAC;
  bool modelPar_given_PWDELVTAC=mod.given("PWDELVTAC");
  AdmsSensFadType modelPar_PLWDELVTAC=mod.PLWDELVTAC;
  bool modelPar_given_PLWDELVTAC=mod.given("PLWDELVTAC");
  AdmsSensFadType modelPar_PONP=mod.PONP;
  bool modelPar_given_PONP=mod.given("PONP");
  AdmsSensFadType modelPar_PLNP=mod.PLNP;
  bool modelPar_given_PLNP=mod.given("PLNP");
  AdmsSensFadType modelPar_PWNP=mod.PWNP;
  bool modelPar_given_PWNP=mod.given("PWNP");
  AdmsSensFadType modelPar_PLWNP=mod.PLWNP;
  bool modelPar_given_PLWNP=mod.given("PLWNP");
  AdmsSensFadType modelPar_POCT=mod.POCT;
  bool modelPar_given_POCT=mod.given("POCT");
  AdmsSensFadType modelPar_PLCT=mod.PLCT;
  bool modelPar_given_PLCT=mod.given("PLCT");
  AdmsSensFadType modelPar_PWCT=mod.PWCT;
  bool modelPar_given_PWCT=mod.given("PWCT");
  AdmsSensFadType modelPar_PLWCT=mod.PLWCT;
  bool modelPar_given_PLWCT=mod.given("PLWCT");
  AdmsSensFadType modelPar_POTOXOV=mod.POTOXOV;
  bool modelPar_given_POTOXOV=mod.given("POTOXOV");
  AdmsSensFadType modelPar_POTOXOVD=mod.POTOXOVD;
  bool modelPar_given_POTOXOVD=mod.given("POTOXOVD");
  AdmsSensFadType modelPar_PONOV=mod.PONOV;
  bool modelPar_given_PONOV=mod.given("PONOV");
  AdmsSensFadType modelPar_PLNOV=mod.PLNOV;
  bool modelPar_given_PLNOV=mod.given("PLNOV");
  AdmsSensFadType modelPar_PWNOV=mod.PWNOV;
  bool modelPar_given_PWNOV=mod.given("PWNOV");
  AdmsSensFadType modelPar_PLWNOV=mod.PLWNOV;
  bool modelPar_given_PLWNOV=mod.given("PLWNOV");
  AdmsSensFadType modelPar_PONOVD=mod.PONOVD;
  bool modelPar_given_PONOVD=mod.given("PONOVD");
  AdmsSensFadType modelPar_PLNOVD=mod.PLNOVD;
  bool modelPar_given_PLNOVD=mod.given("PLNOVD");
  AdmsSensFadType modelPar_PWNOVD=mod.PWNOVD;
  bool modelPar_given_PWNOVD=mod.given("PWNOVD");
  AdmsSensFadType modelPar_PLWNOVD=mod.PLWNOVD;
  bool modelPar_given_PLWNOVD=mod.given("PLWNOVD");
  AdmsSensFadType modelPar_POCF=mod.POCF;
  bool modelPar_given_POCF=mod.given("POCF");
  AdmsSensFadType modelPar_PLCF=mod.PLCF;
  bool modelPar_given_PLCF=mod.given("PLCF");
  AdmsSensFadType modelPar_PWCF=mod.PWCF;
  bool modelPar_given_PWCF=mod.given("PWCF");
  AdmsSensFadType modelPar_PLWCF=mod.PLWCF;
  bool modelPar_given_PLWCF=mod.given("PLWCF");
  AdmsSensFadType modelPar_POCFD=mod.POCFD;
  bool modelPar_given_POCFD=mod.given("POCFD");
  AdmsSensFadType modelPar_POCFB=mod.POCFB;
  bool modelPar_given_POCFB=mod.given("POCFB");
  AdmsSensFadType modelPar_POPSCE=mod.POPSCE;
  bool modelPar_given_POPSCE=mod.given("POPSCE");
  AdmsSensFadType modelPar_PLPSCE=mod.PLPSCE;
  bool modelPar_given_PLPSCE=mod.given("PLPSCE");
  AdmsSensFadType modelPar_PWPSCE=mod.PWPSCE;
  bool modelPar_given_PWPSCE=mod.given("PWPSCE");
  AdmsSensFadType modelPar_PLWPSCE=mod.PLWPSCE;
  bool modelPar_given_PLWPSCE=mod.given("PLWPSCE");
  AdmsSensFadType modelPar_POPSCEB=mod.POPSCEB;
  bool modelPar_given_POPSCEB=mod.given("POPSCEB");
  AdmsSensFadType modelPar_POPSCED=mod.POPSCED;
  bool modelPar_given_POPSCED=mod.given("POPSCED");
  AdmsSensFadType modelPar_POBETN=mod.POBETN;
  bool modelPar_given_POBETN=mod.given("POBETN");
  AdmsSensFadType modelPar_PLBETN=mod.PLBETN;
  bool modelPar_given_PLBETN=mod.given("PLBETN");
  AdmsSensFadType modelPar_PWBETN=mod.PWBETN;
  bool modelPar_given_PWBETN=mod.given("PWBETN");
  AdmsSensFadType modelPar_PLWBETN=mod.PLWBETN;
  bool modelPar_given_PLWBETN=mod.given("PLWBETN");
  AdmsSensFadType modelPar_POSTBET=mod.POSTBET;
  bool modelPar_given_POSTBET=mod.given("POSTBET");
  AdmsSensFadType modelPar_PLSTBET=mod.PLSTBET;
  bool modelPar_given_PLSTBET=mod.given("PLSTBET");
  AdmsSensFadType modelPar_PWSTBET=mod.PWSTBET;
  bool modelPar_given_PWSTBET=mod.given("PWSTBET");
  AdmsSensFadType modelPar_PLWSTBET=mod.PLWSTBET;
  bool modelPar_given_PLWSTBET=mod.given("PLWSTBET");
  AdmsSensFadType modelPar_POMUE=mod.POMUE;
  bool modelPar_given_POMUE=mod.given("POMUE");
  AdmsSensFadType modelPar_PLMUE=mod.PLMUE;
  bool modelPar_given_PLMUE=mod.given("PLMUE");
  AdmsSensFadType modelPar_PWMUE=mod.PWMUE;
  bool modelPar_given_PWMUE=mod.given("PWMUE");
  AdmsSensFadType modelPar_PLWMUE=mod.PLWMUE;
  bool modelPar_given_PLWMUE=mod.given("PLWMUE");
  AdmsSensFadType modelPar_POSTMUE=mod.POSTMUE;
  bool modelPar_given_POSTMUE=mod.given("POSTMUE");
  AdmsSensFadType modelPar_POTHEMU=mod.POTHEMU;
  bool modelPar_given_POTHEMU=mod.given("POTHEMU");
  AdmsSensFadType modelPar_POSTTHEMU=mod.POSTTHEMU;
  bool modelPar_given_POSTTHEMU=mod.given("POSTTHEMU");
  AdmsSensFadType modelPar_POCS=mod.POCS;
  bool modelPar_given_POCS=mod.given("POCS");
  AdmsSensFadType modelPar_PLCS=mod.PLCS;
  bool modelPar_given_PLCS=mod.given("PLCS");
  AdmsSensFadType modelPar_PWCS=mod.PWCS;
  bool modelPar_given_PWCS=mod.given("PWCS");
  AdmsSensFadType modelPar_PLWCS=mod.PLWCS;
  bool modelPar_given_PLWCS=mod.given("PLWCS");
  AdmsSensFadType modelPar_POSTCS=mod.POSTCS;
  bool modelPar_given_POSTCS=mod.given("POSTCS");
  AdmsSensFadType modelPar_POXCOR=mod.POXCOR;
  bool modelPar_given_POXCOR=mod.given("POXCOR");
  AdmsSensFadType modelPar_PLXCOR=mod.PLXCOR;
  bool modelPar_given_PLXCOR=mod.given("PLXCOR");
  AdmsSensFadType modelPar_PWXCOR=mod.PWXCOR;
  bool modelPar_given_PWXCOR=mod.given("PWXCOR");
  AdmsSensFadType modelPar_PLWXCOR=mod.PLWXCOR;
  bool modelPar_given_PLWXCOR=mod.given("PLWXCOR");
  AdmsSensFadType modelPar_POSTXCOR=mod.POSTXCOR;
  bool modelPar_given_POSTXCOR=mod.given("POSTXCOR");
  AdmsSensFadType modelPar_POFETA=mod.POFETA;
  bool modelPar_given_POFETA=mod.given("POFETA");
  AdmsSensFadType modelPar_PORS=mod.PORS;
  bool modelPar_given_PORS=mod.given("PORS");
  AdmsSensFadType modelPar_PLRS=mod.PLRS;
  bool modelPar_given_PLRS=mod.given("PLRS");
  AdmsSensFadType modelPar_PWRS=mod.PWRS;
  bool modelPar_given_PWRS=mod.given("PWRS");
  AdmsSensFadType modelPar_PLWRS=mod.PLWRS;
  bool modelPar_given_PLWRS=mod.given("PLWRS");
  AdmsSensFadType modelPar_POSTRS=mod.POSTRS;
  bool modelPar_given_POSTRS=mod.given("POSTRS");
  AdmsSensFadType modelPar_PORSB=mod.PORSB;
  bool modelPar_given_PORSB=mod.given("PORSB");
  AdmsSensFadType modelPar_PORSG=mod.PORSG;
  bool modelPar_given_PORSG=mod.given("PORSG");
  AdmsSensFadType modelPar_POTHESAT=mod.POTHESAT;
  bool modelPar_given_POTHESAT=mod.given("POTHESAT");
  AdmsSensFadType modelPar_PLTHESAT=mod.PLTHESAT;
  bool modelPar_given_PLTHESAT=mod.given("PLTHESAT");
  AdmsSensFadType modelPar_PWTHESAT=mod.PWTHESAT;
  bool modelPar_given_PWTHESAT=mod.given("PWTHESAT");
  AdmsSensFadType modelPar_PLWTHESAT=mod.PLWTHESAT;
  bool modelPar_given_PLWTHESAT=mod.given("PLWTHESAT");
  AdmsSensFadType modelPar_POSTTHESAT=mod.POSTTHESAT;
  bool modelPar_given_POSTTHESAT=mod.given("POSTTHESAT");
  AdmsSensFadType modelPar_PLSTTHESAT=mod.PLSTTHESAT;
  bool modelPar_given_PLSTTHESAT=mod.given("PLSTTHESAT");
  AdmsSensFadType modelPar_PWSTTHESAT=mod.PWSTTHESAT;
  bool modelPar_given_PWSTTHESAT=mod.given("PWSTTHESAT");
  AdmsSensFadType modelPar_PLWSTTHESAT=mod.PLWSTTHESAT;
  bool modelPar_given_PLWSTTHESAT=mod.given("PLWSTTHESAT");
  AdmsSensFadType modelPar_POTHESATB=mod.POTHESATB;
  bool modelPar_given_POTHESATB=mod.given("POTHESATB");
  AdmsSensFadType modelPar_PLTHESATB=mod.PLTHESATB;
  bool modelPar_given_PLTHESATB=mod.given("PLTHESATB");
  AdmsSensFadType modelPar_PWTHESATB=mod.PWTHESATB;
  bool modelPar_given_PWTHESATB=mod.given("PWTHESATB");
  AdmsSensFadType modelPar_PLWTHESATB=mod.PLWTHESATB;
  bool modelPar_given_PLWTHESATB=mod.given("PLWTHESATB");
  AdmsSensFadType modelPar_POTHESATG=mod.POTHESATG;
  bool modelPar_given_POTHESATG=mod.given("POTHESATG");
  AdmsSensFadType modelPar_PLTHESATG=mod.PLTHESATG;
  bool modelPar_given_PLTHESATG=mod.given("PLTHESATG");
  AdmsSensFadType modelPar_PWTHESATG=mod.PWTHESATG;
  bool modelPar_given_PWTHESATG=mod.given("PWTHESATG");
  AdmsSensFadType modelPar_PLWTHESATG=mod.PLWTHESATG;
  bool modelPar_given_PLWTHESATG=mod.given("PLWTHESATG");
  AdmsSensFadType modelPar_POAX=mod.POAX;
  bool modelPar_given_POAX=mod.given("POAX");
  AdmsSensFadType modelPar_PLAX=mod.PLAX;
  bool modelPar_given_PLAX=mod.given("PLAX");
  AdmsSensFadType modelPar_PWAX=mod.PWAX;
  bool modelPar_given_PWAX=mod.given("PWAX");
  AdmsSensFadType modelPar_PLWAX=mod.PLWAX;
  bool modelPar_given_PLWAX=mod.given("PLWAX");
  AdmsSensFadType modelPar_POALP=mod.POALP;
  bool modelPar_given_POALP=mod.given("POALP");
  AdmsSensFadType modelPar_PLALP=mod.PLALP;
  bool modelPar_given_PLALP=mod.given("PLALP");
  AdmsSensFadType modelPar_PWALP=mod.PWALP;
  bool modelPar_given_PWALP=mod.given("PWALP");
  AdmsSensFadType modelPar_PLWALP=mod.PLWALP;
  bool modelPar_given_PLWALP=mod.given("PLWALP");
  AdmsSensFadType modelPar_POALP1=mod.POALP1;
  bool modelPar_given_POALP1=mod.given("POALP1");
  AdmsSensFadType modelPar_PLALP1=mod.PLALP1;
  bool modelPar_given_PLALP1=mod.given("PLALP1");
  AdmsSensFadType modelPar_PWALP1=mod.PWALP1;
  bool modelPar_given_PWALP1=mod.given("PWALP1");
  AdmsSensFadType modelPar_PLWALP1=mod.PLWALP1;
  bool modelPar_given_PLWALP1=mod.given("PLWALP1");
  AdmsSensFadType modelPar_POALP2=mod.POALP2;
  bool modelPar_given_POALP2=mod.given("POALP2");
  AdmsSensFadType modelPar_PLALP2=mod.PLALP2;
  bool modelPar_given_PLALP2=mod.given("PLALP2");
  AdmsSensFadType modelPar_PWALP2=mod.PWALP2;
  bool modelPar_given_PWALP2=mod.given("PWALP2");
  AdmsSensFadType modelPar_PLWALP2=mod.PLWALP2;
  bool modelPar_given_PLWALP2=mod.given("PLWALP2");
  AdmsSensFadType modelPar_POVP=mod.POVP;
  bool modelPar_given_POVP=mod.given("POVP");
  AdmsSensFadType modelPar_POA1=mod.POA1;
  bool modelPar_given_POA1=mod.given("POA1");
  AdmsSensFadType modelPar_PLA1=mod.PLA1;
  bool modelPar_given_PLA1=mod.given("PLA1");
  AdmsSensFadType modelPar_PWA1=mod.PWA1;
  bool modelPar_given_PWA1=mod.given("PWA1");
  AdmsSensFadType modelPar_PLWA1=mod.PLWA1;
  bool modelPar_given_PLWA1=mod.given("PLWA1");
  AdmsSensFadType modelPar_POA2=mod.POA2;
  bool modelPar_given_POA2=mod.given("POA2");
  AdmsSensFadType modelPar_POSTA2=mod.POSTA2;
  bool modelPar_given_POSTA2=mod.given("POSTA2");
  AdmsSensFadType modelPar_POA3=mod.POA3;
  bool modelPar_given_POA3=mod.given("POA3");
  AdmsSensFadType modelPar_PLA3=mod.PLA3;
  bool modelPar_given_PLA3=mod.given("PLA3");
  AdmsSensFadType modelPar_PWA3=mod.PWA3;
  bool modelPar_given_PWA3=mod.given("PWA3");
  AdmsSensFadType modelPar_PLWA3=mod.PLWA3;
  bool modelPar_given_PLWA3=mod.given("PLWA3");
  AdmsSensFadType modelPar_POA4=mod.POA4;
  bool modelPar_given_POA4=mod.given("POA4");
  AdmsSensFadType modelPar_PLA4=mod.PLA4;
  bool modelPar_given_PLA4=mod.given("PLA4");
  AdmsSensFadType modelPar_PWA4=mod.PWA4;
  bool modelPar_given_PWA4=mod.given("PWA4");
  AdmsSensFadType modelPar_PLWA4=mod.PLWA4;
  bool modelPar_given_PLWA4=mod.given("PLWA4");
  AdmsSensFadType modelPar_POGCO=mod.POGCO;
  bool modelPar_given_POGCO=mod.given("POGCO");
  AdmsSensFadType modelPar_POIGINV=mod.POIGINV;
  bool modelPar_given_POIGINV=mod.given("POIGINV");
  AdmsSensFadType modelPar_PLIGINV=mod.PLIGINV;
  bool modelPar_given_PLIGINV=mod.given("PLIGINV");
  AdmsSensFadType modelPar_PWIGINV=mod.PWIGINV;
  bool modelPar_given_PWIGINV=mod.given("PWIGINV");
  AdmsSensFadType modelPar_PLWIGINV=mod.PLWIGINV;
  bool modelPar_given_PLWIGINV=mod.given("PLWIGINV");
  AdmsSensFadType modelPar_POIGOV=mod.POIGOV;
  bool modelPar_given_POIGOV=mod.given("POIGOV");
  AdmsSensFadType modelPar_PLIGOV=mod.PLIGOV;
  bool modelPar_given_PLIGOV=mod.given("PLIGOV");
  AdmsSensFadType modelPar_PWIGOV=mod.PWIGOV;
  bool modelPar_given_PWIGOV=mod.given("PWIGOV");
  AdmsSensFadType modelPar_PLWIGOV=mod.PLWIGOV;
  bool modelPar_given_PLWIGOV=mod.given("PLWIGOV");
  AdmsSensFadType modelPar_POIGOVD=mod.POIGOVD;
  bool modelPar_given_POIGOVD=mod.given("POIGOVD");
  AdmsSensFadType modelPar_PLIGOVD=mod.PLIGOVD;
  bool modelPar_given_PLIGOVD=mod.given("PLIGOVD");
  AdmsSensFadType modelPar_PWIGOVD=mod.PWIGOVD;
  bool modelPar_given_PWIGOVD=mod.given("PWIGOVD");
  AdmsSensFadType modelPar_PLWIGOVD=mod.PLWIGOVD;
  bool modelPar_given_PLWIGOVD=mod.given("PLWIGOVD");
  AdmsSensFadType modelPar_POSTIG=mod.POSTIG;
  bool modelPar_given_POSTIG=mod.given("POSTIG");
  AdmsSensFadType modelPar_POGC2=mod.POGC2;
  bool modelPar_given_POGC2=mod.given("POGC2");
  AdmsSensFadType modelPar_POGC3=mod.POGC3;
  bool modelPar_given_POGC3=mod.given("POGC3");
  AdmsSensFadType modelPar_POCHIB=mod.POCHIB;
  bool modelPar_given_POCHIB=mod.given("POCHIB");
  AdmsSensFadType modelPar_POAGIDL=mod.POAGIDL;
  bool modelPar_given_POAGIDL=mod.given("POAGIDL");
  AdmsSensFadType modelPar_PLAGIDL=mod.PLAGIDL;
  bool modelPar_given_PLAGIDL=mod.given("PLAGIDL");
  AdmsSensFadType modelPar_PWAGIDL=mod.PWAGIDL;
  bool modelPar_given_PWAGIDL=mod.given("PWAGIDL");
  AdmsSensFadType modelPar_PLWAGIDL=mod.PLWAGIDL;
  bool modelPar_given_PLWAGIDL=mod.given("PLWAGIDL");
  AdmsSensFadType modelPar_POAGIDLD=mod.POAGIDLD;
  bool modelPar_given_POAGIDLD=mod.given("POAGIDLD");
  AdmsSensFadType modelPar_PLAGIDLD=mod.PLAGIDLD;
  bool modelPar_given_PLAGIDLD=mod.given("PLAGIDLD");
  AdmsSensFadType modelPar_PWAGIDLD=mod.PWAGIDLD;
  bool modelPar_given_PWAGIDLD=mod.given("PWAGIDLD");
  AdmsSensFadType modelPar_PLWAGIDLD=mod.PLWAGIDLD;
  bool modelPar_given_PLWAGIDLD=mod.given("PLWAGIDLD");
  AdmsSensFadType modelPar_POBGIDL=mod.POBGIDL;
  bool modelPar_given_POBGIDL=mod.given("POBGIDL");
  AdmsSensFadType modelPar_POBGIDLD=mod.POBGIDLD;
  bool modelPar_given_POBGIDLD=mod.given("POBGIDLD");
  AdmsSensFadType modelPar_POSTBGIDL=mod.POSTBGIDL;
  bool modelPar_given_POSTBGIDL=mod.given("POSTBGIDL");
  AdmsSensFadType modelPar_POSTBGIDLD=mod.POSTBGIDLD;
  bool modelPar_given_POSTBGIDLD=mod.given("POSTBGIDLD");
  AdmsSensFadType modelPar_POCGIDL=mod.POCGIDL;
  bool modelPar_given_POCGIDL=mod.given("POCGIDL");
  AdmsSensFadType modelPar_POCGIDLD=mod.POCGIDLD;
  bool modelPar_given_POCGIDLD=mod.given("POCGIDLD");
  AdmsSensFadType modelPar_POCOX=mod.POCOX;
  bool modelPar_given_POCOX=mod.given("POCOX");
  AdmsSensFadType modelPar_PLCOX=mod.PLCOX;
  bool modelPar_given_PLCOX=mod.given("PLCOX");
  AdmsSensFadType modelPar_PWCOX=mod.PWCOX;
  bool modelPar_given_PWCOX=mod.given("PWCOX");
  AdmsSensFadType modelPar_PLWCOX=mod.PLWCOX;
  bool modelPar_given_PLWCOX=mod.given("PLWCOX");
  AdmsSensFadType modelPar_POCGOV=mod.POCGOV;
  bool modelPar_given_POCGOV=mod.given("POCGOV");
  AdmsSensFadType modelPar_PLCGOV=mod.PLCGOV;
  bool modelPar_given_PLCGOV=mod.given("PLCGOV");
  AdmsSensFadType modelPar_PWCGOV=mod.PWCGOV;
  bool modelPar_given_PWCGOV=mod.given("PWCGOV");
  AdmsSensFadType modelPar_PLWCGOV=mod.PLWCGOV;
  bool modelPar_given_PLWCGOV=mod.given("PLWCGOV");
  AdmsSensFadType modelPar_POCGOVD=mod.POCGOVD;
  bool modelPar_given_POCGOVD=mod.given("POCGOVD");
  AdmsSensFadType modelPar_PLCGOVD=mod.PLCGOVD;
  bool modelPar_given_PLCGOVD=mod.given("PLCGOVD");
  AdmsSensFadType modelPar_PWCGOVD=mod.PWCGOVD;
  bool modelPar_given_PWCGOVD=mod.given("PWCGOVD");
  AdmsSensFadType modelPar_PLWCGOVD=mod.PLWCGOVD;
  bool modelPar_given_PLWCGOVD=mod.given("PLWCGOVD");
  AdmsSensFadType modelPar_POCGBOV=mod.POCGBOV;
  bool modelPar_given_POCGBOV=mod.given("POCGBOV");
  AdmsSensFadType modelPar_PLCGBOV=mod.PLCGBOV;
  bool modelPar_given_PLCGBOV=mod.given("PLCGBOV");
  AdmsSensFadType modelPar_PWCGBOV=mod.PWCGBOV;
  bool modelPar_given_PWCGBOV=mod.given("PWCGBOV");
  AdmsSensFadType modelPar_PLWCGBOV=mod.PLWCGBOV;
  bool modelPar_given_PLWCGBOV=mod.given("PLWCGBOV");
  AdmsSensFadType modelPar_POCFR=mod.POCFR;
  bool modelPar_given_POCFR=mod.given("POCFR");
  AdmsSensFadType modelPar_PLCFR=mod.PLCFR;
  bool modelPar_given_PLCFR=mod.given("PLCFR");
  AdmsSensFadType modelPar_PWCFR=mod.PWCFR;
  bool modelPar_given_PWCFR=mod.given("PWCFR");
  AdmsSensFadType modelPar_PLWCFR=mod.PLWCFR;
  bool modelPar_given_PLWCFR=mod.given("PLWCFR");
  AdmsSensFadType modelPar_POCFRD=mod.POCFRD;
  bool modelPar_given_POCFRD=mod.given("POCFRD");
  AdmsSensFadType modelPar_PLCFRD=mod.PLCFRD;
  bool modelPar_given_PLCFRD=mod.given("PLCFRD");
  AdmsSensFadType modelPar_PWCFRD=mod.PWCFRD;
  bool modelPar_given_PWCFRD=mod.given("PWCFRD");
  AdmsSensFadType modelPar_PLWCFRD=mod.PLWCFRD;
  bool modelPar_given_PLWCFRD=mod.given("PLWCFRD");
  AdmsSensFadType modelPar_POFNT=mod.POFNT;
  bool modelPar_given_POFNT=mod.given("POFNT");
  AdmsSensFadType modelPar_POFNTEXC=mod.POFNTEXC;
  bool modelPar_given_POFNTEXC=mod.given("POFNTEXC");
  AdmsSensFadType modelPar_PLFNTEXC=mod.PLFNTEXC;
  bool modelPar_given_PLFNTEXC=mod.given("PLFNTEXC");
  AdmsSensFadType modelPar_PWFNTEXC=mod.PWFNTEXC;
  bool modelPar_given_PWFNTEXC=mod.given("PWFNTEXC");
  AdmsSensFadType modelPar_PLWFNTEXC=mod.PLWFNTEXC;
  bool modelPar_given_PLWFNTEXC=mod.given("PLWFNTEXC");
  AdmsSensFadType modelPar_PONFA=mod.PONFA;
  bool modelPar_given_PONFA=mod.given("PONFA");
  AdmsSensFadType modelPar_PLNFA=mod.PLNFA;
  bool modelPar_given_PLNFA=mod.given("PLNFA");
  AdmsSensFadType modelPar_PWNFA=mod.PWNFA;
  bool modelPar_given_PWNFA=mod.given("PWNFA");
  AdmsSensFadType modelPar_PLWNFA=mod.PLWNFA;
  bool modelPar_given_PLWNFA=mod.given("PLWNFA");
  AdmsSensFadType modelPar_PONFB=mod.PONFB;
  bool modelPar_given_PONFB=mod.given("PONFB");
  AdmsSensFadType modelPar_PLNFB=mod.PLNFB;
  bool modelPar_given_PLNFB=mod.given("PLNFB");
  AdmsSensFadType modelPar_PWNFB=mod.PWNFB;
  bool modelPar_given_PWNFB=mod.given("PWNFB");
  AdmsSensFadType modelPar_PLWNFB=mod.PLWNFB;
  bool modelPar_given_PLWNFB=mod.given("PLWNFB");
  AdmsSensFadType modelPar_PONFC=mod.PONFC;
  bool modelPar_given_PONFC=mod.given("PONFC");
  AdmsSensFadType modelPar_PLNFC=mod.PLNFC;
  bool modelPar_given_PLNFC=mod.given("PLNFC");
  AdmsSensFadType modelPar_PWNFC=mod.PWNFC;
  bool modelPar_given_PWNFC=mod.given("PWNFC");
  AdmsSensFadType modelPar_PLWNFC=mod.PLWNFC;
  bool modelPar_given_PLWNFC=mod.given("PLWNFC");
  AdmsSensFadType modelPar_POEF=mod.POEF;
  bool modelPar_given_POEF=mod.given("POEF");
  AdmsSensFadType modelPar_POVFBEDGE=mod.POVFBEDGE;
  bool modelPar_given_POVFBEDGE=mod.given("POVFBEDGE");
  AdmsSensFadType modelPar_POSTVFBEDGE=mod.POSTVFBEDGE;
  bool modelPar_given_POSTVFBEDGE=mod.given("POSTVFBEDGE");
  AdmsSensFadType modelPar_PLSTVFBEDGE=mod.PLSTVFBEDGE;
  bool modelPar_given_PLSTVFBEDGE=mod.given("PLSTVFBEDGE");
  AdmsSensFadType modelPar_PWSTVFBEDGE=mod.PWSTVFBEDGE;
  bool modelPar_given_PWSTVFBEDGE=mod.given("PWSTVFBEDGE");
  AdmsSensFadType modelPar_PLWSTVFBEDGE=mod.PLWSTVFBEDGE;
  bool modelPar_given_PLWSTVFBEDGE=mod.given("PLWSTVFBEDGE");
  AdmsSensFadType modelPar_PODPHIBEDGE=mod.PODPHIBEDGE;
  bool modelPar_given_PODPHIBEDGE=mod.given("PODPHIBEDGE");
  AdmsSensFadType modelPar_PLDPHIBEDGE=mod.PLDPHIBEDGE;
  bool modelPar_given_PLDPHIBEDGE=mod.given("PLDPHIBEDGE");
  AdmsSensFadType modelPar_PWDPHIBEDGE=mod.PWDPHIBEDGE;
  bool modelPar_given_PWDPHIBEDGE=mod.given("PWDPHIBEDGE");
  AdmsSensFadType modelPar_PLWDPHIBEDGE=mod.PLWDPHIBEDGE;
  bool modelPar_given_PLWDPHIBEDGE=mod.given("PLWDPHIBEDGE");
  AdmsSensFadType modelPar_PONEFFEDGE=mod.PONEFFEDGE;
  bool modelPar_given_PONEFFEDGE=mod.given("PONEFFEDGE");
  AdmsSensFadType modelPar_PLNEFFEDGE=mod.PLNEFFEDGE;
  bool modelPar_given_PLNEFFEDGE=mod.given("PLNEFFEDGE");
  AdmsSensFadType modelPar_PWNEFFEDGE=mod.PWNEFFEDGE;
  bool modelPar_given_PWNEFFEDGE=mod.given("PWNEFFEDGE");
  AdmsSensFadType modelPar_PLWNEFFEDGE=mod.PLWNEFFEDGE;
  bool modelPar_given_PLWNEFFEDGE=mod.given("PLWNEFFEDGE");
  AdmsSensFadType modelPar_POCTEDGE=mod.POCTEDGE;
  bool modelPar_given_POCTEDGE=mod.given("POCTEDGE");
  AdmsSensFadType modelPar_PLCTEDGE=mod.PLCTEDGE;
  bool modelPar_given_PLCTEDGE=mod.given("PLCTEDGE");
  AdmsSensFadType modelPar_PWCTEDGE=mod.PWCTEDGE;
  bool modelPar_given_PWCTEDGE=mod.given("PWCTEDGE");
  AdmsSensFadType modelPar_PLWCTEDGE=mod.PLWCTEDGE;
  bool modelPar_given_PLWCTEDGE=mod.given("PLWCTEDGE");
  AdmsSensFadType modelPar_POBETNEDGE=mod.POBETNEDGE;
  bool modelPar_given_POBETNEDGE=mod.given("POBETNEDGE");
  AdmsSensFadType modelPar_PLBETNEDGE=mod.PLBETNEDGE;
  bool modelPar_given_PLBETNEDGE=mod.given("PLBETNEDGE");
  AdmsSensFadType modelPar_PWBETNEDGE=mod.PWBETNEDGE;
  bool modelPar_given_PWBETNEDGE=mod.given("PWBETNEDGE");
  AdmsSensFadType modelPar_PLWBETNEDGE=mod.PLWBETNEDGE;
  bool modelPar_given_PLWBETNEDGE=mod.given("PLWBETNEDGE");
  AdmsSensFadType modelPar_POSTBETEDGE=mod.POSTBETEDGE;
  bool modelPar_given_POSTBETEDGE=mod.given("POSTBETEDGE");
  AdmsSensFadType modelPar_PLSTBETEDGE=mod.PLSTBETEDGE;
  bool modelPar_given_PLSTBETEDGE=mod.given("PLSTBETEDGE");
  AdmsSensFadType modelPar_PWSTBETEDGE=mod.PWSTBETEDGE;
  bool modelPar_given_PWSTBETEDGE=mod.given("PWSTBETEDGE");
  AdmsSensFadType modelPar_PLWSTBETEDGE=mod.PLWSTBETEDGE;
  bool modelPar_given_PLWSTBETEDGE=mod.given("PLWSTBETEDGE");
  AdmsSensFadType modelPar_POPSCEEDGE=mod.POPSCEEDGE;
  bool modelPar_given_POPSCEEDGE=mod.given("POPSCEEDGE");
  AdmsSensFadType modelPar_PLPSCEEDGE=mod.PLPSCEEDGE;
  bool modelPar_given_PLPSCEEDGE=mod.given("PLPSCEEDGE");
  AdmsSensFadType modelPar_PWPSCEEDGE=mod.PWPSCEEDGE;
  bool modelPar_given_PWPSCEEDGE=mod.given("PWPSCEEDGE");
  AdmsSensFadType modelPar_PLWPSCEEDGE=mod.PLWPSCEEDGE;
  bool modelPar_given_PLWPSCEEDGE=mod.given("PLWPSCEEDGE");
  AdmsSensFadType modelPar_POPSCEBEDGE=mod.POPSCEBEDGE;
  bool modelPar_given_POPSCEBEDGE=mod.given("POPSCEBEDGE");
  AdmsSensFadType modelPar_POPSCEDEDGE=mod.POPSCEDEDGE;
  bool modelPar_given_POPSCEDEDGE=mod.given("POPSCEDEDGE");
  AdmsSensFadType modelPar_POCFEDGE=mod.POCFEDGE;
  bool modelPar_given_POCFEDGE=mod.given("POCFEDGE");
  AdmsSensFadType modelPar_PLCFEDGE=mod.PLCFEDGE;
  bool modelPar_given_PLCFEDGE=mod.given("PLCFEDGE");
  AdmsSensFadType modelPar_PWCFEDGE=mod.PWCFEDGE;
  bool modelPar_given_PWCFEDGE=mod.given("PWCFEDGE");
  AdmsSensFadType modelPar_PLWCFEDGE=mod.PLWCFEDGE;
  bool modelPar_given_PLWCFEDGE=mod.given("PLWCFEDGE");
  AdmsSensFadType modelPar_POCFDEDGE=mod.POCFDEDGE;
  bool modelPar_given_POCFDEDGE=mod.given("POCFDEDGE");
  AdmsSensFadType modelPar_POCFBEDGE=mod.POCFBEDGE;
  bool modelPar_given_POCFBEDGE=mod.given("POCFBEDGE");
  AdmsSensFadType modelPar_POFNTEDGE=mod.POFNTEDGE;
  bool modelPar_given_POFNTEDGE=mod.given("POFNTEDGE");
  AdmsSensFadType modelPar_PONFAEDGE=mod.PONFAEDGE;
  bool modelPar_given_PONFAEDGE=mod.given("PONFAEDGE");
  AdmsSensFadType modelPar_PLNFAEDGE=mod.PLNFAEDGE;
  bool modelPar_given_PLNFAEDGE=mod.given("PLNFAEDGE");
  AdmsSensFadType modelPar_PWNFAEDGE=mod.PWNFAEDGE;
  bool modelPar_given_PWNFAEDGE=mod.given("PWNFAEDGE");
  AdmsSensFadType modelPar_PLWNFAEDGE=mod.PLWNFAEDGE;
  bool modelPar_given_PLWNFAEDGE=mod.given("PLWNFAEDGE");
  AdmsSensFadType modelPar_PONFBEDGE=mod.PONFBEDGE;
  bool modelPar_given_PONFBEDGE=mod.given("PONFBEDGE");
  AdmsSensFadType modelPar_PLNFBEDGE=mod.PLNFBEDGE;
  bool modelPar_given_PLNFBEDGE=mod.given("PLNFBEDGE");
  AdmsSensFadType modelPar_PWNFBEDGE=mod.PWNFBEDGE;
  bool modelPar_given_PWNFBEDGE=mod.given("PWNFBEDGE");
  AdmsSensFadType modelPar_PLWNFBEDGE=mod.PLWNFBEDGE;
  bool modelPar_given_PLWNFBEDGE=mod.given("PLWNFBEDGE");
  AdmsSensFadType modelPar_PONFCEDGE=mod.PONFCEDGE;
  bool modelPar_given_PONFCEDGE=mod.given("PONFCEDGE");
  AdmsSensFadType modelPar_PLNFCEDGE=mod.PLNFCEDGE;
  bool modelPar_given_PLNFCEDGE=mod.given("PLNFCEDGE");
  AdmsSensFadType modelPar_PWNFCEDGE=mod.PWNFCEDGE;
  bool modelPar_given_PWNFCEDGE=mod.given("PWNFCEDGE");
  AdmsSensFadType modelPar_PLWNFCEDGE=mod.PLWNFCEDGE;
  bool modelPar_given_PLWNFCEDGE=mod.given("PLWNFCEDGE");
  AdmsSensFadType modelPar_POEFEDGE=mod.POEFEDGE;
  bool modelPar_given_POEFEDGE=mod.given("POEFEDGE");
  AdmsSensFadType modelPar_POKVTHOWE=mod.POKVTHOWE;
  bool modelPar_given_POKVTHOWE=mod.given("POKVTHOWE");
  AdmsSensFadType modelPar_PLKVTHOWE=mod.PLKVTHOWE;
  bool modelPar_given_PLKVTHOWE=mod.given("PLKVTHOWE");
  AdmsSensFadType modelPar_PWKVTHOWE=mod.PWKVTHOWE;
  bool modelPar_given_PWKVTHOWE=mod.given("PWKVTHOWE");
  AdmsSensFadType modelPar_PLWKVTHOWE=mod.PLWKVTHOWE;
  bool modelPar_given_PLWKVTHOWE=mod.given("PLWKVTHOWE");
  AdmsSensFadType modelPar_POKUOWE=mod.POKUOWE;
  bool modelPar_given_POKUOWE=mod.given("POKUOWE");
  AdmsSensFadType modelPar_PLKUOWE=mod.PLKUOWE;
  bool modelPar_given_PLKUOWE=mod.given("PLKUOWE");
  AdmsSensFadType modelPar_PWKUOWE=mod.PWKUOWE;
  bool modelPar_given_PWKUOWE=mod.given("PWKUOWE");
  AdmsSensFadType modelPar_PLWKUOWE=mod.PLWKUOWE;
  bool modelPar_given_PLWKUOWE=mod.given("PLWKUOWE");
  AdmsSensFadType modelPar_LMIN=mod.LMIN;
  bool modelPar_given_LMIN=mod.given("LMIN");
  AdmsSensFadType modelPar_LMAX=mod.LMAX;
  bool modelPar_given_LMAX=mod.given("LMAX");
  AdmsSensFadType modelPar_WMIN=mod.WMIN;
  bool modelPar_given_WMIN=mod.given("WMIN");
  AdmsSensFadType modelPar_WMAX=mod.WMAX;
  bool modelPar_given_WMAX=mod.given("WMAX");
  AdmsSensFadType modelPar_LVARO=mod.LVARO;
  bool modelPar_given_LVARO=mod.given("LVARO");
  AdmsSensFadType modelPar_LVARL=mod.LVARL;
  bool modelPar_given_LVARL=mod.given("LVARL");
  AdmsSensFadType modelPar_LVARW=mod.LVARW;
  bool modelPar_given_LVARW=mod.given("LVARW");
  AdmsSensFadType modelPar_LAP=mod.LAP;
  bool modelPar_given_LAP=mod.given("LAP");
  AdmsSensFadType modelPar_WVARO=mod.WVARO;
  bool modelPar_given_WVARO=mod.given("WVARO");
  AdmsSensFadType modelPar_WVARL=mod.WVARL;
  bool modelPar_given_WVARL=mod.given("WVARL");
  AdmsSensFadType modelPar_WVARW=mod.WVARW;
  bool modelPar_given_WVARW=mod.given("WVARW");
  AdmsSensFadType modelPar_WOT=mod.WOT;
  bool modelPar_given_WOT=mod.given("WOT");
  AdmsSensFadType modelPar_DLQ=mod.DLQ;
  bool modelPar_given_DLQ=mod.given("DLQ");
  AdmsSensFadType modelPar_DWQ=mod.DWQ;
  bool modelPar_given_DWQ=mod.given("DWQ");
  AdmsSensFadType modelPar_VFBO=mod.VFBO;
  bool modelPar_given_VFBO=mod.given("VFBO");
  AdmsSensFadType modelPar_VFBL=mod.VFBL;
  bool modelPar_given_VFBL=mod.given("VFBL");
  AdmsSensFadType modelPar_VFBW=mod.VFBW;
  bool modelPar_given_VFBW=mod.given("VFBW");
  AdmsSensFadType modelPar_VFBLW=mod.VFBLW;
  bool modelPar_given_VFBLW=mod.given("VFBLW");
  AdmsSensFadType modelPar_STVFBO=mod.STVFBO;
  bool modelPar_given_STVFBO=mod.given("STVFBO");
  AdmsSensFadType modelPar_STVFBL=mod.STVFBL;
  bool modelPar_given_STVFBL=mod.given("STVFBL");
  AdmsSensFadType modelPar_STVFBW=mod.STVFBW;
  bool modelPar_given_STVFBW=mod.given("STVFBW");
  AdmsSensFadType modelPar_STVFBLW=mod.STVFBLW;
  bool modelPar_given_STVFBLW=mod.given("STVFBLW");
  AdmsSensFadType modelPar_TOXO=mod.TOXO;
  bool modelPar_given_TOXO=mod.given("TOXO");
  AdmsSensFadType modelPar_EPSROXO=mod.EPSROXO;
  bool modelPar_given_EPSROXO=mod.given("EPSROXO");
  AdmsSensFadType modelPar_NSUBO=mod.NSUBO;
  bool modelPar_given_NSUBO=mod.given("NSUBO");
  AdmsSensFadType modelPar_NSUBW=mod.NSUBW;
  bool modelPar_given_NSUBW=mod.given("NSUBW");
  AdmsSensFadType modelPar_WSEG=mod.WSEG;
  bool modelPar_given_WSEG=mod.given("WSEG");
  AdmsSensFadType modelPar_NPCK=mod.NPCK;
  bool modelPar_given_NPCK=mod.given("NPCK");
  AdmsSensFadType modelPar_NPCKW=mod.NPCKW;
  bool modelPar_given_NPCKW=mod.given("NPCKW");
  AdmsSensFadType modelPar_WSEGP=mod.WSEGP;
  bool modelPar_given_WSEGP=mod.given("WSEGP");
  AdmsSensFadType modelPar_LPCK=mod.LPCK;
  bool modelPar_given_LPCK=mod.given("LPCK");
  AdmsSensFadType modelPar_LPCKW=mod.LPCKW;
  bool modelPar_given_LPCKW=mod.given("LPCKW");
  AdmsSensFadType modelPar_FOL1=mod.FOL1;
  bool modelPar_given_FOL1=mod.given("FOL1");
  AdmsSensFadType modelPar_FOL2=mod.FOL2;
  bool modelPar_given_FOL2=mod.given("FOL2");
  AdmsSensFadType modelPar_FACNEFFACO=mod.FACNEFFACO;
  bool modelPar_given_FACNEFFACO=mod.given("FACNEFFACO");
  AdmsSensFadType modelPar_FACNEFFACL=mod.FACNEFFACL;
  bool modelPar_given_FACNEFFACL=mod.given("FACNEFFACL");
  AdmsSensFadType modelPar_FACNEFFACW=mod.FACNEFFACW;
  bool modelPar_given_FACNEFFACW=mod.given("FACNEFFACW");
  AdmsSensFadType modelPar_FACNEFFACLW=mod.FACNEFFACLW;
  bool modelPar_given_FACNEFFACLW=mod.given("FACNEFFACLW");
  AdmsSensFadType modelPar_GFACNUDO=mod.GFACNUDO;
  bool modelPar_given_GFACNUDO=mod.given("GFACNUDO");
  AdmsSensFadType modelPar_GFACNUDL=mod.GFACNUDL;
  bool modelPar_given_GFACNUDL=mod.given("GFACNUDL");
  AdmsSensFadType modelPar_GFACNUDLEXP=mod.GFACNUDLEXP;
  bool modelPar_given_GFACNUDLEXP=mod.given("GFACNUDLEXP");
  AdmsSensFadType modelPar_GFACNUDW=mod.GFACNUDW;
  bool modelPar_given_GFACNUDW=mod.given("GFACNUDW");
  AdmsSensFadType modelPar_GFACNUDLW=mod.GFACNUDLW;
  bool modelPar_given_GFACNUDLW=mod.given("GFACNUDLW");
  AdmsSensFadType modelPar_VSBNUDO=mod.VSBNUDO;
  bool modelPar_given_VSBNUDO=mod.given("VSBNUDO");
  AdmsSensFadType modelPar_DVSBNUDO=mod.DVSBNUDO;
  bool modelPar_given_DVSBNUDO=mod.given("DVSBNUDO");
  AdmsSensFadType modelPar_VNSUBO=mod.VNSUBO;
  bool modelPar_given_VNSUBO=mod.given("VNSUBO");
  AdmsSensFadType modelPar_NSLPO=mod.NSLPO;
  bool modelPar_given_NSLPO=mod.given("NSLPO");
  AdmsSensFadType modelPar_DNSUBO=mod.DNSUBO;
  bool modelPar_given_DNSUBO=mod.given("DNSUBO");
  AdmsSensFadType modelPar_DPHIBO=mod.DPHIBO;
  bool modelPar_given_DPHIBO=mod.given("DPHIBO");
  AdmsSensFadType modelPar_DPHIBL=mod.DPHIBL;
  bool modelPar_given_DPHIBL=mod.given("DPHIBL");
  AdmsSensFadType modelPar_DPHIBLEXP=mod.DPHIBLEXP;
  bool modelPar_given_DPHIBLEXP=mod.given("DPHIBLEXP");
  AdmsSensFadType modelPar_DPHIBW=mod.DPHIBW;
  bool modelPar_given_DPHIBW=mod.given("DPHIBW");
  AdmsSensFadType modelPar_DPHIBLW=mod.DPHIBLW;
  bool modelPar_given_DPHIBLW=mod.given("DPHIBLW");
  AdmsSensFadType modelPar_DELVTACO=mod.DELVTACO;
  bool modelPar_given_DELVTACO=mod.given("DELVTACO");
  AdmsSensFadType modelPar_DELVTACL=mod.DELVTACL;
  bool modelPar_given_DELVTACL=mod.given("DELVTACL");
  AdmsSensFadType modelPar_DELVTACLEXP=mod.DELVTACLEXP;
  bool modelPar_given_DELVTACLEXP=mod.given("DELVTACLEXP");
  AdmsSensFadType modelPar_DELVTACW=mod.DELVTACW;
  bool modelPar_given_DELVTACW=mod.given("DELVTACW");
  AdmsSensFadType modelPar_DELVTACLW=mod.DELVTACLW;
  bool modelPar_given_DELVTACLW=mod.given("DELVTACLW");
  AdmsSensFadType modelPar_NPO=mod.NPO;
  bool modelPar_given_NPO=mod.given("NPO");
  AdmsSensFadType modelPar_NPL=mod.NPL;
  bool modelPar_given_NPL=mod.given("NPL");
  AdmsSensFadType modelPar_CTO=mod.CTO;
  bool modelPar_given_CTO=mod.given("CTO");
  AdmsSensFadType modelPar_CTL=mod.CTL;
  bool modelPar_given_CTL=mod.given("CTL");
  AdmsSensFadType modelPar_CTLEXP=mod.CTLEXP;
  bool modelPar_given_CTLEXP=mod.given("CTLEXP");
  AdmsSensFadType modelPar_CTW=mod.CTW;
  bool modelPar_given_CTW=mod.given("CTW");
  AdmsSensFadType modelPar_CTLW=mod.CTLW;
  bool modelPar_given_CTLW=mod.given("CTLW");
  AdmsSensFadType modelPar_TOXOVO=mod.TOXOVO;
  bool modelPar_given_TOXOVO=mod.given("TOXOVO");
  AdmsSensFadType modelPar_TOXOVDO=mod.TOXOVDO;
  bool modelPar_given_TOXOVDO=mod.given("TOXOVDO");
  AdmsSensFadType modelPar_LOV=mod.LOV;
  bool modelPar_given_LOV=mod.given("LOV");
  AdmsSensFadType modelPar_LOVD=mod.LOVD;
  bool modelPar_given_LOVD=mod.given("LOVD");
  AdmsSensFadType modelPar_NOVO=mod.NOVO;
  bool modelPar_given_NOVO=mod.given("NOVO");
  AdmsSensFadType modelPar_NOVDO=mod.NOVDO;
  bool modelPar_given_NOVDO=mod.given("NOVDO");
  AdmsSensFadType modelPar_CFL=mod.CFL;
  bool modelPar_given_CFL=mod.given("CFL");
  AdmsSensFadType modelPar_CFLEXP=mod.CFLEXP;
  bool modelPar_given_CFLEXP=mod.given("CFLEXP");
  AdmsSensFadType modelPar_CFW=mod.CFW;
  bool modelPar_given_CFW=mod.given("CFW");
  AdmsSensFadType modelPar_CFDO=mod.CFDO;
  bool modelPar_given_CFDO=mod.given("CFDO");
  AdmsSensFadType modelPar_CFBO=mod.CFBO;
  bool modelPar_given_CFBO=mod.given("CFBO");
  AdmsSensFadType modelPar_PSCEL=mod.PSCEL;
  bool modelPar_given_PSCEL=mod.given("PSCEL");
  AdmsSensFadType modelPar_PSCELEXP=mod.PSCELEXP;
  bool modelPar_given_PSCELEXP=mod.given("PSCELEXP");
  AdmsSensFadType modelPar_PSCEW=mod.PSCEW;
  bool modelPar_given_PSCEW=mod.given("PSCEW");
  AdmsSensFadType modelPar_PSCEBO=mod.PSCEBO;
  bool modelPar_given_PSCEBO=mod.given("PSCEBO");
  AdmsSensFadType modelPar_PSCEDO=mod.PSCEDO;
  bool modelPar_given_PSCEDO=mod.given("PSCEDO");
  AdmsSensFadType modelPar_UO=mod.UO;
  bool modelPar_given_UO=mod.given("UO");
  AdmsSensFadType modelPar_FBET1=mod.FBET1;
  bool modelPar_given_FBET1=mod.given("FBET1");
  AdmsSensFadType modelPar_FBET1W=mod.FBET1W;
  bool modelPar_given_FBET1W=mod.given("FBET1W");
  AdmsSensFadType modelPar_LP1=mod.LP1;
  bool modelPar_given_LP1=mod.given("LP1");
  AdmsSensFadType modelPar_LP1W=mod.LP1W;
  bool modelPar_given_LP1W=mod.given("LP1W");
  AdmsSensFadType modelPar_FBET2=mod.FBET2;
  bool modelPar_given_FBET2=mod.given("FBET2");
  AdmsSensFadType modelPar_LP2=mod.LP2;
  bool modelPar_given_LP2=mod.given("LP2");
  AdmsSensFadType modelPar_BETW1=mod.BETW1;
  bool modelPar_given_BETW1=mod.given("BETW1");
  AdmsSensFadType modelPar_BETW2=mod.BETW2;
  bool modelPar_given_BETW2=mod.given("BETW2");
  AdmsSensFadType modelPar_WBET=mod.WBET;
  bool modelPar_given_WBET=mod.given("WBET");
  AdmsSensFadType modelPar_STBETO=mod.STBETO;
  bool modelPar_given_STBETO=mod.given("STBETO");
  AdmsSensFadType modelPar_STBETL=mod.STBETL;
  bool modelPar_given_STBETL=mod.given("STBETL");
  AdmsSensFadType modelPar_STBETW=mod.STBETW;
  bool modelPar_given_STBETW=mod.given("STBETW");
  AdmsSensFadType modelPar_STBETLW=mod.STBETLW;
  bool modelPar_given_STBETLW=mod.given("STBETLW");
  AdmsSensFadType modelPar_MUEO=mod.MUEO;
  bool modelPar_given_MUEO=mod.given("MUEO");
  AdmsSensFadType modelPar_MUEW=mod.MUEW;
  bool modelPar_given_MUEW=mod.given("MUEW");
  AdmsSensFadType modelPar_STMUEO=mod.STMUEO;
  bool modelPar_given_STMUEO=mod.given("STMUEO");
  AdmsSensFadType modelPar_THEMUO=mod.THEMUO;
  bool modelPar_given_THEMUO=mod.given("THEMUO");
  AdmsSensFadType modelPar_STTHEMUO=mod.STTHEMUO;
  bool modelPar_given_STTHEMUO=mod.given("STTHEMUO");
  AdmsSensFadType modelPar_CSO=mod.CSO;
  bool modelPar_given_CSO=mod.given("CSO");
  AdmsSensFadType modelPar_CSL=mod.CSL;
  bool modelPar_given_CSL=mod.given("CSL");
  AdmsSensFadType modelPar_CSLEXP=mod.CSLEXP;
  bool modelPar_given_CSLEXP=mod.given("CSLEXP");
  AdmsSensFadType modelPar_CSW=mod.CSW;
  bool modelPar_given_CSW=mod.given("CSW");
  AdmsSensFadType modelPar_CSLW=mod.CSLW;
  bool modelPar_given_CSLW=mod.given("CSLW");
  AdmsSensFadType modelPar_STCSO=mod.STCSO;
  bool modelPar_given_STCSO=mod.given("STCSO");
  AdmsSensFadType modelPar_XCORO=mod.XCORO;
  bool modelPar_given_XCORO=mod.given("XCORO");
  AdmsSensFadType modelPar_XCORL=mod.XCORL;
  bool modelPar_given_XCORL=mod.given("XCORL");
  AdmsSensFadType modelPar_XCORW=mod.XCORW;
  bool modelPar_given_XCORW=mod.given("XCORW");
  AdmsSensFadType modelPar_XCORLW=mod.XCORLW;
  bool modelPar_given_XCORLW=mod.given("XCORLW");
  AdmsSensFadType modelPar_STXCORO=mod.STXCORO;
  bool modelPar_given_STXCORO=mod.given("STXCORO");
  AdmsSensFadType modelPar_FETAO=mod.FETAO;
  bool modelPar_given_FETAO=mod.given("FETAO");
  AdmsSensFadType modelPar_RSW1=mod.RSW1;
  bool modelPar_given_RSW1=mod.given("RSW1");
  AdmsSensFadType modelPar_RSW2=mod.RSW2;
  bool modelPar_given_RSW2=mod.given("RSW2");
  AdmsSensFadType modelPar_STRSO=mod.STRSO;
  bool modelPar_given_STRSO=mod.given("STRSO");
  AdmsSensFadType modelPar_RSBO=mod.RSBO;
  bool modelPar_given_RSBO=mod.given("RSBO");
  AdmsSensFadType modelPar_RSGO=mod.RSGO;
  bool modelPar_given_RSGO=mod.given("RSGO");
  AdmsSensFadType modelPar_THESATO=mod.THESATO;
  bool modelPar_given_THESATO=mod.given("THESATO");
  AdmsSensFadType modelPar_THESATL=mod.THESATL;
  bool modelPar_given_THESATL=mod.given("THESATL");
  AdmsSensFadType modelPar_THESATLEXP=mod.THESATLEXP;
  bool modelPar_given_THESATLEXP=mod.given("THESATLEXP");
  AdmsSensFadType modelPar_THESATW=mod.THESATW;
  bool modelPar_given_THESATW=mod.given("THESATW");
  AdmsSensFadType modelPar_THESATLW=mod.THESATLW;
  bool modelPar_given_THESATLW=mod.given("THESATLW");
  AdmsSensFadType modelPar_STTHESATO=mod.STTHESATO;
  bool modelPar_given_STTHESATO=mod.given("STTHESATO");
  AdmsSensFadType modelPar_STTHESATL=mod.STTHESATL;
  bool modelPar_given_STTHESATL=mod.given("STTHESATL");
  AdmsSensFadType modelPar_STTHESATW=mod.STTHESATW;
  bool modelPar_given_STTHESATW=mod.given("STTHESATW");
  AdmsSensFadType modelPar_STTHESATLW=mod.STTHESATLW;
  bool modelPar_given_STTHESATLW=mod.given("STTHESATLW");
  AdmsSensFadType modelPar_THESATBO=mod.THESATBO;
  bool modelPar_given_THESATBO=mod.given("THESATBO");
  AdmsSensFadType modelPar_THESATGO=mod.THESATGO;
  bool modelPar_given_THESATGO=mod.given("THESATGO");
  AdmsSensFadType modelPar_AXO=mod.AXO;
  bool modelPar_given_AXO=mod.given("AXO");
  AdmsSensFadType modelPar_AXL=mod.AXL;
  bool modelPar_given_AXL=mod.given("AXL");
  AdmsSensFadType modelPar_ALPL=mod.ALPL;
  bool modelPar_given_ALPL=mod.given("ALPL");
  AdmsSensFadType modelPar_ALPLEXP=mod.ALPLEXP;
  bool modelPar_given_ALPLEXP=mod.given("ALPLEXP");
  AdmsSensFadType modelPar_ALPW=mod.ALPW;
  bool modelPar_given_ALPW=mod.given("ALPW");
  AdmsSensFadType modelPar_ALP1L1=mod.ALP1L1;
  bool modelPar_given_ALP1L1=mod.given("ALP1L1");
  AdmsSensFadType modelPar_ALP1LEXP=mod.ALP1LEXP;
  bool modelPar_given_ALP1LEXP=mod.given("ALP1LEXP");
  AdmsSensFadType modelPar_ALP1L2=mod.ALP1L2;
  bool modelPar_given_ALP1L2=mod.given("ALP1L2");
  AdmsSensFadType modelPar_ALP1W=mod.ALP1W;
  bool modelPar_given_ALP1W=mod.given("ALP1W");
  AdmsSensFadType modelPar_ALP2L1=mod.ALP2L1;
  bool modelPar_given_ALP2L1=mod.given("ALP2L1");
  AdmsSensFadType modelPar_ALP2LEXP=mod.ALP2LEXP;
  bool modelPar_given_ALP2LEXP=mod.given("ALP2LEXP");
  AdmsSensFadType modelPar_ALP2L2=mod.ALP2L2;
  bool modelPar_given_ALP2L2=mod.given("ALP2L2");
  AdmsSensFadType modelPar_ALP2W=mod.ALP2W;
  bool modelPar_given_ALP2W=mod.given("ALP2W");
  AdmsSensFadType modelPar_VPO=mod.VPO;
  bool modelPar_given_VPO=mod.given("VPO");
  AdmsSensFadType modelPar_A1O=mod.A1O;
  bool modelPar_given_A1O=mod.given("A1O");
  AdmsSensFadType modelPar_A1L=mod.A1L;
  bool modelPar_given_A1L=mod.given("A1L");
  AdmsSensFadType modelPar_A1W=mod.A1W;
  bool modelPar_given_A1W=mod.given("A1W");
  AdmsSensFadType modelPar_A2O=mod.A2O;
  bool modelPar_given_A2O=mod.given("A2O");
  AdmsSensFadType modelPar_STA2O=mod.STA2O;
  bool modelPar_given_STA2O=mod.given("STA2O");
  AdmsSensFadType modelPar_A3O=mod.A3O;
  bool modelPar_given_A3O=mod.given("A3O");
  AdmsSensFadType modelPar_A3L=mod.A3L;
  bool modelPar_given_A3L=mod.given("A3L");
  AdmsSensFadType modelPar_A3W=mod.A3W;
  bool modelPar_given_A3W=mod.given("A3W");
  AdmsSensFadType modelPar_A4O=mod.A4O;
  bool modelPar_given_A4O=mod.given("A4O");
  AdmsSensFadType modelPar_A4L=mod.A4L;
  bool modelPar_given_A4L=mod.given("A4L");
  AdmsSensFadType modelPar_A4W=mod.A4W;
  bool modelPar_given_A4W=mod.given("A4W");
  AdmsSensFadType modelPar_GCOO=mod.GCOO;
  bool modelPar_given_GCOO=mod.given("GCOO");
  AdmsSensFadType modelPar_IGINVLW=mod.IGINVLW;
  bool modelPar_given_IGINVLW=mod.given("IGINVLW");
  AdmsSensFadType modelPar_IGOVW=mod.IGOVW;
  bool modelPar_given_IGOVW=mod.given("IGOVW");
  AdmsSensFadType modelPar_IGOVDW=mod.IGOVDW;
  bool modelPar_given_IGOVDW=mod.given("IGOVDW");
  AdmsSensFadType modelPar_STIGO=mod.STIGO;
  bool modelPar_given_STIGO=mod.given("STIGO");
  AdmsSensFadType modelPar_GC2O=mod.GC2O;
  bool modelPar_given_GC2O=mod.given("GC2O");
  AdmsSensFadType modelPar_GC3O=mod.GC3O;
  bool modelPar_given_GC3O=mod.given("GC3O");
  AdmsSensFadType modelPar_CHIBO=mod.CHIBO;
  bool modelPar_given_CHIBO=mod.given("CHIBO");
  AdmsSensFadType modelPar_AGIDLW=mod.AGIDLW;
  bool modelPar_given_AGIDLW=mod.given("AGIDLW");
  AdmsSensFadType modelPar_AGIDLDW=mod.AGIDLDW;
  bool modelPar_given_AGIDLDW=mod.given("AGIDLDW");
  AdmsSensFadType modelPar_BGIDLO=mod.BGIDLO;
  bool modelPar_given_BGIDLO=mod.given("BGIDLO");
  AdmsSensFadType modelPar_BGIDLDO=mod.BGIDLDO;
  bool modelPar_given_BGIDLDO=mod.given("BGIDLDO");
  AdmsSensFadType modelPar_STBGIDLO=mod.STBGIDLO;
  bool modelPar_given_STBGIDLO=mod.given("STBGIDLO");
  AdmsSensFadType modelPar_STBGIDLDO=mod.STBGIDLDO;
  bool modelPar_given_STBGIDLDO=mod.given("STBGIDLDO");
  AdmsSensFadType modelPar_CGIDLO=mod.CGIDLO;
  bool modelPar_given_CGIDLO=mod.given("CGIDLO");
  AdmsSensFadType modelPar_CGIDLDO=mod.CGIDLDO;
  bool modelPar_given_CGIDLDO=mod.given("CGIDLDO");
  AdmsSensFadType modelPar_CGBOVL=mod.CGBOVL;
  bool modelPar_given_CGBOVL=mod.given("CGBOVL");
  AdmsSensFadType modelPar_CFRW=mod.CFRW;
  bool modelPar_given_CFRW=mod.given("CFRW");
  AdmsSensFadType modelPar_CFRDW=mod.CFRDW;
  bool modelPar_given_CFRDW=mod.given("CFRDW");
  AdmsSensFadType modelPar_FNTO=mod.FNTO;
  bool modelPar_given_FNTO=mod.given("FNTO");
  AdmsSensFadType modelPar_FNTEXCL=mod.FNTEXCL;
  bool modelPar_given_FNTEXCL=mod.given("FNTEXCL");
  AdmsSensFadType modelPar_NFALW=mod.NFALW;
  bool modelPar_given_NFALW=mod.given("NFALW");
  AdmsSensFadType modelPar_NFBLW=mod.NFBLW;
  bool modelPar_given_NFBLW=mod.given("NFBLW");
  AdmsSensFadType modelPar_NFCLW=mod.NFCLW;
  bool modelPar_given_NFCLW=mod.given("NFCLW");
  AdmsSensFadType modelPar_EFO=mod.EFO;
  bool modelPar_given_EFO=mod.given("EFO");
  AdmsSensFadType modelPar_LINTNOI=mod.LINTNOI;
  bool modelPar_given_LINTNOI=mod.given("LINTNOI");
  AdmsSensFadType modelPar_ALPNOI=mod.ALPNOI;
  bool modelPar_given_ALPNOI=mod.given("ALPNOI");
  AdmsSensFadType modelPar_WEDGE=mod.WEDGE;
  bool modelPar_given_WEDGE=mod.given("WEDGE");
  AdmsSensFadType modelPar_WEDGEW=mod.WEDGEW;
  bool modelPar_given_WEDGEW=mod.given("WEDGEW");
  AdmsSensFadType modelPar_VFBEDGEO=mod.VFBEDGEO;
  bool modelPar_given_VFBEDGEO=mod.given("VFBEDGEO");
  AdmsSensFadType modelPar_STVFBEDGEO=mod.STVFBEDGEO;
  bool modelPar_given_STVFBEDGEO=mod.given("STVFBEDGEO");
  AdmsSensFadType modelPar_STVFBEDGEL=mod.STVFBEDGEL;
  bool modelPar_given_STVFBEDGEL=mod.given("STVFBEDGEL");
  AdmsSensFadType modelPar_STVFBEDGEW=mod.STVFBEDGEW;
  bool modelPar_given_STVFBEDGEW=mod.given("STVFBEDGEW");
  AdmsSensFadType modelPar_STVFBEDGELW=mod.STVFBEDGELW;
  bool modelPar_given_STVFBEDGELW=mod.given("STVFBEDGELW");
  AdmsSensFadType modelPar_DPHIBEDGEO=mod.DPHIBEDGEO;
  bool modelPar_given_DPHIBEDGEO=mod.given("DPHIBEDGEO");
  AdmsSensFadType modelPar_DPHIBEDGEL=mod.DPHIBEDGEL;
  bool modelPar_given_DPHIBEDGEL=mod.given("DPHIBEDGEL");
  AdmsSensFadType modelPar_DPHIBEDGELEXP=mod.DPHIBEDGELEXP;
  bool modelPar_given_DPHIBEDGELEXP=mod.given("DPHIBEDGELEXP");
  AdmsSensFadType modelPar_DPHIBEDGEW=mod.DPHIBEDGEW;
  bool modelPar_given_DPHIBEDGEW=mod.given("DPHIBEDGEW");
  AdmsSensFadType modelPar_DPHIBEDGELW=mod.DPHIBEDGELW;
  bool modelPar_given_DPHIBEDGELW=mod.given("DPHIBEDGELW");
  AdmsSensFadType modelPar_NSUBEDGEO=mod.NSUBEDGEO;
  bool modelPar_given_NSUBEDGEO=mod.given("NSUBEDGEO");
  AdmsSensFadType modelPar_NSUBEDGEL=mod.NSUBEDGEL;
  bool modelPar_given_NSUBEDGEL=mod.given("NSUBEDGEL");
  AdmsSensFadType modelPar_NSUBEDGEW=mod.NSUBEDGEW;
  bool modelPar_given_NSUBEDGEW=mod.given("NSUBEDGEW");
  AdmsSensFadType modelPar_NSUBEDGELW=mod.NSUBEDGELW;
  bool modelPar_given_NSUBEDGELW=mod.given("NSUBEDGELW");
  AdmsSensFadType modelPar_CTEDGEO=mod.CTEDGEO;
  bool modelPar_given_CTEDGEO=mod.given("CTEDGEO");
  AdmsSensFadType modelPar_CTEDGEL=mod.CTEDGEL;
  bool modelPar_given_CTEDGEL=mod.given("CTEDGEL");
  AdmsSensFadType modelPar_CTEDGELEXP=mod.CTEDGELEXP;
  bool modelPar_given_CTEDGELEXP=mod.given("CTEDGELEXP");
  AdmsSensFadType modelPar_FBETEDGE=mod.FBETEDGE;
  bool modelPar_given_FBETEDGE=mod.given("FBETEDGE");
  AdmsSensFadType modelPar_LPEDGE=mod.LPEDGE;
  bool modelPar_given_LPEDGE=mod.given("LPEDGE");
  AdmsSensFadType modelPar_BETEDGEW=mod.BETEDGEW;
  bool modelPar_given_BETEDGEW=mod.given("BETEDGEW");
  AdmsSensFadType modelPar_STBETEDGEO=mod.STBETEDGEO;
  bool modelPar_given_STBETEDGEO=mod.given("STBETEDGEO");
  AdmsSensFadType modelPar_STBETEDGEL=mod.STBETEDGEL;
  bool modelPar_given_STBETEDGEL=mod.given("STBETEDGEL");
  AdmsSensFadType modelPar_STBETEDGEW=mod.STBETEDGEW;
  bool modelPar_given_STBETEDGEW=mod.given("STBETEDGEW");
  AdmsSensFadType modelPar_STBETEDGELW=mod.STBETEDGELW;
  bool modelPar_given_STBETEDGELW=mod.given("STBETEDGELW");
  AdmsSensFadType modelPar_PSCEEDGEL=mod.PSCEEDGEL;
  bool modelPar_given_PSCEEDGEL=mod.given("PSCEEDGEL");
  AdmsSensFadType modelPar_PSCEEDGELEXP=mod.PSCEEDGELEXP;
  bool modelPar_given_PSCEEDGELEXP=mod.given("PSCEEDGELEXP");
  AdmsSensFadType modelPar_PSCEEDGEW=mod.PSCEEDGEW;
  bool modelPar_given_PSCEEDGEW=mod.given("PSCEEDGEW");
  AdmsSensFadType modelPar_PSCEBEDGEO=mod.PSCEBEDGEO;
  bool modelPar_given_PSCEBEDGEO=mod.given("PSCEBEDGEO");
  AdmsSensFadType modelPar_PSCEDEDGEO=mod.PSCEDEDGEO;
  bool modelPar_given_PSCEDEDGEO=mod.given("PSCEDEDGEO");
  AdmsSensFadType modelPar_CFEDGEL=mod.CFEDGEL;
  bool modelPar_given_CFEDGEL=mod.given("CFEDGEL");
  AdmsSensFadType modelPar_CFEDGELEXP=mod.CFEDGELEXP;
  bool modelPar_given_CFEDGELEXP=mod.given("CFEDGELEXP");
  AdmsSensFadType modelPar_CFEDGEW=mod.CFEDGEW;
  bool modelPar_given_CFEDGEW=mod.given("CFEDGEW");
  AdmsSensFadType modelPar_CFDEDGEO=mod.CFDEDGEO;
  bool modelPar_given_CFDEDGEO=mod.given("CFDEDGEO");
  AdmsSensFadType modelPar_CFBEDGEO=mod.CFBEDGEO;
  bool modelPar_given_CFBEDGEO=mod.given("CFBEDGEO");
  AdmsSensFadType modelPar_FNTEDGEO=mod.FNTEDGEO;
  bool modelPar_given_FNTEDGEO=mod.given("FNTEDGEO");
  AdmsSensFadType modelPar_NFAEDGELW=mod.NFAEDGELW;
  bool modelPar_given_NFAEDGELW=mod.given("NFAEDGELW");
  AdmsSensFadType modelPar_NFBEDGELW=mod.NFBEDGELW;
  bool modelPar_given_NFBEDGELW=mod.given("NFBEDGELW");
  AdmsSensFadType modelPar_NFCEDGELW=mod.NFCEDGELW;
  bool modelPar_given_NFCEDGELW=mod.given("NFCEDGELW");
  AdmsSensFadType modelPar_EFEDGEO=mod.EFEDGEO;
  bool modelPar_given_EFEDGEO=mod.given("EFEDGEO");
  AdmsSensFadType modelPar_KVTHOWEO=mod.KVTHOWEO;
  bool modelPar_given_KVTHOWEO=mod.given("KVTHOWEO");
  AdmsSensFadType modelPar_KVTHOWEL=mod.KVTHOWEL;
  bool modelPar_given_KVTHOWEL=mod.given("KVTHOWEL");
  AdmsSensFadType modelPar_KVTHOWEW=mod.KVTHOWEW;
  bool modelPar_given_KVTHOWEW=mod.given("KVTHOWEW");
  AdmsSensFadType modelPar_KVTHOWELW=mod.KVTHOWELW;
  bool modelPar_given_KVTHOWELW=mod.given("KVTHOWELW");
  AdmsSensFadType modelPar_KUOWEO=mod.KUOWEO;
  bool modelPar_given_KUOWEO=mod.given("KUOWEO");
  AdmsSensFadType modelPar_KUOWEL=mod.KUOWEL;
  bool modelPar_given_KUOWEL=mod.given("KUOWEL");
  AdmsSensFadType modelPar_KUOWEW=mod.KUOWEW;
  bool modelPar_given_KUOWEW=mod.given("KUOWEW");
  AdmsSensFadType modelPar_KUOWELW=mod.KUOWELW;
  bool modelPar_given_KUOWELW=mod.given("KUOWELW");
  AdmsSensFadType modelPar_RGO=mod.RGO;
  bool modelPar_given_RGO=mod.given("RGO");
  AdmsSensFadType modelPar_RINT=mod.RINT;
  bool modelPar_given_RINT=mod.given("RINT");
  AdmsSensFadType modelPar_RVPOLY=mod.RVPOLY;
  bool modelPar_given_RVPOLY=mod.given("RVPOLY");
  AdmsSensFadType modelPar_RSHG=mod.RSHG;
  bool modelPar_given_RSHG=mod.given("RSHG");
  AdmsSensFadType modelPar_DLSIL=mod.DLSIL;
  bool modelPar_given_DLSIL=mod.given("DLSIL");
  AdmsSensFadType modelPar_RSH=mod.RSH;
  bool modelPar_given_RSH=mod.given("RSH");
  AdmsSensFadType modelPar_RSHD=mod.RSHD;
  bool modelPar_given_RSHD=mod.given("RSHD");
  AdmsSensFadType modelPar_RBULKO=mod.RBULKO;
  bool modelPar_given_RBULKO=mod.given("RBULKO");
  AdmsSensFadType modelPar_RWELLO=mod.RWELLO;
  bool modelPar_given_RWELLO=mod.given("RWELLO");
  AdmsSensFadType modelPar_RJUNSO=mod.RJUNSO;
  bool modelPar_given_RJUNSO=mod.given("RJUNSO");
  AdmsSensFadType modelPar_RJUNDO=mod.RJUNDO;
  bool modelPar_given_RJUNDO=mod.given("RJUNDO");
  AdmsSensFadType modelPar_SAREF=mod.SAREF;
  bool modelPar_given_SAREF=mod.given("SAREF");
  AdmsSensFadType modelPar_SBREF=mod.SBREF;
  bool modelPar_given_SBREF=mod.given("SBREF");
  AdmsSensFadType modelPar_WLOD=mod.WLOD;
  bool modelPar_given_WLOD=mod.given("WLOD");
  AdmsSensFadType modelPar_KUO=mod.KUO;
  bool modelPar_given_KUO=mod.given("KUO");
  AdmsSensFadType modelPar_KVSAT=mod.KVSAT;
  bool modelPar_given_KVSAT=mod.given("KVSAT");
  AdmsSensFadType modelPar_TKUO=mod.TKUO;
  bool modelPar_given_TKUO=mod.given("TKUO");
  AdmsSensFadType modelPar_LKUO=mod.LKUO;
  bool modelPar_given_LKUO=mod.given("LKUO");
  AdmsSensFadType modelPar_WKUO=mod.WKUO;
  bool modelPar_given_WKUO=mod.given("WKUO");
  AdmsSensFadType modelPar_PKUO=mod.PKUO;
  bool modelPar_given_PKUO=mod.given("PKUO");
  AdmsSensFadType modelPar_LLODKUO=mod.LLODKUO;
  bool modelPar_given_LLODKUO=mod.given("LLODKUO");
  AdmsSensFadType modelPar_WLODKUO=mod.WLODKUO;
  bool modelPar_given_WLODKUO=mod.given("WLODKUO");
  AdmsSensFadType modelPar_KVTHO=mod.KVTHO;
  bool modelPar_given_KVTHO=mod.given("KVTHO");
  AdmsSensFadType modelPar_LKVTHO=mod.LKVTHO;
  bool modelPar_given_LKVTHO=mod.given("LKVTHO");
  AdmsSensFadType modelPar_WKVTHO=mod.WKVTHO;
  bool modelPar_given_WKVTHO=mod.given("WKVTHO");
  AdmsSensFadType modelPar_PKVTHO=mod.PKVTHO;
  bool modelPar_given_PKVTHO=mod.given("PKVTHO");
  AdmsSensFadType modelPar_LLODVTH=mod.LLODVTH;
  bool modelPar_given_LLODVTH=mod.given("LLODVTH");
  AdmsSensFadType modelPar_WLODVTH=mod.WLODVTH;
  bool modelPar_given_WLODVTH=mod.given("WLODVTH");
  AdmsSensFadType modelPar_STETAO=mod.STETAO;
  bool modelPar_given_STETAO=mod.given("STETAO");
  AdmsSensFadType modelPar_LODETAO=mod.LODETAO;
  bool modelPar_given_LODETAO=mod.given("LODETAO");
  AdmsSensFadType modelPar_SCREF=mod.SCREF;
  bool modelPar_given_SCREF=mod.given("SCREF");
  AdmsSensFadType modelPar_WEB=mod.WEB;
  bool modelPar_given_WEB=mod.given("WEB");
  AdmsSensFadType modelPar_WEC=mod.WEC;
  bool modelPar_given_WEC=mod.given("WEC");
  AdmsSensFadType modelPar_IMAX=mod.IMAX;
  bool modelPar_given_IMAX=mod.given("IMAX");
  AdmsSensFadType modelPar_TRJ=mod.TRJ;
  bool modelPar_given_TRJ=mod.given("TRJ");
  AdmsSensFadType modelPar_FREV=mod.FREV;
  bool modelPar_given_FREV=mod.given("FREV");
  AdmsSensFadType modelPar_CJORBOT=mod.CJORBOT;
  bool modelPar_given_CJORBOT=mod.given("CJORBOT");
  AdmsSensFadType modelPar_CJORSTI=mod.CJORSTI;
  bool modelPar_given_CJORSTI=mod.given("CJORSTI");
  AdmsSensFadType modelPar_CJORGAT=mod.CJORGAT;
  bool modelPar_given_CJORGAT=mod.given("CJORGAT");
  AdmsSensFadType modelPar_VBIRBOT=mod.VBIRBOT;
  bool modelPar_given_VBIRBOT=mod.given("VBIRBOT");
  AdmsSensFadType modelPar_VBIRSTI=mod.VBIRSTI;
  bool modelPar_given_VBIRSTI=mod.given("VBIRSTI");
  AdmsSensFadType modelPar_VBIRGAT=mod.VBIRGAT;
  bool modelPar_given_VBIRGAT=mod.given("VBIRGAT");
  AdmsSensFadType modelPar_PBOT=mod.PBOT;
  bool modelPar_given_PBOT=mod.given("PBOT");
  AdmsSensFadType modelPar_PSTI=mod.PSTI;
  bool modelPar_given_PSTI=mod.given("PSTI");
  AdmsSensFadType modelPar_PGAT=mod.PGAT;
  bool modelPar_given_PGAT=mod.given("PGAT");
  AdmsSensFadType modelPar_PHIGBOT=mod.PHIGBOT;
  bool modelPar_given_PHIGBOT=mod.given("PHIGBOT");
  AdmsSensFadType modelPar_PHIGSTI=mod.PHIGSTI;
  bool modelPar_given_PHIGSTI=mod.given("PHIGSTI");
  AdmsSensFadType modelPar_PHIGGAT=mod.PHIGGAT;
  bool modelPar_given_PHIGGAT=mod.given("PHIGGAT");
  AdmsSensFadType modelPar_IDSATRBOT=mod.IDSATRBOT;
  bool modelPar_given_IDSATRBOT=mod.given("IDSATRBOT");
  AdmsSensFadType modelPar_IDSATRSTI=mod.IDSATRSTI;
  bool modelPar_given_IDSATRSTI=mod.given("IDSATRSTI");
  AdmsSensFadType modelPar_IDSATRGAT=mod.IDSATRGAT;
  bool modelPar_given_IDSATRGAT=mod.given("IDSATRGAT");
  AdmsSensFadType modelPar_CSRHBOT=mod.CSRHBOT;
  bool modelPar_given_CSRHBOT=mod.given("CSRHBOT");
  AdmsSensFadType modelPar_CSRHSTI=mod.CSRHSTI;
  bool modelPar_given_CSRHSTI=mod.given("CSRHSTI");
  AdmsSensFadType modelPar_CSRHGAT=mod.CSRHGAT;
  bool modelPar_given_CSRHGAT=mod.given("CSRHGAT");
  AdmsSensFadType modelPar_XJUNSTI=mod.XJUNSTI;
  bool modelPar_given_XJUNSTI=mod.given("XJUNSTI");
  AdmsSensFadType modelPar_XJUNGAT=mod.XJUNGAT;
  bool modelPar_given_XJUNGAT=mod.given("XJUNGAT");
  AdmsSensFadType modelPar_CTATBOT=mod.CTATBOT;
  bool modelPar_given_CTATBOT=mod.given("CTATBOT");
  AdmsSensFadType modelPar_CTATSTI=mod.CTATSTI;
  bool modelPar_given_CTATSTI=mod.given("CTATSTI");
  AdmsSensFadType modelPar_CTATGAT=mod.CTATGAT;
  bool modelPar_given_CTATGAT=mod.given("CTATGAT");
  AdmsSensFadType modelPar_MEFFTATBOT=mod.MEFFTATBOT;
  bool modelPar_given_MEFFTATBOT=mod.given("MEFFTATBOT");
  AdmsSensFadType modelPar_MEFFTATSTI=mod.MEFFTATSTI;
  bool modelPar_given_MEFFTATSTI=mod.given("MEFFTATSTI");
  AdmsSensFadType modelPar_MEFFTATGAT=mod.MEFFTATGAT;
  bool modelPar_given_MEFFTATGAT=mod.given("MEFFTATGAT");
  AdmsSensFadType modelPar_CBBTBOT=mod.CBBTBOT;
  bool modelPar_given_CBBTBOT=mod.given("CBBTBOT");
  AdmsSensFadType modelPar_CBBTSTI=mod.CBBTSTI;
  bool modelPar_given_CBBTSTI=mod.given("CBBTSTI");
  AdmsSensFadType modelPar_CBBTGAT=mod.CBBTGAT;
  bool modelPar_given_CBBTGAT=mod.given("CBBTGAT");
  AdmsSensFadType modelPar_FBBTRBOT=mod.FBBTRBOT;
  bool modelPar_given_FBBTRBOT=mod.given("FBBTRBOT");
  AdmsSensFadType modelPar_FBBTRSTI=mod.FBBTRSTI;
  bool modelPar_given_FBBTRSTI=mod.given("FBBTRSTI");
  AdmsSensFadType modelPar_FBBTRGAT=mod.FBBTRGAT;
  bool modelPar_given_FBBTRGAT=mod.given("FBBTRGAT");
  AdmsSensFadType modelPar_STFBBTBOT=mod.STFBBTBOT;
  bool modelPar_given_STFBBTBOT=mod.given("STFBBTBOT");
  AdmsSensFadType modelPar_STFBBTSTI=mod.STFBBTSTI;
  bool modelPar_given_STFBBTSTI=mod.given("STFBBTSTI");
  AdmsSensFadType modelPar_STFBBTGAT=mod.STFBBTGAT;
  bool modelPar_given_STFBBTGAT=mod.given("STFBBTGAT");
  AdmsSensFadType modelPar_VBRBOT=mod.VBRBOT;
  bool modelPar_given_VBRBOT=mod.given("VBRBOT");
  AdmsSensFadType modelPar_VBRSTI=mod.VBRSTI;
  bool modelPar_given_VBRSTI=mod.given("VBRSTI");
  AdmsSensFadType modelPar_VBRGAT=mod.VBRGAT;
  bool modelPar_given_VBRGAT=mod.given("VBRGAT");
  AdmsSensFadType modelPar_PBRBOT=mod.PBRBOT;
  bool modelPar_given_PBRBOT=mod.given("PBRBOT");
  AdmsSensFadType modelPar_PBRSTI=mod.PBRSTI;
  bool modelPar_given_PBRSTI=mod.given("PBRSTI");
  AdmsSensFadType modelPar_PBRGAT=mod.PBRGAT;
  bool modelPar_given_PBRGAT=mod.given("PBRGAT");
  AdmsSensFadType modelPar_CJORBOTD=mod.CJORBOTD;
  bool modelPar_given_CJORBOTD=mod.given("CJORBOTD");
  AdmsSensFadType modelPar_CJORSTID=mod.CJORSTID;
  bool modelPar_given_CJORSTID=mod.given("CJORSTID");
  AdmsSensFadType modelPar_CJORGATD=mod.CJORGATD;
  bool modelPar_given_CJORGATD=mod.given("CJORGATD");
  AdmsSensFadType modelPar_VBIRBOTD=mod.VBIRBOTD;
  bool modelPar_given_VBIRBOTD=mod.given("VBIRBOTD");
  AdmsSensFadType modelPar_VBIRSTID=mod.VBIRSTID;
  bool modelPar_given_VBIRSTID=mod.given("VBIRSTID");
  AdmsSensFadType modelPar_VBIRGATD=mod.VBIRGATD;
  bool modelPar_given_VBIRGATD=mod.given("VBIRGATD");
  AdmsSensFadType modelPar_PBOTD=mod.PBOTD;
  bool modelPar_given_PBOTD=mod.given("PBOTD");
  AdmsSensFadType modelPar_PSTID=mod.PSTID;
  bool modelPar_given_PSTID=mod.given("PSTID");
  AdmsSensFadType modelPar_PGATD=mod.PGATD;
  bool modelPar_given_PGATD=mod.given("PGATD");
  AdmsSensFadType modelPar_PHIGBOTD=mod.PHIGBOTD;
  bool modelPar_given_PHIGBOTD=mod.given("PHIGBOTD");
  AdmsSensFadType modelPar_PHIGSTID=mod.PHIGSTID;
  bool modelPar_given_PHIGSTID=mod.given("PHIGSTID");
  AdmsSensFadType modelPar_PHIGGATD=mod.PHIGGATD;
  bool modelPar_given_PHIGGATD=mod.given("PHIGGATD");
  AdmsSensFadType modelPar_IDSATRBOTD=mod.IDSATRBOTD;
  bool modelPar_given_IDSATRBOTD=mod.given("IDSATRBOTD");
  AdmsSensFadType modelPar_IDSATRSTID=mod.IDSATRSTID;
  bool modelPar_given_IDSATRSTID=mod.given("IDSATRSTID");
  AdmsSensFadType modelPar_IDSATRGATD=mod.IDSATRGATD;
  bool modelPar_given_IDSATRGATD=mod.given("IDSATRGATD");
  AdmsSensFadType modelPar_CSRHBOTD=mod.CSRHBOTD;
  bool modelPar_given_CSRHBOTD=mod.given("CSRHBOTD");
  AdmsSensFadType modelPar_CSRHSTID=mod.CSRHSTID;
  bool modelPar_given_CSRHSTID=mod.given("CSRHSTID");
  AdmsSensFadType modelPar_CSRHGATD=mod.CSRHGATD;
  bool modelPar_given_CSRHGATD=mod.given("CSRHGATD");
  AdmsSensFadType modelPar_XJUNSTID=mod.XJUNSTID;
  bool modelPar_given_XJUNSTID=mod.given("XJUNSTID");
  AdmsSensFadType modelPar_XJUNGATD=mod.XJUNGATD;
  bool modelPar_given_XJUNGATD=mod.given("XJUNGATD");
  AdmsSensFadType modelPar_CTATBOTD=mod.CTATBOTD;
  bool modelPar_given_CTATBOTD=mod.given("CTATBOTD");
  AdmsSensFadType modelPar_CTATSTID=mod.CTATSTID;
  bool modelPar_given_CTATSTID=mod.given("CTATSTID");
  AdmsSensFadType modelPar_CTATGATD=mod.CTATGATD;
  bool modelPar_given_CTATGATD=mod.given("CTATGATD");
  AdmsSensFadType modelPar_MEFFTATBOTD=mod.MEFFTATBOTD;
  bool modelPar_given_MEFFTATBOTD=mod.given("MEFFTATBOTD");
  AdmsSensFadType modelPar_MEFFTATSTID=mod.MEFFTATSTID;
  bool modelPar_given_MEFFTATSTID=mod.given("MEFFTATSTID");
  AdmsSensFadType modelPar_MEFFTATGATD=mod.MEFFTATGATD;
  bool modelPar_given_MEFFTATGATD=mod.given("MEFFTATGATD");
  AdmsSensFadType modelPar_CBBTBOTD=mod.CBBTBOTD;
  bool modelPar_given_CBBTBOTD=mod.given("CBBTBOTD");
  AdmsSensFadType modelPar_CBBTSTID=mod.CBBTSTID;
  bool modelPar_given_CBBTSTID=mod.given("CBBTSTID");
  AdmsSensFadType modelPar_CBBTGATD=mod.CBBTGATD;
  bool modelPar_given_CBBTGATD=mod.given("CBBTGATD");
  AdmsSensFadType modelPar_FBBTRBOTD=mod.FBBTRBOTD;
  bool modelPar_given_FBBTRBOTD=mod.given("FBBTRBOTD");
  AdmsSensFadType modelPar_FBBTRSTID=mod.FBBTRSTID;
  bool modelPar_given_FBBTRSTID=mod.given("FBBTRSTID");
  AdmsSensFadType modelPar_FBBTRGATD=mod.FBBTRGATD;
  bool modelPar_given_FBBTRGATD=mod.given("FBBTRGATD");
  AdmsSensFadType modelPar_STFBBTBOTD=mod.STFBBTBOTD;
  bool modelPar_given_STFBBTBOTD=mod.given("STFBBTBOTD");
  AdmsSensFadType modelPar_STFBBTSTID=mod.STFBBTSTID;
  bool modelPar_given_STFBBTSTID=mod.given("STFBBTSTID");
  AdmsSensFadType modelPar_STFBBTGATD=mod.STFBBTGATD;
  bool modelPar_given_STFBBTGATD=mod.given("STFBBTGATD");
  AdmsSensFadType modelPar_VBRBOTD=mod.VBRBOTD;
  bool modelPar_given_VBRBOTD=mod.given("VBRBOTD");
  AdmsSensFadType modelPar_VBRSTID=mod.VBRSTID;
  bool modelPar_given_VBRSTID=mod.given("VBRSTID");
  AdmsSensFadType modelPar_VBRGATD=mod.VBRGATD;
  bool modelPar_given_VBRGATD=mod.given("VBRGATD");
  AdmsSensFadType modelPar_PBRBOTD=mod.PBRBOTD;
  bool modelPar_given_PBRBOTD=mod.given("PBRBOTD");
  AdmsSensFadType modelPar_PBRSTID=mod.PBRSTID;
  bool modelPar_given_PBRSTID=mod.given("PBRSTID");
  AdmsSensFadType modelPar_PBRGATD=mod.PBRGATD;
  bool modelPar_given_PBRGATD=mod.given("PBRGATD");
  AdmsSensFadType modelPar_SWJUNEXP=mod.SWJUNEXP;
  bool modelPar_given_SWJUNEXP=mod.given("SWJUNEXP");
  AdmsSensFadType modelPar_VJUNREF=mod.VJUNREF;
  bool modelPar_given_VJUNREF=mod.given("VJUNREF");
  AdmsSensFadType modelPar_FJUNQ=mod.FJUNQ;
  bool modelPar_given_FJUNQ=mod.given("FJUNQ");
  AdmsSensFadType modelPar_VJUNREFD=mod.VJUNREFD;
  bool modelPar_given_VJUNREFD=mod.given("VJUNREFD");
  AdmsSensFadType modelPar_FJUNQD=mod.FJUNQD;
  bool modelPar_given_FJUNQD=mod.given("FJUNQD");
  AdmsSensFadType modelPar_DTA=mod.DTA;
  bool modelPar_given_DTA=mod.given("DTA");


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_LEVEL=mod.LEVEL;
  bool modelPar_given_LEVEL=mod.given("LEVEL");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");
  int modelPar_SWGEO=mod.SWGEO;
  bool modelPar_given_SWGEO=mod.given("SWGEO");
  int modelPar_SWIGATE=mod.SWIGATE;
  bool modelPar_given_SWIGATE=mod.given("SWIGATE");
  int modelPar_SWIMPACT=mod.SWIMPACT;
  bool modelPar_given_SWIMPACT=mod.given("SWIMPACT");
  int modelPar_SWGIDL=mod.SWGIDL;
  bool modelPar_given_SWGIDL=mod.given("SWGIDL");
  int modelPar_SWJUNCAP=mod.SWJUNCAP;
  bool modelPar_given_SWJUNCAP=mod.given("SWJUNCAP");
  int modelPar_SWJUNASYM=mod.SWJUNASYM;
  bool modelPar_given_SWJUNASYM=mod.given("SWJUNASYM");
  int modelPar_SWNUD=mod.SWNUD;
  bool modelPar_given_SWNUD=mod.given("SWNUD");
  int modelPar_SWEDGE=mod.SWEDGE;
  bool modelPar_given_SWEDGE=mod.given("SWEDGE");
  int modelPar_SWDELVTAC=mod.SWDELVTAC;
  bool modelPar_given_SWDELVTAC=mod.given("SWDELVTAC");
  int modelPar_SWIGN=mod.SWIGN;
  bool modelPar_given_SWIGN=mod.given("SWIGN");



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals
  AdmsSensFadType instancePar_L=in.L;
  bool instancePar_given_L=in.given("L");
  inParamMap["L"] = &instancePar_L;
  AdmsSensFadType instancePar_W=in.W;
  bool instancePar_given_W=in.given("W");
  inParamMap["W"] = &instancePar_W;
  AdmsSensFadType instancePar_SA=in.SA;
  bool instancePar_given_SA=in.given("SA");
  inParamMap["SA"] = &instancePar_SA;
  AdmsSensFadType instancePar_SB=in.SB;
  bool instancePar_given_SB=in.given("SB");
  inParamMap["SB"] = &instancePar_SB;
  AdmsSensFadType instancePar_SD=in.SD;
  bool instancePar_given_SD=in.given("SD");
  inParamMap["SD"] = &instancePar_SD;
  AdmsSensFadType instancePar_SCA=in.SCA;
  bool instancePar_given_SCA=in.given("SCA");
  inParamMap["SCA"] = &instancePar_SCA;
  AdmsSensFadType instancePar_SCB=in.SCB;
  bool instancePar_given_SCB=in.given("SCB");
  inParamMap["SCB"] = &instancePar_SCB;
  AdmsSensFadType instancePar_SCC=in.SCC;
  bool instancePar_given_SCC=in.given("SCC");
  inParamMap["SCC"] = &instancePar_SCC;
  AdmsSensFadType instancePar_SC=in.SC;
  bool instancePar_given_SC=in.given("SC");
  inParamMap["SC"] = &instancePar_SC;
  AdmsSensFadType instancePar_NF=in.NF;
  bool instancePar_given_NF=in.given("NF");
  inParamMap["NF"] = &instancePar_NF;
  AdmsSensFadType instancePar_NGCON=in.NGCON;
  bool instancePar_given_NGCON=in.given("NGCON");
  inParamMap["NGCON"] = &instancePar_NGCON;
  AdmsSensFadType instancePar_XGW=in.XGW;
  bool instancePar_given_XGW=in.given("XGW");
  inParamMap["XGW"] = &instancePar_XGW;
  AdmsSensFadType instancePar_NRS=in.NRS;
  bool instancePar_given_NRS=in.given("NRS");
  inParamMap["NRS"] = &instancePar_NRS;
  AdmsSensFadType instancePar_NRD=in.NRD;
  bool instancePar_given_NRD=in.given("NRD");
  inParamMap["NRD"] = &instancePar_NRD;
  AdmsSensFadType instancePar_JW=in.JW;
  bool instancePar_given_JW=in.given("JW");
  inParamMap["JW"] = &instancePar_JW;
  AdmsSensFadType instancePar_DELVTO=in.DELVTO;
  bool instancePar_given_DELVTO=in.given("DELVTO");
  inParamMap["DELVTO"] = &instancePar_DELVTO;
  AdmsSensFadType instancePar_FACTUO=in.FACTUO;
  bool instancePar_given_FACTUO=in.given("FACTUO");
  inParamMap["FACTUO"] = &instancePar_FACTUO;
  AdmsSensFadType instancePar_DELVTOEDGE=in.DELVTOEDGE;
  bool instancePar_given_DELVTOEDGE=in.given("DELVTOEDGE");
  inParamMap["DELVTOEDGE"] = &instancePar_DELVTOEDGE;
  AdmsSensFadType instancePar_FACTUOEDGE=in.FACTUOEDGE;
  bool instancePar_given_FACTUOEDGE=in.given("FACTUOEDGE");
  inParamMap["FACTUOEDGE"] = &instancePar_FACTUOEDGE;
  AdmsSensFadType instancePar_ABSOURCE=in.ABSOURCE;
  bool instancePar_given_ABSOURCE=in.given("ABSOURCE");
  inParamMap["ABSOURCE"] = &instancePar_ABSOURCE;
  AdmsSensFadType instancePar_LSSOURCE=in.LSSOURCE;
  bool instancePar_given_LSSOURCE=in.given("LSSOURCE");
  inParamMap["LSSOURCE"] = &instancePar_LSSOURCE;
  AdmsSensFadType instancePar_LGSOURCE=in.LGSOURCE;
  bool instancePar_given_LGSOURCE=in.given("LGSOURCE");
  inParamMap["LGSOURCE"] = &instancePar_LGSOURCE;
  AdmsSensFadType instancePar_ABDRAIN=in.ABDRAIN;
  bool instancePar_given_ABDRAIN=in.given("ABDRAIN");
  inParamMap["ABDRAIN"] = &instancePar_ABDRAIN;
  AdmsSensFadType instancePar_LSDRAIN=in.LSDRAIN;
  bool instancePar_given_LSDRAIN=in.given("LSDRAIN");
  inParamMap["LSDRAIN"] = &instancePar_LSDRAIN;
  AdmsSensFadType instancePar_LGDRAIN=in.LGDRAIN;
  bool instancePar_given_LGDRAIN=in.given("LGDRAIN");
  inParamMap["LGDRAIN"] = &instancePar_LGDRAIN;
  AdmsSensFadType instancePar_AS=in.AS;
  bool instancePar_given_AS=in.given("AS");
  inParamMap["AS"] = &instancePar_AS;
  AdmsSensFadType instancePar_PS=in.PS;
  bool instancePar_given_PS=in.given("PS");
  inParamMap["PS"] = &instancePar_PS;
  AdmsSensFadType instancePar_AD=in.AD;
  bool instancePar_given_AD=in.given("AD");
  inParamMap["AD"] = &instancePar_AD;
  AdmsSensFadType instancePar_PD=in.PD;
  bool instancePar_given_PD=in.given("PD");
  inParamMap["PD"] = &instancePar_PD;
  AdmsSensFadType instancePar_MULT=in.MULT;
  bool instancePar_given_MULT=in.given("MULT");
  inParamMap["MULT"] = &instancePar_MULT;


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals
  AdmsSensFadType instanceVar_MULT_i=in.MULT_i;
  AdmsSensFadType instanceVar_GFACNUD_i=in.GFACNUD_i;
  AdmsSensFadType instanceVar_VNSUB_i=in.VNSUB_i;
  AdmsSensFadType instanceVar_NSLP_i=in.NSLP_i;
  AdmsSensFadType instanceVar_DNSUB_i=in.DNSUB_i;
  AdmsSensFadType instanceVar_CF_i=in.CF_i;
  AdmsSensFadType instanceVar_CFD_i=in.CFD_i;
  AdmsSensFadType instanceVar_CFB_i=in.CFB_i;
  AdmsSensFadType instanceVar_PSCE_i=in.PSCE_i;
  AdmsSensFadType instanceVar_PSCEB_i=in.PSCEB_i;
  AdmsSensFadType instanceVar_PSCED_i=in.PSCED_i;
  AdmsSensFadType instanceVar_RSB_i=in.RSB_i;
  AdmsSensFadType instanceVar_RSG_i=in.RSG_i;
  AdmsSensFadType instanceVar_THESATB_i=in.THESATB_i;
  AdmsSensFadType instanceVar_THESATG_i=in.THESATG_i;
  AdmsSensFadType instanceVar_AX_i=in.AX_i;
  AdmsSensFadType instanceVar_ALP_i=in.ALP_i;
  AdmsSensFadType instanceVar_ALP1_i=in.ALP1_i;
  AdmsSensFadType instanceVar_ALP2_i=in.ALP2_i;
  AdmsSensFadType instanceVar_A1_i=in.A1_i;
  AdmsSensFadType instanceVar_A3_i=in.A3_i;
  AdmsSensFadType instanceVar_A4_i=in.A4_i;
  AdmsSensFadType instanceVar_GCO_i=in.GCO_i;
  AdmsSensFadType instanceVar_IGINV_i=in.IGINV_i;
  AdmsSensFadType instanceVar_IGOV_i=in.IGOV_i;
  AdmsSensFadType instanceVar_IGOVD_i=in.IGOVD_i;
  AdmsSensFadType instanceVar_GC2_i=in.GC2_i;
  AdmsSensFadType instanceVar_GC3_i=in.GC3_i;
  AdmsSensFadType instanceVar_CHIB_i=in.CHIB_i;
  AdmsSensFadType instanceVar_AGIDL_i=in.AGIDL_i;
  AdmsSensFadType instanceVar_AGIDLD_i=in.AGIDLD_i;
  AdmsSensFadType instanceVar_CGIDL_i=in.CGIDL_i;
  AdmsSensFadType instanceVar_CGIDLD_i=in.CGIDLD_i;
  AdmsSensFadType instanceVar_COX_i=in.COX_i;
  AdmsSensFadType instanceVar_CGOV_i=in.CGOV_i;
  AdmsSensFadType instanceVar_CGOVD_i=in.CGOVD_i;
  AdmsSensFadType instanceVar_CGBOV_i=in.CGBOV_i;
  AdmsSensFadType instanceVar_CFR_i=in.CFR_i;
  AdmsSensFadType instanceVar_CFRD_i=in.CFRD_i;
  AdmsSensFadType instanceVar_FNTEXC_i=in.FNTEXC_i;
  AdmsSensFadType instanceVar_NFA_i=in.NFA_i;
  AdmsSensFadType instanceVar_NFB_i=in.NFB_i;
  AdmsSensFadType instanceVar_NFC_i=in.NFC_i;
  AdmsSensFadType instanceVar_EF_i=in.EF_i;
  AdmsSensFadType instanceVar_BETNEDGE_i=in.BETNEDGE_i;
  AdmsSensFadType instanceVar_PSCEEDGE_i=in.PSCEEDGE_i;
  AdmsSensFadType instanceVar_PSCEBEDGE_i=in.PSCEBEDGE_i;
  AdmsSensFadType instanceVar_PSCEDEDGE_i=in.PSCEDEDGE_i;
  AdmsSensFadType instanceVar_CFEDGE_i=in.CFEDGE_i;
  AdmsSensFadType instanceVar_CFDEDGE_i=in.CFDEDGE_i;
  AdmsSensFadType instanceVar_CFBEDGE_i=in.CFBEDGE_i;
  AdmsSensFadType instanceVar_NFAEDGE_i=in.NFAEDGE_i;
  AdmsSensFadType instanceVar_NFBEDGE_i=in.NFBEDGE_i;
  AdmsSensFadType instanceVar_NFCEDGE_i=in.NFCEDGE_i;
  AdmsSensFadType instanceVar_EFEDGE_i=in.EFEDGE_i;
  AdmsSensFadType instanceVar_RG_i=in.RG_i;
  AdmsSensFadType instanceVar_RSE_i=in.RSE_i;
  AdmsSensFadType instanceVar_RDE_i=in.RDE_i;
  AdmsSensFadType instanceVar_RBULK_i=in.RBULK_i;
  AdmsSensFadType instanceVar_RJUNS_i=in.RJUNS_i;
  AdmsSensFadType instanceVar_RJUND_i=in.RJUND_i;
  AdmsSensFadType instanceVar_RWELL_i=in.RWELL_i;
  AdmsSensFadType instanceVar_ABSOURCE_i=in.ABSOURCE_i;
  AdmsSensFadType instanceVar_LSSOURCE_i=in.LSSOURCE_i;
  AdmsSensFadType instanceVar_LGSOURCE_i=in.LGSOURCE_i;
  AdmsSensFadType instanceVar_zflagbot_s=in.zflagbot_s;
  AdmsSensFadType instanceVar_zflagsti_s=in.zflagsti_s;
  AdmsSensFadType instanceVar_zflaggat_s=in.zflaggat_s;
  AdmsSensFadType instanceVar_VMAX_s=in.VMAX_s;
  AdmsSensFadType instanceVar_exp_VMAX_over_phitd_s=in.exp_VMAX_over_phitd_s;
  AdmsSensFadType instanceVar_vbimin_s=in.vbimin_s;
  AdmsSensFadType instanceVar_vch_s=in.vch_s;
  AdmsSensFadType instanceVar_vfmin_s=in.vfmin_s;
  AdmsSensFadType instanceVar_vbbtlim_s=in.vbbtlim_s;
  AdmsSensFadType instanceVar_xhighf1_s=in.xhighf1_s;
  AdmsSensFadType instanceVar_expxhf1_s=in.expxhf1_s;
  AdmsSensFadType instanceVar_xhighf2_s=in.xhighf2_s;
  AdmsSensFadType instanceVar_expxhf2_s=in.expxhf2_s;
  AdmsSensFadType instanceVar_xhighr_s=in.xhighr_s;
  AdmsSensFadType instanceVar_expxhr_s=in.expxhr_s;
  AdmsSensFadType instanceVar_m0flag_s=in.m0flag_s;
  AdmsSensFadType instanceVar_ISATFOR1_s=in.ISATFOR1_s;
  AdmsSensFadType instanceVar_MFOR1_s=in.MFOR1_s;
  AdmsSensFadType instanceVar_ISATFOR2_s=in.ISATFOR2_s;
  AdmsSensFadType instanceVar_MFOR2_s=in.MFOR2_s;
  AdmsSensFadType instanceVar_ISATREV_s=in.ISATREV_s;
  AdmsSensFadType instanceVar_MREV_s=in.MREV_s;
  AdmsSensFadType instanceVar_ABDRAIN_i=in.ABDRAIN_i;
  AdmsSensFadType instanceVar_LSDRAIN_i=in.LSDRAIN_i;
  AdmsSensFadType instanceVar_LGDRAIN_i=in.LGDRAIN_i;
  AdmsSensFadType instanceVar_zflagbot_d=in.zflagbot_d;
  AdmsSensFadType instanceVar_zflagsti_d=in.zflagsti_d;
  AdmsSensFadType instanceVar_zflaggat_d=in.zflaggat_d;
  AdmsSensFadType instanceVar_VMAX_d=in.VMAX_d;
  AdmsSensFadType instanceVar_exp_VMAX_over_phitd_d=in.exp_VMAX_over_phitd_d;
  AdmsSensFadType instanceVar_vbimin_d=in.vbimin_d;
  AdmsSensFadType instanceVar_vch_d=in.vch_d;
  AdmsSensFadType instanceVar_vfmin_d=in.vfmin_d;
  AdmsSensFadType instanceVar_vbbtlim_d=in.vbbtlim_d;
  AdmsSensFadType instanceVar_xhighf1_d=in.xhighf1_d;
  AdmsSensFadType instanceVar_expxhf1_d=in.expxhf1_d;
  AdmsSensFadType instanceVar_xhighf2_d=in.xhighf2_d;
  AdmsSensFadType instanceVar_expxhf2_d=in.expxhf2_d;
  AdmsSensFadType instanceVar_xhighr_d=in.xhighr_d;
  AdmsSensFadType instanceVar_expxhr_d=in.expxhr_d;
  AdmsSensFadType instanceVar_m0flag_d=in.m0flag_d;
  AdmsSensFadType instanceVar_ISATFOR1_d=in.ISATFOR1_d;
  AdmsSensFadType instanceVar_MFOR1_d=in.MFOR1_d;
  AdmsSensFadType instanceVar_ISATFOR2_d=in.ISATFOR2_d;
  AdmsSensFadType instanceVar_MFOR2_d=in.MFOR2_d;
  AdmsSensFadType instanceVar_ISATREV_d=in.ISATREV_d;
  AdmsSensFadType instanceVar_MREV_d=in.MREV_d;
  AdmsSensFadType instanceVar_VFB_T=in.VFB_T;
  AdmsSensFadType instanceVar_MUE_T=in.MUE_T;
  AdmsSensFadType instanceVar_THEMU_T=in.THEMU_T;
  AdmsSensFadType instanceVar_CS_T=in.CS_T;
  AdmsSensFadType instanceVar_XCOR_T=in.XCOR_T;
  AdmsSensFadType instanceVar_A2_T=in.A2_T;
  AdmsSensFadType instanceVar_VFBEDGE_T=in.VFBEDGE_T;
  AdmsSensFadType instanceVar_phit0=in.phit0;
  AdmsSensFadType instanceVar_BET_i=in.BET_i;
  AdmsSensFadType instanceVar_BETEDGE_i=in.BETEDGE_i;
  AdmsSensFadType instanceVar_nt=in.nt;
  AdmsSensFadType instanceVar_THESAT_T=in.THESAT_T;
  AdmsSensFadType instanceVar_Sfl_prefac=in.Sfl_prefac;
  AdmsSensFadType instanceVar_phit0edge=in.phit0edge;
  AdmsSensFadType instanceVar_Gfedge2=in.Gfedge2;
  AdmsSensFadType instanceVar_lnGfedge2=in.lnGfedge2;
  AdmsSensFadType instanceVar_Sfl_prefac_edge=in.Sfl_prefac_edge;
  AdmsSensFadType instanceVar_ntedge=in.ntedge;
  AdmsSensFadType instanceVar_phib_dc=in.phib_dc;
  AdmsSensFadType instanceVar_G_0_dc=in.G_0_dc;
  AdmsSensFadType instanceVar_kp=in.kp;
  AdmsSensFadType instanceVar_qlim2=in.qlim2;
  AdmsSensFadType instanceVar_sqrt_phib_dc=in.sqrt_phib_dc;
  AdmsSensFadType instanceVar_phix_dc=in.phix_dc;
  AdmsSensFadType instanceVar_aphi_dc=in.aphi_dc;
  AdmsSensFadType instanceVar_bphi_dc=in.bphi_dc;
  AdmsSensFadType instanceVar_phix1_dc=in.phix1_dc;
  AdmsSensFadType instanceVar_alpha_b=in.alpha_b;
  AdmsSensFadType instanceVar_us1=in.us1;
  AdmsSensFadType instanceVar_us21=in.us21;
  AdmsSensFadType instanceVar_phib_ac=in.phib_ac;
  AdmsSensFadType instanceVar_G_0_ac=in.G_0_ac;
  AdmsSensFadType instanceVar_phix_ac=in.phix_ac;
  AdmsSensFadType instanceVar_aphi_ac=in.aphi_ac;
  AdmsSensFadType instanceVar_bphi_ac=in.bphi_ac;
  AdmsSensFadType instanceVar_phix1_ac=in.phix1_ac;
  AdmsSensFadType instanceVar_THER_i=in.THER_i;
  AdmsSensFadType instanceVar_phibedge=in.phibedge;
  AdmsSensFadType instanceVar_Gfedge=in.Gfedge;
  AdmsSensFadType instanceVar_phixedge=in.phixedge;
  AdmsSensFadType instanceVar_aphiedge=in.aphiedge;
  AdmsSensFadType instanceVar_bphiedge=in.bphiedge;
  AdmsSensFadType instanceVar_phix1edge=in.phix1edge;
  AdmsSensFadType instanceVar_Cox_over_q=in.Cox_over_q;
  AdmsSensFadType instanceVar_qq=in.qq;
  AdmsSensFadType instanceVar_E_eff0=in.E_eff0;
  AdmsSensFadType instanceVar_eta_mu=in.eta_mu;
  AdmsSensFadType instanceVar_eta_mu1=in.eta_mu1;
  AdmsSensFadType instanceVar_inv_AX=in.inv_AX;
  AdmsSensFadType instanceVar_inv_VP=in.inv_VP;
  AdmsSensFadType instanceVar_GOV_s=in.GOV_s;
  AdmsSensFadType instanceVar_GOV_d=in.GOV_d;
  AdmsSensFadType instanceVar_GOV2_s=in.GOV2_s;
  AdmsSensFadType instanceVar_GOV2_d=in.GOV2_d;
  AdmsSensFadType instanceVar_SP_OV_eps2_s=in.SP_OV_eps2_s;
  AdmsSensFadType instanceVar_SP_OV_a_s=in.SP_OV_a_s;
  AdmsSensFadType instanceVar_SP_OV_delta1_s=in.SP_OV_delta1_s;
  AdmsSensFadType instanceVar_SP_OV_eps2_d=in.SP_OV_eps2_d;
  AdmsSensFadType instanceVar_SP_OV_a_d=in.SP_OV_a_d;
  AdmsSensFadType instanceVar_SP_OV_delta1_d=in.SP_OV_delta1_d;
  AdmsSensFadType instanceVar_inv_CHIB=in.inv_CHIB;
  AdmsSensFadType instanceVar_BCH=in.BCH;
  AdmsSensFadType instanceVar_BOV=in.BOV;
  AdmsSensFadType instanceVar_BOV_d=in.BOV_d;
  AdmsSensFadType instanceVar_GCQ=in.GCQ;
  AdmsSensFadType instanceVar_AGIDLs=in.AGIDLs;
  AdmsSensFadType instanceVar_AGIDLDs=in.AGIDLDs;
  AdmsSensFadType instanceVar_BGIDLs=in.BGIDLs;
  AdmsSensFadType instanceVar_BGIDLDs=in.BGIDLDs;
  AdmsSensFadType instanceVar_fac_exc=in.fac_exc;
  AdmsSensFadType instanceVar_ggate=in.ggate;
  AdmsSensFadType instanceVar_gsource=in.gsource;
  AdmsSensFadType instanceVar_gdrain=in.gdrain;
  AdmsSensFadType instanceVar_gbulk=in.gbulk;
  AdmsSensFadType instanceVar_gjuns=in.gjuns;
  AdmsSensFadType instanceVar_gjund=in.gjund;
  AdmsSensFadType instanceVar_gwell=in.gwell;


  //non-reals


  //make local copies of all model vars
  //reals
  AdmsSensFadType modelVar_TOXO_i=mod.TOXO_i;
  AdmsSensFadType modelVar_EPSROXO_i=mod.EPSROXO_i;
  AdmsSensFadType modelVar_NSUBO_i=mod.NSUBO_i;
  AdmsSensFadType modelVar_WSEG_i=mod.WSEG_i;
  AdmsSensFadType modelVar_NPCK_i=mod.NPCK_i;
  AdmsSensFadType modelVar_WSEGP_i=mod.WSEGP_i;
  AdmsSensFadType modelVar_LPCK_i=mod.LPCK_i;
  AdmsSensFadType modelVar_TOXOVO_i=mod.TOXOVO_i;
  AdmsSensFadType modelVar_TOXOVDO_i=mod.TOXOVDO_i;
  AdmsSensFadType modelVar_LOV_i=mod.LOV_i;
  AdmsSensFadType modelVar_LOVD_i=mod.LOVD_i;
  AdmsSensFadType modelVar_LP1_i=mod.LP1_i;
  AdmsSensFadType modelVar_LP2_i=mod.LP2_i;
  AdmsSensFadType modelVar_WBET_i=mod.WBET_i;
  AdmsSensFadType modelVar_AXL_i=mod.AXL_i;
  AdmsSensFadType modelVar_ALP1L2_i=mod.ALP1L2_i;
  AdmsSensFadType modelVar_ALP2L2_i=mod.ALP2L2_i;
  AdmsSensFadType modelVar_SAREF_i=mod.SAREF_i;
  AdmsSensFadType modelVar_SBREF_i=mod.SBREF_i;
  AdmsSensFadType modelVar_KVSAT_i=mod.KVSAT_i;
  AdmsSensFadType modelVar_LLODKUO_i=mod.LLODKUO_i;
  AdmsSensFadType modelVar_WLODKUO_i=mod.WLODKUO_i;
  AdmsSensFadType modelVar_LLODVTH_i=mod.LLODVTH_i;
  AdmsSensFadType modelVar_WLODVTH_i=mod.WLODVTH_i;
  AdmsSensFadType modelVar_LODETAO_i=mod.LODETAO_i;
  AdmsSensFadType modelVar_SCREF_i=mod.SCREF_i;
  AdmsSensFadType modelVar_WEB_i=mod.WEB_i;
  AdmsSensFadType modelVar_WEC_i=mod.WEC_i;
  AdmsSensFadType modelVar_RSHG_i=mod.RSHG_i;
  AdmsSensFadType modelVar_RSH_i=mod.RSH_i;
  AdmsSensFadType modelVar_RSHD_i=mod.RSHD_i;
  AdmsSensFadType modelVar_RINT_i=mod.RINT_i;
  AdmsSensFadType modelVar_RVPOLY_i=mod.RVPOLY_i;
  AdmsSensFadType modelVar_NSUBEDGEO_i=mod.NSUBEDGEO_i;
  AdmsSensFadType modelVar_LPEDGE_i=mod.LPEDGE_i;
  AdmsSensFadType modelVar_QMC_i=mod.QMC_i;
  AdmsSensFadType modelVar_rTa=mod.rTa;
  AdmsSensFadType modelVar_delTa=mod.delTa;
  AdmsSensFadType modelVar_phita=mod.phita;
  AdmsSensFadType modelVar_inv_phita=mod.inv_phita;
  AdmsSensFadType modelVar_TKD=mod.TKD;
  AdmsSensFadType modelVar_delT=mod.delT;
  AdmsSensFadType modelVar_rTn=mod.rTn;
  AdmsSensFadType modelVar_ln_rTn=mod.ln_rTn;
  AdmsSensFadType modelVar_inv_phit=mod.inv_phit;
  AdmsSensFadType modelVar_Eg=mod.Eg;
  AdmsSensFadType modelVar_phibFac=mod.phibFac;
  AdmsSensFadType modelVar_IMAX_i=mod.IMAX_i;
  AdmsSensFadType modelVar_VBIRBOT_i=mod.VBIRBOT_i;
  AdmsSensFadType modelVar_VBIRSTI_i=mod.VBIRSTI_i;
  AdmsSensFadType modelVar_VBIRGAT_i=mod.VBIRGAT_i;
  AdmsSensFadType modelVar_PBOT_i=mod.PBOT_i;
  AdmsSensFadType modelVar_PSTI_i=mod.PSTI_i;
  AdmsSensFadType modelVar_PGAT_i=mod.PGAT_i;
  AdmsSensFadType modelVar_CSRHBOT_i=mod.CSRHBOT_i;
  AdmsSensFadType modelVar_CSRHSTI_i=mod.CSRHSTI_i;
  AdmsSensFadType modelVar_CSRHGAT_i=mod.CSRHGAT_i;
  AdmsSensFadType modelVar_CTATBOT_i=mod.CTATBOT_i;
  AdmsSensFadType modelVar_CTATSTI_i=mod.CTATSTI_i;
  AdmsSensFadType modelVar_CTATGAT_i=mod.CTATGAT_i;
  AdmsSensFadType modelVar_CBBTBOT_i=mod.CBBTBOT_i;
  AdmsSensFadType modelVar_CBBTSTI_i=mod.CBBTSTI_i;
  AdmsSensFadType modelVar_CBBTGAT_i=mod.CBBTGAT_i;
  AdmsSensFadType modelVar_VBRBOT_i=mod.VBRBOT_i;
  AdmsSensFadType modelVar_VBRSTI_i=mod.VBRSTI_i;
  AdmsSensFadType modelVar_VBRGAT_i=mod.VBRGAT_i;
  AdmsSensFadType modelVar_PBRBOT_i=mod.PBRBOT_i;
  AdmsSensFadType modelVar_PBRSTI_i=mod.PBRSTI_i;
  AdmsSensFadType modelVar_PBRGAT_i=mod.PBRGAT_i;
  AdmsSensFadType modelVar_SWJUNEXP_i=mod.SWJUNEXP_i;
  AdmsSensFadType modelVar_VJUNREF_i=mod.VJUNREF_i;
  AdmsSensFadType modelVar_FJUNQ_i=mod.FJUNQ_i;
  AdmsSensFadType modelVar_phitr=mod.phitr;
  AdmsSensFadType modelVar_phitd=mod.phitd;
  AdmsSensFadType modelVar_phitdinv=mod.phitdinv;
  AdmsSensFadType modelVar_perfc=mod.perfc;
  AdmsSensFadType modelVar_berfc=mod.berfc;
  AdmsSensFadType modelVar_cerfc=mod.cerfc;
  AdmsSensFadType modelVar_ftdbot=mod.ftdbot;
  AdmsSensFadType modelVar_ftdsti=mod.ftdsti;
  AdmsSensFadType modelVar_ftdgat=mod.ftdgat;
  AdmsSensFadType modelVar_idsatbot=mod.idsatbot;
  AdmsSensFadType modelVar_idsatsti=mod.idsatsti;
  AdmsSensFadType modelVar_idsatgat=mod.idsatgat;
  AdmsSensFadType modelVar_vbibot=mod.vbibot;
  AdmsSensFadType modelVar_vbisti=mod.vbisti;
  AdmsSensFadType modelVar_vbigat=mod.vbigat;
  AdmsSensFadType modelVar_vbiinvbot=mod.vbiinvbot;
  AdmsSensFadType modelVar_vbiinvsti=mod.vbiinvsti;
  AdmsSensFadType modelVar_vbiinvgat=mod.vbiinvgat;
  AdmsSensFadType modelVar_one_minus_PBOT=mod.one_minus_PBOT;
  AdmsSensFadType modelVar_one_minus_PSTI=mod.one_minus_PSTI;
  AdmsSensFadType modelVar_one_minus_PGAT=mod.one_minus_PGAT;
  AdmsSensFadType modelVar_one_over_one_minus_PBOT=mod.one_over_one_minus_PBOT;
  AdmsSensFadType modelVar_one_over_one_minus_PSTI=mod.one_over_one_minus_PSTI;
  AdmsSensFadType modelVar_one_over_one_minus_PGAT=mod.one_over_one_minus_PGAT;
  AdmsSensFadType modelVar_cjobot=mod.cjobot;
  AdmsSensFadType modelVar_cjosti=mod.cjosti;
  AdmsSensFadType modelVar_cjogat=mod.cjogat;
  AdmsSensFadType modelVar_qprefbot=mod.qprefbot;
  AdmsSensFadType modelVar_qprefsti=mod.qprefsti;
  AdmsSensFadType modelVar_qprefgat=mod.qprefgat;
  AdmsSensFadType modelVar_qpref2bot=mod.qpref2bot;
  AdmsSensFadType modelVar_qpref2sti=mod.qpref2sti;
  AdmsSensFadType modelVar_qpref2gat=mod.qpref2gat;
  AdmsSensFadType modelVar_wdepnulrbot=mod.wdepnulrbot;
  AdmsSensFadType modelVar_wdepnulrsti=mod.wdepnulrsti;
  AdmsSensFadType modelVar_wdepnulrgat=mod.wdepnulrgat;
  AdmsSensFadType modelVar_wdepnulrinvbot=mod.wdepnulrinvbot;
  AdmsSensFadType modelVar_wdepnulrinvsti=mod.wdepnulrinvsti;
  AdmsSensFadType modelVar_wdepnulrinvgat=mod.wdepnulrinvgat;
  AdmsSensFadType modelVar_VBIRBOTinv=mod.VBIRBOTinv;
  AdmsSensFadType modelVar_VBIRSTIinv=mod.VBIRSTIinv;
  AdmsSensFadType modelVar_VBIRGATinv=mod.VBIRGATinv;
  AdmsSensFadType modelVar_atatbot=mod.atatbot;
  AdmsSensFadType modelVar_atatsti=mod.atatsti;
  AdmsSensFadType modelVar_atatgat=mod.atatgat;
  AdmsSensFadType modelVar_btatpartbot=mod.btatpartbot;
  AdmsSensFadType modelVar_btatpartsti=mod.btatpartsti;
  AdmsSensFadType modelVar_btatpartgat=mod.btatpartgat;
  AdmsSensFadType modelVar_fbbtbot=mod.fbbtbot;
  AdmsSensFadType modelVar_fbbtsti=mod.fbbtsti;
  AdmsSensFadType modelVar_fbbtgat=mod.fbbtgat;
  AdmsSensFadType modelVar_alphaav=mod.alphaav;
  AdmsSensFadType modelVar_fstopbot=mod.fstopbot;
  AdmsSensFadType modelVar_fstopsti=mod.fstopsti;
  AdmsSensFadType modelVar_fstopgat=mod.fstopgat;
  AdmsSensFadType modelVar_VBRinvbot=mod.VBRinvbot;
  AdmsSensFadType modelVar_VBRinvsti=mod.VBRinvsti;
  AdmsSensFadType modelVar_VBRinvgat=mod.VBRinvgat;
  AdmsSensFadType modelVar_slopebot=mod.slopebot;
  AdmsSensFadType modelVar_slopesti=mod.slopesti;
  AdmsSensFadType modelVar_slopegat=mod.slopegat;
  AdmsSensFadType modelVar_VBIRBOTD_i=mod.VBIRBOTD_i;
  AdmsSensFadType modelVar_VBIRSTID_i=mod.VBIRSTID_i;
  AdmsSensFadType modelVar_VBIRGATD_i=mod.VBIRGATD_i;
  AdmsSensFadType modelVar_PBOTD_i=mod.PBOTD_i;
  AdmsSensFadType modelVar_PSTID_i=mod.PSTID_i;
  AdmsSensFadType modelVar_PGATD_i=mod.PGATD_i;
  AdmsSensFadType modelVar_CSRHBOTD_i=mod.CSRHBOTD_i;
  AdmsSensFadType modelVar_CSRHSTID_i=mod.CSRHSTID_i;
  AdmsSensFadType modelVar_CSRHGATD_i=mod.CSRHGATD_i;
  AdmsSensFadType modelVar_CTATBOTD_i=mod.CTATBOTD_i;
  AdmsSensFadType modelVar_CTATSTID_i=mod.CTATSTID_i;
  AdmsSensFadType modelVar_CTATGATD_i=mod.CTATGATD_i;
  AdmsSensFadType modelVar_CBBTBOTD_i=mod.CBBTBOTD_i;
  AdmsSensFadType modelVar_CBBTSTID_i=mod.CBBTSTID_i;
  AdmsSensFadType modelVar_CBBTGATD_i=mod.CBBTGATD_i;
  AdmsSensFadType modelVar_VBRBOTD_i=mod.VBRBOTD_i;
  AdmsSensFadType modelVar_VBRSTID_i=mod.VBRSTID_i;
  AdmsSensFadType modelVar_VBRGATD_i=mod.VBRGATD_i;
  AdmsSensFadType modelVar_PBRBOTD_i=mod.PBRBOTD_i;
  AdmsSensFadType modelVar_PBRSTID_i=mod.PBRSTID_i;
  AdmsSensFadType modelVar_PBRGATD_i=mod.PBRGATD_i;
  AdmsSensFadType modelVar_VJUNREFD_i=mod.VJUNREFD_i;
  AdmsSensFadType modelVar_FJUNQD_i=mod.FJUNQD_i;
  AdmsSensFadType modelVar_ftdbot_d=mod.ftdbot_d;
  AdmsSensFadType modelVar_ftdsti_d=mod.ftdsti_d;
  AdmsSensFadType modelVar_ftdgat_d=mod.ftdgat_d;
  AdmsSensFadType modelVar_idsatbot_d=mod.idsatbot_d;
  AdmsSensFadType modelVar_idsatsti_d=mod.idsatsti_d;
  AdmsSensFadType modelVar_idsatgat_d=mod.idsatgat_d;
  AdmsSensFadType modelVar_vbibot_d=mod.vbibot_d;
  AdmsSensFadType modelVar_vbisti_d=mod.vbisti_d;
  AdmsSensFadType modelVar_vbigat_d=mod.vbigat_d;
  AdmsSensFadType modelVar_vbiinvbot_d=mod.vbiinvbot_d;
  AdmsSensFadType modelVar_vbiinvsti_d=mod.vbiinvsti_d;
  AdmsSensFadType modelVar_vbiinvgat_d=mod.vbiinvgat_d;
  AdmsSensFadType modelVar_one_minus_PBOT_d=mod.one_minus_PBOT_d;
  AdmsSensFadType modelVar_one_minus_PSTI_d=mod.one_minus_PSTI_d;
  AdmsSensFadType modelVar_one_minus_PGAT_d=mod.one_minus_PGAT_d;
  AdmsSensFadType modelVar_one_over_one_minus_PBOT_d=mod.one_over_one_minus_PBOT_d;
  AdmsSensFadType modelVar_one_over_one_minus_PSTI_d=mod.one_over_one_minus_PSTI_d;
  AdmsSensFadType modelVar_one_over_one_minus_PGAT_d=mod.one_over_one_minus_PGAT_d;
  AdmsSensFadType modelVar_cjobot_d=mod.cjobot_d;
  AdmsSensFadType modelVar_cjosti_d=mod.cjosti_d;
  AdmsSensFadType modelVar_cjogat_d=mod.cjogat_d;
  AdmsSensFadType modelVar_qprefbot_d=mod.qprefbot_d;
  AdmsSensFadType modelVar_qprefsti_d=mod.qprefsti_d;
  AdmsSensFadType modelVar_qprefgat_d=mod.qprefgat_d;
  AdmsSensFadType modelVar_qpref2bot_d=mod.qpref2bot_d;
  AdmsSensFadType modelVar_qpref2sti_d=mod.qpref2sti_d;
  AdmsSensFadType modelVar_qpref2gat_d=mod.qpref2gat_d;
  AdmsSensFadType modelVar_wdepnulrbot_d=mod.wdepnulrbot_d;
  AdmsSensFadType modelVar_wdepnulrsti_d=mod.wdepnulrsti_d;
  AdmsSensFadType modelVar_wdepnulrgat_d=mod.wdepnulrgat_d;
  AdmsSensFadType modelVar_wdepnulrinvbot_d=mod.wdepnulrinvbot_d;
  AdmsSensFadType modelVar_wdepnulrinvsti_d=mod.wdepnulrinvsti_d;
  AdmsSensFadType modelVar_wdepnulrinvgat_d=mod.wdepnulrinvgat_d;
  AdmsSensFadType modelVar_VBIRBOTinv_d=mod.VBIRBOTinv_d;
  AdmsSensFadType modelVar_VBIRSTIinv_d=mod.VBIRSTIinv_d;
  AdmsSensFadType modelVar_VBIRGATinv_d=mod.VBIRGATinv_d;
  AdmsSensFadType modelVar_atatbot_d=mod.atatbot_d;
  AdmsSensFadType modelVar_atatsti_d=mod.atatsti_d;
  AdmsSensFadType modelVar_atatgat_d=mod.atatgat_d;
  AdmsSensFadType modelVar_btatpartbot_d=mod.btatpartbot_d;
  AdmsSensFadType modelVar_btatpartsti_d=mod.btatpartsti_d;
  AdmsSensFadType modelVar_btatpartgat_d=mod.btatpartgat_d;
  AdmsSensFadType modelVar_fbbtbot_d=mod.fbbtbot_d;
  AdmsSensFadType modelVar_fbbtsti_d=mod.fbbtsti_d;
  AdmsSensFadType modelVar_fbbtgat_d=mod.fbbtgat_d;
  AdmsSensFadType modelVar_fstopbot_d=mod.fstopbot_d;
  AdmsSensFadType modelVar_fstopsti_d=mod.fstopsti_d;
  AdmsSensFadType modelVar_fstopgat_d=mod.fstopgat_d;
  AdmsSensFadType modelVar_VBRinvbot_d=mod.VBRinvbot_d;
  AdmsSensFadType modelVar_VBRinvsti_d=mod.VBRinvsti_d;
  AdmsSensFadType modelVar_VBRinvgat_d=mod.VBRinvgat_d;
  AdmsSensFadType modelVar_slopebot_d=mod.slopebot_d;
  AdmsSensFadType modelVar_slopesti_d=mod.slopesti_d;
  AdmsSensFadType modelVar_slopegat_d=mod.slopegat_d;
  AdmsSensFadType modelVar_phit=mod.phit;
  AdmsSensFadType modelVar_nt0=mod.nt0;
  AdmsSensFadType modelVar_EPSSI=mod.EPSSI;


  // non-reals
  int modelVar_CHNL_TYPE=mod.CHNL_TYPE;
  int modelVar_SWGEO_i=mod.SWGEO_i;
  int modelVar_SWIGATE_i=mod.SWIGATE_i;
  int modelVar_SWIMPACT_i=mod.SWIMPACT_i;
  int modelVar_SWGIDL_i=mod.SWGIDL_i;
  int modelVar_SWJUNCAP_i=mod.SWJUNCAP_i;
  int modelVar_SWJUNASYM_i=mod.SWJUNASYM_i;
  int modelVar_SWNUD_i=mod.SWNUD_i;
  int modelVar_SWEDGE_i=mod.SWEDGE_i;
  int modelVar_SWDELVTAC_i=mod.SWDELVTAC_i;
  int modelVar_SWIGN_i=mod.SWIGN_i;



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.
  probeVars[in.admsProbeID_V_NOI_GND] = (*solVectorPtr)[in.li_NOI];
  probeVars[in.admsProbeID_V_NOI2_GND] = (*solVectorPtr)[in.li_NOI2];
  probeVars[in.admsProbeID_V_B_BI] = (*solVectorPtr)[in.li_B]- (*solVectorPtr)[in.li_BI];
  probeVars[in.admsProbeID_V_BD_BI] = (*solVectorPtr)[in.li_BD]- (*solVectorPtr)[in.li_BI];
  probeVars[in.admsProbeID_V_BS_BI] = (*solVectorPtr)[in.li_BS]- (*solVectorPtr)[in.li_BI];
  probeVars[in.admsProbeID_V_BP_BI] = (*solVectorPtr)[in.li_BP]- (*solVectorPtr)[in.li_BI];
  probeVars[in.admsProbeID_V_D_DI] = (*solVectorPtr)[in.li_D]- (*solVectorPtr)[in.li_DI];
  probeVars[in.admsProbeID_V_S_SI] = (*solVectorPtr)[in.li_S]- (*solVectorPtr)[in.li_SI];
  probeVars[in.admsProbeID_V_G_GP] = (*solVectorPtr)[in.li_G]- (*solVectorPtr)[in.li_GP];
  probeVars[in.admsProbeID_V_DI_BD] = (*solVectorPtr)[in.li_DI]- (*solVectorPtr)[in.li_BD];
  probeVars[in.admsProbeID_V_SI_BS] = (*solVectorPtr)[in.li_SI]- (*solVectorPtr)[in.li_BS];
  probeVars[in.admsProbeID_V_SI_BP] = (*solVectorPtr)[in.li_SI]- (*solVectorPtr)[in.li_BP];
  probeVars[in.admsProbeID_V_DI_SI] = (*solVectorPtr)[in.li_DI]- (*solVectorPtr)[in.li_SI];
  probeVars[in.admsProbeID_V_GP_SI] = (*solVectorPtr)[in.li_GP]- (*solVectorPtr)[in.li_SI];



  // Need to use processParams-like function to process the
  // initial_model and initial_instance blocks with the LOCAL copies of
  // instance and model vars, and local copies of instance and model
  // params.
  evaluateInitialModel(
     // model parameters
     // reals
     modelPar_TR,
     modelPar_given_TR,
     modelPar_QMC,
     modelPar_given_QMC,
     modelPar_VFB,
     modelPar_given_VFB,
     modelPar_STVFB,
     modelPar_given_STVFB,
     modelPar_TOX,
     modelPar_given_TOX,
     modelPar_EPSROX,
     modelPar_given_EPSROX,
     modelPar_NEFF,
     modelPar_given_NEFF,
     modelPar_FACNEFFAC,
     modelPar_given_FACNEFFAC,
     modelPar_GFACNUD,
     modelPar_given_GFACNUD,
     modelPar_VSBNUD,
     modelPar_given_VSBNUD,
     modelPar_DVSBNUD,
     modelPar_given_DVSBNUD,
     modelPar_VNSUB,
     modelPar_given_VNSUB,
     modelPar_NSLP,
     modelPar_given_NSLP,
     modelPar_DNSUB,
     modelPar_given_DNSUB,
     modelPar_DPHIB,
     modelPar_given_DPHIB,
     modelPar_DELVTAC,
     modelPar_given_DELVTAC,
     modelPar_NP,
     modelPar_given_NP,
     modelPar_CT,
     modelPar_given_CT,
     modelPar_TOXOV,
     modelPar_given_TOXOV,
     modelPar_TOXOVD,
     modelPar_given_TOXOVD,
     modelPar_NOV,
     modelPar_given_NOV,
     modelPar_NOVD,
     modelPar_given_NOVD,
     modelPar_CF,
     modelPar_given_CF,
     modelPar_CFD,
     modelPar_given_CFD,
     modelPar_CFB,
     modelPar_given_CFB,
     modelPar_PSCE,
     modelPar_given_PSCE,
     modelPar_PSCEB,
     modelPar_given_PSCEB,
     modelPar_PSCED,
     modelPar_given_PSCED,
     modelPar_BETN,
     modelPar_given_BETN,
     modelPar_STBET,
     modelPar_given_STBET,
     modelPar_MUE,
     modelPar_given_MUE,
     modelPar_STMUE,
     modelPar_given_STMUE,
     modelPar_THEMU,
     modelPar_given_THEMU,
     modelPar_STTHEMU,
     modelPar_given_STTHEMU,
     modelPar_CS,
     modelPar_given_CS,
     modelPar_STCS,
     modelPar_given_STCS,
     modelPar_XCOR,
     modelPar_given_XCOR,
     modelPar_STXCOR,
     modelPar_given_STXCOR,
     modelPar_FETA,
     modelPar_given_FETA,
     modelPar_RS,
     modelPar_given_RS,
     modelPar_STRS,
     modelPar_given_STRS,
     modelPar_RSB,
     modelPar_given_RSB,
     modelPar_RSG,
     modelPar_given_RSG,
     modelPar_THESAT,
     modelPar_given_THESAT,
     modelPar_STTHESAT,
     modelPar_given_STTHESAT,
     modelPar_THESATB,
     modelPar_given_THESATB,
     modelPar_THESATG,
     modelPar_given_THESATG,
     modelPar_AX,
     modelPar_given_AX,
     modelPar_ALP,
     modelPar_given_ALP,
     modelPar_ALP1,
     modelPar_given_ALP1,
     modelPar_ALP2,
     modelPar_given_ALP2,
     modelPar_VP,
     modelPar_given_VP,
     modelPar_A1,
     modelPar_given_A1,
     modelPar_A2,
     modelPar_given_A2,
     modelPar_STA2,
     modelPar_given_STA2,
     modelPar_A3,
     modelPar_given_A3,
     modelPar_A4,
     modelPar_given_A4,
     modelPar_GCO,
     modelPar_given_GCO,
     modelPar_IGINV,
     modelPar_given_IGINV,
     modelPar_IGOV,
     modelPar_given_IGOV,
     modelPar_IGOVD,
     modelPar_given_IGOVD,
     modelPar_STIG,
     modelPar_given_STIG,
     modelPar_GC2,
     modelPar_given_GC2,
     modelPar_GC3,
     modelPar_given_GC3,
     modelPar_CHIB,
     modelPar_given_CHIB,
     modelPar_AGIDL,
     modelPar_given_AGIDL,
     modelPar_AGIDLD,
     modelPar_given_AGIDLD,
     modelPar_BGIDL,
     modelPar_given_BGIDL,
     modelPar_BGIDLD,
     modelPar_given_BGIDLD,
     modelPar_STBGIDL,
     modelPar_given_STBGIDL,
     modelPar_STBGIDLD,
     modelPar_given_STBGIDLD,
     modelPar_CGIDL,
     modelPar_given_CGIDL,
     modelPar_CGIDLD,
     modelPar_given_CGIDLD,
     modelPar_COX,
     modelPar_given_COX,
     modelPar_CGOV,
     modelPar_given_CGOV,
     modelPar_CGOVD,
     modelPar_given_CGOVD,
     modelPar_CGBOV,
     modelPar_given_CGBOV,
     modelPar_CFR,
     modelPar_given_CFR,
     modelPar_CFRD,
     modelPar_given_CFRD,
     modelPar_FNT,
     modelPar_given_FNT,
     modelPar_FNTEXC,
     modelPar_given_FNTEXC,
     modelPar_NFA,
     modelPar_given_NFA,
     modelPar_NFB,
     modelPar_given_NFB,
     modelPar_NFC,
     modelPar_given_NFC,
     modelPar_EF,
     modelPar_given_EF,
     modelPar_VFBEDGE,
     modelPar_given_VFBEDGE,
     modelPar_STVFBEDGE,
     modelPar_given_STVFBEDGE,
     modelPar_DPHIBEDGE,
     modelPar_given_DPHIBEDGE,
     modelPar_NEFFEDGE,
     modelPar_given_NEFFEDGE,
     modelPar_CTEDGE,
     modelPar_given_CTEDGE,
     modelPar_BETNEDGE,
     modelPar_given_BETNEDGE,
     modelPar_STBETEDGE,
     modelPar_given_STBETEDGE,
     modelPar_PSCEEDGE,
     modelPar_given_PSCEEDGE,
     modelPar_PSCEBEDGE,
     modelPar_given_PSCEBEDGE,
     modelPar_PSCEDEDGE,
     modelPar_given_PSCEDEDGE,
     modelPar_CFEDGE,
     modelPar_given_CFEDGE,
     modelPar_CFDEDGE,
     modelPar_given_CFDEDGE,
     modelPar_CFBEDGE,
     modelPar_given_CFBEDGE,
     modelPar_FNTEDGE,
     modelPar_given_FNTEDGE,
     modelPar_NFAEDGE,
     modelPar_given_NFAEDGE,
     modelPar_NFBEDGE,
     modelPar_given_NFBEDGE,
     modelPar_NFCEDGE,
     modelPar_given_NFCEDGE,
     modelPar_EFEDGE,
     modelPar_given_EFEDGE,
     modelPar_RG,
     modelPar_given_RG,
     modelPar_RSE,
     modelPar_given_RSE,
     modelPar_RDE,
     modelPar_given_RDE,
     modelPar_RBULK,
     modelPar_given_RBULK,
     modelPar_RWELL,
     modelPar_given_RWELL,
     modelPar_RJUNS,
     modelPar_given_RJUNS,
     modelPar_RJUND,
     modelPar_given_RJUND,
     modelPar_POVFB,
     modelPar_given_POVFB,
     modelPar_PLVFB,
     modelPar_given_PLVFB,
     modelPar_PWVFB,
     modelPar_given_PWVFB,
     modelPar_PLWVFB,
     modelPar_given_PLWVFB,
     modelPar_POSTVFB,
     modelPar_given_POSTVFB,
     modelPar_PLSTVFB,
     modelPar_given_PLSTVFB,
     modelPar_PWSTVFB,
     modelPar_given_PWSTVFB,
     modelPar_PLWSTVFB,
     modelPar_given_PLWSTVFB,
     modelPar_POTOX,
     modelPar_given_POTOX,
     modelPar_POEPSROX,
     modelPar_given_POEPSROX,
     modelPar_PONEFF,
     modelPar_given_PONEFF,
     modelPar_PLNEFF,
     modelPar_given_PLNEFF,
     modelPar_PWNEFF,
     modelPar_given_PWNEFF,
     modelPar_PLWNEFF,
     modelPar_given_PLWNEFF,
     modelPar_POFACNEFFAC,
     modelPar_given_POFACNEFFAC,
     modelPar_PLFACNEFFAC,
     modelPar_given_PLFACNEFFAC,
     modelPar_PWFACNEFFAC,
     modelPar_given_PWFACNEFFAC,
     modelPar_PLWFACNEFFAC,
     modelPar_given_PLWFACNEFFAC,
     modelPar_POGFACNUD,
     modelPar_given_POGFACNUD,
     modelPar_PLGFACNUD,
     modelPar_given_PLGFACNUD,
     modelPar_PWGFACNUD,
     modelPar_given_PWGFACNUD,
     modelPar_PLWGFACNUD,
     modelPar_given_PLWGFACNUD,
     modelPar_POVSBNUD,
     modelPar_given_POVSBNUD,
     modelPar_PODVSBNUD,
     modelPar_given_PODVSBNUD,
     modelPar_POVNSUB,
     modelPar_given_POVNSUB,
     modelPar_PONSLP,
     modelPar_given_PONSLP,
     modelPar_PODNSUB,
     modelPar_given_PODNSUB,
     modelPar_PODPHIB,
     modelPar_given_PODPHIB,
     modelPar_PLDPHIB,
     modelPar_given_PLDPHIB,
     modelPar_PWDPHIB,
     modelPar_given_PWDPHIB,
     modelPar_PLWDPHIB,
     modelPar_given_PLWDPHIB,
     modelPar_PODELVTAC,
     modelPar_given_PODELVTAC,
     modelPar_PLDELVTAC,
     modelPar_given_PLDELVTAC,
     modelPar_PWDELVTAC,
     modelPar_given_PWDELVTAC,
     modelPar_PLWDELVTAC,
     modelPar_given_PLWDELVTAC,
     modelPar_PONP,
     modelPar_given_PONP,
     modelPar_PLNP,
     modelPar_given_PLNP,
     modelPar_PWNP,
     modelPar_given_PWNP,
     modelPar_PLWNP,
     modelPar_given_PLWNP,
     modelPar_POCT,
     modelPar_given_POCT,
     modelPar_PLCT,
     modelPar_given_PLCT,
     modelPar_PWCT,
     modelPar_given_PWCT,
     modelPar_PLWCT,
     modelPar_given_PLWCT,
     modelPar_POTOXOV,
     modelPar_given_POTOXOV,
     modelPar_POTOXOVD,
     modelPar_given_POTOXOVD,
     modelPar_PONOV,
     modelPar_given_PONOV,
     modelPar_PLNOV,
     modelPar_given_PLNOV,
     modelPar_PWNOV,
     modelPar_given_PWNOV,
     modelPar_PLWNOV,
     modelPar_given_PLWNOV,
     modelPar_PONOVD,
     modelPar_given_PONOVD,
     modelPar_PLNOVD,
     modelPar_given_PLNOVD,
     modelPar_PWNOVD,
     modelPar_given_PWNOVD,
     modelPar_PLWNOVD,
     modelPar_given_PLWNOVD,
     modelPar_POCF,
     modelPar_given_POCF,
     modelPar_PLCF,
     modelPar_given_PLCF,
     modelPar_PWCF,
     modelPar_given_PWCF,
     modelPar_PLWCF,
     modelPar_given_PLWCF,
     modelPar_POCFD,
     modelPar_given_POCFD,
     modelPar_POCFB,
     modelPar_given_POCFB,
     modelPar_POPSCE,
     modelPar_given_POPSCE,
     modelPar_PLPSCE,
     modelPar_given_PLPSCE,
     modelPar_PWPSCE,
     modelPar_given_PWPSCE,
     modelPar_PLWPSCE,
     modelPar_given_PLWPSCE,
     modelPar_POPSCEB,
     modelPar_given_POPSCEB,
     modelPar_POPSCED,
     modelPar_given_POPSCED,
     modelPar_POBETN,
     modelPar_given_POBETN,
     modelPar_PLBETN,
     modelPar_given_PLBETN,
     modelPar_PWBETN,
     modelPar_given_PWBETN,
     modelPar_PLWBETN,
     modelPar_given_PLWBETN,
     modelPar_POSTBET,
     modelPar_given_POSTBET,
     modelPar_PLSTBET,
     modelPar_given_PLSTBET,
     modelPar_PWSTBET,
     modelPar_given_PWSTBET,
     modelPar_PLWSTBET,
     modelPar_given_PLWSTBET,
     modelPar_POMUE,
     modelPar_given_POMUE,
     modelPar_PLMUE,
     modelPar_given_PLMUE,
     modelPar_PWMUE,
     modelPar_given_PWMUE,
     modelPar_PLWMUE,
     modelPar_given_PLWMUE,
     modelPar_POSTMUE,
     modelPar_given_POSTMUE,
     modelPar_POTHEMU,
     modelPar_given_POTHEMU,
     modelPar_POSTTHEMU,
     modelPar_given_POSTTHEMU,
     modelPar_POCS,
     modelPar_given_POCS,
     modelPar_PLCS,
     modelPar_given_PLCS,
     modelPar_PWCS,
     modelPar_given_PWCS,
     modelPar_PLWCS,
     modelPar_given_PLWCS,
     modelPar_POSTCS,
     modelPar_given_POSTCS,
     modelPar_POXCOR,
     modelPar_given_POXCOR,
     modelPar_PLXCOR,
     modelPar_given_PLXCOR,
     modelPar_PWXCOR,
     modelPar_given_PWXCOR,
     modelPar_PLWXCOR,
     modelPar_given_PLWXCOR,
     modelPar_POSTXCOR,
     modelPar_given_POSTXCOR,
     modelPar_POFETA,
     modelPar_given_POFETA,
     modelPar_PORS,
     modelPar_given_PORS,
     modelPar_PLRS,
     modelPar_given_PLRS,
     modelPar_PWRS,
     modelPar_given_PWRS,
     modelPar_PLWRS,
     modelPar_given_PLWRS,
     modelPar_POSTRS,
     modelPar_given_POSTRS,
     modelPar_PORSB,
     modelPar_given_PORSB,
     modelPar_PORSG,
     modelPar_given_PORSG,
     modelPar_POTHESAT,
     modelPar_given_POTHESAT,
     modelPar_PLTHESAT,
     modelPar_given_PLTHESAT,
     modelPar_PWTHESAT,
     modelPar_given_PWTHESAT,
     modelPar_PLWTHESAT,
     modelPar_given_PLWTHESAT,
     modelPar_POSTTHESAT,
     modelPar_given_POSTTHESAT,
     modelPar_PLSTTHESAT,
     modelPar_given_PLSTTHESAT,
     modelPar_PWSTTHESAT,
     modelPar_given_PWSTTHESAT,
     modelPar_PLWSTTHESAT,
     modelPar_given_PLWSTTHESAT,
     modelPar_POTHESATB,
     modelPar_given_POTHESATB,
     modelPar_PLTHESATB,
     modelPar_given_PLTHESATB,
     modelPar_PWTHESATB,
     modelPar_given_PWTHESATB,
     modelPar_PLWTHESATB,
     modelPar_given_PLWTHESATB,
     modelPar_POTHESATG,
     modelPar_given_POTHESATG,
     modelPar_PLTHESATG,
     modelPar_given_PLTHESATG,
     modelPar_PWTHESATG,
     modelPar_given_PWTHESATG,
     modelPar_PLWTHESATG,
     modelPar_given_PLWTHESATG,
     modelPar_POAX,
     modelPar_given_POAX,
     modelPar_PLAX,
     modelPar_given_PLAX,
     modelPar_PWAX,
     modelPar_given_PWAX,
     modelPar_PLWAX,
     modelPar_given_PLWAX,
     modelPar_POALP,
     modelPar_given_POALP,
     modelPar_PLALP,
     modelPar_given_PLALP,
     modelPar_PWALP,
     modelPar_given_PWALP,
     modelPar_PLWALP,
     modelPar_given_PLWALP,
     modelPar_POALP1,
     modelPar_given_POALP1,
     modelPar_PLALP1,
     modelPar_given_PLALP1,
     modelPar_PWALP1,
     modelPar_given_PWALP1,
     modelPar_PLWALP1,
     modelPar_given_PLWALP1,
     modelPar_POALP2,
     modelPar_given_POALP2,
     modelPar_PLALP2,
     modelPar_given_PLALP2,
     modelPar_PWALP2,
     modelPar_given_PWALP2,
     modelPar_PLWALP2,
     modelPar_given_PLWALP2,
     modelPar_POVP,
     modelPar_given_POVP,
     modelPar_POA1,
     modelPar_given_POA1,
     modelPar_PLA1,
     modelPar_given_PLA1,
     modelPar_PWA1,
     modelPar_given_PWA1,
     modelPar_PLWA1,
     modelPar_given_PLWA1,
     modelPar_POA2,
     modelPar_given_POA2,
     modelPar_POSTA2,
     modelPar_given_POSTA2,
     modelPar_POA3,
     modelPar_given_POA3,
     modelPar_PLA3,
     modelPar_given_PLA3,
     modelPar_PWA3,
     modelPar_given_PWA3,
     modelPar_PLWA3,
     modelPar_given_PLWA3,
     modelPar_POA4,
     modelPar_given_POA4,
     modelPar_PLA4,
     modelPar_given_PLA4,
     modelPar_PWA4,
     modelPar_given_PWA4,
     modelPar_PLWA4,
     modelPar_given_PLWA4,
     modelPar_POGCO,
     modelPar_given_POGCO,
     modelPar_POIGINV,
     modelPar_given_POIGINV,
     modelPar_PLIGINV,
     modelPar_given_PLIGINV,
     modelPar_PWIGINV,
     modelPar_given_PWIGINV,
     modelPar_PLWIGINV,
     modelPar_given_PLWIGINV,
     modelPar_POIGOV,
     modelPar_given_POIGOV,
     modelPar_PLIGOV,
     modelPar_given_PLIGOV,
     modelPar_PWIGOV,
     modelPar_given_PWIGOV,
     modelPar_PLWIGOV,
     modelPar_given_PLWIGOV,
     modelPar_POIGOVD,
     modelPar_given_POIGOVD,
     modelPar_PLIGOVD,
     modelPar_given_PLIGOVD,
     modelPar_PWIGOVD,
     modelPar_given_PWIGOVD,
     modelPar_PLWIGOVD,
     modelPar_given_PLWIGOVD,
     modelPar_POSTIG,
     modelPar_given_POSTIG,
     modelPar_POGC2,
     modelPar_given_POGC2,
     modelPar_POGC3,
     modelPar_given_POGC3,
     modelPar_POCHIB,
     modelPar_given_POCHIB,
     modelPar_POAGIDL,
     modelPar_given_POAGIDL,
     modelPar_PLAGIDL,
     modelPar_given_PLAGIDL,
     modelPar_PWAGIDL,
     modelPar_given_PWAGIDL,
     modelPar_PLWAGIDL,
     modelPar_given_PLWAGIDL,
     modelPar_POAGIDLD,
     modelPar_given_POAGIDLD,
     modelPar_PLAGIDLD,
     modelPar_given_PLAGIDLD,
     modelPar_PWAGIDLD,
     modelPar_given_PWAGIDLD,
     modelPar_PLWAGIDLD,
     modelPar_given_PLWAGIDLD,
     modelPar_POBGIDL,
     modelPar_given_POBGIDL,
     modelPar_POBGIDLD,
     modelPar_given_POBGIDLD,
     modelPar_POSTBGIDL,
     modelPar_given_POSTBGIDL,
     modelPar_POSTBGIDLD,
     modelPar_given_POSTBGIDLD,
     modelPar_POCGIDL,
     modelPar_given_POCGIDL,
     modelPar_POCGIDLD,
     modelPar_given_POCGIDLD,
     modelPar_POCOX,
     modelPar_given_POCOX,
     modelPar_PLCOX,
     modelPar_given_PLCOX,
     modelPar_PWCOX,
     modelPar_given_PWCOX,
     modelPar_PLWCOX,
     modelPar_given_PLWCOX,
     modelPar_POCGOV,
     modelPar_given_POCGOV,
     modelPar_PLCGOV,
     modelPar_given_PLCGOV,
     modelPar_PWCGOV,
     modelPar_given_PWCGOV,
     modelPar_PLWCGOV,
     modelPar_given_PLWCGOV,
     modelPar_POCGOVD,
     modelPar_given_POCGOVD,
     modelPar_PLCGOVD,
     modelPar_given_PLCGOVD,
     modelPar_PWCGOVD,
     modelPar_given_PWCGOVD,
     modelPar_PLWCGOVD,
     modelPar_given_PLWCGOVD,
     modelPar_POCGBOV,
     modelPar_given_POCGBOV,
     modelPar_PLCGBOV,
     modelPar_given_PLCGBOV,
     modelPar_PWCGBOV,
     modelPar_given_PWCGBOV,
     modelPar_PLWCGBOV,
     modelPar_given_PLWCGBOV,
     modelPar_POCFR,
     modelPar_given_POCFR,
     modelPar_PLCFR,
     modelPar_given_PLCFR,
     modelPar_PWCFR,
     modelPar_given_PWCFR,
     modelPar_PLWCFR,
     modelPar_given_PLWCFR,
     modelPar_POCFRD,
     modelPar_given_POCFRD,
     modelPar_PLCFRD,
     modelPar_given_PLCFRD,
     modelPar_PWCFRD,
     modelPar_given_PWCFRD,
     modelPar_PLWCFRD,
     modelPar_given_PLWCFRD,
     modelPar_POFNT,
     modelPar_given_POFNT,
     modelPar_POFNTEXC,
     modelPar_given_POFNTEXC,
     modelPar_PLFNTEXC,
     modelPar_given_PLFNTEXC,
     modelPar_PWFNTEXC,
     modelPar_given_PWFNTEXC,
     modelPar_PLWFNTEXC,
     modelPar_given_PLWFNTEXC,
     modelPar_PONFA,
     modelPar_given_PONFA,
     modelPar_PLNFA,
     modelPar_given_PLNFA,
     modelPar_PWNFA,
     modelPar_given_PWNFA,
     modelPar_PLWNFA,
     modelPar_given_PLWNFA,
     modelPar_PONFB,
     modelPar_given_PONFB,
     modelPar_PLNFB,
     modelPar_given_PLNFB,
     modelPar_PWNFB,
     modelPar_given_PWNFB,
     modelPar_PLWNFB,
     modelPar_given_PLWNFB,
     modelPar_PONFC,
     modelPar_given_PONFC,
     modelPar_PLNFC,
     modelPar_given_PLNFC,
     modelPar_PWNFC,
     modelPar_given_PWNFC,
     modelPar_PLWNFC,
     modelPar_given_PLWNFC,
     modelPar_POEF,
     modelPar_given_POEF,
     modelPar_POVFBEDGE,
     modelPar_given_POVFBEDGE,
     modelPar_POSTVFBEDGE,
     modelPar_given_POSTVFBEDGE,
     modelPar_PLSTVFBEDGE,
     modelPar_given_PLSTVFBEDGE,
     modelPar_PWSTVFBEDGE,
     modelPar_given_PWSTVFBEDGE,
     modelPar_PLWSTVFBEDGE,
     modelPar_given_PLWSTVFBEDGE,
     modelPar_PODPHIBEDGE,
     modelPar_given_PODPHIBEDGE,
     modelPar_PLDPHIBEDGE,
     modelPar_given_PLDPHIBEDGE,
     modelPar_PWDPHIBEDGE,
     modelPar_given_PWDPHIBEDGE,
     modelPar_PLWDPHIBEDGE,
     modelPar_given_PLWDPHIBEDGE,
     modelPar_PONEFFEDGE,
     modelPar_given_PONEFFEDGE,
     modelPar_PLNEFFEDGE,
     modelPar_given_PLNEFFEDGE,
     modelPar_PWNEFFEDGE,
     modelPar_given_PWNEFFEDGE,
     modelPar_PLWNEFFEDGE,
     modelPar_given_PLWNEFFEDGE,
     modelPar_POCTEDGE,
     modelPar_given_POCTEDGE,
     modelPar_PLCTEDGE,
     modelPar_given_PLCTEDGE,
     modelPar_PWCTEDGE,
     modelPar_given_PWCTEDGE,
     modelPar_PLWCTEDGE,
     modelPar_given_PLWCTEDGE,
     modelPar_POBETNEDGE,
     modelPar_given_POBETNEDGE,
     modelPar_PLBETNEDGE,
     modelPar_given_PLBETNEDGE,
     modelPar_PWBETNEDGE,
     modelPar_given_PWBETNEDGE,
     modelPar_PLWBETNEDGE,
     modelPar_given_PLWBETNEDGE,
     modelPar_POSTBETEDGE,
     modelPar_given_POSTBETEDGE,
     modelPar_PLSTBETEDGE,
     modelPar_given_PLSTBETEDGE,
     modelPar_PWSTBETEDGE,
     modelPar_given_PWSTBETEDGE,
     modelPar_PLWSTBETEDGE,
     modelPar_given_PLWSTBETEDGE,
     modelPar_POPSCEEDGE,
     modelPar_given_POPSCEEDGE,
     modelPar_PLPSCEEDGE,
     modelPar_given_PLPSCEEDGE,
     modelPar_PWPSCEEDGE,
     modelPar_given_PWPSCEEDGE,
     modelPar_PLWPSCEEDGE,
     modelPar_given_PLWPSCEEDGE,
     modelPar_POPSCEBEDGE,
     modelPar_given_POPSCEBEDGE,
     modelPar_POPSCEDEDGE,
     modelPar_given_POPSCEDEDGE,
     modelPar_POCFEDGE,
     modelPar_given_POCFEDGE,
     modelPar_PLCFEDGE,
     modelPar_given_PLCFEDGE,
     modelPar_PWCFEDGE,
     modelPar_given_PWCFEDGE,
     modelPar_PLWCFEDGE,
     modelPar_given_PLWCFEDGE,
     modelPar_POCFDEDGE,
     modelPar_given_POCFDEDGE,
     modelPar_POCFBEDGE,
     modelPar_given_POCFBEDGE,
     modelPar_POFNTEDGE,
     modelPar_given_POFNTEDGE,
     modelPar_PONFAEDGE,
     modelPar_given_PONFAEDGE,
     modelPar_PLNFAEDGE,
     modelPar_given_PLNFAEDGE,
     modelPar_PWNFAEDGE,
     modelPar_given_PWNFAEDGE,
     modelPar_PLWNFAEDGE,
     modelPar_given_PLWNFAEDGE,
     modelPar_PONFBEDGE,
     modelPar_given_PONFBEDGE,
     modelPar_PLNFBEDGE,
     modelPar_given_PLNFBEDGE,
     modelPar_PWNFBEDGE,
     modelPar_given_PWNFBEDGE,
     modelPar_PLWNFBEDGE,
     modelPar_given_PLWNFBEDGE,
     modelPar_PONFCEDGE,
     modelPar_given_PONFCEDGE,
     modelPar_PLNFCEDGE,
     modelPar_given_PLNFCEDGE,
     modelPar_PWNFCEDGE,
     modelPar_given_PWNFCEDGE,
     modelPar_PLWNFCEDGE,
     modelPar_given_PLWNFCEDGE,
     modelPar_POEFEDGE,
     modelPar_given_POEFEDGE,
     modelPar_POKVTHOWE,
     modelPar_given_POKVTHOWE,
     modelPar_PLKVTHOWE,
     modelPar_given_PLKVTHOWE,
     modelPar_PWKVTHOWE,
     modelPar_given_PWKVTHOWE,
     modelPar_PLWKVTHOWE,
     modelPar_given_PLWKVTHOWE,
     modelPar_POKUOWE,
     modelPar_given_POKUOWE,
     modelPar_PLKUOWE,
     modelPar_given_PLKUOWE,
     modelPar_PWKUOWE,
     modelPar_given_PWKUOWE,
     modelPar_PLWKUOWE,
     modelPar_given_PLWKUOWE,
     modelPar_LMIN,
     modelPar_given_LMIN,
     modelPar_LMAX,
     modelPar_given_LMAX,
     modelPar_WMIN,
     modelPar_given_WMIN,
     modelPar_WMAX,
     modelPar_given_WMAX,
     modelPar_LVARO,
     modelPar_given_LVARO,
     modelPar_LVARL,
     modelPar_given_LVARL,
     modelPar_LVARW,
     modelPar_given_LVARW,
     modelPar_LAP,
     modelPar_given_LAP,
     modelPar_WVARO,
     modelPar_given_WVARO,
     modelPar_WVARL,
     modelPar_given_WVARL,
     modelPar_WVARW,
     modelPar_given_WVARW,
     modelPar_WOT,
     modelPar_given_WOT,
     modelPar_DLQ,
     modelPar_given_DLQ,
     modelPar_DWQ,
     modelPar_given_DWQ,
     modelPar_VFBO,
     modelPar_given_VFBO,
     modelPar_VFBL,
     modelPar_given_VFBL,
     modelPar_VFBW,
     modelPar_given_VFBW,
     modelPar_VFBLW,
     modelPar_given_VFBLW,
     modelPar_STVFBO,
     modelPar_given_STVFBO,
     modelPar_STVFBL,
     modelPar_given_STVFBL,
     modelPar_STVFBW,
     modelPar_given_STVFBW,
     modelPar_STVFBLW,
     modelPar_given_STVFBLW,
     modelPar_TOXO,
     modelPar_given_TOXO,
     modelPar_EPSROXO,
     modelPar_given_EPSROXO,
     modelPar_NSUBO,
     modelPar_given_NSUBO,
     modelPar_NSUBW,
     modelPar_given_NSUBW,
     modelPar_WSEG,
     modelPar_given_WSEG,
     modelPar_NPCK,
     modelPar_given_NPCK,
     modelPar_NPCKW,
     modelPar_given_NPCKW,
     modelPar_WSEGP,
     modelPar_given_WSEGP,
     modelPar_LPCK,
     modelPar_given_LPCK,
     modelPar_LPCKW,
     modelPar_given_LPCKW,
     modelPar_FOL1,
     modelPar_given_FOL1,
     modelPar_FOL2,
     modelPar_given_FOL2,
     modelPar_FACNEFFACO,
     modelPar_given_FACNEFFACO,
     modelPar_FACNEFFACL,
     modelPar_given_FACNEFFACL,
     modelPar_FACNEFFACW,
     modelPar_given_FACNEFFACW,
     modelPar_FACNEFFACLW,
     modelPar_given_FACNEFFACLW,
     modelPar_GFACNUDO,
     modelPar_given_GFACNUDO,
     modelPar_GFACNUDL,
     modelPar_given_GFACNUDL,
     modelPar_GFACNUDLEXP,
     modelPar_given_GFACNUDLEXP,
     modelPar_GFACNUDW,
     modelPar_given_GFACNUDW,
     modelPar_GFACNUDLW,
     modelPar_given_GFACNUDLW,
     modelPar_VSBNUDO,
     modelPar_given_VSBNUDO,
     modelPar_DVSBNUDO,
     modelPar_given_DVSBNUDO,
     modelPar_VNSUBO,
     modelPar_given_VNSUBO,
     modelPar_NSLPO,
     modelPar_given_NSLPO,
     modelPar_DNSUBO,
     modelPar_given_DNSUBO,
     modelPar_DPHIBO,
     modelPar_given_DPHIBO,
     modelPar_DPHIBL,
     modelPar_given_DPHIBL,
     modelPar_DPHIBLEXP,
     modelPar_given_DPHIBLEXP,
     modelPar_DPHIBW,
     modelPar_given_DPHIBW,
     modelPar_DPHIBLW,
     modelPar_given_DPHIBLW,
     modelPar_DELVTACO,
     modelPar_given_DELVTACO,
     modelPar_DELVTACL,
     modelPar_given_DELVTACL,
     modelPar_DELVTACLEXP,
     modelPar_given_DELVTACLEXP,
     modelPar_DELVTACW,
     modelPar_given_DELVTACW,
     modelPar_DELVTACLW,
     modelPar_given_DELVTACLW,
     modelPar_NPO,
     modelPar_given_NPO,
     modelPar_NPL,
     modelPar_given_NPL,
     modelPar_CTO,
     modelPar_given_CTO,
     modelPar_CTL,
     modelPar_given_CTL,
     modelPar_CTLEXP,
     modelPar_given_CTLEXP,
     modelPar_CTW,
     modelPar_given_CTW,
     modelPar_CTLW,
     modelPar_given_CTLW,
     modelPar_TOXOVO,
     modelPar_given_TOXOVO,
     modelPar_TOXOVDO,
     modelPar_given_TOXOVDO,
     modelPar_LOV,
     modelPar_given_LOV,
     modelPar_LOVD,
     modelPar_given_LOVD,
     modelPar_NOVO,
     modelPar_given_NOVO,
     modelPar_NOVDO,
     modelPar_given_NOVDO,
     modelPar_CFL,
     modelPar_given_CFL,
     modelPar_CFLEXP,
     modelPar_given_CFLEXP,
     modelPar_CFW,
     modelPar_given_CFW,
     modelPar_CFDO,
     modelPar_given_CFDO,
     modelPar_CFBO,
     modelPar_given_CFBO,
     modelPar_PSCEL,
     modelPar_given_PSCEL,
     modelPar_PSCELEXP,
     modelPar_given_PSCELEXP,
     modelPar_PSCEW,
     modelPar_given_PSCEW,
     modelPar_PSCEBO,
     modelPar_given_PSCEBO,
     modelPar_PSCEDO,
     modelPar_given_PSCEDO,
     modelPar_UO,
     modelPar_given_UO,
     modelPar_FBET1,
     modelPar_given_FBET1,
     modelPar_FBET1W,
     modelPar_given_FBET1W,
     modelPar_LP1,
     modelPar_given_LP1,
     modelPar_LP1W,
     modelPar_given_LP1W,
     modelPar_FBET2,
     modelPar_given_FBET2,
     modelPar_LP2,
     modelPar_given_LP2,
     modelPar_BETW1,
     modelPar_given_BETW1,
     modelPar_BETW2,
     modelPar_given_BETW2,
     modelPar_WBET,
     modelPar_given_WBET,
     modelPar_STBETO,
     modelPar_given_STBETO,
     modelPar_STBETL,
     modelPar_given_STBETL,
     modelPar_STBETW,
     modelPar_given_STBETW,
     modelPar_STBETLW,
     modelPar_given_STBETLW,
     modelPar_MUEO,
     modelPar_given_MUEO,
     modelPar_MUEW,
     modelPar_given_MUEW,
     modelPar_STMUEO,
     modelPar_given_STMUEO,
     modelPar_THEMUO,
     modelPar_given_THEMUO,
     modelPar_STTHEMUO,
     modelPar_given_STTHEMUO,
     modelPar_CSO,
     modelPar_given_CSO,
     modelPar_CSL,
     modelPar_given_CSL,
     modelPar_CSLEXP,
     modelPar_given_CSLEXP,
     modelPar_CSW,
     modelPar_given_CSW,
     modelPar_CSLW,
     modelPar_given_CSLW,
     modelPar_STCSO,
     modelPar_given_STCSO,
     modelPar_XCORO,
     modelPar_given_XCORO,
     modelPar_XCORL,
     modelPar_given_XCORL,
     modelPar_XCORW,
     modelPar_given_XCORW,
     modelPar_XCORLW,
     modelPar_given_XCORLW,
     modelPar_STXCORO,
     modelPar_given_STXCORO,
     modelPar_FETAO,
     modelPar_given_FETAO,
     modelPar_RSW1,
     modelPar_given_RSW1,
     modelPar_RSW2,
     modelPar_given_RSW2,
     modelPar_STRSO,
     modelPar_given_STRSO,
     modelPar_RSBO,
     modelPar_given_RSBO,
     modelPar_RSGO,
     modelPar_given_RSGO,
     modelPar_THESATO,
     modelPar_given_THESATO,
     modelPar_THESATL,
     modelPar_given_THESATL,
     modelPar_THESATLEXP,
     modelPar_given_THESATLEXP,
     modelPar_THESATW,
     modelPar_given_THESATW,
     modelPar_THESATLW,
     modelPar_given_THESATLW,
     modelPar_STTHESATO,
     modelPar_given_STTHESATO,
     modelPar_STTHESATL,
     modelPar_given_STTHESATL,
     modelPar_STTHESATW,
     modelPar_given_STTHESATW,
     modelPar_STTHESATLW,
     modelPar_given_STTHESATLW,
     modelPar_THESATBO,
     modelPar_given_THESATBO,
     modelPar_THESATGO,
     modelPar_given_THESATGO,
     modelPar_AXO,
     modelPar_given_AXO,
     modelPar_AXL,
     modelPar_given_AXL,
     modelPar_ALPL,
     modelPar_given_ALPL,
     modelPar_ALPLEXP,
     modelPar_given_ALPLEXP,
     modelPar_ALPW,
     modelPar_given_ALPW,
     modelPar_ALP1L1,
     modelPar_given_ALP1L1,
     modelPar_ALP1LEXP,
     modelPar_given_ALP1LEXP,
     modelPar_ALP1L2,
     modelPar_given_ALP1L2,
     modelPar_ALP1W,
     modelPar_given_ALP1W,
     modelPar_ALP2L1,
     modelPar_given_ALP2L1,
     modelPar_ALP2LEXP,
     modelPar_given_ALP2LEXP,
     modelPar_ALP2L2,
     modelPar_given_ALP2L2,
     modelPar_ALP2W,
     modelPar_given_ALP2W,
     modelPar_VPO,
     modelPar_given_VPO,
     modelPar_A1O,
     modelPar_given_A1O,
     modelPar_A1L,
     modelPar_given_A1L,
     modelPar_A1W,
     modelPar_given_A1W,
     modelPar_A2O,
     modelPar_given_A2O,
     modelPar_STA2O,
     modelPar_given_STA2O,
     modelPar_A3O,
     modelPar_given_A3O,
     modelPar_A3L,
     modelPar_given_A3L,
     modelPar_A3W,
     modelPar_given_A3W,
     modelPar_A4O,
     modelPar_given_A4O,
     modelPar_A4L,
     modelPar_given_A4L,
     modelPar_A4W,
     modelPar_given_A4W,
     modelPar_GCOO,
     modelPar_given_GCOO,
     modelPar_IGINVLW,
     modelPar_given_IGINVLW,
     modelPar_IGOVW,
     modelPar_given_IGOVW,
     modelPar_IGOVDW,
     modelPar_given_IGOVDW,
     modelPar_STIGO,
     modelPar_given_STIGO,
     modelPar_GC2O,
     modelPar_given_GC2O,
     modelPar_GC3O,
     modelPar_given_GC3O,
     modelPar_CHIBO,
     modelPar_given_CHIBO,
     modelPar_AGIDLW,
     modelPar_given_AGIDLW,
     modelPar_AGIDLDW,
     modelPar_given_AGIDLDW,
     modelPar_BGIDLO,
     modelPar_given_BGIDLO,
     modelPar_BGIDLDO,
     modelPar_given_BGIDLDO,
     modelPar_STBGIDLO,
     modelPar_given_STBGIDLO,
     modelPar_STBGIDLDO,
     modelPar_given_STBGIDLDO,
     modelPar_CGIDLO,
     modelPar_given_CGIDLO,
     modelPar_CGIDLDO,
     modelPar_given_CGIDLDO,
     modelPar_CGBOVL,
     modelPar_given_CGBOVL,
     modelPar_CFRW,
     modelPar_given_CFRW,
     modelPar_CFRDW,
     modelPar_given_CFRDW,
     modelPar_FNTO,
     modelPar_given_FNTO,
     modelPar_FNTEXCL,
     modelPar_given_FNTEXCL,
     modelPar_NFALW,
     modelPar_given_NFALW,
     modelPar_NFBLW,
     modelPar_given_NFBLW,
     modelPar_NFCLW,
     modelPar_given_NFCLW,
     modelPar_EFO,
     modelPar_given_EFO,
     modelPar_LINTNOI,
     modelPar_given_LINTNOI,
     modelPar_ALPNOI,
     modelPar_given_ALPNOI,
     modelPar_WEDGE,
     modelPar_given_WEDGE,
     modelPar_WEDGEW,
     modelPar_given_WEDGEW,
     modelPar_VFBEDGEO,
     modelPar_given_VFBEDGEO,
     modelPar_STVFBEDGEO,
     modelPar_given_STVFBEDGEO,
     modelPar_STVFBEDGEL,
     modelPar_given_STVFBEDGEL,
     modelPar_STVFBEDGEW,
     modelPar_given_STVFBEDGEW,
     modelPar_STVFBEDGELW,
     modelPar_given_STVFBEDGELW,
     modelPar_DPHIBEDGEO,
     modelPar_given_DPHIBEDGEO,
     modelPar_DPHIBEDGEL,
     modelPar_given_DPHIBEDGEL,
     modelPar_DPHIBEDGELEXP,
     modelPar_given_DPHIBEDGELEXP,
     modelPar_DPHIBEDGEW,
     modelPar_given_DPHIBEDGEW,
     modelPar_DPHIBEDGELW,
     modelPar_given_DPHIBEDGELW,
     modelPar_NSUBEDGEO,
     modelPar_given_NSUBEDGEO,
     modelPar_NSUBEDGEL,
     modelPar_given_NSUBEDGEL,
     modelPar_NSUBEDGEW,
     modelPar_given_NSUBEDGEW,
     modelPar_NSUBEDGELW,
     modelPar_given_NSUBEDGELW,
     modelPar_CTEDGEO,
     modelPar_given_CTEDGEO,
     modelPar_CTEDGEL,
     modelPar_given_CTEDGEL,
     modelPar_CTEDGELEXP,
     modelPar_given_CTEDGELEXP,
     modelPar_FBETEDGE,
     modelPar_given_FBETEDGE,
     modelPar_LPEDGE,
     modelPar_given_LPEDGE,
     modelPar_BETEDGEW,
     modelPar_given_BETEDGEW,
     modelPar_STBETEDGEO,
     modelPar_given_STBETEDGEO,
     modelPar_STBETEDGEL,
     modelPar_given_STBETEDGEL,
     modelPar_STBETEDGEW,
     modelPar_given_STBETEDGEW,
     modelPar_STBETEDGELW,
     modelPar_given_STBETEDGELW,
     modelPar_PSCEEDGEL,
     modelPar_given_PSCEEDGEL,
     modelPar_PSCEEDGELEXP,
     modelPar_given_PSCEEDGELEXP,
     modelPar_PSCEEDGEW,
     modelPar_given_PSCEEDGEW,
     modelPar_PSCEBEDGEO,
     modelPar_given_PSCEBEDGEO,
     modelPar_PSCEDEDGEO,
     modelPar_given_PSCEDEDGEO,
     modelPar_CFEDGEL,
     modelPar_given_CFEDGEL,
     modelPar_CFEDGELEXP,
     modelPar_given_CFEDGELEXP,
     modelPar_CFEDGEW,
     modelPar_given_CFEDGEW,
     modelPar_CFDEDGEO,
     modelPar_given_CFDEDGEO,
     modelPar_CFBEDGEO,
     modelPar_given_CFBEDGEO,
     modelPar_FNTEDGEO,
     modelPar_given_FNTEDGEO,
     modelPar_NFAEDGELW,
     modelPar_given_NFAEDGELW,
     modelPar_NFBEDGELW,
     modelPar_given_NFBEDGELW,
     modelPar_NFCEDGELW,
     modelPar_given_NFCEDGELW,
     modelPar_EFEDGEO,
     modelPar_given_EFEDGEO,
     modelPar_KVTHOWEO,
     modelPar_given_KVTHOWEO,
     modelPar_KVTHOWEL,
     modelPar_given_KVTHOWEL,
     modelPar_KVTHOWEW,
     modelPar_given_KVTHOWEW,
     modelPar_KVTHOWELW,
     modelPar_given_KVTHOWELW,
     modelPar_KUOWEO,
     modelPar_given_KUOWEO,
     modelPar_KUOWEL,
     modelPar_given_KUOWEL,
     modelPar_KUOWEW,
     modelPar_given_KUOWEW,
     modelPar_KUOWELW,
     modelPar_given_KUOWELW,
     modelPar_RGO,
     modelPar_given_RGO,
     modelPar_RINT,
     modelPar_given_RINT,
     modelPar_RVPOLY,
     modelPar_given_RVPOLY,
     modelPar_RSHG,
     modelPar_given_RSHG,
     modelPar_DLSIL,
     modelPar_given_DLSIL,
     modelPar_RSH,
     modelPar_given_RSH,
     modelPar_RSHD,
     modelPar_given_RSHD,
     modelPar_RBULKO,
     modelPar_given_RBULKO,
     modelPar_RWELLO,
     modelPar_given_RWELLO,
     modelPar_RJUNSO,
     modelPar_given_RJUNSO,
     modelPar_RJUNDO,
     modelPar_given_RJUNDO,
     modelPar_SAREF,
     modelPar_given_SAREF,
     modelPar_SBREF,
     modelPar_given_SBREF,
     modelPar_WLOD,
     modelPar_given_WLOD,
     modelPar_KUO,
     modelPar_given_KUO,
     modelPar_KVSAT,
     modelPar_given_KVSAT,
     modelPar_TKUO,
     modelPar_given_TKUO,
     modelPar_LKUO,
     modelPar_given_LKUO,
     modelPar_WKUO,
     modelPar_given_WKUO,
     modelPar_PKUO,
     modelPar_given_PKUO,
     modelPar_LLODKUO,
     modelPar_given_LLODKUO,
     modelPar_WLODKUO,
     modelPar_given_WLODKUO,
     modelPar_KVTHO,
     modelPar_given_KVTHO,
     modelPar_LKVTHO,
     modelPar_given_LKVTHO,
     modelPar_WKVTHO,
     modelPar_given_WKVTHO,
     modelPar_PKVTHO,
     modelPar_given_PKVTHO,
     modelPar_LLODVTH,
     modelPar_given_LLODVTH,
     modelPar_WLODVTH,
     modelPar_given_WLODVTH,
     modelPar_STETAO,
     modelPar_given_STETAO,
     modelPar_LODETAO,
     modelPar_given_LODETAO,
     modelPar_SCREF,
     modelPar_given_SCREF,
     modelPar_WEB,
     modelPar_given_WEB,
     modelPar_WEC,
     modelPar_given_WEC,
     modelPar_IMAX,
     modelPar_given_IMAX,
     modelPar_TRJ,
     modelPar_given_TRJ,
     modelPar_FREV,
     modelPar_given_FREV,
     modelPar_CJORBOT,
     modelPar_given_CJORBOT,
     modelPar_CJORSTI,
     modelPar_given_CJORSTI,
     modelPar_CJORGAT,
     modelPar_given_CJORGAT,
     modelPar_VBIRBOT,
     modelPar_given_VBIRBOT,
     modelPar_VBIRSTI,
     modelPar_given_VBIRSTI,
     modelPar_VBIRGAT,
     modelPar_given_VBIRGAT,
     modelPar_PBOT,
     modelPar_given_PBOT,
     modelPar_PSTI,
     modelPar_given_PSTI,
     modelPar_PGAT,
     modelPar_given_PGAT,
     modelPar_PHIGBOT,
     modelPar_given_PHIGBOT,
     modelPar_PHIGSTI,
     modelPar_given_PHIGSTI,
     modelPar_PHIGGAT,
     modelPar_given_PHIGGAT,
     modelPar_IDSATRBOT,
     modelPar_given_IDSATRBOT,
     modelPar_IDSATRSTI,
     modelPar_given_IDSATRSTI,
     modelPar_IDSATRGAT,
     modelPar_given_IDSATRGAT,
     modelPar_CSRHBOT,
     modelPar_given_CSRHBOT,
     modelPar_CSRHSTI,
     modelPar_given_CSRHSTI,
     modelPar_CSRHGAT,
     modelPar_given_CSRHGAT,
     modelPar_XJUNSTI,
     modelPar_given_XJUNSTI,
     modelPar_XJUNGAT,
     modelPar_given_XJUNGAT,
     modelPar_CTATBOT,
     modelPar_given_CTATBOT,
     modelPar_CTATSTI,
     modelPar_given_CTATSTI,
     modelPar_CTATGAT,
     modelPar_given_CTATGAT,
     modelPar_MEFFTATBOT,
     modelPar_given_MEFFTATBOT,
     modelPar_MEFFTATSTI,
     modelPar_given_MEFFTATSTI,
     modelPar_MEFFTATGAT,
     modelPar_given_MEFFTATGAT,
     modelPar_CBBTBOT,
     modelPar_given_CBBTBOT,
     modelPar_CBBTSTI,
     modelPar_given_CBBTSTI,
     modelPar_CBBTGAT,
     modelPar_given_CBBTGAT,
     modelPar_FBBTRBOT,
     modelPar_given_FBBTRBOT,
     modelPar_FBBTRSTI,
     modelPar_given_FBBTRSTI,
     modelPar_FBBTRGAT,
     modelPar_given_FBBTRGAT,
     modelPar_STFBBTBOT,
     modelPar_given_STFBBTBOT,
     modelPar_STFBBTSTI,
     modelPar_given_STFBBTSTI,
     modelPar_STFBBTGAT,
     modelPar_given_STFBBTGAT,
     modelPar_VBRBOT,
     modelPar_given_VBRBOT,
     modelPar_VBRSTI,
     modelPar_given_VBRSTI,
     modelPar_VBRGAT,
     modelPar_given_VBRGAT,
     modelPar_PBRBOT,
     modelPar_given_PBRBOT,
     modelPar_PBRSTI,
     modelPar_given_PBRSTI,
     modelPar_PBRGAT,
     modelPar_given_PBRGAT,
     modelPar_CJORBOTD,
     modelPar_given_CJORBOTD,
     modelPar_CJORSTID,
     modelPar_given_CJORSTID,
     modelPar_CJORGATD,
     modelPar_given_CJORGATD,
     modelPar_VBIRBOTD,
     modelPar_given_VBIRBOTD,
     modelPar_VBIRSTID,
     modelPar_given_VBIRSTID,
     modelPar_VBIRGATD,
     modelPar_given_VBIRGATD,
     modelPar_PBOTD,
     modelPar_given_PBOTD,
     modelPar_PSTID,
     modelPar_given_PSTID,
     modelPar_PGATD,
     modelPar_given_PGATD,
     modelPar_PHIGBOTD,
     modelPar_given_PHIGBOTD,
     modelPar_PHIGSTID,
     modelPar_given_PHIGSTID,
     modelPar_PHIGGATD,
     modelPar_given_PHIGGATD,
     modelPar_IDSATRBOTD,
     modelPar_given_IDSATRBOTD,
     modelPar_IDSATRSTID,
     modelPar_given_IDSATRSTID,
     modelPar_IDSATRGATD,
     modelPar_given_IDSATRGATD,
     modelPar_CSRHBOTD,
     modelPar_given_CSRHBOTD,
     modelPar_CSRHSTID,
     modelPar_given_CSRHSTID,
     modelPar_CSRHGATD,
     modelPar_given_CSRHGATD,
     modelPar_XJUNSTID,
     modelPar_given_XJUNSTID,
     modelPar_XJUNGATD,
     modelPar_given_XJUNGATD,
     modelPar_CTATBOTD,
     modelPar_given_CTATBOTD,
     modelPar_CTATSTID,
     modelPar_given_CTATSTID,
     modelPar_CTATGATD,
     modelPar_given_CTATGATD,
     modelPar_MEFFTATBOTD,
     modelPar_given_MEFFTATBOTD,
     modelPar_MEFFTATSTID,
     modelPar_given_MEFFTATSTID,
     modelPar_MEFFTATGATD,
     modelPar_given_MEFFTATGATD,
     modelPar_CBBTBOTD,
     modelPar_given_CBBTBOTD,
     modelPar_CBBTSTID,
     modelPar_given_CBBTSTID,
     modelPar_CBBTGATD,
     modelPar_given_CBBTGATD,
     modelPar_FBBTRBOTD,
     modelPar_given_FBBTRBOTD,
     modelPar_FBBTRSTID,
     modelPar_given_FBBTRSTID,
     modelPar_FBBTRGATD,
     modelPar_given_FBBTRGATD,
     modelPar_STFBBTBOTD,
     modelPar_given_STFBBTBOTD,
     modelPar_STFBBTSTID,
     modelPar_given_STFBBTSTID,
     modelPar_STFBBTGATD,
     modelPar_given_STFBBTGATD,
     modelPar_VBRBOTD,
     modelPar_given_VBRBOTD,
     modelPar_VBRSTID,
     modelPar_given_VBRSTID,
     modelPar_VBRGATD,
     modelPar_given_VBRGATD,
     modelPar_PBRBOTD,
     modelPar_given_PBRBOTD,
     modelPar_PBRSTID,
     modelPar_given_PBRSTID,
     modelPar_PBRGATD,
     modelPar_given_PBRGATD,
     modelPar_SWJUNEXP,
     modelPar_given_SWJUNEXP,
     modelPar_VJUNREF,
     modelPar_given_VJUNREF,
     modelPar_FJUNQ,
     modelPar_given_FJUNQ,
     modelPar_VJUNREFD,
     modelPar_given_VJUNREFD,
     modelPar_FJUNQD,
     modelPar_given_FJUNQD,
     modelPar_DTA,
     modelPar_given_DTA,
     // non-reals (including hidden)
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_TYPE,
     modelPar_given_TYPE,
     modelPar_SWGEO,
     modelPar_given_SWGEO,
     modelPar_SWIGATE,
     modelPar_given_SWIGATE,
     modelPar_SWIMPACT,
     modelPar_given_SWIMPACT,
     modelPar_SWGIDL,
     modelPar_given_SWGIDL,
     modelPar_SWJUNCAP,
     modelPar_given_SWJUNCAP,
     modelPar_SWJUNASYM,
     modelPar_given_SWJUNASYM,
     modelPar_SWNUD,
     modelPar_given_SWNUD,
     modelPar_SWEDGE,
     modelPar_given_SWEDGE,
     modelPar_SWDELVTAC,
     modelPar_given_SWDELVTAC,
     modelPar_SWIGN,
     modelPar_given_SWIGN// model variables
     ,
     // reals
     modelVar_TOXO_i,
     modelVar_EPSROXO_i,
     modelVar_NSUBO_i,
     modelVar_WSEG_i,
     modelVar_NPCK_i,
     modelVar_WSEGP_i,
     modelVar_LPCK_i,
     modelVar_TOXOVO_i,
     modelVar_TOXOVDO_i,
     modelVar_LOV_i,
     modelVar_LOVD_i,
     modelVar_LP1_i,
     modelVar_LP2_i,
     modelVar_WBET_i,
     modelVar_AXL_i,
     modelVar_ALP1L2_i,
     modelVar_ALP2L2_i,
     modelVar_SAREF_i,
     modelVar_SBREF_i,
     modelVar_KVSAT_i,
     modelVar_LLODKUO_i,
     modelVar_WLODKUO_i,
     modelVar_LLODVTH_i,
     modelVar_WLODVTH_i,
     modelVar_LODETAO_i,
     modelVar_SCREF_i,
     modelVar_WEB_i,
     modelVar_WEC_i,
     modelVar_RSHG_i,
     modelVar_RSH_i,
     modelVar_RSHD_i,
     modelVar_RINT_i,
     modelVar_RVPOLY_i,
     modelVar_NSUBEDGEO_i,
     modelVar_LPEDGE_i,
     modelVar_QMC_i,
     modelVar_rTa,
     modelVar_delTa,
     modelVar_phita,
     modelVar_inv_phita,
     modelVar_TKD,
     modelVar_delT,
     modelVar_rTn,
     modelVar_ln_rTn,
     modelVar_inv_phit,
     modelVar_Eg,
     modelVar_phibFac,
     modelVar_IMAX_i,
     modelVar_VBIRBOT_i,
     modelVar_VBIRSTI_i,
     modelVar_VBIRGAT_i,
     modelVar_PBOT_i,
     modelVar_PSTI_i,
     modelVar_PGAT_i,
     modelVar_CSRHBOT_i,
     modelVar_CSRHSTI_i,
     modelVar_CSRHGAT_i,
     modelVar_CTATBOT_i,
     modelVar_CTATSTI_i,
     modelVar_CTATGAT_i,
     modelVar_CBBTBOT_i,
     modelVar_CBBTSTI_i,
     modelVar_CBBTGAT_i,
     modelVar_VBRBOT_i,
     modelVar_VBRSTI_i,
     modelVar_VBRGAT_i,
     modelVar_PBRBOT_i,
     modelVar_PBRSTI_i,
     modelVar_PBRGAT_i,
     modelVar_SWJUNEXP_i,
     modelVar_VJUNREF_i,
     modelVar_FJUNQ_i,
     modelVar_phitr,
     modelVar_phitd,
     modelVar_phitdinv,
     modelVar_perfc,
     modelVar_berfc,
     modelVar_cerfc,
     modelVar_ftdbot,
     modelVar_ftdsti,
     modelVar_ftdgat,
     modelVar_idsatbot,
     modelVar_idsatsti,
     modelVar_idsatgat,
     modelVar_vbibot,
     modelVar_vbisti,
     modelVar_vbigat,
     modelVar_vbiinvbot,
     modelVar_vbiinvsti,
     modelVar_vbiinvgat,
     modelVar_one_minus_PBOT,
     modelVar_one_minus_PSTI,
     modelVar_one_minus_PGAT,
     modelVar_one_over_one_minus_PBOT,
     modelVar_one_over_one_minus_PSTI,
     modelVar_one_over_one_minus_PGAT,
     modelVar_cjobot,
     modelVar_cjosti,
     modelVar_cjogat,
     modelVar_qprefbot,
     modelVar_qprefsti,
     modelVar_qprefgat,
     modelVar_qpref2bot,
     modelVar_qpref2sti,
     modelVar_qpref2gat,
     modelVar_wdepnulrbot,
     modelVar_wdepnulrsti,
     modelVar_wdepnulrgat,
     modelVar_wdepnulrinvbot,
     modelVar_wdepnulrinvsti,
     modelVar_wdepnulrinvgat,
     modelVar_VBIRBOTinv,
     modelVar_VBIRSTIinv,
     modelVar_VBIRGATinv,
     modelVar_atatbot,
     modelVar_atatsti,
     modelVar_atatgat,
     modelVar_btatpartbot,
     modelVar_btatpartsti,
     modelVar_btatpartgat,
     modelVar_fbbtbot,
     modelVar_fbbtsti,
     modelVar_fbbtgat,
     modelVar_alphaav,
     modelVar_fstopbot,
     modelVar_fstopsti,
     modelVar_fstopgat,
     modelVar_VBRinvbot,
     modelVar_VBRinvsti,
     modelVar_VBRinvgat,
     modelVar_slopebot,
     modelVar_slopesti,
     modelVar_slopegat,
     modelVar_VBIRBOTD_i,
     modelVar_VBIRSTID_i,
     modelVar_VBIRGATD_i,
     modelVar_PBOTD_i,
     modelVar_PSTID_i,
     modelVar_PGATD_i,
     modelVar_CSRHBOTD_i,
     modelVar_CSRHSTID_i,
     modelVar_CSRHGATD_i,
     modelVar_CTATBOTD_i,
     modelVar_CTATSTID_i,
     modelVar_CTATGATD_i,
     modelVar_CBBTBOTD_i,
     modelVar_CBBTSTID_i,
     modelVar_CBBTGATD_i,
     modelVar_VBRBOTD_i,
     modelVar_VBRSTID_i,
     modelVar_VBRGATD_i,
     modelVar_PBRBOTD_i,
     modelVar_PBRSTID_i,
     modelVar_PBRGATD_i,
     modelVar_VJUNREFD_i,
     modelVar_FJUNQD_i,
     modelVar_ftdbot_d,
     modelVar_ftdsti_d,
     modelVar_ftdgat_d,
     modelVar_idsatbot_d,
     modelVar_idsatsti_d,
     modelVar_idsatgat_d,
     modelVar_vbibot_d,
     modelVar_vbisti_d,
     modelVar_vbigat_d,
     modelVar_vbiinvbot_d,
     modelVar_vbiinvsti_d,
     modelVar_vbiinvgat_d,
     modelVar_one_minus_PBOT_d,
     modelVar_one_minus_PSTI_d,
     modelVar_one_minus_PGAT_d,
     modelVar_one_over_one_minus_PBOT_d,
     modelVar_one_over_one_minus_PSTI_d,
     modelVar_one_over_one_minus_PGAT_d,
     modelVar_cjobot_d,
     modelVar_cjosti_d,
     modelVar_cjogat_d,
     modelVar_qprefbot_d,
     modelVar_qprefsti_d,
     modelVar_qprefgat_d,
     modelVar_qpref2bot_d,
     modelVar_qpref2sti_d,
     modelVar_qpref2gat_d,
     modelVar_wdepnulrbot_d,
     modelVar_wdepnulrsti_d,
     modelVar_wdepnulrgat_d,
     modelVar_wdepnulrinvbot_d,
     modelVar_wdepnulrinvsti_d,
     modelVar_wdepnulrinvgat_d,
     modelVar_VBIRBOTinv_d,
     modelVar_VBIRSTIinv_d,
     modelVar_VBIRGATinv_d,
     modelVar_atatbot_d,
     modelVar_atatsti_d,
     modelVar_atatgat_d,
     modelVar_btatpartbot_d,
     modelVar_btatpartsti_d,
     modelVar_btatpartgat_d,
     modelVar_fbbtbot_d,
     modelVar_fbbtsti_d,
     modelVar_fbbtgat_d,
     modelVar_fstopbot_d,
     modelVar_fstopsti_d,
     modelVar_fstopgat_d,
     modelVar_VBRinvbot_d,
     modelVar_VBRinvsti_d,
     modelVar_VBRinvgat_d,
     modelVar_slopebot_d,
     modelVar_slopesti_d,
     modelVar_slopegat_d,
     modelVar_phit,
     modelVar_nt0,
     modelVar_EPSSI,
     // non-reals
     modelVar_CHNL_TYPE,
     modelVar_SWGEO_i,
     modelVar_SWIGATE_i,
     modelVar_SWIMPACT_i,
     modelVar_SWGIDL_i,
     modelVar_SWJUNCAP_i,
     modelVar_SWJUNASYM_i,
     modelVar_SWNUD_i,
     modelVar_SWEDGE_i,
     modelVar_SWDELVTAC_i,
     modelVar_SWIGN_i,
     mod.admsModTemp,in.getDeviceOptions().gmin,in);
  evaluateInitialInstance(
     // instance parameters
     // reals
     instancePar_L,
     instancePar_given_L,
     instancePar_W,
     instancePar_given_W,
     instancePar_SA,
     instancePar_given_SA,
     instancePar_SB,
     instancePar_given_SB,
     instancePar_SD,
     instancePar_given_SD,
     instancePar_SCA,
     instancePar_given_SCA,
     instancePar_SCB,
     instancePar_given_SCB,
     instancePar_SCC,
     instancePar_given_SCC,
     instancePar_SC,
     instancePar_given_SC,
     instancePar_NF,
     instancePar_given_NF,
     instancePar_NGCON,
     instancePar_given_NGCON,
     instancePar_XGW,
     instancePar_given_XGW,
     instancePar_NRS,
     instancePar_given_NRS,
     instancePar_NRD,
     instancePar_given_NRD,
     instancePar_JW,
     instancePar_given_JW,
     instancePar_DELVTO,
     instancePar_given_DELVTO,
     instancePar_FACTUO,
     instancePar_given_FACTUO,
     instancePar_DELVTOEDGE,
     instancePar_given_DELVTOEDGE,
     instancePar_FACTUOEDGE,
     instancePar_given_FACTUOEDGE,
     instancePar_ABSOURCE,
     instancePar_given_ABSOURCE,
     instancePar_LSSOURCE,
     instancePar_given_LSSOURCE,
     instancePar_LGSOURCE,
     instancePar_given_LGSOURCE,
     instancePar_ABDRAIN,
     instancePar_given_ABDRAIN,
     instancePar_LSDRAIN,
     instancePar_given_LSDRAIN,
     instancePar_LGDRAIN,
     instancePar_given_LGDRAIN,
     instancePar_AS,
     instancePar_given_AS,
     instancePar_PS,
     instancePar_given_PS,
     instancePar_AD,
     instancePar_given_AD,
     instancePar_PD,
     instancePar_given_PD,
     instancePar_MULT,
     instancePar_given_MULT,
     // instance variables
     // reals
     instanceVar_MULT_i,
     instanceVar_GFACNUD_i,
     instanceVar_VNSUB_i,
     instanceVar_NSLP_i,
     instanceVar_DNSUB_i,
     instanceVar_CF_i,
     instanceVar_CFD_i,
     instanceVar_CFB_i,
     instanceVar_PSCE_i,
     instanceVar_PSCEB_i,
     instanceVar_PSCED_i,
     instanceVar_RSB_i,
     instanceVar_RSG_i,
     instanceVar_THESATB_i,
     instanceVar_THESATG_i,
     instanceVar_AX_i,
     instanceVar_ALP_i,
     instanceVar_ALP1_i,
     instanceVar_ALP2_i,
     instanceVar_A1_i,
     instanceVar_A3_i,
     instanceVar_A4_i,
     instanceVar_GCO_i,
     instanceVar_IGINV_i,
     instanceVar_IGOV_i,
     instanceVar_IGOVD_i,
     instanceVar_GC2_i,
     instanceVar_GC3_i,
     instanceVar_CHIB_i,
     instanceVar_AGIDL_i,
     instanceVar_AGIDLD_i,
     instanceVar_CGIDL_i,
     instanceVar_CGIDLD_i,
     instanceVar_COX_i,
     instanceVar_CGOV_i,
     instanceVar_CGOVD_i,
     instanceVar_CGBOV_i,
     instanceVar_CFR_i,
     instanceVar_CFRD_i,
     instanceVar_FNTEXC_i,
     instanceVar_NFA_i,
     instanceVar_NFB_i,
     instanceVar_NFC_i,
     instanceVar_EF_i,
     instanceVar_BETNEDGE_i,
     instanceVar_PSCEEDGE_i,
     instanceVar_PSCEBEDGE_i,
     instanceVar_PSCEDEDGE_i,
     instanceVar_CFEDGE_i,
     instanceVar_CFDEDGE_i,
     instanceVar_CFBEDGE_i,
     instanceVar_NFAEDGE_i,
     instanceVar_NFBEDGE_i,
     instanceVar_NFCEDGE_i,
     instanceVar_EFEDGE_i,
     instanceVar_RG_i,
     instanceVar_RSE_i,
     instanceVar_RDE_i,
     instanceVar_RBULK_i,
     instanceVar_RJUNS_i,
     instanceVar_RJUND_i,
     instanceVar_RWELL_i,
     instanceVar_ABSOURCE_i,
     instanceVar_LSSOURCE_i,
     instanceVar_LGSOURCE_i,
     instanceVar_zflagbot_s,
     instanceVar_zflagsti_s,
     instanceVar_zflaggat_s,
     instanceVar_VMAX_s,
     instanceVar_exp_VMAX_over_phitd_s,
     instanceVar_vbimin_s,
     instanceVar_vch_s,
     instanceVar_vfmin_s,
     instanceVar_vbbtlim_s,
     instanceVar_xhighf1_s,
     instanceVar_expxhf1_s,
     instanceVar_xhighf2_s,
     instanceVar_expxhf2_s,
     instanceVar_xhighr_s,
     instanceVar_expxhr_s,
     instanceVar_m0flag_s,
     instanceVar_ISATFOR1_s,
     instanceVar_MFOR1_s,
     instanceVar_ISATFOR2_s,
     instanceVar_MFOR2_s,
     instanceVar_ISATREV_s,
     instanceVar_MREV_s,
     instanceVar_ABDRAIN_i,
     instanceVar_LSDRAIN_i,
     instanceVar_LGDRAIN_i,
     instanceVar_zflagbot_d,
     instanceVar_zflagsti_d,
     instanceVar_zflaggat_d,
     instanceVar_VMAX_d,
     instanceVar_exp_VMAX_over_phitd_d,
     instanceVar_vbimin_d,
     instanceVar_vch_d,
     instanceVar_vfmin_d,
     instanceVar_vbbtlim_d,
     instanceVar_xhighf1_d,
     instanceVar_expxhf1_d,
     instanceVar_xhighf2_d,
     instanceVar_expxhf2_d,
     instanceVar_xhighr_d,
     instanceVar_expxhr_d,
     instanceVar_m0flag_d,
     instanceVar_ISATFOR1_d,
     instanceVar_MFOR1_d,
     instanceVar_ISATFOR2_d,
     instanceVar_MFOR2_d,
     instanceVar_ISATREV_d,
     instanceVar_MREV_d,
     instanceVar_VFB_T,
     instanceVar_MUE_T,
     instanceVar_THEMU_T,
     instanceVar_CS_T,
     instanceVar_XCOR_T,
     instanceVar_A2_T,
     instanceVar_VFBEDGE_T,
     instanceVar_phit0,
     instanceVar_BET_i,
     instanceVar_BETEDGE_i,
     instanceVar_nt,
     instanceVar_THESAT_T,
     instanceVar_Sfl_prefac,
     instanceVar_phit0edge,
     instanceVar_Gfedge2,
     instanceVar_lnGfedge2,
     instanceVar_Sfl_prefac_edge,
     instanceVar_ntedge,
     instanceVar_phib_dc,
     instanceVar_G_0_dc,
     instanceVar_kp,
     instanceVar_qlim2,
     instanceVar_sqrt_phib_dc,
     instanceVar_phix_dc,
     instanceVar_aphi_dc,
     instanceVar_bphi_dc,
     instanceVar_phix1_dc,
     instanceVar_alpha_b,
     instanceVar_us1,
     instanceVar_us21,
     instanceVar_phib_ac,
     instanceVar_G_0_ac,
     instanceVar_phix_ac,
     instanceVar_aphi_ac,
     instanceVar_bphi_ac,
     instanceVar_phix1_ac,
     instanceVar_THER_i,
     instanceVar_phibedge,
     instanceVar_Gfedge,
     instanceVar_phixedge,
     instanceVar_aphiedge,
     instanceVar_bphiedge,
     instanceVar_phix1edge,
     instanceVar_Cox_over_q,
     instanceVar_qq,
     instanceVar_E_eff0,
     instanceVar_eta_mu,
     instanceVar_eta_mu1,
     instanceVar_inv_AX,
     instanceVar_inv_VP,
     instanceVar_GOV_s,
     instanceVar_GOV_d,
     instanceVar_GOV2_s,
     instanceVar_GOV2_d,
     instanceVar_SP_OV_eps2_s,
     instanceVar_SP_OV_a_s,
     instanceVar_SP_OV_delta1_s,
     instanceVar_SP_OV_eps2_d,
     instanceVar_SP_OV_a_d,
     instanceVar_SP_OV_delta1_d,
     instanceVar_inv_CHIB,
     instanceVar_BCH,
     instanceVar_BOV,
     instanceVar_BOV_d,
     instanceVar_GCQ,
     instanceVar_AGIDLs,
     instanceVar_AGIDLDs,
     instanceVar_BGIDLs,
     instanceVar_BGIDLDs,
     instanceVar_fac_exc,
     instanceVar_ggate,
     instanceVar_gsource,
     instanceVar_gdrain,
     instanceVar_gbulk,
     instanceVar_gjuns,
     instanceVar_gjund,
     instanceVar_gwell,
     // model parameters
     // reals
     modelPar_TR,
     modelPar_given_TR,
     modelPar_QMC,
     modelPar_given_QMC,
     modelPar_VFB,
     modelPar_given_VFB,
     modelPar_STVFB,
     modelPar_given_STVFB,
     modelPar_TOX,
     modelPar_given_TOX,
     modelPar_EPSROX,
     modelPar_given_EPSROX,
     modelPar_NEFF,
     modelPar_given_NEFF,
     modelPar_FACNEFFAC,
     modelPar_given_FACNEFFAC,
     modelPar_GFACNUD,
     modelPar_given_GFACNUD,
     modelPar_VSBNUD,
     modelPar_given_VSBNUD,
     modelPar_DVSBNUD,
     modelPar_given_DVSBNUD,
     modelPar_VNSUB,
     modelPar_given_VNSUB,
     modelPar_NSLP,
     modelPar_given_NSLP,
     modelPar_DNSUB,
     modelPar_given_DNSUB,
     modelPar_DPHIB,
     modelPar_given_DPHIB,
     modelPar_DELVTAC,
     modelPar_given_DELVTAC,
     modelPar_NP,
     modelPar_given_NP,
     modelPar_CT,
     modelPar_given_CT,
     modelPar_TOXOV,
     modelPar_given_TOXOV,
     modelPar_TOXOVD,
     modelPar_given_TOXOVD,
     modelPar_NOV,
     modelPar_given_NOV,
     modelPar_NOVD,
     modelPar_given_NOVD,
     modelPar_CF,
     modelPar_given_CF,
     modelPar_CFD,
     modelPar_given_CFD,
     modelPar_CFB,
     modelPar_given_CFB,
     modelPar_PSCE,
     modelPar_given_PSCE,
     modelPar_PSCEB,
     modelPar_given_PSCEB,
     modelPar_PSCED,
     modelPar_given_PSCED,
     modelPar_BETN,
     modelPar_given_BETN,
     modelPar_STBET,
     modelPar_given_STBET,
     modelPar_MUE,
     modelPar_given_MUE,
     modelPar_STMUE,
     modelPar_given_STMUE,
     modelPar_THEMU,
     modelPar_given_THEMU,
     modelPar_STTHEMU,
     modelPar_given_STTHEMU,
     modelPar_CS,
     modelPar_given_CS,
     modelPar_STCS,
     modelPar_given_STCS,
     modelPar_XCOR,
     modelPar_given_XCOR,
     modelPar_STXCOR,
     modelPar_given_STXCOR,
     modelPar_FETA,
     modelPar_given_FETA,
     modelPar_RS,
     modelPar_given_RS,
     modelPar_STRS,
     modelPar_given_STRS,
     modelPar_RSB,
     modelPar_given_RSB,
     modelPar_RSG,
     modelPar_given_RSG,
     modelPar_THESAT,
     modelPar_given_THESAT,
     modelPar_STTHESAT,
     modelPar_given_STTHESAT,
     modelPar_THESATB,
     modelPar_given_THESATB,
     modelPar_THESATG,
     modelPar_given_THESATG,
     modelPar_AX,
     modelPar_given_AX,
     modelPar_ALP,
     modelPar_given_ALP,
     modelPar_ALP1,
     modelPar_given_ALP1,
     modelPar_ALP2,
     modelPar_given_ALP2,
     modelPar_VP,
     modelPar_given_VP,
     modelPar_A1,
     modelPar_given_A1,
     modelPar_A2,
     modelPar_given_A2,
     modelPar_STA2,
     modelPar_given_STA2,
     modelPar_A3,
     modelPar_given_A3,
     modelPar_A4,
     modelPar_given_A4,
     modelPar_GCO,
     modelPar_given_GCO,
     modelPar_IGINV,
     modelPar_given_IGINV,
     modelPar_IGOV,
     modelPar_given_IGOV,
     modelPar_IGOVD,
     modelPar_given_IGOVD,
     modelPar_STIG,
     modelPar_given_STIG,
     modelPar_GC2,
     modelPar_given_GC2,
     modelPar_GC3,
     modelPar_given_GC3,
     modelPar_CHIB,
     modelPar_given_CHIB,
     modelPar_AGIDL,
     modelPar_given_AGIDL,
     modelPar_AGIDLD,
     modelPar_given_AGIDLD,
     modelPar_BGIDL,
     modelPar_given_BGIDL,
     modelPar_BGIDLD,
     modelPar_given_BGIDLD,
     modelPar_STBGIDL,
     modelPar_given_STBGIDL,
     modelPar_STBGIDLD,
     modelPar_given_STBGIDLD,
     modelPar_CGIDL,
     modelPar_given_CGIDL,
     modelPar_CGIDLD,
     modelPar_given_CGIDLD,
     modelPar_COX,
     modelPar_given_COX,
     modelPar_CGOV,
     modelPar_given_CGOV,
     modelPar_CGOVD,
     modelPar_given_CGOVD,
     modelPar_CGBOV,
     modelPar_given_CGBOV,
     modelPar_CFR,
     modelPar_given_CFR,
     modelPar_CFRD,
     modelPar_given_CFRD,
     modelPar_FNT,
     modelPar_given_FNT,
     modelPar_FNTEXC,
     modelPar_given_FNTEXC,
     modelPar_NFA,
     modelPar_given_NFA,
     modelPar_NFB,
     modelPar_given_NFB,
     modelPar_NFC,
     modelPar_given_NFC,
     modelPar_EF,
     modelPar_given_EF,
     modelPar_VFBEDGE,
     modelPar_given_VFBEDGE,
     modelPar_STVFBEDGE,
     modelPar_given_STVFBEDGE,
     modelPar_DPHIBEDGE,
     modelPar_given_DPHIBEDGE,
     modelPar_NEFFEDGE,
     modelPar_given_NEFFEDGE,
     modelPar_CTEDGE,
     modelPar_given_CTEDGE,
     modelPar_BETNEDGE,
     modelPar_given_BETNEDGE,
     modelPar_STBETEDGE,
     modelPar_given_STBETEDGE,
     modelPar_PSCEEDGE,
     modelPar_given_PSCEEDGE,
     modelPar_PSCEBEDGE,
     modelPar_given_PSCEBEDGE,
     modelPar_PSCEDEDGE,
     modelPar_given_PSCEDEDGE,
     modelPar_CFEDGE,
     modelPar_given_CFEDGE,
     modelPar_CFDEDGE,
     modelPar_given_CFDEDGE,
     modelPar_CFBEDGE,
     modelPar_given_CFBEDGE,
     modelPar_FNTEDGE,
     modelPar_given_FNTEDGE,
     modelPar_NFAEDGE,
     modelPar_given_NFAEDGE,
     modelPar_NFBEDGE,
     modelPar_given_NFBEDGE,
     modelPar_NFCEDGE,
     modelPar_given_NFCEDGE,
     modelPar_EFEDGE,
     modelPar_given_EFEDGE,
     modelPar_RG,
     modelPar_given_RG,
     modelPar_RSE,
     modelPar_given_RSE,
     modelPar_RDE,
     modelPar_given_RDE,
     modelPar_RBULK,
     modelPar_given_RBULK,
     modelPar_RWELL,
     modelPar_given_RWELL,
     modelPar_RJUNS,
     modelPar_given_RJUNS,
     modelPar_RJUND,
     modelPar_given_RJUND,
     modelPar_POVFB,
     modelPar_given_POVFB,
     modelPar_PLVFB,
     modelPar_given_PLVFB,
     modelPar_PWVFB,
     modelPar_given_PWVFB,
     modelPar_PLWVFB,
     modelPar_given_PLWVFB,
     modelPar_POSTVFB,
     modelPar_given_POSTVFB,
     modelPar_PLSTVFB,
     modelPar_given_PLSTVFB,
     modelPar_PWSTVFB,
     modelPar_given_PWSTVFB,
     modelPar_PLWSTVFB,
     modelPar_given_PLWSTVFB,
     modelPar_POTOX,
     modelPar_given_POTOX,
     modelPar_POEPSROX,
     modelPar_given_POEPSROX,
     modelPar_PONEFF,
     modelPar_given_PONEFF,
     modelPar_PLNEFF,
     modelPar_given_PLNEFF,
     modelPar_PWNEFF,
     modelPar_given_PWNEFF,
     modelPar_PLWNEFF,
     modelPar_given_PLWNEFF,
     modelPar_POFACNEFFAC,
     modelPar_given_POFACNEFFAC,
     modelPar_PLFACNEFFAC,
     modelPar_given_PLFACNEFFAC,
     modelPar_PWFACNEFFAC,
     modelPar_given_PWFACNEFFAC,
     modelPar_PLWFACNEFFAC,
     modelPar_given_PLWFACNEFFAC,
     modelPar_POGFACNUD,
     modelPar_given_POGFACNUD,
     modelPar_PLGFACNUD,
     modelPar_given_PLGFACNUD,
     modelPar_PWGFACNUD,
     modelPar_given_PWGFACNUD,
     modelPar_PLWGFACNUD,
     modelPar_given_PLWGFACNUD,
     modelPar_POVSBNUD,
     modelPar_given_POVSBNUD,
     modelPar_PODVSBNUD,
     modelPar_given_PODVSBNUD,
     modelPar_POVNSUB,
     modelPar_given_POVNSUB,
     modelPar_PONSLP,
     modelPar_given_PONSLP,
     modelPar_PODNSUB,
     modelPar_given_PODNSUB,
     modelPar_PODPHIB,
     modelPar_given_PODPHIB,
     modelPar_PLDPHIB,
     modelPar_given_PLDPHIB,
     modelPar_PWDPHIB,
     modelPar_given_PWDPHIB,
     modelPar_PLWDPHIB,
     modelPar_given_PLWDPHIB,
     modelPar_PODELVTAC,
     modelPar_given_PODELVTAC,
     modelPar_PLDELVTAC,
     modelPar_given_PLDELVTAC,
     modelPar_PWDELVTAC,
     modelPar_given_PWDELVTAC,
     modelPar_PLWDELVTAC,
     modelPar_given_PLWDELVTAC,
     modelPar_PONP,
     modelPar_given_PONP,
     modelPar_PLNP,
     modelPar_given_PLNP,
     modelPar_PWNP,
     modelPar_given_PWNP,
     modelPar_PLWNP,
     modelPar_given_PLWNP,
     modelPar_POCT,
     modelPar_given_POCT,
     modelPar_PLCT,
     modelPar_given_PLCT,
     modelPar_PWCT,
     modelPar_given_PWCT,
     modelPar_PLWCT,
     modelPar_given_PLWCT,
     modelPar_POTOXOV,
     modelPar_given_POTOXOV,
     modelPar_POTOXOVD,
     modelPar_given_POTOXOVD,
     modelPar_PONOV,
     modelPar_given_PONOV,
     modelPar_PLNOV,
     modelPar_given_PLNOV,
     modelPar_PWNOV,
     modelPar_given_PWNOV,
     modelPar_PLWNOV,
     modelPar_given_PLWNOV,
     modelPar_PONOVD,
     modelPar_given_PONOVD,
     modelPar_PLNOVD,
     modelPar_given_PLNOVD,
     modelPar_PWNOVD,
     modelPar_given_PWNOVD,
     modelPar_PLWNOVD,
     modelPar_given_PLWNOVD,
     modelPar_POCF,
     modelPar_given_POCF,
     modelPar_PLCF,
     modelPar_given_PLCF,
     modelPar_PWCF,
     modelPar_given_PWCF,
     modelPar_PLWCF,
     modelPar_given_PLWCF,
     modelPar_POCFD,
     modelPar_given_POCFD,
     modelPar_POCFB,
     modelPar_given_POCFB,
     modelPar_POPSCE,
     modelPar_given_POPSCE,
     modelPar_PLPSCE,
     modelPar_given_PLPSCE,
     modelPar_PWPSCE,
     modelPar_given_PWPSCE,
     modelPar_PLWPSCE,
     modelPar_given_PLWPSCE,
     modelPar_POPSCEB,
     modelPar_given_POPSCEB,
     modelPar_POPSCED,
     modelPar_given_POPSCED,
     modelPar_POBETN,
     modelPar_given_POBETN,
     modelPar_PLBETN,
     modelPar_given_PLBETN,
     modelPar_PWBETN,
     modelPar_given_PWBETN,
     modelPar_PLWBETN,
     modelPar_given_PLWBETN,
     modelPar_POSTBET,
     modelPar_given_POSTBET,
     modelPar_PLSTBET,
     modelPar_given_PLSTBET,
     modelPar_PWSTBET,
     modelPar_given_PWSTBET,
     modelPar_PLWSTBET,
     modelPar_given_PLWSTBET,
     modelPar_POMUE,
     modelPar_given_POMUE,
     modelPar_PLMUE,
     modelPar_given_PLMUE,
     modelPar_PWMUE,
     modelPar_given_PWMUE,
     modelPar_PLWMUE,
     modelPar_given_PLWMUE,
     modelPar_POSTMUE,
     modelPar_given_POSTMUE,
     modelPar_POTHEMU,
     modelPar_given_POTHEMU,
     modelPar_POSTTHEMU,
     modelPar_given_POSTTHEMU,
     modelPar_POCS,
     modelPar_given_POCS,
     modelPar_PLCS,
     modelPar_given_PLCS,
     modelPar_PWCS,
     modelPar_given_PWCS,
     modelPar_PLWCS,
     modelPar_given_PLWCS,
     modelPar_POSTCS,
     modelPar_given_POSTCS,
     modelPar_POXCOR,
     modelPar_given_POXCOR,
     modelPar_PLXCOR,
     modelPar_given_PLXCOR,
     modelPar_PWXCOR,
     modelPar_given_PWXCOR,
     modelPar_PLWXCOR,
     modelPar_given_PLWXCOR,
     modelPar_POSTXCOR,
     modelPar_given_POSTXCOR,
     modelPar_POFETA,
     modelPar_given_POFETA,
     modelPar_PORS,
     modelPar_given_PORS,
     modelPar_PLRS,
     modelPar_given_PLRS,
     modelPar_PWRS,
     modelPar_given_PWRS,
     modelPar_PLWRS,
     modelPar_given_PLWRS,
     modelPar_POSTRS,
     modelPar_given_POSTRS,
     modelPar_PORSB,
     modelPar_given_PORSB,
     modelPar_PORSG,
     modelPar_given_PORSG,
     modelPar_POTHESAT,
     modelPar_given_POTHESAT,
     modelPar_PLTHESAT,
     modelPar_given_PLTHESAT,
     modelPar_PWTHESAT,
     modelPar_given_PWTHESAT,
     modelPar_PLWTHESAT,
     modelPar_given_PLWTHESAT,
     modelPar_POSTTHESAT,
     modelPar_given_POSTTHESAT,
     modelPar_PLSTTHESAT,
     modelPar_given_PLSTTHESAT,
     modelPar_PWSTTHESAT,
     modelPar_given_PWSTTHESAT,
     modelPar_PLWSTTHESAT,
     modelPar_given_PLWSTTHESAT,
     modelPar_POTHESATB,
     modelPar_given_POTHESATB,
     modelPar_PLTHESATB,
     modelPar_given_PLTHESATB,
     modelPar_PWTHESATB,
     modelPar_given_PWTHESATB,
     modelPar_PLWTHESATB,
     modelPar_given_PLWTHESATB,
     modelPar_POTHESATG,
     modelPar_given_POTHESATG,
     modelPar_PLTHESATG,
     modelPar_given_PLTHESATG,
     modelPar_PWTHESATG,
     modelPar_given_PWTHESATG,
     modelPar_PLWTHESATG,
     modelPar_given_PLWTHESATG,
     modelPar_POAX,
     modelPar_given_POAX,
     modelPar_PLAX,
     modelPar_given_PLAX,
     modelPar_PWAX,
     modelPar_given_PWAX,
     modelPar_PLWAX,
     modelPar_given_PLWAX,
     modelPar_POALP,
     modelPar_given_POALP,
     modelPar_PLALP,
     modelPar_given_PLALP,
     modelPar_PWALP,
     modelPar_given_PWALP,
     modelPar_PLWALP,
     modelPar_given_PLWALP,
     modelPar_POALP1,
     modelPar_given_POALP1,
     modelPar_PLALP1,
     modelPar_given_PLALP1,
     modelPar_PWALP1,
     modelPar_given_PWALP1,
     modelPar_PLWALP1,
     modelPar_given_PLWALP1,
     modelPar_POALP2,
     modelPar_given_POALP2,
     modelPar_PLALP2,
     modelPar_given_PLALP2,
     modelPar_PWALP2,
     modelPar_given_PWALP2,
     modelPar_PLWALP2,
     modelPar_given_PLWALP2,
     modelPar_POVP,
     modelPar_given_POVP,
     modelPar_POA1,
     modelPar_given_POA1,
     modelPar_PLA1,
     modelPar_given_PLA1,
     modelPar_PWA1,
     modelPar_given_PWA1,
     modelPar_PLWA1,
     modelPar_given_PLWA1,
     modelPar_POA2,
     modelPar_given_POA2,
     modelPar_POSTA2,
     modelPar_given_POSTA2,
     modelPar_POA3,
     modelPar_given_POA3,
     modelPar_PLA3,
     modelPar_given_PLA3,
     modelPar_PWA3,
     modelPar_given_PWA3,
     modelPar_PLWA3,
     modelPar_given_PLWA3,
     modelPar_POA4,
     modelPar_given_POA4,
     modelPar_PLA4,
     modelPar_given_PLA4,
     modelPar_PWA4,
     modelPar_given_PWA4,
     modelPar_PLWA4,
     modelPar_given_PLWA4,
     modelPar_POGCO,
     modelPar_given_POGCO,
     modelPar_POIGINV,
     modelPar_given_POIGINV,
     modelPar_PLIGINV,
     modelPar_given_PLIGINV,
     modelPar_PWIGINV,
     modelPar_given_PWIGINV,
     modelPar_PLWIGINV,
     modelPar_given_PLWIGINV,
     modelPar_POIGOV,
     modelPar_given_POIGOV,
     modelPar_PLIGOV,
     modelPar_given_PLIGOV,
     modelPar_PWIGOV,
     modelPar_given_PWIGOV,
     modelPar_PLWIGOV,
     modelPar_given_PLWIGOV,
     modelPar_POIGOVD,
     modelPar_given_POIGOVD,
     modelPar_PLIGOVD,
     modelPar_given_PLIGOVD,
     modelPar_PWIGOVD,
     modelPar_given_PWIGOVD,
     modelPar_PLWIGOVD,
     modelPar_given_PLWIGOVD,
     modelPar_POSTIG,
     modelPar_given_POSTIG,
     modelPar_POGC2,
     modelPar_given_POGC2,
     modelPar_POGC3,
     modelPar_given_POGC3,
     modelPar_POCHIB,
     modelPar_given_POCHIB,
     modelPar_POAGIDL,
     modelPar_given_POAGIDL,
     modelPar_PLAGIDL,
     modelPar_given_PLAGIDL,
     modelPar_PWAGIDL,
     modelPar_given_PWAGIDL,
     modelPar_PLWAGIDL,
     modelPar_given_PLWAGIDL,
     modelPar_POAGIDLD,
     modelPar_given_POAGIDLD,
     modelPar_PLAGIDLD,
     modelPar_given_PLAGIDLD,
     modelPar_PWAGIDLD,
     modelPar_given_PWAGIDLD,
     modelPar_PLWAGIDLD,
     modelPar_given_PLWAGIDLD,
     modelPar_POBGIDL,
     modelPar_given_POBGIDL,
     modelPar_POBGIDLD,
     modelPar_given_POBGIDLD,
     modelPar_POSTBGIDL,
     modelPar_given_POSTBGIDL,
     modelPar_POSTBGIDLD,
     modelPar_given_POSTBGIDLD,
     modelPar_POCGIDL,
     modelPar_given_POCGIDL,
     modelPar_POCGIDLD,
     modelPar_given_POCGIDLD,
     modelPar_POCOX,
     modelPar_given_POCOX,
     modelPar_PLCOX,
     modelPar_given_PLCOX,
     modelPar_PWCOX,
     modelPar_given_PWCOX,
     modelPar_PLWCOX,
     modelPar_given_PLWCOX,
     modelPar_POCGOV,
     modelPar_given_POCGOV,
     modelPar_PLCGOV,
     modelPar_given_PLCGOV,
     modelPar_PWCGOV,
     modelPar_given_PWCGOV,
     modelPar_PLWCGOV,
     modelPar_given_PLWCGOV,
     modelPar_POCGOVD,
     modelPar_given_POCGOVD,
     modelPar_PLCGOVD,
     modelPar_given_PLCGOVD,
     modelPar_PWCGOVD,
     modelPar_given_PWCGOVD,
     modelPar_PLWCGOVD,
     modelPar_given_PLWCGOVD,
     modelPar_POCGBOV,
     modelPar_given_POCGBOV,
     modelPar_PLCGBOV,
     modelPar_given_PLCGBOV,
     modelPar_PWCGBOV,
     modelPar_given_PWCGBOV,
     modelPar_PLWCGBOV,
     modelPar_given_PLWCGBOV,
     modelPar_POCFR,
     modelPar_given_POCFR,
     modelPar_PLCFR,
     modelPar_given_PLCFR,
     modelPar_PWCFR,
     modelPar_given_PWCFR,
     modelPar_PLWCFR,
     modelPar_given_PLWCFR,
     modelPar_POCFRD,
     modelPar_given_POCFRD,
     modelPar_PLCFRD,
     modelPar_given_PLCFRD,
     modelPar_PWCFRD,
     modelPar_given_PWCFRD,
     modelPar_PLWCFRD,
     modelPar_given_PLWCFRD,
     modelPar_POFNT,
     modelPar_given_POFNT,
     modelPar_POFNTEXC,
     modelPar_given_POFNTEXC,
     modelPar_PLFNTEXC,
     modelPar_given_PLFNTEXC,
     modelPar_PWFNTEXC,
     modelPar_given_PWFNTEXC,
     modelPar_PLWFNTEXC,
     modelPar_given_PLWFNTEXC,
     modelPar_PONFA,
     modelPar_given_PONFA,
     modelPar_PLNFA,
     modelPar_given_PLNFA,
     modelPar_PWNFA,
     modelPar_given_PWNFA,
     modelPar_PLWNFA,
     modelPar_given_PLWNFA,
     modelPar_PONFB,
     modelPar_given_PONFB,
     modelPar_PLNFB,
     modelPar_given_PLNFB,
     modelPar_PWNFB,
     modelPar_given_PWNFB,
     modelPar_PLWNFB,
     modelPar_given_PLWNFB,
     modelPar_PONFC,
     modelPar_given_PONFC,
     modelPar_PLNFC,
     modelPar_given_PLNFC,
     modelPar_PWNFC,
     modelPar_given_PWNFC,
     modelPar_PLWNFC,
     modelPar_given_PLWNFC,
     modelPar_POEF,
     modelPar_given_POEF,
     modelPar_POVFBEDGE,
     modelPar_given_POVFBEDGE,
     modelPar_POSTVFBEDGE,
     modelPar_given_POSTVFBEDGE,
     modelPar_PLSTVFBEDGE,
     modelPar_given_PLSTVFBEDGE,
     modelPar_PWSTVFBEDGE,
     modelPar_given_PWSTVFBEDGE,
     modelPar_PLWSTVFBEDGE,
     modelPar_given_PLWSTVFBEDGE,
     modelPar_PODPHIBEDGE,
     modelPar_given_PODPHIBEDGE,
     modelPar_PLDPHIBEDGE,
     modelPar_given_PLDPHIBEDGE,
     modelPar_PWDPHIBEDGE,
     modelPar_given_PWDPHIBEDGE,
     modelPar_PLWDPHIBEDGE,
     modelPar_given_PLWDPHIBEDGE,
     modelPar_PONEFFEDGE,
     modelPar_given_PONEFFEDGE,
     modelPar_PLNEFFEDGE,
     modelPar_given_PLNEFFEDGE,
     modelPar_PWNEFFEDGE,
     modelPar_given_PWNEFFEDGE,
     modelPar_PLWNEFFEDGE,
     modelPar_given_PLWNEFFEDGE,
     modelPar_POCTEDGE,
     modelPar_given_POCTEDGE,
     modelPar_PLCTEDGE,
     modelPar_given_PLCTEDGE,
     modelPar_PWCTEDGE,
     modelPar_given_PWCTEDGE,
     modelPar_PLWCTEDGE,
     modelPar_given_PLWCTEDGE,
     modelPar_POBETNEDGE,
     modelPar_given_POBETNEDGE,
     modelPar_PLBETNEDGE,
     modelPar_given_PLBETNEDGE,
     modelPar_PWBETNEDGE,
     modelPar_given_PWBETNEDGE,
     modelPar_PLWBETNEDGE,
     modelPar_given_PLWBETNEDGE,
     modelPar_POSTBETEDGE,
     modelPar_given_POSTBETEDGE,
     modelPar_PLSTBETEDGE,
     modelPar_given_PLSTBETEDGE,
     modelPar_PWSTBETEDGE,
     modelPar_given_PWSTBETEDGE,
     modelPar_PLWSTBETEDGE,
     modelPar_given_PLWSTBETEDGE,
     modelPar_POPSCEEDGE,
     modelPar_given_POPSCEEDGE,
     modelPar_PLPSCEEDGE,
     modelPar_given_PLPSCEEDGE,
     modelPar_PWPSCEEDGE,
     modelPar_given_PWPSCEEDGE,
     modelPar_PLWPSCEEDGE,
     modelPar_given_PLWPSCEEDGE,
     modelPar_POPSCEBEDGE,
     modelPar_given_POPSCEBEDGE,
     modelPar_POPSCEDEDGE,
     modelPar_given_POPSCEDEDGE,
     modelPar_POCFEDGE,
     modelPar_given_POCFEDGE,
     modelPar_PLCFEDGE,
     modelPar_given_PLCFEDGE,
     modelPar_PWCFEDGE,
     modelPar_given_PWCFEDGE,
     modelPar_PLWCFEDGE,
     modelPar_given_PLWCFEDGE,
     modelPar_POCFDEDGE,
     modelPar_given_POCFDEDGE,
     modelPar_POCFBEDGE,
     modelPar_given_POCFBEDGE,
     modelPar_POFNTEDGE,
     modelPar_given_POFNTEDGE,
     modelPar_PONFAEDGE,
     modelPar_given_PONFAEDGE,
     modelPar_PLNFAEDGE,
     modelPar_given_PLNFAEDGE,
     modelPar_PWNFAEDGE,
     modelPar_given_PWNFAEDGE,
     modelPar_PLWNFAEDGE,
     modelPar_given_PLWNFAEDGE,
     modelPar_PONFBEDGE,
     modelPar_given_PONFBEDGE,
     modelPar_PLNFBEDGE,
     modelPar_given_PLNFBEDGE,
     modelPar_PWNFBEDGE,
     modelPar_given_PWNFBEDGE,
     modelPar_PLWNFBEDGE,
     modelPar_given_PLWNFBEDGE,
     modelPar_PONFCEDGE,
     modelPar_given_PONFCEDGE,
     modelPar_PLNFCEDGE,
     modelPar_given_PLNFCEDGE,
     modelPar_PWNFCEDGE,
     modelPar_given_PWNFCEDGE,
     modelPar_PLWNFCEDGE,
     modelPar_given_PLWNFCEDGE,
     modelPar_POEFEDGE,
     modelPar_given_POEFEDGE,
     modelPar_POKVTHOWE,
     modelPar_given_POKVTHOWE,
     modelPar_PLKVTHOWE,
     modelPar_given_PLKVTHOWE,
     modelPar_PWKVTHOWE,
     modelPar_given_PWKVTHOWE,
     modelPar_PLWKVTHOWE,
     modelPar_given_PLWKVTHOWE,
     modelPar_POKUOWE,
     modelPar_given_POKUOWE,
     modelPar_PLKUOWE,
     modelPar_given_PLKUOWE,
     modelPar_PWKUOWE,
     modelPar_given_PWKUOWE,
     modelPar_PLWKUOWE,
     modelPar_given_PLWKUOWE,
     modelPar_LMIN,
     modelPar_given_LMIN,
     modelPar_LMAX,
     modelPar_given_LMAX,
     modelPar_WMIN,
     modelPar_given_WMIN,
     modelPar_WMAX,
     modelPar_given_WMAX,
     modelPar_LVARO,
     modelPar_given_LVARO,
     modelPar_LVARL,
     modelPar_given_LVARL,
     modelPar_LVARW,
     modelPar_given_LVARW,
     modelPar_LAP,
     modelPar_given_LAP,
     modelPar_WVARO,
     modelPar_given_WVARO,
     modelPar_WVARL,
     modelPar_given_WVARL,
     modelPar_WVARW,
     modelPar_given_WVARW,
     modelPar_WOT,
     modelPar_given_WOT,
     modelPar_DLQ,
     modelPar_given_DLQ,
     modelPar_DWQ,
     modelPar_given_DWQ,
     modelPar_VFBO,
     modelPar_given_VFBO,
     modelPar_VFBL,
     modelPar_given_VFBL,
     modelPar_VFBW,
     modelPar_given_VFBW,
     modelPar_VFBLW,
     modelPar_given_VFBLW,
     modelPar_STVFBO,
     modelPar_given_STVFBO,
     modelPar_STVFBL,
     modelPar_given_STVFBL,
     modelPar_STVFBW,
     modelPar_given_STVFBW,
     modelPar_STVFBLW,
     modelPar_given_STVFBLW,
     modelPar_TOXO,
     modelPar_given_TOXO,
     modelPar_EPSROXO,
     modelPar_given_EPSROXO,
     modelPar_NSUBO,
     modelPar_given_NSUBO,
     modelPar_NSUBW,
     modelPar_given_NSUBW,
     modelPar_WSEG,
     modelPar_given_WSEG,
     modelPar_NPCK,
     modelPar_given_NPCK,
     modelPar_NPCKW,
     modelPar_given_NPCKW,
     modelPar_WSEGP,
     modelPar_given_WSEGP,
     modelPar_LPCK,
     modelPar_given_LPCK,
     modelPar_LPCKW,
     modelPar_given_LPCKW,
     modelPar_FOL1,
     modelPar_given_FOL1,
     modelPar_FOL2,
     modelPar_given_FOL2,
     modelPar_FACNEFFACO,
     modelPar_given_FACNEFFACO,
     modelPar_FACNEFFACL,
     modelPar_given_FACNEFFACL,
     modelPar_FACNEFFACW,
     modelPar_given_FACNEFFACW,
     modelPar_FACNEFFACLW,
     modelPar_given_FACNEFFACLW,
     modelPar_GFACNUDO,
     modelPar_given_GFACNUDO,
     modelPar_GFACNUDL,
     modelPar_given_GFACNUDL,
     modelPar_GFACNUDLEXP,
     modelPar_given_GFACNUDLEXP,
     modelPar_GFACNUDW,
     modelPar_given_GFACNUDW,
     modelPar_GFACNUDLW,
     modelPar_given_GFACNUDLW,
     modelPar_VSBNUDO,
     modelPar_given_VSBNUDO,
     modelPar_DVSBNUDO,
     modelPar_given_DVSBNUDO,
     modelPar_VNSUBO,
     modelPar_given_VNSUBO,
     modelPar_NSLPO,
     modelPar_given_NSLPO,
     modelPar_DNSUBO,
     modelPar_given_DNSUBO,
     modelPar_DPHIBO,
     modelPar_given_DPHIBO,
     modelPar_DPHIBL,
     modelPar_given_DPHIBL,
     modelPar_DPHIBLEXP,
     modelPar_given_DPHIBLEXP,
     modelPar_DPHIBW,
     modelPar_given_DPHIBW,
     modelPar_DPHIBLW,
     modelPar_given_DPHIBLW,
     modelPar_DELVTACO,
     modelPar_given_DELVTACO,
     modelPar_DELVTACL,
     modelPar_given_DELVTACL,
     modelPar_DELVTACLEXP,
     modelPar_given_DELVTACLEXP,
     modelPar_DELVTACW,
     modelPar_given_DELVTACW,
     modelPar_DELVTACLW,
     modelPar_given_DELVTACLW,
     modelPar_NPO,
     modelPar_given_NPO,
     modelPar_NPL,
     modelPar_given_NPL,
     modelPar_CTO,
     modelPar_given_CTO,
     modelPar_CTL,
     modelPar_given_CTL,
     modelPar_CTLEXP,
     modelPar_given_CTLEXP,
     modelPar_CTW,
     modelPar_given_CTW,
     modelPar_CTLW,
     modelPar_given_CTLW,
     modelPar_TOXOVO,
     modelPar_given_TOXOVO,
     modelPar_TOXOVDO,
     modelPar_given_TOXOVDO,
     modelPar_LOV,
     modelPar_given_LOV,
     modelPar_LOVD,
     modelPar_given_LOVD,
     modelPar_NOVO,
     modelPar_given_NOVO,
     modelPar_NOVDO,
     modelPar_given_NOVDO,
     modelPar_CFL,
     modelPar_given_CFL,
     modelPar_CFLEXP,
     modelPar_given_CFLEXP,
     modelPar_CFW,
     modelPar_given_CFW,
     modelPar_CFDO,
     modelPar_given_CFDO,
     modelPar_CFBO,
     modelPar_given_CFBO,
     modelPar_PSCEL,
     modelPar_given_PSCEL,
     modelPar_PSCELEXP,
     modelPar_given_PSCELEXP,
     modelPar_PSCEW,
     modelPar_given_PSCEW,
     modelPar_PSCEBO,
     modelPar_given_PSCEBO,
     modelPar_PSCEDO,
     modelPar_given_PSCEDO,
     modelPar_UO,
     modelPar_given_UO,
     modelPar_FBET1,
     modelPar_given_FBET1,
     modelPar_FBET1W,
     modelPar_given_FBET1W,
     modelPar_LP1,
     modelPar_given_LP1,
     modelPar_LP1W,
     modelPar_given_LP1W,
     modelPar_FBET2,
     modelPar_given_FBET2,
     modelPar_LP2,
     modelPar_given_LP2,
     modelPar_BETW1,
     modelPar_given_BETW1,
     modelPar_BETW2,
     modelPar_given_BETW2,
     modelPar_WBET,
     modelPar_given_WBET,
     modelPar_STBETO,
     modelPar_given_STBETO,
     modelPar_STBETL,
     modelPar_given_STBETL,
     modelPar_STBETW,
     modelPar_given_STBETW,
     modelPar_STBETLW,
     modelPar_given_STBETLW,
     modelPar_MUEO,
     modelPar_given_MUEO,
     modelPar_MUEW,
     modelPar_given_MUEW,
     modelPar_STMUEO,
     modelPar_given_STMUEO,
     modelPar_THEMUO,
     modelPar_given_THEMUO,
     modelPar_STTHEMUO,
     modelPar_given_STTHEMUO,
     modelPar_CSO,
     modelPar_given_CSO,
     modelPar_CSL,
     modelPar_given_CSL,
     modelPar_CSLEXP,
     modelPar_given_CSLEXP,
     modelPar_CSW,
     modelPar_given_CSW,
     modelPar_CSLW,
     modelPar_given_CSLW,
     modelPar_STCSO,
     modelPar_given_STCSO,
     modelPar_XCORO,
     modelPar_given_XCORO,
     modelPar_XCORL,
     modelPar_given_XCORL,
     modelPar_XCORW,
     modelPar_given_XCORW,
     modelPar_XCORLW,
     modelPar_given_XCORLW,
     modelPar_STXCORO,
     modelPar_given_STXCORO,
     modelPar_FETAO,
     modelPar_given_FETAO,
     modelPar_RSW1,
     modelPar_given_RSW1,
     modelPar_RSW2,
     modelPar_given_RSW2,
     modelPar_STRSO,
     modelPar_given_STRSO,
     modelPar_RSBO,
     modelPar_given_RSBO,
     modelPar_RSGO,
     modelPar_given_RSGO,
     modelPar_THESATO,
     modelPar_given_THESATO,
     modelPar_THESATL,
     modelPar_given_THESATL,
     modelPar_THESATLEXP,
     modelPar_given_THESATLEXP,
     modelPar_THESATW,
     modelPar_given_THESATW,
     modelPar_THESATLW,
     modelPar_given_THESATLW,
     modelPar_STTHESATO,
     modelPar_given_STTHESATO,
     modelPar_STTHESATL,
     modelPar_given_STTHESATL,
     modelPar_STTHESATW,
     modelPar_given_STTHESATW,
     modelPar_STTHESATLW,
     modelPar_given_STTHESATLW,
     modelPar_THESATBO,
     modelPar_given_THESATBO,
     modelPar_THESATGO,
     modelPar_given_THESATGO,
     modelPar_AXO,
     modelPar_given_AXO,
     modelPar_AXL,
     modelPar_given_AXL,
     modelPar_ALPL,
     modelPar_given_ALPL,
     modelPar_ALPLEXP,
     modelPar_given_ALPLEXP,
     modelPar_ALPW,
     modelPar_given_ALPW,
     modelPar_ALP1L1,
     modelPar_given_ALP1L1,
     modelPar_ALP1LEXP,
     modelPar_given_ALP1LEXP,
     modelPar_ALP1L2,
     modelPar_given_ALP1L2,
     modelPar_ALP1W,
     modelPar_given_ALP1W,
     modelPar_ALP2L1,
     modelPar_given_ALP2L1,
     modelPar_ALP2LEXP,
     modelPar_given_ALP2LEXP,
     modelPar_ALP2L2,
     modelPar_given_ALP2L2,
     modelPar_ALP2W,
     modelPar_given_ALP2W,
     modelPar_VPO,
     modelPar_given_VPO,
     modelPar_A1O,
     modelPar_given_A1O,
     modelPar_A1L,
     modelPar_given_A1L,
     modelPar_A1W,
     modelPar_given_A1W,
     modelPar_A2O,
     modelPar_given_A2O,
     modelPar_STA2O,
     modelPar_given_STA2O,
     modelPar_A3O,
     modelPar_given_A3O,
     modelPar_A3L,
     modelPar_given_A3L,
     modelPar_A3W,
     modelPar_given_A3W,
     modelPar_A4O,
     modelPar_given_A4O,
     modelPar_A4L,
     modelPar_given_A4L,
     modelPar_A4W,
     modelPar_given_A4W,
     modelPar_GCOO,
     modelPar_given_GCOO,
     modelPar_IGINVLW,
     modelPar_given_IGINVLW,
     modelPar_IGOVW,
     modelPar_given_IGOVW,
     modelPar_IGOVDW,
     modelPar_given_IGOVDW,
     modelPar_STIGO,
     modelPar_given_STIGO,
     modelPar_GC2O,
     modelPar_given_GC2O,
     modelPar_GC3O,
     modelPar_given_GC3O,
     modelPar_CHIBO,
     modelPar_given_CHIBO,
     modelPar_AGIDLW,
     modelPar_given_AGIDLW,
     modelPar_AGIDLDW,
     modelPar_given_AGIDLDW,
     modelPar_BGIDLO,
     modelPar_given_BGIDLO,
     modelPar_BGIDLDO,
     modelPar_given_BGIDLDO,
     modelPar_STBGIDLO,
     modelPar_given_STBGIDLO,
     modelPar_STBGIDLDO,
     modelPar_given_STBGIDLDO,
     modelPar_CGIDLO,
     modelPar_given_CGIDLO,
     modelPar_CGIDLDO,
     modelPar_given_CGIDLDO,
     modelPar_CGBOVL,
     modelPar_given_CGBOVL,
     modelPar_CFRW,
     modelPar_given_CFRW,
     modelPar_CFRDW,
     modelPar_given_CFRDW,
     modelPar_FNTO,
     modelPar_given_FNTO,
     modelPar_FNTEXCL,
     modelPar_given_FNTEXCL,
     modelPar_NFALW,
     modelPar_given_NFALW,
     modelPar_NFBLW,
     modelPar_given_NFBLW,
     modelPar_NFCLW,
     modelPar_given_NFCLW,
     modelPar_EFO,
     modelPar_given_EFO,
     modelPar_LINTNOI,
     modelPar_given_LINTNOI,
     modelPar_ALPNOI,
     modelPar_given_ALPNOI,
     modelPar_WEDGE,
     modelPar_given_WEDGE,
     modelPar_WEDGEW,
     modelPar_given_WEDGEW,
     modelPar_VFBEDGEO,
     modelPar_given_VFBEDGEO,
     modelPar_STVFBEDGEO,
     modelPar_given_STVFBEDGEO,
     modelPar_STVFBEDGEL,
     modelPar_given_STVFBEDGEL,
     modelPar_STVFBEDGEW,
     modelPar_given_STVFBEDGEW,
     modelPar_STVFBEDGELW,
     modelPar_given_STVFBEDGELW,
     modelPar_DPHIBEDGEO,
     modelPar_given_DPHIBEDGEO,
     modelPar_DPHIBEDGEL,
     modelPar_given_DPHIBEDGEL,
     modelPar_DPHIBEDGELEXP,
     modelPar_given_DPHIBEDGELEXP,
     modelPar_DPHIBEDGEW,
     modelPar_given_DPHIBEDGEW,
     modelPar_DPHIBEDGELW,
     modelPar_given_DPHIBEDGELW,
     modelPar_NSUBEDGEO,
     modelPar_given_NSUBEDGEO,
     modelPar_NSUBEDGEL,
     modelPar_given_NSUBEDGEL,
     modelPar_NSUBEDGEW,
     modelPar_given_NSUBEDGEW,
     modelPar_NSUBEDGELW,
     modelPar_given_NSUBEDGELW,
     modelPar_CTEDGEO,
     modelPar_given_CTEDGEO,
     modelPar_CTEDGEL,
     modelPar_given_CTEDGEL,
     modelPar_CTEDGELEXP,
     modelPar_given_CTEDGELEXP,
     modelPar_FBETEDGE,
     modelPar_given_FBETEDGE,
     modelPar_LPEDGE,
     modelPar_given_LPEDGE,
     modelPar_BETEDGEW,
     modelPar_given_BETEDGEW,
     modelPar_STBETEDGEO,
     modelPar_given_STBETEDGEO,
     modelPar_STBETEDGEL,
     modelPar_given_STBETEDGEL,
     modelPar_STBETEDGEW,
     modelPar_given_STBETEDGEW,
     modelPar_STBETEDGELW,
     modelPar_given_STBETEDGELW,
     modelPar_PSCEEDGEL,
     modelPar_given_PSCEEDGEL,
     modelPar_PSCEEDGELEXP,
     modelPar_given_PSCEEDGELEXP,
     modelPar_PSCEEDGEW,
     modelPar_given_PSCEEDGEW,
     modelPar_PSCEBEDGEO,
     modelPar_given_PSCEBEDGEO,
     modelPar_PSCEDEDGEO,
     modelPar_given_PSCEDEDGEO,
     modelPar_CFEDGEL,
     modelPar_given_CFEDGEL,
     modelPar_CFEDGELEXP,
     modelPar_given_CFEDGELEXP,
     modelPar_CFEDGEW,
     modelPar_given_CFEDGEW,
     modelPar_CFDEDGEO,
     modelPar_given_CFDEDGEO,
     modelPar_CFBEDGEO,
     modelPar_given_CFBEDGEO,
     modelPar_FNTEDGEO,
     modelPar_given_FNTEDGEO,
     modelPar_NFAEDGELW,
     modelPar_given_NFAEDGELW,
     modelPar_NFBEDGELW,
     modelPar_given_NFBEDGELW,
     modelPar_NFCEDGELW,
     modelPar_given_NFCEDGELW,
     modelPar_EFEDGEO,
     modelPar_given_EFEDGEO,
     modelPar_KVTHOWEO,
     modelPar_given_KVTHOWEO,
     modelPar_KVTHOWEL,
     modelPar_given_KVTHOWEL,
     modelPar_KVTHOWEW,
     modelPar_given_KVTHOWEW,
     modelPar_KVTHOWELW,
     modelPar_given_KVTHOWELW,
     modelPar_KUOWEO,
     modelPar_given_KUOWEO,
     modelPar_KUOWEL,
     modelPar_given_KUOWEL,
     modelPar_KUOWEW,
     modelPar_given_KUOWEW,
     modelPar_KUOWELW,
     modelPar_given_KUOWELW,
     modelPar_RGO,
     modelPar_given_RGO,
     modelPar_RINT,
     modelPar_given_RINT,
     modelPar_RVPOLY,
     modelPar_given_RVPOLY,
     modelPar_RSHG,
     modelPar_given_RSHG,
     modelPar_DLSIL,
     modelPar_given_DLSIL,
     modelPar_RSH,
     modelPar_given_RSH,
     modelPar_RSHD,
     modelPar_given_RSHD,
     modelPar_RBULKO,
     modelPar_given_RBULKO,
     modelPar_RWELLO,
     modelPar_given_RWELLO,
     modelPar_RJUNSO,
     modelPar_given_RJUNSO,
     modelPar_RJUNDO,
     modelPar_given_RJUNDO,
     modelPar_SAREF,
     modelPar_given_SAREF,
     modelPar_SBREF,
     modelPar_given_SBREF,
     modelPar_WLOD,
     modelPar_given_WLOD,
     modelPar_KUO,
     modelPar_given_KUO,
     modelPar_KVSAT,
     modelPar_given_KVSAT,
     modelPar_TKUO,
     modelPar_given_TKUO,
     modelPar_LKUO,
     modelPar_given_LKUO,
     modelPar_WKUO,
     modelPar_given_WKUO,
     modelPar_PKUO,
     modelPar_given_PKUO,
     modelPar_LLODKUO,
     modelPar_given_LLODKUO,
     modelPar_WLODKUO,
     modelPar_given_WLODKUO,
     modelPar_KVTHO,
     modelPar_given_KVTHO,
     modelPar_LKVTHO,
     modelPar_given_LKVTHO,
     modelPar_WKVTHO,
     modelPar_given_WKVTHO,
     modelPar_PKVTHO,
     modelPar_given_PKVTHO,
     modelPar_LLODVTH,
     modelPar_given_LLODVTH,
     modelPar_WLODVTH,
     modelPar_given_WLODVTH,
     modelPar_STETAO,
     modelPar_given_STETAO,
     modelPar_LODETAO,
     modelPar_given_LODETAO,
     modelPar_SCREF,
     modelPar_given_SCREF,
     modelPar_WEB,
     modelPar_given_WEB,
     modelPar_WEC,
     modelPar_given_WEC,
     modelPar_IMAX,
     modelPar_given_IMAX,
     modelPar_TRJ,
     modelPar_given_TRJ,
     modelPar_FREV,
     modelPar_given_FREV,
     modelPar_CJORBOT,
     modelPar_given_CJORBOT,
     modelPar_CJORSTI,
     modelPar_given_CJORSTI,
     modelPar_CJORGAT,
     modelPar_given_CJORGAT,
     modelPar_VBIRBOT,
     modelPar_given_VBIRBOT,
     modelPar_VBIRSTI,
     modelPar_given_VBIRSTI,
     modelPar_VBIRGAT,
     modelPar_given_VBIRGAT,
     modelPar_PBOT,
     modelPar_given_PBOT,
     modelPar_PSTI,
     modelPar_given_PSTI,
     modelPar_PGAT,
     modelPar_given_PGAT,
     modelPar_PHIGBOT,
     modelPar_given_PHIGBOT,
     modelPar_PHIGSTI,
     modelPar_given_PHIGSTI,
     modelPar_PHIGGAT,
     modelPar_given_PHIGGAT,
     modelPar_IDSATRBOT,
     modelPar_given_IDSATRBOT,
     modelPar_IDSATRSTI,
     modelPar_given_IDSATRSTI,
     modelPar_IDSATRGAT,
     modelPar_given_IDSATRGAT,
     modelPar_CSRHBOT,
     modelPar_given_CSRHBOT,
     modelPar_CSRHSTI,
     modelPar_given_CSRHSTI,
     modelPar_CSRHGAT,
     modelPar_given_CSRHGAT,
     modelPar_XJUNSTI,
     modelPar_given_XJUNSTI,
     modelPar_XJUNGAT,
     modelPar_given_XJUNGAT,
     modelPar_CTATBOT,
     modelPar_given_CTATBOT,
     modelPar_CTATSTI,
     modelPar_given_CTATSTI,
     modelPar_CTATGAT,
     modelPar_given_CTATGAT,
     modelPar_MEFFTATBOT,
     modelPar_given_MEFFTATBOT,
     modelPar_MEFFTATSTI,
     modelPar_given_MEFFTATSTI,
     modelPar_MEFFTATGAT,
     modelPar_given_MEFFTATGAT,
     modelPar_CBBTBOT,
     modelPar_given_CBBTBOT,
     modelPar_CBBTSTI,
     modelPar_given_CBBTSTI,
     modelPar_CBBTGAT,
     modelPar_given_CBBTGAT,
     modelPar_FBBTRBOT,
     modelPar_given_FBBTRBOT,
     modelPar_FBBTRSTI,
     modelPar_given_FBBTRSTI,
     modelPar_FBBTRGAT,
     modelPar_given_FBBTRGAT,
     modelPar_STFBBTBOT,
     modelPar_given_STFBBTBOT,
     modelPar_STFBBTSTI,
     modelPar_given_STFBBTSTI,
     modelPar_STFBBTGAT,
     modelPar_given_STFBBTGAT,
     modelPar_VBRBOT,
     modelPar_given_VBRBOT,
     modelPar_VBRSTI,
     modelPar_given_VBRSTI,
     modelPar_VBRGAT,
     modelPar_given_VBRGAT,
     modelPar_PBRBOT,
     modelPar_given_PBRBOT,
     modelPar_PBRSTI,
     modelPar_given_PBRSTI,
     modelPar_PBRGAT,
     modelPar_given_PBRGAT,
     modelPar_CJORBOTD,
     modelPar_given_CJORBOTD,
     modelPar_CJORSTID,
     modelPar_given_CJORSTID,
     modelPar_CJORGATD,
     modelPar_given_CJORGATD,
     modelPar_VBIRBOTD,
     modelPar_given_VBIRBOTD,
     modelPar_VBIRSTID,
     modelPar_given_VBIRSTID,
     modelPar_VBIRGATD,
     modelPar_given_VBIRGATD,
     modelPar_PBOTD,
     modelPar_given_PBOTD,
     modelPar_PSTID,
     modelPar_given_PSTID,
     modelPar_PGATD,
     modelPar_given_PGATD,
     modelPar_PHIGBOTD,
     modelPar_given_PHIGBOTD,
     modelPar_PHIGSTID,
     modelPar_given_PHIGSTID,
     modelPar_PHIGGATD,
     modelPar_given_PHIGGATD,
     modelPar_IDSATRBOTD,
     modelPar_given_IDSATRBOTD,
     modelPar_IDSATRSTID,
     modelPar_given_IDSATRSTID,
     modelPar_IDSATRGATD,
     modelPar_given_IDSATRGATD,
     modelPar_CSRHBOTD,
     modelPar_given_CSRHBOTD,
     modelPar_CSRHSTID,
     modelPar_given_CSRHSTID,
     modelPar_CSRHGATD,
     modelPar_given_CSRHGATD,
     modelPar_XJUNSTID,
     modelPar_given_XJUNSTID,
     modelPar_XJUNGATD,
     modelPar_given_XJUNGATD,
     modelPar_CTATBOTD,
     modelPar_given_CTATBOTD,
     modelPar_CTATSTID,
     modelPar_given_CTATSTID,
     modelPar_CTATGATD,
     modelPar_given_CTATGATD,
     modelPar_MEFFTATBOTD,
     modelPar_given_MEFFTATBOTD,
     modelPar_MEFFTATSTID,
     modelPar_given_MEFFTATSTID,
     modelPar_MEFFTATGATD,
     modelPar_given_MEFFTATGATD,
     modelPar_CBBTBOTD,
     modelPar_given_CBBTBOTD,
     modelPar_CBBTSTID,
     modelPar_given_CBBTSTID,
     modelPar_CBBTGATD,
     modelPar_given_CBBTGATD,
     modelPar_FBBTRBOTD,
     modelPar_given_FBBTRBOTD,
     modelPar_FBBTRSTID,
     modelPar_given_FBBTRSTID,
     modelPar_FBBTRGATD,
     modelPar_given_FBBTRGATD,
     modelPar_STFBBTBOTD,
     modelPar_given_STFBBTBOTD,
     modelPar_STFBBTSTID,
     modelPar_given_STFBBTSTID,
     modelPar_STFBBTGATD,
     modelPar_given_STFBBTGATD,
     modelPar_VBRBOTD,
     modelPar_given_VBRBOTD,
     modelPar_VBRSTID,
     modelPar_given_VBRSTID,
     modelPar_VBRGATD,
     modelPar_given_VBRGATD,
     modelPar_PBRBOTD,
     modelPar_given_PBRBOTD,
     modelPar_PBRSTID,
     modelPar_given_PBRSTID,
     modelPar_PBRGATD,
     modelPar_given_PBRGATD,
     modelPar_SWJUNEXP,
     modelPar_given_SWJUNEXP,
     modelPar_VJUNREF,
     modelPar_given_VJUNREF,
     modelPar_FJUNQ,
     modelPar_given_FJUNQ,
     modelPar_VJUNREFD,
     modelPar_given_VJUNREFD,
     modelPar_FJUNQD,
     modelPar_given_FJUNQD,
     modelPar_DTA,
     modelPar_given_DTA,
     // non-reals (including hidden)
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_TYPE,
     modelPar_given_TYPE,
     modelPar_SWGEO,
     modelPar_given_SWGEO,
     modelPar_SWIGATE,
     modelPar_given_SWIGATE,
     modelPar_SWIMPACT,
     modelPar_given_SWIMPACT,
     modelPar_SWGIDL,
     modelPar_given_SWGIDL,
     modelPar_SWJUNCAP,
     modelPar_given_SWJUNCAP,
     modelPar_SWJUNASYM,
     modelPar_given_SWJUNASYM,
     modelPar_SWNUD,
     modelPar_given_SWNUD,
     modelPar_SWEDGE,
     modelPar_given_SWEDGE,
     modelPar_SWDELVTAC,
     modelPar_given_SWDELVTAC,
     modelPar_SWIGN,
     modelPar_given_SWIGN// model variables
     ,
     // reals
     modelVar_TOXO_i,
     modelVar_EPSROXO_i,
     modelVar_NSUBO_i,
     modelVar_WSEG_i,
     modelVar_NPCK_i,
     modelVar_WSEGP_i,
     modelVar_LPCK_i,
     modelVar_TOXOVO_i,
     modelVar_TOXOVDO_i,
     modelVar_LOV_i,
     modelVar_LOVD_i,
     modelVar_LP1_i,
     modelVar_LP2_i,
     modelVar_WBET_i,
     modelVar_AXL_i,
     modelVar_ALP1L2_i,
     modelVar_ALP2L2_i,
     modelVar_SAREF_i,
     modelVar_SBREF_i,
     modelVar_KVSAT_i,
     modelVar_LLODKUO_i,
     modelVar_WLODKUO_i,
     modelVar_LLODVTH_i,
     modelVar_WLODVTH_i,
     modelVar_LODETAO_i,
     modelVar_SCREF_i,
     modelVar_WEB_i,
     modelVar_WEC_i,
     modelVar_RSHG_i,
     modelVar_RSH_i,
     modelVar_RSHD_i,
     modelVar_RINT_i,
     modelVar_RVPOLY_i,
     modelVar_NSUBEDGEO_i,
     modelVar_LPEDGE_i,
     modelVar_QMC_i,
     modelVar_rTa,
     modelVar_delTa,
     modelVar_phita,
     modelVar_inv_phita,
     modelVar_TKD,
     modelVar_delT,
     modelVar_rTn,
     modelVar_ln_rTn,
     modelVar_inv_phit,
     modelVar_Eg,
     modelVar_phibFac,
     modelVar_IMAX_i,
     modelVar_VBIRBOT_i,
     modelVar_VBIRSTI_i,
     modelVar_VBIRGAT_i,
     modelVar_PBOT_i,
     modelVar_PSTI_i,
     modelVar_PGAT_i,
     modelVar_CSRHBOT_i,
     modelVar_CSRHSTI_i,
     modelVar_CSRHGAT_i,
     modelVar_CTATBOT_i,
     modelVar_CTATSTI_i,
     modelVar_CTATGAT_i,
     modelVar_CBBTBOT_i,
     modelVar_CBBTSTI_i,
     modelVar_CBBTGAT_i,
     modelVar_VBRBOT_i,
     modelVar_VBRSTI_i,
     modelVar_VBRGAT_i,
     modelVar_PBRBOT_i,
     modelVar_PBRSTI_i,
     modelVar_PBRGAT_i,
     modelVar_SWJUNEXP_i,
     modelVar_VJUNREF_i,
     modelVar_FJUNQ_i,
     modelVar_phitr,
     modelVar_phitd,
     modelVar_phitdinv,
     modelVar_perfc,
     modelVar_berfc,
     modelVar_cerfc,
     modelVar_ftdbot,
     modelVar_ftdsti,
     modelVar_ftdgat,
     modelVar_idsatbot,
     modelVar_idsatsti,
     modelVar_idsatgat,
     modelVar_vbibot,
     modelVar_vbisti,
     modelVar_vbigat,
     modelVar_vbiinvbot,
     modelVar_vbiinvsti,
     modelVar_vbiinvgat,
     modelVar_one_minus_PBOT,
     modelVar_one_minus_PSTI,
     modelVar_one_minus_PGAT,
     modelVar_one_over_one_minus_PBOT,
     modelVar_one_over_one_minus_PSTI,
     modelVar_one_over_one_minus_PGAT,
     modelVar_cjobot,
     modelVar_cjosti,
     modelVar_cjogat,
     modelVar_qprefbot,
     modelVar_qprefsti,
     modelVar_qprefgat,
     modelVar_qpref2bot,
     modelVar_qpref2sti,
     modelVar_qpref2gat,
     modelVar_wdepnulrbot,
     modelVar_wdepnulrsti,
     modelVar_wdepnulrgat,
     modelVar_wdepnulrinvbot,
     modelVar_wdepnulrinvsti,
     modelVar_wdepnulrinvgat,
     modelVar_VBIRBOTinv,
     modelVar_VBIRSTIinv,
     modelVar_VBIRGATinv,
     modelVar_atatbot,
     modelVar_atatsti,
     modelVar_atatgat,
     modelVar_btatpartbot,
     modelVar_btatpartsti,
     modelVar_btatpartgat,
     modelVar_fbbtbot,
     modelVar_fbbtsti,
     modelVar_fbbtgat,
     modelVar_alphaav,
     modelVar_fstopbot,
     modelVar_fstopsti,
     modelVar_fstopgat,
     modelVar_VBRinvbot,
     modelVar_VBRinvsti,
     modelVar_VBRinvgat,
     modelVar_slopebot,
     modelVar_slopesti,
     modelVar_slopegat,
     modelVar_VBIRBOTD_i,
     modelVar_VBIRSTID_i,
     modelVar_VBIRGATD_i,
     modelVar_PBOTD_i,
     modelVar_PSTID_i,
     modelVar_PGATD_i,
     modelVar_CSRHBOTD_i,
     modelVar_CSRHSTID_i,
     modelVar_CSRHGATD_i,
     modelVar_CTATBOTD_i,
     modelVar_CTATSTID_i,
     modelVar_CTATGATD_i,
     modelVar_CBBTBOTD_i,
     modelVar_CBBTSTID_i,
     modelVar_CBBTGATD_i,
     modelVar_VBRBOTD_i,
     modelVar_VBRSTID_i,
     modelVar_VBRGATD_i,
     modelVar_PBRBOTD_i,
     modelVar_PBRSTID_i,
     modelVar_PBRGATD_i,
     modelVar_VJUNREFD_i,
     modelVar_FJUNQD_i,
     modelVar_ftdbot_d,
     modelVar_ftdsti_d,
     modelVar_ftdgat_d,
     modelVar_idsatbot_d,
     modelVar_idsatsti_d,
     modelVar_idsatgat_d,
     modelVar_vbibot_d,
     modelVar_vbisti_d,
     modelVar_vbigat_d,
     modelVar_vbiinvbot_d,
     modelVar_vbiinvsti_d,
     modelVar_vbiinvgat_d,
     modelVar_one_minus_PBOT_d,
     modelVar_one_minus_PSTI_d,
     modelVar_one_minus_PGAT_d,
     modelVar_one_over_one_minus_PBOT_d,
     modelVar_one_over_one_minus_PSTI_d,
     modelVar_one_over_one_minus_PGAT_d,
     modelVar_cjobot_d,
     modelVar_cjosti_d,
     modelVar_cjogat_d,
     modelVar_qprefbot_d,
     modelVar_qprefsti_d,
     modelVar_qprefgat_d,
     modelVar_qpref2bot_d,
     modelVar_qpref2sti_d,
     modelVar_qpref2gat_d,
     modelVar_wdepnulrbot_d,
     modelVar_wdepnulrsti_d,
     modelVar_wdepnulrgat_d,
     modelVar_wdepnulrinvbot_d,
     modelVar_wdepnulrinvsti_d,
     modelVar_wdepnulrinvgat_d,
     modelVar_VBIRBOTinv_d,
     modelVar_VBIRSTIinv_d,
     modelVar_VBIRGATinv_d,
     modelVar_atatbot_d,
     modelVar_atatsti_d,
     modelVar_atatgat_d,
     modelVar_btatpartbot_d,
     modelVar_btatpartsti_d,
     modelVar_btatpartgat_d,
     modelVar_fbbtbot_d,
     modelVar_fbbtsti_d,
     modelVar_fbbtgat_d,
     modelVar_fstopbot_d,
     modelVar_fstopsti_d,
     modelVar_fstopgat_d,
     modelVar_VBRinvbot_d,
     modelVar_VBRinvsti_d,
     modelVar_VBRinvgat_d,
     modelVar_slopebot_d,
     modelVar_slopesti_d,
     modelVar_slopegat_d,
     modelVar_phit,
     modelVar_nt0,
     modelVar_EPSSI,
     // non-reals
     modelVar_CHNL_TYPE,
     modelVar_SWGEO_i,
     modelVar_SWIGATE_i,
     modelVar_SWIMPACT_i,
     modelVar_SWGIDL_i,
     modelVar_SWJUNCAP_i,
     modelVar_SWJUNASYM_i,
     modelVar_SWNUD_i,
     modelVar_SWEDGE_i,
     modelVar_SWDELVTAC_i,
     modelVar_SWIGN_i,
     in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_NOI_GND,
     in.admsProbeID_V_NOI2_GND,
     in.admsProbeID_V_B_BI,
     in.admsProbeID_V_BD_BI,
     in.admsProbeID_V_BS_BI,
     in.admsProbeID_V_BP_BI,
     in.admsProbeID_V_D_DI,
     in.admsProbeID_V_S_SI,
     in.admsProbeID_V_G_GP,
     in.admsProbeID_V_DI_BD,
     in.admsProbeID_V_SI_BS,
     in.admsProbeID_V_SI_BP,
     in.admsProbeID_V_DI_SI,
     in.admsProbeID_V_GP_SI,

     // node constants
     in.admsNodeID_D,
     in.admsNodeID_G,
     in.admsNodeID_S,
     in.admsNodeID_B,
     in.admsNodeID_NOI,
     in.admsNodeID_NOI2,
     in.admsNodeID_GP,
     in.admsNodeID_SI,
     in.admsNodeID_DI,
     in.admsNodeID_BP,
     in.admsNodeID_BI,
     in.admsNodeID_BS,
     in.admsNodeID_BD,
     // instance parameters
     // reals
     instancePar_L,
     instancePar_given_L,
     instancePar_W,
     instancePar_given_W,
     instancePar_SA,
     instancePar_given_SA,
     instancePar_SB,
     instancePar_given_SB,
     instancePar_SD,
     instancePar_given_SD,
     instancePar_SCA,
     instancePar_given_SCA,
     instancePar_SCB,
     instancePar_given_SCB,
     instancePar_SCC,
     instancePar_given_SCC,
     instancePar_SC,
     instancePar_given_SC,
     instancePar_NF,
     instancePar_given_NF,
     instancePar_NGCON,
     instancePar_given_NGCON,
     instancePar_XGW,
     instancePar_given_XGW,
     instancePar_NRS,
     instancePar_given_NRS,
     instancePar_NRD,
     instancePar_given_NRD,
     instancePar_JW,
     instancePar_given_JW,
     instancePar_DELVTO,
     instancePar_given_DELVTO,
     instancePar_FACTUO,
     instancePar_given_FACTUO,
     instancePar_DELVTOEDGE,
     instancePar_given_DELVTOEDGE,
     instancePar_FACTUOEDGE,
     instancePar_given_FACTUOEDGE,
     instancePar_ABSOURCE,
     instancePar_given_ABSOURCE,
     instancePar_LSSOURCE,
     instancePar_given_LSSOURCE,
     instancePar_LGSOURCE,
     instancePar_given_LGSOURCE,
     instancePar_ABDRAIN,
     instancePar_given_ABDRAIN,
     instancePar_LSDRAIN,
     instancePar_given_LSDRAIN,
     instancePar_LGDRAIN,
     instancePar_given_LGDRAIN,
     instancePar_AS,
     instancePar_given_AS,
     instancePar_PS,
     instancePar_given_PS,
     instancePar_AD,
     instancePar_given_AD,
     instancePar_PD,
     instancePar_given_PD,
     instancePar_MULT,
     instancePar_given_MULT,
     // instance variables
     // reals
     instanceVar_MULT_i,
     instanceVar_GFACNUD_i,
     instanceVar_VNSUB_i,
     instanceVar_NSLP_i,
     instanceVar_DNSUB_i,
     instanceVar_CF_i,
     instanceVar_CFD_i,
     instanceVar_CFB_i,
     instanceVar_PSCE_i,
     instanceVar_PSCEB_i,
     instanceVar_PSCED_i,
     instanceVar_RSB_i,
     instanceVar_RSG_i,
     instanceVar_THESATB_i,
     instanceVar_THESATG_i,
     instanceVar_AX_i,
     instanceVar_ALP_i,
     instanceVar_ALP1_i,
     instanceVar_ALP2_i,
     instanceVar_A1_i,
     instanceVar_A3_i,
     instanceVar_A4_i,
     instanceVar_GCO_i,
     instanceVar_IGINV_i,
     instanceVar_IGOV_i,
     instanceVar_IGOVD_i,
     instanceVar_GC2_i,
     instanceVar_GC3_i,
     instanceVar_CHIB_i,
     instanceVar_AGIDL_i,
     instanceVar_AGIDLD_i,
     instanceVar_CGIDL_i,
     instanceVar_CGIDLD_i,
     instanceVar_COX_i,
     instanceVar_CGOV_i,
     instanceVar_CGOVD_i,
     instanceVar_CGBOV_i,
     instanceVar_CFR_i,
     instanceVar_CFRD_i,
     instanceVar_FNTEXC_i,
     instanceVar_NFA_i,
     instanceVar_NFB_i,
     instanceVar_NFC_i,
     instanceVar_EF_i,
     instanceVar_BETNEDGE_i,
     instanceVar_PSCEEDGE_i,
     instanceVar_PSCEBEDGE_i,
     instanceVar_PSCEDEDGE_i,
     instanceVar_CFEDGE_i,
     instanceVar_CFDEDGE_i,
     instanceVar_CFBEDGE_i,
     instanceVar_NFAEDGE_i,
     instanceVar_NFBEDGE_i,
     instanceVar_NFCEDGE_i,
     instanceVar_EFEDGE_i,
     instanceVar_RG_i,
     instanceVar_RSE_i,
     instanceVar_RDE_i,
     instanceVar_RBULK_i,
     instanceVar_RJUNS_i,
     instanceVar_RJUND_i,
     instanceVar_RWELL_i,
     instanceVar_ABSOURCE_i,
     instanceVar_LSSOURCE_i,
     instanceVar_LGSOURCE_i,
     instanceVar_zflagbot_s,
     instanceVar_zflagsti_s,
     instanceVar_zflaggat_s,
     instanceVar_VMAX_s,
     instanceVar_exp_VMAX_over_phitd_s,
     instanceVar_vbimin_s,
     instanceVar_vch_s,
     instanceVar_vfmin_s,
     instanceVar_vbbtlim_s,
     instanceVar_xhighf1_s,
     instanceVar_expxhf1_s,
     instanceVar_xhighf2_s,
     instanceVar_expxhf2_s,
     instanceVar_xhighr_s,
     instanceVar_expxhr_s,
     instanceVar_m0flag_s,
     instanceVar_ISATFOR1_s,
     instanceVar_MFOR1_s,
     instanceVar_ISATFOR2_s,
     instanceVar_MFOR2_s,
     instanceVar_ISATREV_s,
     instanceVar_MREV_s,
     instanceVar_ABDRAIN_i,
     instanceVar_LSDRAIN_i,
     instanceVar_LGDRAIN_i,
     instanceVar_zflagbot_d,
     instanceVar_zflagsti_d,
     instanceVar_zflaggat_d,
     instanceVar_VMAX_d,
     instanceVar_exp_VMAX_over_phitd_d,
     instanceVar_vbimin_d,
     instanceVar_vch_d,
     instanceVar_vfmin_d,
     instanceVar_vbbtlim_d,
     instanceVar_xhighf1_d,
     instanceVar_expxhf1_d,
     instanceVar_xhighf2_d,
     instanceVar_expxhf2_d,
     instanceVar_xhighr_d,
     instanceVar_expxhr_d,
     instanceVar_m0flag_d,
     instanceVar_ISATFOR1_d,
     instanceVar_MFOR1_d,
     instanceVar_ISATFOR2_d,
     instanceVar_MFOR2_d,
     instanceVar_ISATREV_d,
     instanceVar_MREV_d,
     instanceVar_VFB_T,
     instanceVar_MUE_T,
     instanceVar_THEMU_T,
     instanceVar_CS_T,
     instanceVar_XCOR_T,
     instanceVar_A2_T,
     instanceVar_VFBEDGE_T,
     instanceVar_phit0,
     instanceVar_BET_i,
     instanceVar_BETEDGE_i,
     instanceVar_nt,
     instanceVar_THESAT_T,
     instanceVar_Sfl_prefac,
     instanceVar_phit0edge,
     instanceVar_Gfedge2,
     instanceVar_lnGfedge2,
     instanceVar_Sfl_prefac_edge,
     instanceVar_ntedge,
     instanceVar_phib_dc,
     instanceVar_G_0_dc,
     instanceVar_kp,
     instanceVar_qlim2,
     instanceVar_sqrt_phib_dc,
     instanceVar_phix_dc,
     instanceVar_aphi_dc,
     instanceVar_bphi_dc,
     instanceVar_phix1_dc,
     instanceVar_alpha_b,
     instanceVar_us1,
     instanceVar_us21,
     instanceVar_phib_ac,
     instanceVar_G_0_ac,
     instanceVar_phix_ac,
     instanceVar_aphi_ac,
     instanceVar_bphi_ac,
     instanceVar_phix1_ac,
     instanceVar_THER_i,
     instanceVar_phibedge,
     instanceVar_Gfedge,
     instanceVar_phixedge,
     instanceVar_aphiedge,
     instanceVar_bphiedge,
     instanceVar_phix1edge,
     instanceVar_Cox_over_q,
     instanceVar_qq,
     instanceVar_E_eff0,
     instanceVar_eta_mu,
     instanceVar_eta_mu1,
     instanceVar_inv_AX,
     instanceVar_inv_VP,
     instanceVar_GOV_s,
     instanceVar_GOV_d,
     instanceVar_GOV2_s,
     instanceVar_GOV2_d,
     instanceVar_SP_OV_eps2_s,
     instanceVar_SP_OV_a_s,
     instanceVar_SP_OV_delta1_s,
     instanceVar_SP_OV_eps2_d,
     instanceVar_SP_OV_a_d,
     instanceVar_SP_OV_delta1_d,
     instanceVar_inv_CHIB,
     instanceVar_BCH,
     instanceVar_BOV,
     instanceVar_BOV_d,
     instanceVar_GCQ,
     instanceVar_AGIDLs,
     instanceVar_AGIDLDs,
     instanceVar_BGIDLs,
     instanceVar_BGIDLDs,
     instanceVar_fac_exc,
     instanceVar_ggate,
     instanceVar_gsource,
     instanceVar_gdrain,
     instanceVar_gbulk,
     instanceVar_gjuns,
     instanceVar_gjund,
     instanceVar_gwell,
     // model parameters
     // reals
     modelPar_TR,
     modelPar_given_TR,
     modelPar_QMC,
     modelPar_given_QMC,
     modelPar_VFB,
     modelPar_given_VFB,
     modelPar_STVFB,
     modelPar_given_STVFB,
     modelPar_TOX,
     modelPar_given_TOX,
     modelPar_EPSROX,
     modelPar_given_EPSROX,
     modelPar_NEFF,
     modelPar_given_NEFF,
     modelPar_FACNEFFAC,
     modelPar_given_FACNEFFAC,
     modelPar_GFACNUD,
     modelPar_given_GFACNUD,
     modelPar_VSBNUD,
     modelPar_given_VSBNUD,
     modelPar_DVSBNUD,
     modelPar_given_DVSBNUD,
     modelPar_VNSUB,
     modelPar_given_VNSUB,
     modelPar_NSLP,
     modelPar_given_NSLP,
     modelPar_DNSUB,
     modelPar_given_DNSUB,
     modelPar_DPHIB,
     modelPar_given_DPHIB,
     modelPar_DELVTAC,
     modelPar_given_DELVTAC,
     modelPar_NP,
     modelPar_given_NP,
     modelPar_CT,
     modelPar_given_CT,
     modelPar_TOXOV,
     modelPar_given_TOXOV,
     modelPar_TOXOVD,
     modelPar_given_TOXOVD,
     modelPar_NOV,
     modelPar_given_NOV,
     modelPar_NOVD,
     modelPar_given_NOVD,
     modelPar_CF,
     modelPar_given_CF,
     modelPar_CFD,
     modelPar_given_CFD,
     modelPar_CFB,
     modelPar_given_CFB,
     modelPar_PSCE,
     modelPar_given_PSCE,
     modelPar_PSCEB,
     modelPar_given_PSCEB,
     modelPar_PSCED,
     modelPar_given_PSCED,
     modelPar_BETN,
     modelPar_given_BETN,
     modelPar_STBET,
     modelPar_given_STBET,
     modelPar_MUE,
     modelPar_given_MUE,
     modelPar_STMUE,
     modelPar_given_STMUE,
     modelPar_THEMU,
     modelPar_given_THEMU,
     modelPar_STTHEMU,
     modelPar_given_STTHEMU,
     modelPar_CS,
     modelPar_given_CS,
     modelPar_STCS,
     modelPar_given_STCS,
     modelPar_XCOR,
     modelPar_given_XCOR,
     modelPar_STXCOR,
     modelPar_given_STXCOR,
     modelPar_FETA,
     modelPar_given_FETA,
     modelPar_RS,
     modelPar_given_RS,
     modelPar_STRS,
     modelPar_given_STRS,
     modelPar_RSB,
     modelPar_given_RSB,
     modelPar_RSG,
     modelPar_given_RSG,
     modelPar_THESAT,
     modelPar_given_THESAT,
     modelPar_STTHESAT,
     modelPar_given_STTHESAT,
     modelPar_THESATB,
     modelPar_given_THESATB,
     modelPar_THESATG,
     modelPar_given_THESATG,
     modelPar_AX,
     modelPar_given_AX,
     modelPar_ALP,
     modelPar_given_ALP,
     modelPar_ALP1,
     modelPar_given_ALP1,
     modelPar_ALP2,
     modelPar_given_ALP2,
     modelPar_VP,
     modelPar_given_VP,
     modelPar_A1,
     modelPar_given_A1,
     modelPar_A2,
     modelPar_given_A2,
     modelPar_STA2,
     modelPar_given_STA2,
     modelPar_A3,
     modelPar_given_A3,
     modelPar_A4,
     modelPar_given_A4,
     modelPar_GCO,
     modelPar_given_GCO,
     modelPar_IGINV,
     modelPar_given_IGINV,
     modelPar_IGOV,
     modelPar_given_IGOV,
     modelPar_IGOVD,
     modelPar_given_IGOVD,
     modelPar_STIG,
     modelPar_given_STIG,
     modelPar_GC2,
     modelPar_given_GC2,
     modelPar_GC3,
     modelPar_given_GC3,
     modelPar_CHIB,
     modelPar_given_CHIB,
     modelPar_AGIDL,
     modelPar_given_AGIDL,
     modelPar_AGIDLD,
     modelPar_given_AGIDLD,
     modelPar_BGIDL,
     modelPar_given_BGIDL,
     modelPar_BGIDLD,
     modelPar_given_BGIDLD,
     modelPar_STBGIDL,
     modelPar_given_STBGIDL,
     modelPar_STBGIDLD,
     modelPar_given_STBGIDLD,
     modelPar_CGIDL,
     modelPar_given_CGIDL,
     modelPar_CGIDLD,
     modelPar_given_CGIDLD,
     modelPar_COX,
     modelPar_given_COX,
     modelPar_CGOV,
     modelPar_given_CGOV,
     modelPar_CGOVD,
     modelPar_given_CGOVD,
     modelPar_CGBOV,
     modelPar_given_CGBOV,
     modelPar_CFR,
     modelPar_given_CFR,
     modelPar_CFRD,
     modelPar_given_CFRD,
     modelPar_FNT,
     modelPar_given_FNT,
     modelPar_FNTEXC,
     modelPar_given_FNTEXC,
     modelPar_NFA,
     modelPar_given_NFA,
     modelPar_NFB,
     modelPar_given_NFB,
     modelPar_NFC,
     modelPar_given_NFC,
     modelPar_EF,
     modelPar_given_EF,
     modelPar_VFBEDGE,
     modelPar_given_VFBEDGE,
     modelPar_STVFBEDGE,
     modelPar_given_STVFBEDGE,
     modelPar_DPHIBEDGE,
     modelPar_given_DPHIBEDGE,
     modelPar_NEFFEDGE,
     modelPar_given_NEFFEDGE,
     modelPar_CTEDGE,
     modelPar_given_CTEDGE,
     modelPar_BETNEDGE,
     modelPar_given_BETNEDGE,
     modelPar_STBETEDGE,
     modelPar_given_STBETEDGE,
     modelPar_PSCEEDGE,
     modelPar_given_PSCEEDGE,
     modelPar_PSCEBEDGE,
     modelPar_given_PSCEBEDGE,
     modelPar_PSCEDEDGE,
     modelPar_given_PSCEDEDGE,
     modelPar_CFEDGE,
     modelPar_given_CFEDGE,
     modelPar_CFDEDGE,
     modelPar_given_CFDEDGE,
     modelPar_CFBEDGE,
     modelPar_given_CFBEDGE,
     modelPar_FNTEDGE,
     modelPar_given_FNTEDGE,
     modelPar_NFAEDGE,
     modelPar_given_NFAEDGE,
     modelPar_NFBEDGE,
     modelPar_given_NFBEDGE,
     modelPar_NFCEDGE,
     modelPar_given_NFCEDGE,
     modelPar_EFEDGE,
     modelPar_given_EFEDGE,
     modelPar_RG,
     modelPar_given_RG,
     modelPar_RSE,
     modelPar_given_RSE,
     modelPar_RDE,
     modelPar_given_RDE,
     modelPar_RBULK,
     modelPar_given_RBULK,
     modelPar_RWELL,
     modelPar_given_RWELL,
     modelPar_RJUNS,
     modelPar_given_RJUNS,
     modelPar_RJUND,
     modelPar_given_RJUND,
     modelPar_POVFB,
     modelPar_given_POVFB,
     modelPar_PLVFB,
     modelPar_given_PLVFB,
     modelPar_PWVFB,
     modelPar_given_PWVFB,
     modelPar_PLWVFB,
     modelPar_given_PLWVFB,
     modelPar_POSTVFB,
     modelPar_given_POSTVFB,
     modelPar_PLSTVFB,
     modelPar_given_PLSTVFB,
     modelPar_PWSTVFB,
     modelPar_given_PWSTVFB,
     modelPar_PLWSTVFB,
     modelPar_given_PLWSTVFB,
     modelPar_POTOX,
     modelPar_given_POTOX,
     modelPar_POEPSROX,
     modelPar_given_POEPSROX,
     modelPar_PONEFF,
     modelPar_given_PONEFF,
     modelPar_PLNEFF,
     modelPar_given_PLNEFF,
     modelPar_PWNEFF,
     modelPar_given_PWNEFF,
     modelPar_PLWNEFF,
     modelPar_given_PLWNEFF,
     modelPar_POFACNEFFAC,
     modelPar_given_POFACNEFFAC,
     modelPar_PLFACNEFFAC,
     modelPar_given_PLFACNEFFAC,
     modelPar_PWFACNEFFAC,
     modelPar_given_PWFACNEFFAC,
     modelPar_PLWFACNEFFAC,
     modelPar_given_PLWFACNEFFAC,
     modelPar_POGFACNUD,
     modelPar_given_POGFACNUD,
     modelPar_PLGFACNUD,
     modelPar_given_PLGFACNUD,
     modelPar_PWGFACNUD,
     modelPar_given_PWGFACNUD,
     modelPar_PLWGFACNUD,
     modelPar_given_PLWGFACNUD,
     modelPar_POVSBNUD,
     modelPar_given_POVSBNUD,
     modelPar_PODVSBNUD,
     modelPar_given_PODVSBNUD,
     modelPar_POVNSUB,
     modelPar_given_POVNSUB,
     modelPar_PONSLP,
     modelPar_given_PONSLP,
     modelPar_PODNSUB,
     modelPar_given_PODNSUB,
     modelPar_PODPHIB,
     modelPar_given_PODPHIB,
     modelPar_PLDPHIB,
     modelPar_given_PLDPHIB,
     modelPar_PWDPHIB,
     modelPar_given_PWDPHIB,
     modelPar_PLWDPHIB,
     modelPar_given_PLWDPHIB,
     modelPar_PODELVTAC,
     modelPar_given_PODELVTAC,
     modelPar_PLDELVTAC,
     modelPar_given_PLDELVTAC,
     modelPar_PWDELVTAC,
     modelPar_given_PWDELVTAC,
     modelPar_PLWDELVTAC,
     modelPar_given_PLWDELVTAC,
     modelPar_PONP,
     modelPar_given_PONP,
     modelPar_PLNP,
     modelPar_given_PLNP,
     modelPar_PWNP,
     modelPar_given_PWNP,
     modelPar_PLWNP,
     modelPar_given_PLWNP,
     modelPar_POCT,
     modelPar_given_POCT,
     modelPar_PLCT,
     modelPar_given_PLCT,
     modelPar_PWCT,
     modelPar_given_PWCT,
     modelPar_PLWCT,
     modelPar_given_PLWCT,
     modelPar_POTOXOV,
     modelPar_given_POTOXOV,
     modelPar_POTOXOVD,
     modelPar_given_POTOXOVD,
     modelPar_PONOV,
     modelPar_given_PONOV,
     modelPar_PLNOV,
     modelPar_given_PLNOV,
     modelPar_PWNOV,
     modelPar_given_PWNOV,
     modelPar_PLWNOV,
     modelPar_given_PLWNOV,
     modelPar_PONOVD,
     modelPar_given_PONOVD,
     modelPar_PLNOVD,
     modelPar_given_PLNOVD,
     modelPar_PWNOVD,
     modelPar_given_PWNOVD,
     modelPar_PLWNOVD,
     modelPar_given_PLWNOVD,
     modelPar_POCF,
     modelPar_given_POCF,
     modelPar_PLCF,
     modelPar_given_PLCF,
     modelPar_PWCF,
     modelPar_given_PWCF,
     modelPar_PLWCF,
     modelPar_given_PLWCF,
     modelPar_POCFD,
     modelPar_given_POCFD,
     modelPar_POCFB,
     modelPar_given_POCFB,
     modelPar_POPSCE,
     modelPar_given_POPSCE,
     modelPar_PLPSCE,
     modelPar_given_PLPSCE,
     modelPar_PWPSCE,
     modelPar_given_PWPSCE,
     modelPar_PLWPSCE,
     modelPar_given_PLWPSCE,
     modelPar_POPSCEB,
     modelPar_given_POPSCEB,
     modelPar_POPSCED,
     modelPar_given_POPSCED,
     modelPar_POBETN,
     modelPar_given_POBETN,
     modelPar_PLBETN,
     modelPar_given_PLBETN,
     modelPar_PWBETN,
     modelPar_given_PWBETN,
     modelPar_PLWBETN,
     modelPar_given_PLWBETN,
     modelPar_POSTBET,
     modelPar_given_POSTBET,
     modelPar_PLSTBET,
     modelPar_given_PLSTBET,
     modelPar_PWSTBET,
     modelPar_given_PWSTBET,
     modelPar_PLWSTBET,
     modelPar_given_PLWSTBET,
     modelPar_POMUE,
     modelPar_given_POMUE,
     modelPar_PLMUE,
     modelPar_given_PLMUE,
     modelPar_PWMUE,
     modelPar_given_PWMUE,
     modelPar_PLWMUE,
     modelPar_given_PLWMUE,
     modelPar_POSTMUE,
     modelPar_given_POSTMUE,
     modelPar_POTHEMU,
     modelPar_given_POTHEMU,
     modelPar_POSTTHEMU,
     modelPar_given_POSTTHEMU,
     modelPar_POCS,
     modelPar_given_POCS,
     modelPar_PLCS,
     modelPar_given_PLCS,
     modelPar_PWCS,
     modelPar_given_PWCS,
     modelPar_PLWCS,
     modelPar_given_PLWCS,
     modelPar_POSTCS,
     modelPar_given_POSTCS,
     modelPar_POXCOR,
     modelPar_given_POXCOR,
     modelPar_PLXCOR,
     modelPar_given_PLXCOR,
     modelPar_PWXCOR,
     modelPar_given_PWXCOR,
     modelPar_PLWXCOR,
     modelPar_given_PLWXCOR,
     modelPar_POSTXCOR,
     modelPar_given_POSTXCOR,
     modelPar_POFETA,
     modelPar_given_POFETA,
     modelPar_PORS,
     modelPar_given_PORS,
     modelPar_PLRS,
     modelPar_given_PLRS,
     modelPar_PWRS,
     modelPar_given_PWRS,
     modelPar_PLWRS,
     modelPar_given_PLWRS,
     modelPar_POSTRS,
     modelPar_given_POSTRS,
     modelPar_PORSB,
     modelPar_given_PORSB,
     modelPar_PORSG,
     modelPar_given_PORSG,
     modelPar_POTHESAT,
     modelPar_given_POTHESAT,
     modelPar_PLTHESAT,
     modelPar_given_PLTHESAT,
     modelPar_PWTHESAT,
     modelPar_given_PWTHESAT,
     modelPar_PLWTHESAT,
     modelPar_given_PLWTHESAT,
     modelPar_POSTTHESAT,
     modelPar_given_POSTTHESAT,
     modelPar_PLSTTHESAT,
     modelPar_given_PLSTTHESAT,
     modelPar_PWSTTHESAT,
     modelPar_given_PWSTTHESAT,
     modelPar_PLWSTTHESAT,
     modelPar_given_PLWSTTHESAT,
     modelPar_POTHESATB,
     modelPar_given_POTHESATB,
     modelPar_PLTHESATB,
     modelPar_given_PLTHESATB,
     modelPar_PWTHESATB,
     modelPar_given_PWTHESATB,
     modelPar_PLWTHESATB,
     modelPar_given_PLWTHESATB,
     modelPar_POTHESATG,
     modelPar_given_POTHESATG,
     modelPar_PLTHESATG,
     modelPar_given_PLTHESATG,
     modelPar_PWTHESATG,
     modelPar_given_PWTHESATG,
     modelPar_PLWTHESATG,
     modelPar_given_PLWTHESATG,
     modelPar_POAX,
     modelPar_given_POAX,
     modelPar_PLAX,
     modelPar_given_PLAX,
     modelPar_PWAX,
     modelPar_given_PWAX,
     modelPar_PLWAX,
     modelPar_given_PLWAX,
     modelPar_POALP,
     modelPar_given_POALP,
     modelPar_PLALP,
     modelPar_given_PLALP,
     modelPar_PWALP,
     modelPar_given_PWALP,
     modelPar_PLWALP,
     modelPar_given_PLWALP,
     modelPar_POALP1,
     modelPar_given_POALP1,
     modelPar_PLALP1,
     modelPar_given_PLALP1,
     modelPar_PWALP1,
     modelPar_given_PWALP1,
     modelPar_PLWALP1,
     modelPar_given_PLWALP1,
     modelPar_POALP2,
     modelPar_given_POALP2,
     modelPar_PLALP2,
     modelPar_given_PLALP2,
     modelPar_PWALP2,
     modelPar_given_PWALP2,
     modelPar_PLWALP2,
     modelPar_given_PLWALP2,
     modelPar_POVP,
     modelPar_given_POVP,
     modelPar_POA1,
     modelPar_given_POA1,
     modelPar_PLA1,
     modelPar_given_PLA1,
     modelPar_PWA1,
     modelPar_given_PWA1,
     modelPar_PLWA1,
     modelPar_given_PLWA1,
     modelPar_POA2,
     modelPar_given_POA2,
     modelPar_POSTA2,
     modelPar_given_POSTA2,
     modelPar_POA3,
     modelPar_given_POA3,
     modelPar_PLA3,
     modelPar_given_PLA3,
     modelPar_PWA3,
     modelPar_given_PWA3,
     modelPar_PLWA3,
     modelPar_given_PLWA3,
     modelPar_POA4,
     modelPar_given_POA4,
     modelPar_PLA4,
     modelPar_given_PLA4,
     modelPar_PWA4,
     modelPar_given_PWA4,
     modelPar_PLWA4,
     modelPar_given_PLWA4,
     modelPar_POGCO,
     modelPar_given_POGCO,
     modelPar_POIGINV,
     modelPar_given_POIGINV,
     modelPar_PLIGINV,
     modelPar_given_PLIGINV,
     modelPar_PWIGINV,
     modelPar_given_PWIGINV,
     modelPar_PLWIGINV,
     modelPar_given_PLWIGINV,
     modelPar_POIGOV,
     modelPar_given_POIGOV,
     modelPar_PLIGOV,
     modelPar_given_PLIGOV,
     modelPar_PWIGOV,
     modelPar_given_PWIGOV,
     modelPar_PLWIGOV,
     modelPar_given_PLWIGOV,
     modelPar_POIGOVD,
     modelPar_given_POIGOVD,
     modelPar_PLIGOVD,
     modelPar_given_PLIGOVD,
     modelPar_PWIGOVD,
     modelPar_given_PWIGOVD,
     modelPar_PLWIGOVD,
     modelPar_given_PLWIGOVD,
     modelPar_POSTIG,
     modelPar_given_POSTIG,
     modelPar_POGC2,
     modelPar_given_POGC2,
     modelPar_POGC3,
     modelPar_given_POGC3,
     modelPar_POCHIB,
     modelPar_given_POCHIB,
     modelPar_POAGIDL,
     modelPar_given_POAGIDL,
     modelPar_PLAGIDL,
     modelPar_given_PLAGIDL,
     modelPar_PWAGIDL,
     modelPar_given_PWAGIDL,
     modelPar_PLWAGIDL,
     modelPar_given_PLWAGIDL,
     modelPar_POAGIDLD,
     modelPar_given_POAGIDLD,
     modelPar_PLAGIDLD,
     modelPar_given_PLAGIDLD,
     modelPar_PWAGIDLD,
     modelPar_given_PWAGIDLD,
     modelPar_PLWAGIDLD,
     modelPar_given_PLWAGIDLD,
     modelPar_POBGIDL,
     modelPar_given_POBGIDL,
     modelPar_POBGIDLD,
     modelPar_given_POBGIDLD,
     modelPar_POSTBGIDL,
     modelPar_given_POSTBGIDL,
     modelPar_POSTBGIDLD,
     modelPar_given_POSTBGIDLD,
     modelPar_POCGIDL,
     modelPar_given_POCGIDL,
     modelPar_POCGIDLD,
     modelPar_given_POCGIDLD,
     modelPar_POCOX,
     modelPar_given_POCOX,
     modelPar_PLCOX,
     modelPar_given_PLCOX,
     modelPar_PWCOX,
     modelPar_given_PWCOX,
     modelPar_PLWCOX,
     modelPar_given_PLWCOX,
     modelPar_POCGOV,
     modelPar_given_POCGOV,
     modelPar_PLCGOV,
     modelPar_given_PLCGOV,
     modelPar_PWCGOV,
     modelPar_given_PWCGOV,
     modelPar_PLWCGOV,
     modelPar_given_PLWCGOV,
     modelPar_POCGOVD,
     modelPar_given_POCGOVD,
     modelPar_PLCGOVD,
     modelPar_given_PLCGOVD,
     modelPar_PWCGOVD,
     modelPar_given_PWCGOVD,
     modelPar_PLWCGOVD,
     modelPar_given_PLWCGOVD,
     modelPar_POCGBOV,
     modelPar_given_POCGBOV,
     modelPar_PLCGBOV,
     modelPar_given_PLCGBOV,
     modelPar_PWCGBOV,
     modelPar_given_PWCGBOV,
     modelPar_PLWCGBOV,
     modelPar_given_PLWCGBOV,
     modelPar_POCFR,
     modelPar_given_POCFR,
     modelPar_PLCFR,
     modelPar_given_PLCFR,
     modelPar_PWCFR,
     modelPar_given_PWCFR,
     modelPar_PLWCFR,
     modelPar_given_PLWCFR,
     modelPar_POCFRD,
     modelPar_given_POCFRD,
     modelPar_PLCFRD,
     modelPar_given_PLCFRD,
     modelPar_PWCFRD,
     modelPar_given_PWCFRD,
     modelPar_PLWCFRD,
     modelPar_given_PLWCFRD,
     modelPar_POFNT,
     modelPar_given_POFNT,
     modelPar_POFNTEXC,
     modelPar_given_POFNTEXC,
     modelPar_PLFNTEXC,
     modelPar_given_PLFNTEXC,
     modelPar_PWFNTEXC,
     modelPar_given_PWFNTEXC,
     modelPar_PLWFNTEXC,
     modelPar_given_PLWFNTEXC,
     modelPar_PONFA,
     modelPar_given_PONFA,
     modelPar_PLNFA,
     modelPar_given_PLNFA,
     modelPar_PWNFA,
     modelPar_given_PWNFA,
     modelPar_PLWNFA,
     modelPar_given_PLWNFA,
     modelPar_PONFB,
     modelPar_given_PONFB,
     modelPar_PLNFB,
     modelPar_given_PLNFB,
     modelPar_PWNFB,
     modelPar_given_PWNFB,
     modelPar_PLWNFB,
     modelPar_given_PLWNFB,
     modelPar_PONFC,
     modelPar_given_PONFC,
     modelPar_PLNFC,
     modelPar_given_PLNFC,
     modelPar_PWNFC,
     modelPar_given_PWNFC,
     modelPar_PLWNFC,
     modelPar_given_PLWNFC,
     modelPar_POEF,
     modelPar_given_POEF,
     modelPar_POVFBEDGE,
     modelPar_given_POVFBEDGE,
     modelPar_POSTVFBEDGE,
     modelPar_given_POSTVFBEDGE,
     modelPar_PLSTVFBEDGE,
     modelPar_given_PLSTVFBEDGE,
     modelPar_PWSTVFBEDGE,
     modelPar_given_PWSTVFBEDGE,
     modelPar_PLWSTVFBEDGE,
     modelPar_given_PLWSTVFBEDGE,
     modelPar_PODPHIBEDGE,
     modelPar_given_PODPHIBEDGE,
     modelPar_PLDPHIBEDGE,
     modelPar_given_PLDPHIBEDGE,
     modelPar_PWDPHIBEDGE,
     modelPar_given_PWDPHIBEDGE,
     modelPar_PLWDPHIBEDGE,
     modelPar_given_PLWDPHIBEDGE,
     modelPar_PONEFFEDGE,
     modelPar_given_PONEFFEDGE,
     modelPar_PLNEFFEDGE,
     modelPar_given_PLNEFFEDGE,
     modelPar_PWNEFFEDGE,
     modelPar_given_PWNEFFEDGE,
     modelPar_PLWNEFFEDGE,
     modelPar_given_PLWNEFFEDGE,
     modelPar_POCTEDGE,
     modelPar_given_POCTEDGE,
     modelPar_PLCTEDGE,
     modelPar_given_PLCTEDGE,
     modelPar_PWCTEDGE,
     modelPar_given_PWCTEDGE,
     modelPar_PLWCTEDGE,
     modelPar_given_PLWCTEDGE,
     modelPar_POBETNEDGE,
     modelPar_given_POBETNEDGE,
     modelPar_PLBETNEDGE,
     modelPar_given_PLBETNEDGE,
     modelPar_PWBETNEDGE,
     modelPar_given_PWBETNEDGE,
     modelPar_PLWBETNEDGE,
     modelPar_given_PLWBETNEDGE,
     modelPar_POSTBETEDGE,
     modelPar_given_POSTBETEDGE,
     modelPar_PLSTBETEDGE,
     modelPar_given_PLSTBETEDGE,
     modelPar_PWSTBETEDGE,
     modelPar_given_PWSTBETEDGE,
     modelPar_PLWSTBETEDGE,
     modelPar_given_PLWSTBETEDGE,
     modelPar_POPSCEEDGE,
     modelPar_given_POPSCEEDGE,
     modelPar_PLPSCEEDGE,
     modelPar_given_PLPSCEEDGE,
     modelPar_PWPSCEEDGE,
     modelPar_given_PWPSCEEDGE,
     modelPar_PLWPSCEEDGE,
     modelPar_given_PLWPSCEEDGE,
     modelPar_POPSCEBEDGE,
     modelPar_given_POPSCEBEDGE,
     modelPar_POPSCEDEDGE,
     modelPar_given_POPSCEDEDGE,
     modelPar_POCFEDGE,
     modelPar_given_POCFEDGE,
     modelPar_PLCFEDGE,
     modelPar_given_PLCFEDGE,
     modelPar_PWCFEDGE,
     modelPar_given_PWCFEDGE,
     modelPar_PLWCFEDGE,
     modelPar_given_PLWCFEDGE,
     modelPar_POCFDEDGE,
     modelPar_given_POCFDEDGE,
     modelPar_POCFBEDGE,
     modelPar_given_POCFBEDGE,
     modelPar_POFNTEDGE,
     modelPar_given_POFNTEDGE,
     modelPar_PONFAEDGE,
     modelPar_given_PONFAEDGE,
     modelPar_PLNFAEDGE,
     modelPar_given_PLNFAEDGE,
     modelPar_PWNFAEDGE,
     modelPar_given_PWNFAEDGE,
     modelPar_PLWNFAEDGE,
     modelPar_given_PLWNFAEDGE,
     modelPar_PONFBEDGE,
     modelPar_given_PONFBEDGE,
     modelPar_PLNFBEDGE,
     modelPar_given_PLNFBEDGE,
     modelPar_PWNFBEDGE,
     modelPar_given_PWNFBEDGE,
     modelPar_PLWNFBEDGE,
     modelPar_given_PLWNFBEDGE,
     modelPar_PONFCEDGE,
     modelPar_given_PONFCEDGE,
     modelPar_PLNFCEDGE,
     modelPar_given_PLNFCEDGE,
     modelPar_PWNFCEDGE,
     modelPar_given_PWNFCEDGE,
     modelPar_PLWNFCEDGE,
     modelPar_given_PLWNFCEDGE,
     modelPar_POEFEDGE,
     modelPar_given_POEFEDGE,
     modelPar_POKVTHOWE,
     modelPar_given_POKVTHOWE,
     modelPar_PLKVTHOWE,
     modelPar_given_PLKVTHOWE,
     modelPar_PWKVTHOWE,
     modelPar_given_PWKVTHOWE,
     modelPar_PLWKVTHOWE,
     modelPar_given_PLWKVTHOWE,
     modelPar_POKUOWE,
     modelPar_given_POKUOWE,
     modelPar_PLKUOWE,
     modelPar_given_PLKUOWE,
     modelPar_PWKUOWE,
     modelPar_given_PWKUOWE,
     modelPar_PLWKUOWE,
     modelPar_given_PLWKUOWE,
     modelPar_LMIN,
     modelPar_given_LMIN,
     modelPar_LMAX,
     modelPar_given_LMAX,
     modelPar_WMIN,
     modelPar_given_WMIN,
     modelPar_WMAX,
     modelPar_given_WMAX,
     modelPar_LVARO,
     modelPar_given_LVARO,
     modelPar_LVARL,
     modelPar_given_LVARL,
     modelPar_LVARW,
     modelPar_given_LVARW,
     modelPar_LAP,
     modelPar_given_LAP,
     modelPar_WVARO,
     modelPar_given_WVARO,
     modelPar_WVARL,
     modelPar_given_WVARL,
     modelPar_WVARW,
     modelPar_given_WVARW,
     modelPar_WOT,
     modelPar_given_WOT,
     modelPar_DLQ,
     modelPar_given_DLQ,
     modelPar_DWQ,
     modelPar_given_DWQ,
     modelPar_VFBO,
     modelPar_given_VFBO,
     modelPar_VFBL,
     modelPar_given_VFBL,
     modelPar_VFBW,
     modelPar_given_VFBW,
     modelPar_VFBLW,
     modelPar_given_VFBLW,
     modelPar_STVFBO,
     modelPar_given_STVFBO,
     modelPar_STVFBL,
     modelPar_given_STVFBL,
     modelPar_STVFBW,
     modelPar_given_STVFBW,
     modelPar_STVFBLW,
     modelPar_given_STVFBLW,
     modelPar_TOXO,
     modelPar_given_TOXO,
     modelPar_EPSROXO,
     modelPar_given_EPSROXO,
     modelPar_NSUBO,
     modelPar_given_NSUBO,
     modelPar_NSUBW,
     modelPar_given_NSUBW,
     modelPar_WSEG,
     modelPar_given_WSEG,
     modelPar_NPCK,
     modelPar_given_NPCK,
     modelPar_NPCKW,
     modelPar_given_NPCKW,
     modelPar_WSEGP,
     modelPar_given_WSEGP,
     modelPar_LPCK,
     modelPar_given_LPCK,
     modelPar_LPCKW,
     modelPar_given_LPCKW,
     modelPar_FOL1,
     modelPar_given_FOL1,
     modelPar_FOL2,
     modelPar_given_FOL2,
     modelPar_FACNEFFACO,
     modelPar_given_FACNEFFACO,
     modelPar_FACNEFFACL,
     modelPar_given_FACNEFFACL,
     modelPar_FACNEFFACW,
     modelPar_given_FACNEFFACW,
     modelPar_FACNEFFACLW,
     modelPar_given_FACNEFFACLW,
     modelPar_GFACNUDO,
     modelPar_given_GFACNUDO,
     modelPar_GFACNUDL,
     modelPar_given_GFACNUDL,
     modelPar_GFACNUDLEXP,
     modelPar_given_GFACNUDLEXP,
     modelPar_GFACNUDW,
     modelPar_given_GFACNUDW,
     modelPar_GFACNUDLW,
     modelPar_given_GFACNUDLW,
     modelPar_VSBNUDO,
     modelPar_given_VSBNUDO,
     modelPar_DVSBNUDO,
     modelPar_given_DVSBNUDO,
     modelPar_VNSUBO,
     modelPar_given_VNSUBO,
     modelPar_NSLPO,
     modelPar_given_NSLPO,
     modelPar_DNSUBO,
     modelPar_given_DNSUBO,
     modelPar_DPHIBO,
     modelPar_given_DPHIBO,
     modelPar_DPHIBL,
     modelPar_given_DPHIBL,
     modelPar_DPHIBLEXP,
     modelPar_given_DPHIBLEXP,
     modelPar_DPHIBW,
     modelPar_given_DPHIBW,
     modelPar_DPHIBLW,
     modelPar_given_DPHIBLW,
     modelPar_DELVTACO,
     modelPar_given_DELVTACO,
     modelPar_DELVTACL,
     modelPar_given_DELVTACL,
     modelPar_DELVTACLEXP,
     modelPar_given_DELVTACLEXP,
     modelPar_DELVTACW,
     modelPar_given_DELVTACW,
     modelPar_DELVTACLW,
     modelPar_given_DELVTACLW,
     modelPar_NPO,
     modelPar_given_NPO,
     modelPar_NPL,
     modelPar_given_NPL,
     modelPar_CTO,
     modelPar_given_CTO,
     modelPar_CTL,
     modelPar_given_CTL,
     modelPar_CTLEXP,
     modelPar_given_CTLEXP,
     modelPar_CTW,
     modelPar_given_CTW,
     modelPar_CTLW,
     modelPar_given_CTLW,
     modelPar_TOXOVO,
     modelPar_given_TOXOVO,
     modelPar_TOXOVDO,
     modelPar_given_TOXOVDO,
     modelPar_LOV,
     modelPar_given_LOV,
     modelPar_LOVD,
     modelPar_given_LOVD,
     modelPar_NOVO,
     modelPar_given_NOVO,
     modelPar_NOVDO,
     modelPar_given_NOVDO,
     modelPar_CFL,
     modelPar_given_CFL,
     modelPar_CFLEXP,
     modelPar_given_CFLEXP,
     modelPar_CFW,
     modelPar_given_CFW,
     modelPar_CFDO,
     modelPar_given_CFDO,
     modelPar_CFBO,
     modelPar_given_CFBO,
     modelPar_PSCEL,
     modelPar_given_PSCEL,
     modelPar_PSCELEXP,
     modelPar_given_PSCELEXP,
     modelPar_PSCEW,
     modelPar_given_PSCEW,
     modelPar_PSCEBO,
     modelPar_given_PSCEBO,
     modelPar_PSCEDO,
     modelPar_given_PSCEDO,
     modelPar_UO,
     modelPar_given_UO,
     modelPar_FBET1,
     modelPar_given_FBET1,
     modelPar_FBET1W,
     modelPar_given_FBET1W,
     modelPar_LP1,
     modelPar_given_LP1,
     modelPar_LP1W,
     modelPar_given_LP1W,
     modelPar_FBET2,
     modelPar_given_FBET2,
     modelPar_LP2,
     modelPar_given_LP2,
     modelPar_BETW1,
     modelPar_given_BETW1,
     modelPar_BETW2,
     modelPar_given_BETW2,
     modelPar_WBET,
     modelPar_given_WBET,
     modelPar_STBETO,
     modelPar_given_STBETO,
     modelPar_STBETL,
     modelPar_given_STBETL,
     modelPar_STBETW,
     modelPar_given_STBETW,
     modelPar_STBETLW,
     modelPar_given_STBETLW,
     modelPar_MUEO,
     modelPar_given_MUEO,
     modelPar_MUEW,
     modelPar_given_MUEW,
     modelPar_STMUEO,
     modelPar_given_STMUEO,
     modelPar_THEMUO,
     modelPar_given_THEMUO,
     modelPar_STTHEMUO,
     modelPar_given_STTHEMUO,
     modelPar_CSO,
     modelPar_given_CSO,
     modelPar_CSL,
     modelPar_given_CSL,
     modelPar_CSLEXP,
     modelPar_given_CSLEXP,
     modelPar_CSW,
     modelPar_given_CSW,
     modelPar_CSLW,
     modelPar_given_CSLW,
     modelPar_STCSO,
     modelPar_given_STCSO,
     modelPar_XCORO,
     modelPar_given_XCORO,
     modelPar_XCORL,
     modelPar_given_XCORL,
     modelPar_XCORW,
     modelPar_given_XCORW,
     modelPar_XCORLW,
     modelPar_given_XCORLW,
     modelPar_STXCORO,
     modelPar_given_STXCORO,
     modelPar_FETAO,
     modelPar_given_FETAO,
     modelPar_RSW1,
     modelPar_given_RSW1,
     modelPar_RSW2,
     modelPar_given_RSW2,
     modelPar_STRSO,
     modelPar_given_STRSO,
     modelPar_RSBO,
     modelPar_given_RSBO,
     modelPar_RSGO,
     modelPar_given_RSGO,
     modelPar_THESATO,
     modelPar_given_THESATO,
     modelPar_THESATL,
     modelPar_given_THESATL,
     modelPar_THESATLEXP,
     modelPar_given_THESATLEXP,
     modelPar_THESATW,
     modelPar_given_THESATW,
     modelPar_THESATLW,
     modelPar_given_THESATLW,
     modelPar_STTHESATO,
     modelPar_given_STTHESATO,
     modelPar_STTHESATL,
     modelPar_given_STTHESATL,
     modelPar_STTHESATW,
     modelPar_given_STTHESATW,
     modelPar_STTHESATLW,
     modelPar_given_STTHESATLW,
     modelPar_THESATBO,
     modelPar_given_THESATBO,
     modelPar_THESATGO,
     modelPar_given_THESATGO,
     modelPar_AXO,
     modelPar_given_AXO,
     modelPar_AXL,
     modelPar_given_AXL,
     modelPar_ALPL,
     modelPar_given_ALPL,
     modelPar_ALPLEXP,
     modelPar_given_ALPLEXP,
     modelPar_ALPW,
     modelPar_given_ALPW,
     modelPar_ALP1L1,
     modelPar_given_ALP1L1,
     modelPar_ALP1LEXP,
     modelPar_given_ALP1LEXP,
     modelPar_ALP1L2,
     modelPar_given_ALP1L2,
     modelPar_ALP1W,
     modelPar_given_ALP1W,
     modelPar_ALP2L1,
     modelPar_given_ALP2L1,
     modelPar_ALP2LEXP,
     modelPar_given_ALP2LEXP,
     modelPar_ALP2L2,
     modelPar_given_ALP2L2,
     modelPar_ALP2W,
     modelPar_given_ALP2W,
     modelPar_VPO,
     modelPar_given_VPO,
     modelPar_A1O,
     modelPar_given_A1O,
     modelPar_A1L,
     modelPar_given_A1L,
     modelPar_A1W,
     modelPar_given_A1W,
     modelPar_A2O,
     modelPar_given_A2O,
     modelPar_STA2O,
     modelPar_given_STA2O,
     modelPar_A3O,
     modelPar_given_A3O,
     modelPar_A3L,
     modelPar_given_A3L,
     modelPar_A3W,
     modelPar_given_A3W,
     modelPar_A4O,
     modelPar_given_A4O,
     modelPar_A4L,
     modelPar_given_A4L,
     modelPar_A4W,
     modelPar_given_A4W,
     modelPar_GCOO,
     modelPar_given_GCOO,
     modelPar_IGINVLW,
     modelPar_given_IGINVLW,
     modelPar_IGOVW,
     modelPar_given_IGOVW,
     modelPar_IGOVDW,
     modelPar_given_IGOVDW,
     modelPar_STIGO,
     modelPar_given_STIGO,
     modelPar_GC2O,
     modelPar_given_GC2O,
     modelPar_GC3O,
     modelPar_given_GC3O,
     modelPar_CHIBO,
     modelPar_given_CHIBO,
     modelPar_AGIDLW,
     modelPar_given_AGIDLW,
     modelPar_AGIDLDW,
     modelPar_given_AGIDLDW,
     modelPar_BGIDLO,
     modelPar_given_BGIDLO,
     modelPar_BGIDLDO,
     modelPar_given_BGIDLDO,
     modelPar_STBGIDLO,
     modelPar_given_STBGIDLO,
     modelPar_STBGIDLDO,
     modelPar_given_STBGIDLDO,
     modelPar_CGIDLO,
     modelPar_given_CGIDLO,
     modelPar_CGIDLDO,
     modelPar_given_CGIDLDO,
     modelPar_CGBOVL,
     modelPar_given_CGBOVL,
     modelPar_CFRW,
     modelPar_given_CFRW,
     modelPar_CFRDW,
     modelPar_given_CFRDW,
     modelPar_FNTO,
     modelPar_given_FNTO,
     modelPar_FNTEXCL,
     modelPar_given_FNTEXCL,
     modelPar_NFALW,
     modelPar_given_NFALW,
     modelPar_NFBLW,
     modelPar_given_NFBLW,
     modelPar_NFCLW,
     modelPar_given_NFCLW,
     modelPar_EFO,
     modelPar_given_EFO,
     modelPar_LINTNOI,
     modelPar_given_LINTNOI,
     modelPar_ALPNOI,
     modelPar_given_ALPNOI,
     modelPar_WEDGE,
     modelPar_given_WEDGE,
     modelPar_WEDGEW,
     modelPar_given_WEDGEW,
     modelPar_VFBEDGEO,
     modelPar_given_VFBEDGEO,
     modelPar_STVFBEDGEO,
     modelPar_given_STVFBEDGEO,
     modelPar_STVFBEDGEL,
     modelPar_given_STVFBEDGEL,
     modelPar_STVFBEDGEW,
     modelPar_given_STVFBEDGEW,
     modelPar_STVFBEDGELW,
     modelPar_given_STVFBEDGELW,
     modelPar_DPHIBEDGEO,
     modelPar_given_DPHIBEDGEO,
     modelPar_DPHIBEDGEL,
     modelPar_given_DPHIBEDGEL,
     modelPar_DPHIBEDGELEXP,
     modelPar_given_DPHIBEDGELEXP,
     modelPar_DPHIBEDGEW,
     modelPar_given_DPHIBEDGEW,
     modelPar_DPHIBEDGELW,
     modelPar_given_DPHIBEDGELW,
     modelPar_NSUBEDGEO,
     modelPar_given_NSUBEDGEO,
     modelPar_NSUBEDGEL,
     modelPar_given_NSUBEDGEL,
     modelPar_NSUBEDGEW,
     modelPar_given_NSUBEDGEW,
     modelPar_NSUBEDGELW,
     modelPar_given_NSUBEDGELW,
     modelPar_CTEDGEO,
     modelPar_given_CTEDGEO,
     modelPar_CTEDGEL,
     modelPar_given_CTEDGEL,
     modelPar_CTEDGELEXP,
     modelPar_given_CTEDGELEXP,
     modelPar_FBETEDGE,
     modelPar_given_FBETEDGE,
     modelPar_LPEDGE,
     modelPar_given_LPEDGE,
     modelPar_BETEDGEW,
     modelPar_given_BETEDGEW,
     modelPar_STBETEDGEO,
     modelPar_given_STBETEDGEO,
     modelPar_STBETEDGEL,
     modelPar_given_STBETEDGEL,
     modelPar_STBETEDGEW,
     modelPar_given_STBETEDGEW,
     modelPar_STBETEDGELW,
     modelPar_given_STBETEDGELW,
     modelPar_PSCEEDGEL,
     modelPar_given_PSCEEDGEL,
     modelPar_PSCEEDGELEXP,
     modelPar_given_PSCEEDGELEXP,
     modelPar_PSCEEDGEW,
     modelPar_given_PSCEEDGEW,
     modelPar_PSCEBEDGEO,
     modelPar_given_PSCEBEDGEO,
     modelPar_PSCEDEDGEO,
     modelPar_given_PSCEDEDGEO,
     modelPar_CFEDGEL,
     modelPar_given_CFEDGEL,
     modelPar_CFEDGELEXP,
     modelPar_given_CFEDGELEXP,
     modelPar_CFEDGEW,
     modelPar_given_CFEDGEW,
     modelPar_CFDEDGEO,
     modelPar_given_CFDEDGEO,
     modelPar_CFBEDGEO,
     modelPar_given_CFBEDGEO,
     modelPar_FNTEDGEO,
     modelPar_given_FNTEDGEO,
     modelPar_NFAEDGELW,
     modelPar_given_NFAEDGELW,
     modelPar_NFBEDGELW,
     modelPar_given_NFBEDGELW,
     modelPar_NFCEDGELW,
     modelPar_given_NFCEDGELW,
     modelPar_EFEDGEO,
     modelPar_given_EFEDGEO,
     modelPar_KVTHOWEO,
     modelPar_given_KVTHOWEO,
     modelPar_KVTHOWEL,
     modelPar_given_KVTHOWEL,
     modelPar_KVTHOWEW,
     modelPar_given_KVTHOWEW,
     modelPar_KVTHOWELW,
     modelPar_given_KVTHOWELW,
     modelPar_KUOWEO,
     modelPar_given_KUOWEO,
     modelPar_KUOWEL,
     modelPar_given_KUOWEL,
     modelPar_KUOWEW,
     modelPar_given_KUOWEW,
     modelPar_KUOWELW,
     modelPar_given_KUOWELW,
     modelPar_RGO,
     modelPar_given_RGO,
     modelPar_RINT,
     modelPar_given_RINT,
     modelPar_RVPOLY,
     modelPar_given_RVPOLY,
     modelPar_RSHG,
     modelPar_given_RSHG,
     modelPar_DLSIL,
     modelPar_given_DLSIL,
     modelPar_RSH,
     modelPar_given_RSH,
     modelPar_RSHD,
     modelPar_given_RSHD,
     modelPar_RBULKO,
     modelPar_given_RBULKO,
     modelPar_RWELLO,
     modelPar_given_RWELLO,
     modelPar_RJUNSO,
     modelPar_given_RJUNSO,
     modelPar_RJUNDO,
     modelPar_given_RJUNDO,
     modelPar_SAREF,
     modelPar_given_SAREF,
     modelPar_SBREF,
     modelPar_given_SBREF,
     modelPar_WLOD,
     modelPar_given_WLOD,
     modelPar_KUO,
     modelPar_given_KUO,
     modelPar_KVSAT,
     modelPar_given_KVSAT,
     modelPar_TKUO,
     modelPar_given_TKUO,
     modelPar_LKUO,
     modelPar_given_LKUO,
     modelPar_WKUO,
     modelPar_given_WKUO,
     modelPar_PKUO,
     modelPar_given_PKUO,
     modelPar_LLODKUO,
     modelPar_given_LLODKUO,
     modelPar_WLODKUO,
     modelPar_given_WLODKUO,
     modelPar_KVTHO,
     modelPar_given_KVTHO,
     modelPar_LKVTHO,
     modelPar_given_LKVTHO,
     modelPar_WKVTHO,
     modelPar_given_WKVTHO,
     modelPar_PKVTHO,
     modelPar_given_PKVTHO,
     modelPar_LLODVTH,
     modelPar_given_LLODVTH,
     modelPar_WLODVTH,
     modelPar_given_WLODVTH,
     modelPar_STETAO,
     modelPar_given_STETAO,
     modelPar_LODETAO,
     modelPar_given_LODETAO,
     modelPar_SCREF,
     modelPar_given_SCREF,
     modelPar_WEB,
     modelPar_given_WEB,
     modelPar_WEC,
     modelPar_given_WEC,
     modelPar_IMAX,
     modelPar_given_IMAX,
     modelPar_TRJ,
     modelPar_given_TRJ,
     modelPar_FREV,
     modelPar_given_FREV,
     modelPar_CJORBOT,
     modelPar_given_CJORBOT,
     modelPar_CJORSTI,
     modelPar_given_CJORSTI,
     modelPar_CJORGAT,
     modelPar_given_CJORGAT,
     modelPar_VBIRBOT,
     modelPar_given_VBIRBOT,
     modelPar_VBIRSTI,
     modelPar_given_VBIRSTI,
     modelPar_VBIRGAT,
     modelPar_given_VBIRGAT,
     modelPar_PBOT,
     modelPar_given_PBOT,
     modelPar_PSTI,
     modelPar_given_PSTI,
     modelPar_PGAT,
     modelPar_given_PGAT,
     modelPar_PHIGBOT,
     modelPar_given_PHIGBOT,
     modelPar_PHIGSTI,
     modelPar_given_PHIGSTI,
     modelPar_PHIGGAT,
     modelPar_given_PHIGGAT,
     modelPar_IDSATRBOT,
     modelPar_given_IDSATRBOT,
     modelPar_IDSATRSTI,
     modelPar_given_IDSATRSTI,
     modelPar_IDSATRGAT,
     modelPar_given_IDSATRGAT,
     modelPar_CSRHBOT,
     modelPar_given_CSRHBOT,
     modelPar_CSRHSTI,
     modelPar_given_CSRHSTI,
     modelPar_CSRHGAT,
     modelPar_given_CSRHGAT,
     modelPar_XJUNSTI,
     modelPar_given_XJUNSTI,
     modelPar_XJUNGAT,
     modelPar_given_XJUNGAT,
     modelPar_CTATBOT,
     modelPar_given_CTATBOT,
     modelPar_CTATSTI,
     modelPar_given_CTATSTI,
     modelPar_CTATGAT,
     modelPar_given_CTATGAT,
     modelPar_MEFFTATBOT,
     modelPar_given_MEFFTATBOT,
     modelPar_MEFFTATSTI,
     modelPar_given_MEFFTATSTI,
     modelPar_MEFFTATGAT,
     modelPar_given_MEFFTATGAT,
     modelPar_CBBTBOT,
     modelPar_given_CBBTBOT,
     modelPar_CBBTSTI,
     modelPar_given_CBBTSTI,
     modelPar_CBBTGAT,
     modelPar_given_CBBTGAT,
     modelPar_FBBTRBOT,
     modelPar_given_FBBTRBOT,
     modelPar_FBBTRSTI,
     modelPar_given_FBBTRSTI,
     modelPar_FBBTRGAT,
     modelPar_given_FBBTRGAT,
     modelPar_STFBBTBOT,
     modelPar_given_STFBBTBOT,
     modelPar_STFBBTSTI,
     modelPar_given_STFBBTSTI,
     modelPar_STFBBTGAT,
     modelPar_given_STFBBTGAT,
     modelPar_VBRBOT,
     modelPar_given_VBRBOT,
     modelPar_VBRSTI,
     modelPar_given_VBRSTI,
     modelPar_VBRGAT,
     modelPar_given_VBRGAT,
     modelPar_PBRBOT,
     modelPar_given_PBRBOT,
     modelPar_PBRSTI,
     modelPar_given_PBRSTI,
     modelPar_PBRGAT,
     modelPar_given_PBRGAT,
     modelPar_CJORBOTD,
     modelPar_given_CJORBOTD,
     modelPar_CJORSTID,
     modelPar_given_CJORSTID,
     modelPar_CJORGATD,
     modelPar_given_CJORGATD,
     modelPar_VBIRBOTD,
     modelPar_given_VBIRBOTD,
     modelPar_VBIRSTID,
     modelPar_given_VBIRSTID,
     modelPar_VBIRGATD,
     modelPar_given_VBIRGATD,
     modelPar_PBOTD,
     modelPar_given_PBOTD,
     modelPar_PSTID,
     modelPar_given_PSTID,
     modelPar_PGATD,
     modelPar_given_PGATD,
     modelPar_PHIGBOTD,
     modelPar_given_PHIGBOTD,
     modelPar_PHIGSTID,
     modelPar_given_PHIGSTID,
     modelPar_PHIGGATD,
     modelPar_given_PHIGGATD,
     modelPar_IDSATRBOTD,
     modelPar_given_IDSATRBOTD,
     modelPar_IDSATRSTID,
     modelPar_given_IDSATRSTID,
     modelPar_IDSATRGATD,
     modelPar_given_IDSATRGATD,
     modelPar_CSRHBOTD,
     modelPar_given_CSRHBOTD,
     modelPar_CSRHSTID,
     modelPar_given_CSRHSTID,
     modelPar_CSRHGATD,
     modelPar_given_CSRHGATD,
     modelPar_XJUNSTID,
     modelPar_given_XJUNSTID,
     modelPar_XJUNGATD,
     modelPar_given_XJUNGATD,
     modelPar_CTATBOTD,
     modelPar_given_CTATBOTD,
     modelPar_CTATSTID,
     modelPar_given_CTATSTID,
     modelPar_CTATGATD,
     modelPar_given_CTATGATD,
     modelPar_MEFFTATBOTD,
     modelPar_given_MEFFTATBOTD,
     modelPar_MEFFTATSTID,
     modelPar_given_MEFFTATSTID,
     modelPar_MEFFTATGATD,
     modelPar_given_MEFFTATGATD,
     modelPar_CBBTBOTD,
     modelPar_given_CBBTBOTD,
     modelPar_CBBTSTID,
     modelPar_given_CBBTSTID,
     modelPar_CBBTGATD,
     modelPar_given_CBBTGATD,
     modelPar_FBBTRBOTD,
     modelPar_given_FBBTRBOTD,
     modelPar_FBBTRSTID,
     modelPar_given_FBBTRSTID,
     modelPar_FBBTRGATD,
     modelPar_given_FBBTRGATD,
     modelPar_STFBBTBOTD,
     modelPar_given_STFBBTBOTD,
     modelPar_STFBBTSTID,
     modelPar_given_STFBBTSTID,
     modelPar_STFBBTGATD,
     modelPar_given_STFBBTGATD,
     modelPar_VBRBOTD,
     modelPar_given_VBRBOTD,
     modelPar_VBRSTID,
     modelPar_given_VBRSTID,
     modelPar_VBRGATD,
     modelPar_given_VBRGATD,
     modelPar_PBRBOTD,
     modelPar_given_PBRBOTD,
     modelPar_PBRSTID,
     modelPar_given_PBRSTID,
     modelPar_PBRGATD,
     modelPar_given_PBRGATD,
     modelPar_SWJUNEXP,
     modelPar_given_SWJUNEXP,
     modelPar_VJUNREF,
     modelPar_given_VJUNREF,
     modelPar_FJUNQ,
     modelPar_given_FJUNQ,
     modelPar_VJUNREFD,
     modelPar_given_VJUNREFD,
     modelPar_FJUNQD,
     modelPar_given_FJUNQD,
     modelPar_DTA,
     modelPar_given_DTA,
     // non-reals (including hidden)
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_TYPE,
     modelPar_given_TYPE,
     modelPar_SWGEO,
     modelPar_given_SWGEO,
     modelPar_SWIGATE,
     modelPar_given_SWIGATE,
     modelPar_SWIMPACT,
     modelPar_given_SWIMPACT,
     modelPar_SWGIDL,
     modelPar_given_SWGIDL,
     modelPar_SWJUNCAP,
     modelPar_given_SWJUNCAP,
     modelPar_SWJUNASYM,
     modelPar_given_SWJUNASYM,
     modelPar_SWNUD,
     modelPar_given_SWNUD,
     modelPar_SWEDGE,
     modelPar_given_SWEDGE,
     modelPar_SWDELVTAC,
     modelPar_given_SWDELVTAC,
     modelPar_SWIGN,
     modelPar_given_SWIGN// model variables
     ,
     // reals
     modelVar_TOXO_i,
     modelVar_EPSROXO_i,
     modelVar_NSUBO_i,
     modelVar_WSEG_i,
     modelVar_NPCK_i,
     modelVar_WSEGP_i,
     modelVar_LPCK_i,
     modelVar_TOXOVO_i,
     modelVar_TOXOVDO_i,
     modelVar_LOV_i,
     modelVar_LOVD_i,
     modelVar_LP1_i,
     modelVar_LP2_i,
     modelVar_WBET_i,
     modelVar_AXL_i,
     modelVar_ALP1L2_i,
     modelVar_ALP2L2_i,
     modelVar_SAREF_i,
     modelVar_SBREF_i,
     modelVar_KVSAT_i,
     modelVar_LLODKUO_i,
     modelVar_WLODKUO_i,
     modelVar_LLODVTH_i,
     modelVar_WLODVTH_i,
     modelVar_LODETAO_i,
     modelVar_SCREF_i,
     modelVar_WEB_i,
     modelVar_WEC_i,
     modelVar_RSHG_i,
     modelVar_RSH_i,
     modelVar_RSHD_i,
     modelVar_RINT_i,
     modelVar_RVPOLY_i,
     modelVar_NSUBEDGEO_i,
     modelVar_LPEDGE_i,
     modelVar_QMC_i,
     modelVar_rTa,
     modelVar_delTa,
     modelVar_phita,
     modelVar_inv_phita,
     modelVar_TKD,
     modelVar_delT,
     modelVar_rTn,
     modelVar_ln_rTn,
     modelVar_inv_phit,
     modelVar_Eg,
     modelVar_phibFac,
     modelVar_IMAX_i,
     modelVar_VBIRBOT_i,
     modelVar_VBIRSTI_i,
     modelVar_VBIRGAT_i,
     modelVar_PBOT_i,
     modelVar_PSTI_i,
     modelVar_PGAT_i,
     modelVar_CSRHBOT_i,
     modelVar_CSRHSTI_i,
     modelVar_CSRHGAT_i,
     modelVar_CTATBOT_i,
     modelVar_CTATSTI_i,
     modelVar_CTATGAT_i,
     modelVar_CBBTBOT_i,
     modelVar_CBBTSTI_i,
     modelVar_CBBTGAT_i,
     modelVar_VBRBOT_i,
     modelVar_VBRSTI_i,
     modelVar_VBRGAT_i,
     modelVar_PBRBOT_i,
     modelVar_PBRSTI_i,
     modelVar_PBRGAT_i,
     modelVar_SWJUNEXP_i,
     modelVar_VJUNREF_i,
     modelVar_FJUNQ_i,
     modelVar_phitr,
     modelVar_phitd,
     modelVar_phitdinv,
     modelVar_perfc,
     modelVar_berfc,
     modelVar_cerfc,
     modelVar_ftdbot,
     modelVar_ftdsti,
     modelVar_ftdgat,
     modelVar_idsatbot,
     modelVar_idsatsti,
     modelVar_idsatgat,
     modelVar_vbibot,
     modelVar_vbisti,
     modelVar_vbigat,
     modelVar_vbiinvbot,
     modelVar_vbiinvsti,
     modelVar_vbiinvgat,
     modelVar_one_minus_PBOT,
     modelVar_one_minus_PSTI,
     modelVar_one_minus_PGAT,
     modelVar_one_over_one_minus_PBOT,
     modelVar_one_over_one_minus_PSTI,
     modelVar_one_over_one_minus_PGAT,
     modelVar_cjobot,
     modelVar_cjosti,
     modelVar_cjogat,
     modelVar_qprefbot,
     modelVar_qprefsti,
     modelVar_qprefgat,
     modelVar_qpref2bot,
     modelVar_qpref2sti,
     modelVar_qpref2gat,
     modelVar_wdepnulrbot,
     modelVar_wdepnulrsti,
     modelVar_wdepnulrgat,
     modelVar_wdepnulrinvbot,
     modelVar_wdepnulrinvsti,
     modelVar_wdepnulrinvgat,
     modelVar_VBIRBOTinv,
     modelVar_VBIRSTIinv,
     modelVar_VBIRGATinv,
     modelVar_atatbot,
     modelVar_atatsti,
     modelVar_atatgat,
     modelVar_btatpartbot,
     modelVar_btatpartsti,
     modelVar_btatpartgat,
     modelVar_fbbtbot,
     modelVar_fbbtsti,
     modelVar_fbbtgat,
     modelVar_alphaav,
     modelVar_fstopbot,
     modelVar_fstopsti,
     modelVar_fstopgat,
     modelVar_VBRinvbot,
     modelVar_VBRinvsti,
     modelVar_VBRinvgat,
     modelVar_slopebot,
     modelVar_slopesti,
     modelVar_slopegat,
     modelVar_VBIRBOTD_i,
     modelVar_VBIRSTID_i,
     modelVar_VBIRGATD_i,
     modelVar_PBOTD_i,
     modelVar_PSTID_i,
     modelVar_PGATD_i,
     modelVar_CSRHBOTD_i,
     modelVar_CSRHSTID_i,
     modelVar_CSRHGATD_i,
     modelVar_CTATBOTD_i,
     modelVar_CTATSTID_i,
     modelVar_CTATGATD_i,
     modelVar_CBBTBOTD_i,
     modelVar_CBBTSTID_i,
     modelVar_CBBTGATD_i,
     modelVar_VBRBOTD_i,
     modelVar_VBRSTID_i,
     modelVar_VBRGATD_i,
     modelVar_PBRBOTD_i,
     modelVar_PBRSTID_i,
     modelVar_PBRGATD_i,
     modelVar_VJUNREFD_i,
     modelVar_FJUNQD_i,
     modelVar_ftdbot_d,
     modelVar_ftdsti_d,
     modelVar_ftdgat_d,
     modelVar_idsatbot_d,
     modelVar_idsatsti_d,
     modelVar_idsatgat_d,
     modelVar_vbibot_d,
     modelVar_vbisti_d,
     modelVar_vbigat_d,
     modelVar_vbiinvbot_d,
     modelVar_vbiinvsti_d,
     modelVar_vbiinvgat_d,
     modelVar_one_minus_PBOT_d,
     modelVar_one_minus_PSTI_d,
     modelVar_one_minus_PGAT_d,
     modelVar_one_over_one_minus_PBOT_d,
     modelVar_one_over_one_minus_PSTI_d,
     modelVar_one_over_one_minus_PGAT_d,
     modelVar_cjobot_d,
     modelVar_cjosti_d,
     modelVar_cjogat_d,
     modelVar_qprefbot_d,
     modelVar_qprefsti_d,
     modelVar_qprefgat_d,
     modelVar_qpref2bot_d,
     modelVar_qpref2sti_d,
     modelVar_qpref2gat_d,
     modelVar_wdepnulrbot_d,
     modelVar_wdepnulrsti_d,
     modelVar_wdepnulrgat_d,
     modelVar_wdepnulrinvbot_d,
     modelVar_wdepnulrinvsti_d,
     modelVar_wdepnulrinvgat_d,
     modelVar_VBIRBOTinv_d,
     modelVar_VBIRSTIinv_d,
     modelVar_VBIRGATinv_d,
     modelVar_atatbot_d,
     modelVar_atatsti_d,
     modelVar_atatgat_d,
     modelVar_btatpartbot_d,
     modelVar_btatpartsti_d,
     modelVar_btatpartgat_d,
     modelVar_fbbtbot_d,
     modelVar_fbbtsti_d,
     modelVar_fbbtgat_d,
     modelVar_fstopbot_d,
     modelVar_fstopsti_d,
     modelVar_fstopgat_d,
     modelVar_VBRinvbot_d,
     modelVar_VBRinvsti_d,
     modelVar_VBRinvgat_d,
     modelVar_slopebot_d,
     modelVar_slopesti_d,
     modelVar_slopegat_d,
     modelVar_phit,
     modelVar_nt0,
     modelVar_EPSSI,
     // non-reals
     modelVar_CHNL_TYPE,
     modelVar_SWGEO_i,
     modelVar_SWIGATE_i,
     modelVar_SWIMPACT_i,
     modelVar_SWGIDL_i,
     modelVar_SWJUNCAP_i,
     modelVar_SWJUNASYM_i,
     modelVar_SWNUD_i,
     modelVar_SWEDGE_i,
     modelVar_SWDELVTAC_i,
     modelVar_SWIGN_i,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_D] += staticContributions[in.admsNodeID_D].dx(0);
  dqdp[in.admsNodeID_D] += dynamicContributions[in.admsNodeID_D].dx(0);
  Findices[in.admsNodeID_D] = in.li_D;
  Qindices[in.admsNodeID_D] = in.li_D;
  dfdp[in.admsNodeID_G] += staticContributions[in.admsNodeID_G].dx(0);
  dqdp[in.admsNodeID_G] += dynamicContributions[in.admsNodeID_G].dx(0);
  Findices[in.admsNodeID_G] = in.li_G;
  Qindices[in.admsNodeID_G] = in.li_G;
  dfdp[in.admsNodeID_S] += staticContributions[in.admsNodeID_S].dx(0);
  dqdp[in.admsNodeID_S] += dynamicContributions[in.admsNodeID_S].dx(0);
  Findices[in.admsNodeID_S] = in.li_S;
  Qindices[in.admsNodeID_S] = in.li_S;
  dfdp[in.admsNodeID_B] += staticContributions[in.admsNodeID_B].dx(0);
  dqdp[in.admsNodeID_B] += dynamicContributions[in.admsNodeID_B].dx(0);
  Findices[in.admsNodeID_B] = in.li_B;
  Qindices[in.admsNodeID_B] = in.li_B;
  dfdp[in.admsNodeID_NOI] += staticContributions[in.admsNodeID_NOI].dx(0);
  dqdp[in.admsNodeID_NOI] += dynamicContributions[in.admsNodeID_NOI].dx(0);
  Findices[in.admsNodeID_NOI] = in.li_NOI;
  Qindices[in.admsNodeID_NOI] = in.li_NOI;
  dfdp[in.admsNodeID_NOI2] += staticContributions[in.admsNodeID_NOI2].dx(0);
  dqdp[in.admsNodeID_NOI2] += dynamicContributions[in.admsNodeID_NOI2].dx(0);
  Findices[in.admsNodeID_NOI2] = in.li_NOI2;
  Qindices[in.admsNodeID_NOI2] = in.li_NOI2;
  dfdp[in.admsNodeID_GP] += staticContributions[in.admsNodeID_GP].dx(0);
  dqdp[in.admsNodeID_GP] += dynamicContributions[in.admsNodeID_GP].dx(0);
  Findices[in.admsNodeID_GP] = in.li_GP;
  Qindices[in.admsNodeID_GP] = in.li_GP;
  dfdp[in.admsNodeID_SI] += staticContributions[in.admsNodeID_SI].dx(0);
  dqdp[in.admsNodeID_SI] += dynamicContributions[in.admsNodeID_SI].dx(0);
  Findices[in.admsNodeID_SI] = in.li_SI;
  Qindices[in.admsNodeID_SI] = in.li_SI;
  dfdp[in.admsNodeID_DI] += staticContributions[in.admsNodeID_DI].dx(0);
  dqdp[in.admsNodeID_DI] += dynamicContributions[in.admsNodeID_DI].dx(0);
  Findices[in.admsNodeID_DI] = in.li_DI;
  Qindices[in.admsNodeID_DI] = in.li_DI;
  dfdp[in.admsNodeID_BP] += staticContributions[in.admsNodeID_BP].dx(0);
  dqdp[in.admsNodeID_BP] += dynamicContributions[in.admsNodeID_BP].dx(0);
  Findices[in.admsNodeID_BP] = in.li_BP;
  Qindices[in.admsNodeID_BP] = in.li_BP;
  dfdp[in.admsNodeID_BI] += staticContributions[in.admsNodeID_BI].dx(0);
  dqdp[in.admsNodeID_BI] += dynamicContributions[in.admsNodeID_BI].dx(0);
  Findices[in.admsNodeID_BI] = in.li_BI;
  Qindices[in.admsNodeID_BI] = in.li_BI;
  dfdp[in.admsNodeID_BS] += staticContributions[in.admsNodeID_BS].dx(0);
  dqdp[in.admsNodeID_BS] += dynamicContributions[in.admsNodeID_BS].dx(0);
  Findices[in.admsNodeID_BS] = in.li_BS;
  Qindices[in.admsNodeID_BS] = in.li_BS;
  dfdp[in.admsNodeID_BD] += staticContributions[in.admsNodeID_BD].dx(0);
  dqdp[in.admsNodeID_BD] += dynamicContributions[in.admsNodeID_BD].dx(0);
  Findices[in.admsNodeID_BD] = in.li_BD;
  Qindices[in.admsNodeID_BD] = in.li_BD;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((13+0)*sizeInstance);
  dqdp.resize((13+0)*sizeInstance);
  Findices.resize((13+0)*sizeInstance);
  Qindices.resize((13+0)*sizeInstance);

  std::vector <double> probeVars(14);
  std::vector <AdmsSensFadType> staticContributions(13+0);
  std::vector <AdmsSensFadType> dynamicContributions(13+0);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_TR=mod.TR;
  bool modelPar_given_TR=mod.given("TR");
  modParamMap["TR"] = &modelPar_TR;
  AdmsSensFadType modelPar_QMC=mod.QMC;
  bool modelPar_given_QMC=mod.given("QMC");
  modParamMap["QMC"] = &modelPar_QMC;
  AdmsSensFadType modelPar_VFB=mod.VFB;
  bool modelPar_given_VFB=mod.given("VFB");
  modParamMap["VFB"] = &modelPar_VFB;
  AdmsSensFadType modelPar_STVFB=mod.STVFB;
  bool modelPar_given_STVFB=mod.given("STVFB");
  modParamMap["STVFB"] = &modelPar_STVFB;
  AdmsSensFadType modelPar_TOX=mod.TOX;
  bool modelPar_given_TOX=mod.given("TOX");
  modParamMap["TOX"] = &modelPar_TOX;
  AdmsSensFadType modelPar_EPSROX=mod.EPSROX;
  bool modelPar_given_EPSROX=mod.given("EPSROX");
  modParamMap["EPSROX"] = &modelPar_EPSROX;
  AdmsSensFadType modelPar_NEFF=mod.NEFF;
  bool modelPar_given_NEFF=mod.given("NEFF");
  modParamMap["NEFF"] = &modelPar_NEFF;
  AdmsSensFadType modelPar_FACNEFFAC=mod.FACNEFFAC;
  bool modelPar_given_FACNEFFAC=mod.given("FACNEFFAC");
  modParamMap["FACNEFFAC"] = &modelPar_FACNEFFAC;
  AdmsSensFadType modelPar_GFACNUD=mod.GFACNUD;
  bool modelPar_given_GFACNUD=mod.given("GFACNUD");
  modParamMap["GFACNUD"] = &modelPar_GFACNUD;
  AdmsSensFadType modelPar_VSBNUD=mod.VSBNUD;
  bool modelPar_given_VSBNUD=mod.given("VSBNUD");
  modParamMap["VSBNUD"] = &modelPar_VSBNUD;
  AdmsSensFadType modelPar_DVSBNUD=mod.DVSBNUD;
  bool modelPar_given_DVSBNUD=mod.given("DVSBNUD");
  modParamMap["DVSBNUD"] = &modelPar_DVSBNUD;
  AdmsSensFadType modelPar_VNSUB=mod.VNSUB;
  bool modelPar_given_VNSUB=mod.given("VNSUB");
  modParamMap["VNSUB"] = &modelPar_VNSUB;
  AdmsSensFadType modelPar_NSLP=mod.NSLP;
  bool modelPar_given_NSLP=mod.given("NSLP");
  modParamMap["NSLP"] = &modelPar_NSLP;
  AdmsSensFadType modelPar_DNSUB=mod.DNSUB;
  bool modelPar_given_DNSUB=mod.given("DNSUB");
  modParamMap["DNSUB"] = &modelPar_DNSUB;
  AdmsSensFadType modelPar_DPHIB=mod.DPHIB;
  bool modelPar_given_DPHIB=mod.given("DPHIB");
  modParamMap["DPHIB"] = &modelPar_DPHIB;
  AdmsSensFadType modelPar_DELVTAC=mod.DELVTAC;
  bool modelPar_given_DELVTAC=mod.given("DELVTAC");
  modParamMap["DELVTAC"] = &modelPar_DELVTAC;
  AdmsSensFadType modelPar_NP=mod.NP;
  bool modelPar_given_NP=mod.given("NP");
  modParamMap["NP"] = &modelPar_NP;
  AdmsSensFadType modelPar_CT=mod.CT;
  bool modelPar_given_CT=mod.given("CT");
  modParamMap["CT"] = &modelPar_CT;
  AdmsSensFadType modelPar_TOXOV=mod.TOXOV;
  bool modelPar_given_TOXOV=mod.given("TOXOV");
  modParamMap["TOXOV"] = &modelPar_TOXOV;
  AdmsSensFadType modelPar_TOXOVD=mod.TOXOVD;
  bool modelPar_given_TOXOVD=mod.given("TOXOVD");
  modParamMap["TOXOVD"] = &modelPar_TOXOVD;
  AdmsSensFadType modelPar_NOV=mod.NOV;
  bool modelPar_given_NOV=mod.given("NOV");
  modParamMap["NOV"] = &modelPar_NOV;
  AdmsSensFadType modelPar_NOVD=mod.NOVD;
  bool modelPar_given_NOVD=mod.given("NOVD");
  modParamMap["NOVD"] = &modelPar_NOVD;
  AdmsSensFadType modelPar_CF=mod.CF;
  bool modelPar_given_CF=mod.given("CF");
  modParamMap["CF"] = &modelPar_CF;
  AdmsSensFadType modelPar_CFD=mod.CFD;
  bool modelPar_given_CFD=mod.given("CFD");
  modParamMap["CFD"] = &modelPar_CFD;
  AdmsSensFadType modelPar_CFB=mod.CFB;
  bool modelPar_given_CFB=mod.given("CFB");
  modParamMap["CFB"] = &modelPar_CFB;
  AdmsSensFadType modelPar_PSCE=mod.PSCE;
  bool modelPar_given_PSCE=mod.given("PSCE");
  modParamMap["PSCE"] = &modelPar_PSCE;
  AdmsSensFadType modelPar_PSCEB=mod.PSCEB;
  bool modelPar_given_PSCEB=mod.given("PSCEB");
  modParamMap["PSCEB"] = &modelPar_PSCEB;
  AdmsSensFadType modelPar_PSCED=mod.PSCED;
  bool modelPar_given_PSCED=mod.given("PSCED");
  modParamMap["PSCED"] = &modelPar_PSCED;
  AdmsSensFadType modelPar_BETN=mod.BETN;
  bool modelPar_given_BETN=mod.given("BETN");
  modParamMap["BETN"] = &modelPar_BETN;
  AdmsSensFadType modelPar_STBET=mod.STBET;
  bool modelPar_given_STBET=mod.given("STBET");
  modParamMap["STBET"] = &modelPar_STBET;
  AdmsSensFadType modelPar_MUE=mod.MUE;
  bool modelPar_given_MUE=mod.given("MUE");
  modParamMap["MUE"] = &modelPar_MUE;
  AdmsSensFadType modelPar_STMUE=mod.STMUE;
  bool modelPar_given_STMUE=mod.given("STMUE");
  modParamMap["STMUE"] = &modelPar_STMUE;
  AdmsSensFadType modelPar_THEMU=mod.THEMU;
  bool modelPar_given_THEMU=mod.given("THEMU");
  modParamMap["THEMU"] = &modelPar_THEMU;
  AdmsSensFadType modelPar_STTHEMU=mod.STTHEMU;
  bool modelPar_given_STTHEMU=mod.given("STTHEMU");
  modParamMap["STTHEMU"] = &modelPar_STTHEMU;
  AdmsSensFadType modelPar_CS=mod.CS;
  bool modelPar_given_CS=mod.given("CS");
  modParamMap["CS"] = &modelPar_CS;
  AdmsSensFadType modelPar_STCS=mod.STCS;
  bool modelPar_given_STCS=mod.given("STCS");
  modParamMap["STCS"] = &modelPar_STCS;
  AdmsSensFadType modelPar_XCOR=mod.XCOR;
  bool modelPar_given_XCOR=mod.given("XCOR");
  modParamMap["XCOR"] = &modelPar_XCOR;
  AdmsSensFadType modelPar_STXCOR=mod.STXCOR;
  bool modelPar_given_STXCOR=mod.given("STXCOR");
  modParamMap["STXCOR"] = &modelPar_STXCOR;
  AdmsSensFadType modelPar_FETA=mod.FETA;
  bool modelPar_given_FETA=mod.given("FETA");
  modParamMap["FETA"] = &modelPar_FETA;
  AdmsSensFadType modelPar_RS=mod.RS;
  bool modelPar_given_RS=mod.given("RS");
  modParamMap["RS"] = &modelPar_RS;
  AdmsSensFadType modelPar_STRS=mod.STRS;
  bool modelPar_given_STRS=mod.given("STRS");
  modParamMap["STRS"] = &modelPar_STRS;
  AdmsSensFadType modelPar_RSB=mod.RSB;
  bool modelPar_given_RSB=mod.given("RSB");
  modParamMap["RSB"] = &modelPar_RSB;
  AdmsSensFadType modelPar_RSG=mod.RSG;
  bool modelPar_given_RSG=mod.given("RSG");
  modParamMap["RSG"] = &modelPar_RSG;
  AdmsSensFadType modelPar_THESAT=mod.THESAT;
  bool modelPar_given_THESAT=mod.given("THESAT");
  modParamMap["THESAT"] = &modelPar_THESAT;
  AdmsSensFadType modelPar_STTHESAT=mod.STTHESAT;
  bool modelPar_given_STTHESAT=mod.given("STTHESAT");
  modParamMap["STTHESAT"] = &modelPar_STTHESAT;
  AdmsSensFadType modelPar_THESATB=mod.THESATB;
  bool modelPar_given_THESATB=mod.given("THESATB");
  modParamMap["THESATB"] = &modelPar_THESATB;
  AdmsSensFadType modelPar_THESATG=mod.THESATG;
  bool modelPar_given_THESATG=mod.given("THESATG");
  modParamMap["THESATG"] = &modelPar_THESATG;
  AdmsSensFadType modelPar_AX=mod.AX;
  bool modelPar_given_AX=mod.given("AX");
  modParamMap["AX"] = &modelPar_AX;
  AdmsSensFadType modelPar_ALP=mod.ALP;
  bool modelPar_given_ALP=mod.given("ALP");
  modParamMap["ALP"] = &modelPar_ALP;
  AdmsSensFadType modelPar_ALP1=mod.ALP1;
  bool modelPar_given_ALP1=mod.given("ALP1");
  modParamMap["ALP1"] = &modelPar_ALP1;
  AdmsSensFadType modelPar_ALP2=mod.ALP2;
  bool modelPar_given_ALP2=mod.given("ALP2");
  modParamMap["ALP2"] = &modelPar_ALP2;
  AdmsSensFadType modelPar_VP=mod.VP;
  bool modelPar_given_VP=mod.given("VP");
  modParamMap["VP"] = &modelPar_VP;
  AdmsSensFadType modelPar_A1=mod.A1;
  bool modelPar_given_A1=mod.given("A1");
  modParamMap["A1"] = &modelPar_A1;
  AdmsSensFadType modelPar_A2=mod.A2;
  bool modelPar_given_A2=mod.given("A2");
  modParamMap["A2"] = &modelPar_A2;
  AdmsSensFadType modelPar_STA2=mod.STA2;
  bool modelPar_given_STA2=mod.given("STA2");
  modParamMap["STA2"] = &modelPar_STA2;
  AdmsSensFadType modelPar_A3=mod.A3;
  bool modelPar_given_A3=mod.given("A3");
  modParamMap["A3"] = &modelPar_A3;
  AdmsSensFadType modelPar_A4=mod.A4;
  bool modelPar_given_A4=mod.given("A4");
  modParamMap["A4"] = &modelPar_A4;
  AdmsSensFadType modelPar_GCO=mod.GCO;
  bool modelPar_given_GCO=mod.given("GCO");
  modParamMap["GCO"] = &modelPar_GCO;
  AdmsSensFadType modelPar_IGINV=mod.IGINV;
  bool modelPar_given_IGINV=mod.given("IGINV");
  modParamMap["IGINV"] = &modelPar_IGINV;
  AdmsSensFadType modelPar_IGOV=mod.IGOV;
  bool modelPar_given_IGOV=mod.given("IGOV");
  modParamMap["IGOV"] = &modelPar_IGOV;
  AdmsSensFadType modelPar_IGOVD=mod.IGOVD;
  bool modelPar_given_IGOVD=mod.given("IGOVD");
  modParamMap["IGOVD"] = &modelPar_IGOVD;
  AdmsSensFadType modelPar_STIG=mod.STIG;
  bool modelPar_given_STIG=mod.given("STIG");
  modParamMap["STIG"] = &modelPar_STIG;
  AdmsSensFadType modelPar_GC2=mod.GC2;
  bool modelPar_given_GC2=mod.given("GC2");
  modParamMap["GC2"] = &modelPar_GC2;
  AdmsSensFadType modelPar_GC3=mod.GC3;
  bool modelPar_given_GC3=mod.given("GC3");
  modParamMap["GC3"] = &modelPar_GC3;
  AdmsSensFadType modelPar_CHIB=mod.CHIB;
  bool modelPar_given_CHIB=mod.given("CHIB");
  modParamMap["CHIB"] = &modelPar_CHIB;
  AdmsSensFadType modelPar_AGIDL=mod.AGIDL;
  bool modelPar_given_AGIDL=mod.given("AGIDL");
  modParamMap["AGIDL"] = &modelPar_AGIDL;
  AdmsSensFadType modelPar_AGIDLD=mod.AGIDLD;
  bool modelPar_given_AGIDLD=mod.given("AGIDLD");
  modParamMap["AGIDLD"] = &modelPar_AGIDLD;
  AdmsSensFadType modelPar_BGIDL=mod.BGIDL;
  bool modelPar_given_BGIDL=mod.given("BGIDL");
  modParamMap["BGIDL"] = &modelPar_BGIDL;
  AdmsSensFadType modelPar_BGIDLD=mod.BGIDLD;
  bool modelPar_given_BGIDLD=mod.given("BGIDLD");
  modParamMap["BGIDLD"] = &modelPar_BGIDLD;
  AdmsSensFadType modelPar_STBGIDL=mod.STBGIDL;
  bool modelPar_given_STBGIDL=mod.given("STBGIDL");
  modParamMap["STBGIDL"] = &modelPar_STBGIDL;
  AdmsSensFadType modelPar_STBGIDLD=mod.STBGIDLD;
  bool modelPar_given_STBGIDLD=mod.given("STBGIDLD");
  modParamMap["STBGIDLD"] = &modelPar_STBGIDLD;
  AdmsSensFadType modelPar_CGIDL=mod.CGIDL;
  bool modelPar_given_CGIDL=mod.given("CGIDL");
  modParamMap["CGIDL"] = &modelPar_CGIDL;
  AdmsSensFadType modelPar_CGIDLD=mod.CGIDLD;
  bool modelPar_given_CGIDLD=mod.given("CGIDLD");
  modParamMap["CGIDLD"] = &modelPar_CGIDLD;
  AdmsSensFadType modelPar_COX=mod.COX;
  bool modelPar_given_COX=mod.given("COX");
  modParamMap["COX"] = &modelPar_COX;
  AdmsSensFadType modelPar_CGOV=mod.CGOV;
  bool modelPar_given_CGOV=mod.given("CGOV");
  modParamMap["CGOV"] = &modelPar_CGOV;
  AdmsSensFadType modelPar_CGOVD=mod.CGOVD;
  bool modelPar_given_CGOVD=mod.given("CGOVD");
  modParamMap["CGOVD"] = &modelPar_CGOVD;
  AdmsSensFadType modelPar_CGBOV=mod.CGBOV;
  bool modelPar_given_CGBOV=mod.given("CGBOV");
  modParamMap["CGBOV"] = &modelPar_CGBOV;
  AdmsSensFadType modelPar_CFR=mod.CFR;
  bool modelPar_given_CFR=mod.given("CFR");
  modParamMap["CFR"] = &modelPar_CFR;
  AdmsSensFadType modelPar_CFRD=mod.CFRD;
  bool modelPar_given_CFRD=mod.given("CFRD");
  modParamMap["CFRD"] = &modelPar_CFRD;
  AdmsSensFadType modelPar_FNT=mod.FNT;
  bool modelPar_given_FNT=mod.given("FNT");
  modParamMap["FNT"] = &modelPar_FNT;
  AdmsSensFadType modelPar_FNTEXC=mod.FNTEXC;
  bool modelPar_given_FNTEXC=mod.given("FNTEXC");
  modParamMap["FNTEXC"] = &modelPar_FNTEXC;
  AdmsSensFadType modelPar_NFA=mod.NFA;
  bool modelPar_given_NFA=mod.given("NFA");
  modParamMap["NFA"] = &modelPar_NFA;
  AdmsSensFadType modelPar_NFB=mod.NFB;
  bool modelPar_given_NFB=mod.given("NFB");
  modParamMap["NFB"] = &modelPar_NFB;
  AdmsSensFadType modelPar_NFC=mod.NFC;
  bool modelPar_given_NFC=mod.given("NFC");
  modParamMap["NFC"] = &modelPar_NFC;
  AdmsSensFadType modelPar_EF=mod.EF;
  bool modelPar_given_EF=mod.given("EF");
  modParamMap["EF"] = &modelPar_EF;
  AdmsSensFadType modelPar_VFBEDGE=mod.VFBEDGE;
  bool modelPar_given_VFBEDGE=mod.given("VFBEDGE");
  modParamMap["VFBEDGE"] = &modelPar_VFBEDGE;
  AdmsSensFadType modelPar_STVFBEDGE=mod.STVFBEDGE;
  bool modelPar_given_STVFBEDGE=mod.given("STVFBEDGE");
  modParamMap["STVFBEDGE"] = &modelPar_STVFBEDGE;
  AdmsSensFadType modelPar_DPHIBEDGE=mod.DPHIBEDGE;
  bool modelPar_given_DPHIBEDGE=mod.given("DPHIBEDGE");
  modParamMap["DPHIBEDGE"] = &modelPar_DPHIBEDGE;
  AdmsSensFadType modelPar_NEFFEDGE=mod.NEFFEDGE;
  bool modelPar_given_NEFFEDGE=mod.given("NEFFEDGE");
  modParamMap["NEFFEDGE"] = &modelPar_NEFFEDGE;
  AdmsSensFadType modelPar_CTEDGE=mod.CTEDGE;
  bool modelPar_given_CTEDGE=mod.given("CTEDGE");
  modParamMap["CTEDGE"] = &modelPar_CTEDGE;
  AdmsSensFadType modelPar_BETNEDGE=mod.BETNEDGE;
  bool modelPar_given_BETNEDGE=mod.given("BETNEDGE");
  modParamMap["BETNEDGE"] = &modelPar_BETNEDGE;
  AdmsSensFadType modelPar_STBETEDGE=mod.STBETEDGE;
  bool modelPar_given_STBETEDGE=mod.given("STBETEDGE");
  modParamMap["STBETEDGE"] = &modelPar_STBETEDGE;
  AdmsSensFadType modelPar_PSCEEDGE=mod.PSCEEDGE;
  bool modelPar_given_PSCEEDGE=mod.given("PSCEEDGE");
  modParamMap["PSCEEDGE"] = &modelPar_PSCEEDGE;
  AdmsSensFadType modelPar_PSCEBEDGE=mod.PSCEBEDGE;
  bool modelPar_given_PSCEBEDGE=mod.given("PSCEBEDGE");
  modParamMap["PSCEBEDGE"] = &modelPar_PSCEBEDGE;
  AdmsSensFadType modelPar_PSCEDEDGE=mod.PSCEDEDGE;
  bool modelPar_given_PSCEDEDGE=mod.given("PSCEDEDGE");
  modParamMap["PSCEDEDGE"] = &modelPar_PSCEDEDGE;
  AdmsSensFadType modelPar_CFEDGE=mod.CFEDGE;
  bool modelPar_given_CFEDGE=mod.given("CFEDGE");
  modParamMap["CFEDGE"] = &modelPar_CFEDGE;
  AdmsSensFadType modelPar_CFDEDGE=mod.CFDEDGE;
  bool modelPar_given_CFDEDGE=mod.given("CFDEDGE");
  modParamMap["CFDEDGE"] = &modelPar_CFDEDGE;
  AdmsSensFadType modelPar_CFBEDGE=mod.CFBEDGE;
  bool modelPar_given_CFBEDGE=mod.given("CFBEDGE");
  modParamMap["CFBEDGE"] = &modelPar_CFBEDGE;
  AdmsSensFadType modelPar_FNTEDGE=mod.FNTEDGE;
  bool modelPar_given_FNTEDGE=mod.given("FNTEDGE");
  modParamMap["FNTEDGE"] = &modelPar_FNTEDGE;
  AdmsSensFadType modelPar_NFAEDGE=mod.NFAEDGE;
  bool modelPar_given_NFAEDGE=mod.given("NFAEDGE");
  modParamMap["NFAEDGE"] = &modelPar_NFAEDGE;
  AdmsSensFadType modelPar_NFBEDGE=mod.NFBEDGE;
  bool modelPar_given_NFBEDGE=mod.given("NFBEDGE");
  modParamMap["NFBEDGE"] = &modelPar_NFBEDGE;
  AdmsSensFadType modelPar_NFCEDGE=mod.NFCEDGE;
  bool modelPar_given_NFCEDGE=mod.given("NFCEDGE");
  modParamMap["NFCEDGE"] = &modelPar_NFCEDGE;
  AdmsSensFadType modelPar_EFEDGE=mod.EFEDGE;
  bool modelPar_given_EFEDGE=mod.given("EFEDGE");
  modParamMap["EFEDGE"] = &modelPar_EFEDGE;
  AdmsSensFadType modelPar_RG=mod.RG;
  bool modelPar_given_RG=mod.given("RG");
  modParamMap["RG"] = &modelPar_RG;
  AdmsSensFadType modelPar_RSE=mod.RSE;
  bool modelPar_given_RSE=mod.given("RSE");
  modParamMap["RSE"] = &modelPar_RSE;
  AdmsSensFadType modelPar_RDE=mod.RDE;
  bool modelPar_given_RDE=mod.given("RDE");
  modParamMap["RDE"] = &modelPar_RDE;
  AdmsSensFadType modelPar_RBULK=mod.RBULK;
  bool modelPar_given_RBULK=mod.given("RBULK");
  modParamMap["RBULK"] = &modelPar_RBULK;
  AdmsSensFadType modelPar_RWELL=mod.RWELL;
  bool modelPar_given_RWELL=mod.given("RWELL");
  modParamMap["RWELL"] = &modelPar_RWELL;
  AdmsSensFadType modelPar_RJUNS=mod.RJUNS;
  bool modelPar_given_RJUNS=mod.given("RJUNS");
  modParamMap["RJUNS"] = &modelPar_RJUNS;
  AdmsSensFadType modelPar_RJUND=mod.RJUND;
  bool modelPar_given_RJUND=mod.given("RJUND");
  modParamMap["RJUND"] = &modelPar_RJUND;
  AdmsSensFadType modelPar_POVFB=mod.POVFB;
  bool modelPar_given_POVFB=mod.given("POVFB");
  modParamMap["POVFB"] = &modelPar_POVFB;
  AdmsSensFadType modelPar_PLVFB=mod.PLVFB;
  bool modelPar_given_PLVFB=mod.given("PLVFB");
  modParamMap["PLVFB"] = &modelPar_PLVFB;
  AdmsSensFadType modelPar_PWVFB=mod.PWVFB;
  bool modelPar_given_PWVFB=mod.given("PWVFB");
  modParamMap["PWVFB"] = &modelPar_PWVFB;
  AdmsSensFadType modelPar_PLWVFB=mod.PLWVFB;
  bool modelPar_given_PLWVFB=mod.given("PLWVFB");
  modParamMap["PLWVFB"] = &modelPar_PLWVFB;
  AdmsSensFadType modelPar_POSTVFB=mod.POSTVFB;
  bool modelPar_given_POSTVFB=mod.given("POSTVFB");
  modParamMap["POSTVFB"] = &modelPar_POSTVFB;
  AdmsSensFadType modelPar_PLSTVFB=mod.PLSTVFB;
  bool modelPar_given_PLSTVFB=mod.given("PLSTVFB");
  modParamMap["PLSTVFB"] = &modelPar_PLSTVFB;
  AdmsSensFadType modelPar_PWSTVFB=mod.PWSTVFB;
  bool modelPar_given_PWSTVFB=mod.given("PWSTVFB");
  modParamMap["PWSTVFB"] = &modelPar_PWSTVFB;
  AdmsSensFadType modelPar_PLWSTVFB=mod.PLWSTVFB;
  bool modelPar_given_PLWSTVFB=mod.given("PLWSTVFB");
  modParamMap["PLWSTVFB"] = &modelPar_PLWSTVFB;
  AdmsSensFadType modelPar_POTOX=mod.POTOX;
  bool modelPar_given_POTOX=mod.given("POTOX");
  modParamMap["POTOX"] = &modelPar_POTOX;
  AdmsSensFadType modelPar_POEPSROX=mod.POEPSROX;
  bool modelPar_given_POEPSROX=mod.given("POEPSROX");
  modParamMap["POEPSROX"] = &modelPar_POEPSROX;
  AdmsSensFadType modelPar_PONEFF=mod.PONEFF;
  bool modelPar_given_PONEFF=mod.given("PONEFF");
  modParamMap["PONEFF"] = &modelPar_PONEFF;
  AdmsSensFadType modelPar_PLNEFF=mod.PLNEFF;
  bool modelPar_given_PLNEFF=mod.given("PLNEFF");
  modParamMap["PLNEFF"] = &modelPar_PLNEFF;
  AdmsSensFadType modelPar_PWNEFF=mod.PWNEFF;
  bool modelPar_given_PWNEFF=mod.given("PWNEFF");
  modParamMap["PWNEFF"] = &modelPar_PWNEFF;
  AdmsSensFadType modelPar_PLWNEFF=mod.PLWNEFF;
  bool modelPar_given_PLWNEFF=mod.given("PLWNEFF");
  modParamMap["PLWNEFF"] = &modelPar_PLWNEFF;
  AdmsSensFadType modelPar_POFACNEFFAC=mod.POFACNEFFAC;
  bool modelPar_given_POFACNEFFAC=mod.given("POFACNEFFAC");
  modParamMap["POFACNEFFAC"] = &modelPar_POFACNEFFAC;
  AdmsSensFadType modelPar_PLFACNEFFAC=mod.PLFACNEFFAC;
  bool modelPar_given_PLFACNEFFAC=mod.given("PLFACNEFFAC");
  modParamMap["PLFACNEFFAC"] = &modelPar_PLFACNEFFAC;
  AdmsSensFadType modelPar_PWFACNEFFAC=mod.PWFACNEFFAC;
  bool modelPar_given_PWFACNEFFAC=mod.given("PWFACNEFFAC");
  modParamMap["PWFACNEFFAC"] = &modelPar_PWFACNEFFAC;
  AdmsSensFadType modelPar_PLWFACNEFFAC=mod.PLWFACNEFFAC;
  bool modelPar_given_PLWFACNEFFAC=mod.given("PLWFACNEFFAC");
  modParamMap["PLWFACNEFFAC"] = &modelPar_PLWFACNEFFAC;
  AdmsSensFadType modelPar_POGFACNUD=mod.POGFACNUD;
  bool modelPar_given_POGFACNUD=mod.given("POGFACNUD");
  modParamMap["POGFACNUD"] = &modelPar_POGFACNUD;
  AdmsSensFadType modelPar_PLGFACNUD=mod.PLGFACNUD;
  bool modelPar_given_PLGFACNUD=mod.given("PLGFACNUD");
  modParamMap["PLGFACNUD"] = &modelPar_PLGFACNUD;
  AdmsSensFadType modelPar_PWGFACNUD=mod.PWGFACNUD;
  bool modelPar_given_PWGFACNUD=mod.given("PWGFACNUD");
  modParamMap["PWGFACNUD"] = &modelPar_PWGFACNUD;
  AdmsSensFadType modelPar_PLWGFACNUD=mod.PLWGFACNUD;
  bool modelPar_given_PLWGFACNUD=mod.given("PLWGFACNUD");
  modParamMap["PLWGFACNUD"] = &modelPar_PLWGFACNUD;
  AdmsSensFadType modelPar_POVSBNUD=mod.POVSBNUD;
  bool modelPar_given_POVSBNUD=mod.given("POVSBNUD");
  modParamMap["POVSBNUD"] = &modelPar_POVSBNUD;
  AdmsSensFadType modelPar_PODVSBNUD=mod.PODVSBNUD;
  bool modelPar_given_PODVSBNUD=mod.given("PODVSBNUD");
  modParamMap["PODVSBNUD"] = &modelPar_PODVSBNUD;
  AdmsSensFadType modelPar_POVNSUB=mod.POVNSUB;
  bool modelPar_given_POVNSUB=mod.given("POVNSUB");
  modParamMap["POVNSUB"] = &modelPar_POVNSUB;
  AdmsSensFadType modelPar_PONSLP=mod.PONSLP;
  bool modelPar_given_PONSLP=mod.given("PONSLP");
  modParamMap["PONSLP"] = &modelPar_PONSLP;
  AdmsSensFadType modelPar_PODNSUB=mod.PODNSUB;
  bool modelPar_given_PODNSUB=mod.given("PODNSUB");
  modParamMap["PODNSUB"] = &modelPar_PODNSUB;
  AdmsSensFadType modelPar_PODPHIB=mod.PODPHIB;
  bool modelPar_given_PODPHIB=mod.given("PODPHIB");
  modParamMap["PODPHIB"] = &modelPar_PODPHIB;
  AdmsSensFadType modelPar_PLDPHIB=mod.PLDPHIB;
  bool modelPar_given_PLDPHIB=mod.given("PLDPHIB");
  modParamMap["PLDPHIB"] = &modelPar_PLDPHIB;
  AdmsSensFadType modelPar_PWDPHIB=mod.PWDPHIB;
  bool modelPar_given_PWDPHIB=mod.given("PWDPHIB");
  modParamMap["PWDPHIB"] = &modelPar_PWDPHIB;
  AdmsSensFadType modelPar_PLWDPHIB=mod.PLWDPHIB;
  bool modelPar_given_PLWDPHIB=mod.given("PLWDPHIB");
  modParamMap["PLWDPHIB"] = &modelPar_PLWDPHIB;
  AdmsSensFadType modelPar_PODELVTAC=mod.PODELVTAC;
  bool modelPar_given_PODELVTAC=mod.given("PODELVTAC");
  modParamMap["PODELVTAC"] = &modelPar_PODELVTAC;
  AdmsSensFadType modelPar_PLDELVTAC=mod.PLDELVTAC;
  bool modelPar_given_PLDELVTAC=mod.given("PLDELVTAC");
  modParamMap["PLDELVTAC"] = &modelPar_PLDELVTAC;
  AdmsSensFadType modelPar_PWDELVTAC=mod.PWDELVTAC;
  bool modelPar_given_PWDELVTAC=mod.given("PWDELVTAC");
  modParamMap["PWDELVTAC"] = &modelPar_PWDELVTAC;
  AdmsSensFadType modelPar_PLWDELVTAC=mod.PLWDELVTAC;
  bool modelPar_given_PLWDELVTAC=mod.given("PLWDELVTAC");
  modParamMap["PLWDELVTAC"] = &modelPar_PLWDELVTAC;
  AdmsSensFadType modelPar_PONP=mod.PONP;
  bool modelPar_given_PONP=mod.given("PONP");
  modParamMap["PONP"] = &modelPar_PONP;
  AdmsSensFadType modelPar_PLNP=mod.PLNP;
  bool modelPar_given_PLNP=mod.given("PLNP");
  modParamMap["PLNP"] = &modelPar_PLNP;
  AdmsSensFadType modelPar_PWNP=mod.PWNP;
  bool modelPar_given_PWNP=mod.given("PWNP");
  modParamMap["PWNP"] = &modelPar_PWNP;
  AdmsSensFadType modelPar_PLWNP=mod.PLWNP;
  bool modelPar_given_PLWNP=mod.given("PLWNP");
  modParamMap["PLWNP"] = &modelPar_PLWNP;
  AdmsSensFadType modelPar_POCT=mod.POCT;
  bool modelPar_given_POCT=mod.given("POCT");
  modParamMap["POCT"] = &modelPar_POCT;
  AdmsSensFadType modelPar_PLCT=mod.PLCT;
  bool modelPar_given_PLCT=mod.given("PLCT");
  modParamMap["PLCT"] = &modelPar_PLCT;
  AdmsSensFadType modelPar_PWCT=mod.PWCT;
  bool modelPar_given_PWCT=mod.given("PWCT");
  modParamMap["PWCT"] = &modelPar_PWCT;
  AdmsSensFadType modelPar_PLWCT=mod.PLWCT;
  bool modelPar_given_PLWCT=mod.given("PLWCT");
  modParamMap["PLWCT"] = &modelPar_PLWCT;
  AdmsSensFadType modelPar_POTOXOV=mod.POTOXOV;
  bool modelPar_given_POTOXOV=mod.given("POTOXOV");
  modParamMap["POTOXOV"] = &modelPar_POTOXOV;
  AdmsSensFadType modelPar_POTOXOVD=mod.POTOXOVD;
  bool modelPar_given_POTOXOVD=mod.given("POTOXOVD");
  modParamMap["POTOXOVD"] = &modelPar_POTOXOVD;
  AdmsSensFadType modelPar_PONOV=mod.PONOV;
  bool modelPar_given_PONOV=mod.given("PONOV");
  modParamMap["PONOV"] = &modelPar_PONOV;
  AdmsSensFadType modelPar_PLNOV=mod.PLNOV;
  bool modelPar_given_PLNOV=mod.given("PLNOV");
  modParamMap["PLNOV"] = &modelPar_PLNOV;
  AdmsSensFadType modelPar_PWNOV=mod.PWNOV;
  bool modelPar_given_PWNOV=mod.given("PWNOV");
  modParamMap["PWNOV"] = &modelPar_PWNOV;
  AdmsSensFadType modelPar_PLWNOV=mod.PLWNOV;
  bool modelPar_given_PLWNOV=mod.given("PLWNOV");
  modParamMap["PLWNOV"] = &modelPar_PLWNOV;
  AdmsSensFadType modelPar_PONOVD=mod.PONOVD;
  bool modelPar_given_PONOVD=mod.given("PONOVD");
  modParamMap["PONOVD"] = &modelPar_PONOVD;
  AdmsSensFadType modelPar_PLNOVD=mod.PLNOVD;
  bool modelPar_given_PLNOVD=mod.given("PLNOVD");
  modParamMap["PLNOVD"] = &modelPar_PLNOVD;
  AdmsSensFadType modelPar_PWNOVD=mod.PWNOVD;
  bool modelPar_given_PWNOVD=mod.given("PWNOVD");
  modParamMap["PWNOVD"] = &modelPar_PWNOVD;
  AdmsSensFadType modelPar_PLWNOVD=mod.PLWNOVD;
  bool modelPar_given_PLWNOVD=mod.given("PLWNOVD");
  modParamMap["PLWNOVD"] = &modelPar_PLWNOVD;
  AdmsSensFadType modelPar_POCF=mod.POCF;
  bool modelPar_given_POCF=mod.given("POCF");
  modParamMap["POCF"] = &modelPar_POCF;
  AdmsSensFadType modelPar_PLCF=mod.PLCF;
  bool modelPar_given_PLCF=mod.given("PLCF");
  modParamMap["PLCF"] = &modelPar_PLCF;
  AdmsSensFadType modelPar_PWCF=mod.PWCF;
  bool modelPar_given_PWCF=mod.given("PWCF");
  modParamMap["PWCF"] = &modelPar_PWCF;
  AdmsSensFadType modelPar_PLWCF=mod.PLWCF;
  bool modelPar_given_PLWCF=mod.given("PLWCF");
  modParamMap["PLWCF"] = &modelPar_PLWCF;
  AdmsSensFadType modelPar_POCFD=mod.POCFD;
  bool modelPar_given_POCFD=mod.given("POCFD");
  modParamMap["POCFD"] = &modelPar_POCFD;
  AdmsSensFadType modelPar_POCFB=mod.POCFB;
  bool modelPar_given_POCFB=mod.given("POCFB");
  modParamMap["POCFB"] = &modelPar_POCFB;
  AdmsSensFadType modelPar_POPSCE=mod.POPSCE;
  bool modelPar_given_POPSCE=mod.given("POPSCE");
  modParamMap["POPSCE"] = &modelPar_POPSCE;
  AdmsSensFadType modelPar_PLPSCE=mod.PLPSCE;
  bool modelPar_given_PLPSCE=mod.given("PLPSCE");
  modParamMap["PLPSCE"] = &modelPar_PLPSCE;
  AdmsSensFadType modelPar_PWPSCE=mod.PWPSCE;
  bool modelPar_given_PWPSCE=mod.given("PWPSCE");
  modParamMap["PWPSCE"] = &modelPar_PWPSCE;
  AdmsSensFadType modelPar_PLWPSCE=mod.PLWPSCE;
  bool modelPar_given_PLWPSCE=mod.given("PLWPSCE");
  modParamMap["PLWPSCE"] = &modelPar_PLWPSCE;
  AdmsSensFadType modelPar_POPSCEB=mod.POPSCEB;
  bool modelPar_given_POPSCEB=mod.given("POPSCEB");
  modParamMap["POPSCEB"] = &modelPar_POPSCEB;
  AdmsSensFadType modelPar_POPSCED=mod.POPSCED;
  bool modelPar_given_POPSCED=mod.given("POPSCED");
  modParamMap["POPSCED"] = &modelPar_POPSCED;
  AdmsSensFadType modelPar_POBETN=mod.POBETN;
  bool modelPar_given_POBETN=mod.given("POBETN");
  modParamMap["POBETN"] = &modelPar_POBETN;
  AdmsSensFadType modelPar_PLBETN=mod.PLBETN;
  bool modelPar_given_PLBETN=mod.given("PLBETN");
  modParamMap["PLBETN"] = &modelPar_PLBETN;
  AdmsSensFadType modelPar_PWBETN=mod.PWBETN;
  bool modelPar_given_PWBETN=mod.given("PWBETN");
  modParamMap["PWBETN"] = &modelPar_PWBETN;
  AdmsSensFadType modelPar_PLWBETN=mod.PLWBETN;
  bool modelPar_given_PLWBETN=mod.given("PLWBETN");
  modParamMap["PLWBETN"] = &modelPar_PLWBETN;
  AdmsSensFadType modelPar_POSTBET=mod.POSTBET;
  bool modelPar_given_POSTBET=mod.given("POSTBET");
  modParamMap["POSTBET"] = &modelPar_POSTBET;
  AdmsSensFadType modelPar_PLSTBET=mod.PLSTBET;
  bool modelPar_given_PLSTBET=mod.given("PLSTBET");
  modParamMap["PLSTBET"] = &modelPar_PLSTBET;
  AdmsSensFadType modelPar_PWSTBET=mod.PWSTBET;
  bool modelPar_given_PWSTBET=mod.given("PWSTBET");
  modParamMap["PWSTBET"] = &modelPar_PWSTBET;
  AdmsSensFadType modelPar_PLWSTBET=mod.PLWSTBET;
  bool modelPar_given_PLWSTBET=mod.given("PLWSTBET");
  modParamMap["PLWSTBET"] = &modelPar_PLWSTBET;
  AdmsSensFadType modelPar_POMUE=mod.POMUE;
  bool modelPar_given_POMUE=mod.given("POMUE");
  modParamMap["POMUE"] = &modelPar_POMUE;
  AdmsSensFadType modelPar_PLMUE=mod.PLMUE;
  bool modelPar_given_PLMUE=mod.given("PLMUE");
  modParamMap["PLMUE"] = &modelPar_PLMUE;
  AdmsSensFadType modelPar_PWMUE=mod.PWMUE;
  bool modelPar_given_PWMUE=mod.given("PWMUE");
  modParamMap["PWMUE"] = &modelPar_PWMUE;
  AdmsSensFadType modelPar_PLWMUE=mod.PLWMUE;
  bool modelPar_given_PLWMUE=mod.given("PLWMUE");
  modParamMap["PLWMUE"] = &modelPar_PLWMUE;
  AdmsSensFadType modelPar_POSTMUE=mod.POSTMUE;
  bool modelPar_given_POSTMUE=mod.given("POSTMUE");
  modParamMap["POSTMUE"] = &modelPar_POSTMUE;
  AdmsSensFadType modelPar_POTHEMU=mod.POTHEMU;
  bool modelPar_given_POTHEMU=mod.given("POTHEMU");
  modParamMap["POTHEMU"] = &modelPar_POTHEMU;
  AdmsSensFadType modelPar_POSTTHEMU=mod.POSTTHEMU;
  bool modelPar_given_POSTTHEMU=mod.given("POSTTHEMU");
  modParamMap["POSTTHEMU"] = &modelPar_POSTTHEMU;
  AdmsSensFadType modelPar_POCS=mod.POCS;
  bool modelPar_given_POCS=mod.given("POCS");
  modParamMap["POCS"] = &modelPar_POCS;
  AdmsSensFadType modelPar_PLCS=mod.PLCS;
  bool modelPar_given_PLCS=mod.given("PLCS");
  modParamMap["PLCS"] = &modelPar_PLCS;
  AdmsSensFadType modelPar_PWCS=mod.PWCS;
  bool modelPar_given_PWCS=mod.given("PWCS");
  modParamMap["PWCS"] = &modelPar_PWCS;
  AdmsSensFadType modelPar_PLWCS=mod.PLWCS;
  bool modelPar_given_PLWCS=mod.given("PLWCS");
  modParamMap["PLWCS"] = &modelPar_PLWCS;
  AdmsSensFadType modelPar_POSTCS=mod.POSTCS;
  bool modelPar_given_POSTCS=mod.given("POSTCS");
  modParamMap["POSTCS"] = &modelPar_POSTCS;
  AdmsSensFadType modelPar_POXCOR=mod.POXCOR;
  bool modelPar_given_POXCOR=mod.given("POXCOR");
  modParamMap["POXCOR"] = &modelPar_POXCOR;
  AdmsSensFadType modelPar_PLXCOR=mod.PLXCOR;
  bool modelPar_given_PLXCOR=mod.given("PLXCOR");
  modParamMap["PLXCOR"] = &modelPar_PLXCOR;
  AdmsSensFadType modelPar_PWXCOR=mod.PWXCOR;
  bool modelPar_given_PWXCOR=mod.given("PWXCOR");
  modParamMap["PWXCOR"] = &modelPar_PWXCOR;
  AdmsSensFadType modelPar_PLWXCOR=mod.PLWXCOR;
  bool modelPar_given_PLWXCOR=mod.given("PLWXCOR");
  modParamMap["PLWXCOR"] = &modelPar_PLWXCOR;
  AdmsSensFadType modelPar_POSTXCOR=mod.POSTXCOR;
  bool modelPar_given_POSTXCOR=mod.given("POSTXCOR");
  modParamMap["POSTXCOR"] = &modelPar_POSTXCOR;
  AdmsSensFadType modelPar_POFETA=mod.POFETA;
  bool modelPar_given_POFETA=mod.given("POFETA");
  modParamMap["POFETA"] = &modelPar_POFETA;
  AdmsSensFadType modelPar_PORS=mod.PORS;
  bool modelPar_given_PORS=mod.given("PORS");
  modParamMap["PORS"] = &modelPar_PORS;
  AdmsSensFadType modelPar_PLRS=mod.PLRS;
  bool modelPar_given_PLRS=mod.given("PLRS");
  modParamMap["PLRS"] = &modelPar_PLRS;
  AdmsSensFadType modelPar_PWRS=mod.PWRS;
  bool modelPar_given_PWRS=mod.given("PWRS");
  modParamMap["PWRS"] = &modelPar_PWRS;
  AdmsSensFadType modelPar_PLWRS=mod.PLWRS;
  bool modelPar_given_PLWRS=mod.given("PLWRS");
  modParamMap["PLWRS"] = &modelPar_PLWRS;
  AdmsSensFadType modelPar_POSTRS=mod.POSTRS;
  bool modelPar_given_POSTRS=mod.given("POSTRS");
  modParamMap["POSTRS"] = &modelPar_POSTRS;
  AdmsSensFadType modelPar_PORSB=mod.PORSB;
  bool modelPar_given_PORSB=mod.given("PORSB");
  modParamMap["PORSB"] = &modelPar_PORSB;
  AdmsSensFadType modelPar_PORSG=mod.PORSG;
  bool modelPar_given_PORSG=mod.given("PORSG");
  modParamMap["PORSG"] = &modelPar_PORSG;
  AdmsSensFadType modelPar_POTHESAT=mod.POTHESAT;
  bool modelPar_given_POTHESAT=mod.given("POTHESAT");
  modParamMap["POTHESAT"] = &modelPar_POTHESAT;
  AdmsSensFadType modelPar_PLTHESAT=mod.PLTHESAT;
  bool modelPar_given_PLTHESAT=mod.given("PLTHESAT");
  modParamMap["PLTHESAT"] = &modelPar_PLTHESAT;
  AdmsSensFadType modelPar_PWTHESAT=mod.PWTHESAT;
  bool modelPar_given_PWTHESAT=mod.given("PWTHESAT");
  modParamMap["PWTHESAT"] = &modelPar_PWTHESAT;
  AdmsSensFadType modelPar_PLWTHESAT=mod.PLWTHESAT;
  bool modelPar_given_PLWTHESAT=mod.given("PLWTHESAT");
  modParamMap["PLWTHESAT"] = &modelPar_PLWTHESAT;
  AdmsSensFadType modelPar_POSTTHESAT=mod.POSTTHESAT;
  bool modelPar_given_POSTTHESAT=mod.given("POSTTHESAT");
  modParamMap["POSTTHESAT"] = &modelPar_POSTTHESAT;
  AdmsSensFadType modelPar_PLSTTHESAT=mod.PLSTTHESAT;
  bool modelPar_given_PLSTTHESAT=mod.given("PLSTTHESAT");
  modParamMap["PLSTTHESAT"] = &modelPar_PLSTTHESAT;
  AdmsSensFadType modelPar_PWSTTHESAT=mod.PWSTTHESAT;
  bool modelPar_given_PWSTTHESAT=mod.given("PWSTTHESAT");
  modParamMap["PWSTTHESAT"] = &modelPar_PWSTTHESAT;
  AdmsSensFadType modelPar_PLWSTTHESAT=mod.PLWSTTHESAT;
  bool modelPar_given_PLWSTTHESAT=mod.given("PLWSTTHESAT");
  modParamMap["PLWSTTHESAT"] = &modelPar_PLWSTTHESAT;
  AdmsSensFadType modelPar_POTHESATB=mod.POTHESATB;
  bool modelPar_given_POTHESATB=mod.given("POTHESATB");
  modParamMap["POTHESATB"] = &modelPar_POTHESATB;
  AdmsSensFadType modelPar_PLTHESATB=mod.PLTHESATB;
  bool modelPar_given_PLTHESATB=mod.given("PLTHESATB");
  modParamMap["PLTHESATB"] = &modelPar_PLTHESATB;
  AdmsSensFadType modelPar_PWTHESATB=mod.PWTHESATB;
  bool modelPar_given_PWTHESATB=mod.given("PWTHESATB");
  modParamMap["PWTHESATB"] = &modelPar_PWTHESATB;
  AdmsSensFadType modelPar_PLWTHESATB=mod.PLWTHESATB;
  bool modelPar_given_PLWTHESATB=mod.given("PLWTHESATB");
  modParamMap["PLWTHESATB"] = &modelPar_PLWTHESATB;
  AdmsSensFadType modelPar_POTHESATG=mod.POTHESATG;
  bool modelPar_given_POTHESATG=mod.given("POTHESATG");
  modParamMap["POTHESATG"] = &modelPar_POTHESATG;
  AdmsSensFadType modelPar_PLTHESATG=mod.PLTHESATG;
  bool modelPar_given_PLTHESATG=mod.given("PLTHESATG");
  modParamMap["PLTHESATG"] = &modelPar_PLTHESATG;
  AdmsSensFadType modelPar_PWTHESATG=mod.PWTHESATG;
  bool modelPar_given_PWTHESATG=mod.given("PWTHESATG");
  modParamMap["PWTHESATG"] = &modelPar_PWTHESATG;
  AdmsSensFadType modelPar_PLWTHESATG=mod.PLWTHESATG;
  bool modelPar_given_PLWTHESATG=mod.given("PLWTHESATG");
  modParamMap["PLWTHESATG"] = &modelPar_PLWTHESATG;
  AdmsSensFadType modelPar_POAX=mod.POAX;
  bool modelPar_given_POAX=mod.given("POAX");
  modParamMap["POAX"] = &modelPar_POAX;
  AdmsSensFadType modelPar_PLAX=mod.PLAX;
  bool modelPar_given_PLAX=mod.given("PLAX");
  modParamMap["PLAX"] = &modelPar_PLAX;
  AdmsSensFadType modelPar_PWAX=mod.PWAX;
  bool modelPar_given_PWAX=mod.given("PWAX");
  modParamMap["PWAX"] = &modelPar_PWAX;
  AdmsSensFadType modelPar_PLWAX=mod.PLWAX;
  bool modelPar_given_PLWAX=mod.given("PLWAX");
  modParamMap["PLWAX"] = &modelPar_PLWAX;
  AdmsSensFadType modelPar_POALP=mod.POALP;
  bool modelPar_given_POALP=mod.given("POALP");
  modParamMap["POALP"] = &modelPar_POALP;
  AdmsSensFadType modelPar_PLALP=mod.PLALP;
  bool modelPar_given_PLALP=mod.given("PLALP");
  modParamMap["PLALP"] = &modelPar_PLALP;
  AdmsSensFadType modelPar_PWALP=mod.PWALP;
  bool modelPar_given_PWALP=mod.given("PWALP");
  modParamMap["PWALP"] = &modelPar_PWALP;
  AdmsSensFadType modelPar_PLWALP=mod.PLWALP;
  bool modelPar_given_PLWALP=mod.given("PLWALP");
  modParamMap["PLWALP"] = &modelPar_PLWALP;
  AdmsSensFadType modelPar_POALP1=mod.POALP1;
  bool modelPar_given_POALP1=mod.given("POALP1");
  modParamMap["POALP1"] = &modelPar_POALP1;
  AdmsSensFadType modelPar_PLALP1=mod.PLALP1;
  bool modelPar_given_PLALP1=mod.given("PLALP1");
  modParamMap["PLALP1"] = &modelPar_PLALP1;
  AdmsSensFadType modelPar_PWALP1=mod.PWALP1;
  bool modelPar_given_PWALP1=mod.given("PWALP1");
  modParamMap["PWALP1"] = &modelPar_PWALP1;
  AdmsSensFadType modelPar_PLWALP1=mod.PLWALP1;
  bool modelPar_given_PLWALP1=mod.given("PLWALP1");
  modParamMap["PLWALP1"] = &modelPar_PLWALP1;
  AdmsSensFadType modelPar_POALP2=mod.POALP2;
  bool modelPar_given_POALP2=mod.given("POALP2");
  modParamMap["POALP2"] = &modelPar_POALP2;
  AdmsSensFadType modelPar_PLALP2=mod.PLALP2;
  bool modelPar_given_PLALP2=mod.given("PLALP2");
  modParamMap["PLALP2"] = &modelPar_PLALP2;
  AdmsSensFadType modelPar_PWALP2=mod.PWALP2;
  bool modelPar_given_PWALP2=mod.given("PWALP2");
  modParamMap["PWALP2"] = &modelPar_PWALP2;
  AdmsSensFadType modelPar_PLWALP2=mod.PLWALP2;
  bool modelPar_given_PLWALP2=mod.given("PLWALP2");
  modParamMap["PLWALP2"] = &modelPar_PLWALP2;
  AdmsSensFadType modelPar_POVP=mod.POVP;
  bool modelPar_given_POVP=mod.given("POVP");
  modParamMap["POVP"] = &modelPar_POVP;
  AdmsSensFadType modelPar_POA1=mod.POA1;
  bool modelPar_given_POA1=mod.given("POA1");
  modParamMap["POA1"] = &modelPar_POA1;
  AdmsSensFadType modelPar_PLA1=mod.PLA1;
  bool modelPar_given_PLA1=mod.given("PLA1");
  modParamMap["PLA1"] = &modelPar_PLA1;
  AdmsSensFadType modelPar_PWA1=mod.PWA1;
  bool modelPar_given_PWA1=mod.given("PWA1");
  modParamMap["PWA1"] = &modelPar_PWA1;
  AdmsSensFadType modelPar_PLWA1=mod.PLWA1;
  bool modelPar_given_PLWA1=mod.given("PLWA1");
  modParamMap["PLWA1"] = &modelPar_PLWA1;
  AdmsSensFadType modelPar_POA2=mod.POA2;
  bool modelPar_given_POA2=mod.given("POA2");
  modParamMap["POA2"] = &modelPar_POA2;
  AdmsSensFadType modelPar_POSTA2=mod.POSTA2;
  bool modelPar_given_POSTA2=mod.given("POSTA2");
  modParamMap["POSTA2"] = &modelPar_POSTA2;
  AdmsSensFadType modelPar_POA3=mod.POA3;
  bool modelPar_given_POA3=mod.given("POA3");
  modParamMap["POA3"] = &modelPar_POA3;
  AdmsSensFadType modelPar_PLA3=mod.PLA3;
  bool modelPar_given_PLA3=mod.given("PLA3");
  modParamMap["PLA3"] = &modelPar_PLA3;
  AdmsSensFadType modelPar_PWA3=mod.PWA3;
  bool modelPar_given_PWA3=mod.given("PWA3");
  modParamMap["PWA3"] = &modelPar_PWA3;
  AdmsSensFadType modelPar_PLWA3=mod.PLWA3;
  bool modelPar_given_PLWA3=mod.given("PLWA3");
  modParamMap["PLWA3"] = &modelPar_PLWA3;
  AdmsSensFadType modelPar_POA4=mod.POA4;
  bool modelPar_given_POA4=mod.given("POA4");
  modParamMap["POA4"] = &modelPar_POA4;
  AdmsSensFadType modelPar_PLA4=mod.PLA4;
  bool modelPar_given_PLA4=mod.given("PLA4");
  modParamMap["PLA4"] = &modelPar_PLA4;
  AdmsSensFadType modelPar_PWA4=mod.PWA4;
  bool modelPar_given_PWA4=mod.given("PWA4");
  modParamMap["PWA4"] = &modelPar_PWA4;
  AdmsSensFadType modelPar_PLWA4=mod.PLWA4;
  bool modelPar_given_PLWA4=mod.given("PLWA4");
  modParamMap["PLWA4"] = &modelPar_PLWA4;
  AdmsSensFadType modelPar_POGCO=mod.POGCO;
  bool modelPar_given_POGCO=mod.given("POGCO");
  modParamMap["POGCO"] = &modelPar_POGCO;
  AdmsSensFadType modelPar_POIGINV=mod.POIGINV;
  bool modelPar_given_POIGINV=mod.given("POIGINV");
  modParamMap["POIGINV"] = &modelPar_POIGINV;
  AdmsSensFadType modelPar_PLIGINV=mod.PLIGINV;
  bool modelPar_given_PLIGINV=mod.given("PLIGINV");
  modParamMap["PLIGINV"] = &modelPar_PLIGINV;
  AdmsSensFadType modelPar_PWIGINV=mod.PWIGINV;
  bool modelPar_given_PWIGINV=mod.given("PWIGINV");
  modParamMap["PWIGINV"] = &modelPar_PWIGINV;
  AdmsSensFadType modelPar_PLWIGINV=mod.PLWIGINV;
  bool modelPar_given_PLWIGINV=mod.given("PLWIGINV");
  modParamMap["PLWIGINV"] = &modelPar_PLWIGINV;
  AdmsSensFadType modelPar_POIGOV=mod.POIGOV;
  bool modelPar_given_POIGOV=mod.given("POIGOV");
  modParamMap["POIGOV"] = &modelPar_POIGOV;
  AdmsSensFadType modelPar_PLIGOV=mod.PLIGOV;
  bool modelPar_given_PLIGOV=mod.given("PLIGOV");
  modParamMap["PLIGOV"] = &modelPar_PLIGOV;
  AdmsSensFadType modelPar_PWIGOV=mod.PWIGOV;
  bool modelPar_given_PWIGOV=mod.given("PWIGOV");
  modParamMap["PWIGOV"] = &modelPar_PWIGOV;
  AdmsSensFadType modelPar_PLWIGOV=mod.PLWIGOV;
  bool modelPar_given_PLWIGOV=mod.given("PLWIGOV");
  modParamMap["PLWIGOV"] = &modelPar_PLWIGOV;
  AdmsSensFadType modelPar_POIGOVD=mod.POIGOVD;
  bool modelPar_given_POIGOVD=mod.given("POIGOVD");
  modParamMap["POIGOVD"] = &modelPar_POIGOVD;
  AdmsSensFadType modelPar_PLIGOVD=mod.PLIGOVD;
  bool modelPar_given_PLIGOVD=mod.given("PLIGOVD");
  modParamMap["PLIGOVD"] = &modelPar_PLIGOVD;
  AdmsSensFadType modelPar_PWIGOVD=mod.PWIGOVD;
  bool modelPar_given_PWIGOVD=mod.given("PWIGOVD");
  modParamMap["PWIGOVD"] = &modelPar_PWIGOVD;
  AdmsSensFadType modelPar_PLWIGOVD=mod.PLWIGOVD;
  bool modelPar_given_PLWIGOVD=mod.given("PLWIGOVD");
  modParamMap["PLWIGOVD"] = &modelPar_PLWIGOVD;
  AdmsSensFadType modelPar_POSTIG=mod.POSTIG;
  bool modelPar_given_POSTIG=mod.given("POSTIG");
  modParamMap["POSTIG"] = &modelPar_POSTIG;
  AdmsSensFadType modelPar_POGC2=mod.POGC2;
  bool modelPar_given_POGC2=mod.given("POGC2");
  modParamMap["POGC2"] = &modelPar_POGC2;
  AdmsSensFadType modelPar_POGC3=mod.POGC3;
  bool modelPar_given_POGC3=mod.given("POGC3");
  modParamMap["POGC3"] = &modelPar_POGC3;
  AdmsSensFadType modelPar_POCHIB=mod.POCHIB;
  bool modelPar_given_POCHIB=mod.given("POCHIB");
  modParamMap["POCHIB"] = &modelPar_POCHIB;
  AdmsSensFadType modelPar_POAGIDL=mod.POAGIDL;
  bool modelPar_given_POAGIDL=mod.given("POAGIDL");
  modParamMap["POAGIDL"] = &modelPar_POAGIDL;
  AdmsSensFadType modelPar_PLAGIDL=mod.PLAGIDL;
  bool modelPar_given_PLAGIDL=mod.given("PLAGIDL");
  modParamMap["PLAGIDL"] = &modelPar_PLAGIDL;
  AdmsSensFadType modelPar_PWAGIDL=mod.PWAGIDL;
  bool modelPar_given_PWAGIDL=mod.given("PWAGIDL");
  modParamMap["PWAGIDL"] = &modelPar_PWAGIDL;
  AdmsSensFadType modelPar_PLWAGIDL=mod.PLWAGIDL;
  bool modelPar_given_PLWAGIDL=mod.given("PLWAGIDL");
  modParamMap["PLWAGIDL"] = &modelPar_PLWAGIDL;
  AdmsSensFadType modelPar_POAGIDLD=mod.POAGIDLD;
  bool modelPar_given_POAGIDLD=mod.given("POAGIDLD");
  modParamMap["POAGIDLD"] = &modelPar_POAGIDLD;
  AdmsSensFadType modelPar_PLAGIDLD=mod.PLAGIDLD;
  bool modelPar_given_PLAGIDLD=mod.given("PLAGIDLD");
  modParamMap["PLAGIDLD"] = &modelPar_PLAGIDLD;
  AdmsSensFadType modelPar_PWAGIDLD=mod.PWAGIDLD;
  bool modelPar_given_PWAGIDLD=mod.given("PWAGIDLD");
  modParamMap["PWAGIDLD"] = &modelPar_PWAGIDLD;
  AdmsSensFadType modelPar_PLWAGIDLD=mod.PLWAGIDLD;
  bool modelPar_given_PLWAGIDLD=mod.given("PLWAGIDLD");
  modParamMap["PLWAGIDLD"] = &modelPar_PLWAGIDLD;
  AdmsSensFadType modelPar_POBGIDL=mod.POBGIDL;
  bool modelPar_given_POBGIDL=mod.given("POBGIDL");
  modParamMap["POBGIDL"] = &modelPar_POBGIDL;
  AdmsSensFadType modelPar_POBGIDLD=mod.POBGIDLD;
  bool modelPar_given_POBGIDLD=mod.given("POBGIDLD");
  modParamMap["POBGIDLD"] = &modelPar_POBGIDLD;
  AdmsSensFadType modelPar_POSTBGIDL=mod.POSTBGIDL;
  bool modelPar_given_POSTBGIDL=mod.given("POSTBGIDL");
  modParamMap["POSTBGIDL"] = &modelPar_POSTBGIDL;
  AdmsSensFadType modelPar_POSTBGIDLD=mod.POSTBGIDLD;
  bool modelPar_given_POSTBGIDLD=mod.given("POSTBGIDLD");
  modParamMap["POSTBGIDLD"] = &modelPar_POSTBGIDLD;
  AdmsSensFadType modelPar_POCGIDL=mod.POCGIDL;
  bool modelPar_given_POCGIDL=mod.given("POCGIDL");
  modParamMap["POCGIDL"] = &modelPar_POCGIDL;
  AdmsSensFadType modelPar_POCGIDLD=mod.POCGIDLD;
  bool modelPar_given_POCGIDLD=mod.given("POCGIDLD");
  modParamMap["POCGIDLD"] = &modelPar_POCGIDLD;
  AdmsSensFadType modelPar_POCOX=mod.POCOX;
  bool modelPar_given_POCOX=mod.given("POCOX");
  modParamMap["POCOX"] = &modelPar_POCOX;
  AdmsSensFadType modelPar_PLCOX=mod.PLCOX;
  bool modelPar_given_PLCOX=mod.given("PLCOX");
  modParamMap["PLCOX"] = &modelPar_PLCOX;
  AdmsSensFadType modelPar_PWCOX=mod.PWCOX;
  bool modelPar_given_PWCOX=mod.given("PWCOX");
  modParamMap["PWCOX"] = &modelPar_PWCOX;
  AdmsSensFadType modelPar_PLWCOX=mod.PLWCOX;
  bool modelPar_given_PLWCOX=mod.given("PLWCOX");
  modParamMap["PLWCOX"] = &modelPar_PLWCOX;
  AdmsSensFadType modelPar_POCGOV=mod.POCGOV;
  bool modelPar_given_POCGOV=mod.given("POCGOV");
  modParamMap["POCGOV"] = &modelPar_POCGOV;
  AdmsSensFadType modelPar_PLCGOV=mod.PLCGOV;
  bool modelPar_given_PLCGOV=mod.given("PLCGOV");
  modParamMap["PLCGOV"] = &modelPar_PLCGOV;
  AdmsSensFadType modelPar_PWCGOV=mod.PWCGOV;
  bool modelPar_given_PWCGOV=mod.given("PWCGOV");
  modParamMap["PWCGOV"] = &modelPar_PWCGOV;
  AdmsSensFadType modelPar_PLWCGOV=mod.PLWCGOV;
  bool modelPar_given_PLWCGOV=mod.given("PLWCGOV");
  modParamMap["PLWCGOV"] = &modelPar_PLWCGOV;
  AdmsSensFadType modelPar_POCGOVD=mod.POCGOVD;
  bool modelPar_given_POCGOVD=mod.given("POCGOVD");
  modParamMap["POCGOVD"] = &modelPar_POCGOVD;
  AdmsSensFadType modelPar_PLCGOVD=mod.PLCGOVD;
  bool modelPar_given_PLCGOVD=mod.given("PLCGOVD");
  modParamMap["PLCGOVD"] = &modelPar_PLCGOVD;
  AdmsSensFadType modelPar_PWCGOVD=mod.PWCGOVD;
  bool modelPar_given_PWCGOVD=mod.given("PWCGOVD");
  modParamMap["PWCGOVD"] = &modelPar_PWCGOVD;
  AdmsSensFadType modelPar_PLWCGOVD=mod.PLWCGOVD;
  bool modelPar_given_PLWCGOVD=mod.given("PLWCGOVD");
  modParamMap["PLWCGOVD"] = &modelPar_PLWCGOVD;
  AdmsSensFadType modelPar_POCGBOV=mod.POCGBOV;
  bool modelPar_given_POCGBOV=mod.given("POCGBOV");
  modParamMap["POCGBOV"] = &modelPar_POCGBOV;
  AdmsSensFadType modelPar_PLCGBOV=mod.PLCGBOV;
  bool modelPar_given_PLCGBOV=mod.given("PLCGBOV");
  modParamMap["PLCGBOV"] = &modelPar_PLCGBOV;
  AdmsSensFadType modelPar_PWCGBOV=mod.PWCGBOV;
  bool modelPar_given_PWCGBOV=mod.given("PWCGBOV");
  modParamMap["PWCGBOV"] = &modelPar_PWCGBOV;
  AdmsSensFadType modelPar_PLWCGBOV=mod.PLWCGBOV;
  bool modelPar_given_PLWCGBOV=mod.given("PLWCGBOV");
  modParamMap["PLWCGBOV"] = &modelPar_PLWCGBOV;
  AdmsSensFadType modelPar_POCFR=mod.POCFR;
  bool modelPar_given_POCFR=mod.given("POCFR");
  modParamMap["POCFR"] = &modelPar_POCFR;
  AdmsSensFadType modelPar_PLCFR=mod.PLCFR;
  bool modelPar_given_PLCFR=mod.given("PLCFR");
  modParamMap["PLCFR"] = &modelPar_PLCFR;
  AdmsSensFadType modelPar_PWCFR=mod.PWCFR;
  bool modelPar_given_PWCFR=mod.given("PWCFR");
  modParamMap["PWCFR"] = &modelPar_PWCFR;
  AdmsSensFadType modelPar_PLWCFR=mod.PLWCFR;
  bool modelPar_given_PLWCFR=mod.given("PLWCFR");
  modParamMap["PLWCFR"] = &modelPar_PLWCFR;
  AdmsSensFadType modelPar_POCFRD=mod.POCFRD;
  bool modelPar_given_POCFRD=mod.given("POCFRD");
  modParamMap["POCFRD"] = &modelPar_POCFRD;
  AdmsSensFadType modelPar_PLCFRD=mod.PLCFRD;
  bool modelPar_given_PLCFRD=mod.given("PLCFRD");
  modParamMap["PLCFRD"] = &modelPar_PLCFRD;
  AdmsSensFadType modelPar_PWCFRD=mod.PWCFRD;
  bool modelPar_given_PWCFRD=mod.given("PWCFRD");
  modParamMap["PWCFRD"] = &modelPar_PWCFRD;
  AdmsSensFadType modelPar_PLWCFRD=mod.PLWCFRD;
  bool modelPar_given_PLWCFRD=mod.given("PLWCFRD");
  modParamMap["PLWCFRD"] = &modelPar_PLWCFRD;
  AdmsSensFadType modelPar_POFNT=mod.POFNT;
  bool modelPar_given_POFNT=mod.given("POFNT");
  modParamMap["POFNT"] = &modelPar_POFNT;
  AdmsSensFadType modelPar_POFNTEXC=mod.POFNTEXC;
  bool modelPar_given_POFNTEXC=mod.given("POFNTEXC");
  modParamMap["POFNTEXC"] = &modelPar_POFNTEXC;
  AdmsSensFadType modelPar_PLFNTEXC=mod.PLFNTEXC;
  bool modelPar_given_PLFNTEXC=mod.given("PLFNTEXC");
  modParamMap["PLFNTEXC"] = &modelPar_PLFNTEXC;
  AdmsSensFadType modelPar_PWFNTEXC=mod.PWFNTEXC;
  bool modelPar_given_PWFNTEXC=mod.given("PWFNTEXC");
  modParamMap["PWFNTEXC"] = &modelPar_PWFNTEXC;
  AdmsSensFadType modelPar_PLWFNTEXC=mod.PLWFNTEXC;
  bool modelPar_given_PLWFNTEXC=mod.given("PLWFNTEXC");
  modParamMap["PLWFNTEXC"] = &modelPar_PLWFNTEXC;
  AdmsSensFadType modelPar_PONFA=mod.PONFA;
  bool modelPar_given_PONFA=mod.given("PONFA");
  modParamMap["PONFA"] = &modelPar_PONFA;
  AdmsSensFadType modelPar_PLNFA=mod.PLNFA;
  bool modelPar_given_PLNFA=mod.given("PLNFA");
  modParamMap["PLNFA"] = &modelPar_PLNFA;
  AdmsSensFadType modelPar_PWNFA=mod.PWNFA;
  bool modelPar_given_PWNFA=mod.given("PWNFA");
  modParamMap["PWNFA"] = &modelPar_PWNFA;
  AdmsSensFadType modelPar_PLWNFA=mod.PLWNFA;
  bool modelPar_given_PLWNFA=mod.given("PLWNFA");
  modParamMap["PLWNFA"] = &modelPar_PLWNFA;
  AdmsSensFadType modelPar_PONFB=mod.PONFB;
  bool modelPar_given_PONFB=mod.given("PONFB");
  modParamMap["PONFB"] = &modelPar_PONFB;
  AdmsSensFadType modelPar_PLNFB=mod.PLNFB;
  bool modelPar_given_PLNFB=mod.given("PLNFB");
  modParamMap["PLNFB"] = &modelPar_PLNFB;
  AdmsSensFadType modelPar_PWNFB=mod.PWNFB;
  bool modelPar_given_PWNFB=mod.given("PWNFB");
  modParamMap["PWNFB"] = &modelPar_PWNFB;
  AdmsSensFadType modelPar_PLWNFB=mod.PLWNFB;
  bool modelPar_given_PLWNFB=mod.given("PLWNFB");
  modParamMap["PLWNFB"] = &modelPar_PLWNFB;
  AdmsSensFadType modelPar_PONFC=mod.PONFC;
  bool modelPar_given_PONFC=mod.given("PONFC");
  modParamMap["PONFC"] = &modelPar_PONFC;
  AdmsSensFadType modelPar_PLNFC=mod.PLNFC;
  bool modelPar_given_PLNFC=mod.given("PLNFC");
  modParamMap["PLNFC"] = &modelPar_PLNFC;
  AdmsSensFadType modelPar_PWNFC=mod.PWNFC;
  bool modelPar_given_PWNFC=mod.given("PWNFC");
  modParamMap["PWNFC"] = &modelPar_PWNFC;
  AdmsSensFadType modelPar_PLWNFC=mod.PLWNFC;
  bool modelPar_given_PLWNFC=mod.given("PLWNFC");
  modParamMap["PLWNFC"] = &modelPar_PLWNFC;
  AdmsSensFadType modelPar_POEF=mod.POEF;
  bool modelPar_given_POEF=mod.given("POEF");
  modParamMap["POEF"] = &modelPar_POEF;
  AdmsSensFadType modelPar_POVFBEDGE=mod.POVFBEDGE;
  bool modelPar_given_POVFBEDGE=mod.given("POVFBEDGE");
  modParamMap["POVFBEDGE"] = &modelPar_POVFBEDGE;
  AdmsSensFadType modelPar_POSTVFBEDGE=mod.POSTVFBEDGE;
  bool modelPar_given_POSTVFBEDGE=mod.given("POSTVFBEDGE");
  modParamMap["POSTVFBEDGE"] = &modelPar_POSTVFBEDGE;
  AdmsSensFadType modelPar_PLSTVFBEDGE=mod.PLSTVFBEDGE;
  bool modelPar_given_PLSTVFBEDGE=mod.given("PLSTVFBEDGE");
  modParamMap["PLSTVFBEDGE"] = &modelPar_PLSTVFBEDGE;
  AdmsSensFadType modelPar_PWSTVFBEDGE=mod.PWSTVFBEDGE;
  bool modelPar_given_PWSTVFBEDGE=mod.given("PWSTVFBEDGE");
  modParamMap["PWSTVFBEDGE"] = &modelPar_PWSTVFBEDGE;
  AdmsSensFadType modelPar_PLWSTVFBEDGE=mod.PLWSTVFBEDGE;
  bool modelPar_given_PLWSTVFBEDGE=mod.given("PLWSTVFBEDGE");
  modParamMap["PLWSTVFBEDGE"] = &modelPar_PLWSTVFBEDGE;
  AdmsSensFadType modelPar_PODPHIBEDGE=mod.PODPHIBEDGE;
  bool modelPar_given_PODPHIBEDGE=mod.given("PODPHIBEDGE");
  modParamMap["PODPHIBEDGE"] = &modelPar_PODPHIBEDGE;
  AdmsSensFadType modelPar_PLDPHIBEDGE=mod.PLDPHIBEDGE;
  bool modelPar_given_PLDPHIBEDGE=mod.given("PLDPHIBEDGE");
  modParamMap["PLDPHIBEDGE"] = &modelPar_PLDPHIBEDGE;
  AdmsSensFadType modelPar_PWDPHIBEDGE=mod.PWDPHIBEDGE;
  bool modelPar_given_PWDPHIBEDGE=mod.given("PWDPHIBEDGE");
  modParamMap["PWDPHIBEDGE"] = &modelPar_PWDPHIBEDGE;
  AdmsSensFadType modelPar_PLWDPHIBEDGE=mod.PLWDPHIBEDGE;
  bool modelPar_given_PLWDPHIBEDGE=mod.given("PLWDPHIBEDGE");
  modParamMap["PLWDPHIBEDGE"] = &modelPar_PLWDPHIBEDGE;
  AdmsSensFadType modelPar_PONEFFEDGE=mod.PONEFFEDGE;
  bool modelPar_given_PONEFFEDGE=mod.given("PONEFFEDGE");
  modParamMap["PONEFFEDGE"] = &modelPar_PONEFFEDGE;
  AdmsSensFadType modelPar_PLNEFFEDGE=mod.PLNEFFEDGE;
  bool modelPar_given_PLNEFFEDGE=mod.given("PLNEFFEDGE");
  modParamMap["PLNEFFEDGE"] = &modelPar_PLNEFFEDGE;
  AdmsSensFadType modelPar_PWNEFFEDGE=mod.PWNEFFEDGE;
  bool modelPar_given_PWNEFFEDGE=mod.given("PWNEFFEDGE");
  modParamMap["PWNEFFEDGE"] = &modelPar_PWNEFFEDGE;
  AdmsSensFadType modelPar_PLWNEFFEDGE=mod.PLWNEFFEDGE;
  bool modelPar_given_PLWNEFFEDGE=mod.given("PLWNEFFEDGE");
  modParamMap["PLWNEFFEDGE"] = &modelPar_PLWNEFFEDGE;
  AdmsSensFadType modelPar_POCTEDGE=mod.POCTEDGE;
  bool modelPar_given_POCTEDGE=mod.given("POCTEDGE");
  modParamMap["POCTEDGE"] = &modelPar_POCTEDGE;
  AdmsSensFadType modelPar_PLCTEDGE=mod.PLCTEDGE;
  bool modelPar_given_PLCTEDGE=mod.given("PLCTEDGE");
  modParamMap["PLCTEDGE"] = &modelPar_PLCTEDGE;
  AdmsSensFadType modelPar_PWCTEDGE=mod.PWCTEDGE;
  bool modelPar_given_PWCTEDGE=mod.given("PWCTEDGE");
  modParamMap["PWCTEDGE"] = &modelPar_PWCTEDGE;
  AdmsSensFadType modelPar_PLWCTEDGE=mod.PLWCTEDGE;
  bool modelPar_given_PLWCTEDGE=mod.given("PLWCTEDGE");
  modParamMap["PLWCTEDGE"] = &modelPar_PLWCTEDGE;
  AdmsSensFadType modelPar_POBETNEDGE=mod.POBETNEDGE;
  bool modelPar_given_POBETNEDGE=mod.given("POBETNEDGE");
  modParamMap["POBETNEDGE"] = &modelPar_POBETNEDGE;
  AdmsSensFadType modelPar_PLBETNEDGE=mod.PLBETNEDGE;
  bool modelPar_given_PLBETNEDGE=mod.given("PLBETNEDGE");
  modParamMap["PLBETNEDGE"] = &modelPar_PLBETNEDGE;
  AdmsSensFadType modelPar_PWBETNEDGE=mod.PWBETNEDGE;
  bool modelPar_given_PWBETNEDGE=mod.given("PWBETNEDGE");
  modParamMap["PWBETNEDGE"] = &modelPar_PWBETNEDGE;
  AdmsSensFadType modelPar_PLWBETNEDGE=mod.PLWBETNEDGE;
  bool modelPar_given_PLWBETNEDGE=mod.given("PLWBETNEDGE");
  modParamMap["PLWBETNEDGE"] = &modelPar_PLWBETNEDGE;
  AdmsSensFadType modelPar_POSTBETEDGE=mod.POSTBETEDGE;
  bool modelPar_given_POSTBETEDGE=mod.given("POSTBETEDGE");
  modParamMap["POSTBETEDGE"] = &modelPar_POSTBETEDGE;
  AdmsSensFadType modelPar_PLSTBETEDGE=mod.PLSTBETEDGE;
  bool modelPar_given_PLSTBETEDGE=mod.given("PLSTBETEDGE");
  modParamMap["PLSTBETEDGE"] = &modelPar_PLSTBETEDGE;
  AdmsSensFadType modelPar_PWSTBETEDGE=mod.PWSTBETEDGE;
  bool modelPar_given_PWSTBETEDGE=mod.given("PWSTBETEDGE");
  modParamMap["PWSTBETEDGE"] = &modelPar_PWSTBETEDGE;
  AdmsSensFadType modelPar_PLWSTBETEDGE=mod.PLWSTBETEDGE;
  bool modelPar_given_PLWSTBETEDGE=mod.given("PLWSTBETEDGE");
  modParamMap["PLWSTBETEDGE"] = &modelPar_PLWSTBETEDGE;
  AdmsSensFadType modelPar_POPSCEEDGE=mod.POPSCEEDGE;
  bool modelPar_given_POPSCEEDGE=mod.given("POPSCEEDGE");
  modParamMap["POPSCEEDGE"] = &modelPar_POPSCEEDGE;
  AdmsSensFadType modelPar_PLPSCEEDGE=mod.PLPSCEEDGE;
  bool modelPar_given_PLPSCEEDGE=mod.given("PLPSCEEDGE");
  modParamMap["PLPSCEEDGE"] = &modelPar_PLPSCEEDGE;
  AdmsSensFadType modelPar_PWPSCEEDGE=mod.PWPSCEEDGE;
  bool modelPar_given_PWPSCEEDGE=mod.given("PWPSCEEDGE");
  modParamMap["PWPSCEEDGE"] = &modelPar_PWPSCEEDGE;
  AdmsSensFadType modelPar_PLWPSCEEDGE=mod.PLWPSCEEDGE;
  bool modelPar_given_PLWPSCEEDGE=mod.given("PLWPSCEEDGE");
  modParamMap["PLWPSCEEDGE"] = &modelPar_PLWPSCEEDGE;
  AdmsSensFadType modelPar_POPSCEBEDGE=mod.POPSCEBEDGE;
  bool modelPar_given_POPSCEBEDGE=mod.given("POPSCEBEDGE");
  modParamMap["POPSCEBEDGE"] = &modelPar_POPSCEBEDGE;
  AdmsSensFadType modelPar_POPSCEDEDGE=mod.POPSCEDEDGE;
  bool modelPar_given_POPSCEDEDGE=mod.given("POPSCEDEDGE");
  modParamMap["POPSCEDEDGE"] = &modelPar_POPSCEDEDGE;
  AdmsSensFadType modelPar_POCFEDGE=mod.POCFEDGE;
  bool modelPar_given_POCFEDGE=mod.given("POCFEDGE");
  modParamMap["POCFEDGE"] = &modelPar_POCFEDGE;
  AdmsSensFadType modelPar_PLCFEDGE=mod.PLCFEDGE;
  bool modelPar_given_PLCFEDGE=mod.given("PLCFEDGE");
  modParamMap["PLCFEDGE"] = &modelPar_PLCFEDGE;
  AdmsSensFadType modelPar_PWCFEDGE=mod.PWCFEDGE;
  bool modelPar_given_PWCFEDGE=mod.given("PWCFEDGE");
  modParamMap["PWCFEDGE"] = &modelPar_PWCFEDGE;
  AdmsSensFadType modelPar_PLWCFEDGE=mod.PLWCFEDGE;
  bool modelPar_given_PLWCFEDGE=mod.given("PLWCFEDGE");
  modParamMap["PLWCFEDGE"] = &modelPar_PLWCFEDGE;
  AdmsSensFadType modelPar_POCFDEDGE=mod.POCFDEDGE;
  bool modelPar_given_POCFDEDGE=mod.given("POCFDEDGE");
  modParamMap["POCFDEDGE"] = &modelPar_POCFDEDGE;
  AdmsSensFadType modelPar_POCFBEDGE=mod.POCFBEDGE;
  bool modelPar_given_POCFBEDGE=mod.given("POCFBEDGE");
  modParamMap["POCFBEDGE"] = &modelPar_POCFBEDGE;
  AdmsSensFadType modelPar_POFNTEDGE=mod.POFNTEDGE;
  bool modelPar_given_POFNTEDGE=mod.given("POFNTEDGE");
  modParamMap["POFNTEDGE"] = &modelPar_POFNTEDGE;
  AdmsSensFadType modelPar_PONFAEDGE=mod.PONFAEDGE;
  bool modelPar_given_PONFAEDGE=mod.given("PONFAEDGE");
  modParamMap["PONFAEDGE"] = &modelPar_PONFAEDGE;
  AdmsSensFadType modelPar_PLNFAEDGE=mod.PLNFAEDGE;
  bool modelPar_given_PLNFAEDGE=mod.given("PLNFAEDGE");
  modParamMap["PLNFAEDGE"] = &modelPar_PLNFAEDGE;
  AdmsSensFadType modelPar_PWNFAEDGE=mod.PWNFAEDGE;
  bool modelPar_given_PWNFAEDGE=mod.given("PWNFAEDGE");
  modParamMap["PWNFAEDGE"] = &modelPar_PWNFAEDGE;
  AdmsSensFadType modelPar_PLWNFAEDGE=mod.PLWNFAEDGE;
  bool modelPar_given_PLWNFAEDGE=mod.given("PLWNFAEDGE");
  modParamMap["PLWNFAEDGE"] = &modelPar_PLWNFAEDGE;
  AdmsSensFadType modelPar_PONFBEDGE=mod.PONFBEDGE;
  bool modelPar_given_PONFBEDGE=mod.given("PONFBEDGE");
  modParamMap["PONFBEDGE"] = &modelPar_PONFBEDGE;
  AdmsSensFadType modelPar_PLNFBEDGE=mod.PLNFBEDGE;
  bool modelPar_given_PLNFBEDGE=mod.given("PLNFBEDGE");
  modParamMap["PLNFBEDGE"] = &modelPar_PLNFBEDGE;
  AdmsSensFadType modelPar_PWNFBEDGE=mod.PWNFBEDGE;
  bool modelPar_given_PWNFBEDGE=mod.given("PWNFBEDGE");
  modParamMap["PWNFBEDGE"] = &modelPar_PWNFBEDGE;
  AdmsSensFadType modelPar_PLWNFBEDGE=mod.PLWNFBEDGE;
  bool modelPar_given_PLWNFBEDGE=mod.given("PLWNFBEDGE");
  modParamMap["PLWNFBEDGE"] = &modelPar_PLWNFBEDGE;
  AdmsSensFadType modelPar_PONFCEDGE=mod.PONFCEDGE;
  bool modelPar_given_PONFCEDGE=mod.given("PONFCEDGE");
  modParamMap["PONFCEDGE"] = &modelPar_PONFCEDGE;
  AdmsSensFadType modelPar_PLNFCEDGE=mod.PLNFCEDGE;
  bool modelPar_given_PLNFCEDGE=mod.given("PLNFCEDGE");
  modParamMap["PLNFCEDGE"] = &modelPar_PLNFCEDGE;
  AdmsSensFadType modelPar_PWNFCEDGE=mod.PWNFCEDGE;
  bool modelPar_given_PWNFCEDGE=mod.given("PWNFCEDGE");
  modParamMap["PWNFCEDGE"] = &modelPar_PWNFCEDGE;
  AdmsSensFadType modelPar_PLWNFCEDGE=mod.PLWNFCEDGE;
  bool modelPar_given_PLWNFCEDGE=mod.given("PLWNFCEDGE");
  modParamMap["PLWNFCEDGE"] = &modelPar_PLWNFCEDGE;
  AdmsSensFadType modelPar_POEFEDGE=mod.POEFEDGE;
  bool modelPar_given_POEFEDGE=mod.given("POEFEDGE");
  modParamMap["POEFEDGE"] = &modelPar_POEFEDGE;
  AdmsSensFadType modelPar_POKVTHOWE=mod.POKVTHOWE;
  bool modelPar_given_POKVTHOWE=mod.given("POKVTHOWE");
  modParamMap["POKVTHOWE"] = &modelPar_POKVTHOWE;
  AdmsSensFadType modelPar_PLKVTHOWE=mod.PLKVTHOWE;
  bool modelPar_given_PLKVTHOWE=mod.given("PLKVTHOWE");
  modParamMap["PLKVTHOWE"] = &modelPar_PLKVTHOWE;
  AdmsSensFadType modelPar_PWKVTHOWE=mod.PWKVTHOWE;
  bool modelPar_given_PWKVTHOWE=mod.given("PWKVTHOWE");
  modParamMap["PWKVTHOWE"] = &modelPar_PWKVTHOWE;
  AdmsSensFadType modelPar_PLWKVTHOWE=mod.PLWKVTHOWE;
  bool modelPar_given_PLWKVTHOWE=mod.given("PLWKVTHOWE");
  modParamMap["PLWKVTHOWE"] = &modelPar_PLWKVTHOWE;
  AdmsSensFadType modelPar_POKUOWE=mod.POKUOWE;
  bool modelPar_given_POKUOWE=mod.given("POKUOWE");
  modParamMap["POKUOWE"] = &modelPar_POKUOWE;
  AdmsSensFadType modelPar_PLKUOWE=mod.PLKUOWE;
  bool modelPar_given_PLKUOWE=mod.given("PLKUOWE");
  modParamMap["PLKUOWE"] = &modelPar_PLKUOWE;
  AdmsSensFadType modelPar_PWKUOWE=mod.PWKUOWE;
  bool modelPar_given_PWKUOWE=mod.given("PWKUOWE");
  modParamMap["PWKUOWE"] = &modelPar_PWKUOWE;
  AdmsSensFadType modelPar_PLWKUOWE=mod.PLWKUOWE;
  bool modelPar_given_PLWKUOWE=mod.given("PLWKUOWE");
  modParamMap["PLWKUOWE"] = &modelPar_PLWKUOWE;
  AdmsSensFadType modelPar_LMIN=mod.LMIN;
  bool modelPar_given_LMIN=mod.given("LMIN");
  modParamMap["LMIN"] = &modelPar_LMIN;
  AdmsSensFadType modelPar_LMAX=mod.LMAX;
  bool modelPar_given_LMAX=mod.given("LMAX");
  modParamMap["LMAX"] = &modelPar_LMAX;
  AdmsSensFadType modelPar_WMIN=mod.WMIN;
  bool modelPar_given_WMIN=mod.given("WMIN");
  modParamMap["WMIN"] = &modelPar_WMIN;
  AdmsSensFadType modelPar_WMAX=mod.WMAX;
  bool modelPar_given_WMAX=mod.given("WMAX");
  modParamMap["WMAX"] = &modelPar_WMAX;
  AdmsSensFadType modelPar_LVARO=mod.LVARO;
  bool modelPar_given_LVARO=mod.given("LVARO");
  modParamMap["LVARO"] = &modelPar_LVARO;
  AdmsSensFadType modelPar_LVARL=mod.LVARL;
  bool modelPar_given_LVARL=mod.given("LVARL");
  modParamMap["LVARL"] = &modelPar_LVARL;
  AdmsSensFadType modelPar_LVARW=mod.LVARW;
  bool modelPar_given_LVARW=mod.given("LVARW");
  modParamMap["LVARW"] = &modelPar_LVARW;
  AdmsSensFadType modelPar_LAP=mod.LAP;
  bool modelPar_given_LAP=mod.given("LAP");
  modParamMap["LAP"] = &modelPar_LAP;
  AdmsSensFadType modelPar_WVARO=mod.WVARO;
  bool modelPar_given_WVARO=mod.given("WVARO");
  modParamMap["WVARO"] = &modelPar_WVARO;
  AdmsSensFadType modelPar_WVARL=mod.WVARL;
  bool modelPar_given_WVARL=mod.given("WVARL");
  modParamMap["WVARL"] = &modelPar_WVARL;
  AdmsSensFadType modelPar_WVARW=mod.WVARW;
  bool modelPar_given_WVARW=mod.given("WVARW");
  modParamMap["WVARW"] = &modelPar_WVARW;
  AdmsSensFadType modelPar_WOT=mod.WOT;
  bool modelPar_given_WOT=mod.given("WOT");
  modParamMap["WOT"] = &modelPar_WOT;
  AdmsSensFadType modelPar_DLQ=mod.DLQ;
  bool modelPar_given_DLQ=mod.given("DLQ");
  modParamMap["DLQ"] = &modelPar_DLQ;
  AdmsSensFadType modelPar_DWQ=mod.DWQ;
  bool modelPar_given_DWQ=mod.given("DWQ");
  modParamMap["DWQ"] = &modelPar_DWQ;
  AdmsSensFadType modelPar_VFBO=mod.VFBO;
  bool modelPar_given_VFBO=mod.given("VFBO");
  modParamMap["VFBO"] = &modelPar_VFBO;
  AdmsSensFadType modelPar_VFBL=mod.VFBL;
  bool modelPar_given_VFBL=mod.given("VFBL");
  modParamMap["VFBL"] = &modelPar_VFBL;
  AdmsSensFadType modelPar_VFBW=mod.VFBW;
  bool modelPar_given_VFBW=mod.given("VFBW");
  modParamMap["VFBW"] = &modelPar_VFBW;
  AdmsSensFadType modelPar_VFBLW=mod.VFBLW;
  bool modelPar_given_VFBLW=mod.given("VFBLW");
  modParamMap["VFBLW"] = &modelPar_VFBLW;
  AdmsSensFadType modelPar_STVFBO=mod.STVFBO;
  bool modelPar_given_STVFBO=mod.given("STVFBO");
  modParamMap["STVFBO"] = &modelPar_STVFBO;
  AdmsSensFadType modelPar_STVFBL=mod.STVFBL;
  bool modelPar_given_STVFBL=mod.given("STVFBL");
  modParamMap["STVFBL"] = &modelPar_STVFBL;
  AdmsSensFadType modelPar_STVFBW=mod.STVFBW;
  bool modelPar_given_STVFBW=mod.given("STVFBW");
  modParamMap["STVFBW"] = &modelPar_STVFBW;
  AdmsSensFadType modelPar_STVFBLW=mod.STVFBLW;
  bool modelPar_given_STVFBLW=mod.given("STVFBLW");
  modParamMap["STVFBLW"] = &modelPar_STVFBLW;
  AdmsSensFadType modelPar_TOXO=mod.TOXO;
  bool modelPar_given_TOXO=mod.given("TOXO");
  modParamMap["TOXO"] = &modelPar_TOXO;
  AdmsSensFadType modelPar_EPSROXO=mod.EPSROXO;
  bool modelPar_given_EPSROXO=mod.given("EPSROXO");
  modParamMap["EPSROXO"] = &modelPar_EPSROXO;
  AdmsSensFadType modelPar_NSUBO=mod.NSUBO;
  bool modelPar_given_NSUBO=mod.given("NSUBO");
  modParamMap["NSUBO"] = &modelPar_NSUBO;
  AdmsSensFadType modelPar_NSUBW=mod.NSUBW;
  bool modelPar_given_NSUBW=mod.given("NSUBW");
  modParamMap["NSUBW"] = &modelPar_NSUBW;
  AdmsSensFadType modelPar_WSEG=mod.WSEG;
  bool modelPar_given_WSEG=mod.given("WSEG");
  modParamMap["WSEG"] = &modelPar_WSEG;
  AdmsSensFadType modelPar_NPCK=mod.NPCK;
  bool modelPar_given_NPCK=mod.given("NPCK");
  modParamMap["NPCK"] = &modelPar_NPCK;
  AdmsSensFadType modelPar_NPCKW=mod.NPCKW;
  bool modelPar_given_NPCKW=mod.given("NPCKW");
  modParamMap["NPCKW"] = &modelPar_NPCKW;
  AdmsSensFadType modelPar_WSEGP=mod.WSEGP;
  bool modelPar_given_WSEGP=mod.given("WSEGP");
  modParamMap["WSEGP"] = &modelPar_WSEGP;
  AdmsSensFadType modelPar_LPCK=mod.LPCK;
  bool modelPar_given_LPCK=mod.given("LPCK");
  modParamMap["LPCK"] = &modelPar_LPCK;
  AdmsSensFadType modelPar_LPCKW=mod.LPCKW;
  bool modelPar_given_LPCKW=mod.given("LPCKW");
  modParamMap["LPCKW"] = &modelPar_LPCKW;
  AdmsSensFadType modelPar_FOL1=mod.FOL1;
  bool modelPar_given_FOL1=mod.given("FOL1");
  modParamMap["FOL1"] = &modelPar_FOL1;
  AdmsSensFadType modelPar_FOL2=mod.FOL2;
  bool modelPar_given_FOL2=mod.given("FOL2");
  modParamMap["FOL2"] = &modelPar_FOL2;
  AdmsSensFadType modelPar_FACNEFFACO=mod.FACNEFFACO;
  bool modelPar_given_FACNEFFACO=mod.given("FACNEFFACO");
  modParamMap["FACNEFFACO"] = &modelPar_FACNEFFACO;
  AdmsSensFadType modelPar_FACNEFFACL=mod.FACNEFFACL;
  bool modelPar_given_FACNEFFACL=mod.given("FACNEFFACL");
  modParamMap["FACNEFFACL"] = &modelPar_FACNEFFACL;
  AdmsSensFadType modelPar_FACNEFFACW=mod.FACNEFFACW;
  bool modelPar_given_FACNEFFACW=mod.given("FACNEFFACW");
  modParamMap["FACNEFFACW"] = &modelPar_FACNEFFACW;
  AdmsSensFadType modelPar_FACNEFFACLW=mod.FACNEFFACLW;
  bool modelPar_given_FACNEFFACLW=mod.given("FACNEFFACLW");
  modParamMap["FACNEFFACLW"] = &modelPar_FACNEFFACLW;
  AdmsSensFadType modelPar_GFACNUDO=mod.GFACNUDO;
  bool modelPar_given_GFACNUDO=mod.given("GFACNUDO");
  modParamMap["GFACNUDO"] = &modelPar_GFACNUDO;
  AdmsSensFadType modelPar_GFACNUDL=mod.GFACNUDL;
  bool modelPar_given_GFACNUDL=mod.given("GFACNUDL");
  modParamMap["GFACNUDL"] = &modelPar_GFACNUDL;
  AdmsSensFadType modelPar_GFACNUDLEXP=mod.GFACNUDLEXP;
  bool modelPar_given_GFACNUDLEXP=mod.given("GFACNUDLEXP");
  modParamMap["GFACNUDLEXP"] = &modelPar_GFACNUDLEXP;
  AdmsSensFadType modelPar_GFACNUDW=mod.GFACNUDW;
  bool modelPar_given_GFACNUDW=mod.given("GFACNUDW");
  modParamMap["GFACNUDW"] = &modelPar_GFACNUDW;
  AdmsSensFadType modelPar_GFACNUDLW=mod.GFACNUDLW;
  bool modelPar_given_GFACNUDLW=mod.given("GFACNUDLW");
  modParamMap["GFACNUDLW"] = &modelPar_GFACNUDLW;
  AdmsSensFadType modelPar_VSBNUDO=mod.VSBNUDO;
  bool modelPar_given_VSBNUDO=mod.given("VSBNUDO");
  modParamMap["VSBNUDO"] = &modelPar_VSBNUDO;
  AdmsSensFadType modelPar_DVSBNUDO=mod.DVSBNUDO;
  bool modelPar_given_DVSBNUDO=mod.given("DVSBNUDO");
  modParamMap["DVSBNUDO"] = &modelPar_DVSBNUDO;
  AdmsSensFadType modelPar_VNSUBO=mod.VNSUBO;
  bool modelPar_given_VNSUBO=mod.given("VNSUBO");
  modParamMap["VNSUBO"] = &modelPar_VNSUBO;
  AdmsSensFadType modelPar_NSLPO=mod.NSLPO;
  bool modelPar_given_NSLPO=mod.given("NSLPO");
  modParamMap["NSLPO"] = &modelPar_NSLPO;
  AdmsSensFadType modelPar_DNSUBO=mod.DNSUBO;
  bool modelPar_given_DNSUBO=mod.given("DNSUBO");
  modParamMap["DNSUBO"] = &modelPar_DNSUBO;
  AdmsSensFadType modelPar_DPHIBO=mod.DPHIBO;
  bool modelPar_given_DPHIBO=mod.given("DPHIBO");
  modParamMap["DPHIBO"] = &modelPar_DPHIBO;
  AdmsSensFadType modelPar_DPHIBL=mod.DPHIBL;
  bool modelPar_given_DPHIBL=mod.given("DPHIBL");
  modParamMap["DPHIBL"] = &modelPar_DPHIBL;
  AdmsSensFadType modelPar_DPHIBLEXP=mod.DPHIBLEXP;
  bool modelPar_given_DPHIBLEXP=mod.given("DPHIBLEXP");
  modParamMap["DPHIBLEXP"] = &modelPar_DPHIBLEXP;
  AdmsSensFadType modelPar_DPHIBW=mod.DPHIBW;
  bool modelPar_given_DPHIBW=mod.given("DPHIBW");
  modParamMap["DPHIBW"] = &modelPar_DPHIBW;
  AdmsSensFadType modelPar_DPHIBLW=mod.DPHIBLW;
  bool modelPar_given_DPHIBLW=mod.given("DPHIBLW");
  modParamMap["DPHIBLW"] = &modelPar_DPHIBLW;
  AdmsSensFadType modelPar_DELVTACO=mod.DELVTACO;
  bool modelPar_given_DELVTACO=mod.given("DELVTACO");
  modParamMap["DELVTACO"] = &modelPar_DELVTACO;
  AdmsSensFadType modelPar_DELVTACL=mod.DELVTACL;
  bool modelPar_given_DELVTACL=mod.given("DELVTACL");
  modParamMap["DELVTACL"] = &modelPar_DELVTACL;
  AdmsSensFadType modelPar_DELVTACLEXP=mod.DELVTACLEXP;
  bool modelPar_given_DELVTACLEXP=mod.given("DELVTACLEXP");
  modParamMap["DELVTACLEXP"] = &modelPar_DELVTACLEXP;
  AdmsSensFadType modelPar_DELVTACW=mod.DELVTACW;
  bool modelPar_given_DELVTACW=mod.given("DELVTACW");
  modParamMap["DELVTACW"] = &modelPar_DELVTACW;
  AdmsSensFadType modelPar_DELVTACLW=mod.DELVTACLW;
  bool modelPar_given_DELVTACLW=mod.given("DELVTACLW");
  modParamMap["DELVTACLW"] = &modelPar_DELVTACLW;
  AdmsSensFadType modelPar_NPO=mod.NPO;
  bool modelPar_given_NPO=mod.given("NPO");
  modParamMap["NPO"] = &modelPar_NPO;
  AdmsSensFadType modelPar_NPL=mod.NPL;
  bool modelPar_given_NPL=mod.given("NPL");
  modParamMap["NPL"] = &modelPar_NPL;
  AdmsSensFadType modelPar_CTO=mod.CTO;
  bool modelPar_given_CTO=mod.given("CTO");
  modParamMap["CTO"] = &modelPar_CTO;
  AdmsSensFadType modelPar_CTL=mod.CTL;
  bool modelPar_given_CTL=mod.given("CTL");
  modParamMap["CTL"] = &modelPar_CTL;
  AdmsSensFadType modelPar_CTLEXP=mod.CTLEXP;
  bool modelPar_given_CTLEXP=mod.given("CTLEXP");
  modParamMap["CTLEXP"] = &modelPar_CTLEXP;
  AdmsSensFadType modelPar_CTW=mod.CTW;
  bool modelPar_given_CTW=mod.given("CTW");
  modParamMap["CTW"] = &modelPar_CTW;
  AdmsSensFadType modelPar_CTLW=mod.CTLW;
  bool modelPar_given_CTLW=mod.given("CTLW");
  modParamMap["CTLW"] = &modelPar_CTLW;
  AdmsSensFadType modelPar_TOXOVO=mod.TOXOVO;
  bool modelPar_given_TOXOVO=mod.given("TOXOVO");
  modParamMap["TOXOVO"] = &modelPar_TOXOVO;
  AdmsSensFadType modelPar_TOXOVDO=mod.TOXOVDO;
  bool modelPar_given_TOXOVDO=mod.given("TOXOVDO");
  modParamMap["TOXOVDO"] = &modelPar_TOXOVDO;
  AdmsSensFadType modelPar_LOV=mod.LOV;
  bool modelPar_given_LOV=mod.given("LOV");
  modParamMap["LOV"] = &modelPar_LOV;
  AdmsSensFadType modelPar_LOVD=mod.LOVD;
  bool modelPar_given_LOVD=mod.given("LOVD");
  modParamMap["LOVD"] = &modelPar_LOVD;
  AdmsSensFadType modelPar_NOVO=mod.NOVO;
  bool modelPar_given_NOVO=mod.given("NOVO");
  modParamMap["NOVO"] = &modelPar_NOVO;
  AdmsSensFadType modelPar_NOVDO=mod.NOVDO;
  bool modelPar_given_NOVDO=mod.given("NOVDO");
  modParamMap["NOVDO"] = &modelPar_NOVDO;
  AdmsSensFadType modelPar_CFL=mod.CFL;
  bool modelPar_given_CFL=mod.given("CFL");
  modParamMap["CFL"] = &modelPar_CFL;
  AdmsSensFadType modelPar_CFLEXP=mod.CFLEXP;
  bool modelPar_given_CFLEXP=mod.given("CFLEXP");
  modParamMap["CFLEXP"] = &modelPar_CFLEXP;
  AdmsSensFadType modelPar_CFW=mod.CFW;
  bool modelPar_given_CFW=mod.given("CFW");
  modParamMap["CFW"] = &modelPar_CFW;
  AdmsSensFadType modelPar_CFDO=mod.CFDO;
  bool modelPar_given_CFDO=mod.given("CFDO");
  modParamMap["CFDO"] = &modelPar_CFDO;
  AdmsSensFadType modelPar_CFBO=mod.CFBO;
  bool modelPar_given_CFBO=mod.given("CFBO");
  modParamMap["CFBO"] = &modelPar_CFBO;
  AdmsSensFadType modelPar_PSCEL=mod.PSCEL;
  bool modelPar_given_PSCEL=mod.given("PSCEL");
  modParamMap["PSCEL"] = &modelPar_PSCEL;
  AdmsSensFadType modelPar_PSCELEXP=mod.PSCELEXP;
  bool modelPar_given_PSCELEXP=mod.given("PSCELEXP");
  modParamMap["PSCELEXP"] = &modelPar_PSCELEXP;
  AdmsSensFadType modelPar_PSCEW=mod.PSCEW;
  bool modelPar_given_PSCEW=mod.given("PSCEW");
  modParamMap["PSCEW"] = &modelPar_PSCEW;
  AdmsSensFadType modelPar_PSCEBO=mod.PSCEBO;
  bool modelPar_given_PSCEBO=mod.given("PSCEBO");
  modParamMap["PSCEBO"] = &modelPar_PSCEBO;
  AdmsSensFadType modelPar_PSCEDO=mod.PSCEDO;
  bool modelPar_given_PSCEDO=mod.given("PSCEDO");
  modParamMap["PSCEDO"] = &modelPar_PSCEDO;
  AdmsSensFadType modelPar_UO=mod.UO;
  bool modelPar_given_UO=mod.given("UO");
  modParamMap["UO"] = &modelPar_UO;
  AdmsSensFadType modelPar_FBET1=mod.FBET1;
  bool modelPar_given_FBET1=mod.given("FBET1");
  modParamMap["FBET1"] = &modelPar_FBET1;
  AdmsSensFadType modelPar_FBET1W=mod.FBET1W;
  bool modelPar_given_FBET1W=mod.given("FBET1W");
  modParamMap["FBET1W"] = &modelPar_FBET1W;
  AdmsSensFadType modelPar_LP1=mod.LP1;
  bool modelPar_given_LP1=mod.given("LP1");
  modParamMap["LP1"] = &modelPar_LP1;
  AdmsSensFadType modelPar_LP1W=mod.LP1W;
  bool modelPar_given_LP1W=mod.given("LP1W");
  modParamMap["LP1W"] = &modelPar_LP1W;
  AdmsSensFadType modelPar_FBET2=mod.FBET2;
  bool modelPar_given_FBET2=mod.given("FBET2");
  modParamMap["FBET2"] = &modelPar_FBET2;
  AdmsSensFadType modelPar_LP2=mod.LP2;
  bool modelPar_given_LP2=mod.given("LP2");
  modParamMap["LP2"] = &modelPar_LP2;
  AdmsSensFadType modelPar_BETW1=mod.BETW1;
  bool modelPar_given_BETW1=mod.given("BETW1");
  modParamMap["BETW1"] = &modelPar_BETW1;
  AdmsSensFadType modelPar_BETW2=mod.BETW2;
  bool modelPar_given_BETW2=mod.given("BETW2");
  modParamMap["BETW2"] = &modelPar_BETW2;
  AdmsSensFadType modelPar_WBET=mod.WBET;
  bool modelPar_given_WBET=mod.given("WBET");
  modParamMap["WBET"] = &modelPar_WBET;
  AdmsSensFadType modelPar_STBETO=mod.STBETO;
  bool modelPar_given_STBETO=mod.given("STBETO");
  modParamMap["STBETO"] = &modelPar_STBETO;
  AdmsSensFadType modelPar_STBETL=mod.STBETL;
  bool modelPar_given_STBETL=mod.given("STBETL");
  modParamMap["STBETL"] = &modelPar_STBETL;
  AdmsSensFadType modelPar_STBETW=mod.STBETW;
  bool modelPar_given_STBETW=mod.given("STBETW");
  modParamMap["STBETW"] = &modelPar_STBETW;
  AdmsSensFadType modelPar_STBETLW=mod.STBETLW;
  bool modelPar_given_STBETLW=mod.given("STBETLW");
  modParamMap["STBETLW"] = &modelPar_STBETLW;
  AdmsSensFadType modelPar_MUEO=mod.MUEO;
  bool modelPar_given_MUEO=mod.given("MUEO");
  modParamMap["MUEO"] = &modelPar_MUEO;
  AdmsSensFadType modelPar_MUEW=mod.MUEW;
  bool modelPar_given_MUEW=mod.given("MUEW");
  modParamMap["MUEW"] = &modelPar_MUEW;
  AdmsSensFadType modelPar_STMUEO=mod.STMUEO;
  bool modelPar_given_STMUEO=mod.given("STMUEO");
  modParamMap["STMUEO"] = &modelPar_STMUEO;
  AdmsSensFadType modelPar_THEMUO=mod.THEMUO;
  bool modelPar_given_THEMUO=mod.given("THEMUO");
  modParamMap["THEMUO"] = &modelPar_THEMUO;
  AdmsSensFadType modelPar_STTHEMUO=mod.STTHEMUO;
  bool modelPar_given_STTHEMUO=mod.given("STTHEMUO");
  modParamMap["STTHEMUO"] = &modelPar_STTHEMUO;
  AdmsSensFadType modelPar_CSO=mod.CSO;
  bool modelPar_given_CSO=mod.given("CSO");
  modParamMap["CSO"] = &modelPar_CSO;
  AdmsSensFadType modelPar_CSL=mod.CSL;
  bool modelPar_given_CSL=mod.given("CSL");
  modParamMap["CSL"] = &modelPar_CSL;
  AdmsSensFadType modelPar_CSLEXP=mod.CSLEXP;
  bool modelPar_given_CSLEXP=mod.given("CSLEXP");
  modParamMap["CSLEXP"] = &modelPar_CSLEXP;
  AdmsSensFadType modelPar_CSW=mod.CSW;
  bool modelPar_given_CSW=mod.given("CSW");
  modParamMap["CSW"] = &modelPar_CSW;
  AdmsSensFadType modelPar_CSLW=mod.CSLW;
  bool modelPar_given_CSLW=mod.given("CSLW");
  modParamMap["CSLW"] = &modelPar_CSLW;
  AdmsSensFadType modelPar_STCSO=mod.STCSO;
  bool modelPar_given_STCSO=mod.given("STCSO");
  modParamMap["STCSO"] = &modelPar_STCSO;
  AdmsSensFadType modelPar_XCORO=mod.XCORO;
  bool modelPar_given_XCORO=mod.given("XCORO");
  modParamMap["XCORO"] = &modelPar_XCORO;
  AdmsSensFadType modelPar_XCORL=mod.XCORL;
  bool modelPar_given_XCORL=mod.given("XCORL");
  modParamMap["XCORL"] = &modelPar_XCORL;
  AdmsSensFadType modelPar_XCORW=mod.XCORW;
  bool modelPar_given_XCORW=mod.given("XCORW");
  modParamMap["XCORW"] = &modelPar_XCORW;
  AdmsSensFadType modelPar_XCORLW=mod.XCORLW;
  bool modelPar_given_XCORLW=mod.given("XCORLW");
  modParamMap["XCORLW"] = &modelPar_XCORLW;
  AdmsSensFadType modelPar_STXCORO=mod.STXCORO;
  bool modelPar_given_STXCORO=mod.given("STXCORO");
  modParamMap["STXCORO"] = &modelPar_STXCORO;
  AdmsSensFadType modelPar_FETAO=mod.FETAO;
  bool modelPar_given_FETAO=mod.given("FETAO");
  modParamMap["FETAO"] = &modelPar_FETAO;
  AdmsSensFadType modelPar_RSW1=mod.RSW1;
  bool modelPar_given_RSW1=mod.given("RSW1");
  modParamMap["RSW1"] = &modelPar_RSW1;
  AdmsSensFadType modelPar_RSW2=mod.RSW2;
  bool modelPar_given_RSW2=mod.given("RSW2");
  modParamMap["RSW2"] = &modelPar_RSW2;
  AdmsSensFadType modelPar_STRSO=mod.STRSO;
  bool modelPar_given_STRSO=mod.given("STRSO");
  modParamMap["STRSO"] = &modelPar_STRSO;
  AdmsSensFadType modelPar_RSBO=mod.RSBO;
  bool modelPar_given_RSBO=mod.given("RSBO");
  modParamMap["RSBO"] = &modelPar_RSBO;
  AdmsSensFadType modelPar_RSGO=mod.RSGO;
  bool modelPar_given_RSGO=mod.given("RSGO");
  modParamMap["RSGO"] = &modelPar_RSGO;
  AdmsSensFadType modelPar_THESATO=mod.THESATO;
  bool modelPar_given_THESATO=mod.given("THESATO");
  modParamMap["THESATO"] = &modelPar_THESATO;
  AdmsSensFadType modelPar_THESATL=mod.THESATL;
  bool modelPar_given_THESATL=mod.given("THESATL");
  modParamMap["THESATL"] = &modelPar_THESATL;
  AdmsSensFadType modelPar_THESATLEXP=mod.THESATLEXP;
  bool modelPar_given_THESATLEXP=mod.given("THESATLEXP");
  modParamMap["THESATLEXP"] = &modelPar_THESATLEXP;
  AdmsSensFadType modelPar_THESATW=mod.THESATW;
  bool modelPar_given_THESATW=mod.given("THESATW");
  modParamMap["THESATW"] = &modelPar_THESATW;
  AdmsSensFadType modelPar_THESATLW=mod.THESATLW;
  bool modelPar_given_THESATLW=mod.given("THESATLW");
  modParamMap["THESATLW"] = &modelPar_THESATLW;
  AdmsSensFadType modelPar_STTHESATO=mod.STTHESATO;
  bool modelPar_given_STTHESATO=mod.given("STTHESATO");
  modParamMap["STTHESATO"] = &modelPar_STTHESATO;
  AdmsSensFadType modelPar_STTHESATL=mod.STTHESATL;
  bool modelPar_given_STTHESATL=mod.given("STTHESATL");
  modParamMap["STTHESATL"] = &modelPar_STTHESATL;
  AdmsSensFadType modelPar_STTHESATW=mod.STTHESATW;
  bool modelPar_given_STTHESATW=mod.given("STTHESATW");
  modParamMap["STTHESATW"] = &modelPar_STTHESATW;
  AdmsSensFadType modelPar_STTHESATLW=mod.STTHESATLW;
  bool modelPar_given_STTHESATLW=mod.given("STTHESATLW");
  modParamMap["STTHESATLW"] = &modelPar_STTHESATLW;
  AdmsSensFadType modelPar_THESATBO=mod.THESATBO;
  bool modelPar_given_THESATBO=mod.given("THESATBO");
  modParamMap["THESATBO"] = &modelPar_THESATBO;
  AdmsSensFadType modelPar_THESATGO=mod.THESATGO;
  bool modelPar_given_THESATGO=mod.given("THESATGO");
  modParamMap["THESATGO"] = &modelPar_THESATGO;
  AdmsSensFadType modelPar_AXO=mod.AXO;
  bool modelPar_given_AXO=mod.given("AXO");
  modParamMap["AXO"] = &modelPar_AXO;
  AdmsSensFadType modelPar_AXL=mod.AXL;
  bool modelPar_given_AXL=mod.given("AXL");
  modParamMap["AXL"] = &modelPar_AXL;
  AdmsSensFadType modelPar_ALPL=mod.ALPL;
  bool modelPar_given_ALPL=mod.given("ALPL");
  modParamMap["ALPL"] = &modelPar_ALPL;
  AdmsSensFadType modelPar_ALPLEXP=mod.ALPLEXP;
  bool modelPar_given_ALPLEXP=mod.given("ALPLEXP");
  modParamMap["ALPLEXP"] = &modelPar_ALPLEXP;
  AdmsSensFadType modelPar_ALPW=mod.ALPW;
  bool modelPar_given_ALPW=mod.given("ALPW");
  modParamMap["ALPW"] = &modelPar_ALPW;
  AdmsSensFadType modelPar_ALP1L1=mod.ALP1L1;
  bool modelPar_given_ALP1L1=mod.given("ALP1L1");
  modParamMap["ALP1L1"] = &modelPar_ALP1L1;
  AdmsSensFadType modelPar_ALP1LEXP=mod.ALP1LEXP;
  bool modelPar_given_ALP1LEXP=mod.given("ALP1LEXP");
  modParamMap["ALP1LEXP"] = &modelPar_ALP1LEXP;
  AdmsSensFadType modelPar_ALP1L2=mod.ALP1L2;
  bool modelPar_given_ALP1L2=mod.given("ALP1L2");
  modParamMap["ALP1L2"] = &modelPar_ALP1L2;
  AdmsSensFadType modelPar_ALP1W=mod.ALP1W;
  bool modelPar_given_ALP1W=mod.given("ALP1W");
  modParamMap["ALP1W"] = &modelPar_ALP1W;
  AdmsSensFadType modelPar_ALP2L1=mod.ALP2L1;
  bool modelPar_given_ALP2L1=mod.given("ALP2L1");
  modParamMap["ALP2L1"] = &modelPar_ALP2L1;
  AdmsSensFadType modelPar_ALP2LEXP=mod.ALP2LEXP;
  bool modelPar_given_ALP2LEXP=mod.given("ALP2LEXP");
  modParamMap["ALP2LEXP"] = &modelPar_ALP2LEXP;
  AdmsSensFadType modelPar_ALP2L2=mod.ALP2L2;
  bool modelPar_given_ALP2L2=mod.given("ALP2L2");
  modParamMap["ALP2L2"] = &modelPar_ALP2L2;
  AdmsSensFadType modelPar_ALP2W=mod.ALP2W;
  bool modelPar_given_ALP2W=mod.given("ALP2W");
  modParamMap["ALP2W"] = &modelPar_ALP2W;
  AdmsSensFadType modelPar_VPO=mod.VPO;
  bool modelPar_given_VPO=mod.given("VPO");
  modParamMap["VPO"] = &modelPar_VPO;
  AdmsSensFadType modelPar_A1O=mod.A1O;
  bool modelPar_given_A1O=mod.given("A1O");
  modParamMap["A1O"] = &modelPar_A1O;
  AdmsSensFadType modelPar_A1L=mod.A1L;
  bool modelPar_given_A1L=mod.given("A1L");
  modParamMap["A1L"] = &modelPar_A1L;
  AdmsSensFadType modelPar_A1W=mod.A1W;
  bool modelPar_given_A1W=mod.given("A1W");
  modParamMap["A1W"] = &modelPar_A1W;
  AdmsSensFadType modelPar_A2O=mod.A2O;
  bool modelPar_given_A2O=mod.given("A2O");
  modParamMap["A2O"] = &modelPar_A2O;
  AdmsSensFadType modelPar_STA2O=mod.STA2O;
  bool modelPar_given_STA2O=mod.given("STA2O");
  modParamMap["STA2O"] = &modelPar_STA2O;
  AdmsSensFadType modelPar_A3O=mod.A3O;
  bool modelPar_given_A3O=mod.given("A3O");
  modParamMap["A3O"] = &modelPar_A3O;
  AdmsSensFadType modelPar_A3L=mod.A3L;
  bool modelPar_given_A3L=mod.given("A3L");
  modParamMap["A3L"] = &modelPar_A3L;
  AdmsSensFadType modelPar_A3W=mod.A3W;
  bool modelPar_given_A3W=mod.given("A3W");
  modParamMap["A3W"] = &modelPar_A3W;
  AdmsSensFadType modelPar_A4O=mod.A4O;
  bool modelPar_given_A4O=mod.given("A4O");
  modParamMap["A4O"] = &modelPar_A4O;
  AdmsSensFadType modelPar_A4L=mod.A4L;
  bool modelPar_given_A4L=mod.given("A4L");
  modParamMap["A4L"] = &modelPar_A4L;
  AdmsSensFadType modelPar_A4W=mod.A4W;
  bool modelPar_given_A4W=mod.given("A4W");
  modParamMap["A4W"] = &modelPar_A4W;
  AdmsSensFadType modelPar_GCOO=mod.GCOO;
  bool modelPar_given_GCOO=mod.given("GCOO");
  modParamMap["GCOO"] = &modelPar_GCOO;
  AdmsSensFadType modelPar_IGINVLW=mod.IGINVLW;
  bool modelPar_given_IGINVLW=mod.given("IGINVLW");
  modParamMap["IGINVLW"] = &modelPar_IGINVLW;
  AdmsSensFadType modelPar_IGOVW=mod.IGOVW;
  bool modelPar_given_IGOVW=mod.given("IGOVW");
  modParamMap["IGOVW"] = &modelPar_IGOVW;
  AdmsSensFadType modelPar_IGOVDW=mod.IGOVDW;
  bool modelPar_given_IGOVDW=mod.given("IGOVDW");
  modParamMap["IGOVDW"] = &modelPar_IGOVDW;
  AdmsSensFadType modelPar_STIGO=mod.STIGO;
  bool modelPar_given_STIGO=mod.given("STIGO");
  modParamMap["STIGO"] = &modelPar_STIGO;
  AdmsSensFadType modelPar_GC2O=mod.GC2O;
  bool modelPar_given_GC2O=mod.given("GC2O");
  modParamMap["GC2O"] = &modelPar_GC2O;
  AdmsSensFadType modelPar_GC3O=mod.GC3O;
  bool modelPar_given_GC3O=mod.given("GC3O");
  modParamMap["GC3O"] = &modelPar_GC3O;
  AdmsSensFadType modelPar_CHIBO=mod.CHIBO;
  bool modelPar_given_CHIBO=mod.given("CHIBO");
  modParamMap["CHIBO"] = &modelPar_CHIBO;
  AdmsSensFadType modelPar_AGIDLW=mod.AGIDLW;
  bool modelPar_given_AGIDLW=mod.given("AGIDLW");
  modParamMap["AGIDLW"] = &modelPar_AGIDLW;
  AdmsSensFadType modelPar_AGIDLDW=mod.AGIDLDW;
  bool modelPar_given_AGIDLDW=mod.given("AGIDLDW");
  modParamMap["AGIDLDW"] = &modelPar_AGIDLDW;
  AdmsSensFadType modelPar_BGIDLO=mod.BGIDLO;
  bool modelPar_given_BGIDLO=mod.given("BGIDLO");
  modParamMap["BGIDLO"] = &modelPar_BGIDLO;
  AdmsSensFadType modelPar_BGIDLDO=mod.BGIDLDO;
  bool modelPar_given_BGIDLDO=mod.given("BGIDLDO");
  modParamMap["BGIDLDO"] = &modelPar_BGIDLDO;
  AdmsSensFadType modelPar_STBGIDLO=mod.STBGIDLO;
  bool modelPar_given_STBGIDLO=mod.given("STBGIDLO");
  modParamMap["STBGIDLO"] = &modelPar_STBGIDLO;
  AdmsSensFadType modelPar_STBGIDLDO=mod.STBGIDLDO;
  bool modelPar_given_STBGIDLDO=mod.given("STBGIDLDO");
  modParamMap["STBGIDLDO"] = &modelPar_STBGIDLDO;
  AdmsSensFadType modelPar_CGIDLO=mod.CGIDLO;
  bool modelPar_given_CGIDLO=mod.given("CGIDLO");
  modParamMap["CGIDLO"] = &modelPar_CGIDLO;
  AdmsSensFadType modelPar_CGIDLDO=mod.CGIDLDO;
  bool modelPar_given_CGIDLDO=mod.given("CGIDLDO");
  modParamMap["CGIDLDO"] = &modelPar_CGIDLDO;
  AdmsSensFadType modelPar_CGBOVL=mod.CGBOVL;
  bool modelPar_given_CGBOVL=mod.given("CGBOVL");
  modParamMap["CGBOVL"] = &modelPar_CGBOVL;
  AdmsSensFadType modelPar_CFRW=mod.CFRW;
  bool modelPar_given_CFRW=mod.given("CFRW");
  modParamMap["CFRW"] = &modelPar_CFRW;
  AdmsSensFadType modelPar_CFRDW=mod.CFRDW;
  bool modelPar_given_CFRDW=mod.given("CFRDW");
  modParamMap["CFRDW"] = &modelPar_CFRDW;
  AdmsSensFadType modelPar_FNTO=mod.FNTO;
  bool modelPar_given_FNTO=mod.given("FNTO");
  modParamMap["FNTO"] = &modelPar_FNTO;
  AdmsSensFadType modelPar_FNTEXCL=mod.FNTEXCL;
  bool modelPar_given_FNTEXCL=mod.given("FNTEXCL");
  modParamMap["FNTEXCL"] = &modelPar_FNTEXCL;
  AdmsSensFadType modelPar_NFALW=mod.NFALW;
  bool modelPar_given_NFALW=mod.given("NFALW");
  modParamMap["NFALW"] = &modelPar_NFALW;
  AdmsSensFadType modelPar_NFBLW=mod.NFBLW;
  bool modelPar_given_NFBLW=mod.given("NFBLW");
  modParamMap["NFBLW"] = &modelPar_NFBLW;
  AdmsSensFadType modelPar_NFCLW=mod.NFCLW;
  bool modelPar_given_NFCLW=mod.given("NFCLW");
  modParamMap["NFCLW"] = &modelPar_NFCLW;
  AdmsSensFadType modelPar_EFO=mod.EFO;
  bool modelPar_given_EFO=mod.given("EFO");
  modParamMap["EFO"] = &modelPar_EFO;
  AdmsSensFadType modelPar_LINTNOI=mod.LINTNOI;
  bool modelPar_given_LINTNOI=mod.given("LINTNOI");
  modParamMap["LINTNOI"] = &modelPar_LINTNOI;
  AdmsSensFadType modelPar_ALPNOI=mod.ALPNOI;
  bool modelPar_given_ALPNOI=mod.given("ALPNOI");
  modParamMap["ALPNOI"] = &modelPar_ALPNOI;
  AdmsSensFadType modelPar_WEDGE=mod.WEDGE;
  bool modelPar_given_WEDGE=mod.given("WEDGE");
  modParamMap["WEDGE"] = &modelPar_WEDGE;
  AdmsSensFadType modelPar_WEDGEW=mod.WEDGEW;
  bool modelPar_given_WEDGEW=mod.given("WEDGEW");
  modParamMap["WEDGEW"] = &modelPar_WEDGEW;
  AdmsSensFadType modelPar_VFBEDGEO=mod.VFBEDGEO;
  bool modelPar_given_VFBEDGEO=mod.given("VFBEDGEO");
  modParamMap["VFBEDGEO"] = &modelPar_VFBEDGEO;
  AdmsSensFadType modelPar_STVFBEDGEO=mod.STVFBEDGEO;
  bool modelPar_given_STVFBEDGEO=mod.given("STVFBEDGEO");
  modParamMap["STVFBEDGEO"] = &modelPar_STVFBEDGEO;
  AdmsSensFadType modelPar_STVFBEDGEL=mod.STVFBEDGEL;
  bool modelPar_given_STVFBEDGEL=mod.given("STVFBEDGEL");
  modParamMap["STVFBEDGEL"] = &modelPar_STVFBEDGEL;
  AdmsSensFadType modelPar_STVFBEDGEW=mod.STVFBEDGEW;
  bool modelPar_given_STVFBEDGEW=mod.given("STVFBEDGEW");
  modParamMap["STVFBEDGEW"] = &modelPar_STVFBEDGEW;
  AdmsSensFadType modelPar_STVFBEDGELW=mod.STVFBEDGELW;
  bool modelPar_given_STVFBEDGELW=mod.given("STVFBEDGELW");
  modParamMap["STVFBEDGELW"] = &modelPar_STVFBEDGELW;
  AdmsSensFadType modelPar_DPHIBEDGEO=mod.DPHIBEDGEO;
  bool modelPar_given_DPHIBEDGEO=mod.given("DPHIBEDGEO");
  modParamMap["DPHIBEDGEO"] = &modelPar_DPHIBEDGEO;
  AdmsSensFadType modelPar_DPHIBEDGEL=mod.DPHIBEDGEL;
  bool modelPar_given_DPHIBEDGEL=mod.given("DPHIBEDGEL");
  modParamMap["DPHIBEDGEL"] = &modelPar_DPHIBEDGEL;
  AdmsSensFadType modelPar_DPHIBEDGELEXP=mod.DPHIBEDGELEXP;
  bool modelPar_given_DPHIBEDGELEXP=mod.given("DPHIBEDGELEXP");
  modParamMap["DPHIBEDGELEXP"] = &modelPar_DPHIBEDGELEXP;
  AdmsSensFadType modelPar_DPHIBEDGEW=mod.DPHIBEDGEW;
  bool modelPar_given_DPHIBEDGEW=mod.given("DPHIBEDGEW");
  modParamMap["DPHIBEDGEW"] = &modelPar_DPHIBEDGEW;
  AdmsSensFadType modelPar_DPHIBEDGELW=mod.DPHIBEDGELW;
  bool modelPar_given_DPHIBEDGELW=mod.given("DPHIBEDGELW");
  modParamMap["DPHIBEDGELW"] = &modelPar_DPHIBEDGELW;
  AdmsSensFadType modelPar_NSUBEDGEO=mod.NSUBEDGEO;
  bool modelPar_given_NSUBEDGEO=mod.given("NSUBEDGEO");
  modParamMap["NSUBEDGEO"] = &modelPar_NSUBEDGEO;
  AdmsSensFadType modelPar_NSUBEDGEL=mod.NSUBEDGEL;
  bool modelPar_given_NSUBEDGEL=mod.given("NSUBEDGEL");
  modParamMap["NSUBEDGEL"] = &modelPar_NSUBEDGEL;
  AdmsSensFadType modelPar_NSUBEDGEW=mod.NSUBEDGEW;
  bool modelPar_given_NSUBEDGEW=mod.given("NSUBEDGEW");
  modParamMap["NSUBEDGEW"] = &modelPar_NSUBEDGEW;
  AdmsSensFadType modelPar_NSUBEDGELW=mod.NSUBEDGELW;
  bool modelPar_given_NSUBEDGELW=mod.given("NSUBEDGELW");
  modParamMap["NSUBEDGELW"] = &modelPar_NSUBEDGELW;
  AdmsSensFadType modelPar_CTEDGEO=mod.CTEDGEO;
  bool modelPar_given_CTEDGEO=mod.given("CTEDGEO");
  modParamMap["CTEDGEO"] = &modelPar_CTEDGEO;
  AdmsSensFadType modelPar_CTEDGEL=mod.CTEDGEL;
  bool modelPar_given_CTEDGEL=mod.given("CTEDGEL");
  modParamMap["CTEDGEL"] = &modelPar_CTEDGEL;
  AdmsSensFadType modelPar_CTEDGELEXP=mod.CTEDGELEXP;
  bool modelPar_given_CTEDGELEXP=mod.given("CTEDGELEXP");
  modParamMap["CTEDGELEXP"] = &modelPar_CTEDGELEXP;
  AdmsSensFadType modelPar_FBETEDGE=mod.FBETEDGE;
  bool modelPar_given_FBETEDGE=mod.given("FBETEDGE");
  modParamMap["FBETEDGE"] = &modelPar_FBETEDGE;
  AdmsSensFadType modelPar_LPEDGE=mod.LPEDGE;
  bool modelPar_given_LPEDGE=mod.given("LPEDGE");
  modParamMap["LPEDGE"] = &modelPar_LPEDGE;
  AdmsSensFadType modelPar_BETEDGEW=mod.BETEDGEW;
  bool modelPar_given_BETEDGEW=mod.given("BETEDGEW");
  modParamMap["BETEDGEW"] = &modelPar_BETEDGEW;
  AdmsSensFadType modelPar_STBETEDGEO=mod.STBETEDGEO;
  bool modelPar_given_STBETEDGEO=mod.given("STBETEDGEO");
  modParamMap["STBETEDGEO"] = &modelPar_STBETEDGEO;
  AdmsSensFadType modelPar_STBETEDGEL=mod.STBETEDGEL;
  bool modelPar_given_STBETEDGEL=mod.given("STBETEDGEL");
  modParamMap["STBETEDGEL"] = &modelPar_STBETEDGEL;
  AdmsSensFadType modelPar_STBETEDGEW=mod.STBETEDGEW;
  bool modelPar_given_STBETEDGEW=mod.given("STBETEDGEW");
  modParamMap["STBETEDGEW"] = &modelPar_STBETEDGEW;
  AdmsSensFadType modelPar_STBETEDGELW=mod.STBETEDGELW;
  bool modelPar_given_STBETEDGELW=mod.given("STBETEDGELW");
  modParamMap["STBETEDGELW"] = &modelPar_STBETEDGELW;
  AdmsSensFadType modelPar_PSCEEDGEL=mod.PSCEEDGEL;
  bool modelPar_given_PSCEEDGEL=mod.given("PSCEEDGEL");
  modParamMap["PSCEEDGEL"] = &modelPar_PSCEEDGEL;
  AdmsSensFadType modelPar_PSCEEDGELEXP=mod.PSCEEDGELEXP;
  bool modelPar_given_PSCEEDGELEXP=mod.given("PSCEEDGELEXP");
  modParamMap["PSCEEDGELEXP"] = &modelPar_PSCEEDGELEXP;
  AdmsSensFadType modelPar_PSCEEDGEW=mod.PSCEEDGEW;
  bool modelPar_given_PSCEEDGEW=mod.given("PSCEEDGEW");
  modParamMap["PSCEEDGEW"] = &modelPar_PSCEEDGEW;
  AdmsSensFadType modelPar_PSCEBEDGEO=mod.PSCEBEDGEO;
  bool modelPar_given_PSCEBEDGEO=mod.given("PSCEBEDGEO");
  modParamMap["PSCEBEDGEO"] = &modelPar_PSCEBEDGEO;
  AdmsSensFadType modelPar_PSCEDEDGEO=mod.PSCEDEDGEO;
  bool modelPar_given_PSCEDEDGEO=mod.given("PSCEDEDGEO");
  modParamMap["PSCEDEDGEO"] = &modelPar_PSCEDEDGEO;
  AdmsSensFadType modelPar_CFEDGEL=mod.CFEDGEL;
  bool modelPar_given_CFEDGEL=mod.given("CFEDGEL");
  modParamMap["CFEDGEL"] = &modelPar_CFEDGEL;
  AdmsSensFadType modelPar_CFEDGELEXP=mod.CFEDGELEXP;
  bool modelPar_given_CFEDGELEXP=mod.given("CFEDGELEXP");
  modParamMap["CFEDGELEXP"] = &modelPar_CFEDGELEXP;
  AdmsSensFadType modelPar_CFEDGEW=mod.CFEDGEW;
  bool modelPar_given_CFEDGEW=mod.given("CFEDGEW");
  modParamMap["CFEDGEW"] = &modelPar_CFEDGEW;
  AdmsSensFadType modelPar_CFDEDGEO=mod.CFDEDGEO;
  bool modelPar_given_CFDEDGEO=mod.given("CFDEDGEO");
  modParamMap["CFDEDGEO"] = &modelPar_CFDEDGEO;
  AdmsSensFadType modelPar_CFBEDGEO=mod.CFBEDGEO;
  bool modelPar_given_CFBEDGEO=mod.given("CFBEDGEO");
  modParamMap["CFBEDGEO"] = &modelPar_CFBEDGEO;
  AdmsSensFadType modelPar_FNTEDGEO=mod.FNTEDGEO;
  bool modelPar_given_FNTEDGEO=mod.given("FNTEDGEO");
  modParamMap["FNTEDGEO"] = &modelPar_FNTEDGEO;
  AdmsSensFadType modelPar_NFAEDGELW=mod.NFAEDGELW;
  bool modelPar_given_NFAEDGELW=mod.given("NFAEDGELW");
  modParamMap["NFAEDGELW"] = &modelPar_NFAEDGELW;
  AdmsSensFadType modelPar_NFBEDGELW=mod.NFBEDGELW;
  bool modelPar_given_NFBEDGELW=mod.given("NFBEDGELW");
  modParamMap["NFBEDGELW"] = &modelPar_NFBEDGELW;
  AdmsSensFadType modelPar_NFCEDGELW=mod.NFCEDGELW;
  bool modelPar_given_NFCEDGELW=mod.given("NFCEDGELW");
  modParamMap["NFCEDGELW"] = &modelPar_NFCEDGELW;
  AdmsSensFadType modelPar_EFEDGEO=mod.EFEDGEO;
  bool modelPar_given_EFEDGEO=mod.given("EFEDGEO");
  modParamMap["EFEDGEO"] = &modelPar_EFEDGEO;
  AdmsSensFadType modelPar_KVTHOWEO=mod.KVTHOWEO;
  bool modelPar_given_KVTHOWEO=mod.given("KVTHOWEO");
  modParamMap["KVTHOWEO"] = &modelPar_KVTHOWEO;
  AdmsSensFadType modelPar_KVTHOWEL=mod.KVTHOWEL;
  bool modelPar_given_KVTHOWEL=mod.given("KVTHOWEL");
  modParamMap["KVTHOWEL"] = &modelPar_KVTHOWEL;
  AdmsSensFadType modelPar_KVTHOWEW=mod.KVTHOWEW;
  bool modelPar_given_KVTHOWEW=mod.given("KVTHOWEW");
  modParamMap["KVTHOWEW"] = &modelPar_KVTHOWEW;
  AdmsSensFadType modelPar_KVTHOWELW=mod.KVTHOWELW;
  bool modelPar_given_KVTHOWELW=mod.given("KVTHOWELW");
  modParamMap["KVTHOWELW"] = &modelPar_KVTHOWELW;
  AdmsSensFadType modelPar_KUOWEO=mod.KUOWEO;
  bool modelPar_given_KUOWEO=mod.given("KUOWEO");
  modParamMap["KUOWEO"] = &modelPar_KUOWEO;
  AdmsSensFadType modelPar_KUOWEL=mod.KUOWEL;
  bool modelPar_given_KUOWEL=mod.given("KUOWEL");
  modParamMap["KUOWEL"] = &modelPar_KUOWEL;
  AdmsSensFadType modelPar_KUOWEW=mod.KUOWEW;
  bool modelPar_given_KUOWEW=mod.given("KUOWEW");
  modParamMap["KUOWEW"] = &modelPar_KUOWEW;
  AdmsSensFadType modelPar_KUOWELW=mod.KUOWELW;
  bool modelPar_given_KUOWELW=mod.given("KUOWELW");
  modParamMap["KUOWELW"] = &modelPar_KUOWELW;
  AdmsSensFadType modelPar_RGO=mod.RGO;
  bool modelPar_given_RGO=mod.given("RGO");
  modParamMap["RGO"] = &modelPar_RGO;
  AdmsSensFadType modelPar_RINT=mod.RINT;
  bool modelPar_given_RINT=mod.given("RINT");
  modParamMap["RINT"] = &modelPar_RINT;
  AdmsSensFadType modelPar_RVPOLY=mod.RVPOLY;
  bool modelPar_given_RVPOLY=mod.given("RVPOLY");
  modParamMap["RVPOLY"] = &modelPar_RVPOLY;
  AdmsSensFadType modelPar_RSHG=mod.RSHG;
  bool modelPar_given_RSHG=mod.given("RSHG");
  modParamMap["RSHG"] = &modelPar_RSHG;
  AdmsSensFadType modelPar_DLSIL=mod.DLSIL;
  bool modelPar_given_DLSIL=mod.given("DLSIL");
  modParamMap["DLSIL"] = &modelPar_DLSIL;
  AdmsSensFadType modelPar_RSH=mod.RSH;
  bool modelPar_given_RSH=mod.given("RSH");
  modParamMap["RSH"] = &modelPar_RSH;
  AdmsSensFadType modelPar_RSHD=mod.RSHD;
  bool modelPar_given_RSHD=mod.given("RSHD");
  modParamMap["RSHD"] = &modelPar_RSHD;
  AdmsSensFadType modelPar_RBULKO=mod.RBULKO;
  bool modelPar_given_RBULKO=mod.given("RBULKO");
  modParamMap["RBULKO"] = &modelPar_RBULKO;
  AdmsSensFadType modelPar_RWELLO=mod.RWELLO;
  bool modelPar_given_RWELLO=mod.given("RWELLO");
  modParamMap["RWELLO"] = &modelPar_RWELLO;
  AdmsSensFadType modelPar_RJUNSO=mod.RJUNSO;
  bool modelPar_given_RJUNSO=mod.given("RJUNSO");
  modParamMap["RJUNSO"] = &modelPar_RJUNSO;
  AdmsSensFadType modelPar_RJUNDO=mod.RJUNDO;
  bool modelPar_given_RJUNDO=mod.given("RJUNDO");
  modParamMap["RJUNDO"] = &modelPar_RJUNDO;
  AdmsSensFadType modelPar_SAREF=mod.SAREF;
  bool modelPar_given_SAREF=mod.given("SAREF");
  modParamMap["SAREF"] = &modelPar_SAREF;
  AdmsSensFadType modelPar_SBREF=mod.SBREF;
  bool modelPar_given_SBREF=mod.given("SBREF");
  modParamMap["SBREF"] = &modelPar_SBREF;
  AdmsSensFadType modelPar_WLOD=mod.WLOD;
  bool modelPar_given_WLOD=mod.given("WLOD");
  modParamMap["WLOD"] = &modelPar_WLOD;
  AdmsSensFadType modelPar_KUO=mod.KUO;
  bool modelPar_given_KUO=mod.given("KUO");
  modParamMap["KUO"] = &modelPar_KUO;
  AdmsSensFadType modelPar_KVSAT=mod.KVSAT;
  bool modelPar_given_KVSAT=mod.given("KVSAT");
  modParamMap["KVSAT"] = &modelPar_KVSAT;
  AdmsSensFadType modelPar_TKUO=mod.TKUO;
  bool modelPar_given_TKUO=mod.given("TKUO");
  modParamMap["TKUO"] = &modelPar_TKUO;
  AdmsSensFadType modelPar_LKUO=mod.LKUO;
  bool modelPar_given_LKUO=mod.given("LKUO");
  modParamMap["LKUO"] = &modelPar_LKUO;
  AdmsSensFadType modelPar_WKUO=mod.WKUO;
  bool modelPar_given_WKUO=mod.given("WKUO");
  modParamMap["WKUO"] = &modelPar_WKUO;
  AdmsSensFadType modelPar_PKUO=mod.PKUO;
  bool modelPar_given_PKUO=mod.given("PKUO");
  modParamMap["PKUO"] = &modelPar_PKUO;
  AdmsSensFadType modelPar_LLODKUO=mod.LLODKUO;
  bool modelPar_given_LLODKUO=mod.given("LLODKUO");
  modParamMap["LLODKUO"] = &modelPar_LLODKUO;
  AdmsSensFadType modelPar_WLODKUO=mod.WLODKUO;
  bool modelPar_given_WLODKUO=mod.given("WLODKUO");
  modParamMap["WLODKUO"] = &modelPar_WLODKUO;
  AdmsSensFadType modelPar_KVTHO=mod.KVTHO;
  bool modelPar_given_KVTHO=mod.given("KVTHO");
  modParamMap["KVTHO"] = &modelPar_KVTHO;
  AdmsSensFadType modelPar_LKVTHO=mod.LKVTHO;
  bool modelPar_given_LKVTHO=mod.given("LKVTHO");
  modParamMap["LKVTHO"] = &modelPar_LKVTHO;
  AdmsSensFadType modelPar_WKVTHO=mod.WKVTHO;
  bool modelPar_given_WKVTHO=mod.given("WKVTHO");
  modParamMap["WKVTHO"] = &modelPar_WKVTHO;
  AdmsSensFadType modelPar_PKVTHO=mod.PKVTHO;
  bool modelPar_given_PKVTHO=mod.given("PKVTHO");
  modParamMap["PKVTHO"] = &modelPar_PKVTHO;
  AdmsSensFadType modelPar_LLODVTH=mod.LLODVTH;
  bool modelPar_given_LLODVTH=mod.given("LLODVTH");
  modParamMap["LLODVTH"] = &modelPar_LLODVTH;
  AdmsSensFadType modelPar_WLODVTH=mod.WLODVTH;
  bool modelPar_given_WLODVTH=mod.given("WLODVTH");
  modParamMap["WLODVTH"] = &modelPar_WLODVTH;
  AdmsSensFadType modelPar_STETAO=mod.STETAO;
  bool modelPar_given_STETAO=mod.given("STETAO");
  modParamMap["STETAO"] = &modelPar_STETAO;
  AdmsSensFadType modelPar_LODETAO=mod.LODETAO;
  bool modelPar_given_LODETAO=mod.given("LODETAO");
  modParamMap["LODETAO"] = &modelPar_LODETAO;
  AdmsSensFadType modelPar_SCREF=mod.SCREF;
  bool modelPar_given_SCREF=mod.given("SCREF");
  modParamMap["SCREF"] = &modelPar_SCREF;
  AdmsSensFadType modelPar_WEB=mod.WEB;
  bool modelPar_given_WEB=mod.given("WEB");
  modParamMap["WEB"] = &modelPar_WEB;
  AdmsSensFadType modelPar_WEC=mod.WEC;
  bool modelPar_given_WEC=mod.given("WEC");
  modParamMap["WEC"] = &modelPar_WEC;
  AdmsSensFadType modelPar_IMAX=mod.IMAX;
  bool modelPar_given_IMAX=mod.given("IMAX");
  modParamMap["IMAX"] = &modelPar_IMAX;
  AdmsSensFadType modelPar_TRJ=mod.TRJ;
  bool modelPar_given_TRJ=mod.given("TRJ");
  modParamMap["TRJ"] = &modelPar_TRJ;
  AdmsSensFadType modelPar_FREV=mod.FREV;
  bool modelPar_given_FREV=mod.given("FREV");
  modParamMap["FREV"] = &modelPar_FREV;
  AdmsSensFadType modelPar_CJORBOT=mod.CJORBOT;
  bool modelPar_given_CJORBOT=mod.given("CJORBOT");
  modParamMap["CJORBOT"] = &modelPar_CJORBOT;
  AdmsSensFadType modelPar_CJORSTI=mod.CJORSTI;
  bool modelPar_given_CJORSTI=mod.given("CJORSTI");
  modParamMap["CJORSTI"] = &modelPar_CJORSTI;
  AdmsSensFadType modelPar_CJORGAT=mod.CJORGAT;
  bool modelPar_given_CJORGAT=mod.given("CJORGAT");
  modParamMap["CJORGAT"] = &modelPar_CJORGAT;
  AdmsSensFadType modelPar_VBIRBOT=mod.VBIRBOT;
  bool modelPar_given_VBIRBOT=mod.given("VBIRBOT");
  modParamMap["VBIRBOT"] = &modelPar_VBIRBOT;
  AdmsSensFadType modelPar_VBIRSTI=mod.VBIRSTI;
  bool modelPar_given_VBIRSTI=mod.given("VBIRSTI");
  modParamMap["VBIRSTI"] = &modelPar_VBIRSTI;
  AdmsSensFadType modelPar_VBIRGAT=mod.VBIRGAT;
  bool modelPar_given_VBIRGAT=mod.given("VBIRGAT");
  modParamMap["VBIRGAT"] = &modelPar_VBIRGAT;
  AdmsSensFadType modelPar_PBOT=mod.PBOT;
  bool modelPar_given_PBOT=mod.given("PBOT");
  modParamMap["PBOT"] = &modelPar_PBOT;
  AdmsSensFadType modelPar_PSTI=mod.PSTI;
  bool modelPar_given_PSTI=mod.given("PSTI");
  modParamMap["PSTI"] = &modelPar_PSTI;
  AdmsSensFadType modelPar_PGAT=mod.PGAT;
  bool modelPar_given_PGAT=mod.given("PGAT");
  modParamMap["PGAT"] = &modelPar_PGAT;
  AdmsSensFadType modelPar_PHIGBOT=mod.PHIGBOT;
  bool modelPar_given_PHIGBOT=mod.given("PHIGBOT");
  modParamMap["PHIGBOT"] = &modelPar_PHIGBOT;
  AdmsSensFadType modelPar_PHIGSTI=mod.PHIGSTI;
  bool modelPar_given_PHIGSTI=mod.given("PHIGSTI");
  modParamMap["PHIGSTI"] = &modelPar_PHIGSTI;
  AdmsSensFadType modelPar_PHIGGAT=mod.PHIGGAT;
  bool modelPar_given_PHIGGAT=mod.given("PHIGGAT");
  modParamMap["PHIGGAT"] = &modelPar_PHIGGAT;
  AdmsSensFadType modelPar_IDSATRBOT=mod.IDSATRBOT;
  bool modelPar_given_IDSATRBOT=mod.given("IDSATRBOT");
  modParamMap["IDSATRBOT"] = &modelPar_IDSATRBOT;
  AdmsSensFadType modelPar_IDSATRSTI=mod.IDSATRSTI;
  bool modelPar_given_IDSATRSTI=mod.given("IDSATRSTI");
  modParamMap["IDSATRSTI"] = &modelPar_IDSATRSTI;
  AdmsSensFadType modelPar_IDSATRGAT=mod.IDSATRGAT;
  bool modelPar_given_IDSATRGAT=mod.given("IDSATRGAT");
  modParamMap["IDSATRGAT"] = &modelPar_IDSATRGAT;
  AdmsSensFadType modelPar_CSRHBOT=mod.CSRHBOT;
  bool modelPar_given_CSRHBOT=mod.given("CSRHBOT");
  modParamMap["CSRHBOT"] = &modelPar_CSRHBOT;
  AdmsSensFadType modelPar_CSRHSTI=mod.CSRHSTI;
  bool modelPar_given_CSRHSTI=mod.given("CSRHSTI");
  modParamMap["CSRHSTI"] = &modelPar_CSRHSTI;
  AdmsSensFadType modelPar_CSRHGAT=mod.CSRHGAT;
  bool modelPar_given_CSRHGAT=mod.given("CSRHGAT");
  modParamMap["CSRHGAT"] = &modelPar_CSRHGAT;
  AdmsSensFadType modelPar_XJUNSTI=mod.XJUNSTI;
  bool modelPar_given_XJUNSTI=mod.given("XJUNSTI");
  modParamMap["XJUNSTI"] = &modelPar_XJUNSTI;
  AdmsSensFadType modelPar_XJUNGAT=mod.XJUNGAT;
  bool modelPar_given_XJUNGAT=mod.given("XJUNGAT");
  modParamMap["XJUNGAT"] = &modelPar_XJUNGAT;
  AdmsSensFadType modelPar_CTATBOT=mod.CTATBOT;
  bool modelPar_given_CTATBOT=mod.given("CTATBOT");
  modParamMap["CTATBOT"] = &modelPar_CTATBOT;
  AdmsSensFadType modelPar_CTATSTI=mod.CTATSTI;
  bool modelPar_given_CTATSTI=mod.given("CTATSTI");
  modParamMap["CTATSTI"] = &modelPar_CTATSTI;
  AdmsSensFadType modelPar_CTATGAT=mod.CTATGAT;
  bool modelPar_given_CTATGAT=mod.given("CTATGAT");
  modParamMap["CTATGAT"] = &modelPar_CTATGAT;
  AdmsSensFadType modelPar_MEFFTATBOT=mod.MEFFTATBOT;
  bool modelPar_given_MEFFTATBOT=mod.given("MEFFTATBOT");
  modParamMap["MEFFTATBOT"] = &modelPar_MEFFTATBOT;
  AdmsSensFadType modelPar_MEFFTATSTI=mod.MEFFTATSTI;
  bool modelPar_given_MEFFTATSTI=mod.given("MEFFTATSTI");
  modParamMap["MEFFTATSTI"] = &modelPar_MEFFTATSTI;
  AdmsSensFadType modelPar_MEFFTATGAT=mod.MEFFTATGAT;
  bool modelPar_given_MEFFTATGAT=mod.given("MEFFTATGAT");
  modParamMap["MEFFTATGAT"] = &modelPar_MEFFTATGAT;
  AdmsSensFadType modelPar_CBBTBOT=mod.CBBTBOT;
  bool modelPar_given_CBBTBOT=mod.given("CBBTBOT");
  modParamMap["CBBTBOT"] = &modelPar_CBBTBOT;
  AdmsSensFadType modelPar_CBBTSTI=mod.CBBTSTI;
  bool modelPar_given_CBBTSTI=mod.given("CBBTSTI");
  modParamMap["CBBTSTI"] = &modelPar_CBBTSTI;
  AdmsSensFadType modelPar_CBBTGAT=mod.CBBTGAT;
  bool modelPar_given_CBBTGAT=mod.given("CBBTGAT");
  modParamMap["CBBTGAT"] = &modelPar_CBBTGAT;
  AdmsSensFadType modelPar_FBBTRBOT=mod.FBBTRBOT;
  bool modelPar_given_FBBTRBOT=mod.given("FBBTRBOT");
  modParamMap["FBBTRBOT"] = &modelPar_FBBTRBOT;
  AdmsSensFadType modelPar_FBBTRSTI=mod.FBBTRSTI;
  bool modelPar_given_FBBTRSTI=mod.given("FBBTRSTI");
  modParamMap["FBBTRSTI"] = &modelPar_FBBTRSTI;
  AdmsSensFadType modelPar_FBBTRGAT=mod.FBBTRGAT;
  bool modelPar_given_FBBTRGAT=mod.given("FBBTRGAT");
  modParamMap["FBBTRGAT"] = &modelPar_FBBTRGAT;
  AdmsSensFadType modelPar_STFBBTBOT=mod.STFBBTBOT;
  bool modelPar_given_STFBBTBOT=mod.given("STFBBTBOT");
  modParamMap["STFBBTBOT"] = &modelPar_STFBBTBOT;
  AdmsSensFadType modelPar_STFBBTSTI=mod.STFBBTSTI;
  bool modelPar_given_STFBBTSTI=mod.given("STFBBTSTI");
  modParamMap["STFBBTSTI"] = &modelPar_STFBBTSTI;
  AdmsSensFadType modelPar_STFBBTGAT=mod.STFBBTGAT;
  bool modelPar_given_STFBBTGAT=mod.given("STFBBTGAT");
  modParamMap["STFBBTGAT"] = &modelPar_STFBBTGAT;
  AdmsSensFadType modelPar_VBRBOT=mod.VBRBOT;
  bool modelPar_given_VBRBOT=mod.given("VBRBOT");
  modParamMap["VBRBOT"] = &modelPar_VBRBOT;
  AdmsSensFadType modelPar_VBRSTI=mod.VBRSTI;
  bool modelPar_given_VBRSTI=mod.given("VBRSTI");
  modParamMap["VBRSTI"] = &modelPar_VBRSTI;
  AdmsSensFadType modelPar_VBRGAT=mod.VBRGAT;
  bool modelPar_given_VBRGAT=mod.given("VBRGAT");
  modParamMap["VBRGAT"] = &modelPar_VBRGAT;
  AdmsSensFadType modelPar_PBRBOT=mod.PBRBOT;
  bool modelPar_given_PBRBOT=mod.given("PBRBOT");
  modParamMap["PBRBOT"] = &modelPar_PBRBOT;
  AdmsSensFadType modelPar_PBRSTI=mod.PBRSTI;
  bool modelPar_given_PBRSTI=mod.given("PBRSTI");
  modParamMap["PBRSTI"] = &modelPar_PBRSTI;
  AdmsSensFadType modelPar_PBRGAT=mod.PBRGAT;
  bool modelPar_given_PBRGAT=mod.given("PBRGAT");
  modParamMap["PBRGAT"] = &modelPar_PBRGAT;
  AdmsSensFadType modelPar_CJORBOTD=mod.CJORBOTD;
  bool modelPar_given_CJORBOTD=mod.given("CJORBOTD");
  modParamMap["CJORBOTD"] = &modelPar_CJORBOTD;
  AdmsSensFadType modelPar_CJORSTID=mod.CJORSTID;
  bool modelPar_given_CJORSTID=mod.given("CJORSTID");
  modParamMap["CJORSTID"] = &modelPar_CJORSTID;
  AdmsSensFadType modelPar_CJORGATD=mod.CJORGATD;
  bool modelPar_given_CJORGATD=mod.given("CJORGATD");
  modParamMap["CJORGATD"] = &modelPar_CJORGATD;
  AdmsSensFadType modelPar_VBIRBOTD=mod.VBIRBOTD;
  bool modelPar_given_VBIRBOTD=mod.given("VBIRBOTD");
  modParamMap["VBIRBOTD"] = &modelPar_VBIRBOTD;
  AdmsSensFadType modelPar_VBIRSTID=mod.VBIRSTID;
  bool modelPar_given_VBIRSTID=mod.given("VBIRSTID");
  modParamMap["VBIRSTID"] = &modelPar_VBIRSTID;
  AdmsSensFadType modelPar_VBIRGATD=mod.VBIRGATD;
  bool modelPar_given_VBIRGATD=mod.given("VBIRGATD");
  modParamMap["VBIRGATD"] = &modelPar_VBIRGATD;
  AdmsSensFadType modelPar_PBOTD=mod.PBOTD;
  bool modelPar_given_PBOTD=mod.given("PBOTD");
  modParamMap["PBOTD"] = &modelPar_PBOTD;
  AdmsSensFadType modelPar_PSTID=mod.PSTID;
  bool modelPar_given_PSTID=mod.given("PSTID");
  modParamMap["PSTID"] = &modelPar_PSTID;
  AdmsSensFadType modelPar_PGATD=mod.PGATD;
  bool modelPar_given_PGATD=mod.given("PGATD");
  modParamMap["PGATD"] = &modelPar_PGATD;
  AdmsSensFadType modelPar_PHIGBOTD=mod.PHIGBOTD;
  bool modelPar_given_PHIGBOTD=mod.given("PHIGBOTD");
  modParamMap["PHIGBOTD"] = &modelPar_PHIGBOTD;
  AdmsSensFadType modelPar_PHIGSTID=mod.PHIGSTID;
  bool modelPar_given_PHIGSTID=mod.given("PHIGSTID");
  modParamMap["PHIGSTID"] = &modelPar_PHIGSTID;
  AdmsSensFadType modelPar_PHIGGATD=mod.PHIGGATD;
  bool modelPar_given_PHIGGATD=mod.given("PHIGGATD");
  modParamMap["PHIGGATD"] = &modelPar_PHIGGATD;
  AdmsSensFadType modelPar_IDSATRBOTD=mod.IDSATRBOTD;
  bool modelPar_given_IDSATRBOTD=mod.given("IDSATRBOTD");
  modParamMap["IDSATRBOTD"] = &modelPar_IDSATRBOTD;
  AdmsSensFadType modelPar_IDSATRSTID=mod.IDSATRSTID;
  bool modelPar_given_IDSATRSTID=mod.given("IDSATRSTID");
  modParamMap["IDSATRSTID"] = &modelPar_IDSATRSTID;
  AdmsSensFadType modelPar_IDSATRGATD=mod.IDSATRGATD;
  bool modelPar_given_IDSATRGATD=mod.given("IDSATRGATD");
  modParamMap["IDSATRGATD"] = &modelPar_IDSATRGATD;
  AdmsSensFadType modelPar_CSRHBOTD=mod.CSRHBOTD;
  bool modelPar_given_CSRHBOTD=mod.given("CSRHBOTD");
  modParamMap["CSRHBOTD"] = &modelPar_CSRHBOTD;
  AdmsSensFadType modelPar_CSRHSTID=mod.CSRHSTID;
  bool modelPar_given_CSRHSTID=mod.given("CSRHSTID");
  modParamMap["CSRHSTID"] = &modelPar_CSRHSTID;
  AdmsSensFadType modelPar_CSRHGATD=mod.CSRHGATD;
  bool modelPar_given_CSRHGATD=mod.given("CSRHGATD");
  modParamMap["CSRHGATD"] = &modelPar_CSRHGATD;
  AdmsSensFadType modelPar_XJUNSTID=mod.XJUNSTID;
  bool modelPar_given_XJUNSTID=mod.given("XJUNSTID");
  modParamMap["XJUNSTID"] = &modelPar_XJUNSTID;
  AdmsSensFadType modelPar_XJUNGATD=mod.XJUNGATD;
  bool modelPar_given_XJUNGATD=mod.given("XJUNGATD");
  modParamMap["XJUNGATD"] = &modelPar_XJUNGATD;
  AdmsSensFadType modelPar_CTATBOTD=mod.CTATBOTD;
  bool modelPar_given_CTATBOTD=mod.given("CTATBOTD");
  modParamMap["CTATBOTD"] = &modelPar_CTATBOTD;
  AdmsSensFadType modelPar_CTATSTID=mod.CTATSTID;
  bool modelPar_given_CTATSTID=mod.given("CTATSTID");
  modParamMap["CTATSTID"] = &modelPar_CTATSTID;
  AdmsSensFadType modelPar_CTATGATD=mod.CTATGATD;
  bool modelPar_given_CTATGATD=mod.given("CTATGATD");
  modParamMap["CTATGATD"] = &modelPar_CTATGATD;
  AdmsSensFadType modelPar_MEFFTATBOTD=mod.MEFFTATBOTD;
  bool modelPar_given_MEFFTATBOTD=mod.given("MEFFTATBOTD");
  modParamMap["MEFFTATBOTD"] = &modelPar_MEFFTATBOTD;
  AdmsSensFadType modelPar_MEFFTATSTID=mod.MEFFTATSTID;
  bool modelPar_given_MEFFTATSTID=mod.given("MEFFTATSTID");
  modParamMap["MEFFTATSTID"] = &modelPar_MEFFTATSTID;
  AdmsSensFadType modelPar_MEFFTATGATD=mod.MEFFTATGATD;
  bool modelPar_given_MEFFTATGATD=mod.given("MEFFTATGATD");
  modParamMap["MEFFTATGATD"] = &modelPar_MEFFTATGATD;
  AdmsSensFadType modelPar_CBBTBOTD=mod.CBBTBOTD;
  bool modelPar_given_CBBTBOTD=mod.given("CBBTBOTD");
  modParamMap["CBBTBOTD"] = &modelPar_CBBTBOTD;
  AdmsSensFadType modelPar_CBBTSTID=mod.CBBTSTID;
  bool modelPar_given_CBBTSTID=mod.given("CBBTSTID");
  modParamMap["CBBTSTID"] = &modelPar_CBBTSTID;
  AdmsSensFadType modelPar_CBBTGATD=mod.CBBTGATD;
  bool modelPar_given_CBBTGATD=mod.given("CBBTGATD");
  modParamMap["CBBTGATD"] = &modelPar_CBBTGATD;
  AdmsSensFadType modelPar_FBBTRBOTD=mod.FBBTRBOTD;
  bool modelPar_given_FBBTRBOTD=mod.given("FBBTRBOTD");
  modParamMap["FBBTRBOTD"] = &modelPar_FBBTRBOTD;
  AdmsSensFadType modelPar_FBBTRSTID=mod.FBBTRSTID;
  bool modelPar_given_FBBTRSTID=mod.given("FBBTRSTID");
  modParamMap["FBBTRSTID"] = &modelPar_FBBTRSTID;
  AdmsSensFadType modelPar_FBBTRGATD=mod.FBBTRGATD;
  bool modelPar_given_FBBTRGATD=mod.given("FBBTRGATD");
  modParamMap["FBBTRGATD"] = &modelPar_FBBTRGATD;
  AdmsSensFadType modelPar_STFBBTBOTD=mod.STFBBTBOTD;
  bool modelPar_given_STFBBTBOTD=mod.given("STFBBTBOTD");
  modParamMap["STFBBTBOTD"] = &modelPar_STFBBTBOTD;
  AdmsSensFadType modelPar_STFBBTSTID=mod.STFBBTSTID;
  bool modelPar_given_STFBBTSTID=mod.given("STFBBTSTID");
  modParamMap["STFBBTSTID"] = &modelPar_STFBBTSTID;
  AdmsSensFadType modelPar_STFBBTGATD=mod.STFBBTGATD;
  bool modelPar_given_STFBBTGATD=mod.given("STFBBTGATD");
  modParamMap["STFBBTGATD"] = &modelPar_STFBBTGATD;
  AdmsSensFadType modelPar_VBRBOTD=mod.VBRBOTD;
  bool modelPar_given_VBRBOTD=mod.given("VBRBOTD");
  modParamMap["VBRBOTD"] = &modelPar_VBRBOTD;
  AdmsSensFadType modelPar_VBRSTID=mod.VBRSTID;
  bool modelPar_given_VBRSTID=mod.given("VBRSTID");
  modParamMap["VBRSTID"] = &modelPar_VBRSTID;
  AdmsSensFadType modelPar_VBRGATD=mod.VBRGATD;
  bool modelPar_given_VBRGATD=mod.given("VBRGATD");
  modParamMap["VBRGATD"] = &modelPar_VBRGATD;
  AdmsSensFadType modelPar_PBRBOTD=mod.PBRBOTD;
  bool modelPar_given_PBRBOTD=mod.given("PBRBOTD");
  modParamMap["PBRBOTD"] = &modelPar_PBRBOTD;
  AdmsSensFadType modelPar_PBRSTID=mod.PBRSTID;
  bool modelPar_given_PBRSTID=mod.given("PBRSTID");
  modParamMap["PBRSTID"] = &modelPar_PBRSTID;
  AdmsSensFadType modelPar_PBRGATD=mod.PBRGATD;
  bool modelPar_given_PBRGATD=mod.given("PBRGATD");
  modParamMap["PBRGATD"] = &modelPar_PBRGATD;
  AdmsSensFadType modelPar_SWJUNEXP=mod.SWJUNEXP;
  bool modelPar_given_SWJUNEXP=mod.given("SWJUNEXP");
  modParamMap["SWJUNEXP"] = &modelPar_SWJUNEXP;
  AdmsSensFadType modelPar_VJUNREF=mod.VJUNREF;
  bool modelPar_given_VJUNREF=mod.given("VJUNREF");
  modParamMap["VJUNREF"] = &modelPar_VJUNREF;
  AdmsSensFadType modelPar_FJUNQ=mod.FJUNQ;
  bool modelPar_given_FJUNQ=mod.given("FJUNQ");
  modParamMap["FJUNQ"] = &modelPar_FJUNQ;
  AdmsSensFadType modelPar_VJUNREFD=mod.VJUNREFD;
  bool modelPar_given_VJUNREFD=mod.given("VJUNREFD");
  modParamMap["VJUNREFD"] = &modelPar_VJUNREFD;
  AdmsSensFadType modelPar_FJUNQD=mod.FJUNQD;
  bool modelPar_given_FJUNQD=mod.given("FJUNQD");
  modParamMap["FJUNQD"] = &modelPar_FJUNQD;
  AdmsSensFadType modelPar_DTA=mod.DTA;
  bool modelPar_given_DTA=mod.given("DTA");
  modParamMap["DTA"] = &modelPar_DTA;


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_LEVEL=mod.LEVEL;
  bool modelPar_given_LEVEL=mod.given("LEVEL");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");
  int modelPar_SWGEO=mod.SWGEO;
  bool modelPar_given_SWGEO=mod.given("SWGEO");
  int modelPar_SWIGATE=mod.SWIGATE;
  bool modelPar_given_SWIGATE=mod.given("SWIGATE");
  int modelPar_SWIMPACT=mod.SWIMPACT;
  bool modelPar_given_SWIMPACT=mod.given("SWIMPACT");
  int modelPar_SWGIDL=mod.SWGIDL;
  bool modelPar_given_SWGIDL=mod.given("SWGIDL");
  int modelPar_SWJUNCAP=mod.SWJUNCAP;
  bool modelPar_given_SWJUNCAP=mod.given("SWJUNCAP");
  int modelPar_SWJUNASYM=mod.SWJUNASYM;
  bool modelPar_given_SWJUNASYM=mod.given("SWJUNASYM");
  int modelPar_SWNUD=mod.SWNUD;
  bool modelPar_given_SWNUD=mod.given("SWNUD");
  int modelPar_SWEDGE=mod.SWEDGE;
  bool modelPar_given_SWEDGE=mod.given("SWEDGE");
  int modelPar_SWDELVTAC=mod.SWDELVTAC;
  bool modelPar_given_SWDELVTAC=mod.given("SWDELVTAC");
  int modelPar_SWIGN=mod.SWIGN;
  bool modelPar_given_SWIGN=mod.given("SWIGN");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals
  AdmsSensFadType modelVar_TOXO_i=mod.TOXO_i;
  AdmsSensFadType modelVar_EPSROXO_i=mod.EPSROXO_i;
  AdmsSensFadType modelVar_NSUBO_i=mod.NSUBO_i;
  AdmsSensFadType modelVar_WSEG_i=mod.WSEG_i;
  AdmsSensFadType modelVar_NPCK_i=mod.NPCK_i;
  AdmsSensFadType modelVar_WSEGP_i=mod.WSEGP_i;
  AdmsSensFadType modelVar_LPCK_i=mod.LPCK_i;
  AdmsSensFadType modelVar_TOXOVO_i=mod.TOXOVO_i;
  AdmsSensFadType modelVar_TOXOVDO_i=mod.TOXOVDO_i;
  AdmsSensFadType modelVar_LOV_i=mod.LOV_i;
  AdmsSensFadType modelVar_LOVD_i=mod.LOVD_i;
  AdmsSensFadType modelVar_LP1_i=mod.LP1_i;
  AdmsSensFadType modelVar_LP2_i=mod.LP2_i;
  AdmsSensFadType modelVar_WBET_i=mod.WBET_i;
  AdmsSensFadType modelVar_AXL_i=mod.AXL_i;
  AdmsSensFadType modelVar_ALP1L2_i=mod.ALP1L2_i;
  AdmsSensFadType modelVar_ALP2L2_i=mod.ALP2L2_i;
  AdmsSensFadType modelVar_SAREF_i=mod.SAREF_i;
  AdmsSensFadType modelVar_SBREF_i=mod.SBREF_i;
  AdmsSensFadType modelVar_KVSAT_i=mod.KVSAT_i;
  AdmsSensFadType modelVar_LLODKUO_i=mod.LLODKUO_i;
  AdmsSensFadType modelVar_WLODKUO_i=mod.WLODKUO_i;
  AdmsSensFadType modelVar_LLODVTH_i=mod.LLODVTH_i;
  AdmsSensFadType modelVar_WLODVTH_i=mod.WLODVTH_i;
  AdmsSensFadType modelVar_LODETAO_i=mod.LODETAO_i;
  AdmsSensFadType modelVar_SCREF_i=mod.SCREF_i;
  AdmsSensFadType modelVar_WEB_i=mod.WEB_i;
  AdmsSensFadType modelVar_WEC_i=mod.WEC_i;
  AdmsSensFadType modelVar_RSHG_i=mod.RSHG_i;
  AdmsSensFadType modelVar_RSH_i=mod.RSH_i;
  AdmsSensFadType modelVar_RSHD_i=mod.RSHD_i;
  AdmsSensFadType modelVar_RINT_i=mod.RINT_i;
  AdmsSensFadType modelVar_RVPOLY_i=mod.RVPOLY_i;
  AdmsSensFadType modelVar_NSUBEDGEO_i=mod.NSUBEDGEO_i;
  AdmsSensFadType modelVar_LPEDGE_i=mod.LPEDGE_i;
  AdmsSensFadType modelVar_QMC_i=mod.QMC_i;
  AdmsSensFadType modelVar_rTa=mod.rTa;
  AdmsSensFadType modelVar_delTa=mod.delTa;
  AdmsSensFadType modelVar_phita=mod.phita;
  AdmsSensFadType modelVar_inv_phita=mod.inv_phita;
  AdmsSensFadType modelVar_TKD=mod.TKD;
  AdmsSensFadType modelVar_delT=mod.delT;
  AdmsSensFadType modelVar_rTn=mod.rTn;
  AdmsSensFadType modelVar_ln_rTn=mod.ln_rTn;
  AdmsSensFadType modelVar_inv_phit=mod.inv_phit;
  AdmsSensFadType modelVar_Eg=mod.Eg;
  AdmsSensFadType modelVar_phibFac=mod.phibFac;
  AdmsSensFadType modelVar_IMAX_i=mod.IMAX_i;
  AdmsSensFadType modelVar_VBIRBOT_i=mod.VBIRBOT_i;
  AdmsSensFadType modelVar_VBIRSTI_i=mod.VBIRSTI_i;
  AdmsSensFadType modelVar_VBIRGAT_i=mod.VBIRGAT_i;
  AdmsSensFadType modelVar_PBOT_i=mod.PBOT_i;
  AdmsSensFadType modelVar_PSTI_i=mod.PSTI_i;
  AdmsSensFadType modelVar_PGAT_i=mod.PGAT_i;
  AdmsSensFadType modelVar_CSRHBOT_i=mod.CSRHBOT_i;
  AdmsSensFadType modelVar_CSRHSTI_i=mod.CSRHSTI_i;
  AdmsSensFadType modelVar_CSRHGAT_i=mod.CSRHGAT_i;
  AdmsSensFadType modelVar_CTATBOT_i=mod.CTATBOT_i;
  AdmsSensFadType modelVar_CTATSTI_i=mod.CTATSTI_i;
  AdmsSensFadType modelVar_CTATGAT_i=mod.CTATGAT_i;
  AdmsSensFadType modelVar_CBBTBOT_i=mod.CBBTBOT_i;
  AdmsSensFadType modelVar_CBBTSTI_i=mod.CBBTSTI_i;
  AdmsSensFadType modelVar_CBBTGAT_i=mod.CBBTGAT_i;
  AdmsSensFadType modelVar_VBRBOT_i=mod.VBRBOT_i;
  AdmsSensFadType modelVar_VBRSTI_i=mod.VBRSTI_i;
  AdmsSensFadType modelVar_VBRGAT_i=mod.VBRGAT_i;
  AdmsSensFadType modelVar_PBRBOT_i=mod.PBRBOT_i;
  AdmsSensFadType modelVar_PBRSTI_i=mod.PBRSTI_i;
  AdmsSensFadType modelVar_PBRGAT_i=mod.PBRGAT_i;
  AdmsSensFadType modelVar_SWJUNEXP_i=mod.SWJUNEXP_i;
  AdmsSensFadType modelVar_VJUNREF_i=mod.VJUNREF_i;
  AdmsSensFadType modelVar_FJUNQ_i=mod.FJUNQ_i;
  AdmsSensFadType modelVar_phitr=mod.phitr;
  AdmsSensFadType modelVar_phitd=mod.phitd;
  AdmsSensFadType modelVar_phitdinv=mod.phitdinv;
  AdmsSensFadType modelVar_perfc=mod.perfc;
  AdmsSensFadType modelVar_berfc=mod.berfc;
  AdmsSensFadType modelVar_cerfc=mod.cerfc;
  AdmsSensFadType modelVar_ftdbot=mod.ftdbot;
  AdmsSensFadType modelVar_ftdsti=mod.ftdsti;
  AdmsSensFadType modelVar_ftdgat=mod.ftdgat;
  AdmsSensFadType modelVar_idsatbot=mod.idsatbot;
  AdmsSensFadType modelVar_idsatsti=mod.idsatsti;
  AdmsSensFadType modelVar_idsatgat=mod.idsatgat;
  AdmsSensFadType modelVar_vbibot=mod.vbibot;
  AdmsSensFadType modelVar_vbisti=mod.vbisti;
  AdmsSensFadType modelVar_vbigat=mod.vbigat;
  AdmsSensFadType modelVar_vbiinvbot=mod.vbiinvbot;
  AdmsSensFadType modelVar_vbiinvsti=mod.vbiinvsti;
  AdmsSensFadType modelVar_vbiinvgat=mod.vbiinvgat;
  AdmsSensFadType modelVar_one_minus_PBOT=mod.one_minus_PBOT;
  AdmsSensFadType modelVar_one_minus_PSTI=mod.one_minus_PSTI;
  AdmsSensFadType modelVar_one_minus_PGAT=mod.one_minus_PGAT;
  AdmsSensFadType modelVar_one_over_one_minus_PBOT=mod.one_over_one_minus_PBOT;
  AdmsSensFadType modelVar_one_over_one_minus_PSTI=mod.one_over_one_minus_PSTI;
  AdmsSensFadType modelVar_one_over_one_minus_PGAT=mod.one_over_one_minus_PGAT;
  AdmsSensFadType modelVar_cjobot=mod.cjobot;
  AdmsSensFadType modelVar_cjosti=mod.cjosti;
  AdmsSensFadType modelVar_cjogat=mod.cjogat;
  AdmsSensFadType modelVar_qprefbot=mod.qprefbot;
  AdmsSensFadType modelVar_qprefsti=mod.qprefsti;
  AdmsSensFadType modelVar_qprefgat=mod.qprefgat;
  AdmsSensFadType modelVar_qpref2bot=mod.qpref2bot;
  AdmsSensFadType modelVar_qpref2sti=mod.qpref2sti;
  AdmsSensFadType modelVar_qpref2gat=mod.qpref2gat;
  AdmsSensFadType modelVar_wdepnulrbot=mod.wdepnulrbot;
  AdmsSensFadType modelVar_wdepnulrsti=mod.wdepnulrsti;
  AdmsSensFadType modelVar_wdepnulrgat=mod.wdepnulrgat;
  AdmsSensFadType modelVar_wdepnulrinvbot=mod.wdepnulrinvbot;
  AdmsSensFadType modelVar_wdepnulrinvsti=mod.wdepnulrinvsti;
  AdmsSensFadType modelVar_wdepnulrinvgat=mod.wdepnulrinvgat;
  AdmsSensFadType modelVar_VBIRBOTinv=mod.VBIRBOTinv;
  AdmsSensFadType modelVar_VBIRSTIinv=mod.VBIRSTIinv;
  AdmsSensFadType modelVar_VBIRGATinv=mod.VBIRGATinv;
  AdmsSensFadType modelVar_atatbot=mod.atatbot;
  AdmsSensFadType modelVar_atatsti=mod.atatsti;
  AdmsSensFadType modelVar_atatgat=mod.atatgat;
  AdmsSensFadType modelVar_btatpartbot=mod.btatpartbot;
  AdmsSensFadType modelVar_btatpartsti=mod.btatpartsti;
  AdmsSensFadType modelVar_btatpartgat=mod.btatpartgat;
  AdmsSensFadType modelVar_fbbtbot=mod.fbbtbot;
  AdmsSensFadType modelVar_fbbtsti=mod.fbbtsti;
  AdmsSensFadType modelVar_fbbtgat=mod.fbbtgat;
  AdmsSensFadType modelVar_alphaav=mod.alphaav;
  AdmsSensFadType modelVar_fstopbot=mod.fstopbot;
  AdmsSensFadType modelVar_fstopsti=mod.fstopsti;
  AdmsSensFadType modelVar_fstopgat=mod.fstopgat;
  AdmsSensFadType modelVar_VBRinvbot=mod.VBRinvbot;
  AdmsSensFadType modelVar_VBRinvsti=mod.VBRinvsti;
  AdmsSensFadType modelVar_VBRinvgat=mod.VBRinvgat;
  AdmsSensFadType modelVar_slopebot=mod.slopebot;
  AdmsSensFadType modelVar_slopesti=mod.slopesti;
  AdmsSensFadType modelVar_slopegat=mod.slopegat;
  AdmsSensFadType modelVar_VBIRBOTD_i=mod.VBIRBOTD_i;
  AdmsSensFadType modelVar_VBIRSTID_i=mod.VBIRSTID_i;
  AdmsSensFadType modelVar_VBIRGATD_i=mod.VBIRGATD_i;
  AdmsSensFadType modelVar_PBOTD_i=mod.PBOTD_i;
  AdmsSensFadType modelVar_PSTID_i=mod.PSTID_i;
  AdmsSensFadType modelVar_PGATD_i=mod.PGATD_i;
  AdmsSensFadType modelVar_CSRHBOTD_i=mod.CSRHBOTD_i;
  AdmsSensFadType modelVar_CSRHSTID_i=mod.CSRHSTID_i;
  AdmsSensFadType modelVar_CSRHGATD_i=mod.CSRHGATD_i;
  AdmsSensFadType modelVar_CTATBOTD_i=mod.CTATBOTD_i;
  AdmsSensFadType modelVar_CTATSTID_i=mod.CTATSTID_i;
  AdmsSensFadType modelVar_CTATGATD_i=mod.CTATGATD_i;
  AdmsSensFadType modelVar_CBBTBOTD_i=mod.CBBTBOTD_i;
  AdmsSensFadType modelVar_CBBTSTID_i=mod.CBBTSTID_i;
  AdmsSensFadType modelVar_CBBTGATD_i=mod.CBBTGATD_i;
  AdmsSensFadType modelVar_VBRBOTD_i=mod.VBRBOTD_i;
  AdmsSensFadType modelVar_VBRSTID_i=mod.VBRSTID_i;
  AdmsSensFadType modelVar_VBRGATD_i=mod.VBRGATD_i;
  AdmsSensFadType modelVar_PBRBOTD_i=mod.PBRBOTD_i;
  AdmsSensFadType modelVar_PBRSTID_i=mod.PBRSTID_i;
  AdmsSensFadType modelVar_PBRGATD_i=mod.PBRGATD_i;
  AdmsSensFadType modelVar_VJUNREFD_i=mod.VJUNREFD_i;
  AdmsSensFadType modelVar_FJUNQD_i=mod.FJUNQD_i;
  AdmsSensFadType modelVar_ftdbot_d=mod.ftdbot_d;
  AdmsSensFadType modelVar_ftdsti_d=mod.ftdsti_d;
  AdmsSensFadType modelVar_ftdgat_d=mod.ftdgat_d;
  AdmsSensFadType modelVar_idsatbot_d=mod.idsatbot_d;
  AdmsSensFadType modelVar_idsatsti_d=mod.idsatsti_d;
  AdmsSensFadType modelVar_idsatgat_d=mod.idsatgat_d;
  AdmsSensFadType modelVar_vbibot_d=mod.vbibot_d;
  AdmsSensFadType modelVar_vbisti_d=mod.vbisti_d;
  AdmsSensFadType modelVar_vbigat_d=mod.vbigat_d;
  AdmsSensFadType modelVar_vbiinvbot_d=mod.vbiinvbot_d;
  AdmsSensFadType modelVar_vbiinvsti_d=mod.vbiinvsti_d;
  AdmsSensFadType modelVar_vbiinvgat_d=mod.vbiinvgat_d;
  AdmsSensFadType modelVar_one_minus_PBOT_d=mod.one_minus_PBOT_d;
  AdmsSensFadType modelVar_one_minus_PSTI_d=mod.one_minus_PSTI_d;
  AdmsSensFadType modelVar_one_minus_PGAT_d=mod.one_minus_PGAT_d;
  AdmsSensFadType modelVar_one_over_one_minus_PBOT_d=mod.one_over_one_minus_PBOT_d;
  AdmsSensFadType modelVar_one_over_one_minus_PSTI_d=mod.one_over_one_minus_PSTI_d;
  AdmsSensFadType modelVar_one_over_one_minus_PGAT_d=mod.one_over_one_minus_PGAT_d;
  AdmsSensFadType modelVar_cjobot_d=mod.cjobot_d;
  AdmsSensFadType modelVar_cjosti_d=mod.cjosti_d;
  AdmsSensFadType modelVar_cjogat_d=mod.cjogat_d;
  AdmsSensFadType modelVar_qprefbot_d=mod.qprefbot_d;
  AdmsSensFadType modelVar_qprefsti_d=mod.qprefsti_d;
  AdmsSensFadType modelVar_qprefgat_d=mod.qprefgat_d;
  AdmsSensFadType modelVar_qpref2bot_d=mod.qpref2bot_d;
  AdmsSensFadType modelVar_qpref2sti_d=mod.qpref2sti_d;
  AdmsSensFadType modelVar_qpref2gat_d=mod.qpref2gat_d;
  AdmsSensFadType modelVar_wdepnulrbot_d=mod.wdepnulrbot_d;
  AdmsSensFadType modelVar_wdepnulrsti_d=mod.wdepnulrsti_d;
  AdmsSensFadType modelVar_wdepnulrgat_d=mod.wdepnulrgat_d;
  AdmsSensFadType modelVar_wdepnulrinvbot_d=mod.wdepnulrinvbot_d;
  AdmsSensFadType modelVar_wdepnulrinvsti_d=mod.wdepnulrinvsti_d;
  AdmsSensFadType modelVar_wdepnulrinvgat_d=mod.wdepnulrinvgat_d;
  AdmsSensFadType modelVar_VBIRBOTinv_d=mod.VBIRBOTinv_d;
  AdmsSensFadType modelVar_VBIRSTIinv_d=mod.VBIRSTIinv_d;
  AdmsSensFadType modelVar_VBIRGATinv_d=mod.VBIRGATinv_d;
  AdmsSensFadType modelVar_atatbot_d=mod.atatbot_d;
  AdmsSensFadType modelVar_atatsti_d=mod.atatsti_d;
  AdmsSensFadType modelVar_atatgat_d=mod.atatgat_d;
  AdmsSensFadType modelVar_btatpartbot_d=mod.btatpartbot_d;
  AdmsSensFadType modelVar_btatpartsti_d=mod.btatpartsti_d;
  AdmsSensFadType modelVar_btatpartgat_d=mod.btatpartgat_d;
  AdmsSensFadType modelVar_fbbtbot_d=mod.fbbtbot_d;
  AdmsSensFadType modelVar_fbbtsti_d=mod.fbbtsti_d;
  AdmsSensFadType modelVar_fbbtgat_d=mod.fbbtgat_d;
  AdmsSensFadType modelVar_fstopbot_d=mod.fstopbot_d;
  AdmsSensFadType modelVar_fstopsti_d=mod.fstopsti_d;
  AdmsSensFadType modelVar_fstopgat_d=mod.fstopgat_d;
  AdmsSensFadType modelVar_VBRinvbot_d=mod.VBRinvbot_d;
  AdmsSensFadType modelVar_VBRinvsti_d=mod.VBRinvsti_d;
  AdmsSensFadType modelVar_VBRinvgat_d=mod.VBRinvgat_d;
  AdmsSensFadType modelVar_slopebot_d=mod.slopebot_d;
  AdmsSensFadType modelVar_slopesti_d=mod.slopesti_d;
  AdmsSensFadType modelVar_slopegat_d=mod.slopegat_d;
  AdmsSensFadType modelVar_phit=mod.phit;
  AdmsSensFadType modelVar_nt0=mod.nt0;
  AdmsSensFadType modelVar_EPSSI=mod.EPSSI;


  // non-reals
  int modelVar_CHNL_TYPE=mod.CHNL_TYPE;
  int modelVar_SWGEO_i=mod.SWGEO_i;
  int modelVar_SWIGATE_i=mod.SWIGATE_i;
  int modelVar_SWIMPACT_i=mod.SWIMPACT_i;
  int modelVar_SWGIDL_i=mod.SWGIDL_i;
  int modelVar_SWJUNCAP_i=mod.SWJUNCAP_i;
  int modelVar_SWJUNASYM_i=mod.SWJUNASYM_i;
  int modelVar_SWNUD_i=mod.SWNUD_i;
  int modelVar_SWEDGE_i=mod.SWEDGE_i;
  int modelVar_SWDELVTAC_i=mod.SWDELVTAC_i;
  int modelVar_SWIGN_i=mod.SWIGN_i;



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 13+0 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals
    AdmsSensFadType instancePar_L=in.L;
    bool instancePar_given_L=in.given("L");
    AdmsSensFadType instancePar_W=in.W;
    bool instancePar_given_W=in.given("W");
    AdmsSensFadType instancePar_SA=in.SA;
    bool instancePar_given_SA=in.given("SA");
    AdmsSensFadType instancePar_SB=in.SB;
    bool instancePar_given_SB=in.given("SB");
    AdmsSensFadType instancePar_SD=in.SD;
    bool instancePar_given_SD=in.given("SD");
    AdmsSensFadType instancePar_SCA=in.SCA;
    bool instancePar_given_SCA=in.given("SCA");
    AdmsSensFadType instancePar_SCB=in.SCB;
    bool instancePar_given_SCB=in.given("SCB");
    AdmsSensFadType instancePar_SCC=in.SCC;
    bool instancePar_given_SCC=in.given("SCC");
    AdmsSensFadType instancePar_SC=in.SC;
    bool instancePar_given_SC=in.given("SC");
    AdmsSensFadType instancePar_NF=in.NF;
    bool instancePar_given_NF=in.given("NF");
    AdmsSensFadType instancePar_NGCON=in.NGCON;
    bool instancePar_given_NGCON=in.given("NGCON");
    AdmsSensFadType instancePar_XGW=in.XGW;
    bool instancePar_given_XGW=in.given("XGW");
    AdmsSensFadType instancePar_NRS=in.NRS;
    bool instancePar_given_NRS=in.given("NRS");
    AdmsSensFadType instancePar_NRD=in.NRD;
    bool instancePar_given_NRD=in.given("NRD");
    AdmsSensFadType instancePar_JW=in.JW;
    bool instancePar_given_JW=in.given("JW");
    AdmsSensFadType instancePar_DELVTO=in.DELVTO;
    bool instancePar_given_DELVTO=in.given("DELVTO");
    AdmsSensFadType instancePar_FACTUO=in.FACTUO;
    bool instancePar_given_FACTUO=in.given("FACTUO");
    AdmsSensFadType instancePar_DELVTOEDGE=in.DELVTOEDGE;
    bool instancePar_given_DELVTOEDGE=in.given("DELVTOEDGE");
    AdmsSensFadType instancePar_FACTUOEDGE=in.FACTUOEDGE;
    bool instancePar_given_FACTUOEDGE=in.given("FACTUOEDGE");
    AdmsSensFadType instancePar_ABSOURCE=in.ABSOURCE;
    bool instancePar_given_ABSOURCE=in.given("ABSOURCE");
    AdmsSensFadType instancePar_LSSOURCE=in.LSSOURCE;
    bool instancePar_given_LSSOURCE=in.given("LSSOURCE");
    AdmsSensFadType instancePar_LGSOURCE=in.LGSOURCE;
    bool instancePar_given_LGSOURCE=in.given("LGSOURCE");
    AdmsSensFadType instancePar_ABDRAIN=in.ABDRAIN;
    bool instancePar_given_ABDRAIN=in.given("ABDRAIN");
    AdmsSensFadType instancePar_LSDRAIN=in.LSDRAIN;
    bool instancePar_given_LSDRAIN=in.given("LSDRAIN");
    AdmsSensFadType instancePar_LGDRAIN=in.LGDRAIN;
    bool instancePar_given_LGDRAIN=in.given("LGDRAIN");
    AdmsSensFadType instancePar_AS=in.AS;
    bool instancePar_given_AS=in.given("AS");
    AdmsSensFadType instancePar_PS=in.PS;
    bool instancePar_given_PS=in.given("PS");
    AdmsSensFadType instancePar_AD=in.AD;
    bool instancePar_given_AD=in.given("AD");
    AdmsSensFadType instancePar_PD=in.PD;
    bool instancePar_given_PD=in.given("PD");
    AdmsSensFadType instancePar_MULT=in.MULT;
    bool instancePar_given_MULT=in.given("MULT");


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.


    //make local copies of all instance vars
    //reals
    AdmsSensFadType instanceVar_MULT_i=in.MULT_i;
    AdmsSensFadType instanceVar_GFACNUD_i=in.GFACNUD_i;
    AdmsSensFadType instanceVar_VNSUB_i=in.VNSUB_i;
    AdmsSensFadType instanceVar_NSLP_i=in.NSLP_i;
    AdmsSensFadType instanceVar_DNSUB_i=in.DNSUB_i;
    AdmsSensFadType instanceVar_CF_i=in.CF_i;
    AdmsSensFadType instanceVar_CFD_i=in.CFD_i;
    AdmsSensFadType instanceVar_CFB_i=in.CFB_i;
    AdmsSensFadType instanceVar_PSCE_i=in.PSCE_i;
    AdmsSensFadType instanceVar_PSCEB_i=in.PSCEB_i;
    AdmsSensFadType instanceVar_PSCED_i=in.PSCED_i;
    AdmsSensFadType instanceVar_RSB_i=in.RSB_i;
    AdmsSensFadType instanceVar_RSG_i=in.RSG_i;
    AdmsSensFadType instanceVar_THESATB_i=in.THESATB_i;
    AdmsSensFadType instanceVar_THESATG_i=in.THESATG_i;
    AdmsSensFadType instanceVar_AX_i=in.AX_i;
    AdmsSensFadType instanceVar_ALP_i=in.ALP_i;
    AdmsSensFadType instanceVar_ALP1_i=in.ALP1_i;
    AdmsSensFadType instanceVar_ALP2_i=in.ALP2_i;
    AdmsSensFadType instanceVar_A1_i=in.A1_i;
    AdmsSensFadType instanceVar_A3_i=in.A3_i;
    AdmsSensFadType instanceVar_A4_i=in.A4_i;
    AdmsSensFadType instanceVar_GCO_i=in.GCO_i;
    AdmsSensFadType instanceVar_IGINV_i=in.IGINV_i;
    AdmsSensFadType instanceVar_IGOV_i=in.IGOV_i;
    AdmsSensFadType instanceVar_IGOVD_i=in.IGOVD_i;
    AdmsSensFadType instanceVar_GC2_i=in.GC2_i;
    AdmsSensFadType instanceVar_GC3_i=in.GC3_i;
    AdmsSensFadType instanceVar_CHIB_i=in.CHIB_i;
    AdmsSensFadType instanceVar_AGIDL_i=in.AGIDL_i;
    AdmsSensFadType instanceVar_AGIDLD_i=in.AGIDLD_i;
    AdmsSensFadType instanceVar_CGIDL_i=in.CGIDL_i;
    AdmsSensFadType instanceVar_CGIDLD_i=in.CGIDLD_i;
    AdmsSensFadType instanceVar_COX_i=in.COX_i;
    AdmsSensFadType instanceVar_CGOV_i=in.CGOV_i;
    AdmsSensFadType instanceVar_CGOVD_i=in.CGOVD_i;
    AdmsSensFadType instanceVar_CGBOV_i=in.CGBOV_i;
    AdmsSensFadType instanceVar_CFR_i=in.CFR_i;
    AdmsSensFadType instanceVar_CFRD_i=in.CFRD_i;
    AdmsSensFadType instanceVar_FNTEXC_i=in.FNTEXC_i;
    AdmsSensFadType instanceVar_NFA_i=in.NFA_i;
    AdmsSensFadType instanceVar_NFB_i=in.NFB_i;
    AdmsSensFadType instanceVar_NFC_i=in.NFC_i;
    AdmsSensFadType instanceVar_EF_i=in.EF_i;
    AdmsSensFadType instanceVar_BETNEDGE_i=in.BETNEDGE_i;
    AdmsSensFadType instanceVar_PSCEEDGE_i=in.PSCEEDGE_i;
    AdmsSensFadType instanceVar_PSCEBEDGE_i=in.PSCEBEDGE_i;
    AdmsSensFadType instanceVar_PSCEDEDGE_i=in.PSCEDEDGE_i;
    AdmsSensFadType instanceVar_CFEDGE_i=in.CFEDGE_i;
    AdmsSensFadType instanceVar_CFDEDGE_i=in.CFDEDGE_i;
    AdmsSensFadType instanceVar_CFBEDGE_i=in.CFBEDGE_i;
    AdmsSensFadType instanceVar_NFAEDGE_i=in.NFAEDGE_i;
    AdmsSensFadType instanceVar_NFBEDGE_i=in.NFBEDGE_i;
    AdmsSensFadType instanceVar_NFCEDGE_i=in.NFCEDGE_i;
    AdmsSensFadType instanceVar_EFEDGE_i=in.EFEDGE_i;
    AdmsSensFadType instanceVar_RG_i=in.RG_i;
    AdmsSensFadType instanceVar_RSE_i=in.RSE_i;
    AdmsSensFadType instanceVar_RDE_i=in.RDE_i;
    AdmsSensFadType instanceVar_RBULK_i=in.RBULK_i;
    AdmsSensFadType instanceVar_RJUNS_i=in.RJUNS_i;
    AdmsSensFadType instanceVar_RJUND_i=in.RJUND_i;
    AdmsSensFadType instanceVar_RWELL_i=in.RWELL_i;
    AdmsSensFadType instanceVar_ABSOURCE_i=in.ABSOURCE_i;
    AdmsSensFadType instanceVar_LSSOURCE_i=in.LSSOURCE_i;
    AdmsSensFadType instanceVar_LGSOURCE_i=in.LGSOURCE_i;
    AdmsSensFadType instanceVar_zflagbot_s=in.zflagbot_s;
    AdmsSensFadType instanceVar_zflagsti_s=in.zflagsti_s;
    AdmsSensFadType instanceVar_zflaggat_s=in.zflaggat_s;
    AdmsSensFadType instanceVar_VMAX_s=in.VMAX_s;
    AdmsSensFadType instanceVar_exp_VMAX_over_phitd_s=in.exp_VMAX_over_phitd_s;
    AdmsSensFadType instanceVar_vbimin_s=in.vbimin_s;
    AdmsSensFadType instanceVar_vch_s=in.vch_s;
    AdmsSensFadType instanceVar_vfmin_s=in.vfmin_s;
    AdmsSensFadType instanceVar_vbbtlim_s=in.vbbtlim_s;
    AdmsSensFadType instanceVar_xhighf1_s=in.xhighf1_s;
    AdmsSensFadType instanceVar_expxhf1_s=in.expxhf1_s;
    AdmsSensFadType instanceVar_xhighf2_s=in.xhighf2_s;
    AdmsSensFadType instanceVar_expxhf2_s=in.expxhf2_s;
    AdmsSensFadType instanceVar_xhighr_s=in.xhighr_s;
    AdmsSensFadType instanceVar_expxhr_s=in.expxhr_s;
    AdmsSensFadType instanceVar_m0flag_s=in.m0flag_s;
    AdmsSensFadType instanceVar_ISATFOR1_s=in.ISATFOR1_s;
    AdmsSensFadType instanceVar_MFOR1_s=in.MFOR1_s;
    AdmsSensFadType instanceVar_ISATFOR2_s=in.ISATFOR2_s;
    AdmsSensFadType instanceVar_MFOR2_s=in.MFOR2_s;
    AdmsSensFadType instanceVar_ISATREV_s=in.ISATREV_s;
    AdmsSensFadType instanceVar_MREV_s=in.MREV_s;
    AdmsSensFadType instanceVar_ABDRAIN_i=in.ABDRAIN_i;
    AdmsSensFadType instanceVar_LSDRAIN_i=in.LSDRAIN_i;
    AdmsSensFadType instanceVar_LGDRAIN_i=in.LGDRAIN_i;
    AdmsSensFadType instanceVar_zflagbot_d=in.zflagbot_d;
    AdmsSensFadType instanceVar_zflagsti_d=in.zflagsti_d;
    AdmsSensFadType instanceVar_zflaggat_d=in.zflaggat_d;
    AdmsSensFadType instanceVar_VMAX_d=in.VMAX_d;
    AdmsSensFadType instanceVar_exp_VMAX_over_phitd_d=in.exp_VMAX_over_phitd_d;
    AdmsSensFadType instanceVar_vbimin_d=in.vbimin_d;
    AdmsSensFadType instanceVar_vch_d=in.vch_d;
    AdmsSensFadType instanceVar_vfmin_d=in.vfmin_d;
    AdmsSensFadType instanceVar_vbbtlim_d=in.vbbtlim_d;
    AdmsSensFadType instanceVar_xhighf1_d=in.xhighf1_d;
    AdmsSensFadType instanceVar_expxhf1_d=in.expxhf1_d;
    AdmsSensFadType instanceVar_xhighf2_d=in.xhighf2_d;
    AdmsSensFadType instanceVar_expxhf2_d=in.expxhf2_d;
    AdmsSensFadType instanceVar_xhighr_d=in.xhighr_d;
    AdmsSensFadType instanceVar_expxhr_d=in.expxhr_d;
    AdmsSensFadType instanceVar_m0flag_d=in.m0flag_d;
    AdmsSensFadType instanceVar_ISATFOR1_d=in.ISATFOR1_d;
    AdmsSensFadType instanceVar_MFOR1_d=in.MFOR1_d;
    AdmsSensFadType instanceVar_ISATFOR2_d=in.ISATFOR2_d;
    AdmsSensFadType instanceVar_MFOR2_d=in.MFOR2_d;
    AdmsSensFadType instanceVar_ISATREV_d=in.ISATREV_d;
    AdmsSensFadType instanceVar_MREV_d=in.MREV_d;
    AdmsSensFadType instanceVar_VFB_T=in.VFB_T;
    AdmsSensFadType instanceVar_MUE_T=in.MUE_T;
    AdmsSensFadType instanceVar_THEMU_T=in.THEMU_T;
    AdmsSensFadType instanceVar_CS_T=in.CS_T;
    AdmsSensFadType instanceVar_XCOR_T=in.XCOR_T;
    AdmsSensFadType instanceVar_A2_T=in.A2_T;
    AdmsSensFadType instanceVar_VFBEDGE_T=in.VFBEDGE_T;
    AdmsSensFadType instanceVar_phit0=in.phit0;
    AdmsSensFadType instanceVar_BET_i=in.BET_i;
    AdmsSensFadType instanceVar_BETEDGE_i=in.BETEDGE_i;
    AdmsSensFadType instanceVar_nt=in.nt;
    AdmsSensFadType instanceVar_THESAT_T=in.THESAT_T;
    AdmsSensFadType instanceVar_Sfl_prefac=in.Sfl_prefac;
    AdmsSensFadType instanceVar_phit0edge=in.phit0edge;
    AdmsSensFadType instanceVar_Gfedge2=in.Gfedge2;
    AdmsSensFadType instanceVar_lnGfedge2=in.lnGfedge2;
    AdmsSensFadType instanceVar_Sfl_prefac_edge=in.Sfl_prefac_edge;
    AdmsSensFadType instanceVar_ntedge=in.ntedge;
    AdmsSensFadType instanceVar_phib_dc=in.phib_dc;
    AdmsSensFadType instanceVar_G_0_dc=in.G_0_dc;
    AdmsSensFadType instanceVar_kp=in.kp;
    AdmsSensFadType instanceVar_qlim2=in.qlim2;
    AdmsSensFadType instanceVar_sqrt_phib_dc=in.sqrt_phib_dc;
    AdmsSensFadType instanceVar_phix_dc=in.phix_dc;
    AdmsSensFadType instanceVar_aphi_dc=in.aphi_dc;
    AdmsSensFadType instanceVar_bphi_dc=in.bphi_dc;
    AdmsSensFadType instanceVar_phix1_dc=in.phix1_dc;
    AdmsSensFadType instanceVar_alpha_b=in.alpha_b;
    AdmsSensFadType instanceVar_us1=in.us1;
    AdmsSensFadType instanceVar_us21=in.us21;
    AdmsSensFadType instanceVar_phib_ac=in.phib_ac;
    AdmsSensFadType instanceVar_G_0_ac=in.G_0_ac;
    AdmsSensFadType instanceVar_phix_ac=in.phix_ac;
    AdmsSensFadType instanceVar_aphi_ac=in.aphi_ac;
    AdmsSensFadType instanceVar_bphi_ac=in.bphi_ac;
    AdmsSensFadType instanceVar_phix1_ac=in.phix1_ac;
    AdmsSensFadType instanceVar_THER_i=in.THER_i;
    AdmsSensFadType instanceVar_phibedge=in.phibedge;
    AdmsSensFadType instanceVar_Gfedge=in.Gfedge;
    AdmsSensFadType instanceVar_phixedge=in.phixedge;
    AdmsSensFadType instanceVar_aphiedge=in.aphiedge;
    AdmsSensFadType instanceVar_bphiedge=in.bphiedge;
    AdmsSensFadType instanceVar_phix1edge=in.phix1edge;
    AdmsSensFadType instanceVar_Cox_over_q=in.Cox_over_q;
    AdmsSensFadType instanceVar_qq=in.qq;
    AdmsSensFadType instanceVar_E_eff0=in.E_eff0;
    AdmsSensFadType instanceVar_eta_mu=in.eta_mu;
    AdmsSensFadType instanceVar_eta_mu1=in.eta_mu1;
    AdmsSensFadType instanceVar_inv_AX=in.inv_AX;
    AdmsSensFadType instanceVar_inv_VP=in.inv_VP;
    AdmsSensFadType instanceVar_GOV_s=in.GOV_s;
    AdmsSensFadType instanceVar_GOV_d=in.GOV_d;
    AdmsSensFadType instanceVar_GOV2_s=in.GOV2_s;
    AdmsSensFadType instanceVar_GOV2_d=in.GOV2_d;
    AdmsSensFadType instanceVar_SP_OV_eps2_s=in.SP_OV_eps2_s;
    AdmsSensFadType instanceVar_SP_OV_a_s=in.SP_OV_a_s;
    AdmsSensFadType instanceVar_SP_OV_delta1_s=in.SP_OV_delta1_s;
    AdmsSensFadType instanceVar_SP_OV_eps2_d=in.SP_OV_eps2_d;
    AdmsSensFadType instanceVar_SP_OV_a_d=in.SP_OV_a_d;
    AdmsSensFadType instanceVar_SP_OV_delta1_d=in.SP_OV_delta1_d;
    AdmsSensFadType instanceVar_inv_CHIB=in.inv_CHIB;
    AdmsSensFadType instanceVar_BCH=in.BCH;
    AdmsSensFadType instanceVar_BOV=in.BOV;
    AdmsSensFadType instanceVar_BOV_d=in.BOV_d;
    AdmsSensFadType instanceVar_GCQ=in.GCQ;
    AdmsSensFadType instanceVar_AGIDLs=in.AGIDLs;
    AdmsSensFadType instanceVar_AGIDLDs=in.AGIDLDs;
    AdmsSensFadType instanceVar_BGIDLs=in.BGIDLs;
    AdmsSensFadType instanceVar_BGIDLDs=in.BGIDLDs;
    AdmsSensFadType instanceVar_fac_exc=in.fac_exc;
    AdmsSensFadType instanceVar_ggate=in.ggate;
    AdmsSensFadType instanceVar_gsource=in.gsource;
    AdmsSensFadType instanceVar_gdrain=in.gdrain;
    AdmsSensFadType instanceVar_gbulk=in.gbulk;
    AdmsSensFadType instanceVar_gjuns=in.gjuns;
    AdmsSensFadType instanceVar_gjund=in.gjund;
    AdmsSensFadType instanceVar_gwell=in.gwell;


    //non-reals



    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_NOI_GND] = (*solVectorPtr)[in.li_NOI];
    probeVars[in.admsProbeID_V_NOI2_GND] = (*solVectorPtr)[in.li_NOI2];
    probeVars[in.admsProbeID_V_B_BI] = (*solVectorPtr)[in.li_B] - (*solVectorPtr)[in.li_BI];
    probeVars[in.admsProbeID_V_BD_BI] = (*solVectorPtr)[in.li_BD] - (*solVectorPtr)[in.li_BI];
    probeVars[in.admsProbeID_V_BS_BI] = (*solVectorPtr)[in.li_BS] - (*solVectorPtr)[in.li_BI];
    probeVars[in.admsProbeID_V_BP_BI] = (*solVectorPtr)[in.li_BP] - (*solVectorPtr)[in.li_BI];
    probeVars[in.admsProbeID_V_D_DI] = (*solVectorPtr)[in.li_D] - (*solVectorPtr)[in.li_DI];
    probeVars[in.admsProbeID_V_S_SI] = (*solVectorPtr)[in.li_S] - (*solVectorPtr)[in.li_SI];
    probeVars[in.admsProbeID_V_G_GP] = (*solVectorPtr)[in.li_G] - (*solVectorPtr)[in.li_GP];
    probeVars[in.admsProbeID_V_DI_BD] = (*solVectorPtr)[in.li_DI] - (*solVectorPtr)[in.li_BD];
    probeVars[in.admsProbeID_V_SI_BS] = (*solVectorPtr)[in.li_SI] - (*solVectorPtr)[in.li_BS];
    probeVars[in.admsProbeID_V_SI_BP] = (*solVectorPtr)[in.li_SI] - (*solVectorPtr)[in.li_BP];
    probeVars[in.admsProbeID_V_DI_SI] = (*solVectorPtr)[in.li_DI] - (*solVectorPtr)[in.li_SI];
    probeVars[in.admsProbeID_V_GP_SI] = (*solVectorPtr)[in.li_GP] - (*solVectorPtr)[in.li_SI];



    // Need to use processParams-like function to process the
    // initial_model block with the LOCAL copies of
    //  model vars, and local copies of model
    // params.
    evaluateInitialModel(
       // model parameters
       // reals
       modelPar_TR,
       modelPar_given_TR,
       modelPar_QMC,
       modelPar_given_QMC,
       modelPar_VFB,
       modelPar_given_VFB,
       modelPar_STVFB,
       modelPar_given_STVFB,
       modelPar_TOX,
       modelPar_given_TOX,
       modelPar_EPSROX,
       modelPar_given_EPSROX,
       modelPar_NEFF,
       modelPar_given_NEFF,
       modelPar_FACNEFFAC,
       modelPar_given_FACNEFFAC,
       modelPar_GFACNUD,
       modelPar_given_GFACNUD,
       modelPar_VSBNUD,
       modelPar_given_VSBNUD,
       modelPar_DVSBNUD,
       modelPar_given_DVSBNUD,
       modelPar_VNSUB,
       modelPar_given_VNSUB,
       modelPar_NSLP,
       modelPar_given_NSLP,
       modelPar_DNSUB,
       modelPar_given_DNSUB,
       modelPar_DPHIB,
       modelPar_given_DPHIB,
       modelPar_DELVTAC,
       modelPar_given_DELVTAC,
       modelPar_NP,
       modelPar_given_NP,
       modelPar_CT,
       modelPar_given_CT,
       modelPar_TOXOV,
       modelPar_given_TOXOV,
       modelPar_TOXOVD,
       modelPar_given_TOXOVD,
       modelPar_NOV,
       modelPar_given_NOV,
       modelPar_NOVD,
       modelPar_given_NOVD,
       modelPar_CF,
       modelPar_given_CF,
       modelPar_CFD,
       modelPar_given_CFD,
       modelPar_CFB,
       modelPar_given_CFB,
       modelPar_PSCE,
       modelPar_given_PSCE,
       modelPar_PSCEB,
       modelPar_given_PSCEB,
       modelPar_PSCED,
       modelPar_given_PSCED,
       modelPar_BETN,
       modelPar_given_BETN,
       modelPar_STBET,
       modelPar_given_STBET,
       modelPar_MUE,
       modelPar_given_MUE,
       modelPar_STMUE,
       modelPar_given_STMUE,
       modelPar_THEMU,
       modelPar_given_THEMU,
       modelPar_STTHEMU,
       modelPar_given_STTHEMU,
       modelPar_CS,
       modelPar_given_CS,
       modelPar_STCS,
       modelPar_given_STCS,
       modelPar_XCOR,
       modelPar_given_XCOR,
       modelPar_STXCOR,
       modelPar_given_STXCOR,
       modelPar_FETA,
       modelPar_given_FETA,
       modelPar_RS,
       modelPar_given_RS,
       modelPar_STRS,
       modelPar_given_STRS,
       modelPar_RSB,
       modelPar_given_RSB,
       modelPar_RSG,
       modelPar_given_RSG,
       modelPar_THESAT,
       modelPar_given_THESAT,
       modelPar_STTHESAT,
       modelPar_given_STTHESAT,
       modelPar_THESATB,
       modelPar_given_THESATB,
       modelPar_THESATG,
       modelPar_given_THESATG,
       modelPar_AX,
       modelPar_given_AX,
       modelPar_ALP,
       modelPar_given_ALP,
       modelPar_ALP1,
       modelPar_given_ALP1,
       modelPar_ALP2,
       modelPar_given_ALP2,
       modelPar_VP,
       modelPar_given_VP,
       modelPar_A1,
       modelPar_given_A1,
       modelPar_A2,
       modelPar_given_A2,
       modelPar_STA2,
       modelPar_given_STA2,
       modelPar_A3,
       modelPar_given_A3,
       modelPar_A4,
       modelPar_given_A4,
       modelPar_GCO,
       modelPar_given_GCO,
       modelPar_IGINV,
       modelPar_given_IGINV,
       modelPar_IGOV,
       modelPar_given_IGOV,
       modelPar_IGOVD,
       modelPar_given_IGOVD,
       modelPar_STIG,
       modelPar_given_STIG,
       modelPar_GC2,
       modelPar_given_GC2,
       modelPar_GC3,
       modelPar_given_GC3,
       modelPar_CHIB,
       modelPar_given_CHIB,
       modelPar_AGIDL,
       modelPar_given_AGIDL,
       modelPar_AGIDLD,
       modelPar_given_AGIDLD,
       modelPar_BGIDL,
       modelPar_given_BGIDL,
       modelPar_BGIDLD,
       modelPar_given_BGIDLD,
       modelPar_STBGIDL,
       modelPar_given_STBGIDL,
       modelPar_STBGIDLD,
       modelPar_given_STBGIDLD,
       modelPar_CGIDL,
       modelPar_given_CGIDL,
       modelPar_CGIDLD,
       modelPar_given_CGIDLD,
       modelPar_COX,
       modelPar_given_COX,
       modelPar_CGOV,
       modelPar_given_CGOV,
       modelPar_CGOVD,
       modelPar_given_CGOVD,
       modelPar_CGBOV,
       modelPar_given_CGBOV,
       modelPar_CFR,
       modelPar_given_CFR,
       modelPar_CFRD,
       modelPar_given_CFRD,
       modelPar_FNT,
       modelPar_given_FNT,
       modelPar_FNTEXC,
       modelPar_given_FNTEXC,
       modelPar_NFA,
       modelPar_given_NFA,
       modelPar_NFB,
       modelPar_given_NFB,
       modelPar_NFC,
       modelPar_given_NFC,
       modelPar_EF,
       modelPar_given_EF,
       modelPar_VFBEDGE,
       modelPar_given_VFBEDGE,
       modelPar_STVFBEDGE,
       modelPar_given_STVFBEDGE,
       modelPar_DPHIBEDGE,
       modelPar_given_DPHIBEDGE,
       modelPar_NEFFEDGE,
       modelPar_given_NEFFEDGE,
       modelPar_CTEDGE,
       modelPar_given_CTEDGE,
       modelPar_BETNEDGE,
       modelPar_given_BETNEDGE,
       modelPar_STBETEDGE,
       modelPar_given_STBETEDGE,
       modelPar_PSCEEDGE,
       modelPar_given_PSCEEDGE,
       modelPar_PSCEBEDGE,
       modelPar_given_PSCEBEDGE,
       modelPar_PSCEDEDGE,
       modelPar_given_PSCEDEDGE,
       modelPar_CFEDGE,
       modelPar_given_CFEDGE,
       modelPar_CFDEDGE,
       modelPar_given_CFDEDGE,
       modelPar_CFBEDGE,
       modelPar_given_CFBEDGE,
       modelPar_FNTEDGE,
       modelPar_given_FNTEDGE,
       modelPar_NFAEDGE,
       modelPar_given_NFAEDGE,
       modelPar_NFBEDGE,
       modelPar_given_NFBEDGE,
       modelPar_NFCEDGE,
       modelPar_given_NFCEDGE,
       modelPar_EFEDGE,
       modelPar_given_EFEDGE,
       modelPar_RG,
       modelPar_given_RG,
       modelPar_RSE,
       modelPar_given_RSE,
       modelPar_RDE,
       modelPar_given_RDE,
       modelPar_RBULK,
       modelPar_given_RBULK,
       modelPar_RWELL,
       modelPar_given_RWELL,
       modelPar_RJUNS,
       modelPar_given_RJUNS,
       modelPar_RJUND,
       modelPar_given_RJUND,
       modelPar_POVFB,
       modelPar_given_POVFB,
       modelPar_PLVFB,
       modelPar_given_PLVFB,
       modelPar_PWVFB,
       modelPar_given_PWVFB,
       modelPar_PLWVFB,
       modelPar_given_PLWVFB,
       modelPar_POSTVFB,
       modelPar_given_POSTVFB,
       modelPar_PLSTVFB,
       modelPar_given_PLSTVFB,
       modelPar_PWSTVFB,
       modelPar_given_PWSTVFB,
       modelPar_PLWSTVFB,
       modelPar_given_PLWSTVFB,
       modelPar_POTOX,
       modelPar_given_POTOX,
       modelPar_POEPSROX,
       modelPar_given_POEPSROX,
       modelPar_PONEFF,
       modelPar_given_PONEFF,
       modelPar_PLNEFF,
       modelPar_given_PLNEFF,
       modelPar_PWNEFF,
       modelPar_given_PWNEFF,
       modelPar_PLWNEFF,
       modelPar_given_PLWNEFF,
       modelPar_POFACNEFFAC,
       modelPar_given_POFACNEFFAC,
       modelPar_PLFACNEFFAC,
       modelPar_given_PLFACNEFFAC,
       modelPar_PWFACNEFFAC,
       modelPar_given_PWFACNEFFAC,
       modelPar_PLWFACNEFFAC,
       modelPar_given_PLWFACNEFFAC,
       modelPar_POGFACNUD,
       modelPar_given_POGFACNUD,
       modelPar_PLGFACNUD,
       modelPar_given_PLGFACNUD,
       modelPar_PWGFACNUD,
       modelPar_given_PWGFACNUD,
       modelPar_PLWGFACNUD,
       modelPar_given_PLWGFACNUD,
       modelPar_POVSBNUD,
       modelPar_given_POVSBNUD,
       modelPar_PODVSBNUD,
       modelPar_given_PODVSBNUD,
       modelPar_POVNSUB,
       modelPar_given_POVNSUB,
       modelPar_PONSLP,
       modelPar_given_PONSLP,
       modelPar_PODNSUB,
       modelPar_given_PODNSUB,
       modelPar_PODPHIB,
       modelPar_given_PODPHIB,
       modelPar_PLDPHIB,
       modelPar_given_PLDPHIB,
       modelPar_PWDPHIB,
       modelPar_given_PWDPHIB,
       modelPar_PLWDPHIB,
       modelPar_given_PLWDPHIB,
       modelPar_PODELVTAC,
       modelPar_given_PODELVTAC,
       modelPar_PLDELVTAC,
       modelPar_given_PLDELVTAC,
       modelPar_PWDELVTAC,
       modelPar_given_PWDELVTAC,
       modelPar_PLWDELVTAC,
       modelPar_given_PLWDELVTAC,
       modelPar_PONP,
       modelPar_given_PONP,
       modelPar_PLNP,
       modelPar_given_PLNP,
       modelPar_PWNP,
       modelPar_given_PWNP,
       modelPar_PLWNP,
       modelPar_given_PLWNP,
       modelPar_POCT,
       modelPar_given_POCT,
       modelPar_PLCT,
       modelPar_given_PLCT,
       modelPar_PWCT,
       modelPar_given_PWCT,
       modelPar_PLWCT,
       modelPar_given_PLWCT,
       modelPar_POTOXOV,
       modelPar_given_POTOXOV,
       modelPar_POTOXOVD,
       modelPar_given_POTOXOVD,
       modelPar_PONOV,
       modelPar_given_PONOV,
       modelPar_PLNOV,
       modelPar_given_PLNOV,
       modelPar_PWNOV,
       modelPar_given_PWNOV,
       modelPar_PLWNOV,
       modelPar_given_PLWNOV,
       modelPar_PONOVD,
       modelPar_given_PONOVD,
       modelPar_PLNOVD,
       modelPar_given_PLNOVD,
       modelPar_PWNOVD,
       modelPar_given_PWNOVD,
       modelPar_PLWNOVD,
       modelPar_given_PLWNOVD,
       modelPar_POCF,
       modelPar_given_POCF,
       modelPar_PLCF,
       modelPar_given_PLCF,
       modelPar_PWCF,
       modelPar_given_PWCF,
       modelPar_PLWCF,
       modelPar_given_PLWCF,
       modelPar_POCFD,
       modelPar_given_POCFD,
       modelPar_POCFB,
       modelPar_given_POCFB,
       modelPar_POPSCE,
       modelPar_given_POPSCE,
       modelPar_PLPSCE,
       modelPar_given_PLPSCE,
       modelPar_PWPSCE,
       modelPar_given_PWPSCE,
       modelPar_PLWPSCE,
       modelPar_given_PLWPSCE,
       modelPar_POPSCEB,
       modelPar_given_POPSCEB,
       modelPar_POPSCED,
       modelPar_given_POPSCED,
       modelPar_POBETN,
       modelPar_given_POBETN,
       modelPar_PLBETN,
       modelPar_given_PLBETN,
       modelPar_PWBETN,
       modelPar_given_PWBETN,
       modelPar_PLWBETN,
       modelPar_given_PLWBETN,
       modelPar_POSTBET,
       modelPar_given_POSTBET,
       modelPar_PLSTBET,
       modelPar_given_PLSTBET,
       modelPar_PWSTBET,
       modelPar_given_PWSTBET,
       modelPar_PLWSTBET,
       modelPar_given_PLWSTBET,
       modelPar_POMUE,
       modelPar_given_POMUE,
       modelPar_PLMUE,
       modelPar_given_PLMUE,
       modelPar_PWMUE,
       modelPar_given_PWMUE,
       modelPar_PLWMUE,
       modelPar_given_PLWMUE,
       modelPar_POSTMUE,
       modelPar_given_POSTMUE,
       modelPar_POTHEMU,
       modelPar_given_POTHEMU,
       modelPar_POSTTHEMU,
       modelPar_given_POSTTHEMU,
       modelPar_POCS,
       modelPar_given_POCS,
       modelPar_PLCS,
       modelPar_given_PLCS,
       modelPar_PWCS,
       modelPar_given_PWCS,
       modelPar_PLWCS,
       modelPar_given_PLWCS,
       modelPar_POSTCS,
       modelPar_given_POSTCS,
       modelPar_POXCOR,
       modelPar_given_POXCOR,
       modelPar_PLXCOR,
       modelPar_given_PLXCOR,
       modelPar_PWXCOR,
       modelPar_given_PWXCOR,
       modelPar_PLWXCOR,
       modelPar_given_PLWXCOR,
       modelPar_POSTXCOR,
       modelPar_given_POSTXCOR,
       modelPar_POFETA,
       modelPar_given_POFETA,
       modelPar_PORS,
       modelPar_given_PORS,
       modelPar_PLRS,
       modelPar_given_PLRS,
       modelPar_PWRS,
       modelPar_given_PWRS,
       modelPar_PLWRS,
       modelPar_given_PLWRS,
       modelPar_POSTRS,
       modelPar_given_POSTRS,
       modelPar_PORSB,
       modelPar_given_PORSB,
       modelPar_PORSG,
       modelPar_given_PORSG,
       modelPar_POTHESAT,
       modelPar_given_POTHESAT,
       modelPar_PLTHESAT,
       modelPar_given_PLTHESAT,
       modelPar_PWTHESAT,
       modelPar_given_PWTHESAT,
       modelPar_PLWTHESAT,
       modelPar_given_PLWTHESAT,
       modelPar_POSTTHESAT,
       modelPar_given_POSTTHESAT,
       modelPar_PLSTTHESAT,
       modelPar_given_PLSTTHESAT,
       modelPar_PWSTTHESAT,
       modelPar_given_PWSTTHESAT,
       modelPar_PLWSTTHESAT,
       modelPar_given_PLWSTTHESAT,
       modelPar_POTHESATB,
       modelPar_given_POTHESATB,
       modelPar_PLTHESATB,
       modelPar_given_PLTHESATB,
       modelPar_PWTHESATB,
       modelPar_given_PWTHESATB,
       modelPar_PLWTHESATB,
       modelPar_given_PLWTHESATB,
       modelPar_POTHESATG,
       modelPar_given_POTHESATG,
       modelPar_PLTHESATG,
       modelPar_given_PLTHESATG,
       modelPar_PWTHESATG,
       modelPar_given_PWTHESATG,
       modelPar_PLWTHESATG,
       modelPar_given_PLWTHESATG,
       modelPar_POAX,
       modelPar_given_POAX,
       modelPar_PLAX,
       modelPar_given_PLAX,
       modelPar_PWAX,
       modelPar_given_PWAX,
       modelPar_PLWAX,
       modelPar_given_PLWAX,
       modelPar_POALP,
       modelPar_given_POALP,
       modelPar_PLALP,
       modelPar_given_PLALP,
       modelPar_PWALP,
       modelPar_given_PWALP,
       modelPar_PLWALP,
       modelPar_given_PLWALP,
       modelPar_POALP1,
       modelPar_given_POALP1,
       modelPar_PLALP1,
       modelPar_given_PLALP1,
       modelPar_PWALP1,
       modelPar_given_PWALP1,
       modelPar_PLWALP1,
       modelPar_given_PLWALP1,
       modelPar_POALP2,
       modelPar_given_POALP2,
       modelPar_PLALP2,
       modelPar_given_PLALP2,
       modelPar_PWALP2,
       modelPar_given_PWALP2,
       modelPar_PLWALP2,
       modelPar_given_PLWALP2,
       modelPar_POVP,
       modelPar_given_POVP,
       modelPar_POA1,
       modelPar_given_POA1,
       modelPar_PLA1,
       modelPar_given_PLA1,
       modelPar_PWA1,
       modelPar_given_PWA1,
       modelPar_PLWA1,
       modelPar_given_PLWA1,
       modelPar_POA2,
       modelPar_given_POA2,
       modelPar_POSTA2,
       modelPar_given_POSTA2,
       modelPar_POA3,
       modelPar_given_POA3,
       modelPar_PLA3,
       modelPar_given_PLA3,
       modelPar_PWA3,
       modelPar_given_PWA3,
       modelPar_PLWA3,
       modelPar_given_PLWA3,
       modelPar_POA4,
       modelPar_given_POA4,
       modelPar_PLA4,
       modelPar_given_PLA4,
       modelPar_PWA4,
       modelPar_given_PWA4,
       modelPar_PLWA4,
       modelPar_given_PLWA4,
       modelPar_POGCO,
       modelPar_given_POGCO,
       modelPar_POIGINV,
       modelPar_given_POIGINV,
       modelPar_PLIGINV,
       modelPar_given_PLIGINV,
       modelPar_PWIGINV,
       modelPar_given_PWIGINV,
       modelPar_PLWIGINV,
       modelPar_given_PLWIGINV,
       modelPar_POIGOV,
       modelPar_given_POIGOV,
       modelPar_PLIGOV,
       modelPar_given_PLIGOV,
       modelPar_PWIGOV,
       modelPar_given_PWIGOV,
       modelPar_PLWIGOV,
       modelPar_given_PLWIGOV,
       modelPar_POIGOVD,
       modelPar_given_POIGOVD,
       modelPar_PLIGOVD,
       modelPar_given_PLIGOVD,
       modelPar_PWIGOVD,
       modelPar_given_PWIGOVD,
       modelPar_PLWIGOVD,
       modelPar_given_PLWIGOVD,
       modelPar_POSTIG,
       modelPar_given_POSTIG,
       modelPar_POGC2,
       modelPar_given_POGC2,
       modelPar_POGC3,
       modelPar_given_POGC3,
       modelPar_POCHIB,
       modelPar_given_POCHIB,
       modelPar_POAGIDL,
       modelPar_given_POAGIDL,
       modelPar_PLAGIDL,
       modelPar_given_PLAGIDL,
       modelPar_PWAGIDL,
       modelPar_given_PWAGIDL,
       modelPar_PLWAGIDL,
       modelPar_given_PLWAGIDL,
       modelPar_POAGIDLD,
       modelPar_given_POAGIDLD,
       modelPar_PLAGIDLD,
       modelPar_given_PLAGIDLD,
       modelPar_PWAGIDLD,
       modelPar_given_PWAGIDLD,
       modelPar_PLWAGIDLD,
       modelPar_given_PLWAGIDLD,
       modelPar_POBGIDL,
       modelPar_given_POBGIDL,
       modelPar_POBGIDLD,
       modelPar_given_POBGIDLD,
       modelPar_POSTBGIDL,
       modelPar_given_POSTBGIDL,
       modelPar_POSTBGIDLD,
       modelPar_given_POSTBGIDLD,
       modelPar_POCGIDL,
       modelPar_given_POCGIDL,
       modelPar_POCGIDLD,
       modelPar_given_POCGIDLD,
       modelPar_POCOX,
       modelPar_given_POCOX,
       modelPar_PLCOX,
       modelPar_given_PLCOX,
       modelPar_PWCOX,
       modelPar_given_PWCOX,
       modelPar_PLWCOX,
       modelPar_given_PLWCOX,
       modelPar_POCGOV,
       modelPar_given_POCGOV,
       modelPar_PLCGOV,
       modelPar_given_PLCGOV,
       modelPar_PWCGOV,
       modelPar_given_PWCGOV,
       modelPar_PLWCGOV,
       modelPar_given_PLWCGOV,
       modelPar_POCGOVD,
       modelPar_given_POCGOVD,
       modelPar_PLCGOVD,
       modelPar_given_PLCGOVD,
       modelPar_PWCGOVD,
       modelPar_given_PWCGOVD,
       modelPar_PLWCGOVD,
       modelPar_given_PLWCGOVD,
       modelPar_POCGBOV,
       modelPar_given_POCGBOV,
       modelPar_PLCGBOV,
       modelPar_given_PLCGBOV,
       modelPar_PWCGBOV,
       modelPar_given_PWCGBOV,
       modelPar_PLWCGBOV,
       modelPar_given_PLWCGBOV,
       modelPar_POCFR,
       modelPar_given_POCFR,
       modelPar_PLCFR,
       modelPar_given_PLCFR,
       modelPar_PWCFR,
       modelPar_given_PWCFR,
       modelPar_PLWCFR,
       modelPar_given_PLWCFR,
       modelPar_POCFRD,
       modelPar_given_POCFRD,
       modelPar_PLCFRD,
       modelPar_given_PLCFRD,
       modelPar_PWCFRD,
       modelPar_given_PWCFRD,
       modelPar_PLWCFRD,
       modelPar_given_PLWCFRD,
       modelPar_POFNT,
       modelPar_given_POFNT,
       modelPar_POFNTEXC,
       modelPar_given_POFNTEXC,
       modelPar_PLFNTEXC,
       modelPar_given_PLFNTEXC,
       modelPar_PWFNTEXC,
       modelPar_given_PWFNTEXC,
       modelPar_PLWFNTEXC,
       modelPar_given_PLWFNTEXC,
       modelPar_PONFA,
       modelPar_given_PONFA,
       modelPar_PLNFA,
       modelPar_given_PLNFA,
       modelPar_PWNFA,
       modelPar_given_PWNFA,
       modelPar_PLWNFA,
       modelPar_given_PLWNFA,
       modelPar_PONFB,
       modelPar_given_PONFB,
       modelPar_PLNFB,
       modelPar_given_PLNFB,
       modelPar_PWNFB,
       modelPar_given_PWNFB,
       modelPar_PLWNFB,
       modelPar_given_PLWNFB,
       modelPar_PONFC,
       modelPar_given_PONFC,
       modelPar_PLNFC,
       modelPar_given_PLNFC,
       modelPar_PWNFC,
       modelPar_given_PWNFC,
       modelPar_PLWNFC,
       modelPar_given_PLWNFC,
       modelPar_POEF,
       modelPar_given_POEF,
       modelPar_POVFBEDGE,
       modelPar_given_POVFBEDGE,
       modelPar_POSTVFBEDGE,
       modelPar_given_POSTVFBEDGE,
       modelPar_PLSTVFBEDGE,
       modelPar_given_PLSTVFBEDGE,
       modelPar_PWSTVFBEDGE,
       modelPar_given_PWSTVFBEDGE,
       modelPar_PLWSTVFBEDGE,
       modelPar_given_PLWSTVFBEDGE,
       modelPar_PODPHIBEDGE,
       modelPar_given_PODPHIBEDGE,
       modelPar_PLDPHIBEDGE,
       modelPar_given_PLDPHIBEDGE,
       modelPar_PWDPHIBEDGE,
       modelPar_given_PWDPHIBEDGE,
       modelPar_PLWDPHIBEDGE,
       modelPar_given_PLWDPHIBEDGE,
       modelPar_PONEFFEDGE,
       modelPar_given_PONEFFEDGE,
       modelPar_PLNEFFEDGE,
       modelPar_given_PLNEFFEDGE,
       modelPar_PWNEFFEDGE,
       modelPar_given_PWNEFFEDGE,
       modelPar_PLWNEFFEDGE,
       modelPar_given_PLWNEFFEDGE,
       modelPar_POCTEDGE,
       modelPar_given_POCTEDGE,
       modelPar_PLCTEDGE,
       modelPar_given_PLCTEDGE,
       modelPar_PWCTEDGE,
       modelPar_given_PWCTEDGE,
       modelPar_PLWCTEDGE,
       modelPar_given_PLWCTEDGE,
       modelPar_POBETNEDGE,
       modelPar_given_POBETNEDGE,
       modelPar_PLBETNEDGE,
       modelPar_given_PLBETNEDGE,
       modelPar_PWBETNEDGE,
       modelPar_given_PWBETNEDGE,
       modelPar_PLWBETNEDGE,
       modelPar_given_PLWBETNEDGE,
       modelPar_POSTBETEDGE,
       modelPar_given_POSTBETEDGE,
       modelPar_PLSTBETEDGE,
       modelPar_given_PLSTBETEDGE,
       modelPar_PWSTBETEDGE,
       modelPar_given_PWSTBETEDGE,
       modelPar_PLWSTBETEDGE,
       modelPar_given_PLWSTBETEDGE,
       modelPar_POPSCEEDGE,
       modelPar_given_POPSCEEDGE,
       modelPar_PLPSCEEDGE,
       modelPar_given_PLPSCEEDGE,
       modelPar_PWPSCEEDGE,
       modelPar_given_PWPSCEEDGE,
       modelPar_PLWPSCEEDGE,
       modelPar_given_PLWPSCEEDGE,
       modelPar_POPSCEBEDGE,
       modelPar_given_POPSCEBEDGE,
       modelPar_POPSCEDEDGE,
       modelPar_given_POPSCEDEDGE,
       modelPar_POCFEDGE,
       modelPar_given_POCFEDGE,
       modelPar_PLCFEDGE,
       modelPar_given_PLCFEDGE,
       modelPar_PWCFEDGE,
       modelPar_given_PWCFEDGE,
       modelPar_PLWCFEDGE,
       modelPar_given_PLWCFEDGE,
       modelPar_POCFDEDGE,
       modelPar_given_POCFDEDGE,
       modelPar_POCFBEDGE,
       modelPar_given_POCFBEDGE,
       modelPar_POFNTEDGE,
       modelPar_given_POFNTEDGE,
       modelPar_PONFAEDGE,
       modelPar_given_PONFAEDGE,
       modelPar_PLNFAEDGE,
       modelPar_given_PLNFAEDGE,
       modelPar_PWNFAEDGE,
       modelPar_given_PWNFAEDGE,
       modelPar_PLWNFAEDGE,
       modelPar_given_PLWNFAEDGE,
       modelPar_PONFBEDGE,
       modelPar_given_PONFBEDGE,
       modelPar_PLNFBEDGE,
       modelPar_given_PLNFBEDGE,
       modelPar_PWNFBEDGE,
       modelPar_given_PWNFBEDGE,
       modelPar_PLWNFBEDGE,
       modelPar_given_PLWNFBEDGE,
       modelPar_PONFCEDGE,
       modelPar_given_PONFCEDGE,
       modelPar_PLNFCEDGE,
       modelPar_given_PLNFCEDGE,
       modelPar_PWNFCEDGE,
       modelPar_given_PWNFCEDGE,
       modelPar_PLWNFCEDGE,
       modelPar_given_PLWNFCEDGE,
       modelPar_POEFEDGE,
       modelPar_given_POEFEDGE,
       modelPar_POKVTHOWE,
       modelPar_given_POKVTHOWE,
       modelPar_PLKVTHOWE,
       modelPar_given_PLKVTHOWE,
       modelPar_PWKVTHOWE,
       modelPar_given_PWKVTHOWE,
       modelPar_PLWKVTHOWE,
       modelPar_given_PLWKVTHOWE,
       modelPar_POKUOWE,
       modelPar_given_POKUOWE,
       modelPar_PLKUOWE,
       modelPar_given_PLKUOWE,
       modelPar_PWKUOWE,
       modelPar_given_PWKUOWE,
       modelPar_PLWKUOWE,
       modelPar_given_PLWKUOWE,
       modelPar_LMIN,
       modelPar_given_LMIN,
       modelPar_LMAX,
       modelPar_given_LMAX,
       modelPar_WMIN,
       modelPar_given_WMIN,
       modelPar_WMAX,
       modelPar_given_WMAX,
       modelPar_LVARO,
       modelPar_given_LVARO,
       modelPar_LVARL,
       modelPar_given_LVARL,
       modelPar_LVARW,
       modelPar_given_LVARW,
       modelPar_LAP,
       modelPar_given_LAP,
       modelPar_WVARO,
       modelPar_given_WVARO,
       modelPar_WVARL,
       modelPar_given_WVARL,
       modelPar_WVARW,
       modelPar_given_WVARW,
       modelPar_WOT,
       modelPar_given_WOT,
       modelPar_DLQ,
       modelPar_given_DLQ,
       modelPar_DWQ,
       modelPar_given_DWQ,
       modelPar_VFBO,
       modelPar_given_VFBO,
       modelPar_VFBL,
       modelPar_given_VFBL,
       modelPar_VFBW,
       modelPar_given_VFBW,
       modelPar_VFBLW,
       modelPar_given_VFBLW,
       modelPar_STVFBO,
       modelPar_given_STVFBO,
       modelPar_STVFBL,
       modelPar_given_STVFBL,
       modelPar_STVFBW,
       modelPar_given_STVFBW,
       modelPar_STVFBLW,
       modelPar_given_STVFBLW,
       modelPar_TOXO,
       modelPar_given_TOXO,
       modelPar_EPSROXO,
       modelPar_given_EPSROXO,
       modelPar_NSUBO,
       modelPar_given_NSUBO,
       modelPar_NSUBW,
       modelPar_given_NSUBW,
       modelPar_WSEG,
       modelPar_given_WSEG,
       modelPar_NPCK,
       modelPar_given_NPCK,
       modelPar_NPCKW,
       modelPar_given_NPCKW,
       modelPar_WSEGP,
       modelPar_given_WSEGP,
       modelPar_LPCK,
       modelPar_given_LPCK,
       modelPar_LPCKW,
       modelPar_given_LPCKW,
       modelPar_FOL1,
       modelPar_given_FOL1,
       modelPar_FOL2,
       modelPar_given_FOL2,
       modelPar_FACNEFFACO,
       modelPar_given_FACNEFFACO,
       modelPar_FACNEFFACL,
       modelPar_given_FACNEFFACL,
       modelPar_FACNEFFACW,
       modelPar_given_FACNEFFACW,
       modelPar_FACNEFFACLW,
       modelPar_given_FACNEFFACLW,
       modelPar_GFACNUDO,
       modelPar_given_GFACNUDO,
       modelPar_GFACNUDL,
       modelPar_given_GFACNUDL,
       modelPar_GFACNUDLEXP,
       modelPar_given_GFACNUDLEXP,
       modelPar_GFACNUDW,
       modelPar_given_GFACNUDW,
       modelPar_GFACNUDLW,
       modelPar_given_GFACNUDLW,
       modelPar_VSBNUDO,
       modelPar_given_VSBNUDO,
       modelPar_DVSBNUDO,
       modelPar_given_DVSBNUDO,
       modelPar_VNSUBO,
       modelPar_given_VNSUBO,
       modelPar_NSLPO,
       modelPar_given_NSLPO,
       modelPar_DNSUBO,
       modelPar_given_DNSUBO,
       modelPar_DPHIBO,
       modelPar_given_DPHIBO,
       modelPar_DPHIBL,
       modelPar_given_DPHIBL,
       modelPar_DPHIBLEXP,
       modelPar_given_DPHIBLEXP,
       modelPar_DPHIBW,
       modelPar_given_DPHIBW,
       modelPar_DPHIBLW,
       modelPar_given_DPHIBLW,
       modelPar_DELVTACO,
       modelPar_given_DELVTACO,
       modelPar_DELVTACL,
       modelPar_given_DELVTACL,
       modelPar_DELVTACLEXP,
       modelPar_given_DELVTACLEXP,
       modelPar_DELVTACW,
       modelPar_given_DELVTACW,
       modelPar_DELVTACLW,
       modelPar_given_DELVTACLW,
       modelPar_NPO,
       modelPar_given_NPO,
       modelPar_NPL,
       modelPar_given_NPL,
       modelPar_CTO,
       modelPar_given_CTO,
       modelPar_CTL,
       modelPar_given_CTL,
       modelPar_CTLEXP,
       modelPar_given_CTLEXP,
       modelPar_CTW,
       modelPar_given_CTW,
       modelPar_CTLW,
       modelPar_given_CTLW,
       modelPar_TOXOVO,
       modelPar_given_TOXOVO,
       modelPar_TOXOVDO,
       modelPar_given_TOXOVDO,
       modelPar_LOV,
       modelPar_given_LOV,
       modelPar_LOVD,
       modelPar_given_LOVD,
       modelPar_NOVO,
       modelPar_given_NOVO,
       modelPar_NOVDO,
       modelPar_given_NOVDO,
       modelPar_CFL,
       modelPar_given_CFL,
       modelPar_CFLEXP,
       modelPar_given_CFLEXP,
       modelPar_CFW,
       modelPar_given_CFW,
       modelPar_CFDO,
       modelPar_given_CFDO,
       modelPar_CFBO,
       modelPar_given_CFBO,
       modelPar_PSCEL,
       modelPar_given_PSCEL,
       modelPar_PSCELEXP,
       modelPar_given_PSCELEXP,
       modelPar_PSCEW,
       modelPar_given_PSCEW,
       modelPar_PSCEBO,
       modelPar_given_PSCEBO,
       modelPar_PSCEDO,
       modelPar_given_PSCEDO,
       modelPar_UO,
       modelPar_given_UO,
       modelPar_FBET1,
       modelPar_given_FBET1,
       modelPar_FBET1W,
       modelPar_given_FBET1W,
       modelPar_LP1,
       modelPar_given_LP1,
       modelPar_LP1W,
       modelPar_given_LP1W,
       modelPar_FBET2,
       modelPar_given_FBET2,
       modelPar_LP2,
       modelPar_given_LP2,
       modelPar_BETW1,
       modelPar_given_BETW1,
       modelPar_BETW2,
       modelPar_given_BETW2,
       modelPar_WBET,
       modelPar_given_WBET,
       modelPar_STBETO,
       modelPar_given_STBETO,
       modelPar_STBETL,
       modelPar_given_STBETL,
       modelPar_STBETW,
       modelPar_given_STBETW,
       modelPar_STBETLW,
       modelPar_given_STBETLW,
       modelPar_MUEO,
       modelPar_given_MUEO,
       modelPar_MUEW,
       modelPar_given_MUEW,
       modelPar_STMUEO,
       modelPar_given_STMUEO,
       modelPar_THEMUO,
       modelPar_given_THEMUO,
       modelPar_STTHEMUO,
       modelPar_given_STTHEMUO,
       modelPar_CSO,
       modelPar_given_CSO,
       modelPar_CSL,
       modelPar_given_CSL,
       modelPar_CSLEXP,
       modelPar_given_CSLEXP,
       modelPar_CSW,
       modelPar_given_CSW,
       modelPar_CSLW,
       modelPar_given_CSLW,
       modelPar_STCSO,
       modelPar_given_STCSO,
       modelPar_XCORO,
       modelPar_given_XCORO,
       modelPar_XCORL,
       modelPar_given_XCORL,
       modelPar_XCORW,
       modelPar_given_XCORW,
       modelPar_XCORLW,
       modelPar_given_XCORLW,
       modelPar_STXCORO,
       modelPar_given_STXCORO,
       modelPar_FETAO,
       modelPar_given_FETAO,
       modelPar_RSW1,
       modelPar_given_RSW1,
       modelPar_RSW2,
       modelPar_given_RSW2,
       modelPar_STRSO,
       modelPar_given_STRSO,
       modelPar_RSBO,
       modelPar_given_RSBO,
       modelPar_RSGO,
       modelPar_given_RSGO,
       modelPar_THESATO,
       modelPar_given_THESATO,
       modelPar_THESATL,
       modelPar_given_THESATL,
       modelPar_THESATLEXP,
       modelPar_given_THESATLEXP,
       modelPar_THESATW,
       modelPar_given_THESATW,
       modelPar_THESATLW,
       modelPar_given_THESATLW,
       modelPar_STTHESATO,
       modelPar_given_STTHESATO,
       modelPar_STTHESATL,
       modelPar_given_STTHESATL,
       modelPar_STTHESATW,
       modelPar_given_STTHESATW,
       modelPar_STTHESATLW,
       modelPar_given_STTHESATLW,
       modelPar_THESATBO,
       modelPar_given_THESATBO,
       modelPar_THESATGO,
       modelPar_given_THESATGO,
       modelPar_AXO,
       modelPar_given_AXO,
       modelPar_AXL,
       modelPar_given_AXL,
       modelPar_ALPL,
       modelPar_given_ALPL,
       modelPar_ALPLEXP,
       modelPar_given_ALPLEXP,
       modelPar_ALPW,
       modelPar_given_ALPW,
       modelPar_ALP1L1,
       modelPar_given_ALP1L1,
       modelPar_ALP1LEXP,
       modelPar_given_ALP1LEXP,
       modelPar_ALP1L2,
       modelPar_given_ALP1L2,
       modelPar_ALP1W,
       modelPar_given_ALP1W,
       modelPar_ALP2L1,
       modelPar_given_ALP2L1,
       modelPar_ALP2LEXP,
       modelPar_given_ALP2LEXP,
       modelPar_ALP2L2,
       modelPar_given_ALP2L2,
       modelPar_ALP2W,
       modelPar_given_ALP2W,
       modelPar_VPO,
       modelPar_given_VPO,
       modelPar_A1O,
       modelPar_given_A1O,
       modelPar_A1L,
       modelPar_given_A1L,
       modelPar_A1W,
       modelPar_given_A1W,
       modelPar_A2O,
       modelPar_given_A2O,
       modelPar_STA2O,
       modelPar_given_STA2O,
       modelPar_A3O,
       modelPar_given_A3O,
       modelPar_A3L,
       modelPar_given_A3L,
       modelPar_A3W,
       modelPar_given_A3W,
       modelPar_A4O,
       modelPar_given_A4O,
       modelPar_A4L,
       modelPar_given_A4L,
       modelPar_A4W,
       modelPar_given_A4W,
       modelPar_GCOO,
       modelPar_given_GCOO,
       modelPar_IGINVLW,
       modelPar_given_IGINVLW,
       modelPar_IGOVW,
       modelPar_given_IGOVW,
       modelPar_IGOVDW,
       modelPar_given_IGOVDW,
       modelPar_STIGO,
       modelPar_given_STIGO,
       modelPar_GC2O,
       modelPar_given_GC2O,
       modelPar_GC3O,
       modelPar_given_GC3O,
       modelPar_CHIBO,
       modelPar_given_CHIBO,
       modelPar_AGIDLW,
       modelPar_given_AGIDLW,
       modelPar_AGIDLDW,
       modelPar_given_AGIDLDW,
       modelPar_BGIDLO,
       modelPar_given_BGIDLO,
       modelPar_BGIDLDO,
       modelPar_given_BGIDLDO,
       modelPar_STBGIDLO,
       modelPar_given_STBGIDLO,
       modelPar_STBGIDLDO,
       modelPar_given_STBGIDLDO,
       modelPar_CGIDLO,
       modelPar_given_CGIDLO,
       modelPar_CGIDLDO,
       modelPar_given_CGIDLDO,
       modelPar_CGBOVL,
       modelPar_given_CGBOVL,
       modelPar_CFRW,
       modelPar_given_CFRW,
       modelPar_CFRDW,
       modelPar_given_CFRDW,
       modelPar_FNTO,
       modelPar_given_FNTO,
       modelPar_FNTEXCL,
       modelPar_given_FNTEXCL,
       modelPar_NFALW,
       modelPar_given_NFALW,
       modelPar_NFBLW,
       modelPar_given_NFBLW,
       modelPar_NFCLW,
       modelPar_given_NFCLW,
       modelPar_EFO,
       modelPar_given_EFO,
       modelPar_LINTNOI,
       modelPar_given_LINTNOI,
       modelPar_ALPNOI,
       modelPar_given_ALPNOI,
       modelPar_WEDGE,
       modelPar_given_WEDGE,
       modelPar_WEDGEW,
       modelPar_given_WEDGEW,
       modelPar_VFBEDGEO,
       modelPar_given_VFBEDGEO,
       modelPar_STVFBEDGEO,
       modelPar_given_STVFBEDGEO,
       modelPar_STVFBEDGEL,
       modelPar_given_STVFBEDGEL,
       modelPar_STVFBEDGEW,
       modelPar_given_STVFBEDGEW,
       modelPar_STVFBEDGELW,
       modelPar_given_STVFBEDGELW,
       modelPar_DPHIBEDGEO,
       modelPar_given_DPHIBEDGEO,
       modelPar_DPHIBEDGEL,
       modelPar_given_DPHIBEDGEL,
       modelPar_DPHIBEDGELEXP,
       modelPar_given_DPHIBEDGELEXP,
       modelPar_DPHIBEDGEW,
       modelPar_given_DPHIBEDGEW,
       modelPar_DPHIBEDGELW,
       modelPar_given_DPHIBEDGELW,
       modelPar_NSUBEDGEO,
       modelPar_given_NSUBEDGEO,
       modelPar_NSUBEDGEL,
       modelPar_given_NSUBEDGEL,
       modelPar_NSUBEDGEW,
       modelPar_given_NSUBEDGEW,
       modelPar_NSUBEDGELW,
       modelPar_given_NSUBEDGELW,
       modelPar_CTEDGEO,
       modelPar_given_CTEDGEO,
       modelPar_CTEDGEL,
       modelPar_given_CTEDGEL,
       modelPar_CTEDGELEXP,
       modelPar_given_CTEDGELEXP,
       modelPar_FBETEDGE,
       modelPar_given_FBETEDGE,
       modelPar_LPEDGE,
       modelPar_given_LPEDGE,
       modelPar_BETEDGEW,
       modelPar_given_BETEDGEW,
       modelPar_STBETEDGEO,
       modelPar_given_STBETEDGEO,
       modelPar_STBETEDGEL,
       modelPar_given_STBETEDGEL,
       modelPar_STBETEDGEW,
       modelPar_given_STBETEDGEW,
       modelPar_STBETEDGELW,
       modelPar_given_STBETEDGELW,
       modelPar_PSCEEDGEL,
       modelPar_given_PSCEEDGEL,
       modelPar_PSCEEDGELEXP,
       modelPar_given_PSCEEDGELEXP,
       modelPar_PSCEEDGEW,
       modelPar_given_PSCEEDGEW,
       modelPar_PSCEBEDGEO,
       modelPar_given_PSCEBEDGEO,
       modelPar_PSCEDEDGEO,
       modelPar_given_PSCEDEDGEO,
       modelPar_CFEDGEL,
       modelPar_given_CFEDGEL,
       modelPar_CFEDGELEXP,
       modelPar_given_CFEDGELEXP,
       modelPar_CFEDGEW,
       modelPar_given_CFEDGEW,
       modelPar_CFDEDGEO,
       modelPar_given_CFDEDGEO,
       modelPar_CFBEDGEO,
       modelPar_given_CFBEDGEO,
       modelPar_FNTEDGEO,
       modelPar_given_FNTEDGEO,
       modelPar_NFAEDGELW,
       modelPar_given_NFAEDGELW,
       modelPar_NFBEDGELW,
       modelPar_given_NFBEDGELW,
       modelPar_NFCEDGELW,
       modelPar_given_NFCEDGELW,
       modelPar_EFEDGEO,
       modelPar_given_EFEDGEO,
       modelPar_KVTHOWEO,
       modelPar_given_KVTHOWEO,
       modelPar_KVTHOWEL,
       modelPar_given_KVTHOWEL,
       modelPar_KVTHOWEW,
       modelPar_given_KVTHOWEW,
       modelPar_KVTHOWELW,
       modelPar_given_KVTHOWELW,
       modelPar_KUOWEO,
       modelPar_given_KUOWEO,
       modelPar_KUOWEL,
       modelPar_given_KUOWEL,
       modelPar_KUOWEW,
       modelPar_given_KUOWEW,
       modelPar_KUOWELW,
       modelPar_given_KUOWELW,
       modelPar_RGO,
       modelPar_given_RGO,
       modelPar_RINT,
       modelPar_given_RINT,
       modelPar_RVPOLY,
       modelPar_given_RVPOLY,
       modelPar_RSHG,
       modelPar_given_RSHG,
       modelPar_DLSIL,
       modelPar_given_DLSIL,
       modelPar_RSH,
       modelPar_given_RSH,
       modelPar_RSHD,
       modelPar_given_RSHD,
       modelPar_RBULKO,
       modelPar_given_RBULKO,
       modelPar_RWELLO,
       modelPar_given_RWELLO,
       modelPar_RJUNSO,
       modelPar_given_RJUNSO,
       modelPar_RJUNDO,
       modelPar_given_RJUNDO,
       modelPar_SAREF,
       modelPar_given_SAREF,
       modelPar_SBREF,
       modelPar_given_SBREF,
       modelPar_WLOD,
       modelPar_given_WLOD,
       modelPar_KUO,
       modelPar_given_KUO,
       modelPar_KVSAT,
       modelPar_given_KVSAT,
       modelPar_TKUO,
       modelPar_given_TKUO,
       modelPar_LKUO,
       modelPar_given_LKUO,
       modelPar_WKUO,
       modelPar_given_WKUO,
       modelPar_PKUO,
       modelPar_given_PKUO,
       modelPar_LLODKUO,
       modelPar_given_LLODKUO,
       modelPar_WLODKUO,
       modelPar_given_WLODKUO,
       modelPar_KVTHO,
       modelPar_given_KVTHO,
       modelPar_LKVTHO,
       modelPar_given_LKVTHO,
       modelPar_WKVTHO,
       modelPar_given_WKVTHO,
       modelPar_PKVTHO,
       modelPar_given_PKVTHO,
       modelPar_LLODVTH,
       modelPar_given_LLODVTH,
       modelPar_WLODVTH,
       modelPar_given_WLODVTH,
       modelPar_STETAO,
       modelPar_given_STETAO,
       modelPar_LODETAO,
       modelPar_given_LODETAO,
       modelPar_SCREF,
       modelPar_given_SCREF,
       modelPar_WEB,
       modelPar_given_WEB,
       modelPar_WEC,
       modelPar_given_WEC,
       modelPar_IMAX,
       modelPar_given_IMAX,
       modelPar_TRJ,
       modelPar_given_TRJ,
       modelPar_FREV,
       modelPar_given_FREV,
       modelPar_CJORBOT,
       modelPar_given_CJORBOT,
       modelPar_CJORSTI,
       modelPar_given_CJORSTI,
       modelPar_CJORGAT,
       modelPar_given_CJORGAT,
       modelPar_VBIRBOT,
       modelPar_given_VBIRBOT,
       modelPar_VBIRSTI,
       modelPar_given_VBIRSTI,
       modelPar_VBIRGAT,
       modelPar_given_VBIRGAT,
       modelPar_PBOT,
       modelPar_given_PBOT,
       modelPar_PSTI,
       modelPar_given_PSTI,
       modelPar_PGAT,
       modelPar_given_PGAT,
       modelPar_PHIGBOT,
       modelPar_given_PHIGBOT,
       modelPar_PHIGSTI,
       modelPar_given_PHIGSTI,
       modelPar_PHIGGAT,
       modelPar_given_PHIGGAT,
       modelPar_IDSATRBOT,
       modelPar_given_IDSATRBOT,
       modelPar_IDSATRSTI,
       modelPar_given_IDSATRSTI,
       modelPar_IDSATRGAT,
       modelPar_given_IDSATRGAT,
       modelPar_CSRHBOT,
       modelPar_given_CSRHBOT,
       modelPar_CSRHSTI,
       modelPar_given_CSRHSTI,
       modelPar_CSRHGAT,
       modelPar_given_CSRHGAT,
       modelPar_XJUNSTI,
       modelPar_given_XJUNSTI,
       modelPar_XJUNGAT,
       modelPar_given_XJUNGAT,
       modelPar_CTATBOT,
       modelPar_given_CTATBOT,
       modelPar_CTATSTI,
       modelPar_given_CTATSTI,
       modelPar_CTATGAT,
       modelPar_given_CTATGAT,
       modelPar_MEFFTATBOT,
       modelPar_given_MEFFTATBOT,
       modelPar_MEFFTATSTI,
       modelPar_given_MEFFTATSTI,
       modelPar_MEFFTATGAT,
       modelPar_given_MEFFTATGAT,
       modelPar_CBBTBOT,
       modelPar_given_CBBTBOT,
       modelPar_CBBTSTI,
       modelPar_given_CBBTSTI,
       modelPar_CBBTGAT,
       modelPar_given_CBBTGAT,
       modelPar_FBBTRBOT,
       modelPar_given_FBBTRBOT,
       modelPar_FBBTRSTI,
       modelPar_given_FBBTRSTI,
       modelPar_FBBTRGAT,
       modelPar_given_FBBTRGAT,
       modelPar_STFBBTBOT,
       modelPar_given_STFBBTBOT,
       modelPar_STFBBTSTI,
       modelPar_given_STFBBTSTI,
       modelPar_STFBBTGAT,
       modelPar_given_STFBBTGAT,
       modelPar_VBRBOT,
       modelPar_given_VBRBOT,
       modelPar_VBRSTI,
       modelPar_given_VBRSTI,
       modelPar_VBRGAT,
       modelPar_given_VBRGAT,
       modelPar_PBRBOT,
       modelPar_given_PBRBOT,
       modelPar_PBRSTI,
       modelPar_given_PBRSTI,
       modelPar_PBRGAT,
       modelPar_given_PBRGAT,
       modelPar_CJORBOTD,
       modelPar_given_CJORBOTD,
       modelPar_CJORSTID,
       modelPar_given_CJORSTID,
       modelPar_CJORGATD,
       modelPar_given_CJORGATD,
       modelPar_VBIRBOTD,
       modelPar_given_VBIRBOTD,
       modelPar_VBIRSTID,
       modelPar_given_VBIRSTID,
       modelPar_VBIRGATD,
       modelPar_given_VBIRGATD,
       modelPar_PBOTD,
       modelPar_given_PBOTD,
       modelPar_PSTID,
       modelPar_given_PSTID,
       modelPar_PGATD,
       modelPar_given_PGATD,
       modelPar_PHIGBOTD,
       modelPar_given_PHIGBOTD,
       modelPar_PHIGSTID,
       modelPar_given_PHIGSTID,
       modelPar_PHIGGATD,
       modelPar_given_PHIGGATD,
       modelPar_IDSATRBOTD,
       modelPar_given_IDSATRBOTD,
       modelPar_IDSATRSTID,
       modelPar_given_IDSATRSTID,
       modelPar_IDSATRGATD,
       modelPar_given_IDSATRGATD,
       modelPar_CSRHBOTD,
       modelPar_given_CSRHBOTD,
       modelPar_CSRHSTID,
       modelPar_given_CSRHSTID,
       modelPar_CSRHGATD,
       modelPar_given_CSRHGATD,
       modelPar_XJUNSTID,
       modelPar_given_XJUNSTID,
       modelPar_XJUNGATD,
       modelPar_given_XJUNGATD,
       modelPar_CTATBOTD,
       modelPar_given_CTATBOTD,
       modelPar_CTATSTID,
       modelPar_given_CTATSTID,
       modelPar_CTATGATD,
       modelPar_given_CTATGATD,
       modelPar_MEFFTATBOTD,
       modelPar_given_MEFFTATBOTD,
       modelPar_MEFFTATSTID,
       modelPar_given_MEFFTATSTID,
       modelPar_MEFFTATGATD,
       modelPar_given_MEFFTATGATD,
       modelPar_CBBTBOTD,
       modelPar_given_CBBTBOTD,
       modelPar_CBBTSTID,
       modelPar_given_CBBTSTID,
       modelPar_CBBTGATD,
       modelPar_given_CBBTGATD,
       modelPar_FBBTRBOTD,
       modelPar_given_FBBTRBOTD,
       modelPar_FBBTRSTID,
       modelPar_given_FBBTRSTID,
       modelPar_FBBTRGATD,
       modelPar_given_FBBTRGATD,
       modelPar_STFBBTBOTD,
       modelPar_given_STFBBTBOTD,
       modelPar_STFBBTSTID,
       modelPar_given_STFBBTSTID,
       modelPar_STFBBTGATD,
       modelPar_given_STFBBTGATD,
       modelPar_VBRBOTD,
       modelPar_given_VBRBOTD,
       modelPar_VBRSTID,
       modelPar_given_VBRSTID,
       modelPar_VBRGATD,
       modelPar_given_VBRGATD,
       modelPar_PBRBOTD,
       modelPar_given_PBRBOTD,
       modelPar_PBRSTID,
       modelPar_given_PBRSTID,
       modelPar_PBRGATD,
       modelPar_given_PBRGATD,
       modelPar_SWJUNEXP,
       modelPar_given_SWJUNEXP,
       modelPar_VJUNREF,
       modelPar_given_VJUNREF,
       modelPar_FJUNQ,
       modelPar_given_FJUNQ,
       modelPar_VJUNREFD,
       modelPar_given_VJUNREFD,
       modelPar_FJUNQD,
       modelPar_given_FJUNQD,
       modelPar_DTA,
       modelPar_given_DTA,
       // non-reals (including hidden)
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_TYPE,
       modelPar_given_TYPE,
       modelPar_SWGEO,
       modelPar_given_SWGEO,
       modelPar_SWIGATE,
       modelPar_given_SWIGATE,
       modelPar_SWIMPACT,
       modelPar_given_SWIMPACT,
       modelPar_SWGIDL,
       modelPar_given_SWGIDL,
       modelPar_SWJUNCAP,
       modelPar_given_SWJUNCAP,
       modelPar_SWJUNASYM,
       modelPar_given_SWJUNASYM,
       modelPar_SWNUD,
       modelPar_given_SWNUD,
       modelPar_SWEDGE,
       modelPar_given_SWEDGE,
       modelPar_SWDELVTAC,
       modelPar_given_SWDELVTAC,
       modelPar_SWIGN,
       modelPar_given_SWIGN// model variables
       ,
       // reals
       modelVar_TOXO_i,
       modelVar_EPSROXO_i,
       modelVar_NSUBO_i,
       modelVar_WSEG_i,
       modelVar_NPCK_i,
       modelVar_WSEGP_i,
       modelVar_LPCK_i,
       modelVar_TOXOVO_i,
       modelVar_TOXOVDO_i,
       modelVar_LOV_i,
       modelVar_LOVD_i,
       modelVar_LP1_i,
       modelVar_LP2_i,
       modelVar_WBET_i,
       modelVar_AXL_i,
       modelVar_ALP1L2_i,
       modelVar_ALP2L2_i,
       modelVar_SAREF_i,
       modelVar_SBREF_i,
       modelVar_KVSAT_i,
       modelVar_LLODKUO_i,
       modelVar_WLODKUO_i,
       modelVar_LLODVTH_i,
       modelVar_WLODVTH_i,
       modelVar_LODETAO_i,
       modelVar_SCREF_i,
       modelVar_WEB_i,
       modelVar_WEC_i,
       modelVar_RSHG_i,
       modelVar_RSH_i,
       modelVar_RSHD_i,
       modelVar_RINT_i,
       modelVar_RVPOLY_i,
       modelVar_NSUBEDGEO_i,
       modelVar_LPEDGE_i,
       modelVar_QMC_i,
       modelVar_rTa,
       modelVar_delTa,
       modelVar_phita,
       modelVar_inv_phita,
       modelVar_TKD,
       modelVar_delT,
       modelVar_rTn,
       modelVar_ln_rTn,
       modelVar_inv_phit,
       modelVar_Eg,
       modelVar_phibFac,
       modelVar_IMAX_i,
       modelVar_VBIRBOT_i,
       modelVar_VBIRSTI_i,
       modelVar_VBIRGAT_i,
       modelVar_PBOT_i,
       modelVar_PSTI_i,
       modelVar_PGAT_i,
       modelVar_CSRHBOT_i,
       modelVar_CSRHSTI_i,
       modelVar_CSRHGAT_i,
       modelVar_CTATBOT_i,
       modelVar_CTATSTI_i,
       modelVar_CTATGAT_i,
       modelVar_CBBTBOT_i,
       modelVar_CBBTSTI_i,
       modelVar_CBBTGAT_i,
       modelVar_VBRBOT_i,
       modelVar_VBRSTI_i,
       modelVar_VBRGAT_i,
       modelVar_PBRBOT_i,
       modelVar_PBRSTI_i,
       modelVar_PBRGAT_i,
       modelVar_SWJUNEXP_i,
       modelVar_VJUNREF_i,
       modelVar_FJUNQ_i,
       modelVar_phitr,
       modelVar_phitd,
       modelVar_phitdinv,
       modelVar_perfc,
       modelVar_berfc,
       modelVar_cerfc,
       modelVar_ftdbot,
       modelVar_ftdsti,
       modelVar_ftdgat,
       modelVar_idsatbot,
       modelVar_idsatsti,
       modelVar_idsatgat,
       modelVar_vbibot,
       modelVar_vbisti,
       modelVar_vbigat,
       modelVar_vbiinvbot,
       modelVar_vbiinvsti,
       modelVar_vbiinvgat,
       modelVar_one_minus_PBOT,
       modelVar_one_minus_PSTI,
       modelVar_one_minus_PGAT,
       modelVar_one_over_one_minus_PBOT,
       modelVar_one_over_one_minus_PSTI,
       modelVar_one_over_one_minus_PGAT,
       modelVar_cjobot,
       modelVar_cjosti,
       modelVar_cjogat,
       modelVar_qprefbot,
       modelVar_qprefsti,
       modelVar_qprefgat,
       modelVar_qpref2bot,
       modelVar_qpref2sti,
       modelVar_qpref2gat,
       modelVar_wdepnulrbot,
       modelVar_wdepnulrsti,
       modelVar_wdepnulrgat,
       modelVar_wdepnulrinvbot,
       modelVar_wdepnulrinvsti,
       modelVar_wdepnulrinvgat,
       modelVar_VBIRBOTinv,
       modelVar_VBIRSTIinv,
       modelVar_VBIRGATinv,
       modelVar_atatbot,
       modelVar_atatsti,
       modelVar_atatgat,
       modelVar_btatpartbot,
       modelVar_btatpartsti,
       modelVar_btatpartgat,
       modelVar_fbbtbot,
       modelVar_fbbtsti,
       modelVar_fbbtgat,
       modelVar_alphaav,
       modelVar_fstopbot,
       modelVar_fstopsti,
       modelVar_fstopgat,
       modelVar_VBRinvbot,
       modelVar_VBRinvsti,
       modelVar_VBRinvgat,
       modelVar_slopebot,
       modelVar_slopesti,
       modelVar_slopegat,
       modelVar_VBIRBOTD_i,
       modelVar_VBIRSTID_i,
       modelVar_VBIRGATD_i,
       modelVar_PBOTD_i,
       modelVar_PSTID_i,
       modelVar_PGATD_i,
       modelVar_CSRHBOTD_i,
       modelVar_CSRHSTID_i,
       modelVar_CSRHGATD_i,
       modelVar_CTATBOTD_i,
       modelVar_CTATSTID_i,
       modelVar_CTATGATD_i,
       modelVar_CBBTBOTD_i,
       modelVar_CBBTSTID_i,
       modelVar_CBBTGATD_i,
       modelVar_VBRBOTD_i,
       modelVar_VBRSTID_i,
       modelVar_VBRGATD_i,
       modelVar_PBRBOTD_i,
       modelVar_PBRSTID_i,
       modelVar_PBRGATD_i,
       modelVar_VJUNREFD_i,
       modelVar_FJUNQD_i,
       modelVar_ftdbot_d,
       modelVar_ftdsti_d,
       modelVar_ftdgat_d,
       modelVar_idsatbot_d,
       modelVar_idsatsti_d,
       modelVar_idsatgat_d,
       modelVar_vbibot_d,
       modelVar_vbisti_d,
       modelVar_vbigat_d,
       modelVar_vbiinvbot_d,
       modelVar_vbiinvsti_d,
       modelVar_vbiinvgat_d,
       modelVar_one_minus_PBOT_d,
       modelVar_one_minus_PSTI_d,
       modelVar_one_minus_PGAT_d,
       modelVar_one_over_one_minus_PBOT_d,
       modelVar_one_over_one_minus_PSTI_d,
       modelVar_one_over_one_minus_PGAT_d,
       modelVar_cjobot_d,
       modelVar_cjosti_d,
       modelVar_cjogat_d,
       modelVar_qprefbot_d,
       modelVar_qprefsti_d,
       modelVar_qprefgat_d,
       modelVar_qpref2bot_d,
       modelVar_qpref2sti_d,
       modelVar_qpref2gat_d,
       modelVar_wdepnulrbot_d,
       modelVar_wdepnulrsti_d,
       modelVar_wdepnulrgat_d,
       modelVar_wdepnulrinvbot_d,
       modelVar_wdepnulrinvsti_d,
       modelVar_wdepnulrinvgat_d,
       modelVar_VBIRBOTinv_d,
       modelVar_VBIRSTIinv_d,
       modelVar_VBIRGATinv_d,
       modelVar_atatbot_d,
       modelVar_atatsti_d,
       modelVar_atatgat_d,
       modelVar_btatpartbot_d,
       modelVar_btatpartsti_d,
       modelVar_btatpartgat_d,
       modelVar_fbbtbot_d,
       modelVar_fbbtsti_d,
       modelVar_fbbtgat_d,
       modelVar_fstopbot_d,
       modelVar_fstopsti_d,
       modelVar_fstopgat_d,
       modelVar_VBRinvbot_d,
       modelVar_VBRinvsti_d,
       modelVar_VBRinvgat_d,
       modelVar_slopebot_d,
       modelVar_slopesti_d,
       modelVar_slopegat_d,
       modelVar_phit,
       modelVar_nt0,
       modelVar_EPSSI,
       // non-reals
       modelVar_CHNL_TYPE,
       modelVar_SWGEO_i,
       modelVar_SWIGATE_i,
       modelVar_SWIMPACT_i,
       modelVar_SWGIDL_i,
       modelVar_SWJUNCAP_i,
       modelVar_SWJUNASYM_i,
       modelVar_SWNUD_i,
       modelVar_SWEDGE_i,
       modelVar_SWDELVTAC_i,
       modelVar_SWIGN_i,
       mod.admsModTemp,in.getDeviceOptions().gmin,in);
    evaluateInitialInstance(
       // instance parameters
       // reals
       instancePar_L,
       instancePar_given_L,
       instancePar_W,
       instancePar_given_W,
       instancePar_SA,
       instancePar_given_SA,
       instancePar_SB,
       instancePar_given_SB,
       instancePar_SD,
       instancePar_given_SD,
       instancePar_SCA,
       instancePar_given_SCA,
       instancePar_SCB,
       instancePar_given_SCB,
       instancePar_SCC,
       instancePar_given_SCC,
       instancePar_SC,
       instancePar_given_SC,
       instancePar_NF,
       instancePar_given_NF,
       instancePar_NGCON,
       instancePar_given_NGCON,
       instancePar_XGW,
       instancePar_given_XGW,
       instancePar_NRS,
       instancePar_given_NRS,
       instancePar_NRD,
       instancePar_given_NRD,
       instancePar_JW,
       instancePar_given_JW,
       instancePar_DELVTO,
       instancePar_given_DELVTO,
       instancePar_FACTUO,
       instancePar_given_FACTUO,
       instancePar_DELVTOEDGE,
       instancePar_given_DELVTOEDGE,
       instancePar_FACTUOEDGE,
       instancePar_given_FACTUOEDGE,
       instancePar_ABSOURCE,
       instancePar_given_ABSOURCE,
       instancePar_LSSOURCE,
       instancePar_given_LSSOURCE,
       instancePar_LGSOURCE,
       instancePar_given_LGSOURCE,
       instancePar_ABDRAIN,
       instancePar_given_ABDRAIN,
       instancePar_LSDRAIN,
       instancePar_given_LSDRAIN,
       instancePar_LGDRAIN,
       instancePar_given_LGDRAIN,
       instancePar_AS,
       instancePar_given_AS,
       instancePar_PS,
       instancePar_given_PS,
       instancePar_AD,
       instancePar_given_AD,
       instancePar_PD,
       instancePar_given_PD,
       instancePar_MULT,
       instancePar_given_MULT,
       // instance variables
       // reals
       instanceVar_MULT_i,
       instanceVar_GFACNUD_i,
       instanceVar_VNSUB_i,
       instanceVar_NSLP_i,
       instanceVar_DNSUB_i,
       instanceVar_CF_i,
       instanceVar_CFD_i,
       instanceVar_CFB_i,
       instanceVar_PSCE_i,
       instanceVar_PSCEB_i,
       instanceVar_PSCED_i,
       instanceVar_RSB_i,
       instanceVar_RSG_i,
       instanceVar_THESATB_i,
       instanceVar_THESATG_i,
       instanceVar_AX_i,
       instanceVar_ALP_i,
       instanceVar_ALP1_i,
       instanceVar_ALP2_i,
       instanceVar_A1_i,
       instanceVar_A3_i,
       instanceVar_A4_i,
       instanceVar_GCO_i,
       instanceVar_IGINV_i,
       instanceVar_IGOV_i,
       instanceVar_IGOVD_i,
       instanceVar_GC2_i,
       instanceVar_GC3_i,
       instanceVar_CHIB_i,
       instanceVar_AGIDL_i,
       instanceVar_AGIDLD_i,
       instanceVar_CGIDL_i,
       instanceVar_CGIDLD_i,
       instanceVar_COX_i,
       instanceVar_CGOV_i,
       instanceVar_CGOVD_i,
       instanceVar_CGBOV_i,
       instanceVar_CFR_i,
       instanceVar_CFRD_i,
       instanceVar_FNTEXC_i,
       instanceVar_NFA_i,
       instanceVar_NFB_i,
       instanceVar_NFC_i,
       instanceVar_EF_i,
       instanceVar_BETNEDGE_i,
       instanceVar_PSCEEDGE_i,
       instanceVar_PSCEBEDGE_i,
       instanceVar_PSCEDEDGE_i,
       instanceVar_CFEDGE_i,
       instanceVar_CFDEDGE_i,
       instanceVar_CFBEDGE_i,
       instanceVar_NFAEDGE_i,
       instanceVar_NFBEDGE_i,
       instanceVar_NFCEDGE_i,
       instanceVar_EFEDGE_i,
       instanceVar_RG_i,
       instanceVar_RSE_i,
       instanceVar_RDE_i,
       instanceVar_RBULK_i,
       instanceVar_RJUNS_i,
       instanceVar_RJUND_i,
       instanceVar_RWELL_i,
       instanceVar_ABSOURCE_i,
       instanceVar_LSSOURCE_i,
       instanceVar_LGSOURCE_i,
       instanceVar_zflagbot_s,
       instanceVar_zflagsti_s,
       instanceVar_zflaggat_s,
       instanceVar_VMAX_s,
       instanceVar_exp_VMAX_over_phitd_s,
       instanceVar_vbimin_s,
       instanceVar_vch_s,
       instanceVar_vfmin_s,
       instanceVar_vbbtlim_s,
       instanceVar_xhighf1_s,
       instanceVar_expxhf1_s,
       instanceVar_xhighf2_s,
       instanceVar_expxhf2_s,
       instanceVar_xhighr_s,
       instanceVar_expxhr_s,
       instanceVar_m0flag_s,
       instanceVar_ISATFOR1_s,
       instanceVar_MFOR1_s,
       instanceVar_ISATFOR2_s,
       instanceVar_MFOR2_s,
       instanceVar_ISATREV_s,
       instanceVar_MREV_s,
       instanceVar_ABDRAIN_i,
       instanceVar_LSDRAIN_i,
       instanceVar_LGDRAIN_i,
       instanceVar_zflagbot_d,
       instanceVar_zflagsti_d,
       instanceVar_zflaggat_d,
       instanceVar_VMAX_d,
       instanceVar_exp_VMAX_over_phitd_d,
       instanceVar_vbimin_d,
       instanceVar_vch_d,
       instanceVar_vfmin_d,
       instanceVar_vbbtlim_d,
       instanceVar_xhighf1_d,
       instanceVar_expxhf1_d,
       instanceVar_xhighf2_d,
       instanceVar_expxhf2_d,
       instanceVar_xhighr_d,
       instanceVar_expxhr_d,
       instanceVar_m0flag_d,
       instanceVar_ISATFOR1_d,
       instanceVar_MFOR1_d,
       instanceVar_ISATFOR2_d,
       instanceVar_MFOR2_d,
       instanceVar_ISATREV_d,
       instanceVar_MREV_d,
       instanceVar_VFB_T,
       instanceVar_MUE_T,
       instanceVar_THEMU_T,
       instanceVar_CS_T,
       instanceVar_XCOR_T,
       instanceVar_A2_T,
       instanceVar_VFBEDGE_T,
       instanceVar_phit0,
       instanceVar_BET_i,
       instanceVar_BETEDGE_i,
       instanceVar_nt,
       instanceVar_THESAT_T,
       instanceVar_Sfl_prefac,
       instanceVar_phit0edge,
       instanceVar_Gfedge2,
       instanceVar_lnGfedge2,
       instanceVar_Sfl_prefac_edge,
       instanceVar_ntedge,
       instanceVar_phib_dc,
       instanceVar_G_0_dc,
       instanceVar_kp,
       instanceVar_qlim2,
       instanceVar_sqrt_phib_dc,
       instanceVar_phix_dc,
       instanceVar_aphi_dc,
       instanceVar_bphi_dc,
       instanceVar_phix1_dc,
       instanceVar_alpha_b,
       instanceVar_us1,
       instanceVar_us21,
       instanceVar_phib_ac,
       instanceVar_G_0_ac,
       instanceVar_phix_ac,
       instanceVar_aphi_ac,
       instanceVar_bphi_ac,
       instanceVar_phix1_ac,
       instanceVar_THER_i,
       instanceVar_phibedge,
       instanceVar_Gfedge,
       instanceVar_phixedge,
       instanceVar_aphiedge,
       instanceVar_bphiedge,
       instanceVar_phix1edge,
       instanceVar_Cox_over_q,
       instanceVar_qq,
       instanceVar_E_eff0,
       instanceVar_eta_mu,
       instanceVar_eta_mu1,
       instanceVar_inv_AX,
       instanceVar_inv_VP,
       instanceVar_GOV_s,
       instanceVar_GOV_d,
       instanceVar_GOV2_s,
       instanceVar_GOV2_d,
       instanceVar_SP_OV_eps2_s,
       instanceVar_SP_OV_a_s,
       instanceVar_SP_OV_delta1_s,
       instanceVar_SP_OV_eps2_d,
       instanceVar_SP_OV_a_d,
       instanceVar_SP_OV_delta1_d,
       instanceVar_inv_CHIB,
       instanceVar_BCH,
       instanceVar_BOV,
       instanceVar_BOV_d,
       instanceVar_GCQ,
       instanceVar_AGIDLs,
       instanceVar_AGIDLDs,
       instanceVar_BGIDLs,
       instanceVar_BGIDLDs,
       instanceVar_fac_exc,
       instanceVar_ggate,
       instanceVar_gsource,
       instanceVar_gdrain,
       instanceVar_gbulk,
       instanceVar_gjuns,
       instanceVar_gjund,
       instanceVar_gwell,
       // model parameters
       // reals
       modelPar_TR,
       modelPar_given_TR,
       modelPar_QMC,
       modelPar_given_QMC,
       modelPar_VFB,
       modelPar_given_VFB,
       modelPar_STVFB,
       modelPar_given_STVFB,
       modelPar_TOX,
       modelPar_given_TOX,
       modelPar_EPSROX,
       modelPar_given_EPSROX,
       modelPar_NEFF,
       modelPar_given_NEFF,
       modelPar_FACNEFFAC,
       modelPar_given_FACNEFFAC,
       modelPar_GFACNUD,
       modelPar_given_GFACNUD,
       modelPar_VSBNUD,
       modelPar_given_VSBNUD,
       modelPar_DVSBNUD,
       modelPar_given_DVSBNUD,
       modelPar_VNSUB,
       modelPar_given_VNSUB,
       modelPar_NSLP,
       modelPar_given_NSLP,
       modelPar_DNSUB,
       modelPar_given_DNSUB,
       modelPar_DPHIB,
       modelPar_given_DPHIB,
       modelPar_DELVTAC,
       modelPar_given_DELVTAC,
       modelPar_NP,
       modelPar_given_NP,
       modelPar_CT,
       modelPar_given_CT,
       modelPar_TOXOV,
       modelPar_given_TOXOV,
       modelPar_TOXOVD,
       modelPar_given_TOXOVD,
       modelPar_NOV,
       modelPar_given_NOV,
       modelPar_NOVD,
       modelPar_given_NOVD,
       modelPar_CF,
       modelPar_given_CF,
       modelPar_CFD,
       modelPar_given_CFD,
       modelPar_CFB,
       modelPar_given_CFB,
       modelPar_PSCE,
       modelPar_given_PSCE,
       modelPar_PSCEB,
       modelPar_given_PSCEB,
       modelPar_PSCED,
       modelPar_given_PSCED,
       modelPar_BETN,
       modelPar_given_BETN,
       modelPar_STBET,
       modelPar_given_STBET,
       modelPar_MUE,
       modelPar_given_MUE,
       modelPar_STMUE,
       modelPar_given_STMUE,
       modelPar_THEMU,
       modelPar_given_THEMU,
       modelPar_STTHEMU,
       modelPar_given_STTHEMU,
       modelPar_CS,
       modelPar_given_CS,
       modelPar_STCS,
       modelPar_given_STCS,
       modelPar_XCOR,
       modelPar_given_XCOR,
       modelPar_STXCOR,
       modelPar_given_STXCOR,
       modelPar_FETA,
       modelPar_given_FETA,
       modelPar_RS,
       modelPar_given_RS,
       modelPar_STRS,
       modelPar_given_STRS,
       modelPar_RSB,
       modelPar_given_RSB,
       modelPar_RSG,
       modelPar_given_RSG,
       modelPar_THESAT,
       modelPar_given_THESAT,
       modelPar_STTHESAT,
       modelPar_given_STTHESAT,
       modelPar_THESATB,
       modelPar_given_THESATB,
       modelPar_THESATG,
       modelPar_given_THESATG,
       modelPar_AX,
       modelPar_given_AX,
       modelPar_ALP,
       modelPar_given_ALP,
       modelPar_ALP1,
       modelPar_given_ALP1,
       modelPar_ALP2,
       modelPar_given_ALP2,
       modelPar_VP,
       modelPar_given_VP,
       modelPar_A1,
       modelPar_given_A1,
       modelPar_A2,
       modelPar_given_A2,
       modelPar_STA2,
       modelPar_given_STA2,
       modelPar_A3,
       modelPar_given_A3,
       modelPar_A4,
       modelPar_given_A4,
       modelPar_GCO,
       modelPar_given_GCO,
       modelPar_IGINV,
       modelPar_given_IGINV,
       modelPar_IGOV,
       modelPar_given_IGOV,
       modelPar_IGOVD,
       modelPar_given_IGOVD,
       modelPar_STIG,
       modelPar_given_STIG,
       modelPar_GC2,
       modelPar_given_GC2,
       modelPar_GC3,
       modelPar_given_GC3,
       modelPar_CHIB,
       modelPar_given_CHIB,
       modelPar_AGIDL,
       modelPar_given_AGIDL,
       modelPar_AGIDLD,
       modelPar_given_AGIDLD,
       modelPar_BGIDL,
       modelPar_given_BGIDL,
       modelPar_BGIDLD,
       modelPar_given_BGIDLD,
       modelPar_STBGIDL,
       modelPar_given_STBGIDL,
       modelPar_STBGIDLD,
       modelPar_given_STBGIDLD,
       modelPar_CGIDL,
       modelPar_given_CGIDL,
       modelPar_CGIDLD,
       modelPar_given_CGIDLD,
       modelPar_COX,
       modelPar_given_COX,
       modelPar_CGOV,
       modelPar_given_CGOV,
       modelPar_CGOVD,
       modelPar_given_CGOVD,
       modelPar_CGBOV,
       modelPar_given_CGBOV,
       modelPar_CFR,
       modelPar_given_CFR,
       modelPar_CFRD,
       modelPar_given_CFRD,
       modelPar_FNT,
       modelPar_given_FNT,
       modelPar_FNTEXC,
       modelPar_given_FNTEXC,
       modelPar_NFA,
       modelPar_given_NFA,
       modelPar_NFB,
       modelPar_given_NFB,
       modelPar_NFC,
       modelPar_given_NFC,
       modelPar_EF,
       modelPar_given_EF,
       modelPar_VFBEDGE,
       modelPar_given_VFBEDGE,
       modelPar_STVFBEDGE,
       modelPar_given_STVFBEDGE,
       modelPar_DPHIBEDGE,
       modelPar_given_DPHIBEDGE,
       modelPar_NEFFEDGE,
       modelPar_given_NEFFEDGE,
       modelPar_CTEDGE,
       modelPar_given_CTEDGE,
       modelPar_BETNEDGE,
       modelPar_given_BETNEDGE,
       modelPar_STBETEDGE,
       modelPar_given_STBETEDGE,
       modelPar_PSCEEDGE,
       modelPar_given_PSCEEDGE,
       modelPar_PSCEBEDGE,
       modelPar_given_PSCEBEDGE,
       modelPar_PSCEDEDGE,
       modelPar_given_PSCEDEDGE,
       modelPar_CFEDGE,
       modelPar_given_CFEDGE,
       modelPar_CFDEDGE,
       modelPar_given_CFDEDGE,
       modelPar_CFBEDGE,
       modelPar_given_CFBEDGE,
       modelPar_FNTEDGE,
       modelPar_given_FNTEDGE,
       modelPar_NFAEDGE,
       modelPar_given_NFAEDGE,
       modelPar_NFBEDGE,
       modelPar_given_NFBEDGE,
       modelPar_NFCEDGE,
       modelPar_given_NFCEDGE,
       modelPar_EFEDGE,
       modelPar_given_EFEDGE,
       modelPar_RG,
       modelPar_given_RG,
       modelPar_RSE,
       modelPar_given_RSE,
       modelPar_RDE,
       modelPar_given_RDE,
       modelPar_RBULK,
       modelPar_given_RBULK,
       modelPar_RWELL,
       modelPar_given_RWELL,
       modelPar_RJUNS,
       modelPar_given_RJUNS,
       modelPar_RJUND,
       modelPar_given_RJUND,
       modelPar_POVFB,
       modelPar_given_POVFB,
       modelPar_PLVFB,
       modelPar_given_PLVFB,
       modelPar_PWVFB,
       modelPar_given_PWVFB,
       modelPar_PLWVFB,
       modelPar_given_PLWVFB,
       modelPar_POSTVFB,
       modelPar_given_POSTVFB,
       modelPar_PLSTVFB,
       modelPar_given_PLSTVFB,
       modelPar_PWSTVFB,
       modelPar_given_PWSTVFB,
       modelPar_PLWSTVFB,
       modelPar_given_PLWSTVFB,
       modelPar_POTOX,
       modelPar_given_POTOX,
       modelPar_POEPSROX,
       modelPar_given_POEPSROX,
       modelPar_PONEFF,
       modelPar_given_PONEFF,
       modelPar_PLNEFF,
       modelPar_given_PLNEFF,
       modelPar_PWNEFF,
       modelPar_given_PWNEFF,
       modelPar_PLWNEFF,
       modelPar_given_PLWNEFF,
       modelPar_POFACNEFFAC,
       modelPar_given_POFACNEFFAC,
       modelPar_PLFACNEFFAC,
       modelPar_given_PLFACNEFFAC,
       modelPar_PWFACNEFFAC,
       modelPar_given_PWFACNEFFAC,
       modelPar_PLWFACNEFFAC,
       modelPar_given_PLWFACNEFFAC,
       modelPar_POGFACNUD,
       modelPar_given_POGFACNUD,
       modelPar_PLGFACNUD,
       modelPar_given_PLGFACNUD,
       modelPar_PWGFACNUD,
       modelPar_given_PWGFACNUD,
       modelPar_PLWGFACNUD,
       modelPar_given_PLWGFACNUD,
       modelPar_POVSBNUD,
       modelPar_given_POVSBNUD,
       modelPar_PODVSBNUD,
       modelPar_given_PODVSBNUD,
       modelPar_POVNSUB,
       modelPar_given_POVNSUB,
       modelPar_PONSLP,
       modelPar_given_PONSLP,
       modelPar_PODNSUB,
       modelPar_given_PODNSUB,
       modelPar_PODPHIB,
       modelPar_given_PODPHIB,
       modelPar_PLDPHIB,
       modelPar_given_PLDPHIB,
       modelPar_PWDPHIB,
       modelPar_given_PWDPHIB,
       modelPar_PLWDPHIB,
       modelPar_given_PLWDPHIB,
       modelPar_PODELVTAC,
       modelPar_given_PODELVTAC,
       modelPar_PLDELVTAC,
       modelPar_given_PLDELVTAC,
       modelPar_PWDELVTAC,
       modelPar_given_PWDELVTAC,
       modelPar_PLWDELVTAC,
       modelPar_given_PLWDELVTAC,
       modelPar_PONP,
       modelPar_given_PONP,
       modelPar_PLNP,
       modelPar_given_PLNP,
       modelPar_PWNP,
       modelPar_given_PWNP,
       modelPar_PLWNP,
       modelPar_given_PLWNP,
       modelPar_POCT,
       modelPar_given_POCT,
       modelPar_PLCT,
       modelPar_given_PLCT,
       modelPar_PWCT,
       modelPar_given_PWCT,
       modelPar_PLWCT,
       modelPar_given_PLWCT,
       modelPar_POTOXOV,
       modelPar_given_POTOXOV,
       modelPar_POTOXOVD,
       modelPar_given_POTOXOVD,
       modelPar_PONOV,
       modelPar_given_PONOV,
       modelPar_PLNOV,
       modelPar_given_PLNOV,
       modelPar_PWNOV,
       modelPar_given_PWNOV,
       modelPar_PLWNOV,
       modelPar_given_PLWNOV,
       modelPar_PONOVD,
       modelPar_given_PONOVD,
       modelPar_PLNOVD,
       modelPar_given_PLNOVD,
       modelPar_PWNOVD,
       modelPar_given_PWNOVD,
       modelPar_PLWNOVD,
       modelPar_given_PLWNOVD,
       modelPar_POCF,
       modelPar_given_POCF,
       modelPar_PLCF,
       modelPar_given_PLCF,
       modelPar_PWCF,
       modelPar_given_PWCF,
       modelPar_PLWCF,
       modelPar_given_PLWCF,
       modelPar_POCFD,
       modelPar_given_POCFD,
       modelPar_POCFB,
       modelPar_given_POCFB,
       modelPar_POPSCE,
       modelPar_given_POPSCE,
       modelPar_PLPSCE,
       modelPar_given_PLPSCE,
       modelPar_PWPSCE,
       modelPar_given_PWPSCE,
       modelPar_PLWPSCE,
       modelPar_given_PLWPSCE,
       modelPar_POPSCEB,
       modelPar_given_POPSCEB,
       modelPar_POPSCED,
       modelPar_given_POPSCED,
       modelPar_POBETN,
       modelPar_given_POBETN,
       modelPar_PLBETN,
       modelPar_given_PLBETN,
       modelPar_PWBETN,
       modelPar_given_PWBETN,
       modelPar_PLWBETN,
       modelPar_given_PLWBETN,
       modelPar_POSTBET,
       modelPar_given_POSTBET,
       modelPar_PLSTBET,
       modelPar_given_PLSTBET,
       modelPar_PWSTBET,
       modelPar_given_PWSTBET,
       modelPar_PLWSTBET,
       modelPar_given_PLWSTBET,
       modelPar_POMUE,
       modelPar_given_POMUE,
       modelPar_PLMUE,
       modelPar_given_PLMUE,
       modelPar_PWMUE,
       modelPar_given_PWMUE,
       modelPar_PLWMUE,
       modelPar_given_PLWMUE,
       modelPar_POSTMUE,
       modelPar_given_POSTMUE,
       modelPar_POTHEMU,
       modelPar_given_POTHEMU,
       modelPar_POSTTHEMU,
       modelPar_given_POSTTHEMU,
       modelPar_POCS,
       modelPar_given_POCS,
       modelPar_PLCS,
       modelPar_given_PLCS,
       modelPar_PWCS,
       modelPar_given_PWCS,
       modelPar_PLWCS,
       modelPar_given_PLWCS,
       modelPar_POSTCS,
       modelPar_given_POSTCS,
       modelPar_POXCOR,
       modelPar_given_POXCOR,
       modelPar_PLXCOR,
       modelPar_given_PLXCOR,
       modelPar_PWXCOR,
       modelPar_given_PWXCOR,
       modelPar_PLWXCOR,
       modelPar_given_PLWXCOR,
       modelPar_POSTXCOR,
       modelPar_given_POSTXCOR,
       modelPar_POFETA,
       modelPar_given_POFETA,
       modelPar_PORS,
       modelPar_given_PORS,
       modelPar_PLRS,
       modelPar_given_PLRS,
       modelPar_PWRS,
       modelPar_given_PWRS,
       modelPar_PLWRS,
       modelPar_given_PLWRS,
       modelPar_POSTRS,
       modelPar_given_POSTRS,
       modelPar_PORSB,
       modelPar_given_PORSB,
       modelPar_PORSG,
       modelPar_given_PORSG,
       modelPar_POTHESAT,
       modelPar_given_POTHESAT,
       modelPar_PLTHESAT,
       modelPar_given_PLTHESAT,
       modelPar_PWTHESAT,
       modelPar_given_PWTHESAT,
       modelPar_PLWTHESAT,
       modelPar_given_PLWTHESAT,
       modelPar_POSTTHESAT,
       modelPar_given_POSTTHESAT,
       modelPar_PLSTTHESAT,
       modelPar_given_PLSTTHESAT,
       modelPar_PWSTTHESAT,
       modelPar_given_PWSTTHESAT,
       modelPar_PLWSTTHESAT,
       modelPar_given_PLWSTTHESAT,
       modelPar_POTHESATB,
       modelPar_given_POTHESATB,
       modelPar_PLTHESATB,
       modelPar_given_PLTHESATB,
       modelPar_PWTHESATB,
       modelPar_given_PWTHESATB,
       modelPar_PLWTHESATB,
       modelPar_given_PLWTHESATB,
       modelPar_POTHESATG,
       modelPar_given_POTHESATG,
       modelPar_PLTHESATG,
       modelPar_given_PLTHESATG,
       modelPar_PWTHESATG,
       modelPar_given_PWTHESATG,
       modelPar_PLWTHESATG,
       modelPar_given_PLWTHESATG,
       modelPar_POAX,
       modelPar_given_POAX,
       modelPar_PLAX,
       modelPar_given_PLAX,
       modelPar_PWAX,
       modelPar_given_PWAX,
       modelPar_PLWAX,
       modelPar_given_PLWAX,
       modelPar_POALP,
       modelPar_given_POALP,
       modelPar_PLALP,
       modelPar_given_PLALP,
       modelPar_PWALP,
       modelPar_given_PWALP,
       modelPar_PLWALP,
       modelPar_given_PLWALP,
       modelPar_POALP1,
       modelPar_given_POALP1,
       modelPar_PLALP1,
       modelPar_given_PLALP1,
       modelPar_PWALP1,
       modelPar_given_PWALP1,
       modelPar_PLWALP1,
       modelPar_given_PLWALP1,
       modelPar_POALP2,
       modelPar_given_POALP2,
       modelPar_PLALP2,
       modelPar_given_PLALP2,
       modelPar_PWALP2,
       modelPar_given_PWALP2,
       modelPar_PLWALP2,
       modelPar_given_PLWALP2,
       modelPar_POVP,
       modelPar_given_POVP,
       modelPar_POA1,
       modelPar_given_POA1,
       modelPar_PLA1,
       modelPar_given_PLA1,
       modelPar_PWA1,
       modelPar_given_PWA1,
       modelPar_PLWA1,
       modelPar_given_PLWA1,
       modelPar_POA2,
       modelPar_given_POA2,
       modelPar_POSTA2,
       modelPar_given_POSTA2,
       modelPar_POA3,
       modelPar_given_POA3,
       modelPar_PLA3,
       modelPar_given_PLA3,
       modelPar_PWA3,
       modelPar_given_PWA3,
       modelPar_PLWA3,
       modelPar_given_PLWA3,
       modelPar_POA4,
       modelPar_given_POA4,
       modelPar_PLA4,
       modelPar_given_PLA4,
       modelPar_PWA4,
       modelPar_given_PWA4,
       modelPar_PLWA4,
       modelPar_given_PLWA4,
       modelPar_POGCO,
       modelPar_given_POGCO,
       modelPar_POIGINV,
       modelPar_given_POIGINV,
       modelPar_PLIGINV,
       modelPar_given_PLIGINV,
       modelPar_PWIGINV,
       modelPar_given_PWIGINV,
       modelPar_PLWIGINV,
       modelPar_given_PLWIGINV,
       modelPar_POIGOV,
       modelPar_given_POIGOV,
       modelPar_PLIGOV,
       modelPar_given_PLIGOV,
       modelPar_PWIGOV,
       modelPar_given_PWIGOV,
       modelPar_PLWIGOV,
       modelPar_given_PLWIGOV,
       modelPar_POIGOVD,
       modelPar_given_POIGOVD,
       modelPar_PLIGOVD,
       modelPar_given_PLIGOVD,
       modelPar_PWIGOVD,
       modelPar_given_PWIGOVD,
       modelPar_PLWIGOVD,
       modelPar_given_PLWIGOVD,
       modelPar_POSTIG,
       modelPar_given_POSTIG,
       modelPar_POGC2,
       modelPar_given_POGC2,
       modelPar_POGC3,
       modelPar_given_POGC3,
       modelPar_POCHIB,
       modelPar_given_POCHIB,
       modelPar_POAGIDL,
       modelPar_given_POAGIDL,
       modelPar_PLAGIDL,
       modelPar_given_PLAGIDL,
       modelPar_PWAGIDL,
       modelPar_given_PWAGIDL,
       modelPar_PLWAGIDL,
       modelPar_given_PLWAGIDL,
       modelPar_POAGIDLD,
       modelPar_given_POAGIDLD,
       modelPar_PLAGIDLD,
       modelPar_given_PLAGIDLD,
       modelPar_PWAGIDLD,
       modelPar_given_PWAGIDLD,
       modelPar_PLWAGIDLD,
       modelPar_given_PLWAGIDLD,
       modelPar_POBGIDL,
       modelPar_given_POBGIDL,
       modelPar_POBGIDLD,
       modelPar_given_POBGIDLD,
       modelPar_POSTBGIDL,
       modelPar_given_POSTBGIDL,
       modelPar_POSTBGIDLD,
       modelPar_given_POSTBGIDLD,
       modelPar_POCGIDL,
       modelPar_given_POCGIDL,
       modelPar_POCGIDLD,
       modelPar_given_POCGIDLD,
       modelPar_POCOX,
       modelPar_given_POCOX,
       modelPar_PLCOX,
       modelPar_given_PLCOX,
       modelPar_PWCOX,
       modelPar_given_PWCOX,
       modelPar_PLWCOX,
       modelPar_given_PLWCOX,
       modelPar_POCGOV,
       modelPar_given_POCGOV,
       modelPar_PLCGOV,
       modelPar_given_PLCGOV,
       modelPar_PWCGOV,
       modelPar_given_PWCGOV,
       modelPar_PLWCGOV,
       modelPar_given_PLWCGOV,
       modelPar_POCGOVD,
       modelPar_given_POCGOVD,
       modelPar_PLCGOVD,
       modelPar_given_PLCGOVD,
       modelPar_PWCGOVD,
       modelPar_given_PWCGOVD,
       modelPar_PLWCGOVD,
       modelPar_given_PLWCGOVD,
       modelPar_POCGBOV,
       modelPar_given_POCGBOV,
       modelPar_PLCGBOV,
       modelPar_given_PLCGBOV,
       modelPar_PWCGBOV,
       modelPar_given_PWCGBOV,
       modelPar_PLWCGBOV,
       modelPar_given_PLWCGBOV,
       modelPar_POCFR,
       modelPar_given_POCFR,
       modelPar_PLCFR,
       modelPar_given_PLCFR,
       modelPar_PWCFR,
       modelPar_given_PWCFR,
       modelPar_PLWCFR,
       modelPar_given_PLWCFR,
       modelPar_POCFRD,
       modelPar_given_POCFRD,
       modelPar_PLCFRD,
       modelPar_given_PLCFRD,
       modelPar_PWCFRD,
       modelPar_given_PWCFRD,
       modelPar_PLWCFRD,
       modelPar_given_PLWCFRD,
       modelPar_POFNT,
       modelPar_given_POFNT,
       modelPar_POFNTEXC,
       modelPar_given_POFNTEXC,
       modelPar_PLFNTEXC,
       modelPar_given_PLFNTEXC,
       modelPar_PWFNTEXC,
       modelPar_given_PWFNTEXC,
       modelPar_PLWFNTEXC,
       modelPar_given_PLWFNTEXC,
       modelPar_PONFA,
       modelPar_given_PONFA,
       modelPar_PLNFA,
       modelPar_given_PLNFA,
       modelPar_PWNFA,
       modelPar_given_PWNFA,
       modelPar_PLWNFA,
       modelPar_given_PLWNFA,
       modelPar_PONFB,
       modelPar_given_PONFB,
       modelPar_PLNFB,
       modelPar_given_PLNFB,
       modelPar_PWNFB,
       modelPar_given_PWNFB,
       modelPar_PLWNFB,
       modelPar_given_PLWNFB,
       modelPar_PONFC,
       modelPar_given_PONFC,
       modelPar_PLNFC,
       modelPar_given_PLNFC,
       modelPar_PWNFC,
       modelPar_given_PWNFC,
       modelPar_PLWNFC,
       modelPar_given_PLWNFC,
       modelPar_POEF,
       modelPar_given_POEF,
       modelPar_POVFBEDGE,
       modelPar_given_POVFBEDGE,
       modelPar_POSTVFBEDGE,
       modelPar_given_POSTVFBEDGE,
       modelPar_PLSTVFBEDGE,
       modelPar_given_PLSTVFBEDGE,
       modelPar_PWSTVFBEDGE,
       modelPar_given_PWSTVFBEDGE,
       modelPar_PLWSTVFBEDGE,
       modelPar_given_PLWSTVFBEDGE,
       modelPar_PODPHIBEDGE,
       modelPar_given_PODPHIBEDGE,
       modelPar_PLDPHIBEDGE,
       modelPar_given_PLDPHIBEDGE,
       modelPar_PWDPHIBEDGE,
       modelPar_given_PWDPHIBEDGE,
       modelPar_PLWDPHIBEDGE,
       modelPar_given_PLWDPHIBEDGE,
       modelPar_PONEFFEDGE,
       modelPar_given_PONEFFEDGE,
       modelPar_PLNEFFEDGE,
       modelPar_given_PLNEFFEDGE,
       modelPar_PWNEFFEDGE,
       modelPar_given_PWNEFFEDGE,
       modelPar_PLWNEFFEDGE,
       modelPar_given_PLWNEFFEDGE,
       modelPar_POCTEDGE,
       modelPar_given_POCTEDGE,
       modelPar_PLCTEDGE,
       modelPar_given_PLCTEDGE,
       modelPar_PWCTEDGE,
       modelPar_given_PWCTEDGE,
       modelPar_PLWCTEDGE,
       modelPar_given_PLWCTEDGE,
       modelPar_POBETNEDGE,
       modelPar_given_POBETNEDGE,
       modelPar_PLBETNEDGE,
       modelPar_given_PLBETNEDGE,
       modelPar_PWBETNEDGE,
       modelPar_given_PWBETNEDGE,
       modelPar_PLWBETNEDGE,
       modelPar_given_PLWBETNEDGE,
       modelPar_POSTBETEDGE,
       modelPar_given_POSTBETEDGE,
       modelPar_PLSTBETEDGE,
       modelPar_given_PLSTBETEDGE,
       modelPar_PWSTBETEDGE,
       modelPar_given_PWSTBETEDGE,
       modelPar_PLWSTBETEDGE,
       modelPar_given_PLWSTBETEDGE,
       modelPar_POPSCEEDGE,
       modelPar_given_POPSCEEDGE,
       modelPar_PLPSCEEDGE,
       modelPar_given_PLPSCEEDGE,
       modelPar_PWPSCEEDGE,
       modelPar_given_PWPSCEEDGE,
       modelPar_PLWPSCEEDGE,
       modelPar_given_PLWPSCEEDGE,
       modelPar_POPSCEBEDGE,
       modelPar_given_POPSCEBEDGE,
       modelPar_POPSCEDEDGE,
       modelPar_given_POPSCEDEDGE,
       modelPar_POCFEDGE,
       modelPar_given_POCFEDGE,
       modelPar_PLCFEDGE,
       modelPar_given_PLCFEDGE,
       modelPar_PWCFEDGE,
       modelPar_given_PWCFEDGE,
       modelPar_PLWCFEDGE,
       modelPar_given_PLWCFEDGE,
       modelPar_POCFDEDGE,
       modelPar_given_POCFDEDGE,
       modelPar_POCFBEDGE,
       modelPar_given_POCFBEDGE,
       modelPar_POFNTEDGE,
       modelPar_given_POFNTEDGE,
       modelPar_PONFAEDGE,
       modelPar_given_PONFAEDGE,
       modelPar_PLNFAEDGE,
       modelPar_given_PLNFAEDGE,
       modelPar_PWNFAEDGE,
       modelPar_given_PWNFAEDGE,
       modelPar_PLWNFAEDGE,
       modelPar_given_PLWNFAEDGE,
       modelPar_PONFBEDGE,
       modelPar_given_PONFBEDGE,
       modelPar_PLNFBEDGE,
       modelPar_given_PLNFBEDGE,
       modelPar_PWNFBEDGE,
       modelPar_given_PWNFBEDGE,
       modelPar_PLWNFBEDGE,
       modelPar_given_PLWNFBEDGE,
       modelPar_PONFCEDGE,
       modelPar_given_PONFCEDGE,
       modelPar_PLNFCEDGE,
       modelPar_given_PLNFCEDGE,
       modelPar_PWNFCEDGE,
       modelPar_given_PWNFCEDGE,
       modelPar_PLWNFCEDGE,
       modelPar_given_PLWNFCEDGE,
       modelPar_POEFEDGE,
       modelPar_given_POEFEDGE,
       modelPar_POKVTHOWE,
       modelPar_given_POKVTHOWE,
       modelPar_PLKVTHOWE,
       modelPar_given_PLKVTHOWE,
       modelPar_PWKVTHOWE,
       modelPar_given_PWKVTHOWE,
       modelPar_PLWKVTHOWE,
       modelPar_given_PLWKVTHOWE,
       modelPar_POKUOWE,
       modelPar_given_POKUOWE,
       modelPar_PLKUOWE,
       modelPar_given_PLKUOWE,
       modelPar_PWKUOWE,
       modelPar_given_PWKUOWE,
       modelPar_PLWKUOWE,
       modelPar_given_PLWKUOWE,
       modelPar_LMIN,
       modelPar_given_LMIN,
       modelPar_LMAX,
       modelPar_given_LMAX,
       modelPar_WMIN,
       modelPar_given_WMIN,
       modelPar_WMAX,
       modelPar_given_WMAX,
       modelPar_LVARO,
       modelPar_given_LVARO,
       modelPar_LVARL,
       modelPar_given_LVARL,
       modelPar_LVARW,
       modelPar_given_LVARW,
       modelPar_LAP,
       modelPar_given_LAP,
       modelPar_WVARO,
       modelPar_given_WVARO,
       modelPar_WVARL,
       modelPar_given_WVARL,
       modelPar_WVARW,
       modelPar_given_WVARW,
       modelPar_WOT,
       modelPar_given_WOT,
       modelPar_DLQ,
       modelPar_given_DLQ,
       modelPar_DWQ,
       modelPar_given_DWQ,
       modelPar_VFBO,
       modelPar_given_VFBO,
       modelPar_VFBL,
       modelPar_given_VFBL,
       modelPar_VFBW,
       modelPar_given_VFBW,
       modelPar_VFBLW,
       modelPar_given_VFBLW,
       modelPar_STVFBO,
       modelPar_given_STVFBO,
       modelPar_STVFBL,
       modelPar_given_STVFBL,
       modelPar_STVFBW,
       modelPar_given_STVFBW,
       modelPar_STVFBLW,
       modelPar_given_STVFBLW,
       modelPar_TOXO,
       modelPar_given_TOXO,
       modelPar_EPSROXO,
       modelPar_given_EPSROXO,
       modelPar_NSUBO,
       modelPar_given_NSUBO,
       modelPar_NSUBW,
       modelPar_given_NSUBW,
       modelPar_WSEG,
       modelPar_given_WSEG,
       modelPar_NPCK,
       modelPar_given_NPCK,
       modelPar_NPCKW,
       modelPar_given_NPCKW,
       modelPar_WSEGP,
       modelPar_given_WSEGP,
       modelPar_LPCK,
       modelPar_given_LPCK,
       modelPar_LPCKW,
       modelPar_given_LPCKW,
       modelPar_FOL1,
       modelPar_given_FOL1,
       modelPar_FOL2,
       modelPar_given_FOL2,
       modelPar_FACNEFFACO,
       modelPar_given_FACNEFFACO,
       modelPar_FACNEFFACL,
       modelPar_given_FACNEFFACL,
       modelPar_FACNEFFACW,
       modelPar_given_FACNEFFACW,
       modelPar_FACNEFFACLW,
       modelPar_given_FACNEFFACLW,
       modelPar_GFACNUDO,
       modelPar_given_GFACNUDO,
       modelPar_GFACNUDL,
       modelPar_given_GFACNUDL,
       modelPar_GFACNUDLEXP,
       modelPar_given_GFACNUDLEXP,
       modelPar_GFACNUDW,
       modelPar_given_GFACNUDW,
       modelPar_GFACNUDLW,
       modelPar_given_GFACNUDLW,
       modelPar_VSBNUDO,
       modelPar_given_VSBNUDO,
       modelPar_DVSBNUDO,
       modelPar_given_DVSBNUDO,
       modelPar_VNSUBO,
       modelPar_given_VNSUBO,
       modelPar_NSLPO,
       modelPar_given_NSLPO,
       modelPar_DNSUBO,
       modelPar_given_DNSUBO,
       modelPar_DPHIBO,
       modelPar_given_DPHIBO,
       modelPar_DPHIBL,
       modelPar_given_DPHIBL,
       modelPar_DPHIBLEXP,
       modelPar_given_DPHIBLEXP,
       modelPar_DPHIBW,
       modelPar_given_DPHIBW,
       modelPar_DPHIBLW,
       modelPar_given_DPHIBLW,
       modelPar_DELVTACO,
       modelPar_given_DELVTACO,
       modelPar_DELVTACL,
       modelPar_given_DELVTACL,
       modelPar_DELVTACLEXP,
       modelPar_given_DELVTACLEXP,
       modelPar_DELVTACW,
       modelPar_given_DELVTACW,
       modelPar_DELVTACLW,
       modelPar_given_DELVTACLW,
       modelPar_NPO,
       modelPar_given_NPO,
       modelPar_NPL,
       modelPar_given_NPL,
       modelPar_CTO,
       modelPar_given_CTO,
       modelPar_CTL,
       modelPar_given_CTL,
       modelPar_CTLEXP,
       modelPar_given_CTLEXP,
       modelPar_CTW,
       modelPar_given_CTW,
       modelPar_CTLW,
       modelPar_given_CTLW,
       modelPar_TOXOVO,
       modelPar_given_TOXOVO,
       modelPar_TOXOVDO,
       modelPar_given_TOXOVDO,
       modelPar_LOV,
       modelPar_given_LOV,
       modelPar_LOVD,
       modelPar_given_LOVD,
       modelPar_NOVO,
       modelPar_given_NOVO,
       modelPar_NOVDO,
       modelPar_given_NOVDO,
       modelPar_CFL,
       modelPar_given_CFL,
       modelPar_CFLEXP,
       modelPar_given_CFLEXP,
       modelPar_CFW,
       modelPar_given_CFW,
       modelPar_CFDO,
       modelPar_given_CFDO,
       modelPar_CFBO,
       modelPar_given_CFBO,
       modelPar_PSCEL,
       modelPar_given_PSCEL,
       modelPar_PSCELEXP,
       modelPar_given_PSCELEXP,
       modelPar_PSCEW,
       modelPar_given_PSCEW,
       modelPar_PSCEBO,
       modelPar_given_PSCEBO,
       modelPar_PSCEDO,
       modelPar_given_PSCEDO,
       modelPar_UO,
       modelPar_given_UO,
       modelPar_FBET1,
       modelPar_given_FBET1,
       modelPar_FBET1W,
       modelPar_given_FBET1W,
       modelPar_LP1,
       modelPar_given_LP1,
       modelPar_LP1W,
       modelPar_given_LP1W,
       modelPar_FBET2,
       modelPar_given_FBET2,
       modelPar_LP2,
       modelPar_given_LP2,
       modelPar_BETW1,
       modelPar_given_BETW1,
       modelPar_BETW2,
       modelPar_given_BETW2,
       modelPar_WBET,
       modelPar_given_WBET,
       modelPar_STBETO,
       modelPar_given_STBETO,
       modelPar_STBETL,
       modelPar_given_STBETL,
       modelPar_STBETW,
       modelPar_given_STBETW,
       modelPar_STBETLW,
       modelPar_given_STBETLW,
       modelPar_MUEO,
       modelPar_given_MUEO,
       modelPar_MUEW,
       modelPar_given_MUEW,
       modelPar_STMUEO,
       modelPar_given_STMUEO,
       modelPar_THEMUO,
       modelPar_given_THEMUO,
       modelPar_STTHEMUO,
       modelPar_given_STTHEMUO,
       modelPar_CSO,
       modelPar_given_CSO,
       modelPar_CSL,
       modelPar_given_CSL,
       modelPar_CSLEXP,
       modelPar_given_CSLEXP,
       modelPar_CSW,
       modelPar_given_CSW,
       modelPar_CSLW,
       modelPar_given_CSLW,
       modelPar_STCSO,
       modelPar_given_STCSO,
       modelPar_XCORO,
       modelPar_given_XCORO,
       modelPar_XCORL,
       modelPar_given_XCORL,
       modelPar_XCORW,
       modelPar_given_XCORW,
       modelPar_XCORLW,
       modelPar_given_XCORLW,
       modelPar_STXCORO,
       modelPar_given_STXCORO,
       modelPar_FETAO,
       modelPar_given_FETAO,
       modelPar_RSW1,
       modelPar_given_RSW1,
       modelPar_RSW2,
       modelPar_given_RSW2,
       modelPar_STRSO,
       modelPar_given_STRSO,
       modelPar_RSBO,
       modelPar_given_RSBO,
       modelPar_RSGO,
       modelPar_given_RSGO,
       modelPar_THESATO,
       modelPar_given_THESATO,
       modelPar_THESATL,
       modelPar_given_THESATL,
       modelPar_THESATLEXP,
       modelPar_given_THESATLEXP,
       modelPar_THESATW,
       modelPar_given_THESATW,
       modelPar_THESATLW,
       modelPar_given_THESATLW,
       modelPar_STTHESATO,
       modelPar_given_STTHESATO,
       modelPar_STTHESATL,
       modelPar_given_STTHESATL,
       modelPar_STTHESATW,
       modelPar_given_STTHESATW,
       modelPar_STTHESATLW,
       modelPar_given_STTHESATLW,
       modelPar_THESATBO,
       modelPar_given_THESATBO,
       modelPar_THESATGO,
       modelPar_given_THESATGO,
       modelPar_AXO,
       modelPar_given_AXO,
       modelPar_AXL,
       modelPar_given_AXL,
       modelPar_ALPL,
       modelPar_given_ALPL,
       modelPar_ALPLEXP,
       modelPar_given_ALPLEXP,
       modelPar_ALPW,
       modelPar_given_ALPW,
       modelPar_ALP1L1,
       modelPar_given_ALP1L1,
       modelPar_ALP1LEXP,
       modelPar_given_ALP1LEXP,
       modelPar_ALP1L2,
       modelPar_given_ALP1L2,
       modelPar_ALP1W,
       modelPar_given_ALP1W,
       modelPar_ALP2L1,
       modelPar_given_ALP2L1,
       modelPar_ALP2LEXP,
       modelPar_given_ALP2LEXP,
       modelPar_ALP2L2,
       modelPar_given_ALP2L2,
       modelPar_ALP2W,
       modelPar_given_ALP2W,
       modelPar_VPO,
       modelPar_given_VPO,
       modelPar_A1O,
       modelPar_given_A1O,
       modelPar_A1L,
       modelPar_given_A1L,
       modelPar_A1W,
       modelPar_given_A1W,
       modelPar_A2O,
       modelPar_given_A2O,
       modelPar_STA2O,
       modelPar_given_STA2O,
       modelPar_A3O,
       modelPar_given_A3O,
       modelPar_A3L,
       modelPar_given_A3L,
       modelPar_A3W,
       modelPar_given_A3W,
       modelPar_A4O,
       modelPar_given_A4O,
       modelPar_A4L,
       modelPar_given_A4L,
       modelPar_A4W,
       modelPar_given_A4W,
       modelPar_GCOO,
       modelPar_given_GCOO,
       modelPar_IGINVLW,
       modelPar_given_IGINVLW,
       modelPar_IGOVW,
       modelPar_given_IGOVW,
       modelPar_IGOVDW,
       modelPar_given_IGOVDW,
       modelPar_STIGO,
       modelPar_given_STIGO,
       modelPar_GC2O,
       modelPar_given_GC2O,
       modelPar_GC3O,
       modelPar_given_GC3O,
       modelPar_CHIBO,
       modelPar_given_CHIBO,
       modelPar_AGIDLW,
       modelPar_given_AGIDLW,
       modelPar_AGIDLDW,
       modelPar_given_AGIDLDW,
       modelPar_BGIDLO,
       modelPar_given_BGIDLO,
       modelPar_BGIDLDO,
       modelPar_given_BGIDLDO,
       modelPar_STBGIDLO,
       modelPar_given_STBGIDLO,
       modelPar_STBGIDLDO,
       modelPar_given_STBGIDLDO,
       modelPar_CGIDLO,
       modelPar_given_CGIDLO,
       modelPar_CGIDLDO,
       modelPar_given_CGIDLDO,
       modelPar_CGBOVL,
       modelPar_given_CGBOVL,
       modelPar_CFRW,
       modelPar_given_CFRW,
       modelPar_CFRDW,
       modelPar_given_CFRDW,
       modelPar_FNTO,
       modelPar_given_FNTO,
       modelPar_FNTEXCL,
       modelPar_given_FNTEXCL,
       modelPar_NFALW,
       modelPar_given_NFALW,
       modelPar_NFBLW,
       modelPar_given_NFBLW,
       modelPar_NFCLW,
       modelPar_given_NFCLW,
       modelPar_EFO,
       modelPar_given_EFO,
       modelPar_LINTNOI,
       modelPar_given_LINTNOI,
       modelPar_ALPNOI,
       modelPar_given_ALPNOI,
       modelPar_WEDGE,
       modelPar_given_WEDGE,
       modelPar_WEDGEW,
       modelPar_given_WEDGEW,
       modelPar_VFBEDGEO,
       modelPar_given_VFBEDGEO,
       modelPar_STVFBEDGEO,
       modelPar_given_STVFBEDGEO,
       modelPar_STVFBEDGEL,
       modelPar_given_STVFBEDGEL,
       modelPar_STVFBEDGEW,
       modelPar_given_STVFBEDGEW,
       modelPar_STVFBEDGELW,
       modelPar_given_STVFBEDGELW,
       modelPar_DPHIBEDGEO,
       modelPar_given_DPHIBEDGEO,
       modelPar_DPHIBEDGEL,
       modelPar_given_DPHIBEDGEL,
       modelPar_DPHIBEDGELEXP,
       modelPar_given_DPHIBEDGELEXP,
       modelPar_DPHIBEDGEW,
       modelPar_given_DPHIBEDGEW,
       modelPar_DPHIBEDGELW,
       modelPar_given_DPHIBEDGELW,
       modelPar_NSUBEDGEO,
       modelPar_given_NSUBEDGEO,
       modelPar_NSUBEDGEL,
       modelPar_given_NSUBEDGEL,
       modelPar_NSUBEDGEW,
       modelPar_given_NSUBEDGEW,
       modelPar_NSUBEDGELW,
       modelPar_given_NSUBEDGELW,
       modelPar_CTEDGEO,
       modelPar_given_CTEDGEO,
       modelPar_CTEDGEL,
       modelPar_given_CTEDGEL,
       modelPar_CTEDGELEXP,
       modelPar_given_CTEDGELEXP,
       modelPar_FBETEDGE,
       modelPar_given_FBETEDGE,
       modelPar_LPEDGE,
       modelPar_given_LPEDGE,
       modelPar_BETEDGEW,
       modelPar_given_BETEDGEW,
       modelPar_STBETEDGEO,
       modelPar_given_STBETEDGEO,
       modelPar_STBETEDGEL,
       modelPar_given_STBETEDGEL,
       modelPar_STBETEDGEW,
       modelPar_given_STBETEDGEW,
       modelPar_STBETEDGELW,
       modelPar_given_STBETEDGELW,
       modelPar_PSCEEDGEL,
       modelPar_given_PSCEEDGEL,
       modelPar_PSCEEDGELEXP,
       modelPar_given_PSCEEDGELEXP,
       modelPar_PSCEEDGEW,
       modelPar_given_PSCEEDGEW,
       modelPar_PSCEBEDGEO,
       modelPar_given_PSCEBEDGEO,
       modelPar_PSCEDEDGEO,
       modelPar_given_PSCEDEDGEO,
       modelPar_CFEDGEL,
       modelPar_given_CFEDGEL,
       modelPar_CFEDGELEXP,
       modelPar_given_CFEDGELEXP,
       modelPar_CFEDGEW,
       modelPar_given_CFEDGEW,
       modelPar_CFDEDGEO,
       modelPar_given_CFDEDGEO,
       modelPar_CFBEDGEO,
       modelPar_given_CFBEDGEO,
       modelPar_FNTEDGEO,
       modelPar_given_FNTEDGEO,
       modelPar_NFAEDGELW,
       modelPar_given_NFAEDGELW,
       modelPar_NFBEDGELW,
       modelPar_given_NFBEDGELW,
       modelPar_NFCEDGELW,
       modelPar_given_NFCEDGELW,
       modelPar_EFEDGEO,
       modelPar_given_EFEDGEO,
       modelPar_KVTHOWEO,
       modelPar_given_KVTHOWEO,
       modelPar_KVTHOWEL,
       modelPar_given_KVTHOWEL,
       modelPar_KVTHOWEW,
       modelPar_given_KVTHOWEW,
       modelPar_KVTHOWELW,
       modelPar_given_KVTHOWELW,
       modelPar_KUOWEO,
       modelPar_given_KUOWEO,
       modelPar_KUOWEL,
       modelPar_given_KUOWEL,
       modelPar_KUOWEW,
       modelPar_given_KUOWEW,
       modelPar_KUOWELW,
       modelPar_given_KUOWELW,
       modelPar_RGO,
       modelPar_given_RGO,
       modelPar_RINT,
       modelPar_given_RINT,
       modelPar_RVPOLY,
       modelPar_given_RVPOLY,
       modelPar_RSHG,
       modelPar_given_RSHG,
       modelPar_DLSIL,
       modelPar_given_DLSIL,
       modelPar_RSH,
       modelPar_given_RSH,
       modelPar_RSHD,
       modelPar_given_RSHD,
       modelPar_RBULKO,
       modelPar_given_RBULKO,
       modelPar_RWELLO,
       modelPar_given_RWELLO,
       modelPar_RJUNSO,
       modelPar_given_RJUNSO,
       modelPar_RJUNDO,
       modelPar_given_RJUNDO,
       modelPar_SAREF,
       modelPar_given_SAREF,
       modelPar_SBREF,
       modelPar_given_SBREF,
       modelPar_WLOD,
       modelPar_given_WLOD,
       modelPar_KUO,
       modelPar_given_KUO,
       modelPar_KVSAT,
       modelPar_given_KVSAT,
       modelPar_TKUO,
       modelPar_given_TKUO,
       modelPar_LKUO,
       modelPar_given_LKUO,
       modelPar_WKUO,
       modelPar_given_WKUO,
       modelPar_PKUO,
       modelPar_given_PKUO,
       modelPar_LLODKUO,
       modelPar_given_LLODKUO,
       modelPar_WLODKUO,
       modelPar_given_WLODKUO,
       modelPar_KVTHO,
       modelPar_given_KVTHO,
       modelPar_LKVTHO,
       modelPar_given_LKVTHO,
       modelPar_WKVTHO,
       modelPar_given_WKVTHO,
       modelPar_PKVTHO,
       modelPar_given_PKVTHO,
       modelPar_LLODVTH,
       modelPar_given_LLODVTH,
       modelPar_WLODVTH,
       modelPar_given_WLODVTH,
       modelPar_STETAO,
       modelPar_given_STETAO,
       modelPar_LODETAO,
       modelPar_given_LODETAO,
       modelPar_SCREF,
       modelPar_given_SCREF,
       modelPar_WEB,
       modelPar_given_WEB,
       modelPar_WEC,
       modelPar_given_WEC,
       modelPar_IMAX,
       modelPar_given_IMAX,
       modelPar_TRJ,
       modelPar_given_TRJ,
       modelPar_FREV,
       modelPar_given_FREV,
       modelPar_CJORBOT,
       modelPar_given_CJORBOT,
       modelPar_CJORSTI,
       modelPar_given_CJORSTI,
       modelPar_CJORGAT,
       modelPar_given_CJORGAT,
       modelPar_VBIRBOT,
       modelPar_given_VBIRBOT,
       modelPar_VBIRSTI,
       modelPar_given_VBIRSTI,
       modelPar_VBIRGAT,
       modelPar_given_VBIRGAT,
       modelPar_PBOT,
       modelPar_given_PBOT,
       modelPar_PSTI,
       modelPar_given_PSTI,
       modelPar_PGAT,
       modelPar_given_PGAT,
       modelPar_PHIGBOT,
       modelPar_given_PHIGBOT,
       modelPar_PHIGSTI,
       modelPar_given_PHIGSTI,
       modelPar_PHIGGAT,
       modelPar_given_PHIGGAT,
       modelPar_IDSATRBOT,
       modelPar_given_IDSATRBOT,
       modelPar_IDSATRSTI,
       modelPar_given_IDSATRSTI,
       modelPar_IDSATRGAT,
       modelPar_given_IDSATRGAT,
       modelPar_CSRHBOT,
       modelPar_given_CSRHBOT,
       modelPar_CSRHSTI,
       modelPar_given_CSRHSTI,
       modelPar_CSRHGAT,
       modelPar_given_CSRHGAT,
       modelPar_XJUNSTI,
       modelPar_given_XJUNSTI,
       modelPar_XJUNGAT,
       modelPar_given_XJUNGAT,
       modelPar_CTATBOT,
       modelPar_given_CTATBOT,
       modelPar_CTATSTI,
       modelPar_given_CTATSTI,
       modelPar_CTATGAT,
       modelPar_given_CTATGAT,
       modelPar_MEFFTATBOT,
       modelPar_given_MEFFTATBOT,
       modelPar_MEFFTATSTI,
       modelPar_given_MEFFTATSTI,
       modelPar_MEFFTATGAT,
       modelPar_given_MEFFTATGAT,
       modelPar_CBBTBOT,
       modelPar_given_CBBTBOT,
       modelPar_CBBTSTI,
       modelPar_given_CBBTSTI,
       modelPar_CBBTGAT,
       modelPar_given_CBBTGAT,
       modelPar_FBBTRBOT,
       modelPar_given_FBBTRBOT,
       modelPar_FBBTRSTI,
       modelPar_given_FBBTRSTI,
       modelPar_FBBTRGAT,
       modelPar_given_FBBTRGAT,
       modelPar_STFBBTBOT,
       modelPar_given_STFBBTBOT,
       modelPar_STFBBTSTI,
       modelPar_given_STFBBTSTI,
       modelPar_STFBBTGAT,
       modelPar_given_STFBBTGAT,
       modelPar_VBRBOT,
       modelPar_given_VBRBOT,
       modelPar_VBRSTI,
       modelPar_given_VBRSTI,
       modelPar_VBRGAT,
       modelPar_given_VBRGAT,
       modelPar_PBRBOT,
       modelPar_given_PBRBOT,
       modelPar_PBRSTI,
       modelPar_given_PBRSTI,
       modelPar_PBRGAT,
       modelPar_given_PBRGAT,
       modelPar_CJORBOTD,
       modelPar_given_CJORBOTD,
       modelPar_CJORSTID,
       modelPar_given_CJORSTID,
       modelPar_CJORGATD,
       modelPar_given_CJORGATD,
       modelPar_VBIRBOTD,
       modelPar_given_VBIRBOTD,
       modelPar_VBIRSTID,
       modelPar_given_VBIRSTID,
       modelPar_VBIRGATD,
       modelPar_given_VBIRGATD,
       modelPar_PBOTD,
       modelPar_given_PBOTD,
       modelPar_PSTID,
       modelPar_given_PSTID,
       modelPar_PGATD,
       modelPar_given_PGATD,
       modelPar_PHIGBOTD,
       modelPar_given_PHIGBOTD,
       modelPar_PHIGSTID,
       modelPar_given_PHIGSTID,
       modelPar_PHIGGATD,
       modelPar_given_PHIGGATD,
       modelPar_IDSATRBOTD,
       modelPar_given_IDSATRBOTD,
       modelPar_IDSATRSTID,
       modelPar_given_IDSATRSTID,
       modelPar_IDSATRGATD,
       modelPar_given_IDSATRGATD,
       modelPar_CSRHBOTD,
       modelPar_given_CSRHBOTD,
       modelPar_CSRHSTID,
       modelPar_given_CSRHSTID,
       modelPar_CSRHGATD,
       modelPar_given_CSRHGATD,
       modelPar_XJUNSTID,
       modelPar_given_XJUNSTID,
       modelPar_XJUNGATD,
       modelPar_given_XJUNGATD,
       modelPar_CTATBOTD,
       modelPar_given_CTATBOTD,
       modelPar_CTATSTID,
       modelPar_given_CTATSTID,
       modelPar_CTATGATD,
       modelPar_given_CTATGATD,
       modelPar_MEFFTATBOTD,
       modelPar_given_MEFFTATBOTD,
       modelPar_MEFFTATSTID,
       modelPar_given_MEFFTATSTID,
       modelPar_MEFFTATGATD,
       modelPar_given_MEFFTATGATD,
       modelPar_CBBTBOTD,
       modelPar_given_CBBTBOTD,
       modelPar_CBBTSTID,
       modelPar_given_CBBTSTID,
       modelPar_CBBTGATD,
       modelPar_given_CBBTGATD,
       modelPar_FBBTRBOTD,
       modelPar_given_FBBTRBOTD,
       modelPar_FBBTRSTID,
       modelPar_given_FBBTRSTID,
       modelPar_FBBTRGATD,
       modelPar_given_FBBTRGATD,
       modelPar_STFBBTBOTD,
       modelPar_given_STFBBTBOTD,
       modelPar_STFBBTSTID,
       modelPar_given_STFBBTSTID,
       modelPar_STFBBTGATD,
       modelPar_given_STFBBTGATD,
       modelPar_VBRBOTD,
       modelPar_given_VBRBOTD,
       modelPar_VBRSTID,
       modelPar_given_VBRSTID,
       modelPar_VBRGATD,
       modelPar_given_VBRGATD,
       modelPar_PBRBOTD,
       modelPar_given_PBRBOTD,
       modelPar_PBRSTID,
       modelPar_given_PBRSTID,
       modelPar_PBRGATD,
       modelPar_given_PBRGATD,
       modelPar_SWJUNEXP,
       modelPar_given_SWJUNEXP,
       modelPar_VJUNREF,
       modelPar_given_VJUNREF,
       modelPar_FJUNQ,
       modelPar_given_FJUNQ,
       modelPar_VJUNREFD,
       modelPar_given_VJUNREFD,
       modelPar_FJUNQD,
       modelPar_given_FJUNQD,
       modelPar_DTA,
       modelPar_given_DTA,
       // non-reals (including hidden)
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_TYPE,
       modelPar_given_TYPE,
       modelPar_SWGEO,
       modelPar_given_SWGEO,
       modelPar_SWIGATE,
       modelPar_given_SWIGATE,
       modelPar_SWIMPACT,
       modelPar_given_SWIMPACT,
       modelPar_SWGIDL,
       modelPar_given_SWGIDL,
       modelPar_SWJUNCAP,
       modelPar_given_SWJUNCAP,
       modelPar_SWJUNASYM,
       modelPar_given_SWJUNASYM,
       modelPar_SWNUD,
       modelPar_given_SWNUD,
       modelPar_SWEDGE,
       modelPar_given_SWEDGE,
       modelPar_SWDELVTAC,
       modelPar_given_SWDELVTAC,
       modelPar_SWIGN,
       modelPar_given_SWIGN// model variables
       ,
       // reals
       modelVar_TOXO_i,
       modelVar_EPSROXO_i,
       modelVar_NSUBO_i,
       modelVar_WSEG_i,
       modelVar_NPCK_i,
       modelVar_WSEGP_i,
       modelVar_LPCK_i,
       modelVar_TOXOVO_i,
       modelVar_TOXOVDO_i,
       modelVar_LOV_i,
       modelVar_LOVD_i,
       modelVar_LP1_i,
       modelVar_LP2_i,
       modelVar_WBET_i,
       modelVar_AXL_i,
       modelVar_ALP1L2_i,
       modelVar_ALP2L2_i,
       modelVar_SAREF_i,
       modelVar_SBREF_i,
       modelVar_KVSAT_i,
       modelVar_LLODKUO_i,
       modelVar_WLODKUO_i,
       modelVar_LLODVTH_i,
       modelVar_WLODVTH_i,
       modelVar_LODETAO_i,
       modelVar_SCREF_i,
       modelVar_WEB_i,
       modelVar_WEC_i,
       modelVar_RSHG_i,
       modelVar_RSH_i,
       modelVar_RSHD_i,
       modelVar_RINT_i,
       modelVar_RVPOLY_i,
       modelVar_NSUBEDGEO_i,
       modelVar_LPEDGE_i,
       modelVar_QMC_i,
       modelVar_rTa,
       modelVar_delTa,
       modelVar_phita,
       modelVar_inv_phita,
       modelVar_TKD,
       modelVar_delT,
       modelVar_rTn,
       modelVar_ln_rTn,
       modelVar_inv_phit,
       modelVar_Eg,
       modelVar_phibFac,
       modelVar_IMAX_i,
       modelVar_VBIRBOT_i,
       modelVar_VBIRSTI_i,
       modelVar_VBIRGAT_i,
       modelVar_PBOT_i,
       modelVar_PSTI_i,
       modelVar_PGAT_i,
       modelVar_CSRHBOT_i,
       modelVar_CSRHSTI_i,
       modelVar_CSRHGAT_i,
       modelVar_CTATBOT_i,
       modelVar_CTATSTI_i,
       modelVar_CTATGAT_i,
       modelVar_CBBTBOT_i,
       modelVar_CBBTSTI_i,
       modelVar_CBBTGAT_i,
       modelVar_VBRBOT_i,
       modelVar_VBRSTI_i,
       modelVar_VBRGAT_i,
       modelVar_PBRBOT_i,
       modelVar_PBRSTI_i,
       modelVar_PBRGAT_i,
       modelVar_SWJUNEXP_i,
       modelVar_VJUNREF_i,
       modelVar_FJUNQ_i,
       modelVar_phitr,
       modelVar_phitd,
       modelVar_phitdinv,
       modelVar_perfc,
       modelVar_berfc,
       modelVar_cerfc,
       modelVar_ftdbot,
       modelVar_ftdsti,
       modelVar_ftdgat,
       modelVar_idsatbot,
       modelVar_idsatsti,
       modelVar_idsatgat,
       modelVar_vbibot,
       modelVar_vbisti,
       modelVar_vbigat,
       modelVar_vbiinvbot,
       modelVar_vbiinvsti,
       modelVar_vbiinvgat,
       modelVar_one_minus_PBOT,
       modelVar_one_minus_PSTI,
       modelVar_one_minus_PGAT,
       modelVar_one_over_one_minus_PBOT,
       modelVar_one_over_one_minus_PSTI,
       modelVar_one_over_one_minus_PGAT,
       modelVar_cjobot,
       modelVar_cjosti,
       modelVar_cjogat,
       modelVar_qprefbot,
       modelVar_qprefsti,
       modelVar_qprefgat,
       modelVar_qpref2bot,
       modelVar_qpref2sti,
       modelVar_qpref2gat,
       modelVar_wdepnulrbot,
       modelVar_wdepnulrsti,
       modelVar_wdepnulrgat,
       modelVar_wdepnulrinvbot,
       modelVar_wdepnulrinvsti,
       modelVar_wdepnulrinvgat,
       modelVar_VBIRBOTinv,
       modelVar_VBIRSTIinv,
       modelVar_VBIRGATinv,
       modelVar_atatbot,
       modelVar_atatsti,
       modelVar_atatgat,
       modelVar_btatpartbot,
       modelVar_btatpartsti,
       modelVar_btatpartgat,
       modelVar_fbbtbot,
       modelVar_fbbtsti,
       modelVar_fbbtgat,
       modelVar_alphaav,
       modelVar_fstopbot,
       modelVar_fstopsti,
       modelVar_fstopgat,
       modelVar_VBRinvbot,
       modelVar_VBRinvsti,
       modelVar_VBRinvgat,
       modelVar_slopebot,
       modelVar_slopesti,
       modelVar_slopegat,
       modelVar_VBIRBOTD_i,
       modelVar_VBIRSTID_i,
       modelVar_VBIRGATD_i,
       modelVar_PBOTD_i,
       modelVar_PSTID_i,
       modelVar_PGATD_i,
       modelVar_CSRHBOTD_i,
       modelVar_CSRHSTID_i,
       modelVar_CSRHGATD_i,
       modelVar_CTATBOTD_i,
       modelVar_CTATSTID_i,
       modelVar_CTATGATD_i,
       modelVar_CBBTBOTD_i,
       modelVar_CBBTSTID_i,
       modelVar_CBBTGATD_i,
       modelVar_VBRBOTD_i,
       modelVar_VBRSTID_i,
       modelVar_VBRGATD_i,
       modelVar_PBRBOTD_i,
       modelVar_PBRSTID_i,
       modelVar_PBRGATD_i,
       modelVar_VJUNREFD_i,
       modelVar_FJUNQD_i,
       modelVar_ftdbot_d,
       modelVar_ftdsti_d,
       modelVar_ftdgat_d,
       modelVar_idsatbot_d,
       modelVar_idsatsti_d,
       modelVar_idsatgat_d,
       modelVar_vbibot_d,
       modelVar_vbisti_d,
       modelVar_vbigat_d,
       modelVar_vbiinvbot_d,
       modelVar_vbiinvsti_d,
       modelVar_vbiinvgat_d,
       modelVar_one_minus_PBOT_d,
       modelVar_one_minus_PSTI_d,
       modelVar_one_minus_PGAT_d,
       modelVar_one_over_one_minus_PBOT_d,
       modelVar_one_over_one_minus_PSTI_d,
       modelVar_one_over_one_minus_PGAT_d,
       modelVar_cjobot_d,
       modelVar_cjosti_d,
       modelVar_cjogat_d,
       modelVar_qprefbot_d,
       modelVar_qprefsti_d,
       modelVar_qprefgat_d,
       modelVar_qpref2bot_d,
       modelVar_qpref2sti_d,
       modelVar_qpref2gat_d,
       modelVar_wdepnulrbot_d,
       modelVar_wdepnulrsti_d,
       modelVar_wdepnulrgat_d,
       modelVar_wdepnulrinvbot_d,
       modelVar_wdepnulrinvsti_d,
       modelVar_wdepnulrinvgat_d,
       modelVar_VBIRBOTinv_d,
       modelVar_VBIRSTIinv_d,
       modelVar_VBIRGATinv_d,
       modelVar_atatbot_d,
       modelVar_atatsti_d,
       modelVar_atatgat_d,
       modelVar_btatpartbot_d,
       modelVar_btatpartsti_d,
       modelVar_btatpartgat_d,
       modelVar_fbbtbot_d,
       modelVar_fbbtsti_d,
       modelVar_fbbtgat_d,
       modelVar_fstopbot_d,
       modelVar_fstopsti_d,
       modelVar_fstopgat_d,
       modelVar_VBRinvbot_d,
       modelVar_VBRinvsti_d,
       modelVar_VBRinvgat_d,
       modelVar_slopebot_d,
       modelVar_slopesti_d,
       modelVar_slopegat_d,
       modelVar_phit,
       modelVar_nt0,
       modelVar_EPSSI,
       // non-reals
       modelVar_CHNL_TYPE,
       modelVar_SWGEO_i,
       modelVar_SWIGATE_i,
       modelVar_SWIMPACT_i,
       modelVar_SWGIDL_i,
       modelVar_SWJUNCAP_i,
       modelVar_SWJUNASYM_i,
       modelVar_SWNUD_i,
       modelVar_SWEDGE_i,
       modelVar_SWDELVTAC_i,
       modelVar_SWIGN_i,
       in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_NOI_GND,
       in.admsProbeID_V_NOI2_GND,
       in.admsProbeID_V_B_BI,
       in.admsProbeID_V_BD_BI,
       in.admsProbeID_V_BS_BI,
       in.admsProbeID_V_BP_BI,
       in.admsProbeID_V_D_DI,
       in.admsProbeID_V_S_SI,
       in.admsProbeID_V_G_GP,
       in.admsProbeID_V_DI_BD,
       in.admsProbeID_V_SI_BS,
       in.admsProbeID_V_SI_BP,
       in.admsProbeID_V_DI_SI,
       in.admsProbeID_V_GP_SI,

       // node constants
       in.admsNodeID_D,
       in.admsNodeID_G,
       in.admsNodeID_S,
       in.admsNodeID_B,
       in.admsNodeID_NOI,
       in.admsNodeID_NOI2,
       in.admsNodeID_GP,
       in.admsNodeID_SI,
       in.admsNodeID_DI,
       in.admsNodeID_BP,
       in.admsNodeID_BI,
       in.admsNodeID_BS,
       in.admsNodeID_BD,
       // instance parameters
       // reals
       instancePar_L,
       instancePar_given_L,
       instancePar_W,
       instancePar_given_W,
       instancePar_SA,
       instancePar_given_SA,
       instancePar_SB,
       instancePar_given_SB,
       instancePar_SD,
       instancePar_given_SD,
       instancePar_SCA,
       instancePar_given_SCA,
       instancePar_SCB,
       instancePar_given_SCB,
       instancePar_SCC,
       instancePar_given_SCC,
       instancePar_SC,
       instancePar_given_SC,
       instancePar_NF,
       instancePar_given_NF,
       instancePar_NGCON,
       instancePar_given_NGCON,
       instancePar_XGW,
       instancePar_given_XGW,
       instancePar_NRS,
       instancePar_given_NRS,
       instancePar_NRD,
       instancePar_given_NRD,
       instancePar_JW,
       instancePar_given_JW,
       instancePar_DELVTO,
       instancePar_given_DELVTO,
       instancePar_FACTUO,
       instancePar_given_FACTUO,
       instancePar_DELVTOEDGE,
       instancePar_given_DELVTOEDGE,
       instancePar_FACTUOEDGE,
       instancePar_given_FACTUOEDGE,
       instancePar_ABSOURCE,
       instancePar_given_ABSOURCE,
       instancePar_LSSOURCE,
       instancePar_given_LSSOURCE,
       instancePar_LGSOURCE,
       instancePar_given_LGSOURCE,
       instancePar_ABDRAIN,
       instancePar_given_ABDRAIN,
       instancePar_LSDRAIN,
       instancePar_given_LSDRAIN,
       instancePar_LGDRAIN,
       instancePar_given_LGDRAIN,
       instancePar_AS,
       instancePar_given_AS,
       instancePar_PS,
       instancePar_given_PS,
       instancePar_AD,
       instancePar_given_AD,
       instancePar_PD,
       instancePar_given_PD,
       instancePar_MULT,
       instancePar_given_MULT,
       // instance variables
       // reals
       instanceVar_MULT_i,
       instanceVar_GFACNUD_i,
       instanceVar_VNSUB_i,
       instanceVar_NSLP_i,
       instanceVar_DNSUB_i,
       instanceVar_CF_i,
       instanceVar_CFD_i,
       instanceVar_CFB_i,
       instanceVar_PSCE_i,
       instanceVar_PSCEB_i,
       instanceVar_PSCED_i,
       instanceVar_RSB_i,
       instanceVar_RSG_i,
       instanceVar_THESATB_i,
       instanceVar_THESATG_i,
       instanceVar_AX_i,
       instanceVar_ALP_i,
       instanceVar_ALP1_i,
       instanceVar_ALP2_i,
       instanceVar_A1_i,
       instanceVar_A3_i,
       instanceVar_A4_i,
       instanceVar_GCO_i,
       instanceVar_IGINV_i,
       instanceVar_IGOV_i,
       instanceVar_IGOVD_i,
       instanceVar_GC2_i,
       instanceVar_GC3_i,
       instanceVar_CHIB_i,
       instanceVar_AGIDL_i,
       instanceVar_AGIDLD_i,
       instanceVar_CGIDL_i,
       instanceVar_CGIDLD_i,
       instanceVar_COX_i,
       instanceVar_CGOV_i,
       instanceVar_CGOVD_i,
       instanceVar_CGBOV_i,
       instanceVar_CFR_i,
       instanceVar_CFRD_i,
       instanceVar_FNTEXC_i,
       instanceVar_NFA_i,
       instanceVar_NFB_i,
       instanceVar_NFC_i,
       instanceVar_EF_i,
       instanceVar_BETNEDGE_i,
       instanceVar_PSCEEDGE_i,
       instanceVar_PSCEBEDGE_i,
       instanceVar_PSCEDEDGE_i,
       instanceVar_CFEDGE_i,
       instanceVar_CFDEDGE_i,
       instanceVar_CFBEDGE_i,
       instanceVar_NFAEDGE_i,
       instanceVar_NFBEDGE_i,
       instanceVar_NFCEDGE_i,
       instanceVar_EFEDGE_i,
       instanceVar_RG_i,
       instanceVar_RSE_i,
       instanceVar_RDE_i,
       instanceVar_RBULK_i,
       instanceVar_RJUNS_i,
       instanceVar_RJUND_i,
       instanceVar_RWELL_i,
       instanceVar_ABSOURCE_i,
       instanceVar_LSSOURCE_i,
       instanceVar_LGSOURCE_i,
       instanceVar_zflagbot_s,
       instanceVar_zflagsti_s,
       instanceVar_zflaggat_s,
       instanceVar_VMAX_s,
       instanceVar_exp_VMAX_over_phitd_s,
       instanceVar_vbimin_s,
       instanceVar_vch_s,
       instanceVar_vfmin_s,
       instanceVar_vbbtlim_s,
       instanceVar_xhighf1_s,
       instanceVar_expxhf1_s,
       instanceVar_xhighf2_s,
       instanceVar_expxhf2_s,
       instanceVar_xhighr_s,
       instanceVar_expxhr_s,
       instanceVar_m0flag_s,
       instanceVar_ISATFOR1_s,
       instanceVar_MFOR1_s,
       instanceVar_ISATFOR2_s,
       instanceVar_MFOR2_s,
       instanceVar_ISATREV_s,
       instanceVar_MREV_s,
       instanceVar_ABDRAIN_i,
       instanceVar_LSDRAIN_i,
       instanceVar_LGDRAIN_i,
       instanceVar_zflagbot_d,
       instanceVar_zflagsti_d,
       instanceVar_zflaggat_d,
       instanceVar_VMAX_d,
       instanceVar_exp_VMAX_over_phitd_d,
       instanceVar_vbimin_d,
       instanceVar_vch_d,
       instanceVar_vfmin_d,
       instanceVar_vbbtlim_d,
       instanceVar_xhighf1_d,
       instanceVar_expxhf1_d,
       instanceVar_xhighf2_d,
       instanceVar_expxhf2_d,
       instanceVar_xhighr_d,
       instanceVar_expxhr_d,
       instanceVar_m0flag_d,
       instanceVar_ISATFOR1_d,
       instanceVar_MFOR1_d,
       instanceVar_ISATFOR2_d,
       instanceVar_MFOR2_d,
       instanceVar_ISATREV_d,
       instanceVar_MREV_d,
       instanceVar_VFB_T,
       instanceVar_MUE_T,
       instanceVar_THEMU_T,
       instanceVar_CS_T,
       instanceVar_XCOR_T,
       instanceVar_A2_T,
       instanceVar_VFBEDGE_T,
       instanceVar_phit0,
       instanceVar_BET_i,
       instanceVar_BETEDGE_i,
       instanceVar_nt,
       instanceVar_THESAT_T,
       instanceVar_Sfl_prefac,
       instanceVar_phit0edge,
       instanceVar_Gfedge2,
       instanceVar_lnGfedge2,
       instanceVar_Sfl_prefac_edge,
       instanceVar_ntedge,
       instanceVar_phib_dc,
       instanceVar_G_0_dc,
       instanceVar_kp,
       instanceVar_qlim2,
       instanceVar_sqrt_phib_dc,
       instanceVar_phix_dc,
       instanceVar_aphi_dc,
       instanceVar_bphi_dc,
       instanceVar_phix1_dc,
       instanceVar_alpha_b,
       instanceVar_us1,
       instanceVar_us21,
       instanceVar_phib_ac,
       instanceVar_G_0_ac,
       instanceVar_phix_ac,
       instanceVar_aphi_ac,
       instanceVar_bphi_ac,
       instanceVar_phix1_ac,
       instanceVar_THER_i,
       instanceVar_phibedge,
       instanceVar_Gfedge,
       instanceVar_phixedge,
       instanceVar_aphiedge,
       instanceVar_bphiedge,
       instanceVar_phix1edge,
       instanceVar_Cox_over_q,
       instanceVar_qq,
       instanceVar_E_eff0,
       instanceVar_eta_mu,
       instanceVar_eta_mu1,
       instanceVar_inv_AX,
       instanceVar_inv_VP,
       instanceVar_GOV_s,
       instanceVar_GOV_d,
       instanceVar_GOV2_s,
       instanceVar_GOV2_d,
       instanceVar_SP_OV_eps2_s,
       instanceVar_SP_OV_a_s,
       instanceVar_SP_OV_delta1_s,
       instanceVar_SP_OV_eps2_d,
       instanceVar_SP_OV_a_d,
       instanceVar_SP_OV_delta1_d,
       instanceVar_inv_CHIB,
       instanceVar_BCH,
       instanceVar_BOV,
       instanceVar_BOV_d,
       instanceVar_GCQ,
       instanceVar_AGIDLs,
       instanceVar_AGIDLDs,
       instanceVar_BGIDLs,
       instanceVar_BGIDLDs,
       instanceVar_fac_exc,
       instanceVar_ggate,
       instanceVar_gsource,
       instanceVar_gdrain,
       instanceVar_gbulk,
       instanceVar_gjuns,
       instanceVar_gjund,
       instanceVar_gwell,
       // model parameters
       // reals
       modelPar_TR,
       modelPar_given_TR,
       modelPar_QMC,
       modelPar_given_QMC,
       modelPar_VFB,
       modelPar_given_VFB,
       modelPar_STVFB,
       modelPar_given_STVFB,
       modelPar_TOX,
       modelPar_given_TOX,
       modelPar_EPSROX,
       modelPar_given_EPSROX,
       modelPar_NEFF,
       modelPar_given_NEFF,
       modelPar_FACNEFFAC,
       modelPar_given_FACNEFFAC,
       modelPar_GFACNUD,
       modelPar_given_GFACNUD,
       modelPar_VSBNUD,
       modelPar_given_VSBNUD,
       modelPar_DVSBNUD,
       modelPar_given_DVSBNUD,
       modelPar_VNSUB,
       modelPar_given_VNSUB,
       modelPar_NSLP,
       modelPar_given_NSLP,
       modelPar_DNSUB,
       modelPar_given_DNSUB,
       modelPar_DPHIB,
       modelPar_given_DPHIB,
       modelPar_DELVTAC,
       modelPar_given_DELVTAC,
       modelPar_NP,
       modelPar_given_NP,
       modelPar_CT,
       modelPar_given_CT,
       modelPar_TOXOV,
       modelPar_given_TOXOV,
       modelPar_TOXOVD,
       modelPar_given_TOXOVD,
       modelPar_NOV,
       modelPar_given_NOV,
       modelPar_NOVD,
       modelPar_given_NOVD,
       modelPar_CF,
       modelPar_given_CF,
       modelPar_CFD,
       modelPar_given_CFD,
       modelPar_CFB,
       modelPar_given_CFB,
       modelPar_PSCE,
       modelPar_given_PSCE,
       modelPar_PSCEB,
       modelPar_given_PSCEB,
       modelPar_PSCED,
       modelPar_given_PSCED,
       modelPar_BETN,
       modelPar_given_BETN,
       modelPar_STBET,
       modelPar_given_STBET,
       modelPar_MUE,
       modelPar_given_MUE,
       modelPar_STMUE,
       modelPar_given_STMUE,
       modelPar_THEMU,
       modelPar_given_THEMU,
       modelPar_STTHEMU,
       modelPar_given_STTHEMU,
       modelPar_CS,
       modelPar_given_CS,
       modelPar_STCS,
       modelPar_given_STCS,
       modelPar_XCOR,
       modelPar_given_XCOR,
       modelPar_STXCOR,
       modelPar_given_STXCOR,
       modelPar_FETA,
       modelPar_given_FETA,
       modelPar_RS,
       modelPar_given_RS,
       modelPar_STRS,
       modelPar_given_STRS,
       modelPar_RSB,
       modelPar_given_RSB,
       modelPar_RSG,
       modelPar_given_RSG,
       modelPar_THESAT,
       modelPar_given_THESAT,
       modelPar_STTHESAT,
       modelPar_given_STTHESAT,
       modelPar_THESATB,
       modelPar_given_THESATB,
       modelPar_THESATG,
       modelPar_given_THESATG,
       modelPar_AX,
       modelPar_given_AX,
       modelPar_ALP,
       modelPar_given_ALP,
       modelPar_ALP1,
       modelPar_given_ALP1,
       modelPar_ALP2,
       modelPar_given_ALP2,
       modelPar_VP,
       modelPar_given_VP,
       modelPar_A1,
       modelPar_given_A1,
       modelPar_A2,
       modelPar_given_A2,
       modelPar_STA2,
       modelPar_given_STA2,
       modelPar_A3,
       modelPar_given_A3,
       modelPar_A4,
       modelPar_given_A4,
       modelPar_GCO,
       modelPar_given_GCO,
       modelPar_IGINV,
       modelPar_given_IGINV,
       modelPar_IGOV,
       modelPar_given_IGOV,
       modelPar_IGOVD,
       modelPar_given_IGOVD,
       modelPar_STIG,
       modelPar_given_STIG,
       modelPar_GC2,
       modelPar_given_GC2,
       modelPar_GC3,
       modelPar_given_GC3,
       modelPar_CHIB,
       modelPar_given_CHIB,
       modelPar_AGIDL,
       modelPar_given_AGIDL,
       modelPar_AGIDLD,
       modelPar_given_AGIDLD,
       modelPar_BGIDL,
       modelPar_given_BGIDL,
       modelPar_BGIDLD,
       modelPar_given_BGIDLD,
       modelPar_STBGIDL,
       modelPar_given_STBGIDL,
       modelPar_STBGIDLD,
       modelPar_given_STBGIDLD,
       modelPar_CGIDL,
       modelPar_given_CGIDL,
       modelPar_CGIDLD,
       modelPar_given_CGIDLD,
       modelPar_COX,
       modelPar_given_COX,
       modelPar_CGOV,
       modelPar_given_CGOV,
       modelPar_CGOVD,
       modelPar_given_CGOVD,
       modelPar_CGBOV,
       modelPar_given_CGBOV,
       modelPar_CFR,
       modelPar_given_CFR,
       modelPar_CFRD,
       modelPar_given_CFRD,
       modelPar_FNT,
       modelPar_given_FNT,
       modelPar_FNTEXC,
       modelPar_given_FNTEXC,
       modelPar_NFA,
       modelPar_given_NFA,
       modelPar_NFB,
       modelPar_given_NFB,
       modelPar_NFC,
       modelPar_given_NFC,
       modelPar_EF,
       modelPar_given_EF,
       modelPar_VFBEDGE,
       modelPar_given_VFBEDGE,
       modelPar_STVFBEDGE,
       modelPar_given_STVFBEDGE,
       modelPar_DPHIBEDGE,
       modelPar_given_DPHIBEDGE,
       modelPar_NEFFEDGE,
       modelPar_given_NEFFEDGE,
       modelPar_CTEDGE,
       modelPar_given_CTEDGE,
       modelPar_BETNEDGE,
       modelPar_given_BETNEDGE,
       modelPar_STBETEDGE,
       modelPar_given_STBETEDGE,
       modelPar_PSCEEDGE,
       modelPar_given_PSCEEDGE,
       modelPar_PSCEBEDGE,
       modelPar_given_PSCEBEDGE,
       modelPar_PSCEDEDGE,
       modelPar_given_PSCEDEDGE,
       modelPar_CFEDGE,
       modelPar_given_CFEDGE,
       modelPar_CFDEDGE,
       modelPar_given_CFDEDGE,
       modelPar_CFBEDGE,
       modelPar_given_CFBEDGE,
       modelPar_FNTEDGE,
       modelPar_given_FNTEDGE,
       modelPar_NFAEDGE,
       modelPar_given_NFAEDGE,
       modelPar_NFBEDGE,
       modelPar_given_NFBEDGE,
       modelPar_NFCEDGE,
       modelPar_given_NFCEDGE,
       modelPar_EFEDGE,
       modelPar_given_EFEDGE,
       modelPar_RG,
       modelPar_given_RG,
       modelPar_RSE,
       modelPar_given_RSE,
       modelPar_RDE,
       modelPar_given_RDE,
       modelPar_RBULK,
       modelPar_given_RBULK,
       modelPar_RWELL,
       modelPar_given_RWELL,
       modelPar_RJUNS,
       modelPar_given_RJUNS,
       modelPar_RJUND,
       modelPar_given_RJUND,
       modelPar_POVFB,
       modelPar_given_POVFB,
       modelPar_PLVFB,
       modelPar_given_PLVFB,
       modelPar_PWVFB,
       modelPar_given_PWVFB,
       modelPar_PLWVFB,
       modelPar_given_PLWVFB,
       modelPar_POSTVFB,
       modelPar_given_POSTVFB,
       modelPar_PLSTVFB,
       modelPar_given_PLSTVFB,
       modelPar_PWSTVFB,
       modelPar_given_PWSTVFB,
       modelPar_PLWSTVFB,
       modelPar_given_PLWSTVFB,
       modelPar_POTOX,
       modelPar_given_POTOX,
       modelPar_POEPSROX,
       modelPar_given_POEPSROX,
       modelPar_PONEFF,
       modelPar_given_PONEFF,
       modelPar_PLNEFF,
       modelPar_given_PLNEFF,
       modelPar_PWNEFF,
       modelPar_given_PWNEFF,
       modelPar_PLWNEFF,
       modelPar_given_PLWNEFF,
       modelPar_POFACNEFFAC,
       modelPar_given_POFACNEFFAC,
       modelPar_PLFACNEFFAC,
       modelPar_given_PLFACNEFFAC,
       modelPar_PWFACNEFFAC,
       modelPar_given_PWFACNEFFAC,
       modelPar_PLWFACNEFFAC,
       modelPar_given_PLWFACNEFFAC,
       modelPar_POGFACNUD,
       modelPar_given_POGFACNUD,
       modelPar_PLGFACNUD,
       modelPar_given_PLGFACNUD,
       modelPar_PWGFACNUD,
       modelPar_given_PWGFACNUD,
       modelPar_PLWGFACNUD,
       modelPar_given_PLWGFACNUD,
       modelPar_POVSBNUD,
       modelPar_given_POVSBNUD,
       modelPar_PODVSBNUD,
       modelPar_given_PODVSBNUD,
       modelPar_POVNSUB,
       modelPar_given_POVNSUB,
       modelPar_PONSLP,
       modelPar_given_PONSLP,
       modelPar_PODNSUB,
       modelPar_given_PODNSUB,
       modelPar_PODPHIB,
       modelPar_given_PODPHIB,
       modelPar_PLDPHIB,
       modelPar_given_PLDPHIB,
       modelPar_PWDPHIB,
       modelPar_given_PWDPHIB,
       modelPar_PLWDPHIB,
       modelPar_given_PLWDPHIB,
       modelPar_PODELVTAC,
       modelPar_given_PODELVTAC,
       modelPar_PLDELVTAC,
       modelPar_given_PLDELVTAC,
       modelPar_PWDELVTAC,
       modelPar_given_PWDELVTAC,
       modelPar_PLWDELVTAC,
       modelPar_given_PLWDELVTAC,
       modelPar_PONP,
       modelPar_given_PONP,
       modelPar_PLNP,
       modelPar_given_PLNP,
       modelPar_PWNP,
       modelPar_given_PWNP,
       modelPar_PLWNP,
       modelPar_given_PLWNP,
       modelPar_POCT,
       modelPar_given_POCT,
       modelPar_PLCT,
       modelPar_given_PLCT,
       modelPar_PWCT,
       modelPar_given_PWCT,
       modelPar_PLWCT,
       modelPar_given_PLWCT,
       modelPar_POTOXOV,
       modelPar_given_POTOXOV,
       modelPar_POTOXOVD,
       modelPar_given_POTOXOVD,
       modelPar_PONOV,
       modelPar_given_PONOV,
       modelPar_PLNOV,
       modelPar_given_PLNOV,
       modelPar_PWNOV,
       modelPar_given_PWNOV,
       modelPar_PLWNOV,
       modelPar_given_PLWNOV,
       modelPar_PONOVD,
       modelPar_given_PONOVD,
       modelPar_PLNOVD,
       modelPar_given_PLNOVD,
       modelPar_PWNOVD,
       modelPar_given_PWNOVD,
       modelPar_PLWNOVD,
       modelPar_given_PLWNOVD,
       modelPar_POCF,
       modelPar_given_POCF,
       modelPar_PLCF,
       modelPar_given_PLCF,
       modelPar_PWCF,
       modelPar_given_PWCF,
       modelPar_PLWCF,
       modelPar_given_PLWCF,
       modelPar_POCFD,
       modelPar_given_POCFD,
       modelPar_POCFB,
       modelPar_given_POCFB,
       modelPar_POPSCE,
       modelPar_given_POPSCE,
       modelPar_PLPSCE,
       modelPar_given_PLPSCE,
       modelPar_PWPSCE,
       modelPar_given_PWPSCE,
       modelPar_PLWPSCE,
       modelPar_given_PLWPSCE,
       modelPar_POPSCEB,
       modelPar_given_POPSCEB,
       modelPar_POPSCED,
       modelPar_given_POPSCED,
       modelPar_POBETN,
       modelPar_given_POBETN,
       modelPar_PLBETN,
       modelPar_given_PLBETN,
       modelPar_PWBETN,
       modelPar_given_PWBETN,
       modelPar_PLWBETN,
       modelPar_given_PLWBETN,
       modelPar_POSTBET,
       modelPar_given_POSTBET,
       modelPar_PLSTBET,
       modelPar_given_PLSTBET,
       modelPar_PWSTBET,
       modelPar_given_PWSTBET,
       modelPar_PLWSTBET,
       modelPar_given_PLWSTBET,
       modelPar_POMUE,
       modelPar_given_POMUE,
       modelPar_PLMUE,
       modelPar_given_PLMUE,
       modelPar_PWMUE,
       modelPar_given_PWMUE,
       modelPar_PLWMUE,
       modelPar_given_PLWMUE,
       modelPar_POSTMUE,
       modelPar_given_POSTMUE,
       modelPar_POTHEMU,
       modelPar_given_POTHEMU,
       modelPar_POSTTHEMU,
       modelPar_given_POSTTHEMU,
       modelPar_POCS,
       modelPar_given_POCS,
       modelPar_PLCS,
       modelPar_given_PLCS,
       modelPar_PWCS,
       modelPar_given_PWCS,
       modelPar_PLWCS,
       modelPar_given_PLWCS,
       modelPar_POSTCS,
       modelPar_given_POSTCS,
       modelPar_POXCOR,
       modelPar_given_POXCOR,
       modelPar_PLXCOR,
       modelPar_given_PLXCOR,
       modelPar_PWXCOR,
       modelPar_given_PWXCOR,
       modelPar_PLWXCOR,
       modelPar_given_PLWXCOR,
       modelPar_POSTXCOR,
       modelPar_given_POSTXCOR,
       modelPar_POFETA,
       modelPar_given_POFETA,
       modelPar_PORS,
       modelPar_given_PORS,
       modelPar_PLRS,
       modelPar_given_PLRS,
       modelPar_PWRS,
       modelPar_given_PWRS,
       modelPar_PLWRS,
       modelPar_given_PLWRS,
       modelPar_POSTRS,
       modelPar_given_POSTRS,
       modelPar_PORSB,
       modelPar_given_PORSB,
       modelPar_PORSG,
       modelPar_given_PORSG,
       modelPar_POTHESAT,
       modelPar_given_POTHESAT,
       modelPar_PLTHESAT,
       modelPar_given_PLTHESAT,
       modelPar_PWTHESAT,
       modelPar_given_PWTHESAT,
       modelPar_PLWTHESAT,
       modelPar_given_PLWTHESAT,
       modelPar_POSTTHESAT,
       modelPar_given_POSTTHESAT,
       modelPar_PLSTTHESAT,
       modelPar_given_PLSTTHESAT,
       modelPar_PWSTTHESAT,
       modelPar_given_PWSTTHESAT,
       modelPar_PLWSTTHESAT,
       modelPar_given_PLWSTTHESAT,
       modelPar_POTHESATB,
       modelPar_given_POTHESATB,
       modelPar_PLTHESATB,
       modelPar_given_PLTHESATB,
       modelPar_PWTHESATB,
       modelPar_given_PWTHESATB,
       modelPar_PLWTHESATB,
       modelPar_given_PLWTHESATB,
       modelPar_POTHESATG,
       modelPar_given_POTHESATG,
       modelPar_PLTHESATG,
       modelPar_given_PLTHESATG,
       modelPar_PWTHESATG,
       modelPar_given_PWTHESATG,
       modelPar_PLWTHESATG,
       modelPar_given_PLWTHESATG,
       modelPar_POAX,
       modelPar_given_POAX,
       modelPar_PLAX,
       modelPar_given_PLAX,
       modelPar_PWAX,
       modelPar_given_PWAX,
       modelPar_PLWAX,
       modelPar_given_PLWAX,
       modelPar_POALP,
       modelPar_given_POALP,
       modelPar_PLALP,
       modelPar_given_PLALP,
       modelPar_PWALP,
       modelPar_given_PWALP,
       modelPar_PLWALP,
       modelPar_given_PLWALP,
       modelPar_POALP1,
       modelPar_given_POALP1,
       modelPar_PLALP1,
       modelPar_given_PLALP1,
       modelPar_PWALP1,
       modelPar_given_PWALP1,
       modelPar_PLWALP1,
       modelPar_given_PLWALP1,
       modelPar_POALP2,
       modelPar_given_POALP2,
       modelPar_PLALP2,
       modelPar_given_PLALP2,
       modelPar_PWALP2,
       modelPar_given_PWALP2,
       modelPar_PLWALP2,
       modelPar_given_PLWALP2,
       modelPar_POVP,
       modelPar_given_POVP,
       modelPar_POA1,
       modelPar_given_POA1,
       modelPar_PLA1,
       modelPar_given_PLA1,
       modelPar_PWA1,
       modelPar_given_PWA1,
       modelPar_PLWA1,
       modelPar_given_PLWA1,
       modelPar_POA2,
       modelPar_given_POA2,
       modelPar_POSTA2,
       modelPar_given_POSTA2,
       modelPar_POA3,
       modelPar_given_POA3,
       modelPar_PLA3,
       modelPar_given_PLA3,
       modelPar_PWA3,
       modelPar_given_PWA3,
       modelPar_PLWA3,
       modelPar_given_PLWA3,
       modelPar_POA4,
       modelPar_given_POA4,
       modelPar_PLA4,
       modelPar_given_PLA4,
       modelPar_PWA4,
       modelPar_given_PWA4,
       modelPar_PLWA4,
       modelPar_given_PLWA4,
       modelPar_POGCO,
       modelPar_given_POGCO,
       modelPar_POIGINV,
       modelPar_given_POIGINV,
       modelPar_PLIGINV,
       modelPar_given_PLIGINV,
       modelPar_PWIGINV,
       modelPar_given_PWIGINV,
       modelPar_PLWIGINV,
       modelPar_given_PLWIGINV,
       modelPar_POIGOV,
       modelPar_given_POIGOV,
       modelPar_PLIGOV,
       modelPar_given_PLIGOV,
       modelPar_PWIGOV,
       modelPar_given_PWIGOV,
       modelPar_PLWIGOV,
       modelPar_given_PLWIGOV,
       modelPar_POIGOVD,
       modelPar_given_POIGOVD,
       modelPar_PLIGOVD,
       modelPar_given_PLIGOVD,
       modelPar_PWIGOVD,
       modelPar_given_PWIGOVD,
       modelPar_PLWIGOVD,
       modelPar_given_PLWIGOVD,
       modelPar_POSTIG,
       modelPar_given_POSTIG,
       modelPar_POGC2,
       modelPar_given_POGC2,
       modelPar_POGC3,
       modelPar_given_POGC3,
       modelPar_POCHIB,
       modelPar_given_POCHIB,
       modelPar_POAGIDL,
       modelPar_given_POAGIDL,
       modelPar_PLAGIDL,
       modelPar_given_PLAGIDL,
       modelPar_PWAGIDL,
       modelPar_given_PWAGIDL,
       modelPar_PLWAGIDL,
       modelPar_given_PLWAGIDL,
       modelPar_POAGIDLD,
       modelPar_given_POAGIDLD,
       modelPar_PLAGIDLD,
       modelPar_given_PLAGIDLD,
       modelPar_PWAGIDLD,
       modelPar_given_PWAGIDLD,
       modelPar_PLWAGIDLD,
       modelPar_given_PLWAGIDLD,
       modelPar_POBGIDL,
       modelPar_given_POBGIDL,
       modelPar_POBGIDLD,
       modelPar_given_POBGIDLD,
       modelPar_POSTBGIDL,
       modelPar_given_POSTBGIDL,
       modelPar_POSTBGIDLD,
       modelPar_given_POSTBGIDLD,
       modelPar_POCGIDL,
       modelPar_given_POCGIDL,
       modelPar_POCGIDLD,
       modelPar_given_POCGIDLD,
       modelPar_POCOX,
       modelPar_given_POCOX,
       modelPar_PLCOX,
       modelPar_given_PLCOX,
       modelPar_PWCOX,
       modelPar_given_PWCOX,
       modelPar_PLWCOX,
       modelPar_given_PLWCOX,
       modelPar_POCGOV,
       modelPar_given_POCGOV,
       modelPar_PLCGOV,
       modelPar_given_PLCGOV,
       modelPar_PWCGOV,
       modelPar_given_PWCGOV,
       modelPar_PLWCGOV,
       modelPar_given_PLWCGOV,
       modelPar_POCGOVD,
       modelPar_given_POCGOVD,
       modelPar_PLCGOVD,
       modelPar_given_PLCGOVD,
       modelPar_PWCGOVD,
       modelPar_given_PWCGOVD,
       modelPar_PLWCGOVD,
       modelPar_given_PLWCGOVD,
       modelPar_POCGBOV,
       modelPar_given_POCGBOV,
       modelPar_PLCGBOV,
       modelPar_given_PLCGBOV,
       modelPar_PWCGBOV,
       modelPar_given_PWCGBOV,
       modelPar_PLWCGBOV,
       modelPar_given_PLWCGBOV,
       modelPar_POCFR,
       modelPar_given_POCFR,
       modelPar_PLCFR,
       modelPar_given_PLCFR,
       modelPar_PWCFR,
       modelPar_given_PWCFR,
       modelPar_PLWCFR,
       modelPar_given_PLWCFR,
       modelPar_POCFRD,
       modelPar_given_POCFRD,
       modelPar_PLCFRD,
       modelPar_given_PLCFRD,
       modelPar_PWCFRD,
       modelPar_given_PWCFRD,
       modelPar_PLWCFRD,
       modelPar_given_PLWCFRD,
       modelPar_POFNT,
       modelPar_given_POFNT,
       modelPar_POFNTEXC,
       modelPar_given_POFNTEXC,
       modelPar_PLFNTEXC,
       modelPar_given_PLFNTEXC,
       modelPar_PWFNTEXC,
       modelPar_given_PWFNTEXC,
       modelPar_PLWFNTEXC,
       modelPar_given_PLWFNTEXC,
       modelPar_PONFA,
       modelPar_given_PONFA,
       modelPar_PLNFA,
       modelPar_given_PLNFA,
       modelPar_PWNFA,
       modelPar_given_PWNFA,
       modelPar_PLWNFA,
       modelPar_given_PLWNFA,
       modelPar_PONFB,
       modelPar_given_PONFB,
       modelPar_PLNFB,
       modelPar_given_PLNFB,
       modelPar_PWNFB,
       modelPar_given_PWNFB,
       modelPar_PLWNFB,
       modelPar_given_PLWNFB,
       modelPar_PONFC,
       modelPar_given_PONFC,
       modelPar_PLNFC,
       modelPar_given_PLNFC,
       modelPar_PWNFC,
       modelPar_given_PWNFC,
       modelPar_PLWNFC,
       modelPar_given_PLWNFC,
       modelPar_POEF,
       modelPar_given_POEF,
       modelPar_POVFBEDGE,
       modelPar_given_POVFBEDGE,
       modelPar_POSTVFBEDGE,
       modelPar_given_POSTVFBEDGE,
       modelPar_PLSTVFBEDGE,
       modelPar_given_PLSTVFBEDGE,
       modelPar_PWSTVFBEDGE,
       modelPar_given_PWSTVFBEDGE,
       modelPar_PLWSTVFBEDGE,
       modelPar_given_PLWSTVFBEDGE,
       modelPar_PODPHIBEDGE,
       modelPar_given_PODPHIBEDGE,
       modelPar_PLDPHIBEDGE,
       modelPar_given_PLDPHIBEDGE,
       modelPar_PWDPHIBEDGE,
       modelPar_given_PWDPHIBEDGE,
       modelPar_PLWDPHIBEDGE,
       modelPar_given_PLWDPHIBEDGE,
       modelPar_PONEFFEDGE,
       modelPar_given_PONEFFEDGE,
       modelPar_PLNEFFEDGE,
       modelPar_given_PLNEFFEDGE,
       modelPar_PWNEFFEDGE,
       modelPar_given_PWNEFFEDGE,
       modelPar_PLWNEFFEDGE,
       modelPar_given_PLWNEFFEDGE,
       modelPar_POCTEDGE,
       modelPar_given_POCTEDGE,
       modelPar_PLCTEDGE,
       modelPar_given_PLCTEDGE,
       modelPar_PWCTEDGE,
       modelPar_given_PWCTEDGE,
       modelPar_PLWCTEDGE,
       modelPar_given_PLWCTEDGE,
       modelPar_POBETNEDGE,
       modelPar_given_POBETNEDGE,
       modelPar_PLBETNEDGE,
       modelPar_given_PLBETNEDGE,
       modelPar_PWBETNEDGE,
       modelPar_given_PWBETNEDGE,
       modelPar_PLWBETNEDGE,
       modelPar_given_PLWBETNEDGE,
       modelPar_POSTBETEDGE,
       modelPar_given_POSTBETEDGE,
       modelPar_PLSTBETEDGE,
       modelPar_given_PLSTBETEDGE,
       modelPar_PWSTBETEDGE,
       modelPar_given_PWSTBETEDGE,
       modelPar_PLWSTBETEDGE,
       modelPar_given_PLWSTBETEDGE,
       modelPar_POPSCEEDGE,
       modelPar_given_POPSCEEDGE,
       modelPar_PLPSCEEDGE,
       modelPar_given_PLPSCEEDGE,
       modelPar_PWPSCEEDGE,
       modelPar_given_PWPSCEEDGE,
       modelPar_PLWPSCEEDGE,
       modelPar_given_PLWPSCEEDGE,
       modelPar_POPSCEBEDGE,
       modelPar_given_POPSCEBEDGE,
       modelPar_POPSCEDEDGE,
       modelPar_given_POPSCEDEDGE,
       modelPar_POCFEDGE,
       modelPar_given_POCFEDGE,
       modelPar_PLCFEDGE,
       modelPar_given_PLCFEDGE,
       modelPar_PWCFEDGE,
       modelPar_given_PWCFEDGE,
       modelPar_PLWCFEDGE,
       modelPar_given_PLWCFEDGE,
       modelPar_POCFDEDGE,
       modelPar_given_POCFDEDGE,
       modelPar_POCFBEDGE,
       modelPar_given_POCFBEDGE,
       modelPar_POFNTEDGE,
       modelPar_given_POFNTEDGE,
       modelPar_PONFAEDGE,
       modelPar_given_PONFAEDGE,
       modelPar_PLNFAEDGE,
       modelPar_given_PLNFAEDGE,
       modelPar_PWNFAEDGE,
       modelPar_given_PWNFAEDGE,
       modelPar_PLWNFAEDGE,
       modelPar_given_PLWNFAEDGE,
       modelPar_PONFBEDGE,
       modelPar_given_PONFBEDGE,
       modelPar_PLNFBEDGE,
       modelPar_given_PLNFBEDGE,
       modelPar_PWNFBEDGE,
       modelPar_given_PWNFBEDGE,
       modelPar_PLWNFBEDGE,
       modelPar_given_PLWNFBEDGE,
       modelPar_PONFCEDGE,
       modelPar_given_PONFCEDGE,
       modelPar_PLNFCEDGE,
       modelPar_given_PLNFCEDGE,
       modelPar_PWNFCEDGE,
       modelPar_given_PWNFCEDGE,
       modelPar_PLWNFCEDGE,
       modelPar_given_PLWNFCEDGE,
       modelPar_POEFEDGE,
       modelPar_given_POEFEDGE,
       modelPar_POKVTHOWE,
       modelPar_given_POKVTHOWE,
       modelPar_PLKVTHOWE,
       modelPar_given_PLKVTHOWE,
       modelPar_PWKVTHOWE,
       modelPar_given_PWKVTHOWE,
       modelPar_PLWKVTHOWE,
       modelPar_given_PLWKVTHOWE,
       modelPar_POKUOWE,
       modelPar_given_POKUOWE,
       modelPar_PLKUOWE,
       modelPar_given_PLKUOWE,
       modelPar_PWKUOWE,
       modelPar_given_PWKUOWE,
       modelPar_PLWKUOWE,
       modelPar_given_PLWKUOWE,
       modelPar_LMIN,
       modelPar_given_LMIN,
       modelPar_LMAX,
       modelPar_given_LMAX,
       modelPar_WMIN,
       modelPar_given_WMIN,
       modelPar_WMAX,
       modelPar_given_WMAX,
       modelPar_LVARO,
       modelPar_given_LVARO,
       modelPar_LVARL,
       modelPar_given_LVARL,
       modelPar_LVARW,
       modelPar_given_LVARW,
       modelPar_LAP,
       modelPar_given_LAP,
       modelPar_WVARO,
       modelPar_given_WVARO,
       modelPar_WVARL,
       modelPar_given_WVARL,
       modelPar_WVARW,
       modelPar_given_WVARW,
       modelPar_WOT,
       modelPar_given_WOT,
       modelPar_DLQ,
       modelPar_given_DLQ,
       modelPar_DWQ,
       modelPar_given_DWQ,
       modelPar_VFBO,
       modelPar_given_VFBO,
       modelPar_VFBL,
       modelPar_given_VFBL,
       modelPar_VFBW,
       modelPar_given_VFBW,
       modelPar_VFBLW,
       modelPar_given_VFBLW,
       modelPar_STVFBO,
       modelPar_given_STVFBO,
       modelPar_STVFBL,
       modelPar_given_STVFBL,
       modelPar_STVFBW,
       modelPar_given_STVFBW,
       modelPar_STVFBLW,
       modelPar_given_STVFBLW,
       modelPar_TOXO,
       modelPar_given_TOXO,
       modelPar_EPSROXO,
       modelPar_given_EPSROXO,
       modelPar_NSUBO,
       modelPar_given_NSUBO,
       modelPar_NSUBW,
       modelPar_given_NSUBW,
       modelPar_WSEG,
       modelPar_given_WSEG,
       modelPar_NPCK,
       modelPar_given_NPCK,
       modelPar_NPCKW,
       modelPar_given_NPCKW,
       modelPar_WSEGP,
       modelPar_given_WSEGP,
       modelPar_LPCK,
       modelPar_given_LPCK,
       modelPar_LPCKW,
       modelPar_given_LPCKW,
       modelPar_FOL1,
       modelPar_given_FOL1,
       modelPar_FOL2,
       modelPar_given_FOL2,
       modelPar_FACNEFFACO,
       modelPar_given_FACNEFFACO,
       modelPar_FACNEFFACL,
       modelPar_given_FACNEFFACL,
       modelPar_FACNEFFACW,
       modelPar_given_FACNEFFACW,
       modelPar_FACNEFFACLW,
       modelPar_given_FACNEFFACLW,
       modelPar_GFACNUDO,
       modelPar_given_GFACNUDO,
       modelPar_GFACNUDL,
       modelPar_given_GFACNUDL,
       modelPar_GFACNUDLEXP,
       modelPar_given_GFACNUDLEXP,
       modelPar_GFACNUDW,
       modelPar_given_GFACNUDW,
       modelPar_GFACNUDLW,
       modelPar_given_GFACNUDLW,
       modelPar_VSBNUDO,
       modelPar_given_VSBNUDO,
       modelPar_DVSBNUDO,
       modelPar_given_DVSBNUDO,
       modelPar_VNSUBO,
       modelPar_given_VNSUBO,
       modelPar_NSLPO,
       modelPar_given_NSLPO,
       modelPar_DNSUBO,
       modelPar_given_DNSUBO,
       modelPar_DPHIBO,
       modelPar_given_DPHIBO,
       modelPar_DPHIBL,
       modelPar_given_DPHIBL,
       modelPar_DPHIBLEXP,
       modelPar_given_DPHIBLEXP,
       modelPar_DPHIBW,
       modelPar_given_DPHIBW,
       modelPar_DPHIBLW,
       modelPar_given_DPHIBLW,
       modelPar_DELVTACO,
       modelPar_given_DELVTACO,
       modelPar_DELVTACL,
       modelPar_given_DELVTACL,
       modelPar_DELVTACLEXP,
       modelPar_given_DELVTACLEXP,
       modelPar_DELVTACW,
       modelPar_given_DELVTACW,
       modelPar_DELVTACLW,
       modelPar_given_DELVTACLW,
       modelPar_NPO,
       modelPar_given_NPO,
       modelPar_NPL,
       modelPar_given_NPL,
       modelPar_CTO,
       modelPar_given_CTO,
       modelPar_CTL,
       modelPar_given_CTL,
       modelPar_CTLEXP,
       modelPar_given_CTLEXP,
       modelPar_CTW,
       modelPar_given_CTW,
       modelPar_CTLW,
       modelPar_given_CTLW,
       modelPar_TOXOVO,
       modelPar_given_TOXOVO,
       modelPar_TOXOVDO,
       modelPar_given_TOXOVDO,
       modelPar_LOV,
       modelPar_given_LOV,
       modelPar_LOVD,
       modelPar_given_LOVD,
       modelPar_NOVO,
       modelPar_given_NOVO,
       modelPar_NOVDO,
       modelPar_given_NOVDO,
       modelPar_CFL,
       modelPar_given_CFL,
       modelPar_CFLEXP,
       modelPar_given_CFLEXP,
       modelPar_CFW,
       modelPar_given_CFW,
       modelPar_CFDO,
       modelPar_given_CFDO,
       modelPar_CFBO,
       modelPar_given_CFBO,
       modelPar_PSCEL,
       modelPar_given_PSCEL,
       modelPar_PSCELEXP,
       modelPar_given_PSCELEXP,
       modelPar_PSCEW,
       modelPar_given_PSCEW,
       modelPar_PSCEBO,
       modelPar_given_PSCEBO,
       modelPar_PSCEDO,
       modelPar_given_PSCEDO,
       modelPar_UO,
       modelPar_given_UO,
       modelPar_FBET1,
       modelPar_given_FBET1,
       modelPar_FBET1W,
       modelPar_given_FBET1W,
       modelPar_LP1,
       modelPar_given_LP1,
       modelPar_LP1W,
       modelPar_given_LP1W,
       modelPar_FBET2,
       modelPar_given_FBET2,
       modelPar_LP2,
       modelPar_given_LP2,
       modelPar_BETW1,
       modelPar_given_BETW1,
       modelPar_BETW2,
       modelPar_given_BETW2,
       modelPar_WBET,
       modelPar_given_WBET,
       modelPar_STBETO,
       modelPar_given_STBETO,
       modelPar_STBETL,
       modelPar_given_STBETL,
       modelPar_STBETW,
       modelPar_given_STBETW,
       modelPar_STBETLW,
       modelPar_given_STBETLW,
       modelPar_MUEO,
       modelPar_given_MUEO,
       modelPar_MUEW,
       modelPar_given_MUEW,
       modelPar_STMUEO,
       modelPar_given_STMUEO,
       modelPar_THEMUO,
       modelPar_given_THEMUO,
       modelPar_STTHEMUO,
       modelPar_given_STTHEMUO,
       modelPar_CSO,
       modelPar_given_CSO,
       modelPar_CSL,
       modelPar_given_CSL,
       modelPar_CSLEXP,
       modelPar_given_CSLEXP,
       modelPar_CSW,
       modelPar_given_CSW,
       modelPar_CSLW,
       modelPar_given_CSLW,
       modelPar_STCSO,
       modelPar_given_STCSO,
       modelPar_XCORO,
       modelPar_given_XCORO,
       modelPar_XCORL,
       modelPar_given_XCORL,
       modelPar_XCORW,
       modelPar_given_XCORW,
       modelPar_XCORLW,
       modelPar_given_XCORLW,
       modelPar_STXCORO,
       modelPar_given_STXCORO,
       modelPar_FETAO,
       modelPar_given_FETAO,
       modelPar_RSW1,
       modelPar_given_RSW1,
       modelPar_RSW2,
       modelPar_given_RSW2,
       modelPar_STRSO,
       modelPar_given_STRSO,
       modelPar_RSBO,
       modelPar_given_RSBO,
       modelPar_RSGO,
       modelPar_given_RSGO,
       modelPar_THESATO,
       modelPar_given_THESATO,
       modelPar_THESATL,
       modelPar_given_THESATL,
       modelPar_THESATLEXP,
       modelPar_given_THESATLEXP,
       modelPar_THESATW,
       modelPar_given_THESATW,
       modelPar_THESATLW,
       modelPar_given_THESATLW,
       modelPar_STTHESATO,
       modelPar_given_STTHESATO,
       modelPar_STTHESATL,
       modelPar_given_STTHESATL,
       modelPar_STTHESATW,
       modelPar_given_STTHESATW,
       modelPar_STTHESATLW,
       modelPar_given_STTHESATLW,
       modelPar_THESATBO,
       modelPar_given_THESATBO,
       modelPar_THESATGO,
       modelPar_given_THESATGO,
       modelPar_AXO,
       modelPar_given_AXO,
       modelPar_AXL,
       modelPar_given_AXL,
       modelPar_ALPL,
       modelPar_given_ALPL,
       modelPar_ALPLEXP,
       modelPar_given_ALPLEXP,
       modelPar_ALPW,
       modelPar_given_ALPW,
       modelPar_ALP1L1,
       modelPar_given_ALP1L1,
       modelPar_ALP1LEXP,
       modelPar_given_ALP1LEXP,
       modelPar_ALP1L2,
       modelPar_given_ALP1L2,
       modelPar_ALP1W,
       modelPar_given_ALP1W,
       modelPar_ALP2L1,
       modelPar_given_ALP2L1,
       modelPar_ALP2LEXP,
       modelPar_given_ALP2LEXP,
       modelPar_ALP2L2,
       modelPar_given_ALP2L2,
       modelPar_ALP2W,
       modelPar_given_ALP2W,
       modelPar_VPO,
       modelPar_given_VPO,
       modelPar_A1O,
       modelPar_given_A1O,
       modelPar_A1L,
       modelPar_given_A1L,
       modelPar_A1W,
       modelPar_given_A1W,
       modelPar_A2O,
       modelPar_given_A2O,
       modelPar_STA2O,
       modelPar_given_STA2O,
       modelPar_A3O,
       modelPar_given_A3O,
       modelPar_A3L,
       modelPar_given_A3L,
       modelPar_A3W,
       modelPar_given_A3W,
       modelPar_A4O,
       modelPar_given_A4O,
       modelPar_A4L,
       modelPar_given_A4L,
       modelPar_A4W,
       modelPar_given_A4W,
       modelPar_GCOO,
       modelPar_given_GCOO,
       modelPar_IGINVLW,
       modelPar_given_IGINVLW,
       modelPar_IGOVW,
       modelPar_given_IGOVW,
       modelPar_IGOVDW,
       modelPar_given_IGOVDW,
       modelPar_STIGO,
       modelPar_given_STIGO,
       modelPar_GC2O,
       modelPar_given_GC2O,
       modelPar_GC3O,
       modelPar_given_GC3O,
       modelPar_CHIBO,
       modelPar_given_CHIBO,
       modelPar_AGIDLW,
       modelPar_given_AGIDLW,
       modelPar_AGIDLDW,
       modelPar_given_AGIDLDW,
       modelPar_BGIDLO,
       modelPar_given_BGIDLO,
       modelPar_BGIDLDO,
       modelPar_given_BGIDLDO,
       modelPar_STBGIDLO,
       modelPar_given_STBGIDLO,
       modelPar_STBGIDLDO,
       modelPar_given_STBGIDLDO,
       modelPar_CGIDLO,
       modelPar_given_CGIDLO,
       modelPar_CGIDLDO,
       modelPar_given_CGIDLDO,
       modelPar_CGBOVL,
       modelPar_given_CGBOVL,
       modelPar_CFRW,
       modelPar_given_CFRW,
       modelPar_CFRDW,
       modelPar_given_CFRDW,
       modelPar_FNTO,
       modelPar_given_FNTO,
       modelPar_FNTEXCL,
       modelPar_given_FNTEXCL,
       modelPar_NFALW,
       modelPar_given_NFALW,
       modelPar_NFBLW,
       modelPar_given_NFBLW,
       modelPar_NFCLW,
       modelPar_given_NFCLW,
       modelPar_EFO,
       modelPar_given_EFO,
       modelPar_LINTNOI,
       modelPar_given_LINTNOI,
       modelPar_ALPNOI,
       modelPar_given_ALPNOI,
       modelPar_WEDGE,
       modelPar_given_WEDGE,
       modelPar_WEDGEW,
       modelPar_given_WEDGEW,
       modelPar_VFBEDGEO,
       modelPar_given_VFBEDGEO,
       modelPar_STVFBEDGEO,
       modelPar_given_STVFBEDGEO,
       modelPar_STVFBEDGEL,
       modelPar_given_STVFBEDGEL,
       modelPar_STVFBEDGEW,
       modelPar_given_STVFBEDGEW,
       modelPar_STVFBEDGELW,
       modelPar_given_STVFBEDGELW,
       modelPar_DPHIBEDGEO,
       modelPar_given_DPHIBEDGEO,
       modelPar_DPHIBEDGEL,
       modelPar_given_DPHIBEDGEL,
       modelPar_DPHIBEDGELEXP,
       modelPar_given_DPHIBEDGELEXP,
       modelPar_DPHIBEDGEW,
       modelPar_given_DPHIBEDGEW,
       modelPar_DPHIBEDGELW,
       modelPar_given_DPHIBEDGELW,
       modelPar_NSUBEDGEO,
       modelPar_given_NSUBEDGEO,
       modelPar_NSUBEDGEL,
       modelPar_given_NSUBEDGEL,
       modelPar_NSUBEDGEW,
       modelPar_given_NSUBEDGEW,
       modelPar_NSUBEDGELW,
       modelPar_given_NSUBEDGELW,
       modelPar_CTEDGEO,
       modelPar_given_CTEDGEO,
       modelPar_CTEDGEL,
       modelPar_given_CTEDGEL,
       modelPar_CTEDGELEXP,
       modelPar_given_CTEDGELEXP,
       modelPar_FBETEDGE,
       modelPar_given_FBETEDGE,
       modelPar_LPEDGE,
       modelPar_given_LPEDGE,
       modelPar_BETEDGEW,
       modelPar_given_BETEDGEW,
       modelPar_STBETEDGEO,
       modelPar_given_STBETEDGEO,
       modelPar_STBETEDGEL,
       modelPar_given_STBETEDGEL,
       modelPar_STBETEDGEW,
       modelPar_given_STBETEDGEW,
       modelPar_STBETEDGELW,
       modelPar_given_STBETEDGELW,
       modelPar_PSCEEDGEL,
       modelPar_given_PSCEEDGEL,
       modelPar_PSCEEDGELEXP,
       modelPar_given_PSCEEDGELEXP,
       modelPar_PSCEEDGEW,
       modelPar_given_PSCEEDGEW,
       modelPar_PSCEBEDGEO,
       modelPar_given_PSCEBEDGEO,
       modelPar_PSCEDEDGEO,
       modelPar_given_PSCEDEDGEO,
       modelPar_CFEDGEL,
       modelPar_given_CFEDGEL,
       modelPar_CFEDGELEXP,
       modelPar_given_CFEDGELEXP,
       modelPar_CFEDGEW,
       modelPar_given_CFEDGEW,
       modelPar_CFDEDGEO,
       modelPar_given_CFDEDGEO,
       modelPar_CFBEDGEO,
       modelPar_given_CFBEDGEO,
       modelPar_FNTEDGEO,
       modelPar_given_FNTEDGEO,
       modelPar_NFAEDGELW,
       modelPar_given_NFAEDGELW,
       modelPar_NFBEDGELW,
       modelPar_given_NFBEDGELW,
       modelPar_NFCEDGELW,
       modelPar_given_NFCEDGELW,
       modelPar_EFEDGEO,
       modelPar_given_EFEDGEO,
       modelPar_KVTHOWEO,
       modelPar_given_KVTHOWEO,
       modelPar_KVTHOWEL,
       modelPar_given_KVTHOWEL,
       modelPar_KVTHOWEW,
       modelPar_given_KVTHOWEW,
       modelPar_KVTHOWELW,
       modelPar_given_KVTHOWELW,
       modelPar_KUOWEO,
       modelPar_given_KUOWEO,
       modelPar_KUOWEL,
       modelPar_given_KUOWEL,
       modelPar_KUOWEW,
       modelPar_given_KUOWEW,
       modelPar_KUOWELW,
       modelPar_given_KUOWELW,
       modelPar_RGO,
       modelPar_given_RGO,
       modelPar_RINT,
       modelPar_given_RINT,
       modelPar_RVPOLY,
       modelPar_given_RVPOLY,
       modelPar_RSHG,
       modelPar_given_RSHG,
       modelPar_DLSIL,
       modelPar_given_DLSIL,
       modelPar_RSH,
       modelPar_given_RSH,
       modelPar_RSHD,
       modelPar_given_RSHD,
       modelPar_RBULKO,
       modelPar_given_RBULKO,
       modelPar_RWELLO,
       modelPar_given_RWELLO,
       modelPar_RJUNSO,
       modelPar_given_RJUNSO,
       modelPar_RJUNDO,
       modelPar_given_RJUNDO,
       modelPar_SAREF,
       modelPar_given_SAREF,
       modelPar_SBREF,
       modelPar_given_SBREF,
       modelPar_WLOD,
       modelPar_given_WLOD,
       modelPar_KUO,
       modelPar_given_KUO,
       modelPar_KVSAT,
       modelPar_given_KVSAT,
       modelPar_TKUO,
       modelPar_given_TKUO,
       modelPar_LKUO,
       modelPar_given_LKUO,
       modelPar_WKUO,
       modelPar_given_WKUO,
       modelPar_PKUO,
       modelPar_given_PKUO,
       modelPar_LLODKUO,
       modelPar_given_LLODKUO,
       modelPar_WLODKUO,
       modelPar_given_WLODKUO,
       modelPar_KVTHO,
       modelPar_given_KVTHO,
       modelPar_LKVTHO,
       modelPar_given_LKVTHO,
       modelPar_WKVTHO,
       modelPar_given_WKVTHO,
       modelPar_PKVTHO,
       modelPar_given_PKVTHO,
       modelPar_LLODVTH,
       modelPar_given_LLODVTH,
       modelPar_WLODVTH,
       modelPar_given_WLODVTH,
       modelPar_STETAO,
       modelPar_given_STETAO,
       modelPar_LODETAO,
       modelPar_given_LODETAO,
       modelPar_SCREF,
       modelPar_given_SCREF,
       modelPar_WEB,
       modelPar_given_WEB,
       modelPar_WEC,
       modelPar_given_WEC,
       modelPar_IMAX,
       modelPar_given_IMAX,
       modelPar_TRJ,
       modelPar_given_TRJ,
       modelPar_FREV,
       modelPar_given_FREV,
       modelPar_CJORBOT,
       modelPar_given_CJORBOT,
       modelPar_CJORSTI,
       modelPar_given_CJORSTI,
       modelPar_CJORGAT,
       modelPar_given_CJORGAT,
       modelPar_VBIRBOT,
       modelPar_given_VBIRBOT,
       modelPar_VBIRSTI,
       modelPar_given_VBIRSTI,
       modelPar_VBIRGAT,
       modelPar_given_VBIRGAT,
       modelPar_PBOT,
       modelPar_given_PBOT,
       modelPar_PSTI,
       modelPar_given_PSTI,
       modelPar_PGAT,
       modelPar_given_PGAT,
       modelPar_PHIGBOT,
       modelPar_given_PHIGBOT,
       modelPar_PHIGSTI,
       modelPar_given_PHIGSTI,
       modelPar_PHIGGAT,
       modelPar_given_PHIGGAT,
       modelPar_IDSATRBOT,
       modelPar_given_IDSATRBOT,
       modelPar_IDSATRSTI,
       modelPar_given_IDSATRSTI,
       modelPar_IDSATRGAT,
       modelPar_given_IDSATRGAT,
       modelPar_CSRHBOT,
       modelPar_given_CSRHBOT,
       modelPar_CSRHSTI,
       modelPar_given_CSRHSTI,
       modelPar_CSRHGAT,
       modelPar_given_CSRHGAT,
       modelPar_XJUNSTI,
       modelPar_given_XJUNSTI,
       modelPar_XJUNGAT,
       modelPar_given_XJUNGAT,
       modelPar_CTATBOT,
       modelPar_given_CTATBOT,
       modelPar_CTATSTI,
       modelPar_given_CTATSTI,
       modelPar_CTATGAT,
       modelPar_given_CTATGAT,
       modelPar_MEFFTATBOT,
       modelPar_given_MEFFTATBOT,
       modelPar_MEFFTATSTI,
       modelPar_given_MEFFTATSTI,
       modelPar_MEFFTATGAT,
       modelPar_given_MEFFTATGAT,
       modelPar_CBBTBOT,
       modelPar_given_CBBTBOT,
       modelPar_CBBTSTI,
       modelPar_given_CBBTSTI,
       modelPar_CBBTGAT,
       modelPar_given_CBBTGAT,
       modelPar_FBBTRBOT,
       modelPar_given_FBBTRBOT,
       modelPar_FBBTRSTI,
       modelPar_given_FBBTRSTI,
       modelPar_FBBTRGAT,
       modelPar_given_FBBTRGAT,
       modelPar_STFBBTBOT,
       modelPar_given_STFBBTBOT,
       modelPar_STFBBTSTI,
       modelPar_given_STFBBTSTI,
       modelPar_STFBBTGAT,
       modelPar_given_STFBBTGAT,
       modelPar_VBRBOT,
       modelPar_given_VBRBOT,
       modelPar_VBRSTI,
       modelPar_given_VBRSTI,
       modelPar_VBRGAT,
       modelPar_given_VBRGAT,
       modelPar_PBRBOT,
       modelPar_given_PBRBOT,
       modelPar_PBRSTI,
       modelPar_given_PBRSTI,
       modelPar_PBRGAT,
       modelPar_given_PBRGAT,
       modelPar_CJORBOTD,
       modelPar_given_CJORBOTD,
       modelPar_CJORSTID,
       modelPar_given_CJORSTID,
       modelPar_CJORGATD,
       modelPar_given_CJORGATD,
       modelPar_VBIRBOTD,
       modelPar_given_VBIRBOTD,
       modelPar_VBIRSTID,
       modelPar_given_VBIRSTID,
       modelPar_VBIRGATD,
       modelPar_given_VBIRGATD,
       modelPar_PBOTD,
       modelPar_given_PBOTD,
       modelPar_PSTID,
       modelPar_given_PSTID,
       modelPar_PGATD,
       modelPar_given_PGATD,
       modelPar_PHIGBOTD,
       modelPar_given_PHIGBOTD,
       modelPar_PHIGSTID,
       modelPar_given_PHIGSTID,
       modelPar_PHIGGATD,
       modelPar_given_PHIGGATD,
       modelPar_IDSATRBOTD,
       modelPar_given_IDSATRBOTD,
       modelPar_IDSATRSTID,
       modelPar_given_IDSATRSTID,
       modelPar_IDSATRGATD,
       modelPar_given_IDSATRGATD,
       modelPar_CSRHBOTD,
       modelPar_given_CSRHBOTD,
       modelPar_CSRHSTID,
       modelPar_given_CSRHSTID,
       modelPar_CSRHGATD,
       modelPar_given_CSRHGATD,
       modelPar_XJUNSTID,
       modelPar_given_XJUNSTID,
       modelPar_XJUNGATD,
       modelPar_given_XJUNGATD,
       modelPar_CTATBOTD,
       modelPar_given_CTATBOTD,
       modelPar_CTATSTID,
       modelPar_given_CTATSTID,
       modelPar_CTATGATD,
       modelPar_given_CTATGATD,
       modelPar_MEFFTATBOTD,
       modelPar_given_MEFFTATBOTD,
       modelPar_MEFFTATSTID,
       modelPar_given_MEFFTATSTID,
       modelPar_MEFFTATGATD,
       modelPar_given_MEFFTATGATD,
       modelPar_CBBTBOTD,
       modelPar_given_CBBTBOTD,
       modelPar_CBBTSTID,
       modelPar_given_CBBTSTID,
       modelPar_CBBTGATD,
       modelPar_given_CBBTGATD,
       modelPar_FBBTRBOTD,
       modelPar_given_FBBTRBOTD,
       modelPar_FBBTRSTID,
       modelPar_given_FBBTRSTID,
       modelPar_FBBTRGATD,
       modelPar_given_FBBTRGATD,
       modelPar_STFBBTBOTD,
       modelPar_given_STFBBTBOTD,
       modelPar_STFBBTSTID,
       modelPar_given_STFBBTSTID,
       modelPar_STFBBTGATD,
       modelPar_given_STFBBTGATD,
       modelPar_VBRBOTD,
       modelPar_given_VBRBOTD,
       modelPar_VBRSTID,
       modelPar_given_VBRSTID,
       modelPar_VBRGATD,
       modelPar_given_VBRGATD,
       modelPar_PBRBOTD,
       modelPar_given_PBRBOTD,
       modelPar_PBRSTID,
       modelPar_given_PBRSTID,
       modelPar_PBRGATD,
       modelPar_given_PBRGATD,
       modelPar_SWJUNEXP,
       modelPar_given_SWJUNEXP,
       modelPar_VJUNREF,
       modelPar_given_VJUNREF,
       modelPar_FJUNQ,
       modelPar_given_FJUNQ,
       modelPar_VJUNREFD,
       modelPar_given_VJUNREFD,
       modelPar_FJUNQD,
       modelPar_given_FJUNQD,
       modelPar_DTA,
       modelPar_given_DTA,
       // non-reals (including hidden)
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_TYPE,
       modelPar_given_TYPE,
       modelPar_SWGEO,
       modelPar_given_SWGEO,
       modelPar_SWIGATE,
       modelPar_given_SWIGATE,
       modelPar_SWIMPACT,
       modelPar_given_SWIMPACT,
       modelPar_SWGIDL,
       modelPar_given_SWGIDL,
       modelPar_SWJUNCAP,
       modelPar_given_SWJUNCAP,
       modelPar_SWJUNASYM,
       modelPar_given_SWJUNASYM,
       modelPar_SWNUD,
       modelPar_given_SWNUD,
       modelPar_SWEDGE,
       modelPar_given_SWEDGE,
       modelPar_SWDELVTAC,
       modelPar_given_SWDELVTAC,
       modelPar_SWIGN,
       modelPar_given_SWIGN// model variables
       ,
       // reals
       modelVar_TOXO_i,
       modelVar_EPSROXO_i,
       modelVar_NSUBO_i,
       modelVar_WSEG_i,
       modelVar_NPCK_i,
       modelVar_WSEGP_i,
       modelVar_LPCK_i,
       modelVar_TOXOVO_i,
       modelVar_TOXOVDO_i,
       modelVar_LOV_i,
       modelVar_LOVD_i,
       modelVar_LP1_i,
       modelVar_LP2_i,
       modelVar_WBET_i,
       modelVar_AXL_i,
       modelVar_ALP1L2_i,
       modelVar_ALP2L2_i,
       modelVar_SAREF_i,
       modelVar_SBREF_i,
       modelVar_KVSAT_i,
       modelVar_LLODKUO_i,
       modelVar_WLODKUO_i,
       modelVar_LLODVTH_i,
       modelVar_WLODVTH_i,
       modelVar_LODETAO_i,
       modelVar_SCREF_i,
       modelVar_WEB_i,
       modelVar_WEC_i,
       modelVar_RSHG_i,
       modelVar_RSH_i,
       modelVar_RSHD_i,
       modelVar_RINT_i,
       modelVar_RVPOLY_i,
       modelVar_NSUBEDGEO_i,
       modelVar_LPEDGE_i,
       modelVar_QMC_i,
       modelVar_rTa,
       modelVar_delTa,
       modelVar_phita,
       modelVar_inv_phita,
       modelVar_TKD,
       modelVar_delT,
       modelVar_rTn,
       modelVar_ln_rTn,
       modelVar_inv_phit,
       modelVar_Eg,
       modelVar_phibFac,
       modelVar_IMAX_i,
       modelVar_VBIRBOT_i,
       modelVar_VBIRSTI_i,
       modelVar_VBIRGAT_i,
       modelVar_PBOT_i,
       modelVar_PSTI_i,
       modelVar_PGAT_i,
       modelVar_CSRHBOT_i,
       modelVar_CSRHSTI_i,
       modelVar_CSRHGAT_i,
       modelVar_CTATBOT_i,
       modelVar_CTATSTI_i,
       modelVar_CTATGAT_i,
       modelVar_CBBTBOT_i,
       modelVar_CBBTSTI_i,
       modelVar_CBBTGAT_i,
       modelVar_VBRBOT_i,
       modelVar_VBRSTI_i,
       modelVar_VBRGAT_i,
       modelVar_PBRBOT_i,
       modelVar_PBRSTI_i,
       modelVar_PBRGAT_i,
       modelVar_SWJUNEXP_i,
       modelVar_VJUNREF_i,
       modelVar_FJUNQ_i,
       modelVar_phitr,
       modelVar_phitd,
       modelVar_phitdinv,
       modelVar_perfc,
       modelVar_berfc,
       modelVar_cerfc,
       modelVar_ftdbot,
       modelVar_ftdsti,
       modelVar_ftdgat,
       modelVar_idsatbot,
       modelVar_idsatsti,
       modelVar_idsatgat,
       modelVar_vbibot,
       modelVar_vbisti,
       modelVar_vbigat,
       modelVar_vbiinvbot,
       modelVar_vbiinvsti,
       modelVar_vbiinvgat,
       modelVar_one_minus_PBOT,
       modelVar_one_minus_PSTI,
       modelVar_one_minus_PGAT,
       modelVar_one_over_one_minus_PBOT,
       modelVar_one_over_one_minus_PSTI,
       modelVar_one_over_one_minus_PGAT,
       modelVar_cjobot,
       modelVar_cjosti,
       modelVar_cjogat,
       modelVar_qprefbot,
       modelVar_qprefsti,
       modelVar_qprefgat,
       modelVar_qpref2bot,
       modelVar_qpref2sti,
       modelVar_qpref2gat,
       modelVar_wdepnulrbot,
       modelVar_wdepnulrsti,
       modelVar_wdepnulrgat,
       modelVar_wdepnulrinvbot,
       modelVar_wdepnulrinvsti,
       modelVar_wdepnulrinvgat,
       modelVar_VBIRBOTinv,
       modelVar_VBIRSTIinv,
       modelVar_VBIRGATinv,
       modelVar_atatbot,
       modelVar_atatsti,
       modelVar_atatgat,
       modelVar_btatpartbot,
       modelVar_btatpartsti,
       modelVar_btatpartgat,
       modelVar_fbbtbot,
       modelVar_fbbtsti,
       modelVar_fbbtgat,
       modelVar_alphaav,
       modelVar_fstopbot,
       modelVar_fstopsti,
       modelVar_fstopgat,
       modelVar_VBRinvbot,
       modelVar_VBRinvsti,
       modelVar_VBRinvgat,
       modelVar_slopebot,
       modelVar_slopesti,
       modelVar_slopegat,
       modelVar_VBIRBOTD_i,
       modelVar_VBIRSTID_i,
       modelVar_VBIRGATD_i,
       modelVar_PBOTD_i,
       modelVar_PSTID_i,
       modelVar_PGATD_i,
       modelVar_CSRHBOTD_i,
       modelVar_CSRHSTID_i,
       modelVar_CSRHGATD_i,
       modelVar_CTATBOTD_i,
       modelVar_CTATSTID_i,
       modelVar_CTATGATD_i,
       modelVar_CBBTBOTD_i,
       modelVar_CBBTSTID_i,
       modelVar_CBBTGATD_i,
       modelVar_VBRBOTD_i,
       modelVar_VBRSTID_i,
       modelVar_VBRGATD_i,
       modelVar_PBRBOTD_i,
       modelVar_PBRSTID_i,
       modelVar_PBRGATD_i,
       modelVar_VJUNREFD_i,
       modelVar_FJUNQD_i,
       modelVar_ftdbot_d,
       modelVar_ftdsti_d,
       modelVar_ftdgat_d,
       modelVar_idsatbot_d,
       modelVar_idsatsti_d,
       modelVar_idsatgat_d,
       modelVar_vbibot_d,
       modelVar_vbisti_d,
       modelVar_vbigat_d,
       modelVar_vbiinvbot_d,
       modelVar_vbiinvsti_d,
       modelVar_vbiinvgat_d,
       modelVar_one_minus_PBOT_d,
       modelVar_one_minus_PSTI_d,
       modelVar_one_minus_PGAT_d,
       modelVar_one_over_one_minus_PBOT_d,
       modelVar_one_over_one_minus_PSTI_d,
       modelVar_one_over_one_minus_PGAT_d,
       modelVar_cjobot_d,
       modelVar_cjosti_d,
       modelVar_cjogat_d,
       modelVar_qprefbot_d,
       modelVar_qprefsti_d,
       modelVar_qprefgat_d,
       modelVar_qpref2bot_d,
       modelVar_qpref2sti_d,
       modelVar_qpref2gat_d,
       modelVar_wdepnulrbot_d,
       modelVar_wdepnulrsti_d,
       modelVar_wdepnulrgat_d,
       modelVar_wdepnulrinvbot_d,
       modelVar_wdepnulrinvsti_d,
       modelVar_wdepnulrinvgat_d,
       modelVar_VBIRBOTinv_d,
       modelVar_VBIRSTIinv_d,
       modelVar_VBIRGATinv_d,
       modelVar_atatbot_d,
       modelVar_atatsti_d,
       modelVar_atatgat_d,
       modelVar_btatpartbot_d,
       modelVar_btatpartsti_d,
       modelVar_btatpartgat_d,
       modelVar_fbbtbot_d,
       modelVar_fbbtsti_d,
       modelVar_fbbtgat_d,
       modelVar_fstopbot_d,
       modelVar_fstopsti_d,
       modelVar_fstopgat_d,
       modelVar_VBRinvbot_d,
       modelVar_VBRinvsti_d,
       modelVar_VBRinvgat_d,
       modelVar_slopebot_d,
       modelVar_slopesti_d,
       modelVar_slopegat_d,
       modelVar_phit,
       modelVar_nt0,
       modelVar_EPSSI,
       // non-reals
       modelVar_CHNL_TYPE,
       modelVar_SWGEO_i,
       modelVar_SWIGATE_i,
       modelVar_SWIMPACT_i,
       modelVar_SWGIDL_i,
       modelVar_SWJUNCAP_i,
       modelVar_SWJUNASYM_i,
       modelVar_SWNUD_i,
       modelVar_SWEDGE_i,
       modelVar_SWDELVTAC_i,
       modelVar_SWIGN_i,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);


    // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_D+inst*(13+0)] += staticContributions[in.admsNodeID_D].dx(0);
    dqdp[in.admsNodeID_D+inst*(13+0)] += dynamicContributions[in.admsNodeID_D].dx(0);
    Findices[in.admsNodeID_D+inst*(13+0)] = in.li_D;
    Qindices[in.admsNodeID_D+inst*(13+0)] = in.li_D;
    dfdp[in.admsNodeID_G+inst*(13+0)] += staticContributions[in.admsNodeID_G].dx(0);
    dqdp[in.admsNodeID_G+inst*(13+0)] += dynamicContributions[in.admsNodeID_G].dx(0);
    Findices[in.admsNodeID_G+inst*(13+0)] = in.li_G;
    Qindices[in.admsNodeID_G+inst*(13+0)] = in.li_G;
    dfdp[in.admsNodeID_S+inst*(13+0)] += staticContributions[in.admsNodeID_S].dx(0);
    dqdp[in.admsNodeID_S+inst*(13+0)] += dynamicContributions[in.admsNodeID_S].dx(0);
    Findices[in.admsNodeID_S+inst*(13+0)] = in.li_S;
    Qindices[in.admsNodeID_S+inst*(13+0)] = in.li_S;
    dfdp[in.admsNodeID_B+inst*(13+0)] += staticContributions[in.admsNodeID_B].dx(0);
    dqdp[in.admsNodeID_B+inst*(13+0)] += dynamicContributions[in.admsNodeID_B].dx(0);
    Findices[in.admsNodeID_B+inst*(13+0)] = in.li_B;
    Qindices[in.admsNodeID_B+inst*(13+0)] = in.li_B;
    dfdp[in.admsNodeID_NOI+inst*(13+0)] += staticContributions[in.admsNodeID_NOI].dx(0);
    dqdp[in.admsNodeID_NOI+inst*(13+0)] += dynamicContributions[in.admsNodeID_NOI].dx(0);
    Findices[in.admsNodeID_NOI+inst*(13+0)] = in.li_NOI;
    Qindices[in.admsNodeID_NOI+inst*(13+0)] = in.li_NOI;
    dfdp[in.admsNodeID_NOI2+inst*(13+0)] += staticContributions[in.admsNodeID_NOI2].dx(0);
    dqdp[in.admsNodeID_NOI2+inst*(13+0)] += dynamicContributions[in.admsNodeID_NOI2].dx(0);
    Findices[in.admsNodeID_NOI2+inst*(13+0)] = in.li_NOI2;
    Qindices[in.admsNodeID_NOI2+inst*(13+0)] = in.li_NOI2;
    dfdp[in.admsNodeID_GP+inst*(13+0)] += staticContributions[in.admsNodeID_GP].dx(0);
    dqdp[in.admsNodeID_GP+inst*(13+0)] += dynamicContributions[in.admsNodeID_GP].dx(0);
    Findices[in.admsNodeID_GP+inst*(13+0)] = in.li_GP;
    Qindices[in.admsNodeID_GP+inst*(13+0)] = in.li_GP;
    dfdp[in.admsNodeID_SI+inst*(13+0)] += staticContributions[in.admsNodeID_SI].dx(0);
    dqdp[in.admsNodeID_SI+inst*(13+0)] += dynamicContributions[in.admsNodeID_SI].dx(0);
    Findices[in.admsNodeID_SI+inst*(13+0)] = in.li_SI;
    Qindices[in.admsNodeID_SI+inst*(13+0)] = in.li_SI;
    dfdp[in.admsNodeID_DI+inst*(13+0)] += staticContributions[in.admsNodeID_DI].dx(0);
    dqdp[in.admsNodeID_DI+inst*(13+0)] += dynamicContributions[in.admsNodeID_DI].dx(0);
    Findices[in.admsNodeID_DI+inst*(13+0)] = in.li_DI;
    Qindices[in.admsNodeID_DI+inst*(13+0)] = in.li_DI;
    dfdp[in.admsNodeID_BP+inst*(13+0)] += staticContributions[in.admsNodeID_BP].dx(0);
    dqdp[in.admsNodeID_BP+inst*(13+0)] += dynamicContributions[in.admsNodeID_BP].dx(0);
    Findices[in.admsNodeID_BP+inst*(13+0)] = in.li_BP;
    Qindices[in.admsNodeID_BP+inst*(13+0)] = in.li_BP;
    dfdp[in.admsNodeID_BI+inst*(13+0)] += staticContributions[in.admsNodeID_BI].dx(0);
    dqdp[in.admsNodeID_BI+inst*(13+0)] += dynamicContributions[in.admsNodeID_BI].dx(0);
    Findices[in.admsNodeID_BI+inst*(13+0)] = in.li_BI;
    Qindices[in.admsNodeID_BI+inst*(13+0)] = in.li_BI;
    dfdp[in.admsNodeID_BS+inst*(13+0)] += staticContributions[in.admsNodeID_BS].dx(0);
    dqdp[in.admsNodeID_BS+inst*(13+0)] += dynamicContributions[in.admsNodeID_BS].dx(0);
    Findices[in.admsNodeID_BS+inst*(13+0)] = in.li_BS;
    Qindices[in.admsNodeID_BS+inst*(13+0)] = in.li_BS;
    dfdp[in.admsNodeID_BD+inst*(13+0)] += staticContributions[in.admsNodeID_BD].dx(0);
    dqdp[in.admsNodeID_BD+inst*(13+0)] += dynamicContributions[in.admsNodeID_BD].dx(0);
    Findices[in.admsNodeID_BD+inst*(13+0)] = in.li_BD;
    Qindices[in.admsNodeID_BD+inst*(13+0)] = in.li_BD;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSPSP103VA
} // namespace Device
} // namespace Xyce
