
//-------------------------------------------------------------------------
//   Copyright 2002-2019 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file hicumL2V2p4p0.va with ADMS
//                  interface for Xyce 6.12.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
//                  THIS FILE WAS GENERATED WITH AN EXPERIMENTAL VERSION
//                  OF XYCE/ADMS THAT HAS NOT BEEN RELEASED YET.
//                  Do not regenerate this file using the released version,
//                  or you will lose the optimizations that can be performed
//                  by the experimental code.
//
// Creator        : admsXml-2.3.6
//
// Creation Date  : Mon, 08 Apr 2019 13:58:39
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMShicumL2va.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

#include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

#include <algorithm>

namespace Xyce {
namespace Device {
namespace ADMShicumL2va {


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_c;
const int Instance::admsNodeID_b;
const int Instance::admsNodeID_e;
const int Instance::admsNodeID_s;
const int Instance::admsNodeID_tnode;
const int Instance::admsNodeID_ci;
const int Instance::admsNodeID_ei;
const int Instance::admsNodeID_bp;
const int Instance::admsNodeID_bi;
const int Instance::admsNodeID_si;
const int Instance::admsNodeID_xf1;
const int Instance::admsNodeID_xf2;
const int Instance::admsNodeID_xf;
const int Instance::admsNodeID_n1;
const int Instance::admsNodeID_n2;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMShicumL2va::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMShicumL2va::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");


}

void Traits::loadModelParameters(ParametricData<ADMShicumL2va::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMShicumL2va::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("C10", static_cast<double>(2.0E-30), &ADMShicumL2va::Model::c10)
    .setDescription("GICCR constant")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QP0", static_cast<double>(2.0E-14), &ADMShicumL2va::Model::qp0)
    .setDescription("Zero-bias hole charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ICH", static_cast<double>(0.0), &ADMShicumL2va::Model::ich)
    .setDescription("High-current correction for 2D and 3D effects")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("HF0", static_cast<double>(1.0), &ADMShicumL2va::Model::hf0)
    .setDescription("Weight factor for the low current minority charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("HFE", static_cast<double>(1.0), &ADMShicumL2va::Model::hfe)
    .setDescription("Emitter minority charge weighting factor in HBTs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("HFC", static_cast<double>(1.0), &ADMShicumL2va::Model::hfc)
    .setDescription("Collector minority charge weighting factor in HBTs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("HJEI", static_cast<double>(1.0), &ADMShicumL2va::Model::hjei)
    .setDescription("B-E depletion charge weighting factor in HBTs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AHJEI", static_cast<double>(0.0), &ADMShicumL2va::Model::ahjei)
    .setDescription("Parameter describing the slope of hjEi(VBE)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RHJEI", static_cast<double>(1.0), &ADMShicumL2va::Model::rhjei)
    .setDescription("Smoothing parameter for hjEi(VBE) at high voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("HJCI", static_cast<double>(1.0), &ADMShicumL2va::Model::hjci)
    .setDescription("B-C depletion charge weighting factor in HBTs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBEIS", static_cast<double>(1.0E-18), &ADMShicumL2va::Model::ibeis)
    .setDescription("Internal B-E saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MBEI", static_cast<double>(1.0), &ADMShicumL2va::Model::mbei)
    .setDescription("Internal B-E current ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IREIS", static_cast<double>(0.0), &ADMShicumL2va::Model::ireis)
    .setDescription("Internal B-E recombination saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MREI", static_cast<double>(2.0), &ADMShicumL2va::Model::mrei)
    .setDescription("Internal B-E recombination current ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBEPS", static_cast<double>(0.0), &ADMShicumL2va::Model::ibeps)
    .setDescription("Peripheral B-E saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MBEP", static_cast<double>(1.0), &ADMShicumL2va::Model::mbep)
    .setDescription("Peripheral B-E current ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IREPS", static_cast<double>(0.0), &ADMShicumL2va::Model::ireps)
    .setDescription("Peripheral B-E recombination saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MREP", static_cast<double>(2.0), &ADMShicumL2va::Model::mrep)
    .setDescription("Peripheral B-E recombination current ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MCF", static_cast<double>(1.0), &ADMShicumL2va::Model::mcf)
    .setDescription("Non-ideality factor for III-V HBTs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TBHREC", static_cast<double>(0.0), &ADMShicumL2va::Model::tbhrec)
    .setDescription("Base current recombination time constant at B-C barrier for high forward injection")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBCIS", static_cast<double>(1.0E-16), &ADMShicumL2va::Model::ibcis)
    .setDescription("Internal B-C saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MBCI", static_cast<double>(1.0), &ADMShicumL2va::Model::mbci)
    .setDescription("Internal B-C current ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBCXS", static_cast<double>(0.0), &ADMShicumL2va::Model::ibcxs)
    .setDescription("External B-C saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MBCX", static_cast<double>(1.0), &ADMShicumL2va::Model::mbcx)
    .setDescription("External B-C current ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IBETS", static_cast<double>(0.0), &ADMShicumL2va::Model::ibets)
    .setDescription("B-E tunneling saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ABET", static_cast<double>(40), &ADMShicumL2va::Model::abet)
    .setDescription("Exponent factor for tunneling current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TUNODE", static_cast<int>(1), &ADMShicumL2va::Model::tunode)
    .setDescription("Specifies the base node connection for the tunneling current");
  p.addPar("FAVL", static_cast<double>(0.0), &ADMShicumL2va::Model::favl)
    .setDescription("Avalanche current factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("QAVL", static_cast<double>(0.0), &ADMShicumL2va::Model::qavl)
    .setDescription("Exponent factor for avalanche current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KAVL", static_cast<double>(0.0), &ADMShicumL2va::Model::kavl)
    .setDescription("Flag/factor for turning strong avalanche on")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALFAV", static_cast<double>(0.0), &ADMShicumL2va::Model::alfav)
    .setDescription("Relative TC for FAVL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALQAV", static_cast<double>(0.0), &ADMShicumL2va::Model::alqav)
    .setDescription("Relative TC for QAVL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALKAV", static_cast<double>(0.0), &ADMShicumL2va::Model::alkav)
    .setDescription("Relative TC for KAVL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBI0", static_cast<double>(0.0), &ADMShicumL2va::Model::rbi0)
    .setDescription("Zero bias internal base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RBX", static_cast<double>(0.0), &ADMShicumL2va::Model::rbx)
    .setDescription("External base series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FGEO", static_cast<double>(0.6557), &ADMShicumL2va::Model::fgeo)
    .setDescription("Factor for geometry dependence of emitter current crowding")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FDQR0", static_cast<double>(0.0), &ADMShicumL2va::Model::fdqr0)
    .setDescription("Correction factor for modulation by B-E and B-C space charge layer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FCRBI", static_cast<double>(0.0), &ADMShicumL2va::Model::fcrbi)
    .setDescription("Ratio of HF shunt to total internal capacitance (lateral NQS effect)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FQI", static_cast<double>(1.0), &ADMShicumL2va::Model::fqi)
    .setDescription("Ration of internal to total minority charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RE", static_cast<double>(0.0), &ADMShicumL2va::Model::re)
    .setDescription("Emitter series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCX", static_cast<double>(0.0), &ADMShicumL2va::Model::rcx)
    .setDescription("External collector series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ITSS", static_cast<double>(0.0), &ADMShicumL2va::Model::itss)
    .setDescription("Substrate transistor transfer saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MSF", static_cast<double>(1.0), &ADMShicumL2va::Model::msf)
    .setDescription("Forward ideality factor of substrate transfer current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ISCS", static_cast<double>(0.0), &ADMShicumL2va::Model::iscs)
    .setDescription("C-S diode saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MSC", static_cast<double>(1.0), &ADMShicumL2va::Model::msc)
    .setDescription("Ideality factor of C-S diode current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TSF", static_cast<double>(0.0), &ADMShicumL2va::Model::tsf)
    .setDescription("Transit time for forward operation of substrate transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RSU", static_cast<double>(0.0), &ADMShicumL2va::Model::rsu)
    .setDescription("Substrate series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSU", static_cast<double>(0.0), &ADMShicumL2va::Model::csu)
    .setDescription("Substrate shunt capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJEI0", static_cast<double>(1.0E-20), &ADMShicumL2va::Model::cjei0)
    .setDescription("Internal B-E zero-bias depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDEI", static_cast<double>(0.9), &ADMShicumL2va::Model::vdei)
    .setDescription("Internal B-E built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZEI", static_cast<double>(0.5), &ADMShicumL2va::Model::zei)
    .setDescription("Internal B-E grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AJEI", static_cast<double>(2.5), &ADMShicumL2va::Model::ajei)
    .setDescription("Ratio of maximum to zero-bias value of internal B-E capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJEP0", static_cast<double>(1.0E-20), &ADMShicumL2va::Model::cjep0)
    .setDescription("Peripheral B-E zero-bias depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDEP", static_cast<double>(0.9), &ADMShicumL2va::Model::vdep)
    .setDescription("Peripheral B-E built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZEP", static_cast<double>(0.5), &ADMShicumL2va::Model::zep)
    .setDescription("Peripheral B-E grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AJEP", static_cast<double>(2.5), &ADMShicumL2va::Model::ajep)
    .setDescription("Ratio of maximum to zero-bias value of peripheral B-E capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJCI0", static_cast<double>(1.0E-20), &ADMShicumL2va::Model::cjci0)
    .setDescription("Internal B-C zero-bias depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDCI", static_cast<double>(0.7), &ADMShicumL2va::Model::vdci)
    .setDescription("Internal B-C built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZCI", static_cast<double>(0.4), &ADMShicumL2va::Model::zci)
    .setDescription("Internal B-C grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VPTCI", static_cast<double>(100), &ADMShicumL2va::Model::vptci)
    .setDescription("Internal B-C punch-through voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJCX0", static_cast<double>(1.0E-20), &ADMShicumL2va::Model::cjcx0)
    .setDescription("External B-C zero-bias depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDCX", static_cast<double>(0.7), &ADMShicumL2va::Model::vdcx)
    .setDescription("External B-C built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZCX", static_cast<double>(0.4), &ADMShicumL2va::Model::zcx)
    .setDescription("External B-C grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VPTCX", static_cast<double>(100), &ADMShicumL2va::Model::vptcx)
    .setDescription("External B-C punch-through voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBCPAR", static_cast<double>(0.0), &ADMShicumL2va::Model::fbcpar)
    .setDescription("Partitioning factor of parasitic B-C cap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBEPAR", static_cast<double>(1.0), &ADMShicumL2va::Model::fbepar)
    .setDescription("Partitioning factor of parasitic B-E cap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJS0", static_cast<double>(0.0), &ADMShicumL2va::Model::cjs0)
    .setDescription("C-S zero-bias depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDS", static_cast<double>(0.6), &ADMShicumL2va::Model::vds)
    .setDescription("C-S built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZS", static_cast<double>(0.5), &ADMShicumL2va::Model::zs)
    .setDescription("C-S grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VPTS", static_cast<double>(100), &ADMShicumL2va::Model::vpts)
    .setDescription("C-S punch-through voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSCP0", static_cast<double>(0.0), &ADMShicumL2va::Model::cscp0)
    .setDescription("Perimeter S-C zero-bias depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VDSP", static_cast<double>(0.6), &ADMShicumL2va::Model::vdsp)
    .setDescription("Perimeter S-C built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZSP", static_cast<double>(0.5), &ADMShicumL2va::Model::zsp)
    .setDescription("Perimeter S-C grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VPTSP", static_cast<double>(100), &ADMShicumL2va::Model::vptsp)
    .setDescription("Perimeter S-C punch-through voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("T0", static_cast<double>(0.0), &ADMShicumL2va::Model::t0)
    .setDescription("Low current forward transit time at VBC=0V")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DT0H", static_cast<double>(0.0), &ADMShicumL2va::Model::dt0h)
    .setDescription("Time constant for base and B-C space charge layer width modulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TBVL", static_cast<double>(0.0), &ADMShicumL2va::Model::tbvl)
    .setDescription("Time constant for modeling carrier jam at low VCE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TEF0", static_cast<double>(0.0), &ADMShicumL2va::Model::tef0)
    .setDescription("Neutral emitter storage time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("GTFE", static_cast<double>(1.0), &ADMShicumL2va::Model::gtfe)
    .setDescription("Exponent factor for current dependence of neutral emitter storage time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("THCS", static_cast<double>(0.0), &ADMShicumL2va::Model::thcs)
    .setDescription("Saturation time constant at high current densities")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AHC", static_cast<double>(0.1), &ADMShicumL2va::Model::ahc)
    .setDescription("Smoothing factor for current dependence of base and collector transit time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FTHC", static_cast<double>(0.0), &ADMShicumL2va::Model::fthc)
    .setDescription("Partitioning factor for base and collector portion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("RCI0", static_cast<double>(150), &ADMShicumL2va::Model::rci0)
    .setDescription("Internal collector resistance at low electric field")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VLIM", static_cast<double>(0.5), &ADMShicumL2va::Model::vlim)
    .setDescription("Voltage separating ohmic and saturation velocity regime")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VCES", static_cast<double>(0.1), &ADMShicumL2va::Model::vces)
    .setDescription("Internal C-E saturation voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VPT", static_cast<double>(100.0), &ADMShicumL2va::Model::vpt)
    .setDescription("Collector punch-through voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AICK", static_cast<double>(1e-3), &ADMShicumL2va::Model::aick)
    .setDescription("Smoothing term for ICK")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DELCK", static_cast<double>(2.0), &ADMShicumL2va::Model::delck)
    .setDescription("Fitting factor for critical current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TR", static_cast<double>(0.0), &ADMShicumL2va::Model::tr)
    .setDescription("Storage time for inverse operation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VCBAR", static_cast<double>(0.0), &ADMShicumL2va::Model::vcbar)
    .setDescription("Barrier voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ICBAR", static_cast<double>(0.0), &ADMShicumL2va::Model::icbar)
    .setDescription("Normalization parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ACBAR", static_cast<double>(0.01), &ADMShicumL2va::Model::acbar)
    .setDescription("Smoothing parameter for barrier voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBEPAR", static_cast<double>(0.0), &ADMShicumL2va::Model::cbepar)
    .setDescription("Total parasitic B-E capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBCPAR", static_cast<double>(0.0), &ADMShicumL2va::Model::cbcpar)
    .setDescription("Total parasitic B-C capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALQF", static_cast<double>(0.167), &ADMShicumL2va::Model::alqf)
    .setDescription("Factor for additional delay time of minority charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALIT", static_cast<double>(0.333), &ADMShicumL2va::Model::alit)
    .setDescription("Factor for additional delay time of transfer current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLNQS", static_cast<int>(0), &ADMShicumL2va::Model::flnqs)
    .setDescription("Flag for turning on and off of vertical NQS effect");
  p.addPar("KF", static_cast<double>(0.0), &ADMShicumL2va::Model::kf)
    .setDescription("Flicker noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AF", static_cast<double>(2.0), &ADMShicumL2va::Model::af)
    .setDescription("Flicker noise exponent factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CFBE", static_cast<int>((-1)), &ADMShicumL2va::Model::cfbe)
    .setDescription("Flag for determining where to tag the flicker noise source");
  p.addPar("FLCONO", static_cast<int>(0), &ADMShicumL2va::Model::flcono)
    .setDescription("Flag for turning on and off of correlated noise implementation");
  p.addPar("KFRE", static_cast<double>(0.0), &ADMShicumL2va::Model::kfre)
    .setDescription("Emitter resistance flicker noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("AFRE", static_cast<double>(2.0), &ADMShicumL2va::Model::afre)
    .setDescription("Emitter resistance flicker noise exponent factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LATB", static_cast<double>(0.0), &ADMShicumL2va::Model::latb)
    .setDescription("Scaling factor for collector minority charge in direction of emitter width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LATL", static_cast<double>(0.0), &ADMShicumL2va::Model::latl)
    .setDescription("Scaling factor for collector minority charge in direction of emitter length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGB", static_cast<double>(1.17), &ADMShicumL2va::Model::vgb)
    .setDescription("Bandgap voltage extrapolated to 0 K")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALT0", static_cast<double>(0.0), &ADMShicumL2va::Model::alt0)
    .setDescription("First order relative TC of parameter T0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("KT0", static_cast<double>(0.0), &ADMShicumL2va::Model::kt0)
    .setDescription("Second order relative TC of parameter T0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETACI", static_cast<double>(0.0), &ADMShicumL2va::Model::zetaci)
    .setDescription("Temperature exponent for RCI0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALVS", static_cast<double>(0.0), &ADMShicumL2va::Model::alvs)
    .setDescription("Relative TC of saturation drift velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALCES", static_cast<double>(0.0), &ADMShicumL2va::Model::alces)
    .setDescription("Relative TC of VCES")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETARBI", static_cast<double>(0.0), &ADMShicumL2va::Model::zetarbi)
    .setDescription("Temperature exponent of internal base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETARBX", static_cast<double>(0.0), &ADMShicumL2va::Model::zetarbx)
    .setDescription("Temperature exponent of external base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETARCX", static_cast<double>(0.0), &ADMShicumL2va::Model::zetarcx)
    .setDescription("Temperature exponent of external collector resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETARE", static_cast<double>(0.0), &ADMShicumL2va::Model::zetare)
    .setDescription("Temperature exponent of emitter resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETACX", static_cast<double>(1.0), &ADMShicumL2va::Model::zetacx)
    .setDescription("Temperature exponent of mobility in substrate transistor transit time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGE", static_cast<double>(1.17), &ADMShicumL2va::Model::vge)
    .setDescription("Effective emitter bandgap voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGC", static_cast<double>(1.17), &ADMShicumL2va::Model::vgc)
    .setDescription("Effective collector bandgap voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VGS", static_cast<double>(1.17), &ADMShicumL2va::Model::vgs)
    .setDescription("Effective substrate bandgap voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("F1VG", static_cast<double>((-1.02377e-4)), &ADMShicumL2va::Model::f1vg)
    .setDescription("Coefficient K1 in T-dependent band-gap equation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("F2VG", static_cast<double>(4.3215e-4), &ADMShicumL2va::Model::f2vg)
    .setDescription("Coefficient K2 in T-dependent band-gap equation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETACT", static_cast<double>(3.0), &ADMShicumL2va::Model::zetact)
    .setDescription("Exponent coefficient in transfer current temperature dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETABET", static_cast<double>(3.5), &ADMShicumL2va::Model::zetabet)
    .setDescription("Exponent coefficient in B-E junction current temperature dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALB", static_cast<double>(0.0), &ADMShicumL2va::Model::alb)
    .setDescription("Relative TC of forward current gain for V2.1 model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DVGBE", static_cast<double>(0), &ADMShicumL2va::Model::dvgbe)
    .setDescription("Bandgap difference between B and B-E junction used for hjEi0 and hf0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETAHJEI", static_cast<double>(1), &ADMShicumL2va::Model::zetahjei)
    .setDescription("Temperature coefficient for ahjEi")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETAVGBE", static_cast<double>(1), &ADMShicumL2va::Model::zetavgbe)
    .setDescription("Temperature coefficient for hjEi0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLSH", static_cast<int>(0), &ADMShicumL2va::Model::flsh)
    .setDescription("Flag for turning on and off self-heating effect");
  p.addPar("RTH", static_cast<double>(0.0), &ADMShicumL2va::Model::rth)
    .setDescription("Thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ZETARTH", static_cast<double>(0.0), &ADMShicumL2va::Model::zetarth)
    .setDescription("Temperature coefficient for Rth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("ALRTH", static_cast<double>(0.0), &ADMShicumL2va::Model::alrth)
    .setDescription("First order relative TC of parameter Rth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTH", static_cast<double>(0.0), &ADMShicumL2va::Model::cth)
    .setDescription("Thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FLCOMP", static_cast<double>(0.0), &ADMShicumL2va::Model::flcomp)
    .setDescription("Flag for compatibility with v2.1 model (0=v2.1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TNOM", static_cast<double>(27.0), &ADMShicumL2va::Model::tnom)
    .setDescription("Temperature at which parameters are specified")
    .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("DT", static_cast<double>(0.0), &ADMShicumL2va::Model::dt)
    .setDescription("Temperature change w.r.t. chip temperature for particular transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TYPE", static_cast<int>(1), &ADMShicumL2va::Model::type)
    .setDescription("For transistor type NPN(+1) or PNP (-1)");

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double a_eg;
  double aa;
  double ab;
  double C_1;
  double vge_t0;
  double vgb_t0;
  double k20;
  double k10;
  //Begin block initial_instance
  {
    Tnom = ((model_.tnom)+273.15);
    Tamb = admsTemperature;
    vt0 = ((1.3806503e-23*Tnom)/1.6021766208e-19);
    {
      double value_log_0 = log(Tnom);
      k10 = (((model_.f1vg)*Tnom)*value_log_0);
    }
    k20 = ((model_.f2vg)*Tnom);
    avs = ((model_.alvs)*Tnom);
    vgb_t0 = (((model_.vgb)+k10)+k20);
    vge_t0 = (((model_.vge)+k10)+k20);
    vgbe_t0 = ((vgb_t0+vge_t0)/2);
    vgbe0 = (((model_.vgb)+(model_.vge))/2);
    vgbc0 = (((model_.vgb)+(model_.vgc))/2);
    vgsc0 = (((model_.vgs)+(model_.vgc))/2);
    mg = (3-((1.6021766208e-19*(model_.f1vg))/1.3806503e-23));
    zetabci = ((mg+1)-(model_.zetaci));
    zetabcxt = ((mg+1)-(model_.zetacx));
    zetasct = (mg-1.5);
    C_1 = ((1.0-(model_.fbcpar))*((model_.cjcx0)+(model_.cbcpar)));
    if ((C_1>=(model_.cbcpar)))
    {
      cbcpar1 = (model_.cbcpar);
      cbcpar2 = 0.0;
      cjcx01 = (C_1-(model_.cbcpar));
      cjcx02 = ((model_.cjcx0)-cjcx01);
    }
    else
    {
      cbcpar1 = C_1;
      cbcpar2 = ((model_.cbcpar)-cbcpar1);
      cjcx01 = 0.0;
      cjcx02 = (model_.cjcx0);
    }
    cbepar2 = ((model_.fbepar)*(model_.cbepar));
    cbepar1 = ((model_.cbepar)-cbepar2);
    if (((model_.ich)!=0.0))
    {
      Oich = (1.0/(model_.ich));
    }
    else
    {
      Oich = 0.0;
    }
    if (((model_.tbhrec)!=0.0))
    {
      Otbhrec = (1.0/(model_.tbhrec));
    }
    else
    {
      Otbhrec = 0.0;
    }
    if ((((model_.favl)>0.0)&&((model_.cjci0)>0.0)))
    {
      use_aval = 1;
    }
    else
    {
      use_aval = 0;

      d_iavl_dV_tnode_GND = d_iavl_dV_bi_ei = d_iavl_dV_bi_ci =  0.0;
      iavl = 0.0;
    }
    if ((((model_.flsh)==0)||((model_.rth)<0.001)))
      //Begin block Thermal_updat_without_self_heating
    {

      d_Tdev_dV_tnode_GND =  0.0;
      Tdev = (Tamb+(model_.dt));
      if ((Tdev<((-100.0)+273.15)))
      {

        d_Tdev_dV_tnode_GND =  0.0;
        Tdev = ((-100.0)+273.15);
      }
      else
      {
        if ((Tdev>(326.85+273.15)))
        {

          d_Tdev_dV_tnode_GND =  0.0;
          Tdev = (326.85+273.15);
        }
      }

      d_VT_dV_tnode_GND =  0.0;
      VT = ((1.3806503e-23*Tdev)/1.6021766208e-19);

      d_dT_dV_tnode_GND =  0.0;
      dT = (Tdev-Tnom);

      d_qtt0_dV_tnode_GND =  0.0;
      qtt0 = (Tdev/Tnom);
      {
        double value_log_0 = log(qtt0);

        d_ln_qtt0_dV_tnode_GND =  0.0;
        ln_qtt0 = value_log_0;
      }
      {
        double value_log_0 = log(Tdev);

        d_k1_dV_tnode_GND =  0.0;
        k1 = (((model_.f1vg)*Tdev)*value_log_0);
      }

      d_k2_dV_tnode_GND =  0.0;
      k2 = ((model_.f2vg)*Tdev);

      d_vgb_t_dV_tnode_GND =  0.0;
      vgb_t = (((model_.vgb)+k1)+k2);

      d_vge_t_dV_tnode_GND =  0.0;
      vge_t = (((model_.vge)+k1)+k2);

      d_vgbe_t_dV_tnode_GND =  0.0;
      vgbe_t = ((vgb_t+vge_t)/2);
      if (((model_.cjei0)>0.0))
      {
        {
          double value_exp_0 = exp((((model_.vdei)*0.5)/vt0));
          double value_exp_1 = exp((((-0.5)*(model_.vdei))/vt0));
          double value_log_2 = log((value_exp_0-value_exp_1));
          vdj0 = ((2*vt0)*value_log_2);
        }

        d_vdjt_dV_tnode_GND =  0.0;
        vdjt = (((vdj0*qtt0)+(vgbe0*(1-qtt0)))-((mg*VT)*ln_qtt0));
        {
          double value_exp_0 = exp(((-vdjt)/VT));
          double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
          double value_log_2 = log((0.5*(1+value_sqrt_1)));

          d_vdt_dV_tnode_GND =  0.0;
          vdt = (vdjt+((2*VT)*value_log_2));
        }

        d_vdei_t_dV_tnode_GND =  0.0;
        vdei_t = vdt;
        {
          double value_log_0 = log(((model_.vdei)/vdei_t));
          double value_exp_1 = exp(((model_.zei)*value_log_0));

          d_cjei0_t_dV_tnode_GND =  0.0;
          cjei0_t = ((model_.cjei0)*value_exp_1);
        }
        if ((1==1))
        {

          d_ajei_t_dV_tnode_GND =  0.0;
          ajei_t = (((model_.ajei)*vdei_t)/(model_.vdei));
        }
        else
        {

          d_ajei_t_dV_tnode_GND =  0.0;
          ajei_t = (model_.ajei);
        }
      }
      else
      {

        d_cjei0_t_dV_tnode_GND =  0.0;
        cjei0_t = (model_.cjei0);

        d_vdei_t_dV_tnode_GND =  0.0;
        vdei_t = (model_.vdei);

        d_ajei_t_dV_tnode_GND =  0.0;
        ajei_t = (model_.ajei);
      }
      if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
      {

        d_V_gT_dV_tnode_GND =  0.0;
        V_gT = (((3.0*VT)*ln_qtt0)+((model_.vgb)*(qtt0-1.0)));

        d_r_VgVT_dV_tnode_GND =  0.0;
        r_VgVT = (V_gT/VT);

        d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
        a = ((((model_.mcf)*r_VgVT)/(model_.mbei))-((model_.alb)*dT));
        {
          double value_exp_0 = exp(a);

          d_ibeis_t_dV_tnode_GND =  0.0;
          ibeis_t = ((model_.ibeis)*value_exp_0);
        }

        d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
        a = ((((model_.mcf)*r_VgVT)/(model_.mrei))-((model_.alb)*dT));
        {
          double value_exp_0 = exp(a);

          d_ireis_t_dV_tnode_GND =  0.0;
          ireis_t = ((model_.ireis)*value_exp_0);
        }

        d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
        a = ((((model_.mcf)*r_VgVT)/(model_.mbep))-((model_.alb)*dT));
        {
          double value_exp_0 = exp(a);

          d_ibeps_t_dV_tnode_GND =  0.0;
          ibeps_t = ((model_.ibeps)*value_exp_0);
        }

        d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
        a = ((((model_.mcf)*r_VgVT)/(model_.mrep))-((model_.alb)*dT));
        {
          double value_exp_0 = exp(a);

          d_ireps_t_dV_tnode_GND =  0.0;
          ireps_t = ((model_.ireps)*value_exp_0);
        }

        d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
        a = (r_VgVT/(model_.mbci));
        {
          double value_exp_0 = exp(a);

          d_ibcis_t_dV_tnode_GND =  0.0;
          ibcis_t = ((model_.ibcis)*value_exp_0);
        }

        d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
        a = (r_VgVT/(model_.mbcx));
        {
          double value_exp_0 = exp(a);

          d_ibcxs_t_dV_tnode_GND =  0.0;
          ibcxs_t = ((model_.ibcxs)*value_exp_0);
        }

        d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
        a = (r_VgVT/(model_.msf));
        {
          double value_exp_0 = exp(a);

          d_itss_t_dV_tnode_GND =  0.0;
          itss_t = ((model_.itss)*value_exp_0);
        }

        d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
        a = (r_VgVT/(model_.msc));
        {
          double value_exp_0 = exp(a);

          d_iscs_t_dV_tnode_GND =  0.0;
          iscs_t = ((model_.iscs)*value_exp_0);
        }

        d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
        a = (vdei_t/(model_.vdei));

        d_qp0_t_dV_tnode_GND =  0.0;
        qp0_t = ((model_.qp0)*(1.0+((0.5*(model_.zei))*(1.0-a))));
        {
          double value_exp_0 = exp(((model_.zetaci)*ln_qtt0));

          d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
          a = (((model_.vlim)*(1.0-((model_.alvs)*dT)))*value_exp_0);
        }

        d_k_dV_tnode_GND =  0.0;
        k = ((a-VT)/VT);
        if ((k<11.0))
        {
          {
            double value_exp_0 = exp(k);
            double value_log_1 = log((1.0+value_exp_0));

            d_vlim_t_dV_tnode_GND =  0.0;
            vlim_t = (VT+(VT*value_log_1));
          }
        }
        else
        {

          d_vlim_t_dV_tnode_GND =  0.0;
          vlim_t = a;
        }

        d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
        a = (1.0+((model_.alb)*dT));
        {
          double value_sqrt_0 = sqrt(((a*a)+0.01));

          d_k_dV_tnode_GND =  0.0;
          k = (0.5*(a+value_sqrt_0));
        }

        d_tef0_t_dV_tnode_GND =  0.0;
        tef0_t = (((model_.tef0)*qtt0)/k);
      }
      else
      {
        {
          double value_exp_0 = exp((((model_.zetabet)*ln_qtt0)+(((model_.vge)/VT)*(qtt0-1))));

          d_ibeis_t_dV_tnode_GND =  0.0;
          ibeis_t = ((model_.ibeis)*value_exp_0);
        }
        if (((model_.flcomp)>=2.3))
        {
          {
            double value_exp_0 = exp((((mg/(model_.mrei))*ln_qtt0)+((vgbe0/((model_.mrei)*VT))*(qtt0-1))));

            d_ireis_t_dV_tnode_GND =  0.0;
            ireis_t = ((model_.ireis)*value_exp_0);
          }
        }
        else
        {
          {
            double value_exp_0 = exp((((0.5*mg)*ln_qtt0)+(((0.5*vgbe0)/VT)*(qtt0-1))));

            d_ireis_t_dV_tnode_GND =  0.0;
            ireis_t = ((model_.ireis)*value_exp_0);
          }
        }
        {
          double value_exp_0 = exp((((model_.zetabet)*ln_qtt0)+(((model_.vge)/VT)*(qtt0-1))));

          d_ibeps_t_dV_tnode_GND =  0.0;
          ibeps_t = ((model_.ibeps)*value_exp_0);
        }
        if (((model_.flcomp)>=2.3))
        {
          {
            double value_exp_0 = exp((((mg/(model_.mrep))*ln_qtt0)+((vgbe0/((model_.mrep)*VT))*(qtt0-1))));

            d_ireps_t_dV_tnode_GND =  0.0;
            ireps_t = ((model_.ireps)*value_exp_0);
          }
        }
        else
        {
          {
            double value_exp_0 = exp((((0.5*mg)*ln_qtt0)+(((0.5*vgbe0)/VT)*(qtt0-1))));

            d_ireps_t_dV_tnode_GND =  0.0;
            ireps_t = ((model_.ireps)*value_exp_0);
          }
        }
        {
          double value_exp_0 = exp(((zetabci*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1))));

          d_ibcis_t_dV_tnode_GND =  0.0;
          ibcis_t = ((model_.ibcis)*value_exp_0);
        }
        {
          double value_exp_0 = exp(((zetabcxt*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1))));

          d_ibcxs_t_dV_tnode_GND =  0.0;
          ibcxs_t = ((model_.ibcxs)*value_exp_0);
        }
        {
          double value_exp_0 = exp(((zetasct*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1))));

          d_itss_t_dV_tnode_GND =  0.0;
          itss_t = ((model_.itss)*value_exp_0);
        }
        {
          double value_exp_0 = exp(((zetasct*ln_qtt0)+(((model_.vgs)/VT)*(qtt0-1))));

          d_iscs_t_dV_tnode_GND =  0.0;
          iscs_t = ((model_.iscs)*value_exp_0);
        }
        {
          double value_log_0 = log((vdei_t/(model_.vdei)));
          double value_exp_1 = exp(((model_.zei)*value_log_0));

          d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
          a = value_exp_1;
        }

        d_qp0_t_dV_tnode_GND =  0.0;
        qp0_t = ((model_.qp0)*(2.0-a));
        {
          double value_exp_0 = exp((((model_.zetaci)-avs)*ln_qtt0));

          d_vlim_t_dV_tnode_GND =  0.0;
          vlim_t = ((model_.vlim)*value_exp_0);
        }
        if (((model_.flcomp)>=2.3))
        {

          d_tef0_t_dV_tnode_GND =  0.0;
          tef0_t = (model_.tef0);
        }
        else
        {
          zetatef = (((model_.zetabet)-(model_.zetact))-0.5);
          dvg0 = ((model_.vgb)-(model_.vge));
          {
            double value_exp_0 = exp(((zetatef*ln_qtt0)-((dvg0/VT)*(qtt0-1))));

            d_tef0_t_dV_tnode_GND =  0.0;
            tef0_t = ((model_.tef0)*value_exp_0);
          }
        }
      }
      {
        double value_exp_0 = exp((((model_.zetact)*ln_qtt0)+(((model_.vgb)/VT)*(qtt0-1))));

        d_c10_t_dV_tnode_GND =  0.0;
        c10_t = ((model_.c10)*value_exp_0);
      }
      {
        double value_exp_0 = exp(((model_.zetaci)*ln_qtt0));

        d_rci0_t_dV_tnode_GND =  0.0;
        rci0_t = ((model_.rci0)*value_exp_0);
      }

      d_vces_t_dV_tnode_GND =  0.0;
      vces_t = ((model_.vces)*(1+((model_.alces)*dT)));
      if (((model_.cjci0)>0.0))
      {
        {
          double value_exp_0 = exp((((model_.vdci)*0.5)/vt0));
          double value_exp_1 = exp((((-0.5)*(model_.vdci))/vt0));
          double value_log_2 = log((value_exp_0-value_exp_1));
          vdj0 = ((2*vt0)*value_log_2);
        }

        d_vdjt_dV_tnode_GND =  0.0;
        vdjt = (((vdj0*qtt0)+(vgbc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
        {
          double value_exp_0 = exp(((-vdjt)/VT));
          double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
          double value_log_2 = log((0.5*(1+value_sqrt_1)));

          d_vdt_dV_tnode_GND =  0.0;
          vdt = (vdjt+((2*VT)*value_log_2));
        }

        d_vdci_t_dV_tnode_GND =  0.0;
        vdci_t = vdt;
        {
          double value_log_0 = log(((model_.vdci)/vdci_t));
          double value_exp_1 = exp(((model_.zci)*value_log_0));

          d_cjci0_t_dV_tnode_GND =  0.0;
          cjci0_t = ((model_.cjci0)*value_exp_1);
        }
        if ((0==1))
        {

          d_vptci_t_dV_tnode_GND =  0.0;
          vptci_t = (((model_.vptci)*vdci_t)/(model_.vdci));
        }
        else
        {

          d_vptci_t_dV_tnode_GND =  0.0;
          vptci_t = (model_.vptci);
        }
      }
      else
      {

        d_cjci0_t_dV_tnode_GND =  0.0;
        cjci0_t = (model_.cjci0);

        d_vdci_t_dV_tnode_GND =  0.0;
        vdci_t = (model_.vdci);

        d_vptci_t_dV_tnode_GND =  0.0;
        vptci_t = (model_.vptci);
      }

      d_t0_t_dV_tnode_GND =  0.0;
      t0_t = ((model_.t0)*((1+((model_.alt0)*dT))+(((model_.kt0)*dT)*dT)));
      {
        double value_exp_0 = exp((((model_.zetaci)-1)*ln_qtt0));

        d_thcs_t_dV_tnode_GND =  0.0;
        thcs_t = ((model_.thcs)*value_exp_0);
      }
      {
        double value_exp_0 = exp(((model_.alfav)*dT));

        d_favl_t_dV_tnode_GND =  0.0;
        favl_t = ((model_.favl)*value_exp_0);
      }
      {
        double value_exp_0 = exp(((model_.alqav)*dT));

        d_qavl_t_dV_tnode_GND =  0.0;
        qavl_t = ((model_.qavl)*value_exp_0);
      }
      {
        double value_exp_0 = exp(((model_.alkav)*dT));

        d_kavl_t_dV_tnode_GND =  0.0;
        kavl_t = ((model_.kavl)*value_exp_0);
      }
      {
        double value_exp_0 = exp(((model_.zetarbi)*ln_qtt0));

        d_rbi0_t_dV_tnode_GND =  0.0;
        rbi0_t = ((model_.rbi0)*value_exp_0);
      }
      if (((model_.cjep0)>0.0))
      {
        {
          double value_exp_0 = exp((((model_.vdep)*0.5)/vt0));
          double value_exp_1 = exp((((-0.5)*(model_.vdep))/vt0));
          double value_log_2 = log((value_exp_0-value_exp_1));
          vdj0 = ((2*vt0)*value_log_2);
        }

        d_vdjt_dV_tnode_GND =  0.0;
        vdjt = (((vdj0*qtt0)+(vgbe0*(1-qtt0)))-((mg*VT)*ln_qtt0));
        {
          double value_exp_0 = exp(((-vdjt)/VT));
          double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
          double value_log_2 = log((0.5*(1+value_sqrt_1)));

          d_vdt_dV_tnode_GND =  0.0;
          vdt = (vdjt+((2*VT)*value_log_2));
        }

        d_vdep_t_dV_tnode_GND =  0.0;
        vdep_t = vdt;
        {
          double value_log_0 = log(((model_.vdep)/vdep_t));
          double value_exp_1 = exp(((model_.zep)*value_log_0));

          d_cjep0_t_dV_tnode_GND =  0.0;
          cjep0_t = ((model_.cjep0)*value_exp_1);
        }
        if ((1==1))
        {

          d_ajep_t_dV_tnode_GND =  0.0;
          ajep_t = (((model_.ajep)*vdep_t)/(model_.vdep));
        }
        else
        {

          d_ajep_t_dV_tnode_GND =  0.0;
          ajep_t = (model_.ajep);
        }
      }
      else
      {

        d_cjep0_t_dV_tnode_GND =  0.0;
        cjep0_t = (model_.cjep0);

        d_vdep_t_dV_tnode_GND =  0.0;
        vdep_t = (model_.vdep);

        d_ajep_t_dV_tnode_GND =  0.0;
        ajep_t = (model_.ajep);
      }
      if (((model_.ibets)>0))
        //Begin block HICTUN_T
      {
        //Block-local variables for block HICTUN_T
        double a_eg;
        double ab;
        double aa;
        //End of Block-local variables
        ab = 1.0;
        aa = 1.0;
        a_eg = (vgbe_t0/vgbe_t);
        if (((((model_.tunode)==1)&&((model_.cjep0)>0.0))&&((model_.vdep)>0.0)))
        {
          {
            double value_sqrt_0 = sqrt(a_eg);
            ab = (((((cjep0_t/(model_.cjep0))*value_sqrt_0)*vdep_t)*vdep_t)/((model_.vdep)*(model_.vdep)));
          }
          {
            double value_pow_0 = pow(a_eg,(-1.5));
            aa = ((((model_.vdep)/vdep_t)*((model_.cjep0)/cjep0_t))*value_pow_0);
          }
        }
        else
        {
          if (((((model_.tunode)==0)&&((model_.cjei0)>0.0))&&((model_.vdei)>0.0)))
          {
            {
              double value_sqrt_0 = sqrt(a_eg);
              ab = (((((cjei0_t/(model_.cjei0))*value_sqrt_0)*vdei_t)*vdei_t)/((model_.vdei)*(model_.vdei)));
            }
            {
              double value_pow_0 = pow(a_eg,(-1.5));
              aa = ((((model_.vdei)/vdei_t)*((model_.cjei0)/cjei0_t))*value_pow_0);
            }
          }
        }

        d_ibets_t_dV_tnode_GND =  0.0;
        ibets_t = ((model_.ibets)*ab);

        d_abet_t_dV_tnode_GND =  0.0;
        abet_t = ((model_.abet)*aa);
      }
      // End block HICTUN_T
      else
      {

        d_ibets_t_dV_tnode_GND =  0.0;
        ibets_t = 0;

        d_abet_t_dV_tnode_GND =  0.0;
        abet_t = 1;
      }
      if ((1.0>0.0))
      {
        {
          double value_exp_0 = exp((((model_.vdcx)*0.5)/vt0));
          double value_exp_1 = exp((((-0.5)*(model_.vdcx))/vt0));
          double value_log_2 = log((value_exp_0-value_exp_1));
          vdj0 = ((2*vt0)*value_log_2);
        }

        d_vdjt_dV_tnode_GND =  0.0;
        vdjt = (((vdj0*qtt0)+(vgbc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
        {
          double value_exp_0 = exp(((-vdjt)/VT));
          double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
          double value_log_2 = log((0.5*(1+value_sqrt_1)));

          d_vdt_dV_tnode_GND =  0.0;
          vdt = (vdjt+((2*VT)*value_log_2));
        }

        d_vdcx_t_dV_tnode_GND =  0.0;
        vdcx_t = vdt;
        {
          double value_log_0 = log(((model_.vdcx)/vdcx_t));
          double value_exp_1 = exp(((model_.zcx)*value_log_0));

          d_cratio_t_dV_tnode_GND =  0.0;
          cratio_t = (1.0*value_exp_1);
        }
        if ((0==1))
        {

          d_vptcx_t_dV_tnode_GND =  0.0;
          vptcx_t = (((model_.vptcx)*vdcx_t)/(model_.vdcx));
        }
        else
        {

          d_vptcx_t_dV_tnode_GND =  0.0;
          vptcx_t = (model_.vptcx);
        }
      }
      else
      {

        d_cratio_t_dV_tnode_GND =  0.0;
        cratio_t = 1.0;

        d_vdcx_t_dV_tnode_GND =  0.0;
        vdcx_t = (model_.vdcx);

        d_vptcx_t_dV_tnode_GND =  0.0;
        vptcx_t = (model_.vptcx);
      }

      d_cjcx01_t_dV_tnode_GND =  0.0;
      cjcx01_t = (cratio_t*cjcx01);

      d_cjcx02_t_dV_tnode_GND =  0.0;
      cjcx02_t = (cratio_t*cjcx02);
      {
        double value_exp_0 = exp(((model_.zetarcx)*ln_qtt0));

        d_rcx_t_dV_tnode_GND =  0.0;
        rcx_t = ((model_.rcx)*value_exp_0);
      }
      {
        double value_exp_0 = exp(((model_.zetarbx)*ln_qtt0));

        d_rbx_t_dV_tnode_GND =  0.0;
        rbx_t = ((model_.rbx)*value_exp_0);
      }
      {
        double value_exp_0 = exp(((model_.zetare)*ln_qtt0));

        d_re_t_dV_tnode_GND =  0.0;
        re_t = ((model_.re)*value_exp_0);
      }
      {
        double value_exp_0 = exp((((model_.zetacx)-1.0)*ln_qtt0));

        d_tsf_t_dV_tnode_GND =  0.0;
        tsf_t = ((model_.tsf)*value_exp_0);
      }
      if (((model_.cjs0)>0.0))
      {
        {
          double value_exp_0 = exp((((model_.vds)*0.5)/vt0));
          double value_exp_1 = exp((((-0.5)*(model_.vds))/vt0));
          double value_log_2 = log((value_exp_0-value_exp_1));
          vdj0 = ((2*vt0)*value_log_2);
        }

        d_vdjt_dV_tnode_GND =  0.0;
        vdjt = (((vdj0*qtt0)+(vgsc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
        {
          double value_exp_0 = exp(((-vdjt)/VT));
          double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
          double value_log_2 = log((0.5*(1+value_sqrt_1)));

          d_vdt_dV_tnode_GND =  0.0;
          vdt = (vdjt+((2*VT)*value_log_2));
        }

        d_vds_t_dV_tnode_GND =  0.0;
        vds_t = vdt;
        {
          double value_log_0 = log(((model_.vds)/vds_t));
          double value_exp_1 = exp(((model_.zs)*value_log_0));

          d_cjs0_t_dV_tnode_GND =  0.0;
          cjs0_t = ((model_.cjs0)*value_exp_1);
        }
        if ((0==1))
        {

          d_vpts_t_dV_tnode_GND =  0.0;
          vpts_t = (((model_.vpts)*vds_t)/(model_.vds));
        }
        else
        {

          d_vpts_t_dV_tnode_GND =  0.0;
          vpts_t = (model_.vpts);
        }
      }
      else
      {

        d_cjs0_t_dV_tnode_GND =  0.0;
        cjs0_t = (model_.cjs0);

        d_vds_t_dV_tnode_GND =  0.0;
        vds_t = (model_.vds);

        d_vpts_t_dV_tnode_GND =  0.0;
        vpts_t = (model_.vpts);
      }
      if (((model_.vdsp)>0))
      {
        if (((model_.cscp0)>0.0))
        {
          {
            double value_exp_0 = exp((((model_.vdsp)*0.5)/vt0));
            double value_exp_1 = exp((((-0.5)*(model_.vdsp))/vt0));
            double value_log_2 = log((value_exp_0-value_exp_1));
            vdj0 = ((2*vt0)*value_log_2);
          }

          d_vdjt_dV_tnode_GND =  0.0;
          vdjt = (((vdj0*qtt0)+(vgsc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
          {
            double value_exp_0 = exp(((-vdjt)/VT));
            double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
            double value_log_2 = log((0.5*(1+value_sqrt_1)));

            d_vdt_dV_tnode_GND =  0.0;
            vdt = (vdjt+((2*VT)*value_log_2));
          }

          d_vdsp_t_dV_tnode_GND =  0.0;
          vdsp_t = vdt;
          {
            double value_log_0 = log(((model_.vdsp)/vdsp_t));
            double value_exp_1 = exp(((model_.zsp)*value_log_0));

            d_cscp0_t_dV_tnode_GND =  0.0;
            cscp0_t = ((model_.cscp0)*value_exp_1);
          }
          if ((0==1))
          {

            d_vptsp_t_dV_tnode_GND =  0.0;
            vptsp_t = (((model_.vptsp)*vdsp_t)/(model_.vdsp));
          }
          else
          {

            d_vptsp_t_dV_tnode_GND =  0.0;
            vptsp_t = (model_.vptsp);
          }
        }
        else
        {

          d_cscp0_t_dV_tnode_GND =  0.0;
          cscp0_t = (model_.cscp0);

          d_vdsp_t_dV_tnode_GND =  0.0;
          vdsp_t = (model_.vdsp);

          d_vptsp_t_dV_tnode_GND =  0.0;
          vptsp_t = (model_.vptsp);
        }
      }
      else
      {

        d_cscp0_t_dV_tnode_GND =  0.0;
        cscp0_t = (model_.cscp0);

        d_vdsp_t_dV_tnode_GND =  0.0;
        vdsp_t = (model_.vdsp);

        d_vptsp_t_dV_tnode_GND =  0.0;
        vptsp_t = (model_.vptsp);
      }
      {
        double value_exp_0 = exp(((model_.zetahjei)*ln_qtt0));

        d_ahjei_t_dV_tnode_GND =  0.0;
        ahjei_t = ((model_.ahjei)*value_exp_0);
      }
      {
        double value_log_0 = log(qtt0);
        double value_exp_1 = exp(((model_.zetavgbe)*value_log_0));
        double value_exp_2 = exp((((model_.dvgbe)/VT)*(value_exp_1-1)));

        d_hjei0_t_dV_tnode_GND =  0.0;
        hjei0_t = ((model_.hjei)*value_exp_2);
      }
      {
        double value_exp_0 = exp((((model_.dvgbe)/VT)*(qtt0-1)));

        d_hf0_t_dV_tnode_GND =  0.0;
        hf0_t = ((model_.hf0)*value_exp_0);
      }
      if (((model_.flcomp)>=2.3))
      {
        {
          double value_exp_0 = exp(((((model_.vgb)-(model_.vge))/VT)*(qtt0-1)));

          d_hfe_t_dV_tnode_GND =  0.0;
          hfe_t = ((model_.hfe)*value_exp_0);
        }
        {
          double value_exp_0 = exp(((((model_.vgb)-(model_.vgc))/VT)*(qtt0-1)));

          d_hfc_t_dV_tnode_GND =  0.0;
          hfc_t = ((model_.hfc)*value_exp_0);
        }
      }
      else
      {

        d_hfe_t_dV_tnode_GND =  0.0;
        hfe_t = (model_.hfe);

        d_hfc_t_dV_tnode_GND =  0.0;
        hfc_t = (model_.hfc);
      }
      {
        double value_exp_0 = exp(((model_.zetarth)*ln_qtt0));

        d_rth_t_dV_tnode_GND =  0.0;
        rth_t = (((model_.rth)*value_exp_0)*(1+((model_.alrth)*dT)));
      }
    }
    // End block Thermal_updat_without_self_heating
  }
  // End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    VT(0.0),
    d_VT_dV_tnode_GND(0.0),
    Tdev(0.0),
    d_Tdev_dV_tnode_GND(0.0),
    qtt0(0.0),
    d_qtt0_dV_tnode_GND(0.0),
    ln_qtt0(0.0),
    d_ln_qtt0_dV_tnode_GND(0.0),
    r_VgVT(0.0),
    d_r_VgVT_dV_tnode_GND(0.0),
    V_gT(0.0),
    d_V_gT_dV_tnode_GND(0.0),
    dT(0.0),
    d_dT_dV_tnode_GND(0.0),
    k(0.0),
    d_k_dV_tnode_GND(0.0),
    ireis_t(0.0),
    d_ireis_t_dV_tnode_GND(0.0),
    ibeis_t(0.0),
    d_ibeis_t_dV_tnode_GND(0.0),
    ibcxs_t(0.0),
    d_ibcxs_t_dV_tnode_GND(0.0),
    ibcis_t(0.0),
    d_ibcis_t_dV_tnode_GND(0.0),
    iscs_t(0.0),
    d_iscs_t_dV_tnode_GND(0.0),
    cjci0_t(0.0),
    d_cjci0_t_dV_tnode_GND(0.0),
    cjs0_t(0.0),
    d_cjs0_t_dV_tnode_GND(0.0),
    cscp0_t(0.0),
    d_cscp0_t_dV_tnode_GND(0.0),
    rci0_t(0.0),
    d_rci0_t_dV_tnode_GND(0.0),
    vlim_t(0.0),
    d_vlim_t_dV_tnode_GND(0.0),
    vces_t(0.0),
    d_vces_t_dV_tnode_GND(0.0),
    thcs_t(0.0),
    d_thcs_t_dV_tnode_GND(0.0),
    tef0_t(0.0),
    d_tef0_t_dV_tnode_GND(0.0),
    rbi0_t(0.0),
    d_rbi0_t_dV_tnode_GND(0.0),
    t0_t(0.0),
    d_t0_t_dV_tnode_GND(0.0),
    vdei_t(0.0),
    d_vdei_t_dV_tnode_GND(0.0),
    vdci_t(0.0),
    d_vdci_t_dV_tnode_GND(0.0),
    vpts_t(0.0),
    d_vpts_t_dV_tnode_GND(0.0),
    vptsp_t(0.0),
    d_vptsp_t_dV_tnode_GND(0.0),
    itss_t(0.0),
    d_itss_t_dV_tnode_GND(0.0),
    tsf_t(0.0),
    d_tsf_t_dV_tnode_GND(0.0),
    c10_t(0.0),
    d_c10_t_dV_tnode_GND(0.0),
    cjei0_t(0.0),
    d_cjei0_t_dV_tnode_GND(0.0),
    qp0_t(0.0),
    d_qp0_t_dV_tnode_GND(0.0),
    vdcx_t(0.0),
    d_vdcx_t_dV_tnode_GND(0.0),
    vptcx_t(0.0),
    d_vptcx_t_dV_tnode_GND(0.0),
    cjcx01_t(0.0),
    d_cjcx01_t_dV_tnode_GND(0.0),
    cjcx02_t(0.0),
    d_cjcx02_t_dV_tnode_GND(0.0),
    cratio_t(0.0),
    d_cratio_t_dV_tnode_GND(0.0),
    ibeps_t(0.0),
    d_ibeps_t_dV_tnode_GND(0.0),
    ireps_t(0.0),
    d_ireps_t_dV_tnode_GND(0.0),
    cjep0_t(0.0),
    d_cjep0_t_dV_tnode_GND(0.0),
    ajei_t(0.0),
    d_ajei_t_dV_tnode_GND(0.0),
    qavl_t(0.0),
    d_qavl_t_dV_tnode_GND(0.0),
    favl_t(0.0),
    d_favl_t_dV_tnode_GND(0.0),
    kavl_t(0.0),
    d_kavl_t_dV_tnode_GND(0.0),
    ibets_t(0.0),
    d_ibets_t_dV_tnode_GND(0.0),
    abet_t(0.0),
    d_abet_t_dV_tnode_GND(0.0),
    vptci_t(0.0),
    d_vptci_t_dV_tnode_GND(0.0),
    vdep_t(0.0),
    d_vdep_t_dV_tnode_GND(0.0),
    ajep_t(0.0),
    d_ajep_t_dV_tnode_GND(0.0),
    zetatef(0.0),
    k1(0.0),
    d_k1_dV_tnode_GND(0.0),
    k2(0.0),
    d_k2_dV_tnode_GND(0.0),
    dvg0(0.0),
    vge_t(0.0),
    d_vge_t_dV_tnode_GND(0.0),
    vgb_t(0.0),
    d_vgb_t_dV_tnode_GND(0.0),
    vgbe_t(0.0),
    d_vgbe_t_dV_tnode_GND(0.0),
    vds_t(0.0),
    d_vds_t_dV_tnode_GND(0.0),
    vdsp_t(0.0),
    d_vdsp_t_dV_tnode_GND(0.0),
    vt0(0.0),
    Tnom(0.0),
    Tamb(0.0),
    a(0.0),
    d_a_dV_bi_ei(0.0),
    d_a_dV_bi_ci(0.0),
    d_a_dV_tnode_GND(0.0),
    avs(0.0),
    zetabci(0.0),
    zetabcxt(0.0),
    zetasct(0.0),
    vgbe0(0.0),
    mg(0.0),
    vgbe_t0(0.0),
    vgbc0(0.0),
    vgsc0(0.0),
    cbcpar1(0.0),
    cbcpar2(0.0),
    cbepar2(0.0),
    cbepar1(0.0),
    Oich(0.0),
    Otbhrec(0.0),
    it(0.0),
    d_it_dV_tnode_GND(0.0),
    d_it_dV_bi_ei(0.0),
    d_it_dV_bi_ci(0.0),
    ibei(0.0),
    d_ibei_dV_tnode_GND(0.0),
    d_ibei_dV_bi_ei(0.0),
    ibci(0.0),
    d_ibci_dV_tnode_GND(0.0),
    d_ibci_dV_bi_ci(0.0),
    d_ibci_dV_bi_ei(0.0),
    ibep(0.0),
    d_ibep_dV_tnode_GND(0.0),
    d_ibep_dV_bp_ei(0.0),
    d_ibep_dV_bi_ci(0.0),
    d_ibep_dV_bi_ei(0.0),
    iavl(0.0),
    d_iavl_dV_tnode_GND(0.0),
    d_iavl_dV_bi_ei(0.0),
    d_iavl_dV_bi_ci(0.0),
    ijbcx(0.0),
    d_ijbcx_dV_tnode_GND(0.0),
    d_ijbcx_dV_bp_ci(0.0),
    d_ijbcx_dV_bp_ei(0.0),
    d_ijbcx_dV_bi_ci(0.0),
    d_ijbcx_dV_bi_ei(0.0),
    ijsc(0.0),
    d_ijsc_dV_tnode_GND(0.0),
    d_ijsc_dV_si_ci(0.0),
    d_ijsc_dV_bp_ci(0.0),
    d_ijsc_dV_bp_ei(0.0),
    d_ijsc_dV_bi_ci(0.0),
    d_ijsc_dV_bi_ei(0.0),
    rth_t(0.0),
    d_rth_t_dV_tnode_GND(0.0),
    vdj0(0.0),
    vdjt(0.0),
    d_vdjt_dV_tnode_GND(0.0),
    vdt(0.0),
    d_vdt_dV_tnode_GND(0.0),
    Tf(0.0),
    d_Tf_dV_bi_ei(0.0),
    d_Tf_dV_tnode_GND(0.0),
    d_Tf_dV_bi_ci(0.0),
    cjcx01(0.0),
    cjcx02(0.0),
    betadc(0.0),
    d_betadc_dV_tnode_GND(0.0),
    d_betadc_dV_bi_ei(0.0),
    d_betadc_dV_bi_ci(0.0),
    hjei0_t(0.0),
    d_hjei0_t_dV_tnode_GND(0.0),
    ahjei_t(0.0),
    d_ahjei_t_dV_tnode_GND(0.0),
    hf0_t(0.0),
    d_hf0_t_dV_tnode_GND(0.0),
    hfe_t(0.0),
    d_hfe_t_dV_tnode_GND(0.0),
    hfc_t(0.0),
    d_hfc_t_dV_tnode_GND(0.0),
    use_aval(0),
    rbx_t(0.0),
    d_rbx_t_dV_tnode_GND(0.0),
    rcx_t(0.0),
    d_rcx_t_dV_tnode_GND(0.0),
    re_t(0.0),
    d_re_t_dV_tnode_GND(0.0),
    rbi(0.0),
    d_rbi_dV_tnode_GND(0.0),
    d_rbi_dV_bi_ei(0.0),
    d_rbi_dV_bi_ci(0.0),
    li_c(-1),
    li_b(-1),
    li_e(-1),
    li_s(-1),
    li_tnode(-1),
    li_ci(-1),
    li_ei(-1),
    li_bp(-1),
    li_bi(-1),
    li_si(-1),
    li_xf1(-1),
    li_xf2(-1),
    li_xf(-1),
    li_n1(-1),
    li_n2(-1),
    li_branch_ic(-1),
    li_branch_ib(-1),
    li_branch_ie(-1),
    li_branch_is(-1),
    li_branch_itnode(-1),
    f_bi_Equ_bi_Node_Ptr(0),
    f_bi_Equ_ei_Node_Ptr(0),
    f_ei_Equ_bi_Node_Ptr(0),
    f_ei_Equ_ei_Node_Ptr(0),
    f_bi_Equ_ci_Node_Ptr(0),
    f_ci_Equ_bi_Node_Ptr(0),
    f_ci_Equ_ci_Node_Ptr(0),
    f_ci_Equ_ei_Node_Ptr(0),
    f_ei_Equ_ci_Node_Ptr(0),
    f_b_Equ_bi_Node_Ptr(0),
    f_b_Equ_ci_Node_Ptr(0),
    f_b_Equ_tnode_Node_Ptr(0),
    f_ci_Equ_tnode_Node_Ptr(0),
    f_b_Equ_bp_Node_Ptr(0),
    f_ci_Equ_bp_Node_Ptr(0),
    f_b_Equ_b_Node_Ptr(0),
    f_ci_Equ_b_Node_Ptr(0),
    f_b_Equ_ei_Node_Ptr(0),
    f_bp_Equ_bp_Node_Ptr(0),
    f_bp_Equ_ci_Node_Ptr(0),
    f_bp_Equ_tnode_Node_Ptr(0),
    f_bp_Equ_b_Node_Ptr(0),
    f_bp_Equ_bi_Node_Ptr(0),
    f_bp_Equ_ei_Node_Ptr(0),
    f_bi_Equ_tnode_Node_Ptr(0),
    f_bi_Equ_bp_Node_Ptr(0),
    f_ei_Equ_tnode_Node_Ptr(0),
    f_ei_Equ_bp_Node_Ptr(0),
    f_bi_Equ_xf_Node_Ptr(0),
    f_ei_Equ_xf_Node_Ptr(0),
    f_bp_Equ_si_Node_Ptr(0),
    f_si_Equ_si_Node_Ptr(0),
    f_si_Equ_ci_Node_Ptr(0),
    f_si_Equ_bp_Node_Ptr(0),
    f_si_Equ_tnode_Node_Ptr(0),
    f_b_Equ_e_Node_Ptr(0),
    f_e_Equ_b_Node_Ptr(0),
    f_e_Equ_e_Node_Ptr(0),
    f_bp_Equ_e_Node_Ptr(0),
    f_e_Equ_bp_Node_Ptr(0),
    f_si_Equ_bi_Node_Ptr(0),
    f_si_Equ_ei_Node_Ptr(0),
    f_ci_Equ_si_Node_Ptr(0),
    f_si_Equ_b_Node_Ptr(0),
    f_s_Equ_bi_Node_Ptr(0),
    f_s_Equ_ci_Node_Ptr(0),
    f_c_Equ_bi_Node_Ptr(0),
    f_c_Equ_ci_Node_Ptr(0),
    f_s_Equ_tnode_Node_Ptr(0),
    f_c_Equ_tnode_Node_Ptr(0),
    f_s_Equ_bp_Node_Ptr(0),
    f_c_Equ_bp_Node_Ptr(0),
    f_s_Equ_b_Node_Ptr(0),
    f_c_Equ_b_Node_Ptr(0),
    f_s_Equ_si_Node_Ptr(0),
    f_c_Equ_si_Node_Ptr(0),
    f_s_Equ_s_Node_Ptr(0),
    f_s_Equ_c_Node_Ptr(0),
    f_c_Equ_s_Node_Ptr(0),
    f_c_Equ_c_Node_Ptr(0),
    f_s_Equ_ei_Node_Ptr(0),
    f_c_Equ_ei_Node_Ptr(0),
    f_ci_Equ_xf2_Node_Ptr(0),
    f_ei_Equ_xf2_Node_Ptr(0),
    f_ci_Equ_c_Node_Ptr(0),
    f_e_Equ_tnode_Node_Ptr(0),
    f_ei_Equ_e_Node_Ptr(0),
    f_e_Equ_ei_Node_Ptr(0),
    f_si_Equ_s_Node_Ptr(0),
    f_tnode_Equ_tnode_Node_Ptr(0),
    f_tnode_Equ_bi_Node_Ptr(0),
    f_tnode_Equ_ci_Node_Ptr(0),
    f_tnode_Equ_ei_Node_Ptr(0),
    f_tnode_Equ_si_Node_Ptr(0),
    f_tnode_Equ_bp_Node_Ptr(0),
    f_tnode_Equ_e_Node_Ptr(0),
    f_tnode_Equ_c_Node_Ptr(0),
    f_tnode_Equ_b_Node_Ptr(0),
    f_xf1_Equ_bi_Node_Ptr(0),
    f_xf1_Equ_ci_Node_Ptr(0),
    f_xf1_Equ_ei_Node_Ptr(0),
    f_xf1_Equ_tnode_Node_Ptr(0),
    f_xf1_Equ_xf2_Node_Ptr(0),
    f_xf1_Equ_xf1_Node_Ptr(0),
    f_xf2_Equ_bi_Node_Ptr(0),
    f_xf2_Equ_ci_Node_Ptr(0),
    f_xf2_Equ_tnode_Node_Ptr(0),
    f_xf2_Equ_ei_Node_Ptr(0),
    f_xf2_Equ_xf1_Node_Ptr(0),
    f_xf2_Equ_xf2_Node_Ptr(0),
    f_xf_Equ_bi_Node_Ptr(0),
    f_xf_Equ_ei_Node_Ptr(0),
    f_xf_Equ_ci_Node_Ptr(0),
    f_xf_Equ_tnode_Node_Ptr(0),
    f_xf_Equ_xf_Node_Ptr(0),
    f_e_Equ_bi_Node_Ptr(0),
    f_e_Equ_ci_Node_Ptr(0),
    f_n1_Equ_bi_Node_Ptr(0),
    f_n1_Equ_ei_Node_Ptr(0),
    f_n1_Equ_tnode_Node_Ptr(0),
    f_n1_Equ_n1_Node_Ptr(0),
    f_bi_Equ_n1_Node_Ptr(0),
    f_ei_Equ_n1_Node_Ptr(0),
    f_bi_Equ_n2_Node_Ptr(0),
    f_ei_Equ_n2_Node_Ptr(0),
    f_n2_Equ_bi_Node_Ptr(0),
    f_n2_Equ_ci_Node_Ptr(0),
    f_n2_Equ_ei_Node_Ptr(0),
    f_n2_Equ_tnode_Node_Ptr(0),
    f_n2_Equ_n2_Node_Ptr(0),
    f_ci_Equ_n2_Node_Ptr(0),
    q_bi_Equ_bi_Node_Ptr(0),
    q_bi_Equ_ei_Node_Ptr(0),
    q_ei_Equ_bi_Node_Ptr(0),
    q_ei_Equ_ei_Node_Ptr(0),
    q_bi_Equ_ci_Node_Ptr(0),
    q_ci_Equ_bi_Node_Ptr(0),
    q_ci_Equ_ci_Node_Ptr(0),
    q_ci_Equ_ei_Node_Ptr(0),
    q_ei_Equ_ci_Node_Ptr(0),
    q_b_Equ_bi_Node_Ptr(0),
    q_b_Equ_ci_Node_Ptr(0),
    q_b_Equ_tnode_Node_Ptr(0),
    q_ci_Equ_tnode_Node_Ptr(0),
    q_b_Equ_bp_Node_Ptr(0),
    q_ci_Equ_bp_Node_Ptr(0),
    q_b_Equ_b_Node_Ptr(0),
    q_ci_Equ_b_Node_Ptr(0),
    q_b_Equ_ei_Node_Ptr(0),
    q_bp_Equ_bp_Node_Ptr(0),
    q_bp_Equ_ci_Node_Ptr(0),
    q_bp_Equ_tnode_Node_Ptr(0),
    q_bp_Equ_b_Node_Ptr(0),
    q_bp_Equ_bi_Node_Ptr(0),
    q_bp_Equ_ei_Node_Ptr(0),
    q_bi_Equ_tnode_Node_Ptr(0),
    q_bi_Equ_bp_Node_Ptr(0),
    q_ei_Equ_tnode_Node_Ptr(0),
    q_ei_Equ_bp_Node_Ptr(0),
    q_bi_Equ_xf_Node_Ptr(0),
    q_ei_Equ_xf_Node_Ptr(0),
    q_bp_Equ_si_Node_Ptr(0),
    q_si_Equ_si_Node_Ptr(0),
    q_si_Equ_ci_Node_Ptr(0),
    q_si_Equ_bp_Node_Ptr(0),
    q_si_Equ_tnode_Node_Ptr(0),
    q_b_Equ_e_Node_Ptr(0),
    q_e_Equ_b_Node_Ptr(0),
    q_e_Equ_e_Node_Ptr(0),
    q_bp_Equ_e_Node_Ptr(0),
    q_e_Equ_bp_Node_Ptr(0),
    q_si_Equ_bi_Node_Ptr(0),
    q_si_Equ_ei_Node_Ptr(0),
    q_ci_Equ_si_Node_Ptr(0),
    q_si_Equ_b_Node_Ptr(0),
    q_s_Equ_bi_Node_Ptr(0),
    q_s_Equ_ci_Node_Ptr(0),
    q_c_Equ_bi_Node_Ptr(0),
    q_c_Equ_ci_Node_Ptr(0),
    q_s_Equ_tnode_Node_Ptr(0),
    q_c_Equ_tnode_Node_Ptr(0),
    q_s_Equ_bp_Node_Ptr(0),
    q_c_Equ_bp_Node_Ptr(0),
    q_s_Equ_b_Node_Ptr(0),
    q_c_Equ_b_Node_Ptr(0),
    q_s_Equ_si_Node_Ptr(0),
    q_c_Equ_si_Node_Ptr(0),
    q_s_Equ_s_Node_Ptr(0),
    q_s_Equ_c_Node_Ptr(0),
    q_c_Equ_s_Node_Ptr(0),
    q_c_Equ_c_Node_Ptr(0),
    q_s_Equ_ei_Node_Ptr(0),
    q_c_Equ_ei_Node_Ptr(0),
    q_ci_Equ_xf2_Node_Ptr(0),
    q_ei_Equ_xf2_Node_Ptr(0),
    q_ci_Equ_c_Node_Ptr(0),
    q_e_Equ_tnode_Node_Ptr(0),
    q_ei_Equ_e_Node_Ptr(0),
    q_e_Equ_ei_Node_Ptr(0),
    q_si_Equ_s_Node_Ptr(0),
    q_tnode_Equ_tnode_Node_Ptr(0),
    q_tnode_Equ_bi_Node_Ptr(0),
    q_tnode_Equ_ci_Node_Ptr(0),
    q_tnode_Equ_ei_Node_Ptr(0),
    q_tnode_Equ_si_Node_Ptr(0),
    q_tnode_Equ_bp_Node_Ptr(0),
    q_tnode_Equ_e_Node_Ptr(0),
    q_tnode_Equ_c_Node_Ptr(0),
    q_tnode_Equ_b_Node_Ptr(0),
    q_xf1_Equ_bi_Node_Ptr(0),
    q_xf1_Equ_ci_Node_Ptr(0),
    q_xf1_Equ_ei_Node_Ptr(0),
    q_xf1_Equ_tnode_Node_Ptr(0),
    q_xf1_Equ_xf2_Node_Ptr(0),
    q_xf1_Equ_xf1_Node_Ptr(0),
    q_xf2_Equ_bi_Node_Ptr(0),
    q_xf2_Equ_ci_Node_Ptr(0),
    q_xf2_Equ_tnode_Node_Ptr(0),
    q_xf2_Equ_ei_Node_Ptr(0),
    q_xf2_Equ_xf1_Node_Ptr(0),
    q_xf2_Equ_xf2_Node_Ptr(0),
    q_xf_Equ_bi_Node_Ptr(0),
    q_xf_Equ_ei_Node_Ptr(0),
    q_xf_Equ_ci_Node_Ptr(0),
    q_xf_Equ_tnode_Node_Ptr(0),
    q_xf_Equ_xf_Node_Ptr(0),
    q_e_Equ_bi_Node_Ptr(0),
    q_e_Equ_ci_Node_Ptr(0),
    q_n1_Equ_bi_Node_Ptr(0),
    q_n1_Equ_ei_Node_Ptr(0),
    q_n1_Equ_tnode_Node_Ptr(0),
    q_n1_Equ_n1_Node_Ptr(0),
    q_bi_Equ_n1_Node_Ptr(0),
    q_ei_Equ_n1_Node_Ptr(0),
    q_bi_Equ_n2_Node_Ptr(0),
    q_ei_Equ_n2_Node_Ptr(0),
    q_n2_Equ_bi_Node_Ptr(0),
    q_n2_Equ_ci_Node_Ptr(0),
    q_n2_Equ_ei_Node_Ptr(0),
    q_n2_Equ_tnode_Node_Ptr(0),
    q_n2_Equ_n2_Node_Ptr(0),
    q_ci_Equ_n2_Node_Ptr(0),
    A_bi_Equ_bi_NodeOffset(-1),
    A_bi_Equ_ei_NodeOffset(-1),
    A_ei_Equ_bi_NodeOffset(-1),
    A_ei_Equ_ei_NodeOffset(-1),
    A_bi_Equ_ci_NodeOffset(-1),
    A_ci_Equ_bi_NodeOffset(-1),
    A_ci_Equ_ci_NodeOffset(-1),
    A_ci_Equ_ei_NodeOffset(-1),
    A_ei_Equ_ci_NodeOffset(-1),
    A_b_Equ_bi_NodeOffset(-1),
    A_b_Equ_ci_NodeOffset(-1),
    A_b_Equ_tnode_NodeOffset(-1),
    A_ci_Equ_tnode_NodeOffset(-1),
    A_b_Equ_bp_NodeOffset(-1),
    A_ci_Equ_bp_NodeOffset(-1),
    A_b_Equ_b_NodeOffset(-1),
    A_ci_Equ_b_NodeOffset(-1),
    A_b_Equ_ei_NodeOffset(-1),
    A_bp_Equ_bp_NodeOffset(-1),
    A_bp_Equ_ci_NodeOffset(-1),
    A_bp_Equ_tnode_NodeOffset(-1),
    A_bp_Equ_b_NodeOffset(-1),
    A_bp_Equ_bi_NodeOffset(-1),
    A_bp_Equ_ei_NodeOffset(-1),
    A_bi_Equ_tnode_NodeOffset(-1),
    A_bi_Equ_bp_NodeOffset(-1),
    A_ei_Equ_tnode_NodeOffset(-1),
    A_ei_Equ_bp_NodeOffset(-1),
    A_bi_Equ_xf_NodeOffset(-1),
    A_ei_Equ_xf_NodeOffset(-1),
    A_bp_Equ_si_NodeOffset(-1),
    A_si_Equ_si_NodeOffset(-1),
    A_si_Equ_ci_NodeOffset(-1),
    A_si_Equ_bp_NodeOffset(-1),
    A_si_Equ_tnode_NodeOffset(-1),
    A_b_Equ_e_NodeOffset(-1),
    A_e_Equ_b_NodeOffset(-1),
    A_e_Equ_e_NodeOffset(-1),
    A_bp_Equ_e_NodeOffset(-1),
    A_e_Equ_bp_NodeOffset(-1),
    A_si_Equ_bi_NodeOffset(-1),
    A_si_Equ_ei_NodeOffset(-1),
    A_ci_Equ_si_NodeOffset(-1),
    A_si_Equ_b_NodeOffset(-1),
    A_s_Equ_bi_NodeOffset(-1),
    A_s_Equ_ci_NodeOffset(-1),
    A_c_Equ_bi_NodeOffset(-1),
    A_c_Equ_ci_NodeOffset(-1),
    A_s_Equ_tnode_NodeOffset(-1),
    A_c_Equ_tnode_NodeOffset(-1),
    A_s_Equ_bp_NodeOffset(-1),
    A_c_Equ_bp_NodeOffset(-1),
    A_s_Equ_b_NodeOffset(-1),
    A_c_Equ_b_NodeOffset(-1),
    A_s_Equ_si_NodeOffset(-1),
    A_c_Equ_si_NodeOffset(-1),
    A_s_Equ_s_NodeOffset(-1),
    A_s_Equ_c_NodeOffset(-1),
    A_c_Equ_s_NodeOffset(-1),
    A_c_Equ_c_NodeOffset(-1),
    A_s_Equ_ei_NodeOffset(-1),
    A_c_Equ_ei_NodeOffset(-1),
    A_ci_Equ_xf2_NodeOffset(-1),
    A_ei_Equ_xf2_NodeOffset(-1),
    A_ci_Equ_c_NodeOffset(-1),
    A_e_Equ_tnode_NodeOffset(-1),
    A_ei_Equ_e_NodeOffset(-1),
    A_e_Equ_ei_NodeOffset(-1),
    A_si_Equ_s_NodeOffset(-1),
    A_tnode_Equ_tnode_NodeOffset(-1),
    A_tnode_Equ_bi_NodeOffset(-1),
    A_tnode_Equ_ci_NodeOffset(-1),
    A_tnode_Equ_ei_NodeOffset(-1),
    A_tnode_Equ_si_NodeOffset(-1),
    A_tnode_Equ_bp_NodeOffset(-1),
    A_tnode_Equ_e_NodeOffset(-1),
    A_tnode_Equ_c_NodeOffset(-1),
    A_tnode_Equ_b_NodeOffset(-1),
    A_xf1_Equ_bi_NodeOffset(-1),
    A_xf1_Equ_ci_NodeOffset(-1),
    A_xf1_Equ_ei_NodeOffset(-1),
    A_xf1_Equ_tnode_NodeOffset(-1),
    A_xf1_Equ_xf2_NodeOffset(-1),
    A_xf1_Equ_xf1_NodeOffset(-1),
    A_xf2_Equ_bi_NodeOffset(-1),
    A_xf2_Equ_ci_NodeOffset(-1),
    A_xf2_Equ_tnode_NodeOffset(-1),
    A_xf2_Equ_ei_NodeOffset(-1),
    A_xf2_Equ_xf1_NodeOffset(-1),
    A_xf2_Equ_xf2_NodeOffset(-1),
    A_xf_Equ_bi_NodeOffset(-1),
    A_xf_Equ_ei_NodeOffset(-1),
    A_xf_Equ_ci_NodeOffset(-1),
    A_xf_Equ_tnode_NodeOffset(-1),
    A_xf_Equ_xf_NodeOffset(-1),
    A_e_Equ_bi_NodeOffset(-1),
    A_e_Equ_ci_NodeOffset(-1),
    A_n1_Equ_bi_NodeOffset(-1),
    A_n1_Equ_ei_NodeOffset(-1),
    A_n1_Equ_tnode_NodeOffset(-1),
    A_n1_Equ_n1_NodeOffset(-1),
    A_bi_Equ_n1_NodeOffset(-1),
    A_ei_Equ_n1_NodeOffset(-1),
    A_bi_Equ_n2_NodeOffset(-1),
    A_ei_Equ_n2_NodeOffset(-1),
    A_n2_Equ_bi_NodeOffset(-1),
    A_n2_Equ_ci_NodeOffset(-1),
    A_n2_Equ_ei_NodeOffset(-1),
    A_n2_Equ_tnode_NodeOffset(-1),
    A_n2_Equ_n2_NodeOffset(-1),
    A_ci_Equ_n2_NodeOffset(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
  numIntVars = 10 + 0;
  numExtVars = 5;


  // Right now, we only have store for limited probes...
  setNumStoreVars(0);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 5;

  leadCurrentF.resize(5);
  leadCurrentQ.resize(5);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_xf2));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_c));
  jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_n2));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_xf));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_xf2));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_n1));
  jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_n2));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_e));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_xf));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_n1));
  jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_n2));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_si));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_bp));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_b));
  jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_s));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_xf2));
  jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_xf1));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_xf1));
  jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_xf2));
  jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_xf));
  jacobianElements.push_back(IntPair(admsNodeID_n1,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_n1,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_n1,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_n1,admsNodeID_n1));
  jacobianElements.push_back(IntPair(admsNodeID_n2,admsNodeID_bi));
  jacobianElements.push_back(IntPair(admsNodeID_n2,admsNodeID_ci));
  jacobianElements.push_back(IntPair(admsNodeID_n2,admsNodeID_ei));
  jacobianElements.push_back(IntPair(admsNodeID_n2,admsNodeID_tnode));
  jacobianElements.push_back(IntPair(admsNodeID_n2,admsNodeID_n2));



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_ci)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_ci,admsNodeID_c));
  }
  if (collapseNode_ei)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_ei,admsNodeID_e));
  }
  if (collapseNode_bp)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_bp,admsNodeID_b));
  }
  if (collapseNode_bi)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_bi,admsNodeID_bp));
  }
  if (collapseNode_si)
  {
    collapsedNodes.push_back(IntPair(admsNodeID_si,admsNodeID_s));
  }

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 15+0;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
  collapseNode_ci = false;
  collapseNode_ei = false;
  collapseNode_bp = false;
  collapseNode_bi = false;
  collapseNode_si = false;
  // begin block named Load_sources

  if (!(((model_.rbx)>=0.001)))
  {

    collapseNode_bp = true;

  }

  if (!(((model_.rbi0)>=0.001)))
  {

    collapseNode_bi = true;

  }

  if (!(((model_.rcx)>=0.001)))
  {

    collapseNode_ci = true;

  }

  if (!(((model_.re)>=0.001)))
  {

    collapseNode_ei = true;

  }

  if (!(((model_.rsu)>=0.001)))
  {

    collapseNode_si = true;

  }

  // end block  named Load_sources


  if (collapseNode_ci)
  {
    numIntVars--;
  }
  if (collapseNode_ei)
  {
    numIntVars--;
  }
  if (collapseNode_bp)
  {
    numIntVars--;
  }
  if (collapseNode_bi)
  {
    numIntVars--;
  }
  if (collapseNode_si)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMShicumL2va::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_c = localLIDVec[nodeMap[admsNodeID_c]];
  li_b = localLIDVec[nodeMap[admsNodeID_b]];
  li_e = localLIDVec[nodeMap[admsNodeID_e]];
  li_s = localLIDVec[nodeMap[admsNodeID_s]];
  li_tnode = localLIDVec[nodeMap[admsNodeID_tnode]];
  li_ci = localLIDVec[nodeMap[admsNodeID_ci]];
  li_ei = localLIDVec[nodeMap[admsNodeID_ei]];
  li_bp = localLIDVec[nodeMap[admsNodeID_bp]];
  li_bi = localLIDVec[nodeMap[admsNodeID_bi]];
  li_si = localLIDVec[nodeMap[admsNodeID_si]];
  li_xf1 = localLIDVec[nodeMap[admsNodeID_xf1]];
  li_xf2 = localLIDVec[nodeMap[admsNodeID_xf2]];
  li_xf = localLIDVec[nodeMap[admsNodeID_xf]];
  li_n1 = localLIDVec[nodeMap[admsNodeID_n1]];
  li_n2 = localLIDVec[nodeMap[admsNodeID_n2]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_c = " << li_c << std::endl;
    Xyce::dout() << "\nli_b = " << li_b << std::endl;
    Xyce::dout() << "\nli_e = " << li_e << std::endl;
    Xyce::dout() << "\nli_s = " << li_s << std::endl;
    Xyce::dout() << "\nli_tnode = " << li_tnode << std::endl;
    Xyce::dout() << "\nli_ci = " << li_ci << std::endl;
    Xyce::dout() << "\nli_ei = " << li_ei << std::endl;
    Xyce::dout() << "\nli_bp = " << li_bp << std::endl;
    Xyce::dout() << "\nli_bi = " << li_bi << std::endl;
    Xyce::dout() << "\nli_si = " << li_si << std::endl;
    Xyce::dout() << "\nli_xf1 = " << li_xf1 << std::endl;
    Xyce::dout() << "\nli_xf2 = " << li_xf2 << std::endl;
    Xyce::dout() << "\nli_xf = " << li_xf << std::endl;
    Xyce::dout() << "\nli_n1 = " << li_n1 << std::endl;
    Xyce::dout() << "\nli_n2 = " << li_n2 << std::endl;

    Xyce::dout() << "\nEnd of ADMShicumL2va::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
  if (!collapseNode_ci)
  {
    addInternalNode(symbol_table, li_ci, getName(), "ci");
  }
  if (!collapseNode_ei)
  {
    addInternalNode(symbol_table, li_ei, getName(), "ei");
  }
  if (!collapseNode_bp)
  {
    addInternalNode(symbol_table, li_bp, getName(), "bp");
  }
  if (!collapseNode_bi)
  {
    addInternalNode(symbol_table, li_bi, getName(), "bi");
  }
  if (!collapseNode_si)
  {
    addInternalNode(symbol_table, li_si, getName(), "si");
  }
  addInternalNode(symbol_table, li_xf1, getName(), "xf1");
  addInternalNode(symbol_table, li_xf2, getName(), "xf2");
  addInternalNode(symbol_table, li_xf, getName(), "xf");
  addInternalNode(symbol_table, li_n1, getName(), "n1");
  addInternalNode(symbol_table, li_n2, getName(), "n2");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_ic, getName(), "BRANCH_DC");
    addBranchDataNode( symbol_table, li_branch_ib, getName(), "BRANCH_DB");
    addBranchDataNode( symbol_table, li_branch_ie, getName(), "BRANCH_DE");
    addBranchDataNode( symbol_table, li_branch_is, getName(), "BRANCH_D4");
    addBranchDataNode( symbol_table, li_branch_itnode, getName(), "BRANCH_D5");
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    int i = 0;
    li_branch_ic = branchLIDVecRef[i++];
    li_branch_ib = branchLIDVecRef[i++];
    li_branch_ie = branchLIDVecRef[i++];
    li_branch_is = branchLIDVecRef[i++];
    li_branch_itnode = branchLIDVecRef[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_bi)];
  A_c_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_ci)];
  A_c_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_tnode)];
  A_c_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_bp)];
  A_c_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b)];
  A_c_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_si)];
  A_c_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_s)];
  A_c_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c)];
  A_c_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_ei)];
  A_c_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_bi)];
  A_b_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_ci)];
  A_b_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_tnode)];
  A_b_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_bp)];
  A_b_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b)];
  A_b_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_ei)];
  A_b_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_e)];
  A_b_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_b)];
  A_e_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_e)];
  A_e_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_bp)];
  A_e_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_tnode)];
  A_e_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_ei)];
  A_e_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_bi)];
  A_e_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_ci)];
  A_e_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_bi)];
  A_s_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_ci)];
  A_s_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_tnode)];
  A_s_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_bp)];
  A_s_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b)];
  A_s_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_si)];
  A_s_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_s)];
  A_s_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c)];
  A_s_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_ei)];
  A_s_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_tnode)];
  A_tnode_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_bi)];
  A_tnode_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_ci)];
  A_tnode_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_ei)];
  A_tnode_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_si)];
  A_tnode_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_bp)];
  A_tnode_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_e)];
  A_tnode_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_c)];
  A_tnode_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_b)];
  A_tnode_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_bi)];
  A_ci_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_ci)];
  A_ci_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_ei)];
  A_ci_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_tnode)];
  A_ci_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_bp)];
  A_ci_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_b)];
  A_ci_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_si)];
  A_ci_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_xf2)];
  A_ci_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_c)];
  A_ci_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_n2)];
  A_ci_Equ_n2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_bi)];
  A_ei_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ei)];
  A_ei_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ci)];
  A_ei_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_tnode)];
  A_ei_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_bp)];
  A_ei_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_xf)];
  A_ei_Equ_xf_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_xf2)];
  A_ei_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_e)];
  A_ei_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_n1)];
  A_ei_Equ_n1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_n2)];
  A_ei_Equ_n2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_bp)];
  A_bp_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_ci)];
  A_bp_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_tnode)];
  A_bp_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_b)];
  A_bp_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_bi)];
  A_bp_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_ei)];
  A_bp_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_si)];
  A_bp_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_e)];
  A_bp_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bi)];
  A_bi_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_ei)];
  A_bi_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_ci)];
  A_bi_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_tnode)];
  A_bi_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bp)];
  A_bi_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_xf)];
  A_bi_Equ_xf_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_n1)];
  A_bi_Equ_n1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_n2)];
  A_bi_Equ_n2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_si)];
  A_si_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_ci)];
  A_si_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_bp)];
  A_si_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_tnode)];
  A_si_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_bi)];
  A_si_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_ei)];
  A_si_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_b)];
  A_si_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_s)];
  A_si_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_bi)];
  A_xf1_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_ci)];
  A_xf1_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_ei)];
  A_xf1_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_tnode)];
  A_xf1_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_xf2)];
  A_xf1_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_xf1)];
  A_xf1_Equ_xf1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_bi)];
  A_xf2_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_ci)];
  A_xf2_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_tnode)];
  A_xf2_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_ei)];
  A_xf2_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_xf1)];
  A_xf2_Equ_xf1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_xf2)];
  A_xf2_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_bi)];
  A_xf_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_ei)];
  A_xf_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_ci)];
  A_xf_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_tnode)];
  A_xf_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_xf)];
  A_xf_Equ_xf_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_n1,admsNodeID_bi)];
  A_n1_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_n1,admsNodeID_ei)];
  A_n1_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_n1,admsNodeID_tnode)];
  A_n1_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_n1,admsNodeID_n1)];
  A_n1_Equ_n1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_n2,admsNodeID_bi)];
  A_n2_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_n2,admsNodeID_ci)];
  A_n2_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_n2,admsNodeID_ei)];
  A_n2_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_n2,admsNodeID_tnode)];
  A_n2_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_n2,admsNodeID_n2)];
  A_n2_Equ_n2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
  f_c_Equ_bi_Node_Ptr = &(dFdx[li_c][A_c_Equ_bi_NodeOffset]);
  q_c_Equ_bi_Node_Ptr = &(dQdx[li_c][A_c_Equ_bi_NodeOffset]);
  f_c_Equ_ci_Node_Ptr = &(dFdx[li_c][A_c_Equ_ci_NodeOffset]);
  q_c_Equ_ci_Node_Ptr = &(dQdx[li_c][A_c_Equ_ci_NodeOffset]);
  f_c_Equ_tnode_Node_Ptr = &(dFdx[li_c][A_c_Equ_tnode_NodeOffset]);
  q_c_Equ_tnode_Node_Ptr = &(dQdx[li_c][A_c_Equ_tnode_NodeOffset]);
  f_c_Equ_bp_Node_Ptr = &(dFdx[li_c][A_c_Equ_bp_NodeOffset]);
  q_c_Equ_bp_Node_Ptr = &(dQdx[li_c][A_c_Equ_bp_NodeOffset]);
  f_c_Equ_b_Node_Ptr = &(dFdx[li_c][A_c_Equ_b_NodeOffset]);
  q_c_Equ_b_Node_Ptr = &(dQdx[li_c][A_c_Equ_b_NodeOffset]);
  f_c_Equ_si_Node_Ptr = &(dFdx[li_c][A_c_Equ_si_NodeOffset]);
  q_c_Equ_si_Node_Ptr = &(dQdx[li_c][A_c_Equ_si_NodeOffset]);
  f_c_Equ_s_Node_Ptr = &(dFdx[li_c][A_c_Equ_s_NodeOffset]);
  q_c_Equ_s_Node_Ptr = &(dQdx[li_c][A_c_Equ_s_NodeOffset]);
  f_c_Equ_c_Node_Ptr = &(dFdx[li_c][A_c_Equ_c_NodeOffset]);
  q_c_Equ_c_Node_Ptr = &(dQdx[li_c][A_c_Equ_c_NodeOffset]);
  f_c_Equ_ei_Node_Ptr = &(dFdx[li_c][A_c_Equ_ei_NodeOffset]);
  q_c_Equ_ei_Node_Ptr = &(dQdx[li_c][A_c_Equ_ei_NodeOffset]);
  f_b_Equ_bi_Node_Ptr = &(dFdx[li_b][A_b_Equ_bi_NodeOffset]);
  q_b_Equ_bi_Node_Ptr = &(dQdx[li_b][A_b_Equ_bi_NodeOffset]);
  f_b_Equ_ci_Node_Ptr = &(dFdx[li_b][A_b_Equ_ci_NodeOffset]);
  q_b_Equ_ci_Node_Ptr = &(dQdx[li_b][A_b_Equ_ci_NodeOffset]);
  f_b_Equ_tnode_Node_Ptr = &(dFdx[li_b][A_b_Equ_tnode_NodeOffset]);
  q_b_Equ_tnode_Node_Ptr = &(dQdx[li_b][A_b_Equ_tnode_NodeOffset]);
  f_b_Equ_bp_Node_Ptr = &(dFdx[li_b][A_b_Equ_bp_NodeOffset]);
  q_b_Equ_bp_Node_Ptr = &(dQdx[li_b][A_b_Equ_bp_NodeOffset]);
  f_b_Equ_b_Node_Ptr = &(dFdx[li_b][A_b_Equ_b_NodeOffset]);
  q_b_Equ_b_Node_Ptr = &(dQdx[li_b][A_b_Equ_b_NodeOffset]);
  f_b_Equ_ei_Node_Ptr = &(dFdx[li_b][A_b_Equ_ei_NodeOffset]);
  q_b_Equ_ei_Node_Ptr = &(dQdx[li_b][A_b_Equ_ei_NodeOffset]);
  f_b_Equ_e_Node_Ptr = &(dFdx[li_b][A_b_Equ_e_NodeOffset]);
  q_b_Equ_e_Node_Ptr = &(dQdx[li_b][A_b_Equ_e_NodeOffset]);
  f_e_Equ_b_Node_Ptr = &(dFdx[li_e][A_e_Equ_b_NodeOffset]);
  q_e_Equ_b_Node_Ptr = &(dQdx[li_e][A_e_Equ_b_NodeOffset]);
  f_e_Equ_e_Node_Ptr = &(dFdx[li_e][A_e_Equ_e_NodeOffset]);
  q_e_Equ_e_Node_Ptr = &(dQdx[li_e][A_e_Equ_e_NodeOffset]);
  f_e_Equ_bp_Node_Ptr = &(dFdx[li_e][A_e_Equ_bp_NodeOffset]);
  q_e_Equ_bp_Node_Ptr = &(dQdx[li_e][A_e_Equ_bp_NodeOffset]);
  f_e_Equ_tnode_Node_Ptr = &(dFdx[li_e][A_e_Equ_tnode_NodeOffset]);
  q_e_Equ_tnode_Node_Ptr = &(dQdx[li_e][A_e_Equ_tnode_NodeOffset]);
  f_e_Equ_ei_Node_Ptr = &(dFdx[li_e][A_e_Equ_ei_NodeOffset]);
  q_e_Equ_ei_Node_Ptr = &(dQdx[li_e][A_e_Equ_ei_NodeOffset]);
  f_e_Equ_bi_Node_Ptr = &(dFdx[li_e][A_e_Equ_bi_NodeOffset]);
  q_e_Equ_bi_Node_Ptr = &(dQdx[li_e][A_e_Equ_bi_NodeOffset]);
  f_e_Equ_ci_Node_Ptr = &(dFdx[li_e][A_e_Equ_ci_NodeOffset]);
  q_e_Equ_ci_Node_Ptr = &(dQdx[li_e][A_e_Equ_ci_NodeOffset]);
  f_s_Equ_bi_Node_Ptr = &(dFdx[li_s][A_s_Equ_bi_NodeOffset]);
  q_s_Equ_bi_Node_Ptr = &(dQdx[li_s][A_s_Equ_bi_NodeOffset]);
  f_s_Equ_ci_Node_Ptr = &(dFdx[li_s][A_s_Equ_ci_NodeOffset]);
  q_s_Equ_ci_Node_Ptr = &(dQdx[li_s][A_s_Equ_ci_NodeOffset]);
  f_s_Equ_tnode_Node_Ptr = &(dFdx[li_s][A_s_Equ_tnode_NodeOffset]);
  q_s_Equ_tnode_Node_Ptr = &(dQdx[li_s][A_s_Equ_tnode_NodeOffset]);
  f_s_Equ_bp_Node_Ptr = &(dFdx[li_s][A_s_Equ_bp_NodeOffset]);
  q_s_Equ_bp_Node_Ptr = &(dQdx[li_s][A_s_Equ_bp_NodeOffset]);
  f_s_Equ_b_Node_Ptr = &(dFdx[li_s][A_s_Equ_b_NodeOffset]);
  q_s_Equ_b_Node_Ptr = &(dQdx[li_s][A_s_Equ_b_NodeOffset]);
  f_s_Equ_si_Node_Ptr = &(dFdx[li_s][A_s_Equ_si_NodeOffset]);
  q_s_Equ_si_Node_Ptr = &(dQdx[li_s][A_s_Equ_si_NodeOffset]);
  f_s_Equ_s_Node_Ptr = &(dFdx[li_s][A_s_Equ_s_NodeOffset]);
  q_s_Equ_s_Node_Ptr = &(dQdx[li_s][A_s_Equ_s_NodeOffset]);
  f_s_Equ_c_Node_Ptr = &(dFdx[li_s][A_s_Equ_c_NodeOffset]);
  q_s_Equ_c_Node_Ptr = &(dQdx[li_s][A_s_Equ_c_NodeOffset]);
  f_s_Equ_ei_Node_Ptr = &(dFdx[li_s][A_s_Equ_ei_NodeOffset]);
  q_s_Equ_ei_Node_Ptr = &(dQdx[li_s][A_s_Equ_ei_NodeOffset]);
  f_tnode_Equ_tnode_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_tnode_NodeOffset]);
  q_tnode_Equ_tnode_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_tnode_NodeOffset]);
  f_tnode_Equ_bi_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_bi_NodeOffset]);
  q_tnode_Equ_bi_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_bi_NodeOffset]);
  f_tnode_Equ_ci_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_ci_NodeOffset]);
  q_tnode_Equ_ci_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_ci_NodeOffset]);
  f_tnode_Equ_ei_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_ei_NodeOffset]);
  q_tnode_Equ_ei_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_ei_NodeOffset]);
  f_tnode_Equ_si_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_si_NodeOffset]);
  q_tnode_Equ_si_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_si_NodeOffset]);
  f_tnode_Equ_bp_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_bp_NodeOffset]);
  q_tnode_Equ_bp_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_bp_NodeOffset]);
  f_tnode_Equ_e_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_e_NodeOffset]);
  q_tnode_Equ_e_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_e_NodeOffset]);
  f_tnode_Equ_c_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_c_NodeOffset]);
  q_tnode_Equ_c_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_c_NodeOffset]);
  f_tnode_Equ_b_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_b_NodeOffset]);
  q_tnode_Equ_b_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_b_NodeOffset]);
  f_ci_Equ_bi_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_bi_NodeOffset]);
  q_ci_Equ_bi_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_bi_NodeOffset]);
  f_ci_Equ_ci_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_ci_NodeOffset]);
  q_ci_Equ_ci_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_ci_NodeOffset]);
  f_ci_Equ_ei_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_ei_NodeOffset]);
  q_ci_Equ_ei_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_ei_NodeOffset]);
  f_ci_Equ_tnode_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_tnode_NodeOffset]);
  q_ci_Equ_tnode_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_tnode_NodeOffset]);
  f_ci_Equ_bp_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_bp_NodeOffset]);
  q_ci_Equ_bp_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_bp_NodeOffset]);
  f_ci_Equ_b_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_b_NodeOffset]);
  q_ci_Equ_b_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_b_NodeOffset]);
  f_ci_Equ_si_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_si_NodeOffset]);
  q_ci_Equ_si_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_si_NodeOffset]);
  f_ci_Equ_xf2_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_xf2_NodeOffset]);
  q_ci_Equ_xf2_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_xf2_NodeOffset]);
  f_ci_Equ_c_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_c_NodeOffset]);
  q_ci_Equ_c_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_c_NodeOffset]);
  f_ci_Equ_n2_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_n2_NodeOffset]);
  q_ci_Equ_n2_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_n2_NodeOffset]);
  f_ei_Equ_bi_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_bi_NodeOffset]);
  q_ei_Equ_bi_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_bi_NodeOffset]);
  f_ei_Equ_ei_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_ei_NodeOffset]);
  q_ei_Equ_ei_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_ei_NodeOffset]);
  f_ei_Equ_ci_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_ci_NodeOffset]);
  q_ei_Equ_ci_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_ci_NodeOffset]);
  f_ei_Equ_tnode_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_tnode_NodeOffset]);
  q_ei_Equ_tnode_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_tnode_NodeOffset]);
  f_ei_Equ_bp_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_bp_NodeOffset]);
  q_ei_Equ_bp_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_bp_NodeOffset]);
  f_ei_Equ_xf_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_xf_NodeOffset]);
  q_ei_Equ_xf_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_xf_NodeOffset]);
  f_ei_Equ_xf2_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_xf2_NodeOffset]);
  q_ei_Equ_xf2_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_xf2_NodeOffset]);
  f_ei_Equ_e_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_e_NodeOffset]);
  q_ei_Equ_e_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_e_NodeOffset]);
  f_ei_Equ_n1_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_n1_NodeOffset]);
  q_ei_Equ_n1_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_n1_NodeOffset]);
  f_ei_Equ_n2_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_n2_NodeOffset]);
  q_ei_Equ_n2_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_n2_NodeOffset]);
  f_bp_Equ_bp_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_bp_NodeOffset]);
  q_bp_Equ_bp_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_bp_NodeOffset]);
  f_bp_Equ_ci_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_ci_NodeOffset]);
  q_bp_Equ_ci_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_ci_NodeOffset]);
  f_bp_Equ_tnode_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_tnode_NodeOffset]);
  q_bp_Equ_tnode_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_tnode_NodeOffset]);
  f_bp_Equ_b_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_b_NodeOffset]);
  q_bp_Equ_b_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_b_NodeOffset]);
  f_bp_Equ_bi_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_bi_NodeOffset]);
  q_bp_Equ_bi_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_bi_NodeOffset]);
  f_bp_Equ_ei_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_ei_NodeOffset]);
  q_bp_Equ_ei_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_ei_NodeOffset]);
  f_bp_Equ_si_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_si_NodeOffset]);
  q_bp_Equ_si_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_si_NodeOffset]);
  f_bp_Equ_e_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_e_NodeOffset]);
  q_bp_Equ_e_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_e_NodeOffset]);
  f_bi_Equ_bi_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_bi_NodeOffset]);
  q_bi_Equ_bi_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_bi_NodeOffset]);
  f_bi_Equ_ei_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_ei_NodeOffset]);
  q_bi_Equ_ei_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_ei_NodeOffset]);
  f_bi_Equ_ci_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_ci_NodeOffset]);
  q_bi_Equ_ci_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_ci_NodeOffset]);
  f_bi_Equ_tnode_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_tnode_NodeOffset]);
  q_bi_Equ_tnode_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_tnode_NodeOffset]);
  f_bi_Equ_bp_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_bp_NodeOffset]);
  q_bi_Equ_bp_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_bp_NodeOffset]);
  f_bi_Equ_xf_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_xf_NodeOffset]);
  q_bi_Equ_xf_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_xf_NodeOffset]);
  f_bi_Equ_n1_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_n1_NodeOffset]);
  q_bi_Equ_n1_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_n1_NodeOffset]);
  f_bi_Equ_n2_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_n2_NodeOffset]);
  q_bi_Equ_n2_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_n2_NodeOffset]);
  f_si_Equ_si_Node_Ptr = &(dFdx[li_si][A_si_Equ_si_NodeOffset]);
  q_si_Equ_si_Node_Ptr = &(dQdx[li_si][A_si_Equ_si_NodeOffset]);
  f_si_Equ_ci_Node_Ptr = &(dFdx[li_si][A_si_Equ_ci_NodeOffset]);
  q_si_Equ_ci_Node_Ptr = &(dQdx[li_si][A_si_Equ_ci_NodeOffset]);
  f_si_Equ_bp_Node_Ptr = &(dFdx[li_si][A_si_Equ_bp_NodeOffset]);
  q_si_Equ_bp_Node_Ptr = &(dQdx[li_si][A_si_Equ_bp_NodeOffset]);
  f_si_Equ_tnode_Node_Ptr = &(dFdx[li_si][A_si_Equ_tnode_NodeOffset]);
  q_si_Equ_tnode_Node_Ptr = &(dQdx[li_si][A_si_Equ_tnode_NodeOffset]);
  f_si_Equ_bi_Node_Ptr = &(dFdx[li_si][A_si_Equ_bi_NodeOffset]);
  q_si_Equ_bi_Node_Ptr = &(dQdx[li_si][A_si_Equ_bi_NodeOffset]);
  f_si_Equ_ei_Node_Ptr = &(dFdx[li_si][A_si_Equ_ei_NodeOffset]);
  q_si_Equ_ei_Node_Ptr = &(dQdx[li_si][A_si_Equ_ei_NodeOffset]);
  f_si_Equ_b_Node_Ptr = &(dFdx[li_si][A_si_Equ_b_NodeOffset]);
  q_si_Equ_b_Node_Ptr = &(dQdx[li_si][A_si_Equ_b_NodeOffset]);
  f_si_Equ_s_Node_Ptr = &(dFdx[li_si][A_si_Equ_s_NodeOffset]);
  q_si_Equ_s_Node_Ptr = &(dQdx[li_si][A_si_Equ_s_NodeOffset]);
  f_xf1_Equ_bi_Node_Ptr = &(dFdx[li_xf1][A_xf1_Equ_bi_NodeOffset]);
  q_xf1_Equ_bi_Node_Ptr = &(dQdx[li_xf1][A_xf1_Equ_bi_NodeOffset]);
  f_xf1_Equ_ci_Node_Ptr = &(dFdx[li_xf1][A_xf1_Equ_ci_NodeOffset]);
  q_xf1_Equ_ci_Node_Ptr = &(dQdx[li_xf1][A_xf1_Equ_ci_NodeOffset]);
  f_xf1_Equ_ei_Node_Ptr = &(dFdx[li_xf1][A_xf1_Equ_ei_NodeOffset]);
  q_xf1_Equ_ei_Node_Ptr = &(dQdx[li_xf1][A_xf1_Equ_ei_NodeOffset]);
  f_xf1_Equ_tnode_Node_Ptr = &(dFdx[li_xf1][A_xf1_Equ_tnode_NodeOffset]);
  q_xf1_Equ_tnode_Node_Ptr = &(dQdx[li_xf1][A_xf1_Equ_tnode_NodeOffset]);
  f_xf1_Equ_xf2_Node_Ptr = &(dFdx[li_xf1][A_xf1_Equ_xf2_NodeOffset]);
  q_xf1_Equ_xf2_Node_Ptr = &(dQdx[li_xf1][A_xf1_Equ_xf2_NodeOffset]);
  f_xf1_Equ_xf1_Node_Ptr = &(dFdx[li_xf1][A_xf1_Equ_xf1_NodeOffset]);
  q_xf1_Equ_xf1_Node_Ptr = &(dQdx[li_xf1][A_xf1_Equ_xf1_NodeOffset]);
  f_xf2_Equ_bi_Node_Ptr = &(dFdx[li_xf2][A_xf2_Equ_bi_NodeOffset]);
  q_xf2_Equ_bi_Node_Ptr = &(dQdx[li_xf2][A_xf2_Equ_bi_NodeOffset]);
  f_xf2_Equ_ci_Node_Ptr = &(dFdx[li_xf2][A_xf2_Equ_ci_NodeOffset]);
  q_xf2_Equ_ci_Node_Ptr = &(dQdx[li_xf2][A_xf2_Equ_ci_NodeOffset]);
  f_xf2_Equ_tnode_Node_Ptr = &(dFdx[li_xf2][A_xf2_Equ_tnode_NodeOffset]);
  q_xf2_Equ_tnode_Node_Ptr = &(dQdx[li_xf2][A_xf2_Equ_tnode_NodeOffset]);
  f_xf2_Equ_ei_Node_Ptr = &(dFdx[li_xf2][A_xf2_Equ_ei_NodeOffset]);
  q_xf2_Equ_ei_Node_Ptr = &(dQdx[li_xf2][A_xf2_Equ_ei_NodeOffset]);
  f_xf2_Equ_xf1_Node_Ptr = &(dFdx[li_xf2][A_xf2_Equ_xf1_NodeOffset]);
  q_xf2_Equ_xf1_Node_Ptr = &(dQdx[li_xf2][A_xf2_Equ_xf1_NodeOffset]);
  f_xf2_Equ_xf2_Node_Ptr = &(dFdx[li_xf2][A_xf2_Equ_xf2_NodeOffset]);
  q_xf2_Equ_xf2_Node_Ptr = &(dQdx[li_xf2][A_xf2_Equ_xf2_NodeOffset]);
  f_xf_Equ_bi_Node_Ptr = &(dFdx[li_xf][A_xf_Equ_bi_NodeOffset]);
  q_xf_Equ_bi_Node_Ptr = &(dQdx[li_xf][A_xf_Equ_bi_NodeOffset]);
  f_xf_Equ_ei_Node_Ptr = &(dFdx[li_xf][A_xf_Equ_ei_NodeOffset]);
  q_xf_Equ_ei_Node_Ptr = &(dQdx[li_xf][A_xf_Equ_ei_NodeOffset]);
  f_xf_Equ_ci_Node_Ptr = &(dFdx[li_xf][A_xf_Equ_ci_NodeOffset]);
  q_xf_Equ_ci_Node_Ptr = &(dQdx[li_xf][A_xf_Equ_ci_NodeOffset]);
  f_xf_Equ_tnode_Node_Ptr = &(dFdx[li_xf][A_xf_Equ_tnode_NodeOffset]);
  q_xf_Equ_tnode_Node_Ptr = &(dQdx[li_xf][A_xf_Equ_tnode_NodeOffset]);
  f_xf_Equ_xf_Node_Ptr = &(dFdx[li_xf][A_xf_Equ_xf_NodeOffset]);
  q_xf_Equ_xf_Node_Ptr = &(dQdx[li_xf][A_xf_Equ_xf_NodeOffset]);
  f_n1_Equ_bi_Node_Ptr = &(dFdx[li_n1][A_n1_Equ_bi_NodeOffset]);
  q_n1_Equ_bi_Node_Ptr = &(dQdx[li_n1][A_n1_Equ_bi_NodeOffset]);
  f_n1_Equ_ei_Node_Ptr = &(dFdx[li_n1][A_n1_Equ_ei_NodeOffset]);
  q_n1_Equ_ei_Node_Ptr = &(dQdx[li_n1][A_n1_Equ_ei_NodeOffset]);
  f_n1_Equ_tnode_Node_Ptr = &(dFdx[li_n1][A_n1_Equ_tnode_NodeOffset]);
  q_n1_Equ_tnode_Node_Ptr = &(dQdx[li_n1][A_n1_Equ_tnode_NodeOffset]);
  f_n1_Equ_n1_Node_Ptr = &(dFdx[li_n1][A_n1_Equ_n1_NodeOffset]);
  q_n1_Equ_n1_Node_Ptr = &(dQdx[li_n1][A_n1_Equ_n1_NodeOffset]);
  f_n2_Equ_bi_Node_Ptr = &(dFdx[li_n2][A_n2_Equ_bi_NodeOffset]);
  q_n2_Equ_bi_Node_Ptr = &(dQdx[li_n2][A_n2_Equ_bi_NodeOffset]);
  f_n2_Equ_ci_Node_Ptr = &(dFdx[li_n2][A_n2_Equ_ci_NodeOffset]);
  q_n2_Equ_ci_Node_Ptr = &(dQdx[li_n2][A_n2_Equ_ci_NodeOffset]);
  f_n2_Equ_ei_Node_Ptr = &(dFdx[li_n2][A_n2_Equ_ei_NodeOffset]);
  q_n2_Equ_ei_Node_Ptr = &(dQdx[li_n2][A_n2_Equ_ei_NodeOffset]);
  f_n2_Equ_tnode_Node_Ptr = &(dFdx[li_n2][A_n2_Equ_tnode_NodeOffset]);
  q_n2_Equ_tnode_Node_Ptr = &(dQdx[li_n2][A_n2_Equ_tnode_NodeOffset]);
  f_n2_Equ_n2_Node_Ptr = &(dFdx[li_n2][A_n2_Equ_n2_NodeOffset]);
  q_n2_Equ_n2_Node_Ptr = &(dQdx[li_n2][A_n2_Equ_n2_NodeOffset]);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_c] += staticContributions[admsNodeID_c];
  (*extData.daeFVectorPtr)[li_b] += staticContributions[admsNodeID_b];
  (*extData.daeFVectorPtr)[li_e] += staticContributions[admsNodeID_e];
  (*extData.daeFVectorPtr)[li_s] += staticContributions[admsNodeID_s];
  (*extData.daeFVectorPtr)[li_tnode] += staticContributions[admsNodeID_tnode];
  (*extData.daeFVectorPtr)[li_ci] += staticContributions[admsNodeID_ci];
  (*extData.daeFVectorPtr)[li_ei] += staticContributions[admsNodeID_ei];
  (*extData.daeFVectorPtr)[li_bp] += staticContributions[admsNodeID_bp];
  (*extData.daeFVectorPtr)[li_bi] += staticContributions[admsNodeID_bi];
  (*extData.daeFVectorPtr)[li_si] += staticContributions[admsNodeID_si];
  (*extData.daeFVectorPtr)[li_xf1] += staticContributions[admsNodeID_xf1];
  (*extData.daeFVectorPtr)[li_xf2] += staticContributions[admsNodeID_xf2];
  (*extData.daeFVectorPtr)[li_xf] += staticContributions[admsNodeID_xf];
  (*extData.daeFVectorPtr)[li_n1] += staticContributions[admsNodeID_n1];
  (*extData.daeFVectorPtr)[li_n2] += staticContributions[admsNodeID_n2];


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;

    leadF[li_branch_ic] = leadCurrentF[admsNodeID_c];
    leadF[li_branch_ib] = leadCurrentF[admsNodeID_b];
    leadF[li_branch_ie] = leadCurrentF[admsNodeID_e];
    leadF[li_branch_is] = leadCurrentF[admsNodeID_s];
    leadF[li_branch_itnode] = leadCurrentF[admsNodeID_tnode];

    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

    double * solVec = extData.nextSolVectorRawPtr;
    double * junctionV = extData.nextJunctionVCompRawPtr;
    junctionV[li_branch_ic] = solVec[li_c] - solVec[li_e];
    junctionV[li_branch_ib] = solVec[li_b] - solVec[li_e];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_c] += dynamicContributions[admsNodeID_c];
  (*extData.daeQVectorPtr)[li_b] += dynamicContributions[admsNodeID_b];
  (*extData.daeQVectorPtr)[li_e] += dynamicContributions[admsNodeID_e];
  (*extData.daeQVectorPtr)[li_s] += dynamicContributions[admsNodeID_s];
  (*extData.daeQVectorPtr)[li_tnode] += dynamicContributions[admsNodeID_tnode];
  (*extData.daeQVectorPtr)[li_ci] += dynamicContributions[admsNodeID_ci];
  (*extData.daeQVectorPtr)[li_ei] += dynamicContributions[admsNodeID_ei];
  (*extData.daeQVectorPtr)[li_bp] += dynamicContributions[admsNodeID_bp];
  (*extData.daeQVectorPtr)[li_bi] += dynamicContributions[admsNodeID_bi];
  (*extData.daeQVectorPtr)[li_si] += dynamicContributions[admsNodeID_si];
  (*extData.daeQVectorPtr)[li_xf1] += dynamicContributions[admsNodeID_xf1];
  (*extData.daeQVectorPtr)[li_xf2] += dynamicContributions[admsNodeID_xf2];
  (*extData.daeQVectorPtr)[li_xf] += dynamicContributions[admsNodeID_xf];
  (*extData.daeQVectorPtr)[li_n1] += dynamicContributions[admsNodeID_n1];
  (*extData.daeQVectorPtr)[li_n2] += dynamicContributions[admsNodeID_n2];


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;

    leadQ[li_branch_ic] = leadCurrentQ[admsNodeID_c];
    leadQ[li_branch_ib] = leadCurrentQ[admsNodeID_b];
    leadQ[li_branch_ie] = leadCurrentQ[admsNodeID_e];
    leadQ[li_branch_is] = leadCurrentQ[admsNodeID_s];
    leadQ[li_branch_itnode] = leadCurrentQ[admsNodeID_tnode];
  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.


  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one hicumL2va instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMShicumL2va::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double fourkt;
  double d_fourkt_dV_tnode_GND;
  double flicker_Pwr;
  double d_flicker_Pwr_dV_ei_e;
  double d_flicker_Pwr_dV_tnode_GND;
  double d_flicker_Pwr_dV_bi_ei;
  double d_flicker_Pwr_dV_bp_ei;
  double d_flicker_Pwr_dV_bi_ci;
  double i_re;
  double d_i_re_dV_ei_e;
  double d_i_re_dV_tnode_GND;
  double twoq;
  double n_w;
  double n_1;
  double d_n_1_dV_bi_ei;
  double d_n_1_dV_tnode_GND;
  double d_n_1_dV_bi_ci;
  double sqrt_n2;
  double d_sqrt_n2_dV_tnode_GND;
  double d_sqrt_n2_dV_bi_ei;
  double d_sqrt_n2_dV_bi_ci;
  double n_2;
  double d_n_2_dV_bi_ei;
  double d_n_2_dV_tnode_GND;
  double d_n_2_dV_bi_ci;
  double DIOY;
  double d_DIOY_dV_si_ci;
  double d_DIOY_dV_bp_ci;
  double d_DIOY_dV_bp_ei;
  double d_DIOY_dV_bi_ci;
  double d_DIOY_dV_bi_ei;
  double d_DIOY_dV_tnode_GND;
  double le;
  double d_le_dV_si_ci;
  double d_le_dV_bp_ci;
  double d_le_dV_bp_ei;
  double d_le_dV_bi_ci;
  double d_le_dV_bi_ei;
  double d_le_dV_tnode_GND;
  double irei;
  double d_irei_dV_tnode_GND;
  double d_irei_dV_bi_ei;
  double Orci0_t;
  double d_Orci0_t_dV_tnode_GND;
  double Tr;
  double VT_f;
  double d_VT_f_dV_tnode_GND;
  double i_0f;
  double d_i_0f_dV_tnode_GND;
  double d_i_0f_dV_bi_ei;
  double i_0r;
  double d_i_0r_dV_tnode_GND;
  double d_i_0r_dV_bi_ci;
  double DFV_f;
  double d_DFV_f_dV_tnode_GND;
  double DFv_e;
  double d_DFv_e_dV_s_c;
  double d_DFv_e_dV_si_ci;
  double d_DFv_e_dV_b_ci;
  double d_DFv_e_dV_bp_ci;
  double d_DFv_e_dV_bp_ei;
  double d_DFv_e_dV_bi_ci;
  double d_DFv_e_dV_tnode_GND;
  double d_DFv_e_dV_bi_ei;
  double DFs_q;
  double d_DFs_q_dV_s_c;
  double d_DFs_q_dV_si_ci;
  double d_DFs_q_dV_b_ci;
  double d_DFs_q_dV_bp_ci;
  double d_DFs_q_dV_bp_ei;
  double d_DFs_q_dV_bi_ci;
  double d_DFs_q_dV_tnode_GND;
  double d_DFs_q_dV_bi_ei;
  double DFs_q2;
  double d_DFs_q2_dV_s_c;
  double d_DFs_q2_dV_si_ci;
  double d_DFs_q2_dV_b_ci;
  double d_DFs_q2_dV_bp_ci;
  double d_DFs_q2_dV_bp_ei;
  double d_DFs_q2_dV_bi_ci;
  double d_DFs_q2_dV_tnode_GND;
  double d_DFs_q2_dV_bi_ei;
  double DFv_j;
  double d_DFv_j_dV_s_c;
  double d_DFv_j_dV_si_ci;
  double d_DFv_j_dV_b_ci;
  double d_DFv_j_dV_bp_ci;
  double d_DFv_j_dV_bp_ei;
  double d_DFv_j_dV_bi_ci;
  double d_DFv_j_dV_tnode_GND;
  double d_DFv_j_dV_bi_ei;
  double DFdvj_dv;
  double d_DFdvj_dv_dV_s_c;
  double d_DFdvj_dv_dV_si_ci;
  double d_DFdvj_dv_dV_b_ci;
  double d_DFdvj_dv_dV_bp_ci;
  double d_DFdvj_dv_dV_bp_ei;
  double d_DFdvj_dv_dV_bi_ci;
  double d_DFdvj_dv_dV_tnode_GND;
  double d_DFdvj_dv_dV_bi_ei;
  double DFb;
  double d_DFb_dV_s_c;
  double d_DFb_dV_si_ci;
  double d_DFb_dV_b_ci;
  double d_DFb_dV_bp_ci;
  double d_DFb_dV_bp_ei;
  double d_DFb_dV_bi_ci;
  double d_DFb_dV_tnode_GND;
  double d_DFb_dV_bi_ei;
  double DFC_j1;
  double d_DFC_j1_dV_s_c;
  double d_DFC_j1_dV_si_ci;
  double d_DFC_j1_dV_b_ci;
  double d_DFC_j1_dV_bp_ci;
  double d_DFC_j1_dV_bp_ei;
  double d_DFC_j1_dV_bi_ci;
  double d_DFC_j1_dV_tnode_GND;
  double d_DFC_j1_dV_bi_ei;
  double Cjei;
  double d_Cjei_dV_tnode_GND;
  double d_Cjei_dV_bi_ei;
  double DFQ_j;
  double d_DFQ_j_dV_s_c;
  double d_DFQ_j_dV_si_ci;
  double d_DFQ_j_dV_b_ci;
  double d_DFQ_j_dV_bp_ci;
  double d_DFQ_j_dV_bp_ei;
  double d_DFQ_j_dV_bi_ci;
  double d_DFQ_j_dV_tnode_GND;
  double d_DFQ_j_dV_bi_ei;
  double Qjei;
  double d_Qjei_dV_tnode_GND;
  double d_Qjei_dV_bi_ei;
  double vj;
  double d_vj_dV_tnode_GND;
  double d_vj_dV_bi_ei;
  double vj_z;
  double d_vj_z_dV_tnode_GND;
  double d_vj_z_dV_bi_ei;
  double hjei_vbe;
  double d_hjei_vbe_dV_tnode_GND;
  double d_hjei_vbe_dV_bi_ei;
  double Dz_r;
  double Dv_p;
  double d_Dv_p_dV_tnode_GND;
  double DV_f;
  double d_DV_f_dV_tnode_GND;
  double DC_max;
  double d_DC_max_dV_tnode_GND;
  double DC_c;
  double d_DC_c_dV_tnode_GND;
  double Dv_e;
  double d_Dv_e_dV_s_c;
  double d_Dv_e_dV_si_ci;
  double d_Dv_e_dV_b_ci;
  double d_Dv_e_dV_bp_ci;
  double d_Dv_e_dV_tnode_GND;
  double d_Dv_e_dV_bi_ci;
  double De;
  double d_De_dV_s_c;
  double d_De_dV_si_ci;
  double d_De_dV_b_ci;
  double d_De_dV_bp_ci;
  double d_De_dV_tnode_GND;
  double d_De_dV_bi_ci;
  double De_1;
  double d_De_1_dV_s_c;
  double d_De_1_dV_si_ci;
  double d_De_1_dV_b_ci;
  double d_De_1_dV_bp_ci;
  double d_De_1_dV_tnode_GND;
  double d_De_1_dV_bi_ci;
  double Dv_j1;
  double d_Dv_j1_dV_s_c;
  double d_Dv_j1_dV_si_ci;
  double d_Dv_j1_dV_b_ci;
  double d_Dv_j1_dV_bp_ci;
  double d_Dv_j1_dV_tnode_GND;
  double d_Dv_j1_dV_bi_ci;
  double Da;
  double d_Da_dV_tnode_GND;
  double Dv_r;
  double d_Dv_r_dV_s_c;
  double d_Dv_r_dV_si_ci;
  double d_Dv_r_dV_b_ci;
  double d_Dv_r_dV_bp_ci;
  double d_Dv_r_dV_tnode_GND;
  double d_Dv_r_dV_bi_ci;
  double De_2;
  double d_De_2_dV_s_c;
  double d_De_2_dV_si_ci;
  double d_De_2_dV_b_ci;
  double d_De_2_dV_bp_ci;
  double d_De_2_dV_tnode_GND;
  double d_De_2_dV_bi_ci;
  double Dv_j2;
  double d_Dv_j2_dV_s_c;
  double d_Dv_j2_dV_si_ci;
  double d_Dv_j2_dV_b_ci;
  double d_Dv_j2_dV_bp_ci;
  double d_Dv_j2_dV_tnode_GND;
  double d_Dv_j2_dV_bi_ci;
  double Dv_j4;
  double d_Dv_j4_dV_s_c;
  double d_Dv_j4_dV_si_ci;
  double d_Dv_j4_dV_b_ci;
  double d_Dv_j4_dV_bp_ci;
  double d_Dv_j4_dV_bi_ci;
  double d_Dv_j4_dV_tnode_GND;
  double DCln1;
  double d_DCln1_dV_s_c;
  double d_DCln1_dV_si_ci;
  double d_DCln1_dV_b_ci;
  double d_DCln1_dV_bp_ci;
  double d_DCln1_dV_tnode_GND;
  double d_DCln1_dV_bi_ci;
  double DCln2;
  double d_DCln2_dV_s_c;
  double d_DCln2_dV_si_ci;
  double d_DCln2_dV_b_ci;
  double d_DCln2_dV_bp_ci;
  double d_DCln2_dV_tnode_GND;
  double d_DCln2_dV_bi_ci;
  double Dz1;
  double Dzr1;
  double DC_j1;
  double d_DC_j1_dV_s_c;
  double d_DC_j1_dV_si_ci;
  double d_DC_j1_dV_b_ci;
  double d_DC_j1_dV_bp_ci;
  double d_DC_j1_dV_tnode_GND;
  double d_DC_j1_dV_bi_ci;
  double DC_j2;
  double d_DC_j2_dV_s_c;
  double d_DC_j2_dV_si_ci;
  double d_DC_j2_dV_b_ci;
  double d_DC_j2_dV_bp_ci;
  double d_DC_j2_dV_tnode_GND;
  double d_DC_j2_dV_bi_ci;
  double DC_j3;
  double d_DC_j3_dV_s_c;
  double d_DC_j3_dV_si_ci;
  double d_DC_j3_dV_b_ci;
  double d_DC_j3_dV_bp_ci;
  double d_DC_j3_dV_tnode_GND;
  double d_DC_j3_dV_bi_ci;
  double Cjci;
  double d_Cjci_dV_bi_ei;
  double d_Cjci_dV_tnode_GND;
  double d_Cjci_dV_bi_ci;
  double DQ_j1;
  double d_DQ_j1_dV_s_c;
  double d_DQ_j1_dV_si_ci;
  double d_DQ_j1_dV_b_ci;
  double d_DQ_j1_dV_bp_ci;
  double d_DQ_j1_dV_tnode_GND;
  double d_DQ_j1_dV_bi_ci;
  double DQ_j2;
  double d_DQ_j2_dV_s_c;
  double d_DQ_j2_dV_si_ci;
  double d_DQ_j2_dV_b_ci;
  double d_DQ_j2_dV_bp_ci;
  double d_DQ_j2_dV_tnode_GND;
  double d_DQ_j2_dV_bi_ci;
  double DQ_j3;
  double d_DQ_j3_dV_s_c;
  double d_DQ_j3_dV_si_ci;
  double d_DQ_j3_dV_b_ci;
  double d_DQ_j3_dV_bp_ci;
  double d_DQ_j3_dV_tnode_GND;
  double d_DQ_j3_dV_bi_ci;
  double Qjci;
  double d_Qjci_dV_bi_ei;
  double d_Qjci_dV_tnode_GND;
  double d_Qjci_dV_bi_ci;
  double a_bpt;
  double Q_0;
  double d_Q_0_dV_tnode_GND;
  double d_Q_0_dV_bi_ei;
  double d_Q_0_dV_bi_ci;
  double Q_bpt;
  double d_Q_bpt_dV_tnode_GND;
  double b_q;
  double d_b_q_dV_tnode_GND;
  double d_b_q_dV_bi_ei;
  double d_b_q_dV_bi_ci;
  double Cjcit;
  double d_Cjcit_dV_tnode_GND;
  double d_Cjcit_dV_bi_ci;
  double cc;
  double d_cc_dV_tnode_GND;
  double d_cc_dV_bi_ci;
  double T_f0;
  double d_T_f0_dV_tnode_GND;
  double d_T_f0_dV_bi_ci;
  double vc;
  double d_vc_dV_bi_ei;
  double d_vc_dV_bi_ci;
  double d_vc_dV_tnode_GND;
  double ick;
  double d_ick_dV_bi_ei;
  double d_ick_dV_bi_ci;
  double d_ick_dV_tnode_GND;
  double ICKa;
  double d_ICKa_dV_bi_ei;
  double d_ICKa_dV_bi_ci;
  double d_ICKa_dV_tnode_GND;
  double ick2;
  double d_ick2_dV_bi_ei;
  double d_ick2_dV_bi_ci;
  double d_ick2_dV_tnode_GND;
  double ick1;
  double d_ick1_dV_bi_ei;
  double d_ick1_dV_bi_ci;
  double d_ick1_dV_tnode_GND;
  double Odelck;
  double a11;
  double d_a11_dV_bi_ei;
  double d_a11_dV_bi_ci;
  double d_a11_dV_tnode_GND;
  double a1;
  double d_a1_dV_bi_ei;
  double d_a1_dV_bi_ci;
  double d_a1_dV_tnode_GND;
  double vceff;
  double d_vceff_dV_bi_ei;
  double d_vceff_dV_bi_ci;
  double d_vceff_dV_tnode_GND;
  double d1;
  double d_d1_dV_bi_ei;
  double d_d1_dV_bi_ci;
  double d_d1_dV_tnode_GND;
  double Ovpt;
  double Q_p;
  double d_Q_p_dV_tnode_GND;
  double d_Q_p_dV_bi_ei;
  double d_Q_p_dV_bi_ci;
  double A;
  double d_A_dV_tnode_GND;
  double d_A_dV_bi_ei;
  double d_A_dV_bi_ci;
  double I_Tf1;
  double d_I_Tf1_dV_tnode_GND;
  double d_I_Tf1_dV_bi_ei;
  double d_I_Tf1_dV_bi_ci;
  double a_h;
  double d_a_h_dV_tnode_GND;
  double d_a_h_dV_bi_ei;
  double d_a_h_dV_bi_ci;
  double itf;
  double d_itf_dV_tnode_GND;
  double d_itf_dV_bi_ei;
  double d_itf_dV_bi_ci;
  double itr;
  double d_itr_dV_tnode_GND;
  double d_itr_dV_bi_ci;
  double d_itr_dV_bi_ei;
  double Q_bf;
  double d_Q_bf_dV_tnode_GND;
  double d_Q_bf_dV_bi_ei;
  double d_Q_bf_dV_bi_ci;
  double Qf;
  double d_Qf_dV_tnode_GND;
  double d_Qf_dV_bi_ci;
  double d_Qf_dV_bi_ei;
  double FFitf_ick;
  double d_FFitf_ick_dV_tnode_GND;
  double d_FFitf_ick_dV_bi_ei;
  double d_FFitf_ick_dV_bi_ci;
  double FFdTef;
  double d_FFdTef_dV_tnode_GND;
  double d_FFdTef_dV_bi_ei;
  double d_FFdTef_dV_bi_ci;
  double FFdQef;
  double d_FFdQef_dV_tnode_GND;
  double d_FFdQef_dV_bi_ei;
  double d_FFdQef_dV_bi_ci;
  double FFib;
  double d_FFib_dV_tnode_GND;
  double d_FFib_dV_bi_ei;
  double d_FFib_dV_bi_ci;
  double FFfcbar;
  double d_FFfcbar_dV_tnode_GND;
  double d_FFfcbar_dV_bi_ei;
  double d_FFfcbar_dV_bi_ci;
  double FFdib_ditf;
  double d_FFdib_ditf_dV_tnode_GND;
  double d_FFdib_ditf_dV_bi_ei;
  double d_FFdib_ditf_dV_bi_ci;
  double FFdVc;
  double d_FFdVc_dV_tnode_GND;
  double d_FFdVc_dV_bi_ei;
  double d_FFdVc_dV_bi_ci;
  double FFdVc_ditf;
  double d_FFdVc_ditf_dV_tnode_GND;
  double d_FFdVc_ditf_dV_bi_ei;
  double d_FFdVc_ditf_dV_bi_ci;
  double FFdQbfb;
  double d_FFdQbfb_dV_tnode_GND;
  double d_FFdQbfb_dV_bi_ei;
  double d_FFdQbfb_dV_bi_ci;
  double FFdTbfb;
  double d_FFdTbfb_dV_tnode_GND;
  double d_FFdTbfb_dV_bi_ei;
  double d_FFdTbfb_dV_bi_ci;
  double FFic;
  double d_FFic_dV_tnode_GND;
  double d_FFic_dV_bi_ei;
  double d_FFic_dV_bi_ci;
  double FFw;
  double d_FFw_dV_tnode_GND;
  double d_FFw_dV_bi_ei;
  double d_FFw_dV_bi_ci;
  double FFdQfhc;
  double d_FFdQfhc_dV_tnode_GND;
  double d_FFdQfhc_dV_bi_ei;
  double d_FFdQfhc_dV_bi_ci;
  double FFdTfhc;
  double d_FFdTfhc_dV_tnode_GND;
  double d_FFdTfhc_dV_bi_ei;
  double d_FFdTfhc_dV_bi_ci;
  double FCa;
  double d_FCa_dV_bi_ei;
  double d_FCa_dV_bi_ci;
  double d_FCa_dV_tnode_GND;
  double FCrt;
  double d_FCrt_dV_bi_ei;
  double d_FCrt_dV_bi_ci;
  double d_FCrt_dV_tnode_GND;
  double FCa_ck;
  double d_FCa_ck_dV_bi_ei;
  double d_FCa_ck_dV_bi_ci;
  double d_FCa_ck_dV_tnode_GND;
  double FCdaick_ditf;
  double d_FCdaick_ditf_dV_bi_ei;
  double d_FCdaick_ditf_dV_bi_ci;
  double d_FCdaick_ditf_dV_tnode_GND;
  double FCz_1;
  double d_FCz_1_dV_bi_ei;
  double d_FCz_1_dV_bi_ci;
  double d_FCz_1_dV_tnode_GND;
  double FCd_f;
  double d_FCd_f_dV_bi_ei;
  double d_FCd_f_dV_bi_ci;
  double d_FCd_f_dV_tnode_GND;
  double FCz;
  double d_FCz_dV_bi_ei;
  double d_FCz_dV_bi_ci;
  double d_FCz_dV_tnode_GND;
  double FCxl;
  double FCxb;
  double FCf1;
  double d_FCf1_dV_bi_ei;
  double d_FCf1_dV_bi_ci;
  double d_FCf1_dV_tnode_GND;
  double FCln;
  double FCa1;
  double d_FCa1_dV_bi_ei;
  double d_FCa1_dV_bi_ci;
  double d_FCa1_dV_tnode_GND;
  double FCd_a;
  double d_FCd_a_dV_bi_ei;
  double d_FCd_a_dV_bi_ci;
  double d_FCd_a_dV_tnode_GND;
  double FCw;
  double d_FCw_dV_bi_ei;
  double d_FCw_dV_bi_ci;
  double d_FCw_dV_tnode_GND;
  double FCdw_daick;
  double d_FCdw_daick_dV_bi_ei;
  double d_FCdw_daick_dV_bi_ci;
  double d_FCdw_daick_dV_tnode_GND;
  double FCda1_dw;
  double d_FCda1_dw_dV_bi_ei;
  double d_FCda1_dw_dV_bi_ci;
  double d_FCda1_dw_dV_tnode_GND;
  double FCf_CT;
  double d_FCf_CT_dV_bi_ei;
  double d_FCf_CT_dV_bi_ci;
  double d_FCf_CT_dV_tnode_GND;
  double FCw2;
  double d_FCw2_dV_bi_ei;
  double d_FCw2_dV_bi_ci;
  double d_FCw2_dV_tnode_GND;
  double FCdf1_dw;
  double d_FCdf1_dw_dV_bi_ei;
  double d_FCdf1_dw_dV_bi_ci;
  double d_FCdf1_dw_dV_tnode_GND;
  double z;
  double d_z_dV_bi_ei;
  double d_z_dV_bi_ci;
  double d_z_dV_tnode_GND;
  double lnzb;
  double d_lnzb_dV_bi_ei;
  double d_lnzb_dV_bi_ci;
  double d_lnzb_dV_tnode_GND;
  double x;
  double d_x_dV_bi_ei;
  double d_x_dV_bi_ci;
  double d_x_dV_tnode_GND;
  double a2;
  double d_a2_dV_bi_ei;
  double d_a2_dV_bi_ci;
  double d_a2_dV_tnode_GND;
  double a3;
  double d_a3_dV_bi_ei;
  double d_a3_dV_bi_ci;
  double d_a3_dV_tnode_GND;
  double r;
  double FCf2;
  double d_FCf2_dV_bi_ei;
  double d_FCf2_dV_bi_ci;
  double d_FCf2_dV_tnode_GND;
  double FCdf2_dw;
  double d_FCdf2_dw_dV_bi_ei;
  double d_FCdf2_dw_dV_bi_ci;
  double d_FCdf2_dw_dV_tnode_GND;
  double FCf3;
  double d_FCf3_dV_bi_ei;
  double d_FCf3_dV_bi_ci;
  double d_FCf3_dV_tnode_GND;
  double FCdf3_dw;
  double d_FCdf3_dw_dV_bi_ei;
  double d_FCdf3_dw_dV_bi_ci;
  double d_FCdf3_dw_dV_tnode_GND;
  double FCf_ci;
  double d_FCf_ci_dV_bi_ei;
  double d_FCf_ci_dV_bi_ci;
  double d_FCf_ci_dV_tnode_GND;
  double FCdfc_dw;
  double d_FCdfc_dw_dV_bi_ei;
  double d_FCdfc_dw_dV_bi_ci;
  double d_FCdfc_dw_dV_tnode_GND;
  double FCdw_ditf;
  double d_FCdw_ditf_dV_bi_ei;
  double d_FCdw_ditf_dV_bi_ci;
  double d_FCdw_ditf_dV_tnode_GND;
  double FCdfc_ditf;
  double d_FCdfc_ditf_dV_bi_ei;
  double d_FCdfc_ditf_dV_bi_ci;
  double d_FCdfc_ditf_dV_tnode_GND;
  double lnz;
  double d_lnz_dV_bi_ei;
  double d_lnz_dV_bi_ci;
  double d_lnz_dV_tnode_GND;
  double FCdfCT_dw;
  double d_FCdfCT_dw_dV_bi_ei;
  double d_FCdfCT_dw_dV_bi_ci;
  double d_FCdfCT_dw_dV_tnode_GND;
  double FCdfCT_ditf;
  double d_FCdfCT_ditf_dV_bi_ei;
  double d_FCdfCT_ditf_dV_bi_ci;
  double d_FCdfCT_ditf_dV_tnode_GND;
  double FFdQcfc;
  double d_FFdQcfc_dV_tnode_GND;
  double d_FFdQcfc_dV_bi_ei;
  double d_FFdQcfc_dV_bi_ci;
  double FFdTcfc;
  double d_FFdTcfc_dV_tnode_GND;
  double d_FFdTcfc_dV_bi_ei;
  double d_FFdTcfc_dV_bi_ci;
  double FFdQcfcT;
  double d_FFdQcfcT_dV_tnode_GND;
  double d_FFdQcfcT_dV_bi_ei;
  double d_FFdQcfcT_dV_bi_ci;
  double FFdTcfcT;
  double d_FFdTcfcT_dV_tnode_GND;
  double d_FFdTcfcT_dV_bi_ei;
  double d_FFdTcfcT_dV_bi_ci;
  double FFdQbfc;
  double d_FFdQbfc_dV_tnode_GND;
  double d_FFdQbfc_dV_bi_ei;
  double d_FFdQbfc_dV_bi_ci;
  double FFdTbfc;
  double d_FFdTbfc_dV_tnode_GND;
  double d_FFdTbfc_dV_bi_ei;
  double d_FFdTbfc_dV_bi_ci;
  double Q_fT;
  double d_Q_fT_dV_tnode_GND;
  double d_Q_fT_dV_bi_ci;
  double d_Q_fT_dV_bi_ei;
  double T_fT;
  double d_T_fT_dV_bi_ei;
  double d_T_fT_dV_tnode_GND;
  double d_T_fT_dV_bi_ci;
  double Qr;
  double d_Qr_dV_tnode_GND;
  double d_Qr_dV_bi_ci;
  double d_Qr_dV_bi_ei;
  int l_it;
  double Q_pT;
  double d_Q_pT_dV_tnode_GND;
  double d_Q_pT_dV_bi_ei;
  double d_Q_pT_dV_bi_ci;
  double d_Q;
  double d_d_Q_dV_tnode_GND;
  double d_d_Q_dV_bi_ei;
  double d_d_Q_dV_bi_ci;
  double d_Q0;
  double d_d_Q0_dV_tnode_GND;
  double d_d_Q0_dV_bi_ei;
  double d_d_Q0_dV_bi_ci;
  double Qdei;
  double d_Qdei_dV_tnode_GND;
  double d_Qdei_dV_bi_ci;
  double d_Qdei_dV_bi_ei;
  double Qdci;
  double d_Qdci_dV_tnode_GND;
  double d_Qdci_dV_bi_ci;
  double d_Qdci_dV_bi_ei;
  double Cdei;
  double d_Cdei_dV_tnode_GND;
  double d_Cdei_dV_bi_ci;
  double d_Cdei_dV_bi_ei;
  double Cdci;
  double d_Cdci_dV_tnode_GND;
  double d_Cdci_dV_bi_ci;
  double d_Cdci_dV_bi_ei;
  double Crbi;
  double d_Crbi_dV_tnode_GND;
  double d_Crbi_dV_bi_ei;
  double d_Crbi_dV_bi_ci;
  double qrbi;
  double d_qrbi_dV_tnode_GND;
  double d_qrbi_dV_bi_ei;
  double d_qrbi_dV_bi_ci;
  double d_qrbi_dV_bp_bi;
  double ibh_rec;
  double d_ibh_rec_dV_tnode_GND;
  double d_ibh_rec_dV_bi_ei;
  double d_ibh_rec_dV_bi_ci;
  double irep;
  double d_irep_dV_tnode_GND;
  double d_irep_dV_bp_ei;
  double d_irep_dV_bi_ci;
  double d_irep_dV_bi_ei;
  double Cjep;
  double d_Cjep_dV_bp_ei;
  double d_Cjep_dV_bi_ci;
  double d_Cjep_dV_tnode_GND;
  double d_Cjep_dV_bi_ei;
  double Qjep;
  double d_Qjep_dV_bp_ei;
  double d_Qjep_dV_bi_ci;
  double d_Qjep_dV_tnode_GND;
  double d_Qjep_dV_bi_ei;
  double ibet;
  double d_ibet_dV_bp_ei;
  double d_ibet_dV_tnode_GND;
  double d_ibet_dV_bi_ci;
  double d_ibet_dV_bi_ei;
  double CjCx_ii;
  double d_CjCx_ii_dV_bp_ei;
  double d_CjCx_ii_dV_bi_ei;
  double d_CjCx_ii_dV_bp_ci;
  double d_CjCx_ii_dV_tnode_GND;
  double d_CjCx_ii_dV_bi_ci;
  double qjcx0_t_ii;
  double d_qjcx0_t_ii_dV_bp_ei;
  double d_qjcx0_t_ii_dV_bi_ei;
  double d_qjcx0_t_ii_dV_bp_ci;
  double d_qjcx0_t_ii_dV_tnode_GND;
  double d_qjcx0_t_ii_dV_bi_ci;
  double CjCx_i;
  double d_CjCx_i_dV_bp_ei;
  double d_CjCx_i_dV_bi_ei;
  double d_CjCx_i_dV_b_ci;
  double d_CjCx_i_dV_bp_ci;
  double d_CjCx_i_dV_tnode_GND;
  double d_CjCx_i_dV_bi_ci;
  double qjcx0_t_i;
  double d_qjcx0_t_i_dV_bp_ei;
  double d_qjcx0_t_i_dV_bi_ei;
  double d_qjcx0_t_i_dV_b_ci;
  double d_qjcx0_t_i_dV_bp_ci;
  double d_qjcx0_t_i_dV_tnode_GND;
  double d_qjcx0_t_i_dV_bi_ci;
  double Cjs;
  double d_Cjs_dV_bp_ei;
  double d_Cjs_dV_bi_ei;
  double d_Cjs_dV_si_ci;
  double d_Cjs_dV_b_ci;
  double d_Cjs_dV_bp_ci;
  double d_Cjs_dV_tnode_GND;
  double d_Cjs_dV_bi_ci;
  double Qjs;
  double d_Qjs_dV_bp_ei;
  double d_Qjs_dV_bi_ei;
  double d_Qjs_dV_si_ci;
  double d_Qjs_dV_b_ci;
  double d_Qjs_dV_bp_ci;
  double d_Qjs_dV_tnode_GND;
  double d_Qjs_dV_bi_ci;
  double Cscp;
  double d_Cscp_dV_bp_ei;
  double d_Cscp_dV_bi_ei;
  double d_Cscp_dV_s_c;
  double d_Cscp_dV_si_ci;
  double d_Cscp_dV_b_ci;
  double d_Cscp_dV_bp_ci;
  double d_Cscp_dV_tnode_GND;
  double d_Cscp_dV_bi_ci;
  double Qscp;
  double d_Qscp_dV_bp_ei;
  double d_Qscp_dV_bi_ei;
  double d_Qscp_dV_s_c;
  double d_Qscp_dV_si_ci;
  double d_Qscp_dV_b_ci;
  double d_Qscp_dV_bp_ci;
  double d_Qscp_dV_tnode_GND;
  double d_Qscp_dV_bi_ci;
  double HSUM;
  double d_HSUM_dV_tnode_GND;
  double HSa;
  double d_HSa_dV_bp_ci;
  double d_HSa_dV_tnode_GND;
  double HSb;
  double d_HSb_dV_si_ci;
  double d_HSb_dV_tnode_GND;
  double HSI_Tsu;
  double d_HSI_Tsu_dV_tnode_GND;
  double d_HSI_Tsu_dV_bp_ci;
  double d_HSI_Tsu_dV_si_ci;
  double Qdsu;
  double d_Qdsu_dV_tnode_GND;
  double d_Qdsu_dV_bp_ci;
  double pterm;
  double d_pterm_dV_b_bp;
  double d_pterm_dV_ci_c;
  double d_pterm_dV_ei_e;
  double d_pterm_dV_bp_bi;
  double d_pterm_dV_bp_ei;
  double d_pterm_dV_bp_ci;
  double d_pterm_dV_si_ci;
  double d_pterm_dV_bi_ei;
  double d_pterm_dV_bi_ci;
  double d_pterm_dV_tnode_GND;
  double Itxf;
  double d_Itxf_dV_xf2_GND;
  double d_Itxf_dV_tnode_GND;
  double d_Itxf_dV_bi_ei;
  double d_Itxf_dV_bi_ci;
  double Qdeix;
  double d_Qdeix_dV_xf_GND;
  double d_Qdeix_dV_tnode_GND;
  double d_Qdeix_dV_bi_ci;
  double d_Qdeix_dV_bi_ei;
  double Vxf1;
  double d_Vxf1_dV_xf1_GND;
  double Vxf2;
  double d_Vxf2_dV_xf2_GND;
  double Ixf1;
  double d_Ixf1_dV_xf1_GND;
  double d_Ixf1_dV_xf2_GND;
  double d_Ixf1_dV_tnode_GND;
  double d_Ixf1_dV_bi_ei;
  double d_Ixf1_dV_bi_ci;
  double Ixf2;
  double d_Ixf2_dV_xf2_GND;
  double d_Ixf2_dV_xf1_GND;
  double d_Ixf2_dV_bi_ei;
  double d_Ixf2_dV_tnode_GND;
  double d_Ixf2_dV_bi_ci;
  double Qxf1;
  double d_Qxf1_dV_xf1_GND;
  double Qxf2;
  double d_Qxf2_dV_xf2_GND;
  double Vxf;
  double d_Vxf_dV_xf_GND;
  double fact;
  double d_fact_dV_bi_ei;
  double d_fact_dV_tnode_GND;
  double d_fact_dV_bi_ci;
  double Ixf;
  double d_Ixf_dV_xf_GND;
  double d_Ixf_dV_tnode_GND;
  double d_Ixf_dV_bi_ci;
  double d_Ixf_dV_bi_ei;
  double Qxf;
  double d_Qxf_dV_xf_GND;
  double Vsc;
  double d_Vsc_dV_s_c;
  double Vsici;
  double d_Vsici_dV_si_ci;
  double Vbci;
  double d_Vbci_dV_b_ci;
  double Vbpci;
  double d_Vbpci_dV_bp_ci;
  double Vbpei;
  double d_Vbpei_dV_bp_ei;
  double Vciei;
  double d_Vciei_dV_bi_ei;
  double d_Vciei_dV_bi_ci;
  double Vbici;
  double d_Vbici_dV_bi_ci;
  double Vbiei;
  double d_Vbiei_dV_bi_ei;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (21))
  {
    probeVars.resize(21);
    d_probeVars.resize(21);
    for (int i=0;i<21;i++)
    {
      d_probeVars[i].resize(21);
      for (int j=0;j<21;j++)
        d_probeVars[i][j]=0.0;
    }
    staticContributions.resize(15+0);
    d_staticContributions.resize(15+0);
    for (int i=0;i<15+0;i++)
      d_staticContributions[i].resize(21);
    dynamicContributions.resize(15+0);
    d_dynamicContributions.resize(15+0);
    for (int i=0;i<15+0;i++)
      d_dynamicContributions[i].resize(21);
  }

  noiseContribsPower.resize(17);
  noiseContribsExponent.resize(17);

  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 15+0 ; ++i)
  {
    staticContributions[i]=0;
    for (int j=0;j<21;j++)
      d_staticContributions[i][j] = 0.0;
    dynamicContributions[i]=0;
    for (int j=0;j<21;j++)
      d_dynamicContributions[i][j] = 0.0;
  }

  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_n2_GND] = (*solVectorPtr)[li_n2];
  d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND] = 1.0;
  probeVars[admsProbeID_V_n1_GND] = (*solVectorPtr)[li_n1];
  d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND] = 1.0;
  probeVars[admsProbeID_V_si_s] = (*solVectorPtr)[li_si] - (*solVectorPtr)[li_s];
  d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s] = 1.0;
  probeVars[admsProbeID_V_bp_e] = (*solVectorPtr)[li_bp] - (*solVectorPtr)[li_e];
  d_probeVars[admsProbeID_V_bp_e][admsProbeID_V_bp_e] = 1.0;
  probeVars[admsProbeID_V_b_e] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_e];
  d_probeVars[admsProbeID_V_b_e][admsProbeID_V_b_e] = 1.0;
  probeVars[admsProbeID_V_ci_ei] = (*solVectorPtr)[li_ci] - (*solVectorPtr)[li_ei];
  d_probeVars[admsProbeID_V_ci_ei][admsProbeID_V_ci_ei] = 1.0;
  probeVars[admsProbeID_V_xf_GND] = (*solVectorPtr)[li_xf];
  d_probeVars[admsProbeID_V_xf_GND][admsProbeID_V_xf_GND] = 1.0;
  probeVars[admsProbeID_V_xf2_GND] = (*solVectorPtr)[li_xf2];
  d_probeVars[admsProbeID_V_xf2_GND][admsProbeID_V_xf2_GND] = 1.0;
  probeVars[admsProbeID_V_xf1_GND] = (*solVectorPtr)[li_xf1];
  d_probeVars[admsProbeID_V_xf1_GND][admsProbeID_V_xf1_GND] = 1.0;
  probeVars[admsProbeID_V_b_bp] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_bp];
  d_probeVars[admsProbeID_V_b_bp][admsProbeID_V_b_bp] = 1.0;
  probeVars[admsProbeID_V_ci_c] = (*solVectorPtr)[li_ci] - (*solVectorPtr)[li_c];
  d_probeVars[admsProbeID_V_ci_c][admsProbeID_V_ci_c] = 1.0;
  probeVars[admsProbeID_V_ei_e] = (*solVectorPtr)[li_ei] - (*solVectorPtr)[li_e];
  d_probeVars[admsProbeID_V_ei_e][admsProbeID_V_ei_e] = 1.0;
  probeVars[admsProbeID_V_bp_bi] = (*solVectorPtr)[li_bp] - (*solVectorPtr)[li_bi];
  d_probeVars[admsProbeID_V_bp_bi][admsProbeID_V_bp_bi] = 1.0;
  probeVars[admsProbeID_V_tnode_GND] = (*solVectorPtr)[li_tnode];
  d_probeVars[admsProbeID_V_tnode_GND][admsProbeID_V_tnode_GND] = 1.0;
  probeVars[admsProbeID_V_s_c] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_c];
  d_probeVars[admsProbeID_V_s_c][admsProbeID_V_s_c] = 1.0;
  probeVars[admsProbeID_V_si_ci] = (*solVectorPtr)[li_si] - (*solVectorPtr)[li_ci];
  d_probeVars[admsProbeID_V_si_ci][admsProbeID_V_si_ci] = 1.0;
  probeVars[admsProbeID_V_b_ci] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_ci];
  d_probeVars[admsProbeID_V_b_ci][admsProbeID_V_b_ci] = 1.0;
  probeVars[admsProbeID_V_bp_ci] = (*solVectorPtr)[li_bp] - (*solVectorPtr)[li_ci];
  d_probeVars[admsProbeID_V_bp_ci][admsProbeID_V_bp_ci] = 1.0;
  probeVars[admsProbeID_V_bp_ei] = (*solVectorPtr)[li_bp] - (*solVectorPtr)[li_ei];
  d_probeVars[admsProbeID_V_bp_ei][admsProbeID_V_bp_ei] = 1.0;
  probeVars[admsProbeID_V_bi_ci] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_ci];
  d_probeVars[admsProbeID_V_bi_ci][admsProbeID_V_bi_ci] = 1.0;
  probeVars[admsProbeID_V_bi_ei] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_ei];
  d_probeVars[admsProbeID_V_bi_ei][admsProbeID_V_bi_ei] = 1.0;
  // -- code converted from analog/code block

  d_Vbiei_dV_bi_ei = ((model_.type)*d_probeVars[admsProbeID_V_bi_ei][admsProbeID_V_bi_ei]);
  Vbiei = ((model_.type)*(probeVars[admsProbeID_V_bi_ei]));

  d_Vbici_dV_bi_ci = ((model_.type)*d_probeVars[admsProbeID_V_bi_ci][admsProbeID_V_bi_ci]);
  Vbici = ((model_.type)*(probeVars[admsProbeID_V_bi_ci]));

  d_Vciei_dV_bi_ci = (-d_Vbici_dV_bi_ci);
  d_Vciei_dV_bi_ei = d_Vbiei_dV_bi_ei;
  Vciei = (Vbiei-Vbici);

  d_Vbpei_dV_bp_ei = ((model_.type)*d_probeVars[admsProbeID_V_bp_ei][admsProbeID_V_bp_ei]);
  Vbpei = ((model_.type)*(probeVars[admsProbeID_V_bp_ei]));

  d_Vbpci_dV_bp_ci = ((model_.type)*d_probeVars[admsProbeID_V_bp_ci][admsProbeID_V_bp_ci]);
  Vbpci = ((model_.type)*(probeVars[admsProbeID_V_bp_ci]));

  d_Vbci_dV_b_ci = ((model_.type)*d_probeVars[admsProbeID_V_b_ci][admsProbeID_V_b_ci]);
  Vbci = ((model_.type)*(probeVars[admsProbeID_V_b_ci]));

  d_Vsici_dV_si_ci = ((model_.type)*d_probeVars[admsProbeID_V_si_ci][admsProbeID_V_si_ci]);
  Vsici = ((model_.type)*(probeVars[admsProbeID_V_si_ci]));

  d_Vsc_dV_s_c = ((model_.type)*d_probeVars[admsProbeID_V_s_c][admsProbeID_V_s_c]);
  Vsc = ((model_.type)*(probeVars[admsProbeID_V_s_c]));
  if ((((model_.flsh)!=0)&&((model_.rth)>=0.001)))
    //Begin block Thermal_update_with_self_heating
  {

    d_Tdev_dV_tnode_GND = d_probeVars[admsProbeID_V_tnode_GND][admsProbeID_V_tnode_GND];
    Tdev = ((Tamb+(model_.dt))+(probeVars[admsProbeID_V_tnode_GND]));
    if ((Tdev<((-100.0)+273.15)))
    {

      d_Tdev_dV_tnode_GND =  0.0;
      Tdev = ((-100.0)+273.15);
    }
    else
    {
      if ((Tdev>(326.85+273.15)))
      {

        d_Tdev_dV_tnode_GND =  0.0;
        Tdev = (326.85+273.15);
      }
    }

    d_VT_dV_tnode_GND = ((1.3806503e-23*d_Tdev_dV_tnode_GND)/1.6021766208e-19);
    VT = ((1.3806503e-23*Tdev)/1.6021766208e-19);

    d_dT_dV_tnode_GND = d_Tdev_dV_tnode_GND;
    dT = (Tdev-Tnom);

    d_qtt0_dV_tnode_GND = (d_Tdev_dV_tnode_GND/Tnom);
    qtt0 = (Tdev/Tnom);
    {
      double value_log_0 = log(qtt0);
      double  deriv_log_0_d0 = (1.0/qtt0);

      d_ln_qtt0_dV_tnode_GND = (deriv_log_0_d0*(d_qtt0_dV_tnode_GND));
      ln_qtt0 = value_log_0;
    }
    {
      double value_log_0 = log(Tdev);
      double  deriv_log_0_d0 = (1.0/Tdev);

      d_k1_dV_tnode_GND = ((((model_.f1vg)*Tdev)*(deriv_log_0_d0*(d_Tdev_dV_tnode_GND)))+(((model_.f1vg)*d_Tdev_dV_tnode_GND)*value_log_0));
      k1 = (((model_.f1vg)*Tdev)*value_log_0);
    }

    d_k2_dV_tnode_GND = ((model_.f2vg)*d_Tdev_dV_tnode_GND);
    k2 = ((model_.f2vg)*Tdev);

    d_vgb_t_dV_tnode_GND = (d_k1_dV_tnode_GND+d_k2_dV_tnode_GND);
    vgb_t = (((model_.vgb)+k1)+k2);

    d_vge_t_dV_tnode_GND = (d_k1_dV_tnode_GND+d_k2_dV_tnode_GND);
    vge_t = (((model_.vge)+k1)+k2);

    d_vgbe_t_dV_tnode_GND = ((d_vgb_t_dV_tnode_GND+d_vge_t_dV_tnode_GND)/2);
    vgbe_t = ((vgb_t+vge_t)/2);
    if (((model_.cjei0)>0.0))
    {
      {
        double value_exp_0 = exp((((model_.vdei)*0.5)/vt0));
        double value_exp_1 = exp((((-0.5)*(model_.vdei))/vt0));
        double value_log_2 = log((value_exp_0-value_exp_1));
        vdj0 = ((2*vt0)*value_log_2);
      }

      d_vdjt_dV_tnode_GND = (((vdj0*d_qtt0_dV_tnode_GND)+(vgbe0*(-d_qtt0_dV_tnode_GND)))-(((mg*VT)*d_ln_qtt0_dV_tnode_GND)+((mg*d_VT_dV_tnode_GND)*ln_qtt0)));
      vdjt = (((vdj0*qtt0)+(vgbe0*(1-qtt0)))-((mg*VT)*ln_qtt0));
      {
        double value_exp_0 = exp(((-vdjt)/VT));
        double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
        double value_log_2 = log((0.5*(1+value_sqrt_1)));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
        double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));

        d_vdt_dV_tnode_GND = (d_vdjt_dV_tnode_GND+(((2*VT)*(deriv_log_2_d0*((0.5*(deriv_sqrt_1_d0*((4*(deriv_exp_0_d0*(((VT*(-d_vdjt_dV_tnode_GND)-(-vdjt)*d_VT_dV_tnode_GND)/VT/VT))))))))))+((2*d_VT_dV_tnode_GND)*value_log_2)));
        vdt = (vdjt+((2*VT)*value_log_2));
      }

      d_vdei_t_dV_tnode_GND = d_vdt_dV_tnode_GND;
      vdei_t = vdt;
      {
        double value_log_0 = log(((model_.vdei)/vdei_t));
        double value_exp_1 = exp(((model_.zei)*value_log_0));
        double  deriv_log_0_d0 = (1.0/((model_.vdei)/vdei_t));
        double  deriv_exp_1_d0 = value_exp_1;

        d_cjei0_t_dV_tnode_GND = ((model_.cjei0)*(deriv_exp_1_d0*(((model_.zei)*(deriv_log_0_d0*((-(model_.vdei)*d_vdei_t_dV_tnode_GND/vdei_t/vdei_t)))))));
        cjei0_t = ((model_.cjei0)*value_exp_1);
      }
      if ((1==1))
      {

        d_ajei_t_dV_tnode_GND = (((model_.ajei)*d_vdei_t_dV_tnode_GND)/(model_.vdei));
        ajei_t = (((model_.ajei)*vdei_t)/(model_.vdei));
      }
      else
      {

        d_ajei_t_dV_tnode_GND =  0.0;
        ajei_t = (model_.ajei);
      }
    }
    else
    {

      d_cjei0_t_dV_tnode_GND =  0.0;
      cjei0_t = (model_.cjei0);

      d_vdei_t_dV_tnode_GND =  0.0;
      vdei_t = (model_.vdei);

      d_ajei_t_dV_tnode_GND =  0.0;
      ajei_t = (model_.ajei);
    }
    if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
    {

      d_V_gT_dV_tnode_GND = ((((3.0*VT)*d_ln_qtt0_dV_tnode_GND)+((3.0*d_VT_dV_tnode_GND)*ln_qtt0))+((model_.vgb)*d_qtt0_dV_tnode_GND));
      V_gT = (((3.0*VT)*ln_qtt0)+((model_.vgb)*(qtt0-1.0)));

      d_r_VgVT_dV_tnode_GND = ((VT*d_V_gT_dV_tnode_GND-V_gT*d_VT_dV_tnode_GND)/VT/VT);
      r_VgVT = (V_gT/VT);

      d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
      d_a_dV_tnode_GND = ((((model_.mcf)*d_r_VgVT_dV_tnode_GND)/(model_.mbei))-((model_.alb)*d_dT_dV_tnode_GND));
      a = ((((model_.mcf)*r_VgVT)/(model_.mbei))-((model_.alb)*dT));
      {
        double value_exp_0 = exp(a);
        double  deriv_exp_0_d0 = value_exp_0;

        d_ibeis_t_dV_tnode_GND = ((model_.ibeis)*(deriv_exp_0_d0*(d_a_dV_tnode_GND)));
        ibeis_t = ((model_.ibeis)*value_exp_0);
      }

      d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
      d_a_dV_tnode_GND = ((((model_.mcf)*d_r_VgVT_dV_tnode_GND)/(model_.mrei))-((model_.alb)*d_dT_dV_tnode_GND));
      a = ((((model_.mcf)*r_VgVT)/(model_.mrei))-((model_.alb)*dT));
      {
        double value_exp_0 = exp(a);
        double  deriv_exp_0_d0 = value_exp_0;

        d_ireis_t_dV_tnode_GND = ((model_.ireis)*(deriv_exp_0_d0*(d_a_dV_tnode_GND)));
        ireis_t = ((model_.ireis)*value_exp_0);
      }

      d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
      d_a_dV_tnode_GND = ((((model_.mcf)*d_r_VgVT_dV_tnode_GND)/(model_.mbep))-((model_.alb)*d_dT_dV_tnode_GND));
      a = ((((model_.mcf)*r_VgVT)/(model_.mbep))-((model_.alb)*dT));
      {
        double value_exp_0 = exp(a);
        double  deriv_exp_0_d0 = value_exp_0;

        d_ibeps_t_dV_tnode_GND = ((model_.ibeps)*(deriv_exp_0_d0*(d_a_dV_tnode_GND)));
        ibeps_t = ((model_.ibeps)*value_exp_0);
      }

      d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
      d_a_dV_tnode_GND = ((((model_.mcf)*d_r_VgVT_dV_tnode_GND)/(model_.mrep))-((model_.alb)*d_dT_dV_tnode_GND));
      a = ((((model_.mcf)*r_VgVT)/(model_.mrep))-((model_.alb)*dT));
      {
        double value_exp_0 = exp(a);
        double  deriv_exp_0_d0 = value_exp_0;

        d_ireps_t_dV_tnode_GND = ((model_.ireps)*(deriv_exp_0_d0*(d_a_dV_tnode_GND)));
        ireps_t = ((model_.ireps)*value_exp_0);
      }

      d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
      d_a_dV_tnode_GND = (d_r_VgVT_dV_tnode_GND/(model_.mbci));
      a = (r_VgVT/(model_.mbci));
      {
        double value_exp_0 = exp(a);
        double  deriv_exp_0_d0 = value_exp_0;

        d_ibcis_t_dV_tnode_GND = ((model_.ibcis)*(deriv_exp_0_d0*(d_a_dV_tnode_GND)));
        ibcis_t = ((model_.ibcis)*value_exp_0);
      }

      d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
      d_a_dV_tnode_GND = (d_r_VgVT_dV_tnode_GND/(model_.mbcx));
      a = (r_VgVT/(model_.mbcx));
      {
        double value_exp_0 = exp(a);
        double  deriv_exp_0_d0 = value_exp_0;

        d_ibcxs_t_dV_tnode_GND = ((model_.ibcxs)*(deriv_exp_0_d0*(d_a_dV_tnode_GND)));
        ibcxs_t = ((model_.ibcxs)*value_exp_0);
      }

      d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
      d_a_dV_tnode_GND = (d_r_VgVT_dV_tnode_GND/(model_.msf));
      a = (r_VgVT/(model_.msf));
      {
        double value_exp_0 = exp(a);
        double  deriv_exp_0_d0 = value_exp_0;

        d_itss_t_dV_tnode_GND = ((model_.itss)*(deriv_exp_0_d0*(d_a_dV_tnode_GND)));
        itss_t = ((model_.itss)*value_exp_0);
      }

      d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
      d_a_dV_tnode_GND = (d_r_VgVT_dV_tnode_GND/(model_.msc));
      a = (r_VgVT/(model_.msc));
      {
        double value_exp_0 = exp(a);
        double  deriv_exp_0_d0 = value_exp_0;

        d_iscs_t_dV_tnode_GND = ((model_.iscs)*(deriv_exp_0_d0*(d_a_dV_tnode_GND)));
        iscs_t = ((model_.iscs)*value_exp_0);
      }

      d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
      d_a_dV_tnode_GND = (d_vdei_t_dV_tnode_GND/(model_.vdei));
      a = (vdei_t/(model_.vdei));

      d_qp0_t_dV_tnode_GND = ((model_.qp0)*((0.5*(model_.zei))*(-d_a_dV_tnode_GND)));
      qp0_t = ((model_.qp0)*(1.0+((0.5*(model_.zei))*(1.0-a))));
      {
        double value_exp_0 = exp(((model_.zetaci)*ln_qtt0));
        double  deriv_exp_0_d0 = value_exp_0;

        d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
        d_a_dV_tnode_GND = ((((model_.vlim)*(1.0-((model_.alvs)*dT)))*(deriv_exp_0_d0*(((model_.zetaci)*d_ln_qtt0_dV_tnode_GND))))+(((model_.vlim)*(-((model_.alvs)*d_dT_dV_tnode_GND)))*value_exp_0));
        a = (((model_.vlim)*(1.0-((model_.alvs)*dT)))*value_exp_0);
      }

      d_k_dV_tnode_GND = ((VT*(d_a_dV_tnode_GND-d_VT_dV_tnode_GND)-(a-VT)*d_VT_dV_tnode_GND)/VT/VT);
      k = ((a-VT)/VT);
      if ((k<11.0))
      {
        {
          double value_exp_0 = exp(k);
          double value_log_1 = log((1.0+value_exp_0));
          double  deriv_exp_0_d0 = value_exp_0;
          double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

          d_vlim_t_dV_tnode_GND = (d_VT_dV_tnode_GND+((VT*(deriv_log_1_d0*((deriv_exp_0_d0*(d_k_dV_tnode_GND)))))+(d_VT_dV_tnode_GND*value_log_1)));
          vlim_t = (VT+(VT*value_log_1));
        }
      }
      else
      {

        d_vlim_t_dV_tnode_GND = d_a_dV_tnode_GND;
        vlim_t = a;
      }

      d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
      d_a_dV_tnode_GND = ((model_.alb)*d_dT_dV_tnode_GND);
      a = (1.0+((model_.alb)*dT));
      {
        double value_sqrt_0 = sqrt(((a*a)+0.01));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_k_dV_tnode_GND = (0.5*(d_a_dV_tnode_GND+(deriv_sqrt_0_d0*(((a*d_a_dV_tnode_GND)+(d_a_dV_tnode_GND*a))))));
        k = (0.5*(a+value_sqrt_0));
      }

      d_tef0_t_dV_tnode_GND = ((k*((model_.tef0)*d_qtt0_dV_tnode_GND)-((model_.tef0)*qtt0)*d_k_dV_tnode_GND)/k/k);
      tef0_t = (((model_.tef0)*qtt0)/k);
    }
    else
    {
      {
        double value_exp_0 = exp((((model_.zetabet)*ln_qtt0)+(((model_.vge)/VT)*(qtt0-1))));
        double  deriv_exp_0_d0 = value_exp_0;

        d_ibeis_t_dV_tnode_GND = ((model_.ibeis)*(deriv_exp_0_d0*((((model_.zetabet)*d_ln_qtt0_dV_tnode_GND)+((((model_.vge)/VT)*d_qtt0_dV_tnode_GND)+((-(model_.vge)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))))));
        ibeis_t = ((model_.ibeis)*value_exp_0);
      }
      if (((model_.flcomp)>=2.3))
      {
        {
          double value_exp_0 = exp((((mg/(model_.mrei))*ln_qtt0)+((vgbe0/((model_.mrei)*VT))*(qtt0-1))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_ireis_t_dV_tnode_GND = ((model_.ireis)*(deriv_exp_0_d0*((((mg/(model_.mrei))*d_ln_qtt0_dV_tnode_GND)+(((vgbe0/((model_.mrei)*VT))*d_qtt0_dV_tnode_GND)+((-vgbe0*((model_.mrei)*d_VT_dV_tnode_GND)/((model_.mrei)*VT)/((model_.mrei)*VT))*(qtt0-1)))))));
          ireis_t = ((model_.ireis)*value_exp_0);
        }
      }
      else
      {
        {
          double value_exp_0 = exp((((0.5*mg)*ln_qtt0)+(((0.5*vgbe0)/VT)*(qtt0-1))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_ireis_t_dV_tnode_GND = ((model_.ireis)*(deriv_exp_0_d0*((((0.5*mg)*d_ln_qtt0_dV_tnode_GND)+((((0.5*vgbe0)/VT)*d_qtt0_dV_tnode_GND)+((-(0.5*vgbe0)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))))));
          ireis_t = ((model_.ireis)*value_exp_0);
        }
      }
      {
        double value_exp_0 = exp((((model_.zetabet)*ln_qtt0)+(((model_.vge)/VT)*(qtt0-1))));
        double  deriv_exp_0_d0 = value_exp_0;

        d_ibeps_t_dV_tnode_GND = ((model_.ibeps)*(deriv_exp_0_d0*((((model_.zetabet)*d_ln_qtt0_dV_tnode_GND)+((((model_.vge)/VT)*d_qtt0_dV_tnode_GND)+((-(model_.vge)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))))));
        ibeps_t = ((model_.ibeps)*value_exp_0);
      }
      if (((model_.flcomp)>=2.3))
      {
        {
          double value_exp_0 = exp((((mg/(model_.mrep))*ln_qtt0)+((vgbe0/((model_.mrep)*VT))*(qtt0-1))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_ireps_t_dV_tnode_GND = ((model_.ireps)*(deriv_exp_0_d0*((((mg/(model_.mrep))*d_ln_qtt0_dV_tnode_GND)+(((vgbe0/((model_.mrep)*VT))*d_qtt0_dV_tnode_GND)+((-vgbe0*((model_.mrep)*d_VT_dV_tnode_GND)/((model_.mrep)*VT)/((model_.mrep)*VT))*(qtt0-1)))))));
          ireps_t = ((model_.ireps)*value_exp_0);
        }
      }
      else
      {
        {
          double value_exp_0 = exp((((0.5*mg)*ln_qtt0)+(((0.5*vgbe0)/VT)*(qtt0-1))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_ireps_t_dV_tnode_GND = ((model_.ireps)*(deriv_exp_0_d0*((((0.5*mg)*d_ln_qtt0_dV_tnode_GND)+((((0.5*vgbe0)/VT)*d_qtt0_dV_tnode_GND)+((-(0.5*vgbe0)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))))));
          ireps_t = ((model_.ireps)*value_exp_0);
        }
      }
      {
        double value_exp_0 = exp(((zetabci*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1))));
        double  deriv_exp_0_d0 = value_exp_0;

        d_ibcis_t_dV_tnode_GND = ((model_.ibcis)*(deriv_exp_0_d0*(((zetabci*d_ln_qtt0_dV_tnode_GND)+((((model_.vgc)/VT)*d_qtt0_dV_tnode_GND)+((-(model_.vgc)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))))));
        ibcis_t = ((model_.ibcis)*value_exp_0);
      }
      {
        double value_exp_0 = exp(((zetabcxt*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1))));
        double  deriv_exp_0_d0 = value_exp_0;

        d_ibcxs_t_dV_tnode_GND = ((model_.ibcxs)*(deriv_exp_0_d0*(((zetabcxt*d_ln_qtt0_dV_tnode_GND)+((((model_.vgc)/VT)*d_qtt0_dV_tnode_GND)+((-(model_.vgc)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))))));
        ibcxs_t = ((model_.ibcxs)*value_exp_0);
      }
      {
        double value_exp_0 = exp(((zetasct*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1))));
        double  deriv_exp_0_d0 = value_exp_0;

        d_itss_t_dV_tnode_GND = ((model_.itss)*(deriv_exp_0_d0*(((zetasct*d_ln_qtt0_dV_tnode_GND)+((((model_.vgc)/VT)*d_qtt0_dV_tnode_GND)+((-(model_.vgc)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))))));
        itss_t = ((model_.itss)*value_exp_0);
      }
      {
        double value_exp_0 = exp(((zetasct*ln_qtt0)+(((model_.vgs)/VT)*(qtt0-1))));
        double  deriv_exp_0_d0 = value_exp_0;

        d_iscs_t_dV_tnode_GND = ((model_.iscs)*(deriv_exp_0_d0*(((zetasct*d_ln_qtt0_dV_tnode_GND)+((((model_.vgs)/VT)*d_qtt0_dV_tnode_GND)+((-(model_.vgs)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))))));
        iscs_t = ((model_.iscs)*value_exp_0);
      }
      {
        double value_log_0 = log((vdei_t/(model_.vdei)));
        double value_exp_1 = exp(((model_.zei)*value_log_0));
        double  deriv_log_0_d0 = (1.0/(vdei_t/(model_.vdei)));
        double  deriv_exp_1_d0 = value_exp_1;

        d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
        d_a_dV_tnode_GND = (deriv_exp_1_d0*(((model_.zei)*(deriv_log_0_d0*((d_vdei_t_dV_tnode_GND/(model_.vdei)))))));
        a = value_exp_1;
      }

      d_qp0_t_dV_tnode_GND = ((model_.qp0)*(-d_a_dV_tnode_GND));
      qp0_t = ((model_.qp0)*(2.0-a));
      {
        double value_exp_0 = exp((((model_.zetaci)-avs)*ln_qtt0));
        double  deriv_exp_0_d0 = value_exp_0;

        d_vlim_t_dV_tnode_GND = ((model_.vlim)*(deriv_exp_0_d0*((((model_.zetaci)-avs)*d_ln_qtt0_dV_tnode_GND))));
        vlim_t = ((model_.vlim)*value_exp_0);
      }
      if (((model_.flcomp)>=2.3))
      {

        d_tef0_t_dV_tnode_GND =  0.0;
        tef0_t = (model_.tef0);
      }
      else
      {
        zetatef = (((model_.zetabet)-(model_.zetact))-0.5);
        dvg0 = ((model_.vgb)-(model_.vge));
        {
          double value_exp_0 = exp(((zetatef*ln_qtt0)-((dvg0/VT)*(qtt0-1))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_tef0_t_dV_tnode_GND = ((model_.tef0)*(deriv_exp_0_d0*(((zetatef*d_ln_qtt0_dV_tnode_GND)-(((dvg0/VT)*d_qtt0_dV_tnode_GND)+((-dvg0*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))))));
          tef0_t = ((model_.tef0)*value_exp_0);
        }
      }
    }
    {
      double value_exp_0 = exp((((model_.zetact)*ln_qtt0)+(((model_.vgb)/VT)*(qtt0-1))));
      double  deriv_exp_0_d0 = value_exp_0;

      d_c10_t_dV_tnode_GND = ((model_.c10)*(deriv_exp_0_d0*((((model_.zetact)*d_ln_qtt0_dV_tnode_GND)+((((model_.vgb)/VT)*d_qtt0_dV_tnode_GND)+((-(model_.vgb)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))))));
      c10_t = ((model_.c10)*value_exp_0);
    }
    {
      double value_exp_0 = exp(((model_.zetaci)*ln_qtt0));
      double  deriv_exp_0_d0 = value_exp_0;

      d_rci0_t_dV_tnode_GND = ((model_.rci0)*(deriv_exp_0_d0*(((model_.zetaci)*d_ln_qtt0_dV_tnode_GND))));
      rci0_t = ((model_.rci0)*value_exp_0);
    }

    d_vces_t_dV_tnode_GND = ((model_.vces)*((model_.alces)*d_dT_dV_tnode_GND));
    vces_t = ((model_.vces)*(1+((model_.alces)*dT)));
    if (((model_.cjci0)>0.0))
    {
      {
        double value_exp_0 = exp((((model_.vdci)*0.5)/vt0));
        double value_exp_1 = exp((((-0.5)*(model_.vdci))/vt0));
        double value_log_2 = log((value_exp_0-value_exp_1));
        vdj0 = ((2*vt0)*value_log_2);
      }

      d_vdjt_dV_tnode_GND = (((vdj0*d_qtt0_dV_tnode_GND)+(vgbc0*(-d_qtt0_dV_tnode_GND)))-(((mg*VT)*d_ln_qtt0_dV_tnode_GND)+((mg*d_VT_dV_tnode_GND)*ln_qtt0)));
      vdjt = (((vdj0*qtt0)+(vgbc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
      {
        double value_exp_0 = exp(((-vdjt)/VT));
        double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
        double value_log_2 = log((0.5*(1+value_sqrt_1)));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
        double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));

        d_vdt_dV_tnode_GND = (d_vdjt_dV_tnode_GND+(((2*VT)*(deriv_log_2_d0*((0.5*(deriv_sqrt_1_d0*((4*(deriv_exp_0_d0*(((VT*(-d_vdjt_dV_tnode_GND)-(-vdjt)*d_VT_dV_tnode_GND)/VT/VT))))))))))+((2*d_VT_dV_tnode_GND)*value_log_2)));
        vdt = (vdjt+((2*VT)*value_log_2));
      }

      d_vdci_t_dV_tnode_GND = d_vdt_dV_tnode_GND;
      vdci_t = vdt;
      {
        double value_log_0 = log(((model_.vdci)/vdci_t));
        double value_exp_1 = exp(((model_.zci)*value_log_0));
        double  deriv_log_0_d0 = (1.0/((model_.vdci)/vdci_t));
        double  deriv_exp_1_d0 = value_exp_1;

        d_cjci0_t_dV_tnode_GND = ((model_.cjci0)*(deriv_exp_1_d0*(((model_.zci)*(deriv_log_0_d0*((-(model_.vdci)*d_vdci_t_dV_tnode_GND/vdci_t/vdci_t)))))));
        cjci0_t = ((model_.cjci0)*value_exp_1);
      }
      if ((0==1))
      {

        d_vptci_t_dV_tnode_GND = (((model_.vptci)*d_vdci_t_dV_tnode_GND)/(model_.vdci));
        vptci_t = (((model_.vptci)*vdci_t)/(model_.vdci));
      }
      else
      {

        d_vptci_t_dV_tnode_GND =  0.0;
        vptci_t = (model_.vptci);
      }
    }
    else
    {

      d_cjci0_t_dV_tnode_GND =  0.0;
      cjci0_t = (model_.cjci0);

      d_vdci_t_dV_tnode_GND =  0.0;
      vdci_t = (model_.vdci);

      d_vptci_t_dV_tnode_GND =  0.0;
      vptci_t = (model_.vptci);
    }

    d_t0_t_dV_tnode_GND = ((model_.t0)*(((model_.alt0)*d_dT_dV_tnode_GND)+((((model_.kt0)*dT)*d_dT_dV_tnode_GND)+(((model_.kt0)*d_dT_dV_tnode_GND)*dT))));
    t0_t = ((model_.t0)*((1+((model_.alt0)*dT))+(((model_.kt0)*dT)*dT)));
    {
      double value_exp_0 = exp((((model_.zetaci)-1)*ln_qtt0));
      double  deriv_exp_0_d0 = value_exp_0;

      d_thcs_t_dV_tnode_GND = ((model_.thcs)*(deriv_exp_0_d0*((((model_.zetaci)-1)*d_ln_qtt0_dV_tnode_GND))));
      thcs_t = ((model_.thcs)*value_exp_0);
    }
    {
      double value_exp_0 = exp(((model_.alfav)*dT));
      double  deriv_exp_0_d0 = value_exp_0;

      d_favl_t_dV_tnode_GND = ((model_.favl)*(deriv_exp_0_d0*(((model_.alfav)*d_dT_dV_tnode_GND))));
      favl_t = ((model_.favl)*value_exp_0);
    }
    {
      double value_exp_0 = exp(((model_.alqav)*dT));
      double  deriv_exp_0_d0 = value_exp_0;

      d_qavl_t_dV_tnode_GND = ((model_.qavl)*(deriv_exp_0_d0*(((model_.alqav)*d_dT_dV_tnode_GND))));
      qavl_t = ((model_.qavl)*value_exp_0);
    }
    {
      double value_exp_0 = exp(((model_.alkav)*dT));
      double  deriv_exp_0_d0 = value_exp_0;

      d_kavl_t_dV_tnode_GND = ((model_.kavl)*(deriv_exp_0_d0*(((model_.alkav)*d_dT_dV_tnode_GND))));
      kavl_t = ((model_.kavl)*value_exp_0);
    }
    {
      double value_exp_0 = exp(((model_.zetarbi)*ln_qtt0));
      double  deriv_exp_0_d0 = value_exp_0;

      d_rbi0_t_dV_tnode_GND = ((model_.rbi0)*(deriv_exp_0_d0*(((model_.zetarbi)*d_ln_qtt0_dV_tnode_GND))));
      rbi0_t = ((model_.rbi0)*value_exp_0);
    }
    if (((model_.cjep0)>0.0))
    {
      {
        double value_exp_0 = exp((((model_.vdep)*0.5)/vt0));
        double value_exp_1 = exp((((-0.5)*(model_.vdep))/vt0));
        double value_log_2 = log((value_exp_0-value_exp_1));
        vdj0 = ((2*vt0)*value_log_2);
      }

      d_vdjt_dV_tnode_GND = (((vdj0*d_qtt0_dV_tnode_GND)+(vgbe0*(-d_qtt0_dV_tnode_GND)))-(((mg*VT)*d_ln_qtt0_dV_tnode_GND)+((mg*d_VT_dV_tnode_GND)*ln_qtt0)));
      vdjt = (((vdj0*qtt0)+(vgbe0*(1-qtt0)))-((mg*VT)*ln_qtt0));
      {
        double value_exp_0 = exp(((-vdjt)/VT));
        double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
        double value_log_2 = log((0.5*(1+value_sqrt_1)));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
        double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));

        d_vdt_dV_tnode_GND = (d_vdjt_dV_tnode_GND+(((2*VT)*(deriv_log_2_d0*((0.5*(deriv_sqrt_1_d0*((4*(deriv_exp_0_d0*(((VT*(-d_vdjt_dV_tnode_GND)-(-vdjt)*d_VT_dV_tnode_GND)/VT/VT))))))))))+((2*d_VT_dV_tnode_GND)*value_log_2)));
        vdt = (vdjt+((2*VT)*value_log_2));
      }

      d_vdep_t_dV_tnode_GND = d_vdt_dV_tnode_GND;
      vdep_t = vdt;
      {
        double value_log_0 = log(((model_.vdep)/vdep_t));
        double value_exp_1 = exp(((model_.zep)*value_log_0));
        double  deriv_log_0_d0 = (1.0/((model_.vdep)/vdep_t));
        double  deriv_exp_1_d0 = value_exp_1;

        d_cjep0_t_dV_tnode_GND = ((model_.cjep0)*(deriv_exp_1_d0*(((model_.zep)*(deriv_log_0_d0*((-(model_.vdep)*d_vdep_t_dV_tnode_GND/vdep_t/vdep_t)))))));
        cjep0_t = ((model_.cjep0)*value_exp_1);
      }
      if ((1==1))
      {

        d_ajep_t_dV_tnode_GND = (((model_.ajep)*d_vdep_t_dV_tnode_GND)/(model_.vdep));
        ajep_t = (((model_.ajep)*vdep_t)/(model_.vdep));
      }
      else
      {

        d_ajep_t_dV_tnode_GND =  0.0;
        ajep_t = (model_.ajep);
      }
    }
    else
    {

      d_cjep0_t_dV_tnode_GND =  0.0;
      cjep0_t = (model_.cjep0);

      d_vdep_t_dV_tnode_GND =  0.0;
      vdep_t = (model_.vdep);

      d_ajep_t_dV_tnode_GND =  0.0;
      ajep_t = (model_.ajep);
    }
    if ((((model_.ibets)>0)&&((Vbpei<0.0)||(Vbiei<0.0))))
      //Begin block HICTUN_T
    {
      //Block-local variables for block HICTUN_T
      double a_eg;
      double d_a_eg_dV_tnode_GND;
      double ab;
      double d_ab_dV_tnode_GND;
      double aa;
      double d_aa_dV_tnode_GND;
      //End of Block-local variables

      d_ab_dV_tnode_GND =  0.0;
      ab = 1.0;

      d_aa_dV_tnode_GND =  0.0;
      aa = 1.0;

      d_a_eg_dV_tnode_GND = (-vgbe_t0*d_vgbe_t_dV_tnode_GND/vgbe_t/vgbe_t);
      a_eg = (vgbe_t0/vgbe_t);
      if (((((model_.tunode)==1)&&((model_.cjep0)>0.0))&&((model_.vdep)>0.0)))
      {
        {
          double value_sqrt_0 = sqrt(a_eg);
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_ab_dV_tnode_GND = ((((((cjep0_t/(model_.cjep0))*value_sqrt_0)*vdep_t)*d_vdep_t_dV_tnode_GND)+(((((cjep0_t/(model_.cjep0))*value_sqrt_0)*d_vdep_t_dV_tnode_GND)+((((cjep0_t/(model_.cjep0))*(deriv_sqrt_0_d0*(d_a_eg_dV_tnode_GND)))+((d_cjep0_t_dV_tnode_GND/(model_.cjep0))*value_sqrt_0))*vdep_t))*vdep_t))/((model_.vdep)*(model_.vdep)));
          ab = (((((cjep0_t/(model_.cjep0))*value_sqrt_0)*vdep_t)*vdep_t)/((model_.vdep)*(model_.vdep)));
        }
        {
          double value_pow_0 = pow(a_eg,(-1.5));
          double  deriv_pow_0_d0 = ((a_eg == 0.0)?0.0:(value_pow_0*(-1.5)/a_eg));

          d_aa_dV_tnode_GND = (((((model_.vdep)/vdep_t)*((model_.cjep0)/cjep0_t))*(deriv_pow_0_d0*(d_a_eg_dV_tnode_GND)))+(((((model_.vdep)/vdep_t)*(-(model_.cjep0)*d_cjep0_t_dV_tnode_GND/cjep0_t/cjep0_t))+((-(model_.vdep)*d_vdep_t_dV_tnode_GND/vdep_t/vdep_t)*((model_.cjep0)/cjep0_t)))*value_pow_0));
          aa = ((((model_.vdep)/vdep_t)*((model_.cjep0)/cjep0_t))*value_pow_0);
        }
      }
      else
      {
        if (((((model_.tunode)==0)&&((model_.cjei0)>0.0))&&((model_.vdei)>0.0)))
        {
          {
            double value_sqrt_0 = sqrt(a_eg);
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_ab_dV_tnode_GND = ((((((cjei0_t/(model_.cjei0))*value_sqrt_0)*vdei_t)*d_vdei_t_dV_tnode_GND)+(((((cjei0_t/(model_.cjei0))*value_sqrt_0)*d_vdei_t_dV_tnode_GND)+((((cjei0_t/(model_.cjei0))*(deriv_sqrt_0_d0*(d_a_eg_dV_tnode_GND)))+((d_cjei0_t_dV_tnode_GND/(model_.cjei0))*value_sqrt_0))*vdei_t))*vdei_t))/((model_.vdei)*(model_.vdei)));
            ab = (((((cjei0_t/(model_.cjei0))*value_sqrt_0)*vdei_t)*vdei_t)/((model_.vdei)*(model_.vdei)));
          }
          {
            double value_pow_0 = pow(a_eg,(-1.5));
            double  deriv_pow_0_d0 = ((a_eg == 0.0)?0.0:(value_pow_0*(-1.5)/a_eg));

            d_aa_dV_tnode_GND = (((((model_.vdei)/vdei_t)*((model_.cjei0)/cjei0_t))*(deriv_pow_0_d0*(d_a_eg_dV_tnode_GND)))+(((((model_.vdei)/vdei_t)*(-(model_.cjei0)*d_cjei0_t_dV_tnode_GND/cjei0_t/cjei0_t))+((-(model_.vdei)*d_vdei_t_dV_tnode_GND/vdei_t/vdei_t)*((model_.cjei0)/cjei0_t)))*value_pow_0));
            aa = ((((model_.vdei)/vdei_t)*((model_.cjei0)/cjei0_t))*value_pow_0);
          }
        }
      }

      d_ibets_t_dV_tnode_GND = ((model_.ibets)*d_ab_dV_tnode_GND);
      ibets_t = ((model_.ibets)*ab);

      d_abet_t_dV_tnode_GND = ((model_.abet)*d_aa_dV_tnode_GND);
      abet_t = ((model_.abet)*aa);
    }
    // End block HICTUN_T
    else
    {

      d_ibets_t_dV_tnode_GND =  0.0;
      ibets_t = 0;

      d_abet_t_dV_tnode_GND =  0.0;
      abet_t = 1;
    }
    if ((1.0>0.0))
    {
      {
        double value_exp_0 = exp((((model_.vdcx)*0.5)/vt0));
        double value_exp_1 = exp((((-0.5)*(model_.vdcx))/vt0));
        double value_log_2 = log((value_exp_0-value_exp_1));
        vdj0 = ((2*vt0)*value_log_2);
      }

      d_vdjt_dV_tnode_GND = (((vdj0*d_qtt0_dV_tnode_GND)+(vgbc0*(-d_qtt0_dV_tnode_GND)))-(((mg*VT)*d_ln_qtt0_dV_tnode_GND)+((mg*d_VT_dV_tnode_GND)*ln_qtt0)));
      vdjt = (((vdj0*qtt0)+(vgbc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
      {
        double value_exp_0 = exp(((-vdjt)/VT));
        double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
        double value_log_2 = log((0.5*(1+value_sqrt_1)));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
        double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));

        d_vdt_dV_tnode_GND = (d_vdjt_dV_tnode_GND+(((2*VT)*(deriv_log_2_d0*((0.5*(deriv_sqrt_1_d0*((4*(deriv_exp_0_d0*(((VT*(-d_vdjt_dV_tnode_GND)-(-vdjt)*d_VT_dV_tnode_GND)/VT/VT))))))))))+((2*d_VT_dV_tnode_GND)*value_log_2)));
        vdt = (vdjt+((2*VT)*value_log_2));
      }

      d_vdcx_t_dV_tnode_GND = d_vdt_dV_tnode_GND;
      vdcx_t = vdt;
      {
        double value_log_0 = log(((model_.vdcx)/vdcx_t));
        double value_exp_1 = exp(((model_.zcx)*value_log_0));
        double  deriv_log_0_d0 = (1.0/((model_.vdcx)/vdcx_t));
        double  deriv_exp_1_d0 = value_exp_1;

        d_cratio_t_dV_tnode_GND = (1.0*(deriv_exp_1_d0*(((model_.zcx)*(deriv_log_0_d0*((-(model_.vdcx)*d_vdcx_t_dV_tnode_GND/vdcx_t/vdcx_t)))))));
        cratio_t = (1.0*value_exp_1);
      }
      if ((0==1))
      {

        d_vptcx_t_dV_tnode_GND = (((model_.vptcx)*d_vdcx_t_dV_tnode_GND)/(model_.vdcx));
        vptcx_t = (((model_.vptcx)*vdcx_t)/(model_.vdcx));
      }
      else
      {

        d_vptcx_t_dV_tnode_GND =  0.0;
        vptcx_t = (model_.vptcx);
      }
    }
    else
    {

      d_cratio_t_dV_tnode_GND =  0.0;
      cratio_t = 1.0;

      d_vdcx_t_dV_tnode_GND =  0.0;
      vdcx_t = (model_.vdcx);

      d_vptcx_t_dV_tnode_GND =  0.0;
      vptcx_t = (model_.vptcx);
    }

    d_cjcx01_t_dV_tnode_GND = (d_cratio_t_dV_tnode_GND*cjcx01);
    cjcx01_t = (cratio_t*cjcx01);

    d_cjcx02_t_dV_tnode_GND = (d_cratio_t_dV_tnode_GND*cjcx02);
    cjcx02_t = (cratio_t*cjcx02);
    {
      double value_exp_0 = exp(((model_.zetarcx)*ln_qtt0));
      double  deriv_exp_0_d0 = value_exp_0;

      d_rcx_t_dV_tnode_GND = ((model_.rcx)*(deriv_exp_0_d0*(((model_.zetarcx)*d_ln_qtt0_dV_tnode_GND))));
      rcx_t = ((model_.rcx)*value_exp_0);
    }
    {
      double value_exp_0 = exp(((model_.zetarbx)*ln_qtt0));
      double  deriv_exp_0_d0 = value_exp_0;

      d_rbx_t_dV_tnode_GND = ((model_.rbx)*(deriv_exp_0_d0*(((model_.zetarbx)*d_ln_qtt0_dV_tnode_GND))));
      rbx_t = ((model_.rbx)*value_exp_0);
    }
    {
      double value_exp_0 = exp(((model_.zetare)*ln_qtt0));
      double  deriv_exp_0_d0 = value_exp_0;

      d_re_t_dV_tnode_GND = ((model_.re)*(deriv_exp_0_d0*(((model_.zetare)*d_ln_qtt0_dV_tnode_GND))));
      re_t = ((model_.re)*value_exp_0);
    }
    {
      double value_exp_0 = exp((((model_.zetacx)-1.0)*ln_qtt0));
      double  deriv_exp_0_d0 = value_exp_0;

      d_tsf_t_dV_tnode_GND = ((model_.tsf)*(deriv_exp_0_d0*((((model_.zetacx)-1.0)*d_ln_qtt0_dV_tnode_GND))));
      tsf_t = ((model_.tsf)*value_exp_0);
    }
    if (((model_.cjs0)>0.0))
    {
      {
        double value_exp_0 = exp((((model_.vds)*0.5)/vt0));
        double value_exp_1 = exp((((-0.5)*(model_.vds))/vt0));
        double value_log_2 = log((value_exp_0-value_exp_1));
        vdj0 = ((2*vt0)*value_log_2);
      }

      d_vdjt_dV_tnode_GND = (((vdj0*d_qtt0_dV_tnode_GND)+(vgsc0*(-d_qtt0_dV_tnode_GND)))-(((mg*VT)*d_ln_qtt0_dV_tnode_GND)+((mg*d_VT_dV_tnode_GND)*ln_qtt0)));
      vdjt = (((vdj0*qtt0)+(vgsc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
      {
        double value_exp_0 = exp(((-vdjt)/VT));
        double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
        double value_log_2 = log((0.5*(1+value_sqrt_1)));
        double  deriv_exp_0_d0 = value_exp_0;
        double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
        double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));

        d_vdt_dV_tnode_GND = (d_vdjt_dV_tnode_GND+(((2*VT)*(deriv_log_2_d0*((0.5*(deriv_sqrt_1_d0*((4*(deriv_exp_0_d0*(((VT*(-d_vdjt_dV_tnode_GND)-(-vdjt)*d_VT_dV_tnode_GND)/VT/VT))))))))))+((2*d_VT_dV_tnode_GND)*value_log_2)));
        vdt = (vdjt+((2*VT)*value_log_2));
      }

      d_vds_t_dV_tnode_GND = d_vdt_dV_tnode_GND;
      vds_t = vdt;
      {
        double value_log_0 = log(((model_.vds)/vds_t));
        double value_exp_1 = exp(((model_.zs)*value_log_0));
        double  deriv_log_0_d0 = (1.0/((model_.vds)/vds_t));
        double  deriv_exp_1_d0 = value_exp_1;

        d_cjs0_t_dV_tnode_GND = ((model_.cjs0)*(deriv_exp_1_d0*(((model_.zs)*(deriv_log_0_d0*((-(model_.vds)*d_vds_t_dV_tnode_GND/vds_t/vds_t)))))));
        cjs0_t = ((model_.cjs0)*value_exp_1);
      }
      if ((0==1))
      {

        d_vpts_t_dV_tnode_GND = (((model_.vpts)*d_vds_t_dV_tnode_GND)/(model_.vds));
        vpts_t = (((model_.vpts)*vds_t)/(model_.vds));
      }
      else
      {

        d_vpts_t_dV_tnode_GND =  0.0;
        vpts_t = (model_.vpts);
      }
    }
    else
    {

      d_cjs0_t_dV_tnode_GND =  0.0;
      cjs0_t = (model_.cjs0);

      d_vds_t_dV_tnode_GND =  0.0;
      vds_t = (model_.vds);

      d_vpts_t_dV_tnode_GND =  0.0;
      vpts_t = (model_.vpts);
    }
    if (((model_.vdsp)>0))
    {
      if (((model_.cscp0)>0.0))
      {
        {
          double value_exp_0 = exp((((model_.vdsp)*0.5)/vt0));
          double value_exp_1 = exp((((-0.5)*(model_.vdsp))/vt0));
          double value_log_2 = log((value_exp_0-value_exp_1));
          vdj0 = ((2*vt0)*value_log_2);
        }

        d_vdjt_dV_tnode_GND = (((vdj0*d_qtt0_dV_tnode_GND)+(vgsc0*(-d_qtt0_dV_tnode_GND)))-(((mg*VT)*d_ln_qtt0_dV_tnode_GND)+((mg*d_VT_dV_tnode_GND)*ln_qtt0)));
        vdjt = (((vdj0*qtt0)+(vgsc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
        {
          double value_exp_0 = exp(((-vdjt)/VT));
          double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
          double value_log_2 = log((0.5*(1+value_sqrt_1)));
          double  deriv_exp_0_d0 = value_exp_0;
          double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
          double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));

          d_vdt_dV_tnode_GND = (d_vdjt_dV_tnode_GND+(((2*VT)*(deriv_log_2_d0*((0.5*(deriv_sqrt_1_d0*((4*(deriv_exp_0_d0*(((VT*(-d_vdjt_dV_tnode_GND)-(-vdjt)*d_VT_dV_tnode_GND)/VT/VT))))))))))+((2*d_VT_dV_tnode_GND)*value_log_2)));
          vdt = (vdjt+((2*VT)*value_log_2));
        }

        d_vdsp_t_dV_tnode_GND = d_vdt_dV_tnode_GND;
        vdsp_t = vdt;
        {
          double value_log_0 = log(((model_.vdsp)/vdsp_t));
          double value_exp_1 = exp(((model_.zsp)*value_log_0));
          double  deriv_log_0_d0 = (1.0/((model_.vdsp)/vdsp_t));
          double  deriv_exp_1_d0 = value_exp_1;

          d_cscp0_t_dV_tnode_GND = ((model_.cscp0)*(deriv_exp_1_d0*(((model_.zsp)*(deriv_log_0_d0*((-(model_.vdsp)*d_vdsp_t_dV_tnode_GND/vdsp_t/vdsp_t)))))));
          cscp0_t = ((model_.cscp0)*value_exp_1);
        }
        if ((0==1))
        {

          d_vptsp_t_dV_tnode_GND = (((model_.vptsp)*d_vdsp_t_dV_tnode_GND)/(model_.vdsp));
          vptsp_t = (((model_.vptsp)*vdsp_t)/(model_.vdsp));
        }
        else
        {

          d_vptsp_t_dV_tnode_GND =  0.0;
          vptsp_t = (model_.vptsp);
        }
      }
      else
      {

        d_cscp0_t_dV_tnode_GND =  0.0;
        cscp0_t = (model_.cscp0);

        d_vdsp_t_dV_tnode_GND =  0.0;
        vdsp_t = (model_.vdsp);

        d_vptsp_t_dV_tnode_GND =  0.0;
        vptsp_t = (model_.vptsp);
      }
    }
    else
    {

      d_cscp0_t_dV_tnode_GND =  0.0;
      cscp0_t = (model_.cscp0);

      d_vdsp_t_dV_tnode_GND =  0.0;
      vdsp_t = (model_.vdsp);

      d_vptsp_t_dV_tnode_GND =  0.0;
      vptsp_t = (model_.vptsp);
    }
    {
      double value_exp_0 = exp(((model_.zetahjei)*ln_qtt0));
      double  deriv_exp_0_d0 = value_exp_0;

      d_ahjei_t_dV_tnode_GND = ((model_.ahjei)*(deriv_exp_0_d0*(((model_.zetahjei)*d_ln_qtt0_dV_tnode_GND))));
      ahjei_t = ((model_.ahjei)*value_exp_0);
    }
    {
      double value_log_0 = log(qtt0);
      double value_exp_1 = exp(((model_.zetavgbe)*value_log_0));
      double value_exp_2 = exp((((model_.dvgbe)/VT)*(value_exp_1-1)));
      double  deriv_log_0_d0 = (1.0/qtt0);
      double  deriv_exp_1_d0 = value_exp_1;
      double  deriv_exp_2_d0 = value_exp_2;

      d_hjei0_t_dV_tnode_GND = ((model_.hjei)*(deriv_exp_2_d0*(((((model_.dvgbe)/VT)*(deriv_exp_1_d0*(((model_.zetavgbe)*(deriv_log_0_d0*(d_qtt0_dV_tnode_GND))))))+((-(model_.dvgbe)*d_VT_dV_tnode_GND/VT/VT)*(value_exp_1-1))))));
      hjei0_t = ((model_.hjei)*value_exp_2);
    }
    {
      double value_exp_0 = exp((((model_.dvgbe)/VT)*(qtt0-1)));
      double  deriv_exp_0_d0 = value_exp_0;

      d_hf0_t_dV_tnode_GND = ((model_.hf0)*(deriv_exp_0_d0*(((((model_.dvgbe)/VT)*d_qtt0_dV_tnode_GND)+((-(model_.dvgbe)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1))))));
      hf0_t = ((model_.hf0)*value_exp_0);
    }
    if (((model_.flcomp)>=2.3))
    {
      {
        double value_exp_0 = exp(((((model_.vgb)-(model_.vge))/VT)*(qtt0-1)));
        double  deriv_exp_0_d0 = value_exp_0;

        d_hfe_t_dV_tnode_GND = ((model_.hfe)*(deriv_exp_0_d0*((((((model_.vgb)-(model_.vge))/VT)*d_qtt0_dV_tnode_GND)+((-((model_.vgb)-(model_.vge))*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1))))));
        hfe_t = ((model_.hfe)*value_exp_0);
      }
      {
        double value_exp_0 = exp(((((model_.vgb)-(model_.vgc))/VT)*(qtt0-1)));
        double  deriv_exp_0_d0 = value_exp_0;

        d_hfc_t_dV_tnode_GND = ((model_.hfc)*(deriv_exp_0_d0*((((((model_.vgb)-(model_.vgc))/VT)*d_qtt0_dV_tnode_GND)+((-((model_.vgb)-(model_.vgc))*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1))))));
        hfc_t = ((model_.hfc)*value_exp_0);
      }
    }
    else
    {

      d_hfe_t_dV_tnode_GND =  0.0;
      hfe_t = (model_.hfe);

      d_hfc_t_dV_tnode_GND =  0.0;
      hfc_t = (model_.hfc);
    }
    {
      double value_exp_0 = exp(((model_.zetarth)*ln_qtt0));
      double  deriv_exp_0_d0 = value_exp_0;

      d_rth_t_dV_tnode_GND = ((((model_.rth)*value_exp_0)*((model_.alrth)*d_dT_dV_tnode_GND))+(((model_.rth)*(deriv_exp_0_d0*(((model_.zetarth)*d_ln_qtt0_dV_tnode_GND))))*(1+((model_.alrth)*dT))));
      rth_t = (((model_.rth)*value_exp_0)*(1+((model_.alrth)*dT)));
    }
  }
  // End block Thermal_update_with_self_heating
  //Begin block Model_evaluation
  {

    d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci =  0.0;
    d_DIOY_dV_tnode_GND = (-Vbiei*((model_.mbei)*d_VT_dV_tnode_GND)/((model_.mbei)*VT)/((model_.mbei)*VT));
    d_DIOY_dV_bi_ei = (d_Vbiei_dV_bi_ei/((model_.mbei)*VT));
    DIOY = (Vbiei/((model_.mbei)*VT));
    if (((model_.ibeis)>0.0))
    {
      if ((DIOY>80.0))
      {

        d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci =  0.0;
        d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
        d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
        le = (1+(DIOY-80.0));

        d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
        DIOY = 80.0;
      }
      else
      {

        d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
        le = 1;
      }
      {
        double value_limexp_0 = limexp(DIOY);
        double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

        d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci =  0.0;
        d_le_dV_tnode_GND = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND)))+(d_le_dV_tnode_GND*value_limexp_0));
        d_le_dV_bi_ei = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei)))+(d_le_dV_bi_ei*value_limexp_0));
        le = (le*value_limexp_0);
      }

      d_ibei_dV_bi_ei = (ibeis_t*d_le_dV_bi_ei);
      d_ibei_dV_tnode_GND = ((ibeis_t*d_le_dV_tnode_GND)+(d_ibeis_t_dV_tnode_GND*(le-1.0)));
      ibei = (ibeis_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {

        d_ibei_dV_bi_ei =  0.0;
        d_ibei_dV_tnode_GND = (-d_ibeis_t_dV_tnode_GND);
        ibei = (-ibeis_t);
      }
    }
    else
    {

      d_ibei_dV_tnode_GND = d_ibei_dV_bi_ei =  0.0;
      ibei = 0.0;
    }

    d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci =  0.0;
    d_DIOY_dV_tnode_GND = (-Vbiei*((model_.mrei)*d_VT_dV_tnode_GND)/((model_.mrei)*VT)/((model_.mrei)*VT));
    d_DIOY_dV_bi_ei = (d_Vbiei_dV_bi_ei/((model_.mrei)*VT));
    DIOY = (Vbiei/((model_.mrei)*VT));
    if (((model_.ireis)>0.0))
    {
      if ((DIOY>80.0))
      {

        d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci =  0.0;
        d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
        d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
        le = (1+(DIOY-80.0));

        d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
        DIOY = 80.0;
      }
      else
      {

        d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
        le = 1;
      }
      {
        double value_limexp_0 = limexp(DIOY);
        double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

        d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci =  0.0;
        d_le_dV_tnode_GND = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND)))+(d_le_dV_tnode_GND*value_limexp_0));
        d_le_dV_bi_ei = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei)))+(d_le_dV_bi_ei*value_limexp_0));
        le = (le*value_limexp_0);
      }

      d_irei_dV_bi_ei = (ireis_t*d_le_dV_bi_ei);
      d_irei_dV_tnode_GND = ((ireis_t*d_le_dV_tnode_GND)+(d_ireis_t_dV_tnode_GND*(le-1.0)));
      irei = (ireis_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {

        d_irei_dV_bi_ei =  0.0;
        d_irei_dV_tnode_GND = (-d_ireis_t_dV_tnode_GND);
        irei = (-ireis_t);
      }
    }
    else
    {

      d_irei_dV_tnode_GND = d_irei_dV_bi_ei =  0.0;
      irei = 0.0;
    }

    d_Orci0_t_dV_tnode_GND = (-d_rci0_t_dV_tnode_GND/rci0_t/rci0_t);
    Orci0_t = (1.0/rci0_t);
    Tr = (model_.tr);

    d_VT_f_dV_tnode_GND = ((model_.mcf)*d_VT_dV_tnode_GND);
    VT_f = ((model_.mcf)*VT);
    {
      double value_limexp_0 = limexp((Vbiei/VT_f));
      double  deriv_limexp_0_d0 = ((((Vbiei/VT_f))<80)?(value_limexp_0):exp(80.0));

      d_i_0f_dV_bi_ei = (c10_t*(deriv_limexp_0_d0*((d_Vbiei_dV_bi_ei/VT_f))));
      d_i_0f_dV_tnode_GND = ((c10_t*(deriv_limexp_0_d0*((-Vbiei*d_VT_f_dV_tnode_GND/VT_f/VT_f))))+(d_c10_t_dV_tnode_GND*value_limexp_0));
      i_0f = (c10_t*value_limexp_0);
    }
    {
      double value_limexp_0 = limexp((Vbici/VT));
      double  deriv_limexp_0_d0 = ((((Vbici/VT))<80)?(value_limexp_0):exp(80.0));

      d_i_0r_dV_bi_ci = (c10_t*(deriv_limexp_0_d0*((d_Vbici_dV_bi_ci/VT))));
      d_i_0r_dV_tnode_GND = ((c10_t*(deriv_limexp_0_d0*((-Vbici*d_VT_dV_tnode_GND/VT/VT))))+(d_c10_t_dV_tnode_GND*value_limexp_0));
      i_0r = (c10_t*value_limexp_0);
    }
    if ((cjei0_t>0.0))
    {
      {
        double value_log_0 = log(ajei_t);
        double value_exp_1 = exp(((-value_log_0)/(model_.zei)));
        double  deriv_log_0_d0 = (1.0/ajei_t);
        double  deriv_exp_1_d0 = value_exp_1;

        d_DFV_f_dV_tnode_GND = ((vdei_t*(-(deriv_exp_1_d0*(((-(deriv_log_0_d0*(d_ajei_t_dV_tnode_GND)))/(model_.zei))))))+(d_vdei_t_dV_tnode_GND*(1.0-value_exp_1)));
        DFV_f = (vdei_t*(1.0-value_exp_1));
      }

      d_DFv_e_dV_s_c = d_DFv_e_dV_si_ci = d_DFv_e_dV_b_ci = d_DFv_e_dV_bp_ci = d_DFv_e_dV_bp_ei = d_DFv_e_dV_bi_ci =  0.0;
      d_DFv_e_dV_bi_ei = ((-d_Vbiei_dV_bi_ei)/VT);
      d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vbiei)*d_VT_dV_tnode_GND)/VT/VT);
      DFv_e = ((DFV_f-Vbiei)/VT);
      {
        double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_DFs_q_dV_s_c = d_DFs_q_dV_si_ci = d_DFs_q_dV_b_ci = d_DFs_q_dV_bp_ci = d_DFs_q_dV_bp_ei = d_DFs_q_dV_bi_ci =  0.0;
        d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bi_ei)+(d_DFv_e_dV_bi_ei*DFv_e))));
        d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_tnode_GND)+(d_DFv_e_dV_tnode_GND*DFv_e))));
        DFs_q = value_sqrt_0;
      }

      d_DFs_q2_dV_s_c = d_DFs_q2_dV_si_ci = d_DFs_q2_dV_b_ci = d_DFs_q2_dV_bp_ci = d_DFs_q2_dV_bp_ei = d_DFs_q2_dV_bi_ci =  0.0;
      d_DFs_q2_dV_bi_ei = ((d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5);
      d_DFs_q2_dV_tnode_GND = ((d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5);
      DFs_q2 = ((DFv_e+DFs_q)*0.5);

      d_DFv_j_dV_s_c = d_DFv_j_dV_si_ci = d_DFv_j_dV_b_ci = d_DFv_j_dV_bp_ci = d_DFv_j_dV_bp_ei = d_DFv_j_dV_bi_ci =  0.0;
      d_DFv_j_dV_bi_ei = (-(VT*d_DFs_q2_dV_bi_ei));
      d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-((VT*d_DFs_q2_dV_tnode_GND)+(d_VT_dV_tnode_GND*DFs_q2)));
      DFv_j = (DFV_f-(VT*DFs_q2));

      d_DFdvj_dv_dV_s_c = d_DFdvj_dv_dV_si_ci = d_DFdvj_dv_dV_b_ci = d_DFdvj_dv_dV_bp_ci = d_DFdvj_dv_dV_bp_ei = d_DFdvj_dv_dV_bi_ci =  0.0;
      d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
      d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
      DFdvj_dv = (DFs_q2/DFs_q);
      {
        double value_log_0 = log((1.0-(DFv_j/vdei_t)));
        double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vdei_t)));

        d_DFb_dV_s_c = d_DFb_dV_si_ci = d_DFb_dV_b_ci = d_DFb_dV_bp_ci = d_DFb_dV_bp_ei = d_DFb_dV_bi_ci =  0.0;
        d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vdei_t))));
        d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vdei_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vdei_t_dV_tnode_GND)/vdei_t/vdei_t))));
        DFb = value_log_0;
      }
      {
        double value_exp_0 = exp(((-(model_.zei))*DFb));
        double  deriv_exp_0_d0 = value_exp_0;

        d_DFC_j1_dV_s_c = d_DFC_j1_dV_si_ci = d_DFC_j1_dV_b_ci = d_DFC_j1_dV_bp_ci = d_DFC_j1_dV_bp_ei = d_DFC_j1_dV_bi_ci =  0.0;
        d_DFC_j1_dV_bi_ei = (((cjei0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei)+((cjei0_t*(deriv_exp_0_d0*(((-(model_.zei))*d_DFb_dV_bi_ei))))*DFdvj_dv));
        d_DFC_j1_dV_tnode_GND = (((cjei0_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND)+(((cjei0_t*(deriv_exp_0_d0*(((-(model_.zei))*d_DFb_dV_tnode_GND))))+(d_cjei0_t_dV_tnode_GND*value_exp_0))*DFdvj_dv));
        DFC_j1 = ((cjei0_t*value_exp_0)*DFdvj_dv);
      }

      d_Cjei_dV_bi_ei = (d_DFC_j1_dV_bi_ei+((ajei_t*cjei0_t)*(-d_DFdvj_dv_dV_bi_ei)));
      d_Cjei_dV_tnode_GND = (d_DFC_j1_dV_tnode_GND+(((ajei_t*cjei0_t)*(-d_DFdvj_dv_dV_tnode_GND))+(((ajei_t*d_cjei0_t_dV_tnode_GND)+(d_ajei_t_dV_tnode_GND*cjei0_t))*(1.0-DFdvj_dv))));
      Cjei = (DFC_j1+((ajei_t*cjei0_t)*(1.0-DFdvj_dv)));
      {
        double value_exp_0 = exp((DFb*(1.0-(model_.zei))));
        double  deriv_exp_0_d0 = value_exp_0;

        d_DFQ_j_dV_s_c = d_DFQ_j_dV_si_ci = d_DFQ_j_dV_b_ci = d_DFQ_j_dV_bp_ci = d_DFQ_j_dV_bp_ei = d_DFQ_j_dV_bi_ci =  0.0;
        d_DFQ_j_dV_bi_ei = (((cjei0_t*vdei_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bi_ei*(1.0-(model_.zei)))))))/(1.0-(model_.zei)));
        d_DFQ_j_dV_tnode_GND = ((((cjei0_t*vdei_t)*(-(deriv_exp_0_d0*((d_DFb_dV_tnode_GND*(1.0-(model_.zei)))))))+(((cjei0_t*d_vdei_t_dV_tnode_GND)+(d_cjei0_t_dV_tnode_GND*vdei_t))*(1.0-value_exp_0)))/(1.0-(model_.zei)));
        DFQ_j = (((cjei0_t*vdei_t)*(1.0-value_exp_0))/(1.0-(model_.zei)));
      }

      d_Qjei_dV_bi_ei = (d_DFQ_j_dV_bi_ei+((ajei_t*cjei0_t)*(d_Vbiei_dV_bi_ei-d_DFv_j_dV_bi_ei)));
      d_Qjei_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+(((ajei_t*cjei0_t)*(-d_DFv_j_dV_tnode_GND))+(((ajei_t*d_cjei0_t_dV_tnode_GND)+(d_ajei_t_dV_tnode_GND*cjei0_t))*(Vbiei-DFv_j))));
      Qjei = (DFQ_j+((ajei_t*cjei0_t)*(Vbiei-DFv_j)));
    }
    else
    {

      d_Cjei_dV_tnode_GND = d_Cjei_dV_bi_ei =  0.0;
      Cjei = 0.0;

      d_Qjei_dV_tnode_GND = d_Qjei_dV_bi_ei =  0.0;
      Qjei = 0.0;
    }
    if (((model_.ahjei)==0.0))
    {

      d_hjei_vbe_dV_tnode_GND = d_hjei_vbe_dV_bi_ei =  0.0;
      hjei_vbe = (model_.hjei);
    }
    else
    {

      d_vj_dV_bi_ei = ((-d_Vbiei_dV_bi_ei)/((model_.rhjei)*VT));
      d_vj_dV_tnode_GND = ((((model_.rhjei)*VT)*d_vdei_t_dV_tnode_GND-(vdei_t-Vbiei)*((model_.rhjei)*d_VT_dV_tnode_GND))/((model_.rhjei)*VT)/((model_.rhjei)*VT));
      vj = ((vdei_t-Vbiei)/((model_.rhjei)*VT));
      {
        double value_sqrt_0 = sqrt(((vj*vj)+1.921812));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_vj_dV_bi_ei = (-((((model_.rhjei)*VT)*(d_vj_dV_bi_ei+(deriv_sqrt_0_d0*(((vj*d_vj_dV_bi_ei)+(d_vj_dV_bi_ei*vj))))))*0.5));
        d_vj_dV_tnode_GND = (d_vdei_t_dV_tnode_GND-(((((model_.rhjei)*VT)*(d_vj_dV_tnode_GND+(deriv_sqrt_0_d0*(((vj*d_vj_dV_tnode_GND)+(d_vj_dV_tnode_GND*vj))))))+(((model_.rhjei)*d_VT_dV_tnode_GND)*(vj+value_sqrt_0)))*0.5));
        vj = (vdei_t-((((model_.rhjei)*VT)*(vj+value_sqrt_0))*0.5));
      }

      d_vj_dV_bi_ei = (d_vj_dV_bi_ei/VT);
      d_vj_dV_tnode_GND = ((VT*(d_vj_dV_tnode_GND-d_VT_dV_tnode_GND)-(vj-VT)*d_VT_dV_tnode_GND)/VT/VT);
      vj = ((vj-VT)/VT);
      {
        double value_sqrt_0 = sqrt(((vj*vj)+1.921812));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_vj_dV_bi_ei = (VT*((d_vj_dV_bi_ei+(deriv_sqrt_0_d0*(((vj*d_vj_dV_bi_ei)+(d_vj_dV_bi_ei*vj)))))*0.5));
        d_vj_dV_tnode_GND = ((VT*((d_vj_dV_tnode_GND+(deriv_sqrt_0_d0*(((vj*d_vj_dV_tnode_GND)+(d_vj_dV_tnode_GND*vj)))))*0.5))+(d_VT_dV_tnode_GND*(1.0+((vj+value_sqrt_0)*0.5))));
        vj = (VT*(1.0+((vj+value_sqrt_0)*0.5)));
      }
      {
        double value_log_0 = log((1.0-(vj/vdei_t)));
        double value_exp_1 = exp(((model_.zei)*value_log_0));
        double  deriv_log_0_d0 = (1.0/(1.0-(vj/vdei_t)));
        double  deriv_exp_1_d0 = value_exp_1;

        d_vj_z_dV_bi_ei = ((-(deriv_exp_1_d0*(((model_.zei)*(deriv_log_0_d0*((-(d_vj_dV_bi_ei/vdei_t))))))))*ahjei_t);
        d_vj_z_dV_tnode_GND = (((1.0-value_exp_1)*d_ahjei_t_dV_tnode_GND)+((-(deriv_exp_1_d0*(((model_.zei)*(deriv_log_0_d0*((-((vdei_t*d_vj_dV_tnode_GND-vj*d_vdei_t_dV_tnode_GND)/vdei_t/vdei_t))))))))*ahjei_t));
        vj_z = ((1.0-value_exp_1)*ahjei_t);
      }
      {
        double value_exp_0 = exp(vj_z);
        double  deriv_exp_0_d0 = value_exp_0;

        d_hjei_vbe_dV_bi_ei = ((vj_z*(hjei0_t*(deriv_exp_0_d0*(d_vj_z_dV_bi_ei)))-(hjei0_t*(value_exp_0-1.0))*d_vj_z_dV_bi_ei)/vj_z/vj_z);
        d_hjei_vbe_dV_tnode_GND = ((vj_z*((hjei0_t*(deriv_exp_0_d0*(d_vj_z_dV_tnode_GND)))+(d_hjei0_t_dV_tnode_GND*(value_exp_0-1.0)))-(hjei0_t*(value_exp_0-1.0))*d_vj_z_dV_tnode_GND)/vj_z/vj_z);
        hjei_vbe = ((hjei0_t*(value_exp_0-1.0))/vj_z);
      }
    }
    if ((vptci_t<1.0e2))
    {
      if ((cjci0_t>0.0))
      {
        Dz_r = ((model_.zci)/4.0);

        d_Dv_p_dV_tnode_GND = (d_vptci_t_dV_tnode_GND-d_vdci_t_dV_tnode_GND);
        Dv_p = (vptci_t-vdci_t);
        {
          double value_log_0 = log(static_cast<double>(2.4));
          double value_exp_1 = exp(((-value_log_0)/(model_.zci)));

          d_DV_f_dV_tnode_GND = (d_vdci_t_dV_tnode_GND*(1.0-value_exp_1));
          DV_f = (vdci_t*(1.0-value_exp_1));
        }

        d_DC_max_dV_tnode_GND = (2.4*d_cjci0_t_dV_tnode_GND);
        DC_max = (2.4*cjci0_t);
        {
          double value_log_0 = log((vptci_t/vdci_t));
          double value_exp_1 = exp(((Dz_r-(model_.zci))*value_log_0));
          double  deriv_log_0_d0 = (1.0/(vptci_t/vdci_t));
          double  deriv_exp_1_d0 = value_exp_1;

          d_DC_c_dV_tnode_GND = ((cjci0_t*(deriv_exp_1_d0*(((Dz_r-(model_.zci))*(deriv_log_0_d0*(((vdci_t*d_vptci_t_dV_tnode_GND-vptci_t*d_vdci_t_dV_tnode_GND)/vdci_t/vdci_t)))))))+(d_cjci0_t_dV_tnode_GND*value_exp_1));
          DC_c = (cjci0_t*value_exp_1);
        }

        d_Dv_e_dV_s_c = d_Dv_e_dV_si_ci = d_Dv_e_dV_b_ci = d_Dv_e_dV_bp_ci =  0.0;
        d_Dv_e_dV_bi_ci = ((-d_Vbici_dV_bi_ci)/VT);
        d_Dv_e_dV_tnode_GND = ((VT*d_DV_f_dV_tnode_GND-(DV_f-Vbici)*d_VT_dV_tnode_GND)/VT/VT);
        Dv_e = ((DV_f-Vbici)/VT);
        if ((Dv_e<80.0))
        {
          {
            double value_exp_0 = exp(Dv_e);
            double  deriv_exp_0_d0 = value_exp_0;

            d_De_dV_s_c = d_De_dV_si_ci = d_De_dV_b_ci = d_De_dV_bp_ci =  0.0;
            d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bi_ci));
            d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_e_dV_tnode_GND));
            De = value_exp_0;
          }

          d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci = d_De_1_dV_bp_ci =  0.0;
          d_De_1_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
          d_De_1_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
          De_1 = (De/(1.0+De));
          {
            double value_log_0 = log((1.0+De));
            double  deriv_log_0_d0 = (1.0/(1.0+De));

            d_Dv_j1_dV_s_c = d_Dv_j1_dV_si_ci = d_Dv_j1_dV_b_ci = d_Dv_j1_dV_bp_ci =  0.0;
            d_Dv_j1_dV_bi_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_bi_ci))));
            d_Dv_j1_dV_tnode_GND = (d_DV_f_dV_tnode_GND-((VT*(deriv_log_0_d0*(d_De_dV_tnode_GND)))+(d_VT_dV_tnode_GND*value_log_0)));
            Dv_j1 = (DV_f-(VT*value_log_0));
          }
        }
        else
        {

          d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci = d_De_1_dV_bp_ci = d_De_1_dV_tnode_GND = d_De_1_dV_bi_ci =  0.0;
          De_1 = 1.0;

          d_Dv_j1_dV_s_c = d_Dv_j1_dV_si_ci = d_Dv_j1_dV_b_ci = d_Dv_j1_dV_bp_ci = d_Dv_j1_dV_tnode_GND =  0.0;
          d_Dv_j1_dV_bi_ci = d_Vbici_dV_bi_ci;
          Dv_j1 = Vbici;
        }

        d_Da_dV_tnode_GND = ((0.1*d_Dv_p_dV_tnode_GND)+(4.0*d_VT_dV_tnode_GND));
        Da = ((0.1*Dv_p)+(4.0*VT));

        d_Dv_r_dV_s_c = d_Dv_r_dV_si_ci = d_Dv_r_dV_b_ci = d_Dv_r_dV_bp_ci =  0.0;
        d_Dv_r_dV_bi_ci = (d_Dv_j1_dV_bi_ci/Da);
        d_Dv_r_dV_tnode_GND = ((Da*(d_Dv_p_dV_tnode_GND+d_Dv_j1_dV_tnode_GND)-(Dv_p+Dv_j1)*d_Da_dV_tnode_GND)/Da/Da);
        Dv_r = ((Dv_p+Dv_j1)/Da);
        if ((Dv_r<80.0))
        {
          {
            double value_exp_0 = exp(Dv_r);
            double  deriv_exp_0_d0 = value_exp_0;

            d_De_dV_s_c = d_De_dV_si_ci = d_De_dV_b_ci = d_De_dV_bp_ci =  0.0;
            d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bi_ci));
            d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_r_dV_tnode_GND));
            De = value_exp_0;
          }

          d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci = d_De_2_dV_bp_ci =  0.0;
          d_De_2_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
          d_De_2_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
          De_2 = (De/(1.0+De));
          {
            double value_log_0 = log((1.0+De));
            double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
            double  deriv_log_0_d0 = (1.0/(1.0+De));
            double  deriv_exp_1_d0 = value_exp_1;

            d_Dv_j2_dV_s_c = d_Dv_j2_dV_si_ci = d_Dv_j2_dV_b_ci = d_Dv_j2_dV_bp_ci =  0.0;
            d_Dv_j2_dV_bi_ci = (Da*(deriv_log_0_d0*(d_De_dV_bi_ci)));
            d_Dv_j2_dV_tnode_GND = ((-d_Dv_p_dV_tnode_GND)+((Da*((deriv_log_0_d0*(d_De_dV_tnode_GND))-(deriv_exp_1_d0*(((Da*(-(d_Dv_p_dV_tnode_GND+d_DV_f_dV_tnode_GND))-(-(Dv_p+DV_f))*d_Da_dV_tnode_GND)/Da/Da)))))+(d_Da_dV_tnode_GND*(value_log_0-value_exp_1))));
            Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
          }
        }
        else
        {

          d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci = d_De_2_dV_bp_ci = d_De_2_dV_tnode_GND = d_De_2_dV_bi_ci =  0.0;
          De_2 = 1.0;

          d_Dv_j2_dV_s_c = d_Dv_j2_dV_si_ci = d_Dv_j2_dV_b_ci = d_Dv_j2_dV_bp_ci =  0.0;
          d_Dv_j2_dV_bi_ci = d_Dv_j1_dV_bi_ci;
          d_Dv_j2_dV_tnode_GND = d_Dv_j1_dV_tnode_GND;
          Dv_j2 = Dv_j1;
        }

        d_Dv_j4_dV_s_c = d_Dv_j4_dV_si_ci = d_Dv_j4_dV_b_ci = d_Dv_j4_dV_bp_ci =  0.0;
        d_Dv_j4_dV_tnode_GND = (-d_Dv_j1_dV_tnode_GND);
        d_Dv_j4_dV_bi_ci = (d_Vbici_dV_bi_ci-d_Dv_j1_dV_bi_ci);
        Dv_j4 = (Vbici-Dv_j1);
        {
          double value_log_0 = log((1.0-(Dv_j1/vdci_t)));
          double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/vdci_t)));

          d_DCln1_dV_s_c = d_DCln1_dV_si_ci = d_DCln1_dV_b_ci = d_DCln1_dV_bp_ci =  0.0;
          d_DCln1_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bi_ci/vdci_t))));
          d_DCln1_dV_tnode_GND = (deriv_log_0_d0*((-((vdci_t*d_Dv_j1_dV_tnode_GND-Dv_j1*d_vdci_t_dV_tnode_GND)/vdci_t/vdci_t))));
          DCln1 = value_log_0;
        }
        {
          double value_log_0 = log((1.0-(Dv_j2/vdci_t)));
          double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/vdci_t)));

          d_DCln2_dV_s_c = d_DCln2_dV_si_ci = d_DCln2_dV_b_ci = d_DCln2_dV_bp_ci =  0.0;
          d_DCln2_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bi_ci/vdci_t))));
          d_DCln2_dV_tnode_GND = (deriv_log_0_d0*((-((vdci_t*d_Dv_j2_dV_tnode_GND-Dv_j2*d_vdci_t_dV_tnode_GND)/vdci_t/vdci_t))));
          DCln2 = value_log_0;
        }
        Dz1 = (1.0-(model_.zci));
        Dzr1 = (1.0-Dz_r);
        {
          double value_exp_0 = exp((DCln2*(-(model_.zci))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DC_j1_dV_s_c = d_DC_j1_dV_si_ci = d_DC_j1_dV_b_ci = d_DC_j1_dV_bp_ci =  0.0;
          d_DC_j1_dV_bi_ci = ((((cjci0_t*value_exp_0)*De_1)*d_De_2_dV_bi_ci)+((((cjci0_t*value_exp_0)*d_De_1_dV_bi_ci)+((cjci0_t*(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*(-(model_.zci))))))*De_1))*De_2));
          d_DC_j1_dV_tnode_GND = ((((cjci0_t*value_exp_0)*De_1)*d_De_2_dV_tnode_GND)+((((cjci0_t*value_exp_0)*d_De_1_dV_tnode_GND)+(((cjci0_t*(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*(-(model_.zci))))))+(d_cjci0_t_dV_tnode_GND*value_exp_0))*De_1))*De_2));
          DC_j1 = (((cjci0_t*value_exp_0)*De_1)*De_2);
        }
        {
          double value_exp_0 = exp((DCln1*(-Dz_r)));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DC_j2_dV_s_c = d_DC_j2_dV_si_ci = d_DC_j2_dV_b_ci = d_DC_j2_dV_bp_ci =  0.0;
          d_DC_j2_dV_bi_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_bi_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_bi_ci*(-Dz_r)))))*(1.0-De_2)));
          d_DC_j2_dV_tnode_GND = (((DC_c*value_exp_0)*(-d_De_2_dV_tnode_GND))+(((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_tnode_GND*(-Dz_r)))))+(d_DC_c_dV_tnode_GND*value_exp_0))*(1.0-De_2)));
          DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
        }

        d_DC_j3_dV_s_c = d_DC_j3_dV_si_ci = d_DC_j3_dV_b_ci = d_DC_j3_dV_bp_ci =  0.0;
        d_DC_j3_dV_bi_ci = (DC_max*(-d_De_1_dV_bi_ci));
        d_DC_j3_dV_tnode_GND = ((DC_max*(-d_De_1_dV_tnode_GND))+(d_DC_max_dV_tnode_GND*(1.0-De_1)));
        DC_j3 = (DC_max*(1.0-De_1));

        d_Cjci_dV_bi_ei =  0.0;
        d_Cjci_dV_bi_ci = ((d_DC_j1_dV_bi_ci+d_DC_j2_dV_bi_ci)+d_DC_j3_dV_bi_ci);
        d_Cjci_dV_tnode_GND = ((d_DC_j1_dV_tnode_GND+d_DC_j2_dV_tnode_GND)+d_DC_j3_dV_tnode_GND);
        Cjci = ((DC_j1+DC_j2)+DC_j3);
        {
          double value_exp_0 = exp((DCln2*Dz1));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DQ_j1_dV_s_c = d_DQ_j1_dV_si_ci = d_DQ_j1_dV_b_ci = d_DQ_j1_dV_bp_ci =  0.0;
          d_DQ_j1_dV_bi_ci = ((cjci0_t*(-(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*Dz1)))))/Dz1);
          d_DQ_j1_dV_tnode_GND = (((cjci0_t*(-(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*Dz1)))))+(d_cjci0_t_dV_tnode_GND*(1.0-value_exp_0)))/Dz1);
          DQ_j1 = ((cjci0_t*(1.0-value_exp_0))/Dz1);
        }
        {
          double value_exp_0 = exp((DCln1*Dzr1));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DQ_j2_dV_s_c = d_DQ_j2_dV_si_ci = d_DQ_j2_dV_b_ci = d_DQ_j2_dV_bp_ci =  0.0;
          d_DQ_j2_dV_bi_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_bi_ci*Dzr1)))))/Dzr1);
          d_DQ_j2_dV_tnode_GND = (((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_tnode_GND*Dzr1)))))+(d_DC_c_dV_tnode_GND*(1.0-value_exp_0)))/Dzr1);
          DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }
        {
          double value_exp_0 = exp((DCln2*Dzr1));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DQ_j3_dV_s_c = d_DQ_j3_dV_si_ci = d_DQ_j3_dV_b_ci = d_DQ_j3_dV_bp_ci =  0.0;
          d_DQ_j3_dV_bi_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*Dzr1)))))/Dzr1);
          d_DQ_j3_dV_tnode_GND = (((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*Dzr1)))))+(d_DC_c_dV_tnode_GND*(1.0-value_exp_0)))/Dzr1);
          DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }

        d_Qjci_dV_bi_ei =  0.0;
        d_Qjci_dV_bi_ci = ((((d_DQ_j1_dV_bi_ci+d_DQ_j2_dV_bi_ci)-d_DQ_j3_dV_bi_ci)*vdci_t)+(DC_max*d_Dv_j4_dV_bi_ci));
        d_Qjci_dV_tnode_GND = (((((DQ_j1+DQ_j2)-DQ_j3)*d_vdci_t_dV_tnode_GND)+(((d_DQ_j1_dV_tnode_GND+d_DQ_j2_dV_tnode_GND)-d_DQ_j3_dV_tnode_GND)*vdci_t))+((DC_max*d_Dv_j4_dV_tnode_GND)+(d_DC_max_dV_tnode_GND*Dv_j4)));
        Qjci = ((((DQ_j1+DQ_j2)-DQ_j3)*vdci_t)+(DC_max*Dv_j4));
      }
      else
      {

        d_Cjci_dV_bi_ei = d_Cjci_dV_tnode_GND = d_Cjci_dV_bi_ci =  0.0;
        Cjci = 0.0;

        d_Qjci_dV_bi_ei = d_Qjci_dV_tnode_GND = d_Qjci_dV_bi_ci =  0.0;
        Qjci = 0.0;
      }
    }
    else
    {
      if ((cjci0_t>0.0))
      {
        {
          double value_log_0 = log(static_cast<double>(2.4));
          double value_exp_1 = exp(((-value_log_0)/(model_.zci)));

          d_DFV_f_dV_tnode_GND = (d_vdci_t_dV_tnode_GND*(1.0-value_exp_1));
          DFV_f = (vdci_t*(1.0-value_exp_1));
        }

        d_DFv_e_dV_s_c = d_DFv_e_dV_si_ci = d_DFv_e_dV_b_ci = d_DFv_e_dV_bp_ci = d_DFv_e_dV_bp_ei = d_DFv_e_dV_bi_ei =  0.0;
        d_DFv_e_dV_bi_ci = ((-d_Vbici_dV_bi_ci)/VT);
        d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vbici)*d_VT_dV_tnode_GND)/VT/VT);
        DFv_e = ((DFV_f-Vbici)/VT);
        {
          double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_DFs_q_dV_s_c = d_DFs_q_dV_si_ci = d_DFs_q_dV_b_ci = d_DFs_q_dV_bp_ci = d_DFs_q_dV_bp_ei =  0.0;
          d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bi_ei)+(d_DFv_e_dV_bi_ei*DFv_e))));
          d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_tnode_GND)+(d_DFv_e_dV_tnode_GND*DFv_e))));
          d_DFs_q_dV_bi_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bi_ci)+(d_DFv_e_dV_bi_ci*DFv_e))));
          DFs_q = value_sqrt_0;
        }

        d_DFs_q2_dV_s_c = d_DFs_q2_dV_si_ci = d_DFs_q2_dV_b_ci = d_DFs_q2_dV_bp_ci = d_DFs_q2_dV_bp_ei =  0.0;
        d_DFs_q2_dV_bi_ei = ((d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5);
        d_DFs_q2_dV_tnode_GND = ((d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5);
        d_DFs_q2_dV_bi_ci = ((d_DFv_e_dV_bi_ci+d_DFs_q_dV_bi_ci)*0.5);
        DFs_q2 = ((DFv_e+DFs_q)*0.5);

        d_DFv_j_dV_s_c = d_DFv_j_dV_si_ci = d_DFv_j_dV_b_ci = d_DFv_j_dV_bp_ci = d_DFv_j_dV_bp_ei =  0.0;
        d_DFv_j_dV_bi_ei = (-(VT*d_DFs_q2_dV_bi_ei));
        d_DFv_j_dV_bi_ci = (-(VT*d_DFs_q2_dV_bi_ci));
        d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-((VT*d_DFs_q2_dV_tnode_GND)+(d_VT_dV_tnode_GND*DFs_q2)));
        DFv_j = (DFV_f-(VT*DFs_q2));

        d_DFdvj_dv_dV_s_c = d_DFdvj_dv_dV_si_ci = d_DFdvj_dv_dV_b_ci = d_DFdvj_dv_dV_bp_ci = d_DFdvj_dv_dV_bp_ei =  0.0;
        d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_bi_ci = ((DFs_q*d_DFs_q2_dV_bi_ci-DFs_q2*d_DFs_q_dV_bi_ci)/DFs_q/DFs_q);
        DFdvj_dv = (DFs_q2/DFs_q);
        {
          double value_log_0 = log((1.0-(DFv_j/vdci_t)));
          double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vdci_t)));

          d_DFb_dV_s_c = d_DFb_dV_si_ci = d_DFb_dV_b_ci = d_DFb_dV_bp_ci = d_DFb_dV_bp_ei =  0.0;
          d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vdci_t))));
          d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vdci_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vdci_t_dV_tnode_GND)/vdci_t/vdci_t))));
          d_DFb_dV_bi_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ci/vdci_t))));
          DFb = value_log_0;
        }
        {
          double value_exp_0 = exp(((-(model_.zci))*DFb));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DFC_j1_dV_s_c = d_DFC_j1_dV_si_ci = d_DFC_j1_dV_b_ci = d_DFC_j1_dV_bp_ci = d_DFC_j1_dV_bp_ei =  0.0;
          d_DFC_j1_dV_bi_ei = (((cjci0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei)+((cjci0_t*(deriv_exp_0_d0*(((-(model_.zci))*d_DFb_dV_bi_ei))))*DFdvj_dv));
          d_DFC_j1_dV_bi_ci = (((cjci0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ci)+((cjci0_t*(deriv_exp_0_d0*(((-(model_.zci))*d_DFb_dV_bi_ci))))*DFdvj_dv));
          d_DFC_j1_dV_tnode_GND = (((cjci0_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND)+(((cjci0_t*(deriv_exp_0_d0*(((-(model_.zci))*d_DFb_dV_tnode_GND))))+(d_cjci0_t_dV_tnode_GND*value_exp_0))*DFdvj_dv));
          DFC_j1 = ((cjci0_t*value_exp_0)*DFdvj_dv);
        }

        d_Cjci_dV_bi_ei = (d_DFC_j1_dV_bi_ei+((2.4*cjci0_t)*(-d_DFdvj_dv_dV_bi_ei)));
        d_Cjci_dV_tnode_GND = (d_DFC_j1_dV_tnode_GND+(((2.4*cjci0_t)*(-d_DFdvj_dv_dV_tnode_GND))+((2.4*d_cjci0_t_dV_tnode_GND)*(1.0-DFdvj_dv))));
        d_Cjci_dV_bi_ci = (d_DFC_j1_dV_bi_ci+((2.4*cjci0_t)*(-d_DFdvj_dv_dV_bi_ci)));
        Cjci = (DFC_j1+((2.4*cjci0_t)*(1.0-DFdvj_dv)));
        {
          double value_exp_0 = exp((DFb*(1.0-(model_.zci))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DFQ_j_dV_s_c = d_DFQ_j_dV_si_ci = d_DFQ_j_dV_b_ci = d_DFQ_j_dV_bp_ci = d_DFQ_j_dV_bp_ei =  0.0;
          d_DFQ_j_dV_bi_ei = (((cjci0_t*vdci_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bi_ei*(1.0-(model_.zci)))))))/(1.0-(model_.zci)));
          d_DFQ_j_dV_bi_ci = (((cjci0_t*vdci_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bi_ci*(1.0-(model_.zci)))))))/(1.0-(model_.zci)));
          d_DFQ_j_dV_tnode_GND = ((((cjci0_t*vdci_t)*(-(deriv_exp_0_d0*((d_DFb_dV_tnode_GND*(1.0-(model_.zci)))))))+(((cjci0_t*d_vdci_t_dV_tnode_GND)+(d_cjci0_t_dV_tnode_GND*vdci_t))*(1.0-value_exp_0)))/(1.0-(model_.zci)));
          DFQ_j = (((cjci0_t*vdci_t)*(1.0-value_exp_0))/(1.0-(model_.zci)));
        }

        d_Qjci_dV_bi_ei = (d_DFQ_j_dV_bi_ei+((2.4*cjci0_t)*(-d_DFv_j_dV_bi_ei)));
        d_Qjci_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+(((2.4*cjci0_t)*(-d_DFv_j_dV_tnode_GND))+((2.4*d_cjci0_t_dV_tnode_GND)*(Vbici-DFv_j))));
        d_Qjci_dV_bi_ci = (d_DFQ_j_dV_bi_ci+((2.4*cjci0_t)*(d_Vbici_dV_bi_ci-d_DFv_j_dV_bi_ci)));
        Qjci = (DFQ_j+((2.4*cjci0_t)*(Vbici-DFv_j)));
      }
      else
      {

        d_Cjci_dV_bi_ei = d_Cjci_dV_tnode_GND = d_Cjci_dV_bi_ci =  0.0;
        Cjci = 0.0;

        d_Qjci_dV_bi_ei = d_Qjci_dV_tnode_GND = d_Qjci_dV_bi_ci =  0.0;
        Qjci = 0.0;
      }
    }
    a_bpt = 0.05;

    d_Q_0_dV_bi_ci = ((model_.hjci)*d_Qjci_dV_bi_ci);
    d_Q_0_dV_bi_ei = (((hjei_vbe*d_Qjei_dV_bi_ei)+(d_hjei_vbe_dV_bi_ei*Qjei))+((model_.hjci)*d_Qjci_dV_bi_ei));
    d_Q_0_dV_tnode_GND = ((d_qp0_t_dV_tnode_GND+((hjei_vbe*d_Qjei_dV_tnode_GND)+(d_hjei_vbe_dV_tnode_GND*Qjei)))+((model_.hjci)*d_Qjci_dV_tnode_GND));
    Q_0 = ((qp0_t+(hjei_vbe*Qjei))+((model_.hjci)*Qjci));

    d_Q_bpt_dV_tnode_GND = (a_bpt*d_qp0_t_dV_tnode_GND);
    Q_bpt = (a_bpt*qp0_t);

    d_b_q_dV_bi_ci = (d_Q_0_dV_bi_ci/Q_bpt);
    d_b_q_dV_bi_ei = (d_Q_0_dV_bi_ei/Q_bpt);
    d_b_q_dV_tnode_GND = ((Q_bpt*d_Q_0_dV_tnode_GND-Q_0*d_Q_bpt_dV_tnode_GND)/Q_bpt/Q_bpt);
    b_q = ((Q_0/Q_bpt)-1);
    {
      double value_sqrt_0 = sqrt(((b_q*b_q)+1.921812));
      double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

      d_Q_0_dV_bi_ci = (Q_bpt*((d_b_q_dV_bi_ci+(deriv_sqrt_0_d0*(((b_q*d_b_q_dV_bi_ci)+(d_b_q_dV_bi_ci*b_q)))))/2));
      d_Q_0_dV_bi_ei = (Q_bpt*((d_b_q_dV_bi_ei+(deriv_sqrt_0_d0*(((b_q*d_b_q_dV_bi_ei)+(d_b_q_dV_bi_ei*b_q)))))/2));
      d_Q_0_dV_tnode_GND = ((Q_bpt*((d_b_q_dV_tnode_GND+(deriv_sqrt_0_d0*(((b_q*d_b_q_dV_tnode_GND)+(d_b_q_dV_tnode_GND*b_q)))))/2))+(d_Q_bpt_dV_tnode_GND*(1+((b_q+value_sqrt_0)/2))));
      Q_0 = (Q_bpt*(1+((b_q+value_sqrt_0)/2)));
    }
    if ((cjci0_t>0.0))
      //Begin block CJMODF
    {
      //Block-local variables for block CJMODF
      double cV_f;
      double d_cV_f_dV_tnode_GND;
      double cv_e;
      double d_cv_e_dV_tnode_GND;
      double d_cv_e_dV_bi_ci;
      double cs_q;
      double d_cs_q_dV_tnode_GND;
      double d_cs_q_dV_bi_ci;
      double cs_q2;
      double d_cs_q2_dV_tnode_GND;
      double d_cs_q2_dV_bi_ci;
      double cv_j;
      double d_cv_j_dV_tnode_GND;
      double d_cv_j_dV_bi_ci;
      double cdvj_dv;
      double d_cdvj_dv_dV_tnode_GND;
      double d_cdvj_dv_dV_bi_ci;
      //End of Block-local variables
      {
        double value_log_0 = log(static_cast<double>(2.4));
        double value_exp_1 = exp(((-value_log_0)/(model_.zci)));

        d_cV_f_dV_tnode_GND = (d_vdci_t_dV_tnode_GND*(1.0-value_exp_1));
        cV_f = (vdci_t*(1.0-value_exp_1));
      }

      d_cv_e_dV_bi_ci = ((-d_Vbici_dV_bi_ci)/VT);
      d_cv_e_dV_tnode_GND = ((VT*d_cV_f_dV_tnode_GND-(cV_f-Vbici)*d_VT_dV_tnode_GND)/VT/VT);
      cv_e = ((cV_f-Vbici)/VT);
      {
        double value_sqrt_0 = sqrt(((cv_e*cv_e)+1.921812));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_cs_q_dV_bi_ci = (deriv_sqrt_0_d0*(((cv_e*d_cv_e_dV_bi_ci)+(d_cv_e_dV_bi_ci*cv_e))));
        d_cs_q_dV_tnode_GND = (deriv_sqrt_0_d0*(((cv_e*d_cv_e_dV_tnode_GND)+(d_cv_e_dV_tnode_GND*cv_e))));
        cs_q = value_sqrt_0;
      }

      d_cs_q2_dV_bi_ci = ((d_cv_e_dV_bi_ci+d_cs_q_dV_bi_ci)*0.5);
      d_cs_q2_dV_tnode_GND = ((d_cv_e_dV_tnode_GND+d_cs_q_dV_tnode_GND)*0.5);
      cs_q2 = ((cv_e+cs_q)*0.5);

      d_cv_j_dV_bi_ci = (-(VT*d_cs_q2_dV_bi_ci));
      d_cv_j_dV_tnode_GND = (d_cV_f_dV_tnode_GND-((VT*d_cs_q2_dV_tnode_GND)+(d_VT_dV_tnode_GND*cs_q2)));
      cv_j = (cV_f-(VT*cs_q2));

      d_cdvj_dv_dV_bi_ci = ((cs_q*d_cs_q2_dV_bi_ci-cs_q2*d_cs_q_dV_bi_ci)/cs_q/cs_q);
      d_cdvj_dv_dV_tnode_GND = ((cs_q*d_cs_q2_dV_tnode_GND-cs_q2*d_cs_q_dV_tnode_GND)/cs_q/cs_q);
      cdvj_dv = (cs_q2/cs_q);
      {
        double value_log_0 = log((1.0-(cv_j/vdci_t)));
        double value_exp_1 = exp(((-(model_.zci))*value_log_0));
        double  deriv_log_0_d0 = (1.0/(1.0-(cv_j/vdci_t)));
        double  deriv_exp_1_d0 = value_exp_1;

        d_Cjcit_dV_bi_ci = ((((cjci0_t*value_exp_1)*d_cdvj_dv_dV_bi_ci)+((cjci0_t*(deriv_exp_1_d0*(((-(model_.zci))*(deriv_log_0_d0*((-(d_cv_j_dV_bi_ci/vdci_t))))))))*cdvj_dv))+((2.4*cjci0_t)*(-d_cdvj_dv_dV_bi_ci)));
        d_Cjcit_dV_tnode_GND = ((((cjci0_t*value_exp_1)*d_cdvj_dv_dV_tnode_GND)+(((cjci0_t*(deriv_exp_1_d0*(((-(model_.zci))*(deriv_log_0_d0*((-((vdci_t*d_cv_j_dV_tnode_GND-cv_j*d_vdci_t_dV_tnode_GND)/vdci_t/vdci_t))))))))+(d_cjci0_t_dV_tnode_GND*value_exp_1))*cdvj_dv))+(((2.4*cjci0_t)*(-d_cdvj_dv_dV_tnode_GND))+((2.4*d_cjci0_t_dV_tnode_GND)*(1.0-cdvj_dv))));
        Cjcit = (((cjci0_t*value_exp_1)*cdvj_dv)+((2.4*cjci0_t)*(1.0-cdvj_dv)));
      }
    }
    // End block CJMODF
    else
    {

      d_Cjcit_dV_tnode_GND = d_Cjcit_dV_bi_ci =  0.0;
      Cjcit = 0.0;
    }
    if ((Cjcit>0.0))
    {

      d_cc_dV_bi_ci = (-cjci0_t*d_Cjcit_dV_bi_ci/Cjcit/Cjcit);
      d_cc_dV_tnode_GND = ((Cjcit*d_cjci0_t_dV_tnode_GND-cjci0_t*d_Cjcit_dV_tnode_GND)/Cjcit/Cjcit);
      cc = (cjci0_t/Cjcit);
    }
    else
    {

      d_cc_dV_tnode_GND = d_cc_dV_bi_ci =  0.0;
      cc = 1.0;
    }

    d_T_f0_dV_bi_ci = (((model_.dt0h)*d_cc_dV_bi_ci)+((model_.tbvl)*(-1*d_cc_dV_bi_ci/cc/cc)));
    d_T_f0_dV_tnode_GND = ((d_t0_t_dV_tnode_GND+((model_.dt0h)*d_cc_dV_tnode_GND))+((model_.tbvl)*(-1*d_cc_dV_tnode_GND/cc/cc)));
    T_f0 = ((t0_t+((model_.dt0h)*(cc-1.0)))+((model_.tbvl)*((1/cc)-1.0)));

    d_vc_dV_tnode_GND = (-d_vces_t_dV_tnode_GND);
    d_vc_dV_bi_ci = d_Vciei_dV_bi_ci;
    d_vc_dV_bi_ei = d_Vciei_dV_bi_ei;
    vc = (Vciei-vces_t);
    //Begin block HICICK
    {
      Ovpt = (1.0/(model_.vpt));

      d_a_dV_tnode_GND = ((VT*d_vc_dV_tnode_GND-vc*d_VT_dV_tnode_GND)/VT/VT);
      d_a_dV_bi_ci = (d_vc_dV_bi_ci/VT);
      d_a_dV_bi_ei = (d_vc_dV_bi_ei/VT);
      a = (vc/VT);

      d_d1_dV_tnode_GND = d_a_dV_tnode_GND;
      d_d1_dV_bi_ci = d_a_dV_bi_ci;
      d_d1_dV_bi_ei = d_a_dV_bi_ei;
      d1 = (a-1);
      {
        double value_sqrt_0 = sqrt(((d1*d1)+1.921812));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_vceff_dV_tnode_GND = (((1.0+((d1+value_sqrt_0)/2))*d_VT_dV_tnode_GND)+(((d_d1_dV_tnode_GND+(deriv_sqrt_0_d0*(((d1*d_d1_dV_tnode_GND)+(d_d1_dV_tnode_GND*d1)))))/2)*VT));
        d_vceff_dV_bi_ci = (((d_d1_dV_bi_ci+(deriv_sqrt_0_d0*(((d1*d_d1_dV_bi_ci)+(d_d1_dV_bi_ci*d1)))))/2)*VT);
        d_vceff_dV_bi_ei = (((d_d1_dV_bi_ei+(deriv_sqrt_0_d0*(((d1*d_d1_dV_bi_ei)+(d_d1_dV_bi_ei*d1)))))/2)*VT);
        vceff = ((1.0+((d1+value_sqrt_0)/2))*VT);
      }

      d_a1_dV_tnode_GND = ((vlim_t*d_vceff_dV_tnode_GND-vceff*d_vlim_t_dV_tnode_GND)/vlim_t/vlim_t);
      d_a1_dV_bi_ci = (d_vceff_dV_bi_ci/vlim_t);
      d_a1_dV_bi_ei = (d_vceff_dV_bi_ei/vlim_t);
      a1 = (vceff/vlim_t);

      d_a11_dV_tnode_GND = ((vceff*d_Orci0_t_dV_tnode_GND)+(d_vceff_dV_tnode_GND*Orci0_t));
      d_a11_dV_bi_ci = (d_vceff_dV_bi_ci*Orci0_t);
      d_a11_dV_bi_ei = (d_vceff_dV_bi_ei*Orci0_t);
      a11 = (vceff*Orci0_t);
      Odelck = (1/(model_.delck));
      {
        double value_log_0 = log(a1);
        double value_exp_1 = exp(((model_.delck)*value_log_0));
        double value_log_2 = log((1+value_exp_1));
        double value_exp_3 = exp((Odelck*value_log_2));
        double  deriv_log_0_d0 = (1.0/a1);
        double  deriv_exp_1_d0 = value_exp_1;
        double  deriv_log_2_d0 = (1.0/(1+value_exp_1));
        double  deriv_exp_3_d0 = value_exp_3;

        d_ick1_dV_tnode_GND = (deriv_exp_3_d0*((Odelck*(deriv_log_2_d0*((deriv_exp_1_d0*(((model_.delck)*(deriv_log_0_d0*(d_a1_dV_tnode_GND))))))))));
        d_ick1_dV_bi_ci = (deriv_exp_3_d0*((Odelck*(deriv_log_2_d0*((deriv_exp_1_d0*(((model_.delck)*(deriv_log_0_d0*(d_a1_dV_bi_ci))))))))));
        d_ick1_dV_bi_ei = (deriv_exp_3_d0*((Odelck*(deriv_log_2_d0*((deriv_exp_1_d0*(((model_.delck)*(deriv_log_0_d0*(d_a1_dV_bi_ei))))))))));
        ick1 = value_exp_3;
      }

      d_ick2_dV_tnode_GND = ((ick1*d_a11_dV_tnode_GND-a11*d_ick1_dV_tnode_GND)/ick1/ick1);
      d_ick2_dV_bi_ci = ((ick1*d_a11_dV_bi_ci-a11*d_ick1_dV_bi_ci)/ick1/ick1);
      d_ick2_dV_bi_ei = ((ick1*d_a11_dV_bi_ei-a11*d_ick1_dV_bi_ei)/ick1/ick1);
      ick2 = (a11/ick1);

      d_ICKa_dV_tnode_GND = ((d_vceff_dV_tnode_GND-d_vlim_t_dV_tnode_GND)*Ovpt);
      d_ICKa_dV_bi_ci = (d_vceff_dV_bi_ci*Ovpt);
      d_ICKa_dV_bi_ei = (d_vceff_dV_bi_ei*Ovpt);
      ICKa = ((vceff-vlim_t)*Ovpt);
      {
        double value_sqrt_0 = sqrt(((ICKa*ICKa)+(model_.aick)));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_ick_dV_tnode_GND = ((ick2*(0.5*(d_ICKa_dV_tnode_GND+(deriv_sqrt_0_d0*(((ICKa*d_ICKa_dV_tnode_GND)+(d_ICKa_dV_tnode_GND*ICKa)))))))+(d_ick2_dV_tnode_GND*(1.0+(0.5*(ICKa+value_sqrt_0)))));
        d_ick_dV_bi_ci = ((ick2*(0.5*(d_ICKa_dV_bi_ci+(deriv_sqrt_0_d0*(((ICKa*d_ICKa_dV_bi_ci)+(d_ICKa_dV_bi_ci*ICKa)))))))+(d_ick2_dV_bi_ci*(1.0+(0.5*(ICKa+value_sqrt_0)))));
        d_ick_dV_bi_ei = ((ick2*(0.5*(d_ICKa_dV_bi_ei+(deriv_sqrt_0_d0*(((ICKa*d_ICKa_dV_bi_ei)+(d_ICKa_dV_bi_ei*ICKa)))))))+(d_ick2_dV_bi_ei*(1.0+(0.5*(ICKa+value_sqrt_0)))));
        ick = (ick2*(1.0+(0.5*(ICKa+value_sqrt_0))));
      }
    }
    // End block HICICK

    d_Q_p_dV_bi_ci = d_Q_0_dV_bi_ci;
    d_Q_p_dV_bi_ei = d_Q_0_dV_bi_ei;
    d_Q_p_dV_tnode_GND = d_Q_0_dV_tnode_GND;
    Q_p = Q_0;
    if (((T_f0>0.0)||(Tr>0.0)))
    {

      d_A_dV_bi_ci = (0.5*d_Q_0_dV_bi_ci);
      d_A_dV_bi_ei = (0.5*d_Q_0_dV_bi_ei);
      d_A_dV_tnode_GND = (0.5*d_Q_0_dV_tnode_GND);
      A = (0.5*Q_0);
      {
        double value_sqrt_0 = sqrt((((A*A)+(T_f0*i_0f))+(Tr*i_0r)));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_Q_p_dV_bi_ci = (d_A_dV_bi_ci+(deriv_sqrt_0_d0*(((((A*d_A_dV_bi_ci)+(d_A_dV_bi_ci*A))+(d_T_f0_dV_bi_ci*i_0f))+(Tr*d_i_0r_dV_bi_ci)))));
        d_Q_p_dV_bi_ei = (d_A_dV_bi_ei+(deriv_sqrt_0_d0*((((A*d_A_dV_bi_ei)+(d_A_dV_bi_ei*A))+(T_f0*d_i_0f_dV_bi_ei)))));
        d_Q_p_dV_tnode_GND = (d_A_dV_tnode_GND+(deriv_sqrt_0_d0*(((((A*d_A_dV_tnode_GND)+(d_A_dV_tnode_GND*A))+((T_f0*d_i_0f_dV_tnode_GND)+(d_T_f0_dV_tnode_GND*i_0f)))+(Tr*d_i_0r_dV_tnode_GND)))));
        Q_p = (A+value_sqrt_0);
      }
    }

    d_I_Tf1_dV_bi_ci = (-i_0f*d_Q_p_dV_bi_ci/Q_p/Q_p);
    d_I_Tf1_dV_bi_ei = ((Q_p*d_i_0f_dV_bi_ei-i_0f*d_Q_p_dV_bi_ei)/Q_p/Q_p);
    d_I_Tf1_dV_tnode_GND = ((Q_p*d_i_0f_dV_tnode_GND-i_0f*d_Q_p_dV_tnode_GND)/Q_p/Q_p);
    I_Tf1 = (i_0f/Q_p);

    d_a_h_dV_bi_ci = (Oich*d_I_Tf1_dV_bi_ci);
    d_a_h_dV_bi_ei = (Oich*d_I_Tf1_dV_bi_ei);
    d_a_h_dV_tnode_GND = (Oich*d_I_Tf1_dV_tnode_GND);
    a_h = (Oich*I_Tf1);

    d_itf_dV_bi_ci = ((I_Tf1*d_a_h_dV_bi_ci)+(d_I_Tf1_dV_bi_ci*(1.0+a_h)));
    d_itf_dV_bi_ei = ((I_Tf1*d_a_h_dV_bi_ei)+(d_I_Tf1_dV_bi_ei*(1.0+a_h)));
    d_itf_dV_tnode_GND = ((I_Tf1*d_a_h_dV_tnode_GND)+(d_I_Tf1_dV_tnode_GND*(1.0+a_h)));
    itf = (I_Tf1*(1.0+a_h));

    d_itr_dV_bi_ei = (-i_0r*d_Q_p_dV_bi_ei/Q_p/Q_p);
    d_itr_dV_bi_ci = ((Q_p*d_i_0r_dV_bi_ci-i_0r*d_Q_p_dV_bi_ci)/Q_p/Q_p);
    d_itr_dV_tnode_GND = ((Q_p*d_i_0r_dV_tnode_GND-i_0r*d_Q_p_dV_tnode_GND)/Q_p/Q_p);
    itr = (i_0r/Q_p);

    d_Q_bf_dV_tnode_GND = d_Q_bf_dV_bi_ei = d_Q_bf_dV_bi_ci =  0.0;
    Q_bf = 0.0;

    d_Tf_dV_bi_ei =  0.0;
    d_Tf_dV_bi_ci = d_T_f0_dV_bi_ci;
    d_Tf_dV_tnode_GND = d_T_f0_dV_tnode_GND;
    Tf = T_f0;

    d_Qf_dV_bi_ei = (T_f0*d_itf_dV_bi_ei);
    d_Qf_dV_bi_ci = ((T_f0*d_itf_dV_bi_ci)+(d_T_f0_dV_bi_ci*itf));
    d_Qf_dV_tnode_GND = ((T_f0*d_itf_dV_tnode_GND)+(d_T_f0_dV_tnode_GND*itf));
    Qf = (T_f0*itf);
    if ((itf<(1.0e-6*ick)))
    {

      d_Q_fT_dV_bi_ei = d_Qf_dV_bi_ei;
      d_Q_fT_dV_bi_ci = d_Qf_dV_bi_ci;
      d_Q_fT_dV_tnode_GND = d_Qf_dV_tnode_GND;
      Q_fT = Qf;

      d_T_fT_dV_bi_ei =  0.0;
      d_T_fT_dV_bi_ci = d_Tf_dV_bi_ci;
      d_T_fT_dV_tnode_GND = d_Tf_dV_tnode_GND;
      T_fT = Tf;

      d_Q_bf_dV_tnode_GND = d_Q_bf_dV_bi_ei = d_Q_bf_dV_bi_ci =  0.0;
      Q_bf = 0;
    }
    else
    {

      d_FFitf_ick_dV_bi_ci = ((ick*d_itf_dV_bi_ci-itf*d_ick_dV_bi_ci)/ick/ick);
      d_FFitf_ick_dV_bi_ei = ((ick*d_itf_dV_bi_ei-itf*d_ick_dV_bi_ei)/ick/ick);
      d_FFitf_ick_dV_tnode_GND = ((ick*d_itf_dV_tnode_GND-itf*d_ick_dV_tnode_GND)/ick/ick);
      FFitf_ick = (itf/ick);
      {
        double value_log_0 = log(FFitf_ick);
        double value_exp_1 = exp(((model_.gtfe)*value_log_0));
        double  deriv_log_0_d0 = (1.0/FFitf_ick);
        double  deriv_exp_1_d0 = value_exp_1;

        d_FFdTef_dV_bi_ci = (tef0_t*(deriv_exp_1_d0*(((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_bi_ci))))));
        d_FFdTef_dV_bi_ei = (tef0_t*(deriv_exp_1_d0*(((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_bi_ei))))));
        d_FFdTef_dV_tnode_GND = ((tef0_t*(deriv_exp_1_d0*(((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_tnode_GND))))))+(d_tef0_t_dV_tnode_GND*value_exp_1));
        FFdTef = (tef0_t*value_exp_1);
      }

      d_FFdQef_dV_bi_ci = (((FFdTef*d_itf_dV_bi_ci)+(d_FFdTef_dV_bi_ci*itf))/(1+(model_.gtfe)));
      d_FFdQef_dV_bi_ei = (((FFdTef*d_itf_dV_bi_ei)+(d_FFdTef_dV_bi_ei*itf))/(1+(model_.gtfe)));
      d_FFdQef_dV_tnode_GND = (((FFdTef*d_itf_dV_tnode_GND)+(d_FFdTef_dV_tnode_GND*itf))/(1+(model_.gtfe)));
      FFdQef = ((FFdTef*itf)/(1+(model_.gtfe)));
      if (((model_.icbar)<(0.05*((model_.vlim)/(model_.rci0)))))
      {

        d_FFdVc_dV_tnode_GND = d_FFdVc_dV_bi_ei = d_FFdVc_dV_bi_ci =  0.0;
        FFdVc = 0;

        d_FFdVc_ditf_dV_tnode_GND = d_FFdVc_ditf_dV_bi_ei = d_FFdVc_ditf_dV_bi_ci =  0.0;
        FFdVc_ditf = 0;
      }
      else
      {

        d_FFib_dV_bi_ci = ((d_itf_dV_bi_ci-d_ick_dV_bi_ci)/(model_.icbar));
        d_FFib_dV_bi_ei = ((d_itf_dV_bi_ei-d_ick_dV_bi_ei)/(model_.icbar));
        d_FFib_dV_tnode_GND = ((d_itf_dV_tnode_GND-d_ick_dV_tnode_GND)/(model_.icbar));
        FFib = ((itf-ick)/(model_.icbar));
        if ((FFib<(-1.0e10)))
        {

          d_FFib_dV_tnode_GND = d_FFib_dV_bi_ei = d_FFib_dV_bi_ci =  0.0;
          FFib = (-1.0e10);
        }
        {
          double value_sqrt_0 = sqrt(((FFib*FFib)+(model_.acbar)));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_FFfcbar_dV_bi_ci = ((d_FFib_dV_bi_ci+(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_bi_ci)+(d_FFib_dV_bi_ci*FFib)))))/2.0);
          d_FFfcbar_dV_bi_ei = ((d_FFib_dV_bi_ei+(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_bi_ei)+(d_FFib_dV_bi_ei*FFib)))))/2.0);
          d_FFfcbar_dV_tnode_GND = ((d_FFib_dV_tnode_GND+(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_tnode_GND)+(d_FFib_dV_tnode_GND*FFib)))))/2.0);
          FFfcbar = ((FFib+value_sqrt_0)/2.0);
        }
        {
          double value_sqrt_0 = sqrt(((FFib*FFib)+(model_.acbar)));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_FFdib_ditf_dV_bi_ci = (((value_sqrt_0*d_FFfcbar_dV_bi_ci-FFfcbar*(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_bi_ci)+(d_FFib_dV_bi_ci*FFib)))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
          d_FFdib_ditf_dV_bi_ei = (((value_sqrt_0*d_FFfcbar_dV_bi_ei-FFfcbar*(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_bi_ei)+(d_FFib_dV_bi_ei*FFib)))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
          d_FFdib_ditf_dV_tnode_GND = (((value_sqrt_0*d_FFfcbar_dV_tnode_GND-FFfcbar*(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_tnode_GND)+(d_FFib_dV_tnode_GND*FFib)))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
          FFdib_ditf = ((FFfcbar/value_sqrt_0)/(model_.icbar));
        }
        {
          double value_exp_0 = exp(((-1.0)/FFfcbar));
          double  deriv_exp_0_d0 = value_exp_0;

          d_FFdVc_dV_bi_ci = ((model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_bi_ci/FFfcbar/FFfcbar))));
          d_FFdVc_dV_bi_ei = ((model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_bi_ei/FFfcbar/FFfcbar))));
          d_FFdVc_dV_tnode_GND = ((model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_tnode_GND/FFfcbar/FFfcbar))));
          FFdVc = ((model_.vcbar)*value_exp_0);
        }

        d_FFdVc_ditf_dV_bi_ci = (((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_bi_ci)+((((FFfcbar*FFfcbar)*d_FFdVc_dV_bi_ci-FFdVc*((FFfcbar*d_FFfcbar_dV_bi_ci)+(d_FFfcbar_dV_bi_ci*FFfcbar)))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf));
        d_FFdVc_ditf_dV_bi_ei = (((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_bi_ei)+((((FFfcbar*FFfcbar)*d_FFdVc_dV_bi_ei-FFdVc*((FFfcbar*d_FFfcbar_dV_bi_ei)+(d_FFfcbar_dV_bi_ei*FFfcbar)))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf));
        d_FFdVc_ditf_dV_tnode_GND = (((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_tnode_GND)+((((FFfcbar*FFfcbar)*d_FFdVc_dV_tnode_GND-FFdVc*((FFfcbar*d_FFfcbar_dV_tnode_GND)+(d_FFfcbar_dV_tnode_GND*FFfcbar)))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf));
        FFdVc_ditf = ((FFdVc/(FFfcbar*FFfcbar))*FFdib_ditf);
      }
      {
        double value_exp_0 = exp((FFdVc/VT));
        double  deriv_exp_0_d0 = value_exp_0;

        d_FFdQbfb_dV_bi_ci = (((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+((((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ci)*(value_exp_0-1)));
        d_FFdQbfb_dV_bi_ei = (((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+((((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ei)*(value_exp_0-1)));
        d_FFdQbfb_dV_tnode_GND = (((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-FFdVc*d_VT_dV_tnode_GND)/VT/VT))))+(((((1-(model_.fthc))*thcs_t)*d_itf_dV_tnode_GND)+(((1-(model_.fthc))*d_thcs_t_dV_tnode_GND)*itf))*(value_exp_0-1)));
        FFdQbfb = ((((1-(model_.fthc))*thcs_t)*itf)*(value_exp_0-1));
      }
      {
        double value_exp_0 = exp((FFdVc/VT));
        double  deriv_exp_0_d0 = value_exp_0;

        d_FFdTbfb_dV_bi_ci = (((itf*d_FFdQbfb_dV_bi_ci-FFdQbfb*d_itf_dV_bi_ci)/itf/itf)+(((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_bi_ci)+(((((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+((((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ci)*value_exp_0))/VT)*FFdVc_ditf)));
        d_FFdTbfb_dV_bi_ei = (((itf*d_FFdQbfb_dV_bi_ei-FFdQbfb*d_itf_dV_bi_ei)/itf/itf)+(((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_bi_ei)+(((((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+((((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ei)*value_exp_0))/VT)*FFdVc_ditf)));
        d_FFdTbfb_dV_tnode_GND = (((itf*d_FFdQbfb_dV_tnode_GND-FFdQbfb*d_itf_dV_tnode_GND)/itf/itf)+(((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_tnode_GND)+(((VT*(((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-FFdVc*d_VT_dV_tnode_GND)/VT/VT))))+(((((1-(model_.fthc))*thcs_t)*d_itf_dV_tnode_GND)+(((1-(model_.fthc))*d_thcs_t_dV_tnode_GND)*itf))*value_exp_0))-((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf)));
        FFdTbfb = ((FFdQbfb/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*FFdVc_ditf));
      }

      d_FFic_dV_bi_ci = (-(-d_FFitf_ick_dV_bi_ci/FFitf_ick/FFitf_ick));
      d_FFic_dV_bi_ei = (-(-d_FFitf_ick_dV_bi_ei/FFitf_ick/FFitf_ick));
      d_FFic_dV_tnode_GND = (-(-d_FFitf_ick_dV_tnode_GND/FFitf_ick/FFitf_ick));
      FFic = (1-(1.0/FFitf_ick));
      {
        double value_sqrt_0 = sqrt(((FFic*FFic)+(model_.ahc)));
        double value_sqrt_1 = sqrt((1+(model_.ahc)));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_FFw_dV_bi_ci = ((d_FFic_dV_bi_ci+(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_bi_ci)+(d_FFic_dV_bi_ci*FFic)))))/(1+value_sqrt_1));
        d_FFw_dV_bi_ei = ((d_FFic_dV_bi_ei+(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_bi_ei)+(d_FFic_dV_bi_ei*FFic)))))/(1+value_sqrt_1));
        d_FFw_dV_tnode_GND = ((d_FFic_dV_tnode_GND+(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_tnode_GND)+(d_FFic_dV_tnode_GND*FFic)))))/(1+value_sqrt_1));
        FFw = ((FFic+value_sqrt_0)/(1+value_sqrt_1));
      }
      {
        double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
        double  deriv_exp_0_d0 = value_exp_0;

        d_FFdQfhc_dV_bi_ci = (((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+(((((thcs_t*itf)*FFw)*d_FFw_dV_bi_ci)+((((thcs_t*itf)*d_FFw_dV_bi_ci)+((thcs_t*d_itf_dV_bi_ci)*FFw))*FFw))*value_exp_0));
        d_FFdQfhc_dV_bi_ei = (((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+(((((thcs_t*itf)*FFw)*d_FFw_dV_bi_ei)+((((thcs_t*itf)*d_FFw_dV_bi_ei)+((thcs_t*d_itf_dV_bi_ei)*FFw))*FFw))*value_exp_0));
        d_FFdQfhc_dV_tnode_GND = (((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((((thcs_t*itf)*FFw)*d_FFw_dV_tnode_GND)+((((thcs_t*itf)*d_FFw_dV_tnode_GND)+(((thcs_t*d_itf_dV_tnode_GND)+(d_thcs_t_dV_tnode_GND*itf))*FFw))*FFw))*value_exp_0));
        FFdQfhc = ((((thcs_t*itf)*FFw)*FFw)*value_exp_0);
      }
      {
        double value_sqrt_0 = sqrt(((FFic*FFic)+(model_.ahc)));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_FFdTfhc_dV_bi_ci = ((FFdQfhc*((((1.0/itf)*(-2.0*((FFitf_ick*(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_bi_ci)+(d_FFic_dV_bi_ci*FFic)))))+(d_FFitf_ick_dV_bi_ci*value_sqrt_0))/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0)))+((-d_itf_dV_bi_ci/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0)))))+((1.0/VT)*d_FFdVc_ditf_dV_bi_ci)))+(d_FFdQfhc_dV_bi_ci*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf))));
        d_FFdTfhc_dV_bi_ei = ((FFdQfhc*((((1.0/itf)*(-2.0*((FFitf_ick*(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_bi_ei)+(d_FFic_dV_bi_ei*FFic)))))+(d_FFitf_ick_dV_bi_ei*value_sqrt_0))/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0)))+((-d_itf_dV_bi_ei/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0)))))+((1.0/VT)*d_FFdVc_ditf_dV_bi_ei)))+(d_FFdQfhc_dV_bi_ei*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf))));
        d_FFdTfhc_dV_tnode_GND = ((FFdQfhc*((((1.0/itf)*(-2.0*((FFitf_ick*(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_tnode_GND)+(d_FFic_dV_tnode_GND*FFic)))))+(d_FFitf_ick_dV_tnode_GND*value_sqrt_0))/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0)))+((-d_itf_dV_tnode_GND/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0)))))+(((1.0/VT)*d_FFdVc_ditf_dV_tnode_GND)+((-d_VT_dV_tnode_GND/VT/VT)*FFdVc_ditf))))+(d_FFdQfhc_dV_tnode_GND*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf))));
        FFdTfhc = (FFdQfhc*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
      }
      if ((((model_.latb)<=0.0)&&((model_.latl)<=0.0)))
      {

        d_FFdQcfc_dV_bi_ci = ((model_.fthc)*d_FFdQfhc_dV_bi_ci);
        d_FFdQcfc_dV_bi_ei = ((model_.fthc)*d_FFdQfhc_dV_bi_ei);
        d_FFdQcfc_dV_tnode_GND = ((model_.fthc)*d_FFdQfhc_dV_tnode_GND);
        FFdQcfc = ((model_.fthc)*FFdQfhc);

        d_FFdTcfc_dV_bi_ci = ((model_.fthc)*d_FFdTfhc_dV_bi_ci);
        d_FFdTcfc_dV_bi_ei = ((model_.fthc)*d_FFdTfhc_dV_bi_ei);
        d_FFdTcfc_dV_tnode_GND = ((model_.fthc)*d_FFdTfhc_dV_tnode_GND);
        FFdTcfc = ((model_.fthc)*FFdTfhc);

        d_FFdQcfcT_dV_bi_ci = d_FFdQcfc_dV_bi_ci;
        d_FFdQcfcT_dV_bi_ei = d_FFdQcfc_dV_bi_ei;
        d_FFdQcfcT_dV_tnode_GND = d_FFdQcfc_dV_tnode_GND;
        FFdQcfcT = FFdQcfc;

        d_FFdTcfcT_dV_bi_ci = d_FFdTcfc_dV_bi_ci;
        d_FFdTcfcT_dV_bi_ei = d_FFdTcfc_dV_bi_ei;
        d_FFdTcfcT_dV_tnode_GND = d_FFdTcfc_dV_tnode_GND;
        FFdTcfcT = FFdTcfc;
      }
      else
      {

        d_FFdQcfc_dV_bi_ci = (((model_.fthc)*thcs_t)*d_itf_dV_bi_ci);
        d_FFdQcfc_dV_bi_ei = (((model_.fthc)*thcs_t)*d_itf_dV_bi_ei);
        d_FFdQcfc_dV_tnode_GND = ((((model_.fthc)*thcs_t)*d_itf_dV_tnode_GND)+(((model_.fthc)*d_thcs_t_dV_tnode_GND)*itf));
        FFdQcfc = (((model_.fthc)*thcs_t)*itf);

        d_FCa_dV_tnode_GND = (-((itf*d_ick_dV_tnode_GND-ick*d_itf_dV_tnode_GND)/itf/itf));
        d_FCa_dV_bi_ci = (-((itf*d_ick_dV_bi_ci-ick*d_itf_dV_bi_ci)/itf/itf));
        d_FCa_dV_bi_ei = (-((itf*d_ick_dV_bi_ei-ick*d_itf_dV_bi_ei)/itf/itf));
        FCa = (1.0-(ick/itf));
        {
          double value_sqrt_0 = sqrt(((FCa*FCa)+(model_.ahc)));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_FCrt_dV_tnode_GND = (deriv_sqrt_0_d0*(((FCa*d_FCa_dV_tnode_GND)+(d_FCa_dV_tnode_GND*FCa))));
          d_FCrt_dV_bi_ci = (deriv_sqrt_0_d0*(((FCa*d_FCa_dV_bi_ci)+(d_FCa_dV_bi_ci*FCa))));
          d_FCrt_dV_bi_ei = (deriv_sqrt_0_d0*(((FCa*d_FCa_dV_bi_ei)+(d_FCa_dV_bi_ei*FCa))));
          FCrt = value_sqrt_0;
        }
        {
          double value_sqrt_0 = sqrt((1.0+(model_.ahc)));

          d_FCa_ck_dV_tnode_GND = (-((d_FCa_dV_tnode_GND+d_FCrt_dV_tnode_GND)/(1.0+value_sqrt_0)));
          d_FCa_ck_dV_bi_ci = (-((d_FCa_dV_bi_ci+d_FCrt_dV_bi_ci)/(1.0+value_sqrt_0)));
          d_FCa_ck_dV_bi_ei = (-((d_FCa_dV_bi_ei+d_FCrt_dV_bi_ei)/(1.0+value_sqrt_0)));
          FCa_ck = (1.0-((FCa+FCrt)/(1.0+value_sqrt_0)));
        }

        d_FCdaick_ditf_dV_tnode_GND = (((FCrt*itf)*(((FCa_ck-1.0)*(-d_FCa_dV_tnode_GND))+(d_FCa_ck_dV_tnode_GND*(1-FCa)))-((FCa_ck-1.0)*(1-FCa))*((FCrt*d_itf_dV_tnode_GND)+(d_FCrt_dV_tnode_GND*itf)))/(FCrt*itf)/(FCrt*itf));
        d_FCdaick_ditf_dV_bi_ci = (((FCrt*itf)*(((FCa_ck-1.0)*(-d_FCa_dV_bi_ci))+(d_FCa_ck_dV_bi_ci*(1-FCa)))-((FCa_ck-1.0)*(1-FCa))*((FCrt*d_itf_dV_bi_ci)+(d_FCrt_dV_bi_ci*itf)))/(FCrt*itf)/(FCrt*itf));
        d_FCdaick_ditf_dV_bi_ei = (((FCrt*itf)*(((FCa_ck-1.0)*(-d_FCa_dV_bi_ei))+(d_FCa_ck_dV_bi_ei*(1-FCa)))-((FCa_ck-1.0)*(1-FCa))*((FCrt*d_itf_dV_bi_ei)+(d_FCrt_dV_bi_ei*itf)))/(FCrt*itf)/(FCrt*itf));
        FCdaick_ditf = (((FCa_ck-1.0)*(1-FCa))/(FCrt*itf));
        if (((model_.latb)>(model_.latl)))
        {

          d_FCz_dV_bi_ei = d_FCz_dV_bi_ci = d_FCz_dV_tnode_GND =  0.0;
          FCz = ((model_.latb)-(model_.latl));
          FCxl = (1.0+(model_.latl));
          FCxb = (1.0+(model_.latb));
          if (((model_.latb)>0.01))
          {
            {
              double value_log_0 = log((FCxb/FCxl));
              FCln = value_log_0;
            }
            {
              double value_exp_0 = exp(((FCa_ck-1.0)*FCln));
              double  deriv_exp_0_d0 = value_exp_0;

              d_FCa1_dV_tnode_GND = (deriv_exp_0_d0*((d_FCa_ck_dV_tnode_GND*FCln)));
              d_FCa1_dV_bi_ci = (deriv_exp_0_d0*((d_FCa_ck_dV_bi_ci*FCln)));
              d_FCa1_dV_bi_ei = (deriv_exp_0_d0*((d_FCa_ck_dV_bi_ei*FCln)));
              FCa1 = value_exp_0;
            }

            d_FCd_a_dV_tnode_GND = (-(-(d_FCa1_dV_tnode_GND*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
            d_FCd_a_dV_bi_ci = (-(-(d_FCa1_dV_bi_ci*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
            d_FCd_a_dV_bi_ei = (-(-(d_FCa1_dV_bi_ei*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
            FCd_a = (1.0/((model_.latl)-(FCa1*(model_.latb))));

            d_FCw_dV_tnode_GND = (((FCa1-1.0)*d_FCd_a_dV_tnode_GND)+(d_FCa1_dV_tnode_GND*FCd_a));
            d_FCw_dV_bi_ci = (((FCa1-1.0)*d_FCd_a_dV_bi_ci)+(d_FCa1_dV_bi_ci*FCd_a));
            d_FCw_dV_bi_ei = (((FCa1-1.0)*d_FCd_a_dV_bi_ei)+(d_FCa1_dV_bi_ei*FCd_a));
            FCw = ((FCa1-1.0)*FCd_a);

            d_FCdw_daick_dV_tnode_GND = ((((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_tnode_GND)+((((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_tnode_GND)+(((((-FCz)*d_FCa1_dV_tnode_GND)+((-d_FCz_dV_tnode_GND)*FCa1))*FCln)*FCd_a))*FCd_a));
            d_FCdw_daick_dV_bi_ci = ((((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_bi_ci)+((((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_bi_ci)+(((((-FCz)*d_FCa1_dV_bi_ci)+((-d_FCz_dV_bi_ci)*FCa1))*FCln)*FCd_a))*FCd_a));
            d_FCdw_daick_dV_bi_ei = ((((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_bi_ei)+((((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_bi_ei)+(((((-FCz)*d_FCa1_dV_bi_ei)+((-d_FCz_dV_bi_ei)*FCa1))*FCln)*FCd_a))*FCd_a));
            FCdw_daick = (((((-FCz)*FCa1)*FCln)*FCd_a)*FCd_a);
            {
              double value_log_0 = log(((1.0+((model_.latb)*FCw))/(1.0+((model_.latl)*FCw))));
              double  deriv_log_0_d0 = (1.0/((1.0+((model_.latb)*FCw))/(1.0+((model_.latl)*FCw))));

              d_FCa1_dV_tnode_GND = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*((model_.latb)*d_FCw_dV_tnode_GND)-(1.0+((model_.latb)*FCw))*((model_.latl)*d_FCw_dV_tnode_GND))/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
              d_FCa1_dV_bi_ci = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*((model_.latb)*d_FCw_dV_bi_ci)-(1.0+((model_.latb)*FCw))*((model_.latl)*d_FCw_dV_bi_ci))/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
              d_FCa1_dV_bi_ei = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*((model_.latb)*d_FCw_dV_bi_ei)-(1.0+((model_.latb)*FCw))*((model_.latl)*d_FCw_dV_bi_ei))/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
              FCa1 = value_log_0;
            }

            d_FCda1_dw_dV_tnode_GND = ((-(model_.latb)*((model_.latb)*d_FCw_dV_tnode_GND)/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*((model_.latl)*d_FCw_dV_tnode_GND)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
            d_FCda1_dw_dV_bi_ci = ((-(model_.latb)*((model_.latb)*d_FCw_dV_bi_ci)/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*((model_.latl)*d_FCw_dV_bi_ci)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
            d_FCda1_dw_dV_bi_ei = ((-(model_.latb)*((model_.latb)*d_FCw_dV_bi_ei)/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*((model_.latl)*d_FCw_dV_bi_ei)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
            FCda1_dw = (((model_.latb)/(1.0+((model_.latb)*FCw)))-((model_.latl)/(1.0+((model_.latl)*FCw))));
          }
          else
          {

            d_FCf1_dV_tnode_GND = (-d_FCa_ck_dV_tnode_GND);
            d_FCf1_dV_bi_ci = (-d_FCa_ck_dV_bi_ci);
            d_FCf1_dV_bi_ei = (-d_FCa_ck_dV_bi_ei);
            FCf1 = (1.0-FCa_ck);

            d_FCd_a_dV_tnode_GND = (-(d_FCa_ck_dV_tnode_GND*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
            d_FCd_a_dV_bi_ci = (-(d_FCa_ck_dV_bi_ci*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
            d_FCd_a_dV_bi_ei = (-(d_FCa_ck_dV_bi_ei*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
            FCd_a = (1.0/(1.0+(FCa_ck*(model_.latb))));

            d_FCw_dV_tnode_GND = ((FCf1*d_FCd_a_dV_tnode_GND)+(d_FCf1_dV_tnode_GND*FCd_a));
            d_FCw_dV_bi_ci = ((FCf1*d_FCd_a_dV_bi_ci)+(d_FCf1_dV_bi_ci*FCd_a));
            d_FCw_dV_bi_ei = ((FCf1*d_FCd_a_dV_bi_ei)+(d_FCf1_dV_bi_ei*FCd_a));
            FCw = (FCf1*FCd_a);

            d_FCdw_daick_dV_tnode_GND = ((((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_tnode_GND)+((((((-1.0)*FCd_a)*d_FCd_a_dV_tnode_GND)+(((-1.0)*d_FCd_a_dV_tnode_GND)*FCd_a))*FCxb)*FCd_a));
            d_FCdw_daick_dV_bi_ci = ((((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_bi_ci)+((((((-1.0)*FCd_a)*d_FCd_a_dV_bi_ci)+(((-1.0)*d_FCd_a_dV_bi_ci)*FCd_a))*FCxb)*FCd_a));
            d_FCdw_daick_dV_bi_ei = ((((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_bi_ei)+((((((-1.0)*FCd_a)*d_FCd_a_dV_bi_ei)+(((-1.0)*d_FCd_a_dV_bi_ei)*FCd_a))*FCxb)*FCd_a));
            FCdw_daick = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*FCd_a);

            d_FCa1_dV_tnode_GND = ((FCz*d_FCw_dV_tnode_GND)+(d_FCz_dV_tnode_GND*FCw));
            d_FCa1_dV_bi_ci = ((FCz*d_FCw_dV_bi_ci)+(d_FCz_dV_bi_ci*FCw));
            d_FCa1_dV_bi_ei = ((FCz*d_FCw_dV_bi_ei)+(d_FCz_dV_bi_ei*FCw));
            FCa1 = (FCz*FCw);

            d_FCda1_dw_dV_bi_ei = d_FCda1_dw_dV_bi_ci = d_FCda1_dw_dV_tnode_GND =  0.0;
            FCda1_dw = FCz;
          }

          d_FCf_CT_dV_bi_ei = d_FCf_CT_dV_bi_ci = d_FCf_CT_dV_tnode_GND =  0.0;
          FCf_CT = (2.0/FCz);

          d_FCw2_dV_tnode_GND = ((FCw*d_FCw_dV_tnode_GND)+(d_FCw_dV_tnode_GND*FCw));
          d_FCw2_dV_bi_ci = ((FCw*d_FCw_dV_bi_ci)+(d_FCw_dV_bi_ci*FCw));
          d_FCw2_dV_bi_ei = ((FCw*d_FCw_dV_bi_ei)+(d_FCw_dV_bi_ei*FCw));
          FCw2 = (FCw*FCw);

          d_FCf1_dV_tnode_GND = ((((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_tnode_GND)+((((model_.latb)*(model_.latl))*d_FCw_dV_tnode_GND)*FCw2))/3.0)+((((model_.latb)+(model_.latl))*d_FCw2_dV_tnode_GND)/2.0))+d_FCw_dV_tnode_GND);
          d_FCf1_dV_bi_ci = ((((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_bi_ci)+((((model_.latb)*(model_.latl))*d_FCw_dV_bi_ci)*FCw2))/3.0)+((((model_.latb)+(model_.latl))*d_FCw2_dV_bi_ci)/2.0))+d_FCw_dV_bi_ci);
          d_FCf1_dV_bi_ei = ((((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_bi_ei)+((((model_.latb)*(model_.latl))*d_FCw_dV_bi_ei)*FCw2))/3.0)+((((model_.latb)+(model_.latl))*d_FCw2_dV_bi_ei)/2.0))+d_FCw_dV_bi_ei);
          FCf1 = (((((((model_.latb)*(model_.latl))*FCw)*FCw2)/3.0)+((((model_.latb)+(model_.latl))*FCw2)/2.0))+FCw);

          d_FCdf1_dw_dV_tnode_GND = ((((model_.latb)*(model_.latl))*d_FCw2_dV_tnode_GND)+(((model_.latb)+(model_.latl))*d_FCw_dV_tnode_GND));
          d_FCdf1_dw_dV_bi_ci = ((((model_.latb)*(model_.latl))*d_FCw2_dV_bi_ci)+(((model_.latb)+(model_.latl))*d_FCw_dV_bi_ci));
          d_FCdf1_dw_dV_bi_ei = ((((model_.latb)*(model_.latl))*d_FCw2_dV_bi_ei)+(((model_.latb)+(model_.latl))*d_FCw_dV_bi_ei));
          FCdf1_dw = (((((model_.latb)*(model_.latl))*FCw2)+(((model_.latb)+(model_.latl))*FCw))+1.0);

          d_z_dV_tnode_GND = ((model_.latb)*d_FCw_dV_tnode_GND);
          d_z_dV_bi_ci = ((model_.latb)*d_FCw_dV_bi_ci);
          d_z_dV_bi_ei = ((model_.latb)*d_FCw_dV_bi_ei);
          z = ((model_.latb)*FCw);
          {
            double value_log_0 = log((1+((model_.latb)*FCw)));
            double  deriv_log_0_d0 = (1.0/(1+((model_.latb)*FCw)));

            d_lnzb_dV_tnode_GND = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_tnode_GND)));
            d_lnzb_dV_bi_ci = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_bi_ci)));
            d_lnzb_dV_bi_ei = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_bi_ei)));
            lnzb = value_log_0;
          }
          if ((z>1.0e-6))
          {

            d_x_dV_tnode_GND = d_z_dV_tnode_GND;
            d_x_dV_bi_ci = d_z_dV_bi_ci;
            d_x_dV_bi_ei = d_z_dV_bi_ei;
            x = (1.0+z);

            d_a_dV_tnode_GND = ((x*d_x_dV_tnode_GND)+(d_x_dV_tnode_GND*x));
            d_a_dV_bi_ci = ((x*d_x_dV_bi_ci)+(d_x_dV_bi_ci*x));
            d_a_dV_bi_ei = ((x*d_x_dV_bi_ei)+(d_x_dV_bi_ei*x));
            a = (x*x);

            d_a2_dV_tnode_GND = (0.250*((a*(2.0*d_lnzb_dV_tnode_GND))+(d_a_dV_tnode_GND*((2.0*lnzb)-1.0))));
            d_a2_dV_bi_ci = (0.250*((a*(2.0*d_lnzb_dV_bi_ci))+(d_a_dV_bi_ci*((2.0*lnzb)-1.0))));
            d_a2_dV_bi_ei = (0.250*((a*(2.0*d_lnzb_dV_bi_ei))+(d_a_dV_bi_ei*((2.0*lnzb)-1.0))));
            a2 = (0.250*((a*((2.0*lnzb)-1.0))+1.0));

            d_a3_dV_tnode_GND = ((((a*x)*(3.0*d_lnzb_dV_tnode_GND))+(((a*d_x_dV_tnode_GND)+(d_a_dV_tnode_GND*x))*((3.0*lnzb)-1.0)))/9.0);
            d_a3_dV_bi_ci = ((((a*x)*(3.0*d_lnzb_dV_bi_ci))+(((a*d_x_dV_bi_ci)+(d_a_dV_bi_ci*x))*((3.0*lnzb)-1.0)))/9.0);
            d_a3_dV_bi_ei = ((((a*x)*(3.0*d_lnzb_dV_bi_ei))+(((a*d_x_dV_bi_ei)+(d_a_dV_bi_ei*x))*((3.0*lnzb)-1.0)))/9.0);
            a3 = ((((a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
            r = ((model_.latl)/(model_.latb));

            d_FCf2_dV_tnode_GND = ((((1.0-r)*d_a2_dV_tnode_GND)+(r*d_a3_dV_tnode_GND))/(model_.latb));
            d_FCf2_dV_bi_ci = ((((1.0-r)*d_a2_dV_bi_ci)+(r*d_a3_dV_bi_ci))/(model_.latb));
            d_FCf2_dV_bi_ei = ((((1.0-r)*d_a2_dV_bi_ei)+(r*d_a3_dV_bi_ei))/(model_.latb));
            FCf2 = ((((1.0-r)*a2)+(r*a3))/(model_.latb));

            d_FCdf2_dw_dV_tnode_GND = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_tnode_GND)+((((1.0-r)*d_x_dV_tnode_GND)+(r*d_a_dV_tnode_GND))*lnzb));
            d_FCdf2_dw_dV_bi_ci = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ci)+((((1.0-r)*d_x_dV_bi_ci)+(r*d_a_dV_bi_ci))*lnzb));
            d_FCdf2_dw_dV_bi_ei = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ei)+((((1.0-r)*d_x_dV_bi_ei)+(r*d_a_dV_bi_ei))*lnzb));
            FCdf2_dw = ((((1.0-r)*x)+(r*a))*lnzb);
          }
          else
          {

            d_a_dV_tnode_GND = ((z*d_z_dV_tnode_GND)+(d_z_dV_tnode_GND*z));
            d_a_dV_bi_ci = ((z*d_z_dV_bi_ci)+(d_z_dV_bi_ci*z));
            d_a_dV_bi_ei = ((z*d_z_dV_bi_ei)+(d_z_dV_bi_ei*z));
            a = (z*z);

            d_a2_dV_tnode_GND = ((d_z_dV_tnode_GND-(0.25*d_a_dV_tnode_GND))+(((0.10*z)*d_a_dV_tnode_GND)+((0.10*d_z_dV_tnode_GND)*a)));
            d_a2_dV_bi_ci = ((d_z_dV_bi_ci-(0.25*d_a_dV_bi_ci))+(((0.10*z)*d_a_dV_bi_ci)+((0.10*d_z_dV_bi_ci)*a)));
            d_a2_dV_bi_ei = ((d_z_dV_bi_ei-(0.25*d_a_dV_bi_ei))+(((0.10*z)*d_a_dV_bi_ei)+((0.10*d_z_dV_bi_ei)*a)));
            a2 = (((3.0+z)-(0.25*a))+((0.10*z)*a));

            d_a3_dV_tnode_GND = (((2.0*d_z_dV_tnode_GND)+(0.75*d_a_dV_tnode_GND))-(((0.20*a)*d_z_dV_tnode_GND)+((0.20*d_a_dV_tnode_GND)*z)));
            d_a3_dV_bi_ci = (((2.0*d_z_dV_bi_ci)+(0.75*d_a_dV_bi_ci))-(((0.20*a)*d_z_dV_bi_ci)+((0.20*d_a_dV_bi_ci)*z)));
            d_a3_dV_bi_ei = (((2.0*d_z_dV_bi_ei)+(0.75*d_a_dV_bi_ei))-(((0.20*a)*d_z_dV_bi_ei)+((0.20*d_a_dV_bi_ei)*z)));
            a3 = (((2.0*z)+(0.75*a))-((0.20*a)*z));

            d_FCf2_dV_tnode_GND = (((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_tnode_GND)+((((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_tnode_GND)+((((model_.latb)*d_a2_dV_tnode_GND)+((model_.latl)*d_a3_dV_tnode_GND))*FCw))*FCw))/6.0);
            d_FCf2_dV_bi_ci = (((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_bi_ci)+((((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_bi_ci)+((((model_.latb)*d_a2_dV_bi_ci)+((model_.latl)*d_a3_dV_bi_ci))*FCw))*FCw))/6.0);
            d_FCf2_dV_bi_ei = (((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_bi_ei)+((((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_bi_ei)+((((model_.latb)*d_a2_dV_bi_ei)+((model_.latl)*d_a3_dV_bi_ei))*FCw))*FCw))/6.0);
            FCf2 = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*FCw)/6.0);

            d_FCdf2_dw_dV_tnode_GND = ((((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_tnode_GND)+((((1+((model_.latl)*FCw))*d_z_dV_tnode_GND)+(((model_.latl)*d_FCw_dV_tnode_GND)*(1+z)))*lnzb));
            d_FCdf2_dw_dV_bi_ci = ((((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_bi_ci)+((((1+((model_.latl)*FCw))*d_z_dV_bi_ci)+(((model_.latl)*d_FCw_dV_bi_ci)*(1+z)))*lnzb));
            d_FCdf2_dw_dV_bi_ei = ((((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_bi_ei)+((((1+((model_.latl)*FCw))*d_z_dV_bi_ei)+(((model_.latl)*d_FCw_dV_bi_ei)*(1+z)))*lnzb));
            FCdf2_dw = (((1+((model_.latl)*FCw))*(1+z))*lnzb);
          }

          d_z_dV_tnode_GND = ((model_.latl)*d_FCw_dV_tnode_GND);
          d_z_dV_bi_ci = ((model_.latl)*d_FCw_dV_bi_ci);
          d_z_dV_bi_ei = ((model_.latl)*d_FCw_dV_bi_ei);
          z = ((model_.latl)*FCw);
          {
            double value_log_0 = log((1+((model_.latl)*FCw)));
            double  deriv_log_0_d0 = (1.0/(1+((model_.latl)*FCw)));

            d_lnzb_dV_tnode_GND = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_tnode_GND)));
            d_lnzb_dV_bi_ci = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_bi_ci)));
            d_lnzb_dV_bi_ei = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_bi_ei)));
            lnzb = value_log_0;
          }
          if ((z>1.0e-6))
          {

            d_x_dV_tnode_GND = d_z_dV_tnode_GND;
            d_x_dV_bi_ci = d_z_dV_bi_ci;
            d_x_dV_bi_ei = d_z_dV_bi_ei;
            x = (1.0+z);

            d_a_dV_tnode_GND = ((x*d_x_dV_tnode_GND)+(d_x_dV_tnode_GND*x));
            d_a_dV_bi_ci = ((x*d_x_dV_bi_ci)+(d_x_dV_bi_ci*x));
            d_a_dV_bi_ei = ((x*d_x_dV_bi_ei)+(d_x_dV_bi_ei*x));
            a = (x*x);

            d_a2_dV_tnode_GND = (0.250*((a*(2.0*d_lnzb_dV_tnode_GND))+(d_a_dV_tnode_GND*((2.0*lnzb)-1.0))));
            d_a2_dV_bi_ci = (0.250*((a*(2.0*d_lnzb_dV_bi_ci))+(d_a_dV_bi_ci*((2.0*lnzb)-1.0))));
            d_a2_dV_bi_ei = (0.250*((a*(2.0*d_lnzb_dV_bi_ei))+(d_a_dV_bi_ei*((2.0*lnzb)-1.0))));
            a2 = (0.250*((a*((2.0*lnzb)-1.0))+1.0));

            d_a3_dV_tnode_GND = ((((a*x)*(3.0*d_lnzb_dV_tnode_GND))+(((a*d_x_dV_tnode_GND)+(d_a_dV_tnode_GND*x))*((3.0*lnzb)-1.0)))/9.0);
            d_a3_dV_bi_ci = ((((a*x)*(3.0*d_lnzb_dV_bi_ci))+(((a*d_x_dV_bi_ci)+(d_a_dV_bi_ci*x))*((3.0*lnzb)-1.0)))/9.0);
            d_a3_dV_bi_ei = ((((a*x)*(3.0*d_lnzb_dV_bi_ei))+(((a*d_x_dV_bi_ei)+(d_a_dV_bi_ei*x))*((3.0*lnzb)-1.0)))/9.0);
            a3 = ((((a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
            r = ((model_.latb)/(model_.latl));

            d_FCf3_dV_tnode_GND = ((((1.0-r)*d_a2_dV_tnode_GND)+(r*d_a3_dV_tnode_GND))/(model_.latl));
            d_FCf3_dV_bi_ci = ((((1.0-r)*d_a2_dV_bi_ci)+(r*d_a3_dV_bi_ci))/(model_.latl));
            d_FCf3_dV_bi_ei = ((((1.0-r)*d_a2_dV_bi_ei)+(r*d_a3_dV_bi_ei))/(model_.latl));
            FCf3 = ((((1.0-r)*a2)+(r*a3))/(model_.latl));

            d_FCdf3_dw_dV_tnode_GND = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_tnode_GND)+((((1.0-r)*d_x_dV_tnode_GND)+(r*d_a_dV_tnode_GND))*lnzb));
            d_FCdf3_dw_dV_bi_ci = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ci)+((((1.0-r)*d_x_dV_bi_ci)+(r*d_a_dV_bi_ci))*lnzb));
            d_FCdf3_dw_dV_bi_ei = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ei)+((((1.0-r)*d_x_dV_bi_ei)+(r*d_a_dV_bi_ei))*lnzb));
            FCdf3_dw = ((((1.0-r)*x)+(r*a))*lnzb);
          }
          else
          {

            d_a_dV_tnode_GND = ((z*d_z_dV_tnode_GND)+(d_z_dV_tnode_GND*z));
            d_a_dV_bi_ci = ((z*d_z_dV_bi_ci)+(d_z_dV_bi_ci*z));
            d_a_dV_bi_ei = ((z*d_z_dV_bi_ei)+(d_z_dV_bi_ei*z));
            a = (z*z);

            d_a2_dV_tnode_GND = ((d_z_dV_tnode_GND-(0.25*d_a_dV_tnode_GND))+(((0.10*z)*d_a_dV_tnode_GND)+((0.10*d_z_dV_tnode_GND)*a)));
            d_a2_dV_bi_ci = ((d_z_dV_bi_ci-(0.25*d_a_dV_bi_ci))+(((0.10*z)*d_a_dV_bi_ci)+((0.10*d_z_dV_bi_ci)*a)));
            d_a2_dV_bi_ei = ((d_z_dV_bi_ei-(0.25*d_a_dV_bi_ei))+(((0.10*z)*d_a_dV_bi_ei)+((0.10*d_z_dV_bi_ei)*a)));
            a2 = (((3.0+z)-(0.25*a))+((0.10*z)*a));

            d_a3_dV_tnode_GND = (((2.0*d_z_dV_tnode_GND)+(0.75*d_a_dV_tnode_GND))-(((0.20*a)*d_z_dV_tnode_GND)+((0.20*d_a_dV_tnode_GND)*z)));
            d_a3_dV_bi_ci = (((2.0*d_z_dV_bi_ci)+(0.75*d_a_dV_bi_ci))-(((0.20*a)*d_z_dV_bi_ci)+((0.20*d_a_dV_bi_ci)*z)));
            d_a3_dV_bi_ei = (((2.0*d_z_dV_bi_ei)+(0.75*d_a_dV_bi_ei))-(((0.20*a)*d_z_dV_bi_ei)+((0.20*d_a_dV_bi_ei)*z)));
            a3 = (((2.0*z)+(0.75*a))-((0.20*a)*z));

            d_FCf3_dV_tnode_GND = (((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_tnode_GND)+((((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_tnode_GND)+((((model_.latl)*d_a2_dV_tnode_GND)+((model_.latb)*d_a3_dV_tnode_GND))*FCw))*FCw))/6.0);
            d_FCf3_dV_bi_ci = (((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_bi_ci)+((((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_bi_ci)+((((model_.latl)*d_a2_dV_bi_ci)+((model_.latb)*d_a3_dV_bi_ci))*FCw))*FCw))/6.0);
            d_FCf3_dV_bi_ei = (((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_bi_ei)+((((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_bi_ei)+((((model_.latl)*d_a2_dV_bi_ei)+((model_.latb)*d_a3_dV_bi_ei))*FCw))*FCw))/6.0);
            FCf3 = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*FCw)/6.0);

            d_FCdf3_dw_dV_tnode_GND = ((((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_tnode_GND)+((((1+((model_.latb)*FCw))*d_z_dV_tnode_GND)+(((model_.latb)*d_FCw_dV_tnode_GND)*(1+z)))*lnzb));
            d_FCdf3_dw_dV_bi_ci = ((((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_bi_ci)+((((1+((model_.latb)*FCw))*d_z_dV_bi_ci)+(((model_.latb)*d_FCw_dV_bi_ci)*(1+z)))*lnzb));
            d_FCdf3_dw_dV_bi_ei = ((((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_bi_ei)+((((1+((model_.latb)*FCw))*d_z_dV_bi_ei)+(((model_.latb)*d_FCw_dV_bi_ei)*(1+z)))*lnzb));
            FCdf3_dw = (((1+((model_.latb)*FCw))*(1+z))*lnzb);
          }

          d_FCf_ci_dV_tnode_GND = ((FCf_CT*((((FCa1*d_FCf1_dV_tnode_GND)+(d_FCa1_dV_tnode_GND*FCf1))-d_FCf2_dV_tnode_GND)+d_FCf3_dV_tnode_GND))+(d_FCf_CT_dV_tnode_GND*(((FCa1*FCf1)-FCf2)+FCf3)));
          d_FCf_ci_dV_bi_ci = ((FCf_CT*((((FCa1*d_FCf1_dV_bi_ci)+(d_FCa1_dV_bi_ci*FCf1))-d_FCf2_dV_bi_ci)+d_FCf3_dV_bi_ci))+(d_FCf_CT_dV_bi_ci*(((FCa1*FCf1)-FCf2)+FCf3)));
          d_FCf_ci_dV_bi_ei = ((FCf_CT*((((FCa1*d_FCf1_dV_bi_ei)+(d_FCa1_dV_bi_ei*FCf1))-d_FCf2_dV_bi_ei)+d_FCf3_dV_bi_ei))+(d_FCf_CT_dV_bi_ei*(((FCa1*FCf1)-FCf2)+FCf3)));
          FCf_ci = (FCf_CT*(((FCa1*FCf1)-FCf2)+FCf3));

          d_FCdfc_dw_dV_tnode_GND = ((FCf_CT*(((((FCa1*d_FCdf1_dw_dV_tnode_GND)+(d_FCa1_dV_tnode_GND*FCdf1_dw))+((FCda1_dw*d_FCf1_dV_tnode_GND)+(d_FCda1_dw_dV_tnode_GND*FCf1)))-d_FCdf2_dw_dV_tnode_GND)+d_FCdf3_dw_dV_tnode_GND))+(d_FCf_CT_dV_tnode_GND*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw)));
          d_FCdfc_dw_dV_bi_ci = ((FCf_CT*(((((FCa1*d_FCdf1_dw_dV_bi_ci)+(d_FCa1_dV_bi_ci*FCdf1_dw))+((FCda1_dw*d_FCf1_dV_bi_ci)+(d_FCda1_dw_dV_bi_ci*FCf1)))-d_FCdf2_dw_dV_bi_ci)+d_FCdf3_dw_dV_bi_ci))+(d_FCf_CT_dV_bi_ci*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw)));
          d_FCdfc_dw_dV_bi_ei = ((FCf_CT*(((((FCa1*d_FCdf1_dw_dV_bi_ei)+(d_FCa1_dV_bi_ei*FCdf1_dw))+((FCda1_dw*d_FCf1_dV_bi_ei)+(d_FCda1_dw_dV_bi_ei*FCf1)))-d_FCdf2_dw_dV_bi_ei)+d_FCdf3_dw_dV_bi_ei))+(d_FCf_CT_dV_bi_ei*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw)));
          FCdfc_dw = (FCf_CT*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));

          d_FCdw_ditf_dV_tnode_GND = ((FCdw_daick*d_FCdaick_ditf_dV_tnode_GND)+(d_FCdw_daick_dV_tnode_GND*FCdaick_ditf));
          d_FCdw_ditf_dV_bi_ci = ((FCdw_daick*d_FCdaick_ditf_dV_bi_ci)+(d_FCdw_daick_dV_bi_ci*FCdaick_ditf));
          d_FCdw_ditf_dV_bi_ei = ((FCdw_daick*d_FCdaick_ditf_dV_bi_ei)+(d_FCdw_daick_dV_bi_ei*FCdaick_ditf));
          FCdw_ditf = (FCdw_daick*FCdaick_ditf);

          d_FCdfc_ditf_dV_tnode_GND = ((FCdfc_dw*d_FCdw_ditf_dV_tnode_GND)+(d_FCdfc_dw_dV_tnode_GND*FCdw_ditf));
          d_FCdfc_ditf_dV_bi_ci = ((FCdfc_dw*d_FCdw_ditf_dV_bi_ci)+(d_FCdfc_dw_dV_bi_ci*FCdw_ditf));
          d_FCdfc_ditf_dV_bi_ei = ((FCdfc_dw*d_FCdw_ditf_dV_bi_ei)+(d_FCdfc_dw_dV_bi_ei*FCdw_ditf));
          FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
          if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
          {

            d_a_dV_tnode_GND = ((model_.latb)*d_FCw_dV_tnode_GND);
            d_a_dV_bi_ci = ((model_.latb)*d_FCw_dV_bi_ci);
            d_a_dV_bi_ei = ((model_.latb)*d_FCw_dV_bi_ei);
            a = ((model_.latb)*FCw);
            {
              double value_log_0 = log((1+((model_.latb)*FCw)));
              double  deriv_log_0_d0 = (1.0/(1+((model_.latb)*FCw)));

              d_lnz_dV_tnode_GND = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_tnode_GND)));
              d_lnz_dV_bi_ci = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_bi_ci)));
              d_lnz_dV_bi_ei = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_bi_ei)));
              lnz = value_log_0;
            }
            if ((a>1.0e-6))
            {

              d_FCf2_dV_tnode_GND = ((d_a_dV_tnode_GND-d_lnz_dV_tnode_GND)/(model_.latb));
              d_FCf2_dV_bi_ci = ((d_a_dV_bi_ci-d_lnz_dV_bi_ci)/(model_.latb));
              d_FCf2_dV_bi_ei = ((d_a_dV_bi_ei-d_lnz_dV_bi_ei)/(model_.latb));
              FCf2 = ((a-lnz)/(model_.latb));

              d_FCdf2_dw_dV_tnode_GND = (((1.0+a)*d_a_dV_tnode_GND-a*d_a_dV_tnode_GND)/(1.0+a)/(1.0+a));
              d_FCdf2_dw_dV_bi_ci = (((1.0+a)*d_a_dV_bi_ci-a*d_a_dV_bi_ci)/(1.0+a)/(1.0+a));
              d_FCdf2_dw_dV_bi_ei = (((1.0+a)*d_a_dV_bi_ei-a*d_a_dV_bi_ei)/(1.0+a)/(1.0+a));
              FCdf2_dw = (a/(1.0+a));
            }
            else
            {

              d_FCf2_dV_tnode_GND = (((0.5*a)*d_FCw_dV_tnode_GND)+((0.5*d_a_dV_tnode_GND)*FCw));
              d_FCf2_dV_bi_ci = (((0.5*a)*d_FCw_dV_bi_ci)+((0.5*d_a_dV_bi_ci)*FCw));
              d_FCf2_dV_bi_ei = (((0.5*a)*d_FCw_dV_bi_ei)+((0.5*d_a_dV_bi_ei)*FCw));
              FCf2 = ((0.5*a)*FCw);

              d_FCdf2_dw_dV_tnode_GND = d_a_dV_tnode_GND;
              d_FCdf2_dw_dV_bi_ci = d_a_dV_bi_ci;
              d_FCdf2_dw_dV_bi_ei = d_a_dV_bi_ei;
              FCdf2_dw = a;
            }

            d_a_dV_tnode_GND = ((model_.latl)*d_FCw_dV_tnode_GND);
            d_a_dV_bi_ci = ((model_.latl)*d_FCw_dV_bi_ci);
            d_a_dV_bi_ei = ((model_.latl)*d_FCw_dV_bi_ei);
            a = ((model_.latl)*FCw);
            {
              double value_log_0 = log((1+((model_.latl)*FCw)));
              double  deriv_log_0_d0 = (1.0/(1+((model_.latl)*FCw)));

              d_lnz_dV_tnode_GND = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_tnode_GND)));
              d_lnz_dV_bi_ci = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_bi_ci)));
              d_lnz_dV_bi_ei = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_bi_ei)));
              lnz = value_log_0;
            }
            if ((a>1.0e-6))
            {

              d_FCf3_dV_tnode_GND = ((d_a_dV_tnode_GND-d_lnz_dV_tnode_GND)/(model_.latl));
              d_FCf3_dV_bi_ci = ((d_a_dV_bi_ci-d_lnz_dV_bi_ci)/(model_.latl));
              d_FCf3_dV_bi_ei = ((d_a_dV_bi_ei-d_lnz_dV_bi_ei)/(model_.latl));
              FCf3 = ((a-lnz)/(model_.latl));

              d_FCdf3_dw_dV_tnode_GND = (((1.0+a)*d_a_dV_tnode_GND-a*d_a_dV_tnode_GND)/(1.0+a)/(1.0+a));
              d_FCdf3_dw_dV_bi_ci = (((1.0+a)*d_a_dV_bi_ci-a*d_a_dV_bi_ci)/(1.0+a)/(1.0+a));
              d_FCdf3_dw_dV_bi_ei = (((1.0+a)*d_a_dV_bi_ei-a*d_a_dV_bi_ei)/(1.0+a)/(1.0+a));
              FCdf3_dw = (a/(1.0+a));
            }
            else
            {

              d_FCf3_dV_tnode_GND = (((0.5*a)*d_FCw_dV_tnode_GND)+((0.5*d_a_dV_tnode_GND)*FCw));
              d_FCf3_dV_bi_ci = (((0.5*a)*d_FCw_dV_bi_ci)+((0.5*d_a_dV_bi_ci)*FCw));
              d_FCf3_dV_bi_ei = (((0.5*a)*d_FCw_dV_bi_ei)+((0.5*d_a_dV_bi_ei)*FCw));
              FCf3 = ((0.5*a)*FCw);

              d_FCdf3_dw_dV_tnode_GND = d_a_dV_tnode_GND;
              d_FCdf3_dw_dV_bi_ci = d_a_dV_bi_ci;
              d_FCdf3_dw_dV_bi_ei = d_a_dV_bi_ei;
              FCdf3_dw = a;
            }

            d_FCf_CT_dV_tnode_GND = ((FCf_CT*(d_FCf2_dV_tnode_GND-d_FCf3_dV_tnode_GND))+(d_FCf_CT_dV_tnode_GND*(FCf2-FCf3)));
            d_FCf_CT_dV_bi_ci = ((FCf_CT*(d_FCf2_dV_bi_ci-d_FCf3_dV_bi_ci))+(d_FCf_CT_dV_bi_ci*(FCf2-FCf3)));
            d_FCf_CT_dV_bi_ei = ((FCf_CT*(d_FCf2_dV_bi_ei-d_FCf3_dV_bi_ei))+(d_FCf_CT_dV_bi_ei*(FCf2-FCf3)));
            FCf_CT = (FCf_CT*(FCf2-FCf3));

            d_FCdfCT_dw_dV_tnode_GND = ((FCf_CT*(d_FCdf2_dw_dV_tnode_GND-d_FCdf3_dw_dV_tnode_GND))+(d_FCf_CT_dV_tnode_GND*(FCdf2_dw-FCdf3_dw)));
            d_FCdfCT_dw_dV_bi_ci = ((FCf_CT*(d_FCdf2_dw_dV_bi_ci-d_FCdf3_dw_dV_bi_ci))+(d_FCf_CT_dV_bi_ci*(FCdf2_dw-FCdf3_dw)));
            d_FCdfCT_dw_dV_bi_ei = ((FCf_CT*(d_FCdf2_dw_dV_bi_ei-d_FCdf3_dw_dV_bi_ei))+(d_FCf_CT_dV_bi_ei*(FCdf2_dw-FCdf3_dw)));
            FCdfCT_dw = (FCf_CT*(FCdf2_dw-FCdf3_dw));

            d_FCdfCT_ditf_dV_tnode_GND = ((FCdfCT_dw*d_FCdw_ditf_dV_tnode_GND)+(d_FCdfCT_dw_dV_tnode_GND*FCdw_ditf));
            d_FCdfCT_ditf_dV_bi_ci = ((FCdfCT_dw*d_FCdw_ditf_dV_bi_ci)+(d_FCdfCT_dw_dV_bi_ci*FCdw_ditf));
            d_FCdfCT_ditf_dV_bi_ei = ((FCdfCT_dw*d_FCdw_ditf_dV_bi_ei)+(d_FCdfCT_dw_dV_bi_ei*FCdw_ditf));
            FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
          }
          else
          {

            d_FCf_CT_dV_tnode_GND = d_FCf_ci_dV_tnode_GND;
            d_FCf_CT_dV_bi_ci = d_FCf_ci_dV_bi_ci;
            d_FCf_CT_dV_bi_ei = d_FCf_ci_dV_bi_ei;
            FCf_CT = FCf_ci;

            d_FCdfCT_ditf_dV_tnode_GND = d_FCdfc_ditf_dV_tnode_GND;
            d_FCdfCT_ditf_dV_bi_ci = d_FCdfc_ditf_dV_bi_ci;
            d_FCdfCT_ditf_dV_bi_ei = d_FCdfc_ditf_dV_bi_ei;
            FCdfCT_ditf = FCdfc_ditf;
          }
        }
        else
        {
          if (((model_.latb)>0.01))
          {

            d_FCd_a_dV_tnode_GND = (-(d_FCa_ck_dV_tnode_GND*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
            d_FCd_a_dV_bi_ci = (-(d_FCa_ck_dV_bi_ci*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
            d_FCd_a_dV_bi_ei = (-(d_FCa_ck_dV_bi_ei*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
            FCd_a = (1.0/(1.0+(FCa_ck*(model_.latb))));

            d_FCw_dV_tnode_GND = (((1.0-FCa_ck)*d_FCd_a_dV_tnode_GND)+((-d_FCa_ck_dV_tnode_GND)*FCd_a));
            d_FCw_dV_bi_ci = (((1.0-FCa_ck)*d_FCd_a_dV_bi_ci)+((-d_FCa_ck_dV_bi_ci)*FCd_a));
            d_FCw_dV_bi_ei = (((1.0-FCa_ck)*d_FCd_a_dV_bi_ei)+((-d_FCa_ck_dV_bi_ei)*FCd_a));
            FCw = ((1.0-FCa_ck)*FCd_a);

            d_FCdw_daick_dV_tnode_GND = ((((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_tnode_GND)+(((-(1.0+(model_.latb)))*d_FCd_a_dV_tnode_GND)*FCd_a));
            d_FCdw_daick_dV_bi_ci = ((((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_bi_ci)+(((-(1.0+(model_.latb)))*d_FCd_a_dV_bi_ci)*FCd_a));
            d_FCdw_daick_dV_bi_ei = ((((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_bi_ei)+(((-(1.0+(model_.latb)))*d_FCd_a_dV_bi_ei)*FCd_a));
            FCdw_daick = (((-(1.0+(model_.latb)))*FCd_a)*FCd_a);
          }
          else
          {

            d_FCw_dV_tnode_GND = ((-d_FCa_ck_dV_tnode_GND)-(d_FCa_ck_dV_tnode_GND*(model_.latb)));
            d_FCw_dV_bi_ci = ((-d_FCa_ck_dV_bi_ci)-(d_FCa_ck_dV_bi_ci*(model_.latb)));
            d_FCw_dV_bi_ei = ((-d_FCa_ck_dV_bi_ei)-(d_FCa_ck_dV_bi_ei*(model_.latb)));
            FCw = ((1.0-FCa_ck)-(FCa_ck*(model_.latb)));

            d_FCdw_daick_dV_bi_ei = d_FCdw_daick_dV_bi_ci = d_FCdw_daick_dV_tnode_GND =  0.0;
            FCdw_daick = (-(1.0+(model_.latb)));
          }

          d_FCw2_dV_tnode_GND = ((FCw*d_FCw_dV_tnode_GND)+(d_FCw_dV_tnode_GND*FCw));
          d_FCw2_dV_bi_ci = ((FCw*d_FCw_dV_bi_ci)+(d_FCw_dV_bi_ci*FCw));
          d_FCw2_dV_bi_ei = ((FCw*d_FCw_dV_bi_ei)+(d_FCw_dV_bi_ei*FCw));
          FCw2 = (FCw*FCw);

          d_FCz_dV_tnode_GND = ((model_.latb)*d_FCw_dV_tnode_GND);
          d_FCz_dV_bi_ci = ((model_.latb)*d_FCw_dV_bi_ci);
          d_FCz_dV_bi_ei = ((model_.latb)*d_FCw_dV_bi_ei);
          FCz = ((model_.latb)*FCw);

          d_FCz_1_dV_tnode_GND = d_FCz_dV_tnode_GND;
          d_FCz_1_dV_bi_ci = d_FCz_dV_bi_ci;
          d_FCz_1_dV_bi_ei = d_FCz_dV_bi_ei;
          FCz_1 = (1.0+FCz);

          d_FCd_f_dV_tnode_GND = (-d_FCz_1_dV_tnode_GND/FCz_1/FCz_1);
          d_FCd_f_dV_bi_ci = (-d_FCz_1_dV_bi_ci/FCz_1/FCz_1);
          d_FCd_f_dV_bi_ei = (-d_FCz_1_dV_bi_ei/FCz_1/FCz_1);
          FCd_f = (1.0/FCz_1);

          d_FCf_ci_dV_tnode_GND = (((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_tnode_GND)+(((FCw2*(d_FCz_dV_tnode_GND/3.0))+(d_FCw2_dV_tnode_GND*(1.0+(FCz/3.0))))*FCd_f));
          d_FCf_ci_dV_bi_ci = (((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_bi_ci)+(((FCw2*(d_FCz_dV_bi_ci/3.0))+(d_FCw2_dV_bi_ci*(1.0+(FCz/3.0))))*FCd_f));
          d_FCf_ci_dV_bi_ei = (((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_bi_ei)+(((FCw2*(d_FCz_dV_bi_ei/3.0))+(d_FCw2_dV_bi_ei*(1.0+(FCz/3.0))))*FCd_f));
          FCf_ci = ((FCw2*(1.0+(FCz/3.0)))*FCd_f);

          d_FCdfc_dw_dV_tnode_GND = (((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_tnode_GND)+(((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_tnode_GND)+((((2.0*FCw)*(d_FCz_1_dV_tnode_GND+(((FCz*d_FCz_dV_tnode_GND)+(d_FCz_dV_tnode_GND*FCz))/3.0)))+((2.0*d_FCw_dV_tnode_GND)*(FCz_1+((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
          d_FCdfc_dw_dV_bi_ci = (((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ci)+(((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ci)+((((2.0*FCw)*(d_FCz_1_dV_bi_ci+(((FCz*d_FCz_dV_bi_ci)+(d_FCz_dV_bi_ci*FCz))/3.0)))+((2.0*d_FCw_dV_bi_ci)*(FCz_1+((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
          d_FCdfc_dw_dV_bi_ei = (((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ei)+(((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ei)+((((2.0*FCw)*(d_FCz_1_dV_bi_ei+(((FCz*d_FCz_dV_bi_ei)+(d_FCz_dV_bi_ei*FCz))/3.0)))+((2.0*d_FCw_dV_bi_ei)*(FCz_1+((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
          FCdfc_dw = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);

          d_FCdw_ditf_dV_tnode_GND = ((FCdw_daick*d_FCdaick_ditf_dV_tnode_GND)+(d_FCdw_daick_dV_tnode_GND*FCdaick_ditf));
          d_FCdw_ditf_dV_bi_ci = ((FCdw_daick*d_FCdaick_ditf_dV_bi_ci)+(d_FCdw_daick_dV_bi_ci*FCdaick_ditf));
          d_FCdw_ditf_dV_bi_ei = ((FCdw_daick*d_FCdaick_ditf_dV_bi_ei)+(d_FCdw_daick_dV_bi_ei*FCdaick_ditf));
          FCdw_ditf = (FCdw_daick*FCdaick_ditf);

          d_FCdfc_ditf_dV_tnode_GND = ((FCdfc_dw*d_FCdw_ditf_dV_tnode_GND)+(d_FCdfc_dw_dV_tnode_GND*FCdw_ditf));
          d_FCdfc_ditf_dV_bi_ci = ((FCdfc_dw*d_FCdw_ditf_dV_bi_ci)+(d_FCdfc_dw_dV_bi_ci*FCdw_ditf));
          d_FCdfc_ditf_dV_bi_ei = ((FCdfc_dw*d_FCdw_ditf_dV_bi_ei)+(d_FCdfc_dw_dV_bi_ei*FCdw_ditf));
          FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
          if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
          {
            if ((FCz>0.001))
            {
              {
                double value_log_0 = log(FCz_1);
                double  deriv_log_0_d0 = (1.0/FCz_1);

                d_FCf_CT_dV_tnode_GND = (((((model_.latb)*(model_.latb))*FCz_1)*(2.0*(((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_tnode_GND)))+(d_FCz_1_dV_tnode_GND*value_log_0))-d_FCz_dV_tnode_GND))-(2.0*((FCz_1*value_log_0)-FCz))*(((model_.latb)*(model_.latb))*d_FCz_1_dV_tnode_GND))/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
                d_FCf_CT_dV_bi_ci = (((((model_.latb)*(model_.latb))*FCz_1)*(2.0*(((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_bi_ci)))+(d_FCz_1_dV_bi_ci*value_log_0))-d_FCz_dV_bi_ci))-(2.0*((FCz_1*value_log_0)-FCz))*(((model_.latb)*(model_.latb))*d_FCz_1_dV_bi_ci))/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
                d_FCf_CT_dV_bi_ei = (((((model_.latb)*(model_.latb))*FCz_1)*(2.0*(((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_bi_ei)))+(d_FCz_1_dV_bi_ei*value_log_0))-d_FCz_dV_bi_ei))-(2.0*((FCz_1*value_log_0)-FCz))*(((model_.latb)*(model_.latb))*d_FCz_1_dV_bi_ei))/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
                FCf_CT = ((2.0*((FCz_1*value_log_0)-FCz))/(((model_.latb)*(model_.latb))*FCz_1));
              }

              d_FCdfCT_dw_dV_tnode_GND = ((((2.0*FCw)*FCd_f)*d_FCd_f_dV_tnode_GND)+((((2.0*FCw)*d_FCd_f_dV_tnode_GND)+((2.0*d_FCw_dV_tnode_GND)*FCd_f))*FCd_f));
              d_FCdfCT_dw_dV_bi_ci = ((((2.0*FCw)*FCd_f)*d_FCd_f_dV_bi_ci)+((((2.0*FCw)*d_FCd_f_dV_bi_ci)+((2.0*d_FCw_dV_bi_ci)*FCd_f))*FCd_f));
              d_FCdfCT_dw_dV_bi_ei = ((((2.0*FCw)*FCd_f)*d_FCd_f_dV_bi_ei)+((((2.0*FCw)*d_FCd_f_dV_bi_ei)+((2.0*d_FCw_dV_bi_ei)*FCd_f))*FCd_f));
              FCdfCT_dw = (((2.0*FCw)*FCd_f)*FCd_f);
            }
            else
            {

              d_FCf_CT_dV_tnode_GND = (((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_tnode_GND)+(((FCw2*(-(d_FCz_dV_tnode_GND/3.0)))+(d_FCw2_dV_tnode_GND*(1.0-(FCz/3.0))))*FCd_f));
              d_FCf_CT_dV_bi_ci = (((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_bi_ci)+(((FCw2*(-(d_FCz_dV_bi_ci/3.0)))+(d_FCw2_dV_bi_ci*(1.0-(FCz/3.0))))*FCd_f));
              d_FCf_CT_dV_bi_ei = (((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_bi_ei)+(((FCw2*(-(d_FCz_dV_bi_ei/3.0)))+(d_FCw2_dV_bi_ei*(1.0-(FCz/3.0))))*FCd_f));
              FCf_CT = ((FCw2*(1.0-(FCz/3.0)))*FCd_f);

              d_FCdfCT_dw_dV_tnode_GND = (((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_tnode_GND)+(((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_tnode_GND)+((((2.0*FCw)*(-(((FCz*d_FCz_dV_tnode_GND)+(d_FCz_dV_tnode_GND*FCz))/3.0)))+((2.0*d_FCw_dV_tnode_GND)*(1.0-((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
              d_FCdfCT_dw_dV_bi_ci = (((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ci)+(((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ci)+((((2.0*FCw)*(-(((FCz*d_FCz_dV_bi_ci)+(d_FCz_dV_bi_ci*FCz))/3.0)))+((2.0*d_FCw_dV_bi_ci)*(1.0-((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
              d_FCdfCT_dw_dV_bi_ei = (((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ei)+(((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ei)+((((2.0*FCw)*(-(((FCz*d_FCz_dV_bi_ei)+(d_FCz_dV_bi_ei*FCz))/3.0)))+((2.0*d_FCw_dV_bi_ei)*(1.0-((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
              FCdfCT_dw = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
            }

            d_FCdfCT_ditf_dV_tnode_GND = ((FCdfCT_dw*d_FCdw_ditf_dV_tnode_GND)+(d_FCdfCT_dw_dV_tnode_GND*FCdw_ditf));
            d_FCdfCT_ditf_dV_bi_ci = ((FCdfCT_dw*d_FCdw_ditf_dV_bi_ci)+(d_FCdfCT_dw_dV_bi_ci*FCdw_ditf));
            d_FCdfCT_ditf_dV_bi_ei = ((FCdfCT_dw*d_FCdw_ditf_dV_bi_ei)+(d_FCdfCT_dw_dV_bi_ei*FCdw_ditf));
            FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
          }
          else
          {

            d_FCf_CT_dV_tnode_GND = d_FCf_ci_dV_tnode_GND;
            d_FCf_CT_dV_bi_ci = d_FCf_ci_dV_bi_ci;
            d_FCf_CT_dV_bi_ei = d_FCf_ci_dV_bi_ei;
            FCf_CT = FCf_ci;

            d_FCdfCT_ditf_dV_tnode_GND = d_FCdfc_ditf_dV_tnode_GND;
            d_FCdfCT_ditf_dV_bi_ci = d_FCdfc_ditf_dV_bi_ci;
            d_FCdfCT_ditf_dV_bi_ei = d_FCdfc_ditf_dV_bi_ei;
            FCdfCT_ditf = FCdfc_ditf;
          }
        }
        {
          double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
          double  deriv_exp_0_d0 = value_exp_0;

          d_FFdQcfcT_dV_bi_ci = (((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+(((FFdQcfc*d_FCf_CT_dV_bi_ci)+(d_FFdQcfc_dV_bi_ci*FCf_CT))*value_exp_0));
          d_FFdQcfcT_dV_bi_ei = (((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+(((FFdQcfc*d_FCf_CT_dV_bi_ei)+(d_FFdQcfc_dV_bi_ei*FCf_CT))*value_exp_0));
          d_FFdQcfcT_dV_tnode_GND = (((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((FFdQcfc*d_FCf_CT_dV_tnode_GND)+(d_FFdQcfc_dV_tnode_GND*FCf_CT))*value_exp_0));
          FFdQcfcT = ((FFdQcfc*FCf_CT)*value_exp_0);
        }
        {
          double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
          double  deriv_exp_0_d0 = value_exp_0;

          d_FFdQcfc_dV_bi_ci = (((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+(((FFdQcfc*d_FCf_ci_dV_bi_ci)+(d_FFdQcfc_dV_bi_ci*FCf_ci))*value_exp_0));
          d_FFdQcfc_dV_bi_ei = (((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+(((FFdQcfc*d_FCf_ci_dV_bi_ei)+(d_FFdQcfc_dV_bi_ei*FCf_ci))*value_exp_0));
          d_FFdQcfc_dV_tnode_GND = (((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((FFdQcfc*d_FCf_ci_dV_tnode_GND)+(d_FFdQcfc_dV_tnode_GND*FCf_ci))*value_exp_0));
          FFdQcfc = ((FFdQcfc*FCf_ci)*value_exp_0);
        }
        {
          double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
          double  deriv_exp_0_d0 = value_exp_0;

          d_FFdTcfc_dV_bi_ci = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_bi_ci+((itf*d_FCdfc_ditf_dV_bi_ci)+(d_itf_dV_bi_ci*FCdfc_ditf))))+((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))*(FCf_ci+(itf*FCdfc_ditf))))+(((FFdQcfc/VT)*d_FFdVc_ditf_dV_bi_ci)+((d_FFdQcfc_dV_bi_ci/VT)*FFdVc_ditf)));
          d_FFdTcfc_dV_bi_ei = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_bi_ei+((itf*d_FCdfc_ditf_dV_bi_ei)+(d_itf_dV_bi_ei*FCdfc_ditf))))+((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))*(FCf_ci+(itf*FCdfc_ditf))))+(((FFdQcfc/VT)*d_FFdVc_ditf_dV_bi_ei)+((d_FFdQcfc_dV_bi_ei/VT)*FFdVc_ditf)));
          d_FFdTcfc_dV_tnode_GND = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_tnode_GND+((itf*d_FCdfc_ditf_dV_tnode_GND)+(d_itf_dV_tnode_GND*FCdfc_ditf))))+(((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((model_.fthc)*d_thcs_t_dV_tnode_GND)*value_exp_0))*(FCf_ci+(itf*FCdfc_ditf))))+(((FFdQcfc/VT)*d_FFdVc_ditf_dV_tnode_GND)+(((VT*d_FFdQcfc_dV_tnode_GND-FFdQcfc*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf)));
          FFdTcfc = (((((model_.fthc)*thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*FFdVc_ditf));
        }
        {
          double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
          double  deriv_exp_0_d0 = value_exp_0;

          d_FFdTcfcT_dV_bi_ci = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_bi_ci+((itf*d_FCdfCT_ditf_dV_bi_ci)+(d_itf_dV_bi_ci*FCdfCT_ditf))))+((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))*(FCf_CT+(itf*FCdfCT_ditf))))+(((FFdQcfcT/VT)*d_FFdVc_ditf_dV_bi_ci)+((d_FFdQcfcT_dV_bi_ci/VT)*FFdVc_ditf)));
          d_FFdTcfcT_dV_bi_ei = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_bi_ei+((itf*d_FCdfCT_ditf_dV_bi_ei)+(d_itf_dV_bi_ei*FCdfCT_ditf))))+((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))*(FCf_CT+(itf*FCdfCT_ditf))))+(((FFdQcfcT/VT)*d_FFdVc_ditf_dV_bi_ei)+((d_FFdQcfcT_dV_bi_ei/VT)*FFdVc_ditf)));
          d_FFdTcfcT_dV_tnode_GND = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_tnode_GND+((itf*d_FCdfCT_ditf_dV_tnode_GND)+(d_itf_dV_tnode_GND*FCdfCT_ditf))))+(((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((model_.fthc)*d_thcs_t_dV_tnode_GND)*value_exp_0))*(FCf_CT+(itf*FCdfCT_ditf))))+(((FFdQcfcT/VT)*d_FFdVc_ditf_dV_tnode_GND)+(((VT*d_FFdQcfcT_dV_tnode_GND-FFdQcfcT*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf)));
          FFdTcfcT = (((((model_.fthc)*thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*FFdVc_ditf));
        }
      }

      d_FFdQbfc_dV_bi_ci = ((1-(model_.fthc))*d_FFdQfhc_dV_bi_ci);
      d_FFdQbfc_dV_bi_ei = ((1-(model_.fthc))*d_FFdQfhc_dV_bi_ei);
      d_FFdQbfc_dV_tnode_GND = ((1-(model_.fthc))*d_FFdQfhc_dV_tnode_GND);
      FFdQbfc = ((1-(model_.fthc))*FFdQfhc);

      d_FFdTbfc_dV_bi_ci = ((1-(model_.fthc))*d_FFdTfhc_dV_bi_ci);
      d_FFdTbfc_dV_bi_ei = ((1-(model_.fthc))*d_FFdTfhc_dV_bi_ei);
      d_FFdTbfc_dV_tnode_GND = ((1-(model_.fthc))*d_FFdTfhc_dV_tnode_GND);
      FFdTbfc = ((1-(model_.fthc))*FFdTfhc);

      d_Q_fT_dV_bi_ei = (((((hf0_t*d_Qf_dV_bi_ei)+d_FFdQbfb_dV_bi_ei)+d_FFdQbfc_dV_bi_ei)+(hfe_t*d_FFdQef_dV_bi_ei))+(hfc_t*d_FFdQcfcT_dV_bi_ei));
      d_Q_fT_dV_bi_ci = (((((hf0_t*d_Qf_dV_bi_ci)+d_FFdQbfb_dV_bi_ci)+d_FFdQbfc_dV_bi_ci)+(hfe_t*d_FFdQef_dV_bi_ci))+(hfc_t*d_FFdQcfcT_dV_bi_ci));
      d_Q_fT_dV_tnode_GND = ((((((hf0_t*d_Qf_dV_tnode_GND)+(d_hf0_t_dV_tnode_GND*Qf))+d_FFdQbfb_dV_tnode_GND)+d_FFdQbfc_dV_tnode_GND)+((hfe_t*d_FFdQef_dV_tnode_GND)+(d_hfe_t_dV_tnode_GND*FFdQef)))+((hfc_t*d_FFdQcfcT_dV_tnode_GND)+(d_hfc_t_dV_tnode_GND*FFdQcfcT)));
      Q_fT = (((((hf0_t*Qf)+FFdQbfb)+FFdQbfc)+(hfe_t*FFdQef))+(hfc_t*FFdQcfcT));

      d_T_fT_dV_bi_ei = (((((hf0_t*d_Tf_dV_bi_ei)+d_FFdTbfb_dV_bi_ei)+d_FFdTbfc_dV_bi_ei)+(hfe_t*d_FFdTef_dV_bi_ei))+(hfc_t*d_FFdTcfcT_dV_bi_ei));
      d_T_fT_dV_bi_ci = (((((hf0_t*d_Tf_dV_bi_ci)+d_FFdTbfb_dV_bi_ci)+d_FFdTbfc_dV_bi_ci)+(hfe_t*d_FFdTef_dV_bi_ci))+(hfc_t*d_FFdTcfcT_dV_bi_ci));
      d_T_fT_dV_tnode_GND = ((((((hf0_t*d_Tf_dV_tnode_GND)+(d_hf0_t_dV_tnode_GND*Tf))+d_FFdTbfb_dV_tnode_GND)+d_FFdTbfc_dV_tnode_GND)+((hfe_t*d_FFdTef_dV_tnode_GND)+(d_hfe_t_dV_tnode_GND*FFdTef)))+((hfc_t*d_FFdTcfcT_dV_tnode_GND)+(d_hfc_t_dV_tnode_GND*FFdTcfcT)));
      T_fT = (((((hf0_t*Tf)+FFdTbfb)+FFdTbfc)+(hfe_t*FFdTef))+(hfc_t*FFdTcfcT));

      d_Qf_dV_bi_ei = (((d_Qf_dV_bi_ei+(d_FFdQbfb_dV_bi_ei+d_FFdQbfc_dV_bi_ei))+d_FFdQef_dV_bi_ei)+d_FFdQcfc_dV_bi_ei);
      d_Qf_dV_bi_ci = (((d_Qf_dV_bi_ci+(d_FFdQbfb_dV_bi_ci+d_FFdQbfc_dV_bi_ci))+d_FFdQef_dV_bi_ci)+d_FFdQcfc_dV_bi_ci);
      d_Qf_dV_tnode_GND = (((d_Qf_dV_tnode_GND+(d_FFdQbfb_dV_tnode_GND+d_FFdQbfc_dV_tnode_GND))+d_FFdQef_dV_tnode_GND)+d_FFdQcfc_dV_tnode_GND);
      Qf = (((Qf+(FFdQbfb+FFdQbfc))+FFdQef)+FFdQcfc);

      d_Tf_dV_bi_ei = (((d_Tf_dV_bi_ei+(d_FFdTbfb_dV_bi_ei+d_FFdTbfc_dV_bi_ei))+d_FFdTef_dV_bi_ei)+d_FFdTcfc_dV_bi_ei);
      d_Tf_dV_bi_ci = (((d_Tf_dV_bi_ci+(d_FFdTbfb_dV_bi_ci+d_FFdTbfc_dV_bi_ci))+d_FFdTef_dV_bi_ci)+d_FFdTcfc_dV_bi_ci);
      d_Tf_dV_tnode_GND = (((d_Tf_dV_tnode_GND+(d_FFdTbfb_dV_tnode_GND+d_FFdTbfc_dV_tnode_GND))+d_FFdTef_dV_tnode_GND)+d_FFdTcfc_dV_tnode_GND);
      Tf = (((Tf+(FFdTbfb+FFdTbfc))+FFdTef)+FFdTcfc);

      d_Q_bf_dV_bi_ci = (d_FFdQbfb_dV_bi_ci+d_FFdQbfc_dV_bi_ci);
      d_Q_bf_dV_bi_ei = (d_FFdQbfb_dV_bi_ei+d_FFdQbfc_dV_bi_ei);
      d_Q_bf_dV_tnode_GND = (d_FFdQbfb_dV_tnode_GND+d_FFdQbfc_dV_tnode_GND);
      Q_bf = (FFdQbfb+FFdQbfc);
    }

    d_Qr_dV_bi_ei = (Tr*d_itr_dV_bi_ei);
    d_Qr_dV_bi_ci = (Tr*d_itr_dV_bi_ci);
    d_Qr_dV_tnode_GND = (Tr*d_itr_dV_tnode_GND);
    Qr = (Tr*itr);
    l_it = 0;
    if (((Qf>(1.0e-5*Q_p))||(a_h>1.0e-5)))
    {
      {
        double value_sqrt_0 = sqrt(((T_f0*itf)*Q_fT));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_Qf_dV_bi_ei = (deriv_sqrt_0_d0*((((T_f0*itf)*d_Q_fT_dV_bi_ei)+((T_f0*d_itf_dV_bi_ei)*Q_fT))));
        d_Qf_dV_bi_ci = (deriv_sqrt_0_d0*((((T_f0*itf)*d_Q_fT_dV_bi_ci)+(((T_f0*d_itf_dV_bi_ci)+(d_T_f0_dV_bi_ci*itf))*Q_fT))));
        d_Qf_dV_tnode_GND = (deriv_sqrt_0_d0*((((T_f0*itf)*d_Q_fT_dV_tnode_GND)+(((T_f0*d_itf_dV_tnode_GND)+(d_T_f0_dV_tnode_GND*itf))*Q_fT))));
        Qf = value_sqrt_0;
      }

      d_Q_pT_dV_bi_ci = ((d_Q_0_dV_bi_ci+d_Qf_dV_bi_ci)+d_Qr_dV_bi_ci);
      d_Q_pT_dV_bi_ei = ((d_Q_0_dV_bi_ei+d_Qf_dV_bi_ei)+d_Qr_dV_bi_ei);
      d_Q_pT_dV_tnode_GND = ((d_Q_0_dV_tnode_GND+d_Qf_dV_tnode_GND)+d_Qr_dV_tnode_GND);
      Q_pT = ((Q_0+Qf)+Qr);

      d_d_Q_dV_bi_ci = d_Q_pT_dV_bi_ci;
      d_d_Q_dV_bi_ei = d_Q_pT_dV_bi_ei;
      d_d_Q_dV_tnode_GND = d_Q_pT_dV_tnode_GND;
      d_Q = Q_pT;
      while (((fabs(d_Q)>=(1.0e-5*fabs(Q_pT)))&&(l_it<=100)))
      {

        d_d_Q0_dV_bi_ci = d_d_Q_dV_bi_ci;
        d_d_Q0_dV_bi_ei = d_d_Q_dV_bi_ei;
        d_d_Q0_dV_tnode_GND = d_d_Q_dV_tnode_GND;
        d_Q0 = d_Q;

        d_I_Tf1_dV_bi_ci = (-i_0f*d_Q_pT_dV_bi_ci/Q_pT/Q_pT);
        d_I_Tf1_dV_bi_ei = ((Q_pT*d_i_0f_dV_bi_ei-i_0f*d_Q_pT_dV_bi_ei)/Q_pT/Q_pT);
        d_I_Tf1_dV_tnode_GND = ((Q_pT*d_i_0f_dV_tnode_GND-i_0f*d_Q_pT_dV_tnode_GND)/Q_pT/Q_pT);
        I_Tf1 = (i_0f/Q_pT);

        d_a_h_dV_bi_ci = (Oich*d_I_Tf1_dV_bi_ci);
        d_a_h_dV_bi_ei = (Oich*d_I_Tf1_dV_bi_ei);
        d_a_h_dV_tnode_GND = (Oich*d_I_Tf1_dV_tnode_GND);
        a_h = (Oich*I_Tf1);

        d_itf_dV_bi_ci = ((I_Tf1*d_a_h_dV_bi_ci)+(d_I_Tf1_dV_bi_ci*(1.0+a_h)));
        d_itf_dV_bi_ei = ((I_Tf1*d_a_h_dV_bi_ei)+(d_I_Tf1_dV_bi_ei*(1.0+a_h)));
        d_itf_dV_tnode_GND = ((I_Tf1*d_a_h_dV_tnode_GND)+(d_I_Tf1_dV_tnode_GND*(1.0+a_h)));
        itf = (I_Tf1*(1.0+a_h));

        d_itr_dV_bi_ei = (-i_0r*d_Q_pT_dV_bi_ei/Q_pT/Q_pT);
        d_itr_dV_bi_ci = ((Q_pT*d_i_0r_dV_bi_ci-i_0r*d_Q_pT_dV_bi_ci)/Q_pT/Q_pT);
        d_itr_dV_tnode_GND = ((Q_pT*d_i_0r_dV_tnode_GND-i_0r*d_Q_pT_dV_tnode_GND)/Q_pT/Q_pT);
        itr = (i_0r/Q_pT);

        d_Tf_dV_bi_ei =  0.0;
        d_Tf_dV_bi_ci = d_T_f0_dV_bi_ci;
        d_Tf_dV_tnode_GND = d_T_f0_dV_tnode_GND;
        Tf = T_f0;

        d_Qf_dV_bi_ei = (T_f0*d_itf_dV_bi_ei);
        d_Qf_dV_bi_ci = ((T_f0*d_itf_dV_bi_ci)+(d_T_f0_dV_bi_ci*itf));
        d_Qf_dV_tnode_GND = ((T_f0*d_itf_dV_tnode_GND)+(d_T_f0_dV_tnode_GND*itf));
        Qf = (T_f0*itf);
        if ((itf<(1.0e-6*ick)))
        {

          d_Q_fT_dV_bi_ei = d_Qf_dV_bi_ei;
          d_Q_fT_dV_bi_ci = d_Qf_dV_bi_ci;
          d_Q_fT_dV_tnode_GND = d_Qf_dV_tnode_GND;
          Q_fT = Qf;

          d_T_fT_dV_bi_ci = d_Tf_dV_bi_ci;
          d_T_fT_dV_tnode_GND = d_Tf_dV_tnode_GND;
          d_T_fT_dV_bi_ei = d_Tf_dV_bi_ei;
          T_fT = Tf;

          d_Q_bf_dV_tnode_GND = d_Q_bf_dV_bi_ei = d_Q_bf_dV_bi_ci =  0.0;
          Q_bf = 0;
        }
        else
        {

          d_FFitf_ick_dV_bi_ci = ((ick*d_itf_dV_bi_ci-itf*d_ick_dV_bi_ci)/ick/ick);
          d_FFitf_ick_dV_bi_ei = ((ick*d_itf_dV_bi_ei-itf*d_ick_dV_bi_ei)/ick/ick);
          d_FFitf_ick_dV_tnode_GND = ((ick*d_itf_dV_tnode_GND-itf*d_ick_dV_tnode_GND)/ick/ick);
          FFitf_ick = (itf/ick);
          {
            double value_log_0 = log(FFitf_ick);
            double value_exp_1 = exp(((model_.gtfe)*value_log_0));
            double  deriv_log_0_d0 = (1.0/FFitf_ick);
            double  deriv_exp_1_d0 = value_exp_1;

            d_FFdTef_dV_bi_ci = (tef0_t*(deriv_exp_1_d0*(((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_bi_ci))))));
            d_FFdTef_dV_bi_ei = (tef0_t*(deriv_exp_1_d0*(((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_bi_ei))))));
            d_FFdTef_dV_tnode_GND = ((tef0_t*(deriv_exp_1_d0*(((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_tnode_GND))))))+(d_tef0_t_dV_tnode_GND*value_exp_1));
            FFdTef = (tef0_t*value_exp_1);
          }

          d_FFdQef_dV_bi_ci = (((FFdTef*d_itf_dV_bi_ci)+(d_FFdTef_dV_bi_ci*itf))/(1+(model_.gtfe)));
          d_FFdQef_dV_bi_ei = (((FFdTef*d_itf_dV_bi_ei)+(d_FFdTef_dV_bi_ei*itf))/(1+(model_.gtfe)));
          d_FFdQef_dV_tnode_GND = (((FFdTef*d_itf_dV_tnode_GND)+(d_FFdTef_dV_tnode_GND*itf))/(1+(model_.gtfe)));
          FFdQef = ((FFdTef*itf)/(1+(model_.gtfe)));
          if (((model_.icbar)<(0.05*((model_.vlim)/(model_.rci0)))))
          {

            d_FFdVc_dV_tnode_GND = d_FFdVc_dV_bi_ei = d_FFdVc_dV_bi_ci =  0.0;
            FFdVc = 0;

            d_FFdVc_ditf_dV_tnode_GND = d_FFdVc_ditf_dV_bi_ei = d_FFdVc_ditf_dV_bi_ci =  0.0;
            FFdVc_ditf = 0;
          }
          else
          {

            d_FFib_dV_bi_ci = ((d_itf_dV_bi_ci-d_ick_dV_bi_ci)/(model_.icbar));
            d_FFib_dV_bi_ei = ((d_itf_dV_bi_ei-d_ick_dV_bi_ei)/(model_.icbar));
            d_FFib_dV_tnode_GND = ((d_itf_dV_tnode_GND-d_ick_dV_tnode_GND)/(model_.icbar));
            FFib = ((itf-ick)/(model_.icbar));
            if ((FFib<(-1.0e10)))
            {

              d_FFib_dV_tnode_GND = d_FFib_dV_bi_ei = d_FFib_dV_bi_ci =  0.0;
              FFib = (-1.0e10);
            }
            {
              double value_sqrt_0 = sqrt(((FFib*FFib)+(model_.acbar)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_FFfcbar_dV_bi_ci = ((d_FFib_dV_bi_ci+(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_bi_ci)+(d_FFib_dV_bi_ci*FFib)))))/2.0);
              d_FFfcbar_dV_bi_ei = ((d_FFib_dV_bi_ei+(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_bi_ei)+(d_FFib_dV_bi_ei*FFib)))))/2.0);
              d_FFfcbar_dV_tnode_GND = ((d_FFib_dV_tnode_GND+(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_tnode_GND)+(d_FFib_dV_tnode_GND*FFib)))))/2.0);
              FFfcbar = ((FFib+value_sqrt_0)/2.0);
            }
            {
              double value_sqrt_0 = sqrt(((FFib*FFib)+(model_.acbar)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_FFdib_ditf_dV_bi_ci = (((value_sqrt_0*d_FFfcbar_dV_bi_ci-FFfcbar*(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_bi_ci)+(d_FFib_dV_bi_ci*FFib)))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
              d_FFdib_ditf_dV_bi_ei = (((value_sqrt_0*d_FFfcbar_dV_bi_ei-FFfcbar*(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_bi_ei)+(d_FFib_dV_bi_ei*FFib)))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
              d_FFdib_ditf_dV_tnode_GND = (((value_sqrt_0*d_FFfcbar_dV_tnode_GND-FFfcbar*(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_tnode_GND)+(d_FFib_dV_tnode_GND*FFib)))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
              FFdib_ditf = ((FFfcbar/value_sqrt_0)/(model_.icbar));
            }
            {
              double value_exp_0 = exp(((-1.0)/FFfcbar));
              double  deriv_exp_0_d0 = value_exp_0;

              d_FFdVc_dV_bi_ci = ((model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_bi_ci/FFfcbar/FFfcbar))));
              d_FFdVc_dV_bi_ei = ((model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_bi_ei/FFfcbar/FFfcbar))));
              d_FFdVc_dV_tnode_GND = ((model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_tnode_GND/FFfcbar/FFfcbar))));
              FFdVc = ((model_.vcbar)*value_exp_0);
            }

            d_FFdVc_ditf_dV_bi_ci = (((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_bi_ci)+((((FFfcbar*FFfcbar)*d_FFdVc_dV_bi_ci-FFdVc*((FFfcbar*d_FFfcbar_dV_bi_ci)+(d_FFfcbar_dV_bi_ci*FFfcbar)))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf));
            d_FFdVc_ditf_dV_bi_ei = (((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_bi_ei)+((((FFfcbar*FFfcbar)*d_FFdVc_dV_bi_ei-FFdVc*((FFfcbar*d_FFfcbar_dV_bi_ei)+(d_FFfcbar_dV_bi_ei*FFfcbar)))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf));
            d_FFdVc_ditf_dV_tnode_GND = (((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_tnode_GND)+((((FFfcbar*FFfcbar)*d_FFdVc_dV_tnode_GND-FFdVc*((FFfcbar*d_FFfcbar_dV_tnode_GND)+(d_FFfcbar_dV_tnode_GND*FFfcbar)))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf));
            FFdVc_ditf = ((FFdVc/(FFfcbar*FFfcbar))*FFdib_ditf);
          }
          {
            double value_exp_0 = exp((FFdVc/VT));
            double  deriv_exp_0_d0 = value_exp_0;

            d_FFdQbfb_dV_bi_ci = (((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+((((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ci)*(value_exp_0-1)));
            d_FFdQbfb_dV_bi_ei = (((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+((((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ei)*(value_exp_0-1)));
            d_FFdQbfb_dV_tnode_GND = (((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-FFdVc*d_VT_dV_tnode_GND)/VT/VT))))+(((((1-(model_.fthc))*thcs_t)*d_itf_dV_tnode_GND)+(((1-(model_.fthc))*d_thcs_t_dV_tnode_GND)*itf))*(value_exp_0-1)));
            FFdQbfb = ((((1-(model_.fthc))*thcs_t)*itf)*(value_exp_0-1));
          }
          {
            double value_exp_0 = exp((FFdVc/VT));
            double  deriv_exp_0_d0 = value_exp_0;

            d_FFdTbfb_dV_bi_ci = (((itf*d_FFdQbfb_dV_bi_ci-FFdQbfb*d_itf_dV_bi_ci)/itf/itf)+(((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_bi_ci)+(((((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+((((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ci)*value_exp_0))/VT)*FFdVc_ditf)));
            d_FFdTbfb_dV_bi_ei = (((itf*d_FFdQbfb_dV_bi_ei-FFdQbfb*d_itf_dV_bi_ei)/itf/itf)+(((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_bi_ei)+(((((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+((((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ei)*value_exp_0))/VT)*FFdVc_ditf)));
            d_FFdTbfb_dV_tnode_GND = (((itf*d_FFdQbfb_dV_tnode_GND-FFdQbfb*d_itf_dV_tnode_GND)/itf/itf)+(((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_tnode_GND)+(((VT*(((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-FFdVc*d_VT_dV_tnode_GND)/VT/VT))))+(((((1-(model_.fthc))*thcs_t)*d_itf_dV_tnode_GND)+(((1-(model_.fthc))*d_thcs_t_dV_tnode_GND)*itf))*value_exp_0))-((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf)));
            FFdTbfb = ((FFdQbfb/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*FFdVc_ditf));
          }

          d_FFic_dV_bi_ci = (-(-d_FFitf_ick_dV_bi_ci/FFitf_ick/FFitf_ick));
          d_FFic_dV_bi_ei = (-(-d_FFitf_ick_dV_bi_ei/FFitf_ick/FFitf_ick));
          d_FFic_dV_tnode_GND = (-(-d_FFitf_ick_dV_tnode_GND/FFitf_ick/FFitf_ick));
          FFic = (1-(1.0/FFitf_ick));
          {
            double value_sqrt_0 = sqrt(((FFic*FFic)+(model_.ahc)));
            double value_sqrt_1 = sqrt((1+(model_.ahc)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_FFw_dV_bi_ci = ((d_FFic_dV_bi_ci+(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_bi_ci)+(d_FFic_dV_bi_ci*FFic)))))/(1+value_sqrt_1));
            d_FFw_dV_bi_ei = ((d_FFic_dV_bi_ei+(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_bi_ei)+(d_FFic_dV_bi_ei*FFic)))))/(1+value_sqrt_1));
            d_FFw_dV_tnode_GND = ((d_FFic_dV_tnode_GND+(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_tnode_GND)+(d_FFic_dV_tnode_GND*FFic)))))/(1+value_sqrt_1));
            FFw = ((FFic+value_sqrt_0)/(1+value_sqrt_1));
          }
          {
            double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
            double  deriv_exp_0_d0 = value_exp_0;

            d_FFdQfhc_dV_bi_ci = (((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+(((((thcs_t*itf)*FFw)*d_FFw_dV_bi_ci)+((((thcs_t*itf)*d_FFw_dV_bi_ci)+((thcs_t*d_itf_dV_bi_ci)*FFw))*FFw))*value_exp_0));
            d_FFdQfhc_dV_bi_ei = (((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+(((((thcs_t*itf)*FFw)*d_FFw_dV_bi_ei)+((((thcs_t*itf)*d_FFw_dV_bi_ei)+((thcs_t*d_itf_dV_bi_ei)*FFw))*FFw))*value_exp_0));
            d_FFdQfhc_dV_tnode_GND = (((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((((thcs_t*itf)*FFw)*d_FFw_dV_tnode_GND)+((((thcs_t*itf)*d_FFw_dV_tnode_GND)+(((thcs_t*d_itf_dV_tnode_GND)+(d_thcs_t_dV_tnode_GND*itf))*FFw))*FFw))*value_exp_0));
            FFdQfhc = ((((thcs_t*itf)*FFw)*FFw)*value_exp_0);
          }
          {
            double value_sqrt_0 = sqrt(((FFic*FFic)+(model_.ahc)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_FFdTfhc_dV_bi_ci = ((FFdQfhc*((((1.0/itf)*(-2.0*((FFitf_ick*(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_bi_ci)+(d_FFic_dV_bi_ci*FFic)))))+(d_FFitf_ick_dV_bi_ci*value_sqrt_0))/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0)))+((-d_itf_dV_bi_ci/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0)))))+((1.0/VT)*d_FFdVc_ditf_dV_bi_ci)))+(d_FFdQfhc_dV_bi_ci*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf))));
            d_FFdTfhc_dV_bi_ei = ((FFdQfhc*((((1.0/itf)*(-2.0*((FFitf_ick*(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_bi_ei)+(d_FFic_dV_bi_ei*FFic)))))+(d_FFitf_ick_dV_bi_ei*value_sqrt_0))/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0)))+((-d_itf_dV_bi_ei/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0)))))+((1.0/VT)*d_FFdVc_ditf_dV_bi_ei)))+(d_FFdQfhc_dV_bi_ei*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf))));
            d_FFdTfhc_dV_tnode_GND = ((FFdQfhc*((((1.0/itf)*(-2.0*((FFitf_ick*(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_tnode_GND)+(d_FFic_dV_tnode_GND*FFic)))))+(d_FFitf_ick_dV_tnode_GND*value_sqrt_0))/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0)))+((-d_itf_dV_tnode_GND/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0)))))+(((1.0/VT)*d_FFdVc_ditf_dV_tnode_GND)+((-d_VT_dV_tnode_GND/VT/VT)*FFdVc_ditf))))+(d_FFdQfhc_dV_tnode_GND*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf))));
            FFdTfhc = (FFdQfhc*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
          }
          if ((((model_.latb)<=0.0)&&((model_.latl)<=0.0)))
          {

            d_FFdQcfc_dV_bi_ci = ((model_.fthc)*d_FFdQfhc_dV_bi_ci);
            d_FFdQcfc_dV_bi_ei = ((model_.fthc)*d_FFdQfhc_dV_bi_ei);
            d_FFdQcfc_dV_tnode_GND = ((model_.fthc)*d_FFdQfhc_dV_tnode_GND);
            FFdQcfc = ((model_.fthc)*FFdQfhc);

            d_FFdTcfc_dV_bi_ci = ((model_.fthc)*d_FFdTfhc_dV_bi_ci);
            d_FFdTcfc_dV_bi_ei = ((model_.fthc)*d_FFdTfhc_dV_bi_ei);
            d_FFdTcfc_dV_tnode_GND = ((model_.fthc)*d_FFdTfhc_dV_tnode_GND);
            FFdTcfc = ((model_.fthc)*FFdTfhc);

            d_FFdQcfcT_dV_bi_ci = d_FFdQcfc_dV_bi_ci;
            d_FFdQcfcT_dV_bi_ei = d_FFdQcfc_dV_bi_ei;
            d_FFdQcfcT_dV_tnode_GND = d_FFdQcfc_dV_tnode_GND;
            FFdQcfcT = FFdQcfc;

            d_FFdTcfcT_dV_bi_ci = d_FFdTcfc_dV_bi_ci;
            d_FFdTcfcT_dV_bi_ei = d_FFdTcfc_dV_bi_ei;
            d_FFdTcfcT_dV_tnode_GND = d_FFdTcfc_dV_tnode_GND;
            FFdTcfcT = FFdTcfc;
          }
          else
          {

            d_FFdQcfc_dV_bi_ci = (((model_.fthc)*thcs_t)*d_itf_dV_bi_ci);
            d_FFdQcfc_dV_bi_ei = (((model_.fthc)*thcs_t)*d_itf_dV_bi_ei);
            d_FFdQcfc_dV_tnode_GND = ((((model_.fthc)*thcs_t)*d_itf_dV_tnode_GND)+(((model_.fthc)*d_thcs_t_dV_tnode_GND)*itf));
            FFdQcfc = (((model_.fthc)*thcs_t)*itf);

            d_FCa_dV_tnode_GND = (-((itf*d_ick_dV_tnode_GND-ick*d_itf_dV_tnode_GND)/itf/itf));
            d_FCa_dV_bi_ci = (-((itf*d_ick_dV_bi_ci-ick*d_itf_dV_bi_ci)/itf/itf));
            d_FCa_dV_bi_ei = (-((itf*d_ick_dV_bi_ei-ick*d_itf_dV_bi_ei)/itf/itf));
            FCa = (1.0-(ick/itf));
            {
              double value_sqrt_0 = sqrt(((FCa*FCa)+(model_.ahc)));
              double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

              d_FCrt_dV_tnode_GND = (deriv_sqrt_0_d0*(((FCa*d_FCa_dV_tnode_GND)+(d_FCa_dV_tnode_GND*FCa))));
              d_FCrt_dV_bi_ci = (deriv_sqrt_0_d0*(((FCa*d_FCa_dV_bi_ci)+(d_FCa_dV_bi_ci*FCa))));
              d_FCrt_dV_bi_ei = (deriv_sqrt_0_d0*(((FCa*d_FCa_dV_bi_ei)+(d_FCa_dV_bi_ei*FCa))));
              FCrt = value_sqrt_0;
            }
            {
              double value_sqrt_0 = sqrt((1.0+(model_.ahc)));

              d_FCa_ck_dV_tnode_GND = (-((d_FCa_dV_tnode_GND+d_FCrt_dV_tnode_GND)/(1.0+value_sqrt_0)));
              d_FCa_ck_dV_bi_ci = (-((d_FCa_dV_bi_ci+d_FCrt_dV_bi_ci)/(1.0+value_sqrt_0)));
              d_FCa_ck_dV_bi_ei = (-((d_FCa_dV_bi_ei+d_FCrt_dV_bi_ei)/(1.0+value_sqrt_0)));
              FCa_ck = (1.0-((FCa+FCrt)/(1.0+value_sqrt_0)));
            }

            d_FCdaick_ditf_dV_tnode_GND = (((FCrt*itf)*(((FCa_ck-1.0)*(-d_FCa_dV_tnode_GND))+(d_FCa_ck_dV_tnode_GND*(1-FCa)))-((FCa_ck-1.0)*(1-FCa))*((FCrt*d_itf_dV_tnode_GND)+(d_FCrt_dV_tnode_GND*itf)))/(FCrt*itf)/(FCrt*itf));
            d_FCdaick_ditf_dV_bi_ci = (((FCrt*itf)*(((FCa_ck-1.0)*(-d_FCa_dV_bi_ci))+(d_FCa_ck_dV_bi_ci*(1-FCa)))-((FCa_ck-1.0)*(1-FCa))*((FCrt*d_itf_dV_bi_ci)+(d_FCrt_dV_bi_ci*itf)))/(FCrt*itf)/(FCrt*itf));
            d_FCdaick_ditf_dV_bi_ei = (((FCrt*itf)*(((FCa_ck-1.0)*(-d_FCa_dV_bi_ei))+(d_FCa_ck_dV_bi_ei*(1-FCa)))-((FCa_ck-1.0)*(1-FCa))*((FCrt*d_itf_dV_bi_ei)+(d_FCrt_dV_bi_ei*itf)))/(FCrt*itf)/(FCrt*itf));
            FCdaick_ditf = (((FCa_ck-1.0)*(1-FCa))/(FCrt*itf));
            if (((model_.latb)>(model_.latl)))
            {

              d_FCz_dV_bi_ei = d_FCz_dV_bi_ci = d_FCz_dV_tnode_GND =  0.0;
              FCz = ((model_.latb)-(model_.latl));
              FCxl = (1.0+(model_.latl));
              FCxb = (1.0+(model_.latb));
              if (((model_.latb)>0.01))
              {
                {
                  double value_log_0 = log((FCxb/FCxl));
                  FCln = value_log_0;
                }
                {
                  double value_exp_0 = exp(((FCa_ck-1.0)*FCln));
                  double  deriv_exp_0_d0 = value_exp_0;

                  d_FCa1_dV_tnode_GND = (deriv_exp_0_d0*((d_FCa_ck_dV_tnode_GND*FCln)));
                  d_FCa1_dV_bi_ci = (deriv_exp_0_d0*((d_FCa_ck_dV_bi_ci*FCln)));
                  d_FCa1_dV_bi_ei = (deriv_exp_0_d0*((d_FCa_ck_dV_bi_ei*FCln)));
                  FCa1 = value_exp_0;
                }

                d_FCd_a_dV_tnode_GND = (-(-(d_FCa1_dV_tnode_GND*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
                d_FCd_a_dV_bi_ci = (-(-(d_FCa1_dV_bi_ci*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
                d_FCd_a_dV_bi_ei = (-(-(d_FCa1_dV_bi_ei*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
                FCd_a = (1.0/((model_.latl)-(FCa1*(model_.latb))));

                d_FCw_dV_tnode_GND = (((FCa1-1.0)*d_FCd_a_dV_tnode_GND)+(d_FCa1_dV_tnode_GND*FCd_a));
                d_FCw_dV_bi_ci = (((FCa1-1.0)*d_FCd_a_dV_bi_ci)+(d_FCa1_dV_bi_ci*FCd_a));
                d_FCw_dV_bi_ei = (((FCa1-1.0)*d_FCd_a_dV_bi_ei)+(d_FCa1_dV_bi_ei*FCd_a));
                FCw = ((FCa1-1.0)*FCd_a);

                d_FCdw_daick_dV_tnode_GND = ((((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_tnode_GND)+((((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_tnode_GND)+(((((-FCz)*d_FCa1_dV_tnode_GND)+((-d_FCz_dV_tnode_GND)*FCa1))*FCln)*FCd_a))*FCd_a));
                d_FCdw_daick_dV_bi_ci = ((((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_bi_ci)+((((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_bi_ci)+(((((-FCz)*d_FCa1_dV_bi_ci)+((-d_FCz_dV_bi_ci)*FCa1))*FCln)*FCd_a))*FCd_a));
                d_FCdw_daick_dV_bi_ei = ((((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_bi_ei)+((((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_bi_ei)+(((((-FCz)*d_FCa1_dV_bi_ei)+((-d_FCz_dV_bi_ei)*FCa1))*FCln)*FCd_a))*FCd_a));
                FCdw_daick = (((((-FCz)*FCa1)*FCln)*FCd_a)*FCd_a);
                {
                  double value_log_0 = log(((1.0+((model_.latb)*FCw))/(1.0+((model_.latl)*FCw))));
                  double  deriv_log_0_d0 = (1.0/((1.0+((model_.latb)*FCw))/(1.0+((model_.latl)*FCw))));

                  d_FCa1_dV_tnode_GND = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*((model_.latb)*d_FCw_dV_tnode_GND)-(1.0+((model_.latb)*FCw))*((model_.latl)*d_FCw_dV_tnode_GND))/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
                  d_FCa1_dV_bi_ci = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*((model_.latb)*d_FCw_dV_bi_ci)-(1.0+((model_.latb)*FCw))*((model_.latl)*d_FCw_dV_bi_ci))/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
                  d_FCa1_dV_bi_ei = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*((model_.latb)*d_FCw_dV_bi_ei)-(1.0+((model_.latb)*FCw))*((model_.latl)*d_FCw_dV_bi_ei))/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
                  FCa1 = value_log_0;
                }

                d_FCda1_dw_dV_tnode_GND = ((-(model_.latb)*((model_.latb)*d_FCw_dV_tnode_GND)/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*((model_.latl)*d_FCw_dV_tnode_GND)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
                d_FCda1_dw_dV_bi_ci = ((-(model_.latb)*((model_.latb)*d_FCw_dV_bi_ci)/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*((model_.latl)*d_FCw_dV_bi_ci)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
                d_FCda1_dw_dV_bi_ei = ((-(model_.latb)*((model_.latb)*d_FCw_dV_bi_ei)/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*((model_.latl)*d_FCw_dV_bi_ei)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
                FCda1_dw = (((model_.latb)/(1.0+((model_.latb)*FCw)))-((model_.latl)/(1.0+((model_.latl)*FCw))));
              }
              else
              {

                d_FCf1_dV_tnode_GND = (-d_FCa_ck_dV_tnode_GND);
                d_FCf1_dV_bi_ci = (-d_FCa_ck_dV_bi_ci);
                d_FCf1_dV_bi_ei = (-d_FCa_ck_dV_bi_ei);
                FCf1 = (1.0-FCa_ck);

                d_FCd_a_dV_tnode_GND = (-(d_FCa_ck_dV_tnode_GND*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
                d_FCd_a_dV_bi_ci = (-(d_FCa_ck_dV_bi_ci*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
                d_FCd_a_dV_bi_ei = (-(d_FCa_ck_dV_bi_ei*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
                FCd_a = (1.0/(1.0+(FCa_ck*(model_.latb))));

                d_FCw_dV_tnode_GND = ((FCf1*d_FCd_a_dV_tnode_GND)+(d_FCf1_dV_tnode_GND*FCd_a));
                d_FCw_dV_bi_ci = ((FCf1*d_FCd_a_dV_bi_ci)+(d_FCf1_dV_bi_ci*FCd_a));
                d_FCw_dV_bi_ei = ((FCf1*d_FCd_a_dV_bi_ei)+(d_FCf1_dV_bi_ei*FCd_a));
                FCw = (FCf1*FCd_a);

                d_FCdw_daick_dV_tnode_GND = ((((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_tnode_GND)+((((((-1.0)*FCd_a)*d_FCd_a_dV_tnode_GND)+(((-1.0)*d_FCd_a_dV_tnode_GND)*FCd_a))*FCxb)*FCd_a));
                d_FCdw_daick_dV_bi_ci = ((((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_bi_ci)+((((((-1.0)*FCd_a)*d_FCd_a_dV_bi_ci)+(((-1.0)*d_FCd_a_dV_bi_ci)*FCd_a))*FCxb)*FCd_a));
                d_FCdw_daick_dV_bi_ei = ((((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_bi_ei)+((((((-1.0)*FCd_a)*d_FCd_a_dV_bi_ei)+(((-1.0)*d_FCd_a_dV_bi_ei)*FCd_a))*FCxb)*FCd_a));
                FCdw_daick = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*FCd_a);

                d_FCa1_dV_tnode_GND = ((FCz*d_FCw_dV_tnode_GND)+(d_FCz_dV_tnode_GND*FCw));
                d_FCa1_dV_bi_ci = ((FCz*d_FCw_dV_bi_ci)+(d_FCz_dV_bi_ci*FCw));
                d_FCa1_dV_bi_ei = ((FCz*d_FCw_dV_bi_ei)+(d_FCz_dV_bi_ei*FCw));
                FCa1 = (FCz*FCw);

                d_FCda1_dw_dV_tnode_GND = d_FCz_dV_tnode_GND;
                d_FCda1_dw_dV_bi_ci = d_FCz_dV_bi_ci;
                d_FCda1_dw_dV_bi_ei = d_FCz_dV_bi_ei;
                FCda1_dw = FCz;
              }

              d_FCf_CT_dV_tnode_GND = (-2.0*d_FCz_dV_tnode_GND/FCz/FCz);
              d_FCf_CT_dV_bi_ci = (-2.0*d_FCz_dV_bi_ci/FCz/FCz);
              d_FCf_CT_dV_bi_ei = (-2.0*d_FCz_dV_bi_ei/FCz/FCz);
              FCf_CT = (2.0/FCz);

              d_FCw2_dV_tnode_GND = ((FCw*d_FCw_dV_tnode_GND)+(d_FCw_dV_tnode_GND*FCw));
              d_FCw2_dV_bi_ci = ((FCw*d_FCw_dV_bi_ci)+(d_FCw_dV_bi_ci*FCw));
              d_FCw2_dV_bi_ei = ((FCw*d_FCw_dV_bi_ei)+(d_FCw_dV_bi_ei*FCw));
              FCw2 = (FCw*FCw);

              d_FCf1_dV_tnode_GND = ((((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_tnode_GND)+((((model_.latb)*(model_.latl))*d_FCw_dV_tnode_GND)*FCw2))/3.0)+((((model_.latb)+(model_.latl))*d_FCw2_dV_tnode_GND)/2.0))+d_FCw_dV_tnode_GND);
              d_FCf1_dV_bi_ci = ((((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_bi_ci)+((((model_.latb)*(model_.latl))*d_FCw_dV_bi_ci)*FCw2))/3.0)+((((model_.latb)+(model_.latl))*d_FCw2_dV_bi_ci)/2.0))+d_FCw_dV_bi_ci);
              d_FCf1_dV_bi_ei = ((((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_bi_ei)+((((model_.latb)*(model_.latl))*d_FCw_dV_bi_ei)*FCw2))/3.0)+((((model_.latb)+(model_.latl))*d_FCw2_dV_bi_ei)/2.0))+d_FCw_dV_bi_ei);
              FCf1 = (((((((model_.latb)*(model_.latl))*FCw)*FCw2)/3.0)+((((model_.latb)+(model_.latl))*FCw2)/2.0))+FCw);

              d_FCdf1_dw_dV_tnode_GND = ((((model_.latb)*(model_.latl))*d_FCw2_dV_tnode_GND)+(((model_.latb)+(model_.latl))*d_FCw_dV_tnode_GND));
              d_FCdf1_dw_dV_bi_ci = ((((model_.latb)*(model_.latl))*d_FCw2_dV_bi_ci)+(((model_.latb)+(model_.latl))*d_FCw_dV_bi_ci));
              d_FCdf1_dw_dV_bi_ei = ((((model_.latb)*(model_.latl))*d_FCw2_dV_bi_ei)+(((model_.latb)+(model_.latl))*d_FCw_dV_bi_ei));
              FCdf1_dw = (((((model_.latb)*(model_.latl))*FCw2)+(((model_.latb)+(model_.latl))*FCw))+1.0);

              d_z_dV_tnode_GND = ((model_.latb)*d_FCw_dV_tnode_GND);
              d_z_dV_bi_ci = ((model_.latb)*d_FCw_dV_bi_ci);
              d_z_dV_bi_ei = ((model_.latb)*d_FCw_dV_bi_ei);
              z = ((model_.latb)*FCw);
              {
                double value_log_0 = log((1+((model_.latb)*FCw)));
                double  deriv_log_0_d0 = (1.0/(1+((model_.latb)*FCw)));

                d_lnzb_dV_tnode_GND = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_tnode_GND)));
                d_lnzb_dV_bi_ci = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_bi_ci)));
                d_lnzb_dV_bi_ei = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_bi_ei)));
                lnzb = value_log_0;
              }
              if ((z>1.0e-6))
              {

                d_x_dV_tnode_GND = d_z_dV_tnode_GND;
                d_x_dV_bi_ci = d_z_dV_bi_ci;
                d_x_dV_bi_ei = d_z_dV_bi_ei;
                x = (1.0+z);

                d_a_dV_tnode_GND = ((x*d_x_dV_tnode_GND)+(d_x_dV_tnode_GND*x));
                d_a_dV_bi_ci = ((x*d_x_dV_bi_ci)+(d_x_dV_bi_ci*x));
                d_a_dV_bi_ei = ((x*d_x_dV_bi_ei)+(d_x_dV_bi_ei*x));
                a = (x*x);

                d_a2_dV_tnode_GND = (0.250*((a*(2.0*d_lnzb_dV_tnode_GND))+(d_a_dV_tnode_GND*((2.0*lnzb)-1.0))));
                d_a2_dV_bi_ci = (0.250*((a*(2.0*d_lnzb_dV_bi_ci))+(d_a_dV_bi_ci*((2.0*lnzb)-1.0))));
                d_a2_dV_bi_ei = (0.250*((a*(2.0*d_lnzb_dV_bi_ei))+(d_a_dV_bi_ei*((2.0*lnzb)-1.0))));
                a2 = (0.250*((a*((2.0*lnzb)-1.0))+1.0));

                d_a3_dV_tnode_GND = ((((a*x)*(3.0*d_lnzb_dV_tnode_GND))+(((a*d_x_dV_tnode_GND)+(d_a_dV_tnode_GND*x))*((3.0*lnzb)-1.0)))/9.0);
                d_a3_dV_bi_ci = ((((a*x)*(3.0*d_lnzb_dV_bi_ci))+(((a*d_x_dV_bi_ci)+(d_a_dV_bi_ci*x))*((3.0*lnzb)-1.0)))/9.0);
                d_a3_dV_bi_ei = ((((a*x)*(3.0*d_lnzb_dV_bi_ei))+(((a*d_x_dV_bi_ei)+(d_a_dV_bi_ei*x))*((3.0*lnzb)-1.0)))/9.0);
                a3 = ((((a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
                r = ((model_.latl)/(model_.latb));

                d_FCf2_dV_tnode_GND = ((((1.0-r)*d_a2_dV_tnode_GND)+(r*d_a3_dV_tnode_GND))/(model_.latb));
                d_FCf2_dV_bi_ci = ((((1.0-r)*d_a2_dV_bi_ci)+(r*d_a3_dV_bi_ci))/(model_.latb));
                d_FCf2_dV_bi_ei = ((((1.0-r)*d_a2_dV_bi_ei)+(r*d_a3_dV_bi_ei))/(model_.latb));
                FCf2 = ((((1.0-r)*a2)+(r*a3))/(model_.latb));

                d_FCdf2_dw_dV_tnode_GND = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_tnode_GND)+((((1.0-r)*d_x_dV_tnode_GND)+(r*d_a_dV_tnode_GND))*lnzb));
                d_FCdf2_dw_dV_bi_ci = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ci)+((((1.0-r)*d_x_dV_bi_ci)+(r*d_a_dV_bi_ci))*lnzb));
                d_FCdf2_dw_dV_bi_ei = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ei)+((((1.0-r)*d_x_dV_bi_ei)+(r*d_a_dV_bi_ei))*lnzb));
                FCdf2_dw = ((((1.0-r)*x)+(r*a))*lnzb);
              }
              else
              {

                d_a_dV_tnode_GND = ((z*d_z_dV_tnode_GND)+(d_z_dV_tnode_GND*z));
                d_a_dV_bi_ci = ((z*d_z_dV_bi_ci)+(d_z_dV_bi_ci*z));
                d_a_dV_bi_ei = ((z*d_z_dV_bi_ei)+(d_z_dV_bi_ei*z));
                a = (z*z);

                d_a2_dV_tnode_GND = ((d_z_dV_tnode_GND-(0.25*d_a_dV_tnode_GND))+(((0.10*z)*d_a_dV_tnode_GND)+((0.10*d_z_dV_tnode_GND)*a)));
                d_a2_dV_bi_ci = ((d_z_dV_bi_ci-(0.25*d_a_dV_bi_ci))+(((0.10*z)*d_a_dV_bi_ci)+((0.10*d_z_dV_bi_ci)*a)));
                d_a2_dV_bi_ei = ((d_z_dV_bi_ei-(0.25*d_a_dV_bi_ei))+(((0.10*z)*d_a_dV_bi_ei)+((0.10*d_z_dV_bi_ei)*a)));
                a2 = (((3.0+z)-(0.25*a))+((0.10*z)*a));

                d_a3_dV_tnode_GND = (((2.0*d_z_dV_tnode_GND)+(0.75*d_a_dV_tnode_GND))-(((0.20*a)*d_z_dV_tnode_GND)+((0.20*d_a_dV_tnode_GND)*z)));
                d_a3_dV_bi_ci = (((2.0*d_z_dV_bi_ci)+(0.75*d_a_dV_bi_ci))-(((0.20*a)*d_z_dV_bi_ci)+((0.20*d_a_dV_bi_ci)*z)));
                d_a3_dV_bi_ei = (((2.0*d_z_dV_bi_ei)+(0.75*d_a_dV_bi_ei))-(((0.20*a)*d_z_dV_bi_ei)+((0.20*d_a_dV_bi_ei)*z)));
                a3 = (((2.0*z)+(0.75*a))-((0.20*a)*z));

                d_FCf2_dV_tnode_GND = (((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_tnode_GND)+((((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_tnode_GND)+((((model_.latb)*d_a2_dV_tnode_GND)+((model_.latl)*d_a3_dV_tnode_GND))*FCw))*FCw))/6.0);
                d_FCf2_dV_bi_ci = (((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_bi_ci)+((((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_bi_ci)+((((model_.latb)*d_a2_dV_bi_ci)+((model_.latl)*d_a3_dV_bi_ci))*FCw))*FCw))/6.0);
                d_FCf2_dV_bi_ei = (((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_bi_ei)+((((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_bi_ei)+((((model_.latb)*d_a2_dV_bi_ei)+((model_.latl)*d_a3_dV_bi_ei))*FCw))*FCw))/6.0);
                FCf2 = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*FCw)/6.0);

                d_FCdf2_dw_dV_tnode_GND = ((((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_tnode_GND)+((((1+((model_.latl)*FCw))*d_z_dV_tnode_GND)+(((model_.latl)*d_FCw_dV_tnode_GND)*(1+z)))*lnzb));
                d_FCdf2_dw_dV_bi_ci = ((((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_bi_ci)+((((1+((model_.latl)*FCw))*d_z_dV_bi_ci)+(((model_.latl)*d_FCw_dV_bi_ci)*(1+z)))*lnzb));
                d_FCdf2_dw_dV_bi_ei = ((((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_bi_ei)+((((1+((model_.latl)*FCw))*d_z_dV_bi_ei)+(((model_.latl)*d_FCw_dV_bi_ei)*(1+z)))*lnzb));
                FCdf2_dw = (((1+((model_.latl)*FCw))*(1+z))*lnzb);
              }

              d_z_dV_tnode_GND = ((model_.latl)*d_FCw_dV_tnode_GND);
              d_z_dV_bi_ci = ((model_.latl)*d_FCw_dV_bi_ci);
              d_z_dV_bi_ei = ((model_.latl)*d_FCw_dV_bi_ei);
              z = ((model_.latl)*FCw);
              {
                double value_log_0 = log((1+((model_.latl)*FCw)));
                double  deriv_log_0_d0 = (1.0/(1+((model_.latl)*FCw)));

                d_lnzb_dV_tnode_GND = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_tnode_GND)));
                d_lnzb_dV_bi_ci = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_bi_ci)));
                d_lnzb_dV_bi_ei = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_bi_ei)));
                lnzb = value_log_0;
              }
              if ((z>1.0e-6))
              {

                d_x_dV_tnode_GND = d_z_dV_tnode_GND;
                d_x_dV_bi_ci = d_z_dV_bi_ci;
                d_x_dV_bi_ei = d_z_dV_bi_ei;
                x = (1.0+z);

                d_a_dV_tnode_GND = ((x*d_x_dV_tnode_GND)+(d_x_dV_tnode_GND*x));
                d_a_dV_bi_ci = ((x*d_x_dV_bi_ci)+(d_x_dV_bi_ci*x));
                d_a_dV_bi_ei = ((x*d_x_dV_bi_ei)+(d_x_dV_bi_ei*x));
                a = (x*x);

                d_a2_dV_tnode_GND = (0.250*((a*(2.0*d_lnzb_dV_tnode_GND))+(d_a_dV_tnode_GND*((2.0*lnzb)-1.0))));
                d_a2_dV_bi_ci = (0.250*((a*(2.0*d_lnzb_dV_bi_ci))+(d_a_dV_bi_ci*((2.0*lnzb)-1.0))));
                d_a2_dV_bi_ei = (0.250*((a*(2.0*d_lnzb_dV_bi_ei))+(d_a_dV_bi_ei*((2.0*lnzb)-1.0))));
                a2 = (0.250*((a*((2.0*lnzb)-1.0))+1.0));

                d_a3_dV_tnode_GND = ((((a*x)*(3.0*d_lnzb_dV_tnode_GND))+(((a*d_x_dV_tnode_GND)+(d_a_dV_tnode_GND*x))*((3.0*lnzb)-1.0)))/9.0);
                d_a3_dV_bi_ci = ((((a*x)*(3.0*d_lnzb_dV_bi_ci))+(((a*d_x_dV_bi_ci)+(d_a_dV_bi_ci*x))*((3.0*lnzb)-1.0)))/9.0);
                d_a3_dV_bi_ei = ((((a*x)*(3.0*d_lnzb_dV_bi_ei))+(((a*d_x_dV_bi_ei)+(d_a_dV_bi_ei*x))*((3.0*lnzb)-1.0)))/9.0);
                a3 = ((((a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
                r = ((model_.latb)/(model_.latl));

                d_FCf3_dV_tnode_GND = ((((1.0-r)*d_a2_dV_tnode_GND)+(r*d_a3_dV_tnode_GND))/(model_.latl));
                d_FCf3_dV_bi_ci = ((((1.0-r)*d_a2_dV_bi_ci)+(r*d_a3_dV_bi_ci))/(model_.latl));
                d_FCf3_dV_bi_ei = ((((1.0-r)*d_a2_dV_bi_ei)+(r*d_a3_dV_bi_ei))/(model_.latl));
                FCf3 = ((((1.0-r)*a2)+(r*a3))/(model_.latl));

                d_FCdf3_dw_dV_tnode_GND = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_tnode_GND)+((((1.0-r)*d_x_dV_tnode_GND)+(r*d_a_dV_tnode_GND))*lnzb));
                d_FCdf3_dw_dV_bi_ci = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ci)+((((1.0-r)*d_x_dV_bi_ci)+(r*d_a_dV_bi_ci))*lnzb));
                d_FCdf3_dw_dV_bi_ei = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ei)+((((1.0-r)*d_x_dV_bi_ei)+(r*d_a_dV_bi_ei))*lnzb));
                FCdf3_dw = ((((1.0-r)*x)+(r*a))*lnzb);
              }
              else
              {

                d_a_dV_tnode_GND = ((z*d_z_dV_tnode_GND)+(d_z_dV_tnode_GND*z));
                d_a_dV_bi_ci = ((z*d_z_dV_bi_ci)+(d_z_dV_bi_ci*z));
                d_a_dV_bi_ei = ((z*d_z_dV_bi_ei)+(d_z_dV_bi_ei*z));
                a = (z*z);

                d_a2_dV_tnode_GND = ((d_z_dV_tnode_GND-(0.25*d_a_dV_tnode_GND))+(((0.10*z)*d_a_dV_tnode_GND)+((0.10*d_z_dV_tnode_GND)*a)));
                d_a2_dV_bi_ci = ((d_z_dV_bi_ci-(0.25*d_a_dV_bi_ci))+(((0.10*z)*d_a_dV_bi_ci)+((0.10*d_z_dV_bi_ci)*a)));
                d_a2_dV_bi_ei = ((d_z_dV_bi_ei-(0.25*d_a_dV_bi_ei))+(((0.10*z)*d_a_dV_bi_ei)+((0.10*d_z_dV_bi_ei)*a)));
                a2 = (((3.0+z)-(0.25*a))+((0.10*z)*a));

                d_a3_dV_tnode_GND = (((2.0*d_z_dV_tnode_GND)+(0.75*d_a_dV_tnode_GND))-(((0.20*a)*d_z_dV_tnode_GND)+((0.20*d_a_dV_tnode_GND)*z)));
                d_a3_dV_bi_ci = (((2.0*d_z_dV_bi_ci)+(0.75*d_a_dV_bi_ci))-(((0.20*a)*d_z_dV_bi_ci)+((0.20*d_a_dV_bi_ci)*z)));
                d_a3_dV_bi_ei = (((2.0*d_z_dV_bi_ei)+(0.75*d_a_dV_bi_ei))-(((0.20*a)*d_z_dV_bi_ei)+((0.20*d_a_dV_bi_ei)*z)));
                a3 = (((2.0*z)+(0.75*a))-((0.20*a)*z));

                d_FCf3_dV_tnode_GND = (((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_tnode_GND)+((((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_tnode_GND)+((((model_.latl)*d_a2_dV_tnode_GND)+((model_.latb)*d_a3_dV_tnode_GND))*FCw))*FCw))/6.0);
                d_FCf3_dV_bi_ci = (((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_bi_ci)+((((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_bi_ci)+((((model_.latl)*d_a2_dV_bi_ci)+((model_.latb)*d_a3_dV_bi_ci))*FCw))*FCw))/6.0);
                d_FCf3_dV_bi_ei = (((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_bi_ei)+((((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_bi_ei)+((((model_.latl)*d_a2_dV_bi_ei)+((model_.latb)*d_a3_dV_bi_ei))*FCw))*FCw))/6.0);
                FCf3 = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*FCw)/6.0);

                d_FCdf3_dw_dV_tnode_GND = ((((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_tnode_GND)+((((1+((model_.latb)*FCw))*d_z_dV_tnode_GND)+(((model_.latb)*d_FCw_dV_tnode_GND)*(1+z)))*lnzb));
                d_FCdf3_dw_dV_bi_ci = ((((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_bi_ci)+((((1+((model_.latb)*FCw))*d_z_dV_bi_ci)+(((model_.latb)*d_FCw_dV_bi_ci)*(1+z)))*lnzb));
                d_FCdf3_dw_dV_bi_ei = ((((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_bi_ei)+((((1+((model_.latb)*FCw))*d_z_dV_bi_ei)+(((model_.latb)*d_FCw_dV_bi_ei)*(1+z)))*lnzb));
                FCdf3_dw = (((1+((model_.latb)*FCw))*(1+z))*lnzb);
              }

              d_FCf_ci_dV_tnode_GND = ((FCf_CT*((((FCa1*d_FCf1_dV_tnode_GND)+(d_FCa1_dV_tnode_GND*FCf1))-d_FCf2_dV_tnode_GND)+d_FCf3_dV_tnode_GND))+(d_FCf_CT_dV_tnode_GND*(((FCa1*FCf1)-FCf2)+FCf3)));
              d_FCf_ci_dV_bi_ci = ((FCf_CT*((((FCa1*d_FCf1_dV_bi_ci)+(d_FCa1_dV_bi_ci*FCf1))-d_FCf2_dV_bi_ci)+d_FCf3_dV_bi_ci))+(d_FCf_CT_dV_bi_ci*(((FCa1*FCf1)-FCf2)+FCf3)));
              d_FCf_ci_dV_bi_ei = ((FCf_CT*((((FCa1*d_FCf1_dV_bi_ei)+(d_FCa1_dV_bi_ei*FCf1))-d_FCf2_dV_bi_ei)+d_FCf3_dV_bi_ei))+(d_FCf_CT_dV_bi_ei*(((FCa1*FCf1)-FCf2)+FCf3)));
              FCf_ci = (FCf_CT*(((FCa1*FCf1)-FCf2)+FCf3));

              d_FCdfc_dw_dV_tnode_GND = ((FCf_CT*(((((FCa1*d_FCdf1_dw_dV_tnode_GND)+(d_FCa1_dV_tnode_GND*FCdf1_dw))+((FCda1_dw*d_FCf1_dV_tnode_GND)+(d_FCda1_dw_dV_tnode_GND*FCf1)))-d_FCdf2_dw_dV_tnode_GND)+d_FCdf3_dw_dV_tnode_GND))+(d_FCf_CT_dV_tnode_GND*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw)));
              d_FCdfc_dw_dV_bi_ci = ((FCf_CT*(((((FCa1*d_FCdf1_dw_dV_bi_ci)+(d_FCa1_dV_bi_ci*FCdf1_dw))+((FCda1_dw*d_FCf1_dV_bi_ci)+(d_FCda1_dw_dV_bi_ci*FCf1)))-d_FCdf2_dw_dV_bi_ci)+d_FCdf3_dw_dV_bi_ci))+(d_FCf_CT_dV_bi_ci*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw)));
              d_FCdfc_dw_dV_bi_ei = ((FCf_CT*(((((FCa1*d_FCdf1_dw_dV_bi_ei)+(d_FCa1_dV_bi_ei*FCdf1_dw))+((FCda1_dw*d_FCf1_dV_bi_ei)+(d_FCda1_dw_dV_bi_ei*FCf1)))-d_FCdf2_dw_dV_bi_ei)+d_FCdf3_dw_dV_bi_ei))+(d_FCf_CT_dV_bi_ei*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw)));
              FCdfc_dw = (FCf_CT*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));

              d_FCdw_ditf_dV_tnode_GND = ((FCdw_daick*d_FCdaick_ditf_dV_tnode_GND)+(d_FCdw_daick_dV_tnode_GND*FCdaick_ditf));
              d_FCdw_ditf_dV_bi_ci = ((FCdw_daick*d_FCdaick_ditf_dV_bi_ci)+(d_FCdw_daick_dV_bi_ci*FCdaick_ditf));
              d_FCdw_ditf_dV_bi_ei = ((FCdw_daick*d_FCdaick_ditf_dV_bi_ei)+(d_FCdw_daick_dV_bi_ei*FCdaick_ditf));
              FCdw_ditf = (FCdw_daick*FCdaick_ditf);

              d_FCdfc_ditf_dV_tnode_GND = ((FCdfc_dw*d_FCdw_ditf_dV_tnode_GND)+(d_FCdfc_dw_dV_tnode_GND*FCdw_ditf));
              d_FCdfc_ditf_dV_bi_ci = ((FCdfc_dw*d_FCdw_ditf_dV_bi_ci)+(d_FCdfc_dw_dV_bi_ci*FCdw_ditf));
              d_FCdfc_ditf_dV_bi_ei = ((FCdfc_dw*d_FCdw_ditf_dV_bi_ei)+(d_FCdfc_dw_dV_bi_ei*FCdw_ditf));
              FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
              if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
              {

                d_a_dV_tnode_GND = ((model_.latb)*d_FCw_dV_tnode_GND);
                d_a_dV_bi_ci = ((model_.latb)*d_FCw_dV_bi_ci);
                d_a_dV_bi_ei = ((model_.latb)*d_FCw_dV_bi_ei);
                a = ((model_.latb)*FCw);
                {
                  double value_log_0 = log((1+((model_.latb)*FCw)));
                  double  deriv_log_0_d0 = (1.0/(1+((model_.latb)*FCw)));

                  d_lnz_dV_tnode_GND = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_tnode_GND)));
                  d_lnz_dV_bi_ci = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_bi_ci)));
                  d_lnz_dV_bi_ei = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_bi_ei)));
                  lnz = value_log_0;
                }
                if ((a>1.0e-6))
                {

                  d_FCf2_dV_tnode_GND = ((d_a_dV_tnode_GND-d_lnz_dV_tnode_GND)/(model_.latb));
                  d_FCf2_dV_bi_ci = ((d_a_dV_bi_ci-d_lnz_dV_bi_ci)/(model_.latb));
                  d_FCf2_dV_bi_ei = ((d_a_dV_bi_ei-d_lnz_dV_bi_ei)/(model_.latb));
                  FCf2 = ((a-lnz)/(model_.latb));

                  d_FCdf2_dw_dV_tnode_GND = (((1.0+a)*d_a_dV_tnode_GND-a*d_a_dV_tnode_GND)/(1.0+a)/(1.0+a));
                  d_FCdf2_dw_dV_bi_ci = (((1.0+a)*d_a_dV_bi_ci-a*d_a_dV_bi_ci)/(1.0+a)/(1.0+a));
                  d_FCdf2_dw_dV_bi_ei = (((1.0+a)*d_a_dV_bi_ei-a*d_a_dV_bi_ei)/(1.0+a)/(1.0+a));
                  FCdf2_dw = (a/(1.0+a));
                }
                else
                {

                  d_FCf2_dV_tnode_GND = (((0.5*a)*d_FCw_dV_tnode_GND)+((0.5*d_a_dV_tnode_GND)*FCw));
                  d_FCf2_dV_bi_ci = (((0.5*a)*d_FCw_dV_bi_ci)+((0.5*d_a_dV_bi_ci)*FCw));
                  d_FCf2_dV_bi_ei = (((0.5*a)*d_FCw_dV_bi_ei)+((0.5*d_a_dV_bi_ei)*FCw));
                  FCf2 = ((0.5*a)*FCw);

                  d_FCdf2_dw_dV_tnode_GND = d_a_dV_tnode_GND;
                  d_FCdf2_dw_dV_bi_ci = d_a_dV_bi_ci;
                  d_FCdf2_dw_dV_bi_ei = d_a_dV_bi_ei;
                  FCdf2_dw = a;
                }

                d_a_dV_tnode_GND = ((model_.latl)*d_FCw_dV_tnode_GND);
                d_a_dV_bi_ci = ((model_.latl)*d_FCw_dV_bi_ci);
                d_a_dV_bi_ei = ((model_.latl)*d_FCw_dV_bi_ei);
                a = ((model_.latl)*FCw);
                {
                  double value_log_0 = log((1+((model_.latl)*FCw)));
                  double  deriv_log_0_d0 = (1.0/(1+((model_.latl)*FCw)));

                  d_lnz_dV_tnode_GND = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_tnode_GND)));
                  d_lnz_dV_bi_ci = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_bi_ci)));
                  d_lnz_dV_bi_ei = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_bi_ei)));
                  lnz = value_log_0;
                }
                if ((a>1.0e-6))
                {

                  d_FCf3_dV_tnode_GND = ((d_a_dV_tnode_GND-d_lnz_dV_tnode_GND)/(model_.latl));
                  d_FCf3_dV_bi_ci = ((d_a_dV_bi_ci-d_lnz_dV_bi_ci)/(model_.latl));
                  d_FCf3_dV_bi_ei = ((d_a_dV_bi_ei-d_lnz_dV_bi_ei)/(model_.latl));
                  FCf3 = ((a-lnz)/(model_.latl));

                  d_FCdf3_dw_dV_tnode_GND = (((1.0+a)*d_a_dV_tnode_GND-a*d_a_dV_tnode_GND)/(1.0+a)/(1.0+a));
                  d_FCdf3_dw_dV_bi_ci = (((1.0+a)*d_a_dV_bi_ci-a*d_a_dV_bi_ci)/(1.0+a)/(1.0+a));
                  d_FCdf3_dw_dV_bi_ei = (((1.0+a)*d_a_dV_bi_ei-a*d_a_dV_bi_ei)/(1.0+a)/(1.0+a));
                  FCdf3_dw = (a/(1.0+a));
                }
                else
                {

                  d_FCf3_dV_tnode_GND = (((0.5*a)*d_FCw_dV_tnode_GND)+((0.5*d_a_dV_tnode_GND)*FCw));
                  d_FCf3_dV_bi_ci = (((0.5*a)*d_FCw_dV_bi_ci)+((0.5*d_a_dV_bi_ci)*FCw));
                  d_FCf3_dV_bi_ei = (((0.5*a)*d_FCw_dV_bi_ei)+((0.5*d_a_dV_bi_ei)*FCw));
                  FCf3 = ((0.5*a)*FCw);

                  d_FCdf3_dw_dV_tnode_GND = d_a_dV_tnode_GND;
                  d_FCdf3_dw_dV_bi_ci = d_a_dV_bi_ci;
                  d_FCdf3_dw_dV_bi_ei = d_a_dV_bi_ei;
                  FCdf3_dw = a;
                }

                d_FCf_CT_dV_tnode_GND = ((FCf_CT*(d_FCf2_dV_tnode_GND-d_FCf3_dV_tnode_GND))+(d_FCf_CT_dV_tnode_GND*(FCf2-FCf3)));
                d_FCf_CT_dV_bi_ci = ((FCf_CT*(d_FCf2_dV_bi_ci-d_FCf3_dV_bi_ci))+(d_FCf_CT_dV_bi_ci*(FCf2-FCf3)));
                d_FCf_CT_dV_bi_ei = ((FCf_CT*(d_FCf2_dV_bi_ei-d_FCf3_dV_bi_ei))+(d_FCf_CT_dV_bi_ei*(FCf2-FCf3)));
                FCf_CT = (FCf_CT*(FCf2-FCf3));

                d_FCdfCT_dw_dV_tnode_GND = ((FCf_CT*(d_FCdf2_dw_dV_tnode_GND-d_FCdf3_dw_dV_tnode_GND))+(d_FCf_CT_dV_tnode_GND*(FCdf2_dw-FCdf3_dw)));
                d_FCdfCT_dw_dV_bi_ci = ((FCf_CT*(d_FCdf2_dw_dV_bi_ci-d_FCdf3_dw_dV_bi_ci))+(d_FCf_CT_dV_bi_ci*(FCdf2_dw-FCdf3_dw)));
                d_FCdfCT_dw_dV_bi_ei = ((FCf_CT*(d_FCdf2_dw_dV_bi_ei-d_FCdf3_dw_dV_bi_ei))+(d_FCf_CT_dV_bi_ei*(FCdf2_dw-FCdf3_dw)));
                FCdfCT_dw = (FCf_CT*(FCdf2_dw-FCdf3_dw));

                d_FCdfCT_ditf_dV_tnode_GND = ((FCdfCT_dw*d_FCdw_ditf_dV_tnode_GND)+(d_FCdfCT_dw_dV_tnode_GND*FCdw_ditf));
                d_FCdfCT_ditf_dV_bi_ci = ((FCdfCT_dw*d_FCdw_ditf_dV_bi_ci)+(d_FCdfCT_dw_dV_bi_ci*FCdw_ditf));
                d_FCdfCT_ditf_dV_bi_ei = ((FCdfCT_dw*d_FCdw_ditf_dV_bi_ei)+(d_FCdfCT_dw_dV_bi_ei*FCdw_ditf));
                FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
              }
              else
              {

                d_FCf_CT_dV_tnode_GND = d_FCf_ci_dV_tnode_GND;
                d_FCf_CT_dV_bi_ci = d_FCf_ci_dV_bi_ci;
                d_FCf_CT_dV_bi_ei = d_FCf_ci_dV_bi_ei;
                FCf_CT = FCf_ci;

                d_FCdfCT_ditf_dV_tnode_GND = d_FCdfc_ditf_dV_tnode_GND;
                d_FCdfCT_ditf_dV_bi_ci = d_FCdfc_ditf_dV_bi_ci;
                d_FCdfCT_ditf_dV_bi_ei = d_FCdfc_ditf_dV_bi_ei;
                FCdfCT_ditf = FCdfc_ditf;
              }
            }
            else
            {
              if (((model_.latb)>0.01))
              {

                d_FCd_a_dV_tnode_GND = (-(d_FCa_ck_dV_tnode_GND*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
                d_FCd_a_dV_bi_ci = (-(d_FCa_ck_dV_bi_ci*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
                d_FCd_a_dV_bi_ei = (-(d_FCa_ck_dV_bi_ei*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
                FCd_a = (1.0/(1.0+(FCa_ck*(model_.latb))));

                d_FCw_dV_tnode_GND = (((1.0-FCa_ck)*d_FCd_a_dV_tnode_GND)+((-d_FCa_ck_dV_tnode_GND)*FCd_a));
                d_FCw_dV_bi_ci = (((1.0-FCa_ck)*d_FCd_a_dV_bi_ci)+((-d_FCa_ck_dV_bi_ci)*FCd_a));
                d_FCw_dV_bi_ei = (((1.0-FCa_ck)*d_FCd_a_dV_bi_ei)+((-d_FCa_ck_dV_bi_ei)*FCd_a));
                FCw = ((1.0-FCa_ck)*FCd_a);

                d_FCdw_daick_dV_tnode_GND = ((((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_tnode_GND)+(((-(1.0+(model_.latb)))*d_FCd_a_dV_tnode_GND)*FCd_a));
                d_FCdw_daick_dV_bi_ci = ((((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_bi_ci)+(((-(1.0+(model_.latb)))*d_FCd_a_dV_bi_ci)*FCd_a));
                d_FCdw_daick_dV_bi_ei = ((((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_bi_ei)+(((-(1.0+(model_.latb)))*d_FCd_a_dV_bi_ei)*FCd_a));
                FCdw_daick = (((-(1.0+(model_.latb)))*FCd_a)*FCd_a);
              }
              else
              {

                d_FCw_dV_tnode_GND = ((-d_FCa_ck_dV_tnode_GND)-(d_FCa_ck_dV_tnode_GND*(model_.latb)));
                d_FCw_dV_bi_ci = ((-d_FCa_ck_dV_bi_ci)-(d_FCa_ck_dV_bi_ci*(model_.latb)));
                d_FCw_dV_bi_ei = ((-d_FCa_ck_dV_bi_ei)-(d_FCa_ck_dV_bi_ei*(model_.latb)));
                FCw = ((1.0-FCa_ck)-(FCa_ck*(model_.latb)));

                d_FCdw_daick_dV_bi_ei = d_FCdw_daick_dV_bi_ci = d_FCdw_daick_dV_tnode_GND =  0.0;
                FCdw_daick = (-(1.0+(model_.latb)));
              }

              d_FCw2_dV_tnode_GND = ((FCw*d_FCw_dV_tnode_GND)+(d_FCw_dV_tnode_GND*FCw));
              d_FCw2_dV_bi_ci = ((FCw*d_FCw_dV_bi_ci)+(d_FCw_dV_bi_ci*FCw));
              d_FCw2_dV_bi_ei = ((FCw*d_FCw_dV_bi_ei)+(d_FCw_dV_bi_ei*FCw));
              FCw2 = (FCw*FCw);

              d_FCz_dV_tnode_GND = ((model_.latb)*d_FCw_dV_tnode_GND);
              d_FCz_dV_bi_ci = ((model_.latb)*d_FCw_dV_bi_ci);
              d_FCz_dV_bi_ei = ((model_.latb)*d_FCw_dV_bi_ei);
              FCz = ((model_.latb)*FCw);

              d_FCz_1_dV_tnode_GND = d_FCz_dV_tnode_GND;
              d_FCz_1_dV_bi_ci = d_FCz_dV_bi_ci;
              d_FCz_1_dV_bi_ei = d_FCz_dV_bi_ei;
              FCz_1 = (1.0+FCz);

              d_FCd_f_dV_tnode_GND = (-d_FCz_1_dV_tnode_GND/FCz_1/FCz_1);
              d_FCd_f_dV_bi_ci = (-d_FCz_1_dV_bi_ci/FCz_1/FCz_1);
              d_FCd_f_dV_bi_ei = (-d_FCz_1_dV_bi_ei/FCz_1/FCz_1);
              FCd_f = (1.0/FCz_1);

              d_FCf_ci_dV_tnode_GND = (((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_tnode_GND)+(((FCw2*(d_FCz_dV_tnode_GND/3.0))+(d_FCw2_dV_tnode_GND*(1.0+(FCz/3.0))))*FCd_f));
              d_FCf_ci_dV_bi_ci = (((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_bi_ci)+(((FCw2*(d_FCz_dV_bi_ci/3.0))+(d_FCw2_dV_bi_ci*(1.0+(FCz/3.0))))*FCd_f));
              d_FCf_ci_dV_bi_ei = (((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_bi_ei)+(((FCw2*(d_FCz_dV_bi_ei/3.0))+(d_FCw2_dV_bi_ei*(1.0+(FCz/3.0))))*FCd_f));
              FCf_ci = ((FCw2*(1.0+(FCz/3.0)))*FCd_f);

              d_FCdfc_dw_dV_tnode_GND = (((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_tnode_GND)+(((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_tnode_GND)+((((2.0*FCw)*(d_FCz_1_dV_tnode_GND+(((FCz*d_FCz_dV_tnode_GND)+(d_FCz_dV_tnode_GND*FCz))/3.0)))+((2.0*d_FCw_dV_tnode_GND)*(FCz_1+((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
              d_FCdfc_dw_dV_bi_ci = (((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ci)+(((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ci)+((((2.0*FCw)*(d_FCz_1_dV_bi_ci+(((FCz*d_FCz_dV_bi_ci)+(d_FCz_dV_bi_ci*FCz))/3.0)))+((2.0*d_FCw_dV_bi_ci)*(FCz_1+((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
              d_FCdfc_dw_dV_bi_ei = (((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ei)+(((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ei)+((((2.0*FCw)*(d_FCz_1_dV_bi_ei+(((FCz*d_FCz_dV_bi_ei)+(d_FCz_dV_bi_ei*FCz))/3.0)))+((2.0*d_FCw_dV_bi_ei)*(FCz_1+((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
              FCdfc_dw = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);

              d_FCdw_ditf_dV_tnode_GND = ((FCdw_daick*d_FCdaick_ditf_dV_tnode_GND)+(d_FCdw_daick_dV_tnode_GND*FCdaick_ditf));
              d_FCdw_ditf_dV_bi_ci = ((FCdw_daick*d_FCdaick_ditf_dV_bi_ci)+(d_FCdw_daick_dV_bi_ci*FCdaick_ditf));
              d_FCdw_ditf_dV_bi_ei = ((FCdw_daick*d_FCdaick_ditf_dV_bi_ei)+(d_FCdw_daick_dV_bi_ei*FCdaick_ditf));
              FCdw_ditf = (FCdw_daick*FCdaick_ditf);

              d_FCdfc_ditf_dV_tnode_GND = ((FCdfc_dw*d_FCdw_ditf_dV_tnode_GND)+(d_FCdfc_dw_dV_tnode_GND*FCdw_ditf));
              d_FCdfc_ditf_dV_bi_ci = ((FCdfc_dw*d_FCdw_ditf_dV_bi_ci)+(d_FCdfc_dw_dV_bi_ci*FCdw_ditf));
              d_FCdfc_ditf_dV_bi_ei = ((FCdfc_dw*d_FCdw_ditf_dV_bi_ei)+(d_FCdfc_dw_dV_bi_ei*FCdw_ditf));
              FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
              if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
              {
                if ((FCz>0.001))
                {
                  {
                    double value_log_0 = log(FCz_1);
                    double  deriv_log_0_d0 = (1.0/FCz_1);

                    d_FCf_CT_dV_tnode_GND = (((((model_.latb)*(model_.latb))*FCz_1)*(2.0*(((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_tnode_GND)))+(d_FCz_1_dV_tnode_GND*value_log_0))-d_FCz_dV_tnode_GND))-(2.0*((FCz_1*value_log_0)-FCz))*(((model_.latb)*(model_.latb))*d_FCz_1_dV_tnode_GND))/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
                    d_FCf_CT_dV_bi_ci = (((((model_.latb)*(model_.latb))*FCz_1)*(2.0*(((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_bi_ci)))+(d_FCz_1_dV_bi_ci*value_log_0))-d_FCz_dV_bi_ci))-(2.0*((FCz_1*value_log_0)-FCz))*(((model_.latb)*(model_.latb))*d_FCz_1_dV_bi_ci))/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
                    d_FCf_CT_dV_bi_ei = (((((model_.latb)*(model_.latb))*FCz_1)*(2.0*(((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_bi_ei)))+(d_FCz_1_dV_bi_ei*value_log_0))-d_FCz_dV_bi_ei))-(2.0*((FCz_1*value_log_0)-FCz))*(((model_.latb)*(model_.latb))*d_FCz_1_dV_bi_ei))/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
                    FCf_CT = ((2.0*((FCz_1*value_log_0)-FCz))/(((model_.latb)*(model_.latb))*FCz_1));
                  }

                  d_FCdfCT_dw_dV_tnode_GND = ((((2.0*FCw)*FCd_f)*d_FCd_f_dV_tnode_GND)+((((2.0*FCw)*d_FCd_f_dV_tnode_GND)+((2.0*d_FCw_dV_tnode_GND)*FCd_f))*FCd_f));
                  d_FCdfCT_dw_dV_bi_ci = ((((2.0*FCw)*FCd_f)*d_FCd_f_dV_bi_ci)+((((2.0*FCw)*d_FCd_f_dV_bi_ci)+((2.0*d_FCw_dV_bi_ci)*FCd_f))*FCd_f));
                  d_FCdfCT_dw_dV_bi_ei = ((((2.0*FCw)*FCd_f)*d_FCd_f_dV_bi_ei)+((((2.0*FCw)*d_FCd_f_dV_bi_ei)+((2.0*d_FCw_dV_bi_ei)*FCd_f))*FCd_f));
                  FCdfCT_dw = (((2.0*FCw)*FCd_f)*FCd_f);
                }
                else
                {

                  d_FCf_CT_dV_tnode_GND = (((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_tnode_GND)+(((FCw2*(-(d_FCz_dV_tnode_GND/3.0)))+(d_FCw2_dV_tnode_GND*(1.0-(FCz/3.0))))*FCd_f));
                  d_FCf_CT_dV_bi_ci = (((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_bi_ci)+(((FCw2*(-(d_FCz_dV_bi_ci/3.0)))+(d_FCw2_dV_bi_ci*(1.0-(FCz/3.0))))*FCd_f));
                  d_FCf_CT_dV_bi_ei = (((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_bi_ei)+(((FCw2*(-(d_FCz_dV_bi_ei/3.0)))+(d_FCw2_dV_bi_ei*(1.0-(FCz/3.0))))*FCd_f));
                  FCf_CT = ((FCw2*(1.0-(FCz/3.0)))*FCd_f);

                  d_FCdfCT_dw_dV_tnode_GND = (((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_tnode_GND)+(((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_tnode_GND)+((((2.0*FCw)*(-(((FCz*d_FCz_dV_tnode_GND)+(d_FCz_dV_tnode_GND*FCz))/3.0)))+((2.0*d_FCw_dV_tnode_GND)*(1.0-((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
                  d_FCdfCT_dw_dV_bi_ci = (((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ci)+(((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ci)+((((2.0*FCw)*(-(((FCz*d_FCz_dV_bi_ci)+(d_FCz_dV_bi_ci*FCz))/3.0)))+((2.0*d_FCw_dV_bi_ci)*(1.0-((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
                  d_FCdfCT_dw_dV_bi_ei = (((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ei)+(((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ei)+((((2.0*FCw)*(-(((FCz*d_FCz_dV_bi_ei)+(d_FCz_dV_bi_ei*FCz))/3.0)))+((2.0*d_FCw_dV_bi_ei)*(1.0-((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
                  FCdfCT_dw = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
                }

                d_FCdfCT_ditf_dV_tnode_GND = ((FCdfCT_dw*d_FCdw_ditf_dV_tnode_GND)+(d_FCdfCT_dw_dV_tnode_GND*FCdw_ditf));
                d_FCdfCT_ditf_dV_bi_ci = ((FCdfCT_dw*d_FCdw_ditf_dV_bi_ci)+(d_FCdfCT_dw_dV_bi_ci*FCdw_ditf));
                d_FCdfCT_ditf_dV_bi_ei = ((FCdfCT_dw*d_FCdw_ditf_dV_bi_ei)+(d_FCdfCT_dw_dV_bi_ei*FCdw_ditf));
                FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
              }
              else
              {

                d_FCf_CT_dV_tnode_GND = d_FCf_ci_dV_tnode_GND;
                d_FCf_CT_dV_bi_ci = d_FCf_ci_dV_bi_ci;
                d_FCf_CT_dV_bi_ei = d_FCf_ci_dV_bi_ei;
                FCf_CT = FCf_ci;

                d_FCdfCT_ditf_dV_tnode_GND = d_FCdfc_ditf_dV_tnode_GND;
                d_FCdfCT_ditf_dV_bi_ci = d_FCdfc_ditf_dV_bi_ci;
                d_FCdfCT_ditf_dV_bi_ei = d_FCdfc_ditf_dV_bi_ei;
                FCdfCT_ditf = FCdfc_ditf;
              }
            }
            {
              double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
              double  deriv_exp_0_d0 = value_exp_0;

              d_FFdQcfcT_dV_bi_ci = (((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+(((FFdQcfc*d_FCf_CT_dV_bi_ci)+(d_FFdQcfc_dV_bi_ci*FCf_CT))*value_exp_0));
              d_FFdQcfcT_dV_bi_ei = (((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+(((FFdQcfc*d_FCf_CT_dV_bi_ei)+(d_FFdQcfc_dV_bi_ei*FCf_CT))*value_exp_0));
              d_FFdQcfcT_dV_tnode_GND = (((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((FFdQcfc*d_FCf_CT_dV_tnode_GND)+(d_FFdQcfc_dV_tnode_GND*FCf_CT))*value_exp_0));
              FFdQcfcT = ((FFdQcfc*FCf_CT)*value_exp_0);
            }
            {
              double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
              double  deriv_exp_0_d0 = value_exp_0;

              d_FFdQcfc_dV_bi_ci = (((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+(((FFdQcfc*d_FCf_ci_dV_bi_ci)+(d_FFdQcfc_dV_bi_ci*FCf_ci))*value_exp_0));
              d_FFdQcfc_dV_bi_ei = (((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+(((FFdQcfc*d_FCf_ci_dV_bi_ei)+(d_FFdQcfc_dV_bi_ei*FCf_ci))*value_exp_0));
              d_FFdQcfc_dV_tnode_GND = (((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((FFdQcfc*d_FCf_ci_dV_tnode_GND)+(d_FFdQcfc_dV_tnode_GND*FCf_ci))*value_exp_0));
              FFdQcfc = ((FFdQcfc*FCf_ci)*value_exp_0);
            }
            {
              double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
              double  deriv_exp_0_d0 = value_exp_0;

              d_FFdTcfc_dV_bi_ci = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_bi_ci+((itf*d_FCdfc_ditf_dV_bi_ci)+(d_itf_dV_bi_ci*FCdfc_ditf))))+((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))*(FCf_ci+(itf*FCdfc_ditf))))+(((FFdQcfc/VT)*d_FFdVc_ditf_dV_bi_ci)+((d_FFdQcfc_dV_bi_ci/VT)*FFdVc_ditf)));
              d_FFdTcfc_dV_bi_ei = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_bi_ei+((itf*d_FCdfc_ditf_dV_bi_ei)+(d_itf_dV_bi_ei*FCdfc_ditf))))+((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))*(FCf_ci+(itf*FCdfc_ditf))))+(((FFdQcfc/VT)*d_FFdVc_ditf_dV_bi_ei)+((d_FFdQcfc_dV_bi_ei/VT)*FFdVc_ditf)));
              d_FFdTcfc_dV_tnode_GND = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_tnode_GND+((itf*d_FCdfc_ditf_dV_tnode_GND)+(d_itf_dV_tnode_GND*FCdfc_ditf))))+(((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((model_.fthc)*d_thcs_t_dV_tnode_GND)*value_exp_0))*(FCf_ci+(itf*FCdfc_ditf))))+(((FFdQcfc/VT)*d_FFdVc_ditf_dV_tnode_GND)+(((VT*d_FFdQcfc_dV_tnode_GND-FFdQcfc*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf)));
              FFdTcfc = (((((model_.fthc)*thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*FFdVc_ditf));
            }
            {
              double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
              double  deriv_exp_0_d0 = value_exp_0;

              d_FFdTcfcT_dV_bi_ci = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_bi_ci+((itf*d_FCdfCT_ditf_dV_bi_ci)+(d_itf_dV_bi_ci*FCdfCT_ditf))))+((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))*(FCf_CT+(itf*FCdfCT_ditf))))+(((FFdQcfcT/VT)*d_FFdVc_ditf_dV_bi_ci)+((d_FFdQcfcT_dV_bi_ci/VT)*FFdVc_ditf)));
              d_FFdTcfcT_dV_bi_ei = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_bi_ei+((itf*d_FCdfCT_ditf_dV_bi_ei)+(d_itf_dV_bi_ei*FCdfCT_ditf))))+((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))*(FCf_CT+(itf*FCdfCT_ditf))))+(((FFdQcfcT/VT)*d_FFdVc_ditf_dV_bi_ei)+((d_FFdQcfcT_dV_bi_ei/VT)*FFdVc_ditf)));
              d_FFdTcfcT_dV_tnode_GND = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_tnode_GND+((itf*d_FCdfCT_ditf_dV_tnode_GND)+(d_itf_dV_tnode_GND*FCdfCT_ditf))))+(((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((model_.fthc)*d_thcs_t_dV_tnode_GND)*value_exp_0))*(FCf_CT+(itf*FCdfCT_ditf))))+(((FFdQcfcT/VT)*d_FFdVc_ditf_dV_tnode_GND)+(((VT*d_FFdQcfcT_dV_tnode_GND-FFdQcfcT*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf)));
              FFdTcfcT = (((((model_.fthc)*thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*FFdVc_ditf));
            }
          }

          d_FFdQbfc_dV_bi_ci = ((1-(model_.fthc))*d_FFdQfhc_dV_bi_ci);
          d_FFdQbfc_dV_bi_ei = ((1-(model_.fthc))*d_FFdQfhc_dV_bi_ei);
          d_FFdQbfc_dV_tnode_GND = ((1-(model_.fthc))*d_FFdQfhc_dV_tnode_GND);
          FFdQbfc = ((1-(model_.fthc))*FFdQfhc);

          d_FFdTbfc_dV_bi_ci = ((1-(model_.fthc))*d_FFdTfhc_dV_bi_ci);
          d_FFdTbfc_dV_bi_ei = ((1-(model_.fthc))*d_FFdTfhc_dV_bi_ei);
          d_FFdTbfc_dV_tnode_GND = ((1-(model_.fthc))*d_FFdTfhc_dV_tnode_GND);
          FFdTbfc = ((1-(model_.fthc))*FFdTfhc);

          d_Q_fT_dV_bi_ei = (((((hf0_t*d_Qf_dV_bi_ei)+d_FFdQbfb_dV_bi_ei)+d_FFdQbfc_dV_bi_ei)+(hfe_t*d_FFdQef_dV_bi_ei))+(hfc_t*d_FFdQcfcT_dV_bi_ei));
          d_Q_fT_dV_bi_ci = (((((hf0_t*d_Qf_dV_bi_ci)+d_FFdQbfb_dV_bi_ci)+d_FFdQbfc_dV_bi_ci)+(hfe_t*d_FFdQef_dV_bi_ci))+(hfc_t*d_FFdQcfcT_dV_bi_ci));
          d_Q_fT_dV_tnode_GND = ((((((hf0_t*d_Qf_dV_tnode_GND)+(d_hf0_t_dV_tnode_GND*Qf))+d_FFdQbfb_dV_tnode_GND)+d_FFdQbfc_dV_tnode_GND)+((hfe_t*d_FFdQef_dV_tnode_GND)+(d_hfe_t_dV_tnode_GND*FFdQef)))+((hfc_t*d_FFdQcfcT_dV_tnode_GND)+(d_hfc_t_dV_tnode_GND*FFdQcfcT)));
          Q_fT = (((((hf0_t*Qf)+FFdQbfb)+FFdQbfc)+(hfe_t*FFdQef))+(hfc_t*FFdQcfcT));

          d_T_fT_dV_bi_ci = (((((hf0_t*d_Tf_dV_bi_ci)+d_FFdTbfb_dV_bi_ci)+d_FFdTbfc_dV_bi_ci)+(hfe_t*d_FFdTef_dV_bi_ci))+(hfc_t*d_FFdTcfcT_dV_bi_ci));
          d_T_fT_dV_bi_ei = (((((hf0_t*d_Tf_dV_bi_ei)+d_FFdTbfb_dV_bi_ei)+d_FFdTbfc_dV_bi_ei)+(hfe_t*d_FFdTef_dV_bi_ei))+(hfc_t*d_FFdTcfcT_dV_bi_ei));
          d_T_fT_dV_tnode_GND = ((((((hf0_t*d_Tf_dV_tnode_GND)+(d_hf0_t_dV_tnode_GND*Tf))+d_FFdTbfb_dV_tnode_GND)+d_FFdTbfc_dV_tnode_GND)+((hfe_t*d_FFdTef_dV_tnode_GND)+(d_hfe_t_dV_tnode_GND*FFdTef)))+((hfc_t*d_FFdTcfcT_dV_tnode_GND)+(d_hfc_t_dV_tnode_GND*FFdTcfcT)));
          T_fT = (((((hf0_t*Tf)+FFdTbfb)+FFdTbfc)+(hfe_t*FFdTef))+(hfc_t*FFdTcfcT));

          d_Qf_dV_bi_ei = (((d_Qf_dV_bi_ei+(d_FFdQbfb_dV_bi_ei+d_FFdQbfc_dV_bi_ei))+d_FFdQef_dV_bi_ei)+d_FFdQcfc_dV_bi_ei);
          d_Qf_dV_bi_ci = (((d_Qf_dV_bi_ci+(d_FFdQbfb_dV_bi_ci+d_FFdQbfc_dV_bi_ci))+d_FFdQef_dV_bi_ci)+d_FFdQcfc_dV_bi_ci);
          d_Qf_dV_tnode_GND = (((d_Qf_dV_tnode_GND+(d_FFdQbfb_dV_tnode_GND+d_FFdQbfc_dV_tnode_GND))+d_FFdQef_dV_tnode_GND)+d_FFdQcfc_dV_tnode_GND);
          Qf = (((Qf+(FFdQbfb+FFdQbfc))+FFdQef)+FFdQcfc);

          d_Tf_dV_bi_ci = (((d_Tf_dV_bi_ci+(d_FFdTbfb_dV_bi_ci+d_FFdTbfc_dV_bi_ci))+d_FFdTef_dV_bi_ci)+d_FFdTcfc_dV_bi_ci);
          d_Tf_dV_tnode_GND = (((d_Tf_dV_tnode_GND+(d_FFdTbfb_dV_tnode_GND+d_FFdTbfc_dV_tnode_GND))+d_FFdTef_dV_tnode_GND)+d_FFdTcfc_dV_tnode_GND);
          d_Tf_dV_bi_ei = (((d_Tf_dV_bi_ei+(d_FFdTbfb_dV_bi_ei+d_FFdTbfc_dV_bi_ei))+d_FFdTef_dV_bi_ei)+d_FFdTcfc_dV_bi_ei);
          Tf = (((Tf+(FFdTbfb+FFdTbfc))+FFdTef)+FFdTcfc);

          d_Q_bf_dV_bi_ci = (d_FFdQbfb_dV_bi_ci+d_FFdQbfc_dV_bi_ci);
          d_Q_bf_dV_bi_ei = (d_FFdQbfb_dV_bi_ei+d_FFdQbfc_dV_bi_ei);
          d_Q_bf_dV_tnode_GND = (d_FFdQbfb_dV_tnode_GND+d_FFdQbfc_dV_tnode_GND);
          Q_bf = (FFdQbfb+FFdQbfc);
        }

        d_Qr_dV_bi_ei = (Tr*d_itr_dV_bi_ei);
        d_Qr_dV_bi_ci = (Tr*d_itr_dV_bi_ci);
        d_Qr_dV_tnode_GND = (Tr*d_itr_dV_tnode_GND);
        Qr = (Tr*itr);
        if ((Oich==0.0))
        {

          d_a_dV_bi_ci = ((Q_pT*(((T_fT*d_itf_dV_bi_ci)+(d_T_fT_dV_bi_ci*itf))+d_Qr_dV_bi_ci)-((T_fT*itf)+Qr)*d_Q_pT_dV_bi_ci)/Q_pT/Q_pT);
          d_a_dV_tnode_GND = ((Q_pT*(((T_fT*d_itf_dV_tnode_GND)+(d_T_fT_dV_tnode_GND*itf))+d_Qr_dV_tnode_GND)-((T_fT*itf)+Qr)*d_Q_pT_dV_tnode_GND)/Q_pT/Q_pT);
          d_a_dV_bi_ei = ((Q_pT*(((T_fT*d_itf_dV_bi_ei)+(d_T_fT_dV_bi_ei*itf))+d_Qr_dV_bi_ei)-((T_fT*itf)+Qr)*d_Q_pT_dV_bi_ei)/Q_pT/Q_pT);
          a = (1.0+(((T_fT*itf)+Qr)/Q_pT));
        }
        else
        {

          d_a_dV_bi_ci = ((Q_pT*((((T_fT*I_Tf1)*(2.0*d_a_h_dV_bi_ci))+(((T_fT*d_I_Tf1_dV_bi_ci)+(d_T_fT_dV_bi_ci*I_Tf1))*(1.0+(2.0*a_h))))+d_Qr_dV_bi_ci)-(((T_fT*I_Tf1)*(1.0+(2.0*a_h)))+Qr)*d_Q_pT_dV_bi_ci)/Q_pT/Q_pT);
          d_a_dV_tnode_GND = ((Q_pT*((((T_fT*I_Tf1)*(2.0*d_a_h_dV_tnode_GND))+(((T_fT*d_I_Tf1_dV_tnode_GND)+(d_T_fT_dV_tnode_GND*I_Tf1))*(1.0+(2.0*a_h))))+d_Qr_dV_tnode_GND)-(((T_fT*I_Tf1)*(1.0+(2.0*a_h)))+Qr)*d_Q_pT_dV_tnode_GND)/Q_pT/Q_pT);
          d_a_dV_bi_ei = ((Q_pT*((((T_fT*I_Tf1)*(2.0*d_a_h_dV_bi_ei))+(((T_fT*d_I_Tf1_dV_bi_ei)+(d_T_fT_dV_bi_ei*I_Tf1))*(1.0+(2.0*a_h))))+d_Qr_dV_bi_ei)-(((T_fT*I_Tf1)*(1.0+(2.0*a_h)))+Qr)*d_Q_pT_dV_bi_ei)/Q_pT/Q_pT);
          a = (1.0+((((T_fT*I_Tf1)*(1.0+(2.0*a_h)))+Qr)/Q_pT));
        }

        d_d_Q_dV_bi_ci = ((a*(-(d_Q_pT_dV_bi_ci-((d_Q_0_dV_bi_ci+d_Q_fT_dV_bi_ci)+d_Qr_dV_bi_ci)))-(-(Q_pT-((Q_0+Q_fT)+Qr)))*d_a_dV_bi_ci)/a/a);
        d_d_Q_dV_bi_ei = ((a*(-(d_Q_pT_dV_bi_ei-((d_Q_0_dV_bi_ei+d_Q_fT_dV_bi_ei)+d_Qr_dV_bi_ei)))-(-(Q_pT-((Q_0+Q_fT)+Qr)))*d_a_dV_bi_ei)/a/a);
        d_d_Q_dV_tnode_GND = ((a*(-(d_Q_pT_dV_tnode_GND-((d_Q_0_dV_tnode_GND+d_Q_fT_dV_tnode_GND)+d_Qr_dV_tnode_GND)))-(-(Q_pT-((Q_0+Q_fT)+Qr)))*d_a_dV_tnode_GND)/a/a);
        d_Q = ((-(Q_pT-((Q_0+Q_fT)+Qr)))/a);
        {
          double value_fabs_0 = fabs((0.3*Q_pT));
          double  deriv_fabs_0_d0 = ((((0.3*Q_pT))>=0)?(+1.0):(-1.0));

          d_a_dV_bi_ci = (deriv_fabs_0_d0*((0.3*d_Q_pT_dV_bi_ci)));
          d_a_dV_bi_ei = (deriv_fabs_0_d0*((0.3*d_Q_pT_dV_bi_ei)));
          d_a_dV_tnode_GND = (deriv_fabs_0_d0*((0.3*d_Q_pT_dV_tnode_GND)));
          a = value_fabs_0;
        }
        if ((fabs(d_Q)>a))
        {
          if ((d_Q>=0))
          {

            d_d_Q_dV_tnode_GND = d_a_dV_tnode_GND;
            d_d_Q_dV_bi_ci = d_a_dV_bi_ci;
            d_d_Q_dV_bi_ei = d_a_dV_bi_ei;
            d_Q = a;
          }
          else
          {

            d_d_Q_dV_tnode_GND = (-d_a_dV_tnode_GND);
            d_d_Q_dV_bi_ci = (-d_a_dV_bi_ci);
            d_d_Q_dV_bi_ei = (-d_a_dV_bi_ei);
            d_Q = (-a);
          }
        }

        d_Q_pT_dV_bi_ci = (d_Q_pT_dV_bi_ci+d_d_Q_dV_bi_ci);
        d_Q_pT_dV_bi_ei = (d_Q_pT_dV_bi_ei+d_d_Q_dV_bi_ei);
        d_Q_pT_dV_tnode_GND = (d_Q_pT_dV_tnode_GND+d_d_Q_dV_tnode_GND);
        Q_pT = (Q_pT+d_Q);
        l_it = (l_it+1);
      }

      d_I_Tf1_dV_bi_ci = (-i_0f*d_Q_pT_dV_bi_ci/Q_pT/Q_pT);
      d_I_Tf1_dV_bi_ei = ((Q_pT*d_i_0f_dV_bi_ei-i_0f*d_Q_pT_dV_bi_ei)/Q_pT/Q_pT);
      d_I_Tf1_dV_tnode_GND = ((Q_pT*d_i_0f_dV_tnode_GND-i_0f*d_Q_pT_dV_tnode_GND)/Q_pT/Q_pT);
      I_Tf1 = (i_0f/Q_pT);

      d_a_h_dV_bi_ci = (Oich*d_I_Tf1_dV_bi_ci);
      d_a_h_dV_bi_ei = (Oich*d_I_Tf1_dV_bi_ei);
      d_a_h_dV_tnode_GND = (Oich*d_I_Tf1_dV_tnode_GND);
      a_h = (Oich*I_Tf1);

      d_itf_dV_bi_ci = ((I_Tf1*d_a_h_dV_bi_ci)+(d_I_Tf1_dV_bi_ci*(1.0+a_h)));
      d_itf_dV_bi_ei = ((I_Tf1*d_a_h_dV_bi_ei)+(d_I_Tf1_dV_bi_ei*(1.0+a_h)));
      d_itf_dV_tnode_GND = ((I_Tf1*d_a_h_dV_tnode_GND)+(d_I_Tf1_dV_tnode_GND*(1.0+a_h)));
      itf = (I_Tf1*(1.0+a_h));

      d_itr_dV_bi_ei = (-i_0r*d_Q_pT_dV_bi_ei/Q_pT/Q_pT);
      d_itr_dV_bi_ci = ((Q_pT*d_i_0r_dV_bi_ci-i_0r*d_Q_pT_dV_bi_ci)/Q_pT/Q_pT);
      d_itr_dV_tnode_GND = ((Q_pT*d_i_0r_dV_tnode_GND-i_0r*d_Q_pT_dV_tnode_GND)/Q_pT/Q_pT);
      itr = (i_0r/Q_pT);

      d_Tf_dV_bi_ei =  0.0;
      d_Tf_dV_bi_ci = d_T_f0_dV_bi_ci;
      d_Tf_dV_tnode_GND = d_T_f0_dV_tnode_GND;
      Tf = T_f0;

      d_Qf_dV_bi_ei = (T_f0*d_itf_dV_bi_ei);
      d_Qf_dV_bi_ci = ((T_f0*d_itf_dV_bi_ci)+(d_T_f0_dV_bi_ci*itf));
      d_Qf_dV_tnode_GND = ((T_f0*d_itf_dV_tnode_GND)+(d_T_f0_dV_tnode_GND*itf));
      Qf = (T_f0*itf);
      if ((itf<(1.0e-6*ick)))
      {

        d_Q_fT_dV_bi_ei = d_Qf_dV_bi_ei;
        d_Q_fT_dV_bi_ci = d_Qf_dV_bi_ci;
        d_Q_fT_dV_tnode_GND = d_Qf_dV_tnode_GND;
        Q_fT = Qf;

        d_T_fT_dV_bi_ci = d_Tf_dV_bi_ci;
        d_T_fT_dV_tnode_GND = d_Tf_dV_tnode_GND;
        d_T_fT_dV_bi_ei = d_Tf_dV_bi_ei;
        T_fT = Tf;

        d_Q_bf_dV_tnode_GND = d_Q_bf_dV_bi_ei = d_Q_bf_dV_bi_ci =  0.0;
        Q_bf = 0;
      }
      else
      {

        d_FFitf_ick_dV_bi_ci = ((ick*d_itf_dV_bi_ci-itf*d_ick_dV_bi_ci)/ick/ick);
        d_FFitf_ick_dV_bi_ei = ((ick*d_itf_dV_bi_ei-itf*d_ick_dV_bi_ei)/ick/ick);
        d_FFitf_ick_dV_tnode_GND = ((ick*d_itf_dV_tnode_GND-itf*d_ick_dV_tnode_GND)/ick/ick);
        FFitf_ick = (itf/ick);
        {
          double value_log_0 = log(FFitf_ick);
          double value_exp_1 = exp(((model_.gtfe)*value_log_0));
          double  deriv_log_0_d0 = (1.0/FFitf_ick);
          double  deriv_exp_1_d0 = value_exp_1;

          d_FFdTef_dV_bi_ci = (tef0_t*(deriv_exp_1_d0*(((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_bi_ci))))));
          d_FFdTef_dV_bi_ei = (tef0_t*(deriv_exp_1_d0*(((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_bi_ei))))));
          d_FFdTef_dV_tnode_GND = ((tef0_t*(deriv_exp_1_d0*(((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_tnode_GND))))))+(d_tef0_t_dV_tnode_GND*value_exp_1));
          FFdTef = (tef0_t*value_exp_1);
        }

        d_FFdQef_dV_bi_ci = (((FFdTef*d_itf_dV_bi_ci)+(d_FFdTef_dV_bi_ci*itf))/(1+(model_.gtfe)));
        d_FFdQef_dV_bi_ei = (((FFdTef*d_itf_dV_bi_ei)+(d_FFdTef_dV_bi_ei*itf))/(1+(model_.gtfe)));
        d_FFdQef_dV_tnode_GND = (((FFdTef*d_itf_dV_tnode_GND)+(d_FFdTef_dV_tnode_GND*itf))/(1+(model_.gtfe)));
        FFdQef = ((FFdTef*itf)/(1+(model_.gtfe)));
        if (((model_.icbar)<(0.05*((model_.vlim)/(model_.rci0)))))
        {

          d_FFdVc_dV_tnode_GND = d_FFdVc_dV_bi_ei = d_FFdVc_dV_bi_ci =  0.0;
          FFdVc = 0;

          d_FFdVc_ditf_dV_tnode_GND = d_FFdVc_ditf_dV_bi_ei = d_FFdVc_ditf_dV_bi_ci =  0.0;
          FFdVc_ditf = 0;
        }
        else
        {

          d_FFib_dV_bi_ci = ((d_itf_dV_bi_ci-d_ick_dV_bi_ci)/(model_.icbar));
          d_FFib_dV_bi_ei = ((d_itf_dV_bi_ei-d_ick_dV_bi_ei)/(model_.icbar));
          d_FFib_dV_tnode_GND = ((d_itf_dV_tnode_GND-d_ick_dV_tnode_GND)/(model_.icbar));
          FFib = ((itf-ick)/(model_.icbar));
          if ((FFib<(-1.0e10)))
          {

            d_FFib_dV_tnode_GND = d_FFib_dV_bi_ei = d_FFib_dV_bi_ci =  0.0;
            FFib = (-1.0e10);
          }
          {
            double value_sqrt_0 = sqrt(((FFib*FFib)+(model_.acbar)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_FFfcbar_dV_bi_ci = ((d_FFib_dV_bi_ci+(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_bi_ci)+(d_FFib_dV_bi_ci*FFib)))))/2.0);
            d_FFfcbar_dV_bi_ei = ((d_FFib_dV_bi_ei+(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_bi_ei)+(d_FFib_dV_bi_ei*FFib)))))/2.0);
            d_FFfcbar_dV_tnode_GND = ((d_FFib_dV_tnode_GND+(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_tnode_GND)+(d_FFib_dV_tnode_GND*FFib)))))/2.0);
            FFfcbar = ((FFib+value_sqrt_0)/2.0);
          }
          {
            double value_sqrt_0 = sqrt(((FFib*FFib)+(model_.acbar)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_FFdib_ditf_dV_bi_ci = (((value_sqrt_0*d_FFfcbar_dV_bi_ci-FFfcbar*(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_bi_ci)+(d_FFib_dV_bi_ci*FFib)))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
            d_FFdib_ditf_dV_bi_ei = (((value_sqrt_0*d_FFfcbar_dV_bi_ei-FFfcbar*(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_bi_ei)+(d_FFib_dV_bi_ei*FFib)))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
            d_FFdib_ditf_dV_tnode_GND = (((value_sqrt_0*d_FFfcbar_dV_tnode_GND-FFfcbar*(deriv_sqrt_0_d0*(((FFib*d_FFib_dV_tnode_GND)+(d_FFib_dV_tnode_GND*FFib)))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
            FFdib_ditf = ((FFfcbar/value_sqrt_0)/(model_.icbar));
          }
          {
            double value_exp_0 = exp(((-1.0)/FFfcbar));
            double  deriv_exp_0_d0 = value_exp_0;

            d_FFdVc_dV_bi_ci = ((model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_bi_ci/FFfcbar/FFfcbar))));
            d_FFdVc_dV_bi_ei = ((model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_bi_ei/FFfcbar/FFfcbar))));
            d_FFdVc_dV_tnode_GND = ((model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_tnode_GND/FFfcbar/FFfcbar))));
            FFdVc = ((model_.vcbar)*value_exp_0);
          }

          d_FFdVc_ditf_dV_bi_ci = (((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_bi_ci)+((((FFfcbar*FFfcbar)*d_FFdVc_dV_bi_ci-FFdVc*((FFfcbar*d_FFfcbar_dV_bi_ci)+(d_FFfcbar_dV_bi_ci*FFfcbar)))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf));
          d_FFdVc_ditf_dV_bi_ei = (((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_bi_ei)+((((FFfcbar*FFfcbar)*d_FFdVc_dV_bi_ei-FFdVc*((FFfcbar*d_FFfcbar_dV_bi_ei)+(d_FFfcbar_dV_bi_ei*FFfcbar)))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf));
          d_FFdVc_ditf_dV_tnode_GND = (((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_tnode_GND)+((((FFfcbar*FFfcbar)*d_FFdVc_dV_tnode_GND-FFdVc*((FFfcbar*d_FFfcbar_dV_tnode_GND)+(d_FFfcbar_dV_tnode_GND*FFfcbar)))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf));
          FFdVc_ditf = ((FFdVc/(FFfcbar*FFfcbar))*FFdib_ditf);
        }
        {
          double value_exp_0 = exp((FFdVc/VT));
          double  deriv_exp_0_d0 = value_exp_0;

          d_FFdQbfb_dV_bi_ci = (((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+((((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ci)*(value_exp_0-1)));
          d_FFdQbfb_dV_bi_ei = (((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+((((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ei)*(value_exp_0-1)));
          d_FFdQbfb_dV_tnode_GND = (((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-FFdVc*d_VT_dV_tnode_GND)/VT/VT))))+(((((1-(model_.fthc))*thcs_t)*d_itf_dV_tnode_GND)+(((1-(model_.fthc))*d_thcs_t_dV_tnode_GND)*itf))*(value_exp_0-1)));
          FFdQbfb = ((((1-(model_.fthc))*thcs_t)*itf)*(value_exp_0-1));
        }
        {
          double value_exp_0 = exp((FFdVc/VT));
          double  deriv_exp_0_d0 = value_exp_0;

          d_FFdTbfb_dV_bi_ci = (((itf*d_FFdQbfb_dV_bi_ci-FFdQbfb*d_itf_dV_bi_ci)/itf/itf)+(((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_bi_ci)+(((((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+((((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ci)*value_exp_0))/VT)*FFdVc_ditf)));
          d_FFdTbfb_dV_bi_ei = (((itf*d_FFdQbfb_dV_bi_ei-FFdQbfb*d_itf_dV_bi_ei)/itf/itf)+(((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_bi_ei)+(((((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+((((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ei)*value_exp_0))/VT)*FFdVc_ditf)));
          d_FFdTbfb_dV_tnode_GND = (((itf*d_FFdQbfb_dV_tnode_GND-FFdQbfb*d_itf_dV_tnode_GND)/itf/itf)+(((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_tnode_GND)+(((VT*(((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-FFdVc*d_VT_dV_tnode_GND)/VT/VT))))+(((((1-(model_.fthc))*thcs_t)*d_itf_dV_tnode_GND)+(((1-(model_.fthc))*d_thcs_t_dV_tnode_GND)*itf))*value_exp_0))-((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf)));
          FFdTbfb = ((FFdQbfb/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*FFdVc_ditf));
        }

        d_FFic_dV_bi_ci = (-(-d_FFitf_ick_dV_bi_ci/FFitf_ick/FFitf_ick));
        d_FFic_dV_bi_ei = (-(-d_FFitf_ick_dV_bi_ei/FFitf_ick/FFitf_ick));
        d_FFic_dV_tnode_GND = (-(-d_FFitf_ick_dV_tnode_GND/FFitf_ick/FFitf_ick));
        FFic = (1-(1.0/FFitf_ick));
        {
          double value_sqrt_0 = sqrt(((FFic*FFic)+(model_.ahc)));
          double value_sqrt_1 = sqrt((1+(model_.ahc)));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_FFw_dV_bi_ci = ((d_FFic_dV_bi_ci+(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_bi_ci)+(d_FFic_dV_bi_ci*FFic)))))/(1+value_sqrt_1));
          d_FFw_dV_bi_ei = ((d_FFic_dV_bi_ei+(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_bi_ei)+(d_FFic_dV_bi_ei*FFic)))))/(1+value_sqrt_1));
          d_FFw_dV_tnode_GND = ((d_FFic_dV_tnode_GND+(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_tnode_GND)+(d_FFic_dV_tnode_GND*FFic)))))/(1+value_sqrt_1));
          FFw = ((FFic+value_sqrt_0)/(1+value_sqrt_1));
        }
        {
          double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
          double  deriv_exp_0_d0 = value_exp_0;

          d_FFdQfhc_dV_bi_ci = (((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+(((((thcs_t*itf)*FFw)*d_FFw_dV_bi_ci)+((((thcs_t*itf)*d_FFw_dV_bi_ci)+((thcs_t*d_itf_dV_bi_ci)*FFw))*FFw))*value_exp_0));
          d_FFdQfhc_dV_bi_ei = (((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+(((((thcs_t*itf)*FFw)*d_FFw_dV_bi_ei)+((((thcs_t*itf)*d_FFw_dV_bi_ei)+((thcs_t*d_itf_dV_bi_ei)*FFw))*FFw))*value_exp_0));
          d_FFdQfhc_dV_tnode_GND = (((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((((thcs_t*itf)*FFw)*d_FFw_dV_tnode_GND)+((((thcs_t*itf)*d_FFw_dV_tnode_GND)+(((thcs_t*d_itf_dV_tnode_GND)+(d_thcs_t_dV_tnode_GND*itf))*FFw))*FFw))*value_exp_0));
          FFdQfhc = ((((thcs_t*itf)*FFw)*FFw)*value_exp_0);
        }
        {
          double value_sqrt_0 = sqrt(((FFic*FFic)+(model_.ahc)));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_FFdTfhc_dV_bi_ci = ((FFdQfhc*((((1.0/itf)*(-2.0*((FFitf_ick*(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_bi_ci)+(d_FFic_dV_bi_ci*FFic)))))+(d_FFitf_ick_dV_bi_ci*value_sqrt_0))/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0)))+((-d_itf_dV_bi_ci/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0)))))+((1.0/VT)*d_FFdVc_ditf_dV_bi_ci)))+(d_FFdQfhc_dV_bi_ci*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf))));
          d_FFdTfhc_dV_bi_ei = ((FFdQfhc*((((1.0/itf)*(-2.0*((FFitf_ick*(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_bi_ei)+(d_FFic_dV_bi_ei*FFic)))))+(d_FFitf_ick_dV_bi_ei*value_sqrt_0))/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0)))+((-d_itf_dV_bi_ei/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0)))))+((1.0/VT)*d_FFdVc_ditf_dV_bi_ei)))+(d_FFdQfhc_dV_bi_ei*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf))));
          d_FFdTfhc_dV_tnode_GND = ((FFdQfhc*((((1.0/itf)*(-2.0*((FFitf_ick*(deriv_sqrt_0_d0*(((FFic*d_FFic_dV_tnode_GND)+(d_FFic_dV_tnode_GND*FFic)))))+(d_FFitf_ick_dV_tnode_GND*value_sqrt_0))/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0)))+((-d_itf_dV_tnode_GND/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0)))))+(((1.0/VT)*d_FFdVc_ditf_dV_tnode_GND)+((-d_VT_dV_tnode_GND/VT/VT)*FFdVc_ditf))))+(d_FFdQfhc_dV_tnode_GND*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf))));
          FFdTfhc = (FFdQfhc*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
        }
        if ((((model_.latb)<=0.0)&&((model_.latl)<=0.0)))
        {

          d_FFdQcfc_dV_bi_ci = ((model_.fthc)*d_FFdQfhc_dV_bi_ci);
          d_FFdQcfc_dV_bi_ei = ((model_.fthc)*d_FFdQfhc_dV_bi_ei);
          d_FFdQcfc_dV_tnode_GND = ((model_.fthc)*d_FFdQfhc_dV_tnode_GND);
          FFdQcfc = ((model_.fthc)*FFdQfhc);

          d_FFdTcfc_dV_bi_ci = ((model_.fthc)*d_FFdTfhc_dV_bi_ci);
          d_FFdTcfc_dV_bi_ei = ((model_.fthc)*d_FFdTfhc_dV_bi_ei);
          d_FFdTcfc_dV_tnode_GND = ((model_.fthc)*d_FFdTfhc_dV_tnode_GND);
          FFdTcfc = ((model_.fthc)*FFdTfhc);

          d_FFdQcfcT_dV_bi_ci = d_FFdQcfc_dV_bi_ci;
          d_FFdQcfcT_dV_bi_ei = d_FFdQcfc_dV_bi_ei;
          d_FFdQcfcT_dV_tnode_GND = d_FFdQcfc_dV_tnode_GND;
          FFdQcfcT = FFdQcfc;

          d_FFdTcfcT_dV_bi_ci = d_FFdTcfc_dV_bi_ci;
          d_FFdTcfcT_dV_bi_ei = d_FFdTcfc_dV_bi_ei;
          d_FFdTcfcT_dV_tnode_GND = d_FFdTcfc_dV_tnode_GND;
          FFdTcfcT = FFdTcfc;
        }
        else
        {

          d_FFdQcfc_dV_bi_ci = (((model_.fthc)*thcs_t)*d_itf_dV_bi_ci);
          d_FFdQcfc_dV_bi_ei = (((model_.fthc)*thcs_t)*d_itf_dV_bi_ei);
          d_FFdQcfc_dV_tnode_GND = ((((model_.fthc)*thcs_t)*d_itf_dV_tnode_GND)+(((model_.fthc)*d_thcs_t_dV_tnode_GND)*itf));
          FFdQcfc = (((model_.fthc)*thcs_t)*itf);

          d_FCa_dV_tnode_GND = (-((itf*d_ick_dV_tnode_GND-ick*d_itf_dV_tnode_GND)/itf/itf));
          d_FCa_dV_bi_ci = (-((itf*d_ick_dV_bi_ci-ick*d_itf_dV_bi_ci)/itf/itf));
          d_FCa_dV_bi_ei = (-((itf*d_ick_dV_bi_ei-ick*d_itf_dV_bi_ei)/itf/itf));
          FCa = (1.0-(ick/itf));
          {
            double value_sqrt_0 = sqrt(((FCa*FCa)+(model_.ahc)));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_FCrt_dV_tnode_GND = (deriv_sqrt_0_d0*(((FCa*d_FCa_dV_tnode_GND)+(d_FCa_dV_tnode_GND*FCa))));
            d_FCrt_dV_bi_ci = (deriv_sqrt_0_d0*(((FCa*d_FCa_dV_bi_ci)+(d_FCa_dV_bi_ci*FCa))));
            d_FCrt_dV_bi_ei = (deriv_sqrt_0_d0*(((FCa*d_FCa_dV_bi_ei)+(d_FCa_dV_bi_ei*FCa))));
            FCrt = value_sqrt_0;
          }
          {
            double value_sqrt_0 = sqrt((1.0+(model_.ahc)));

            d_FCa_ck_dV_tnode_GND = (-((d_FCa_dV_tnode_GND+d_FCrt_dV_tnode_GND)/(1.0+value_sqrt_0)));
            d_FCa_ck_dV_bi_ci = (-((d_FCa_dV_bi_ci+d_FCrt_dV_bi_ci)/(1.0+value_sqrt_0)));
            d_FCa_ck_dV_bi_ei = (-((d_FCa_dV_bi_ei+d_FCrt_dV_bi_ei)/(1.0+value_sqrt_0)));
            FCa_ck = (1.0-((FCa+FCrt)/(1.0+value_sqrt_0)));
          }

          d_FCdaick_ditf_dV_tnode_GND = (((FCrt*itf)*(((FCa_ck-1.0)*(-d_FCa_dV_tnode_GND))+(d_FCa_ck_dV_tnode_GND*(1-FCa)))-((FCa_ck-1.0)*(1-FCa))*((FCrt*d_itf_dV_tnode_GND)+(d_FCrt_dV_tnode_GND*itf)))/(FCrt*itf)/(FCrt*itf));
          d_FCdaick_ditf_dV_bi_ci = (((FCrt*itf)*(((FCa_ck-1.0)*(-d_FCa_dV_bi_ci))+(d_FCa_ck_dV_bi_ci*(1-FCa)))-((FCa_ck-1.0)*(1-FCa))*((FCrt*d_itf_dV_bi_ci)+(d_FCrt_dV_bi_ci*itf)))/(FCrt*itf)/(FCrt*itf));
          d_FCdaick_ditf_dV_bi_ei = (((FCrt*itf)*(((FCa_ck-1.0)*(-d_FCa_dV_bi_ei))+(d_FCa_ck_dV_bi_ei*(1-FCa)))-((FCa_ck-1.0)*(1-FCa))*((FCrt*d_itf_dV_bi_ei)+(d_FCrt_dV_bi_ei*itf)))/(FCrt*itf)/(FCrt*itf));
          FCdaick_ditf = (((FCa_ck-1.0)*(1-FCa))/(FCrt*itf));
          if (((model_.latb)>(model_.latl)))
          {

            d_FCz_dV_bi_ei = d_FCz_dV_bi_ci = d_FCz_dV_tnode_GND =  0.0;
            FCz = ((model_.latb)-(model_.latl));
            FCxl = (1.0+(model_.latl));
            FCxb = (1.0+(model_.latb));
            if (((model_.latb)>0.01))
            {
              {
                double value_log_0 = log((FCxb/FCxl));
                FCln = value_log_0;
              }
              {
                double value_exp_0 = exp(((FCa_ck-1.0)*FCln));
                double  deriv_exp_0_d0 = value_exp_0;

                d_FCa1_dV_tnode_GND = (deriv_exp_0_d0*((d_FCa_ck_dV_tnode_GND*FCln)));
                d_FCa1_dV_bi_ci = (deriv_exp_0_d0*((d_FCa_ck_dV_bi_ci*FCln)));
                d_FCa1_dV_bi_ei = (deriv_exp_0_d0*((d_FCa_ck_dV_bi_ei*FCln)));
                FCa1 = value_exp_0;
              }

              d_FCd_a_dV_tnode_GND = (-(-(d_FCa1_dV_tnode_GND*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
              d_FCd_a_dV_bi_ci = (-(-(d_FCa1_dV_bi_ci*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
              d_FCd_a_dV_bi_ei = (-(-(d_FCa1_dV_bi_ei*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
              FCd_a = (1.0/((model_.latl)-(FCa1*(model_.latb))));

              d_FCw_dV_tnode_GND = (((FCa1-1.0)*d_FCd_a_dV_tnode_GND)+(d_FCa1_dV_tnode_GND*FCd_a));
              d_FCw_dV_bi_ci = (((FCa1-1.0)*d_FCd_a_dV_bi_ci)+(d_FCa1_dV_bi_ci*FCd_a));
              d_FCw_dV_bi_ei = (((FCa1-1.0)*d_FCd_a_dV_bi_ei)+(d_FCa1_dV_bi_ei*FCd_a));
              FCw = ((FCa1-1.0)*FCd_a);

              d_FCdw_daick_dV_tnode_GND = ((((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_tnode_GND)+((((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_tnode_GND)+(((((-FCz)*d_FCa1_dV_tnode_GND)+((-d_FCz_dV_tnode_GND)*FCa1))*FCln)*FCd_a))*FCd_a));
              d_FCdw_daick_dV_bi_ci = ((((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_bi_ci)+((((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_bi_ci)+(((((-FCz)*d_FCa1_dV_bi_ci)+((-d_FCz_dV_bi_ci)*FCa1))*FCln)*FCd_a))*FCd_a));
              d_FCdw_daick_dV_bi_ei = ((((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_bi_ei)+((((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_bi_ei)+(((((-FCz)*d_FCa1_dV_bi_ei)+((-d_FCz_dV_bi_ei)*FCa1))*FCln)*FCd_a))*FCd_a));
              FCdw_daick = (((((-FCz)*FCa1)*FCln)*FCd_a)*FCd_a);
              {
                double value_log_0 = log(((1.0+((model_.latb)*FCw))/(1.0+((model_.latl)*FCw))));
                double  deriv_log_0_d0 = (1.0/((1.0+((model_.latb)*FCw))/(1.0+((model_.latl)*FCw))));

                d_FCa1_dV_tnode_GND = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*((model_.latb)*d_FCw_dV_tnode_GND)-(1.0+((model_.latb)*FCw))*((model_.latl)*d_FCw_dV_tnode_GND))/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
                d_FCa1_dV_bi_ci = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*((model_.latb)*d_FCw_dV_bi_ci)-(1.0+((model_.latb)*FCw))*((model_.latl)*d_FCw_dV_bi_ci))/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
                d_FCa1_dV_bi_ei = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*((model_.latb)*d_FCw_dV_bi_ei)-(1.0+((model_.latb)*FCw))*((model_.latl)*d_FCw_dV_bi_ei))/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
                FCa1 = value_log_0;
              }

              d_FCda1_dw_dV_tnode_GND = ((-(model_.latb)*((model_.latb)*d_FCw_dV_tnode_GND)/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*((model_.latl)*d_FCw_dV_tnode_GND)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
              d_FCda1_dw_dV_bi_ci = ((-(model_.latb)*((model_.latb)*d_FCw_dV_bi_ci)/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*((model_.latl)*d_FCw_dV_bi_ci)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
              d_FCda1_dw_dV_bi_ei = ((-(model_.latb)*((model_.latb)*d_FCw_dV_bi_ei)/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*((model_.latl)*d_FCw_dV_bi_ei)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
              FCda1_dw = (((model_.latb)/(1.0+((model_.latb)*FCw)))-((model_.latl)/(1.0+((model_.latl)*FCw))));
            }
            else
            {

              d_FCf1_dV_tnode_GND = (-d_FCa_ck_dV_tnode_GND);
              d_FCf1_dV_bi_ci = (-d_FCa_ck_dV_bi_ci);
              d_FCf1_dV_bi_ei = (-d_FCa_ck_dV_bi_ei);
              FCf1 = (1.0-FCa_ck);

              d_FCd_a_dV_tnode_GND = (-(d_FCa_ck_dV_tnode_GND*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
              d_FCd_a_dV_bi_ci = (-(d_FCa_ck_dV_bi_ci*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
              d_FCd_a_dV_bi_ei = (-(d_FCa_ck_dV_bi_ei*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
              FCd_a = (1.0/(1.0+(FCa_ck*(model_.latb))));

              d_FCw_dV_tnode_GND = ((FCf1*d_FCd_a_dV_tnode_GND)+(d_FCf1_dV_tnode_GND*FCd_a));
              d_FCw_dV_bi_ci = ((FCf1*d_FCd_a_dV_bi_ci)+(d_FCf1_dV_bi_ci*FCd_a));
              d_FCw_dV_bi_ei = ((FCf1*d_FCd_a_dV_bi_ei)+(d_FCf1_dV_bi_ei*FCd_a));
              FCw = (FCf1*FCd_a);

              d_FCdw_daick_dV_tnode_GND = ((((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_tnode_GND)+((((((-1.0)*FCd_a)*d_FCd_a_dV_tnode_GND)+(((-1.0)*d_FCd_a_dV_tnode_GND)*FCd_a))*FCxb)*FCd_a));
              d_FCdw_daick_dV_bi_ci = ((((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_bi_ci)+((((((-1.0)*FCd_a)*d_FCd_a_dV_bi_ci)+(((-1.0)*d_FCd_a_dV_bi_ci)*FCd_a))*FCxb)*FCd_a));
              d_FCdw_daick_dV_bi_ei = ((((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_bi_ei)+((((((-1.0)*FCd_a)*d_FCd_a_dV_bi_ei)+(((-1.0)*d_FCd_a_dV_bi_ei)*FCd_a))*FCxb)*FCd_a));
              FCdw_daick = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*FCd_a);

              d_FCa1_dV_tnode_GND = ((FCz*d_FCw_dV_tnode_GND)+(d_FCz_dV_tnode_GND*FCw));
              d_FCa1_dV_bi_ci = ((FCz*d_FCw_dV_bi_ci)+(d_FCz_dV_bi_ci*FCw));
              d_FCa1_dV_bi_ei = ((FCz*d_FCw_dV_bi_ei)+(d_FCz_dV_bi_ei*FCw));
              FCa1 = (FCz*FCw);

              d_FCda1_dw_dV_tnode_GND = d_FCz_dV_tnode_GND;
              d_FCda1_dw_dV_bi_ci = d_FCz_dV_bi_ci;
              d_FCda1_dw_dV_bi_ei = d_FCz_dV_bi_ei;
              FCda1_dw = FCz;
            }

            d_FCf_CT_dV_tnode_GND = (-2.0*d_FCz_dV_tnode_GND/FCz/FCz);
            d_FCf_CT_dV_bi_ci = (-2.0*d_FCz_dV_bi_ci/FCz/FCz);
            d_FCf_CT_dV_bi_ei = (-2.0*d_FCz_dV_bi_ei/FCz/FCz);
            FCf_CT = (2.0/FCz);

            d_FCw2_dV_tnode_GND = ((FCw*d_FCw_dV_tnode_GND)+(d_FCw_dV_tnode_GND*FCw));
            d_FCw2_dV_bi_ci = ((FCw*d_FCw_dV_bi_ci)+(d_FCw_dV_bi_ci*FCw));
            d_FCw2_dV_bi_ei = ((FCw*d_FCw_dV_bi_ei)+(d_FCw_dV_bi_ei*FCw));
            FCw2 = (FCw*FCw);

            d_FCf1_dV_tnode_GND = ((((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_tnode_GND)+((((model_.latb)*(model_.latl))*d_FCw_dV_tnode_GND)*FCw2))/3.0)+((((model_.latb)+(model_.latl))*d_FCw2_dV_tnode_GND)/2.0))+d_FCw_dV_tnode_GND);
            d_FCf1_dV_bi_ci = ((((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_bi_ci)+((((model_.latb)*(model_.latl))*d_FCw_dV_bi_ci)*FCw2))/3.0)+((((model_.latb)+(model_.latl))*d_FCw2_dV_bi_ci)/2.0))+d_FCw_dV_bi_ci);
            d_FCf1_dV_bi_ei = ((((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_bi_ei)+((((model_.latb)*(model_.latl))*d_FCw_dV_bi_ei)*FCw2))/3.0)+((((model_.latb)+(model_.latl))*d_FCw2_dV_bi_ei)/2.0))+d_FCw_dV_bi_ei);
            FCf1 = (((((((model_.latb)*(model_.latl))*FCw)*FCw2)/3.0)+((((model_.latb)+(model_.latl))*FCw2)/2.0))+FCw);

            d_FCdf1_dw_dV_tnode_GND = ((((model_.latb)*(model_.latl))*d_FCw2_dV_tnode_GND)+(((model_.latb)+(model_.latl))*d_FCw_dV_tnode_GND));
            d_FCdf1_dw_dV_bi_ci = ((((model_.latb)*(model_.latl))*d_FCw2_dV_bi_ci)+(((model_.latb)+(model_.latl))*d_FCw_dV_bi_ci));
            d_FCdf1_dw_dV_bi_ei = ((((model_.latb)*(model_.latl))*d_FCw2_dV_bi_ei)+(((model_.latb)+(model_.latl))*d_FCw_dV_bi_ei));
            FCdf1_dw = (((((model_.latb)*(model_.latl))*FCw2)+(((model_.latb)+(model_.latl))*FCw))+1.0);

            d_z_dV_tnode_GND = ((model_.latb)*d_FCw_dV_tnode_GND);
            d_z_dV_bi_ci = ((model_.latb)*d_FCw_dV_bi_ci);
            d_z_dV_bi_ei = ((model_.latb)*d_FCw_dV_bi_ei);
            z = ((model_.latb)*FCw);
            {
              double value_log_0 = log((1+((model_.latb)*FCw)));
              double  deriv_log_0_d0 = (1.0/(1+((model_.latb)*FCw)));

              d_lnzb_dV_tnode_GND = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_tnode_GND)));
              d_lnzb_dV_bi_ci = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_bi_ci)));
              d_lnzb_dV_bi_ei = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_bi_ei)));
              lnzb = value_log_0;
            }
            if ((z>1.0e-6))
            {

              d_x_dV_tnode_GND = d_z_dV_tnode_GND;
              d_x_dV_bi_ci = d_z_dV_bi_ci;
              d_x_dV_bi_ei = d_z_dV_bi_ei;
              x = (1.0+z);

              d_a_dV_tnode_GND = ((x*d_x_dV_tnode_GND)+(d_x_dV_tnode_GND*x));
              d_a_dV_bi_ci = ((x*d_x_dV_bi_ci)+(d_x_dV_bi_ci*x));
              d_a_dV_bi_ei = ((x*d_x_dV_bi_ei)+(d_x_dV_bi_ei*x));
              a = (x*x);

              d_a2_dV_tnode_GND = (0.250*((a*(2.0*d_lnzb_dV_tnode_GND))+(d_a_dV_tnode_GND*((2.0*lnzb)-1.0))));
              d_a2_dV_bi_ci = (0.250*((a*(2.0*d_lnzb_dV_bi_ci))+(d_a_dV_bi_ci*((2.0*lnzb)-1.0))));
              d_a2_dV_bi_ei = (0.250*((a*(2.0*d_lnzb_dV_bi_ei))+(d_a_dV_bi_ei*((2.0*lnzb)-1.0))));
              a2 = (0.250*((a*((2.0*lnzb)-1.0))+1.0));

              d_a3_dV_tnode_GND = ((((a*x)*(3.0*d_lnzb_dV_tnode_GND))+(((a*d_x_dV_tnode_GND)+(d_a_dV_tnode_GND*x))*((3.0*lnzb)-1.0)))/9.0);
              d_a3_dV_bi_ci = ((((a*x)*(3.0*d_lnzb_dV_bi_ci))+(((a*d_x_dV_bi_ci)+(d_a_dV_bi_ci*x))*((3.0*lnzb)-1.0)))/9.0);
              d_a3_dV_bi_ei = ((((a*x)*(3.0*d_lnzb_dV_bi_ei))+(((a*d_x_dV_bi_ei)+(d_a_dV_bi_ei*x))*((3.0*lnzb)-1.0)))/9.0);
              a3 = ((((a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
              r = ((model_.latl)/(model_.latb));

              d_FCf2_dV_tnode_GND = ((((1.0-r)*d_a2_dV_tnode_GND)+(r*d_a3_dV_tnode_GND))/(model_.latb));
              d_FCf2_dV_bi_ci = ((((1.0-r)*d_a2_dV_bi_ci)+(r*d_a3_dV_bi_ci))/(model_.latb));
              d_FCf2_dV_bi_ei = ((((1.0-r)*d_a2_dV_bi_ei)+(r*d_a3_dV_bi_ei))/(model_.latb));
              FCf2 = ((((1.0-r)*a2)+(r*a3))/(model_.latb));

              d_FCdf2_dw_dV_tnode_GND = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_tnode_GND)+((((1.0-r)*d_x_dV_tnode_GND)+(r*d_a_dV_tnode_GND))*lnzb));
              d_FCdf2_dw_dV_bi_ci = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ci)+((((1.0-r)*d_x_dV_bi_ci)+(r*d_a_dV_bi_ci))*lnzb));
              d_FCdf2_dw_dV_bi_ei = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ei)+((((1.0-r)*d_x_dV_bi_ei)+(r*d_a_dV_bi_ei))*lnzb));
              FCdf2_dw = ((((1.0-r)*x)+(r*a))*lnzb);
            }
            else
            {

              d_a_dV_tnode_GND = ((z*d_z_dV_tnode_GND)+(d_z_dV_tnode_GND*z));
              d_a_dV_bi_ci = ((z*d_z_dV_bi_ci)+(d_z_dV_bi_ci*z));
              d_a_dV_bi_ei = ((z*d_z_dV_bi_ei)+(d_z_dV_bi_ei*z));
              a = (z*z);

              d_a2_dV_tnode_GND = ((d_z_dV_tnode_GND-(0.25*d_a_dV_tnode_GND))+(((0.10*z)*d_a_dV_tnode_GND)+((0.10*d_z_dV_tnode_GND)*a)));
              d_a2_dV_bi_ci = ((d_z_dV_bi_ci-(0.25*d_a_dV_bi_ci))+(((0.10*z)*d_a_dV_bi_ci)+((0.10*d_z_dV_bi_ci)*a)));
              d_a2_dV_bi_ei = ((d_z_dV_bi_ei-(0.25*d_a_dV_bi_ei))+(((0.10*z)*d_a_dV_bi_ei)+((0.10*d_z_dV_bi_ei)*a)));
              a2 = (((3.0+z)-(0.25*a))+((0.10*z)*a));

              d_a3_dV_tnode_GND = (((2.0*d_z_dV_tnode_GND)+(0.75*d_a_dV_tnode_GND))-(((0.20*a)*d_z_dV_tnode_GND)+((0.20*d_a_dV_tnode_GND)*z)));
              d_a3_dV_bi_ci = (((2.0*d_z_dV_bi_ci)+(0.75*d_a_dV_bi_ci))-(((0.20*a)*d_z_dV_bi_ci)+((0.20*d_a_dV_bi_ci)*z)));
              d_a3_dV_bi_ei = (((2.0*d_z_dV_bi_ei)+(0.75*d_a_dV_bi_ei))-(((0.20*a)*d_z_dV_bi_ei)+((0.20*d_a_dV_bi_ei)*z)));
              a3 = (((2.0*z)+(0.75*a))-((0.20*a)*z));

              d_FCf2_dV_tnode_GND = (((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_tnode_GND)+((((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_tnode_GND)+((((model_.latb)*d_a2_dV_tnode_GND)+((model_.latl)*d_a3_dV_tnode_GND))*FCw))*FCw))/6.0);
              d_FCf2_dV_bi_ci = (((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_bi_ci)+((((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_bi_ci)+((((model_.latb)*d_a2_dV_bi_ci)+((model_.latl)*d_a3_dV_bi_ci))*FCw))*FCw))/6.0);
              d_FCf2_dV_bi_ei = (((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_bi_ei)+((((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_bi_ei)+((((model_.latb)*d_a2_dV_bi_ei)+((model_.latl)*d_a3_dV_bi_ei))*FCw))*FCw))/6.0);
              FCf2 = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*FCw)/6.0);

              d_FCdf2_dw_dV_tnode_GND = ((((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_tnode_GND)+((((1+((model_.latl)*FCw))*d_z_dV_tnode_GND)+(((model_.latl)*d_FCw_dV_tnode_GND)*(1+z)))*lnzb));
              d_FCdf2_dw_dV_bi_ci = ((((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_bi_ci)+((((1+((model_.latl)*FCw))*d_z_dV_bi_ci)+(((model_.latl)*d_FCw_dV_bi_ci)*(1+z)))*lnzb));
              d_FCdf2_dw_dV_bi_ei = ((((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_bi_ei)+((((1+((model_.latl)*FCw))*d_z_dV_bi_ei)+(((model_.latl)*d_FCw_dV_bi_ei)*(1+z)))*lnzb));
              FCdf2_dw = (((1+((model_.latl)*FCw))*(1+z))*lnzb);
            }

            d_z_dV_tnode_GND = ((model_.latl)*d_FCw_dV_tnode_GND);
            d_z_dV_bi_ci = ((model_.latl)*d_FCw_dV_bi_ci);
            d_z_dV_bi_ei = ((model_.latl)*d_FCw_dV_bi_ei);
            z = ((model_.latl)*FCw);
            {
              double value_log_0 = log((1+((model_.latl)*FCw)));
              double  deriv_log_0_d0 = (1.0/(1+((model_.latl)*FCw)));

              d_lnzb_dV_tnode_GND = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_tnode_GND)));
              d_lnzb_dV_bi_ci = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_bi_ci)));
              d_lnzb_dV_bi_ei = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_bi_ei)));
              lnzb = value_log_0;
            }
            if ((z>1.0e-6))
            {

              d_x_dV_tnode_GND = d_z_dV_tnode_GND;
              d_x_dV_bi_ci = d_z_dV_bi_ci;
              d_x_dV_bi_ei = d_z_dV_bi_ei;
              x = (1.0+z);

              d_a_dV_tnode_GND = ((x*d_x_dV_tnode_GND)+(d_x_dV_tnode_GND*x));
              d_a_dV_bi_ci = ((x*d_x_dV_bi_ci)+(d_x_dV_bi_ci*x));
              d_a_dV_bi_ei = ((x*d_x_dV_bi_ei)+(d_x_dV_bi_ei*x));
              a = (x*x);

              d_a2_dV_tnode_GND = (0.250*((a*(2.0*d_lnzb_dV_tnode_GND))+(d_a_dV_tnode_GND*((2.0*lnzb)-1.0))));
              d_a2_dV_bi_ci = (0.250*((a*(2.0*d_lnzb_dV_bi_ci))+(d_a_dV_bi_ci*((2.0*lnzb)-1.0))));
              d_a2_dV_bi_ei = (0.250*((a*(2.0*d_lnzb_dV_bi_ei))+(d_a_dV_bi_ei*((2.0*lnzb)-1.0))));
              a2 = (0.250*((a*((2.0*lnzb)-1.0))+1.0));

              d_a3_dV_tnode_GND = ((((a*x)*(3.0*d_lnzb_dV_tnode_GND))+(((a*d_x_dV_tnode_GND)+(d_a_dV_tnode_GND*x))*((3.0*lnzb)-1.0)))/9.0);
              d_a3_dV_bi_ci = ((((a*x)*(3.0*d_lnzb_dV_bi_ci))+(((a*d_x_dV_bi_ci)+(d_a_dV_bi_ci*x))*((3.0*lnzb)-1.0)))/9.0);
              d_a3_dV_bi_ei = ((((a*x)*(3.0*d_lnzb_dV_bi_ei))+(((a*d_x_dV_bi_ei)+(d_a_dV_bi_ei*x))*((3.0*lnzb)-1.0)))/9.0);
              a3 = ((((a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
              r = ((model_.latb)/(model_.latl));

              d_FCf3_dV_tnode_GND = ((((1.0-r)*d_a2_dV_tnode_GND)+(r*d_a3_dV_tnode_GND))/(model_.latl));
              d_FCf3_dV_bi_ci = ((((1.0-r)*d_a2_dV_bi_ci)+(r*d_a3_dV_bi_ci))/(model_.latl));
              d_FCf3_dV_bi_ei = ((((1.0-r)*d_a2_dV_bi_ei)+(r*d_a3_dV_bi_ei))/(model_.latl));
              FCf3 = ((((1.0-r)*a2)+(r*a3))/(model_.latl));

              d_FCdf3_dw_dV_tnode_GND = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_tnode_GND)+((((1.0-r)*d_x_dV_tnode_GND)+(r*d_a_dV_tnode_GND))*lnzb));
              d_FCdf3_dw_dV_bi_ci = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ci)+((((1.0-r)*d_x_dV_bi_ci)+(r*d_a_dV_bi_ci))*lnzb));
              d_FCdf3_dw_dV_bi_ei = (((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ei)+((((1.0-r)*d_x_dV_bi_ei)+(r*d_a_dV_bi_ei))*lnzb));
              FCdf3_dw = ((((1.0-r)*x)+(r*a))*lnzb);
            }
            else
            {

              d_a_dV_tnode_GND = ((z*d_z_dV_tnode_GND)+(d_z_dV_tnode_GND*z));
              d_a_dV_bi_ci = ((z*d_z_dV_bi_ci)+(d_z_dV_bi_ci*z));
              d_a_dV_bi_ei = ((z*d_z_dV_bi_ei)+(d_z_dV_bi_ei*z));
              a = (z*z);

              d_a2_dV_tnode_GND = ((d_z_dV_tnode_GND-(0.25*d_a_dV_tnode_GND))+(((0.10*z)*d_a_dV_tnode_GND)+((0.10*d_z_dV_tnode_GND)*a)));
              d_a2_dV_bi_ci = ((d_z_dV_bi_ci-(0.25*d_a_dV_bi_ci))+(((0.10*z)*d_a_dV_bi_ci)+((0.10*d_z_dV_bi_ci)*a)));
              d_a2_dV_bi_ei = ((d_z_dV_bi_ei-(0.25*d_a_dV_bi_ei))+(((0.10*z)*d_a_dV_bi_ei)+((0.10*d_z_dV_bi_ei)*a)));
              a2 = (((3.0+z)-(0.25*a))+((0.10*z)*a));

              d_a3_dV_tnode_GND = (((2.0*d_z_dV_tnode_GND)+(0.75*d_a_dV_tnode_GND))-(((0.20*a)*d_z_dV_tnode_GND)+((0.20*d_a_dV_tnode_GND)*z)));
              d_a3_dV_bi_ci = (((2.0*d_z_dV_bi_ci)+(0.75*d_a_dV_bi_ci))-(((0.20*a)*d_z_dV_bi_ci)+((0.20*d_a_dV_bi_ci)*z)));
              d_a3_dV_bi_ei = (((2.0*d_z_dV_bi_ei)+(0.75*d_a_dV_bi_ei))-(((0.20*a)*d_z_dV_bi_ei)+((0.20*d_a_dV_bi_ei)*z)));
              a3 = (((2.0*z)+(0.75*a))-((0.20*a)*z));

              d_FCf3_dV_tnode_GND = (((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_tnode_GND)+((((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_tnode_GND)+((((model_.latl)*d_a2_dV_tnode_GND)+((model_.latb)*d_a3_dV_tnode_GND))*FCw))*FCw))/6.0);
              d_FCf3_dV_bi_ci = (((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_bi_ci)+((((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_bi_ci)+((((model_.latl)*d_a2_dV_bi_ci)+((model_.latb)*d_a3_dV_bi_ci))*FCw))*FCw))/6.0);
              d_FCf3_dV_bi_ei = (((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_bi_ei)+((((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_bi_ei)+((((model_.latl)*d_a2_dV_bi_ei)+((model_.latb)*d_a3_dV_bi_ei))*FCw))*FCw))/6.0);
              FCf3 = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*FCw)/6.0);

              d_FCdf3_dw_dV_tnode_GND = ((((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_tnode_GND)+((((1+((model_.latb)*FCw))*d_z_dV_tnode_GND)+(((model_.latb)*d_FCw_dV_tnode_GND)*(1+z)))*lnzb));
              d_FCdf3_dw_dV_bi_ci = ((((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_bi_ci)+((((1+((model_.latb)*FCw))*d_z_dV_bi_ci)+(((model_.latb)*d_FCw_dV_bi_ci)*(1+z)))*lnzb));
              d_FCdf3_dw_dV_bi_ei = ((((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_bi_ei)+((((1+((model_.latb)*FCw))*d_z_dV_bi_ei)+(((model_.latb)*d_FCw_dV_bi_ei)*(1+z)))*lnzb));
              FCdf3_dw = (((1+((model_.latb)*FCw))*(1+z))*lnzb);
            }

            d_FCf_ci_dV_tnode_GND = ((FCf_CT*((((FCa1*d_FCf1_dV_tnode_GND)+(d_FCa1_dV_tnode_GND*FCf1))-d_FCf2_dV_tnode_GND)+d_FCf3_dV_tnode_GND))+(d_FCf_CT_dV_tnode_GND*(((FCa1*FCf1)-FCf2)+FCf3)));
            d_FCf_ci_dV_bi_ci = ((FCf_CT*((((FCa1*d_FCf1_dV_bi_ci)+(d_FCa1_dV_bi_ci*FCf1))-d_FCf2_dV_bi_ci)+d_FCf3_dV_bi_ci))+(d_FCf_CT_dV_bi_ci*(((FCa1*FCf1)-FCf2)+FCf3)));
            d_FCf_ci_dV_bi_ei = ((FCf_CT*((((FCa1*d_FCf1_dV_bi_ei)+(d_FCa1_dV_bi_ei*FCf1))-d_FCf2_dV_bi_ei)+d_FCf3_dV_bi_ei))+(d_FCf_CT_dV_bi_ei*(((FCa1*FCf1)-FCf2)+FCf3)));
            FCf_ci = (FCf_CT*(((FCa1*FCf1)-FCf2)+FCf3));

            d_FCdfc_dw_dV_tnode_GND = ((FCf_CT*(((((FCa1*d_FCdf1_dw_dV_tnode_GND)+(d_FCa1_dV_tnode_GND*FCdf1_dw))+((FCda1_dw*d_FCf1_dV_tnode_GND)+(d_FCda1_dw_dV_tnode_GND*FCf1)))-d_FCdf2_dw_dV_tnode_GND)+d_FCdf3_dw_dV_tnode_GND))+(d_FCf_CT_dV_tnode_GND*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw)));
            d_FCdfc_dw_dV_bi_ci = ((FCf_CT*(((((FCa1*d_FCdf1_dw_dV_bi_ci)+(d_FCa1_dV_bi_ci*FCdf1_dw))+((FCda1_dw*d_FCf1_dV_bi_ci)+(d_FCda1_dw_dV_bi_ci*FCf1)))-d_FCdf2_dw_dV_bi_ci)+d_FCdf3_dw_dV_bi_ci))+(d_FCf_CT_dV_bi_ci*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw)));
            d_FCdfc_dw_dV_bi_ei = ((FCf_CT*(((((FCa1*d_FCdf1_dw_dV_bi_ei)+(d_FCa1_dV_bi_ei*FCdf1_dw))+((FCda1_dw*d_FCf1_dV_bi_ei)+(d_FCda1_dw_dV_bi_ei*FCf1)))-d_FCdf2_dw_dV_bi_ei)+d_FCdf3_dw_dV_bi_ei))+(d_FCf_CT_dV_bi_ei*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw)));
            FCdfc_dw = (FCf_CT*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));

            d_FCdw_ditf_dV_tnode_GND = ((FCdw_daick*d_FCdaick_ditf_dV_tnode_GND)+(d_FCdw_daick_dV_tnode_GND*FCdaick_ditf));
            d_FCdw_ditf_dV_bi_ci = ((FCdw_daick*d_FCdaick_ditf_dV_bi_ci)+(d_FCdw_daick_dV_bi_ci*FCdaick_ditf));
            d_FCdw_ditf_dV_bi_ei = ((FCdw_daick*d_FCdaick_ditf_dV_bi_ei)+(d_FCdw_daick_dV_bi_ei*FCdaick_ditf));
            FCdw_ditf = (FCdw_daick*FCdaick_ditf);

            d_FCdfc_ditf_dV_tnode_GND = ((FCdfc_dw*d_FCdw_ditf_dV_tnode_GND)+(d_FCdfc_dw_dV_tnode_GND*FCdw_ditf));
            d_FCdfc_ditf_dV_bi_ci = ((FCdfc_dw*d_FCdw_ditf_dV_bi_ci)+(d_FCdfc_dw_dV_bi_ci*FCdw_ditf));
            d_FCdfc_ditf_dV_bi_ei = ((FCdfc_dw*d_FCdw_ditf_dV_bi_ei)+(d_FCdfc_dw_dV_bi_ei*FCdw_ditf));
            FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
            if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
            {

              d_a_dV_tnode_GND = ((model_.latb)*d_FCw_dV_tnode_GND);
              d_a_dV_bi_ci = ((model_.latb)*d_FCw_dV_bi_ci);
              d_a_dV_bi_ei = ((model_.latb)*d_FCw_dV_bi_ei);
              a = ((model_.latb)*FCw);
              {
                double value_log_0 = log((1+((model_.latb)*FCw)));
                double  deriv_log_0_d0 = (1.0/(1+((model_.latb)*FCw)));

                d_lnz_dV_tnode_GND = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_tnode_GND)));
                d_lnz_dV_bi_ci = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_bi_ci)));
                d_lnz_dV_bi_ei = (deriv_log_0_d0*(((model_.latb)*d_FCw_dV_bi_ei)));
                lnz = value_log_0;
              }
              if ((a>1.0e-6))
              {

                d_FCf2_dV_tnode_GND = ((d_a_dV_tnode_GND-d_lnz_dV_tnode_GND)/(model_.latb));
                d_FCf2_dV_bi_ci = ((d_a_dV_bi_ci-d_lnz_dV_bi_ci)/(model_.latb));
                d_FCf2_dV_bi_ei = ((d_a_dV_bi_ei-d_lnz_dV_bi_ei)/(model_.latb));
                FCf2 = ((a-lnz)/(model_.latb));

                d_FCdf2_dw_dV_tnode_GND = (((1.0+a)*d_a_dV_tnode_GND-a*d_a_dV_tnode_GND)/(1.0+a)/(1.0+a));
                d_FCdf2_dw_dV_bi_ci = (((1.0+a)*d_a_dV_bi_ci-a*d_a_dV_bi_ci)/(1.0+a)/(1.0+a));
                d_FCdf2_dw_dV_bi_ei = (((1.0+a)*d_a_dV_bi_ei-a*d_a_dV_bi_ei)/(1.0+a)/(1.0+a));
                FCdf2_dw = (a/(1.0+a));
              }
              else
              {

                d_FCf2_dV_tnode_GND = (((0.5*a)*d_FCw_dV_tnode_GND)+((0.5*d_a_dV_tnode_GND)*FCw));
                d_FCf2_dV_bi_ci = (((0.5*a)*d_FCw_dV_bi_ci)+((0.5*d_a_dV_bi_ci)*FCw));
                d_FCf2_dV_bi_ei = (((0.5*a)*d_FCw_dV_bi_ei)+((0.5*d_a_dV_bi_ei)*FCw));
                FCf2 = ((0.5*a)*FCw);

                d_FCdf2_dw_dV_tnode_GND = d_a_dV_tnode_GND;
                d_FCdf2_dw_dV_bi_ci = d_a_dV_bi_ci;
                d_FCdf2_dw_dV_bi_ei = d_a_dV_bi_ei;
                FCdf2_dw = a;
              }

              d_a_dV_tnode_GND = ((model_.latl)*d_FCw_dV_tnode_GND);
              d_a_dV_bi_ci = ((model_.latl)*d_FCw_dV_bi_ci);
              d_a_dV_bi_ei = ((model_.latl)*d_FCw_dV_bi_ei);
              a = ((model_.latl)*FCw);
              {
                double value_log_0 = log((1+((model_.latl)*FCw)));
                double  deriv_log_0_d0 = (1.0/(1+((model_.latl)*FCw)));

                d_lnz_dV_tnode_GND = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_tnode_GND)));
                d_lnz_dV_bi_ci = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_bi_ci)));
                d_lnz_dV_bi_ei = (deriv_log_0_d0*(((model_.latl)*d_FCw_dV_bi_ei)));
                lnz = value_log_0;
              }
              if ((a>1.0e-6))
              {

                d_FCf3_dV_tnode_GND = ((d_a_dV_tnode_GND-d_lnz_dV_tnode_GND)/(model_.latl));
                d_FCf3_dV_bi_ci = ((d_a_dV_bi_ci-d_lnz_dV_bi_ci)/(model_.latl));
                d_FCf3_dV_bi_ei = ((d_a_dV_bi_ei-d_lnz_dV_bi_ei)/(model_.latl));
                FCf3 = ((a-lnz)/(model_.latl));

                d_FCdf3_dw_dV_tnode_GND = (((1.0+a)*d_a_dV_tnode_GND-a*d_a_dV_tnode_GND)/(1.0+a)/(1.0+a));
                d_FCdf3_dw_dV_bi_ci = (((1.0+a)*d_a_dV_bi_ci-a*d_a_dV_bi_ci)/(1.0+a)/(1.0+a));
                d_FCdf3_dw_dV_bi_ei = (((1.0+a)*d_a_dV_bi_ei-a*d_a_dV_bi_ei)/(1.0+a)/(1.0+a));
                FCdf3_dw = (a/(1.0+a));
              }
              else
              {

                d_FCf3_dV_tnode_GND = (((0.5*a)*d_FCw_dV_tnode_GND)+((0.5*d_a_dV_tnode_GND)*FCw));
                d_FCf3_dV_bi_ci = (((0.5*a)*d_FCw_dV_bi_ci)+((0.5*d_a_dV_bi_ci)*FCw));
                d_FCf3_dV_bi_ei = (((0.5*a)*d_FCw_dV_bi_ei)+((0.5*d_a_dV_bi_ei)*FCw));
                FCf3 = ((0.5*a)*FCw);

                d_FCdf3_dw_dV_tnode_GND = d_a_dV_tnode_GND;
                d_FCdf3_dw_dV_bi_ci = d_a_dV_bi_ci;
                d_FCdf3_dw_dV_bi_ei = d_a_dV_bi_ei;
                FCdf3_dw = a;
              }

              d_FCf_CT_dV_tnode_GND = ((FCf_CT*(d_FCf2_dV_tnode_GND-d_FCf3_dV_tnode_GND))+(d_FCf_CT_dV_tnode_GND*(FCf2-FCf3)));
              d_FCf_CT_dV_bi_ci = ((FCf_CT*(d_FCf2_dV_bi_ci-d_FCf3_dV_bi_ci))+(d_FCf_CT_dV_bi_ci*(FCf2-FCf3)));
              d_FCf_CT_dV_bi_ei = ((FCf_CT*(d_FCf2_dV_bi_ei-d_FCf3_dV_bi_ei))+(d_FCf_CT_dV_bi_ei*(FCf2-FCf3)));
              FCf_CT = (FCf_CT*(FCf2-FCf3));

              d_FCdfCT_dw_dV_tnode_GND = ((FCf_CT*(d_FCdf2_dw_dV_tnode_GND-d_FCdf3_dw_dV_tnode_GND))+(d_FCf_CT_dV_tnode_GND*(FCdf2_dw-FCdf3_dw)));
              d_FCdfCT_dw_dV_bi_ci = ((FCf_CT*(d_FCdf2_dw_dV_bi_ci-d_FCdf3_dw_dV_bi_ci))+(d_FCf_CT_dV_bi_ci*(FCdf2_dw-FCdf3_dw)));
              d_FCdfCT_dw_dV_bi_ei = ((FCf_CT*(d_FCdf2_dw_dV_bi_ei-d_FCdf3_dw_dV_bi_ei))+(d_FCf_CT_dV_bi_ei*(FCdf2_dw-FCdf3_dw)));
              FCdfCT_dw = (FCf_CT*(FCdf2_dw-FCdf3_dw));

              d_FCdfCT_ditf_dV_tnode_GND = ((FCdfCT_dw*d_FCdw_ditf_dV_tnode_GND)+(d_FCdfCT_dw_dV_tnode_GND*FCdw_ditf));
              d_FCdfCT_ditf_dV_bi_ci = ((FCdfCT_dw*d_FCdw_ditf_dV_bi_ci)+(d_FCdfCT_dw_dV_bi_ci*FCdw_ditf));
              d_FCdfCT_ditf_dV_bi_ei = ((FCdfCT_dw*d_FCdw_ditf_dV_bi_ei)+(d_FCdfCT_dw_dV_bi_ei*FCdw_ditf));
              FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
            }
            else
            {

              d_FCf_CT_dV_tnode_GND = d_FCf_ci_dV_tnode_GND;
              d_FCf_CT_dV_bi_ci = d_FCf_ci_dV_bi_ci;
              d_FCf_CT_dV_bi_ei = d_FCf_ci_dV_bi_ei;
              FCf_CT = FCf_ci;

              d_FCdfCT_ditf_dV_tnode_GND = d_FCdfc_ditf_dV_tnode_GND;
              d_FCdfCT_ditf_dV_bi_ci = d_FCdfc_ditf_dV_bi_ci;
              d_FCdfCT_ditf_dV_bi_ei = d_FCdfc_ditf_dV_bi_ei;
              FCdfCT_ditf = FCdfc_ditf;
            }
          }
          else
          {
            if (((model_.latb)>0.01))
            {

              d_FCd_a_dV_tnode_GND = (-(d_FCa_ck_dV_tnode_GND*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
              d_FCd_a_dV_bi_ci = (-(d_FCa_ck_dV_bi_ci*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
              d_FCd_a_dV_bi_ei = (-(d_FCa_ck_dV_bi_ei*(model_.latb))/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
              FCd_a = (1.0/(1.0+(FCa_ck*(model_.latb))));

              d_FCw_dV_tnode_GND = (((1.0-FCa_ck)*d_FCd_a_dV_tnode_GND)+((-d_FCa_ck_dV_tnode_GND)*FCd_a));
              d_FCw_dV_bi_ci = (((1.0-FCa_ck)*d_FCd_a_dV_bi_ci)+((-d_FCa_ck_dV_bi_ci)*FCd_a));
              d_FCw_dV_bi_ei = (((1.0-FCa_ck)*d_FCd_a_dV_bi_ei)+((-d_FCa_ck_dV_bi_ei)*FCd_a));
              FCw = ((1.0-FCa_ck)*FCd_a);

              d_FCdw_daick_dV_tnode_GND = ((((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_tnode_GND)+(((-(1.0+(model_.latb)))*d_FCd_a_dV_tnode_GND)*FCd_a));
              d_FCdw_daick_dV_bi_ci = ((((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_bi_ci)+(((-(1.0+(model_.latb)))*d_FCd_a_dV_bi_ci)*FCd_a));
              d_FCdw_daick_dV_bi_ei = ((((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_bi_ei)+(((-(1.0+(model_.latb)))*d_FCd_a_dV_bi_ei)*FCd_a));
              FCdw_daick = (((-(1.0+(model_.latb)))*FCd_a)*FCd_a);
            }
            else
            {

              d_FCw_dV_tnode_GND = ((-d_FCa_ck_dV_tnode_GND)-(d_FCa_ck_dV_tnode_GND*(model_.latb)));
              d_FCw_dV_bi_ci = ((-d_FCa_ck_dV_bi_ci)-(d_FCa_ck_dV_bi_ci*(model_.latb)));
              d_FCw_dV_bi_ei = ((-d_FCa_ck_dV_bi_ei)-(d_FCa_ck_dV_bi_ei*(model_.latb)));
              FCw = ((1.0-FCa_ck)-(FCa_ck*(model_.latb)));

              d_FCdw_daick_dV_bi_ei = d_FCdw_daick_dV_bi_ci = d_FCdw_daick_dV_tnode_GND =  0.0;
              FCdw_daick = (-(1.0+(model_.latb)));
            }

            d_FCw2_dV_tnode_GND = ((FCw*d_FCw_dV_tnode_GND)+(d_FCw_dV_tnode_GND*FCw));
            d_FCw2_dV_bi_ci = ((FCw*d_FCw_dV_bi_ci)+(d_FCw_dV_bi_ci*FCw));
            d_FCw2_dV_bi_ei = ((FCw*d_FCw_dV_bi_ei)+(d_FCw_dV_bi_ei*FCw));
            FCw2 = (FCw*FCw);

            d_FCz_dV_tnode_GND = ((model_.latb)*d_FCw_dV_tnode_GND);
            d_FCz_dV_bi_ci = ((model_.latb)*d_FCw_dV_bi_ci);
            d_FCz_dV_bi_ei = ((model_.latb)*d_FCw_dV_bi_ei);
            FCz = ((model_.latb)*FCw);

            d_FCz_1_dV_tnode_GND = d_FCz_dV_tnode_GND;
            d_FCz_1_dV_bi_ci = d_FCz_dV_bi_ci;
            d_FCz_1_dV_bi_ei = d_FCz_dV_bi_ei;
            FCz_1 = (1.0+FCz);

            d_FCd_f_dV_tnode_GND = (-d_FCz_1_dV_tnode_GND/FCz_1/FCz_1);
            d_FCd_f_dV_bi_ci = (-d_FCz_1_dV_bi_ci/FCz_1/FCz_1);
            d_FCd_f_dV_bi_ei = (-d_FCz_1_dV_bi_ei/FCz_1/FCz_1);
            FCd_f = (1.0/FCz_1);

            d_FCf_ci_dV_tnode_GND = (((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_tnode_GND)+(((FCw2*(d_FCz_dV_tnode_GND/3.0))+(d_FCw2_dV_tnode_GND*(1.0+(FCz/3.0))))*FCd_f));
            d_FCf_ci_dV_bi_ci = (((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_bi_ci)+(((FCw2*(d_FCz_dV_bi_ci/3.0))+(d_FCw2_dV_bi_ci*(1.0+(FCz/3.0))))*FCd_f));
            d_FCf_ci_dV_bi_ei = (((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_bi_ei)+(((FCw2*(d_FCz_dV_bi_ei/3.0))+(d_FCw2_dV_bi_ei*(1.0+(FCz/3.0))))*FCd_f));
            FCf_ci = ((FCw2*(1.0+(FCz/3.0)))*FCd_f);

            d_FCdfc_dw_dV_tnode_GND = (((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_tnode_GND)+(((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_tnode_GND)+((((2.0*FCw)*(d_FCz_1_dV_tnode_GND+(((FCz*d_FCz_dV_tnode_GND)+(d_FCz_dV_tnode_GND*FCz))/3.0)))+((2.0*d_FCw_dV_tnode_GND)*(FCz_1+((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
            d_FCdfc_dw_dV_bi_ci = (((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ci)+(((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ci)+((((2.0*FCw)*(d_FCz_1_dV_bi_ci+(((FCz*d_FCz_dV_bi_ci)+(d_FCz_dV_bi_ci*FCz))/3.0)))+((2.0*d_FCw_dV_bi_ci)*(FCz_1+((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
            d_FCdfc_dw_dV_bi_ei = (((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ei)+(((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ei)+((((2.0*FCw)*(d_FCz_1_dV_bi_ei+(((FCz*d_FCz_dV_bi_ei)+(d_FCz_dV_bi_ei*FCz))/3.0)))+((2.0*d_FCw_dV_bi_ei)*(FCz_1+((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
            FCdfc_dw = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);

            d_FCdw_ditf_dV_tnode_GND = ((FCdw_daick*d_FCdaick_ditf_dV_tnode_GND)+(d_FCdw_daick_dV_tnode_GND*FCdaick_ditf));
            d_FCdw_ditf_dV_bi_ci = ((FCdw_daick*d_FCdaick_ditf_dV_bi_ci)+(d_FCdw_daick_dV_bi_ci*FCdaick_ditf));
            d_FCdw_ditf_dV_bi_ei = ((FCdw_daick*d_FCdaick_ditf_dV_bi_ei)+(d_FCdw_daick_dV_bi_ei*FCdaick_ditf));
            FCdw_ditf = (FCdw_daick*FCdaick_ditf);

            d_FCdfc_ditf_dV_tnode_GND = ((FCdfc_dw*d_FCdw_ditf_dV_tnode_GND)+(d_FCdfc_dw_dV_tnode_GND*FCdw_ditf));
            d_FCdfc_ditf_dV_bi_ci = ((FCdfc_dw*d_FCdw_ditf_dV_bi_ci)+(d_FCdfc_dw_dV_bi_ci*FCdw_ditf));
            d_FCdfc_ditf_dV_bi_ei = ((FCdfc_dw*d_FCdw_ditf_dV_bi_ei)+(d_FCdfc_dw_dV_bi_ei*FCdw_ditf));
            FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
            if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
            {
              if ((FCz>0.001))
              {
                {
                  double value_log_0 = log(FCz_1);
                  double  deriv_log_0_d0 = (1.0/FCz_1);

                  d_FCf_CT_dV_tnode_GND = (((((model_.latb)*(model_.latb))*FCz_1)*(2.0*(((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_tnode_GND)))+(d_FCz_1_dV_tnode_GND*value_log_0))-d_FCz_dV_tnode_GND))-(2.0*((FCz_1*value_log_0)-FCz))*(((model_.latb)*(model_.latb))*d_FCz_1_dV_tnode_GND))/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
                  d_FCf_CT_dV_bi_ci = (((((model_.latb)*(model_.latb))*FCz_1)*(2.0*(((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_bi_ci)))+(d_FCz_1_dV_bi_ci*value_log_0))-d_FCz_dV_bi_ci))-(2.0*((FCz_1*value_log_0)-FCz))*(((model_.latb)*(model_.latb))*d_FCz_1_dV_bi_ci))/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
                  d_FCf_CT_dV_bi_ei = (((((model_.latb)*(model_.latb))*FCz_1)*(2.0*(((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_bi_ei)))+(d_FCz_1_dV_bi_ei*value_log_0))-d_FCz_dV_bi_ei))-(2.0*((FCz_1*value_log_0)-FCz))*(((model_.latb)*(model_.latb))*d_FCz_1_dV_bi_ei))/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
                  FCf_CT = ((2.0*((FCz_1*value_log_0)-FCz))/(((model_.latb)*(model_.latb))*FCz_1));
                }

                d_FCdfCT_dw_dV_tnode_GND = ((((2.0*FCw)*FCd_f)*d_FCd_f_dV_tnode_GND)+((((2.0*FCw)*d_FCd_f_dV_tnode_GND)+((2.0*d_FCw_dV_tnode_GND)*FCd_f))*FCd_f));
                d_FCdfCT_dw_dV_bi_ci = ((((2.0*FCw)*FCd_f)*d_FCd_f_dV_bi_ci)+((((2.0*FCw)*d_FCd_f_dV_bi_ci)+((2.0*d_FCw_dV_bi_ci)*FCd_f))*FCd_f));
                d_FCdfCT_dw_dV_bi_ei = ((((2.0*FCw)*FCd_f)*d_FCd_f_dV_bi_ei)+((((2.0*FCw)*d_FCd_f_dV_bi_ei)+((2.0*d_FCw_dV_bi_ei)*FCd_f))*FCd_f));
                FCdfCT_dw = (((2.0*FCw)*FCd_f)*FCd_f);
              }
              else
              {

                d_FCf_CT_dV_tnode_GND = (((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_tnode_GND)+(((FCw2*(-(d_FCz_dV_tnode_GND/3.0)))+(d_FCw2_dV_tnode_GND*(1.0-(FCz/3.0))))*FCd_f));
                d_FCf_CT_dV_bi_ci = (((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_bi_ci)+(((FCw2*(-(d_FCz_dV_bi_ci/3.0)))+(d_FCw2_dV_bi_ci*(1.0-(FCz/3.0))))*FCd_f));
                d_FCf_CT_dV_bi_ei = (((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_bi_ei)+(((FCw2*(-(d_FCz_dV_bi_ei/3.0)))+(d_FCw2_dV_bi_ei*(1.0-(FCz/3.0))))*FCd_f));
                FCf_CT = ((FCw2*(1.0-(FCz/3.0)))*FCd_f);

                d_FCdfCT_dw_dV_tnode_GND = (((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_tnode_GND)+(((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_tnode_GND)+((((2.0*FCw)*(-(((FCz*d_FCz_dV_tnode_GND)+(d_FCz_dV_tnode_GND*FCz))/3.0)))+((2.0*d_FCw_dV_tnode_GND)*(1.0-((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
                d_FCdfCT_dw_dV_bi_ci = (((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ci)+(((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ci)+((((2.0*FCw)*(-(((FCz*d_FCz_dV_bi_ci)+(d_FCz_dV_bi_ci*FCz))/3.0)))+((2.0*d_FCw_dV_bi_ci)*(1.0-((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
                d_FCdfCT_dw_dV_bi_ei = (((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ei)+(((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ei)+((((2.0*FCw)*(-(((FCz*d_FCz_dV_bi_ei)+(d_FCz_dV_bi_ei*FCz))/3.0)))+((2.0*d_FCw_dV_bi_ei)*(1.0-((FCz*FCz)/3.0))))*FCd_f))*FCd_f));
                FCdfCT_dw = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
              }

              d_FCdfCT_ditf_dV_tnode_GND = ((FCdfCT_dw*d_FCdw_ditf_dV_tnode_GND)+(d_FCdfCT_dw_dV_tnode_GND*FCdw_ditf));
              d_FCdfCT_ditf_dV_bi_ci = ((FCdfCT_dw*d_FCdw_ditf_dV_bi_ci)+(d_FCdfCT_dw_dV_bi_ci*FCdw_ditf));
              d_FCdfCT_ditf_dV_bi_ei = ((FCdfCT_dw*d_FCdw_ditf_dV_bi_ei)+(d_FCdfCT_dw_dV_bi_ei*FCdw_ditf));
              FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
            }
            else
            {

              d_FCf_CT_dV_tnode_GND = d_FCf_ci_dV_tnode_GND;
              d_FCf_CT_dV_bi_ci = d_FCf_ci_dV_bi_ci;
              d_FCf_CT_dV_bi_ei = d_FCf_ci_dV_bi_ei;
              FCf_CT = FCf_ci;

              d_FCdfCT_ditf_dV_tnode_GND = d_FCdfc_ditf_dV_tnode_GND;
              d_FCdfCT_ditf_dV_bi_ci = d_FCdfc_ditf_dV_bi_ci;
              d_FCdfCT_ditf_dV_bi_ei = d_FCdfc_ditf_dV_bi_ei;
              FCdfCT_ditf = FCdfc_ditf;
            }
          }
          {
            double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
            double  deriv_exp_0_d0 = value_exp_0;

            d_FFdQcfcT_dV_bi_ci = (((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+(((FFdQcfc*d_FCf_CT_dV_bi_ci)+(d_FFdQcfc_dV_bi_ci*FCf_CT))*value_exp_0));
            d_FFdQcfcT_dV_bi_ei = (((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+(((FFdQcfc*d_FCf_CT_dV_bi_ei)+(d_FFdQcfc_dV_bi_ei*FCf_CT))*value_exp_0));
            d_FFdQcfcT_dV_tnode_GND = (((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((FFdQcfc*d_FCf_CT_dV_tnode_GND)+(d_FFdQcfc_dV_tnode_GND*FCf_CT))*value_exp_0));
            FFdQcfcT = ((FFdQcfc*FCf_CT)*value_exp_0);
          }
          {
            double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
            double  deriv_exp_0_d0 = value_exp_0;

            d_FFdQcfc_dV_bi_ci = (((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))+(((FFdQcfc*d_FCf_ci_dV_bi_ci)+(d_FFdQcfc_dV_bi_ci*FCf_ci))*value_exp_0));
            d_FFdQcfc_dV_bi_ei = (((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))+(((FFdQcfc*d_FCf_ci_dV_bi_ei)+(d_FFdQcfc_dV_bi_ei*FCf_ci))*value_exp_0));
            d_FFdQcfc_dV_tnode_GND = (((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((FFdQcfc*d_FCf_ci_dV_tnode_GND)+(d_FFdQcfc_dV_tnode_GND*FCf_ci))*value_exp_0));
            FFdQcfc = ((FFdQcfc*FCf_ci)*value_exp_0);
          }
          {
            double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
            double  deriv_exp_0_d0 = value_exp_0;

            d_FFdTcfc_dV_bi_ci = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_bi_ci+((itf*d_FCdfc_ditf_dV_bi_ci)+(d_itf_dV_bi_ci*FCdfc_ditf))))+((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))*(FCf_ci+(itf*FCdfc_ditf))))+(((FFdQcfc/VT)*d_FFdVc_ditf_dV_bi_ci)+((d_FFdQcfc_dV_bi_ci/VT)*FFdVc_ditf)));
            d_FFdTcfc_dV_bi_ei = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_bi_ei+((itf*d_FCdfc_ditf_dV_bi_ei)+(d_itf_dV_bi_ei*FCdfc_ditf))))+((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))*(FCf_ci+(itf*FCdfc_ditf))))+(((FFdQcfc/VT)*d_FFdVc_ditf_dV_bi_ei)+((d_FFdQcfc_dV_bi_ei/VT)*FFdVc_ditf)));
            d_FFdTcfc_dV_tnode_GND = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_tnode_GND+((itf*d_FCdfc_ditf_dV_tnode_GND)+(d_itf_dV_tnode_GND*FCdfc_ditf))))+(((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((model_.fthc)*d_thcs_t_dV_tnode_GND)*value_exp_0))*(FCf_ci+(itf*FCdfc_ditf))))+(((FFdQcfc/VT)*d_FFdVc_ditf_dV_tnode_GND)+(((VT*d_FFdQcfc_dV_tnode_GND-FFdQcfc*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf)));
            FFdTcfc = (((((model_.fthc)*thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*FFdVc_ditf));
          }
          {
            double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
            double  deriv_exp_0_d0 = value_exp_0;

            d_FFdTcfcT_dV_bi_ci = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_bi_ci+((itf*d_FCdfCT_ditf_dV_bi_ci)+(d_itf_dV_bi_ci*FCdfCT_ditf))))+((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT))))*(FCf_CT+(itf*FCdfCT_ditf))))+(((FFdQcfcT/VT)*d_FFdVc_ditf_dV_bi_ci)+((d_FFdQcfcT_dV_bi_ci/VT)*FFdVc_ditf)));
            d_FFdTcfcT_dV_bi_ei = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_bi_ei+((itf*d_FCdfCT_ditf_dV_bi_ei)+(d_itf_dV_bi_ei*FCdfCT_ditf))))+((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT))))*(FCf_CT+(itf*FCdfCT_ditf))))+(((FFdQcfcT/VT)*d_FFdVc_ditf_dV_bi_ei)+((d_FFdQcfcT_dV_bi_ei/VT)*FFdVc_ditf)));
            d_FFdTcfcT_dV_tnode_GND = ((((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_tnode_GND+((itf*d_FCdfCT_ditf_dV_tnode_GND)+(d_itf_dV_tnode_GND*FCdfCT_ditf))))+(((((model_.fthc)*thcs_t)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT))))+(((model_.fthc)*d_thcs_t_dV_tnode_GND)*value_exp_0))*(FCf_CT+(itf*FCdfCT_ditf))))+(((FFdQcfcT/VT)*d_FFdVc_ditf_dV_tnode_GND)+(((VT*d_FFdQcfcT_dV_tnode_GND-FFdQcfcT*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf)));
            FFdTcfcT = (((((model_.fthc)*thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*FFdVc_ditf));
          }
        }

        d_FFdQbfc_dV_bi_ci = ((1-(model_.fthc))*d_FFdQfhc_dV_bi_ci);
        d_FFdQbfc_dV_bi_ei = ((1-(model_.fthc))*d_FFdQfhc_dV_bi_ei);
        d_FFdQbfc_dV_tnode_GND = ((1-(model_.fthc))*d_FFdQfhc_dV_tnode_GND);
        FFdQbfc = ((1-(model_.fthc))*FFdQfhc);

        d_FFdTbfc_dV_bi_ci = ((1-(model_.fthc))*d_FFdTfhc_dV_bi_ci);
        d_FFdTbfc_dV_bi_ei = ((1-(model_.fthc))*d_FFdTfhc_dV_bi_ei);
        d_FFdTbfc_dV_tnode_GND = ((1-(model_.fthc))*d_FFdTfhc_dV_tnode_GND);
        FFdTbfc = ((1-(model_.fthc))*FFdTfhc);

        d_Q_fT_dV_bi_ei = (((((hf0_t*d_Qf_dV_bi_ei)+d_FFdQbfb_dV_bi_ei)+d_FFdQbfc_dV_bi_ei)+(hfe_t*d_FFdQef_dV_bi_ei))+(hfc_t*d_FFdQcfcT_dV_bi_ei));
        d_Q_fT_dV_bi_ci = (((((hf0_t*d_Qf_dV_bi_ci)+d_FFdQbfb_dV_bi_ci)+d_FFdQbfc_dV_bi_ci)+(hfe_t*d_FFdQef_dV_bi_ci))+(hfc_t*d_FFdQcfcT_dV_bi_ci));
        d_Q_fT_dV_tnode_GND = ((((((hf0_t*d_Qf_dV_tnode_GND)+(d_hf0_t_dV_tnode_GND*Qf))+d_FFdQbfb_dV_tnode_GND)+d_FFdQbfc_dV_tnode_GND)+((hfe_t*d_FFdQef_dV_tnode_GND)+(d_hfe_t_dV_tnode_GND*FFdQef)))+((hfc_t*d_FFdQcfcT_dV_tnode_GND)+(d_hfc_t_dV_tnode_GND*FFdQcfcT)));
        Q_fT = (((((hf0_t*Qf)+FFdQbfb)+FFdQbfc)+(hfe_t*FFdQef))+(hfc_t*FFdQcfcT));

        d_T_fT_dV_bi_ci = (((((hf0_t*d_Tf_dV_bi_ci)+d_FFdTbfb_dV_bi_ci)+d_FFdTbfc_dV_bi_ci)+(hfe_t*d_FFdTef_dV_bi_ci))+(hfc_t*d_FFdTcfcT_dV_bi_ci));
        d_T_fT_dV_bi_ei = (((((hf0_t*d_Tf_dV_bi_ei)+d_FFdTbfb_dV_bi_ei)+d_FFdTbfc_dV_bi_ei)+(hfe_t*d_FFdTef_dV_bi_ei))+(hfc_t*d_FFdTcfcT_dV_bi_ei));
        d_T_fT_dV_tnode_GND = ((((((hf0_t*d_Tf_dV_tnode_GND)+(d_hf0_t_dV_tnode_GND*Tf))+d_FFdTbfb_dV_tnode_GND)+d_FFdTbfc_dV_tnode_GND)+((hfe_t*d_FFdTef_dV_tnode_GND)+(d_hfe_t_dV_tnode_GND*FFdTef)))+((hfc_t*d_FFdTcfcT_dV_tnode_GND)+(d_hfc_t_dV_tnode_GND*FFdTcfcT)));
        T_fT = (((((hf0_t*Tf)+FFdTbfb)+FFdTbfc)+(hfe_t*FFdTef))+(hfc_t*FFdTcfcT));

        d_Qf_dV_bi_ei = (((d_Qf_dV_bi_ei+(d_FFdQbfb_dV_bi_ei+d_FFdQbfc_dV_bi_ei))+d_FFdQef_dV_bi_ei)+d_FFdQcfc_dV_bi_ei);
        d_Qf_dV_bi_ci = (((d_Qf_dV_bi_ci+(d_FFdQbfb_dV_bi_ci+d_FFdQbfc_dV_bi_ci))+d_FFdQef_dV_bi_ci)+d_FFdQcfc_dV_bi_ci);
        d_Qf_dV_tnode_GND = (((d_Qf_dV_tnode_GND+(d_FFdQbfb_dV_tnode_GND+d_FFdQbfc_dV_tnode_GND))+d_FFdQef_dV_tnode_GND)+d_FFdQcfc_dV_tnode_GND);
        Qf = (((Qf+(FFdQbfb+FFdQbfc))+FFdQef)+FFdQcfc);

        d_Tf_dV_bi_ci = (((d_Tf_dV_bi_ci+(d_FFdTbfb_dV_bi_ci+d_FFdTbfc_dV_bi_ci))+d_FFdTef_dV_bi_ci)+d_FFdTcfc_dV_bi_ci);
        d_Tf_dV_tnode_GND = (((d_Tf_dV_tnode_GND+(d_FFdTbfb_dV_tnode_GND+d_FFdTbfc_dV_tnode_GND))+d_FFdTef_dV_tnode_GND)+d_FFdTcfc_dV_tnode_GND);
        d_Tf_dV_bi_ei = (((d_Tf_dV_bi_ei+(d_FFdTbfb_dV_bi_ei+d_FFdTbfc_dV_bi_ei))+d_FFdTef_dV_bi_ei)+d_FFdTcfc_dV_bi_ei);
        Tf = (((Tf+(FFdTbfb+FFdTbfc))+FFdTef)+FFdTcfc);

        d_Q_bf_dV_bi_ci = (d_FFdQbfb_dV_bi_ci+d_FFdQbfc_dV_bi_ci);
        d_Q_bf_dV_bi_ei = (d_FFdQbfb_dV_bi_ei+d_FFdQbfc_dV_bi_ei);
        d_Q_bf_dV_tnode_GND = (d_FFdQbfb_dV_tnode_GND+d_FFdQbfc_dV_tnode_GND);
        Q_bf = (FFdQbfb+FFdQbfc);
      }

      d_Qr_dV_bi_ei = (Tr*d_itr_dV_bi_ei);
      d_Qr_dV_bi_ci = (Tr*d_itr_dV_bi_ci);
      d_Qr_dV_tnode_GND = (Tr*d_itr_dV_tnode_GND);
      Qr = (Tr*itr);
    }

    d_it_dV_bi_ci = (d_itf_dV_bi_ci-d_itr_dV_bi_ci);
    d_it_dV_bi_ei = (d_itf_dV_bi_ei-d_itr_dV_bi_ei);
    d_it_dV_tnode_GND = (d_itf_dV_tnode_GND-d_itr_dV_tnode_GND);
    it = (itf-itr);

    d_Qdei_dV_bi_ei = d_Qf_dV_bi_ei;
    d_Qdei_dV_bi_ci = d_Qf_dV_bi_ci;
    d_Qdei_dV_tnode_GND = d_Qf_dV_tnode_GND;
    Qdei = Qf;

    d_Qdci_dV_bi_ei = d_Qr_dV_bi_ei;
    d_Qdci_dV_bi_ci = d_Qr_dV_bi_ci;
    d_Qdci_dV_tnode_GND = d_Qr_dV_tnode_GND;
    Qdci = Qr;

    d_Cdei_dV_bi_ei = ((T_f0*d_itf_dV_bi_ei)/VT);
    d_Cdei_dV_bi_ci = (((T_f0*d_itf_dV_bi_ci)+(d_T_f0_dV_bi_ci*itf))/VT);
    d_Cdei_dV_tnode_GND = ((VT*((T_f0*d_itf_dV_tnode_GND)+(d_T_f0_dV_tnode_GND*itf))-(T_f0*itf)*d_VT_dV_tnode_GND)/VT/VT);
    Cdei = ((T_f0*itf)/VT);

    d_Cdci_dV_bi_ei = (((model_.tr)*d_itr_dV_bi_ei)/VT);
    d_Cdci_dV_bi_ci = (((model_.tr)*d_itr_dV_bi_ci)/VT);
    d_Cdci_dV_tnode_GND = ((VT*((model_.tr)*d_itr_dV_tnode_GND)-((model_.tr)*itr)*d_VT_dV_tnode_GND)/VT/VT);
    Cdci = (((model_.tr)*itr)/VT);

    d_Crbi_dV_bi_ci = ((model_.fcrbi)*((d_Cjci_dV_bi_ci+d_Cdei_dV_bi_ci)+d_Cdci_dV_bi_ci));
    d_Crbi_dV_bi_ei = ((model_.fcrbi)*(((d_Cjei_dV_bi_ei+d_Cjci_dV_bi_ei)+d_Cdei_dV_bi_ei)+d_Cdci_dV_bi_ei));
    d_Crbi_dV_tnode_GND = ((model_.fcrbi)*(((d_Cjei_dV_tnode_GND+d_Cjci_dV_tnode_GND)+d_Cdei_dV_tnode_GND)+d_Cdci_dV_tnode_GND));
    Crbi = ((model_.fcrbi)*(((Cjei+Cjci)+Cdei)+Cdci));

    d_qrbi_dV_bp_bi = (Crbi*d_probeVars[admsProbeID_V_bp_bi][admsProbeID_V_bp_bi]);
    d_qrbi_dV_bi_ci = (d_Crbi_dV_bi_ci*(probeVars[admsProbeID_V_bp_bi]));
    d_qrbi_dV_bi_ei = (d_Crbi_dV_bi_ei*(probeVars[admsProbeID_V_bp_bi]));
    d_qrbi_dV_tnode_GND = (d_Crbi_dV_tnode_GND*(probeVars[admsProbeID_V_bp_bi]));
    qrbi = (Crbi*(probeVars[admsProbeID_V_bp_bi]));

    d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ei =  0.0;
    d_DIOY_dV_tnode_GND = (-Vbici*((model_.mbci)*d_VT_dV_tnode_GND)/((model_.mbci)*VT)/((model_.mbci)*VT));
    d_DIOY_dV_bi_ci = (d_Vbici_dV_bi_ci/((model_.mbci)*VT));
    DIOY = (Vbici/((model_.mbci)*VT));
    if (((model_.ibcis)>0.0))
    {
      if ((DIOY>80.0))
      {

        d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei =  0.0;
        d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
        d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
        d_le_dV_bi_ci = d_DIOY_dV_bi_ci;
        le = (1+(DIOY-80.0));

        d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
        DIOY = 80.0;
      }
      else
      {

        d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
        le = 1;
      }
      {
        double value_limexp_0 = limexp(DIOY);
        double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

        d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei =  0.0;
        d_le_dV_tnode_GND = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND)))+(d_le_dV_tnode_GND*value_limexp_0));
        d_le_dV_bi_ei = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei)))+(d_le_dV_bi_ei*value_limexp_0));
        d_le_dV_bi_ci = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ci)))+(d_le_dV_bi_ci*value_limexp_0));
        le = (le*value_limexp_0);
      }

      d_ibci_dV_bi_ei = (ibcis_t*d_le_dV_bi_ei);
      d_ibci_dV_bi_ci = (ibcis_t*d_le_dV_bi_ci);
      d_ibci_dV_tnode_GND = ((ibcis_t*d_le_dV_tnode_GND)+(d_ibcis_t_dV_tnode_GND*(le-1.0)));
      ibci = (ibcis_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {

        d_ibci_dV_bi_ci = d_ibci_dV_bi_ei =  0.0;
        d_ibci_dV_tnode_GND = (-d_ibcis_t_dV_tnode_GND);
        ibci = (-ibcis_t);
      }
    }
    else
    {

      d_ibci_dV_tnode_GND = d_ibci_dV_bi_ci = d_ibci_dV_bi_ei =  0.0;
      ibci = 0.0;
    }
    if ((use_aval==1))
      //Begin block HICAVL
    {
      //Block-local variables for block HICAVL
      double v_bord;
      double d_v_bord_dV_tnode_GND;
      double d_v_bord_dV_bi_ci;
      double v_q;
      double d_v_q_dV_tnode_GND;
      double d_v_q_dV_bi_ei;
      double d_v_q_dV_bi_ci;
      double U0;
      double d_U0_dV_tnode_GND;
      double av;
      double d_av_dV_tnode_GND;
      double d_av_dV_bi_ei;
      double d_av_dV_bi_ci;
      double avl;
      double d_avl_dV_tnode_GND;
      double d_avl_dV_bi_ei;
      double d_avl_dV_bi_ci;
      //End of Block-local variables

      d_v_bord_dV_bi_ci = (-d_Vbici_dV_bi_ci);
      d_v_bord_dV_tnode_GND = d_vdci_t_dV_tnode_GND;
      v_bord = (vdci_t-Vbici);
      if ((v_bord>0))
      {

        d_v_q_dV_bi_ci = (-qavl_t*d_Cjci_dV_bi_ci/Cjci/Cjci);
        d_v_q_dV_bi_ei = (-qavl_t*d_Cjci_dV_bi_ei/Cjci/Cjci);
        d_v_q_dV_tnode_GND = ((Cjci*d_qavl_t_dV_tnode_GND-qavl_t*d_Cjci_dV_tnode_GND)/Cjci/Cjci);
        v_q = (qavl_t/Cjci);

        d_U0_dV_tnode_GND = ((cjci0_t*d_qavl_t_dV_tnode_GND-qavl_t*d_cjci0_t_dV_tnode_GND)/cjci0_t/cjci0_t);
        U0 = (qavl_t/cjci0_t);
        if ((v_bord>U0))
        {
          {
            double value_exp_0 = exp(((-v_q)/U0));
            double  deriv_exp_0_d0 = value_exp_0;

            d_av_dV_bi_ci = (favl_t*(deriv_exp_0_d0*(((-d_v_q_dV_bi_ci)/U0))));
            d_av_dV_bi_ei = (favl_t*(deriv_exp_0_d0*(((-d_v_q_dV_bi_ei)/U0))));
            d_av_dV_tnode_GND = ((favl_t*(deriv_exp_0_d0*(((U0*(-d_v_q_dV_tnode_GND)-(-v_q)*d_U0_dV_tnode_GND)/U0/U0))))+(d_favl_t_dV_tnode_GND*value_exp_0));
            av = (favl_t*value_exp_0);
          }

          d_avl_dV_bi_ci = ((av*(((1.0+(v_q/U0))*d_v_bord_dV_bi_ci)+((d_v_q_dV_bi_ci/U0)*(v_bord-U0))))+(d_av_dV_bi_ci*(U0+((1.0+(v_q/U0))*(v_bord-U0)))));
          d_avl_dV_bi_ei = ((av*((d_v_q_dV_bi_ei/U0)*(v_bord-U0)))+(d_av_dV_bi_ei*(U0+((1.0+(v_q/U0))*(v_bord-U0)))));
          d_avl_dV_tnode_GND = ((av*(d_U0_dV_tnode_GND+(((1.0+(v_q/U0))*(d_v_bord_dV_tnode_GND-d_U0_dV_tnode_GND))+(((U0*d_v_q_dV_tnode_GND-v_q*d_U0_dV_tnode_GND)/U0/U0)*(v_bord-U0)))))+(d_av_dV_tnode_GND*(U0+((1.0+(v_q/U0))*(v_bord-U0)))));
          avl = (av*(U0+((1.0+(v_q/U0))*(v_bord-U0))));
        }
        else
        {
          {
            double value_exp_0 = exp(((-v_q)/v_bord));
            double  deriv_exp_0_d0 = value_exp_0;

            d_avl_dV_bi_ei = ((favl_t*v_bord)*(deriv_exp_0_d0*(((-d_v_q_dV_bi_ei)/v_bord))));
            d_avl_dV_bi_ci = (((favl_t*v_bord)*(deriv_exp_0_d0*(((v_bord*(-d_v_q_dV_bi_ci)-(-v_q)*d_v_bord_dV_bi_ci)/v_bord/v_bord))))+((favl_t*d_v_bord_dV_bi_ci)*value_exp_0));
            d_avl_dV_tnode_GND = (((favl_t*v_bord)*(deriv_exp_0_d0*(((v_bord*(-d_v_q_dV_tnode_GND)-(-v_q)*d_v_bord_dV_tnode_GND)/v_bord/v_bord))))+(((favl_t*d_v_bord_dV_tnode_GND)+(d_favl_t_dV_tnode_GND*v_bord))*value_exp_0));
            avl = ((favl_t*v_bord)*value_exp_0);
          }
        }
        if (((model_.kavl)>0))
          //Begin block HICAVLHIGH
        {
          //Block-local variables for block HICAVLHIGH
          double denom;
          double d_denom_dV_tnode_GND;
          double d_denom_dV_bi_ei;
          double d_denom_dV_bi_ci;
          double sq_smooth;
          double d_sq_smooth_dV_tnode_GND;
          double d_sq_smooth_dV_bi_ei;
          double d_sq_smooth_dV_bi_ci;
          double hl;
          double d_hl_dV_tnode_GND;
          double d_hl_dV_bi_ei;
          double d_hl_dV_bi_ci;
          //End of Block-local variables

          d_denom_dV_bi_ci = (-(kavl_t*d_avl_dV_bi_ci));
          d_denom_dV_bi_ei = (-(kavl_t*d_avl_dV_bi_ei));
          d_denom_dV_tnode_GND = (-((kavl_t*d_avl_dV_tnode_GND)+(d_kavl_t_dV_tnode_GND*avl)));
          denom = (1-(kavl_t*avl));
          {
            double value_sqrt_0 = sqrt(((denom*denom)+0.01));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_sq_smooth_dV_bi_ci = (deriv_sqrt_0_d0*(((denom*d_denom_dV_bi_ci)+(d_denom_dV_bi_ci*denom))));
            d_sq_smooth_dV_bi_ei = (deriv_sqrt_0_d0*(((denom*d_denom_dV_bi_ei)+(d_denom_dV_bi_ei*denom))));
            d_sq_smooth_dV_tnode_GND = (deriv_sqrt_0_d0*(((denom*d_denom_dV_tnode_GND)+(d_denom_dV_tnode_GND*denom))));
            sq_smooth = value_sqrt_0;
          }

          d_hl_dV_bi_ci = (0.5*(d_denom_dV_bi_ci+d_sq_smooth_dV_bi_ci));
          d_hl_dV_bi_ei = (0.5*(d_denom_dV_bi_ei+d_sq_smooth_dV_bi_ei));
          d_hl_dV_tnode_GND = (0.5*(d_denom_dV_tnode_GND+d_sq_smooth_dV_tnode_GND));
          hl = (0.5*(denom+sq_smooth));

          d_iavl_dV_bi_ci = ((hl*((itf*d_avl_dV_bi_ci)+(d_itf_dV_bi_ci*avl))-(itf*avl)*d_hl_dV_bi_ci)/hl/hl);
          d_iavl_dV_bi_ei = ((hl*((itf*d_avl_dV_bi_ei)+(d_itf_dV_bi_ei*avl))-(itf*avl)*d_hl_dV_bi_ei)/hl/hl);
          d_iavl_dV_tnode_GND = ((hl*((itf*d_avl_dV_tnode_GND)+(d_itf_dV_tnode_GND*avl))-(itf*avl)*d_hl_dV_tnode_GND)/hl/hl);
          iavl = ((itf*avl)/hl);
        }
        // End block HICAVLHIGH
        else
        {

          d_iavl_dV_bi_ci = ((itf*d_avl_dV_bi_ci)+(d_itf_dV_bi_ci*avl));
          d_iavl_dV_bi_ei = ((itf*d_avl_dV_bi_ei)+(d_itf_dV_bi_ei*avl));
          d_iavl_dV_tnode_GND = ((itf*d_avl_dV_tnode_GND)+(d_itf_dV_tnode_GND*avl));
          iavl = (itf*avl);
        }
      }
      else
      {

        d_iavl_dV_tnode_GND = d_iavl_dV_bi_ei = d_iavl_dV_bi_ci =  0.0;
        iavl = 0.0;
      }
    }
    // End block HICAVL

    d_ibh_rec_dV_bi_ci = (d_Q_bf_dV_bi_ci*Otbhrec);
    d_ibh_rec_dV_bi_ei = (d_Q_bf_dV_bi_ei*Otbhrec);
    d_ibh_rec_dV_tnode_GND = (d_Q_bf_dV_tnode_GND*Otbhrec);
    ibh_rec = (Q_bf*Otbhrec);
    if ((rbi0_t>0.0))
      //Begin block HICRBI
    {
      //Block-local variables for block HICRBI
      double Qz_nom;
      double d_Qz_nom_dV_tnode_GND;
      double d_Qz_nom_dV_bi_ei;
      double d_Qz_nom_dV_bi_ci;
      double f_QR;
      double d_f_QR_dV_tnode_GND;
      double ETA;
      double d_ETA_dV_tnode_GND;
      double d_ETA_dV_bi_ei;
      double d_ETA_dV_bi_ci;
      double Qz0;
      double d_Qz0_dV_tnode_GND;
      double d_Qz0_dV_bi_ei;
      double d_Qz0_dV_bi_ci;
      double fQz;
      double d_fQz_dV_tnode_GND;
      double d_fQz_dV_bi_ei;
      double d_fQz_dV_bi_ci;
      //End of Block-local variables

      d_f_QR_dV_tnode_GND = ((1+(model_.fdqr0))*d_qp0_t_dV_tnode_GND);
      f_QR = ((1+(model_.fdqr0))*qp0_t);

      d_Qz0_dV_bi_ci = (d_Qjci_dV_bi_ci+d_Qf_dV_bi_ci);
      d_Qz0_dV_bi_ei = ((d_Qjei_dV_bi_ei+d_Qjci_dV_bi_ei)+d_Qf_dV_bi_ei);
      d_Qz0_dV_tnode_GND = ((d_Qjei_dV_tnode_GND+d_Qjci_dV_tnode_GND)+d_Qf_dV_tnode_GND);
      Qz0 = ((Qjei+Qjci)+Qf);

      d_Qz_nom_dV_bi_ci = (d_Qz0_dV_bi_ci/f_QR);
      d_Qz_nom_dV_bi_ei = (d_Qz0_dV_bi_ei/f_QR);
      d_Qz_nom_dV_tnode_GND = ((f_QR*d_Qz0_dV_tnode_GND-Qz0*d_f_QR_dV_tnode_GND)/f_QR/f_QR);
      Qz_nom = (1+(Qz0/f_QR));
      {
        double value_sqrt_0 = sqrt(((Qz_nom*Qz_nom)+0.01));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_fQz_dV_bi_ci = (0.5*(d_Qz_nom_dV_bi_ci+(deriv_sqrt_0_d0*(((Qz_nom*d_Qz_nom_dV_bi_ci)+(d_Qz_nom_dV_bi_ci*Qz_nom))))));
        d_fQz_dV_bi_ei = (0.5*(d_Qz_nom_dV_bi_ei+(deriv_sqrt_0_d0*(((Qz_nom*d_Qz_nom_dV_bi_ei)+(d_Qz_nom_dV_bi_ei*Qz_nom))))));
        d_fQz_dV_tnode_GND = (0.5*(d_Qz_nom_dV_tnode_GND+(deriv_sqrt_0_d0*(((Qz_nom*d_Qz_nom_dV_tnode_GND)+(d_Qz_nom_dV_tnode_GND*Qz_nom))))));
        fQz = (0.5*(Qz_nom+value_sqrt_0));
      }

      d_rbi_dV_bi_ci = (-rbi0_t*d_fQz_dV_bi_ci/fQz/fQz);
      d_rbi_dV_bi_ei = (-rbi0_t*d_fQz_dV_bi_ei/fQz/fQz);
      d_rbi_dV_tnode_GND = ((fQz*d_rbi0_t_dV_tnode_GND-rbi0_t*d_fQz_dV_tnode_GND)/fQz/fQz);
      rbi = (rbi0_t/fQz);
      if ((ibei>0.0))
      {

        d_ETA_dV_bi_ci = (((d_rbi_dV_bi_ci*ibei)*(model_.fgeo))/VT);
        d_ETA_dV_bi_ei = ((((rbi*d_ibei_dV_bi_ei)+(d_rbi_dV_bi_ei*ibei))*(model_.fgeo))/VT);
        d_ETA_dV_tnode_GND = ((VT*(((rbi*d_ibei_dV_tnode_GND)+(d_rbi_dV_tnode_GND*ibei))*(model_.fgeo))-((rbi*ibei)*(model_.fgeo))*d_VT_dV_tnode_GND)/VT/VT);
        ETA = (((rbi*ibei)*(model_.fgeo))/VT);
        if ((ETA<1.0e-6))
        {

          d_rbi_dV_bi_ci = ((rbi*(-(0.5*d_ETA_dV_bi_ci)))+(d_rbi_dV_bi_ci*(1.0-(0.5*ETA))));
          d_rbi_dV_bi_ei = ((rbi*(-(0.5*d_ETA_dV_bi_ei)))+(d_rbi_dV_bi_ei*(1.0-(0.5*ETA))));
          d_rbi_dV_tnode_GND = ((rbi*(-(0.5*d_ETA_dV_tnode_GND)))+(d_rbi_dV_tnode_GND*(1.0-(0.5*ETA))));
          rbi = (rbi*(1.0-(0.5*ETA)));
        }
        else
        {
          {
            double value_log_0 = log((1.0+ETA));
            double  deriv_log_0_d0 = (1.0/(1.0+ETA));

            d_rbi_dV_bi_ci = ((ETA*((rbi*(deriv_log_0_d0*(d_ETA_dV_bi_ci)))+(d_rbi_dV_bi_ci*value_log_0))-(rbi*value_log_0)*d_ETA_dV_bi_ci)/ETA/ETA);
            d_rbi_dV_bi_ei = ((ETA*((rbi*(deriv_log_0_d0*(d_ETA_dV_bi_ei)))+(d_rbi_dV_bi_ei*value_log_0))-(rbi*value_log_0)*d_ETA_dV_bi_ei)/ETA/ETA);
            d_rbi_dV_tnode_GND = ((ETA*((rbi*(deriv_log_0_d0*(d_ETA_dV_tnode_GND)))+(d_rbi_dV_tnode_GND*value_log_0))-(rbi*value_log_0)*d_ETA_dV_tnode_GND)/ETA/ETA);
            rbi = ((rbi*value_log_0)/ETA);
          }
        }
      }
      if ((Qf>0.0))
      {

        d_rbi_dV_bi_ci = (((Qjei+Qf)*((rbi*(d_Qf_dV_bi_ci*(model_.fqi)))+(d_rbi_dV_bi_ci*(Qjei+(Qf*(model_.fqi)))))-(rbi*(Qjei+(Qf*(model_.fqi))))*d_Qf_dV_bi_ci)/(Qjei+Qf)/(Qjei+Qf));
        d_rbi_dV_bi_ei = (((Qjei+Qf)*((rbi*(d_Qjei_dV_bi_ei+(d_Qf_dV_bi_ei*(model_.fqi))))+(d_rbi_dV_bi_ei*(Qjei+(Qf*(model_.fqi)))))-(rbi*(Qjei+(Qf*(model_.fqi))))*(d_Qjei_dV_bi_ei+d_Qf_dV_bi_ei))/(Qjei+Qf)/(Qjei+Qf));
        d_rbi_dV_tnode_GND = (((Qjei+Qf)*((rbi*(d_Qjei_dV_tnode_GND+(d_Qf_dV_tnode_GND*(model_.fqi))))+(d_rbi_dV_tnode_GND*(Qjei+(Qf*(model_.fqi)))))-(rbi*(Qjei+(Qf*(model_.fqi))))*(d_Qjei_dV_tnode_GND+d_Qf_dV_tnode_GND))/(Qjei+Qf)/(Qjei+Qf));
        rbi = ((rbi*(Qjei+(Qf*(model_.fqi))))/(Qjei+Qf));
      }
    }
    // End block HICRBI
    else
    {

      d_rbi_dV_tnode_GND = d_rbi_dV_bi_ei = d_rbi_dV_bi_ci =  0.0;
      rbi = 0.0;
    }

    d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei =  0.0;
    d_DIOY_dV_tnode_GND = (-Vbpei*((model_.mbep)*d_VT_dV_tnode_GND)/((model_.mbep)*VT)/((model_.mbep)*VT));
    d_DIOY_dV_bp_ei = (d_Vbpei_dV_bp_ei/((model_.mbep)*VT));
    DIOY = (Vbpei/((model_.mbep)*VT));
    if (((model_.ibeps)>0.0))
    {
      if ((DIOY>80.0))
      {

        d_le_dV_si_ci = d_le_dV_bp_ci =  0.0;
        d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
        d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
        d_le_dV_bi_ci = d_DIOY_dV_bi_ci;
        d_le_dV_bp_ei = d_DIOY_dV_bp_ei;
        le = (1+(DIOY-80.0));

        d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
        DIOY = 80.0;
      }
      else
      {

        d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
        le = 1;
      }
      {
        double value_limexp_0 = limexp(DIOY);
        double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

        d_le_dV_si_ci = d_le_dV_bp_ci =  0.0;
        d_le_dV_tnode_GND = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND)))+(d_le_dV_tnode_GND*value_limexp_0));
        d_le_dV_bi_ei = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei)))+(d_le_dV_bi_ei*value_limexp_0));
        d_le_dV_bi_ci = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ci)))+(d_le_dV_bi_ci*value_limexp_0));
        d_le_dV_bp_ei = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bp_ei)))+(d_le_dV_bp_ei*value_limexp_0));
        le = (le*value_limexp_0);
      }

      d_ibep_dV_bi_ei = (ibeps_t*d_le_dV_bi_ei);
      d_ibep_dV_bi_ci = (ibeps_t*d_le_dV_bi_ci);
      d_ibep_dV_bp_ei = (ibeps_t*d_le_dV_bp_ei);
      d_ibep_dV_tnode_GND = ((ibeps_t*d_le_dV_tnode_GND)+(d_ibeps_t_dV_tnode_GND*(le-1.0)));
      ibep = (ibeps_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {

        d_ibep_dV_bp_ei = d_ibep_dV_bi_ci = d_ibep_dV_bi_ei =  0.0;
        d_ibep_dV_tnode_GND = (-d_ibeps_t_dV_tnode_GND);
        ibep = (-ibeps_t);
      }
    }
    else
    {

      d_ibep_dV_tnode_GND = d_ibep_dV_bp_ei = d_ibep_dV_bi_ci = d_ibep_dV_bi_ei =  0.0;
      ibep = 0.0;
    }

    d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei =  0.0;
    d_DIOY_dV_tnode_GND = (-Vbpei*((model_.mrep)*d_VT_dV_tnode_GND)/((model_.mrep)*VT)/((model_.mrep)*VT));
    d_DIOY_dV_bp_ei = (d_Vbpei_dV_bp_ei/((model_.mrep)*VT));
    DIOY = (Vbpei/((model_.mrep)*VT));
    if (((model_.ireps)>0.0))
    {
      if ((DIOY>80.0))
      {

        d_le_dV_si_ci = d_le_dV_bp_ci =  0.0;
        d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
        d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
        d_le_dV_bi_ci = d_DIOY_dV_bi_ci;
        d_le_dV_bp_ei = d_DIOY_dV_bp_ei;
        le = (1+(DIOY-80.0));

        d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
        DIOY = 80.0;
      }
      else
      {

        d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
        le = 1;
      }
      {
        double value_limexp_0 = limexp(DIOY);
        double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

        d_le_dV_si_ci = d_le_dV_bp_ci =  0.0;
        d_le_dV_tnode_GND = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND)))+(d_le_dV_tnode_GND*value_limexp_0));
        d_le_dV_bi_ei = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei)))+(d_le_dV_bi_ei*value_limexp_0));
        d_le_dV_bi_ci = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ci)))+(d_le_dV_bi_ci*value_limexp_0));
        d_le_dV_bp_ei = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bp_ei)))+(d_le_dV_bp_ei*value_limexp_0));
        le = (le*value_limexp_0);
      }

      d_irep_dV_bi_ei = (ireps_t*d_le_dV_bi_ei);
      d_irep_dV_bi_ci = (ireps_t*d_le_dV_bi_ci);
      d_irep_dV_bp_ei = (ireps_t*d_le_dV_bp_ei);
      d_irep_dV_tnode_GND = ((ireps_t*d_le_dV_tnode_GND)+(d_ireps_t_dV_tnode_GND*(le-1.0)));
      irep = (ireps_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {

        d_irep_dV_bp_ei = d_irep_dV_bi_ci = d_irep_dV_bi_ei =  0.0;
        d_irep_dV_tnode_GND = (-d_ireps_t_dV_tnode_GND);
        irep = (-ireps_t);
      }
    }
    else
    {

      d_irep_dV_tnode_GND = d_irep_dV_bp_ei = d_irep_dV_bi_ci = d_irep_dV_bi_ei =  0.0;
      irep = 0.0;
    }
    if ((cjep0_t>0.0))
    {
      {
        double value_log_0 = log(ajep_t);
        double value_exp_1 = exp(((-value_log_0)/(model_.zep)));
        double  deriv_log_0_d0 = (1.0/ajep_t);
        double  deriv_exp_1_d0 = value_exp_1;

        d_DFV_f_dV_tnode_GND = ((vdep_t*(-(deriv_exp_1_d0*(((-(deriv_log_0_d0*(d_ajep_t_dV_tnode_GND)))/(model_.zep))))))+(d_vdep_t_dV_tnode_GND*(1.0-value_exp_1)));
        DFV_f = (vdep_t*(1.0-value_exp_1));
      }

      d_DFv_e_dV_s_c = d_DFv_e_dV_si_ci = d_DFv_e_dV_b_ci = d_DFv_e_dV_bp_ci = d_DFv_e_dV_bi_ci = d_DFv_e_dV_bi_ei =  0.0;
      d_DFv_e_dV_bp_ei = ((-d_Vbpei_dV_bp_ei)/VT);
      d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vbpei)*d_VT_dV_tnode_GND)/VT/VT);
      DFv_e = ((DFV_f-Vbpei)/VT);
      {
        double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
        double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

        d_DFs_q_dV_s_c = d_DFs_q_dV_si_ci = d_DFs_q_dV_b_ci = d_DFs_q_dV_bp_ci =  0.0;
        d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bi_ei)+(d_DFv_e_dV_bi_ei*DFv_e))));
        d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_tnode_GND)+(d_DFv_e_dV_tnode_GND*DFv_e))));
        d_DFs_q_dV_bi_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bi_ci)+(d_DFv_e_dV_bi_ci*DFv_e))));
        d_DFs_q_dV_bp_ei = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bp_ei)+(d_DFv_e_dV_bp_ei*DFv_e))));
        DFs_q = value_sqrt_0;
      }

      d_DFs_q2_dV_s_c = d_DFs_q2_dV_si_ci = d_DFs_q2_dV_b_ci = d_DFs_q2_dV_bp_ci =  0.0;
      d_DFs_q2_dV_bi_ei = ((d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5);
      d_DFs_q2_dV_tnode_GND = ((d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5);
      d_DFs_q2_dV_bi_ci = ((d_DFv_e_dV_bi_ci+d_DFs_q_dV_bi_ci)*0.5);
      d_DFs_q2_dV_bp_ei = ((d_DFv_e_dV_bp_ei+d_DFs_q_dV_bp_ei)*0.5);
      DFs_q2 = ((DFv_e+DFs_q)*0.5);

      d_DFv_j_dV_s_c = d_DFv_j_dV_si_ci = d_DFv_j_dV_b_ci = d_DFv_j_dV_bp_ci =  0.0;
      d_DFv_j_dV_bi_ei = (-(VT*d_DFs_q2_dV_bi_ei));
      d_DFv_j_dV_bi_ci = (-(VT*d_DFs_q2_dV_bi_ci));
      d_DFv_j_dV_bp_ei = (-(VT*d_DFs_q2_dV_bp_ei));
      d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-((VT*d_DFs_q2_dV_tnode_GND)+(d_VT_dV_tnode_GND*DFs_q2)));
      DFv_j = (DFV_f-(VT*DFs_q2));

      d_DFdvj_dv_dV_s_c = d_DFdvj_dv_dV_si_ci = d_DFdvj_dv_dV_b_ci = d_DFdvj_dv_dV_bp_ci =  0.0;
      d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
      d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
      d_DFdvj_dv_dV_bi_ci = ((DFs_q*d_DFs_q2_dV_bi_ci-DFs_q2*d_DFs_q_dV_bi_ci)/DFs_q/DFs_q);
      d_DFdvj_dv_dV_bp_ei = ((DFs_q*d_DFs_q2_dV_bp_ei-DFs_q2*d_DFs_q_dV_bp_ei)/DFs_q/DFs_q);
      DFdvj_dv = (DFs_q2/DFs_q);
      {
        double value_log_0 = log((1.0-(DFv_j/vdep_t)));
        double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vdep_t)));

        d_DFb_dV_s_c = d_DFb_dV_si_ci = d_DFb_dV_b_ci = d_DFb_dV_bp_ci =  0.0;
        d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vdep_t))));
        d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vdep_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vdep_t_dV_tnode_GND)/vdep_t/vdep_t))));
        d_DFb_dV_bi_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ci/vdep_t))));
        d_DFb_dV_bp_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ei/vdep_t))));
        DFb = value_log_0;
      }
      {
        double value_exp_0 = exp(((-(model_.zep))*DFb));
        double  deriv_exp_0_d0 = value_exp_0;

        d_DFC_j1_dV_s_c = d_DFC_j1_dV_si_ci = d_DFC_j1_dV_b_ci = d_DFC_j1_dV_bp_ci =  0.0;
        d_DFC_j1_dV_bi_ei = (((cjep0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei)+((cjep0_t*(deriv_exp_0_d0*(((-(model_.zep))*d_DFb_dV_bi_ei))))*DFdvj_dv));
        d_DFC_j1_dV_bi_ci = (((cjep0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ci)+((cjep0_t*(deriv_exp_0_d0*(((-(model_.zep))*d_DFb_dV_bi_ci))))*DFdvj_dv));
        d_DFC_j1_dV_bp_ei = (((cjep0_t*value_exp_0)*d_DFdvj_dv_dV_bp_ei)+((cjep0_t*(deriv_exp_0_d0*(((-(model_.zep))*d_DFb_dV_bp_ei))))*DFdvj_dv));
        d_DFC_j1_dV_tnode_GND = (((cjep0_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND)+(((cjep0_t*(deriv_exp_0_d0*(((-(model_.zep))*d_DFb_dV_tnode_GND))))+(d_cjep0_t_dV_tnode_GND*value_exp_0))*DFdvj_dv));
        DFC_j1 = ((cjep0_t*value_exp_0)*DFdvj_dv);
      }

      d_Cjep_dV_bi_ei = (d_DFC_j1_dV_bi_ei+((ajep_t*cjep0_t)*(-d_DFdvj_dv_dV_bi_ei)));
      d_Cjep_dV_tnode_GND = (d_DFC_j1_dV_tnode_GND+(((ajep_t*cjep0_t)*(-d_DFdvj_dv_dV_tnode_GND))+(((ajep_t*d_cjep0_t_dV_tnode_GND)+(d_ajep_t_dV_tnode_GND*cjep0_t))*(1.0-DFdvj_dv))));
      d_Cjep_dV_bi_ci = (d_DFC_j1_dV_bi_ci+((ajep_t*cjep0_t)*(-d_DFdvj_dv_dV_bi_ci)));
      d_Cjep_dV_bp_ei = (d_DFC_j1_dV_bp_ei+((ajep_t*cjep0_t)*(-d_DFdvj_dv_dV_bp_ei)));
      Cjep = (DFC_j1+((ajep_t*cjep0_t)*(1.0-DFdvj_dv)));
      {
        double value_exp_0 = exp((DFb*(1.0-(model_.zep))));
        double  deriv_exp_0_d0 = value_exp_0;

        d_DFQ_j_dV_s_c = d_DFQ_j_dV_si_ci = d_DFQ_j_dV_b_ci = d_DFQ_j_dV_bp_ci =  0.0;
        d_DFQ_j_dV_bi_ei = (((cjep0_t*vdep_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bi_ei*(1.0-(model_.zep)))))))/(1.0-(model_.zep)));
        d_DFQ_j_dV_bi_ci = (((cjep0_t*vdep_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bi_ci*(1.0-(model_.zep)))))))/(1.0-(model_.zep)));
        d_DFQ_j_dV_bp_ei = (((cjep0_t*vdep_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bp_ei*(1.0-(model_.zep)))))))/(1.0-(model_.zep)));
        d_DFQ_j_dV_tnode_GND = ((((cjep0_t*vdep_t)*(-(deriv_exp_0_d0*((d_DFb_dV_tnode_GND*(1.0-(model_.zep)))))))+(((cjep0_t*d_vdep_t_dV_tnode_GND)+(d_cjep0_t_dV_tnode_GND*vdep_t))*(1.0-value_exp_0)))/(1.0-(model_.zep)));
        DFQ_j = (((cjep0_t*vdep_t)*(1.0-value_exp_0))/(1.0-(model_.zep)));
      }

      d_Qjep_dV_bi_ei = (d_DFQ_j_dV_bi_ei+((ajep_t*cjep0_t)*(-d_DFv_j_dV_bi_ei)));
      d_Qjep_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+(((ajep_t*cjep0_t)*(-d_DFv_j_dV_tnode_GND))+(((ajep_t*d_cjep0_t_dV_tnode_GND)+(d_ajep_t_dV_tnode_GND*cjep0_t))*(Vbpei-DFv_j))));
      d_Qjep_dV_bi_ci = (d_DFQ_j_dV_bi_ci+((ajep_t*cjep0_t)*(-d_DFv_j_dV_bi_ci)));
      d_Qjep_dV_bp_ei = (d_DFQ_j_dV_bp_ei+((ajep_t*cjep0_t)*(d_Vbpei_dV_bp_ei-d_DFv_j_dV_bp_ei)));
      Qjep = (DFQ_j+((ajep_t*cjep0_t)*(Vbpei-DFv_j)));
    }
    else
    {

      d_Cjep_dV_bp_ei = d_Cjep_dV_bi_ci = d_Cjep_dV_tnode_GND = d_Cjep_dV_bi_ei =  0.0;
      Cjep = 0.0;

      d_Qjep_dV_bp_ei = d_Qjep_dV_bi_ci = d_Qjep_dV_tnode_GND = d_Qjep_dV_bi_ei =  0.0;
      Qjep = 0.0;
    }
    if ((((model_.ibets)>0)&&((Vbpei<0.0)||(Vbiei<0.0))))
      //Begin block HICTUN
    {
      //Block-local variables for block HICTUN
      double pocce;
      double d_pocce_dV_bp_ei;
      double d_pocce_dV_bi_ci;
      double d_pocce_dV_tnode_GND;
      double d_pocce_dV_bi_ei;
      double czz;
      double d_czz_dV_bp_ei;
      double d_czz_dV_tnode_GND;
      double d_czz_dV_bi_ci;
      double d_czz_dV_bi_ei;
      //End of Block-local variables
      if (((((model_.tunode)==1)&&(cjep0_t>0.0))&&(vdep_t>0.0)))
      {
        {
          double value_log_0 = log((Cjep/cjep0_t));
          double value_exp_1 = exp(((1-(1/(model_.zep)))*value_log_0));
          double  deriv_log_0_d0 = (1.0/(Cjep/cjep0_t));
          double  deriv_exp_1_d0 = value_exp_1;

          d_pocce_dV_bi_ei = (deriv_exp_1_d0*(((1-(1/(model_.zep)))*(deriv_log_0_d0*((d_Cjep_dV_bi_ei/cjep0_t))))));
          d_pocce_dV_tnode_GND = (deriv_exp_1_d0*(((1-(1/(model_.zep)))*(deriv_log_0_d0*(((cjep0_t*d_Cjep_dV_tnode_GND-Cjep*d_cjep0_t_dV_tnode_GND)/cjep0_t/cjep0_t))))));
          d_pocce_dV_bi_ci = (deriv_exp_1_d0*(((1-(1/(model_.zep)))*(deriv_log_0_d0*((d_Cjep_dV_bi_ci/cjep0_t))))));
          d_pocce_dV_bp_ei = (deriv_exp_1_d0*(((1-(1/(model_.zep)))*(deriv_log_0_d0*((d_Cjep_dV_bp_ei/cjep0_t))))));
          pocce = value_exp_1;
        }

        d_czz_dV_bi_ei = (((-(Vbpei/vdep_t))*ibets_t)*d_pocce_dV_bi_ei);
        d_czz_dV_bi_ci = (((-(Vbpei/vdep_t))*ibets_t)*d_pocce_dV_bi_ci);
        d_czz_dV_tnode_GND = ((((-(Vbpei/vdep_t))*ibets_t)*d_pocce_dV_tnode_GND)+((((-(Vbpei/vdep_t))*d_ibets_t_dV_tnode_GND)+((-(-Vbpei*d_vdep_t_dV_tnode_GND/vdep_t/vdep_t))*ibets_t))*pocce));
        d_czz_dV_bp_ei = ((((-(Vbpei/vdep_t))*ibets_t)*d_pocce_dV_bp_ei)+(((-(d_Vbpei_dV_bp_ei/vdep_t))*ibets_t)*pocce));
        czz = (((-(Vbpei/vdep_t))*ibets_t)*pocce);
        {
          double value_exp_0 = exp(((-abet_t)/pocce));
          double  deriv_exp_0_d0 = value_exp_0;

          d_ibet_dV_bi_ei = ((czz*(deriv_exp_0_d0*((-(-abet_t)*d_pocce_dV_bi_ei/pocce/pocce))))+(d_czz_dV_bi_ei*value_exp_0));
          d_ibet_dV_bi_ci = ((czz*(deriv_exp_0_d0*((-(-abet_t)*d_pocce_dV_bi_ci/pocce/pocce))))+(d_czz_dV_bi_ci*value_exp_0));
          d_ibet_dV_tnode_GND = ((czz*(deriv_exp_0_d0*(((pocce*(-d_abet_t_dV_tnode_GND)-(-abet_t)*d_pocce_dV_tnode_GND)/pocce/pocce))))+(d_czz_dV_tnode_GND*value_exp_0));
          d_ibet_dV_bp_ei = ((czz*(deriv_exp_0_d0*((-(-abet_t)*d_pocce_dV_bp_ei/pocce/pocce))))+(d_czz_dV_bp_ei*value_exp_0));
          ibet = (czz*value_exp_0);
        }
      }
      else
      {
        if (((((model_.tunode)==0)&&(cjei0_t>0.0))&&(vdei_t>0.0)))
        {
          {
            double value_log_0 = log((Cjei/cjei0_t));
            double value_exp_1 = exp(((1-(1/(model_.zei)))*value_log_0));
            double  deriv_log_0_d0 = (1.0/(Cjei/cjei0_t));
            double  deriv_exp_1_d0 = value_exp_1;

            d_pocce_dV_bp_ei = d_pocce_dV_bi_ci =  0.0;
            d_pocce_dV_bi_ei = (deriv_exp_1_d0*(((1-(1/(model_.zei)))*(deriv_log_0_d0*((d_Cjei_dV_bi_ei/cjei0_t))))));
            d_pocce_dV_tnode_GND = (deriv_exp_1_d0*(((1-(1/(model_.zei)))*(deriv_log_0_d0*(((cjei0_t*d_Cjei_dV_tnode_GND-Cjei*d_cjei0_t_dV_tnode_GND)/cjei0_t/cjei0_t))))));
            pocce = value_exp_1;
          }

          d_czz_dV_bi_ci = (((-(Vbiei/vdei_t))*ibets_t)*d_pocce_dV_bi_ci);
          d_czz_dV_bp_ei = (((-(Vbiei/vdei_t))*ibets_t)*d_pocce_dV_bp_ei);
          d_czz_dV_tnode_GND = ((((-(Vbiei/vdei_t))*ibets_t)*d_pocce_dV_tnode_GND)+((((-(Vbiei/vdei_t))*d_ibets_t_dV_tnode_GND)+((-(-Vbiei*d_vdei_t_dV_tnode_GND/vdei_t/vdei_t))*ibets_t))*pocce));
          d_czz_dV_bi_ei = ((((-(Vbiei/vdei_t))*ibets_t)*d_pocce_dV_bi_ei)+(((-(d_Vbiei_dV_bi_ei/vdei_t))*ibets_t)*pocce));
          czz = (((-(Vbiei/vdei_t))*ibets_t)*pocce);
          {
            double value_exp_0 = exp(((-abet_t)/pocce));
            double  deriv_exp_0_d0 = value_exp_0;

            d_ibet_dV_bi_ei = ((czz*(deriv_exp_0_d0*((-(-abet_t)*d_pocce_dV_bi_ei/pocce/pocce))))+(d_czz_dV_bi_ei*value_exp_0));
            d_ibet_dV_bi_ci = ((czz*(deriv_exp_0_d0*((-(-abet_t)*d_pocce_dV_bi_ci/pocce/pocce))))+(d_czz_dV_bi_ci*value_exp_0));
            d_ibet_dV_tnode_GND = ((czz*(deriv_exp_0_d0*(((pocce*(-d_abet_t_dV_tnode_GND)-(-abet_t)*d_pocce_dV_tnode_GND)/pocce/pocce))))+(d_czz_dV_tnode_GND*value_exp_0));
            d_ibet_dV_bp_ei = ((czz*(deriv_exp_0_d0*((-(-abet_t)*d_pocce_dV_bp_ei/pocce/pocce))))+(d_czz_dV_bp_ei*value_exp_0));
            ibet = (czz*value_exp_0);
          }
        }
        else
        {

          d_ibet_dV_bp_ei = d_ibet_dV_tnode_GND = d_ibet_dV_bi_ci = d_ibet_dV_bi_ei =  0.0;
          ibet = 0.0;
        }
      }
    }
    // End block HICTUN
    else
    {

      d_ibet_dV_bp_ei = d_ibet_dV_tnode_GND = d_ibet_dV_bi_ci = d_ibet_dV_bi_ei =  0.0;
      ibet = 0.0;
    }
    if ((vptcx_t<1.0e2))
    {
      if ((cjcx02_t>0.0))
      {
        Dz_r = ((model_.zcx)/4.0);

        d_Dv_p_dV_tnode_GND = (d_vptcx_t_dV_tnode_GND-d_vdcx_t_dV_tnode_GND);
        Dv_p = (vptcx_t-vdcx_t);
        {
          double value_log_0 = log(static_cast<double>(2.4));
          double value_exp_1 = exp(((-value_log_0)/(model_.zcx)));

          d_DV_f_dV_tnode_GND = (d_vdcx_t_dV_tnode_GND*(1.0-value_exp_1));
          DV_f = (vdcx_t*(1.0-value_exp_1));
        }

        d_DC_max_dV_tnode_GND = (2.4*d_cjcx02_t_dV_tnode_GND);
        DC_max = (2.4*cjcx02_t);
        {
          double value_log_0 = log((vptcx_t/vdcx_t));
          double value_exp_1 = exp(((Dz_r-(model_.zcx))*value_log_0));
          double  deriv_log_0_d0 = (1.0/(vptcx_t/vdcx_t));
          double  deriv_exp_1_d0 = value_exp_1;

          d_DC_c_dV_tnode_GND = ((cjcx02_t*(deriv_exp_1_d0*(((Dz_r-(model_.zcx))*(deriv_log_0_d0*(((vdcx_t*d_vptcx_t_dV_tnode_GND-vptcx_t*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t)))))))+(d_cjcx02_t_dV_tnode_GND*value_exp_1));
          DC_c = (cjcx02_t*value_exp_1);
        }

        d_Dv_e_dV_s_c = d_Dv_e_dV_si_ci = d_Dv_e_dV_b_ci = d_Dv_e_dV_bi_ci =  0.0;
        d_Dv_e_dV_bp_ci = ((-d_Vbpci_dV_bp_ci)/VT);
        d_Dv_e_dV_tnode_GND = ((VT*d_DV_f_dV_tnode_GND-(DV_f-Vbpci)*d_VT_dV_tnode_GND)/VT/VT);
        Dv_e = ((DV_f-Vbpci)/VT);
        if ((Dv_e<80.0))
        {
          {
            double value_exp_0 = exp(Dv_e);
            double  deriv_exp_0_d0 = value_exp_0;

            d_De_dV_s_c = d_De_dV_si_ci = d_De_dV_b_ci =  0.0;
            d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bi_ci));
            d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_e_dV_tnode_GND));
            d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bp_ci));
            De = value_exp_0;
          }

          d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci =  0.0;
          d_De_1_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
          d_De_1_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
          d_De_1_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
          De_1 = (De/(1.0+De));
          {
            double value_log_0 = log((1.0+De));
            double  deriv_log_0_d0 = (1.0/(1.0+De));

            d_Dv_j1_dV_s_c = d_Dv_j1_dV_si_ci = d_Dv_j1_dV_b_ci =  0.0;
            d_Dv_j1_dV_bi_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_bi_ci))));
            d_Dv_j1_dV_bp_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_bp_ci))));
            d_Dv_j1_dV_tnode_GND = (d_DV_f_dV_tnode_GND-((VT*(deriv_log_0_d0*(d_De_dV_tnode_GND)))+(d_VT_dV_tnode_GND*value_log_0)));
            Dv_j1 = (DV_f-(VT*value_log_0));
          }
        }
        else
        {

          d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci = d_De_1_dV_bp_ci = d_De_1_dV_tnode_GND = d_De_1_dV_bi_ci =  0.0;
          De_1 = 1.0;

          d_Dv_j1_dV_s_c = d_Dv_j1_dV_si_ci = d_Dv_j1_dV_b_ci = d_Dv_j1_dV_tnode_GND = d_Dv_j1_dV_bi_ci =  0.0;
          d_Dv_j1_dV_bp_ci = d_Vbpci_dV_bp_ci;
          Dv_j1 = Vbpci;
        }

        d_Da_dV_tnode_GND = ((0.1*d_Dv_p_dV_tnode_GND)+(4.0*d_VT_dV_tnode_GND));
        Da = ((0.1*Dv_p)+(4.0*VT));

        d_Dv_r_dV_s_c = d_Dv_r_dV_si_ci = d_Dv_r_dV_b_ci =  0.0;
        d_Dv_r_dV_bi_ci = (d_Dv_j1_dV_bi_ci/Da);
        d_Dv_r_dV_bp_ci = (d_Dv_j1_dV_bp_ci/Da);
        d_Dv_r_dV_tnode_GND = ((Da*(d_Dv_p_dV_tnode_GND+d_Dv_j1_dV_tnode_GND)-(Dv_p+Dv_j1)*d_Da_dV_tnode_GND)/Da/Da);
        Dv_r = ((Dv_p+Dv_j1)/Da);
        if ((Dv_r<80.0))
        {
          {
            double value_exp_0 = exp(Dv_r);
            double  deriv_exp_0_d0 = value_exp_0;

            d_De_dV_s_c = d_De_dV_si_ci = d_De_dV_b_ci =  0.0;
            d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bi_ci));
            d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_r_dV_tnode_GND));
            d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bp_ci));
            De = value_exp_0;
          }

          d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci =  0.0;
          d_De_2_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
          d_De_2_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
          d_De_2_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
          De_2 = (De/(1.0+De));
          {
            double value_log_0 = log((1.0+De));
            double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
            double  deriv_log_0_d0 = (1.0/(1.0+De));
            double  deriv_exp_1_d0 = value_exp_1;

            d_Dv_j2_dV_s_c = d_Dv_j2_dV_si_ci = d_Dv_j2_dV_b_ci =  0.0;
            d_Dv_j2_dV_bi_ci = (Da*(deriv_log_0_d0*(d_De_dV_bi_ci)));
            d_Dv_j2_dV_bp_ci = (Da*(deriv_log_0_d0*(d_De_dV_bp_ci)));
            d_Dv_j2_dV_tnode_GND = ((-d_Dv_p_dV_tnode_GND)+((Da*((deriv_log_0_d0*(d_De_dV_tnode_GND))-(deriv_exp_1_d0*(((Da*(-(d_Dv_p_dV_tnode_GND+d_DV_f_dV_tnode_GND))-(-(Dv_p+DV_f))*d_Da_dV_tnode_GND)/Da/Da)))))+(d_Da_dV_tnode_GND*(value_log_0-value_exp_1))));
            Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
          }
        }
        else
        {

          d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci = d_De_2_dV_bp_ci = d_De_2_dV_tnode_GND = d_De_2_dV_bi_ci =  0.0;
          De_2 = 1.0;

          d_Dv_j2_dV_s_c = d_Dv_j2_dV_si_ci = d_Dv_j2_dV_b_ci =  0.0;
          d_Dv_j2_dV_bi_ci = d_Dv_j1_dV_bi_ci;
          d_Dv_j2_dV_tnode_GND = d_Dv_j1_dV_tnode_GND;
          d_Dv_j2_dV_bp_ci = d_Dv_j1_dV_bp_ci;
          Dv_j2 = Dv_j1;
        }

        d_Dv_j4_dV_s_c = d_Dv_j4_dV_si_ci = d_Dv_j4_dV_b_ci =  0.0;
        d_Dv_j4_dV_bi_ci = (-d_Dv_j1_dV_bi_ci);
        d_Dv_j4_dV_tnode_GND = (-d_Dv_j1_dV_tnode_GND);
        d_Dv_j4_dV_bp_ci = (d_Vbpci_dV_bp_ci-d_Dv_j1_dV_bp_ci);
        Dv_j4 = (Vbpci-Dv_j1);
        {
          double value_log_0 = log((1.0-(Dv_j1/vdcx_t)));
          double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/vdcx_t)));

          d_DCln1_dV_s_c = d_DCln1_dV_si_ci = d_DCln1_dV_b_ci =  0.0;
          d_DCln1_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bi_ci/vdcx_t))));
          d_DCln1_dV_tnode_GND = (deriv_log_0_d0*((-((vdcx_t*d_Dv_j1_dV_tnode_GND-Dv_j1*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t))));
          d_DCln1_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bp_ci/vdcx_t))));
          DCln1 = value_log_0;
        }
        {
          double value_log_0 = log((1.0-(Dv_j2/vdcx_t)));
          double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/vdcx_t)));

          d_DCln2_dV_s_c = d_DCln2_dV_si_ci = d_DCln2_dV_b_ci =  0.0;
          d_DCln2_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bi_ci/vdcx_t))));
          d_DCln2_dV_tnode_GND = (deriv_log_0_d0*((-((vdcx_t*d_Dv_j2_dV_tnode_GND-Dv_j2*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t))));
          d_DCln2_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bp_ci/vdcx_t))));
          DCln2 = value_log_0;
        }
        Dz1 = (1.0-(model_.zcx));
        Dzr1 = (1.0-Dz_r);
        {
          double value_exp_0 = exp((DCln2*(-(model_.zcx))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DC_j1_dV_s_c = d_DC_j1_dV_si_ci = d_DC_j1_dV_b_ci =  0.0;
          d_DC_j1_dV_bi_ci = ((((cjcx02_t*value_exp_0)*De_1)*d_De_2_dV_bi_ci)+((((cjcx02_t*value_exp_0)*d_De_1_dV_bi_ci)+((cjcx02_t*(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*(-(model_.zcx))))))*De_1))*De_2));
          d_DC_j1_dV_bp_ci = ((((cjcx02_t*value_exp_0)*De_1)*d_De_2_dV_bp_ci)+((((cjcx02_t*value_exp_0)*d_De_1_dV_bp_ci)+((cjcx02_t*(deriv_exp_0_d0*((d_DCln2_dV_bp_ci*(-(model_.zcx))))))*De_1))*De_2));
          d_DC_j1_dV_tnode_GND = ((((cjcx02_t*value_exp_0)*De_1)*d_De_2_dV_tnode_GND)+((((cjcx02_t*value_exp_0)*d_De_1_dV_tnode_GND)+(((cjcx02_t*(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*(-(model_.zcx))))))+(d_cjcx02_t_dV_tnode_GND*value_exp_0))*De_1))*De_2));
          DC_j1 = (((cjcx02_t*value_exp_0)*De_1)*De_2);
        }
        {
          double value_exp_0 = exp((DCln1*(-Dz_r)));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DC_j2_dV_s_c = d_DC_j2_dV_si_ci = d_DC_j2_dV_b_ci =  0.0;
          d_DC_j2_dV_bi_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_bi_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_bi_ci*(-Dz_r)))))*(1.0-De_2)));
          d_DC_j2_dV_bp_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_bp_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_bp_ci*(-Dz_r)))))*(1.0-De_2)));
          d_DC_j2_dV_tnode_GND = (((DC_c*value_exp_0)*(-d_De_2_dV_tnode_GND))+(((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_tnode_GND*(-Dz_r)))))+(d_DC_c_dV_tnode_GND*value_exp_0))*(1.0-De_2)));
          DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
        }

        d_DC_j3_dV_s_c = d_DC_j3_dV_si_ci = d_DC_j3_dV_b_ci =  0.0;
        d_DC_j3_dV_bi_ci = (DC_max*(-d_De_1_dV_bi_ci));
        d_DC_j3_dV_bp_ci = (DC_max*(-d_De_1_dV_bp_ci));
        d_DC_j3_dV_tnode_GND = ((DC_max*(-d_De_1_dV_tnode_GND))+(d_DC_max_dV_tnode_GND*(1.0-De_1)));
        DC_j3 = (DC_max*(1.0-De_1));

        d_CjCx_ii_dV_bp_ei = d_CjCx_ii_dV_bi_ei =  0.0;
        d_CjCx_ii_dV_bi_ci = ((d_DC_j1_dV_bi_ci+d_DC_j2_dV_bi_ci)+d_DC_j3_dV_bi_ci);
        d_CjCx_ii_dV_tnode_GND = ((d_DC_j1_dV_tnode_GND+d_DC_j2_dV_tnode_GND)+d_DC_j3_dV_tnode_GND);
        d_CjCx_ii_dV_bp_ci = ((d_DC_j1_dV_bp_ci+d_DC_j2_dV_bp_ci)+d_DC_j3_dV_bp_ci);
        CjCx_ii = ((DC_j1+DC_j2)+DC_j3);
        {
          double value_exp_0 = exp((DCln2*Dz1));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DQ_j1_dV_s_c = d_DQ_j1_dV_si_ci = d_DQ_j1_dV_b_ci =  0.0;
          d_DQ_j1_dV_bi_ci = ((cjcx02_t*(-(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*Dz1)))))/Dz1);
          d_DQ_j1_dV_bp_ci = ((cjcx02_t*(-(deriv_exp_0_d0*((d_DCln2_dV_bp_ci*Dz1)))))/Dz1);
          d_DQ_j1_dV_tnode_GND = (((cjcx02_t*(-(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*Dz1)))))+(d_cjcx02_t_dV_tnode_GND*(1.0-value_exp_0)))/Dz1);
          DQ_j1 = ((cjcx02_t*(1.0-value_exp_0))/Dz1);
        }
        {
          double value_exp_0 = exp((DCln1*Dzr1));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DQ_j2_dV_s_c = d_DQ_j2_dV_si_ci = d_DQ_j2_dV_b_ci =  0.0;
          d_DQ_j2_dV_bi_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_bi_ci*Dzr1)))))/Dzr1);
          d_DQ_j2_dV_bp_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_bp_ci*Dzr1)))))/Dzr1);
          d_DQ_j2_dV_tnode_GND = (((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_tnode_GND*Dzr1)))))+(d_DC_c_dV_tnode_GND*(1.0-value_exp_0)))/Dzr1);
          DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }
        {
          double value_exp_0 = exp((DCln2*Dzr1));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DQ_j3_dV_s_c = d_DQ_j3_dV_si_ci = d_DQ_j3_dV_b_ci =  0.0;
          d_DQ_j3_dV_bi_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*Dzr1)))))/Dzr1);
          d_DQ_j3_dV_bp_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_bp_ci*Dzr1)))))/Dzr1);
          d_DQ_j3_dV_tnode_GND = (((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*Dzr1)))))+(d_DC_c_dV_tnode_GND*(1.0-value_exp_0)))/Dzr1);
          DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }

        d_qjcx0_t_ii_dV_bp_ei = d_qjcx0_t_ii_dV_bi_ei =  0.0;
        d_qjcx0_t_ii_dV_bi_ci = ((((d_DQ_j1_dV_bi_ci+d_DQ_j2_dV_bi_ci)-d_DQ_j3_dV_bi_ci)*vdcx_t)+(DC_max*d_Dv_j4_dV_bi_ci));
        d_qjcx0_t_ii_dV_tnode_GND = (((((DQ_j1+DQ_j2)-DQ_j3)*d_vdcx_t_dV_tnode_GND)+(((d_DQ_j1_dV_tnode_GND+d_DQ_j2_dV_tnode_GND)-d_DQ_j3_dV_tnode_GND)*vdcx_t))+((DC_max*d_Dv_j4_dV_tnode_GND)+(d_DC_max_dV_tnode_GND*Dv_j4)));
        d_qjcx0_t_ii_dV_bp_ci = ((((d_DQ_j1_dV_bp_ci+d_DQ_j2_dV_bp_ci)-d_DQ_j3_dV_bp_ci)*vdcx_t)+(DC_max*d_Dv_j4_dV_bp_ci));
        qjcx0_t_ii = ((((DQ_j1+DQ_j2)-DQ_j3)*vdcx_t)+(DC_max*Dv_j4));
      }
      else
      {

        d_CjCx_ii_dV_bp_ei = d_CjCx_ii_dV_bi_ei = d_CjCx_ii_dV_bp_ci = d_CjCx_ii_dV_tnode_GND = d_CjCx_ii_dV_bi_ci =  0.0;
        CjCx_ii = 0.0;

        d_qjcx0_t_ii_dV_bp_ei = d_qjcx0_t_ii_dV_bi_ei = d_qjcx0_t_ii_dV_bp_ci = d_qjcx0_t_ii_dV_tnode_GND = d_qjcx0_t_ii_dV_bi_ci =  0.0;
        qjcx0_t_ii = 0.0;
      }
    }
    else
    {
      if ((cjcx02_t>0.0))
      {
        {
          double value_log_0 = log(static_cast<double>(2.4));
          double value_exp_1 = exp(((-value_log_0)/(model_.zcx)));

          d_DFV_f_dV_tnode_GND = (d_vdcx_t_dV_tnode_GND*(1.0-value_exp_1));
          DFV_f = (vdcx_t*(1.0-value_exp_1));
        }

        d_DFv_e_dV_s_c = d_DFv_e_dV_si_ci = d_DFv_e_dV_b_ci = d_DFv_e_dV_bp_ei = d_DFv_e_dV_bi_ci = d_DFv_e_dV_bi_ei =  0.0;
        d_DFv_e_dV_bp_ci = ((-d_Vbpci_dV_bp_ci)/VT);
        d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vbpci)*d_VT_dV_tnode_GND)/VT/VT);
        DFv_e = ((DFV_f-Vbpci)/VT);
        {
          double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_DFs_q_dV_s_c = d_DFs_q_dV_si_ci = d_DFs_q_dV_b_ci =  0.0;
          d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bi_ei)+(d_DFv_e_dV_bi_ei*DFv_e))));
          d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_tnode_GND)+(d_DFv_e_dV_tnode_GND*DFv_e))));
          d_DFs_q_dV_bi_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bi_ci)+(d_DFv_e_dV_bi_ci*DFv_e))));
          d_DFs_q_dV_bp_ei = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bp_ei)+(d_DFv_e_dV_bp_ei*DFv_e))));
          d_DFs_q_dV_bp_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bp_ci)+(d_DFv_e_dV_bp_ci*DFv_e))));
          DFs_q = value_sqrt_0;
        }

        d_DFs_q2_dV_s_c = d_DFs_q2_dV_si_ci = d_DFs_q2_dV_b_ci =  0.0;
        d_DFs_q2_dV_bi_ei = ((d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5);
        d_DFs_q2_dV_tnode_GND = ((d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5);
        d_DFs_q2_dV_bi_ci = ((d_DFv_e_dV_bi_ci+d_DFs_q_dV_bi_ci)*0.5);
        d_DFs_q2_dV_bp_ei = ((d_DFv_e_dV_bp_ei+d_DFs_q_dV_bp_ei)*0.5);
        d_DFs_q2_dV_bp_ci = ((d_DFv_e_dV_bp_ci+d_DFs_q_dV_bp_ci)*0.5);
        DFs_q2 = ((DFv_e+DFs_q)*0.5);

        d_DFv_j_dV_s_c = d_DFv_j_dV_si_ci = d_DFv_j_dV_b_ci =  0.0;
        d_DFv_j_dV_bi_ei = (-(VT*d_DFs_q2_dV_bi_ei));
        d_DFv_j_dV_bi_ci = (-(VT*d_DFs_q2_dV_bi_ci));
        d_DFv_j_dV_bp_ei = (-(VT*d_DFs_q2_dV_bp_ei));
        d_DFv_j_dV_bp_ci = (-(VT*d_DFs_q2_dV_bp_ci));
        d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-((VT*d_DFs_q2_dV_tnode_GND)+(d_VT_dV_tnode_GND*DFs_q2)));
        DFv_j = (DFV_f-(VT*DFs_q2));

        d_DFdvj_dv_dV_s_c = d_DFdvj_dv_dV_si_ci = d_DFdvj_dv_dV_b_ci =  0.0;
        d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_bi_ci = ((DFs_q*d_DFs_q2_dV_bi_ci-DFs_q2*d_DFs_q_dV_bi_ci)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_bp_ei = ((DFs_q*d_DFs_q2_dV_bp_ei-DFs_q2*d_DFs_q_dV_bp_ei)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_bp_ci = ((DFs_q*d_DFs_q2_dV_bp_ci-DFs_q2*d_DFs_q_dV_bp_ci)/DFs_q/DFs_q);
        DFdvj_dv = (DFs_q2/DFs_q);
        {
          double value_log_0 = log((1.0-(DFv_j/vdcx_t)));
          double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vdcx_t)));

          d_DFb_dV_s_c = d_DFb_dV_si_ci = d_DFb_dV_b_ci =  0.0;
          d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vdcx_t))));
          d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vdcx_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t))));
          d_DFb_dV_bi_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ci/vdcx_t))));
          d_DFb_dV_bp_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ei/vdcx_t))));
          d_DFb_dV_bp_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ci/vdcx_t))));
          DFb = value_log_0;
        }
        {
          double value_exp_0 = exp(((-(model_.zcx))*DFb));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DFC_j1_dV_s_c = d_DFC_j1_dV_si_ci = d_DFC_j1_dV_b_ci =  0.0;
          d_DFC_j1_dV_bi_ei = (((cjcx02_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei)+((cjcx02_t*(deriv_exp_0_d0*(((-(model_.zcx))*d_DFb_dV_bi_ei))))*DFdvj_dv));
          d_DFC_j1_dV_bi_ci = (((cjcx02_t*value_exp_0)*d_DFdvj_dv_dV_bi_ci)+((cjcx02_t*(deriv_exp_0_d0*(((-(model_.zcx))*d_DFb_dV_bi_ci))))*DFdvj_dv));
          d_DFC_j1_dV_bp_ei = (((cjcx02_t*value_exp_0)*d_DFdvj_dv_dV_bp_ei)+((cjcx02_t*(deriv_exp_0_d0*(((-(model_.zcx))*d_DFb_dV_bp_ei))))*DFdvj_dv));
          d_DFC_j1_dV_bp_ci = (((cjcx02_t*value_exp_0)*d_DFdvj_dv_dV_bp_ci)+((cjcx02_t*(deriv_exp_0_d0*(((-(model_.zcx))*d_DFb_dV_bp_ci))))*DFdvj_dv));
          d_DFC_j1_dV_tnode_GND = (((cjcx02_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND)+(((cjcx02_t*(deriv_exp_0_d0*(((-(model_.zcx))*d_DFb_dV_tnode_GND))))+(d_cjcx02_t_dV_tnode_GND*value_exp_0))*DFdvj_dv));
          DFC_j1 = ((cjcx02_t*value_exp_0)*DFdvj_dv);
        }

        d_CjCx_ii_dV_bi_ei = (d_DFC_j1_dV_bi_ei+((2.4*cjcx02_t)*(-d_DFdvj_dv_dV_bi_ei)));
        d_CjCx_ii_dV_tnode_GND = (d_DFC_j1_dV_tnode_GND+(((2.4*cjcx02_t)*(-d_DFdvj_dv_dV_tnode_GND))+((2.4*d_cjcx02_t_dV_tnode_GND)*(1.0-DFdvj_dv))));
        d_CjCx_ii_dV_bi_ci = (d_DFC_j1_dV_bi_ci+((2.4*cjcx02_t)*(-d_DFdvj_dv_dV_bi_ci)));
        d_CjCx_ii_dV_bp_ei = (d_DFC_j1_dV_bp_ei+((2.4*cjcx02_t)*(-d_DFdvj_dv_dV_bp_ei)));
        d_CjCx_ii_dV_bp_ci = (d_DFC_j1_dV_bp_ci+((2.4*cjcx02_t)*(-d_DFdvj_dv_dV_bp_ci)));
        CjCx_ii = (DFC_j1+((2.4*cjcx02_t)*(1.0-DFdvj_dv)));
        {
          double value_exp_0 = exp((DFb*(1.0-(model_.zcx))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DFQ_j_dV_s_c = d_DFQ_j_dV_si_ci = d_DFQ_j_dV_b_ci =  0.0;
          d_DFQ_j_dV_bi_ei = (((cjcx02_t*vdcx_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bi_ei*(1.0-(model_.zcx)))))))/(1.0-(model_.zcx)));
          d_DFQ_j_dV_bi_ci = (((cjcx02_t*vdcx_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bi_ci*(1.0-(model_.zcx)))))))/(1.0-(model_.zcx)));
          d_DFQ_j_dV_bp_ei = (((cjcx02_t*vdcx_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bp_ei*(1.0-(model_.zcx)))))))/(1.0-(model_.zcx)));
          d_DFQ_j_dV_bp_ci = (((cjcx02_t*vdcx_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bp_ci*(1.0-(model_.zcx)))))))/(1.0-(model_.zcx)));
          d_DFQ_j_dV_tnode_GND = ((((cjcx02_t*vdcx_t)*(-(deriv_exp_0_d0*((d_DFb_dV_tnode_GND*(1.0-(model_.zcx)))))))+(((cjcx02_t*d_vdcx_t_dV_tnode_GND)+(d_cjcx02_t_dV_tnode_GND*vdcx_t))*(1.0-value_exp_0)))/(1.0-(model_.zcx)));
          DFQ_j = (((cjcx02_t*vdcx_t)*(1.0-value_exp_0))/(1.0-(model_.zcx)));
        }

        d_qjcx0_t_ii_dV_bi_ei = (d_DFQ_j_dV_bi_ei+((2.4*cjcx02_t)*(-d_DFv_j_dV_bi_ei)));
        d_qjcx0_t_ii_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+(((2.4*cjcx02_t)*(-d_DFv_j_dV_tnode_GND))+((2.4*d_cjcx02_t_dV_tnode_GND)*(Vbpci-DFv_j))));
        d_qjcx0_t_ii_dV_bi_ci = (d_DFQ_j_dV_bi_ci+((2.4*cjcx02_t)*(-d_DFv_j_dV_bi_ci)));
        d_qjcx0_t_ii_dV_bp_ei = (d_DFQ_j_dV_bp_ei+((2.4*cjcx02_t)*(-d_DFv_j_dV_bp_ei)));
        d_qjcx0_t_ii_dV_bp_ci = (d_DFQ_j_dV_bp_ci+((2.4*cjcx02_t)*(d_Vbpci_dV_bp_ci-d_DFv_j_dV_bp_ci)));
        qjcx0_t_ii = (DFQ_j+((2.4*cjcx02_t)*(Vbpci-DFv_j)));
      }
      else
      {

        d_CjCx_ii_dV_bp_ei = d_CjCx_ii_dV_bi_ei = d_CjCx_ii_dV_bp_ci = d_CjCx_ii_dV_tnode_GND = d_CjCx_ii_dV_bi_ci =  0.0;
        CjCx_ii = 0.0;

        d_qjcx0_t_ii_dV_bp_ei = d_qjcx0_t_ii_dV_bi_ei = d_qjcx0_t_ii_dV_bp_ci = d_qjcx0_t_ii_dV_tnode_GND = d_qjcx0_t_ii_dV_bi_ci =  0.0;
        qjcx0_t_ii = 0.0;
      }
    }

    d_DIOY_dV_si_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei =  0.0;
    d_DIOY_dV_tnode_GND = (-Vbpci*((model_.mbcx)*d_VT_dV_tnode_GND)/((model_.mbcx)*VT)/((model_.mbcx)*VT));
    d_DIOY_dV_bp_ci = (d_Vbpci_dV_bp_ci/((model_.mbcx)*VT));
    DIOY = (Vbpci/((model_.mbcx)*VT));
    if (((model_.ibcxs)>0.0))
    {
      if ((DIOY>80.0))
      {

        d_le_dV_si_ci =  0.0;
        d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
        d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
        d_le_dV_bi_ci = d_DIOY_dV_bi_ci;
        d_le_dV_bp_ei = d_DIOY_dV_bp_ei;
        d_le_dV_bp_ci = d_DIOY_dV_bp_ci;
        le = (1+(DIOY-80.0));

        d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
        DIOY = 80.0;
      }
      else
      {

        d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
        le = 1;
      }
      {
        double value_limexp_0 = limexp(DIOY);
        double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

        d_le_dV_si_ci =  0.0;
        d_le_dV_tnode_GND = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND)))+(d_le_dV_tnode_GND*value_limexp_0));
        d_le_dV_bi_ei = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei)))+(d_le_dV_bi_ei*value_limexp_0));
        d_le_dV_bi_ci = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ci)))+(d_le_dV_bi_ci*value_limexp_0));
        d_le_dV_bp_ei = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bp_ei)))+(d_le_dV_bp_ei*value_limexp_0));
        d_le_dV_bp_ci = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bp_ci)))+(d_le_dV_bp_ci*value_limexp_0));
        le = (le*value_limexp_0);
      }

      d_ijbcx_dV_bi_ei = (ibcxs_t*d_le_dV_bi_ei);
      d_ijbcx_dV_bi_ci = (ibcxs_t*d_le_dV_bi_ci);
      d_ijbcx_dV_bp_ei = (ibcxs_t*d_le_dV_bp_ei);
      d_ijbcx_dV_bp_ci = (ibcxs_t*d_le_dV_bp_ci);
      d_ijbcx_dV_tnode_GND = ((ibcxs_t*d_le_dV_tnode_GND)+(d_ibcxs_t_dV_tnode_GND*(le-1.0)));
      ijbcx = (ibcxs_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {

        d_ijbcx_dV_bp_ci = d_ijbcx_dV_bp_ei = d_ijbcx_dV_bi_ci = d_ijbcx_dV_bi_ei =  0.0;
        d_ijbcx_dV_tnode_GND = (-d_ibcxs_t_dV_tnode_GND);
        ijbcx = (-ibcxs_t);
      }
    }
    else
    {

      d_ijbcx_dV_tnode_GND = d_ijbcx_dV_bp_ci = d_ijbcx_dV_bp_ei = d_ijbcx_dV_bi_ci = d_ijbcx_dV_bi_ei =  0.0;
      ijbcx = 0.0;
    }
    if ((vptcx_t<1.0e2))
    {
      if ((cjcx01_t>0.0))
      {
        Dz_r = ((model_.zcx)/4.0);

        d_Dv_p_dV_tnode_GND = (d_vptcx_t_dV_tnode_GND-d_vdcx_t_dV_tnode_GND);
        Dv_p = (vptcx_t-vdcx_t);
        {
          double value_log_0 = log(static_cast<double>(2.4));
          double value_exp_1 = exp(((-value_log_0)/(model_.zcx)));

          d_DV_f_dV_tnode_GND = (d_vdcx_t_dV_tnode_GND*(1.0-value_exp_1));
          DV_f = (vdcx_t*(1.0-value_exp_1));
        }

        d_DC_max_dV_tnode_GND = (2.4*d_cjcx01_t_dV_tnode_GND);
        DC_max = (2.4*cjcx01_t);
        {
          double value_log_0 = log((vptcx_t/vdcx_t));
          double value_exp_1 = exp(((Dz_r-(model_.zcx))*value_log_0));
          double  deriv_log_0_d0 = (1.0/(vptcx_t/vdcx_t));
          double  deriv_exp_1_d0 = value_exp_1;

          d_DC_c_dV_tnode_GND = ((cjcx01_t*(deriv_exp_1_d0*(((Dz_r-(model_.zcx))*(deriv_log_0_d0*(((vdcx_t*d_vptcx_t_dV_tnode_GND-vptcx_t*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t)))))))+(d_cjcx01_t_dV_tnode_GND*value_exp_1));
          DC_c = (cjcx01_t*value_exp_1);
        }

        d_Dv_e_dV_s_c = d_Dv_e_dV_si_ci = d_Dv_e_dV_bp_ci = d_Dv_e_dV_bi_ci =  0.0;
        d_Dv_e_dV_b_ci = ((-d_Vbci_dV_b_ci)/VT);
        d_Dv_e_dV_tnode_GND = ((VT*d_DV_f_dV_tnode_GND-(DV_f-Vbci)*d_VT_dV_tnode_GND)/VT/VT);
        Dv_e = ((DV_f-Vbci)/VT);
        if ((Dv_e<80.0))
        {
          {
            double value_exp_0 = exp(Dv_e);
            double  deriv_exp_0_d0 = value_exp_0;

            d_De_dV_s_c = d_De_dV_si_ci =  0.0;
            d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bi_ci));
            d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_e_dV_tnode_GND));
            d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bp_ci));
            d_De_dV_b_ci = (deriv_exp_0_d0*(d_Dv_e_dV_b_ci));
            De = value_exp_0;
          }

          d_De_1_dV_s_c = d_De_1_dV_si_ci =  0.0;
          d_De_1_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
          d_De_1_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
          d_De_1_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
          d_De_1_dV_b_ci = (((1.0+De)*d_De_dV_b_ci-De*d_De_dV_b_ci)/(1.0+De)/(1.0+De));
          De_1 = (De/(1.0+De));
          {
            double value_log_0 = log((1.0+De));
            double  deriv_log_0_d0 = (1.0/(1.0+De));

            d_Dv_j1_dV_s_c = d_Dv_j1_dV_si_ci =  0.0;
            d_Dv_j1_dV_bi_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_bi_ci))));
            d_Dv_j1_dV_bp_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_bp_ci))));
            d_Dv_j1_dV_b_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_b_ci))));
            d_Dv_j1_dV_tnode_GND = (d_DV_f_dV_tnode_GND-((VT*(deriv_log_0_d0*(d_De_dV_tnode_GND)))+(d_VT_dV_tnode_GND*value_log_0)));
            Dv_j1 = (DV_f-(VT*value_log_0));
          }
        }
        else
        {

          d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci = d_De_1_dV_bp_ci = d_De_1_dV_tnode_GND = d_De_1_dV_bi_ci =  0.0;
          De_1 = 1.0;

          d_Dv_j1_dV_s_c = d_Dv_j1_dV_si_ci = d_Dv_j1_dV_bp_ci = d_Dv_j1_dV_tnode_GND = d_Dv_j1_dV_bi_ci =  0.0;
          d_Dv_j1_dV_b_ci = d_Vbci_dV_b_ci;
          Dv_j1 = Vbci;
        }

        d_Da_dV_tnode_GND = ((0.1*d_Dv_p_dV_tnode_GND)+(4.0*d_VT_dV_tnode_GND));
        Da = ((0.1*Dv_p)+(4.0*VT));

        d_Dv_r_dV_s_c = d_Dv_r_dV_si_ci =  0.0;
        d_Dv_r_dV_bi_ci = (d_Dv_j1_dV_bi_ci/Da);
        d_Dv_r_dV_bp_ci = (d_Dv_j1_dV_bp_ci/Da);
        d_Dv_r_dV_b_ci = (d_Dv_j1_dV_b_ci/Da);
        d_Dv_r_dV_tnode_GND = ((Da*(d_Dv_p_dV_tnode_GND+d_Dv_j1_dV_tnode_GND)-(Dv_p+Dv_j1)*d_Da_dV_tnode_GND)/Da/Da);
        Dv_r = ((Dv_p+Dv_j1)/Da);
        if ((Dv_r<80.0))
        {
          {
            double value_exp_0 = exp(Dv_r);
            double  deriv_exp_0_d0 = value_exp_0;

            d_De_dV_s_c = d_De_dV_si_ci =  0.0;
            d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bi_ci));
            d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_r_dV_tnode_GND));
            d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bp_ci));
            d_De_dV_b_ci = (deriv_exp_0_d0*(d_Dv_r_dV_b_ci));
            De = value_exp_0;
          }

          d_De_2_dV_s_c = d_De_2_dV_si_ci =  0.0;
          d_De_2_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
          d_De_2_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
          d_De_2_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
          d_De_2_dV_b_ci = (((1.0+De)*d_De_dV_b_ci-De*d_De_dV_b_ci)/(1.0+De)/(1.0+De));
          De_2 = (De/(1.0+De));
          {
            double value_log_0 = log((1.0+De));
            double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
            double  deriv_log_0_d0 = (1.0/(1.0+De));
            double  deriv_exp_1_d0 = value_exp_1;

            d_Dv_j2_dV_s_c = d_Dv_j2_dV_si_ci =  0.0;
            d_Dv_j2_dV_bi_ci = (Da*(deriv_log_0_d0*(d_De_dV_bi_ci)));
            d_Dv_j2_dV_bp_ci = (Da*(deriv_log_0_d0*(d_De_dV_bp_ci)));
            d_Dv_j2_dV_b_ci = (Da*(deriv_log_0_d0*(d_De_dV_b_ci)));
            d_Dv_j2_dV_tnode_GND = ((-d_Dv_p_dV_tnode_GND)+((Da*((deriv_log_0_d0*(d_De_dV_tnode_GND))-(deriv_exp_1_d0*(((Da*(-(d_Dv_p_dV_tnode_GND+d_DV_f_dV_tnode_GND))-(-(Dv_p+DV_f))*d_Da_dV_tnode_GND)/Da/Da)))))+(d_Da_dV_tnode_GND*(value_log_0-value_exp_1))));
            Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
          }
        }
        else
        {

          d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci = d_De_2_dV_bp_ci = d_De_2_dV_tnode_GND = d_De_2_dV_bi_ci =  0.0;
          De_2 = 1.0;

          d_Dv_j2_dV_s_c = d_Dv_j2_dV_si_ci =  0.0;
          d_Dv_j2_dV_bi_ci = d_Dv_j1_dV_bi_ci;
          d_Dv_j2_dV_tnode_GND = d_Dv_j1_dV_tnode_GND;
          d_Dv_j2_dV_bp_ci = d_Dv_j1_dV_bp_ci;
          d_Dv_j2_dV_b_ci = d_Dv_j1_dV_b_ci;
          Dv_j2 = Dv_j1;
        }

        d_Dv_j4_dV_s_c = d_Dv_j4_dV_si_ci =  0.0;
        d_Dv_j4_dV_bi_ci = (-d_Dv_j1_dV_bi_ci);
        d_Dv_j4_dV_tnode_GND = (-d_Dv_j1_dV_tnode_GND);
        d_Dv_j4_dV_bp_ci = (-d_Dv_j1_dV_bp_ci);
        d_Dv_j4_dV_b_ci = (d_Vbci_dV_b_ci-d_Dv_j1_dV_b_ci);
        Dv_j4 = (Vbci-Dv_j1);
        {
          double value_log_0 = log((1.0-(Dv_j1/vdcx_t)));
          double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/vdcx_t)));

          d_DCln1_dV_s_c = d_DCln1_dV_si_ci =  0.0;
          d_DCln1_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bi_ci/vdcx_t))));
          d_DCln1_dV_tnode_GND = (deriv_log_0_d0*((-((vdcx_t*d_Dv_j1_dV_tnode_GND-Dv_j1*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t))));
          d_DCln1_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bp_ci/vdcx_t))));
          d_DCln1_dV_b_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_b_ci/vdcx_t))));
          DCln1 = value_log_0;
        }
        {
          double value_log_0 = log((1.0-(Dv_j2/vdcx_t)));
          double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/vdcx_t)));

          d_DCln2_dV_s_c = d_DCln2_dV_si_ci =  0.0;
          d_DCln2_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bi_ci/vdcx_t))));
          d_DCln2_dV_tnode_GND = (deriv_log_0_d0*((-((vdcx_t*d_Dv_j2_dV_tnode_GND-Dv_j2*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t))));
          d_DCln2_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bp_ci/vdcx_t))));
          d_DCln2_dV_b_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_b_ci/vdcx_t))));
          DCln2 = value_log_0;
        }
        Dz1 = (1.0-(model_.zcx));
        Dzr1 = (1.0-Dz_r);
        {
          double value_exp_0 = exp((DCln2*(-(model_.zcx))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DC_j1_dV_s_c = d_DC_j1_dV_si_ci =  0.0;
          d_DC_j1_dV_bi_ci = ((((cjcx01_t*value_exp_0)*De_1)*d_De_2_dV_bi_ci)+((((cjcx01_t*value_exp_0)*d_De_1_dV_bi_ci)+((cjcx01_t*(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*(-(model_.zcx))))))*De_1))*De_2));
          d_DC_j1_dV_bp_ci = ((((cjcx01_t*value_exp_0)*De_1)*d_De_2_dV_bp_ci)+((((cjcx01_t*value_exp_0)*d_De_1_dV_bp_ci)+((cjcx01_t*(deriv_exp_0_d0*((d_DCln2_dV_bp_ci*(-(model_.zcx))))))*De_1))*De_2));
          d_DC_j1_dV_b_ci = ((((cjcx01_t*value_exp_0)*De_1)*d_De_2_dV_b_ci)+((((cjcx01_t*value_exp_0)*d_De_1_dV_b_ci)+((cjcx01_t*(deriv_exp_0_d0*((d_DCln2_dV_b_ci*(-(model_.zcx))))))*De_1))*De_2));
          d_DC_j1_dV_tnode_GND = ((((cjcx01_t*value_exp_0)*De_1)*d_De_2_dV_tnode_GND)+((((cjcx01_t*value_exp_0)*d_De_1_dV_tnode_GND)+(((cjcx01_t*(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*(-(model_.zcx))))))+(d_cjcx01_t_dV_tnode_GND*value_exp_0))*De_1))*De_2));
          DC_j1 = (((cjcx01_t*value_exp_0)*De_1)*De_2);
        }
        {
          double value_exp_0 = exp((DCln1*(-Dz_r)));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DC_j2_dV_s_c = d_DC_j2_dV_si_ci =  0.0;
          d_DC_j2_dV_bi_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_bi_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_bi_ci*(-Dz_r)))))*(1.0-De_2)));
          d_DC_j2_dV_bp_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_bp_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_bp_ci*(-Dz_r)))))*(1.0-De_2)));
          d_DC_j2_dV_b_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_b_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_b_ci*(-Dz_r)))))*(1.0-De_2)));
          d_DC_j2_dV_tnode_GND = (((DC_c*value_exp_0)*(-d_De_2_dV_tnode_GND))+(((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_tnode_GND*(-Dz_r)))))+(d_DC_c_dV_tnode_GND*value_exp_0))*(1.0-De_2)));
          DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
        }

        d_DC_j3_dV_s_c = d_DC_j3_dV_si_ci =  0.0;
        d_DC_j3_dV_bi_ci = (DC_max*(-d_De_1_dV_bi_ci));
        d_DC_j3_dV_bp_ci = (DC_max*(-d_De_1_dV_bp_ci));
        d_DC_j3_dV_b_ci = (DC_max*(-d_De_1_dV_b_ci));
        d_DC_j3_dV_tnode_GND = ((DC_max*(-d_De_1_dV_tnode_GND))+(d_DC_max_dV_tnode_GND*(1.0-De_1)));
        DC_j3 = (DC_max*(1.0-De_1));

        d_CjCx_i_dV_bp_ei = d_CjCx_i_dV_bi_ei =  0.0;
        d_CjCx_i_dV_bi_ci = ((d_DC_j1_dV_bi_ci+d_DC_j2_dV_bi_ci)+d_DC_j3_dV_bi_ci);
        d_CjCx_i_dV_tnode_GND = ((d_DC_j1_dV_tnode_GND+d_DC_j2_dV_tnode_GND)+d_DC_j3_dV_tnode_GND);
        d_CjCx_i_dV_bp_ci = ((d_DC_j1_dV_bp_ci+d_DC_j2_dV_bp_ci)+d_DC_j3_dV_bp_ci);
        d_CjCx_i_dV_b_ci = ((d_DC_j1_dV_b_ci+d_DC_j2_dV_b_ci)+d_DC_j3_dV_b_ci);
        CjCx_i = ((DC_j1+DC_j2)+DC_j3);
        {
          double value_exp_0 = exp((DCln2*Dz1));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DQ_j1_dV_s_c = d_DQ_j1_dV_si_ci =  0.0;
          d_DQ_j1_dV_bi_ci = ((cjcx01_t*(-(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*Dz1)))))/Dz1);
          d_DQ_j1_dV_bp_ci = ((cjcx01_t*(-(deriv_exp_0_d0*((d_DCln2_dV_bp_ci*Dz1)))))/Dz1);
          d_DQ_j1_dV_b_ci = ((cjcx01_t*(-(deriv_exp_0_d0*((d_DCln2_dV_b_ci*Dz1)))))/Dz1);
          d_DQ_j1_dV_tnode_GND = (((cjcx01_t*(-(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*Dz1)))))+(d_cjcx01_t_dV_tnode_GND*(1.0-value_exp_0)))/Dz1);
          DQ_j1 = ((cjcx01_t*(1.0-value_exp_0))/Dz1);
        }
        {
          double value_exp_0 = exp((DCln1*Dzr1));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DQ_j2_dV_s_c = d_DQ_j2_dV_si_ci =  0.0;
          d_DQ_j2_dV_bi_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_bi_ci*Dzr1)))))/Dzr1);
          d_DQ_j2_dV_bp_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_bp_ci*Dzr1)))))/Dzr1);
          d_DQ_j2_dV_b_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_b_ci*Dzr1)))))/Dzr1);
          d_DQ_j2_dV_tnode_GND = (((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_tnode_GND*Dzr1)))))+(d_DC_c_dV_tnode_GND*(1.0-value_exp_0)))/Dzr1);
          DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }
        {
          double value_exp_0 = exp((DCln2*Dzr1));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DQ_j3_dV_s_c = d_DQ_j3_dV_si_ci =  0.0;
          d_DQ_j3_dV_bi_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*Dzr1)))))/Dzr1);
          d_DQ_j3_dV_bp_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_bp_ci*Dzr1)))))/Dzr1);
          d_DQ_j3_dV_b_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_b_ci*Dzr1)))))/Dzr1);
          d_DQ_j3_dV_tnode_GND = (((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*Dzr1)))))+(d_DC_c_dV_tnode_GND*(1.0-value_exp_0)))/Dzr1);
          DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }

        d_qjcx0_t_i_dV_bp_ei = d_qjcx0_t_i_dV_bi_ei =  0.0;
        d_qjcx0_t_i_dV_bi_ci = ((((d_DQ_j1_dV_bi_ci+d_DQ_j2_dV_bi_ci)-d_DQ_j3_dV_bi_ci)*vdcx_t)+(DC_max*d_Dv_j4_dV_bi_ci));
        d_qjcx0_t_i_dV_tnode_GND = (((((DQ_j1+DQ_j2)-DQ_j3)*d_vdcx_t_dV_tnode_GND)+(((d_DQ_j1_dV_tnode_GND+d_DQ_j2_dV_tnode_GND)-d_DQ_j3_dV_tnode_GND)*vdcx_t))+((DC_max*d_Dv_j4_dV_tnode_GND)+(d_DC_max_dV_tnode_GND*Dv_j4)));
        d_qjcx0_t_i_dV_bp_ci = ((((d_DQ_j1_dV_bp_ci+d_DQ_j2_dV_bp_ci)-d_DQ_j3_dV_bp_ci)*vdcx_t)+(DC_max*d_Dv_j4_dV_bp_ci));
        d_qjcx0_t_i_dV_b_ci = ((((d_DQ_j1_dV_b_ci+d_DQ_j2_dV_b_ci)-d_DQ_j3_dV_b_ci)*vdcx_t)+(DC_max*d_Dv_j4_dV_b_ci));
        qjcx0_t_i = ((((DQ_j1+DQ_j2)-DQ_j3)*vdcx_t)+(DC_max*Dv_j4));
      }
      else
      {

        d_CjCx_i_dV_bp_ei = d_CjCx_i_dV_bi_ei = d_CjCx_i_dV_b_ci = d_CjCx_i_dV_bp_ci = d_CjCx_i_dV_tnode_GND = d_CjCx_i_dV_bi_ci =  0.0;
        CjCx_i = 0.0;

        d_qjcx0_t_i_dV_bp_ei = d_qjcx0_t_i_dV_bi_ei = d_qjcx0_t_i_dV_b_ci = d_qjcx0_t_i_dV_bp_ci = d_qjcx0_t_i_dV_tnode_GND = d_qjcx0_t_i_dV_bi_ci =  0.0;
        qjcx0_t_i = 0.0;
      }
    }
    else
    {
      if ((cjcx01_t>0.0))
      {
        {
          double value_log_0 = log(static_cast<double>(2.4));
          double value_exp_1 = exp(((-value_log_0)/(model_.zcx)));

          d_DFV_f_dV_tnode_GND = (d_vdcx_t_dV_tnode_GND*(1.0-value_exp_1));
          DFV_f = (vdcx_t*(1.0-value_exp_1));
        }

        d_DFv_e_dV_s_c = d_DFv_e_dV_si_ci = d_DFv_e_dV_bp_ci = d_DFv_e_dV_bp_ei = d_DFv_e_dV_bi_ci = d_DFv_e_dV_bi_ei =  0.0;
        d_DFv_e_dV_b_ci = ((-d_Vbci_dV_b_ci)/VT);
        d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vbci)*d_VT_dV_tnode_GND)/VT/VT);
        DFv_e = ((DFV_f-Vbci)/VT);
        {
          double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_DFs_q_dV_s_c = d_DFs_q_dV_si_ci =  0.0;
          d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bi_ei)+(d_DFv_e_dV_bi_ei*DFv_e))));
          d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_tnode_GND)+(d_DFv_e_dV_tnode_GND*DFv_e))));
          d_DFs_q_dV_bi_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bi_ci)+(d_DFv_e_dV_bi_ci*DFv_e))));
          d_DFs_q_dV_bp_ei = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bp_ei)+(d_DFv_e_dV_bp_ei*DFv_e))));
          d_DFs_q_dV_bp_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bp_ci)+(d_DFv_e_dV_bp_ci*DFv_e))));
          d_DFs_q_dV_b_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_b_ci)+(d_DFv_e_dV_b_ci*DFv_e))));
          DFs_q = value_sqrt_0;
        }

        d_DFs_q2_dV_s_c = d_DFs_q2_dV_si_ci =  0.0;
        d_DFs_q2_dV_bi_ei = ((d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5);
        d_DFs_q2_dV_tnode_GND = ((d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5);
        d_DFs_q2_dV_bi_ci = ((d_DFv_e_dV_bi_ci+d_DFs_q_dV_bi_ci)*0.5);
        d_DFs_q2_dV_bp_ei = ((d_DFv_e_dV_bp_ei+d_DFs_q_dV_bp_ei)*0.5);
        d_DFs_q2_dV_bp_ci = ((d_DFv_e_dV_bp_ci+d_DFs_q_dV_bp_ci)*0.5);
        d_DFs_q2_dV_b_ci = ((d_DFv_e_dV_b_ci+d_DFs_q_dV_b_ci)*0.5);
        DFs_q2 = ((DFv_e+DFs_q)*0.5);

        d_DFv_j_dV_s_c = d_DFv_j_dV_si_ci =  0.0;
        d_DFv_j_dV_bi_ei = (-(VT*d_DFs_q2_dV_bi_ei));
        d_DFv_j_dV_bi_ci = (-(VT*d_DFs_q2_dV_bi_ci));
        d_DFv_j_dV_bp_ei = (-(VT*d_DFs_q2_dV_bp_ei));
        d_DFv_j_dV_bp_ci = (-(VT*d_DFs_q2_dV_bp_ci));
        d_DFv_j_dV_b_ci = (-(VT*d_DFs_q2_dV_b_ci));
        d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-((VT*d_DFs_q2_dV_tnode_GND)+(d_VT_dV_tnode_GND*DFs_q2)));
        DFv_j = (DFV_f-(VT*DFs_q2));

        d_DFdvj_dv_dV_s_c = d_DFdvj_dv_dV_si_ci =  0.0;
        d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_bi_ci = ((DFs_q*d_DFs_q2_dV_bi_ci-DFs_q2*d_DFs_q_dV_bi_ci)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_bp_ei = ((DFs_q*d_DFs_q2_dV_bp_ei-DFs_q2*d_DFs_q_dV_bp_ei)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_bp_ci = ((DFs_q*d_DFs_q2_dV_bp_ci-DFs_q2*d_DFs_q_dV_bp_ci)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_b_ci = ((DFs_q*d_DFs_q2_dV_b_ci-DFs_q2*d_DFs_q_dV_b_ci)/DFs_q/DFs_q);
        DFdvj_dv = (DFs_q2/DFs_q);
        {
          double value_log_0 = log((1.0-(DFv_j/vdcx_t)));
          double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vdcx_t)));

          d_DFb_dV_s_c = d_DFb_dV_si_ci =  0.0;
          d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vdcx_t))));
          d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vdcx_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t))));
          d_DFb_dV_bi_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ci/vdcx_t))));
          d_DFb_dV_bp_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ei/vdcx_t))));
          d_DFb_dV_bp_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ci/vdcx_t))));
          d_DFb_dV_b_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_b_ci/vdcx_t))));
          DFb = value_log_0;
        }
        {
          double value_exp_0 = exp(((-(model_.zcx))*DFb));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DFC_j1_dV_s_c = d_DFC_j1_dV_si_ci =  0.0;
          d_DFC_j1_dV_bi_ei = (((cjcx01_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei)+((cjcx01_t*(deriv_exp_0_d0*(((-(model_.zcx))*d_DFb_dV_bi_ei))))*DFdvj_dv));
          d_DFC_j1_dV_bi_ci = (((cjcx01_t*value_exp_0)*d_DFdvj_dv_dV_bi_ci)+((cjcx01_t*(deriv_exp_0_d0*(((-(model_.zcx))*d_DFb_dV_bi_ci))))*DFdvj_dv));
          d_DFC_j1_dV_bp_ei = (((cjcx01_t*value_exp_0)*d_DFdvj_dv_dV_bp_ei)+((cjcx01_t*(deriv_exp_0_d0*(((-(model_.zcx))*d_DFb_dV_bp_ei))))*DFdvj_dv));
          d_DFC_j1_dV_bp_ci = (((cjcx01_t*value_exp_0)*d_DFdvj_dv_dV_bp_ci)+((cjcx01_t*(deriv_exp_0_d0*(((-(model_.zcx))*d_DFb_dV_bp_ci))))*DFdvj_dv));
          d_DFC_j1_dV_b_ci = (((cjcx01_t*value_exp_0)*d_DFdvj_dv_dV_b_ci)+((cjcx01_t*(deriv_exp_0_d0*(((-(model_.zcx))*d_DFb_dV_b_ci))))*DFdvj_dv));
          d_DFC_j1_dV_tnode_GND = (((cjcx01_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND)+(((cjcx01_t*(deriv_exp_0_d0*(((-(model_.zcx))*d_DFb_dV_tnode_GND))))+(d_cjcx01_t_dV_tnode_GND*value_exp_0))*DFdvj_dv));
          DFC_j1 = ((cjcx01_t*value_exp_0)*DFdvj_dv);
        }

        d_CjCx_i_dV_bi_ei = (d_DFC_j1_dV_bi_ei+((2.4*cjcx01_t)*(-d_DFdvj_dv_dV_bi_ei)));
        d_CjCx_i_dV_tnode_GND = (d_DFC_j1_dV_tnode_GND+(((2.4*cjcx01_t)*(-d_DFdvj_dv_dV_tnode_GND))+((2.4*d_cjcx01_t_dV_tnode_GND)*(1.0-DFdvj_dv))));
        d_CjCx_i_dV_bi_ci = (d_DFC_j1_dV_bi_ci+((2.4*cjcx01_t)*(-d_DFdvj_dv_dV_bi_ci)));
        d_CjCx_i_dV_bp_ei = (d_DFC_j1_dV_bp_ei+((2.4*cjcx01_t)*(-d_DFdvj_dv_dV_bp_ei)));
        d_CjCx_i_dV_bp_ci = (d_DFC_j1_dV_bp_ci+((2.4*cjcx01_t)*(-d_DFdvj_dv_dV_bp_ci)));
        d_CjCx_i_dV_b_ci = (d_DFC_j1_dV_b_ci+((2.4*cjcx01_t)*(-d_DFdvj_dv_dV_b_ci)));
        CjCx_i = (DFC_j1+((2.4*cjcx01_t)*(1.0-DFdvj_dv)));
        {
          double value_exp_0 = exp((DFb*(1.0-(model_.zcx))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DFQ_j_dV_s_c = d_DFQ_j_dV_si_ci =  0.0;
          d_DFQ_j_dV_bi_ei = (((cjcx01_t*vdcx_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bi_ei*(1.0-(model_.zcx)))))))/(1.0-(model_.zcx)));
          d_DFQ_j_dV_bi_ci = (((cjcx01_t*vdcx_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bi_ci*(1.0-(model_.zcx)))))))/(1.0-(model_.zcx)));
          d_DFQ_j_dV_bp_ei = (((cjcx01_t*vdcx_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bp_ei*(1.0-(model_.zcx)))))))/(1.0-(model_.zcx)));
          d_DFQ_j_dV_bp_ci = (((cjcx01_t*vdcx_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bp_ci*(1.0-(model_.zcx)))))))/(1.0-(model_.zcx)));
          d_DFQ_j_dV_b_ci = (((cjcx01_t*vdcx_t)*(-(deriv_exp_0_d0*((d_DFb_dV_b_ci*(1.0-(model_.zcx)))))))/(1.0-(model_.zcx)));
          d_DFQ_j_dV_tnode_GND = ((((cjcx01_t*vdcx_t)*(-(deriv_exp_0_d0*((d_DFb_dV_tnode_GND*(1.0-(model_.zcx)))))))+(((cjcx01_t*d_vdcx_t_dV_tnode_GND)+(d_cjcx01_t_dV_tnode_GND*vdcx_t))*(1.0-value_exp_0)))/(1.0-(model_.zcx)));
          DFQ_j = (((cjcx01_t*vdcx_t)*(1.0-value_exp_0))/(1.0-(model_.zcx)));
        }

        d_qjcx0_t_i_dV_bi_ei = (d_DFQ_j_dV_bi_ei+((2.4*cjcx01_t)*(-d_DFv_j_dV_bi_ei)));
        d_qjcx0_t_i_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+(((2.4*cjcx01_t)*(-d_DFv_j_dV_tnode_GND))+((2.4*d_cjcx01_t_dV_tnode_GND)*(Vbci-DFv_j))));
        d_qjcx0_t_i_dV_bi_ci = (d_DFQ_j_dV_bi_ci+((2.4*cjcx01_t)*(-d_DFv_j_dV_bi_ci)));
        d_qjcx0_t_i_dV_bp_ei = (d_DFQ_j_dV_bp_ei+((2.4*cjcx01_t)*(-d_DFv_j_dV_bp_ei)));
        d_qjcx0_t_i_dV_bp_ci = (d_DFQ_j_dV_bp_ci+((2.4*cjcx01_t)*(-d_DFv_j_dV_bp_ci)));
        d_qjcx0_t_i_dV_b_ci = (d_DFQ_j_dV_b_ci+((2.4*cjcx01_t)*(d_Vbci_dV_b_ci-d_DFv_j_dV_b_ci)));
        qjcx0_t_i = (DFQ_j+((2.4*cjcx01_t)*(Vbci-DFv_j)));
      }
      else
      {

        d_CjCx_i_dV_bp_ei = d_CjCx_i_dV_bi_ei = d_CjCx_i_dV_b_ci = d_CjCx_i_dV_bp_ci = d_CjCx_i_dV_tnode_GND = d_CjCx_i_dV_bi_ci =  0.0;
        CjCx_i = 0.0;

        d_qjcx0_t_i_dV_bp_ei = d_qjcx0_t_i_dV_bi_ei = d_qjcx0_t_i_dV_b_ci = d_qjcx0_t_i_dV_bp_ci = d_qjcx0_t_i_dV_tnode_GND = d_qjcx0_t_i_dV_bi_ci =  0.0;
        qjcx0_t_i = 0.0;
      }
    }
    if ((vpts_t<1.0e2))
    {
      if ((cjs0_t>0.0))
      {
        Dz_r = ((model_.zs)/4.0);

        d_Dv_p_dV_tnode_GND = (d_vpts_t_dV_tnode_GND-d_vds_t_dV_tnode_GND);
        Dv_p = (vpts_t-vds_t);
        {
          double value_log_0 = log(static_cast<double>(2.4));
          double value_exp_1 = exp(((-value_log_0)/(model_.zs)));

          d_DV_f_dV_tnode_GND = (d_vds_t_dV_tnode_GND*(1.0-value_exp_1));
          DV_f = (vds_t*(1.0-value_exp_1));
        }

        d_DC_max_dV_tnode_GND = (2.4*d_cjs0_t_dV_tnode_GND);
        DC_max = (2.4*cjs0_t);
        {
          double value_log_0 = log((vpts_t/vds_t));
          double value_exp_1 = exp(((Dz_r-(model_.zs))*value_log_0));
          double  deriv_log_0_d0 = (1.0/(vpts_t/vds_t));
          double  deriv_exp_1_d0 = value_exp_1;

          d_DC_c_dV_tnode_GND = ((cjs0_t*(deriv_exp_1_d0*(((Dz_r-(model_.zs))*(deriv_log_0_d0*(((vds_t*d_vpts_t_dV_tnode_GND-vpts_t*d_vds_t_dV_tnode_GND)/vds_t/vds_t)))))))+(d_cjs0_t_dV_tnode_GND*value_exp_1));
          DC_c = (cjs0_t*value_exp_1);
        }

        d_Dv_e_dV_s_c = d_Dv_e_dV_b_ci = d_Dv_e_dV_bp_ci = d_Dv_e_dV_bi_ci =  0.0;
        d_Dv_e_dV_si_ci = ((-d_Vsici_dV_si_ci)/VT);
        d_Dv_e_dV_tnode_GND = ((VT*d_DV_f_dV_tnode_GND-(DV_f-Vsici)*d_VT_dV_tnode_GND)/VT/VT);
        Dv_e = ((DV_f-Vsici)/VT);
        if ((Dv_e<80.0))
        {
          {
            double value_exp_0 = exp(Dv_e);
            double  deriv_exp_0_d0 = value_exp_0;

            d_De_dV_s_c =  0.0;
            d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bi_ci));
            d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_e_dV_tnode_GND));
            d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bp_ci));
            d_De_dV_b_ci = (deriv_exp_0_d0*(d_Dv_e_dV_b_ci));
            d_De_dV_si_ci = (deriv_exp_0_d0*(d_Dv_e_dV_si_ci));
            De = value_exp_0;
          }

          d_De_1_dV_s_c =  0.0;
          d_De_1_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
          d_De_1_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
          d_De_1_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
          d_De_1_dV_b_ci = (((1.0+De)*d_De_dV_b_ci-De*d_De_dV_b_ci)/(1.0+De)/(1.0+De));
          d_De_1_dV_si_ci = (((1.0+De)*d_De_dV_si_ci-De*d_De_dV_si_ci)/(1.0+De)/(1.0+De));
          De_1 = (De/(1.0+De));
          {
            double value_log_0 = log((1.0+De));
            double  deriv_log_0_d0 = (1.0/(1.0+De));

            d_Dv_j1_dV_s_c =  0.0;
            d_Dv_j1_dV_bi_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_bi_ci))));
            d_Dv_j1_dV_bp_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_bp_ci))));
            d_Dv_j1_dV_b_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_b_ci))));
            d_Dv_j1_dV_si_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_si_ci))));
            d_Dv_j1_dV_tnode_GND = (d_DV_f_dV_tnode_GND-((VT*(deriv_log_0_d0*(d_De_dV_tnode_GND)))+(d_VT_dV_tnode_GND*value_log_0)));
            Dv_j1 = (DV_f-(VT*value_log_0));
          }
        }
        else
        {

          d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci = d_De_1_dV_bp_ci = d_De_1_dV_tnode_GND = d_De_1_dV_bi_ci =  0.0;
          De_1 = 1.0;

          d_Dv_j1_dV_s_c = d_Dv_j1_dV_b_ci = d_Dv_j1_dV_bp_ci = d_Dv_j1_dV_tnode_GND = d_Dv_j1_dV_bi_ci =  0.0;
          d_Dv_j1_dV_si_ci = d_Vsici_dV_si_ci;
          Dv_j1 = Vsici;
        }

        d_Da_dV_tnode_GND = ((0.1*d_Dv_p_dV_tnode_GND)+(4.0*d_VT_dV_tnode_GND));
        Da = ((0.1*Dv_p)+(4.0*VT));

        d_Dv_r_dV_s_c =  0.0;
        d_Dv_r_dV_bi_ci = (d_Dv_j1_dV_bi_ci/Da);
        d_Dv_r_dV_bp_ci = (d_Dv_j1_dV_bp_ci/Da);
        d_Dv_r_dV_b_ci = (d_Dv_j1_dV_b_ci/Da);
        d_Dv_r_dV_si_ci = (d_Dv_j1_dV_si_ci/Da);
        d_Dv_r_dV_tnode_GND = ((Da*(d_Dv_p_dV_tnode_GND+d_Dv_j1_dV_tnode_GND)-(Dv_p+Dv_j1)*d_Da_dV_tnode_GND)/Da/Da);
        Dv_r = ((Dv_p+Dv_j1)/Da);
        if ((Dv_r<80.0))
        {
          {
            double value_exp_0 = exp(Dv_r);
            double  deriv_exp_0_d0 = value_exp_0;

            d_De_dV_s_c =  0.0;
            d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bi_ci));
            d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_r_dV_tnode_GND));
            d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bp_ci));
            d_De_dV_b_ci = (deriv_exp_0_d0*(d_Dv_r_dV_b_ci));
            d_De_dV_si_ci = (deriv_exp_0_d0*(d_Dv_r_dV_si_ci));
            De = value_exp_0;
          }

          d_De_2_dV_s_c =  0.0;
          d_De_2_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
          d_De_2_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
          d_De_2_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
          d_De_2_dV_b_ci = (((1.0+De)*d_De_dV_b_ci-De*d_De_dV_b_ci)/(1.0+De)/(1.0+De));
          d_De_2_dV_si_ci = (((1.0+De)*d_De_dV_si_ci-De*d_De_dV_si_ci)/(1.0+De)/(1.0+De));
          De_2 = (De/(1.0+De));
          {
            double value_log_0 = log((1.0+De));
            double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
            double  deriv_log_0_d0 = (1.0/(1.0+De));
            double  deriv_exp_1_d0 = value_exp_1;

            d_Dv_j2_dV_s_c =  0.0;
            d_Dv_j2_dV_bi_ci = (Da*(deriv_log_0_d0*(d_De_dV_bi_ci)));
            d_Dv_j2_dV_bp_ci = (Da*(deriv_log_0_d0*(d_De_dV_bp_ci)));
            d_Dv_j2_dV_b_ci = (Da*(deriv_log_0_d0*(d_De_dV_b_ci)));
            d_Dv_j2_dV_si_ci = (Da*(deriv_log_0_d0*(d_De_dV_si_ci)));
            d_Dv_j2_dV_tnode_GND = ((-d_Dv_p_dV_tnode_GND)+((Da*((deriv_log_0_d0*(d_De_dV_tnode_GND))-(deriv_exp_1_d0*(((Da*(-(d_Dv_p_dV_tnode_GND+d_DV_f_dV_tnode_GND))-(-(Dv_p+DV_f))*d_Da_dV_tnode_GND)/Da/Da)))))+(d_Da_dV_tnode_GND*(value_log_0-value_exp_1))));
            Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
          }
        }
        else
        {

          d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci = d_De_2_dV_bp_ci = d_De_2_dV_tnode_GND = d_De_2_dV_bi_ci =  0.0;
          De_2 = 1.0;

          d_Dv_j2_dV_s_c =  0.0;
          d_Dv_j2_dV_bi_ci = d_Dv_j1_dV_bi_ci;
          d_Dv_j2_dV_tnode_GND = d_Dv_j1_dV_tnode_GND;
          d_Dv_j2_dV_bp_ci = d_Dv_j1_dV_bp_ci;
          d_Dv_j2_dV_b_ci = d_Dv_j1_dV_b_ci;
          d_Dv_j2_dV_si_ci = d_Dv_j1_dV_si_ci;
          Dv_j2 = Dv_j1;
        }

        d_Dv_j4_dV_s_c =  0.0;
        d_Dv_j4_dV_bi_ci = (-d_Dv_j1_dV_bi_ci);
        d_Dv_j4_dV_tnode_GND = (-d_Dv_j1_dV_tnode_GND);
        d_Dv_j4_dV_bp_ci = (-d_Dv_j1_dV_bp_ci);
        d_Dv_j4_dV_b_ci = (-d_Dv_j1_dV_b_ci);
        d_Dv_j4_dV_si_ci = (d_Vsici_dV_si_ci-d_Dv_j1_dV_si_ci);
        Dv_j4 = (Vsici-Dv_j1);
        {
          double value_log_0 = log((1.0-(Dv_j1/vds_t)));
          double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/vds_t)));

          d_DCln1_dV_s_c =  0.0;
          d_DCln1_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bi_ci/vds_t))));
          d_DCln1_dV_tnode_GND = (deriv_log_0_d0*((-((vds_t*d_Dv_j1_dV_tnode_GND-Dv_j1*d_vds_t_dV_tnode_GND)/vds_t/vds_t))));
          d_DCln1_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bp_ci/vds_t))));
          d_DCln1_dV_b_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_b_ci/vds_t))));
          d_DCln1_dV_si_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_si_ci/vds_t))));
          DCln1 = value_log_0;
        }
        {
          double value_log_0 = log((1.0-(Dv_j2/vds_t)));
          double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/vds_t)));

          d_DCln2_dV_s_c =  0.0;
          d_DCln2_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bi_ci/vds_t))));
          d_DCln2_dV_tnode_GND = (deriv_log_0_d0*((-((vds_t*d_Dv_j2_dV_tnode_GND-Dv_j2*d_vds_t_dV_tnode_GND)/vds_t/vds_t))));
          d_DCln2_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bp_ci/vds_t))));
          d_DCln2_dV_b_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_b_ci/vds_t))));
          d_DCln2_dV_si_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_si_ci/vds_t))));
          DCln2 = value_log_0;
        }
        Dz1 = (1.0-(model_.zs));
        Dzr1 = (1.0-Dz_r);
        {
          double value_exp_0 = exp((DCln2*(-(model_.zs))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DC_j1_dV_s_c =  0.0;
          d_DC_j1_dV_bi_ci = ((((cjs0_t*value_exp_0)*De_1)*d_De_2_dV_bi_ci)+((((cjs0_t*value_exp_0)*d_De_1_dV_bi_ci)+((cjs0_t*(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*(-(model_.zs))))))*De_1))*De_2));
          d_DC_j1_dV_bp_ci = ((((cjs0_t*value_exp_0)*De_1)*d_De_2_dV_bp_ci)+((((cjs0_t*value_exp_0)*d_De_1_dV_bp_ci)+((cjs0_t*(deriv_exp_0_d0*((d_DCln2_dV_bp_ci*(-(model_.zs))))))*De_1))*De_2));
          d_DC_j1_dV_b_ci = ((((cjs0_t*value_exp_0)*De_1)*d_De_2_dV_b_ci)+((((cjs0_t*value_exp_0)*d_De_1_dV_b_ci)+((cjs0_t*(deriv_exp_0_d0*((d_DCln2_dV_b_ci*(-(model_.zs))))))*De_1))*De_2));
          d_DC_j1_dV_si_ci = ((((cjs0_t*value_exp_0)*De_1)*d_De_2_dV_si_ci)+((((cjs0_t*value_exp_0)*d_De_1_dV_si_ci)+((cjs0_t*(deriv_exp_0_d0*((d_DCln2_dV_si_ci*(-(model_.zs))))))*De_1))*De_2));
          d_DC_j1_dV_tnode_GND = ((((cjs0_t*value_exp_0)*De_1)*d_De_2_dV_tnode_GND)+((((cjs0_t*value_exp_0)*d_De_1_dV_tnode_GND)+(((cjs0_t*(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*(-(model_.zs))))))+(d_cjs0_t_dV_tnode_GND*value_exp_0))*De_1))*De_2));
          DC_j1 = (((cjs0_t*value_exp_0)*De_1)*De_2);
        }
        {
          double value_exp_0 = exp((DCln1*(-Dz_r)));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DC_j2_dV_s_c =  0.0;
          d_DC_j2_dV_bi_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_bi_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_bi_ci*(-Dz_r)))))*(1.0-De_2)));
          d_DC_j2_dV_bp_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_bp_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_bp_ci*(-Dz_r)))))*(1.0-De_2)));
          d_DC_j2_dV_b_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_b_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_b_ci*(-Dz_r)))))*(1.0-De_2)));
          d_DC_j2_dV_si_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_si_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_si_ci*(-Dz_r)))))*(1.0-De_2)));
          d_DC_j2_dV_tnode_GND = (((DC_c*value_exp_0)*(-d_De_2_dV_tnode_GND))+(((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_tnode_GND*(-Dz_r)))))+(d_DC_c_dV_tnode_GND*value_exp_0))*(1.0-De_2)));
          DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
        }

        d_DC_j3_dV_s_c =  0.0;
        d_DC_j3_dV_bi_ci = (DC_max*(-d_De_1_dV_bi_ci));
        d_DC_j3_dV_bp_ci = (DC_max*(-d_De_1_dV_bp_ci));
        d_DC_j3_dV_b_ci = (DC_max*(-d_De_1_dV_b_ci));
        d_DC_j3_dV_si_ci = (DC_max*(-d_De_1_dV_si_ci));
        d_DC_j3_dV_tnode_GND = ((DC_max*(-d_De_1_dV_tnode_GND))+(d_DC_max_dV_tnode_GND*(1.0-De_1)));
        DC_j3 = (DC_max*(1.0-De_1));

        d_Cjs_dV_bp_ei = d_Cjs_dV_bi_ei =  0.0;
        d_Cjs_dV_bi_ci = ((d_DC_j1_dV_bi_ci+d_DC_j2_dV_bi_ci)+d_DC_j3_dV_bi_ci);
        d_Cjs_dV_tnode_GND = ((d_DC_j1_dV_tnode_GND+d_DC_j2_dV_tnode_GND)+d_DC_j3_dV_tnode_GND);
        d_Cjs_dV_bp_ci = ((d_DC_j1_dV_bp_ci+d_DC_j2_dV_bp_ci)+d_DC_j3_dV_bp_ci);
        d_Cjs_dV_b_ci = ((d_DC_j1_dV_b_ci+d_DC_j2_dV_b_ci)+d_DC_j3_dV_b_ci);
        d_Cjs_dV_si_ci = ((d_DC_j1_dV_si_ci+d_DC_j2_dV_si_ci)+d_DC_j3_dV_si_ci);
        Cjs = ((DC_j1+DC_j2)+DC_j3);
        {
          double value_exp_0 = exp((DCln2*Dz1));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DQ_j1_dV_s_c =  0.0;
          d_DQ_j1_dV_bi_ci = ((cjs0_t*(-(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*Dz1)))))/Dz1);
          d_DQ_j1_dV_bp_ci = ((cjs0_t*(-(deriv_exp_0_d0*((d_DCln2_dV_bp_ci*Dz1)))))/Dz1);
          d_DQ_j1_dV_b_ci = ((cjs0_t*(-(deriv_exp_0_d0*((d_DCln2_dV_b_ci*Dz1)))))/Dz1);
          d_DQ_j1_dV_si_ci = ((cjs0_t*(-(deriv_exp_0_d0*((d_DCln2_dV_si_ci*Dz1)))))/Dz1);
          d_DQ_j1_dV_tnode_GND = (((cjs0_t*(-(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*Dz1)))))+(d_cjs0_t_dV_tnode_GND*(1.0-value_exp_0)))/Dz1);
          DQ_j1 = ((cjs0_t*(1.0-value_exp_0))/Dz1);
        }
        {
          double value_exp_0 = exp((DCln1*Dzr1));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DQ_j2_dV_s_c =  0.0;
          d_DQ_j2_dV_bi_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_bi_ci*Dzr1)))))/Dzr1);
          d_DQ_j2_dV_bp_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_bp_ci*Dzr1)))))/Dzr1);
          d_DQ_j2_dV_b_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_b_ci*Dzr1)))))/Dzr1);
          d_DQ_j2_dV_si_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_si_ci*Dzr1)))))/Dzr1);
          d_DQ_j2_dV_tnode_GND = (((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_tnode_GND*Dzr1)))))+(d_DC_c_dV_tnode_GND*(1.0-value_exp_0)))/Dzr1);
          DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }
        {
          double value_exp_0 = exp((DCln2*Dzr1));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DQ_j3_dV_s_c =  0.0;
          d_DQ_j3_dV_bi_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*Dzr1)))))/Dzr1);
          d_DQ_j3_dV_bp_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_bp_ci*Dzr1)))))/Dzr1);
          d_DQ_j3_dV_b_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_b_ci*Dzr1)))))/Dzr1);
          d_DQ_j3_dV_si_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_si_ci*Dzr1)))))/Dzr1);
          d_DQ_j3_dV_tnode_GND = (((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*Dzr1)))))+(d_DC_c_dV_tnode_GND*(1.0-value_exp_0)))/Dzr1);
          DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }

        d_Qjs_dV_bp_ei = d_Qjs_dV_bi_ei =  0.0;
        d_Qjs_dV_bi_ci = ((((d_DQ_j1_dV_bi_ci+d_DQ_j2_dV_bi_ci)-d_DQ_j3_dV_bi_ci)*vds_t)+(DC_max*d_Dv_j4_dV_bi_ci));
        d_Qjs_dV_tnode_GND = (((((DQ_j1+DQ_j2)-DQ_j3)*d_vds_t_dV_tnode_GND)+(((d_DQ_j1_dV_tnode_GND+d_DQ_j2_dV_tnode_GND)-d_DQ_j3_dV_tnode_GND)*vds_t))+((DC_max*d_Dv_j4_dV_tnode_GND)+(d_DC_max_dV_tnode_GND*Dv_j4)));
        d_Qjs_dV_bp_ci = ((((d_DQ_j1_dV_bp_ci+d_DQ_j2_dV_bp_ci)-d_DQ_j3_dV_bp_ci)*vds_t)+(DC_max*d_Dv_j4_dV_bp_ci));
        d_Qjs_dV_b_ci = ((((d_DQ_j1_dV_b_ci+d_DQ_j2_dV_b_ci)-d_DQ_j3_dV_b_ci)*vds_t)+(DC_max*d_Dv_j4_dV_b_ci));
        d_Qjs_dV_si_ci = ((((d_DQ_j1_dV_si_ci+d_DQ_j2_dV_si_ci)-d_DQ_j3_dV_si_ci)*vds_t)+(DC_max*d_Dv_j4_dV_si_ci));
        Qjs = ((((DQ_j1+DQ_j2)-DQ_j3)*vds_t)+(DC_max*Dv_j4));
      }
      else
      {

        d_Cjs_dV_bp_ei = d_Cjs_dV_bi_ei = d_Cjs_dV_si_ci = d_Cjs_dV_b_ci = d_Cjs_dV_bp_ci = d_Cjs_dV_tnode_GND = d_Cjs_dV_bi_ci =  0.0;
        Cjs = 0.0;

        d_Qjs_dV_bp_ei = d_Qjs_dV_bi_ei = d_Qjs_dV_si_ci = d_Qjs_dV_b_ci = d_Qjs_dV_bp_ci = d_Qjs_dV_tnode_GND = d_Qjs_dV_bi_ci =  0.0;
        Qjs = 0.0;
      }
    }
    else
    {
      if ((cjs0_t>0.0))
      {
        {
          double value_log_0 = log(static_cast<double>(2.4));
          double value_exp_1 = exp(((-value_log_0)/(model_.zs)));

          d_DFV_f_dV_tnode_GND = (d_vds_t_dV_tnode_GND*(1.0-value_exp_1));
          DFV_f = (vds_t*(1.0-value_exp_1));
        }

        d_DFv_e_dV_s_c = d_DFv_e_dV_b_ci = d_DFv_e_dV_bp_ci = d_DFv_e_dV_bp_ei = d_DFv_e_dV_bi_ci = d_DFv_e_dV_bi_ei =  0.0;
        d_DFv_e_dV_si_ci = ((-d_Vsici_dV_si_ci)/VT);
        d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vsici)*d_VT_dV_tnode_GND)/VT/VT);
        DFv_e = ((DFV_f-Vsici)/VT);
        {
          double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_DFs_q_dV_s_c =  0.0;
          d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bi_ei)+(d_DFv_e_dV_bi_ei*DFv_e))));
          d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_tnode_GND)+(d_DFv_e_dV_tnode_GND*DFv_e))));
          d_DFs_q_dV_bi_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bi_ci)+(d_DFv_e_dV_bi_ci*DFv_e))));
          d_DFs_q_dV_bp_ei = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bp_ei)+(d_DFv_e_dV_bp_ei*DFv_e))));
          d_DFs_q_dV_bp_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bp_ci)+(d_DFv_e_dV_bp_ci*DFv_e))));
          d_DFs_q_dV_b_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_b_ci)+(d_DFv_e_dV_b_ci*DFv_e))));
          d_DFs_q_dV_si_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_si_ci)+(d_DFv_e_dV_si_ci*DFv_e))));
          DFs_q = value_sqrt_0;
        }

        d_DFs_q2_dV_s_c =  0.0;
        d_DFs_q2_dV_bi_ei = ((d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5);
        d_DFs_q2_dV_tnode_GND = ((d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5);
        d_DFs_q2_dV_bi_ci = ((d_DFv_e_dV_bi_ci+d_DFs_q_dV_bi_ci)*0.5);
        d_DFs_q2_dV_bp_ei = ((d_DFv_e_dV_bp_ei+d_DFs_q_dV_bp_ei)*0.5);
        d_DFs_q2_dV_bp_ci = ((d_DFv_e_dV_bp_ci+d_DFs_q_dV_bp_ci)*0.5);
        d_DFs_q2_dV_b_ci = ((d_DFv_e_dV_b_ci+d_DFs_q_dV_b_ci)*0.5);
        d_DFs_q2_dV_si_ci = ((d_DFv_e_dV_si_ci+d_DFs_q_dV_si_ci)*0.5);
        DFs_q2 = ((DFv_e+DFs_q)*0.5);

        d_DFv_j_dV_s_c =  0.0;
        d_DFv_j_dV_bi_ei = (-(VT*d_DFs_q2_dV_bi_ei));
        d_DFv_j_dV_bi_ci = (-(VT*d_DFs_q2_dV_bi_ci));
        d_DFv_j_dV_bp_ei = (-(VT*d_DFs_q2_dV_bp_ei));
        d_DFv_j_dV_bp_ci = (-(VT*d_DFs_q2_dV_bp_ci));
        d_DFv_j_dV_b_ci = (-(VT*d_DFs_q2_dV_b_ci));
        d_DFv_j_dV_si_ci = (-(VT*d_DFs_q2_dV_si_ci));
        d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-((VT*d_DFs_q2_dV_tnode_GND)+(d_VT_dV_tnode_GND*DFs_q2)));
        DFv_j = (DFV_f-(VT*DFs_q2));

        d_DFdvj_dv_dV_s_c =  0.0;
        d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_bi_ci = ((DFs_q*d_DFs_q2_dV_bi_ci-DFs_q2*d_DFs_q_dV_bi_ci)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_bp_ei = ((DFs_q*d_DFs_q2_dV_bp_ei-DFs_q2*d_DFs_q_dV_bp_ei)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_bp_ci = ((DFs_q*d_DFs_q2_dV_bp_ci-DFs_q2*d_DFs_q_dV_bp_ci)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_b_ci = ((DFs_q*d_DFs_q2_dV_b_ci-DFs_q2*d_DFs_q_dV_b_ci)/DFs_q/DFs_q);
        d_DFdvj_dv_dV_si_ci = ((DFs_q*d_DFs_q2_dV_si_ci-DFs_q2*d_DFs_q_dV_si_ci)/DFs_q/DFs_q);
        DFdvj_dv = (DFs_q2/DFs_q);
        {
          double value_log_0 = log((1.0-(DFv_j/vds_t)));
          double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vds_t)));

          d_DFb_dV_s_c =  0.0;
          d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vds_t))));
          d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vds_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vds_t_dV_tnode_GND)/vds_t/vds_t))));
          d_DFb_dV_bi_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ci/vds_t))));
          d_DFb_dV_bp_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ei/vds_t))));
          d_DFb_dV_bp_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ci/vds_t))));
          d_DFb_dV_b_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_b_ci/vds_t))));
          d_DFb_dV_si_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_si_ci/vds_t))));
          DFb = value_log_0;
        }
        {
          double value_exp_0 = exp(((-(model_.zs))*DFb));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DFC_j1_dV_s_c =  0.0;
          d_DFC_j1_dV_bi_ei = (((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei)+((cjs0_t*(deriv_exp_0_d0*(((-(model_.zs))*d_DFb_dV_bi_ei))))*DFdvj_dv));
          d_DFC_j1_dV_bi_ci = (((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ci)+((cjs0_t*(deriv_exp_0_d0*(((-(model_.zs))*d_DFb_dV_bi_ci))))*DFdvj_dv));
          d_DFC_j1_dV_bp_ei = (((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_bp_ei)+((cjs0_t*(deriv_exp_0_d0*(((-(model_.zs))*d_DFb_dV_bp_ei))))*DFdvj_dv));
          d_DFC_j1_dV_bp_ci = (((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_bp_ci)+((cjs0_t*(deriv_exp_0_d0*(((-(model_.zs))*d_DFb_dV_bp_ci))))*DFdvj_dv));
          d_DFC_j1_dV_b_ci = (((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_b_ci)+((cjs0_t*(deriv_exp_0_d0*(((-(model_.zs))*d_DFb_dV_b_ci))))*DFdvj_dv));
          d_DFC_j1_dV_si_ci = (((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_si_ci)+((cjs0_t*(deriv_exp_0_d0*(((-(model_.zs))*d_DFb_dV_si_ci))))*DFdvj_dv));
          d_DFC_j1_dV_tnode_GND = (((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND)+(((cjs0_t*(deriv_exp_0_d0*(((-(model_.zs))*d_DFb_dV_tnode_GND))))+(d_cjs0_t_dV_tnode_GND*value_exp_0))*DFdvj_dv));
          DFC_j1 = ((cjs0_t*value_exp_0)*DFdvj_dv);
        }

        d_Cjs_dV_bi_ei = (d_DFC_j1_dV_bi_ei+((2.4*cjs0_t)*(-d_DFdvj_dv_dV_bi_ei)));
        d_Cjs_dV_tnode_GND = (d_DFC_j1_dV_tnode_GND+(((2.4*cjs0_t)*(-d_DFdvj_dv_dV_tnode_GND))+((2.4*d_cjs0_t_dV_tnode_GND)*(1.0-DFdvj_dv))));
        d_Cjs_dV_bi_ci = (d_DFC_j1_dV_bi_ci+((2.4*cjs0_t)*(-d_DFdvj_dv_dV_bi_ci)));
        d_Cjs_dV_bp_ei = (d_DFC_j1_dV_bp_ei+((2.4*cjs0_t)*(-d_DFdvj_dv_dV_bp_ei)));
        d_Cjs_dV_bp_ci = (d_DFC_j1_dV_bp_ci+((2.4*cjs0_t)*(-d_DFdvj_dv_dV_bp_ci)));
        d_Cjs_dV_b_ci = (d_DFC_j1_dV_b_ci+((2.4*cjs0_t)*(-d_DFdvj_dv_dV_b_ci)));
        d_Cjs_dV_si_ci = (d_DFC_j1_dV_si_ci+((2.4*cjs0_t)*(-d_DFdvj_dv_dV_si_ci)));
        Cjs = (DFC_j1+((2.4*cjs0_t)*(1.0-DFdvj_dv)));
        {
          double value_exp_0 = exp((DFb*(1.0-(model_.zs))));
          double  deriv_exp_0_d0 = value_exp_0;

          d_DFQ_j_dV_s_c =  0.0;
          d_DFQ_j_dV_bi_ei = (((cjs0_t*vds_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bi_ei*(1.0-(model_.zs)))))))/(1.0-(model_.zs)));
          d_DFQ_j_dV_bi_ci = (((cjs0_t*vds_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bi_ci*(1.0-(model_.zs)))))))/(1.0-(model_.zs)));
          d_DFQ_j_dV_bp_ei = (((cjs0_t*vds_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bp_ei*(1.0-(model_.zs)))))))/(1.0-(model_.zs)));
          d_DFQ_j_dV_bp_ci = (((cjs0_t*vds_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bp_ci*(1.0-(model_.zs)))))))/(1.0-(model_.zs)));
          d_DFQ_j_dV_b_ci = (((cjs0_t*vds_t)*(-(deriv_exp_0_d0*((d_DFb_dV_b_ci*(1.0-(model_.zs)))))))/(1.0-(model_.zs)));
          d_DFQ_j_dV_si_ci = (((cjs0_t*vds_t)*(-(deriv_exp_0_d0*((d_DFb_dV_si_ci*(1.0-(model_.zs)))))))/(1.0-(model_.zs)));
          d_DFQ_j_dV_tnode_GND = ((((cjs0_t*vds_t)*(-(deriv_exp_0_d0*((d_DFb_dV_tnode_GND*(1.0-(model_.zs)))))))+(((cjs0_t*d_vds_t_dV_tnode_GND)+(d_cjs0_t_dV_tnode_GND*vds_t))*(1.0-value_exp_0)))/(1.0-(model_.zs)));
          DFQ_j = (((cjs0_t*vds_t)*(1.0-value_exp_0))/(1.0-(model_.zs)));
        }

        d_Qjs_dV_bi_ei = (d_DFQ_j_dV_bi_ei+((2.4*cjs0_t)*(-d_DFv_j_dV_bi_ei)));
        d_Qjs_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+(((2.4*cjs0_t)*(-d_DFv_j_dV_tnode_GND))+((2.4*d_cjs0_t_dV_tnode_GND)*(Vsici-DFv_j))));
        d_Qjs_dV_bi_ci = (d_DFQ_j_dV_bi_ci+((2.4*cjs0_t)*(-d_DFv_j_dV_bi_ci)));
        d_Qjs_dV_bp_ei = (d_DFQ_j_dV_bp_ei+((2.4*cjs0_t)*(-d_DFv_j_dV_bp_ei)));
        d_Qjs_dV_bp_ci = (d_DFQ_j_dV_bp_ci+((2.4*cjs0_t)*(-d_DFv_j_dV_bp_ci)));
        d_Qjs_dV_b_ci = (d_DFQ_j_dV_b_ci+((2.4*cjs0_t)*(-d_DFv_j_dV_b_ci)));
        d_Qjs_dV_si_ci = (d_DFQ_j_dV_si_ci+((2.4*cjs0_t)*(d_Vsici_dV_si_ci-d_DFv_j_dV_si_ci)));
        Qjs = (DFQ_j+((2.4*cjs0_t)*(Vsici-DFv_j)));
      }
      else
      {

        d_Cjs_dV_bp_ei = d_Cjs_dV_bi_ei = d_Cjs_dV_si_ci = d_Cjs_dV_b_ci = d_Cjs_dV_bp_ci = d_Cjs_dV_tnode_GND = d_Cjs_dV_bi_ci =  0.0;
        Cjs = 0.0;

        d_Qjs_dV_bp_ei = d_Qjs_dV_bi_ei = d_Qjs_dV_si_ci = d_Qjs_dV_b_ci = d_Qjs_dV_bp_ci = d_Qjs_dV_tnode_GND = d_Qjs_dV_bi_ci =  0.0;
        Qjs = 0.0;
      }
    }
    if (((model_.vdsp)>0))
    {
      if ((vptsp_t<1.0e2))
      {
        if ((cscp0_t>0.0))
        {
          Dz_r = ((model_.zsp)/4.0);

          d_Dv_p_dV_tnode_GND = (d_vptsp_t_dV_tnode_GND-d_vdsp_t_dV_tnode_GND);
          Dv_p = (vptsp_t-vdsp_t);
          {
            double value_log_0 = log(static_cast<double>(2.4));
            double value_exp_1 = exp(((-value_log_0)/(model_.zsp)));

            d_DV_f_dV_tnode_GND = (d_vdsp_t_dV_tnode_GND*(1.0-value_exp_1));
            DV_f = (vdsp_t*(1.0-value_exp_1));
          }

          d_DC_max_dV_tnode_GND = (2.4*d_cscp0_t_dV_tnode_GND);
          DC_max = (2.4*cscp0_t);
          {
            double value_log_0 = log((vptsp_t/vdsp_t));
            double value_exp_1 = exp(((Dz_r-(model_.zsp))*value_log_0));
            double  deriv_log_0_d0 = (1.0/(vptsp_t/vdsp_t));
            double  deriv_exp_1_d0 = value_exp_1;

            d_DC_c_dV_tnode_GND = ((cscp0_t*(deriv_exp_1_d0*(((Dz_r-(model_.zsp))*(deriv_log_0_d0*(((vdsp_t*d_vptsp_t_dV_tnode_GND-vptsp_t*d_vdsp_t_dV_tnode_GND)/vdsp_t/vdsp_t)))))))+(d_cscp0_t_dV_tnode_GND*value_exp_1));
            DC_c = (cscp0_t*value_exp_1);
          }

          d_Dv_e_dV_si_ci = d_Dv_e_dV_b_ci = d_Dv_e_dV_bp_ci = d_Dv_e_dV_bi_ci =  0.0;
          d_Dv_e_dV_s_c = ((-d_Vsc_dV_s_c)/VT);
          d_Dv_e_dV_tnode_GND = ((VT*d_DV_f_dV_tnode_GND-(DV_f-Vsc)*d_VT_dV_tnode_GND)/VT/VT);
          Dv_e = ((DV_f-Vsc)/VT);
          if ((Dv_e<80.0))
          {
            {
              double value_exp_0 = exp(Dv_e);
              double  deriv_exp_0_d0 = value_exp_0;

              d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bi_ci));
              d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_e_dV_tnode_GND));
              d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bp_ci));
              d_De_dV_b_ci = (deriv_exp_0_d0*(d_Dv_e_dV_b_ci));
              d_De_dV_si_ci = (deriv_exp_0_d0*(d_Dv_e_dV_si_ci));
              d_De_dV_s_c = (deriv_exp_0_d0*(d_Dv_e_dV_s_c));
              De = value_exp_0;
            }

            d_De_1_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
            d_De_1_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
            d_De_1_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
            d_De_1_dV_b_ci = (((1.0+De)*d_De_dV_b_ci-De*d_De_dV_b_ci)/(1.0+De)/(1.0+De));
            d_De_1_dV_si_ci = (((1.0+De)*d_De_dV_si_ci-De*d_De_dV_si_ci)/(1.0+De)/(1.0+De));
            d_De_1_dV_s_c = (((1.0+De)*d_De_dV_s_c-De*d_De_dV_s_c)/(1.0+De)/(1.0+De));
            De_1 = (De/(1.0+De));
            {
              double value_log_0 = log((1.0+De));
              double  deriv_log_0_d0 = (1.0/(1.0+De));

              d_Dv_j1_dV_bi_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_bi_ci))));
              d_Dv_j1_dV_bp_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_bp_ci))));
              d_Dv_j1_dV_b_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_b_ci))));
              d_Dv_j1_dV_si_ci = (-(VT*(deriv_log_0_d0*(d_De_dV_si_ci))));
              d_Dv_j1_dV_s_c = (-(VT*(deriv_log_0_d0*(d_De_dV_s_c))));
              d_Dv_j1_dV_tnode_GND = (d_DV_f_dV_tnode_GND-((VT*(deriv_log_0_d0*(d_De_dV_tnode_GND)))+(d_VT_dV_tnode_GND*value_log_0)));
              Dv_j1 = (DV_f-(VT*value_log_0));
            }
          }
          else
          {

            d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci = d_De_1_dV_bp_ci = d_De_1_dV_tnode_GND = d_De_1_dV_bi_ci =  0.0;
            De_1 = 1.0;

            d_Dv_j1_dV_si_ci = d_Dv_j1_dV_b_ci = d_Dv_j1_dV_bp_ci = d_Dv_j1_dV_tnode_GND = d_Dv_j1_dV_bi_ci =  0.0;
            d_Dv_j1_dV_s_c = d_Vsc_dV_s_c;
            Dv_j1 = Vsc;
          }

          d_Da_dV_tnode_GND = ((0.1*d_Dv_p_dV_tnode_GND)+(4.0*d_VT_dV_tnode_GND));
          Da = ((0.1*Dv_p)+(4.0*VT));

          d_Dv_r_dV_bi_ci = (d_Dv_j1_dV_bi_ci/Da);
          d_Dv_r_dV_bp_ci = (d_Dv_j1_dV_bp_ci/Da);
          d_Dv_r_dV_b_ci = (d_Dv_j1_dV_b_ci/Da);
          d_Dv_r_dV_si_ci = (d_Dv_j1_dV_si_ci/Da);
          d_Dv_r_dV_s_c = (d_Dv_j1_dV_s_c/Da);
          d_Dv_r_dV_tnode_GND = ((Da*(d_Dv_p_dV_tnode_GND+d_Dv_j1_dV_tnode_GND)-(Dv_p+Dv_j1)*d_Da_dV_tnode_GND)/Da/Da);
          Dv_r = ((Dv_p+Dv_j1)/Da);
          if ((Dv_r<80.0))
          {
            {
              double value_exp_0 = exp(Dv_r);
              double  deriv_exp_0_d0 = value_exp_0;

              d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bi_ci));
              d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_r_dV_tnode_GND));
              d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bp_ci));
              d_De_dV_b_ci = (deriv_exp_0_d0*(d_Dv_r_dV_b_ci));
              d_De_dV_si_ci = (deriv_exp_0_d0*(d_Dv_r_dV_si_ci));
              d_De_dV_s_c = (deriv_exp_0_d0*(d_Dv_r_dV_s_c));
              De = value_exp_0;
            }

            d_De_2_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
            d_De_2_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
            d_De_2_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
            d_De_2_dV_b_ci = (((1.0+De)*d_De_dV_b_ci-De*d_De_dV_b_ci)/(1.0+De)/(1.0+De));
            d_De_2_dV_si_ci = (((1.0+De)*d_De_dV_si_ci-De*d_De_dV_si_ci)/(1.0+De)/(1.0+De));
            d_De_2_dV_s_c = (((1.0+De)*d_De_dV_s_c-De*d_De_dV_s_c)/(1.0+De)/(1.0+De));
            De_2 = (De/(1.0+De));
            {
              double value_log_0 = log((1.0+De));
              double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
              double  deriv_log_0_d0 = (1.0/(1.0+De));
              double  deriv_exp_1_d0 = value_exp_1;

              d_Dv_j2_dV_bi_ci = (Da*(deriv_log_0_d0*(d_De_dV_bi_ci)));
              d_Dv_j2_dV_bp_ci = (Da*(deriv_log_0_d0*(d_De_dV_bp_ci)));
              d_Dv_j2_dV_b_ci = (Da*(deriv_log_0_d0*(d_De_dV_b_ci)));
              d_Dv_j2_dV_si_ci = (Da*(deriv_log_0_d0*(d_De_dV_si_ci)));
              d_Dv_j2_dV_s_c = (Da*(deriv_log_0_d0*(d_De_dV_s_c)));
              d_Dv_j2_dV_tnode_GND = ((-d_Dv_p_dV_tnode_GND)+((Da*((deriv_log_0_d0*(d_De_dV_tnode_GND))-(deriv_exp_1_d0*(((Da*(-(d_Dv_p_dV_tnode_GND+d_DV_f_dV_tnode_GND))-(-(Dv_p+DV_f))*d_Da_dV_tnode_GND)/Da/Da)))))+(d_Da_dV_tnode_GND*(value_log_0-value_exp_1))));
              Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
            }
          }
          else
          {

            d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci = d_De_2_dV_bp_ci = d_De_2_dV_tnode_GND = d_De_2_dV_bi_ci =  0.0;
            De_2 = 1.0;

            d_Dv_j2_dV_bi_ci = d_Dv_j1_dV_bi_ci;
            d_Dv_j2_dV_tnode_GND = d_Dv_j1_dV_tnode_GND;
            d_Dv_j2_dV_bp_ci = d_Dv_j1_dV_bp_ci;
            d_Dv_j2_dV_b_ci = d_Dv_j1_dV_b_ci;
            d_Dv_j2_dV_si_ci = d_Dv_j1_dV_si_ci;
            d_Dv_j2_dV_s_c = d_Dv_j1_dV_s_c;
            Dv_j2 = Dv_j1;
          }

          d_Dv_j4_dV_bi_ci = (-d_Dv_j1_dV_bi_ci);
          d_Dv_j4_dV_tnode_GND = (-d_Dv_j1_dV_tnode_GND);
          d_Dv_j4_dV_bp_ci = (-d_Dv_j1_dV_bp_ci);
          d_Dv_j4_dV_b_ci = (-d_Dv_j1_dV_b_ci);
          d_Dv_j4_dV_si_ci = (-d_Dv_j1_dV_si_ci);
          d_Dv_j4_dV_s_c = (d_Vsc_dV_s_c-d_Dv_j1_dV_s_c);
          Dv_j4 = (Vsc-Dv_j1);
          {
            double value_log_0 = log((1.0-(Dv_j1/vdsp_t)));
            double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/vdsp_t)));

            d_DCln1_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bi_ci/vdsp_t))));
            d_DCln1_dV_tnode_GND = (deriv_log_0_d0*((-((vdsp_t*d_Dv_j1_dV_tnode_GND-Dv_j1*d_vdsp_t_dV_tnode_GND)/vdsp_t/vdsp_t))));
            d_DCln1_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bp_ci/vdsp_t))));
            d_DCln1_dV_b_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_b_ci/vdsp_t))));
            d_DCln1_dV_si_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_si_ci/vdsp_t))));
            d_DCln1_dV_s_c = (deriv_log_0_d0*((-(d_Dv_j1_dV_s_c/vdsp_t))));
            DCln1 = value_log_0;
          }
          {
            double value_log_0 = log((1.0-(Dv_j2/vdsp_t)));
            double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/vdsp_t)));

            d_DCln2_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bi_ci/vdsp_t))));
            d_DCln2_dV_tnode_GND = (deriv_log_0_d0*((-((vdsp_t*d_Dv_j2_dV_tnode_GND-Dv_j2*d_vdsp_t_dV_tnode_GND)/vdsp_t/vdsp_t))));
            d_DCln2_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bp_ci/vdsp_t))));
            d_DCln2_dV_b_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_b_ci/vdsp_t))));
            d_DCln2_dV_si_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_si_ci/vdsp_t))));
            d_DCln2_dV_s_c = (deriv_log_0_d0*((-(d_Dv_j2_dV_s_c/vdsp_t))));
            DCln2 = value_log_0;
          }
          Dz1 = (1.0-(model_.zsp));
          Dzr1 = (1.0-Dz_r);
          {
            double value_exp_0 = exp((DCln2*(-(model_.zsp))));
            double  deriv_exp_0_d0 = value_exp_0;

            d_DC_j1_dV_bi_ci = ((((cscp0_t*value_exp_0)*De_1)*d_De_2_dV_bi_ci)+((((cscp0_t*value_exp_0)*d_De_1_dV_bi_ci)+((cscp0_t*(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*(-(model_.zsp))))))*De_1))*De_2));
            d_DC_j1_dV_bp_ci = ((((cscp0_t*value_exp_0)*De_1)*d_De_2_dV_bp_ci)+((((cscp0_t*value_exp_0)*d_De_1_dV_bp_ci)+((cscp0_t*(deriv_exp_0_d0*((d_DCln2_dV_bp_ci*(-(model_.zsp))))))*De_1))*De_2));
            d_DC_j1_dV_b_ci = ((((cscp0_t*value_exp_0)*De_1)*d_De_2_dV_b_ci)+((((cscp0_t*value_exp_0)*d_De_1_dV_b_ci)+((cscp0_t*(deriv_exp_0_d0*((d_DCln2_dV_b_ci*(-(model_.zsp))))))*De_1))*De_2));
            d_DC_j1_dV_si_ci = ((((cscp0_t*value_exp_0)*De_1)*d_De_2_dV_si_ci)+((((cscp0_t*value_exp_0)*d_De_1_dV_si_ci)+((cscp0_t*(deriv_exp_0_d0*((d_DCln2_dV_si_ci*(-(model_.zsp))))))*De_1))*De_2));
            d_DC_j1_dV_s_c = ((((cscp0_t*value_exp_0)*De_1)*d_De_2_dV_s_c)+((((cscp0_t*value_exp_0)*d_De_1_dV_s_c)+((cscp0_t*(deriv_exp_0_d0*((d_DCln2_dV_s_c*(-(model_.zsp))))))*De_1))*De_2));
            d_DC_j1_dV_tnode_GND = ((((cscp0_t*value_exp_0)*De_1)*d_De_2_dV_tnode_GND)+((((cscp0_t*value_exp_0)*d_De_1_dV_tnode_GND)+(((cscp0_t*(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*(-(model_.zsp))))))+(d_cscp0_t_dV_tnode_GND*value_exp_0))*De_1))*De_2));
            DC_j1 = (((cscp0_t*value_exp_0)*De_1)*De_2);
          }
          {
            double value_exp_0 = exp((DCln1*(-Dz_r)));
            double  deriv_exp_0_d0 = value_exp_0;

            d_DC_j2_dV_bi_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_bi_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_bi_ci*(-Dz_r)))))*(1.0-De_2)));
            d_DC_j2_dV_bp_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_bp_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_bp_ci*(-Dz_r)))))*(1.0-De_2)));
            d_DC_j2_dV_b_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_b_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_b_ci*(-Dz_r)))))*(1.0-De_2)));
            d_DC_j2_dV_si_ci = (((DC_c*value_exp_0)*(-d_De_2_dV_si_ci))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_si_ci*(-Dz_r)))))*(1.0-De_2)));
            d_DC_j2_dV_s_c = (((DC_c*value_exp_0)*(-d_De_2_dV_s_c))+((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_s_c*(-Dz_r)))))*(1.0-De_2)));
            d_DC_j2_dV_tnode_GND = (((DC_c*value_exp_0)*(-d_De_2_dV_tnode_GND))+(((DC_c*(deriv_exp_0_d0*((d_DCln1_dV_tnode_GND*(-Dz_r)))))+(d_DC_c_dV_tnode_GND*value_exp_0))*(1.0-De_2)));
            DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
          }

          d_DC_j3_dV_bi_ci = (DC_max*(-d_De_1_dV_bi_ci));
          d_DC_j3_dV_bp_ci = (DC_max*(-d_De_1_dV_bp_ci));
          d_DC_j3_dV_b_ci = (DC_max*(-d_De_1_dV_b_ci));
          d_DC_j3_dV_si_ci = (DC_max*(-d_De_1_dV_si_ci));
          d_DC_j3_dV_s_c = (DC_max*(-d_De_1_dV_s_c));
          d_DC_j3_dV_tnode_GND = ((DC_max*(-d_De_1_dV_tnode_GND))+(d_DC_max_dV_tnode_GND*(1.0-De_1)));
          DC_j3 = (DC_max*(1.0-De_1));

          d_Cscp_dV_bp_ei = d_Cscp_dV_bi_ei =  0.0;
          d_Cscp_dV_bi_ci = ((d_DC_j1_dV_bi_ci+d_DC_j2_dV_bi_ci)+d_DC_j3_dV_bi_ci);
          d_Cscp_dV_tnode_GND = ((d_DC_j1_dV_tnode_GND+d_DC_j2_dV_tnode_GND)+d_DC_j3_dV_tnode_GND);
          d_Cscp_dV_bp_ci = ((d_DC_j1_dV_bp_ci+d_DC_j2_dV_bp_ci)+d_DC_j3_dV_bp_ci);
          d_Cscp_dV_b_ci = ((d_DC_j1_dV_b_ci+d_DC_j2_dV_b_ci)+d_DC_j3_dV_b_ci);
          d_Cscp_dV_si_ci = ((d_DC_j1_dV_si_ci+d_DC_j2_dV_si_ci)+d_DC_j3_dV_si_ci);
          d_Cscp_dV_s_c = ((d_DC_j1_dV_s_c+d_DC_j2_dV_s_c)+d_DC_j3_dV_s_c);
          Cscp = ((DC_j1+DC_j2)+DC_j3);
          {
            double value_exp_0 = exp((DCln2*Dz1));
            double  deriv_exp_0_d0 = value_exp_0;

            d_DQ_j1_dV_bi_ci = ((cscp0_t*(-(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*Dz1)))))/Dz1);
            d_DQ_j1_dV_bp_ci = ((cscp0_t*(-(deriv_exp_0_d0*((d_DCln2_dV_bp_ci*Dz1)))))/Dz1);
            d_DQ_j1_dV_b_ci = ((cscp0_t*(-(deriv_exp_0_d0*((d_DCln2_dV_b_ci*Dz1)))))/Dz1);
            d_DQ_j1_dV_si_ci = ((cscp0_t*(-(deriv_exp_0_d0*((d_DCln2_dV_si_ci*Dz1)))))/Dz1);
            d_DQ_j1_dV_s_c = ((cscp0_t*(-(deriv_exp_0_d0*((d_DCln2_dV_s_c*Dz1)))))/Dz1);
            d_DQ_j1_dV_tnode_GND = (((cscp0_t*(-(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*Dz1)))))+(d_cscp0_t_dV_tnode_GND*(1.0-value_exp_0)))/Dz1);
            DQ_j1 = ((cscp0_t*(1.0-value_exp_0))/Dz1);
          }
          {
            double value_exp_0 = exp((DCln1*Dzr1));
            double  deriv_exp_0_d0 = value_exp_0;

            d_DQ_j2_dV_bi_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_bi_ci*Dzr1)))))/Dzr1);
            d_DQ_j2_dV_bp_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_bp_ci*Dzr1)))))/Dzr1);
            d_DQ_j2_dV_b_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_b_ci*Dzr1)))))/Dzr1);
            d_DQ_j2_dV_si_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_si_ci*Dzr1)))))/Dzr1);
            d_DQ_j2_dV_s_c = ((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_s_c*Dzr1)))))/Dzr1);
            d_DQ_j2_dV_tnode_GND = (((DC_c*(-(deriv_exp_0_d0*((d_DCln1_dV_tnode_GND*Dzr1)))))+(d_DC_c_dV_tnode_GND*(1.0-value_exp_0)))/Dzr1);
            DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
          }
          {
            double value_exp_0 = exp((DCln2*Dzr1));
            double  deriv_exp_0_d0 = value_exp_0;

            d_DQ_j3_dV_bi_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_bi_ci*Dzr1)))))/Dzr1);
            d_DQ_j3_dV_bp_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_bp_ci*Dzr1)))))/Dzr1);
            d_DQ_j3_dV_b_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_b_ci*Dzr1)))))/Dzr1);
            d_DQ_j3_dV_si_ci = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_si_ci*Dzr1)))))/Dzr1);
            d_DQ_j3_dV_s_c = ((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_s_c*Dzr1)))))/Dzr1);
            d_DQ_j3_dV_tnode_GND = (((DC_c*(-(deriv_exp_0_d0*((d_DCln2_dV_tnode_GND*Dzr1)))))+(d_DC_c_dV_tnode_GND*(1.0-value_exp_0)))/Dzr1);
            DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
          }

          d_Qscp_dV_bp_ei = d_Qscp_dV_bi_ei =  0.0;
          d_Qscp_dV_bi_ci = ((((d_DQ_j1_dV_bi_ci+d_DQ_j2_dV_bi_ci)-d_DQ_j3_dV_bi_ci)*vdsp_t)+(DC_max*d_Dv_j4_dV_bi_ci));
          d_Qscp_dV_tnode_GND = (((((DQ_j1+DQ_j2)-DQ_j3)*d_vdsp_t_dV_tnode_GND)+(((d_DQ_j1_dV_tnode_GND+d_DQ_j2_dV_tnode_GND)-d_DQ_j3_dV_tnode_GND)*vdsp_t))+((DC_max*d_Dv_j4_dV_tnode_GND)+(d_DC_max_dV_tnode_GND*Dv_j4)));
          d_Qscp_dV_bp_ci = ((((d_DQ_j1_dV_bp_ci+d_DQ_j2_dV_bp_ci)-d_DQ_j3_dV_bp_ci)*vdsp_t)+(DC_max*d_Dv_j4_dV_bp_ci));
          d_Qscp_dV_b_ci = ((((d_DQ_j1_dV_b_ci+d_DQ_j2_dV_b_ci)-d_DQ_j3_dV_b_ci)*vdsp_t)+(DC_max*d_Dv_j4_dV_b_ci));
          d_Qscp_dV_si_ci = ((((d_DQ_j1_dV_si_ci+d_DQ_j2_dV_si_ci)-d_DQ_j3_dV_si_ci)*vdsp_t)+(DC_max*d_Dv_j4_dV_si_ci));
          d_Qscp_dV_s_c = ((((d_DQ_j1_dV_s_c+d_DQ_j2_dV_s_c)-d_DQ_j3_dV_s_c)*vdsp_t)+(DC_max*d_Dv_j4_dV_s_c));
          Qscp = ((((DQ_j1+DQ_j2)-DQ_j3)*vdsp_t)+(DC_max*Dv_j4));
        }
        else
        {

          d_Cscp_dV_bp_ei = d_Cscp_dV_bi_ei = d_Cscp_dV_s_c = d_Cscp_dV_si_ci = d_Cscp_dV_b_ci = d_Cscp_dV_bp_ci = d_Cscp_dV_tnode_GND = d_Cscp_dV_bi_ci =  0.0;
          Cscp = 0.0;

          d_Qscp_dV_bp_ei = d_Qscp_dV_bi_ei = d_Qscp_dV_s_c = d_Qscp_dV_si_ci = d_Qscp_dV_b_ci = d_Qscp_dV_bp_ci = d_Qscp_dV_tnode_GND = d_Qscp_dV_bi_ci =  0.0;
          Qscp = 0.0;
        }
      }
      else
      {
        if ((cscp0_t>0.0))
        {
          {
            double value_log_0 = log(static_cast<double>(2.4));
            double value_exp_1 = exp(((-value_log_0)/(model_.zsp)));

            d_DFV_f_dV_tnode_GND = (d_vdsp_t_dV_tnode_GND*(1.0-value_exp_1));
            DFV_f = (vdsp_t*(1.0-value_exp_1));
          }

          d_DFv_e_dV_si_ci = d_DFv_e_dV_b_ci = d_DFv_e_dV_bp_ci = d_DFv_e_dV_bp_ei = d_DFv_e_dV_bi_ci = d_DFv_e_dV_bi_ei =  0.0;
          d_DFv_e_dV_s_c = ((-d_Vsc_dV_s_c)/VT);
          d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vsc)*d_VT_dV_tnode_GND)/VT/VT);
          DFv_e = ((DFV_f-Vsc)/VT);
          {
            double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
            double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

            d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bi_ei)+(d_DFv_e_dV_bi_ei*DFv_e))));
            d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_tnode_GND)+(d_DFv_e_dV_tnode_GND*DFv_e))));
            d_DFs_q_dV_bi_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bi_ci)+(d_DFv_e_dV_bi_ci*DFv_e))));
            d_DFs_q_dV_bp_ei = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bp_ei)+(d_DFv_e_dV_bp_ei*DFv_e))));
            d_DFs_q_dV_bp_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_bp_ci)+(d_DFv_e_dV_bp_ci*DFv_e))));
            d_DFs_q_dV_b_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_b_ci)+(d_DFv_e_dV_b_ci*DFv_e))));
            d_DFs_q_dV_si_ci = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_si_ci)+(d_DFv_e_dV_si_ci*DFv_e))));
            d_DFs_q_dV_s_c = (deriv_sqrt_0_d0*(((DFv_e*d_DFv_e_dV_s_c)+(d_DFv_e_dV_s_c*DFv_e))));
            DFs_q = value_sqrt_0;
          }

          d_DFs_q2_dV_bi_ei = ((d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5);
          d_DFs_q2_dV_tnode_GND = ((d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5);
          d_DFs_q2_dV_bi_ci = ((d_DFv_e_dV_bi_ci+d_DFs_q_dV_bi_ci)*0.5);
          d_DFs_q2_dV_bp_ei = ((d_DFv_e_dV_bp_ei+d_DFs_q_dV_bp_ei)*0.5);
          d_DFs_q2_dV_bp_ci = ((d_DFv_e_dV_bp_ci+d_DFs_q_dV_bp_ci)*0.5);
          d_DFs_q2_dV_b_ci = ((d_DFv_e_dV_b_ci+d_DFs_q_dV_b_ci)*0.5);
          d_DFs_q2_dV_si_ci = ((d_DFv_e_dV_si_ci+d_DFs_q_dV_si_ci)*0.5);
          d_DFs_q2_dV_s_c = ((d_DFv_e_dV_s_c+d_DFs_q_dV_s_c)*0.5);
          DFs_q2 = ((DFv_e+DFs_q)*0.5);

          d_DFv_j_dV_bi_ei = (-(VT*d_DFs_q2_dV_bi_ei));
          d_DFv_j_dV_bi_ci = (-(VT*d_DFs_q2_dV_bi_ci));
          d_DFv_j_dV_bp_ei = (-(VT*d_DFs_q2_dV_bp_ei));
          d_DFv_j_dV_bp_ci = (-(VT*d_DFs_q2_dV_bp_ci));
          d_DFv_j_dV_b_ci = (-(VT*d_DFs_q2_dV_b_ci));
          d_DFv_j_dV_si_ci = (-(VT*d_DFs_q2_dV_si_ci));
          d_DFv_j_dV_s_c = (-(VT*d_DFs_q2_dV_s_c));
          d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-((VT*d_DFs_q2_dV_tnode_GND)+(d_VT_dV_tnode_GND*DFs_q2)));
          DFv_j = (DFV_f-(VT*DFs_q2));

          d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
          d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
          d_DFdvj_dv_dV_bi_ci = ((DFs_q*d_DFs_q2_dV_bi_ci-DFs_q2*d_DFs_q_dV_bi_ci)/DFs_q/DFs_q);
          d_DFdvj_dv_dV_bp_ei = ((DFs_q*d_DFs_q2_dV_bp_ei-DFs_q2*d_DFs_q_dV_bp_ei)/DFs_q/DFs_q);
          d_DFdvj_dv_dV_bp_ci = ((DFs_q*d_DFs_q2_dV_bp_ci-DFs_q2*d_DFs_q_dV_bp_ci)/DFs_q/DFs_q);
          d_DFdvj_dv_dV_b_ci = ((DFs_q*d_DFs_q2_dV_b_ci-DFs_q2*d_DFs_q_dV_b_ci)/DFs_q/DFs_q);
          d_DFdvj_dv_dV_si_ci = ((DFs_q*d_DFs_q2_dV_si_ci-DFs_q2*d_DFs_q_dV_si_ci)/DFs_q/DFs_q);
          d_DFdvj_dv_dV_s_c = ((DFs_q*d_DFs_q2_dV_s_c-DFs_q2*d_DFs_q_dV_s_c)/DFs_q/DFs_q);
          DFdvj_dv = (DFs_q2/DFs_q);
          {
            double value_log_0 = log((1.0-(DFv_j/vdsp_t)));
            double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vdsp_t)));

            d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vdsp_t))));
            d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vdsp_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vdsp_t_dV_tnode_GND)/vdsp_t/vdsp_t))));
            d_DFb_dV_bi_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ci/vdsp_t))));
            d_DFb_dV_bp_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ei/vdsp_t))));
            d_DFb_dV_bp_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ci/vdsp_t))));
            d_DFb_dV_b_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_b_ci/vdsp_t))));
            d_DFb_dV_si_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_si_ci/vdsp_t))));
            d_DFb_dV_s_c = (deriv_log_0_d0*((-(d_DFv_j_dV_s_c/vdsp_t))));
            DFb = value_log_0;
          }
          {
            double value_exp_0 = exp(((-(model_.zsp))*DFb));
            double  deriv_exp_0_d0 = value_exp_0;

            d_DFC_j1_dV_bi_ei = (((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei)+((cscp0_t*(deriv_exp_0_d0*(((-(model_.zsp))*d_DFb_dV_bi_ei))))*DFdvj_dv));
            d_DFC_j1_dV_bi_ci = (((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ci)+((cscp0_t*(deriv_exp_0_d0*(((-(model_.zsp))*d_DFb_dV_bi_ci))))*DFdvj_dv));
            d_DFC_j1_dV_bp_ei = (((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_bp_ei)+((cscp0_t*(deriv_exp_0_d0*(((-(model_.zsp))*d_DFb_dV_bp_ei))))*DFdvj_dv));
            d_DFC_j1_dV_bp_ci = (((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_bp_ci)+((cscp0_t*(deriv_exp_0_d0*(((-(model_.zsp))*d_DFb_dV_bp_ci))))*DFdvj_dv));
            d_DFC_j1_dV_b_ci = (((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_b_ci)+((cscp0_t*(deriv_exp_0_d0*(((-(model_.zsp))*d_DFb_dV_b_ci))))*DFdvj_dv));
            d_DFC_j1_dV_si_ci = (((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_si_ci)+((cscp0_t*(deriv_exp_0_d0*(((-(model_.zsp))*d_DFb_dV_si_ci))))*DFdvj_dv));
            d_DFC_j1_dV_s_c = (((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_s_c)+((cscp0_t*(deriv_exp_0_d0*(((-(model_.zsp))*d_DFb_dV_s_c))))*DFdvj_dv));
            d_DFC_j1_dV_tnode_GND = (((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND)+(((cscp0_t*(deriv_exp_0_d0*(((-(model_.zsp))*d_DFb_dV_tnode_GND))))+(d_cscp0_t_dV_tnode_GND*value_exp_0))*DFdvj_dv));
            DFC_j1 = ((cscp0_t*value_exp_0)*DFdvj_dv);
          }

          d_Cscp_dV_bi_ei = (d_DFC_j1_dV_bi_ei+((2.4*cscp0_t)*(-d_DFdvj_dv_dV_bi_ei)));
          d_Cscp_dV_tnode_GND = (d_DFC_j1_dV_tnode_GND+(((2.4*cscp0_t)*(-d_DFdvj_dv_dV_tnode_GND))+((2.4*d_cscp0_t_dV_tnode_GND)*(1.0-DFdvj_dv))));
          d_Cscp_dV_bi_ci = (d_DFC_j1_dV_bi_ci+((2.4*cscp0_t)*(-d_DFdvj_dv_dV_bi_ci)));
          d_Cscp_dV_bp_ei = (d_DFC_j1_dV_bp_ei+((2.4*cscp0_t)*(-d_DFdvj_dv_dV_bp_ei)));
          d_Cscp_dV_bp_ci = (d_DFC_j1_dV_bp_ci+((2.4*cscp0_t)*(-d_DFdvj_dv_dV_bp_ci)));
          d_Cscp_dV_b_ci = (d_DFC_j1_dV_b_ci+((2.4*cscp0_t)*(-d_DFdvj_dv_dV_b_ci)));
          d_Cscp_dV_si_ci = (d_DFC_j1_dV_si_ci+((2.4*cscp0_t)*(-d_DFdvj_dv_dV_si_ci)));
          d_Cscp_dV_s_c = (d_DFC_j1_dV_s_c+((2.4*cscp0_t)*(-d_DFdvj_dv_dV_s_c)));
          Cscp = (DFC_j1+((2.4*cscp0_t)*(1.0-DFdvj_dv)));
          {
            double value_exp_0 = exp((DFb*(1.0-(model_.zsp))));
            double  deriv_exp_0_d0 = value_exp_0;

            d_DFQ_j_dV_bi_ei = (((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bi_ei*(1.0-(model_.zsp)))))))/(1.0-(model_.zsp)));
            d_DFQ_j_dV_bi_ci = (((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bi_ci*(1.0-(model_.zsp)))))))/(1.0-(model_.zsp)));
            d_DFQ_j_dV_bp_ei = (((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bp_ei*(1.0-(model_.zsp)))))))/(1.0-(model_.zsp)));
            d_DFQ_j_dV_bp_ci = (((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*((d_DFb_dV_bp_ci*(1.0-(model_.zsp)))))))/(1.0-(model_.zsp)));
            d_DFQ_j_dV_b_ci = (((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*((d_DFb_dV_b_ci*(1.0-(model_.zsp)))))))/(1.0-(model_.zsp)));
            d_DFQ_j_dV_si_ci = (((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*((d_DFb_dV_si_ci*(1.0-(model_.zsp)))))))/(1.0-(model_.zsp)));
            d_DFQ_j_dV_s_c = (((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*((d_DFb_dV_s_c*(1.0-(model_.zsp)))))))/(1.0-(model_.zsp)));
            d_DFQ_j_dV_tnode_GND = ((((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*((d_DFb_dV_tnode_GND*(1.0-(model_.zsp)))))))+(((cscp0_t*d_vdsp_t_dV_tnode_GND)+(d_cscp0_t_dV_tnode_GND*vdsp_t))*(1.0-value_exp_0)))/(1.0-(model_.zsp)));
            DFQ_j = (((cscp0_t*vdsp_t)*(1.0-value_exp_0))/(1.0-(model_.zsp)));
          }

          d_Qscp_dV_bi_ei = (d_DFQ_j_dV_bi_ei+((2.4*cscp0_t)*(-d_DFv_j_dV_bi_ei)));
          d_Qscp_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+(((2.4*cscp0_t)*(-d_DFv_j_dV_tnode_GND))+((2.4*d_cscp0_t_dV_tnode_GND)*(Vsc-DFv_j))));
          d_Qscp_dV_bi_ci = (d_DFQ_j_dV_bi_ci+((2.4*cscp0_t)*(-d_DFv_j_dV_bi_ci)));
          d_Qscp_dV_bp_ei = (d_DFQ_j_dV_bp_ei+((2.4*cscp0_t)*(-d_DFv_j_dV_bp_ei)));
          d_Qscp_dV_bp_ci = (d_DFQ_j_dV_bp_ci+((2.4*cscp0_t)*(-d_DFv_j_dV_bp_ci)));
          d_Qscp_dV_b_ci = (d_DFQ_j_dV_b_ci+((2.4*cscp0_t)*(-d_DFv_j_dV_b_ci)));
          d_Qscp_dV_si_ci = (d_DFQ_j_dV_si_ci+((2.4*cscp0_t)*(-d_DFv_j_dV_si_ci)));
          d_Qscp_dV_s_c = (d_DFQ_j_dV_s_c+((2.4*cscp0_t)*(d_Vsc_dV_s_c-d_DFv_j_dV_s_c)));
          Qscp = (DFQ_j+((2.4*cscp0_t)*(Vsc-DFv_j)));
        }
        else
        {

          d_Cscp_dV_bp_ei = d_Cscp_dV_bi_ei = d_Cscp_dV_s_c = d_Cscp_dV_si_ci = d_Cscp_dV_b_ci = d_Cscp_dV_bp_ci = d_Cscp_dV_tnode_GND = d_Cscp_dV_bi_ci =  0.0;
          Cscp = 0.0;

          d_Qscp_dV_bp_ei = d_Qscp_dV_bi_ei = d_Qscp_dV_s_c = d_Qscp_dV_si_ci = d_Qscp_dV_b_ci = d_Qscp_dV_bp_ci = d_Qscp_dV_tnode_GND = d_Qscp_dV_bi_ci =  0.0;
          Qscp = 0.0;
        }
      }
    }
    else
    {

      d_Cscp_dV_bp_ei = d_Cscp_dV_bi_ei = d_Cscp_dV_s_c = d_Cscp_dV_si_ci = d_Cscp_dV_b_ci = d_Cscp_dV_bp_ci = d_Cscp_dV_tnode_GND = d_Cscp_dV_bi_ci =  0.0;
      Cscp = (model_.cscp0);

      d_Qscp_dV_bp_ei = d_Qscp_dV_bi_ei = d_Qscp_dV_si_ci = d_Qscp_dV_b_ci = d_Qscp_dV_bp_ci = d_Qscp_dV_tnode_GND = d_Qscp_dV_bi_ci =  0.0;
      d_Qscp_dV_s_c = ((model_.cscp0)*d_Vsc_dV_s_c);
      Qscp = ((model_.cscp0)*Vsc);
    }
    if (((model_.itss)>0.0))
      //Begin block Sub_Transfer
    {

      d_HSUM_dV_tnode_GND = ((model_.msf)*d_VT_dV_tnode_GND);
      HSUM = ((model_.msf)*VT);
      {
        double value_limexp_0 = limexp((Vbpci/HSUM));
        double  deriv_limexp_0_d0 = ((((Vbpci/HSUM))<80)?(value_limexp_0):exp(80.0));

        d_HSa_dV_tnode_GND = (deriv_limexp_0_d0*((-Vbpci*d_HSUM_dV_tnode_GND/HSUM/HSUM)));
        d_HSa_dV_bp_ci = (deriv_limexp_0_d0*((d_Vbpci_dV_bp_ci/HSUM)));
        HSa = value_limexp_0;
      }
      {
        double value_limexp_0 = limexp((Vsici/HSUM));
        double  deriv_limexp_0_d0 = ((((Vsici/HSUM))<80)?(value_limexp_0):exp(80.0));

        d_HSb_dV_tnode_GND = (deriv_limexp_0_d0*((-Vsici*d_HSUM_dV_tnode_GND/HSUM/HSUM)));
        d_HSb_dV_si_ci = (deriv_limexp_0_d0*((d_Vsici_dV_si_ci/HSUM)));
        HSb = value_limexp_0;
      }

      d_HSI_Tsu_dV_si_ci = (itss_t*(-d_HSb_dV_si_ci));
      d_HSI_Tsu_dV_bp_ci = (itss_t*d_HSa_dV_bp_ci);
      d_HSI_Tsu_dV_tnode_GND = ((itss_t*(d_HSa_dV_tnode_GND-d_HSb_dV_tnode_GND))+(d_itss_t_dV_tnode_GND*(HSa-HSb)));
      HSI_Tsu = (itss_t*(HSa-HSb));
      if (((model_.tsf)>0.0))
      {

        d_Qdsu_dV_bp_ci = ((tsf_t*itss_t)*d_HSa_dV_bp_ci);
        d_Qdsu_dV_tnode_GND = (((tsf_t*itss_t)*d_HSa_dV_tnode_GND)+(((tsf_t*d_itss_t_dV_tnode_GND)+(d_tsf_t_dV_tnode_GND*itss_t))*HSa));
        Qdsu = ((tsf_t*itss_t)*HSa);
      }
      else
      {

        d_Qdsu_dV_tnode_GND = d_Qdsu_dV_bp_ci =  0.0;
        Qdsu = 0.0;
      }
    }
    // End block Sub_Transfer
    else
    {

      d_HSI_Tsu_dV_tnode_GND = d_HSI_Tsu_dV_bp_ci = d_HSI_Tsu_dV_si_ci =  0.0;
      HSI_Tsu = 0.0;

      d_Qdsu_dV_tnode_GND = d_Qdsu_dV_bp_ci =  0.0;
      Qdsu = 0.0;
    }
    if ((ibei>0.0))
    {

      d_betadc_dV_bi_ci = (d_it_dV_bi_ci/ibei);
      d_betadc_dV_bi_ei = ((ibei*d_it_dV_bi_ei-it*d_ibei_dV_bi_ei)/ibei/ibei);
      d_betadc_dV_tnode_GND = ((ibei*d_it_dV_tnode_GND-it*d_ibei_dV_tnode_GND)/ibei/ibei);
      betadc = (it/ibei);
    }
    else
    {

      d_betadc_dV_tnode_GND = d_betadc_dV_bi_ei = d_betadc_dV_bi_ci =  0.0;
      betadc = 0.0;
    }

    d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei =  0.0;
    d_DIOY_dV_tnode_GND = (-Vsici*((model_.msc)*d_VT_dV_tnode_GND)/((model_.msc)*VT)/((model_.msc)*VT));
    d_DIOY_dV_si_ci = (d_Vsici_dV_si_ci/((model_.msc)*VT));
    DIOY = (Vsici/((model_.msc)*VT));
    if (((model_.iscs)>0.0))
    {
      if ((DIOY>80.0))
      {

        d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
        d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
        d_le_dV_bi_ci = d_DIOY_dV_bi_ci;
        d_le_dV_bp_ei = d_DIOY_dV_bp_ei;
        d_le_dV_bp_ci = d_DIOY_dV_bp_ci;
        d_le_dV_si_ci = d_DIOY_dV_si_ci;
        le = (1+(DIOY-80.0));

        d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
        DIOY = 80.0;
      }
      else
      {

        d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
        le = 1;
      }
      {
        double value_limexp_0 = limexp(DIOY);
        double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

        d_le_dV_tnode_GND = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND)))+(d_le_dV_tnode_GND*value_limexp_0));
        d_le_dV_bi_ei = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei)))+(d_le_dV_bi_ei*value_limexp_0));
        d_le_dV_bi_ci = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ci)))+(d_le_dV_bi_ci*value_limexp_0));
        d_le_dV_bp_ei = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bp_ei)))+(d_le_dV_bp_ei*value_limexp_0));
        d_le_dV_bp_ci = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_bp_ci)))+(d_le_dV_bp_ci*value_limexp_0));
        d_le_dV_si_ci = ((le*(deriv_limexp_0_d0*(d_DIOY_dV_si_ci)))+(d_le_dV_si_ci*value_limexp_0));
        le = (le*value_limexp_0);
      }

      d_ijsc_dV_bi_ei = (iscs_t*d_le_dV_bi_ei);
      d_ijsc_dV_bi_ci = (iscs_t*d_le_dV_bi_ci);
      d_ijsc_dV_bp_ei = (iscs_t*d_le_dV_bp_ei);
      d_ijsc_dV_bp_ci = (iscs_t*d_le_dV_bp_ci);
      d_ijsc_dV_si_ci = (iscs_t*d_le_dV_si_ci);
      d_ijsc_dV_tnode_GND = ((iscs_t*d_le_dV_tnode_GND)+(d_iscs_t_dV_tnode_GND*(le-1.0)));
      ijsc = (iscs_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {

        d_ijsc_dV_si_ci = d_ijsc_dV_bp_ci = d_ijsc_dV_bp_ei = d_ijsc_dV_bi_ci = d_ijsc_dV_bi_ei =  0.0;
        d_ijsc_dV_tnode_GND = (-d_iscs_t_dV_tnode_GND);
        ijsc = (-iscs_t);
      }
    }
    else
    {

      d_ijsc_dV_tnode_GND = d_ijsc_dV_si_ci = d_ijsc_dV_bp_ci = d_ijsc_dV_bp_ei = d_ijsc_dV_bi_ci = d_ijsc_dV_bi_ei =  0.0;
      ijsc = 0.0;
    }
    if ((((model_.flsh)==1)&&((model_.rth)>=0.001)))
    {

      d_pterm_dV_b_bp = d_pterm_dV_ci_c = d_pterm_dV_ei_e = d_pterm_dV_bp_bi = d_pterm_dV_bp_ei = d_pterm_dV_bp_ci = d_pterm_dV_si_ci =  0.0;
      d_pterm_dV_tnode_GND = ((Vciei*d_it_dV_tnode_GND)+(((vdci_t-Vbici)*d_iavl_dV_tnode_GND)+(d_vdci_t_dV_tnode_GND*iavl)));
      d_pterm_dV_bi_ci = (((Vciei*d_it_dV_bi_ci)+(d_Vciei_dV_bi_ci*it))+(((vdci_t-Vbici)*d_iavl_dV_bi_ci)+((-d_Vbici_dV_bi_ci)*iavl)));
      d_pterm_dV_bi_ei = (((Vciei*d_it_dV_bi_ei)+(d_Vciei_dV_bi_ei*it))+((vdci_t-Vbici)*d_iavl_dV_bi_ei));
      pterm = ((Vciei*it)+((vdci_t-Vbici)*iavl));
    }
    else
    {
      if ((((model_.flsh)==2)&&((model_.rth)>=0.001)))
      {

        d_pterm_dV_b_bp = d_pterm_dV_ci_c = d_pterm_dV_ei_e = d_pterm_dV_bp_bi =  0.0;
        d_pterm_dV_si_ci = ((ijsc*d_Vsici_dV_si_ci)+(d_ijsc_dV_si_ci*Vsici));
        d_pterm_dV_bp_ci = (((ijbcx*d_Vbpci_dV_bp_ci)+(d_ijbcx_dV_bp_ci*Vbpci))+(d_ijsc_dV_bp_ci*Vsici));
        d_pterm_dV_bp_ei = ((((ibep*d_Vbpei_dV_bp_ei)+(d_ibep_dV_bp_ei*Vbpei))+(d_ijbcx_dV_bp_ei*Vbpci))+(d_ijsc_dV_bp_ei*Vsici));
        d_pterm_dV_tnode_GND = (((((((Vciei*d_it_dV_tnode_GND)+(((vdci_t-Vbici)*d_iavl_dV_tnode_GND)+(d_vdci_t_dV_tnode_GND*iavl)))+(d_ibei_dV_tnode_GND*Vbiei))+(d_ibci_dV_tnode_GND*Vbici))+(d_ibep_dV_tnode_GND*Vbpei))+(d_ijbcx_dV_tnode_GND*Vbpci))+(d_ijsc_dV_tnode_GND*Vsici));
        d_pterm_dV_bi_ci = (((((((Vciei*d_it_dV_bi_ci)+(d_Vciei_dV_bi_ci*it))+(((vdci_t-Vbici)*d_iavl_dV_bi_ci)+((-d_Vbici_dV_bi_ci)*iavl)))+((ibci*d_Vbici_dV_bi_ci)+(d_ibci_dV_bi_ci*Vbici)))+(d_ibep_dV_bi_ci*Vbpei))+(d_ijbcx_dV_bi_ci*Vbpci))+(d_ijsc_dV_bi_ci*Vsici));
        d_pterm_dV_bi_ei = ((((((((Vciei*d_it_dV_bi_ei)+(d_Vciei_dV_bi_ei*it))+((vdci_t-Vbici)*d_iavl_dV_bi_ei))+((ibei*d_Vbiei_dV_bi_ei)+(d_ibei_dV_bi_ei*Vbiei)))+(d_ibci_dV_bi_ei*Vbici))+(d_ibep_dV_bi_ei*Vbpei))+(d_ijbcx_dV_bi_ei*Vbpci))+(d_ijsc_dV_bi_ei*Vsici));
        pterm = (((((((Vciei*it)+((vdci_t-Vbici)*iavl))+(ibei*Vbiei))+(ibci*Vbici))+(ibep*Vbpei))+(ijbcx*Vbpci))+(ijsc*Vsici));
        if ((rbi>=0.001))
        {

          d_pterm_dV_b_bp = d_pterm_dV_ci_c = d_pterm_dV_ei_e =  0.0;
          d_pterm_dV_bp_bi = (d_pterm_dV_bp_bi+((((probeVars[admsProbeID_V_bp_bi])*d_probeVars[admsProbeID_V_bp_bi][admsProbeID_V_bp_bi])+(d_probeVars[admsProbeID_V_bp_bi][admsProbeID_V_bp_bi]*(probeVars[admsProbeID_V_bp_bi])))/rbi));
          d_pterm_dV_tnode_GND = (d_pterm_dV_tnode_GND+(-((probeVars[admsProbeID_V_bp_bi])*(probeVars[admsProbeID_V_bp_bi]))*d_rbi_dV_tnode_GND/rbi/rbi));
          d_pterm_dV_bi_ci = (d_pterm_dV_bi_ci+(-((probeVars[admsProbeID_V_bp_bi])*(probeVars[admsProbeID_V_bp_bi]))*d_rbi_dV_bi_ci/rbi/rbi));
          d_pterm_dV_bi_ei = (d_pterm_dV_bi_ei+(-((probeVars[admsProbeID_V_bp_bi])*(probeVars[admsProbeID_V_bp_bi]))*d_rbi_dV_bi_ei/rbi/rbi));
          pterm = (pterm+(((probeVars[admsProbeID_V_bp_bi])*(probeVars[admsProbeID_V_bp_bi]))/rbi));
        }
        if ((re_t>=0.001))
        {

          d_pterm_dV_b_bp = d_pterm_dV_ci_c =  0.0;
          d_pterm_dV_ei_e = (d_pterm_dV_ei_e+((((probeVars[admsProbeID_V_ei_e])*d_probeVars[admsProbeID_V_ei_e][admsProbeID_V_ei_e])+(d_probeVars[admsProbeID_V_ei_e][admsProbeID_V_ei_e]*(probeVars[admsProbeID_V_ei_e])))/re_t));
          d_pterm_dV_tnode_GND = (d_pterm_dV_tnode_GND+(-((probeVars[admsProbeID_V_ei_e])*(probeVars[admsProbeID_V_ei_e]))*d_re_t_dV_tnode_GND/re_t/re_t));
          pterm = (pterm+(((probeVars[admsProbeID_V_ei_e])*(probeVars[admsProbeID_V_ei_e]))/re_t));
        }
        if ((rcx_t>=0.001))
        {

          d_pterm_dV_b_bp =  0.0;
          d_pterm_dV_ci_c = (d_pterm_dV_ci_c+((((probeVars[admsProbeID_V_ci_c])*d_probeVars[admsProbeID_V_ci_c][admsProbeID_V_ci_c])+(d_probeVars[admsProbeID_V_ci_c][admsProbeID_V_ci_c]*(probeVars[admsProbeID_V_ci_c])))/rcx_t));
          d_pterm_dV_tnode_GND = (d_pterm_dV_tnode_GND+(-((probeVars[admsProbeID_V_ci_c])*(probeVars[admsProbeID_V_ci_c]))*d_rcx_t_dV_tnode_GND/rcx_t/rcx_t));
          pterm = (pterm+(((probeVars[admsProbeID_V_ci_c])*(probeVars[admsProbeID_V_ci_c]))/rcx_t));
        }
        if ((rbx_t>=0.001))
        {

          d_pterm_dV_b_bp = (d_pterm_dV_b_bp+((((probeVars[admsProbeID_V_b_bp])*d_probeVars[admsProbeID_V_b_bp][admsProbeID_V_b_bp])+(d_probeVars[admsProbeID_V_b_bp][admsProbeID_V_b_bp]*(probeVars[admsProbeID_V_b_bp])))/rbx_t));
          d_pterm_dV_tnode_GND = (d_pterm_dV_tnode_GND+(-((probeVars[admsProbeID_V_b_bp])*(probeVars[admsProbeID_V_b_bp]))*d_rbx_t_dV_tnode_GND/rbx_t/rbx_t));
          pterm = (pterm+(((probeVars[admsProbeID_V_b_bp])*(probeVars[admsProbeID_V_b_bp]))/rbx_t));
        }
      }
    }

    d_Itxf_dV_xf2_GND =  0.0;
    d_Itxf_dV_bi_ci = d_itf_dV_bi_ci;
    d_Itxf_dV_bi_ei = d_itf_dV_bi_ei;
    d_Itxf_dV_tnode_GND = d_itf_dV_tnode_GND;
    Itxf = itf;

    d_Qdeix_dV_xf_GND =  0.0;
    d_Qdeix_dV_bi_ei = d_Qdei_dV_bi_ei;
    d_Qdeix_dV_bi_ci = d_Qdei_dV_bi_ci;
    d_Qdeix_dV_tnode_GND = d_Qdei_dV_tnode_GND;
    Qdeix = Qdei;
    if (((((((model_.flnqs)!=0)||((model_.flcomp)==0.0))||((model_.flcomp)==2.1))&&(Tf!=0))&&(((model_.alit)>0)||((model_.alqf)>0))))
    {

      d_Vxf1_dV_xf1_GND = d_probeVars[admsProbeID_V_xf1_GND][admsProbeID_V_xf1_GND];
      Vxf1 = (probeVars[admsProbeID_V_xf1_GND]);

      d_Vxf2_dV_xf2_GND = d_probeVars[admsProbeID_V_xf2_GND][admsProbeID_V_xf2_GND];
      Vxf2 = (probeVars[admsProbeID_V_xf2_GND]);

      d_Ixf1_dV_xf1_GND =  0.0;
      d_Ixf1_dV_bi_ci = (((Tf*(-d_itf_dV_bi_ci)-(Vxf2-itf)*d_Tf_dV_bi_ci)/Tf/Tf)*(model_.t0));
      d_Ixf1_dV_bi_ei = (((Tf*(-d_itf_dV_bi_ei)-(Vxf2-itf)*d_Tf_dV_bi_ei)/Tf/Tf)*(model_.t0));
      d_Ixf1_dV_tnode_GND = (((Tf*(-d_itf_dV_tnode_GND)-(Vxf2-itf)*d_Tf_dV_tnode_GND)/Tf/Tf)*(model_.t0));
      d_Ixf1_dV_xf2_GND = ((d_Vxf2_dV_xf2_GND/Tf)*(model_.t0));
      Ixf1 = (((Vxf2-itf)/Tf)*(model_.t0));

      d_Ixf2_dV_bi_ci = ((-(Vxf2-Vxf1)*d_Tf_dV_bi_ci/Tf/Tf)*(model_.t0));
      d_Ixf2_dV_tnode_GND = ((-(Vxf2-Vxf1)*d_Tf_dV_tnode_GND/Tf/Tf)*(model_.t0));
      d_Ixf2_dV_bi_ei = ((-(Vxf2-Vxf1)*d_Tf_dV_bi_ei/Tf/Tf)*(model_.t0));
      d_Ixf2_dV_xf1_GND = (((-d_Vxf1_dV_xf1_GND)/Tf)*(model_.t0));
      d_Ixf2_dV_xf2_GND = ((d_Vxf2_dV_xf2_GND/Tf)*(model_.t0));
      Ixf2 = (((Vxf2-Vxf1)/Tf)*(model_.t0));

      d_Qxf1_dV_xf1_GND = (((model_.alit)*d_Vxf1_dV_xf1_GND)*(model_.t0));
      Qxf1 = (((model_.alit)*Vxf1)*(model_.t0));

      d_Qxf2_dV_xf2_GND = ((((model_.alit)*d_Vxf2_dV_xf2_GND)/3)*(model_.t0));
      Qxf2 = ((((model_.alit)*Vxf2)/3)*(model_.t0));

      d_Itxf_dV_tnode_GND = d_Itxf_dV_bi_ei = d_Itxf_dV_bi_ci =  0.0;
      d_Itxf_dV_xf2_GND = d_Vxf2_dV_xf2_GND;
      Itxf = Vxf2;

      d_Vxf_dV_xf_GND = d_probeVars[admsProbeID_V_xf_GND][admsProbeID_V_xf_GND];
      Vxf = (probeVars[admsProbeID_V_xf_GND]);

      d_fact_dV_bi_ci = (-(model_.t0)*d_Tf_dV_bi_ci/Tf/Tf);
      d_fact_dV_tnode_GND = (-(model_.t0)*d_Tf_dV_tnode_GND/Tf/Tf);
      d_fact_dV_bi_ei = (-(model_.t0)*d_Tf_dV_bi_ei/Tf/Tf);
      fact = ((model_.t0)/Tf);

      d_Ixf_dV_bi_ei = (((Vxf-Qdei)*d_fact_dV_bi_ei)+((-d_Qdei_dV_bi_ei)*fact));
      d_Ixf_dV_bi_ci = (((Vxf-Qdei)*d_fact_dV_bi_ci)+((-d_Qdei_dV_bi_ci)*fact));
      d_Ixf_dV_tnode_GND = (((Vxf-Qdei)*d_fact_dV_tnode_GND)+((-d_Qdei_dV_tnode_GND)*fact));
      d_Ixf_dV_xf_GND = (d_Vxf_dV_xf_GND*fact);
      Ixf = ((Vxf-Qdei)*fact);

      d_Qxf_dV_xf_GND = (((model_.alqf)*d_Vxf_dV_xf_GND)*(model_.t0));
      Qxf = (((model_.alqf)*Vxf)*(model_.t0));

      d_Qdeix_dV_tnode_GND = d_Qdeix_dV_bi_ci = d_Qdeix_dV_bi_ei =  0.0;
      d_Qdeix_dV_xf_GND = d_Vxf_dV_xf_GND;
      Qdeix = Vxf;
    }
    else
    {

      d_Ixf1_dV_xf2_GND = d_Ixf1_dV_tnode_GND = d_Ixf1_dV_bi_ei = d_Ixf1_dV_bi_ci =  0.0;
      d_Ixf1_dV_xf1_GND = d_probeVars[admsProbeID_V_xf1_GND][admsProbeID_V_xf1_GND];
      Ixf1 = (probeVars[admsProbeID_V_xf1_GND]);

      d_Ixf2_dV_xf1_GND = d_Ixf2_dV_bi_ei = d_Ixf2_dV_tnode_GND = d_Ixf2_dV_bi_ci =  0.0;
      d_Ixf2_dV_xf2_GND = d_probeVars[admsProbeID_V_xf2_GND][admsProbeID_V_xf2_GND];
      Ixf2 = (probeVars[admsProbeID_V_xf2_GND]);

      d_Qxf1_dV_xf1_GND =  0.0;
      Qxf1 = 0;

      d_Qxf2_dV_xf2_GND =  0.0;
      Qxf2 = 0;

      d_Ixf_dV_tnode_GND = d_Ixf_dV_bi_ci = d_Ixf_dV_bi_ei =  0.0;
      d_Ixf_dV_xf_GND = d_probeVars[admsProbeID_V_xf_GND][admsProbeID_V_xf_GND];
      Ixf = (probeVars[admsProbeID_V_xf_GND]);

      d_Qxf_dV_xf_GND =  0.0;
      Qxf = 0;
    }
  }
  // End block Model_evaluation
  //Begin block Load_sources
  {
    // I(bi,ei) <+ (($simparam("gmin",1e-12)*V(bi,ei)))
    staticContributions[admsNodeID_bi] += (getDeviceOptions().gmin*(probeVars[admsProbeID_V_bi_ei]));
    d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += (getDeviceOptions().gmin*d_probeVars[admsProbeID_V_bi_ei][admsProbeID_V_bi_ei]);
    staticContributions[admsNodeID_ei] -= (getDeviceOptions().gmin*(probeVars[admsProbeID_V_bi_ei]));
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= (getDeviceOptions().gmin*d_probeVars[admsProbeID_V_bi_ei][admsProbeID_V_bi_ei]);
    // I(bi,ci) <+ (($simparam("gmin",1e-12)*V(bi,ci)))
    staticContributions[admsNodeID_bi] += (getDeviceOptions().gmin*(probeVars[admsProbeID_V_bi_ci]));
    d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += (getDeviceOptions().gmin*d_probeVars[admsProbeID_V_bi_ci][admsProbeID_V_bi_ci]);
    staticContributions[admsNodeID_ci] -= (getDeviceOptions().gmin*(probeVars[admsProbeID_V_bi_ci]));
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= (getDeviceOptions().gmin*d_probeVars[admsProbeID_V_bi_ci][admsProbeID_V_bi_ci]);
    // I(ci,ei) <+ (($simparam("gmin",1e-12)*V(ci,ei)))
    staticContributions[admsNodeID_ci] += (getDeviceOptions().gmin*(probeVars[admsProbeID_V_ci_ei]));
    d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_ei] += (getDeviceOptions().gmin*d_probeVars[admsProbeID_V_ci_ei][admsProbeID_V_ci_ei]);
    staticContributions[admsNodeID_ei] -= (getDeviceOptions().gmin*(probeVars[admsProbeID_V_ci_ei]));
    d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_ei] -= (getDeviceOptions().gmin*d_probeVars[admsProbeID_V_ci_ei][admsProbeID_V_ci_ei]);
    // I(b,ci) <+ (ddt((type*qjcx0_t_i)))
    dynamicContributions[admsNodeID_b] += (((model_.type)*qjcx0_t_i));
    d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ci] += (((model_.type)*d_qjcx0_t_i_dV_bi_ci));
    d_dynamicContributions[admsNodeID_b][admsProbeID_V_tnode_GND] += (((model_.type)*d_qjcx0_t_i_dV_tnode_GND));
    d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ci] += (((model_.type)*d_qjcx0_t_i_dV_bp_ci));
    d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci] += (((model_.type)*d_qjcx0_t_i_dV_b_ci));
    d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ei] += (((model_.type)*d_qjcx0_t_i_dV_bi_ei));
    d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ei] += (((model_.type)*d_qjcx0_t_i_dV_bp_ei));
    dynamicContributions[admsNodeID_ci] -= (((model_.type)*qjcx0_t_i));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= (((model_.type)*d_qjcx0_t_i_dV_bi_ci));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= (((model_.type)*d_qjcx0_t_i_dV_tnode_GND));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -= (((model_.type)*d_qjcx0_t_i_dV_bp_ci));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci] -= (((model_.type)*d_qjcx0_t_i_dV_b_ci));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= (((model_.type)*d_qjcx0_t_i_dV_bi_ei));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -= (((model_.type)*d_qjcx0_t_i_dV_bp_ei));
    // I(b,ci) <+ (ddt((cbcpar1*V(b,ci))))
    dynamicContributions[admsNodeID_b] += ((cbcpar1*(probeVars[admsProbeID_V_b_ci])));
    d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci] += ((cbcpar1*d_probeVars[admsProbeID_V_b_ci][admsProbeID_V_b_ci]));
    dynamicContributions[admsNodeID_ci] -= ((cbcpar1*(probeVars[admsProbeID_V_b_ci])));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci] -= ((cbcpar1*d_probeVars[admsProbeID_V_b_ci][admsProbeID_V_b_ci]));
    // I(bp,ci) <+ (ddt((cbcpar2*V(bp,ci))))
    dynamicContributions[admsNodeID_bp] += ((cbcpar2*(probeVars[admsProbeID_V_bp_ci])));
    d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci] += ((cbcpar2*d_probeVars[admsProbeID_V_bp_ci][admsProbeID_V_bp_ci]));
    dynamicContributions[admsNodeID_ci] -= ((cbcpar2*(probeVars[admsProbeID_V_bp_ci])));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -= ((cbcpar2*d_probeVars[admsProbeID_V_bp_ci][admsProbeID_V_bp_ci]));
    if (((model_.rbx)>=0.001))
    {
      // I(b,bp) <+ ((V(b,bp)/rbx_t))
      staticContributions[admsNodeID_b] += ((probeVars[admsProbeID_V_b_bp])/rbx_t);
      d_staticContributions[admsNodeID_b][admsProbeID_V_tnode_GND] += (-(probeVars[admsProbeID_V_b_bp])*d_rbx_t_dV_tnode_GND/rbx_t/rbx_t);
      d_staticContributions[admsNodeID_b][admsProbeID_V_b_bp] += (d_probeVars[admsProbeID_V_b_bp][admsProbeID_V_b_bp]/rbx_t);
      staticContributions[admsNodeID_bp] -= ((probeVars[admsProbeID_V_b_bp])/rbx_t);
      d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] -= (-(probeVars[admsProbeID_V_b_bp])*d_rbx_t_dV_tnode_GND/rbx_t/rbx_t);
      d_staticContributions[admsNodeID_bp][admsProbeID_V_b_bp] -= (d_probeVars[admsProbeID_V_b_bp][admsProbeID_V_b_bp]/rbx_t);
    }
    else
    {
      // V(b,bp) <+ (0.0)
      // do nothing at all
    }
    if (((model_.rbi0)>=0.001))
    {
      // I(bp,bi) <+ ((V(bp,bi)/rbi))
      staticContributions[admsNodeID_bp] += ((probeVars[admsProbeID_V_bp_bi])/rbi);
      d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += (-(probeVars[admsProbeID_V_bp_bi])*d_rbi_dV_bi_ci/rbi/rbi);
      d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += (-(probeVars[admsProbeID_V_bp_bi])*d_rbi_dV_bi_ei/rbi/rbi);
      d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += (-(probeVars[admsProbeID_V_bp_bi])*d_rbi_dV_tnode_GND/rbi/rbi);
      d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_bi] += (d_probeVars[admsProbeID_V_bp_bi][admsProbeID_V_bp_bi]/rbi);
      staticContributions[admsNodeID_bi] -= ((probeVars[admsProbeID_V_bp_bi])/rbi);
      d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] -= (-(probeVars[admsProbeID_V_bp_bi])*d_rbi_dV_bi_ci/rbi/rbi);
      d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] -= (-(probeVars[admsProbeID_V_bp_bi])*d_rbi_dV_bi_ei/rbi/rbi);
      d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] -= (-(probeVars[admsProbeID_V_bp_bi])*d_rbi_dV_tnode_GND/rbi/rbi);
      d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_bi] -= (d_probeVars[admsProbeID_V_bp_bi][admsProbeID_V_bp_bi]/rbi);
      // I(bp,bi) <+ (ddt(qrbi))
      dynamicContributions[admsNodeID_bp] += (qrbi);
      d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_bi] += (d_qrbi_dV_bp_bi);
      d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += (d_qrbi_dV_bi_ci);
      d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += (d_qrbi_dV_bi_ei);
      d_dynamicContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += (d_qrbi_dV_tnode_GND);
      dynamicContributions[admsNodeID_bi] -= (qrbi);
      d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_bi] -= (d_qrbi_dV_bp_bi);
      d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] -= (d_qrbi_dV_bi_ci);
      d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] -= (d_qrbi_dV_bi_ei);
      d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] -= (d_qrbi_dV_tnode_GND);
    }
    else
    {
      // V(bp,bi) <+ (0.0)
      // do nothing at all
    }
    if (((model_.tunode)==1.0))
    {
      // I(bp,ei) <+ (((-type)*ibet))
      staticContributions[admsNodeID_bp] += ((-(model_.type))*ibet);
      d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += ((-(model_.type))*d_ibet_dV_bi_ei);
      d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += ((-(model_.type))*d_ibet_dV_bi_ci);
      d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += ((-(model_.type))*d_ibet_dV_tnode_GND);
      d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] += ((-(model_.type))*d_ibet_dV_bp_ei);
      staticContributions[admsNodeID_ei] -= ((-(model_.type))*ibet);
      d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= ((-(model_.type))*d_ibet_dV_bi_ei);
      d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= ((-(model_.type))*d_ibet_dV_bi_ci);
      d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= ((-(model_.type))*d_ibet_dV_tnode_GND);
      d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -= ((-(model_.type))*d_ibet_dV_bp_ei);
    }
    else
    {
      // I(bi,ei) <+ (((-type)*ibet))
      staticContributions[admsNodeID_bi] += ((-(model_.type))*ibet);
      d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += ((-(model_.type))*d_ibet_dV_bi_ei);
      d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += ((-(model_.type))*d_ibet_dV_bi_ci);
      d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += ((-(model_.type))*d_ibet_dV_tnode_GND);
      d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ei] += ((-(model_.type))*d_ibet_dV_bp_ei);
      staticContributions[admsNodeID_ei] -= ((-(model_.type))*ibet);
      d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= ((-(model_.type))*d_ibet_dV_bi_ei);
      d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= ((-(model_.type))*d_ibet_dV_bi_ci);
      d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= ((-(model_.type))*d_ibet_dV_tnode_GND);
      d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -= ((-(model_.type))*d_ibet_dV_bp_ei);
    }
    // I(bp,ei) <+ ((type*ibep))
    staticContributions[admsNodeID_bp] += ((model_.type)*ibep);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += ((model_.type)*d_ibep_dV_bi_ei);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += ((model_.type)*d_ibep_dV_bi_ci);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] += ((model_.type)*d_ibep_dV_bp_ei);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += ((model_.type)*d_ibep_dV_tnode_GND);
    staticContributions[admsNodeID_ei] -= ((model_.type)*ibep);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= ((model_.type)*d_ibep_dV_bi_ei);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= ((model_.type)*d_ibep_dV_bi_ci);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -= ((model_.type)*d_ibep_dV_bp_ei);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= ((model_.type)*d_ibep_dV_tnode_GND);
    // I(bp,ei) <+ ((type*irep))
    staticContributions[admsNodeID_bp] += ((model_.type)*irep);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += ((model_.type)*d_irep_dV_bi_ei);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += ((model_.type)*d_irep_dV_bi_ci);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] += ((model_.type)*d_irep_dV_bp_ei);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += ((model_.type)*d_irep_dV_tnode_GND);
    staticContributions[admsNodeID_ei] -= ((model_.type)*irep);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= ((model_.type)*d_irep_dV_bi_ei);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= ((model_.type)*d_irep_dV_bi_ci);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -= ((model_.type)*d_irep_dV_bp_ei);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= ((model_.type)*d_irep_dV_tnode_GND);
    // I(bp,ei) <+ (ddt((type*Qjep)))
    dynamicContributions[admsNodeID_bp] += (((model_.type)*Qjep));
    d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += (((model_.type)*d_Qjep_dV_bi_ei));
    d_dynamicContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += (((model_.type)*d_Qjep_dV_tnode_GND));
    d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += (((model_.type)*d_Qjep_dV_bi_ci));
    d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] += (((model_.type)*d_Qjep_dV_bp_ei));
    dynamicContributions[admsNodeID_ei] -= (((model_.type)*Qjep));
    d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= (((model_.type)*d_Qjep_dV_bi_ei));
    d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= (((model_.type)*d_Qjep_dV_tnode_GND));
    d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= (((model_.type)*d_Qjep_dV_bi_ci));
    d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -= (((model_.type)*d_Qjep_dV_bp_ei));
    // I(bi,ei) <+ ((type*ibei))
    staticContributions[admsNodeID_bi] += ((model_.type)*ibei);
    d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += ((model_.type)*d_ibei_dV_bi_ei);
    d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += ((model_.type)*d_ibei_dV_tnode_GND);
    staticContributions[admsNodeID_ei] -= ((model_.type)*ibei);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= ((model_.type)*d_ibei_dV_bi_ei);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= ((model_.type)*d_ibei_dV_tnode_GND);
    // I(bi,ei) <+ ((type*irei))
    staticContributions[admsNodeID_bi] += ((model_.type)*irei);
    d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += ((model_.type)*d_irei_dV_bi_ei);
    d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += ((model_.type)*d_irei_dV_tnode_GND);
    staticContributions[admsNodeID_ei] -= ((model_.type)*irei);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= ((model_.type)*d_irei_dV_bi_ei);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= ((model_.type)*d_irei_dV_tnode_GND);
    // I(bi,ei) <+ ((type*ibh_rec))
    staticContributions[admsNodeID_bi] += ((model_.type)*ibh_rec);
    d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += ((model_.type)*d_ibh_rec_dV_bi_ci);
    d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += ((model_.type)*d_ibh_rec_dV_bi_ei);
    d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += ((model_.type)*d_ibh_rec_dV_tnode_GND);
    staticContributions[admsNodeID_ei] -= ((model_.type)*ibh_rec);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= ((model_.type)*d_ibh_rec_dV_bi_ci);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= ((model_.type)*d_ibh_rec_dV_bi_ei);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= ((model_.type)*d_ibh_rec_dV_tnode_GND);
    // I(bi,ei) <+ (ddt((type*(Qdeix+Qjei))))
    dynamicContributions[admsNodeID_bi] += (((model_.type)*(Qdeix+Qjei)));
    d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += (((model_.type)*(d_Qdeix_dV_bi_ei+d_Qjei_dV_bi_ei)));
    d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += (((model_.type)*d_Qdeix_dV_bi_ci));
    d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += (((model_.type)*(d_Qdeix_dV_tnode_GND+d_Qjei_dV_tnode_GND)));
    d_dynamicContributions[admsNodeID_bi][admsProbeID_V_xf_GND] += (((model_.type)*d_Qdeix_dV_xf_GND));
    dynamicContributions[admsNodeID_ei] -= (((model_.type)*(Qdeix+Qjei)));
    d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= (((model_.type)*(d_Qdeix_dV_bi_ei+d_Qjei_dV_bi_ei)));
    d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= (((model_.type)*d_Qdeix_dV_bi_ci));
    d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= (((model_.type)*(d_Qdeix_dV_tnode_GND+d_Qjei_dV_tnode_GND)));
    d_dynamicContributions[admsNodeID_ei][admsProbeID_V_xf_GND] -= (((model_.type)*d_Qdeix_dV_xf_GND));
    // I(bp,si) <+ ((type*HSI_Tsu))
    staticContributions[admsNodeID_bp] += ((model_.type)*HSI_Tsu);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_si_ci] += ((model_.type)*d_HSI_Tsu_dV_si_ci);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] += ((model_.type)*d_HSI_Tsu_dV_bp_ci);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += ((model_.type)*d_HSI_Tsu_dV_tnode_GND);
    staticContributions[admsNodeID_si] -= ((model_.type)*HSI_Tsu);
    d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci] -= ((model_.type)*d_HSI_Tsu_dV_si_ci);
    d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci] -= ((model_.type)*d_HSI_Tsu_dV_bp_ci);
    d_staticContributions[admsNodeID_si][admsProbeID_V_tnode_GND] -= ((model_.type)*d_HSI_Tsu_dV_tnode_GND);
    // I(bp,ci) <+ ((type*ijbcx))
    staticContributions[admsNodeID_bp] += ((model_.type)*ijbcx);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += ((model_.type)*d_ijbcx_dV_bi_ei);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += ((model_.type)*d_ijbcx_dV_bi_ci);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] += ((model_.type)*d_ijbcx_dV_bp_ei);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] += ((model_.type)*d_ijbcx_dV_bp_ci);
    d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += ((model_.type)*d_ijbcx_dV_tnode_GND);
    staticContributions[admsNodeID_ci] -= ((model_.type)*ijbcx);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= ((model_.type)*d_ijbcx_dV_bi_ei);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= ((model_.type)*d_ijbcx_dV_bi_ci);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -= ((model_.type)*d_ijbcx_dV_bp_ei);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -= ((model_.type)*d_ijbcx_dV_bp_ci);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= ((model_.type)*d_ijbcx_dV_tnode_GND);
    // I(bp,ci) <+ (ddt((type*(qjcx0_t_ii+Qdsu))))
    dynamicContributions[admsNodeID_bp] += (((model_.type)*(qjcx0_t_ii+Qdsu)));
    d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += (((model_.type)*d_qjcx0_t_ii_dV_bi_ci));
    d_dynamicContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += (((model_.type)*(d_qjcx0_t_ii_dV_tnode_GND+d_Qdsu_dV_tnode_GND)));
    d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci] += (((model_.type)*(d_qjcx0_t_ii_dV_bp_ci+d_Qdsu_dV_bp_ci)));
    d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += (((model_.type)*d_qjcx0_t_ii_dV_bi_ei));
    d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] += (((model_.type)*d_qjcx0_t_ii_dV_bp_ei));
    dynamicContributions[admsNodeID_ci] -= (((model_.type)*(qjcx0_t_ii+Qdsu)));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= (((model_.type)*d_qjcx0_t_ii_dV_bi_ci));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= (((model_.type)*(d_qjcx0_t_ii_dV_tnode_GND+d_Qdsu_dV_tnode_GND)));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -= (((model_.type)*(d_qjcx0_t_ii_dV_bp_ci+d_Qdsu_dV_bp_ci)));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= (((model_.type)*d_qjcx0_t_ii_dV_bi_ei));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -= (((model_.type)*d_qjcx0_t_ii_dV_bp_ei));
    // I(b,e) <+ (ddt((cbepar1*V(b,e))))
    dynamicContributions[admsNodeID_b] += ((cbepar1*(probeVars[admsProbeID_V_b_e])));
    d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e] += ((cbepar1*d_probeVars[admsProbeID_V_b_e][admsProbeID_V_b_e]));
    dynamicContributions[admsNodeID_e] -= ((cbepar1*(probeVars[admsProbeID_V_b_e])));
    d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e] -= ((cbepar1*d_probeVars[admsProbeID_V_b_e][admsProbeID_V_b_e]));
    // I(bp,e) <+ (ddt((cbepar2*V(bp,e))))
    dynamicContributions[admsNodeID_bp] += ((cbepar2*(probeVars[admsProbeID_V_bp_e])));
    d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_e] += ((cbepar2*d_probeVars[admsProbeID_V_bp_e][admsProbeID_V_bp_e]));
    dynamicContributions[admsNodeID_e] -= ((cbepar2*(probeVars[admsProbeID_V_bp_e])));
    d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_e] -= ((cbepar2*d_probeVars[admsProbeID_V_bp_e][admsProbeID_V_bp_e]));
    // I(bi,ci) <+ ((type*(ibci-iavl)))
    staticContributions[admsNodeID_bi] += ((model_.type)*(ibci-iavl));
    d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += ((model_.type)*(d_ibci_dV_bi_ei-d_iavl_dV_bi_ei));
    d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += ((model_.type)*(d_ibci_dV_bi_ci-d_iavl_dV_bi_ci));
    d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += ((model_.type)*(d_ibci_dV_tnode_GND-d_iavl_dV_tnode_GND));
    staticContributions[admsNodeID_ci] -= ((model_.type)*(ibci-iavl));
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= ((model_.type)*(d_ibci_dV_bi_ei-d_iavl_dV_bi_ei));
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= ((model_.type)*(d_ibci_dV_bi_ci-d_iavl_dV_bi_ci));
    d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= ((model_.type)*(d_ibci_dV_tnode_GND-d_iavl_dV_tnode_GND));
    // I(bi,ci) <+ (ddt((type*(Qdci+Qjci))))
    dynamicContributions[admsNodeID_bi] += (((model_.type)*(Qdci+Qjci)));
    d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += (((model_.type)*(d_Qdci_dV_bi_ei+d_Qjci_dV_bi_ei)));
    d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += (((model_.type)*(d_Qdci_dV_bi_ci+d_Qjci_dV_bi_ci)));
    d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += (((model_.type)*(d_Qdci_dV_tnode_GND+d_Qjci_dV_tnode_GND)));
    dynamicContributions[admsNodeID_ci] -= (((model_.type)*(Qdci+Qjci)));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= (((model_.type)*(d_Qdci_dV_bi_ei+d_Qjci_dV_bi_ei)));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= (((model_.type)*(d_Qdci_dV_bi_ci+d_Qjci_dV_bi_ci)));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= (((model_.type)*(d_Qdci_dV_tnode_GND+d_Qjci_dV_tnode_GND)));
    // I(si,ci) <+ ((type*ijsc))
    staticContributions[admsNodeID_si] += ((model_.type)*ijsc);
    d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ei] += ((model_.type)*d_ijsc_dV_bi_ei);
    d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ci] += ((model_.type)*d_ijsc_dV_bi_ci);
    d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ei] += ((model_.type)*d_ijsc_dV_bp_ei);
    d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci] += ((model_.type)*d_ijsc_dV_bp_ci);
    d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci] += ((model_.type)*d_ijsc_dV_si_ci);
    d_staticContributions[admsNodeID_si][admsProbeID_V_tnode_GND] += ((model_.type)*d_ijsc_dV_tnode_GND);
    staticContributions[admsNodeID_ci] -= ((model_.type)*ijsc);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= ((model_.type)*d_ijsc_dV_bi_ei);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= ((model_.type)*d_ijsc_dV_bi_ci);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -= ((model_.type)*d_ijsc_dV_bp_ei);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -= ((model_.type)*d_ijsc_dV_bp_ci);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_si_ci] -= ((model_.type)*d_ijsc_dV_si_ci);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= ((model_.type)*d_ijsc_dV_tnode_GND);
    // I(si,ci) <+ (ddt((type*Qjs)))
    dynamicContributions[admsNodeID_si] += (((model_.type)*Qjs));
    d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ci] += (((model_.type)*d_Qjs_dV_bi_ci));
    d_dynamicContributions[admsNodeID_si][admsProbeID_V_tnode_GND] += (((model_.type)*d_Qjs_dV_tnode_GND));
    d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ci] += (((model_.type)*d_Qjs_dV_bp_ci));
    d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_ci] += (((model_.type)*d_Qjs_dV_b_ci));
    d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_ci] += (((model_.type)*d_Qjs_dV_si_ci));
    d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ei] += (((model_.type)*d_Qjs_dV_bi_ei));
    d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ei] += (((model_.type)*d_Qjs_dV_bp_ei));
    dynamicContributions[admsNodeID_ci] -= (((model_.type)*Qjs));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= (((model_.type)*d_Qjs_dV_bi_ci));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= (((model_.type)*d_Qjs_dV_tnode_GND));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -= (((model_.type)*d_Qjs_dV_bp_ci));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci] -= (((model_.type)*d_Qjs_dV_b_ci));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_ci] -= (((model_.type)*d_Qjs_dV_si_ci));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= (((model_.type)*d_Qjs_dV_bi_ei));
    d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -= (((model_.type)*d_Qjs_dV_bp_ei));
    // I(s,c) <+ (ddt((type*Qscp)))
    dynamicContributions[admsNodeID_s] += (((model_.type)*Qscp));
    d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ci] += (((model_.type)*d_Qscp_dV_bi_ci));
    d_dynamicContributions[admsNodeID_s][admsProbeID_V_tnode_GND] += (((model_.type)*d_Qscp_dV_tnode_GND));
    d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ci] += (((model_.type)*d_Qscp_dV_bp_ci));
    d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_ci] += (((model_.type)*d_Qscp_dV_b_ci));
    d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_ci] += (((model_.type)*d_Qscp_dV_si_ci));
    d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c] += (((model_.type)*d_Qscp_dV_s_c));
    d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ei] += (((model_.type)*d_Qscp_dV_bi_ei));
    d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ei] += (((model_.type)*d_Qscp_dV_bp_ei));
    dynamicContributions[admsNodeID_c] -= (((model_.type)*Qscp));
    d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ci] -= (((model_.type)*d_Qscp_dV_bi_ci));
    d_dynamicContributions[admsNodeID_c][admsProbeID_V_tnode_GND] -= (((model_.type)*d_Qscp_dV_tnode_GND));
    d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ci] -= (((model_.type)*d_Qscp_dV_bp_ci));
    d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_ci] -= (((model_.type)*d_Qscp_dV_b_ci));
    d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_ci] -= (((model_.type)*d_Qscp_dV_si_ci));
    d_dynamicContributions[admsNodeID_c][admsProbeID_V_s_c] -= (((model_.type)*d_Qscp_dV_s_c));
    d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ei] -= (((model_.type)*d_Qscp_dV_bi_ei));
    d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ei] -= (((model_.type)*d_Qscp_dV_bp_ei));
    // I(ci,ei) <+ ((type*Itxf))
    staticContributions[admsNodeID_ci] += ((model_.type)*Itxf);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] += ((model_.type)*d_Itxf_dV_bi_ci);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] += ((model_.type)*d_Itxf_dV_bi_ei);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] += ((model_.type)*d_Itxf_dV_tnode_GND);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_xf2_GND] += ((model_.type)*d_Itxf_dV_xf2_GND);
    staticContributions[admsNodeID_ei] -= ((model_.type)*Itxf);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= ((model_.type)*d_Itxf_dV_bi_ci);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= ((model_.type)*d_Itxf_dV_bi_ei);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= ((model_.type)*d_Itxf_dV_tnode_GND);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_xf2_GND] -= ((model_.type)*d_Itxf_dV_xf2_GND);
    // I(ei,ci) <+ ((type*itr))
    staticContributions[admsNodeID_ei] += ((model_.type)*itr);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] += ((model_.type)*d_itr_dV_bi_ei);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] += ((model_.type)*d_itr_dV_bi_ci);
    d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] += ((model_.type)*d_itr_dV_tnode_GND);
    staticContributions[admsNodeID_ci] -= ((model_.type)*itr);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= ((model_.type)*d_itr_dV_bi_ei);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= ((model_.type)*d_itr_dV_bi_ci);
    d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= ((model_.type)*d_itr_dV_tnode_GND);
    if (((model_.rcx)>=0.001))
    {
      // I(ci,c) <+ ((V(ci,c)/rcx_t))
      staticContributions[admsNodeID_ci] += ((probeVars[admsProbeID_V_ci_c])/rcx_t);
      d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] += (-(probeVars[admsProbeID_V_ci_c])*d_rcx_t_dV_tnode_GND/rcx_t/rcx_t);
      d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_c] += (d_probeVars[admsProbeID_V_ci_c][admsProbeID_V_ci_c]/rcx_t);
      staticContributions[admsNodeID_c] -= ((probeVars[admsProbeID_V_ci_c])/rcx_t);
      d_staticContributions[admsNodeID_c][admsProbeID_V_tnode_GND] -= (-(probeVars[admsProbeID_V_ci_c])*d_rcx_t_dV_tnode_GND/rcx_t/rcx_t);
      d_staticContributions[admsNodeID_c][admsProbeID_V_ci_c] -= (d_probeVars[admsProbeID_V_ci_c][admsProbeID_V_ci_c]/rcx_t);
    }
    else
    {
      // V(ci,c) <+ (0.0)
      // do nothing at all
    }
    if (((model_.re)>=0.001))
    {
      // I(ei,e) <+ ((V(ei,e)/re_t))
      staticContributions[admsNodeID_ei] += ((probeVars[admsProbeID_V_ei_e])/re_t);
      d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] += (-(probeVars[admsProbeID_V_ei_e])*d_re_t_dV_tnode_GND/re_t/re_t);
      d_staticContributions[admsNodeID_ei][admsProbeID_V_ei_e] += (d_probeVars[admsProbeID_V_ei_e][admsProbeID_V_ei_e]/re_t);
      staticContributions[admsNodeID_e] -= ((probeVars[admsProbeID_V_ei_e])/re_t);
      d_staticContributions[admsNodeID_e][admsProbeID_V_tnode_GND] -= (-(probeVars[admsProbeID_V_ei_e])*d_re_t_dV_tnode_GND/re_t/re_t);
      d_staticContributions[admsNodeID_e][admsProbeID_V_ei_e] -= (d_probeVars[admsProbeID_V_ei_e][admsProbeID_V_ei_e]/re_t);
    }
    else
    {
      // V(ei,e) <+ (0.0)
      // do nothing at all
    }
    if (((model_.rsu)>=0.001))
    {
      // I(si,s) <+ ((V(si,s)/rsu))
      staticContributions[admsNodeID_si] += ((probeVars[admsProbeID_V_si_s])/(model_.rsu));
      d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] += (d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s]/(model_.rsu));
      staticContributions[admsNodeID_s] -= ((probeVars[admsProbeID_V_si_s])/(model_.rsu));
      d_staticContributions[admsNodeID_s][admsProbeID_V_si_s] -= (d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s]/(model_.rsu));
      // I(si,s) <+ (ddt((csu*V(si,s))))
      dynamicContributions[admsNodeID_si] += (((model_.csu)*(probeVars[admsProbeID_V_si_s])));
      d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s] += (((model_.csu)*d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s]));
      dynamicContributions[admsNodeID_s] -= (((model_.csu)*(probeVars[admsProbeID_V_si_s])));
      d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_s] -= (((model_.csu)*d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s]));
    }
    else
    {
      // V(si,s) <+ (0.0)
      // do nothing at all
    }
    if ((((model_.flsh)==0)||((model_.rth)<0.001)))
    {
      // I(tnode,GND) <+ ((V(tnode,GND)/0.001))
      staticContributions[admsNodeID_tnode] += ((probeVars[admsProbeID_V_tnode_GND])/0.001);
      d_staticContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND] += (d_probeVars[admsProbeID_V_tnode_GND][admsProbeID_V_tnode_GND]/0.001);
    }
    else
    {
      // I(tnode,GND) <+ (((V(tnode,GND)/rth_t)-pterm))
      staticContributions[admsNodeID_tnode] += (((probeVars[admsProbeID_V_tnode_GND])/rth_t)-pterm);
      d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ci] += (-d_pterm_dV_bi_ci);
      d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ei] += (-d_pterm_dV_bi_ei);
      d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_ci] += (-d_pterm_dV_si_ci);
      d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ci] += (-d_pterm_dV_bp_ci);
      d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] += (-d_pterm_dV_bp_ei);
      d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] += (-d_pterm_dV_bp_bi);
      d_staticContributions[admsNodeID_tnode][admsProbeID_V_ei_e] += (-d_pterm_dV_ei_e);
      d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_c] += (-d_pterm_dV_ci_c);
      d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_bp] += (-d_pterm_dV_b_bp);
      d_staticContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND] += (((rth_t*d_probeVars[admsProbeID_V_tnode_GND][admsProbeID_V_tnode_GND]-(probeVars[admsProbeID_V_tnode_GND])*d_rth_t_dV_tnode_GND)/rth_t/rth_t)-d_pterm_dV_tnode_GND);
      // I(tnode,GND) <+ (ddt((cth*V(tnode,GND))))
      dynamicContributions[admsNodeID_tnode] += (((model_.cth)*(probeVars[admsProbeID_V_tnode_GND])));
      d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND] += (((model_.cth)*d_probeVars[admsProbeID_V_tnode_GND][admsProbeID_V_tnode_GND]));
    }
    // I(xf1,GND) <+ (Ixf1)
    staticContributions[admsNodeID_xf1] += Ixf1;
    d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ci] += d_Ixf1_dV_bi_ci;
    d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ei] += d_Ixf1_dV_bi_ei;
    d_staticContributions[admsNodeID_xf1][admsProbeID_V_tnode_GND] += d_Ixf1_dV_tnode_GND;
    d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf2_GND] += d_Ixf1_dV_xf2_GND;
    d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND] += d_Ixf1_dV_xf1_GND;
    // I(xf1,GND) <+ (ddt(Qxf1))
    dynamicContributions[admsNodeID_xf1] += (Qxf1);
    d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND] += (d_Qxf1_dV_xf1_GND);
    // I(xf2,GND) <+ (Ixf2)
    staticContributions[admsNodeID_xf2] += Ixf2;
    d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ci] += d_Ixf2_dV_bi_ci;
    d_staticContributions[admsNodeID_xf2][admsProbeID_V_tnode_GND] += d_Ixf2_dV_tnode_GND;
    d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ei] += d_Ixf2_dV_bi_ei;
    d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf1_GND] += d_Ixf2_dV_xf1_GND;
    d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND] += d_Ixf2_dV_xf2_GND;
    // I(xf2,GND) <+ (ddt(Qxf2))
    dynamicContributions[admsNodeID_xf2] += (Qxf2);
    d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND] += (d_Qxf2_dV_xf2_GND);
    // I(xf,GND) <+ (Ixf)
    staticContributions[admsNodeID_xf] += Ixf;
    d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ei] += d_Ixf_dV_bi_ei;
    d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ci] += d_Ixf_dV_bi_ci;
    d_staticContributions[admsNodeID_xf][admsProbeID_V_tnode_GND] += d_Ixf_dV_tnode_GND;
    d_staticContributions[admsNodeID_xf][admsProbeID_V_xf_GND] += d_Ixf_dV_xf_GND;
    // I(xf,GND) <+ (ddt(Qxf))
    dynamicContributions[admsNodeID_xf] += (Qxf);
    d_dynamicContributions[admsNodeID_xf][admsProbeID_V_xf_GND] += (d_Qxf_dV_xf_GND);
  }
  // End block Load_sources
  //Begin block noise
  {

    d_fourkt_dV_tnode_GND = ((4.0*1.3806503e-23)*d_Tdev_dV_tnode_GND);
    fourkt = ((4.0*1.3806503e-23)*Tdev);
    if (((model_.rbx)>=0.001))
    {
      // I(b,bp) <+ (white_noise((fourkt/rbx_t),"rbx"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[0]= (fourkt/rbx_t);
      }
    }
    if (((model_.rbi0)>=0.001))
    {
      // I(bp,bi) <+ (white_noise((fourkt/rbi),"rbi"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[1]= (fourkt/rbi);
      }
    }
    if (((model_.rcx)>=0.001))
    {
      // I(ci,c) <+ (white_noise((fourkt/rcx_t),"rcx"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[2]= (fourkt/rcx_t);
      }
    }
    if (((model_.re)>=0.001))
    {
      // I(ei,e) <+ (white_noise((fourkt/re_t),"re"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[3]= (fourkt/re_t);
      }
    }
    if (((model_.rsu)>=0.001))
    {
      // I(si,s) <+ (white_noise((fourkt/rsu),"rsu"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[4]= (fourkt/(model_.rsu));
      }
    }
    {
      double value_fabs_0 = fabs((ibei+ibep));
      double value_pow_1 = pow(value_fabs_0,(model_.af));
      double  deriv_fabs_0_d0 = ((((ibei+ibep))>=0)?(+1.0):(-1.0));
      double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.af)/value_fabs_0));

      d_flicker_Pwr_dV_ei_e =  0.0;
      d_flicker_Pwr_dV_bi_ci = ((model_.kf)*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_ibep_dV_bi_ci)))));
      d_flicker_Pwr_dV_bp_ei = ((model_.kf)*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_ibep_dV_bp_ei)))));
      d_flicker_Pwr_dV_bi_ei = ((model_.kf)*(deriv_pow_1_d0*((deriv_fabs_0_d0*((d_ibei_dV_bi_ei+d_ibep_dV_bi_ei))))));
      d_flicker_Pwr_dV_tnode_GND = ((model_.kf)*(deriv_pow_1_d0*((deriv_fabs_0_d0*((d_ibei_dV_tnode_GND+d_ibep_dV_tnode_GND))))));
      flicker_Pwr = ((model_.kf)*value_pow_1);
    }
    if (((model_.cfbe)==(-1)))
    {
      // I(bi,ei) <+ (flicker_noise(flicker_Pwr,1.0,"flicker"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[5]= flicker_Pwr;
        noiseContribsExponent[5]= 1.0;
      }
    }
    else
    {
      // I(bp,ei) <+ (flicker_noise(flicker_Pwr,1.0,"flicker"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[6]= flicker_Pwr;
        noiseContribsExponent[6]= 1.0;
      }
    }
    if (((model_.re)>=0.001))
    {

      d_i_re_dV_tnode_GND = (-(probeVars[admsProbeID_V_ei_e])*d_re_t_dV_tnode_GND/re_t/re_t);
      d_i_re_dV_ei_e = (d_probeVars[admsProbeID_V_ei_e][admsProbeID_V_ei_e]/re_t);
      i_re = ((probeVars[admsProbeID_V_ei_e])/re_t);
      {
        double value_fabs_0 = fabs(i_re);
        double value_pow_1 = pow(value_fabs_0,(model_.afre));
        double  deriv_fabs_0_d0 = (((i_re)>=0)?(+1.0):(-1.0));
        double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.afre)/value_fabs_0));

        d_flicker_Pwr_dV_bi_ei = d_flicker_Pwr_dV_bp_ei = d_flicker_Pwr_dV_bi_ci =  0.0;
        d_flicker_Pwr_dV_tnode_GND = ((model_.kfre)*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_i_re_dV_tnode_GND)))));
        d_flicker_Pwr_dV_ei_e = ((model_.kfre)*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_i_re_dV_ei_e)))));
        flicker_Pwr = ((model_.kfre)*value_pow_1);
      }
      // I(ei,e) <+ (flicker_noise(flicker_Pwr,1.0,"flicker_re"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[7]= flicker_Pwr;
        noiseContribsExponent[7]= 1.0;
      }
    }
    twoq = (2.0*1.6021766208e-19);
    // I(ci,bi) <+ (white_noise((twoq*iavl),"iavl"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[8]= (twoq*iavl);
    }
    // I(bi,ci) <+ (white_noise((twoq*abs(ibci)),"ibci"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[9]= (twoq*fabs(ibci));
    }
    // I(bp,ei) <+ (white_noise((twoq*abs(ibep)),"ibep"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[10]= (twoq*fabs(ibep));
    }
    // I(bp,ci) <+ (white_noise((twoq*abs(ijbcx)),"ijbcx"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[11]= (twoq*fabs(ijbcx));
    }
    // I(si,ci) <+ (white_noise((twoq*abs(ijsc)),"ijsc"))
    if (getSolverState().noiseFlag)
    {
      noiseContribsPower[12]= (twoq*fabs(ijsc));
    }
    if ((((model_.flcono)==1)&&(((model_.alit)>0)&&((model_.alqf)>0))))
    {
      n_w = 1;

      d_n_1_dV_bi_ci = (d_Tf_dV_bi_ci*(model_.alit));
      d_n_1_dV_tnode_GND = (d_Tf_dV_tnode_GND*(model_.alit));
      d_n_1_dV_bi_ei = (d_Tf_dV_bi_ei*(model_.alit));
      n_1 = (Tf*(model_.alit));

      d_sqrt_n2_dV_bi_ci = (d_betadc_dV_bi_ci*((2*(model_.alqf))-((model_.alit)*(model_.alit))));
      d_sqrt_n2_dV_bi_ei = (d_betadc_dV_bi_ei*((2*(model_.alqf))-((model_.alit)*(model_.alit))));
      d_sqrt_n2_dV_tnode_GND = (d_betadc_dV_tnode_GND*((2*(model_.alqf))-((model_.alit)*(model_.alit))));
      sqrt_n2 = (betadc*((2*(model_.alqf))-((model_.alit)*(model_.alit))));
      if ((sqrt_n2>0.0))
      {
        {
          double value_sqrt_0 = sqrt(sqrt_n2);
          double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

          d_n_2_dV_bi_ci = ((Tf*(deriv_sqrt_0_d0*(d_sqrt_n2_dV_bi_ci)))+(d_Tf_dV_bi_ci*value_sqrt_0));
          d_n_2_dV_tnode_GND = ((Tf*(deriv_sqrt_0_d0*(d_sqrt_n2_dV_tnode_GND)))+(d_Tf_dV_tnode_GND*value_sqrt_0));
          d_n_2_dV_bi_ei = ((Tf*(deriv_sqrt_0_d0*(d_sqrt_n2_dV_bi_ei)))+(d_Tf_dV_bi_ei*value_sqrt_0));
          n_2 = (Tf*value_sqrt_0);
        }
      }
      else
      {

        d_n_2_dV_bi_ei = d_n_2_dV_tnode_GND = d_n_2_dV_bi_ci =  0.0;
        n_2 = 0;
      }
      // I(n1,GND) <+ (white_noise(((2*1.6021766208e-19)*abs(ibei)),"ibei"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[13]= ((2*1.6021766208e-19)*fabs(ibei));
      }
      // I(n1,GND) <+ ((-V(n1,GND)))
      staticContributions[admsNodeID_n1] += (-(probeVars[admsProbeID_V_n1_GND]));
      d_staticContributions[admsNodeID_n1][admsProbeID_V_n1_GND] += (-d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND]);
      // I(bi,ei) <+ (V(n1,GND))
      staticContributions[admsNodeID_bi] += (probeVars[admsProbeID_V_n1_GND]);
      d_staticContributions[admsNodeID_bi][admsProbeID_V_n1_GND] += d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND];
      staticContributions[admsNodeID_ei] -= (probeVars[admsProbeID_V_n1_GND]);
      d_staticContributions[admsNodeID_ei][admsProbeID_V_n1_GND] -= d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND];
      // I(bi,ei) <+ (((n_2/n_w)*ddt((n_w*V(n1,GND)))))
      dynamicContributions[admsNodeID_bi] += ((n_2/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND]))));
      d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n1_GND] += ((n_2/n_w)*((n_w*d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND])));
      d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += (((n_2/n_w)*(0.0))+((d_n_2_dV_bi_ci/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND])))));
      d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += (((n_2/n_w)*(0.0))+((d_n_2_dV_tnode_GND/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND])))));
      d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += (((n_2/n_w)*(0.0))+((d_n_2_dV_bi_ei/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND])))));
      dynamicContributions[admsNodeID_ei] -= ((n_2/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND]))));
      d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n1_GND] -= ((n_2/n_w)*((n_w*d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND])));
      d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= (((n_2/n_w)*(0.0))+((d_n_2_dV_bi_ci/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND])))));
      d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= (((n_2/n_w)*(0.0))+((d_n_2_dV_tnode_GND/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND])))));
      d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= (((n_2/n_w)*(0.0))+((d_n_2_dV_bi_ei/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND])))));
      // I(bi,ei) <+ (((n_1/n_w)*ddt((n_w*V(n2,GND)))))
      dynamicContributions[admsNodeID_bi] += ((n_1/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND]))));
      d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n2_GND] += ((n_1/n_w)*((n_w*d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND])));
      d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += (((n_1/n_w)*(0.0))+((d_n_1_dV_bi_ci/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND])))));
      d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += (((n_1/n_w)*(0.0))+((d_n_1_dV_tnode_GND/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND])))));
      d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += (((n_1/n_w)*(0.0))+((d_n_1_dV_bi_ei/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND])))));
      dynamicContributions[admsNodeID_ei] -= ((n_1/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND]))));
      d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n2_GND] -= ((n_1/n_w)*((n_w*d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND])));
      d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= (((n_1/n_w)*(0.0))+((d_n_1_dV_bi_ci/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND])))));
      d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= (((n_1/n_w)*(0.0))+((d_n_1_dV_tnode_GND/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND])))));
      d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= (((n_1/n_w)*(0.0))+((d_n_1_dV_bi_ei/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND])))));
      // I(n2,GND) <+ (white_noise(((2*1.6021766208e-19)*abs(it)),"it"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[14]= ((2*1.6021766208e-19)*fabs(it));
      }
      // I(n2,GND) <+ ((-V(n2,GND)))
      staticContributions[admsNodeID_n2] += (-(probeVars[admsProbeID_V_n2_GND]));
      d_staticContributions[admsNodeID_n2][admsProbeID_V_n2_GND] += (-d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND]);
      // I(ci,ei) <+ (V(n2,GND))
      staticContributions[admsNodeID_ci] += (probeVars[admsProbeID_V_n2_GND]);
      d_staticContributions[admsNodeID_ci][admsProbeID_V_n2_GND] += d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND];
      staticContributions[admsNodeID_ei] -= (probeVars[admsProbeID_V_n2_GND]);
      d_staticContributions[admsNodeID_ei][admsProbeID_V_n2_GND] -= d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND];
    }
    else
    {
      // I(ci,ei) <+ (white_noise((twoq*abs(it)),"it"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[15]= (twoq*fabs(it));
      }
      // I(bi,ei) <+ (white_noise((twoq*abs(ibei)),"ibei"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[16]= (twoq*fabs(ibei));
      }
      // I(n1,GND) <+ (V(n1,GND))
      staticContributions[admsNodeID_n1] += (probeVars[admsProbeID_V_n1_GND]);
      d_staticContributions[admsNodeID_n1][admsProbeID_V_n1_GND] += d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND];
      // I(n2,GND) <+ (V(n2,GND))
      staticContributions[admsNodeID_n2] += (probeVars[admsProbeID_V_n2_GND]);
      d_staticContributions[admsNodeID_n2][admsProbeID_V_n2_GND] += d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND];
    }
  }
  // End block noise


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_n2_GND] =  "
                 <<probeVars[admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_n1_GND] =  "
                 <<probeVars[admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_si_s] =  "
                 <<probeVars[admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bp_e] =  "
                 <<probeVars[admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_e] =  "
                 <<probeVars[admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ci_ei] =  "
                 <<probeVars[admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_xf_GND] =  "
                 <<probeVars[admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_xf2_GND] =  "
                 <<probeVars[admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_xf1_GND] =  "
                 <<probeVars[admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_bp] =  "
                 <<probeVars[admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ci_c] =  "
                 <<probeVars[admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ei_e] =  "
                 <<probeVars[admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bp_bi] =  "
                 <<probeVars[admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_tnode_GND] =  "
                 <<probeVars[admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_c] =  "
                 <<probeVars[admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_si_ci] =  "
                 <<probeVars[admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_ci] =  "
                 <<probeVars[admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bp_ci] =  "
                 <<probeVars[admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bp_ei] =  "
                 <<probeVars[admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_ci] =  "
                 <<probeVars[admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_ei] =  "
                 <<probeVars[admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c] =  "
                 <<staticContributions[admsNodeID_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c] =  "
                 <<dynamicContributions[admsNodeID_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b] =  "
                 <<staticContributions[admsNodeID_b] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b] =  "
                 <<dynamicContributions[admsNodeID_b] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e] =  "
                 <<staticContributions[admsNodeID_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e] =  "
                 <<dynamicContributions[admsNodeID_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_s] =  "
                 <<staticContributions[admsNodeID_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_s] =  "
                 <<dynamicContributions[admsNodeID_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_tnode] =  "
                 <<staticContributions[admsNodeID_tnode] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_tnode] =  "
                 <<dynamicContributions[admsNodeID_tnode] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ci] =  "
                 <<staticContributions[admsNodeID_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ci] =  "
                 <<dynamicContributions[admsNodeID_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ei] =  "
                 <<staticContributions[admsNodeID_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ei] =  "
                 <<dynamicContributions[admsNodeID_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bp] =  "
                 <<staticContributions[admsNodeID_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bp] =  "
                 <<dynamicContributions[admsNodeID_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bi] =  "
                 <<staticContributions[admsNodeID_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bi] =  "
                 <<dynamicContributions[admsNodeID_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_si] =  "
                 <<staticContributions[admsNodeID_si] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_si] =  "
                 <<dynamicContributions[admsNodeID_si] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xf1] =  "
                 <<staticContributions[admsNodeID_xf1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xf1] =  "
                 <<dynamicContributions[admsNodeID_xf1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xf2] =  "
                 <<staticContributions[admsNodeID_xf2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xf2] =  "
                 <<dynamicContributions[admsNodeID_xf2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xf] =  "
                 <<staticContributions[admsNodeID_xf] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xf] =  "
                 <<dynamicContributions[admsNodeID_xf] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_n1] =  "
                 <<staticContributions[admsNodeID_n1] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_n1] =  "
                 <<dynamicContributions[admsNodeID_n1] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_n2] =  "
                 <<staticContributions[admsNodeID_n2] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_n2] =  "
                 <<dynamicContributions[admsNodeID_n2] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bi_ei] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 5 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 15; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 5 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode];
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode];
      }
    }
  }
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
  return 17;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
  int numSources=getNumNoiseSources();
  noiseData.numSources = numSources;
  noiseData.resize(numSources);

  noiseData.deviceName = getName().getEncodedName();
  std::string theNoiseName;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_b_bp")+std::string("_")+std::string("rbx");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[0]=theNoiseName;
  noiseData.li_Pos[0]=li_b;
  noiseData.li_Neg[0]=li_bp;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_bp_bi")+std::string("_")+std::string("rbi");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[1]=theNoiseName;
  noiseData.li_Pos[1]=li_bp;
  noiseData.li_Neg[1]=li_bi;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_ci_c")+std::string("_")+std::string("rcx");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[2]=theNoiseName;
  noiseData.li_Pos[2]=li_ci;
  noiseData.li_Neg[2]=li_c;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_ei_e")+std::string("_")+std::string("re");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[3]=theNoiseName;
  noiseData.li_Pos[3]=li_ei;
  noiseData.li_Neg[3]=li_e;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_si_s")+std::string("_")+std::string("rsu");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[4]=theNoiseName;
  noiseData.li_Pos[4]=li_si;
  noiseData.li_Neg[4]=li_s;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_bi_ei")+std::string("_")+std::string("flicker");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[5]=theNoiseName;
  noiseData.li_Pos[5]=li_bi;
  noiseData.li_Neg[5]=li_ei;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_bp_ei")+std::string("_")+std::string("flicker");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[6]=theNoiseName;
  noiseData.li_Pos[6]=li_bp;
  noiseData.li_Neg[6]=li_ei;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_ei_e")+std::string("_")+std::string("flicker_re");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[7]=theNoiseName;
  noiseData.li_Pos[7]=li_ei;
  noiseData.li_Neg[7]=li_e;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_ci_bi")+std::string("_")+std::string("iavl");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[8]=theNoiseName;
  noiseData.li_Pos[8]=li_ci;
  noiseData.li_Neg[8]=li_bi;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_bi_ci")+std::string("_")+std::string("ibci");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[9]=theNoiseName;
  noiseData.li_Pos[9]=li_bi;
  noiseData.li_Neg[9]=li_ci;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_bp_ei")+std::string("_")+std::string("ibep");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[10]=theNoiseName;
  noiseData.li_Pos[10]=li_bp;
  noiseData.li_Neg[10]=li_ei;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_bp_ci")+std::string("_")+std::string("ijbcx");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[11]=theNoiseName;
  noiseData.li_Pos[11]=li_bp;
  noiseData.li_Neg[11]=li_ci;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_si_ci")+std::string("_")+std::string("ijsc");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[12]=theNoiseName;
  noiseData.li_Pos[12]=li_si;
  noiseData.li_Neg[12]=li_ci;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_n1_GND")+std::string("_")+std::string("ibei");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[13]=theNoiseName;
  noiseData.li_Pos[13]=li_n1;
  noiseData.li_Neg[13]=-1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_n2_GND")+std::string("_")+std::string("it");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[14]=theNoiseName;
  noiseData.li_Pos[14]=li_n2;
  noiseData.li_Neg[14]=-1;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_ci_ei")+std::string("_")+std::string("it");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[15]=theNoiseName;
  noiseData.li_Pos[15]=li_ci;
  noiseData.li_Neg[15]=li_ei;
  theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_bi_ei")+std::string("_")+std::string("ibei");
  std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
  noiseData.noiseNames[16]=theNoiseName;
  noiseData.li_Pos[16]=li_bi;
  noiseData.li_Neg[16]=li_ei;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
  noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
  noiseData.noiseDens[1] = noiseContribsPower[1];
  noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
  noiseData.noiseDens[2] = noiseContribsPower[2];
  noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
  noiseData.noiseDens[3] = noiseContribsPower[3];
  noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
  noiseData.noiseDens[4] = noiseContribsPower[4];
  noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
  noiseData.noiseDens[5] = noiseContribsPower[5];

  noiseData.noiseDens[5] /= pow(noiseData.freq,noiseContribsExponent[5]);noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
  noiseData.noiseDens[6] = noiseContribsPower[6];

  noiseData.noiseDens[6] /= pow(noiseData.freq,noiseContribsExponent[6]);noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
  noiseData.noiseDens[7] = noiseContribsPower[7];

  noiseData.noiseDens[7] /= pow(noiseData.freq,noiseContribsExponent[7]);noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
  noiseData.noiseDens[8] = noiseContribsPower[8];
  noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
  noiseData.noiseDens[9] = noiseContribsPower[9];
  noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
  noiseData.noiseDens[10] = noiseContribsPower[10];
  noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));
  noiseData.noiseDens[11] = noiseContribsPower[11];
  noiseData.lnNoiseDens[11] = std::log(std::max(noiseData.noiseDens[11],N_MINLOG));
  noiseData.noiseDens[12] = noiseContribsPower[12];
  noiseData.lnNoiseDens[12] = std::log(std::max(noiseData.noiseDens[12],N_MINLOG));
  noiseData.noiseDens[13] = noiseContribsPower[13];
  noiseData.lnNoiseDens[13] = std::log(std::max(noiseData.noiseDens[13],N_MINLOG));
  noiseData.noiseDens[14] = noiseContribsPower[14];
  noiseData.lnNoiseDens[14] = std::log(std::max(noiseData.noiseDens[14],N_MINLOG));
  noiseData.noiseDens[15] = noiseContribsPower[15];
  noiseData.lnNoiseDens[15] = std::log(std::max(noiseData.noiseDens[15],N_MINLOG));
  noiseData.noiseDens[16] = noiseContribsPower[16];
  noiseData.lnNoiseDens[16] = std::log(std::max(noiseData.noiseDens[16],N_MINLOG));

}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_bi_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei];
  (*f_bi_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei];
  (*f_ei_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  (*f_ei_Equ_ei_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_ei_e] -d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_ei] -d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  (*f_bi_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci];
  (*f_ci_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  (*f_ci_Equ_ci_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_c] -d_staticContributions[admsNodeID_ci][admsProbeID_V_si_ci] -d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] +d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_ei] -d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  (*f_ci_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_ei];
  (*f_ei_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_ei];
  (*f_b_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_tnode_GND];
  (*f_ci_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND];
  (*f_b_Equ_bp_Node_Ptr) +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_bp];
  (*f_ci_Equ_bp_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] +d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei];
  (*f_b_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_b_bp];
  (*f_bp_Equ_bp_Node_Ptr) +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_bi] -d_staticContributions[admsNodeID_bp][admsProbeID_V_b_bp];
  (*f_bp_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] -d_staticContributions[admsNodeID_bp][admsProbeID_V_si_ci] -d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci];
  (*f_bp_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND];
  (*f_bp_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_b_bp];
  (*f_bp_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci];
  (*f_bp_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei];
  (*f_bi_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND];
  (*f_bi_Equ_bp_Node_Ptr) +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_bi];
  (*f_ei_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND];
  (*f_ei_Equ_bp_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei];
  (*f_bp_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_si_ci];
  (*f_si_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] +d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci];
  (*f_si_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ci] -d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci] -d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci];
  (*f_si_Equ_bp_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci];
  (*f_si_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_tnode_GND];
  (*f_e_Equ_e_Node_Ptr) +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_ei_e];
  (*f_e_Equ_bp_Node_Ptr) +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_bp_ei];
  (*f_si_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ei];
  (*f_si_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ei];
  (*f_ci_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_si_ci];
  (*f_c_Equ_ci_Node_Ptr) +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_ci_c];
  (*f_s_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_tnode_GND];
  (*f_c_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_tnode_GND];
  (*f_s_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_si_s];
  (*f_s_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_si_s];
  (*f_c_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_c][admsProbeID_V_ci_c];
  (*f_ci_Equ_xf2_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_xf2_GND];
  (*f_ei_Equ_xf2_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_xf2_GND];
  (*f_ci_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_c];
  (*f_e_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_tnode_GND];
  (*f_ei_Equ_e_Node_Ptr) +=  -d_staticContributions[admsNodeID_ei][admsProbeID_V_ei_e];
  (*f_e_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ei] -d_staticContributions[admsNodeID_e][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_e][admsProbeID_V_ei_e];
  (*f_si_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_si_s];
  (*f_tnode_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND];
  (*f_tnode_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ci];
  (*f_tnode_Equ_ci_Node_Ptr) +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_c] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ci] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_ci] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ci];
  (*f_tnode_Equ_ei_Node_Ptr) +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_ei_e] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ei];
  (*f_tnode_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_ci];
  (*f_tnode_Equ_bp_Node_Ptr) +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_bp] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ci];
  (*f_tnode_Equ_e_Node_Ptr) +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_ei_e];
  (*f_tnode_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_c];
  (*f_tnode_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_bp];
  (*f_xf1_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ci];
  (*f_xf1_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ci];
  (*f_xf1_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ei];
  (*f_xf1_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_tnode_GND];
  (*f_xf1_Equ_xf2_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf2_GND];
  (*f_xf1_Equ_xf1_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND];
  (*f_xf2_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ci];
  (*f_xf2_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ci];
  (*f_xf2_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_tnode_GND];
  (*f_xf2_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ei];
  (*f_xf2_Equ_xf1_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf1_GND];
  (*f_xf2_Equ_xf2_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND];
  (*f_xf_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ei];
  (*f_xf_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ei];
  (*f_xf_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ci];
  (*f_xf_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf][admsProbeID_V_tnode_GND];
  (*f_xf_Equ_xf_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf][admsProbeID_V_xf_GND];
  (*f_e_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ci];
  (*f_e_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ci];
  (*f_n1_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_n1][admsProbeID_V_bi_ei];
  (*f_n1_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_n1][admsProbeID_V_bi_ei];
  (*f_n1_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_n1][admsProbeID_V_tnode_GND];
  (*f_n1_Equ_n1_Node_Ptr) +=  +d_staticContributions[admsNodeID_n1][admsProbeID_V_n1_GND];
  (*f_bi_Equ_n1_Node_Ptr) +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_n1_GND];
  (*f_ei_Equ_n1_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_n1_GND];
  (*f_ei_Equ_n2_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_n2_GND];
  (*f_n2_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ci];
  (*f_n2_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ci];
  (*f_n2_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ei];
  (*f_n2_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_n2][admsProbeID_V_tnode_GND];
  (*f_n2_Equ_n2_Node_Ptr) +=  +d_staticContributions[admsNodeID_n2][admsProbeID_V_n2_GND];
  (*f_ci_Equ_n2_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_n2_GND];

#else
  //use the offsets instead of pointers
  dFdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei];
  dFdx[li_bi][A_bi_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei];
  dFdx[li_ei][A_ei_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  dFdx[li_ei][A_ei_Equ_ei_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_ei_e] -d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_ei] -d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  dFdx[li_bi][A_bi_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci];
  dFdx[li_ci][A_ci_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  dFdx[li_ci][A_ci_Equ_ci_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_c] -d_staticContributions[admsNodeID_ci][admsProbeID_V_si_ci] -d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] +d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_ei] -d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  dFdx[li_ci][A_ci_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_ei];
  dFdx[li_ei][A_ei_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_ei];
  dFdx[li_b][A_b_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_tnode_GND];
  dFdx[li_ci][A_ci_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND];
  dFdx[li_b][A_b_Equ_bp_NodeOffset] +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_bp];
  dFdx[li_ci][A_ci_Equ_bp_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] +d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei];
  dFdx[li_b][A_b_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_b_bp];
  dFdx[li_bp][A_bp_Equ_bp_NodeOffset] +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_bi] -d_staticContributions[admsNodeID_bp][admsProbeID_V_b_bp];
  dFdx[li_bp][A_bp_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] -d_staticContributions[admsNodeID_bp][admsProbeID_V_si_ci] -d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci];
  dFdx[li_bp][A_bp_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND];
  dFdx[li_bp][A_bp_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_b_bp];
  dFdx[li_bp][A_bp_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci];
  dFdx[li_bp][A_bp_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei];
  dFdx[li_bi][A_bi_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND];
  dFdx[li_bi][A_bi_Equ_bp_NodeOffset] +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_bi];
  dFdx[li_ei][A_ei_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND];
  dFdx[li_ei][A_ei_Equ_bp_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei];
  dFdx[li_bp][A_bp_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_si_ci];
  dFdx[li_si][A_si_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] +d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci];
  dFdx[li_si][A_si_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ci] -d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci] -d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci];
  dFdx[li_si][A_si_Equ_bp_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci];
  dFdx[li_si][A_si_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_tnode_GND];
  dFdx[li_e][A_e_Equ_e_NodeOffset] +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_ei_e];
  dFdx[li_e][A_e_Equ_bp_NodeOffset] +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_bp_ei];
  dFdx[li_si][A_si_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ei];
  dFdx[li_si][A_si_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ei];
  dFdx[li_ci][A_ci_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_si_ci];
  dFdx[li_c][A_c_Equ_ci_NodeOffset] +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_ci_c];
  dFdx[li_s][A_s_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_tnode_GND];
  dFdx[li_c][A_c_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_tnode_GND];
  dFdx[li_s][A_s_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_si_s];
  dFdx[li_s][A_s_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_si_s];
  dFdx[li_c][A_c_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_c][admsProbeID_V_ci_c];
  dFdx[li_ci][A_ci_Equ_xf2_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_xf2_GND];
  dFdx[li_ei][A_ei_Equ_xf2_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_xf2_GND];
  dFdx[li_ci][A_ci_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_c];
  dFdx[li_e][A_e_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_tnode_GND];
  dFdx[li_ei][A_ei_Equ_e_NodeOffset] +=  -d_staticContributions[admsNodeID_ei][admsProbeID_V_ei_e];
  dFdx[li_e][A_e_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ei] -d_staticContributions[admsNodeID_e][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_e][admsProbeID_V_ei_e];
  dFdx[li_si][A_si_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_si_s];
  dFdx[li_tnode][A_tnode_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND];
  dFdx[li_tnode][A_tnode_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ci];
  dFdx[li_tnode][A_tnode_Equ_ci_NodeOffset] +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_c] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ci] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_ci] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ci];
  dFdx[li_tnode][A_tnode_Equ_ei_NodeOffset] +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_ei_e] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ei];
  dFdx[li_tnode][A_tnode_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_ci];
  dFdx[li_tnode][A_tnode_Equ_bp_NodeOffset] +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_bp] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ci];
  dFdx[li_tnode][A_tnode_Equ_e_NodeOffset] +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_ei_e];
  dFdx[li_tnode][A_tnode_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_c];
  dFdx[li_tnode][A_tnode_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_bp];
  dFdx[li_xf1][A_xf1_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ci];
  dFdx[li_xf1][A_xf1_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ci];
  dFdx[li_xf1][A_xf1_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ei];
  dFdx[li_xf1][A_xf1_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_tnode_GND];
  dFdx[li_xf1][A_xf1_Equ_xf2_NodeOffset] +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf2_GND];
  dFdx[li_xf1][A_xf1_Equ_xf1_NodeOffset] +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND];
  dFdx[li_xf2][A_xf2_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ci];
  dFdx[li_xf2][A_xf2_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ci];
  dFdx[li_xf2][A_xf2_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_tnode_GND];
  dFdx[li_xf2][A_xf2_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ei];
  dFdx[li_xf2][A_xf2_Equ_xf1_NodeOffset] +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf1_GND];
  dFdx[li_xf2][A_xf2_Equ_xf2_NodeOffset] +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND];
  dFdx[li_xf][A_xf_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ei];
  dFdx[li_xf][A_xf_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ei];
  dFdx[li_xf][A_xf_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ci];
  dFdx[li_xf][A_xf_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_xf][admsProbeID_V_tnode_GND];
  dFdx[li_xf][A_xf_Equ_xf_NodeOffset] +=  +d_staticContributions[admsNodeID_xf][admsProbeID_V_xf_GND];
  dFdx[li_e][A_e_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ci];
  dFdx[li_e][A_e_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ci];
  dFdx[li_n1][A_n1_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_n1][admsProbeID_V_bi_ei];
  dFdx[li_n1][A_n1_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_n1][admsProbeID_V_bi_ei];
  dFdx[li_n1][A_n1_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_n1][admsProbeID_V_tnode_GND];
  dFdx[li_n1][A_n1_Equ_n1_NodeOffset] +=  +d_staticContributions[admsNodeID_n1][admsProbeID_V_n1_GND];
  dFdx[li_bi][A_bi_Equ_n1_NodeOffset] +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_n1_GND];
  dFdx[li_ei][A_ei_Equ_n1_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_n1_GND];
  dFdx[li_ei][A_ei_Equ_n2_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_n2_GND];
  dFdx[li_n2][A_n2_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ci];
  dFdx[li_n2][A_n2_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ci];
  dFdx[li_n2][A_n2_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ei];
  dFdx[li_n2][A_n2_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_n2][admsProbeID_V_tnode_GND];
  dFdx[li_n2][A_n2_Equ_n2_NodeOffset] +=  +d_staticContributions[admsNodeID_n2][admsProbeID_V_n2_GND];
  dFdx[li_ci][A_ci_Equ_n2_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_n2_GND];

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_bi_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_bi];
  (*q_bi_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei];
  (*q_ei_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  (*q_ei_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  (*q_bi_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci];
  (*q_ci_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  (*q_ci_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  (*q_ci_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei];
  (*q_ei_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci];
  (*q_b_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ci];
  (*q_b_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ci];
  (*q_b_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_tnode_GND];
  (*q_ci_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND];
  (*q_b_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ci];
  (*q_ci_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci];
  (*q_b_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci];
  (*q_ci_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci];
  (*q_b_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ei];
  (*q_bp_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_e] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_bi] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci];
  (*q_bp_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci];
  (*q_bp_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_tnode_GND];
  (*q_bp_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_bi];
  (*q_bp_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei];
  (*q_bi_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND];
  (*q_bi_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_bi];
  (*q_ei_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND];
  (*q_ei_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ei];
  (*q_bi_Equ_xf_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_xf_GND];
  (*q_ei_Equ_xf_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_xf_GND];
  (*q_si_Equ_si_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_ci];
  (*q_si_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ci];
  (*q_si_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ci];
  (*q_si_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_tnode_GND];
  (*q_b_Equ_e_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e];
  (*q_e_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e];
  (*q_e_Equ_e_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_e] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e];
  (*q_bp_Equ_e_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_e];
  (*q_e_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_e];
  (*q_si_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ci];
  (*q_si_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ei];
  (*q_ci_Equ_si_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_ci];
  (*q_si_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_ci];
  (*q_s_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ci];
  (*q_s_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ci];
  (*q_c_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ci];
  (*q_c_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ci];
  (*q_s_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_tnode_GND];
  (*q_c_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_tnode_GND];
  (*q_s_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ci];
  (*q_c_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ci];
  (*q_s_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_ci];
  (*q_c_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_ci];
  (*q_s_Equ_si_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_ci];
  (*q_c_Equ_si_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_ci];
  (*q_s_Equ_s_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c];
  (*q_s_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c];
  (*q_c_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_s_c];
  (*q_c_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_s_c];
  (*q_s_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ei];
  (*q_c_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ei];
  (*q_si_Equ_s_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s];
  (*q_tnode_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND];
  (*q_xf1_Equ_xf1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND];
  (*q_xf2_Equ_xf2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND];
  (*q_xf_Equ_xf_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_xf][admsProbeID_V_xf_GND];
  (*q_bi_Equ_n1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n1_GND];
  (*q_ei_Equ_n1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n1_GND];
  (*q_bi_Equ_n2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n2_GND];
  (*q_ei_Equ_n2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n2_GND];

#else
  //use the offsets instead of pointers
  dQdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_bi];
  dQdx[li_bi][A_bi_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei];
  dQdx[li_ei][A_ei_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  dQdx[li_ei][A_ei_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  dQdx[li_bi][A_bi_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci];
  dQdx[li_ci][A_ci_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  dQdx[li_ci][A_ci_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  dQdx[li_ci][A_ci_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei];
  dQdx[li_ei][A_ei_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci];
  dQdx[li_b][A_b_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ci];
  dQdx[li_b][A_b_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ci];
  dQdx[li_b][A_b_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_tnode_GND];
  dQdx[li_ci][A_ci_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND];
  dQdx[li_b][A_b_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ci];
  dQdx[li_ci][A_ci_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci];
  dQdx[li_b][A_b_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci];
  dQdx[li_ci][A_ci_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci];
  dQdx[li_b][A_b_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ei];
  dQdx[li_bp][A_bp_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_e] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_bi] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci];
  dQdx[li_bp][A_bp_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci];
  dQdx[li_bp][A_bp_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_tnode_GND];
  dQdx[li_bp][A_bp_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_bi];
  dQdx[li_bp][A_bp_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei];
  dQdx[li_bi][A_bi_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND];
  dQdx[li_bi][A_bi_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_bi];
  dQdx[li_ei][A_ei_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND];
  dQdx[li_ei][A_ei_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ei];
  dQdx[li_bi][A_bi_Equ_xf_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_xf_GND];
  dQdx[li_ei][A_ei_Equ_xf_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_xf_GND];
  dQdx[li_si][A_si_Equ_si_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_ci];
  dQdx[li_si][A_si_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ci];
  dQdx[li_si][A_si_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ci];
  dQdx[li_si][A_si_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_tnode_GND];
  dQdx[li_b][A_b_Equ_e_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e];
  dQdx[li_e][A_e_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e];
  dQdx[li_e][A_e_Equ_e_NodeOffset] +=  -d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_e] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e];
  dQdx[li_bp][A_bp_Equ_e_NodeOffset] +=  -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_e];
  dQdx[li_e][A_e_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_e];
  dQdx[li_si][A_si_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ci];
  dQdx[li_si][A_si_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ei];
  dQdx[li_ci][A_ci_Equ_si_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_ci];
  dQdx[li_si][A_si_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_ci];
  dQdx[li_s][A_s_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ci];
  dQdx[li_s][A_s_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ci];
  dQdx[li_c][A_c_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ci];
  dQdx[li_c][A_c_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ci];
  dQdx[li_s][A_s_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_tnode_GND];
  dQdx[li_c][A_c_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_tnode_GND];
  dQdx[li_s][A_s_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ci];
  dQdx[li_c][A_c_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ci];
  dQdx[li_s][A_s_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_ci];
  dQdx[li_c][A_c_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_ci];
  dQdx[li_s][A_s_Equ_si_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_ci];
  dQdx[li_c][A_c_Equ_si_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_ci];
  dQdx[li_s][A_s_Equ_s_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c];
  dQdx[li_s][A_s_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c];
  dQdx[li_c][A_c_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_s_c];
  dQdx[li_c][A_c_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_s_c];
  dQdx[li_s][A_s_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ei];
  dQdx[li_c][A_c_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ei];
  dQdx[li_si][A_si_Equ_s_NodeOffset] +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s];
  dQdx[li_tnode][A_tnode_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND];
  dQdx[li_xf1][A_xf1_Equ_xf1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND];
  dQdx[li_xf2][A_xf2_Equ_xf2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND];
  dQdx[li_xf][A_xf_Equ_xf_NodeOffset] +=  +d_dynamicContributions[admsNodeID_xf][admsProbeID_V_xf_GND];
  dQdx[li_bi][A_bi_Equ_n1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n1_GND];
  dQdx[li_ei][A_ei_Equ_n1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n1_GND];
  dQdx[li_bi][A_bi_Equ_n2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n2_GND];
  dQdx[li_ei][A_ei_Equ_n2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n2_GND];


#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

  // set internal model type based on model card type
  if (getType() == "pnp" || getType() == "PNP")
    type = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter c10 : [ 0, 1 ]
  if ( (!((c10 >=0 && c10 <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter c10 value " << c10 << " out of range [ 0, 1 ]";
  }

  //    Parameter qp0 : ] 0, 1 ]
  if ( (!((qp0 >0 && qp0 <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter qp0 value " << qp0 << " out of range ] 0, 1 ]";
  }

  //    Parameter ich : [ 0,  (+inf) [
  if ( (!((ich >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ich value " << ich << " out of range [ 0,  (+inf) [";
  }

  //    Parameter hf0 : [ 0,  (+inf) [
  if ( (!((hf0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter hf0 value " << hf0 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter hfe : [ 0,  (+inf) [
  if ( (!((hfe >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter hfe value " << hfe << " out of range [ 0,  (+inf) [";
  }

  //    Parameter hfc : [ 0,  (+inf) [
  if ( (!((hfc >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter hfc value " << hfc << " out of range [ 0,  (+inf) [";
  }

  //    Parameter hjei : [ 0, 100 ]
  if ( (!((hjei >=0 && hjei <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter hjei value " << hjei << " out of range [ 0, 100 ]";
  }

  //    Parameter ahjei : [ 0, 100 ]
  if ( (!((ahjei >=0 && ahjei <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ahjei value " << ahjei << " out of range [ 0, 100 ]";
  }

  //    Parameter rhjei : ] 0, 10 ]
  if ( (!((rhjei >0 && rhjei <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rhjei value " << rhjei << " out of range ] 0, 10 ]";
  }

  //    Parameter hjci : [ 0, 100 ]
  if ( (!((hjci >=0 && hjci <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter hjci value " << hjci << " out of range [ 0, 100 ]";
  }

  //    Parameter ibeis : [ 0, 1 ]
  if ( (!((ibeis >=0 && ibeis <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ibeis value " << ibeis << " out of range [ 0, 1 ]";
  }

  //    Parameter mbei : ] 0, 10 ]
  if ( (!((mbei >0 && mbei <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mbei value " << mbei << " out of range ] 0, 10 ]";
  }

  //    Parameter ireis : [ 0, 1 ]
  if ( (!((ireis >=0 && ireis <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ireis value " << ireis << " out of range [ 0, 1 ]";
  }

  //    Parameter mrei : ] 0, 10 ]
  if ( (!((mrei >0 && mrei <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mrei value " << mrei << " out of range ] 0, 10 ]";
  }

  //    Parameter ibeps : [ 0, 1 ]
  if ( (!((ibeps >=0 && ibeps <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ibeps value " << ibeps << " out of range [ 0, 1 ]";
  }

  //    Parameter mbep : ] 0, 10 ]
  if ( (!((mbep >0 && mbep <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mbep value " << mbep << " out of range ] 0, 10 ]";
  }

  //    Parameter ireps : [ 0, 1 ]
  if ( (!((ireps >=0 && ireps <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ireps value " << ireps << " out of range [ 0, 1 ]";
  }

  //    Parameter mrep : ] 0, 10 ]
  if ( (!((mrep >0 && mrep <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mrep value " << mrep << " out of range ] 0, 10 ]";
  }

  //    Parameter mcf : ] 0, 10 ]
  if ( (!((mcf >0 && mcf <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mcf value " << mcf << " out of range ] 0, 10 ]";
  }

  //    Parameter tbhrec : [ 0,  (+inf) [
  if ( (!((tbhrec >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter tbhrec value " << tbhrec << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ibcis : [ 0, 1.0 ]
  if ( (!((ibcis >=0 && ibcis <=1.0 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ibcis value " << ibcis << " out of range [ 0, 1.0 ]";
  }

  //    Parameter mbci : ] 0, 10 ]
  if ( (!((mbci >0 && mbci <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mbci value " << mbci << " out of range ] 0, 10 ]";
  }

  //    Parameter ibcxs : [ 0, 1.0 ]
  if ( (!((ibcxs >=0 && ibcxs <=1.0 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ibcxs value " << ibcxs << " out of range [ 0, 1.0 ]";
  }

  //    Parameter mbcx : ] 0, 10 ]
  if ( (!((mbcx >0 && mbcx <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mbcx value " << mbcx << " out of range ] 0, 10 ]";
  }

  //    Parameter ibets : [ 0, 50 ]
  if ( (!((ibets >=0 && ibets <=50 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ibets value " << ibets << " out of range [ 0, 50 ]";
  }

  //    Parameter abet : [ 0,  (+inf) [
  if ( (!((abet >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter abet value " << abet << " out of range [ 0,  (+inf) [";
  }

  //    Parameter tunode : [ 0, 1 ]
  if ( (!((tunode >=0 && tunode <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter tunode value " << tunode << " out of range [ 0, 1 ]";
  }

  //    Parameter favl : [ 0,  (+inf) [
  if ( (!((favl >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter favl value " << favl << " out of range [ 0,  (+inf) [";
  }

  //    Parameter qavl : [ 0,  (+inf) [
  if ( (!((qavl >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter qavl value " << qavl << " out of range [ 0,  (+inf) [";
  }

  //    Parameter kavl : [ 0, 3 ]
  if ( (!((kavl >=0 && kavl <=3 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter kavl value " << kavl << " out of range [ 0, 3 ]";
  }

  //    Parameter rbi0 : [ 0,  (+inf) [
  if ( (!((rbi0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rbi0 value " << rbi0 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter rbx : [ 0,  (+inf) [
  if ( (!((rbx >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rbx value " << rbx << " out of range [ 0,  (+inf) [";
  }

  //    Parameter fgeo : [ 0,  (+inf) [
  if ( (!((fgeo >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fgeo value " << fgeo << " out of range [ 0,  (+inf) [";
  }

  //    Parameter fdqr0 : [ (-0.5), 100 ]
  if ( (!((fdqr0 >=(-0.5) && fdqr0 <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fdqr0 value " << fdqr0 << " out of range [ (-0.5), 100 ]";
  }

  //    Parameter fcrbi : [ 0, 1 ]
  if ( (!((fcrbi >=0 && fcrbi <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fcrbi value " << fcrbi << " out of range [ 0, 1 ]";
  }

  //    Parameter fqi : [ 0, 1 ]
  if ( (!((fqi >=0 && fqi <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fqi value " << fqi << " out of range [ 0, 1 ]";
  }

  //    Parameter re : [ 0,  (+inf) [
  if ( (!((re >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter re value " << re << " out of range [ 0,  (+inf) [";
  }

  //    Parameter rcx : [ 0,  (+inf) [
  if ( (!((rcx >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rcx value " << rcx << " out of range [ 0,  (+inf) [";
  }

  //    Parameter itss : [ 0, 1.0 ]
  if ( (!((itss >=0 && itss <=1.0 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter itss value " << itss << " out of range [ 0, 1.0 ]";
  }

  //    Parameter msf : ] 0, 10 ]
  if ( (!((msf >0 && msf <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter msf value " << msf << " out of range ] 0, 10 ]";
  }

  //    Parameter iscs : [ 0, 1.0 ]
  if ( (!((iscs >=0 && iscs <=1.0 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter iscs value " << iscs << " out of range [ 0, 1.0 ]";
  }

  //    Parameter msc : ] 0, 10 ]
  if ( (!((msc >0 && msc <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter msc value " << msc << " out of range ] 0, 10 ]";
  }

  //    Parameter tsf : [ 0,  (+inf) [
  if ( (!((tsf >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter tsf value " << tsf << " out of range [ 0,  (+inf) [";
  }

  //    Parameter rsu : [ 0,  (+inf) [
  if ( (!((rsu >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rsu value " << rsu << " out of range [ 0,  (+inf) [";
  }

  //    Parameter csu : [ 0,  (+inf) [
  if ( (!((csu >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter csu value " << csu << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cjei0 : [ 0,  (+inf) [
  if ( (!((cjei0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cjei0 value " << cjei0 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vdei : ] 0, 10 ]
  if ( (!((vdei >0 && vdei <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vdei value " << vdei << " out of range ] 0, 10 ]";
  }

  //    Parameter zei : ] 0, 1 [
  if ( (!((zei >0 && zei <1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zei value " << zei << " out of range ] 0, 1 [";
  }

  //    Parameter ajei : [ 1,  (+inf) [
  if ( (!((ajei >=1))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ajei value " << ajei << " out of range [ 1,  (+inf) [";
  }

  //    Parameter cjep0 : [ 0,  (+inf) [
  if ( (!((cjep0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cjep0 value " << cjep0 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vdep : ] 0, 10 ]
  if ( (!((vdep >0 && vdep <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vdep value " << vdep << " out of range ] 0, 10 ]";
  }

  //    Parameter zep : ] 0, 1 [
  if ( (!((zep >0 && zep <1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zep value " << zep << " out of range ] 0, 1 [";
  }

  //    Parameter ajep : [ 1,  (+inf) [
  if ( (!((ajep >=1))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ajep value " << ajep << " out of range [ 1,  (+inf) [";
  }

  //    Parameter cjci0 : [ 0,  (+inf) [
  if ( (!((cjci0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cjci0 value " << cjci0 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vdci : ] 0, 10 ]
  if ( (!((vdci >0 && vdci <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vdci value " << vdci << " out of range ] 0, 10 ]";
  }

  //    Parameter zci : ] 0, 1 [
  if ( (!((zci >0 && zci <1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zci value " << zci << " out of range ] 0, 1 [";
  }

  //    Parameter vptci : ] 0, 100 ]
  if ( (!((vptci >0 && vptci <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vptci value " << vptci << " out of range ] 0, 100 ]";
  }

  //    Parameter cjcx0 : [ 0,  (+inf) [
  if ( (!((cjcx0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cjcx0 value " << cjcx0 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vdcx : ] 0, 10 ]
  if ( (!((vdcx >0 && vdcx <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vdcx value " << vdcx << " out of range ] 0, 10 ]";
  }

  //    Parameter zcx : ] 0, 1 [
  if ( (!((zcx >0 && zcx <1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zcx value " << zcx << " out of range ] 0, 1 [";
  }

  //    Parameter vptcx : ] 0, 100 ]
  if ( (!((vptcx >0 && vptcx <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vptcx value " << vptcx << " out of range ] 0, 100 ]";
  }

  //    Parameter fbcpar : [ 0, 1 ]
  if ( (!((fbcpar >=0 && fbcpar <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fbcpar value " << fbcpar << " out of range [ 0, 1 ]";
  }

  //    Parameter fbepar : [ 0, 1 ]
  if ( (!((fbepar >=0 && fbepar <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fbepar value " << fbepar << " out of range [ 0, 1 ]";
  }

  //    Parameter cjs0 : [ 0,  (+inf) [
  if ( (!((cjs0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cjs0 value " << cjs0 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vds : ] 0, 10 ]
  if ( (!((vds >0 && vds <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vds value " << vds << " out of range ] 0, 10 ]";
  }

  //    Parameter zs : ] 0, 1 [
  if ( (!((zs >0 && zs <1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zs value " << zs << " out of range ] 0, 1 [";
  }

  //    Parameter vpts : ] 0, 100 ]
  if ( (!((vpts >0 && vpts <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vpts value " << vpts << " out of range ] 0, 100 ]";
  }

  //    Parameter cscp0 : [ 0,  (+inf) [
  if ( (!((cscp0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cscp0 value " << cscp0 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vdsp : [ 0, 10 ]
  if ( (!((vdsp >=0 && vdsp <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vdsp value " << vdsp << " out of range [ 0, 10 ]";
  }

  //    Parameter zsp : ] 0, 1 [
  if ( (!((zsp >0 && zsp <1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zsp value " << zsp << " out of range ] 0, 1 [";
  }

  //    Parameter vptsp : ] 0, 100 ]
  if ( (!((vptsp >0 && vptsp <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vptsp value " << vptsp << " out of range ] 0, 100 ]";
  }

  //    Parameter t0 : [ 0,  (+inf) [
  if ( (!((t0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter t0 value " << t0 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter dt0h :  ] (-inf)  (+inf) [

  //    Parameter tbvl :  ] (-inf)  (+inf) [

  //    Parameter tef0 : [ 0,  (+inf) [
  if ( (!((tef0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter tef0 value " << tef0 << " out of range [ 0,  (+inf) [";
  }

  //    Parameter gtfe : ] 0, 10 ]
  if ( (!((gtfe >0 && gtfe <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter gtfe value " << gtfe << " out of range ] 0, 10 ]";
  }

  //    Parameter thcs : [ 0,  (+inf) [
  if ( (!((thcs >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter thcs value " << thcs << " out of range [ 0,  (+inf) [";
  }

  //    Parameter ahc : ] 0, 50 ]
  if ( (!((ahc >0 && ahc <=50 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ahc value " << ahc << " out of range ] 0, 50 ]";
  }

  //    Parameter fthc : [ 0, 1 ]
  if ( (!((fthc >=0 && fthc <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fthc value " << fthc << " out of range [ 0, 1 ]";
  }

  //    Parameter rci0 : ] 0,  (+inf) [
  if ( (!((rci0 >0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rci0 value " << rci0 << " out of range ] 0,  (+inf) [";
  }

  //    Parameter vlim : ] 0, 10 ]
  if ( (!((vlim >0 && vlim <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vlim value " << vlim << " out of range ] 0, 10 ]";
  }

  //    Parameter vces : [ 0, 1 ]
  if ( (!((vces >=0 && vces <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vces value " << vces << " out of range [ 0, 1 ]";
  }

  //    Parameter vpt : ] 0,  (+inf) [
  if ( (!((vpt >0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vpt value " << vpt << " out of range ] 0,  (+inf) [";
  }

  //    Parameter aick : ] 0, 10 ]
  if ( (!((aick >0 && aick <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter aick value " << aick << " out of range ] 0, 10 ]";
  }

  //    Parameter delck : ] 0, 10 ]
  if ( (!((delck >0 && delck <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter delck value " << delck << " out of range ] 0, 10 ]";
  }

  //    Parameter tr : [ 0,  (+inf) [
  if ( (!((tr >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter tr value " << tr << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vcbar : [ 0, 1 ]
  if ( (!((vcbar >=0 && vcbar <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vcbar value " << vcbar << " out of range [ 0, 1 ]";
  }

  //    Parameter icbar : [ 0, 1 ]
  if ( (!((icbar >=0 && icbar <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter icbar value " << icbar << " out of range [ 0, 1 ]";
  }

  //    Parameter acbar : ] 0, 10 ]
  if ( (!((acbar >0 && acbar <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter acbar value " << acbar << " out of range ] 0, 10 ]";
  }

  //    Parameter cbepar : [ 0,  (+inf) [
  if ( (!((cbepar >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cbepar value " << cbepar << " out of range [ 0,  (+inf) [";
  }

  //    Parameter cbcpar : [ 0,  (+inf) [
  if ( (!((cbcpar >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cbcpar value " << cbcpar << " out of range [ 0,  (+inf) [";
  }

  //    Parameter alqf : [ 0, 1 ]
  if ( (!((alqf >=0 && alqf <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter alqf value " << alqf << " out of range [ 0, 1 ]";
  }

  //    Parameter alit : [ 0, 1 ]
  if ( (!((alit >=0 && alit <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter alit value " << alit << " out of range [ 0, 1 ]";
  }

  //    Parameter flnqs : [ 0, 1 ]
  if ( (!((flnqs >=0 && flnqs <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter flnqs value " << flnqs << " out of range [ 0, 1 ]";
  }

  //    Parameter kf : [ 0,  (+inf) [
  if ( (!((kf >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter kf value " << kf << " out of range [ 0,  (+inf) [";
  }

  //    Parameter af : ] 0, 10 ]
  if ( (!((af >0 && af <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter af value " << af << " out of range ] 0, 10 ]";
  }

  //    Parameter cfbe : [ (-2), (-1) ]
  if ( (!((cfbe >=(-2) && cfbe <=(-1) ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cfbe value " << cfbe << " out of range [ (-2), (-1) ]";
  }

  //    Parameter flcono : [ 0, 1 ]
  if ( (!((flcono >=0 && flcono <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter flcono value " << flcono << " out of range [ 0, 1 ]";
  }

  //    Parameter kfre : [ 0,  (+inf) [
  if ( (!((kfre >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter kfre value " << kfre << " out of range [ 0,  (+inf) [";
  }

  //    Parameter afre : ] 0, 10 ]
  if ( (!((afre >0 && afre <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter afre value " << afre << " out of range ] 0, 10 ]";
  }

  //    Parameter latb : [ 0,  (+inf) [
  if ( (!((latb >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter latb value " << latb << " out of range [ 0,  (+inf) [";
  }

  //    Parameter latl : [ 0,  (+inf) [
  if ( (!((latl >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter latl value " << latl << " out of range [ 0,  (+inf) [";
  }

  //    Parameter vgb : ] 0, 10 ]
  if ( (!((vgb >0 && vgb <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vgb value " << vgb << " out of range ] 0, 10 ]";
  }

  //    Parameter zetaci : [ (-10), 10 ]
  if ( (!((zetaci >=(-10) && zetaci <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetaci value " << zetaci << " out of range [ (-10), 10 ]";
  }

  //    Parameter zetarbi : [ (-10), 10 ]
  if ( (!((zetarbi >=(-10) && zetarbi <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetarbi value " << zetarbi << " out of range [ (-10), 10 ]";
  }

  //    Parameter zetarbx : [ (-10), 10 ]
  if ( (!((zetarbx >=(-10) && zetarbx <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetarbx value " << zetarbx << " out of range [ (-10), 10 ]";
  }

  //    Parameter zetarcx : [ (-10), 10 ]
  if ( (!((zetarcx >=(-10) && zetarcx <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetarcx value " << zetarcx << " out of range [ (-10), 10 ]";
  }

  //    Parameter zetare : [ (-10), 10 ]
  if ( (!((zetare >=(-10) && zetare <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetare value " << zetare << " out of range [ (-10), 10 ]";
  }

  //    Parameter zetacx : [ (-10), 10 ]
  if ( (!((zetacx >=(-10) && zetacx <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetacx value " << zetacx << " out of range [ (-10), 10 ]";
  }

  //    Parameter vge : ] 0, 10 ]
  if ( (!((vge >0 && vge <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vge value " << vge << " out of range ] 0, 10 ]";
  }

  //    Parameter vgc : ] 0, 10 ]
  if ( (!((vgc >0 && vgc <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vgc value " << vgc << " out of range ] 0, 10 ]";
  }

  //    Parameter vgs : ] 0, 10 ]
  if ( (!((vgs >0 && vgs <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vgs value " << vgs << " out of range ] 0, 10 ]";
  }

  //    Parameter zetact : [ (-10), 10 ]
  if ( (!((zetact >=(-10) && zetact <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetact value " << zetact << " out of range [ (-10), 10 ]";
  }

  //    Parameter zetabet : [ (-10), 10 ]
  if ( (!((zetabet >=(-10) && zetabet <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetabet value " << zetabet << " out of range [ (-10), 10 ]";
  }

  //    Parameter dvgbe : [ (-10), 10 ]
  if ( (!((dvgbe >=(-10) && dvgbe <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter dvgbe value " << dvgbe << " out of range [ (-10), 10 ]";
  }

  //    Parameter zetahjei : [ (-10), 10 ]
  if ( (!((zetahjei >=(-10) && zetahjei <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetahjei value " << zetahjei << " out of range [ (-10), 10 ]";
  }

  //    Parameter zetavgbe : [ (-10), 10 ]
  if ( (!((zetavgbe >=(-10) && zetavgbe <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetavgbe value " << zetavgbe << " out of range [ (-10), 10 ]";
  }

  //    Parameter flsh : [ 0, 2 ]
  if ( (!((flsh >=0 && flsh <=2 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter flsh value " << flsh << " out of range [ 0, 2 ]";
  }

  //    Parameter rth : [ 0,  (+inf) [
  if ( (!((rth >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rth value " << rth << " out of range [ 0,  (+inf) [";
  }

  //    Parameter zetarth : [ (-10), 10 ]
  if ( (!((zetarth >=(-10) && zetarth <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetarth value " << zetarth << " out of range [ (-10), 10 ]";
  }

  //    Parameter alrth : [ (-10), 10 ]
  if ( (!((alrth >=(-10) && alrth <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter alrth value " << alrth << " out of range [ (-10), 10 ]";
  }

  //    Parameter cth : [ 0,  (+inf) [
  if ( (!((cth >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cth value " << cth << " out of range [ 0,  (+inf) [";
  }

  //    Parameter flcomp : [ 0,  (+inf) [
  if ( (!((flcomp >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter flcomp value " << flcomp << " out of range [ 0,  (+inf) [";
  }

  //    Parameter type : [ (-1), 1 ]] 0, 0 [
  if ( (!((type >=(-1) && type <=1 )) || (type >0 && type <0 )) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter type value " << type << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    c10(2.0E-30),
    qp0(2.0E-14),
    ich(0.0),
    hf0(1.0),
    hfe(1.0),
    hfc(1.0),
    hjei(1.0),
    ahjei(0.0),
    rhjei(1.0),
    hjci(1.0),
    ibeis(1.0E-18),
    mbei(1.0),
    ireis(0.0),
    mrei(2.0),
    ibeps(0.0),
    mbep(1.0),
    ireps(0.0),
    mrep(2.0),
    mcf(1.0),
    tbhrec(0.0),
    ibcis(1.0E-16),
    mbci(1.0),
    ibcxs(0.0),
    mbcx(1.0),
    ibets(0.0),
    abet(40),
    tunode(1),
    favl(0.0),
    qavl(0.0),
    kavl(0.0),
    alfav(0.0),
    alqav(0.0),
    alkav(0.0),
    rbi0(0.0),
    rbx(0.0),
    fgeo(0.6557),
    fdqr0(0.0),
    fcrbi(0.0),
    fqi(1.0),
    re(0.0),
    rcx(0.0),
    itss(0.0),
    msf(1.0),
    iscs(0.0),
    msc(1.0),
    tsf(0.0),
    rsu(0.0),
    csu(0.0),
    cjei0(1.0E-20),
    vdei(0.9),
    zei(0.5),
    ajei(2.5),
    cjep0(1.0E-20),
    vdep(0.9),
    zep(0.5),
    ajep(2.5),
    cjci0(1.0E-20),
    vdci(0.7),
    zci(0.4),
    vptci(100),
    cjcx0(1.0E-20),
    vdcx(0.7),
    zcx(0.4),
    vptcx(100),
    fbcpar(0.0),
    fbepar(1.0),
    cjs0(0.0),
    vds(0.6),
    zs(0.5),
    vpts(100),
    cscp0(0.0),
    vdsp(0.6),
    zsp(0.5),
    vptsp(100),
    t0(0.0),
    dt0h(0.0),
    tbvl(0.0),
    tef0(0.0),
    gtfe(1.0),
    thcs(0.0),
    ahc(0.1),
    fthc(0.0),
    rci0(150),
    vlim(0.5),
    vces(0.1),
    vpt(100.0),
    aick(1e-3),
    delck(2.0),
    tr(0.0),
    vcbar(0.0),
    icbar(0.0),
    acbar(0.01),
    cbepar(0.0),
    cbcpar(0.0),
    alqf(0.167),
    alit(0.333),
    flnqs(0),
    kf(0.0),
    af(2.0),
    cfbe((-1)),
    flcono(0),
    kfre(0.0),
    afre(2.0),
    latb(0.0),
    latl(0.0),
    vgb(1.17),
    alt0(0.0),
    kt0(0.0),
    zetaci(0.0),
    alvs(0.0),
    alces(0.0),
    zetarbi(0.0),
    zetarbx(0.0),
    zetarcx(0.0),
    zetare(0.0),
    zetacx(1.0),
    vge(1.17),
    vgc(1.17),
    vgs(1.17),
    f1vg((-1.02377e-4)),
    f2vg(4.3215e-4),
    zetact(3.0),
    zetabet(3.5),
    alb(0.0),
    dvgbe(0),
    zetahjei(1),
    zetavgbe(1),
    flsh(0),
    rth(0.0),
    zetarth(0.0),
    alrth(0.0),
    cth(0.0),
    flcomp(0.0),
    tnom(27.0),
    dt(0.0),
    type(1)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
  if (deviceMap.empty() ||
      ((deviceMap.find("Q") != deviceMap.end() && (levelSet.find(234)!=levelSet.end()))))
  {
    BJT::registerDevice();

    Config<Traits>::addConfiguration()
      .registerDevice("q", 234)
      .registerModelType("npn", 234)
      .registerModelType("pnp", 234);
  }
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_VT,
   AdmsSensFadType & instanceVar_Tdev,
   AdmsSensFadType & instanceVar_qtt0,
   AdmsSensFadType & instanceVar_ln_qtt0,
   AdmsSensFadType & instanceVar_r_VgVT,
   AdmsSensFadType & instanceVar_V_gT,
   AdmsSensFadType & instanceVar_dT,
   AdmsSensFadType & instanceVar_k,
   AdmsSensFadType & instanceVar_ireis_t,
   AdmsSensFadType & instanceVar_ibeis_t,
   AdmsSensFadType & instanceVar_ibcxs_t,
   AdmsSensFadType & instanceVar_ibcis_t,
   AdmsSensFadType & instanceVar_iscs_t,
   AdmsSensFadType & instanceVar_cjci0_t,
   AdmsSensFadType & instanceVar_cjs0_t,
   AdmsSensFadType & instanceVar_cscp0_t,
   AdmsSensFadType & instanceVar_rci0_t,
   AdmsSensFadType & instanceVar_vlim_t,
   AdmsSensFadType & instanceVar_vces_t,
   AdmsSensFadType & instanceVar_thcs_t,
   AdmsSensFadType & instanceVar_tef0_t,
   AdmsSensFadType & instanceVar_rbi0_t,
   AdmsSensFadType & instanceVar_t0_t,
   AdmsSensFadType & instanceVar_vdei_t,
   AdmsSensFadType & instanceVar_vdci_t,
   AdmsSensFadType & instanceVar_vpts_t,
   AdmsSensFadType & instanceVar_vptsp_t,
   AdmsSensFadType & instanceVar_itss_t,
   AdmsSensFadType & instanceVar_tsf_t,
   AdmsSensFadType & instanceVar_c10_t,
   AdmsSensFadType & instanceVar_cjei0_t,
   AdmsSensFadType & instanceVar_qp0_t,
   AdmsSensFadType & instanceVar_vdcx_t,
   AdmsSensFadType & instanceVar_vptcx_t,
   AdmsSensFadType & instanceVar_cjcx01_t,
   AdmsSensFadType & instanceVar_cjcx02_t,
   AdmsSensFadType & instanceVar_cratio_t,
   AdmsSensFadType & instanceVar_ibeps_t,
   AdmsSensFadType & instanceVar_ireps_t,
   AdmsSensFadType & instanceVar_cjep0_t,
   AdmsSensFadType & instanceVar_ajei_t,
   AdmsSensFadType & instanceVar_qavl_t,
   AdmsSensFadType & instanceVar_favl_t,
   AdmsSensFadType & instanceVar_kavl_t,
   AdmsSensFadType & instanceVar_ibets_t,
   AdmsSensFadType & instanceVar_abet_t,
   AdmsSensFadType & instanceVar_vptci_t,
   AdmsSensFadType & instanceVar_vdep_t,
   AdmsSensFadType & instanceVar_ajep_t,
   AdmsSensFadType & instanceVar_zetatef,
   AdmsSensFadType & instanceVar_k1,
   AdmsSensFadType & instanceVar_k2,
   AdmsSensFadType & instanceVar_dvg0,
   AdmsSensFadType & instanceVar_vge_t,
   AdmsSensFadType & instanceVar_vgb_t,
   AdmsSensFadType & instanceVar_vgbe_t,
   AdmsSensFadType & instanceVar_vds_t,
   AdmsSensFadType & instanceVar_vdsp_t,
   AdmsSensFadType & instanceVar_vt0,
   AdmsSensFadType & instanceVar_Tnom,
   AdmsSensFadType & instanceVar_Tamb,
   AdmsSensFadType & instanceVar_a,
   AdmsSensFadType & instanceVar_avs,
   AdmsSensFadType & instanceVar_zetabci,
   AdmsSensFadType & instanceVar_zetabcxt,
   AdmsSensFadType & instanceVar_zetasct,
   AdmsSensFadType & instanceVar_vgbe0,
   AdmsSensFadType & instanceVar_mg,
   AdmsSensFadType & instanceVar_vgbe_t0,
   AdmsSensFadType & instanceVar_vgbc0,
   AdmsSensFadType & instanceVar_vgsc0,
   AdmsSensFadType & instanceVar_cbcpar1,
   AdmsSensFadType & instanceVar_cbcpar2,
   AdmsSensFadType & instanceVar_cbepar2,
   AdmsSensFadType & instanceVar_cbepar1,
   AdmsSensFadType & instanceVar_Oich,
   AdmsSensFadType & instanceVar_Otbhrec,
   AdmsSensFadType & instanceVar_it,
   AdmsSensFadType & instanceVar_ibei,
   AdmsSensFadType & instanceVar_ibci,
   AdmsSensFadType & instanceVar_ibep,
   AdmsSensFadType & instanceVar_iavl,
   AdmsSensFadType & instanceVar_ijbcx,
   AdmsSensFadType & instanceVar_ijsc,
   AdmsSensFadType & instanceVar_rth_t,
   AdmsSensFadType & instanceVar_vdj0,
   AdmsSensFadType & instanceVar_vdjt,
   AdmsSensFadType & instanceVar_vdt,
   AdmsSensFadType & instanceVar_Tf,
   AdmsSensFadType & instanceVar_cjcx01,
   AdmsSensFadType & instanceVar_cjcx02,
   AdmsSensFadType & instanceVar_betadc,
   AdmsSensFadType & instanceVar_hjei0_t,
   AdmsSensFadType & instanceVar_ahjei_t,
   AdmsSensFadType & instanceVar_hf0_t,
   AdmsSensFadType & instanceVar_hfe_t,
   AdmsSensFadType & instanceVar_hfc_t,
   AdmsSensFadType & instanceVar_rbx_t,
   AdmsSensFadType & instanceVar_rcx_t,
   AdmsSensFadType & instanceVar_re_t,
   AdmsSensFadType & instanceVar_rbi,
   // non-reals
   int instanceVar_use_aval,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_c10,
   bool modelPar_given_c10,
   AdmsSensFadType & modelPar_qp0,
   bool modelPar_given_qp0,
   AdmsSensFadType & modelPar_ich,
   bool modelPar_given_ich,
   AdmsSensFadType & modelPar_hf0,
   bool modelPar_given_hf0,
   AdmsSensFadType & modelPar_hfe,
   bool modelPar_given_hfe,
   AdmsSensFadType & modelPar_hfc,
   bool modelPar_given_hfc,
   AdmsSensFadType & modelPar_hjei,
   bool modelPar_given_hjei,
   AdmsSensFadType & modelPar_ahjei,
   bool modelPar_given_ahjei,
   AdmsSensFadType & modelPar_rhjei,
   bool modelPar_given_rhjei,
   AdmsSensFadType & modelPar_hjci,
   bool modelPar_given_hjci,
   AdmsSensFadType & modelPar_ibeis,
   bool modelPar_given_ibeis,
   AdmsSensFadType & modelPar_mbei,
   bool modelPar_given_mbei,
   AdmsSensFadType & modelPar_ireis,
   bool modelPar_given_ireis,
   AdmsSensFadType & modelPar_mrei,
   bool modelPar_given_mrei,
   AdmsSensFadType & modelPar_ibeps,
   bool modelPar_given_ibeps,
   AdmsSensFadType & modelPar_mbep,
   bool modelPar_given_mbep,
   AdmsSensFadType & modelPar_ireps,
   bool modelPar_given_ireps,
   AdmsSensFadType & modelPar_mrep,
   bool modelPar_given_mrep,
   AdmsSensFadType & modelPar_mcf,
   bool modelPar_given_mcf,
   AdmsSensFadType & modelPar_tbhrec,
   bool modelPar_given_tbhrec,
   AdmsSensFadType & modelPar_ibcis,
   bool modelPar_given_ibcis,
   AdmsSensFadType & modelPar_mbci,
   bool modelPar_given_mbci,
   AdmsSensFadType & modelPar_ibcxs,
   bool modelPar_given_ibcxs,
   AdmsSensFadType & modelPar_mbcx,
   bool modelPar_given_mbcx,
   AdmsSensFadType & modelPar_ibets,
   bool modelPar_given_ibets,
   AdmsSensFadType & modelPar_abet,
   bool modelPar_given_abet,
   AdmsSensFadType & modelPar_favl,
   bool modelPar_given_favl,
   AdmsSensFadType & modelPar_qavl,
   bool modelPar_given_qavl,
   AdmsSensFadType & modelPar_kavl,
   bool modelPar_given_kavl,
   AdmsSensFadType & modelPar_alfav,
   bool modelPar_given_alfav,
   AdmsSensFadType & modelPar_alqav,
   bool modelPar_given_alqav,
   AdmsSensFadType & modelPar_alkav,
   bool modelPar_given_alkav,
   AdmsSensFadType & modelPar_rbi0,
   bool modelPar_given_rbi0,
   AdmsSensFadType & modelPar_rbx,
   bool modelPar_given_rbx,
   AdmsSensFadType & modelPar_fgeo,
   bool modelPar_given_fgeo,
   AdmsSensFadType & modelPar_fdqr0,
   bool modelPar_given_fdqr0,
   AdmsSensFadType & modelPar_fcrbi,
   bool modelPar_given_fcrbi,
   AdmsSensFadType & modelPar_fqi,
   bool modelPar_given_fqi,
   AdmsSensFadType & modelPar_re,
   bool modelPar_given_re,
   AdmsSensFadType & modelPar_rcx,
   bool modelPar_given_rcx,
   AdmsSensFadType & modelPar_itss,
   bool modelPar_given_itss,
   AdmsSensFadType & modelPar_msf,
   bool modelPar_given_msf,
   AdmsSensFadType & modelPar_iscs,
   bool modelPar_given_iscs,
   AdmsSensFadType & modelPar_msc,
   bool modelPar_given_msc,
   AdmsSensFadType & modelPar_tsf,
   bool modelPar_given_tsf,
   AdmsSensFadType & modelPar_rsu,
   bool modelPar_given_rsu,
   AdmsSensFadType & modelPar_csu,
   bool modelPar_given_csu,
   AdmsSensFadType & modelPar_cjei0,
   bool modelPar_given_cjei0,
   AdmsSensFadType & modelPar_vdei,
   bool modelPar_given_vdei,
   AdmsSensFadType & modelPar_zei,
   bool modelPar_given_zei,
   AdmsSensFadType & modelPar_ajei,
   bool modelPar_given_ajei,
   AdmsSensFadType & modelPar_cjep0,
   bool modelPar_given_cjep0,
   AdmsSensFadType & modelPar_vdep,
   bool modelPar_given_vdep,
   AdmsSensFadType & modelPar_zep,
   bool modelPar_given_zep,
   AdmsSensFadType & modelPar_ajep,
   bool modelPar_given_ajep,
   AdmsSensFadType & modelPar_cjci0,
   bool modelPar_given_cjci0,
   AdmsSensFadType & modelPar_vdci,
   bool modelPar_given_vdci,
   AdmsSensFadType & modelPar_zci,
   bool modelPar_given_zci,
   AdmsSensFadType & modelPar_vptci,
   bool modelPar_given_vptci,
   AdmsSensFadType & modelPar_cjcx0,
   bool modelPar_given_cjcx0,
   AdmsSensFadType & modelPar_vdcx,
   bool modelPar_given_vdcx,
   AdmsSensFadType & modelPar_zcx,
   bool modelPar_given_zcx,
   AdmsSensFadType & modelPar_vptcx,
   bool modelPar_given_vptcx,
   AdmsSensFadType & modelPar_fbcpar,
   bool modelPar_given_fbcpar,
   AdmsSensFadType & modelPar_fbepar,
   bool modelPar_given_fbepar,
   AdmsSensFadType & modelPar_cjs0,
   bool modelPar_given_cjs0,
   AdmsSensFadType & modelPar_vds,
   bool modelPar_given_vds,
   AdmsSensFadType & modelPar_zs,
   bool modelPar_given_zs,
   AdmsSensFadType & modelPar_vpts,
   bool modelPar_given_vpts,
   AdmsSensFadType & modelPar_cscp0,
   bool modelPar_given_cscp0,
   AdmsSensFadType & modelPar_vdsp,
   bool modelPar_given_vdsp,
   AdmsSensFadType & modelPar_zsp,
   bool modelPar_given_zsp,
   AdmsSensFadType & modelPar_vptsp,
   bool modelPar_given_vptsp,
   AdmsSensFadType & modelPar_t0,
   bool modelPar_given_t0,
   AdmsSensFadType & modelPar_dt0h,
   bool modelPar_given_dt0h,
   AdmsSensFadType & modelPar_tbvl,
   bool modelPar_given_tbvl,
   AdmsSensFadType & modelPar_tef0,
   bool modelPar_given_tef0,
   AdmsSensFadType & modelPar_gtfe,
   bool modelPar_given_gtfe,
   AdmsSensFadType & modelPar_thcs,
   bool modelPar_given_thcs,
   AdmsSensFadType & modelPar_ahc,
   bool modelPar_given_ahc,
   AdmsSensFadType & modelPar_fthc,
   bool modelPar_given_fthc,
   AdmsSensFadType & modelPar_rci0,
   bool modelPar_given_rci0,
   AdmsSensFadType & modelPar_vlim,
   bool modelPar_given_vlim,
   AdmsSensFadType & modelPar_vces,
   bool modelPar_given_vces,
   AdmsSensFadType & modelPar_vpt,
   bool modelPar_given_vpt,
   AdmsSensFadType & modelPar_aick,
   bool modelPar_given_aick,
   AdmsSensFadType & modelPar_delck,
   bool modelPar_given_delck,
   AdmsSensFadType & modelPar_tr,
   bool modelPar_given_tr,
   AdmsSensFadType & modelPar_vcbar,
   bool modelPar_given_vcbar,
   AdmsSensFadType & modelPar_icbar,
   bool modelPar_given_icbar,
   AdmsSensFadType & modelPar_acbar,
   bool modelPar_given_acbar,
   AdmsSensFadType & modelPar_cbepar,
   bool modelPar_given_cbepar,
   AdmsSensFadType & modelPar_cbcpar,
   bool modelPar_given_cbcpar,
   AdmsSensFadType & modelPar_alqf,
   bool modelPar_given_alqf,
   AdmsSensFadType & modelPar_alit,
   bool modelPar_given_alit,
   AdmsSensFadType & modelPar_kf,
   bool modelPar_given_kf,
   AdmsSensFadType & modelPar_af,
   bool modelPar_given_af,
   AdmsSensFadType & modelPar_kfre,
   bool modelPar_given_kfre,
   AdmsSensFadType & modelPar_afre,
   bool modelPar_given_afre,
   AdmsSensFadType & modelPar_latb,
   bool modelPar_given_latb,
   AdmsSensFadType & modelPar_latl,
   bool modelPar_given_latl,
   AdmsSensFadType & modelPar_vgb,
   bool modelPar_given_vgb,
   AdmsSensFadType & modelPar_alt0,
   bool modelPar_given_alt0,
   AdmsSensFadType & modelPar_kt0,
   bool modelPar_given_kt0,
   AdmsSensFadType & modelPar_zetaci,
   bool modelPar_given_zetaci,
   AdmsSensFadType & modelPar_alvs,
   bool modelPar_given_alvs,
   AdmsSensFadType & modelPar_alces,
   bool modelPar_given_alces,
   AdmsSensFadType & modelPar_zetarbi,
   bool modelPar_given_zetarbi,
   AdmsSensFadType & modelPar_zetarbx,
   bool modelPar_given_zetarbx,
   AdmsSensFadType & modelPar_zetarcx,
   bool modelPar_given_zetarcx,
   AdmsSensFadType & modelPar_zetare,
   bool modelPar_given_zetare,
   AdmsSensFadType & modelPar_zetacx,
   bool modelPar_given_zetacx,
   AdmsSensFadType & modelPar_vge,
   bool modelPar_given_vge,
   AdmsSensFadType & modelPar_vgc,
   bool modelPar_given_vgc,
   AdmsSensFadType & modelPar_vgs,
   bool modelPar_given_vgs,
   AdmsSensFadType & modelPar_f1vg,
   bool modelPar_given_f1vg,
   AdmsSensFadType & modelPar_f2vg,
   bool modelPar_given_f2vg,
   AdmsSensFadType & modelPar_zetact,
   bool modelPar_given_zetact,
   AdmsSensFadType & modelPar_zetabet,
   bool modelPar_given_zetabet,
   AdmsSensFadType & modelPar_alb,
   bool modelPar_given_alb,
   AdmsSensFadType & modelPar_dvgbe,
   bool modelPar_given_dvgbe,
   AdmsSensFadType & modelPar_zetahjei,
   bool modelPar_given_zetahjei,
   AdmsSensFadType & modelPar_zetavgbe,
   bool modelPar_given_zetavgbe,
   AdmsSensFadType & modelPar_rth,
   bool modelPar_given_rth,
   AdmsSensFadType & modelPar_zetarth,
   bool modelPar_given_zetarth,
   AdmsSensFadType & modelPar_alrth,
   bool modelPar_given_alrth,
   AdmsSensFadType & modelPar_cth,
   bool modelPar_given_cth,
   AdmsSensFadType & modelPar_flcomp,
   bool modelPar_given_flcomp,
   AdmsSensFadType & modelPar_tnom,
   bool modelPar_given_tnom,
   AdmsSensFadType & modelPar_dt,
   bool modelPar_given_dt,
   // non-reals (including hidden)
   int modelPar_tunode,
   bool modelPar_given_tunode,
   int modelPar_flnqs,
   bool modelPar_given_flnqs,
   int modelPar_cfbe,
   bool modelPar_given_cfbe,
   int modelPar_flcono,
   bool modelPar_given_flcono,
   int modelPar_flsh,
   bool modelPar_given_flsh,
   int modelPar_type,
   bool modelPar_given_type,
   double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
  AdmsSensFadType a_eg;
  AdmsSensFadType aa;
  AdmsSensFadType ab;
  AdmsSensFadType C_1;
  AdmsSensFadType vge_t0;
  AdmsSensFadType vgb_t0;
  AdmsSensFadType k20;
  AdmsSensFadType k10;
  //Begin block initial_instance
  {
    instanceVar_Tnom = (modelPar_tnom+273.15);
    instanceVar_Tamb = admsTemperature;
    instanceVar_vt0 = ((1.3806503e-23*instanceVar_Tnom)/1.6021766208e-19);
    {
      AdmsSensFadType value_log_0 = log(instanceVar_Tnom);
      k10 = ((modelPar_f1vg*instanceVar_Tnom)*value_log_0);
    }
    k20 = (modelPar_f2vg*instanceVar_Tnom);
    instanceVar_avs = (modelPar_alvs*instanceVar_Tnom);
    vgb_t0 = ((modelPar_vgb+k10)+k20);
    vge_t0 = ((modelPar_vge+k10)+k20);
    instanceVar_vgbe_t0 = ((vgb_t0+vge_t0)/2);
    instanceVar_vgbe0 = ((modelPar_vgb+modelPar_vge)/2);
    instanceVar_vgbc0 = ((modelPar_vgb+modelPar_vgc)/2);
    instanceVar_vgsc0 = ((modelPar_vgs+modelPar_vgc)/2);
    instanceVar_mg = (3-((1.6021766208e-19*modelPar_f1vg)/1.3806503e-23));
    instanceVar_zetabci = ((instanceVar_mg+1)-modelPar_zetaci);
    instanceVar_zetabcxt = ((instanceVar_mg+1)-modelPar_zetacx);
    instanceVar_zetasct = (instanceVar_mg-1.5);
    C_1 = ((1.0-modelPar_fbcpar)*(modelPar_cjcx0+modelPar_cbcpar));
    if ((C_1>=modelPar_cbcpar))
    {
      instanceVar_cbcpar1 = modelPar_cbcpar;
      instanceVar_cbcpar2 = 0.0;
      instanceVar_cjcx01 = (C_1-modelPar_cbcpar);
      instanceVar_cjcx02 = (modelPar_cjcx0-instanceVar_cjcx01);
    }
    else
    {
      instanceVar_cbcpar1 = C_1;
      instanceVar_cbcpar2 = (modelPar_cbcpar-instanceVar_cbcpar1);
      instanceVar_cjcx01 = 0.0;
      instanceVar_cjcx02 = modelPar_cjcx0;
    }
    instanceVar_cbepar2 = (modelPar_fbepar*modelPar_cbepar);
    instanceVar_cbepar1 = (modelPar_cbepar-instanceVar_cbepar2);
    if ((modelPar_ich!=0.0))
    {
      instanceVar_Oich = (1.0/modelPar_ich);
    }
    else
    {
      instanceVar_Oich = 0.0;
    }
    if ((modelPar_tbhrec!=0.0))
    {
      instanceVar_Otbhrec = (1.0/modelPar_tbhrec);
    }
    else
    {
      instanceVar_Otbhrec = 0.0;
    }
    if (((modelPar_favl>0.0)&&(modelPar_cjci0>0.0)))
    {
      instanceVar_use_aval = 1;
    }
    else
    {
      instanceVar_use_aval = 0;
      instanceVar_iavl = 0.0;
    }
    if (((modelPar_flsh==0)||(modelPar_rth<0.001)))
      //Begin block Thermal_updat_without_self_heating
    {
      instanceVar_Tdev = (instanceVar_Tamb+modelPar_dt);
      if ((instanceVar_Tdev<((-100.0)+273.15)))
      {
        instanceVar_Tdev = ((-100.0)+273.15);
      }
      else
      {
        if ((instanceVar_Tdev>(326.85+273.15)))
        {
          instanceVar_Tdev = (326.85+273.15);
        }
      }
      instanceVar_VT = ((1.3806503e-23*instanceVar_Tdev)/1.6021766208e-19);
      instanceVar_dT = (instanceVar_Tdev-instanceVar_Tnom);
      instanceVar_qtt0 = (instanceVar_Tdev/instanceVar_Tnom);
      {
        AdmsSensFadType value_log_0 = log(instanceVar_qtt0);
        instanceVar_ln_qtt0 = value_log_0;
      }
      {
        AdmsSensFadType value_log_0 = log(instanceVar_Tdev);
        instanceVar_k1 = ((modelPar_f1vg*instanceVar_Tdev)*value_log_0);
      }
      instanceVar_k2 = (modelPar_f2vg*instanceVar_Tdev);
      instanceVar_vgb_t = ((modelPar_vgb+instanceVar_k1)+instanceVar_k2);
      instanceVar_vge_t = ((modelPar_vge+instanceVar_k1)+instanceVar_k2);
      instanceVar_vgbe_t = ((instanceVar_vgb_t+instanceVar_vge_t)/2);
      if ((modelPar_cjei0>0.0))
      {
        {
          AdmsSensFadType value_exp_0 = exp(((modelPar_vdei*0.5)/instanceVar_vt0));
          AdmsSensFadType value_exp_1 = exp((((-0.5)*modelPar_vdei)/instanceVar_vt0));
          AdmsSensFadType value_log_2 = log((value_exp_0-value_exp_1));
          instanceVar_vdj0 = ((2*instanceVar_vt0)*value_log_2);
        }
        instanceVar_vdjt = (((instanceVar_vdj0*instanceVar_qtt0)+(instanceVar_vgbe0*(1-instanceVar_qtt0)))-((instanceVar_mg*instanceVar_VT)*instanceVar_ln_qtt0));
        {
          AdmsSensFadType value_exp_0 = exp(((-instanceVar_vdjt)/instanceVar_VT));
          AdmsSensFadType value_sqrt_1 = sqrt((1+(4*value_exp_0)));
          AdmsSensFadType value_log_2 = log((0.5*(1+value_sqrt_1)));
          instanceVar_vdt = (instanceVar_vdjt+((2*instanceVar_VT)*value_log_2));
        }
        instanceVar_vdei_t = instanceVar_vdt;
        {
          AdmsSensFadType value_log_0 = log((modelPar_vdei/instanceVar_vdei_t));
          AdmsSensFadType value_exp_1 = exp((modelPar_zei*value_log_0));
          instanceVar_cjei0_t = (modelPar_cjei0*value_exp_1);
        }
        if ((1==1))
        {
          instanceVar_ajei_t = ((modelPar_ajei*instanceVar_vdei_t)/modelPar_vdei);
        }
        else
        {
          instanceVar_ajei_t = modelPar_ajei;
        }
      }
      else
      {
        instanceVar_cjei0_t = modelPar_cjei0;
        instanceVar_vdei_t = modelPar_vdei;
        instanceVar_ajei_t = modelPar_ajei;
      }
      if (((modelPar_flcomp==0.0)||(modelPar_flcomp==2.1)))
      {
        instanceVar_V_gT = (((3.0*instanceVar_VT)*instanceVar_ln_qtt0)+(modelPar_vgb*(instanceVar_qtt0-1.0)));
        instanceVar_r_VgVT = (instanceVar_V_gT/instanceVar_VT);
        instanceVar_a = (((modelPar_mcf*instanceVar_r_VgVT)/modelPar_mbei)-(modelPar_alb*instanceVar_dT));
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_a);
          instanceVar_ibeis_t = (modelPar_ibeis*value_exp_0);
        }
        instanceVar_a = (((modelPar_mcf*instanceVar_r_VgVT)/modelPar_mrei)-(modelPar_alb*instanceVar_dT));
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_a);
          instanceVar_ireis_t = (modelPar_ireis*value_exp_0);
        }
        instanceVar_a = (((modelPar_mcf*instanceVar_r_VgVT)/modelPar_mbep)-(modelPar_alb*instanceVar_dT));
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_a);
          instanceVar_ibeps_t = (modelPar_ibeps*value_exp_0);
        }
        instanceVar_a = (((modelPar_mcf*instanceVar_r_VgVT)/modelPar_mrep)-(modelPar_alb*instanceVar_dT));
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_a);
          instanceVar_ireps_t = (modelPar_ireps*value_exp_0);
        }
        instanceVar_a = (instanceVar_r_VgVT/modelPar_mbci);
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_a);
          instanceVar_ibcis_t = (modelPar_ibcis*value_exp_0);
        }
        instanceVar_a = (instanceVar_r_VgVT/modelPar_mbcx);
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_a);
          instanceVar_ibcxs_t = (modelPar_ibcxs*value_exp_0);
        }
        instanceVar_a = (instanceVar_r_VgVT/modelPar_msf);
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_a);
          instanceVar_itss_t = (modelPar_itss*value_exp_0);
        }
        instanceVar_a = (instanceVar_r_VgVT/modelPar_msc);
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_a);
          instanceVar_iscs_t = (modelPar_iscs*value_exp_0);
        }
        instanceVar_a = (instanceVar_vdei_t/modelPar_vdei);
        instanceVar_qp0_t = (modelPar_qp0*(1.0+((0.5*modelPar_zei)*(1.0-instanceVar_a))));
        {
          AdmsSensFadType value_exp_0 = exp((modelPar_zetaci*instanceVar_ln_qtt0));
          instanceVar_a = ((modelPar_vlim*(1.0-(modelPar_alvs*instanceVar_dT)))*value_exp_0);
        }
        instanceVar_k = ((instanceVar_a-instanceVar_VT)/instanceVar_VT);
        if ((instanceVar_k<11.0))
        {
          {
            AdmsSensFadType value_exp_0 = exp(instanceVar_k);
            AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
            instanceVar_vlim_t = (instanceVar_VT+(instanceVar_VT*value_log_1));
          }
        }
        else
        {
          instanceVar_vlim_t = instanceVar_a;
        }
        instanceVar_a = (1.0+(modelPar_alb*instanceVar_dT));
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((instanceVar_a*instanceVar_a)+0.01));
          instanceVar_k = (0.5*(instanceVar_a+value_sqrt_0));
        }
        instanceVar_tef0_t = ((modelPar_tef0*instanceVar_qtt0)/instanceVar_k);
      }
      else
      {
        {
          AdmsSensFadType value_exp_0 = exp(((modelPar_zetabet*instanceVar_ln_qtt0)+((modelPar_vge/instanceVar_VT)*(instanceVar_qtt0-1))));
          instanceVar_ibeis_t = (modelPar_ibeis*value_exp_0);
        }
        if ((modelPar_flcomp>=2.3))
        {
          {
            AdmsSensFadType value_exp_0 = exp((((instanceVar_mg/modelPar_mrei)*instanceVar_ln_qtt0)+((instanceVar_vgbe0/(modelPar_mrei*instanceVar_VT))*(instanceVar_qtt0-1))));
            instanceVar_ireis_t = (modelPar_ireis*value_exp_0);
          }
        }
        else
        {
          {
            AdmsSensFadType value_exp_0 = exp((((0.5*instanceVar_mg)*instanceVar_ln_qtt0)+(((0.5*instanceVar_vgbe0)/instanceVar_VT)*(instanceVar_qtt0-1))));
            instanceVar_ireis_t = (modelPar_ireis*value_exp_0);
          }
        }
        {
          AdmsSensFadType value_exp_0 = exp(((modelPar_zetabet*instanceVar_ln_qtt0)+((modelPar_vge/instanceVar_VT)*(instanceVar_qtt0-1))));
          instanceVar_ibeps_t = (modelPar_ibeps*value_exp_0);
        }
        if ((modelPar_flcomp>=2.3))
        {
          {
            AdmsSensFadType value_exp_0 = exp((((instanceVar_mg/modelPar_mrep)*instanceVar_ln_qtt0)+((instanceVar_vgbe0/(modelPar_mrep*instanceVar_VT))*(instanceVar_qtt0-1))));
            instanceVar_ireps_t = (modelPar_ireps*value_exp_0);
          }
        }
        else
        {
          {
            AdmsSensFadType value_exp_0 = exp((((0.5*instanceVar_mg)*instanceVar_ln_qtt0)+(((0.5*instanceVar_vgbe0)/instanceVar_VT)*(instanceVar_qtt0-1))));
            instanceVar_ireps_t = (modelPar_ireps*value_exp_0);
          }
        }
        {
          AdmsSensFadType value_exp_0 = exp(((instanceVar_zetabci*instanceVar_ln_qtt0)+((modelPar_vgc/instanceVar_VT)*(instanceVar_qtt0-1))));
          instanceVar_ibcis_t = (modelPar_ibcis*value_exp_0);
        }
        {
          AdmsSensFadType value_exp_0 = exp(((instanceVar_zetabcxt*instanceVar_ln_qtt0)+((modelPar_vgc/instanceVar_VT)*(instanceVar_qtt0-1))));
          instanceVar_ibcxs_t = (modelPar_ibcxs*value_exp_0);
        }
        {
          AdmsSensFadType value_exp_0 = exp(((instanceVar_zetasct*instanceVar_ln_qtt0)+((modelPar_vgc/instanceVar_VT)*(instanceVar_qtt0-1))));
          instanceVar_itss_t = (modelPar_itss*value_exp_0);
        }
        {
          AdmsSensFadType value_exp_0 = exp(((instanceVar_zetasct*instanceVar_ln_qtt0)+((modelPar_vgs/instanceVar_VT)*(instanceVar_qtt0-1))));
          instanceVar_iscs_t = (modelPar_iscs*value_exp_0);
        }
        {
          AdmsSensFadType value_log_0 = log((instanceVar_vdei_t/modelPar_vdei));
          AdmsSensFadType value_exp_1 = exp((modelPar_zei*value_log_0));
          instanceVar_a = value_exp_1;
        }
        instanceVar_qp0_t = (modelPar_qp0*(2.0-instanceVar_a));
        {
          AdmsSensFadType value_exp_0 = exp(((modelPar_zetaci-instanceVar_avs)*instanceVar_ln_qtt0));
          instanceVar_vlim_t = (modelPar_vlim*value_exp_0);
        }
        if ((modelPar_flcomp>=2.3))
        {
          instanceVar_tef0_t = modelPar_tef0;
        }
        else
        {
          instanceVar_zetatef = ((modelPar_zetabet-modelPar_zetact)-0.5);
          instanceVar_dvg0 = (modelPar_vgb-modelPar_vge);
          {
            AdmsSensFadType value_exp_0 = exp(((instanceVar_zetatef*instanceVar_ln_qtt0)-((instanceVar_dvg0/instanceVar_VT)*(instanceVar_qtt0-1))));
            instanceVar_tef0_t = (modelPar_tef0*value_exp_0);
          }
        }
      }
      {
        AdmsSensFadType value_exp_0 = exp(((modelPar_zetact*instanceVar_ln_qtt0)+((modelPar_vgb/instanceVar_VT)*(instanceVar_qtt0-1))));
        instanceVar_c10_t = (modelPar_c10*value_exp_0);
      }
      {
        AdmsSensFadType value_exp_0 = exp((modelPar_zetaci*instanceVar_ln_qtt0));
        instanceVar_rci0_t = (modelPar_rci0*value_exp_0);
      }
      instanceVar_vces_t = (modelPar_vces*(1+(modelPar_alces*instanceVar_dT)));
      if ((modelPar_cjci0>0.0))
      {
        {
          AdmsSensFadType value_exp_0 = exp(((modelPar_vdci*0.5)/instanceVar_vt0));
          AdmsSensFadType value_exp_1 = exp((((-0.5)*modelPar_vdci)/instanceVar_vt0));
          AdmsSensFadType value_log_2 = log((value_exp_0-value_exp_1));
          instanceVar_vdj0 = ((2*instanceVar_vt0)*value_log_2);
        }
        instanceVar_vdjt = (((instanceVar_vdj0*instanceVar_qtt0)+(instanceVar_vgbc0*(1-instanceVar_qtt0)))-((instanceVar_mg*instanceVar_VT)*instanceVar_ln_qtt0));
        {
          AdmsSensFadType value_exp_0 = exp(((-instanceVar_vdjt)/instanceVar_VT));
          AdmsSensFadType value_sqrt_1 = sqrt((1+(4*value_exp_0)));
          AdmsSensFadType value_log_2 = log((0.5*(1+value_sqrt_1)));
          instanceVar_vdt = (instanceVar_vdjt+((2*instanceVar_VT)*value_log_2));
        }
        instanceVar_vdci_t = instanceVar_vdt;
        {
          AdmsSensFadType value_log_0 = log((modelPar_vdci/instanceVar_vdci_t));
          AdmsSensFadType value_exp_1 = exp((modelPar_zci*value_log_0));
          instanceVar_cjci0_t = (modelPar_cjci0*value_exp_1);
        }
        if ((0==1))
        {
          instanceVar_vptci_t = ((modelPar_vptci*instanceVar_vdci_t)/modelPar_vdci);
        }
        else
        {
          instanceVar_vptci_t = modelPar_vptci;
        }
      }
      else
      {
        instanceVar_cjci0_t = modelPar_cjci0;
        instanceVar_vdci_t = modelPar_vdci;
        instanceVar_vptci_t = modelPar_vptci;
      }
      instanceVar_t0_t = (modelPar_t0*((1+(modelPar_alt0*instanceVar_dT))+((modelPar_kt0*instanceVar_dT)*instanceVar_dT)));
      {
        AdmsSensFadType value_exp_0 = exp(((modelPar_zetaci-1)*instanceVar_ln_qtt0));
        instanceVar_thcs_t = (modelPar_thcs*value_exp_0);
      }
      {
        AdmsSensFadType value_exp_0 = exp((modelPar_alfav*instanceVar_dT));
        instanceVar_favl_t = (modelPar_favl*value_exp_0);
      }
      {
        AdmsSensFadType value_exp_0 = exp((modelPar_alqav*instanceVar_dT));
        instanceVar_qavl_t = (modelPar_qavl*value_exp_0);
      }
      {
        AdmsSensFadType value_exp_0 = exp((modelPar_alkav*instanceVar_dT));
        instanceVar_kavl_t = (modelPar_kavl*value_exp_0);
      }
      {
        AdmsSensFadType value_exp_0 = exp((modelPar_zetarbi*instanceVar_ln_qtt0));
        instanceVar_rbi0_t = (modelPar_rbi0*value_exp_0);
      }
      if ((modelPar_cjep0>0.0))
      {
        {
          AdmsSensFadType value_exp_0 = exp(((modelPar_vdep*0.5)/instanceVar_vt0));
          AdmsSensFadType value_exp_1 = exp((((-0.5)*modelPar_vdep)/instanceVar_vt0));
          AdmsSensFadType value_log_2 = log((value_exp_0-value_exp_1));
          instanceVar_vdj0 = ((2*instanceVar_vt0)*value_log_2);
        }
        instanceVar_vdjt = (((instanceVar_vdj0*instanceVar_qtt0)+(instanceVar_vgbe0*(1-instanceVar_qtt0)))-((instanceVar_mg*instanceVar_VT)*instanceVar_ln_qtt0));
        {
          AdmsSensFadType value_exp_0 = exp(((-instanceVar_vdjt)/instanceVar_VT));
          AdmsSensFadType value_sqrt_1 = sqrt((1+(4*value_exp_0)));
          AdmsSensFadType value_log_2 = log((0.5*(1+value_sqrt_1)));
          instanceVar_vdt = (instanceVar_vdjt+((2*instanceVar_VT)*value_log_2));
        }
        instanceVar_vdep_t = instanceVar_vdt;
        {
          AdmsSensFadType value_log_0 = log((modelPar_vdep/instanceVar_vdep_t));
          AdmsSensFadType value_exp_1 = exp((modelPar_zep*value_log_0));
          instanceVar_cjep0_t = (modelPar_cjep0*value_exp_1);
        }
        if ((1==1))
        {
          instanceVar_ajep_t = ((modelPar_ajep*instanceVar_vdep_t)/modelPar_vdep);
        }
        else
        {
          instanceVar_ajep_t = modelPar_ajep;
        }
      }
      else
      {
        instanceVar_cjep0_t = modelPar_cjep0;
        instanceVar_vdep_t = modelPar_vdep;
        instanceVar_ajep_t = modelPar_ajep;
      }
      if ((modelPar_ibets>0))
        //Begin block HICTUN_T
      {
        //Block-local variables for block HICTUN_T
        AdmsSensFadType a_eg;
        AdmsSensFadType ab;
        AdmsSensFadType aa;
        //End of Block-local variables
        ab = 1.0;
        aa = 1.0;
        a_eg = (instanceVar_vgbe_t0/instanceVar_vgbe_t);
        if ((((modelPar_tunode==1)&&(modelPar_cjep0>0.0))&&(modelPar_vdep>0.0)))
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt(a_eg);
            ab = (((((instanceVar_cjep0_t/modelPar_cjep0)*value_sqrt_0)*instanceVar_vdep_t)*instanceVar_vdep_t)/(modelPar_vdep*modelPar_vdep));
          }
          {
            AdmsSensFadType value_pow_0 = pow(a_eg,(-1.5));
            aa = (((modelPar_vdep/instanceVar_vdep_t)*(modelPar_cjep0/instanceVar_cjep0_t))*value_pow_0);
          }
        }
        else
        {
          if ((((modelPar_tunode==0)&&(modelPar_cjei0>0.0))&&(modelPar_vdei>0.0)))
          {
            {
              AdmsSensFadType value_sqrt_0 = sqrt(a_eg);
              ab = (((((instanceVar_cjei0_t/modelPar_cjei0)*value_sqrt_0)*instanceVar_vdei_t)*instanceVar_vdei_t)/(modelPar_vdei*modelPar_vdei));
            }
            {
              AdmsSensFadType value_pow_0 = pow(a_eg,(-1.5));
              aa = (((modelPar_vdei/instanceVar_vdei_t)*(modelPar_cjei0/instanceVar_cjei0_t))*value_pow_0);
            }
          }
        }
        instanceVar_ibets_t = (modelPar_ibets*ab);
        instanceVar_abet_t = (modelPar_abet*aa);
      }
      // End block HICTUN_T
      else
      {
        instanceVar_ibets_t = 0;
        instanceVar_abet_t = 1;
      }
      if ((1.0>0.0))
      {
        {
          AdmsSensFadType value_exp_0 = exp(((modelPar_vdcx*0.5)/instanceVar_vt0));
          AdmsSensFadType value_exp_1 = exp((((-0.5)*modelPar_vdcx)/instanceVar_vt0));
          AdmsSensFadType value_log_2 = log((value_exp_0-value_exp_1));
          instanceVar_vdj0 = ((2*instanceVar_vt0)*value_log_2);
        }
        instanceVar_vdjt = (((instanceVar_vdj0*instanceVar_qtt0)+(instanceVar_vgbc0*(1-instanceVar_qtt0)))-((instanceVar_mg*instanceVar_VT)*instanceVar_ln_qtt0));
        {
          AdmsSensFadType value_exp_0 = exp(((-instanceVar_vdjt)/instanceVar_VT));
          AdmsSensFadType value_sqrt_1 = sqrt((1+(4*value_exp_0)));
          AdmsSensFadType value_log_2 = log((0.5*(1+value_sqrt_1)));
          instanceVar_vdt = (instanceVar_vdjt+((2*instanceVar_VT)*value_log_2));
        }
        instanceVar_vdcx_t = instanceVar_vdt;
        {
          AdmsSensFadType value_log_0 = log((modelPar_vdcx/instanceVar_vdcx_t));
          AdmsSensFadType value_exp_1 = exp((modelPar_zcx*value_log_0));
          instanceVar_cratio_t = (1.0*value_exp_1);
        }
        if ((0==1))
        {
          instanceVar_vptcx_t = ((modelPar_vptcx*instanceVar_vdcx_t)/modelPar_vdcx);
        }
        else
        {
          instanceVar_vptcx_t = modelPar_vptcx;
        }
      }
      else
      {
        instanceVar_cratio_t = 1.0;
        instanceVar_vdcx_t = modelPar_vdcx;
        instanceVar_vptcx_t = modelPar_vptcx;
      }
      instanceVar_cjcx01_t = (instanceVar_cratio_t*instanceVar_cjcx01);
      instanceVar_cjcx02_t = (instanceVar_cratio_t*instanceVar_cjcx02);
      {
        AdmsSensFadType value_exp_0 = exp((modelPar_zetarcx*instanceVar_ln_qtt0));
        instanceVar_rcx_t = (modelPar_rcx*value_exp_0);
      }
      {
        AdmsSensFadType value_exp_0 = exp((modelPar_zetarbx*instanceVar_ln_qtt0));
        instanceVar_rbx_t = (modelPar_rbx*value_exp_0);
      }
      {
        AdmsSensFadType value_exp_0 = exp((modelPar_zetare*instanceVar_ln_qtt0));
        instanceVar_re_t = (modelPar_re*value_exp_0);
      }
      {
        AdmsSensFadType value_exp_0 = exp(((modelPar_zetacx-1.0)*instanceVar_ln_qtt0));
        instanceVar_tsf_t = (modelPar_tsf*value_exp_0);
      }
      if ((modelPar_cjs0>0.0))
      {
        {
          AdmsSensFadType value_exp_0 = exp(((modelPar_vds*0.5)/instanceVar_vt0));
          AdmsSensFadType value_exp_1 = exp((((-0.5)*modelPar_vds)/instanceVar_vt0));
          AdmsSensFadType value_log_2 = log((value_exp_0-value_exp_1));
          instanceVar_vdj0 = ((2*instanceVar_vt0)*value_log_2);
        }
        instanceVar_vdjt = (((instanceVar_vdj0*instanceVar_qtt0)+(instanceVar_vgsc0*(1-instanceVar_qtt0)))-((instanceVar_mg*instanceVar_VT)*instanceVar_ln_qtt0));
        {
          AdmsSensFadType value_exp_0 = exp(((-instanceVar_vdjt)/instanceVar_VT));
          AdmsSensFadType value_sqrt_1 = sqrt((1+(4*value_exp_0)));
          AdmsSensFadType value_log_2 = log((0.5*(1+value_sqrt_1)));
          instanceVar_vdt = (instanceVar_vdjt+((2*instanceVar_VT)*value_log_2));
        }
        instanceVar_vds_t = instanceVar_vdt;
        {
          AdmsSensFadType value_log_0 = log((modelPar_vds/instanceVar_vds_t));
          AdmsSensFadType value_exp_1 = exp((modelPar_zs*value_log_0));
          instanceVar_cjs0_t = (modelPar_cjs0*value_exp_1);
        }
        if ((0==1))
        {
          instanceVar_vpts_t = ((modelPar_vpts*instanceVar_vds_t)/modelPar_vds);
        }
        else
        {
          instanceVar_vpts_t = modelPar_vpts;
        }
      }
      else
      {
        instanceVar_cjs0_t = modelPar_cjs0;
        instanceVar_vds_t = modelPar_vds;
        instanceVar_vpts_t = modelPar_vpts;
      }
      if ((modelPar_vdsp>0))
      {
        if ((modelPar_cscp0>0.0))
        {
          {
            AdmsSensFadType value_exp_0 = exp(((modelPar_vdsp*0.5)/instanceVar_vt0));
            AdmsSensFadType value_exp_1 = exp((((-0.5)*modelPar_vdsp)/instanceVar_vt0));
            AdmsSensFadType value_log_2 = log((value_exp_0-value_exp_1));
            instanceVar_vdj0 = ((2*instanceVar_vt0)*value_log_2);
          }
          instanceVar_vdjt = (((instanceVar_vdj0*instanceVar_qtt0)+(instanceVar_vgsc0*(1-instanceVar_qtt0)))-((instanceVar_mg*instanceVar_VT)*instanceVar_ln_qtt0));
          {
            AdmsSensFadType value_exp_0 = exp(((-instanceVar_vdjt)/instanceVar_VT));
            AdmsSensFadType value_sqrt_1 = sqrt((1+(4*value_exp_0)));
            AdmsSensFadType value_log_2 = log((0.5*(1+value_sqrt_1)));
            instanceVar_vdt = (instanceVar_vdjt+((2*instanceVar_VT)*value_log_2));
          }
          instanceVar_vdsp_t = instanceVar_vdt;
          {
            AdmsSensFadType value_log_0 = log((modelPar_vdsp/instanceVar_vdsp_t));
            AdmsSensFadType value_exp_1 = exp((modelPar_zsp*value_log_0));
            instanceVar_cscp0_t = (modelPar_cscp0*value_exp_1);
          }
          if ((0==1))
          {
            instanceVar_vptsp_t = ((modelPar_vptsp*instanceVar_vdsp_t)/modelPar_vdsp);
          }
          else
          {
            instanceVar_vptsp_t = modelPar_vptsp;
          }
        }
        else
        {
          instanceVar_cscp0_t = modelPar_cscp0;
          instanceVar_vdsp_t = modelPar_vdsp;
          instanceVar_vptsp_t = modelPar_vptsp;
        }
      }
      else
      {
        instanceVar_cscp0_t = modelPar_cscp0;
        instanceVar_vdsp_t = modelPar_vdsp;
        instanceVar_vptsp_t = modelPar_vptsp;
      }
      {
        AdmsSensFadType value_exp_0 = exp((modelPar_zetahjei*instanceVar_ln_qtt0));
        instanceVar_ahjei_t = (modelPar_ahjei*value_exp_0);
      }
      {
        AdmsSensFadType value_log_0 = log(instanceVar_qtt0);
        AdmsSensFadType value_exp_1 = exp((modelPar_zetavgbe*value_log_0));
        AdmsSensFadType value_exp_2 = exp(((modelPar_dvgbe/instanceVar_VT)*(value_exp_1-1)));
        instanceVar_hjei0_t = (modelPar_hjei*value_exp_2);
      }
      {
        AdmsSensFadType value_exp_0 = exp(((modelPar_dvgbe/instanceVar_VT)*(instanceVar_qtt0-1)));
        instanceVar_hf0_t = (modelPar_hf0*value_exp_0);
      }
      if ((modelPar_flcomp>=2.3))
      {
        {
          AdmsSensFadType value_exp_0 = exp((((modelPar_vgb-modelPar_vge)/instanceVar_VT)*(instanceVar_qtt0-1)));
          instanceVar_hfe_t = (modelPar_hfe*value_exp_0);
        }
        {
          AdmsSensFadType value_exp_0 = exp((((modelPar_vgb-modelPar_vgc)/instanceVar_VT)*(instanceVar_qtt0-1)));
          instanceVar_hfc_t = (modelPar_hfc*value_exp_0);
        }
      }
      else
      {
        instanceVar_hfe_t = modelPar_hfe;
        instanceVar_hfc_t = modelPar_hfc;
      }
      {
        AdmsSensFadType value_exp_0 = exp((modelPar_zetarth*instanceVar_ln_qtt0));
        instanceVar_rth_t = ((modelPar_rth*value_exp_0)*(1+(modelPar_alrth*instanceVar_dT)));
      }
    }
    // End block Thermal_updat_without_self_heating
  }
  // End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_c10,
   bool modelPar_given_c10,
   AdmsSensFadType & modelPar_qp0,
   bool modelPar_given_qp0,
   AdmsSensFadType & modelPar_ich,
   bool modelPar_given_ich,
   AdmsSensFadType & modelPar_hf0,
   bool modelPar_given_hf0,
   AdmsSensFadType & modelPar_hfe,
   bool modelPar_given_hfe,
   AdmsSensFadType & modelPar_hfc,
   bool modelPar_given_hfc,
   AdmsSensFadType & modelPar_hjei,
   bool modelPar_given_hjei,
   AdmsSensFadType & modelPar_ahjei,
   bool modelPar_given_ahjei,
   AdmsSensFadType & modelPar_rhjei,
   bool modelPar_given_rhjei,
   AdmsSensFadType & modelPar_hjci,
   bool modelPar_given_hjci,
   AdmsSensFadType & modelPar_ibeis,
   bool modelPar_given_ibeis,
   AdmsSensFadType & modelPar_mbei,
   bool modelPar_given_mbei,
   AdmsSensFadType & modelPar_ireis,
   bool modelPar_given_ireis,
   AdmsSensFadType & modelPar_mrei,
   bool modelPar_given_mrei,
   AdmsSensFadType & modelPar_ibeps,
   bool modelPar_given_ibeps,
   AdmsSensFadType & modelPar_mbep,
   bool modelPar_given_mbep,
   AdmsSensFadType & modelPar_ireps,
   bool modelPar_given_ireps,
   AdmsSensFadType & modelPar_mrep,
   bool modelPar_given_mrep,
   AdmsSensFadType & modelPar_mcf,
   bool modelPar_given_mcf,
   AdmsSensFadType & modelPar_tbhrec,
   bool modelPar_given_tbhrec,
   AdmsSensFadType & modelPar_ibcis,
   bool modelPar_given_ibcis,
   AdmsSensFadType & modelPar_mbci,
   bool modelPar_given_mbci,
   AdmsSensFadType & modelPar_ibcxs,
   bool modelPar_given_ibcxs,
   AdmsSensFadType & modelPar_mbcx,
   bool modelPar_given_mbcx,
   AdmsSensFadType & modelPar_ibets,
   bool modelPar_given_ibets,
   AdmsSensFadType & modelPar_abet,
   bool modelPar_given_abet,
   AdmsSensFadType & modelPar_favl,
   bool modelPar_given_favl,
   AdmsSensFadType & modelPar_qavl,
   bool modelPar_given_qavl,
   AdmsSensFadType & modelPar_kavl,
   bool modelPar_given_kavl,
   AdmsSensFadType & modelPar_alfav,
   bool modelPar_given_alfav,
   AdmsSensFadType & modelPar_alqav,
   bool modelPar_given_alqav,
   AdmsSensFadType & modelPar_alkav,
   bool modelPar_given_alkav,
   AdmsSensFadType & modelPar_rbi0,
   bool modelPar_given_rbi0,
   AdmsSensFadType & modelPar_rbx,
   bool modelPar_given_rbx,
   AdmsSensFadType & modelPar_fgeo,
   bool modelPar_given_fgeo,
   AdmsSensFadType & modelPar_fdqr0,
   bool modelPar_given_fdqr0,
   AdmsSensFadType & modelPar_fcrbi,
   bool modelPar_given_fcrbi,
   AdmsSensFadType & modelPar_fqi,
   bool modelPar_given_fqi,
   AdmsSensFadType & modelPar_re,
   bool modelPar_given_re,
   AdmsSensFadType & modelPar_rcx,
   bool modelPar_given_rcx,
   AdmsSensFadType & modelPar_itss,
   bool modelPar_given_itss,
   AdmsSensFadType & modelPar_msf,
   bool modelPar_given_msf,
   AdmsSensFadType & modelPar_iscs,
   bool modelPar_given_iscs,
   AdmsSensFadType & modelPar_msc,
   bool modelPar_given_msc,
   AdmsSensFadType & modelPar_tsf,
   bool modelPar_given_tsf,
   AdmsSensFadType & modelPar_rsu,
   bool modelPar_given_rsu,
   AdmsSensFadType & modelPar_csu,
   bool modelPar_given_csu,
   AdmsSensFadType & modelPar_cjei0,
   bool modelPar_given_cjei0,
   AdmsSensFadType & modelPar_vdei,
   bool modelPar_given_vdei,
   AdmsSensFadType & modelPar_zei,
   bool modelPar_given_zei,
   AdmsSensFadType & modelPar_ajei,
   bool modelPar_given_ajei,
   AdmsSensFadType & modelPar_cjep0,
   bool modelPar_given_cjep0,
   AdmsSensFadType & modelPar_vdep,
   bool modelPar_given_vdep,
   AdmsSensFadType & modelPar_zep,
   bool modelPar_given_zep,
   AdmsSensFadType & modelPar_ajep,
   bool modelPar_given_ajep,
   AdmsSensFadType & modelPar_cjci0,
   bool modelPar_given_cjci0,
   AdmsSensFadType & modelPar_vdci,
   bool modelPar_given_vdci,
   AdmsSensFadType & modelPar_zci,
   bool modelPar_given_zci,
   AdmsSensFadType & modelPar_vptci,
   bool modelPar_given_vptci,
   AdmsSensFadType & modelPar_cjcx0,
   bool modelPar_given_cjcx0,
   AdmsSensFadType & modelPar_vdcx,
   bool modelPar_given_vdcx,
   AdmsSensFadType & modelPar_zcx,
   bool modelPar_given_zcx,
   AdmsSensFadType & modelPar_vptcx,
   bool modelPar_given_vptcx,
   AdmsSensFadType & modelPar_fbcpar,
   bool modelPar_given_fbcpar,
   AdmsSensFadType & modelPar_fbepar,
   bool modelPar_given_fbepar,
   AdmsSensFadType & modelPar_cjs0,
   bool modelPar_given_cjs0,
   AdmsSensFadType & modelPar_vds,
   bool modelPar_given_vds,
   AdmsSensFadType & modelPar_zs,
   bool modelPar_given_zs,
   AdmsSensFadType & modelPar_vpts,
   bool modelPar_given_vpts,
   AdmsSensFadType & modelPar_cscp0,
   bool modelPar_given_cscp0,
   AdmsSensFadType & modelPar_vdsp,
   bool modelPar_given_vdsp,
   AdmsSensFadType & modelPar_zsp,
   bool modelPar_given_zsp,
   AdmsSensFadType & modelPar_vptsp,
   bool modelPar_given_vptsp,
   AdmsSensFadType & modelPar_t0,
   bool modelPar_given_t0,
   AdmsSensFadType & modelPar_dt0h,
   bool modelPar_given_dt0h,
   AdmsSensFadType & modelPar_tbvl,
   bool modelPar_given_tbvl,
   AdmsSensFadType & modelPar_tef0,
   bool modelPar_given_tef0,
   AdmsSensFadType & modelPar_gtfe,
   bool modelPar_given_gtfe,
   AdmsSensFadType & modelPar_thcs,
   bool modelPar_given_thcs,
   AdmsSensFadType & modelPar_ahc,
   bool modelPar_given_ahc,
   AdmsSensFadType & modelPar_fthc,
   bool modelPar_given_fthc,
   AdmsSensFadType & modelPar_rci0,
   bool modelPar_given_rci0,
   AdmsSensFadType & modelPar_vlim,
   bool modelPar_given_vlim,
   AdmsSensFadType & modelPar_vces,
   bool modelPar_given_vces,
   AdmsSensFadType & modelPar_vpt,
   bool modelPar_given_vpt,
   AdmsSensFadType & modelPar_aick,
   bool modelPar_given_aick,
   AdmsSensFadType & modelPar_delck,
   bool modelPar_given_delck,
   AdmsSensFadType & modelPar_tr,
   bool modelPar_given_tr,
   AdmsSensFadType & modelPar_vcbar,
   bool modelPar_given_vcbar,
   AdmsSensFadType & modelPar_icbar,
   bool modelPar_given_icbar,
   AdmsSensFadType & modelPar_acbar,
   bool modelPar_given_acbar,
   AdmsSensFadType & modelPar_cbepar,
   bool modelPar_given_cbepar,
   AdmsSensFadType & modelPar_cbcpar,
   bool modelPar_given_cbcpar,
   AdmsSensFadType & modelPar_alqf,
   bool modelPar_given_alqf,
   AdmsSensFadType & modelPar_alit,
   bool modelPar_given_alit,
   AdmsSensFadType & modelPar_kf,
   bool modelPar_given_kf,
   AdmsSensFadType & modelPar_af,
   bool modelPar_given_af,
   AdmsSensFadType & modelPar_kfre,
   bool modelPar_given_kfre,
   AdmsSensFadType & modelPar_afre,
   bool modelPar_given_afre,
   AdmsSensFadType & modelPar_latb,
   bool modelPar_given_latb,
   AdmsSensFadType & modelPar_latl,
   bool modelPar_given_latl,
   AdmsSensFadType & modelPar_vgb,
   bool modelPar_given_vgb,
   AdmsSensFadType & modelPar_alt0,
   bool modelPar_given_alt0,
   AdmsSensFadType & modelPar_kt0,
   bool modelPar_given_kt0,
   AdmsSensFadType & modelPar_zetaci,
   bool modelPar_given_zetaci,
   AdmsSensFadType & modelPar_alvs,
   bool modelPar_given_alvs,
   AdmsSensFadType & modelPar_alces,
   bool modelPar_given_alces,
   AdmsSensFadType & modelPar_zetarbi,
   bool modelPar_given_zetarbi,
   AdmsSensFadType & modelPar_zetarbx,
   bool modelPar_given_zetarbx,
   AdmsSensFadType & modelPar_zetarcx,
   bool modelPar_given_zetarcx,
   AdmsSensFadType & modelPar_zetare,
   bool modelPar_given_zetare,
   AdmsSensFadType & modelPar_zetacx,
   bool modelPar_given_zetacx,
   AdmsSensFadType & modelPar_vge,
   bool modelPar_given_vge,
   AdmsSensFadType & modelPar_vgc,
   bool modelPar_given_vgc,
   AdmsSensFadType & modelPar_vgs,
   bool modelPar_given_vgs,
   AdmsSensFadType & modelPar_f1vg,
   bool modelPar_given_f1vg,
   AdmsSensFadType & modelPar_f2vg,
   bool modelPar_given_f2vg,
   AdmsSensFadType & modelPar_zetact,
   bool modelPar_given_zetact,
   AdmsSensFadType & modelPar_zetabet,
   bool modelPar_given_zetabet,
   AdmsSensFadType & modelPar_alb,
   bool modelPar_given_alb,
   AdmsSensFadType & modelPar_dvgbe,
   bool modelPar_given_dvgbe,
   AdmsSensFadType & modelPar_zetahjei,
   bool modelPar_given_zetahjei,
   AdmsSensFadType & modelPar_zetavgbe,
   bool modelPar_given_zetavgbe,
   AdmsSensFadType & modelPar_rth,
   bool modelPar_given_rth,
   AdmsSensFadType & modelPar_zetarth,
   bool modelPar_given_zetarth,
   AdmsSensFadType & modelPar_alrth,
   bool modelPar_given_alrth,
   AdmsSensFadType & modelPar_cth,
   bool modelPar_given_cth,
   AdmsSensFadType & modelPar_flcomp,
   bool modelPar_given_flcomp,
   AdmsSensFadType & modelPar_tnom,
   bool modelPar_given_tnom,
   AdmsSensFadType & modelPar_dt,
   bool modelPar_given_dt,
   // non-reals (including hidden)
   int modelPar_tunode,
   bool modelPar_given_tunode,
   int modelPar_flnqs,
   bool modelPar_given_flnqs,
   int modelPar_cfbe,
   bool modelPar_given_cfbe,
   int modelPar_flcono,
   bool modelPar_given_flcono,
   int modelPar_flsh,
   bool modelPar_given_flsh,
   int modelPar_type,
   bool modelPar_given_type,
   double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_n2_GND,
   const int admsProbeID_V_n1_GND,
   const int admsProbeID_V_si_s,
   const int admsProbeID_V_bp_e,
   const int admsProbeID_V_b_e,
   const int admsProbeID_V_ci_ei,
   const int admsProbeID_V_xf_GND,
   const int admsProbeID_V_xf2_GND,
   const int admsProbeID_V_xf1_GND,
   const int admsProbeID_V_b_bp,
   const int admsProbeID_V_ci_c,
   const int admsProbeID_V_ei_e,
   const int admsProbeID_V_bp_bi,
   const int admsProbeID_V_tnode_GND,
   const int admsProbeID_V_s_c,
   const int admsProbeID_V_si_ci,
   const int admsProbeID_V_b_ci,
   const int admsProbeID_V_bp_ci,
   const int admsProbeID_V_bp_ei,
   const int admsProbeID_V_bi_ci,
   const int admsProbeID_V_bi_ei,
   // node constants
   const int admsNodeID_c,
   const int admsNodeID_b,
   const int admsNodeID_e,
   const int admsNodeID_s,
   const int admsNodeID_tnode,
   const int admsNodeID_ci,
   const int admsNodeID_ei,
   const int admsNodeID_bp,
   const int admsNodeID_bi,
   const int admsNodeID_si,
   const int admsNodeID_xf1,
   const int admsNodeID_xf2,
   const int admsNodeID_xf,
   const int admsNodeID_n1,
   const int admsNodeID_n2,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_VT,
   AdmsSensFadType & instanceVar_Tdev,
   AdmsSensFadType & instanceVar_qtt0,
   AdmsSensFadType & instanceVar_ln_qtt0,
   AdmsSensFadType & instanceVar_r_VgVT,
   AdmsSensFadType & instanceVar_V_gT,
   AdmsSensFadType & instanceVar_dT,
   AdmsSensFadType & instanceVar_k,
   AdmsSensFadType & instanceVar_ireis_t,
   AdmsSensFadType & instanceVar_ibeis_t,
   AdmsSensFadType & instanceVar_ibcxs_t,
   AdmsSensFadType & instanceVar_ibcis_t,
   AdmsSensFadType & instanceVar_iscs_t,
   AdmsSensFadType & instanceVar_cjci0_t,
   AdmsSensFadType & instanceVar_cjs0_t,
   AdmsSensFadType & instanceVar_cscp0_t,
   AdmsSensFadType & instanceVar_rci0_t,
   AdmsSensFadType & instanceVar_vlim_t,
   AdmsSensFadType & instanceVar_vces_t,
   AdmsSensFadType & instanceVar_thcs_t,
   AdmsSensFadType & instanceVar_tef0_t,
   AdmsSensFadType & instanceVar_rbi0_t,
   AdmsSensFadType & instanceVar_t0_t,
   AdmsSensFadType & instanceVar_vdei_t,
   AdmsSensFadType & instanceVar_vdci_t,
   AdmsSensFadType & instanceVar_vpts_t,
   AdmsSensFadType & instanceVar_vptsp_t,
   AdmsSensFadType & instanceVar_itss_t,
   AdmsSensFadType & instanceVar_tsf_t,
   AdmsSensFadType & instanceVar_c10_t,
   AdmsSensFadType & instanceVar_cjei0_t,
   AdmsSensFadType & instanceVar_qp0_t,
   AdmsSensFadType & instanceVar_vdcx_t,
   AdmsSensFadType & instanceVar_vptcx_t,
   AdmsSensFadType & instanceVar_cjcx01_t,
   AdmsSensFadType & instanceVar_cjcx02_t,
   AdmsSensFadType & instanceVar_cratio_t,
   AdmsSensFadType & instanceVar_ibeps_t,
   AdmsSensFadType & instanceVar_ireps_t,
   AdmsSensFadType & instanceVar_cjep0_t,
   AdmsSensFadType & instanceVar_ajei_t,
   AdmsSensFadType & instanceVar_qavl_t,
   AdmsSensFadType & instanceVar_favl_t,
   AdmsSensFadType & instanceVar_kavl_t,
   AdmsSensFadType & instanceVar_ibets_t,
   AdmsSensFadType & instanceVar_abet_t,
   AdmsSensFadType & instanceVar_vptci_t,
   AdmsSensFadType & instanceVar_vdep_t,
   AdmsSensFadType & instanceVar_ajep_t,
   AdmsSensFadType & instanceVar_zetatef,
   AdmsSensFadType & instanceVar_k1,
   AdmsSensFadType & instanceVar_k2,
   AdmsSensFadType & instanceVar_dvg0,
   AdmsSensFadType & instanceVar_vge_t,
   AdmsSensFadType & instanceVar_vgb_t,
   AdmsSensFadType & instanceVar_vgbe_t,
   AdmsSensFadType & instanceVar_vds_t,
   AdmsSensFadType & instanceVar_vdsp_t,
   AdmsSensFadType & instanceVar_vt0,
   AdmsSensFadType & instanceVar_Tnom,
   AdmsSensFadType & instanceVar_Tamb,
   AdmsSensFadType & instanceVar_a,
   AdmsSensFadType & instanceVar_avs,
   AdmsSensFadType & instanceVar_zetabci,
   AdmsSensFadType & instanceVar_zetabcxt,
   AdmsSensFadType & instanceVar_zetasct,
   AdmsSensFadType & instanceVar_vgbe0,
   AdmsSensFadType & instanceVar_mg,
   AdmsSensFadType & instanceVar_vgbe_t0,
   AdmsSensFadType & instanceVar_vgbc0,
   AdmsSensFadType & instanceVar_vgsc0,
   AdmsSensFadType & instanceVar_cbcpar1,
   AdmsSensFadType & instanceVar_cbcpar2,
   AdmsSensFadType & instanceVar_cbepar2,
   AdmsSensFadType & instanceVar_cbepar1,
   AdmsSensFadType & instanceVar_Oich,
   AdmsSensFadType & instanceVar_Otbhrec,
   AdmsSensFadType & instanceVar_it,
   AdmsSensFadType & instanceVar_ibei,
   AdmsSensFadType & instanceVar_ibci,
   AdmsSensFadType & instanceVar_ibep,
   AdmsSensFadType & instanceVar_iavl,
   AdmsSensFadType & instanceVar_ijbcx,
   AdmsSensFadType & instanceVar_ijsc,
   AdmsSensFadType & instanceVar_rth_t,
   AdmsSensFadType & instanceVar_vdj0,
   AdmsSensFadType & instanceVar_vdjt,
   AdmsSensFadType & instanceVar_vdt,
   AdmsSensFadType & instanceVar_Tf,
   AdmsSensFadType & instanceVar_cjcx01,
   AdmsSensFadType & instanceVar_cjcx02,
   AdmsSensFadType & instanceVar_betadc,
   AdmsSensFadType & instanceVar_hjei0_t,
   AdmsSensFadType & instanceVar_ahjei_t,
   AdmsSensFadType & instanceVar_hf0_t,
   AdmsSensFadType & instanceVar_hfe_t,
   AdmsSensFadType & instanceVar_hfc_t,
   AdmsSensFadType & instanceVar_rbx_t,
   AdmsSensFadType & instanceVar_rcx_t,
   AdmsSensFadType & instanceVar_re_t,
   AdmsSensFadType & instanceVar_rbi,
   // non-reals
   int instanceVar_use_aval,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_c10,
   bool modelPar_given_c10,
   AdmsSensFadType & modelPar_qp0,
   bool modelPar_given_qp0,
   AdmsSensFadType & modelPar_ich,
   bool modelPar_given_ich,
   AdmsSensFadType & modelPar_hf0,
   bool modelPar_given_hf0,
   AdmsSensFadType & modelPar_hfe,
   bool modelPar_given_hfe,
   AdmsSensFadType & modelPar_hfc,
   bool modelPar_given_hfc,
   AdmsSensFadType & modelPar_hjei,
   bool modelPar_given_hjei,
   AdmsSensFadType & modelPar_ahjei,
   bool modelPar_given_ahjei,
   AdmsSensFadType & modelPar_rhjei,
   bool modelPar_given_rhjei,
   AdmsSensFadType & modelPar_hjci,
   bool modelPar_given_hjci,
   AdmsSensFadType & modelPar_ibeis,
   bool modelPar_given_ibeis,
   AdmsSensFadType & modelPar_mbei,
   bool modelPar_given_mbei,
   AdmsSensFadType & modelPar_ireis,
   bool modelPar_given_ireis,
   AdmsSensFadType & modelPar_mrei,
   bool modelPar_given_mrei,
   AdmsSensFadType & modelPar_ibeps,
   bool modelPar_given_ibeps,
   AdmsSensFadType & modelPar_mbep,
   bool modelPar_given_mbep,
   AdmsSensFadType & modelPar_ireps,
   bool modelPar_given_ireps,
   AdmsSensFadType & modelPar_mrep,
   bool modelPar_given_mrep,
   AdmsSensFadType & modelPar_mcf,
   bool modelPar_given_mcf,
   AdmsSensFadType & modelPar_tbhrec,
   bool modelPar_given_tbhrec,
   AdmsSensFadType & modelPar_ibcis,
   bool modelPar_given_ibcis,
   AdmsSensFadType & modelPar_mbci,
   bool modelPar_given_mbci,
   AdmsSensFadType & modelPar_ibcxs,
   bool modelPar_given_ibcxs,
   AdmsSensFadType & modelPar_mbcx,
   bool modelPar_given_mbcx,
   AdmsSensFadType & modelPar_ibets,
   bool modelPar_given_ibets,
   AdmsSensFadType & modelPar_abet,
   bool modelPar_given_abet,
   AdmsSensFadType & modelPar_favl,
   bool modelPar_given_favl,
   AdmsSensFadType & modelPar_qavl,
   bool modelPar_given_qavl,
   AdmsSensFadType & modelPar_kavl,
   bool modelPar_given_kavl,
   AdmsSensFadType & modelPar_alfav,
   bool modelPar_given_alfav,
   AdmsSensFadType & modelPar_alqav,
   bool modelPar_given_alqav,
   AdmsSensFadType & modelPar_alkav,
   bool modelPar_given_alkav,
   AdmsSensFadType & modelPar_rbi0,
   bool modelPar_given_rbi0,
   AdmsSensFadType & modelPar_rbx,
   bool modelPar_given_rbx,
   AdmsSensFadType & modelPar_fgeo,
   bool modelPar_given_fgeo,
   AdmsSensFadType & modelPar_fdqr0,
   bool modelPar_given_fdqr0,
   AdmsSensFadType & modelPar_fcrbi,
   bool modelPar_given_fcrbi,
   AdmsSensFadType & modelPar_fqi,
   bool modelPar_given_fqi,
   AdmsSensFadType & modelPar_re,
   bool modelPar_given_re,
   AdmsSensFadType & modelPar_rcx,
   bool modelPar_given_rcx,
   AdmsSensFadType & modelPar_itss,
   bool modelPar_given_itss,
   AdmsSensFadType & modelPar_msf,
   bool modelPar_given_msf,
   AdmsSensFadType & modelPar_iscs,
   bool modelPar_given_iscs,
   AdmsSensFadType & modelPar_msc,
   bool modelPar_given_msc,
   AdmsSensFadType & modelPar_tsf,
   bool modelPar_given_tsf,
   AdmsSensFadType & modelPar_rsu,
   bool modelPar_given_rsu,
   AdmsSensFadType & modelPar_csu,
   bool modelPar_given_csu,
   AdmsSensFadType & modelPar_cjei0,
   bool modelPar_given_cjei0,
   AdmsSensFadType & modelPar_vdei,
   bool modelPar_given_vdei,
   AdmsSensFadType & modelPar_zei,
   bool modelPar_given_zei,
   AdmsSensFadType & modelPar_ajei,
   bool modelPar_given_ajei,
   AdmsSensFadType & modelPar_cjep0,
   bool modelPar_given_cjep0,
   AdmsSensFadType & modelPar_vdep,
   bool modelPar_given_vdep,
   AdmsSensFadType & modelPar_zep,
   bool modelPar_given_zep,
   AdmsSensFadType & modelPar_ajep,
   bool modelPar_given_ajep,
   AdmsSensFadType & modelPar_cjci0,
   bool modelPar_given_cjci0,
   AdmsSensFadType & modelPar_vdci,
   bool modelPar_given_vdci,
   AdmsSensFadType & modelPar_zci,
   bool modelPar_given_zci,
   AdmsSensFadType & modelPar_vptci,
   bool modelPar_given_vptci,
   AdmsSensFadType & modelPar_cjcx0,
   bool modelPar_given_cjcx0,
   AdmsSensFadType & modelPar_vdcx,
   bool modelPar_given_vdcx,
   AdmsSensFadType & modelPar_zcx,
   bool modelPar_given_zcx,
   AdmsSensFadType & modelPar_vptcx,
   bool modelPar_given_vptcx,
   AdmsSensFadType & modelPar_fbcpar,
   bool modelPar_given_fbcpar,
   AdmsSensFadType & modelPar_fbepar,
   bool modelPar_given_fbepar,
   AdmsSensFadType & modelPar_cjs0,
   bool modelPar_given_cjs0,
   AdmsSensFadType & modelPar_vds,
   bool modelPar_given_vds,
   AdmsSensFadType & modelPar_zs,
   bool modelPar_given_zs,
   AdmsSensFadType & modelPar_vpts,
   bool modelPar_given_vpts,
   AdmsSensFadType & modelPar_cscp0,
   bool modelPar_given_cscp0,
   AdmsSensFadType & modelPar_vdsp,
   bool modelPar_given_vdsp,
   AdmsSensFadType & modelPar_zsp,
   bool modelPar_given_zsp,
   AdmsSensFadType & modelPar_vptsp,
   bool modelPar_given_vptsp,
   AdmsSensFadType & modelPar_t0,
   bool modelPar_given_t0,
   AdmsSensFadType & modelPar_dt0h,
   bool modelPar_given_dt0h,
   AdmsSensFadType & modelPar_tbvl,
   bool modelPar_given_tbvl,
   AdmsSensFadType & modelPar_tef0,
   bool modelPar_given_tef0,
   AdmsSensFadType & modelPar_gtfe,
   bool modelPar_given_gtfe,
   AdmsSensFadType & modelPar_thcs,
   bool modelPar_given_thcs,
   AdmsSensFadType & modelPar_ahc,
   bool modelPar_given_ahc,
   AdmsSensFadType & modelPar_fthc,
   bool modelPar_given_fthc,
   AdmsSensFadType & modelPar_rci0,
   bool modelPar_given_rci0,
   AdmsSensFadType & modelPar_vlim,
   bool modelPar_given_vlim,
   AdmsSensFadType & modelPar_vces,
   bool modelPar_given_vces,
   AdmsSensFadType & modelPar_vpt,
   bool modelPar_given_vpt,
   AdmsSensFadType & modelPar_aick,
   bool modelPar_given_aick,
   AdmsSensFadType & modelPar_delck,
   bool modelPar_given_delck,
   AdmsSensFadType & modelPar_tr,
   bool modelPar_given_tr,
   AdmsSensFadType & modelPar_vcbar,
   bool modelPar_given_vcbar,
   AdmsSensFadType & modelPar_icbar,
   bool modelPar_given_icbar,
   AdmsSensFadType & modelPar_acbar,
   bool modelPar_given_acbar,
   AdmsSensFadType & modelPar_cbepar,
   bool modelPar_given_cbepar,
   AdmsSensFadType & modelPar_cbcpar,
   bool modelPar_given_cbcpar,
   AdmsSensFadType & modelPar_alqf,
   bool modelPar_given_alqf,
   AdmsSensFadType & modelPar_alit,
   bool modelPar_given_alit,
   AdmsSensFadType & modelPar_kf,
   bool modelPar_given_kf,
   AdmsSensFadType & modelPar_af,
   bool modelPar_given_af,
   AdmsSensFadType & modelPar_kfre,
   bool modelPar_given_kfre,
   AdmsSensFadType & modelPar_afre,
   bool modelPar_given_afre,
   AdmsSensFadType & modelPar_latb,
   bool modelPar_given_latb,
   AdmsSensFadType & modelPar_latl,
   bool modelPar_given_latl,
   AdmsSensFadType & modelPar_vgb,
   bool modelPar_given_vgb,
   AdmsSensFadType & modelPar_alt0,
   bool modelPar_given_alt0,
   AdmsSensFadType & modelPar_kt0,
   bool modelPar_given_kt0,
   AdmsSensFadType & modelPar_zetaci,
   bool modelPar_given_zetaci,
   AdmsSensFadType & modelPar_alvs,
   bool modelPar_given_alvs,
   AdmsSensFadType & modelPar_alces,
   bool modelPar_given_alces,
   AdmsSensFadType & modelPar_zetarbi,
   bool modelPar_given_zetarbi,
   AdmsSensFadType & modelPar_zetarbx,
   bool modelPar_given_zetarbx,
   AdmsSensFadType & modelPar_zetarcx,
   bool modelPar_given_zetarcx,
   AdmsSensFadType & modelPar_zetare,
   bool modelPar_given_zetare,
   AdmsSensFadType & modelPar_zetacx,
   bool modelPar_given_zetacx,
   AdmsSensFadType & modelPar_vge,
   bool modelPar_given_vge,
   AdmsSensFadType & modelPar_vgc,
   bool modelPar_given_vgc,
   AdmsSensFadType & modelPar_vgs,
   bool modelPar_given_vgs,
   AdmsSensFadType & modelPar_f1vg,
   bool modelPar_given_f1vg,
   AdmsSensFadType & modelPar_f2vg,
   bool modelPar_given_f2vg,
   AdmsSensFadType & modelPar_zetact,
   bool modelPar_given_zetact,
   AdmsSensFadType & modelPar_zetabet,
   bool modelPar_given_zetabet,
   AdmsSensFadType & modelPar_alb,
   bool modelPar_given_alb,
   AdmsSensFadType & modelPar_dvgbe,
   bool modelPar_given_dvgbe,
   AdmsSensFadType & modelPar_zetahjei,
   bool modelPar_given_zetahjei,
   AdmsSensFadType & modelPar_zetavgbe,
   bool modelPar_given_zetavgbe,
   AdmsSensFadType & modelPar_rth,
   bool modelPar_given_rth,
   AdmsSensFadType & modelPar_zetarth,
   bool modelPar_given_zetarth,
   AdmsSensFadType & modelPar_alrth,
   bool modelPar_given_alrth,
   AdmsSensFadType & modelPar_cth,
   bool modelPar_given_cth,
   AdmsSensFadType & modelPar_flcomp,
   bool modelPar_given_flcomp,
   AdmsSensFadType & modelPar_tnom,
   bool modelPar_given_tnom,
   AdmsSensFadType & modelPar_dt,
   bool modelPar_given_dt,
   // non-reals (including hidden)
   int modelPar_tunode,
   bool modelPar_given_tunode,
   int modelPar_flnqs,
   bool modelPar_given_flnqs,
   int modelPar_cfbe,
   bool modelPar_given_cfbe,
   int modelPar_flcono,
   bool modelPar_given_flcono,
   int modelPar_flsh,
   bool modelPar_given_flsh,
   int modelPar_type,
   bool modelPar_given_type,
   // basic variables
   double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  AdmsSensFadType fourkt;
  AdmsSensFadType flicker_Pwr;
  AdmsSensFadType i_re;
  double twoq;
  double n_w;
  AdmsSensFadType n_1;
  AdmsSensFadType sqrt_n2;
  AdmsSensFadType n_2;
  AdmsSensFadType DIOY;
  AdmsSensFadType le;
  AdmsSensFadType irei;
  AdmsSensFadType Orci0_t;
  AdmsSensFadType Tr;
  AdmsSensFadType VT_f;
  AdmsSensFadType i_0f;
  AdmsSensFadType i_0r;
  AdmsSensFadType DFV_f;
  AdmsSensFadType DFv_e;
  AdmsSensFadType DFs_q;
  AdmsSensFadType DFs_q2;
  AdmsSensFadType DFv_j;
  AdmsSensFadType DFdvj_dv;
  AdmsSensFadType DFb;
  AdmsSensFadType DFC_j1;
  AdmsSensFadType Cjei;
  AdmsSensFadType DFQ_j;
  AdmsSensFadType Qjei;
  AdmsSensFadType vj;
  AdmsSensFadType vj_z;
  AdmsSensFadType hjei_vbe;
  AdmsSensFadType Dz_r;
  AdmsSensFadType Dv_p;
  AdmsSensFadType DV_f;
  AdmsSensFadType DC_max;
  AdmsSensFadType DC_c;
  AdmsSensFadType Dv_e;
  AdmsSensFadType De;
  AdmsSensFadType De_1;
  AdmsSensFadType Dv_j1;
  AdmsSensFadType Da;
  AdmsSensFadType Dv_r;
  AdmsSensFadType De_2;
  AdmsSensFadType Dv_j2;
  AdmsSensFadType Dv_j4;
  AdmsSensFadType DCln1;
  AdmsSensFadType DCln2;
  AdmsSensFadType Dz1;
  AdmsSensFadType Dzr1;
  AdmsSensFadType DC_j1;
  AdmsSensFadType DC_j2;
  AdmsSensFadType DC_j3;
  AdmsSensFadType Cjci;
  AdmsSensFadType DQ_j1;
  AdmsSensFadType DQ_j2;
  AdmsSensFadType DQ_j3;
  AdmsSensFadType Qjci;
  double a_bpt;
  AdmsSensFadType Q_0;
  AdmsSensFadType Q_bpt;
  AdmsSensFadType b_q;
  AdmsSensFadType Cjcit;
  AdmsSensFadType cc;
  AdmsSensFadType T_f0;
  AdmsSensFadType vc;
  AdmsSensFadType ick;
  AdmsSensFadType ICKa;
  AdmsSensFadType ick2;
  AdmsSensFadType ick1;
  AdmsSensFadType Odelck;
  AdmsSensFadType a11;
  AdmsSensFadType a1;
  AdmsSensFadType vceff;
  AdmsSensFadType d1;
  AdmsSensFadType Ovpt;
  AdmsSensFadType Q_p;
  AdmsSensFadType A;
  AdmsSensFadType I_Tf1;
  AdmsSensFadType a_h;
  AdmsSensFadType itf;
  AdmsSensFadType itr;
  AdmsSensFadType Q_bf;
  AdmsSensFadType Qf;
  AdmsSensFadType FFitf_ick;
  AdmsSensFadType FFdTef;
  AdmsSensFadType FFdQef;
  AdmsSensFadType FFib;
  AdmsSensFadType FFfcbar;
  AdmsSensFadType FFdib_ditf;
  AdmsSensFadType FFdVc;
  AdmsSensFadType FFdVc_ditf;
  AdmsSensFadType FFdQbfb;
  AdmsSensFadType FFdTbfb;
  AdmsSensFadType FFic;
  AdmsSensFadType FFw;
  AdmsSensFadType FFdQfhc;
  AdmsSensFadType FFdTfhc;
  AdmsSensFadType FCa;
  AdmsSensFadType FCrt;
  AdmsSensFadType FCa_ck;
  AdmsSensFadType FCdaick_ditf;
  AdmsSensFadType FCz_1;
  AdmsSensFadType FCd_f;
  AdmsSensFadType FCz;
  AdmsSensFadType FCxl;
  AdmsSensFadType FCxb;
  AdmsSensFadType FCf1;
  AdmsSensFadType FCln;
  AdmsSensFadType FCa1;
  AdmsSensFadType FCd_a;
  AdmsSensFadType FCw;
  AdmsSensFadType FCdw_daick;
  AdmsSensFadType FCda1_dw;
  AdmsSensFadType FCf_CT;
  AdmsSensFadType FCw2;
  AdmsSensFadType FCdf1_dw;
  AdmsSensFadType z;
  AdmsSensFadType lnzb;
  AdmsSensFadType x;
  AdmsSensFadType a2;
  AdmsSensFadType a3;
  AdmsSensFadType r;
  AdmsSensFadType FCf2;
  AdmsSensFadType FCdf2_dw;
  AdmsSensFadType FCf3;
  AdmsSensFadType FCdf3_dw;
  AdmsSensFadType FCf_ci;
  AdmsSensFadType FCdfc_dw;
  AdmsSensFadType FCdw_ditf;
  AdmsSensFadType FCdfc_ditf;
  AdmsSensFadType lnz;
  AdmsSensFadType FCdfCT_dw;
  AdmsSensFadType FCdfCT_ditf;
  AdmsSensFadType FFdQcfc;
  AdmsSensFadType FFdTcfc;
  AdmsSensFadType FFdQcfcT;
  AdmsSensFadType FFdTcfcT;
  AdmsSensFadType FFdQbfc;
  AdmsSensFadType FFdTbfc;
  AdmsSensFadType Q_fT;
  AdmsSensFadType T_fT;
  AdmsSensFadType Qr;
  int l_it;
  AdmsSensFadType Q_pT;
  AdmsSensFadType d_Q;
  AdmsSensFadType d_Q0;
  AdmsSensFadType Qdei;
  AdmsSensFadType Qdci;
  AdmsSensFadType Cdei;
  AdmsSensFadType Cdci;
  AdmsSensFadType Crbi;
  AdmsSensFadType qrbi;
  AdmsSensFadType ibh_rec;
  AdmsSensFadType irep;
  AdmsSensFadType Cjep;
  AdmsSensFadType Qjep;
  AdmsSensFadType ibet;
  AdmsSensFadType CjCx_ii;
  AdmsSensFadType qjcx0_t_ii;
  AdmsSensFadType CjCx_i;
  AdmsSensFadType qjcx0_t_i;
  AdmsSensFadType Cjs;
  AdmsSensFadType Qjs;
  AdmsSensFadType Cscp;
  AdmsSensFadType Qscp;
  AdmsSensFadType HSUM;
  AdmsSensFadType HSa;
  AdmsSensFadType HSb;
  AdmsSensFadType HSI_Tsu;
  AdmsSensFadType Qdsu;
  AdmsSensFadType pterm;
  AdmsSensFadType Itxf;
  AdmsSensFadType Qdeix;
  double Vxf1;
  double Vxf2;
  AdmsSensFadType Ixf1;
  AdmsSensFadType Ixf2;
  AdmsSensFadType Qxf1;
  AdmsSensFadType Qxf2;
  double Vxf;
  AdmsSensFadType fact;
  AdmsSensFadType Ixf;
  AdmsSensFadType Qxf;
  AdmsSensFadType Vsc;
  AdmsSensFadType Vsici;
  AdmsSensFadType Vbci;
  AdmsSensFadType Vbpci;
  AdmsSensFadType Vbpei;
  AdmsSensFadType Vciei;
  AdmsSensFadType Vbici;
  AdmsSensFadType Vbiei;


  // -- code converted from analog/code block
  Vbiei = (modelPar_type*(probeVars[admsProbeID_V_bi_ei]));
  Vbici = (modelPar_type*(probeVars[admsProbeID_V_bi_ci]));
  Vciei = (Vbiei-Vbici);
  Vbpei = (modelPar_type*(probeVars[admsProbeID_V_bp_ei]));
  Vbpci = (modelPar_type*(probeVars[admsProbeID_V_bp_ci]));
  Vbci = (modelPar_type*(probeVars[admsProbeID_V_b_ci]));
  Vsici = (modelPar_type*(probeVars[admsProbeID_V_si_ci]));
  Vsc = (modelPar_type*(probeVars[admsProbeID_V_s_c]));
  if (((modelPar_flsh!=0)&&(modelPar_rth>=0.001)))
    //Begin block Thermal_update_with_self_heating
  {
    instanceVar_Tdev = ((instanceVar_Tamb+modelPar_dt)+(probeVars[admsProbeID_V_tnode_GND]));
    if ((instanceVar_Tdev<((-100.0)+273.15)))
    {
      instanceVar_Tdev = ((-100.0)+273.15);
    }
    else
    {
      if ((instanceVar_Tdev>(326.85+273.15)))
      {
        instanceVar_Tdev = (326.85+273.15);
      }
    }
    instanceVar_VT = ((1.3806503e-23*instanceVar_Tdev)/1.6021766208e-19);
    instanceVar_dT = (instanceVar_Tdev-instanceVar_Tnom);
    instanceVar_qtt0 = (instanceVar_Tdev/instanceVar_Tnom);
    {
      AdmsSensFadType value_log_0 = log(instanceVar_qtt0);
      instanceVar_ln_qtt0 = value_log_0;
    }
    {
      AdmsSensFadType value_log_0 = log(instanceVar_Tdev);
      instanceVar_k1 = ((modelPar_f1vg*instanceVar_Tdev)*value_log_0);
    }
    instanceVar_k2 = (modelPar_f2vg*instanceVar_Tdev);
    instanceVar_vgb_t = ((modelPar_vgb+instanceVar_k1)+instanceVar_k2);
    instanceVar_vge_t = ((modelPar_vge+instanceVar_k1)+instanceVar_k2);
    instanceVar_vgbe_t = ((instanceVar_vgb_t+instanceVar_vge_t)/2);
    if ((modelPar_cjei0>0.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp(((modelPar_vdei*0.5)/instanceVar_vt0));
        AdmsSensFadType value_exp_1 = exp((((-0.5)*modelPar_vdei)/instanceVar_vt0));
        AdmsSensFadType value_log_2 = log((value_exp_0-value_exp_1));
        instanceVar_vdj0 = ((2*instanceVar_vt0)*value_log_2);
      }
      instanceVar_vdjt = (((instanceVar_vdj0*instanceVar_qtt0)+(instanceVar_vgbe0*(1-instanceVar_qtt0)))-((instanceVar_mg*instanceVar_VT)*instanceVar_ln_qtt0));
      {
        AdmsSensFadType value_exp_0 = exp(((-instanceVar_vdjt)/instanceVar_VT));
        AdmsSensFadType value_sqrt_1 = sqrt((1+(4*value_exp_0)));
        AdmsSensFadType value_log_2 = log((0.5*(1+value_sqrt_1)));
        instanceVar_vdt = (instanceVar_vdjt+((2*instanceVar_VT)*value_log_2));
      }
      instanceVar_vdei_t = instanceVar_vdt;
      {
        AdmsSensFadType value_log_0 = log((modelPar_vdei/instanceVar_vdei_t));
        AdmsSensFadType value_exp_1 = exp((modelPar_zei*value_log_0));
        instanceVar_cjei0_t = (modelPar_cjei0*value_exp_1);
      }
      if ((1==1))
      {
        instanceVar_ajei_t = ((modelPar_ajei*instanceVar_vdei_t)/modelPar_vdei);
      }
      else
      {
        instanceVar_ajei_t = modelPar_ajei;
      }
    }
    else
    {
      instanceVar_cjei0_t = modelPar_cjei0;
      instanceVar_vdei_t = modelPar_vdei;
      instanceVar_ajei_t = modelPar_ajei;
    }
    if (((modelPar_flcomp==0.0)||(modelPar_flcomp==2.1)))
    {
      instanceVar_V_gT = (((3.0*instanceVar_VT)*instanceVar_ln_qtt0)+(modelPar_vgb*(instanceVar_qtt0-1.0)));
      instanceVar_r_VgVT = (instanceVar_V_gT/instanceVar_VT);
      instanceVar_a = (((modelPar_mcf*instanceVar_r_VgVT)/modelPar_mbei)-(modelPar_alb*instanceVar_dT));
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_a);
        instanceVar_ibeis_t = (modelPar_ibeis*value_exp_0);
      }
      instanceVar_a = (((modelPar_mcf*instanceVar_r_VgVT)/modelPar_mrei)-(modelPar_alb*instanceVar_dT));
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_a);
        instanceVar_ireis_t = (modelPar_ireis*value_exp_0);
      }
      instanceVar_a = (((modelPar_mcf*instanceVar_r_VgVT)/modelPar_mbep)-(modelPar_alb*instanceVar_dT));
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_a);
        instanceVar_ibeps_t = (modelPar_ibeps*value_exp_0);
      }
      instanceVar_a = (((modelPar_mcf*instanceVar_r_VgVT)/modelPar_mrep)-(modelPar_alb*instanceVar_dT));
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_a);
        instanceVar_ireps_t = (modelPar_ireps*value_exp_0);
      }
      instanceVar_a = (instanceVar_r_VgVT/modelPar_mbci);
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_a);
        instanceVar_ibcis_t = (modelPar_ibcis*value_exp_0);
      }
      instanceVar_a = (instanceVar_r_VgVT/modelPar_mbcx);
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_a);
        instanceVar_ibcxs_t = (modelPar_ibcxs*value_exp_0);
      }
      instanceVar_a = (instanceVar_r_VgVT/modelPar_msf);
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_a);
        instanceVar_itss_t = (modelPar_itss*value_exp_0);
      }
      instanceVar_a = (instanceVar_r_VgVT/modelPar_msc);
      {
        AdmsSensFadType value_exp_0 = exp(instanceVar_a);
        instanceVar_iscs_t = (modelPar_iscs*value_exp_0);
      }
      instanceVar_a = (instanceVar_vdei_t/modelPar_vdei);
      instanceVar_qp0_t = (modelPar_qp0*(1.0+((0.5*modelPar_zei)*(1.0-instanceVar_a))));
      {
        AdmsSensFadType value_exp_0 = exp((modelPar_zetaci*instanceVar_ln_qtt0));
        instanceVar_a = ((modelPar_vlim*(1.0-(modelPar_alvs*instanceVar_dT)))*value_exp_0);
      }
      instanceVar_k = ((instanceVar_a-instanceVar_VT)/instanceVar_VT);
      if ((instanceVar_k<11.0))
      {
        {
          AdmsSensFadType value_exp_0 = exp(instanceVar_k);
          AdmsSensFadType value_log_1 = log((1.0+value_exp_0));
          instanceVar_vlim_t = (instanceVar_VT+(instanceVar_VT*value_log_1));
        }
      }
      else
      {
        instanceVar_vlim_t = instanceVar_a;
      }
      instanceVar_a = (1.0+(modelPar_alb*instanceVar_dT));
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((instanceVar_a*instanceVar_a)+0.01));
        instanceVar_k = (0.5*(instanceVar_a+value_sqrt_0));
      }
      instanceVar_tef0_t = ((modelPar_tef0*instanceVar_qtt0)/instanceVar_k);
    }
    else
    {
      {
        AdmsSensFadType value_exp_0 = exp(((modelPar_zetabet*instanceVar_ln_qtt0)+((modelPar_vge/instanceVar_VT)*(instanceVar_qtt0-1))));
        instanceVar_ibeis_t = (modelPar_ibeis*value_exp_0);
      }
      if ((modelPar_flcomp>=2.3))
      {
        {
          AdmsSensFadType value_exp_0 = exp((((instanceVar_mg/modelPar_mrei)*instanceVar_ln_qtt0)+((instanceVar_vgbe0/(modelPar_mrei*instanceVar_VT))*(instanceVar_qtt0-1))));
          instanceVar_ireis_t = (modelPar_ireis*value_exp_0);
        }
      }
      else
      {
        {
          AdmsSensFadType value_exp_0 = exp((((0.5*instanceVar_mg)*instanceVar_ln_qtt0)+(((0.5*instanceVar_vgbe0)/instanceVar_VT)*(instanceVar_qtt0-1))));
          instanceVar_ireis_t = (modelPar_ireis*value_exp_0);
        }
      }
      {
        AdmsSensFadType value_exp_0 = exp(((modelPar_zetabet*instanceVar_ln_qtt0)+((modelPar_vge/instanceVar_VT)*(instanceVar_qtt0-1))));
        instanceVar_ibeps_t = (modelPar_ibeps*value_exp_0);
      }
      if ((modelPar_flcomp>=2.3))
      {
        {
          AdmsSensFadType value_exp_0 = exp((((instanceVar_mg/modelPar_mrep)*instanceVar_ln_qtt0)+((instanceVar_vgbe0/(modelPar_mrep*instanceVar_VT))*(instanceVar_qtt0-1))));
          instanceVar_ireps_t = (modelPar_ireps*value_exp_0);
        }
      }
      else
      {
        {
          AdmsSensFadType value_exp_0 = exp((((0.5*instanceVar_mg)*instanceVar_ln_qtt0)+(((0.5*instanceVar_vgbe0)/instanceVar_VT)*(instanceVar_qtt0-1))));
          instanceVar_ireps_t = (modelPar_ireps*value_exp_0);
        }
      }
      {
        AdmsSensFadType value_exp_0 = exp(((instanceVar_zetabci*instanceVar_ln_qtt0)+((modelPar_vgc/instanceVar_VT)*(instanceVar_qtt0-1))));
        instanceVar_ibcis_t = (modelPar_ibcis*value_exp_0);
      }
      {
        AdmsSensFadType value_exp_0 = exp(((instanceVar_zetabcxt*instanceVar_ln_qtt0)+((modelPar_vgc/instanceVar_VT)*(instanceVar_qtt0-1))));
        instanceVar_ibcxs_t = (modelPar_ibcxs*value_exp_0);
      }
      {
        AdmsSensFadType value_exp_0 = exp(((instanceVar_zetasct*instanceVar_ln_qtt0)+((modelPar_vgc/instanceVar_VT)*(instanceVar_qtt0-1))));
        instanceVar_itss_t = (modelPar_itss*value_exp_0);
      }
      {
        AdmsSensFadType value_exp_0 = exp(((instanceVar_zetasct*instanceVar_ln_qtt0)+((modelPar_vgs/instanceVar_VT)*(instanceVar_qtt0-1))));
        instanceVar_iscs_t = (modelPar_iscs*value_exp_0);
      }
      {
        AdmsSensFadType value_log_0 = log((instanceVar_vdei_t/modelPar_vdei));
        AdmsSensFadType value_exp_1 = exp((modelPar_zei*value_log_0));
        instanceVar_a = value_exp_1;
      }
      instanceVar_qp0_t = (modelPar_qp0*(2.0-instanceVar_a));
      {
        AdmsSensFadType value_exp_0 = exp(((modelPar_zetaci-instanceVar_avs)*instanceVar_ln_qtt0));
        instanceVar_vlim_t = (modelPar_vlim*value_exp_0);
      }
      if ((modelPar_flcomp>=2.3))
      {
        instanceVar_tef0_t = modelPar_tef0;
      }
      else
      {
        instanceVar_zetatef = ((modelPar_zetabet-modelPar_zetact)-0.5);
        instanceVar_dvg0 = (modelPar_vgb-modelPar_vge);
        {
          AdmsSensFadType value_exp_0 = exp(((instanceVar_zetatef*instanceVar_ln_qtt0)-((instanceVar_dvg0/instanceVar_VT)*(instanceVar_qtt0-1))));
          instanceVar_tef0_t = (modelPar_tef0*value_exp_0);
        }
      }
    }
    {
      AdmsSensFadType value_exp_0 = exp(((modelPar_zetact*instanceVar_ln_qtt0)+((modelPar_vgb/instanceVar_VT)*(instanceVar_qtt0-1))));
      instanceVar_c10_t = (modelPar_c10*value_exp_0);
    }
    {
      AdmsSensFadType value_exp_0 = exp((modelPar_zetaci*instanceVar_ln_qtt0));
      instanceVar_rci0_t = (modelPar_rci0*value_exp_0);
    }
    instanceVar_vces_t = (modelPar_vces*(1+(modelPar_alces*instanceVar_dT)));
    if ((modelPar_cjci0>0.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp(((modelPar_vdci*0.5)/instanceVar_vt0));
        AdmsSensFadType value_exp_1 = exp((((-0.5)*modelPar_vdci)/instanceVar_vt0));
        AdmsSensFadType value_log_2 = log((value_exp_0-value_exp_1));
        instanceVar_vdj0 = ((2*instanceVar_vt0)*value_log_2);
      }
      instanceVar_vdjt = (((instanceVar_vdj0*instanceVar_qtt0)+(instanceVar_vgbc0*(1-instanceVar_qtt0)))-((instanceVar_mg*instanceVar_VT)*instanceVar_ln_qtt0));
      {
        AdmsSensFadType value_exp_0 = exp(((-instanceVar_vdjt)/instanceVar_VT));
        AdmsSensFadType value_sqrt_1 = sqrt((1+(4*value_exp_0)));
        AdmsSensFadType value_log_2 = log((0.5*(1+value_sqrt_1)));
        instanceVar_vdt = (instanceVar_vdjt+((2*instanceVar_VT)*value_log_2));
      }
      instanceVar_vdci_t = instanceVar_vdt;
      {
        AdmsSensFadType value_log_0 = log((modelPar_vdci/instanceVar_vdci_t));
        AdmsSensFadType value_exp_1 = exp((modelPar_zci*value_log_0));
        instanceVar_cjci0_t = (modelPar_cjci0*value_exp_1);
      }
      if ((0==1))
      {
        instanceVar_vptci_t = ((modelPar_vptci*instanceVar_vdci_t)/modelPar_vdci);
      }
      else
      {
        instanceVar_vptci_t = modelPar_vptci;
      }
    }
    else
    {
      instanceVar_cjci0_t = modelPar_cjci0;
      instanceVar_vdci_t = modelPar_vdci;
      instanceVar_vptci_t = modelPar_vptci;
    }
    instanceVar_t0_t = (modelPar_t0*((1+(modelPar_alt0*instanceVar_dT))+((modelPar_kt0*instanceVar_dT)*instanceVar_dT)));
    {
      AdmsSensFadType value_exp_0 = exp(((modelPar_zetaci-1)*instanceVar_ln_qtt0));
      instanceVar_thcs_t = (modelPar_thcs*value_exp_0);
    }
    {
      AdmsSensFadType value_exp_0 = exp((modelPar_alfav*instanceVar_dT));
      instanceVar_favl_t = (modelPar_favl*value_exp_0);
    }
    {
      AdmsSensFadType value_exp_0 = exp((modelPar_alqav*instanceVar_dT));
      instanceVar_qavl_t = (modelPar_qavl*value_exp_0);
    }
    {
      AdmsSensFadType value_exp_0 = exp((modelPar_alkav*instanceVar_dT));
      instanceVar_kavl_t = (modelPar_kavl*value_exp_0);
    }
    {
      AdmsSensFadType value_exp_0 = exp((modelPar_zetarbi*instanceVar_ln_qtt0));
      instanceVar_rbi0_t = (modelPar_rbi0*value_exp_0);
    }
    if ((modelPar_cjep0>0.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp(((modelPar_vdep*0.5)/instanceVar_vt0));
        AdmsSensFadType value_exp_1 = exp((((-0.5)*modelPar_vdep)/instanceVar_vt0));
        AdmsSensFadType value_log_2 = log((value_exp_0-value_exp_1));
        instanceVar_vdj0 = ((2*instanceVar_vt0)*value_log_2);
      }
      instanceVar_vdjt = (((instanceVar_vdj0*instanceVar_qtt0)+(instanceVar_vgbe0*(1-instanceVar_qtt0)))-((instanceVar_mg*instanceVar_VT)*instanceVar_ln_qtt0));
      {
        AdmsSensFadType value_exp_0 = exp(((-instanceVar_vdjt)/instanceVar_VT));
        AdmsSensFadType value_sqrt_1 = sqrt((1+(4*value_exp_0)));
        AdmsSensFadType value_log_2 = log((0.5*(1+value_sqrt_1)));
        instanceVar_vdt = (instanceVar_vdjt+((2*instanceVar_VT)*value_log_2));
      }
      instanceVar_vdep_t = instanceVar_vdt;
      {
        AdmsSensFadType value_log_0 = log((modelPar_vdep/instanceVar_vdep_t));
        AdmsSensFadType value_exp_1 = exp((modelPar_zep*value_log_0));
        instanceVar_cjep0_t = (modelPar_cjep0*value_exp_1);
      }
      if ((1==1))
      {
        instanceVar_ajep_t = ((modelPar_ajep*instanceVar_vdep_t)/modelPar_vdep);
      }
      else
      {
        instanceVar_ajep_t = modelPar_ajep;
      }
    }
    else
    {
      instanceVar_cjep0_t = modelPar_cjep0;
      instanceVar_vdep_t = modelPar_vdep;
      instanceVar_ajep_t = modelPar_ajep;
    }
    if (((modelPar_ibets>0)&&((Vbpei<0.0)||(Vbiei<0.0))))
      //Begin block HICTUN_T
    {
      //Block-local variables for block HICTUN_T
      AdmsSensFadType a_eg;
      AdmsSensFadType ab;
      AdmsSensFadType aa;
      //End of Block-local variables
      ab = 1.0;
      aa = 1.0;
      a_eg = (instanceVar_vgbe_t0/instanceVar_vgbe_t);
      if ((((modelPar_tunode==1)&&(modelPar_cjep0>0.0))&&(modelPar_vdep>0.0)))
      {
        {
          AdmsSensFadType value_sqrt_0 = sqrt(a_eg);
          ab = (((((instanceVar_cjep0_t/modelPar_cjep0)*value_sqrt_0)*instanceVar_vdep_t)*instanceVar_vdep_t)/(modelPar_vdep*modelPar_vdep));
        }
        {
          AdmsSensFadType value_pow_0 = pow(a_eg,(-1.5));
          aa = (((modelPar_vdep/instanceVar_vdep_t)*(modelPar_cjep0/instanceVar_cjep0_t))*value_pow_0);
        }
      }
      else
      {
        if ((((modelPar_tunode==0)&&(modelPar_cjei0>0.0))&&(modelPar_vdei>0.0)))
        {
          {
            AdmsSensFadType value_sqrt_0 = sqrt(a_eg);
            ab = (((((instanceVar_cjei0_t/modelPar_cjei0)*value_sqrt_0)*instanceVar_vdei_t)*instanceVar_vdei_t)/(modelPar_vdei*modelPar_vdei));
          }
          {
            AdmsSensFadType value_pow_0 = pow(a_eg,(-1.5));
            aa = (((modelPar_vdei/instanceVar_vdei_t)*(modelPar_cjei0/instanceVar_cjei0_t))*value_pow_0);
          }
        }
      }
      instanceVar_ibets_t = (modelPar_ibets*ab);
      instanceVar_abet_t = (modelPar_abet*aa);
    }
    // End block HICTUN_T
    else
    {
      instanceVar_ibets_t = 0;
      instanceVar_abet_t = 1;
    }
    if ((1.0>0.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp(((modelPar_vdcx*0.5)/instanceVar_vt0));
        AdmsSensFadType value_exp_1 = exp((((-0.5)*modelPar_vdcx)/instanceVar_vt0));
        AdmsSensFadType value_log_2 = log((value_exp_0-value_exp_1));
        instanceVar_vdj0 = ((2*instanceVar_vt0)*value_log_2);
      }
      instanceVar_vdjt = (((instanceVar_vdj0*instanceVar_qtt0)+(instanceVar_vgbc0*(1-instanceVar_qtt0)))-((instanceVar_mg*instanceVar_VT)*instanceVar_ln_qtt0));
      {
        AdmsSensFadType value_exp_0 = exp(((-instanceVar_vdjt)/instanceVar_VT));
        AdmsSensFadType value_sqrt_1 = sqrt((1+(4*value_exp_0)));
        AdmsSensFadType value_log_2 = log((0.5*(1+value_sqrt_1)));
        instanceVar_vdt = (instanceVar_vdjt+((2*instanceVar_VT)*value_log_2));
      }
      instanceVar_vdcx_t = instanceVar_vdt;
      {
        AdmsSensFadType value_log_0 = log((modelPar_vdcx/instanceVar_vdcx_t));
        AdmsSensFadType value_exp_1 = exp((modelPar_zcx*value_log_0));
        instanceVar_cratio_t = (1.0*value_exp_1);
      }
      if ((0==1))
      {
        instanceVar_vptcx_t = ((modelPar_vptcx*instanceVar_vdcx_t)/modelPar_vdcx);
      }
      else
      {
        instanceVar_vptcx_t = modelPar_vptcx;
      }
    }
    else
    {
      instanceVar_cratio_t = 1.0;
      instanceVar_vdcx_t = modelPar_vdcx;
      instanceVar_vptcx_t = modelPar_vptcx;
    }
    instanceVar_cjcx01_t = (instanceVar_cratio_t*instanceVar_cjcx01);
    instanceVar_cjcx02_t = (instanceVar_cratio_t*instanceVar_cjcx02);
    {
      AdmsSensFadType value_exp_0 = exp((modelPar_zetarcx*instanceVar_ln_qtt0));
      instanceVar_rcx_t = (modelPar_rcx*value_exp_0);
    }
    {
      AdmsSensFadType value_exp_0 = exp((modelPar_zetarbx*instanceVar_ln_qtt0));
      instanceVar_rbx_t = (modelPar_rbx*value_exp_0);
    }
    {
      AdmsSensFadType value_exp_0 = exp((modelPar_zetare*instanceVar_ln_qtt0));
      instanceVar_re_t = (modelPar_re*value_exp_0);
    }
    {
      AdmsSensFadType value_exp_0 = exp(((modelPar_zetacx-1.0)*instanceVar_ln_qtt0));
      instanceVar_tsf_t = (modelPar_tsf*value_exp_0);
    }
    if ((modelPar_cjs0>0.0))
    {
      {
        AdmsSensFadType value_exp_0 = exp(((modelPar_vds*0.5)/instanceVar_vt0));
        AdmsSensFadType value_exp_1 = exp((((-0.5)*modelPar_vds)/instanceVar_vt0));
        AdmsSensFadType value_log_2 = log((value_exp_0-value_exp_1));
        instanceVar_vdj0 = ((2*instanceVar_vt0)*value_log_2);
      }
      instanceVar_vdjt = (((instanceVar_vdj0*instanceVar_qtt0)+(instanceVar_vgsc0*(1-instanceVar_qtt0)))-((instanceVar_mg*instanceVar_VT)*instanceVar_ln_qtt0));
      {
        AdmsSensFadType value_exp_0 = exp(((-instanceVar_vdjt)/instanceVar_VT));
        AdmsSensFadType value_sqrt_1 = sqrt((1+(4*value_exp_0)));
        AdmsSensFadType value_log_2 = log((0.5*(1+value_sqrt_1)));
        instanceVar_vdt = (instanceVar_vdjt+((2*instanceVar_VT)*value_log_2));
      }
      instanceVar_vds_t = instanceVar_vdt;
      {
        AdmsSensFadType value_log_0 = log((modelPar_vds/instanceVar_vds_t));
        AdmsSensFadType value_exp_1 = exp((modelPar_zs*value_log_0));
        instanceVar_cjs0_t = (modelPar_cjs0*value_exp_1);
      }
      if ((0==1))
      {
        instanceVar_vpts_t = ((modelPar_vpts*instanceVar_vds_t)/modelPar_vds);
      }
      else
      {
        instanceVar_vpts_t = modelPar_vpts;
      }
    }
    else
    {
      instanceVar_cjs0_t = modelPar_cjs0;
      instanceVar_vds_t = modelPar_vds;
      instanceVar_vpts_t = modelPar_vpts;
    }
    if ((modelPar_vdsp>0))
    {
      if ((modelPar_cscp0>0.0))
      {
        {
          AdmsSensFadType value_exp_0 = exp(((modelPar_vdsp*0.5)/instanceVar_vt0));
          AdmsSensFadType value_exp_1 = exp((((-0.5)*modelPar_vdsp)/instanceVar_vt0));
          AdmsSensFadType value_log_2 = log((value_exp_0-value_exp_1));
          instanceVar_vdj0 = ((2*instanceVar_vt0)*value_log_2);
        }
        instanceVar_vdjt = (((instanceVar_vdj0*instanceVar_qtt0)+(instanceVar_vgsc0*(1-instanceVar_qtt0)))-((instanceVar_mg*instanceVar_VT)*instanceVar_ln_qtt0));
        {
          AdmsSensFadType value_exp_0 = exp(((-instanceVar_vdjt)/instanceVar_VT));
          AdmsSensFadType value_sqrt_1 = sqrt((1+(4*value_exp_0)));
          AdmsSensFadType value_log_2 = log((0.5*(1+value_sqrt_1)));
          instanceVar_vdt = (instanceVar_vdjt+((2*instanceVar_VT)*value_log_2));
        }
        instanceVar_vdsp_t = instanceVar_vdt;
        {
          AdmsSensFadType value_log_0 = log((modelPar_vdsp/instanceVar_vdsp_t));
          AdmsSensFadType value_exp_1 = exp((modelPar_zsp*value_log_0));
          instanceVar_cscp0_t = (modelPar_cscp0*value_exp_1);
        }
        if ((0==1))
        {
          instanceVar_vptsp_t = ((modelPar_vptsp*instanceVar_vdsp_t)/modelPar_vdsp);
        }
        else
        {
          instanceVar_vptsp_t = modelPar_vptsp;
        }
      }
      else
      {
        instanceVar_cscp0_t = modelPar_cscp0;
        instanceVar_vdsp_t = modelPar_vdsp;
        instanceVar_vptsp_t = modelPar_vptsp;
      }
    }
    else
    {
      instanceVar_cscp0_t = modelPar_cscp0;
      instanceVar_vdsp_t = modelPar_vdsp;
      instanceVar_vptsp_t = modelPar_vptsp;
    }
    {
      AdmsSensFadType value_exp_0 = exp((modelPar_zetahjei*instanceVar_ln_qtt0));
      instanceVar_ahjei_t = (modelPar_ahjei*value_exp_0);
    }
    {
      AdmsSensFadType value_log_0 = log(instanceVar_qtt0);
      AdmsSensFadType value_exp_1 = exp((modelPar_zetavgbe*value_log_0));
      AdmsSensFadType value_exp_2 = exp(((modelPar_dvgbe/instanceVar_VT)*(value_exp_1-1)));
      instanceVar_hjei0_t = (modelPar_hjei*value_exp_2);
    }
    {
      AdmsSensFadType value_exp_0 = exp(((modelPar_dvgbe/instanceVar_VT)*(instanceVar_qtt0-1)));
      instanceVar_hf0_t = (modelPar_hf0*value_exp_0);
    }
    if ((modelPar_flcomp>=2.3))
    {
      {
        AdmsSensFadType value_exp_0 = exp((((modelPar_vgb-modelPar_vge)/instanceVar_VT)*(instanceVar_qtt0-1)));
        instanceVar_hfe_t = (modelPar_hfe*value_exp_0);
      }
      {
        AdmsSensFadType value_exp_0 = exp((((modelPar_vgb-modelPar_vgc)/instanceVar_VT)*(instanceVar_qtt0-1)));
        instanceVar_hfc_t = (modelPar_hfc*value_exp_0);
      }
    }
    else
    {
      instanceVar_hfe_t = modelPar_hfe;
      instanceVar_hfc_t = modelPar_hfc;
    }
    {
      AdmsSensFadType value_exp_0 = exp((modelPar_zetarth*instanceVar_ln_qtt0));
      instanceVar_rth_t = ((modelPar_rth*value_exp_0)*(1+(modelPar_alrth*instanceVar_dT)));
    }
  }
  // End block Thermal_update_with_self_heating
  //Begin block Model_evaluation
  {
    DIOY = (Vbiei/(modelPar_mbei*instanceVar_VT));
    if ((modelPar_ibeis>0.0))
    {
      if ((DIOY>80.0))
      {
        le = (1+(DIOY-80.0));
        DIOY = 80.0;
      }
      else
      {
        le = 1;
      }
      {
        AdmsSensFadType value_limexp_0 = limexp<AdmsSensFadType>(DIOY);
        le = (le*value_limexp_0);
      }
      instanceVar_ibei = (instanceVar_ibeis_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {
        instanceVar_ibei = (-instanceVar_ibeis_t);
      }
    }
    else
    {
      instanceVar_ibei = 0.0;
    }
    DIOY = (Vbiei/(modelPar_mrei*instanceVar_VT));
    if ((modelPar_ireis>0.0))
    {
      if ((DIOY>80.0))
      {
        le = (1+(DIOY-80.0));
        DIOY = 80.0;
      }
      else
      {
        le = 1;
      }
      {
        AdmsSensFadType value_limexp_0 = limexp<AdmsSensFadType>(DIOY);
        le = (le*value_limexp_0);
      }
      irei = (instanceVar_ireis_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {
        irei = (-instanceVar_ireis_t);
      }
    }
    else
    {
      irei = 0.0;
    }
    Orci0_t = (1.0/instanceVar_rci0_t);
    Tr = modelPar_tr;
    VT_f = (modelPar_mcf*instanceVar_VT);
    {
      AdmsSensFadType value_limexp_0 = limexp<AdmsSensFadType>((Vbiei/VT_f));
      i_0f = (instanceVar_c10_t*value_limexp_0);
    }
    {
      AdmsSensFadType value_limexp_0 = limexp<AdmsSensFadType>((Vbici/instanceVar_VT));
      i_0r = (instanceVar_c10_t*value_limexp_0);
    }
    if ((instanceVar_cjei0_t>0.0))
    {
      {
        AdmsSensFadType value_log_0 = log(instanceVar_ajei_t);
        AdmsSensFadType value_exp_1 = exp(((-value_log_0)/modelPar_zei));
        DFV_f = (instanceVar_vdei_t*(1.0-value_exp_1));
      }
      DFv_e = ((DFV_f-Vbiei)/instanceVar_VT);
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
        DFs_q = value_sqrt_0;
      }
      DFs_q2 = ((DFv_e+DFs_q)*0.5);
      DFv_j = (DFV_f-(instanceVar_VT*DFs_q2));
      DFdvj_dv = (DFs_q2/DFs_q);
      {
        AdmsSensFadType value_log_0 = log((1.0-(DFv_j/instanceVar_vdei_t)));
        DFb = value_log_0;
      }
      {
        AdmsSensFadType value_exp_0 = exp(((-modelPar_zei)*DFb));
        DFC_j1 = ((instanceVar_cjei0_t*value_exp_0)*DFdvj_dv);
      }
      Cjei = (DFC_j1+((instanceVar_ajei_t*instanceVar_cjei0_t)*(1.0-DFdvj_dv)));
      {
        AdmsSensFadType value_exp_0 = exp((DFb*(1.0-modelPar_zei)));
        DFQ_j = (((instanceVar_cjei0_t*instanceVar_vdei_t)*(1.0-value_exp_0))/(1.0-modelPar_zei));
      }
      Qjei = (DFQ_j+((instanceVar_ajei_t*instanceVar_cjei0_t)*(Vbiei-DFv_j)));
    }
    else
    {
      Cjei = 0.0;
      Qjei = 0.0;
    }
    if ((modelPar_ahjei==0.0))
    {
      hjei_vbe = modelPar_hjei;
    }
    else
    {
      vj = ((instanceVar_vdei_t-Vbiei)/(modelPar_rhjei*instanceVar_VT));
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((vj*vj)+1.921812));
        vj = (instanceVar_vdei_t-(((modelPar_rhjei*instanceVar_VT)*(vj+value_sqrt_0))*0.5));
      }
      vj = ((vj-instanceVar_VT)/instanceVar_VT);
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((vj*vj)+1.921812));
        vj = (instanceVar_VT*(1.0+((vj+value_sqrt_0)*0.5)));
      }
      {
        AdmsSensFadType value_log_0 = log((1.0-(vj/instanceVar_vdei_t)));
        AdmsSensFadType value_exp_1 = exp((modelPar_zei*value_log_0));
        vj_z = ((1.0-value_exp_1)*instanceVar_ahjei_t);
      }
      {
        AdmsSensFadType value_exp_0 = exp(vj_z);
        hjei_vbe = ((instanceVar_hjei0_t*(value_exp_0-1.0))/vj_z);
      }
    }
    if ((instanceVar_vptci_t<1.0e2))
    {
      if ((instanceVar_cjci0_t>0.0))
      {
        Dz_r = (modelPar_zci/4.0);
        Dv_p = (instanceVar_vptci_t-instanceVar_vdci_t);
        {
          AdmsSensFadType value_log_0 = log(static_cast<double>(2.4));
          AdmsSensFadType value_exp_1 = exp(((-value_log_0)/modelPar_zci));
          DV_f = (instanceVar_vdci_t*(1.0-value_exp_1));
        }
        DC_max = (2.4*instanceVar_cjci0_t);
        {
          AdmsSensFadType value_log_0 = log((instanceVar_vptci_t/instanceVar_vdci_t));
          AdmsSensFadType value_exp_1 = exp(((Dz_r-modelPar_zci)*value_log_0));
          DC_c = (instanceVar_cjci0_t*value_exp_1);
        }
        Dv_e = ((DV_f-Vbici)/instanceVar_VT);
        if ((Dv_e<80.0))
        {
          {
            AdmsSensFadType value_exp_0 = exp(Dv_e);
            De = value_exp_0;
          }
          De_1 = (De/(1.0+De));
          {
            AdmsSensFadType value_log_0 = log((1.0+De));
            Dv_j1 = (DV_f-(instanceVar_VT*value_log_0));
          }
        }
        else
        {
          De_1 = 1.0;
          Dv_j1 = Vbici;
        }
        Da = ((0.1*Dv_p)+(4.0*instanceVar_VT));
        Dv_r = ((Dv_p+Dv_j1)/Da);
        if ((Dv_r<80.0))
        {
          {
            AdmsSensFadType value_exp_0 = exp(Dv_r);
            De = value_exp_0;
          }
          De_2 = (De/(1.0+De));
          {
            AdmsSensFadType value_log_0 = log((1.0+De));
            AdmsSensFadType value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
            Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
          }
        }
        else
        {
          De_2 = 1.0;
          Dv_j2 = Dv_j1;
        }
        Dv_j4 = (Vbici-Dv_j1);
        {
          AdmsSensFadType value_log_0 = log((1.0-(Dv_j1/instanceVar_vdci_t)));
          DCln1 = value_log_0;
        }
        {
          AdmsSensFadType value_log_0 = log((1.0-(Dv_j2/instanceVar_vdci_t)));
          DCln2 = value_log_0;
        }
        Dz1 = (1.0-modelPar_zci);
        Dzr1 = (1.0-Dz_r);
        {
          AdmsSensFadType value_exp_0 = exp((DCln2*(-modelPar_zci)));
          DC_j1 = (((instanceVar_cjci0_t*value_exp_0)*De_1)*De_2);
        }
        {
          AdmsSensFadType value_exp_0 = exp((DCln1*(-Dz_r)));
          DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
        }
        DC_j3 = (DC_max*(1.0-De_1));
        Cjci = ((DC_j1+DC_j2)+DC_j3);
        {
          AdmsSensFadType value_exp_0 = exp((DCln2*Dz1));
          DQ_j1 = ((instanceVar_cjci0_t*(1.0-value_exp_0))/Dz1);
        }
        {
          AdmsSensFadType value_exp_0 = exp((DCln1*Dzr1));
          DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }
        {
          AdmsSensFadType value_exp_0 = exp((DCln2*Dzr1));
          DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }
        Qjci = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceVar_vdci_t)+(DC_max*Dv_j4));
      }
      else
      {
        Cjci = 0.0;
        Qjci = 0.0;
      }
    }
    else
    {
      if ((instanceVar_cjci0_t>0.0))
      {
        {
          AdmsSensFadType value_log_0 = log(static_cast<double>(2.4));
          AdmsSensFadType value_exp_1 = exp(((-value_log_0)/modelPar_zci));
          DFV_f = (instanceVar_vdci_t*(1.0-value_exp_1));
        }
        DFv_e = ((DFV_f-Vbici)/instanceVar_VT);
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
          DFs_q = value_sqrt_0;
        }
        DFs_q2 = ((DFv_e+DFs_q)*0.5);
        DFv_j = (DFV_f-(instanceVar_VT*DFs_q2));
        DFdvj_dv = (DFs_q2/DFs_q);
        {
          AdmsSensFadType value_log_0 = log((1.0-(DFv_j/instanceVar_vdci_t)));
          DFb = value_log_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(((-modelPar_zci)*DFb));
          DFC_j1 = ((instanceVar_cjci0_t*value_exp_0)*DFdvj_dv);
        }
        Cjci = (DFC_j1+((2.4*instanceVar_cjci0_t)*(1.0-DFdvj_dv)));
        {
          AdmsSensFadType value_exp_0 = exp((DFb*(1.0-modelPar_zci)));
          DFQ_j = (((instanceVar_cjci0_t*instanceVar_vdci_t)*(1.0-value_exp_0))/(1.0-modelPar_zci));
        }
        Qjci = (DFQ_j+((2.4*instanceVar_cjci0_t)*(Vbici-DFv_j)));
      }
      else
      {
        Cjci = 0.0;
        Qjci = 0.0;
      }
    }
    a_bpt = 0.05;
    Q_0 = ((instanceVar_qp0_t+(hjei_vbe*Qjei))+(modelPar_hjci*Qjci));
    Q_bpt = (a_bpt*instanceVar_qp0_t);
    b_q = ((Q_0/Q_bpt)-1);
    {
      AdmsSensFadType value_sqrt_0 = sqrt(((b_q*b_q)+1.921812));
      Q_0 = (Q_bpt*(1+((b_q+value_sqrt_0)/2)));
    }
    if ((instanceVar_cjci0_t>0.0))
      //Begin block CJMODF
    {
      //Block-local variables for block CJMODF
      AdmsSensFadType cV_f;
      AdmsSensFadType cv_e;
      AdmsSensFadType cs_q;
      AdmsSensFadType cs_q2;
      AdmsSensFadType cv_j;
      AdmsSensFadType cdvj_dv;
      //End of Block-local variables
      {
        AdmsSensFadType value_log_0 = log(static_cast<double>(2.4));
        AdmsSensFadType value_exp_1 = exp(((-value_log_0)/modelPar_zci));
        cV_f = (instanceVar_vdci_t*(1.0-value_exp_1));
      }
      cv_e = ((cV_f-Vbici)/instanceVar_VT);
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((cv_e*cv_e)+1.921812));
        cs_q = value_sqrt_0;
      }
      cs_q2 = ((cv_e+cs_q)*0.5);
      cv_j = (cV_f-(instanceVar_VT*cs_q2));
      cdvj_dv = (cs_q2/cs_q);
      {
        AdmsSensFadType value_log_0 = log((1.0-(cv_j/instanceVar_vdci_t)));
        AdmsSensFadType value_exp_1 = exp(((-modelPar_zci)*value_log_0));
        Cjcit = (((instanceVar_cjci0_t*value_exp_1)*cdvj_dv)+((2.4*instanceVar_cjci0_t)*(1.0-cdvj_dv)));
      }
    }
    // End block CJMODF
    else
    {
      Cjcit = 0.0;
    }
    if ((Cjcit>0.0))
    {
      cc = (instanceVar_cjci0_t/Cjcit);
    }
    else
    {
      cc = 1.0;
    }
    T_f0 = ((instanceVar_t0_t+(modelPar_dt0h*(cc-1.0)))+(modelPar_tbvl*((1/cc)-1.0)));
    vc = (Vciei-instanceVar_vces_t);
    //Begin block HICICK
    {
      Ovpt = (1.0/modelPar_vpt);
      instanceVar_a = (vc/instanceVar_VT);
      d1 = (instanceVar_a-1);
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((d1*d1)+1.921812));
        vceff = ((1.0+((d1+value_sqrt_0)/2))*instanceVar_VT);
      }
      a1 = (vceff/instanceVar_vlim_t);
      a11 = (vceff*Orci0_t);
      Odelck = (1/modelPar_delck);
      {
        AdmsSensFadType value_log_0 = log(a1);
        AdmsSensFadType value_exp_1 = exp((modelPar_delck*value_log_0));
        AdmsSensFadType value_log_2 = log((1+value_exp_1));
        AdmsSensFadType value_exp_3 = exp((Odelck*value_log_2));
        ick1 = value_exp_3;
      }
      ick2 = (a11/ick1);
      ICKa = ((vceff-instanceVar_vlim_t)*Ovpt);
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((ICKa*ICKa)+modelPar_aick));
        ick = (ick2*(1.0+(0.5*(ICKa+value_sqrt_0))));
      }
    }
    // End block HICICK
    Q_p = Q_0;
    if (((T_f0>0.0)||(Tr>0.0)))
    {
      A = (0.5*Q_0);
      {
        AdmsSensFadType value_sqrt_0 = sqrt((((A*A)+(T_f0*i_0f))+(Tr*i_0r)));
        Q_p = (A+value_sqrt_0);
      }
    }
    I_Tf1 = (i_0f/Q_p);
    a_h = (instanceVar_Oich*I_Tf1);
    itf = (I_Tf1*(1.0+a_h));
    itr = (i_0r/Q_p);
    Q_bf = 0.0;
    instanceVar_Tf = T_f0;
    Qf = (T_f0*itf);
    if ((itf<(1.0e-6*ick)))
    {
      Q_fT = Qf;
      T_fT = instanceVar_Tf;
      Q_bf = 0;
    }
    else
    {
      FFitf_ick = (itf/ick);
      {
        AdmsSensFadType value_log_0 = log(FFitf_ick);
        AdmsSensFadType value_exp_1 = exp((modelPar_gtfe*value_log_0));
        FFdTef = (instanceVar_tef0_t*value_exp_1);
      }
      FFdQef = ((FFdTef*itf)/(1+modelPar_gtfe));
      if ((modelPar_icbar<(0.05*(modelPar_vlim/modelPar_rci0))))
      {
        FFdVc = 0;
        FFdVc_ditf = 0;
      }
      else
      {
        FFib = ((itf-ick)/modelPar_icbar);
        if ((FFib<(-1.0e10)))
        {
          FFib = (-1.0e10);
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((FFib*FFib)+modelPar_acbar));
          FFfcbar = ((FFib+value_sqrt_0)/2.0);
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((FFib*FFib)+modelPar_acbar));
          FFdib_ditf = ((FFfcbar/value_sqrt_0)/modelPar_icbar);
        }
        {
          AdmsSensFadType value_exp_0 = exp(((-1.0)/FFfcbar));
          FFdVc = (modelPar_vcbar*value_exp_0);
        }
        FFdVc_ditf = ((FFdVc/(FFfcbar*FFfcbar))*FFdib_ditf);
      }
      {
        AdmsSensFadType value_exp_0 = exp((FFdVc/instanceVar_VT));
        FFdQbfb = ((((1-modelPar_fthc)*instanceVar_thcs_t)*itf)*(value_exp_0-1));
      }
      {
        AdmsSensFadType value_exp_0 = exp((FFdVc/instanceVar_VT));
        FFdTbfb = ((FFdQbfb/itf)+((((((1-modelPar_fthc)*instanceVar_thcs_t)*itf)*value_exp_0)/instanceVar_VT)*FFdVc_ditf));
      }
      FFic = (1-(1.0/FFitf_ick));
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((FFic*FFic)+modelPar_ahc));
        AdmsSensFadType value_sqrt_1 = sqrt((1+modelPar_ahc));
        FFw = ((FFic+value_sqrt_0)/(1+value_sqrt_1));
      }
      {
        AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
        FFdQfhc = ((((instanceVar_thcs_t*itf)*FFw)*FFw)*value_exp_0);
      }
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((FFic*FFic)+modelPar_ahc));
        FFdTfhc = (FFdQfhc*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/instanceVar_VT)*FFdVc_ditf)));
      }
      if (((modelPar_latb<=0.0)&&(modelPar_latl<=0.0)))
      {
        FFdQcfc = (modelPar_fthc*FFdQfhc);
        FFdTcfc = (modelPar_fthc*FFdTfhc);
        FFdQcfcT = FFdQcfc;
        FFdTcfcT = FFdTcfc;
      }
      else
      {
        FFdQcfc = ((modelPar_fthc*instanceVar_thcs_t)*itf);
        FCa = (1.0-(ick/itf));
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((FCa*FCa)+modelPar_ahc));
          FCrt = value_sqrt_0;
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt((1.0+modelPar_ahc));
          FCa_ck = (1.0-((FCa+FCrt)/(1.0+value_sqrt_0)));
        }
        FCdaick_ditf = (((FCa_ck-1.0)*(1-FCa))/(FCrt*itf));
        if ((modelPar_latb>modelPar_latl))
        {
          FCz = (modelPar_latb-modelPar_latl);
          FCxl = (1.0+modelPar_latl);
          FCxb = (1.0+modelPar_latb);
          if ((modelPar_latb>0.01))
          {
            {
              AdmsSensFadType value_log_0 = log((FCxb/FCxl));
              FCln = value_log_0;
            }
            {
              AdmsSensFadType value_exp_0 = exp(((FCa_ck-1.0)*FCln));
              FCa1 = value_exp_0;
            }
            FCd_a = (1.0/(modelPar_latl-(FCa1*modelPar_latb)));
            FCw = ((FCa1-1.0)*FCd_a);
            FCdw_daick = (((((-FCz)*FCa1)*FCln)*FCd_a)*FCd_a);
            {
              AdmsSensFadType value_log_0 = log(((1.0+(modelPar_latb*FCw))/(1.0+(modelPar_latl*FCw))));
              FCa1 = value_log_0;
            }
            FCda1_dw = ((modelPar_latb/(1.0+(modelPar_latb*FCw)))-(modelPar_latl/(1.0+(modelPar_latl*FCw))));
          }
          else
          {
            FCf1 = (1.0-FCa_ck);
            FCd_a = (1.0/(1.0+(FCa_ck*modelPar_latb)));
            FCw = (FCf1*FCd_a);
            FCdw_daick = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*FCd_a);
            FCa1 = (FCz*FCw);
            FCda1_dw = FCz;
          }
          FCf_CT = (2.0/FCz);
          FCw2 = (FCw*FCw);
          FCf1 = ((((((modelPar_latb*modelPar_latl)*FCw)*FCw2)/3.0)+(((modelPar_latb+modelPar_latl)*FCw2)/2.0))+FCw);
          FCdf1_dw = ((((modelPar_latb*modelPar_latl)*FCw2)+((modelPar_latb+modelPar_latl)*FCw))+1.0);
          z = (modelPar_latb*FCw);
          {
            AdmsSensFadType value_log_0 = log((1+(modelPar_latb*FCw)));
            lnzb = value_log_0;
          }
          if ((z>1.0e-6))
          {
            x = (1.0+z);
            instanceVar_a = (x*x);
            a2 = (0.250*((instanceVar_a*((2.0*lnzb)-1.0))+1.0));
            a3 = ((((instanceVar_a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
            r = (modelPar_latl/modelPar_latb);
            FCf2 = ((((1.0-r)*a2)+(r*a3))/modelPar_latb);
            FCdf2_dw = ((((1.0-r)*x)+(r*instanceVar_a))*lnzb);
          }
          else
          {
            instanceVar_a = (z*z);
            a2 = (((3.0+z)-(0.25*instanceVar_a))+((0.10*z)*instanceVar_a));
            a3 = (((2.0*z)+(0.75*instanceVar_a))-((0.20*instanceVar_a)*z));
            FCf2 = (((((modelPar_latb*a2)+(modelPar_latl*a3))*FCw)*FCw)/6.0);
            FCdf2_dw = (((1+(modelPar_latl*FCw))*(1+z))*lnzb);
          }
          z = (modelPar_latl*FCw);
          {
            AdmsSensFadType value_log_0 = log((1+(modelPar_latl*FCw)));
            lnzb = value_log_0;
          }
          if ((z>1.0e-6))
          {
            x = (1.0+z);
            instanceVar_a = (x*x);
            a2 = (0.250*((instanceVar_a*((2.0*lnzb)-1.0))+1.0));
            a3 = ((((instanceVar_a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
            r = (modelPar_latb/modelPar_latl);
            FCf3 = ((((1.0-r)*a2)+(r*a3))/modelPar_latl);
            FCdf3_dw = ((((1.0-r)*x)+(r*instanceVar_a))*lnzb);
          }
          else
          {
            instanceVar_a = (z*z);
            a2 = (((3.0+z)-(0.25*instanceVar_a))+((0.10*z)*instanceVar_a));
            a3 = (((2.0*z)+(0.75*instanceVar_a))-((0.20*instanceVar_a)*z));
            FCf3 = (((((modelPar_latl*a2)+(modelPar_latb*a3))*FCw)*FCw)/6.0);
            FCdf3_dw = (((1+(modelPar_latb*FCw))*(1+z))*lnzb);
          }
          FCf_ci = (FCf_CT*(((FCa1*FCf1)-FCf2)+FCf3));
          FCdfc_dw = (FCf_CT*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
          FCdw_ditf = (FCdw_daick*FCdaick_ditf);
          FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
          if (((modelPar_flcomp==0.0)||(modelPar_flcomp==2.1)))
          {
            instanceVar_a = (modelPar_latb*FCw);
            {
              AdmsSensFadType value_log_0 = log((1+(modelPar_latb*FCw)));
              lnz = value_log_0;
            }
            if ((instanceVar_a>1.0e-6))
            {
              FCf2 = ((instanceVar_a-lnz)/modelPar_latb);
              FCdf2_dw = (instanceVar_a/(1.0+instanceVar_a));
            }
            else
            {
              FCf2 = ((0.5*instanceVar_a)*FCw);
              FCdf2_dw = instanceVar_a;
            }
            instanceVar_a = (modelPar_latl*FCw);
            {
              AdmsSensFadType value_log_0 = log((1+(modelPar_latl*FCw)));
              lnz = value_log_0;
            }
            if ((instanceVar_a>1.0e-6))
            {
              FCf3 = ((instanceVar_a-lnz)/modelPar_latl);
              FCdf3_dw = (instanceVar_a/(1.0+instanceVar_a));
            }
            else
            {
              FCf3 = ((0.5*instanceVar_a)*FCw);
              FCdf3_dw = instanceVar_a;
            }
            FCf_CT = (FCf_CT*(FCf2-FCf3));
            FCdfCT_dw = (FCf_CT*(FCdf2_dw-FCdf3_dw));
            FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
          }
          else
          {
            FCf_CT = FCf_ci;
            FCdfCT_ditf = FCdfc_ditf;
          }
        }
        else
        {
          if ((modelPar_latb>0.01))
          {
            FCd_a = (1.0/(1.0+(FCa_ck*modelPar_latb)));
            FCw = ((1.0-FCa_ck)*FCd_a);
            FCdw_daick = (((-(1.0+modelPar_latb))*FCd_a)*FCd_a);
          }
          else
          {
            FCw = ((1.0-FCa_ck)-(FCa_ck*modelPar_latb));
            FCdw_daick = (-(1.0+modelPar_latb));
          }
          FCw2 = (FCw*FCw);
          FCz = (modelPar_latb*FCw);
          FCz_1 = (1.0+FCz);
          FCd_f = (1.0/FCz_1);
          FCf_ci = ((FCw2*(1.0+(FCz/3.0)))*FCd_f);
          FCdfc_dw = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
          FCdw_ditf = (FCdw_daick*FCdaick_ditf);
          FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
          if (((modelPar_flcomp==0.0)||(modelPar_flcomp==2.1)))
          {
            if ((FCz>0.001))
            {
              {
                AdmsSensFadType value_log_0 = log(FCz_1);
                FCf_CT = ((2.0*((FCz_1*value_log_0)-FCz))/((modelPar_latb*modelPar_latb)*FCz_1));
              }
              FCdfCT_dw = (((2.0*FCw)*FCd_f)*FCd_f);
            }
            else
            {
              FCf_CT = ((FCw2*(1.0-(FCz/3.0)))*FCd_f);
              FCdfCT_dw = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
            }
            FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
          }
          else
          {
            FCf_CT = FCf_ci;
            FCdfCT_ditf = FCdfc_ditf;
          }
        }
        {
          AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
          FFdQcfcT = ((FFdQcfc*FCf_CT)*value_exp_0);
        }
        {
          AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
          FFdQcfc = ((FFdQcfc*FCf_ci)*value_exp_0);
        }
        {
          AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
          FFdTcfc = ((((modelPar_fthc*instanceVar_thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/instanceVar_VT)*FFdVc_ditf));
        }
        {
          AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
          FFdTcfcT = ((((modelPar_fthc*instanceVar_thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/instanceVar_VT)*FFdVc_ditf));
        }
      }
      FFdQbfc = ((1-modelPar_fthc)*FFdQfhc);
      FFdTbfc = ((1-modelPar_fthc)*FFdTfhc);
      Q_fT = (((((instanceVar_hf0_t*Qf)+FFdQbfb)+FFdQbfc)+(instanceVar_hfe_t*FFdQef))+(instanceVar_hfc_t*FFdQcfcT));
      T_fT = (((((instanceVar_hf0_t*instanceVar_Tf)+FFdTbfb)+FFdTbfc)+(instanceVar_hfe_t*FFdTef))+(instanceVar_hfc_t*FFdTcfcT));
      Qf = (((Qf+(FFdQbfb+FFdQbfc))+FFdQef)+FFdQcfc);
      instanceVar_Tf = (((instanceVar_Tf+(FFdTbfb+FFdTbfc))+FFdTef)+FFdTcfc);
      Q_bf = (FFdQbfb+FFdQbfc);
    }
    Qr = (Tr*itr);
    l_it = 0;
    if (((Qf>(1.0e-5*Q_p))||(a_h>1.0e-5)))
    {
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((T_f0*itf)*Q_fT));
        Qf = value_sqrt_0;
      }
      Q_pT = ((Q_0+Qf)+Qr);
      d_Q = Q_pT;
      while (((fabs(d_Q)>=(1.0e-5*fabs(Q_pT)))&&(l_it<=100)))
      {
        d_Q0 = d_Q;
        I_Tf1 = (i_0f/Q_pT);
        a_h = (instanceVar_Oich*I_Tf1);
        itf = (I_Tf1*(1.0+a_h));
        itr = (i_0r/Q_pT);
        instanceVar_Tf = T_f0;
        Qf = (T_f0*itf);
        if ((itf<(1.0e-6*ick)))
        {
          Q_fT = Qf;
          T_fT = instanceVar_Tf;
          Q_bf = 0;
        }
        else
        {
          FFitf_ick = (itf/ick);
          {
            AdmsSensFadType value_log_0 = log(FFitf_ick);
            AdmsSensFadType value_exp_1 = exp((modelPar_gtfe*value_log_0));
            FFdTef = (instanceVar_tef0_t*value_exp_1);
          }
          FFdQef = ((FFdTef*itf)/(1+modelPar_gtfe));
          if ((modelPar_icbar<(0.05*(modelPar_vlim/modelPar_rci0))))
          {
            FFdVc = 0;
            FFdVc_ditf = 0;
          }
          else
          {
            FFib = ((itf-ick)/modelPar_icbar);
            if ((FFib<(-1.0e10)))
            {
              FFib = (-1.0e10);
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((FFib*FFib)+modelPar_acbar));
              FFfcbar = ((FFib+value_sqrt_0)/2.0);
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((FFib*FFib)+modelPar_acbar));
              FFdib_ditf = ((FFfcbar/value_sqrt_0)/modelPar_icbar);
            }
            {
              AdmsSensFadType value_exp_0 = exp(((-1.0)/FFfcbar));
              FFdVc = (modelPar_vcbar*value_exp_0);
            }
            FFdVc_ditf = ((FFdVc/(FFfcbar*FFfcbar))*FFdib_ditf);
          }
          {
            AdmsSensFadType value_exp_0 = exp((FFdVc/instanceVar_VT));
            FFdQbfb = ((((1-modelPar_fthc)*instanceVar_thcs_t)*itf)*(value_exp_0-1));
          }
          {
            AdmsSensFadType value_exp_0 = exp((FFdVc/instanceVar_VT));
            FFdTbfb = ((FFdQbfb/itf)+((((((1-modelPar_fthc)*instanceVar_thcs_t)*itf)*value_exp_0)/instanceVar_VT)*FFdVc_ditf));
          }
          FFic = (1-(1.0/FFitf_ick));
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((FFic*FFic)+modelPar_ahc));
            AdmsSensFadType value_sqrt_1 = sqrt((1+modelPar_ahc));
            FFw = ((FFic+value_sqrt_0)/(1+value_sqrt_1));
          }
          {
            AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
            FFdQfhc = ((((instanceVar_thcs_t*itf)*FFw)*FFw)*value_exp_0);
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((FFic*FFic)+modelPar_ahc));
            FFdTfhc = (FFdQfhc*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/instanceVar_VT)*FFdVc_ditf)));
          }
          if (((modelPar_latb<=0.0)&&(modelPar_latl<=0.0)))
          {
            FFdQcfc = (modelPar_fthc*FFdQfhc);
            FFdTcfc = (modelPar_fthc*FFdTfhc);
            FFdQcfcT = FFdQcfc;
            FFdTcfcT = FFdTcfc;
          }
          else
          {
            FFdQcfc = ((modelPar_fthc*instanceVar_thcs_t)*itf);
            FCa = (1.0-(ick/itf));
            {
              AdmsSensFadType value_sqrt_0 = sqrt(((FCa*FCa)+modelPar_ahc));
              FCrt = value_sqrt_0;
            }
            {
              AdmsSensFadType value_sqrt_0 = sqrt((1.0+modelPar_ahc));
              FCa_ck = (1.0-((FCa+FCrt)/(1.0+value_sqrt_0)));
            }
            FCdaick_ditf = (((FCa_ck-1.0)*(1-FCa))/(FCrt*itf));
            if ((modelPar_latb>modelPar_latl))
            {
              FCz = (modelPar_latb-modelPar_latl);
              FCxl = (1.0+modelPar_latl);
              FCxb = (1.0+modelPar_latb);
              if ((modelPar_latb>0.01))
              {
                {
                  AdmsSensFadType value_log_0 = log((FCxb/FCxl));
                  FCln = value_log_0;
                }
                {
                  AdmsSensFadType value_exp_0 = exp(((FCa_ck-1.0)*FCln));
                  FCa1 = value_exp_0;
                }
                FCd_a = (1.0/(modelPar_latl-(FCa1*modelPar_latb)));
                FCw = ((FCa1-1.0)*FCd_a);
                FCdw_daick = (((((-FCz)*FCa1)*FCln)*FCd_a)*FCd_a);
                {
                  AdmsSensFadType value_log_0 = log(((1.0+(modelPar_latb*FCw))/(1.0+(modelPar_latl*FCw))));
                  FCa1 = value_log_0;
                }
                FCda1_dw = ((modelPar_latb/(1.0+(modelPar_latb*FCw)))-(modelPar_latl/(1.0+(modelPar_latl*FCw))));
              }
              else
              {
                FCf1 = (1.0-FCa_ck);
                FCd_a = (1.0/(1.0+(FCa_ck*modelPar_latb)));
                FCw = (FCf1*FCd_a);
                FCdw_daick = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*FCd_a);
                FCa1 = (FCz*FCw);
                FCda1_dw = FCz;
              }
              FCf_CT = (2.0/FCz);
              FCw2 = (FCw*FCw);
              FCf1 = ((((((modelPar_latb*modelPar_latl)*FCw)*FCw2)/3.0)+(((modelPar_latb+modelPar_latl)*FCw2)/2.0))+FCw);
              FCdf1_dw = ((((modelPar_latb*modelPar_latl)*FCw2)+((modelPar_latb+modelPar_latl)*FCw))+1.0);
              z = (modelPar_latb*FCw);
              {
                AdmsSensFadType value_log_0 = log((1+(modelPar_latb*FCw)));
                lnzb = value_log_0;
              }
              if ((z>1.0e-6))
              {
                x = (1.0+z);
                instanceVar_a = (x*x);
                a2 = (0.250*((instanceVar_a*((2.0*lnzb)-1.0))+1.0));
                a3 = ((((instanceVar_a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
                r = (modelPar_latl/modelPar_latb);
                FCf2 = ((((1.0-r)*a2)+(r*a3))/modelPar_latb);
                FCdf2_dw = ((((1.0-r)*x)+(r*instanceVar_a))*lnzb);
              }
              else
              {
                instanceVar_a = (z*z);
                a2 = (((3.0+z)-(0.25*instanceVar_a))+((0.10*z)*instanceVar_a));
                a3 = (((2.0*z)+(0.75*instanceVar_a))-((0.20*instanceVar_a)*z));
                FCf2 = (((((modelPar_latb*a2)+(modelPar_latl*a3))*FCw)*FCw)/6.0);
                FCdf2_dw = (((1+(modelPar_latl*FCw))*(1+z))*lnzb);
              }
              z = (modelPar_latl*FCw);
              {
                AdmsSensFadType value_log_0 = log((1+(modelPar_latl*FCw)));
                lnzb = value_log_0;
              }
              if ((z>1.0e-6))
              {
                x = (1.0+z);
                instanceVar_a = (x*x);
                a2 = (0.250*((instanceVar_a*((2.0*lnzb)-1.0))+1.0));
                a3 = ((((instanceVar_a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
                r = (modelPar_latb/modelPar_latl);
                FCf3 = ((((1.0-r)*a2)+(r*a3))/modelPar_latl);
                FCdf3_dw = ((((1.0-r)*x)+(r*instanceVar_a))*lnzb);
              }
              else
              {
                instanceVar_a = (z*z);
                a2 = (((3.0+z)-(0.25*instanceVar_a))+((0.10*z)*instanceVar_a));
                a3 = (((2.0*z)+(0.75*instanceVar_a))-((0.20*instanceVar_a)*z));
                FCf3 = (((((modelPar_latl*a2)+(modelPar_latb*a3))*FCw)*FCw)/6.0);
                FCdf3_dw = (((1+(modelPar_latb*FCw))*(1+z))*lnzb);
              }
              FCf_ci = (FCf_CT*(((FCa1*FCf1)-FCf2)+FCf3));
              FCdfc_dw = (FCf_CT*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
              FCdw_ditf = (FCdw_daick*FCdaick_ditf);
              FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
              if (((modelPar_flcomp==0.0)||(modelPar_flcomp==2.1)))
              {
                instanceVar_a = (modelPar_latb*FCw);
                {
                  AdmsSensFadType value_log_0 = log((1+(modelPar_latb*FCw)));
                  lnz = value_log_0;
                }
                if ((instanceVar_a>1.0e-6))
                {
                  FCf2 = ((instanceVar_a-lnz)/modelPar_latb);
                  FCdf2_dw = (instanceVar_a/(1.0+instanceVar_a));
                }
                else
                {
                  FCf2 = ((0.5*instanceVar_a)*FCw);
                  FCdf2_dw = instanceVar_a;
                }
                instanceVar_a = (modelPar_latl*FCw);
                {
                  AdmsSensFadType value_log_0 = log((1+(modelPar_latl*FCw)));
                  lnz = value_log_0;
                }
                if ((instanceVar_a>1.0e-6))
                {
                  FCf3 = ((instanceVar_a-lnz)/modelPar_latl);
                  FCdf3_dw = (instanceVar_a/(1.0+instanceVar_a));
                }
                else
                {
                  FCf3 = ((0.5*instanceVar_a)*FCw);
                  FCdf3_dw = instanceVar_a;
                }
                FCf_CT = (FCf_CT*(FCf2-FCf3));
                FCdfCT_dw = (FCf_CT*(FCdf2_dw-FCdf3_dw));
                FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
              }
              else
              {
                FCf_CT = FCf_ci;
                FCdfCT_ditf = FCdfc_ditf;
              }
            }
            else
            {
              if ((modelPar_latb>0.01))
              {
                FCd_a = (1.0/(1.0+(FCa_ck*modelPar_latb)));
                FCw = ((1.0-FCa_ck)*FCd_a);
                FCdw_daick = (((-(1.0+modelPar_latb))*FCd_a)*FCd_a);
              }
              else
              {
                FCw = ((1.0-FCa_ck)-(FCa_ck*modelPar_latb));
                FCdw_daick = (-(1.0+modelPar_latb));
              }
              FCw2 = (FCw*FCw);
              FCz = (modelPar_latb*FCw);
              FCz_1 = (1.0+FCz);
              FCd_f = (1.0/FCz_1);
              FCf_ci = ((FCw2*(1.0+(FCz/3.0)))*FCd_f);
              FCdfc_dw = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
              FCdw_ditf = (FCdw_daick*FCdaick_ditf);
              FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
              if (((modelPar_flcomp==0.0)||(modelPar_flcomp==2.1)))
              {
                if ((FCz>0.001))
                {
                  {
                    AdmsSensFadType value_log_0 = log(FCz_1);
                    FCf_CT = ((2.0*((FCz_1*value_log_0)-FCz))/((modelPar_latb*modelPar_latb)*FCz_1));
                  }
                  FCdfCT_dw = (((2.0*FCw)*FCd_f)*FCd_f);
                }
                else
                {
                  FCf_CT = ((FCw2*(1.0-(FCz/3.0)))*FCd_f);
                  FCdfCT_dw = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
                }
                FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
              }
              else
              {
                FCf_CT = FCf_ci;
                FCdfCT_ditf = FCdfc_ditf;
              }
            }
            {
              AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
              FFdQcfcT = ((FFdQcfc*FCf_CT)*value_exp_0);
            }
            {
              AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
              FFdQcfc = ((FFdQcfc*FCf_ci)*value_exp_0);
            }
            {
              AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
              FFdTcfc = ((((modelPar_fthc*instanceVar_thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/instanceVar_VT)*FFdVc_ditf));
            }
            {
              AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
              FFdTcfcT = ((((modelPar_fthc*instanceVar_thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/instanceVar_VT)*FFdVc_ditf));
            }
          }
          FFdQbfc = ((1-modelPar_fthc)*FFdQfhc);
          FFdTbfc = ((1-modelPar_fthc)*FFdTfhc);
          Q_fT = (((((instanceVar_hf0_t*Qf)+FFdQbfb)+FFdQbfc)+(instanceVar_hfe_t*FFdQef))+(instanceVar_hfc_t*FFdQcfcT));
          T_fT = (((((instanceVar_hf0_t*instanceVar_Tf)+FFdTbfb)+FFdTbfc)+(instanceVar_hfe_t*FFdTef))+(instanceVar_hfc_t*FFdTcfcT));
          Qf = (((Qf+(FFdQbfb+FFdQbfc))+FFdQef)+FFdQcfc);
          instanceVar_Tf = (((instanceVar_Tf+(FFdTbfb+FFdTbfc))+FFdTef)+FFdTcfc);
          Q_bf = (FFdQbfb+FFdQbfc);
        }
        Qr = (Tr*itr);
        if ((instanceVar_Oich==0.0))
        {
          instanceVar_a = (1.0+(((T_fT*itf)+Qr)/Q_pT));
        }
        else
        {
          instanceVar_a = (1.0+((((T_fT*I_Tf1)*(1.0+(2.0*a_h)))+Qr)/Q_pT));
        }
        d_Q = ((-(Q_pT-((Q_0+Q_fT)+Qr)))/instanceVar_a);
        {
          AdmsSensFadType value_fabs_0 = fabs((0.3*Q_pT));
          instanceVar_a = value_fabs_0;
        }
        if ((fabs(d_Q)>instanceVar_a))
        {
          if ((d_Q>=0))
          {
            d_Q = instanceVar_a;
          }
          else
          {
            d_Q = (-instanceVar_a);
          }
        }
        Q_pT = (Q_pT+d_Q);
        l_it = (l_it+1);
      }
      I_Tf1 = (i_0f/Q_pT);
      a_h = (instanceVar_Oich*I_Tf1);
      itf = (I_Tf1*(1.0+a_h));
      itr = (i_0r/Q_pT);
      instanceVar_Tf = T_f0;
      Qf = (T_f0*itf);
      if ((itf<(1.0e-6*ick)))
      {
        Q_fT = Qf;
        T_fT = instanceVar_Tf;
        Q_bf = 0;
      }
      else
      {
        FFitf_ick = (itf/ick);
        {
          AdmsSensFadType value_log_0 = log(FFitf_ick);
          AdmsSensFadType value_exp_1 = exp((modelPar_gtfe*value_log_0));
          FFdTef = (instanceVar_tef0_t*value_exp_1);
        }
        FFdQef = ((FFdTef*itf)/(1+modelPar_gtfe));
        if ((modelPar_icbar<(0.05*(modelPar_vlim/modelPar_rci0))))
        {
          FFdVc = 0;
          FFdVc_ditf = 0;
        }
        else
        {
          FFib = ((itf-ick)/modelPar_icbar);
          if ((FFib<(-1.0e10)))
          {
            FFib = (-1.0e10);
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((FFib*FFib)+modelPar_acbar));
            FFfcbar = ((FFib+value_sqrt_0)/2.0);
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((FFib*FFib)+modelPar_acbar));
            FFdib_ditf = ((FFfcbar/value_sqrt_0)/modelPar_icbar);
          }
          {
            AdmsSensFadType value_exp_0 = exp(((-1.0)/FFfcbar));
            FFdVc = (modelPar_vcbar*value_exp_0);
          }
          FFdVc_ditf = ((FFdVc/(FFfcbar*FFfcbar))*FFdib_ditf);
        }
        {
          AdmsSensFadType value_exp_0 = exp((FFdVc/instanceVar_VT));
          FFdQbfb = ((((1-modelPar_fthc)*instanceVar_thcs_t)*itf)*(value_exp_0-1));
        }
        {
          AdmsSensFadType value_exp_0 = exp((FFdVc/instanceVar_VT));
          FFdTbfb = ((FFdQbfb/itf)+((((((1-modelPar_fthc)*instanceVar_thcs_t)*itf)*value_exp_0)/instanceVar_VT)*FFdVc_ditf));
        }
        FFic = (1-(1.0/FFitf_ick));
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((FFic*FFic)+modelPar_ahc));
          AdmsSensFadType value_sqrt_1 = sqrt((1+modelPar_ahc));
          FFw = ((FFic+value_sqrt_0)/(1+value_sqrt_1));
        }
        {
          AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
          FFdQfhc = ((((instanceVar_thcs_t*itf)*FFw)*FFw)*value_exp_0);
        }
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((FFic*FFic)+modelPar_ahc));
          FFdTfhc = (FFdQfhc*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/instanceVar_VT)*FFdVc_ditf)));
        }
        if (((modelPar_latb<=0.0)&&(modelPar_latl<=0.0)))
        {
          FFdQcfc = (modelPar_fthc*FFdQfhc);
          FFdTcfc = (modelPar_fthc*FFdTfhc);
          FFdQcfcT = FFdQcfc;
          FFdTcfcT = FFdTcfc;
        }
        else
        {
          FFdQcfc = ((modelPar_fthc*instanceVar_thcs_t)*itf);
          FCa = (1.0-(ick/itf));
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((FCa*FCa)+modelPar_ahc));
            FCrt = value_sqrt_0;
          }
          {
            AdmsSensFadType value_sqrt_0 = sqrt((1.0+modelPar_ahc));
            FCa_ck = (1.0-((FCa+FCrt)/(1.0+value_sqrt_0)));
          }
          FCdaick_ditf = (((FCa_ck-1.0)*(1-FCa))/(FCrt*itf));
          if ((modelPar_latb>modelPar_latl))
          {
            FCz = (modelPar_latb-modelPar_latl);
            FCxl = (1.0+modelPar_latl);
            FCxb = (1.0+modelPar_latb);
            if ((modelPar_latb>0.01))
            {
              {
                AdmsSensFadType value_log_0 = log((FCxb/FCxl));
                FCln = value_log_0;
              }
              {
                AdmsSensFadType value_exp_0 = exp(((FCa_ck-1.0)*FCln));
                FCa1 = value_exp_0;
              }
              FCd_a = (1.0/(modelPar_latl-(FCa1*modelPar_latb)));
              FCw = ((FCa1-1.0)*FCd_a);
              FCdw_daick = (((((-FCz)*FCa1)*FCln)*FCd_a)*FCd_a);
              {
                AdmsSensFadType value_log_0 = log(((1.0+(modelPar_latb*FCw))/(1.0+(modelPar_latl*FCw))));
                FCa1 = value_log_0;
              }
              FCda1_dw = ((modelPar_latb/(1.0+(modelPar_latb*FCw)))-(modelPar_latl/(1.0+(modelPar_latl*FCw))));
            }
            else
            {
              FCf1 = (1.0-FCa_ck);
              FCd_a = (1.0/(1.0+(FCa_ck*modelPar_latb)));
              FCw = (FCf1*FCd_a);
              FCdw_daick = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*FCd_a);
              FCa1 = (FCz*FCw);
              FCda1_dw = FCz;
            }
            FCf_CT = (2.0/FCz);
            FCw2 = (FCw*FCw);
            FCf1 = ((((((modelPar_latb*modelPar_latl)*FCw)*FCw2)/3.0)+(((modelPar_latb+modelPar_latl)*FCw2)/2.0))+FCw);
            FCdf1_dw = ((((modelPar_latb*modelPar_latl)*FCw2)+((modelPar_latb+modelPar_latl)*FCw))+1.0);
            z = (modelPar_latb*FCw);
            {
              AdmsSensFadType value_log_0 = log((1+(modelPar_latb*FCw)));
              lnzb = value_log_0;
            }
            if ((z>1.0e-6))
            {
              x = (1.0+z);
              instanceVar_a = (x*x);
              a2 = (0.250*((instanceVar_a*((2.0*lnzb)-1.0))+1.0));
              a3 = ((((instanceVar_a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
              r = (modelPar_latl/modelPar_latb);
              FCf2 = ((((1.0-r)*a2)+(r*a3))/modelPar_latb);
              FCdf2_dw = ((((1.0-r)*x)+(r*instanceVar_a))*lnzb);
            }
            else
            {
              instanceVar_a = (z*z);
              a2 = (((3.0+z)-(0.25*instanceVar_a))+((0.10*z)*instanceVar_a));
              a3 = (((2.0*z)+(0.75*instanceVar_a))-((0.20*instanceVar_a)*z));
              FCf2 = (((((modelPar_latb*a2)+(modelPar_latl*a3))*FCw)*FCw)/6.0);
              FCdf2_dw = (((1+(modelPar_latl*FCw))*(1+z))*lnzb);
            }
            z = (modelPar_latl*FCw);
            {
              AdmsSensFadType value_log_0 = log((1+(modelPar_latl*FCw)));
              lnzb = value_log_0;
            }
            if ((z>1.0e-6))
            {
              x = (1.0+z);
              instanceVar_a = (x*x);
              a2 = (0.250*((instanceVar_a*((2.0*lnzb)-1.0))+1.0));
              a3 = ((((instanceVar_a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
              r = (modelPar_latb/modelPar_latl);
              FCf3 = ((((1.0-r)*a2)+(r*a3))/modelPar_latl);
              FCdf3_dw = ((((1.0-r)*x)+(r*instanceVar_a))*lnzb);
            }
            else
            {
              instanceVar_a = (z*z);
              a2 = (((3.0+z)-(0.25*instanceVar_a))+((0.10*z)*instanceVar_a));
              a3 = (((2.0*z)+(0.75*instanceVar_a))-((0.20*instanceVar_a)*z));
              FCf3 = (((((modelPar_latl*a2)+(modelPar_latb*a3))*FCw)*FCw)/6.0);
              FCdf3_dw = (((1+(modelPar_latb*FCw))*(1+z))*lnzb);
            }
            FCf_ci = (FCf_CT*(((FCa1*FCf1)-FCf2)+FCf3));
            FCdfc_dw = (FCf_CT*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
            FCdw_ditf = (FCdw_daick*FCdaick_ditf);
            FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
            if (((modelPar_flcomp==0.0)||(modelPar_flcomp==2.1)))
            {
              instanceVar_a = (modelPar_latb*FCw);
              {
                AdmsSensFadType value_log_0 = log((1+(modelPar_latb*FCw)));
                lnz = value_log_0;
              }
              if ((instanceVar_a>1.0e-6))
              {
                FCf2 = ((instanceVar_a-lnz)/modelPar_latb);
                FCdf2_dw = (instanceVar_a/(1.0+instanceVar_a));
              }
              else
              {
                FCf2 = ((0.5*instanceVar_a)*FCw);
                FCdf2_dw = instanceVar_a;
              }
              instanceVar_a = (modelPar_latl*FCw);
              {
                AdmsSensFadType value_log_0 = log((1+(modelPar_latl*FCw)));
                lnz = value_log_0;
              }
              if ((instanceVar_a>1.0e-6))
              {
                FCf3 = ((instanceVar_a-lnz)/modelPar_latl);
                FCdf3_dw = (instanceVar_a/(1.0+instanceVar_a));
              }
              else
              {
                FCf3 = ((0.5*instanceVar_a)*FCw);
                FCdf3_dw = instanceVar_a;
              }
              FCf_CT = (FCf_CT*(FCf2-FCf3));
              FCdfCT_dw = (FCf_CT*(FCdf2_dw-FCdf3_dw));
              FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
            }
            else
            {
              FCf_CT = FCf_ci;
              FCdfCT_ditf = FCdfc_ditf;
            }
          }
          else
          {
            if ((modelPar_latb>0.01))
            {
              FCd_a = (1.0/(1.0+(FCa_ck*modelPar_latb)));
              FCw = ((1.0-FCa_ck)*FCd_a);
              FCdw_daick = (((-(1.0+modelPar_latb))*FCd_a)*FCd_a);
            }
            else
            {
              FCw = ((1.0-FCa_ck)-(FCa_ck*modelPar_latb));
              FCdw_daick = (-(1.0+modelPar_latb));
            }
            FCw2 = (FCw*FCw);
            FCz = (modelPar_latb*FCw);
            FCz_1 = (1.0+FCz);
            FCd_f = (1.0/FCz_1);
            FCf_ci = ((FCw2*(1.0+(FCz/3.0)))*FCd_f);
            FCdfc_dw = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
            FCdw_ditf = (FCdw_daick*FCdaick_ditf);
            FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
            if (((modelPar_flcomp==0.0)||(modelPar_flcomp==2.1)))
            {
              if ((FCz>0.001))
              {
                {
                  AdmsSensFadType value_log_0 = log(FCz_1);
                  FCf_CT = ((2.0*((FCz_1*value_log_0)-FCz))/((modelPar_latb*modelPar_latb)*FCz_1));
                }
                FCdfCT_dw = (((2.0*FCw)*FCd_f)*FCd_f);
              }
              else
              {
                FCf_CT = ((FCw2*(1.0-(FCz/3.0)))*FCd_f);
                FCdfCT_dw = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
              }
              FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
            }
            else
            {
              FCf_CT = FCf_ci;
              FCdfCT_ditf = FCdfc_ditf;
            }
          }
          {
            AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
            FFdQcfcT = ((FFdQcfc*FCf_CT)*value_exp_0);
          }
          {
            AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
            FFdQcfc = ((FFdQcfc*FCf_ci)*value_exp_0);
          }
          {
            AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
            FFdTcfc = ((((modelPar_fthc*instanceVar_thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/instanceVar_VT)*FFdVc_ditf));
          }
          {
            AdmsSensFadType value_exp_0 = exp(((FFdVc-modelPar_vcbar)/instanceVar_VT));
            FFdTcfcT = ((((modelPar_fthc*instanceVar_thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/instanceVar_VT)*FFdVc_ditf));
          }
        }
        FFdQbfc = ((1-modelPar_fthc)*FFdQfhc);
        FFdTbfc = ((1-modelPar_fthc)*FFdTfhc);
        Q_fT = (((((instanceVar_hf0_t*Qf)+FFdQbfb)+FFdQbfc)+(instanceVar_hfe_t*FFdQef))+(instanceVar_hfc_t*FFdQcfcT));
        T_fT = (((((instanceVar_hf0_t*instanceVar_Tf)+FFdTbfb)+FFdTbfc)+(instanceVar_hfe_t*FFdTef))+(instanceVar_hfc_t*FFdTcfcT));
        Qf = (((Qf+(FFdQbfb+FFdQbfc))+FFdQef)+FFdQcfc);
        instanceVar_Tf = (((instanceVar_Tf+(FFdTbfb+FFdTbfc))+FFdTef)+FFdTcfc);
        Q_bf = (FFdQbfb+FFdQbfc);
      }
      Qr = (Tr*itr);
    }
    instanceVar_it = (itf-itr);
    Qdei = Qf;
    Qdci = Qr;
    Cdei = ((T_f0*itf)/instanceVar_VT);
    Cdci = ((modelPar_tr*itr)/instanceVar_VT);
    Crbi = (modelPar_fcrbi*(((Cjei+Cjci)+Cdei)+Cdci));
    qrbi = (Crbi*(probeVars[admsProbeID_V_bp_bi]));
    DIOY = (Vbici/(modelPar_mbci*instanceVar_VT));
    if ((modelPar_ibcis>0.0))
    {
      if ((DIOY>80.0))
      {
        le = (1+(DIOY-80.0));
        DIOY = 80.0;
      }
      else
      {
        le = 1;
      }
      {
        AdmsSensFadType value_limexp_0 = limexp<AdmsSensFadType>(DIOY);
        le = (le*value_limexp_0);
      }
      instanceVar_ibci = (instanceVar_ibcis_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {
        instanceVar_ibci = (-instanceVar_ibcis_t);
      }
    }
    else
    {
      instanceVar_ibci = 0.0;
    }
    if ((instanceVar_use_aval==1))
      //Begin block HICAVL
    {
      //Block-local variables for block HICAVL
      AdmsSensFadType v_bord;
      AdmsSensFadType v_q;
      AdmsSensFadType U0;
      AdmsSensFadType av;
      AdmsSensFadType avl;
      //End of Block-local variables
      v_bord = (instanceVar_vdci_t-Vbici);
      if ((v_bord>0))
      {
        v_q = (instanceVar_qavl_t/Cjci);
        U0 = (instanceVar_qavl_t/instanceVar_cjci0_t);
        if ((v_bord>U0))
        {
          {
            AdmsSensFadType value_exp_0 = exp(((-v_q)/U0));
            av = (instanceVar_favl_t*value_exp_0);
          }
          avl = (av*(U0+((1.0+(v_q/U0))*(v_bord-U0))));
        }
        else
        {
          {
            AdmsSensFadType value_exp_0 = exp(((-v_q)/v_bord));
            avl = ((instanceVar_favl_t*v_bord)*value_exp_0);
          }
        }
        if ((modelPar_kavl>0))
          //Begin block HICAVLHIGH
        {
          //Block-local variables for block HICAVLHIGH
          AdmsSensFadType denom;
          AdmsSensFadType sq_smooth;
          AdmsSensFadType hl;
          //End of Block-local variables
          denom = (1-(instanceVar_kavl_t*avl));
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((denom*denom)+0.01));
            sq_smooth = value_sqrt_0;
          }
          hl = (0.5*(denom+sq_smooth));
          instanceVar_iavl = ((itf*avl)/hl);
        }
        // End block HICAVLHIGH
        else
        {
          instanceVar_iavl = (itf*avl);
        }
      }
      else
      {
        instanceVar_iavl = 0.0;
      }
    }
    // End block HICAVL
    ibh_rec = (Q_bf*instanceVar_Otbhrec);
    if ((instanceVar_rbi0_t>0.0))
      //Begin block HICRBI
    {
      //Block-local variables for block HICRBI
      AdmsSensFadType Qz_nom;
      AdmsSensFadType f_QR;
      AdmsSensFadType ETA;
      AdmsSensFadType Qz0;
      AdmsSensFadType fQz;
      //End of Block-local variables
      f_QR = ((1+modelPar_fdqr0)*instanceVar_qp0_t);
      Qz0 = ((Qjei+Qjci)+Qf);
      Qz_nom = (1+(Qz0/f_QR));
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((Qz_nom*Qz_nom)+0.01));
        fQz = (0.5*(Qz_nom+value_sqrt_0));
      }
      instanceVar_rbi = (instanceVar_rbi0_t/fQz);
      if ((instanceVar_ibei>0.0))
      {
        ETA = (((instanceVar_rbi*instanceVar_ibei)*modelPar_fgeo)/instanceVar_VT);
        if ((ETA<1.0e-6))
        {
          instanceVar_rbi = (instanceVar_rbi*(1.0-(0.5*ETA)));
        }
        else
        {
          {
            AdmsSensFadType value_log_0 = log((1.0+ETA));
            instanceVar_rbi = ((instanceVar_rbi*value_log_0)/ETA);
          }
        }
      }
      if ((Qf>0.0))
      {
        instanceVar_rbi = ((instanceVar_rbi*(Qjei+(Qf*modelPar_fqi)))/(Qjei+Qf));
      }
    }
    // End block HICRBI
    else
    {
      instanceVar_rbi = 0.0;
    }
    DIOY = (Vbpei/(modelPar_mbep*instanceVar_VT));
    if ((modelPar_ibeps>0.0))
    {
      if ((DIOY>80.0))
      {
        le = (1+(DIOY-80.0));
        DIOY = 80.0;
      }
      else
      {
        le = 1;
      }
      {
        AdmsSensFadType value_limexp_0 = limexp<AdmsSensFadType>(DIOY);
        le = (le*value_limexp_0);
      }
      instanceVar_ibep = (instanceVar_ibeps_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {
        instanceVar_ibep = (-instanceVar_ibeps_t);
      }
    }
    else
    {
      instanceVar_ibep = 0.0;
    }
    DIOY = (Vbpei/(modelPar_mrep*instanceVar_VT));
    if ((modelPar_ireps>0.0))
    {
      if ((DIOY>80.0))
      {
        le = (1+(DIOY-80.0));
        DIOY = 80.0;
      }
      else
      {
        le = 1;
      }
      {
        AdmsSensFadType value_limexp_0 = limexp<AdmsSensFadType>(DIOY);
        le = (le*value_limexp_0);
      }
      irep = (instanceVar_ireps_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {
        irep = (-instanceVar_ireps_t);
      }
    }
    else
    {
      irep = 0.0;
    }
    if ((instanceVar_cjep0_t>0.0))
    {
      {
        AdmsSensFadType value_log_0 = log(instanceVar_ajep_t);
        AdmsSensFadType value_exp_1 = exp(((-value_log_0)/modelPar_zep));
        DFV_f = (instanceVar_vdep_t*(1.0-value_exp_1));
      }
      DFv_e = ((DFV_f-Vbpei)/instanceVar_VT);
      {
        AdmsSensFadType value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
        DFs_q = value_sqrt_0;
      }
      DFs_q2 = ((DFv_e+DFs_q)*0.5);
      DFv_j = (DFV_f-(instanceVar_VT*DFs_q2));
      DFdvj_dv = (DFs_q2/DFs_q);
      {
        AdmsSensFadType value_log_0 = log((1.0-(DFv_j/instanceVar_vdep_t)));
        DFb = value_log_0;
      }
      {
        AdmsSensFadType value_exp_0 = exp(((-modelPar_zep)*DFb));
        DFC_j1 = ((instanceVar_cjep0_t*value_exp_0)*DFdvj_dv);
      }
      Cjep = (DFC_j1+((instanceVar_ajep_t*instanceVar_cjep0_t)*(1.0-DFdvj_dv)));
      {
        AdmsSensFadType value_exp_0 = exp((DFb*(1.0-modelPar_zep)));
        DFQ_j = (((instanceVar_cjep0_t*instanceVar_vdep_t)*(1.0-value_exp_0))/(1.0-modelPar_zep));
      }
      Qjep = (DFQ_j+((instanceVar_ajep_t*instanceVar_cjep0_t)*(Vbpei-DFv_j)));
    }
    else
    {
      Cjep = 0.0;
      Qjep = 0.0;
    }
    if (((modelPar_ibets>0)&&((Vbpei<0.0)||(Vbiei<0.0))))
      //Begin block HICTUN
    {
      //Block-local variables for block HICTUN
      AdmsSensFadType pocce;
      AdmsSensFadType czz;
      //End of Block-local variables
      if ((((modelPar_tunode==1)&&(instanceVar_cjep0_t>0.0))&&(instanceVar_vdep_t>0.0)))
      {
        {
          AdmsSensFadType value_log_0 = log((Cjep/instanceVar_cjep0_t));
          AdmsSensFadType value_exp_1 = exp(((1-(1/modelPar_zep))*value_log_0));
          pocce = value_exp_1;
        }
        czz = (((-(Vbpei/instanceVar_vdep_t))*instanceVar_ibets_t)*pocce);
        {
          AdmsSensFadType value_exp_0 = exp(((-instanceVar_abet_t)/pocce));
          ibet = (czz*value_exp_0);
        }
      }
      else
      {
        if ((((modelPar_tunode==0)&&(instanceVar_cjei0_t>0.0))&&(instanceVar_vdei_t>0.0)))
        {
          {
            AdmsSensFadType value_log_0 = log((Cjei/instanceVar_cjei0_t));
            AdmsSensFadType value_exp_1 = exp(((1-(1/modelPar_zei))*value_log_0));
            pocce = value_exp_1;
          }
          czz = (((-(Vbiei/instanceVar_vdei_t))*instanceVar_ibets_t)*pocce);
          {
            AdmsSensFadType value_exp_0 = exp(((-instanceVar_abet_t)/pocce));
            ibet = (czz*value_exp_0);
          }
        }
        else
        {
          ibet = 0.0;
        }
      }
    }
    // End block HICTUN
    else
    {
      ibet = 0.0;
    }
    if ((instanceVar_vptcx_t<1.0e2))
    {
      if ((instanceVar_cjcx02_t>0.0))
      {
        Dz_r = (modelPar_zcx/4.0);
        Dv_p = (instanceVar_vptcx_t-instanceVar_vdcx_t);
        {
          AdmsSensFadType value_log_0 = log(static_cast<double>(2.4));
          AdmsSensFadType value_exp_1 = exp(((-value_log_0)/modelPar_zcx));
          DV_f = (instanceVar_vdcx_t*(1.0-value_exp_1));
        }
        DC_max = (2.4*instanceVar_cjcx02_t);
        {
          AdmsSensFadType value_log_0 = log((instanceVar_vptcx_t/instanceVar_vdcx_t));
          AdmsSensFadType value_exp_1 = exp(((Dz_r-modelPar_zcx)*value_log_0));
          DC_c = (instanceVar_cjcx02_t*value_exp_1);
        }
        Dv_e = ((DV_f-Vbpci)/instanceVar_VT);
        if ((Dv_e<80.0))
        {
          {
            AdmsSensFadType value_exp_0 = exp(Dv_e);
            De = value_exp_0;
          }
          De_1 = (De/(1.0+De));
          {
            AdmsSensFadType value_log_0 = log((1.0+De));
            Dv_j1 = (DV_f-(instanceVar_VT*value_log_0));
          }
        }
        else
        {
          De_1 = 1.0;
          Dv_j1 = Vbpci;
        }
        Da = ((0.1*Dv_p)+(4.0*instanceVar_VT));
        Dv_r = ((Dv_p+Dv_j1)/Da);
        if ((Dv_r<80.0))
        {
          {
            AdmsSensFadType value_exp_0 = exp(Dv_r);
            De = value_exp_0;
          }
          De_2 = (De/(1.0+De));
          {
            AdmsSensFadType value_log_0 = log((1.0+De));
            AdmsSensFadType value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
            Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
          }
        }
        else
        {
          De_2 = 1.0;
          Dv_j2 = Dv_j1;
        }
        Dv_j4 = (Vbpci-Dv_j1);
        {
          AdmsSensFadType value_log_0 = log((1.0-(Dv_j1/instanceVar_vdcx_t)));
          DCln1 = value_log_0;
        }
        {
          AdmsSensFadType value_log_0 = log((1.0-(Dv_j2/instanceVar_vdcx_t)));
          DCln2 = value_log_0;
        }
        Dz1 = (1.0-modelPar_zcx);
        Dzr1 = (1.0-Dz_r);
        {
          AdmsSensFadType value_exp_0 = exp((DCln2*(-modelPar_zcx)));
          DC_j1 = (((instanceVar_cjcx02_t*value_exp_0)*De_1)*De_2);
        }
        {
          AdmsSensFadType value_exp_0 = exp((DCln1*(-Dz_r)));
          DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
        }
        DC_j3 = (DC_max*(1.0-De_1));
        CjCx_ii = ((DC_j1+DC_j2)+DC_j3);
        {
          AdmsSensFadType value_exp_0 = exp((DCln2*Dz1));
          DQ_j1 = ((instanceVar_cjcx02_t*(1.0-value_exp_0))/Dz1);
        }
        {
          AdmsSensFadType value_exp_0 = exp((DCln1*Dzr1));
          DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }
        {
          AdmsSensFadType value_exp_0 = exp((DCln2*Dzr1));
          DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }
        qjcx0_t_ii = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceVar_vdcx_t)+(DC_max*Dv_j4));
      }
      else
      {
        CjCx_ii = 0.0;
        qjcx0_t_ii = 0.0;
      }
    }
    else
    {
      if ((instanceVar_cjcx02_t>0.0))
      {
        {
          AdmsSensFadType value_log_0 = log(static_cast<double>(2.4));
          AdmsSensFadType value_exp_1 = exp(((-value_log_0)/modelPar_zcx));
          DFV_f = (instanceVar_vdcx_t*(1.0-value_exp_1));
        }
        DFv_e = ((DFV_f-Vbpci)/instanceVar_VT);
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
          DFs_q = value_sqrt_0;
        }
        DFs_q2 = ((DFv_e+DFs_q)*0.5);
        DFv_j = (DFV_f-(instanceVar_VT*DFs_q2));
        DFdvj_dv = (DFs_q2/DFs_q);
        {
          AdmsSensFadType value_log_0 = log((1.0-(DFv_j/instanceVar_vdcx_t)));
          DFb = value_log_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(((-modelPar_zcx)*DFb));
          DFC_j1 = ((instanceVar_cjcx02_t*value_exp_0)*DFdvj_dv);
        }
        CjCx_ii = (DFC_j1+((2.4*instanceVar_cjcx02_t)*(1.0-DFdvj_dv)));
        {
          AdmsSensFadType value_exp_0 = exp((DFb*(1.0-modelPar_zcx)));
          DFQ_j = (((instanceVar_cjcx02_t*instanceVar_vdcx_t)*(1.0-value_exp_0))/(1.0-modelPar_zcx));
        }
        qjcx0_t_ii = (DFQ_j+((2.4*instanceVar_cjcx02_t)*(Vbpci-DFv_j)));
      }
      else
      {
        CjCx_ii = 0.0;
        qjcx0_t_ii = 0.0;
      }
    }
    DIOY = (Vbpci/(modelPar_mbcx*instanceVar_VT));
    if ((modelPar_ibcxs>0.0))
    {
      if ((DIOY>80.0))
      {
        le = (1+(DIOY-80.0));
        DIOY = 80.0;
      }
      else
      {
        le = 1;
      }
      {
        AdmsSensFadType value_limexp_0 = limexp<AdmsSensFadType>(DIOY);
        le = (le*value_limexp_0);
      }
      instanceVar_ijbcx = (instanceVar_ibcxs_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {
        instanceVar_ijbcx = (-instanceVar_ibcxs_t);
      }
    }
    else
    {
      instanceVar_ijbcx = 0.0;
    }
    if ((instanceVar_vptcx_t<1.0e2))
    {
      if ((instanceVar_cjcx01_t>0.0))
      {
        Dz_r = (modelPar_zcx/4.0);
        Dv_p = (instanceVar_vptcx_t-instanceVar_vdcx_t);
        {
          AdmsSensFadType value_log_0 = log(static_cast<double>(2.4));
          AdmsSensFadType value_exp_1 = exp(((-value_log_0)/modelPar_zcx));
          DV_f = (instanceVar_vdcx_t*(1.0-value_exp_1));
        }
        DC_max = (2.4*instanceVar_cjcx01_t);
        {
          AdmsSensFadType value_log_0 = log((instanceVar_vptcx_t/instanceVar_vdcx_t));
          AdmsSensFadType value_exp_1 = exp(((Dz_r-modelPar_zcx)*value_log_0));
          DC_c = (instanceVar_cjcx01_t*value_exp_1);
        }
        Dv_e = ((DV_f-Vbci)/instanceVar_VT);
        if ((Dv_e<80.0))
        {
          {
            AdmsSensFadType value_exp_0 = exp(Dv_e);
            De = value_exp_0;
          }
          De_1 = (De/(1.0+De));
          {
            AdmsSensFadType value_log_0 = log((1.0+De));
            Dv_j1 = (DV_f-(instanceVar_VT*value_log_0));
          }
        }
        else
        {
          De_1 = 1.0;
          Dv_j1 = Vbci;
        }
        Da = ((0.1*Dv_p)+(4.0*instanceVar_VT));
        Dv_r = ((Dv_p+Dv_j1)/Da);
        if ((Dv_r<80.0))
        {
          {
            AdmsSensFadType value_exp_0 = exp(Dv_r);
            De = value_exp_0;
          }
          De_2 = (De/(1.0+De));
          {
            AdmsSensFadType value_log_0 = log((1.0+De));
            AdmsSensFadType value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
            Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
          }
        }
        else
        {
          De_2 = 1.0;
          Dv_j2 = Dv_j1;
        }
        Dv_j4 = (Vbci-Dv_j1);
        {
          AdmsSensFadType value_log_0 = log((1.0-(Dv_j1/instanceVar_vdcx_t)));
          DCln1 = value_log_0;
        }
        {
          AdmsSensFadType value_log_0 = log((1.0-(Dv_j2/instanceVar_vdcx_t)));
          DCln2 = value_log_0;
        }
        Dz1 = (1.0-modelPar_zcx);
        Dzr1 = (1.0-Dz_r);
        {
          AdmsSensFadType value_exp_0 = exp((DCln2*(-modelPar_zcx)));
          DC_j1 = (((instanceVar_cjcx01_t*value_exp_0)*De_1)*De_2);
        }
        {
          AdmsSensFadType value_exp_0 = exp((DCln1*(-Dz_r)));
          DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
        }
        DC_j3 = (DC_max*(1.0-De_1));
        CjCx_i = ((DC_j1+DC_j2)+DC_j3);
        {
          AdmsSensFadType value_exp_0 = exp((DCln2*Dz1));
          DQ_j1 = ((instanceVar_cjcx01_t*(1.0-value_exp_0))/Dz1);
        }
        {
          AdmsSensFadType value_exp_0 = exp((DCln1*Dzr1));
          DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }
        {
          AdmsSensFadType value_exp_0 = exp((DCln2*Dzr1));
          DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }
        qjcx0_t_i = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceVar_vdcx_t)+(DC_max*Dv_j4));
      }
      else
      {
        CjCx_i = 0.0;
        qjcx0_t_i = 0.0;
      }
    }
    else
    {
      if ((instanceVar_cjcx01_t>0.0))
      {
        {
          AdmsSensFadType value_log_0 = log(static_cast<double>(2.4));
          AdmsSensFadType value_exp_1 = exp(((-value_log_0)/modelPar_zcx));
          DFV_f = (instanceVar_vdcx_t*(1.0-value_exp_1));
        }
        DFv_e = ((DFV_f-Vbci)/instanceVar_VT);
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
          DFs_q = value_sqrt_0;
        }
        DFs_q2 = ((DFv_e+DFs_q)*0.5);
        DFv_j = (DFV_f-(instanceVar_VT*DFs_q2));
        DFdvj_dv = (DFs_q2/DFs_q);
        {
          AdmsSensFadType value_log_0 = log((1.0-(DFv_j/instanceVar_vdcx_t)));
          DFb = value_log_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(((-modelPar_zcx)*DFb));
          DFC_j1 = ((instanceVar_cjcx01_t*value_exp_0)*DFdvj_dv);
        }
        CjCx_i = (DFC_j1+((2.4*instanceVar_cjcx01_t)*(1.0-DFdvj_dv)));
        {
          AdmsSensFadType value_exp_0 = exp((DFb*(1.0-modelPar_zcx)));
          DFQ_j = (((instanceVar_cjcx01_t*instanceVar_vdcx_t)*(1.0-value_exp_0))/(1.0-modelPar_zcx));
        }
        qjcx0_t_i = (DFQ_j+((2.4*instanceVar_cjcx01_t)*(Vbci-DFv_j)));
      }
      else
      {
        CjCx_i = 0.0;
        qjcx0_t_i = 0.0;
      }
    }
    if ((instanceVar_vpts_t<1.0e2))
    {
      if ((instanceVar_cjs0_t>0.0))
      {
        Dz_r = (modelPar_zs/4.0);
        Dv_p = (instanceVar_vpts_t-instanceVar_vds_t);
        {
          AdmsSensFadType value_log_0 = log(static_cast<double>(2.4));
          AdmsSensFadType value_exp_1 = exp(((-value_log_0)/modelPar_zs));
          DV_f = (instanceVar_vds_t*(1.0-value_exp_1));
        }
        DC_max = (2.4*instanceVar_cjs0_t);
        {
          AdmsSensFadType value_log_0 = log((instanceVar_vpts_t/instanceVar_vds_t));
          AdmsSensFadType value_exp_1 = exp(((Dz_r-modelPar_zs)*value_log_0));
          DC_c = (instanceVar_cjs0_t*value_exp_1);
        }
        Dv_e = ((DV_f-Vsici)/instanceVar_VT);
        if ((Dv_e<80.0))
        {
          {
            AdmsSensFadType value_exp_0 = exp(Dv_e);
            De = value_exp_0;
          }
          De_1 = (De/(1.0+De));
          {
            AdmsSensFadType value_log_0 = log((1.0+De));
            Dv_j1 = (DV_f-(instanceVar_VT*value_log_0));
          }
        }
        else
        {
          De_1 = 1.0;
          Dv_j1 = Vsici;
        }
        Da = ((0.1*Dv_p)+(4.0*instanceVar_VT));
        Dv_r = ((Dv_p+Dv_j1)/Da);
        if ((Dv_r<80.0))
        {
          {
            AdmsSensFadType value_exp_0 = exp(Dv_r);
            De = value_exp_0;
          }
          De_2 = (De/(1.0+De));
          {
            AdmsSensFadType value_log_0 = log((1.0+De));
            AdmsSensFadType value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
            Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
          }
        }
        else
        {
          De_2 = 1.0;
          Dv_j2 = Dv_j1;
        }
        Dv_j4 = (Vsici-Dv_j1);
        {
          AdmsSensFadType value_log_0 = log((1.0-(Dv_j1/instanceVar_vds_t)));
          DCln1 = value_log_0;
        }
        {
          AdmsSensFadType value_log_0 = log((1.0-(Dv_j2/instanceVar_vds_t)));
          DCln2 = value_log_0;
        }
        Dz1 = (1.0-modelPar_zs);
        Dzr1 = (1.0-Dz_r);
        {
          AdmsSensFadType value_exp_0 = exp((DCln2*(-modelPar_zs)));
          DC_j1 = (((instanceVar_cjs0_t*value_exp_0)*De_1)*De_2);
        }
        {
          AdmsSensFadType value_exp_0 = exp((DCln1*(-Dz_r)));
          DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
        }
        DC_j3 = (DC_max*(1.0-De_1));
        Cjs = ((DC_j1+DC_j2)+DC_j3);
        {
          AdmsSensFadType value_exp_0 = exp((DCln2*Dz1));
          DQ_j1 = ((instanceVar_cjs0_t*(1.0-value_exp_0))/Dz1);
        }
        {
          AdmsSensFadType value_exp_0 = exp((DCln1*Dzr1));
          DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }
        {
          AdmsSensFadType value_exp_0 = exp((DCln2*Dzr1));
          DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
        }
        Qjs = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceVar_vds_t)+(DC_max*Dv_j4));
      }
      else
      {
        Cjs = 0.0;
        Qjs = 0.0;
      }
    }
    else
    {
      if ((instanceVar_cjs0_t>0.0))
      {
        {
          AdmsSensFadType value_log_0 = log(static_cast<double>(2.4));
          AdmsSensFadType value_exp_1 = exp(((-value_log_0)/modelPar_zs));
          DFV_f = (instanceVar_vds_t*(1.0-value_exp_1));
        }
        DFv_e = ((DFV_f-Vsici)/instanceVar_VT);
        {
          AdmsSensFadType value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
          DFs_q = value_sqrt_0;
        }
        DFs_q2 = ((DFv_e+DFs_q)*0.5);
        DFv_j = (DFV_f-(instanceVar_VT*DFs_q2));
        DFdvj_dv = (DFs_q2/DFs_q);
        {
          AdmsSensFadType value_log_0 = log((1.0-(DFv_j/instanceVar_vds_t)));
          DFb = value_log_0;
        }
        {
          AdmsSensFadType value_exp_0 = exp(((-modelPar_zs)*DFb));
          DFC_j1 = ((instanceVar_cjs0_t*value_exp_0)*DFdvj_dv);
        }
        Cjs = (DFC_j1+((2.4*instanceVar_cjs0_t)*(1.0-DFdvj_dv)));
        {
          AdmsSensFadType value_exp_0 = exp((DFb*(1.0-modelPar_zs)));
          DFQ_j = (((instanceVar_cjs0_t*instanceVar_vds_t)*(1.0-value_exp_0))/(1.0-modelPar_zs));
        }
        Qjs = (DFQ_j+((2.4*instanceVar_cjs0_t)*(Vsici-DFv_j)));
      }
      else
      {
        Cjs = 0.0;
        Qjs = 0.0;
      }
    }
    if ((modelPar_vdsp>0))
    {
      if ((instanceVar_vptsp_t<1.0e2))
      {
        if ((instanceVar_cscp0_t>0.0))
        {
          Dz_r = (modelPar_zsp/4.0);
          Dv_p = (instanceVar_vptsp_t-instanceVar_vdsp_t);
          {
            AdmsSensFadType value_log_0 = log(static_cast<double>(2.4));
            AdmsSensFadType value_exp_1 = exp(((-value_log_0)/modelPar_zsp));
            DV_f = (instanceVar_vdsp_t*(1.0-value_exp_1));
          }
          DC_max = (2.4*instanceVar_cscp0_t);
          {
            AdmsSensFadType value_log_0 = log((instanceVar_vptsp_t/instanceVar_vdsp_t));
            AdmsSensFadType value_exp_1 = exp(((Dz_r-modelPar_zsp)*value_log_0));
            DC_c = (instanceVar_cscp0_t*value_exp_1);
          }
          Dv_e = ((DV_f-Vsc)/instanceVar_VT);
          if ((Dv_e<80.0))
          {
            {
              AdmsSensFadType value_exp_0 = exp(Dv_e);
              De = value_exp_0;
            }
            De_1 = (De/(1.0+De));
            {
              AdmsSensFadType value_log_0 = log((1.0+De));
              Dv_j1 = (DV_f-(instanceVar_VT*value_log_0));
            }
          }
          else
          {
            De_1 = 1.0;
            Dv_j1 = Vsc;
          }
          Da = ((0.1*Dv_p)+(4.0*instanceVar_VT));
          Dv_r = ((Dv_p+Dv_j1)/Da);
          if ((Dv_r<80.0))
          {
            {
              AdmsSensFadType value_exp_0 = exp(Dv_r);
              De = value_exp_0;
            }
            De_2 = (De/(1.0+De));
            {
              AdmsSensFadType value_log_0 = log((1.0+De));
              AdmsSensFadType value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
              Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
            }
          }
          else
          {
            De_2 = 1.0;
            Dv_j2 = Dv_j1;
          }
          Dv_j4 = (Vsc-Dv_j1);
          {
            AdmsSensFadType value_log_0 = log((1.0-(Dv_j1/instanceVar_vdsp_t)));
            DCln1 = value_log_0;
          }
          {
            AdmsSensFadType value_log_0 = log((1.0-(Dv_j2/instanceVar_vdsp_t)));
            DCln2 = value_log_0;
          }
          Dz1 = (1.0-modelPar_zsp);
          Dzr1 = (1.0-Dz_r);
          {
            AdmsSensFadType value_exp_0 = exp((DCln2*(-modelPar_zsp)));
            DC_j1 = (((instanceVar_cscp0_t*value_exp_0)*De_1)*De_2);
          }
          {
            AdmsSensFadType value_exp_0 = exp((DCln1*(-Dz_r)));
            DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
          }
          DC_j3 = (DC_max*(1.0-De_1));
          Cscp = ((DC_j1+DC_j2)+DC_j3);
          {
            AdmsSensFadType value_exp_0 = exp((DCln2*Dz1));
            DQ_j1 = ((instanceVar_cscp0_t*(1.0-value_exp_0))/Dz1);
          }
          {
            AdmsSensFadType value_exp_0 = exp((DCln1*Dzr1));
            DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
          }
          {
            AdmsSensFadType value_exp_0 = exp((DCln2*Dzr1));
            DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
          }
          Qscp = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceVar_vdsp_t)+(DC_max*Dv_j4));
        }
        else
        {
          Cscp = 0.0;
          Qscp = 0.0;
        }
      }
      else
      {
        if ((instanceVar_cscp0_t>0.0))
        {
          {
            AdmsSensFadType value_log_0 = log(static_cast<double>(2.4));
            AdmsSensFadType value_exp_1 = exp(((-value_log_0)/modelPar_zsp));
            DFV_f = (instanceVar_vdsp_t*(1.0-value_exp_1));
          }
          DFv_e = ((DFV_f-Vsc)/instanceVar_VT);
          {
            AdmsSensFadType value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
            DFs_q = value_sqrt_0;
          }
          DFs_q2 = ((DFv_e+DFs_q)*0.5);
          DFv_j = (DFV_f-(instanceVar_VT*DFs_q2));
          DFdvj_dv = (DFs_q2/DFs_q);
          {
            AdmsSensFadType value_log_0 = log((1.0-(DFv_j/instanceVar_vdsp_t)));
            DFb = value_log_0;
          }
          {
            AdmsSensFadType value_exp_0 = exp(((-modelPar_zsp)*DFb));
            DFC_j1 = ((instanceVar_cscp0_t*value_exp_0)*DFdvj_dv);
          }
          Cscp = (DFC_j1+((2.4*instanceVar_cscp0_t)*(1.0-DFdvj_dv)));
          {
            AdmsSensFadType value_exp_0 = exp((DFb*(1.0-modelPar_zsp)));
            DFQ_j = (((instanceVar_cscp0_t*instanceVar_vdsp_t)*(1.0-value_exp_0))/(1.0-modelPar_zsp));
          }
          Qscp = (DFQ_j+((2.4*instanceVar_cscp0_t)*(Vsc-DFv_j)));
        }
        else
        {
          Cscp = 0.0;
          Qscp = 0.0;
        }
      }
    }
    else
    {
      Cscp = modelPar_cscp0;
      Qscp = (modelPar_cscp0*Vsc);
    }
    if ((modelPar_itss>0.0))
      //Begin block Sub_Transfer
    {
      HSUM = (modelPar_msf*instanceVar_VT);
      {
        AdmsSensFadType value_limexp_0 = limexp<AdmsSensFadType>((Vbpci/HSUM));
        HSa = value_limexp_0;
      }
      {
        AdmsSensFadType value_limexp_0 = limexp<AdmsSensFadType>((Vsici/HSUM));
        HSb = value_limexp_0;
      }
      HSI_Tsu = (instanceVar_itss_t*(HSa-HSb));
      if ((modelPar_tsf>0.0))
      {
        Qdsu = ((instanceVar_tsf_t*instanceVar_itss_t)*HSa);
      }
      else
      {
        Qdsu = 0.0;
      }
    }
    // End block Sub_Transfer
    else
    {
      HSI_Tsu = 0.0;
      Qdsu = 0.0;
    }
    if ((instanceVar_ibei>0.0))
    {
      instanceVar_betadc = (instanceVar_it/instanceVar_ibei);
    }
    else
    {
      instanceVar_betadc = 0.0;
    }
    DIOY = (Vsici/(modelPar_msc*instanceVar_VT));
    if ((modelPar_iscs>0.0))
    {
      if ((DIOY>80.0))
      {
        le = (1+(DIOY-80.0));
        DIOY = 80.0;
      }
      else
      {
        le = 1;
      }
      {
        AdmsSensFadType value_limexp_0 = limexp<AdmsSensFadType>(DIOY);
        le = (le*value_limexp_0);
      }
      instanceVar_ijsc = (instanceVar_iscs_t*(le-1.0));
      if ((DIOY<=(-14.0)))
      {
        instanceVar_ijsc = (-instanceVar_iscs_t);
      }
    }
    else
    {
      instanceVar_ijsc = 0.0;
    }
    if (((modelPar_flsh==1)&&(modelPar_rth>=0.001)))
    {
      pterm = ((Vciei*instanceVar_it)+((instanceVar_vdci_t-Vbici)*instanceVar_iavl));
    }
    else
    {
      if (((modelPar_flsh==2)&&(modelPar_rth>=0.001)))
      {
        pterm = (((((((Vciei*instanceVar_it)+((instanceVar_vdci_t-Vbici)*instanceVar_iavl))+(instanceVar_ibei*Vbiei))+(instanceVar_ibci*Vbici))+(instanceVar_ibep*Vbpei))+(instanceVar_ijbcx*Vbpci))+(instanceVar_ijsc*Vsici));
        if ((instanceVar_rbi>=0.001))
        {
          pterm = (pterm+(((probeVars[admsProbeID_V_bp_bi])*(probeVars[admsProbeID_V_bp_bi]))/instanceVar_rbi));
        }
        if ((instanceVar_re_t>=0.001))
        {
          pterm = (pterm+(((probeVars[admsProbeID_V_ei_e])*(probeVars[admsProbeID_V_ei_e]))/instanceVar_re_t));
        }
        if ((instanceVar_rcx_t>=0.001))
        {
          pterm = (pterm+(((probeVars[admsProbeID_V_ci_c])*(probeVars[admsProbeID_V_ci_c]))/instanceVar_rcx_t));
        }
        if ((instanceVar_rbx_t>=0.001))
        {
          pterm = (pterm+(((probeVars[admsProbeID_V_b_bp])*(probeVars[admsProbeID_V_b_bp]))/instanceVar_rbx_t));
        }
      }
    }
    Itxf = itf;
    Qdeix = Qdei;
    if ((((((modelPar_flnqs!=0)||(modelPar_flcomp==0.0))||(modelPar_flcomp==2.1))&&(instanceVar_Tf!=0))&&((modelPar_alit>0)||(modelPar_alqf>0))))
    {
      Vxf1 = (probeVars[admsProbeID_V_xf1_GND]);
      Vxf2 = (probeVars[admsProbeID_V_xf2_GND]);
      Ixf1 = (((Vxf2-itf)/instanceVar_Tf)*modelPar_t0);
      Ixf2 = (((Vxf2-Vxf1)/instanceVar_Tf)*modelPar_t0);
      Qxf1 = ((modelPar_alit*Vxf1)*modelPar_t0);
      Qxf2 = (((modelPar_alit*Vxf2)/3)*modelPar_t0);
      Itxf = Vxf2;
      Vxf = (probeVars[admsProbeID_V_xf_GND]);
      fact = (modelPar_t0/instanceVar_Tf);
      Ixf = ((Vxf-Qdei)*fact);
      Qxf = ((modelPar_alqf*Vxf)*modelPar_t0);
      Qdeix = Vxf;
    }
    else
    {
      Ixf1 = (probeVars[admsProbeID_V_xf1_GND]);
      Ixf2 = (probeVars[admsProbeID_V_xf2_GND]);
      Qxf1 = 0;
      Qxf2 = 0;
      Ixf = (probeVars[admsProbeID_V_xf_GND]);
      Qxf = 0;
    }
  }
  // End block Model_evaluation
  //Begin block Load_sources
  {
    // I(bi,ei) <+ (($simparam("gmin",1e-12)*V(bi,ei)))
    staticContributions[admsNodeID_bi] += (ADMSgmin_arg*(probeVars[admsProbeID_V_bi_ei]));
    staticContributions[admsNodeID_ei] -= (ADMSgmin_arg*(probeVars[admsProbeID_V_bi_ei]));
    // I(bi,ci) <+ (($simparam("gmin",1e-12)*V(bi,ci)))
    staticContributions[admsNodeID_bi] += (ADMSgmin_arg*(probeVars[admsProbeID_V_bi_ci]));
    staticContributions[admsNodeID_ci] -= (ADMSgmin_arg*(probeVars[admsProbeID_V_bi_ci]));
    // I(ci,ei) <+ (($simparam("gmin",1e-12)*V(ci,ei)))
    staticContributions[admsNodeID_ci] += (ADMSgmin_arg*(probeVars[admsProbeID_V_ci_ei]));
    staticContributions[admsNodeID_ei] -= (ADMSgmin_arg*(probeVars[admsProbeID_V_ci_ei]));
    // I(b,ci) <+ (ddt((type*qjcx0_t_i)))
    dynamicContributions[admsNodeID_b] += ((modelPar_type*qjcx0_t_i));
    dynamicContributions[admsNodeID_ci] -= ((modelPar_type*qjcx0_t_i));
    // I(b,ci) <+ (ddt((cbcpar1*V(b,ci))))
    dynamicContributions[admsNodeID_b] += ((instanceVar_cbcpar1*(probeVars[admsProbeID_V_b_ci])));
    dynamicContributions[admsNodeID_ci] -= ((instanceVar_cbcpar1*(probeVars[admsProbeID_V_b_ci])));
    // I(bp,ci) <+ (ddt((cbcpar2*V(bp,ci))))
    dynamicContributions[admsNodeID_bp] += ((instanceVar_cbcpar2*(probeVars[admsProbeID_V_bp_ci])));
    dynamicContributions[admsNodeID_ci] -= ((instanceVar_cbcpar2*(probeVars[admsProbeID_V_bp_ci])));
    if ((modelPar_rbx>=0.001))
    {
      // I(b,bp) <+ ((V(b,bp)/rbx_t))
      staticContributions[admsNodeID_b] += ((probeVars[admsProbeID_V_b_bp])/instanceVar_rbx_t);
      staticContributions[admsNodeID_bp] -= ((probeVars[admsProbeID_V_b_bp])/instanceVar_rbx_t);
    }
    else
    {
      // V(b,bp) <+ (0.0)
      // do nothing at all
    }
    if ((modelPar_rbi0>=0.001))
    {
      // I(bp,bi) <+ ((V(bp,bi)/rbi))
      staticContributions[admsNodeID_bp] += ((probeVars[admsProbeID_V_bp_bi])/instanceVar_rbi);
      staticContributions[admsNodeID_bi] -= ((probeVars[admsProbeID_V_bp_bi])/instanceVar_rbi);
      // I(bp,bi) <+ (ddt(qrbi))
      dynamicContributions[admsNodeID_bp] += (qrbi);
      dynamicContributions[admsNodeID_bi] -= (qrbi);
    }
    else
    {
      // V(bp,bi) <+ (0.0)
      // do nothing at all
    }
    if ((modelPar_tunode==1.0))
    {
      // I(bp,ei) <+ (((-type)*ibet))
      staticContributions[admsNodeID_bp] += ((-modelPar_type)*ibet);
      staticContributions[admsNodeID_ei] -= ((-modelPar_type)*ibet);
    }
    else
    {
      // I(bi,ei) <+ (((-type)*ibet))
      staticContributions[admsNodeID_bi] += ((-modelPar_type)*ibet);
      staticContributions[admsNodeID_ei] -= ((-modelPar_type)*ibet);
    }
    // I(bp,ei) <+ ((type*ibep))
    staticContributions[admsNodeID_bp] += (modelPar_type*instanceVar_ibep);
    staticContributions[admsNodeID_ei] -= (modelPar_type*instanceVar_ibep);
    // I(bp,ei) <+ ((type*irep))
    staticContributions[admsNodeID_bp] += (modelPar_type*irep);
    staticContributions[admsNodeID_ei] -= (modelPar_type*irep);
    // I(bp,ei) <+ (ddt((type*Qjep)))
    dynamicContributions[admsNodeID_bp] += ((modelPar_type*Qjep));
    dynamicContributions[admsNodeID_ei] -= ((modelPar_type*Qjep));
    // I(bi,ei) <+ ((type*ibei))
    staticContributions[admsNodeID_bi] += (modelPar_type*instanceVar_ibei);
    staticContributions[admsNodeID_ei] -= (modelPar_type*instanceVar_ibei);
    // I(bi,ei) <+ ((type*irei))
    staticContributions[admsNodeID_bi] += (modelPar_type*irei);
    staticContributions[admsNodeID_ei] -= (modelPar_type*irei);
    // I(bi,ei) <+ ((type*ibh_rec))
    staticContributions[admsNodeID_bi] += (modelPar_type*ibh_rec);
    staticContributions[admsNodeID_ei] -= (modelPar_type*ibh_rec);
    // I(bi,ei) <+ (ddt((type*(Qdeix+Qjei))))
    dynamicContributions[admsNodeID_bi] += ((modelPar_type*(Qdeix+Qjei)));
    dynamicContributions[admsNodeID_ei] -= ((modelPar_type*(Qdeix+Qjei)));
    // I(bp,si) <+ ((type*HSI_Tsu))
    staticContributions[admsNodeID_bp] += (modelPar_type*HSI_Tsu);
    staticContributions[admsNodeID_si] -= (modelPar_type*HSI_Tsu);
    // I(bp,ci) <+ ((type*ijbcx))
    staticContributions[admsNodeID_bp] += (modelPar_type*instanceVar_ijbcx);
    staticContributions[admsNodeID_ci] -= (modelPar_type*instanceVar_ijbcx);
    // I(bp,ci) <+ (ddt((type*(qjcx0_t_ii+Qdsu))))
    dynamicContributions[admsNodeID_bp] += ((modelPar_type*(qjcx0_t_ii+Qdsu)));
    dynamicContributions[admsNodeID_ci] -= ((modelPar_type*(qjcx0_t_ii+Qdsu)));
    // I(b,e) <+ (ddt((cbepar1*V(b,e))))
    dynamicContributions[admsNodeID_b] += ((instanceVar_cbepar1*(probeVars[admsProbeID_V_b_e])));
    dynamicContributions[admsNodeID_e] -= ((instanceVar_cbepar1*(probeVars[admsProbeID_V_b_e])));
    // I(bp,e) <+ (ddt((cbepar2*V(bp,e))))
    dynamicContributions[admsNodeID_bp] += ((instanceVar_cbepar2*(probeVars[admsProbeID_V_bp_e])));
    dynamicContributions[admsNodeID_e] -= ((instanceVar_cbepar2*(probeVars[admsProbeID_V_bp_e])));
    // I(bi,ci) <+ ((type*(ibci-iavl)))
    staticContributions[admsNodeID_bi] += (modelPar_type*(instanceVar_ibci-instanceVar_iavl));
    staticContributions[admsNodeID_ci] -= (modelPar_type*(instanceVar_ibci-instanceVar_iavl));
    // I(bi,ci) <+ (ddt((type*(Qdci+Qjci))))
    dynamicContributions[admsNodeID_bi] += ((modelPar_type*(Qdci+Qjci)));
    dynamicContributions[admsNodeID_ci] -= ((modelPar_type*(Qdci+Qjci)));
    // I(si,ci) <+ ((type*ijsc))
    staticContributions[admsNodeID_si] += (modelPar_type*instanceVar_ijsc);
    staticContributions[admsNodeID_ci] -= (modelPar_type*instanceVar_ijsc);
    // I(si,ci) <+ (ddt((type*Qjs)))
    dynamicContributions[admsNodeID_si] += ((modelPar_type*Qjs));
    dynamicContributions[admsNodeID_ci] -= ((modelPar_type*Qjs));
    // I(s,c) <+ (ddt((type*Qscp)))
    dynamicContributions[admsNodeID_s] += ((modelPar_type*Qscp));
    dynamicContributions[admsNodeID_c] -= ((modelPar_type*Qscp));
    // I(ci,ei) <+ ((type*Itxf))
    staticContributions[admsNodeID_ci] += (modelPar_type*Itxf);
    staticContributions[admsNodeID_ei] -= (modelPar_type*Itxf);
    // I(ei,ci) <+ ((type*itr))
    staticContributions[admsNodeID_ei] += (modelPar_type*itr);
    staticContributions[admsNodeID_ci] -= (modelPar_type*itr);
    if ((modelPar_rcx>=0.001))
    {
      // I(ci,c) <+ ((V(ci,c)/rcx_t))
      staticContributions[admsNodeID_ci] += ((probeVars[admsProbeID_V_ci_c])/instanceVar_rcx_t);
      staticContributions[admsNodeID_c] -= ((probeVars[admsProbeID_V_ci_c])/instanceVar_rcx_t);
    }
    else
    {
      // V(ci,c) <+ (0.0)
      // do nothing at all
    }
    if ((modelPar_re>=0.001))
    {
      // I(ei,e) <+ ((V(ei,e)/re_t))
      staticContributions[admsNodeID_ei] += ((probeVars[admsProbeID_V_ei_e])/instanceVar_re_t);
      staticContributions[admsNodeID_e] -= ((probeVars[admsProbeID_V_ei_e])/instanceVar_re_t);
    }
    else
    {
      // V(ei,e) <+ (0.0)
      // do nothing at all
    }
    if ((modelPar_rsu>=0.001))
    {
      // I(si,s) <+ ((V(si,s)/rsu))
      staticContributions[admsNodeID_si] += ((probeVars[admsProbeID_V_si_s])/modelPar_rsu);
      staticContributions[admsNodeID_s] -= ((probeVars[admsProbeID_V_si_s])/modelPar_rsu);
      // I(si,s) <+ (ddt((csu*V(si,s))))
      dynamicContributions[admsNodeID_si] += ((modelPar_csu*(probeVars[admsProbeID_V_si_s])));
      dynamicContributions[admsNodeID_s] -= ((modelPar_csu*(probeVars[admsProbeID_V_si_s])));
    }
    else
    {
      // V(si,s) <+ (0.0)
      // do nothing at all
    }
    if (((modelPar_flsh==0)||(modelPar_rth<0.001)))
    {
      // I(tnode,GND) <+ ((V(tnode,GND)/0.001))
      staticContributions[admsNodeID_tnode] += ((probeVars[admsProbeID_V_tnode_GND])/0.001);
    }
    else
    {
      // I(tnode,GND) <+ (((V(tnode,GND)/rth_t)-pterm))
      staticContributions[admsNodeID_tnode] += (((probeVars[admsProbeID_V_tnode_GND])/instanceVar_rth_t)-pterm);
      // I(tnode,GND) <+ (ddt((cth*V(tnode,GND))))
      dynamicContributions[admsNodeID_tnode] += ((modelPar_cth*(probeVars[admsProbeID_V_tnode_GND])));
    }
    // I(xf1,GND) <+ (Ixf1)
    staticContributions[admsNodeID_xf1] += Ixf1;
    // I(xf1,GND) <+ (ddt(Qxf1))
    dynamicContributions[admsNodeID_xf1] += (Qxf1);
    // I(xf2,GND) <+ (Ixf2)
    staticContributions[admsNodeID_xf2] += Ixf2;
    // I(xf2,GND) <+ (ddt(Qxf2))
    dynamicContributions[admsNodeID_xf2] += (Qxf2);
    // I(xf,GND) <+ (Ixf)
    staticContributions[admsNodeID_xf] += Ixf;
    // I(xf,GND) <+ (ddt(Qxf))
    dynamicContributions[admsNodeID_xf] += (Qxf);
  }
  // End block Load_sources
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(15+0);
  dqdp.resize(15+0);
  Findices.resize(15+0);
  Qindices.resize(15+0);

  std::vector <double> probeVars(21);
  std::vector <AdmsSensFadType> staticContributions(15+0);
  std::vector <AdmsSensFadType> dynamicContributions(15+0);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 15+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_c10=mod.c10;
  bool modelPar_given_c10=mod.given("c10");
  AdmsSensFadType modelPar_qp0=mod.qp0;
  bool modelPar_given_qp0=mod.given("qp0");
  AdmsSensFadType modelPar_ich=mod.ich;
  bool modelPar_given_ich=mod.given("ich");
  AdmsSensFadType modelPar_hf0=mod.hf0;
  bool modelPar_given_hf0=mod.given("hf0");
  AdmsSensFadType modelPar_hfe=mod.hfe;
  bool modelPar_given_hfe=mod.given("hfe");
  AdmsSensFadType modelPar_hfc=mod.hfc;
  bool modelPar_given_hfc=mod.given("hfc");
  AdmsSensFadType modelPar_hjei=mod.hjei;
  bool modelPar_given_hjei=mod.given("hjei");
  AdmsSensFadType modelPar_ahjei=mod.ahjei;
  bool modelPar_given_ahjei=mod.given("ahjei");
  AdmsSensFadType modelPar_rhjei=mod.rhjei;
  bool modelPar_given_rhjei=mod.given("rhjei");
  AdmsSensFadType modelPar_hjci=mod.hjci;
  bool modelPar_given_hjci=mod.given("hjci");
  AdmsSensFadType modelPar_ibeis=mod.ibeis;
  bool modelPar_given_ibeis=mod.given("ibeis");
  AdmsSensFadType modelPar_mbei=mod.mbei;
  bool modelPar_given_mbei=mod.given("mbei");
  AdmsSensFadType modelPar_ireis=mod.ireis;
  bool modelPar_given_ireis=mod.given("ireis");
  AdmsSensFadType modelPar_mrei=mod.mrei;
  bool modelPar_given_mrei=mod.given("mrei");
  AdmsSensFadType modelPar_ibeps=mod.ibeps;
  bool modelPar_given_ibeps=mod.given("ibeps");
  AdmsSensFadType modelPar_mbep=mod.mbep;
  bool modelPar_given_mbep=mod.given("mbep");
  AdmsSensFadType modelPar_ireps=mod.ireps;
  bool modelPar_given_ireps=mod.given("ireps");
  AdmsSensFadType modelPar_mrep=mod.mrep;
  bool modelPar_given_mrep=mod.given("mrep");
  AdmsSensFadType modelPar_mcf=mod.mcf;
  bool modelPar_given_mcf=mod.given("mcf");
  AdmsSensFadType modelPar_tbhrec=mod.tbhrec;
  bool modelPar_given_tbhrec=mod.given("tbhrec");
  AdmsSensFadType modelPar_ibcis=mod.ibcis;
  bool modelPar_given_ibcis=mod.given("ibcis");
  AdmsSensFadType modelPar_mbci=mod.mbci;
  bool modelPar_given_mbci=mod.given("mbci");
  AdmsSensFadType modelPar_ibcxs=mod.ibcxs;
  bool modelPar_given_ibcxs=mod.given("ibcxs");
  AdmsSensFadType modelPar_mbcx=mod.mbcx;
  bool modelPar_given_mbcx=mod.given("mbcx");
  AdmsSensFadType modelPar_ibets=mod.ibets;
  bool modelPar_given_ibets=mod.given("ibets");
  AdmsSensFadType modelPar_abet=mod.abet;
  bool modelPar_given_abet=mod.given("abet");
  AdmsSensFadType modelPar_favl=mod.favl;
  bool modelPar_given_favl=mod.given("favl");
  AdmsSensFadType modelPar_qavl=mod.qavl;
  bool modelPar_given_qavl=mod.given("qavl");
  AdmsSensFadType modelPar_kavl=mod.kavl;
  bool modelPar_given_kavl=mod.given("kavl");
  AdmsSensFadType modelPar_alfav=mod.alfav;
  bool modelPar_given_alfav=mod.given("alfav");
  AdmsSensFadType modelPar_alqav=mod.alqav;
  bool modelPar_given_alqav=mod.given("alqav");
  AdmsSensFadType modelPar_alkav=mod.alkav;
  bool modelPar_given_alkav=mod.given("alkav");
  AdmsSensFadType modelPar_rbi0=mod.rbi0;
  bool modelPar_given_rbi0=mod.given("rbi0");
  AdmsSensFadType modelPar_rbx=mod.rbx;
  bool modelPar_given_rbx=mod.given("rbx");
  AdmsSensFadType modelPar_fgeo=mod.fgeo;
  bool modelPar_given_fgeo=mod.given("fgeo");
  AdmsSensFadType modelPar_fdqr0=mod.fdqr0;
  bool modelPar_given_fdqr0=mod.given("fdqr0");
  AdmsSensFadType modelPar_fcrbi=mod.fcrbi;
  bool modelPar_given_fcrbi=mod.given("fcrbi");
  AdmsSensFadType modelPar_fqi=mod.fqi;
  bool modelPar_given_fqi=mod.given("fqi");
  AdmsSensFadType modelPar_re=mod.re;
  bool modelPar_given_re=mod.given("re");
  AdmsSensFadType modelPar_rcx=mod.rcx;
  bool modelPar_given_rcx=mod.given("rcx");
  AdmsSensFadType modelPar_itss=mod.itss;
  bool modelPar_given_itss=mod.given("itss");
  AdmsSensFadType modelPar_msf=mod.msf;
  bool modelPar_given_msf=mod.given("msf");
  AdmsSensFadType modelPar_iscs=mod.iscs;
  bool modelPar_given_iscs=mod.given("iscs");
  AdmsSensFadType modelPar_msc=mod.msc;
  bool modelPar_given_msc=mod.given("msc");
  AdmsSensFadType modelPar_tsf=mod.tsf;
  bool modelPar_given_tsf=mod.given("tsf");
  AdmsSensFadType modelPar_rsu=mod.rsu;
  bool modelPar_given_rsu=mod.given("rsu");
  AdmsSensFadType modelPar_csu=mod.csu;
  bool modelPar_given_csu=mod.given("csu");
  AdmsSensFadType modelPar_cjei0=mod.cjei0;
  bool modelPar_given_cjei0=mod.given("cjei0");
  AdmsSensFadType modelPar_vdei=mod.vdei;
  bool modelPar_given_vdei=mod.given("vdei");
  AdmsSensFadType modelPar_zei=mod.zei;
  bool modelPar_given_zei=mod.given("zei");
  AdmsSensFadType modelPar_ajei=mod.ajei;
  bool modelPar_given_ajei=mod.given("ajei");
  AdmsSensFadType modelPar_cjep0=mod.cjep0;
  bool modelPar_given_cjep0=mod.given("cjep0");
  AdmsSensFadType modelPar_vdep=mod.vdep;
  bool modelPar_given_vdep=mod.given("vdep");
  AdmsSensFadType modelPar_zep=mod.zep;
  bool modelPar_given_zep=mod.given("zep");
  AdmsSensFadType modelPar_ajep=mod.ajep;
  bool modelPar_given_ajep=mod.given("ajep");
  AdmsSensFadType modelPar_cjci0=mod.cjci0;
  bool modelPar_given_cjci0=mod.given("cjci0");
  AdmsSensFadType modelPar_vdci=mod.vdci;
  bool modelPar_given_vdci=mod.given("vdci");
  AdmsSensFadType modelPar_zci=mod.zci;
  bool modelPar_given_zci=mod.given("zci");
  AdmsSensFadType modelPar_vptci=mod.vptci;
  bool modelPar_given_vptci=mod.given("vptci");
  AdmsSensFadType modelPar_cjcx0=mod.cjcx0;
  bool modelPar_given_cjcx0=mod.given("cjcx0");
  AdmsSensFadType modelPar_vdcx=mod.vdcx;
  bool modelPar_given_vdcx=mod.given("vdcx");
  AdmsSensFadType modelPar_zcx=mod.zcx;
  bool modelPar_given_zcx=mod.given("zcx");
  AdmsSensFadType modelPar_vptcx=mod.vptcx;
  bool modelPar_given_vptcx=mod.given("vptcx");
  AdmsSensFadType modelPar_fbcpar=mod.fbcpar;
  bool modelPar_given_fbcpar=mod.given("fbcpar");
  AdmsSensFadType modelPar_fbepar=mod.fbepar;
  bool modelPar_given_fbepar=mod.given("fbepar");
  AdmsSensFadType modelPar_cjs0=mod.cjs0;
  bool modelPar_given_cjs0=mod.given("cjs0");
  AdmsSensFadType modelPar_vds=mod.vds;
  bool modelPar_given_vds=mod.given("vds");
  AdmsSensFadType modelPar_zs=mod.zs;
  bool modelPar_given_zs=mod.given("zs");
  AdmsSensFadType modelPar_vpts=mod.vpts;
  bool modelPar_given_vpts=mod.given("vpts");
  AdmsSensFadType modelPar_cscp0=mod.cscp0;
  bool modelPar_given_cscp0=mod.given("cscp0");
  AdmsSensFadType modelPar_vdsp=mod.vdsp;
  bool modelPar_given_vdsp=mod.given("vdsp");
  AdmsSensFadType modelPar_zsp=mod.zsp;
  bool modelPar_given_zsp=mod.given("zsp");
  AdmsSensFadType modelPar_vptsp=mod.vptsp;
  bool modelPar_given_vptsp=mod.given("vptsp");
  AdmsSensFadType modelPar_t0=mod.t0;
  bool modelPar_given_t0=mod.given("t0");
  AdmsSensFadType modelPar_dt0h=mod.dt0h;
  bool modelPar_given_dt0h=mod.given("dt0h");
  AdmsSensFadType modelPar_tbvl=mod.tbvl;
  bool modelPar_given_tbvl=mod.given("tbvl");
  AdmsSensFadType modelPar_tef0=mod.tef0;
  bool modelPar_given_tef0=mod.given("tef0");
  AdmsSensFadType modelPar_gtfe=mod.gtfe;
  bool modelPar_given_gtfe=mod.given("gtfe");
  AdmsSensFadType modelPar_thcs=mod.thcs;
  bool modelPar_given_thcs=mod.given("thcs");
  AdmsSensFadType modelPar_ahc=mod.ahc;
  bool modelPar_given_ahc=mod.given("ahc");
  AdmsSensFadType modelPar_fthc=mod.fthc;
  bool modelPar_given_fthc=mod.given("fthc");
  AdmsSensFadType modelPar_rci0=mod.rci0;
  bool modelPar_given_rci0=mod.given("rci0");
  AdmsSensFadType modelPar_vlim=mod.vlim;
  bool modelPar_given_vlim=mod.given("vlim");
  AdmsSensFadType modelPar_vces=mod.vces;
  bool modelPar_given_vces=mod.given("vces");
  AdmsSensFadType modelPar_vpt=mod.vpt;
  bool modelPar_given_vpt=mod.given("vpt");
  AdmsSensFadType modelPar_aick=mod.aick;
  bool modelPar_given_aick=mod.given("aick");
  AdmsSensFadType modelPar_delck=mod.delck;
  bool modelPar_given_delck=mod.given("delck");
  AdmsSensFadType modelPar_tr=mod.tr;
  bool modelPar_given_tr=mod.given("tr");
  AdmsSensFadType modelPar_vcbar=mod.vcbar;
  bool modelPar_given_vcbar=mod.given("vcbar");
  AdmsSensFadType modelPar_icbar=mod.icbar;
  bool modelPar_given_icbar=mod.given("icbar");
  AdmsSensFadType modelPar_acbar=mod.acbar;
  bool modelPar_given_acbar=mod.given("acbar");
  AdmsSensFadType modelPar_cbepar=mod.cbepar;
  bool modelPar_given_cbepar=mod.given("cbepar");
  AdmsSensFadType modelPar_cbcpar=mod.cbcpar;
  bool modelPar_given_cbcpar=mod.given("cbcpar");
  AdmsSensFadType modelPar_alqf=mod.alqf;
  bool modelPar_given_alqf=mod.given("alqf");
  AdmsSensFadType modelPar_alit=mod.alit;
  bool modelPar_given_alit=mod.given("alit");
  AdmsSensFadType modelPar_kf=mod.kf;
  bool modelPar_given_kf=mod.given("kf");
  AdmsSensFadType modelPar_af=mod.af;
  bool modelPar_given_af=mod.given("af");
  AdmsSensFadType modelPar_kfre=mod.kfre;
  bool modelPar_given_kfre=mod.given("kfre");
  AdmsSensFadType modelPar_afre=mod.afre;
  bool modelPar_given_afre=mod.given("afre");
  AdmsSensFadType modelPar_latb=mod.latb;
  bool modelPar_given_latb=mod.given("latb");
  AdmsSensFadType modelPar_latl=mod.latl;
  bool modelPar_given_latl=mod.given("latl");
  AdmsSensFadType modelPar_vgb=mod.vgb;
  bool modelPar_given_vgb=mod.given("vgb");
  AdmsSensFadType modelPar_alt0=mod.alt0;
  bool modelPar_given_alt0=mod.given("alt0");
  AdmsSensFadType modelPar_kt0=mod.kt0;
  bool modelPar_given_kt0=mod.given("kt0");
  AdmsSensFadType modelPar_zetaci=mod.zetaci;
  bool modelPar_given_zetaci=mod.given("zetaci");
  AdmsSensFadType modelPar_alvs=mod.alvs;
  bool modelPar_given_alvs=mod.given("alvs");
  AdmsSensFadType modelPar_alces=mod.alces;
  bool modelPar_given_alces=mod.given("alces");
  AdmsSensFadType modelPar_zetarbi=mod.zetarbi;
  bool modelPar_given_zetarbi=mod.given("zetarbi");
  AdmsSensFadType modelPar_zetarbx=mod.zetarbx;
  bool modelPar_given_zetarbx=mod.given("zetarbx");
  AdmsSensFadType modelPar_zetarcx=mod.zetarcx;
  bool modelPar_given_zetarcx=mod.given("zetarcx");
  AdmsSensFadType modelPar_zetare=mod.zetare;
  bool modelPar_given_zetare=mod.given("zetare");
  AdmsSensFadType modelPar_zetacx=mod.zetacx;
  bool modelPar_given_zetacx=mod.given("zetacx");
  AdmsSensFadType modelPar_vge=mod.vge;
  bool modelPar_given_vge=mod.given("vge");
  AdmsSensFadType modelPar_vgc=mod.vgc;
  bool modelPar_given_vgc=mod.given("vgc");
  AdmsSensFadType modelPar_vgs=mod.vgs;
  bool modelPar_given_vgs=mod.given("vgs");
  AdmsSensFadType modelPar_f1vg=mod.f1vg;
  bool modelPar_given_f1vg=mod.given("f1vg");
  AdmsSensFadType modelPar_f2vg=mod.f2vg;
  bool modelPar_given_f2vg=mod.given("f2vg");
  AdmsSensFadType modelPar_zetact=mod.zetact;
  bool modelPar_given_zetact=mod.given("zetact");
  AdmsSensFadType modelPar_zetabet=mod.zetabet;
  bool modelPar_given_zetabet=mod.given("zetabet");
  AdmsSensFadType modelPar_alb=mod.alb;
  bool modelPar_given_alb=mod.given("alb");
  AdmsSensFadType modelPar_dvgbe=mod.dvgbe;
  bool modelPar_given_dvgbe=mod.given("dvgbe");
  AdmsSensFadType modelPar_zetahjei=mod.zetahjei;
  bool modelPar_given_zetahjei=mod.given("zetahjei");
  AdmsSensFadType modelPar_zetavgbe=mod.zetavgbe;
  bool modelPar_given_zetavgbe=mod.given("zetavgbe");
  AdmsSensFadType modelPar_rth=mod.rth;
  bool modelPar_given_rth=mod.given("rth");
  AdmsSensFadType modelPar_zetarth=mod.zetarth;
  bool modelPar_given_zetarth=mod.given("zetarth");
  AdmsSensFadType modelPar_alrth=mod.alrth;
  bool modelPar_given_alrth=mod.given("alrth");
  AdmsSensFadType modelPar_cth=mod.cth;
  bool modelPar_given_cth=mod.given("cth");
  AdmsSensFadType modelPar_flcomp=mod.flcomp;
  bool modelPar_given_flcomp=mod.given("flcomp");
  AdmsSensFadType modelPar_tnom=mod.tnom;
  bool modelPar_given_tnom=mod.given("tnom");
  AdmsSensFadType modelPar_dt=mod.dt;
  bool modelPar_given_dt=mod.given("dt");


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_tunode=mod.tunode;
  bool modelPar_given_tunode=mod.given("tunode");
  int modelPar_flnqs=mod.flnqs;
  bool modelPar_given_flnqs=mod.given("flnqs");
  int modelPar_cfbe=mod.cfbe;
  bool modelPar_given_cfbe=mod.given("cfbe");
  int modelPar_flcono=mod.flcono;
  bool modelPar_given_flcono=mod.given("flcono");
  int modelPar_flsh=mod.flsh;
  bool modelPar_given_flsh=mod.given("flsh");
  int modelPar_type=mod.type;
  bool modelPar_given_type=mod.given("type");



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals
  AdmsSensFadType instanceVar_VT=in.VT;
  AdmsSensFadType instanceVar_Tdev=in.Tdev;
  AdmsSensFadType instanceVar_qtt0=in.qtt0;
  AdmsSensFadType instanceVar_ln_qtt0=in.ln_qtt0;
  AdmsSensFadType instanceVar_r_VgVT=in.r_VgVT;
  AdmsSensFadType instanceVar_V_gT=in.V_gT;
  AdmsSensFadType instanceVar_dT=in.dT;
  AdmsSensFadType instanceVar_k=in.k;
  AdmsSensFadType instanceVar_ireis_t=in.ireis_t;
  AdmsSensFadType instanceVar_ibeis_t=in.ibeis_t;
  AdmsSensFadType instanceVar_ibcxs_t=in.ibcxs_t;
  AdmsSensFadType instanceVar_ibcis_t=in.ibcis_t;
  AdmsSensFadType instanceVar_iscs_t=in.iscs_t;
  AdmsSensFadType instanceVar_cjci0_t=in.cjci0_t;
  AdmsSensFadType instanceVar_cjs0_t=in.cjs0_t;
  AdmsSensFadType instanceVar_cscp0_t=in.cscp0_t;
  AdmsSensFadType instanceVar_rci0_t=in.rci0_t;
  AdmsSensFadType instanceVar_vlim_t=in.vlim_t;
  AdmsSensFadType instanceVar_vces_t=in.vces_t;
  AdmsSensFadType instanceVar_thcs_t=in.thcs_t;
  AdmsSensFadType instanceVar_tef0_t=in.tef0_t;
  AdmsSensFadType instanceVar_rbi0_t=in.rbi0_t;
  AdmsSensFadType instanceVar_t0_t=in.t0_t;
  AdmsSensFadType instanceVar_vdei_t=in.vdei_t;
  AdmsSensFadType instanceVar_vdci_t=in.vdci_t;
  AdmsSensFadType instanceVar_vpts_t=in.vpts_t;
  AdmsSensFadType instanceVar_vptsp_t=in.vptsp_t;
  AdmsSensFadType instanceVar_itss_t=in.itss_t;
  AdmsSensFadType instanceVar_tsf_t=in.tsf_t;
  AdmsSensFadType instanceVar_c10_t=in.c10_t;
  AdmsSensFadType instanceVar_cjei0_t=in.cjei0_t;
  AdmsSensFadType instanceVar_qp0_t=in.qp0_t;
  AdmsSensFadType instanceVar_vdcx_t=in.vdcx_t;
  AdmsSensFadType instanceVar_vptcx_t=in.vptcx_t;
  AdmsSensFadType instanceVar_cjcx01_t=in.cjcx01_t;
  AdmsSensFadType instanceVar_cjcx02_t=in.cjcx02_t;
  AdmsSensFadType instanceVar_cratio_t=in.cratio_t;
  AdmsSensFadType instanceVar_ibeps_t=in.ibeps_t;
  AdmsSensFadType instanceVar_ireps_t=in.ireps_t;
  AdmsSensFadType instanceVar_cjep0_t=in.cjep0_t;
  AdmsSensFadType instanceVar_ajei_t=in.ajei_t;
  AdmsSensFadType instanceVar_qavl_t=in.qavl_t;
  AdmsSensFadType instanceVar_favl_t=in.favl_t;
  AdmsSensFadType instanceVar_kavl_t=in.kavl_t;
  AdmsSensFadType instanceVar_ibets_t=in.ibets_t;
  AdmsSensFadType instanceVar_abet_t=in.abet_t;
  AdmsSensFadType instanceVar_vptci_t=in.vptci_t;
  AdmsSensFadType instanceVar_vdep_t=in.vdep_t;
  AdmsSensFadType instanceVar_ajep_t=in.ajep_t;
  AdmsSensFadType instanceVar_zetatef=in.zetatef;
  AdmsSensFadType instanceVar_k1=in.k1;
  AdmsSensFadType instanceVar_k2=in.k2;
  AdmsSensFadType instanceVar_dvg0=in.dvg0;
  AdmsSensFadType instanceVar_vge_t=in.vge_t;
  AdmsSensFadType instanceVar_vgb_t=in.vgb_t;
  AdmsSensFadType instanceVar_vgbe_t=in.vgbe_t;
  AdmsSensFadType instanceVar_vds_t=in.vds_t;
  AdmsSensFadType instanceVar_vdsp_t=in.vdsp_t;
  AdmsSensFadType instanceVar_vt0=in.vt0;
  AdmsSensFadType instanceVar_Tnom=in.Tnom;
  AdmsSensFadType instanceVar_Tamb=in.Tamb;
  AdmsSensFadType instanceVar_a=in.a;
  AdmsSensFadType instanceVar_avs=in.avs;
  AdmsSensFadType instanceVar_zetabci=in.zetabci;
  AdmsSensFadType instanceVar_zetabcxt=in.zetabcxt;
  AdmsSensFadType instanceVar_zetasct=in.zetasct;
  AdmsSensFadType instanceVar_vgbe0=in.vgbe0;
  AdmsSensFadType instanceVar_mg=in.mg;
  AdmsSensFadType instanceVar_vgbe_t0=in.vgbe_t0;
  AdmsSensFadType instanceVar_vgbc0=in.vgbc0;
  AdmsSensFadType instanceVar_vgsc0=in.vgsc0;
  AdmsSensFadType instanceVar_cbcpar1=in.cbcpar1;
  AdmsSensFadType instanceVar_cbcpar2=in.cbcpar2;
  AdmsSensFadType instanceVar_cbepar2=in.cbepar2;
  AdmsSensFadType instanceVar_cbepar1=in.cbepar1;
  AdmsSensFadType instanceVar_Oich=in.Oich;
  AdmsSensFadType instanceVar_Otbhrec=in.Otbhrec;
  AdmsSensFadType instanceVar_it=in.it;
  AdmsSensFadType instanceVar_ibei=in.ibei;
  AdmsSensFadType instanceVar_ibci=in.ibci;
  AdmsSensFadType instanceVar_ibep=in.ibep;
  AdmsSensFadType instanceVar_iavl=in.iavl;
  AdmsSensFadType instanceVar_ijbcx=in.ijbcx;
  AdmsSensFadType instanceVar_ijsc=in.ijsc;
  AdmsSensFadType instanceVar_rth_t=in.rth_t;
  AdmsSensFadType instanceVar_vdj0=in.vdj0;
  AdmsSensFadType instanceVar_vdjt=in.vdjt;
  AdmsSensFadType instanceVar_vdt=in.vdt;
  AdmsSensFadType instanceVar_Tf=in.Tf;
  AdmsSensFadType instanceVar_cjcx01=in.cjcx01;
  AdmsSensFadType instanceVar_cjcx02=in.cjcx02;
  AdmsSensFadType instanceVar_betadc=in.betadc;
  AdmsSensFadType instanceVar_hjei0_t=in.hjei0_t;
  AdmsSensFadType instanceVar_ahjei_t=in.ahjei_t;
  AdmsSensFadType instanceVar_hf0_t=in.hf0_t;
  AdmsSensFadType instanceVar_hfe_t=in.hfe_t;
  AdmsSensFadType instanceVar_hfc_t=in.hfc_t;
  AdmsSensFadType instanceVar_rbx_t=in.rbx_t;
  AdmsSensFadType instanceVar_rcx_t=in.rcx_t;
  AdmsSensFadType instanceVar_re_t=in.re_t;
  AdmsSensFadType instanceVar_rbi=in.rbi;


  //non-reals
  int instanceVar_use_aval=in.use_aval;


  //make local copies of all model vars
  //reals


  // non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.
  probeVars[in.admsProbeID_V_n2_GND] = (*solVectorPtr)[in.li_n2];
  probeVars[in.admsProbeID_V_n1_GND] = (*solVectorPtr)[in.li_n1];
  probeVars[in.admsProbeID_V_si_s] = (*solVectorPtr)[in.li_si]- (*solVectorPtr)[in.li_s];
  probeVars[in.admsProbeID_V_bp_e] = (*solVectorPtr)[in.li_bp]- (*solVectorPtr)[in.li_e];
  probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_e];
  probeVars[in.admsProbeID_V_ci_ei] = (*solVectorPtr)[in.li_ci]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_xf_GND] = (*solVectorPtr)[in.li_xf];
  probeVars[in.admsProbeID_V_xf2_GND] = (*solVectorPtr)[in.li_xf2];
  probeVars[in.admsProbeID_V_xf1_GND] = (*solVectorPtr)[in.li_xf1];
  probeVars[in.admsProbeID_V_b_bp] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_bp];
  probeVars[in.admsProbeID_V_ci_c] = (*solVectorPtr)[in.li_ci]- (*solVectorPtr)[in.li_c];
  probeVars[in.admsProbeID_V_ei_e] = (*solVectorPtr)[in.li_ei]- (*solVectorPtr)[in.li_e];
  probeVars[in.admsProbeID_V_bp_bi] = (*solVectorPtr)[in.li_bp]- (*solVectorPtr)[in.li_bi];
  probeVars[in.admsProbeID_V_tnode_GND] = (*solVectorPtr)[in.li_tnode];
  probeVars[in.admsProbeID_V_s_c] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_c];
  probeVars[in.admsProbeID_V_si_ci] = (*solVectorPtr)[in.li_si]- (*solVectorPtr)[in.li_ci];
  probeVars[in.admsProbeID_V_b_ci] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_ci];
  probeVars[in.admsProbeID_V_bp_ci] = (*solVectorPtr)[in.li_bp]- (*solVectorPtr)[in.li_ci];
  probeVars[in.admsProbeID_V_bp_ei] = (*solVectorPtr)[in.li_bp]- (*solVectorPtr)[in.li_ei];
  probeVars[in.admsProbeID_V_bi_ci] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_ci];
  probeVars[in.admsProbeID_V_bi_ei] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_ei];


  evaluateInitialInstance(
     // instance variables
     // reals
     instanceVar_VT,
     instanceVar_Tdev,
     instanceVar_qtt0,
     instanceVar_ln_qtt0,
     instanceVar_r_VgVT,
     instanceVar_V_gT,
     instanceVar_dT,
     instanceVar_k,
     instanceVar_ireis_t,
     instanceVar_ibeis_t,
     instanceVar_ibcxs_t,
     instanceVar_ibcis_t,
     instanceVar_iscs_t,
     instanceVar_cjci0_t,
     instanceVar_cjs0_t,
     instanceVar_cscp0_t,
     instanceVar_rci0_t,
     instanceVar_vlim_t,
     instanceVar_vces_t,
     instanceVar_thcs_t,
     instanceVar_tef0_t,
     instanceVar_rbi0_t,
     instanceVar_t0_t,
     instanceVar_vdei_t,
     instanceVar_vdci_t,
     instanceVar_vpts_t,
     instanceVar_vptsp_t,
     instanceVar_itss_t,
     instanceVar_tsf_t,
     instanceVar_c10_t,
     instanceVar_cjei0_t,
     instanceVar_qp0_t,
     instanceVar_vdcx_t,
     instanceVar_vptcx_t,
     instanceVar_cjcx01_t,
     instanceVar_cjcx02_t,
     instanceVar_cratio_t,
     instanceVar_ibeps_t,
     instanceVar_ireps_t,
     instanceVar_cjep0_t,
     instanceVar_ajei_t,
     instanceVar_qavl_t,
     instanceVar_favl_t,
     instanceVar_kavl_t,
     instanceVar_ibets_t,
     instanceVar_abet_t,
     instanceVar_vptci_t,
     instanceVar_vdep_t,
     instanceVar_ajep_t,
     instanceVar_zetatef,
     instanceVar_k1,
     instanceVar_k2,
     instanceVar_dvg0,
     instanceVar_vge_t,
     instanceVar_vgb_t,
     instanceVar_vgbe_t,
     instanceVar_vds_t,
     instanceVar_vdsp_t,
     instanceVar_vt0,
     instanceVar_Tnom,
     instanceVar_Tamb,
     instanceVar_a,
     instanceVar_avs,
     instanceVar_zetabci,
     instanceVar_zetabcxt,
     instanceVar_zetasct,
     instanceVar_vgbe0,
     instanceVar_mg,
     instanceVar_vgbe_t0,
     instanceVar_vgbc0,
     instanceVar_vgsc0,
     instanceVar_cbcpar1,
     instanceVar_cbcpar2,
     instanceVar_cbepar2,
     instanceVar_cbepar1,
     instanceVar_Oich,
     instanceVar_Otbhrec,
     instanceVar_it,
     instanceVar_ibei,
     instanceVar_ibci,
     instanceVar_ibep,
     instanceVar_iavl,
     instanceVar_ijbcx,
     instanceVar_ijsc,
     instanceVar_rth_t,
     instanceVar_vdj0,
     instanceVar_vdjt,
     instanceVar_vdt,
     instanceVar_Tf,
     instanceVar_cjcx01,
     instanceVar_cjcx02,
     instanceVar_betadc,
     instanceVar_hjei0_t,
     instanceVar_ahjei_t,
     instanceVar_hf0_t,
     instanceVar_hfe_t,
     instanceVar_hfc_t,
     instanceVar_rbx_t,
     instanceVar_rcx_t,
     instanceVar_re_t,
     instanceVar_rbi,
     // non-reals
     instanceVar_use_aval,
     // model parameters
     // reals
     modelPar_c10,
     modelPar_given_c10,
     modelPar_qp0,
     modelPar_given_qp0,
     modelPar_ich,
     modelPar_given_ich,
     modelPar_hf0,
     modelPar_given_hf0,
     modelPar_hfe,
     modelPar_given_hfe,
     modelPar_hfc,
     modelPar_given_hfc,
     modelPar_hjei,
     modelPar_given_hjei,
     modelPar_ahjei,
     modelPar_given_ahjei,
     modelPar_rhjei,
     modelPar_given_rhjei,
     modelPar_hjci,
     modelPar_given_hjci,
     modelPar_ibeis,
     modelPar_given_ibeis,
     modelPar_mbei,
     modelPar_given_mbei,
     modelPar_ireis,
     modelPar_given_ireis,
     modelPar_mrei,
     modelPar_given_mrei,
     modelPar_ibeps,
     modelPar_given_ibeps,
     modelPar_mbep,
     modelPar_given_mbep,
     modelPar_ireps,
     modelPar_given_ireps,
     modelPar_mrep,
     modelPar_given_mrep,
     modelPar_mcf,
     modelPar_given_mcf,
     modelPar_tbhrec,
     modelPar_given_tbhrec,
     modelPar_ibcis,
     modelPar_given_ibcis,
     modelPar_mbci,
     modelPar_given_mbci,
     modelPar_ibcxs,
     modelPar_given_ibcxs,
     modelPar_mbcx,
     modelPar_given_mbcx,
     modelPar_ibets,
     modelPar_given_ibets,
     modelPar_abet,
     modelPar_given_abet,
     modelPar_favl,
     modelPar_given_favl,
     modelPar_qavl,
     modelPar_given_qavl,
     modelPar_kavl,
     modelPar_given_kavl,
     modelPar_alfav,
     modelPar_given_alfav,
     modelPar_alqav,
     modelPar_given_alqav,
     modelPar_alkav,
     modelPar_given_alkav,
     modelPar_rbi0,
     modelPar_given_rbi0,
     modelPar_rbx,
     modelPar_given_rbx,
     modelPar_fgeo,
     modelPar_given_fgeo,
     modelPar_fdqr0,
     modelPar_given_fdqr0,
     modelPar_fcrbi,
     modelPar_given_fcrbi,
     modelPar_fqi,
     modelPar_given_fqi,
     modelPar_re,
     modelPar_given_re,
     modelPar_rcx,
     modelPar_given_rcx,
     modelPar_itss,
     modelPar_given_itss,
     modelPar_msf,
     modelPar_given_msf,
     modelPar_iscs,
     modelPar_given_iscs,
     modelPar_msc,
     modelPar_given_msc,
     modelPar_tsf,
     modelPar_given_tsf,
     modelPar_rsu,
     modelPar_given_rsu,
     modelPar_csu,
     modelPar_given_csu,
     modelPar_cjei0,
     modelPar_given_cjei0,
     modelPar_vdei,
     modelPar_given_vdei,
     modelPar_zei,
     modelPar_given_zei,
     modelPar_ajei,
     modelPar_given_ajei,
     modelPar_cjep0,
     modelPar_given_cjep0,
     modelPar_vdep,
     modelPar_given_vdep,
     modelPar_zep,
     modelPar_given_zep,
     modelPar_ajep,
     modelPar_given_ajep,
     modelPar_cjci0,
     modelPar_given_cjci0,
     modelPar_vdci,
     modelPar_given_vdci,
     modelPar_zci,
     modelPar_given_zci,
     modelPar_vptci,
     modelPar_given_vptci,
     modelPar_cjcx0,
     modelPar_given_cjcx0,
     modelPar_vdcx,
     modelPar_given_vdcx,
     modelPar_zcx,
     modelPar_given_zcx,
     modelPar_vptcx,
     modelPar_given_vptcx,
     modelPar_fbcpar,
     modelPar_given_fbcpar,
     modelPar_fbepar,
     modelPar_given_fbepar,
     modelPar_cjs0,
     modelPar_given_cjs0,
     modelPar_vds,
     modelPar_given_vds,
     modelPar_zs,
     modelPar_given_zs,
     modelPar_vpts,
     modelPar_given_vpts,
     modelPar_cscp0,
     modelPar_given_cscp0,
     modelPar_vdsp,
     modelPar_given_vdsp,
     modelPar_zsp,
     modelPar_given_zsp,
     modelPar_vptsp,
     modelPar_given_vptsp,
     modelPar_t0,
     modelPar_given_t0,
     modelPar_dt0h,
     modelPar_given_dt0h,
     modelPar_tbvl,
     modelPar_given_tbvl,
     modelPar_tef0,
     modelPar_given_tef0,
     modelPar_gtfe,
     modelPar_given_gtfe,
     modelPar_thcs,
     modelPar_given_thcs,
     modelPar_ahc,
     modelPar_given_ahc,
     modelPar_fthc,
     modelPar_given_fthc,
     modelPar_rci0,
     modelPar_given_rci0,
     modelPar_vlim,
     modelPar_given_vlim,
     modelPar_vces,
     modelPar_given_vces,
     modelPar_vpt,
     modelPar_given_vpt,
     modelPar_aick,
     modelPar_given_aick,
     modelPar_delck,
     modelPar_given_delck,
     modelPar_tr,
     modelPar_given_tr,
     modelPar_vcbar,
     modelPar_given_vcbar,
     modelPar_icbar,
     modelPar_given_icbar,
     modelPar_acbar,
     modelPar_given_acbar,
     modelPar_cbepar,
     modelPar_given_cbepar,
     modelPar_cbcpar,
     modelPar_given_cbcpar,
     modelPar_alqf,
     modelPar_given_alqf,
     modelPar_alit,
     modelPar_given_alit,
     modelPar_kf,
     modelPar_given_kf,
     modelPar_af,
     modelPar_given_af,
     modelPar_kfre,
     modelPar_given_kfre,
     modelPar_afre,
     modelPar_given_afre,
     modelPar_latb,
     modelPar_given_latb,
     modelPar_latl,
     modelPar_given_latl,
     modelPar_vgb,
     modelPar_given_vgb,
     modelPar_alt0,
     modelPar_given_alt0,
     modelPar_kt0,
     modelPar_given_kt0,
     modelPar_zetaci,
     modelPar_given_zetaci,
     modelPar_alvs,
     modelPar_given_alvs,
     modelPar_alces,
     modelPar_given_alces,
     modelPar_zetarbi,
     modelPar_given_zetarbi,
     modelPar_zetarbx,
     modelPar_given_zetarbx,
     modelPar_zetarcx,
     modelPar_given_zetarcx,
     modelPar_zetare,
     modelPar_given_zetare,
     modelPar_zetacx,
     modelPar_given_zetacx,
     modelPar_vge,
     modelPar_given_vge,
     modelPar_vgc,
     modelPar_given_vgc,
     modelPar_vgs,
     modelPar_given_vgs,
     modelPar_f1vg,
     modelPar_given_f1vg,
     modelPar_f2vg,
     modelPar_given_f2vg,
     modelPar_zetact,
     modelPar_given_zetact,
     modelPar_zetabet,
     modelPar_given_zetabet,
     modelPar_alb,
     modelPar_given_alb,
     modelPar_dvgbe,
     modelPar_given_dvgbe,
     modelPar_zetahjei,
     modelPar_given_zetahjei,
     modelPar_zetavgbe,
     modelPar_given_zetavgbe,
     modelPar_rth,
     modelPar_given_rth,
     modelPar_zetarth,
     modelPar_given_zetarth,
     modelPar_alrth,
     modelPar_given_alrth,
     modelPar_cth,
     modelPar_given_cth,
     modelPar_flcomp,
     modelPar_given_flcomp,
     modelPar_tnom,
     modelPar_given_tnom,
     modelPar_dt,
     modelPar_given_dt,
     // non-reals (including hidden)
     modelPar_tunode,
     modelPar_given_tunode,
     modelPar_flnqs,
     modelPar_given_flnqs,
     modelPar_cfbe,
     modelPar_given_cfbe,
     modelPar_flcono,
     modelPar_given_flcono,
     modelPar_flsh,
     modelPar_given_flsh,
     modelPar_type,
     modelPar_given_type,
     in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_n2_GND,
     in.admsProbeID_V_n1_GND,
     in.admsProbeID_V_si_s,
     in.admsProbeID_V_bp_e,
     in.admsProbeID_V_b_e,
     in.admsProbeID_V_ci_ei,
     in.admsProbeID_V_xf_GND,
     in.admsProbeID_V_xf2_GND,
     in.admsProbeID_V_xf1_GND,
     in.admsProbeID_V_b_bp,
     in.admsProbeID_V_ci_c,
     in.admsProbeID_V_ei_e,
     in.admsProbeID_V_bp_bi,
     in.admsProbeID_V_tnode_GND,
     in.admsProbeID_V_s_c,
     in.admsProbeID_V_si_ci,
     in.admsProbeID_V_b_ci,
     in.admsProbeID_V_bp_ci,
     in.admsProbeID_V_bp_ei,
     in.admsProbeID_V_bi_ci,
     in.admsProbeID_V_bi_ei,

     // node constants
     in.admsNodeID_c,
     in.admsNodeID_b,
     in.admsNodeID_e,
     in.admsNodeID_s,
     in.admsNodeID_tnode,
     in.admsNodeID_ci,
     in.admsNodeID_ei,
     in.admsNodeID_bp,
     in.admsNodeID_bi,
     in.admsNodeID_si,
     in.admsNodeID_xf1,
     in.admsNodeID_xf2,
     in.admsNodeID_xf,
     in.admsNodeID_n1,
     in.admsNodeID_n2,
     // instance variables
     // reals
     instanceVar_VT,
     instanceVar_Tdev,
     instanceVar_qtt0,
     instanceVar_ln_qtt0,
     instanceVar_r_VgVT,
     instanceVar_V_gT,
     instanceVar_dT,
     instanceVar_k,
     instanceVar_ireis_t,
     instanceVar_ibeis_t,
     instanceVar_ibcxs_t,
     instanceVar_ibcis_t,
     instanceVar_iscs_t,
     instanceVar_cjci0_t,
     instanceVar_cjs0_t,
     instanceVar_cscp0_t,
     instanceVar_rci0_t,
     instanceVar_vlim_t,
     instanceVar_vces_t,
     instanceVar_thcs_t,
     instanceVar_tef0_t,
     instanceVar_rbi0_t,
     instanceVar_t0_t,
     instanceVar_vdei_t,
     instanceVar_vdci_t,
     instanceVar_vpts_t,
     instanceVar_vptsp_t,
     instanceVar_itss_t,
     instanceVar_tsf_t,
     instanceVar_c10_t,
     instanceVar_cjei0_t,
     instanceVar_qp0_t,
     instanceVar_vdcx_t,
     instanceVar_vptcx_t,
     instanceVar_cjcx01_t,
     instanceVar_cjcx02_t,
     instanceVar_cratio_t,
     instanceVar_ibeps_t,
     instanceVar_ireps_t,
     instanceVar_cjep0_t,
     instanceVar_ajei_t,
     instanceVar_qavl_t,
     instanceVar_favl_t,
     instanceVar_kavl_t,
     instanceVar_ibets_t,
     instanceVar_abet_t,
     instanceVar_vptci_t,
     instanceVar_vdep_t,
     instanceVar_ajep_t,
     instanceVar_zetatef,
     instanceVar_k1,
     instanceVar_k2,
     instanceVar_dvg0,
     instanceVar_vge_t,
     instanceVar_vgb_t,
     instanceVar_vgbe_t,
     instanceVar_vds_t,
     instanceVar_vdsp_t,
     instanceVar_vt0,
     instanceVar_Tnom,
     instanceVar_Tamb,
     instanceVar_a,
     instanceVar_avs,
     instanceVar_zetabci,
     instanceVar_zetabcxt,
     instanceVar_zetasct,
     instanceVar_vgbe0,
     instanceVar_mg,
     instanceVar_vgbe_t0,
     instanceVar_vgbc0,
     instanceVar_vgsc0,
     instanceVar_cbcpar1,
     instanceVar_cbcpar2,
     instanceVar_cbepar2,
     instanceVar_cbepar1,
     instanceVar_Oich,
     instanceVar_Otbhrec,
     instanceVar_it,
     instanceVar_ibei,
     instanceVar_ibci,
     instanceVar_ibep,
     instanceVar_iavl,
     instanceVar_ijbcx,
     instanceVar_ijsc,
     instanceVar_rth_t,
     instanceVar_vdj0,
     instanceVar_vdjt,
     instanceVar_vdt,
     instanceVar_Tf,
     instanceVar_cjcx01,
     instanceVar_cjcx02,
     instanceVar_betadc,
     instanceVar_hjei0_t,
     instanceVar_ahjei_t,
     instanceVar_hf0_t,
     instanceVar_hfe_t,
     instanceVar_hfc_t,
     instanceVar_rbx_t,
     instanceVar_rcx_t,
     instanceVar_re_t,
     instanceVar_rbi,
     // non-reals
     instanceVar_use_aval,
     // model parameters
     // reals
     modelPar_c10,
     modelPar_given_c10,
     modelPar_qp0,
     modelPar_given_qp0,
     modelPar_ich,
     modelPar_given_ich,
     modelPar_hf0,
     modelPar_given_hf0,
     modelPar_hfe,
     modelPar_given_hfe,
     modelPar_hfc,
     modelPar_given_hfc,
     modelPar_hjei,
     modelPar_given_hjei,
     modelPar_ahjei,
     modelPar_given_ahjei,
     modelPar_rhjei,
     modelPar_given_rhjei,
     modelPar_hjci,
     modelPar_given_hjci,
     modelPar_ibeis,
     modelPar_given_ibeis,
     modelPar_mbei,
     modelPar_given_mbei,
     modelPar_ireis,
     modelPar_given_ireis,
     modelPar_mrei,
     modelPar_given_mrei,
     modelPar_ibeps,
     modelPar_given_ibeps,
     modelPar_mbep,
     modelPar_given_mbep,
     modelPar_ireps,
     modelPar_given_ireps,
     modelPar_mrep,
     modelPar_given_mrep,
     modelPar_mcf,
     modelPar_given_mcf,
     modelPar_tbhrec,
     modelPar_given_tbhrec,
     modelPar_ibcis,
     modelPar_given_ibcis,
     modelPar_mbci,
     modelPar_given_mbci,
     modelPar_ibcxs,
     modelPar_given_ibcxs,
     modelPar_mbcx,
     modelPar_given_mbcx,
     modelPar_ibets,
     modelPar_given_ibets,
     modelPar_abet,
     modelPar_given_abet,
     modelPar_favl,
     modelPar_given_favl,
     modelPar_qavl,
     modelPar_given_qavl,
     modelPar_kavl,
     modelPar_given_kavl,
     modelPar_alfav,
     modelPar_given_alfav,
     modelPar_alqav,
     modelPar_given_alqav,
     modelPar_alkav,
     modelPar_given_alkav,
     modelPar_rbi0,
     modelPar_given_rbi0,
     modelPar_rbx,
     modelPar_given_rbx,
     modelPar_fgeo,
     modelPar_given_fgeo,
     modelPar_fdqr0,
     modelPar_given_fdqr0,
     modelPar_fcrbi,
     modelPar_given_fcrbi,
     modelPar_fqi,
     modelPar_given_fqi,
     modelPar_re,
     modelPar_given_re,
     modelPar_rcx,
     modelPar_given_rcx,
     modelPar_itss,
     modelPar_given_itss,
     modelPar_msf,
     modelPar_given_msf,
     modelPar_iscs,
     modelPar_given_iscs,
     modelPar_msc,
     modelPar_given_msc,
     modelPar_tsf,
     modelPar_given_tsf,
     modelPar_rsu,
     modelPar_given_rsu,
     modelPar_csu,
     modelPar_given_csu,
     modelPar_cjei0,
     modelPar_given_cjei0,
     modelPar_vdei,
     modelPar_given_vdei,
     modelPar_zei,
     modelPar_given_zei,
     modelPar_ajei,
     modelPar_given_ajei,
     modelPar_cjep0,
     modelPar_given_cjep0,
     modelPar_vdep,
     modelPar_given_vdep,
     modelPar_zep,
     modelPar_given_zep,
     modelPar_ajep,
     modelPar_given_ajep,
     modelPar_cjci0,
     modelPar_given_cjci0,
     modelPar_vdci,
     modelPar_given_vdci,
     modelPar_zci,
     modelPar_given_zci,
     modelPar_vptci,
     modelPar_given_vptci,
     modelPar_cjcx0,
     modelPar_given_cjcx0,
     modelPar_vdcx,
     modelPar_given_vdcx,
     modelPar_zcx,
     modelPar_given_zcx,
     modelPar_vptcx,
     modelPar_given_vptcx,
     modelPar_fbcpar,
     modelPar_given_fbcpar,
     modelPar_fbepar,
     modelPar_given_fbepar,
     modelPar_cjs0,
     modelPar_given_cjs0,
     modelPar_vds,
     modelPar_given_vds,
     modelPar_zs,
     modelPar_given_zs,
     modelPar_vpts,
     modelPar_given_vpts,
     modelPar_cscp0,
     modelPar_given_cscp0,
     modelPar_vdsp,
     modelPar_given_vdsp,
     modelPar_zsp,
     modelPar_given_zsp,
     modelPar_vptsp,
     modelPar_given_vptsp,
     modelPar_t0,
     modelPar_given_t0,
     modelPar_dt0h,
     modelPar_given_dt0h,
     modelPar_tbvl,
     modelPar_given_tbvl,
     modelPar_tef0,
     modelPar_given_tef0,
     modelPar_gtfe,
     modelPar_given_gtfe,
     modelPar_thcs,
     modelPar_given_thcs,
     modelPar_ahc,
     modelPar_given_ahc,
     modelPar_fthc,
     modelPar_given_fthc,
     modelPar_rci0,
     modelPar_given_rci0,
     modelPar_vlim,
     modelPar_given_vlim,
     modelPar_vces,
     modelPar_given_vces,
     modelPar_vpt,
     modelPar_given_vpt,
     modelPar_aick,
     modelPar_given_aick,
     modelPar_delck,
     modelPar_given_delck,
     modelPar_tr,
     modelPar_given_tr,
     modelPar_vcbar,
     modelPar_given_vcbar,
     modelPar_icbar,
     modelPar_given_icbar,
     modelPar_acbar,
     modelPar_given_acbar,
     modelPar_cbepar,
     modelPar_given_cbepar,
     modelPar_cbcpar,
     modelPar_given_cbcpar,
     modelPar_alqf,
     modelPar_given_alqf,
     modelPar_alit,
     modelPar_given_alit,
     modelPar_kf,
     modelPar_given_kf,
     modelPar_af,
     modelPar_given_af,
     modelPar_kfre,
     modelPar_given_kfre,
     modelPar_afre,
     modelPar_given_afre,
     modelPar_latb,
     modelPar_given_latb,
     modelPar_latl,
     modelPar_given_latl,
     modelPar_vgb,
     modelPar_given_vgb,
     modelPar_alt0,
     modelPar_given_alt0,
     modelPar_kt0,
     modelPar_given_kt0,
     modelPar_zetaci,
     modelPar_given_zetaci,
     modelPar_alvs,
     modelPar_given_alvs,
     modelPar_alces,
     modelPar_given_alces,
     modelPar_zetarbi,
     modelPar_given_zetarbi,
     modelPar_zetarbx,
     modelPar_given_zetarbx,
     modelPar_zetarcx,
     modelPar_given_zetarcx,
     modelPar_zetare,
     modelPar_given_zetare,
     modelPar_zetacx,
     modelPar_given_zetacx,
     modelPar_vge,
     modelPar_given_vge,
     modelPar_vgc,
     modelPar_given_vgc,
     modelPar_vgs,
     modelPar_given_vgs,
     modelPar_f1vg,
     modelPar_given_f1vg,
     modelPar_f2vg,
     modelPar_given_f2vg,
     modelPar_zetact,
     modelPar_given_zetact,
     modelPar_zetabet,
     modelPar_given_zetabet,
     modelPar_alb,
     modelPar_given_alb,
     modelPar_dvgbe,
     modelPar_given_dvgbe,
     modelPar_zetahjei,
     modelPar_given_zetahjei,
     modelPar_zetavgbe,
     modelPar_given_zetavgbe,
     modelPar_rth,
     modelPar_given_rth,
     modelPar_zetarth,
     modelPar_given_zetarth,
     modelPar_alrth,
     modelPar_given_alrth,
     modelPar_cth,
     modelPar_given_cth,
     modelPar_flcomp,
     modelPar_given_flcomp,
     modelPar_tnom,
     modelPar_given_tnom,
     modelPar_dt,
     modelPar_given_dt,
     // non-reals (including hidden)
     modelPar_tunode,
     modelPar_given_tunode,
     modelPar_flnqs,
     modelPar_given_flnqs,
     modelPar_cfbe,
     modelPar_given_cfbe,
     modelPar_flcono,
     modelPar_given_flcono,
     modelPar_flsh,
     modelPar_given_flsh,
     modelPar_type,
     modelPar_given_type,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_c] += staticContributions[in.admsNodeID_c].dx(0);
  dqdp[in.admsNodeID_c] += dynamicContributions[in.admsNodeID_c].dx(0);
  Findices[in.admsNodeID_c] = in.li_c;
  Qindices[in.admsNodeID_c] = in.li_c;
  dfdp[in.admsNodeID_b] += staticContributions[in.admsNodeID_b].dx(0);
  dqdp[in.admsNodeID_b] += dynamicContributions[in.admsNodeID_b].dx(0);
  Findices[in.admsNodeID_b] = in.li_b;
  Qindices[in.admsNodeID_b] = in.li_b;
  dfdp[in.admsNodeID_e] += staticContributions[in.admsNodeID_e].dx(0);
  dqdp[in.admsNodeID_e] += dynamicContributions[in.admsNodeID_e].dx(0);
  Findices[in.admsNodeID_e] = in.li_e;
  Qindices[in.admsNodeID_e] = in.li_e;
  dfdp[in.admsNodeID_s] += staticContributions[in.admsNodeID_s].dx(0);
  dqdp[in.admsNodeID_s] += dynamicContributions[in.admsNodeID_s].dx(0);
  Findices[in.admsNodeID_s] = in.li_s;
  Qindices[in.admsNodeID_s] = in.li_s;
  dfdp[in.admsNodeID_tnode] += staticContributions[in.admsNodeID_tnode].dx(0);
  dqdp[in.admsNodeID_tnode] += dynamicContributions[in.admsNodeID_tnode].dx(0);
  Findices[in.admsNodeID_tnode] = in.li_tnode;
  Qindices[in.admsNodeID_tnode] = in.li_tnode;
  dfdp[in.admsNodeID_ci] += staticContributions[in.admsNodeID_ci].dx(0);
  dqdp[in.admsNodeID_ci] += dynamicContributions[in.admsNodeID_ci].dx(0);
  Findices[in.admsNodeID_ci] = in.li_ci;
  Qindices[in.admsNodeID_ci] = in.li_ci;
  dfdp[in.admsNodeID_ei] += staticContributions[in.admsNodeID_ei].dx(0);
  dqdp[in.admsNodeID_ei] += dynamicContributions[in.admsNodeID_ei].dx(0);
  Findices[in.admsNodeID_ei] = in.li_ei;
  Qindices[in.admsNodeID_ei] = in.li_ei;
  dfdp[in.admsNodeID_bp] += staticContributions[in.admsNodeID_bp].dx(0);
  dqdp[in.admsNodeID_bp] += dynamicContributions[in.admsNodeID_bp].dx(0);
  Findices[in.admsNodeID_bp] = in.li_bp;
  Qindices[in.admsNodeID_bp] = in.li_bp;
  dfdp[in.admsNodeID_bi] += staticContributions[in.admsNodeID_bi].dx(0);
  dqdp[in.admsNodeID_bi] += dynamicContributions[in.admsNodeID_bi].dx(0);
  Findices[in.admsNodeID_bi] = in.li_bi;
  Qindices[in.admsNodeID_bi] = in.li_bi;
  dfdp[in.admsNodeID_si] += staticContributions[in.admsNodeID_si].dx(0);
  dqdp[in.admsNodeID_si] += dynamicContributions[in.admsNodeID_si].dx(0);
  Findices[in.admsNodeID_si] = in.li_si;
  Qindices[in.admsNodeID_si] = in.li_si;
  dfdp[in.admsNodeID_xf1] += staticContributions[in.admsNodeID_xf1].dx(0);
  dqdp[in.admsNodeID_xf1] += dynamicContributions[in.admsNodeID_xf1].dx(0);
  Findices[in.admsNodeID_xf1] = in.li_xf1;
  Qindices[in.admsNodeID_xf1] = in.li_xf1;
  dfdp[in.admsNodeID_xf2] += staticContributions[in.admsNodeID_xf2].dx(0);
  dqdp[in.admsNodeID_xf2] += dynamicContributions[in.admsNodeID_xf2].dx(0);
  Findices[in.admsNodeID_xf2] = in.li_xf2;
  Qindices[in.admsNodeID_xf2] = in.li_xf2;
  dfdp[in.admsNodeID_xf] += staticContributions[in.admsNodeID_xf].dx(0);
  dqdp[in.admsNodeID_xf] += dynamicContributions[in.admsNodeID_xf].dx(0);
  Findices[in.admsNodeID_xf] = in.li_xf;
  Qindices[in.admsNodeID_xf] = in.li_xf;
  dfdp[in.admsNodeID_n1] += staticContributions[in.admsNodeID_n1].dx(0);
  dqdp[in.admsNodeID_n1] += dynamicContributions[in.admsNodeID_n1].dx(0);
  Findices[in.admsNodeID_n1] = in.li_n1;
  Qindices[in.admsNodeID_n1] = in.li_n1;
  dfdp[in.admsNodeID_n2] += staticContributions[in.admsNodeID_n2].dx(0);
  dqdp[in.admsNodeID_n2] += dynamicContributions[in.admsNodeID_n2].dx(0);
  Findices[in.admsNodeID_n2] = in.li_n2;
  Qindices[in.admsNodeID_n2] = in.li_n2;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((15+0)*sizeInstance);
  dqdp.resize((15+0)*sizeInstance);
  Findices.resize((15+0)*sizeInstance);
  Qindices.resize((15+0)*sizeInstance);

  std::vector <double> probeVars(21);
  std::vector <AdmsSensFadType> staticContributions(15+0);
  std::vector <AdmsSensFadType> dynamicContributions(15+0);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_c10=mod.c10;
  bool modelPar_given_c10=mod.given("c10");
  modParamMap["c10"] = &modelPar_c10;
  AdmsSensFadType modelPar_qp0=mod.qp0;
  bool modelPar_given_qp0=mod.given("qp0");
  modParamMap["qp0"] = &modelPar_qp0;
  AdmsSensFadType modelPar_ich=mod.ich;
  bool modelPar_given_ich=mod.given("ich");
  modParamMap["ich"] = &modelPar_ich;
  AdmsSensFadType modelPar_hf0=mod.hf0;
  bool modelPar_given_hf0=mod.given("hf0");
  modParamMap["hf0"] = &modelPar_hf0;
  AdmsSensFadType modelPar_hfe=mod.hfe;
  bool modelPar_given_hfe=mod.given("hfe");
  modParamMap["hfe"] = &modelPar_hfe;
  AdmsSensFadType modelPar_hfc=mod.hfc;
  bool modelPar_given_hfc=mod.given("hfc");
  modParamMap["hfc"] = &modelPar_hfc;
  AdmsSensFadType modelPar_hjei=mod.hjei;
  bool modelPar_given_hjei=mod.given("hjei");
  modParamMap["hjei"] = &modelPar_hjei;
  AdmsSensFadType modelPar_ahjei=mod.ahjei;
  bool modelPar_given_ahjei=mod.given("ahjei");
  modParamMap["ahjei"] = &modelPar_ahjei;
  AdmsSensFadType modelPar_rhjei=mod.rhjei;
  bool modelPar_given_rhjei=mod.given("rhjei");
  modParamMap["rhjei"] = &modelPar_rhjei;
  AdmsSensFadType modelPar_hjci=mod.hjci;
  bool modelPar_given_hjci=mod.given("hjci");
  modParamMap["hjci"] = &modelPar_hjci;
  AdmsSensFadType modelPar_ibeis=mod.ibeis;
  bool modelPar_given_ibeis=mod.given("ibeis");
  modParamMap["ibeis"] = &modelPar_ibeis;
  AdmsSensFadType modelPar_mbei=mod.mbei;
  bool modelPar_given_mbei=mod.given("mbei");
  modParamMap["mbei"] = &modelPar_mbei;
  AdmsSensFadType modelPar_ireis=mod.ireis;
  bool modelPar_given_ireis=mod.given("ireis");
  modParamMap["ireis"] = &modelPar_ireis;
  AdmsSensFadType modelPar_mrei=mod.mrei;
  bool modelPar_given_mrei=mod.given("mrei");
  modParamMap["mrei"] = &modelPar_mrei;
  AdmsSensFadType modelPar_ibeps=mod.ibeps;
  bool modelPar_given_ibeps=mod.given("ibeps");
  modParamMap["ibeps"] = &modelPar_ibeps;
  AdmsSensFadType modelPar_mbep=mod.mbep;
  bool modelPar_given_mbep=mod.given("mbep");
  modParamMap["mbep"] = &modelPar_mbep;
  AdmsSensFadType modelPar_ireps=mod.ireps;
  bool modelPar_given_ireps=mod.given("ireps");
  modParamMap["ireps"] = &modelPar_ireps;
  AdmsSensFadType modelPar_mrep=mod.mrep;
  bool modelPar_given_mrep=mod.given("mrep");
  modParamMap["mrep"] = &modelPar_mrep;
  AdmsSensFadType modelPar_mcf=mod.mcf;
  bool modelPar_given_mcf=mod.given("mcf");
  modParamMap["mcf"] = &modelPar_mcf;
  AdmsSensFadType modelPar_tbhrec=mod.tbhrec;
  bool modelPar_given_tbhrec=mod.given("tbhrec");
  modParamMap["tbhrec"] = &modelPar_tbhrec;
  AdmsSensFadType modelPar_ibcis=mod.ibcis;
  bool modelPar_given_ibcis=mod.given("ibcis");
  modParamMap["ibcis"] = &modelPar_ibcis;
  AdmsSensFadType modelPar_mbci=mod.mbci;
  bool modelPar_given_mbci=mod.given("mbci");
  modParamMap["mbci"] = &modelPar_mbci;
  AdmsSensFadType modelPar_ibcxs=mod.ibcxs;
  bool modelPar_given_ibcxs=mod.given("ibcxs");
  modParamMap["ibcxs"] = &modelPar_ibcxs;
  AdmsSensFadType modelPar_mbcx=mod.mbcx;
  bool modelPar_given_mbcx=mod.given("mbcx");
  modParamMap["mbcx"] = &modelPar_mbcx;
  AdmsSensFadType modelPar_ibets=mod.ibets;
  bool modelPar_given_ibets=mod.given("ibets");
  modParamMap["ibets"] = &modelPar_ibets;
  AdmsSensFadType modelPar_abet=mod.abet;
  bool modelPar_given_abet=mod.given("abet");
  modParamMap["abet"] = &modelPar_abet;
  AdmsSensFadType modelPar_favl=mod.favl;
  bool modelPar_given_favl=mod.given("favl");
  modParamMap["favl"] = &modelPar_favl;
  AdmsSensFadType modelPar_qavl=mod.qavl;
  bool modelPar_given_qavl=mod.given("qavl");
  modParamMap["qavl"] = &modelPar_qavl;
  AdmsSensFadType modelPar_kavl=mod.kavl;
  bool modelPar_given_kavl=mod.given("kavl");
  modParamMap["kavl"] = &modelPar_kavl;
  AdmsSensFadType modelPar_alfav=mod.alfav;
  bool modelPar_given_alfav=mod.given("alfav");
  modParamMap["alfav"] = &modelPar_alfav;
  AdmsSensFadType modelPar_alqav=mod.alqav;
  bool modelPar_given_alqav=mod.given("alqav");
  modParamMap["alqav"] = &modelPar_alqav;
  AdmsSensFadType modelPar_alkav=mod.alkav;
  bool modelPar_given_alkav=mod.given("alkav");
  modParamMap["alkav"] = &modelPar_alkav;
  AdmsSensFadType modelPar_rbi0=mod.rbi0;
  bool modelPar_given_rbi0=mod.given("rbi0");
  modParamMap["rbi0"] = &modelPar_rbi0;
  AdmsSensFadType modelPar_rbx=mod.rbx;
  bool modelPar_given_rbx=mod.given("rbx");
  modParamMap["rbx"] = &modelPar_rbx;
  AdmsSensFadType modelPar_fgeo=mod.fgeo;
  bool modelPar_given_fgeo=mod.given("fgeo");
  modParamMap["fgeo"] = &modelPar_fgeo;
  AdmsSensFadType modelPar_fdqr0=mod.fdqr0;
  bool modelPar_given_fdqr0=mod.given("fdqr0");
  modParamMap["fdqr0"] = &modelPar_fdqr0;
  AdmsSensFadType modelPar_fcrbi=mod.fcrbi;
  bool modelPar_given_fcrbi=mod.given("fcrbi");
  modParamMap["fcrbi"] = &modelPar_fcrbi;
  AdmsSensFadType modelPar_fqi=mod.fqi;
  bool modelPar_given_fqi=mod.given("fqi");
  modParamMap["fqi"] = &modelPar_fqi;
  AdmsSensFadType modelPar_re=mod.re;
  bool modelPar_given_re=mod.given("re");
  modParamMap["re"] = &modelPar_re;
  AdmsSensFadType modelPar_rcx=mod.rcx;
  bool modelPar_given_rcx=mod.given("rcx");
  modParamMap["rcx"] = &modelPar_rcx;
  AdmsSensFadType modelPar_itss=mod.itss;
  bool modelPar_given_itss=mod.given("itss");
  modParamMap["itss"] = &modelPar_itss;
  AdmsSensFadType modelPar_msf=mod.msf;
  bool modelPar_given_msf=mod.given("msf");
  modParamMap["msf"] = &modelPar_msf;
  AdmsSensFadType modelPar_iscs=mod.iscs;
  bool modelPar_given_iscs=mod.given("iscs");
  modParamMap["iscs"] = &modelPar_iscs;
  AdmsSensFadType modelPar_msc=mod.msc;
  bool modelPar_given_msc=mod.given("msc");
  modParamMap["msc"] = &modelPar_msc;
  AdmsSensFadType modelPar_tsf=mod.tsf;
  bool modelPar_given_tsf=mod.given("tsf");
  modParamMap["tsf"] = &modelPar_tsf;
  AdmsSensFadType modelPar_rsu=mod.rsu;
  bool modelPar_given_rsu=mod.given("rsu");
  modParamMap["rsu"] = &modelPar_rsu;
  AdmsSensFadType modelPar_csu=mod.csu;
  bool modelPar_given_csu=mod.given("csu");
  modParamMap["csu"] = &modelPar_csu;
  AdmsSensFadType modelPar_cjei0=mod.cjei0;
  bool modelPar_given_cjei0=mod.given("cjei0");
  modParamMap["cjei0"] = &modelPar_cjei0;
  AdmsSensFadType modelPar_vdei=mod.vdei;
  bool modelPar_given_vdei=mod.given("vdei");
  modParamMap["vdei"] = &modelPar_vdei;
  AdmsSensFadType modelPar_zei=mod.zei;
  bool modelPar_given_zei=mod.given("zei");
  modParamMap["zei"] = &modelPar_zei;
  AdmsSensFadType modelPar_ajei=mod.ajei;
  bool modelPar_given_ajei=mod.given("ajei");
  modParamMap["ajei"] = &modelPar_ajei;
  AdmsSensFadType modelPar_cjep0=mod.cjep0;
  bool modelPar_given_cjep0=mod.given("cjep0");
  modParamMap["cjep0"] = &modelPar_cjep0;
  AdmsSensFadType modelPar_vdep=mod.vdep;
  bool modelPar_given_vdep=mod.given("vdep");
  modParamMap["vdep"] = &modelPar_vdep;
  AdmsSensFadType modelPar_zep=mod.zep;
  bool modelPar_given_zep=mod.given("zep");
  modParamMap["zep"] = &modelPar_zep;
  AdmsSensFadType modelPar_ajep=mod.ajep;
  bool modelPar_given_ajep=mod.given("ajep");
  modParamMap["ajep"] = &modelPar_ajep;
  AdmsSensFadType modelPar_cjci0=mod.cjci0;
  bool modelPar_given_cjci0=mod.given("cjci0");
  modParamMap["cjci0"] = &modelPar_cjci0;
  AdmsSensFadType modelPar_vdci=mod.vdci;
  bool modelPar_given_vdci=mod.given("vdci");
  modParamMap["vdci"] = &modelPar_vdci;
  AdmsSensFadType modelPar_zci=mod.zci;
  bool modelPar_given_zci=mod.given("zci");
  modParamMap["zci"] = &modelPar_zci;
  AdmsSensFadType modelPar_vptci=mod.vptci;
  bool modelPar_given_vptci=mod.given("vptci");
  modParamMap["vptci"] = &modelPar_vptci;
  AdmsSensFadType modelPar_cjcx0=mod.cjcx0;
  bool modelPar_given_cjcx0=mod.given("cjcx0");
  modParamMap["cjcx0"] = &modelPar_cjcx0;
  AdmsSensFadType modelPar_vdcx=mod.vdcx;
  bool modelPar_given_vdcx=mod.given("vdcx");
  modParamMap["vdcx"] = &modelPar_vdcx;
  AdmsSensFadType modelPar_zcx=mod.zcx;
  bool modelPar_given_zcx=mod.given("zcx");
  modParamMap["zcx"] = &modelPar_zcx;
  AdmsSensFadType modelPar_vptcx=mod.vptcx;
  bool modelPar_given_vptcx=mod.given("vptcx");
  modParamMap["vptcx"] = &modelPar_vptcx;
  AdmsSensFadType modelPar_fbcpar=mod.fbcpar;
  bool modelPar_given_fbcpar=mod.given("fbcpar");
  modParamMap["fbcpar"] = &modelPar_fbcpar;
  AdmsSensFadType modelPar_fbepar=mod.fbepar;
  bool modelPar_given_fbepar=mod.given("fbepar");
  modParamMap["fbepar"] = &modelPar_fbepar;
  AdmsSensFadType modelPar_cjs0=mod.cjs0;
  bool modelPar_given_cjs0=mod.given("cjs0");
  modParamMap["cjs0"] = &modelPar_cjs0;
  AdmsSensFadType modelPar_vds=mod.vds;
  bool modelPar_given_vds=mod.given("vds");
  modParamMap["vds"] = &modelPar_vds;
  AdmsSensFadType modelPar_zs=mod.zs;
  bool modelPar_given_zs=mod.given("zs");
  modParamMap["zs"] = &modelPar_zs;
  AdmsSensFadType modelPar_vpts=mod.vpts;
  bool modelPar_given_vpts=mod.given("vpts");
  modParamMap["vpts"] = &modelPar_vpts;
  AdmsSensFadType modelPar_cscp0=mod.cscp0;
  bool modelPar_given_cscp0=mod.given("cscp0");
  modParamMap["cscp0"] = &modelPar_cscp0;
  AdmsSensFadType modelPar_vdsp=mod.vdsp;
  bool modelPar_given_vdsp=mod.given("vdsp");
  modParamMap["vdsp"] = &modelPar_vdsp;
  AdmsSensFadType modelPar_zsp=mod.zsp;
  bool modelPar_given_zsp=mod.given("zsp");
  modParamMap["zsp"] = &modelPar_zsp;
  AdmsSensFadType modelPar_vptsp=mod.vptsp;
  bool modelPar_given_vptsp=mod.given("vptsp");
  modParamMap["vptsp"] = &modelPar_vptsp;
  AdmsSensFadType modelPar_t0=mod.t0;
  bool modelPar_given_t0=mod.given("t0");
  modParamMap["t0"] = &modelPar_t0;
  AdmsSensFadType modelPar_dt0h=mod.dt0h;
  bool modelPar_given_dt0h=mod.given("dt0h");
  modParamMap["dt0h"] = &modelPar_dt0h;
  AdmsSensFadType modelPar_tbvl=mod.tbvl;
  bool modelPar_given_tbvl=mod.given("tbvl");
  modParamMap["tbvl"] = &modelPar_tbvl;
  AdmsSensFadType modelPar_tef0=mod.tef0;
  bool modelPar_given_tef0=mod.given("tef0");
  modParamMap["tef0"] = &modelPar_tef0;
  AdmsSensFadType modelPar_gtfe=mod.gtfe;
  bool modelPar_given_gtfe=mod.given("gtfe");
  modParamMap["gtfe"] = &modelPar_gtfe;
  AdmsSensFadType modelPar_thcs=mod.thcs;
  bool modelPar_given_thcs=mod.given("thcs");
  modParamMap["thcs"] = &modelPar_thcs;
  AdmsSensFadType modelPar_ahc=mod.ahc;
  bool modelPar_given_ahc=mod.given("ahc");
  modParamMap["ahc"] = &modelPar_ahc;
  AdmsSensFadType modelPar_fthc=mod.fthc;
  bool modelPar_given_fthc=mod.given("fthc");
  modParamMap["fthc"] = &modelPar_fthc;
  AdmsSensFadType modelPar_rci0=mod.rci0;
  bool modelPar_given_rci0=mod.given("rci0");
  modParamMap["rci0"] = &modelPar_rci0;
  AdmsSensFadType modelPar_vlim=mod.vlim;
  bool modelPar_given_vlim=mod.given("vlim");
  modParamMap["vlim"] = &modelPar_vlim;
  AdmsSensFadType modelPar_vces=mod.vces;
  bool modelPar_given_vces=mod.given("vces");
  modParamMap["vces"] = &modelPar_vces;
  AdmsSensFadType modelPar_vpt=mod.vpt;
  bool modelPar_given_vpt=mod.given("vpt");
  modParamMap["vpt"] = &modelPar_vpt;
  AdmsSensFadType modelPar_aick=mod.aick;
  bool modelPar_given_aick=mod.given("aick");
  modParamMap["aick"] = &modelPar_aick;
  AdmsSensFadType modelPar_delck=mod.delck;
  bool modelPar_given_delck=mod.given("delck");
  modParamMap["delck"] = &modelPar_delck;
  AdmsSensFadType modelPar_tr=mod.tr;
  bool modelPar_given_tr=mod.given("tr");
  modParamMap["tr"] = &modelPar_tr;
  AdmsSensFadType modelPar_vcbar=mod.vcbar;
  bool modelPar_given_vcbar=mod.given("vcbar");
  modParamMap["vcbar"] = &modelPar_vcbar;
  AdmsSensFadType modelPar_icbar=mod.icbar;
  bool modelPar_given_icbar=mod.given("icbar");
  modParamMap["icbar"] = &modelPar_icbar;
  AdmsSensFadType modelPar_acbar=mod.acbar;
  bool modelPar_given_acbar=mod.given("acbar");
  modParamMap["acbar"] = &modelPar_acbar;
  AdmsSensFadType modelPar_cbepar=mod.cbepar;
  bool modelPar_given_cbepar=mod.given("cbepar");
  modParamMap["cbepar"] = &modelPar_cbepar;
  AdmsSensFadType modelPar_cbcpar=mod.cbcpar;
  bool modelPar_given_cbcpar=mod.given("cbcpar");
  modParamMap["cbcpar"] = &modelPar_cbcpar;
  AdmsSensFadType modelPar_alqf=mod.alqf;
  bool modelPar_given_alqf=mod.given("alqf");
  modParamMap["alqf"] = &modelPar_alqf;
  AdmsSensFadType modelPar_alit=mod.alit;
  bool modelPar_given_alit=mod.given("alit");
  modParamMap["alit"] = &modelPar_alit;
  AdmsSensFadType modelPar_kf=mod.kf;
  bool modelPar_given_kf=mod.given("kf");
  modParamMap["kf"] = &modelPar_kf;
  AdmsSensFadType modelPar_af=mod.af;
  bool modelPar_given_af=mod.given("af");
  modParamMap["af"] = &modelPar_af;
  AdmsSensFadType modelPar_kfre=mod.kfre;
  bool modelPar_given_kfre=mod.given("kfre");
  modParamMap["kfre"] = &modelPar_kfre;
  AdmsSensFadType modelPar_afre=mod.afre;
  bool modelPar_given_afre=mod.given("afre");
  modParamMap["afre"] = &modelPar_afre;
  AdmsSensFadType modelPar_latb=mod.latb;
  bool modelPar_given_latb=mod.given("latb");
  modParamMap["latb"] = &modelPar_latb;
  AdmsSensFadType modelPar_latl=mod.latl;
  bool modelPar_given_latl=mod.given("latl");
  modParamMap["latl"] = &modelPar_latl;
  AdmsSensFadType modelPar_vgb=mod.vgb;
  bool modelPar_given_vgb=mod.given("vgb");
  modParamMap["vgb"] = &modelPar_vgb;
  AdmsSensFadType modelPar_alt0=mod.alt0;
  bool modelPar_given_alt0=mod.given("alt0");
  modParamMap["alt0"] = &modelPar_alt0;
  AdmsSensFadType modelPar_kt0=mod.kt0;
  bool modelPar_given_kt0=mod.given("kt0");
  modParamMap["kt0"] = &modelPar_kt0;
  AdmsSensFadType modelPar_zetaci=mod.zetaci;
  bool modelPar_given_zetaci=mod.given("zetaci");
  modParamMap["zetaci"] = &modelPar_zetaci;
  AdmsSensFadType modelPar_alvs=mod.alvs;
  bool modelPar_given_alvs=mod.given("alvs");
  modParamMap["alvs"] = &modelPar_alvs;
  AdmsSensFadType modelPar_alces=mod.alces;
  bool modelPar_given_alces=mod.given("alces");
  modParamMap["alces"] = &modelPar_alces;
  AdmsSensFadType modelPar_zetarbi=mod.zetarbi;
  bool modelPar_given_zetarbi=mod.given("zetarbi");
  modParamMap["zetarbi"] = &modelPar_zetarbi;
  AdmsSensFadType modelPar_zetarbx=mod.zetarbx;
  bool modelPar_given_zetarbx=mod.given("zetarbx");
  modParamMap["zetarbx"] = &modelPar_zetarbx;
  AdmsSensFadType modelPar_zetarcx=mod.zetarcx;
  bool modelPar_given_zetarcx=mod.given("zetarcx");
  modParamMap["zetarcx"] = &modelPar_zetarcx;
  AdmsSensFadType modelPar_zetare=mod.zetare;
  bool modelPar_given_zetare=mod.given("zetare");
  modParamMap["zetare"] = &modelPar_zetare;
  AdmsSensFadType modelPar_zetacx=mod.zetacx;
  bool modelPar_given_zetacx=mod.given("zetacx");
  modParamMap["zetacx"] = &modelPar_zetacx;
  AdmsSensFadType modelPar_vge=mod.vge;
  bool modelPar_given_vge=mod.given("vge");
  modParamMap["vge"] = &modelPar_vge;
  AdmsSensFadType modelPar_vgc=mod.vgc;
  bool modelPar_given_vgc=mod.given("vgc");
  modParamMap["vgc"] = &modelPar_vgc;
  AdmsSensFadType modelPar_vgs=mod.vgs;
  bool modelPar_given_vgs=mod.given("vgs");
  modParamMap["vgs"] = &modelPar_vgs;
  AdmsSensFadType modelPar_f1vg=mod.f1vg;
  bool modelPar_given_f1vg=mod.given("f1vg");
  modParamMap["f1vg"] = &modelPar_f1vg;
  AdmsSensFadType modelPar_f2vg=mod.f2vg;
  bool modelPar_given_f2vg=mod.given("f2vg");
  modParamMap["f2vg"] = &modelPar_f2vg;
  AdmsSensFadType modelPar_zetact=mod.zetact;
  bool modelPar_given_zetact=mod.given("zetact");
  modParamMap["zetact"] = &modelPar_zetact;
  AdmsSensFadType modelPar_zetabet=mod.zetabet;
  bool modelPar_given_zetabet=mod.given("zetabet");
  modParamMap["zetabet"] = &modelPar_zetabet;
  AdmsSensFadType modelPar_alb=mod.alb;
  bool modelPar_given_alb=mod.given("alb");
  modParamMap["alb"] = &modelPar_alb;
  AdmsSensFadType modelPar_dvgbe=mod.dvgbe;
  bool modelPar_given_dvgbe=mod.given("dvgbe");
  modParamMap["dvgbe"] = &modelPar_dvgbe;
  AdmsSensFadType modelPar_zetahjei=mod.zetahjei;
  bool modelPar_given_zetahjei=mod.given("zetahjei");
  modParamMap["zetahjei"] = &modelPar_zetahjei;
  AdmsSensFadType modelPar_zetavgbe=mod.zetavgbe;
  bool modelPar_given_zetavgbe=mod.given("zetavgbe");
  modParamMap["zetavgbe"] = &modelPar_zetavgbe;
  AdmsSensFadType modelPar_rth=mod.rth;
  bool modelPar_given_rth=mod.given("rth");
  modParamMap["rth"] = &modelPar_rth;
  AdmsSensFadType modelPar_zetarth=mod.zetarth;
  bool modelPar_given_zetarth=mod.given("zetarth");
  modParamMap["zetarth"] = &modelPar_zetarth;
  AdmsSensFadType modelPar_alrth=mod.alrth;
  bool modelPar_given_alrth=mod.given("alrth");
  modParamMap["alrth"] = &modelPar_alrth;
  AdmsSensFadType modelPar_cth=mod.cth;
  bool modelPar_given_cth=mod.given("cth");
  modParamMap["cth"] = &modelPar_cth;
  AdmsSensFadType modelPar_flcomp=mod.flcomp;
  bool modelPar_given_flcomp=mod.given("flcomp");
  modParamMap["flcomp"] = &modelPar_flcomp;
  AdmsSensFadType modelPar_tnom=mod.tnom;
  bool modelPar_given_tnom=mod.given("tnom");
  modParamMap["tnom"] = &modelPar_tnom;
  AdmsSensFadType modelPar_dt=mod.dt;
  bool modelPar_given_dt=mod.given("dt");
  modParamMap["dt"] = &modelPar_dt;


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_tunode=mod.tunode;
  bool modelPar_given_tunode=mod.given("tunode");
  int modelPar_flnqs=mod.flnqs;
  bool modelPar_given_flnqs=mod.given("flnqs");
  int modelPar_cfbe=mod.cfbe;
  bool modelPar_given_cfbe=mod.given("cfbe");
  int modelPar_flcono=mod.flcono;
  bool modelPar_given_flcono=mod.given("flcono");
  int modelPar_flsh=mod.flsh;
  bool modelPar_given_flsh=mod.given("flsh");
  int modelPar_type=mod.type;
  bool modelPar_given_type=mod.given("type");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals


  // non-reals



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 15+0 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.


    //make local copies of all instance vars
    //reals
    AdmsSensFadType instanceVar_VT=in.VT;
    AdmsSensFadType instanceVar_Tdev=in.Tdev;
    AdmsSensFadType instanceVar_qtt0=in.qtt0;
    AdmsSensFadType instanceVar_ln_qtt0=in.ln_qtt0;
    AdmsSensFadType instanceVar_r_VgVT=in.r_VgVT;
    AdmsSensFadType instanceVar_V_gT=in.V_gT;
    AdmsSensFadType instanceVar_dT=in.dT;
    AdmsSensFadType instanceVar_k=in.k;
    AdmsSensFadType instanceVar_ireis_t=in.ireis_t;
    AdmsSensFadType instanceVar_ibeis_t=in.ibeis_t;
    AdmsSensFadType instanceVar_ibcxs_t=in.ibcxs_t;
    AdmsSensFadType instanceVar_ibcis_t=in.ibcis_t;
    AdmsSensFadType instanceVar_iscs_t=in.iscs_t;
    AdmsSensFadType instanceVar_cjci0_t=in.cjci0_t;
    AdmsSensFadType instanceVar_cjs0_t=in.cjs0_t;
    AdmsSensFadType instanceVar_cscp0_t=in.cscp0_t;
    AdmsSensFadType instanceVar_rci0_t=in.rci0_t;
    AdmsSensFadType instanceVar_vlim_t=in.vlim_t;
    AdmsSensFadType instanceVar_vces_t=in.vces_t;
    AdmsSensFadType instanceVar_thcs_t=in.thcs_t;
    AdmsSensFadType instanceVar_tef0_t=in.tef0_t;
    AdmsSensFadType instanceVar_rbi0_t=in.rbi0_t;
    AdmsSensFadType instanceVar_t0_t=in.t0_t;
    AdmsSensFadType instanceVar_vdei_t=in.vdei_t;
    AdmsSensFadType instanceVar_vdci_t=in.vdci_t;
    AdmsSensFadType instanceVar_vpts_t=in.vpts_t;
    AdmsSensFadType instanceVar_vptsp_t=in.vptsp_t;
    AdmsSensFadType instanceVar_itss_t=in.itss_t;
    AdmsSensFadType instanceVar_tsf_t=in.tsf_t;
    AdmsSensFadType instanceVar_c10_t=in.c10_t;
    AdmsSensFadType instanceVar_cjei0_t=in.cjei0_t;
    AdmsSensFadType instanceVar_qp0_t=in.qp0_t;
    AdmsSensFadType instanceVar_vdcx_t=in.vdcx_t;
    AdmsSensFadType instanceVar_vptcx_t=in.vptcx_t;
    AdmsSensFadType instanceVar_cjcx01_t=in.cjcx01_t;
    AdmsSensFadType instanceVar_cjcx02_t=in.cjcx02_t;
    AdmsSensFadType instanceVar_cratio_t=in.cratio_t;
    AdmsSensFadType instanceVar_ibeps_t=in.ibeps_t;
    AdmsSensFadType instanceVar_ireps_t=in.ireps_t;
    AdmsSensFadType instanceVar_cjep0_t=in.cjep0_t;
    AdmsSensFadType instanceVar_ajei_t=in.ajei_t;
    AdmsSensFadType instanceVar_qavl_t=in.qavl_t;
    AdmsSensFadType instanceVar_favl_t=in.favl_t;
    AdmsSensFadType instanceVar_kavl_t=in.kavl_t;
    AdmsSensFadType instanceVar_ibets_t=in.ibets_t;
    AdmsSensFadType instanceVar_abet_t=in.abet_t;
    AdmsSensFadType instanceVar_vptci_t=in.vptci_t;
    AdmsSensFadType instanceVar_vdep_t=in.vdep_t;
    AdmsSensFadType instanceVar_ajep_t=in.ajep_t;
    AdmsSensFadType instanceVar_zetatef=in.zetatef;
    AdmsSensFadType instanceVar_k1=in.k1;
    AdmsSensFadType instanceVar_k2=in.k2;
    AdmsSensFadType instanceVar_dvg0=in.dvg0;
    AdmsSensFadType instanceVar_vge_t=in.vge_t;
    AdmsSensFadType instanceVar_vgb_t=in.vgb_t;
    AdmsSensFadType instanceVar_vgbe_t=in.vgbe_t;
    AdmsSensFadType instanceVar_vds_t=in.vds_t;
    AdmsSensFadType instanceVar_vdsp_t=in.vdsp_t;
    AdmsSensFadType instanceVar_vt0=in.vt0;
    AdmsSensFadType instanceVar_Tnom=in.Tnom;
    AdmsSensFadType instanceVar_Tamb=in.Tamb;
    AdmsSensFadType instanceVar_a=in.a;
    AdmsSensFadType instanceVar_avs=in.avs;
    AdmsSensFadType instanceVar_zetabci=in.zetabci;
    AdmsSensFadType instanceVar_zetabcxt=in.zetabcxt;
    AdmsSensFadType instanceVar_zetasct=in.zetasct;
    AdmsSensFadType instanceVar_vgbe0=in.vgbe0;
    AdmsSensFadType instanceVar_mg=in.mg;
    AdmsSensFadType instanceVar_vgbe_t0=in.vgbe_t0;
    AdmsSensFadType instanceVar_vgbc0=in.vgbc0;
    AdmsSensFadType instanceVar_vgsc0=in.vgsc0;
    AdmsSensFadType instanceVar_cbcpar1=in.cbcpar1;
    AdmsSensFadType instanceVar_cbcpar2=in.cbcpar2;
    AdmsSensFadType instanceVar_cbepar2=in.cbepar2;
    AdmsSensFadType instanceVar_cbepar1=in.cbepar1;
    AdmsSensFadType instanceVar_Oich=in.Oich;
    AdmsSensFadType instanceVar_Otbhrec=in.Otbhrec;
    AdmsSensFadType instanceVar_it=in.it;
    AdmsSensFadType instanceVar_ibei=in.ibei;
    AdmsSensFadType instanceVar_ibci=in.ibci;
    AdmsSensFadType instanceVar_ibep=in.ibep;
    AdmsSensFadType instanceVar_iavl=in.iavl;
    AdmsSensFadType instanceVar_ijbcx=in.ijbcx;
    AdmsSensFadType instanceVar_ijsc=in.ijsc;
    AdmsSensFadType instanceVar_rth_t=in.rth_t;
    AdmsSensFadType instanceVar_vdj0=in.vdj0;
    AdmsSensFadType instanceVar_vdjt=in.vdjt;
    AdmsSensFadType instanceVar_vdt=in.vdt;
    AdmsSensFadType instanceVar_Tf=in.Tf;
    AdmsSensFadType instanceVar_cjcx01=in.cjcx01;
    AdmsSensFadType instanceVar_cjcx02=in.cjcx02;
    AdmsSensFadType instanceVar_betadc=in.betadc;
    AdmsSensFadType instanceVar_hjei0_t=in.hjei0_t;
    AdmsSensFadType instanceVar_ahjei_t=in.ahjei_t;
    AdmsSensFadType instanceVar_hf0_t=in.hf0_t;
    AdmsSensFadType instanceVar_hfe_t=in.hfe_t;
    AdmsSensFadType instanceVar_hfc_t=in.hfc_t;
    AdmsSensFadType instanceVar_rbx_t=in.rbx_t;
    AdmsSensFadType instanceVar_rcx_t=in.rcx_t;
    AdmsSensFadType instanceVar_re_t=in.re_t;
    AdmsSensFadType instanceVar_rbi=in.rbi;


    //non-reals
    int instanceVar_use_aval=in.use_aval;



    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_n2_GND] = (*solVectorPtr)[in.li_n2];
    probeVars[in.admsProbeID_V_n1_GND] = (*solVectorPtr)[in.li_n1];
    probeVars[in.admsProbeID_V_si_s] = (*solVectorPtr)[in.li_si] - (*solVectorPtr)[in.li_s];
    probeVars[in.admsProbeID_V_bp_e] = (*solVectorPtr)[in.li_bp] - (*solVectorPtr)[in.li_e];
    probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_e];
    probeVars[in.admsProbeID_V_ci_ei] = (*solVectorPtr)[in.li_ci] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_xf_GND] = (*solVectorPtr)[in.li_xf];
    probeVars[in.admsProbeID_V_xf2_GND] = (*solVectorPtr)[in.li_xf2];
    probeVars[in.admsProbeID_V_xf1_GND] = (*solVectorPtr)[in.li_xf1];
    probeVars[in.admsProbeID_V_b_bp] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_bp];
    probeVars[in.admsProbeID_V_ci_c] = (*solVectorPtr)[in.li_ci] - (*solVectorPtr)[in.li_c];
    probeVars[in.admsProbeID_V_ei_e] = (*solVectorPtr)[in.li_ei] - (*solVectorPtr)[in.li_e];
    probeVars[in.admsProbeID_V_bp_bi] = (*solVectorPtr)[in.li_bp] - (*solVectorPtr)[in.li_bi];
    probeVars[in.admsProbeID_V_tnode_GND] = (*solVectorPtr)[in.li_tnode];
    probeVars[in.admsProbeID_V_s_c] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_c];
    probeVars[in.admsProbeID_V_si_ci] = (*solVectorPtr)[in.li_si] - (*solVectorPtr)[in.li_ci];
    probeVars[in.admsProbeID_V_b_ci] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_ci];
    probeVars[in.admsProbeID_V_bp_ci] = (*solVectorPtr)[in.li_bp] - (*solVectorPtr)[in.li_ci];
    probeVars[in.admsProbeID_V_bp_ei] = (*solVectorPtr)[in.li_bp] - (*solVectorPtr)[in.li_ei];
    probeVars[in.admsProbeID_V_bi_ci] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_ci];
    probeVars[in.admsProbeID_V_bi_ei] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_ei];


    evaluateInitialInstance(
       // instance variables
       // reals
       instanceVar_VT,
       instanceVar_Tdev,
       instanceVar_qtt0,
       instanceVar_ln_qtt0,
       instanceVar_r_VgVT,
       instanceVar_V_gT,
       instanceVar_dT,
       instanceVar_k,
       instanceVar_ireis_t,
       instanceVar_ibeis_t,
       instanceVar_ibcxs_t,
       instanceVar_ibcis_t,
       instanceVar_iscs_t,
       instanceVar_cjci0_t,
       instanceVar_cjs0_t,
       instanceVar_cscp0_t,
       instanceVar_rci0_t,
       instanceVar_vlim_t,
       instanceVar_vces_t,
       instanceVar_thcs_t,
       instanceVar_tef0_t,
       instanceVar_rbi0_t,
       instanceVar_t0_t,
       instanceVar_vdei_t,
       instanceVar_vdci_t,
       instanceVar_vpts_t,
       instanceVar_vptsp_t,
       instanceVar_itss_t,
       instanceVar_tsf_t,
       instanceVar_c10_t,
       instanceVar_cjei0_t,
       instanceVar_qp0_t,
       instanceVar_vdcx_t,
       instanceVar_vptcx_t,
       instanceVar_cjcx01_t,
       instanceVar_cjcx02_t,
       instanceVar_cratio_t,
       instanceVar_ibeps_t,
       instanceVar_ireps_t,
       instanceVar_cjep0_t,
       instanceVar_ajei_t,
       instanceVar_qavl_t,
       instanceVar_favl_t,
       instanceVar_kavl_t,
       instanceVar_ibets_t,
       instanceVar_abet_t,
       instanceVar_vptci_t,
       instanceVar_vdep_t,
       instanceVar_ajep_t,
       instanceVar_zetatef,
       instanceVar_k1,
       instanceVar_k2,
       instanceVar_dvg0,
       instanceVar_vge_t,
       instanceVar_vgb_t,
       instanceVar_vgbe_t,
       instanceVar_vds_t,
       instanceVar_vdsp_t,
       instanceVar_vt0,
       instanceVar_Tnom,
       instanceVar_Tamb,
       instanceVar_a,
       instanceVar_avs,
       instanceVar_zetabci,
       instanceVar_zetabcxt,
       instanceVar_zetasct,
       instanceVar_vgbe0,
       instanceVar_mg,
       instanceVar_vgbe_t0,
       instanceVar_vgbc0,
       instanceVar_vgsc0,
       instanceVar_cbcpar1,
       instanceVar_cbcpar2,
       instanceVar_cbepar2,
       instanceVar_cbepar1,
       instanceVar_Oich,
       instanceVar_Otbhrec,
       instanceVar_it,
       instanceVar_ibei,
       instanceVar_ibci,
       instanceVar_ibep,
       instanceVar_iavl,
       instanceVar_ijbcx,
       instanceVar_ijsc,
       instanceVar_rth_t,
       instanceVar_vdj0,
       instanceVar_vdjt,
       instanceVar_vdt,
       instanceVar_Tf,
       instanceVar_cjcx01,
       instanceVar_cjcx02,
       instanceVar_betadc,
       instanceVar_hjei0_t,
       instanceVar_ahjei_t,
       instanceVar_hf0_t,
       instanceVar_hfe_t,
       instanceVar_hfc_t,
       instanceVar_rbx_t,
       instanceVar_rcx_t,
       instanceVar_re_t,
       instanceVar_rbi,
       // non-reals
       instanceVar_use_aval,
       // model parameters
       // reals
       modelPar_c10,
       modelPar_given_c10,
       modelPar_qp0,
       modelPar_given_qp0,
       modelPar_ich,
       modelPar_given_ich,
       modelPar_hf0,
       modelPar_given_hf0,
       modelPar_hfe,
       modelPar_given_hfe,
       modelPar_hfc,
       modelPar_given_hfc,
       modelPar_hjei,
       modelPar_given_hjei,
       modelPar_ahjei,
       modelPar_given_ahjei,
       modelPar_rhjei,
       modelPar_given_rhjei,
       modelPar_hjci,
       modelPar_given_hjci,
       modelPar_ibeis,
       modelPar_given_ibeis,
       modelPar_mbei,
       modelPar_given_mbei,
       modelPar_ireis,
       modelPar_given_ireis,
       modelPar_mrei,
       modelPar_given_mrei,
       modelPar_ibeps,
       modelPar_given_ibeps,
       modelPar_mbep,
       modelPar_given_mbep,
       modelPar_ireps,
       modelPar_given_ireps,
       modelPar_mrep,
       modelPar_given_mrep,
       modelPar_mcf,
       modelPar_given_mcf,
       modelPar_tbhrec,
       modelPar_given_tbhrec,
       modelPar_ibcis,
       modelPar_given_ibcis,
       modelPar_mbci,
       modelPar_given_mbci,
       modelPar_ibcxs,
       modelPar_given_ibcxs,
       modelPar_mbcx,
       modelPar_given_mbcx,
       modelPar_ibets,
       modelPar_given_ibets,
       modelPar_abet,
       modelPar_given_abet,
       modelPar_favl,
       modelPar_given_favl,
       modelPar_qavl,
       modelPar_given_qavl,
       modelPar_kavl,
       modelPar_given_kavl,
       modelPar_alfav,
       modelPar_given_alfav,
       modelPar_alqav,
       modelPar_given_alqav,
       modelPar_alkav,
       modelPar_given_alkav,
       modelPar_rbi0,
       modelPar_given_rbi0,
       modelPar_rbx,
       modelPar_given_rbx,
       modelPar_fgeo,
       modelPar_given_fgeo,
       modelPar_fdqr0,
       modelPar_given_fdqr0,
       modelPar_fcrbi,
       modelPar_given_fcrbi,
       modelPar_fqi,
       modelPar_given_fqi,
       modelPar_re,
       modelPar_given_re,
       modelPar_rcx,
       modelPar_given_rcx,
       modelPar_itss,
       modelPar_given_itss,
       modelPar_msf,
       modelPar_given_msf,
       modelPar_iscs,
       modelPar_given_iscs,
       modelPar_msc,
       modelPar_given_msc,
       modelPar_tsf,
       modelPar_given_tsf,
       modelPar_rsu,
       modelPar_given_rsu,
       modelPar_csu,
       modelPar_given_csu,
       modelPar_cjei0,
       modelPar_given_cjei0,
       modelPar_vdei,
       modelPar_given_vdei,
       modelPar_zei,
       modelPar_given_zei,
       modelPar_ajei,
       modelPar_given_ajei,
       modelPar_cjep0,
       modelPar_given_cjep0,
       modelPar_vdep,
       modelPar_given_vdep,
       modelPar_zep,
       modelPar_given_zep,
       modelPar_ajep,
       modelPar_given_ajep,
       modelPar_cjci0,
       modelPar_given_cjci0,
       modelPar_vdci,
       modelPar_given_vdci,
       modelPar_zci,
       modelPar_given_zci,
       modelPar_vptci,
       modelPar_given_vptci,
       modelPar_cjcx0,
       modelPar_given_cjcx0,
       modelPar_vdcx,
       modelPar_given_vdcx,
       modelPar_zcx,
       modelPar_given_zcx,
       modelPar_vptcx,
       modelPar_given_vptcx,
       modelPar_fbcpar,
       modelPar_given_fbcpar,
       modelPar_fbepar,
       modelPar_given_fbepar,
       modelPar_cjs0,
       modelPar_given_cjs0,
       modelPar_vds,
       modelPar_given_vds,
       modelPar_zs,
       modelPar_given_zs,
       modelPar_vpts,
       modelPar_given_vpts,
       modelPar_cscp0,
       modelPar_given_cscp0,
       modelPar_vdsp,
       modelPar_given_vdsp,
       modelPar_zsp,
       modelPar_given_zsp,
       modelPar_vptsp,
       modelPar_given_vptsp,
       modelPar_t0,
       modelPar_given_t0,
       modelPar_dt0h,
       modelPar_given_dt0h,
       modelPar_tbvl,
       modelPar_given_tbvl,
       modelPar_tef0,
       modelPar_given_tef0,
       modelPar_gtfe,
       modelPar_given_gtfe,
       modelPar_thcs,
       modelPar_given_thcs,
       modelPar_ahc,
       modelPar_given_ahc,
       modelPar_fthc,
       modelPar_given_fthc,
       modelPar_rci0,
       modelPar_given_rci0,
       modelPar_vlim,
       modelPar_given_vlim,
       modelPar_vces,
       modelPar_given_vces,
       modelPar_vpt,
       modelPar_given_vpt,
       modelPar_aick,
       modelPar_given_aick,
       modelPar_delck,
       modelPar_given_delck,
       modelPar_tr,
       modelPar_given_tr,
       modelPar_vcbar,
       modelPar_given_vcbar,
       modelPar_icbar,
       modelPar_given_icbar,
       modelPar_acbar,
       modelPar_given_acbar,
       modelPar_cbepar,
       modelPar_given_cbepar,
       modelPar_cbcpar,
       modelPar_given_cbcpar,
       modelPar_alqf,
       modelPar_given_alqf,
       modelPar_alit,
       modelPar_given_alit,
       modelPar_kf,
       modelPar_given_kf,
       modelPar_af,
       modelPar_given_af,
       modelPar_kfre,
       modelPar_given_kfre,
       modelPar_afre,
       modelPar_given_afre,
       modelPar_latb,
       modelPar_given_latb,
       modelPar_latl,
       modelPar_given_latl,
       modelPar_vgb,
       modelPar_given_vgb,
       modelPar_alt0,
       modelPar_given_alt0,
       modelPar_kt0,
       modelPar_given_kt0,
       modelPar_zetaci,
       modelPar_given_zetaci,
       modelPar_alvs,
       modelPar_given_alvs,
       modelPar_alces,
       modelPar_given_alces,
       modelPar_zetarbi,
       modelPar_given_zetarbi,
       modelPar_zetarbx,
       modelPar_given_zetarbx,
       modelPar_zetarcx,
       modelPar_given_zetarcx,
       modelPar_zetare,
       modelPar_given_zetare,
       modelPar_zetacx,
       modelPar_given_zetacx,
       modelPar_vge,
       modelPar_given_vge,
       modelPar_vgc,
       modelPar_given_vgc,
       modelPar_vgs,
       modelPar_given_vgs,
       modelPar_f1vg,
       modelPar_given_f1vg,
       modelPar_f2vg,
       modelPar_given_f2vg,
       modelPar_zetact,
       modelPar_given_zetact,
       modelPar_zetabet,
       modelPar_given_zetabet,
       modelPar_alb,
       modelPar_given_alb,
       modelPar_dvgbe,
       modelPar_given_dvgbe,
       modelPar_zetahjei,
       modelPar_given_zetahjei,
       modelPar_zetavgbe,
       modelPar_given_zetavgbe,
       modelPar_rth,
       modelPar_given_rth,
       modelPar_zetarth,
       modelPar_given_zetarth,
       modelPar_alrth,
       modelPar_given_alrth,
       modelPar_cth,
       modelPar_given_cth,
       modelPar_flcomp,
       modelPar_given_flcomp,
       modelPar_tnom,
       modelPar_given_tnom,
       modelPar_dt,
       modelPar_given_dt,
       // non-reals (including hidden)
       modelPar_tunode,
       modelPar_given_tunode,
       modelPar_flnqs,
       modelPar_given_flnqs,
       modelPar_cfbe,
       modelPar_given_cfbe,
       modelPar_flcono,
       modelPar_given_flcono,
       modelPar_flsh,
       modelPar_given_flsh,
       modelPar_type,
       modelPar_given_type,
       in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_n2_GND,
       in.admsProbeID_V_n1_GND,
       in.admsProbeID_V_si_s,
       in.admsProbeID_V_bp_e,
       in.admsProbeID_V_b_e,
       in.admsProbeID_V_ci_ei,
       in.admsProbeID_V_xf_GND,
       in.admsProbeID_V_xf2_GND,
       in.admsProbeID_V_xf1_GND,
       in.admsProbeID_V_b_bp,
       in.admsProbeID_V_ci_c,
       in.admsProbeID_V_ei_e,
       in.admsProbeID_V_bp_bi,
       in.admsProbeID_V_tnode_GND,
       in.admsProbeID_V_s_c,
       in.admsProbeID_V_si_ci,
       in.admsProbeID_V_b_ci,
       in.admsProbeID_V_bp_ci,
       in.admsProbeID_V_bp_ei,
       in.admsProbeID_V_bi_ci,
       in.admsProbeID_V_bi_ei,

       // node constants
       in.admsNodeID_c,
       in.admsNodeID_b,
       in.admsNodeID_e,
       in.admsNodeID_s,
       in.admsNodeID_tnode,
       in.admsNodeID_ci,
       in.admsNodeID_ei,
       in.admsNodeID_bp,
       in.admsNodeID_bi,
       in.admsNodeID_si,
       in.admsNodeID_xf1,
       in.admsNodeID_xf2,
       in.admsNodeID_xf,
       in.admsNodeID_n1,
       in.admsNodeID_n2,
       // instance variables
       // reals
       instanceVar_VT,
       instanceVar_Tdev,
       instanceVar_qtt0,
       instanceVar_ln_qtt0,
       instanceVar_r_VgVT,
       instanceVar_V_gT,
       instanceVar_dT,
       instanceVar_k,
       instanceVar_ireis_t,
       instanceVar_ibeis_t,
       instanceVar_ibcxs_t,
       instanceVar_ibcis_t,
       instanceVar_iscs_t,
       instanceVar_cjci0_t,
       instanceVar_cjs0_t,
       instanceVar_cscp0_t,
       instanceVar_rci0_t,
       instanceVar_vlim_t,
       instanceVar_vces_t,
       instanceVar_thcs_t,
       instanceVar_tef0_t,
       instanceVar_rbi0_t,
       instanceVar_t0_t,
       instanceVar_vdei_t,
       instanceVar_vdci_t,
       instanceVar_vpts_t,
       instanceVar_vptsp_t,
       instanceVar_itss_t,
       instanceVar_tsf_t,
       instanceVar_c10_t,
       instanceVar_cjei0_t,
       instanceVar_qp0_t,
       instanceVar_vdcx_t,
       instanceVar_vptcx_t,
       instanceVar_cjcx01_t,
       instanceVar_cjcx02_t,
       instanceVar_cratio_t,
       instanceVar_ibeps_t,
       instanceVar_ireps_t,
       instanceVar_cjep0_t,
       instanceVar_ajei_t,
       instanceVar_qavl_t,
       instanceVar_favl_t,
       instanceVar_kavl_t,
       instanceVar_ibets_t,
       instanceVar_abet_t,
       instanceVar_vptci_t,
       instanceVar_vdep_t,
       instanceVar_ajep_t,
       instanceVar_zetatef,
       instanceVar_k1,
       instanceVar_k2,
       instanceVar_dvg0,
       instanceVar_vge_t,
       instanceVar_vgb_t,
       instanceVar_vgbe_t,
       instanceVar_vds_t,
       instanceVar_vdsp_t,
       instanceVar_vt0,
       instanceVar_Tnom,
       instanceVar_Tamb,
       instanceVar_a,
       instanceVar_avs,
       instanceVar_zetabci,
       instanceVar_zetabcxt,
       instanceVar_zetasct,
       instanceVar_vgbe0,
       instanceVar_mg,
       instanceVar_vgbe_t0,
       instanceVar_vgbc0,
       instanceVar_vgsc0,
       instanceVar_cbcpar1,
       instanceVar_cbcpar2,
       instanceVar_cbepar2,
       instanceVar_cbepar1,
       instanceVar_Oich,
       instanceVar_Otbhrec,
       instanceVar_it,
       instanceVar_ibei,
       instanceVar_ibci,
       instanceVar_ibep,
       instanceVar_iavl,
       instanceVar_ijbcx,
       instanceVar_ijsc,
       instanceVar_rth_t,
       instanceVar_vdj0,
       instanceVar_vdjt,
       instanceVar_vdt,
       instanceVar_Tf,
       instanceVar_cjcx01,
       instanceVar_cjcx02,
       instanceVar_betadc,
       instanceVar_hjei0_t,
       instanceVar_ahjei_t,
       instanceVar_hf0_t,
       instanceVar_hfe_t,
       instanceVar_hfc_t,
       instanceVar_rbx_t,
       instanceVar_rcx_t,
       instanceVar_re_t,
       instanceVar_rbi,
       // non-reals
       instanceVar_use_aval,
       // model parameters
       // reals
       modelPar_c10,
       modelPar_given_c10,
       modelPar_qp0,
       modelPar_given_qp0,
       modelPar_ich,
       modelPar_given_ich,
       modelPar_hf0,
       modelPar_given_hf0,
       modelPar_hfe,
       modelPar_given_hfe,
       modelPar_hfc,
       modelPar_given_hfc,
       modelPar_hjei,
       modelPar_given_hjei,
       modelPar_ahjei,
       modelPar_given_ahjei,
       modelPar_rhjei,
       modelPar_given_rhjei,
       modelPar_hjci,
       modelPar_given_hjci,
       modelPar_ibeis,
       modelPar_given_ibeis,
       modelPar_mbei,
       modelPar_given_mbei,
       modelPar_ireis,
       modelPar_given_ireis,
       modelPar_mrei,
       modelPar_given_mrei,
       modelPar_ibeps,
       modelPar_given_ibeps,
       modelPar_mbep,
       modelPar_given_mbep,
       modelPar_ireps,
       modelPar_given_ireps,
       modelPar_mrep,
       modelPar_given_mrep,
       modelPar_mcf,
       modelPar_given_mcf,
       modelPar_tbhrec,
       modelPar_given_tbhrec,
       modelPar_ibcis,
       modelPar_given_ibcis,
       modelPar_mbci,
       modelPar_given_mbci,
       modelPar_ibcxs,
       modelPar_given_ibcxs,
       modelPar_mbcx,
       modelPar_given_mbcx,
       modelPar_ibets,
       modelPar_given_ibets,
       modelPar_abet,
       modelPar_given_abet,
       modelPar_favl,
       modelPar_given_favl,
       modelPar_qavl,
       modelPar_given_qavl,
       modelPar_kavl,
       modelPar_given_kavl,
       modelPar_alfav,
       modelPar_given_alfav,
       modelPar_alqav,
       modelPar_given_alqav,
       modelPar_alkav,
       modelPar_given_alkav,
       modelPar_rbi0,
       modelPar_given_rbi0,
       modelPar_rbx,
       modelPar_given_rbx,
       modelPar_fgeo,
       modelPar_given_fgeo,
       modelPar_fdqr0,
       modelPar_given_fdqr0,
       modelPar_fcrbi,
       modelPar_given_fcrbi,
       modelPar_fqi,
       modelPar_given_fqi,
       modelPar_re,
       modelPar_given_re,
       modelPar_rcx,
       modelPar_given_rcx,
       modelPar_itss,
       modelPar_given_itss,
       modelPar_msf,
       modelPar_given_msf,
       modelPar_iscs,
       modelPar_given_iscs,
       modelPar_msc,
       modelPar_given_msc,
       modelPar_tsf,
       modelPar_given_tsf,
       modelPar_rsu,
       modelPar_given_rsu,
       modelPar_csu,
       modelPar_given_csu,
       modelPar_cjei0,
       modelPar_given_cjei0,
       modelPar_vdei,
       modelPar_given_vdei,
       modelPar_zei,
       modelPar_given_zei,
       modelPar_ajei,
       modelPar_given_ajei,
       modelPar_cjep0,
       modelPar_given_cjep0,
       modelPar_vdep,
       modelPar_given_vdep,
       modelPar_zep,
       modelPar_given_zep,
       modelPar_ajep,
       modelPar_given_ajep,
       modelPar_cjci0,
       modelPar_given_cjci0,
       modelPar_vdci,
       modelPar_given_vdci,
       modelPar_zci,
       modelPar_given_zci,
       modelPar_vptci,
       modelPar_given_vptci,
       modelPar_cjcx0,
       modelPar_given_cjcx0,
       modelPar_vdcx,
       modelPar_given_vdcx,
       modelPar_zcx,
       modelPar_given_zcx,
       modelPar_vptcx,
       modelPar_given_vptcx,
       modelPar_fbcpar,
       modelPar_given_fbcpar,
       modelPar_fbepar,
       modelPar_given_fbepar,
       modelPar_cjs0,
       modelPar_given_cjs0,
       modelPar_vds,
       modelPar_given_vds,
       modelPar_zs,
       modelPar_given_zs,
       modelPar_vpts,
       modelPar_given_vpts,
       modelPar_cscp0,
       modelPar_given_cscp0,
       modelPar_vdsp,
       modelPar_given_vdsp,
       modelPar_zsp,
       modelPar_given_zsp,
       modelPar_vptsp,
       modelPar_given_vptsp,
       modelPar_t0,
       modelPar_given_t0,
       modelPar_dt0h,
       modelPar_given_dt0h,
       modelPar_tbvl,
       modelPar_given_tbvl,
       modelPar_tef0,
       modelPar_given_tef0,
       modelPar_gtfe,
       modelPar_given_gtfe,
       modelPar_thcs,
       modelPar_given_thcs,
       modelPar_ahc,
       modelPar_given_ahc,
       modelPar_fthc,
       modelPar_given_fthc,
       modelPar_rci0,
       modelPar_given_rci0,
       modelPar_vlim,
       modelPar_given_vlim,
       modelPar_vces,
       modelPar_given_vces,
       modelPar_vpt,
       modelPar_given_vpt,
       modelPar_aick,
       modelPar_given_aick,
       modelPar_delck,
       modelPar_given_delck,
       modelPar_tr,
       modelPar_given_tr,
       modelPar_vcbar,
       modelPar_given_vcbar,
       modelPar_icbar,
       modelPar_given_icbar,
       modelPar_acbar,
       modelPar_given_acbar,
       modelPar_cbepar,
       modelPar_given_cbepar,
       modelPar_cbcpar,
       modelPar_given_cbcpar,
       modelPar_alqf,
       modelPar_given_alqf,
       modelPar_alit,
       modelPar_given_alit,
       modelPar_kf,
       modelPar_given_kf,
       modelPar_af,
       modelPar_given_af,
       modelPar_kfre,
       modelPar_given_kfre,
       modelPar_afre,
       modelPar_given_afre,
       modelPar_latb,
       modelPar_given_latb,
       modelPar_latl,
       modelPar_given_latl,
       modelPar_vgb,
       modelPar_given_vgb,
       modelPar_alt0,
       modelPar_given_alt0,
       modelPar_kt0,
       modelPar_given_kt0,
       modelPar_zetaci,
       modelPar_given_zetaci,
       modelPar_alvs,
       modelPar_given_alvs,
       modelPar_alces,
       modelPar_given_alces,
       modelPar_zetarbi,
       modelPar_given_zetarbi,
       modelPar_zetarbx,
       modelPar_given_zetarbx,
       modelPar_zetarcx,
       modelPar_given_zetarcx,
       modelPar_zetare,
       modelPar_given_zetare,
       modelPar_zetacx,
       modelPar_given_zetacx,
       modelPar_vge,
       modelPar_given_vge,
       modelPar_vgc,
       modelPar_given_vgc,
       modelPar_vgs,
       modelPar_given_vgs,
       modelPar_f1vg,
       modelPar_given_f1vg,
       modelPar_f2vg,
       modelPar_given_f2vg,
       modelPar_zetact,
       modelPar_given_zetact,
       modelPar_zetabet,
       modelPar_given_zetabet,
       modelPar_alb,
       modelPar_given_alb,
       modelPar_dvgbe,
       modelPar_given_dvgbe,
       modelPar_zetahjei,
       modelPar_given_zetahjei,
       modelPar_zetavgbe,
       modelPar_given_zetavgbe,
       modelPar_rth,
       modelPar_given_rth,
       modelPar_zetarth,
       modelPar_given_zetarth,
       modelPar_alrth,
       modelPar_given_alrth,
       modelPar_cth,
       modelPar_given_cth,
       modelPar_flcomp,
       modelPar_given_flcomp,
       modelPar_tnom,
       modelPar_given_tnom,
       modelPar_dt,
       modelPar_given_dt,
       // non-reals (including hidden)
       modelPar_tunode,
       modelPar_given_tunode,
       modelPar_flnqs,
       modelPar_given_flnqs,
       modelPar_cfbe,
       modelPar_given_cfbe,
       modelPar_flcono,
       modelPar_given_flcono,
       modelPar_flsh,
       modelPar_given_flsh,
       modelPar_type,
       modelPar_given_type,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);


    // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_c+inst*(15+0)] += staticContributions[in.admsNodeID_c].dx(0);
    dqdp[in.admsNodeID_c+inst*(15+0)] += dynamicContributions[in.admsNodeID_c].dx(0);
    Findices[in.admsNodeID_c+inst*(15+0)] = in.li_c;
    Qindices[in.admsNodeID_c+inst*(15+0)] = in.li_c;
    dfdp[in.admsNodeID_b+inst*(15+0)] += staticContributions[in.admsNodeID_b].dx(0);
    dqdp[in.admsNodeID_b+inst*(15+0)] += dynamicContributions[in.admsNodeID_b].dx(0);
    Findices[in.admsNodeID_b+inst*(15+0)] = in.li_b;
    Qindices[in.admsNodeID_b+inst*(15+0)] = in.li_b;
    dfdp[in.admsNodeID_e+inst*(15+0)] += staticContributions[in.admsNodeID_e].dx(0);
    dqdp[in.admsNodeID_e+inst*(15+0)] += dynamicContributions[in.admsNodeID_e].dx(0);
    Findices[in.admsNodeID_e+inst*(15+0)] = in.li_e;
    Qindices[in.admsNodeID_e+inst*(15+0)] = in.li_e;
    dfdp[in.admsNodeID_s+inst*(15+0)] += staticContributions[in.admsNodeID_s].dx(0);
    dqdp[in.admsNodeID_s+inst*(15+0)] += dynamicContributions[in.admsNodeID_s].dx(0);
    Findices[in.admsNodeID_s+inst*(15+0)] = in.li_s;
    Qindices[in.admsNodeID_s+inst*(15+0)] = in.li_s;
    dfdp[in.admsNodeID_tnode+inst*(15+0)] += staticContributions[in.admsNodeID_tnode].dx(0);
    dqdp[in.admsNodeID_tnode+inst*(15+0)] += dynamicContributions[in.admsNodeID_tnode].dx(0);
    Findices[in.admsNodeID_tnode+inst*(15+0)] = in.li_tnode;
    Qindices[in.admsNodeID_tnode+inst*(15+0)] = in.li_tnode;
    dfdp[in.admsNodeID_ci+inst*(15+0)] += staticContributions[in.admsNodeID_ci].dx(0);
    dqdp[in.admsNodeID_ci+inst*(15+0)] += dynamicContributions[in.admsNodeID_ci].dx(0);
    Findices[in.admsNodeID_ci+inst*(15+0)] = in.li_ci;
    Qindices[in.admsNodeID_ci+inst*(15+0)] = in.li_ci;
    dfdp[in.admsNodeID_ei+inst*(15+0)] += staticContributions[in.admsNodeID_ei].dx(0);
    dqdp[in.admsNodeID_ei+inst*(15+0)] += dynamicContributions[in.admsNodeID_ei].dx(0);
    Findices[in.admsNodeID_ei+inst*(15+0)] = in.li_ei;
    Qindices[in.admsNodeID_ei+inst*(15+0)] = in.li_ei;
    dfdp[in.admsNodeID_bp+inst*(15+0)] += staticContributions[in.admsNodeID_bp].dx(0);
    dqdp[in.admsNodeID_bp+inst*(15+0)] += dynamicContributions[in.admsNodeID_bp].dx(0);
    Findices[in.admsNodeID_bp+inst*(15+0)] = in.li_bp;
    Qindices[in.admsNodeID_bp+inst*(15+0)] = in.li_bp;
    dfdp[in.admsNodeID_bi+inst*(15+0)] += staticContributions[in.admsNodeID_bi].dx(0);
    dqdp[in.admsNodeID_bi+inst*(15+0)] += dynamicContributions[in.admsNodeID_bi].dx(0);
    Findices[in.admsNodeID_bi+inst*(15+0)] = in.li_bi;
    Qindices[in.admsNodeID_bi+inst*(15+0)] = in.li_bi;
    dfdp[in.admsNodeID_si+inst*(15+0)] += staticContributions[in.admsNodeID_si].dx(0);
    dqdp[in.admsNodeID_si+inst*(15+0)] += dynamicContributions[in.admsNodeID_si].dx(0);
    Findices[in.admsNodeID_si+inst*(15+0)] = in.li_si;
    Qindices[in.admsNodeID_si+inst*(15+0)] = in.li_si;
    dfdp[in.admsNodeID_xf1+inst*(15+0)] += staticContributions[in.admsNodeID_xf1].dx(0);
    dqdp[in.admsNodeID_xf1+inst*(15+0)] += dynamicContributions[in.admsNodeID_xf1].dx(0);
    Findices[in.admsNodeID_xf1+inst*(15+0)] = in.li_xf1;
    Qindices[in.admsNodeID_xf1+inst*(15+0)] = in.li_xf1;
    dfdp[in.admsNodeID_xf2+inst*(15+0)] += staticContributions[in.admsNodeID_xf2].dx(0);
    dqdp[in.admsNodeID_xf2+inst*(15+0)] += dynamicContributions[in.admsNodeID_xf2].dx(0);
    Findices[in.admsNodeID_xf2+inst*(15+0)] = in.li_xf2;
    Qindices[in.admsNodeID_xf2+inst*(15+0)] = in.li_xf2;
    dfdp[in.admsNodeID_xf+inst*(15+0)] += staticContributions[in.admsNodeID_xf].dx(0);
    dqdp[in.admsNodeID_xf+inst*(15+0)] += dynamicContributions[in.admsNodeID_xf].dx(0);
    Findices[in.admsNodeID_xf+inst*(15+0)] = in.li_xf;
    Qindices[in.admsNodeID_xf+inst*(15+0)] = in.li_xf;
    dfdp[in.admsNodeID_n1+inst*(15+0)] += staticContributions[in.admsNodeID_n1].dx(0);
    dqdp[in.admsNodeID_n1+inst*(15+0)] += dynamicContributions[in.admsNodeID_n1].dx(0);
    Findices[in.admsNodeID_n1+inst*(15+0)] = in.li_n1;
    Qindices[in.admsNodeID_n1+inst*(15+0)] = in.li_n1;
    dfdp[in.admsNodeID_n2+inst*(15+0)] += staticContributions[in.admsNodeID_n2].dx(0);
    dqdp[in.admsNodeID_n2+inst*(15+0)] += dynamicContributions[in.admsNodeID_n2].dx(0);
    Findices[in.admsNodeID_n2+inst*(15+0)] = in.li_n2;
    Qindices[in.admsNodeID_n2+inst*(15+0)] = in.li_n2;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMShicumL2va
} // namespace Device
} // namespace Xyce
